!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE DEGRADE( CBLK, DT, JDATE, JTIME )

C**********************************************************************
C
C Function: Calculate changes in gas species based on a exponential decay.
C           The decay rate sums losses from processes in DEGRADE_DATA.
C
C CALLED BY: HRSOLVER
C
C WARNING: THIS ROUTINE ASSUMES SIMPLE AND LINEAR TRANSFORMATIONS FROM
C          ATMOSPHERIC CHEMISTRY.
C
C Species being degraded are governed by the equation,
C     dx/dt = -b*x, where b is the sum of N loss rates
C
C IT DOES NOT SOLVE A SYSTEM OF ODE's AS IN SMVGEAR, ROS3, and EBI SOLVERS.
C
C  REVISION HISTORY:  07/29/05 : B.Hutzell - Initial version
C                     09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                                optional degraded species i.e., RXTANT_MAP( I )
C                                is less than zero
C**********************************************************************

      USE RXNS_DATA
      USE DEGRADE_SETUP_TOX

      IMPLICIT NONE

C.....ARGUMENTS:

      REAL( 8 ), INTENT( IN ) :: CBLK( : )      ! array holding species concentrations
      REAL( 8 ), INTENT( IN ) :: DT             ! time step for integrations [sec]
      INTEGER,   INTENT( IN ) :: JDATE          ! current model date , coded YYYYDDD
      INTEGER,   INTENT( IN ) :: JTIME          ! current model time , coded HHMMSS

C.....PARAMETERS:

      CHARACTER(16), PARAMETER :: PNAME  = ' DEGRADE    '  ! name of routine calling I/OAPI

      INTEGER, PARAMETER :: LOCAL_DT = 3     ! minimum time step, mili-seconds

      REAL(8), PARAMETER :: CONMIN = 1.0D-30 ! concentration lower limit

C.....LOCAL VARIABLES:

      CHARACTER(16)  ::  VNAME                    ! variable name
      CHARACTER(120) ::  XMSG

      INTEGER        :: TIME_SECONDS                ! TIME, sec
      INTEGER        :: I_RXT, I_RAD, J_RAD, I_PROD ! indices
      INTEGER        :: I, J, K, L                  ! loop counters
      INTEGER, SAVE  :: I_SIZE                      ! scratch

      LOGICAL, SAVE  :: FIRSTCALL  = .TRUE.

      REAL(8)        :: TRANS                    ! molecules/cm^3 transferred to products
      REAL(8)        :: LOSS_RATE( N_PROCESSES ) ! individual loss rates  [sec^-1]
      REAL(8)        :: NET_RATE                 ! net rate of transfer   [sec^-1]
      REAL(8)        :: NET_LIFE                 ! lifetime based on net transfer rate  [sec]
      REAL(8)        :: TSTEP                    ! degradation time step, sec

C**********************************************************************

      IF ( FIRSTCALL ) THEN  ! initialize maps
         I_SIZE = SIZE( CBLK )
         FIRSTCALL = .FALSE.
      ENDIF

C..Update concentrations except degraded species

      LOOP_NEW: DO I = 1, I_SIZE
         DO J = 1, N_REACT
            IF( RXTANT_MAP( J ) .EQ. I )THEN
                CYCLE LOOP_NEW
            END IF
         ENDDO
         CURR_CONC( I ) = CBLK( I ) 
      ENDDO LOOP_NEW
      
      DELT_CONC = 0.0D0

C..Quality Control on time step

      TSTEP = DT
      BLOCK_A : IF ( TSTEP < 0.0D0 ) THEN
         XMSG = ' Time step has negative value. '
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      ENDIF BLOCK_A

C..Loop over each reactant

      LOOP_REACT: DO I = 1, N_REACT
      

         LOSS_RATE = 0.0D0
         NET_RATE  = 0.0D0
         NET_LIFE  = 0.0D0

         I_RXT = RXTANT_MAP( I )
         IF( I_RXT < 0 )CYCLE LOOP_REACT
         

         IF( CURR_CONC( I_RXT ) <= CONMIN )CYCLE LOOP_REACT

         LOOP_UNIRATE: DO J = UNI_START, UNI_STOP
             LOSS_RATE( J ) = RATE_CONST( I, J )
         ENDDO LOOP_UNIRATE

         L = 0

         LOOP_BIRATE: DO J = BI_START, BI_STOP
            L = L + 1
            I_RAD = RAD_MAP( I, L )
            IF ( I_RAD < 1 ) CYCLE   ! radical species is undefined
            IF ( I_RAD > 900 ) THEN
               LOSS_RATE( J ) = RATE_CONST( I, J )
     &                        * NUMB_DENS
            ELSE
               LOSS_RATE( J ) = 0.5D0 * RATE_CONST( I, J )
     &                        * ( PREV_CONC( I_RAD ) + CURR_CONC( I_RAD ) )
            ENDIF
         ENDDO LOOP_BIRATE

         L = 0

         LOOP_TRIRATE: DO J = TRI_START, TRI_STOP
            L = L + 1
            I_RAD = RAD2_MAP( I, L, 1 )
            J_RAD = RAD2_MAP( I, L, 2 )
            IF ( I_RAD < 1 .OR. J_RAD < 1 ) CYCLE   ! radical species are undefined
            LOSS_RATE( J ) = 0.5D0 * RATE_CONST( I, J )
     &                     * ( PREV_CONC( I_RAD ) * PREV_CONC( J_RAD )
     &                     +   CURR_CONC( I_RAD ) * CURR_CONC( J_RAD ) )
         ENDDO LOOP_TRIRATE

         L = 0
         LOOP_PHOTORATE: DO J = PHOTO_START, PHOTO_STOP
            L = L + 1
            LOSS_RATE( J ) = RATE_CONST( I, J )
         ENDDO LOOP_PHOTORATE

         LOOP_RATE :  DO J = 1, N_PROCESSES
               NET_RATE = NET_RATE + LOSS_RATE( J )
         ENDDO LOOP_RATE
                  
         IF ( NET_RATE * DT .LE. 1.0D-20 ) CYCLE LOOP_REACT

         NET_LIFE = 1.0D0 / NET_RATE         
         
         TRANS = CURR_CONC( I_RXT ) * ( 1.0D0 - DEXP( -NET_RATE * DT ) )

         IF ( TRANS <= CONMIN ) CYCLE LOOP_REACT

         DELT_CONC( I_RXT ) = TRANS

         LOOP_PROD: DO J = 1, N_PROCESSES
            I_PROD = PROD_MAP( I, J )
            IF ( I_PROD < 1 ) CYCLE ! no specified product
            DELT_CONC( I_PROD ) = ( LOSS_RATE( J ) * NET_LIFE )
     &                          * TRANS
         ENDDO LOOP_PROD

      ENDDO LOOP_REACT

      PREV_CONC( 1:NSPCSD ) = CURR_CONC( 1:NSPCSD )

C..update concentrations

      LOOP_UPDATE1: DO I = 1, N_REACT
      
         I_RXT = RXTANT_MAP( I )
         IF( I_RXT < 0 )CYCLE LOOP_UPDATE1

         IF ( DELT_CONC( I_RXT ) <= CONMIN .OR. CURR_CONC( I_RXT ) <= CONMIN ) CYCLE
         CURR_CONC( I_RXT ) = MAX( CURR_CONC( I_RXT ) - DELT_CONC( I_RXT ), CONMIN )

         LOOP_UPDATE2: DO J = 1, N_PROCESSES
            I_PROD = PROD_MAP( I, J )
            IF ( I_PROD < 1 ) CYCLE ! no specified product
            CURR_CONC( I_PROD ) = CURR_CONC( I_PROD )
     &                          + RATE_YIELD( I, J )
     &                          * MAX( DELT_CONC( I_PROD ), CONMIN )
         ENDDO LOOP_UPDATE2

      ENDDO LOOP_UPDATE1

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C-----------------------------------------------------------------------
      SUBROUTINE PA_ERRCHECK

C-----------------------------------------------------------------------
C Function: To check the Process Analysis inputs for errors
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified by Jerry Gipson April, 1997 to add ADJC process and to add
C  species = all for IPR outputs
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Dec. 1, 1998 to correct operator name check problem
C  Modified Apr 11, 2000 to account for AE species w/ surface area units
C  J.Young: fix LCHEMFAM array index bug, fix N_IPR_SPC value for no ipr,
C  fix blank in 'Air density' species name (found by Michael Bane in UK)
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Jul 2016 Jeff Young: modify for model inline
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------

      USE UTILIO_DEFN   
      USE PA_GLOBAL     ! Mech and Grid data used 
      USE CGRID_SPCS, Only: N_CGRID_SPC, CGRID_NAME
      USE PA_IPRVARS
      USE PA_VARS
      USE PA_PARSE
      USE PA_IPRDEF, Only: NOPNAMES, OPNAME
      USE PA_DEFN

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables
      CHARACTER(  4 ) :: TYPE       ! Operator type
      CHARACTER(  7 ) :: PNFLAG     ! Initialization flag
      CHARACTER( 16 ) :: FAM_UNITS  ! Units for first species in a family
      CHARACTER( 16 ) :: VALNAME( MAXDEFNAMES )  ! Vector of valid defined names
      CHARACTER( 16 ) :: SP_UNITS(  MAXFAMMEM )  ! Units for each species

      LOGICAL LDIFF      ! Flag for difference found
      LOGICAL LERROR     ! Flag for an error found
      LOGICAL LFOUND     ! Flag for a name found
      LOGICAL LFIRST     ! Flag for first time
      LOGICAL :: LERREND = .FALSE.   ! Flag to stop processing because of errors
      LOGICAL :: LCHEMFAM( 0:MAXFAMLYS ) ! Flag for gas-chem species family
      LOGICAL LRXINC( MXRXNS )     ! Flag for rxns included in cycles
      LOGICAL LCYUSED( MAXCYCLES ) ! Flag to indicate cycle referenced
      LOGICAL LRXUSED( MAXRXNSUM ) ! Flag to indicate rxnsum referenced
     
      INTEGER CINDX      ! Current index for IPR arrays
      INTEGER HINDX      ! Index for rearranging IPR arrays
      INTEGER INDX       ! Index returned from function INDEX1
      INTEGER JNDX       ! Index returned from function INDEX1
      INTEGER IRRIND     ! Index for IRR reaction number
      INTEGER LINDX      ! Index for rearranging IPR arrays
      INTEGER N          ! Loop index for specis and defined names
      INTEGER NCYC       ! Loop index for number of cycles
      INTEGER NEWNPASP   ! Number of IPR species after ALL species option
      INTEGER NFAM       ! Loop index for number of families
      INTEGER NMEM       ! Loop index for number of family members
      INTEGER NOP        ! Loop index for number of IPR operators
      INTEGER NOPS       ! Number of IPR_OUTPUT operators
      INTEGER NOUT       ! Loop index for number of output requests
      INTEGER NR         ! No. of Rxns found by getrxns
      INTEGER NRX        ! Loop index for reactions
      INTEGER NRXS       ! Loop index for number of reaction sums
      INTEGER NTERM      ! Loop index for number of terms
      INTEGER NUMRXNS    ! No. of IRR reactions
      INTEGER NVALID     ! Number of valid defined names
      INTEGER OFFSET     ! Offset use to compute IPR output index
      INTEGER PAINDX     ! Index for IPR outputs
      INTEGER :: RXNUMS( MXRXNS ) ! Rxn nos. of Rxns found bt getrxns
      INTEGER ASTAT      ! Memory

      REAL    :: COEFFS( MXRXNS )    ! Coefficient found with getrxns
         
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write log header message
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( MSG, 93000 )
      CALL M3MESG( MSG )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check that all family names are valid
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      NVALID = 0
      INDX = 0
      LCHEMFAM( 0 ) = .FALSE.
      DO 40 NFAM = 1, NFAMLYS
         INDX = INDEX1( FAMNAME( NFAM ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94000 ) NFAM, FAMNAME( NFAM )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         INDX = INDEX1( FAMNAME( NFAM ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94020 ) NFAM, FAMNAME( NFAM )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         LCHEMFAM( NFAM ) = .TRUE.
         DO NMEM = 1, NUMFAMMEM( NFAM )
            INDX = INDEX1( FAMMEMNAM( NFAM,NMEM ), N_CGRID_SPC, CGRID_NAME ) 
            IF ( INDX .NE. 0 ) THEN               
               FAMSPIDS( NFAM, NMEM ) = INDX
               JNDX = INDEX1( FAMMEMNAM( NFAM,NMEM ), NUMB_MECH_SPC, CHEMISTRY_SPC )              
               IF ( JNDX .EQ. 0 ) LCHEMFAM( NFAM ) = .FALSE.
            ELSE
               WRITE( MSG, 94040 ) NFAM, FAMNAME( NFAM ),
     &                             FAMMEMNAM( NFAM,NMEM )
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
         END DO

         IF ( .NOT. LERROR ) THEN
            NVALID = NVALID + 1
            VALNAME( NVALID ) = FAMNAME( NFAM )
         END IF
40    CONTINUE
      IF ( LERROR ) LERREND = .TRUE. 
     
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check rxnsums inputs
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 80 NRXS = 1, NRXSUMS
         LRXUSED( NRXS ) = .FALSE.

         INDX = INDEX1( RXSUMNAME( NRXS ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN 
            WRITE( MSG, 94060 ) NRXS, RXSUMNAME( NRXS )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         INDX = INDEX1( RXSUMNAME( NRXS ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94080 ) NRXS, RXSUMNAME( NRXS )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         DO NTERM = 1, NRXTERMS( NRXS )
            INDX = INDEX1( RXSUMLBL( NRXS,NTERM ), NRXNS, RXLABEL ) 
            IF ( INDX .NE. 0 ) THEN
               RXSUMRN( NRXS, NTERM ) = INDX
            ELSE
               WRITE( MSG, 94100 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94105 ) NRXS, RXSUMNAME( NRXS )
               CALL M3MESG( MSG )
               WRITE( MSG, 94110 ) RXSUMLBL( NRXS,NTERM )
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
         END DO

         IF ( .NOT. LERROR ) THEN
            NVALID = NVALID + 1
            VALNAME( NVALID ) = RXSUMNAME( NRXS )
         END IF
80    CONTINUE

      IF ( LERROR ) LERREND = .TRUE. 
      
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check cycle names and cycle species names
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 100 NCYC = 1, NCYCLES
         LCYUSED( NCYC ) = .FALSE.

         INDX = INDEX1( CYCLNAME( NCYC ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94120 ) NCYC, CYCLNAME( NCYC )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         INDX = INDEX1( CYCLNAME( NCYC ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94140 ) NCYC, CYCLNAME( NCYC )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         LFOUND = .FALSE.
         INDX = INDEX1( CYCLSPEC( NCYC ), NUMB_MECH_SPC, CHEMISTRY_SPC )
         IF ( INDX .NE. 0 ) THEN
            LFOUND = .TRUE.
            CYSPTYP( NCYC ) = 'MECH'
            CYSPNUM( NCYC ) = INDX
         END IF

         INDX = INDEX1( CYCLSPEC( NCYC ), NFAMLYS, FAMNAME ) 
         IF ( INDX .NE. 0 ) THEN
            LFOUND = .TRUE.
            CYSPTYP( NCYC ) = 'FAM'
            CYSPNUM( NCYC ) = INDX
         END IF

         IF ( .NOT. LFOUND ) THEN
            WRITE( MSG, 94160 ) NCYC, CYCLNAME( NCYC ), CYCLSPEC( NCYC )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF
100   CONTINUE
      IF ( LERROR ) LERREND = .TRUE. 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check IRR_OUTPUT species names and reaction labels
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 140 NOUT = 1, NIRROUT

c..check that the output name itself is unique
         INDX = INDEX1( IRRNAME( NOUT ), N_CGRID_SPC, CGRID_NAME )
         IF ( INDX .NE. 0 ) THEN 
            WRITE( MSG, 94180 ) NOUT, IRRNAME( NOUT )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF
         
         INDX = INDEX1( IRRNAME( NOUT ), NVALID, VALNAME )
         IF ( INDX .NE. 0 ) THEN
            WRITE( MSG, 94200 ) NOUT, IRRNAME( NOUT )
            CALL M3MESG( MSG )
            LERROR = .TRUE.
         END IF

         IF ( .NOT. LERROR ) THEN
            NVALID = NVALID + 1
            VALNAME( NVALID ) = IRRNAME( NOUT )
         END IF

         DO 120 NTERM = 1, NIRRTERMS( NOUT )

c...check names used in production/loss/net operators
            TYPE = OUTTYPE( NOUT,NTERM )
            IF ( TYPE .EQ. 'PROD' .OR. TYPE .EQ. 'NETP' .OR. 
     &           TYPE .EQ. 'LOSS' .OR. TYPE .EQ. 'NETL' .OR.
     &           TYPE .EQ. 'NET' ) THEN

               LFOUND = .FALSE.

               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NUMB_MECH_SPC, CHEMISTRY_SPC )
               IF ( INDX .NE. 0 ) THEN
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT, NTERM ) = 'MECH'
                  OUTS1NUM( NOUT, NTERM ) = INDX
               END IF

               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NFAMLYS, FAMNAME )
               IF ( INDX .NE. 0 .AND. LCHEMFAM( INDX ) ) THEN
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT, NTERM ) = 'FAM'
                  OUTS1NUM( NOUT, NTERM ) = INDX
               END IF
 
               IF ( .NOT. LFOUND ) THEN
                  LERROR = .TRUE.
                  IF ( INDX .NE. 0 .AND. .NOT. LCHEMFAM( INDX ) ) THEN
                     WRITE( MSG, 94220 )
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT ) 
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94230 ) OUTSPEC1( NOUT, NTERM )
                     CALL M3MESG( MSG )
                  ELSE
                     WRITE( MSG, 94240 )
                     CALL M3MESG( MSG )
                     WRITE( MSG,94260 ) NOUT, IRRNAME( NOUT ) 
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94280 ) OUTSPEC1( NOUT, NTERM )
                     CALL M3MESG( MSG )
                  END IF
               END IF

               IF ( OUTSPEC2( NOUT,NTERM ) .NE. '' .AND. 
     &              ( TYPE .EQ. 'PROD' .OR. TYPE .NE. 'NETP' ) ) THEN
                  LFOUND = .FALSE.
                  INDX = INDEX1( OUTSPEC2( NOUT,NTERM ), NUMB_MECH_SPC, CHEMISTRY_SPC )
                  IF ( INDX .NE. 0 ) THEN
                     LFOUND = .TRUE.
                     OUTS2TYP( NOUT,NTERM ) = 'MECH'
                     OUTS2NUM( NOUT,NTERM ) = INDX
                  END IF

                  INDX = INDEX1( OUTSPEC2( NOUT,NTERM ), NFAMLYS, FAMNAME )
                  IF ( INDX .NE. 0 .AND. LCHEMFAM( INDX ) ) THEN
                     LFOUND = .TRUE.
                     OUTS2TYP( NOUT,NTERM ) = 'FAM'
                     OUTS2NUM( NOUT,NTERM ) = INDX
                  END IF

                  IF ( OUTSPEC2( NOUT,NTERM ) .EQ. 'hv' ) THEN
                     LFOUND = .TRUE.
                     OUTS2TYP( NOUT,NTERM ) = 'MECH'
                     OUTS2NUM( NOUT,NTERM ) = 0
                  END IF
                        
                  IF ( .NOT. LFOUND ) THEN
                     LERROR = .TRUE.
                     IF ( INDX .NE. 0 .AND. .NOT. LCHEMFAM( INDX ) ) THEN
                        WRITE( MSG, 94220 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT ) 
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94230 ) OUTSPEC2( NOUT,NTERM )
                        CALL M3MESG( MSG )
                     ELSE
                        WRITE( MSG, 94240 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94280 ) OUTSPEC2( NOUT,NTERM )
                        CALL M3MESG( MSG )
                     END IF
                  END IF
               END IF
               
               IF ( OUTSPEC3( NOUT, NTERM ) .NE. '' .AND. 
     &                TYPE .NE. 'NET' ) THEN
                  LFOUND = .FALSE.
                  INDX = INDEX1( OUTSPEC3( NOUT,NTERM ), NUMB_MECH_SPC, CHEMISTRY_SPC )
                  IF ( INDX .NE. 0 ) THEN
                     LFOUND = .TRUE.
                     OUTS3TYP( NOUT,NTERM ) = 'MECH'
                     OUTS3NUM( NOUT,NTERM ) = INDX
                  END IF

                  INDX = INDEX1( OUTSPEC3( NOUT,NTERM ), NFAMLYS, FAMNAME )
                  IF ( INDX .NE. 0 .AND. LCHEMFAM( INDX ) ) THEN
                     LFOUND = .TRUE.
                     OUTS3TYP( NOUT,NTERM ) = 'FAM'
                     OUTS3NUM( NOUT,NTERM ) = INDX
                  END IF

                  IF ( OUTSPEC3( NOUT,NTERM ) .EQ. 'hv ' ) THEN
                     LFOUND = .TRUE.
                     OUTS3TYP( NOUT,NTERM ) = 'MECH'
                     OUTS3NUM( NOUT,NTERM ) = 0
                  END IF
                    
                  IF ( .NOT. LFOUND ) THEN
                     LERROR = .TRUE.
                     IF ( INDX .NE. 0 .AND. .NOT. LCHEMFAM( INDX ) ) THEN
                        WRITE( MSG, 94220 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT ) 
                        CALL M3MESG( MSG )
                        WRITE( MSG,94230 ) OUTSPEC2( NOUT,NTERM )
                        CALL M3MESG( MSG )
                     ELSE
                        WRITE( MSG, 94240 )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94260 ) NOUT, IRRNAME( NOUT )
                        CALL M3MESG( MSG )
                        WRITE( MSG, 94280 ) OUTSPEC3( NOUT,NTERM ) 
                        CALL M3MESG( MSG )
                     END IF
                  END IF
               END IF

c..check cycle names or reaction sum names
            ELSE IF ( TYPE .EQ. 'NAME' ) THEN
               LFOUND = .FALSE.
               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NRXSUMS, RXSUMNAME )
               IF ( INDX .NE. 0 ) THEN               
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT, NTERM ) = 'RXSM'
                  OUTS1NUM( NOUT, NTERM ) = INDX
                  LRXUSED( INDX ) = .TRUE.
               END IF
               INDX = INDEX1( OUTSPEC1( NOUT,NTERM ), NCYCLES, CYCLNAME )
               IF ( INDX .NE. 0 ) THEN               
                  LFOUND = .TRUE.
                  OUTS1TYP( NOUT,NTERM ) = 'CYCL'
                  OUTS1NUM( NOUT,NTERM ) = INDX
                  LCYUSED( INDX ) = .TRUE.
               END IF

               IF ( .NOT. LFOUND ) THEN
                  WRITE( MSG, 94300 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94320 ) NOUT, IRRNAME( NOUT ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94340 ) OUTSPEC1( NOUT,NTERM )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
               END IF

c..check for reaction label name
            ELSE IF ( TYPE .EQ. 'RXN' ) THEN
               LFOUND = .FALSE.
               INDX = INDEX1( OUTRXLBL( NOUT,NTERM ), NRXNS, RXLABEL )
               IF ( INDX .NE. 0 ) THEN               
                  LFOUND = .TRUE.
                  OUTRN( NOUT,NTERM ) = INDX
               END IF

               IF ( .NOT. LFOUND ) THEN
                  WRITE( MSG, 94360 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94380 ) NOUT, IRRNAME( NOUT ) 
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94400 ) OUTRXLBL( NOUT,NTERM )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
               END IF
            ELSE
               WRITE( MSG, 94420 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94440 ) NOUT, IRRNAME( NOUT )
               CALL M3MESG( MSG )
               WRITE( MSG, 94460 ) TYPE
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
120      CONTINUE
140   CONTINUE         
      IF ( LERROR ) LERREND = .TRUE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check IPR_OUTPUT species names
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      IF ( N_IPR_SPC .GT. 0 ) THEN
         OFFSET = 0
         NEWNPASP = N_IPR_SPC
         DO 160 NOUT = 1, N_IPR_SPC
            PAINDX = NOUT + OFFSET 
            LFOUND = .FALSE.
            INDX = INDEX1( IPR_SPNAM( PAINDX ), N_CGRID_SPC, CGRID_NAME )
            IF ( INDX .NE. 0 ) THEN 
               LFOUND = .TRUE.
               IPR_SPTYPE( PAINDX ) = 'SPEC'
               IPR_SPNUM( PAINDX ) = INDX
            END IF
  
            IF ( .NOT. LFOUND ) THEN
               INDX = INDEX1( IPR_SPNAM( PAINDX ), NFAMLYS, FAMNAME )
               IF ( INDX .NE. 0 ) THEN 
                  LFOUND = .TRUE.
                  IPR_SPTYPE( PAINDX ) = 'FAM'
                  IPR_SPNUM( PAINDX ) = INDX
               END IF
            END IF

c..If all species requested, insert all species into position
            IF ( .NOT. LFOUND. AND. 
     &            ( IPR_SPNAM( PAINDX )( 1:3 ) .EQ. 'ALL' .OR.
     &              IPR_SPNAM( NOUT )( 1:3 ) .EQ. 'all' ) ) THEN
               LFOUND = .TRUE.
               NEWNPASP = PAINDX - 1 + N_CGRID_SPC + ( N_IPR_SPC - NOUT )
               IF ( NEWNPASP .GT. MAXIPRSPC ) THEN
                  WRITE( MSG, 94800 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94820 ) MAXIPRSPC
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94840 )
                  CALL M3MESG( MSG )
                  CALL M3EXIT( 'ERRCHECK', IZERO, IZERO, ' ', XSTAT1 )
               END IF

               OFFSET = PAINDX - 1 + N_CGRID_SPC - NOUT
               IF ( N_IPR_SPC .GT. NOUT ) THEN
                  CINDX = PAINDX
                  DO N = NOUT + 1, N_IPR_SPC
                     CINDX = CINDX + 1
                     HINDX = N + OFFSET
                     IPR_SPNAM( HINDX ) = IPR_SPNAM( CINDX )
                     N_IPR_OPS( HINDX ) = N_IPR_OPS( CINDX )
                     IF ( N_IPR_OPS( HINDX ) .GT. 0 ) THEN
                        DO NOP = 1, N_IPR_OPS( HINDX )
                           IPR_OPNAME( HINDX, NOP ) = IPR_OPNAME( CINDX,NOP )
                        END DO
                     END IF
                  END DO
               END IF

               LINDX = PAINDX
               DO N = 1, N_CGRID_SPC
                  IPR_SPNAM( LINDX )  = CGRID_NAME( N )
                  N_IPR_OPS( LINDX )  = N_IPR_OPS( PAINDX )
                  IPR_SPTYPE( LINDX ) = 'SPEC'
                  IPR_SPNUM( LINDX )  = N
                  DO NOP = 1, N_IPR_OPS( LINDX )
                     IPR_OPNAME( LINDX,NOP ) = IPR_OPNAME( PAINDX,NOP )
                  END DO
                  LINDX = LINDX + 1
               END DO
            END IF
                         
            IF ( .NOT. LFOUND ) THEN
               WRITE( MSG, 94480 )
               CALL M3MESG( MSG )
               WRITE( MSG, 94500 ) IPR_SPNAM( PAINDX )
               CALL M3MESG( MSG )
               LERROR = .TRUE.
            END IF
160      CONTINUE
         N_IPR_SPC = NEWNPASP
      END IF               
      IF ( LERROR ) LERREND = .TRUE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check IPR_OUTPUT operators
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO 180 NOUT = 1, N_IPR_SPC
         NOPS = N_IPR_OPS( NOUT )
         IF ( NOPS .GT. 0 ) THEN
            DO N = 1, NOPS
               INDX = INDEX1( IPR_OPNAME( NOUT,N ), NOPNAMES, OPNAME )
               IF ( INDX .EQ. 0 ) THEN
                  WRITE( MSG, 94520 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94540 ) IPR_OPNAME( NOUT,N ), 
     &                                IPR_SPNAM( NOUT )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
               ELSE
                  IPR_OPNAME( NOUT,N ) = OPNAME( INDX )
               END IF
            END DO
         ELSE
            DO N = 1, NPRCS
               IPR_OPNAME( NOUT,N ) = PROCNAME( N )
            END DO
            N_IPR_OPS( NOUT ) = NPRCS
         END IF
180   CONTINUE

      IF ( LERROR ) LERREND = .TRUE.
               
      IF ( LERROR .OR. LERREND ) GO TO 999  ! If errors, skip next error checks

c determine NIRRRXNS
      ALLOCATE( NIRRRXNS( NIRRVAR ), STAT = ASTAT )   ! NIRRVAR .ge. NIRROUT
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 1 allocating IRR variables'
         CALL M3EXIT ( 'PA_ERRCHECK', 0, 0, MSG, XSTAT2 )
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Get IRR reaction numbers excluding those included in CYCLES & RXNSUMS 
c  and check dimension magnitudes
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      MXNIRRRXNS = 0
      DO 300 NOUT = 1, NIRROUT
         NIRRRXNS( NOUT ) = 0
         
c..Flag reactions included in Cycles for elimination in operators
         DO NRX = 1, NRXNS
            LRXINC( NRX ) = .TRUE.
         END DO

         IF ( NOUTCYCS( NOUT ) .GT. 0 ) THEN
            DO N = 1, NOUTCYCS( NOUT )
               NCYC = OUTCYCS( NOUT, N )
               DO NTERM = 1, NCYTERMS( NCYC )
                  INDX = CYRXNUM( NCYC,NTERM )
                  LRXINC( INDX ) = .FALSE.
               END DO
            END DO
         END IF

         DO 280 NTERM = 1, NIRRTERMS( NOUT )
            TYPE = OUTTYPE( NOUT, NTERM ) 
            IF ( TYPE .NE. 'NAME' .AND. TYPE .NE. 'RXN' ) THEN             
               CALL GETRXNS( NOUT, NTERM, NR, RXNUMS, COEFFS, LRXINC )
               IF ( NR .GT. 0 ) THEN
                  NUMRXNS = NIRRRXNS( NOUT ) + NR
                  IF ( NUMRXNS .GT. MAXTERMS ) THEN
                     WRITE( MSG, 94560 )
                     CALL M3MESG( MSG )
                     WRITE( MSG, 94580 ) NOUT, IRRNAME( NOUT )
                     CALL M3MESG( MSG )
                     LERROR = .TRUE.
                     GO TO 300
                  END IF
                  DO NRX = 1, NR
                     INDX = RXNUMS( NRX )
                     IRRIND = NIRRRXNS( NOUT ) + NRX
                     IRRRXN_TMP( NOUT,IRRIND ) = INDX
                     IRRCOEF_TMP( NOUT,IRRIND ) = COEFFS( NRX ) * OUTSC( NOUT,NTERM ) 
                  END DO                     
                  NIRRRXNS( NOUT ) = NIRRRXNS( NOUT ) + NR
               END IF
            ELSE IF ( TYPE .EQ. 'RXN' ) THEN
               NUMRXNS = NIRRRXNS( NOUT ) + 1
               IF ( NUMRXNS .GT. MAXTERMS ) THEN
                  WRITE( MSG, 94560 )
                  CALL M3MESG( MSG )
                  WRITE( MSG, 94580 ) NOUT, IRRNAME( NOUT )
                  CALL M3MESG( MSG )
                  LERROR = .TRUE.
                  GO TO 300 
               END IF
               NIRRRXNS( NOUT ) = NIRRRXNS( NOUT ) + 1                  
               IRRRXN_TMP(  NOUT,NIRRRXNS( NOUT ) ) = OUTRN( NOUT,NTERM ) 
               IRRCOEF_TMP( NOUT,NIRRRXNS( NOUT ) ) = OUTSC( NOUT,NTERM )
            END IF
280      CONTINUE
         MXNIRRRXNS = MAX( MXNIRRRXNS, NIRRRXNS( NOUT ) ) 
300   CONTINUE

      ALLOCATE( IRRRXN( NIRRVAR,MXNIRRRXNS ),
     &          IRRCOEF( NIRRVAR,MXNIRRRXNS ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 2 allocating IRR variables'
         CALL M3EXIT ( 'PA_ERRCHECK', 0, 0, MSG, XSTAT2 )
      END IF

      IRRRXN  = IRRRXN_TMP( 1:NIRRVAR,1:MXNIRRRXNS )
      IRRCOEF = IRRCOEF_TMP( 1:NIRRVAR,1:MXNIRRRXNS )

      IF ( LERROR ) LERREND = .TRUE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check some dimension limits, saving some info
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NUMOUTPOS = 0
      NUMOUTNEG = 0
      NUMOUTIND = 0
      DO NOUT = 1, NIRROUT
         DO NTERM = 1, NIRRTERMS( NOUT )
            TYPE = OUTS1TYP( NOUT, NTERM )
            IF ( TYPE .EQ. 'CYCL' .OR. TYPE .EQ. 'RXSM' ) THEN            
               PNFLAG = OUTPNFLAG( NOUT,NTERM )
               IF ( PNFLAG .EQ. 'POSONLY' ) THEN
                  NUMOUTPOS = NUMOUTPOS + 1
               ELSE IF ( PNFLAG .EQ. 'NEGONLY' ) THEN
                  NUMOUTNEG = NUMOUTNEG + 1
               ELSE IF ( PNFLAG .EQ. '' ) THEN
                  NUMOUTIND = NUMOUTIND + 1
               END IF 
            END IF
         END DO
      END DO

      IF ( NUMOUTPOS .GT. MAXTERMS .OR. NUMOUTNEG .GT. MAXTERMS .OR.
     &     NUMOUTIND .GT. MAXTERMS ) THEN
         WRITE( MSG, 94600 )  MAXTERMS
         CALL M3MESG( MSG )
         LERREND = .TRUE.
      END IF

      IF ( LFULLIRR .AND. NRXNS .GT. MAXIRROUT ) THEN
         WRITE( MSG, 94610 )  MAXIRROUT
         CALL M3MESG( MSG )
         LERREND = .TRUE.
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check to see that a species is not named more than once in a FAMILY
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      LFIRST = .TRUE.
      DO NFAM = 1, NFAMLYS
         DO NMEM = 1, NUMFAMMEM( NFAM )
            DO N = 1, NUMFAMMEM( NFAM )
               IF ( NMEM .NE. N ) THEN
                  IF ( FAMMEMNAM( NFAM,NMEM ) .EQ. 
     &                FAMMEMNAM( NFAM,N ) ) THEN
                     IF ( LFIRST ) THEN
                        WRITE( MSG, 94620 ) 
                        CALL M3MESG( MSG )
                        LFIRST = .FALSE.
                     END IF
                     WRITE( MSG, 94640 ) NFAM, FAMNAME( NFAM ), 
     &                                   FAMMEMNAM( N,NMEM )
                     CALL M3MESG( MSG )
                     LERROR = .TRUE.
                  END IF
               END IF
            END DO
         END DO
      END DO
      IF ( LERROR ) LERREND = .TRUE. 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check to see that all species in a FAMILY have the same units
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LERROR = .FALSE.
      DO NFAM = 1, NFAMLYS
         LDIFF = .FALSE.
         DO NMEM = 1, NUMFAMMEM( NFAM )
            SP_UNITS( NMEM ) = 'ppm'
            INDX = INDEX1( FAMMEMNAM( NFAM,NMEM ), N_CGRID_SPC, CGRID_NAME )
            IF ( NMEM .EQ. 1 ) THEN
               FAM_UNITS = SP_UNITS( NMEM )
            ELSE
               IF ( SP_UNITS( NMEM ) .NE. FAM_UNITS ) LDIFF = .TRUE.   
            END IF
         END DO

         IF ( LDIFF ) THEN
            LERROR = .TRUE.
            WRITE( MSG, 94650 ) NFAM, FAMNAME( NFAM ) 
            CALL M3MESG( MSG )
            DO NMEM = 1, NUMFAMMEM( NFAM )
               WRITE( MSG,94652 ) NMEM, FAMMEMNAM( NFAM,NMEM ), SP_UNITS( NMEM ) 
               CALL M3MESG( MSG )
            END DO
         END IF
      END DO                   
      IF ( LERROR ) LERREND = .TRUE. 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check to see if any defined CYCLES or RXNSUMS are not used
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LFIRST = .TRUE.
      DO NCYC = 1, NCYCLES
         IF ( .NOT. LCYUSED( NCYC ) ) THEN
            IF ( LFIRST ) THEN 
               WRITE( MSG, 94660 ) 
               CALL M3MESG( MSG )
               LFIRST = .FALSE.
            END IF
            WRITE( MSG, 94680 ) NCYC, CYCLNAME( NCYC )
            CALL M3MESG( MSG )
         END IF
      END DO

      LFIRST = .TRUE.
      DO NRXS = 1, NRXSUMS
         IF ( .NOT. LRXUSED( NRXS ) ) THEN
            IF ( LFIRST ) THEN 
               WRITE( MSG, 95700 ) 
               CALL M3MESG( MSG )
               LFIRST = .FALSE.
            END IF
            WRITE( MSG, 95720 ) NRXS, RXSUMNAME( NRXS )
            CALL M3MESG( MSG )
         END IF
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Return or stop
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
999   CONTINUE
      IF ( LERREND ) THEN
         WRITE( MSG, 95740 )
         CALL M3MESG( MSG )
         CALL M3EXIT( 'ERRCHECK', IZERO, IZERO, ' ', XSTAT1 )
      ELSE
         WRITE( MSG, 95760 )
         CALL M3MESG( MSG )
         RETURN
      END IF
 
C---------------------- Format Statements -----------------------------     
      
93000 FORMAT( 'Entering the Process Analysis error checking routine' )
94000 FORMAT( 'ERROR: FAMILY name ', I3, ' ', A16, 
     &               ' duplicates a species name' )
94020 FORMAT( 'ERROR: FAMILY name ', I3, ' ', A16, ' duplicates another',
     &               ' DEFINEd name' )
94040 FORMAT( 'ERROR: Invalid member name for FAMILY ', I3, ' ', A16,
     &               ':', A16 )
94060 FORMAT( 'ERROR: RXNSUM name ', I3, ' ', A16,
     &               ' duplicates a species name' )
94080 FORMAT( 'ERROR: RXNSUM name ', I3, ' ', A16,' duplicates another',
     &               ' DEFINEd name' )
94100 FORMAT( 'ERROR: Invalid reaction label for RXNSUM' )
94105 FORMAT( '       RXNSUM name ', I3, ': ', A16 )
94110 FORMAT( '       Invalid reaction label: ', A16 )         
94120 FORMAT( 'ERROR: CYCLE name ', I3, ' ', A16,
     &               ' duplicates a species name' )
94140 FORMAT( 'ERROR: CYCLE name ', I3, ' ', A16, ' duplicates another',
     &               ' DEFINEd name' )
94160 FORMAT( 'ERROR: Invalid species name for CYCLE ', I3,' ',A16,
     &               ': ', A16 ) 
94180 FORMAT( 'ERROR: IRR_OUTPUT name ', I3, ' ', A16, ' duplicates',
     &               ' a species name' )
94200 FORMAT( 'ERROR: IRR_OUTPUT name ', I3, ' ', A16, ' duplicates',
     &               ' another DEFINEd name' )
94220 FORMAT( 'ERROR: Family in an IRR_OUTPUT operator contains a non-',
     &               'gas chemistry species' )
94230 FORMAT( '       Family name: ', A16 )
94240 FORMAT( 'ERROR: Invalid species name in an IRR_OUTPUT operator' )
94260 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94280 FORMAT( '       Invalid name: ', A16 ) 
94300 FORMAT( 'ERROR: Invalid CYCLE or RXNSUM name in an IRR_OUTPUT' )
94320 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94340 FORMAT( '       Invalid name: ', A16 )
94360 FORMAT( 'ERROR: Invalid reaction label for an IRR_OUTPUT' )
94380 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94400 FORMAT( '       Invalid reaction label: ', A16 ) 
94420 FORMAT( 'ERROR: Invalid operation type for IRR_OUTPUT' )
94440 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94460 FORMAT( '       Invalid operation name: ', A16 ) 
94480 FORMAT( 'ERROR: Invalid species name for IPR_OUTPUT operation' )
94500 FORMAT( '       Invalid name: ', A16 )
94520 FORMAT( 'ERROR: Invalid operator name for IPR_OUTPUT operation' )
94540 FORMAT( '       Invalid name: ', A16, ' for species ', A )
94560 FORMAT( 'ERROR: The total number of reactions in the IRR_OUTPUT',
     &               ' operation exceeds the maximum allowable of 500' )
94580 FORMAT( '       IRR_OUTPUT name ', I3, ': ', A16 )
94600 FORMAT( 'ERROR: The number of CYCLEs plus RXSUMs exceeds the',
     &               ' maximum allowable of 500' )
94610 FORMAT( 'ERROR: The number of reactions for IRRTYPE=FULL exceeds',
     &               ' the maximum allowable of 500' )
94620 FORMAT( 'ERROR: A species is listed more than once in a FAMILY' )
94640 FORMAT( '       FAMILY ', I3, ': ', A,'   SPECIES: ', A )
94650 FORMAT( 'ERROR: Inconsistent species units in FAMILY ', I3, ': ', A )
94652 FORMAT( '       SPECIES ', I3, ': ', A, '    UNITS: ', A )
94660 FORMAT( 'WARNING: The following cycles were defined but not used:' )
94680 FORMAT( '         CYCLE ', I3, ': ', A )
95700 FORMAT( 'WARNING: The following rxsums were defined but not used:' )
95720 FORMAT( '         RXSUM ', I3, ': ', A )
95740 FORMAT( 'STOPPING in ERRCHECK because of errors' )
95760 FORMAT( 'No input errors detected, continuing....' ) 
94800 FORMAT( 'ERROR: Maximum number of PA species exceeded' )
94820 FORMAT( '       Modify PARAMETER ( MAXIPRSPC =', I3,' ) or decrease',
     &              ' the number of PA species' )
94840 FORMAT( '       Error occurred while processing species option ',
     &               ' ALL' )

      END SUBROUTINE PA_ERRCHECK

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE RDBCON ( JDATE, JTIME, TSTEP, LVL, BCON, LSTAT )

C-----------------------------------------------------------------------
C Function:
C   Read boundary concentrations data for advection and couple with
C   SqRDMT, Where SqRDMT = Sq. Root [det ( metric tensor )]
C                        = Vertical Jacobian / (map scale factor)**2
C   Load Air Density X SqRDMT = RHOJ into last BCON slot for advection

C Preconditions:

C Subroutines and Functions Called:
C   INTERPX, INTERPB, M3EXIT, TRIMLEN, ADVBC_MAP, TIME2SEC, SEC2TIME, NEXTIME

C Revision History:
C   Jeff - Aug 1997 Based on beta version, keep in ppmV units (not aerosols)
C   Jeff - Dec 97 - add CMIN
C   Jeff - Apr 98 - fix conversion/coupling for aerosol number species
C   Jeff - Apr 01 - dyn alloc - Use PINTERB for boundary data - assume the met
C                   data could come from a larger file, but not the conc cata
C   23 Jun 03 J.Young: for layer dependent advection tstep
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C   14 Sep 15 J.Young: change Fortran string comparison to logical from advbc_map
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                     clauses
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1

C-----------------------------------------------------------------------

      USE GRID_CONF            ! horizontal & vertical domain specifications
      USE CGRID_SPCS           ! CGRID mechanism species
      USE UTILIO_DEFN
      USE RXNS_DATA, ONLY : MECHNAME
      USE AERO_DATA, only : CHECK_AERO_ICBC, N_MODE
      use CENTRALIZED_IO_MODULE, only : interpolate_var, window

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN, SEN_PAR, BCS
#endif 

      IMPLICIT NONE
 
C Includes:
      INCLUDE SUBST_CONST      ! constants
      INCLUDE SUBST_FILES_ID   ! file name parameters

C Arguments:
      INTEGER, INTENT( IN ) :: JDATE       ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME       ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP       ! timestep
      INTEGER, INTENT( IN ) :: LVL         ! layer
      REAL,    INTENT( OUT ) :: BCON( :,: ) ! boundary concentrations
      LOGICAL, INTENT( INOUT ) :: LSTAT       ! Flag for identifying Aerosol BC flaws

C Parameters:
      REAL, PARAMETER :: KGPMG = 1.0E-09  ! Kg / micro-gram
      REAL, PARAMETER :: CMIN = 1.0E-30

      CHARACTER( 16 ) :: CONCMIN

C File variables:
      REAL, ALLOCATABLE, SAVE :: JACOBM_BND( :,: ) ! boundary Jacobian
      REAL, ALLOCATABLE, SAVE :: RHOJ_BND  ( :,: ) ! mid-layer boundary RhoJ

      REAL, ALLOCATABLE, SAVE :: JACOBM_BUF( :,: ) ! grid Jacobian
      REAL, ALLOCATABLE, SAVE :: RHOJ_BUF  ( :,: ) ! mid-layer grid RhoJ

      REAL, ALLOCATABLE, SAVE :: BBUF      ( :,: ) ! bcon file buffer
      REAL, ALLOCATABLE, SAVE :: BBUF_TMP  ( :,: ) ! bcon file buffer

C External Functions: None

C Local variables:
      CHARACTER( 16 ) :: PNAME = 'RDBCON'
      CHARACTER( 16 ) :: VNAME

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 16 ) :: BLNK = ' '
      CHARACTER( 16 ) :: BCNAME_TMP = ' '
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: BCNAME( : )  ! BC name for adv species
      REAL,            ALLOCATABLE, SAVE :: BCFAC( : )   ! Scale factor for BCs
      LOGICAL,         ALLOCATABLE, SAVE :: ONFILE( : )  ! BC species on the file

      CHARACTER( 96 )  :: XMSG = ' '
      CHARACTER( 199 ) :: XMSG2 = ' '
      INTEGER          :: STAT

      INTEGER, SAVE :: N_SPC_ADV
      INTEGER       :: LMODE    !Identifies the problematic mode from
                                !the BC Check routine
      REAL          :: AER_PAR( 2, N_MODE,5 )  !Modal parameter after the BC 
                                               !check (N, dg, sg)
                                               !      (N, M2, M3) - Before
                                               !      (N, M2, M3) - After

      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
      INTEGER   STEP              ! advection time step in seconds

      INTEGER   BND, VAR, SPC     ! loop counters
      INTEGER   COL, ROW, IMODE   ! loop counters
      INTEGER   STRT, FINI, IAER, J
      INTEGER   ALLOCSTAT

      INTEGER   COUNT             ! Counter for constructing boundary arrays

#ifdef sens
      INTEGER SENNUM
      CHARACTER(16 ) :: SNAME    ! Name of sens bc parameter
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: S_BCNAME( :,: )
#endif

      INTERFACE
         SUBROUTINE ADVBC_MAP( CONCMIN, BCNAME, BCFAC, ONFILE )
            CHARACTER( 16 ), INTENT( IN )  :: CONCMIN
            CHARACTER( 16 ), INTENT( OUT ) :: BCNAME( : )
            REAL,            INTENT( OUT ) :: BCFAC ( : )
            LOGICAL,         INTENT( OUT ) :: ONFILE( : )
         END SUBROUTINE ADVBC_MAP
      END INTERFACE

#ifdef verbose_rdbcon
      real sumbc
      integer s
#endif
C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         WRITE( CONCMIN,'(1PE9.2)' ) CMIN

         ALLOCATE ( BBUF( NBNDY,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BBUF'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         ALLOCATE ( BBUF_TMP( NBNDY,NLAYS ), STAT = ALLOCSTAT )

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ


         ALLOCATE ( BCNAME( N_SPC_ADV ),
     &              BCFAC ( N_SPC_ADV ),
     &              ONFILE( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BCNAME, BCFAC, or ONFILE'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C create advected species map to bc`s
 
         CALL ADVBC_MAP ( CONCMIN, BCNAME, BCFAC, ONFILE )

         ALLOCATE ( JACOBM_BND( NBNDY,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating JACOBM_BND'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( RHOJ_BND( NBNDY,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating RHOJ_BND'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( WINDOW ) THEN

            ALLOCATE ( JACOBM_BUF( 0:NCOLS+1,0:NROWS+1 ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating JACOBM_BUF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( RHOJ_BUF( 0:NCOLS+1,0:NROWS+1 ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating RHOJ_BUF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF

#ifdef sens
         ALLOCATE ( S_BCNAME( N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_BCNAME'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( BCS ) THEN
            DO NP = 1, NPMAX
               FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
               DO VAR = 1, FINI
                  S_BCNAME( VAR,NP ) = TRIM( BCNAME( VAR ) ) // '_' // SEN_PAR( NP )
               END DO
            END DO
         ENDIF
#endif


      END IF                    ! if FIRSTIME

      MDATE  = JDATE
      MTIME  = JTIME
      STEP   = TIME2SEC( TSTEP )
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

C Read & interpolate boundary SqrDMT, and RhoJ
C According to the METBDY3D File, variables have the following units:
C    JACOBM  - Meters
C    DENSA_J - KG M-2

      IF ( WINDOW ) THEN

         RHOJ_BUF = 0.0
         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ_BUF, slay=lvl)

         call interpolate_var ('JACOBM', mdate, mtime, JACOBM_BUF, slay=lvl)

C Fill in DENSJ array for boundaries
         COUNT = 0
         DO ROW = 0, 0                                ! South
            DO COL = 1, NCOLS+1
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO
         DO ROW = 1, NROWS+1                       ! East
            DO COL = NCOLS+1, NCOLS+1
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO
         DO ROW = NROWS+1, NROWS+1              ! North
            DO COL = 0, NCOLS
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO
         DO ROW = 0, NROWS                         ! West
            DO COL = 0, 0
               COUNT = COUNT + 1
               JACOBM_BND( COUNT,LVL ) = JACOBM_BUF( COL,ROW )
               RHOJ_BND  ( COUNT,LVL ) = RHOJ_BUF  ( COL,ROW )
            END DO
         END DO

      ELSE

#ifdef parallel
         call interpolate_var ('JACOBM', mdate, mtime, JACOBM_BND, 'b', lvl)
#else
         call interpolate_var ('JACOBM', mdate, mtime, JACOBM_BND, 'b')
#endif

#ifdef parallel
         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ_BND, 'b', lvl)
#else
         call interpolate_var ('DENSA_J', mdate, mtime, RHOJ_BND, 'b')
#endif

      END IF   ! WINDOW

      BCON = 0.0

C Read & interpolate boundary concentrations
      ! Gas-Phase Species
      STRT = 1
      FINI = N_GC_TRNS
      DO 141 VAR = STRT, FINI
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = BCFAC( VAR ) * BBUF( BND,LVL )
     &                         * RHOJ_BND( BND,LVL )
            END DO
         ELSE
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = CMIN
            END DO
         END IF
141   CONTINUE

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         write( logdev,'(/"@@@b ", i8, i7.6)') jdate, jtime
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

      ! Particle Species
      SPC = 0
      STRT = N_GC_TRNS + 1
      FINI = N_GC_TRNS + N_AE_TRNS
      DO 151 VAR = STRT, FINI
         SPC = SPC + 1
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            ! Add Non-Carbon Mass to Carbon Mass if the model is
            ! running semivolatile POA
            IF ( BCNAME( VAR )( 1:4 ) .EQ. 'APOC' .AND.
     &           AE_TRNS( SPC )( 1:4 ) .NE. 'APOC' ) THEN 
                 BBUF_TMP = 0.0
                 BCNAME_TMP = 'APNCOM' // BCNAME( VAR )( 5:5 )
#ifdef parallel
                 call interpolate_var (BCNAME_TMP, mdate, mtime, BBUF_TMP, 'b', lvl)
#else
                 call interpolate_var (BCNAME_TMP, mdate, mtime, BBUF_TMP, 'b')
#endif
                 BBUF = BBUF + BBUF_TMP
            END IF

            ! Units of JACOBM_BND are Meters, according to the input
            ! file. Units of BBUF are ug m-3 ( m2 m-3 for surface
            ! area and N m-3 for number).
            BCON( 1:NBNDY,VAR ) = BCFAC( VAR ) * BBUF( 1:NBNDY,LVL ) 
     &                               * JACOBM_BND( 1:NBNDY,LVL )
                  
            ! Found bc's (microgram/m**3, m**2/m**3, or number/m**3)
            ! Also Do a Mass conversion as long as this particle
            ! species is not Number or Surface Area.
            IF ( AE_TRNS( SPC )( 1:3 ) .NE. 'NUM' .AND.
     &           AE_TRNS( SPC )( 1:3 ) .NE. 'SRF'      ) THEN
               BCON( 1:NBNDY,VAR ) = BCON( 1:NBNDY,VAR ) * KGPMG
            END IF
                
         ELSE
            BCON( 1:NBNDY,VAR ) = CMIN
         END IF
151   CONTINUE
      
      WHERE( BCON .NE. BCON ) BCON = 0.0

      !Check Aerosol Size Distributions and Warn 
      !the User if They Are Not Robust
      DO BND = 1,NBNDY
        CALL CHECK_AERO_ICBC( BCON( BND,STRT:FINI ), .FALSE., STAT, AER_PAR, LMODE )
        IF ( STAT .GT. 0 ) THEN
          LSTAT = .TRUE.
#ifdef verbose_rdbcon
          WRITE ( LOGDEV,'(7x,A55,I1,/,7x,A20,I1,A42,/,9x,A51,/,9x,A22,I4,2x,I2,/,
     &                 9x,A19,1x,A3,8x,A2,8x,A2,8x,A2,8x,A2,/,
     &                 27x,E8.1,1x,E8.1,1x,E8.1,1x,E8.1,4x,F4.1,/,
     &                 9x,A19,1x,A3,8x,A2,8x,A2,8x,A2,8x,A2,/,
     &                 27x,E8.1,1x,E8.1,1x,E8.1,1x,E8.1,4x,F4.1)'),
     &               'Warning: Applying Aerosol Boundary Conditions for mode ',LMODE,
     &               'The Offending Mode (',LMODE,') had diameter and/or sigma out of bounds.',
     &               'It was overwritten by changing the Num and SrfArea.',
     &               'Grid Cell(Horz,Vert): ',BND, LVL,
     &               'Modal Props Before:','Num','M2','M3','Dg','Sg',(AER_PAR(1,LMODE,j),j=1,5),
     &               'Modal Props After: ','Num','M2','M3','Dg','Sg',(AER_PAR(2,LMODE,j),j=1,5)
#endif
        ENDIF
      END DO

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

      ! Non-Reactive Species
      STRT = N_GC_TRNS + N_AE_TRNS + 1
      FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS
      DO 161 VAR = STRT, FINI
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = BCFAC( VAR ) * BBUF( BND,LVL )
     &                           * RHOJ_BND( BND,LVL )
            END DO
         ELSE
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = CMIN
            END DO
         END IF
161   CONTINUE

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

      ! Tracer Species
      STRT = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + 1
      FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
      DO 171 VAR = STRT, FINI
         IF ( ONFILE( VAR ) ) THEN
            BBUF = 0.0   ! array assignment
#ifdef parallel
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b', lvl)
#else
            call interpolate_var (BCNAME(VAR), mdate, mtime, BBUF, 'b')
#endif
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = BCFAC( VAR ) * BBUF( BND,LVL )
     &                         * RHOJ_BND( BND,LVL )
            END DO
         ELSE
            DO BND = 1, NBNDY
               BCON( BND,VAR ) = CMIN
            END DO
         END IF
171   CONTINUE

#ifdef verbose_rdbcon
      if ( lvl .eq. 1 ) then
         do var = strt, fini
            sumbc = 0.0
            do bnd = 1, nbndy
               sumbc = sumbc + bcon( bnd,var )
            end do
            write( logdev,'("@@@b ", a, g16.6)') bcname( var ), sumbc
         end do
      end if
#endif

C for advecting Air Density X Jacobian

      DO BND = 1, NBNDY
         BCON( BND,N_SPC_ADV ) = RHOJ_BND( BND,LVL )
      END DO

#ifdef sens
C Initialize BSEN as zero, if flag is set for using bc files, use those,
C otherwise skip all of this.'

      BSEN = 0.0

c     IF ( BCS ) THEN
c        DO NP = 1, NPMAX

c           STRT = 1
c           FINI = N_GC_TRNS
c           DO 241 VAR = STRT, FINI
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                 ELSE   ! found bc's (PPM) on file; convert
c                    DO BND = 1, NBNDY
c                       BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                     * RHOJ_BND( BND,LVL )
c                    END DO
c                 END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c241         CONTINUE

c           SPC = 0
c           STRT = N_GC_TRNS + 1
c           FINI = N_GC_TRNS + N_AE_TRNS
c           DO 251 VAR = STRT, FINI
c              SPC = SPC + 1
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB ( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                 MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME ( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                 ELSE   ! found bc's (microgram/m**3, m**2/m**3, or number/m**3)
c                           ! on file; convert
c                    IF ( AE_TRNS( SPC )( 1:3 ) .EQ. 'NUM' ) THEN
c                       DO BND = 1, NBNDY
c                          BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                        * JACOBM_BND( BND,LVL )
c                       END DO
c                    ELSE IF ( AE_TRNS( SPC )( 1:3 ) .EQ. 'SRF' ) THEN
c                       DO BND = 1, NBNDY
c                          BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                        * JACOBM_BND( BND,LVL )
c                       END DO
c                    ELSE
c                       DO BND = 1, NBNDY
c                          BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL ) * KGPMG
c    &                                        * JACOBM_BND( BND,LVL )
c                       END DO
c                    END IF
c                 END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c251         CONTINUE

c           STRT = N_GC_TRNS + N_AE_TRNS + 1
c           FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS
c           DO 261 VAR = STRT, FINI
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB ( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                 MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                    ELSE   ! found bc's (PPM) on file; convert
c                    DO BND = 1, NBNDY
c                       BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                     * RHOJ_BND( BND,LVL )
c                       END DO
c                    END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c261         CONTINUE

c           STRT = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + 1
c           FINI = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
c           DO 271 VAR = STRT, FINI
c              IF ( ONFILE( VAR ) ) THEN
c                 BBUF = 0.0   ! array assignment
c                 IF ( .NOT. INTERPB ( BNDY_SENS_1, S_BCNAME( VAR,NP ), PNAME,
c    &                                 MDATE, MTIME, NBNDY*NLAYS, BBUF ) ) THEN
c                    XMSG = 'Could not read ' // TRIM( S_BCNAME( VAR,NP ) ) // ' from '
c    &                    // BNDY_SENS_1
c                    CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
c                 ELSE   ! found bc's (PPM) on file; convert
c                    DO BND = 1, NBNDY
c                       BSEN( BND,VAR,NP ) = BCFAC( VAR ) * BBUF( BND,LVL )
c    &                                     * RHOJ_BND( BND,LVL )
c                    END DO
c                 END IF
c              ELSE
c                 DO BND = 1, NBNDY
c                    BSEN( BND,VAR,NP ) = 0.0
c                 END DO
c              END IF
c271         CONTINUE

c           DO BND = 1, NBNDY
c              BSEN( BND,N_SPC_ADV,NP ) = 0.0
c           END DO

c        END DO
c     ENDIF
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C=======================================================================
      SUBROUTINE PA_MKHDR ( TYPE, NFL, OUTFNAME, SDATE, STIME, TSTEP )

C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   16 Sep 16 J.Young: update for inline procan

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE PAGRD_DEFN            ! PA horiz domain specs

      IMPLICIT NONE

C used in pa_init
C FIRSTIME gets some FDESC3 common variables from GRID_CONF to be used
C for both IPR and IRR if needed.

C Arguments:
      CHARACTER( 3 ) ::  TYPE   ! IPR or IRR
      INTEGER NFL               ! file sequence no.
      CHARACTER( 16 ) :: OUTFNAME  ! Assigned IPR or IRR output file name
      INTEGER SDATE             ! starting date,    format YYYYDDD
      INTEGER STIME             ! starting time,    format HHMMSS
      INTEGER TSTEP( 3 )        ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C Local Variables:
      INTEGER AE_INDX   ! Index for aerosol species
      INTEGER IPRSPC    ! Index for IPR species
      INTEGER PL        ! Index for PA output level
      INTEGER VARINDX   ! Index for output variable
      INTEGER L, NOUT   ! Loop indicies
      INTEGER NSP, NPR  ! Loop indices for finding IPR species
      INTEGER ICG       ! species pointer

      CHARACTER( 16 ) ::  PNAME = 'PA_MKHDR'  ! Subroutine Name

C-----------------------------------------------------------------------

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Get file header description from GRID_CONF and reconfigure output domain
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD
      P_GAM3D = P_GAM_GD

      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD

      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD

      FTYPE3D = GRDDED3
      GDNAM3D = GDNAME_GD
      UPNAM3D = PNAME
!     EXECN3D = '????????'
!     UPDSC3D =

      SDATE3D = SDATE
      STIME3D = STIME
      CALL NEXTIME( SDATE3D, STIME3D, TSTEP( 1 ) )
      TSTEP3D = TSTEP( 1 )

      NCOLS3D = PACOLS
      NROWS3D = PAROWS
      NLAYS3D = PALEVS

      XORIG3D = XORIG3D + DBLE( PA_BEGCOL - 1 ) * XCELL3D
      YORIG3D = YORIG3D + DBLE( PA_BEGROW - 1 ) * YCELL3D

      DO L = PA_BEGLEV, PA_ENDLEV + 1
         PL = L - PA_BEGLEV + 1
         VGLVS3D ( PL ) = VGLVS_GD( L )
      END DO

      IF ( TYPE .EQ. 'IPR' ) THEN

         FDESC3D( 1 ) = 'Integrated Process Rates Output File ' // OUTFNAME
         NVARS3D = MIN( MXVARS3 , ( NIPRVAR - ( NFL - 1 ) * MXVARS3 ) )

         DO NOUT = 1, NVARS3D
            VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT
            VNAME3D( NOUT ) = IPRNAME( VARINDX )
            VTYPE3D( NOUT ) = M3REAL

C..Find the IPR species to set correct units descriptor
            DO NSP = 1, N_IPR_SPC
               DO NPR = 1, NPRCS
                  IF ( VARINDX .EQ. IPROUT( NSP, NPR ) ) THEN
                     IPRSPC = NSP
                     EXIT
                  END IF
               END DO
            END DO

            ICG = IPR2GRD( IPRSPC, 1 )
            UNITS3D( NOUT ) = 'ppmV'

            IF ( ICG .GE. AE_STRT .AND. ICG .LT. NR_STRT ) THEN
               AE_INDX = ICG - AE_STRT + 1
               IF ( AE_SPC( AE_INDX ) ( 1 : 3 ) .EQ. 'NUM' ) THEN
                  UNITS3D( NOUT ) = 'm-3'
               ELSE IF ( AE_SPC( AE_INDX ) ( 1 : 3 ) .EQ. 'SRF' ) THEN
                  UNITS3D( NOUT ) = 'm2 m-3'
               ELSE
                  UNITS3D( NOUT ) = 'ug m-3'
               END IF
            END IF

               VDESC3D( NOUT ) = IPRDESC( VARINDX )
         END DO

      ELSE IF ( TYPE .EQ. 'IRR' ) THEN

         FDESC3D( 1 ) = 'Integrated Reaction Rate Output File ' // OUTFNAME
         NVARS3D = MIN( MXVARS3 , ( NIRRVAR - ( ( NFL - 1 ) * MXVARS3 ) ) )

         DO NOUT = 1, NVARS3D
            VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT
            VNAME3D( NOUT ) = IRRNAME( VARINDX )
            VTYPE3D( NOUT ) = M3REAL
            UNITS3D( NOUT ) = 'ppmV'
            VDESC3D( NOUT ) = IRRDESC( VARINDX )
         END DO

      ELSE

         CALL M3EXIT( PNAME, SDATE, STIME,
     &        'Incorrect process analysis type specified', 2 )

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE VDIFF ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Asymmetric Convective Model v2 (ACM2) -- Pleim(2006)
C Function:
C   calculates and writes dry deposition.
C   calculates vertical diffusion

C Subroutines and Functions Called:
C   SEC2TIME, TIME2SEC, WRITE3, NEXTIME,
C   M3EXIT, EDDYX, TRI, MATRIX, PA_UPDATE_EMIS, PA_UPDATE_DDEP

C Revision History:
C   Analogous to VDIFFIM (Eddy diffusion PBL scheme)

C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module (GRID_CONF)
C    7 Jun 05 P.Bhave: added call to OPSSEMIS if MECHNAME='AE4';
C                      added TSTEP to RDEMIS_AE call vector
C    Aug 05 J. Pleim Update to v4.5
C
C    Jan 06 J. Pleim ACM2 implementation
C    Jul 06 J.Young: emis module
C    Nov 06 B.Hutzell, J.Young: depv module
C    Mar 08 G.Sarwar: added heterogeneous reaction for HONO. It affects HONO, NO2 and HNO3
C    Apr 08 J.Young: optional inline beis and plume rise emissions
C 21 Jun 10 J.Young: convert for Namelist redesign
C 16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C 10 May 11 J.Bash: updated for NH3 bidirectional exchange
C 11 May 11 D.Wong: - incorporated twoway model implementation
C 20 May 11 D.Schwede: modified to include mosaic
C 15 Aug 11 D.Schwede and G. Sarwar: Modified HONO calculation so that deposition
C           velocity for NO2 that is output in DEPV file does not include the loss due
C           to the heterogeneous reaction.
C           This additional loss is now accounted for in vdiff.F
C 14 Sep 11 J.Young: fix TSTEP bug in call to DEPV_INIT
C 11 Apr 13 J.Young: fix double adjustment of conc for DDBF in heterogeneous HONO
C           if-then-else clauses; eliminate some white space
C 13 May 13 J.Young: access met data from VDIFF_MET module
C                    change CRANKP to THBAR, CRANKQ to THETA
C 25 May 13 J.Young: re-do the acm/eddy algorithm for computational efficiency
C 30 Apr 14 J.Young: switch THBAR and THETA
C  2 May 14 J.Pleim, J.Young: replace the banded tridiagonal matrix solver for the
C           convective PBL, with the ACM1 matrix solver followed by the tridiagonal
C           matrix solver
C 30 May 14 J.Young: split vdiff calculation out of vdiff proc.
C 31 Jul 14 J.Young: incorporate gravitational settling for J-,K-mode aerosols
C 07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C 03 Jul 15 J.Young: put sedi stuff into a module
C 13 Aug 15 J.Bash: updated for MP model
C 15 Aug 15 D.Wong: - Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O 
C                     implementation
C                   - Added a block of code to allow non I/O processors
C                     to open CTM_DRY_DEP_1, CTM_VSED_DIAG, CTM_VDIFF_DIAG,
C                     CTM_DRY_DEP_MOS, and CTM_DRY_DEP_FST
C 03 Mar 16 G.Sarwar: updated for halogen emissions
C 16 Sep 16 J.Young: update for inline procan (IPR)
C 02 Nov 2018: L.Zhou, S.Napelenok: isam implementation
C  1 Feb 19 D.Wong: removed all MY_N clauses
C 12 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE CGRID_SPCS          ! CGRID mechanism species
      USE GRID_CONF
      USE EMIS_VARS, ONLY : VDEMIS_DIFF, EMLAYS
      USE EMIS_DEFN, ONLY : EMIS_INIT, GET_EMIS
      USE DEPV_DEFN
      USE ASX_DATA_MOD
!      USE MPAS_DATA_MOD
      USE VDIFF_MAP
      USE UTILIO_DEFN
      USE BIDI_MOD
      USE HGSIM
!      USE LSM_MOD, Only: n_lufrac
      USE SEDIMENTATION
      USE VDIFF_DIAG
      USE PA_DEFN, Only: LIPR ! Process Anaylsis control and data variables

#ifdef isam
      USE SA_DEFN, Only: ITAG, N_SPCTAG, VNAM_SPCTAG, SA_DDEP, SA_BIDI, ISAM, NTAG_SA, 
     &                   VNAM_SPCTAG, NSPC_SA, SPC_NAME, OTHRTAG
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: NP, NPMAX, SENGRID, SPCNAME, S_DDEP, SNGRD, SENGRID_TEMP, SEN_PAR
#endif 

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' '

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )              !  concentrations
      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP( 3 )   ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C Parameters:

C External Functions: None

C Local Variables: 
      CHARACTER( 16 ), SAVE :: PNAME = 'VDIFFPROC'
      CHARACTER( 80 ) :: VARDESC                ! env variable description
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: WRITE_FIRSTIME = .TRUE.
      INTEGER, SAVE :: WSTEP  = 0               ! local write counter
      INTEGER  STATUS                           ! ENV... status

      REAL             FCMSF                         ! loop local RMSFX4( C,R )

      REAL, ALLOCATABLE, SAVE :: CNGRD( :,:,:,: )    ! cgrid aero in mixing ratio
      REAL, ALLOCATABLE, SAVE :: DDEP     ( :,:,: )   ! ddep accumulator
      REAL, ALLOCATABLE, SAVE :: ICMP     ( :,:,: )   ! component flux accumlator 
      REAL     :: WRDD( NCOLS,NROWS )                 ! ddep write buffer

      REAL, ALLOCATABLE, SAVE :: DDEP_PA  ( :,:,: )   ! ddep for process analysis
      REAL, ALLOCATABLE, SAVE :: EMIS_PA( :,:,:,: )   ! emis for process analysis

      INTEGER, SAVE :: N_SPC_CGRID              ! no. of CGRID species

      REAL     :: EDDYV ( NCOLS,NROWS,NLAYS )   ! from EDYINTB
      REAL     :: SEDDY ( NLAYS,NCOLS,NROWS )   ! flipped EDDYV
      REAL        DTSEC                         ! model time step in seconds

      REAL     :: NH3_FLUX( NCOLS,NROWS )

      REAL, ALLOCATABLE, SAVE :: VSED_AE( :,:,:,: )
      INTEGER, SAVE :: NH3_HIT

C Local Variables
      INTEGER     ASTAT
      INTEGER     C, R, L, S, V, I, J, OFF      ! loop induction variables
      INTEGER     MDATE, MTIME, MSTEP           ! internal simulation date&time
      CHARACTER(LEN=8), PARAMETER :: NAME_NH3_EMIS = 'NH3_Emis'
      CHARACTER(LEN=8), PARAMETER :: NAME_NH3_FLUX = 'NH3_Flux'

#ifdef isam
      REAL NH3_SUM
      REAL, ALLOCATABLE, SAVE :: NH3_TAG_FRACTION( : )
      INTEGER :: NH3_ISAM_IDX = 0
      INTEGER, ALLOCATABLE, SAVE :: ISAM_DEPV( : )
      INTEGER IBGN, JTAG
      CHARACTER( 16 ) :: ISAM_SPECIES

      INTEGER, SAVE :: NH3_DV2DF_SPC_IDX = 0

#endif

      INTERFACE
         SUBROUTINE PA_UPDATE_EMIS ( PNAME, VDEMIS_DIFF, JDATE, JTIME, TSTEP )
            CHARACTER( * ), INTENT( IN )  :: PNAME
            REAL,           INTENT( IN )  :: VDEMIS_DIFF( :,:,:,: )
            INTEGER,        INTENT( IN )  :: JDATE, JTIME
            INTEGER,        INTENT( IN )  :: TSTEP( 3 )
         END SUBROUTINE PA_UPDATE_EMIS
         SUBROUTINE PA_UPDATE_DDEP ( PNAME, DDEP, JDATE, JTIME, TSTEP )
            CHARACTER( * ), INTENT( IN )  :: PNAME
            REAL,           INTENT( IN )  :: DDEP( :,:,: )
            INTEGER,        INTENT( IN )  :: JDATE, JTIME
            INTEGER,        INTENT( IN )  :: TSTEP( 3 )
         END SUBROUTINE PA_UPDATE_DDEP
         SUBROUTINE CONV_CGRID ( CGRID, JDATE, JTIME, CNGRD )
            REAL, POINTER :: CGRID( :,:,:,: )
            INTEGER,        INTENT( IN )  :: JDATE, JTIME
            REAL,           INTENT( INOUT ) :: CNGRD( :,:,:,: )
         END SUBROUTINE CONV_CGRID
         SUBROUTINE REV_CGRID ( CNGRD, JDATE, JTIME, CGRID )
            REAL,           INTENT( INOUT ) :: CNGRD( :,:,:,: )
            INTEGER,        INTENT( IN )  :: JDATE, JTIME
            REAL, POINTER :: CGRID( :,:,:,: )
         END SUBROUTINE REV_CGRID
         SUBROUTINE EDDYX ( EDDYV )
            REAL,           INTENT( OUT ) :: EDDYV( :,:,: )
         END SUBROUTINE EDDYX
         SUBROUTINE VDIFFACMX( dtsec, seddy, ddep, icmp, cngrd)
            REAL, INTENT( IN )    :: dtsec
            REAL, INTENT( INOUT ) :: seddy( :,:,: )
            REAL, INTENT( INOUT ) :: ddep ( :,:,: )
            REAL, INTENT( INOUT ) :: icmp ( :,:,: )
            REAL, INTENT( INOUT ) :: cngrd( :,:,:,: )
         END SUBROUTINE VDIFFACMX
#ifdef isam
         SUBROUTINE SA_OPWDDEP ( SADEPFILE, JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            CHARACTER( 16 ) SADEPFILE ! Dry or wet dep file for tags
            INTEGER      JDATE      ! current model date, coded YYYYDDD
            INTEGER      JTIME      ! current model time, coded HHMMSS
            INTEGER      TSTEP      ! output time step
         END SUBROUTINE SA_OPWDDEP
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         CALL LOG_HEADING( LOGDEV, "Initialize Surface Exchange Module" )

         IF ( .NOT. DEPV_INIT ( JDATE, JTIME, TSTEP, CGRID ) ) THEN
            XMSG = 'Failure initializing deposition velocities module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C create global maps
         IF ( .NOT. VDIFF_MAP_INIT( ) ) THEN
            XMSG = 'Failure initializing index mapping module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize the met data
         CALL INIT_MET( JDATE, JTIME )

        IF ( HGBIDI ) THEN ! Initialize HGSIM module
           CALL INIT_HGSIM(JDATE, JTIME)
        END IF

C Set output file characteristics based on COORD.EXT and open the dry dep file
         IF ( IO_PE_INCLUSIVE ) THEN
            CALL OPDDEP ( JDATE, JTIME, TSTEP( 1 ), N_SPC_DDEP )
#ifdef isam
            CALL SA_OPWDDEP ( SA_DD_1, JDATE, JTIME,TSTEP( 1 ) )
#endif
            IF ( ABFLUX .OR. HGBIDI ) CALL OPASX_MEDIA( JDATE, JTIME, TSTEP( 1 ) )
         END IF

C Open vdiff diagnostics file (ioapi header from cgrd)
         IF ( VDIFFDIAG ) THEN
            IF ( .NOT. VDIFF_DIAG_INIT ( JDATE, JTIME, TSTEP( 1 ), GRAV_SETL ) ) THEN
               XMSG = 'Failure initializing vdiff diagnostics module'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

C Allocate and initialize dry deposition array

         ALLOCATE ( DDEP( N_SPC_DEPV,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DDEP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         DDEP = 0.0   ! array assignment
 
         ALLOCATE ( ICMP( LCMP,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ICMP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         ICMP = 0.0   ! array assignment

         CALL LOG_HEADING( LOGDEV, "Initialize Emissions Module" )

C Allocate and initialize emissions
         IF ( .NOT. EMIS_INIT ( JDATE, JTIME, TSTEP( 1 ) ) ) THEN
            XMSG = 'Failure initializing emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( SA_DDEP( NCOLS,NROWS,N_SPCTAG ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SA_DDEP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         SA_DDEP = 0.0
#endif

C Set up for process analysis
         IF ( LIPR ) THEN
            CALL LOG_HEADING( LOGDEV, "Initialize Surface Exchange for Process Analysis" )

            ALLOCATE ( EMIS_PA( NCOLS,NROWS,EMLAYS,N_SPC_DIFF ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'EMIS_PA memory allocation failed'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( DDEP_PA( NCOLS,NROWS,N_SPC_DEPV ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'DDEP_PA memory allocation failed'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

C Set up for grav. settling
         IF ( GRAV_SETL ) THEN
            CALL LOG_HEADING( LOGDEV, "Set Up Gravitational Settling" )

            ALLOCATE ( VSED_AE( N_AE_SPC,NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating VSED_AE'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         N_SPC_CGRID = SIZE ( CGRID,4 )

         ALLOCATE ( CNGRD( N_SPC_CGRID,NLAYS,NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CNGRD'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         CNGRD = 0.0   ! array assignment
 
         NH3_HIT = 0
         DO V = 1, N_SPC_DDEP
            IF ( DDEP_SPC( V ) .EQ. 'NH3' ) NH3_HIT = V
         END DO

#ifdef sens
         ALLOCATE ( S_DDEP( N_SPC_DEPV,NCOLS,NROWS,NPMAX ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_DDEP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         S_DDEP = 0.0

         ALLOCATE ( SNGRD( N_SPC_CGRID,NLAYS,NCOLS,NROWS,NPMAX ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SNGRD'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         SNGRD = 0.0
#endif

#ifdef isam
        IF ( SA_BIDI ) THEN
          NH3_ISAM_IDX  = INDEX1( 'NH3', NSPC_SA, SPC_NAME(:,OTHRTAG) )
          ALLOCATE ( ISAM_DEPV( N_SPCTAG ), 
     &               NH3_TAG_FRACTION( NTAG_SA ), STAT = ASTAT )
          IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure Allocating ISAM variables in VDIFF'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF
          ISAM_DEPV     = 0
          DO ITAG = 1, N_SPCTAG
            DO V = 1, N_SPC_DEPV
              IBGN         = INDEX( VNAM_SPCTAG( ITAG ), '_', .FALSE. ) - 1
              ISAM_SPECIES = VNAM_SPCTAG( ITAG )( 1:IBGN )
              IF ( TRIM( ISAM_SPECIES ) .EQ. DV2DF_SPC( V ) ) THEN
                ISAM_DEPV( ITAG ) = V
              END IF
            END DO
          END DO

          DO V = 1, N_SPC_DEPV
            IF ( DV2DF_SPC( V ) .EQ.'NH3' ) THEN
              NH3_DV2DF_SPC_IDX = V
            ENDIF
          END DO
        ENDIF
#endif

      END IF   !  if Firstime

      MDATE = JDATE
      MTIME = JTIME
      MSTEP = TIME2SEC( TSTEP( 2 ) )
      DTSEC = FLOAT( MSTEP )
      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( MSTEP / 2 ) )

C Convert non-molar mixing ratio species and re-order CGRID
      CALL CONV_CGRID ( CGRID, MDATE, MTIME, CNGRD )

#ifdef sens
      DO NP = 1, NPMAX
         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DO S = 1, N_SPC_CGRID
                     SENGRID_TEMP( C,R,L,S ) = SENGRID( C,R,L,NP,S )
                  END DO
               END DO
            END DO
         END DO
         CALL CONV_CGRID ( SENGRID_TEMP,MDATE, MTIME, SNGRD(:,:,:,:,NP) )
      END DO
#endif

C read & interpolate met data
      CALL GET_MET ( MDATE, MTIME, MSTEP )

C read & interpolate deposition velocities
      CALL GET_DEPV ( MDATE, MTIME, TSTEP, CGRID )      

      IF ( GRAV_SETL ) THEN
C Get gravitational settling velocity for the vsed aero species:
C AERO_SEDV assumes that every aero species is dry deposited and is diffused (trns)
C Calculate the changes in the layer J-,K-mode aerosol concentrations
         CALL SEDI( MDATE, MTIME, DTSEC, VSED_AE, CGRID, CNGRD )
      END IF

C read & interpolate emissions data => VDEMIS_DIFF from EMIS_DEFN module
      CALL GET_EMIS ( MDATE, MTIME, TSTEP, CGRID )

      IF ( LIPR ) THEN
         DO S = 1, N_SPC_DIFF
            DO L = 1, EMLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     EMIS_PA( C,R,L,S ) = VDEMIS_DIFF( S,L,C,R )
                  END DO
               END DO
            END DO
         END DO
         CALL PA_UPDATE_EMIS ( 'VDIF', EMIS_PA, JDATE, JTIME, TSTEP )
      END IF

      CALL EDDYX ( EDDYV )

C EDDYV returned = Kz, where Kz is in m**2/sec

      DO R = 1, NROWS
         DO C = 1, NCOLS
!            FCMSF = Grid_Data%RMSFX4( C,R )
            DO L = 1, NLAYS
               SEDDY( L,C,R ) = EDDYV( C,R,L )
            END DO
         END DO
      END DO

      IF ( WSTEP .EQ. 0 ) THEN
         DDEP = 0.0                      ! array assignment
         ICMP = 0.0                      ! array assignment
#ifdef sens
         S_DDEP = 0.0
#endif
      END IF

C Calculate the change in concentration and dry dep from vertical diffusion and vsed
C Note: cngrd is the argument keyword (from the INTERFACE); CNGRD is the actual argument

      CALL VDIFFACMX( DTSEC, SEDDY, DDEP, ICMP, CNGRD )

      IF ( VDIFFDIAG ) THEN
         NTICS = NTICS + 1
         NLPCR_SUM = NLPCR_SUM + NLPCR_MEAN    ! array assignment
         DO R = 1, NROWS
            DO C = 1, NCOLS
               NLPCR_MAX( C,R ) = MAX( NLPCR_MEAN( C,R ), NLPCR_MAX( C,R ) )
               NLPCR_MIN( C,R ) = MIN( NLPCR_MEAN( C,R ), NLPCR_MIN( C,R ) )
            END DO
         END DO
         IF ( GRAV_SETL ) THEN
            DTCCR_SUM = DTCCR_SUM + DTCCR_MEAN    ! array assignment
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DTCCR_MAX( C,R ) = MAX( DTCCR_MEAN( C,R ), DTCCR_MAX( C,R ) )
                  DTCCR_MIN( C,R ) = MIN( DTCCR_MEAN( C,R ), DTCCR_MIN( C,R ) )
               END DO
            END DO
         END IF
      END IF

C Revert non-molar mixing ratio species and re-order CGRID
      CALL REV_CGRID ( CNGRD, MDATE, MTIME, CGRID )

#ifdef sens
      DO NP = 1, NPMAX
         CALL REV_CGRID ( SNGRD(:,:,:,:,NP), MDATE, MTIME, SENGRID_TEMP )
         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DO S = 1, N_SPC_CGRID
                     SENGRID( C,R,L,NP,S ) = SENGRID_TEMP( C,R,L,S )
                  END DO
               END DO
            END DO
         END DO
      END DO
#endif

C If last call this hour:  write accumulated depositions:

      WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
      IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
         MDATE = JDATE
         MTIME = JTIME
         CALL NEXTIME( MDATE, MTIME, TSTEP( 2 ) )
         WSTEP = 0

#ifdef parallel_io
         IF ( WRITE_FIRSTIME ) THEN
            WRITE_FIRSTIME = .FALSE.

            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSREAD3, PNAME ) ) THEN
                  XMSG = 'Could not open ' // TRIM(CTM_DRY_DEP_1)
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

#ifdef sens
               IF ( .NOT. OPEN3( CTM_SDRYDEP_1, FSNONIO, PNAME ) ) THEN
                  XMSG = 'Could not open ' // TRIM(CTM_SDRYDEP_1`)
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
#endif 

            END IF   ! .NOT. IO_PE_INCLUSIVE
         END IF
#endif
         IF ( ABFLUX ) THEN
           DO R = 1, NROWS
               DO C = 1, NCOLS
                  NH3_FLUX(C,R) = DDEP( DD2DV(NH3_HIT),C,R )
                  DDEP( DD2DV(NH3_HIT),C,R ) = NH3_EMIS(C,R)+NH3_FLUX(C,R)
               END DO
            END DO
#ifdef isam
            IF ( SA_BIDI ) THEN
              DO R = 1, NROWS
                DO C = 1, NCOLS
                  NH3_SUM = 0.0
                  DO ITAG = 1, NTAG_SA
                    NH3_SUM = NH3_SUM + ISAM( C,R,1,NH3_ISAM_IDX,ITAG )
                  END DO
                  IF ( NH3_SUM .GT. 1.0E-25 ) THEN
                    DO ITAG = 1, NTAG_SA
                      NH3_TAG_FRACTION( ITAG ) = ISAM( C,R,1,NH3_ISAM_IDX,ITAG ) / NH3_SUM
                    END DO
                  ELSE
                    NH3_TAG_FRACTION = 0.0
                  END IF
 
                  JTAG = 0 
                  DO ITAG = 1, N_SPCTAG
                    V = ISAM_DEPV( ITAG )
                    IF ( V .EQ. NH3_DV2DF_SPC_IDX ) THEN
                      JTAG = JTAG + 1
                      SA_DDEP( C,R,ITAG ) = SA_DDEP( C,R,ITAG ) + NH3_TAG_FRACTION( JTAG ) * NH3_EMIS(C,R)
                    END IF
                  END DO
                END DO
              END DO
            END IF
#endif
         ENDIF
         DO V = 1, N_SPC_DDEP
            S = DD2DV( V )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  WRDD( C,R ) = DDEP( S,C,R )
               END DO
            END DO

            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, DDEP_SPC( V ),
     &                 MDATE, MTIME, WRDD ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
         END DO 
C Write extra arrays for NH3 emission and net flux for bidi
         IF ( ABFLUX ) THEN

            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, NAME_NH3_FLUX,
     &                 MDATE, MTIME, NH3_FLUX ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. WRITE3( CTM_DRY_DEP_1, NAME_NH3_EMIS,
     &                 MDATE, MTIME, NH3_EMIS ) ) THEN
               XMSG = 'Could not write ' // CTM_DRY_DEP_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
! must ensure the col/row being written to log is not larger than 
! the subdomain size for this PE. 
!          WRITE( LOGDEV,*) ' NH3emis, drydep, flux=',NH3_EMIS(27,18),
!    &                     DDEP_NH3(27,18),DDEP( DD2DV(NH3_HIT),27,18)
         NH3_EMIS = 0.0
         END IF

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_DRY_DEP_1,
     &         'for date and time', MDATE, MTIME
         
C Write vdiff diagnostics
         IF ( VDIFFDIAG ) THEN
            IF ( GRAV_SETL ) THEN   ! Write vsed diagnostics

               DO V = 1, N_VSED
                  S = VSED_MAP( V )
                  DO L = 1, NLAYS
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           VSED_BUF( C,R,L,V ) = VSED_AE( S,L,C,R )
                        END DO
                     END DO
                  END DO
                  IF ( .NOT. WRITE3( CTM_VSED_DIAG, VSED_NAME( V ),
     &                               MDATE, MTIME, VSED_BUF( 1,1,1,V ) ) ) THEN
                     XMSG = 'Could not write ' // TRIM( VSED_NAME( V ) )
     &                    // ' to ' // CTM_VSED_DIAG
                     CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                  END IF
               END DO

               WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &               'Timestep written to', CTM_VSED_DIAG,
     &               'for date and time', MDATE, MTIME

            END IF   ! GRAV_SETL

C Write other diagnostics
            NLPCR_MEAN = NLPCR_SUM / FLOAT( NTICS )
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'NLP_MEAN',
     &                         MDATE, MTIME, NLPCR_MEAN ) ) THEN
               XMSG = 'Could not write ' //  'NLP_MEAN to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'NLP_MAX',
     &                         MDATE, MTIME, NLPCR_MAX ) ) THEN
               XMSG = 'Could not write ' //  'NLP_MAX to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'NLP_MIN',
     &                         MDATE, MTIME, NLPCR_MIN ) ) THEN
               XMSG = 'Could not write ' //  'NLP_MIN to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
            NLPCR_MAX = 0.0      ! array assignment
            NLPCR_MIN = 9.9E30   ! array assignment
            NLPCR_SUM = 0.0      ! array assignment

            IF ( GRAV_SETL ) THEN   ! Write vsed diagnostics
               DTCCR_MEAN = DTCCR_SUM / FLOAT( NTICS )
               IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'SEDI_DTC_MEAN',
     &                            MDATE, MTIME, DTCCR_MEAN ) ) THEN
                  XMSG = 'Could not write ' //  'SEDI_DTC_MEAN to ' // CTM_VDIFF_DIAG
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF
               IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'SEDI_DTC_MAX',
     &                            MDATE, MTIME, DTCCR_MAX ) ) THEN
                  XMSG = 'Could not write ' //  'SEDI_DTC_MAX to ' // CTM_VDIFF_DIAG
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF
               IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'SEDI_DTC_MIN',
     &                            MDATE, MTIME, DTCCR_MIN ) ) THEN
                  XMSG = 'Could not write ' //  'SEDI_DTC_MIN to ' // CTM_VDIFF_DIAG
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF
               DTCCR_MAX = 0.0      ! array assignment
               DTCCR_MIN = 9.9E30   ! array assignment
               DTCCR_SUM = 0.0      ! array assignment
            END IF

            CNVCT = 0.0   ! array assignment
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( Met_Data%CONVCT( C,R ) ) CNVCT( C,R ) = 1.0
               END DO
            END DO
            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'CONVCT',
     &                         MDATE, MTIME, CNVCT ) ) THEN
               XMSG = 'Could not write ' //  'convct to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

            IF ( .NOT. WRITE3( CTM_VDIFF_DIAG, 'LPBL',
     &                         MDATE, MTIME, REAL( Met_Data%LPBL ) ) ) THEN
               XMSG = 'Could not write ' //  'lpbl to ' // CTM_VDIFF_DIAG
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6, I6 )' )
     &            'Timestep written to', CTM_VDIFF_DIAG,
     &            'for date and time (and ntics)', MDATE, MTIME, NTICS
            NTICS = 0

         END IF
         
         IF ( ABFLUX .OR. HGBIDI ) THEN    
            CALL WRASX_MEDIA( MDATE, MTIME )
         END IF 

         IF ( LIPR ) THEN
            DO V = 1, N_SPC_DEPV
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     DDEP_PA( C,R,V ) = DDEP( V,C,R )
                  END DO
               END DO
            END DO
            CALL PA_UPDATE_DDEP ( 'VDIF', DDEP_PA, JDATE, JTIME, TSTEP )
         END IF

#ifdef isam
         WRDD = 0.0
         DO ITAG = 1, N_SPCTAG
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  WRDD( C,R ) = SA_DDEP( C,R,ITAG )
               END DO
            END DO

            IF ( .NOT. WRITE3( SA_DD_1, VNAM_SPCTAG( ITAG ),
     &                         MDATE, MTIME, WRDD ) ) THEN
               XMSG = 'Could not write ' // SA_DD_1 // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
         END DO
         SA_DDEP = 0.0
#endif

C re-set dry deposition array to zero

         DDEP = 0.0
         ICMP = 0.0

#ifdef sens
C WT - write out dry deposition sensitivities
         DO V = 1, N_SPC_DDEP
            S = DD2DV( V )
            SPCNAME = DDEP_SPC( V )( 1:12 )                       ! <- these lines have to
            DO NP = 1, NPMAX
               SPCNAME = TRIM( SPCNAME ) //'_' // SEN_PAR( NP )   ! <- match what is in opddep.F
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     WRDD( C,R ) = S_DDEP( S, C, R, NP )
                  ENDDO
               ENDDO

               IF ( .NOT. WRITE3( CTM_SDRYDEP_1, SPCNAME,
     &                 MDATE, MTIME, WRDD ) ) THEN
                  XMSG = 'Could not write ' // CTM_SDRYDEP_1 // ' file'
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF

            ENDDO
         ENDDO
         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_SDRYDEP_1,
     &         'for date and time', MDATE, MTIME

         S_DDEP = 0.0
#endif

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE SSEMIS
C-----------------------------------------------------------------------
C Description:

C Revision History:
C   04 Apr 11 S.Howard: generalization to accomodate different sea-salt speciation
C                       in aero5 and aero6
C   07 Apr 11 J.Young: additional mods
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module.
C   12 Aug 15 D.Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
C   09 Dec 15 D.Wong: Open CTM_SSEMIS_1 file in a IO_PE_INCLUSIVE conditional block
C   24 Mar 16 G.Sarwar: updated to calculate NACL emissions (needed for BR2 emissions) 
C   16 Aug 18 G. Sarwar: Removed NACL
C    1 Feb 19 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN
      USE AERO_DATA, ONLY: N_MODE
      USE EMIS_VARS

      IMPLICIT NONE

C Number of chemical species in fresh sea-salt aerosol
      INTEGER :: NSSSPC

C Sea-Salt Emissions Rates
      PUBLIC NSSSPC, SSEMIS_INIT, GET_SSEMIS, SEA_FACTNUM, SEA_FACTSRF, SSOUTM
      PRIVATE

C Position of H2O in sea-salt emission arrays
      INTEGER :: KH2O

C Variables for the sea-salt diagnostic file
      INTEGER :: NSSDIAG                ! number of species in sea-salt
                                        ! diagnostic emission file
      Real,    ALLOCATABLE, SAVE :: SSOUTM( :,:,: )  ! SeaSpray Mass Emiss Rate [ug/m3/s]
      Real,    ALLOCATABLE, SAVE :: SSOUTN( :,:,: )  ! SeaSpray Number Emiss Rate [1/m3/s]
      Real,    ALLOCATABLE, SAVE :: SSOUTS( :,:,: )  ! SeaSpray Surface Area Emiss Rate [m2/m3/s]
      REAL,    ALLOCATABLE       :: SSOUTD( : )   ! emission rates
      REAL,    ALLOCATABLE, SAVE :: SSBF( :,:,: ) ! seasalt emiss accumulator
      REAL,    ALLOCATABLE, SAVE :: WRSS( :,: )   ! seasalt emiss write buffer
      REAL,    ALLOCATABLE, SAVE :: SEA_FACTNUM( :,:,: ) ! Array for scaling Number Emissions
      REAL,    ALLOCATABLE, SAVE :: SEA_FACTSRF( :,:,: ) ! Array for scaling Surface Area Emissions 

C Species names in the speciated sea-salt-emissions
      CHARACTER( 16 ), ALLOCATABLE :: WRSS_SPC( : )  ! species names

C Lognormal parameters fit to the open-ocean flux function
      REAL,    SAVE :: DGNJ( 136 )     ! geom mean diam of accum-mode [um]
      REAL,    SAVE :: DGNK( 136 )     ! geom mean diam of coarse-mode [um]
      REAL,    SAVE :: SIGJ( 136 )     ! geom std deviation of accum-mode flux
      REAL,    SAVE :: SIGK( 136 )     ! geom std deviation of coarse-mode flux
      REAL,    SAVE :: FNJ ( 136 )     ! magnitude of accum-mode flux [1/m2/s]
      REAL,    SAVE :: FNK ( 136 )     ! magnitude of coarse-mode flux [1/m2/s]

C Open-ocean flux numerically integrated over size range of interest
      REAL,    SAVE :: VFLUX( 136 )    ! total particle volume flux [m3/m2/s]

C Polycoeffs from Zhang et al. (2005)
      REAL( 8 ), SAVE :: C0_COEFF( 6 )   ! Eq 8
      REAL( 8 ), SAVE :: X_COEFF( 6 )    ! Eq 1

      INTEGER I

C-------------------------- Data Statements ----------------------------

C RH-dependent values calculated using MATLAB for THETA = 8 from Gong (2003)

C Geometric mean diameter of accumulation mode [um]
      DATA ( DGNJ( I ), I = 1, 136 ) /
     &      0.0913, 0.0917, 0.0921, 0.0925, 0.0929, 0.0933, 0.0938, 0.0942,
     &      0.0946, 0.0951, 0.0956, 0.0961, 0.0967, 0.0972, 0.0977, 0.0984,
     &      0.0990, 0.0996, 0.1002, 0.1010, 0.1017, 0.1024, 0.1032, 0.1040,
     &      0.1048, 0.1058, 0.1067, 0.1077, 0.1087, 0.1098, 0.1110, 0.1123,
     &      0.1136, 0.1150, 0.1165, 0.1181, 0.1198, 0.1217, 0.1237, 0.1259,
     &      0.1283, 0.1309, 0.1338, 0.1371, 0.1407, 0.1448, 0.1453, 0.1457,
     &      0.1462, 0.1466, 0.1471, 0.1476, 0.1481, 0.1486, 0.1491, 0.1496,
     &      0.1501, 0.1506, 0.1511, 0.1517, 0.1522, 0.1528, 0.1533, 0.1539,
     &      0.1545, 0.1551, 0.1557, 0.1563, 0.1570, 0.1576, 0.1582, 0.1589,
     &      0.1596, 0.1603, 0.1610, 0.1617, 0.1624, 0.1631, 0.1639, 0.1647,
     &      0.1655, 0.1663, 0.1671, 0.1679, 0.1688, 0.1697, 0.1706, 0.1715,
     &      0.1724, 0.1734, 0.1744, 0.1754, 0.1764, 0.1775, 0.1786, 0.1797,
     &      0.1809, 0.1821, 0.1833, 0.1845, 0.1858, 0.1872, 0.1885, 0.1899,
     &      0.1914, 0.1929, 0.1945, 0.1961, 0.1978, 0.1995, 0.2013, 0.2032,
     &      0.2052, 0.2072, 0.2093, 0.2115, 0.2138, 0.2162, 0.2188, 0.2214,
     &      0.2243, 0.2272, 0.2304, 0.2336, 0.2371, 0.2409, 0.2449, 0.2492,
     &      0.2538, 0.2587, 0.2641, 0.2702, 0.2765, 0.2837, 0.2918, 0.3009 /

C Geometric mean diameter of coarse mode [um]
      DATA ( DGNK( I ), I = 1, 136 ) /
     &      1.7786, 1.8180, 1.8254, 1.8330, 1.8408, 1.8489, 1.8891, 1.8979,
     &      1.9069, 1.9163, 1.9259, 1.9673, 1.9778, 1.9887, 2.0000, 2.0425,
     &      2.0549, 2.0677, 2.0812, 2.1252, 2.1400, 2.1554, 2.2009, 2.2180,
     &      2.2359, 2.2833, 2.3034, 2.3244, 2.3746, 2.3983, 2.4504, 2.4773,
     &      2.5319, 2.5627, 2.6207, 2.6563, 2.7187, 2.7831, 2.8286, 2.9000,
     &      2.9750, 3.0545, 3.1395, 3.2312, 3.3313, 3.4419, 3.4524, 3.4631,
     &      3.4855, 3.4965, 3.5077, 3.5190, 3.5305, 3.5422, 3.5540, 3.5760,
     &      3.5882, 3.6007, 3.6133, 3.6262, 3.6392, 3.6607, 3.6742, 3.6879,
     &      3.7019, 3.7161, 3.7306, 3.7517, 3.7667, 3.7820, 3.7976, 3.8134,
     &      3.8296, 3.8506, 3.8674, 3.8845, 3.9019, 3.9197, 3.9405, 3.9591,
     &      3.9781, 3.9974, 4.0172, 4.0380, 4.0587, 4.0798, 4.1015, 4.1221,
     &      4.1448, 4.1680, 4.1918, 4.2126, 4.2375, 4.2632, 4.2895, 4.3108,
     &      4.3385, 4.3671, 4.3964, 4.4185, 4.4495, 4.4816, 4.5040, 4.5381,
     &      4.5732, 4.5965, 4.6340, 4.6728, 4.6974, 4.7390, 4.7640, 4.8087,
     &      4.8552, 4.8827, 4.9330, 4.9618, 5.0166, 5.0472, 5.1071, 5.1403,
     &      5.2062, 5.2426, 5.3158, 5.3566, 5.3985, 5.4852, 5.5338, 5.5844,
     &      5.6378, 5.6944, 5.7547, 5.8867, 5.8898, 5.9665, 6.0510, 6.1446 /

C Geometric standard deviation of accumulation mode
      DATA ( SIGJ( I ), I = 1, 136 ) /
     &      2.1420, 2.1442, 2.1442, 2.1442, 2.1442, 2.1442, 2.1464, 2.1464,
     &      2.1464, 2.1464, 2.1464, 2.1485, 2.1485, 2.1485, 2.1485, 2.1506,
     &      2.1506, 2.1506, 2.1506, 2.1526, 2.1526, 2.1526, 2.1545, 2.1545,
     &      2.1545, 2.1564, 2.1564, 2.1564, 2.1582, 2.1582, 2.1599, 2.1599,
     &      2.1616, 2.1616, 2.1632, 2.1632, 2.1647, 2.1661, 2.1661, 2.1674,
     &      2.1687, 2.1698, 2.1709, 2.1719, 2.1727, 2.1735, 2.1735, 2.1735,
     &      2.1742, 2.1742, 2.1742, 2.1742, 2.1742, 2.1742, 2.1742, 2.1747,
     &      2.1747, 2.1747, 2.1747, 2.1747, 2.1747, 2.1752, 2.1752, 2.1752,
     &      2.1752, 2.1752, 2.1752, 2.1756, 2.1756, 2.1756, 2.1756, 2.1756,
     &      2.1756, 2.1758, 2.1758, 2.1758, 2.1758, 2.1758, 2.1760, 2.1760,
     &      2.1760, 2.1760, 2.1760, 2.1760, 2.1760, 2.1760, 2.1760, 2.1759,
     &      2.1759, 2.1759, 2.1759, 2.1757, 2.1757, 2.1757, 2.1757, 2.1754,
     &      2.1754, 2.1754, 2.1754, 2.1750, 2.1750, 2.1750, 2.1745, 2.1745,
     &      2.1745, 2.1739, 2.1739, 2.1739, 2.1731, 2.1731, 2.1723, 2.1723,
     &      2.1723, 2.1713, 2.1713, 2.1703, 2.1703, 2.1691, 2.1691, 2.1679,
     &      2.1679, 2.1665, 2.1665, 2.1651, 2.1636, 2.1636, 2.1619, 2.1602,
     &      2.1584, 2.1566, 2.1546, 2.1546, 2.1506, 2.1484, 2.1462, 2.1440 /

C Geometric standard deviation of coarse mode
      DATA ( SIGK( I ), I = 1, 136 ) /
     &      2.1083, 2.0900, 2.0900, 2.0900, 2.0900, 2.0900, 2.0725, 2.0725,
     &      2.0725, 2.0725, 2.0725, 2.0558, 2.0558, 2.0558, 2.0558, 2.0399,
     &      2.0399, 2.0399, 2.0399, 2.0248, 2.0248, 2.0248, 2.0103, 2.0103,
     &      2.0103, 1.9967, 1.9967, 1.9967, 1.9836, 1.9836, 1.9713, 1.9713,
     &      1.9597, 1.9597, 1.9487, 1.9487, 1.9384, 1.9288, 1.9288, 1.9198,
     &      1.9114, 1.9036, 1.8965, 1.8901, 1.8843, 1.8791, 1.8791, 1.8791,
     &      1.8746, 1.8746, 1.8746, 1.8746, 1.8746, 1.8746, 1.8746, 1.8708,
     &      1.8708, 1.8708, 1.8708, 1.8708, 1.8708, 1.8676, 1.8676, 1.8676,
     &      1.8676, 1.8676, 1.8676, 1.8652, 1.8652, 1.8652, 1.8652, 1.8652,
     &      1.8652, 1.8635, 1.8635, 1.8635, 1.8635, 1.8635, 1.8625, 1.8625,
     &      1.8625, 1.8625, 1.8625, 1.8622, 1.8622, 1.8622, 1.8622, 1.8628,
     &      1.8628, 1.8628, 1.8628, 1.8642, 1.8642, 1.8642, 1.8642, 1.8664,
     &      1.8664, 1.8664, 1.8664, 1.8696, 1.8696, 1.8696, 1.8737, 1.8737,
     &      1.8737, 1.8788, 1.8788, 1.8788, 1.8850, 1.8850, 1.8923, 1.8923,
     &      1.8923, 1.9009, 1.9009, 1.9108, 1.9108, 1.9221, 1.9221, 1.9351,
     &      1.9351, 1.9497, 1.9497, 1.9662, 1.9849, 1.9849, 2.0058, 2.0295,
     &      2.0560, 2.0859, 2.1197, 2.1197, 2.2014, 2.2510, 2.3080, 2.3740 /

C Number flux in accumulation mode at 1 m/s [1/m2/s]
            DATA ( FNJ( I ), I = 1, 136 ) /
     &      1249.0821, 1248.2831, 1248.2831, 1248.2831, 1248.2831, 1248.2831,
     &      1247.4863, 1247.4863, 1247.4863, 1247.4863, 1247.4863, 1246.6948,
     &      1246.6948, 1246.6948, 1246.6948, 1245.9114, 1245.9114, 1245.9114,
     &      1245.9114, 1245.1389, 1245.1389, 1245.1389, 1244.3799, 1244.3799,
     &      1244.3799, 1243.6370, 1243.6370, 1243.6370, 1242.9115, 1242.9115,
     &      1242.2081, 1242.2081, 1241.5281, 1241.5281, 1240.8739, 1240.8739,
     &      1240.2476, 1239.6513, 1239.6513, 1239.0872, 1238.5571, 1238.0628,
     &      1237.6062, 1237.1869, 1236.8099, 1236.4749, 1236.4749, 1236.4749,
     &      1236.1833, 1236.1833, 1236.1833, 1236.1833, 1236.1833, 1236.1833,
     &      1236.1833, 1235.9361, 1235.9361, 1235.9361, 1235.9361, 1235.9361,
     &      1235.9361, 1235.7343, 1235.7343, 1235.7343, 1235.7343, 1235.7343,
     &      1235.7343, 1235.5787, 1235.5787, 1235.5786, 1235.5786, 1235.5786,
     &      1235.5786, 1235.4698, 1235.4698, 1235.4698, 1235.4698, 1235.4698,
     &      1235.4082, 1235.4082, 1235.4082, 1235.4082, 1235.4082, 1235.3941,
     &      1235.3941, 1235.3941, 1235.3941, 1235.4277, 1235.4277, 1235.4277,
     &      1235.4277, 1235.5087, 1235.5087, 1235.5087, 1235.5087, 1235.6351,
     &      1235.6351, 1235.6351, 1235.6351, 1235.8099, 1235.8099, 1235.8099,
     &      1236.0306, 1236.0306, 1236.0306, 1236.2963, 1236.2963, 1236.2963,
     &      1236.6058, 1236.6058, 1236.9575, 1236.9575, 1236.9575, 1237.3498,
     &      1237.3498, 1237.7807, 1237.7807, 1238.2480, 1238.2480, 1238.7491,
     &      1238.7491, 1239.2812, 1239.2812, 1239.8412, 1240.4256, 1240.4256,
     &      1241.0307, 1241.6543, 1242.2878, 1242.9282, 1243.5702, 1243.5702,
     &      1244.8344, 1245.4428, 1246.0247, 1246.5734 /

C Number flux in coarse mode at 1 m/s [1/m2/s]
      DATA ( FNK( I ), I = 1, 136 ) /
     &      11.2976, 11.1324, 11.1324, 11.1324, 11.1324, 11.1324, 10.9787,
     &      10.9787, 10.9787, 10.9787, 10.9787, 10.8356, 10.8356, 10.8356,
     &      10.8356, 10.7024, 10.7024, 10.7024, 10.7024, 10.5785, 10.5785,
     &      10.5785, 10.4632, 10.4632, 10.4632, 10.3561, 10.3561, 10.3561,
     &      10.2565, 10.2565, 10.1641, 10.1641, 10.0786, 10.0786, 9.9994,
     &      9.9994, 9.9263, 9.8591, 9.8591, 9.7973, 9.7408, 9.6894, 9.6430,
     &      9.6011, 9.5640, 9.5315, 9.5315, 9.5315, 9.5034, 9.5034, 9.5034,
     &      9.5034, 9.5034, 9.5034, 9.5034, 9.4797, 9.4797, 9.4797, 9.4797,
     &      9.4797, 9.4797, 9.4604, 9.4604, 9.4604, 9.4604, 9.4604, 9.4604,
     &      9.4455, 9.4455, 9.4455, 9.4455, 9.4455, 9.4455, 9.4351, 9.4351,
     &      9.4351, 9.4351, 9.4351, 9.4291, 9.4291, 9.4291, 9.4291, 9.4291,
     &      9.4278, 9.4278, 9.4278, 9.4278, 9.4311, 9.4311, 9.4311, 9.4311,
     &      9.4393, 9.4393, 9.4393, 9.4393, 9.4523, 9.4523, 9.4523, 9.4523,
     &      9.4708, 9.4708, 9.4708, 9.4948, 9.4948, 9.4948, 9.5247, 9.5247,
     &      9.5247, 9.5608, 9.5608, 9.6036, 9.6036, 9.6036, 9.6536, 9.6536,
     &      9.7112, 9.7112, 9.7773, 9.7773, 9.8524, 9.8524, 9.9376, 9.9376,
     &      10.0336, 10.1418, 10.1418, 10.2634, 10.4001, 10.5533, 10.7252,
     &      10.9184, 10.9184, 11.3807, 11.6576, 11.9718, 12.3303 /

C Volume flux at 1 m/s numerically integrated over full size range [m3/m2/s]
      DATA ( VFLUX( I ), I = 1, 136 ) /
     &      3.5750e-16, 3.5600e-16, 3.6036e-16, 3.6489e-16, 3.6960e-16,
     &      3.7449e-16, 3.7367e-16, 3.7889e-16, 3.8434e-16, 3.9002e-16,
     &      3.9596e-16, 3.9603e-16, 4.0243e-16, 4.0913e-16, 4.1615e-16,
     &      4.1720e-16, 4.2484e-16, 4.3289e-16, 4.4136e-16, 4.4371e-16,
     &      4.5303e-16, 4.6290e-16, 4.6656e-16, 4.7752e-16, 4.8919e-16,
     &      4.9453e-16, 5.0765e-16, 5.2171e-16, 5.2932e-16, 5.4535e-16,
     &      5.5493e-16, 5.7342e-16, 5.8547e-16, 6.0711e-16, 6.2234e-16,
     &      6.4805e-16, 6.6748e-16, 6.8942e-16, 7.2379e-16, 7.5245e-16,
     &      7.8530e-16, 8.2321e-16, 8.6731e-16, 9.1914e-16, 9.8076e-16,
     &      1.0551e-15, 1.0648e-15, 1.0746e-15, 1.0704e-15, 1.0806e-15,
     &      1.0909e-15, 1.1015e-15, 1.1124e-15, 1.1234e-15, 1.1347e-15,
     &      1.1310e-15, 1.1427e-15, 1.1546e-15, 1.1668e-15, 1.1793e-15,
     &      1.1921e-15, 1.1889e-15, 1.2021e-15, 1.2157e-15, 1.2295e-15,
     &      1.2437e-15, 1.2583e-15, 1.2559e-15, 1.2711e-15, 1.2866e-15,
     &      1.3025e-15, 1.3189e-15, 1.3357e-15, 1.3343e-15, 1.3518e-15,
     &      1.3699e-15, 1.3884e-15, 1.4075e-15, 1.4072e-15, 1.4272e-15,
     &      1.4477e-15, 1.4690e-15, 1.4909e-15, 1.4919e-15, 1.5149e-15,
     &      1.5387e-15, 1.5633e-15, 1.5657e-15, 1.5916e-15, 1.6185e-15,
     &      1.6464e-15, 1.6504e-15, 1.6799e-15, 1.7106e-15, 1.7425e-15,
     &      1.7487e-15, 1.7827e-15, 1.8181e-15, 1.8550e-15, 1.8640e-15,
     &      1.9036e-15, 1.9450e-15, 1.9566e-15, 2.0013e-15, 2.0481e-15,
     &      2.0629e-15, 2.1138e-15, 2.1673e-15, 2.1862e-15, 2.2448e-15,
     &      2.2666e-15, 2.3310e-15, 2.3993e-15, 2.4276e-15, 2.5035e-15,
     &      2.5366e-15, 2.6216e-15, 2.6607e-15, 2.7566e-15, 2.8033e-15,
     &      2.9126e-15, 2.9689e-15, 3.0950e-15, 3.1640e-15, 3.2387e-15,
     &      3.3973e-15, 3.4912e-15, 3.5945e-15, 3.7089e-15, 3.8366e-15,
     &      3.9802e-15, 4.2603e-15, 4.3308e-15, 4.5485e-15, 4.8050e-15,
     &      5.1124e-15 /


C Polynomial coefficients from Zhang et al. (2005)         
      DATA C0_COEFF / 28.376D0, -205.44D0, 653.37D0, -1031.7D0, 803.18D0, -247.08D0 /
      DATA X_COEFF  / 3.1657D0, -19.079D0,  55.72D0, -83.998D0, 63.436D0, -19.248D0 /

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         FUNCTION SSEMIS_INIT( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

C Revision History:
C   26 Feb 10 J.Young:  Eliminate BARRIER, etc. to prevent MPI race condition
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   04 Apr 11 S.Howard: dynamic allocation and generalization of indices for
C                       SSOUTD, WRSS_SPC, and SSSPC_MAP
C   11 May 11 D.Wong: incorporated twoway model implementation
C   12 Aug 15 D.Wong: added code to handle parallel I/O implementation

            USE UTILIO_DEFN
            USE AERO_DATA

#ifdef parallel
            USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
            USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

            IMPLICIT NONE

C Arguments:
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP
            LOGICAL :: SUCCESS

C Includes:
            INCLUDE SUBST_FILES_ID  ! file name parameters

C Local Variables:
            CHARACTER( 16 ), SAVE :: PNAME = 'SSEMIS_INIT'
            CHARACTER( 80 ) :: VARDESC
            CHARACTER( 250 ) :: XMSG = ' '
            INTEGER STATUS
            INTEGER S, N, L, ISEA, SPC, IM
            LOGICAL SEA_MATCH
            CHARACTER( 16 ) :: SN

C-----------------------------------------------------------------------

            SUCCESS = .TRUE.

C Map aerospc data
            CALL MAP_AERO()

            CALL LOG_MESSAGE( LOGDEV, 'Initialize Sea Spray Aerosol Emissions' )

            ! Specify H2O in mapping
            KH2O = NSEA_SPC

C Populate Master Emissions Map Vector So That Diagnostics 
C can be printed in EMIS_MAP
            NSSSPC = NSEA_SPC
            Em_File_Surr( iseasrm )%len = nssspc*2
            Allocate( Em_File_Surr( iseasrm )%arry ( nssspc*2 ) )
            Allocate( Em_File_Surr( iseasrm )%units( nssspc*2 ) )
            Allocate( Em_File_Surr( iseasrm )%mw   ( nssspc*2 ) )
            Allocate( Em_File_Surr( iseasrm )%used ( nssspc*2 ) )
            Allocate( Em_File_Surr( iseasrm )%conv ( nssspc*2 ) )
            Allocate( Em_File_Surr( iseasrm )%basis( nssspc*2 ) )
            Em_File_Surr( iseasrm )%arry( : ) = 'NOT_AVAILABLE'
            do i = 1,nssspc
              IF ( sea_spc( i )%spcfac(1) .NE. 0.0 .or. i .EQ. nssspc ) 
     &           Em_File_Surr( iseasrm )%arry( i )  =
     &                         "PMFINE_" // sea_spc(i)%name
              IF ( sea_spc( i )%spcfac(2) .NE. 0.0 .or. i .EQ. nssspc ) 
     &           Em_File_Surr( iseasrm )%arry( i+nssspc )  =
     &                         "PMCOARSE_" // sea_spc(i)%name
               Em_File_Surr( iseasrm )%mw   ( i ) = sea_spc(i)%mw
               Em_File_Surr( iseasrm )%mw   ( i+nssspc ) = sea_spc(i)%mw
            end do
            Em_File_Surr( iseasrm )%units( : ) = 'G/S'
            Em_File_Surr( iseasrm )%used ( : ) = .FALSE.
            Em_File_Surr( iseasrm )%conv ( : ) = 1.0
            Em_File_Surr( iseasrm )%basis( : ) = 'MASS'
 
C Allocate SS arrays using NSSSPC value
            ALLOCATE ( SSOUTM( NSSSPC*2,NCOLS,NROWS ),
     &                 SSOUTN( 2,NCOLS,NROWS ),
     &                 SSOUTS( 2,NCOLS,NROWS ), 
     &                 SEA_FACTNUM( N_MODE,NCOLS,NROWS ),
     &                 SEA_FACTSRF( N_MODE,NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
               XMSG = '*** SSOUTM, SSOUTN or SSOUTS memory allocation failed'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF


            IF ( SSEMDIAG ) THEN    ! Open the sea-salt emission diagnostic file
C Determine number of sea-salt species For diagnostic file
               NSSDIAG = 0
               DO ISEA = 1,NSSSPC
                  NSSDIAG = NSSDIAG + COUNT( SEA_SPC( ISEA )%SPCFAC( : ) .GT. 0. )
               ENDDO
C Include H2O
               NSSDIAG = NSSDIAG + 2   !! count both J and K modes
C Include NUMBER and SURFACE_AREA to diagnostic (J & K)
               NSSDIAG = NSSDIAG + 4

C Allocate diagnostic arrays
               ALLOCATE ( SSOUTD( NSSDIAG ),
     &                    WRSS_SPC( NSSDIAG ), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = '*** SSOUTD or WRSS_SPC memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

C Build diagnostic file write buffer (WRSS_SPC) array
               NSSDIAG = 0
               DO N = 1, 2
                  DO S = 1, NSSSPC
                     IF ( SEA_SPC( S )%SPCFAC( N ) .GT. 0.0 ) THEN
                        NSSDIAG = NSSDIAG + 1
                        WRSS_SPC( NSSDIAG ) = TRIM( SEA_SPC( S )%NAME ) // MODESUFF( N ) 
                     END IF
                  END DO
C Include H2O
                  NSSDIAG = NSSDIAG + 1
                  WRSS_SPC( NSSDIAG ) = 'AH2O' // MODESUFF( N )
               END DO

C Include Mode NUMBER to diagnostic
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "NUMFINE"
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "NUMCOARSE"
 
C Include Mode SURFACE_AREA to diagnostic
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "SRFFINE"
               NSSDIAG = NSSDIAG + 1
               WRSS_SPC( NSSDIAG ) = "SRFCOARSE"

C Open the sea-salt emission dignostic file
               IF ( IO_PE_INCLUSIVE ) CALL OPSSEMIS ( STDATE, STTIME, TSTEP, NSSDIAG, WRSS_SPC )

               ALLOCATE ( SSBF( NSSDIAG,NCOLS,NROWS ),
     &                    WRSS( NCOLS,NROWS ), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = '*** SSBF or WRSS memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

#ifdef parallel_io
               CALL SE_BARRIER
               IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_SSEMIS_1, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM(CTM_SSEMIS_1)
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                  END IF
               END IF
#endif

            END IF

         END FUNCTION SSEMIS_INIT

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE OPSSEMIS ( JDATE, JTIME, TSTEP, NSSDIAG, WRSS_SPC )

C   16 May 05 P.Bhave: original version, using OPDDEP as a template
C    4 Mar 10 J.Young: accomodate Steve Howard's reengineering
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN

         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER      JDATE      ! current model date, coded YYYYDDD
         INTEGER      JTIME      ! current model time, coded HHMMSS
         INTEGER      TSTEP      ! output time step
         INTEGER      NSSDIAG
         CHARACTER( 16 ) :: WRSS_SPC( NSSDIAG )

C Local variables:
         CHARACTER( 16 ) :: PNAME = 'OPSSEMIS'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER      V, L       ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update
         IF ( .NOT. OPEN3( CTM_SSEMIS_1, FSRDWR3, PNAME ) ) THEN
            XMSG = 'Could not open CTM_SSEMIS_1 for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open diagnostic file
            FTYPE3D = GRDDED3
            SDATE3D = JDATE
            STIME3D = JTIME
            TSTEP3D = TSTEP
            CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

            NVARS3D = NSSDIAG
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D = 1
            NTHIK3D = 1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD
!           VGTPUN3D = VGTPUN_GD ! currently, not defined
            DO L = 1, NLAYS3D + 1
               VGLVS3D( L ) = VGLVS_GD( L )
            END DO
!           GDNAM3D = GDNAME_GD
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            DO V = 1, NSSDIAG
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = WRSS_SPC( V )
               IF ( VNAME3D( V )(1:3) .EQ. 'NUM' ) THEN
                  UNITS3D( V ) = 's-1'
               ELSE IF ( VNAME3D( V )(1:3) .EQ. 'SRF' ) THEN
                  UNITS3D( V ) = 'm2 s-1'
               ELSE
                  UNITS3D( V ) = 'g s-1'
               END IF
               VDESC3D( V ) = 'hourly ' // TRIM( VNAME3D( V ) )
     &                     // ' sea-salt emission rate'
            END DO

            FDESC3D( 1 ) = 'hourly layer-1 sea-salt emission rates'
            DO L = 2, MXDESC3
               FDESC3D( L ) = ' '
            END DO

C Open sea-salt emissions diagnostic file
            IF ( .NOT. OPEN3( CTM_SSEMIS_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create the CTM_SSEMIS_1 file'
               CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
            END IF

         END IF

         RETURN

         END SUBROUTINE OPSSEMIS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_SSEMIS ( JDATE, JTIME, TSTEP, CELLVOL, CELLHGT )

C GET_SSEMIS calculates the sea-salt emission rates in a grid cell
C given the fractional grid-cell area covered by open ocean and surf zone
 
C Key Subroutines/Functions Called:  NONE
 
C Revision History:
 
C   13 Jun 05 P.Bhave:  first version for public release
C   11 Apr 08 J.Kelly:  added code for (1) emission of coarse surface area,
C                       (2) emission of coarse water, (3) enhanced surf zone
C                       emissions, and (4) variable coarse std. deviation
C   20 Feb 10 J.Young:  move out of AERO_EMIS proper into this module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   04 Apr 11 S.Howard: moved speciation to AERO_DATA and generalized species
C                       and modal references and density calculation
C   11 May 11 D.Wong: incorporated twoway model implementation
C   08 Aug 14 B.Gantt: added code for (1) increased accumulation mode
C                      emissions, (2) sea surface temperature dependence
C                      of emissions, and (3) reduction of surf zone
C                      emisions
 
C References:
C    Alduchov and Eskridge, "Improved Magnus Form Approximations of
C          Saturation Vapor Pressure," Jour. of Applied Meteorology, vol. 35,
C          pp 601-609, April, 1996.
C    Binkowski F.S., S.J. Roselle. Models-3 Community Multiscale Air Quality 
C          (CMAQ) model aerosol component 1: Model Description.  J. Geophys. 
C          Res., Vol 108, No D6, 4183, doi:10.1029/2001JD001409 (2003).
C    Seinfeld, J.H., S.N. Pandis.  "Atmospheric Chemistry and Physics - from
C          air pollution to climate change"  John Wiley & Sons, Inc. (1998).
C    Zhang, K.M., E.M. Knipping, A.S. Wexler, P.V. Bhave, G.S. Tonnesen
C          "Size distribution of sea-salt emissions as a function of relative
C          humidity"  Atmospheric Environment, 39, 3373-3379 (2005).
C    Lewis, E.R. and Schwartz, S.E. "Comment on "Size distribution of sea-salt
C           emissions as a funciton of relative humidity", Atmospheric Environment,
C           40, 588-590 (2006)
C    Zhang, K.M., E.M. Knipping, A.S. Wexler, P.V. Bhave, G.S. Tonnesen, "Reply
C           to comment on "Size distribution of sea-salt emissions as a funciton 
C           of relative humidity", Atmospheric Environment, 40, 591-592 (2006)
C    Clarke, A.D., S.R. Owens, and J. Zhou "An ultrafine sea-salt flux from
C          breaking waves: Implications for cloud condensation nuclei in the
C          remote marine atmosphere" J. Geophys. Res. (2006)
C    Gong, S. L., A parameterization of sea-salt aerosol source function
C          for sub- and super-micron particles, Global Biogeochem. Cycles, 17,
C          1097, (2003).
C    Jaeglé, L., P. K. Quinn, T. S. Bates, B. Alexander, and J. T. Lin, Global 
C          distribution of sea salt aerosols: New constraints from in situ and
C          remote sensing observations, Atmos. Chem. Phys., 11, 3137–3157,
C          (2011).
C    Ovadnevaite, J., Manders, A., de Leeuw, G., Ceburnis, D., Monahan, C., 
C          Partanen, A.-I., Korhonen, H., and O'Dowd, C. D.: A sea spray 
C          aerosol flux parameterization encapsulating wave state, Atmos. 
C          Chem. Phys., 14, 1837-1852, (2014).
C-----------------------------------------------------------------------

            USE UTILIO_DEFN
            USE AERO_DATA
            USE AEROMET_DATA   ! Includes CONST.EXT
            USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA, svp2, svp3

            IMPLICIT NONE

C Arguments
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP( 3 )
            REAL,    INTENT( IN ) :: CELLVOL               ! grid-cell volume [m2*sigma]
            REAL,    INTENT( IN ) :: CELLHGT               ! grid-cell height [sigma]

C Includes:
            INCLUDE SUBST_FILES_ID  ! file name parameters

C Local Variables:
            REAL    :: OFRAC              ! fractional seawater cover
            REAL    :: SFRAC              ! fractional surf-zone cover
            REAL    :: BLKPRS             ! atmospheric pressure [Pa]
            REAL    :: BLKTA              ! air temperature [K]
            REAL    :: BLKQV              ! H2O mass mixing ratio [ kg/kg ]
            REAL    :: U10                ! wind speed at 10m [m/s]
            REAL    :: RLAY1HT            ! reciprocal of layer-1 height [1/m]
            REAL    :: AIRVOL             ! grid-cell volume [m3]
            REAL    :: SST                ! sea surface temperature[C]

            CHARACTER( 16 ), SAVE :: PNAME = 'GET_SSEMIS'
            CHARACTER( 96 ) :: XMSG = ' '
            INTEGER C, R, L, N, V, S         ! loop indices

C Variables for calculating ambient RH as done in the aerosol module
            REAL, PARAMETER :: AA = 610.94      ! coefficients from Alduchov
            REAL, PARAMETER :: BB = 17.625      !  and Eskridge (1996)
            REAL, PARAMETER :: CC = 243.04
            REAL, PARAMETER :: EPSWATER = MWWAT / MWAIR
            REAL      :: ESAT             ! saturation vapor pressure
            REAL      :: BLKRH            ! fractional relative humidity

C Variables for calculating solute mass fraction & size-correction factors
            REAL( 8 ), PARAMETER :: ONE3  = 1.0D0 / 3.00D0
            REAL( 8 ), PARAMETER :: A0    = 1.0D0 / 3.70D0
            REAL( 8 ), PARAMETER :: A80   = 3.7D0 / 1.82D0
            REAL      :: RH               ! BLKRH constrained to 45-99% range
            REAL( 8 ) :: DRH              ! double precision RH
            REAL( 8 ) :: C0               ! (Diam @ formation) / (Diam @ ambient RH)
            REAL( 8 ) :: C80              ! (Diam @ 80% RH) / (Diam @ ambient RH)    
            REAL( 8 ) :: XSW              ! fractional solute weight fraction

C Density of dry sea salt [kg/m3] using volume additivity
            REAL( 8 )       :: RHOSW( 2 ) ! sea-salt particle density at ambient RH [g/m3]

C Maximum and minimum diameters for emission-flux integrations [m]
            REAL, PARAMETER :: DPMAX = 20.0E-6 ! upper limit used for the
                                               ! numerical integrations
            REAL      :: DPMINO           ! minimum diameter for open-ocean flux
            REAL      :: DPMAXO           ! maximum diameter for open-ocean flux
   
C Wind-speed-dependent scaling factors for emissions flux functions
            REAL      :: WDSCALO          ! Gong-Monahan open-ocean flux

C SST-dependent scaling factor for emissions flux functions
            REAL      :: SSTSCALO          ! Jaegle flux

C Fraction of whitecap coverage
            REAL      :: WCAP

C Lognormal parameters and numerically-integrated fluxes at ambient RH
            INTEGER   :: IPOS             ! position of ambient RH in data arrays
            REAL      :: DGNJRH           ! geometric mean of accum-mode flux [m]
            REAL      :: DGNKRH           ! geometric mean of coarse-mode flux [m]
            REAL      :: SIGJRH           ! geom std deviation of accum-mode flux
            REAL      :: SIGKRH           ! geom std deviation of coarse-mode flux
            REAL      :: FNJRH            ! magnitude of accum-mode flux [1/m2/s]
            REAL      :: FNKRH            ! magnitude of coarse-mode flux [1/m2/s]
            REAL      :: VFLXRH           ! total particle volume [m3/m2/s]

C Alternate forms of geometric std devs stored for efficiency
            REAL      :: LNSGJ, LNSGK     ! natural log of std dev
            REAL      :: RDIVJ, RDIVK     ! reciprocal of sqrt(2)*lnsg

C Geometric mean diameters by volume/mass [m]
            REAL      :: DGVJRH           ! accumulation mode
            REAL      :: DGVKRH           ! coarse mode

C Variables for converting 3rd moment emission rates to M0 and M2 rates
            REAL      :: FACTNUMJ         ! conversion for accumulation mode M0
            REAL      :: FACTNUMK         ! conversion for coarse mode M0
            REAL      :: FACTM2J          ! conversion for accumulation mode M2
            REAL      :: FACTM2K          ! conversion for coarse mode M2 

C Variables for calculating fraction of mass emissions assigned to each mode
            REAL      :: FFINJ            ! finite integral for accumulation mode
            REAL      :: FFINK            ! finite integral for coarse mode
            REAL      :: FRACMJ           ! mass fraction assigned to accumulation mode
            REAL      :: FRACMK           ! mass fraction assigned to coarse mode

C Mode-specific sea-salt mass emission rates [g/m3/s]
            REAL( 8 ) :: ESEASJ           ! accumulation mode
            REAL( 8 ) :: ESEASK           ! coarse mode

C 3rd moment emission rates [m3/m3/s]
            REAL      :: M3J              ! accumulation mode, 3rd moment
            REAL      :: M3K              ! coarse mode, 3rd moment
         
C Variables for calculating dry surface-area emission rate for accum mode
            REAL      :: WET_M3J, DRY_M3J ! wet & dry 3rd moment emis rates [m3/m3/s] 
            REAL      :: WET_M2J, DRY_M2J ! wet & dry 2nd moment emis rates [m3/m3/s] 
            REAL      :: WET_M3K, DRY_M3K ! wet & dry 3rd moment emis rates [m3/m3/s] 
            REAL      :: WET_M2K, DRY_M2K ! wet & dry 2nd moment emis rates [m3/m3/s] 

            INTEGER, SAVE     :: WSTEP  = 0    ! local write counter
            INTEGER           :: MDATE, MTIME  ! SSEMIS write date&time

            LOGICAL, SAVE :: FIRSTIME      = .TRUE.

C Mathematical constants; statement function for ERF approximation
            REAL, PARAMETER      :: TWO3 = 2.0 / 3.0
            REAL                 :: ERF        ! ERF approx. statement function
            REAL                 :: X          ! dummy argument for ERF
            ERF( X ) = SIGN( 1.0, X ) * SQRT( 1.0 - EXP( -4.0 * X * X / PI ) )

C----------------------------- Begin calc ------------------------------

C Initialize sea-salt output buffer
            IF ( SSEMDIAG .AND. WSTEP .EQ. 0 ) SSBF = 0.0
            SEA_FACTNUM = 0.0
            SEA_FACTSRF = 0.0

            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( Grid_Data%OCEAN( C,R ) + Grid_Data%SZONE( C,R ) .GT. 0.0 ) THEN
                     OFRAC   = Grid_Data%OCEAN     ( C,R )
                     SFRAC   = Grid_Data%SZONE     ( C,R )
                     BLKPRS  = Met_Data%PRES       ( C,R,1 )
                     BLKTA   = Met_Data%TA         ( C,R,1 )
                     BLKQV   = Met_Data%QV         ( C,R,1 )
                     U10     = Met_Data%WSPD10     ( C,R )
                     SST     = max(Met_Data%TSEASFC( C,R ) - 273.15, 0.0 )
                     RLAY1HT = Met_Data%RJACM ( C,R,1 ) / CELLHGT
                  ELSE
                     DO N = 1, 2
                        DO S = 1, NSSSPC
                           SSOUTM( (N-1)*NSSSPC+S,C,R ) = 0.0
                        END DO
                        SSOUTN( N,C,R ) = 0.0
                        SSOUTS( N,C,R ) = 0.0
                     END DO
                     CYCLE
                  END IF

C Calculate fractional relative humidity in the grid cell
C Follow the same methodology as in other portions of the code just for the 10m RH
                  If ( BLKTA .Lt. stdtemp ) Then
                     ESAT = vp0 *Exp( 22.514 - ( 6.15e3 / BLKTA ) )
                  Else
                     ESAT = vp0 *Exp( svp2 * ( BLKTA -stdtemp ) / ( BLKTA -svp3 ) ) 
                  End If
                  BLKRH = BLKPRS * BLKQV / ( ( EPSWATER + BLKQV ) *  ESAT )       
                  BLKRH = MIN( 0.99, MAX( 0.005, BLKRH ) )

C Calculate RH-dependent size-correction factors and solute mass fraction
C using equations from Zhang et al. (2005), which are valid over the
C 45-99% RH range.  Store powers of RH for polynomial calculations.
                  RH = BLKRH
                  RH = MAX( 0.45, MIN( 0.99, RH ) )
                  DRH = REAL( RH, 8 )

C Calculate inverse of size-correction factors from Equation 3 of Lewis & Schwartz 2006 and Zhang et al 2006 equation 2. 
!                  C0  = 3.70D0 * ( (1.0D0-DRH) / (2.0D0-DRH) ) ** (1.0D0/3.0D0)
!                  C80 = 1.82D0 * ( (1.0D0-DRH) / (2.0D0-DRH) ) ** (1.0D0/3.0D0)
                  C0  = A0  * ( (2.0D0-DRH) / (1.0D0-DRH) ) ** ONE3
                  C80 = A80 * C0

C Calculate solute mass fraction using Equation 1 of Zhang et al.
                  XSW =         X_COEFF( 1 )
     &                + DRH * ( X_COEFF( 2 )
     &                + DRH * ( X_COEFF( 3 )
     &                + DRH * ( X_COEFF( 4 )
     &                + DRH * ( X_COEFF( 5 )
     &                + DRH * ( X_COEFF( 6 ) ) ) ) ) )


C Calculate sea-salt-particle density [g/m3] at ambient RH, assuming
C volume additivity of dry salt plus water
                  RHOSW( 1 ) = 1.0D+3 
     &                  / ( XSW / SEASPRAY_DENS( 2 ) + ( 1.0D0 - XSW ) * SPECIFIC_VOL_H2O )
                  RHOSW( 2 ) = 1.0D+3 
     &                  / ( XSW / SEASPRAY_DENS( 3 ) + ( 1.0D0 - XSW ) * SPECIFIC_VOL_H2O )

C Set minimum and maximum diameters for integration using the size-
C correction factors of Zhang et al. (2005)

C Gong-Monahan flux function is valid from 0.005-5.0 um dry radius;
C multiply by 4 to get wet diameter at 80% RH
!                  DPMINO = 2.0E-8 / REAL( C80, 4 )
!                  DPMAXO = MIN( DPMAX, DPMAX / REAL( C80, 4 ) )
                  DPMINO = 2.0E-8 * REAL( C80, 4 )
                  DPMAXO = MIN( DPMAX, DPMAX * REAL( C80, 4 ) )


C deLeeuw flux function is valid from 1.6-20 um diameter at formation
!                 DPMINS = 1.6E-6 * C0 
!                 DPMAXS = MIN( DPMAX, DPMAX * C0 )
            
C Calculate scaling factors to correct the tabulated fluxes for the 10m
C wind speed in this cell.  Note: tabulated values are based on 1 m/s.
                  WDSCALO = MIN( U10, 20.0 ) ** 3.41        ! Gong-Monahan flux function
!                 WDSCALS = EXP( 0.23 * MIN( U10, 9.0 ) )   ! deLeeuw flux function

C SST scaling factor based on Jaegle et al. (2011)
C linearized by Ovadnevaite et al. (2014)
                  SSTSCALO = 0.38 + 0.054 * SST

C Calculate whitecap coverage fraction 
                  WCAP = 3.84E-6 * WDSCALO ! Eq. 5, Clarke et al. (2006) JGR

C Find position in the data arrays that corresponds to ambient RH in this
C grid cell and set the appropriate data values
                  IF ( BLKRH .LE. 0.45 ) THEN
                     IPOS = 1
                  ELSE IF ( BLKRH .LE. 0.90 ) THEN
                     IPOS = NINT( 100.0 * BLKRH - 44.0 )
                  ELSE IF ( BLKRH .LE. 0.99 ) THEN
                     IPOS = NINT( 1000.0 * BLKRH - 854.0 )
                  ELSE
                     IPOS = 136
                  END IF

                  DGNJRH = DGNJ ( IPOS ) * 1.0E-6   ! convert to [m]
                  DGNKRH = DGNK ( IPOS ) * 1.0E-6   ! convert to [m]
                  SIGJRH = SIGJ ( IPOS )
                  SIGKRH = SIGK ( IPOS ) 
                  FNJRH  = FNJ  ( IPOS )
                  FNKRH  = FNK  ( IPOS )
                  VFLXRH = VFLUX( IPOS ) * ( OFRAC * SSTSCALO
     &            + (SFRAC * 0.5) / WCAP )

C Save certain functions of the geometric standard deviations for later use
                  LNSGJ  = LOG( SIGJRH )
                  LNSGK  = LOG( SIGKRH )
                  RDIVJ  = 1.0 / ( SQRT( 2.0 ) * LNSGJ )
                  RDIVK  = 1.0 / ( SQRT( 2.0 ) * LNSGK )

C Calculate geometric-mean diameters by volume using Equation 7.52 of
C Seinfeld & Pandis (1998).
                  DGVJRH = DGNJRH * EXP( 3.0 * LNSGJ * LNSGJ )
                  DGVKRH = DGNKRH * EXP( 3.0 * LNSGK * LNSGK )

C Calculate modal volume fluxes [m3/m2/s] by evaluating finite integrals 
C from DPMIN to DPMAX over each lognormal distribution.  Use resulting
C values to calculate the fraction of the total number emissions to 
C assign to each mode.  See Equations 19 and 20 of Uma Shankar`s
C "Integration of Sea-Salt Fluxes" memo.
                  FFINJ  = 0.5 * FNJRH * DGVJRH ** 3 * EXP( -4.5 * LNSGJ * LNSGJ )
     &                         * ( ERF( LOG( DPMAXO / DGVJRH ) * RDIVJ )  
     &                           - ERF( LOG( DPMINO / DGVJRH ) * RDIVJ ) )
                  FFINK  = 0.5 * FNKRH * DGVKRH ** 3 * EXP( -4.5 * LNSGK * LNSGK )
     &                         * ( ERF( LOG( DPMAXO / DGVKRH ) * RDIVK )  
     &                           - ERF( LOG( DPMINO / DGVKRH ) * RDIVK ) )
                  FRACMJ = FFINJ / ( FFINJ + FFINK )
                  FRACMK = 1.0 - FRACMJ

C Calculate mode-specific mass emission rates [g/m3/s], by multiplying
C numerically-integrated volume fluxes by the modal volume fractions,
C scaling for wind speed, dividing by grid-cell height, and multiplying
C by particle density.  Multiply by chemical speciation factors to
C obtain speciated mass emissions.

                  ESEASJ = VFLXRH * FRACMJ * WDSCALO * RLAY1HT * REAL( RHOSW( 1 ), 4 )

                  ESEASK = VFLXRH * FRACMK * WDSCALO * RLAY1HT * REAL( RHOSW( 2 ), 4 )

                  DO S = 1, NSSSPC
                     IF ( S .EQ. KH2O ) THEN    ! Water
                        SSOUTM( S,C,R ) = ESEASJ * REAL( ( 1.0D0 - XSW ), 4 )
                        SSOUTM( S+NSSSPC,C,R ) = ESEASK * REAL( ( 1.0D0 - XSW ), 4 )
                     ELSE
                        SSOUTM( S,C,R ) = ESEASJ * REAL( XSW, 4 )
     &                                    * SEA_SPC( S )%SPCFAC( 1 )
                        SSOUTM( S+NSSSPC,C,R ) = ESEASK * REAL( XSW, 4 )
     &                                    * SEA_SPC( S )%SPCFAC( 2 )
                     END IF

                  END DO

C Calculate mode-specific 3rd moment emission rates [m3/m3/s]
                  M3J = ESEASJ * F6PI / REAL( RHOSW( 1 ), 4 ) + TINY(0.0)
                  M3K = ESEASK * F6PI / REAL( RHOSW( 2 ), 4 ) + TINY(0.0)

C Calculate factors for converting 3rd moment emission rates into number
C and 2nd moment emission rates.  See Equations 7b and 7c of Binkowski &
C Roselle (2003)
                  FACTNUMJ = EXP( 4.5 * LNSGJ * LNSGJ ) / DGVJRH ** 3
                  FACTNUMK = EXP( 4.5 * LNSGK * LNSGK ) / DGVKRH ** 3
                  FACTM2J  = EXP( 0.5 * LNSGJ * LNSGJ ) / DGVJRH
                  FACTM2K  = EXP( 0.5 * LNSGK * LNSGK ) / DGVKRH 

C Calculate mode-specific emission rates of particle number [1/s]
                  SSOUTN( 1,C,R ) = M3J * FACTNUMJ
                  SSOUTN( 2,C,R ) = M3K * FACTNUMK

C Calculate mode-specific dry surface area emission rates [m2/m3/s].  
C Subtract water from 3rd moment to obtain dry 3rd moment emission rate.  
C Calculate dry 2nd moment while holding the standard deviation constant.
C Multiply dry 2nd moment by PI to obtain dry surface area emission rate.
                  WET_M3J = M3J 
                  WET_M2J = M3J * FACTM2J
                  DRY_M3J = WET_M3J - F6PI * SSOUTM( KH2O,C,R ) * 1.0E-06
                  DRY_M2J = WET_M2J * ( DRY_M3J / WET_M3J ) ** TWO3

                  WET_M3K = M3K
                  WET_M2K = M3K * FACTM2K
                  DRY_M3K = WET_M3K - F6PI * SSOUTM( KH2O+NSSSPC,C,R ) * 1.0E-06
                  DRY_M2K = WET_M2K * ( DRY_M3K / WET_M3K ) ** TWO3

                  SSOUTS( 1,C,R ) = PI * DRY_M2J
                  SSOUTS( 2,C,R ) = PI * DRY_M2K

! Propagate Number and Surface Area Scaling Factors back to Emissions
! Module so that the sea spray emissions can be scaled appropriately            
                  SEA_FACTNUM( 1,C,R ) = 0.0
                  SEA_FACTNUM( 2,C,R ) = FACTNUMJ
                  SEA_FACTNUM( 3,C,R ) = FACTNUMK
                  SEA_FACTSRF( 1,C,R ) = 0.0
                  SEA_FACTSRF( 2,C,R ) = SSOUTS( 1,C,R ) / M3J
                  SEA_FACTSRF( 3,C,R ) = SSOUTS( 2,C,R ) / M3K

C Update the SSBF array, for writing the diagnostic sea-salt-emission file.
                  IF ( SSEMDIAG ) THEN
                     V = 0
                     DO N = 1, 2
                        DO S = 1, NSSSPC
                           IF ( S .EQ. KH2O .OR. SEA_SPC( S )%SPCFAC( N ) .GT. 0 ) THEN
                              V = V + 1
                              SSOUTD( V ) = SSOUTM( (N-1)*NSSSPC+S,C,R )
                           END IF
                        END DO
                     END DO

                     DO N = 1, 2
                        V = V + 1
                        SSOUTD( V ) = SSOUTN( N,C,R )
                     END DO

                     DO N = 1, 2
                        V = V + 1
                        SSOUTD( V ) = SSOUTS( N,C,R )
                     END DO

                     AIRVOL = CELLVOL / Met_Data%RJACM( C,R,1 )

                     DO S = 1, NSSDIAG
                        SSBF( S,C,R ) = SSBF( S,C,R ) + SSOUTD( S ) * AIRVOL
     &                                * FLOAT( TIME2SEC ( TSTEP( 2 ) ) )
                     END DO
                  END IF  ! SSEMDIAG

               END DO   ! C
            END DO   ! R

C If last call this hour, write out the total sea-salt emissions [g/s].
C Then reset the sea-salt emissions array and local write counter.
            IF ( SSEMDIAG ) THEN

#ifdef parallel_io
               IF ( FIRSTIME ) THEN
                  FIRSTIME = .FALSE.
                  IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                     IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSREAD3, PNAME ) ) THEN
                        XMSG = 'Could not open ' // TRIM( CTM_DRY_DEP_1 )
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                     END IF
                  END IF
               END IF
#endif

               WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )

               IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
                  IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, TSTEP( 1 ),
     &                                 MDATE, MTIME ) ) THEN
                     XMSG = 'Cannot get step date and time'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                  END IF
                  CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )
                  DO V = 1, NSSDIAG
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           WRSS( C,R ) = SSBF( V,C,R ) / FLOAT( WSTEP )
                        END DO
                     END DO
                     IF ( .NOT. WRITE3( CTM_SSEMIS_1, WRSS_SPC( V ),
     &                          MDATE, MTIME, WRSS ) ) THEN
                        XMSG = 'Could not write ' // CTM_SSEMIS_1 // ' file'
                        CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                     END IF
                  END DO
                  WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &                  'Timestep written to', CTM_SSEMIS_1,
     &                  'for date and time', MDATE, MTIME
                  WSTEP = 0
                  SSBF = 0.0
               END IF

            END IF  ! SSEMDIAG

            RETURN
            
         END SUBROUTINE GET_SSEMIS

      END MODULE SSEMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_DATAGEN( )
 
C----------------------------------------------------------------------
C Function: Create the Process Analysis control data
 
C Preconditions: None
 
C Key Subroutines/Functions Called:
 
C  Revision History:
C  27 Jul 16 J.Young: inline PA ctl program
C----------------------------------------------------------------------

      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE PA_VARS, Only: NFAMLYS, NRXSUMS, NCYCLES, NIRROUT
      USE PA_DEFN            ! Process Anaylsis control and data variables

      IMPLICIT NONE 

C..Includes: None
C..Arguments: None
C..Parameters: None
C..External Functions: None
C..Local Variables: None
      CHARACTER(  16 ) :: PNAME      = 'PA_DATAGEN'
      
      CHARACTER( 240 ) :: XMSG = ' '

      INTEGER          :: JDATE, JTIME
      INTEGER          :: ESTAT         ! status from environment var check
        
C----------------------------------------------------------------------

!...Get flag to use process analysis
      WRITE( LOGDEV, * )
      CALL LOG_HEADING( LOGDEV, 'INITIALIZE PROCESS ANALYSIS' )


      JDATE = 0; JTIME = 0
      IF ( PROCAN ) THEN
         XMSG = TRIM( PNAME ) // ': Process Analysis is activated'
         CALL M3MESG( XMSG )
      ELSE
         XMSG = TRIM( PNAME ) // ': Process Analysis is not activated'
         CALL M3MESG( XMSG )
         RETURN
      END IF
        
      CALL PA_READ
      CALL PA_ERRCHECK
      CALL PA_SETUP_IPR
      CALL PA_SETUP_IRR
      CALL PA_COMPMECH
!     CALL PA_WRTPADEFN
      CALL PA_REPORT
      CALL M3MESG( 'End of initial Process Analysis Control data generation' )
      CALL M3MESG( ' ' )

      NFAMLYS = 0
      NRXSUMS = 0
      NCYCLES = 0
      NIRROUT = 0

      RETURN
      END SUBROUTINE PA_DATAGEN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPENLAYOUT( SDATE, STIME, TSTEP, EMLAYS, VGLVSXG,
     &                       NPTGRPS, MY_NSRC, LNAME )

C-----------------------------------------------------------------------
 
C  Description:
C    Opens the diagnostic layer fractions file(s).
 
C  Preconditions:
 
C  Subroutines and Functions Called:
C       I/O API 

C Revision History:
C   16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   26 Sep 2016 D.Wong: reformatted PLAY_BASE variable as PLAY_BASE_*
C                       rather than PLAY_BASE*_

C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C             System
C File: @(#)$Id: openlayout.F,v 1.4 2011/10/21 16:11:30 yoj Exp $
C COPYRIGHT (C) 2002, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/plrise/smoke/openlayout.F,v $
C Last updated: $Date: 2011/10/21 16:11:30 $ 
 
C-----------------------------------------------------------------------

      USE RUNTIME_VARS, ONLY : LOGDEV, PLAY_BASE
      USE HGRD_DEFN, ONLY: MYPE
      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:

C Local Parameters:

C Arguments:
      INTEGER,        INTENT( IN )  :: SDATE    ! Julian start date
      INTEGER,        INTENT( IN )  :: STIME    ! start time (HHMMSS)
      INTEGER,        INTENT( IN )  :: TSTEP    ! time step (HHMMSS)
      INTEGER,        INTENT( IN )  :: EMLAYS   ! number of emissions layers
      REAL,           INTENT( IN )  :: VGLVSXG( 0:MXLAYS3 ) !  vertical coord values
      INTEGER,        INTENT( IN )  :: NPTGRPS  ! number of output files
      INTEGER,        INTENT( IN )  :: MY_NSRC( NPTGRPS ) ! number of point sources
      CHARACTER( * ), INTENT( OUT ) :: LNAME( NPTGRPS )   ! layer fractions logical file name

C Local variables:

      INTEGER J, N
      CHARACTER( 256 ) :: XMSG      !  buffer for M3EXIT() messages
      CHARACTER(  16 ) :: PNAME = 'OPENLAYOUT'   ! procedure name

      CHARACTER(   3 ) :: CMYPE
      CHARACTER(   4 ) :: POSTSTR = '.ncf'
      CHARACTER(  96 ) :: PLAY_EQ
      CHARACTER(  96 ) :: EQNAME
      CHARACTER( 256 ) :: BASE

      INTEGER :: IOS

C-----------------------------------------------------------------------

C Set up and open diagnostic file(s)

      FTYPE3D = GRDDED3
      SDATE3D = SDATE
      STIME3D = STIME
      TSTEP3D = TSTEP

      NROWS3D = EMLAYS
      NLAYS3D = 1
      NTHIK3D = 1
      NVARS3D = 2
      GDTYP3D = IMISS3
      P_ALP3D = AMISS3
      P_BET3D = AMISS3
      P_GAM3D = AMISS3
      XCENT3D = AMISS3
      YCENT3D = AMISS3
      XORIG3D = AMISS3
      YORIG3D = AMISS3
      XCELL3D = AMISS3
      YCELL3D = AMISS3
      VGTYP3D = IMISS3
      VGTOP3D = AMISS3
      GDNAM3D = ' '

      VNAME3D = ' '     ! array
      VTYPE3D = 0       ! array
      UNITS3D = ''     ! array
      VDESC3D = ' '     ! array
      VNAME3D( 1 ) = 'LFRAC'
      VTYPE3D( 1 ) = M3REAL
      UNITS3D( 1 ) = '1'
      VDESC3D( 1 ) = 'Fraction of plume emitted into layer'
      VNAME3D( 2 ) = 'ZPLUME'
      VTYPE3D( 2 ) = M3REAL
      UNITS3D( 2 ) = '1'
      VDESC3D( 2 ) = 'plume elevation above ground'

      VGLVS3D = 0.0     ! array
      J = LBOUND( VGLVS3D, 1 )
      VGLVS3D( J:J+EMLAYS ) = VGLVSXG( 0:EMLAYS )  ! array
      VGTYP3D = -1
      VGTOP3D = 0.0

      UPNAM3D = 'DISTR_GRIDDED'   ! Mandatory!

      FDESC3D = ' '  ! array
      FDESC3D( 1 ) = 'By-source hourly plume rise layer fractions'
      FDESC3D( 2 ) = '/FROM/ '    // PNAME
      FDESC3D( 3 ) = '/VERSION/ Inline'

      WRITE( CMYPE,'(I3.3)' ) MYPE
      DO N = 1, NPTGRPS

         IF ( MY_NSRC( N ) .GT. 0 ) THEN
            NCOLS3D = MY_NSRC( N )

            PLAY_EQ = TRIM( PLAY_BASE( N ) ) // '_' // CMYPE // POSTSTR
            WRITE( LNAME( N ),'( "PLAY_", I2.2 )' ) N
            IF ( .NOT. SETENVVAR ( LNAME( N ), PLAY_EQ ) ) THEN
               XMSG = 'Could not set environment variable for ' // PLAY_EQ
               CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT3 )
            END IF
            IF ( .NOT. OPEN3( LNAME( N ), FSNEW3, UPNAM3D ) ) THEN
               XMSG = 'Could not open ' // TRIM( FDESC3D( 1 ) ) // ' file'
               CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
            END IF

         ELSE

            WRITE( LOGDEV,1009 ) N

         END IF

      END DO

      RETURN

1009  FORMAT( /5X, 'No sources in this subdomain for file sector', I2
     &        /5X, 'Therefore no plume layer fraction file created' )

      END SUBROUTINE OPENLAYOUT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
      MODULE AERO_PHOTDATA

      IMPLICIT NONE

      REAL( 8 ), ALLOCATABLE :: SHELL_MOMENT3( :,: )  ! modal shell third moment conc.
      REAL( 8 ), ALLOCATABLE :: CORE_MOMENT3 ( :,: )  ! model core third moment conc.

      REAL, ALLOCATABLE :: BLK_AE_VOL  ( :,: )     ! aerosol modal volumes [ m**3/m**3 ]
      REAL, ALLOCATABLE :: BLK_AE_LSG  ( :,: )     ! aerosol modal log of geo. stand. dev
      REAL, ALLOCATABLE :: BLK_AE_DGN  ( :,: )     ! aerosol modal mean geometeric diam. [ m ]
      REAL, ALLOCATABLE :: AE_DGN_CORE ( :,: )   ! inner core modal mean geometeric diam. [ m ]
      REAL, ALLOCATABLE :: AE_DGN_SHELL( :,: )   ! modal mean geometeric diam. [ m ]
      REAL, ALLOCATABLE :: BLK_AE_CONC ( :,:,: ) ! aerosol species concentrations [ ug/m**3]

      REAL, ALLOCATABLE :: AE_NR_SHELL ( :,:,: ) ! real part of refractive index for outer shell
      REAL, ALLOCATABLE :: AE_NI_SHELL ( :,:,: ) ! imaginary part of refractive index for outer shell
      REAL, ALLOCATABLE :: AE_NR_CORE  ( :,:,: ) ! real part of refractive index for inner core
      REAL, ALLOCATABLE :: AE_NI_CORE  ( :,:,: ) ! imaginary part of refractive index for inner core
      REAL, ALLOCATABLE :: BLK_AE_NR   ( :,:,: ) ! mean aerosol real part of refractive index
      REAL, ALLOCATABLE :: BLK_AE_NI   ( :,:,: ) ! mean aerosol imaginary part of refractive index

      REAL, ALLOCATABLE :: AERO_ASYM_FAC ( :,: ) ! aerosol modal averaged asymmetry factor
      REAL, ALLOCATABLE :: AERO_EXTI_COEF( :,: ) ! aerosol modal averaged extinction coeff., 1/m
      REAL, ALLOCATABLE :: AERO_SCAT_COEF( :,: ) ! aerosol modal averaged scattering coeff., 1/m
      REAL, ALLOCATABLE :: AERO_EXTI_550  ( : )  ! aerosol modal averaged extinction coeff. at 550nm, 1/m
 
      PUBLIC            :: AERO_ASYM_FAC, AERO_EXTI_COEF, AERO_SCAT_COEF,
     &                     INIT_AERO_DATA, GET_AERO_DATA, AERO_OPTICS_INTERNAL

      INTEGER,   ALLOCATABLE, PRIVATE :: REFRACT_INDX_MAP( : )  ! map array for refactive index

      REAL,      ALLOCATABLE, PRIVATE :: VOL_MINS( : )          ! minmum volume permode
      REAL( 8 ), ALLOCATABLE, PRIVATE :: M3_FACTOR( : )         ! convert mass to portion of 3rd moment
      LOGICAL,   ALLOCATABLE, PRIVATE :: IS_CORE_SPCS( :,: )    ! flag denoting species is in aerosol core

      INTEGER,   PARAMETER, PRIVATE   :: NUMB_COR_SPCS = 3      ! number species in core

      LOGICAL :: CALCULATE_EXT_550   = .FALSE. ! flag to get extinction at 550 nm
      LOGICAL :: USE_ANGSTROM_INTERP = .FALSE. ! flag to use angstrom exponents for 550 nm
      
      INTEGER   :: IWL_ANGSTROM_LOWER  = 0       ! index for wavelength less than 550 nm
      INTEGER   :: IWL_ANGSTROM_UPPER  = 0       ! index for wavelength greater than 550 nm
      REAL( 8 ) :: ANGSTROM_RATIO      = 1.0D0   ! wavelength less than 550 nm divided by 550 nm
      REAL( 8 ) :: LOG_ANGSTROM_RATIO  = 0.0D0    
      REAL( 8 ) :: ANGSTROM_SPAN       = 1.0D0   ! reciprocal of log ((wavelength < 550 nm)/(wavelength > 550 nm)
      REAL( 8 ) :: ANGSTROM_EXPONENT   = 1.0D0   ! Angstrom exponent used to interpolate extinction at 550 nm
          
C *** Species in aerosol core

      CHARACTER( 16 ), PARAMETER, PRIVATE :: CORE_SPCS( NUMB_COR_SPCS ) =
     &                                       (/ 'AECI', 'AECJ', 'AECK' /)
      
      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INIT_AERO_DATA( )

C Allocate and define arrays used to calculate aerosol optical properties

         USE GRID_CONF, ONLY: NROWS, NCOLS, NLAYS  ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
      
         USE AERO_DATA           ! aero variable data
         USE SOA_DEFN            ! gas soa data
         USE AEROMET_DATA        ! constants and met data
      
         USE CSQY_DATA, ONLY : NWL => NWL_REF, NUM_REFRACTIVE, REFRACTIVE_INDEX,
     &                         WAVELENGTH => EFFWL_REF

         IMPLICIT NONE

C Arguments:

C Local:
         CHARACTER(  32 ) :: PNAME             = 'INIT_AERO_DATA'
         CHARACTER( 120 ) :: XMSG 

         INTEGER          :: ALLOCSTAT
         INTEGER          :: ESTAT          ! status from environment var check
         INTEGER          :: JDATE, JTIME
         INTEGER          :: M, N, SPC, V   ! loop counters
      
         LOGICAL, SAVE    :: INITIALIZED  = .FALSE.

#ifdef verbose_phot
         character( 26 ), allocatable :: lambda_list( : )
#endif

         IF ( INITIALIZED ) THEN
            RETURN
         END IF
          
         JDATE  = 0
         JTIME  = 0


C...Allocate needed arrays

         ALLOCATE ( VOL_MINS( N_MODE ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VOL_MINS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( BLK_AE_CONC( N_AEROSPC,N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_CONC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( SHELL_MOMENT3( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SHELL_MOMENT3'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( BLK_AE_VOL( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_VOL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( BLK_AE_LSG( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_LSG'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( BLK_AE_DGN( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BLK_AE_DGN'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AE_DGN_SHELL( N_MODE,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AE_DGN_SHELL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AE_NR_SHELL( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating  AE_NR_SHELL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AE_NI_SHELL( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating  AE_NI_SHELL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_ASYM_FAC( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_ASYM_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_EXTI_COEF( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_EXTI_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AERO_SCAT_COEF( NLAYS,NWL ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AERO_EXTI_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         AERO_SCAT_COEF = 0.0
         AERO_EXTI_COEF = 0.0
         AERO_ASYM_FAC  = 0.0

         IF( CALCULATE_EXT_550 )THEN
            ALLOCATE ( AERO_EXTI_550( NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AERO_EXTI_550'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            AERO_EXTI_550  = 0.0
         END IF   

         CALL MAP_AERO()
                  
         ALLOCATE( M3_FACTOR( N_AEROSPC ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating  M3_FACTOR'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE( REFRACT_INDX_MAP( N_AEROSPC ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating REFRACT_INDX_MAP'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
!        IF( CORE_SHELL )THEN
            ALLOCATE( IS_CORE_SPCS( N_AEROSPC,N_MODE ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating IS_CORE_SPCS'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         
            IS_CORE_SPCS = .FALSE.

            ALLOCATE ( CORE_MOMENT3( N_MODE,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating CORE_MOMENT3'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
      
            ALLOCATE ( AE_DGN_CORE( N_MODE,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_DGN_CORE'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
      
            ALLOCATE ( AE_NR_CORE( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_NR_CORE'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
      
            ALLOCATE ( AE_NI_CORE( N_MODE,NLAYS,NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_NI_CORE'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
!        END IF
C ***    Create map for refactive index for each species

#ifdef verbose_phot
         allocate( lambda_list( nwl ) )
         do v = 1, nwl
            write( lambda_list( v ), 5000)int(wavelength( v )), 
     &      int(wavelength( v ))
         end do
         write( logdev, 5001)(lambda_list( v ), v = 1, nwl)
#endif 

         IF ( MIE_CALC .AND. .NOT. CORE_SHELL ) THEN
            CALL M3MESG('For optics of internally mixed aerosol, Mie calculation used')
            CALL M3MESG('Core-shell mixing model option is set to off')
         ELSE IF ( MIE_CALC .AND. CORE_SHELL ) THEN
            CALL M3MESG('For AERO mixing models, core-shell model is possible')
            CALL M3MESG('For optics of aerosols with no core, Mie calculation used')
         ELSE IF ( .NOT. MIE_CALC .AND. CORE_SHELL ) THEN
            CALL M3MESG('For AERO mixing models, core-shell model is possible')
            CALL M3MESG('For optics of aerosols with no core, FASTER_OPTICS used')
         ELSE
            CALL M3MESG('Using internal mixing model for aerosol and FASTER_OPTICS')
         END IF

         FORALL ( SPC = 1:N_MODE ) VOL_MINS( SPC ) = PI6 * AEROMODE( SPC )%MIN_M3CONC

         DO SPC = 1, N_AEROSPC

            M3_FACTOR( SPC ) = REAL( 1.0E-9 * F6DPI / AEROSPC( SPC )%DENSITY, 8 )

            DO M = 1, NUM_REFRACTIVE
               IF ( AEROSPC( SPC )%OPTIC_SURR .EQ. REFRACTIVE_INDEX( M )%NAME ) THEN
                  REFRACT_INDX_MAP( SPC ) = M
                  DO N = 1, N_MODE

                     IF ( CORE_SHELL ) THEN
                        DO V = 1, NUMB_COR_SPCS
                           IF ( AEROSPC( SPC )%NAME( N ) .EQ. CORE_SPCS( V ) ) THEN
                               IS_CORE_SPCS( SPC, N ) = .TRUE.
                           END IF
                        END DO
                     END IF
#ifdef verbose_phot
                     if ( aero_missing(spc,n) ) cycle
                     write( logdev, 5002)trim( aerospc( spc )%name( n ) ), 
     &               trim( refractive_index( m )%name ),is_core_spcs( spc,n ),
     &               (refractive_index( m )%real_part( n,v ), 
     &                refractive_index( m )%imag_part( n,v ), v = 1, nwl)
#endif                  
                  END DO 
                  EXIT
               END IF
            END DO
            IF ( REFRACT_INDX_MAP( SPC ) .LT. 1 ) THEN
               DO M = 1, N_MODE
                  IF ( aero_missing(spc,n) ) CYCLE
                  XMSG = 'Species ' // TRIM( AEROSPC( SPC )%NAME( M ) )
     &                 // ' does not use defined refractive index.'
                  CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT3 )
               END DO
            END IF
         END DO

         IF( CALCULATE_EXT_550 )THEN ! locate 550 nm in wavebands and set-up interpolation 
            IF ( WAVELENGTH( 1 ) .GE. 550.0 )  THEN
                IWL_ANGSTROM_LOWER = 1
            ELSE IF ( WAVELENGTH( NWL ) .LE. 550.0 ) THEN
                IWL_ANGSTROM_LOWER = NWL
            ELSE
                LOOP_FINDW: DO V = 1, NWL - 1
                   IF ( WAVELENGTH( V ) .LT. 550.0 .AND. WAVELENGTH( V+1 ) .GT. 550.0 ) THEN
                      IWL_ANGSTROM_LOWER = V
                      IWL_ANGSTROM_UPPER = V+1
                      ANGSTROM_SPAN      = REAL( 1.0 / LOG( WAVELENGTH( V ) / WAVELENGTH( V+1 ) ), 8 )
                      ANGSTROM_RATIO     = REAL( (WAVELENGTH( V ) / 550.0), 8)
!                     ANGSTROM_RATIO     = REAL( (WAVELENGTH( V ) / WAVELENGTH( V+1 )), 8)
                      LOG_ANGSTROM_RATIO = LOG( ANGSTROM_RATIO )
!                      WRITE(LOGDEV,'(A,2(F7.3,1X))')'Angstrom Interpolation Wavelengths: ', 
!     &                WAVELENGTH( IWL_ANGSTROM_LOWER ), WAVELENGTH( IWL_ANGSTROM_UPPER  )
!                      WRITE(LOGDEV,'(A,2(ES12.4,1X))')'Angstrom Span, Ratio: ', 
!     &                ANGSTROM_SPAN, ANGSTROM_RATIO
                      USE_ANGSTROM_INTERP  = .TRUE.
                      EXIT LOOP_FINDW
                   ELSE IF ( WAVELENGTH( V ) .EQ. 550.0 ) THEN
                      IWL_ANGSTROM_LOWER = V
                      EXIT LOOP_FINDW
                   END IF
                END DO LOOP_FINDW
            END IF
            IF( .NOT. USE_ANGSTROM_INTERP )THEN
               WRITE(LOGDEV,'(A,2(F7.3,1X))')'No Angstrom Inpolation Used 550 Extinction used at ', 
     &         WAVELENGTH( IWL_ANGSTROM_LOWER )
            END IF
         END IF

      RETURN

5000  FORMAT(2X,'NR_',I3.3,7X,'NI_',I3.3,5X)
5002  FORMAT(2(A16,1X),L12,1X,200(ES12.4,1X))                    
5001  FORMAT('     AE_SPC     ',1X,'  REFRACT_INDX  ',1X,'PART_OF_CORE',1X,200(A26))

      END SUBROUTINE INIT_AERO_DATA

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GET_AERO_DATA ( COL, ROW, NLAYS, CGRID )

C-----------------------------------------------------------------------
C  FUNCTION:  This subroutine calculates the volume, the natural logs of 
C     geometric standard of all 3 modes. It assumes that aerosols have inner 
C     core with an outer shell to compute a core and total diameter per mode.  
C     The code also calculates the average modal aerosol refractive indices 
C     for the inner core and outer shell.
C
C     Internally mixed wet aerosols are assumed.
C
C     NOTE
C       2nd moment concentrations (M2) are passed into GETPAR in the
C       CBLK array.  The GETPAR calculations implicitly assume
C       that the input value of M2 is up to date
C       If, for example, the input M2 value was calculated
C       for a "dry" aerosol and the Wet_Moments_FLAG is .TRUE., GETPAR would
C       incorrectly adjust the M2 concentrations!
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  EXTRACT_AERO, EXTRACT_SOA, GETPAR
C                                     AERO_OPTICAL2, AERO_OPTICAL_CS  
C  REVISION HISTORY
C     06/13/13 B.Hutzell - initial version created for aero_photdata.F 
C                          from version 5.01
C     05/2016 H. Pye and B. Murphy - updated treatment of aerosol
C                          moments
C     05/23/16 D.Wong - replaced RRTMG_AERO_OPTICAL_UTIL_MODULE with
C                       CMAQ_RRTMG_AERO_OPTICAL_UTIL_MODULE to avoid
C                       duplication of the same module name on WRF side
C                       of the two-way model
C
C  REFERENCES:
C     Horvath, H., Size segrated light absorption coefficient for
C     the atmospheric aerosol, Atmos. Environ., Vol. 29, No. 8,
C     pp 875-883, 1995.
C
C     Beyer, K.D. A.R. Ravishankara, and E. R. Lovejoy, Meanurements
C     of H2SO4/H2O and H2SO4/HNO3/H2O solutions, J. Geophys. Res. Vol.
C     101, D9, pp 14519-14524, 1996.
C
C-----------------------------------------------------------------------

!     USE GRID_CONF           ! horizontal & vertical domain specifications
      USE RXNS_DATA
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

      USE AERO_DATA           ! aero variable data
      USE SOA_DEFN            ! gas soa data
      USE AEROMET_DATA        ! constants and met data
      
      USE CSQY_DATA,  ONLY : NWL => NWL_REF, NUM_REFRACTIVE, REFRACTIVE_INDEX,
     &                       WAVELENGTH => EFFWL_REF

      USE CMAQ_RRTMG_AERO_OPTICAL_UTIL_MODULE, ONLY : AERO_OPTICAL2, AERO_OPTICAL_CS

      IMPLICIT NONE

C Includes:

C Arguments:

      INTEGER, INTENT( IN ) :: COL               ! specified column index
      INTEGER, INTENT( IN ) :: ROW               ! specified row index
      INTEGER, INTENT( IN ) :: NLAYS             ! # of vertical layers
      REAL,    POINTER      :: CGRID( :,:,:,: )

C Parameters:

      REAL( 8 ), PARAMETER :: NEGLECT_FRAC = 1.0D-9      ! skip if below this volume fraction
      REAL( 8 ), PARAMETER :: ONE_THIRD    = 1.0D0/3.0D0 
      REAL,      PARAMETER :: ONE_OVER_PI  = 1.0 / PI

C Local saved variables:

      CHARACTER( 16 ), SAVE :: AE_VRSN                  ! Aerosol version name
      CHARACTER( 32 ), SAVE :: PNAME = 'GET_AERO_DATA'  ! routine name

C Local variables:

      CHARACTER( 16 ) :: VNAME            ! varable name
      CHARACTER( 96 ) :: XMSG = ' '

      REAL( 8 ) :: FACTOR
      REAL( 8 ) :: FRACTION_CORE
      REAL( 8 ) :: FRACTION_SHELL
      REAL( 8 ) :: MOMENT3_PORTION
      REAL( 8 ) :: SUMRI_R_SHELL
      REAL( 8 ) :: SUMRI_I_SHELL
      REAL( 8 ) :: SUMRI_R_CORE
      REAL( 8 ) :: SUMRI_I_CORE
      REAL( 8 ) :: SUMRI_R
      REAL( 8 ) :: SUMRI_I

      REAL DGN_CORE       ! geometric mean diameters of aerosol core
      REAL VOL            ! Total Modal aerosol volume
      REAL VOL_CORE       ! Modal aerosol volume of aerosol core
      REAL DGN_SHELL      ! geometric mean diameters of aerosol core
      REAL VOL_SHELL      ! Modal aerosol volume of aerosol core
      REAL XXLSG          ! geometric standard deviation
      REAL MIE_PARAMETER  ! Modal Mie parameter

C***  variables for calculating modal averaged properties per layer and lambda

      COMPLEX NR_SHELL
      COMPLEX NI_SHELL
      COMPLEX NR_CORE
      COMPLEX NI_CORE

      REAL BEXT_MODE  ! total aerosol extinction coefficient [ 1/m ]
      REAL BSCAT_MODE ! total aerosol scattering coefficient [ 1/m ]
      REAL GBAR_MODE  ! total aerosol asymmetry factor
      REAL BEXT       ! total aerosol extinction coefficient [ 1/m ]
      REAL VFAC, BSC  ! unit correction factors
      REAL BSCAT      ! total aerosol scattering coefficient [ 1/m ]
      REAL G_BAR      ! total aerosol asymmetry factor
      REAL INV_LAMBDA ! reciprocal of wavelength [ 1/m ]
      REAL LAMDA_UM   ! wavelength  [ um ]

      INTEGER L, V, N, M            ! loop counters
      INTEGER SPC                   ! species loop counter
      INTEGER MODE                  ! aerosol mode loop counter
      LOGICAL SUCCESS
      LOGICAL TROUBLE
      LOGICAL, SAVE    :: FIRSTCALL  = .TRUE.
 
#ifdef verbose_phot
      character( 26 ), allocatable :: lambda_list( : )
#endif
      
C-----------------------------------------------------------------------

      IF ( N_AE_SPC .LE. 0 ) RETURN

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Put the grid cell physical data in the block arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

C *** initialize internal and external dimensions of aerosols

      CORE_MOMENT3  = 0.0D+0
      SHELL_MOMENT3 = 0.0D+0
      BLK_AE_VOL    = 0.0
      BLK_AE_CONC   = 0.0
      AE_DGN_SHELL  = 0.0
      AE_DGN_CORE   = 0.0
      SUCCESS       = .TRUE.


      LAY_LOOP1: DO L = 1, NLAYS

C *** extract grid cell concentrations of aero species from CGRID into aerospc_conc 
C *** in aero_data module
C     Also converts dry surface area to wet second moment
#ifdef sens
         CALL EXTRACT_AERO ( CGRID( COL,ROW,L,: ), .TRUE., CGRID( COL,ROW,:,: ), .FALSE. )
#else
         CALL EXTRACT_AERO ( CGRID( COL,ROW,L,: ), .TRUE. )
#endif

C *** extract soa concentrations from CGRID
         CALL EXTRACT_SOA ( CGRID( COL,ROW,L,: ) )

C *** Calculate geometric mean diameters and standard deviations of "wet" size distribution
         CALL GETPAR ( .FALSE. )

#ifdef verbose_phot
         if(col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 )then
            do m = 1, n_mode
               write(logdev, 4999)l, m, aeromode_diam( m ),pi6*moment3_conc( m ),
     &         aeromode_lnsg( m )
4999           format('lay = ',i3,' mode = ',i3,' diam = ',es12.4,' pi6*moment3 = ', 
     &         es12.4,' ae_lsg = ', es12.4)
           end do
         end if
#endif

         DIME_LOOP: DO MODE = 1, N_MODE

            FRACTION_CORE  = 0.0D+0
            FRACTION_SHELL = 0.0D+0
            
            SPC_LOOP1: DO SPC = 1, N_AEROSPC
               IF ( AEROSPC( SPC )%TRACER ) CYCLE      ! skip tracer species
               IF ( AERO_MISSING( SPC,MODE ) ) CYCLE   ! skip undefined species
               BLK_AE_CONC( SPC,MODE,L ) = AEROSPC_CONC( SPC,MODE )

               MOMENT3_PORTION = M3_FACTOR( SPC ) * REAL( AEROSPC_CONC( SPC,MODE ), 8 )
               IF ( IS_CORE_SPCS( SPC,MODE ) ) THEN  
                  CORE_MOMENT3( MODE,L )  = CORE_MOMENT3( MODE,L )  + MOMENT3_PORTION
#ifdef verbose_phot
                  if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
                     write(logdev,5007)aerospc( spc )%name( mode ),moment3_portion,
     &               core_moment3( mode, l )
5007                 format(a16,1x,'moment3_portion = ',es12.4,1x,'moment3_core = ',es12.4 )
                  end if
#endif 
               ELSE 
                  SHELL_MOMENT3( MODE,L ) = SHELL_MOMENT3( MODE,L ) + MOMENT3_PORTION
#ifdef verbose_phot
                  if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
                     write(logdev,5008)aerospc( spc )%name( mode ),moment3_portion,
     &               shell_moment3( mode, l )
5008                 format(a16,1x,'moment3_portion = ',es12.4,1x,'moment3_shell = ',es12.4 )
                  end if
#endif 
               END IF 
            END DO SPC_LOOP1


            FRACTION_CORE  = CORE_MOMENT3(  MODE,L ) / REAL( MOMENT3_CONC( MODE ), 8 )
            FRACTION_SHELL = SHELL_MOMENT3( MODE,L ) / REAL( MOMENT3_CONC( MODE ), 8 )

            BLK_AE_LSG  ( MODE,L ) = AEROMODE_LNSG( MODE )
            AE_DGN_SHELL( MODE,L ) = AEROMODE_DIAM( MODE )

            IF ( FRACTION_CORE .LT. NEGLECT_FRAC ) THEN
               AE_DGN_CORE( MODE,L ) = 0.0
            ELSE
               FACTOR = FRACTION_CORE ** ONE_THIRD
               AE_DGN_CORE( MODE,L ) = REAL( FACTOR * AEROMODE_DIAM( MODE ) )
            END IF

            IF ( MOMENT3_CONC( MODE ) .GT. AEROMODE( MODE )%MIN_M3CONC ) THEN
               BLK_AE_VOL( MODE,L ) = PI6 * MOMENT3_CONC( MODE )
            END IF

#ifdef verbose_phot
            if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
               write(logdev, 5006)l, mode, ae_dgn_core( mode,l ), ae_dgn_shell( mode,l ),
     &         blk_ae_vol( mode,l ),blk_ae_lsg( mode,l) 
5006           format('lay = ',i3,' mode = ',i3,' dgn_core = ', es12.4, ' dgn_shell = ', 
     &         es12.4,' ae_vol = ', es12.4,' ae_lsg = ', es12.4)
            end if
#endif

         END DO DIME_LOOP

      END DO LAY_LOOP1

C *** Initialize refractive indices then compute

      AE_NR_SHELL = 0.0
      AE_NI_SHELL = 0.0
      AE_NR_CORE  = 0.0
      AE_NI_CORE  = 0.0

      LOOP_WAVE: DO V = 1, NWL

         LAMDA_UM   = 1.0E-3 * WAVELENGTH( V ) ! convert to micro-meters
         INV_LAMBDA = 1.0E9 / WAVELENGTH( V )

         LAY_LOOP2: DO L = 1, NLAYS

            REFRAC_LOOP: DO MODE = 1, N_MODE

               SUMRI_R_SHELL = 0.0D+0
               SUMRI_I_SHELL = 0.0D+0
               SUMRI_R_CORE  = 0.0D+0
               SUMRI_I_CORE  = 0.0D+0

               SPC_LOOP2: DO SPC = 1, N_AEROSPC
                  IF ( AEROSPC( SPC )%TRACER ) CYCLE              ! neglect tracer species
                  IF ( AERO_MISSING( SPC,MODE ) ) CYCLE  ! neglect undefined species

                  M = REFRACT_INDX_MAP( SPC )

                  MOMENT3_PORTION = M3_FACTOR( SPC ) * REAL( BLK_AE_CONC( SPC,MODE,L ), 8)
     
                  IF ( IS_CORE_SPCS( SPC, MODE ) ) THEN  
                  
                     SUMRI_R_CORE = SUMRI_R_CORE + MOMENT3_PORTION
     &                            * REAL( REFRACTIVE_INDEX( M )%REAL_PART( MODE,V ), 8)
                     SUMRI_I_CORE = SUMRI_I_CORE + MOMENT3_PORTION
     &                            * REAL( REFRACTIVE_INDEX( M )%IMAG_PART( MODE,V ), 8)

                  ELSE

                     SUMRI_R_SHELL = SUMRI_R_SHELL + MOMENT3_PORTION
     &                             * REAL( REFRACTIVE_INDEX( M )%REAL_PART( MODE,V ), 8)
                     SUMRI_I_SHELL = SUMRI_I_SHELL + MOMENT3_PORTION
     &                             * REAL( REFRACTIVE_INDEX( M )%IMAG_PART( MODE,V ), 8)

                  END IF
                  
               END DO SPC_LOOP2

C ***       Update output array values
               
               IF ( CORE_MOMENT3( MODE,L ) .GT. 0.0D0 ) THEN
                   AE_NR_CORE ( MODE,L,V ) = REAL( SUMRI_R_CORE / CORE_MOMENT3( MODE,L ) )
                   AE_NI_CORE ( MODE,L,V ) = REAL( SUMRI_I_CORE / CORE_MOMENT3( MODE,L ) )
               END IF
               
               IF ( SHELL_MOMENT3( MODE,L ) .GT. 0.0D0 ) THEN
                   AE_NR_SHELL ( MODE,L,V ) = REAL( SUMRI_R_SHELL / SHELL_MOMENT3( MODE,L ) )
                   AE_NI_SHELL ( MODE,L,V ) = REAL( SUMRI_I_SHELL / SHELL_MOMENT3( MODE,L ) )
               END IF
               
            END DO REFRAC_LOOP

C***loop over mode again for mean modal extinction and scattering properties
        
            G_BAR = 0.0
            BEXT  = 0.0
            BSCAT = 0.0

#ifdef verbose_phot_extra
            if ( L .eq. 1 .and. V .eq. 1 ) then

               write(LOGDEV, 9501)L, wavelength( V ), ae_dgn_core(  m,l ), ae_dgn_shell( m, l ), 
     &         ae_nr_shell( m,L,V ), ae_ni_shell( m,L,V ), ae_nr_core( m,L,V ), 
     &         ae_ni_core( m,L,V )

9501           format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ',
     &                 2(es12.4,1x))

               end if
#endif            

            OPTICS_LOOP: DO MODE = 1, N_MODE
               TROUBLE = .FALSE.
            
               DGN_CORE  = AE_DGN_CORE(  MODE,L )
               DGN_SHELL = AE_DGN_SHELL( MODE,L )
         
               VOL = BLK_AE_VOL( MODE,L )
 
               NR_SHELL = CMPLX( AE_NR_SHELL( MODE,L,V ), AE_NI_SHELL( MODE,L,V ) )

               IF ( AE_NR_SHELL( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
               IF ( AE_NI_SHELL( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
        
               XXLSG = EXP( BLK_AE_LSG( MODE,L ) )

C***calculate the extinction and scattering coefficients in [ 1 / m ] and the asymmetry 
C*** factor for aerosols.

               IF ( DGN_CORE .GT. 0.0 .AND. DGN_CORE / DGN_SHELL .LT. 0.999 ) THEN

                  VOL_CORE  = PI6 * REAL( CORE_MOMENT3( MODE,L ), 4 )
                  VOL_SHELL = PI6 * REAL( SHELL_MOMENT3( MODE,L ), 4 )

                  NR_CORE  = CMPLX( AE_NR_CORE( MODE,L,V ), AE_NI_CORE( MODE,L,V ) )

                  IF ( AE_NR_CORE( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
                  IF ( AE_NI_CORE( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.

                  IF ( VOL_SHELL .LE. 0.0 ) THEN
                     SUCCESS = .FALSE.
!                    WRITE(6,*)TRIM(PNAME),': VOL_SHELL(',MODE,') = ',VOL_SHELL
                  END IF

                  IF ( VOL_CORE .LE. 0.0 ) THEN
                     SUCCESS = .FALSE.
!                    WRITE(6,*)TRIM(PNAME),':  VOL_CORE(',MODE,') = ',VOL_CORE
                  END IF

                  IF ( DGN_SHELL .LE. 0.0 ) SUCCESS = .FALSE.
                   
C *** Core-Shell case for optics         
                  IF ( SUCCESS ) CALL AERO_OPTICAL_CS( LAMDA_UM, NR_CORE, NR_SHELL,  
     &                                   VOL_CORE, VOL_SHELL, DGN_CORE,      
     &                                   DGN_SHELL, XXLSG,
     &                                   BEXT_MODE, BSCAT_MODE, GBAR_MODE, SUCCESS )

                  VFAC  = 1.0 ! correction factor 

                  IF ( .NOT. SUCCESS ) THEN
     
                     WRITE( LOGDEV,9503 ) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_CORE( MODE,L ), AE_DGN_SHELL( MODE,L ),
     &               AE_NR_SHELL( MODE,L,V ), AE_NI_SHELL( MODE,L,V ),
     &               AE_NR_CORE( MODE,L,V ),  AE_NI_CORE( MODE,L,V ),
     &               BLK_AE_LSG( MODE,L )
     
                     XMSG =  'FAILURE IN AERO_OPTICAL_CS: core with shell case '
                     CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
                     
                  END IF

C***sum to get total extinction and scattering
C***  and contribution to the overall asymmetry factor

                  BEXT  = BEXT  + BEXT_MODE
                  BSCAT = BSCAT + BSCAT_MODE
                  G_BAR = G_BAR + BSCAT_MODE * GBAR_MODE

               ELSE IF ( VOL .GT. 0.0 ) THEN

!*** FSB Internal Volume mixture case for optics 
                  IF ( MIE_CALC ) THEN
                     IF ( SUCCESS ) CALL AERO_OPTICAL2( LAMDA_UM, NR_SHELL, VOL, 
     &                                   DGN_SHELL, XXLSG,
     &                                   BEXT_MODE, BSCAT_MODE, GBAR_MODE, SUCCESS )
                     VFAC  = 1.0 ! correction factor 
                  ELSE 
! use old fast optics method
                     IF ( SUCCESS ) CALL FAST_OPTICS( AE_NR_SHELL( MODE, L, V ),  
     &                                       AE_NI_SHELL( MODE, L, V ), 
     &                                       WAVELENGTH( V ), DGN_SHELL, XXLSG, 
     &                                       BEXT_MODE, BSCAT_MODE, GBAR_MODE )
                     VFAC  = VOL * INV_LAMBDA
! updated fast optics method; has problems from eposidically infinite values of aerosol optical depth
!                    MIE_PARAMETER = PI * DGN_SHELL * INV_LAMBDA
!     &                            * EXP( 3.0 * BLK_AE_LSG( MODE, L ) * BLK_AE_LSG( MODE, L ) )

!                    IF( SUCCESS ) CALL FASTER_OPTICS( AE_NR_SHELL( MODE, L, V ),  
!     &                                       AE_NI_SHELL( MODE, L, V ), 
!     &                                       MIE_PARAMETER, BLK_AE_LSG( MODE, L ), 
!     &                                       BEXT_MODE, BSCAT_MODE, GBAR_MODE )
!                    VFAC  = VOL * INV_LAMBDA
                  END IF
                   
                  IF ( BEXT_MODE .LT. 0.0 .OR. BEXT_MODE .LT. BSCAT_MODE .OR. BSCAT_MODE .LT. 0.0 ) THEN
                     TROUBLE = .TRUE.
                  END IF

                  IF ( BEXT_MODE .NE. BEXT_MODE .OR. BSCAT_MODE .NE. BSCAT_MODE ) THEN
                     TROUBLE = .TRUE.
                  END IF

                  IF ( GBAR_MODE .NE. GBAR_MODE .OR. ABS( GBAR_MODE ) .GT. 0.9999999 ) THEN
                     TROUBLE = .TRUE.
                  END IF

9402              format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' ae_bext = ',es12.4,' ae_bscat = ',es12.4,' ae_gbar = ',es12.4,
     &                 ' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ', 2(es12.4,1x))

                  IF ( TROUBLE ) THEN

                     write(logdev, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
     &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )
!                    write(6, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
!    &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
!    &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )

                     WRITE( LOGDEV, 9504 ) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_SHELL( MODE,L ), AE_NR_SHELL( MODE,L,V ),
     &               AE_NI_SHELL( MODE,L,V ), BLK_AE_VOL( MODE,L ),
     &               BLK_AE_LSG( MODE,L )
     
                     XMSG =  'FAILURE IN AERO_OPTICAL2: shell only case '
                     CALL M3WARN( PNAME, 0, 0, XMSG )
                     
                  END IF

                  IF ( .NOT. SUCCESS ) THEN

                     write(logdev, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
     &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )
!                    write(6, 9402)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
!    &               bscat_mode, gbar_mode, ae_nr_shell( mode, l, v ), ae_ni_shell( mode, l, v ),
!    &               ae_nr_core( mode, l, v ), ae_ni_core( mode, l, v )

                     WRITE( LOGDEV, 9504) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_SHELL( MODE,L ), AE_NR_SHELL( MODE,L,V ),
     &               AE_NI_SHELL( MODE,L,V ), BLK_AE_VOL( MODE,L ),
     &               BLK_AE_LSG( MODE,L )
     
                     XMSG =  'FAILURE IN AERO_OPTICAL2: shell only case '
                     CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
                     
                  END IF

C***sum to get total extinction and scattering
C***  and contribution to the overall asymmetry factor

                  BEXT  = BEXT + VFAC * BEXT_MODE
                  BSC   = VFAC * BSCAT_MODE
                  BSCAT = BSCAT + BSC
                  G_BAR = G_BAR + BSC * GBAR_MODE

               END IF       

            END DO OPTICS_LOOP

            AERO_SCAT_COEF( L,V ) = BSCAT
            AERO_EXTI_COEF( L,V ) = MAX( BEXT, 1.0E-30 )
            AERO_ASYM_FAC ( L,V ) = G_BAR / MAX( BSCAT, 1.0E-30 )

#ifdef verbose_phot_extra
            if( l .eq. 1 .and. v .eq. 1)then
               write(logdev, 9502)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &         bscat_mode, gbar_mode, ae_nr_shell( l, mode, v ), ae_ni_shell( v, mode, v ),
     &         ae_nr_core( l, mode, iv ), ae_ni_core( l, mode, v )
9502           format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' ae_bext = ',es12.4,' ae_bscat = ',es12.4,' ae_gbar = ',es12.4,
     &                 ' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ', 2(es12.4,1x))
            end if
#endif            

         END DO LAY_LOOP2         

      END DO LOOP_WAVE

      IF( CALCULATE_EXT_550 )THEN
!         IF( USE_ANGSTROM_INTERP .AND. FIRSTCALL )THEN
!          WRITE(LOGDEV,'(A,2(F7.3,1X))')'Angstrom Interpolation Wavelengths: ', 
!     &     WAVELENGTH( IWL_ANGSTROM_LOWER ), WAVELENGTH( IWL_ANGSTROM_UPPER  )
!           WRITE(LOGDEV,'(A,2(ES12.4,1X))')'Angstrom Span, Ratio: ', 
!     &     ANGSTROM_SPAN, ANGSTROM_RATIO
!         END IF
         LOOP_550NM: DO L = 1, NLAYS
              IF( USE_ANGSTROM_INTERP )THEN
                 ANGSTROM_EXPONENT  =  - REAL( LOG( AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ) 
     &                                         / AERO_EXTI_COEF( L,IWL_ANGSTROM_UPPER ) ), 8 )
     &                              *  ANGSTROM_SPAN
!                AERO_EXTI_550( L ) = LOG( AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ) )
!    &                              + REAL( ANGSTROM_EXPONENT * LOG_ANGSTROM_RATIO, 4 )
!                AERO_EXTI_550( L ) =  EXP( AERO_EXTI_550( L ) )
                 AERO_EXTI_550( L ) =  AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ) 
     &                              *  REAL( ANGSTROM_RATIO ** ANGSTROM_EXPONENT, 4 )
!                 IF ( FIRSTCALL ) THEN
!                     WRITE( LOGDEV,'(I3,A,7(ES12.4,1X))')L,
!     &              ' AERO_EXT_LOWER,AERO_EXT_UPPER,EXPONENT,EXPONENT*LOG(RATIO),EXT_550_1,EXT_550_2: ',
!     &               AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER ), AERO_EXTI_COEF( L,IWL_ANGSTROM_UPPER ),
!     &               ANGSTROM_EXPONENT,REAL( ANGSTROM_EXPONENT * LOG_ANGSTROM_RATIO,4),AERO_EXTI_550( L ),
!     &               AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER)*ANGSTROM_RATIO ** ANGSTROM_EXPONENT
!                 END IF
              ELSE
                 AERO_EXTI_550( L ) =  AERO_EXTI_COEF( L,IWL_ANGSTROM_LOWER )
              END IF
         END DO LOOP_550NM
!         IF ( FIRSTCALL ) FIRSTCALL = .FALSE.
      END IF 
      
#ifdef verbose_phot
      if ( col .eq. 1 .and. row .eq. 1 ) then
         l = 1
         v = 1
         do mode = 1, n_mode
            write(logdev, 5005)l, mode, v, ae_nr_core ( mode, l, v ), ae_ni_core ( mode, l, v ),
     &      ae_nr_shell ( mode, l, v ), ae_ni_shell ( mode, l, v )
5005        format('lay = ',i3,' mode = ',i3,' wlv index = ',i3,' ae_core(nr,ni) = ',
     &      2(es12.4,1x), ' ae_shell(nr,ni) = ', 2(es12.4,1x))
         end do
      end if
#endif

9503  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN_CORE(m) = ',ES12.4,
     &       ' DGN_SHELL(m) = ', ES12.4 / ' REFRACT_IDX_SHELL(NR,NI) = ', 2(ES12.4,1X),
     &       ' REFRACT_IDX_CORE(NR,NI) = ', 2(ES12.4,1X) / ' LN(GEO.STD.DEV.) = ',
     &       ES12.4)
9504  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN(m) = ',ES12.4,
     &       ' REFRACT_IDX(NR,NI) = ', 2(ES12.4,1X) / ' VOL.DENS. = ', ES12.4,
     &       ' LN(GEO.STD.DEV.) = ', ES12.4)

      RETURN
      END SUBROUTINE GET_AERO_DATA

CC:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO_OPTICS_INTERNAL ( COL, ROW, NLAYS, CGRID )

C-----------------------------------------------------------------------
C  FUNCTION:  This subroutine calculates the volume, the natural logs of 
C     geometric standard of all 3 modes. It assumes that aerosols have inner 
C     core with an outer shell to compute a core and total diameter per mode.  
C     The code also calculates the average modal aerosol refractive indices 
C     for the inner core and outer shell.
C
C     Internally mixed wet aerosols are assumed.
C
C     NOTE
C       2nd moment concentrations (M2) are passed into GETPAR in the
C       CBLK array.  The GETPAR calculations implicitly assume
C       that the input value of M2 is up to date.  
C       If, for example, the input M2 value was calculated
C       for a "dry" aerosol and the Wet_Moments_FLAG is .TRUE., GETPAR would
C       incorrectly adjust the M2 concentrations!
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  EXTRACT_AERO, EXTRACT_SOA, GETPAR
C                                     AERO_OPTICAL2, AERO_OPTICAL_CS  
C  REVISION HISTORY
C     06/13/13 B.Hutzell - initial version created for aero_photdata.F 
C                          from version 5.01
C     05/2016 H. Pye and B. Murphy - updated treatment of aerosol
C                          moments
C     05/23/16 D.Wong - replaced RRTMG_AERO_OPTICAL_UTIL_MODULE with
C                       CMAQ_RRTMG_AERO_OPTICAL_UTIL_MODULE to avoid
C                       duplication of the same module name on WRF side
C                       of the two-way model
C
C  REFERENCES:
C     Horvath, H., Size segrated light absorption coefficient for
C     the atmospheric aerosol, Atmos. Environ., Vol. 29, No. 8,
C     pp 875-883, 1995.
C
C     Beyer, K.D. A.R. Ravishankara, and E. R. Lovejoy, Meanurements
C     of H2SO4/H2O and H2SO4/HNO3/H2O solutions, J. Geophys. Res. Vol.
C     101, D9, pp 14519-14524, 1996.
C
C-----------------------------------------------------------------------

!     USE GRID_CONF           ! horizontal & vertical domain specifications
      USE RXNS_DATA
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

      USE AERO_DATA           ! aero variable data
      USE SOA_DEFN            ! gas soa data
      USE AEROMET_DATA        ! constants and met data
      
      USE CSQY_DATA, ONLY : NWL => NWL_REF, NUM_REFRACTIVE, REFRACTIVE_INDEX,
     &                       WAVELENGTH => EFFWL_REF

      USE CMAQ_RRTMG_AERO_OPTICAL_UTIL_MODULE, ONLY : AERO_OPTICAL2, AERO_OPTICAL_CS

      IMPLICIT NONE

C Includes:

C Arguments:

      INTEGER, INTENT( IN ) :: COL               ! specified column index
      INTEGER, INTENT( IN ) :: ROW               ! specified row index
      INTEGER, INTENT( IN ) :: NLAYS             ! # of vertical layers
      REAL,    POINTER      :: CGRID( :,:,:,: )

C Parameters:

      REAL( 8 ), PARAMETER :: NEGLECT_FRAC = 1.0D-9      ! skip if below this volume fraction
      REAL( 8 ), PARAMETER :: ONE_THIRD    = 1.0D0/3.0D0 
      REAL,      PARAMETER :: ONE_OVER_PI  = 1.0 / PI

C Local saved variables:

      CHARACTER( 16 ), SAVE :: AE_VRSN                            ! Aerosol version name
      CHARACTER( 32 ), SAVE :: PNAME = 'AERO_OPTICS_INTERNAL'            ! routine name

C Local variables:

      CHARACTER( 16 ) :: VNAME            ! varable name
      CHARACTER( 96 ) :: XMSG = ' '

      REAL( 8 ) :: FACTOR
      REAL( 8 ) :: SUMRI_R
      REAL( 8 ) :: SUMRI_I

      REAL VOL            ! Total Modal aerosol volume
      REAL DGN_SHELL      ! geometric mean diameters of aerosol core
      REAL VOL_SHELL      ! Modal aerosol volume of aerosol core
      REAL XXLSG          ! geometric standard deviation
      REAL MIE_PARAMETER  ! Modal Mie parameter
      REAL SUMRI_R_SHELL
      REAL SUMRI_I_SHELL
      REAL MOMENT3_PORTION

C***  variables for calculating modal averaged properties per layer and lambda

      COMPLEX NR_SHELL
      COMPLEX NI_SHELL

      REAL BEXT_MODE  ! total aerosol extinction coefficient [ 1/m ]
      REAL BSCAT_MODE ! total aerosol scattering coefficient [ 1/m ]
      REAL GBAR_MODE  ! total aerosol asymmetry factor
      REAL BEXT       ! total aerosol extinction coefficient [ 1/m ]
      REAL VFAC, BSC  ! unit correction factors
      REAL BSCAT      ! total aerosol scattering coefficient [ 1/m ]
      REAL G_BAR      ! total aerosol asymmetry factor
      REAL INV_LAMBDA ! reciprocal of wavelength [ 1/m ]
      REAL LAMDA_UM   ! wavelength  [ um ]

      INTEGER L, V, N, M            ! loop counters
      INTEGER SPC                   ! species loop counter
      INTEGER MODE                  ! aerosol mode loop counter
      LOGICAL SUCCESS

#ifdef verbose_phot
      character( 26 ), allocatable :: lambda_list( : )
#endif

C-----------------------------------------------------------------------

      IF ( N_AE_SPC .LE. 0 ) RETURN

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Put the grid cell physical data in the block arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc


C *** initialize internal and external dimensions of aerosols

      CORE_MOMENT3  = 0.0D+0
      SHELL_MOMENT3 = 0.0D+0
      BLK_AE_VOL    = 0.0
      BLK_AE_CONC   = 0.0
      AE_DGN_SHELL  = 0.0
      AE_DGN_CORE   = 0.0
      SUCCESS       = .TRUE.

      LAY_LOOP1: DO L = 1, NLAYS

C *** extract grid cell concentrations of aero species from CGRID into aerospc_conc 
C *** in aero_data module
C     Also converts surface area to wet second moment
#ifdef sens
         CALL EXTRACT_AERO ( CGRID( COL,ROW,L,: ), .TRUE., CGRID( COL,ROW,:,: ), .FALSE. )
#else
         CALL EXTRACT_AERO ( CGRID( COL,ROW,L,: ), .TRUE. )
#endif

C *** extract soa concentrations from CGRID
         CALL EXTRACT_SOA ( CGRID( COL,ROW,L,: ) )

C *** Calculate geometric mean diameters and standard deviations of "wet" size distribution
         CALL GETPAR ( .FALSE. )

#ifdef verbose_phot
         if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
            do m = 1, n_mode
               write(logdev, 4999)l, m, aeromode_diam( m ),pi6*moment3_conc( m ),
     &         aeromode_lnsg( m )
4999           format('lay = ',i3,' mode = ',i3,' diam = ',es12.4,' pi6*moment3 = ', 
     &         es12.4,' ae_lsg = ', es12.4)
            end do
         end if
#endif

         DIME_LOOP: DO MODE = 1, N_MODE
            SPC_LOOP1: DO SPC = 1, N_AEROSPC
               IF ( AEROSPC( SPC )%TRACER ) CYCLE              ! neglect tracer species
               IF ( AERO_MISSING( SPC,MODE ) ) CYCLE  ! neglect undefined species
               BLK_AE_CONC( SPC,MODE,L ) = AEROSPC_CONC( SPC,MODE )

               MOMENT3_PORTION          = REAL( M3_FACTOR( SPC ) ) * AEROSPC_CONC( SPC,MODE )
               SHELL_MOMENT3( MODE,L ) = SHELL_MOMENT3( MODE,L ) + REAL( MOMENT3_PORTION, 8 )
#ifdef verbose_phot
               if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
                  write(logdev,5008)aerospc( spc )%name( mode ),moment3_portion, shell_moment3( mode, l )
5008              format(a16,1x,'moment3_portion = ',es12.4,1x,'moment3_shell = ',es12.4)
               end if
#endif 
            END DO SPC_LOOP1

            BLK_AE_LSG  ( MODE,L ) = aeromode_lnsg( MODE )
            AE_DGN_SHELL( MODE,L ) = AEROMODE_DIAM( MODE )
                   
            IF ( MOMENT3_CONC( MODE ) .GT. AEROMODE( MODE )%MIN_M3CONC ) THEN
               BLK_AE_VOL( MODE,L ) = PI6 * MOMENT3_CONC( MODE )
            END IF
            
#ifdef verbose_phot
            if ( col .eq. 1 .and. row .eq. 1 .and. l .eq. 1 ) then
               write(logdev, 5006)l, mode, ae_dgn_core( mode, l ), ae_dgn_shell( mode, l ),
     &         blk_ae_vol( mode, l ),blk_ae_lsg( mode, l) 
5006           format('lay = ',i3,' mode = ',i3,' dgn_core = ', es12.4, ' dgn_shell = ', 
     &         es12.4,' ae_vol = ', es12.4,' ae_lsg = ', es12.4)
            end if
#endif

         END DO DIME_LOOP
      END DO LAY_LOOP1

C *** Initialize refractive indices then compute
      AE_NR_SHELL = 0.0
      AE_NI_SHELL = 0.0
         
      LOOP_WAVE: DO V = 1, NWL
         LAMDA_UM   = 1.0E-3 * WAVELENGTH( V ) ! convert to micro-meters
         INV_LAMBDA = 1.0E9 / WAVELENGTH( V )

         LAY_LOOP2: DO L = 1, NLAYS
            REFRAC_LOOP: DO MODE = 1, N_MODE
               SUMRI_R_SHELL = 0.0D0
               SUMRI_I_SHELL = 0.0D0

               IF ( SHELL_MOMENT3( MODE, L ) .LE. 0.0D0 ) CYCLE
               SPC_LOOP2: DO SPC = 1, N_AEROSPC
                  IF ( AEROSPC( SPC )%TRACER ) CYCLE     ! skip tracer species
                  IF ( AERO_MISSING( SPC,MODE ) ) CYCLE  ! skip undefined species

                  M = REFRACT_INDX_MAP( SPC )

                  MOMENT3_PORTION  = REAL( M3_FACTOR( SPC ) ) * BLK_AE_CONC( SPC,MODE,L )

                  SUMRI_R_SHELL = SUMRI_R_SHELL + MOMENT3_PORTION
     &                          * REFRACTIVE_INDEX( M )%REAL_PART( MODE,V )
                  SUMRI_I_SHELL = SUMRI_I_SHELL + MOMENT3_PORTION
     &                          * REFRACTIVE_INDEX( M )%IMAG_PART( MODE,V )

               END DO SPC_LOOP2
C ***       Update output array values
               VFAC = REAL( 1.0D0 / SHELL_MOMENT3( MODE,L ) ) 
               AE_NR_SHELL ( MODE,L,V ) = SUMRI_R_SHELL * VFAC 
               AE_NI_SHELL ( MODE,L,V ) = SUMRI_I_SHELL * VFAC
            END DO REFRAC_LOOP

C***loop over mode again for mean modal extinction and scattering properties

            G_BAR = 0.0
            BEXT  = 0.0
            BSCAT = 0.0

#ifdef verbose_phot_extra
            if ( L .eq. 1 .and. V .eq. 1 ) then

               write( LOGDEV, 9501) L, wavelength( V ), ae_dgn_core(  2, l ), ae_dgn_shell( 2, l ), 
     &         ae_nr_shell( 2, L, V ), ae_ni_shell( 2, L, V ), ae_nr_core( 2, L, V ), 
     &         ae_ni_core( 2, L, V )

9501           format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ', 
     &                 2(es12.4,1x))

            end if
#endif            
            

            OPTICS_LOOP: DO MODE = 1, N_MODE

               DGN_SHELL = AE_DGN_SHELL( MODE,L )
               VOL = BLK_AE_VOL( MODE,L )
               NR_SHELL = CMPLX( AE_NR_SHELL( MODE,L,V ), AE_NI_SHELL( MODE,L,V ) )

!              IF ( AE_NR_SHELL( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
!              IF ( AE_NI_SHELL( MODE,L,V ) .LE. 0.0 ) SUCCESS = .FALSE.
        
C***calculate the extinction and scattering coefficients in [ 1 / m ] and the asymmetry 
C*** factor for aerosols.

               IF ( VOL .GT. 0.0 ) THEN

!*** FSB Internal Volume mixture case for optics 
                  IF ( MIE_CALC ) THEN
                     XXLSG = EXP( BLK_AE_LSG( MODE, L ) )
                     IF( SUCCESS ) CALL AERO_OPTICAL2( LAMDA_UM, NR_SHELL, VOL, 
     &                                   DGN_SHELL, XXLSG,
     &                                   BEXT_MODE, BSCAT_MODE, GBAR_MODE, SUCCESS )
                     VFAC  = 1.0 ! correction factor 
                  ELSE 
! use old fast optics method
                     IF ( SUCCESS ) CALL FAST_OPTICS( AE_NR_SHELL( MODE,L,V ),  
     &                                    AE_NI_SHELL( MODE,L,V ), 
     &                                    WAVELENGTH( V ), DGN_SHELL, XXLSG, 
     &                                    BEXT_MODE, BSCAT_MODE, GBAR_MODE )
                     VFAC  = VOL * INV_LAMBDA
! updated fast optics method; has problems from eposidically infinite values of aerosol optical depth
!                    MIE_PARAMETER = PI * DGN_SHELL * INV_LAMBDA
!     &                            * EXP( 3.0 * BLK_AE_LSG( MODE, L ) * BLK_AE_LSG( MODE, L ) )

!                    IF( SUCCESS ) CALL FASTER_OPTICS( AE_NR_SHELL( MODE, L, V ),  
!     &                                  AE_NI_SHELL( MODE, L, V ), 
!     &                                  MIE_PARAMETER, BLK_AE_LSG( MODE, L ), 
!     &                                  BEXT_MODE, BSCAT_MODE, GBAR_MODE )
!                    VFAC  = VOL * INV_LAMBDA
                  END IF

                  IF ( .NOT. SUCCESS ) THEN

                     WRITE( LOGDEV, 9504 ) L, MODE, WAVELENGTH( V ), 
     &               AE_DGN_SHELL( MODE,L ), AE_NR_SHELL( MODE,L,V ),
     &               AE_NI_SHELL( MODE,L,V ), BLK_AE_VOL( MODE,L ),
     &               BLK_AE_LSG( MODE,L )

                     XMSG =  'FAILURE IN AERO_OPTICAL2: shell only case '
                     CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )

                  END IF

C***sum to get total extinction and scattering
C***  and contribution to the overall asymmetry factor

                  BEXT  = BEXT + VFAC * BEXT_MODE
                  BSC   = VFAC * BSCAT_MODE
                  BSCAT = BSCAT + BSC
                  G_BAR = G_BAR + BSC * GBAR_MODE

               END IF       

            END DO OPTICS_LOOP

            AERO_SCAT_COEF( L,V ) = BSCAT
            AERO_EXTI_COEF( L,V ) = BEXT
            AERO_ASYM_FAC ( L,V ) = G_BAR / MAX( BSCAT, 1.0E-30 )

#ifdef verbose_phot_extra
            if ( l .eq. 1 .and. v .eq. 1 ) then
               write(logdev, 9502)l, wavelength( V ), dgn_core, dgn_shell, bext_mode, 
     &         bscat_mode, gbar_mode, ae_nr_shell( l, mode, v ), ae_ni_shell( v, mode, v ),
     &         ae_nr_core( l, mode, iv ), ae_ni_core( l, mode, v )
9502           format('layer = ',i2,' lambda  = ',es12.4,' dgn_core = ',es12.4,' dgn_shell = ',
     &                 es12.4,' ae_bext = ',es12.4,' ae_bscat = ',es12.4,' ae_gbar = ',es12.4,
     &                 ' refract_shell(nr,ni) = ', 2(es12.4,1x),' refract_core = ', 2(es12.4,1x))
            end if
#endif            

         END DO LAY_LOOP2         

      END DO LOOP_WAVE

#ifdef verbose_phot
      if ( col .eq. 1 .and. row .eq. 1 ) then
         l = 1
         v = 1
         do mode = 1, n_mode
            write(logdev, 5005)l, mode, v, ae_nr_core ( mode, l, v ), ae_ni_core ( mode, l, v ),
     &      ae_nr_shell ( mode, l, v ), ae_ni_shell ( mode, l, v )
5005        format('lay = ',i3,' mode = ',i3,' wlv index = ',i3,' ae_core(nr,ni) = ',
     &      2(es12.4,1x), ' ae_shell(nr,ni) = ', 2(es12.4,1x))
         end do
      end if
#endif


9503  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN_CORE(m) = ',ES12.4,
     &       ' DGN_SHELL(m) = ', ES12.4 / ' REFRACT_IDX_SHELL(NR,NI) = ', 2(ES12.4,1X),
     &       ' REFRACT_IDX_CORE(NR,NI) = ', 2(ES12.4,1X) / ' LN(GEO.STD.DEV.) = ',
     &       ES12.4)
9504  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN(m) = ',ES12.4,
     &       ' REFRACT_IDX(NR,NI) = ', 2(ES12.4,1X) / ' VOL.DENS. = ', ES12.4,
     &       ' LN(GEO.STD.DEV.) = ', ES12.4)

      RETURN
      END SUBROUTINE AERO_OPTICS_INTERNAL 

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE FASTER_OPTICS ( NR, NI, ALPHV, XLNSIG, BETA_EXT, BETA_SCAT, G )
C-----------------------------------------------------------------------
C  A parameterization of the aerosol extinction and scattering code
C     Coded by Dr. Francis S. Binkowski
C     CEMP, The Institute for the Environment
C     The University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C     Code dates. Began February 25, 2005, current March 18, 2005
C     modified by FSB May 10, 2005 to calculate asymmetry factor by the
C     semi-empirical method of Hanna and Mathur. Note that
C     the normalized scattering coefficient (non-dimensional) is
C     interpreted as an average of  scattering efficiency over the
C     size distribution
C     Modified 05/25/2005 to ensure that if ni = 0.0, that
C     beta_scat = beta_ext.
C     Modified 03/17/2008 to ensure match with reference calculation for
C     all cases of sigma_g.
C     Modified 10/25/2009 to be consistent with research version of code.
C     The modifications include better representation of the
C     asymmetry factor.
C     The form of the mathematical expression for extinction
C     and scattering is based upon that of
C     Heintzenberg & Baker (1976), and further inspired by the work
C     of Willeke and Brockmann(1977) who showed the basic shape of
C     the extinction resulting from an integration of the Mie extinction
C     efficiency over a log normal particle size distribution.
C     This current code has been developed from a direct calculation of
C     extinction and scattering using a Mie code integrated over
C     a log normal distribution. The results of that calculation
C     replicate the Willee and Brockmann (1977) results.
C     The parameterization is based upon a fit to the standard CMAQ
C     radiative transfer code for visibility. to which a module for
C     absorption was added so that absorption and scattering would also be
C     available.
C
C     The  shape has been modified for absorption by small particles
C     by using the formulae of Penndorf (1962). For large particles,
C     the shape has been altered by using the large sphere values from
C     Table I of  Irvine (1965)
C
C     Results are consistent with those of Willeke and Brockmann (1977).
C
C     The asymmetry factor is calculated by a new algorithm FSB - 04/04/2008
C     Sept 2014: J.Young-change arguments and usage of Mie Paramater attempting
C                to optimize runtimes or efficiency
C     Oct  2014: B.Hutzell-Added mininum values for scatttering efficiency for small
C                highly absorbing particles such as Aitken particle that
C                are mostly composed of elemental carbon
C
C  References:
C
C     Heintzenberg, J. and M. Baker, Spherical particle populations:
C     approximate analytic relationship between size distribution
C     parameters and integral optical properties, Applied Optics,
C     Volume 15, Number 5 pp 1178-1181, May 1976.
C
C     Irvine, W. M. Light Scattering by spherical particles: Radiation
C     pressure, asymmetry factor, and extinction cross section,
C     Journal of eh Optical Society of Amerioca, Vol. 55, NO. 1,
C     January ,1965
C
C     Penndorf, R. Scattering and Extinction Coefficeints for small
C     spherical particles, J. Atmospheric Sciences, Volume 19, p 193,
C     March 1962.
C
C     Willeke, K. and  J. E. Brockmann, Extinction coefficients for
C     multmodal atmospheric particle size distributions, Atmospheric
C     Environment, vol. 11, pp 95-999, 1977.
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INCLUDE SUBST_CONST      ! physical constants

C***arguments

      REAL, INTENT( IN )  :: NR, NI     ! indices of refraction
      REAL, INTENT( IN )  :: ALPHV      ! Mie parameter for dgv
      REAL, INTENT( IN )  :: XLNSIG     ! log of geometric standard deviation

      REAL, INTENT( OUT ) :: BETA_EXT   ! normalized extinction coefficient
      REAL, INTENT( OUT ) :: BETA_SCAT  ! normalized scattering coefficient
      REAL, INTENT( OUT ) :: G          ! asymmetry factor

C***internal variables

      REAL NR1, NR2, TAU
      REAL C, CEXT, CSCAT
      REAL B, BEXT, BSCAT
      REAL BBFAC
      REAL ALPHA_I
      REAL A, LOGX2, XLNSIG2, MM1

      REAL, PARAMETER :: SIGMA_G_TWO = 2.0
      REAL, PARAMETER :: LOGSIG_TWO = 0.693147
      REAL, PARAMETER :: LOGSIG_TWO_SQD = LOGSIG_TWO * LOGSIG_TWO
      REAL, PARAMETER :: LOGSIG_105 = 1.102500
      REAL, PARAMETER :: DIFFSIG = SIGMA_G_TWO - 1.05
      REAL, PARAMETER :: A_TWO = 0.5 / LOGSIG_TWO_SQD
      REAL LARGESCAT  ! large sphere limit for scattering
      REAL LARGEEXT   ! large sphere limit for extinction
      REAL SMALL_G, LARGE_G

      REAL ALPHV2, ALPHV3
      REAL X_ALPHA, X_ALPHA2, X_ALPHA3
      REAL SIGMA_G, FCORR
      REAL EXPFAC2, EXPFAC3
      REAL EFAC, EFAC_EXT, EFAC_SCAT
      REAL DEN1, FAC1, FAC2
      REAL F1, F2, F3
      REAL G1, G2, G3, G4, G5
      REAL NN, TT

      REAL T1F1, T2F1, T1F2, T2F2, T1F3, T2F3
      REAL T1G1, T2G1, T1G2, T2G2, T1G3, T2G3, T1G4, T2G4
      REAL T1G5, T2G5, T1P1, T2P1

C***the following are for calculating the Penndorff Coefficients

      REAL PENN1, A1, A2, A3, PENN2
      REAL XNR, XNI, XNR2, XNI2, XNRI, XNRI2, XNRMI
      REAL XRI, XRI2, XRI36, XNX, XNX2
      REAL Z1, Z12, Z2, XC1

C***coefficients for polynomials

      REAL, PARAMETER :: F1A0 = -1.309193E-1
      REAL, PARAMETER :: F1A1 =  2.565668E+0

      REAL, PARAMETER :: F2A0 =  1.489233E+1
      REAL, PARAMETER :: F2A1 = -5.311351E+1
      REAL, PARAMETER :: F2A2 =  8.180334E+1
      REAL, PARAMETER :: F2A3 = -4.549854E+1

      REAL, PARAMETER :: F3A0 =  5.549359E-1
      REAL, PARAMETER :: F3A1 =  2.571002E-1
      REAL, PARAMETER :: F3A2 =  9.212703E-1
      REAL, PARAMETER :: F3A3 =  5.155047E-2

      REAL, PARAMETER :: G1A0 =  1.000000E+0
      REAL, PARAMETER :: G1A1 = -7.636121E-1
      REAL, PARAMETER :: G1A2 =  1.285532E+0
      REAL, PARAMETER :: G1A3 =  1.629161E-2

      REAL, PARAMETER :: G2A0 =  1.000000E+0
      REAL, PARAMETER :: G2A1 = -2.507954E+0
      REAL, PARAMETER :: G2A2 =  5.170246E+0
      REAL, PARAMETER :: G2A3 = -4.945515E+0

      REAL, PARAMETER :: G3A0 =  1.000000E+0
      REAL, PARAMETER :: G3A1 = -2.650134E+0
      REAL, PARAMETER :: G3A2 =  4.515327E+0
      REAL, PARAMETER :: G3A3 = -4.027442E+0

      REAL, PARAMETER :: G4A0 =  1.000000E+0
      REAL, PARAMETER :: G4A1 = -8.532647E-1
      REAL, PARAMETER :: G4A2 =  6.766073E-1

      REAL, PARAMETER :: G5A0 =  1.0
      REAL, PARAMETER :: G5A1 = -6.674946E-1
      REAL, PARAMETER :: G5A2 = -5.426378E-1

C *** Coefficients for quadratic fit for <cos> large particles
C     from Irvine (1965) Table I
      REAL, PARAMETER :: IRVA0 =  1.076232E+0
      REAL, PARAMETER :: IRVA1 = -4.891972E-2
      REAL, PARAMETER :: IRVA2 = -2.243449E-2


C FSB Coefficients for SMALL_G  calculation
      REAL, PARAMETER :: XXA0 =  3.392224E-2
      REAL, PARAMETER :: XXA1 =  8.276532E-1
      REAL, PARAMETER :: XXA2 = -3.784926E-1
      REAL, PARAMETER :: XXA3 =  5.853108E-2
      REAL, PARAMETER :: G_ALPHA_I = XXA0 + XXA1 + XXA2 + XXA3

C FSB Coefficients for LARGE_G calculation
      REAL, PARAMETER :: YYA0 =  6.776173E-1
      REAL, PARAMETER :: YYA1 =  2.385339E-2
      REAL, PARAMETER :: YYA2 = -7.952263E-4
      REAL, PARAMETER :: YYA3 =  9.410370E-6

C FSB Coefficientf for adjusting asymmetry factor calculation
      REAL, PARAMETER :: CXG0 = -5.845196E-2
      REAL, PARAMETER :: CXG1 =  3.229183E-1
      REAL, PARAMETER :: CXG2 =  2.764716E-1
      REAL, PARAMETER :: CXG3 = -8.790411E-2

C***FSB added for asymmetry factor calculation

      REAL QSCAT_AVG

      REAL, PARAMETER :: AA0 =  88.466
      REAL, PARAMETER :: AA1 = -61.628
      REAL, PARAMETER :: AA2 =  34.483
      REAL, PARAMETER :: AA3 =  -8.543
      REAL, PARAMETER :: AA4 =   0.77435

      REAL GMAX
      REAL QANGLE
      REAL QQ, QF1, QF2, QF3
      REAL QQSUM, QQF1,QQF2, QQF3, QQCORR

      REAL, PARAMETER :: DEGTORAD = PI180
      REAL, PARAMETER :: THREE_PI_TWO = 3.0 * PI / 2.0

C***FSB start calculation
      SIGMA_G = EXP( XLNSIG )
C FSB check range of SIGMA_G
C *** Maximum value of SIGMA_G allowed is 2.0
      SIGMA_G = MIN( 2.0, SIGMA_G )
C *** Minimum allowed value fo SIGMA_F is 1.05
      SIGMA_G = MAX( 1.05, SIGMA_G )

      XLNSIG2 = XLNSIG * XLNSIG
      A = 0.5 / XLNSIG2

      NR1 = NR - 1.0
      NR2 = NR * NR

C***evaluate polynomials
C***  optimize for piplined microprocessor
C***  appproach recommended by Dr. Carlie Coats

      NN = NR1 * NR1

      T1F1 = F1A0 + F1A1 * NR1
      T1F2 = F2A0 + F2A1 * NR1
      T2F2 = F2A2 + F2A3 * NR1
      T1F3 = F3A0 + F3A1 * NR1
      T2F3 = F3A2 + F3A3 * NR1

      F1 = T1F1                 ! linear
      F2 = T1F2 + T2F2 * NN     ! cubic
      F3 = T1F3 + T2F3 * NN     ! cubic

      C = F1

C FSB correct for values of SIGMA_ less than 2.0.
C     The smallest value of SIGMA_G allowed is 1.05
C     2.0 - 1.05 = 0.95
C      FCORR   = (1.0 - 0.13 * (SIGMA_G - 1.05)  / 0.95 )
C     1.0 / 0.95 = 1.052632.  1.0 / 0.95 * 0.13 = 0.136842

      FCORR   = 1.0 - 0.136842 * ( SIGMA_G - 1.05 )

      CEXT    = C * FCORR
      CSCAT   = CEXT
      B       = F3 * A_TWO
      ALPHA_I = F2
      BEXT    = B
      BSCAT   = B
      PENN1   = 0.0
      PENN2   = 0.0

      ALPHV2 = ALPHV * ALPHV
      ALPHV3 = ALPHV2 * ALPHV

      IF ( NI .GT. 0.0 ) THEN

         TAU = NI / NR1

C***evaluate more polynomials
C***  optimize for piplined microprocessor
C***  appproach recommended by Dr. Carlie Coats

         TT = TAU * TAU
         T1G1 = G1A0 + G1A1 * TAU
         T2G1 = G1A2 + G1A3 * TAU
         T1G2 = G2A0 + G2A1 * TAU
         T2G2 = G2A2 + G2A3 * TAU
         T1G3 = G3A0 + G3A1 * TAU
         T2G3 = G3A2 + G3A3 * TAU
         T1G4 = G4A0 + G4A1 * TAU
         T2G4 = G4A2            ! quadratic
         T1G5 = G5A0 + G5A1 * TAU
         T2G5 = G5A2            ! quadratic
         G1   = T1G1 + T2G1 * TT
         G2   = T1G2 + T2G2 * TT
         G3   = T1G3 + T2G3 * TT
         G4   = T1G4 + T2G4 * TT
         G5   = T1G5 + T2G5 * TT

C *** adjust the variables

         CEXT    = CEXT    * G1
         CSCAT   = CSCAT   * G2
         BEXT    = BEXT    * G3
         BSCAT   = BSCAT   * G4
         ALPHA_I = ALPHA_I * G5

C*** Calculate the Penndorf Coefficients for the small particle limit

         XNR   = NR
         XNI   = NI
         XNR2  = XNR   * XNR
         XNI2  = XNI   * XNI
         XNRI  = XNR2  + XNI2
         XNRI2 = XNRI  * XNRI
         XNRMI = XNR2  - XNI2
         XRI   = XNR   * XNI
         XRI2  = XRI   * XRI
         XRI36 = 36.0  * XRI2
         XNX   = XNRI2 + XNRMI - 2.0
         XNX2  = XNX   * XNX

         Z1    = XNRI2 + 4.0 * XNRMI + 4.0
         Z12   = Z1    * Z1
         Z2    = 4.0   * XNRI2 + 12.0 * XNRMI + 9.0
         XC1   = 8.0   / ( 3.0 * Z12 )
         A1    = 24.0  * XRI / Z1

         A2    = 4.0   * XRI / 15.0 + 20.0 * XRI / ( 3.0 * Z2 ) +
     &           4.8   * XRI * (  7.0 * XNRI2 +
     &           4.0   * ( XNRMI - 5.0 ) ) / Z12

         A3    = XC1   * ( XNX2 - XRI36 )

!        ALPHV2 = ALPHV * ALPHV
!        ALPHV3 = ALPHV2 * ALPHV
         EXPFAC2 = EXP( 2.0 * XLNSIG2 )
         EXPFAC3 = EXP( 4.5 * XLNSIG2 )

         T1P1 = A1 + A2 * ALPHV2 * EXPFAC2
         T2P1 = A3 * ALPHV3 * EXPFAC3

C***PENN1 is the analytic integral of the Pendorff formulae over
C***   a log normal particle size distribution.

         PENN1 = THREE_PI_TWO * ( T1P1 + T2P1 )
         PENN2 = THREE_PI_TWO * T2P1

      END IF   ! test for ni > 0.0

      X_ALPHA  = ALPHV / ALPHA_I

!     LOGX2    = LOG( X_ALPHA )** 2
      LOGX2    = LOG( X_ALPHA )
      LOGX2    = LOGX2 * LOGX2

      BBFAC    = BEXT * A  / ( BEXT + A )

      EFAC_EXT = EXP( -BBFAC * LOGX2 )

C***FSB calculate normalized extinction and scattering coefficients

      BETA_EXT = THREE_PI_TWO * CEXT
     &         * SQRT( A / ( BEXT + A ) ) * EFAC_EXT

      BETA_SCAT = BETA_EXT      ! NI = 0.0 case

C *** Check for NI > 0.0

      IF ( NI .GT. 0.0 ) THEN

!        BBFAC = 1.5 * BBFAC ! reset BBFAC for scattering
         BBFAC = 1.1 * BBFAC ! reset BBFAC for scattering

         EFAC_SCAT = EXP( -BBFAC * LOGX2 )

C *** recalculate the normalized scattering coefficient

         BETA_SCAT = THREE_PI_TWO * CSCAT
     &             * SQRT( A / ( BSCAT + A ) ) * EFAC_SCAT

C *** Adjust beta_ext for small particle absorption:

         IF ( X_ALPHA .LT. 0.13 ) THEN

            FAC1 = ALPHV + 0.6 * ALPHV2

            BETA_EXT = MAX( BETA_EXT,
     &                    ( BETA_EXT  * FAC1 + ( 1.0 - FAC1 ) * PENN1 ) )

            BETA_SCAT = MAX( BETA_SCAT,
     &                     ( BETA_SCAT * FAC1 + ( 1.0 - FAC1 ) * PENN2 ) )

         END IF ! test for   XALPHA < 0.13

! small highly absorbing  particles such as a Tyndall scatterers such as
! described in Jacobson (1999) in Fundmentals of Atmospheric Modeling. This
! is approximately consistent with Penndorf (1962).

        BETA_SCAT = MAX( 0.001 * BETA_EXT, BETA_SCAT )

      END IF  ! test for NI > 0.0

C *** Calculate large sphere limits(Irvine, 1965)

      MM1 = EXP( 0.5 * XLNSIG2 ) / ALPHV

C FSB large sphere limit - scattering

      LARGESCAT = THREE_PI_TWO * ( 8.652439E-01 + 1.501772E-01 * NR ) * MM1

C FSB large spnere limit for extinction ( no edge effects )

      LARGEEXT = THREE_PI_TWO * ( 2.0 * MM1 )

C FSB Adjust for large sphere limits

      IF ( ALPHV .GE. 10.0 ) THEN

         BETA_EXT  = MAX( BETA_EXT, LARGEEXT )

         BETA_SCAT = MAX( BETA_SCAT, LARGESCAT )

      END IF ! test for 10.0 < ALPHV

C***FSB now calculate the asymmetry factor
C***  using the Hanna-Mathur quasi-empirical method
!     GMAX = 0.0

!     QSCAT_AVG = BETA_SCAT
!     QANGLE = AA0

!     IF ( QSCAT_AVG .GT. 1.0E-4 ) THEN
!        QQ  = QSCAT_AVG * QSCAT_AVG
!        QF1 = AA0 + AA1 * QSCAT_AVG
!        QF2 = AA2 + AA3 * QSCAT_AVG
!        QF3 = AA4 * QSCAT_AVG * QSCAT_AVG
!        QANGLE = QF1 + QF2 * QQ + QF3 * QQ
!     END IF

!     QANGLE = DEGTORAD * QANGLE
!     G      = COS( QANGLE)     ! asymmetry factor

C***FSB now calculate the asymmetry factor
C***   using a parametric fit to Mie calculations

      X_ALPHA2 = X_ALPHA * X_ALPHA
      X_ALPHA3 = X_ALPHA2 * X_ALPHA

      SMALL_G = 0.0
      LARGE_G = 0.0

      IF ( ALPHV .LT. 2.6 ) THEN

C FSB Calculate SMALL_G for sigma_g = 2.0

         QF1 = XXA0 + XXA1 * ALPHV
         QF2 = XXA2 * ALPHV2
         QF3 = XXA3 * ALPHV3
         SMALL_G = QF1 + QF2 + QF3 ! valid at sigma_g = 2.0

C FSB adjust SMALL_G for values less than 2.0
C     The smallest sigma_g allowed is 1.05

         QQF1 = CXG0 + CXG1 * ALPHV
         QQF2 = CXG2 * ALPHV2
         QQF3 = CXG3 * ALPHV3
         QQSUM = QQF1 + QQF2 + QQF3
         FAC1 = 1.052632 * ( 2.0 - SIGMA_G )
         QQSUM = MAX( 0.0, QQSUM )
         QQCORR = ( 1.0 - FAC1 ) + FAC1 * QQSUM
         SMALL_G = SMALL_G * QQCORR
         G = SMALL_G

      ELSE IF ( ALPHV .LT. 100.0 ) THEN

         QF1 = YYA0 + YYA1 * X_ALPHA
         QF2 = YYA2 * X_ALPHA2
         QF3 = YYA3 * X_ALPHA3
         LARGE_G = QF1 + QF2 + QF3
         G = LARGE_G

      ELSE

C     Very large sphere limit from fit to Irvine (1965).

         G = 1.124484 - 1.153869E-01 * NR

      END IF

      RETURN
      END SUBROUTINE FASTER_OPTICS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE FAST_OPTICS( NR, NI, LAMBDA, DGN, SIGMA_G, BETA_EXT, BETA_SCAT, G )
C-----------------------------------------------------------------------
C  A parameterization of the aerosol extinction and scattering code
C     Coded by Dr. Francis S. Binkowski
C     CEMP, The Institute for the Environment
C     The University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C     Code dates. Began February 25, 2005, current March 18, 2005
C     modified by FSB May 10, 2005 to calculate asymmetry factor by the
C     semi-empirical method of Hanna and Mathur. Note that
C     the normalized scattering coefficient (non-dimensional) is
C     interpreted as an average of  scattering efficiency over the
C     size distribution
C     Modified 05/25/2005 to ensure that if ni = 0.0, that
C     beta_scat = beta_ext.
C     Modified 03/17/2008 to ensure match with reference calculation for
C     all cases of sigma_g.
C     Modified 10/25/2009 to be consistent with research version of code.
C     The modifications include better representation of the
C     asymmetry factor.
C     The form of the mathematical expression for extinction
C     and scattering is based upon that of
C     Heintzenberg & Baker (1976), and further inspired by the work
C     of Willeke and Brockmann(1977) who showed the basic shape of
C     the extinction resulting from an integration of the Mie extinction
C     efficiency over a log normal particle size distribution.
C     This current code has been developed from a direct calculation of
C     extinction and scattering using a Mie code integrated over
C     a log normal distribution. The results of that calculation
C     replicate the Willee and Brockmann (1977) results.
C     The parameterization is based upon a fit to the standard CMAQ
C     radiative transfer code for visibility. to which a module for
C     absorption was added so that absorption and scattering would also be
C     available.
C
C     The  shape has been modified for absorption by small particles
C     by using the formulae of Penndorf (1962). For large particles,
C     the shape has been altered by using the large sphere values from
C     Table I of  Irvine (1965)
C
C     Results are consistent with those of Willeke and Brockmann (1977).
C
C     The asymmetry factor is calculated by a new algorithm FSB - 04/04/2008
C
C     Oct  2014: B.Hutzell-Added mininum values for scatttering efficiency for small
C                highly absorbing particles such as Aitken particle that
C                are mostly composed of elemental carbon
C
C  References:
C
C     Heintzenberg, J. and M. Baker, Spherical particle populations:
C     approximate analytic relationship between size distribution
C     parameters and integral optical properties, Applied Optics,
C     Volume 15, Number 5 pp 1178-1181, May 1976.
C
C     Irvine, W. M. Light Scattering by spherical particles: Radiation
C     pressure, asymmetry factor, and extinction cross section,
C     Journal of eh Optical Society of Amerioca, Vol. 55, NO. 1,
C     January ,1965
C
C     Penndorf, R. Scattering and Extinction Coefficeints for small
C     spherical particles, J. Atmospheric Sciences, Volume 19, p 193,
C     March 1962.
C
C     Willeke, K. and  J. E. Brockmann, Extinction coefficients for
C     multmodal atmospheric particle size distributions, Atmospheric
C     Environment, vol. 11, pp 95-999, 1977.
C-----------------------------------------------------------------------

      IMPLICIT NONE

C***include files

      INCLUDE SUBST_CONST      ! physical constants

C***arguments

      REAL, INTENT( IN )     :: NR, NI     ! indices of refraction
      REAL, INTENT( IN )     :: LAMBDA     ! wavelength, nm
      REAL, INTENT( IN )     :: DGN        ! geometric mean diameter, m
      REAL, INTENT( INOUT )  :: SIGMA_G     ! geometric standard deviation

      REAL, INTENT( OUT )    :: BETA_EXT   ! normalized extinction coefficient
      REAL, INTENT( OUT )    :: BETA_SCAT  ! normalized scattering coefficient
      REAL, INTENT( OUT )    :: G          ! asymmetry factor

C***internal variables

      REAL NR1, NR2, TAU
      REAL C, CEXT, CSCAT
      REAL B, BEXT, BSCAT
      REAL BBFAC
      REAL ALPHV
      REAL ALPHA_I
      REAL A, LOGX2, XLNSIG, XLNSIG2, MM1

      REAL, PARAMETER :: SIGMA_G_TWO = 2.0
      REAL, PARAMETER :: LOGSIG_TWO = 0.693147
      REAL, PARAMETER :: LOGSIG_TWO_SQD = LOGSIG_TWO * LOGSIG_TWO
      REAL, PARAMETER :: LOGSIG_105 = 1.102500
      REAL, PARAMETER :: DIFFSIG = SIGMA_G_TWO - 1.05
      REAL, PARAMETER :: A_TWO = 0.5 / LOGSIG_TWO_SQD
      REAL LARGESCAT  ! large sphere limit for scattering
      REAL LARGEEXT   ! large sphere limit for extinction
      REAL SMALL_G, LARGE_G

      REAL ALPHV2, ALPHV3
      REAL X_ALPHA, X_ALPHA2, X_ALPHA3
      REAL FCORR
      REAL EXPFAC2, EXPFAC3
      REAL EFAC, EFAC_EXT, EFAC_SCAT
      REAL DEN1, FAC1, FAC2
      REAL F1, F2, F3
      REAL G1, G2, G3, G4, G5
      REAL NN, TT

      REAL T1F1, T2F1, T1F2, T2F2, T1F3, T2F3
      REAL T1G1, T2G1, T1G2, T2G2, T1G3, T2G3, T1G4, T2G4
      REAL T1G5, T2G5, T1P1, T2P1

C***the following are for calculating the Penndorff Coefficients

      REAL PENN1, A1, A2, A3, PENN2
      REAL XNR, XNI, XNR2, XNI2, XNRI, XNRI2, XNRMI
      REAL XRI, XRI2, XRI36, XNX, XNX2
      REAL Z1, Z12, Z2, XC1

C***coefficients for polynomials

      REAL, PARAMETER :: F1A0 = -1.309193E-1
      REAL, PARAMETER :: F1A1 =  2.565668E+0

      REAL, PARAMETER :: F2A0 =  1.489233E+1
      REAL, PARAMETER :: F2A1 = -5.311351E+1
      REAL, PARAMETER :: F2A2 =  8.180334E+1
      REAL, PARAMETER :: F2A3 = -4.549854E+1

      REAL, PARAMETER :: F3A0 =  5.549359E-1
      REAL, PARAMETER :: F3A1 =  2.571002E-1
      REAL, PARAMETER :: F3A2 =  9.212703E-1
      REAL, PARAMETER :: F3A3 =  5.155047E-2

      REAL, PARAMETER :: G1A0 =  1.000000E+0
      REAL, PARAMETER :: G1A1 = -7.636121E-1
      REAL, PARAMETER :: G1A2 =  1.285532E+0
      REAL, PARAMETER :: G1A3 =  1.629161E-2

      REAL, PARAMETER :: G2A0 =  1.000000E+0
      REAL, PARAMETER :: G2A1 = -2.507954E+0
      REAL, PARAMETER :: G2A2 =  5.170246E+0
      REAL, PARAMETER :: G2A3 = -4.945515E+0

      REAL, PARAMETER :: G3A0 =  1.000000E+0
      REAL, PARAMETER :: G3A1 = -2.650134E+0
      REAL, PARAMETER :: G3A2 =  4.515327E+0
      REAL, PARAMETER :: G3A3 = -4.027442E+0

      REAL, PARAMETER :: G4A0 =  1.000000E+0
      REAL, PARAMETER :: G4A1 = -8.532647E-1
      REAL, PARAMETER :: G4A2 =  6.766073E-1

      REAL, PARAMETER :: G5A0 =  1.0
      REAL, PARAMETER :: G5A1 = -6.674946E-1
      REAL, PARAMETER :: G5A2 = -5.426378E-1

C *** Coefficients for quadratic fit for <cos> large particles
C     from Irvine (1965) Table I
      REAL, PARAMETER :: IRVA0 =  1.076232E+0
      REAL, PARAMETER :: IRVA1 = -4.891972E-2
      REAL, PARAMETER :: IRVA2 = -2.243449E-2


C FSB Coefficients for SMALL_G  calculation
      REAL, PARAMETER :: XXA0 =  3.392224E-2
      REAL, PARAMETER :: XXA1 =  8.276532E-1
      REAL, PARAMETER :: XXA2 = -3.784926E-1
      REAL, PARAMETER :: XXA3 =  5.853108E-2
      REAL, PARAMETER :: G_ALPHA_I = XXA0 + XXA1 + XXA2 + XXA3

C FSB Coefficients for LARGE_G calculation
      REAL, PARAMETER :: YYA0 =  6.776173E-1
      REAL, PARAMETER :: YYA1 =  2.385339E-2
      REAL, PARAMETER :: YYA2 = -7.952263E-4
      REAL, PARAMETER :: YYA3 =  9.410370E-6

C FSB Coefficientf for adjusting asymmetry factor calculation
      REAL, PARAMETER :: CXG0 = -5.845196E-2
      REAL, PARAMETER :: CXG1 =  3.229183E-1
      REAL, PARAMETER :: CXG2 =  2.764716E-1
      REAL, PARAMETER :: CXG3 = -8.790411E-2

C***FSB added for asymmetry factor calculation

      REAL QSCAT_AVG

      REAL, PARAMETER :: AA0 =  88.466
      REAL, PARAMETER :: AA1 = -61.628
      REAL, PARAMETER :: AA2 =  34.483
      REAL, PARAMETER :: AA3 =  -8.543
      REAL, PARAMETER :: AA4 =   0.77435

      REAL GMAX
      REAL QANGLE
      REAL QQ, QF1, QF2, QF3
      REAL QQSUM, QQF1,QQF2, QQF3, QQCORR

      REAL, PARAMETER :: DEGTORAD = PI180
      REAL, PARAMETER :: THREE_PI_TWO = 3.0 * PI / 2.0


      REAL, PARAMETER :: SCALE = 1.00E+9

C FSB check range of SIGMA_G
C *** Maximum value of SIGMA_G allowed is 2.0
      SIGMA_G = MIN( 2.0, SIGMA_G )
C *** Minimum allowed value fo SIGMA_F is 1.05
      SIGMA_G = MAX( 1.05, SIGMA_G )
C***FSB start calculation
      XLNSIG = LOG( SIGMA_G ) 

      ALPHV = SCALE * PI * DGN * EXP( 3.0 * XLNSIG * XLNSIG ) / LAMBDA
      ALPHV2 = ALPHV * ALPHV
      ALPHV3 = ALPHV * ALPHV * ALPHV

      XLNSIG2 = XLNSIG * XLNSIG
      A = 0.5 / XLNSIG2

      NR1 = NR - 1.0
      NR2 = NR * NR

C***evaluate polynomials
C***  optimize for piplined microprocessor
C***  appproach recommended by Dr. Carlie Coats

      NN = NR1 * NR1

      T1F1 = F1A0 + F1A1 * NR1
      T1F2 = F2A0 + F2A1 * NR1
      T2F2 = F2A2 + F2A3 * NR1
      T1F3 = F3A0 + F3A1 * NR1
      T2F3 = F3A2 + F3A3 * NR1

      F1 = T1F1                 ! linear
      F2 = T1F2 + T2F2 * NN     ! cubic
      F3 = T1F3 + T2F3 * NN     ! cubic

      C       = F1

C FSB correct for values of SIGMA_ less than 2.0.
C     The smallest value of SIGMA_G allowed is 1.05
C     2.0 - 1.05 = 0.95
C      FCORR   = (1.0 - 0.13 * (SIGMA_G - 1.05)  / 0.95 )
C     1.0 / 0.95 = 1.052632.  1.0 / 0.95 * 0.13 = 0.136842

      FCORR   = 1.0 - 0.136842 * ( SIGMA_G - 1.05 )

      CEXT    = C * FCORR
      CSCAT   = CEXT
      B       = F3 * A_TWO
      ALPHA_I = F2
      BEXT    = B
      BSCAT   = B
      PENN1   = 0.0
      PENN2   = 0.0

      IF ( NI .GT. 0.0 ) THEN

         TAU = NI / NR1

C***evaluate more polynomials
C***  optimize for piplined microprocessor
C***  appproach recommended by Dr. Carlie Coats

         TT = TAU * TAU
         T1G1 = G1A0 + G1A1 * TAU
         T2G1 = G1A2 + G1A3 * TAU
         T1G2 = G2A0 + G2A1 * TAU
         T2G2 = G2A2 + G2A3 * TAU
         T1G3 = G3A0 + G3A1 * TAU
         T2G3 = G3A2 + G3A3 * TAU
         T1G4 = G4A0 + G4A1 * TAU
         T2G4 = G4A2            ! quadratic
         T1G5 = G5A0 + G5A1 * TAU
         T2G5 = G5A2            ! quadratic
         G1   = T1G1 + T2G1 * TT
         G2   = T1G2 + T2G2 * TT
         G3   = T1G3 + T2G3 * TT
         G4   = T1G4 + T2G4 * TT
         G5   = T1G5 + T2G5 * TT

C *** adjust the variables

         CEXT    = CEXT    * G1
         CSCAT   = CSCAT   * G2
         BEXT    = BEXT    * G3
         BSCAT   = BSCAT   * G4
         ALPHA_I = ALPHA_I * G5

C*** Calculate the Penndorf Coefficients for the small particle limit

         XNR   = NR
         XNI   = NI
         XNR2  = XNR   * XNR
         XNI2  = XNI   * XNI
         XNRI  = XNR2  + XNI2
         XNRI2 = XNRI  * XNRI
         XNRMI = XNR2  - XNI2
         XRI   = XNR   * XNI
         XRI2  = XRI   * XRI
         XRI36 = 36.0  * XRI2
         XNX   = XNRI2 + XNRMI - 2.0
         XNX2  = XNX   * XNX

         Z1    = XNRI2 + 4.0 * XNRMI + 4.0
         Z12   = Z1    * Z1
         Z2    = 4.0   * XNRI2 + 12.0 * XNRMI + 9.0
         XC1   = 8.0   / ( 3.0 * Z12 )
         A1    = 24.0  * XRI / Z1

         A2    = 4.0   * XRI / 15.0 + 20.0 * XRI / ( 3.0 * Z2 ) +
     &           4.8   * XRI * (  7.0 * XNRI2 +
     &           4.0   * ( XNRMI - 5.0 ) ) / Z12

         A3    = XC1   * ( XNX2 - XRI36 )

         EXPFAC2 = EXP( 2.0 * XLNSIG2 )
         EXPFAC3 = EXP( 4.5 * XLNSIG2 )

         T1P1 = A1 + A2 * ALPHV2 * EXPFAC2
         T2P1 = A3 * ALPHV3 * EXPFAC3

C***PENN1 is the analytic integral of the Pendorff formulae over
C***   a log normal particle size distribution.

         PENN1 = THREE_PI_TWO * ( T1P1 + T2P1 )
         PENN2 = THREE_PI_TWO * T2P1

      END IF                    ! test of ni > 0.0

      X_ALPHA  = ALPHV / ALPHA_I

      LOGX2    = LOG( X_ALPHA )** 2

      BBFAC    = BEXT * A  / ( BEXT + A )

      EFAC_EXT = EXP( -BBFAC * LOGX2 )

C***FSB calculate normalized extinction and scattering coefficients

      BETA_EXT = THREE_PI_TWO * CEXT *
     &                      SQRT( A / ( BEXT + A ) ) * EFAC_EXT

      BETA_SCAT = BETA_EXT      ! NI = 0.0 case

C *** Check for 0.0 < NI

      IF ( NI .GT. 0.0 ) THEN

!        BBFAC = 1.5 * BBFAC ! reset BBFAC for scattering
         BBFAC = 1.1 * BBFAC ! reset BBFAC for scattering

         EFAC_SCAT = EXP( -BBFAC * LOGX2 )

C *** recalculate the normalized scattering coefficient

         BETA_SCAT = THREE_PI_TWO * CSCAT *
     &                       SQRT( A / ( BSCAT + A ) ) * EFAC_SCAT

C *** Adjust beta_ext for small particle absorption:

         IF ( X_ALPHA .LT. 0.13 ) THEN

            FAC1 = ALPHV + 0.6 * ALPHV2

            BETA_EXT = MAX( BETA_EXT,
     &                 ( BETA_EXT  * FAC1 + ( 1.0 - FAC1 ) * PENN1 ) )

            BETA_SCAT = MAX( BETA_SCAT,
     &                 ( BETA_SCAT * FAC1 + ( 1.0 - FAC1 ) * PENN2 ) )

         END IF ! test for   XALPHA < 0.13
        
! small highly absorbing  particles such as a Tyndall scatterers such as
! described in Jacobson (1999) in Fundmentals of Atmospheric Modeling. This
! is approximately consistent with Penndorf (1962).

         BETA_SCAT = MAX( 0.001 * BETA_EXT, BETA_SCAT )
          
      END IF  ! test for 0.0  < NI
C *** Calculate large sphere limits(Irvine, 1965)

      MM1 = EXP( 0.5 * XLNSIG2 ) / ALPHV

C FSB large sphere limit - scattering

      LARGESCAT = THREE_PI_TWO * ( 8.652439E-1 + 1.501772E-1 * NR ) * MM1

C FSB large spnere limit for extinction ( no edge effectss )

      LARGEEXT = THREE_PI_TWO * ( 2.0 * MM1 )

C FSB Adjust for large sphere limits

      IF ( ALPHV .GE. 10.0 ) THEN

         BETA_EXT  = MAX( BETA_EXT, LARGEEXT )

         BETA_SCAT = MAX( BETA_SCAT, LARGESCAT )

      END IF ! test for 10.0 < ALPHV

C***FSB now calculate the asymmetry factor
C***  using the Hanna-Mathur quasi-empirical method
!     GMAX = 0.0

!     QSCAT_AVG = BETA_SCAT
!     QANGLE = AA0

!     IF ( QSCAT_AVG .GT. 1.0E-4 ) THEN
!        QQ  = QSCAT_AVG * QSCAT_AVG
!        QF1 = AA0 + AA1 * QSCAT_AVG
!        QF2 = AA2 + AA3 * QSCAT_AVG
!        QF3 = AA4 * QSCAT_AVG * QSCAT_AVG
!        QANGLE = QF1 + QF2 * QQ + QF3 * QQ
!     END IF

!     QANGLE = DEGTORAD * QANGLE
!     G      = COS( QANGLE)     ! asymmetry factor

C***FSB now calculate the asymmetry factor
C***   using a parametric fit to Mie calculations

      X_ALPHA2 = X_ALPHA * X_ALPHA
      X_ALPHA3 = X_ALPHA * X_ALPHA * X_ALPHA

      SMALL_G = 0.0
      LARGE_G = 0.0

      IF ( ALPHV .LT. 2.6 ) THEN

C FSB Calculate SMALL_G for sigma_g = 2.0

         QF1 = XXA0 + XXA1 * ALPHV
         QF2 = XXA2 * ALPHV2
         QF3 = XXA3 * ALPHV3
         SMALL_G = QF1 + QF2 + QF3 ! valid at sigma_g = 2.0

C FSB adjust SMALL_G for values less than 2.0
C     The smallest sigma_g allowed is 1.05

         QQF1 = CXG0 + CXG1 * ALPHV
         QQF2 = CXG2 * ALPHV2
         QQF3 = CXG3 * ALPHV3
         QQSUM = QQF1 + QQF2 + QQF3
         FAC1 = 1.052632 * ( 2.0 - SIGMA_G)
         QQSUM = MAX( 0.0, QQSUM )
         QQCORR =   ( 1.0 - FAC1 ) + FAC1 * QQSUM
         SMALL_G = SMALL_G * QQCORR
         G = SMALL_G

      ELSE IF ( ALPHV .LT. 100.0 ) THEN

         QF1 =  YYA0 + YYA1 * X_ALPHA
         QF2 = YYA2 * X_ALPHA2
         QF3 = YYA3 * X_ALPHA3
         LARGE_G = QF1 + QF2 + QF3
         G = LARGE_G

      ELSE

C     Very large sphere limit from fit to Irvine (1965).

         G = 1.124484 - 1.153869E-1 * NR

      END IF
C Simple and gross fix if appromation exceed realistic bounds
      G = MAX( -0.9999, MIN( G, 0.9999))
      RETURN
      END SUBROUTINE FAST_OPTICS

      END MODULE AERO_PHOTDATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/init/yamo/grdcheck.F,v 1.3 2011/10/21 16:11:24 yoj Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

       SUBROUTINE GRDCHECK ( FNAME, LOK )

C----------------------------------------------------------------------
C Function: To check files and COORD.EXT for consistency
 
C Preconditions: None
 
C Key Subroutines/Functions Called:
 
C Revision History:
C    Prototype created by Jerry Gipson, September, 1997
C    eliminate EMISLYRS, Jeff, Oct 97
C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C    6 Sep 06 J.Young: ensure LNLAYSOK is initialized - Michael Bane's suggestion
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN

      IMPLICIT NONE 

C..INCLUDES:
      INCLUDE SUBST_FILES_ID    ! file name parameters
       
C..ARGUMENTS:
      CHARACTER*(*) FNAME     ! File Name
      LOGICAL LOK             ! Flag to indicate error found

C..PARAMETERS: None

C..EXTERNAL FUNCTIONS: None

C..SAVED LOCAL VARIABLES: None
      
C..SCRATCH LOCAL VARIABLES:
      CHARACTER*20 CHR1      ! Value of variable 1 in character data
      CHARACTER*20 CHR2      ! Value of variable 1 in character data
      CHARACTER*80 MSG       ! Message

      INTEGER LAY       ! Loop index for layers
      INTEGER NCOLS_DOT ! No. of columns for a dot file
      INTEGER NLAYS_FL  ! No. of layers expected on 3D file
      INTEGER NLAYS2CK  ! No. of layers to check vertical levels
      INTEGER NROWS_DOT ! No. of rows for a dot file

      LOGICAL LDIFF     ! Flag for difference in vertical levels
      LOGICAL LNLAYSOK  ! Flag to indicate no. of vert. layers OK

      REAL*8 XORIG_FL   ! Computed XORIG for dot file
      REAL*8 YORIG_FL   ! Computed YORIG for dot file

C----------------------------------------------------------------------

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check horizontal grid structure
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

C...For DOT files only
      IF(INDEX( FNAME, '_DOT_' ) .NE. 0 ) THEN

         IF( GL_NCOLS + 1 .NE. NCOLS3D ) THEN
            NCOLS_DOT = GL_NCOLS + 1
            CALL INTDIFF( 'GL_NCOLS', NCOLS3D, NCOLS_DOT )
            LOK = .FALSE.
         END IF

         IF( GL_NROWS + 1 .NE. NROWS3D ) THEN
            NROWS_DOT = GL_NROWS + 1
            CALL INTDIFF( 'GL_NROWS', NROWS3D,  NROWS_DOT )
            LOK = .FALSE.
         END IF

C...Skip PDM files
      ELSEIF( INDEX( FNAME, 'PDM_' ) .NE. 0) THEN

C...Skip PING files
      ELSEIF( INDEX( FNAME, '_PING_' ) .NE. 0) THEN

C...Skip IPR files
      ELSEIF( INDEX( FNAME, '_IPR_' ) .NE. 0) THEN

C...Skip IRR files
      ELSEIF( INDEX( FNAME, '_IRR_' ) .NE. 0) THEN

C...All other files
      ELSE

         IF( GL_NCOLS .NE. NCOLS3D ) THEN
            CALL INTDIFF( 'GL_NCOLS', NCOLS3D, GL_NCOLS )
            LOK = .FALSE.
         END IF

         IF( GL_NROWS .NE. NROWS3D ) THEN
            CALL INTDIFF( 'GL_NROWS', NROWS3D, GL_NROWS )
            LOK = .FALSE.
         END IF
 
      END IF

C...Check Number of vertical layers only for true 3D files

      LNLAYSOK = .TRUE.

      IF( INDEX( FNAME,   'PDM_' ) .EQ. 0 .AND.
     &    INDEX( FNAME, '_PING_' ) .EQ. 0 .AND. NLAYS3D .GT. 1 )  THEN

         IF( INDEX( FNAME,  'EMIS' ) .GT. 0 .OR.
     &       INDEX( FNAME, 'MEPSE' ) .GT. 0 .OR.
     &       INDEX( FNAME, '_IPR_' ) .GT. 0 .OR.
     &       INDEX( FNAME, '_IRR_' ) .GT. 0 ) THEN
!           NLAYS_FL = EMISLYRS
            NLAYS_FL = NLAYS3D   ! don't check this file
         ELSE
            NLAYS_FL = NLAYS
         END IF

         IF( NLAYS_FL .NE. NLAYS3D ) THEN
            CALL INTDIFF( 'NLAYS', NLAYS3D, NLAYS_FL )
            LOK = .FALSE.
            LNLAYSOK = .FALSE.
         END IF

         IF( NTHIK .NE. NTHIK3D ) THEN
            CALL INTDIFF( 'NTHIK', NTHIK3D, NTHIK )
            LOK = .FALSE.
         END IF
             
      END IF
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check Map projection
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF( GDTYP_GD .NE. GDTYP3D ) THEN
         CALL INTDIFF( 'GDTYP', GDTYP_GD, GDTYP3D )
         LOK = .FALSE.
      END IF

C...Check P_ALPHA only for Lambert, Mercator, Stereographic and UTM
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 5 ) THEN      
         WRITE( CHR1, 94020 ) P_ALP3D
         WRITE( CHR2, 94020 ) P_ALP_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'P_ALP', CHR1, CHR2 )
            LOK = .FALSE.
        END IF
      END IF

C...Check P_BETA only for Lambert, Mercator, and Stereographic
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 4 ) THEN      
         WRITE( CHR1, 94020 ) P_BET3D
         WRITE( CHR2, 94020 ) P_BET_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'P_BET', CHR1,  CHR2 )
            LOK = .FALSE.
        END IF
      END IF

C...Check P_GAMMA only for Lambert, Mercator, and Stereographic
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 4 ) THEN      
         WRITE( CHR1, 94020 ) P_GAM3D
         WRITE( CHR2, 94020 ) P_GAM_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'P_GAM', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
      END IF

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check for horizontal grid location and size
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C...Check XORG & YORG only for Lambert, Mercator, Stereographic and UTM
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 5 ) THEN      
         IF( INDEX( FNAME, '_DOT_' ) .GT. 0 ) THEN
            XORIG_FL = XORIG_GD - 0.5 * XCELL_GD
            YORIG_FL = YORIG_GD - 0.5 * YCELL_GD
         ELSE
            XORIG_FL = XORIG_GD 
            YORIG_FL = YORIG_GD 
         END IF
         WRITE( CHR1, 94020 ) XORIG3D
         WRITE( CHR2, 94020 ) XORIG_FL
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'XORIG', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
         WRITE( CHR1, 94020 ) YORIG3D
         WRITE( CHR2, 94020 ) YORIG_FL
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'YORIG', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
      END IF

C...Check XCENT & YCENT only for Lambert, Mercator, and Stereographic
      IF( GDTYP_GD .GE. 2 .AND. GDTYP_GD .LE. 4 ) THEN      
         WRITE( CHR1, 94020 ) XCENT3D
         WRITE( CHR2, 94020 ) XCENT_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'XCENT', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF

         WRITE( CHR1, 94020 ) YCENT3D
         WRITE( CHR2, 94020 ) YCENT_GD
         IF( CHR1 .NE. CHR2 ) THEN
            CALL CHRDIFF( 'YCENT', CHR1,  CHR2 )
            LOK = .FALSE.
         END IF
      END IF

      WRITE( CHR1, 94020 ) XCELL3D
      WRITE( CHR2, 94020 ) XCELL_GD
      IF( CHR1 .NE. CHR2 ) THEN
         CALL CHRDIFF( 'XCELL', CHR1,  CHR2 )
         LOK = .FALSE.
      END IF

      WRITE( CHR1, 94020 ) YCELL3D
      WRITE( CHR2, 94020 ) YCELL_GD
      IF( CHR1 .NE. CHR2 ) THEN
         CALL CHRDIFF( 'YCELL', CHR1,  CHR2 )
         LOK = .FALSE.
      END IF
 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Check vertical structure (only for "true" 3D files
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF( INDEX( FNAME,   'PDM_' ) .EQ. 0 .AND.
     &    INDEX( FNAME, '_PING_' ) .EQ. 0 .AND.
     &    NLAYS3D .GT. 1 .AND. LNLAYSOK )  THEN

         IF( VGTYP_GD .NE. VGTYP3D ) THEN
            CALL INTDIFF( 'VGTYP', VGTYP3D, VGTYP_GD )
            LOK = .FALSE.
         END IF

C..Check for vtop for sigma-p coordinates only
         IF( VGTYP3D .GE. 1 .AND. VGTYP3D .LE. 2 ) THEN  
            WRITE( CHR1, 94020 ) VGTOP3D
            WRITE( CHR2, 94020 ) VGTOP_GD
            IF( CHR1 .NE. CHR2 ) THEN
               CALL CHRDIFF( 'VGTOP', CHR1,  CHR2 )
               LOK = .FALSE.
            END IF
         END IF

C..Check vertical levels for 3D files only

         LDIFF = .FALSE.

         IF( INDEX( FNAME, 'EMIS' ) .GT. 0 ) THEN
!           NLAYS2CK = EMISLYRS
            NLAYS2CK = NLAYS3D
         ELSE
            NLAYS2CK = NLAYS
         END IF

         DO LAY = 1 , NLAYS2CK
            WRITE( CHR1, 94020 ) VGLVS3D( LAY )
            WRITE( CHR2, 94020 ) VGLVS_GD( LAY )
            IF( CHR1 .NE. CHR2 ) LDIFF = .TRUE.
         END DO

         IF( LDIFF ) THEN    
            MSG = '    Inconsistent value for vertical level'
            CALL M3MESG( MSG )
            LOK = .FALSE.
         END IF

      END IF

      RETURN

94020 FORMAT( 1PE20.4 )

      END
         

      SUBROUTINE SA_WRAP_AE( CGRID0, CGRID, JDATE, JTIME, TSTEP )

!*************************************************************
!20140428 As a wrapper to apportion the tags with bulk conc after AERO process
!
!     Called by sciproc.F

! Revision History:
!
!   13 May 19 David Wong: Implemented centralized I/O approach
!*************************************************************
      USE GRID_CONF
      USE CGRID_SPCS
      USE SA_DEFN
      USE UTILIO_DEFN
      USE AERO_BUDGET
      USE AERO_DATA, ONLY : AERO_MISSING, AEROSPC_MAP, N_MODE,
     &                      N_AEROSPC, AEROSPC
      USE CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID
      INCLUDE SUBST_CONST

! Arguments
      REAL, POINTER             :: CGRID( :,:,:,: )
      REAL                      :: CGRID0( :,:,:,: )
      INTEGER, INTENT( IN )     :: JDATE
      INTEGER, INTENT( IN )     :: JTIME
      INTEGER, INTENT( IN )     :: TSTEP( 3 )

! Scratch
      CHARACTER( 16 ), SAVE :: PNAME = 'SA_WRAP_AE'
      INTEGER S,V,K
      INTEGER JSPCTAG
      INTEGER IBGN
      REAL    TOTAL_OLD, TOTAL_NEW
      CHARACTER( 16 ) :: PRECUR
      REAL, ALLOCATABLE, SAVE :: TTLB4( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: SULFCOND( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SULFCOND_AIT( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SULFCOND_ACC( :,:,: )
      REAL, ALLOCATABLE, SAVE :: CCOND( :,:,:,: )

! for interpx
      REAL DX1, DX2
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      REAL DENS ( NCOLS,NROWS,NLAYS )
      INTEGER MDATE, MTIME, MSTEP
      CHARACTER( 96 ) :: XMSG = ' '

! Constants of Gas Law
      REAL, PARAMETER :: SLP0 = 101325.0 ! standard atm (centibars) * 1000
      REAL, PARAMETER :: GAS_CONST = 8.2057E-05 ! gas const (L-atm/mole-k) / 1000
      REAL, PARAMETER :: MWNH3 = 17.03061
      REAL, PARAMETER :: MWNH4 = 18.03858
      REAL, PARAMETER :: MWHNO3 = 63.01287
      REAL, PARAMETER :: MWNO3 = 62.0049
      REAL, PARAMETER :: MWCL  = 35.453
      REAL, PARAMETER :: MWSO4 = 96.0576

! ppm2mole conversion
      REAL ppm2mole( NCOLS,NROWS,NLAYS )

! Identify ISAM species indices 20130529
      INTEGER, SAVE :: JNH3, JNH4I, JNH4J, JHNO3, JNO3I, JNO3J
      INTEGER, SAVE :: JHCL, JCLI , JCLJ
      INTEGER, SAVE :: JSULF, JSO4I, JSO4J, JSRXN

      INTEGER :: ISA1, ISA2, ICG1, ICG2, IAER, IM, INDX

      INTEGER, SAVE :: CNH3, CNH4I, CNH4J, CHNO3, CNO3I, CNO3J
      INTEGER, SAVE :: CHCL, CCLI,  CCLJ


! Arrays for combined ammonium, combined nitrates, and combined sulfates
      REAL, ALLOCATABLE, SAVE :: AMMONIA_TAG (:,:,:)
      REAL, ALLOCATABLE, SAVE :: NITRATE_TAG (:,:,:)
      REAL, ALLOCATABLE, SAVE :: CHLORINE_TAG(:,:,:)
      REAL, ALLOCATABLE, SAVE :: SULFATE_TAG (:,:,:)
      REAL, ALLOCATABLE, SAVE :: TOTAER_TAG (:,:,:)

      REAL, ALLOCATABLE, SAVE :: TOTNH3(:,:,:)
      REAL, ALLOCATABLE, SAVE :: TOTNO3(:,:,:)
      REAL, ALLOCATABLE, SAVE :: TOTCL (:,:,:)
      REAL, ALLOCATABLE, SAVE :: TOTSO4(:,:,:)
      REAL, ALLOCATABLE, SAVE :: TOTAER(:,:,:)
      REAL, ALLOCATABLE, SAVE :: FRAC1(:,:,:)
      REAL, ALLOCATABLE, SAVE :: FRAC2(:,:,:)

      REAL, ALLOCATABLE, SAVE :: ISAM0(:,:,:,:,:)
      REAL, ALLOCATABLE, SAVE :: ISAM1(:,:,:,:,:)

      REAL ::  FRAC( NCOLS,NROWS,NLAYS )
      REAL ::  A(3)

! Logicals for determining presence of inorganic ions
      LOGICAL, SAVE :: LAE_NH4 
      LOGICAL, SAVE :: LAE_NO3 
      LOGICAL, SAVE :: LAE_CL 
      LOGICAL, SAVE :: LAE_SO4 
     
      REAL, PARAMETER :: MIN_VAL = 1.0E-25
      REAL, SAVE :: MIN_TAGTOT 

      INTEGER ALLOCSTAT
!-------------------------------------------------------------------


Ckrt Identify species index in ISAM array
      ! Decompose domain for Density
      IF ( FIRSTIME ) THEN
        FIRSTIME = .FALSE.

        LAE_NH4 = .FALSE.
        LAE_NO3 = .FALSE.
        LAE_CL  = .FALSE.
        LAE_SO4 = .FALSE.

        JNH3  = INDEX1( 'NH3', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JNH4I = INDEX1( 'ANH4I', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JNH4J = INDEX1( 'ANH4J', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        IF ( JNH3 .GT. 0 .AND. JNH4I .GT. 0 .AND. JNH4J .GT. 0 ) THEN
          LAE_NH4 = .TRUE.
          CNH3  = SPC_INDEX( JNH3, 2 )
          CNH4I = SPC_INDEX( JNH4I,2 )
          CNH4J = SPC_INDEX( JNH4J,2 )
        END IF

        JHNO3 = INDEX1( 'HNO3', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JNO3I = INDEX1( 'ANO3I', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JNO3J = INDEX1( 'ANO3J', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        IF ( JHNO3 .GT. 0 .AND. JNO3I .GT. 0 .AND. JNO3J .GT. 0 ) THEN
          LAE_NO3 = .TRUE.
          CHNO3 = SPC_INDEX( JHNO3,2 )
          CNO3I = SPC_INDEX( JNO3I,2 )
          CNO3J = SPC_INDEX( JNO3J,2 )
        END IF
 
        JHCL = INDEX1( 'HCL',  NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JCLI = INDEX1( 'ACLI', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JCLJ = INDEX1( 'ACLJ', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        IF ( JHCL .GT. 0 .AND. JCLI .GT. 0 .AND. JCLJ .GT. 0 ) THEN
          LAE_CL = .TRUE.
          CHCL = SPC_INDEX( JHCL,2 )
          CCLI = SPC_INDEX( JCLI,2 )
          CCLJ = SPC_INDEX( JCLJ,2 )
        END IF
 
        JSULF = INDEX1( 'SULF', NSPC_SA, SPC_NAME( :,OTHRTAG ) )  
        JSO4I = INDEX1( 'ASO4I', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JSO4J = INDEX1( 'ASO4J', NSPC_SA, SPC_NAME( :,OTHRTAG ) )
        JSRXN = INDEX1( 'SULRXN', NSPC_SA, SPC_NAME( :,OTHRTAG ) )  
        IF ( JSULF .GT. 0 .AND. JSO4I .GT. 0 .AND. JSO4J .GT. 0 
     &       .AND. JSRXN .GT. 0 ) LAE_SO4 = .TRUE.

        ! Map Aerosol Modes and Names to Source Apportionment Species
        ALLOCATE( MAP_AEROtoSA( N_AEROSPC, N_MODE ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating MAP_AEROtoSA'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        MAP_AEROtoSA( :,: ) = 0
        DO IM = 1,N_MODE
            DO IAER = 1,N_AEROSPC
                INDX = INDEX1( AEROSPC( IAER )%NAME( IM ), NSPC_SA, SPC_NAME( :,2 ) )
                IF ( INDX .NE. 0 ) MAP_AEROtoSA( IAER,IM ) = INDX
            END DO
        END DO

        MIN_TAGTOT = MIN_VAL * NTAG_SA
  
        IF ( .NOT. OPEN3( MET_CRO_3D, FSREAD3, PNAME ) ) THEN
          XMSG = 'Could not open  MET_CRO_3D  file '
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE( CCOND( NCOLS,NROWS,NLAYS,NSPCSD ),
     &     TTLB4( NCOLS,NROWS,NLAYS,NSPC_SA ),
     &     SULFCOND( NCOLS,NROWS,NLAYS ), 
     &     SULFCOND_AIT( NCOLS,NROWS,NLAYS ),
     &     SULFCOND_ACC( NCOLS,NROWS,NLAYS ),
     &     STAT = ALLOCSTAT ) 
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating TTLB4, SULFCOND, SULFCOND_AIT, '
     &          //'or SULFCOND_ACC'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE( AMMONIA_TAG( NCOLS,NROWS,NLAYS ),
     &     NITRATE_TAG ( NCOLS,NROWS,NLAYS ),
     &     CHLORINE_TAG( NCOLS,NROWS,NLAYS ),
     &     SULFATE_TAG ( NCOLS,NROWS,NLAYS ),
     &     TOTAER_TAG  ( NCOLS,NROWS,NLAYS ),
     &     STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating AMMONIA_TAG, NITRATE_TAG, '
     &          //'SULFATE_TAG, or TOTAER_TAG'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE( TOTNH3( NCOLS,NROWS,NLAYS ),
     &     TOTNO3( NCOLS,NROWS,NLAYS ),
     &     TOTCL ( NCOLS,NROWS,NLAYS ),
     &     TOTSO4( NCOLS,NROWS,NLAYS ),
     &     TOTAER( NCOLS,NROWS,NLAYS ),
     &     FRAC1( NCOLS,NROWS,NLAYS ),
     &     FRAC2( NCOLS,NROWS,NLAYS ),
     &     STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating TOTNO3, TOTSO4, TOTAER, '
     &          //'FRAC1, or FRAC2'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE( ISAM0( NCOLS,NROWS,NLAYS,NSPC_SA,NTAG_SA ),
     &     ISAM1( NCOLS,NROWS,NLAYS,NSPC_SA,NTAG_SA ),
     &     STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating ISAM0 or ISAM1 '
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

      ENDIF ! firstime ?

      ! Extract Density for gas conversion to umol/m3
      MDATE = JDATE
      MTIME = JTIME
      MSTEP = TIME2SEC( TSTEP( 2 ) )
      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( MSTEP/2 ) )

      ! Get Air Density in kg/m3
      call interpolate_var ('DENS', MDATE, MTIME, DENS)

      ! Conversion factor to move gases from ppmv to umol/m3
      ppm2mole( :,:,: ) = MAX( DENS( :,:,: ) * 1000. / MWAIR, 1e-10 )
      
      ! Create 1D array of combined ammonium tags and combined nitrate tags
      AMMONIA_TAG  = 0.0
      NITRATE_TAG  = 0.0
      CHLORINE_TAG = 0.0
      SULFATE_TAG  = 0.0

      ! Sum up pre-process tags for each species at each grid cell
c     ISAM = MAX( ISAM, MIN_VAL )
      CGRID0 = MAX( CGRID0, MIN_TAGTOT )
      ISAM0(:,:,:,:,:) = ISAM(:,:,:,:,:)
      ISAM1(:,:,:,:,:) = ISAM(:,:,:,:,:)
      TTLB4( :,:,:,: ) = SUM( ISAM( :,:,:,:,: ),5 )

      CCOND = MAX( CGRID0 + AERO_COND, MIN_TAGTOT )

      IF ( LAE_SO4 ) THEN
         SULFCOND = MAX( ( AERO_COND( :,:,:,SPC_INDEX(JSO4I,2) ) 
     &            + AERO_COND( :,:,:,SPC_INDEX(JSO4J,2) ) 
     &            + AERO_NPF ( :,:,:,SPC_INDEX(JSO4I,2) ) ), MIN_VAL )
         SULFCOND_AIT = (AERO_COND( :,:,:,SPC_INDEX( JSO4I,2 ))  
     &                + AERO_NPF( :,:,:,SPC_INDEX(JSO4I,2)) ) / SULFCOND  
         SULFCOND_ACC = 1.0 - SULFCOND_AIT
      END IF

      ! Preprocess total - ammonium and ammonia
      IF ( LAE_NH4 ) THEN
        CCOND( :,:,:,CNH3 )  = CCOND( :,:,:,CNH3 ) * ppm2mole ! umol / m3
        CCOND( :,:,:,CNH4I ) = CCOND( :,:,:,CNH4I ) / MWNH4   ! umol / m3
        CCOND( :,:,:,CNH4J ) = CCOND( :,:,:,CNH4J ) / MWNH4   ! umol / m3
        TOTNH3 = TTLB4( :,:,:,JNH3 ) * ppm2mole + TTLB4( :,:,:,JNH4I ) / MWNH4 
     &          +TTLB4( :,:,:,JNH4J ) / MWNH4
      ENDIF 

      ! Preprocess total nitrate
      IF ( LAE_NO3 ) THEN
        CCOND( :,:,:,CHNO3 ) = CCOND( :,:,:,CHNO3 ) * ppm2mole
        CCOND( :,:,:,CNO3I ) = CCOND( :,:,:,CNO3I ) / MWNO3
        CCOND( :,:,:,CNO3J ) = CCOND( :,:,:,CNO3J ) / MWNO3
        TOTNO3 = TTLB4( :,:,:,JHNO3 ) * ppm2mole + TTLB4( :,:,:,JNO3I ) / MWNO3 
     &          +TTLB4( :,:,:,JNO3J ) / MWNO3
      ENDIF 
 
      ! Preprocess total chlorine
      IF ( LAE_CL ) THEN
        CCOND( :,:,:,CHCL ) = CCOND( :,:,:,CHCL ) * ppm2mole
        CCOND( :,:,:,CCLI ) = CCOND( :,:,:,CCLI ) / MWCL
        CCOND( :,:,:,CCLJ ) = CCOND( :,:,:,CCLJ ) / MWCL
        TOTCL = TTLB4( :,:,:,JHCL ) * ppm2mole + TTLB4( :,:,:,JCLI ) / MWCL
     &         +TTLB4( :,:,:,JCLJ ) / MWCL
      ENDIF 
 
      ! Preprocess total sulfate
      IF ( LAE_SO4 ) THEN
        TTLB4( :,:,:,JSULF ) = TTLB4( :,:,:,JSULF ) * ppm2mole
        TTLB4( :,:,:,JSRXN ) = TTLB4( :,:,:,JSRXN ) * ppm2mole
        TTLB4( :,:,:,JSO4I ) = TTLB4( :,:,:,JSO4I ) / MWSO4
        TTLB4( :,:,:,JSO4J ) = TTLB4( :,:,:,JSO4J ) / MWSO4
      ENDIF 

c  !------------------------!
c  !>>>>> CONDENSATION <<<<<!
      ! Find preprocess bulk fraction for condensable species and
      ! propagate source apporitonment through aerosol condensation changes
      DO K = 1, NTAG_SA

        ! Ammonium
        IF ( LAE_NH4 ) THEN
          
          AMMONIA_TAG( :,:,: ) = (  ISAM0( :,:,:,JNH3,K ) * ppm2mole
     &                              + ISAM0( :,:,:,JNH4I,K )/ MWNH4
     &                              + ISAM0( :,:,:,JNH4J,K )/ MWNH4 ) /
     &                                MAX( TOTNH3, MIN_TAGTOT*3.0 )
c     &                            (    TTLB4( :,:,:,JNH4I ) / MWNH4
c     &                              + TTLB4( :,:,:,JNH4J ) / MWNH4
c     &                              + TTLB4( :,:,:,JNH3 ) * ppm2mole )     

          ISAM1( :,:,:,JNH3,K )  = AMMONIA_TAG( :,:,: ) * CCOND( :,:,:,CNH3 ) / ppm2mole
          ISAM1( :,:,:,JNH4I,K ) = AMMONIA_TAG( :,:,: ) * CCOND( :,:,:,CNH4I ) * MWNH4
          ISAM1( :,:,:,JNH4J,K ) = AMMONIA_TAG( :,:,: ) * CCOND( :,:,:,CNH4J ) * MWNH4
        ENDIF 

        ! Nitrate
        IF ( LAE_NO3 ) THEN
           NITRATE_TAG( :,:,: ) = ( ISAM0( :,:,:,JHNO3,K ) * ppm2mole
     &                              + ISAM0( :,:,:,JNO3I,K )/ MWNO3
     &                              + ISAM0( :,:,:,JNO3J,K )/ MWNO3 ) /
     &                                MAX( TOTNO3, MIN_TAGTOT*3.0 )
c     &                            (    TTLB4( :,:,:,JNO3I ) / MWNO3
c     &                              + TTLB4( :,:,:,JNO3J ) / MWNO3
c     &                              + TTLB4( :,:,:,JHNO3 ) * ppm2mole )

          ISAM1( :,:,:,JHNO3,K ) = NITRATE_TAG( :,:,: ) * CCOND( :,:,:,CHNO3 ) / ppm2mole
          ISAM1( :,:,:,JNO3I,K ) = NITRATE_TAG( :,:,: ) * CCOND( :,:,:,CNO3I ) * MWNO3
          ISAM1( :,:,:,JNO3J,K ) = NITRATE_TAG( :,:,: ) * CCOND( :,:,:,CNO3J ) * MWNO3
        ENDIF

        ! Chlorine
        IF ( LAE_CL ) THEN
           CHLORINE_TAG( :,:,: ) = ( ISAM0( :,:,:,JHCL,K ) * ppm2mole
     &                             + ISAM0( :,:,:,JCLI,K )/ MWCL
     &                             + ISAM0( :,:,:,JCLJ,K )/ MWCL ) /
     &                                MAX( TOTCL, MIN_TAGTOT*3.0 )
c     &                            (    TTLB4( :,:,:,JNO3I ) / MWNO3
c     &                              + TTLB4( :,:,:,JNO3J ) / MWNO3
c     &                              + TTLB4( :,:,:,JHNO3 ) * ppm2mole )

          ISAM1( :,:,:,JHCL,K ) = CHLORINE_TAG( :,:,: ) * CCOND( :,:,:,CHCL ) / ppm2mole
          ISAM1( :,:,:,JCLI,K ) = CHLORINE_TAG( :,:,: ) * CCOND( :,:,:,CCLI ) * MWCL
          ISAM1( :,:,:,JCLJ,K ) = CHLORINE_TAG( :,:,: ) * CCOND( :,:,:,CCLJ ) * MWCL
        ENDIF
 
        ! Sulfate
        IF ( LAE_SO4 ) THEN
          ! Use Source Distribution of Sulfuric Acid Produced and apply
          ! that profile to the mass that was condensed to each mode.
          ISAM1( :,:,:,JSO4I,K ) = ISAM0( :,:,:,JSO4I,K ) + 
     &                             ISAM0( :,:,:,JSRXN,K ) * SULFCOND_AIT( :,:,: )
     &                             * ppm2mole ( :,:,: ) * 98.0

          ISAM1( :,:,:,JSO4J,K ) = ISAM0( :,:,:,JSO4J,K ) + 
     &                             ISAM0( :,:,:,JSRXN,K ) * SULFCOND_ACC( :,:,: )
     &                             * ppm2mole ( :,:,: ) * 98.0

          ISAM1( :,:,:,JSRXN,K ) = MIN_VAL
        ENDIF 

      ENDDO ! k tags

      ! Let the Sulfuric Acid Vapor Source Distribution equal that of the
      ! total condensed sulfate
      IF ( LAE_SO4 ) THEN
         TOTSO4 = MAX( SUM( ISAM1( :,:,:,JSO4I,: ),4 ) 
     &          + SUM( ISAM1(:,:,:,JSO4J,: ),4 ), MIN_TAGTOT*2.0 )
         DO K = 1,NTAG_SA
            FRAC( :,:,: ) = ( ISAM1( :,:,:,JSO4I,K ) + ISAM1( :,:,:,JSO4J,K ) ) / TOTSO4
            ISAM1( :,:,:,JSULF,K ) = FRAC( :,:,: ) * CGRID( :,:,:,SPC_INDEX(JSULF,2) )
         END DO
      END IF

c  !-----------------------!
c  !>>>>> COAGULATION <<<<<!
      ! Propagate source apportionment changes through coagulation and
      ! growth processes
      DO IAER = 1,N_AEROSPC
          IF ( AERO_MISSING( IAER,1 ) ) CYCLE

          ! Account for Loss of Aitken Mode from Coagulation and Growth
          ! Move source contribution from Aitken mode to Accumulation
          ! mode
          ISA1 = MAP_AEROtoSA( IAER,1 )  ! Index of source particles (1=Aitken)
          IF ( ISA1 .EQ. 0 ) CYCLE

          ISA2 = MAP_AEROtoSA( IAER,2 )  ! Index of destination particles (2=Accumulation)
          ICG1 = AEROSPC_MAP( IAER,1 )   ! Index of source in aerosol process analysis array
          ICG2 = AEROSPC_MAP( IAER,2 )   ! Index of destination in aerosol process analysis array

          ! Get Current Partitioning of Mass Between Source and
          ! Destination Modes
          TOTAER( :,:,: )  = CGRID( :,:,:,ICG1 ) + CGRID( :,:,:,ICG2 )
          FRAC1( :,:,: ) = CGRID( :,:,:,ICG1 ) / MAX( TOTAER( :,:,: ), MIN_TAGTOT )
          FRAC2( :,:,: ) = 1.0 - FRAC1( :,:,: )

          DO K = 1,NTAG_SA
             ! Sum Total Aerosols Among Relevant Modes for this Tag
             TOTAER_TAG( :,:,: ) = ISAM1( :,:,:,ISA1,K ) + ISAM1( :,:,:,ISA2,K )

             ! Calculate New Tag Concentrations
             ISAM1( :,:,:,ISA1,K ) = TOTAER_TAG * FRAC1
             ISAM1( :,:,:,ISA2,K ) = TOTAER_TAG * FRAC2

          END DO
      END DO

      ! Update global ISAM array with modified attribution array ISAM1
      ISAM = ISAM1

      END 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE VGRD_DEFN

C Define the vertical layer structure (replaces COORD.EXT and VGRD.EXT)
C Revision History: Jeff Young: 6 Dec 04: created
C                              26 Jul 06: comments in line with PARMS3.EXT
C                   S. Roselle 29 Mar 11: Replaced I/O API include files
C                                         with UTILIO_DEFN
C                   D. Wong    11 May 11: incorporated twoway model implementation
C.......................................................................

      USE RUNTIME_VARS

      IMPLICIT NONE

      INTEGER, SAVE :: NLAYS = 0

      REAL, ALLOCATABLE, SAVE :: VGLVS_GD( : )  ! vert layer surface values
      REAL, ALLOCATABLE, SAVE :: X3FACE_GD( : ) ! mono. incr. vert coord values
                                                ! = 1 - VGLVS_GD
      CHARACTER( 16 ), SAVE :: GDNAME_GD

C The definitions and declarations in this F90 Module follow those
C given in the I/O-API include file FDESC3C.EXT and replace similar
C definitions. This F90 Module is compatible with FDESC3C.EXT.

C VGTYP_GD:
C The vertical grid type:
C  1: VGSGPH3 : hydrostatic sigma-P
C  2: VGSGPN3 : non-h sigma-P
C  3: VGSIGZ3 : sigma-Z
C  4: VGPRES3 : pressure (mb)
C  5: VGZVAL3 : Z (m) (above sea lvl)
C  6: VGHVAL3 : H (m) (above ground)
C  7: VGWRFEM : WRF mass-core sigma
C  8: VGWRFNM : WRF NMM
C  9: IMISS3 for vertical coordinates not stored in VGLVSD
C            (e.g., temporally or spatially changing vertical coordinates)

      INTEGER, SAVE :: VGTYP_GD

C VGTPUN_GD:
C The units of the vertical coordinate top.

      CHARACTER( 16 ), SAVE :: VGTPUN_GD

C VGTOP_GD:
C The value for the model top used in the definition of the sigma coordinate
C systems in the VGTPUN_GD units.

      REAL, SAVE :: VGTOP_GD

C For sigma-P, the relationship between pressure levels P and sigma-P is
C given by:
C    sigma-P = ( P - VGTOP_GD ) / (P_srf - VGTOP_GD ),
C    where P_srf is the surface pressure.

C VGLVUN_GD:
C The units of the vertical coordinate surface values,

      CHARACTER( 16 ) :: VGLVUN_GD

C-----------------------------------------------------------------------

      CONTAINS

         FUNCTION VGRD_INIT ( ) RESULT ( SUCCESS )

            USE UTILIO_DEFN

            IMPLICIT NONE

            LOGICAL :: SUCCESS

            LOGICAL, SAVE :: FIRSTIME = .TRUE.
            CHARACTER( 96 ) :: XMSG = ' '
!           CHARACTER( 16 ) :: LAYER_FILE = 'LAYER_FILE'
            CHARACTER( 16 ) :: LAYER_FILE = 'MET_CRO_3D'

            INTEGER L, ALLOCSTAT

C This function is expected to be called only once - at startup

            IF ( FIRSTIME ) THEN
               FIRSTIME = .FALSE.
               SUCCESS = .TRUE.

C get vert layer definition from LAYER_FILE

               WRITE( LOGDEV, * )
               CALL LOG_HEADING( LOGDEV, "Retrieve Vertical Grid" )
               IF ( .NOT. OPEN3( LAYER_FILE, FSREAD3, 'VGRD_INIT' ) ) THEN
                  XMSG = 'Could not open '// LAYER_FILE
                  CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
                  END IF

               IF ( .NOT. DESC3( LAYER_FILE ) ) THEN
                  XMSG = 'Could not get ' // LAYER_FILE // ' file description'
                  CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
                  END IF

               GDNAME_GD = GDNAM3D

               NLAYS = NLAYS3D

               VGTYP_GD  = VGTYP3D
               VGTOP_GD  = VGTOP3D
               VGTPUN_GD = 'Pa'
               VGLVUN_GD = 'none'

               ALLOCATE ( VGLVS_GD( NLAYS + 1 ), STAT = ALLOCSTAT )
               ALLOCATE ( X3FACE_GD( 0:NLAYS ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating VGLVS_GD, X3FACE_GD'
                  CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
                  END IF

               DO L = 1, NLAYS + 1
                  VGLVS_GD( L ) = VGLVS3D( L )
                  END DO

C set layer layer thickenesses

               DO L = 0, NLAYS
                  X3FACE_GD( L ) = 1.0 - VGLVS_GD( L + 1 )
                  END DO

            ELSE
            XMSG = 'Vertical layer structure already defined'
            CALL M3WARN ( 'VGRD_INIT', 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN

            END IF   ! FIRSTIME

         RETURN
         END FUNCTION VGRD_INIT

      END MODULE VGRD_DEFN

C  21   VGLVS_GD   X3FACE_GD
C  
C   1     1.0       0.0
C   2     0.995     0.005
C   3     0.99      0.01
C   4     0.985     0.015
C   5     0.98      0.02
C   6     0.97      0.03
C   7     0.96      0.04
C   8     0.945     0.055
C   9     0.93      0.07
C  10     0.91      0.09
C  11     0.89      0.11
C  12     0.865     0.135
C  13     0.84      0.16
C  14     0.78      0.22
C  15     0.7       0.3
C  16     0.6       0.4
C  17     0.5       0.5
C  18     0.4       0.6
C  19     0.3       0.7
C  20     0.2       0.8
C  21     0.1       0.9
C  22     0.0       1.0

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/checkmem.f,v 1.3 2011/10/21 16:10:17 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CHECKMEM( MSTATUS, AVAR, CALLER )
 
C-----------------------------------------------------------------------
 
C  Description:
C       Reports an error and exits if memory status flag is non-zero.
 
C  Preconditions:
 
C  Subroutines and Functions Called:
 
C  Revision History:
C       Adapted 10/98 by M Houyoux
C       02/11: S.Roselle-Removed deprecated TRIMLEN

C-----------------------------------------------------------------------
C Modified from:
 
C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C             System
C File: @(#)$Id: checkmem.f,v 1.3 2011/10/21 16:10:17 yoj Exp $
C COPYRIGHT (C) 1999, MCNC--North Carolina Supercomputing Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Programs Group
C MCNC--North Carolina Supercomputing Center
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C env_progs@mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/checkmem.f,v $
C Last updated: $Date: 2011/10/21 16:10:17 $ 
 
C-----------------------------------------------------------------------
 
      IMPLICIT NONE

C Arguments:

      INTEGER           MSTATUS  ! ALLOCATE function exit status
      CHARACTER( * ) :: AVAR     ! Variable name of ALLOCATE statement
      CHARACTER( * ) :: CALLER   ! Name of calling procedure

C External Functions:

C Local Variables;
      INTEGER       L1
      INTEGER       L2
      CHARACTER( 256 ) :: MESG = ' '

C-----------------------------------------------------------------------

C Abort if memory status is non-zero

      IF ( MSTATUS .GT. 0 ) THEN           
         L1 = LEN_TRIM( AVAR )
         L2 = LEN_TRIM( CALLER )
         MESG = 'Failure allocating memory for "' // AVAR( 1:L1 )
     &        // '" variable'
         CALL M3EXIT( CALLER( 1:L2 ), 0, 0, MESG, 2 )
      END IF

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /amber/home/krt/cmq471/models/CCTM/src/vdiff/acm2_inline/opddep.F,v 1.1.1.1 2010/06/14 16:03:07 sjr Exp $
 
C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SA_OPWDDEP ( SADEPFILE, JDATE, JTIME, TSTEP )

C20140428  Open dry or wet deposition file (SA_DD_1 or SA_WD_1 as SADEPFILE)
C          for ISAM tracers.
C
C          Called by vdiffproc.F (dry) or initscen.F (wet)

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE UTILIO_DEFN         ! 20120712 replaces ioparms, iofdesc, iodecl
      USE SA_DEFN             ! Mc06
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      IMPLICIT NONE
 
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      CHARACTER( 16 )  SADEPFILE ! Either SA_DD_1 or SA_WD_1
      INTEGER      JDATE      ! current model date, coded YYYYDDD
      INTEGER      JTIME      ! current model time, coded HHMMSS
      INTEGER      TSTEP      ! output time step

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'OPWDDEP'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      V, L     ! loop induction variables
      INTEGER      JSPCTAG  ! loop induction for the Tags

C-----------------------------------------------------------------------

C Try to open existing file for update

      IF ( .NOT. OPEN3( SADEPFILE, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // SADEPFILE // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open the dry dep file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = 10000 * ( JTIME / 10000 )   ! Clear MMSS fields
         TSTEP3D = TSTEP
         CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

         NVARS3D = N_SPCTAG  
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D =     1
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
!        VGTPUN3D = VGTPUN_GD ! currently, not defined
         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
!        GDNAM3D = GDNAME_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         IF ( SADEPFILE .EQ. SA_DD_1 ) THEN
           XMSG = ' RADM dry '
         ELSEIF ( SADEPFILE .EQ. SA_WD_1 ) THEN
           XMSG = ' wet '
         ENDIF

         DO JSPCTAG = 1, N_SPCTAG
           VTYPE3D( JSPCTAG ) = M3REAL
           VNAME3D( JSPCTAG ) = VNAM_SPCTAG( JSPCTAG )
           UNITS3D( JSPCTAG ) = 'kg/hectare'
           VDESC3D( JSPCTAG ) = 'hourly' // XMSG( 1:LEN_TRIM(XMSG) )
     &                  // 'deposition values'
           write(*,*) VNAM_SPCTAG( JSPCTAG ),VNAME3D(JSPCTAG), UNITS3D( JSPCTAG ),VDESC3D( JSPCTAG )
         END DO

         FDESC3D( 1 ) = 
     &      'hourly 1-layer X-point' // XMSG( 1:LEN_TRIM(XMSG) ) 
     &      // 'dep data for Tags'
         DO L = 2, MXDESC3
           FDESC3D( L ) = ' '
         END DO

C    Open dry deposition file

         IF ( .NOT. OPEN3( SADEPFILE, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// SADEPFILE // ' file'
            CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE MGEMIS
C-----------------------------------------------------------------------
C Description:

C Revision History:
C   03 Nov 15: B. Gantt and G. Sarwar: created the initial version for marine 
C      gas emissions
C   26 Sep 16: D. Wong: removed repeated SEAICE interpx statement
C   20 Feb 18: G. Sarwar: removed Br2, added DMS, and revised estimates of 
C              halocarbon and HOI/I2 emissions
C   04 Dec 18: G. Srawar: updated local time calculation
C   01 Feb 19: D. Wong: Implemented centralized I/O approach
C   15 May 19: D. Wong: Replaced MGEM with USE_MARINE_GAS_EMISSION which is set in RUNTIME_VARS.F
C   16 May 19: D. Wong: * Removed initialization of OCEAN, SZONE, CHLR, and DMSL. 
C                       * Used LON directly to save space.
C   04 Sep 20: G. Sarwar* Fixed bug for Kw

      USE RUNTIME_VARS
      USE HGRD_DEFN
      USE EMIS_VARS

      IMPLICIT NONE

      INTEGER, PARAMETER :: NMGSPC = 12

C Marine gas Emissions Rates
      REAL, ALLOCATABLE, SAVE :: VDEMIS_MG( :,:,: )   ! marine gas emission rates [moles/s]

      PUBLIC NMGSPC, VDEMIS_MG, MGEMIS_INIT, GET_MGEMIS, MG_SPC, MGSPC_MAP
      PRIVATE

      INTEGER, SAVE              :: LGC_O3            ! pointer to O3 in CGRID

C Variables for the marine gas diagnostic file
      INTEGER :: NMGDIAG                              ! number of species in marine gas
                                                      ! diagnostic emission file
      REAL,    ALLOCATABLE       :: MGOUTD( : )       ! emission rates
      REAL,    ALLOCATABLE, SAVE :: MGBF( :,:,: )     ! marine gas emiss accumulator
      REAL,    ALLOCATABLE, SAVE :: WRMG( :,: )       ! marine gas emiss write buffer
      INTEGER, SAVE              :: MGSPC_MAP( NMGSPC )

! Species names in the speciated marine gas-emissions
      CHARACTER( 16 ), ALLOCATABLE :: WRMG_SPC( : )   ! species names

      CHARACTER( 16 ) :: MG_SPC( NMGSPC)           ! emitted species

      DATA  MG_SPC  /  'MB3             ',
     &                 'MB2             ',
     &                 'MBC             ',
     &                 'MB2C            ',
     &                 'MBC2            ',
     &                 'CH3I            ',
     &                 'MIC             ',
     &                 'MIB             ',
     &                 'MI2             ',
     &                 'I2              ',
     &                 'HOI             ',
     &                 'DMS             ' /

       REAL :: MG_MW( NMGSPC )                    ! emitted species molecular weight (g/mol)

       DATA MG_MW   / 252.7,
     &                173.8,
     &                129.4,
     &                208.3,
     &                243.8,
     &                141.9,
     &                176.4,
     &                219.9,
     &                267.8,
     &                253.8,
     &                143.9,
     &                62.0     /

C Variables interpolated from the meteorological input files
      REAL,    ALLOCATABLE, SAVE :: U10( :,: )      ! wind speed at 10m [m/s]
      REAL,    ALLOCATABLE, SAVE :: TSEASFC( :,: )  ! sea surface temp K
      REAL,    ALLOCATABLE, SAVE :: SEAICE( :,: )   ! seaice fraction

      INTEGER I

C Domain decomposition info from emission and meteorology files
      INTEGER, SAVE :: GXOFF, GYOFF                 ! origin offset
      INTEGER, SAVE :: STRTCOL_O1, ENDCOL_O1, STRTROW_O1, ENDROW_O1
      INTEGER, SAVE :: STRTCOLMC3, ENDCOLMC3, STRTROWMC3, ENDROWMC3
      INTEGER, SAVE :: STRTCOLGC2, ENDCOLGC2, STRTROWGC2, ENDROWGC2

      CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      FUNCTION MGEMIS_INIT( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

C Revision History:
C   03 Nov 15: B. Gantt and G. Sarwar: created the initial version for marine gas emissions

            USE UTILIO_DEFN
            USE HGRD_DEFN
            USE CGRID_SPCS
            USE RXNS_DATA
            USE RUNTIME_VARS, ONLY : USE_MARINE_GAS_EMISSION
            USE CENTRALIZED_IO_MODULE, only : chlr, dmsl

            IMPLICIT NONE
            INCLUDE SUBST_CONST                                     ! constants
            INCLUDE SUBST_FILES_ID                                  ! file name parameters

C Arguments:
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP
            LOGICAL :: SUCCESS


            CHARACTER( 80 )       :: VARDESC                        ! env variable description

C Local Variables:

            CHARACTER( 16 ), SAVE :: PNAME = 'MGEMIS_INIT'
            CHARACTER( 96 ) :: XMSG = ' '
            CHARACTER(  16 ) :: VARNM
            INTEGER STATUS
            INTEGER S, N, L, K, V

C-----------------------------------------------------------------------

            SUCCESS = .TRUE.

C flag for marine gas emissions; this flag is set in the subroutine EM_FILE_INIT 
            IF ( .NOT. USE_MARINE_GAS_EMISSION ) RETURN

C Allocate MG arrays using NMGSPC value
            EM_FILE_SURR( IMGSRM )%LEN = NMGSPC
            ALLOCATE( EM_FILE_SURR( IMGSRM )%ARRY ( NMGSPC ) )
            ALLOCATE( EM_FILE_SURR( IMGSRM )%UNITS( NMGSPC ) )
            ALLOCATE( EM_FILE_SURR( IMGSRM )%MW   ( NMGSPC ) )
            ALLOCATE( EM_FILE_SURR( IMGSRM )%USED ( NMGSPC ) )
            ALLOCATE( EM_FILE_SURR( IMGSRM )%CONV ( NMGSPC ) )
            ALLOCATE( EM_FILE_SURR( IMGSRM )%BASIS( NMGSPC ) )
            
            EM_FILE_SURR( IMGSRM )%ARRY  = MG_SPC
            EM_FILE_SURR( IMGSRM )%UNITS = 'MOLES/S'
            EM_FILE_SURR( IMGSRM )%MW    = MG_MW
            EM_FILE_SURR( IMGSRM )%USED  = .FALSE.
            EM_FILE_SURR( IMGSRM )%CONV  = 1.0
            EM_FILE_SURR( IMGSRM )%BASIS = 'MOLE'

            ALLOCATE ( VDEMIS_MG( NMGSPC,NCOLS,NROWS), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
               XMSG = '*** VDEMIS_MG, memory allocation failed'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE ( TSEASFC( NCOLS,NROWS ),
     &                 U10( NCOLS,NROWS ),
     &                 SEAICE( NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
              XMSG = '*** DMSL, TSEASFC, U10, or SEAICE memory'
              CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
              SUCCESS = .FALSE.; RETURN
            END IF   
            U10     = 0.0
            TSEASFC = 293.15
            SEAICE  = 0.0

C Get index for surface ozone concentration 
            VARNM = 'O3'
            LGC_O3 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
            IF ( LGC_O3 .LE. 0 ) THEN
               XMSG = 'Could not find ' // VARNM // 'in species table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            IF (USE_MARINE_GAS_EMISSION .AND. MGEMDIAG ) THEN           ! Open the marine gas emission diagnostic file
C Determine number of marine gas species for diagnostic file
                NMGDIAG = NMGSPC

C Allocate diagnostic arrays
                ALLOCATE ( MGOUTD( NMGDIAG ),
     &                     WRMG_SPC( NMGDIAG ), STAT = STATUS )
                IF ( STATUS .NE. 0 ) THEN
                    XMSG = '*** MGOUTD or WRMG_SPC memory alloc failed'
                    CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                    SUCCESS = .FALSE.; RETURN
                END IF

C Build diagnostic file write buffer (WRMG_SPC) array
                NMGDIAG = 0
                DO S = 1, NMGSPC
                   NMGDIAG = NMGDIAG + 1
                   WRMG_SPC( NMGDIAG ) = MG_SPC( S )
                END DO

C Open the marine gas emission dignostic file
                IF ( IO_PE_INCLUSIVE ) CALL OPMGEMIS ( STDATE, STTIME, TSTEP, NMGDIAG, WRMG_SPC )

                ALLOCATE ( MGBF( NMGDIAG,NCOLS,NROWS ),
     &                     WRMG( NCOLS,NROWS ), STAT = STATUS )
                IF ( STATUS .NE. 0 ) THEN
                   XMSG = '*** MGBF or WRMG memory allocation failed'
                   CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                   SUCCESS = .FALSE.; RETURN
                END IF
                MGBF = 0.0

            END IF

         END FUNCTION MGEMIS_INIT

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE OPMGEMIS ( JDATE, JTIME, TSTEP, NMGDIAG, WRMG_SPC )

C 8 Aug 14 B.Gantt adapted from sea salt diagnostic

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN

         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER, INTENT( IN )         :: JDATE      ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN )         :: JTIME      ! current model time, coded HHMMSS
         INTEGER, INTENT( IN )         :: TSTEP      ! output time step
         INTEGER, INTENT( IN )         :: NMGDIAG
         CHARACTER( 16 ), INTENT( IN ) :: WRMG_SPC( NMGDIAG )

C Local variables:
         CHARACTER( 16 ) :: PNAME = 'OPMGEMIS'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER      V, L       ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update
         IF ( .NOT. OPEN3( CTM_MGEM_1, FSRDWR3, PNAME ) ) THEN
            XMSG = 'Could not open CTM_MGEM_1 for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open diagnostic file
            FTYPE3D = GRDDED3
            SDATE3D = JDATE
            STIME3D = JTIME
            TSTEP3D = TSTEP
            CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

            NVARS3D = NMGDIAG
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D = 1
            NTHIK3D = 1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD
!           VGTPUN3D = VGTPUN_GD ! currently, not defined
            DO L = 1, NLAYS3D + 1
               VGLVS3D( L ) = VGLVS_GD( L )
            END DO
!           GDNAM3D = GDNAME_GD
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            DO V = 1, NMGDIAG
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = WRMG_SPC( V )
               UNITS3D( V ) = 'mol s-1'
               VDESC3D( V ) = 'hourly ' // TRIM( VNAME3D( V ) )
     &                     // ' marine gas emission rate'
            END DO

            FDESC3D( 1 ) = 'hourly layer-1 marine gas emission rates'
            DO L = 2, MXDESC3
               FDESC3D( L ) = ' '
            END DO

C Open marine gas emissions diagnostic file
            IF ( .NOT. OPEN3( CTM_MGEM_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create the CTM_MGEM_1 file'
               CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
            END IF

         END IF

         RETURN

         END SUBROUTINE OPMGEMIS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_MGEMIS ( JDATE, JTIME, TSTEP, CGRID )

C GET_MGEMIS calculates the marine gas emission rates in a grid cell
C given the fractional grid-cell area covered by open ocean and surf zone

C Key Subroutines/Functions Called:  NONE

C Revision History:
C   03 Nov 15: B. Gantt and G. Sarwar: created the initial version from sea salt diagnostic file
C   20 Feb 18: G. Sarwar: removed Br2, added DMS, and revised estimates of halocarbon and HOI/I2 emissions
C   04 Dec 18: G. Srawar: updated local time calculation
C
CReferences:
C MacDonald, S. M., Gómez Martín, J. C., Chance, R., Warriner, S., Saiz-Lopez, A., Carpenter, L. J.,
C and Plane, J. M. C.: A laboratory characterisation of inorganic iodine emissions from the sea
C surface: dependence on oceanic variables and parameterisation for global modelling, Atmos. Chem.
C Phys., 14, 5841-5852, doi:10.5194/acp-14-5841-2014, 2014.
C
C     Sherwen, T., Evans, M. J., Carpenter, L. J., Andrews, S. J., Lidster, R. T., Dix, B., Koenig, T. K., 
C Sinreich, R., Ortega, I., Volkamer, R., Saiz-Lopez, A., Prados-Roman, C., Mahajan, A. S., and Ordóñez, C.: 
C Iodine's impact on tropospheric oxidants: a global model study in GEOS-Chem. Atmos. Chem. Phys., 2016, 16, 1161-1186.

C-----------------------------------------------------------------------
            USE UTILIO_DEFN
            USE AEROMET_DATA   ! Includes CONST.EXT
            USE ASX_DATA_MOD, ONLY: MET_DATA                 ! added by Sarwar
            USE CGRID_SPCS     ! CGRID mechanism species
            USE PCGRID_DEFN    ! get cgrid
            USE GRID_CONF
            USE CENTRALIZED_IO_MODULE

            IMPLICIT NONE

C Arguments
            INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP( 3 )
            REAL, POINTER         :: CGRID( :,:,:,: )         !  concentrations

C Includes:
            INCLUDE SUBST_FILES_ID  ! file name parameters

C Parameters:
C.. Define Marine Gas indices

            INTEGER, PARAMETER :: IMB3  = 1
            INTEGER, PARAMETER :: IMB2  = 2
            INTEGER, PARAMETER :: IMBC  = 3
            INTEGER, PARAMETER :: IMB2C = 4
            INTEGER, PARAMETER :: IMBC2 = 5
            INTEGER, PARAMETER :: ICH3I = 6
            INTEGER, PARAMETER :: IMIC  = 7
            INTEGER, PARAMETER :: IMIB  = 8
            INTEGER, PARAMETER :: IMI2  = 9
            INTEGER, PARAMETER :: II2   = 10
            INTEGER, PARAMETER :: IHOI  = 11
            INTEGER, PARAMETER :: IDMS  = 12

            REAL, PARAMETER :: SECS2HR = 1.0 / 3600.0          ! hour per seconds
            REAL, PARAMETER :: C_FACT  = 1.0E-9 /(24.0*3600.0) ! factor to convert nmole/m2/day to mole/m2/sec
            REAL, PARAMETER :: LON2TZ  = 1.0 / 15.0            ! longitude to time zone, 1/degrees
            REAL, PARAMETER :: FHRLY(0:23) =
     &                         ( / 0.032, 0.032, 0.032, 0.033, 0.034, 0.036,
     &                             0.039, 0.044, 0.051, 0.057, 0.062, 0.064,
     &                             0.062, 0.057, 0.051, 0.044, 0.039, 0.036,
     &                             0.034, 0.033, 0.032, 0.032, 0.032, 0.032 / )

C Local Variables:
!            REAL    :: OFRAC              ! fractional seawater cover
!            REAL    :: SFRAC              ! fractional surf-zone cover
            REAL    :: CHLA
            REAL    :: SSTC
            REAL    :: SST            
            REAL    :: DMS_L              ! DMS in ocean water - nM  
            REAL    :: DMS                ! DMS in atmosphere                        
            REAL    :: SICE               ! SEAICE in a gird-cell

            REAL    :: SCN
            REAL    :: K600
            REAL    :: KW
            REAL    :: KA
            REAL    :: KT
            REAL    :: GAMMA
            REAL    :: ALPHA
            REAL    :: H_DMS

            CHARACTER( 16 ), SAVE :: PNAME = 'GET_MGEMIS'
            CHARACTER( 96 )       :: XMSG = ' '
            CHARACTER( 80 ) :: MSG                      ! Message

            INTEGER         :: C, R, L, N, V, S         ! loop indices

            INTEGER         :: LOGUNIT
            INTEGER         :: NVARS, NSTEPS
            INTEGER         :: LOCHR
            INTEGER         :: OFF_SET
            INTEGER, SAVE   :: WSTEP  = 0                      ! local write counter
            INTEGER         :: MDATE, MTIME                    ! MGEM write date&time
 
            REAL            :: IWSTEP                          ! reciprocal of local write counter
            REAL            :: DX1, DX2                        ! CX x1- and x2-cell widths
            REAL            :: O3, I_AQ                        ! SST in K, SSTC in C, O3 in ppb, SWPD10 in m/s
            REAL            :: DUMMY                           ! dummy variable for calculating marine gas emission
!            REAL            :: WDSCALO                         ! WDSCALO: 10 meter wind-speed-dependent scaling factors for emissions flux functions
!            REAL            :: SSTSCALO                        ! SSTSCALO: SST-dependent scaling factor for emissions from Jaegle et al. (2011) (SST in Celsius)
            REAL            :: LOC_LON                         ! grid-cell longitude
            REAL            :: WSPD10                          ! wind speed
            REAL            :: WSPD10_M5                       ! wind speed with a minimum speed of 5 m/s (used for HOI and I2 emission calculation)
            REAL            :: MARINE_AREA                     ! marine fraction of surface and later marine surface area
            REAL            :: CURRHR                          ! current GMT hour
            REAL, SAVE      :: A                               ! horizontal area of cells, m**2
            REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0           ! 2.0 / 3.0
            REAL, PARAMETER :: ONESIXHUNDREDS = 1.0 / 600.0    ! 1.0 / 600.0

            LOGICAL, SAVE   :: FIRST_TIME = .TRUE.

C----------------------------- Begin calc ------------------------------

           IF( FIRST_TIME ) THEN
C calculate grid-cell area
             IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
                DX1 = DG2M * XCELL_GD ! in m.
                DX2 = DG2M * YCELL_GD
     &              * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 )))! in m.
             ELSE
                DX1 = XCELL_GD        ! in m.
                DX2 = YCELL_GD        ! in m.
             END IF
             A = DX1 * DX2                                      ! m2

             FIRST_TIME = .FALSE.
           END IF

           CURRHR = REAL ( TIME2SEC( JTIME ) ) / 3600.0

C Assume MET_CRO_2D file is already opened

           IF (WSPD10_AVAIL) THEN
              call interpolate_var ('WSPD10', jdate, jtime, U10)
           ELSE
              call interpolate_var ('WIND10', jdate, jtime, U10)
           END IF

           IF (TSEASFC_AVAIL) THEN
              call interpolate_var ('TSEASFC', jdate, jtime, TSEASFC)
           ELSE
              call interpolate_var ('TEMPG', jdate, jtime, TSEASFC)
           END IF

           call interpolate_var ('SEAICE', jdate, jtime, SEAICE)

          IF ( MGEMDIAG .AND. WSTEP .EQ. 0 ) MGBF = 0.0

C Initialize marine gas output buffer
          DO R = 1, NROWS
             DO C = 1, NCOLS
                MARINE_AREA = ( OCEAN( C,R ) + SZONE( C,R ) )
                IF ( MARINE_AREA .GT. 0.0 .AND. SEAICE( C, R ) .LE. 0.0) THEN
!            convert area fraction to an actual area
                     MARINE_AREA = MARINE_AREA * A

                     CHLA      = CHLR ( C,R )
                     WSPD10    = U10( C,R )
                     WSPD10_M5 = MAX (5.0, WSPD10)
                     SST       = TSEASFC (C,R)
!                    SSTC    = SST - 273.15
                     SSTC      = MIN( (SST - 273.15), 30.0)                          
                     LOC_LON   = LON (C,R)
                     O3       = 1000.0 * CGRID(C, R, 1, LGC_O3)
                     DMS_L     = DMSL( C, R )   

C.. calculate iodide in water
                     I_AQ = 1.46E6 * EXP( -9134.0 / SST)

!..    calculate parameters needed for DMS emissions 

!..    Calculate Schmidt number of DMS (Saltzman et al, JGR, 1993)
       SCN = 2674.0 - 147.12 * SSTC + 3.726 * SSTC * SSTC - 0.038 * SSTC * SSTC * SSTC

!..    Calculate water-side DMS gas-transfer velocity following Liss and Merlivat,  1986 (unit - cm/hr)
       IF ( WSPD10 .LE. 3.6 ) THEN 
          KW = 0.17 * WSPD10 / ( (SCN * ONESIXHUNDREDS)**TWOTHIRDS)
        ELSE IF ( WSPD10 .GT. 3.6 .AND. WSPD10 .LE. 13.0 ) THEN
          KW = ( 2.85 * WSPD10 - 9.65 ) / SQRT(SCN * ONESIXHUNDREDS)
        ELSE IF ( WSPD10 .GT. 13.0) THEN
          KW = ( 5.9 * WSPD10 - 49.3 ) / SQRT(SCN * ONESIXHUNDREDS)
       ENDIF
    
!..    Calculate air-side DMS gas-transfer velocity (McGills et al, JGR, 2000) (unit - cm/hr)
       KA = 659.0 * WSPD10 / SQRT(62.0/18.0)
            
!..    Calculate Henry's Law Coefficient of DMS expressed as C_air/C_water following Dacey et al, GRL, 1984  (unit - atm . L /mole)
       H_DMS = EXP ( 12.64 - 3547.0/SST )                             
       
!..    Calculate Solubility Coeffcient of DMS expressed as C_water/C_air following McGills et al, JGR, 2000 - (unit dimensionless ) 
!..    Dacey et al. calculates Henry's Law Coefficient as C_air/C_water, thus, an inverse is taken for unit consistency 
!..    and then it is converted into dimensionless unit
       ALPHA = 0.082058 * SST / H_DMS                                

!..    Calculate Atmospheric Gradient Fraction following Lan et al,  Global Biogeochemical Cycles, 2011
       GAMMA = 1.0 /( 1.0 + KA / (ALPHA * KW))  

!..    Calculate total gas transfer velocity for DMS following Lan et al,  Global Biogeochemical Cycles, 2011 
       KT = KW * (1.0 - GAMMA)

C.. calculate local hour
                     OFF_SET = NINT(LOC_LON * LON2TZ )
                     LOCHR =  INT(CURRHR + OFF_SET )

                     IF (LOCHR .LT.  0) LOCHR = LOCHR + 24
                     IF (LOCHR .GT. 23) LOCHR = LOCHR - 24

                     DUMMY = 2.50E-8 * MARINE_AREA * FHRLY(LOCHR) * CHLA * SECS2HR  

C.. Calculate MB3 emission rate in mole/s
                     VDEMIS_MG( IMB3, C, R ) = DUMMY * 2.00

C.. Calculate MB2 emission rate in mole/s
                     VDEMIS_MG( IMB2, C, R ) = DUMMY * 0.50

C.. Calculate MBC emission rate in mole/s
                     VDEMIS_MG( IMBC, C, R ) = DUMMY * 0.08

C.. Calculate MB2C emission rate in mole/s
                     VDEMIS_MG( IMB2C, C, R ) = DUMMY * 0.12

C.. Calculate MBC2 emission rate in mole/s
                     VDEMIS_MG( IMBC2, C, R ) = DUMMY * 0.10

C.. Calculate CH3I emission rate in mole/s
                     VDEMIS_MG( ICH3I, C, R ) = DUMMY * 1.60

C.. Calculate MIC emission rate in mole/s
                     VDEMIS_MG( IMIC, C, R ) = DUMMY * 1.41

C.. Calculate MIB emission rate in mole/s
                     VDEMIS_MG( IMIB, C, R ) = DUMMY * 0.42

C.. Calculate MI2 emission rate in mole/s
                     VDEMIS_MG( IMI2, C, R ) = DUMMY * 0.46

C.. Calculate I2 emission rate in mole/s (Macdonald et al., ACP, 14, 5841-5852, 2014)
                     DUMMY = O3 * (I_AQ**1.3) * (1.74E9 - 6.54E8*LOG(WSPD10_M5)) ! NMOL/M2/D
                     DUMMY = MARINE_AREA * DUMMY * C_FACT
                     VDEMIS_MG( II2, C, R ) = MAX( 0.0, DUMMY )

C.. Calculate HOI emission rate in mole/s (Macdonald et al., ACP, 14, 5841-5852, 2014)
                     DUMMY = SQRT(I_AQ)
                     DUMMY = O3
     &                     * ((4.15E5*DUMMY - 20.6)/WSPD10_M5 - 23600.0*DUMMY)  ! NMOL/M2/D
                     DUMMY = MARINE_AREA * DUMMY * C_FACT
                     VDEMIS_MG( IHOI, C, R ) = MAX( 0.0, DUMMY )

C .. Calculate DMS emission rate in mole/s
                     DUMMY = MARINE_AREA *  DMS_L * KT * 2.78E-12
                     VDEMIS_MG( IDMS, C, R ) = MAX ( 0.0, DUMMY)

                ELSE
                     DO N = 1, NMGSPC
                        VDEMIS_MG( N, C, R ) = 0.0
                     END DO
                     CYCLE
                END IF

C Update the MGBF array, for writing the diagnostic marine gas emission file
                IF ( MGEMDIAG ) THEN
                   V = 0
                   DO S = 1, NMGSPC
                      V = V + 1
                      MGOUTD( V ) = VDEMIS_MG( S,C,R )
                   END DO

                   DO S = 1, NMGDIAG
                      MGBF( S,C,R ) = MGBF( S,C,R ) + MGOUTD( S )
     &                              * REAL( TIME2SEC ( TSTEP( 2 ) ) )
                  END DO
                END IF  ! MGEMDIAG

             END DO   ! C
         END DO   ! R


C If last call this hour, write out the total MG emissions [moles/s].
C Then reset the MG emissions array and local write counter.
         IF ( MGEMDIAG ) THEN

             WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )

             IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
                IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, TSTEP( 1 ),
     &                                MDATE, MTIME ) ) THEN
                     XMSG = 'Cannot get step date and time'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                END IF
                CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )
                IWSTEP = 1.0 / REAL( WSTEP )
#ifdef parallel_io
                IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_MGEM_1, FSREAD3, PNAME ) ) THEN
                       XMSG = 'Could not open ' // TRIM(CTM_MGEM_1)
                       CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                  END IF
                END IF
#endif
                DO V = 1, NMGDIAG
                   DO R = 1, NROWS
                      DO C = 1, NCOLS
                         WRMG( C,R ) = MGBF( V,C,R ) * IWSTEP
                      END DO
                   END DO
                   IF ( .NOT. WRITE3( CTM_MGEM_1, WRMG_SPC( V ),
     &                        MDATE, MTIME, WRMG ) ) THEN
                     XMSG = 'Couldnt write ' // CTM_MGEM_1 // 'file'
                     CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                   END IF
               END DO
               WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )')
     &                      'Timestep written to', CTM_MGEM_1,
     &                      'for date and time', MDATE, MTIME
               WSTEP = 0
               MGBF = 0.0
             END IF

          END IF  ! MGDIAG

         RETURN

       END SUBROUTINE GET_MGEMIS

      END MODULE MGEMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HRNO( JDATE, JTIME, TSTEP, NOPOL )

C-----------------------------------------------------------------------
C Description:
   
C    Uses new NO algorithm NO = Normalized*Tadj*Padj*Fadj*Cadj
C    to estimate NO emissions 
C    Information needed to estimate NO emissions:
C       Julian Day          (integer)    JDATE
C       Surface Temperature (MCIP field) TA    (K)
C       Rainfall    (MCIP derived field) RAIN  (cm)
C       Soil Moisture       (MCIP field) SOILM (M**3/M**3) (PX_LSM)
C            (ratio of volume of water per volume of soil)
C       Soil Temperature    (MCIP field) SOILT (K)         (PX_LSM)
C       Soil Type           (MCIP field) ISLTYP            (PX_LSM)
C       Saturation values for soil types (constants)       (PX_LSM)
C    FOR PX Version, the Temperature adjustment factor accounts for wet and dry
C    soils and the precipitation adjustment factor accounts for saturated soils
C    FOR the non-PX version, the basic algorithm remains with a temperature
C    adjustment factor (dry soil) and no adjustment for saturated soils
 
C    The following arrays are potentially updated after a call to HRNO:
C       PTYPE     type of NO emission pulse 
C       PULSEDATE julian date for the beginning of an NO pulse 
C       PULSETIME        time for the beginning of an NO pulse
   
C    The calculation are based on the following paper:
C    J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,
C    11447-11464, 1995
 
C    The Temperature Adjustment Factor is based on section 4.2 for wet and dry
C    soils with the following modification (PX version):
C       Instead of classifying soils as either 'wet' or 'dry', the wet and dry
C       adjustment is calculated at each grid cell.  A linear interpolation between
C       the wet and dry adjustment factor is made using the relative amount of soil
C       moisture in the top layer (1cm) as the interpolating factor.  The relative
C       amount of soil moisture is determined by taking the MCIP soil moisture field
C       and dividing by the saturation value defined for each soil type in the PX
C       version of MCIP. The soil temperature is used in PX version
 
C    The Precipation Adjustment factor is based on section 4.1 with the following
C    modifications:
C       The rainrate is computed from the MCIP directly using a 24 hr daily total. 
C       The types of Pulses as described in YL95 were used to estimate the NO
C       emission rate.  
 
C    Also see the following paper for more information:
C    Proceedings of the Air and Waste Management Association/U.S. Environmental
C    Protection Agency EMission Inventory Conference, Raleigh October 26-28, 1999
C    Raleigh NC by Tom Pierce and Lucille Bender       
 
C    References:
 
C    Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.
C    J.J. Yienger and H. Levy II, Journal of Geophysical Research, vol 100,
C    11447-11464, 1995
C    T. Pierce and L. Bender, Examining the Temporal Variability of Ammonia and
C    Nitric Oxide Emissions from Agricultural Processes Proceedings of the Air and
C    Waste Management Association/U.S. Environmental Protection Agency Emission
C    Inventory Conference, Raleigh October 26-28, 1999 Raleigh NC

C Preconditions:
C     Normalized NO emissions, Surface Temperature, Soil Moisture, Soil type,
C     NO emission pulse type, soil moisture from previous time step, julian date
C     of NO emission pulse start, time of NO emission pulse start,
C     soil type, SOIL TYPES, Land use data
 
C Subroutines and Functions Called (directly or indirectly):
C     PRECIP_ADJ     computes precipitation adjustment factor
C     FERTILIZER_ADJ computes fertlizer adjustment factor
C     VEG_ADJ        computes vegetation adjustment factor
C     GROWSEASON     computes Julian day of growing season
C     PRECIPFAC      computes precip adjustment factor from rainfall in last 24 hrs
C                    and time since pulse initiation
C     PULSETYPE      determines type & duration of NO emission pulse from rainrate
      
C Revision History:
C    10/01: Prototype by GAP
C    10/03: modified transition to non growing season for jul-oct of the year
C    08/04: Converted to SMOKE code style by C Seppanen
C   Mar 07: Restructure; J.Young
C   Jan 26: J.Young - move input data reads from tmpbeis;
C                     remove ck & report if TAIR > 315;
C                     restructure growing season, col/row loops;
C                     restructure PRECIP_ADJ
C   Jan 27: D. Wong - Eliminate potential race condition with mype = 0 and
C                     barrier implementation - not needed anyway.
C    02/11: S.Roselle-Replaced I/O API include files with UTILIO_DEFN
C    05/11: D. Wong - incorporated twoway model implementation
C    05/12: J.Young - make PX_LSM the default
C    05/13: D.Wong  - replaced M3EXIT with M3WARN when CHKGRID is called in the twoway model
C    09/13: D.Wong  - made the code more robust by
C                     * allowing simulation start time at any hour rather than 0
C                     * allowing finer met data time step and maintaining an hourly
C                       rainfall bucket
C    07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C    Aug 15 D.Wong:    Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O 
C                      implementation and added code to handle parallel I/O
C    09 Jan 15 J.Young: fix bug of not calculating NOPOL for last sync step of last
C                       run output step; get saturation from LSM module; put PX_LSM
C                       as first conditional clause
C    01 Feb 19 D.Wong: Implemented centralized I/O approach
C    30 June 19 J. Pleim: Corrected Soil Types to 16 and simplified code 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: hrno.F,v 1.6 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/hrno.F,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN             ! horizontal domain specifications
      USE BIOG_EMIS, ONLY: NSEF ! beis
      USE ASX_DATA_MOD
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
      USE centralized_io_module

      IMPLICIT NONE
        
C Includes:

C Arguments:
      INTEGER, INTENT( IN )  :: JDATE         ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME         ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: TSTEP( 3 )    ! time step vector (HHMMSS)
      REAL,    INTENT( OUT ) :: NOPOL( :,: )  ! output NO emissions

C External Functions
      LOGICAL,         EXTERNAL :: CHKGRID

C Parameters:
      INTEGER, PARAMETER :: MXRHRS = 24     ! no. of rainfall hours for YL95 algorithm
      INTEGER, PARAMETER :: LSM_WATER = 14
      REAL,    PARAMETER :: CFNODRYFC = ( 1.0 / 3.0 ) * ( 1.0 / 30.0 )
        
C Saturation values for 11 soil types from pxpbl.F  (MCIP PX version)
C In LSM_MOD:WSAT
C Pleim-Xiu Land-Surface and PBL Model (PX-LSM)
C See Jacquemin B. and Noilhan J. (1990), Bound.-Layer Meteorol., 52, 93-134.

C Local Variables:

      CHARACTER( 16 ), SAVE :: MNAME   ! logical name for MET_CRO_2D
      CHARACTER( 16 ), SAVE :: SOILINP ! logical name for input NO soil data
      CHARACTER( 16 ), SAVE :: SOILOUT = 'SOILOUT' ! logical name for output NO soil data
      CHARACTER( 33 ), SAVE :: DESCSTR = 'hrly cnv. & non-cnv. rainfall for'

      CHARACTER( 16 ) :: VAR        ! variable name

      INTEGER, SAVE :: IHR       ! current simulation hour
      INTEGER          NDX       ! RAINFALL array timestep index

      REAL,    ALLOCATABLE, SAVE :: C_RAINFALL ( :,: ) ! rainfall for current hour
      REAL,    ALLOCATABLE, SAVE :: RNTOT    ( :,: )  ! RN + RC
      INTEGER, SAVE :: RHOURS    ! SOILINP(OUT) file no. of RAINFALL hour variables
      INTEGER, SAVE :: RDATE     ! date to update rainfall
      INTEGER, SAVE :: RTIME     ! time to update rainfall
      INTEGER, SAVE :: EDATE     ! end scenario date
      INTEGER, SAVE :: ETIME     ! end scenario time
      INTEGER, SAVE :: NDATE     ! test date to update rainfall
      INTEGER, SAVE :: NTIME     ! test time to update rainfall
        
      LOGICAL, SAVE :: INITIAL_DAY = .FALSE.  ! true: 1st 24 hours; no previous data
                                              ! false: previous 24 hours of rainfall
                                              ! are available for HRNO

      INTEGER          SOILCAT            ! soil category
      INTEGER, SAVE :: MSTEPS             ! run no. of steps
      INTEGER          I, J, K, R, C, L   ! counters
      LOGICAL          OK
      INTEGER          IOS                ! IO or memory allocation status
      INTEGER, SAVE :: METSTEP            ! met_cro_2d time step
      
      REAL,    SAVE :: EFAC
      REAL             CFNO               ! NO correction factor
      REAL             CFNOGRASS          ! NO correction factor for grasslands
      REAL             TAIR               ! surface temperature
      REAL             TSOI               ! soil temperature
      REAL             CFNOWET, CFNODRY, RATIO
      REAL             FAC1, FAC2, FAC3, FAC4

      LOGICAL, SAVE :: USE_SOILT = .TRUE. ! use soil temperature in PX version
                                          ! rather than estimate as in BEIS2

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: FIRSTHR  = .TRUE.
      LOGICAL, SAVE :: FIRST_WRITE = .TRUE.
      CHARACTER( 256 ) :: MESG            ! message buffer
      CHARACTER( 16 )  :: PNAME = 'HRNO'  ! procedure name

      INTEGER      GXOFF, GYOFF           ! global origin offset from file
C for INTERPX
      INTEGER       :: STRTCOLSIN, ENDCOLSIN, STRTROWSIN, ENDROWSIN  ! SOILINP

      CHARACTER( 16 ), SAVE :: VNAME_RC, VNAME_RN
      INTEGER :: SPC

      LOGICAL, EXTERNAL :: FLUSH3

#ifdef verbose_hrno
      integer mxptype, ncfno0
      real    mxrntot, mxfac1, avgfac2, mxfac3, mxfac4
      real    mxtair, mxcfno
#endif
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
!        FIRSTIME = .FALSE.

C Determine last timestamp
         EDATE = STDATE; ETIME = STTIME
         CALL NEXTIME( EDATE, ETIME, RUNLEN )   ! end date & time
         MSTEPS = TIME2SEC( RUNLEN ) / TIME2SEC( TSTEP( 1 ) )

C Open met file
         MNAME = PROMPTMFILE(
     &           'Enter name for gridded met input file',
     &           FSREAD3, 'MET_CRO_2D', PNAME )

C Get description of met file
         IF ( .NOT. DESC3( MNAME ) ) THEN
            MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF

         METSTEP = TSTEP3D

C Check that grid description matches B3GRD file
         IF ( .NOT. CHKGRID( MNAME ) ) THEN
            MESG = 'Grid in file "' // TRIM( MNAME )
     &           // '" does not match grid in file ' // TRIM( MNAME ) // '"'
#ifdef twoway
            CALL M3WARN( PNAME, 0, 0, MESG )
#else
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
#endif
         END IF

         ALLOCATE( RNTOT( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RNTOT', PNAME )

C Initial run until a full 24 hours has been recorded on the SOIL(OUT/INP) file
C for the Yienger and Levy algorithm
         WRITE( LOGDEV,'(/5X, A)' ) 'Temporal BEIS ...'
         RHOURS = MXRHRS

C If initial run, initialize some variables, otherwise get them from file
         IF ( NEW_START ) THEN

            PULSEDATE = 0   ! array
            PULSETIME = 0   ! array
            PTYPE     = 0   ! array

         END IF   ! initial run

         ALLOCATE( C_RAINFALL( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RAINFALL', PNAME )
         C_RAINFALL = 0.0 ! array

         RDATE = STDATE; RTIME = STTIME
!        IHR = 0
         EFAC = EXP( -0.103 * 30.0 )

      END IF   ! FIRSTIME

C Non-convective (RN) and convective (RC) rain is the total amount for the met
C preprocessor's (typically MCIP) output timestep (typically one hour). It doesn't
C make sense to time-interpolate these values, since rain generally does not fall
C at a constant rate for an output timestep.
      IF ( .NOT. CURRSTEP( JDATE, JTIME, STDATE, STTIME, METSTEP,
     &                     NDATE, NTIME ) ) THEN
         MESG = 'Cannot get step date and time'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT3 )
      END IF

C Store current time step rainfall totals
      IF ( NDATE .EQ. RDATE .AND. NTIME .EQ. RTIME ) THEN   ! on the METSTEP

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            IHR = MOD( RTIME / 10000 + 23, 24 )  ! previous hour bin,
                                                 ! to accommodate non-zero start hour
         END IF

C For the first hour of the simulation day, use the previous 24 hour
C data to compute precip adjustment

         NDX = 1 + MOD( IHR, MXRHRS )
         C_RAINFALL = C_RAINFALL + MET_DATA%RN + MET_DATA%RC
         WRITE( DDTTM( NDX ),'(I8,":",I6.6)' ) RDATE, RTIME

         IF ( MOD( NTIME, 10000 ) .EQ. 0 ) THEN    ! at the hourly mark
            RAINFALL( :,:,NDX ) = C_RAINFALL
            C_RAINFALL = 0.0
            IHR = IHR + 1
         END IF

!        CALL NEXTIME( RDATE, RTIME, TSTEP( 1 ) )
         CALL NEXTIME( RDATE, RTIME, METSTEP )

         RNTOT = 0.0   ! array assignment
         IF ( NEW_START ) THEN
            IF ( IHR .LT. MXRHRS ) THEN
               INITIAL_DAY = .TRUE.
            ELSE
               INITIAL_DAY = .FALSE.
            END IF
         ELSE   ! store accumulated rain in RNTOT array
            DO I = 1, MXRHRS
               RNTOT = RNTOT + RAINFALL( :,:,I )
            END DO
         END IF

#ifdef verbose_hrno
         write( logdev,* ) 'hrno - INITIAL_DAY, IHR: ', initial_day, ihr
#endif

      END IF   ! on the METSTEP

C Calculate temporal non-speciated soil NO emissions
 
      IF ( GROWSEASON( JDATE ) .EQ. 0 ) THEN   ! not growing season

#ifdef verbose_hrno
         write( logdev,* ) ' not growing season'
         mxtair = 0.0; mxcfno = 0.0; ncfno0 = 0
#endif

         DO R = 1, NROWS
            DO C = 1, NCOLS
            
               TAIR = MET_DATA%TEMP2( C,R )   ! unit in degree K

C Check min bounds for temperature and limit to 303 deg K
               IF ( TAIR .LT. 200.0 ) THEN
                  WRITE( MESG, 94010 ) 'TAIR=', TAIR,
     &                 'out of range at (C,R)=', C, R
                  CALL M3MESG( MESG )
                  Write( MESG,94010 ) 'Max TAIR: ', Maxval( MET_DATA%TEMP2 ),
     &                 'at (C,R)', Maxloc( MET_DATA%TEMP2 )
                  CALL M3MESG( MESG )
                  Write( MESG,94010 ) 'Min TAIR: ', Minval( MET_DATA%TEMP2 ),
     &                 'at (C,R)', Minloc( MET_DATA%TEMP2 )
                  CALL M3MESG( MESG )
                  CALL M3EXIT( PNAME, JDATE, JTIME, '*** ABORT', 2 )
               END IF
               TAIR = MIN( TAIR, 303.0 )

               IF ( TAIR .GT. 268.8690 ) THEN
                  CFNO = EXP( 0.04686 * TAIR - 14.30579 ) ! grass (from BEIS2)
               ELSE
                  CFNO = 0.0
#ifdef verbose_hrno
                  ncfno0 = ncfno0 + 1
#endif
               END IF

#ifdef verbose_hrno
               mxtair = max( mxtair, tair )
               mxcfno = max( mxcfno, cfno )
#endif

               NOPOL( C,R ) = CFNO * ( NGROWAGNO( C,R )  ! agriculture
     &                             +   NONAGNO( C,R ) )  ! non-agriculture

            END DO  ! columns
         END DO  ! rows

#ifdef verbose_hrno
      write( logdev,2009 ) ncfno0, mxtair, mxcfno
2009  format( ' hrno - NCFNO0, MAX TAIR,CFNO: ', i7, 2f10.5 )
#endif

      ELSE   ! growing season

#ifdef verbose_hrno
         mxptype = 0; mxrntot = 0.0
         mxfac1 = 0.0; avgfac2 = 0.0; mxfac3 = 0.0; mxfac4 = 0.0
#endif

         DO R = 1, NROWS
            DO C = 1, NCOLS
            
               TAIR = MET_DATA%TEMP2( C,R )   ! unit in degree K

C Check min bounds for temperature and limit max to 303 deg K
               IF ( TAIR .LT. 200.0 ) THEN
                  WRITE( MESG, 94010 ) 'TAIR=', TAIR,
     &                 'out of range at (C,R)=', C, R
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, 2 )
               END IF
               TAIR = MIN( TAIR, 303.0 )

C Calculate NO emissions by going thru temperature cases

               IF ( PX_LSM .OR. CLM_LSM .OR. NOAH_LSM ) THEN

                  SOILCAT = GRID_DATA%SLTYP( C,R )
                  TSOI = 0.0
                  IF( SOILCAT .NE. LSM_WATER  ) THEN
                     RATIO = MET_DATA%SOIM1( C,R ) / Grid_Data%WSAT( C,R )
                     IF ( USE_SOILT ) THEN
                        TSOI = MET_DATA%SOIT1( C,R )
                     ELSE
                        TSOI = 0.72 * TAIR + 82.28
                     END IF
                     TSOI = MIN( MAX( TSOI, 273.16 ), 303.16 ) - 273.16   ! deg C
                     CFNODRY = CFNODRYFC * TSOI ! see YL 1995 Eqn 9a p. 11452

                     IF ( TSOI .LE. 10.0 ) THEN ! see YL 1995 Eqn 7b
                        CFNOWET = 0.28 * EFAC * TSOI   ! linear cold case
                     ELSE
                        CFNOWET = EFAC * EXP( 0.103 * TSOI )   ! exponential case
                     END IF

                     CFNO = CFNODRY + RATIO * ( CFNOWET - CFNODRY )
                     FAC1 = GROWAGNO( C,R ) * CFNO
     &                    * FERTILIZER_ADJ( JDATE )
     &                    * VEG_ADJ( JDATE )

                  ELSE
                     FAC1 = 0.0
                  END IF

                  IF ( INITIAL_DAY ) THEN
                     FAC2 = 1.0
                     PTYPE( C,R ) = 0
                     PULSEDATE( C,R ) = 0
                     PULSETIME( C,R ) = 0
                  ELSE
                     FAC2 = PRECIP_ADJ_PX( JDATE, JTIME, RNTOT( C,R ),
     &                                     MET_DATA%SOIM1( C,R ),
     &                                     Grid_Data%WSAT( C,R ), PTYPE( C,R ), 
     &                                     PULSEDATE( C,R ), PULSETIME( C,R ) )
                  END IF

               ELSE

                  TSOI = 0.72 * TAIR + 82.28
                  TSOI = MIN( MAX( TSOI, 273.16 ), 303.16 ) - 273.16   ! deg C
                  CFNODRY = CFNODRYFC * TSOI ! see YL 1995 Eqn 9a p. 11452
                  IF ( TSOI .LE. 10.0 ) THEN ! see YL 1995 Eqn 7b
                     CFNOWET = 0.28 * EFAC * TSOI   ! linear cold case
                  ELSE
                     CFNOWET = EFAC * EXP( 0.103 * TSOI )   ! exponential case
                  END IF
                  CFNO = 0.5 * ( CFNOWET + CFNODRY )

                  FAC1 = GROWAGNO( C,R ) * CFNO
     &                 * FERTILIZER_ADJ( JDATE )
     &                 * VEG_ADJ( JDATE )
     
                  IF ( INITIAL_DAY ) THEN
                     FAC2 = 1.0
                     PTYPE( C,R ) = 0
                     PULSEDATE( C,R ) = 0
                     PULSETIME( C,R ) = 0
                  ELSE
                     FAC2 = PRECIP_ADJ( JDATE, JTIME, RNTOT( C,R ),
     &                                  PTYPE( C,R ), PULSEDATE( C,R ),
     &                                  PULSETIME( C,R ) )
                  END IF

               END IF  ! PX version check

               IF ( TAIR .GT. 268.8690 ) THEN  
                  CFNOGRASS = EXP( 0.04686 * TAIR - 14.30579 ) ! grass (from BEIS2)
                  FAC3 = NGROWAGNO( C,R ) * CFNOGRASS 
                  FAC4 = NONAGNO( C,R ) * CFNOGRASS
               ELSE
                  FAC3 = 0.0
                  FAC4 = 0.0
               END IF

#ifdef verbose_hrno
               mxptype = max( mxptype, ptype( c,r ) )
               mxrntot = max( mxrntot, rntot( c,r ) )
               mxfac1 = max( mxfac1, fac1 )
               avgfac2 = avgfac2 + fac2
               mxfac3 = max( mxfac3, fac3 )
               mxfac4 = max( mxfac4, fac4 )
#endif
               IF( TSOI .LE. 0.0 ) THEN
                  NOPOL( C,R ) = 0.0
               ELSE 
                  NOPOL( C,R ) = MAX( ( FAC1 * FAC2 ), FAC3 ) + FAC4
               END IF

            END DO  ! columns
         END DO  ! rows

#ifdef verbose_hrno
      write( logdev,2011 ) mxptype, mxrntot, avgfac2/(ncols*nrows), mxfac1, mxfac3, mxfac4
2011  format( ' hrno MAX PTYPE,RNTOT,AVGFAC2,FAC1,3,4: ', I2, 2f8.3 , 3f10.3 )
#endif

      END IF  ! growing season check

      IF ( SECSDIFF( JDATE,JTIME, EDATE,ETIME ) .GT. TIME2SEC( TSTEP( 2 ) ) ) RETURN

C Create rain data file for soil NO

C Final timestamp
      NDATE = EDATE; NTIME = ETIME

C Build description for, and create/open soil NO emissions output file
      FTYPE3D = GRDDED3
      SDATE3D = NDATE
      STIME3D = NTIME
      TSTEP3D = 0   ! make it a time-independent file
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = 1
      NVARS3D = 3 + RHOURS
      MXREC3D = 1
      NTHIK3D = 1
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
      DO L = 1, NLAYS3D + 1
         VGLVS3D( L ) = VGLVS_GD( L )
      END DO
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN

      VNAME3D = ' '
      VNAME3D( 1 ) = 'PTYPE'
      VNAME3D( 2 ) = 'PULSEDATE'
      VNAME3D( 3 ) = 'PULSETIME'

      DO I = 1, RHOURS
         WRITE( VAR, '(A8,I2.2)' ) 'RAINFALL', I
         VNAME3D( I+3 ) = VAR
      END DO

      UNITS3D = ' '
      UNITS3D( 1 ) = 'INTEGER'
      UNITS3D( 2 ) = 'YYYYDDD'
      UNITS3D( 3 ) = 'HHMMSS'
      UNITS3D( 4:RHOURS+3 ) = 'cm'

      VDESC3D( 1 ) = 'NO emission pulse type'
      VDESC3D( 2 ) = 'CMAQ starting date for NO emission pulse'
      VDESC3D( 3 ) = 'CMAQ starting time for NO emission pulse'
!     VDESC3D( 4:RHOURS+3 ) = 'hourly convective and non-convective rainfall'
      DO I = 1, RHOURS
         VDESC3D( I+3 ) = DESCSTR // DDTTM( I )
      END DO

      VTYPE3D = 0
      VTYPE3D( 1 ) = M3INT
      VTYPE3D( 2 ) = M3INT
      VTYPE3D( 3 ) = M3INT
      VTYPE3D( 4:RHOURS+3 ) = M3REAL

      FDESC3D = ' '
      FDESC3D( 1 ) = 'Gridded rainfall data for soil NO emissions'
      FDESC3D( 2 ) = '/From/ ' // PNAME
      FDESC3D( 3 ) = '/Version/ CMAQ'

C Open NO rain data save file
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSNEW3, PNAME ) ) THEN
            MESG = 'Could not open "' // TRIM( SOILOUT ) // '" file'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
         END IF
      END IF

#ifdef parallel_io
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. FLUSH3 ( SOILOUT ) ) THEN
            MESG = 'Could not sync to disk ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
      CALL SE_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( SOILOUT, FSREAD3, PNAME ) ) THEN
            MESG = 'Could not open ' // TRIM( SOILOUT )
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END IF
#endif

C Write soil NO rain data file

      VAR = 'PTYPE'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PTYPE ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      VAR = 'PULSEDATE'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PULSEDATE ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      VAR = 'PULSETIME'
      IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, PULSETIME ) ) THEN
         MESG = 'Could not write "' // TRIM( VAR ) //
     &          '" to file "' // TRIM( SOILOUT ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

      NDX = 1 + MOD( IHR, MXRHRS )
      RAINFALL( :,:,NDX ) = C_RAINFALL
      DO I = 1, RHOURS
         WRITE( VAR, '(A8,I2.2)' ) 'RAINFALL', I
         IF ( .NOT. WRITE3( SOILOUT, VAR, NDATE, NTIME, RAINFALL( 1,1,I ) ) ) THEN
            MESG = 'Could not write "' // TRIM( VAR ) //
     &             '" to file "' // TRIM( SOILOUT ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF
      END DO

      WRITE( LOGDEV,94040 )
     &      'Timestep written to', SOILOUT,
     &      'for date and time', NDATE, NTIME

      RETURN

94010 FORMAT( A, F10.2, 1X, A, I3, ',', I3 )
94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

C-----------------------------------------------------------------------

      CONTAINS

         REAL FUNCTION PRECIP_ADJ_PX( JDATE, JTIME, RAIN, SOILM, WSAT,
     &                                PTYPE, PULSEDATE, PULSETIME )

C-----------------------------------------------------------------------
 
C Description:
   
C    Compute precipitation adjustment factor for estimate of NO emissions 
C    Uses: julian day, time, soil moisture
C    Requires the use of three arrays that are re-used each time step:
C    PTYPE, PULSEDATE, PULSETIME 
C    These arrays store the type of NO pulse initiated by the rainfall
C    and the starting date and time of the pulse.
 
C Preconditions:
C    Soil Moisture current time, Soil Moisture previous time,
C    Soil type, Land Use, PTYPE, PULSEDATE, PULSETIME 
 
C Subroutines and Functions Called:
C    precipfact - computes precip adjustment factor from rainrate and time
C                 since pulse initiation
C    pulsetype  - determines type & duration of NO emission pulse from rainrate
 
C Revision History:
C    11/01 : Prototype by GAP
C    3/05  : create separate functions for PX vs non-PX versions
C    1/10  : J.Young - restructure
C    7/31/19 J. Pleim : Corrected Soil Types and Simplified Code
C-----------------------------------------------------------------------

         USE UTILIO_DEFN

         IMPLICIT NONE

C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME
         REAL,    INTENT( IN )    :: RAIN
         REAL,    INTENT( IN )    :: SOILM     ! only avilable if PX version
         REAL,    INTENT( IN )    :: WSAT      ! only tested for PX and CLM versions         
         INTEGER, INTENT( INOUT ) :: PTYPE     ! pulse type
         INTEGER, INTENT( INOUT ) :: PULSEDATE ! date of pulse start
         INTEGER, INTENT( INOUT ) :: PULSETIME ! date of pulse end

C External functions:
         
C Parameters:
         REAL, PARAMETER :: SAT_THRES = 0.95

C Local variables:
         INTEGER SOILCAT     ! soil type category
         INTEGER PTYPE_TEST

C-----------------------------------------------------------------------

C Summary of algorithm
C   1. compute rate of change of soil moisture from soil moisture
C   2. estimate rainrate from soil moisture and soil moisture rate
C   3. compute adjustment using pulsetype, rainrate, ptype, and date/time
C        if stronger NO pulse compared to previous time step, then
C        start a new NO emission pulse,
C        otherwise continue present NO pulse
C   4. override adjustment for saturated soils 

         SOILCAT = GRID_DATA%SLTYP( C,R )
         IF ( SOILCAT .NE. LSM_WATER  ) THEN 
            IF ( SOILM .GE. SAT_THRES * WSAT ) THEN
               PRECIP_ADJ_PX = 0.0
            ELSE
               PTYPE_TEST = PULSETYPE( RAIN )
               IF ( PTYPE_TEST .GT. PTYPE ) THEN ! Rainfall class type increases
                  PULSEDATE = JDATE              ! (NO emission pulse generated)
                  PULSETIME = JTIME
                  PTYPE = PTYPE_TEST
               END IF
               PRECIP_ADJ_PX = PRECIPFAC( JDATE, JTIME, PULSEDATE, PULSETIME, PTYPE )
            END IF
         ELSE
            PRECIP_ADJ_PX = 0.0
         END IF

         RETURN
         
         END FUNCTION PRECIP_ADJ_PX
         
C-----------------------------------------------------------------------

         REAL FUNCTION PRECIP_ADJ( JDATE, JTIME, RAIN,
     &                             PTYPE, PULSEDATE, PULSETIME )

C-----------------------------------------------------------------------
C Description:
   
C    Compute precipitation adjustment factor for estimate of NO emissions 
C    Uses: julian day, time, soil moisture
C    Requires the use of three arrays that are re-used each time step:
C    PTYPE, PULSEDATE, PULSETIME 
C    These arrays store the type of NO pulse initiated by the rainfall
C    and the starting date and time of the pulse.
 
C Preconditions:
C    Soil Moisture current time, Soil Moisture previous time,
C    Soil type, Land Use, PTYPE, PULSEDATE, PULSETIME 
 
C Subroutines and Functions Called:
C    precipfact - computes precip adjustment factor from rainrate and time
C                 since pulse initiation
C    pulsetype  - determines type & duration of NO emission pulse from rainrate
 
C Revision History:
C    11/01 : Prototype by GAP
C    3/05  : created a non-PX version of this function 
C    1/10  : J.Young - restructure
  
C-----------------------------------------------------------------------

         USE UTILIO_DEFN

         IMPLICIT NONE

C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME
         REAL,    INTENT( IN )    :: RAIN
         INTEGER, INTENT( INOUT ) :: PTYPE     ! pulse type
         INTEGER, INTENT( INOUT ) :: PULSEDATE ! date of pulse start
         INTEGER, INTENT( INOUT ) :: PULSETIME ! time of pulse start

C External functions:

C Local variable
         INTEGER PTYPE_TEST

C-----------------------------------------------------------------------

C Summary of algorithm
C    1. if no rainfall or new rainfall class less than current one, continue
C       existing NO emission pulse
C    2. if new rainfall that increases rainfall class, then create new NO
C       emission pulse using pulsetype, rainrate, ptype, and date/time -
C       if stronger NO pulse compared to previous time step, then start
C       a new NO emission pulse

         PTYPE_TEST = PULSETYPE( RAIN )
         IF ( PTYPE_TEST .GT. PTYPE ) THEN ! Rainfall class type increases
            PULSEDATE = JDATE              ! (NO emission pulse generated)
            PULSETIME = JTIME
            PTYPE = PTYPE_TEST
         END IF

         PRECIP_ADJ = PRECIPFAC( JDATE, JTIME, PULSEDATE, PULSETIME, PTYPE )

         RETURN
         
         END FUNCTION PRECIP_ADJ

C-----------------------------------------------------------------------

         REAL FUNCTION FERTILIZER_ADJ( DATE )

C Compute a fertilizer adjustment factor for the given date in yyyyddd format.
C If it is not growing season, the adjustment factor is 0; otherwise, it
C ranges from 0.0 to 1.0.

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN ) :: DATE

C Local variables:
         INTEGER  GDAY

C-----------------------------------------------------------------------

         GDAY = GROWSEASON( DATE )
         
         IF ( GDAY .EQ. 0 ) THEN
            FERTILIZER_ADJ = 0.0
         ELSE IF ( GDAY .GE. 1 .AND. GDAY .LT. 30 ) THEN  ! first month of growing season
            FERTILIZER_ADJ = 1.0
         ELSE IF ( GDAY .GE. 30 ) THEN
            FERTILIZER_ADJ = 1.0 + 30.0 / 184.0 - FLOAT( GDAY ) / 184.0
         ELSE
            WRITE( MESG,94010 ) 'Invalid date specified; date = ', DATE,
     &                          'growing season day = ', GDAY
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END IF

94010    FORMAT( A, I8, 1X, A, I3 )
         
         RETURN
         
         END FUNCTION FERTILIZER_ADJ

C-----------------------------------------------------------------------

         REAL FUNCTION VEG_ADJ( DATE )

C Compute a vegetation adjustment factor for the given date in yyyyddd format.
C The adjustment factor ranges from 0.5 to 1.0.

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN ) :: DATE

C Local variables:
         INTEGER  GDAY

C-----------------------------------------------------------------------

         GDAY = GROWSEASON( DATE )
         
         IF ( GDAY .LE. 30 ) THEN
            VEG_ADJ = 1.0
         ELSE IF ( GDAY .GT. 30 .AND. GDAY .LT. 60 ) THEN
            VEG_ADJ = 1.5 - ( FLOAT( GDAY ) / 60.0 )
         ELSE IF ( GDAY .GE. 60 ) THEN
            VEG_ADJ = 0.5
         ELSE
            WRITE( MESG,94010 ) 'Invalid date specified; date = ', DATE,
     &                          'growing season day = ', GDAY
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END IF

94010    FORMAT( A, I8, 1X, A, I3 )

         RETURN
      
         END FUNCTION VEG_ADJ
         
C-----------------------------------------------------------------------

         INTEGER FUNCTION GROWSEASON( DATE )

C Compute the day of the growing season corresponding to the given date
C in yyyyddd format.

         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN ) :: DATE   ! YYYYDDD

C External functions:

C Parameters:
         INTEGER, PARAMETER :: GSTART_MONTH  = 04     ! April
         INTEGER, PARAMETER :: GSTART_DAY    = 01
         INTEGER, PARAMETER :: GEND_MONTH    = 10     ! October
         INTEGER, PARAMETER :: GEND_DAY      = 31

C Local variables:
         INTEGER  YEAR, MONTH, DAY
         INTEGER  JDAY, GDAY
         INTEGER  GSJULIAN_START
         INTEGER  GSJULIAN_END
         
C-----------------------------------------------------------------------

         YEAR = INT( FLOAT( DATE ) / 1000.0 )
         JDAY = DATE - YEAR * 1000
         
         GSJULIAN_START = JULIAN( YEAR, GSTART_MONTH, GSTART_DAY )
         GSJULIAN_END = JULIAN( YEAR, GEND_MONTH, GEND_DAY )
         
         IF ( JDAY .GE. GSJULIAN_START .AND. JDAY .LE. GSJULIAN_END ) THEN
            GROWSEASON = JDAY - GSJULIAN_START + 1  ! growing season
         ELSE IF ( JDAY .GE. 1 .AND. JDAY .LE. 366 ) THEN
            GROWSEASON = 0                          ! before or after growing season
         ELSE
            WRITE( MESG,94010 ) 'Invalid date specified; date = ', DATE,
     &                          'jday = ', JDAY
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END IF

94010    FORMAT( A, I8, 1X, A, I3 )

         RETURN

         END FUNCTION GROWSEASON

C-----------------------------------------------------------------------

         REAL FUNCTION PRECIPFAC( JDATE, JTIME, PDATE, PTIME, PTYPE )

C Compute a precipitation adjustment factor from a previous 24 hour rainfall
C based on YL 1995
C The pulse type is an integer ranging from 0 to 3 indicating the type of
C rainfall rate:
C If rainfall < 0.1 cm in last 24 hr, "reset"
C Else if rainfall < 0.5 cm in last 24 hr, and time since last pulse is .ge. 2 days,
C    reset; else, precipfact=11.19*...
C Else if rainfall < 1.5 cm in last 24 hr, and time since last pulse is .ge. 6 days,
C    reset; else, precipfact=14.68*...
C Else if rainfall >=1.5 cm in last 24 hr, and time since last pulse is .ge. 13 days,
C    reset; else, precipfact=18.46*...

         USE UTILIO_DEFN

         IMPLICIT NONE
         
C Function arguments:
         INTEGER, INTENT( IN )    :: JDATE, JTIME, PDATE, PTIME
         INTEGER, INTENT( INOUT ) :: PTYPE
         
C External functions:

C Parameters:
         REAL, PARAMETER :: DAYPERSEC = 1.0 / ( 24.0 * 3600.0 ) ! = 0.000011574074074

C Local variables:
         REAL DAYDIFF, DAYDIF1
         
C-----------------------------------------------------------------------

         DAYDIFF = FLOAT( SECSDIFF( PDATE, PTIME, JDATE, JTIME ) ) * DAYPERSEC
         DAYDIF1 = DAYDIFF + 1.0
         
         SELECT CASE( PTYPE )
         CASE( 0 )
            PRECIPFAC = 1.0
         CASE( 1 )
            IF ( ( DAYDIFF ) .LT. 2.0 ) THEN
               PRECIPFAC = 11.19 * EXP( -0.805 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE( 2 )
            IF ( ( DAYDIFF ) .LT. 6.0 ) THEN
               PRECIPFAC = 14.68 * EXP( -0.384 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE( 3 )
            IF ( ( DAYDIFF ) .LT. 13.0 ) THEN
               PRECIPFAC = 18.46 * EXP( -0.208 * DAYDIF1 )
            ELSE
               PTYPE = 0
               PRECIPFAC = 1.0
            END IF
         CASE DEFAULT
            WRITE( MESG,'( A, I6 )' ) 'Invalid Pulse Type specified ',
     &                                 PTYPE
            CALL M3EXIT( PNAME, 0, 0, MESG, 2 )
         END SELECT
         
         RETURN
         
         END FUNCTION PRECIPFAC
    
C-----------------------------------------------------------------------

         INTEGER FUNCTION PULSETYPE( RAIN )

C Compute the pulse type from the rainfall rate (see YL 1995).

         IMPLICIT NONE
         
C Function arguments
         REAL, INTENT( IN ) :: RAIN   ! [cm/24hr]
         
C-----------------------------------------------------------------------

         IF ( RAIN .LT. 0.1 ) THEN
            PULSETYPE = 0
         ELSE IF ( RAIN .LT. 0.5 ) THEN
            PULSETYPE = 1
         ELSE IF ( RAIN .LT. 1.5 ) THEN
            PULSETYPE = 2
         ELSE
            PULSETYPE = 3
         END IF
         
         RETURN
         
         END FUNCTION PULSETYPE

C-----------------------------------------------------------------------

      END SUBROUTINE HRNO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!
!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE CONVCLD_PROP_ACM( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C
C  FUNCTION: Convective cloud processor Models-3 science process:
C       MAIN ROUTINE calculates cloud characteristics, and uses them
C       to generate cloud top, bottom, water, ice and fractions.
C
C       ICLDTYPE = 1 => computes raining cloud physics
C       ICLDTYPE = 2 => does the same for non-precip clouds utilizing saved
C                       info from RNCLD in the case of co-existing clouds
C
C  PRECONDITIONS REQUIRED:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C
C  REVISION  HISTORY:
C       Adapted 3/93 by CJC from science module template
C       Version 3/3/93 with complete LCM aqueous chem by JNY.
C       Modified 6/3-7/93 by CJC & JNY to correct treatment of half layers
C       vs. full layers in loop 255:  calculation of DTDP centered at
C       quarter-layers using PSTAR; corresponding revisions to TLCL, TSAT.
C       Uses 4th order R-K solver there.
C       Version 6/5/93 by CJC using relative rainout rates.
C       Version 7/6/93 by CJC using INTERP3()
C       Adapted from LCM aqueous chemistry, initial version, 9/93
C              by JNY and CJC
C       Completion of EM cloud mixing, JNY 12/93
C       Inclusion of EM aqueous chemistry JNY 12/93
C       UPGRADE TO FULL RADM CLOUD MODULE EMULATION, JNY 4/94
C       8/16/94 by Dongming Hwang Configuration management template
C       Adapted 10/96 by S.Roselle for Models-3
C       1/97 s.roselle added McHenry`s well mixed assumption code
C       8/97 S.Roselle revised cgrid units, pressure units, rainfall
C              to hourly amounts, built indices for wet dep species,
C              scavenged species, and aqueous species, built wrapper
C              around aqueous chemistry module
C       10/97 S.Roselle removed McHenry`s well mixed assumption code
C              and put back the below cloud concentration scaling
C       11/97 S.Roselle moved the wet deposition output to the calling
C              routine--CLDPROC
C       01/98 S.Roselle moved indexing code to AQINTER, also
C              moved scavenging to SCAVWDEP
C       03/98 S.Roselle read sub-hourly rainfall data
C       12/98 David Wong at LM:
C             -- changed division of 8000, 2, 1000 to its corresponding
C                reciprocal
C              -- added INT in the expression STEP * 0.5 when calling SEC2TIME
C       03/99 David Wong at LM:
C             -- replaced "/ FRAC * .001" by "/ ( FRAC * 1000.0 )" to minimize
C                lost of significant digits in calculation
C       Jeff - Dec 00 - move CGRID_MAP into f90 module
C       Jeff - Sep 01 - Dyn Alloc - Use HGRD_DEFN
C       4/02 S.Roselle changed minimum horizontal resolution for subgrid
C             clouds from 12km to 8km.
C       1/05 J.Young: dyn alloc - establish both horizontal & vertical
C                     domain specifications in one module
C       5/05 J.Pleim Replaced cloud mixing algorithm with ACM
C       6/05 S.Roselle added new cloud diagnostic variables
C       7/05 J.Young: clean up and mod for CMAQ-F
C       8/10 J.Young: replace chem mechanism include files with namelists
C                    and accomodate Shawn Roselle`s, Sergey Napelenok`s
C                    and Steve Howard`s aerosol reengineering
C       3/11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C       5/11/11 D.Wong: incorporated twoway model implementation
C       7/11 G. Sarwar: calculate zenith angle to determine daytime and nightime 
C                    needed for sulfur oxidation via metal catalysis
C       9/11 S.Roselle: enable CMAQ subgrid cloud model only when met. driver
C             uses a convective cloud parameterization (removed minimum
C             horizontal grid resolution restriction)
C       02Aug12 S.Roselle:  instrumented to calculate and return
C                           transmissivity for convective clouds
C       04Apr14 B.Hutzell:  Added routine call to capture cloud fractions,
C                           water, and ice mixing ratios
C       11Feb15 J.Young: Updated call to czangle.F which uses the ASX_DATA_MOD shared
C                        data module (Implemented by J.Bash on 07 Nov 14)
C       09/04/15 D.Wong: - Made variable declaration method consistent in the caller
C                          and calling routines
C                        - Used a variable rather than an array in calculation to
C                          reduce memory footprint and to increase code efficiency
C       28May15 J.Young: cleanup
C       12Jun15 B.Hutzell: Moved call to CLEAR_ACM_CLOUD to after FIRSTIME block to
C                          insure results from previous time step are removed
C       12Jan16 D.Wong: Fixed a bug that causes different result when code run with 
C                       different domain decomposition
C       4Apr16 J.Bash      Calculate the Sundqvist et al. 1989 threshold humidities 
C                          for cloud formation based on Mocko and Cotton (1995) to be
C                          More consistent with WRF
C       01Feb19 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                       clauses
C       01AUG19 D.Wong: Modified code to work with two-way model
C       11 Nov 19 F. Sidi: Changed MSTEP to accomdate Centralized I/O changes
C-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE HGRD_DEFN,     ONLY: MYPE
      USE UTILIO_DEFN
      USE PHOT_MET_DATA, ONLY: USE_ACM_CLOUD, CLEAR_ACM_CLOUD, CAPTURE_ACM_CLOUD
      USE ASX_DATA_MOD,  ONLY: INIT_MET, GRID_DATA
      USE CENTRALIZED_IO_MODULE,  ONLY: RCA_AVAIL, cio_model_sdate,
     &                                  cio_model_stime, 
     &                                  interpolate_var,
     &                                  file_tstep, f_met 

      IMPLICIT NONE

C...........INCLUDES

      INCLUDE SUBST_CONST               ! constants
      INCLUDE SUBST_FILES_ID            ! file name parameters

C...........Arguments

      INTEGER, INTENT( IN )    :: JDATE
      INTEGER, INTENT( IN )    :: JTIME
      INTEGER, INTENT( IN )    :: TSTEP( 3 )


C...........Parameters

C critical rel humidity for land (fraction)
      REAL, SAVE      :: RCRITL

C critical rel humidity for water (fraction)
      REAL, SAVE      :: RCRITW

C intermediate factor
      REAL            :: XKM

C param contlng sidewall entrainment function for raining clouds
      REAL, PARAMETER :: SIDEFAC = 0.5

C storm rainout efficiency
      REAL, PARAMETER :: STORME  = 0.3

C emp sat vapor press constant from RADM
      REAL, PARAMETER :: C303 = 19.83

C emp sat vapor press constant from RADM
      REAL, PARAMETER :: C302 = 5417.4

C g/kg
      REAL, PARAMETER :: GPKG = 1.0E+03

C 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: M2PHA = 1.0E+04

C subgrid scale temp perturb (deg K)
      REAL, PARAMETER :: PERT = 1.5

C wvp mix ratio perturb (dimensionless)
      REAL, PARAMETER :: PERQ = 1.5E-3

C rainfall threshold (mm/hr)
      REAL, PARAMETER :: RTHRESH = 0.1

C vapor press of water at 0 C (Pa)
      REAL, PARAMETER :: VP0PA = 611.2

C 1.0 / (vapor press of water @ 0 C) (1/Pa)
      REAL, PARAMETER :: VPINV = 1.0 / VP0PA

C converg. crit. for entrainment solver
      REAL, PARAMETER :: TST = 0.01

C assumed cloud lifetime for convective clouds (sec)
      REAL, PARAMETER :: TCLIFE = 3600.0

C ratio of mol wt of water vapor to mol wt of air
      REAL, PARAMETER :: MVOMA = MWWAT / MWAIR

C ratio of dry gas const to specific heat
      REAL, PARAMETER :: ROVCP = RDGAS / CPD

C ratio of latent heat of vap to specific heat
      REAL, PARAMETER :: LVOCP = LV0 / CPD

C dry adiabatic lapse rate (deg K/m)
      REAL, PARAMETER :: DALR = GRAV / CPD

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS

C parameter to control frequency of convective cloud processing
C   SYNCCLD=.TRUE.  : every synchronization timestep
C   SYNCCLD=.FALSE. : every hour on the half hour
      LOGICAL, PARAMETER :: SYNCCLD = .TRUE. ! default to sync timestep

      INTEGER       ICLDTYPE            ! 1: raining, 2: either CNP or PFW

C...........Local Variables

C-------for ACM version - jp 2/05        REAL DPB
      REAL, ALLOCATABLE, SAVE :: SIGF( : )
C-------------------------------------------

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru
      LOGICAL, SAVE :: CONVCLD = .TRUE.  ! flag for modeling convective clds

      CHARACTER( 16 ) :: PNAME = 'CONVCLD_ACM'   ! prcess name
      CHARACTER( 16 ) :: VARNM          ! variable name for IOAPI to get

      CHARACTER( 16 ), SAVE :: RC_NAME  ! RC name: old is RC and new is RCA

      INTEGER          ATIME            ! time diff from half-hour
      INTEGER          CLTOP            ! model LAY containing cloud top
      INTEGER          COL              ! column loop counter
      INTEGER          ROW              ! row loop counter
      INTEGER          CTOP             ! dummy variable for cloud top layer
      INTEGER          FINI             ! ending position
      INTEGER          I599C            ! entrainment solver iteration counter
      INTEGER          LAY              ! layer loop counter
      INTEGER          MDATE            ! process date
      INTEGER          MTIME            ! process time (half-hour)
      INTEGER, SAVE :: MSTEP            ! met file time step (hhmmss)
      INTEGER, SAVE :: SDATE            ! met file start date
      INTEGER          SPC              ! liquid species loop counter
      INTEGER          STEP             ! step loop counter
      INTEGER          STRT             ! starting position
      INTEGER, SAVE :: STIME            ! met file start time
      INTEGER          VAR              ! variable loop counter

      INTEGER          CLBASE           ! cld base layer
      INTEGER          CLTOPUSTBL       ! unstable cld top layer
      INTEGER          ISOUND           ! flag for sounding stability
      INTEGER          SRCLAY           ! cloud source level vert index

      REAL             AIRM             ! total air mass (mol/m2) in cloudy air
      REAL             AIRMB0           ! mol/m2 air below cloud
      REAL             AIRMBI           ! inverse mol/m2 air below cloud
      REAL             ALFA0            ! aitken mode number scavenging coef
      REAL             ALFA2            ! aitken mode sfc area scavenging coef
      REAL             ALFA3            ! aitken mode mass scavenging coef
      REAL             ARPRES           ! ave cloud pres in atm
      REAL             CONDIS           !
      REAL             CTHK             ! cloud thickness (m)
      REAL             CTHK1            ! aq chem calc cloud thickness
      REAL             DAMDP            ! dry adiabatic minus dew point lapse rate
      REAL             DP               ! pressure increment along moist adiabat
      REAL             DPLR             ! dew point lapse rate
      REAL             DQI              ! change in ice mix ratio due to melting caused by entrainment
      REAL             DQL              ! change in liq wat mix ratio due to evap caused by entrainment
      REAL             DTCLD            ! cloud integration timestep (s)
      REAL             DTDP             ! moist adiabatic lapse rate
      REAL             DZLCL            ! height increment to LCL above source level
      REAL             ZLCL             ! height of LCL above ground
      REAL             EMAX             ! water vapor pressure at source level
      REAL             EQTH             ! parcel equivalent potential temperature
      REAL             EQTHM            ! parcel equivalent potential temp
      REAL             FA               ! entrainment functional value at TEMPA
      REAL             FB               ! entrainment functional value at TEMPB
      REAL             FRAC             ! cloud fractional coverage
      REAL             FTST             ! functional product in Walcek bisection solver
      REAL             HTST             ! temp diff in Walcek bisection solver
      REAL, SAVE    :: METSTEP          ! reciprocal of timestep on the met file, 1/hr
      REAL             P1               ! intermediate pressure used in calculating WL
      REAL             P2               ! intermediate pressure used in calculating WL
      REAL             P3               ! intermediate pressure used in calculating WL
      REAL             PBAR             ! mean pressure in vertical increments up from LCL along moist adiabat
      REAL             PBARC            ! mean cloud pressure (Pa)
      REAL             PMAX             ! parcel pressure
      REAL             PP               ! scratch pressure variable
      REAL             PRATE            ! total rainfall (mm/hr)
      REAL             PRATE1           ! storm rainfall rate (mm/hr)
      REAL             QENT             ! wat vap mix ratio due to cld sidewall entrainmt
      REAL             QP               ! perturbed water vap mix ratio of parcel
      REAL             QXS              ! int. excess wat ov grid cell needed for rainout
      REAL             REMOVAC          ! variable storing H+ deposition
      REAL             RHOAIR           ! air density in kg/m3
      REAL             RLH              ! relative humidity
      REAL             RLHSRC           ! relative humidity at cld src level
      REAL             RTCH             ! chemical gas const times temp
      REAL             T1               ! perturbed temp to calc neutral buoyancy also used as max temp in cell comparing cloud with environment
      REAL             TBAR             ! mean temp in vertical increments up from LCL along moist adiabat
      REAL             TBARC            ! mean cloud temp (K)
      REAL             TBASE            ! iterative temp along moist adiabat
      REAL             TDMAX            ! dew point at source level
      REAL             TEMPA            ! lower limit on temp for entrainment solver
      REAL             TEMPB            ! upper limit on temp for entrainment solver
      REAL             TEMPC            ! scratch temp solved for cloudy air parcel
      REAL             TENT             ! temp accounting for cld sidewall entrainment
      REAL             THMAX            ! parcel potential temperature
      REAL             TI               ! init temp of cloud air before evap of water
      REAL             TLCL             ! temp at LCL
      REAL             TMAX             ! perturbed temp of parcel
      REAL             TP               ! perturbed temp of parcel
      REAL             TTOP             ! scr vbl used in application of Eq. 7, W&T
      REAL             TWC              ! tot wat cont in cloud (kg H2O/m3 air)
      REAL             WCBAR            ! liq water content of cloud (kg/m3)
      REAL             WL               ! Warner profile (an earlier version appears appears in Walcek and Taylor (JAS, 1986)
      REAL             WTBAR            ! total wat cont (kg/m2) int. thru cloud depth
      REAL             X1               ! intermediate vbles in lapse rate calculation X1 also reused as scratch vble in mixing
      REAL             QDIF             ! scratch vbl used in entrainment solver
      REAL             CLOD
      REAL             LWP
      REAL             STRNS            ! intermediate to set subgrid cld transmissivity
      REAL          :: DENSL( NLAYS )      ! air density (kg/m3)
      REAL          :: F    ( NLAYS )      ! cloud entrainment fraction to be solved for
      REAL          :: FSIDE( NLAYS )      ! sidewall entrainment vertical profile
      REAL          :: LWC  ( NLAYS )      ! liq wat cont of cloud in kg H2O/m3 air
      REAL, ALLOCATABLE, SAVE :: QICE ( : )      ! ice mixing ratio in cloud
      REAL, ALLOCATABLE, SAVE :: QLQD ( : )      ! actual liq. wat. mix ratio in cloud
      REAL          :: QVC  ( NLAYS )      ! saturation wat vap mix ratio at T1
      REAL          :: QWAT ( NLAYS )      ! liq wat mix rat, taken as total condensed water (ice + liq) profile (Eq.4, W&T)
      REAL          :: RHOM2( NLAYS )      ! mol/m2 air
      REAL          :: TCLD ( NLAYS )      ! temp of cloudy air parcel

      REAL             FRACMAX             ! max frac cov for NP cld
      REAL             PLCL                ! pressure at LCL
      REAL             QMAX                ! pertbd w.. mix rat of parcel
      REAL          :: RAIN( NCOLS,NROWS ) ! this timestep rainfall (mm/hr)
      REAL             BCLDWT              ! below cloud weighting function

      REAL          :: RC   ( NCOLS,NROWS )        ! hourly convective rainfall (cm)
      REAL          :: PBL  ( NCOLS,NROWS )        ! PBL height (m)
      REAL          :: DZZ  ( NCOLS,NROWS,NLAYS )  ! computed gridded vble
      REAL          :: DZZL ( NLAYS )              ! grid cell delta Z
      REAL          :: PRES ( NCOLS,NROWS,NLAYS )  ! file gridded vble
      REAL          :: PRESL( NLAYS )              ! grid cell pressure
      REAL          :: QAD  ( NLAYS )              ! moist adiab. sat. mix ratio
      REAL          :: QV   ( NCOLS,NROWS,NLAYS )  ! input gridded vble
      REAL          :: QVL  ( NLAYS )              ! grid cell sp. hum.
      REAL          :: TA   ( NCOLS,NROWS,NLAYS )  ! input gridded vble
      REAL          :: TAL  ( NLAYS )              ! grid cell temp
      REAL          :: TSAT ( NLAYS )              ! parcel temp along moist adiabat @ half levels
      REAL          :: ZH   ( NCOLS,NROWS,NLAYS )  ! mid-layer height (m)
      REAL          :: ZF   ( NCOLS,NROWS,NLAYS )  ! level/layer-face height (m)

      INTEGER         ALLOCSTAT
      INTEGER         STATUS

      CHARACTER( 120 ) :: XMSG = ' '   ! Exit status message

C...........Statement Functions

      REAL             ESAT            ! sat vap pres (Pa) as fn of T (deg K)
      REAL             QSAT            ! sat water vapor mixing ratio

      REAL             T               ! temperature dummy arg
      REAL             E               ! sat vapor pressure dummy arg
      REAL             P               ! pressure dummy arg

      ESAT( T ) = VP0PA * EXP( C303 - ( C302 / T ) )

      QSAT( E, P ) = MVOMA * ( E / ( P - E ) )

C-----------------------------------------------------------------------
C  begin body of subroutine CONVCLD_ACM

C...INITIALIZATION for the CONVCLD_ACM module:
C...  event-statistics variables.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

        CALL INIT_MET( JDATE, JTIME )

C...check the grid resolution from the MET_CRO_2D and set an appropriate
C...  flag as to whether convective clouds should be run for the given
C...  resolution

C...open MET_CRO_3D

!       IF ( .NOT. OPEN3( MET_CRO_3D, FSREAD3, PNAME ) ) THEN
!         XMSG = 'Could not open '// MET_CRO_3D // ' file'
!         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!       END IF

C...get description from the met file

!       IF ( .NOT. DESC3( MET_CRO_2D ) ) THEN
!         XMSG = 'Could not get ' // MET_CRO_2D //' file description'
!         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!       END IF

C cccccccccccccccccccc enable backward compatiblity ccccccccccccccccccccc

        IF ( RCA_AVAIL ) THEN
           RC_NAME = 'RCA'
        ELSE
           RC_NAME = 'RC'
        END IF

C...store met file time, date, and step information and compute
C...  the met timestep in hours

        SDATE = cio_model_sdate
        STIME = cio_model_stime
        MSTEP = file_tstep(f_met) 
        
        METSTEP = 3600.0 / FLOAT( TIME2SEC( MSTEP ) ) ! convert to 1/hours

C...check convective precipitation on met files to determine if WRF used
C...  a convective parameterization

        call interpolate_var (RC_NAME, sdate, stime, RC)

C...in coordination with MCIPv4.0, negative values will be loaded into the RC
C...  field if a convective parameterization was not used in the WRF simulation

        IF ( MAXVAL( RC ) .LT. 0.0 ) THEN
          CONVCLD = .FALSE.
          XMSG = 'MCIP files indicate no convective parameterization was '
     &        // 'used in the WRF simulation'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
          XMSG = 'Processing will continue without subgrid clouds'
          CALL M3MESG ( XMSG )
          RETURN
        END IF

C...allocate saved arrays

        ALLOCATE ( SIGF( 0:NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SIGF'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        DO LAY = 1, NLAYS
          SIGF( LAY ) = 1.0 - X3FACE_GD( LAY )
        END DO
        SIGF( 0 ) = 1.0

        ALLOCATE ( QLQD   ( NLAYS ), 
     &             QICE   ( NLAYS ), 
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating BMOL, CBASE0, CBASEF, CEND, POLC, REMOV,'
     &         // 'QLQD or QICE'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF


C...Calculate the Sundqvist et al. 1989 threshold humidities for cloud formation based on 
C...Mocko and Cotton (1995)
        XKM = REAL( XCELL_GD / 1000 )
        RCRITW = 0.879 + SQRT( 1.0 / ( 100.0 + XKM * XKM ) )
        RCRITL = 0.839 + SQRT( 1.0 / ( 50.0 + 0.5 * XKM ** 3 ) )

      END IF   ! Firstime

      IF ( .NOT. CONVCLD ) RETURN

C...check option for processing clouds on the synchronization timestep

      MDATE = JDATE
      MTIME = JTIME

C...set the cloud timestep (=adv timestep)

      STEP  = TIME2SEC( TSTEP( 2 ) )         ! syncronization timestep
      DTCLD = REAL( STEP )

C...set time to the midpoint of this timestep for data interpolation

      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

C...clear arrays that capture ACM cloud results

      IF ( USE_ACM_CLOUD ) CALL CLEAR_ACM_CLOUD( JDATE, JTIME )

C...ACTUAL SCIENCE PROCESS (loop on internal process time steps):
C...  Interpolate time dependent layered input variables
C...  (reading those variables for which it is necessary)

      call interpolate_var ('TA', mdate, mtime, TA)

      call interpolate_var ('QV', mdate, mtime, QV)

      call interpolate_var ('ZF', mdate, mtime, ZF)

      call interpolate_var ('ZH', mdate, mtime, ZH)

C...Get pressure (Pa)
      call interpolate_var ('PRES', mdate, mtime, PRES)

C...compute layer thicknesses (m)
      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          DZZ( COL,ROW, 1 ) = ZF( COL,ROW, 1 )
          DO LAY = 2, NLAYS
            DZZ( COL,ROW,LAY ) = ZF( COL,ROW,LAY ) - ZF( COL,ROW,LAY - 1 )
          END DO
        END DO
      END DO

C...Get PBL height (m)
      call interpolate_var ('PBL', mdate, mtime, PBL)

C...advance the MDATE and MTIME to the next time on the met file
C...  to get ready to read the precipitation amounts.
C...  Precipitation data WILL NOT BE INTERPOLATED!  Precipitation data
C...  on the input file are amounts within the metfiles timestep.

      IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, MSTEP,
     &                     MDATE, MTIME ) ) THEN
        XMSG = 'Cannot get step-starting date and time'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

      CALL NEXTIME ( MDATE, MTIME, MSTEP )  ! set mdate:mtime to the hour

C...Get convective precipitation amount (cm)

      call interpolate_var (RC_NAME, mdate, mtime, RC)

C...Convert the rainfall rate into mm/hr, then set a flag noting the
C...  presence of raining clouds if the rainfall is above the specified
C...  threshold

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          RAIN( COL,ROW ) = 10.0 * RC( COL,ROW ) * METSTEP
        END DO
      END DO
      IF ( MINVAL( RAIN ) .LT. 0.0 ) THEN
        XMSG = 'NEGATIVE RAIN...PROBABLY BAD MET DATA... in' // MET_CRO_2D
        CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
      END IF

C...Loop through all grid cells

      DO 311 ROW = 1, NROWS
        DO 301 COL = 1, NCOLS

          QLQD = 0.0
          QICE = 0.0
          FRAC = 0.0


          CLBASE     = NLAYS
          CLTOP      = CLBASE
          CLTOPUSTBL = NLAYS
          QMAX       = 0.0
          PLCL       = 0.0
          SRCLAY     = NLAYS

          DO LAY = 1, NLAYS
            QAD( LAY ) = 0.0
            PRESL( LAY ) = PRES( COL,ROW,LAY )
            TAL( LAY )   = TA( COL,ROW,LAY )
            QVL( LAY )   = QV( COL,ROW,LAY )
            DZZL( LAY )  = DZZ( COL,ROW,LAY )
            DENSL( LAY ) = PRESL( LAY ) / ( RDGAS * TAL( LAY ) )
          END DO

C...Test for raining clouds
C...If the rainfall amount is below the specified threshold, then set
C...  values for some of the parameters which will be used when the
C...  routine is called again for non-precipitating clouds...then
C...  skip to the next grid cell.

          IF ( RAIN( COL,ROW ) .GE. RTHRESH ) THEN
            ICLDTYPE = 1
            PRATE = RAIN( COL,ROW )
            FRACMAX = 0.0
          ELSE
            ICLDTYPE = 2
            FRACMAX = 0.5
          END IF

C...Determine cloud source level by determining equivalent
C...   potential temperature profile given perturbed temperature
C...   and water vapor to account for local hot spots which
C...   initiate convection.  Layer with maximum equivalent
C...   potential temperature is cloud source layer.

          SRCLAY = 1
          TMAX  = TAL( 1 ) + PERT
          QMAX  = QVL( 1 ) + PERQ
          PMAX  = PRESL( 1 )
          THMAX = TMAX * ( 1.0E+05 / PMAX ) ** ROVCP
          EQTHM = THMAX * EXP( LVOCP * QMAX / TMAX )

          DO LAY = 2, NLAYS

            PP = PRESL( LAY )

            IF ( ZH( COL,ROW,LAY ) .GT. 3000.0 ) EXIT   ! 650 mb

            TP = TAL( LAY ) + PERT
            QP = QVL( LAY ) + PERQ
            THMAX = TP * ( 1.0E+05 / PP ) ** ROVCP
            EQTH = THMAX * EXP( LVOCP * QP / TP )

            IF ( EQTH .GT. EQTHM ) THEN
              TMAX = TP
              SRCLAY = LAY
              QMAX  = QP
              PMAX = PP
              EQTHM = EQTH
            END IF

          END DO

C...Equivalent potential temp max is now known between LAY 1
C...   and 650 mb. We now proceed to compute lifting condensation
C...   level. First, compute vapor pressure at the source level.
C...   Find dewpoint using empirical relationship, avoiding
C...   supersaturation. Then compute dew point lapse rate -
C...   see Walcek and Taylor, 1986.

          EMAX  = QMAX * PMAX / ( MVOMA + QMAX )
          TDMAX = C302 / ( C303 - LOG( EMAX * VPINV ) )
          TDMAX = MIN( TDMAX, TMAX )
          DPLR  = ( GRAV * TDMAX * TDMAX ) / ( MVOMA * LV0 * TMAX )

c...Compute difference between dry adiabatic and dew point lapse
C...   rate, height increment above source level to reach LCL,
C...   then calculate value of pressure at LCL.  Save result
C...   in CONV_DEP( *,*,N_SPC_WDEP+2 ).

          DAMDP = DALR - DPLR

          IF ( DAMDP .LE. 0.0 ) THEN

            DZLCL = 0.0
            PLCL = PMAX
C...walcek formula
            TLCL = TMAX
C...walcek formula

          ELSE

            DZLCL = ( TMAX - TDMAX ) / DAMDP
C...walcek formula
            TLCL = TMAX - DALR * DZLCL
C...walcek formula
            TBAR = TMAX - 0.5 * DALR * DZLCL   !  midpt of TMAX, TLCL
            TBAR = MAX( TBAR , 150.0 )
            PLCL = PMAX * EXP( -( GRAV / RDGAS ) * DZLCL / TBAR )
            ZLCL = DZLCL + ZH( COL,ROW, SRCLAY )

          END IF

C...Determine cloud base at LAY in  which LCL resides,
C...  but not below layer 2.

C...plcl above middle of top layer

          IF ( PRESL( NLAYS ) .GE. PLCL ) THEN
            PLCL = PRESL( NLAYS )
            CLBASE = NLAYS
            CLTOP = CLBASE
            WRITE( LOGDEV,* ) ' WARNING: PLCL above top: Continuing'

C...search loop to find CLBASE

          ELSE

            DO LAY = 2, NLAYS
              IF ( PRESL( LAY ) .LE. PLCL ) THEN
                CLBASE = LAY
                GO TO 245
              END IF
            END DO

            CLBASE = NLAYS   ! if you get here base never found

245         CONTINUE

          END IF      ! if plcl < ptop or , or ...

C...CLBASE is LAY of LCL. Now, determine cloud top by following
C...   moist adiabat up from CLBASE. Assume a stable sounding
C...   (ISOUND=0) at first.  Moist adiabat solver calculates
C...   saturation temperatures TF at the full levels and TSAT( COL,ROW,LAY )
C...   at the half-levels, using a 2nd order Runge method employing
C...   temperatures and pressures at the quarter-levels.

          ISOUND = 0
          DO 255 LAY = CLBASE, NLAYS

C...walcek formulas

            DP   = PRESL( LAY - 1 ) - PRESL( LAY )
            PBAR = PRESL( LAY - 1 ) - DP * 0.5
            IF ( LAY .EQ. CLBASE ) THEN
              DP    = PLCL - PRESL( LAY )
              PBAR  = PLCL - DP * 0.5
              TBASE = TLCL
            END IF

            TBAR = MAX( TBASE - 0.00065 * DP, 150.0 )
            X1 = LV0 * QSAT( ESAT( TBAR ), PBAR ) / ( RDGAS * TBAR ) ! Walcek's
            DTDP = ( ( RDGAS * TBAR ) / ( PBAR * CPD ) )             ! original
     &           * ( ( 1.0 + X1 )                                    ! formulas
     &           / ( 1.0 + ( 0.622 * LVOCP / TBAR ) * X1 ) )
            TSAT( LAY ) = MAX( TBASE - DP * DTDP, 150.0 )
            QAD ( LAY ) = QSAT( ESAT( TSAT( LAY ) ), PRESL( LAY ) )
            TBASE = TSAT( LAY )

C...end Walcek formulas

C...QAD is the moist adiabatic saturation mixing ratio, needed
C...  for the entrainment solver
C...  Now make choice on stability of sounding, comparing parcel
C...  temperature TSAT with environmental temperature TA.
C...  ISOUND is index for sounding stability. If ISOUND=0,
C...  moist adiabat never warmer than environment (stable).
C...  ISOUND=1, moist adiabat becomes warmer than environment
C...  (unstable).

            IF ( ISOUND .EQ. 0 ) THEN
              IF ( TSAT( LAY ) .GT. TAL( LAY ) ) ISOUND = 1
            ELSE           ! cloud top determined by neutral bouyancy
              T1 = TSAT( LAY ) ! - 0.5 * PERT
              IF ( T1 .LT. TAL( LAY ) ) THEN
                CLTOP = LAY - 1
                GO TO 256
              END IF
            END IF

255       CONTINUE            !  end loop following moist adiabat

          CLTOP = NLAYS - 1   !  if you get here:  cloud stable or no top

256       CONTINUE

C...At this point, if ISOUND has not been set to 1, we have a
C...  "stable" cloud. In this case, we find cloud top by relative
C...   humidity criterion, or, not let cloud top go above 600mb.

          IF ( ISOUND .EQ. 0 ) THEN
            IF ( ICLDTYPE .NE. 1 ) GO TO 299

            DO 265 LAY = CLBASE + 1, NLAYS
              IF ( PRESL( LAY ) .LE. 60000.0 ) THEN
                CLTOP = LAY - 1
                GO TO 267        ! loop exit
              END IF
              RLH = QVL( LAY ) / QSAT( ESAT( TAL( LAY ) ), PRESL( LAY ) )
              IF ( RLH .LT. 0.65 ) THEN
                CLTOP = LAY - 1
                GO TO 267        ! loop exit
              END IF
265         CONTINUE

            CLTOP = NLAYS - 1   ! if you get here:  top never found

          ELSE

            CLTOPUSTBL = CLTOP  ! store unstable cloud top

          END IF

267       CONTINUE   ! loop exit target

          IF ( ICLDTYPE .NE. 1 ) THEN   !  get cloud top for either CNP or PFW

            IF ( ZLCL .GT. PBL( COL,ROW ) ) GO TO 299

C...compute relative humidity at the cloud source level

            RLHSRC = MIN( 1.0, QVL( SRCLAY )
     &                        / QSAT( ESAT( TAL( SRCLAY ) ), PRESL( SRCLAY ) ) )

C...If all tests pass, then a CNP or PFW cloud exists
C...  Proceed to find CLTOP for CNP or PFW; don`t allow
C...  cloud top to exceed 500mb, or, when RH falls below
C...  65%, cloud top found

C...Distiguish between CNP and PFW by whether rain is falling
C...  in the cell; if PFW, limit depth and find new CLTOP,
C...  else leave CLTOP alone

            IF ( CLTOP .EQ. CLBASE ) THEN
              GO TO 322
            ELSE                   ! confine PFW to 1500 meters
              CTOP = CLTOP

              DO LAY = CTOP, CLBASE, -1
                IF ( ZH( COL,ROW,LAY ) - ZH( COL,ROW,CLBASE ) .LE. 3000.0 ) THEN
                  CLTOP = LAY
                  GO TO 322   ! exit loop
                END IF
              END DO

            END IF

322         CONTINUE     ! loop exit for PFW cloud

C...If unstable CNP or PFW, limit CLTOP to CLTOPUSTBL so that
C...  QAD profile is known through cloud depth for entrainment
C...  solver

            IF ( ISOUND .EQ. 1 ) CLTOP = MIN( CLTOP, CLTOPUSTBL )

C...Now compute fractional coverage for either CNP or PFW:
C...Now based on Sunqdvist et al. 1989 DOI: 10.1175/1520-0493(1989)117<1641:CACPSW>2.0.CO;2 
            FRAC = 0.0
            IF ( GRID_DATA%LWMASK( COL,ROW ) .EQ. 1.0 ) THEN   ! land
               IF ( RLHSRC .GE. RCRITL )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITL ) )
            ELSE   ! water
               IF ( RLHSRC .GE. RCRITW )
     &            FRAC = 1.0 - SQRT( ( 1.0 - RLHSRC ) / ( 1.0 - RCRITW ) )
            END IF
            FRAC = MAX( 0.0, MIN( FRAC, 0.95 ) )

            IF ( FRAC .LT. 0.01 ) GO TO 299


          END IF  ! end of existence, depth and frac cov calc for
                  ! either PFW or CNP clouds

C...Now cloud existence is established, initialize various
C...  variables needed for rest of computations

C...First, get mol air/m2 at each layer, initialize FSIDE

          DO LAY = 1, NLAYS
            RHOM2( LAY ) = PRESL( LAY ) * DZZL( LAY )
     &                   * 1.0E3 / ( RDGAS * MWAIR * TAL( LAY ) )
            FSIDE( LAY ) = 0.0
          END DO

C...Initialize variables needed for entrainment and in-cloud properties solver

          QXS =   0.0  ! integrated excess water over grid cell nec. for rnout
          AIRM =  0.0  ! total air mass (mol/m2) in cloudy layers
          PBARC = 0.0  ! in-cloud average pressure
          CTHK  = 0.0  ! cloud thickness (m)
          WCBAR = 0.0  ! condensed wat cont (kg/m2) integ. thru cloud depth
          WTBAR = 0.0  ! total wat cont (kg/m2) integrated thru cloud depth
          TBARC = 0.0  ! cloud mean temp (K)

C...Determine condensed water content and entrainment at each cloud level
C...  Determine FSIDE profile for raining clouds; side entrainment
C...  only for PFW and CNP clouds

          IF ( ICLDTYPE .EQ. 1 ) THEN   ! raining cloud

            IF ( CLBASE .EQ. CLTOP ) THEN
              FSIDE( CLBASE ) = 1.0
            ELSE

              DO LAY = CLBASE, CLTOP
                FSIDE( LAY ) = 1.0
              END DO

            END IF

          ELSE                    ! CNP or PFW

            DO LAY = CLBASE, CLTOP
              FSIDE( LAY ) = 1.0
            END DO

          END IF

C...Use Warner profile to close system of conservation and
C...  thermodynamic equations solved iteratively, using Secant solver

          DO LAY = CLBASE, CLTOP
            WL = 0.7 * EXP( ( PRESL( LAY ) - PLCL ) * 0.000125 ) + 0.2

            IF ( LAY .EQ. CLBASE ) THEN
              P1 = 0.5 * ( PRESL( LAY ) + PRESL( LAY - 1 ) )

              IF ( PLCL .LT. P1 ) THEN
                P2 = 0.5 * ( PRESL( LAY + 1 ) + PRESL( LAY ) )
                P3 = ( P2 + PLCL ) * 0.5
                WL = 0.7 * EXP( ( P3 - PLCL ) * 0.000125 ) + 0.2
              END IF

            END IF

c...original Walcek bisection solver

            QWAT( LAY ) = WL * ( QMAX - QAD( LAY ) )
            QWAT( LAY ) = MAX( QWAT( LAY ), 1.0E-20 )

            TEMPA = TSAT( LAY ) - 20.0
            TEMPB = TSAT( LAY ) + 10.0

            QENT = FSIDE( LAY ) * QVL( LAY )
     &           + ( 1.0 - FSIDE( LAY ) ) * QVL( CLTOP )
            QDIF = QENT - QMAX
            IF ( QDIF .EQ. 0.0 ) QDIF = 1.0E-10
            F( LAY ) = ( QSAT( ESAT( TEMPA ), PRESL( LAY ) )
     &               + QWAT( LAY ) - QMAX ) / QDIF
            F( LAY ) = MIN( F( LAY ), 1.0 )
            F( LAY ) = MAX( F( LAY ), 0.0 )

            TTOP = TAL( CLTOP ) * ( PRESL( LAY ) / PRESL( CLTOP ) ) ** ROVCP
            TENT = TTOP * ( 1.0 - FSIDE( LAY ) ) + TAL( LAY ) * FSIDE( LAY )

            TI = TSAT( LAY ) * ( 1.0 - F( LAY ) ) + TENT * F( LAY )
            DQL = ( QMAX - QAD( LAY ) ) * ( 1.0 - F( LAY ) - WL )
            DQI = 0.0

            IF ( TEMPA .LT. 273.15 ) THEN
              DQI = -QWAT( LAY ) * ( TEMPA - 273.15 ) / 18.0
              IF ( TEMPA .LE. 255.15 ) DQI = QWAT( LAY )
            END IF

            FA = CPD * ( TEMPA - TI ) + LV0 * DQL + LF0 * DQI

C...test for convergence, then cut the interval in half

            I599C = 0

599         CONTINUE

            HTST = TEMPB - TEMPA
            IF ( HTST .LT. TST ) GO TO 595   ! convergence
            I599C = I599C + 1

            IF ( I599C .GT. 1000 ) THEN
              WRITE( XMSG, 91010 )
     &             'NO CONVERGENCE IN ENTRAINMENT SOLVER AT COL= ',
     &             COL, ' ROW= ',  ROW, ' ICLDTYPE= ', ICLDTYPE
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            TEMPC = ( TEMPA + TEMPB ) * 0.5
            QENT = FSIDE( LAY ) * QVL( LAY )
     &           + ( 1.0 - FSIDE( LAY ) ) * QVL( CLTOP )
            QDIF = QENT - QMAX
            IF ( QDIF .EQ. 0.0 ) QDIF = 1.0E-10
            F( LAY ) = ( QSAT( ESAT( TEMPC ), PRESL( LAY ) )
     &               + QWAT( LAY ) - QMAX ) / QDIF
            F( LAY ) = MIN( F( LAY ), 0.99 )
            F( LAY ) = MAX( F( LAY ), 0.01 )
            TTOP = TAL( CLTOP ) * ( PRESL( LAY ) / PRESL( CLTOP ) ) ** ROVCP
            TENT = TTOP * ( 1.0 - FSIDE( LAY ) ) + TAL( LAY ) * FSIDE( LAY )
            TI = TSAT( LAY ) * ( 1.0 - F( LAY ) ) + TENT * F( LAY )
            DQL = ( QMAX - QAD( LAY ) ) * ( 1.0 - F( LAY ) - WL )
            DQI = 0.0

            IF ( TEMPC .LT. 273.15 ) THEN
              DQI = -QWAT( LAY ) * ( TEMPC - 273.15 ) / 18.0
              IF ( TEMPC .LE. 255.15 ) DQI = QWAT( LAY )
            END IF

            FB = CPD * ( TEMPC - TI ) + LV0 * DQL + LF0 * DQI

            FTST = FA * FB

C...if fa*fb < 0 then zero lies between ta & tc
C...if fa*fb > 0 then zero lies between tc & tb

            IF ( FTST .LE. 0.0 ) THEN
              TEMPB = TEMPC
            ELSE
              TEMPA = TEMPC
            END IF
            GO TO 599

595         CONTINUE   ! exit from iterator, convergence achieved

C...we have obtained parcel temp TEMPC at layer LAY
C...and entrainment fraction F(LAY)

C...end of Walcek bisection solver

            TCLD( LAY ) = MAX( TEMPC, 150.0 )

C...ice load in cloud is a function of temperature below freezing

            IF ( TCLD( LAY ) .LT. 273.15 ) THEN
              QICE( LAY ) = -QWAT( LAY ) * ( TCLD( LAY ) - 273.15 ) / 18.0
              IF ( TCLD( LAY ) .LE. 255.15 ) QICE( LAY ) = QWAT( LAY )
            END IF

C...After determining the ice fraction, compute the actual
C...  liquid water mixing ratio:

            QLQD( LAY ) = QWAT( LAY ) - QICE( LAY )

C...compute the Liquid Water Content (LWC) by taking the
C...  product of the liquid wat mix ratio and the air density
C...  LWC in kg H2O per m**3 air:

            RHOAIR = PRESL( LAY ) / ( RDGAS * TCLD( LAY ) )
            LWC( LAY ) = QLQD( LAY ) * RHOAIR
            LWC( LAY ) = MAX( 5.0E-6, LWC( LAY ) )  ! lower limit
            TWC = QWAT( LAY ) * RHOAIR         ! total water content

C...Now perform vertical integration, weighting by liquid water
C...  content so that averaged quantities (used in Aqueous
C...  Chemistry) get the greatest weight where the liquid
C...  water content is greatest.

C...weighted cloud temp
            TBARC = TBARC + TCLD( LAY ) * DZZL( LAY ) * LWC( LAY )

C...weighted cloud pres
            PBARC = PBARC + PRESL( LAY ) * DZZL( LAY ) * LWC( LAY )

C...integrated liquid water content (kg/m3)
            WCBAR = WCBAR + DZZL( LAY ) * LWC( LAY )

C...integrated total water content
            WTBAR = WTBAR + DZZL( LAY ) * TWC
            CTHK = CTHK + DZZL( LAY )   ! Cloud thickness

C...Now compute integrated excess water over grid cell
C...  average necessary for rainout, through cloud depth.
C...  First, get max temp in the cell (either in cloud or env.)

            T1 = MAX( TCLD( LAY ), TAL( LAY ) )

C...get saturation water vapor mixing ratio at that temp:

            QVC( LAY ) = QSAT( ESAT( T1 ), PRESL( LAY ) )

C...excess water is the sum of total condensed and saturated
C...  vapor minus grid cell average mixing ratio: QXS in kg/m2:
C...  integrated through cloud depth

            QXS = QXS
     &          + ( QWAT( LAY ) + QVC( LAY ) - QVL( LAY ) )
     &          * RHOAIR * DZZL( LAY )

C...get total air mass in cloudy layers:

            AIRM = AIRM + RHOM2( LAY )

          END DO

C...Now begin to split calculations for non-raining and raining
C...  clouds depending on inner loop index ICLDTYPE (1 = raining,
C...  2 = nonraining: either CNP of PFW:)

          IF ( ICLDTYPE .EQ. 2 ) THEN   ! no precip or excess water
            PRATE1 = 1.0E-30
            PRATE  = 1.0E-30
            QXS    = 1.0E-30
            GO TO 7000       ! branch for further CNP or PFW calculations
          END IF

C...continue here for raining cloud...

C...get PRATE1, storm rainout rate in mm/hour, noting that 1 kg
C...  of water occupies a 1 mm thick layer of water in a square meter
C...  of ground (accounts for density of water = 1000 kg/m3)

          PRATE1 = STORME * QXS * 3600.0 / TCLIFE
          IF ( PRATE1 .LE. 1.001 * PRATE ) THEN
            FRAC = 0.999                ! Changed back to .999 - jp 6/05
            PRATE1 = PRATE / FRAC
          ELSE
            FRAC = PRATE / PRATE1
          END IF
          IF ( FRAC .LT. 0.01 ) GO TO 299

C...for raining cloud, compute water properties of interest
C...  below cloud base. First, parameterize total water content

          TWC = ( 0.067 * PRATE ** ( 0.846 ) ) / ( FRAC * 1000.0 ) ! tot wat cont kg/m3

          DO LAY = 1, CLBASE - 1
            TCLD( LAY ) = TAL( LAY )
            RHOAIR = PRESL( LAY ) / ( RDGAS * TCLD( LAY ) )
            QWAT( LAY ) = TWC / RHOAIR    ! kg H2O / kg air

C...again partition into ice and liquid

            IF ( TCLD( LAY ) .LT. 273.15 ) THEN
              QICE( LAY) = -QWAT( LAY ) * ( TCLD( LAY ) - 273.15 ) / 18.0
              IF ( TCLD( LAY ) .LE. 255.15 ) QICE( LAY ) = QWAT( LAY )
            END IF

            QLQD( LAY ) = QWAT( LAY ) - QICE( LAY )
            LWC ( LAY ) = QLQD( LAY ) * RHOAIR
            LWC ( LAY ) = MAX( 5.0E-06, LWC( LAY ) )         ! lower limit
            PBARC = PBARC + PRESL( LAY ) * DZZL( LAY ) * LWC( LAY )
            TBARC = TBARC + TCLD( LAY ) * DZZL( LAY ) * LWC( LAY )
            WCBAR = WCBAR + DZZL( LAY ) * LWC( LAY )
            WTBAR = WTBAR + DZZL( LAY ) * TWC
            CTHK = CTHK + DZZL( LAY )

C...excess water is all rain

            QXS = QXS + QWAT( LAY ) * RHOAIR * DZZL( LAY )
            
          END DO

C...Final calc of storm rainfall rate and frac area (raining clds)

          PRATE1 = STORME * QXS * 3600.0 / TCLIFE

          IF ( PRATE1 .LE. 1.001 * PRATE ) THEN
            FRAC = 0.999        ! Changed back to .999 - jp 6/05
            PRATE1 = PRATE / FRAC
          ELSE
            FRAC = PRATE / PRATE1
          END IF
          IF ( FRAC .LT. 0.01 ) GO TO 299
          
7000      CONTINUE                        ! target of cloudtype split

C...Capture cloud information for both cloud types

          IF ( USE_ACM_CLOUD ) THEN
!            WRITE(6,'(A,7(I8,1X),3(ES12.4,1X))')
!     &      'MYPE, JDATE, JTIME, COL, ROW, SUBGRID CLD CLBASE, CLTOP,FRAC, SUM(QLQD), SUM(QICE) = ',
!     &       MYPE, JDATE, JTIME, COL, ROW, CLBASE, CLTOP,FRAC, SUM(QLQD), SUM(QICE)
            CALL CAPTURE_ACM_CLOUD( JDATE, JTIME, COL, ROW, CLBASE, CLTOP,
     &                              FRAC, QLQD, QICE )
          END IF

299     CONTINUE

301     CONTINUE        !  end loop on columns COL
311   CONTINUE        !  end loop on rows    ROW

      RETURN          !  from main routine CLDPROC

91010 FORMAT( 3( A, :, I3, : ) )
      END SUBROUTINE CONVCLD_PROP_ACM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPPMDIAG ( JDATE, JTIME, TSTEP )

C Revision history
C   ??? Frank Binkowski
C   8 Sep 01 J.Young: dyn alloc - Use HGRD_DEFN
C   03 Sep 01 David Wong: for new pario
C   13 May 04 P.Bhave: added RH to species list; removed M0 and dry M2
C                      conc's from species list
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   18 Jul 05 P.Bhave: Added mass fractions of each mode < 2.5um to output list
C   06 Apr 06 P.Bhave: Added GAMMA_N2O5 to output list
C   25 May 06 P.Bhave: Changed units of all DG variables from m to um, as 
C                      suggested by Dr. Bill Hutzell
C   11 Apr 08 J.Kelly: Added STDEVCOR and variables to account for dry & wet
C                      DGCOR, M2COR_WET, and M3COR_DRY
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   26 Sep 14 H. Pye: Added GAMMA_IEPOX and replaced blank units with na
C   11 May 16 D. Wong: - Modified the code to retreive PMDIAG information from
C                        construct PMDIAG_SPC_RECORD stored in module cgrid_spcs
C                        to provide flexibility to handle AE6 and AE61
C                      - renamed the procedure name from OPDIAM to OPPMDIAG

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE RXNS_DATA, ONLY : MECHNAME
      USE PMDIAG_DATA_MODULE

        IMPLICIT NONE
 
        INCLUDE SUBST_FILES_ID  ! file name parameters

C...Arguments:

        INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
        INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
        INTEGER, INTENT( IN ) :: TSTEP      ! output time step

C...Local variables:

        CHARACTER( 16 ), SAVE :: PNAME = 'OPPMDIAG'
        CHARACTER( 96 ) :: XMSG = ' '

        INTEGER :: L          ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_PMDIAG_1, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_PMDIAG_1 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open the aerosol
C diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP
         CALL NEXTIME ( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

         NVARS3D = NUM_PMDIAG_SPC 
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D = NLAYS
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
!        VGTPUN3D = VGTPUN_GD ! currently, not defined

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
            END DO

!        GDNAM3D = GDNAME_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         DO L = 1, NUM_PMDIAG_SPC
            VTYPE3D(L) = PMDIAG_SPC_RECORD(L)%VAR_TYPE
            VNAME3D(L) = PMDIAG_SPC_RECORD(L)%SPC_NAME
            UNITS3D(L) = PMDIAG_SPC_RECORD(L)%SPC_UNIT
            VDESC3D(L) = PMDIAG_SPC_RECORD(L)%SPC_DESC
         END DO

         FDESC3D( 1 ) = 'aerosol distribution and chemistry parameters'
         DO L = 2, MXDESC3
            FDESC3D( L ) = ' '
            END DO

C Open the aerosol diagnostic file

         IF ( .NOT. OPEN3( CTM_PMDIAG_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_PMDIAG_1 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
            END IF

         END IF

      END SUBROUTINE OPPMDIAG

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/par/mpi/mpcomm_init.F,v 1.4 2011/10/21 16:11:25 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MPCOMM_INIT( NPROCS, MYPE, CLOCK, IERR )
C.......................................................................
C
C Purpose:   Initialization for parallel execution of CMAQ
 
C Revision History: 
C      Original version  5/09 Jeff Young - modified from par_init
C      Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with UTILIO_DEFN
C      Modified 08/10/2011 by David Wong
C          -- Called MPI_INIT if it is a regular CMAQ run
C      Modified 08/2011 by David Wong
C          -- Replaced SUBST_MPI with mpif.h
 
C Argument List Description:
C  In:
C     INTEGER NLAYS             ! Number of layers in entire grid
C     INTEGER NSPCS             ! Number of species in CGRID
 
C  Out:
C     REAL    CLOCK             ! Wall-clock time (sec) at MPI initialization
C     INTEGER IERR              ! Error code: 0 for ok, 1 for fail
 
C Local Variable Description:
 
C  Other Local Variable Descriptions:  see below

C Calls: M3WARN, MPI_INIT, MPI_COMM_RANK, MPI_COMM_SIZE, MPI_WTIME
 
C........................................................................

      USE UTILIO_DEFN

      IMPLICIT  NONE

C Include Files

!     INCLUDE SUBST_MPI         ! MPI definitions and parameters
      include 'mpif.h'

C Arguments

      INTEGER, INTENT( OUT ) :: NPROCS  ! number of parallel processors
      INTEGER, INTENT( OUT ) :: MYPE    ! this parallel processor
      REAL(8), INTENT( OUT ) :: CLOCK   ! Wall-clock time (sec) at MPI initialization
      INTEGER, INTENT( OUT ) :: IERR    ! error code

C Local Variables 

      INTEGER FLAG

      CHARACTER( 80 ) :: XMSG     ! Message issued from M3WARN routine
      CHARACTER( 16 ) :: PNAME = 'MPCOMM_INIT'

C------------------------------------------------------------------------

      IERR = 0

C Start up MPI
#ifndef twoway
      CALL MPI_INIT( FLAG )
      IF ( FLAG .NE. 0 ) THEN
         WRITE( XMSG,'(I6, A)' ) FLAG, 'Error in MPI_INIT.'
         CALL M3WARN ( PNAME, 0, 0, XMSG )
         IERR = 1; RETURN
      END IF
#endif

C Get wall-clock time
      CLOCK = MPI_WTIME()

C Get number of processors
      CALL MPI_COMM_SIZE( MPI_COMM_WORLD, NPROCS, FLAG )
      IF ( FLAG .NE. 0 ) THEN
         WRITE( XMSG,'(I6, A)' ) FLAG, 'Error in MPI_COMM_SIZE.'
         CALL M3WARN ( PNAME, 0, 0, XMSG )
         IERR = 1; RETURN
      END IF

C Get my processor rank (i.e., get ID of this processor)
      CALL MPI_COMM_RANK( MPI_COMM_WORLD, MYPE, FLAG )
      IF ( FLAG .NE. 0 ) THEN
         WRITE( XMSG,'(I6, A)' ) FLAG, 'Error in MPI_COMM_RANK.'
         CALL M3WARN ( PNAME, 0, 0, XMSG )
         IERR = 1; RETURN
      END IF

#ifdef cluster
C Distribute run time environment variables to other machines - by bo wang
      CALL distr_env ( MYPE, NPROCS )
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      module get_env_module

! Function: get environment variables

! Revision History:
!        2010 D.Wong: initial implementation
!  2 Feb 2010 D.Wong: provided an optional outputing device option,
!                     absorbed get_envlist function

        implicit none

        integer, parameter :: max_str_len = 10000

        character (max_str_len) :: loc_str

        interface get_env
          module procedure get_env_int,      &
                           get_env_float,    &
                           get_env_double,   &
                           get_env_char,     &
                           get_env_logical,  &
                           get_envlist
        end interface

        contains

! --------------------------------------------------------------------------------
        subroutine get_env_int (env_value, env_var, default_env_value, logdev)

          integer, intent(out)      :: env_value
          character (*), intent(in) :: env_var
          integer, intent(in)       :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             read (loc_str, *) env_value
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(A16,2x,A,2x,i10, 1x, a9)' ), env_var,'|', env_value, '(default)'
             else if (regular) then
                write( loc_logdev, '(A16,2x,A,2x,i10)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_int

! --------------------------------------------------------------------------------
        subroutine get_env_float (env_value, env_var, default_env_value, logdev)

          real, intent(out)         :: env_value
          character (*), intent(in) :: env_var
          real, intent(in)          :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             read (loc_str, *) env_value
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(A16,2x,A,2x,e10.3, 1x, a9)' ), env_var,'|', env_value, '(default)'
             else if (regular) then
                write( loc_logdev, '(A16,2x,A,2x,e10.3)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_float

! --------------------------------------------------------------------------------
        subroutine get_env_double (env_value, env_var, default_env_value, logdev)

          real (8), intent(out)     :: env_value
          character (*), intent(in) :: env_var
          real, intent(in)          :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             read (loc_str, *) env_value
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(A16,2x,A,2x,e10.3, 1x, a9)' ), env_var,'|', env_value, '(default)' 
             else if (regular) then
                write( loc_logdev, '(A16,2x,A,2x,e10.3)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_double

! --------------------------------------------------------------------------------
        subroutine get_env_char (env_value, env_var, default_env_value, logdev)

          character (*), intent(out) :: env_value
          character (*), intent(in)  :: env_var
          character (*), intent(in)  :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: loc_logdev, length
          logical :: default, regular
          character (50) :: myfmt

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          regular = .false.
          default = .false.

          if (len(trim(loc_str)) == 0) then
             env_value = default_env_value
             default = .true.
          else
             env_value = loc_str
             regular = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             length = len_trim(env_value)
             if (default) then
                if (length .eq. 0) then
                   write( loc_logdev, '(A16, 2x, A, 13x, a9)') env_var, '|', '(default)'
                else
                   write (myfmt, '(a18, i3.3, a9)') '(A16, 2x, A, 2x, A', length, ', 1x, a9)'
                   write( loc_logdev, myfmt) env_var, '|', env_value, '(default)'
                end if
             else if (regular) then
                write (myfmt, '(a18, i3.3, a1)') '(A16, 2x, A, 2x, A', length, ')'
                write( loc_logdev, myfmt) env_var,'|', env_value
             end if
          end if

        end subroutine get_env_char

! --------------------------------------------------------------------------------
        subroutine get_env_logical (env_value, env_var, default_env_value, logdev)

          logical, intent(out)      :: env_value
          character (*), intent(in) :: env_var
          logical, intent(in)       :: default_env_value
          integer, intent(in), optional :: logdev

          integer :: length
          integer :: loc_logdev
          logical :: default, regular

          call getenv (env_var, loc_str)

          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

          length = len(trim(loc_str))
          regular = .false.
          default = .false.

          if (length <= 0) then
             env_value = default_env_value
             default = .true.
          else if ((length == 1) .and. ((loc_str(1:1) .eq. 'Y') .or.       &
                                        (loc_str(1:1) .eq. 'y') .or.       &
                                        (loc_str(1:1) .eq. 'T') .or.       &
                                        (loc_str(1:1) .eq. 't'))) then
             env_value = .true.
             regular = .true.
          else if ((length == 1) .and. ((loc_str(1:1) .eq. 'N') .or.       &
                                        (loc_str(1:1) .eq. 'n') .or.       &
                                        (loc_str(1:1) .eq. 'F') .or.       &
                                        (loc_str(1:1) .eq. 'f'))) then
             env_value = .false.
             regular = .true.
          else if ((trim(loc_str) == '.TRUE.') .or.                        &
                   (trim(loc_str) == '.true.') .or.                        &
                   (trim(loc_str) == '.True.') .or.                        &
                   (trim(loc_str) == 'TRUE') .or.                          &
                   (trim(loc_str) == 'true') .or.                          &
                   (trim(loc_str) == 'True') .or.                          &
                   (trim(loc_str) == 'YES') .or.                           &
                   (trim(loc_str) == 'yes') .or.                           &
                   (trim(loc_str) == 'Yes')) then
             env_value = .true.
             regular = .true.
          else if ((trim(loc_str) == '.FALSE.') .or.                       &
                   (trim(loc_str) == '.false.') .or.                       &
                   (trim(loc_str) == '.False.') .or.                       &
                   (trim(loc_str) == 'FALSE') .or.                         &
                   (trim(loc_str) == 'false') .or.                         &
                   (trim(loc_str) == 'False') .or.                         &
                   (trim(loc_str) == 'NO') .or.                            &
                   (trim(loc_str) == 'no') .or.                            &
                   (trim(loc_str) == 'No')) then
             env_value = .false.
             regular = .true.
          else
             write (loc_logdev, *) ' Note: Variable ', trim(env_var), ' improperly formatted'
             env_value = default_env_value
             default = .true.
          end if

          if ( loc_logdev .gt. 0 ) then
             if (default) then
                write( loc_logdev, '(A16,2x,A,10x,L, 1x, a9)' ), env_var,'|', env_value, '(default)'
             else if (regular) then
                write( loc_logdev, '(A16,2x,A,10x,L)' ), env_var,'|', env_value
             end if
          end if

        end subroutine get_env_logical

! --------------------------------------------------------------------------------
        subroutine get_envlist ( env_var, nvars, val_list, logdev )

! get a list env var (quoted string of items delimited by white space,
! commas or semi-colons) and parse out the items into variables. Two data
! types: character strings and integers (still represented as strings in
! the env var vaules).
! Examples:
! 1)   setenv AVG_CONC_VARS "O3 NO NO2"
! 2)   setenv AVG_CONC_LAYS "2 5"          < start at two, end at 5
! 3)   setenv NPCOLSXNPROWS "4 3"
! 4)   setenv BCOL_ECOL "3 8"
! 5)   setenv BROW_EROW "2 10"
! 6)   setenv BLAY_ELAY "1 5"

! In example (1), not only parse out the named items "O3", "NO" and "NO2",
! but also obtain the count on the number of items (=3).

! Revision: 2013/02/11 David Wong: increased the max env var length from 256 to 1000
! 13 Dec 2013 J.Young: 1000 breaks BUFLEN in IOAPI's envgets.c. Change to 512.
! 17 Jun 2016 J.Young: IOAPI's envgets.c BUFLEN has been increased to 10000.
! 20 Jun 2016 J.Young: Forget IOAPI's envgets.c: use Fortran GETENV

          character( * ),  intent ( in )  :: env_var
          integer,         intent ( out ) :: nvars
          character( 16 ), intent ( out ) :: val_list( : )
          integer, intent(in), optional :: logdev

          integer             :: max_len
          character( 16 )     :: pname = 'GET_ENVLIST'
          character( 16*size( val_list ) ) :: e_val
          character(  1 )     :: chr
          character( 96 )     :: xmsg

          integer :: jp( 16*size( val_list ) ), kp( 16*size( val_list ) ), status
          integer ip, v

          integer :: loc_logdev
 
          if (present(logdev)) then
             loc_logdev = logdev
          else
             loc_logdev = 6
          end if

           max_len = 16 * size( val_list )

          call get_env( e_val, env_var, ' ', loc_logdev )

          if ( env_var .eq. " " ) then
             xmsg = 'Environment variable ' // env_var // ' not set'
             call m3warn( pname, 0, 0, xmsg )
             nvars = 0
             return
          end if

          nvars = 1

          ip = 0

101   continue
          ip = ip + 1
          if ( ip .gt. max_len ) go to 301
          chr = e_val( ip:ip )
          if ( chr .eq. ' ' .or. ichar ( chr ) .eq. 09 ) go to 101
          jp( nvars ) = ip   ! 1st char

201   continue
          ip = ip + 1
          if ( ip .gt. max_len ) then
             xmsg = 'Environment variable value too long'
             call m3exit( pname, 0, 0, xmsg, 2 )
          end if
          chr = e_val( ip:ip )
          if ( chr .ne. ' ' .and.    &
               chr .ne. ',' .and.    &
               chr .ne. ';' .or.     &
               ichar ( chr ) .eq. 09 ) then  ! 09 = horizontal tab
             go to 201
          else
             kp( nvars ) = ip - 1 ! last char in this item
             nvars = nvars + 1
          end if

          go to 101

301       continue
          nvars = nvars - 1

          do v = 1, nvars
             val_list( v ) = e_val( jp( v ):kp( v ) )
          end do

        end subroutine get_envlist

      end module get_env_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

C-----------------------------------------------------------------------
C Function:
C   Advection in the horizontal plane
C   The process time step is set equal to TSTEP(2). Boundary concentrations
C   are coupled in RDBCON with SqRDMT = Sq. Root [det ( metric tensor )]
C   = Jacobian / (map scale factor)**2
C   where Air Density X SqRDMT is loaded into last BCON slot for advection.
      
C Preconditions:
C   Dates and times represented YYYYDDD:HHMMSS.
C   No "skipped" dates and times.  All boundary input variables have the
C   same boundary perimeter structure with a thickness of 1
C   CGRID in transport units: SQRT{DET[metric tensor]}*concentration (Mass/Vol)
      
C Subroutines and functions called:
 
C Revision history:
C  19 Jan 2004: Jeff Young
C   7 Jul 2007: Jeff Young - declare MTRHOJ dimensions properly in order to retain
C                            them as declared in X_YAMO and Y_YAMO
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   May 2019 j. pleim:  removed yamo hadvect subroutines
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
      
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN
#endif 

      IMPLICIT NONE
      
C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:
      
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER     JDATE         ! current model date, coded YYYYDDD
      INTEGER     JTIME         ! current model time, coded HHMMSS
      INTEGER     TSTEP( 3 )    ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

      INTEGER     ASTEP( : )    ! layer advection time step

C External Functions: None
      
C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

C File Variables:

      REAL, ALLOCATABLE, SAVE :: BCON( :,: )    ! boundary concentrations
      REAL         RHOJ( NCOLS,NROWS )          ! RhoJ

C Local Variables:


      INTEGER       ALLOCSTAT

      INTEGER, SAVE :: ASPC                     ! RHOJ index in CGRID

      CHARACTER( 16 ) :: PNAME = 'HADVPPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: FIRST_BC = .TRUE.
      LOGICAL, ALLOCATABLE, SAVE :: XYFIRST( : )


      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 199 ) :: XMSG2 = ' '

      INTEGER      STEP                         ! ASTEP( L ), (dt) in sec
      INTEGER      DSTEP                        ! dt accumulator
      INTEGER      FDATE                        ! interpolation date
      INTEGER      FTIME                        ! interpolation time
      INTEGER      SYNCSTEP

      INTEGER      COL, ROW, LVL                ! loop counters
      LOGICAL      LSTAT

C Required interface for allocatable array dummy arguments

      INTERFACE
         SUBROUTINE RDBCON ( FDATE, FTIME, TSTEP, LVL, BCON, LSTAT )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, TSTEP, LVL
            REAL,    INTENT( OUT ) :: BCON( :,: )
            LOGICAL, INTENT( INOUT ) :: LSTAT
         END SUBROUTINE RDBCON
         SUBROUTINE X_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )
            REAL, POINTER          :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, TSTEP, LVL
!           REAL,    INTENT( IN )  :: BCON( NBNDY,* )
            REAL,    INTENT( IN )  :: BCON( :,: )
         END SUBROUTINE X_PPM
         SUBROUTINE Y_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )
            REAL, POINTER          :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, TSTEP, LVL
!           REAL,    INTENT( IN )  :: BCON( NBNDY,: )
            REAL,    INTENT( IN )  :: BCON( :,: )
         END SUBROUTINE Y_PPM
!        SUBROUTINE LCKSUMMER ( PNAME, CGRID, JDATE, JTIME, LVL )
!           CHARACTER( * ), INTENT( IN ) :: PNAME
!           REAL, POINTER                :: CGRID( :,:,:,: )
!           INTEGER, INTENT( IN )        :: JDATE, JTIME, LVL
!        END SUBROUTINE LCKSUMMER
      END INTERFACE
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE( XYFIRST( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating XYFIRST'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         XYFIRST( : ) = .TRUE.

C Get CGRID offsets

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ
         ALLOCATE ( BCON( NBNDY,N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BCON'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ASPC = GC_STRT - 1 + N_GC_SPCD

#ifdef sens
         ALLOCATE ( BSEN( NBNDY,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BSEN'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
#endif

      END IF                    ! if firstime

      SYNCSTEP = TIME2SEC( TSTEP( 2 ) )

      LSTAT = .FALSE.
      DO 301 LVL = 1, NLAYS

         STEP = TIME2SEC ( ASTEP( LVL ) )
         DSTEP = STEP
         FDATE = JDATE
         FTIME = JTIME

101      CONTINUE

         CALL RDBCON ( FDATE, FTIME, ASTEP( LVL ), LVL, BCON, LSTAT )

         IF ( XYFIRST( LVL ) ) THEN

            XYFIRST( LVL ) = .FALSE.

            CALL X_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'X_PPM', CGRID, FDATE, FTIME, LVL )

            CALL Y_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'Y_PPM', CGRID, FDATE, FTIME, LVL )

         ELSE

            XYFIRST( LVL ) = .TRUE.

            CALL Y_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'Y_PPM', CGRID, FDATE, FTIME, LVL )

            CALL X_PPM ( CGRID, FDATE, FTIME, ASTEP( LVL ), LVL, BCON )
!           CALL LCKSUMMER ( 'X_PPM', CGRID, FDATE, FTIME, LVL )

         END IF

         DSTEP = DSTEP + STEP
         IF ( DSTEP .LE. SYNCSTEP ) THEN
            CALL NEXTIME( FDATE, FTIME, SEC2TIME( STEP ) )
            GO TO 101
         END IF

301   CONTINUE
 
      !Print warning if any aerosol BCs violated the size distribution parameters
      IF ( LSTAT ) THEN 
         IF ( FIRST_BC ) THEN
            FIRST_BC = .FALSE.
            WRITE( XMSG2, '(A)' ),
     &            'ATTENTION: Applying fix to aerosol Boundary Conditions' //
     &            ' for aerosol modes. Set verbose_rdbcon preprocessor' //
     &            ' flag to learn more.'
            WRITE( LOGDEV, * )
            CALL LOG_MESSAGE( LOGDEV, XMSG2 )
            WRITE( LOGDEV, * )
         END IF
      END IF
 
 
      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HDIFF ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Horizontal diffusion with constant eddy diffusivity - gen. coord.
C   The process time step is set equal to TSTEP(2). Boundary concentrations
C   are set using a Dirichlet (no flux) condition
      
C Preconditions:
C   Dates and times represented YYYYDDD:HHMMSS.
C   No "skipped" dates and times.  All boundary input variables have the
C   same boundary perimeter structure with a thickness of 1
C   CGRID in ppm units or micro-g/m**3, #/m**3 for aerosols
      
C Subroutines and functions called:
C   TIME2SEC, SEC2TIME, CGRID_MAP, NEXTIME, RHO_J, 
C   HCDIFF3D
 
C Revision history:
C   Jeff - 5 Nov 97, 1 Jan 98
C   DWB  - 1 Feb 98, use simple B/C (no conc gradient at domain boundary)

C   David Wong Sep. 1998
C     -- parallelized the code
C     -- removed the intermediate constant CRHOJ_Q and placed the answer of
C        the calculation directly into CGRID. Removed the next immediate
C        loop completely.

C   David Wong 1/19/99
C      -- add a loop_index call
C      -- change loop index ending point to avoid accessing invalid region.
C         (reason to do this is to prevent using boundary data from PINTERP,
C          which sets pseudo-boundary data to 0)
 
C   Daewon Byun 10/10/2000
C      -- generalized 3d horizontal diffusivity module
C      -- accomdates 3d hdiff values

C    15 Dec 00 J.Young: PE_COMM3 -> Dave Wong's f90 stenex COMM 
C     6 Aug 01 J.Young: Use HGRD_DEFN
C    25 Mar 04 G.Hammond: RK11/RK22 ghost cell updates moved outside main loop;
C                         use explicit boundary arrays for CGRID ghost cells;
C                         use SNL's "swap3d".
C    31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module
C    17 Dec 09 J.Young: fix CONC initializing error for sub-cycling timesteps (DO 344)
C                       reported by Talat Odman and Yongtao Hu of GA tech.
C    21 Jun 10 J.Young: convert for Namelist redesign
C    16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    29 Nov 17 D.Wong: removed all SWAP routines and replaced with SE_COMM
C    18 Nov 18 S. Napelenok: ISAM implementation
C    01 Feb 19 David Wong: removed all MY_N clauses
C    11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------
      
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef isam
      USE SA_DEFN, Only: ISAM, N_SPCTAG, S_SPCTAG, T_SPCTAG, TRANSPORT_SPC
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NPMAX, NP
#endif

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:
      
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                          ! TSTEP(1) = local output step
                                          ! TSTEP(2) = sciproc sync. step (chem)
                                          ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                          !            step and wrf/cmaq call frequency

C External Functions: None
           
C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_DIFF
 
C File Variables:
 
      REAL          CONC  ( 0:NCOLS+1,0:NROWS+1 )   ! conc working array
      REAL          RHOJ  ( 0:NCOLS+1,0:NROWS+1,NLAYS ) ! density X Jacobian
      CHARACTER( 8 ), SAVE :: COMMSTR                 ! for both CONC and RHOJ
      REAL          RK11  (   NCOLS+1,NROWS+1,NLAYS ) ! initially used as RHOJ
                              ! at x1 cell face, then finally as 11 eddy diff. factor
      REAL          RK22  (   NCOLS+1,NROWS+1,NLAYS ) ! initially used as RHOJ
                              ! at x2 cell face, then finally as 22 eddy diff. factor
      REAL          K11BAR3D ( NCOLS+1,NROWS+1,NLAYS ) ! ave. Cx11 eddy diff
      REAL          K22BAR3D ( NCOLS+1,NROWS+1,NLAYS ) ! ave. Cx22 eddy diff
      REAL          DT                          ! diffusion time step
      REAL          CRHOJ_Q                     ! intermediate, coupled conc.

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'HDIFF'
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      REAL          DX1                         ! dx1 (meters)
      REAL          DX2                         ! dx2 (meters)
      REAL, SAVE :: RDX1S                       ! reciprocal dx1*dx1
      REAL, SAVE :: RDX2S                       ! reciprocal dx2*dx2
      
      REAL          DTDX1S                      ! dt/dx1**2
      REAL          DTDX2S                      ! dt/dx2**2
      REAL          DTSEC                       ! model time step in seconds
      INTEGER       NSTEPS                      ! diffusion time steps
      INTEGER       STEP                        ! FIX dt
      INTEGER       FDATE                       ! interpolation date
      INTEGER       FTIME                       ! interpolation time

      REAL,    ALLOCATABLE, SAVE :: HALO_SOUTH( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: HALO_NORTH( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: HALO_WEST ( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: HALO_EAST ( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: BUF_NS    ( :,:,: )
      REAL,    ALLOCATABLE, SAVE :: BUF_EW    ( :,:,: )

      INTEGER, ALLOCATABLE, SAVE :: DIFF_MAP( : )   ! global diff map to CGRID

      INTEGER      C, R, L, S, V, N            ! loop counters
      INTEGER      D2C, IOS

      CHARACTER( 96 ) :: XMSG = ' '
     
      INTEGER MY_TEMP
      INTEGER, SAVE :: STARTROW, ENDROW
      INTEGER, SAVE :: STARTCOL, ENDCOL

#ifdef isam
      INTEGER      JSPCTAG
      REAL         SA_CONC ( 0:NCOLS+1,0:NROWS+1 )   ! sa_conc working array
      REAL, ALLOCATABLE, SAVE :: SA_HALO_SOUTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_NORTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_WEST ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_EAST ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_NS    ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_EW    ( :,:,: )
#endif

#ifdef sens
      REAL, ALLOCATABLE, SAVE :: S_HALO_SOUTH( :,:,:,: ) ! ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_HALO_NORTH( :,:,:,: ) ! ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_HALO_WEST ( :,:,:,: ) ! ( NROWS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_HALO_EAST ( :,:,:,: ) ! ( NROWS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_BUF_NS    ( :,:,:,: ) ! ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL, ALLOCATABLE, SAVE :: S_BUF_EW    ( :,:,:,: ) ! ( NROWS,NLAYS,N_SPC_DIFF,NPMAX )
      REAL SENSWORK  ( 0:NCOLS+1,0:NROWS+1,NPMAX )   ! sens working array
#endif



      INTERFACE
         SUBROUTINE RHO_J ( JDATE, JTIME, TSTEP, RHOJ )
            INTEGER, INTENT( IN )  :: JDATE, JTIME, TSTEP( 3 )
            REAL,    INTENT( OUT ) :: RHOJ( :,:,: )
         END SUBROUTINE RHO_J
         SUBROUTINE HCDIFF3D ( JDATE, JTIME, K11BAR, K22BAR, DT )
            INTEGER, INTENT( IN )  :: JDATE, JTIME
            REAL,    INTENT( OUT ) :: K11BAR( :,:,: ), K22BAR( :,:,: )
            REAL,    INTENT( OUT ) :: DT
         END SUBROUTINE HCDIFF3D
      END INTERFACE
 
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Get dx1 from COORD include file

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 ))) ! in m.
            DX2 = DG2M * YCELL_GD   ! in m.
         ELSE
            DX1 = XCELL_GD          ! in m.
            DX2 = YCELL_GD          ! in m.
         END IF

         RDX1S = 1.0 / ( DX1 * DX1 )
         RDX2S = 1.0 / ( DX2 * DX2 )

         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF

         ALLOCATE ( HALO_SOUTH( NCOLS,NLAYS,N_SPC_DIFF ),
     &              HALO_NORTH( NCOLS,NLAYS,N_SPC_DIFF ),
     &              HALO_WEST ( NROWS,NLAYS,N_SPC_DIFF ),
     &              HALO_EAST ( NROWS,NLAYS,N_SPC_DIFF ),
     &              BUF_NS    ( NCOLS,NLAYS,N_SPC_DIFF ),
     &              BUF_EW    ( NROWS,NLAYS,N_SPC_DIFF ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating HALO_SOUTH, HALO_NORTH, HALO_WEST, HALO_EAST, BUF_NS, or BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( SA_HALO_SOUTH( NCOLS,NLAYS,N_SPCTAG ),
     &              SA_HALO_NORTH( NCOLS,NLAYS,N_SPCTAG ),
     &              SA_HALO_WEST ( NROWS,NLAYS,N_SPCTAG ),
     &              SA_HALO_EAST ( NROWS,NLAYS,N_SPCTAG ),
     &              SA_BUF_NS    ( NCOLS,NLAYS,N_SPCTAG ),
     &              SA_BUF_EW    ( NROWS,NLAYS,N_SPCTAG ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating SA_HALO_SOUTH, SA_HALO_NORTH,'
     &           // ' SA_HALO_WEST, SA_HALO_EAST, SA_BUF_NS, or SA_BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#endif

#ifdef sens
         ALLOCATE ( S_HALO_SOUTH( NCOLS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_HALO_NORTH( NCOLS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_HALO_WEST ( NROWS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_HALO_EAST ( NROWS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_BUF_NS    ( NCOLS,NLAYS,N_SPC_DIFF,NPMAX ),
     &              S_BUF_EW    ( NROWS,NLAYS,N_SPC_DIFF,NPMAX ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating S_HALO_SOUTH, S_HALO_NORTH,'
     &           // ' S_HALO_WEST, S_HALO_EAST, S_BUF_NS, or S_BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#endif


         ALLOCATE ( DIFF_MAP( N_SPC_DIFF ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating DIFF_MAP'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

C Create global map to CGRID
 
         S = 0
         DO V = 1, N_GC_TRNS
            S = S + 1
            DIFF_MAP( S ) = GC_STRT - 1 + GC_TRNS_MAP( V )
         END DO
         DO V = 1, N_AE_TRNS
            S = S + 1
            DIFF_MAP( S ) = AE_STRT - 1 + AE_TRNS_MAP( V )
         END DO
         DO V = 1, N_NR_TRNS
            S = S + 1
            DIFF_MAP( S ) = NR_STRT - 1 + NR_TRNS_MAP( V )
         END DO
         DO V = 1, N_TR_DIFF
            S = S + 1
            DIFF_MAP( S ) = TR_STRT - 1 + TR_DIFF_MAP( V )
         END DO
 
C Get file start and end indices for subdomain
 
         CALL SUBST_LOOP_INDEX ( 'C', 1, NCOLS, 1, MY_TEMP, STARTCOL, ENDCOL )
         CALL SUBST_LOOP_INDEX ( 'R', 1, NROWS, 1, MY_TEMP, STARTROW, ENDROW )

         WRITE( COMMSTR,'(4I2)' )  1, 0, 2, 0

      END IF                    ! if firstime
                                     
      DTSEC = FLOAT( TIME2SEC( TSTEP( 2 ) ) )
      FDATE = JDATE
      FTIME = JTIME
 
C Get the computational grid ( rho X Jacobian ) for this step

      CALL RHO_J ( FDATE, FTIME, TSTEP, RHOJ )

      CALL SUBST_COMM ( RHOJ, DSPL_N0_E0_S1_W1, DRCN_S_W, COMMSTR )

C initialize RK11, RK22 with face values for RHOJ (assumes dx1 = dx2)

      RK11 = 0.0   ! array assignment
      RK22 = 0.0   ! array assignment
      DO L = 1, NLAYS
         DO R = STARTROW, ENDROW        !  DO R = 1, NROWS + 1
            DO C = STARTCOL, ENDCOL     !     DO C = 1, NCOLS + 1
               RK11( C,R,L ) = 0.5 * ( RHOJ( C,R,L ) + RHOJ( C-1,R,  L ) )
               RK22( C,R,L ) = 0.5 * ( RHOJ( C,R,L ) + RHOJ( C,  R-1,L ) )
            END DO
         END DO
      END DO

C Do the gridded computation for horizontal diffusion

C Get the contravariant eddy diffusivities

      CALL HCDIFF3D ( FDATE, FTIME, K11BAR3D, K22BAR3D, DT )

C get number of steps based on eddy time 
 
      NSTEPS = INT ( DTSEC / DT ) + 1
      DT = DTSEC / FLOAT( NSTEPS )
 
      DTDX1S = DT * RDX1S
      DTDX2S = DT * RDX2S

      DO L = 1, NLAYS
         DO R = STARTROW, ENDROW        !  DO R = 1, NROWS + 1
            DO C = STARTCOL, ENDCOL     !     DO C = 1, NCOLS + 1
               RK11( C,R,L ) = RK11( C,R,L ) * K11BAR3D( C,R,L )
               RK22( C,R,L ) = RK22( C,R,L ) * K22BAR3D( C,R,L )
            END DO
         END DO
      END DO

      CALL SUBST_COMM ( RK11, DSPL_N0_E1_S0_W0, DRCN_E )
      CALL SUBST_COMM ( RK22, DSPL_N1_E0_S0_W0, DRCN_N )

      DO S = 1, N_SPC_DIFF
         D2C = DIFF_MAP( S )
         DO L = 1, NLAYS
            DO C = 1, NCOLS
               HALO_SOUTH( C,L,S ) = CGRID( C,1,L,D2C ) / RHOJ( C,1,L )
               HALO_NORTH( C,L,S ) = CGRID( C,NROWS,L,D2C ) / RHOJ( C,NROWS,L )
               BUF_NS( C,L,S ) = HALO_NORTH( C,L,S )
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_SOUTH, HALO_NORTH, DSPL_N1_E0_S0_W0, DRCN_N)
      CALL SUBST_COMM (BUF_NS,     HALO_SOUTH, DSPL_N0_E0_S1_W0, DRCN_S)

#ifdef sens
      DO NP = 1, NPMAX

        DO S = 1, N_SPC_DIFF
           D2C = DIFF_MAP( S )
           DO L = 1, NLAYS
              DO C = 1, NCOLS
                 S_HALO_SOUTH( C,L,S,NP ) = SENGRID( C,1,L,NP,D2C ) / RHOJ( C,1,L )
                 S_HALO_NORTH( C,L,S,NP ) = SENGRID( C,NROWS,L,NP,D2C ) / RHOJ( C,NROWS,L )
                 S_BUF_NS( C,L,S,NP ) = S_HALO_NORTH( C,L,S,NP )
              END DO
           END DO
        END DO

        CALL SUBST_COMM (S_HALO_SOUTH(:,:,:,NP), S_HALO_NORTH(:,:,:,NP),
     &                   DSPL_N1_E0_S0_W0, DRCN_N)
        CALL SUBST_COMM (S_BUF_NS(:,:,:,NP),     S_HALO_SOUTH(:,:,:,NP),
     &                   DSPL_N0_E0_S1_W0, DRCN_S)

      END DO
#endif

      DO S = 1, N_SPC_DIFF
         D2C = DIFF_MAP( S )
         DO L = 1, NLAYS
            DO R = 1, NROWS
               HALO_WEST( R,L,S ) = CGRID( 1,R,L,D2C ) / RHOJ( 1,R,L )
               HALO_EAST( R,L,S ) = CGRID( NCOLS,R,L,D2C ) / RHOJ( NCOLS,R,L )
               BUF_EW( R,L,S ) = HALO_EAST( R,L,S )
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_WEST, HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (BUF_EW,    HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)

#ifdef sens
      DO NP = 1, NPMAX

        DO S = 1, N_SPC_DIFF
           D2C = DIFF_MAP( S )
           DO L = 1, NLAYS
              DO R = 1, NROWS
                 S_HALO_WEST( R,L,S,NP ) = SENGRID( 1,R,L,NP,D2C ) / RHOJ( 1,R,L )
                 S_HALO_EAST( R,L,S,NP ) = SENGRID( NCOLS,R,L,NP,D2C ) / RHOJ( NCOLS,R,L )
                 S_BUF_EW( R,L,S,NP ) = S_HALO_EAST( R,L,S,NP )
              END DO
           END DO
        END DO

        CALL SUBST_COMM (S_HALO_WEST(:,:,:,NP), S_HALO_EAST(:,:,:,NP),
     &                   DSPL_N0_E1_S0_W0, DRCN_E)
        CALL SUBST_COMM (S_BUF_EW(:,:,:,NP),    S_HALO_WEST(:,:,:,NP),
     &                   DSPL_N0_E0_S0_W1, DRCN_W)

      END DO
#endif

#ifdef isam
      DO JSPCTAG = 1, N_SPCTAG
         DO L = 1, NLAYS
            DO C = 1, NCOLS
               SA_HALO_SOUTH( C,L,JSPCTAG ) =
     &            ISAM( C,1,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( C,1,L )
               SA_HALO_NORTH( C,L,JSPCTAG ) =
     &            ISAM( C,NROWS,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( C,NROWS,L )
               SA_BUF_NS( C,L,JSPCTAG ) = SA_HALO_NORTH( C,L,JSPCTAG )
             END DO
         END DO
      END DO

      CALL SUBST_COMM (SA_HALO_SOUTH, SA_HALO_NORTH, DSPL_N1_E0_S0_W0, DRCN_N)
      CALL SUBST_COMM (SA_BUF_NS,     SA_HALO_SOUTH, DSPL_N0_E0_S1_W0, DRCN_S)

      DO JSPCTAG = 1, N_SPCTAG
         DO L = 1, NLAYS
            DO R = 1, NROWS
               SA_HALO_WEST( R,L,JSPCTAG ) =
     &            ISAM( 1,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( 1,R,L )
               SA_HALO_EAST( R,L,JSPCTAG ) =
     &            ISAM( NCOLS,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) / RHOJ( NCOLS,R,L )
               SA_BUF_EW( R,L,JSPCTAG ) = SA_HALO_EAST( R,L,JSPCTAG )
            END DO
         END DO
      END DO

      CALL SUBST_COMM (SA_HALO_WEST, SA_HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (SA_BUF_EW,    SA_HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)

#endif

C Loop over species, layers, nsteps

      DO 366 S = 1, N_SPC_DIFF
         D2C = DIFF_MAP( S )

         DO 355 L = 1, NLAYS

            DO 344 N = 1, NSTEPS

C Load working array (CGRID is coupled, CONC is mixing ratio)

               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CONC( C,R ) = CGRID( C,R,L,D2C ) / RHOJ( C,R,L )
                  END DO
               END DO

#ifdef sens
               DO NP = 1, NPMAX
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        SENSWORK( C,R,NP ) = SENGRID( C,R,L,NP,D2C ) / RHOJ( C,R,L )
                     END DO
                  END DO
               END DO
#endif

               DO C = 1, NCOLS
                  CONC( C,0 )       = HALO_SOUTH( C,L,S )
                  CONC( C,NROWS+1 ) = HALO_NORTH( C,L,S )
               END DO

               DO R = 1, NROWS
                  CONC( 0,R )       = HALO_WEST( R,L,S )
                  CONC( NCOLS+1,R ) = HALO_EAST( R,L,S )
               END DO

#ifdef sens
               DO NP = 1, NPMAX
                  DO C = 1, NCOLS
                     SENSWORK( C,0,NP ) = S_HALO_SOUTH( C,L,S,NP )
                     SENSWORK( C,NROWS+1,NP ) = S_HALO_NORTH( C,L,S,NP )
                  END DO

                  DO R = 1, NROWS
                     SENSWORK( 0,R,NP ) = S_HALO_WEST( R,L,S,NP )
                     SENSWORK( NCOLS+1,R,NP ) = S_HALO_EAST( R,L,S,NP )
                  END DO
               END DO
#endif

C Update CGRID

               DO R = 1, NROWS
                  DO C = 1, NCOLS

                     CGRID( C,R,L,D2C ) = RHOJ( C,R,L ) * CONC( C,R )
     &                                  + DTDX1S
     &                                  * ( RK11( C+1,R,L )
     &                                  * ( CONC( C+1,R ) - CONC( C,R ) )
     &                                  - RK11( C,R,L )
     &                                    * ( CONC( C,R )   - CONC( C-1,R ) ) )
     &                                  + DTDX2S
     &                                  * ( RK22( C,R+1,L )
     &                                    * ( CONC( C,R+1 ) - CONC( C,R ) )
     &                                    - RK22( C,R,L )
     &                                    * ( CONC( C,R )   - CONC( C,R-1 ) ) )

#ifdef sens
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,D2C ) = RHOJ( C,R,L ) * SENSWORK( C,R,NP )
     &                                          + DTDX1S
     &                                          * ( RK11( C+1,R,L )
     &                                          * ( SENSWORK( C+1,R,NP ) - SENSWORK( C,R,NP ) )
     &                                          - RK11( C,R,L )
     &                                          * ( SENSWORK( C,R,NP ) - SENSWORK( C-1,R,NP )))
     &                                          + DTDX2S
     &                                          * ( RK22( C,R+1,L )
     &                                          * ( SENSWORK( C,R+1,NP ) - SENSWORK( C,R,NP ) )
     &                                          - RK22( C,R,L )
     &                                          * ( SENSWORK( C,R,NP ) - SENSWORK( C,R-1,NP )))
                     END DO

#endif
                  END DO
               END DO

344         CONTINUE

355      CONTINUE
366   CONTINUE

#ifdef isam
      DO 766 JSPCTAG = 1, N_SPCTAG
        IF( TRANSPORT_SPC( JSPCTAG ) )THEN
          DO 755 L = 1, NLAYS
            DO 744 N = 1, NSTEPS

C Load working array (ISAM is coupled, SA_CONC is mixing ratio)

               DO R = 1, NROWS
                   DO C = 1, NCOLS
                      SA_CONC( C,R ) =
     &                ISAM( C,R,L,S_SPCTAG(JSPCTAG),T_SPCTAG(JSPCTAG) ) / RHOJ( C,R,L )
                   END DO ! C
               END DO ! R

C Fill 4 boundaries of working array SA_CONC: south, north, west, east
               DO C = 1, NCOLS
                  SA_CONC( C,0 )       = SA_HALO_SOUTH( C,L,JSPCTAG )
                  SA_CONC( C,NROWS+1 ) = SA_HALO_NORTH( C,L,JSPCTAG )
               END DO ! C

               DO R = 1, NROWS
                  SA_CONC( 0,R )       = SA_HALO_WEST( R,L,JSPCTAG )
                  SA_CONC( NCOLS+1,R ) = SA_HALO_EAST( R,L,JSPCTAG )
               END DO ! R

C Update ISAM
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     ISAM( C,R,L,S_SPCTAG(JSPCTAG),T_SPCTAG(JSPCTAG) ) =
     &                                RHOJ( C,R,L ) * SA_CONC( C,R )
     &                                + DTDX1S
     &                                * ( RK11( C+1,R,L )
     &                                * ( SA_CONC( C+1,R ) - SA_CONC( C,R ) )
     &                                - RK11( C,R,L )
     &                                * ( SA_CONC( C,R )   - SA_CONC( C-1,R ) ) )
     &                                + DTDX2S
     &                                * ( RK22( C,R+1,L )
     &                                * ( SA_CONC( C,R+1 ) - SA_CONC( C,R ) )
     &                                - RK22( C,R,L )
     &                                * ( SA_CONC( C,R )   - SA_CONC( C,R-1 ) ) )

                  END DO
               END DO

744         CONTINUE
755       CONTINUE
        END IF
766   CONTINUE
#endif


      RETURN

1001  FORMAT( 5X, 'Negative concentrations reset to', 1PE11.3 )
1003  FORMAT( 1X, 4I7, 9X, 1PE11.3)

      END

C=======================================================================
      MODULE PA_DEFN
 
C Contains: Control parameters for Process Analysis
C
C Dependent On: Mechanism Input file
C
C Created By: Process Analysis Control Program
C           11:05:01 EDT  July 15, 2016

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used to control calls to the Integrated
c  Process Rate and Integrated Reaction Rate routines:
c     LIPR = Flag for calculating Integrated Process Rates
c     LIRR = Flag for calculating Integrated Reaction Rates
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c these are set in pa_read.F
      LOGICAL :: LIPR = .FALSE.
      LOGICAL :: LIRR = .FALSE.

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used in the output file descriptions
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     NIPRVAR = Number of IPR output variables
c     NIRRVAR = Number of IRR output variables
c     IPRNAME = Name of IPR output variable
c     IRRNAME = Name of IRR output variable
c     IPRDESC = Extended name of IPR output variable
c     IRRDESC = Extended name of IRR output variable
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c these are set in pa_setup_ipr.F, pa_read.F, respectively
c   change to pa_read
      INTEGER :: NIPRVAR = 0
      INTEGER :: NIRRVAR = 0

c these are set in pa_setup_ipr.F, pa_getirrout.F (pa_setup_irr.F)
c   allocate in pa_read
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: IPRNAME( : ) ! IPRNAME( NIPRVAR )
      CHARACTER( 60 ), ALLOCATABLE, SAVE :: IPRDESC( : ) ! IPRDESC( NIPRVAR )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: IRRNAME( : ) ! IRRNAME( NIRRVAR )
      CHARACTER( 60 ), ALLOCATABLE, SAVE :: IRRDESC( : ) ! IRRDESC( NIRRVAR )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used in the integrated process rate 
c  computations.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c    NPRCS     = No. of science processes that can be monitored
c    PROCNAME  =
c    N_IPR_SPC = Number of families for IPR
c    NCSAVE    = Number of CTM species concs to save for IPR
c    MXCGRID   = Max number of CTM species in an IPR family
c    LPROCOUT  =
c    NCGRID    = Array of no. of CTM species in an IPR family
c    IPROUT    = Array of IPR output variable indices
c    IPR2GRD   = Array of CTM species indices for IPR families
c    IPR2SAV   = Array of saved species indices for IPR families
c    SV2GRD    = Array of CTM indicies for saved concs
c    SPCOEF    = Array of coefficients for IPR familys
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      INTEGER, PARAMETER :: NPRCS = 12

      CHARACTER( 16 ), PARAMETER :: PROCNAME( NPRCS ) = (/
     &   'ZADV            ',  'HADV            ',  'HDIF            ',
     &   'VDIF            ',  'EMIS            ',  'DDEP            ',
     &   'CLDS            ',  'CHEM            ',  'COND            ',
     &   'COAG            ',  'GROW            ',  'NPF             ' /)

c this is set in pa_getiprout.F, pa_errcheck.F?
      INTEGER :: N_IPR_SPC = 0
c these are set in pa_setup_ipr.F
      INTEGER :: NCSAVE    = 0
      INTEGER :: MXCGRID   = 0

c these are allocated in pa_setpadefn.F
      LOGICAL, ALLOCATABLE, SAVE :: LPROCOUT( : )   ! LPROCOUT( NPRCS )

      INTEGER, ALLOCATABLE, SAVE :: NCGRID ( : )    ! ( N_IPR_SPC )
      INTEGER, ALLOCATABLE, SAVE :: SAV2GRD( : )    ! ( NCSAVE )
      INTEGER, ALLOCATABLE, SAVE :: IPROUT ( :,: )  ! ( N_IPR_SPC,NPRCS )
      INTEGER, ALLOCATABLE, SAVE :: IPR2GRD( :,: )  ! ( N_IPR_SPC,MXCGRID )
      INTEGER, ALLOCATABLE, SAVE :: IPR2SAV( :,: )  ! ( N_IPR_SPC,MXCGRID )

      REAL,    ALLOCATABLE, SAVE :: SPCOEF ( :,: )  ! ( N_IPR_SPC,MXCGRID )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  The following variables are used in the integrated reaction rate
c  computations.
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c    LFULLIRR     = Flag for computing IRRs for every reaction
c    LPARTIRR     = Flag for computing IRRs for selected reactions
c    NUMOUTPOS    = No. of temp. IRR terms to add iff the IRR > 0
c    NUMOUTNEG    = No. of temp. IRR terms to add iff the IRR < 0
c    NUMOUTIND    = No. of temp. IRR terms to add regardless of sign
c    MXNIRRRXNS   = Max no. of reaction terms in an output IRR
c    MXTEMPTRMS   = Max no. of reaction terms in a temp. IRR
c    NIRRRXNS     = Vector of no. of reaction terms in an output IRR
c    TEMPTERMS    = Vector of no. of terms in a temporary IRR
c    TEMPOUTPOS   = Vector of no. of IRR terms to add if IRR > 0
c    TEMPOUTNEG   = Vector of no. of IRR terms to add if IRR < 0
c    TEMPOUTIND   = Vector of no. of IRR terms to add regardless of sign
c    INDXOUTPOS   = Vector of indices pointing to IRR output variable
c    INDXOUTNEG   = Vector of indices pointing to IRR output variable
c    INDXOUTIND   = Vector of indices pointing to IRR output variable
c    COEFOUTPOS   = Vector of temp IRR coefficients
c    COEFOUTNEG   = Vector of temp IRR coefficients
c    COEFOUTIND   = Vector of temp IRR coefficients
c    NUMTEMPS     = No. of temporary intermediate IRRs to compute
c    TEMPRXN      = Array of reaction nos. for a temp. IRR
c    IRRRXN       = Array of reaction nos. for an output IRR
c    TEMPCOEF     = Array of reaction coefficients for a temp IRR
c    IRRCOEF      = Array of reaction coefficients for an output IRR
c    IRRSTEP      = Array of output IRRs for one time step
c    IRRBLK       = Array of output IRRs for a block of cells
c    IRROUT       = Array of IRRs to output
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c these are set in pa_read.F
      LOGICAL, SAVE :: LFULLIRR = .FALSE.
      LOGICAL, SAVE :: LPARTIRR = .FALSE.

c these are set in pa_setup_irr.F, pa_errcheck.F
      INTEGER, SAVE :: NUMOUTPOS  = 0
      INTEGER, SAVE :: NUMOUTNEG  = 0
      INTEGER, SAVE :: NUMOUTIND  = 0
      INTEGER, SAVE :: MXNIRRRXNS = 0
      INTEGER, SAVE :: NUMTEMPS   = 0
      INTEGER, SAVE :: MXTEMPTRMS = 0

c this is set in the Model`s GRID_CONF
      INTEGER, SAVE :: BLKSIZED = 50

c these are allocated in pa_setup_irr.F
      INTEGER, ALLOCATABLE, SAVE :: NIRRRXNS  ( : )    ! ( NIRRVAR )
      INTEGER, ALLOCATABLE, SAVE :: IRRRXN    ( :,: )  ! ( NIRRVAR,MXNIRRRXNS )
      INTEGER, ALLOCATABLE, SAVE :: TEMPOUTPOS( : )    ! ( NUMOUTPOS )
      INTEGER, ALLOCATABLE, SAVE :: INDXOUTPOS( : )    ! ( NUMOUTPOS )
      INTEGER, ALLOCATABLE, SAVE :: TEMPOUTNEG( : )    ! ( NUMOUTNEG )
      INTEGER, ALLOCATABLE, SAVE :: INDXOUTNEG( : )    ! ( NUMOUTNEG )
      INTEGER, ALLOCATABLE, SAVE :: TEMPOUTIND( : )    ! ( NUMOUTIND )
      INTEGER, ALLOCATABLE, SAVE :: INDXOUTIND( : )    ! ( NUMOUTIND )
      INTEGER, ALLOCATABLE, SAVE :: TEMPTERMS ( : )    ! ( NUMTEMPS )
      INTEGER, ALLOCATABLE, SAVE :: TEMPRXN   ( :,: )  ! ( NUMTEMPS,MXTEMPTRMS )

      REAL,    ALLOCATABLE, SAVE :: COEFOUTPOS( : )    ! ( NUMOUTPOS )
      REAL,    ALLOCATABLE, SAVE :: COEFOUTNEG( : )    ! ( NUMOUTNEG )
      REAL,    ALLOCATABLE, SAVE :: COEFOUTIND( : )    ! ( NUMOUTIND )
      REAL,    ALLOCATABLE, SAVE :: TEMPCOEF  ( :,: )  ! ( NUMTEMPS,MXTEMPTRMS )
      REAL,    ALLOCATABLE, SAVE :: IRRCOEF   ( :,: )  ! ( NIRRVAR,MXNIRRRXNS )
      REAL,    ALLOCATABLE, SAVE :: IRRSTEP   ( :,: )  ! ( BLKSIZED,NIRRVAR )
      REAL,    ALLOCATABLE, SAVE :: IRRBLK    ( :,: )  ! ( BLKSIZED,NIRRVAR )
      REAL,    ALLOCATABLE, SAVE :: IRRDEL    ( : )    ! ( NIRRVAR )
      REAL,    ALLOCATABLE, SAVE :: IRRSUM    ( : )    ! ( NIRRVAR )

      END MODULE PA_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE LOAD_CGRID ( FNAME, SPC_CAT, CMIN, CGRID )

C-----------------------------------------------------------------------
C Function:
C   Initialize the model CGRID array from file data

C Revision history:
C   Jeff - Dec 00 - split out from initscen.F
C                 - move CGRID_MAP into f90 module
C   Jeff - Feb 01 - module LOCALFILE to set CCTM IOAPI file defn's
C                 - add BUFSIZE for dfio option
C                 - assumed shape arrays
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX;
C   30 Oct 01 J.Young: fix ICBC_FAC
C    4 Sep 03 J.Young: fix SPC/NDX bug if ASO4J IC's are unavailable
C   20 Nov 03 J.Young: enable loading RHOJ
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C    2 Sep 11 J.Young: change ICBC_FAC policy to always assigning factor,
C                      if specified, not just if a surrogate is also specified 
C   11 Sep 15 B.Murphy: add condition for no surrogate name
C
C   08 Mar 19 F. Sidi  Split up ICBC_FAC into IC_FAC and BC_FAC for 
C                      tracer namelist only
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C   08 Mar 19 F. Sidi  Split up ICBC_FAC into IC_FAC and BC_FAC for 
C                      tracer namelist only
C   13 Mar 19 D. Wong: Implemented centralized I/O approach
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE RXNS_DATA, ONLY : MECHNAME
      USE AERO_DATA, ONLY : CHECK_AERO_ICBC, N_MODE
      Use CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE

      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      CHARACTER( 16 ) :: FNAME
      INTEGER      JDATE
      INTEGER      JTIME
      CHARACTER( 2 ) :: SPC_CAT
      REAL         CMIN
!     REAL      :: CGRID( :,:,:,: )  ! for initial CONC
      REAL, POINTER :: CGRID( :,:,:,: )  ! for initial CONC

C Parameters:

C minimum aerosol sulfate concentration [ ug/m**3 ]
      REAL, PARAMETER :: AEROCONCMIN = 0.001

C The following two factors assume that sulfate density is 1.8e3 [ kg/m**3 ]
C and that the geometric mean diameter and geometric standard deviations
C for the Aitken mode are 0.01e-6 [ m ] and 1.7 respectively
C and are 0.07e-6 and 2.0 respectively for the accumulation mode.

C factor to calculate aerosol number concentration from aerosol sulfate mass
C concentration in the Aitken mode [ ug ].
      REAL, PARAMETER :: NUMFACT_I = 2.988524 E11

C factor to calculate aerosol number concentration from aerosol sulfate mass
C concentration in the Accumulation mode [ ug ].
      REAL, PARAMETER :: NUMFACT_J = 3.560191 E08

C fraction of sulfuric acid vapor taken as aerosol for first time step
      REAL, PARAMETER :: SO4VAPTOAER = 0.999
C initial fraction of total aerosol sulfate in the Aitken mode
      REAL, PARAMETER :: IFRACATKN = 0.04

      INTEGER, SAVE :: MXSPC
      INTEGER ASTAT

C File variables:

      REAL      :: DENS( NCOLS,NROWS,NLAYS )       ! air density (kg/m^3)
      REAL      :: RHOJ( NCOLS,NROWS,NLAYS ) ! air density X Jacobian (kg/m^2)

C External Functions:

      INTEGER, EXTERNAL :: FINDEX       !  looks up number in table.

C Local Variables

      REAL         MWH2SO4                           ! H2SO4 molec. wt.
      REAL         H2SO4CONV                         ! ppm -> ug/m**3
      INTEGER      LSULF                             ! Gas chem CGRID index
      INTEGER      ISO4AJ, ISO4AI, INUMATKN, INUMACC ! CGRID aerosol indices

      INTEGER      GXOFF, GYOFF               ! global origin offset from file

C for XTRACT3
      INTEGER       :: STRTCOLINI, ENDCOLINI, STRTROWINI, ENDROWINI
      REAL      :: DBUFF( NCOLS,NROWS,NLAYS )
      REAL      :: DBUFF_TMP( NCOLS,NROWS,NLAYS )

      INTEGER      SPC_STRT, SPC_FINI         ! Species Indices
      INTEGER      N_SPCS                     ! no. of species for this call
      INTEGER      NDX                        ! loop copy of INDX
      INTEGER      ISUR                       ! surrogate index
      INTEGER      ISPCS                      ! model species index
      INTEGER, ALLOCATABLE, SAVE :: INDX( : ) ! Variable indices for all IC species
      REAL,    ALLOCATABLE, SAVE :: ICBC_FAC( : ) ! Factor to be applied to ICs
      INTEGER      C, R, L, SPC, V, J         ! loop counters
      INTEGER      ASPC                       ! CGRID RHOJ pointer
      INTEGER      STAT                       ! Status reported by Aerosol Dist Checker

      INTEGER       :: LMODE    !Identifies the problematic mode from
                                !the BC Check routine
      REAL          :: AER_PAR( 2, N_MODE,5 )  !Modal parameter after the BC 
                                               !check (N, dg, sg)
                                               !      (N, M2, M3) - Before
                                               !      (N, M2, M3) - After
      REAL          :: AECON( N_AE_SPC )

      CHARACTER( 16 ) :: PNAME = 'LOAD_CGRID'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: POC_CHK
      CHARACTER( 16 ) :: ICNAME_TMP
      CHARACTER( 16 ) :: CONCMIN
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER(199 ) :: XMSG2 = ' '
      CHARACTER( 40 ) :: CHWARN = 'Domain extents different from model for '
      CHARACTER( 24 ) :: ESTR1 = 'No IC found for species '
      CHARACTER( 34 ) :: ESTR2 = ' '
      CHARACTER( 34 ) :: ESTR3 = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL       :: LSTAT

C-----------------------------------------------------------------------

      JDATE = STDATE
      JTIME = STTIME

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LOG_HEADING( LOGDEV, 'Load Initial Conditions' ) 

         MXSPC = N_GC_SPC + N_AE_SPC + N_NR_SPC + N_TR_SPC
         ALLOCATE ( INDX( MXSPC ), ICBC_FAC( MXSPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'ERROR allocating INDX or ICBC_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
      END IF

      WRITE( CONCMIN,'(1PE9.2)' ) CMIN

      IF ( .NOT. OPEN3( FNAME, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open ' // FNAME // ' file'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
 
      IF ( .NOT. DESC3( FNAME ) ) THEN
         XMSG = 'Could not get ' // FNAME // ' file description'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
 
      IF ( GL_NCOLS .NE. NCOLS3D ) THEN
         WRITE( LOGDEV,* ) ' '
         WRITE( LOGDEV,* ) '    WARNING: ' // CHWARN // FNAME
         WRITE( LOGDEV,* ) '>>  GL_NCOLS: ', GL_NCOLS, '  NCOLS3D: ', NCOLS3D
      END IF
 
      IF ( GL_NROWS .NE. NROWS3D ) THEN
         WRITE( LOGDEV,* ) ' '
         WRITE( LOGDEV,* ) '    WARNING: ' // CHWARN // FNAME
         WRITE( LOGDEV,* ) '>>  GL_NROWS: ', GL_NROWS, '  NROWS3D: ', NROWS3D
      END IF
 
      IF ( NLAYS .NE. NLAYS3D ) THEN
         XMSG = 'Wrong number of layers in ' // FNAME // ' file'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF

      ESTR2 = ' in ' // TRIM( FNAME ) // '; Look for '
      ESTR3 = ' in ' // TRIM( FNAME ) // '; set to ' // TRIM( CONCMIN )

C The original policy for using surrogate names is first, check if the Namelist
C species is on the IC file; if so ignore any surrogate. If the Namelist species
C is not on the IC file, then check if the surrogate name is; if so also use the
C scale factor (default = 1.0).
C Note: parsing in CGRID_SPCS follows this policy for all the Namelist surrogate
C types (EMIS, DEPV, ICBC, and SCAV).
C => Change this for ICBC:
C First check if there's a surrogate name in the Namelist and use it (and the
C corresponding scale factor) if it exists. If it's not on the IC file, which it
C wouldn`t be if it were blank, e.g., then look for the Namelist species name. If
C that name is found on the IC file, then the default scale factor is applied
C (default = 1.0). To use a scale factor other that 1.0, there must be a name in
C the surrogate slot; it could be the same as the Namelist main species name.

C Get INDX
      DO SPC = 1, MXSPC
         INDX( SPC ) = 0
      END DO

      IF ( SPC_CAT .EQ. 'GC' ) THEN
         WRITE( XMSG,1009 ) 'transported gas-phase (reactive) species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = GC_STRT
         N_SPCS = N_GC_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_GC_IC, GC_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
               NDX = INDEX1( GC_IC( ISUR ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
C if there`s a surrogate name, CGRID_SPCS handles setting GC_ICBC_FAC
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = GC_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( GC_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(GC_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cannot be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
               NDX = INDEX1( GC_SPC( SPC ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( GC_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), GC_SPC( SPC ), ICBC_FAC( SPC )

         END DO

      ELSE IF ( SPC_CAT .EQ. 'AE' ) THEN
         WRITE( XMSG,1009 ) 'transported aerosol species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = AE_STRT
         N_SPCS = N_AE_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_AE_IC, AE_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
               NDX = INDEX1( AE_IC( ISUR ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = AE_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( AE_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(AE_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cant be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
               NDX = INDEX1( AE_SPC( SPC ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( AE_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), AE_SPC( SPC ), ICBC_FAC( SPC )
 
         END DO

      ELSE IF ( SPC_CAT .EQ. 'NR' ) THEN
         WRITE( XMSG,1009 ) 'transported non-reactive gas species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = NR_STRT
         N_SPCS = N_NR_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_NR_IC, NR_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
               NDX = INDEX1( NR_IC( ISUR ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = NR_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( NR_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(NR_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cant be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
               NDX = INDEX1( NR_SPC( SPC ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( NR_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), NR_SPC( SPC ), ICBC_FAC( SPC )

         END DO

      ELSE IF ( SPC_CAT .EQ. 'TR' ) THEN
         WRITE( XMSG, 1009 ) 'transported inert tracer gas species'
         WRITE( LOGDEV, * )
         CALL LOG_MESSAGE( LOGDEV, XMSG )
         SPC_STRT = TR_STRT
         N_SPCS = N_TR_SPC
         DO SPC = 1, N_SPCS
C is there a surrogate name?
            ISUR = FINDEX ( SPC, N_TR_IC, TR_IC_MAP )
            NDX = 0
            IF ( ISUR .NE. 0 ) THEN
C is it on the IC file?
               NDX = INDEX1( TR_IC( ISUR ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX   ! index in the IC file
                  ICBC_FAC( SPC ) = TR_IC_FAC( ISUR )
               ELSE
                  XMSG = ESTR1 // TRIM( TR_IC( ISUR ) ) // ESTR2 // 
     &                   TRIM(TR_SPC( SPC ))
                  CALL M3MESG( XMSG )
               END IF
            END IF
C If there is no surrogate or it cant be found, look for the (main) species name on the IC file
            If ( ISUR .EQ. 0 .OR. NDX .EQ. 0 .OR. (.NOT. NEW_START ) ) THEN
               NDX = INDEX1( TR_SPC( SPC ), NVARS3D, VNAME3D )
               IF ( NDX .NE. 0 ) THEN
                  INDX( SPC ) = NDX
                  ICBC_FAC( SPC ) = 1.0
               ELSE
                  XMSG = ESTR1 // TRIM( TR_SPC( SPC ) ) // ESTR3
                  CALL M3MESG( XMSG )
               END IF
            END IF

            IF ( INDX( SPC ) .GT. 0 )
     &         WRITE( LOGDEV,1013 ) INDX( SPC ), TR_SPC( SPC ), ICBC_FAC( SPC )

         END DO

      ELSE IF ( SPC_CAT .EQ. 'RJ' ) THEN
         N_SPCS = 0
      ELSE
         XMSG = 'Species categories incorrect for CGRID '
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
      END IF
        
C Read into CGRID

!     CALL SUBHFILE ( FNAME, GXOFF, GYOFF,
!    &                STRTCOLINI, ENDCOLINI, STRTROWINI, ENDROWINI )
C IOFDESC common now loaded with FNAME header

      DO SPC = 1, N_SPCS
         V = SPC_STRT - 1 + SPC
         NDX = INDX( SPC )

         IF ( NDX .GT. 0 ) THEN
            call interpolate_var (VNAME3D ( NDX ), jdate, jtime, DBUFF)

            ! Add Non-Carbon Mass to Carbon Mass if any tracer is
            ! pointing to POC as a surrogate. It is very likely that
            ! these tracers are seeking the entire POA mass (e.g.
            ! semivolatile POA tracers).
            POC_CHK = 'NOTPOC'
            IF ( SPC_CAT .EQ. 'AE' ) POC_CHK = AE_SPC( SPC )

            IF ( VNAME3D( NDX )( 1:4 ) .EQ. 'APOC' .AND.
     &           POC_CHK(1:4) .NE. 'APOC' ) THEN 
               ICNAME_TMP = 'APNCOM' // VNAME3D( NDX )( 5:5 )
               call interpolate_var (ICNAME_TMP, jdate, jtime, DBUFF_TMP)
               DBUFF = DBUFF + DBUFF_TMP
            END IF

            ! Load ICs into CGRID
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,V ) = ICBC_FAC( SPC ) * DBUFF( C,R,L )
                  END DO
               END DO
            END DO

         END IF   ! INDX .GT. 0

      END DO
 

      !IF ( N_SPCS .NE. 0 ) WRITE( LOGDEV,'(/ 5X, A)' )
      !&                            SPC_CAT // ' loaded into CGRID'

      IF ( SPC_CAT .EQ. 'RJ' ) THEN

C Load RHOJ for transport and mixing ratio advection adjustment

         call interpolate_var ('DENSA_J', jdate, jtime, RHOJ)

         ASPC = GC_STRT - 1 + N_GC_SPCD
         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  CGRID( C,R,L,ASPC ) = RHOJ( C,R,L )
               END DO
            END DO
         END DO

         !WRITE( LOGDEV,'(/ 5X, A)' ) 'Density*Jacobian loaded into CGRID'


      END IF

      IF ( SPC_CAT .EQ. 'AE' ) THEN
         CALL LOG_SUBHEADING( LOGDEV, 'Check Aerosol IC Size Distributions' )

         ! Check Aerosol Size Distributions and Warn the User if They Are Not Robust
         IF ( NEW_START ) THEN
           SPC_STRT = AE_STRT
           SPC_FINI = AE_STRT + N_AE_SPC - 1
           LSTAT    = .FALSE.
           DO L = 1, NLAYS
           DO R = 1, NROWS
           DO C = 1, NCOLS
              AECON( 1:N_AE_SPC ) = CGRID( C,R,L,SPC_STRT:SPC_FINI )
              CALL CHECK_AERO_ICBC( AECON, .TRUE., STAT, AER_PAR, LMODE )
              CGRID( C,R,L,SPC_STRT:SPC_FINI ) = AECON( 1:N_AE_SPC )
              IF ( STAT .GT. 0 ) THEN
                 LSTAT = .TRUE.
#ifdef verbose_loadcgrid
                 WRITE ( 6, '(7x,A55,I1,/,7x,A20,I1,A42,/,9x,A51,/,9x,A24,I3,2x,I3,2x,I2,/,
     &                 9x,A19,1x,A3,8x,A2,8x,A2,8x,A2,8x,A2,/,
     &                 27x,E8.1,1x,E8.1,1x,E8.1,1x,E8.1,4x,F4.1,/,
     &                 9x,A19,1x,A3,8x,A2,8x,A2,8x,A2,8x,A2,/,
     &                 27x,E8.1,1x,E8.1,1x,E8.1,1x,E8.1,4x,F4.1)'),
     &               'Warning: Applying Aerosol Initial Conditions for mode ',LMODE,
     &               'The Offending Mode (',LMODE,') had diameter and/or sigma out of bounds.',
     &               'It was overwritten by changing the Num and SrfArea.',
     &               'Grid Cell(Col,Row,Lay): ',C,R,L,
     &               'Modal Props Before:','Num','M2','M3','Dg','Sg',(AER_PAR(1,LMODE,j),j=1,5),
     &               'Modal Props After: ','Num','M2','M3','Dg','Sg',(AER_PAR(2,LMODE,j),j=1,5)
#endif
              ENDIF
           END DO
           END DO
           END DO

           !Print warning if any aerosol ICs violated the size distribution parameters
           IF ( LSTAT ) THEN    
               WRITE( XMSG2, '(A)' ),
     &            'ATTENTION: Applying fix to aerosol Initial' //
     &            ' Conditions for aerosol modes.' //
     &            ' Set verbose_loadcgrid preprocessor flag to' //
     &            ' learn more.'
               CALL LOG_MESSAGE( LOGDEV, XMSG2 )
           END IF
         END IF

C are ASO4J ICs available on the file?

         VNAME = 'ASO4J'
         NDX = INDEX1( VNAME, NVARS3D, VNAME3D )
     
         IF ( NDX .EQ. 0 ) THEN  ! ASO4J not on file

C Set pointers for gas (vapor) phase sulfur species

            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               ISO4AJ = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            VNAME = 'SULF'
            NDX = INDEX1( VNAME, N_GC_G2AE, GC_G2AE )
            IF ( NDX .NE. 0 ) THEN
               LSULF   = GC_STRT - 1 + GC_G2AE_MAP( NDX )
               MWH2SO4 = GC_MOLWT( GC_G2AE_MAP( NDX ) )
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in gas chem aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            VNAME = 'ASO4I'
            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               ISO4AI = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF
            VNAME = 'NUMATKN'
            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               INUMATKN = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF
            VNAME = 'NUMACC'
            NDX = INDEX1( VNAME, N_AE_SPC, AE_SPC )
            IF ( NDX .NE. 0 ) THEN
               INUMACC = AE_STRT - 1 + NDX
            ELSE
               XMSG = 'Could not find ' // VNAME // 'in aerosol table'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            END IF

            call interpolate_var ('DENS', jdate, jtime, DENS)

C Partition the aerosol sulfate arrays with a fraction of the initial SO4 

            H2SO4CONV = 1.0E3 * MWH2SO4 / MWAIR * SO4VAPTOAER

            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS

C total accumulation mode sulfate:

                     CGRID( C,R,L,ISO4AJ )   = MAX ( AEROCONCMIN,
     &                                         ( 1.0 - IFRACATKN )
     &                                       * H2SO4CONV
     &                                       * DENS ( C,R,L )
     &                                       * CGRID( C,R,L,LSULF ) )

C Accumulation mode number:
    
                     CGRID( C,R,L,INUMACC )  = NUMFACT_J
     &                                       * CGRID( C,R,L,ISO4AJ )

C Aitken mode sulfate:
    
                     CGRID( C,R,L,ISO4AI )   = MAX ( AEROCONCMIN,
     &                                         IFRACATKN
     &                                       * H2SO4CONV
     &                                       * DENS ( C,R,L )
     &                                       * CGRID( C,R,L,LSULF ) )
    
C Aitken mode number:
    
                     CGRID( C,R,L,INUMATKN ) = NUMFACT_I
     &                                       * CGRID( C,R,L,ISO4AI )
    
C correct sulfate vapor concentration for part removed:
    
                     CGRID( C,R,L,LSULF )    = ( 1.0 - SO4VAPTOAER )
     &                                       * CGRID( C,R,L,LSULF)
    
                  END DO
               END DO
            END DO

            XMSG = 'No IC''s found for aerosol sulfate. ' //
     &             'Gas Chem sulfate used for partitioning.'
            CALL M3MESG( XMSG )

         END IF  ! NDX .EQ. 0

      END IF  !  SPC_CAT .EQ. 'AE'

      RETURN

1009  FORMAT( 'Initial Condition Factors used for ', A )
1013  FORMAT( 5X, I3, 2X, A, 1PG13.5 )
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module dust_emis
     
C-----------------------------------------------------------------------
C Description:
C * Extracts selected landuse categories from BELD01 and BELD03 and merges
C * the selections into a dust-related landuse array (ULAND).

C   Optionally, reads 3 gridded crop calendar file and calculates an
C   erodible agriculture land fraction. (cropcal)

C * Applies a predetermined removal fraction in and below canopy to
C * ULAND and determines a transport factor (TFB) for this regime.
C * = applies to tfbelow

C Function: 3d point source emissions interface to the chemistry-transport model

C Revision History:
C 16 Dec 10 J.Young: Adapting Daniel Tong`s work on windblown dust
C 21 Apr 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C 11 May 11 D.Wong: incorporated twoway model implementation
C  8 Jul 11 J.Young: unified string lengths in character lists for compiler compatibility
C 11 Nov 11 J.Young: generalizing land use/cover
C  8 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C 13 Jul 12 J.Young: following Daniel Tong: changed clayc, siltc, sandc units from mass
C                    fraction to %; adjusted F/G (vertical to horizontal flux) ratio
C                    to be continuous for clay content > 20%
C 30 Sep 13 J.Young: corrected diag file units description; added snow cover adjustment;
C                    adjusted F/G (vertical to horizontal flux) ratio to be continuous
C                    for clay content > 0.2; convert volumetric soil moisture to
C                    gravimetric water content; corrected soil moisture factor (fmoit);
C                    use lwmask>0 rather than sltyp>0 (non-existent) for over water test
C 15 Sep 15 H.Foroutan: revised threshold friction velocity parameterization
C 20 Oct 15 H.Foroutan: Updated the calculation of the threshold velocity(U*t), which is
C                       now based on dust particle size, following Shao and Lu [JGR,2000].
C                       Implemented a dynamic vegetation fraction based on the MODIS FPAR.
C                       Introduced a new parametrization for surface roughness (z0)
C                       applicable to dust emission schemes, and accordingly calculated
C                       the friction velocity (U*) at the surface using 10m wind speed
C                       and the new (microspcopic) surface roughness.
C                       Surface roughness adjusted for estimated annual vegetation height.
C                       Included drag partitioning coefficient. Updated the calculation of
C                       the vertical-to-horizontal flux based on Lu and Shao [JGR,1999].
C                       Updated the dust diag output file accordingly.
C  8 Jan 16 J.Young: Changes for computational efficiency
C  2 Feb 16 J.Young: move dust aero speciation table to AERO_DATA
C  01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all MY_N clauses
C  9 Jul 19 Gilliam: Removed a lot of old commented out legacy tables. 
C                    Removed the direct read of FPAR MODIS file as this data comes 
C                    directly from WRF LSM models that have access to MODIS veg data now.
C                    Number of soil types fixed to 16 to match WRF and tables updated.
C-----------------------------------------------------------------------
      use lus_defn
      use aero_data
      use emis_vars

      implicit none 

      public ndust_spc, dust_spc,
     &       dust_emis_init, get_dust_emis
      private

      real, allocatable, save :: dust_em( :,: )  ! total dust emissions [g/m**3/s]

C updated values of mass fraction for "freshly emitted dust"
C based on Kok [PNAS, 2011] and Nabat et al. [ACP, 2012]
      real, parameter :: fracmj = 0.07  ! mass fraction assigned to accum mode
      real, parameter :: fracmk = 0.93  ! mass fraction assigned to coarse mode

C diam`s from fracmj,fracmk-weighted 2 2-bin averages of geom means
C 2 J-mode bins: 0.1-1.0, 1.0-2.5 um
C 2 K-mode bins: 2.5-5.0, 5.0-10.0 um
      real, parameter :: dgvj = 1.3914  ! geom mean diam of accum mode [um]
      real, parameter :: dgvk = 5.2590  ! geom mean diam of coarse mode [um]
      real, parameter :: sigj = 2.0000  ! geom std deviation of accum mode flux
      real, parameter :: sigk = 2.0000  ! geom std deviation of coarse mode flux

C Local Variables:

C Factors for converting 3rd moment emission rates into number and 2nd moment
C emission rates.  (Diameters in [um] changed to [m] ) See Equations 7b and 7c
C of Binkowski & Roselle (2003)
      real       :: l2sgj    ! [ln( sigj )] ** 2
      real       :: l2sgk    ! [ln( sigk )] ** 2
      real, save :: factnumj ! = exp( 4.5 * l2sgj ) / dgvj ** 3 * 1.0e18
      real, save :: factnumk ! = exp( 4.5 * l2sgk ) / dgvk ** 3 * 1.0e18
      real, save :: factm2j  ! = exp( 0.5 * l2sgj ) / dgvj * 1.0e6
      real, save :: factm2k  ! = exp( 0.5 * l2sgk ) / dgvk * 1.0e6
      real, save :: factsrfj ! = pi * factm2j
      real, save :: factsrfk ! = pi * factm2k

      real       :: sumsplit, sumfrac
      integer    :: n, idx

C Number of soil types: For WRF there are 16 types;
      integer, parameter :: nsltyp = 16

C Variables for the windblown dust diagnostic file:
      integer, parameter :: fndust_diag = 19 ! number of fixed diagnostic output vars
      integer, save      :: ndust_diag       ! number of diagnostic output vars
      real, allocatable, save :: diagv( : )  ! diagnostic output variables
      real, allocatable, save :: dustbf( :,:,: ) ! diagnostic accumulate buffer

#ifdef verbose_wbdust
      real, allocatable, save :: sdiagv( : )  ! global sum of each diag output var
#endif

      type diag_type
         character( 16 ) :: var
         character( 16 ) :: units
         character( 80 ) :: desc
      end type diag_type

      type( diag_type ), allocatable, save :: diagnm( : )
      type( diag_type ), allocatable, save :: vdiagnm_emis( : )
      type( diag_type ), allocatable, save :: vdiagnm_frac( : )
      type( diag_type ), allocatable, save :: vdiagnm_ustar( : )
      type( diag_type ), allocatable, save :: vdiagnm_kvh( : )
      type( diag_type ), allocatable, save :: vdiagnm_rough( : )

      character( 10 ) :: truncnm
      character( 16 ) :: vnm

      type( diag_type ), parameter :: fdiagnm( fndust_diag ) = (/
C                      var              units                 desc
C                 ----------------    --------    -------------------------------------------
     & diag_type( 'Cropland_Emis   ', 'g m-3 s-1', 'emissions for cropland landuse type        '),
     & diag_type( 'Desertland_Emis ', 'g m-3 s-1', 'total emis for desert types and cropland   '),
     & diag_type( 'Cropland_Frac   ', 'percent  ', 'cropland erodible landuse fraction (%)     '),
     & diag_type( 'Desertland_Frac ', 'percent  ', 'total desert fraction (%)                  '),
     & diag_type( 'Cropland_Ustar  ', 'm s-1    ', 'u* for cropland                            '),
     & diag_type( 'Cropland_kvh    ', 'm-1      ', 'cropland vert to horiz flux ratio          '),
     & diag_type( 'Cropland_Rough  ', '         ', 'cropland surface roughness factor          '),
     & diag_type( 'Soil_Moist_Fac  ', '         ', 'soil moisture factor for threshold u*      '),
     & diag_type( 'Soil_Erode_Pot  ', '1        ', 'soil -> dust erodiblity potential          '),
     & diag_type( 'Mx_Adsrb_H2O_Frc', '1        ', 'max adsorbed water fraction                '),
     & diag_type( 'Vegetation_Frac ', '1        ', 'vegetation land coverage                   '),
     & diag_type( 'Urban_Cover     ', 'percent  ', 'urban land coverage                        '),
     & diag_type( 'Forest_Cover    ', 'percent  ', 'forest land coverage                       '),
     & diag_type( 'Trfac_Above_Can ', '         ', 'transport factor above canopy              '),
     & diag_type( 'Trfac_Inside_Can', '         ', 'transport factor in and below canopy       '),
     & diag_type( 'ANUMJ           ', 's-1', 'accumulation mode number                   '),
     & diag_type( 'ANUMK           ', 's-1', 'coarse mode number                         '),
     & diag_type( 'ASRFJ           ', 'm2 s-1   ', 'accumulation mode surface area             '),
     & diag_type( 'ASRFK           ', 'm2 s-1   ', 'coarse mode surface area                   ')/)
  
C Module shared variables:
      real, allocatable, save :: agland( :,: )   ! agriculture land fraction
      real, allocatable, save :: wmax  ( :,: )   ! max adsorb water percent
      real, allocatable, save :: kvh   ( :,:,: ) ! ratio of vertical flux / horizontal (k factor)
      real, allocatable, save :: sd_ep ( :,: )   ! soil->dust erodiblity potential
      real, allocatable, save :: tfb   ( :,: )   ! transport fraction in and below canopy

      real :: eropot( 3 ) =     ! erodible potential of soil components
     &        (/ 0.08,   ! clay
     &           1.00,   ! silt
     &           0.12 /) ! sand

      CONTAINS

C=======================================================================
         function dust_emis_init( jdate, jtime, tstep ) result( success )

C Revision History.
C   Aug 12, 15 D. Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
C   implementation

         use hgrd_defn        ! horizontal domain specifications
         use aero_data        ! aerosol species definitions
         use asx_data_mod     ! meteorology data
         use utilio_defn
         use lus_data_module
         use centralized_io_module

C Arguments:
         integer, intent( in ) :: jdate   ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime   ! current model time, coded HHMMSS
         integer, intent( in ) :: tstep   ! output time step
         logical      success

C Includes:
         include SUBST_FILES_ID  ! file name parameters

C Local variables:
         character( 16 ) :: pname = 'DUST_EMIS_INIT'
         character( 16 ) :: vname
         character( 80 ) :: vardesc
         character( 250 ) :: xmsg = ' '

         integer status
         integer c, r, i, j, k, l, n, im
         integer idiag, idust, spc
         integer n_mass_emissions

         character( 16 ) :: sn

         type( diag_type ), allocatable :: diagnm_swap( : )

         interface
            subroutine cropcal ( jdate, jtime, agland )
            integer, intent( in )  :: jdate, jtime
            real,    intent( out ) :: agland( :,: )
            end subroutine cropcal
            subroutine tfbelow ( jdate, jtime, tfb )
            integer, intent( in )  :: jdate, jtime
            real,    intent( out ) :: tfb( :,: )
            end subroutine tfbelow
         end interface

C-----------------------------------------------------------------------

         success = .true.

         CALL LOG_MESSAGE( LOGDEV, 'Initialize Wind-Blown Dust Emissions' )

C...Populate Master Emissions Map Vector So That Diagnostics 
C   can be printed in EMIS_MAP
         Em_File_Surr( IDUSTSRM )%len = ndust_spc*2
         Allocate( Em_File_Surr( IDUSTSRM )%arry( ndust_spc*2 ) )
         Allocate( Em_File_Surr( IDUSTSRM )%units( ndust_spc*2 ) )
         Allocate( Em_File_Surr( IDUSTSRM )%mw   ( ndust_spc*2 ) )
         Allocate( Em_File_Surr( IDUSTSRM )%used ( ndust_spc*2 ) )
         Allocate( Em_File_Surr( IDUSTSRM )%conv ( ndust_spc*2 ) )
         Allocate( Em_File_Surr( IDUSTSRM )%basis( ndust_spc*2 ) )
         Em_File_Surr( IDUSTSRM )%arry( : ) = 'NOT_AVAILABLE'
         do i = 1,ndust_spc
            IF ( dust_spc( i )%spcfac(1) .NE. 0.0 ) 
     &         Em_File_Surr( IDUSTSRM )%arry( i )  = 
     &                    'PMFINE_' // dust_spc(i)%name
            IF ( dust_spc( i )%spcfac(2) .NE. 0.0 ) 
     &         Em_File_Surr( IDUSTSRM )%arry( i+ndust_spc )  = 
     &                    'PMCOARSE_' // dust_spc(i)%name
            Em_File_Surr( IDUSTSRM )%mw( i )  = dust_spc(i)%mw
            Em_File_Surr( IDUSTSRM )%mw( i+ndust_spc )  = dust_spc(i)%mw
         end do
         Em_File_Surr( IDUSTSRM )%units( : ) = 'G/S'
         Em_File_Surr( IDUSTSRM )%used ( : ) = .FALSE.
         Em_File_Surr( IDUSTSRM )%conv ( : ) = 1.0
         Em_File_Surr( IDUSTSRM )%basis( : ) = 'MASS'
 
C...Count the number of mass emissions species
        n_mass_emissions = 0
        do i = 1, ndust_spc
           do j = 1, 2
              if( dust_spc( i )%spcfac( j )  .gt. 0. ) 
     &               n_mass_emissions = n_mass_emissions + 1  
           end do
        end do                     
        allocate ( dustoutm( ndust_spc*2,ncols,nrows ),
     &              dustoutn( 2,ncols,nrows ),
     &              dustouts( 2,ncols,nrows ), stat = status )
         if ( status .ne. 0 ) then
            xmsg = '*** Failure allocating DUSTOUTM, DUSTOUTN, or DUSTOUTS'
            call m3warn ( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if

C Allocate emissions array
         allocate( dust_em( ncols,nrows ), stat = status )
         if ( status .ne. 0 ) then
            xmsg = '*** Failure allocating DUST_EM'
            call m3warn( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if

C Allocate private arrays
         allocate( agland( ncols,nrows ),
     &             wmax  ( ncols,nrows ),
     &             sd_ep ( ncols,nrows ),
     &             tfb   ( ncols,nrows ), stat = status )
         if ( status .ne. 0 ) then
            xmsg = '*** Failure allocating AGLAND, WMAX, SD_EP, or TFB'
            call m3warn( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if
         agland = 0.0   ! array assignment
         wmax   = 0.0   ! array assignment
         sd_ep  = 0.0   ! array assignment

C Initialize land use/cover variables
         if ( .not. lus_init( jdate, jtime ) ) then
            xmsg = 'Failure initializing land use module'
            call m3exit( pname, jdate, jtime, xmsg, xstat2 )
         end if

         if ( dustem_diag ) then    ! Open the emissions diagnostic file

C Set up variable diagnostic names (from LUS_DEFN)
            allocate( vdiagnm_emis ( n_dlcat ),
     &                vdiagnm_frac ( n_dlcat ),
     &                vdiagnm_kvh  ( n_dlcat ),
     &                vdiagnm_rough( n_dlcat ),
     &                vdiagnm_ustar( n_dlcat ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating VDIAGNM_*'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            vdiagnm_emis  = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_frac  = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_ustar = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_kvh   = diag_type( ' ', ' ', ' ' )  ! array assignment
            vdiagnm_rough = diag_type( ' ', ' ', ' ' )  ! array assignment

C...Set Up Diagnostic Species Variables
            ndust_diag = fndust_diag + 5 * n_dlcat + n_mass_emissions 

            do i = 1, n_dlcat
               truncnm = vnmld( i )%desc   ! char( 10 )
C...           replace embedded spaces (within 16 chars) with "_"
C...           replace embedded dashes (within 16 chars) with "_"
               l = len_trim( truncnm )
               do k = 1, l
                  if ( truncnm( k:k ) .eq. " " .or.
     &                 truncnm( k:k ) .eq. "-" ) truncnm( k:k ) = "_"
               end do
               vnm = trim( truncnm ) // '_Emis'    ! char( 16 )
               vdiagnm_emis( i ) = diag_type( vnm, 'g/m**2/s', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Frac'    ! char( 16 )
               vdiagnm_frac( i ) = diag_type( vnm, 'percent', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Ustr'    ! char( 16 )
               vdiagnm_ustar( i ) = diag_type( vnm, 'm/s', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Kvh'    ! char( 16 )
               vdiagnm_kvh( i ) = diag_type( vnm, '1/m', vnmld( i )%desc )
               vnm = trim( truncnm ) // '_Rough'    ! char( 16 )
               vdiagnm_rough( i ) = diag_type( vnm, '   ', vnmld( i )%desc )
            end do

C Allocate diagnostic emissions arrays
            allocate( diagnm( ndust_diag ),    ! diag_type
     &                diagv ( ndust_diag ),
     &                dustbf( ndust_diag,ncols,nrows ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating DIAGNM, DIAGV or DUSTBF'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

#ifdef verbose_wbdust
            allocate( sdiagv( ndust_diag ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating SDIAGV'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
#endif

C Build the complete diagnostic name array                     n for MODIS NOAH
            do i = 1, n_dlcat                                ! 4
               diagnm( i ) = vdiagnm_emis( i )
            end do
            n = n_dlcat + 1
            diagnm( n ) = fdiagnm( 1 )    ! Cropland_Emis
            n = n + 1
            diagnm( n ) = fdiagnm( 2 )    ! Desertland_Emis

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_frac( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 3 )    ! Cropland_Frac
            n = n + 1
            diagnm( n ) = fdiagnm( 4 )    ! Desertland_Frac

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_ustar( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 5 )    ! Cropland_Ustar

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_kvh( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 6 )    ! Cropland_Kvh

            do i = 1, n_dlcat
               diagnm( i+n ) = vdiagnm_rough( i )
            end do
            n = n + n_dlcat + 1
            diagnm( n ) = fdiagnm( 7 )    ! Cropland_Rough

            n = n - 7                     ! add remaining variables in fdiagnm
            do i = 8, fndust_diag 
               idiag = i+n
               diagnm( idiag ) = fdiagnm( i )
            end do

C...append diagnostic variables with mass emissions species
            do j = 1, 2
               do i = 1, ndust_spc
                  if( dust_spc( i )%spcfac( j ) .eq. 0. ) cycle 
                    n = 0
                    do k = 1, idiag   ! determine if dust emissions is already added to diagnostic output
                       if( trim( EM_FILE_SURR( IDUSTSRM )%ARRY( (j-1)*ndust_spc+i )) 
     &                     .Eq. diagnm( k )%var ) Then
                         n = k
                         exit
                     end if
                  end do
                  if( n .gt. 0  ) cycle ! skip already added 
                  
                  idiag = idiag + 1
                  diagnm( idiag )%var = EM_FILE_SURR( IDUSTSRM )%ARRY( (j-1)*ndust_spc+i ) 
                  diagnm( idiag )%units = 'g/m**3/s'

                  Select Case( j ) ! assumes only two aerosol modes dust emissions
                     Case( 1 )
                        diagnm( idiag )%desc = 'fine mode' 
                     Case( 2 )
                        diagnm( idiag )%desc = 'coarse mode' 
                  end Select
                  diagnm( idiag )%desc = Trim( diagnm( idiag )%desc )
     &                                   // ' emissions for '  
     &                                   // Trim( dust_spc( i )%description )
               end do
            end do
            
! remove unused space in diagnm by deallocated and reallocating to idiag value
            allocate( diagnm_swap( ndust_diag ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating DIAGNM_SWAP'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            diagnm_swap = diagnm 

            deallocate( diagnm )

            ndust_diag = idiag
            allocate( diagnm( ndust_diag ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure reallocating DIAGNM'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            diagnm( 1:ndust_diag ) = diagnm_swap( 1:ndust_diag )
            deallocate( diagnm_swap )

            if ( io_pe_inclusive )
     &         call opdust_emis ( stdate, sttime, tstep, ndust_diag, diagnm )

         end if   ! dustem_diag


         if ( erode_agland ) then
            call cropcal ( stdate, sttime, agland )
            do r = 1, nrows
            do c = 1, ncols
               if ( agland( c,r ) .lt. 0.0 .or. agland( c,r ) .gt. 100.0 ) then
                  xmsg = '*** ERROR in AGLAND'
                  call m3exit( pname, jdate, jtime, xmsg, xstat1 )
               end if
            end do
            end do
         end if

C Get transport factor within canopy and 4 land use type percents
         call tfbelow ( jdate, jtime, tfb )

         l2sgj = log( sigj ) * log( sigj )
         l2sgk = log( sigk ) * log( sigk )

C Factors for converting 3rd moment emission rates into number and 2nd moment
C emission rates.  (Diameters in [um] changed to [m] ) See Equations 7b and 7c
C of Binkowski & Roselle (2003)
         factnumj = 1.0e18 * exp( 4.5 * l2sgj ) / dgvj ** 3
         factnumk = 1.0e18 * exp( 4.5 * l2sgk ) / dgvk ** 3
         factm2j  = 1.0e06 * exp( 0.5 * l2sgj ) / dgvj
         factm2k  = 1.0e06 * exp( 0.5 * l2sgk ) / dgvk
         factsrfj = pi * factm2j
         factsrfk = pi * factm2k

#ifdef verbose_wbdust
         write( logdev,* ) ' '
         write( logdev,* ) '    l2sgj,l2sgk:         ', l2sgj, l2sgk
         write( logdev,* ) '    factnumj,factnumk:   ', factnumj, factnumk
         write( logdev,* ) '    factm2j,factm2k:     ', factm2j, factm2k
         write( logdev,* ) '    factsrfj,factsrfk:   ', factsrfj, factsrfk
         write( logdev,* ) ' '
#endif

         end function dust_emis_init

C=======================================================================
         subroutine opdust_emis ( jdate, jtime, tstep, ndust_var, dust_var )

C   27 Dec 10 J.Young: initial

         use grid_conf           ! horizontal & vertical domain specifications
         use utilio_defn

         implicit none

         include SUBST_FILES_ID  ! file name parameters

C Arguments:
         integer, intent( in ) :: jdate      ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime      ! current model time, coded HHMMSS
         integer, intent( in ) :: tstep      ! output time step
         integer, intent( in ) :: ndust_var
         type( diag_type ), intent( in ) :: dust_var( : )

C Local variables:
         character( 16 ) :: pname = 'OPDUST_EMIS'
         character( 96 ) :: xmsg = ' '

         integer      v, l       ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update
         if ( .not. open3( ctm_dust_emis_1, fsrdwr3, pname ) ) then
            xmsg = 'Could not open CTM_DUST_EMIS_1 for update - '
     &           // 'try to open new'
            call m3mesg( xmsg )

C Set output file characteristics based on COORD.EXT and open diagnostic file
            ftype3d = grdded3
            sdate3d = jdate
            stime3d = jtime
            tstep3d = tstep
            call nextime( sdate3d, stime3d, tstep3d ) !  start the next hour

            nvars3d = ndust_var
            ncols3d = gl_ncols
            nrows3d = gl_nrows
            nlays3d = 1
            nthik3d = 1
            gdtyp3d = gdtyp_gd
            p_alp3d = p_alp_gd
            p_bet3d = p_bet_gd
            p_gam3d = p_gam_gd
            xorig3d = xorig_gd
            yorig3d = yorig_gd
            xcent3d = xcent_gd
            ycent3d = ycent_gd
            xcell3d = xcell_gd
            ycell3d = ycell_gd
            vgtyp3d = vgtyp_gd
            vgtop3d = vgtop_gd
!           vgtpun3d = vgtpun_gd ! currently, not defined
            do l = 1, nlays3d + 1
               vglvs3d( l ) = vglvs_gd( l )
            end do
            gdnam3d = grid_name  ! from HGRD_DEFN

            do v = 1, nvars3d
               vtype3d( v ) = m3real
               vname3d( v ) = dust_var( v )%var
               units3d( v ) = dust_var( v )%units
               vdesc3d( v ) = dust_var( v )%desc
            end do

            fdesc3d( 1 ) = 'windblown dust parameters, variables, and'
            fdesc3d( 2 ) = 'hourly layer-1 windblown dust emission rates'
            do l = 3, mxdesc3
               fdesc3d( l ) = ' '
            end do

C Open windblown dust emissions diagnostic file
            if ( .not. open3( ctm_dust_emis_1, fsnew3, pname ) ) then
               xmsg = 'Could not create the CTM_DUST_EMIS_1 file'
               call m3exit( pname, sdate3d, stime3d, xmsg, xstat1 )
            end if

         end if

         return

         end subroutine opdust_emis

C=======================================================================
         subroutine get_dust_emis( jdate, jtime, tstep, rjacm, cellhgt )

         use grid_conf        ! horizontal & vertical domain specifications
         use asx_data_mod     ! meteorology data
         use aero_data
         use utilio_defn
         use lus_data_module

C       8/18/11 D.Wong: incorporated twoway model implementation and change
C                       RC -> RCA and RN -> RNA and made it backward compatible
C       8/12/15 D.Wong: added code to handle parallel I/O implementation

C Arguments:
         integer, intent( in ) :: jdate      ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime      ! current model time, coded HHMMSS
         integer, intent( in ) :: tstep( 3 ) ! output time step, sync step, 2way step
         real,    intent( in ) :: rjacm( ncols,nrows ) ! reciprocal Jacobian [1/m]
         real,    intent( in ) :: cellhgt    ! grid-cell height [sigma]

C Includes:
         include SUBST_FILES_ID  ! file name parameters

C External Functions:
               
C Parameters:
         integer, parameter :: ndp = 4     ! number of soil texture type particle sizes:
                                           !  1  Coarse sand
                                           !  2  Fine-medium sand
                                           !  3  Silt
                                           !  4  Clay

         real, parameter :: f6dpi = 6.0 / pi

         real, parameter :: mv    = 0.16
         real, parameter :: sigv  = 1.45
         real, parameter :: betav = 202.0
         real, parameter :: sigv_mv  = sigv * mv   ! = 0.232
         real, parameter :: betav_mv = betav * mv  ! = 32.32
         real, parameter :: mb    = 0.5
         real, parameter :: sigb  = 1.0
         real, parameter :: betab = 90.0
         real, parameter :: sigb_mb  = sigb * mb   ! = 0.5
         real, parameter :: betab_mb = betab * mb  ! = 45.0

         character( 16 ) :: pname = 'GET_DUST_EMIS'
         character( 16 ) :: vname
         character( 96 ) :: xmsg
         integer status
         integer c, r, j, m, n, v, isd

         integer, save   :: wstep = 0      ! local write counter
         integer         :: mdate, mtime   ! diagnostic file write date&time

                       ! automatic arrays
         real       :: fmoit  ( ncols,nrows )      ! factor of soil moisture on u*t
         real       :: soimt  ( ncols,nrows )      ! gravimetric soil moisture (Kg/Kg)
         real       :: tfa    ( ncols,nrows )      ! transport fraction above canopy
         real       :: wrbuf  ( ncols,nrows )      ! diagnositc write buffer
         real       :: vegfrac( ncols,nrows )      ! vegetation fraction
         real       :: vegfree                     ! 1.0 - vegfrac for this col, row
         real       :: lai    ( ncols,nrows )      ! leaf area index

         real, allocatable, save :: ustr  ( :,:,: ) ! U* [m/s]
         real, allocatable, save :: qam   ( :,:,: ) ! emis for landuse type [g/m**2/s]
         real, allocatable, save :: elus  ( :,:,: ) ! erodible landuse percent (0~100)
         real, allocatable, save :: fruf  ( :,:,: ) ! surface roughness factor

         real       :: edust( 2 )       ! mass emis rate [g/s] per mode (only accum & coarse)
         real       :: sumdfr           ! sum var for desert fraction
         real       :: rlay1hgt         ! reciprocal of layer-1 height [1/m]
         real       :: m3j              ! 3rd moment accumulation (J) mode emis rates [m3/m3/s]
         real       :: m3k              ! 3rd moment coarse mode (K) emis rates [m3/m3/s]
         real       :: fruf2            ! surface roughness factor squared

         character( 16 ), save :: rc_name, rn_name    ! new names: RC -> RCA, RN -> RNA
         logical, save :: firstime = .true.

         real       :: lambda, vegheight
         real       :: z0
         real       :: lambdav           ! vegetation roughness density - Shao et. al [Aus. J. Soil Res., 1996]
         real       :: flxfac1, flxfac2  ! combined soli type mapping factors
         real       :: hflux, vflux      ! horizontal and vertical dust flux
         real       :: jday
         integer    :: emap( n_dlcat+1 )

C---Height for veg elements
         real :: hv( 4 )

C---Roughness density for solid elements
C from Darmenova et al. [JGR,2009] and Xi and Sokolik [JGR,2015]
        real :: lambdab( 4 ) =
     &           (/ 0.03,     ! shrubland
     &              0.04,     ! shrubgrass
     &              0.0001,   ! barrenland
     &              0.15 /)   ! cropland

C---Compound for computational efficiency
         real :: hb_lambdab( 4 ) =
     &           (/ 6.0e-04,   ! shrubland
     &              8.0e-04,   ! shrubgrass
     &              2.0e-06,   ! barrenland
     &              3.0e-03 /) ! cropland

C converted to gravimetric [kg/kg]
         real :: soilml1( nsltyp ) =
     &           (/ 0.242,     ! Sand
     &              0.257,     ! Loamy Sand
     &              0.286,     ! Sandy Loam
     &              0.350,     ! Silt Loam
     &              0.350,     ! Silt
     &              0.307,     ! Loam
     &              0.277,     ! Sandy Clay Loam
     &              0.350,     ! Silty Clay Loam
     &              0.332,     ! Clay Loam
     &              0.284,     ! Sandy Clay
     &              0.357,     ! Silty Clay
     &              0.344,     ! Clay
     &              0.329,     ! Organic Material
     &              0.000,     ! Water
     &              0.170,     ! BedRock
     &              0.280 /)   ! Other

C---Soil texture: the amount of
C   1: Coarse sand, 2: Fine-medium sand, 3: Silt, 4: Clay
C   in each soil type [Kg/Kg]. from Menut et al. [JGR,2013]
         real :: soiltxt( nsltyp,ndp ) = reshape (
     &           (/ 0.46,   0.46,   0.05,   0.03,     ! Sand
     &              0.41,   0.41,   0.18,   0.00,     ! Loamy Sand
     &              0.29,   0.29,   0.32,   0.10,     ! Sandy Loam
     &              0.00,   0.17,   0.70,   0.13,     ! Silt Loam
     &              0.00,   0.10,   0.85,   0.05,     ! Silt
     &              0.00,   0.43,   0.39,   0.18,     ! Loam
     &              0.29,   0.29,   0.15,   0.27,     ! Sandy Clay Loam
     &              0.00,   0.10,   0.56,   0.34,     ! Silty Clay Loam
     &              0.00,   0.32,   0.34,   0.34,     ! Clay Loam
     &              0.00,   0.52,   0.06,   0.42,     ! Sandy Clay
     &              0.00,   0.06,   0.47,   0.47,     ! Silty Clay
     &              0.00,   0.22,   0.20,   0.58,     ! Clay
     &              0.00,   0.00,   0.00,   0.00,     ! Organic Material
     &              0.00,   0.00,   0.00,   0.00,     ! Water
     &              0.00,   0.00,   0.00,   0.00,     ! BedRock
     &              0.00,   0.00,   0.00,   0.00 /),  ! Other
     &           (/ nsltyp,4 /), order = (/ 2,1 /) ) ! fill columns first

         real :: soiltxt2( ndp )

C---Mean mass median particle diameter (m) for each soil texture type
C   Chatenet et al. [Sedimentology,1996] and Menut et al. [JGR,2013]
         real :: dp( ndp ) =
     &           (/ 690.0E-6,     ! Coarse sand
     &              210.0E-6,     ! Fine-medium sand
     &              125.0E-6,     ! Silt
     &                2.0E-6 /)   ! Clay

         interface
            subroutine tfabove ( tfa )
               real,    intent( out ) :: tfa( :,: )
            end subroutine tfabove
         end interface

#ifdef verbose_wbdust
         integer dryhit
         integer dusthit
#endif

C-----------------------------------------------------------------------

         if ( firstime ) then
            firstime = .false.
            allocate ( ustr( ncols,nrows,n_dlcat+1 ),
     &                  qam( ncols,nrows,n_dlcat+1 ),
     &                 fruf( ncols,nrows,n_dlcat+1 ),
     &                  kvh( ncols,nrows,n_dlcat+1 ),
     &                 elus( ncols,nrows,n_dlcat+1 ), stat = status )
            if ( status .ne. 0 ) then
               xmsg = '*** Failure allocating USTR, QAM, FRUF, KVH, or ELUS'
               call m3exit( pname, jdate, jtime, xmsg, xstat1 )
            end if
         end if

C---Calculate transport factor above the canopy
         call tfabove ( tfa )

C---Get Julian day number in year
         jday = float( mod( jdate,1000 ) )

C---Vegetation height dynamically changed based on the month of the year
C   Veg. heights in [m] for 1: Shrubland 2: shrubgrass 3: barrenland 4: Cropland
C   following the idea of Xi and Sokolik [JGR,2015]
         if ( jday .gt. 59 .and. jday .le. 90 ) then         ! Mar
            hv = (/ 0.15 , 0.05 , 0.10 , 0.05 /)
         else if ( jday .gt. 90 .and. jday .le. 120 ) then   ! Apr
            hv = (/ 0.15 , 0.10 , 0.10 , 0.05 /)
         else if ( jday .gt. 120 .and. jday .le. 151 ) then  ! May
            hv = (/ 0.12 , 0.20 , 0.10 , 0.10 /)
         else if ( jday .gt. 151 .and. jday .le. 181 ) then  ! Jun
            hv = (/ 0.12 , 0.15 , 0.10 , 0.30 /)
         else if ( jday .gt. 181 .and. jday .le. 212 ) then  ! Jul
            hv = (/ 0.10 , 0.12 , 0.10 , 0.50 /)
         else if ( jday .gt. 212 .and. jday .le. 243 ) then  ! Aug
            hv = (/ 0.10 , 0.12 , 0.10 , 0.50 /)
         else if ( jday .gt. 243 .and. jday .le. 273 ) then  ! Sep
            hv = (/ 0.10 , 0.10 , 0.10 , 0.30 /)
         else if ( jday .gt. 273 .and. jday .le. 304 ) then  ! Oct
            hv = (/ 0.05 , 0.08 , 0.10 , 0.10 /)
         else                                                ! Nov-Feb
            hv = (/ 0.05 , 0.05 , 0.05 , 0.05 /)
         end if

#ifdef verbose_wbdust
         dryhit = 0
         dusthit = 0
#endif

C Initialize windblown dust diagnostics output buffer
         if ( dustem_diag .and. wstep .eq. 0 ) then
            dustbf = 0.0   ! array assignment
#ifdef verbose_wbdust
            sdiagv = 0.0   ! array assignment
#endif
         end if

C set erodible landuse map
         do m = 1, n_dlcat
            emap( m ) = dmap( m )  ! dmap maps to one of the 3 BELD3 desert types
         end do
         emap( n_dlcat+1 ) = 4

C --------- ###### Start Main Loop ###### ---------
 
         do r = 1, nrows
         do c = 1, ncols
            dust_em( c,r ) = 0.0
            soimt( c,r )   = 0.0
            fmoit( c,r )   = 0.0   ! for diagnostic output visualization
            vegfrac( c,r ) = 0.0
            do m = 1, n_dlcat+1
               ustr( c,r,m ) = 0.0   ! for diagnostic output visualization
               qam ( c,r,m ) = 0.0
               elus( c,r,m ) = 0.0
               fruf( c,r,m ) = 0.0
               kvh ( c,r,m ) = 0.0
            end do
 
            rlay1hgt = rjacm ( c,r ) / cellhgt

C---Vegetation fraction based on the WRF/MCIP VEG variable. In WRF that would be VEGF_PX
C-- for the case of PX and VEGFRA in the case of other LSMs. In more recent WRFv4+ versions
C-- high resolution MODIS veg data is availiable and can be used in PX with pxlsm_modis_veg = 1
            vegfrac( c,r ) = max( min( Met_Data%veg(c,r), 0.95 ), 0.005)
            vegfree = 1.0 - vegfrac( c,r )
            lambdav = -0.35 * log( vegfree ) ! Shao et al. [Aus. J. Soil Res.,1996]

C---Dust possiblity only if 1. not over water 
C                           2. rain < 1/100 in. (1 in. = 2.540 cm)
C                           3. not snow-covered
C                           4. if soimt <= limit
C                           5. desert type or ag landuse
C                           6. erodible landuse
C                           7. friction velocity > threshold

            if ( ( Grid_Data%lwmask( c,r ) .gt. 0.0 ) .and.
     &           ( Met_Data%rn( c,r ) + Met_Data%rc( c,r ) .le. 0.0254 ) .and. ! rn, rc = [cm]
     &           ( Met_Data%snocov( c,r ) .lt. 0.001 ) ) then ! less than 0.1% snow coverage
C---Dust possiblity 1,2,3

               j = Grid_Data%sltyp( c,r )

C kludge (fixed in wrf-px after 4 Mar 11)
               if ( j .gt. 4 ) j = j + 1   ! PX combines "silt" with "silt loam"
               if ( j .gt. 13 ) j = 13   ! = ?

C Calculate maximum amount of the adsorbed water
C    w` = 0.0014(%clay)**2 + 0.17(%clay) - w` in %
C    Fecan et al. [1999,Annales Geophys.,17,144-157]
               wmax( c,r ) = ( 14.0 * soiltxt( j,4 ) + 17.0 ) * soiltxt( j,4 )   ! [%]

!              write( logdev,'( 2x, a, i8.6, f12.5 )' ) 'max wmax:', jtime, maxval( wmax )

C Change soil moisture units from volumetric (m**3/m**3) to gravimetric (Kg/Kg)
               soimt( c,r ) = Met_Data%soim1( c,r ) ! <- [m**3/m**3]
     &                      * 1000.0 / ( 2650.0 * ( 0.511 + 0.126
     &                                          * ( soiltxt( j,1 ) + soiltxt( j,2 ) ) ) )

               if ( soimt( c,r ) .le. soilml1( j ) ) then
C---Dust possiblity 4

#ifdef verbose_wbdust
                  dryhit = dryhit + 1
#endif

C---Soil moisture effect on U*t
                  if ( soimt( c,r ) .le. 0.01 * wmax( c,r ) ) then   ! wmax in [%]
                     fmoit( c,r ) = 1.0
                  else
                     fmoit( c,r ) = sqrt( 1.0 + 1.21
     &                            * ( 100.0 * soimt( c,r ) - wmax( c,r ) ) ** 0.68 )
                  end if

C---Erodibility potential of soil component
                  sd_ep( c,r ) = soiltxt( j,4 ) * eropot( 1 )
     &                         + soiltxt( j,3 ) * eropot( 2 )
     &                         + ( soiltxt( j,1 ) + soiltxt( j,2 ) ) * eropot( 3 )

C---Lu and Shao [JGR,1999] and Kang et al. [JGR,2011]
C   First, mapping soil types into 4 main soil types following Kang et al. [JGR,2011]
                  select case ( j )
                     case( 1, 2 )          ! sand
                  !     pp = 5000.0
                  !     calpha = 0.001
                  !     pfrac = 0.06
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 5.886e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 1.5215430
                     case( 3, 4, 6, 8, 9 ) ! loam
                  !     pp = 10000.0
                  !     calpha = 0.0006
                  !     pfrac = 0.18
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 5.2974e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 1.0758933
                     case( 7 )             ! sandy clay loam
                  !     pp = 10000.0
                  !     calpha = 0.0006
                  !     pfrac = 0.32
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 9.4176e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 1.0758933
                     case( 5, 10, 11, 12 ) ! clay
                  !     pp = 30000.0
                  !     calpha = 0.0002
                  !     pfrac = 0.72
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 2.3544e-05
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 0.1964303
                     case default          ! others -- no dust
                  !     pp = 100000.0
                  !     calpha = 1.0
                  !     pfrac = 0.0
                  !     flxfac1 = calpha * 9.81 * pfrac * 500.0 / pp
                        flxfac1 = 0.0
                  !     flxfac2 = 2.09 * sqrt( 2650.0 / pp )
                        flxfac2 = 0.3402273
                  end select

                  do m = 1, n_dlcat     ! desert type landuse category
                     elus( c,r,m ) = ladut( c,r,m ) * vegfree   ! desert land [%]
                  end do
                  elus( c,r,n_dlcat+1 ) = agland( c,r ) * vegfree ! crop land [%]
 
C ------- Start Loop Over Erodible Landuse ----
 
                  do m = 1, n_dlcat+1   ! desert type & crop landuse categories

                     if ( elus( c,r,m ) .gt. 100.0 .or. elus( c,r,m ) .lt. 0.0 ) then
                        write( xmsg,2009 ) elus( c,r,m ), c, r, m
                        call m3exit( pname, jdate, jtime, xmsg, xstat1 )
                     end if

                     if ( elus( c,r,m ) .gt. 0.0 ) then

                        n = emap( m )
                        lambda    = lambdab( n ) + lambdav
                        vegheight = ( hb_lambdab( n ) + hv( n ) * lambdav ) / lambda

C---New parametrization for surface roughness by H. Foroutan - Oct. 2015
                        if ( lambda .le. 0.2 ) then
                           z0 = 0.96  * ( lambda ** 1.07 )  * vegheight 
                        else
                           z0 = 0.083 * ( lambda ** ( -0.46 ) ) * vegheight 
                        end if

C---Calculate friction velocity (U*) at the surafce applicable to dust emission 
                        ustr( c,r,m ) = karman * Met_Data%WSPD10( c,r ) / log ( 10.0 / z0 )

C---Roughness effect on U*t (Drag partitioning)
C   Xi and Sokolik [JGR,2015]
                        fruf2  = ( 1.0 - sigv_mv  * lambdav )
     &                     *     ( 1.0 + betav_mv * lambdav )
     &                     *     ( 1.0 - sigb_mb  * lambdab( n ) / vegfree ) 
     &                     *     ( 1.0 + betab_mb * lambdab( n ) / vegfree )

                        if( fruf2 .gt. 1.0 ) then

                           fruf( c,r,m ) = sqrt( fruf2 )
                        else 
                           fruf( c,r,m ) = 10.0
                        end if

C---Vert-to-Horiz dust flux ratio : Kang et al. [JGR, 2011] : Eq. (12)
!                       kvh( c,r,m ) = ( calpha * 9.81 * pfrac * 1000.0 / 2.0 / pp )
!    &                               * ( 0.24 + 2.09 * ustr( c,r,m ) * sqrt( 2650.0 / pp ) )
                        kvh( c,r,m ) = flxfac1 * ( 0.24 + flxfac2 * ustr( c,r,m ) )
                        soiltxt2 = soiltxt( j,: )
                        hflux = dust_hflux( ndp, dp,
     &                                      soiltxt2,
     &                                      fmoit( c,r ),
     &                                      fruf( c,r,m ),
     &                                      ustr( c,r,m ),
     &                                      sd_ep( c,r ),
     &                                      Met_Data%dens1( c,r ) )
                        vflux = hflux * kvh( c,r,m )                    ! [g/m**2/s]
                        qam( c,r,m ) = qam( c,r,m ) + vflux * rlay1hgt
     &                               * ( elus( c,r,m ) * 0.01 )         ! [g/m**3/s]
                     end if  ! if erodible land

                     if ( elus( c,r,m ) .eq. 0.0 .and. qam( c,r,m ) .ne. 0.0 ) then
                        xmsg = 'Erodible land use = 0, but emissions .ne. 0'
                        call m3exit( pname, jdate, jtime, xmsg, xstat1 )
                     end if

                     dust_em( c,r ) = dust_em( c,r ) + qam( c,r,m )

                  end do   ! m landuse
 
C ------- End Loop Over Erodible Landuse ----
 
C Dust removal by surrounding vegetation <-???
C Adjust dust emissions for transport factors

                  dust_em( c,r ) = dust_em( c,r ) * tfa( c,r ) * tfb( c,r )

               end if   ! if soil moisture
            end if   ! if rain & land & snow

         end do   ! c
         end do   ! r

C --------- ###### End Main Loop ##### ---------

#ifdef verbose_wbdust
         write( logdev,'( /5x, a, 1x, 2i8 )' ) 'dry hit count, 
     &                                          out of total cells:',
     &                                          dryhit, (c-1)*(r-1)
#endif

         do r = 1, nrows
         do c = 1, ncols

C J/K mass emis rate [g/s]  (edust( 1 ) not used)
            edust( 1 ) = fracmj * dust_em( c,r )
            edust( 2 ) = fracmk * dust_em( c,r )

            do n = 1,2
               do v = 1, ndust_spc
                  dustoutm( (n-1)*ndust_spc+v,c,r ) = 
     &                     edust( n ) * dust_spc( v )%spcfac( n )
               end do
            end do

C J/K 3rd moment emis rate [m3/s] (needed for number and surface)
            m3j = edust( 1 ) * f6dpi / ( gpkg * dust_dens( 1 ) ) + TINY(0.0)
            m3k = edust( 2 ) * f6dpi / ( gpkg * dust_dens( 2 ) ) + TINY(0.0)

C Mode-specific emission rates of particle number [1/s]
            dustoutn( 1,c,r ) = m3j * factnumj
            dustoutn( 2,c,r ) = m3k * factnumk

C Mode-specific dry surface area emission rates [m**2/s].
C 2nd moment multiplied by PI to obtain the surface area emissions rate.
            dustouts( 1,c,r ) = m3j * factsrfj
            dustouts( 2,c,r ) = m3k * factsrfk

! Propagate Number and Surface Area Scaling Factors back to Emissions
! Module so that the dust emissions can be scaled appropriately            
            ISD = INDEX1( 'FINE', EM_STREAM_SIZE( IDUSTSRM )%LEN, 
     &                    EM_STREAM_SIZE( IDUSTSRM )%NAME )
            EM_STREAM_SIZE( IDUSTSRM )%FACNUM( ISD,2 ) = FACTNUMJ
            EM_STREAM_SIZE( IDUSTSRM )%FACSRF( ISD,2 ) = FACTSRFJ
            
            ISD = INDEX1( 'COARSE', EM_STREAM_SIZE( IDUSTSRM )%LEN, 
     &                    EM_STREAM_SIZE( IDUSTSRM )%NAME )
            EM_STREAM_SIZE( IDUSTSRM )%FACNUM( ISD,3 ) = FACTNUMK
            EM_STREAM_SIZE( IDUSTSRM )%FACSRF( ISD,3 ) = FACTSRFK

#ifdef verbose_wbdust
            if ( m3j .ne. 0.0 ) dusthit = dusthit + 1
#endif

            if ( dustem_diag ) then
               do m = 1, n_dlcat+1
                  diagv( m ) = qam( c,r,m )             ! g/m**3/s
               end do
               n = n_dlcat + 2
               diagv( n ) = dust_em( c,r )              ! g/m**3/s

               sumdfr = 0.0
               do m = 1, n_dlcat+1
                  diagv( m+n ) = elus( c,r,m )
                  sumdfr = sumdfr + elus( c,r,m )
               end do
               n = n + n_dlcat + 2
               diagv( n ) = sumdfr

               do m = 1, n_dlcat+1
                  diagv( m+n ) = ustr( c,r,m )
               end do
               n = n + n_dlcat + 1

               do m = 1, n_dlcat+1
                  diagv( m+n ) = kvh( c,r,m )
               end do
               n = n + n_dlcat + 1

               do m = 1, n_dlcat+1
                  diagv( m+n ) = fruf( c,r,m )
               end do
               n = n + n_dlcat + 1

               diagv( n+1  ) = fmoit( c,r )       ! 'Soil_Moist_Fac  '
               diagv( n+2  ) = sd_ep( c,r )       ! 'Soil_Erode_Pot  '
               diagv( n+3  ) = wmax ( c,r )       ! 'Mx_Adsrb_H2O_Frc'
               diagv( n+4  ) = vegfrac( c,r )     ! 'Vegetation_Frac '
               diagv( n+5  ) = uland( c,r,3 )     ! 'Urban_Cover     '
               diagv( n+6  ) = uland( c,r,4 )     ! 'Forest_Cover    '
               diagv( n+7  ) = tfa  ( c,r )       ! 'Trfac_Above_Can '
               diagv( n+8 )  = tfb  ( c,r )       ! 'Trfac_Inside_Can'

               n = n + 8

! accum and coarse mode number density emissions
               diagv( n+1 ) = dustoutn( 1,c,r )
               diagv( n+2 ) = dustoutn( 2,c,r )
! accum and coarse mode surface area density emissions
               diagv( n+3 ) = dustouts( 1,c,r )
               diagv( n+4 ) = dustouts( 2,c,r )
              
               n = n + 4
               m = 0
               do v = 1, ndust_spc
                  if ( dust_spc( v )%spcfac( 1 ) .gt. 0. ) then  ! accum. mode mass emissions
                     m = m + 1
                     diagv( m+n ) = dustoutm( v,c,r )
                  end if
               end do

               do v = 1, ndust_spc
                  if ( dust_spc( v )%spcfac( 2 ) .gt. 0. ) then  ! coarse mode mass emissions
                     m = m + 1
                     diagv( m+n ) = dustoutm( v+ndust_spc,c,r )
                  end if
               end do

               n = n + m

C Multiply by sync step because when write to output we divide by the output step
C to get a timestep average.
               do v = 1, ndust_diag
                  dustbf( v,c,r ) = dustbf( v,c,r ) + diagv( v )
     &                            * float( time2sec( tstep( 2 ) ) )
#ifdef verbose_wbdust
                  sdiagv( v ) = sdiagv( v ) + diagv( v )
     &                                      * float( time2sec( tstep( 2 ) ) )
#endif
               end do
            end if   ! dustem_diag
         end do   ! col
         end do   ! row

#ifdef verbose_wbdust
         write( logdev,'( 5x, a, 2i8 / )' ) 'dust hit count, out of total cells:',
     &                                       dusthit, (c-1)*(r-1)
#endif

         if ( dustem_diag ) then

C If last call this hour, write out the windblown dust emissions dignostics.
C Then reset the emissions array and local write counter.

            wstep = wstep + time2sec( tstep( 2 ) )

            if ( wstep .ge. time2sec( tstep( 1 ) ) ) then
               if ( .not. currstep( jdate, jtime, stdate, sttime, tstep( 1 ),
     &                              mdate, mtime ) ) then
                  xmsg = 'Cannot get step date and time'
                  call m3exit( pname, jdate, jtime, xmsg, xstat3 )
               end if
               call nextime( mdate, mtime, tstep( 1 ) )

#ifdef verbose_wbdust
               sdiagv = sdiagv / float( wstep )   ! array assignment
               write( logdev,2015 ) jdate, jtime
               do v = 1, ndust_diag
                  if ( diagnm( v )%var(1:4) .ne. 'ANUM' ) then
                     write( logdev,2019 ) v, diagnm( v )%var, sdiagv( v )
                  else
                     write( logdev,2023 ) v, diagnm( v )%var, sdiagv( v )
                  end if
               end do
               sdiagv = 0.0   ! array assignment
#endif
               do v = 1, ndust_diag
                  do r = 1, nrows
                     do c = 1, ncols
                        wrbuf( c,r ) = dustbf( v,c,r ) / float( wstep )
                     end do
                  end do

                  if ( .not. WRITE3( ctm_dust_emis_1, diagnm( v )%var,
     &                       mdate, mtime, wrbuf ) ) then
                     xmsg = 'Could not write ' // trim( diagnm( v )%var )
     &                    // ' to CTM_DUST_EMIS_1'
                     call m3exit( pname, mdate, mtime, xmsg, xstat1 )
                  end if
               end do
               write( logdev,'( /5x, 2( a, 1x ), i8, ":", i6.6 )' )
     &               'Timestep written to CTM_DUST_EMIS_1',
     &               'for date and time', mdate, mtime
               wstep = 0
               dustbf = 0.0   ! array assignment
            end if   !  time to write
         end if   ! dustem_diag

2009     Format( '*** Erodible landuse incorrect ', 1pe13.5, 1x, 'at: ', 3i4 )
2015     format( /5x, 'Total grid time-avg sum of dust emis variables at:',
     &            1x, i8, ":", I6.6  )
2019     format( i10, 1x, a, f20.5 )
2023     format( i10, 1x, a, e20.3 )

         end subroutine get_dust_emis

C=======================================================================
         function dust_hflux( ndp, dp, soiltxt2, fmoit, fruf, ustr, sd_ep, dens )
     &      result( hflux )

C usage: hflux = dust_flux( ndp, dp,
C                           soiltxt2( : ),
C                           fmoit( c,r ),
C                           fruf( c,r,m ),
C                           ustr( c,r,m ),
C                           sd_ep( c,r ),
C                           dens( c,r ) )

            implicit none

            include SUBST_CONST   ! for grav

            integer, intent( in ) :: ndp
            real,    intent( in ) :: dp( ndp )
            real,    intent( in ) :: soiltxt2( ndp )
            real,    intent( in ) :: fmoit, fruf, ustr, sd_ep, dens
            real hflux

            real, parameter :: amen = 1.0          ! Marticorena and Bergametti [JGR,1997]
            real, parameter :: cfac = 1000.0 * amen / grav
            real, parameter :: A = 260.60061       ! 0.0123 * 2650.0 * 9.81 / 1.227
            real, parameter :: B = 1.6540342e-06   ! 0.0123 * 0.000165 / 1.227
            real utstar                            ! threshold U* [m/s]
            real utem                              ! U term [(m/s)**3]
            real fac
            integer n

! I can't initialize dp this way - it has to be passed in since ndp is variable

C---Mean mass median diameter (m) for each soil texture
C   [Chatenet et al., Sedimentology 1996 and Menut et al., JGR 2013]
!           real :: dp( ndp ) =
!    &              (/ 690.0E-6,     ! Coarse sand
!    &                 210.0E-6,     ! Fine-medium sand
!    &                 125.0E-6,     ! Silt
!    &                   2.0E-6 /)   ! Clay

            fac = cfac * dens * sd_ep
            utem    = 0.0
            utstar  = 0.0
            hflux   = 0.0
            do n = 1, ndp   ! loop over dust particle size
!              utstar = sqrt( 0.0123 * ( 2650.0 * 9.81 * dp( n ) / 1.227 + 0.000165
!              / 1.227 / dp( n ) ) )              ! X roughness & moisture effects
               utstar = sqrt( A * dp( n ) + B / dp( n ) ) * fmoit * fruf !Shao and Lu [JGR,2000]
               if ( ustr .gt. utstar ) then  ! wind erosion occurs only if U* > U*t
C---Horiz. Flux from White (1979)
                  utem = ( ustr + utstar ) * ( ustr * ustr - utstar * utstar )
C---Horiz. Flux from Owen (1964)
!                 utem = ustr * ( ustr * ustr - utstar * utstar )
                  hflux = hflux
     &                  + fac * utem * soiltxt2( n )   !  [g/m/s]
               end if
            end do   ! dust particle size

         end function dust_hflux

      end module dust_emis

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


       SUBROUTINE HRSOLVER( JDATE, JTIME, C, R, L )


C**********************************************************************
C
C  FUNCTION: EBI solver
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  HRRATES, HRG1, HRG2, HRG3
C                                     HRG4, HRPRODLOSS
C                                     DEGRADE
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C   21 Jun 10 J.Young: convert for Namelist redesign
C   18 Jul 14 B.Hutzell: revised 1) to use the RXNS_DATA and RXNS_FUNCTION
C                        modules instead of include files and 2) to use
C                        real(8) variables
C   27 Dec 19 S.Napelenok: ddm-3d implementation for v5.3.1
C**********************************************************************

      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE RXNS_DATA
      USE HRDATA
      USE PA_IRR_MODULE
#ifdef isam
      USE SA_IRR_DEFN
#endif

#ifdef sens
      USE DDM3D_CHEM, ONLY: YCDDM, DDM_CHECK, N_EBI_MID, ODD_STEPS
      USE CGRID_SPCS, ONLY: GC_SPC
#endif 


      IMPLICIT NONE

C..INCLUDES:


C..ARGUMENTS:
      INTEGER, INTENT( IN ) :: JDATE    ! Current date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME    ! Current time (HHMMSS)
      INTEGER, INTENT( IN ) :: C, R, L  ! Cell col, row, lev

C..PARAMETERS:
      INTEGER, PARAMETER :: MXBKUPS = 5  ! Max no. of back-ups allowed
      INTEGER, PARAMETER :: STAT = 1     ! Status code

      REAL( 8 ), PARAMETER :: DTMIN   = 1.0D-08    ! Smallest time step allowed, min
      REAL( 8 ), PARAMETER :: EPSLON  = 1.0D-30    ! Small number
      REAL( 8 ), PARAMETER :: MAXPRED = 1.0D+03    ! Upper limit on predicted conc
      REAL( 8 ), PARAMETER :: ZERO    = 1.0D-40    ! effective zero

C..EXTERNAL FUNCTIONS:


C..SAVED LOCAL VARIABLES:
      CHARACTER( 16 ),      SAVE :: PNAME  = 'HRSOLVER' ! Program name
      LOGICAL,              SAVE :: LFIRST = .TRUE.     ! Flag for first call
      LOGICAL, ALLOCATABLE, SAVE :: LEBISPFL( : )       ! Convergence Error Flag for EBI species
      LOGICAL, ALLOCATABLE, SAVE :: MAXCONC ( : )       ! MAXCONC ERROR Flag for EBI species
      LOGICAL, ALLOCATABLE, SAVE :: NOTMAX  ( : )       ! Initial concentration not greater than MAXPRED

      REAL( 8 ), ALLOCATABLE, SAVE :: RERROR  ( : )     ! Relative Error
      REAL( 8 ), ALLOCATABLE, SAVE :: AERROR  ( : )     ! Absolute Error


C..SCRATCH LOCAL VARIABLES:

      CHARACTER( 132 ) :: MSG           ! Message text

      INTEGER CELLNO          ! Cell no. fo debug output
      INTEGER ITER            ! Loop index for Backward Euler iterations
      INTEGER S               ! Loop index for species
      INTEGER SP              ! Imbedded loop index for species
      INTEGER NEBI            ! Loop index for time steps
      INTEGER NINR            ! No. of inner time steps
#ifdef hrdebug
      INTEGER N               ! Loop index
#endif
      INTEGER M               ! species index
      INTEGER EBI             ! Loop index
      INTEGER NBKUPS          ! No. of times time step reduced
      INTEGER ERR             ! Allocate error flag


      LOGICAL LEBI_CONV          ! Flag for EBI convergence
      LOGICAL MXFL               ! hit MAXPRED flag

      REAL( 8 ) DTC              ! Time step to take
      REAL( 8 ) DTG         ! Time step in degrade routines, sec
      REAL( 8 ) FXDLOSS          ! Total loss due to negative stoichiometry
      REAL( 8 ) VARLOSS          ! Loss excluding negative stoichiometry


#ifdef hrdebug
      CHARACTER( 8 ) :: NOTE  ! Convergence fail note

      INTEGER COL             ! Column to generate deboug output for
      INTEGER ROW             ! Row to generate deboug output for
      INTEGER LEV             ! Level to generate deboug output for
      INTEGER DBGOUT          ! Output unit for debu outpt

      LOGICAL LDEBUG          ! Debug output flag
      LOGICAL, SAVE  :: LOPEN = .FALSE.
#endif

      INTERFACE ! for degrade algorithm
        SUBROUTINE DEGRADE( CBLK, DT, JDATE, JTIME )
          REAL( 8 ), INTENT( IN ) :: CBLK( : )      ! array holding species concentrations
          REAL( 8 ), INTENT( IN ) :: DT             ! time step for integrations [sec]
          INTEGER,   INTENT( IN ) :: JDATE          ! current model date , coded YYYYDDD
          INTEGER,   INTENT( IN ) :: JTIME          ! current model time , coded HHMMSS
        END SUBROUTINE
      END INTERFACE

C**********************************************************************


       IF( LFIRST ) THEN
          LFIRST = .FALSE.

          ALLOCATE ( LEBISPFL( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating LEBISPFL'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( MAXCONC( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating MAXCONC'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( NOTMAX( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating NOTMAX'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( RERROR( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating ERROR'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

          ALLOCATE ( AERROR( NUMB_MECH_SPC ), STAT = ERR )
          IF ( ERR .NE. 0 ) THEN
             MSG = 'Error allocating AERROR'
             CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
          END IF

       END IF

#ifdef sens
      DO S = 1, N_SPEC
         DDM_CHECK( S ) = .FALSE.
      END DO
      N_EBI_MID = CEILING( N_EBI_STEPS / 2.0 )
      IF ( MOD( N_EBI_STEPS, 2 ) .EQ. 1 ) THEN
         ODD_STEPS = .TRUE.
      ELSE
         ODD_STEPS = .FALSE.
      END IF
#endif

c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++
#ifdef hrdebug
      COL = 0
      ROW = 0
      LEV = 0
      IF( C .EQ. COL .AND. R .EQ. ROW .AND. L .EQ. LEV ) THEN
c      IF( JTIME .EQ. 160000 ) THEN
         LDEBUG = .TRUE.
      ELSE
         LDEBUG = .FALSE.
      END IF

      IF( LDEBUG ) THEN
           IF( .NOT. LOPEN ) THEN
              DBGOUT = JUNIT()
              OPEN( UNIT = DBGOUT, FILE = 'debug.out' )
              LOPEN = .TRUE.
           END IF

           WRITE( DBGOUT, '( A, 2I4, I3, 1X, I7, 1X, I6 ) ' )
     &             'Debug output for col/row/lev/date/time:',
     &              C, R, L, JDATE, JTIME
           WRITE( DBGOUT, '( A, F7.2) ' )
     &             'EBI_TMSTEP = ', EBI_TMSTEP
           WRITE( DBGOUT, '( A )' ) 'Starting concs and rate constants'
           DO N = 1, NUMB_MECH_SPC
             WRITE( DBGOUT,  '( A, I3, 1X, A, 1X, 1PD13.5 )' )
     &                     'SP ',N, CHEMISTRY_SPC( N ), YC( N )
           END DO
           DO N = 1, N_RXNS
             WRITE( DBGOUT, '( A, I3, 1X, 1PD13.5 )' )
     &                     'RKI ', N, RKI(  N )
           END DO
      END IF
#endif
c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++



      DTC         = EBI_TMSTEP

      N_EBI_IT    = 0
      NBKUPS      = 0
      N_INR_STEPS = 1
      NEBI        = 1
      LEBI_CONV   = .TRUE.
#ifdef isam
      UPDATE_SOLD = .FALSE.
      UPDATE_PROBABILITIES = .TRUE.
      CALL SA_IRR_UNBLOCKED ( .TRUE., RKI, YC, DTC )
#endif


      DO S = 1, NUMB_MECH_SPC
         IF( YC( S ) .LE. MAXPRED )THEN
           NOTMAX( S ) = .TRUE.
         ELSE
           NOTMAX( S ) = .FALSE.
           WRITE(LOGDEV,91000)C, R, L, CHEMISTRY_SPC(S), YC(S)
         END IF
      END DO

! Initial PA_IRR
      IF( CALL_IRR ) CALL PA_IRR ( .TRUE., RKI, YC, DTC )
      TSTEP_EBI: DO    ! EBI time-step loop

         SUBSTEP_EBI: DO NINR = 1, N_INR_STEPS   ! time substeps loop
!  first attempt is sub time-step equals EBI time-step

            IF( LEBI_CONV ) FORALL( S = 1:NUMB_MECH_SPC )YC0( S ) = YC( S )   ! Set ICs for EBI iterations

            ITER_SUBSTEP: DO ITER = 1, NEBITER  ! iteration loop solving for sub time-step


               N_EBI_IT = N_EBI_IT + 1
               CALL HRRATES

c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++
#ifdef hrdebug
               IF( LDEBUG ) THEN
                  WRITE( DBGOUT, '( A, I5 )' ) 'ITER NO ', ITER
                  WRITE( DBGOUT, '( A, F12.5 )' )
     &               ' DTC=', DTC

                  IF( ITER .EQ. 1 ) THEN
                     WRITE( DBGOUT, '( A )' ) 'Starting reaction rates'
                     DO N = 1, N_RXNS
                        WRITE( DBGOUT, '( A, I3, 1X, 1PD13.5 )' )
     &                        'RXRAT ', N, RXRAT( NCELL, N )
                     END DO
                  END IF
               END IF
#endif
c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Call routines to compute concentrations of groups 1-4
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

               CALL HRG1( DTC )

               CALL HRG2( DTC )

               CALL HRG3( DTC )

               CALL HRG4( DTC )


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the Euler backward method
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               CALL HRPRODLOSS

               DO EBI = 1, N_EBISP
                  S = EBISP( EBI )
                  YCP( S ) =  YC( S )*( ( YC0( S ) + PROD( S ) * DTC )
     &                     / ( YC( S ) + LOSS( S ) * DTC ) )
               END DO

c..Special treatment of PAR because of negative product stoichiometry
               IF( PNEG( PAR ) .GT. 0.0D0 ) THEN
                  FXDLOSS = PNEG( PAR ) * DTC
                  IF( FXDLOSS .GE. YC0( PAR ) + PROD( PAR ) * DTC ) THEN
                     YCP( PAR ) = 0.0D0
                  ELSE
                     VARLOSS = MAX( LOSS( PAR ) - PNEG( PAR ) , ZERO )
                     YCP( PAR ) = ( YC0( PAR ) + PROD( PAR ) * DTC  - 
     &             FXDLOSS ) / ( 1.0D0 + VARLOSS * DTC / YC( PAR ) )
                  END IF
               END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Check for convergence
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
               LEBI_CONV = .TRUE.
               MXFL      = .FALSE.

               DO S = 1, NUMB_MECH_SPC
                  LEBISPFL( S ) = .FALSE.
                  YCP( S ) = MAX( ZERO, YCP( S ) )
                  AERROR( S ) = ABS( YC(S)-YCP(S) )
                  RERROR( S ) = AERROR( S ) / ABS( YC(S)+YCP(S) )
                   IF( RERROR( S ) .GT. RTOL(S) .OR. AERROR( S ) .GT. 1.0D-5 )THEN
!                 IF( RERROR( S ) .GT. RTOL(S)  )THEN
                     LEBI_CONV     = .FALSE.
                     LEBISPFL( S ) = .TRUE.
                  END IF
c..test if predictions growing too large
                  IF( YCP( S ) .GT. MAXPRED .AND. NOTMAX( S ) ) THEN
                     MXFL          = .TRUE.
                     LEBI_CONV     = .FALSE.
                     LEBISPFL( S ) = .TRUE.
                  END IF
                  YC( S ) = YCP( S )
               END DO
c..test if predictions growing too large, abort interation loop
               IF( MXFL ) EXIT ITER_SUBSTEP

c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++
#ifdef hrdebug
               IF( LDEBUG ) THEN
                  WRITE( DBGOUT, '( A, I5 )' ) 'Concs after ITER= ', ITER
                  DO S = 1, NUMB_MECH_SPC

                     IF( LEBISPFL( S ) ) THEN
                        NOTE = 'CONV FAIL'
                     ELSE
                        NOTE = '         '
                     END IF

                     WRITE( DBGOUT, '( I3, 1X, A, 1PD13.5, 1X, A )' )
     &                            S, CHEMISTRY_SPC( S ), YC( S ), NOTE
                  END DO
                  IF( LEBI_CONV ) WRITE( DBGOUT, '( A )' )
     &                 '****Convergence achieved'
               END IF
#endif
c++++++++++++++++++++++++Debug section++++++++++++++++++++++++++++++++++

               IF( LEBI_CONV ) THEN

                DTG = 60.0D0 * DTC
                DO S = 1, NUMB_MECH_SPC
                   M = CGRID_INDEX( S )
                   YCCELL( M ) = YC( S )
                END DO
                IF( CALL_DEG )CALL DEGRADE(YCCELL, DTG, JDATE, JTIME) ! :WTH Call degradation routine

                 IF( CALL_IRR ) CALL PA_IRR ( .FALSE., RKI, YC, DTC )
#ifdef isam
                 IF( NEBI .EQ. N_EBI_STEPS )UPDATE_SOLD = .TRUE.
                 CALL SA_IRR_UNBLOCKED ( .FALSE., RKI, YC, DTC )
                 UPDATE_PROBABILITIES = .FALSE.
#endif

#ifdef sens
C YCDDM is the value at the middle time step
                  IF ( N_EBI_MID .EQ. NEBI ) THEN
                   DO S = 1, NUMB_MECH_SPC
                     DDM_CHECK ( S ) = .TRUE.
                     YCDDM( S ) = YC( S )
                     IF ( YCDDM( S ) .LT. 1.e-25) YCDDM( S ) = 0.0
                   END DO
                  END IF
#endif

                 CYCLE SUBSTEP_EBI ! solve for next sub time-step

               END IF

            END DO ITER_SUBSTEP
! interating for substep failed, attempt to increase number of sub time-steps
            NBKUPS = NBKUPS + 1

!            IF( NBKUPS .LE. MXBKUPS ) THEN
            IF ( DTC .GT. DTMIN ) THEN
! reset YC and cut sub time-step in half
               IF ( MXFL ) THEN
                  WRITE( LOGDEV, 92008 ) NBKUPS
                  WRITE( LOGDEV, 92009 ) C+PECOL_OFFSET, R+PEROW_OFFSET, L
                  DO S = 1, NUMB_MECH_SPC
                     IF( LEBISPFL( S ) )WRITE( LOGDEV, 92010 )TRIM( CHEMISTRY_SPC( S ) ),
     &               YC0(S), YCP(S)
                  END DO
               ELSE
                  WRITE( LOGDEV, 92000 ) C+PECOL_OFFSET, R+PEROW_OFFSET, L, NBKUPS
                  DO S = 1, NUMB_MECH_SPC
                     IF( LEBISPFL( S ) )WRITE( LOGDEV, 92010 )TRIM( CHEMISTRY_SPC( S ) ),
     &               YC0(S), YCP(S)
                  END DO
               END IF

               FORALL( S = 1:NUMB_MECH_SPC )YC( S ) = YC0( S )   ! Set ICs for EBI time-step

               DTC = 0.5D0 * DTC

               N_INR_STEPS = 2 ** NBKUPS

               EXIT SUBSTEP_EBI

            ELSE

               WRITE( LOGDEV, 92040 ) C+PECOL_OFFSET, R+PEROW_OFFSET, L

               WRITE( LOGDEV, 92060 )
               DO S = 1, NUMB_MECH_SPC
                  IF( LEBISPFL( S ) ) WRITE( LOGDEV, 92080 ) CHEMISTRY_SPC( S ),
     &            YC0(S), YCP(S)
               END DO

               MSG = 'ERROR: Stopping because of EBI convergence failures'
               CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT2 )

            END IF

         END DO SUBSTEP_EBI

         IF( LEBI_CONV )THEN
             NEBI        = 1 + NEBI
! test for completing final EBI time-step
             IF( NEBI .GT. N_EBI_STEPS )RETURN
! test whether backups were done
             IF( NBKUPS .EQ. 0 )CYCLE TSTEP_EBI
! Reset NBKUPS, N_INR_STEPS and sub-time step
             NBKUPS      = 0
             N_INR_STEPS = 1
             DTC         = EBI_TMSTEP
         END IF

      END DO TSTEP_EBI

#ifdef sens
      DO S = 1, N_SPEC
         IF ( .NOT. DDM_CHECK( S ) ) THEN
            MSG = 'ERROR: HRSOLVER failed to assign YCDDM to ' //
     &             GC_SPC( S )
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, STAT )
         END IF
      END DO
#endif

      RETURN


91000 FORMAT( 'WARNING: EBI solver in cell (',2(I4,','),I4,') Init.Conc. for ',
     &         A16, ' = ', ES12.4,' ppmV')

92000 FORMAT( 'WARNING: EBI Euler convergence failure' /
     &        '         Reducing EBI time step because of ',
     &        '         convergence failure in ' /
     &        '         Cell (', I3, ', ', I3, ', ', I3, ')' ,
     &        '         Solution Attempt #', I2 /
     &        '         Below Species Causing Error: Init.Conc, Pred.Conc.'  )

92008 FORMAT( 'WARNING: At solution attempt #', I2  )
92009 FORMAT( 'WARNING: EBI Euler convergence failure' /
     &        '         Reducing EBI time step because of ',
     &        '         MAXPRED failure in ' /
     &        '         Cell (', I3, ', ', I3, ', ', I3, ')' ,
     &        '         for the below species: : Init.Conc, Pred.Conc.')
92010 FORMAT( A16, 2(1X,ES12.4), ' ppmV'  )

92040 FORMAT( 'ERROR: Max number of EBI time step reductions exceeded'
     &      / '      Convergence failure for cell (', I3, ', ', I3,
     &                ', ', I3, ')' )

92060 FORMAT( '      Convergence failure for the following species:',
     &        'Init.Conc, Pred.Conc.' )

92080 FORMAT( 10X, A, 2(1X,ES12.4), ' ppmV ' )

92061 FORMAT( '      Convergence failure for the following species:',
     &        'Init.Conc, Pred.Conc.,Rel.Error,' )

92081 FORMAT( 10X, A, 2(1X,ES12.4), ' ppmV ', ES12.4,'%' )

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module soa_defn

C  Defines aerosol species arrays and parameters required in SOA processing.

C  Contains:
C     Subroutine extract_soa
C     Subroutine update_orgvapor
C     Function findVapor
C     Function findOrgprod
C     Subroutine orgaer

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C HP  03/11/11 Updated monoterpene SOA alphas and Cstars to Carlton et al. 2010 values
C HP  07/24/11 Changed aromatic SOA alphas for consistency with updated reaction counters
C               BNZ, TOL, XYL numbers now match Ng et al. 2007 Atmos. Chem. Phys.
C 08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C 13 Aug 13 H. Pye: Xylene and toluene low-NOx yields switched. Values now
C               follow experimental data of Ng et al. 2007 ACP as shown in Table 3.
C               Values in Table 6 of Ng et al. (previously used) are incorrect.
C 18 Dec 13 G.Sarwar: added orgprod parent names based on RACM2
C 07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C 21 Jul 14 B.Hutzell: used ifdef statement to make oligomerization
C                      optional because process represented in chemical
C                      mechanism
C 26 Sep 14 H. Pye: Added isoprene + NO3 SOA (see mech.def, no changes
C                   here). When IEPOX uptake present in gas phase for
C                   cb05e51, replace preivous acid enhanced isoprene SOA
C                   with IEPOX uptake SOA now handled as a heterogeneous
C                   rxn. For saprc07tic_ae6i, perform more detailed
C                   IEPOX and MAE uptake and do not do Carlton et al. 2010
C                   acid enhancement. Note that saprc07tic_ae6i is a research
C                   version and it is unclear how duplicative AISO1+AISO2+their oligomers
C                   are with  IEPOX+MAE uptake and their oligomers.
C                   Both pathways occur with sarpc07tic_ae6i. To turn AISO1+AISO2
C                   oligomers off, set "Decay" in oaspc to 0.0 for SV_ISO1/2.
C 27 Sep 14 H. Pye: Added alkane and PAH SOA (Pye and Pouliot 2012 ES&T)
C 15 Jul 15 G. Sarwar: updated SOA from alkane, PAH, and isoprene for RACM2
C 03/03/16  D. Luecken: added capability for CB6
C 24 Mar 16 G. Sarwar: updated for CB05EH51
C    May 16 B. Murphy, H. Pye: updated treatment of aerosol moments
C    Jan 18 H. Pye: updated monoterpene photoxidation SOA: Xu et al. 2018 ACPD
C                   AMT1-7 will replace ATRP1-2 when fully implemented
C                   across mechanisms. 
C    Aug 18 M. Qin, H. Pye: Removed oligomerization option here. Oligomerization
C                   must be done in gas chemistry (mech.def). Added anthropogenic
C                   SOA condensation for aero7.
C   29 Aug 18 G. Sarwar: updated for CB6R3M
C-----------------------------------------------------------------------
      Implicit None

      ! Define Logical values as T and F for the OA table
      Logical, Parameter, Private :: T = .true.
      Logical, Parameter, Private :: F = .false.

      Integer, Parameter :: n_oa_list = 56   ! # of potential partitioning SVOCs
      Integer, Save      :: n_oa             ! # of actual simulated SOA vapors

      Type oa_type
         Character( 16 ) :: name        ! Organic Aerosol Species Name
         Character( 16 ) :: gas_name    ! Condensable Vapor Species Name
         Character( 16 ) :: ctr_name    ! Reaction Counter Name
         Real            :: alpha       ! Mass-based stoichiometric coefficients [ug/m^3]/[ug/m^3]
         Real            :: cstar       ! Effective saturation concentrations [ug/m^3] at 298 K
         Real            :: enth        ! Enthalphy of Vaporization [J/mol]
         Logical         :: nonvol      ! Flag identifying nonvolatile species
      End Type oa_type

      Type( oa_type ), Allocatable, Save :: oaspc( : )

      Type( oa_type ), Save :: oa_list( n_oa_list ) = (/

      !         PM          Vapor       Rxn Cntr     Alpha   CStar^    Enth-   Nonvol-     
      !         Name        Name        Name*                           alpy    atile        
      !        ----------  ----------  ----------   ------  --------  -------  -----    
     & oa_type('AALK1  ', 'SVALK1  ', 'ALKRXN  ',  0.0334,   0.1472,  53.0E3,   F ),
     & oa_type('AALK2  ', 'SVALK2  ', 'ALKRXN  ',  0.2164,  51.8775,  53.0E3,   F ),
     & oa_type('AXYL1  ', 'SVXYL1  ', 'XYLNRXN ',  0.0310,   1.3140,  32.0E3,   F ),
     & oa_type('AXYL2  ', 'SVXYL2  ', 'XYLNRXN ',  0.0900,  34.4830,  32.0E3,   F ),
     & oa_type('ATOL1  ', 'SVTOL1  ', 'TOLNRXN ',  0.0580,   2.3260,  18.0E3,   F ),
     & oa_type('ATOL2  ', 'SVTOL2  ', 'TOLNRXN ',  0.1130,  21.2770,  18.0E3,   F ),
     & oa_type('ABNZ1  ', 'SVBNZ1  ', 'BNZNRXN ',  0.0720,   0.3020,  18.0E3,   F ),
     & oa_type('ABNZ2  ', 'SVBNZ2  ', 'BNZNRXN ',  0.8880, 111.1100,  18.0E3,   F ),
     & oa_type('APAH1  ', 'SVPAH1  ', 'PAHNRXN ',  0.2100,   1.6598,  18.0E3,   F ),
     & oa_type('APAH2  ', 'SVPAH2  ', 'PAHNRXN ',  1.0700, 264.6675,  18.0E3,   F ),
     & oa_type('ATRP1  ', 'SVTRP1  ', 'TRPRXN  ',  0.1393,  14.7920,  40.0E3,   F ),
     & oa_type('ATRP2  ', 'SVTRP2  ', 'TRPRXN  ',  0.4542, 133.7297,  40.0E3,   F ),
     & oa_type('AMT1   ', 'SVMT1   ', 'TRPRXN  ',   0.040,    0.010, 102.0E3,   F ),
     & oa_type('AMT2   ', 'SVMT2   ', 'TRPRXN  ',   0.032,    0.100,  91.0E3,   F ),
     & oa_type('AMT3   ', 'SVMT3   ', 'TRPRXN  ',   0.032,    1.000,  80.0E3,   F ),
     & oa_type('AMT4   ', 'SVMT4   ', 'TRPRXN  ',   0.103,   10.000,  69.0E3,   F ),
     & oa_type('AMT5   ', 'SVMT5   ', 'TRPRXN  ',   0.143,  100.000,  58.0E3,   F ),
     & oa_type('AMT6   ', 'SVMT6   ', 'TRPRXN  ',   0.285, 1000.000,  47.0E3,   F ),
     & oa_type('AMT7   ', 'SVMT7   ', 'TRPRXN  ',   0.160,10000.000,  36.0E3,   F ),
     & oa_type('AMTNO3 ', 'MTNO3   ', '        ',     0.0,     12.0,  40.0E3,   F ),
     & oa_type('AISOPNN', 'ISOPNN  ', '        ',     0.0,     8.9,   40.0E3,   F ),
     & oa_type('AMTHYD ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AIETET ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AIEOS  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('ADIM   ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AIMGA  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AIMOS  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AISO1  ', 'SVISO1  ', 'ISOPRXN ',  0.2320, 116.0100,  40.0E3,   F ),
     & oa_type('AISO2  ', 'SVISO2  ', 'ISOPRXN ',  0.0288,   0.6170,  40.0E3,   F ),
     & oa_type('AISO3  ', '        ', '        ',     0.0,   1.e-10,   1.0E0,   T ),
     & oa_type('ASQT   ', 'SVSQT   ', 'SESQRXN ',  1.5370,  24.9840,  40.0E3,   F ),
     & oa_type('AGLY   ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AORGC  ', '        ', '        ',     0.0,   1.E-10,   1.0E0,   T ),
     & oa_type('AXYL3  ', '        ', 'XYLNRXN ',  0.3600,   1.e-10,   1.0E0,   T ),
     & oa_type('ATOL3  ', '        ', 'TOLNRXN ',  0.3000,   1.e-10,   1.0E0,   T ),
     & oa_type('ABNZ3  ', '        ', 'BNZNRXN ',  0.3700,   1.e-10,   1.0E0,   T ),
     & oa_type('APAH3  ', '        ', 'PAHNRXN ',  0.7300,   1.e-10,   1.0E0,   T ),
     & oa_type('APOC   ', '        ', '        ',  0.0   ,   1.e-10,   1.0E0,   T ),
     & oa_type('APNCOM ', '        ', '        ',  0.0   ,   1.e-10,   1.0E0,   T ),
     & oa_type('APCSO  ', 'LVPCSOG ', 'PCSOARXN',  1.0   ,   1.e-05,  40.0E3,   F ),
     & oa_type('ALVPO1 ', 'VLVPO1  ', '        ',  0.0000,    1.e-1,  96.0E3,   F ),
     & oa_type('ASVPO1 ', 'VSVPO1  ', '        ',  0.0000,    1.e+0,  85.0E3,   F ),
     & oa_type('ASVPO2 ', 'VSVPO2  ', '        ',  0.0000,    1.e+1,  74.0E3,   F ),
     & oa_type('ASVPO3 ', 'VSVPO3  ', '        ',  0.0000,    1.e+2,  63.0E3,   F ),
     & oa_type('AIVPO1 ', 'VIVPO1  ', '        ',  0.0000,    1.e+3,  52.0E3,   F ),
     & oa_type('ALVOO1 ', 'VLVOO1  ', '        ',  0.0000,    1.e-2, 107.0E3,   F ),
     & oa_type('ALVOO2 ', 'VLVOO2  ', '        ',  0.0000,    1.e-1,  96.0E3,   F ),
     & oa_type('ASVOO1 ', 'VSVOO1  ', '        ',  0.0000,    1.e+0,  85.0E3,   F ),
     & oa_type('ASVOO2 ', 'VSVOO2  ', '        ',  0.0000,    1.e+1,  74.0E3,   F ),
     & oa_type('ASVOO3 ', 'VSVOO3  ', '        ',  0.0000,    1.e+2,  63.0E3,   F ),
     & oa_type('AAVB1  ', 'SVAVB1  ', '        ',  0.0000,    0.010,  18.0E3,   F ),
     & oa_type('AAVB2  ', 'SVAVB2  ', '        ',  0.0000,    1.000,  18.0E3,   F ),
     & oa_type('AAVB3  ', 'SVAVB3  ', '        ',  0.0000,   10.000,  18.0E3,   F ),
     & oa_type('AAVB4  ', 'SVAVB4  ', '        ',  0.0000,  100.000,  18.0E3,   F ),
     & oa_type('AOLGA  ', '        ', '        ',  0.0000,   1.e-10,   1.0E0,   T ),
     & oa_type('AOLGB  ', '        ', '        ',  0.0000,   1.e-10,   1.0E0,   T ) /)
      ! Table Comments:
      ! *Reaction Counters are only needed if the vapor species is not formed
      !  directly in the gas-phase chemistry mechanism.
      ! ^Nonvolatile species are given a default C* of 1e-10 ug/m3 and
      !  enthalpy of vaporization equal to 1 kJ/mol.

      ! Identify Species Required for Isoprene and Monoterpene Chemistry
      Character( 16 ), Private, Parameter :: req_sviso1  = 'SVISO1'
      Character( 16 ), Private, Parameter :: req_sviso2  = 'SVISO2'
      Character( 16 ), Private, Parameter :: req_mtno3   = 'MTNO3'
      Character( 16 ), Private, Parameter :: req_isopnn  = 'ISOPNN'
      Character( 16 ), Private, Parameter :: req_aeiso1  = 'AISO1'
      Character( 16 ), Private, Parameter :: req_aeiso2  = 'AISO2'
      Character( 16 ), Private, Parameter :: req_aeiso3  = 'AISO3'
      Character( 16 ), Private, Parameter :: req_aeorgc  = 'AORGC'
      Character( 16 ), Private, Parameter :: req_amtno3  = 'AMTNO3'
      Character( 16 ), Private, Parameter :: req_aisopnn = 'AISOPNN'

      ! Variables for Carrying Indices of required species
      Integer :: iso1_idx
      Integer :: iso2_idx
      Integer :: mtno3_idx
      Integer :: isopnn_idx
      Integer :: amtno3_idx
      Integer :: aisopnn_idx
      Integer :: aiso1_idx
      Integer :: aiso2_idx
      Integer :: aiso3_idx
      Integer :: aorgc_idx

      ! Variables for saving properties and concentrations of organic
      ! compounds
      !   Molecular Weights
          Real, Allocatable    :: op_mw    ( : )   ! PM species
          Real, Allocatable    :: og_mw    ( : )   ! Vapor Species
          Real, Allocatable    :: rog_mw   ( : )   ! Precursor Species
                                                   ! that are linked to yields
      !   Concentrations
          Real, Allocatable    :: og_conc  ( : )   ! Vapors
          Real, Allocatable    :: rog_dconc( : )   ! Reaction counters

      ! Variables for mapping OA to aerosol and CGRID arrays
      Integer, Allocatable :: map_OAtoAERO( : )    ! organic aerosol pointers to aerospc
      Integer, Allocatable :: map_OGtoCGRID( : )   ! pointers of vapor species to CGRID
      Integer, Allocatable :: map_ROGtoCGRID( : )  ! pointers of SOA parent species to CGRID
      Logical, Allocatable :: lnonvol_oa( : )      ! flag identifying non-volaitle OA species 
                                                   ! in aerosol array
      ! Variables for controlling behavior of OA module
      Logical, Private, Save :: mapped              = .False.
      Logical, Private, Save :: RXNS_eflag          = .False. ! error flag for RXNS modules used
      Logical, Private, Save :: OA_eflag            = .False. ! error flag for soa_defn
      Character( 16 ), Private, Save :: pname = 'SOA_DEFN        '

      Contains

C-----------------------------------------------------------------------
      Subroutine extract_soa( conc )

C  Extracts the required soa data from CGRID into the conc array.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 Renamed met_data to aeromet_data
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C HP  09/27/14 alk_factor removed, updated for alkane/PAH SOA.
C              Conversion of reacted alkane to dodecane equivalent
C              is handled in mech.def. A factor of 0.47 is in use and
C              reflects the fact that alkane SOA precursor
C              emissions are dominated by compounds smaller than dodecane.
C BM  02/19/19 Major Revision to simplify the mapping procedure and
C              remove redundat variables.
C-----------------------------------------------------------------------

      Use rxns_data, only: mechname
      Use aero_data, only: AE_eflag, findAero, aerospc_mw, n_aerospc
      Use aeromet_data, only: airdens, inv_mwair, min_gasconc
      Use cgrid_spcs, only: n_gc_spc, gc_spc, n_gc_g2ae, gc_g2ae, gc_strt, gc_molwt, gc_g2ae_map, 
     &                      n_nr_spc, nr_spc, n_nr_n2ae, nr_n2ae, nr_strt, nr_molwt, nr_n2ae_map,
     &                      n_ae_spc, ae_spc
      Use runtime_vars, only: logdev
      Use utilio_defn, only: index1, xstat3

      Implicit None

      ! Arguments:
      Real, Intent( In ) :: conc( : )

      ! Local Variables:
      Character( 300 ):: xmsg
      Real            :: gasconv
      Real            :: vtmp
      Integer         :: n, a, g
      Integer         :: spc
      Integer         :: map_OAtoOAlist( 200 )

      ! Map All OA Species and Load Properties
      If ( .Not. mapped ) Then
          mapped = .TRUE.

          ! First, the number and names of all active OA species must be
          ! determined by checking the AEROSOL Table with the species names
          ! available from the OA_LIST table. 
          n_oa = 0
          Do spc = 1,n_oa_list
             n = findAero( oa_list( spc )%name, .False. )
             If ( n .Gt. 0 ) Then
               n_oa = n_oa + 1
               map_OAtoOAlist( n_oa ) = spc
             End If
          End Do

          ! Allocate the OA property and mapping variables now that the
          ! number of active OA species has been determined.
          Allocate ( oaspc  ( n_oa ))
          Allocate ( op_mw  ( n_oa ))
          Allocate ( og_mw  ( n_oa ))
          Allocate ( rog_mw ( n_oa ))
          Allocate ( og_conc( n_oa ))
          Allocate ( rog_dconc( n_oa ))
          Allocate ( map_ROGtoCGRID( n_oa ))
          Allocate ( map_OAtoAERO( n_oa ))
          Allocate ( map_OGtoCGRID( n_oa ))
          Allocate ( lnonvol_oa( n_aerospc ))

          ! Initialize and populate key OA variables
          map_OAtoAERO = 0
          op_mw = 200.0
          lnonvol_oa = .false.
          Do spc = 1,n_oa
             oaspc( spc ) = oa_list( map_OAtoOAlist( spc ) )
             map_OAtoAERO( spc ) = findAero( oaspc( spc )%name, .False. )
             If( map_OAtoAERO( spc ) .Lt. 1 ) 
     &           write(logdev,99904) Trim( oaspc( spc )%name )
             op_mw( spc ) = aerospc_mw( map_OAtoAERO( spc ) )
             lnonvol_oa( map_OAtoAERo( spc ) ) = oaspc( spc )%nonvol
          End Do

          ! Determine the location of any reaction counter species on the 
          ! GC Namelist. When a match is found, populate the properties
          ! of that counter species.
          map_ROGtoCGRID = 0
          ROG_mw = 200.0
          Do spc = 1, n_oa
            If( oaspc( spc )%ctr_name == '' ) Cycle
            g = index1( oaspc( spc )%ctr_name, n_gc_spc, gc_spc )
            if ( g .ge. 1 ) then
              ! Populate Mapping Vector for the Precursor Species
              map_ROGtoCGRID( spc ) = gc_strt - 1 + g
              ROG_mw( spc ) = gc_molwt( g )
            else
              ! Log an Error
              OA_eflag  = .True.
              write(logdev,99903)Trim( oaspc( spc )%ctr_name ),
     &        Trim( oaspc( spc )%gas_name )
            End If
         End Do

         ! Determine the location on CGRID of condensable gases in 
         ! equilibrium with OA particle species. When a match is found, 
         ! populate the properties of those gas species.
         map_OGtoCGRID = 0
         og_mw = 200.0 ! Default Molecular Weight for all Organic Vapor Species
         Do spc = 1,n_oa
           If( oaspc( spc )%gas_name == '' ) Cycle

           n = index1( oaspc( spc )%gas_name, n_nr_spc, nr_spc )
           If ( n .ge. 1 ) Then
               map_OGtoCGRID( spc ) = nr_strt - 1 + n
               og_mw( spc ) = nr_molwt( n )
           End If

           g = index1( oaspc( spc )%gas_name, n_gc_spc, gc_spc )
           If ( g .ge. 1 ) Then
               map_OGtoCGRID( spc ) = gc_strt - 1 + g
               og_mw( spc ) = gc_molwt( g )
           End If

           If( n .lt. 1 .and. g .lt. 1 ) Then
               OA_eflag  = .True.
               write(logdev,99902)Trim( oaspc( spc )%gas_name ), 
     &         Trim ( oaspc( spc )%name )
           End If
         End Do

         ! Find indices of required species
         iso1_idx   = findVapor( req_sviso1 )
         iso2_idx   = findVapor( req_sviso2 )
         aiso1_idx  = findAero( req_aeiso1, .True. )
         aiso2_idx  = findAero( req_aeiso2, .True. )
         aiso3_idx  = findAero( req_aeiso3, .True. )
         aorgc_idx  = findAero( req_aeorgc, .True. )

         ! Look for Additional Isoprene Product Species if AE6i is being
         ! used
         If ( INDEX( MECHNAME,"SAPRC07TIC_AE6I" ) .Ne. 0 ) Then
           mtno3_idx  = findVapor( req_mtno3  )
           isopnn_idx = findVapor( req_isopnn )
           amtno3_idx  = findAero( req_amtno3, .True. )
           aisopnn_idx = findAero( req_aisopnn,.True. )
         End If
      End If     ! mapping condition


      ! Copy grid cell concentrations of vapor species
      og_conc   = 0.0
      rog_dconc = 0.0
      gasconv = airdens * inv_mwair ! Compute gas conversion constant

      Do spc = 1, n_oa
         n = map_OGtoCGRID( spc )
         If ( n .Ne. 0 ) Then
            vtmp = gasconv * og_mw( spc )
            og_conc( spc ) = Max( conc( n ) * vtmp, min_gasconc )
         End If
         
         n = map_ROGtoCGRID( spc )
         If ( n .Ne. 0 ) Then
            rog_dconc( spc ) = Max( conc( n ), min_gasconc )
         End If
      End Do

99902 Format('FATAL: SOA Vapor, ', a, 
     &       ', is not found among the species in '
     &     / 'the NR or GC namelist used. Required for modeling ', a / )
99903 Format( 'FATAL: SOA Reaction Counter, ', a,  
     &        '. is not found among the species',
     &     / 'in GC namelist used. Required for modeling vapor, ', 
     &       a / )
99904 Format(1X,'aerosol product from namelist species: ', a /)
  
      Return
      End Subroutine extract_soa

C-----------------------------------------------------------------------
      Subroutine update_orgvapor( conc )

C  Populates CGRID from the conc array with updated SOA values.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 Renamed met_data to aeromet_data
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      Use aeromet_data, only: airdens, inv_mwair, min_gasconc
      Use utilio_defn, only: xstat3

      Implicit None

      ! Arguments:
      Real, Intent( Out ) :: conc( : )

      ! Local Variables:
      Character( 80 ) :: xmsg
      Real            :: gasconv
      Real            :: vtmp
      Integer         :: n
      Integer         :: spc

      If ( .Not. mapped ) Then
         xmsg = 'CGRID Species has not been mapped'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If

      ! Compute gas conversion constant
      gasconv = airdens * inv_mwair

      ! Copy og_conc back to grid cell concentrations
      Do spc = 1, n_oa
         n = map_OGtoCGRID( spc )
         If ( n .Ne. 0 ) Then
            vtmp = og_mw( spc ) * gasconv
            conc( n ) = Max ( og_conc( spc ) / vtmp, min_gasconc )
         End If
      End Do

      Return
      End Subroutine update_orgvapor

C-----------------------------------------------------------------------
      Function findVapor( vname ) Result ( ndx )

C  Finds the index of 'required' semivolatile species in the oaspc list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      Implicit None

      ! Arguments:
      Character( 16 ) :: vname
      Integer ndx

      ! Local Variables:
      Character( 80 ) :: xmsg
      Integer         :: spc

      ndx = 0
      Do spc = 1, n_oa
         If ( oaspc( spc )%gas_name .Eq. vname ) Then
            ndx = spc
            Return
         End If
      End Do

      xmsg = 'FATAL:' // Trim( vname )
     &  // ' is not found in the G2AE or N2AE values of GC or namelists'
      OA_eflag  = .True.
      Call m3warn( pname, 0, 0, xmsg )

      Return
      End Function findVapor

C-----------------------------------------------------------------------
      Subroutine orgaer( dt, layer )

C Updates CGRID via several pathways for secondary organic aerosol (SOA)
C formation, as recommended by Edney et al. (2007).  These include SOA
C formation from isoprene, monoterpenes, sesquiterpenes, long alkanes, and
C aromatics (incl. benzene).

C Input includes the concentrations of reactive organic gases (ROG)
C that were oxidized during the time step (ORGPROD), the vapor-phase
C concentration of each semi-volatile organic compound, the
C concentration of each SOA species, and the concentration of primary
C organic aerosol (all concentrations are stored in the CBLK array).
C Output includes updated concentrations of SOA species, vapor-phase
C semi-volatile organic compounds, and moments of the accumulation
C mode.  The geometric mean diameter of the accumulation mode is also
C updated.  All SOA formation is restricted to the accumulation mode.

C This code relies on 12 counter species to be incorporated in the
C gas-phase chemical mechanisms to track the amounts of individual
C ROG that reacted during the current time step (i.e., NPREC=10).
C The arrays of length = NPREC include:
C       (1) "long" alkanes  (ALKRXN)
C       (2) low-yield aromatics, high-NOx pathway (XYLNRXN)
C       (3) low-yield aromatics, low-NOx pathway (XYLHRXN)
C       (4) high-yield aromatics, high-NOx pathway (TOLNRXN)
C       (5) high-yield aromatics, low-NOx pathway (TOLHRXN)
C       (6) benzene, high-NOx pathway (BNZNRXN)
C       (7) benzene, low-NOx pathway (BNZHRXN)
C       (8) monoterpenes (TRPRXN)
C       (9) isoprene (ISOPRXN)
C      (10) sesquiterpenes (SESQRXN)
C      (11) PAHs/naphthalene, high-NOx pathway (PAHNRXN)
C      (12) PAHs/naphthalene, low-NOx pathway (PAHHRXN)

C In total, 15 organic species are allowed to partition between the
C vapor and particulate phases (i.e., NCVAP=12). The arrays of
C length = NCVAP include:
C           alkane (2 semi-volatile products)
C           low-yield aromatics, high-NOx pathway (2 products)
C           high-yield aromatics, high-NOx pathway (2 products)
C           benzene, high-NOx pathway (2 products)
C           monoterpenes (2 products)
C           isoprene (2 products)
C           sesquiterpenes (1 product)
C           PAHs/naphthalene, high-NOx pathway (2 products)

C Equilibrium partitioning calculations are based on the absorptive
C partitioning model of Pankow (1994) that was extended by Odum et
C al. (1996).  Saturation vapor pressures (cstar) and mass-based
C stoichiometric yield coefficients (alpha) are obtained from smog-
C chamber studies.  Saturation vapor pressures are modified as a
C function of temperature using eqn 6 of Sheehan & Bowman (2001).

C If the pre-existing organic aerosol concentration is zero,
C gas/particle equilibrium is established only after the organic gas
C concentration reaches the threshold value defined in eqn 9 of
C Schell et al. (2001).  Until this threshold value is reached,
C organic vapors do not partition to the particle phase.  Once the
C organic gas/particle equilibrium has been established, gas and
C particle-phase concentrations of each condensible species are
C calculated iteratively using a globally convergent variation of
C Newton's method (SUBROUTINE NEWT), as described in eqn 8 of Schell
C et al. (2001).

C In addition to the various pathways of semi-volatile SOA formation
C treated in previous versions of the model, four types of non-
C volatile SOA are considered here:
C   (1) aromatic and PAH-derived SOA under low-NOx conditions
C   (2) oligomerization of all particle-phase semi-volatile material
C   (3) SOA formed by in-cloud oxidation  (SUBROUTINE AQCHEM)
C   (4) isoprene IEPOX-derived SOA under acidic conditions (AEROSOL_CHEMISTRY)

C Previous code revision history:
C   Originally coded August 1, 2001 by Dr. Francis S. Binkowski

C   Revised April 4, 2003 by Gerald Gipson to allow for evaporation
C   of organics from aerosols. Now total vapor + aerosol phase is
C   repartitioned at each time step and totorgnv ( Mo ) does not
C   include oldsoa.

C   Revised July 14, 2003 by Dr. Prakash V. Bhave
C   - changed cstar(2,3) from 10.103 & 90.925 to 111.11 & 1000.0
C     because smog chamber data of Kalberer et al. were collected
C     at 298 K (not 310 K, as was previously assumed)
C   - changed mw_vap(9,10) from 184 g/mol to 177 g/mol, to be
C     consistent with mwsoa_b
C   - modified threshold criteria for establishing gas/particle
C     equilibrium by removing the loose criterion involving "mtot"
C   - changed variable names to reflect that the combined vapor +
C     aerosol concentrations are now being repartitioned during
C     each time step (not just the newly formed SVOC's)
C   - added documentation and removed extraneous lines of code

C   Revised December 4, 2003 by Dr. Francis S. Binkowski
C   - output variables ORGRATE and ORGBRATE removed and replaced
C     by SOA_A and SOA_B, the newly equilibrated values of
C     Anthropogenic and Biogenic SOA, respectively.  These are non-
C     negative values.
C   - variable jj also removed

C   Revised January 8, 2004 by Dr. Prakash V. Bhave
C   - removed the output variable YIELD.  It has no physical meaning
C     after the 12/04/2003 revisions.

C   Revised January 12, 2004 by Dr. Chris G. Nolte
C   - for computational efficiency, modified the initial caer guess
C     used as input to NEWT.  If NEWT returns check .eq. true, then
C     NEWT is called again with a guess of caer = 0.5*ctot
C   - removed ITS parameter from NEWT call vector
C   - fixed bug where concentrations less than TOLMIN (i.e., 1.0E-12)
C     were reset to 1.0e-30
C   - removed extraneous code related to "Pandis method" of SVOC
C     partitioning when threshold criterion is not met (i.e.,
C     insufficient organic matter to establish gas/particle
C     equilibrium)  ** results unaffected by this change
C
C   Revised September 7, 2007 by Dr. Sergey L. Napelenok
C   - Replaced old SOA species (SOA_A, SOA_B) with an array of
C     precursor-specific SOA species.  Replaced OLDSOA_A and OLDSOA_B
C     with an array (OLDSOA).  Updated call vector accordingly.
C   - Deleted nole* and nbio* variables (now obsolete)
C   - Increased the dimension of several arrays to accommodate new
C     SOA precursors (benzene, sesquiterpenes) and pathways (low-NOx,
C     acid-catalyzed, oligomers, in-cloud)
C
C   Revised November 29, 2007 by Dr. Prakash V. Bhave
C   - Renamed subroutine from ORGAER3 to ORGAER5
C   - Modified M2 and M3 calculations to account for the updated
C     definition of DRY aerosol (which now includes non-volatile SOA)
C   - Updated Hvap and corresponding cstar values
C   - Added parameters for SOA from isoprene and sesquiterpenes
C   - Updated aromatic SOA scheme to include semi-volatile and non-
C     volatile products that form under high-NOx and low-NOx
C     conditions, respectively
C   - Added oligomerization process
C   - Added enhancement of isoprene SOA under acidic conditions
C
C   Revised June 2, 2008 by Dr. Prakash V. Bhave
C   - Changed h_vap of benzene SOA to match that of toluene SOA, based
C     on consultation with Dr. Ed Edney and Dr. Tad Kleindienst.

C   Revised June 5, 2008 by Drs. Prakash Bhave and Sergey Napelenok
C   - Simplified the code for conserving low-volatility isoprene
C     oxidation products and removed a minor bug in the acid-induced
C     isoprene SOA calculation.
C
C   Revised September 9, 2008 by Dr. Prakash V. Bhave
C   - Increased alpha values for SV_TRP1, SV_TRP2, and SV_SQT by a
C     factor of 1.3 to correct for the implicit assumption of unit
C     density in those SOA yield parameters.
C   - Reduced SOA/SOC ratio of AISO1 and AISO2 from 2.5 to 1.6, and
C     increased SOA/SOC ratio of AISO3 from 2.5 to 2.7.  Accordingly,
C     the molar masses of AISO1 and AISO2 were decreased to 96 g/mol
C     and the molar mass of AISO3 was increased to 162.
C
C   Revised September 26, 2014 by Dr. Havala Pye
C   - Removed previous acid enhanced isoprene SOA. Acid catalyzed
C     isoprene SOA now follows Pye et al. 2013 ES&T uptake of IEPOX.
C     See AEROSOL_CHEMISTRY and mech.def for IEPOX SOA.
C   - Allowed for alternate method to NEWT for solving partitioning
C     equations

C References:
C   1. Edney, E.O., T.E. Kleindienst, M. Lewandowski, and J.H.
C      Offenberg, Updated SOA chemical mechanism for the Community
C      Multi-Scale Air Quality model, EPA 600/X-07/025, U.S. EPA,
C      Research Triangle Park, NC, 2007.

C   2. Pankow, J. F., An absorption model of gas/particle partitioning
C      of organic compounds in the atmosphere, Atmos. Environ., Vol 28,
C      No 2, 185-188, 1994.

C   3. Odum, J. R., T. Hoffmann, F. Bowman, D. Collins, R. C. Flagan,
C      and J. H. Seinfeld, Gas/particle partitioning and secondary
C      organic aerosol yields, Environ. Sci. Technol., Vol 30, No 8,
C      2580-2585, 1996.

C   4. Sheehan, P. E. and F. M. Bowman, Estimated effects of temperature
C      on secondary organic aerosol concentrations, Environ. Sci.
C      Technol., Vol 35, No 11, 2129-2135, 2001.

C   5. Schell, B., I. J. Ackermann, H. Hass, F. S. Binkowski, and
C      A. Abel, Modeling the formation of secondary organic aerosol
C      within a comprehensive air quality modeling system, J. Geophys.
C      Res., Vol 106, No D22, 28275-28293, 2001.

C   6. Strader, R., F. Lurmann, and S. N. Pandis, Evaluation of
C      secondary organic aerosol formation in winter, Atmos. Environ.,
C      Vol 33, 4849-4863, 1999.

C   7. Ng, N. L., J. H. Kroll, A. W. H. Chan, P. S. Chhabra, R. C.
C      Flagan, and J. H. Seinfeld, Secondary organic aerosol formation
C      from m-xylene, toluene, and benzene, Atmos. Chem. Phys., Vol 7,
C      3909-3922, 2007a.

C   8. Griffin, R. J., D. R. Cocker III, R. C. Flagan, and J. H.
C      Seinfeld, Organic aerosol formation from the oxidation of
C      biogenic hydrocarbons, J. Geophys. Res., Vol 104, No D3,
C      3555-3567, 1999.

C   9. Bian, F. and F. M. Bowman, Theoretical method for lumping
C      multicomponent secondary organic aerosol mixtures, Environ.
C      Sci. Technol., Vol 36, No 11, 2491-2497, 2002.

C  10. Offenberg, J. H., T. E. Kleindienst, M. Jaoui, M. Lewandowski,
C      and E. O. Edney, Thermal properties of secondary organic
C      aerosols, Geophys. Res. Lett., Vol 33, L03816, doi:10.1029/
C      2005GL024623, 2006.

C  11. Bahreini, R., M. D. Keywood, N. L. Ng, V. Varutbangkul, S. Gao,
C      R. C. Flagan, J. H. Seinfeld, D. R. Worsnop, and J. L. Jimenez,
C      Measurements of secondary organic aerosol from oxidation of
C      cycloalkenes, terpenes, and m-xylene using an Aerodyne aerosol
C      mass spectrometer, Environ. Sci. Technol., Vol 39, 5674-5688,
C      2005.

C  12. Alfarra, M. R., D. Paulsen, M. Gysel, A. A. Gaforth, J. Dommen,
C      A. S. H. Prevot, D. R. Worsnop, U. Baltensperger, and H. Coe,
C      A mass spectrometric study of secondary organic aerosols formed
C      from the photooxidation of anthropogenic and biogenic precursors
C      in a reaction chamber, Atmos. Chem. Phys., Vol 6, 5279-5293,
C      2006.

C  13. Ng, N. L., P. S. Chhabra, A. W. H. Chan, J. D. Surratt, J. H.
C      Kroll, A. J. Kwan, D. C. McCabe, P. O. Wennberg, A. Sorooshian,
C      S. M. Murphy, N. F. Dalleska, R. C. Flagan, and J. H. Seinfeld,
C      Effect of NOx level on secondary organic aerosol (SOA) formation
C      from the photooxidation of terpenes, Atmos. Chem. Phys., Vol 7,
C      5159-5174, 2007b.

C  14. Kostenidou, E., R. K. Pathak, and S. N. Pandis, An algorithm for
C      the calculation of secondary organic aerosol density combining
C      AMS and SMPS data, Aerosol Sci. Technol., Vol 41, 1002-1010,
C      2007.

C  15. Offenberg, J. H., C. W. Lewis, M. Lewandowski, M. Jaoui, T. E.
C      Kleindienst, and E. O. Edney, Contributions of toluene and
C      alpha-pinene to SOA formed in an irradiated toluene/alpha-pinene/
C      NOx/air mixture: comparison of results using 14C content and SOA
C      organic tracer methods, Environ. Sci. Technol., Vol 41, 3972-
C      3976, 2007.

C  16. Henze, D. K. and J. H. Seinfeld, Global secondary organic aerosol
C      from isoprene oxidation, Geophys. Res. Lett., Vol 33, L09812,
C      doi:10.1029/2006GL025976, 2006.

C  17. Kleindienst, T. E., M. Jaoui, M. Lewandowski, J. H. Offenberg,
C      C. W. Lewis, P. V. Bhave, and E. O. Edney, Estimates of the
C      contributions of biogenic and anthropogenic hydrocarbons to
C      secondary organic aerosol at a southeastern US location, Atmos.
C      Environ., Vol 41, 8288-8300, 2007.

C  18. Kalberer, M., D. Paulsen, M. Sax, M. Steinbacher, J. Dommen,
C      A. S. H. Prevot, R. Fisseha, E. Weingartner, V. Frankevich,
C      R. Zenobi, and U. Baltensperger, Identification of polymers as
C      major components of atmospheric organic aerosols, Science, Vol
C      303, 1659-1662, 2004.

C  19. Turpin, B. J. and H.-J. Lim, Species contributions to PM2.5 mass
C      concentrations: revisiting common assumptions for estimating
C      organic mass, Aero. Sci. Technol., Vol 35, 602-610, 2001.

C  20. Surratt, J. D., M. Lewandowski, J. H. Offenberg, M. Jaoui, T. E.
C      Kleindienst, E. O. Edney, and J. H. Seinfeld, Effect of acidity
C      on secondary organic aerosol formation from isoprene, Environ.
C      Sci. Technol., Vol 41, 5363-5369, 2007.

C  21. Pye et al., Epoxide pathways improve model prediction of isoprene
C      markers and reveal key role of acidity in aerosol formation,
C      Environ. Sci. Technol., 2013.


C Revision History:
C    First orgaer version was coded in April 2010 by Steve Howard with
C    Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 Renamed met_data to aeromet_data
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C HOTP 05Aug15 Made the calculation for total number of organic moles more robust
C BNM 11/09/15 Added Some Comments to the SOA Scheme
C HOTP 7/17/18 Added uptake of water onto hydrophillic organics
C-----------------------------------------------------------------------

C Key Subroutines/Functions called:  newt, soabisection

      Use aero_data
      Use aeromet_data
      Use utilio_defn
      Use rxns_data, only : MECHNAME

      Implicit None

      ! Arguments:
      Real    :: dt            ! Synchronization time step [ s ]
      Integer :: layer         ! model layer number


      ! Local variables:
      Logical, Save :: first_time = .True.
      Character( 300 ) :: xmsg
      Integer       :: i, im, indx, ispc, n, nsvol

      Real, Allocatable, Save ::  mw_inv( : )     ! Inverse MW of SVOCs [ mol/g ]

      Real, Allocatable, Save ::  rog_ppm2ug( : ) ! [ ppm per ug/m3 ] for ORGPROD at
                                        ! reference temperature and pressure

      ! Parameters & variables for adjusting cstar to ambient conditions
      Real, Parameter :: tref   = 298.0          ! reference temperature [ K ]
      Real, Parameter :: trefm1 = 1.0 / tref     ! inverse of reference temperature
      Real, Parameter :: prefm1 = 1.0 / stdatmpa ! inverse of reference pressure
      Real, Parameter :: rgas1  = 1.0 / rgasuniv ! reciprocal of universal gas constant
      Real, Parameter :: kolig  = 0.69314718 / 72000.0  ! 20h half-life of oligomerization rate [ 1/s ]
      Real, Parameter :: olgrat = 2.1            ! SOA/SOC ratio for oligomers
      Real, Parameter :: kacid  = 0.00361        ! acid-induced enhancement factor
      Real, Parameter :: threshmin = 1.0E-19     ! small positive number
      Real, Parameter :: ctolmin = 1.0E-06
      Real, Parameter :: convfac_298 = 101325.0 * rgas1 * trefm1  ! P/RT at 1 atm and 298 K [ mole/m**3 ]
      Real, Parameter :: difforg = 9.36e-6  ! Diffusivity of organics [m2 s-1]
      Real, Parameter :: alphorg = 1.0      ! accomodation coefficient

      Real convfac
      Real tt1, tt2      ! temperature-related factors
      Real tempcorr      ! temperature correction factor for cstar

      ! Variables used in oligomerization calculations
      Real expdt         ! non-dimensional loss coefficient
      Real nsvpa         ! particle-phase anthropogenic SVOC [ umolC/m3 ]
      Real nsvpb         ! particle-phase biogenic SVOC [ umolC/m3 ]

      ! Variables used in acid-enhanced isoprene SOA calculations
      Real hplus         ! accumulation-mode H+ conc [ nmol/m3 ]
      Real aiso12        ! particle-phase isoprene SVOC [ ug/m3 ]
      Real vviso         ! vapor-phase isoprene SVOC [ ug/m3 ]
      Real xiso3         ! newly produced AISO3J [ ug/m3 ]
      Real isofrac       ! ratio for depletion of vapor-phase products

      ! Variables used in equilibrium partitioning calculations
      Real totrog( n_oa ) ! drog conc mapped to each SVOC [ ug/m3 ]
      Real(8) GRtmp( n_mode )   ! Dummy variable for accurate treatment of growth to specific moment
      Real GR3( n_oa,n_mode ) ! 3rd Moment Growth for each mode and compound
      Real GR3FRAC( n_oa,n_mode ) ! Fraction of each mode growing/shrinking
      Real dcaer          ! Change in SVOC conc after partitioning happens[ ug/m3 ]
      Real cbar_org(n_oa) ! On-line molecular speed of each organic
      Real dv_org            ! On-line gas-phase diffusivity of each organic
      Real totorgnv          ! Non-volatile OA [ umole/m3 ]
      Real totorg            ! SOA + POA before time step [ umole/m3 ]
      Real threshold         ! criterion for establishing gas/part equil.
      Real faer              ! fraction of total in aerosol, intermediate value
      Logical check          ! flag to indicate if NEWT subroutine
                             ! converged to a spurious root
      Real totaer            ! total aerosol-phase mass of each semivolaitle component
      Real Phi               ! mass fraction of a semivolatile component
                             ! in each mode
      Character(16), Allocatable, Save :: svname( : )
      Real, Allocatable, Save          :: svmw( : ), svmw_inv( : )
      Real, Allocatable, Save          :: c0    ( : ) ! cstar at AIRTEMP [ ug/m3 ]
      Real, Allocatable, Save          :: caer0 ( : ) ! Particle conc before current time step [ ug/m3 ]
      Real, Allocatable, Save          :: ctoti ( : ) ! Total (g+p) conc before current time step [ ug/m3 ]
      Real, Allocatable, Save          :: prod  ( : ) ! Total G+P produced during current step [ ug/m3 ]
      Real, Allocatable, Save          :: ctotf ( : ) ! Total conc after current time step [ ug/m3 ]
      Real, Allocatable, Save          :: caer  ( : ) ! Particle conc in aerosol phase after current 
                                                      !  step [ ug/m3 ]

      ! Variables for computing the budget
      REAL :: CBUDGET0_NUM ( N_MODE )
      REAL :: CBUDGET0_SRF ( N_MODE )
      REAL :: CBUDGET0_MASS( N_AEROSPC,N_MODE )


      ! Variables for water uptake onto organics
      Real kappaVorg        ! sum_i(kappa_i*Vorganic_i) [m3 species/m3 air]
      Real overallkappa     ! sum_i(kappa_i*Vorganic_i)/vtot [NA units]
      Real totvol           ! total aerosol volume [m3 species/m3 air]
      Real poa              ! nonvolatile poa concentration [ug/m3]
      Real numparticles     ! number of acc mode particles [#/m3]
      Real diam             ! volume equivalent particle diameter [m]
      Real aw               ! activity of water [fraction]
      Real relhumid         ! relative humidity capped at 95% [fraction]
                            ! Cap represents conservative est of water uptake
                            ! and is consistent with IMPROVE visibility methods

      ! Variables for updating 2nd and 3rd moments
      Real(8) m0_init( 2 )  ! initial 0 moment, wet [ mom/m3 ]
      Real(8) m1wet_init( 2 )  ! initial 1st moment, wet [ mom/m3 ]
      Real(8) m2wet_initD( 2 )  ! initial 2nd moment, wet [ mom/m3 ]
      Real m3wet_init( 2 )  ! initial 3rd moment, wet [ mom/m3 ]
      Real m2wet_init( 2 )  ! initial 2nd moment, wet [ mom/m3 ]
      Real m3wet_final( 2 )  ! final 3rd moment with updated SOA [ mom/m3 ]
      Real m2wet_final( 2 )  ! final 2nd moment with updated SOA [ mom/m3 ]

      ! Added for new SOA bisection (hotp 7/6/11)
      Real               :: lowb, upb, orgmoles      ! lower bound, upper bound, total aerosol moles
      Logical, Parameter :: newtpartition = .False.   ! true to use original method, false to use new bisection

C-----------------------------------------------------------------------

      If ( first_time )  Then
         first_time = .False.

         ! Set unit conversion and inverse mw constants. Allocate space
         ! for semivolatile species partitioning variables.
         Allocate( rog_ppm2ug( n_oa ), mw_inv( n_oa ) )
         rog_ppm2ug( : ) = ROG_mw( : ) * convfac_298
         mw_inv( : ) = 1.0 / op_mw( : )

         nsvol = count( .not.oaspc( : )%nonvol )
         Allocate( svname( nsvol ), svmw( nsvol ), svmw_inv( nsvol ),
     &             c0( nsvol ), caer0( nsvol ), ctoti( nsvol ),
     &             prod( nsvol ), ctotf( nsvol ), caer( nsvol ) )

      End If ! first_time

      ! Set temperature factors
      tt1 = tref / airtemp
      tt2 = trefm1 - 1.0 / airtemp
      convfac = tt1 * airpres * prefm1

      ! Set Mass Transfer Properties (although each condensing organic
      ! will have its own diffusivity and molecular speed, just assume
      ! as a first guess that they are all uniform and given by a rep-
      ! resentative compound.
      Dv_org = difforg * ( STDATMPA / AIRPRES ) * ( AIRTEMP / 273.16 ) ** 1.75
      cbar_org( : ) = SQRT(8.0 * RGASUNIV * AIRTEMP / ( PI * og_mw(:) * 1.0E-3 ) )
 
      ! Compute 3rd moment, 2nd moment. moment_conc arrays are wet
      Call calcmoments ( .true. )
      Call getpar( FIXED_sg )


      ! Initialize Budget Variables
      CBUDGET0_NUM  = MOMENT0_CONC
      CBUDGET0_SRF  = MOMENT2_CONC
      CBUDGET0_MASS = AEROSPC_CONC

      ! Initialize Local Moment Variables
      m3wet_init( : ) = moment3_conc( 1:2 )
      m2wet_init( : ) = moment2_conc( 1:2 )
        
      ! Calculate total flux associated with each indivual mode 
      ! for the third moment.
      GR3( :,: ) = 0.0
      m0_init( : )    = Real( moment0_conc( 1:2 ), 8 )
      m2wet_initD( : ) = Real( m2wet_init( 1:2 ), 8 )

      Do im = 1,2
        m1wet_init( im ) = m0_init( im ) * aeromode_diam( im ) * 
     &                     exp( 0.5d0 * aeromode_lnsg( im ) ** 2.0d0 )

        Do i = 1, n_oa
          If ( aero_missing( map_OAtoAERO( i ),im ) .or.
     &         oaspc(i)%nonvol ) Cycle
          
          Call HCOND3( m0_init( im ), m1wet_init( im ),
     &                 m2wet_initD( im ), Dv_org, alphorg, 
     &                 cbar_org(i), GRtmp )
          GR3( i,im ) = Real( GRtmp( 2 ), 4 )
        End Do
      End Do
      
      ! Calculate fraction of mass transfer to/from each mode
      GR3FRAC( :,: ) = 0.0
      Where ( GR3( :,1 ) .gt. 0. ) 
     &    GR3FRAC( :,1 ) = GR3( :,1 ) / ( GR3(:,1) + GR3(:,2) ) ! Aitken Growth
      Where ( GR3( :,2 ) .gt. 0. )
     &    GR3FRAC( :,2 ) = GR3( :,2 ) / ( GR3(:,1) + GR3(:,2) ) ! Accumulation Growth

      ! Initialize drog from ORGPROD and change units to [ ug / m**3 ]
      ! Assignment of drog to totrog. This moving mass from the reactive
      ! gas tracer species to the array that will be multiplied by alpha
      ! to give newly formed semivolatile vapors.
      totrog( : ) = rog_dconc( : ) * rog_ppm2ug( : ) * convfac

      ! Transfer non-volatile products directly to aerospc_conc array (2nd mode)
      Do i = 1, n_oa
         If ( oaspc( i )%nonvol .and. oaspc( i )%alpha .gt. 0. ) Then
            aerospc_conc( map_OAtoAERO( i ),2 ) =
     &      aerospc_conc( map_OAtoAERO( i ),2 )
     &      + oaspc( i )%alpha * totrog( i )
         End If
      End Do

      ! Equilibrium Partitioning Calculations

      ! Initial guess of caer is computed as follows:
      !    From eqn (8) of Schell et al. (2001)
      !    caer = ctotf - c0 * (caer/MW) / totorg
      !    Assuming totorg doesn't change during the timestep,
      !    caer * (1 + c0/MW / totorg) = ctotf
      !    caer = ctotf / ( 1 + c0/MW / totorg )

      threshold = 0.0  ! This threshold will be compared to the
                       ! saturation concentration to determine whether
                       ! or not OA partitioning is even likely.
      upb = 0.0  ! Upper bound for bisection method

      ! Compute the number of nonvolatile and total organic compound
      ! moles in the system
      nsvol    = 0
      totorgnv = sum( sum( aerospc_conc( :,1:2 ),2 ) / aerospc_mw( : ), 
     &                     mask=lnonvol_oa( : ) )  
      totorg   = sum( sum( aerospc_conc( :,1:2 ),2 ) * aerospc_mwinv( : ), 
     &                     mask=aerospc(:)%om )  

      ! Calculate the Initial Partitioning of Each Semivolatile
      ! Compound
      Do i = 1, n_oa
        n = map_OAtoAERO( i )
        if ( .not.oaspc( i )%nonvol ) Then
          nsvol = nsvol + 1
          svname( nsvol ) = oaspc( i )%name

          ! Sum particle-phase and total organic mass for this
          ! semivolatile species
          caer0( nsvol ) = aerospc_conc( n,2 ) + aerospc_conc( n,1 )
          ctoti( nsvol ) = og_conc( i ) + 
     &                     aerospc_conc( n,2 ) + aerospc_conc( n,1 )

          ! Calculate C* at current temperature
          tempcorr      = tt1 * Exp( oaspc( i )%enth * rgas1 * tt2 )
          c0( nsvol )   = oaspc( i )%cstar * tempcorr      ! Satn Conc. [ug/m3]
          prod( nsvol ) = oaspc( i )%alpha * totrog( i )   ! Total Vapor Produced [ug/m3]
          ctotf( nsvol )= ctoti( nsvol ) + prod( nsvol )   ! Vapor + Particle [ug/m3]
          threshold  = threshold +  ctotf( nsvol ) / c0( nsvol )
         
          ! Partition semivolatile species accordingly
          faer   = totorg                                  ! initial fraction in aerosol
     &              / (totorg + c0( nsvol ) * mw_inv( i ) ) 

          caer( nsvol )  = ctotf( nsvol ) * faer           ! initial amount in aerosol
          upb        = upb + ctotf( nsvol ) * mw_inv( i )  ! upper bound: just semivolatile
                                                           !  moles for now. Nonvolatile moles 
                                                           !  will be added later.
          svmw_inv( nsvol ) = mw_inv( i )
          svmw( nsvol ) = op_mw( i )
        end if
      End Do

      ! Check If gas/particle equilibrium can be established
      If ( ( threshold .Gt. 1.0 ) .Or. ( totorgnv .Gt. threshmin ) ) Then

        ! Perform one of two methods for partitioning
        If ( newtpartition ) Then

          ! METHOD1
          ! Calculate new SOA by partitioning. This method uses a globally convergent
          ! Newton-Raphson method coded by Dr Benedikt Schell to solve the nonlinear
          ! quadratic system shown in eqn 8 of Schell et al:
          !    A(i)  * caer(i) ** 2 + B * caer(i) + C(i) = 0.0,
          !    where B(i) contains the sum of all caer(j), for j not equal to i.

          Call newt( layer, caer, nsvol, check,
     &               ctotf, c0, svmw_inv, totorgnv )
          If ( check ) Then
             ! Try again with initial guess of 50/50 gas/aerosol split.
             Do i = 1, nsvol
                caer( i ) = 0.5 * ctotf( i )
             End Do
             Call newt( layer, caer, nsvol, check,
     &                  ctotf, c0, svmw_inv, totorgnv )
             If ( check ) Then
                Write( xmsg,'( A,I4 )' ) 
     &                 ' *** Problem in NEWT at Layer = ', layer
                Call m3exit( pname, 0, 0, xmsg, xstat3 )
             End If
          End If

        Else
            
          ! METHOD2
          !      Calculate new SOA by partitioning.
          !      Method uses bisection method to solve for total number of moles
          !      of orgaic aerosol. Caer is then calculated based on that number.
          !         Solve for total number of organic moles in aerosol (hotp 7/5/11)
          lowb      = totorgnv   ! lower: moles of nonvolatile
          upb       = lowb + upb ! upper: all moles (semi and nonvolatile)
          If ( abs( upb - lowb ) .Lt. threshmin ) Then
            ! no SOA to partition
            orgmoles = ( lowb + upb ) / 2.0
          Else
            upb       = upb * ( 2.0 + 1.0e-7 * real(n_oa) ) ! prevent numerical issues
            orgmoles = soabisect( lowb, upb, totorgnv, nsvol, c0, ctotf, svmw )
          End If

          ! Determine concentration of each semivoltile (hotp 7/5/11)
          Do i = 1, nsvol
            faer = svmw(i) * orgmoles / 
     &             ( c0( i ) + svmw(i) * orgmoles )
            caer( i ) = ctotf( i ) * faer
          End Do

        End If  ! End OA paritioning solver METHOD selection

        ! Constrain caer to values between conmin and ctotf
        nsvol = 0
        Do i = 1, n_oa
           If ( oaspc( i )%nonvol ) Cycle
           nsvol = nsvol + 1

           ! Check that the mass of aerosol left has not gone below a
           ! minimum value
           If ( caer( nsvol ) .Lt. tiny(0.0) ) Then
              Write( logdev,* ) 'caer less than zero for OA species: ', 
     &                              oaspc( i )%name, ' ', caer( nsvol ),
     &                              ' reset to evapmin.'
              ctotf( nsvol ) = ctotf( nsvol ) - caer( nsvol ) + evapmin
              caer( nsvol ) = evapmin
           End If

           ! Check that the mass of aerosol condensed does not exceed
           ! the total
           If ( caer( nsvol ) - ctotf( nsvol ) .Gt. tiny(0.0) ) Then
               Write( logdev,* ) 'caer exceeds ctotf at i = ', i
               Write( logdev,* ) 'caer: ', caer( nsvol ), ' ctotf: ', ctotf( nsvol )
               Write( logdev,* ) 'caer reset to ctotf'
               caer( nsvol ) = ctotf( nsvol )
           End If


           ! Calculate total change in OA Species Concentration
           dcaer = caer( nsvol ) - caer0( nsvol )  

           ! Sum the total aerosol mass of this compound across all
           ! aerosol modes
           indx = map_OAtoAERO( i )
           totaer = max( sum( aerospc_conc( indx,: ) , mask = 
     &                 .NOT.aero_missing( indx,: ) ), conmin )
    
           ! Transfer the semivolatile mass
           Do im = 1,2
              If ( aero_missing( indx,im ) ) Cycle
              If ( dcaer .lt. 0.0 ) Then
                 ! Evaporate using mode-dependent mass fraction
                 Phi = aerospc_conc( indx,im ) / totaer
                 aerospc_conc( indx,im ) = 
     &                aerospc_conc( indx,im ) + dcaer * Phi
              Else
                 ! Condense using mode-dependent condensaiton flux 
                 ! fraction
                 aerospc_conc( indx,im ) = aerospc_conc( indx,im ) 
     &                + dcaer * GR3FRAC( i,im )
              End If
           End Do

           og_conc( i ) = ctotf( nsvol ) - caer( nsvol )
        End Do  ! Partitioning Vapor Loop
 
      Else   ! threshold not exceeded; no material transferred to aerosol phase
        
        nsvol = 0
        Do i = 1, n_oa
            if ( oaspc( i )%nonvol ) Cycle
            nsvol = nsvol + 1
            indx = map_OAtoAERO( i )

            ! Set all semivolatile aerosols to minimum concentration
            aerospc_conc( indx, 1:n_mode ) = conmin
            ! Sum up particle-phase mass to subtract it from available
            ! vapor
            og_conc( i ) = ctotf( nsvol ) -
     &                       sum( aerospc_conc( indx,: ), 
     &                            mask=.not.aero_missing( indx,: ) )
        End Do

      End If    ! check on equilibrium threshold


      ! Add uptake of water onto hydrophillic organics (see Petters and
      ! Kreidenweis 2007 ACP and Pye et al. 2017 ACP for method).
      ! Uptake of water onto inorganic species is calculated elsewhere
      ! using ISORROPIA.
      If ( aorgh2o_idx > 0 ) Then

         kappaVorg = 0.0e0 ! units: m3.spec/m3.air
         totvol    = 0.0e0 ! units: m3.particle/m3.air

         im = 2 ! only compute water for accumulation mode OM

         ! Compute sum_i(Kappa_i*Vorg_i) for all OM species except POC 
         ! and PNCOM, which will be handled next.
         Do i = 1, n_aerospc
           If(  aerospc( i )%tracer )cycle
              totvol = totvol + aerospc_conc(i, im ) /
     &                 aerospc( i )%density * 1.0e-9
           If( aerospc( i )%OM .and. 
     &         i .ne. apoc_idx .and. i .ne. apncom_idx ) Then
              kappaVorg = kappaVorg + aerospc( i )%kappaorg *
     &                    aerospc_conc( i, im ) / aerospc( i )%density*1.0e-9
           End If
         End Do

         ! Account for Kappa of Nonvolatile POC and PNCOM species. This
         ! must be done separately because PNCOM has infinite OM:OC
         poa = aerospc_conc( apoc_idx, im ) + aerospc_conc( apncom_idx, im )
         kappaVorg = kappaVorg + 
     &               (0.11*poa / ( aerospc_conc(apoc_idx, im ) + tiny(0.0) ) -0.10)
     &               * (aerospc_conc( apncom_idx, im ) / aerospc( apncom_idx )%density +
     &                  aerospc_conc( apoc_idx,   im ) / aerospc( apoc_idx )%density )*1.0e-9

         ! Calculate Aggregate Kappa and volume Equivalent Diameter
         overallkappa = kappaVorg/totvol
         numparticles = moment0_conc( im )
         diam         = (6.0*totvol/numparticles/ pi ) ** (1.0/3.0)

         ! Compute aerosol water (Eq 3 of Petters and Kreidenweis)
         relhumid = min( airRH, 0.95 ) ! Cap RH at 95% to be conservative regarding uptake
         aw = activityw( relhumid, airtemp, diam ) ! activity of water
         If( overallkappa .gt. 1e-6 ) then ! prevents situation of little uptake
            aerospc_conc( aorgh2o_idx, im ) = aerospc( aorgh2o_idx )%density
     &       * aw/(1.0-aw) * kappaVorg * 1.0e9
         Else
            aerospc_conc( aorgh2o_idx, im ) =  conmin ! no significant orgwater
         End If

      End If ! End organic water uptake

      ! Update 3rd moment, 2nd moment, and Dg in CBLK array by assuming that SOA
      ! condensation/evaporation does not affect the geometric standard deviation.

      ! Get new third moment of all species, do not get second moment
      ! directly from the calcmoments diagnostic. Instead, update it
      ! manually to account for condensation in ORGAER.
      Call calcmoments( .true. )
      m3wet_final( : ) = moment3_conc( 1:2 )
      m2wet_final( 1 ) = m2wet_init( 1 ) * ( m3wet_final( 1 ) /
     &                     m3wet_init( 1 ) ) ** ( 2.0 / 3.0 )
      m2wet_final( 2 ) = m2wet_init( 2 ) * ( m3wet_final( 2 ) / 
     &                     m3wet_init( 2 ) ) ** ( 2.0 / 3.0 )
      moment2_conc( 1:2 )  = m2wet_final( : )

      ! Update Budget Variables
      DO IM = 1,N_MODE
        COND_BUDGET( AERONUM_MAP( IM ) )  = MOMENT0_CONC( IM ) - CBUDGET0_NUM( IM )
        COND_BUDGET( AEROSRF_MAP( IM ) )  = MOMENT2_CONC( IM ) - CBUDGET0_SRF( IM )

        DO ISPC = 1,N_AEROSPC
          IF ( AEROSPC_MAP( ISPC,IM ) .NE. 0 ) 
     &         COND_BUDGET( AEROSPC_MAP( ISPC,IM ) ) = 
     &              AEROSPC_CONC( ISPC,IM ) - CBUDGET0_MASS( ISPC,IM )
        END DO
      END DO

      Return
      End Subroutine orgaer

C-----------------------------------------------------------------------
      SUBROUTINE NEWT( LAYER, X, N, CHECK,
     &                 CTOT, CSAT, IMWCV, MINITW )

C  Description:
C   This subroutine and the underlying subprograms constitute Dr.
C   Benedikt Schell's SOA model.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 9.7, 2nd ed.
C
C  Given an initial guess X(1:N) for a root in N dimensions, find
C  the root by a globally convergent Newton's method. The vector of
C  functions to be zeroed, called FVEC(1:N) in the routine below, is
C  returned by a user-supplied subroutine that must be called FUNCV
C  and have the declaration SUBROUTINE FUNCV(N,X,FVEC). The output
C  quantity CHECK is false on a normal return and true if the
C  routine has converged to a local minimum of the function FMINV
C  defined below. In this case, user should try restarting from a
C  different initial guess.
C
C  Key Subroutines Called: FDJAC, FMINV, LNSRCH, LUBKSB, LUDCMP
C
C  Revision History:
C     In CMAQ v4.3 - v4.7.1, this subroutine was embedded in a separate
C     Fortran module entitled SOA_NEWT.  Below, the Revision History from
C     the SOA_NEWT module has been merged with the Revision History from
C     this specific subroutine.
C
C CGN 01/12/04 removed ITS from call vector, added documentation, and
C     removed extraneous lines of code
C
C SLN 09/18/07 updated NP and NPREC for compatibility with new SOA module
C
C PVB 11/19/07 renamed NP to NCVAP for consistency with ORGAER5 subroutine
C
C SH  02/10/10 embedded the old Fortran module, SOA_NEWT, into a new module,
C     SOA_DEFN, so all SOA-related code can be found in one file.  Renamed
C     NCVAP to n_oa.  Its value is now set in SOA_DEFN (instead of inside
C     this subroutine).  Added TOLX to the call vector of Subroutine LNSRCH,
C     since that parameter is now set in this subroutine (instead of in the
C     Fortran module).
C
C  References:
C   1. Schell, B., I. J. Ackermann, H. Hass, F. S. Binkowski, and
C      A. Abel, Modeling the formation of secondary organic aerosol
C      within a comprehensive air quality modeling system, J. Geophys.
C      Res., Vol 106, No D22, 28275-28293, 2001.

      IMPLICIT NONE

C  Arguments

      INTEGER LAYER      ! model layer
      INTEGER N          ! dimension of problem
      REAL X( N )        ! initial guess of CAER
      LOGICAL CHECK
      REAL CTOT( N )     ! total concentration GAS + AER + PROD
      REAL CSAT( N )     ! saturation conc. of cond. vapor [ug/m^3]
      REAL IMWCV( N )    ! inverse molecular weights
      REAL MINITW        ! weighted initial mass

C  Following Numerical recipes

      Integer NN
      REAL :: FVEC( N )               ! vector of functions to be zeroed
      ! COMMON /NEWTV/ FVEC(n_oa), NN
      ! SAVE /NEWTV/

C  Parameters
      INTEGER, PARAMETER :: MAXITS = 100  ! maximum number of iterations
      REAL, PARAMETER :: TOLF = 1.0E-09   ! convergence criterion on fxn values
      REAL, PARAMETER :: TOLMIN = 1.0E-12 ! criterion whether spurious conver-
                                          ! gence to a minimum has occurred
      REAL, PARAMETER :: TOLX = 1.0E-10   ! convergence criterion on delta_x
      REAL, PARAMETER :: STPMX = 100.0    ! scaled maximum step length allowed

C  Local variables
      REAL :: CT( N ), CS( N ), IMW( N ), M
      ! REAL CS
      ! REAL IMW
      ! REAL M
      ! COMMON /NEWTINP/ CT( n_oa ), CS( n_oa ), IMW( n_oa ), M
      ! SAVE /NEWTINP/

      INTEGER I, ITS, J, INDX( N_OA )
      REAL D, DEN, F, FOLD, STPMAX, SUM, TEMP, TEST
      REAL FJAC( N_OA,N_OA )
      REAL G( N_OA), P( N_OA ), XOLD( N_OA )
!     EXTERNAL FDJAC

C-----------------------------------------------------------------------

      CHECK = .FALSE.
      M = MINITW
      DO I = 1, N
         CT( I ) = CTOT( I )
         CS( I ) = CSAT( I )
         IMW( I ) = IMWCV( I )
      END DO

      NN = N
      CALL FMINV( X,F,NN,FVEC,CT,CS,IMW,M )  ! The vector FVEC is also computed by this call
      TEST = 0.0              ! Test for initial guess being a root. Use more
                              ! stringent test than simply TOLF.
      DO I = 1, N
         IF ( ABS( FVEC( I ) ) .GT. TEST ) TEST = ABS( FVEC( I ))
      END DO

      IF ( TEST .LT. 0.01 * TOLF ) RETURN  ! initial guess is a root
      SUM = 0.0                    ! Calculate STPMAX for line searches
      DO I = 1, N
         SUM = SUM + X( I ) ** 2
      END DO
      STPMAX = STPMX * MAX( SQRT( SUM ), FLOAT( N ) )
      DO ITS = 1, MAXITS           ! start of iteration loop
         CALL FDJAC( N, X, FJAC, CT, CS, IMW, M )  ! get Jacobian
         DO I = 1, N               ! compute Delta f for line search
            SUM = 0.0
            DO J = 1, N
               SUM = SUM + FJAC( J,I ) * FVEC( J )
            END DO
            G( I ) = SUM
         END DO
         DO I = 1, N               ! store X
            XOLD( I ) = X( I )
         END DO
         FOLD = F                  ! store F
         DO I = 1, N               ! right-hand side for linear equations
            P( I ) = -FVEC( I )
         END DO
         CALL LUDCMP( FJAC, N, INDX, D ) ! solve linear equations by LU decomposition
         CALL LUBKSB( FJAC, N, INDX, P )
         CALL LNSRCH( CTOT,
     &                N, XOLD, FOLD, G,  ! LNSRCH returns new X and F. It also
     &                P, X, F, STPMAX,   ! calculates FVEC at the new X when it
     &                TOLX, CHECK, FVEC,
     &                CT, CS, IMW, M)      ! calls FMINV
         TEST = 0.0
         DO I = 1, N
            IF ( ABS( FVEC( I ) ) .GT. TEST ) TEST = ABS( FVEC( I ) )
         END DO
         IF ( TEST .LT. TOLF ) THEN
            CHECK = .FALSE.
            RETURN
         END IF
         IF ( CHECK ) THEN        ! Check for gradient of F zero,
            TEST = 0.0            ! i.e., spurious convergence.
            DEN = MAX( F, 0.5 * N )
            DO I = 1, N
               TEMP = ABS( G( I ) ) * MAX( ABS( X( I ) ), 1.0 ) / DEN
               IF ( TEMP .GT. TEST ) TEST = TEMP
            END DO
            IF ( TEST .LT. TOLMIN ) THEN
               CHECK = .TRUE.
            ELSE
               CHECK = .FALSE.
            END IF
            RETURN
         END IF
         TEST = 0.0             ! Test for convergence on delta_x
         DO I = 1, N
            TEMP = ( ABS( X( I ) - XOLD( I ) ) ) / MAX( ABS( X( I ) ), 1.0 )
            IF ( TEMP .GT. TEST ) TEST = TEMP
         END DO
         IF ( TEST .LT. TOLX ) RETURN
      END DO
      WRITE( *,'(a,i2)' ) 'MAXITS exceeded in NEWT ! Layer: ', LAYER
      END SUBROUTINE NEWT

C-----------------------------------------------------------------------
      SUBROUTINE FDJAC( N, X, FJAC, CT, CS, IMW, M )

C  Description:
C    Get the Jacobian of the function

C          ( a1 * X1^2 + b1 * X1 + c1 )
C          ( a2 * X2^2 + b2 * X2 + c2 )
C          ( a3 * X3^2 + b3 * X3 + c3 )
C   F(X) = ( a4 * X4^2 + b4 * X4 + c4 ) = 0.0
C          ( ........................ )
C          ( aN * XN^2 + bN * XN + cN )
C
C    a_i = IMW_i
C    b_i = SUM(X_j * IMW_j)_j.NE.i + CSAT_i * IMW_i  + M
C          - CTOT_i * IMW_i
C
C    c_i = - CTOT_i * [ SUM(X_j * IMW_j)_j.NE.i + M ]
C
C           delta F_i    ( 2. * a_i * X_i + b_i          If i .EQ. j
C   J_ij = ----------- = (
C           delta X_j    ( ( X_i  - CTOT_i ) * IMW_j     If i .NE. j

C Revision History:
C   CGN 01/12/04 changed B1 & B2 to scalars
C   SH  02/10/10 renamed NCVAP to n_oa. Value is inherited from SOA_DEFN.

      IMPLICIT NONE

      INTEGER N                 ! dimension of problem
      REAL X( N )               ! initial guess of CAER

      REAL CT( N )
      REAL CS( N )
      REAL IMW( N )
      REAL M

      REAL FJAC( N,N )

      INTEGER I, J              ! loop index
      REAL A( N_OA )
      REAL B( N_OA )
      REAL B1
      REAL B2
      REAL SUM_JNEI

      DO I = 1, N
         A( I ) = IMW( I )
         SUM_JNEI = 0.0
         DO J = 1, N
            SUM_JNEI = SUM_JNEI + X( J ) * IMW( J )
         END DO
         B1 = SUM_JNEI - ( X( I ) * IMW( I ) )
         B2 = ( CS( I ) - CT( I ) ) * IMW( I ) + M
         B( I ) = B1 + B2
      END DO
      DO J = 1, N
         DO I = 1, N
            IF ( I .EQ. J ) THEN
               FJAC( I,J ) = 2.0 * A( I ) * X( I ) + B( I )
            ELSE
               FJAC( I,J ) = ( X( I ) - CT( I ) ) * IMW( J )
            END IF
         END DO
      END DO

      RETURN
      END SUBROUTINE FDJAC

C-----------------------------------------------------------------------
      SUBROUTINE FMINV( X,F,N,FVEC, CT, CS, IMW, M )

C Description:
C    Returns f = 0.5 * F*F at X. SR FUNCV(N,X,F) is a fixed-name,
C    user-supplied routine that returns the vector of functions at X.
C    The common block NEWTV communicates the function values back to
C    NEWT.

C Adopted from Numerical Recipes in FORTRAN, Chapter 9.7, 2nd ed.

C Key Subroutines Called: FUNCV

C Revision History:
C   YOJ 07/31/02 changed FUNCTION FMIN to SUBROUTINE FMINV to avoid errors
C       with (some) compilers
C   SH  02/10/10 renamed NCVAP to n_oa. Value is inherited from SOA_DEFN.

      IMPLICIT NONE

      INTEGER N

      REAL X( * ), F
      REAL :: FVEC( N ), CT( N ), CS( N ), IMW( N ), M

      INTEGER I
      REAL SUM
      CALL FUNCV( N, X, FVEC, CT, CS, IMW, M )
      SUM = 0.0
      DO I = 1, N
         SUM = SUM + FVEC( I ) ** 2
      END DO
      F = 0.5 * SUM
      RETURN
      END SUBROUTINE FMINV

C-----------------------------------------------------------------------
      SUBROUTINE FUNCV( N, X, FVEC, CT, CS, IMW, M )

C Description:
C   From Equation (8) of Schell et al., 2001:
C     Caer,i = Ctot,i - Csat,i * (Caer,i/MWi) /
C                             ( sum_j (Caer,j/MWj) + Cinit/MWinit)
C   Let Xi  = Caer,i
C       a_i = 1 / MWi
C       M   = Cinit/MWinit
C       CTi = Ctot,i
C       CSi = Csat,i
C   Then,
C       Xi  = CTi - CSi * (a_i * Xi) / ( sum_j (a_j * Xj) + M )
C
C   Multiply above equation by sum_j(a_j*Xj) + M and group terms
C       a_i Xi^2 + ( sum_jnei (a_j*Xj) + M + CSi*a_i - CTi*a_i ) Xi
C                - CTi * ( sum_jnei (a_j*Xj) + M ) = 0
C
C   This equation is of the form F(X) = a_i*Xi^2 + b_i*Xi + c_i = 0.
C     F(X) is stored as FVEC in this subroutine.
C
C   See also FDJAC.

C Key Subroutines Called: none

C Revision History:
C CGN 01/12/04  Added documentation, removed extraneous lines of code
C SH  02/10/10 renamed NCVAP to n_oa.  Value is inherited from SOA_DEFN

C References:
C   1. Schell, B., I. J. Ackermann, H. Hass, F. S. Binkowski, and
C      A. Abel, Modeling the formation of secondary organic aerosol
C      within a comprehensive air quality modeling system, J. Geophys.
C      Res., Vol 106, No D22, 28275-28293, 2001.

      IMPLICIT NONE

      INTEGER N
      REAL X( * )
      REAL FVEC( N )

      REAL CT( N )
      REAL CS( N )
      REAL IMW( N )
      REAL M

      INTEGER I, J
      REAL SUM_JNEI
      REAL A( N )
      REAL B( N )
      REAL C( N )

      DO I = 1, N
         A( I ) = IMW( I )
         SUM_JNEI = 0.0
         DO J  = 1, N
            SUM_JNEI = SUM_JNEI + X( J ) * IMW( J )
         END DO
         SUM_JNEI = SUM_JNEI - ( X( I ) * IMW( I ) )
         B( I ) = SUM_JNEI + M + ( CS( I ) - CT( I ) ) * IMW( I )
         C( I ) = -CT( I ) * ( SUM_JNEI + M )
         FVEC( I ) = X( I ) * ( A( I ) * X( I ) + B( I ) ) + C( I )
      END DO

      RETURN
      END SUBROUTINE FUNCV

C-----------------------------------------------------------------------
      SUBROUTINE LNSRCH( CTOT,
     &                   N, XOLD, FOLD, G, P,
     &                   X, F, STPMAX, TOLX, CHECK, FVEC,
     &                   CT, CS, IMW, M )

C Description:
C   Given an n-dimensional point XOLD(1:N), the value of the function
C   and gradient there, FOLD and G(1:N), and a direction P(1:N),
C   finds a new point X(1:N) along the direction P from XOLD where
C   the function FUNC has decreased 'sufficiently'. The new function
C   value is returned in F. STPMAX is an input quantity that limits
C   the length of the steps so that you do not try to evaluate the
C   function in regions where it is undefined or subject to overflow.
C   P is usually the Newton direction. The output quantity CHECK is
C   false on a normal exit. It is true when X is too close to XOLD.
C   In a minimization algorithm, this usually signals convergence and
C   can be ignored. However, in a zero-finding algorithm the calling
C   program should check whether the convergence is spurious.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 9.7, 2nd ed.

C Key Subroutines Called: FUNCV

C Revision History:
C   SH  02/10/10 added TOLX to the call vector.  In previous versions, this
C       parameter was declared in the Module SOA_NEWT (which contained this
C       subroutine).

      IMPLICIT NONE

      INTEGER N
      REAL TOLX
      LOGICAL CHECK
      REAL F, FOLD, STPMAX
      REAL G( N ), P( N ), X( N ), XOLD( N )
      REAL CTOT( N )
      REAL, PARAMETER :: ALF = 1.E-04
      REAL, PARAMETER :: CONMIN = 1.E-30
      REAL :: FVEC( N ), CT( N ), CS( N ), IMW( N ), M

      INTEGER I
      REAL A, ALAM, ALAM2, ALAMIN, B, DISC
      REAL F2, FOLD2, RHS1, RHS2, SLOPE
      REAL SUM, TEMP, TEST, TMPLAM

      CHECK = .FALSE.
      SUM = 0.0
      DO I = 1, N
         SUM = SUM + P( I ) * P( I )
      END DO
      SUM = SQRT( SUM )
      IF ( SUM .GT. STPMAX ) THEN
         DO I = 1, N
            P( I ) = P( I ) * STPMAX / SUM
         END DO
      END IF
      SLOPE = 0.0
      DO I = 1, N
         SLOPE = SLOPE + G( I ) * P( I )
      END DO
      TEST = 0.0
      DO I = 1, N
         TEMP = ABS( P( I ) ) / MAX( ABS( XOLD( I ) ), 1.0 )
         IF ( TEMP .GT. TEST ) TEST = TEMP
      END DO
      ALAMIN = TOLX / TEST
      ALAM = 1.0

101   CONTINUE

C  avoid negative concentrations and set upper limit given by CTOT.

      DO I = 1, N
         X( I ) = XOLD( I ) + ALAM * P( I )
         IF ( X( I ) .LE. 0.0 )       X( I ) = CONMIN
         IF ( X( I ) .GT. CTOT( I ) ) X( I ) = CTOT( I )
      END DO
      CALL FMINV( X,F,N,FVEC,CT,CS,IMW,M )
      IF ( ALAM .LT. ALAMIN ) THEN
         DO I = 1, N
            X( I ) = XOLD( I )
         END DO
         CHECK = .TRUE.
         RETURN
      ELSE IF ( F .LE. FOLD + ALF * ALAM * SLOPE ) THEN
         RETURN
      ELSE
         IF ( ALAM .EQ. 1.0 ) THEN
            TMPLAM = -SLOPE / ( 2.0 * ( F - FOLD - SLOPE ) )
         ELSE
            RHS1 = F - FOLD - ALAM * SLOPE
            RHS2 = F2 - FOLD2 - ALAM2 * SLOPE
            A = ( RHS1 / ALAM ** 2 - RHS2 / ALAM2 ** 2 ) / ( ALAM - ALAM2 )
            B = ( -ALAM2 * RHS1 / ALAM ** 2 + ALAM * RHS2 / ALAM2 ** 2 )
     &        / ( ALAM - ALAM2 )
            IF ( A .EQ. 0.0 ) THEN
               TMPLAM = -SLOPE / ( 2.0 * B )
            ELSE
               DISC  = B * B - 3.0 * A * SLOPE
               TMPLAM = ( -B + SQRT( DISC ) ) / ( 3.0 * A )
            END IF
            IF ( TMPLAM .GT. 0.5 * ALAM ) TMPLAM = 0.5 * ALAM
         END IF
      END IF
      ALAM2 = ALAM
      F2 = F
      FOLD2 = FOLD
      ALAM = MAX( TMPLAM, 0.1 * ALAM )
      GO TO 101

      END SUBROUTINE LNSRCH

C-----------------------------------------------------------------------
      SUBROUTINE LUBKSB( A, N, INDX, B )

C Description:
C   Solves the set of N linear equations A * X = B. Here A is input,
C   not as the matrix A but rather as its LU decomposition,
C   determined by the routine LUDCMP. B(1:N) is input as the right-
C   hand side vector B, and returns with the solution vector X. A, N,
C   and INDX are not modified by this routine and can be left in
C   place for successive calls with different right-hand sides B.
C   This routine takes into account the possibility that B will begin
C   with many zero elements, so it is efficient for use in matrix
C   inversion.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 2.3, 2nd ed.
C
C Key Subroutines Called: none
C
C Revision History:
C    call vector modified to remove NCVAP and set dimensions to N.

      IMPLICIT NONE

      INTEGER N, INDX( N )
      REAL A( N,N ), B( N ) ! A now has dimension NxN.

      INTEGER I, II, J, LL
      REAL SUM

      II = 0
      DO I = 1, N
         LL = INDX( I )
         SUM = B( LL )
         B( LL ) = B( I )
         IF ( II .NE. 0 ) THEN
            DO J = II, I-1
               SUM = SUM - A( I,J ) * B( J )
            END DO
         ELSE IF ( SUM .NE. 0 ) THEN
            II = I
         END IF
         B( I ) = SUM
      END DO
      DO I = N, 1, -1
         SUM = B( I )
         DO J = I+1, N
            SUM = SUM - A( I,J ) * B( J )
         END DO
         B( I ) = SUM / A( I,I )
      END DO

      RETURN
      END SUBROUTINE LUBKSB

C-----------------------------------------------------------------------
      SUBROUTINE LUDCMP( A, N, INDX, D )

C Description:
C   Given a matrix A(1:N,1:N), with physical dimension N by N, this
C   routine replaces it by the LU decomposition of a rowwise
C   permutation of itself. A and N are input. A is output arranged as
C   in equation (2.3.14) above; INDX(1:N) is an output vector that
C   records vector that records the row permutation effected by the
C   partial pivoting; D is output as +-1 depending on whether the
C   number of row interchanges was even or odd, respectively. This
C   routine is used in combination with SR LUBKSB to solve linear
C   equations or invert a matrix.
C
C  Adopted from Numerical Recipes in FORTRAN, Chapter 2.3, 2nd ed.

C  Equation (2.3.14) Numerical Recipes, p 36:
C   | b_11 b_12 b_13 b_14 |
C   | a_21 b_22 b_23 b_24 |
C   | a_31 a_32 b_33 b_34 |
C   | a_41 a_42 a_43 b_44 |

C Key Subroutines Called: None

C Revision History:
C    call vector modified to remove NCVAP
C    all dimensions now depend upon N only

      IMPLICIT NONE

      INTEGER N, INDX( N )
!     INTEGER NMAX
!     PARAMETER ( NMAX = 10 )   ! largest expected N
      REAL D, A( N,N )     ! note that A now has dimension NxN
                           ! NCVAP is ignored
      REAL, PARAMETER :: TINY = 1.0E-20

      INTEGER I, IMAX, J, K
      REAL AAMAX, DUM, SUM, VV( N )

      D = 1.0
      DO I = 1, N
         AAMAX = 0.0
         DO J = 1, N
            IF ( ABS(A( I,J ) ) .GT. AAMAX ) AAMAX = ABS( A( I,J ) )
         END DO
         IF ( AAMAX .EQ. 0.0 ) THEN
            WRITE( *,'(a)' ) '*** Singular matrix in ludcmp!'
         END IF
         VV( I ) = 1.0 / AAMAX
      END DO
      DO J = 1, N
         DO I = 1, J-1
            SUM = A( I,J )
            DO K = 1, I-1
               SUM = SUM - A( I,K ) * A( K,J )
            END DO
            A( I,J ) = SUM
         END DO
         AAMAX = 0.0
         DO I = J, N
            SUM = A( I,J )
            DO K = 1, J-1
               SUM = SUM - A( I,K ) * A( K,J )
            END DO
            A( I,J ) = SUM
            DUM = VV( I ) * ABS( SUM )
            IF ( DUM .GE. AAMAX ) THEN
               IMAX = I
               AAMAX = DUM
            END IF
         END DO
         IF ( J .NE. IMAX ) THEN
            DO K = 1, N
               DUM = A( IMAX,K )
               A( IMAX,K ) = A( J,K )
               A( J,K ) = DUM
            END DO
            D = -D
            VV( IMAX ) = VV( J )
         END IF
         INDX( J ) = IMAX
         IF ( A( J,J ) .EQ. 0.0 ) A( J,J ) = TINY
         IF ( J .NE. N ) THEN
            DUM = 1.0 / A( J,J )
            DO I = J+1, N
               A( I,J ) = A( I,J ) * DUM
            END DO
         END IF
      END DO

      RETURN
      END SUBROUTINE LUDCMP

C-----------------------------------------------------------------------
      Function soabisect( lowerb, upperb, nonvolmol, n, cstaratt, totsemivol,
     &                    mlwt) RESULT ( nroot )

C     Determines the root of an equation, nroot, that is located
C     between the lowerb and upperb. The equation of interest is defined
C     in the function soaequation. Before calling soabisect, the threshold 
C     for SOA should have already been checked which should ensure a solution.
C     The recommended lower bound is the number of moles of nonvolatile aerosol
C     and the recommended upper bound is the total number of organic moles
C
C     History
C     Created 7/2011 by HOT Pye

      Use utilio_defn

      Implicit None

C     Function arguments
      Real, Intent(IN) :: lowerb, upperb      ! lower bound, upper bound 
      Real, Intent(IN) :: nonvolmol           ! nonvolatile aerosol in moles = POA + non-voltile SOA
      Integer, Intent(IN) :: n
      Real, Intent(IN) :: cstaratt(n)   ! Cstars at T of interest
      Real, Intent(IN) :: totsemivol(n) ! total semivolatile to partition in ug/m3 (gas+aer+newlyformed)
      Real, Intent(IN) :: mlwt(n)       ! molecular weight of semivolatiles 

C     Parameters for solution convergenc
      Real             :: FRACTOL = 1.0e-6    ! Solution converged if abs(old-new)/new < FRACTOL
!     Real             :: ABSTOL  = 1.0e-10   ! Solution converged if there are less than ABSTOL umol/m3 in aerosol
      Real             :: ABSTOL  = 1.0e-08   ! Solution converged if there are less than ABSTOL umol/m3 in aerosol

C     Result
      Real             :: nroot               ! solution (final nguess)

C     Local variables
      Real             :: nguess              ! current guess for total moles organic aerosol
      Real             :: oldn, lower, upper, flower, fnguess ! intermediate values
      Real             :: fupper              ! function evaluated at upper bound
      Real             :: ea                  ! difference b/w old and new guesses (umol/m3)
      Real             :: test                ! to detect sign change
      Integer          :: iter                ! counter to prevent infinite loops
      Character( 120 ) :: xmsg

C     Store current lower and upper bound, evaluate at lower bound 
      lower  = lowerb
      upper  = upperb
      flower = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, lowerb )
      fupper = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, upperb )

C     First guess: solution at upperb
      nguess = upperb

C     Counter of iterations to prevent infinite loops
      iter = 0

C     Iterate until the number of moles changes by less than fractol (percent) or
C     abstol (absolute) amount
      Do

        If ( flower * fupper .gt. 0.0 ) Then
           ! function does not change sign between bounds
#ifdef verbose_soa
           nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
           Write( xmsg,'(a,2(1pe15.5))' )
     &           'Error: no solution between bounds in soa bisection:', flower, fupper
#else
           xmsg = 'Error: no solution between bounds in soa bisection'
#endif
           Call m3exit( pname, 0, 0, xmsg, xstat3)
        End If

        iter   = iter + 1
        oldn   = nguess                     ! store last guess
        nguess = ( lower + upper ) / 2.0e0  ! new guess is halfway b/w old lower and upper
        fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess
        If ( nguess .ne. 0.0 ) Then            ! safe division
           ea = Abs( nguess - oldn ) / nguess  ! fractional diff b/w 2 guesses
        Else
#ifdef verbose_soa
          nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
          Write( xmsg,'(a,1pe15.5)' )
     &       'Warning: number of organic aerosol moles going to zero in soa bisection:',
     &        nroot
#else
          xmsg = 'Warning: number of organic aerosol moles going to zero in soa bisection'
#endif
          Call m3exit( pname, 0, 0, xmsg, xstat3 )
        End If

        test = fnguess * flower
        If ( test .Lt. 0.0 ) Then         ! if function changes sign b/w guess and lower, guess becomes upper
          upper  = nguess
          fupper = fnguess
        Else If ( test .Gt. 0.0 ) Then    ! if function does not change sign, guess becomes lowerbound
          lower  = nguess
          flower = fnguess
        Else If ( flower .Eq. 0.0 ) Then  ! if the lower bound is the root
          ea      = 0.0
          nguess  = lower
          fnguess = flower
        Else If ( fnguess .Eq. 0.0 ) Then ! guess is the root
          ea      = 0.0
        End If

        ! solution found if error is less than ABSTOL/100 % or N bounded by values less than ABSTOL
        If ( ( ea .Lt. FRACTOL ) .Or. ( ( upper + lower ) .Lt. ABSTOL ) ) Then
          nroot = nguess
          ! double check that the function is approximately zero
          fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess
          If ( Abs( fnguess ) .Gt. 1.0e-03 ) Then
!           pfc = pfc + 1
#ifdef verbose_soa
            nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
!           Write( xmsg,'(a,2(1pe15.5,i8))' )
!    &      'Warning: possible false convergence in soa bisection:', fnguess, nroot, pfc
            Write( xmsg,'(a,2(1pe15.5))' )
     &      'Warning: possible false convergence in soa bisection:', fnguess, nroot
            Call m3warn( pname, 0, 0, xmsg )
#else
            xmsg = 'Warning: possible false convergence in soa bisection'
#endif
!           Call m3warn( pname, 0, 0, xmsg )
          End If

          Return
        End If

        If ( iter .Gt. 1000000 ) Then ! stop infinite loop
#ifdef verbose_soa
          nroot = soabisect_debug(lowerb, upperb, nonvolmol, cstaratt, totsemivol, mlwt)
          Write( xmsg,'(a,i9,1pe15.5)' )
     &      'Error: too many iterations in soa bisection', iter, nroot
#else
          xmsg = 'Error: too many iterations in soa bisection'
#endif
          Call m3exit( pname, 0, 0, xmsg, xstat3 )
        End If
      End Do

      End Function soabisect

C-----------------------------------------------------------------------
      Function soaequation( nonvmol, n, cstar, semivol, mlwt, currentN ) Result ( eqnerror )

C     Evaluates the following function of total aerosol moles, N
C     Function evaluates to zero at equilibrium 
C     
C                      totalsemivol_i        mols nonvolatile POA + SOA
C     f(N) = sum_i (  ----------------   ) + ---------------------------  - 1.0 
C                     cstar_i + mw_i*N                  N
C
C     History
C     Created 7/2011 HOT Pye

      Implicit None

C     Function inputs and output
      Real, INTENT(IN) :: nonvmol, currentN             ! nonvolatile moles, total moles
      Integer, INTENT(IN) :: n                          ! number of semivolatile species
      Real, INTENT(IN) :: mlwt(n)                    ! molecular weights of semivolatiles
      Real, INTENT(IN) :: semivol(n), cstar(n) ! semivolatile mass, sat conc in ug/m3
      Real             :: eqnerror                         ! result, deviation from 0.0 in equation

C     Local variables
      Real             :: temptot                          ! temporary total
      Integer          :: i                                ! counter

C     Compute function value for current value of N 
      temptot = 0.0e0
      Do i = 1, n
         temptot = temptot + semivol(i) / ( cstar(i) + mlwt(i) * currentN )
      End Do
      eqnerror = temptot + nonvmol / currentN - 1.0e0

      End function soaequation

C-----------------------------------------------------------------------
      Function soabisect_debug( lowerb, upperb, nonvolmol, n, cstaratt, totsemivol,
     &                          mlwt) RESULT ( nroot )

      Use utilio_defn
      Use runtime_vars

      Implicit None

C     Function arguments
      Real, Intent(IN) :: lowerb, upperb      ! lower bound, upper bound
      Real, Intent(IN) :: nonvolmol           ! nonvolatile aerosol in moles = POA + non-voltile SOA
      Integer, Intent(IN) :: n                ! Number of semivolatile species
      Real, Intent(IN) :: cstaratt(:)   ! Cstars at T of interest
      Real, Intent(IN) :: totsemivol(:) ! total semivolatile to partition in ug/m3 (gas+aer+newlyformed)
      Real, Intent(IN) :: mlwt(:)       ! molecular weight of semivolatiles

C     Parameters for solution convergenc
      Real             :: FRACTOL = 1.0e-6    ! Solution converged if abs(old-new)/new < FRACTOL
      Real             :: ABSTOL  = 1.0e-10   ! Solution converged if there are less than ABSTOL umol/m3 in aerosol

C     Result
      Real             :: nroot               ! solution (final nguess)

C External functions:

C     Local variables
      Logical, Save    :: first_time = .True.

      Real             :: nguess              ! current guess for total moles organic aerosol
      Real             :: oldn, lower, upper, flower, fnguess ! intermediate values
      Real             :: fupper              ! function evaluated at upper bound
      Real             :: ea                  ! difference b/w old and new guesses (umol/m3)
      Real             :: test                ! to detect sign change
      Integer          :: iter                ! counter to preventinfinite loops
      Character( 120 ) :: xmsg

      If ( first_time )  Then
        first_time = .False.
      End If

C     Store current lower and upper bound, evaluate at lower bound
      lower  = lowerb
      upper  = upperb
      flower = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, lowerb )
      fupper = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, upperb )

C     First guess: solution at upperb
      nguess = upperb

C     Counter of iterations to prevent infinite loops
      iter = 0

C     Iterate until the number of moles changes by less than fractol
C     (percent) or abstol (absolute) amount
      Do

        If ( flower * fupper .Gt. 0.0 ) Then
          ! function does not change sign between bounds
          xmsg = 'Error: no solution between bounds in soa bisection'
          Write( logdev,* ) xmsg
        End If

        iter    = iter + 1
        oldn    = nguess                    ! store last guess
        nguess  = ( lower + upper ) / 2.0e0 ! new guess is halfway b/w old lower and upper
        fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess

        Write( logdev,* ), 'iter   ', iter
        Write( logdev,* ), 'Lower= ', lower, flower
        Write( logdev,* ), 'Upper= ', upper, fupper
        Write( logdev,* ), 'Guess= ', nguess, fnguess

        If ( nguess .Ne. 0.0 ) Then           ! safe division
          ea = ABS( nguess - oldn )/nguess   ! fractional diff b/w 2guesses
        Else
          xmsg = 'Error: number of organic aerosol moles going to zero in soa bisection'
          Write( logdev,* ) xmsg
        End If

        Write( logdev,* ) 'error', ea
        test = fnguess * flower
        If ( test .Lt. 0.0 ) Then           ! if function changes sign b/w guess and lower, guess becomes upper
          upper  = nguess
          fupper = fnguess
        Else If ( test .Gt. 0.0 ) Then      ! if function does not change sign, guess becomes lowerbound
          lower  = nguess
          flower = fnguess
        Else If ( flower .Eq. 0.0 ) Then    ! if the lower bound is the root
          ea      = 0.0
          nguess  = lower
          fnguess = flower
        Else If ( fnguess .Eq. 0.0 ) Then   ! guess is the root
          ea      = 0.0
        End If

        ! solution found if error is less than ABSTOL/100 % or N bounded
        ! by values less than 1e-08
        If ( ( ea .Lt. FRACTOL ) .Or. ( ( upper + lower ) .Lt. ABSTOL ) ) then
          nroot = nguess
          ! double check that the function is approximately zero
          fnguess = soaequation( nonvolmol, n, cstaratt, totsemivol, mlwt, nguess ) ! function evaluated at new guess
          If ( Abs( fnguess ) .Gt. 1.0e-03 ) Then
             xmsg = 'Warning: possible false convergence in soa bisection'
             Write( logdev,* ) xmsg
          End If

          Return
        End If

        If ( iter .Gt. 1000000 ) Then ! stop infinite loops
          !print*,'current lower, upper, and N: ',lower, upper, nguess
          xmsg = 'Error: too many iterations in soa bisection'
          Write( logdev,* ) xmsg
        End If
      End Do

      End Function soabisect_debug

!-----------------------------------------------

      Function activityw( rh, temp, dtot ) result( aw )

C Function calculates the activity of water
C over an aqueous solution droplet of specified diameter
C Equation 1 of Petters and Kreidenweis 2007 ACP:
C
C                   -4*surftens*Mw
C   aw  = RH * exp( ---------------)
C                     R*T*dens*D
C
C The diameter is the wet, volume equivalent, diameter of the particle.

      Implicit None
                                       
      Include SUBST_CONST    ! common constants

C     Function arguments
      Real rh      ! RH between 0.005, 0.99 [fraction]
      Real temp    ! temperature [K]
      Real dtot    ! volume equivalent diameter of entire particle [m]

C     Function return value
      Real aw      ! activity of water [fraction]

C     Local variables
      Real partialaw ! intermediate value

C     Parameters
      Real, Parameter :: surftens = 0.072e0  ! surface tension of water [J/m2]
      Real, Parameter :: mwtwater = 0.018e0  ! molecular weight of water [kg/mol]
      Real, Parameter :: denswater = 1000e0  ! density of water [kg/m3]

C     Calculations
      partialaw = 4.0*surftens*mwtwater/(rgasuniv*temp*denswater)
      aw = rh / exp( partialaw/dtot )

      End Function activityw

!-----------------------------------------------

      End Module soa_defn

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE GRID_CONF

C Define the horizontal grid and vertical layer structure by inheriting
C HGRD_DEFN and VGRD_DEFN. In addition, set up the computational blocking
C parameters.
C VGRD_DEFN replaces COORD.EXT and VGRD.EXT
C Revision History: Jeff Young 31 Jen 05: created
C.......................................................................

      USE HGRD_DEFN             ! horizontal domain specifications
      USE VGRD_DEFN             ! vertical layer specifications

      IMPLICIT NONE

!     INTEGER, PARAMETER :: BLKSIZE = 500
      INTEGER, PARAMETER :: BLKSIZE = 50
      INTEGER, SAVE :: MXCELLS
      INTEGER, SAVE :: MXBLKS

      CONTAINS

         FUNCTION GRID_INIT ( NPROCS, MYID ) RESULT ( SUCCESS )

         INTEGER :: NPROCS
         INTEGER :: MYID
         LOGICAL :: SUCCESS

         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         CHARACTER( 96 ) :: MSG = ' '

C-----------------------------------------------------------------------

C This function is expected to be called only once - at startup

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SUCCESS = .TRUE.

C Set up horizontal domain and calculate processor-to-subdomain maps
            IF ( .NOT. HGRD_INIT ( NPROCS, MYID ) ) THEN
               MSG = '*** Failure defining horizontal domain'
               CALL M3WARN ( 'GRID_INIT', 0, 0, MSG )
               SUCCESS = .FALSE.
               RETURN
               END IF

C define vertical layer structure
            IF ( .NOT. VGRD_INIT() ) THEN
               MSG = '*** Failure defining vertical structure'
               CALL M3WARN ( 'GRID_INIT', 0, 0, MSG )
               SUCCESS = .FALSE.
               RETURN
               END IF

            MXCELLS = NCOLS * NROWS * NLAYS
            MXBLKS  = 1 + ( MXCELLS - 1 ) / BLKSIZE

            ELSE
            MSG = 'Domain configuration already defined'
            CALL M3WARN ( 'GRID_INIT', 0, 0, MSG )
            SUCCESS = .FALSE.; RETURN

            END IF   ! FIRSTIME

         RETURN
         END FUNCTION GRID_INIT

      END MODULE GRID_CONF

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PAGRD_DEFN

C process analysis variables that are dependent on NCOLS, NROWS

C Preconditions: HGRD_INIT() called from PAR_INIT, which is called from DRIVER

C Revision History:
C   J.Young 17 Aug 01: create
C   D.Wong, J.Young Oct 01: set dimensions for DELC and CSAV correctly for
C   subdomain; IRROUT must have full domain because of SE_DATA_COPY in pa_output
C   J.Young 31 Jan 05: dyn alloc - establish both horizontal & vertical domain
C   specifications in one module
C   J.Young 22 Dec 05: move proc. analy. stuff from HGRD_DEFN to here. create
C   arrays COLSZ_PE and ROWSZ_PE for proc analy, which are equivalent to
C   COLSX_PE and ROWSX_PE
C   J.Young  8 Jul 10: minor mods
C   S. Roselle 29 Mar 11: Replaced I/O API include files with UTILIO_DEFN
C   J.Young 14 Sep 11: allow default subdomain values
C   J.Young 28 Jun 16: use PA_DEFN module intead of include files
C   J.Young 16 Sep 16: update for inline procan
C   C. Nolte, S. Roselle Sep 18: replace M3UTILIO with UTILIO_DEFN
C   D.Dwong 01 Feb 19: removed all MY_N clauses
C.......................................................................
      USE RUNTIME_VARS

      IMPLICIT NONE

C Total number of columns, rows and layers for PA output
      INTEGER, SAVE :: PACOLS, PAROWS, PALEVS

C Starting and ending column of local PA grid in this processor
      INTEGER, SAVE :: MY_BEGCOL, MY_ENDCOL
C Starting and ending row of local PA grid in this processor
      INTEGER, SAVE :: MY_BEGROW, MY_ENDROW
C Starting and ending layer of local PA grid in this processor
      INTEGER, SAVE :: MY_BEGLEV, MY_ENDLEV

C Starting and ending column of local IRR grid in this processor
      INTEGER, SAVE :: MY_IRR_BEGCOL, MY_IRR_ENDCOL
C Starting and ending row of local IRR grid in this processor
      INTEGER, SAVE :: MY_IRR_BEGROW, MY_IRR_ENDROW
C Starting and ending layer of local IRR grid in this processor
      INTEGER, SAVE :: MY_IRR_BEGLEV, MY_IRR_ENDLEV

C Number of columns and rows of local PA/IRR grid in this processor
      INTEGER, SAVE :: MY_PACOLS, MY_PAROWS

C column and row range for each processor
      INTEGER, ALLOCATABLE, SAVE :: COLSZ_PE( :,: ), ROWSZ_PE( :,: )

C Conc difference for a science process
      REAL, ALLOCATABLE, SAVE :: DELC( :,:,:,: )

C previous Conc in a science process
      REAL, ALLOCATABLE, SAVE :: CSAV( :,:,:,: )

C Array for outputting IRR results
      REAL, ALLOCATABLE, SAVE :: IRROUT( :,:,:,: )

C Buffer for writing IRR results
      REAL, ALLOCATABLE, SAVE :: DBUFF( :,:,: )

      CONTAINS
         FUNCTION PAGRD_INIT ( RANK ) RESULT ( SUCCESS )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
#ifdef parallel
         USE SE_MODULES          ! stenex (using SE_UTIL_MODULE)
#else
         USE NOOP_MODULES        ! stenex (using NOOP_UTIL_MODULE)
#endif
         USE PA_DEFN             ! Process Anaylsis control and data variables

         INTEGER, INTENT( IN ) :: RANK
         LOGICAL SUCCESS

         INTEGER IRCOLS
         INTEGER IRROWS
         INTEGER IRLEVS

         INTEGER, ALLOCATABLE :: NCOLS_PE( : )  ! Column range for each PE
         INTEGER, ALLOCATABLE :: NROWS_PE( : )  ! Row range for each PE

         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         INTEGER ALST
         INTEGER X1F0  ! dimension homotopy for parallel or serial
         CHARACTER( 16 ) :: PNAME = 'PAGRD_INIT'
         CHARACTER( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------

C This function is expected to be called only once - at startup

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SUCCESS = .TRUE.

            IF ( LIPR .OR. LIRR ) THEN

C Retrieve the process analysis subdomain dimensions:
               IF ( PA_ENDCOL .EQ. 0 ) PA_ENDCOL = GL_NCOLS
               IF ( PA_ENDROW .EQ. 0 ) PA_ENDROW = GL_NROWS
               IF ( PA_ENDLEV .EQ. 0 ) PA_ENDLEV = NLAYS

               IF ( PA_BEGCOL .LT. 1 .OR. PA_ENDCOL .GT. GL_NCOLS .OR.
     &              PA_BEGROW .LT. 1 .OR. PA_ENDROW .GT. GL_NROWS .OR.
     &              PA_BEGLEV .LT. 1 .OR. PA_ENDLEV .GT. NLAYS ) THEN
                  XMSG = 'Process Analysis domain inconsistent with CTM domain' 
                  CALL M3WARN ( PNAME, 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

C Determine IPR subgrid mapping with data redistribution
               CALL SUBST_SUBGRID_INDEX
     &             ( PA_BEGCOL, PA_ENDCOL, PA_BEGROW, PA_ENDROW,
     &               PA_BEGLEV, PA_ENDLEV,
     &               MY_BEGCOL, MY_ENDCOL, MY_BEGROW, MY_ENDROW,
     &               MY_BEGLEV, MY_ENDLEV, MY_PACOLS, MY_PAROWS )

               PACOLS = PA_ENDCOL - PA_BEGCOL + 1
               PAROWS = PA_ENDROW - PA_BEGROW + 1
               PALEVS = PA_ENDLEV - PA_BEGLEV + 1

               ALLOCATE ( NCOLS_PE( NPROCS ),
     &                    NROWS_PE( NPROCS ), STAT = ALST )
               IF ( ALST .NE. 0 ) THEN
                  XMSG = '*** PA_NCOLS_PE or PA_NROWS_PE Memory allocation failed'
                  CALL M3WARN ( PNAME, 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

               ALLOCATE ( COLSZ_PE( 2,NPROCS ),
     &                    ROWSZ_PE( 2,NPROCS ), STAT = ALST )
               IF ( ALST .NE. 0 ) THEN
                  XMSG = '*** COLSX_PE or ROWSX_PE Memory allocation failed'
                  CALL M3WARN ( PNAME, 0, 0, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF

C Construct the processor-to-subdomain map for IPR domain
               CALL SUBHDOMAIN( NPROCS, NPCOL, NPROW, PACOLS, PAROWS,
     &                          NCOLS_PE, NROWS_PE, COLSZ_PE, ROWSZ_PE )

               MY_PACOLS = NCOLS_PE( RANK+1 )
               MY_PAROWS = NROWS_PE( RANK+1 )

               IF ( LIPR ) THEN

                  ALLOCATE ( DELC( MY_PACOLS,MY_PAROWS,PALEVS,NIPRVAR ),
     &                       STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = '*** DELC Memory allocation failed'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  END IF

                  ALLOCATE ( CSAV( MY_PACOLS,MY_PAROWS,PALEVS,NCSAVE ),
     &                       STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = '*** CSAV Memory allocation failed'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  END IF

               END IF

               IF ( LIRR ) THEN

C Determine IRR subgrid mapping without data redistribution
                  CALL SUBST_SUBGRID_INDEX
     &                ( PA_BEGCOL, PA_ENDCOL, PA_BEGROW, PA_ENDROW,
     &                  PA_BEGLEV, PA_ENDLEV,
     &                  MY_IRR_BEGCOL, MY_IRR_ENDCOL, MY_IRR_BEGROW,
     &                  MY_IRR_ENDROW, MY_IRR_BEGLEV, MY_IRR_ENDLEV, 'N' )

                  X1F0 = ( NCOLS / GL_NCOLS ) * ( NROWS / GL_NROWS )
                  IRCOLS = X1F0 * PACOLS + ( 1 - X1F0 ) * NCOLS
                  IRROWS = X1F0 * PAROWS + ( 1 - X1F0 ) * NROWS
                  IRLEVS = PALEVS

                  ALLOCATE ( IRROUT( IRCOLS,IRROWS,IRLEVS,NIRRVAR ),
     &                       STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = '*** IRROUT Memory allocation failed'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  END IF

                  ALLOCATE ( DBUFF( MY_PACOLS,MY_PAROWS,PALEVS ), STAT = ALST )
                  IF ( ALST .NE. 0 ) THEN
                     XMSG = 'ERROR allocating DBUFF'
                     CALL M3WARN ( PNAME, 0, 0, XMSG )
                     SUCCESS = .FALSE.; RETURN
                  ENDIF

               END IF

            ELSE

               PA_BEGCOL = 1
               PA_ENDCOL = 1
               PA_BEGROW = 1
               PA_ENDROW = 1
               PA_BEGLEV = 1
               PA_ENDLEV = 1

               XMSG = 'No Process Analysis for this run'
               CALL M3WARN ( PNAME, 0, 0, XMSG )
               SUCCESS = .TRUE.; RETURN

            END IF

         ELSE   ! called more than once

            XMSG = 'Horizontal domain dependent variables already allocated'
            CALL M3WARN ( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN

         END IF   ! FIRSTIME

         RETURN
         END FUNCTION PAGRD_INIT

      END MODULE PAGRD_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/emis/emis/cropcal.F,v 1.4 2012/01/19 15:23:37 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine cropcal ( jdate, jtime, agland )

C-----------------------------------------------------------------------
C Description:
C   Read cropland fraction from BELD and 3 gridded crop calendar files
C   and calculate erodible agriculture land fraction
 
C Revison History:
C      2003 Shan He at RTP: initial
C      2003 Daniel Tong:
C  Jan 2011 Jeff Young: mods for inline wind-blown dust module
C  Apr 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  Jul 2011 J.Young: pad vnmld and vcrop for uniform string lengths
C  Jan 2012 J.Young: pad vnmld and vcrop for 16 char string lengths
C  Jun 2012 J.Young: remove full character blank padding put in for GNU Fortran (GCC) 4.1.2
C  Feb 2019 D.Wong: Implemented centralized I/O approach, and created
C                   a new module crop_data_module (model_data_module.F) 
C                   to hold some of information originally stored here 
C                   to avoid cyclic dependence
 
C Subroutines and Functions Called:
C   open3, xtract3, m3exit
C-----------------------------------------------------------------------

      use hgrd_defn             ! horizontal domain specifications
      use utilio_defn
      use crop_data_module

      implicit none

C Includes:
!     include 'DUST_CONST.EXT'

C Arguments:
      integer, intent(  in ) :: jdate   ! current date, coded YYYYDDD
      integer, intent(  in ) :: jtime   ! current model time, coded HHMMSS
      real,    intent( out ) :: agland( :,: ) ! total erodible crop land fraction

C Local Variables:
      character(  16 ) :: pname = 'CROPCAL         '
      character(  16 ) :: dust_lu_1 = 'DUST_LU_1'
      character( 120 ) :: xmsg = ' '

      real    jday                 ! Julian day of the year converted to REAL
      real    ttmp
      real    twos                 ! two season factor (1.0 or 0.5)
      real    pctf, potf           ! ?? ?? Tillage Factor ????????
      integer i, m, c, r
      
      real :: crpdt1, crpdt2, crpdt3        ! cropland calendar subexpression

      integer allocstat

C-----------------------------------------------------------------------

C Get day number in year
      jday = float( mod( jdate,1000 ) )

C Calculate erodible ag land fraction
      do r = 1, nrows
      do c = 1, ncols
         agland( c,r ) = 0.0
         ttmp = 0.0
         pctf = 0.0
         potf = 0.0
         do i = 1, nlcrp
            crplnd( c,r,i ) = 0.0
            if ( crop_ladut( c,r,i ) .gt. 0.0 ) then  ! non zero crop cover begin if1
               if ( i .eq.  1 ) m = 1      ! Alfalfa
               if ( i .eq.  2 ) m = 2      ! Barley spring fall
               if ( i .eq.  3 ) m = 4      ! Corn
               if ( i .eq.  4 ) m = 5      ! Cotton
               if ( i .eq.  5 ) m = 6      ! Grass as hay
               if ( i .eq.  6 ) m = 6      ! Hay
               if ( i .eq.  7 ) m = 15     ! Misc_crop as sugerbeets
               if ( i .eq.  8 ) m = 7      ! Oats spring fall
               if ( i .eq.  9 ) m = 6      ! Pasture
               if ( i .eq. 10 ) m = 9      ! Peanuts
               if ( i .eq. 11 ) m = 10     ! Potatoes
               if ( i .eq. 12 ) m = 11     ! Rice
               if ( i .eq. 13 ) m = 12     ! Rye
               if ( i .eq. 14 ) m = 13     ! Sorghum
               if ( i .eq. 15 ) m = 14     ! Soybeans
               if ( i .eq. 16 ) m = 16     ! Tobacco
               if ( i .eq. 17 ) m = 17     ! Wheat spring winter

               crpdt1 = cropdt( c,r,m,1 )
               if ( crpdt1 .eq. 0.0 ) go to 7744

3344           continue

               crpdt2 = cropdt( c,r,m,2 )
               crpdt3 = cropdt( c,r,m,3 )

               ! extend planting end day if needed
               if ( ( crpdt1 .lt. crpdt2 ) .and.
     &                crpdt2 .lt. ( crpdt1 + 14.0 ) ) then
                  crpdt2 = crpdt2 + 14.0
                  if ( crpdt2 .gt. 365.0 ) crpdt2 = 365.0 - crpdt2
               end if

               if ( ( crpdt1 + 14.0 ) .gt. 365.0 ) then
                  xmsg = '*** Error in cropland erodibility'
                  call m3exit ( pname, jdate, jtime, xmsg, xstat1 )
               end if

               ! before planting after harvest BEGIN IF2
               if ( ( ( crpdt1 .lt. crpdt3 ) .and.
     &                ( jday .le. crpdt1 .or.
     &                  jday .ge. crpdt3 ) ) .or.
     &                ( ( crpdt1 .gt. crpdt3 ) .and.
     &                ( jday .ge. crpdt1 .and.
     &                  jday .le. crpdt3 ) ) ) then
                  pctf = 1.0
                  potf = 0.0
                  ! other than cotton, peanut, potato, tobacco IF2
                  if ( ( i .ne. 4 .and. i .ne. 10 .and. i .ne. 11 .and. i .ne. 16 ) .and.
     &                 ( ( crpdt1 .lt. crpdt3 .and.
     &                   ( jday .le. ( crpdt1 - 7.0 ) .or.
     &                     jday .ge. ( crpdt3 + 14.0 ) ) ) .or.
     &                   ( crpdt1 .gt. crpdt3 .and.
     &                   ( jday .le. ( crpdt1 - 7.0 ) .and.
     &                     jday .ge. ( crpdt3 + 14.0 ) ) ) ) )
     &               pctf = 0.0
               else if ( jday .ge. crpdt1 .and.
     &                   jday .le. ( crpdt1 + 14.0 ) ) then   ! in 2 weeks after planting if2
                  ttmp = ( jday - crpdt1 ) / 14.0
                  pctf = 1.0
                  potf = 0.6 * ttmp
               else if ( crpdt1 .lt. crpdt2 ) then  ! planting end same year if2
                  if ( jday .ge. ( crpdt1 + 14.0 ) .and.
     &                 jday .le. crpdt2 ) then   ! after 2 weeks planting to the end planting begin if3
                     ttmp = (   jday - ( crpdt1 + 14.0 ) )
     &                    / ( crpdt2 - ( crpdt1 + 14.0 ) )
                     pctf = ttmp
                     potf = 0.6 * ttmp
                  else     ! in harvesting if3
                     pctf = 0.0
                     potf = 0.0
                  end if   ! if3
               else                            ! planting start this year end next if2
                  if ( jday .ge. crpdt2 ) then      ! in harvesting begin if4
                     pctf = 0.0
                     potf = 0.0
                  else                              ! in planting if4
                     if ( jday .ge. ( crpdt1 + 14.0 ) ) then  ! in planting at year end begin if5
                        ttmp = (               jday - ( crpdt1 + 14.0 ) )
     &                       / ( ( crpdt2 + 365.0 ) - ( crpdt1 + 14.0 ) )
                     else                                   ! in planting at year begin if5
                        ttmp = (   ( jday + 365.0 ) - ( crpdt1 + 14.0 ) )
     &                       / ( ( crpdt2 + 365.0 ) - ( crpdt1 + 14.0 ) )
                     end if   ! if5
                     pctf = ttmp
                     potf = 0.6 * ttmp
                  end if   ! if4
               end if   ! if2

               ! possible 2 season for barley, oats or wheat
               twos = 1.0
               if ( ( i .eq.  2 .and. cropdt( c,r, 2,1 ) .ne. 0.0 .and.
     &                                cropdt( c,r, 3,1 ) .ne. 0.0 ) .or.
     &              ( i .eq.  8 .and. cropdt( c,r, 7,1 ) .ne. 0.0 .and.
     &                                cropdt( c,r, 8,1 ) .ne. 0.0 ) .or.
     &              ( i .eq. 17 .and. cropdt( c,r,17,1 ) .ne. 0.0 .and.
     &                                cropdt( c,r,18,1 ) .ne. 0.0 ) )
     &            twos = 0.5   ! if 2 season crop then 50-50 each

               crplnd( c,r,i ) =     twos * crop_ladut( c,r,i )
     &                           * ( pctf * ctilf( i )
     &                           +   potf * ( 1.0 - ntilf( i ) - ctilf( i ) ) ) 

               agland( c,r ) = agland( c,r ) + crplnd( c,r,i )

               if ( i .eq. 2 .and. m .eq. 2 ) then          ! Barley: spring -> fall
                  m = 3
                  go to 3344
               else if ( i .eq. 8 .and. m .eq. 7 ) then     ! Oats: spring -> fall
                  m = 8
                  go to 3344
               else if ( i .eq. 17 .and. m .eq. 17 ) then   ! Wheat: spring -> winter
                  m = 18
                  go to 3344
               end if

7744           continue

            end if   ! if1
         end do   ! i
      end do   ! c
      end do   ! r

      return
      end subroutine cropcal

!--------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE VDIFFACMX ( DTSEC, SEDDY, DDEP, ICMP, CNGRD )

C-----------------------------------------------------------------------
C Asymmetric Convective Model v2 (ACM2/ACM1) -- Pleim(2006/2014)
C Function:
C   calculates vertical diffusion

C Subroutines and Functions Called:
C   SEC2TIME, TIME2SEC, WRITE3, NEXTIME,
C   M3EXIT, EDDYX, TRI, MATRIX, PA_UPDATE_EMIS, PA_UPDATE_DDEP

C Revision History:
C   Analogous to VDIFFACM2
C 11 Apr 13 J.Young: fix double adjustment of conc for DDBF in heterogeneous HONO
C           if-then-else clauses; eliminate some white space
C 13 May 13 J.Young: access met data from VDIFF_MET module
C                    change CRANKP to THBAR, CRANKQ to THETA
C 25 May 13 J.Young: re-do the acm/eddy algorithm for computational efficiency
C 30 Apr 14 J.Young: switch THBAR and THETA
C  2 May 14 J.Pleim, J.Young: replace the banded tridiagonal matrix solver for the
C           convective PBL, with the ACM1 matrix solver followed by the tridiagonal
C           matrix solver
C   30 May 14 J.Young: split vdiff calculation out of vdiff proc.
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C   02 Nov 2018: L.Zhou, S.Napelenok: isam implementation
C   May 2019  J.Pleim Changed from sigma coords to Z coords for compatability w/ MPAS and WRF
C   12 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE CGRID_SPCS          ! CGRID mechanism species
      USE GRID_CONF
      USE EMIS_VARS, ONLY : VDEMIS_DIFF,EMLAYS          
      USE DEPV_DEFN
      USE ASX_DATA_MOD
      USE VDIFF_MAP
      USE UTILIO_DEFN
!      USE BIDI_MOD
!      USE LSM_MOD, ONLY: N_LUFRAC
      USE VDIFF_DIAG, NLPCR => NLPCR_MEAN
      USE HGRD_DEFN,only : COLSX_PE, ROWSX_PE
#ifdef isam
      USE SA_DEFN, ONLY: N_SPCTAG, ISAM, VNAM_SPCTAG, TRANSPORT_SPC,
     &                   SA_VDEMIS_DIFF, ITAG, NTAG_SA, NSPC_SA,
     &                   S_SPCTAG, T_SPCTAG, SA_DDEP, OTHRTAG, SPC_NAME,
     &                   L_NITRATE, SA_BIDI, BIDITAG, L_NH4
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, SNGRD, S_DDEP, S_PLDV, SVDEMIS_DIFF,
     &                       SENS, S_EMIS, S_DD, S_UU, S_DDBF, S_POL,
     &                       S_DELC, S_PLDV_HONO
#endif


      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' '

C Arguments:
      REAL, INTENT( IN )    :: DTSEC                ! model time step in seconds
C--- SEDDY is strictly an input, but it gets modified here
      REAL, INTENT( INOUT ) :: SEDDY    ( :,:,: )   ! flipped EDDYV
      REAL, INTENT( INOUT ) :: DDEP     ( :,:,: )   ! ddep accumulator
      REAL, INTENT( INOUT ) :: ICMP     ( :,:,: )   ! component flux accumlator 
      REAL, INTENT( INOUT ) :: CNGRD    ( :,:,:,: ) ! cgrid replacement

C Parameters:

C explicit, THETA = 0, implicit, THETA = 1     ! Crank-Nicholson: THETA = 0.5
      REAL, PARAMETER :: THETA = 0.5,
     &                   THBAR = 1.0 - THETA

      REAL, PARAMETER :: EPS = 1.0E-06

C External Functions: None

C Local Variables:

      CHARACTER( 16 ), SAVE :: PNAME = 'VDIFFACMX'

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      REAL, ALLOCATABLE, SAVE :: DD_FAC     ( : )   ! combined subexpression
      REAL, ALLOCATABLE, SAVE :: DDBF       ( : )   ! secondary DDEP
      REAl, ALLOCATABLE, SAVE :: CMPF       ( : )   ! intermediate CMP
      REAL, ALLOCATABLE, SAVE :: CONC       ( :,: ) ! secondary CGRID expression
      REAL, ALLOCATABLE, SAVE :: EMIS       ( :,: ) ! emissions subexpression
      REAL        DTDENS1                       ! DT * layer 1 air density

C ACM Local Variables
      REAL     :: EDDY  ( NLAYS )               ! local converted eddyv
      REAL        MEDDY                         ! ACM2 intermediate var
      REAL        MBAR                          ! ACM2 mixing rate (S-1)
      REAL     :: MBARKS( NLAYS )               ! by layer
      REAL     :: MDWN  ( NLAYS )               ! ACM down mix rate
      REAL     :: MFAC  ( NLAYS )               ! intermediate loop factor
      REAL     :: AA    ( NLAYS )               ! matrix column one
      REAL     :: BB1   ( NLAYS )               ! diagonal for MATRIX1
      REAL     :: BB2   ( NLAYS )               ! diagonal for TRI
      REAL     :: CC    ( NLAYS )               ! subdiagonal
      REAL     :: EE1   ( NLAYS )               ! superdiagonal for MATRIX1
      REAL     :: EE2   ( NLAYS )               ! superdiagonal for TRI
      REAL, ALLOCATABLE, SAVE :: DD ( :,: )     ! R.H.S
      REAL, ALLOCATABLE, SAVE :: UU ( :,: )     ! returned solution
      REAL        DFACP, DFACQ
      REAL     :: DFSP( NLAYS ), DFSQ( NLAYS )  ! intermediate loop factors
      REAL        DELC, DELP, RP, RQ
      REAL     :: LFAC1( NLAYS )                ! intermediate factor for CONVT
      REAL     :: LFAC2( NLAYS )                ! intermediate factor for CONVT
      REAL     :: LFAC3( NLAYS )                ! intermediate factor for eddy
      REAL     :: LFAC4( NLAYS )                ! intermediate factor for eddy
      REAL, ALLOCATABLE, SAVE :: DEPVCR     ( : )   ! dep vel in one cell
                                                    ! one cell for each landuse category
      REAL, ALLOCATABLE, SAVE :: EFAC1 ( : )
      REAL, ALLOCATABLE, SAVE :: EFAC2 ( : )
      REAL, ALLOCATABLE, SAVE :: POL   ( : )    ! prodn/lossrate = PLDV/DEPV
      REAL        PLDV_HONO                     ! PLDV for HONO
      REAL        DEPV_NO2                      ! dep vel of NO2
      REAL        DEPV_HNO3                     ! dep vel of HNO3
      REAL        FNL                           ! ACM2 Variable
      INTEGER     NLP, NL, LCBL
      INTEGER, SAVE :: NO2_HIT = 0, HONO_HIT = 0, HNO3_HIT = 0, NO2_MAP= 0, HNO3_MAP = 0 
      INTEGER, SAVE :: O3_HIT = 0, O3_MAP = 0
      INTEGER, SAVE :: NH3_HIT = 0
      REAL        DTLIM, DTS, DTACM, RZ

      INTEGER     ASTAT
      INTEGER     C, R, L, S, V, I, J           ! loop induction variables
      INTEGER     MDATE, MTIME                  ! internal simulation date&time
!--Local Arrays for Z-coord implimentation
      REAL     :: DZH   ( NLAYS )               ! ZF(L) - ZF(L-1)
      REAL     :: DZHI  ( NLAYS )               ! 1/DZH
      REAL     :: DZFI  ( NLAYS )               ! ZH(L+1) - ZH(L)
      integer  gl_c, gl_r
#ifdef isam
      REAL :: TOTAL_SA_NO2
      REAL, ALLOCATABLE, SAVE :: SA_DDBF( : )
      INTEGER IBGN, JSPCTAG

      REAL, ALLOCATABLE,SAVE :: SAEMIS( :,: )
      REAL, ALLOCATABLE,SAVE :: SACONC( :,: )
      REAL, ALLOCATABLE,SAVE :: SA_DD( :,: )
      REAL, ALLOCATABLE,SAVE :: SA_UU( :,: )

      REAL, ALLOCATABLE,SAVE :: SAFRAC( : )
      REAL, ALLOCATABLE,SAVE :: SA_NO2( : )      

      INTEGER, SAVE              :: ISAM_INDEX_NO2 = 0   ! ...Index locating NO2 in ISAM
      INTEGER, SAVE              :: ISAM_INDEX_NH3 = 0   ! ...Index locating NH3 in ISAM
      INTEGER, SAVE              :: PLDV_INDEX_NH3 = 0   ! ...Index locating NH3 in PLDV

      INTEGER, ALLOCATABLE, SAVE :: ISAM_DEPV( : )
      INTEGER, ALLOCATABLE, SAVE :: INDEX_SA_HONO( : )
      INTEGER, ALLOCATABLE, SAVE :: INDEX_SA_NH3( : )


      CHARACTER( 16 ) :: ISAM_SPECIES

      INTEGER TOP, BOT

      REAL NH3_SUM
#endif      


      INTERFACE
         SUBROUTINE MATRIX1 ( KL, A, B, E, D, X )
            INTEGER,        INTENT( IN )  :: KL
            REAL,           INTENT( IN )  :: A( : ), B( : ), E( : )
            REAL,           INTENT( IN )  :: D( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE MATRIX1
         SUBROUTINE TRI ( L, D, U, B, X )
            REAL,           INTENT( IN )  :: L( : ), D( : ), U( : )
            REAL,           INTENT( IN )  :: B( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE TRI
#ifdef isam
         SUBROUTINE SA_MATRIX1 ( KL, A, B, E, D, X )
            INTEGER,        INTENT( IN )  :: KL
            REAL,           INTENT( IN )  :: A( : ), B( : ), E(: )
            REAL,           INTENT( IN )  :: D( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE SA_MATRIX1

         SUBROUTINE SA_TRI ( L, D, U, B, X )
            REAL,           INTENT( IN )  :: L( : ), D( : ), U( : )
            REAL,           INTENT( IN )  :: B( :,: )
            REAL,           INTENT( OUT ) :: X( :,: )
         END SUBROUTINE SA_TRI
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         MDATE = 0; MTIME = 0

C set auxiliary depv arrays

         ALLOCATE ( DD_FAC( N_SPC_DEPV  ),
     &              DDBF  ( N_SPC_DEPV ),
     &              DEPVCR( N_SPC_DEPV ),
     &              EFAC1 ( N_SPC_DEPV ),
     &              EFAC2 ( N_SPC_DEPV ),
     &              POL   ( N_SPC_DEPV ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD_FAC, DDBF, DEPVCR, EFAC1, EFAC2, or POL'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( CMPF( LCMP ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CMPF'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( CONC( N_SPC_DIFF,NLAYS ),
     &              EMIS( N_SPC_DIFF,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CONC or EMIS'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         CONC = 0.0; EMIS = 0.0   ! array assignment

         ALLOCATE ( DD( N_SPC_DIFF,NLAYS ),
     &              UU( N_SPC_DIFF,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD or UU'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         DD = 0.0; UU = 0.0   ! array assignment

         HONO_HIT = 0; HNO3_HIT = 0; NO2_HIT  = 0; NH3_HIT = 0
                       HNO3_MAP = 0; NO2_MAP  = 0
         DO V = 1, N_SPC_DEPV
            IF ( DV2DF_SPC( V ) .EQ. 'NO2' ) THEN
               NO2_HIT = V
               NO2_MAP = DV2DF( V )
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'HONO' ) THEN
               HONO_HIT = V
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'HNO3' ) THEN
               HNO3_HIT = V
               HNO3_MAP = DV2DF( V )
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'NH3' ) THEN
               NH3_HIT = V
            ELSE IF ( DV2DF_SPC( V ) .EQ. 'O3' ) THEN
               O3_HIT = V
               O3_MAP = DV2DF( V )
            END IF
         END DO

#ifdef isam
         ALLOCATE (  SA_DDBF( N_SPCTAG ), 
     &               SACONC( N_SPCTAG, NLAYS ),
     &               SAEMIS( N_SPCTAG, NLAYS ), 
     &               SA_DD ( N_SPCTAG, NLAYS ),
     &               SA_UU ( N_SPCTAG, NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure ISAM diffusion variables'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         ALLOCATE (  SAFRAC ( N_SPCTAG ),
     &               ISAM_DEPV( N_SPCTAG ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure ISAM depv variables'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( SA_NO2( NTAG_SA ),
     &              INDEX_SA_HONO( NTAG_SA ), 
     &              INDEX_SA_NH3 ( NTAG_SA ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure ISAM HONO/NH3 variables'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         
         SACONC = 0.0
         SAEMIS = 0.0
         SA_DD  = 0.0
         SA_UU  = 0.0

         SAFRAC        = 0.0
         ISAM_DEPV     = 0
         SA_NO2        = 1.0 / REAL( NTAG_SA )
         INDEX_SA_HONO = 0
         INDEX_SA_NH3  = 0

! set default partitioning of surface fluxes
         DO JSPCTAG = 1, N_SPCTAG
            IF ( T_SPCTAG( JSPCTAG ) .EQ. OTHRTAG ) THEN
               SAFRAC( JSPCTAG ) = 1.0
            ELSE
               SAFRAC( JSPCTAG ) = 0.0
            END IF
         END DO
! find NO2 in tracked species
         DO S = 1, NSPC_SA
            IF( SPC_NAME( S,1 ) .EQ. 'NO2' )THEN
                ISAM_INDEX_NO2 = S
                EXIT
            END IF            
         END DO

! find NH3 in tracked species
         IF ( SA_BIDI ) THEN
           DO S = 1, NSPC_SA
              IF( SPC_NAME( S,1 ) .EQ. 'NH3' )THEN
                  ISAM_INDEX_NH3 = S
                  EXIT
              END IF
           END DO
           S = -1
           S = INDEX1( 'NH3', N_SPC_DEPV, DEPV_SPC )
           IF ( S .GT. 0 ) THEN
             PLDV_INDEX_NH3 = S
           ELSE
             XMSG = 'NH3 not found in DEPV_SPC array'
             CALL M3EXIT( 'PLDV_INDEX_NH3', 0, 0, XMSG, XSTAT1 )
           END IF
         END IF

! set indices determining depv treatment, equals zero if none
         ITAG = 0
         WRITE(LOGDEV,'(/,A7,1X,2(A16,1X))')'JSPCTAG','ISAM_SPECIES','DEPV Value'
         DO JSPCTAG = 1, N_SPCTAG
            IBGN         = INDEX( VNAM_SPCTAG( JSPCTAG ), '_', .FALSE. ) - 1
            ISAM_SPECIES = VNAM_SPCTAG( JSPCTAG )( 1:IBGN )
            IF( TRIM( ISAM_SPECIES ) .EQ. 'HONO' )THEN
               ITAG = ITAG + 1
               INDEX_SA_HONO( ITAG ) = JSPCTAG
            END IF
            DO V = 1, N_SPC_DEPV
               IF ( TRIM( ISAM_SPECIES ) .EQ. DV2DF_SPC( V ) ) THEN
                    ISAM_DEPV( JSPCTAG ) = V
               END IF  
            END DO
            IF ( ISAM_DEPV( JSPCTAG ) .GT. 0 ) THEN
               V = ISAM_DEPV( JSPCTAG )
               WRITE(LOGDEV,'(I4,4X,2(A16,1X))')JSPCTAG,ISAM_SPECIES,DV2DF_SPC( V )
            ELSE
               WRITE(LOGDEV,'(I4,4X,2(A16,1X))')JSPCTAG,ISAM_SPECIES,'NONE'
            END IF   
        END DO       
        WRITE(LOGDEV,'(/,A4,1X,A13,1X,A16))')'ITAG','INDEX_SA_HONO','ISAM_SPECIES'
        DO ITAG = 1, NTAG_SA
           JSPCTAG = INDEX_SA_HONO( ITAG )
           IF ( JSPCTAG .GT. 0 ) THEN
              WRITE(LOGDEV,'(I2,3X,I4,8X,A16)')ITAG,JSPCTAG,VNAM_SPCTAG( JSPCTAG )
           ELSE
              WRITE(LOGDEV,'(I2,3X,I4,8X,A16)')ITAG,JSPCTAG,'MISSING'
           END IF   
        END DO
        WRITE(LOGDEV,* )'TAG_species, Default Partitioning Coeff.'
        DO JSPCTAG = 1, N_SPCTAG
          WRITE(LOGDEV,*)VNAM_SPCTAG( JSPCTAG ),' ,',SAFRAC( JSPCTAG )
        END DO          
        IF ( ABFLUX .AND. L_NH4 ) THEN
          ITAG = 0
          DO JSPCTAG = 1, N_SPCTAG
            IBGN         = INDEX( VNAM_SPCTAG( JSPCTAG ), '_', .FALSE. ) - 1
            ISAM_SPECIES = VNAM_SPCTAG( JSPCTAG )( 1:IBGN )
            IF( TRIM( ISAM_SPECIES ) .EQ. 'NH3' )THEN
               ITAG = ITAG + 1
               INDEX_SA_NH3( ITAG ) = JSPCTAG
            END IF
          END DO

          DO ITAG = 1, NTAG_SA
            JSPCTAG = INDEX_SA_NH3( ITAG )
            SAFRAC( JSPCTAG ) = 0.0 ! to not double count the bi-di emmissions
          END DO
        END IF
#endif

#ifdef sens
         ALLOCATE ( S_POL   ( NPMAX, N_SPC_DEPV ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_POL'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         S_POL = 0.0

         ALLOCATE ( S_DDBF( N_SPC_DEPV, NPMAX ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_DBF'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF
         S_DDBF = 0.0

         ALLOCATE ( SENS( N_SPC_DIFF,NLAYS,NPMAX ),
     &              S_EMIS( N_SPC_DIFF,NLAYS,NPMAX ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SENS or S_EMIS'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         SENS = 0.0; S_EMIS = 0.0   ! array assignment

         ALLOCATE ( S_DD( N_SPC_DIFF,NLAYS,NPMAX ),
     &              S_UU( N_SPC_DIFF,NLAYS,NPMAX ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_DD or S_UU'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         S_DD = 0.0; S_UU = 0.0   ! array assignment

         ALLOCATE ( S_PLDV_HONO( NPMAX ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_PLDV_HONO'
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
         S_PLDV_HONO = 0.0  ! array assignment


#endif
 
      END IF   !  if Firstime

C ------------------------------------------- Row, Col LOOPS -----------

      DO 345 R = 1, NROWS
      DO 344 C = 1, NCOLS
         DZH(1)  =  Met_Data%ZF( C,R,1 )
         DZHI(1) =  1./DZH(1)
         DO L = 2, NLAYS
            DZH(L)  =  Met_Data%ZF( C,R,L ) - Met_Data%ZF( C,R,L-1 ) 
            DZHI(L) =  1./DZH(L)
         ENDDO
         DO L = 1, NLAYS - 1
            DZFI(L) = 1. / ( Met_Data%ZH( C,R,L+1 ) - Met_Data%ZH( C,R,L ) )
         ENDDO
         DZFI(NLAYS) = DZFI(NLAYS-1)

C for ACM time step
         DTLIM = DTSEC

C dt = .75 dzf*dzh / Kz
         DO L = 1, NLAYS - 1
            DTLIM = MIN( DTLIM, 0.75 / ( SEDDY( L,C,R ) * DZHI(L)*DZFI(L) ) )
         END DO
         MBARKS = 0.0   ! array assignment
         MDWN = 0.0     ! array assignment

C conjoin ACM & EDDY ---------------------------------------------------

         MBAR = 0.0
         FNL = 0.0

         IF ( Met_Data%CONVCT( C,R ) ) THEN   ! Do ACM for this column
            LCBL = Met_Data%LPBL( C,R )
            MEDDY = SEDDY( 1,C,R ) * DZFI(1) / (Met_Data%PBL( C,R ) - Met_Data%ZF(C,R,1))
            FNL = 1.0 / ( 1.0 + ( ( KARMAN / ( -Met_Data%HOL( C,R ) ) ) ** 0.3333 )
     &                / ( 0.72 * KARMAN ) )
            MBAR = MEDDY * FNL
            IF ( MEDDY .LT. EPS ) THEN
               gl_c = c + COLSX_PE(1,mype+1) -1
               gl_r = r + ROWSX_PE(1,mype+1) -1
               WRITE( LOGDEV,* ) ' Warning --- MEDDY < 1e-6 s-1'
               WRITE( LOGDEV,* ) ' SEDDY, MEDDY, FNL, HOL = ',
     &                             SEDDY( 1,C,R ), MEDDY, FNL, Met_Data%HOL( C,R )
               XMSG = '*** ACM fails ***'
               WRITE( LOGDEV,*)' c,r=', gl_c,gl_r,' pbl,ust=',Met_Data%PBL( C,R ),Met_Data%USTAR( C,R )
!               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT2 )
            END IF

            IF ( ( FNL .LE. 0.0 ) .OR.            ! never gonna happen for CONVCT
     &           ( LCBL .GE. NLAYS-1 ) .OR.       ! .GT. never gonna happen
     &           ( Met_Data%HOL( C,R ) .GT. -0.00001 ) )   ! never gonna happen
     &         WRITE( LOGDEV,1015 ) LCBL, MBAR, FNL, SEDDY( 1,C,R ), Met_Data%HOL( C,R )
1015           FORMAT( ' LCBL, MBAR, FNL, SEDDY1, HOL:', I3, 1X, 4(1PE13.5) )

            DO L = 2, LCBL 
               SEDDY( L,C,R ) = ( 1.0 - FNL ) * SEDDY( L,C,R  )
               MBARKS( L ) = MBAR
               MDWN( L )   = MBAR * (Met_Data%PBL( C,R ) - Met_Data%ZF(C,R,L-1)) * DZHI(L)
            END DO
            SEDDY( 1,C,R ) = ( 1.0 - FNL ) * SEDDY( 1,C,R  )
            MBARKS(1) = MBAR
            MBARKS(LCBL) = MDWN(LCBL)
            MDWN(LCBL+1) = 0.0

C Modify Timestep for ACM2
            RZ     = (Met_Data%ZF(C,R,LCBL) - Met_Data%ZF(C,R,1)) * DZHI(1)
            DTACM  = 1.0 / ( MBAR * RZ )
            DTLIM  = MIN( 0.75 * DTACM, DTLIM )
         ELSE
            LCBL = 1
         END IF

C-----------------------------------------------------------------------

         NLP = INT( DTSEC / DTLIM + 0.99 )
         IF ( VDIFFDIAG ) NLPCR( C,R ) = REAL( NLP )
         DTS = DTSEC / REAL( NLP )
         DTDENS1 = DTS * Met_Data%DENS1( C,R )
         DFACP = THETA * DTS
         DFACQ = THBAR * DTS

#ifdef Verbose_Vdiff
        IF ( R .EQ. NROWS / 2 .AND. C .EQ. NCOLS / 2 )
     &      WRITE( LOGDEV,1021 ) Met_Data%CONVCT( C,R ), DTS, EDDYV( C,R,1 ), MBAR, FNL
1021  FORMAT( ' CONVCT, DTS, EDDYV, MBAR, FNL: ', L3, 1X, 4(1PE13.5) )
#endif

         DO L = 1, NLAYS
            DO V = 1, N_SPC_DIFF
               CONC( V,L ) = CNGRD( DIFF_MAP( V ),L,C,R )
            END DO
#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               SACONC( JSPCTAG,L ) = ISAM( C,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) )
            END DO
#endif
         END DO

#ifdef sens
         DO NP = 1, NPMAX
            DO L = 1, NLAYS
               DO V = 1, N_SPC_DIFF
                  SENS( V,L,NP ) = SNGRD( DIFF_MAP( V ),L,C,R,NP )
               END DO
            END DO
         END DO
#endif

#ifdef isam
         IF( L_NITRATE .AND. SFC_HONO ) THEN
! compute the flux partitioning for HONO from NO2 surface reaction
            DO ITAG = 1, NTAG_SA
               SA_NO2( ITAG ) = MAX( ISAM( C,R,1,ISAM_INDEX_NO2,ITAG ), 1.0E-30 )
            END DO
            TOTAL_SA_NO2 = 1.0 / SUM( SA_NO2 )
            DO ITAG = 1, NTAG_SA
               JSPCTAG = INDEX_SA_HONO( ITAG )
               SAFRAC( JSPCTAG ) = SA_NO2( ITAG ) * TOTAL_SA_NO2 
            END DO 
         END IF                
#endif
 
         EMIS = 0.0      ! array assignment
         EMIS( :,1:EMLAYS ) = DTS * VDEMIS_DIFF( :,:,C,R )

#ifdef isam
         SAEMIS = 0.0

! modify ground emissions for bidirectional species (for bidi, PLVD > 0.0)
         IF ( SA_BIDI ) THEN
           SA_VDEMIS_DIFF( ISAM_INDEX_NH3,1,C,R,BIDITAG )
     &             = PLDV(PLDV_INDEX_NH3,C,R) * Met_Data%RDEPVHT( C,R )
         END IF

! collapse ISAM emissions array
         DO L = 1, EMLAYS
            DO ITAG = 1, NTAG_SA
               BOT = (ITAG-1)*NSPC_SA+1
               TOP = NSPC_SA*ITAG
               SAEMIS( BOT:TOP,L ) = DTS * SA_VDEMIS_DIFF( :,L,C,R,ITAG )
            END DO
         END DO
#endif

#ifdef sens
         S_EMIS = 0.0
         DO NP = 1, NPMAX
            S_EMIS( :,1:EMLAYS,NP ) = DTS * SVDEMIS_DIFF( :,:,C,R,NP )
         END DO
#endif

         DO L = 1, NLAYS
            DFSP( L ) = DFACP * DZHI( L )
            DFSQ( L ) = DFACQ * DZHI( L )
            EDDY( L ) = SEDDY( L,C,R ) * DZFI(L)
         END DO

         RP = DFACP * Met_Data%RDEPVHT( C,R )
         RQ = DFACQ * Met_Data%RDEPVHT( C,R )
         DO V = 1, N_SPC_DEPV
            DDBF( V )   = DDEP( V,C,R )
            DEPVCR( V ) = DEPV( V,C,R )
            DD_FAC( V ) = DTDENS1 * DD_CONV( V ) * DEPVCR( V )
            EFAC1 ( V ) = EXP( -DEPVCR( V ) * RP )
            EFAC2 ( V ) = EXP( -DEPVCR( V ) * RQ )
            POL   ( V ) = PLDV( V,C,R ) / DEPVCR( V )
#ifdef sens
            DO NP = 1, NPMAX
               S_POL   ( NP,V ) = S_PLDV( NP,V,C,R ) / DEPVCR( V )
               S_DDBF( V, NP ) = S_DDEP( V, C, R, NP )
            END DO
#endif
         END DO
         PLDV_HONO = PLDV( HONO_HIT,C,R )
#ifdef sens
         DO NP = 1, NPMAX
            S_PLDV_HONO( NP ) = S_PLDV( NP,HONO_HIT,C,R )
         END DO
#endif

#ifdef isam
         DO JSPCTAG = 1, N_SPCTAG
            SA_DDBF( JSPCTAG ) = SA_DDEP( C,R,JSPCTAG )
         END DO
#endif

C These don`t change in the NLP sub-time step loop:---------------------
         DO L = 1, NLAYS
            AA ( L ) = 0.0
            BB1( L ) = 0.0
            EE1( L ) = 0.0
            CC ( L ) = 0.0
            EE2( L ) = 0.0
            BB2( L ) = 0.0
         END DO
         IF ( Met_Data%CONVCT( C,R ) ) THEN
            L = 1
            DELP = Met_Data%PBL( C,R ) - Met_Data%ZF( C,R,L )
            BB1( L ) = 1.0 + DELP * DFSP( L ) * MBARKS( L )
            LFAC1( L ) = DFSQ( L ) * DELP * MBARKS( L )
            LFAC2( L ) = DFSQ( L ) * MDWN( L+1 ) * DZH( L+1 )
            DO L = 2, LCBL
               AA ( L ) = -DFACP * MBARKS( L )
               BB1( L ) = 1.0 + DFACP * MDWN( L )
               EE1( L ) = -DFSP( L-1 ) * DZH( L ) * MDWN( L )
               MFAC( L ) = DZH( L+1 ) * DZHI( L ) * MDWN( L+1 )
            END DO
         END IF

         DO L = 1, NLAYS
            EE2( L ) = - DFSP( L ) * EDDY( L )
            LFAC3( L ) = DFSQ( L ) * EDDY( L )
         END DO

         BB2( 1 ) = 1.0 - EE2( 1 )
         DO L = 2, NLAYS
            CC ( L ) = - DFSP( L ) * EDDY( L-1 )
            BB2( L ) = 1.0 - CC( L ) - EE2( L )
            LFAC4( L ) = DFSQ( L ) * EDDY( L-1 )
         END DO

         DO 301 NL = 1, NLP      ! loop over sub time

            DO V = 1, N_SPC_DEPV

C --------- HET HONO RX -----------------

C Use special treatment for HNO3
C HNO3 produced via the heterogeneous reaction sticks on surfaces and
C is accounted as depositional loss; calculate increased deposition loss
               IF ( V .EQ. HNO3_HIT ) THEN
                  S = HNO3_MAP
                  CONC( S,1 ) = POL( V ) + ( CONC( S,1 ) - POL( V ) ) * EFAC1( V )
                  DEPV_HNO3 = DEPVCR( V ) + PLDV_HONO / CONC( NO2_MAP,1 )
                  DD_FAC( V ) = DTDENS1 * DD_CONV( V ) * DEPV_HNO3
                  DDBF( V ) = DDBF( V ) + THETA * DD_FAC( V ) * CONC( S,1 )
#ifdef sens
                  DO NP = 1, NPMAX
                     SENS( S,1,NP ) = S_POL( NP,V ) + ( SENS( S,1,NP ) - S_POL( NP,V ) ) * EFAC1( V )
                     S_DDBF( V, NP ) = S_DDBF( V, NP ) + THETA * DD_FAC( V ) * SENS ( S,1,NP )
                  END DO
#endif

C Use special treatment for NO2
C Loss of NO2 via the heterogeneous reaction is accounted for as an additional
C depositional loss. Add the loss of NO2 via the heterogeneous reaction
C to the regular deposition velocity (increased dep. vel.).  This will
C reduce the NO2 conc. in the atmosphere without affecting the depositional loss.
               ELSE IF ( V .EQ. NO2_HIT ) THEN
                  S = NO2_MAP
                  DEPV_NO2 = DEPVCR( V ) + 2.0 * PLDV_HONO / CONC( S,1 )
                  EFAC1 ( V ) = EXP( -DEPV_NO2 * RP )
                  EFAC2 ( V ) = EXP( -DEPV_NO2 * RQ )
                  POL   ( V ) = PLDV( V,C,R ) / DEPV_NO2
                  CONC( S,1 ) = POL( V ) + ( CONC( S,1 ) - POL( V ) ) * EFAC1( V )
                  DDBF( V ) = DDBF( V ) + THETA * DD_FAC( V ) * CONC( S,1 )
#ifdef sens
                  DO NP = 1, NPMAX
                     S_POL( NP, V ) = S_PLDV( NP,V,C,R ) / DEPV_NO2
                     SENS( S,1,NP ) = S_POL( NP,V ) + ( SENS( S,1,NP ) - S_POL( NP,V ) ) * EFAC1( V )
                     S_DDBF( V, NP ) = S_DDBF( V, NP ) + THETA * DD_FAC( V ) * SENS ( S,1,NP )
                  END DO
#endif
  
C --------- END of HET HONO RX ----------

               ELSE
                  S = DV2DF( V )
                  CONC( S,1 ) = POL( V ) + ( CONC( S,1 ) - POL( V ) ) * EFAC1( V )
                  DDBF( V ) = DDBF( V ) + THETA * ( DD_FAC( V ) * CONC( S,1 ) 
C Add evasion as negative dep flux                  
     &                      - DTDENS1 * DD_CONV( V ) * PLDV( V,C,R ) )         

#ifdef sens
                  DO NP = 1, NPMAX
                     SENS( S,1,NP ) = S_POL( NP,V ) + ( SENS( S,1,NP ) - S_POL( NP,V ) ) * EFAC1( V )
                     S_DDBF( V, NP ) = S_DDBF( V, NP ) + THETA * ( DD_FAC( V ) * SENS( S, 1,NP )
     &                      - DTDENS1 * DD_CONV( V ) * S_PLDV( NP,V,C,R ) )
                  END DO
#endif

               END IF

            END DO
    
            DO L = 1, NLAYS
               DO V = 1, N_SPC_DIFF
                  DD( V,L ) = 0.0
                  UU( V,L ) = 0.0
#ifdef sens
                  DO NP = 1, NPMAX
                     S_DD( V,L,NP) = 0.0
                     S_UU( V,L,NP) = 0.0
                  END DO
#endif
               END DO
            END DO

#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               S = ISAM_DEPV( JSPCTAG )
               IF ( S .GT. 0 ) THEN
                  SACONC( JSPCTAG,1 ) = SACONC( JSPCTAG,1 ) * EFAC1( S )
     &                                + SAFRAC( JSPCTAG ) * POL( S ) * ( 1.0 -  EFAC1( S ) )               
                  SA_DDBF( JSPCTAG  ) = SA_DDBF( JSPCTAG )
     &                                + THETA * DD_FAC( S ) *  SACONC( JSPCTAG,1 )
                  IF( S .NE. NO2_HIT .AND. S .NE. HNO3_HIT ) THEN
                     SA_DDBF( JSPCTAG  ) = SA_DDBF( JSPCTAG )
     &                                   - THETA * DTDENS1 * SAFRAC( JSPCTAG ) * DD_CONV( S ) * PLDV( S,C,R )                        
                   END IF
               END IF
            END DO

c Recalculate bidi NH3 deposition
            IF ( ABFLUX .AND. SA_BIDI ) THEN
              NH3_SUM = 0.0
              DO JSPCTAG = 1, N_SPCTAG
                S = ISAM_DEPV( JSPCTAG )
                IF ( S .EQ. NH3_HIT ) NH3_SUM = NH3_SUM + SACONC( JSPCTAG,1 )
              END DO

              DO JSPCTAG = 1, N_SPCTAG
                S = ISAM_DEPV( JSPCTAG )
                IF ( S .EQ. NH3_HIT ) THEN
                  IF( NH3_SUM .GT. 1.0E-25  ) THEN
                    SA_DDBF( JSPCTAG  ) = DDBF(NH3_HIT) * ( SACONC( JSPCTAG,1 ) / NH3_SUM )
                  ELSE
                    SA_DDBF( JSPCTAG  ) = 0.0
                  END IF
                END IF
              END DO
            END IF

            DO L = 1, NLAYS
               DO V = 1, N_SPCTAG
                 SA_DD( V,L ) = 0.0
                 SA_UU( V,L ) = 0.0
               END DO
            END DO
#endif

C Compute tendency of CBL concentrations - semi-implicit solution
C Set MATRIX1 elements A (col 1), B (diag.), E (superdiag.) and D (RHS)

            IF ( Met_Data%CONVCT( C,R ) ) THEN

               L = 1
               DO V = 1, N_SPC_DIFF
                  DD( V,L ) = CONC( V,L )
     &                      - LFAC1( L ) * CONC( V,L )
     &                      + LFAC2( L ) * CONC( V,L+1 ) 
#ifdef sens
                  DO NP = 1, NPMAX
                     S_DD( V,L,NP ) = SENS( V,L,NP )
     &                         - LFAC1( L ) * SENS( V,L,NP )
     &                         + LFAC2( L ) * SENS( V,L+1,NP )
                  END DO
#endif
               END DO

#ifdef isam
               DO JSPCTAG = 1, N_SPCTAG
                  SA_DD( JSPCTAG, L) = SACONC( JSPCTAG,L )
     &                      - LFAC1( L ) * SACONC( JSPCTAG,L )
     &                      + LFAC2( L ) * SACONC( JSPCTAG,L+1 )
               ENDDO
#endif

               DO L = 2, LCBL
                  DO V = 1, N_SPC_DIFF
                     DELC = MBARKS( L ) * CONC( V,1 )
     &                    -   MDWN( L ) * CONC( V,L )
     &                    +   MFAC( L ) * CONC( V,L+1 )
                     DD( V,L ) = CONC( V,L ) + DFACQ * DELC
#ifdef sens    
                     DO NP = 1, NPMAX
                        S_DELC = MBARKS( L ) * SENS( V,1,NP )
     &                       -   MDWN( L ) * SENS( V,L,NP )
     &                       +   MFAC( L ) * SENS( V,L+1,NP )
                        S_DD( V,L,NP ) = SENS( V,L,NP ) + DFACQ * S_DELC
                     END DO
#endif         
                  END DO

#ifdef isam
                  DO JSPCTAG = 1, N_SPCTAG
                     DELC = MBARKS( L ) * SACONC( JSPCTAG,1 )
     &                     -   MDWN( L ) * SACONC( JSPCTAG,L )
     &                     +   MFAC( L ) * SACONC( JSPCTAG,L+1 )
                     SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L ) + DFACQ  * DELC
                  END DO
#endif

               END DO

               CALL MATRIX1 ( LCBL, AA, BB1, EE1, DD, UU )
#ifdef isam 
               CALL SA_MATRIX1( LCBL, AA, BB1,EE1, SA_DD, SA_UU)
#endif

#ifdef sens
               DO NP = 1, NPMAX
                  CALL MATRIX1 ( LCBL, AA, BB1, EE1, S_DD(:,:,NP), S_UU(:,:,NP) )
               END DO
#endif


C update conc
               DO L = 1, LCBL
                  DO V = 1, N_SPC_DIFF
                     CONC( V,L ) = UU( V,L )
#ifdef sens
                     DO NP = 1, NPMAX
                        SENS( V,L,NP ) = S_UU( V,L,NP )
                     END DO
#endif
                  END DO
#ifdef isam
                  DO JSPCTAG = 1, N_SPCTAG
                     SACONC ( JSPCTAG,L ) = SA_UU( JSPCTAG,L )
                  ENDDO
#endif
               END DO

C reinitialize for TRI solver
               DO L = 1, NLAYS
                  DO V = 1, N_SPC_DIFF
                     DD( V,L ) = 0.0
                     UU( V,L ) = 0.0
#ifdef sens
                     DO NP = 1, NPMAX
                        S_DD( V,L,NP ) = 0.0
                        S_UU( V,L,NP ) = 0.0
                     END DO
#endif
                  END DO
#ifdef isam
                  DO JSPCTAG = 1, N_SPCTAG
                     SA_DD( JSPCTAG,L ) = 0.0
                     SA_UU( JSPCTAG,L ) = 0.0
                  ENDDO
#endif
               END DO

            END IF

            L = 1
            DO V = 1, N_SPC_DIFF
               DD( V,L ) = CONC( V,L )
     &                   + LFAC3( L ) * ( CONC( V,L+1 ) - CONC( V,L ) )
     &                   + EMIS( V,L )
#ifdef sens
               DO NP = 1, NPMAX
                  S_DD( V,L,NP ) = SENS( V,L,NP )
     &                           + LFAC3( L ) * ( SENS( V,L+1,NP ) - SENS( V,L,NP ) )
     &                           + S_EMIS( V,L,NP )
               END DO
#endif
            END DO

#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L )
     &                   + LFAC3( L ) * ( SACONC( JSPCTAG,L+1 ) - SACONC( JSPCTAG,L ) )
     &                   + SAEMIS( JSPCTAG,L )
            END DO
#endif

            DO L = 2, NLAYS-1
               DO V = 1, N_SPC_DIFF
                  DD( V,L ) = CONC( V,L )
     &                      + LFAC3( L ) * ( CONC( V,L+1 ) - CONC( V,L ) )
     &                      - LFAC4( L ) * ( CONC( V,L ) - CONC( V,L-1 ) )
     &                      + EMIS( V,L )
#ifdef sens 
                  DO NP = 1, NPMAX
                     S_DD( V,L,NP ) = SENS( V,L,NP )
     &                              + LFAC3( L ) * ( SENS( V,L+1,NP ) - SENS( V,L,NP ) )
     &                              - LFAC4( L ) * ( SENS( V,L,NP ) - SENS( V,L-1,NP ) )
     &                              + S_EMIS( V,L,NP )
                  END DO
#endif
               END DO
#ifdef isam
               DO JSPCTAG = 1, N_SPCTAG
                  SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L )
     &                      + LFAC3( L ) * ( SACONC( JSPCTAG,L+1 ) - SACONC( JSPCTAG,L ) )
     &                      - LFAC4( L ) * ( SACONC( JSPCTAG,L ) - SACONC( JSPCTAG,L-1 ) )
     &                      + SAEMIS( JSPCTAG,L )
               END DO
#endif
            END DO

            L = NLAYS
            DO V = 1, N_SPC_DIFF
               DD( V,L ) = CONC( V,L )
     &                   - LFAC4( L ) * ( CONC( V,L ) - CONC( V,L-1 ) )
#ifdef sens
               DO NP = 1, NPMAX
                  S_DD( V,L,NP ) = SENS( V,L,NP )
     &                           - LFAC4( L ) * ( SENS( V,L,NP ) - SENS( V,L-1,NP ) )
               END DO
#endif
            END DO
#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               SA_DD( JSPCTAG,L ) = SACONC( JSPCTAG,L )
     &                   - LFAC4( L ) * ( SACONC( JSPCTAG,L ) - SACONC( JSPCTAG,L-1 ) )
            END DO
#endif

            CALL TRI ( CC, BB2, EE2, DD, UU )
#ifdef isam
            CALL SA_TRI ( CC, BB2, EE2, SA_DD, SA_UU )
#endif

#ifdef sens
            DO NP = 1, NPMAX
               CALL TRI ( CC, BB2, EE2, S_DD(:,:,NP), S_UU(:,:,NP) )
            END DO
#endif


C Load into CGRID
            DO L = 1, NLAYS
               DO V = 1, N_SPC_DIFF
                  CONC( V,L ) = UU( V,L )
#ifdef sens
                  DO NP = 1, NPMAX
                     SENS( V,L,NP ) = S_UU( V,L,NP )
                  END DO
#endif
               END DO
#ifdef isam
               DO JSPCTAG = 1, N_SPCTAG
                  SACONC( JSPCTAG,L ) = SA_UU( JSPCTAG,L )
               END DO
#endif
            END DO
            
            DO V = 1, N_SPC_DEPV

C --------- HET HONO RX -----------------

               IF ( V .EQ. HNO3_HIT ) THEN
                  S = HNO3_MAP
                  CONC( S,1 ) = POL( V ) + ( CONC( S,1 ) - POL( V ) ) * EFAC2( V )
                  DDBF( V ) = DDBF( V ) + THBAR * DD_FAC( V ) * CONC( S,1 )

#ifdef sens
                  DO NP = 1, NPMAX
                     SENS( S,1,NP ) = S_POL( NP,V ) + ( SENS( S,1,NP ) - S_POL( NP,V ) ) * EFAC2( V )
                     S_DDBF( V,NP ) = S_DDBF( V,NP ) + THBAR * DD_FAC( V ) * SENS( S,1,NP )
                  END DO
#endif

               ELSE IF ( V .EQ. NO2_HIT ) THEN
                  S = NO2_MAP
                  CONC( S,1 ) = POL( V ) + ( CONC( S,1 ) - POL( V ) ) * EFAC2( V )
                  DDBF( V ) = DDBF( V ) + THBAR * DD_FAC( V ) * CONC( S,1 )

#ifdef sens
                  DO NP = 1, NPMAX
                     SENS( S,1,NP ) = S_POL( NP,V ) + ( SENS( S,1,NP ) - S_POL( NP,V ) ) * EFAC2( V )
                     S_DDBF( V,NP ) = S_DDBF( V,NP ) + THBAR * DD_FAC( V ) * SENS( S,1,NP )
                  END DO
#endif

C --------- END of HET HONO RX ----------

               ELSE
                  S = DV2DF( V )
                  CONC( S,1 ) = POL( V ) + ( CONC( S,1 ) - POL( V ) ) * EFAC2( V )
                  DDBF( V ) = DDBF( V ) + THBAR * ( DD_FAC( V ) * CONC( S,1 )
C Add evasion as negative dep flux                      
     &                      - DTDENS1 * DD_CONV( V ) * PLDV( V,C,R ) )

#ifdef sens
                  DO NP = 1, NPMAX
                     SENS( S,1,NP ) = S_POL( NP,V ) + ( SENS( S,1,NP ) - S_POL( NP,V ) ) * EFAC2( V )
                     S_DDBF( V,NP ) = S_DDBF( V,NP ) + THBAR * ( DD_FAC( V ) * SENS( S,1,NP )
     &                      - DTDENS1 * DD_CONV( V ) * S_PLDV( NP,V,C,R ) )
                  END DO
#endif
                  
               END IF

            END DO
#ifdef isam
C Update ISAM Dry Deposition
            DO JSPCTAG = 1, N_SPCTAG
               S = ISAM_DEPV( JSPCTAG )
               IF ( S .GT. 0 ) THEN
                  SACONC( JSPCTAG,1 ) = SACONC( JSPCTAG,1 ) * EFAC2( S )
     &                                + SAFRAC( JSPCTAG ) * POL( S ) * ( 1.0 -  EFAC2( S ) )               
                  SA_DDBF( JSPCTAG  ) = SA_DDBF( JSPCTAG )
     &                                + THBAR * DD_FAC( S ) *  SACONC( JSPCTAG,1 )
                  IF( S .NE. NO2_HIT .AND. S .NE. HNO3_HIT ) THEN
                     SA_DDBF( JSPCTAG  ) = SA_DDBF( JSPCTAG )
     &                                   - THBAR * DTDENS1 * SAFRAC( JSPCTAG ) * DD_CONV( S ) * PLDV( S,C,R )                         
                  END IF
               END IF
            END DO

c Recalculate bidi NH3 deposition
            IF ( ABFLUX .AND. SA_BIDI ) THEN
              NH3_SUM = 0.0
              DO JSPCTAG = 1, N_SPCTAG
                S = ISAM_DEPV( JSPCTAG )
                IF ( S .EQ. NH3_HIT ) NH3_SUM = NH3_SUM + SACONC( JSPCTAG,1 )
              END DO

              DO JSPCTAG = 1, N_SPCTAG
                S = ISAM_DEPV( JSPCTAG )
                IF ( S .EQ. NH3_HIT ) THEN
                  IF( NH3_SUM .GT. 1.0E-25  ) THEN
                    SA_DDBF( JSPCTAG  ) = DDBF(NH3_HIT) * ( SACONC( JSPCTAG,1 ) / NH3_SUM )
                  ELSE
                    SA_DDBF( JSPCTAG  ) = 0.0
                  END IF
                END IF
              END DO
            END IF
#endif
    

301      CONTINUE                 ! end sub time loop

         DO L = 1, NLAYS
            DO V = 1, N_SPC_DIFF
               CNGRD( DIFF_MAP( V ),L,C,R ) = CONC( V,L )
            END DO
#ifdef isam
            DO JSPCTAG = 1, N_SPCTAG
               IF( TRANSPORT_SPC( JSPCTAG ) )THEN
                  ISAM( C,R,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) = SACONC( JSPCTAG,L )
               END IF
            END DO
#endif
         END DO

         DO V = 1, N_SPC_DEPV
            DDEP( V,C,R ) = DDBF( V )
         END DO

#ifdef isam
         DO JSPCTAG = 1, N_SPCTAG
            SA_DDEP( C,R,JSPCTAG ) = SA_DDBF( JSPCTAG )
         END DO
#endif

#ifdef sens
         DO NP = 1, NPMAX

            DO L = 1, NLAYS
               DO V = 1, N_SPC_DIFF
                  SNGRD( DIFF_MAP( V ),L,C,R,NP ) = SENS( V,L,NP )
               END DO
            END DO

            DO V = 1, N_SPC_DEPV
               S_DDEP( V,C,R,NP ) = S_DDBF( V,NP )
            END DO

         END DO
#endif


 
344   CONTINUE         !  end loop on col C
345   CONTINUE         !  end loop on row R

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE FINAL_DEGRADE( CBLK )
C**********************************************************************
C
C  FUNCTION: Update CBLK concentrations with concentrations from degrade
C            routines
C
C  CALLED BY: HRDRIVER
C
C  REVISION HISTORY: 07/29/05 : B.Hutzell - Initial version
C                    09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                               optional degraded species i.e., RXTANT_MAP( I )
C                               is less than zero
C
C**********************************************************************

      USE DEGRADE_SETUP_TOX

      IMPLICIT NONE

C.....ARGUMENTS:

      REAL( 8 ), INTENT( INOUT ) :: CBLK( : )    !  species concentration in cell

C.....LOCAL VARIABLES:

      REAL, PARAMETER ::  CONMIN = 1.0E-30

      INTEGER         ::  I_RXT, I_PROD   ! indices
      INTEGER         ::  I, J, K         ! loop counters

C**********************************************************************

      LOOP_REACT: DO I = 1, N_REACT ! Loop over each reactant

c..update CBLK

         I_RXT = RXTANT_MAP( I )

         IF( I_RXT <= 0 )CYCLE LOOP_REACT

         CBLK( I_RXT ) = CURR_CONC( I_RXT )

         LOOP_PROD: DO J = 1, N_PROCESSES

            I_PROD = PROD_MAP( I, J )

            IF( I_PROD < 1 ) CYCLE ! no specified product

            CBLK( I_PROD ) = CURR_CONC( I_PROD )

         ENDDO LOOP_PROD

      ENDDO LOOP_REACT

      END SUBROUTINE FINAL_DEGRADE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/depv/m3dry/m3dry.F,v 1.12 2012/01/19 14:19:43 yoj Exp $

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE m3dry ( jdate, jtime, dtsec, cgridl1, depvel_gas, pvd, nh3_emis)

C-------------------------------------------------------------------------------
C Name:     Models-3 Dry Deposition
C Purpose:  Computes dry deposition velocities using Rst and Ra, and
C           elements of ADOM DD model.
C Revised:  21 Jan 1998  Original version.  (J. Pleim and A. Bourgeois)
C           18 Sep 2001  Made general for USGS 24-category system.
C                        (T. Otte, J. Pleim, and W. Hutzell)
C           14 Jan 2002  Added temperature dependence to Henry's Law
C                        constants.  Added temperature and pressure
C                        dependence to diffusivity.  Added new dry
C                        deposition species, methanol.  (Y. Wu and T. Otte)
C           18 Jan 2002  Changed the reference wet cuticle resistance.
C                        (J. Pleim)
C           09 Jun 2003  Added logic for modeling snow covered surfaces.
C                        Changed the reactivities for SO2, HNO3 and NH3.
C                        Changed pH values to have an east-west variation.
C                        Using the Henry's law constant function from CMAQ in
C                        place of local code.  Also changed the code for
C                        deposition to water to use a pH of 8.1 and the
C                        temperature of water in calculating the Henry's law
C                        constant.  Adjusted values of RSNOW0 = 1000 and
C                        A(NH3) = 20.  Added new dry deposition species: N2O5,
C                        NO3, Generic_aldehyde.  Corrected diffusivities of
C                        chemicals and water and viscosity of air to all be at
C                        the same temperature (273.15K).  Temperature and
C                        pressure adjustments to the values are not needed
C                        because the diffusivities and viscosity are always used
C                        as ratios, so the temperature-pressure dependence was
C                        removed.  Removed dry deposition species, ATRA and
C                        ATRAP, from output.  (D. Schwede, J. Pleim, and
C                        T. Otte)
C           28 Feb 2005  Added optional dry deposition species for chlorine
C                        and mercury.  (G. Sarwar, R. Bullock, and T. Otte)
C           02 Feb 2006  Added mesophyll resistance to dry deposition velocity
C                        calculation, and defined non-zero value for mercury.
C                        (D. Schwede, J. Pleim, and R. Bullock)
C           01 Aug 2007  Added a non-zero mesophyll resistance for NO, NO2, and
C                        CO.  Restored wet cuticle resistance for O3 based on
C                        field study measurements.  Added wet ground resistance.
C                        Changed ground resistance to include partitioning of
C                        wet and dry ground.  Updated pH of rain water for
C                        eastern United States and outside of North America.
C                        Changed reactivity for PAN.  Removed dry deposition
C                        velocity calculations for obsolete chlorine species
C                        ICL1 and ICL2.  Corrected error in the calculation of
C                        surface resistance over water where (Sc/Pr)**(2/3) had
C                        been inadvertently omitted from the numerator.
C                        Surface resistance over water is now a function of
C                        species.  Surface resistance over water now uses wet
C                        bulb temperature rather than ground (water) temperature
C                        in the calculation of the effective Henry's law
C                        constant, and the algorithm has been updated.  Changed
C                        (Sc/Pr)**(2/3) over water to a species-dependent,
C                        meteorologically dependent variable.  Effective Henry's
C                        law constant over land now uses 2-m temperature rather
C                        than layer 1 temperature. Changed ES
C                        into ES_AIR and ES_GRND, and changed QSS into QSS_AIR
C                        and QSS_GRND to clarify usage.  (J. Pleim, E. Cooter,
C                        J. Bash, T. Otte, and G. Sarwar)
C           07 Dec 2007  Add into CMAQ for in-line deposition velocities.
C                        (W. Hutzell, J. Young and T. Otte)
C           07 Jan 2008  Changed the value of d3, the scaling parameter used to
C                        estimate the friction velocity in surface waters from
C                        the atmospheric friction velocity to a value following
C                        Slinn et al. (1978) and Fairall et al. (2007).
C                        (J. Bash)
C           01 Feb 2008  Added bidirectional NH3 flux calculations. (J. Pleim and
C                        J. Young)
C           20 Mar 2008  Added a trap for undefined dry deposition velocities
C                        (e.g., NaN's).  (T. Otte)
C           21 Mar 2008  Added heterogeneous reaction for HONO. It affects HONO, NO2
C                        and HNO3 (G. Sarwar)
C           30 Apr 2008  Added five air toxic species to output.  (W. Hutzell
C                        and T. Otte)
C           August 2008  Applied a minimum value to ustg (0.001 m/s) to prevent
C                        negative rbg values in the bidi calculation (J. Pleim)
C           05 Oct 2009  Added condition that vegetation fraction must be
C                        greater than zero to be considered a land point.  This
C                        works around intermittent inconsistencies in surface
C                        fields in some WRF data sets.  (T. Otte)
C           Dec 2009     Revised bidirectional NH3 flux calculations to use soil
C                        Gamma values read from gridded file.  Bidi flux calcs
C                        based on comparisons with Lillington, NC corn data 2007 (J. Pleim)
C           30 Mar 2010  Modified to output the NH3 bidi stomtal, cuticle and soil component
C                        fluxes and chaged NH3 bidi variables used in estimating the compensation
C                        point double. (J. Bash)
C           16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C           20 May 2011  D.Schwede: add MOSAIC processing
C           14 Jul 2011  Replaced dw25 calculation with Hayduk and Laudie method.
C                        LeBas molar volumes are from the Schroeder additive method
C                        with the exception of HGIIGAS (modeled as HgCl2) which was
C                        obtained using the Tyn and Calus method. Also, ICL1 and ICL2
C                        were removed. (D. Schwede)
C           27 Jul 2011 J.Bash: Parmaterized the mesophyll resistance as a function
C                        of solubility following Wesely 1989 Atmos Environ.
C           15 Aug 2011  Modified HONO calculation so that deposition velocity for NO2
C                        that is output in DEPV file does not include the loss due to
C                        the heterogeneous reaction. This additional loss is now
C                        accounted for in vdiff.F (D. Schwede and G. Sarwar)
C           29 Aug 2011 Added NH3 bidirectional flux variables and modules and integrated
C                       NH3 bidi algorithms with MOSAIC algorithms. NH3 bidi routines now
C                       read in foratted EPIC output and maintain a soil NH4 budget and
C                       fluxes are calculated for individual land cover types.
C                       (J. Bash and D. Schwede)
C           22 Sep 2011 -- incorporated twoway model implementation
C                       -- removed non-use dluse array
C                          (David Wong)
C           26 Sep 2011 -- made the number of actual and dummy arguments the same in
C                          calling subroutine Init_ABFlux
C                          (David Wong)
C           7 Jun 2012  Allow read of C-staggered (UWINDC and VWINDC) wind and B-staggered
C                       (UWIND and VWIND) from MET_DOT_3D to maintain compatibility with
C                       current and previous versions of MCIP (J. Bash)
C          12 Sep 2012  Added code for NLCD40 land use classification (D. Schwede)
C          20 May 2013  Added code for increased ozone deposition to oceans due to iodide (D. Schwede)
C          30 Jul 2013  Added new organic N species for explicit deposition due to differences in Henry's Law
C          14 Nov 2013  Added MPAN as an explicit species, separating it from PANX
C          28 Aug 2014  G. Sarwar: added deposition data for CLNO2
C           7 Nov 2014  J. Bash: Modified for the restructuring of vidff. Moved constants and data to 
C                       ASX_DATA_MOD.
C            June 2018  revised for v5.3 - removed mosaic, new epic-bidi - j pleim
C          01 Feb 2019  D. Wong: Implemented centralized I/O approach, removed all MY_N clauses
C          12 Dec 2019  S.L.Napelenok: update for cmaq 5.3.1
C          August 2020  J Pleim: corrected TSTEP to be DTSEC. Corrects NH3 bidi emis, dep outputs
C-------------------------------------------------------------------------------

      USE RUNTIME_VARS
      USE HGRD_DEFN      ! horizontal grid specifications
      USE DEPVVARS
      USE VGRD_DEFN      ! to get VGTYP_GD
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES     ! stenex (using SE_COMM_MODULE)
#else
      USE NOOP_MODULES   ! stenex (using NOOP_COMM_MODULE)
#endif     
      Use ABFlux_Mod     ! bidi NH3 exchange routines
      Use ASX_DATA_MOD   ! contains CONSTANTS include
      Use BIDI_MOD, only:HGBIDI    ! contains CONSTANTS include
      Use HGSIM
#ifdef twoway
      USE twoway_data_module, only : num_land_cat
#endif
      Use CENTRALIZED_IO_MODULE, only : WR_AVAIL

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_PVD, S_CGRIDL1
#endif

      IMPLICIT NONE
C Includes:

      INCLUDE SUBST_FILES_ID  ! file name parameters
      INCLUDE SUBST_PE_COMM   ! PE communication displacement and direction

C Arguments:

      INTEGER,     INTENT( IN )  :: jdate
      INTEGER,     INTENT( IN )  :: jtime
      REAL,        INTENT( IN )  :: dtsec      ! model time step (sec)
      REAL,        INTENT( IN )  :: cgridl1( :,:,: )    ! layer 1 concentrations
      REAL,        INTENT( OUT ) :: depvel_gas( :,:,: )
      REAL,        INTENT( OUT ) :: pvd( :,:,: )
      REAL,        INTENT( OUT ) :: nh3_emis(:,:)

C Local Variables:

      INTEGER                    :: c,r,l,n              ! loop variables
      INTEGER                    :: elapsedsec,idt
      INTEGER                    :: ifsnow               ! 1=snow
      INTEGER, SAVE, ALLOCATABLE :: lstwetdate( :,: )
      INTEGER, SAVE, ALLOCATABLE :: lstwettime( :,: )

      REAL                       :: cp_air               ! specific heat of moist air
      REAL                       :: ctemp2               ! temp2 [C]
      REAL                       :: dw
      REAL                       :: dw25       ! diffusivity of water at 298.15 k
      REAL                       :: hcan
      REAL                       :: heff                 ! effective Henry's Law constant
      REAL                       :: heff_ap              ! Henry's Law constant for leaf apoplast M/atm
      REAL                       :: hplus
      REAL                       :: kvisw      ! kinematic viscosity of water [cm^2/s]
      REAL                       :: lv                   ! latent heat of vaporization
      REAL                       :: laicr                ! col row lai
      REAL                       :: q2p0cr               ! cell 2.0 m water vapor mix ratio
      REAL                       :: rac
      REAL                       :: rbc
      REAL                       :: rci
      REAL                       :: rcut
      REAL                       :: rgnd
      REAL                       :: rgndc
      REAL                       :: rgw                  ! resist for water-covered sfc
      REAL                       :: rh_grnd              ! rel humidity (ground)
      REAL                       :: rinc
      REAL                       :: rsnow
      REAL                       :: rstom
      REAL                       :: rsurf
      REAL                       :: rwet                 ! wet sfc resist (cuticle or grnd)
      REAL                       :: rwetsfc
      REAL                       :: scw_pr_23            ! (scw/pr)**2/3
      REAL                       :: temp2p0cr            ! cell 2.0-m temp
      REAL                       :: tempgcr              ! cell ground temp
      REAL                       :: tw                   ! wet bulb temp.
      REAL                       :: ustarcr              ! cell friction velocity
      REAL                       :: vegcr                ! cell veg coverage fraction
      REAL                       :: wrmax
      REAL,    SAVE              :: xcent
      REAL,    SAVE              :: ycent
      REAL                       :: xm                   ! liquid water mass frac
      REAL                       :: rh_func              ! Simple RH function for the development of a water film on leaf cuticles 
      Real,            Parameter :: MolNH3   = 17.01     ! g/mol NH3  for NH3 bidi to convert to microg/m3
      Real,            Parameter :: MolAir   = 29.97     ! g/mol dry air
      Real                       :: cnh3,tpvd,lnh3,femis

      REAL,    SAVE, ALLOCATABLE :: delta     ( :,: )

      REAL,            EXTERNAL  :: hlconst              ! [M / atm]

      LOGICAL                    :: effective  ! true=compute effective Henry's Law const
      LOGICAL, SAVE              :: first_call = .TRUE.

      CHARACTER( 16 ), PARAMETER :: pname      = 'M3DRY'
      CHARACTER( 96 )            :: xmsg = ' '

      REAL, SAVE                 :: scc_pr_23( ltotg )        ! (SCC/PR)**2/3, fn of DIF0

C-------------------------------------------------------------------------------
C gas phase species indexes
      Integer, Save              :: n_HONO
      Integer, Save              :: l_HONO         ! m3dry map
      Integer, Save              :: n_NO2          ! CGRID map
      Integer, Save              :: l_NO2
      Integer, Save              :: n_O3          ! CGRID map
      Integer, Save              :: l_O3
      Integer, Save              :: n_NH3          ! CGRID map
      Integer, Save              :: l_NH3
      Integer, Save              :: n_HG          ! CGRID map
      Integer, Save              :: l_HG
      Integer, Save              :: n_HGII          ! CGRID map
      Integer, Save              :: l_HGII
C-------------------------------------------------------------------------------
C For ozone exchange over the ocean

      REAL                       :: pchang      ! p value used in equation (12) in Chang et al( 2004)
      REAL                       :: kwchang     ! kw value used in Chang et al (2004)
      REAL                       :: ciodide     ! iodide concentration (umol/L)
      REAL                       :: qiodide     ! q in Chang et al (2004)

C-------------------------------------------------------------------------------
C For heterogenous hono on surfaces
      REAL                       :: conc_no2                  ! concentration of NO2
      REAL                       :: kno2                      ! first order rate constant for the heterogenous reaction [1/s]
      REAL                       :: surf_bldg                 ! Surface area of bldgs to volume of air [-]
      REAL                       :: surf_leaf                 ! Surface area of leaves to volume of air [-]
#ifdef sens
      REAL                       :: s_conc_no2( NPMAX )
#endif

C-------------------------------------------------------------------------------
C For Mercury bidirectional flux
      REAL                       :: chg            ! gem layer one concentration
      REAL                       :: awhg           ! GEM Oswald solubility coeff
      REAL                       :: chgIIgas       ! rgm layer one concentration
      REAL                       :: vdHgII         ! divalent mercury deposition velocity
      REAL                       :: vdHg           ! elemental mercury deposition velocity
      REAL                       :: dpvd           ! dummy pvd variable passed to the hgasx subroutine
      REAL                       :: dvel           ! dummy depvel_gas returned from ATX

C-------------------------------------------------------------------------------


      IF ( first_call ) THEN
         first_call = .FALSE.

         DO l = 1, n_spc_m3dry
            IF ( dif0( l ) > 0.0 ) THEN
               scc_pr_23( l ) = ( ( kvis / dif0( l ) ) / pr ) ** twothirds
            ELSE
               scc_pr_23( l ) = 0.0
            END IF
         END DO

         IF ( .NOT. desc3( met_cro_2d ) ) THEN
            xmsg = 'Could not get  met_cro_2d  file description'
            CALL m3exit( pname, jdate, jtime, xmsg, xstat2 )
         END IF

         xcent = real( xcent3d, 4 )
         ycent = real( ycent3d, 4 )

         IF ( abflux ) THEN
            CALL Init_ABFlux( jdate, jtime )
         END IF

         IF ( .NOT. ALLOCATED ( delta ) ) THEN
            ALLOCATE ( delta( ncols,nrows ) )
            delta( :,: ) = 0.0
         END IF

         IF ( .NOT. ALLOCATED ( lstwetdate ) .AND. .NOT. WR_AVAIL ) THEN
            ALLOCATE ( lstwetdate( ncols,nrows ) )
            lstwetdate( :,: ) = 0
         END IF

         IF ( .NOT. ALLOCATED ( lstwettime ) .AND. .NOT. WR_AVAIL ) THEN
            ALLOCATE ( lstwettime( ncols,nrows ) )
            lstwettime( :,: ) = 0
         END IF
C-----------------------------------------------------------------
C        Species maps
C-----------------------------------------------------------------
         l_HONO = 0
         n_HONO = 0
         l_NO2  = 0
         n_NO2  = 0
         l_O3   = 0
         n_O3   = 0
         l_NH3  = 0
         n_NH3  = 0
         l_HG   = 0
         n_HG   = 0
         l_HGII = 0
         n_HGII = 0
         n = 0
         maploop: DO l = 1, n_spc_m3dry
            IF ( .NOT. use_depspc( l ) ) CYCLE maploop
            n = n + 1

            If ( depspc( l ) .EQ. 'NO2' ) THEN
               l_NO2 = l
               n_NO2 = n
            End If
            If ( depspc( l ) .EQ. 'HONO' ) THEN
               l_HONO = l
               n_HONO = n
            End If
            If ( depspc( l ) .EQ. 'O3' ) THEN
               l_O3 = l
               n_O3 = n
            End If
            If ( depspc( l ) .EQ. 'NH3' ) THEN
               l_NH3 = l
               n_NH3 = n
            End If
            If ( depspc( l ) .EQ. 'HG' ) THEN
               l_HG = l
               n_HG = n
            End If
            If ( depspc( l ) .EQ. 'HGIIGAS' ) THEN
               l_HGII = l
               n_HGII = n
            End If
         END DO maploop

      END IF   ! first_call

C-------------------------------------------------------------------------------
C Loop over grid cells and calculate dry deposition.
C-------------------------------------------------------------------------------

      effective = .TRUE.
      idt = nint(dtsec)
      depvel_gas( :,:,: ) = 0.0  ! initialize for this time period
      pvd       ( :,:,: ) = 0.0  !     "       "    "    "    "

#ifdef sens
      s_pvd     ( :,:,:,: ) = 0.0
#endif

      DO r = 1, nrows
      DO c = 1, ncols

         laicr     = MET_DATA%LAI   ( c,r )
         q2p0cr    = MET_DATA%Q2    ( c,r )
         temp2p0cr = MET_DATA%TEMP2 ( c,r )
         tempgcr   = MET_DATA%TEMPG ( c,r )
         ustarcr   = MET_DATA%USTAR ( c,r )
         vegcr     = MET_DATA%VEG   ( c,r )
         ifsnow    = MAX( 0, NINT( MET_DATA%SNOCOV( c,r ) ) )

! Calculate the relative humidity of air and ground.
         
         rh_grnd  = 100.0 * q2p0cr / MET_DATA%QSS_GRND( c,r )
         rh_grnd  = MIN( 100.0, rh_grnd )

         IF ( ( NINT(GRID_DATA%LWMASK( c,r )) .NE. 0 ) .AND. ( vegcr .GT. 0.0 ) ) THEN  ! land

            IF ( .NOT. WR_AVAIL ) THEN  ! approx canopy wetness - dew from Wesely

            ! canopy is wet if > trace precip. or moist with light winds

               IF ( ( MET_DATA%RN( c,r ) + MET_DATA%RC( c,r ) .GT. 0.025 ) .OR.
     &              ( (0.6 + MET_DATA%WSPD10( c,r ))*(100.0-rh_grnd) .LE. 19.0 ) ) THEN

                  delta( c,r )      = 1.0
                  lstwetdate( c,r ) = jdate
                  lstwettime( c,r ) = jtime

               ELSE

                  IF ( MET_DATA%RGRND( c,r ) .GT. 5.0 ) THEN  ! day (if at night, persist delta)

                  ! Determine if canopy was recently wet.

                     IF ( ( lstwetdate( c,r ) .GT. 0 ) .AND.
     &                    ( lstwettime( c,r ) .GT. 0 ) ) THEN  ! canopy recently wet

                        elapsedsec = secsdiff ( lstwetdate( c,r ),
     &                                          lstwettime( c,r ),
     &                                          jdate, jtime )

                        IF ( ( elapsedsec .GT.     0 ) .AND.     ! assume canopy stays
     &                       ( elapsedsec .LE. 7200 ) ) THEN    ! wet for 2 h
                           delta( c,r ) = 1.0
                        ELSE IF ( ( elapsedsec .GT.  7200 ) .AND.     ! ramp down DELTA
     &                            ( elapsedsec .LT. 10800 ) ) THEN    ! between 2 & 3 h
                           delta( c,r ) = ( 10800.0 - FLOAT( elapsedsec ) ) / 3600.0
                        ELSE
                           delta( c,r )      = 0.0
                           lstwetdate( c,r ) = 0
                           lstwettime( c,r ) = 0
                        END IF

                     END IF

                  END IF

               END IF


            ELSE  ! Already have canopy wetness explicitly from met model

               wrmax = 0.2e-3 * vegcr * laicr   ! [m]
               IF ( MET_DATA%WR( c,r ) .LE. 0.0 ) THEN
                  delta( c,r ) = 0.0
               ELSE
                  delta( c,r ) = MET_DATA%WR( c,r ) / wrmax   ! refer to SiB model
                  delta( c,r ) = MIN( delta( c,r ), 1.0 )
               END IF

            END IF   ! canopy wetness

      ! Assign a pH for rain water based on longitude if US simulation.
      ! Otherwise use default pH.  Use pH value in HPLUS calculation.

            IF ( ( ycent .GE.   30.0 ) .AND. ( ycent .LE.  45.0 ) .AND.
     &           ( xcent .GE. -120.0 ) .AND. ( xcent .LE. -70.0 ) ) THEN
               IF ( GRID_DATA%LON( c,r ) .GT. -100.0 ) THEN
                  hplus = hplus_east
               ELSE
                  hplus = hplus_west
               END IF
            ELSE
               hplus = hplus_def
            END IF

         ELSE   ! water
      ! Calculate the water surface film temperature: wet bulb temperature.
      ! Wet bulb temperature based on eqn in Fritschen and Gay (1979).

            ctemp2 = temp2p0cr - stdtemp
            lv     = lv0 - dlvdt * ctemp2
            cp_air = 1004.67 * ( 1.0 + 0.84 * q2p0cr )               ! [J/kg/K]
            tw     = ( ( 4.71e4 * cp_air / lv ) - 0.870 ) + stdtemp  ! [K]

         END IF  ! land or water

      ! Loop over species to calculate dry deposition velocities.

         n = 0
         ddloop: DO l = 1, n_spc_m3dry

            IF ( .NOT. use_depspc( l ) ) CYCLE ddloop

            n = n + 1

            IF ( ( NINT(GRID_DATA%LWMASK( c,r )) .EQ. 0 ) .OR. ( vegcr .EQ. 0.0 ) ) THEN  ! water

               IF ( l .EQ. l_HG ) THEN  ! elemental mercury gas
! calculate and save Henry's constant for use in HGSIM

                  IF( HGBIDI ) THEN 
                     awhg = hlconst( subname( l ), tw, effective, hplus_h2o )* 0.08205 * tw
                  ELSE
                     rsurf = 1.0e30
                  END IF
               ELSE   ! any species other than elemental mercury gas

         ! Use CMAQ function for calculating the effective Henry's Law
         ! constant.  Note that original M3DRY wants inverse, non-
         ! dimensional Henry's Law (caq/cg).   Water pH is different
         ! than rain, and we need to use the water temperature.

                  heff  = hlconst( subname( l ), tw, effective, hplus_h2o )

         ! Make Henry's Law constant non-dimensional.

                  heff  = heff * 0.08205 * tw

         ! from Hayduk and Laudie
                  dw25 = 13.26e-5 / ( 0.8904**1.14 * lebas( l )**0.589 )
                  kvisw = 0.017 * EXP( -0.025 * ( tw - stdtemp ) )
                  dw    = dw25 * ( tw * rt25inK ) * ( 0.009025 / kvisw )
                  scw_pr_23 = ( ( kvisw / dw ) / pr ) ** twothirds

                  IF ( l .EQ. l_O3 ) THEN   !implement Chang et al(2004)
c        pChang is a/H or alpha/H which would be 1/H in current model
c        note that in Chang et al (2004) and Garland et al (1980) their H is Cair/Cwater with is
c        the inverse of heff
                     pChang = 1.75
                     kwChang = (d3*ustarcr)/scw_pr_23


c        If a file of chlorophyll concentrations is provided, Iodide concentration are estimated from
c        a fit to the Rebello et al 1990 data. The slope and correlation are given in the paper
c        but not the intercept, so the data in Tables 3 & 4 were fit to get the relationship below.
c        The regression gives the concentration in umol/L and is converted to mol/L for use in Chang et al eq.
c        The slope and correlation are a slightly different than in Table 5.
c        If chlorophyll concs are not available, a constant value for [I-] of 100e-9 mol/l is used
c        Use ocean file variables to determine if the water cell is ocean or lake; method is only for ocean cells

                     IF (((GRID_DATA%OCEAN(c,r) + GRID_DATA%SZONE(c,r)) .GT. 0) .AND. (MET_DATA%SEAICE(c,r) .LE. 0)) THEN
c        Iodide in sea-water based on SST  (mol /dm-3)
                       ciodide = 1.46E6 * EXP( -9134.0 / tempgcr)
                       qiodide = ( ( 2.0e9 * ciodide * dw * 1e-4 ) ** 0.5 ) * heff
                       rgw = 1.0 / ( pChang * kwchang + qiodide )
                     ELSE                  ! O3 over land
                       rgw   = scw_pr_23 / ( heff * d3 * ustarcr )
                     END IF
                  ELSE                     ! other chems
                     rgw   = scw_pr_23 / ( heff * d3 * ustarcr )
                  END IF

                  rsurf = rgw

               END IF ! Hg

            ELSE   ! land

         ! Use CMAQ function for calculating the effective Henry's Law
         ! constant.  Note that original M3DRY wants inverse,
         ! non-dimensional Henry's Law (caq/cg).

               heff  = hlconst( subname( l ), temp2p0cr, effective, hplus )

         ! Make Henry's Law constant non-dimensional.

               heff  = heff * 0.08205 * temp2p0cr

         ! Wet surface resistance.  (Note DELTA = CWC in ADOM lingo.)
         ! This now applies to cuticle and ground.

               IF ( l .Ne. l_O3 ) THEN 
                  rwet = rcw0 / heff      ! wet cuticle
               ELSE
         ! Canopy level wet resistence Rwet to ozone was found to be about 200 s/m on basis of Keysburg exp
         ! Using LAI(1-sided) of about 6.25 measured at Keysburg gives leaf level rwet about 1250 s/m
                  rwet = 1250.0    ! s/m
         ! Leaf level rwet estimated from Altimir et al 2006 gives about 1350 s/m
               END IF

         ! Dry snow resistance.

               rsnow = rsnow0 * a0 / ar( l )

         ! If the surface is cold and wet, use dry snow.

               IF ( tempgcr .LT. stdtemp ) THEN
                  rwetsfc = rsnow
               ELSE
                  rwetsfc = rwet
               END IF

         ! Dry cuticle resistance.

               IF( l .Eq. l_O3 ) THEN
                  rh_func = max( 0.0,( MET_DATA%RH2( c,r ) - 70.0 )/30.0 )
                  rcut = rcut0 * a0 / ar( l ) * ( 1.0 -rh_func) + rwetsfc * rh_func
               ELSE IF ( l .Eq. l_NH3 ) THEN
         !        rcut = 4000.0 * EXP( -0.054 * MET_DATA%RH( c,r ) )
                  rcut = rwetsfc + 100.0-max(MET_DATA%RH2( c,r ),60.0) ! consistant with bidi
               ELSE 
                  rcut = rcut0 * a0 / ar( l )
               END IF

! Dry ground resistance.  (revised according to Erisman). Canopy height is assumed to be 10 * z0 according to PX-LSM
 
               hcan  = MET_DATA%Z0( c,r ) * 10.0
               rinc  = 14.0 * laicr * hcan / ustarcr
                IF ( depspc( l ) .NE. 'O3' ) THEN
                   rgnd  = rg0 * a0 / ar( l )
                   rgw  = rgwet0 / heff    ! wet ground
               ELSE
! Ozone soil resistence depends on soil moisture (Meszaros et al 2009, Biogeosci; Massman 2004, AE, Ran et al 2016, CMAS)
                   IF ( tempgcr .GE. stdtemp ) THEN
                     rgnd  = 200. + 300. * MET_DATA%SOIM1(c,r)/GRID_DATA%WFC (c,r)
                     rgnd = min (500.0, rgnd)
                     rgw = 500.              ! wet ground for ozone (Massman 2004)
                   ELSE
                     rgnd  = 200. + (rsnow-200.) * MET_DATA%SOIM1(c,r)/GRID_DATA%WFC (c,r)
                     rgnd = min (rsnow, rgnd)
                   endif
               END IF 

               IF ( tempgcr .LT. stdtemp ) THEN   ! frozen ground water = ice
                  rgw = rsnow
               END IF

         ! Determine the snow liquid water mass fraction (0.0 to 0.5).

               xm = 0.02 * ( temp2p0cr - ( stdtemp - 1.0 ) )**2
               xm = MIN (xm, 0.5)
               xm = MAX (xm, 0.0)
               IF ( temp2p0cr .LT. ( stdtemp - 1.0 ) ) xm = 0.0

         ! pathway through canopy to ground, either wet, dry, or snow

               rgndc = rinc + 1.0 / (real( 1-ifsnow )*( ( 1.0 - delta( c,r ) ) / 
     &                 rgnd + delta( c,r ) / rgw ) + real( ifsnow )
     &                 * ( (1.0 - xm) / rsnow + xm / (rsndiff + rgw) ) )

         ! Bulk stomatal resistance; include mesophyll resistance.

               heff_ap = hlconst( subname( l ), temp2p0cr, effective, hplus_ap )

               rstom = MET_DATA%RS( c,r ) * dwat / dif0( l )
     &               + 1.0 / ( heff_ap / 3000.0 + 100.0 * meso( l ) ) / laicr

         ! Bulk surface resistance.

               rci = vegcr
     &             * ( 1.0/rstom + (1.0-delta( c,r ) ) * laicr / rcut
     &             + ( delta( c,r ) * laicr / rwetsfc ) + 1.0 / rgndc )
     &             + (1.0 - vegcr) * ( real( 1-ifsnow ) * ( (1.0-delta( c,r ) ) /
     &                                         rgnd + delta( c,r ) / rgw)  
     &             + real( ifsnow ) * ( (1.0 - xm) / rsnow + xm / (rsndiff + rgw) ) )

               rsurf = 1.0 / rci

            END IF   ! land or water cell

         ! Compute dry deposition velocity.

            rbc = 5.0 / ustarcr * scc_pr_23( l )
            rac = MET_DATA%RA( c,r ) + rbc

            depvel_gas( n,c,r ) = 1.0 / ( rsurf + rac )

C--------------------------------------------------------------------------
            IF ( abflux .And. l .Eq. l_NH3 ) THEN   ! Ammonia Bidirectional Flux
               cnh3  = cgridl1( n,c,r ) * MolNH3/MolAir * 1000.0 * Met_Data%DENS1( C,R ) ! convert to micrograms/m3

               IF ( NINT( GRID_DATA%LWMASK( c,r ) ) .NE. 0 .and. ifsnow .EQ. 0 ) THEN  ! land

                  CALL Get_Flux( cnh3,rwetsfc,rgw,r,c,l,tpvd,lnh3, rbc, rinc, 
     >                           rstom, delta(c,r),rgnd,femis )
                   pvd( n,c,r ) = tpvd * 0.001 * MolAir / (MolNH3 * Met_Data%DENS1( C,R ))
                   nh3_emis(c,r) = nh3_emis(c,r) + femis * dtsec * 1.0e-5  ! convert from microg/m2  to kg/ha
                   depvel_gas( n,c,r ) = lnh3
               ELSE   ! water or snow covered
!                   ddep_nh3(c,r) = ddep_nh3(c,r) + depvel_gas( n,c,r ) * cnh3 * dt(2) * 1.0e-5
                   nh3_emis(c,r) = 0.0
               END IF
            END IF   ! 'abflux'

C--------------------------------------------------------------------------
            IF ( sfc_hono ) THEN

C HONO production via heterogeneous reaction on ground surfaces,
C 2NO2 = HONO + HNO3
C Rate constant for the reaction = (3.0E-3/60)* (A/V),
C where A/V is surface area/volume ratio
C HONO is produced and released into the atmosphere
C NO2 is lost via chemical reaction
C HNO3 is sticky and stays on the surfaces

C Calculate A/V for leaves.
C LAI was multiplied by 2 to account for the fact that surface area
C is provided by both sides of the leaves.
C Matthews Jones, Ammonia deposition to semi-natural vegetation,
C PhD dissertation, University of Dundee, Scotland, 2006

               surf_leaf = 2.0 * laicr / MET_DATA%ZF( c,r,1 )

C Calculate A/V for buildings and other structures.
C Buildings and other structures can provide additional surfaces in
C urban areas for the heterogeneous reaction to occur. However, such
C information is not readily available; in the absence of such information,
C it is scaled to purb(c,r). Svensson et al., (1987) suggests a typical value
C of 0.2 for A/V for buildings in urban environments. A maximum value of 0.2
C for A/V for buildings is assigned to the grid cell containing the highest
C purb(c,r) i.e., 100.0. A/V for buildings for other grid-cell is calculated
C as purb(c,r)*(0.2/100.0); Cai et al. (2006) used a value of 1.0 for their
C study at New York (total A/V)

               surf_bldg = GRID_DATA%PURB( c,r ) * 0.002

C Calculate rate constant for the reaction (psudeo-first order reaction,
C unit per second). Calculate pseudo-first order rate constant using Eq 1
C of Vogel et al. (2003).  Unit of KNO2 is in 1/min in the paper; divide it
C by 60 to convert it into 1/sec.

!                 kno2 = MAX( 0.0, 3.0E-3 * (surf_leaf + surf_bldg) / 60.0 )
                  kno2 = MAX( 0.0, 5.0E-5 * (surf_leaf + surf_bldg) )

C Determine NO2 concentration needed for HONO production term.

                  IF ( l .EQ. l_NO2 ) THEN
                     conc_no2 = cgridl1( n,c,r )

#ifdef sens
                     DO NP = 1, NPMAX
                        s_conc_no2( NP ) = s_cgridl1( NP, n,c,r )
                     END DO
#endif

C Loss of NO2 via the heterogeneous reaction is accounted as additional
C depositional loss. Add the loss of NO2 via the heterogeneous reaction
C to the regular deposition velocity (increased dep. vel.).  This will
C reduce the NO2 conc. in the atmosphere. Dep vel is adjusted back to the
C original value in vdiffacm2 after NO2 conc is reduced but before calculating
C depositional loss.

!                    depvel_gas( n,c,r ) = depvel_gas( n,c,r ) + 2.0 * kno2 * zf( c,r )

               END IF

C Calculate production (pvd) for HONO; unit = ppm * m/s

               IF ( l .EQ. l_HONO)
     &            pvd( n,c,r ) = kno2 * conc_no2 * MET_DATA%ZF( c,r,1 )
#ifdef sens
               IF ( l .EQ. l_HONO) THEN
                  DO NP = 1, NPMAX
                     s_pvd( NP,n,c,r ) = kno2 * s_conc_no2( NP ) * MET_DATA%ZF( c,r,1 )
                  END DO
               END IF
#endif
            END IF
C--------------------------------------------------------------------------
C Bidirectional mercury flux section
C--------------------------------------------------------------------------

            IF ( HGBIDI .AND.  l .EQ. l_HG ) THEN

               chg  = cgridl1( n_HG,c,r )

               IF ( NINT( GRID_DATA%LWMASK( c,r ) ) .EQ. 0  .AND. ( vegcr .EQ. 0.0 )) THEN ! water

                  depvel_gas( n_Hg,c,r ) = 1.0 / ( rsurf + rac )
                  vdhg = depvel_gas( n_Hg,c,r )
                  pvd( n_Hg,c,r )  = 0.0 ! in the nether regions of LU/LC

               ELSE ! terrestrial

                  awhg  = hlconst( subname( l ), temp2p0cr, effective, hplus )* 0.08205 * temp2p0cr

C************* Call the Hg air surface exchange subroutine *************************************************
                 CALL ATX(rbc, rcut, rwetsfc, rinc,rsnow, rgw, ifsnow, xm, dvel, chg, awhg,
     &                    dpvd, delta( c,r ),idt, c, r, l_HG, jdate, jtime )

                  pvd( n_HG,c,r ) = dpvd

                  depvel_gas( n_HG,c,r ) = dvel

               END IF ! water

            END IF ! 'HG'

               ! Check for negative values or NaN's

            IF ( depvel_gas( n,c,r ) .LT. 0.0 .OR.
     &           depvel_gas( n,c,r ) .NE. depvel_gas( n,c,r ) ) GO TO 999            

         END DO ddloop  ! (l = 1, n_spc_m3dry)

         IF ( HGBIDI .AND. NINT( GRID_DATA%LWMASK( c,r ) ) .EQ. 0 .AND. ( vegcr .EQ. 0.0 )) THEN ! water

            chgIIgas = cgridl1( n_HGII,c,r )
            vdhgII   = depvel_gas( n_HGII,c,r )

            CALL ASWX( chg, chgIIgas, vdhg, vdhgII, awhg,
     &                 dpvd, c, r, jdate, jtime, idt )

            pvd( n_Hg,c,r ) = dpvd

         END IF ! water

      END DO   ! c
      END DO   ! r

      RETURN

C-------------------------------------------------------------------------------
C Error-handling section.
C-------------------------------------------------------------------------------

999   CONTINUE
      WRITE( logdev,9003 ) c, r, TRIM( subname( l ) ), depvel_gas( n,c,r )
      xmsg = 'ABORT'

1001  CONTINUE

      CALL m3exit( pname, jdate, jtime, xmsg, xstat1 )

      RETURN

C-------------------------------------------------------------------------------
C Format statements.
C-------------------------------------------------------------------------------

6501  FORMAT(/ 1x, 70('='),
     &       / 1x, '--- Subroutine: M3DRY',
     &       / 1x, '---   Found canopy wetness (WR) in MET_CRO_2D ',
     &       / 1x, 70('=') /)

6503  FORMAT(/ 1x, 70('='),
     &       / 1x, '--- Subroutine: M3DRY',
     &       / 1x, '---   Found 2-m water vapor mixing ratio (Q2) in MET_CRO_2D',
     &       / 1x, 70('=') /)

9001  FORMAT( 'Failure reading ', a, 1x, 'from ', a )

9003  FORMAT(/ 1x, 70('*'),
     &       / 1x, '*** Subroutine: M3DRY',
     &       / 1x, '***   NEGATIVE or UNDEFINED Dry Deposition Velocity',
     &       / 1x, '***   Point   = ', 2i5,
     &       / 1x, '***   Species = ', a,
     &       / 1x, '***   Vd      = ', e13.6,
     &       / 1x, 70('*') /)

9005  FORMAT(/ 1x, 70('*'),
     &       / 1x, '*** Subroutine: M3DRY',
     &       / 1x, '***   Bidirectional flux for ammonia assumes ',
     &       / 1x, '***   USGS 24-category land use.',
     &       / 1x, '***   Need to update N_LUFRAC, LUF_FAC, and other places',
     &       / 1x, '***   Land use description is: ', a,
     &       / 1x, 70('*') /)
9033  FORMAT(/ 1x, 70('*'),
     &       / 1x, '*** Subroutine: M3DRY',
     &       / 1x, '***   NEGATIVE or UNDEFINED Land use specific Dry Deposition Velocity',
     &       / 1x, '***   Column  = ', i5,
     &       / 1x, '***   Row     = ', i5,
     &       / 1x, '***   Luc     = ', i5,
     &       / 1x, '***   Species = ', a,
     &       / 1x, '***   Vd      = ', e13.6,
     &       / 1x, '***   lai     = ', g10.3,
     &       / 1x, '***   z0      = ', g10.3,
     &       / 1x, '***   ustar   = ', g10.3,
     &       / 1x, '***   rgndc   = ', g10.3,
     &       / 1x, '***   Ra      = ', g10.3,
     &       / 1x, '***   Rbc     = ', g10.3,
     &       / 1x, '***   Rsurf   = ', g10.3,
     &       / 1x, '***   Rstom   = ', g10.3,
     &       / 1x, '***   Rcut    = ', g10.3,
     &       / 1x, '***   Rwetsfc = ', g10.3,
     &       / 1x, '***   Rgnd    = ', g10.3,
     &       / 1x, '***   Rgw     = ', g10.3,
     &       / 1x, '***   Delta   = ', g10.3,
     &       / 1x, '***   Veg     = ', g10.3,
     &       / 1x, '***   Xm      = ', g10.3,
     &       / 1x, '***   Rsndiff = ', g10.3,
     &       / 1x, '***   ifsnow  = ', i6
     &       / 1x, 70('*') /)

9034  FORMAT(/ 1x, 70('*'),
     &       / 1x, '*** Subroutine: M3DRY',
     &       / 1x, '***   NEGATIVE or UNDEFINED Land use specific Dry Deposition Velocity',
     &       / 1x, '***   Column  = ', i5,
     &       / 1x, '***   Row     = ', i5,
     &       / 1x, '***   Luc     = ', i5,
     &       / 1x, '***   Species = ', a,
     &       / 1x, '***   Vdfstj  = ', e13.6,
     &       / 1x, '***   Rcanj    = ', e13.6,
     &       / 1x, '***   Rstcj   = ', e13.6,
     &       / 1x, '***   Rstomj  = ', e13.6,
     &       / 1x, 70('*') /)

      END SUBROUTINE m3dry

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module vdiff_diag
C diagnostic output of acm2 parameters and sedimentation velocities
      use runtime_vars
      use utilio_defn
      use grid_conf
      use cgrid_spcs

      implicit none

      character( 16 ), save :: vdiff_diag_file = 'VDIFF_DIAG_FILE'

      integer, save :: n_vdiff
      integer, save :: n_vsed
      character( 16 ), allocatable, save :: vsed_name( : )
      integer, allocatable, save :: vsed_map( : )

      integer, save :: ntics = 0           ! no. of substeps within an output time step
C vdiff sub-timestep counter
      real, allocatable :: nlpcr_mean( :,: )   ! over the output time step TSTEP(1)
      real, allocatable :: nlpcr_max( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: nlpcr_min( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: nlpcr_sum( :,: )    ! accumulator
C sedi sub-timestep counter
      real, allocatable :: dtccr_mean( :,: )   ! over the output time step TSTEP(1)
      real, allocatable :: dtccr_max( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: dtccr_min( :,: )    ! over the output time step TSTEP(1)
      real, allocatable :: dtccr_sum( :,: )    ! accumulator
      real, allocatable :: cnvct( :,: )
      real, allocatable :: vsed_buf( :,:,:,: )

      contains

         function vdiff_diag_init( jdate, jtime, tstep1, grvsetl ) result ( success )

! Revision History.
!     Aug 12,2015 D. Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
!     Mar  2,2016 D. Wong: Modified the code to handle any combination of two environment
!                          variables: CTM_GRAV_SETL and VDIFF_DIAG_FILE, in a robust way for
!                          parallel I/O implementation

#ifdef parallel
         use se_modules            ! stenex (using SE_UTIL_MODULE)
#else
         use noop_modules          ! stenex (using NOOP_UTIL_MODULE)
#endif

         implicit none
         include SUBST_FILES_ID  ! file name parameters
         logical success
         integer jdate, jtime, tstep1
         logical grvsetl
         character( 96 ) :: xmsg = ' '
         character( 16 ) :: pname = 'vdiff_diag_init'  
         logical ok, add, skip
         integer i, j, k, v, ios
         integer, allocatable :: found( : )

         success = .true.

         if ( grvsetl ) then
            n_vdiff = 8   ! nlp's, sedi dtc's, convct, lpbl
            n_vsed = 6    ! aero sedv
            allocate( vsed_name( n_vsed ),
     &                vsed_map( n_vsed ),
     &                found( n_vsed ), stat = ios )
            if ( ios .ne. 0 ) then
               xmsg = "ERROR allocating nlp_'s or cnvct"
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            vsed_name = ( / 'VNUMACC', 'VNUMCOR', 'VSRFACC',
     &                      'VSRFCOR', 'VMASSJ ', 'VMASSC ' / )
         else
            n_vdiff = 5
            n_vsed = 0
         end if

         if ( grvsetl ) then
C Create the vsed_map (find the 1st vsed_ae species for each of the 6 surrogate classes)
            do i = 1, n_vsed
               found( i ) = -9
            end do

            k = 0
            do v = 1, n_ae_depv

               skip = .true.
               do i = 1, n_vsed   ! search the entire list
                  if ( ae_depv( v ) .eq. vsed_name( i ) ) skip = .false.
               end do
               if ( skip ) cycle

               j = index1( ae_depv( v ), n_vsed, vsed_name )
               add = .true.
               do i = 1, n_vsed   ! search the entire list for j
                  if ( j .eq. found( i ) ) then
                     add = .false.
                  end if
               end do
               if ( add ) then    ! this j is not in the list; add it
                  k = k + 1
                  found( k ) = j
                  vsed_map( k ) = v
               end if

            end do
    
         end if

         if ( io_pe_inclusive ) then

C get CONC file header description
            ok = open3( ctm_conc_1, fsread3, pname )
            ok = desc3( ctm_conc_1 )
            if ( .not. ok ) then
               xmsg = 'could not read '// trim( ctm_conc_1 )
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

            sdate3d = jdate
            stime3d = jtime
            call nextime ( sdate3d, stime3d, tstep1 ) 

            if ( grvsetl ) then

               nvars3d = n_vsed
               fdesc3d = ' '   ! array
               fdesc3d( 1 ) = 'representative coarse aerosol gravitational settling velocities'
               do v = 1, n_vsed
                  vtype3d( v ) = m3real
                  units3d( v ) = 'm s-1'
                  vname3d( v ) = vsed_name( v )
                  vdesc3d( v ) = 'gravitational settling velocity'
               end do

               ok = open3( ctm_vsed_diag, fsnew3, pname )
               if ( .not. ok ) then
                  xmsg = 'could not create '// trim( ctm_vsed_diag ) // ' file'
                  call m3warn( 'vdiff_diag', jdate, jtime, xmsg )
                  success = .false.; return
               end if

            end if

            nvars3d = n_vdiff
            nlays3d = 1
            fdesc3d = ' '   ! array
            fdesc3d( 1 ) = 'vdiff diagnostic variables'
            v = 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'NLP_MEAN'
            vdesc3d( v ) = 'mean sub-timestep iteration count'
            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'NLP_MAX'
            vdesc3d( v ) = 'max sub-timestep iteration count'
            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'NLP_MIN'
            vdesc3d( v ) = 'min sub-timestep iteration count'

            if ( grvsetl ) then

               v = v + 1
               vtype3d( v ) = m3real
               units3d( v ) = ''
               vname3d( v ) = 'SEDI_DTC_MEAN'
               vdesc3d( v ) = 'mean grav. settling velocity sub-timestep iteration count'
               v = v + 1
               vtype3d( v ) = m3real
               units3d( v ) = ''
               vname3d( v ) = 'SEDI_DTC_MAX'
               vdesc3d( v ) = 'max grav. settling velocity sub-timestep iteration count'
               v = v + 1
               vtype3d( v ) = m3real
               units3d( v ) = ''
               vname3d( v ) = 'SEDI_DTC_MIN'
               vdesc3d( v ) = 'min grav. settling velocity sub-timestep iteration count'
            end if

            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'CONVCT'
            vdesc3d( v ) = 'Convective cell (for ACM2)'
            v = v + 1
            vtype3d( v ) = m3real
            units3d( v ) = ''
            vname3d( v ) = 'LPBL'
            vdesc3d( v ) = 'PBL top sigma layer'

            ok = open3( ctm_vdiff_diag, fsnew3, pname )
            if ( .not. ok ) then
               xmsg = 'could not create '// trim( ctm_vdiff_diag ) // ' file'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

         end if  ! io_pe_inclusive

         allocate ( nlpcr_max( ncols,nrows ),
     &              nlpcr_min( ncols,nrows ),
     &              nlpcr_mean( ncols,nrows ),
     &              nlpcr_sum( ncols,nrows ),
     &              cnvct( ncols,nrows ), stat = ios )
         if ( ios .ne. 0 ) then
            xmsg = "ERROR allocating nlp_'s or cnvct"
            call m3warn( pname, jdate, jtime, xmsg )
            success = .false.; return
         end if
         nlpcr_max = 0.0      ! array assignment
         nlpcr_min = 9.9E30   ! array assignment
         nlpcr_sum = 0.0      ! array assignment

         if ( grvsetl ) then

            allocate ( vsed_buf( ncols,nrows,nlays,n_vsed ), stat = ios )
            if ( ios .ne. 0 ) then
               xmsg = 'ERROR allocating vsed_buf'
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if

            allocate ( dtccr_max( ncols,nrows ), 
     &                 dtccr_min( ncols,nrows ), 
     &                 dtccr_mean( ncols,nrows ),
     &                 dtccr_sum( ncols,nrows ), stat = ios )
            if ( ios .ne. 0 ) then
               xmsg = "ERROR allocating , sedi dtc's"
               call m3warn( pname, jdate, jtime, xmsg )
               success = .false.; return
            end if
            dtccr_max = 0.0      ! array assignment
            dtccr_min = 9.9E30   ! array assignment
            dtccr_sum = 0.0      ! array assignment

         end if

#ifdef parallel_io
         call se_barrier
         if ( .not. io_pe_inclusive ) then
            if ( grvsetl ) then
               if ( .not. open3 ( ctm_vsed_diag, fsread3, pname ) ) then
                  xmsg = 'Could not open ' // trim( ctm_vsed_diag )
                  call m3exit ( pname, jdate, jtime, xmsg, xstat2 )
               end if
            end if
            if ( .not. open3 ( ctm_vdiff_diag, fsread3, pname ) ) then
               xmsg = 'Could not open ' // trim( ctm_vdiff_diag )
               call m3exit ( pname, jdate, jtime, xmsg, xstat2 )
            end if
         end if
#endif

         end function vdiff_diag_init

      end module vdiff_diag

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PTMET

C-----------------------------------------------------------------------
C Function: 3d point source emissions met data

C Revision History:
C     20 Nov 2007 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     27 Jul 2011 D.Wong: removed calculation which extends SRTCOL and STRTROW
C                         to the west and south direction in subroutines: 
C                         READMC2, READMC3, and READMD3
C     12 Aug 2015 D.Wong: - Used assumed shape array declaration and declared 
C                           associated subroutines in INTERFACE block
C                         - Replaced BMATVEC with BMATVECN which will call
C                           with a 1d or 2d argument subroutine by F90 
C                           poly-morphism feature
C                         - Based on the condition of MY_NSRC ( > 0 or not) to 
C                           determine execution of certain section of code or not
C                         - fixed a bug of incorrect assignment:
C                           PTMET_DATA%LEN1 = EMLAYS, PTMET_DATA%LEN2 = MSRC
C     01 Feb 2019 D.Wong: - Implemented centralized I/O approach and removed 
C                           ZSTATIC implementation
C     05 Aug 2019 D.Wong: - Used met information in the cell where a point source resides
C                           rather than using bi-linear interpolation (call BMATVECN) to
C                           obtain met information for that point source
C     06 Aug 2019 D.Wong: - For two-way model, use UWIND/VWIND (wind U/V component on the
C                           mass point and in offline CMAQ model, use average value of
C                           UWINDC/VWINDC to approximate UWIND/VWIND. Hence no longer
C                           need UWINDC_AVAIL/VWINDC_AVAIL
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE UDTYPES, ONLY: PTMET_TYPE
      USE EMIS_VARS, ONLY : EMLAYS

      IMPLICIT NONE

c     TYPE :: PTMET_TYPE
c        INTEGER          :: LEN1, LEN2
C Allocatable per-source meteorology variables
c        REAL,    POINTER :: HFX( : )        ! sensible heat flux [watts/m**2]
c        REAL,    POINTER :: HMIX( : )       ! mixing height [m]
c        REAL,    POINTER :: TSFC( : )       ! surface temperature [degK]
c        REAL,    POINTER :: USTAR( : )      ! friction velocity [m/s]
c        REAL,    POINTER :: PRSFC( : )      ! surface pressure [Pa]
C Allocatable temporary per-layer variables from 1:EMLAYS
c        REAL,    POINTER :: WSPD( : )       ! wind speed [m/s]
c        REAL,    POINTER :: DTHDZ( : )      ! virtual pot temp gradient [degK/m]
C Allocatable temporary per-layer variables from 0:EMLAYS
c        REAL,    POINTER :: PRESF( : )      ! pressure at full-levels
c        REAL,    POINTER :: ZZF( : )        ! per src elevn at full-levels
c Allocatable per-source and per layer meteorology variables.
C Dimensioned by layers, then sources
c!       REAL,    POINTER :: DDZH ( :,: )    ! 1/( ZH(L) - ZH(L-1) )
c        REAL,    POINTER :: DDZF ( :,: )    ! 1/( ZF(L) - ZF(L-1) )
c        REAL,    POINTER :: PRES ( :,: )    ! pressure [Pa]
c        REAL,    POINTER :: DENS ( :,: )    ! air density [kg/m**3]
c        REAL,    POINTER :: QV   ( :,: )    ! moisture mixing ratio [kg/kg]
c        REAL,    POINTER :: TA   ( :,: )    ! temperature [degK]
c        REAL,    POINTER :: UWIND( :,: )    ! x-component wind speed [m/s]
c        REAL,    POINTER :: VWIND( :,: )    ! y-component wind speed [m/s]
c        REAL,    POINTER :: ZF   ( :,: )    ! full layer height [m]
c        REAL,    POINTER :: ZH   ( :,: )    ! mid layer height [m]
c        REAL,    POINTER :: ZSTK ( :,: )    ! ZF( L,S ) - STKHT(S) [m]
c     END TYPE PTMET_TYPE

      TYPE( PTMET_TYPE ), ALLOCATABLE, SAVE :: PTMET_DATA( : )

C cross-point surface met file name
      CHARACTER(  16 ),              SAVE :: MC2NAME
C cross-point layered met file name
      CHARACTER(  16 ),              SAVE :: MC3NAME
C dot-point layered met file name
      CHARACTER(  16 ),              SAVE :: MD3NAME

C-----------------------------------------------------------------------
      CONTAINS

         FUNCTION PTMET_INIT ( ) RESULT ( SUCCESS )

         USE M3UTILIO
         USE STK_PRMS, ONLY: MY_NSRC         

         IMPLICIT NONE

         LOGICAL               :: SUCCESS                          

         INTEGER N, MSRC, IOS
         CHARACTER( 16 ) :: PNAME = 'PTMET_INIT'   ! procedure name

         SUCCESS = .TRUE.
         ALLOCATE( PTMET_DATA( NPTGRPS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'PTMET_DATA', PNAME )

         DO N = 1, NPTGRPS

            MSRC = MY_NSRC( N )
            PTMET_DATA(N)%LEN1 = EMLAYS; PTMET_DATA(N)%LEN2 = MSRC

            IF ( MY_NSRC( N ) .GT. 0 ) THEN
C Allocate per-source arrays
               ALLOCATE( PTMET_DATA( N )%HFX  ( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'HFX', PNAME )
               ALLOCATE( PTMET_DATA( N )%HMIX ( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'HMIX', PNAME )
               ALLOCATE( PTMET_DATA( N )%TSFC ( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'TSFC', PNAME )
               ALLOCATE( PTMET_DATA( N )%USTAR( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'USTAR', PNAME )
               ALLOCATE( PTMET_DATA( N )%PRSFC( MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'PRSFC', PNAME )

C Allocate per-source and per-layer arrays
               ALLOCATE( PTMET_DATA( N )%DDZF ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'DDZF', PNAME )
               ALLOCATE( PTMET_DATA( N )%PRES ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'PRES', PNAME )
               ALLOCATE( PTMET_DATA( N )%DENS ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'DENS', PNAME )
               ALLOCATE( PTMET_DATA( N )%QV   ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'QV', PNAME )
               ALLOCATE( PTMET_DATA( N )%TA   ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'TA', PNAME )
               ALLOCATE( PTMET_DATA( N )%UWIND( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'UWIND', PNAME )
               ALLOCATE( PTMET_DATA( N )%VWIND( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'VWIND', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZF   ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZF', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZH   ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZH', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZSTK ( EMLAYS,MSRC ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZSTK', PNAME )

C Allocate per-layer arrays from 1:EMLAYS
               ALLOCATE( PTMET_DATA( N )%WSPD ( EMLAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'WSPD', PNAME )
               ALLOCATE( PTMET_DATA( N )%DTHDZ( EMLAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'DTHDZ', PNAME )

C Allocate per-layer arrays from 0:EMLAYS
               ALLOCATE( PTMET_DATA( N )%PRESF( 0:EMLAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'PRESF', PNAME )
               ALLOCATE( PTMET_DATA( N )%ZZF  ( 0:EMLAYS ), STAT=IOS )
               CALL CHECKMEM( IOS, 'ZZF', PNAME )
            END IF ! (MY_NSRC( N ) > 0)

         END DO

         END FUNCTION PTMET_INIT 

C-----------------------------------------------------------------------

         SUBROUTINE PTMET_CONVT( JDATE, JTIME )

         USE STK_PRMS, ONLY: MY_NSRC, SOURCE, MY_STKCOL, MY_STKROW
         USE STACK_GROUP_DATA_MODULE, ONLY: STKHT
         USE CENTRALIZED_IO_MODULE, ONLY : INTERPOLATE_VAR
         USE HGRD_DEFN, ONLY : NCOLS, NROWS
         USE VGRD_DEFN, ONLY : NLAYS

         IMPLICIT NONE

         INTEGER, INTENT( IN ) :: JDATE, JTIME

         INTEGER         :: L, N, MSRC, S
         CHARACTER( 16 ) :: PNAME = 'PTMET_CONVT'   ! PROCEDURE NAME

         INTEGER :: MYC, MYR, STAT
         
         REAL, ALLOCATABLE, SAVE:: LOC_ZH(:,:,:),
     &                             LOC_ZF(:,:,:),
     &                             LOC_HFX(:,:),
     &                             LOC_PBL(:,:),
     &                             LOC_TEMP2(:,:),
     &                             LOC_USTAR(:,:),
     &                             LOC_PRSFC(:,:),
     &                             LOC_TA(:,:,:),
     &                             LOC_QV(:,:,:),
     &                             LOC_PRES(:,:,:),
     &                             LOC_DENS(:,:,:),
     &                             LOC_UWIND(:,:,:),
     &                             LOC_VWIND(:,:,:)

         LOGICAL, SAVE :: INITIALIZE = .TRUE.
         
         INTERFACE
            SUBROUTINE DELTA_ZS( EMLAYS, MY_NSRC, SRC_MAP, STKHT, ZF, ZSTK, DDZF )
               INTEGER, INTENT( IN )  :: EMLAYS, MY_NSRC
               INTEGER, INTENT( IN )  :: SRC_MAP( : )
               REAL,    INTENT( IN )  :: STKHT( : )
               REAL,    INTENT( IN )  :: ZF  ( :,: )
               REAL,    INTENT( OUT ) :: ZSTK( :,: )
               REAL,    INTENT( OUT ) :: DDZF( :,: )
            END SUBROUTINE DELTA_ZS
         END INTERFACE

C-----------------------------------------------------------------------

         IF ( INITIALIZE ) THEN
         
            ALLOCATE ( LOC_ZH(NCOLS,NROWS,NLAYS),
     &                 LOC_ZF(NCOLS,NROWS,NLAYS),
     &                 LOC_HFX(NCOLS,NROWS),
     &                 LOC_PBL(NCOLS,NROWS),
     &                 LOC_TEMP2(NCOLS,NROWS),
     &                 LOC_USTAR(NCOLS,NROWS),
     &                 LOC_PRSFC(NCOLS,NROWS),
     &                 LOC_TA(NCOLS,NROWS,NLAYS),
     &                 LOC_QV(NCOLS,NROWS,NLAYS),
     &                 LOC_PRES(NCOLS,NROWS,NLAYS),
     &                 LOC_DENS(NCOLS,NROWS,NLAYS),
     &                 LOC_UWIND(NCOLS+1,NROWS+1,NLAYS),
     &                 LOC_VWIND(NCOLS+1,NROWS+1,NLAYS),
     &                 STAT=STAT)
     
           INITIALIZE = .FALSE.
           
         END IF

         CALL INTERPOLATE_VAR ('ZH', JDATE, JTIME, LOC_ZH)
         CALL INTERPOLATE_VAR ('ZF', JDATE, JTIME, LOC_ZF)
         CALL INTERPOLATE_VAR ('HFX', JDATE, JTIME, LOC_HFX)
         CALL INTERPOLATE_VAR ('PBL', JDATE, JTIME, LOC_PBL)
         CALL INTERPOLATE_VAR ('TEMP2', JDATE, JTIME, LOC_TEMP2)
         CALL INTERPOLATE_VAR ('USTAR', JDATE, JTIME, LOC_USTAR)
         CALL INTERPOLATE_VAR ('PRSFC', JDATE, JTIME, LOC_PRSFC)
         CALL INTERPOLATE_VAR ('TA', JDATE, JTIME, LOC_TA)
         CALL INTERPOLATE_VAR ('QV', JDATE, JTIME, LOC_QV)
         CALL INTERPOLATE_VAR ('PRES', JDATE, JTIME, LOC_PRES)
         CALL INTERPOLATE_VAR ('DENS', JDATE, JTIME, LOC_DENS)
#ifdef twoway
         CALL INTERPOLATE_VAR ('UWIND', JDATE, JTIME, LOC_UWIND)
         CALL INTERPOLATE_VAR ('VWIND', JDATE, JTIME, LOC_VWIND)
#else
         CALL INTERPOLATE_VAR ('UWINDC', JDATE, JTIME, LOC_UWIND)
         CALL INTERPOLATE_VAR ('VWINDC', JDATE, JTIME, LOC_VWIND)
#endif
         DO N = 1, NPTGRPS

            MSRC = MY_NSRC( N )

            DO S = 1, MY_NSRC (N )

               MYC = MY_STKCOL( N )%ARRY( S )
               MYR = MY_STKROW( N )%ARRY( S )

               PTMET_DATA( N )%HFX(S) = LOC_HFX(MYC, MYR)

               PTMET_DATA( N )%HMIX(S) = LOC_PBL(MYC, MYR)

               PTMET_DATA( N )%TSFC(S) = LOC_TEMP2(MYC, MYR)

               PTMET_DATA( N )%USTAR(S) = LOC_USTAR(MYC, MYR)

               PTMET_DATA( N )%PRSFC(S) = LOC_PRSFC(MYC, MYR)

               DO L = 1, NLAYS
               
                  PTMET_DATA( N )%ZH(L,S)    = LOC_ZH(MYC, MYR, L)
                  
                  PTMET_DATA( N )%ZF(L,S)    = LOC_ZF(MYC, MYR, L)
                  
                  PTMET_DATA( N )%TA(L,S)    = LOC_TA(MYC, MYR, L)
                  
                  PTMET_DATA( N )%QV(L,S)    = LOC_QV(MYC, MYR, L)
                  
                  PTMET_DATA( N )%PRES(L,S)  = LOC_PRES(MYC, MYR, L)
                  
                  PTMET_DATA( N )%DENS(L,S)  = LOC_DENS(MYC, MYR, L)
#ifdef twoway
                  PTMET_DATA( N )%UWIND(:,S) = LOC_UWIND(MYC, MYR, L)

                  PTMET_DATA( N )%VWIND(:,S) = LOC_VWIND(MYC, MYR, L)
#else
                  PTMET_DATA( N )%UWIND(L,S) = 0.5*( LOC_UWIND(MYC, MYR, L)
     &                                       +       LOC_UWIND(MYC+1, MYR, L) )
               
                  PTMET_DATA( N )%VWIND(L,S) = 0.5*( LOC_VWIND(MYC, MYR, L)
     &                                       +       LOC_VWIND(MYC, MYR+1, L) )
#endif                
               END DO

            END DO

            IF ( MY_NSRC( N ) .GT. 0 ) THEN ! Compute ZSTK, DDZF
               CALL DELTA_ZS( EMLAYS, MSRC,
     &                        SOURCE( N )%ARRY, STKHT( N )%ARRY,
     &                        PTMET_DATA( N )%ZF,
     &                        PTMET_DATA( N )%ZSTK,
     &                        PTMET_DATA( N )%DDZF )
            END IF ! MY_NSRC( N ) > 0

         END DO   ! NPTGRPS

         END SUBROUTINE PTMET_CONVT

C-----------------------------------------------------------------------

      END MODULE PTMET

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPACONC ( JDATE, JTIME, TSTEP )

! Revision History:
!   D. Wong - July 15: initial version
!   D. Wong 19 May 2016 - renamed ACONC_END_TIME to AVG_FILE_ENDTIME
!   F. Sidi 09 Sep 2019 - Replaced L_ACONC_WVEL(depreciated) with W_VEL
!-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE AVG_CONC              ! integral average CONC
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

! Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      INTEGER, INTENT (IN ) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT (IN ) :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT (IN ) :: TSTEP        ! output timestep (HHMMSS)

! Local variables:

      INTEGER      MDATE        ! modified model date, coded YYYYDDD
      INTEGER      MTIME        ! modified model time, coded HHMMSS

      CHARACTER( 16 ) :: PNAME = 'OPACONC'
      CHARACTER( 80 ) :: VARDESC = ' '
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER      L, K, KD, VAR, SPC ! loop counters
      INTEGER      STATUS

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF
!-----------------------------------------------------------------------

! Change output date/time to starting date/time - e.g. timestamp 1995196:090000
! represents data computed from time 1995196:090000 to 1995196:100000
 
! Override default beginning time timestamp for ACONC?      
      IF ( END_TIME ) THEN   ! ending time timestamp
         MDATE = JDATE; MTIME = JTIME
         CALL NEXTIME ( MDATE, MTIME, TSTEP )
      ELSE                   ! beginning time timestamp
         MDATE = JDATE; MTIME = JTIME
      END IF
 

! Try to open existing file for update
      OK = OPEN3( A_CONC_1, FSRDWR3, PNAME )
      CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )
      IF ( .NOT. OK ) THEN
#ifndef twoway
         BACKSPACE( LOGDEV )
#endif
         XMSG = 'Could not open ' // TRIM( A_CONC_1 )
     &        // ' file for update - try to open new'
         CALL M3MESG( XMSG )

         IF ( IO_PE_INCLUSIVE ) THEN

! Get default file header attibutes from CONC file (assumes file already open)

            IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
               XMSG = 'Could not get '
     &              // TRIM( CTM_CONC_1 )
     &              // ' file description'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

! Set file header attributes that differ from CONC and open the file

            SDATE3D = MDATE
            STIME3D = MTIME
            TSTEP3D = TSTEP
            NVARS3D = N_ACONC_VARS
            NLAYS3D = A_NLYS

            L = 0
            DO K = ACONC_BLEV, ACONC_ELEV + 1
               L = L + 1
               VGLVS3D( L ) = VGLVS_GD( K )
            END DO
!           GDNAM3D = GDNAME_GD
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            FDESC3D( 1 ) = 'Concentration file output '
            FDESC3D( 2 ) = 'Averaged over the synchronization time steps '
            FDESC3D( 3 ) = 'Timestamp represents beginning computed date/time '
            FDESC3D( 4 ) = 'Layer mapping (CGRID to AGRID):'
            KD = 4
            VAR = ACONC_BLEV
            L = 0
            DO K = KD + 1, MIN ( A_NLYS + KD, MXDESC3 )
               L = L + 1
               WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &         VAR + L - 1, L
            END DO
            IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
               DO K = KD + 1 + L, MXDESC3
                  FDESC3D( K ) = ' '
               END DO
            END IF

            WRITE( LOGDEV,* ) 
            WRITE( LOGDEV, '(5x,A)' ) 'Avg Conc File Header Description:'
            DO K = 1, KD + L
               WRITE( LOGDEV,'(7x,A)' ) TRIM( FDESC3D( K ) )
            END DO

            VAR = 0

            DO SPC = 1, N_A_GC_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_GC_SPC( SPC )
               UNITS3D( VAR ) = 'ppmV'
               VDESC3D( VAR ) = 'Average Molar Mixing Ratio of ' // VNAME3D( VAR )
            END DO

            DO SPC = 1, N_A_AE_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_AE_SPC( SPC )
               IF ( VNAME3D( VAR )(1:3) .EQ. 'NUM' ) THEN
                  UNITS3D( VAR ) = 'm-3'
               ELSE IF ( VNAME3D( VAR )(1:3) .EQ. 'SRF' ) THEN
                  UNITS3D( VAR ) = 'm2 m-3'
               ELSE
                  UNITS3D( VAR ) = 'ug m-3'
               END IF
               VDESC3D( VAR ) = 'Average Concentrations of ' // VNAME3D( VAR )
            END DO

            DO SPC = 1, N_A_NR_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_NR_SPC( SPC )
               UNITS3D( VAR ) = 'ppmV'
               VDESC3D( VAR ) = 'Average Molar Mixing Ratio of ' // VNAME3D( VAR )
            END DO

            DO SPC = 1, N_A_TR_SPC
               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = A_TR_SPC( SPC )
               UNITS3D( VAR ) = 'ppmV'
               VDESC3D( VAR ) = 'Average Molar Mixing Ratio of ' // VNAME3D( VAR )
            END DO

            IF ( W_VEL ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'WVEL'
               UNITS3D( VAR ) = 'm s-1'
               VDESC3D( VAR ) = 'Vertical Wind Velocity'
            END IF
             
            IF ( L_ACONC_RH ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'RH'
               UNITS3D( VAR ) = '1'
               VDESC3D( VAR ) = 'Fractional Relative Humidity'
            END IF
             
            IF ( L_ACONC_TA ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'TA'
               UNITS3D( VAR ) = 'K'
               VDESC3D( VAR ) = 'Air Temperature'
            END IF
          
            IF ( L_ACONC_PRES ) THEN
               VAR = VAR + 1 
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'PRES'
               UNITS3D( VAR ) = 'Pa'
               VDESC3D( VAR ) = 'Air Pressure'
            END IF

            DO SPC = 1, VAR
               WRITE( LOGDEV,'( 7X, "=> VNAME3D(", I3, " ): ", A )' )
     &                SPC, VNAME3D( SPC )
            END DO

            IF ( .NOT. OPEN3( A_CONC_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not open '
     &              // TRIM( A_CONC_1 ) // ' file'
               CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

         END IF   ! MYPE = 0

      ELSE

! File exists. Make sure it matches requested output.

         IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
            XMSG = 'Could not get '
     &           // TRIM( CTM_CONC_1 )
     &           // ' file description'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         TSTEP_RF = TSTEP3D
         NTHIK_RF = NTHIK3D
         NCOLS_RF = NCOLS3D
         NROWS_RF = NROWS3D
         GDTYP_RF = GDTYP3D
         P_ALP_RF = P_ALP3D
         P_BET_RF = P_BET3D
         P_GAM_RF = P_GAM3D
         XCENT_RF = XCENT3D
         YCENT_RF = YCENT3D
         XORIG_RF = XORIG3D
         YORIG_RF = YORIG3D
         XCELL_RF = XCELL3D
         YCELL_RF = YCELL3D
         VGTYP_RF = VGTYP3D
         VGTOP_RF = VGTOP3D

         IF ( .NOT. DESC3( A_CONC_1 ) ) THEN
            XMSG = 'Could not get '
     &           // TRIM( A_CONC_1 )
     &           // ' file description'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( N_ACONC_VARS .NE. NVARS3D ) THEN
            WRITE( XMSG, '( A, 2I6 )' )
     &      'Number of variables don''t match file: ', N_ACONC_VARS, NVARS3D
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

         DO SPC = 1, N_ASPCS
            DO VAR = 1, NVARS3D
               IF ( ACONC_FILE_SPCS( SPC ) .EQ. VNAME3D( VAR ) ) GO TO 101
            END DO
            XMSG = 'Could not find ' // ACONC_FILE_SPCS( SPC )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
101         CONTINUE
         END DO

         IF ( A_NLYS .NE. NLAYS3D ) THEN
            WRITE( XMSG, '( A, 2I6 )' )
     &      'Number of layers don''t match file: ', A_NLYS, NLAYS3D
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

! Check other header data with CONC file as reference

         IF ( TSTEP_RF .NE. TSTEP3D .OR.
     &        NTHIK_RF .NE. NTHIK3D .OR.
     &        NCOLS_RF .NE. NCOLS3D .OR.
     &        NROWS_RF .NE. NROWS3D .OR.
     &        GDTYP_RF .NE. GDTYP3D ) THEN
              XMSG = 'Header inconsistent on existing A_CONC_1'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &        P_BET_RF .NE. P_BET3D .OR.
     &        P_GAM_RF .NE. P_GAM3D ) THEN
              XMSG = 'Header inconsistent on existing A_CONC_1'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( XCENT_RF .NE. XCENT3D .OR.
     &        YCENT_RF .NE. YCENT3D ) THEN
              XMSG = 'Header inconsistent on existing A_CONC_1'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( XORIG_RF .NE. XORIG3D .OR.
     &        YORIG_RF .NE. YORIG3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( XCELL_RF .NE. XCELL3D .OR.
     &        YCELL_RF .NE. YCELL3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( VGTYP_RF .NE. VGTYP3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF
         IF ( VGTOP_RF .NE. VGTOP3D ) THEN
            XMSG = 'Header inconsistent on existing A_CONC_1'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

      END IF   ! .NOT. OPEN A_CONC_1

      END SUBROUTINE OPACONC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE GETCYCLE

C-----------------------------------------------------------------------
C Function: To process the DEFINE CYCLE option 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: GETCHR
C                                   GETWORD
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
 
      USE UTILIO_DEFN
      USE PA_VARS
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables: None

C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Get assigned name and check for = sign delimiter
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      NCYCLES = NCYCLES + 1
      IF( NCYCLES .GT. MAXCYCLES ) THEN
         WRITE( MSG, 94000 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94020 ) MAXCYCLES
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETCYCLE', IZERO, IZERO, ' ', XSTAT2 )
      ENDIF

      CALL GETWORD
      CYCLNAME( NCYCLES ) = WORD

      IF( CHR .NE. '=' ) THEN
         WRITE( MSG, 94040 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETCYCLE', IZERO, IZERO, ' ', XSTAT2 )
      ELSE
         CALL GETCHR
      ENDIF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c Get the name of the CYCLE species and return
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      CALL GETWORD
      CYCLSPEC( NCYCLES ) = WORD

      IF( CHR .EQ .';' ) THEN
         CALL GETCHR
         RETURN
      ELSE
         WRITE( MSG, 94060 ) 
         CALL M3MESG( MSG )
         WRITE( MSG, 94500 ) LINNUM, INBUF
         CALL M3MESG( MSG )
         WRITE( MSG, 94520 ) CHR
         CALL M3MESG( MSG )
         CALL M3EXIT( 'GETCYCLE', IZERO, IZERO, ' ', XSTAT2 ) 
      END IF

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of CYCLEs exceeded' )
94020 FORMAT( '       Modify PARAMETER ( MAXCYCLES =', I3,' ) or',
     &              '  decrease the number of CYCLEs' )
94040 FORMAT( 'ERROR: An equal sign expected after CYCLE name' )
94060 FORMAT( 'ERROR: A ; must end a CYCLE definition' )

94500 FORMAT( '       Line No. ', I4, ': ', A )
94520 FORMAT( '       Character found: ', A )

      END SUBROUTINE GETCYCLE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!



!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE CSQY_DATA

      USE RUNTIME_VARS

      IMPLICIT NONE

      CHARACTER( 32 ), PUBLIC :: JTABLE_REF

      INTEGER, PUBLIC :: NPHOT_REF  ! # ref phot reactions
      INTEGER, PUBLIC :: NTEMP_REF  ! # ref temperatures
      INTEGER, PUBLIC :: NWL_REF    ! # ref wavelengths

!...Names of the mapped photolysis reactions (available to chemical)
!... mechanisms) and their pointers to the reference photolysis rxn

      CHARACTER( 16 ), ALLOCATABLE, PUBLIC :: PNAME_REF( : )

!...Setup the Mapping from CMAQ chemical reactions to the reference data

      INTEGER, PUBLIC :: NPHOT_MAP  ! #  phot mapped reactions

      CHARACTER( 16 ), ALLOCATABLE, PUBLIC :: PNAME_MAP( : )
      INTEGER, ALLOCATABLE,         PUBLIC :: PHOT_MAP ( : )

      REAL, PUBLIC, ALLOCATABLE :: STWL_REF ( : )
      REAL, PUBLIC, ALLOCATABLE :: EFFWL_REF( : )
      REAL, PUBLIC, ALLOCATABLE :: ENDWL_REF( : )

      REAL, ALLOCATABLE, PUBLIC :: CLD_BETA_REF    ( : )  ! cloud extinction coef divided by LWC
      REAL, ALLOCATABLE, PUBLIC :: CLD_COALBEDO_REF( : )  ! cloud coalbedo
      REAL, ALLOCATABLE, PUBLIC :: CLD_G_REF       ( : )  ! cloud asymmetry factor

      REAL, ALLOCATABLE, PUBLIC :: FSOLAR_REF( : )        ! initial solar flux [photons*cm-2*s-1]

      REAL, ALLOCATABLE, PUBLIC :: TEMP_BASE ( : )        ! reference temperatures
      REAL, ALLOCATABLE, PUBLIC :: TEMP_REF( :,: )        ! reference temperatures

      REAL, ALLOCATABLE, PUBLIC :: CS_REF ( :,:,: )       ! effective cross sections
      REAL, ALLOCATABLE, PUBLIC :: QY_REF ( :,:,: )       ! effective quantum yields
      REAL, ALLOCATABLE, PUBLIC :: ECS_REF( :,:,: )       ! CS*QY averaged UCI Solar Flux

      INTEGER,           PUBLIC :: NTEMP_STRAT_REF        ! number of stratos temperatures
      REAL, ALLOCATABLE, PUBLIC :: TEMP_STRAT_REF( : )    ! temperature for stratos O3 xcross, K
      REAL, ALLOCATABLE, PUBLIC :: O3_CS_STRAT_REF( :,: ) ! ozone xcross at stratos temperatures, cm2

!...    effective quantum yields were computed by performing separate
!...    interval integrations for the cross sections and for the
!...    effective cross sections (cs*qy) (calculated on the finer
!...    wavelength grid.  The effective quantum yield values
!...    were then calculated for the 7 wavelength intervals by
!...    dividing the effective cross sections by the interval average
!...    cross sections (eQY=eCS/CS).

      REAL, ALLOCATABLE, PUBLIC :: EQY_REF( :,:,: ) ! eCS/CS averaged 77 bins in UCI Model

      INTEGER, PUBLIC :: NUM_REFRACTIVE

      TYPE MODAL_COMPLEX
         CHARACTER( 16 ) :: NAME                           ! name of complex property
         REAL, ALLOCATABLE, DIMENSION( :, : ) :: REAL_PART ! real part
         REAL, ALLOCATABLE, DIMENSION( :, : ) :: IMAG_PART ! imaginary part
      END TYPE MODAL_COMPLEX

      TYPE( MODAL_COMPLEX ), ALLOCATABLE, PUBLIC :: REFRACTIVE_INDEX( : )

      INTEGER, PUBLIC :: IWLR  ! wavelength loop variable
      INTEGER, PUBLIC :: ITTR  ! temperature loop variable

! arrays for the size and optical properties of liquid droplets. The latter
! is a function of radius and wavelength
      INTEGER, PUBLIC  :: NRADIUS_LIQUID

      REAL, ALLOCATABLE, PUBLIC  ::  RADIUS_LIQUID( : )       ! droplet radius, um
      REAL, PUBLIC               ::  INIT_RADIUS_LIQUID
      REAL, PUBLIC               ::  MAXI_RADIUS_LIQUID
      REAL, PUBLIC               ::  MINI_RADIUS_LIQUID
      REAL, PUBLIC               ::  FREQ_RADIUS_LIQUID

      REAL, ALLOCATABLE, PUBLIC ::  LIQUID_EXTINCT( :, : )   ! extinction coefficient, m**3/g
      REAL, ALLOCATABLE, PUBLIC :: LIQUID_ASYMFACT( :, : )   ! asymmetery factor, dimensionaless
      REAL, ALLOCATABLE, PUBLIC :: LIQUID_COALBEDO( :, : )   ! One minus single scattering albebo, dimensionaless

! arrays for the size and optical properties of ice particles. The latter
! is a function of effective diameter and wavelength

      INTEGER, PUBLIC  :: NDIAMETER_ICE

      REAL, ALLOCATABLE, PUBLIC ::  DIAMETER_ICE( : )     ! particle effective diameter, um
      REAL, PUBLIC              ::  INIT_DIAMETER_ICE
      REAL, PUBLIC              ::  MAXI_DIAMETER_ICE
      REAL, PUBLIC              ::  MINI_DIAMETER_ICE
      REAL, PUBLIC              ::  FREQ_DIAMETER_ICE

      REAL, ALLOCATABLE, PUBLIC ::  ICE_EXTINCT( :, : )   ! extinction coefficient, m**3/g
      REAL, ALLOCATABLE, PUBLIC :: ICE_ASYMFACT( :, : )   ! asymmetery factor, dimensionaless
      REAL, ALLOCATABLE, PUBLIC :: ICE_COALBEDO( :, : )   ! One minus single scattering albebo, dimensionaless
      REAL, ALLOCATABLE, PUBLIC :: ICE_DELTRANS( :, : )   ! Delta Transmission Function at zero scattering angle, dimensionaless

      PUBLIC            :: LOAD_CSQY_DATA, LOAD_OPTICS_DATA, GET_CSQY


!***Information for photolysis

      INTEGER, SAVE       :: NWL     ! number of wavelengths
!     INTEGER, PARAMETER  :: NWL_INLINE_METHOD = 7

      INTEGER JWAVE             ! index use for wavelength
      INTEGER ITEMP             ! index for temperature
      INTEGER IRRXN

      REAL, ALLOCATABLE :: WAVELENGTH( : )  ! effective wavelengths [nm ]
      REAL, ALLOCATABLE :: WAVENUMBER( : )  ! effective wavenumbers [cm-1]

      REAL, ALLOCATABLE :: FEXT( : )   ! downward solar direct flux at the top of
                                             ! of the Atmosphere.  [ photons / ( cm **2 s) ]

!***surface albedo

      REAL, ALLOCATABLE :: ALB( : )  ! set in subroutine PHOT

!**Cloud albedo values from JPROC

      REAL, ALLOCATABLE :: CLOUD_BETA_LWC( : ) ! cloud extinction coef divided by LWC
      REAL, ALLOCATABLE :: CLOUD_COALBEDO( : ) ! cloud coalbedo
      REAL, ALLOCATABLE :: CLOUD_G( : )        ! cloud asymmetry factor

      INTEGER            :: NTEMP_STRAT
      REAL, ALLOCATABLE  :: XO3CS( :,: )       !
      REAL, ALLOCATABLE  :: TEMP_O3_STRAT( : ) ! temperature for XO3CS, K

!***arrays for reference data for needed photolysis rates

      REAL, ALLOCATABLE :: XXCS( :,:,: )  ! absorption cross sections
      REAL, ALLOCATABLE :: XXQY( :,:,: )  ! quantum yield
      REAL, ALLOCATABLE :: RTEMP_S( :,: )

      INTEGER                     :: MECHANISM_RATES
      CHARACTER(16), ALLOCATABLE  :: PHOTOLYSIS_RATE( : ) ! subset of photolysis rates from CSQY DATA

!***Indices for special case photolysis cross sections

      INTEGER :: LNO2
      INTEGER :: LO3O1D
      INTEGER :: LO3O3P
      INTEGER :: LACETONE
      INTEGER :: LKETONE
      INTEGER :: LMGLY_ADJ
      INTEGER :: LMGLY_ABS
      INTEGER :: LHCHOR_06
      INTEGER :: LH2O2
      INTEGER :: LHNO3
      INTEGER :: LACETONE_CO
      INTEGER :: LACETONE_CH3CO

      LOGICAL :: ACETONE_CHANNELS

! integer pointer for specific density correction to cross-section
! and/or quantum yield values
            INTEGER, PARAMETER :: ACETALDEHYDE           =  1
            INTEGER, PARAMETER :: HIGHER_ALDEHYDES       =  2
            INTEGER, PARAMETER :: METHYL_VINYL_KETONE    =  3
            INTEGER, PARAMETER :: METHYL_ACROLEIN        =  4
            INTEGER, PARAMETER :: METHYL_ETHYL_KETONE    =  5
            INTEGER, PARAMETER :: METHYL_GLYOXAL_IUPAC04 =  6
            INTEGER, PARAMETER :: ACROLEIN               =  7
            INTEGER, PARAMETER :: FORMALDEHYDE_MOLECULAR =  8
            INTEGER, PARAMETER :: ACETONE                =  9
            INTEGER, PARAMETER :: KETONE_LEGACY          = 10
            INTEGER, PARAMETER :: KETONE_RACM2           = 11
            INTEGER, PARAMETER :: GLYOXAL_RACM2          = 12
            INTEGER, PARAMETER :: METHYL_GLYOXAL_LEGACY  = 13
            INTEGER, PARAMETER :: NBUTYRALDEHYDE         = 14
            INTEGER, PARAMETER :: BIACETYL               = 15
            INTEGER, PARAMETER :: ACETONE_CH3CO          = 16
            INTEGER, PARAMETER :: GLYOXAL_IUPAC_2013     = 17
            INTEGER, PARAMETER :: CH3CHO_IUPAC2013       = 18

            CHARACTER( 32 ) :: CSQY_ADJUSTMENTS( 0:18 )
            DATA CSQY_ADJUSTMENTS /
     &                             'NO_ADJUSTMENT',
     &                             'ACETALDEHYDE',
     &                             'HIGHER_ALDEHYDES',
     &                             'METHYL_VINYL_KETONE',
     &                             'METHYL_ACROLEIN',
     &                             'METHYL_ETHYL_KETONE',
     &                             'METHYL_GLYOXAL_IUPAC04',
     &                             'ACROLEIN',
     &                             'FORMALDEHYDE_MOLECULAR',
     &                             'ACETONE',
     &                             'KETONE_LEGACY',
     &                             'KETONE_RACM2',
     &                             'GLYOXAL_RACM2',
     &                             'METHYL_GLYOXAL_LEGACY',
     &                             'NBUTYRALDEHYDE',
     &                             'BIACETYL',
     &                             'ACETONE_CH3CO',
     &                             'GLYOXAL_IUPAC_2013',
     &                             'CH3CHO_IUPAC2013'      /

! integer pointer for density correction to a photolysis rates' cross-section
! and/or quantum yield values
            INTEGER, ALLOCATABLE :: CSQY_ADJUST( : )

            REAL,    ALLOCATABLE :: IPHI0_MGLY( : ) ! Reciprocal Methyl Glyoxal Quantum Yields at zero pressure
            REAL,    ALLOCATABLE :: KMGLY    ( : )  ! Quenching Coefficient for Methyl Glyoxal Quantum Yields

! coefficients used correct acetaldehyde Quantum Yields based on IUPAC 2013 recommendations
            REAL,    ALLOCATABLE :: IPHIS_CH3CHO( : ) ! Reciprocal acetaldehyde Quantum Yields at surface pressure
            REAL,    ALLOCATABLE :: IPHI0_CH3CHO( : ) ! Reciprocal acetaldehyde Quantum Yields at zero pressure
            REAL,    ALLOCATABLE :: KCH3CHO     ( : ) ! Quenching Coefficient for acetaldehyde Quantum Yields



      INTEGER :: IREFTEMPS  ! number of ref. temperatures

      INTEGER :: NUMB_LANDUSE_REF
      INTEGER :: INDEX_GRASSLAND_REF
      INTEGER :: INDEX_OCEAN_REF
      INTEGER :: INDEX_SEA_ICE

      CHARACTER(30), ALLOCATABLE :: LANDUSE_REF( : )
      REAL,          ALLOCATABLE :: ZENITH_COEFF_REF( : )
      REAL,          ALLOCATABLE :: SEASON_COEFF_REF( : )
      REAL,          ALLOCATABLE :: SNOW_COEFF_REF( : )
      REAL,          ALLOCATABLE :: SPECTRAL_ALBEDO_REF( :,: )

      INTEGER, PARAMETER         :: NUMB_EXPECT_NLCD50  = 50
      INTEGER                    :: NUMB_LANDUSE_NLCD50
      CHARACTER(60), ALLOCATABLE :: LANDUSE_NLCD50( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2NLCD50( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2NLCD50( : )

      INTEGER, PARAMETER         :: NUMB_EXPECT_NLCD40  = 40
      INTEGER, SAVE              :: NUMB_LANDUSE_NLCD40
      CHARACTER(60), ALLOCATABLE :: LANDUSE_NLCD40( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2NLCD40( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2NLCD40( : )

      INTEGER, PARAMETER         :: NUMB_EXPECT_USGS  = 24
      INTEGER                    :: NUMB_LANDUSE_USGS
      CHARACTER(60), ALLOCATABLE :: LANDUSE_USGS( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2USGS( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2USGS( : )

      INTEGER, PARAMETER         :: NUMB_EXPECT_MODIS = 33
      INTEGER                    :: NUMB_LANDUSE_MODIS
      CHARACTER(60), ALLOCATABLE :: LANDUSE_MODIS( : )
      INTEGER,       ALLOCATABLE :: ALBMAP_REF2MODIS( : )
      REAL,          ALLOCATABLE :: ALBFAC_REF2MODIS( : )

      LOGICAL      :: NO_NLCD40
      LOGICAL      :: WRITE_CELL

!***special information for acetone
!***  Reference:
!***     Cameron-Smith, P., Incorporation of non-linear
!***     effective cross section parameterization into a
!***     fast photolysis computation  code (Fast-J)
!***     Journal of Atmospheric Chemistry, Vol. 37,
!***     pp 283-297, 2000.

      INTEGER, PARAMETER :: NWL_ACETONE_FJX = 7

      REAL :: OP0( 2, NWL_ACETONE_FJX ) ! variable needed for acetone

      DATA ( OP0( 1, JWAVE ), JWAVE = 1, NWL_ACETONE_FJX ) /
     &     2.982E-20, 1.301E-20, 4.321E-21, 1.038E-21,
     &     5.878E-23, 1.529E-25, 0.0/

      DATA ( OP0( 2, JWAVE ), JWAVE = 1, NWL_ACETONE_FJX ) /
     &     3.255E-20, 1.476E-20, 5.179E-21, 1.304E-21,
     &     9.619E-23, 2.671E-25, 0.0 /

      REAL :: YY30( NWL_ACETONE_FJX )   ! variable needed for acetone

      DATA YY30 / 5.651E-20, 1.595E-19, 2.134E-19,
     &     1.262E-19, 1.306E-19, 1.548E-19, 0.0 /

      REAL :: OPTT                ! variable needed for acetone

      CONTAINS

      SUBROUTINE LOAD_CSQY_DATA ( )
!-----------------------------------------------------------------------
!  Purpose: read input file for
!           -wavelength bin and temperature structure.
!           -photolysis cross-sections and quantum
!
!  Revision History:
!   31 Jan 2014 B.Hutzell: Initial Version based on LOAD_REF_DATA in
!   CMAQ version 5.0
!   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RXNS_DATA           ! chemical mechanism data

      IMPLICIT NONE

!***arguments

C     NONE

!***local

      LOGICAL :: WRITE_LOG = .TRUE.

      CHARACTER(  32 ) :: PNAME = 'LOAD_CSQY_DATA'
      CHARACTER(  16 ) :: CSQY_FILE = 'CSQY_DATA' ! CSQY_DATA i/o logical name
      CHARACTER(  16 ) :: PHOT_EXPECT
      CHARACTER(  30 ) :: LAND_EXPECT
      CHARACTER( 120 ) :: MSG                     ! buffer for messages to output
      CHARACTER( 240 ) :: FILE_LINE

      CHARACTER(  16 ),  ALLOCATABLE :: AE_RERACT_REF( : )

!     INTEGER, INTENT(OUT) :: NWL_PHOT    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: NWL_PHOT    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: IOST        ! IOST returned from OPEN function
      INTEGER :: JDATE = 0
      INTEGER :: PHOTAB_UNIT
      INTEGER :: IPHOT, IPHOT_LOAD ! loop indices
      INTEGER :: ITT, ITT_LOAD     ! loop indices
      INTEGER :: IP_MAP, IP_REF    ! photolysis reaction indicies
      INTEGER :: IWL, IWL_LOAD
      INTEGER :: STRT, FINI


      INTEGER :: NAE_REFRACT_REF

      REAL,       ALLOCATABLE :: AE_IMAG_REFRACT( :, : )
      REAL,       ALLOCATABLE :: AE_REAL_REFRACT( :, : )

      LOGICAL                  :: ERROR_FLAG = .FALSE.

!***external functions: none

      PHOTAB_UNIT = GETEFILE( CSQY_FILE, .TRUE., .TRUE., PNAME )

      IF ( PHOTAB_UNIT .LT. 0 ) THEN
         MSG = 'Error opening the CSQY data file: ' // TRIM( CSQY_FILE )
         CALL M3WARN ( PNAME, 0, 0, MSG )
         ERROR_FLAG = .TRUE.
      END IF

C...begin read

      READ( PHOTAB_UNIT,'(22X,A32)' ) JTABLE_REF

      IF ( JTABLE_REF .NE. MECHNAME ) THEN
         MSG =  'WARNING: JTABLE mechanism is for ' // JTABLE_REF
     &       // ' but gas chemistry name is '       // MECHNAME
         CALL M3WARN( PNAME, 0, 0, MSG )
      END IF

      READ( PHOTAB_UNIT,'(10X,I4)' ) NPHOT_MAP

      IF ( NPHOT_MAP .LT. NPHOTAB ) THEN
         WRITE( MSG,'( A,1X,I4,1X,A,1X,I4)')
     &   'Error: CSQY data file has',NPHOT_MAP,
     &   'rates but the need number is',NPHOTAB
          CALL M3WARN( PNAME, 0, 0, MSG )
         ERROR_FLAG = .TRUE.
      END IF


#ifdef verbose_phot
      write( LOGDEV,'(A,a32)' )'JTABLE_REF = ',trim(jtable_ref)
      write( LOGDEV,'(A,10x,i4)' )'NPHOT_MAP = ', nphot_map
#endif

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

      ALLOCATE( PNAME_MAP( NPHOT_MAP ) )
      ALLOCATE( PNAME_REF( NPHOT_MAP ) )
      ALLOCATE( PHOT_MAP ( NPHOT_MAP ) )

      DO IPHOT_LOAD = 1, NPHOT_MAP
         READ( PHOTAB_UNIT,'(A16)' ) PNAME_REF( IPHOT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,'(i3,1x,a16)' ) iphot_load, pname_ref( iphot_load )
#endif

         PNAME_MAP( IPHOT_LOAD ) = PNAME_REF( IPHOT_LOAD )
         PHOT_MAP ( IPHOT_LOAD ) = IPHOT_LOAD
      END DO

      READ( PHOTAB_UNIT,'(10X,I3)' ) NTEMP_REF

#ifdef verbose_phot
      write( LOGDEV,'(10x,i3)' ) ntemp_ref
#endif

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV,* ) trim( file_line )
#endif

      IREFTEMPS = NTEMP_REF

      ALLOCATE( TEMP_BASE( NTEMP_REF ) )

      DO ITT_LOAD = 1, NTEMP_REF
         READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
         write( LOGDEV,* ) trim( file_line )
#endif

         READ( FILE_LINE,* ) IPHOT_LOAD, TEMP_BASE( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,'(4x,f6.2)' ) temp_base( itt_load )
#endif

      END DO

      ALLOCATE( TEMP_REF( NTEMP_REF, NPHOT_MAP) )

      DO ITT_LOAD = 1, 15 ! skip next 15 lines
         READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(I2,1X,A)' )ITT_LOAD,TRIM(FILE_LINE)
#endif
      END DO

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif
      READ( FILE_LINE, 4999) NWL_REF

#ifdef verbose_phot
      write( LOGDEV,'(17x,i3)' ) nwl_ref
#endif


4999  FORMAT(17X,I3,2X,17X,I3)


      NWL       = NWL_REF
      NWL_PHOT  = NWL


      IF ( NWL_REF .LT. 1 ) THEN
         WRITE( LOGDEV,* ) 'NWL_REF  = ', NWL_REF
         MSG = 'NWL_REF in ' // CSQY_FILE
     &       // ' has the bad value, written above. '
         CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
      END IF

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, * )FILE_LINE
#endif

      IF( .NOT. ALLOCATED( STWL_REF   ) ) ALLOCATE( STWL_REF  ( NWL_REF ) )
      IF( .NOT. ALLOCATED( ENDWL_REF  ) ) ALLOCATE( ENDWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FSOLAR_REF ) ) ALLOCATE( FSOLAR_REF( NWL_REF ) )
      IF( .NOT. ALLOCATED( EFFWL_REF  ) ) ALLOCATE( EFFWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FEXT       ) ) ALLOCATE( FEXT      ( NWL_REF ) )
      IF( .NOT. ALLOCATED( WAVELENGTH ) ) ALLOCATE( WAVELENGTH( NWL_REF ) )
      IF( .NOT. ALLOCATED( WAVENUMBER ) ) ALLOCATE( WAVENUMBER( NWL_REF ) )

      DO IWL_LOAD = 1, NWL_REF
!         READ( PHOTAB_UNIT,'(4X,3(F8.3,2X),2X,ES12.4,2X,2(F8.3,2X),ES12.4,2X)' )
         READ( PHOTAB_UNIT, * )iphot_load,
     &         STWL_REF( IWL_LOAD ), EFFWL_REF( IWL_LOAD ),
     &         ENDWL_REF( IWL_LOAD ), FSOLAR_REF( IWL_LOAD )

#ifdef verbose_phot
         write( LOGDEV,'(4x,3(f8.3,2x),2x,2(es12.4,2x),f8.3,2x,12(es12.4,2x))' )
     &          stwl_ref( iwl_load ), effwl_ref( iwl_load ),
     &          endwl_ref( iwl_load ),fsolar_ref( iwl_load )
#endif
         WAVELENGTH( IWL_LOAD ) = EFFWL_REF ( IWL_LOAD )
         WAVENUMBER( IWL_LOAD ) = 1.0E7 / EFFWL_REF ( IWL_LOAD )
         FEXT      ( IWL_LOAD ) = FSOLAR_REF( IWL_LOAD )
      END DO


      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

      ALLOCATE( CS_REF (  NWL_REF, NTEMP_REF, NPHOT_MAP ) )
      ALLOCATE( QY_REF (  NWL_REF, NTEMP_REF, NPHOT_MAP ) )
      ALLOCATE( EQY_REF(  NWL_REF, NTEMP_REF, NPHOT_MAP ) )
      ALLOCATE( ECS_REF(  NWL_REF, NTEMP_REF, NPHOT_MAP ) )

      CS_REF = 0.0
      QY_REF  = 0.0
      EQY_REF = 0.0
      ECS_REF = 0.0

      DO IPHOT_LOAD = 1, NPHOT_MAP
         DO ITT_LOAD = 1, NTEMP_REF
            READ( PHOTAB_UNIT,'(A16,7X,F8.3,1X,40(1PE12.6,2X))' )
     &            PHOT_EXPECT, TEMP_REF( ITT_LOAD, IPHOT_LOAD),
     &            ( CS_REF( IWL_LOAD, ITT_LOAD, IPHOT_LOAD ), IWL_LOAD = 1, NWL_REF )

#ifdef verbose_phot
            write( LOGDEV,'(a16,7x,f8.3,1x,40(1pe13.6,2x))' )
     &             phot_expect, temp_ref( itt_load, iphot_load),
     &             ( cs_ref( iwl_load, itt_load, iphot_load ), iwl_load = 1, nwl_ref )
#endif

            IF ( PHOT_EXPECT .NE. PNAME_REF( IPHOT_LOAD ) ) THEN
                MSG =  'CS for ' // TRIM( PHOT_EXPECT )
     &              // ' does match the order the PHOT_MAP array.'
                CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
            END IF

            READ( PHOTAB_UNIT,'(A16,7X,F8.3,1X,40(1PE12.6,2X))' )
     &            PHOT_EXPECT, TEMP_REF( ITT_LOAD, IPHOT_LOAD),
     &            ( EQY_REF( IWL_LOAD, ITT_LOAD, IPHOT_LOAD ), IWL_LOAD = 1, NWL_REF )

            QY_REF( 1:NWL_REF, ITT_LOAD, IPHOT_LOAD ) = EQY_REF( 1:NWL_REF, ITT_LOAD, IPHOT_LOAD )

#ifdef verbose_phot
            write( LOGDEV,'(a16,7x,f8.3,1x,40(1pe13.6,2x))' )
     &             phot_expect, temp_ref( itt_load, iphot_load),
     &             ( qy_ref( iwl_load, itt_load, iphot_load ), iwl_load = 1, nwl_ref )
#endif

            IF ( PHOT_EXPECT .NE. PNAME_REF(IPHOT_LOAD) ) THEN
               MSG =  'EQY for ' // TRIM( PHOT_EXPECT )
     &             // ' does match the order the PHOT_MAP array.'
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
         END DO
      END DO

      DO ITT_LOAD = 1, 3 ! skip next 3 lines
         READ( PHOTAB_UNIT,'(A)' ) FILE_LINE
      END DO

      READ( PHOTAB_UNIT,'(15X,I3)' ) NTEMP_STRAT_REF

#ifdef verbose_phot
      write( LOGDEV,'(16x,i3)' ) ntemp_strat_ref
#endif

      ALLOCATE( TEMP_STRAT_REF ( NTEMP_STRAT_REF ) )
      ALLOCATE( O3_CS_STRAT_REF( NWL_REF, NTEMP_STRAT_REF ) )

      READ( PHOTAB_UNIT,'(A)' ) FILE_LINE

      DO ITT_LOAD = 1, NTEMP_STRAT_REF
         READ( PHOTAB_UNIT,'(A16,7X,F8.3,1X,40(1PE12.6,2X))' )
     &         PHOT_EXPECT, TEMP_STRAT_REF( ITT_LOAD ),
     &         ( O3_CS_STRAT_REF( IWL_LOAD, ITT_LOAD ), IWL_LOAD = 1, NWL_REF )

#ifdef verbose_phot
         write( LOGDEV,'(a16,7x,f8.3,1x,40(1pe13.6,2x))' )
     &          phot_expect, temp_strat_ref( itt_load ),
     &          ( o3_cs_strat_ref( iwl_load, itt_load ), iwl_load = 1, nwl_ref )
#endif

         IF ( PHOT_EXPECT .NE. 'O3_STRAT' ) THEN
            MSG = 'O3_STRAT not found at expected location in CSQY_FILE. ' //
     &            TRIM( PHOT_EXPECT ) // ' found.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            ERROR_FLAG = .TRUE.
         END IF
      END DO


      NTEMP_STRAT = NTEMP_STRAT_REF
      ALLOCATE( TEMP_O3_STRAT( NTEMP_STRAT_REF ) )
      ALLOCATE( XO3CS        ( NTEMP_STRAT_REF, NWL_PHOT ) )

      DO ITT_LOAD = 1, NTEMP_STRAT_REF
         TEMP_O3_STRAT( ITT_LOAD ) = TEMP_STRAT_REF( ITT_LOAD )
         DO IWL_LOAD = 1, NWL_PHOT
            XO3CS( ITT_LOAD, IWL_LOAD ) = O3_CS_STRAT_REF( IWL_LOAD, ITT_LOAD )
         END DO
      END DO

!***initialize pointers for mandatory photolysis rates

      LNO2      = 0
      LO3O1D    = 0
      LO3O3P    = 0
      LACETONE  = 0
      LKETONE   = 0
      LMGLY_ADJ = 0
      LMGLY_ABS = 0
      LHCHOR_06 = 0
      LH2O2     = 0
      LHNO3     = 0

! initialized pointers and flag if specific acetone channel are used
      LACETONE_CO    = 0
      LACETONE_CH3CO = 0
      ACETONE_CHANNELS = .FALSE.

!***get needed photolysis data for the model chemistry from the
!***CSQY_DATA

       ALLOCATE( PHOTOLYSIS_RATE ( NPHOTAB ) )
       ALLOCATE( XXCS( IREFTEMPS, NWL, NPHOTAB ) )
       ALLOCATE( XXQY( IREFTEMPS, NWL, NPHOTAB ) )
       ALLOCATE( RTEMP_S( IREFTEMPS, NPHOTAB ) )

       MECHANISM_RATES = NPHOTAB


       DO IPHOT = 1, NPHOTAB
          IP_MAP = INDEXR( PHOTAB( IPHOT ), NPHOT_MAP, PNAME_MAP )
          IF ( IP_MAP .LE. 0 ) THEN
             MSG = 'FATAL ERROR: photolysis reaction ' // TRIM( PHOTAB( IPHOT ) )
     &          // ' not found in ' //
     &             'the reference data! '
             ERROR_FLAG = .TRUE.
             CALL M3WARN ( PNAME, 0, 0, MSG )
             CYCLE
          END IF
          IP_REF = PHOT_MAP( IP_MAP )
          PHOTOLYSIS_RATE( IPHOT ) = PNAME_MAP( IP_MAP )

!***check to see if this photolysis reaction is a special case that
!***  is referenced in other sections of the code.  if so, then set
!***  the appropriate pointers for later processing

           SELECT CASE ( PHOTOLYSIS_RATE( IPHOT ) )
              CASE( 'O3O3P', 'O3O3P_SAPRC99', 'O3O3P_06', 'O3_O3P_IUPAC04', 'O3O3P_NASA06', 'O3_O3P_IUPAC10' )
                    LO3O3P = IPHOT
              CASE( 'NO2', 'NO2_SAPRC99', 'NO2_06', 'NO2_RACM2', 'NO2_IUPAC10' )
                    LNO2 = IPHOT
              CASE( 'O3O1D',  'O3O1D_SAPRC99' , 'O3O1D_06', 'O3_O1D_IUPAC04', 'O3O1D_NASA06', 'O3_O1D_IUPAC10' )
                    LO3O1D = IPHOT
              CASE( 'KETONE', 'KET_RACM2' )
                    LKETONE   = IPHOT
              CASE( 'MGLY_ADJ' )
                    LMGLY_ADJ = IPHOT
              CASE(  'MGLY_ABS' )
                    LMGLY_ABS = IPHOT
              CASE( 'ACETONE', 'CH3COCH3_RACM2', 'ACET_IUPAC10' )
                    IF( NWL .EQ. NWL_ACETONE_FJX ) LACETONE  = IPHOT
              CASE( 'HCHOR_06', 'HCHO_R_SAPRC99', 'HCHO_RAD_RACM2', 'FORM_R_IUPAC10', 'HCHO_R_MCMv32' )
                    LHCHOR_06 = IPHOT
              CASE( 'ACET_CH3CO_CRI' )
                    LACETONE_CH3CO   = IPHOT
                    ACETONE_CHANNELS = .TRUE.
              CASE( 'H2O2', 'H2O2_SAPRC99', 'H2O2_RACM2', 'H2O2_IUPAC10' )
                   LH2O2 = IPHOT
              CASE( 'HNO3', 'HNO3_IUPAC04', 'HNO3_IUPAC10', 'HNO3_RACM2' )
                   LHNO3 = IPHOT
           END SELECT



!***load the local cross section & quantum yield data from the reference
!***  dataset for this photolysis reaction

            DO ITT = 1, IREFTEMPS
               RTEMP_S( ITT, IPHOT ) = TEMP_REF( ITT, IP_REF )
               DO IWL = 1, NWL
                  XXCS( ITT, IWL, IPHOT ) = CS_REF( IWL, ITT, IP_REF )
                  XXQY( ITT, IWL, IPHOT ) = QY_REF( IWL, ITT, IP_REF )
               END DO   ! iwl
            END DO   ! itt

       END DO   ! iphot

       IF ( LNO2   .EQ. 0 ) THEN
          MSG = 'NO2 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF
       IF ( LO3O1D .EQ. 0 ) THEN
          MSG = 'O3(1D) production not found in the CSQY data! '
          CALL M3WARN ( 'NEW_OPTICS', 0, 0, MSG )
       END IF
       IF ( LO3O3P .EQ. 0 ) THEN
          MSG = 'O3 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF
       IF ( LH2O2 .EQ. 0 ) THEN
          MSG = 'H2O2 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF
       IF ( LHNO3 .EQ. 0 ) THEN
          MSG = 'HNO3 cross-section not found in the CSQY data! '
          ERROR_FLAG = .TRUE.
          CALL M3WARN ( PNAME, 0, 0, MSG )
       END IF

       IF( ERROR_FLAG )THEN
         MSG = 'The above fatal error(s) found in CSQY data! '
         CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
       END IF

      CLOSE(PHOTAB_UNIT)

5012  FORMAT( 4X,A30,1X,3(F8.3,2X) )
5013  FORMAT( 22X,I3 )
5016  FORMAT( 4X,A60,1X,I3,2X,3(F8.3,2X) )

#ifdef verbose_phot
6009  format( a3,', ',8(a,', ') )
6013  format( a22,1x,i3 )
6016  format( i3,1x,a60,1x,i3,2x,3(f8.3,2x) )
#endif

      RETURN
      END SUBROUTINE LOAD_CSQY_DATA



      SUBROUTINE LOAD_OPTICS_DATA()
!-----------------------------------------------------------------------
!  Purpose: read input file for
!           -wavelength bin for cross check against
!           -size dependent optical data for liquid droplets and ice
!            ice particles
!           -landuse type data for surface alebdo
!
!  Revision History:
!   31 Jan 2014 B.Hutzell: Initial Version based on LOAD_REF_DATA in
!   CMAQ version 5.0
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE AERO_DATA,   ONLY: N_MODE

      IMPLICIT NONE

!***arguments

      REAL, PARAMETER  :: EPSILON = 1.0E-6     ! small number

!***local

      LOGICAL :: WRITE_LOG = .TRUE.

      CHARACTER(  32 ) :: PNAME         = 'LOAD_OPTICS_DATA'
      CHARACTER(  16 ) :: OPTICS_FILE   = 'OPTICS_DATA'      ! OPTICS_DATA i/o logical name
      CHARACTER(  16 ) :: OPTICS_EXPECT
      CHARACTER(  16 ) :: QUANTITY
      CHARACTER(  30 ) :: LAND_EXPECT
      CHARACTER( 120 ) :: MSG                               ! buffer for messages to output
      CHARACTER( 240 ) :: FILE_LINE

      CHARACTER(  16 ),  ALLOCATABLE :: AE_RERACT_REF( : )

!     INTEGER, INTENT(OUT) :: NWL_OPTICS    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: NWL_OPTICS    ! # of wavelengths used in PHOT_MOD.F
      INTEGER :: IOST        ! IOST returned from OPEN function
      INTEGER :: JDATE = 0
      INTEGER :: OPTICS_UNIT
      INTEGER :: IPHOT, IPHOT_LOAD ! loop indices
      INTEGER :: ITT, ITT_LOAD     ! loop indices
      INTEGER :: IP_MAP, IP_REF    ! photolysis reaction indicies
      INTEGER :: IWL_LOAD
      INTEGER :: STRT, FINI

      INTEGER :: NAE_REFRACT_REF

      REAL,       ALLOCATABLE :: AE_IMAG_REFRACT( :, : )
      REAL,       ALLOCATABLE :: AE_REAL_REFRACT( :, : )
      REAL                    :: DELTA

      LOGICAL                  :: ERROR_FLAG = .FALSE.

!***external functions: none

      OPTICS_UNIT = GETEFILE( OPTICS_FILE, .TRUE., .TRUE., PNAME )


      READ( OPTICS_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif

      READ( FILE_LINE, 4999) NWL_REF
#ifdef verbose_phot
      write( LOGDEV,'(17x,i3)' ) nwl_ref
#endif

      NWL_OPTICS = NWL_REF

      DO ITT_LOAD = 1, 15 ! skip next 15 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif
      END DO

      ALLOCATE( CLD_BETA_REF    ( NWL_REF ), CLOUD_BETA_LWC( NWL_REF ) )
      ALLOCATE( CLD_COALBEDO_REF( NWL_REF ), CLOUD_COALBEDO( NWL_REF ) )
      ALLOCATE( CLD_G_REF       ( NWL_REF ), CLOUD_G       ( NWL_REF ) )

      IF( .NOT. ALLOCATED( STWL_REF   ) ) ALLOCATE( STWL_REF  ( NWL_REF ) )
      IF( .NOT. ALLOCATED( ENDWL_REF  ) ) ALLOCATE( ENDWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FSOLAR_REF ) ) ALLOCATE( FSOLAR_REF( NWL_REF ) )
      IF( .NOT. ALLOCATED( EFFWL_REF  ) ) ALLOCATE( EFFWL_REF ( NWL_REF ) )
      IF( .NOT. ALLOCATED( FEXT       ) ) ALLOCATE( FEXT      ( NWL_REF ) )
      IF( .NOT. ALLOCATED( WAVELENGTH ) ) ALLOCATE( WAVELENGTH( NWL_REF ) )

      DO IWL_LOAD = 1, NWL_REF
         READ( OPTICS_UNIT, * )IPHOT_LOAD,
     &   STWL_REF( IWL_LOAD ), EFFWL_REF( IWL_LOAD ), ENDWL_REF( IWL_LOAD ),
     &   CLD_BETA_REF( IWL_LOAD ), CLD_G_REF( IWL_LOAD ), CLD_COALBEDO_REF( IWL_LOAD )


#ifdef verbose_phot
         write( LOGDEV, 99946 )
     &   stwl_ref( iwl_load ), effwl_ref( iwl_load ), endwl_ref( iwl_load ),
     &   cld_beta_ref( iwl_load ), cld_g_ref( iwl_load ), cld_coalbedo_ref( iwl_load )
#endif

         WAVELENGTH( IWL_LOAD ) = EFFWL_REF ( IWL_LOAD )
         FEXT      ( IWL_LOAD ) = FSOLAR_REF( IWL_LOAD )

         CLOUD_BETA_LWC( IWL_LOAD ) = CLD_BETA_REF    ( IWL_LOAD )
         CLOUD_COALBEDO( IWL_LOAD ) = CLD_COALBEDO_REF( IWL_LOAD )
         CLOUD_G       ( IWL_LOAD ) = CLD_G_REF       ( IWL_LOAD )

      END DO

      DO ITT_LOAD = 1, 7 ! skip next 7 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif

      READ( FILE_LINE, 4999)NAE_REFRACT_REF

#ifdef verbose_phot
      write( LOGDEV, * )' NAE_REFRACT_REF = ', NAE_REFRACT_REF
#endif

      NUM_REFRACTIVE = NAE_REFRACT_REF
      
      ALLOCATE( AE_RERACT_REF   ( NAE_REFRACT_REF ) )

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE

#ifdef verbose_phot
      write( LOGDEV, '(a)')TRIM(FILE_LINE)
#endif

      STRT = SCAN(FILE_LINE, '=', BACK = .TRUE.) + 1
      FINI =  LEN(FILE_LINE)

      READ( FILE_LINE( STRT:FINI ), * )( AE_RERACT_REF( ITT_LOAD ),
     &                                   ITT_LOAD = 1, NAE_REFRACT_REF )

#ifdef verbose_phot
      write( LOGDEV, 99947)'REFRACTIVE_INDICES'
      write( LOGDEV, 99948 )(AE_RERACT_REF( ITT_LOAD ),ITT_LOAD = 1, 
     &                                 NAE_REFRACT_REF )
#endif


      ALLOCATE( AE_REAL_REFRACT ( NAE_REFRACT_REF, NWL_REF ) )
      ALLOCATE( AE_IMAG_REFRACT ( NAE_REFRACT_REF, NWL_REF ) )
      ALLOCATE( REFRACTIVE_INDEX( NAE_REFRACT_REF ) )

      DO ITT_LOAD = 1, NAE_REFRACT_REF
! set up refractive indices used by aero_photdata routine

          REFRACTIVE_INDEX( ITT_LOAD )%NAME = AE_RERACT_REF( ITT_LOAD )
          ALLOCATE( REFRACTIVE_INDEX( ITT_LOAD )%REAL_PART( N_MODE, NWL_REF ) )
          ALLOCATE( REFRACTIVE_INDEX( ITT_LOAD )%IMAG_PART( N_MODE, NWL_REF )  )

#ifdef verbose_phot
          write( LOGDEV, '(i3, 1x, a16)')itt_load, refractive_index( itt_load )%name
#endif

      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(A)' )TRIM(FILE_LINE)
#endif

      DO IWL_LOAD = 1, NWL_REF
         READ( OPTICS_UNIT, * )iphot_load,
     &   STWL_REF( IWL_LOAD ), EFFWL_REF( IWL_LOAD ), ENDWL_REF( IWL_LOAD ),
     &   (AE_REAL_REFRACT( ITT_LOAD, IWL_LOAD ), AE_IMAG_REFRACT( ITT_LOAD, IWL_LOAD ),
     &    ITT_LOAD = 1, NAE_REFRACT_REF)

               DO ITT_LOAD = 1, NAE_REFRACT_REF
                  REFRACTIVE_INDEX( ITT_LOAD )%REAL_PART( 1:N_MODE, IWL_LOAD )
     &                                      = AE_REAL_REFRACT( ITT_LOAD, IWL_LOAD )
                  REFRACTIVE_INDEX( ITT_LOAD )%IMAG_PART( 1:N_MODE, IWL_LOAD )
     &                                      = AE_IMAG_REFRACT( ITT_LOAD, IWL_LOAD )
               END DO
#ifdef verbose_phot
         write( LOGDEV, 99949 )
     &          stwl_ref( iwl_load ), effwl_ref( iwl_load ),
     &          endwl_ref( iwl_load ),fsolar_ref( iwl_load ),
     &          ( ae_real_refract( itt_load, iwl_load ),
     &            ae_imag_refract( itt_load, iwl_load ), itt_load = 1, nae_refract_ref )
#endif

      END DO

      DO ITT_LOAD = 1, 8 ! skip next 8 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

! read optical data for liquid droplets

      READ( FILE_LINE, 4999)NRADIUS_LIQUID

#ifdef verbose_phot
      write( LOGDEV, '(a,i4)' )'NRADIUS_LIQUID = ',NRADIUS_LIQUID
#endif

      ALLOCATE(RADIUS_LIQUID( NRADIUS_LIQUID ))

      ALLOCATE( LIQUID_EXTINCT(NRADIUS_LIQUID, NWL_OPTICS),
     &         LIQUID_ASYMFACT(NRADIUS_LIQUID, NWL_OPTICS),
     &         LIQUID_COALBEDO(NRADIUS_LIQUID, NWL_OPTICS))

      QUANTITY = 'LIQ_EXT'

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      DO ITT_LOAD = 1, NRADIUS_LIQUID
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO


      QUANTITY = 'LIQ_ASY'

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      DO ITT_LOAD = 1, NRADIUS_LIQUID
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'LIQ_COA'

      DO ITT_LOAD = 1, NRADIUS_LIQUID
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, RADIUS_LIQUID( ITT_LOAD ),
     &         ( LIQUID_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO


      DO ITT_LOAD = 1, 7 ! skip next 7 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

! read optical data for liquid droplets

      READ( FILE_LINE, 4999)NDIAMETER_ICE

#ifdef verbose_phot
      write( LOGDEV, '(a,i4)' )'NDIAMETER_ICE = ',NDIAMETER_ICE
#endif

      ALLOCATE(DIAMETER_ICE( NDIAMETER_ICE ))

      ALLOCATE( ICE_EXTINCT(NDIAMETER_ICE, NWL_OPTICS),
     &         ICE_ASYMFACT(NDIAMETER_ICE, NWL_OPTICS),
     &         ICE_COALBEDO(NDIAMETER_ICE, NWL_OPTICS),
     &            ICE_DELTRANS(NDIAMETER_ICE, NWL_OPTICS))

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_EXT'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_EXTINCT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_ASY'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_ASYMFACT( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_COA'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_COALBEDO( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      QUANTITY = 'ICE_DEL'

      DO ITT_LOAD = 1, NDIAMETER_ICE
         READ( OPTICS_UNIT, * )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_DELTRANS( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )

#ifdef verbose_phot
          write( LOGDEV, 99950 )
     &         OPTICS_EXPECT, DIAMETER_ICE( ITT_LOAD ),
     &         ( ICE_DELTRANS( ITT_LOAD, IWL_LOAD), IWL_LOAD = 1, NWL_OPTICS )
#endif
            IF ( OPTICS_EXPECT .NE. QUANTITY ) THEN
               MSG =  'Optical quantity read ' // TRIM( OPTICS_EXPECT )
     &             // ' does match expected quantity, ' // TRIM( QUANTITY )
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
            END IF
      END DO

! Determine limit and frequencies of liquid and ice inputs
      MAXI_RADIUS_LIQUID = MAXVAL( RADIUS_LIQUID )
      MINI_RADIUS_LIQUID = MINVAL( RADIUS_LIQUID )

      DELTA = (RADIUS_LIQUID( 2 ) - RADIUS_LIQUID( 1 ))

      IF( DELTA  .LE. EPSILON )THEN
         WRITE( MSG, 99951)DELTA
               CALL M3WARN( PNAME, 0, 0, MSG )
               ERROR_FLAG = .TRUE.
      ELSE
         FREQ_RADIUS_LIQUID = 1.0 / DELTA
         INIT_RADIUS_LIQUID = MINI_RADIUS_LIQUID
     &                      - DELTA
      END IF

      MAXI_DIAMETER_ICE = MAXVAL( DIAMETER_ICE )
      MINI_DIAMETER_ICE = MINVAL( DIAMETER_ICE )

      DELTA = (DIAMETER_ICE( 2 ) - DIAMETER_ICE( 1 ))

      IF( DELTA  .LE. EPSILON )THEN
         WRITE( MSG, 99952)DELTA
         CALL M3WARN( PNAME, 0, 0, MSG )
         ERROR_FLAG = .TRUE.
      ELSE
         FREQ_DIAMETER_ICE = 1.0 / DELTA
         INIT_DIAMETER_ICE = MINI_DIAMETER_ICE
     &                     - DELTA
      END IF

!  read data for calculating surface albedo

      DO ITT_LOAD = 1, 6 ! skip next 6 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_REF

      DO ITT_LOAD = 1, 3 ! skip next 3 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,5013 ) INDEX_GRASSLAND_REF
      READ( OPTICS_UNIT,5013 ) INDEX_OCEAN_REF
      READ( OPTICS_UNIT,5013 ) INDEX_SEA_ICE

#ifdef verbose_phot
      write( LOGDEV,6013 )'NUMB_LANDUSE_REF    = ', numb_landuse_ref
      write( LOGDEV,6013 )'INDEX_GRASSLAND_REF = ', index_grassland_ref
      write( LOGDEV,6013 )'INDEX_OCEAN_REF     = ', index_ocean_ref
      write( LOGDEV,6013 )'INDEX_SEA_ICE       = ', index_sea_ice
#endif

      ALLOCATE( LANDUSE_REF     ( NUMB_LANDUSE_REF ) )
      ALLOCATE( ZENITH_COEFF_REF( NUMB_LANDUSE_REF ) )
      ALLOCATE( SEASON_COEFF_REF( NUMB_LANDUSE_REF ) )
      ALLOCATE( SNOW_COEFF_REF  ( NUMB_LANDUSE_REF ) )
      ALLOCATE( SPECTRAL_ALBEDO_REF( NWL_OPTICS, NUMB_LANDUSE_REF ) )

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      DO ITT_LOAD = 1, NUMB_LANDUSE_REF
         READ( OPTICS_UNIT,5012 ) LANDUSE_REF( ITT_LOAD ),
     &                            ZENITH_COEFF_REF( ITT_LOAD ),
     &                            SEASON_COEFF_REF( ITT_LOAD ),
     &                            SNOW_COEFF_REF( ITT_LOAD )
#ifdef verbose_phot
         write( LOGDEV,5012 ) landuse_ref( itt_load ),
     &                          zenith_coeff_ref( itt_load ),
     &                          season_coeff_ref( itt_load ),
     &                          snow_coeff_ref( itt_load )
#endif
      END DO

      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      DO ITT_LOAD = 1, NUMB_LANDUSE_REF
         READ( OPTICS_UNIT,'(A30,1X,40(1PE12.6,2X))' ) LAND_EXPECT,
     &        ( SPECTRAL_ALBEDO_REF(IWL_LOAD, ITT_LOAD), IWL_LOAD = 1, NWL_REF )

#ifdef verbose_phot
         write( LOGDEV,'(a30,1x,40(1pe13.6,2x))' ) trim( land_expect ),
     &        ( spectral_albedo_ref(iwl_load, itt_load), iwl_load = 1, nwl_ref )
#endif

      END DO

      DO ITT_LOAD = 1, 3 ! skip next 3 lines
         READ( OPTICS_UNIT,'(A)' ) FILE_LINE
#ifdef verbose_phot
         write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif
      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_NLCD50
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line

#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_NLCD50_MODIS = ', numb_landuse_NLCD50
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_NLCD50( NUMB_LANDUSE_NLCD50 )  )
      ALLOCATE( ALBMAP_REF2NLCD50( NUMB_LANDUSE_NLCD50 )  )
      ALLOCATE( ALBFAC_REF2NLCD50( NUMB_LANDUSE_NLCD50 )  )

      DO ITT_LOAD = 1, NUMB_LANDUSE_NLCD50
         READ( OPTICS_UNIT,5016 ) LANDUSE_NLCD50( ITT_LOAD ),
     &                            ALBMAP_REF2NLCD50( ITT_LOAD ),
     &                            ALBFAC_REF2NLCD50( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_NLCD50( itt_load ),
     &                          albmap_ref2NLCD50( itt_load ),
     &                          albfac_ref2NLCD50( itt_load )
#endif

      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_USGS
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_USGS = ', numb_landuse_usgs
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_USGS   ( NUMB_LANDUSE_USGS ) )
      ALLOCATE( ALBMAP_REF2USGS( NUMB_LANDUSE_USGS ) )
      ALLOCATE( ALBFAC_REF2USGS( NUMB_LANDUSE_USGS ) )

      DO ITT_LOAD = 1, NUMB_LANDUSE_USGS
         READ( OPTICS_UNIT,5016 ) LANDUSE_USGS( ITT_LOAD ),
     &                            ALBMAP_REF2USGS( ITT_LOAD ),
     &                            ALBFAC_REF2USGS( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_usgs( itt_load ),
     &                          albmap_ref2usgs( itt_load ),
     &                          albfac_ref2usgs( itt_load )
#endif

      END DO

      READ( OPTICS_UNIT,5013 ) NUMB_LANDUSE_MODIS
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_MODIS = ', numb_landuse_modis
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_MODIS   ( NUMB_LANDUSE_MODIS ) )
      ALLOCATE( ALBMAP_REF2MODIS( NUMB_LANDUSE_MODIS ) )
      ALLOCATE( ALBFAC_REF2MODIS( NUMB_LANDUSE_MODIS ) )

      DO ITT_LOAD = 1, NUMB_LANDUSE_MODIS
         READ( OPTICS_UNIT,5016 ) LANDUSE_MODIS( ITT_LOAD ),
     &                            ALBMAP_REF2MODIS( ITT_LOAD ),
     &                            ALBFAC_REF2MODIS( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_modis( itt_load ),
     &                          albmap_ref2modis( itt_load ),
     &                          albfac_ref2modis( itt_load )
#endif

      END DO

      NO_NLCD40 = .TRUE.  ! default condition that file does not contain NLCD40 Landuse data

      READ( OPTICS_UNIT,5013, END = 101 ) NUMB_LANDUSE_NLCD40
      READ( OPTICS_UNIT,'(A)' ) FILE_LINE ! skip line
#ifdef verbose_phot
      write( LOGDEV,6013 ) 'NUMB_NLCD40_MODIS = ', numb_landuse_NLCD40
      write( LOGDEV, '(a)' )TRIM(FILE_LINE)
#endif

      ALLOCATE( LANDUSE_NLCD40( NUMB_LANDUSE_NLCD40 )  )
      ALLOCATE( ALBMAP_REF2NLCD40( NUMB_LANDUSE_NLCD40 )  )
      ALLOCATE( ALBFAC_REF2NLCD40( NUMB_LANDUSE_NLCD40 )  )

      DO ITT_LOAD = 1, NUMB_LANDUSE_NLCD40
         READ( OPTICS_UNIT,5016 ) LANDUSE_NLCD40( ITT_LOAD ),
     &                            ALBMAP_REF2NLCD40( ITT_LOAD ),
     &                            ALBFAC_REF2NLCD40( ITT_LOAD )

#ifdef verbose_phot
         write( LOGDEV,6016 ) itt_load, landuse_NLCD40( itt_load ),
     &                          albmap_ref2NLCD40( itt_load ),
     &                          albfac_ref2NLCD40( itt_load )
#endif

      END DO

      NO_NLCD40 = .FALSE.

101   IF( NO_NLCD40 )THEN
          MSG = TRIM( PNAME ) // ':'
     &       // TRIM( OPTICS_FILE )
     &       // ' does not contain data for NLCD40 land use and'
     &       // ' corresponds to CMAQ version 5.01.'
          CALL M3MESG( MSG )
      END IF

! set the default values for surface albedo
      ALLOCATE( ALB( NWL_OPTICS ) )

      DO IWL_LOAD = 1, NWL_OPTICS
         IF ( WAVELENGTH( IWL_LOAD ) .LE. 380.1 ) THEN
            ALB( IWL_LOAD ) = 0.05
         ELSE
            ALB( IWL_LOAD ) = 0.10
         END IF
      END DO



      IF( ERROR_FLAG )THEN
         MSG = 'The above fatal error(s) found in CSQY data! '
         CALL M3EXIT( PNAME, 0, 0, MSG, -1 )
      END IF


      CLOSE(OPTICS_UNIT)

4999  FORMAT(17X,I3,2X,17X,I3)
5012  FORMAT( 4X,A30,1X,3(F8.3,2X) )
5013  FORMAT( 22X,I3 )
5016  FORMAT( 4X,A60,1X,I3,2X,3(F8.3,2X) )
99946 FORMAT(4x,3(f8.3,2x),2x,2(es12.4,2x),f8.3,2x,12(es12.4,2x))
99947 FORMAT(a3, 1x, a16)
99948 FORMAT(10(a16,1x))
99949 FORMAT(4x,3(f8.3,2x),2x,2(es12.4,2x),f8.3,2x,12(es12.4,2x))
99950 FORMAT(a8,1x,f10.3,40(1x,1pe13.6))
99951 FORMAT('Too Small Differences in Liquid Droplet Radii = ',1PE12.4,' um ')
99952 FORMAT('Too Small Differences in Ice Particle Sizes   = ',1PE12.4,' um ')
#ifdef verbose_phot
6009  format( a3,', ',8(a,', ') )
6013  format( a22,1x,i3 )
6016  format( i3,1x,a60,1x,i3,2x,3(f8.3,2x) )
#endif

      RETURN
      END SUBROUTINE LOAD_OPTICS_DATA

C///////////////////////////////////////////////////////////////////////
       INTEGER FUNCTION INDEXR ( NAME1, N, NAME2 )
C-----------------------------------------------------------------------
C
C  FUNCTION:
C     This routine searches for NAME1 in list NAME2
C
C  REVISION HISTORY:
C     5/88   Modified for ROMNET
C     July 29, 2005 by FSB
C     Changed name to avoid conflict FSB
C     copied from CMAQ routine INDEX2 to allow internal use
C
C  ARGUMENT LIST DESCRIPTION:
C
C  Input arguments:
C     NAME1       Character string being searched for
C     N           Length of array to be searched
C     NAME2       Character array to be searched
C
C  Output arguments:
C     INDEX1      The position within the NAME2 array that NAME1
C                 found.  If string was not found, INDEX1 = 0
C
C  LOCAL VARIABLE DESCRIPTION:
C     None
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: N

      CHARACTER*(*), INTENT(IN) :: NAME1
      CHARACTER*(*), INTENT(IN) :: NAME2(*)

      INTEGER I

!***Assume NAME1 is not in list NAME2

      INDEXR = 0

      DO I = 1, N
         IF ( INDEX( NAME2( I ), NAME1 ) .EQ. 1 ) THEN
            INDEXR = I
            RETURN
         END IF
      END DO

      RETURN
      END FUNCTION INDEXR
      SUBROUTINE GET_CSQY ( TEMP, DENS, CSZ, QYZ )
!-----------------------------------------------------------------------
!  Purpose: Calculate values of absorption cross
!     section and quantum yield, given, temperature and air
!     pressure and density.
!
!  reference for acetone:
!     Cameron-Smith, Philip J., Incorporating non_linear computation
!     code (Fast-J), Journal of Atmospheric Chemistry, Vol. 37,
!     pp 283-297, 2000)
!
!  Mar 2011: Bill Hutzell
!     - revised interpolation method for a general number of
!     interpolation points
!     - revised density corrections for specific photolysis reactions
!  Apr 2014: Bill Hutzell
!     -revised method to determine what density corrections for a
!      specific photolysis reactions from name select to index selection
!     -revision agrument an variable names to use data available in CSQY_DATA
!      and GRID_CONF modules
!  Sept 2014: Bill Hutzell
!     -revised fortrans looping constructs attempting to improve computational
!      efficiency
!     -corrected several density or pressure adjustment for quantum yield based on
!      re-consulting source and cited references
!-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications

      IMPLICIT NONE

!***Arguments


      REAL, INTENT(IN)  :: TEMP( : )      ! air temperature [K]
      REAL, INTENT(IN)  :: DENS( : )      ! air density [molecules/cm**3]
      REAL, INTENT(OUT) :: CSZ( :, :, : ) ! abs cross sections
      REAL, INTENT(OUT) :: QYZ( :, :, : ) ! quantum yields

!***Internal:

      INTEGER  :: IT, IWL, LAYS, IPHOT
      REAL     :: XTEMP            ! local temperature
      REAL     :: YTEMP            ! temperature difference ratio

      REAL,    ALLOCATABLE, SAVE :: DELTA_REFT( :, : )
      INTEGER, ALLOCATABLE, SAVE :: ITEMP( :, : )

      REAL, PARAMETER :: TTX1 = 235.0
      REAL, PARAMETER :: TTX2 = 298.0
      REAL, PARAMETER :: DTTX = TTX2 - TTX1

      REAL            :: PRESSURE          ! units vary
      REAL            :: FACTOR            ! scratch variable for yield
      REAL            :: ALPHA, BETA       ! scratch variables
      REAL            :: PHI_CO            ! CO channel of acetone QYZ
      REAL            :: PHI_CH3CO         ! CH3CO channel of acetone QYZ

      LOGICAL, SAVE   :: FIRSTCALL = .TRUE.

      IF ( FIRSTCALL ) THEN
          ALLOCATE( ITEMP( NLAYS, MECHANISM_RATES ) )
          ALLOCATE( DELTA_REFT( (IREFTEMPS - 1), MECHANISM_RATES ) )
          DO IT = 1, IREFTEMPS - 1
             DO IPHOT = 1, MECHANISM_RATES
                DELTA_REFT( IT, IPHOT ) = RTEMP_S( IT + 1, IPHOT ) -  RTEMP_S( IT, IPHOT )
             END DO
          END DO
          CALL DEFINE_CSQY_ADJUST()
          FIRSTCALL = .FALSE.
      END IF

!***determine and save where layer temperatures fall within range of CS and QY data
      DO IPHOT = 1, MECHANISM_RATES
         DO LAYS = 1, NLAYS
             IF ( TEMP( LAYS ) .LE. RTEMP_S( 1, IPHOT ) )  THEN
                ITEMP( LAYS, IPHOT ) = 0
             ELSE IF ( TEMP( LAYS ) .GE. RTEMP_S( IREFTEMPS, IPHOT ) ) THEN
                ITEMP( LAYS, IPHOT ) = IREFTEMPS
             ELSE
                 LOOP_FINDT: DO IT = 1, IREFTEMPS - 1
                    IF ( TEMP( LAYS ) .GT. RTEMP_S( IT, IPHOT ) .AND. TEMP( LAYS ) .LE. RTEMP_S( IT + 1, IPHOT ) ) THEN
                       ITEMP( LAYS, IPHOT ) = IT
                       EXIT LOOP_FINDT
                    END IF
                 END DO LOOP_FINDT
            END IF
         END DO
      END DO


!***loop over rates
      DO IPHOT = 1, MECHANISM_RATES
!***loop over wavelengths
        DO IWL = 1, NWL_REF
!***Loop over layers:
           DO LAYS = 1, NLAYS
!***fetch temperature data
               XTEMP = TEMP( LAYS )
               IT    = ITEMP( LAYS, IPHOT )

               IF ( IT .EQ. 0 ) THEN
!***if the ambient temperature is cooler than the minimum
!***  reference temperature, then use the value at the minimum reference temperature
                  CSZ( LAYS, IWL, IPHOT ) = XXCS( IT+1, IWL, IPHOT )
                  QYZ( LAYS, IWL, IPHOT ) = XXQY( IT+1, IWL, IPHOT )
               ELSE IF ( IT .GE. 1 .AND. IT .LT. IREFTEMPS ) THEN
!***for the next case use linear interpolation
                  YTEMP = ( XTEMP - RTEMP_S( IT, IPHOT ) )
     &                  /   DELTA_REFT( IT, IPHOT )

                  CSZ( LAYS, IWL, IPHOT ) =   XXCS(   IT, IWL, IPHOT )
     &                                    + ( XXCS( IT+1, IWL, IPHOT )
     &                                      - XXCS(   IT, IWL, IPHOT ) )
     &                                    * YTEMP
                  QYZ( LAYS, IWL, IPHOT ) =   XXQY(   IT, IWL, IPHOT )
     &                                    + ( XXQY( IT+1, IWL, IPHOT )
     &                                      - XXQY(   IT, IWL, IPHOT ) )
     &                                    * YTEMP
               ELSE
!***if the ambient temperature is warmer than the maximum
!***  reference temperature, then use the value at the maximum reference temperature
                  CSZ( LAYS, IWL, IPHOT ) = XXCS( IT, IWL, IPHOT )
                  QYZ( LAYS, IWL, IPHOT ) = XXQY( IT, IWL, IPHOT )
               END IF
           END DO
        END DO
!***Make specific temperature and/or density corrections if needed
!***Note specific acetone channels are treated outside these three nested loops

        IF( CSQY_ADJUST( IPHOT ) .LT. 1 )CYCLE

        SELECT CASE (  CSQY_ADJUST( IPHOT ) )
           CASE ( ACETALDEHYDE )      ! 'CH3CHO -> CH3 + HCO'
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = 1.0
     &                                       / ( 1.0 + ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - 1.0 ) * DENS( LAYS ) * 4.0568E-20 )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
           CASE( CH3CHO_IUPAC2013 ) ! IUPAC 2013 correction for acetaldehyde
! density correction to quantum yield recommended in
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P2_CH3CHO+hv.pdf dated June 2013
! and based on
! Warneck, P. and Moortgat, G.K. (2012). Quantum yields and photodissociation coefficients of
! acetaldehyde in the troposphere, Atmos. Environ., 62, 153-163.
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
     &                                       * IPHIS_CH3CHO( IWL )
     &                                       / ( IPHI0_CH3CHO( IWL ) + KCH3CHO( IWL ) * DENS( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
!      IF ( FIRSTCALL )THEN
!             DO LAYS = 1, NLAYS
!                WRITE(LOGDEV, 99951)'DENS, CH3CHO_IUPAC2013 QYZ factor =  ', ' ',DENS( LAYS ),
!     &          (IPHIS_CH3CHO( IWL )/( IPHI0_CH3CHO( IWL ) + KCH3CHO( IWL ) * DENS( LAYS ) ),IWL=1,NWL_REF)
!             END DO
!      END IF
           CASE ( HIGHER_ALDEHYDES )  ! C3 and some higher aldehydes
!***density correction to quantum yield
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = 1.0
     &                                       / ( 1.0 + ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - 1.0 ) * DENS( LAYS ) * 4.0568E-20 )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
           CASE( NBUTYRALDEHYDE ) ! both photolysis channels for n-C3H7CHO
! based on recommendation in
! IUPAC Recommendation
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P11_nC3H7CHO+hv.pdf dated 2002
               FORALL( IWL = 1:NWL_REF )
                  FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 )
                     QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
     &                                       * ( 1.81 + 4.919E-3 * TEMP( LAYS ) )
     &                                       / ( 1.81 + 2.000E-22 * DENS( LAYS ) * TEMP( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                  END FORALL
               END FORALL
           CASE ( METHYL_VINYL_KETONE )
!***quantum yield from
!***  Gierczak, T., J. B. Burkholder, R. K. Talukdar, A. Mellouki, S. B. Barone,
!***  and A. R. Ravishankara, Atmospheric fate of methyl vinyl ketone and methacrolein,
!***  J. Photochem. Photobiol A: Chemistry, 110 1-10, 1997.
!***  depends on pressure and wavelength, set upper limit to 1.0
!***  However, chamber evaluations for SAPRC07T require a pressure correction where
!***  number density coefficient is five times higher.
!***density correction to quantum yield
!***remove wavelength dependence
              FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                     QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT ) *  118.4
     &                                       / ( 5.5 + 4.6E-19 * DENS( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX(0.0, MIN( QYZ( LAYS, IWL, IPHOT ), 1.0 ) )
              END FORALL
           CASE ( METHYL_ACROLEIN )
!***quantum yield based on 2.76 times MVK from
!***  Gierczak, T., J. B. Burkholder, R. K. Talukdar, A. Mellouki, S. B. Barone,
!***  and A. R. Ravishankara, Atmospheric fate of methyl vinyl ketone and methacrolein,
!***  J. Photochem. Photobiol A: Chemistry, 110 1-10, 1997.
!***  depends on pressure and wavelength, set upper limit to 1.0
!***  However, chamber evaluations for SAPRC07T require a pressure correction where
!***  number density coefficient is five times higher.
!***density correction to quantum yield
!***remove wavelength dependence
              FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                 QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT ) * 118.4
     &                                   / ( 5.5 + 4.6E-19 * DENS( LAYS ) )
                 QYZ( LAYS, IWL, IPHOT ) = MAX(0.0, MIN( QYZ( LAYS, IWL, IPHOT ), 1.0 ) )
              END FORALL
           CASE ( METHYL_ETHYL_KETONE )
!***Quantum Yields from
!***  Raber, W.H. (1992) PhD Thesis, Johannes Gutenberg-Universitaet, Mainz, Germany.
!***  other channels assumed negligible (less than 10%).
!***  Total quantum yield  = 0.38 at 760 Torr.
!***  Ttemperature/Density correction to quantum yield in
!***  Stern-Volmer form :  1/phi = 0.96 + 2.22e-3*P(torr)
!***  Using relative correction to quantum yields based on above formula
               FORALL( IWL = 1:NWL_REF )
                   FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 0.0 )
! skips SAPRC07T cases where qy is set to one and photolysis rate is scaled in mech.def
!***  Carter adjusted to 0.175 based on chamber tests and sets the values in
!***  mechanism definition file. The photolysis data submitted for SAPRC07T sets this
!***  quantum yield to one.
!                     IF( QYZ( LAYS, IWL, IPHOT ) .GE.  1.0 )THEN
!                          CYCLE
!                     END IF
!                     PRESSURE = ( 1.03547E-19 * DENS( LAYS ) * TEMP( LAYS ) ) ! TORR
!                     IF ( PRESSURE  .LT. 18.02 ) THEN
!                        QYZ( LAYS, IWL, IPHOT ) =  1.0
!                     ELSE
!                        QYZ( LAYS, IWL, IPHOT ) =  1.0 / ( 0.96 + 2.22E-3 * PRESSURE )
!                     END IF
                     QYZ( LAYS, IWL, IPHOT ) =  QYZ( LAYS, IWL, IPHOT )
     &                                       * ( 0.96 + 5.66639E-03 * TEMP( LAYS ) )
     &                                       / ( 0.96 + 2.29874E-22 * DENS( LAYS ) * TEMP( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END FORALL
               END FORALL
           CASE ( BIACETYL )
! Biacetyl quantum yield (CH3CO + CH3CO) = 0.158 for wavelength less than 460 nm
! Pressure correction based on phi(z=infi) and ph(z=0) values based on
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P23_Biacetyl+hv.pdf dated 2011
! by solving the below for kq
! phi(z=infi)/ph(z=0) = (0.76/0.16) = 1.0 + kq*Temp(z=0)*Number_Density(z=0)
! where Temp(z=0) = 298.15K and Number_Density(z=0) = 2.46E19 molecules/cm3
               FORALL( IWL = 1:NWL_REF )
                   FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 0.0 )
                     QYZ( LAYS, IWL, IPHOT ) =  QYZ( LAYS, IWL, IPHOT )
     &                                       * ( 1.0 + 1.37662E-02 * TEMP( LAYS ) )
     &                                       / ( 1.0 + 5.19481E-22 * DENS( LAYS ) * TEMP( LAYS ) )
                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END FORALL
               END FORALL
           CASE ( METHYL_GLYOXAL_IUPAC04 )
               DO IWL = 1, NWL_REF
                   IF( WAVELENGTH( IWL ) .GE. 500.0 .OR. WAVELENGTH( IWL ) .LE. 240.0 )CYCLE
                   DO LAYS = 1, NLAYS
                        IF( QYZ( LAYS, IWL, IPHOT ) .LE. 0.0 )CYCLE
! Replaced the following method used in CMAQ 5.01
!***  Pressure dependence based on Koch and Moortgat (1998),
!***  J. Phys. Chem. A, vol 102, pages 9142. The application contradicts
!***  NASA (2006) & IUPAC (2005) and is used based recommendations for
!***  SAPRC07T photolysis rates by William Carter (2009)
!                       PRESSURE = MIN( 472.0, 1.03547E-19 * DENS( LAYS ) * TEMP( LAYS )  ) ! in TORRs
!***remove wavelength dependence
!                       QYZ( LAYS, IWL, IPHOT ) = 6.4192E10 ! 1.36E8 * ( 472.0 )
!     &                                         / ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - 1.0 )
!                       QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
!     &                                         / ( QYZ( LAYS, IWL, IPHOT ) + 1.36E8 * PRESSURE )
! by using the relative correction recommended in NASA JPL (2011).  Note that linearily interpolated
! values are assumed to be at air number density equal to 2.465E19 molecules/cm3. Pressure units are Torrs.
! New correction is based on recommendation in
! http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P6_CH3COCHO+hv.pdf dated 2003
! but places lower limit on pressure of 4 Torrs based on source of recommendation:
!     Y. Chen, W. Wang and L. Zhu, J. Phys. Chem. A, 104 11126 (2000).
                       PRESSURE = 1.03547E-19 * TEMP( LAYS ) * DENS( LAYS )
                       FACTOR   = 2.5524 * TEMP( LAYS ) ! pressure for dens at 2.465e19 molec/cm3
                       IF( WAVELENGTH( IWL ) .LE. 370.0 )THEN
                           PRESSURE = MAX( 400.0, PRESSURE )
                           FACTOR   = MAX( 400.0, FACTOR   )
                       END IF
                       QYZ( LAYS, IWL, IPHOT ) =  QYZ( LAYS, IWL, IPHOT )
     &                                         * ( IPHI0_MGLY( IWL ) + KMGLY( IWL ) * FACTOR )
     &                                         / ( IPHI0_MGLY( IWL ) + KMGLY( IWL ) * PRESSURE )
                       QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END DO
               END DO
           CASE (  ACROLEIN )
!***density correction quantum yield
               DO IWL = 1, NWL_REF
                   DO LAYS = 1, NLAYS
!***Number density dependence based on Gardner et. al (1987),
!***  J. Phys. Chem., vol 91, pages 1922. The application uses
!***  the quantum yields set in in cross-section file.
!***  For SAPRC07T CSQY data, yields set approximately four times NASA (2006)
!***  because the mechanism developer sums over all possible channels and
!***  Gardner et. al may support this conclusion.
                     IF ( DENS( LAYS ) .GE. 8.0E+17 ) THEN
                        QYZ( LAYS, IWL, IPHOT ) = 153.5 * QYZ( LAYS, IWL, IPHOT )
     &                                          * ( 4.0E-3 + 1.0 / ( 8.6E-2 + 1.613E-17 * DENS( LAYS ) ) )
                     ELSE IF ( DENS( LAYS ) .LT. 8.0E+17 ) THEN
                        QYZ( LAYS, IWL, IPHOT ) = 12.431 * QYZ( LAYS, IWL, IPHOT )
                     END IF

                     QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END DO
               END DO
           CASE ( FORMALDEHYDE_MOLECULAR )  ! 'CH2O -> H2 + CO'
!***temperature/density correction to quantum yield
! based on
! Sander, S. P., Friedl, R. R., Abbatt, J. P. D., Barker, J. R.,
! Burkholder, J. B., Golden, D. M., Kolb, C. E., Kurylo, M. J.,
! Moortgat, G. K., Wine, P. H., Huie, R. E., and Orkin, V. L.:
! Chemical kinetics and photochemical data for use in atmospheric
! studies. Evaluation number 17, JPL-Publication 10-6, Pasadena,
! 2011.
              IF ( LHCHOR_06 .LE. 0 )CYCLE
              DO IWL = 1, NWL_REF
                 IF ( WAVELENGTH( IWL ) .LE. 329.0 ) CYCLE
                 DO LAYS = 1, NLAYS
                    IF ( QYZ( LAYS, IWL, IPHOT ) .LE. 0.0 ) CYCLE

                    BETA = 1.0 / ( 1.0 - QYZ( LAYS, IWL, LHCHOR_06 ) )
                    IF ( TEMP( LAYS ) .LT. 300.0 .AND. TEMP( LAYS ) .GT. 220.0 ) THEN
                        PRESSURE = 1.36312E-22  * DENS( LAYS ) * TEMP( LAYS )   ! pressure units, atm
                        ALPHA = ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - BETA )
     &                        * ( 1.0 + 0.05 * ( WAVELENGTH( IWL ) - 329.0 )
     &                        * ( ( TEMP( LAYS ) - 80.0 ) * 0.0125 ) )
                    ELSE IF ( TEMP( LAYS ) .LE. 220.0 ) THEN
                        PRESSURE = 3.0E-20 * DENS( LAYS )
                        ALPHA = ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - BETA )
     &                        * ( 1.0 + 0.0875 * ( WAVELENGTH( IWL ) - 329.0 ) )
                    ELSE IF ( TEMP( LAYS ) .GE. 300.0 ) THEN
                        PRESSURE = 4.09E-20 * DENS( LAYS )
                        ALPHA = ( 1.0 / QYZ( LAYS, IWL, IPHOT ) - BETA )
     &                        * ( 1.0 + 0.1375 * ( WAVELENGTH( IWL ) - 329.0 ) )
                    END IF
!***use relative change assuming that air density for interpolated value is 2.465e19 molecules/cm3
                    QYZ( LAYS, IWL, IPHOT ) = QYZ( LAYS, IWL, IPHOT )
     &                                      * ( BETA + 3.3601E-3 * TEMP( LAYS ) * ALPHA ) 
     &                                      / ( BETA + PRESSURE * ALPHA )                    
!      IF ( FIRSTCALL )THEN 
!                WRITE(LOGDEV, 99951)'TEMP, DENS, HCHO_M QYZ factor =  ', ' ',TEMP( LAYS ), DENS( LAYS ),
!     &          ( BETA + 3.3601E-3 * TEMP( LAYS ) * ALPHA )/( BETA + PRESSURE * ALPHA )
!      END IF

                    QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                 END DO
              END DO
           CASE (  ACETONE ) ! 'CH3COCH3 -> products' total quantum yield
!***temperature/density correction to quantum yield
              IF ( IPHOT .EQ. LACETONE ) THEN
!***OPTT is the effective cross section ( Cs * QY )
!***This is an implementation of eq(21) of Cameron-Smith (2000)
!***special information for acetone. Reference:
!***  Cameron-Smith, P., Incorporation of non-linear effective cross section
!***  parameterization into a fast photolysis computation  code (Fast-J)
!***  Journal of Atmospheric Chemistry, Vol. 37, pp 283-297, 2000.
                 FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                       CSZ( LAYS, IWL, LACETONE ) = ( ( TTX2 - TEMP( LAYS ) ) * OP0( 1, IWL )
     &                                            + ( TEMP( LAYS ) - TTX1 ) * OP0( 2, IWL ) )
     &                                            / ( DTTX * ( 1.0 + YY30( IWL ) * DENS( LAYS ) ) )
                       QYZ( LAYS, IWL, LACETONE ) = 1.0
                 END FORALL
             ELSE ! approximate relative correction based on effective wavelengths
                 DO IWL = 1, NWL_REF
                      DO LAYS = 1, NLAYS
                        QYZ( LAYS, IWL, IPHOT ) = RQUANTUM_ACETONE( TEMP( LAYS ), DENS( LAYS ), IWL )
     &                                          * QYZ( LAYS, IWL, IPHOT )
                        QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                   END DO
                END DO
             END IF
         CASE (  ACETONE_CH3CO  )
             DO IWL = 1, NWL_REF
                DO LAYS = 1, NLAYS
                   QYZ( LAYS, IWL, IPHOT ) = RQY_ACETONE_CH3CO( TEMP( LAYS ), DENS( LAYS ), IWL )
     &                                     * QYZ( LAYS, IWL, IPHOT )
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END DO
             END DO
         CASE( GLYOXAL_IUPAC_2013 )
             DO IWL = 1, NWL_REF
                DO LAYS = 1, NLAYS
                   QYZ( LAYS, IWL, IPHOT ) = RQY_GLYOXAL( TEMP( LAYS ), DENS( LAYS ), IWL )
     &                                     * QYZ( LAYS, IWL, IPHOT )
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END DO
             END DO
         CASE (  KETONE_LEGACY  )
             FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                 CSZ( LAYS, IWL, IPHOT ) = CSZ( LAYS, IWL, IPHOT ) / ( 1.0 + 0.80E-19 * DENS( LAYS ) )
             END FORALL
         CASE ( KETONE_RACM2 ) ! Ketone treatement from W. Stockwell sbox
             FORALL( IWL = 1:NWL_REF )
                FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 .AND. QYZ( LAYS, IWL, IPHOT ) .LT. 0.9999 )
                   QYZ( LAYS, IWL, IPHOT ) =  1.0
     &                                     / (1.0 + 4.057E-20 * DENS( LAYS ) * ( 1.0 / QYZ(LAYS, IWL, IPHOT ) - 1.0 ))
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END FORALL
             END FORALL
         CASE ( GLYOXAL_RACM2  ) ! glyoxal treatement from W. Stockwell sbox
             FORALL( IWL = 1:NWL_REF )
                FORALL( LAYS = 1:NLAYS, QYZ( LAYS, IWL, IPHOT ) .GT. 1.0E-5 .AND. QYZ( LAYS, IWL, IPHOT ) .LT. 0.9999 )
                   QYZ( LAYS, IWL, IPHOT ) =  1.0
     &                                     / ( 1.0 + 4.057E-20 * DENS( LAYS ) * ( 1.0 / QYZ(LAYS, IWL, IPHOT ) - 1.0 ))
                   QYZ( LAYS, IWL, IPHOT ) = MAX( 0.0, MIN( 1.0, QYZ( LAYS, IWL, IPHOT ) ) )
                END FORALL
             END FORALL
         CASE (  METHYL_GLYOXAL_LEGACY )
             FORALL( LAYS = 1:NLAYS, IWL = 1:NWL_REF )
                   CSZ( LAYS, IWL, IPHOT ) = CSZ( LAYS, IWL, IPHOT ) / ( 1.0 + 1.67E-19 * DENS( LAYS ) )
             END FORALL
         END SELECT

      END DO   ! loop on IPHOT


!      IF ( FIRSTCALL )THEN
!          DO IPHOT = 1, MECHANISM_RATES
!             DO LAYS = 1, NLAYS
!                WRITE(LOGDEV, 99951)'CSZ for ', PHOTOLYSIS_RATE( IPHOT ),(CSZ( LAYS, IWL, IPHOT ),IWL=1,NWL_REF)
!                WRITE(LOGDEV, 99951)'QYZ for ', PHOTOLYSIS_RATE( IPHOT ),(QYZ( LAYS, IWL, IPHOT ),IWL=1,NWL_REF)
!             END DO
!          END DO
!          FIRSTCALL = .FALSE.
!      END IF

99951 FORMAT(A,A16,40(1X,ES12.4))
      RETURN
      END SUBROUTINE GET_CSQY
      SUBROUTINE DEFINE_CSQY_ADJUST()
! Purpose determine whether a photolysis rate uses specific corrections to
! CSQY data
!          Apr  2014 B.Hutzell Initial version
!          Sept 2014 B.Hutzell corrected acetaldehyde case to include CCHO_R_SAPRC99,
!                    the photolysis rate used in original CB05 mechanism

               IMPLICIT NONE

               INTEGER :: IPHOT, IWL

               REAL( 8 ) :: ILAMBDA

               ALLOCATE( CSQY_ADJUST( MECHANISM_RATES ) )

               DO IPHOT = 1, MECHANISM_RATES
                  SELECT CASE ( TRIM( PHOTOLYSIS_RATE( IPHOT ) ) )
                     CASE ( 'CCHO_R', 'CCHO_R_SAPRC99', 'CH3CHO_RACM2', 'ALD2_R_IUPAC10' )      ! 'CH3CHO -> CH3 + HCO'
                        CSQY_ADJUST( IPHOT ) = ACETALDEHYDE
                     CASE ( 'CCHO_R1_MCMv32', 'CCHO_R2_MCMv32' )      ! 'CH3CHO -> CH3 + HCO'
                        CSQY_ADJUST( IPHOT ) = CH3CHO_IUPAC2013
                        IF( .NOT. ALLOCATED( KCH3CHO ) ) ALLOCATE( KCH3CHO( NWL_REF ) )
                        IF( .NOT. ALLOCATED( IPHI0_CH3CHO ) ) ALLOCATE( IPHI0_CH3CHO( NWL_REF ) )
                        IF( .NOT. ALLOCATED( IPHIS_CH3CHO ) ) ALLOCATE( IPHIS_CH3CHO( NWL_REF ) )
                        DO IWL = 1, NWL_REF
                           IF(  WAVELENGTH( IWL ) .LE. 608.0 )THEN
                             ILAMBDA = REAL( 1.0D0 / WAVELENGTH( IWL ), 8 )
                             KCH3CHO( IWL )   = REAL( 1.0D-21
     &                                        * (1.04D27*EXP(-1.792D4*ILAMBDA) + 1.48D6*EXP(-3.211D3*ILAMBDA)))
                             IPHI0_CH3CHO( IWL ) = 1.0 + EXP( 0.2627801*(  WAVELENGTH( IWL ) - 320.56 ) )
                             IPHIS_CH3CHO( IWL ) = IPHI0_CH3CHO( IWL ) + 2.465E19 *  KCH3CHO( IWL )
                           ELSE ! use values for wavelength equals 608 nm
                             KCH3CHO( IWL )      = 1.64731E-07
                             IPHI0_CH3CHO( IWL ) = 5.50947E+32
                             IPHIS_CH3CHO( IWL ) = 5.50946E+32
                           END IF                               
!                WRITE(LOGDEV, 99951)'DENS, CH3CHO_IUPAC2013 QYZ factor =  ', ' ',2.465E19,
!     &          IPHIS_CH3CHO( IWL ),IPHI0_CH3CHO( IWL ),KCH3CHO( IWL )
                        END DO
                     CASE ( 'NC3CHO_R_MCMv32', 'NC3CHO_M_MCMv32' ) ! n-C3H7CHO (n-butyraldehyde, n-butanal)
                        CSQY_ADJUST( IPHOT ) = NBUTYRALDEHYDE
                     CASE ( 'C2CHO', 'ALD_RACM2', 'BALD_RACM2', 'UALD_RACM2', 'ALDX_R_IUPAC10'  )  ! C3 and higher aldehydes
                        CSQY_ADJUST( IPHOT ) = HIGHER_ALDEHYDES
                     CASE ( 'MVK_06' )
                        CSQY_ADJUST( IPHOT ) = METHYL_VINYL_KETONE
                     CASE ( 'MACR_06', 'MACR_RACM2', 'MACR_MCMv32' )
                        CSQY_ADJUST( IPHOT ) = METHYL_ACROLEIN
                     CASE ( 'MEK_06', 'MEK_MCMv32' )
                        CSQY_ADJUST( IPHOT ) = METHYL_ETHYL_KETONE
                     CASE ( 'MGLY_06' , 'BACL_07', 'MGLY_IUPAC04', 'MGLY_IUPAC10' )
                        CSQY_ADJUST( IPHOT ) = METHYL_GLYOXAL_IUPAC04
                        IF( .NOT. ALLOCATED( KMGLY ) ) ALLOCATE( KMGLY( NWL_REF ) )
                        IF( .NOT. ALLOCATED( IPHI0_MGLY ) ) ALLOCATE( IPHI0_MGLY( NWL_REF ) )
                        WHERE( WAVELENGTH .LT. 380.41 )
                            IPHI0_MGLY = 1.0
                            KMGLY      = 7.08021E-03
                        ELSE WHERE ! maximum value correspond to wavelength = 711.8954 nm
                            IPHI0_MGLY =  MAX( 2.755E+06 * EXP( -5639.0 / WAVELENGTH ), 1.0E+03 )
                            KMGLY       = MAX(  1.93E+04 * EXP( -5639.0 / WAVELENGTH ), 7.00590 )
                        END WHERE
                     CASE (  'ACRO_09' )
                        CSQY_ADJUST( IPHOT ) = ACROLEIN
                     CASE (  'BIACET_MCMv32' )
                        CSQY_ADJUST( IPHOT ) = BIACETYL
                     CASE ( 'HCHO_M_MCMv32', 'HCHOM_06', 'HCHO_M_SAPRC99', 'HCHO_MOL_RACM2', 'FORM_R_IUPAC10' )  ! 'CH2O -> H2 + CO'
                        CSQY_ADJUST( IPHOT ) = FORMALDEHYDE_MOLECULAR
                     CASE (  'ACET_06', 'ACETONE', 'CH3COCH3_RACM2', 'ACET_IUPAC10' ) ! 'CH3COCH3 -> products'
                        CSQY_ADJUST( IPHOT ) = ACETONE
                     CASE (  'KETONE'  )
                        CSQY_ADJUST( IPHOT ) = KETONE_LEGACY
                     CASE ( 'KET_RACM2', 'HKET_RACM2', 'MEK_RACM2', 'MVK_RACM2' ) ! Ketone treatement from W. Stockwell sbox
                        CSQY_ADJUST( IPHOT ) = KETONE_RACM2
                     CASE ( 'GLYH2_RACM2', 'GLYF_RACM2', 'GLYHX_RACM2', 'MGLY_RACM2'  ) ! glyoxal treatement from W. Stockwell sbox
                        CSQY_ADJUST( IPHOT ) = GLYOXAL_RACM2
                     CASE ( 'GLYOX_R_CRI', 'GLYOX_M_CRI', 'GLY_R_IUPAC10'  ) ! glyoxal treatement based on IUPAC 2013 datasheet
                        CSQY_ADJUST( IPHOT ) = GLYOXAL_IUPAC_2013
                     CASE (  'MGLY_ADJ',  'MGLY_ABS' )
                        CSQY_ADJUST( IPHOT ) = METHYL_GLYOXAL_LEGACY
                     CASE ( 'ACET_R2_CRI' )
                        CSQY_ADJUST( IPHOT ) = ACETONE_CH3CO
                     CASE DEFAULT
                        CSQY_ADJUST( IPHOT ) =  0
                     END SELECT
!                      WRITE(LOGDEV,'(A)')'For rate ' // TRIM( PHOTOLYSIS_RATE( IPHOT ) ) 
!     &               // ' using CSQY_ADJUSTMENT ' // TRIM( CSQY_ADJUSTMENTS( CSQY_ADJUST( IPHOT ) ) )
               END DO
              RETURN
99951 FORMAT(A9,A16,40(1X,ES12.4))
      END SUBROUTINE DEFINE_CSQY_ADJUST
      REAL FUNCTION QUANTUM_ACETONE( TEMP, DENS_NUMB, LAMBDA )

C-----------------------------------------------------------------------
C Computes acetone quantum yields according to:
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL, INTENT(IN) :: TEMP        ! air temperature, K
      REAL, INTENT(IN) :: DENS_NUMB   ! air number density, 1/cm^3
      REAL, INTENT(IN) :: LAMBDA      ! wavelength, nm

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295  ! 1/K

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL PHI_CO       ! CO branch of IUPAC (2013) acetone QYZ
      REAL PHI_CH3CO    ! CH3CO branch of IUPAC (2013) acetone QYZ
      REAL AA           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL BB           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL CC           ! scratch variable for IUPAC (2013) acetone QYZ

      REAL TEMP_OVER 295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! reciprocal of wavelength, 1E7/nm or 1/cm

      TEMP_OVER 295K  = TEMP * ONE_OVER_295K
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         AA = 0.350 * ( TEMP_OVER 295K )**(-1.28)
         BB = 0.068 * ( TEMP_OVER 295K )**(-2.65)
         A0 = ( AA / ( 1.0 - AA ) ) * EXP( BB * ( LAMBDA - 248.0 ) )
         PHI_CO = 1.0 / ( 1.0 + A0 )

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.600E-19 * ( TEMP_OVER 295K )**(-2.38)
            BB =  0.55E-03 * ( TEMP_OVER 295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 33113.0 ) )
            PHI_CH3CO = ( 1.0 - PHI_CO ) / ( 1.0 + A1*DENS_NUMB )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER 295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER 295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER 295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER 295K )**(-2.93)
            CC = ( 30006.0 )   * ( TEMP_OVER 295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER 295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER 295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            PHI_CH3CO = ( 1.0 - PHI_CO )
     &                * ( 1.0 + A4 * DENS_NUMB + A3 )
     &                / ( ( 1.0 + A2 * DENS_NUMB + A3 )
     &                *   ( 1.0 + A4 * DENS_NUMB ) )
         END IF

         QUANTUM_ACETONE = MAX( 0.0, MIN( 1.0, (PHI_CO+PHI_CH3CO) ) )

      ELSE IF ( LAMBDA .LT. 248.0 .AND. LAMBDA .GT. 0.0 ) THEN ! set QY to 1.0

!***based on IUPAC (2013) data sheet

         QUANTUM_ACETONE = 1.0

      ELSE IF ( LAMBDA .GT. 349.0 ) THEN

         QUANTUM_ACETONE = 0.0

      END IF


      RETURN
      END FUNCTION QUANTUM_ACETONE
      SUBROUTINE QY_ACETONE_CHANNELS( TEMP, DENS_NUMB, LAMBDA, PHI_CO, PHI_CH3CO )

C-----------------------------------------------------------------------
C Computes acetone quantum yields according to:
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL, INTENT(IN)  :: TEMP        ! air temperature, K
      REAL, INTENT(IN)  :: DENS_NUMB   ! air number density, 1/cm^3
      REAL, INTENT(IN)  :: LAMBDA      ! wavelength, nm
      REAL, INTENT(OUT) :: PHI_CO      ! CO branch of IUPAC (2013) acetone QYZ
      REAL, INTENT(OUT) :: PHI_CH3CO   ! CH3CO branch of IUPAC (2013) acetone QYZ

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL AA           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL BB           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL CC           ! scratch variable for IUPAC (2013) acetone QYZ

      REAL TEMP_OVER 295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! reciprocal of wavelength, 1E7/nm or 1/cm

      TEMP_OVER 295K  = TEMP * ONE_OVER_295K
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         AA = 0.350 * ( TEMP_OVER 295K )**(-1.28)
         BB = 0.068 * ( TEMP_OVER 295K )**(-2.65)
         A0 = ( AA / ( 1.0 - AA ) ) * EXP( BB * ( LAMBDA - 248.0 ) )
         PHI_CO = 1.0 / ( 1.0 + A0 )

         PHI_CO = MAX( 0.0, MIN( 1.0, PHI_CO ) )

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.60E-19 * ( TEMP_OVER 295K )**(-2.38)
            BB = 0.55E-03 * ( TEMP_OVER 295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 33113.0 ) )
            PHI_CH3CO = ( 1.0 - PHI_CO ) / ( 1.0 + A1*DENS_NUMB )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER 295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER 295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER 295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER 295K )**(-2.93)
            CC = 30006.0 * ( TEMP_OVER 295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER 295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER 295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 30488.0 ) )

            PHI_CH3CO = ( 1.0 - PHI_CO )
     &                * ( 1.0 + A4 * DENS_NUMB + A3 )
     &                / ( ( 1.0 + A2 * DENS_NUMB + A3 )
     &                *   ( 1.0 + A4 * DENS_NUMB ) )
         END IF

         PHI_CH3CO = MAX( 0.0, MIN( 1.0, PHI_CH3CO ) )

      ELSE IF ( LAMBDA .LT. 248.0 .AND. LAMBDA .GT. 0.0 ) THEN ! set QY to 1.0

!***based on IUPAC (2013) data sheet

         PHI_CO    = 0.45
         PHI_CH3CO = 0.55

      ELSE IF ( LAMBDA .GT. 349.0 ) THEN

         PHI_CO    = 0.0
         PHI_CH3CO = 0.0

      END IF

      RETURN
      END SUBROUTINE QY_ACETONE_CHANNELS
#ifdef preprocessor
      REAL FUNCTION RQY_ACETONE_CH3CO( TEMP, DENS_NUMB, LAMBDA )
#else
      REAL FUNCTION RQY_ACETONE_CH3CO( TEMP, DENS_NUMB, IWAVE )
#endif
C-----------------------------------------------------------------------
C Computes correction to acetone CH3CO quantum yields at (TEMP, DENS_NUMB)  relative to
C quantum yields at (TEMP, DENS_NUMB = 2.46E19) according to:
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL,    INTENT(IN)  :: TEMP        ! air temperature, K
      REAL,    INTENT(IN)  :: DENS_NUMB   ! air number density, molcules/cm^3
#ifdef preprocessor
      REAL,     INTENT(IN) :: LAMBDA      ! wavelength, nm
#else
      INTEGER, INTENT(IN)  :: IWAVE       !  wavelength index
#endif

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K
      REAL, PARAMETER  :: DENS0          = 2.46E19      ! air number at STP, molecules/cm^3

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL PHI_CO       ! CO qy  at (TEMP, DENS_NUMB)
      REAL PHI_CH3CO    ! CH3CO qy at (TEMP, DENS_NUMB)
      REAL PHI_COS      ! CO qy branch at (TEMP, DENS0)
      REAL PHI_CH3COS   ! inverse of CH3CO qy at (TEMP, DENS0)
      REAL AA           ! scratch variable for acetone QY
      REAL BB           ! scratch variable for acetone QY
      REAL CC           ! scratch variable for acetone QY

      REAL TEMP_OVER 295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! wavenumber, 10E7/nm or 1/cm
#ifndef preprocessor
      REAL LAMBDA           ! wavelength, nm

      LAMBDA          = WAVELENGTH( IWAVE )
      ONE_OVER_LAMBDA = WAVENUMBER( IWAVE )
#else
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA
#endif

      TEMP_OVER 295K  = TEMP * ONE_OVER_295K

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.60E-19 * ( TEMP_OVER 295K )**(-2.38)
            BB = 0.55E-03 * ( TEMP_OVER 295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 33113.0 ) )
            RQY_ACETONE_CH3CO = ( 1.0 + A1*DENS0 ) / ( 1.0 + A1*DENS_NUMB )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER 295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER 295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER 295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER 295K )**(-2.93)
            CC = 30006.0 * ( TEMP_OVER 295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER 295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER 295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

!***below qy_ch3co values are normalized by (1 - qy_co) which does not depend on
!***number density
            PHI_CH3CO  = ( 1.0 + A4 * DENS_NUMB + A3 )
     &                 / ( ( 1.0 + A2 * DENS_NUMB + A3 ) * ( 1.0 + A4 * DENS_NUMB ) )

            PHI_CH3COS = ( ( 1.0 + A2 * DENS0 + A3 ) * ( 1.0 + A4 * DENS0 ) )
     &                 / ( 1.0 + A4 * DENS0 + A3 )

            RQY_ACETONE_CH3CO = PHI_CH3CO * PHI_CH3COS

         END IF

      ELSE ! set RQY to 1.0 for 248.0 > LAMBDA or LAMBDA 349.0

         RQY_ACETONE_CH3CO = 1.0

      END IF

      RETURN
      END FUNCTION RQY_ACETONE_CH3CO
#ifdef preprocessor
      REAL FUNCTION RQUANTUM_ACETONE( TEMP, DENS_NUMB, LAMBDA )
#else
      REAL FUNCTION RQUANTUM_ACETONE( TEMP, DENS_NUMB, IWAVE )
#endif


C-----------------------------------------------------------------------
C Computes total acetone quantum yields at (TEMP, DENS_NUMB)  relative to
C quantum yields at (TEMP, DENS_NUMB = 2.46E19) according to
C IUPAC (2013) recommendation based on
C Blitz, M. A., D. E. Heard, M. J. Pilling, S. R. Arnold, and M. P. Chipperfield
C       (2004), Pressure and temperature-dependent quantum yields for the
C       photodissociation of acetone between 279 and 327.5 nm, Geophys.
C       Res. Lett., 31, L06111, doi:10.1029/2003GL018793.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL,    INTENT(IN) :: TEMP        ! air temperature, K
      REAL,    INTENT(IN) :: DENS_NUMB   ! air number density, 1/cm^3
#ifdef preprocessor
      REAL,    INTENT(IN) :: LAMBDA      ! wavelength, nm
#else
      INTEGER, INTENT(IN) :: IWAVE       !  wavelength index
#endif

!***local
      REAL, PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K
      REAL, PARAMETER  :: DENS0          = 2.46E19      ! air number at STP, molecules/cm^3

      REAL A0           ! 1st coef for qy
      REAL A1           ! 2nd coef for qy
      REAL A2           ! 3rd coef for qy
      REAL A3           ! 4th coef for qy
      REAL A4           ! 5th coef for qy

      REAL PHI_CO       ! CO branch of IUPAC (2013) acetone QYZ
      REAL DEL_PHI_CO   ! one minus CO branch of IUPAC (2013) acetone QYZ
      REAL PHI_CH3CO    ! CH3CO branch of IUPAC (2013) acetone QYZ
      REAL PHI_CH3CO0   ! CH3CO branch of IUPAC (2013) acetone QYZ at DENS0
      REAL AA           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL BB           ! scratch variable for IUPAC (2013) acetone QYZ
      REAL CC           ! scratch variable for IUPAC (2013) acetone QYZ

      REAL TEMP_OVER 295K   ! temperature divided by 295 K
      REAL ONE_OVER_LAMBDA  ! reciprocal of wavelength, 1E7/nm or 1/cm
#ifndef preprocessor
      REAL LAMBDA           ! wavelength, nm

      LAMBDA          = WAVELENGTH( IWAVE )
      ONE_OVER_LAMBDA = WAVENUMBER( IWAVE )
#else
      ONE_OVER_LAMBDA = 1.0E7 / LAMBDA
#endif

      TEMP_OVER 295K  = TEMP * ONE_OVER_295K

      IF ( LAMBDA .GE. 248.0 .AND. LAMBDA .LE. 349.0 ) THEN

         AA = 0.350 * ( TEMP_OVER 295K )**(-1.28)
         BB = 0.068 * ( TEMP_OVER 295K )**(-2.65)
         A0 = ( AA / ( 1.0 - AA ) ) * EXP( BB * ( LAMBDA - 248.0 ) )
         PHI_CO     = 1.0 / ( 1.0 + A0 )
         DEL_PHI_CO = MAX(0.0, 1.0 - PHI_CO)

         IF ( LAMBDA .LE. 302.0 ) THEN

!***wavelengths 248-302 nm

            AA = 1.600E-19 * ( TEMP_OVER 295K )**(-2.38)
            BB =  0.55E-03 * ( TEMP_OVER 295K )**(-3.19)
            A1 = AA * EXP( -BB * ( ( ONE_OVER_LAMBDA ) - 33113.0 ) )
            PHI_CH3CO  = DEL_PHI_CO / ( 1.0 + A1*DENS_NUMB )
            PHI_CH3CO0 = DEL_PHI_CO / ( 1.0 + A1*DENS0 )

!***wavelengths 302-349 nm

         ELSE

            AA = 1.62E-17 * ( TEMP_OVER 295K )**(-10.03)
            BB = 1.79E-03  * ( TEMP_OVER 295K )**(-1.364)
            A2 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

            AA = 26.29 * ( TEMP_OVER 295K )**(-6.59)
            BB = 5.72E-7 * ( TEMP_OVER 295K )**(-2.93)
            CC = ( 30006.0 )   * ( TEMP_OVER 295K )**(-0.064)
            A3 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - CC )**2.0 )

            AA = 1.67E-15 * ( TEMP_OVER 295K )**(-7.25)
            BB = 2.08E-03  * ( TEMP_OVER 295K )**(-1.16)
            A4 = AA * EXP( -BB * ( ONE_OVER_LAMBDA - 30488.0 ) )

            PHI_CH3CO = DEL_PHI_CO
     &                * ( 1.0 + A4 * DENS_NUMB + A3 )
     &                / ( ( 1.0 + A2 * DENS_NUMB + A3 )
     &                *   ( 1.0 + A4 * DENS_NUMB ) )

            PHI_CH3CO0 = DEL_PHI_CO
     &                * ( 1.0 + A4 * DENS0 + A3 )
     &                / ( ( 1.0 + A2 * DENS0 + A3 )
     &                *   ( 1.0 + A4 * DENS0 ) )

         END IF

         IF( (PHI_CO + PHI_CH3CO0) .GT. 1.0E-10 )THEN
             RQUANTUM_ACETONE = ( PHI_CO + PHI_CH3CO ) / ( PHI_CO + PHI_CH3CO0 )
         ELSE
             RQUANTUM_ACETONE = 1.0
         END IF

      ELSE

         RQUANTUM_ACETONE = 1.0

      END IF


      RETURN
      END FUNCTION RQUANTUM_ACETONE
#ifdef preprocessor
      REAL FUNCTION RQY_GLYOXAL( TEMP, DENS_NUMB, LAMBDA )
#else
      REAL FUNCTION RQY_GLYOXAL( TEMP, DENS_NUMB, IWAVE )
#endif

!-----------------------------------------------------------------------
! Computes total glyoxal (CHOCHO) quantum yield at (TEMP, DENS_NUMB)
! relative to total yield at (TEMP0, DENS_NUMB = 2.46E19) according to
!  IUPAC (2013) recommendation
!  http://iupac.pole-ether.fr/htdocs/datasheets/pdf/P4_%28CHO%292+hv.pdf
! that is based on
!  Salter, R. J., Blitz, M. A., Heard, D. E., Kovacs, T., Pilling, M. J.,
!  Rickard, A. R. and Seakins, P. W. (2013), Quantum yields for the photolysis
!  of glyoxal below 350 nm and parameterisations for its photolysis rate in
!  the troposphere, Phys. Chem. Chem. Phys., 15, 4984-4994,
!  doi:10.1039/c3cp43597k.
!-----------------------------------------------------------------------

        IMPLICIT NONE

!***arguments
        REAL,  INTENT(IN) :: TEMP        ! air temperature, K
        REAL,  INTENT(IN) :: DENS_NUMB   ! air number density, 1/cm^3
#ifdef preprocessor
      REAL,    INTENT(IN) :: LAMBDA      ! wavelength, nm
#else
      INTEGER, INTENT(IN) :: IWAVE       !  wavelength index
#endif
!***local
        REAL,      PARAMETER  :: ONE_OVER_295K  = 1.0 / 295.0  ! 1/K
        REAL( 8 ), PARAMETER  :: DENS0          = 2.46D19      ! air number at STP, molecules/cm^3

        REAL( 8 ) TEMP_OVER 295K   ! temperature divided by 295 K

        REAL( 8 ) AA           ! scratch variable for qy
        REAL( 8 ) BB           ! scratch variable for qy
        REAL( 8 ) A1           ! 2nd coef for qy
        REAL( 8 ) A2           ! 3rd coef for qy
        REAL( 8 ) A3           ! 4th coef for qy
        REAL( 8 ) WN_OFFSET    ! adjusted wavenumber, 1/cm
        REAL( 8 ) R8_DENS      ! air number density, 1/cm^3

        REAL ONE_OVER_LAMBDA  ! wavenumber, 10E7/nm or 1/cm
        REAL QY_DENS_NUMB     ! total qy at DENS_NUMB
        REAL IQY_DENS0        ! reciprocal of total qy at DENS0
#ifndef preprocessor
        REAL LAMBDA           ! wavelength, nm

        LAMBDA    = WAVELENGTH( IWAVE )
        WN_OFFSET = REAL( WAVENUMBER( IWAVE ) - 23800.0, 8 )
#else
        WN_OFFSET = REAL( 1.0E7 / LAMBDA - 23800.0, 8 )
#endif

        TEMP_OVER 295K  = REAL( TEMP * ONE_OVER_295K, 8 )
        R8_DENS         = REAL( DENS_NUMB, 8 )


         IF( LAMBDA .LT. 460.0 .AND. LAMBDA .GT. 250.0 )THEN
            AA = 6.48D-19 * TEMP_OVER 295K**(-1.83D0)
            BB = 7.60D-04 * TEMP_OVER 295K**(-0.515D0)
            A1 = AA * EXP( -BB * WN_OFFSET )

            AA = 1.128D02 * TEMP_OVER 295K**(-1.53D0)
            BB = 4.61D-03 * TEMP_OVER 295K**(-0.507D0)
            A2 = AA * EXP( -BB * WN_OFFSET  )

            AA = 2.25D-16 * TEMP_OVER 295K**(-9.18D0)
            BB = 7.80D-04 * TEMP_OVER 295K**(-7.03D0)
            A3 = AA * EXP( -BB * WN_OFFSET )

!*** note that values are normalized by total qy at DENS = 0.0 but
!    its values equals 1.0

            IQY_DENS0 = REAL( (1.0D0 + A1*DENS0 + A2) * (1.0D0 + A3*DENS0)
     &                / (1.0D0 + A2 + A3*DENS0 ) )

            QY_DENS_NUMB  = REAL( (1.0D0 + A2 + A3*R8_DENS)
     &                    / ((1.0D0 + A1*R8_DENS + A2)*(1.0D0 + A3*R8_DENS)) )

            RQY_GLYOXAL  = QY_DENS_NUMB * IQY_DENS0

          ELSE

            RQY_GLYOXAL  = 1.0

          END IF

          RETURN
       END FUNCTION RQY_GLYOXAL
      END MODULE CSQY_DATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/plrise/smoke/oppt3d_diag.F,v 1.3 2011/10/21 16:11:31 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPPT3D_DIAG( PT3DNAME, TSTEP, 
     &                        N_SPC, SPEC_NAME, SPEC_UNITS )

C-----------------------------------------------------------------------
 
C  Description:
C    Opens the output 3d point source emissions diagnostic file
 
C  Preconditions:
 
C  Subroutines and Functions Called:
C       I/O API 

C Revision History:
C      4 Sep 2007 J.Young: initial
C     29 Jan 2010 D. Wong: Eliminate potential race condition at the MYPE = 0
C                          to open the diagnostic file. Eliminate the BARRIER
C                          and the CLOSE3 and OPEN3.
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     Aug 2015 D. Wong:    Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
C                            implementation
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE EMIS_VARS, ONLY : EMLAYS

      IMPLICIT NONE
 
C Includes:

C External Functions:

C Local Parameters:

C Arguments:
      CHARACTER( 16 ), INTENT( IN ) :: PT3DNAME ! diagnostic file logical name
      INTEGER,         INTENT( IN ) :: TSTEP    ! time step (HHMMSS)
      INTEGER,         INTENT( IN ) :: N_SPC    ! number of point source surrogates
      CHARACTER( 16 ), INTENT( IN ) :: SPEC_NAME( N_SPC )  ! species names
      CHARACTER( 16 ), INTENT( IN ) :: SPEC_UNITS( N_SPC ) ! units

C Local variables:

      INTEGER L, V, IOS
      CHARACTER( 256 ) :: XMSG      ! buffer for M3EXIT() messages
      CHARACTER( 256 ) :: RET_VAL   ! env var returned value
      CHARACTER(  16 ) :: PNAME = 'OPPT3DDIAG'   ! procedure name

C-----------------------------------------------------------------------

C Set output file characteristics based on GRID_CONF module and open the 3D emis file

      FTYPE3D = GRDDED3
      SDATE3D = STDATE
      STIME3D = STTIME
      TSTEP3D = TSTEP
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = EMLAYS
      NTHIK3D = 1
      NVARS3D = N_SPC
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN

      DO L = 1, NLAYS3D + 1
         VGLVS3D( L ) = VGLVS_GD( L )
      END DO

      VNAME3D = ' '     ! array
      DO V = 1, N_SPC
         VNAME3D( V ) = SPEC_NAME( V )
      END DO

      VTYPE3D = 0       ! array
      VTYPE3D( 1:NVARS3D ) = M3REAL

      UNITS3D = ' '     ! array
      DO V = 1, N_SPC
         UNITS3D( V ) = SPEC_UNITS( V )
      END DO

      VDESC3D = ' '     ! array
      DO V = 1, N_SPC
         VDESC3D( V ) = 'Model species: ' // TRIM( SPEC_NAME( V ) )
      END DO

      FDESC3D = ' '  ! array
      FDESC3D( 1 ) = 'gridded hourly point source layered emissions'
      FDESC3D( 2 ) = '/From/ ' // PNAME
      FDESC3D( 3 ) = '/Version/ Inline'

C create header

      IF ( IO_PE_INCLUSIVE ) THEN   ! open new
         IF ( .NOT. OPEN3( PT3DNAME, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not open ' // TRIM( PT3DNAME )
            CALL M3EXIT( PNAME, STDATE, STTIME, XMSG, XSTAT1 )
         END IF
      END IF

      RETURN

      END SUBROUTINE OPPT3D_DIAG

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPCONC ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Create the IO/API netCDF header and open the output CONC file

C Revision history:
C   Jeff - Dec 00 - split out from initscen.F
C                 - move CGRID_MAP into f90 module
C   Jeff - Feb 01 - assumed shape arrays
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C
C    3 Sep 01 David Wong
C     -- let PE 0 open CTM_CONC_1 as new and later on let the rest open
C        it for read and write
C     -- put an explicit barrier before opening a new netCDF file to avoid
C        NCOPEN error
C    7 May 03 J.Young: open and close conc file in processor 0; spin-wait to
C                      deal with nfs network latency for mpich cluster
C   28 Aug 03 J.Young: following Zion Wang at CERT, remove the spin-wait and
C                      simplify opening and closing CONC file (see initscen)
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   30 May 05 J.Young: optional save derived vert. vel. to conc file
C   21 Jan 06 J.Young: add subset non-reactives capability with NR_CONC.EXT
C                      and subset layers saved to conc file; no longer save
C                      RHOJ to conc file
C   22 Aug 06 J.Young: enable capturing IC's as 0 timestep
C   11 Jun 08 J.Young: clean up
C   30 Mar 10 David Wong: removed unnecessary barrier
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   Aug 15 D.Wong:     Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
C                        implementation
C                      Added a block of code to let non I/O processor to open
C                        CTM_CONC_1 file
C   Dec 15 D.Wong:     Removed all the data writing parts and moved it into a
C                      new file, wr_init.F
C   Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE WVEL_DEFN             ! derived vertical velocity component
      USE STD_CONC              ! standard CONC
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      INTEGER      JDATE        ! starting date (YYYYDDD)
      INTEGER      JTIME        ! starting time (HHMMSS)
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'OPCONC'
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 28 ) :: SSTR = ' species saved to CONC file:'

C environment variable for no. of layers from bottom to save on CONC file
      CHARACTER( 16 ) :: NLAYS_CONC = 'NLAYS_CONC'

C  environment variable description
      CHARACTER( 80 ) :: VARDESC

      INTEGER      K, KD, L, SPC, V, VAR   ! loop counters
      INTEGER      STRT, FINI         ! loop counters
      INTEGER      INDX

      LOGICAL, EXTERNAL :: FLUSH3

C-----------------------------------------------------------------------

C Set output file characteristics based on COORD.EXT and open it

      FTYPE3D = GRDDED3
      SDATE3D = JDATE
      STIME3D = JTIME
      TSTEP3D = TSTEP
      NVARS3D = N_CONC_VARS
      NCOLS3D = GL_NCOLS
      NROWS3D = GL_NROWS
      NLAYS3D = C_NLAYS
      NTHIK3D = 1
      GDTYP3D = GDTYP_GD
      P_ALP3D = P_ALP_GD
      P_BET3D = P_BET_GD 
      P_GAM3D = P_GAM_GD
      XORIG3D = XORIG_GD
      YORIG3D = YORIG_GD
      XCENT3D = XCENT_GD
      YCENT3D = YCENT_GD
      XCELL3D = XCELL_GD
      YCELL3D = YCELL_GD
      VGTYP3D = VGTYP_GD
      VGTOP3D = VGTOP_GD
!     VGTPUN3D = VGTPUN_GD ! currently, not defined
      DO L = 1, NLAYS3D + 1
         VGLVS3D( L ) = VGLVS_GD( L )
      END DO
      GDNAM3D = GRID_NAME  ! from HGRD_DEFN

      FDESC3D( 1 ) = 'Concentration file output'
      FDESC3D( 2 ) = 'From CMAQ model dyn alloc version CTM'
      FDESC3D( 3 ) = 'Set of variables (possibly) reduced from CGRID'
      FDESC3D( 4 ) = 'For next scenario continuation runs,'
      FDESC3D( 5 ) = 'use the "one-step" CGRID file'
      KD = 5
      V = CONC_BLEV
      L = 0
      DO K = KD + 1, MIN ( C_NLAYS + KD, MXDESC3 )
         L = L + 1
         WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &   V + L - 1, L
      END DO
      IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
         DO K = KD + 1 + L, MXDESC3
            FDESC3D( K ) = ' '
         END DO
      END IF

      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) '    Conc File Header Description:'
      DO K = 1, KD + L
         WRITE( LOGDEV,* ) '       ', TRIM( FDESC3D( K ) )
      END DO

      V = 0
      STRT = 1
      FINI = N_C_GC_SPC
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_GC_SPC( V )
         UNITS3D( SPC ) = 'ppmV'
         VDESC3D( SPC ) = 'Instantaneous Molar Mixing Ratio ' // VNAME3D( SPC )
      END DO

      V = 0
      STRT = FINI + 1
      FINI = FINI + N_C_AE_SPC
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_AE_SPC( V )   ! from STD_CONC module
         IF ( VNAME3D( SPC )(1:3) .EQ. 'NUM' ) THEN
            UNITS3D( SPC ) = 'm-3'
         ELSE IF ( VNAME3D( SPC )(1:3) .EQ. 'SRF' ) THEN
            UNITS3D( SPC ) = 'm2 m-3'
         ELSE
            UNITS3D( SPC ) = 'ug m-3'
         END IF
         VDESC3D( SPC ) = 'Instantaneous Aerosol Concentration of ' // VNAME3D( SPC )
      END DO

      V = 0
      STRT = FINI + 1
      FINI = FINI + N_C_NR_SPC
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_NR_SPC( V )   ! from STD_CONC module
         UNITS3D( SPC ) = 'ppmV'
         VDESC3D( SPC ) = 'Instantaneous molar mixing ratio of ' // VNAME3D( SPC )
      END DO

      V = 0
      STRT = FINI + 1
      FINI = FINI + N_C_TR_SPC ! write all TR species
      DO SPC = STRT, FINI
         V = V + 1
         VTYPE3D( SPC ) = M3REAL
         VNAME3D( SPC ) = C_TR_SPC( V )   ! from STD_CONC module
         UNITS3D( SPC ) = 'ppmV'
         VDESC3D( SPC ) = 'Instantaneous molar mixing ratio of ' // VNAME3D( SPC )
      END DO

      VAR = FINI
      IF ( W_VEL ) THEN   ! for vertical velocity from advection
         VAR = VAR + 1
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'W_VEL'
         UNITS3D( VAR ) = 'm s-1'
         VDESC3D( VAR ) = 'Derived vertical velocity component'
      END IF
 
      IF ( L_CONC_RH ) THEN   ! for Relative Humidity
         VAR = VAR + 1 
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'RH'
         UNITS3D( VAR ) = '1'
         VDESC3D( VAR ) = 'Fractional Relative Humidity'
      END IF
    
      IF ( L_CONC_TA ) THEN   ! for Temperature
         VAR = VAR + 1 
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'TA'
         UNITS3D( VAR ) = 'K'
         VDESC3D( VAR ) = 'Air Temperature'
      END IF
    
      IF ( L_CONC_PRES ) THEN   ! for Pressure
         VAR = VAR + 1 
         VTYPE3D( VAR ) = M3REAL
         VNAME3D( VAR ) = 'PRES'
         UNITS3D( VAR ) = 'Pa'
         VDESC3D( VAR ) = 'Air Pressure'
      END IF

C create header

      IF ( IO_PE_INCLUSIVE ) THEN   ! open new

         IF ( .NOT. OPEN3( CTM_CONC_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not open ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( .NOT. FLUSH3 ( CTM_CONC_1 ) ) THEN
            XMSG = 'Could not sync to disk ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

      END IF

      END SUBROUTINE OPCONC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_modules.f,v 1.1 2004/03/26 16:16:47 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   to provide an interface between the stencil exchange library and the
C application code
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C                    02/27/01 by David Wong
C                      -- include two use statements: use se_term_module and
C                         use se_reconfig_grid_module
C                    11/27/01 by David Wong
C                      -- include a new module: se_bndy_copy_module
C                    08/24/11 by David Wong
C                      -- include a new module: se_twoway_comm_module for
C                         the WRF-CMAQ twoway model
C --------------------------------------------------------------------------

        module se_modules

          use se_init_module
          use se_term_module

          use se_util_module

          use se_comm_module
          use se_slice_module
          use se_data_copy_module
          use se_gather_module

          use se_reconfig_grid_module

          use se_bndy_copy_module

          use se_global_max_module
          use se_global_min_module
          use se_global_sum_module

          use se_twoway_comm_module

        end module se_modules

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/emis/emis/tfbelow.F,v 1.3 2011/10/21 16:10:48 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine tfbelow ( jdate, jtime, tfb )

C-----------------------------------------------------------------------
C Description:
C   Extracts selected landuse types from BELD01 and BELD03 and merges
C   the selections into a dust-related landuse array (ULAND).
C   Optionally, reads 3 gridded crop calendar file and calculates an
C   erodible agriculture land fraction.
C   Applies a predetermined removal fraction in and below canopy to
C   ULAND and determines a transport factor (TFB) for this regime.
 
C Subroutines and Functions Called:
C      OPEN3, INTERPX, XTRACT3, M3EXIT

C Revison History:
C  Jun 2009 D. Tong
C  Jan 2011 J. Young: mods for inline wind-blown dust module
C  Apr 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  Jul 2011 J.Young: pad vnmld for uniform string lengths
C  Oct 2018 D. Wong: With new re-structure of LUS_DEFN, most of the data
C                    declaration has been moved to lus_data_module
C  Feb 2019 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      use hgrd_defn                     ! horizontal domain specifications
      use lus_data_module, only: uland  ! land use/cover schema definitions
                                        ! uland in %
      use utilio_defn

      implicit none

C Includes:

C Arguments:
      integer, intent( in )  :: jdate      ! current model date, coded YYYYDDD
      integer, intent( in )  :: jtime      ! current model time, coded HHMMSS
      real,    intent( out ) :: tfb( :,: ) ! dust transport factor from
                                           ! flow into canopy
 
      character(  16 ) :: pname = 'TFBELOW'
      character( 128 ) :: xmsg = ' '

      real              :: ufc  ! total weighted removal fraction for each cell

      integer i, c, r

      real   :: fr( 4 ) = ! removal fraction in and below canopy
     &         (/ 0.0,    ! water
     &            0.10,   ! grass&crop
     &            0.50,   ! building
     &            0.95 /) ! forest

      do r = 1, nrows
      do c = 1, ncols

         ufc = 0.0
         do i = 1, 4
            ufc = ufc + fr( i ) * uland( c,r,i )
         end do
         tfb( c,r ) = 1.0 - ufc * 0.01

         if ( tfb( c,r ) .gt. 1.0 .or. tfb( c,r ) .lt. 0.0 ) then
            write( xmsg,'( a, e10.3, a, 2i4 )' ) '*** Transport factor error: ',
     &            tfb( c,r ), ' At col, row: ', c, r 
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

      end do   ! ncols
      end do   ! nrows

      return
      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE FLCHECK ( STDATE, STTIME, TSTEP )

C-----------------------------------------------------------------------
C Function: To check file header data for consistency with COORD.EXT
C            and runlength; only gridded and boundary files are checked.
 
C Preconditions: None
 
C Key Subroutines/Functions Called:
 
C Revision History: Prototype created by Jerry Gipson, September, 1997
C                   Modified Jun, 1998 by Jerry Gipson to remove PING
C                   and MEPSE files from being checked
C                   Jeff - Nov 2000 - ck only input files for start date/time
C   30 Mar 01 J.Young: elim reference to grid
C    6 Jul 10 J.Young: minor mods - F90-ize
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   11 Apr 16 D.Wong: formulated a robust way to handle a situation when
C                     ACONC file with STIME3 = starting time of the simulation,
C                     and the file is emtpy and requires to go through CHECK3
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RUNTIME_VARS, ONLY : LOG_HEADING, LOG_SUBHEADING, LOG_MESSAGE,
     &                         RUNLEN, FL_ERR_STOP, LOGDEV

      IMPLICIT NONE 

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      
C Arguments:
      INTEGER, INTENT( IN ) :: STDATE   ! Current date (YYYYDDD)
      INTEGER, INTENT( IN ) :: STTIME   ! Current time (HHMMSS)
      INTEGER, INTENT( IN ) :: TSTEP    ! Current time step (HHMMSS)

C Parameters: None

C External Functions: None

C Saved Local Variables: None
      
C Local Variables:
      CHARACTER( 80 ) :: MSG                ! Message buffer
      CHARACTER( 16 ) :: PNAME = 'FLCHECK'  ! Procedure name
      
      INTEGER JDATE     ! Time step date (YYYYDDD)
      INTEGER JTIME     ! Time step time (HHMMSS)
      INTEGER N         ! Loop index
      INTEGER STATUS    ! Status of returned value

      LOGICAL LERROR    ! Flag to indicate error for 1 or more files
      LOGICAL LOK       ! Flag to indicate error for 1 file

      CHARACTER( 500 )  :: FNAME
      INTEGER           :: LSTAT
      LOGICAL           :: ESTAT

C-----------------------------------------------------------------------

      CALL LOG_HEADING( LOGDEV, 'Check Input File Headers' )

      LERROR = .FALSE.

      DO N = 1, N_FILES      

         ! Detect whether or not this filename logical has been set in the run
         ! script
         CALL GET_ENVIRONMENT_VARIABLE( NAME = LGCL_NAME( N ), 
     &            VALUE = FNAME, STATUS = LSTAT )

         ! Check to see if this file already exists
         INQUIRE( FILE = TRIM( FNAME ), EXIST = ESTAT )
         
         ! skip checking files that were not set in the run script or do 
         ! not exist 
         IF ( LSTAT .LE. 0 .AND. ESTAT ) THEN

            LOK = OPEN3( LGCL_NAME( N ), FSREAD3, PNAME )

            IF ( LOK ) THEN

               IF ( DESC3( LGCL_NAME( N ) ) ) THEN
     
                  ! only check gridded or boundary files
                  IF ( FTYPE3D .EQ. GRDDED3 .OR. FTYPE3D .EQ. BNDARY3 ) THEN

                     MSG = 'Checking header data for file: ' // LGCL_NAME( N )
                     CALL M3MESG( MSG )

                     CALL GRDCHECK ( LGCL_NAME( N ), LOK )

                     ! check time steps for time dependent files
                     IF ( TSTEP3D .GT. 0 ) THEN
                        JDATE = STDATE
                        JTIME = STTIME

                        IF ( .NOT. CHECK3( LGCL_NAME( N ), ALLVAR3,
     &                                     JDATE, JTIME ) ) THEN
                           LOK = .FALSE.
                           MSG = 'Starting time not on file'
                           CALL M3MESG( MSG )
                        END IF
 
                        ! skip checking ending time for output files
                        IF ( IN_MODE( N ) ) THEN
                           CALL NEXTIME ( JDATE, JTIME, RUNLEN )
                           IF ( .NOT. CHECK3( LGCL_NAME( N ), ALLVAR3,
     &                                        JDATE, JTIME ) ) THEN
                              LOK = .FALSE.
                              MSG = 'Ending time not on file'
                              CALL M3MESG( MSG )
                           END IF
                        END IF

                     END IF   ! if TSTEP3D .GT. 0

                     IF ( .NOT. LOK ) LERROR = .TRUE.

                  END IF   ! only check gridded or boundary files

               ELSE

                  LOK = .FALSE.
                  MSG = 'DESC3 failed for ' // LGCL_NAME( N )
                  CALL M3MESG( MSG )

               END IF   ! DESC3 successful

            END IF   ! successful open

         END IF  ! skip files not set in run script or that don't exist

      END DO

      IF ( LERROR ) THEN
         MSG = 'Inconsistent header data on input files'
         IF ( FL_ERR_STOP ) THEN       
            CALL M3EXIT ( PNAME, STDATE, STTIME, MSG, XSTAT2 )
         ELSE
            CALL M3WARN ( PNAME, STDATE, STTIME, MSG )
            RETURN
         END IF
      ELSE
         CALL LOG_MESSAGE( LOGDEV, 'No inconsistent header data found on input files' )
         WRITE( LOGDEV, * )
      END IF

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/aero/aero5/AEROMET_DATA.F,v 1.6 2012/01/19 13:10:03 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module aeromet_data

C Some parameters and meteorological variables required in aerosol
C processing.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SH  03/10/11 renamed file and module from MET_DATA to AEROMET_DATA
C----------------------------------------------------------------------

      Implicit None

C Fundamental constants
      Include SUBST_CONST    ! common constants

      Real( 8 ), Parameter :: f6dpi = 6.0D0 / dpi
      Real,      Parameter :: f6pi = 6.0 / pi
      Real( 8 ), Parameter :: dpi6 = dpi / 6.0D0
      Real,      Parameter :: pi6 = pi / 6.0
      Real( 8 ), Parameter :: boltzmann = drgasuniv / davo  ! [ J/K ]

C Concentration lower limit used for gas species
      Real,      Parameter :: min_gasconc = 1.0E-30        ! [ ug/m^3 ]
      Real,      Parameter :: inv_mwair   = 1.0E3 / mwair  ! [ 1/g ]

C Meteorological variables (data from MET_CRO_3D file)
      Real :: airtemp      ! air temp [ K ]
      Real :: airpres      ! air pressure [ Pa]
      Real :: airdens      ! air density [ kg/m^3]
      Real :: airRH        ! fractional relative humidity
      Real :: airQV        ! water vapor mass mixing ratio [ kg_H2O/kg_air ]
      Real :: H2OsatVP     ! saturation water vapor pressure [ Pa ]
      Real :: H2OVP        ! ambient water vapor pressure [ Pa ]

      End Module aeromet_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETALPHA ( NUMI, MASSI, SURFI,
     &                      LWC, T, P, RHOAIR, ALFA0, ALFA2, ALFA3 )

C-----------------------------------------------------------------------
C  Description:
C    Calculate the in-cloud scavenging coefficients for number (alfa0),
C    surface area (alfa2) and mass (alfa3). This code combines the RPM
C    codes getcld.f, and pandkcd.f
 
C  Revision History:
C      Date       Who                      What
C    -------- -------------------------  -------------------------------
C    12/16/97 Dr. Francis S. Binkowski.  Coded
C    12/22/97 S.Roselle                  Revised to comply with M3 Coding
C                                           standards
C    02/10/99 Binkowski                  Added provision for 2nd moment
C                                           and variable geometric
C                                           standard deviation
C    09/25/00 S.Roselle                  Modified to enable backwards
C                                           compatibility with aerosol
C                                           model version 1
C    08/23/2005  Binkowski               Changed check on MASSI to
C                                           be 1.0e-6 [ug/M**3] rather than
C                                           to avoid difficulties causing NAN's
C                                           as found by Bonyoung Koo
C                                           I have also commented out some lines 
C                                           code that are unnecessary in this 
C                                           implementation
C-----------------------------------------------------------------------

      USE AERO_DATA

      IMPLICIT NONE

      INCLUDE SUBST_CONST   ! PI, RGASUNIV, AVO, GRAV

C...........Parameters:

      REAL, PARAMETER :: SIGC = 1.2     ! geometric standard deviation for cloud droplets

      REAL, PARAMETER :: P0 = 101325.0  ! Standard pressure [ Pa ]

      REAL, PARAMETER :: T0 = 288.0

      REAL, PARAMETER :: ONE3 = 1.0 / 3.0

      REAL, PARAMETER :: TWO3 = 2.0 / 3.0

      REAL, PARAMETER :: KBOLTZ = RGASUNIV / AVO    ! 1.38065E-23 [ J/K ]

      REAL, PARAMETER :: RHOPART = 1.0E3   ! particle density [ kg/ m**3 ]

!sjr  REAL, PARAMETER :: AERCONST = 6.0E-9 / ( RHOPART * PI / 6.0 )
      REAL, PARAMETER :: AERCONST = 1.0E-9 / ( RHOPART * PI / 6.0 )

      REAL, PARAMETER :: RHO_WATER = 1.0E3 ! density of water at 20 C & 1 ATM [ kg/m**3 ]

C...........Arguments:

      REAL          NUMI       ! total number concentration for the Aitken mode [ #/m**3 ]
      REAL          MASSI      ! total mass concentration in AItken mode [ ug/m**3 ]
      REAL          SURFI      ! total surface area in Aitken mode [ m**2 / m**3 ]
      REAL          LWC        ! cloud liquid water content [ kg/m**3 ]
      REAL          T          ! average cloud temperature [ K ]
      REAL          P          ! average cloud pressure [ Pa ]
      REAL          RHOAIR     ! average cloud density [ kg/m**3 ]
      REAL          ALFA0      ! scavenging coefficient for number [ 1/s ]
      REAL          ALFA2      ! scavenging coefficient for surface area [ 1/s ]
      REAL          ALFA3      ! scavenging coefficient for mass [ 1/s ]

C...........Local Variables (scalars):

      REAL          DGNI       ! geometric mean diameter for AItken mode [ m ]
      REAL          L2SGI      ! square of the log of the
                               ! Aitken mode geometric standard deviation
!     REAL          XXFN       ! fraction for computing L2SGI

c *** ranges for acceptable values of LOG( sigma_g).

      REAL, SAVE   :: MINL2SG  ! minimum value of L2SG
      REAL, SAVE   :: MAXL2SG  ! maximum value of L2SG
      REAL, SAVE   :: DEFL2SG  ! default value of L2SG if no surface area

      REAL          NC         ! total cloud droplet number concentration  [ #/m**3 ]
      REAL          DGC        ! geometric mean diameter for cloud droplet [ m ]
      REAL          ESG4       ! exp(0.5 * L2SGI )
      REAL          ESG16      ! exp(2.0 * L2SGI )
      REAL          ESG36      ! exp(4.5 * L2SGI )
      REAL          DG2        ! square of geometic mean diameter
      REAL          AMM2       ! -2nd moment of the Aitken mode distribution
      REAL          AMM1       ! -1st moment of the Aitken mode distribution
      REAL          AM1        ! 1st moment of the Aitken mode distribution
      REAL          AM0        ! alternative name for Aitken mode number  [ #/m**3]
      REAL          AM2        ! 2nd moment of the Aitken mode distribution
      REAL          AM3        ! 3rd moment of the Aitken mode distribution
      REAL          M0C        ! moments of the cloud droplet distribution
      REAL          M1C        ! moments of the cloud droplet distribution
      REAL          M2C        ! moments of the cloud droplet distribution

      REAL          LSGC, LSGC2  ! log and square of log of SIGC
      REAL, SAVE :: ESGC4      !
      REAL, SAVE :: ESGC16     !

      REAL          COEF       !
      !REAL          DIFF0      ! aerosol diffusivities
      !REAL          DIFF2      ! aerosol diffusivities
      REAL          DIFF3      ! aerosol diffusivities
      !REAL          PE0        ! Peclet numbers
      !REAL          PE2        ! Peclet numers
      REAL          PE3        ! Peclet numbers
      REAL          COEF2      !
      REAL          COEF3      !
      REAL          COEF4      !
      REAL          VSETTL     ! settling velocity for cloud drops
      REAL          LAMDA      ! mean free path of air [ m ]
      REAL          MU         ! dynamic viscosity [ kg/(m*s) ]
      REAL          NU         ! kinematic viscosity [ m**2/s ]

      REAL          CUBRT      ! cube root
      REAL          XX         ! dummy arguement for cube root

      REAL, SAVE :: CLCONST    !

      LOGICAL, SAVE :: FIRSTIME = .TRUE.   ! flag for first pass thru

C...........Statement Functions:

      CUBRT( XX ) = EXP( ONE3 * LOG( XX ) )

C-----------------------------------------------------------------------
C     begin body of subroutine GETALPHA

      IF ( FIRSTIME ) THEN
        FIRSTIME = .FALSE.

C...compute special variables for moments
C...  of cloud droplet distribution

        LSGC   = LOG( SIGC )
        LSGC2  = LSGC * LSGC
        ESGC4  = EXP( 0.5 * LSGC2 )
        ESGC16 = EXP( 2.0 * LSGC2 )

C...compute constant for obtaining dgc

        CLCONST = 6.0 / ( RHO_WATER * PI * EXP( 4.5 * LOG( SIGC ) ** 2 ) )

        MINL2SG = LOG( MIN_SIGMA_G ) ** 2.0        ! minimum sigma_g = 1.05 (2.380480e-3)
        MAXL2SG = LOG( MAX_SIGMA_G ) ** 2.0        ! maximum sigma_g = 2.5  (8.395887e-1)
        DEFL2SG = LOG( DEF_SIGMA_G( 1 ) ) ** 2.0   ! default sigma_g = 1.7  (2.815663e-1)

      END IF ! check on firstime

C...check to make sure that there is aerosol mass and number before
C... proceeding, if not set alphas to zero

!cc FSB      IF ( ( NUMI .LE. 0.0 ) .OR. ( MASSI .LE. 0.0 ) .OR.
!cc FSB    &     ( LWC  .LE. 0.0 ) ) THEN

C FSB mass check changed to be 1.0e-6 [ug/m**3] - 08/23/2005
C     to avoid AM3 becomming too small.  With this change
C     AM3 is no smaller than 1.0e-18

      IF ( ( NUMI .LE. 0.0 ) .OR. ( MASSI .LE. 1.0e-6 ) .OR.
     &     ( LWC  .LE. 0.0 ) ) THEN
!cc     &     ( SURFI .LE. 0.0 ) .OR. ( LWC  .LE. 0.0 ) ) THEN
        ALFA0 = 0.0
        ALFA2 = 0.0
        ALFA3 = 0.0
        RETURN
      END IF

C...get cloud characteristics
C...  reference: Bower, K.N. and T.W. Choularton, 1992,
C...  " A parameterisation of the effective radius of ice
C...  free clouds for use in global climate models"
C...  Atmospheric Research, 27, 305-339, figures 10 & 11.
C...
C...  data in Bower & Choularton fit with quadratic function
C...  for droplet number as a function of lwc

C...calculate the total number concentration of cloud droplets.

      IF ( LWC .LE. 3.0E-3 ) THEN
        NC = 4.80E11 * LWC - 8.0E13 * LWC * LWC
      ELSE
        NC = 7.20E8
      END IF

C...calculate dgc

      DGC =  CUBRT( CLCONST * LWC / NC )

C...get m0c cloud droplet number and 1st and 2nd moments
C...  of cloud droplet distribution

      M0C = NC
      M1C = M0C * DGC * ESGC4
      M2C = M0C * DGC * DGC * ESGC16

C...set values for the 0th and 3rd moments

      AM3   = AERCONST * MASSI
      AM0   = NUMI

C...Check to see if surface area exists and process accordingly

      IF ( SURFI .GT. 0.0 ) THEN

C...set the 2nd moment value

        AM2   = SURFI / PI

C...get square of the log of the geometric standard deviation L2SGI
C...  The following method is much more robust, even if it uses three log calls.

        L2SGI = ONE3 * LOG( AM0 ) +
     &          TWO3 * LOG( AM3 ) -
     &                 LOG( AM2 )

        L2SGI = MAX( MINL2SG, L2SGI )
        L2SGI = MIN( MAXL2SG, L2SGI )

      ELSE

C...set the standard deviation to a fixed value (e.g. 1.7)

        L2SGI = DEFL2SG

C...calculate the 2nd moment based on the fixed standard deviation

        AM2 = EXP( TWO3 * LOG( AM3 ) +
     &             ONE3 * LOG( AM0 ) -
     &             L2SGI )

      END IF

C...compute special variables for moments
C...  of Aitken mode distribution

      ESG4  = EXP( 0.5 * L2SGI )
      ESG16 = EXP( 2.0 * L2SGI )
      ESG36 = ESG4 * ESG16 * ESG16

C...calculate dgni from numi and m3i

      DGNI = CUBRT( AM3 / ( AM0 * ESG36 ) )
      DG2  = DGNI  * DGNI

C...now get other aerosol moments

      AMM2  = AM0  * ESG16 / DG2
      AMM1  = AM0  * ESG4  / DGNI
      AM1   = AM0  * DGNI  * ESG4

C...calculate:
C...  lamda     mean free path of air [ m ]
C...  mu        dynamic viscosity [ kg/(m*s) ]
C...  nu        kinematic viscosity [ m**2/s ]

      MU = 1.458E-6 * T * SQRT( T ) / ( T + 110.4 )
      LAMDA = 6.6328E-8 * ( P0 / P ) * ( T / T0 )
      NU = MU / RHOAIR

C...implement Pruppacher and Klett method for scavenging coefficients
C...  calculates scavenging coefficients for number and mass
C...  of interstitial aerosol with a variable sigma_g.
C...  this method uses Brownian diffusion with convective enhancement.
C...  reference:
C...      Pruppacher & Klett "Microphysics of Clouds & Precipitation"
C...                             pp 380 - 384, 1978, D. Reidel

      COEF = KBOLTZ * ( T / ( 3.0 * PI * MU ) )

C...get aerosol diffusivities

!cc FSB these values are not used
!cc      DIFF0 = COEF * ( AMM1 + 2.492 * LAMDA * AMM2 ) / AM0
!cc      DIFF2 = COEF * ( AM1  + 2.492 * LAMDA * AM0  ) / AM2
      DIFF3 = COEF * ( ( AM2  + 2.492 * LAMDA * AM1  ) / AM3 )

C...set up coefficient coef2 for settling velocity of cloud drops

      COEF2 = ( GRAV / ( 18.0 * NU ) ) * ( RHOPART / RHOAIR )

C...get settling velocity for cloud drops

      VSETTL = COEF2 * M2C / M0C

C...set up for Peclet numbers

      COEF3 = VSETTL * DGC

C...calculate Peclet numbers

!cc FSB because these Peclet numbers are not used, I have commented 
!cc     these lines of code - Binkowski 08/23/2005
!cc      PE0 = COEF3 / DIFF0
!cc      PE2 = COEF3 / DIFF2
      PE3 = COEF3 / DIFF3

C...now get in-cloud scavenging coefficients
C...  including convective enhancement

      COEF4  = 2.0 * PI * M1C

!cc FSB use a common value, that for 3rd moment.
!cc
!cc      ALFA0 = COEF4 * DIFF0 * ( 1.0 + 0.5 * CUBRT( PE0 ) )
!cc      ALFA2 = COEF4 * DIFF2 * ( 1.0 + 0.5 * CUBRT( PE2 ) )
      ALFA3 = COEF4 * DIFF3 * ( 1.0 + 0.5 * CUBRT( PE3 ) )
      ALFA0 = ALFA3
      ALFA2 = ALFA3

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE HGSIM

C-----------------------------------------------------------------------
C Function: This module contains the code to predict bidirectional
C          exchanges between the atmosphere and surface media using a two
C          layer resistance-capacitance model. Fluxes are parameterized by
C          applying Fick's law  across the atmospheric surface media
C          concentration gradient.
C
C Revision History:
C      12 Aug  2008  J. Bash initial implementation
C       2 Apr  2009  J. Bash for solar irradation on the order of 1e-3 w/m2
C                           the mercury surface water photo redox scheme
C                           became unstable. A conditional statement was
C                           added to correct this instability.
C       4 June 2009 J. Bash Corrected the time stamp on WRASX_MEDIA to be
C                           consistant with other CMAQ modules reported by
C                          (T.Myers)
C     22 Oct   2009 J. Bash Corrected a units conversion error in ASWX and ATX
C                           reported by (P. Pongprueksa) and added a more
C                           robust soil diffusion model adapted from the
C                           Community Land Model 3.5.
C     13 Sept 2011  J. Bash Updated the Hg bidi model to share data with the 
C                           NH3 bidirectional exchange model in a more general
C                           framework using BIDI_MOD.F and LSM_MOD.F modules. 
C                           Hg bidirectional exchange is now a run time option. 
C     17 Jan  2012  J. Bash Removed the dependence on the LAPACK libraries
C                           and found analytical solutions to all the Hg
C                           exchange equations.
C     14 Feb 2013   J. Bash Added support for the NLCD 40 (2006) land use data
C     15 Oct 2018   D. wong Moved INIT_MEDC_1 data extraction code to centralized_io_module.F
C     01 Feb 2019 David Wong: Implemented centralized I/O approach, removed all MY_N clauses
C
C  References:
C
C  Bash, J.O. 2010, Description and initial simulaiton of a dynamic bi-directional 
C     surface exchange model for mercury in CMAQ, J. Geophys.
C     Res., 115, D06305
C  Mason, R.P., J.R. Reinfelder, F.M.M. Morel, 1996, Uptake, toxicity, and
C     trophic transfer of mercury in a coastal diatom, Environ. Sci. Technol.
C     30, 1835-1845
C  Scholtz, M.T., B.J. Van Heyst, W.H. Schroeder, 2003, Modelling of mercury
C     emissions from background soils, Sci. Tot. Environ. 304, 185-207
C  Trapp S. and Matthies, 1995, Generic one-compartment model for uptake of
C     organic chemicals by foliar vegetations. Environ. Sci. Technol. 29,
C     2333-2338
C  Trapp, S., 2004, Plant uptake and transport for netural and ionic chemicals,
C     Environ. Sci. Pollut. Res. 11, 33-39
C  Whalin, L., E.-H. Kim, R. Mason, 2007, Factors influencing the oxidation,
C     reduciton, methylation and demethylation of mercury species in costal
C     water, Marine Chem. 107, 278-294
C-----------------------------------------------------------------------
      IMPLICIT NONE

!    Shared variables

!     Private variables used in this routine and
      REAL(8), ALLOCATABLE,       PRIVATE :: HgLU_Fac(:)
      REAL(8), ALLOCATABLE, SAVE, PRIVATE :: fevgrn(:,:)  ! fraction of evergreen land use

      REAL(8), PARAMETER, PRIVATE :: zsurf  = 1d+0 ! ocean slab depth (m)
      REAL(8), PARAMETER, PRIVATE :: ZG = 5d-2

      CHARACTER( 96 ), PRIVATE :: XMSG = ' '
      CHARACTER( 80 ), SAVE, Private   :: LAND_SCHEME

! variable needed for analytical solutions of exchange equations
      REAL(8), ALLOCATABLE, PRIVATE :: KO(:,:)
      REAL(8), ALLOCATABLE, PRIVATE :: EIVAL(:)
      REAL(8), ALLOCATABLE, PRIVATE :: VR(:,:)
      REAL(8), PRIVATE :: ax     ! coefficients used of the  
      REAL(8), PRIVATE :: bx     ! quadratic and cubic equations
      REAL(8), PRIVATE :: cx     ! ATX and ASWX
      REAL(8), PRIVATE :: Qx     ! coefficients used to solve for 
      REAL(8), PRIVATE :: Rx     ! the roots of the cubic equation
      REAL(8), PRIVATE :: ThetaX ! in ATX
      REAL(8), PRIVATE :: ev1    ! Temporary variables used to 
      REAL(8), PRIVATE :: ev2    ! calculate the eigen vectors 
      REAL(8), PRIVATE :: ev3    ! in ATX and ASWX
      REAL(8), PRIVATE :: evmax  !
      REAL(8), PRIVATE :: DetKO  ! Variables used to solve for the 
      REAL(8), PRIVATE :: DetK1  ! non-homogeneous part of the solution
      REAL(8), PRIVATE :: DetK2  ! a system of equations in ATX and
      REAL(8), PRIVATE :: DetK3  ! ASWX using Cramer's Rule
      REAL(8), PRIVATE :: DetEV  ! Variables used to solve for the 
      REAL(8), PRIVATE :: DetE1  ! integration constants in the 
      REAL(8), PRIVATE :: DetE2  ! system of equations in ATX and
      REAL(8), PRIVATE :: DetE3  ! ASWX using Cramer's Rule
      
      INTEGER, PRIVATE :: NC
      INTEGER, PRIVATE :: i
      INTEGER, PRIVATE :: j
      
      REAL(8), ALLOCATABLE, PRIVATE :: B( : )   ! Surface media concentration vector
      REAL(8), ALLOCATABLE, PRIVATE :: NHS( : ) ! non-homogenious solution

      INTEGER, SAVE, PRIVATE :: dt  ! internal model time step

C input/output parameters

      INTEGER, PRIVATE :: N_AQ_CONC  ! aqueous media concentrations
      INTEGER, PRIVATE :: N_GAS_CONC ! gaseous media concentrations
      INTEGER, PRIVATE :: N_SOL_CONC ! solid media concentrations

      CHARACTER( 16 ), ALLOCATABLE, PRIVATE :: MEDIA_NAMES( : )

      REAL(8), ALLOCATABLE, PRIVATE :: MLAI( :,: ) ! used to track change in LAI

      CONTAINS

         SUBROUTINE INIT_HGSIM( JDATE, JTIME )

         USE HGRD_DEFN           ! horizontal grid specifications
         USE UTILIO_DEFN
         USE ASX_DATA_MOD
         USE LSM_MOD
         USE Bidi_Mod

         IMPLICIT NONE

         INCLUDE SUBST_FILES_ID  ! file name parameters

         INTEGER, INTENT( IN ) :: JDATE
         INTEGER, INTENT( IN ) :: JTIME

         INTEGER      GXOFF, GYOFF              ! global origin offset from file
         integer, save :: loc_strtcol, loc_endcol, loc_strtrow, loc_endrow
         INTEGER, SAVE :: loc_STRTCOLGC2, loc_ENDCOLGC2, loc_STRTROWGC2, loc_ENDROWGC2

         CHARACTER( 16 ) :: PNAME = 'INIT_HGSIM'
         CHARACTER( 96 ) :: MSG = ' '

         INTEGER  V, L, C, R

C--------------------------------------------------------------------------
         INIT_LAI = .TRUE.

         IF( .NOT. ALLOCATED (MLAI) ) THEN
            ALLOCATE( MLAI(NCOLS,NROWS) )
            MLAI( :,: ) = 0.0
         END IF
         IF ( .NOT. ALLOCATED ( fevgrn ) ) THEN
            ALLOCATE ( fevgrn( NCOLS,NROWS ) )
            fevgrn( :,: ) = 0.0
         END IF

!         SELECT CASE( LAND_SCHEME )
!            CASE( 'USGS24' )
!               ALLOCATE (  Hglu_fac( n_lufrac ) )
!               Hglu_fac = HGLU_FAC_USGS            
         DO C = 1, NCOLS
            DO R = 1, NROWS
               DO L = 1, N_LUFRAC
                  IF(CAT_LU(L) .EQ. 'EVEFOR') THEN
                     fevgrn(c,r) = fevgrn(c,r) + Grid_Data%lufrac(c,r,l)
                  End IF
                  IF(CAT_LU(L) .EQ. 'MIXFOR') THEN
                     fevgrn(c,r) = fevgrn(c,r) + Grid_Data%lufrac(c,r,l)
                  End IF                                    
               END DO
            END DO
         END DO
!            CASE( 'MODIS' )
!               ALLOCATE (  Hglu_fac( n_lufrac ) )
!               Hglu_fac = HGLU_FAC_MODIS
!               DO C = 1, NCOLS
!                   DO R = 1, NROWS
!                     fevgrn(c,r) = lufrac(1,c,r)+lufrac(2,c,r)+0.5*lufrac(5,c,r)
!                  END DO
!               END DO
!             CASE( 'NLCD40' )
!               ALLOCATE (  Hglu_fac( n_lufrac ) )
!               Hglu_fac = HGLU_FAC_NLCD40
!               DO C = 1, NCOLS
!                   DO R = 1, NROWS
!                      fevgrn(c,r) = lufrac(1,c,r) + lufrac(2,c,r) +
!     &                              0.5*lufrac(5,c,r) + lufrac(29,c,r) +
!     &                              0.5*lufrac(30,c,r)
!                  END DO
!               END DO
!             CASE( 'NLCD50' )
!               ALLOCATE (  Hglu_fac( n_lufrac ) )
!               Hglu_fac = HGLU_FAC_NLCD50
!               DO C = 1, NCOLS
!                   DO R = 1, NROWS
!                      fevgrn(c,r) = lufrac(10,c,r) + 0.5*lufrac(11,c,r) +
!     &                              lufrac(32,c,r) + lufrac(32,c,r) + 
!     &                              0.5*lufrac(36,c,r)
!                  END DO
!               END DO
!            CASE DEFAULT
!               xmsg = 'Land use scheme not supported'
!               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
!         END SELECT

C **** Read in saved surface layer concentrations
         IF ( .NOT. MEDC_AVAIL ) THEN
            INIT_ASX = .TRUE.
            INIT_ATX = .TRUE.

         ELSE

            INIT_ASX = .FALSE.
            INIT_ATX = .FALSE.

         END IF ! load surface arrays

         RETURN

!------------------------------------------------------------------------------
! Error handeling section
!------------------------------------------------------------------------------
1001     CONTINUE
         CALL M3EXIT( pname, jdate, jtime, xmsg, xstat1 )
C-------------------------------------------------------------------------------
C Format statements.
C-------------------------------------------------------------------------------

9001     FORMAT( 'Failure reading ', a, 1x, 'from ', a )

         RETURN

         END SUBROUTINE INIT_HGSIM

         SUBROUTINE ATX (rbc, rcut, rwetsfc, rinc, rsnow, rgw, ifsnow, xm, 
     &                   dvel, HG, H, dpvd, del, tstep, c, r, l, jdate, jtime )

! test program to find and return eigenvalues and eigenvectors for a coupled
! land - surface echange model using Intels math kernel library (MKL) linear
! algebra functions

         USE HGRD_DEFN           ! horizontal grid specifications
         USE DEPVVARS
         USE LSM_MOD
         USE UTILIO_DEFN
         USE BIDI_MOD
         USE ASX_DATA_MOD

C Includes:

!         INCLUDE SUBST_CONST     ! constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments passed to and from m3dry

         REAL, INTENT( IN )   :: rbc     ! laminar boundary layer resistance
         REAL, INTENT( IN )   :: rcut    ! cuticle resistance
         REAL, INTENT( IN )   :: rwetsfc ! wet surface resistance
         REAL, INTENT( IN )   :: rinc    ! in canopy resistance
         REAL, INTENT( IN )   :: rsnow
         REAL, INTENT( IN )   :: rgw     ! wet soil resistance
         REAL, INTENT( IN )   :: xm
         REAL, INTENT( IN )   :: HG
         REAL, INTENT( IN )   :: H
         REAL, INTENT( IN )   :: del

         REAL, INTENT( OUT )  :: dpvd     ! evasion
         REAL, INTENT( OUT )  :: dvel     ! deposition velocity

         INTEGER, INTENT( IN ) :: c
         INTEGER, INTENT( IN ) :: r
         INTEGER, INTENT( IN ) :: l
         INTEGER, INTENT( IN ) :: jdate
         INTEGER, INTENT( IN ) :: jtime
         INTEGER, INTENT( IN ) :: tstep
         INTEGER, INTENT( IN ) :: ifsnow

         CHARACTER( 96 ) :: XMSG = ' '

         CHARACTER( 16 ), PARAMETER :: pname      = 'ATX'

         REAL(8)   :: vdHG   ! Elemental Hg deposition velocity
         REAL(8)   :: vdHGct   ! Hg cuticular transfer velocity
         REAL(8)   :: vdHGst  ! stomatal transfer velocity
         REAL(8)   :: vdHGsl
         REAL(8)   :: pdHgsl
         REAL(8)   :: rgnd

         REAL(8) :: ZC, ZM ! depth of model surface media

!Model concentrations

         REAL(8), SAVE :: Cc         ! cuticular Hg(0) concentrations
         REAL(8), SAVE :: Cm         ! mesophyll Hg(0) concentrations
         REAL(8), SAVE :: CgHg       ! Soil Hg(0) concentrations
         REAL(8), SAVE :: CHgzo      ! Hg(0) concentrations at z = zo
         REAL(8), SAVE :: CgHgII0    ! Soil Hg(II) concentrations
         REAL(8) :: vdHgt   ! sum of Hg deposition velocities
!********* reduction and partioning terms *******************************
         REAL(8) :: kr      ! soil divalent mercury reduction term
         REAL(8) :: Kam     ! air mesophyll partitioning coefficient for Hg(II)
         REAL(8) :: Kac     ! air cuticule partitioning coeffiecient for Hg(II)
         REAL(8) :: Kow     ! HgCl2 Octanol water partioning coefficient
         REAL(8) :: Kpwc    ! Hg(0) air-vegetation surface partitioning coefficient
         REAL(8) :: Kpwm    ! Hg(0) air-mesophyll partitioning coefficient
!********* vegetation poperties *****************************************
         REAL(8) :: lm   ! leaf mesophyll lipid fraction
         REAL(8) :: lc   ! cuticular wax mesophyll lipid fraction
         REAL(8) :: Wp   ! water content fraction of the leaf
         REAL(8) :: bc   ! Emprical coefficeint to describe differences in plant lipids
         REAL(8) :: flai ! Factor in mercury accumulation due to biodilution or scenescence
!********* Intermediate concentration variables *********************
         REAL, SAVE :: Hgm
         REAL, SAVE :: Hgc
         REAL, SAVE :: Hgs
!******** soil properties ***********************************************
         REAL(8), PARAMETER :: kvis_d = REAL(kvis,8) ! [cm^2 / s] at 273.15K
         REAL(8)            :: wg_min         ! minimum soil moisture content
         REAL(8)            :: ldry           ! diffusion length
         Real(8)            :: rbg            ! soil boundary layer resistance
         REAL(8)            :: scn            ! for Rbg
         REAL(8)            :: ustg           ! for Rbg
         REAL(8)            :: del0           ! for Rbg
         Real(8)            :: dp             ! for Rsoil
         INTEGER            :: ist            ! soil type
!********* Unit conversions *********************
         REAL(8) :: M3MOLVOL ! molar volume of air at stp m3/mol
!********* Variables used to handle an over determined system
         LOGICAL :: EV23 ! eigen values 1 and 3 are the same 

         M3MOLVOL = MOLVOL/1.0D3
         
         IF( INIT_LAI ) THEN
            MLAI( c,r ) = Met_Data%LAI(c,r)
            flai = 1.0D0
         END IF         
         IF( INIT_ATX ) THEN
! Equilibrium Hg(0) mesophyll concentration in a 5 month box model simulation
! umol/g leaf dry matter
            Cm     = fevgrn(c,r)*6.0D-6 + (1.0D0-fevgrn(c,r))*CMEDIA(c,r,5)
! Cuticular Hg(0) concentration in a 5 month box model simulation
            Cc     = fevgrn(c,r)*6.0D-7 + (1.0D0-fevgrn(c,r))*CMEDIA(c,r,6)
! Initialize at ambient concentration (zero flux condition)
            CgHg   = HG  ! ng/g bulk soil concentration
            CHgzo  = HG  ! ppm compensation point
         ELSE
            IF( MLAI(c,r) .EQ. 0.0 ) THEN
               flai = 1.0D0
            ELSE
               flai = max(Met_Data%LAI(c,r)/MLAI( c,r ),1.0D0) ! bio dilution
            END IF
            IF(flai .GT. 3.0) WRITE(Logdev,*) 'LAI factor: ', flai
            MLAI( c,r ) = Met_Data%LAI(c,r)
            Cm     = CMEDIA( c,r,5 )/flai  ! ng/g bulk leaf concentration
            Cc     = CMEDIA( c,r,6 )/flai  ! ng/g bulk leaf concentration
            CgHg   = CMEDIA( c,r,3 )  ! ng/g bulk soil concentration
         END IF

         dt     = tstep

! Model layer depths

         ZC     = 7.1D1* REAL(Met_Data%LAI(c,r),8) ! g/m**2 based off of leaf litter fall
         ZM     = 7.1D1* REAL(Met_Data%LAI(c,r),8) ! measurements at UCONN's experimental
! forest Bash and Miller 2009 Atmos. Environ.

!***************** canopy parameters *********************************
         Kow  = 4.15D0    ! For Hg, Mason 1996
         lm   = 2.0D-2    ! From Trapp and Matthis 1995
         lc   = 2.0D-2    ! Assumed cuticular wax lipid content
         Wp   = 8.0D-1     ! leaf water fraction, Trapp and Mathis 1996
         bc   = 9.5D-1   ! For barley, Trapp and Mathis 1996
         Kpwc = (Wp+lc*1.0D0/8.22D-1*Kow**bc)*MWWAT                 ! g/umol
         Kpwm = (Wp+lm*1.0D0/8.22D-1*Kow**bc)*MWWAT                 ! g/umol
! Partitioning coeficients following the methodology of the PEM model
         kac = (Kpwc*(1.0D0-del)) +  ! evasion from dry cuticles
     &         Kpwc*del*H        ! g/mol cuticle surface
         kam = Kpwm*H            ! g/mol apoplast solution
!**************** soil parameters ************************************
! Compute quasi-laminar boundary layer resistance at the soil surface
         scn  = kvis / dif0(l)
         ustg = max(Met_Data%Ustar(c,r) * EXP(-REAL(Met_Data%LAI(c,r),8)), 1.0D-3)
         del0 = 1.0D-4 * kvis / ( karman * ustg )
         rbg  = ( scn - LOG( 1.0D1 * del0 ) ) / ( karman * ustg )
! Compute soil resistance
         ist = Grid_Data%SLTYP(c,r)
         wg_min = REAL(MAX(Met_Data%SOIM1(c,r),Grid_Data%Wres(c,r)),8)
         ldry= MAX(ZG*(EXP((1.0D0-wg_min/Grid_Data%Wsat(c,r))**5)-1.0D0)/1.718D0,1.0D-12)
         dp  = dif0(l)*1.D-4 * Grid_Data%Wsat(c,r)**2 
     &       *(1.0D0-Grid_Data%Wres(c,r)/Grid_Data%Wsat(c,r))**(2.0D0+3.0D0/Grid_Data%Bslp(c,r))
! Soil divalent mercury reduction rate following Scholz et al 2003
         IF(Met_Data%SOIT1(c,r) .GT. 273.15) THEN
            kr     = 8.0D-11
            rgnd   = ldry/dp
         ELSE ! if the soil is frozen limit diffusion and reduction
            kr     = 0.0D0
            rgnd   = 1.0D6
         END IF

         cgHgII0 = 0.0D0

         DO i = 1, n_lufrac
            cgHgII0 = cgHgII0+hglu_fac(i)*Grid_data%lufrac(c,r,i)
         END DO
C Set floor to smallest terrestrial value
         cgHgII0 = MAX( cgHgII0, 1.8D1 )          

C diffusion through soil from Scholtz et al. 2003
         vdHg   = 1/(REAL(Met_Data%RA(c,r),8)+5.0D-1*rinc)
         vdHgst = 1.0D0/( rbc + REAL(Met_Data%RS(c,r),8) )
         vdHgct = REAL(Met_Data%LAI(c,r),8)*(( 1.0D0 - del  )/( rbc + rcut )
     &            + ( del )/(rbc + rwetsfc ))
         vdHgsl = REAL(Met_Data%VEG(c,r),8)/( rbg + rgnd + 5.0D-1*rinc)
     &            + ((1-ifsnow) *( 1.0D0 - REAL(Met_Data%VEG(c,r),8) )*( 1.0D0-del ))/(rbg + rgnd )
     &            + (del * (1.0D0-ifsnow))/(rbg + rgw )
     &            + (ifsnow*(1.0D0 - xm))/( rbg + rsnow )
     &            + (xm*ifsnow)/(rbc + rsndiff + rgw)
         pdHgsl = 1.0D0/(REAL(Met_Data%RA(c,r),8) + 1.0D0/vdHgsl )     ! production term with no canopy

         vdHgt = vdHg + vdHgst + vdHgct + vdHgsl

         CHgzo = (vdHg*Hg+vdHgst/kam*Cm+vdHgct/kac*Cc+vdHgsl/H*cgHg)
     &                    /vdHgt

         dpvd = Met_Data%veg(c,r) * vdHg * CHgzo + (1.0D0-REAL(Met_Data%VEG(c,r),8)) * pdHgsl/H * CgHg

         dvel = pdHgsl + REAL(Met_Data%VEG(c,r),8) *(vdhg-pdHgsl)

! Load array A
         NC = 3

         ALLOCATE ( KO(NC,NC), VR(NC,NC), EIVAL(NC))

         KO = 0.0D0

         KO(1,1) = -vdHgst/(ZM*kam*M3MOLVOL)*(1.0D0-vdHgst/(kam*vdHgt))
         KO(1,2) =  vdHgst/(ZM*M3MOLVOL)*vdHgct/(kac*vdHgt)
         KO(1,3) =  vdHgst/(ZM*M3MOLVOL)*vdHgsl/(H*vdHgt)
         KO(2,1) =  vdHgct/(ZC*M3MOLVOL)*vdHgst/(kam*vdHgt)
         KO(2,2) = -vdHgct/(ZC*kac*M3MOLVOL)*(1.0D0-vdHgct/(kac*vdHgt))
         KO(2,3) =  vdHgct/(ZC*M3MOLVOL)*vdHgsl/(H*vdHgt)
         KO(3,1) =  vdHgsl/(ZG*wg_min)*vdHgst/(kam*vdHgt)
         KO(3,2) =  vdHgsl/(ZG*wg_min)*vdHgct/(kac*vdHgt)
         KO(3,3) = -vdHgsl/(ZG*wg_min*H)*(1.0D0-vdHgsl/(H*vdHgt))         

         ALLOCATE( NHS(NC))

         NHS = 0.0D0

!        load the non-homogenious part of the system of equations
         NHS(1) = -vdHgst/ZM*(vdHg*HG/M3MOLVOL)/vdHgt
         NHS(2) = -vdHgct/ZC*(vdHg*HG/M3MOLVOL)/vdHgt
         NHS(3) = -vdHgsl/(ZG*wg_min)*(vdHg*HG)/vdHgt 
     &            -kr*rhob(ist)*cgHgII0*(ZG)/(1.0D3*2.0059D2)     
         
         ALLOCATE( B(NC))

         B = 0.0D0

!        Load the initial conditions

         B(1) = real( Cm,   8 )
         B(2) = real( Cc,   8 )
         B(3) = real( CgHg, 8 )

!*****************************************************************************
! Get eigen values and vectors where the cubic equation is:
! lambda**3+ax*lambda**2+bx*lambda+cx = 0
! and is solved following Numerical recipies for Fortran equations 5.6.10-5.6.12
!*****************************************************************************

         ax = -(KO(1,1)+KO(2,2)+KO(3,3))
 
         bx = -(KO(2,3)*KO(3,2)+KO(2,1)*KO(1,2)+
     &          KO(3,1)*KO(1,3)-KO(1,1)*KO(2,2)-
     &          KO(1,1)*KO(3,3)-KO(2,2)*KO(3,3))
         
         cx = (KO(1,1)*KO(2,3)*KO(3,2)+
     &         KO(3,1)*KO(1,3)*KO(2,2)+
     &         KO(2,1)*KO(1,2)*KO(3,3)-
     &         KO(3,1)*KO(1,2)*KO(2,3)-
     &         KO(2,1)*KO(1,3)*KO(3,2)-
     &         KO(1,1)*KO(2,2)*KO(3,3))
     
         Qx = (ax**2.0D0-3.0D0*bx)/9.0D0
         Rx = (2.0D0*ax**3.0D0-9.0D0*ax*bx+27.0D0*cx)/54.0D0 

! There will always be three real roots in this system
! so we can use the simple geometric solution for a 
! cubic equation.
         IF( Rx/DSQRT(Qx**3) .LT. 1.0D0 ) THEN
            ThetaX   =  DACOS(Rx/DSQRT(Qx**3))
            EIVAL(1) = -2.0D0*sqrt(Qx)*DCOS(ThetaX/3.0D0)-ax/3.0D0
            EIVAL(2) = -2.0D0*sqrt(Qx)*DCOS((ThetaX+2.0D0*Pi)/3.0D0)-ax/3.0D0
            EIVAL(3) = -2.0D0*sqrt(Qx)*DCOS((ThetaX-2.0D0*Pi)/3.0D0)-ax/3.0D0
! Solve for the eigenvectors by setting the first element to 1 and using
! Cramer's rule to solve the second and third elements using the first
! two equations          
            DO i = 1, NC
               ev1 =   1.0D0
               ev2 = (KO(2,1)*KO(1,3)-(KO(1,1)-EIVAL(i))*KO(2,3))/
     &               (KO(1,2)*KO(2,3)-(KO(2,2)-EIVAL(i))*KO(1,3))  
               ev3 = ((KO(1,1)-EIVAL(i))*(KO(2,2)-EIVAL(i))-KO(2,1)*KO(1,2))/
     &               (KO(1,2)*KO(2,3)-(KO(2,2)-EIVAL(i))*KO(1,3))
               evmax = max(abs(ev1),abs(ev2),abs(ev3))
! scale the eigenvector
               VR(1,i) = ev1/evmax
               VR(2,i) = ev2/evmax
               VR(3,i) = ev3/evmax         
            END DO 
! Rounding error can lead to Rx**2 > Qx**2 this usually indicates that two of the Eigen values are 
! equivalent Rx**2 = Qx**3 or there are complex roots in which the model will crash
         ELSE
            ThetaX   =  0.0D0
            EIVAL(1) = -2.0D0*sqrt(Qx)*DCOS(ThetaX/3.0D0)-ax/3.0D0
            EIVAL(2) = -2.0D0*sqrt(Qx)*DCOS((ThetaX+2.0D0*Pi)/3.0D0)-ax/3.0D0
            EIVAL(3) = -2.0D0*sqrt(Qx)*DCOS((ThetaX-2.0D0*Pi)/3.0D0)-ax/3.0D0
            DO i = 1, NC
               ev1 =   1.0D0
               ev2 = (KO(2,1)*KO(1,3)-(KO(1,1)-EIVAL(i))*KO(2,3))/
     &               (KO(1,2)*KO(2,3)-(KO(2,2)-EIVAL(i))*KO(1,3))  
               ev3 = ((KO(1,1)-EIVAL(i))*(KO(2,2)-EIVAL(i))-KO(2,1)*KO(1,2))/
     &               (KO(1,2)*KO(2,3)-(KO(2,2)-EIVAL(i))*KO(1,3))
               evmax = max(abs(ev1),abs(ev2),abs(ev3))
! scale the eigenvector
               VR(1,i) = ev1/evmax
               VR(2,i) = ev2/evmax
               VR(3,i) = ev3/evmax        
            END DO   
! Two roots are the same and independent eigenvectors need to be found 
! simply select a different element of the vector to be unity
            ev1 = ( KO(1,3)*(         KO(2,2)-EIVAL(3))-KO(1,2)*KO(2,3))/
     &            ((KO(1,1)-EIVAL(3))*KO(2,3)-          KO(1,3)*KO(2,1))
            ev2 = -1.0D0  
            ev3 = ( KO(2,1)*          KO(1,2)-(KO(1,1)-EIVAL(3))*(KO(2,2)-EIVAL(3)))/
     &            ((KO(1,1)-EIVAL(3))*KO(2,3)- KO(1,3)*           KO(2,1))
            evmax = max(abs(ev1),abs(ev2),abs(ev3))
! scale the eigenvector
            VR(1,3) = ev1/evmax
            VR(2,3) = ev2/evmax
            VR(3,3) = ev3/evmax
         END IF

C******************************************************************************
C******* Find the non homogenious solution ************************************
C******************************************************************************

! solve for KO*x = NHS using Cramer's Rule

         DetKO = KO(1,1)*KO(2,2)*KO(3,3)-KO(1,1)*KO(3,2)*KO(2,3)+
     &           KO(2,1)*KO(3,2)*KO(1,3)-KO(2,1)*KO(1,2)*KO(3,3)+
     &           KO(3,1)*KO(1,2)*KO(2,3)-KO(3,1)*KO(2,2)*KO(1,3)     

         DetK1 = NHS(1)*KO(2,2)*KO(3,3)-NHS(1)*KO(3,2)*KO(2,3)+
     &           NHS(2)*KO(3,2)*KO(1,3)-NHS(2)*KO(1,2)*KO(3,3)+
     &           NHS(3)*KO(1,2)*KO(2,3)-NHS(3)*KO(2,2)*KO(1,3)    
     
         DetK2 = KO(1,1)*NHS(2)*KO(3,3)-KO(1,1)*NHS(3)*KO(2,3)+
     &           KO(2,1)*NHS(3)*KO(1,3)-KO(2,1)*NHS(1)*KO(3,3)+
     &           KO(3,1)*NHS(1)*KO(2,3)-KO(3,1)*NHS(2)*KO(1,3)  
     
         DetK3 = KO(1,1)*KO(2,2)*NHS(3)-KO(1,1)*KO(3,2)*NHS(2)+
     &           KO(2,1)*KO(3,2)*NHS(1)-KO(2,1)*KO(1,2)*NHS(3)+
     &           KO(3,1)*KO(1,2)*NHS(2)-KO(3,1)*KO(2,2)*NHS(1)   
     
         NHS(1) = DetK1/DetKO
         NHS(2) = DetK2/DetKO
         NHS(3) = DetK3/DetKO

C******************************************************************************
C*** Update the IC's for the Non-homogenious solutions and solve the system ***
C******************************************************************************

!        Subtract the non-homogenious solution from the 
         DO i = 1, NC
            B(i) = B(i)-NHS(i)
         END DO
!        Solve x for VR*x=B using Cramer's Rule

         DetEV = VR(1,1)*VR(2,2)*VR(3,3)-VR(1,1)*VR(3,2)*VR(2,3)+
     &           VR(2,1)*VR(3,2)*VR(1,3)-VR(2,1)*VR(1,2)*VR(3,3)+
     &           VR(3,1)*VR(1,2)*VR(2,3)-VR(3,1)*VR(2,2)*VR(1,3)  
 
         DetE1 = B(1)*VR(2,2)*VR(3,3)-B(1)*VR(3,2)*VR(2,3)+
     &           B(2)*VR(3,2)*VR(1,3)-B(2)*VR(1,2)*VR(3,3)+
     &           B(3)*VR(1,2)*VR(2,3)-B(3)*VR(2,2)*VR(1,3) 
     
         DetE2 = VR(1,1)*B(2)*VR(3,3)-VR(1,1)*B(3)*VR(2,3)+
     &           VR(2,1)*B(3)*VR(1,3)-VR(2,1)*B(1)*VR(3,3)+
     &           VR(3,1)*B(1)*VR(2,3)-VR(3,1)*B(2)*VR(1,3)
     
         DetE3 = VR(1,1)*VR(2,2)*B(3)-VR(1,1)*VR(3,2)*B(2)+
     &           VR(2,1)*VR(3,2)*B(1)-VR(2,1)*VR(1,2)*B(3)+
     &           VR(3,1)*VR(1,2)*B(2)-VR(3,1)*VR(2,2)*B(1)  
     
         B(1) = DetE1/DetEV        
         B(2) = DetE2/DetEV        
         B(3) = DetE3/DetEV   

! update the surface array
         Hgm = 0.0
         Hgc = 0.0
         Hgs = 0.0

         DO i = 1, NC
            Hgm = Hgm + B(i) * VR(1,i) * DEXP( EIVAL(i) * dt )
            Hgc = Hgc + B(i) * VR(2,i) * DEXP( EIVAL(i) * dt )
            Hgs = Hgs + B(i) * VR(3,i) * DEXP( EIVAL(i) * dt )
         END DO

         Hgm   = Hgm + NHS(1)
         Hgc   = Hgc + NHS(2)
         Hgs   = Hgs + NHS(3) 
 
         IF ( Hgm .LT. 0.0 ) THEN

            XMSG = '*** Negative concentration in Hgm resetting it to zero ***'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            Hgm = max(Hgm,0.0)

         END IF

         IF ( Hgc .LT. 0.0 ) THEN

            XMSG = '*** Negative concentration in Hgc resetting it to zero ***'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            Hgc = max(Hgc, 0.0)

         END IF

         IF ( Hgs .LT. 0.0 ) THEN
! This can happen when the soil moisture approaches zero limiting the Hg that 
! can evade from this source.
            XMSG = '*** Negative concentration in Hgs resetting it to zero flux condition ***'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            WRITE(LOGDEV,*) 'wg  :',wg_min, 'Hgs :', Hgs, 'H :',H
            WRITE(LOGDEV,*) 'Col :',c, 'Row :', r
            Hgs = CHgzo*H 

         END IF

         IF ( Hgm .NE. Hgm .OR. Hgc .NE. Hgc .OR. Hgs .NE. Hgs ) THEN
            XMSG = '*** NaN in Hgs, Hgc, or Hgm ***'
            WRITE(LOGDEV,*) 'Col',c,'Row',r
            WRITE(LOGDEV,*) 'Hgm',Hgm,'Hgc',Hgc,'Hgs',Hgs
            WRITE(LOGDEV,*) 'B      :',B
            WRITE(LOGDEV,*) 'NHS    :',NHS
            WRITE(LOGDEV,*) 'KO     :',KO
            WRITE(LOGDEV,*) 'cgHgII0: ',cgHgII0
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1)
         END IF

         CMEDIA( c,r,1 ) = 0.0 ! water
         CMEDIA( c,r,2 ) = 0.0 ! water
         CMEDIA( c,r,3 ) = Hgs
         CMEDIA( c,r,4 ) = CHgzo
         CMEDIA( c,r,5 ) = Hgm
         CMEDIA( c,r,6 ) = Hgc

         DEALLOCATE( KO, VR, EIVAL )

         DEALLOCATE( B, NHS )

         RETURN

         END SUBROUTINE ATX

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
C::::::: Air surface water exchange subroutine :::::::::::::::::::::::::::
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

         SUBROUTINE ASWX( Hg, HgIIgas, vdHg, vdHgII, awhg,
     &                    dpvd, c, r, JDATE, JTIME, TSTEP )

         USE HGRD_DEFN           ! horizontal grid specifications
         USE DEPVVARS
         USE UTILIO_DEFN
         USE BIDI_MOD
         USE ASX_DATA_MOD

C Includes:

!         INCLUDE SUBST_CONST     ! constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

         INTEGER, INTENT( IN )   :: JDATE
         INTEGER, INTENT( IN )   :: JTIME
         INTEGER, INTENT( IN )   :: TSTEP
         REAL,    INTENT( IN )   :: Hg
         REAL,    INTENT( IN )   :: HgIIgas
         REAL,    INTENT( IN )   :: vdHg
         REAL,    INTENT( IN )   :: vdHgII
         REAL,    INTENT( IN )   :: awhg
         REAL,    INTENT( OUT )  :: dpvd
         INTEGER, INTENT( IN )   :: c
         INTEGER, INTENT( IN )   :: r

         CHARACTER( 16 ), PARAMETER :: pname      = 'ASWX'

C*************************** Ocean box parameters ***********************
         REAL(8), PARAMETER :: satten = 7.58d-1
C*************************** Model concentrations ***********************
         REAL(8), SAVE :: cDGM
         REAL(8), SAVE :: cHgIIaq
C***** reduction and partioning terms from Whalin et al 2007 ************
         REAL(8), PARAMETER :: rref  = 240d+0    ! referance incoming radiation
                                           ! for redox measurements (w/m2)
         REAL(8), PARAMETER :: kphot = 6.5d-4 ! drm photoreduction rate 1/s
         REAL(8), PARAMETER :: kox   = 7.2d-4 ! dgm photo-oxidation rate 1/s
C********* Intermediate concentration variables *********************
         REAL(8), SAVE :: DGM
         REAL(8), SAVE :: DRM


         IF (INIT_ASX ) THEN
            cDGM    = Hg*awhg*3 ! assume 3x eq con.
            cHgIIaq = 3.57e-6   ! from Whalin et al 2007
         ELSE
            cDGM    = CMEDIA( c,r,1 )
            cHgIIaq = CMEDIA( c,r,2 )
         END IF

         dt   = TSTEP

         dpvd = cDGM * vdHg/awhg

         IF ( Met_Data%RGRND(c,r) .LT. 1e-3 ) THEN
C the aqueous elemental and divalent Hg pools become decoupled and the
C matrices become singular warrenting an alternative solution

C Find a simple one box solution for elemental Hg

            DGM = Hg*awhg + (cDGM - Hg*awhg)*DEXP(-vdHg/(ZSURF*awhg)*dt)

C in the absence of photo-redox reactions divalent Hg accumulates
            DRM = cHgIIaq + vdHgII/ZSURF*HgIIgas*dt

         ELSE

            NC    = 2

            ALLOCATE ( KO(NC,NC), VR(NC,NC), EIVAL(NC) )

            KO = 0.0D0

C 240 w/m**2 is the 'typical light spectrum' from Whalin et al 2007 Marine Chem.
C attenuation at 1 m = 1/K (1-exp(-K Z)) = 0.758 using a K of 0.58


            KO( 1,1 )   = -vdhg / ( ZSURF * awhg )
     &                    -kox *   satten * Met_Data%RGRND(c,r)/rref
            KO( 1,2 )   =  kphot * satten * Met_Data%RGRND(c,r)/rref
            KO( 2,1 )   =  kox *   satten * Met_Data%RGRND(c,r)/rref
            KO( 2,2 )   = -kphot * satten * Met_Data%RGRND(c,r)/rref

            ALLOCATE( NHS(NC))

            NHS = 0.0

            NHS(1) = -vdHg/ZSURF*HG
            NHS(2) = -vdHgII/ZSURF*HgIIgas

            ALLOCATE( B(NC))

            B = 0.0

            B( 1 ) = REAL( cDGM,    8)   
            B( 2 ) = REAL( cHgIIaq, 8)


C*****************************************************************************
! Get eigen values and vectors where the cubic equation is:
! ax*lambda**2+bx*lambda+cx = 0
! and is solved following Numerical recipies for Fortran equations 5.6.2-5.6.5
C*****************************************************************************

            ax = 1.0D0
            bx = -(KO(1,1)+KO(2,2))
            cx = KO(1,1)*KO(2,2)-KO(1,2)*KO(2,1)
    
            Qx = -5.0D-1*(bx+SIGN(1.0D0,bx)*DSQRT(bx**2-4.0D0*ax*cx))
    
            EIVAL(1) = Qx/ax
            EIVAL(2) = cx/Qx
    
! Solve for the eigenvectors
         DO i = 1, NC
            ev1   = 1.0D0
            ev2   = -(KO(2,1)*ev1)/(KO(2,2)-EIVAL(i))
            evmax = max(abs(ev1),abs(ev2))
! scale the eigenvector
            VR(1,i) = ev1/evmax
            VR(2,i) = ev2/evmax
         END DO

C******************************************************************************
C******* Do the non homogenious part ******************************************
C******************************************************************************

! solve for x in  KO*x = NHS using Cramer's Rule

         DetKO  = KO(1,1)*KO(2,2)-KO(1,2)*KO(2,1)  
 
         DetK1 = NHS(1)*KO(2,2)-NHS(2)*KO(1,2)
         DetK2 = NHS(2)*KO(1,1)-NHS(1)*KO(2,1)
 
         NHS(1) = DetK1/DetKO
         NHS(2) = DetK2/DetKO 

C******************************************************************************
C*** Update the IC's for the Non-homogenious solutions and solve the system ***
C******************************************************************************

            DO i = 1, NC
               B(i) = B(i) - NHS(i)
            END DO

!        Solve for x in VR*x=B using Cramer's Rule

         DetEV  = VR(1,1)*VR(2,2)-VR(1,2)*VR(2,1)
 
         DetE1  = B(1)*VR(2,2)-B(2)*VR(1,2) 
         DetE2  = B(2)*VR(1,1)-B(1)*VR(2,1)
 
         B(1) = DetE1/DetEV
         B(2) = DetE2/DetEV

! update the surface array
            DGM = 0.0D0
            DRM = 0.0D0

            DO i = 1, NC
               DGM = DGM + B(i) * VR(1,i) * DEXP( EIVAL(i) * dt )
               DRM = DRM + B(i) * VR(2,i) * DEXP( EIVAL(i) * dt )
            END DO

            DGM     = DGM   + NHS(1)
            DRM     = DRM   + NHS(2)
    
            DEALLOCATE( KO, VR, EIVAL )

            DEALLOCATE( B, NHS )

         END IF         
    
         IF ( DGM .LT. 0.0 .OR. DRM .LT. 0.0 ) THEN
            
            XMSG = '*** Negative concentration ***'   
            WRITE(LOGDEV,*) 'awhg',awhg,'HG',HG
            WRITE(LOGDEV,*) 'DGM',DGM,'DRM',DRM             
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )

         END IF 

         CMEDIA( c,r,1 ) = DGM
         CMEDIA( c,r,2 ) = DRM
         CMEDIA( c,r,3 ) = 0.0 ! land
         CMEDIA( c,r,4 ) = 0.0 ! land
         CMEDIA( c,r,5 ) = 0.0 ! land
         CMEDIA( c,r,6 ) = 0.0 ! land

         RETURN

         END SUBROUTINE ASWX

C------------------------------------------------------------------------------

         SUBROUTINE GET_WDEP( CSE, WDEP, C, R )

         Use ASX_DATA_MOD, Only: Grid_Data
         USE BIDI_MOD, Only: CMedia

         IMPLICIT NONE

         INCLUDE SUBST_CONST     ! constants

         CHARACTER( 8 ), INTENT( IN ) :: CSE  ! wet dep sepcies
         REAL,      INTENT( IN ) :: WDEP ! wet deposition in kg/ha
         INTEGER,   INTENT( IN ) :: C
         INTEGER,   INTENT( IN ) :: R
         REAL, PARAMETER :: HAOM2   = 1.0e-4 ! ha/m^2 conversion
         REAL, PARAMETER :: MWHG    = 200.59 ! molecular weight of Hg
         REAL, PARAMETER :: UGOKG   = 1.0e9  ! ug/kg conversion
         REAL, PARAMETER :: GH2ONM3 = 1.0e6  ! g H2O in M^3 H2O
         REAL  WDEP_LOAD   ! loading due to wet deposition


         IF ( NINT( Grid_Data%lwmask( c,r ) ) .EQ. 0 ) THEN ! water

         ! convert to umol/m2 pulse input
            WDEP_LOAD = WDEP*HAOM2*UGOKG/MWHG
         ! convert to added concentration in ppm assuming it remains at the surface
            WDEP_LOAD = WDEP_LOAD/ZSURF/GH2ONM3*MWWAT

            IF( CSE .EQ. 'HG      ' ) THEN

               CMEDIA( C,R,1 ) = CMEDIA( C,R,1 ) + WDEP_LOAD

            END IF

            IF( CSE .EQ. 'HGIIGAS ' ) THEN

               CMEDIA( C,R,2 ) = CMEDIA( C,R,2 ) + WDEP_LOAD

            END IF

         END IF ! water

         RETURN

         END SUBROUTINE GET_WDEP
      END MODULE HGSIM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/emis/emis/UDTYPES.F,v 1.2 2011/10/21 16:10:47 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE UDTYPES

C-----------------------------------------------------------------------
C Function: User-defined types

C Revision History:
C     21 Nov 2007 J.Young: initial implementation

C-----------------------------------------------------------------------

      IMPLICIT NONE

      TYPE :: IARRY1
         INTEGER, POINTER :: ARRY( : )
         INTEGER          :: LEN
      END TYPE IARRY1

      TYPE :: IARRY2
         INTEGER, POINTER :: ARRY( :,: )
         INTEGER          :: LEN1, LEN2
      END TYPE IARRY2

      TYPE :: RARRY1
         REAL,    POINTER :: ARRY( : )
         INTEGER          :: LEN
      END TYPE RARRY1

      TYPE :: RARRY2
         REAL,    POINTER :: ARRY( :,: )
         INTEGER          :: LEN1, LEN2
      END TYPE RARRY2

      TYPE :: CARRY1
         CHARACTER( 16 ), POINTER :: ARRY( : )
         CHARACTER( 16 ), POINTER :: UNITS( : )
         INTEGER                  :: LEN
      END TYPE CARRY1

      TYPE :: LARRY1
         LOGICAL, POINTER :: ARRY( : )
         INTEGER                  :: LEN
      END TYPE LARRY1

      TYPE :: BILIN_TYPE
C Allocatable un-gridding matrix variables (uses BMATVEC bilinear interpolation):
C (Dimensioned 4 by number of pt sources)
         INTEGER          :: LEN1, LEN2
         INTEGER, POINTER :: ND( :,: )    ! dot-point, cell indexes
         INTEGER, POINTER :: NX( :,: )    ! cross-point, cell indexes
         REAL,    POINTER :: CD( :,: )    ! dot-point, coefficients
         REAL,    POINTER :: CX( :,: )    ! cross-point, coefficients
      END TYPE BILIN_TYPE

      TYPE :: PTMET_TYPE
         INTEGER          :: LEN1, LEN2
C Allocatable per-source meteorology variables:
         REAL,    POINTER :: HFX( : )        ! sensible heat flux [watts/m**2]
         REAL,    POINTER :: HMIX( : )       ! mixing height [m]
         REAL,    POINTER :: TSFC( : )       ! surface temperature [degK]
         REAL,    POINTER :: USTAR( : )      ! friction velocity [m/s]
         REAL,    POINTER :: PRSFC( : )      ! surface pressure [Pa]
C Allocatable temporary per-layer variables from 1:EMLAYS:
         REAL,    POINTER :: WSPD( : )       ! wind speed [m/s]
         REAL,    POINTER :: DTHDZ( : )      ! virtual pot temp gradient [degK/m]
C Allocatable temporary per-layer variables from 0:EMLAYS:
         REAL,    POINTER :: PRESF( : )      ! pressure at full-levels
         REAL,    POINTER :: ZZF( : )        ! per src elevn at full-levels
C Allocatable per-source and per-layer meteorology variables:
C (Dimensioned by layers, then number of sources)
!        REAL,    POINTER :: DDZH ( :,: )    ! 1/( ZH(L) - ZH(L-1) )
         REAL,    POINTER :: DDZF ( :,: )    ! 1/( ZF(L) - ZF(L-1) )
         REAL,    POINTER :: PRES ( :,: )    ! pressure [Pa]
         REAL,    POINTER :: DENS ( :,: )    ! air density [kg/m**3]
         REAL,    POINTER :: QV   ( :,: )    ! moisture mixing ratio [kg/kg]
         REAL,    POINTER :: TA   ( :,: )    ! temperature [degK]
         REAL,    POINTER :: UWIND( :,: )    ! x-component wind speed [m/s]
         REAL,    POINTER :: VWIND( :,: )    ! y-component wind speed [m/s]
         REAL,    POINTER :: ZF   ( :,: )    ! full layer height [m]
         REAL,    POINTER :: ZH   ( :,: )    ! mid layer height [m]
         REAL,    POINTER :: ZSTK ( :,: )    ! ZF( L,S ) - STKHT(S) [m]
      END TYPE PTMET_TYPE

      END MODULE UDTYPES

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE SA_DEFN

! KWOK: Define tagging emissions, species, dimensions, etc, based on user-supplied sa_io_list
! KWOK: Created Oct 5, 2010
! 29 Oct 18 L.Zhou, S.Napelenok: update for cmaq 5.3 release
! 35 Mar 19 S.Napelenok: recode REGION handling and clean-up for release
! 

      IMPLICIT NONE

      SAVE

      PUBLIC

      INTEGER ITAG

c...Tagging maps
      CHARACTER( 16 ), ALLOCATABLE :: SPC_NAME( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: SPC_INDEX( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_CGRtoSA( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_AEROtoSA( :,: )
      LOGICAL, ALLOCATABLE, SAVE   :: IS_SPC_AEROSOL( :,: )
      LOGICAL, ALLOCATABLE, SAVE   :: TRANSPORT_SPC ( : )
      INTEGER, ALLOCATABLE, SAVE   :: STREAM_TO_TAG ( :,: )
      INTEGER, ALLOCATABLE, SAVE   :: TAGS_PER_STREAM( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_DIFFtoSA( : )
      INTEGER, ALLOCATABLE, SAVE   :: MAP_ADVtoSA( : )
c     INTEGER, ALLOCATABLE, SAVE   :: MAP_DEPVtoSA( : )
 
      INTEGER, ALLOCATABLE, SAVE   :: ISAM_PVO3_MAP( : ) ! potential vorticity map

      INTEGER ::     NSPC_SA
      INTEGER ::     NTAG_SA
      INTEGER ::     NSPC_TRANSPORT

c...Define Allocatable Apportionment Arrays
      REAL, POINTER :: ISAM  ( :,:,:,:,: )
      REAL, ALLOCATABLE :: AISAM ( :,:,:,:,: )
      REAL, ALLOCATABLE :: TOT_SADEP ( :,:,:,: )
      REAL, ALLOCATABLE :: CONV_SADEP ( :,:,:,: )
c     REAL, ALLOCATABLE :: MAPFRAC( :,:,: )
c     REAL, ALLOCATABLE :: MFRC_P( :,:,: )
c     REAL, ALLOCATABLE :: VOC5D ( :,:,:,:,: )
      REAL, ALLOCATABLE :: SA_VDEMIS_CONV( :,:,:,:,: ) ! full emissions array mapped to diffused species
      REAL, ALLOCATABLE :: SA_VDEMIS_CONV_OTHER( :,:,:,: ) ! emissions left for 'OTHRTAG'
      REAL, ALLOCATABLE :: SA_VDEMIS_DIFF( :,:,:,:,: ) 

c...Variables regarding the tag list
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: TAGNAME( : )
      CHARACTER( 96 )                    :: TAGCLASSES = ' '
      CHARACTER( 96 ), ALLOCATABLE, SAVE :: TAGSTREAMS_TEMP( : )
      CHARACTER( 96 ), ALLOCATABLE, SAVE :: TAGSTREAMS( :, : )
      INTEGER, ALLOCATABLE, SAVE         :: TAGSTREAMS_NUM( : )

      CHARACTER( 96 ), ALLOCATABLE, SAVE :: ISAMRGN_TEMP( : )
      CHARACTER( 96 ), ALLOCATABLE, SAVE :: ISAMRGN( :, : )
      INTEGER, ALLOCATABLE, SAVE         :: ISAMRGN_NUM( : )
      INTEGER, ALLOCATABLE, SAVE         :: ISAMRGN_MAP( :, : )

c...Logical values for tagging species
      LOGICAL, SAVE :: L_EC      = .FALSE.
      LOGICAL, SAVE :: L_OC      = .FALSE.
      LOGICAL, SAVE :: L_SFATE   = .FALSE.
      LOGICAL, SAVE :: L_NITRATE = .FALSE.
      LOGICAL, SAVE :: L_NH4     = .FALSE.
      LOGICAL, SAVE :: L_PM25    = .FALSE.
      LOGICAL, SAVE :: L_OZONE   = .FALSE.
      LOGICAL, SAVE :: L_VOC     = .FALSE.
      LOGICAL, SAVE :: L_CHLORINE  = .FALSE.
!      LOGICAL, SAVE :: L_CO      = .FALSE.
!      LOGICAL, SAVE :: L_GAS_HAPS  = .FALSE.
!      LOGICAL, SAVE :: L_AERO_HAPS = .FALSE.
      
      LOGICAL, SAVE :: SA_BIDI = .FALSE.

!      INTEGER,         PARAMETER :: N_AERO_HAPS_LIST = 16       
!      CHARACTER( 16 ), PARAMETER :: AERO_HAPS_LIST(  N_AERO_HAPS_LIST ) =
!     & (/ 'ANI     ',
!     &    'ACR_VI  ',
!     &    'ACR_III ',
!     &    'ABE     ',
!     &    'APB     ',
!     &    'ADE_OTHR',
!     &    'ADE_EC  ',
!     &    'ADE_OC  ',
!     &    'ADE_NO3 ',
!     &    'ADE_SO4 ',
!     &    'ADE_CORS',
!     &    'ACD     ',
!     &    'AMN_HAPS',
!     &    'APHG    ',
!     &    'AAS     ',
!     &    'ABENAPY '  /)
     
!      INTEGER                      :: N_AERO_HAPS = 0
!      CHARACTER( 16 ), ALLOCATABLE :: AERO_HAPS(  : ) 
     
      
! Full chemistry commented out because it produced floating
! point error in advection when using debug flags.
!     LOGICAL, SAVE :: L_CHEMISTRY

! Cloud Module variables - sln 4 june 2018
      REAL, SAVE :: DEPSUM_SAVE = 0.0
      REAL, SAVE :: DS4_SAVE    = 0.0
      REAL, SAVE :: REMOV_SAVE  = 0.0

c...Final, combined tags
      INTEGER                      :: N_SPCTAG
      INTEGER,         ALLOCATABLE :: S_SPCTAG( : )
      INTEGER,         ALLOCATABLE :: T_SPCTAG( : )
      CHARACTER( 16 ), ALLOCATABLE :: VNAM_SPCTAG( : )

C ...Tagging indices for bcon, others, icon
      INTEGER, SAVE :: BIDITAG = 0
      INTEGER, SAVE :: BCONTAG = 0
      INTEGER, SAVE :: OTHRTAG = 0
      INTEGER, SAVE :: ICONTAG = 0

      REAL, PRIVATE, ALLOCATABLE :: BUFF2( :,: )

! Diffusion module variables
      REAL, ALLOCATABLE, SAVE :: SA_DDEP( :,:,: )

! Advection module variables
      LOGICAL, ALLOCATABLE, SAVE :: BCON_SPC( : )

        INTEGER, PARAMETER, PRIVATE :: MAX_STRING     = 32  ! max length of tagclass name
        INTEGER, PARAMETER, PRIVATE :: MAX_TAGCLASSES = 200 ! max number of tagclasses
        INTEGER, PARAMETER, PRIVATE :: NUMB_CLASSES   = 9   ! number of defined tagclasses
        
        CHARACTER( MAX_STRING ), PARAMETER, PRIVATE :: DEFINED_CLASSES( NUMB_CLASSES ) = 
     & (/ 'AMMONIUM ',
     &    'OC       ',
     &    'CHLORINE ',
     &    'EC       ',
     &    'SULFATE  ',
     &    'OZONE    ',
     &    'NITRATE  ',
     &    'VOC      ',
     &    'PM25_IONS' /)
        
      
      CONTAINS

C============================================================

        SUBROUTINE CNT_SA_IO_LIST ( NTAGS )

C20140428  Counts the number of emissions tags in the input control file
C         Called by sa_dim.F
C
C

        USE UTILIO_DEFN     ! 20120615
c       USE HGRD_DEFN    
        USE RUNTIME_VARS, ONLY: ABFLUX, MYPE, LOGDEV
                
        IMPLICIT NONE

        CHARACTER( 16 ) :: PNAME = 'CNT_SA_IO_LIST'
        CHARACTER( 256 ) :: EQNAME 
        INTEGER INPUT_UNIT
        INTEGER IOST
        CHARACTER( 80 ) :: XMSG   
C external functions
        INTEGER LEN_TRIM

        INTEGER, INTENT( OUT ) :: NTAGS
        INTEGER ILINE
        CHARACTER( 180 ) :: TXTLINE
        
C-----------------------------------------------------------
        CALL NAMEVAL( 'SA_IOLIST', EQNAME )
        INPUT_UNIT = JUNIT()
         
        OPEN ( UNIT = INPUT_UNIT, FILE = EQNAME, STATUS = 'OLD', IOSTAT = IOST )
        XMSG = 'Error Opening SA_IO_LIST file'
        IF ( IOST .NE. 0 ) THEN
          CALL M3EXIT ( 'SA_IOLIST', 0, 0, XMSG, XSTAT1 )
        ENDIF

        IF ( MYPE .EQ. 0 ) THEN        
          WRITE(LOGDEV, *) 'SA_IO_LIST Sucessfully Opened'
          WRITE(LOGDEV, *) 'Start counting the list...'
        ENDIF
        NTAGS = 0
        COUNTTAG: DO 
          READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE( 1:7 ) .EQ. 'ENDLIST' ) EXIT COUNTTAG
          IF ( TXTLINE( 1:7 ) .EQ. 'TAG NAM' ) THEN
            NTAGS = NTAGS + 1
            IF ( MYPE .EQ. 0 ) PRINT*, TXTLINE
          ENDIF ! if tag_name
c check to see if bidirectional tag is necessary
          IF ( ABFLUX ) THEN
            IF ( TXTLINE( 1:11 ) .EQ. 'TAG CLASSES' ) THEN
              IOST = INDEX( TXTLINE,'AMMONIUM', BACK = .FALSE. )
              IF ( IOST .NE. 0 ) THEN
                SA_BIDI = .TRUE.
                NTAGS   = NTAGS + 1
c               BIDITAG = NTAGS ! set to last tag
              END IF
            END IF
          END IF
        ENDDO COUNTTAG


        IF ( SA_BIDI ) BIDITAG = NTAGS ! set to last tag

        CLOSE( INPUT_UNIT )

        END SUBROUTINE CNT_SA_IO_LIST
C============================================================

        SUBROUTINE RD_SA_IO_LIST ( NTAGS )

C20140428  Read entries in each emissions tag in the input control file
C         Called by sa_dim.F
C
C
C 05 Nov 2018: L.Zhou, S.Napelenok: Reorganized the control file
c 

        USE UTILIO_DEFN 
        USE RUNTIME_VARS, ONLY: ABFLUX, MYPE, LOGDEV

        IMPLICIT NONE
C arguments
        INTEGER, INTENT( IN ) :: NTAGS

        CHARACTER( 16 )    :: PNAME = 'RD_SA_IO_LIST'
        CHARACTER( 256 )   :: EQNAME 
        INTEGER INPUT_UNIT
        INTEGER IOST
        CHARACTER( 120 ) :: XMSG   
C external functions
        INTEGER LEN_TRIM

        INTEGER ILINE
        INTEGER ITAG, TAGLOOP
        CHARACTER( 128 ) :: TXTLINE

C...multi-sectors-for-a-single-tag 20130702
        INTEGER ISGSTK
        CHARACTER( 2 )  :: CSGSTK
        CHARACTER( 16 ) :: FNAME
        LOGICAL LBACK
        INTEGER DELIMINATOR_INDEX 
        INTEGER BGN_SG
        INTEGER I, J ,k
        CHARACTER(1) :: CHR

C-----------------------------------------------------------
        CALL NAMEVAL( 'SA_IOLIST', EQNAME )
        INPUT_UNIT = JUNIT()

        OPEN ( UNIT = INPUT_UNIT, FILE = EQNAME, STATUS = 'OLD', IOSTAT = IOST )
        XMSG = 'Error Opening SA_IO_LIST file'
        IF ( IOST .NE. 0 ) THEN
          CALL M3EXIT ( 'SA_IOLIST', 0, 0, XMSG, XSTAT1 )
        ENDIF
        
        CHR = CHAR(124)
101     READ ( INPUT_UNIT, '(A)' ) TXTLINE
        IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 101
        IF( INDEX( TXTLINE, 'TAG CLASSES' ) .GE. 1 )THEN
           DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 ) ) + 1
           IF(  DELIMINATOR_INDEX .LE. 1 )THEN
              XMSG = 'ISAM ERROR: TAG CLASSES line missing the "|" deliminator'
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
           END IF 
           TAGCLASSES = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
           IF( LEN_TRIM( TAGCLASSES ) .LT. 1 )THEN
              XMSG = "ISAM ERROR: TAGCLASSES in control file is blank. "
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
           END IF
        ELSE   
           XMSG = "ISAM ERROR: First Nonblank or Noncomment line "
     &         // "in control file must define TAG CLASSES. "
           CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
        END IF

        IF ( MYPE .eq. 0 ) then
          WRITE(LOGDEV, *) 'Reading ISAM control file'
          WRITE(LOGDEV, *) 'TAGCLASSES = ',TRIM(TAGCLASSES)
          WRITE(LOGDEV, *) '  for ', NTAGS, ' tags'
        ENDIF

        IF ( SA_BIDI ) THEN
          TAGLOOP = NTAGS -1
        ELSE
          TAGLOOP = NTAGS
        ENDIF

        DO ITAG = 1, ( TAGLOOP )
        
          TAGNAME( ITAG )         = ' '
          ISAMRGN_TEMP( ITAG )    = ' '
          TAGSTREAMS_TEMP( ITAG ) = ' '
          
102       READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 102
          IF( INDEX( TXTLINE, 'TAG NAME' ) .GE. 1 )THEN
              DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 ) ) + 1
              IF(  DELIMINATOR_INDEX .LE. 1 )THEN
                 XMSG = 'ISAM ERROR: "TAG NAME" line missing the "|" deliminator'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF 
              TAGNAME( ITAG ) = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
              IF( LEN_TRIM( TAGNAME( ITAG ) ) .LT. 1 )THEN
                 XMSG = 'ISAM ERROR: a "TAG NAME" in control file is blank. '
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
          ELSE   
              XMSG = "ISAM ERROR: First line defining a TAG "
     &            // 'in control file must contain the "TAG NAME" ' 
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
          END IF

103       READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 103
          IF( INDEX( TXTLINE, 'REGION' ) .GE. 1 )THEN
              DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 )  ) + 1
              IF(  DELIMINATOR_INDEX .LE. 1 )THEN
                 XMSG = 'ISAM ERROR: a "REGION(s)" line missing the "|" deliminator'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF 
              ISAMRGN_TEMP( ITAG ) = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
              IF( LEN_TRIM( ISAMRGN_TEMP( ITAG ) ) .LT. 1 )THEN
                 XMSG = 'ISAM ERROR: a "REGION(s)" in control file is blank. '
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
          ELSE   
              XMSG = "ISAM ERROR: Second line defining a TAG "
     &            // 'in control file must contain the "REGION(s)" ' 
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
          END IF

104       READ ( INPUT_UNIT, '(A)' ) TXTLINE
          IF ( TXTLINE(1:3) .EQ. '!!!' .OR. TXTLINE(1:3) .EQ. '' ) GOTO 104
          IF( INDEX( TXTLINE, 'EMIS STREAM' ) .GE. 1 )THEN
              DELIMINATOR_INDEX = INDEX( TXTLINE, CHAR( 124 )  ) + 1
              IF(  DELIMINATOR_INDEX .LE. 1 )THEN
                 XMSG = 'ISAM ERROR: a "EMIS STREAM(s)" line missing the "|" deliminator'
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF 
              TAGSTREAMS_TEMP( ITAG ) = TXTLINE( DELIMINATOR_INDEX:LEN_TRIM( TXTLINE ) )
              IF( LEN_TRIM( TAGSTREAMS_TEMP( ITAG ) ) .LT. 1 )THEN
                 XMSG = 'ISAM ERROR: a "EMIS STREAM(s)" in control file is blank. '
                 CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
              END IF
          ELSE   
              XMSG = "ISAM ERROR: Third line defining a TAG "
     &            // 'in control file must contain the "EMIS STREAM(s)" ' 
              CALL M3EXIT('SA_IOLIST', 0, 0, XMSG, XSTAT2 )
          END IF

        END DO
        
c add a bidirectional tag if necesssary
        IF ( SA_BIDI ) THEN
          TAGNAME( NTAGS )         = 'BID' 
          ISAMRGN_TEMP( NTAGS )    = 'EVERYWHERE'
          TAGSTREAMS_TEMP( NTAGS ) = 'BIDIRECTIONALNH3'
        ENDIF

        END SUBROUTINE RD_SA_IO_LIST
C============================================================
        
        SUBROUTINE GET_NSPC_SA ()

C20140428  Determine number of ISAM species
C         Called by sa_dim.F
C

        USE RUNTIME_VARS
        USE GRID_CONF    ! just for mype 20140327
        USE CGRID_SPCS, ONLY : N_AE_SPC, AE_SPC
        USE RXNS_DATA,  ONLY : MECHNAME, NUMB_MECH_SPC !Get Chemical Mechanism Name
!       USE DEGRADE_PARAMETERS
        USE UTILIO_DEFN  ! 20130627

        IMPLICIT NONE

        INTEGER :: ITAG
        INTEGER :: J, K

        LOGICAL :: LBACK
        LOGICAL :: DEFINED 
        INTEGER :: BGN_SP
        LOGICAL :: EFLAG = .FALSE. 
        INTEGER :: CLASSES_FOUND  = 0
        
        CHARACTER( 132 ) :: XMSG

        INTEGER :: IOST
        CHARACTER( MAX_STRING ), ALLOCATABLE :: CLASS_NAMES( : )
        INTEGER :: NCLASSES = 0
        
c----------------------------------------------------------


        ALLOCATE( CLASS_NAMES( MAX_TAGCLASSES ) )
        CALL PARSE_STRING( TAGCLASSES, NCLASSES, CLASS_NAMES )
                
        IF( NCLASSES .LT. 1 )THEN
           XMSG = "ISAM ERROR: TAGCLASSES in control file incorrectly defined. "
           CALL M3EXIT('GET_NSPC_SA', 0, 0, XMSG, XSTAT2 )
        END IF
        
        DO J = 1, NCLASSES
           K = INDEX1( CLASS_NAMES( J ), NUMB_CLASSES, DEFINED_CLASSES )
           IF( K .LT. 1 )THEN
              XMSG = "ISAM ERROR: unknown tagclass: " // TRIM( CLASS_NAMES( J ) )
              WRITE(LOGDEV,'(A)')TRIM(XMSG )
              EFLAG = .TRUE. 
           ELSE
              CLASSES_FOUND = CLASSES_FOUND + 1   
           END IF       
        END DO
        
        IF( EFLAG .OR. CLASSES_FOUND .LT. 1 )THEN
           XMSG = 'ISAM ERROR: problem defining tagclasses'
           WRITE(LOGDEV,'(A)')TRIM(XMSG )
           XMSG = 'Permitted TAGCLASSES listed below:'
           WRITE(LOGDEV,'(A)')TRIM(XMSG )
           DO J = 1, NUMB_CLASSES
              WRITE(LOGDEV,'(2X,A)')TRIM( DEFINED_CLASSES( J ) )
           END DO
           XMSG = 'Above fatal error(s) in setting up ISAM'
           CALL M3EXIT('GET_NSPC_SA', 0, 0, XMSG, XSTAT2 )
        END IF 
        
        L_EC     = .FALSE. 
        L_OC     = .FALSE. 
        L_SFATE  = .FALSE. 
        L_NITRATE = .FALSE. 
        L_NH4     = .FALSE. 
        L_PM25    = .FALSE.   
!        L_CO      = .FALSE.   
        L_OZONE   = .FALSE.   
        L_VOC     = .FALSE.   
        L_CHLORINE  = .FALSE.
!       L_GAS_HAPS  = .FALSE.
!       L_AERO_HAPS = .FALSE.
!       L_CHEMISTRY = .FALSE.   

        NSPC_SA = 0

        LBACK = .FALSE. 

!       LBACK = .FALSE.
!       BGN_SP = INDEX( TAGCLASSES,'CHEMISTRY',LBACK )
!       IF ( BGN_SP .NE. 0 ) THEN
!         NSPC_SA = NSPC_SA + NUMB_MECH_SPC  ! CO
!         L_CHEMISTRY = .TRUE.
!         L_NITRATE   = .TRUE.
!         L_VOC       = .TRUE.
!         L_CHLORINE  = .TRUE.
!       ENDIF

        BGN_SP = INDEX( TAGCLASSES,'CHLORINE',LBACK )        
        L_CHLORINE = ( BGN_SP .NE. 0 .OR. L_CHLORINE )
        IF ( L_CHLORINE ) THEN
          NSPC_SA = NSPC_SA + 3  ! ACLI, ACLJ, HCL
        ENDIF

        BGN_SP = INDEX( TAGCLASSES,'EC',LBACK )
        IF ( BGN_SP .NE. 0 ) THEN
          NSPC_SA = NSPC_SA + 2  ! AECJ, AECI
          L_EC = .TRUE.
        ENDIF

        BGN_SP = INDEX( TAGCLASSES,'OC',LBACK )
        IF ( BGN_SP .NE. 0 ) THEN
c          NSPC_SA = NSPC_SA + 13  ! ALVPO1I,ALVPO1J,ASVPO1I,ASVPO1J,ASVPO2I,ASVPO2J,ASVPO3J,AIVPO1J
                                  ! VLVPO1,VSVPO1,VSVPO2,VSVO3,VIVPO1
          NSPC_SA = NSPC_SA + 4   ! APOCJ, APOCI, APNCOMJ, APNCOMI  
          L_OC = .TRUE.
        ENDIF

        BGN_SP = INDEX( TAGCLASSES,'SULFATE',LBACK )
        IF ( BGN_SP .NE. 0 ) THEN
          L_SFATE  = .TRUE. 
          NSPC_SA = NSPC_SA + 5  ! ASO4J, ASO4I, SO2, SULF, SULRXN
          IF ( MECHNAME .EQ. 'CB6R3M_AE7_KMTBR' ) NSPC_SA = NSPC_SA + 1  ! add DMS
        ENDIF

        BGN_SP = INDEX( TAGCLASSES,'OZONE',LBACK )
        IF ( BGN_SP .NE. 0 ) THEN
          NSPC_SA = NSPC_SA + 4  ! O3, O1D, O or O3P, HO2
          L_OZONE   = .TRUE.
          L_NITRATE = .TRUE.
          L_VOC     = .TRUE.
        END IF       

        BGN_SP = INDEX( TAGCLASSES,'NITRATE',LBACK )
        L_NITRATE = ( BGN_SP .NE. 0 .OR. L_NITRATE )

        BGN_SP = INDEX( TAGCLASSES,'VOC',LBACK )
        L_VOC = ( BGN_SP .NE. 0 .OR. L_VOC )

!        BGN_SP     = INDEX( TAGCLASSES,'GAS_HAPS',LBACK )        
!        L_GAS_HAPS = ( BGN_SP .NE. 0 .OR. L_GAS_HAPS )
!        IF ( L_GAS_HAPS ) THEN
!          SELECT CASE( MECHNAME )
!             CASE( 'CB6R3_AE6_AQ', 'CB6R3_AE7_AQ', 'CB6R3M_AE7_KMTBR' )
!                NSPC_SA = NSPC_SA + 5  ! FORM_PRIM, ALD2_PRIM, ACRO, ACRO_PRIM, 13BUTADIENE
!             CASE( 'SAPRC07TC_AE6_AQ','SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ' ) 
!                NSPC_SA = NSPC_SA + 5  ! HCHO_PRIM, CCHO_PRIM, ACRO, ACRO_PRIM, 13BUTADIENE 
!             CASE( 'RACM2_AE6_AQ') 
!                NSPC_SA = NSPC_SA + 0   
!          END SELECT
!          CALL DEGRADE_DATA()        
!          NSPC_SA = NSPC_SA + NDEGRADED_FOUND ! degradation species found in species namelists
!        ENDIF

        DEFINED = .TRUE.

        IF( L_NITRATE .OR. L_VOC .OR. L_OZONE )THEN ! determine if tag species are defined by mechanism's name
          SELECT CASE( MECHNAME ) 
             CASE( 'CB6R3_AE6_AQ',     'CB6R3_AE7_AQ',      'CB6R3M_AE7_KMTBR', 
     &             'SAPRC07TC_AE6_AQ', 'SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ',
     &             'RACM2_AE6_AQ'                                               ) 
                DEFINED = .TRUE.
             CASE DEFAULT 
                DEFINED = .FALSE.
          END SELECT
        END IF
       
        IF( .NOT. DEFINED )THEN
            XMSG = "ISAM ERROR: Using L_NITRATE or L_VOC or L_OZONE tag group but their species "
     &          // "for the " // TRIM( MECHNAME ) // " mechanism not defined. Modify GET_NSPC_SA "
     &          // "and GET_SPC_INDEX  subroutines to include MECHNAME cases for it."
            CALL M3EXIT('GET_NSPC_SA', 0, 0, XMSG, XSTAT2 )
        END IF
        
        IF ( L_NITRATE ) THEN
          SELECT CASE( MECHNAME )
             CASE( 'CB6R3_AE6_AQ', 'CB6R3_AE7_AQ' )
                NSPC_SA = NSPC_SA + 13  
!                NSPC_SA = NSPC_SA + 19
             CASE( 'CB6R3M_AE7_KMTBR' )
                NSPC_SA = NSPC_SA + 18  
!                NSPC_SA = NSPC_SA + 24  
             CASE( 'SAPRC07TC_AE6_AQ' ) 
                NSPC_SA = NSPC_SA + 16   
             CASE( 'RACM2_AE6_AQ') 
                NSPC_SA = NSPC_SA + 14   
             CASE( 'SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ' ) 
                NSPC_SA = NSPC_SA + 33  
          END SELECT
! specices common to all mechanisms          
          NSPC_SA = NSPC_SA + 11  ! NO, NO2, NO3, ANO3J, ANO3I, HNO3, HONO, N2O5, PNA or HNO4, PAN, PANX or PAN2 or MPAN
        ENDIF

        IF ( L_VOC ) THEN
          SELECT CASE( MECHNAME )
             CASE( 'CB6R3_AE6_AQ' )
                NSPC_SA = NSPC_SA + 25
             CASE( 'CB6R3_AE7_AQ', 'CB6R3M_AE7_KMTBR' )
                NSPC_SA = NSPC_SA + 26
             CASE( 'RACM2_AE6_AQ') 
                NSPC_SA = NSPC_SA + 37
             CASE( 'SAPRC07TC_AE6_AQ', 'SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ' ) 
                NSPC_SA = NSPC_SA + 40
          END SELECT
        ENDIF

        LBACK = .FALSE.
        BGN_SP = INDEX( TAGCLASSES,'AMMONIUM',LBACK )
        IF ( BGN_SP .NE. 0 ) THEN
          NSPC_SA = NSPC_SA + 3  ! ANH4J, ANH4I, NH3
          L_NH4 = .TRUE.
        ENDIF

        LBACK = .FALSE.
        BGN_SP = INDEX( TAGCLASSES,'PM25_IONS',LBACK )
        IF ( BGN_SP .NE. 0 ) THEN
          NSPC_SA = NSPC_SA + 12 ! ANAI/J,AMGJ,AKJ,ACAJ,AFEJ,AALJ,ASI/J,ATIJ,AMNJ,AOTHRI/J
          L_PM25 = .TRUE.
        ENDIF

!        LBACK = .FALSE.
!        BGN_SP = INDEX( TAGCLASSES,'CO',LBACK )
!        IF ( BGN_SP .NE. 0 ) THEN
!          NSPC_SA = NSPC_SA + 1  ! CO
!          L_CO = .TRUE.
!        ENDIF

!        LBACK = .FALSE.
!        BGN_SP = INDEX( TAGCLASSES,'AERO_HAPS',LBACK )
!        IF ( BGN_SP .NE. 0 ) THEN          
!          L_AERO_HAPS = .TRUE.
!          DO J = 1, N_AERO_HAPS_LIST
!             DO K = 1, N_AE_SPC
!                IF( INDEX( AE_SPC( K ), AERO_HAPS_LIST( J ) ) .GT. 0 ) THEN
!                   NSPC_SA     = NSPC_SA + 1
!                   N_AERO_HAPS = N_AERO_HAPS + 1
!                END IF  
!             END DO           
!          END DO
!        ENDIF

        END SUBROUTINE GET_NSPC_SA

! --------------------------------------------------------------------------------
        SUBROUTINE PARSE_STRING ( ENV_VAL, NVARS, VAL_LIST, LOGDEV )

! takes a string of items delimited by white space,
! commas or semi-colons) and parse out the items into variables. Two data
! types: character strings and integers (still represented as strings in
! the env var vaules).
          USE UTILIO_DEFN 
          
          IMPLICIT NONE

          CHARACTER( * ), INTENT ( IN )           :: ENV_VAL
          INTEGER,        INTENT ( OUT )          :: NVARS
          CHARACTER( * ), INTENT ( OUT )          :: VAL_LIST( : )
          INTEGER,        INTENT ( IN ), OPTIONAL :: LOGDEV

          INTEGER             :: MAX_LEN
          INTEGER             :: LEN_EVAL
          CHARACTER( 16 )     :: PNAME = 'PARSE_STRING'
          CHARACTER(  1 )     :: CHR
          CHARACTER( 96 )     :: XMSG

          INTEGER :: JP( MAX_STRING*SIZE( VAL_LIST ) )
          INTEGER :: KP( MAX_STRING*SIZE( VAL_LIST ) )
          INTEGER :: STATUS
          INTEGER :: IP, V

          INTEGER :: LOC_LOGDEV
 
          IF (PRESENT(LOGDEV)) THEN
             LOC_LOGDEV = LOGDEV
          ELSE
             LOC_LOGDEV = 6
          END IF

          MAX_LEN = MAX_STRING * ( SIZE( VAL_LIST ) + 1 ) ! extra character allows deliminator

C Parse:

           NVARS = 0

C don't count until 1st char in string
           
           IP = 0
           KP = 1
           JP = 1
           LEN_EVAL = LEN_TRIM( ENV_VAL ) 
           IF ( LEN_EVAL .GT. MAX_LEN ) THEN
              XMSG = TRIM( PNAME ) // ': The Environment variable, '
     &            // TRIM( ENV_VAL ) // ',  has too long, greater than ' 
              WRITE(LOGDEV,'(A,I8)')TRIM( XMSG ), MAX_LEN
              XMSG = 'Above fatal error encountered '
              CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
           END IF
101        LOOP_101: DO  ! read list
              IP = IP + 1
              IF ( IP .GT. LEN_EVAL ) EXIT LOOP_101
              CHR = ENV_VAL( IP:IP )
              IF ( CHR .EQ. ' ' .OR. ICHAR ( CHR ) .EQ. 09 ) CYCLE LOOP_101
              IF( NVARS .GT. SIZE( VAL_LIST ) )THEN
                 XMSG = TRIM( PNAME ) // ':ERROR: Number of values in List, ' 
     &                //  TRIM( ENV_VAL ) 
     &                // ', greater than the size of its storage array, '
                  WRITE(LOGDEV,'(A,I4)')TRIM( XMSG ), SIZE( VAL_LIST )
                  XMSG = 'Above fatal error encountered '
                  CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
              END IF
              NVARS = NVARS + 1
              JP( NVARS ) = IP   ! 1st char
              IF( IP .EQ. LEN_EVAL )THEN ! word one character long          
                  KP( NVARS ) = IP
                  V = 1
                  EXIT LOOP_101
              END IF     
201           LOOP_201: DO ! read word
                 IP = IP + 1
                 CHR = ENV_VAL( IP:IP )
                 IF ( CHR .NE. ' ' .AND.
     &                CHR .NE. ',' .AND.
     &                CHR .NE. ';' .OR.
     &                ICHAR ( CHR ) .EQ. 09 ) THEN  ! 09 = horizontal tab
                    CYCLE LOOP_201
                 ELSE                               ! last char in word
                    KP( NVARS ) = IP - 1 
                    V = JP( NVARS ) - IP
                    IF( V .GT. MAX_STRING )THEN
                      XMSG =  'The word, ' // ENV_VAL( JP(NVARS):KP(NVARS) ) 
     &                     // ', in list, ' // TRIM( ENV_VAL )
     &                     // ', is too long, '
                      WRITE(LOGDEV,'(A,1X,I2,A,I2)')TRIM( XMSG ), V, ' max allowed ',
     &                MAX_STRING
                      XMSG = 'Above fatal error encountered '
                      CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
                    END IF
                    EXIT LOOP_201
                 END IF 
                 IF ( IP .GE. LEN_EVAL ) EXIT LOOP_101
              END DO LOOP_201
           END DO LOOP_101
           
           IF( NVARS .GT. SIZE( VAL_LIST ) )THEN
              XMSG = TRIM( PNAME ) // ':ERROR: Number of values in List, ' 
     &             //  TRIM( ENV_VAL ) // ', greater than '
              WRITE(LOGDEV,'(A,I4)')TRIM( XMSG ), SIZE( VAL_LIST )
              XMSG = 'Above fatal error encountered '
              CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )                     
           END IF
           DO V = 1, NVARS
              VAL_LIST( V ) = ENV_VAL( JP( V ):KP( V ) )
           END DO

           RETURN
           
        END SUBROUTINE PARSE_STRING

c===============================================================

        SUBROUTINE GET_SPC_INDEX ()

C20140428  Map CGRID species index to ISAM tracer species index
C         Called by driver.F
C

        USE CGRID_SPCS     
        USE RXNS_DATA,    ONLY : MECHNAME, NUMB_MECH_SPC, CHEMISTRY_SPC 
!        USE DEGRADE_PARAMETERS
        USE RUNTIME_VARS, ONLY: MYPE
        USE UTILIO_DEFN    

        IMPLICIT NONE
      
        INTEGER J_SPC, N, ITAG, I2, ISUM
        INTEGER N_OZN     ! index of ozone in gc_spc list
        INTEGER ALLOCSTAT

        CHARACTER( 16 ), ALLOCATABLE, SAVE :: CMAQ_ADV_NAMES( : ) 
        
        CHARACTER( 16 ), ALLOCATABLE :: SPC_LIST( : )
        LOGICAL,         ALLOCATABLE :: SPC_KEEP( : )
        
        INTEGER FRST, LAST, CMAQ_ADV

        INTEGER I_SPC, K_SPC, NLIST
         
        CHARACTER( 132 ) :: XMSG

        LOGICAL FOUND
        LOGICAL TRANS_WARN
        LOGICAL EFLAG
c----------------------------------------------------------
        

        NLIST = NSPC_SA
        ALLOCATE ( SPC_LIST( NLIST ), STAT = ALLOCSTAT )
        ALLOCATE ( SPC_KEEP( NLIST ), STAT = ALLOCSTAT )
        SPC_LIST = ' '
        SPC_KEEP = .TRUE.
        
        J_SPC = 0
         
        EFLAG = .FALSE.
         
        IF (  L_CHLORINE ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ACLJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ACLI'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'HCL'
        ENDIF
        
        IF (  L_EC ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AECJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AECI'   
        ENDIF

        IF ( L_OC ) THEN
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ALVPO1J'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ALVPO1I'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ASVPO1J'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ASVPO1I'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ASVPO2J'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ASVPO2I'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'ASVPO3J'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'AIVPO1J'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'VLVPO1'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'VSVPO1'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'VSVPO2'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'VSVPO3'
c            J_SPC = J_SPC + 1
c            SPC_LIST( J_SPC ) = 'VIVPO1'
            J_SPC = J_SPC + 1
            SPC_LIST( J_SPC ) = 'APOCJ'
            J_SPC = J_SPC + 1
            SPC_LIST( J_SPC ) = 'APOCI'
            J_SPC = J_SPC + 1
            SPC_LIST( J_SPC ) = 'APNCOMJ'
            J_SPC = J_SPC + 1
            SPC_LIST( J_SPC ) = 'APNCOMI'
        ENDIF

          
        IF ( L_SFATE ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ASO4J'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ASO4I'    
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'SO2'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'SULF'    
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'SULRXN'
          IF ( MECHNAME .EQ. 'CB6R3M_AE7_KMTBR' ) THEN
             J_SPC = J_SPC + 1
             SPC_LIST( J_SPC ) = 'DMS'
          END IF
        ENDIF

        IF ( L_NITRATE ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ANO3J'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ANO3I'    
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'HNO3'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'NO'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'NO2'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'NO3'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'HONO'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'N2O5'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'PAN'
          SELECT CASE( MECHNAME )
             CASE( 'CB6R3_AE6_AQ', 'CB6R3_AE7_AQ' )
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'NTR1' 
               J_SPC = J_SPC + 1  
               SPC_LIST( J_SPC ) = 'NTR2'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'INTR'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PNA'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PANX'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLNO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLNO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XO2H'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XO2N'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ROR' 
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MEO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ISO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'C2O3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CXO3'                
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'OPO3'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'BZO2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'TO2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'XLO2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'EPX2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'HCO3'                
             CASE( 'CB6R3M_AE7_KMTBR' )
               J_SPC = J_SPC + 1  
               SPC_LIST( J_SPC ) = 'NTR1'   
               J_SPC = J_SPC + 1  
               SPC_LIST( J_SPC ) = 'NTR2'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'INTR'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PNA'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PANX'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLNO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLNO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'BRNO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'BRNO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'INO'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'INO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'INO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XO2H'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XO2N'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ROR' 
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MEO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ISO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'C2O3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CXO3'                
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'OPO3'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'BZO2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'TO2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'XLO2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'EPX2'
!                J_SPC = J_SPC + 1
!                SPC_LIST( J_SPC ) = 'HCO3'                
             CASE( 'SAPRC07TC_AE6_AQ' ) 
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'HNO4'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RNO3'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PAN2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLNO'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLONO'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLONO2'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xNO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MEO2'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xMEO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RO2C'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RO2XC'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MECO3'
               
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xMECO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RCO3'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xRCO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'BZCO3'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PBZN'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MACO3'
               
             CASE( 'SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ' ) 
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'HNO4'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RNO3'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PAN2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLNO'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLONO'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'CLONO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ETHLN'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'IMAE'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'IMAPAN'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ISOPNN'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MACRN'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'NIT1'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MVKN'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PROPNN'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MTNO3'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'AMTNO3J'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'AISOPNNJ'  
                
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xNO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MEO2'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xMEO2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RO2C'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RO2XC'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MECO3'
               
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xMECO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RCO3'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'xRCO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'BZCO3'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'PBZN'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MACO3'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'TERPNRO2'  
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ISOPO2'  

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'NISOPO2'  
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MVKOO'  

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MACROO'  
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RNO3I'  

!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'DIBOO'  
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'HC5OO'  

!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'NIT1NO3OOA'  
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'NIT1NO3OOB'  


             CASE( 'RACM2_AE6_AQ') 
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'HNO4'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ONIT'   
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MPAN'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ACO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'MO2'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'HC3P'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'HC5P'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'HC8P'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'KETP'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ISOP'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ETHP'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'RCO3'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'XYLP'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'TR2'
               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'BENP'

               J_SPC = J_SPC + 1
               SPC_LIST( J_SPC ) = 'ETEP'

          END SELECT 
        ENDIF ! L_NITRATE

        IF ( L_VOC ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'CO'
          SELECT CASE( MECHNAME )
             CASE( 'CB6R3_AE6_AQ' )
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALD2'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALDX'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETHA'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'FORM'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'IOLE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ISOP'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OLE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ECH4'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'PAR'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TERP'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TOL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'XYLMN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'NAPH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETHY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'PRPA'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACET'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'KET'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'GLY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'BENZENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'GLYD'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEPX'                
             CASE( 'CB6R3_AE7_AQ', 'CB6R3M_AE7_KMTBR' )
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALD2'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALDX'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETHA'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'FORM'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'IOLE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ISOP'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OLE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ECH4'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'PAR'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TERP'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TOL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'XYLMN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'NAPH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETHY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'PRPA'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACET'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'KET'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'GLY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'BENZENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'APIN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'GLYD'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEPX'                
             CASE( 'SAPRC07TC_AE6_AQ', 'SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ' ) 
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'HCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'CCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'RCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'xHCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'xCCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'xRCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALK1'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALK2'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALK3'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALK4'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALK5'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETHENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACETYLENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'PROPENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ISOPRENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TERP'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'SESQ'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'APIN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OLE1'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OLE2'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'GLY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MGLY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'BENZENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TMBENZ124'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TOLUENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MXYL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OXYL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'PXYL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'NAPHTHAL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ARO1'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ARO2MN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'BUTADIENE13'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACROLEIN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACETONE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEK'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MVK'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MACR'
             CASE( 'RACM2_AE6_AQ') 
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'HCHO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACD'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ALD'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'UALD'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'HC3'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'HC5'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'HC8'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OLI'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'OLT'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ETE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ISO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'SESQ'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'LIM'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'API'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'EOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MOH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'GLY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MGLY'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'BENZENE'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'TOL'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'XYM'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'XYO'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'XYP'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'NAPH'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'DIEN'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'ACT'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'HKET'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'KET'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MVK'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MEK'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'MACR'

                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'DCB1'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'DCB2'
                J_SPC = J_SPC + 1
                SPC_LIST( J_SPC ) = 'DCB3'

          END SELECT
        ENDIF ! L_VOC

        IF (  L_NH4 ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ANH4J'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ANH4I'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'NH3'
        ENDIF

        IF ( L_PM25 ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ANAJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ANAI' 
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AMGJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AKJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ACAJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AFEJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AALJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ASIJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'ATIJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AMNJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AOTHRJ'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'AOTHRI'
        ENDIF

!        IF ( L_CO ) THEN
!          J_SPC = J_SPC + 1
!          SPC_LIST( J_SPC ) = 'CO'
!        ENDIF

        IF ( L_OZONE ) THEN
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'HO2'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'O3'
          J_SPC = J_SPC + 1
          SPC_LIST( J_SPC ) = 'O1D'
          J_SPC = J_SPC + 1
          SELECT CASE( MECHNAME )
             CASE( 'CB6R3_AE6_AQ', 'CB6R3_AE7_AQ', 'CB6R3M_AE7_KMTBR')
                SPC_LIST( J_SPC ) = 'O'
             CASE( 'SAPRC07TC_AE6_AQ', 'RACM2_AE6_AQ', 'SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ' ) 
                SPC_LIST( J_SPC ) = 'O3P'
          END SELECT
        ENDIF


!        IF ( L_GAS_HAPS ) THEN
!          SELECT CASE( MECHNAME )
!             CASE( 'CB6R3_AE6_AQ', 'CB6R3_AE7_AQ', 'CB6R3M_AE7_KMTBR' )
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'FORM_PRIMARY'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'ALD2_PRIMARY'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'ACROLEIN'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'BUTADIENE13'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'ACRO_PRIMARY'
!             CASE( 'SAPRC07TC_AE6_AQ','SAPRC07TIC_AE6I_AQ', 'SAPRC07TIC_AE7I_AQ')
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'HCHO_PRIMARY'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'CCHO_PRIMARY'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'ACROLEIN'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'BUTADIENE13'
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = 'ACRO_PRIMARY'
!            END SELECT
!            DO I_SPC = 1, NDEGRADED_FOUND
!               J_SPC = J_SPC + 1
!               SPC_LIST( J_SPC ) = DEGRADED_SPECIES( I_SPC )
!            END DO
!        END IF

!        IF ( L_AERO_HAPS ) THEN          
!          DO I_SPC = 1, N_AERO_HAPS_LIST
!             DO K_SPC = 1, N_AE_SPC
! find HAP aerosols in aerosol species and adjust NSPC_SA if in SPC_LIST
!                IF ( INDEX(  AE_SPC( K_SPC ), AERO_HAPS_LIST( I_SPC ) ) .GT. 0 ) THEN 
!                   J_SPC = J_SPC + 1
!                   SPC_LIST( J_SPC ) = AE_SPC( K_SPC )
!                END IF 
!             END DO            
!          END DO
!        ENDIF
        
!       IF ( L_CHEMISTRY ) THEN
!          SPC_LIST( ( J_SPC+1 ):( J_SPC+NUMB_MECH_SPC ) ) = CHEMISTRY_SPC( 1:NUMB_MECH_SPC )
!          J_SPC = J_SPC + NUMB_MECH_SPC 
!       END IF

C...Check if the above adds up to number of tagging species
        IF ( J_SPC .NE. NSPC_SA ) THEN
          WRITE(LOGDEV,'(A,I4,A,I4,3A)')'Tagged species found, ', J_SPC,  
     &    ', does not equal expected, ',  NSPC_SA,
     &    ', for the ', TRIM( MECHNAME ), ' mechanism.'
          EFLAG = .TRUE.
        ELSE
         WRITE(LOGDEV,'(A,I4,A,I4,3A)')'Tagged species found, ', J_SPC,
     &    ', equals expected, ',  NSPC_SA,
     &    ', for the ', TRIM( MECHNAME ), ' mechanism.'
        ENDIF

! check for redundant species names
        DO I_SPC = 1, NSPC_SA
             WRITE(LOGDEV,'(A,I4,1X,A16)')'ISAM_INIT: SPC_LIST: ',I_SPC,SPC_LIST( I_SPC )
        END DO
        DO I_SPC = 1, NSPC_SA
           IF ( .NOT. SPC_KEEP( I_SPC ) )CYCLE
           IF ( LEN_TRIM( SPC_LIST( I_SPC ) ) .LT. 1 ) THEN
c             WRITE(6,'(A,I4)')'ISAM_INIT ERROR: SPC_LIST blank at index: ',I_SPC
              WRITE(LOGDEV,'(A,I4)')'ISAM_INIT ERROR: SPC_LIST blank at index: ',I_SPC
              EFLAG = .TRUE.
              CYCLE
           ELSE                 
c             WRITE(6,'(A,I4,1X,A16)')'ISAM_INIT: SPC_LIST: ',I_SPC,SPC_LIST( I_SPC )
              WRITE(LOGDEV,'(A,I4,1X,A16)')'ISAM_INIT: SPC_LIST: ',I_SPC,SPC_LIST( I_SPC )
           END IF
           DO K_SPC = 1, NSPC_SA
              IF( I_SPC .EQ. K_SPC )CYCLE
              IF ( SPC_LIST( I_SPC ) .EQ. SPC_LIST( K_SPC ) ) THEN
                     SPC_KEEP( K_SPC ) = .FALSE.
                     J_SPC = J_SPC - 1
                     WRITE(LOGDEV,'(A,I4,1X,A16,A,I4)')
     &              'ISAM_INIT: Omitting redundant species ',
     &               K_SPC,SPC_LIST( K_SPC ),' NSPC_SA now = ',J_SPC
              END IF
           END DO
        END DO

        IF ( EFLAG ) THEN
          CALL M3EXIT( 'GET_SPC_INDEX', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
        END IF 

! reset number of track species        
        NSPC_SA  = J_SPC
        N_SPCTAG = NSPC_SA * NTAG_SA
    
        ALLOCATE ( SPC_NAME( NSPC_SA, NTAG_SA ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'SPC_NAME', 'GET_SPC_INDEX' )
        SPC_NAME = ' '
        ALLOCATE ( SPC_INDEX( NSPC_SA,20 ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'SPC_INDEX', 'GET_SPC_INDEX' )
        SPC_INDEX = -1
        ALLOCATE ( IS_SPC_AEROSOL( NSPC_SA,NTAG_SA ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'IS_SPC_AEROSOL', 'IS_SPC_AEROSOL' )
        IS_SPC_AEROSOL = .FALSE.
        ALLOCATE ( TRANSPORT_SPC( N_SPCTAG ), STAT = ALLOCSTAT )
        CALL CHECKMEM( ALLOCSTAT, 'TRANSPORT_SPC', 'TRANSPORT_SPC' )
        TRANSPORT_SPC = .TRUE.

! set species names
        I_SPC = 0
        WRITE(LOGDEV,*)'# FINAL List of ISAM species = ', NSPC_SA 
        DO K_SPC = 1, NLIST
           IF( SPC_KEEP( K_SPC ) )THEN
              I_SPC = I_SPC + 1
              SPC_NAME( I_SPC,: ) = SPC_LIST( K_SPC )
           END IF
        END DO
        DO I_SPC = 1, NSPC_SA 
           WRITE(LOGDEV,'(I4,1X,A16)')I_SPC, SPC_NAME( I_SPC,1 )
        END DO


C...Initialize species index
        SPC_INDEX = -1

C..Determine which ISAM species are aerosols and are transported
        NSPC_TRANSPORT = 0
        ISUM  = 0
        DO ITAG = 1, NTAG_SA
           DO J_SPC = 1, NSPC_SA
              ISUM = ISUM + 1
              DO N = 1, N_AE_SPC
                 IF( TRIM( SPC_NAME( J_SPC,ITAG ) ) .EQ. TRIM( AE_SPC( N ) ) )THEN
                     IS_SPC_AEROSOL( J_SPC,ITAG ) = .TRUE.
                 END IF
              END DO
              FOUND = .FALSE.        
              DO N = 1, N_GC_TRNS
                 IF( TRIM( SPC_NAME( J_SPC,ITAG ) ) .EQ. TRIM( GC_TRNS( N ) ) )FOUND = .TRUE.
              END DO
              DO N = 1, N_AE_TRNS
                 IF( TRIM( SPC_NAME( J_SPC,ITAG ) ) .EQ. TRIM( AE_TRNS( N ) ) )FOUND = .TRUE.
              END DO
              DO N = 1, N_NR_TRNS
                 IF( TRIM( SPC_NAME( J_SPC,ITAG ) ) .EQ. TRIM( NR_TRNS( N ) ) )FOUND = .TRUE.
              END DO
              DO N = 1, N_TR_ADV
                 IF( TRIM( SPC_NAME( J_SPC,ITAG ) ) .EQ. TRIM( TR_ADV( N ) ) )FOUND = .TRUE.
              END DO
              TRANSPORT_SPC( ISUM ) = FOUND
              IF( FOUND )NSPC_TRANSPORT = NSPC_TRANSPORT + 1
           END DO  
        END DO

C...Assign species index with CMAQ species mappings
        ALLOCATE( MAP_CGRtoSA( NSPCSD ) )
        MAP_CGRtoSA = 0

        LOOP_FIND: DO N = 1, NSPCSD
          IF ( N .GE. GC_STRT .AND. N .LE. GC_FINI ) THEN
            DO J_SPC = 1, NSPC_SA
              IF ( SPC_NAME( J_SPC,ICONTAG ) .EQ. GC_SPC( N ) ) THEN  
                SPC_INDEX( J_SPC,1 ) = 1
                SPC_INDEX( J_SPC,2 ) = N
                MAP_CGRtoSA( N ) = J_SPC
                CYCLE LOOP_FIND
              END IF ! spc_name and gc_spc match
            END DO
          ELSE IF ( N .GE. AE_STRT .AND. N .LE. AE_FINI ) THEN
            DO J_SPC = 1, NSPC_SA
              IF ( TRIM( SPC_NAME( J_SPC,ICONTAG ) ) .EQ. TRIM( AE_SPC( N-AE_STRT+1 ) ) ) THEN
                SPC_INDEX( J_SPC,1 ) = 1
                SPC_INDEX( J_SPC,2 ) = N
                MAP_CGRtoSA( N ) = J_SPC
                CYCLE LOOP_FIND
              END IF ! spc_name and ae_spc match
            END DO
          ELSE IF ( N .GE. NR_STRT .AND. N .LE. NR_FINI ) THEN
            DO J_SPC = 1, NSPC_SA
              IF ( SPC_NAME( J_SPC,ICONTAG ) .EQ. NR_SPC( N-NR_STRT+1 ) ) THEN
                SPC_INDEX( J_SPC,1 ) = 1
                SPC_INDEX( J_SPC,2 ) = N
                MAP_CGRtoSA( N ) = J_SPC
                CYCLE LOOP_FIND
              END IF
            END DO          
          END IF
        END DO LOOP_FIND ! number of tagging species

        DO J_SPC = 1, NSPC_SA
          IF ( SPC_INDEX( J_SPC,2 ) .LT. 1 ) THEN
             write(logdev,'(A)')'Tracked species '
     &       // TRIM( SPC_NAME( J_SPC,ICONTAG ) ) //
     &          ' not found among model species '
             EFLAG = .TRUE.
          END IF
        END DO 

C...Map SA species for Advection
        ALLOCATE( MAP_ADVtoSA ( N_SPCTAG ) )
 
        CMAQ_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV
        ALLOCATE( CMAQ_ADV_NAMES( CMAQ_ADV ) )

        FRST = 0
        LAST = 0
        IF ( N_GC_TRNS .NE. 0 ) THEN 
           FRST = 1
           LAST = N_GC_TRNS
           CMAQ_ADV_NAMES( FRST:LAST ) = GC_TRNS(1:N_GC_TRNS)
        ENDIF

        IF ( N_AE_TRNS .NE. 0 ) THEN
           FRST = LAST + 1
           LAST = LAST + N_AE_TRNS
           CMAQ_ADV_NAMES( FRST:LAST ) = AE_TRNS(1:N_AE_TRNS)
        END IF

        IF ( N_NR_TRNS .NE. 0 ) THEN
           FRST = LAST + 1
           LAST = LAST + N_NR_TRNS
           CMAQ_ADV_NAMES( FRST:LAST ) = NR_TRNS(1:N_NR_TRNS)
        END IF

        IF ( N_TR_ADV .NE. 0 ) THEN
           FRST = LAST + 1
           LAST = LAST + N_TR_ADV
           CMAQ_ADV_NAMES( FRST:LAST ) = TR_ADV(1:N_TR_ADV)
        END IF

        MAP_ADVtoSA = -1
        N = 0
        TRANS_WARN = .FALSE.
        DO ITAG = 1, NTAG_SA
           DO J_SPC = 1, NSPC_SA
              N = N + 1
              MAP_ADVtoSA(N) = INDEX1( SPC_NAME(J_SPC,1), CMAQ_ADV, CMAQ_ADV_NAMES )
              IF( MAP_ADVtoSA(N) .LT. 1 .AND. ITAG .LT. 2 )THEN
                 TRANS_WARN = .TRUE.
                 XMSG = 'ISAM WARNING: Tagged Species, ' // TRIM( SPC_NAME(J_SPC,1) ) 
     &               // ' not transported. Modify species namelist(s) to include process.'
                 WRITE(LOGDEV,'(A)')TRIM( XMSG )
              END IF
!              XMSG = 'For ' // SPC_NAME(J_SPC,1) // ' transported, adv_map = '
!              WRITE(LOGDEV,95000)NSPC_TRANSPORT, J_SPC, TRIM( XMSG ),
!     &        TRANSPORT_SPC(J_SPC), MAP_ADVtoSA(N)
           END DO
        END DO
        
        IF ( TRANS_WARN ) THEN
          CALL M3WARN( 'GET_SPC_INDEX', 0, 0, 'Above Problems Encountered' )
        END IF
        IF ( EFLAG ) THEN
          CALL M3EXIT( 'GET_SPC_INDEX', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
        END IF 

95000    FORMAT(2(I3,1X),A,L4,1X,I4)


C...Map SA species for DEPV
C
C...  DO THIS LATER IF NEEDED FOR THE GENERAL CASE - RIGHT NOW ONLY DO AMMONIA
c       ALLOCATE( MAP_DEPVtoSA ( N_SPCTAG ) )

c       CMAQ_DEPV = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + N_TR_DEPV
c       ALLOCATE( CMAQ_DEPV_NAMES( CMAQ_DEPV ) )

c       FRST = 0
c       LAST = 0
c       IF ( N_GC_DEPV .NE. 0 ) THEN
c          FRST = 1
c          LAST = N_GC_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = GC_DEPV(1:N_GC_DEPV)
c       ENDIF

c       IF ( N_AE_DEPV .NE. 0 ) THEN
c          FRST = LAST + 1
c          LAST = LAST + N_AE_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = AE_DEPV(1:N_AE_DEPV)
c       END IF

c       IF ( N_NR_DEPV .NE. 0 ) THEN
c          FRST = LAST + 1
c          LAST = LAST + N_NR_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = NR_DEPV(1:N_NR_DEPV)
c       END IF

c       IF ( N_TR_DEPV .NE. 0 ) THEN
c          FRST = LAST + 1
c          LAST = LAST + N_TR_DEPV
c          CMAQ_DEPV_NAMES( FRST:LAST ) = TR_DEPV(1:N_TR_DEPV)
c       END IF

c       MAP_DEPVtoSA = -1
c       N = 0
!       DO ITAG = 1, NTAG_SA
c          DO J_SPC = 1, NSPC_SA
c             N = N + 1
c             MAP_DEPVtoSA(N) = INDEX1( SPC_NAME(J_SPC,1), CMAQ_DEPV, CMAQ_DEPV_NAMES )
c             IF( MAP_DEPVtoSA(N) .LT. 1 )THEN
c                XMSG = 'ISAM WARNING: Tagged Species, ' // TRIM( SPC_NAME(J_SPC,1) )
c    &               // ' not in DEPV list.'
c                CALL M3EXIT ( 'MAP_DEPVtoSA', 0, 0, XMSG, XSTAT1 )
c             END IF
c          END DO
!       END DO

        END SUBROUTINE GET_SPC_INDEX

      END MODULE SA_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!-----------------------------------------------------------------------
      Module AERO_BUDGET

!  Collects Aerosol Microphysical Process Rates
!
!-----------------------------------------------------------------------

      Implicit None

      SAVE

      ! These Arrays are sorted in the same manner as CGRID so they may
      ! be directly applied in modules like Process Analysis and ISAM
      REAL, ALLOCATABLE :: AERO_COAG  ( :,:,:,:,: ) ! Change in Species due to Coagulation
      REAL, ALLOCATABLE :: AERO_COND  ( :,:,:,: )   ! Change in Species due to Condensation
      REAL, ALLOCATABLE :: AERO_NPF   ( :,:,:,: )   ! Change in Species due to NPF
      REAL, ALLOCATABLE :: AERO_GROWTH( :,:,:,: )   ! Change in species due to aerosol 
                                                    !   renaming (mode merging)

!      Contains

C-----------------------------------------------------------------------

      End Module AERO_BUDGET

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_ACONC ( AGRID, JDATE, JTIME, TSTEP )

C Revision History:
C   Jeff - July 01
C   Note: If previous A_CONC exists, check that user hasn't changed what
C         species/layers to save (or domain).
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   20 Jul 11 J.Young: added option for ending time timestamp
C   12 Aug 15 D.Wong:  Extracted section of code that deals with creating
C                        A_CONC_1 and put it in opaconc.F
C                      Added a section of code to allow non IO processors
C                        to open A_CONC_1
C   19 May 16 D.Wong: renamed ACONC_END_TIME to AVG_FILE_ENDTIME
C   27 Mar 17 D.Wong: removed redundant parallel_io ifdef construct
C   09 Sep 19 F. Sidi: Replaced L_ACONC_WVEL(depreciated) with W_VEL
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE AVG_CONC              ! integral average CONC
      USE UTILIO_DEFN
      USE RUNTIME_VARS
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      REAL      :: AGRID( :,:,:,: )
      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:

      INTEGER      MDATE        ! modified model date, coded YYYYDDD
      INTEGER      MTIME        ! modified model time, coded HHMMSS

      CHARACTER( 16 ) :: PNAME = 'WR_ACONC'
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER      L, K, VAR, SPC ! loop counters
      INTEGER      STATUS

C-----------------------------------------------------------------------

C Change output date/time to starting date/time - e.g. timestamp 1995196:090000
C represents data computed from time 1995196:090000 to 1995196:100000

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Override default beginning time timestamp for ACONC?
         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( A_CONC_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // A_CONC_1 // ' file for update'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

      END IF

      IF ( END_TIME ) THEN   ! ending time timestamp
         MDATE = JDATE; MTIME = JTIME
      ELSE                   ! beginning time timestamp
         MDATE = JDATE; MTIME = JTIME
         CALL NEXTIME ( MDATE, MTIME, -TSTEP )
      END IF

      VAR = 0
    
      DO SPC = 1, N_A_GC_SPC
         VAR = VAR + 1

         IF ( .NOT. WRITE3( A_CONC_1, A_GC_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_GC_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      DO SPC = 1, N_A_AE_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( A_CONC_1, A_AE_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_AE_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      DO SPC = 1, N_A_NR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( A_CONC_1, A_NR_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_NR_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      ! Write Tracer Species Concentrations to Average Concentration File
      DO SPC = 1, N_A_TR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( A_CONC_1, A_TR_SPC( SPC ),
     &      MDATE, MTIME, AGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( A_TR_SPC( SPC ) )
     &           // ' to ' // A_CONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      ! Write Vertical Velocity to Average Concentration File
      IF ( W_VEL ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'WVEL',
     &        MDATE, MTIME, AVG_WVEL ) ) THEN
              XMSG = 'Could not write Vertical Wind Velocity'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
 
      ! Write Relative Humidity to Average Concentration File
      IF ( L_ACONC_RH ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'RH',
     &        MDATE, MTIME, AVG_RH ) ) THEN
              XMSG = 'Could not write Relative Humidity'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
      
      ! Write Temperature to Average Concentration File
      IF ( L_ACONC_TA ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'TA',
     &        MDATE, MTIME, AVG_TA ) ) THEN
              XMSG = 'Could not write Temperature'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
 

      ! Write Pressure to Average Concentration File
      IF (L_ACONC_PRES ) THEN
        IF ( .NOT. WRITE3( A_CONC_1, 'PRES',
     &        MDATE, MTIME, AVG_PRES ) ) THEN
              XMSG = 'Could not write Pressure'
     &             // ' to ' // A_CONC_1
              CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
        END IF 
      END IF
 

      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', A_CONC_1,
     &      'for date and time', MDATE, MTIME

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/driver/wrf/wr_aconc.F,v 1.6 2011/10/21 16:10:43 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_AVG_SA ( JDATE, JTIME, TSTEP )

C20140428  Writes hourly averaged ISAM conc to SA_ACONC_1
C
C          Called by driver.F
C
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses

C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
c     USE SA_LAYERS             ! 20140428 for AISAM_BLEV, AISAM_ELEV, SA_NLAYS
      USE SA_DEFN
      USE RUNTIME_VARS

!     USE SUBST_MODULES         ! stenex
!     USE SUBST_UTIL_MODULE     ! stenex

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:

      REAL, ALLOCATABLE :: BUF4( :,:,:,: )
      INTEGER      MDATE        ! modified model date, coded YYYYDDD
      INTEGER      MTIME        ! modified model time, coded HHMMSS

      CHARACTER( 16 ) :: PNAME = 'WR_AVG_SA'
      CHARACTER( 16 ) :: ACONC_END_TIME = 'ACONC_END_TIME'
      CHARACTER( 80 ) :: VARDESC = ' '
      CHARACTER( 96 ) :: XMSG = ' '

c     INTEGER, SAVE :: LOGDEV       ! FORTRAN unit number for log file
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK
c     LOGICAL, SAVE :: END_TIME = .FALSE.

      INTEGER      L, K, KD, VAR, SPC ! loop counters
      INTEGER      STATUS

      INTEGER, SAVE :: A_NLYS

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF
C-----------------------------------------------------------------------

C Change output date/time to starting date/time - e.g. timestamp 1995196:090000
C represents data computed from time 1995196:090000 to 1995196:100000

      IF ( FIRSTIME ) THEN
         LOGDEV = INIT3 ()

C Override default beginning time timestamp for ACONC?
c        VARDESC = 
c    &     'Flag to Override default beginning time timestamp for ACONC'
c        END_TIME = ENVYN( ACONC_END_TIME, VARDESC, END_TIME, STATUS )
c        IF ( STATUS .EQ. 1 ) THEN
c           XMSG = 'Environment variable improperly formatted'
c           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
c        ELSE IF ( STATUS .NE. 0 ) THEN
c           WRITE( LOGDEV, '(5X, A)' ) VARDESC
c           XMSG = '... Using default:'
c           WRITE( LOGDEV, '(5X, A, I9)' ) XMSG, JTIME
c        END IF

      END IF

      IF ( END_TIME ) THEN   ! ending time timestamp
         MDATE = JDATE; MTIME = JTIME
      ELSE                   ! beginning time timestamp
         MDATE = JDATE; MTIME = JTIME
         CALL NEXTIME ( MDATE, MTIME, -TSTEP )
      END IF

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Try to open existing file for update

c        CALL SUBST_BARRIER

         IF ( AISAM_ELEV .EQ. -1 ) AISAM_ELEV = NLAYS

         A_NLYS = AISAM_ELEV - AISAM_BLEV + 1

         OK = OPEN3( SA_ACONC_1, FSRDWR3, PNAME )
         CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )
         IF ( .NOT. OK ) THEN

            XMSG = 'Could not open ' // TRIM( SA_ACONC_1 )
     &           // ' file for update - try to open new'
            CALL M3MESG( XMSG )

            IF ( MYPE .EQ. 0 ) THEN

C Get default file header attibutes from CONC file (assumes file already open)

               IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( SA_CONC_1 )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

C Set file header attributes that differ from CONC and open the file

               SDATE3D = MDATE
               STIME3D = MTIME
               TSTEP3D = TSTEP
!0711          NVARS3D = N_SPCTAG
               NLAYS3D = A_NLYS

               L = 0
               DO K = AISAM_BLEV, AISAM_ELEV
                  L = L + 1
                  VGLVS3D( L ) = VGLVS_GD( K )
               END DO
!0711          VGLVS3D( A_NLYS + 1 ) = VGLVS_GD( NLAYS + 1 )
!              GDNAM3D = GDNAME_GD
               GDNAM3D = GRID_NAME  ! from HGRD_DEFN

               FDESC3D( 1 ) = 'Src Apportionment file output '
               FDESC3D( 2 ) = 
     &                'Averaged over the synchronization time steps '
               FDESC3D( 3 ) = 
     &              'Timestamp represents beginning computed date/time '
               FDESC3D( 4 ) = 'Layer mapping (ISAM to AISAM):'
               KD = 4
               VAR = AISAM_BLEV
               L = 0
               DO K = KD + 1, MIN ( A_NLYS + KD, MXDESC3 )
                  L = L + 1
                  WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &            VAR + L - 1, L
               END DO
               IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
                  DO K = KD + 1 + L, MXDESC3
                     FDESC3D( K ) = ' '
                  END DO
               END IF

               WRITE( LOGDEV,* ) ' '
               WRITE( LOGDEV,* ) 
     &                  '      Avg ISAM File Header Description:'
               DO K = 1, KD + L
                  WRITE( LOGDEV,* ) '    => ',
     &            TRIM( FDESC3D( K ) )
               END DO


               IF ( .NOT. OPEN3( SA_ACONC_1, FSNEW3, PNAME ) ) THEN
                  XMSG = 'Could not open '
     &                 // TRIM( SA_ACONC_1 ) // ' file'
                  CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               END IF

            END IF   ! MYPE = 0

         ELSE

C File exists. Make sure it matches requested output.

            IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
               XMSG = 'Could not get '
     &              // TRIM( SA_CONC_1 )
     &              // ' file description'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            TSTEP_RF = TSTEP3D
            NTHIK_RF = NTHIK3D
            NCOLS_RF = NCOLS3D
            NROWS_RF = NROWS3D
            GDTYP_RF = GDTYP3D
            P_ALP_RF = P_ALP3D
            P_BET_RF = P_BET3D
            P_GAM_RF = P_GAM3D
            XCENT_RF = XCENT3D
            YCENT_RF = YCENT3D
            XORIG_RF = XORIG3D
            YORIG_RF = YORIG3D
            XCELL_RF = XCELL3D
            YCELL_RF = YCELL3D
            VGTYP_RF = VGTYP3D
            VGTOP_RF = VGTOP3D

            IF ( .NOT. DESC3( SA_ACONC_1 ) ) THEN
               XMSG = 'Could not get '
     &              // TRIM( SA_ACONC_1 )
     &              // ' file description'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            IF ( N_SPCTAG .NE. NVARS3D ) THEN
               WRITE( XMSG, '( A, 2I6 )' )
     &         'Number of variables don''t match file: ', N_SPCTAG, NVARS3D
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            DO SPC = 1, N_SPCTAG
               DO VAR = 1, NVARS3D
                  IF ( VNAM_SPCTAG( SPC ) .EQ. VNAME3D( VAR ) ) GO TO 101
               END DO
               XMSG = 'Could not find ' // VNAM_SPCTAG( SPC )
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
101            CONTINUE
            END DO

            IF ( A_NLYS .NE. NLAYS3D ) THEN
               WRITE( XMSG, '( A, 2I6 )' )
     &         'Number of layers don''t match file: ', A_NLYS, NLAYS3D
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

C Check other header data with CONC file as reference

            IF ( TSTEP_RF .NE. TSTEP3D .OR.
     &           NTHIK_RF .NE. NTHIK3D .OR.
     &           NCOLS_RF .NE. NCOLS3D .OR.
     &           NROWS_RF .NE. NROWS3D .OR.
     &           GDTYP_RF .NE. GDTYP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_ACONC_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &           P_BET_RF .NE. P_BET3D .OR.
     &           P_GAM_RF .NE. P_GAM3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_ACONC_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCENT_RF .NE. XCENT3D .OR.
     &           YCENT_RF .NE. YCENT3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_ACONC_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XORIG_RF .NE. XORIG3D .OR.
     &           YORIG_RF .NE. YORIG3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCELL_RF .NE. XCELL3D .OR.
     &           YCELL_RF .NE. YCELL3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTYP_RF .NE. VGTYP3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTOP_RF .NE. VGTOP3D ) THEN
               XMSG = 'Header inconsistent on existing SA_ACONC_1'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

         END IF   ! .NOT. OPEN SA_ACONC_1

c        CALL SUBST_BARRIER

      END IF   ! FIRSTIME
    
      IF ( .NOT. ALLOCATED( BUF4 ) ) ALLOCATE( BUF4( NCOLS, NROWS, A_NLYS, N_SPCTAG ) )

    
      DO SPC = 1, N_SPCTAG
         L = 0
         DO K = AISAM_BLEV, AISAM_ELEV
          L = L + 1
          BUF4( :,:,L,SPC ) = AISAM( :,:,K, S_SPCTAG(SPC), T_SPCTAG(SPC) )
         ENDDO !
         IF ( .NOT. WRITE3( SA_ACONC_1, VNAM_SPCTAG( SPC ),
     &      MDATE, MTIME, BUF4( :,:,:,SPC ) ) ) THEN
            XMSG = 'Could not write '
     &           // VNAM_SPCTAG( SPC )
     &           // ' to ' // SA_ACONC_1
            CALL M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
         END IF
!     write( logdev,* ) ' <>var, A_GC_SPC: ', VAR, A_GC_SPC( SPC )
      END DO
 
      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', SA_ACONC_1,
     &      'for date and time', MDATE, MTIME

      IF ( ALLOCATED( BUF4 ) ) DEALLOCATE( BUF4 )

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PMDIAG_DATA_MODULE

c-----------------------------------------------------------------------
c Revision History:
c David Wong 11 May 16: created
c-----------------------------------------------------------------------

        IMPLICIT NONE

        TYPE PMDIAG_SPC_RECORD_TYPE
          CHARACTER (LEN = 16) :: SPC_NAME
          INTEGER              :: VAR_TYPE
          CHARACTER (LEN = 16) :: SPC_UNIT
          CHARACTER (LEN = 80) :: SPC_DESC
        END TYPE PMDIAG_SPC_RECORD_TYPE

        TYPE (PMDIAG_SPC_RECORD_TYPE), PARAMETER :: PMDIAG_SPC_RECORD(41) = (/
     &    PMDIAG_SPC_RECORD_TYPE( 'STDEVATKN       ', 5, '                ', 'Aitken mode standard deviation (dry and wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'STDEVACC        ', 5, '                ', 
     &                            'Accumulation mode standard deviation (dry and wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'STDEVCOR        ', 5, '                ', 'Coarse mode standard deviation (dry and wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DGATKN_DRY      ', 5, 'um              ', 'Aitken mode mean diameter (dry)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DGACC_DRY       ', 5, 'um              ', 'Accumulation mode mean diameter (dry)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DGCOR_DRY       ', 5, 'um              ', 'Coarse mode mean diameter (dry)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DGATKN_WET      ', 5, 'um              ', 'Aitken mode mean diameter (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DGACC_WET       ', 5, 'um              ', 'Accumulation mode mean diameter (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DGCOR_WET       ', 5, 'um              ', 'Coarse mode mean diameter (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M2ATKN_WET      ', 5, 'm2 m-3          ', 'Aitken mode 2nd moment (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M2ACC_WET       ', 5, 'm2 m-3          ', 'Accumulation mode 2nd moment (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M2COR_WET       ', 5, 'm2 m-3          ', 'Coarse mode 2nd moment (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M3ATKN_DRY      ', 5, 'm3 m-3          ', 'Aitken mode 3rd moment (dry)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M3ACC_DRY       ', 5, 'm3 m-3          ', 'Accumulation mode 3rd moment (dry)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M3COR_DRY       ', 5, 'm3 m-3          ', 'Coarse mode 3rd moment (dry)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M3ATKN_WET      ', 5, 'm3 m-3          ', 'Aitken mode 3rd moment (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M3ACC_WET       ', 5, 'm3 m-3          ', 'Accumulation mode 3rd moment (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'M3COR_WET       ', 5, 'm3 m-3          ', 'Coarse mode 3rd moment (wet)' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'RH              ', 5, '1               ', 'Relative humidity' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM1AT           ', 5, '1               ', 'PM1 fraction of Aitken mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM1AC           ', 5, '1               ', 'PM1 fraction of accumulation mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM1CO           ', 5, '1               ', 'PM1 fraction of coarse mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM25AT          ', 5, '1               ', 'PM2.5 fraction of Aitken mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM25AC          ', 5, '1               ', 'PM2.5 fraction of accumulation mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM25CO          ', 5, '1               ', 'PM2.5 fraction of coarse mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM10AT          ', 5, '1               ', 'PM10 fraction of Aitken mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM10AC          ', 5, '1               ', 'PM10 fraction of accumulation mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'PM10CO          ', 5, '1               ', 'PM10 fraction of coarse mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'AMSAT           ', 5, '1               ', 'AMS Transmission Fraction of Aitken mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'AMSAC           ', 5, '1               ', 'AMS Transmission Fraction of Accumulation mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'AMSCO           ', 5, '1               ', 'AMS Transmission Fraction of Coarse mode' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'GAMMA_N2O5      ', 5, '1               ', 
     &                            'Fine Mode N2O5 Heterogeneous reaction probability' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'GAMMA_N2O5K     ', 5, '1               ', 
     &                            'Coarse Mode N2O5 Heterogeneous reaction probability' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'YIELD_CLNO2     ', 5, '1               ', 'Fine Mode CLNO2 Heterogeneous reaction yield' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'YIELD_CLNO2K    ', 5, '1               ', 'Coarse Mode CLNO2 Heterogeneous reaction yield' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'GAMMA_IEPOX     ', 5, '1               ', 'IEPOX heterogeneous uptake coefficient' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DENS_ATKN       ', 5, 'kg m-3          ', 'Bulk Density of Aitken-Mode Particles' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DENS_ACC        ', 5, 'kg m-3          ', 'Bulk Density of Accumulation-Mode Particles' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'DENS_COR        ', 5, 'kg m-3          ', 'Bulk Density of Coarse-Mode Particles' ), 
     &    PMDIAG_SPC_RECORD_TYPE( 'k_prtcl_iepox   ', 5, 's-1             ', 'IEPOX pseudo particle phase reaction rate const' ),
     &    PMDIAG_SPC_RECORD_TYPE( 'GAMMA_IMAE      ', 5, '1               ', 'IMAE heterogeneous uptake coefficient' ) /)

        INTEGER :: A_PMDIAG_SPC_MAP (41), NUM_PMDIAG_SPC

      END MODULE PMDIAG_DATA_MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE OP_SA ( JDATE, JTIME, TSTEP, NSTEPS, FILE_NAME )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c20140428  Opens ISAM's SA_CONC_1 file
c       op_sa.F called by initscen.F
c
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
c
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


!      USE HGRD_DEFN             ! horizontal domain specifications
      USE GRID_CONF
c     USE SA_LAYERS
      USE SA_DEFN               ! Mc06
      USE UTILIO_DEFN           ! replaces ioparms, iofdesc, iodecl
c     USE SUBST_MODULES         ! stenex
      USE RXNS_DATA, ONLY : MECHNAME !Get Chemical Mechanism Name
      USE RUNTIME_VARS

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

C...Arguments Declaration
      INTEGER    JDATE          ! current model date, coded YYYYDDD
      INTEGER    JTIME          ! current model time, coded HHMMSS
      INTEGER    TSTEP(3)       ! format 10000, 0, 0
cyqw
      INTEGER    NSTEPS         ! Number of time steps of 3D output
cyqw
      CHARACTER( 16 )       :: FILE_NAME

   
C...End of argument declaration

C Local variables:
      
c     INTEGER          ALLOCSTAT, LOGDEV
      INTEGER          ALLOCSTAT

      CHARACTER( 16 ), DIMENSION( :,: ), ALLOCATABLE::VNAME
      CHARACTER( 1 ),  DIMENSION(:), ALLOCATABLE::SPECIE_NAME
      CHARACTER( 16 ) :: TEMP, CSUFFX
      INTEGER          LENGTH

      CHARACTER( 16 ) :: PNAME = 'OP_SA'
      CHARACTER( 96 ) :: XMSG = ' '
      
      INTEGER   C,R,S,K,N, L    ! loop induction variables
c     INTEGER   ITAG, JSPC, JSPCTAG
      INTEGER   JSPC, JSPCTAG


      REAL, ALLOCATABLE :: ISAM_BUFF ( :,:,:,: )

Ckrt Diagnostic
      CHARACTER( 256 ) EQNAME

C-----------------------------------------------------------------------



Ckrt Create variable names for tag output


        LOGDEV = INIT3()

        IF ( ISAM_ELEV .EQ. -1 ) ISAM_ELEV = NLAYS
        SA_NLAYS = ISAM_ELEV - ISAM_BLEV + 1

        ALLOCATE( VNAME(NSPC_SA,NTAG_SA) )
        VNAME = ''
        JSPCTAG = 0
        DO ITAG = 1, NTAG_SA
          DO JSPC = 1, NSPC_SA
            JSPCTAG = JSPCTAG + 1
            LENGTH = LEN_TRIM( SPC_NAME( JSPC,ITAG ) )
            IF ( LENGTH .GT. 0 ) THEN
              TEMP = SPC_NAME( JSPC,ITAG )( 1:LENGTH )
              ALLOCATE ( SPECIE_NAME( LENGTH ) )
              DO N = 1, LENGTH
                SPECIE_NAME(N:N) = TEMP(N:N)
              ENDDO
              IF ( ITAG .EQ. BCONTAG ) THEN
                CSUFFX = 'BCO             '
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             CSUFFX, VNAME( JSPC,ITAG ) )
              ELSEIF ( ITAG .EQ. OTHRTAG ) THEN
                CSUFFX = 'OTH             '
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             CSUFFX, VNAME( JSPC,ITAG ) )
              ELSEIF ( ITAG .EQ. ICONTAG ) THEN
                CSUFFX = 'ICO             '
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             CSUFFX, VNAME( JSPC,ITAG ) )
              ELSE
                CALL WR_VARNAME( SPECIE_NAME, LENGTH, NTAG_SA, NSPC_SA,
     &             TAGNAME(ITAG), VNAME( JSPC,ITAG ) )
              ENDIF ! Is itag bcon, othr, icon, or emis ?
!              WRITE(LOGDEV,'(I3,2(1X,I2),2(1X,A16))')JSPCTAG,JSPC,ITAG,SPC_NAME( JSPC,ITAG ),VNAME( JSPC,ITAG )
              DEALLOCATE ( SPECIE_NAME )
            ENDIF ! length > 0?
          ENDDO ! jspc
        ENDDO ! itag

Ckrt Set nvars3d for SA_CONC_1 or SA_CGRID_1 file
        NVARS3D = N_SPCTAG

Ckrt Set vname3d for SA_CONC_1 file
        JSPCTAG = 0
!       write (logdev, *) NSPC_SA, NTAG_SA

        DO ITAG = 1, NTAG_SA
           DO JSPC = 1, NSPC_SA
              JSPCTAG = JSPCTAG + 1
              VTYPE3D( JSPCTAG ) = M3REAL
              VNAME3D( JSPCTAG ) = VNAME(JSPC,ITAG)
              IF( IS_SPC_AEROSOL( JSPC,ITAG ) )THEN 
                UNITS3D( JSPCTAG ) = "micrograms/m**3 "
              ELSE 
                UNITS3D( JSPCTAG ) = "ppmV            "
              END IF
              VDESC3D( JSPCTAG ) = "tracer conc."
              S_SPCTAG  ( JSPCTAG ) = JSPC
              T_SPCTAG  ( JSPCTAG ) = ITAG
              VNAM_SPCTAG ( JSPCTAG ) = VNAME(JSPC,ITAG)
!              WRITE(LOGDEV,'(I4,2(1X,I3),2(1X,A16),2(1X,I3))')
!     &        JSPCTAG,JSPC,ITAG,  
!     &        VNAME3D( JSPCTAG ), UNITS3D( JSPCTAG ),
!     &        S_SPCTAG( JSPCTAG ), T_SPCTAG( JSPCTAG )
           END DO
        END DO

        SDATE3D = JDATE
        STIME3D = JTIME

        FTYPE3D = GRDDED3
cyqw    TSTEP3D = TSTEP(1)
        TSTEP3D = TSTEP ( 1 ) * NSTEPS
         
        NCOLS3D = GL_NCOLS
        NROWS3D = GL_NROWS
        NLAYS3D = SA_NLAYS
        NTHIK3D =     1
        GDTYP3D = GDTYP_GD
        P_ALP3D = P_ALP_GD
        P_BET3D = P_BET_GD 
        P_GAM3D = P_GAM_GD
        XORIG3D = XORIG_GD
        YORIG3D = YORIG_GD
        XCENT3D = XCENT_GD
        YCENT3D = YCENT_GD
        XCELL3D = XCELL_GD
        YCELL3D = YCELL_GD
        VGTYP3D = VGTYP_GD
        VGTOP3D = VGTOP_GD


        DO L = ISAM_BLEV, ISAM_ELEV !1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
        END DO

!       GDNAM3D = GDNAME_GD
        GDNAM3D = GRID_NAME  ! from HGRD_DEFN

        FDESC3D( 1 ) = 'SA_CONC_1 stores contributing srcs '
        DO L = 2, MXDESC3
            FDESC3D( L ) = ' '
        END DO
   
               
        IF ( MYPE .EQ. 0 ) THEN
!           CALL M3EXIT( 'OP_SA', 0, 0, 'Fatal Error Encountered', XSTAT2 )
           IF ( .NOT. OPEN3( FILE_NAME, FSNEW3, PNAME ) ) THEN
              XMSG = 'Could not create '// FILE_NAME // ' file'
              CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
           END IF
        END IF

Ckrt...Write initial conditions to sa_conc_1 ( or last hour sa_cgrid_1 )
          ALLOCATE ( ISAM_BUFF( NCOLS, NROWS, SA_NLAYS, N_SPCTAG ), 
     &     STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ISAM_BUFF'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          ENDIF
          ISAM_BUFF = 0.0
C
         ! print *, S, N_SPCTAG,ISAM_BLEV, ISAM_ELEV
          DO S = 1, N_SPCTAG
            DO L = ISAM_BLEV, ISAM_ELEV
              ISAM_BUFF( :,:,L,S ) = ISAM( :,:,L,S_SPCTAG(S),T_SPCTAG(S) )
            ENDDO
          END DO ! loop over total tags
          IF ( .NOT. WRITE3( FILE_NAME, ALLVAR3, JDATE, JTIME, 
     &     ISAM_BUFF ) ) THEN
            XMSG = 'Could not write to '
     &         // FILE_NAME
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF
          if ( MYPE .eq. 0 ) then
            print*,'Finished write3 S =',S
            print*,'While N_SPCTAG =',N_SPCTAG
          endif
          DEALLOCATE( ISAM_BUFF )

      
c.....couple ISAM after writing

      return
      end

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c
c   this subroutine must be implemented to overcome Character*1 X 16
c   to Character*16 conversion.
c   new varname will be created by this way.
c
c   by bo wang
c
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      subroutine wr_varname(input, length, ntag_tssa, nspc_tssa, 
     &     src_name, varname)
     
c     ...argument
      integer                     length
      character*1              :: input(length)
      integer                     ntag_tssa, nspc_tssa
      character*16                src_name
      character*16                varname

c     ...local variable
      integer                     i
      CHARACTER*7                 CHAR1
Ckrt  CHARACTER(len=16-length) :: CHAR1
      character(len=length)       output
      character*16                temp

c     ...external function
      integer len_trim
      
c.....................................................................
      
      do i = 1, length
         output(i:i) = input(i)
      end do

      temp = src_name

!0711 do i = 1, 7
      do i = 1, min( 7, 16-length-1 )
        char1(i:i) = temp(i:i)
      end do
         
      VARNAME = output // '_' // char1

      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE VDIFF_MAP

C-----------------------------------------------------------------------
C Function: index mapping between CGRID, diffusion, dry dep, and emissions
C           species

C Module depends on prior call to DEPV_INIT to get NDEPV_SPC

C Revision History:
C   10 Apr 2008 J.Young: initial implementation using subroutine vdiff_map.F
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 J.Bash: Modified for NH3 bidi component fluxes
C   04 Jan 12 J.Young: Initalize char strings with blank padding

C-----------------------------------------------------------------------
      USE VDIFF_DATA

C global diffusion species
      !INTEGER, SAVE :: N_SPC_DIFF 
     
C global dry dep species
      INTEGER, SAVE :: N_SPC_DDEP 

      INTEGER, ALLOCATABLE, SAVE :: DIFF_MAP( : ) ! global diff map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: DF2DV   ( : ) ! map from diff spc to depv spc
      INTEGER, ALLOCATABLE, SAVE :: DF2EM   ( : ) ! map from diff spc to emis spc
      INTEGER, ALLOCATABLE, SAVE :: DD2DV   ( : ) ! map from ddep spc to depv spc
      INTEGER, ALLOCATABLE, SAVE :: DEPV_MAP( : ) ! global depv map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: DV2DF   ( : )  ! map from depv spc to diff spc

      ! These Masks Identify the Phase/Nature of Species in The Diffused
      ! Species Vector
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_GAS ( : ) !Gases
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_AERO( : ) !Particles
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_NUM ( : ) !Particles
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_SRF ( : ) !Particles
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_NR  ( : ) !Non-Reactives
      LOGICAL, ALLOCATABLE, SAVE :: DIFF_MASK_TRAC( : ) !Tracers

      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DDEP_SPC( : )
      !CHARACTER( 16 ), ALLOCATABLE, SAVE :: DIFF_SPC( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DEPV_SPC( : )
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: DV2DF_SPC( : )
      REAL,            ALLOCATABLE, SAVE :: DIFF_MW  ( : )

C component flux output variables 
      INTEGER, PARAMETER :: LCMP  = 8
      CHARACTER( 16 ), SAVE :: CMPSPC( LCMP ) = ' '

      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION VDIFF_MAP_INIT( ) RESULT ( SUCCESS )

         USE CGRID_SPCS   ! CGRID species number and offsets
         USE UTILIO_DEFN
         USE DEPV_DEFN, ONLY : N_SPC_DEPV

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_EMISPRM   ! Emissions processing control parameters

C Arguments:
         LOGICAL SUCCESS

C External Functions:
         INTEGER, EXTERNAL :: FINDEX

C Local variables:
         
         CHARACTER( 80 )  :: XMSG       ! Message text
         CHARACTER( 16 )  :: PNAME = 'VDIFF_MAP'

         INTEGER STRT, FINI
         INTEGER S, V, N, I, INDX
         INTEGER ALLOCSTAT

         LOGICAL LERROR                    ! Error flag

!-----------------------------------------------------------------------
         SUCCESS = .TRUE.

         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF
         
         ALLOCATE ( DIFF_MAP( N_SPC_DIFF+1 ),
     &              DF2DV( N_SPC_DIFF+1 ),
     &              DIFF_MW( N_SPC_DIFF+1 ),
    ! &              DF2EM( N_SPC_DIFF+1 ),
     &              DIFF_SPC( N_SPC_DIFF+1 ), stat = allocstat )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DIFF_MAP, DF2DV or DIFF_SPC'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         N_SPC_DDEP = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP

         ALLOCATE ( DD2DV( N_SPC_DDEP+1 ),
     &              DDEP_SPC( N_SPC_DDEP+1 ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD2DV or DDEP_SPC'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         ALLOCATE ( DEPV_MAP( N_SPC_DEPV+1 ),
     &              DEPV_SPC( N_SPC_DEPV ),
     &              DV2DF( N_SPC_DEPV ),
     &              dv2df_spc( n_spc_depv ), stat = allocstat )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DEPV_MAP, DEPV_SPC, DV2DF or dv2df_spc'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

! Populate global maps to CGRID

! Map Diffusion Module Species to Deposition Velocity Species
         I = 0; S = 0; N = 0
         DO V = 1, N_GC_TRNS ! assumes dep.vel species subset of vdif species
            N = N + 1
            INDX = FINDEX( GC_TRNS_MAP( V ), N_GC_DEPV, GC_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               I = I + 1
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO
         S = S + I     ! S should now be = N_GC_DEPV

         I = 0
         DO V = 1, N_AE_TRNS
            N = N + 1
            INDX = FINDEX( AE_TRNS_MAP( V ), N_AE_DEPV, AE_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               I = I + 1
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO
         S = S + I     ! S should now be = N_GC_DEPV + N_AE_DEPV

         I = 0
         DO V = 1, N_NR_TRNS
            N = N + 1
            INDX = FINDEX( NR_TRNS_MAP( V ), N_NR_DEPV, NR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               I = I + 1
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO
         S = S + I     ! S should now be = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV

         DO V = 1, N_TR_DIFF
            N = N + 1
            INDX = FINDEX( TR_DIFF_MAP( V ), N_TR_DEPV, TR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DF2DV( N ) = S + INDX
            ELSE
               DF2DV( N ) = N_SPC_DEPV + 1
            END IF
         END DO

! Map Deposition Velocity Species to Dry Deposition Module Species
         LERROR = .FALSE.
         S = 0; V = 0
         DO N = 1, N_GC_DDEP
            V = V + 1
            INDX = FINDEX ( GC_DDEP_MAP( N ), N_GC_DEPV, GC_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = GC_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               GC_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_DEPV
         DO N = 1, N_AE_DDEP
            V = V + 1
            INDX = FINDEX ( AE_DDEP_MAP( N ), N_AE_DEPV, AE_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = AE_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               AE_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_DEPV + N_AE_DEPV
         DO N = 1, N_NR_DDEP
            V = V + 1
            INDX = FINDEX ( NR_DDEP_MAP( N ), N_NR_DEPV, NR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = NR_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               NR_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV
         DO N = 1, N_TR_DEPV
            V = V + 1
            INDX = FINDEX ( TR_DDEP_MAP( N ), N_TR_DEPV, TR_DEPV_MAP )
            IF ( INDX .GT. 0 ) THEN
               DD2DV ( V ) = S + INDX
               DDEP_SPC( V ) = TR_DDEP( N )
            ELSE
               XMSG = 'ERROR: No deposition velocity for DDEP species ' //
     &               TR_DDEP( N )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         CMPSPC( 1 ) = 'NH3_Emis'
         CMPSPC( 2 ) = 'NH3_Flux'
         CMPSPC( 3 ) = 'NH3_Stom'
         CMPSPC( 4 ) = 'NH3_Cut '
         CMPSPC( 5 ) = 'NH3_Soil'
         CMPSPC( 6 ) = 'NH3_Ag  '
         CMPSPC( 7 ) = 'NH3_Nat '
         CMPSPC( 8 ) = 'NH3_Wat '

! Populate Deposition Velocity Map and Species 
         S = 0
         DO V = 1, N_GC_DEPV
            S = S + 1
            DEPV_MAP( S ) = GC_STRT - 1 + GC_DEPV_MAP( V )
            DEPV_SPC( S ) = GC_SPC( GC_DEPV_MAP( V ) )
         END DO
         DO V = 1, N_AE_DEPV
            S = S + 1
            DEPV_MAP( S ) = AE_STRT - 1 + AE_DEPV_MAP( V )
            DEPV_SPC( S ) = AE_SPC( AE_DEPV_MAP( V ) )
         END DO
         DO V = 1, N_NR_DEPV
            S = S + 1
            DEPV_MAP( S ) = NR_STRT - 1 + NR_DEPV_MAP( V )
            DEPV_SPC( S ) = NR_SPC( NR_DEPV_MAP( V ) )
         END DO
         DO V = 1, N_TR_DEPV
            S = S + 1
            DEPV_MAP( S ) = TR_STRT - 1 + TR_DEPV_MAP( V )
            DEPV_SPC( S ) = TR_SPC( TR_DEPV_MAP( V ) )
         END DO

! Populate Diffusion Module Map and Species
         ALLOCATE( DIFF_MASK_GAS ( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_AERO( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_NUM( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_SRF( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_NR  ( N_SPC_DIFF ) )
         ALLOCATE( DIFF_MASK_TRAC( N_SPC_DIFF ) )
         DIFF_MASK_GAS  = .FALSE.
         DIFF_MASK_AERO = .FALSE.
         DIFF_MASK_NUM  = .FALSE.
         DIFF_MASK_SRF  = .FALSE.
         DIFF_MASK_NR   = .FALSE.
         DIFF_MASK_TRAC = .FALSE.
         DIFF_MAP = 0
         DIFF_SPC = ""
         DIFF_MW  = 0.

         S = 0
         DO V = 1, N_GC_TRNS
            S = S + 1
            DIFF_MAP( S ) = GC_STRT - 1 + GC_TRNS_MAP( V )
            DIFF_SPC( S ) = GC_SPC( GC_TRNS_MAP( V ) )
            DIFF_MW ( S ) = GC_MOLWT( GC_TRNS_MAP( V ) )
            DIFF_MASK_GAS( S ) = .TRUE.
         END DO
         DO V = 1, N_AE_TRNS
            S = S + 1
            DIFF_MAP( S ) = AE_STRT - 1 + AE_TRNS_MAP( V )
            DIFF_SPC( S ) = AE_SPC( AE_TRNS_MAP( V ) )
            DIFF_MW ( S ) = AE_MOLWT( AE_TRNS_MAP( V ) )
            DIFF_MASK_AERO( S ) = .TRUE.
            IF ( INDEX( DIFF_SPC( S ), 'NUM' ) .NE. 0 ) DIFF_MASK_NUM( S ) = .TRUE.
            IF ( INDEX( DIFF_SPC( S ), 'SRF' ) .NE. 0 ) DIFF_MASK_SRF( S ) = .TRUE.
         END DO
         DO V = 1, N_NR_TRNS
            S = S + 1
            DIFF_MAP( S ) = NR_STRT - 1 + NR_TRNS_MAP( V )
            DIFF_SPC( S ) = NR_SPC( NR_TRNS_MAP( V ) )
            DIFF_MW ( S ) = NR_MOLWT( NR_TRNS_MAP( V ) )
            DIFF_MASK_NR( S ) = .TRUE.
         END DO
         DO V = 1, N_TR_DIFF
            S = S + 1
            DIFF_MAP( S ) = TR_STRT - 1 + TR_DIFF_MAP( V )
            DIFF_SPC( S ) = TR_SPC( TR_DIFF_MAP( V ) )
            DIFF_MW ( S ) = TR_MOLWT( TR_DIFF_MAP( V ) )
            DIFF_MASK_TRAC( S ) = .TRUE.
         END DO

! Map Deposition Velocity Species to Diffusion Module Species
         S = 0; V = 0
         DO N = 1, N_GC_DEPV
            V = V + 1
            INDX = FINDEX ( GC_DEPV_MAP( N ), N_GC_TRNS, GC_TRNS_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = gc_trns( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // GC_SPC( GC_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_TRNS
         DO N = 1, N_AE_DEPV
            V = V + 1
            INDX = FINDEX ( AE_DEPV_MAP( N ), N_AE_TRNS, AE_TRNS_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = ae_trns( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // AE_SPC( AE_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_TRNS + N_AE_TRNS
         DO N = 1, N_NR_DEPV
            V = V + 1
            INDX = FINDEX ( NR_DEPV_MAP( N ), N_NR_TRNS, NR_TRNS_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = nr_trns( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // NR_SPC( NR_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

         S = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS
         DO N = 1, N_TR_DEPV
            V = V + 1
            INDX = FINDEX ( TR_DEPV_MAP( N ), N_TR_DIFF, TR_DIFF_MAP )
            IF ( INDX .GT. 0 ) THEN
               DV2DF ( V ) = S + INDX
               dv2df_spc( v ) = tr_diff( indx )
            ELSE
               XMSG = 'ERROR: deposition velocity specified for non-diff species '
     &               // TR_SPC( TR_DEPV_MAP( N ) )
               CALL M3MESG( XMSG )
               LERROR = .TRUE.
            END IF
         END DO

! Check for Errors and Exit
         IF ( LERROR ) THEN
            XMSG = '*** Species mapping error(s) in VDIFF_MAP'
            CALL M3WARN( PNAME, 0, 0, XMSG )
            SUCCESS = .FALSE.
         END IF

         RETURN

         END FUNCTION VDIFF_MAP_INIT

      END MODULE VDIFF_MAP

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE  HRDATA

C*************************************************************************
C
C  FUNCTION:  Mechanism & solver data for EBI solver
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables for solution
C*************************************************************************

c..EBI solver fixed parameters
      INTEGER, PARAMETER    ::  NEBITER       = 1000      ! No. of iterations for EBI
      INTEGER, PARAMETER    ::  MAX_CELLS_EBI = 1         ! max # cells in local conc arrays
      REAL( 8 ), PARAMETER  ::  DELTAT        = 2.500D+00 ! EBI time step (min)

c..Mechanism specific variables
      INTEGER   N_SPEC       ! No. of species in mechanism
      INTEGER   N_RXNS       ! No. of reactions in mechanism
      INTEGER   N_EBISP      ! No. of species solved by EBI
      INTEGER   NING1        ! No. of species in group 1
      INTEGER   NING2        ! No. of species in group 2
      INTEGER   N_SPCL_RKS   ! No. of special rate constants
      INTEGER   N_ACTSP      ! No. of species in mechanism (non-ss spec)
      INTEGER   NCELL        ! cell number in EBI Block

c..Control flags
      LOGICAL   L_AE_VRSN    ! Flag for aerosol version of mech
      LOGICAL   L_AQ_VRSN    ! Flag for aqueous chemistry version of mech
      LOGICAL   CALL_IRR     ! Flag initializing for IRR and calling PA_IRR

  ! SWITCH for calling DEGRADE routine
      LOGICAL, SAVE :: CALL_DEG = .TRUE.

c..Miscellaneous variables
      INTEGER   N_EBI_IT      ! No. of iterations for EBI
      INTEGER   N_EBI_STEPS   ! No. of time steps for EBI
      INTEGER   N_INR_STEPS   ! No. of inner time steps for EBI
      INTEGER   PECOL_OFFSET  ! Local Column Offset for processor
      INTEGER   PEROW_OFFSET  ! Local Column Offset for processor
  
      INTEGER, SAVE ::   MODEL_SPECIES ! No. of species in CGRID

      REAL( 8 )    EBI_TMSTEP          ! Time step for EBI loops (min)

c...Allocatable arrays
      INTEGER, ALLOCATABLE :: EBISP( : )         ! Index of EBI species
      INTEGER, ALLOCATABLE :: SSASP( : )         ! Index of ss species
      INTEGER, ALLOCATABLE :: ACTSP( : )         ! Index of active species
      INTEGER, ALLOCATABLE :: IOLD2NEW( :,: )    ! YC species map, used if NSPECIAL > 0

      REAL( 8 ), ALLOCATABLE ::  RKI(  : )     ! Rate constants
      REAL( 8 ), ALLOCATABLE ::  RKI_SAV(  :,  : )  ! Saved values of RKI for SS species calcs

      REAL( 8 ), ALLOCATABLE ::  YC (  : )      ! Species concentrations
      REAL( 8 ), ALLOCATABLE ::  YC0(  : )      ! Species concentrations
      REAL( 8 ), ALLOCATABLE ::  YCP(  : )      ! Species concentrations
      REAL( 8 ), ALLOCATABLE ::  SYC(  :, : )   ! Species concentrations

      REAL, ALLOCATABLE      :: FORWARD_CONV( : )  ! CGRID to CHEM Species conversion factor
      REAL, ALLOCATABLE      :: REVERSE_CONV( : )  ! CHEM to CGRID Species conversion factor

      REAL( 8 ), ALLOCATABLE ::  RXRAT( : )     ! Reaction rates
      REAL( 8 ), ALLOCATABLE ::  RTOL(  : )        ! Species tolerances
      REAL( 8 ), ALLOCATABLE ::  YCCELL( : )       ! ALL Species in cgrid
      REAL( 8 ), ALLOCATABLE ::  PROD(  : )     ! Prod of species
      REAL( 8 ), ALLOCATABLE ::  LOSS(  : )     ! Loss of species
      REAL( 8 ), ALLOCATABLE ::  PNEG(  : )! Negative production rates

      REAL, ALLOCATABLE      :: PRES( :, :, : )          ! pressure (Pa)
      REAL, ALLOCATABLE      :: QV  ( :, :, : )          ! water vapor (Kg/Kg air)
      REAL, ALLOCATABLE      :: TA  ( :, :, : )          ! temperature (K)

      REAL, ALLOCATABLE      :: SEAICE ( :, :)            ! fractional seaice cover, [-]
      REAL, ALLOCATABLE      :: DENS( :, :, : )           ! mass density (Kg/m^3)

      LOGICAL, ALLOCATABLE   :: LAND_ZONE   ( :,: )       ! Is the surface totally land?
      LOGICAL, ALLOCATABLE   :: LFLAGIRR    ( :,:,: )     ! Conduct IRR for cell

      REAL( 8 ), ALLOCATABLE ::  ATMPRES ( : )     ! Cell pressure, Atm
!      REAL( 8 ), ALLOCATABLE ::  PRESCELL( : )         ! Cell pressure, Pa
      REAL( 8 ), ALLOCATABLE ::  H2O     ( : )     ! Cell H2O mixing ratio (ppmV)
      REAL( 8 ), ALLOCATABLE ::  TEMP    ( : )     ! Cell Temperature
      REAL( 8 ), ALLOCATABLE ::  DENSITY ( : )     ! Cell mass density (Kg/m3)
      REAL( 8 ), ALLOCATABLE ::  HET     ( :, : )  ! cell heterogeneous reaction rates
      REAL( 8 ), ALLOCATABLE ::  RJIN    ( :, : )  ! J-values for a cell
      LOGICAL, ALLOCATABLE   ::  LAND    ( : )     ! land_zone value for specific cell

c..Species indices
      INTEGER, PARAMETER :: NO2              =    1
      INTEGER, PARAMETER :: NO               =    2
      INTEGER, PARAMETER :: O                =    3
      INTEGER, PARAMETER :: O3               =    4
      INTEGER, PARAMETER :: NO3              =    5
      INTEGER, PARAMETER :: O1D              =    6
      INTEGER, PARAMETER :: OH               =    7
      INTEGER, PARAMETER :: HO2              =    8
      INTEGER, PARAMETER :: H2O2             =    9
      INTEGER, PARAMETER :: N2O5             =   10
      INTEGER, PARAMETER :: HNO3             =   11
      INTEGER, PARAMETER :: HONO             =   12
      INTEGER, PARAMETER :: PNA              =   13
      INTEGER, PARAMETER :: SO2              =   14
      INTEGER, PARAMETER :: SULF             =   15
      INTEGER, PARAMETER :: SULRXN           =   16
      INTEGER, PARAMETER :: C2O3             =   17
      INTEGER, PARAMETER :: MEO2             =   18
      INTEGER, PARAMETER :: RO2              =   19
      INTEGER, PARAMETER :: PAN              =   20
      INTEGER, PARAMETER :: PACD             =   21
      INTEGER, PARAMETER :: AACD             =   22
      INTEGER, PARAMETER :: CXO3             =   23
      INTEGER, PARAMETER :: ALD2             =   24
      INTEGER, PARAMETER :: XO2H             =   25
      INTEGER, PARAMETER :: PANX             =   26
      INTEGER, PARAMETER :: FORM             =   27
      INTEGER, PARAMETER :: MEPX             =   28
      INTEGER, PARAMETER :: MEOH             =   29
      INTEGER, PARAMETER :: ROOH             =   30
      INTEGER, PARAMETER :: XO2              =   31
      INTEGER, PARAMETER :: XO2N             =   32
      INTEGER, PARAMETER :: NTR1             =   33
      INTEGER, PARAMETER :: NTR2             =   34
      INTEGER, PARAMETER :: FACD             =   35
      INTEGER, PARAMETER :: CO               =   36
      INTEGER, PARAMETER :: HCO3             =   37
      INTEGER, PARAMETER :: ALDX             =   38
      INTEGER, PARAMETER :: GLYD             =   39
      INTEGER, PARAMETER :: GLY              =   40
      INTEGER, PARAMETER :: MGLY             =   41
      INTEGER, PARAMETER :: ETHA             =   42
      INTEGER, PARAMETER :: ETOH             =   43
      INTEGER, PARAMETER :: KET              =   44
      INTEGER, PARAMETER :: PAR              =   45
      INTEGER, PARAMETER :: ACET             =   46
      INTEGER, PARAMETER :: PRPA             =   47
      INTEGER, PARAMETER :: XPRP             =   48
      INTEGER, PARAMETER :: XPAR             =   49
      INTEGER, PARAMETER :: ROR              =   50
      INTEGER, PARAMETER :: ETHY             =   51
      INTEGER, PARAMETER :: ETH              =   52
      INTEGER, PARAMETER :: OLE              =   53
      INTEGER, PARAMETER :: IOLE             =   54
      INTEGER, PARAMETER :: ISOP             =   55
      INTEGER, PARAMETER :: ISO2             =   56
      INTEGER, PARAMETER :: ISOPRXN          =   57
      INTEGER, PARAMETER :: ISPD             =   58
      INTEGER, PARAMETER :: INTR             =   59
      INTEGER, PARAMETER :: ISPX             =   60
      INTEGER, PARAMETER :: HPLD             =   61
      INTEGER, PARAMETER :: OPO3             =   62
      INTEGER, PARAMETER :: EPOX             =   63
      INTEGER, PARAMETER :: EPX2             =   64
      INTEGER, PARAMETER :: TERP             =   65
      INTEGER, PARAMETER :: TRPRXN           =   66
      INTEGER, PARAMETER :: TERPNRO2         =   67
      INTEGER, PARAMETER :: APIN             =   68
      INTEGER, PARAMETER :: BENZENE          =   69
      INTEGER, PARAMETER :: CRES             =   70
      INTEGER, PARAMETER :: BZO2             =   71
      INTEGER, PARAMETER :: OPEN             =   72
      INTEGER, PARAMETER :: BENZRO2          =   73
      INTEGER, PARAMETER :: TOL              =   74
      INTEGER, PARAMETER :: TO2              =   75
      INTEGER, PARAMETER :: TOLRO2           =   76
      INTEGER, PARAMETER :: XOPN             =   77
      INTEGER, PARAMETER :: XYLMN            =   78
      INTEGER, PARAMETER :: XLO2             =   79
      INTEGER, PARAMETER :: XYLRO2           =   80
      INTEGER, PARAMETER :: NAPH             =   81
      INTEGER, PARAMETER :: PAHRO2           =   82
      INTEGER, PARAMETER :: CRO              =   83
      INTEGER, PARAMETER :: CAT1             =   84
      INTEGER, PARAMETER :: CRON             =   85
      INTEGER, PARAMETER :: OPAN             =   86
      INTEGER, PARAMETER :: ECH4             =   87
      INTEGER, PARAMETER :: CL2              =   88
      INTEGER, PARAMETER :: CL               =   89
      INTEGER, PARAMETER :: HOCL             =   90
      INTEGER, PARAMETER :: CLO              =   91
      INTEGER, PARAMETER :: FMCL             =   92
      INTEGER, PARAMETER :: HCL              =   93
      INTEGER, PARAMETER :: CLNO2            =   94
      INTEGER, PARAMETER :: CLNO3            =   95
      INTEGER, PARAMETER :: SVAVB2           =   96
      INTEGER, PARAMETER :: SVAVB3           =   97
      INTEGER, PARAMETER :: SVAVB4           =   98
      INTEGER, PARAMETER :: SVAVB1           =   99
      INTEGER, PARAMETER :: SESQ             =  100
      INTEGER, PARAMETER :: SESQRXN          =  101
      INTEGER, PARAMETER :: SOAALK           =  102
      INTEGER, PARAMETER :: H2NO3PIJ         =  103
      INTEGER, PARAMETER :: H2NO3PK          =  104
      INTEGER, PARAMETER :: ACLI             =  105
      INTEGER, PARAMETER :: ACLJ             =  106
      INTEGER, PARAMETER :: ACLK             =  107
      INTEGER, PARAMETER :: IEPOXP           =  108
      INTEGER, PARAMETER :: ASO4J            =  109
      INTEGER, PARAMETER :: AISO3J           =  110
      INTEGER, PARAMETER :: AGLYJ            =  111
      INTEGER, PARAMETER :: MTNO3            =  112
      INTEGER, PARAMETER :: AMTNO3J          =  113
      INTEGER, PARAMETER :: AMTHYDJ          =  114
      INTEGER, PARAMETER :: AAVB2J           =  115
      INTEGER, PARAMETER :: AOLGAJ           =  116
      INTEGER, PARAMETER :: AAVB3J           =  117
      INTEGER, PARAMETER :: AAVB4J           =  118
      INTEGER, PARAMETER :: AISO1J           =  119
      INTEGER, PARAMETER :: AOLGBJ           =  120
      INTEGER, PARAMETER :: AISO2J           =  121
      INTEGER, PARAMETER :: ASQTJ            =  122
      INTEGER, PARAMETER :: APOCI            =  123
      INTEGER, PARAMETER :: APNCOMI          =  124
      INTEGER, PARAMETER :: APOCJ            =  125
      INTEGER, PARAMETER :: APNCOMJ          =  126
      INTEGER, PARAMETER :: PCVOC            =  127
      INTEGER, PARAMETER :: PCSOARXN         =  128
      INTEGER, PARAMETER :: VLVPO1           =  129
      INTEGER, PARAMETER :: VSVPO1           =  130
      INTEGER, PARAMETER :: VSVPO2           =  131
      INTEGER, PARAMETER :: VSVPO3           =  132
      INTEGER, PARAMETER :: VIVPO1           =  133
      INTEGER, PARAMETER :: VLVOO1           =  134
      INTEGER, PARAMETER :: VLVOO2           =  135
      INTEGER, PARAMETER :: VSVOO2           =  136
      INTEGER, PARAMETER :: VSVOO3           =  137
      INTEGER, PARAMETER :: VSVOO1           =  138
      INTEGER, PARAMETER :: FORM_PRIMARY     =  139
      INTEGER, PARAMETER :: ALD2_PRIMARY     =  140
      INTEGER, PARAMETER :: BUTADIENE13      =  141
      INTEGER, PARAMETER :: ACROLEIN         =  142
      INTEGER, PARAMETER :: ACRO_PRIMARY     =  143
      INTEGER, PARAMETER :: TOLU             =  144
      INTEGER, PARAMETER :: HG               =  145
      INTEGER, PARAMETER :: HGIIAER          =  146
      INTEGER, PARAMETER :: HGIIGAS          =  147

      END MODULE HRDATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from EMIS_DEFN.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module em_param_module

            INTEGER :: N_EM_SRM   ! global number of emissions streams
            INTEGER :: N_EMIS_ISTR! global emissions instructions
            INTEGER :: N_EM_RGN   ! no. of region masks

            ! Define Data Structure for Storing Emission Control Namelist Options  
            TYPE EM_REG
                CHARACTER( 32 ) :: LABEL
                CHARACTER( 32 ) :: FILE
                CHARACTER( 32 ) :: VAR
                INTEGER         :: FILENUM
            END TYPE EM_REG

            TYPE( EM_REG ), ALLOCATABLE :: EM_REGIONS( : )
            REAL, ALLOCATABLE           :: EM_REG_FAC( :,:,: )

            TYPE EM_RULE_REG
                CHARACTER( 32 ) :: REGION
                CHARACTER( 32 ) :: STREAM
                CHARACTER( 16 ) :: SURR
                CHARACTER( 16 ) :: SPEC
                CHARACTER( 16 ) :: PHASE
                REAL            :: FAC
                CHARACTER( 4  ) :: BASIS
                CHARACTER( 1  ) :: OP
            END TYPE EM_RULE_REG
            INTEGER, PARAMETER  :: N_EM_RULE_REG = 2000
            TYPE( EM_RULE_REG ), ALLOCATABLE :: EM_NML( : )

            TYPE REGIONS_REG
                CHARACTER( 32 ) :: LABEL
                CHARACTER( 32 ) :: FILE
                CHARACTER( 32 ) :: VAR
            END TYPE REGIONS_REG
            INTEGER, PARAMETER  :: N_REGIONS_REG = 600
            TYPE( REGIONS_REG ), ALLOCATABLE :: RGN_NML( : )

            ! Define Structure for Size Distribution Rule      
            TYPE SD_RULE
                CHARACTER( 32 ) :: STREAM
                CHARACTER( 16 ) :: MODE
                CHARACTER( 16 ) :: MODE_REF
            END TYPE SD_RULE
            INTEGER, PARAMETER :: N_SD_REG = 200
            TYPE( SD_RULE ), ALLOCATABLE :: SD_NML( : )

            ! Define General Parameters for Ignoring Online Streams when
            ! Scaling All Streams with the "ALL" Keyword
            LOGICAL :: Guard_BiogenicVOC   = .FALSE.
            LOGICAL :: Guard_MarineGas     = .FALSE.
            LOGICAL :: Guard_LightningNO   = .FALSE.
            LOGICAL :: Guard_WindBlownDust = .FALSE.
            LOGICAL :: Guard_SeaSpray      = .FALSE.

            ! Define Chemical Family Variables
            INTEGER, PARAMETER          :: N_CHEM_FAMILY_REG = 50
            INTEGER, PARAMETER          :: N_CHEM_MEMBER_REG = 100
            INTEGER                     :: NCHEMFAMILIES
            CHARACTER( 32 ),ALLOCATABLE :: CHEMFAMILYNAME( : )
            INTEGER, ALLOCATABLE        :: CHEMFAMILYNUM( : )
            CHARACTER( 32 ),ALLOCATABLE :: CHEMFAMILYMEMBERS( :,: )

            ! Define Stream Family Variables
            INTEGER, PARAMETER          :: N_STREAM_FAMILY_REG = 50
            INTEGER, PARAMETER          :: N_STREAM_MEMBER_REG = 100
            INTEGER                     :: NSTREAMFAMILIES
            CHARACTER( 32 ),ALLOCATABLE :: STREAMFAMILYNAME( : )
            INTEGER, ALLOCATABLE        :: STREAMFAMILYNUM( : )
            CHARACTER( 32 ),ALLOCATABLE :: STREAMFAMILYMEMBERS( :,: )

            ! Define Region Family Variables
            INTEGER, PARAMETER          :: N_REGION_FAMILY_REG = 50
            INTEGER, PARAMETER          :: N_REGION_MEMBER_REG = 100
            INTEGER                     :: NREGIONFAMILIES
            CHARACTER( 32 ),ALLOCATABLE :: REGIONFAMILYNAME( : )
            INTEGER, ALLOCATABLE        :: REGIONFAMILYNUM( : )
            CHARACTER( 32 ),ALLOCATABLE :: REGIONFAMILYMEMBERS( :,: )

          end module em_param_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE AVG_CONC

      IMPLICIT NONE

C Revision History
C   10 May 2016 D. Wong Modified code to provide flexibility to handle
C                       environment variable ACONC_FILE_SPCS is set to 'ALL' 
C                       or not set.
C 
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL &
C                      added W_VEL to species aconc_species list depending on
C                      if the user requests the vertical velocity to be output
C
C
C Function: species, layer pointers and definitions for integral average
C CONC calculations
C
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      INTEGER, SAVE :: N_ASPCS = 0

      INTEGER, SAVE, ALLOCATABLE :: AVG_CONC_MAP( : ) ! pointer into CGRID
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_GC_SPC( : ) ! pointer into GC_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_AE_SPC( : ) ! pointer into AE_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_NR_SPC( : ) ! pointer into NR_SPC
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: A_TR_SPC( : ) ! pointer into TR_SPC

C species classes configuration for average CONC 
      INTEGER, SAVE :: A_GC_STRT
      INTEGER, SAVE :: N_A_GC_SPC
      INTEGER, SAVE :: A_AE_STRT
      INTEGER, SAVE :: N_A_AE_SPC
      INTEGER, SAVE :: A_NR_STRT
      INTEGER, SAVE :: N_A_NR_SPC
      INTEGER, SAVE :: A_TR_STRT
      INTEGER, SAVE :: N_A_TR_SPC

      INTEGER, SAVE :: N_A_AE_SPCD
                                
C Number of Average Concentration Layers                                
      INTEGER, SAVE :: A_NLYS = 1

C Average Arrays for Met variables
      REAL, SAVE, ALLOCATABLE :: AVG_WVEL( :,:,: )
      REAL, SAVE, ALLOCATABLE :: AVG_RH( :,:,: )
      REAL, SAVE, ALLOCATABLE :: AVG_TA( :,:,: )
      REAL, SAVE, ALLOCATABLE :: AVG_PRES( :,:,: )

C Logical to test whether met variables are included
      LOGICAL, SAVE :: L_ACONC_RH = .FALSE.
      LOGICAL, SAVE :: L_ACONC_TA = .FALSE.
      LOGICAL, SAVE :: L_ACONC_PRES = .FALSE.

      CONTAINS

         SUBROUTINE A_CONC_DEFN ()

         USE RUNTIME_VARS
         USE GRID_CONF             ! Grid Configuration
         USE CGRID_SPCS            ! CGRID mechanism species
         USE UTILIO_DEFN

#ifdef sens
         Use DDM3D_DEFN, Only: N_ASENS_VARS
#endif

         CHARACTER( 16 ) :: PNAME = 'A_CONC_DEFN'
         CHARACTER(200 ) :: XMSG = ' '

         INTEGER OFF, VAR, V, NV, LVL
         INTEGER ALLOCSTAT, STATUS
         INTEGER :: JDATE = 0
         INTEGER :: JTIME = 0

         INTEGER, ALLOCATABLE :: GC_MAP( : )
         INTEGER, ALLOCATABLE :: AE_MAP( : )
         INTEGER, ALLOCATABLE :: NR_MAP( : )
         INTEGER, ALLOCATABLE :: TR_MAP( : )


C-----------------------------------------------------------------------

C RETRIEVE THE SPECIES SAVED TO INTEGRAL AVERAGE CONCENTRATION FILE

         IF ( N_ACONC_VARS .EQ. 0 .OR. ACONC_FILE_SPCS( 1 ) .EQ. 'ALL' ) THEN
            V = 0
            DO VAR = 1, N_GC_SPC
               V = V + 1
               ACONC_FILE_SPCS( V ) = GC_SPC( VAR )
            END DO
            DO VAR = 1, N_AE_SPC
               V = V + 1
               ACONC_FILE_SPCS( V ) = AE_SPC( VAR )
            END DO
            DO VAR = 1, N_NR_SPC
               V = V + 1
               ACONC_FILE_SPCS( V ) = NR_SPC( VAR )
            END DO
            DO VAR = 1, N_TR_SPC
               V = V + 1
               ACONC_FILE_SPCS( V ) = TR_SPC( VAR )
            END DO
            ACONC_FILE_SPCS( V + 1 ) = 'RH'
            ACONC_FILE_SPCS( V + 2 ) = 'TA'
            ACONC_FILE_SPCS( V + 3 ) = 'PRES'
            N_ACONC_VARS = V + 3
#ifdef sens
            N_ASENS_VARS = V
#endif
         END IF
C  Retrieve CTM_WVEL environmental variable to see if user wants diagnosed vertical velocity
         IF ( W_VEL ) THEN 
            ACONC_FILE_SPCS( N_ACONC_VARS + 1 ) = 'WVEL'
            N_ACONC_VARS = N_ACONC_VARS + 1
         END IF
C Retrieve the layer range used in integral average concentration file
         IF ( ACONC_ELEV .EQ. -1 ) ACONC_ELEV = NLAYS

         IF ( ACONC_BLEV .LE. 0 .OR. ACONC_ELEV .GT. NLAYS ) THEN
            WRITE( XMSG,'( "Layer range", 2I4, " invalid for this model" )' )
     &      ACONC_BLEV, ACONC_ELEV
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         A_NLYS = ACONC_ELEV - ACONC_BLEV + 1

C Check species names against include files and create AVG_CONC_MAP, and
C get starting index in AGRID and total count for each species class

         ALLOCATE ( A_GC_SPC    ( N_ACONC_VARS ),
     &              A_AE_SPC    ( N_ACONC_VARS ),
     &              A_NR_SPC    ( N_ACONC_VARS ),
     &              A_TR_SPC    ( N_ACONC_VARS ),
     &              GC_MAP      ( N_ACONC_VARS ),
     &              AE_MAP      ( N_ACONC_VARS ),
     &              NR_MAP      ( N_ACONC_VARS ),
     &              TR_MAP      ( N_ACONC_VARS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'AVG_CONC_MAP or A_GC_SPC or A_AE_SPC or A_NR_SPC'
     &           // ' or A_TR_SPC or GC_MAP or AE_MAP or NR_MAP or TR_MAP'
     &           // ' memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

C The selected species MUST be contiguous with the classes,
C and the classes must be in the sequence: GC, AE, NR, TR

         N_A_GC_SPC = 0
         N_A_AE_SPC = 0
         N_A_NR_SPC = 0
         N_A_TR_SPC = 0

         DO VAR = 1, N_ACONC_VARS
            V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_GC_SPC, GC_SPC )
            IF ( V .GT. 0 ) THEN
               N_ASPCS = N_ASPCS + 1
               N_A_GC_SPC = N_A_GC_SPC + 1
               A_GC_SPC( N_A_GC_SPC ) = ACONC_FILE_SPCS( VAR )
               OFF = 0
               GC_MAP( N_A_GC_SPC ) = V + OFF
            ELSE
               V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_AE_SPC, AE_SPC )
               IF ( V .GT. 0 ) THEN
                  N_ASPCS = N_ASPCS + 1
                  N_A_AE_SPC = N_A_AE_SPC + 1
                  OFF = N_GC_SPC + 1   ! accounts for advected density
                  A_AE_SPC( N_A_AE_SPC ) = ACONC_FILE_SPCS( VAR )
                  AE_MAP( N_A_AE_SPC ) = V + OFF
               ELSE
                  V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_NR_SPC, NR_SPC )
                  IF ( V .GT. 0 ) THEN
                     N_ASPCS = N_ASPCS + 1
                     N_A_NR_SPC = N_A_NR_SPC + 1
                     OFF = N_GC_SPC + 1 + N_AE_SPC
                     A_NR_SPC( N_A_NR_SPC ) = ACONC_FILE_SPCS( VAR )
                     NR_MAP( N_A_NR_SPC ) = V + OFF
                  ELSE
                     V = INDEX1 ( ACONC_FILE_SPCS( VAR ), N_TR_SPC, TR_SPC )
                     IF ( V .GT. 0 ) THEN
                        N_ASPCS = N_ASPCS + 1
                        N_A_TR_SPC = N_A_TR_SPC + 1
                        OFF = N_GC_SPC + 1 + N_AE_SPC + N_NR_SPC
                        A_TR_SPC( N_A_TR_SPC ) = ACONC_FILE_SPCS( VAR )
                        TR_MAP( N_A_TR_SPC ) = V + OFF
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'WVEL' ) THEN
                        ALLOCATE( AVG_WVEL( NCOLS,NROWS,A_NLYS ) )
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'RH' ) THEN
                        L_ACONC_RH = .TRUE.
                        ALLOCATE( AVG_RH( NCOLS,NROWS,A_NLYS ) )
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'TA' ) THEN
                        L_ACONC_TA = .TRUE.
                        ALLOCATE( AVG_TA( NCOLS,NROWS,A_NLYS ) )
                     ELSE IF ( ACONC_FILE_SPCS( VAR ) .EQ. 'PRES' ) THEN
                        L_ACONC_PRES = .TRUE.
                        ALLOCATE( AVG_PRES( NCOLS,NROWS,A_NLYS ) )
                     ELSE
                        XMSG = 'Variable ' // ACONC_FILE_SPCS( VAR )
     &                  // ' was requested for average concentration '
     &                  // ' output, but it is not available from any '
     &                  // ' species namelist.'
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                     END IF
                  END IF
               END IF
            END IF
         END DO

         A_GC_STRT = 1
         A_AE_STRT = A_GC_STRT + N_A_GC_SPC
         A_NR_STRT = A_AE_STRT + N_A_AE_SPC
         A_TR_STRT = A_NR_STRT + N_A_NR_SPC

         IF ( N_A_AE_SPC .GT. 0 ) THEN
            N_A_AE_SPCD = N_A_AE_SPC
         ELSE
            N_A_AE_SPCD = 1
         END IF

         ! Map the CGRID indices to the AGRID indices 
         !    i.e.: AVG_CONC_MAP( AGRID_IND ) = CGRID_IND
         ALLOCATE( AVG_CONC_MAP( N_ASPCS ) )
         VAR = 0
         DO V = 1, N_A_GC_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = GC_MAP( V )
         END DO

         DO V = 1, N_A_AE_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = AE_MAP( V )
         END DO

         DO V = 1, N_A_NR_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = NR_MAP( V )
         END DO

         DO V = 1, N_A_TR_SPC
            VAR = VAR + 1
            AVG_CONC_MAP( VAR ) = TR_MAP( V )
         END DO

         ! Deallocate arrays if they are unused
         DEALLOCATE( GC_MAP, AE_MAP, NR_MAP, TR_MAP )
         IF ( N_A_GC_SPC .EQ. 0 ) DEALLOCATE ( A_GC_SPC )
         IF ( N_A_AE_SPC .EQ. 0 ) DEALLOCATE ( A_AE_SPC )
         IF ( N_A_NR_SPC .EQ. 0 ) DEALLOCATE ( A_NR_SPC )
         IF ( N_A_TR_SPC .EQ. 0 ) DEALLOCATE ( A_TR_SPC )

         END SUBROUTINE A_CONC_DEFN

      END MODULE AVG_CONC

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_SETUP_IPR

C-----------------------------------------------------------------------
C Function: To store IPR data that will be needed to 
C           generate the PA report and output INCLUDE files
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified by Jerry Gipson April, 1997, to add ADJC process
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jun, 1998 by Jerry Gipson to add PING to the CTM science processes
C  Modified Feb, 2002 by Jerry Gipson to correct IO/API variable names for
C  TOTDIF & TOTTRAN
C  Jun, 2005 Jeff Young to add HADV for yamo
C  Jan, 2006 Jeff Young: change operator names to be 4 chars - they prepend
C species names, which must remain less that 12 chars, i.e. OPNM_<__SPECIES__>
C                                                           12345 67890123456
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS, Only: NFAMLYS, FAMNAME, NUMFAMMEM, FAMMEMNAM, FAMSC
      USE PA_IPRVARS
      USE PA_IPRDEF
      USE PA_DEFN
      USE PA_PARSE, Only: IZERO
      USE CGRID_SPCS, Only: N_CGRID_SPC, CGRID_NAME

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:
      INTEGER IFM    ! Family pointer 
      INTEGER ISP    ! Species pointer
      INTEGER N      ! Loop counter
      INTEGER NIPR   ! Loop counter on IPR output commands
      INTEGER NS     ! Loop index for species
      INTEGER ASTAT  ! Memory allocation status

      LOGICAL :: LSAVSP( N_CGRID_SPC )  ! Flag to save species conc for PA

      CHARACTER( 120 ) :: MSG = ' '
         
C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set up the Process analysis output pointers 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ALLOCATE( LPROCOUT( NPRCS ),
     &          IPROUT( N_IPR_SPC,NPRCS ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 1 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF
      LPROCOUT = .FALSE.   ! array assignment
      IPROUT = 0           !   "       "

      NIPRVAR = 0
      DO NIPR = 1, N_IPR_SPC
         IF ( LEN_TRIM( IPR_SPNAM( NIPR ) ) .GT. 11 ) THEN
            WRITE( *,* ) ' '
            WRITE( MSG, 94030 ) TRIM( IPR_SPNAM( NIPR ) )
            CALL M3MESG( MSG )
            WRITE( MSG, 94031 )
            CALL M3MESG( MSG )
         END IF

         DO N = 1, N_IPR_OPS( NIPR )

            NIPRVAR = NIPRVAR + 1

            IF ( NIPRVAR .GT. MAXIPROUT ) THEN
               WRITE( MSG, 94000 ) 
               CALL M3MESG( MSG )
               WRITE( MSG, 94020 ) MAXIPROUT
               CALL M3MESG( MSG )
               CALL M3EXIT( 'GETEXTDAT', IZERO, IZERO, ' ', XSTAT2 )
            END IF

            IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'ZADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'ZADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Z-Advection of ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,1 )   = NIPRVAR
               LPROCOUT( 1 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'HADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'HADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal Advection of ' //
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,2 )   =  NIPRVAR
               LPROCOUT( 2 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'HDIF' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'HDIF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal diffusion for ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,3 )   = NIPRVAR
               LPROCOUT( 3 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'VDIF' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'VDIF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Vertical diffusion for ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,4 )   = NIPRVAR
               LPROCOUT( 4 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'EMIS' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'EMIS_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Emissions of ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,5 )   = NIPRVAR
               LPROCOUT( 5 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'DDEP' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'DDEP_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Dry deposition for ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,6 )   = NIPRVAR
               LPROCOUT( 6 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'CLDS' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'CLDS_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Clouds for ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,7 )   = NIPRVAR
               LPROCOUT( 7 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'CHEM' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'CHEM_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Chemistry of ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,8 )   = NIPRVAR
               LPROCOUT( 8 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'COND' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'COND_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Condensation for ' // 
     &                                    IPR_SPNAM( NIPR )
               IPROUT( NIPR,9 )   = NIPRVAR
               LPROCOUT( 9 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'COAG' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'COAG_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Coagulation for ' // 
     &                                    IPR_SPNAM( NIPR )
               IPROUT( NIPR,10 )   = NIPRVAR
               LPROCOUT( 10 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:5 ) .EQ. 'GROW' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'GROW_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'Aerosol Growth (Renaming) for ' // 
     &                                    IPR_SPNAM( NIPR )
               IPROUT( NIPR,11 )   = NIPRVAR
               LPROCOUT( 11 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:3 ) .EQ. 'NPF' ) THEN
               IPRNAME_TMP( NIPRVAR )  = 'NPF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR )  = 'New Particle Formation for ' // 
     &                                    IPR_SPNAM( NIPR )
               IPROUT( NIPR,12 )   = NIPRVAR
               LPROCOUT( 12 )      = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'AERO' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'AERO_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Aerosol Impact on ' // 
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,9  )  = NIPRVAR
               IPROUT( NIPR,10 )  = NIPRVAR
               IPROUT( NIPR,11 )  = NIPRVAR
               IPROUT( NIPR,12 )  = NIPRVAR
               LPROCOUT( 9  )     = .TRUE.
               LPROCOUT( 10 )     = .TRUE.
               LPROCOUT( 11 )     = .TRUE.
               LPROCOUT( 12 )     = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'MADV' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'MADV_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Horizontal and Vertical Advection of ' //
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,2 )  = NIPRVAR
               IPROUT( NIPR,1 )  = NIPRVAR
               LPROCOUT( 2 )     = .TRUE.
               LPROCOUT( 1 )     = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'TDIF' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'TDIF_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Total Diffusion of ' //
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,3 )  = NIPRVAR
               IPROUT( NIPR,4 )  = NIPRVAR
               LPROCOUT( 3 )     = .TRUE.
               LPROCOUT( 4 )     = .TRUE.
            ELSE IF ( IPR_OPNAME( NIPR,N )( 1:4 ) .EQ. 'TRNM' ) THEN
               IPRNAME_TMP( NIPRVAR ) = 'TRNM_' // IPR_SPNAM( NIPR )
               IPRDESC_TMP( NIPRVAR ) = 'Total Mass-Conserving Transport of ' //
     &                                   IPR_SPNAM( NIPR )
               IPROUT( NIPR,2 )  = NIPRVAR
               IPROUT( NIPR,1 )  = NIPRVAR
               IPROUT( NIPR,3 )  = NIPRVAR
               IPROUT( NIPR,4 )  = NIPRVAR
               LPROCOUT( 2 )     = .TRUE.
               LPROCOUT( 1 )     = .TRUE.
               LPROCOUT( 3 )     = .TRUE.
               LPROCOUT( 4 )     = .TRUE.
            END IF
         END DO
      END DO

      ALLOCATE( IPRNAME( NIPRVAR ),
     &          IPRDESC( NIPRVAR ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 2 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF

      IPRNAME = IPRNAME_TMP( 1:NIPRVAR )
      IPRDESC = IPRDESC_TMP( 1:NIPRVAR )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set up the species pointers for the IPR Outputs
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LSAVSP = .FALSE.

      ALLOCATE( NCGRID ( N_IPR_SPC ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 3 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF

      DO NIPR = 1, N_IPR_SPC
         ISP = INDEX1( IPR_SPNAM( NIPR ), N_CGRID_SPC, CGRID_NAME )
         IF ( ISP .NE. 0 ) THEN
            LSAVSP( ISP ) = .TRUE.
            NCGRID( NIPR ) = 1
            IPR2GRD_TMP( NIPR,1 ) = ISP
            SPCOEF_TMP( NIPR,1 ) = 1.0
         ELSE
            IFM = INDEX1( IPR_SPNAM( NIPR ), NFAMLYS, FAMNAME )
            NCGRID( NIPR ) = NUMFAMMEM( IFM )
            DO N = 1, NUMFAMMEM( IFM )
               ISP = INDEX1( FAMMEMNAM( IFM,N ), N_CGRID_SPC, CGRID_NAME )
               LSAVSP( ISP ) = .TRUE.               
               IPR2GRD_TMP( NIPR,N ) = ISP 
               SPCOEF_TMP( NIPR,N ) = FAMSC( IFM,N )
            END DO
         END IF
      END DO
      MXCGRID = MAX( 1, MAXVAL( NCGRID( : ) ) )

      NCSAVE = 0
      DO NS = 1, N_CGRID_SPC
         IF ( LSAVSP( NS ) ) THEN
            NCSAVE = NCSAVE + 1
            SAV2GRD_TMP( NCSAVE ) = NS
         END IF
      END DO

      DO NIPR = 1, N_IPR_SPC
         DO N = 1, NCGRID( NIPR )
            DO NS = 1, NCSAVE
               IF ( SAV2GRD_TMP( NS ) .EQ. IPR2GRD_TMP( NIPR,N ) )
     &              IPR2SAV_TMP( NIPR,N ) = NS
            END DO
         END DO
      END DO

      NCSAVE    = MAX( NCSAVE, 1 )
      ALLOCATE( SAV2GRD ( NCSAVE ),
     &          IPR2GRD( N_IPR_SPC,MXCGRID ),
     &          IPR2SAV( N_IPR_SPC,MXCGRID ),
     &          SPCOEF ( N_IPR_SPC,MXCGRID ), STAT = ASTAT )
      IF ( ASTAT .NE. 0 ) THEN
         MSG = 'ERROR 4 allocating IPR variables'
         CALL M3EXIT ( 'PA_SETUP_IPR', 0, 0, MSG, XSTAT2 )
      END IF

      SAV2GRD = SAV2GRD_TMP( 1:NCSAVE )
      IPR2GRD = IPR2GRD_TMP( 1:N_IPR_SPC,1:MXCGRID )
      IPR2SAV = IPR2SAV_TMP( 1:N_IPR_SPC,1:MXCGRID )
      SPCOEF  = SPCOEF_TMP ( 1:N_IPR_SPC,1:MXCGRID )

      RETURN

C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( 'ERROR: Maximum number of IPR_OUTPUTs exceeded' )
94020 FORMAT( '       Modify PARAMETER ( MAXIPROUT =', I3,' ) or',
     &              ' decrease the number of IPR_OUTPUTs' )
94030 FORMAT( 'WARNING: Species name ', A, ' too long.' )
94031 FORMAT( '     Combined variable name will ',
     &        'exceed the I/O-API''s 16 character limit.' )
            
      END SUBROUTINE PA_SETUP_IPR

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE LSTEPF ( FNAME, LDATE, LTIME )

C returns the last data date & time on file FNAME
C specifically used only for input files

      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:
 
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      CHARACTER( 16 ) :: FNAME
      INTEGER      LDATE        ! last file data date, coded YYYYDDD
      INTEGER      LTIME        ! last file data time, coded HHMMSS

C External Functions:
  
C local variables:

      CHARACTER( 16 ) :: PNAME = 'LSTEPF'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      LSTEP

C-----------------------------------------------------------------------

C open existing file for readonly access

      IF ( .NOT. OPEN3( FNAME, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open '// FNAME
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF

      IF ( .NOT. DESC3( FNAME ) ) THEN
         XMSG = 'Could not get ' // FNAME // ' file description'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
         END IF
 
      LSTEP = SEC2TIME( ( MXREC3D - 1 ) * TIME2SEC( TSTEP3D ) )
      LDATE = SDATE3D
      LTIME = STIME3D
      CALL NEXTIME( LDATE, LTIME, LSTEP )
 
      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE PM3EXIT( CALLER, JDATE, JTIME, MSGTXT, EXITSTAT )
C.....................................................................
C
C  PURPOSE:   Provides M3EXIT functionality in a parallel environment.
C             The processor-id suffix is appended to the name of the
C             caller. Generate simple error messages for Models-3.
C             Program execution is terminated via exit(0) if exitstat
C             is zero and by MPI_ABORT otherwise.
C
C
C  PRECONDITIONS REQUIRED:  Same as for M3EXIT.
C
C
C  REVISION  HISTORY:
C       Original version 07/1998 by Al Bourgeois.
C       Modified 12/07/1998 by Al Bourgeois to add EXTERNAL declarations.
C       Modified 06/11/1999 by Al Bourgeois to cause all processors to exit.
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO; removed
C             deprecated TRIMLEN
C       Modified 09/19/2011 by David Wong
C          -- Replaced MPI_FINALIZE with MPI_ABORT to avoid hanging situation
C
C
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER*(*)   CALLER       ! Name of the caller.
C     INTEGER         JDATE        ! Model date for the error.
C     INTEGER         JTIME        ! Model time for the error.
C     CHARACTER*(*)   MSGTXT       ! Error message.
C     INTEGER         EXITSTAT     ! Exit status for program.
C
C     COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE               !  Local processor id.
C
C  OUT: none
C
C  SUBROUTINES AND FUNCTIONS CALLS:  INIT3, SHUT3, MPI_ABORT, INQUIRE.
C
C***********************************************************************

      USE M3UTILIO              ! i/o api
      USE RUNTIME_VARS

      IMPLICIT NONE

C...........   INCLUDES:

      INCLUDE 'mpif.h'           ! MPI definitions and parameters.
      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.


C...........   ARGUMENTS and their descriptions:

      CHARACTER*(*)   CALLER       ! Name of the caller.
      INTEGER         JDATE        ! Model date for the error.
      INTEGER         JTIME        ! Model time for the error.
      CHARACTER*(*)   MSGTXT       ! Error message.
      INTEGER         EXITSTAT     ! Exit status for program.


C...........   LOCAL VARIABLES

      INTEGER      LENSTR       ! String length of CALLER.
      INTEGER      IDEV         ! Loop counter over FORTRAN unit numbers.
      INTEGER      ERRCODE      ! Error code from abort attempt.
      INTEGER      IERROR       ! Error from MPI_ABORT routine.
      LOGICAL      OFLAG        ! Flag for indicating file open.
      CHARACTER*24 DTBUF        ! Scratch area for date string.
      CHARACTER*7  PE_STR       ! String suffix to go with processor ID.
      CHARACTER*16 CALL16       ! First 16 characters of CALLER.
      CHARACTER*26 PCALLER      ! New caller string with PE information.

C.............................................................................
C   begin subroutine PM3EXIT


C.......  Construct new CALLER string.
      WRITE (PE_STR,'(A7)') ' on PE '


C.......  Construct new CALLER string.
      LENSTR = MIN( 16, LEN_TRIM(CALLER) )
      CALL16 = CALLER( 1: LENSTR )
      PCALLER = CALL16(1:LENSTR)//PE_STR//CMYPE


C.......  Do M3EXIT tasks.

      IF ( EXITSTAT .NE. 0 ) THEN     ! Print messages for abnormal abort. 

          WRITE( LOGDEV,91010 ) PCALLER, TRIM( MSGTXT )

          IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
              DTBUF = DT2STR( JDATE, JTIME )
              IF ( LOGDEV .NE. 6 )
     &            WRITE( LOGDEV,* ) 'PM3EXIT:  DTBUF ', DTBUF
              WRITE( LOGDEV,92020 ) DTBUF, JDATE, JTIME
          ELSE
              IF ( LOGDEV .NE. 6 )
     &            WRITE( LOGDEV,* )  'PM3EXIT:  date&time specified as 0'
              WRITE( LOGDEV,92000 )
     &                'Date&time specified as 0', ' ', ' '
          END IF


      ELSE        ! Print message for normal completion.

            WRITE( LOGDEV,92010 ) PCALLER, TRIM( MSGTXT )

            IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
                WRITE( LOGDEV,92020 )
     &             DT2STR( JDATE, JTIME ), JDATE, JTIME
            END IF

      END IF


C.......  Shut down the I/O API.
      IF ( .NOT. SHUT3() ) THEN
         WRITE( LOGDEV,91000 )
     &   'Could not shut down I/O API files correctly'
      END IF


C.......  Close all files.
      DO IDEV = 10, 99
         INQUIRE( UNIT = IDEV, OPENED = OFLAG )
         IF ( OFLAG ) CLOSE( IDEV )
      END DO

      
      IF ( EXITSTAT .NE. 0 ) THEN    ! Abnormal abort.

C.......  Abort all parallel tasks.
          CALL MPI_ABORT( MPI_COMM_WORLD, ERRCODE, IERROR )
!         CALL MPI_FINALIZE( IERROR )

          STOP

      ELSE    !  exitstat = 0:  successful completion.

          CALL EXIT( EXITSTAT )

      ENDIF



C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91000   FORMAT ( //5X , '*** ERROR ABORT in subroutine PM3EXIT ***',
     &            /5X , A , // )

91010   FORMAT ( //5X , '*** ERROR ABORT in subroutine ', A,
     &            /5X , A )


C...........   Informational (LOG) message formats... 92xxx

92000   FORMAT ( 5X , A )

92010   FORMAT ( //5X , '--->>  Normal Completion of program ', A,
     &            /5X , A )

92020   FORMAT ( 5X , 'Date and time ', A, :,
     &                  ' (', I7, ':', I6.6, ')' )

      END
  
         

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE Y_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )

C-----------------------------------------------------------------------
C Function:
C   Piecewise Parabolic Method advection in the Y-direction

C Preconditions:

C Subroutines and functions called:

C Revision history:
C  28 Jun 2004: Jeff Young

C   1 Nov 06: Jeff Young - Following Glenn Hammond, moved all communication
C   out of HPPM to this level; using "swap_sandia" communication; update only
C   local values in the CGRID array within a time step, discarding previous
C   ghost values.
C   11 May 2009: Jeff Young: Simplify - assume constant cell widths, DS( i )
C   11 May 2010: Jeff Young: New hppm fix for PGI compiler by David Wong
C   21 Jun 2010: Jeff Young: convert for Namelist redesign
C   16 Feb 2011: Shawn Roselle: replaced I/O API include files with UTILIO_DEFN
C   19 Oct 2015: Jeff Young: Remove stmnt func to resolve PGI compiler error
C   29 Nov 17 David Wong: removed all SWAP routines and replaced with SE_COMM
C   16 NOv 2018 S.Napelenok: ISAM implementation
C    1 Feb 19 David Wong: removed all MY_N clauses
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE HGRD_DEFN             ! horizontal domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef isam
      USE SA_DEFN, Only: ISAM, N_SPCTAG, S_SPCTAG, T_SPCTAG,
     &                   TRANSPORT_SPC, BCON_SPC, MAP_ADVtoSA
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN, BCS, DATENUM, IPT, IDATE, IPARM, IREGION, CKTIME, STARTDATE
#endif 

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: FDATE         ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: FTIME         ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP         ! time step (HHMMSS)
      INTEGER, INTENT( IN ) :: LVL           ! layer
      REAL,    INTENT( IN ) :: BCON( :,: )      ! boundary concentrations

C External Functions:

      REAL,    EXTERNAL :: ZFDBC

C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

! #ifdef parallel
      INTEGER, PARAMETER :: SWP = 3
! #else
!     INTEGER, PARAMETER :: SWP = 1
! #endif

C File Variables:

      REAL         VHAT( NCOLS+1,NROWS+1 )       ! x1-component CX-velocity

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'Y_PPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 96 ) :: XMSG = ' '

      REAL,    SAVE :: DX2                      ! dx2 (meters)
      INTEGER, SAVE :: ASPC                     ! RHOJ index in CGRID

      REAL, ALLOCATABLE, SAVE :: VELY( : ),     ! Velocities along a column
     &                           CONY( :,: )    ! Conc's along a column
#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_CONY( :,: )
#endif

      REAL          DT                          ! TSTEP in sec
      INTEGER       ALLOCSTAT

      INTEGER, ALLOCATABLE, SAVE :: ADV_MAP( : )  ! global adv map to CGRID

      CHARACTER( 16 ) :: X2VEL = 'X2VEL'

      INTEGER      COL, ROW, SPC, VAR           ! loop counters
      INTEGER      A2C

      LOGICAL, SAVE :: BNDY_PE_LOY, BNDY_PE_HIY

#ifdef parallel
      INTEGER NORTH_ROW
      REAL, ALLOCATABLE, SAVE :: HALO_NORTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: HALO_SOUTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: BUF_NS( :,:,: )
#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_HALO_NORTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_SOUTH( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_NS( :,:,: )
#endif
#endif
      INTEGER, SAVE :: SFX    ! fixed parameter for southern boundary
      INTEGER, SAVE :: NFX    ! fixed parameter for northern boundary

#ifdef sens
      LOGICAL TIMEFLAG                  ! checks if within desired time
      REAL, ALLOCATABLE, SAVE :: SENY( :,: )    ! Sens along a col
      REAL,    EXTERNAL :: S_ZFDBC   ! similar to zfdbc, for sens
#ifdef parallel
      REAL, ALLOCATABLE, SAVE :: S_HALO_NORTH( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: S_HALO_SOUTH( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: S_BUF_NS( :,:,:,: )
#endif
#endif

C Required interface for allocatable array dummy arguments

      INTERFACE
         SUBROUTINE HCONTVEL ( FDATE, FTIME, TSTEP, LVL, UORV, UHAT )
            INTEGER,         INTENT( IN )     :: FDATE, FTIME, TSTEP, LVL
            CHARACTER( 16 ), INTENT( IN )     :: UORV
            REAL,            INTENT( OUT )    :: UHAT( :,: )
         END SUBROUTINE HCONTVEL
         SUBROUTINE HPPM ( NI, NJ, CON, VEL, DT, DS, ORI )
! #ifdef parallel
            INTEGER, PARAMETER                :: SWP = 3
! #else
!           INTEGER, PARAMETER                :: SWP = 1
! #endif
            INTEGER,         INTENT( IN )     :: NI, NJ
            REAL,            INTENT( IN OUT ) :: CON( 1-SWP:,1: )
            REAL,            INTENT( IN )     :: VEL( : )
            REAL,            INTENT( IN )     :: DT
            REAL,            INTENT( IN )     :: DS
            CHARACTER,       INTENT( IN )     :: ORI
         END SUBROUTINE HPPM
      END INTERFACE
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         SFX = 0
         NFX = NCOLS + NROWS + 3

C Get dx2 from HGRD_DEFN module

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX2 = DG2M * YCELL_GD   ! in m.

         ELSE
            DX2 = YCELL_GD          ! in m.
         END IF

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ

         ALLOCATE ( CONY( 1-SWP:NROWS+SWP,N_SPC_ADV ),
#ifdef isam
     &              SA_CONY( 1-SWP:NROWS+SWP,N_SPCTAG ),
#endif
     &              VELY( NROWS+1 ), STAT = ALLOCSTAT ) ! Vel along a col
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VELY, or CONY'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#ifdef isam
         SA_CONY = 0.0
#endif
         ALLOCATE ( ADV_MAP( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ADV_MAP'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

#ifdef parallel
         ALLOCATE ( HALO_NORTH( NCOLS,SWP,N_SPC_ADV ),
     &              HALO_SOUTH( NCOLS,SWP,N_SPC_ADV ),
     &              BUF_NS    ( NCOLS,SWP,N_SPC_ADV ),
#ifdef isam
     &              SA_HALO_NORTH( NCOLS,SWP,N_SPCTAG ),
     &              SA_HALO_SOUTH( NCOLS,SWP,N_SPCTAG ),
     &              SA_BUF_NS    ( NCOLS,SWP,N_SPCTAG ),
#endif
     &              STAT = ALLOCSTAT )

         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating HALO_NORTH, HALO_SOUTH, or BUF_NS'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
         HALO_NORTH = 0.0   ! array
         HALO_SOUTH = 0.0   ! array
         BUF_NS     = 0.0   ! array
#ifdef isam
         SA_HALO_NORTH = 0.0   ! array
         SA_HALO_SOUTH = 0.0   ! array
         SA_BUF_NS     = 0.0   ! array
#endif
#endif

#ifdef sens
         ALLOCATE ( SENY( 1-SWP:NROWS+SWP,N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SENY'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
            END IF
#ifdef parallel
         ALLOCATE ( S_HALO_NORTH( NCOLS,SWP,N_SPC_ADV,NPMAX ),
     &              S_HALO_SOUTH( NCOLS,SWP,N_SPC_ADV,NPMAX ),
     &              S_BUF_NS    ( NCOLS,SWP,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG =
     &      'Failure allocating S_HALO_NORTH, S_HALO_SOUTH, or S_BUF_NS'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
         S_HALO_NORTH = 0.0   ! array
         S_HALO_SOUTH = 0.0   ! array
         S_BUF_NS     = 0.0   ! array
#endif
#endif

         ASPC = GC_STRT - 1 + N_GC_SPCD

C Create global map to CGRID

         SPC = 0
         DO VAR = 1, N_GC_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = GC_STRT - 1 + GC_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_AE_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = AE_STRT - 1 + AE_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_NR_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = NR_STRT - 1 + NR_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_TR_ADV
            SPC = SPC + 1
            ADV_MAP( SPC ) = TR_STRT - 1 + TR_ADV_MAP( VAR )
         END DO

         ADV_MAP( N_SPC_ADV ) = ASPC

         CALL SUBST_HI_LO_BND_PE ( 'R', BNDY_PE_LOY, BNDY_PE_HIY )

         END IF                    ! if firstime

      DT = FLOAT ( TIME2SEC ( TSTEP ) )

#ifdef sens
      ! index that will be used by IDATE
      DATENUM = 1 + FDATE - STARTDATE
#endif

C Do the computation for y advection

C Get the contravariant x2 velocity component

      CALL HCONTVEL ( FDATE, FTIME, TSTEP, LVL, X2VEL, VHAT )

      CALL SUBST_COMM (VHAT, DSPL_N1_E0_S0_W0, DRCN_N)

#ifdef parallel
      NORTH_ROW = NROWS - SWP
      DO SPC = 1, N_SPC_ADV
         A2C = ADV_MAP( SPC )
         DO ROW = 1, SWP
            DO COL = 1, NCOLS
               HALO_SOUTH( COL,ROW,SPC ) = CGRID( COL,ROW,LVL,A2C )
               HALO_NORTH( COL,ROW,SPC ) = CGRID( COL,NORTH_ROW+ROW,LVL,A2C )
               BUF_NS( COL,ROW,SPC ) = HALO_NORTH( COL,ROW,SPC )
#ifdef sens
               DO NP = 1, NPMAX
                 S_HALO_SOUTH( COL,ROW,SPC,NP ) = SENGRID( COL,ROW,LVL,NP,A2C )
                 S_HALO_NORTH( COL,ROW,SPC,NP ) = SENGRID( COL,NORTH_ROW+ROW,LVL,NP,A2C )
                 S_BUF_NS( COL,ROW,SPC,NP ) = S_HALO_NORTH( COL,ROW,SPC,NP )
               END DO
#endif
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_SOUTH, HALO_NORTH, DSPL_N1_E0_S0_W0, DRCN_N)
      CALL SUBST_COMM (BUF_NS,     HALO_SOUTH, DSPL_N0_E0_S1_W0, DRCN_S)
#ifdef sens
      DO NP = 1, NPMAX
         CALL SUBST_COMM( S_HALO_SOUTH(:,:,:,NP), S_HALO_NORTH(:,:,:,NP),
     &                    DSPL_N1_E0_S0_W0, DRCN_N )
         CALL SUBST_COMM( S_BUF_NS(:,:,:,NP),         S_HALO_SOUTH(:,:,:,NP),
     &                    DSPL_N0_E0_S1_W0, DRCN_S )
      END DO
#endif


#ifdef isam
      DO SPC = 1, N_SPCTAG
        IF( TRANSPORT_SPC( SPC ) )THEN      
           DO ROW = 1, SWP
             DO COL = 1, NCOLS
               SA_HALO_SOUTH( COL,ROW,SPC ) =
     &                  ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
               SA_HALO_NORTH( COL,ROW,SPC ) =
     &                  ISAM( COL,NORTH_ROW+ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
               SA_BUF_NS( COL,ROW,SPC ) = SA_HALO_NORTH( COL,ROW,SPC )
             END DO
           END DO
        END IF
      END DO

      CALL SUBST_COMM (SA_HALO_SOUTH, SA_HALO_NORTH, DSPL_N1_E0_S0_W0, DRCN_N)
      CALL SUBST_COMM (SA_BUF_NS,     SA_HALO_SOUTH, DSPL_N0_E0_S1_W0, DRCN_S)

#endif

#endif

      DO 233 COL = 1, NCOLS

         DO ROW = 1, NROWS+1
            VELY( ROW ) = VHAT( COL,ROW )
         END DO

         DO SPC = 1, N_SPC_ADV

            A2C = ADV_MAP( SPC )
            DO ROW = 1, NROWS
               CONY( ROW,SPC ) = CGRID( COL,ROW,LVL,A2C )
            END DO

#ifdef parallel
            DO ROW = 1, SWP
               CONY( ROW-SWP,SPC )      = HALO_SOUTH( COL,ROW,SPC )
               CONY( NROWS+ROW,SPC ) = HALO_NORTH( COL,ROW,SPC )
            END DO
#endif

C South boundary

            IF ( BNDY_PE_LOY ) THEN
               IF ( VELY( 1 ) .LT. 0.0 ) THEN          ! outflow
                  CONY( 1-SWP:0,SPC) =
     &               ZFDBC ( CONY( 1,SPC ), CONY( 2,SPC ),
     &                       VELY( 1 ),     VELY( 2 ) )
               ELSE    ! inflow
                  CONY( 1-SWP:0,SPC ) = BCON( SFX+COL,SPC )
               END IF
            END IF

C North boundary

            IF ( BNDY_PE_HIY ) THEN
               IF ( VELY( NROWS+1 ) .GT. 0.0 ) THEN     ! outflow
                  CONY( NROWS+1:NROWS+SWP,SPC ) =
     &               ZFDBC ( CONY( NROWS,SPC ), CONY( NROWS-1,SPC ),
     &                       VELY( NROWS+1 ),   VELY( NROWS ) )
               ELSE    ! inflow
                  CONY( NROWS+1:NROWS+SWP,SPC ) = BCON( NFX+COL,SPC )
               END IF
            END IF

         END DO

#ifdef isam
         DO SPC = 1, N_SPCTAG

            IF( TRANSPORT_SPC( SPC ) )THEN

                DO ROW = 1, NROWS
                   SA_CONY( ROW,SPC ) = ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
                END DO
                
#ifdef parallel
                DO ROW = 1, SWP
                   SA_CONY( ROW-SWP,SPC ) = SA_HALO_SOUTH( COL,ROW,SPC )
                   SA_CONY( NROWS+ROW,SPC ) = SA_HALO_NORTH( COL,ROW,SPC )
                END DO
#endif

C South boundary
                IF ( BNDY_PE_LOY ) THEN
                   IF ( VELY( 1 ) .LT. 0.0 ) THEN   ! outflow
                      SA_CONY( 1-SWP:0,SPC ) =
     &                ZFDBC ( SA_CONY( 1,SPC ), SA_CONY( 2,SPC ), VELY( 1 ), VELY( 2 ) )
                   ELSE    ! inflow
                      IF ( BCON_SPC( SPC ) ) THEN
                         SA_CONY( 1-SWP:0,SPC ) = BCON( SFX+COL,MAP_ADVtoSA( SPC )  )
                      ELSE
                         SA_CONY( 1-SWP:0,SPC ) = 0.0
                      END IF 
                   END IF   ! vely < 0 ?
                END IF   ! bndy_pe_loy ?

C North boundary
                IF ( BNDY_PE_HIY ) THEN
                   IF ( VELY( NROWS+1 ) .GT. 0.0 ) THEN     ! outflow
                      SA_CONY( NROWS+1:NROWS+SWP,SPC ) =
     &                ZFDBC ( SA_CONY( NROWS,SPC ), SA_CONY( NROWS-1,SPC ),
     &                        VELY( NROWS+1 ), VELY( NROWS ) )
                   ELSE    ! inflow
                      IF ( BCON_SPC( SPC ) ) THEN
                         SA_CONY( NROWS+1:NROWS+SWP,SPC ) = BCON( NFX+COL,MAP_ADVtoSA( SPC ) )
                      ELSE
                         SA_CONY( NROWS+1:NROWS+SWP,SPC ) = 0.0
                      END IF
                   END IF   ! vely > 0 ?
                END IF   ! bndy_pe_hiy ?
            END IF  
         END DO   ! SPC loop
#endif

C PPM scheme
         CALL HPPM ( NROWS, NCOLS, CONY, VELY, DT, DX2, 'R' )
#ifdef isam
         CALL HPPM ( NROWS, NCOLS, SA_CONY, VELY, DT, DX2, 'R' )
#endif

         DO SPC = 1, N_SPC_ADV
            A2C = ADV_MAP( SPC )
            DO ROW = 1, NROWS
               CGRID( COL,ROW,LVL,A2C ) = CONY( ROW,SPC )
            END DO
         END DO

#ifdef isam
        DO SPC = 1, N_SPCTAG
           IF( TRANSPORT_SPC( SPC ) )THEN
              DO ROW = 1, NROWS
                 ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) = SA_CONY( ROW,SPC )
              END DO
           END IF   
        END DO
#endif


#ifdef sens
         DO NP = 1, NPMAX

           CALL CKTIME( FDATE,FTIME,NP,TIMEFLAG) ! Check if the current time is within the time range

           DO SPC = 1, N_SPC_ADV
             A2C = ADV_MAP( SPC )
             DO ROW = 1, NROWS
               SENY( ROW,SPC ) = SENGRID( COL,ROW,LVL,NP,A2C )
             END DO

#ifdef parallel
             DO ROW = 1, SWP
               SENY( ROW-SWP,SPC )   = S_HALO_SOUTH( COL,ROW,SPC,NP )
               SENY( NROWS+ROW,SPC ) = S_HALO_NORTH( COL,ROW,SPC,NP )
             END DO
#endif

C South boundary
             IF ( BNDY_PE_LOY ) THEN
               IF ( VELY( 1 ) .LT. 0.0 ) THEN          ! outflow
                 IF ( CONY( 0, SPC ) .EQ. 0.0 ) THEN
                   SENY( 1-SWP:0, SPC ) = 0.0
                 ELSE ! Zero-flux divergence boundary condition for sens
                   SENY( 1-SWP:0,SPC ) =
     &               S_ZFDBC ( SENY( 1,SPC ), SENY( 2,SPC ),
     &                         VELY( 1 ),     VELY( 2 ) )
                 END IF
               ELSE    ! inflow
                 IF ( BCS ) THEN
                   SENY( 1-SWP:0,SPC ) = BSEN( SFX+COL,SPC,NP )
                 ELSE IF ( ( IPT( NP ) .EQ. 2 ) .AND. ( TIMEFLAG ) ) THEN
                 ! Insert boundary condition to SEN iff time, date,
                 ! species, and region match and senstype is BOUN
                   SENY( 1-SWP:0,SPC ) = BCON( SFX+COL,SPC )
     &                                 * IREGION( COL, 1, LVL, NP )
     &                                 * REAL ( IDATE ( NP, DATENUM ) )
     &                                 * REAL ( IPARM ( NP, A2C     ) )
                 ELSE
                 ! Otherwise, set to 0
                   SENY( 1-SWP:0, SPC ) = 0.0
                 END IF
               END IF
             END IF

C North boundary
             IF ( BNDY_PE_HIY ) THEN
               IF ( VELY( NROWS+1 ) .GT. 0.0 ) THEN     ! outflow
                 IF ( CONY( NROWS+1, SPC ) .EQ. 0.0 ) THEN
                   SENY( NROWS+1:NROWS+SWP, SPC ) = 0.0
                 ELSE
                 ! Zero-flux divergence boundary condition for sens
                   SENY( NROWS+1:NROWS+SWP,SPC ) =
     &               S_ZFDBC ( SENY( NROWS,SPC ), SENY( NROWS-1,SPC ),
     &                         VELY( NROWS+1 ),   VELY( NROWS ) )
                 END IF
               ELSE    ! inflow
                 IF ( BCS ) THEN
                   SENY( NROWS+1:NROWS+SWP,SPC ) = BSEN( NFX+COL,SPC,NP )
                 ELSE IF ( ( IPT( NP ) .EQ. 2 ) .AND. ( TIMEFLAG ) ) THEN
                 ! Insert boundary condition to SEN iff time, date,
                 ! species, and region match and senstype is BOUN
                   SENY( NROWS+1:NROWS+SWP,SPC ) = BCON( NFX+COL,SPC )
     &                               * IREGION( COL, NROWS, LVL, NP )
     &                               * REAL ( IDATE ( NP, DATENUM ) )
     &                               * REAL ( IPARM ( NP, A2C     ) )
                 ELSE
                   SENY( NROWS+1:NROWS+SWP,SPC ) = 0.0
                 END IF
               END IF
             END IF

           END DO

C PPM scheme
           CALL HPPM ( NROWS, NCOLS, SENY, VELY, DT, DX2, 'R' )

           DO SPC = 1, N_SPC_ADV
             A2C = ADV_MAP( SPC )
             DO ROW = 1, NROWS
               SENGRID( COL,ROW,LVL,NP,A2C ) = SENY( ROW,SPC )
             END DO
           END DO

         END DO   ! NP
#endif

233   CONTINUE

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE ADVSTEP( JDATE, JTIME, TSTEP, ASTEP, NREPS )

C-----------------------------------------------------------------------
C Function:
C    Use Courant-number conditions to determine the (time-splitting) model
C    base synchronization time step TSTEP(2) and number NREPS of sync time
C    steps per output time step TSTEP(1). The base synchronization time step
C    is considered to be the Courant condition safe advection time step.
C    Minimum returned sync time step = 900 sec
C    Determines a Courant condition safe advection step in TSTEP(3) with
C    respect to a user-defined minimum sync time step [TSTEP(2)].

C    June 2003 J.Young
C    Restructure to produce layer dependent advection step
C    change arguments:
C       TSTEP( 1 ) = output timestep (same) - input
C       TSTEP( 2 ) = synchronization timestep (same) - output
C       eliminate TSTEP( 3 ). Add new argument ASTEP( NLAYS ) - output

C Preconditions:

C Subroutines and functions called:
C    SEC2TIME, TIME2SEC, DESC3, M3EXIT, HVELOC

C Revision history:
C    prototype 2/93 by CJC
C    configuration management prototype 6/94 by Dongming Hwang

C    Apr 15, 1996 by M. Talat Odman at NCSC:  the number of model time
C    steps is made even to assure symmetry of transport operators within
C    each output time step.

C    Jan 20, 1996 by M. Talat Odman at NCSC:  now applies the CFL condition
C    independently in all three contravariant directions and
C    finds minimum time step.

C    22 Apr 97 Jeff: only for horizontal advection
C                    keep Talat's even step mod for symmetric sciproc
C     2 Sep 97 Jeff: calc. separate sync and adv time steps, TSTEP(3)
C    12 Feb 98 Jeff: make sync step = chem step
C    27 Jun 98 Jeff: allow for constant vel field (time-independent file)

C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C
C    8 Jan 99 by David Wong at LM: GLOBAL_MAX function call is added
C
C    1/19/99 David Wong
C      -- add a loop_index call
C      -- change loop index ending point to avoid accessing invalid region.
C         (reason to do this is to prevent using boundary data from PINTERP,
C          which sets pseudo-boundary data to 0)
C
C    9 Jun 99 by David Wong at LM: change GLOBAL_MAX to GLOBAL_RMAX
C    21 Nov 00 J.Young: GLOBAL_RMAX -> Dave Wong's f90 stenex GLOBAL_MAX
C    Jeff - Feb 01 - module LOCALFILE to set CCTM IOAPI file defn's
C                  - assumed shape arrays
C   30 Mar 01 J.Young: Use HGRD_DEFN; replace INTERP3 with INTERPX
C    9 Sep 03 J.Young: return layer dependent advection tstep, ASTEP
C   27 Aug 03 J.Young: symmetric processing is now deprecated
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   26 Jul 06 J.Young: add WRF sigma VGTYP
C   27 Apr 07 J.Young: Using Peter Percell's (UH) two timestep max wind
C   20 Jan 09 J.Young: In addition to the CFL criterion, use horizontal divergence
C                      to establish safe advection time step
C   28 Oct 09 J.Young: Revert back from Percell's algorithm to Talat's fix for
C                      multiple adv steps per sync step
C   16 Mar 10 J.Young: Fix hdiv bug for MPI by communicating ghost cell data using
C                      new hveloc to add hdiv and replace hcontvel
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   10 May 11 D.Wong: incorporated twoway model implementation
C    6 Apr 12 J.Young: changed default HDIV_LIM to 0.9; made CFL an env var
C    1 Nov 18 David Wong: removed MY_N clause for NCOLS and NROWS
C    1 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C   20 Nov 19 F. Sidi: Updated MET STIME, SDATE, TSTEP, XCELL, YCELL to correspond
C                      to updates in Centralized I/O 
C   10 Feb 20 D. Wong: Updated sync step calculation to include input 
C                      meterology temporal frequency, to allow running with
C                      finer temporal scale.
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_GLOBAL_MAX_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_GLOBAL_MAX_MODULE, NOOP_UTIL_MODULE)
#endif
      USE centralized_io_module

      IMPLICIT NONE

C Includes:
      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      INTEGER, INTENT( IN ) :: JDATE ! current model simulation date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME ! current model simulation time (HHMMSS)
      INTEGER, INTENT( INOUT ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                ! TSTEP( 1 ) = local output step - INTENT( IN )
                                ! TSTEP( 2 ) = sciproc sync. step (chem) - INTENT( OUT )
                                ! TSTEP( 3 ) = twoway model time step w.r.t. wrf time
                                !              step and wrf/cmaq call frequency
      INTEGER, INTENT( OUT ) :: ASTEP( : )   ! layer advection sub-steps per sync step
                                             ! (HHMMSS)
      INTEGER, INTENT( OUT ) :: NREPS        ! no. of sync steps per output step

C Parameters:

C External Functions:

C Local Variables:
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER, SAVE :: ADVLAYR       ! adv=sync at least up to this level

      INTEGER, SAVE :: WSTEP = 0     ! wind file interpolation time step
      INTEGER, SAVE :: SDATE, STIME  ! wind file start date and time
      INTEGER, SAVE :: FDATE, FTIME  ! wind file current date and time
      INTEGER, SAVE :: FSTEP         ! wind file time step
      INTEGER, SAVE :: OSTEP         ! output time step (sec)

      REAL,    SAVE :: IDX1, IDX2    ! 1/dx1, 1/dx2

      INTEGER :: MINSECS             ! effective MINSYNC (sec) that divides TSTEP(1)
 
      INTEGER :: C, R, L, K  ! loop counters
      INTEGER :: EDATE, ETIME
      INTEGER :: SYNC, SUB, REP      ! loop variables
      INTEGER :: ADV, TADV           ! test sub adv step
      INTEGER :: NADVS( NLAYS )      ! no. of advection sub-steps per sync step
      REAL    :: RSYNC
      REAL    :: MXUOVDX             ! max ( WIND / DS ) all layers 1, ADVLAYR
      LOGICAL :: ADJFLG

      REAL    :: UWIND( NCOLS+1,NROWS+1,NLAYS )
      REAL    :: VWIND( NCOLS+1,NROWS+1,NLAYS )
      REAL    :: HDIV( NCOLS,NROWS,NLAYS )
                                                    ! MAX ( WIND / DS ) ...
      REAL, ALLOCATABLE, SAVE :: WIND_IDX_BEG( : )  ! at beginning of output step
      REAL, ALLOCATABLE, SAVE :: WIND_IDX_END( : )  ! at end of output step
      REAL, ALLOCATABLE, SAVE :: WIND_IDX    ( : )  ! for whole output step
      REAL, ALLOCATABLE, SAVE :: MX_HDIV_BEG( : )   ! at beginning of output step
      REAL, ALLOCATABLE, SAVE :: MX_HDIV_END( : )   ! at end of output step
      REAL, ALLOCATABLE, SAVE :: MX_HDIV    ( : )   ! for whole output step

      REAL(8), PARAMETER :: TOL = 1.D-3 ! Tolerance Parameter for checking that grid 
                                        ! specifications from input files match those 
                                        ! in the model. Units are in meters.

      CHARACTER( 16 ) :: PNAME = 'ADVSTEP'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER :: ALLOCSTAT

      CHARACTER( 80 ) :: VARDESC  ! environment variable description

      INTERFACE
        SUBROUTINE HVELOC( FDATE, FTIME, FSTEP, UWIND, VWIND, HDIV )
            INTEGER, INTENT( IN )  :: FDATE, FTIME, FSTEP
            REAL,    INTENT( OUT ) :: UWIND( :,:,: ), VWIND( :,:,: )
            REAL,    INTENT( OUT ) :: HDIV( :,:,: )
         END SUBROUTINE HVELOC
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LOG_HEADING( LOGDEV, 'INITIALIZE ADVECTION STEPPING' )

         IF ( SIGST .GT. VGLVS_GD( 2 ) .OR.
     &        SIGST .LT. VGLVS_GD( NLAYS + 1 ) ) THEN
            WRITE(XMSG, '(A, 1PE12.3)') 'SIGMA_SYNC_TOP incorrect', SIGST
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

         IF ( SIGST .EQ. VGLVS_GD( NLAYS + 1 ) ) THEN
            L = NLAYS
         ELSE
            DO K = 1, NLAYS
               IF ( SIGST .GE. VGLVS_GD( K+1 ) ) THEN
                  IF ( SIGST - VGLVS_GD( K+1 ) .LE.
     &                 VGLVS_GD( K ) - SIGST )  THEN
                     L = K
                  ELSE
                     L = K - 1
                  END IF
                  EXIT
               END IF
            END DO
         END IF

         ADVLAYR = L
         WRITE( LOGDEV,92005 ) ADVLAYR

         SDATE = FILE_SDATE(F_MET)
         STIME = FILE_STIME(F_MET)
         FSTEP = FILE_TSTEP(F_MET)

C Check file data against COORD.EXT

         IF ( ABS( FILE_XCELL(F_MET) - XCELL_GD ) .GT. TOL .OR.
     &        ABS( FILE_YCELL(F_MET) - YCELL_GD ) .GT. TOL      ) THEN
            WRITE( LOGDEV,* ) 'XCELL3D, XCELL_GD, YCELL3D, YCELL_GD: '
            WRITE( LOGDEV,* ) XCELL3D, XCELL_GD, YCELL3D,YCELL_GD
            XMSG = 'File grid sizes do not match CTM domain definition'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

C Get cell size in meters (from COORD.EXT)

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            IDX2 = 1.0 / ( DG2M * YCELL_GD )
            IDX1 = 1.0 / ( DG2M * XCELL_GD
     &           * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( NROWS/2 ) ) ) )
         ELSE
            IDX1 = 1.0 / XCELL_GD
            IDX2 = 1.0 / YCELL_GD
         END IF

C Get the time of starting wind field: do not interpolate
         IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, FSTEP,
     &                        FDATE, FTIME) ) THEN
            XMSG = 'Cannot get step-starting date and time'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         ALLOCATE( WIND_IDX_BEG( NLAYS ),
     &             WIND_IDX_END( NLAYS ),
     &             WIND_IDX    ( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating WIND_IDX*'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE( MX_HDIV_BEG( NLAYS ),
     &             MX_HDIV_END( NLAYS ),
     &             MX_HDIV    ( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating MX_HDIV*'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
 
         IF ( .NOT. COLUMN_MODEL ) THEN

            CALL HVELOC( FDATE, FTIME, WSTEP, UWIND, VWIND, HDIV )

            DO L = 1, NLAYS
               WIND_IDX_BEG( L ) = 0.0
               MX_HDIV_BEG( L ) = 0.0
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     WIND_IDX_BEG( L ) = MAX( WIND_IDX_BEG( L ),
     &                                   ABS( UWIND( C,R,L ) ) * IDX1,
     &                                   ABS( VWIND( C,R,L ) ) * IDX2 )
                     MX_HDIV_BEG( L ) = MAX( MX_HDIV_BEG( L ), HDIV( C,R,L ) )
                  END DO
               END DO
               WIND_IDX_BEG( L ) = SUBST_GLOBAL_MAX( WIND_IDX_BEG( L ) )
               MX_HDIV_BEG( L )  = SUBST_GLOBAL_MAX( MX_HDIV_BEG( L ) )
            END DO

         ELSE

            UWIND = 0.0
            VWIND = 0.0
            HDIV  = 0.0
            WIND_IDX     = 0.0
            MX_HDIV      = 0.0
            WIND_IDX_BEG = 0.0
            WIND_IDX_END = 0.0
            MX_HDIV_END  = 0.0
            MX_HDIV_BEG  = 0.0

         END IF
      END IF   ! FIRSTIME

C Compute the least number of equal time steps that satisfy the Courant
C condition (force TSTEP(2) to be no greater than MAXSYNC):

#ifdef twoway
      OSTEP = TIME2SEC( TSTEP( 3 ) )
#else
      OSTEP = TIME2SEC( min(TSTEP( 1 ), FSTEP) )
#endif
      MAXSYNC = MIN( OSTEP, MAXSYNC )

C Make sure MINSYNC <= output time step
      IF ( MINSYNC .GT. OSTEP ) THEN
         WRITE( LOGDEV,92009 ) OSTEP, MINSYNC
         XMSG = ' '
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

C Make sure MINSYNC <= MAXSYNC
      IF ( MINSYNC .GT. MAXSYNC ) THEN
         WRITE( LOGDEV,92010 ) MAXSYNC, MINSYNC
         XMSG = ' '
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

C Determine MINSECS, the smallest time step (sec) between MINSYNC and MAXSYNC
C that divides the output step
      IF ( MINSYNC .LE. 1 ) THEN
         MINSECS = 1
      ELSE
         DO MINSECS = MINSYNC, MAXSYNC
            IF ( MOD( OSTEP, MINSECS ) .EQ. 0 ) THEN
               IF ( MINSECS .NE. MINSYNC )
     &              WRITE( LOGDEV,92011 ) JDATE, JTIME, MINSYNC, MINSECS
               EXIT
            ELSE IF ( MINSECS .LT. MAXSYNC ) THEN
               CYCLE
            END IF
C A satisfactory MINSECS could not be found
            WRITE( XMSG,92012 ) MINSYNC, OSTEP
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END DO
      END IF

C Establish ending time for this Courant number calculation:
      EDATE = JDATE
      ETIME = JTIME
#ifdef twoway
      CALL NEXTIME( EDATE, ETIME, TSTEP( 3 ) )
#else
      CALL NEXTIME( EDATE, ETIME, min(TSTEP( 1 ), FSTEP) )
#endif

      IF ( SECSDIFF( FDATE, FTIME, EDATE, ETIME ) .GT. 0 )
C Get the next wind field: do not interpolate
     &   CALL NEXTIME( FDATE, FTIME, FSTEP )

      IF ( .NOT. COLUMN_MODEL ) THEN

         CALL HVELOC( FDATE, FTIME, WSTEP, UWIND, VWIND, HDIV )

         DO L = 1, NLAYS
            WIND_IDX_END( L ) = 0.0
            MX_HDIV_END( L ) = 0.0
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  WIND_IDX_END( L ) = MAX( WIND_IDX_END( L ),
     &                                ABS( UWIND( C,R,L ) ) * IDX1,
     &                                ABS( VWIND( C,R,L ) ) * IDX2 )
                   MX_HDIV_END( L ) = MAX( MX_HDIV_END( L ), HDIV( C,R,L ) )
               END DO
            END DO
            WIND_IDX_END( L ) = SUBST_GLOBAL_MAX( WIND_IDX_END( L ) )
            MX_HDIV_END( L )  = SUBST_GLOBAL_MAX( MX_HDIV_END( L ) )
         END DO

      END IF

      WIND_IDX = MAX( WIND_IDX_BEG, WIND_IDX_END ) ! array
      WIND_IDX_BEG = WIND_IDX_END                  ! save for next call
      MX_HDIV = MAX( MX_HDIV_BEG, MX_HDIV_END )    ! array
      MX_HDIV_BEG = MX_HDIV_END                    ! save for next call

C Determine the synchronization timestep, TSTEP(2), and NREPS, the corresponding
C number of sync steps per output timestep

C Find the largest timestep that satisfies the Courant condition in all of the
C lower ADVLAYR layers. If this is smaller than MINSECS, then set the sync step
C to MINSECS. Otherwise, set the sync step to the largest time step that both
C satisfies the Courant condition and is an integer divisor of the output step
C (existence of such a sync step is guaranteed because, at this point, MINSECS
C satisfies both conditions).
      MXUOVDX = MAXVAL( WIND_IDX( 1:ADVLAYR ) )
      ADJFLG = .FALSE.
      DO REP = 1, OSTEP
         IF ( MOD( OSTEP, REP ) .EQ. 0 ) THEN   ! make TSTEP(2) divide TSTEP(1)
            SYNC = OSTEP / REP
            IF ( SYNC .LE. MAXSYNC ) THEN   ! enforce max TSTEP(2)
               ADV = SYNC
               IF ( MXUOVDX * REAL( ADV ) .LT. CFL ) THEN   ! CFL satisfied
                  IF ( SYNC .GE. MINSECS ) THEN   ! force min TSTEP(2)
                     NREPS = REP
                     GO TO 301
                  ELSE   ! multiple adv steps per sync step (= MINSECS)
                     SYNC = MINSECS
                     NREPS = OSTEP / MINSECS
                     DO SUB = 1, MINSECS
                        IF ( MOD( MINSECS, SUB ) .EQ. 0 ) THEN  ! make ADV divide TSTEP(2)
                           TADV = MINSECS / SUB
                           IF ( TADV .LE. ADV ) THEN
                              ADV = TADV
                              ADJFLG = .TRUE.
                              GO TO 301
                           END IF
                        END IF
                     END DO
                     GO TO 291   ! No solution
                  END IF
               END IF    ! if Courant condition satisfied
            END IF    ! if SYNC .le. MAXSYNC
         END IF    ! if REP divides STEP evenly
      END DO    ! REP loop

291   continue

C If you get here: could not determine satisfactory advection time step.

      WRITE( LOGDEV,94011 ) min(TSTEP( 1 ), FSTEP), MXUOVDX
      XMSG = ' '
      CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )

301   CONTINUE

      TSTEP( 2 ) = SEC2TIME( SYNC )
      DO L = 1, ADVLAYR
         ASTEP( L ) = SEC2TIME( ADV )
         NADVS( L ) = SYNC / ADV
      END DO

      IF ( ADJFLG ) THEN
         WRITE( LOGDEV,92019 ) MINSECS, TSTEP( 2 ), NREPS
      ELSE
         WRITE( LOGDEV,92021 ) TSTEP( 2 ), NREPS
      END IF

      DO L = ADVLAYR + 1, NLAYS
         DO REP = 1, SYNC
            IF ( MOD( SYNC, REP ) .EQ. 0 ) THEN
               ADV = SYNC / REP
               IF ( WIND_IDX( L ) * REAL( ADV ) .LT. CFL ) THEN  ! Layer CFL satisfied
                  NADVS( L ) = REP
                  ASTEP( L ) = SEC2TIME( ADV )
                  GO TO 401
               END IF   ! if courant condition satisfied
            END IF   !  if rep divides step
         END DO

C If you get here: could not determine satisfactory advection time step.

         WRITE( LOGDEV,94013 ) min(TSTEP( 1 ), FSTEP), L, WIND_IDX( L )
         XMSG = ' '
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )

401      CONTINUE

      END DO   ! layer loop

C For each layer ensure that Max(HDIV)*ADV < 1.

      WRITE( LOGDEV,92025 )
      DO L = NLAYS, 1, -1   ! start at the top, purely for the 92027, 92029 write
         ADV = TIME2SEC( ASTEP( L ) )
         IF ( REAL( ADV ) * MX_HDIV( L ) .LT. HDIV_LIM ) THEN
            WRITE( LOGDEV,92027 ) L, ASTEP( L ), NADVS( L )
            CYCLE
         ELSE
            SUB = ADV
            DO WHILE ( SUB .GT. 0 )
               SUB = SUB - 1
               IF ( MOD( SYNC, SUB ) .EQ. 0 ) THEN
                  ASTEP( L ) = SEC2TIME( SUB )
                  NADVS( L ) = SYNC / SUB
                  GO TO 501
               END IF
            END DO
C If you get here: could not determine satisfactory advection time step.

            WRITE( LOGDEV,94013 ) min(TSTEP( 1 ), FSTEP), L, WIND_IDX( L )
            XMSG = ' '
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )

501         CONTINUE
            WRITE( LOGDEV,92029 ) L, ASTEP( L ), NADVS( L )
         END IF
      END DO

      RETURN

C------------------  FORMAT  STATEMENTS   ------------------------------

92005 FORMAT(   5X, 'Top layer thru which sync step determined:', I3 )

92009 FORMAT( / 5X, 'Output time step:', I8,
     &          1X, 'less than minimum synchronization step:', I8 )

92010 FORMAT( / 5X, 'Maximum synchronization step:', I8,
     &          1X, 'less than minimum synchronization step:', I8 )

92011 FORMAT( / 5X, 'From ADVSTEP - date/time: ', I8, '/', I6.6
     &        / 5X, 'Minimum Synchronization Step adjusted from:', I8,
     &          1X, 'to:', I8 )

92012 FORMAT( / 5X, 'Starting from:', I6, ',',
     &          1X, 'could not determine minimum step that divides TSTEP',
     &          1X, 'for model step:', I7.6, ' HHMMSS' )

92019 FORMAT( / 5X, 'Synchronization step adjusted up to minimum (SEC):', I7
     &        /46X, '(HHMMSS): ', I6.6
     &        / 5X, 'Number of Synchronization steps:', I5  )

92021 FORMAT(   5X, 'Computed synchronization step (HHMMSS): ', I6.6
     &        / 5X, 'Number of Synchronization steps:', I5  )

92025 FORMAT( / 5X, 'Layer', 3X, 'Advection', 3X, 'per Sync'
     &        /11X, 'Step (HHMMSS)', 2X, 'Step' )

92027 FORMAT(   5X, I4, 6X, I6.6, 6X, I2 )
92029 FORMAT(   5X, I4, 6X, I6.6, 6X, I2, 2X, '<- Hdiv adjusted' )

94011 FORMAT( / 5X, 'Could not determine Courant-condition safe sync step',
     &          1X, 'for model step:', I7.6, ' HHMMSS',
     &        / 5X, '(Max vel)/(dX) =', 1PE10.3)

94013 FORMAT( / 5X, 'Could not determine Courant-condition safe sync step',
     &          1X, 'for model step:', I7.6, ' HHMMSS',
     &          1X, 'in layer:', I3
     &        / 5X, '(Max vel)/(dX) =', 1PE10.3)

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CMAQ_DRIVER ( MODEL_STDATE, MODEL_STTIME, MODEL_TSTEP,
     $                         MODEL_JDATE, MODEL_JTIME, LAST_STEP,
     $                         COUPLE_TSTEP, NCOLS_IN, NLAYS_IN)

C-----------------------------------------------------------------------
C Function:
C    CMAQ CTM driver
 
C Preconditions:
C    Initialized file CONCFILE for output; completed
C    files HISTORY containing initial conditions, SPCCONST for
C    conversion of concentration field from computational units
C    to output units.
 
C Subroutines and functions called:
C    INITSCEN, ADVSTEP, M3EXIT, WRITE3
C    science processes SCIPROC, PA_OUTPUT
 
C Revision History:
C    prototype 6/92 by CJC for proof-of-concept
C    Revised   2/93 by CJC for initial LCM Prototype Alpha
 
C    31 August, 1995 by M. Talat Odman at NCSC: special version for one 
C    single grid
 
C    16 April 1995 by M. Talat Odman at NCSC: write (or rewrite if restart)
C    initial conditions to the output file

C    Jeff
C    18 June 98 - put load of mechanism common here because of ping/ping_noop,
C    chem/chem_noop options

C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C    Jeff - Dec 00 - move CGRID_MAP into f90 module, re-order cols/rows in
C    call to PAR_INIT
C    Jeff - Jul 01 - enable integral average conc data
C    Sep 01  J. Young        Dyn Alloc - Use HGRD_DEFN

C    3 Sep 01 David wong
C      -- removed M3IO SHUT3 call which is done in PAR_TERM
C      -- removed SET_CTMFILE call

C   23 Jun 03 J.Young: for layer dependent advection tstep
C   18 Aug 03 J. Pleim - move vdiff before advection
C   07 Dec 04 J.Young: for layer dyn alloc - Use VGRD_DEFN
C   30 May 05 J.Young: mass-conserving advection (yamo)
C   20 Jan 06 J.Young: add circular buffer CGRID state file
C   24 May 06 J.Young: par_init/pio_init col/row order check
C    6 Sep 06 J.Young: one-write cgrid file; SGRID in module
C   27 May 09 J.Young: re-do parallel processing initialization
C   21 Jun 10 J.Young: convert for Namelist redesign
C   20 Jul 10 J.Young: re-do serial processing termination (eliminate par_noop)
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   24 Aug 11 D.Wong: eliminated data and geo orientation in se_init call
C    8 Jan 13 C.Nolte: fixed load AGRID bug if TSTEP(1) .ne. 010000 hhmmss
C   24 Sep 13 D.Wong:  Computed AGRID at the output mark of the model
C                      indicated in TSTEP(1) for twoway model
C   21 Apr 14 D.Wong:  Removed M3EXIT call in SHUT3 block
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   10 Aug 15 D.Wong:  Replaced MYPE with IO_PE_INCLUSIVE for parallel
C                      I/O implementation
C   10 Dec 15 D.Wong:  Moved the code which determines which processors are involved
C                      in I/O processing in front of routine PIO_RE_INIT and passed
C                      that information into PIO_RE_INIT
C   26 Jan 16 J.Young: Consolidate PIO_INIT, use keywords for optional arguments
C   28 Jan 16 D.Wong:  Add SAVE attribute to TSTEP for the two-way model implementation
C   16 Sep 16 J.Young: update for inline procan (IRR)
C   29 Nov 17 D. Wong: removed all SWAP routines and replaced with SE_COMM
C   29 Oct 18 L.Zhou, S.Napelenok: isam implementation
C   31 Jan 19 D. Wong: adopted the idea to process all twoway related environment
C                      variables in one place
C   01 Feb 19 D. Wong: made this as a subroutine rather than the main program to
C                      accommodate interface with global, regional and offlice mode,
C                      implemented centralized I/O approach, removed all MY_N clauses,
C                      with new re-structure of LUS_DEFN, most of the data declaration 
C                      has been moved to lus_data_module (model_data_module.f) and to
C                      call lus_setup to setup land use information according to land
C                      use scheme
C   02 Aug 19 F. Sidi: Restored serial processing option
C   03 AUG 19 D.Wong:  Modified code to work with two-way model
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C   21 Nov 19 S.L.Napelenok: Include DDM3D for versions 5.3.1
C-----------------------------------------------------------------------

      USE RXNS_DATA             ! chemical mechanism data
#ifdef mpas
      USE CGRID_SPCS            ! CGRID mechanism species
      USE HGRD_DEFN, ONLY: MYPE
      use coupler_module
      use VGRD_DEFN, ONLY : NLAYS
      use HGRD_DEFN, ONLY : NCOLS, NROWS

      use mydata_module
      use get_env_module
      use lus_defn
      USE AERO_DATA

      use mio_module
#else
      USE PCGRID_DEFN           ! inherits GRID_CONF
      USE CGRID_SPCS, Only: CGRID_SPCS_INIT  ! CGRID mechanism species
      USE STD_CONC              ! standard CONC
      USE AVG_CONC              ! integral average CONC
      USE WVEL_DEFN             ! derived vertical velocity component
      USE PA_DEFN, Only: LIPR, LIRR  ! Process Anaylsis control and data variables
      USE PAGRD_DEFN            ! Process Anaylsis horiz domain specs
      USE UTILIO_DEFN
      USE RUNTIME_VARS

      USE ASX_DATA_MOD, Only : MET_DATA, INIT_MET, GET_MET
      USE LSM_MOD, Only : INIT_LSM
      USE BIDI_MOD, Only : INIT_BIDI

#ifdef isam
c     USE SA_LAYERS
      USE SA_DEFN
      USE PISAM_DEFN            ! SA array definition (borrowed )
c     USE PMFRC_DEFN            ! MAPFRAC array definition ( adapted )
#endif

#ifdef sens
      USE DDM3D_DEFN
      USE S_PCGRID_DEFN
#endif

#ifdef parallel
      USE VERTEXT_MODULE
#endif

      USE CENTRALIZED_IO_MODULE
      USE lus_data_module

#ifdef twoway
      use twoway_data_module
      use sd_time_series_module
#endif

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_INIT_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_INIT_MODULE)
#endif
#endif   ! end mpas

      IMPLICIT NONE

      INTEGER, INTENT( IN )  :: MODEL_STDATE, MODEL_STTIME, MODEL_TSTEP
      INTEGER, INTENT( OUT ) :: MODEL_JDATE, MODEL_JTIME
      LOGICAL, INTENT( IN )  :: LAST_STEP
      INTEGER, INTENT( IN ), OPTIONAL :: COUPLE_TSTEP
      INTEGER, INTENT( IN ), OPTIONAL :: NCOLS_IN, NLAYS_IN

#ifdef mpas
      real, parameter :: cmin = 1.0E-30

      integer :: ncols_gl
#endif

C Include Files:
      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

#ifdef parallel
!     INCLUDE SUBST_MPI         ! MPI definitions and parameters
      INCLUDE 'mpif.h'
#endif

C Local variables:

      INTEGER, SAVE :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                  ! TSTEP(1) = local output step
                                  ! TSTEP(2) = sciproc sync. step (chem)
                                  ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                  !            step and wrf/cmaq call frequency

      INTEGER, ALLOCATABLE, SAVE :: ASTEP( : )
      INTEGER, SAVE :: NREPS    ! number of model time steps per output step
      INTEGER          ISTEP    ! current output time step number
      INTEGER          IREP     ! model step number within this output step
      INTEGER, SAVE :: JDATE    ! current model date, coded YYYYDDD
      INTEGER, SAVE :: JTIME    ! current model time, coded HHMMSS
      INTEGER          C, R, L, K, S, V     ! loop induction variables
      INTEGER          ALLOCSTAT
      INTEGER          NFILE, IFILE
      LOGICAL          EXST, OPD
      CHARACTER( 1000 ) :: CFILE
      CHARACTER(   16 ) :: ACT
      REAL( 8 )         :: CPU_TIME_START, CPU_TIME_FINISH
      REAL              :: REAL_TIME


      CHARACTER(  2 ) :: COLROW = 'CR'  ! col/row arg list order
      CHARACTER( 16 ) :: PNAME = 'DRIVER'
      CHARACTER( 96 ) :: XMSG = ' '

      REAL, SAVE, POINTER     :: CGRID( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: AGRID( :,:,:,: )
      REAL    DIVFAC      ! trapezoidal average factor

      LOGICAL, SAVE :: FIRST_RUN = .TRUE.  ! used for twoway model
      LOGICAL       :: WFLG                ! turn on write subdmap in pio_init

      INTEGER, SAVE :: myNREPS = 0
      INTEGER       :: STATUS

#ifdef mpas
      INTEGER       :: TIME2SEC, SEC2TIME

      integer :: io_mode

      INTEGER      SPC_STRT, SPC_FINI, J
      LOGICAL      LSTAT
      INTEGER      STAT                       ! Status reported by Aerosol Dist Checker

      INTEGER      LMODE    !Identifies the problematic mode from
                                !the BC Check routine
      REAL         AER_PAR( 2, N_MODE,5 )  !Modal parameter after the BC 
                                           !check (N, dg, sg)
                                           !      (N, M2, M3) -
                                           !      Before
                                           !      (N, M2, M3) -
                                           !      After
      REAL,ALLOCATABLE :: AECON( : )
      LOGICAL,SAVE :: NEW_START
#endif

      INTERFACE
         SUBROUTINE INITSCEN ( CGRID, TSTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( OUT )   :: TSTEP( 3 )
         END SUBROUTINE INITSCEN
#ifndef mpas
         SUBROUTINE ADVSTEP ( JDATE, JTIME, TSTEP, ASTEP, NREPS )
            INTEGER, INTENT( IN )    :: JDATE, JTIME
            INTEGER, INTENT( INOUT ) :: TSTEP( 3 )
            INTEGER, INTENT( OUT )   :: ASTEP( : )
            INTEGER, INTENT( OUT )   :: NREPS
         END SUBROUTINE ADVSTEP
         SUBROUTINE CKSUMMER ( PRNAME, CGRID, JDATE, JTIME )
            CHARACTER( * ), INTENT( IN ) :: PRNAME
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME
         END SUBROUTINE CKSUMMER
         SUBROUTINE PA_INIT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP( 3 )
         END SUBROUTINE PA_INIT
         SUBROUTINE WR_ACONC ( AGRID, JDATE, JTIME, TSTEP )
            REAL,    INTENT( IN )    :: AGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_ACONC
         SUBROUTINE WR_CGRID ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_CGRID
         SUBROUTINE PA_OUTPUT ( CGRID, JDATE, JTIME )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME
         END SUBROUTINE PA_OUTPUT
#ifdef isam
         SUBROUTINE WR_SA ( JDATE, JTIME, TSTEP, NSTEPS )
            IMPLICIT NONE
            INTEGER                  :: JDATE, JTIME, TSTEP( 3 )
            INTEGER                  :: NSTEPS
         END SUBROUTINE WR_SA
         SUBROUTINE WR_AVG_SA ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER                  :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_AVG_SA
         SUBROUTINE WR_SA_CGRID ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER                  :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_SA_CGRID
#endif
#ifdef sens
         SUBROUTINE WR_SENGRID ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_SENGRID
         SUBROUTINE WR_ASENS ( JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP
         END SUBROUTINE WR_ASENS
#endif
#endif

         SUBROUTINE SCIPROC ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( INOUT ) :: JDATE, JTIME
            INTEGER, INTENT( IN )    :: TSTEP( 3 ), ASTEP( : )
         END SUBROUTINE SCIPROC
#ifdef mpas
         SUBROUTINE UNLOAD_CGRID ( CGRID )
            REAL, INTENT(IN)  :: CGRID( :,:,:,: )
         END SUBROUTINE UNLOAD_CGRID
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRST_RUN ) THEN

         TSTEP = 0
         STDATE     = MODEL_STDATE
         STTIME     = MODEL_STTIME
#ifdef twoway
         TSTEP( 1 ) = LOCAL_TSTEP
         TSTEP( 3 ) = SEC2TIME(MODEL_TSTEP)
#else
         TSTEP( 1 ) = MODEL_TSTEP
#endif

         IF (PRESENT (COUPLE_TSTEP)) THEN
            TSTEP( 3 ) = SEC2TIME( COUPLE_TSTEP )
         END IF

         IF (PRESENT(NCOLS_IN)) THEN
            NCOLS = NCOLS_IN
            NROWS = 1
            NLAYS = NLAYS_IN
            TSTEP( 2 ) = SEC2TIME( COUPLE_TSTEP )
         END IF

#ifdef mpas
         call mpi_allreduce (ncols, ncols_gl, 1, mpi_int, mpi_sum, mpi_comm_world, status)

         call finit(NPROCS, 1, ncols_gl, nrows)

         ALLOCATE (CGRID ( NCOLS,NROWS,NLAYS,NSPCSD ), STAT = ALLOCSTAT )

#else
#ifdef twoway
C Initialize Environment Variables
         JDATE = 0
         JTIME = 0
         CALL INIT_ENV_VARS( JDATE, JTIME )
#endif

C Set up horizontal domain, calculate processor-to-subdomain maps
C and define vertical layer structure (in module GRID_CONF)
         IF ( .NOT. GRID_INIT ( NPROCS, MYPE ) ) THEN
            XMSG = '*** Failure defining domain configuration'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef verbose_driver
         write( logdev,* ) ' MYPE -> NPROCS:   ', mype, nprocs
         write( logdev,* ) ' MYPE -> NPCOL:    ', mype, npcol
         write( logdev,* ) ' MYPE -> NPROW:    ', mype, nprow
         write( logdev,* ) ' MYPE -> MY_NCOLS: ', mype, ncols
         write( logdev,* ) ' MYPE -> MY_NROWS: ', mype, nrows
         write( logdev,* ) ' MYPE -> GL_NCOLS: ', mype, gl_ncols
         write( logdev,* ) ' MYPE -> GL_NROWS: ', mype, gl_nrows
         write( logdev,* ) ' MYPE -> NLAYS:    ', mype, nlays
         write( logdev,* ) ' MYPE -> NBNDY:    ', mype, nbndy
#endif

C Set CGRID mechanism
         IF ( .NOT. CGRID_SPCS_INIT() ) THEN
            XMSG = 'Error in CGRID_SPCS:CGRID_SPCS_INIT'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, 1 )
         END IF

#ifdef verbose_driver
         write( logdev,* ) ' MYPE -> NSPCS:    ', mype, nspcsd
#endif

#ifdef parallel_io
         IF ( MOD( MYPE, NPCOL ) .EQ. 0 ) THEN
#else
         IF ( MYPE .EQ. 0 ) THEN
#endif
            IO_PE_INCLUSIVE = .TRUE.
         ELSE
            IO_PE_INCLUSIVE = .FALSE.
         END IF

#ifdef parallel
C Initialize PARIO
         IF ( .NOT. PIO_INIT( COLROW, GL_NCOLS, GL_NROWS, NLAYS, NTHIK,
     &                        NCOLS, NROWS, NPCOL, NPROW, NPROCS, MYPE,
     &                        wflg = WFLG, io_pe_inclusive = IO_PE_INCLUSIVE ) ) THEN
            XMSG = 'Failed to initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#endif
C Initialize stencil exchange
         CALL SUBST_SE_INIT( NPROCS, NPCOL, NPROW, GL_NCOLS, GL_NROWS, NLAYS,
     &                       NSPCSD, MYPE, MNDIS, MEDIS, MSDIS, MWDIS )


#ifdef verbose_driver
         write( logdev,* ) ' MYPE -> MNDIS:    ', mype, mndis
         write( logdev,* ) ' MYPE -> MEDIS:    ', mype, medis
         write( logdev,* ) ' MYPE -> MSDIS:    ', mype, msdis
         write( logdev,* ) ' MYPE -> MWDIS:    ', mype, mwdis
#endif

C Generate the process analysis data: load PA_DEFN module
         CALL PA_DATAGEN( )

C Set up horizontal domain and calculate processor-to-subdomain maps for
C process analysis, if required
         IF ( LIPR .OR. LIRR ) THEN
            IF ( .NOT. PAGRD_INIT( MYPE ) ) THEN
               XMSG = '*** Failure defining PA domain configuration'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         IF ( NSPCSD .GT. MXVARS3 ) THEN
            WRITE( XMSG,'(5X, A, I5, A)' ) 'The number of variables,', NSPCSD,
     &      ' to be written to the State CGRID File'
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            WRITE( XMSG,'(5X, A, I5)' ) 'exceeds the I/O-API limit:', MXVARS3
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            XMSG = 'Recompile with an I/O-API lib having a larger MXVARS3'
            CALL LOG_MESSAGE( LOGDEV, XMSG )
            CALL M3EXIT( PNAME, JDATE, JTIME, ' ', XSTAT1 )
         END IF

C Initialize PCGRID
         IF ( .NOT. PCGRID_INIT () ) THEN
            XMSG = 'Failure defining horizontal domain'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2  )
         END IF
      
         CGRID => PCGRID( 1:NCOLS,1:NROWS,:,: )   ! required for PinG

C Initalize CONC definitions (in STD_CONC F90 module)
         CALL CONC_DEFN ()

C Get avg CONC definitions, species and layer pointers (in AVG_CONC F90 module)
         CALL A_CONC_DEFN ()

C Miscellaneous Configuration Operations
         WRITE( LOGDEV, * )
         CALL LOG_HEADING( LOGDEV, "Configure Scenario" )

#ifdef isam
c        CALL GET_SA_LAYS ()
         CALL SA_DIM()

         N_SPCTAG = NSPC_SA * NTAG_SA

         CALL GET_SPC_INDEX ()

C Initialize PISAM
         IF ( .NOT. PISAM_INIT ( NSPC_SA, NTAG_SA ) ) THEN
            XMSG = 'Failure in defining SA horizontal domain'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2  )
         END IF
         ISAM => PISAM( 1:NCOLS,1:NROWS,:,:,: )

C Allocate arrays of species indices, tagging indices, and
C variable names for the combined species-tags
C i.e. set s_spctag, t_spctag, and vnam_spctag
         ALLOCATE ( S_SPCTAG( N_SPCTAG ) )
         ALLOCATE ( T_SPCTAG( N_SPCTAG ) )
         ALLOCATE ( VNAM_SPCTAG( N_SPCTAG ) )
         ALLOCATE ( BCON_SPC( N_SPCTAG ) )

C Assign BCON tag indicies used in advection
         BCON_SPC = .FALSE.
         BCON_SPC( ((BCONTAG - 1)*NSPC_SA+1) : (NSPC_SA*BCONTAG) ) = .TRUE.
#endif

C Initialize optional derived vertical velocity writes to conc file
         IF ( .NOT. WVEL_INIT () ) THEN
            XMSG = 'Failure initializing derived vertical velocity writes'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2  )
         END IF

#ifdef sens
C Initialize ddm3d calculations
         CALL INIT_DDM3D

         IF ( .NOT. S_PCGRID_IN( NPMAX ) ) THEN
            XMSG = 'Failure defining horizontal sens domain'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2  )
         END IF

         SENGRID => S_PCGRID(1:NCOLS,1:NROWS,:,:,:)
         SENGRID_TEMP => S_PCGRID_TEMP(1:NCOLS,1:NROWS,:,:)

         ALLOCATE ( SAGRID( NCOLS,NROWS,A_NLYS,NPMAX,N_ASPCS ), STAT = STATUS)
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'SAGRID memory allocation failed'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF

         SAGRID = 0.0
#endif


#endif

         call centralized_io_init

C Initialize conc field: Copy IC's to CONC file as step 0
C Convention: the input file concentration units are always ppmV.
         CALL INITSCEN ( CGRID, TSTEP )
         JDATE = STDATE; JTIME = STTIME

#ifdef sens
         STARTDATE = STDATE   ! save variable into DDM3D module
#endif

#ifndef mpas
         CALL CKSUMMER ( 'INITSCEN', CGRID, JDATE, JTIME )

         IF ( LIPR .OR. LIRR ) CALL PA_INIT ( CGRID, JDATE, JTIME, TSTEP )

C Verify input file header consistency and run duration
         CALL FLCHECK ( JDATE, JTIME, TSTEP( 1 ) )

         ALLOCATE ( AGRID( NCOLS,NROWS,A_NLYS,N_ASPCS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'AGRID memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( ASTEP( NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'ASTEP memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( AISAM( NCOLS,NROWS,NLAYS,NSPC_SA,NTAG_SA ),STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'AISAM memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         AISAM = 0.
#endif



#ifdef twoway
         IF ( SD_TIME_SERIES ) THEN
            CALL SD_TIME_SERIES_INIT ( LOGDEV, TSTEP( 3 ) )
            CALL OUTPUT_SD_TIME_SERIES ( CGRID, JDATE, JTIME )
         END IF

         IF ( CMAQ_WRF_FEEDBACK ) THEN
            CALL FEEDBACK_SETUP ( JDATE, JTIME, TSTEP( 3 ) )
         END IF
#endif
#else
        if (.not. lus_init (mminlu_mpas, lufrac_data(:,:,1)) ) then
           CALL M3EXIT( 'DRIVER',JDATE,JTIME,'ERROR: Cannot initialize Land Use Category', 2)
        end if

        if (ncd_64bit_offset) then
            io_mode = ior (nf90_noclobber, nf90_64bit_offset)
         else
            io_mode = nf90_noclobber
         end if

        call setfile (EMIS_1)

        if (pmdiag) then
           call fcreate (CTM_PMDIAG_1, io_mode)
        end if

        call fcreate (CTM_DRY_DEP_1, io_mode)
        call fcreate (CTM_WET_DEP_1, io_mode)

        if ( depv_diag ) then
            call fcreate (CTM_DEPV_DIAG, io_mode)
        end if

        if ( cld_diag ) then
            call fcreate (CTM_WET_DEP_2, io_mode)
        end if

        if (photdiag) then
           call fcreate (CTM_RJ_1, io_mode)
           call fcreate (CTM_RJ_2, io_mode)
        end if

#endif

C Initialize Meteorology Structures
         CALL INIT_LSM( JDATE, JTIME )
         CALL INIT_BIDI( )
         CALL INIT_MET( JDATE, JTIME )
         CALL GET_MET ( JDATE, JTIME, 0 )
         IF ( W_VEL ) CALL GET_WVEL( JDATE, JTIME ) ! If the user wants vertical velocity written to file, retrieve it.

         FIRST_RUN = .FALSE.

C Main processing loop:
         IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )
         IF ( MYPE. EQ. 0 ) CALL LOG_HEADING( OUTDEV, "Time Integration" )

      END IF ! first_run

      MODEL_JDATE = JDATE
      MODEL_JTIME = JTIME

#ifdef mpas

      mpas_cmaq_last_step = LAST_STEP

      v = size(cmaq_species, 4)

      DO L = 1, NLAYS
         DO C = 1, NCOLS
            CGRID( C,1,L,1:V ) = cmaq_species( c,1,l,1:v )
         END DO
      END DO

      ! If this run is not a restart, then check the initial conditions
      ! to make sure they are physically realistic. Check Aerosol Size 
      ! Distributions and Warn the User if They Are Not Robust.
      call get_env (NEW_START, 'NEW_START', .false.)
      IF ( NEW_START ) THEN
         ALLOCATE( AECON( N_AE_SPC ) )
         SPC_STRT = AE_STRT
         SPC_FINI = AE_STRT + N_AE_SPC - 1
         LSTAT    = .FALSE.
         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  AECON( 1:N_AE_SPC ) = CGRID( C,R,L,SPC_STRT:SPC_FINI )
                  CALL CHECK_AERO_ICBC( AECON, .TRUE., STAT, AER_PAR,
                  CLMODE )
                  CGRID( C,R,L,SPC_STRT:SPC_FINI ) = AECON( 1:N_AE_SPC )
                  IF ( STAT .GT. 0 ) THEN
                     LSTAT = .TRUE.
                  ENDIF
               END DO
            END DO
         END DO
    
         !Print warning if any aerosol ICs violated the size
         !distribution parameters
         IF ( LSTAT ) THEN
            WRITE( XMSG, '(A,A)' ),
     &         'Applying fix to aerosol Initial Conditions for aerosol',
     &         ' modes.'
            print *, trim(xmsg)
         END IF
      END IF
 
      NREPS = 1
#else
C Get synchronization and advection time steps, TSTEP(2), ASTEP(L) and NREPS
      CALL ADVSTEP ( JDATE, JTIME, TSTEP, ASTEP, NREPS )

      IF ( MOD( TIME2SEC( JTIME ), TIME2SEC( TSTEP( 1 ) ) ) .EQ. 0 ) THEN
         DO V = 1, N_ASPCS
            S = AVG_CONC_MAP( V )
            AGRID( :,:,:,V ) = CGRID( :,:,ACONC_BLEV:ACONC_ELEV,S )
#ifdef sens
            DO NP = 1, NPMAX
               SAGRID( :,:,:,NP,V ) = SENGRID( :,:,ACONC_BLEV:ACONC_ELEV,NP,S )
            END DO
#endif if
         END DO
#ifdef isam
            DO ITAG = 1, NTAG_SA ! average isam
               DO V = 1, NSPC_SA
                  L = 0
                  DO K = AISAM_BLEV, AISAM_ELEV
                     L = L + 1
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           AISAM( C,R,L,V,ITAG ) = ISAM( C,R,K,V,ITAG )
                        END DO
                     END DO
                  END DO
               END DO
            END DO
#endif

         IF ( W_VEL )
     &      AVG_WVEL( :,:,: ) = WVEL( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_RH )
     &      AVG_RH( :,:,: ) = MET_DATA%RH( :,:,ACONC_BLEV:ACONC_ELEV)
         IF ( L_ACONC_TA )
     &      AVG_TA( :,:,: ) = MET_DATA%TA( :,:,ACONC_BLEV:ACONC_ELEV)
         IF ( L_ACONC_PRES )
     &      AVG_PRES( :,:,: ) = MET_DATA%PRES( :,:,ACONC_BLEV:ACONC_ELEV )
      END IF
#endif

C science process sequence:
         
      myNREPS = myNREPS + NREPS

      DO IREP = 1, NREPS

            CALL SCIPROC ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

#ifndef mpas
C Use trapezoidal rule to time-average data

         DO V = 1, N_ASPCS
            S = AVG_CONC_MAP( V )
            AGRID( :,:,:,V ) = AGRID( :,:,:,V )
     &            + 2.0 * CGRID( :,:,ACONC_BLEV:ACONC_ELEV,S )
#ifdef sens
            DO NP = 1, NPMAX
               SAGRID( :,:,:,NP,V ) = SAGRID( :,:,:,NP,V )
     &            + 2.0 * SENGRID( :,:,ACONC_BLEV:ACONC_ELEV,NP,S )
            END DO
#endif 
         END DO
         IF ( W_VEL )
     &      AVG_WVEL( :,:,: ) = AVG_WVEL + 2.0 * WVEL( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_RH )
     &      AVG_RH( :,:,: ) = AVG_RH + 2.0 * MET_DATA%RH( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_TA )
     &      AVG_TA( :,:,: ) = AVG_TA + 2.0 * MET_DATA%TA( :,:,ACONC_BLEV:ACONC_ELEV )
         IF ( L_ACONC_PRES )
     &      AVG_PRES( :,:,: ) = AVG_PRES + 2.0 * MET_DATA%PRES( :,:,ACONC_BLEV:ACONC_ELEV )

#ifdef isam
            ! average isam
            DO ITAG = 1, NTAG_SA
               DO V = 1, NSPC_SA
                  L = 0
                  DO K = AISAM_BLEV, AISAM_ELEV
                     L = L + 1
                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           AISAM( C,R,L,V,ITAG ) = AISAM( C,R,L,V,ITAG )
     &                                           + 2.0 * ISAM( C,R,K,V,ITAG )
                        END DO
                     END DO
                  END DO
               END DO
            END DO
#endif

#endif

      END DO

#ifndef mpas
      IF ( MOD( TIME2SEC( JTIME ), TIME2SEC( TSTEP( 1 ) ) ) .EQ. 0 ) THEN
         DIVFAC = 0.5 / FLOAT( myNREPS )
         myNREPS = 0

         DO V = 1, N_ASPCS
            S = AVG_CONC_MAP( V )
            AGRID( :,:,:,V ) = DIVFAC * ( AGRID( :,:,:,V )
     &           - CGRID( :,:,ACONC_BLEV:ACONC_ELEV,S ) )
#ifdef sens
            DO NP = 1, NPMAX
               SAGRID( :,:,:,NP,V ) = DIVFAC * ( SAGRID( :,:,:,NP,V )
     &           - SENGRID( :,:,ACONC_BLEV:ACONC_ELEV,NP,S ) )
            END DO
#endif
         END DO
         IF ( W_VEL )
     &         AVG_WVEL( :,:,: ) = DIVFAC * ( AVG_WVEL( :,:,: ) - WVEL( :,:,ACONC_BLEV:ACONC_ELEV ) )
         IF ( L_ACONC_RH )
     &         AVG_RH( :,:,: ) = DIVFAC * ( AVG_RH( :,:,: ) - MET_DATA%RH( :,:,ACONC_BLEV:ACONC_ELEV ) )
         IF ( L_ACONC_TA )
     &         AVG_TA( :,:,: ) = DIVFAC * ( AVG_TA - MET_DATA%TA( :,:,ACONC_BLEV:ACONC_ELEV ) )
         IF ( L_ACONC_PRES )
     &         AVG_PRES( :,:,: ) = DIVFAC * ( AVG_PRES - MET_DATA%PRES( :,:,ACONC_BLEV:ACONC_ELEV ) )

#ifdef isam
         DO ITAG = 1, NTAG_SA ! average isam
            DO V = 1, NSPC_SA
               L = 0
               DO K = AISAM_BLEV, AISAM_ELEV
                  L = L + 1
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        AISAM( C,R,L,V,ITAG ) = DIVFAC * ( AISAM(C,R,L,V,ITAG )
     &                                        -            ISAM( C,R,K,V,ITAG ) )
                     END DO
                  END DO
               END DO
            END DO
         END DO
#endif

      END IF

      DO V = 1, N_CSPCS
         S = CONC_MAP( V )
         SGRID( :,:,:,V ) = CGRID( :,:,CONC_BLEV:CONC_ELEV,S )
      END DO

C write conc fields

      IF ( MOD( TIME2SEC( JTIME ), TIME2SEC( TSTEP( 1 ) ) ) .EQ. 0 ) THEN
#ifdef parallel
         CPU_TIME_START =  MPI_WTIME()
#else
         CALL CPU_TIME( REAL_TIME )
         CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
         CALL WR_CONC ( JDATE, JTIME, TSTEP( 1 ) )
#ifdef parallel
         IF ( LVEXT ) CALL WR_VEXT ( CGRID, JDATE, JTIME, TSTEP( 1 ) )
#endif
         CALL WR_ACONC ( AGRID, JDATE, JTIME, TSTEP( 1 ) )
#ifdef isam
         CALL WR_SA     ( JDATE, JTIME, TSTEP, 1 )
         CALL WR_AVG_SA ( JDATE, JTIME, TSTEP( 1 ) )
#endif

#ifdef sens
         CALL WR_ASENS ( JDATE, JTIME, TSTEP( 1 ) )
#endif
         IF ( LIPR .OR. LIRR ) CALL PA_OUTPUT ( CGRID, JDATE, JTIME )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 3 )
      END IF

#ifdef twoway
      IF ( SD_TIME_SERIES ) THEN
         CALL OUTPUT_SD_TIME_SERIES ( CGRID, JDATE, JTIME )
      END IF
#endif

#else
      CALL UNLOAD_CGRID (CGRID)
#endif

      IF ( LAST_STEP ) THEN
#ifdef mpas
         call shutdown()
#else
C write CGRID state file for subsequent runs
         CALL WR_CGRID ( CGRID, JDATE, JTIME, TSTEP( 1 ) )
#ifdef isam
         CALL WR_SA_CGRID ( JDATE, JTIME, TSTEP( 1 ) )
#endif
#ifdef sens
         CALL WR_SENGRID ( JDATE, JTIME, TSTEP( 1 )  )
#endif

C Shut down IOAPI
         IF ( SHUT3() ) THEN
            WRITE( LOGDEV, * )
            CALL LOG_HEADING( LOGDEV, 'Program Completed Successfully' )
            WRITE( XMSG, '(A,A,A,I7,A,I6.6,A)' ) 'Date and time ',
     &             DT2STR( JDATE, JTIME ), ' (',JDATE,':',JTIME,')' 
            CALL LOG_MESSAGE( LOGDEV, XMSG ) 

            IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )
            IF ( MYPE .EQ. 0 ) CALL LOG_HEADING( OUTDEV, 'Program Completed Successfully' )
            IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
         ELSE
            CALL LOG_MESSAGE( LOGDEV, ' *** FATAL ERROR shutting down Models-3 I/O *** ' )
         END IF
#endif
      END IF

      END SUBROUTINE CMAQ_DRIVER

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      FUNCTION WRITE3_DISTR ( FNAME, VNAME, JDATE, JTIME, DIM1, DIM2, DATA )
     &                        RESULT ( SUCCESS )

C-----------------------------------------------------------------------
C Function: Use I/O-API's WRITE3 and avoid using PWRITE3 to write layer
C           fractions to processor unique fake-gridded files

C Note: This function must live in a file that has a ".f" extension!

C Revision History:
C     5 Dec 2007 J.Young: initial implementation
C    16 Feb 2011 S.Roselle: replaced I/O API include files with M3UTILIO
C-----------------------------------------------------------------------

      USE RUNTIME_VARS
      USE M3UTILIO

      IMPLICIT NONE

      CHARACTER( * ), INTENT( IN ) :: FNAME
      CHARACTER( * ), INTENT( IN ) :: VNAME
      INTEGER,        INTENT( IN ) :: JDATE, JTIME
      INTEGER,        INTENT( IN ) :: DIM1, DIM2
      REAL,           INTENT( IN ) :: DATA( DIM1,DIM2 )
      LOGICAL SUCCESS

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------

      SUCCESS = .TRUE.

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
      END If

      IF ( .NOT. WRITE3( FNAME, VNAME, JDATE, JTIME, DATA ) ) THEN
         XMSG = 'Error writing ' // 'to file "' // TRIM( FNAME ) // '."'
         WRITE( LOGDEV,* ) XMSG
         SUCCESS = .FALSE.
      END IF

      RETURN
      END FUNCTION WRITE3_DISTR

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/vdiff/acm2/matrix.F,v 1.5 2011/10/21 16:11:45 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE MATRIX1 ( KL, A, B, E, D, X )

C Rather than solving the ACM2 banded tridiagonal matrix using LU decomposition,
C it is much faster to split the solution into the ACM1 convective solver followed
C by the tridiagonal solver
C MATRIX1 is the ACM1 solver. When the PBL is convective, this solver is called
C followed by TRI. If not convective, only TRI is called.

C-- ACM1 Matrix is in this form (there is no subdiagonal:
C   B1 E2                     <- note E2 (flux from layer above), not E1
C   A2 B2 E3
C   A3    B3 E4
C   A4       B4 E5
C   A5          B5 E6
C   A6             B6

      USE VGRD_DEFN           ! vertical layer specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:
      INTEGER, SAVE :: N_SPC_DIFF    ! global diffusion species

C Arguments:
      INTEGER, INTENT( IN )  :: KL         ! CBL sigma height
      REAL,    INTENT( IN )  :: A( : )     ! matrix column one
      REAL,    INTENT( IN )  :: B( : )     ! diagonal
      REAL,    INTENT( IN )  :: E( : )     ! superdiagonal
      REAL,    INTENT( IN )  :: D( :,: )   ! R.H.S
      REAL,    INTENT( OUT ) :: X( :,: )   ! returned solution

C Locals:
      REAL, ALLOCATABLE, SAVE :: BETA( : )
      REAL  ALPHA, GAMA 

      INTEGER L, V, IOS

      CHARACTER( 120 ) :: XMSG = ' '
      LOGICAL :: FIRSTIME = .TRUE.

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         N_SPC_DIFF = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_DIFF
         ALLOCATE ( BETA( N_SPC_DIFF ), STAT = IOS )
         IF ( IOS .NE. 0 ) THEN
            XMSG = 'Failure allocating BETA'
            CALL M3EXIT( 'MATRIX', 0, 0, XMSG, XSTAT1 )
         END IF
      END IF   ! FIRSTIME

C-- ACM1 matrix solver

      DO V = 1, N_SPC_DIFF
         BETA( V ) = D( V,1 )
      END DO
      GAMA = B( 1 )
      ALPHA = 1.0

      DO L = 2, KL
         ALPHA = -ALPHA * E( L ) / B( L )
         DO V = 1, N_SPC_DIFF
            BETA( V ) = ALPHA * D( V,L ) + BETA( V )
         END DO
         GAMA = GAMA + ALPHA * A( L )
      END DO

      DO V = 1, N_SPC_DIFF
         X( V,1 )  = BETA( V ) / GAMA
         X( V,KL ) = ( D( V,KL ) - A( KL ) * X( V,1 ) ) / B( KL )
      END DO

C-- Back sub for Ux=y

      DO L = KL-1, 2, -1
         DO V = 1, N_SPC_DIFF
            X( V,L ) = ( D( V,L ) - A( L ) * X( V,1 ) - E( L+1 ) * X( V,L+1 ) ) / B( L )
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!....................................................................
!  The RUNTIME_VARS module contains file unit identifiers for the log files,
!  input files, and the values of all environment variables.
!
!  It also contains routines for reading environment variables, and
!  opening input files.
!
!  History:
!   07/19/18, D. Wong: removed some of the ifdef clause for twoway model
!                      and added new logical environment variables
!                      ncd_64bit_offset and cell_num for MPAS coupling scheme
!  31 Jan 2019  (David Wong)
!     -- removed all twoway related environment variables in this file
!  01 Feb 2019  (David Wong)
!     -- implemented invocation of GET_ENV call directly, removed unnecessay
!        interface block and unnecessary functions
!  02 May 2019  (David Wong)
!     -- set BIOGEMIS_SEASON = .FALSE. as the default value
!  13 May 2019  (David Wong)
!     -- setup environment variable ISAM_NEW_START
!  14 May 2019  (David Wong)
!     -- updated environment variable ISAM_NEW_START with default value 'Y'
!  15 May 2019  (David Wong)
!     -- included check for using marine gas emission or not
!  13 June 2019 (F. Sidi) 
!     -- Set the default for ERODE_AGLAND to FALSE. No longer supported feature
!        in CMAQv5.3
!  25 July 2019 (D. Wong) 
!     -- Included a logic to determine whether met data was created from 
!        WRF V4+ is used
!  01 Aug 2019 (D. Wong) 
!     -- Modified code to work with two-way model
!  07 Nov 2019 (D. Wong) 
!     -- Made RUNLEN environment variable avilable to two-way model as well
!  22 Nov 2019 (F. Sidi) 
!     -- Re-introduced master switch to overide emissions file date for
!        representative day files
!  10 Feb 2020 (D. Wong) 
!     -- Added new environmental variable, MET_TSTEP, to enable
!        running with temporally finer meteorology
!....................................................................

      MODULE RUNTIME_VARS

      use get_env_module

      IMPLICIT NONE

      SAVE

      PUBLIC

      INTEGER :: OUTDEV = 6   ! File Unit for Standard Output
      INTEGER :: LOGDEV = -1  ! File Unit for Ascii Log File
      INTEGER :: TOTPE  = 1   ! Number of Total Processors
      INTEGER :: NPROCS = 1   ! Number of Total Processors
      INTEGER :: MYPE   = -1  ! Processor Number
      CHARACTER( 3 ) :: CMYPE  = ""  ! Processor Number

      !-----------------------------------------------------------------------------------
      !>> Parameters for formatting output log files
      !-----------------------------------------------------------------------------------

      INTEGER, PARAMETER :: CTM_DIAG_LVL = 0
      
      INTEGER :: LOG_LINE_LENGTH = 80  ! Cut the log offs at this character if possible
      INTEGER :: LOG_MAJOR_TAB   = 5   ! Left tab for all text including headings
      INTEGER :: LOG_MINOR_TAB   = 2   ! Tab for indenting subsequent lines of text in
                                       ! a paragraph for instance.

      CHARACTER( 10 ) :: WEEKDAY( 7 ) = (/'Monday   ','Tuesday  ','Wednesday',
     &                        'Thursday ','Friday   ','Saturday ','Sunday   ' /)


! this is for MPAS
      LOGICAL :: ncd_64bit_offset = .FALSE.

      !-----------------------------------------------------------------------------------
      !>> Define Environment Variables for Controlling CMAQ Processes
      !-----------------------------------------------------------------------------------

      ! Met model version
      LOGICAL :: WRF_V4P         = .FALSE.  ! Indicator of whether WRF version is 4+ or not

      ! Convective scheme in met model
      LOGICAL :: CONVECTIVE_SCHEME = .TRUE.
      ! Flag for column model
      LOGICAL :: COLUMN_MODEL      = .FALSE.

      ! Grid and High-Level Model Parameters
      LOGICAL :: NEW_START       = .TRUE.   ! Start New Simulation. Not a Restart
      CHARACTER(1) :: ISAM_NEW_START = 'Y'  ! Start New Simulation. Not a Restart for ISAM
      CHARACTER(16) :: GRID_NAME = ''       ! grid name selected from GRIDDESC
      CHARACTER(16) :: PROGNAME  = 'DRIVER' ! Program name selected from GRIDDESC
      INTEGER :: RUNLEN          = 480000   ! Run Length
      INTEGER :: STDATE          = 1995192  ! Start Date
      INTEGER :: STTIME          = 000000   ! Start Time
      INTEGER :: LOCAL_TSTEP     = 010000   ! set to TSTEP( 1 ) in initscen.F
      INTEGER :: MET_TSTEP                  ! set meterology input temporal frequency
      INTEGER :: NPCOL           = 1        ! no. of processors across grid columns
      INTEGER :: NPROW           = 1        ! no. of processors across grid rows
      INTEGER :: MAXSYNC         = 720      ! force max TSTEP(2) (sec)
      INTEGER :: MINSYNC         = 60       ! force min TSTEP(2) (sec)

      INTEGER, PARAMETER :: MAXLEN_CCTM_APPL     = 200    ! Length of Logfile Names
      CHARACTER( MAXLEN_CCTM_APPL ) :: APPL_NAME = 'APPL' ! Logfile Names
      CHARACTER( MAXLEN_CCTM_APPL ) :: BLDFOLD   = ''     ! Build Directory
      CHARACTER( MAXLEN_CCTM_APPL ) :: OUTDIR    = ''     ! Output Directory

      ! General; Multiprocess control, output and error checking
      LOGICAL :: PRINT_PROC_TIME = .FALSE. ! Flag to print elapsed time for all 
                                           ! science submodules
      LOGICAL :: FL_ERR_STOP=.TRUE.  ! Flag to stop run if errors are found.
      LOGICAL :: CKSUM     = .TRUE.  ! flag for cksum on, default = [T]
      LOGICAL :: END_TIME  = .FALSE. ! Override default beginning ACON timestamp
      
      INTEGER :: N_ACONC_VARS = 0    ! Number of species saved to avg conc file
      INTEGER :: N_CONC_VARS  = 0    ! Number of species saved to conc file
      INTEGER :: ACONC_BLEV= 0       ! Beginning level saved to avg conc file
      INTEGER :: ACONC_ELEV= 0       ! Ending level saved to avg conc file
      INTEGER :: CONC_BLEV = 0       ! Beginning level saved to conc file
      INTEGER :: CONC_ELEV = 0       ! Ending level saved to conc file
      CHARACTER(  16 ) :: ACONC_FILE_SPCS( 900 ) = '' ! avg conc file species list
      CHARACTER(  16 ) :: CONC_FILE_SPCS(900 )   = '' ! conc file species list
      LOGICAL :: PWRTFLAG  = .TRUE.  ! Print confirmation of successful output 
                                           ! to logfile
      LOGICAL :: LVEXT = .FALSE.     ! Flag to perform vertical Extraction
      CHARACTER( 1000 ) :: VEXT_COORD_PATH = "" ! File Path for Lon-Lat Text file specifying 
                                                ! locations for vertical extraction
      
      CHARACTER(256) :: GC_NAMELIST = '' ! Gas Species Namelist
      CHARACTER(256) :: AE_NAMELIST = '' ! Aerosol Species Namelist
      CHARACTER(256) :: NR_NAMELIST = '' ! Nonreactive Species Namelist
      CHARACTER(256) :: TR_NAMELIST = '' ! Tracer Species Namelist
     
      ! Chemistry and Photolysis
      LOGICAL :: PHOTDIAG  = .FALSE. ! Flag for PHOTDIAG file
      INTEGER :: NLAYS_DIAG = 0      ! Number of Diagnostic Layers to write out for photolysis
      INTEGER :: NWAVE = 0           ! Number of Diagnostic Wavelengths
      CHARACTER(16) :: WAVE_ENV(100) ! Targeted wavelengths for diagnostic output
      LOGICAL :: CORE_SHELL= .FALSE. ! flag for using core-shell mixing model for aerosol optics
      LOGICAL :: MIE_CALC  = .FALSE. ! flag for using Mie Theory in aerosol optics calculation
      REAL    :: GEAR_ATOL = 1.0E-9  ! Absolute Tolerance for Gear Solver
      REAL    :: GEAR_RTOL = 1.0E-3  ! Relative Tolerance for Gear Solver
      REAL    :: GLBL_ATOL = 1.0E-7  ! Absolute Tolerance for Rosenbrock Solver
      REAL    :: GLBL_RTOL = 1.0E-3  ! Relative Tolerance for Rosenbrock Solver

      ! Aerosols
      LOGICAL :: AVISDIAG  = .FALSE. ! flag for PMDIAG and APMDIAG file [F], default
      LOGICAL :: ZERO_PCSOA= .FALSE. ! flag for Zeroing out pcSOA formation
      LOGICAL :: AOD       = .FALSE. ! flag for printing AOD file
      LOGICAL :: PMDIAG    = .FALSE. ! flag for Instantaneous PM Diagnostic file
      LOGICAL :: APMDIAG   = .FALSE. ! flag for Average PM Diagnostic file
      INTEGER :: APMDIAG_ZLO  = 0    ! PM Diagnostic File Lower Layer
      INTEGER :: APMDIAG_ZHI  = 0    ! PM Diagnostic File Upper Layer
      INTEGER :: N_APMDIAG_SPC= 0    ! PM Diagnostic File Number of Species
      CHARACTER(  16 ) :: APMDIAG_SPC( 200 ) = '' !PM Diagnostic File Species Names

      ! Cloud Parameters
      LOGICAL :: CLD_DIAG  = .FALSE. ! flag to output cloud diagnostic files

      ! Air-Surface Exchange
      LOGICAL :: ABFLUX    = .FALSE. ! flag for ammonia bi-directional flux with in-lining depv
      LOGICAL :: MOSAIC    = .FALSE. ! flag for mosaic - luc specific deposition - within in-lining depv
      LOGICAL :: SFC_HONO  = .FALSE. ! flag for HONO interaction with surfaces within in-lining depv
      LOGICAL :: FST       = .FALSE. ! flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
      LOGICAL :: PX_LSM    = .TRUE.  ! flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
      LOGICAL :: CLM_LSM   = .FALSE. ! flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
      LOGICAL :: NOAH_LSM  = .TRUE.  ! flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
      LOGICAL :: STAGE     = .FALSE. ! flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
      LOGICAL :: DEPV_DIAG = .FALSE. ! flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
      Logical :: HGBIDI    = .FALSE. ! flag for Hg bidirectional exchange
      Logical :: BIDI_FERT_NH3 = .TRUE. ! flag to remove fertilizer ammonia from Bidirectional emissions
      CHARACTER(16) :: DUST_LAND_SCHEME = "UNKNOWN" ! NLCD, USGS, etc
 

      ! Transport Processes
      LOGICAL :: VDIFFDIAG = .FALSE. ! flag for VDIFF diagnostic files
      REAL    :: SIGST     = 0.7     ! sigma_sync_top value
      REAL    :: HDIV_LIM  = 0.9     ! cutoff for max horizontal divergence step adj
      REAL    :: CFL       = 0.75    ! maximum Courant-Friedrichs-Lewy number allowed
      Logical :: MINKZ     = .TRUE.  ! flag for minimum Kz 
      LOGICAL :: W_VEL     = .FALSE. ! flag for vertical velocity 
      LOGICAL :: GRAV_SETL = .TRUE.  ! flag for aerosol gravitational setling


      ! Emissions Processes
      CHARACTER( MAXLEN_CCTM_APPL ) :: EMISSCTRL  = 'EMISSCTRL_NML' ! Emission Control Filename
      INTEGER :: EMLAYS_MX     = 0       ! Emission Layers
      INTEGER :: N_FILE_GR     = 0       ! Number of Gridded Emission Files
      INTEGER :: N_FILE_TR     = 0       ! NUmber of Tracer Emission Files
      LOGICAL :: EMISCHK       = .TRUE.  ! flag for checking that surrogate emissions 
                                               !   are present on emission files
      LOGICAL :: BIOGEMIS      = .FALSE. ! flag to in-line biogenic VOC emissions
      CHARACTER(16) :: SPPRO   = 'DEFAULT' ! requested speciation profile name
      LOGICAL :: BIOGEMIS_SEASON=.FALSE. ! use frost switch file
      LOGICAL :: ASSUME_SUMMER = .TRUE.  ! use summer normalized emissions
      LOGICAL :: BEMIS_DIAG    = .TRUE.  ! true: write diagnostic emiss file
      LOGICAL :: MGEMDIAG      = .FALSE. ! flag for MGEM diagnostic file
      LOGICAL :: OCEAN_CHEM    = .TRUE.  ! Flag for ocean halogen chemistry and sea spray aerosol emissions
      LOGICAL :: WB_DUST       = .FALSE. ! flag for On-Line Dust Emission Calculation
      LOGICAL :: ERODE_AGLAND  = .FALSE.  ! Account for Erodible Agricultural Land when 
                                               !   computing dust Emissions
      LOGICAL :: DUSTEM_DIAG   = .FALSE. ! flag for dustemis diagnostic file
      LOGICAL :: SSEMDIAG      = .FALSE. ! flag for SSEMIS diagnostic file
      LOGICAL :: LTNG_NO       = .FALSE. ! flag for online calculation of NO from lightning
      INTEGER :: LT_ASM_DT     = 0       ! Lightning Input Time Interval
      LOGICAL :: NLDNSTRIKE    = .FALSE. ! flag to use NLDN STRIKE directly 
      LOGICAL :: LTNGDIAG      = .FALSE. ! flag to turn on lightning NO diagnostics
      REAL    :: MOLSNCG       = 350.0   ! Lightning NO Production Rate
      REAL    :: MOLSNIC       = 350.0   ! Lightning NO Production Rate
      CHARACTER(250) :: LTNG_FNAME = 'InLine' ! Lightning NO Input Name

      INTEGER :: NPTGRPS       = 0       ! no. pt src input file groups
      LOGICAL :: PT3DDIAG      = .FALSE. ! Write point source 3d emis diagnostic file
      LOGICAL :: PT3DFRAC      = .FALSE. ! Write layer fractions diagnostic file, if true
      INTEGER :: PT_NSTEPS     = 1
      INTEGER :: PT_DATE       = 1995192 ! Julian start date (YYYYDDD)
      INTEGER :: PT_TIME       = 0       ! start time (HHMMSS)
      INTEGER :: IPVERT        = 0       ! Numerical flag for plume vertical spread method
      INTEGER :: REP_LAYR      = -1      ! Minimum layer for reporting srcs w/ high plumes
      CHARACTER( 6 ) :: EMISDIAG = 'FALSE' ! Default Assumption for
                                         !     Emissions Diagnostic File Output
      LOGICAL :: EMIS_SYM_DATE = .FALSE.  ! Overrider CMAQ not to check
                                          ! if the dates on the emissions file match that of 
                                          ! the interal model (representative day case)
      CHARACTER(  16 ), SAVE, ALLOCATABLE :: PLAY_BASE( : ) ! Use for Plume Rise Calculation

      LOGICAL :: USE_MARINE_GAS_EMISSION = .FALSE.

      ! Process Analysis
      LOGICAL :: PROCAN    = .FALSE. ! flag for process analysis
      INTEGER :: PA_BEGCOL = 0       ! Starting PA output
      INTEGER :: PA_ENDCOL = 0       ! ending column for PA output
      INTEGER :: PA_BEGROW = 0       ! Starting row for PA output
      INTEGER :: PA_ENDROW = 0       ! ending row for PA output
      INTEGER :: PA_BEGLEV = 0       ! Starting layer for PA output
      INTEGER :: PA_ENDLEV = 0       ! ending layer for PA output

      ! Sulfur tracking
      LOGICAL :: STM        = .FALSE. ! flag for sulfur tracking option
      LOGICAL :: ADJ_STMSPC = .TRUE.  ! flag for normalizing sulfur tracking species

      ! ISAM
      INTEGER :: ISAM_BLEV = 0  ! Beginning level saved to conc file
      INTEGER :: ISAM_ELEV = 0  ! Ending level saved to conc file
      INTEGER :: SA_NLAYS = 0   ! Number of layers saved to conc file
      INTEGER :: AISAM_BLEV = 0 ! Beginning level saved to sa_aconc file
      INTEGER :: AISAM_ELEV = 0 ! Ending level saved to sa_aconc file
      INTEGER :: AVGSA_LAYS = 0 ! Number of layers saved to conc file

      CONTAINS
          
!.........................................................................
      SUBROUTINE INIT_ENV_VARS( JDATE, JTIME )

!  Defines and retrieves values for all environment variable input to 
!  CMAQ. 
!.........................................................................

      USE RXNS_DATA, ONLY : MECHNAME
      USE M3UTILIO

      IMPLICIT NONE                         

      INCLUDE SUBST_FILES_ID             ! file name parameters

#ifdef parallel      
      include 'mpif.h'
#endif
 
      INTEGER, INTENT( In )  :: JDATE       
      INTEGER, INTENT( In )  :: JTIME  
      CHARACTER(  16 )       :: V_LIST2( 20 )
      CHARACTER( 240 )       :: XMSG   = ''  
      INTEGER                :: NV


      INTEGER          :: STATUS      ! ENV... status
      CHARACTER( 250 ) :: STRTEMP
      CHARACTER( 80 )  :: PBASE     
      INTEGER, PARAMETER :: EXIT_STATUS = 1
      INTEGER          :: ERROR
      INTEGER          :: VARDEV = -1

      LOGICAL          :: FOUND
      INTEGER          :: LOC, STR_LEN
      CHARACTER(10)    :: WRF_VERSION

      CHARACTER( 16 ) :: PNAME = 'RUNTIME_VARS'

      !-------------------------------------------------------------------------------------------------------
      !>> Grid and High-Level Model Parameters
      !-------------------------------------------------------------------------------------------------------
#ifdef parallel
      CALL MPI_COMM_RANK ( MPI_COMM_WORLD, MYPE, ERROR )
      CALL MPI_COMM_SIZE ( MPI_COMM_WORLD, TOTPE, ERROR )
#else
      MYPE = 0
      TOTPE = 0
#endif
 
      IF ( MYPE .EQ. 0 ) VARDEV = OUTDEV

      ! Get Simulation Scenario Name to Label Log Files, etc
      CALL GET_ENV( APPL_NAME, 'CTM_APPL', APPL_NAME, VARDEV )
      
      ! Start I/O-API and set up log file(s)
      CALL SETUP_LOGDEV()
      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_HEADING( OUTDEV, "Environment Variable Report" )
         CALL LOG_SUBHEADING( OUTDEV, "Grid and High-Level Model Parameters" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

       ! Get Logfile Directory
      CALL GET_ENV ( BLDFOLD, 'BLD', BLDFOLD, VARDEV ) 
 
      ! Get Logfile Directory
      CALL GET_ENV ( OUTDIR, 'OUTDIR', OUTDIR, VARDEV ) 
 
      ! Determine if this run is a new start or a restart
      CALL GET_ENV ( NEW_START, 'NEW_START', NEW_START, VARDEV )
    
      ! Determine if this run is a new start or a restart
      CALL GET_ENV ( ISAM_NEW_START, 'ISAM_NEW_START', ISAM_NEW_START, VARDEV )
    
      ! Get Grid Name
      CALL GET_ENV ( STRTEMP, 'GRID_NAME', GRID_NAME, VARDEV )
      GRID_NAME = STRTEMP(1:16)

      ! Output Time Step
      CALL GET_ENV ( LOCAL_TSTEP, 'CTM_TSTEP', LOCAL_TSTEP, VARDEV )

      ! Run Duration
      CALL GET_ENV ( RUNLEN,  'CTM_RUNLEN', RUNLEN, VARDEV )
      
#ifndef twoway
      ! Main Program Name
      CALL GET_ENV ( STRTEMP, 'CTM_PROGNAME', PROGNAME, VARDEV )
      PROGNAME = STRTEMP( 1:16 )

      ! Starting Date
      CALL GET_ENV ( STDATE, 'CTM_STDATE', STDATE, VARDEV )

      ! Starting Time
      CALL GET_ENV ( STTIME, 'CTM_STTIME', STTIME, VARDEV )

      ! Retrieve the domain decomposition processor array
      IF ( NPROCS .GT. 1 ) THEN
         CALL GET_ENV ( 'NPCOL_NPROW', NV, V_LIST2, VARDEV )
         IF ( NV .NE. 2 ) THEN
            XMSG = 'Environment variable problem for NPCOL_NPROW'
     &           // ' using default 1X1'
            CALL M3WARN ( 'INIT_ENV_VARS', 0, 0, XMSG )
            NV = 2
            V_LIST2( 1 ) = '1'
            V_LIST2( 2 ) = '1'
         END IF
         READ( V_LIST2( 1 ), '( I4 )' ) NPCOL
         READ( V_LIST2( 2 ), '( I4 )' ) NPROW
      END IF
      
#endif
      
      ! MAXSYNC
      CALL GET_ENV ( MAXSYNC, 'CTM_MAXSYNC', MAXSYNC, VARDEV )

      ! MINSYNC
      CALL GET_ENV ( MINSYNC, 'CTM_MINSYNC', MINSYNC, VARDEV )


      !-------------------------------------------------------------------------------------------------------
      !>> General; Multiprocess control, output and error checking
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Multiprocess control, output and error checking" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! PRINT_PROC_TIME
      CALL GET_ENV ( PRINT_PROC_TIME, 'PRINT_PROC_TIME', PRINT_PROC_TIME, VARDEV )  

      ! FL_ERR_STOP
      CALL GET_ENV ( FL_ERR_STOP, 'FL_ERR_STOP', FL_ERR_STOP, VARDEV )  

      ! CKSUM
      CALL GET_ENV ( CKSUM, 'CTM_CKSUM', CKSUM, VARDEV )

      ! Override default beginning time timestamp for ACONC?
      CALL GET_ENV ( END_TIME, 'AVG_FILE_ENDTIME', END_TIME, VARDEV )
      
      ! ACONC File Species List
      CALL GET_ENV ( 'AVG_CONC_SPCS', N_ACONC_VARS, ACONC_FILE_SPCS, VARDEV )

      ! CONC File Species List 
      CALL GET_ENV ( 'CONC_SPCS', N_CONC_VARS, CONC_FILE_SPCS, VARDEV )
 
      ! ACONC Layer Specification
      CALL GET_ENV ( 'ACONC_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         ACONC_BLEV = 1
         ACONC_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:CONC_BLEV_ELEV
         ACONC_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) ACONC_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) ACONC_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) ACONC_ELEV
      ELSE 
         XMSG = 'Environment variable error for ACONC_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF
  
      ! CONC File Vertical Layer Range and Speciation
      CALL GET_ENV ( 'CONC_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         CONC_BLEV = 1
         CONC_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:CONC_BLEV_ELEV
         CONC_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) CONC_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) CONC_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) CONC_ELEV
      ELSE 
         XMSG = 'Environment variable error for CONC_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

#ifdef isam
      ! SA_ACONC Layer Specification
      CALL GET_ENV ( 'AISAM_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         AISAM_BLEV = 1
         AISAM_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:AISAM_BLEV_ELEV
         AISAM_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) AISAM_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) AISAM_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) AISAM_ELEV
      ELSE
         XMSG = 'Environment variable error for AISAM_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

      ! SA_CONC File Vertical Layer Range and Speciation
      CALL GET_ENV ( 'ISAM_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         ISAM_BLEV = 1
         ISAM_ELEV = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:ISAM_BLEV_ELEV
         ISAM_BLEV = 1
         READ( V_LIST2( 2 ), '( I4 )' ) ISAM_ELEV
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) ISAM_BLEV
         READ( V_LIST2( 2 ), '( I4 )' ) ISAM_ELEV
      ELSE
         XMSG = 'Environment variable error for ISAM_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF
#endif
      
      ! PWRTFLAG
      CALL GET_ENV ( PWRTFLAG, 'IOAPI_LOG_WRITE', PWRTFLAG, VARDEV )

      ! Get Flag for Vertical Extraction
      CALL GET_ENV ( LVEXT, 'VERTEXT', LVEXT, VARDEV )
#ifdef parallel
      ! Get Filepath for File Specifying Lon-Lat Coordinates for
      ! Vertical Extraction
      CALL GET_ENV ( VEXT_COORD_PATH, 'VERTEXT_COORD_PATH', VEXT_COORD_PATH, VARDEV )
#else
      IF( LVEXT ) THEN
          LVEXT = .FALSE.
          WRITE( OUTDEV,'(A)')'Option to extract a Vertical Column of Ouptut Data set to YES'
          WRITE( OUTDEV,'(A)')'However, the serial version cannot execute the option'
          WRITE( LOGDEV,'(A)')'Option to extract a Vertical Column of Ouptut Data set to YES'
          WRITE( LOGDEV,'(A)')'However, the serial version cannot execute the option'
      END IF
#endif

      ! Get Filename for Gas Species Namelist
      CALL GET_ENV ( GC_NAMELIST, 'gc_matrix_nml', GC_NAMELIST, VARDEV )

      ! Get Filename for Aerosol Species Namelist
      CALL GET_ENV ( AE_NAMELIST, 'ae_matrix_nml', AE_NAMELIST, VARDEV )

      ! Get Filename for Nonreactive Species Namelist
      CALL GET_ENV ( NR_NAMELIST, 'nr_matrix_nml', NR_NAMELIST, VARDEV )

      ! Get Filename for Tracer Species Namelist
      CALL GET_ENV ( TR_NAMELIST, 'tr_matrix_nml', TR_NAMELIST, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> Chemistry and Photolysis
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Chemistry and Photolysis" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Get photolysis rate diagnostic file flag
      CALL GET_ENV ( PHOTDIAG, 'CTM_PHOTDIAG', PHOTDIAG, VARDEV )

      IF( PHOTDIAG ) THEN
      ! Get desired number of layers for PHOTDIAG2 and PHOTDIAG3 files
         CALL GET_ENV ( NLAYS_DIAG, 'NLAYS_PHOTDIAG', NLAYS_DIAG, VARDEV )

      ! Get Desired Wavelengths for Diagnostic Output
        CALL GET_ENV( 'NWAVE_PHOTDIAG', NWAVE, WAVE_ENV, VARDEV )
      END IF  

      ! Get flag to use core-shell mixing model for aerosol optical properties
      CALL GET_ENV ( CORE_SHELL, 'CORE_SHELL_OPTICS', CORE_SHELL, VARDEV )

      ! Get flag to use fast optics for volume mixing model for aerosol optical properties
      CALL GET_ENV ( MIE_CALC, 'OPTICS_MIE_CALC', MIE_CALC, VARDEV )

      !Absolute Tolerance for SMVGEAR
      CALL GET_ENV ( GEAR_ATOL, 'GEAR_ATOL', GEAR_ATOL, VARDEV )
      
      !Relative Tolerance for SMVGEAR
      CALL GET_ENV ( GEAR_RTOL, 'GEAR_RTOL', GEAR_RTOL, VARDEV )
      
      ! Tolerances for Rosenbrock Solver
      CALL GET_ENV ( GLBL_RTOL, 'RB_RTOL', GLBL_RTOL, VARDEV )

      ! Absolute Tolerance for RB Solver
      CALL GET_ENV ( GLBL_ATOL, 'RB_ATOL', GLBL_ATOL, VARDEV )
 
      !-------------------------------------------------------------------------------------------------------
      !>> Aerosols
      !-------------------------------------------------------------------------------------------------------
      
      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Aerosols" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Get aerosol average diagnostic file flag.
      CALL GET_ENV ( AVISDIAG, 'CTM_AVISDIAG', AVISDIAG, VARDEV )

      ! Retrieve the Environment Variable allowing the User to Toggle
      ! the pcVOC emissions
      CALL GET_ENV ( ZERO_PCSOA, 'CTM_ZERO_PCSOA', ZERO_PCSOA, VARDEV )

      ! Get AOD diagnostic file flag.
      CALL GET_ENV ( AOD, 'CTM_AOD', AOD, VARDEV )

      ! Get flag for instantaneous PM diagnostic file.
      CALL GET_ENV ( PMDIAG, 'CTM_PMDIAG', PMDIAG, VARDEV )

      ! Get flag for average PM diagnostic file.
      CALL GET_ENV ( APMDIAG, 'CTM_APMDIAG', APMDIAG, VARDEV )

      ! APMDIAG Layer Specification 
      CALL GET_ENV ( 'APMDIAG_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   ! assume 1:NLAYS
         APMDIAG_ZLO = 1
         APMDIAG_ZHI = -1
      ELSE IF ( NV .EQ. 1 ) THEN ! Assume 1:CONC_BLEV_ELEV
         APMDIAG_ZLO = 1
         READ( V_LIST2( 2 ), '( I4 )' ) APMDIAG_ZHI
      ELSE IF ( NV .EQ. 2 ) THEN ! Correct Input
         READ( V_LIST2( 1 ), '( I4 )' ) APMDIAG_ZLO
         READ( V_LIST2( 2 ), '( I4 )' ) APMDIAG_ZHI
      ELSE 
         XMSG = 'Environment variable error for APMDIAG_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF
       
      ! APMDIAG File Species List 
      CALL GET_ENV ( 'AVG_PMDIAG_SPCS', N_APMDIAG_SPC, APMDIAG_SPC, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> sulfur tracking option
      !-------------------------------------------------------------------------------------------------------

      ! Flag for sulfur tracking option
      CALL GET_ENV ( STM, 'STM_SO4TRACK', STM, VARDEV )

      IF ( STM ) THEN
         ! Get sulfur tracking normalization flag
         CALL GET_ENV ( ADJ_STMSPC, 'STM_ADJSO4', ADJ_STMSPC, VARDEV )
      END IF      

      !-------------------------------------------------------------------------------------------------------
      !>> Cloud Parameters
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Cloud Processes" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! FLag for outputting cloud diagnostics
      CALL GET_ENV ( CLD_DIAG, 'CLD_DIAG', CLD_DIAG, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> Air-Surface Exchange Parameters
      !-------------------------------------------------------------------------------------------------------
 
      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Air-Surface Exchange Processes" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Check if using PX version of MCIP
      CALL GET_ENV ( PX_LSM, 'PX_VERSION', PX_LSM, VARDEV )

      ! Flag for Ammonia bi-directional flux with in-line deposition 
      ! velocities calculation
      CALL GET_ENV ( ABFLUX, 'CTM_ABFLUX', ABFLUX, VARDEV )

      ! Flag for Mosaic method to get land-use specific deposition velocities
      CALL GET_ENV ( MOSAIC, 'CTM_MOSAIC', MOSAIC, VARDEV )

      ! Flag for HONO interaction with leaf and building surfaces
      CALL GET_ENV ( SFC_HONO, 'CTM_SFC_HONO', SFC_HONO, VARDEV )
         
      ! Mosaic method to get land-use specific stomatal flux
      IF ( MOSAIC ) THEN
         CALL GET_ENV ( FST, 'CTM_FST', FST, VARDEV )
      END IF

      ! Flag CLM LSM
      CALL GET_ENV ( CLM_LSM, 'CLM_VERSION', CLM_LSM, VARDEV )

      ! Flag for NOAH LSM
      CALL GET_ENV ( NOAH_LSM, 'NOAH_VERSION', NOAH_LSM, VARDEV )

      ! Flag for Surface Tiled Aerosol and Gaseous Exchange (STAGE) model
      CALL GET_ENV ( STAGE, 'CTM_STAGE', STAGE, VARDEV )

      ! CTM_DEPV_FILE
      CALL GET_ENV ( DEPV_DIAG, 'CTM_DEPV_FILE', DEPV_DIAG, VARDEV )

      ! CTM_HGBIDI
      CALL GET_ENV ( HGBIDI, 'CTM_HGBIDI', HGBIDI, VARDEV )
 
      ! CTM_IGNORE_FERT_NH3
      CALL GET_ENV ( BIDI_FERT_NH3, 'CTM_BIDI_FERT_NH3', BIDI_FERT_NH3, VARDEV )
 
      ! Flag for using BELD Land Use for WindBlown Dust 
      CALL GET_ENV ( STRTEMP, 'CTM_WBDUST_BELD', DUST_LAND_SCHEME, VARDEV )
      DUST_LAND_SCHEME = STRTEMP( 1:16)
 
      !-------------------------------------------------------------------------------------------------------
      !>> Transport Processes
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Transport Processes" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! CTM_VDIFF_DIAG_FILE
      CALL GET_ENV ( VDIFFDIAG, 'CTM_VDIFF_DIAG_FILE', VDIFFDIAG, VARDEV )

      ! Get Minimum Layer for Advection Time Step Adjustment
      CALL GET_ENV ( SIGST, 'SIGMA_SYNC_TOP', SIGST, VARDEV )

      ! Get Maximum Horizontal Div Limit for Advection Adjustment
      CALL GET_ENV ( HDIV_LIM, 'ADV_HDIV_LIM', HDIV_LIM, VARDEV )

      ! CFL Criteria
      CALL GET_ENV ( CFL, 'CTM_ADV_CFL', CFL, VARDEV )

      ! CTM_KZMIN
      CALL GET_ENV ( MINKZ, 'KZMIN', MINKZ, VARDEV )

      ! CTM_WVEL
      CALL GET_ENV ( W_VEL, 'CTM_WVEL', W_VEL, VARDEV )

      ! CTM_GRAV_SETL
      CALL GET_ENV ( GRAV_SETL, 'CTM_GRAV_SETL', GRAV_SETL, VARDEV )

      !-------------------------------------------------------------------------------------------------------
      !>> Emission Environment Variables 
      !-------------------------------------------------------------------------------------------------------
      
      IF ( INDEX( MECHNAME, 'CB6R3M' ) .GT. 0 ) then
         USE_MARINE_GAS_EMISSION = .TRUE.
      END IF

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Emissions Parameters" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Get Name of Emission Control File
      CALL GET_ENV ( EMISSCTRL, 'EMISSCTRL_NML', EMISSCTRL, VARDEV )

      ! Number of Layers for Emissions
      CALL GET_ENV ( EMLAYS_MX, 'CTM_EMLAYS', EMLAYS_MX, VARDEV )

      ! Get number of different Gridded File Emissions Streams
      CALL GET_ENV ( N_FILE_GR, 'N_EMIS_GR', N_FILE_GR, VARDEV )
      
      ! Get number of different Gridded File Emissions Streams
      CALL GET_ENV ( N_FILE_TR, 'N_EMIS_TR', N_FILE_TR, VARDEV )

      ! Flag for checking emissions surrogates against species actually
      ! present on emissions files
      CALL GET_ENV (  EMISCHK, 'CTM_EMISCHK', EMISCHK, VARDEV )
 
      ! CTM_BIOGEMIS
      CALL GET_ENV ( BIOGEMIS, 'CTM_BIOGEMIS', BIOGEMIS, VARDEV )

      ! Get the speciation profile to use
      CALL GET_ENV ( SPPRO, 'BIOG_SPRO', SPPRO, VARDEV )
 
      ! Bioseason Switch Flag
      CALL GET_ENV ( BIOGEMIS_SEASON, 'BIOSW_YN', BIOGEMIS_SEASON, VARDEV )

      IF ( .NOT. BIOGEMIS_SEASON ) THEN
         ! Assume_Summer flag
         CALL GET_ENV ( ASSUME_SUMMER, 'SUMMER_YN', ASSUME_SUMMER, VARDEV )
      END IF

      ! Biogenic Emission Diag File
      CALL GET_ENV ( BEMIS_DIAG, 'B3GTS_DIAG', BEMIS_DIAG, VARDEV )
 
      ! Get marine gas emission diagnostic output file flag.
      CALL GET_ENV ( MGEMDIAG, 'CTM_MGEMDIAG', MGEMDIAG, VARDEV )
 
      ! Flag for ocean halogen chemistry and sea spray aerosol emissions
      CALL GET_ENV ( OCEAN_CHEM, 'CTM_OCEAN_CHEM', OCEAN_CHEM, VARDEV )

      ! Flag for Online Calculation of Windblown dust emissions
      CALL GET_ENV ( WB_DUST, 'CTM_WB_DUST', WB_DUST, VARDEV )

      ! Get env var for erodible agriculture land fraction
      !CALL GET_ENV ( ERODE_AGLAND, 'CTM_ERODE_AGLAND', ERODE_AGLAND, VARDEV )

      ! Get env var for diagnostic output
      CALL GET_ENV ( DUSTEM_DIAG, 'CTM_DUSTEM_DIAG', DUSTEM_DIAG, VARDEV )
       
      ! Get sea spray emission diagnostic output file flag.
      CALL GET_ENV ( SSEMDIAG, 'CTM_SSEMDIAG', SSEMDIAG, VARDEV )
 
      ! Set LTNG_NO to Y or T to turn on lightning NO production
      CALL GET_ENV ( LTNG_NO, 'CTM_LTNG_NO', LTNG_NO, VARDEV ) 

      ! Get Lightning Input Time Interval
      CALL GET_ENV ( LT_ASM_DT, 'LTNG_ASSIM_DT', LT_ASM_DT, VARDEV ) 

      ! Get Lightning NO File Name
      CALL GET_ENV ( LTNG_FNAME, 'LTNGNO', LTNG_FNAME, VARDEV )
 
      ! Flag for using NLDN data for Lightning Strikes
      CALL GET_ENV ( NLDNSTRIKE, 'USE_NLDN', NLDNSTRIKE, VARDEV )
 
      ! Flag for Outputing Lightning Diagnostic File
      CALL GET_ENV ( LTNGDIAG, 'LTNGDIAG', LTNGDIAG, VARDEV )
       
      ! Get Lightning NO Production Rate
      CALL GET_ENV ( MOLSNCG, 'MOLSNCG', 350.0, VARDEV )
      
      ! Get Lightning NO Production Rate
      CALL GET_ENV ( MOLSNIC, 'MOLSNIC', 350.0, VARDEV )
 
      ! get number of different file groups (sectors)
      CALL GET_ENV ( NPTGRPS, 'N_EMIS_PT', NPTGRPS, VARDEV )
      
      ! PT3DDIAG
!     CALL GET_ENV ( PT3DDIAG, 'PT3DDIAG', PT3DDIAG, VARDEV )

      ! PT3DFRAC
!     CALL GET_ENV ( PT3DFRAC, 'PT3DFRAC', PT3DFRAC, VARDEV )

      ! Point Source Time Steps
!     CALL GET_ENV ( PT_NSTEPS, 'LAYP_NSTEPS', PT_NSTEPS, VARDEV )

      ! Point Source Date
!     CALL GET_ENV ( PT_DATE, 'LAYP_STDATE', PT_DATE, VARDEV )

      ! Point Source Time
!     CALL GET_ENV ( PT_TIME, 'LAYP_STTIME', PT_TIME, VARDEV )

      ! IPVERT
      CALL GET_ENV ( IPVERT, 'IPVERT', IPVERT, VARDEV )

      ! REP_LAYR
!     CALL GET_ENV ( REP_LAYR, 'REP_LAYER_MIN', REP_LAYR, VARDEV )
 
!     ALLOCATE( PLAY_BASE( NPTGRPS ) )
!     PLAY_BASE( : ) = ''
!     DO NV = 1,NPTGRPS
!        WRITE( PBASE,'( "PLAY_BASE", "_", I2.2 )' ) NV
!        CALL GET_ENV ( STRTEMP, PBASE, PLAY_BASE( NV ), VARDEV )
!        PLAY_BASE( NV ) = STRTEMP
!     END DO
       
      ! Determine user-defined default for emissions diagnostics
      CALL GET_ENV ( EMISDIAG, 'EMISDIAG', EMISDIAG, VARDEV )

      ! Determine user-defined default for emissions date override for representative days
      CALL GET_ENV ( EMIS_SYM_DATE, 'EMIS_SYM_DATE', EMIS_SYM_DATE, VARDEV )
 
      !-------------------------------------------------------------------------------------------------------
      !>> Process Analysis
      !-------------------------------------------------------------------------------------------------------

      IF ( MYPE .EQ. 0 ) THEN 
         CALL LOG_SUBHEADING( OUTDEV, "Process Analysis Parameters" )
         WRITE( OUTDEV, '(6x,A)' ),'--Env Variable-- | --Value--'
         WRITE( OUTDEV, '(6x,A)' ), REPEAT( '-',80 )
      END IF

      ! Flag for Using Process Analysis
      CALL GET_ENV ( PROCAN, 'CTM_PROCAN', PROCAN, VARDEV )
       
      ! Get the Beginning and Ending Columns for Process Analysis
      CALL GET_ENV ( 'PA_BCOL_ECOL', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   
         PA_BEGCOL = 1; PA_ENDCOL = 0
      ELSE IF ( NV .EQ. 2 ) THEN
         READ( V_LIST2( 1 ), '( I4 )' ) PA_BEGCOL
         READ( V_LIST2( 2 ), '( I4 )' ) PA_ENDCOL
      ELSE 
         XMSG = 'Environment variable error for PA_BCOL_ECOL'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

      ! Get the Beginning and Ending Rows for Process Analysis
      CALL GET_ENV ( 'PA_BROW_EROW', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN   
         PA_BEGROW = 1; PA_ENDROW = 0
      ELSE IF ( NV .EQ. 2 ) THEN
         READ( V_LIST2( 1 ), '( I4 )' ) PA_BEGROW
         READ( V_LIST2( 2 ), '( I4 )' ) PA_ENDROW
      ELSE 
         XMSG = 'Environment variable error for PA_BROW_EROW'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

      ! Get the Beginning and Ending Layers for Process Analysis
      CALL GET_ENV ( 'PA_BLEV_ELEV', NV, V_LIST2, VARDEV )
      IF ( NV .LE. 0 ) THEN  
         PA_BEGLEV = 1; PA_ENDLEV = 0
      ELSE IF ( NV .EQ. 2 ) THEN
         READ( V_LIST2( 1 ), '( I4 )' ) PA_BEGLEV
         READ( V_LIST2( 2 ), '( I4 )' ) PA_ENDLEV
      ELSE 
         XMSG = 'Environment variable error for PA_BLEV_ELEV'
         CALL M3EXIT( 'INIT_ENV_VARS', JDATE, JTIME, XMSG, EXIT_STATUS )
      END IF

! for MPAS
#ifdef mpas
      call get_env (ncd_64bit_offset, 'ncd_64bit_offset', .false., vardev)
      call get_env( cell_num, 'cell_num', 1, vardev)
#endif

#ifdef twoway
      WRF_V4P = .TRUE.
#else
! to obtain WRF version information
      IF ( .NOT. OPEN3( MET_CRO_3D, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open '// MET_CRO_3D // ' file'
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      IF ( .NOT. DESC3( MET_CRO_3D ) ) THEN
         XMSG = 'Could not get ' // MET_CRO_3D //' file description'
         CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      ! Get environ. variable met_tstep to control meteorology frequency
      CALL GET_ENV ( MET_TSTEP, 'MET_TSTEP', TSTEP3D, VARDEV)

      ! Ensure users cannot pick a met_tstep that is not smaller than the
      ! file time step and something that is not a multiple of that tstep
          
      IF (MOD(TIME2SEC(MET_TSTEP), TIME2SEC(TSTEP3D)) .NE. 0) then
          XMSG = 'MET_TSTEP environmental variable not equal to or a 
     & multiple greater than time step of met file ' // MET_CRO_3D
          CALL M3EXIT(PNAME, 0, 0, XMSG, XSTAT1)
      end if 

      FOUND = .FALSE.
      NV = 0
      Do WHILE ((.NOT. FOUND) .AND. (NV .LT. MXDESC3))
         NV = NV + 1
         LOC = INDEX (FDESC3D(NV), 'WRF ARW V')
         IF (LOC > 0) THEN
            FOUND = .TRUE.
            STR_LEN = LEN_TRIM(FDESC3D(NV))
            READ (FDESC3D(NV)(LOC+9:STR_LEN), *) WRF_VERSION
            IF (WRF_VERSION .GE. '4.1') THEN
               WRF_V4P = .TRUE.
            END IF
         END IF
      END DO

      XMSG = 'MET data determined based on WRF ARW version '
      IF( MYPE .EQ. 0 ) THEN
          WRITE(OUTDEV,'(/,5X,2(A,1X),/)')TRIM( XMSG ), TRIM( FDESC3D(NV)(LOC+9:STR_LEN) )
          WRITE(LOGDEV,'(/,5X,2(A,1X),/)')TRIM( XMSG ), TRIM( FDESC3D(NV)(LOC+9:STR_LEN) )
      ELSE
          WRITE(LOGDEV,'(/,5X,2(A,1X),/)')TRIM( XMSG ), TRIM( FDESC3D(NV)(LOC+9:STR_LEN) )
      END IF

      IF ( .NOT. CLOSE3( MET_CRO_3D ) ) THEN
        XMSG = 'Could not close ' // MET_CRO_3D
        CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF
#endif

      END SUBROUTINE INIT_ENV_VARS

!.........................................................................
      SUBROUTINE LOG_HEADING( FUNIT, CHEAD_IN )

!  Formats and writes a user-supplied heading to a specific log file.
!  This approach is intended to standardize the log files that are
!  created by CMAQ. The length of the input array is set at 80 because
!  we would like to try limiting lines to 80 characters and a heading
!  should probably just be one line.
!.........................................................................

      IMPLICIT NONE

      INTEGER, INTENT( IN )           :: FUNIT
      CHARACTER( * ), INTENT( IN )    :: CHEAD_IN
      CHARACTER( len=: ), ALLOCATABLE :: CHEAD
      CHARACTER( 20 )                 :: FMT
      CHARACTER( 20 )                 :: FMT2
      INTEGER                         :: LDASH

      ! Capitalize the heading
      CHEAD = CHEAD_IN
      CALL UPCASE( CHEAD )

      ! Write the heading to the log file
      WRITE( FUNIT, * )
      WRITE( FMT, '("(", I0, "x,A,A,A)")' ) LOG_MAJOR_TAB
      WRITE( FMT2,'("(", I0, "x,A,)")' ) LOG_MAJOR_TAB

      LDASH = 2*8 + LEN_TRIM( CHEAD )
      WRITE( FUNIT, FMT2 ), REPEAT( '=', LDASH )
      WRITE( FUNIT, FMT ),
     &       '|>---   ',TRIM( CHEAD ),'   ---<|'
      WRITE( FUNIT, FMT2 ), REPEAT( '=', LDASH )

      END SUBROUTINE LOG_HEADING
      
!.........................................................................
      SUBROUTINE LOG_SUBHEADING( FUNIT, CHEAD )

!  Formats and writes a user-supplied sub-heading to a specific log file.
!  This approach is intended to standardize the log files that are
!  created by CMAQ. The length of the input array is set at 80 because
!  we would like to try limiting lines to 80 characters and a sub-heading
!  should probably just be one line.
!.........................................................................

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: FUNIT
      CHARACTER( * ), INTENT( IN ) :: CHEAD
      CHARACTER( 20 )       :: FMT
      INTEGER                         :: LDASH

      ! Write the sub-heading to the log file
      WRITE( FMT, '("(/,", I0, "x,A,A,A)")' ) LOG_MAJOR_TAB
      WRITE( FUNIT, FMT ),'|> ',TRIM( CHEAD ),':'
      LDASH = 2*3 - 1 + LEN_TRIM( CHEAD )

      WRITE( FMT, '("(", I0, "x,A,A)")' ) LOG_MAJOR_TAB
      WRITE( FUNIT, FMT ) '+',REPEAT( '=', LDASH )

      END SUBROUTINE LOG_SUBHEADING
      
!.........................................................................
      SUBROUTINE LOG_MESSAGE( FUNIT, CMSG_IN )

!  Formats and writes a user-supplied message to a specific log file.
!  This approach is intended to standardize the log files that are
!  created by CMAQ.
!.........................................................................

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: FUNIT
      CHARACTER( * ), INTENT( IN ) :: CMSG_IN
      CHARACTER( len=: ), ALLOCATABLE :: CMSG
      CHARACTER( 20 )       :: FMT

      CHARACTER( LOG_LINE_LENGTH ) :: CTEMP
      INTEGER :: MSG_SIZE
      INTEGER :: NLINE1, NLINE2, NLINE, NTAB, LAST_SPACE

      CMSG = CMSG_IN

      ! Write the message to the log file, while trimming to 80
      ! characters (while accounting for tab-length)
      NLINE1 = LOG_LINE_LENGTH - LOG_MAJOR_TAB
      NLINE2 = LOG_LINE_LENGTH - LOG_MAJOR_TAB - LOG_MINOR_TAB
      NLINE  = NLINE1
      NTAB   = LOG_MAJOR_TAB
      
      ! Determine Length of Total Message
      MSG_SIZE = LEN_TRIM( CMSG )
      
      DO WHILE ( MSG_SIZE .GT. LOG_LINE_LENGTH )
         ! Isolate One Line of Text
         LAST_SPACE = INDEX( CMSG( 1:NLINE+1 ), " ", BACK=.TRUE. )
     
         CTEMP = CMSG( 1:LAST_SPACE-1 )

         WRITE( FMT, '("(", I0, "x,A)")' ) NTAB
         WRITE( FUNIT, FMT ), CTEMP

         CMSG = CMSG( LAST_SPACE+1:LEN( CMSG ) )
         MSG_SIZE = LEN_TRIM( CMSG )

         IF ( NTAB .EQ. LOG_MAJOR_TAB ) NTAB = NTAB + LOG_MINOR_TAB
         IF ( NLINE.EQ. NLINE1 ) NLINE = NLINE2
      END DO

      ! Write Last Line
      WRITE( FMT, '("(", I0, "x,A)")' ) NTAB
      WRITE( FUNIT, FMT ), TRIM( CMSG )


      END SUBROUTINE LOG_MESSAGE

!.........................................................................
      SUBROUTINE TIMING_SPLIT( CPU_TIME_START, IMSG, CPROCIN )

!  This subroutine provides a split for the MPI timing functions and
!  then prints out a message for how much time has passed using a
!  character string input for customizing that message. 
!.........................................................................
 
      IMPLICIT NONE

#ifdef parallel
      INCLUDE 'mpif.h'
#endif
      REAL( 8 )        :: CPU_TIME_START
      REAL( 8 )        :: CPU_TIME_FINISH
      INTEGER          :: IMSG   ! What kind of checkpoint this is
                                 !  1 = 'PROCESS'
                                 !  2 = 'MASTER TIME STEP'
                                 !  3 = 'OUTPUT'
      CHARACTER( * ), INTENT(IN), OPTIONAL :: CPROCIN
      CHARACTER( len=: ), ALLOCATABLE :: CPROC
      CHARACTER( 250 ) :: XMSG

#ifndef parallel
      REAL :: REAL_TIME
#endif


      IF ( PRESENT( CPROCIN ) ) THEN
         CPROC = CPROCIN
      ELSE
         CPROC = ' '
      END IF
 
      ! Record Time at this Checkpoint
#ifdef parallel
      CPU_TIME_FINISH = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_FINISH = REAL( REAL_TIME,8 )
#endif


      ! Assemble the statement requested by the calling program
      SELECT CASE ( IMSG )
      CASE ( 1 )
          ! Write Out The Time to Complete Each Sub-Process
          WRITE( XMSG, 1002 ),TRIM( CPROC ), CPU_TIME_FINISH-CPU_TIME_START
1002      FORMAT ( 2x, A15, ' completed... ', F6.1, ' seconds' )

      CASE ( 2 ) 
          ! Write out the time to complete the entire master time step
          WRITE( XMSG, '(7x,A16)' ),'Master Time Step'
          CALL LOG_MESSAGE( LOGDEV, XMSG )
#ifndef twoway
          IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
#endif
          WRITE( XMSG, '(7x,A24,F6.1,A8)' ),'Processing completed... ',
     &                     (CPU_TIME_FINISH-CPU_TIME_START),' seconds'
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, * )

      CASE ( 3 ) 
          ! Write out the time to complete the output procedure
          WRITE( XMSG, '(1x,A32,F4.1,A)' ), '=--> Data Output completed...   ',
     &                     (CPU_TIME_FINISH-CPU_TIME_START),' seconds'
          CALL LOG_MESSAGE( LOGDEV, XMSG )
          WRITE( LOGDEV, * )
#ifndef twoway
          IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * )
#endif
 
      END SELECT 

      ! Write out the timing statement
#ifndef twoway
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
#endif
#ifdef parallel      
      CPU_TIME_START = MPI_WTIME()
#else
      CALL CPU_TIME( REAL_TIME )
      CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
      END SUBROUTINE TIMING_SPLIT    
 
      END MODULE RUNTIME_VARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/phot/phot_inline/opphot.F,v 1.3 2011/10/21 16:11:28 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPPHOT ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C
C  FUNCTION:  Opens the photolysis diagnostic files
C
C  PRECONDITIONS REQUIRED:
C     None
C
C  REVISION  HISTORY:
C       Date   Who          What
C     -------- ----------   -----------------------------------------
C     01/2008  S.Roselle    Adapted from OPDIAM in the aerosol module
C                           for opening the photolysis diagnostic files
C     03/2011  B.Hutzell    Generalized and modified to write out surface albedo
C     03/29/11 S.Roselle    Replaced I/O API include files with UTILIO_DEFN
C     09/30/14 B.Hutzell    Added several diagnostics based on changes to cloud
C                           and aerosol description in radiation transfer solution
C-----------------------------------------------------------------------

      USE GRID_CONF               ! horizontal & vertical domain specifications
      USE RXNS_DATA               ! chemical mechanism declarations and data
      USE UTILIO_DEFN
      USE PHOT_MET_DATA, ONLY:  USE_ACM_CLOUD ! Met and Grid data
      USE PHOT_MOD                            ! photolysis in-line routines and data

      IMPLICIT none

      INCLUDE SUBST_FILES_ID  ! file name parameters

C...Arguments

      INTEGER, INTENT( IN ) :: JDATE  ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP  ! output time step

C...Local variables

      CHARACTER( 16 ), SAVE :: PNAME = 'OPPHOT'
      CHARACTER( 16 )       :: LAMBDA
      CHARACTER( 96 )       :: XMSG = ' '

      INTEGER N, L, JWL, INCR     ! loop variables
C-----------------------------------------------------------------------

C...Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_RJ_1, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_RJ_1 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C...Set output file characteristics based on COORD.EXT and open
C...  the photolysis diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP

         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D =     1
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO

         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

C...CSA Variables, Units and Descriptions for RJ_FILE

         N = 1
         VNAME3D( N ) = 'COSZENS'
         UNITS3D( N ) = ''
         VDESC3D( N ) = 'Cosine of Solar Zenith Angle'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'OZONE_COLUMN'
         UNITS3D( N ) = 'DU'
         VDESC3D( N ) = 'Observed Total Ozone Column Density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'NO2_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted nitrogen dioxide column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'CO_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted carbon monoxide column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'SO2_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted sulfur dioxide column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'HCHO_COLUMN'
         UNITS3D( N ) = 'petamolec cm-2'
         VDESC3D( N ) = 'Predicted formaldehyde column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'TROPO_O3_COLUMN'
         UNITS3D( N ) = 'DU'
         VDESC3D( N ) = 'Predicted Tropospheric Ozone Column density'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'JNO2'
         UNITS3D( N ) = 'min-1'
         VDESC3D( N ) = 'Photodissociation rate of NO2'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'JO3O1D'
         UNITS3D( N ) = 'min-1'
         VDESC3D( N ) = 'Photodissociation rate of ozone producing O(1D)'
         VTYPE3D( N ) = M3REAL


         N = N + 1
         VNAME3D( N ) = 'RESOLVED_CFRAC'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'Resolved Cloud Fraction averaged over cloudy layers'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'RESOLVED_WBAR'
         UNITS3D( N ) = 'g m-3'
         VDESC3D( N ) = 'Resolved Cloud Hydrometeor Content averaged over cloudy layers'
         VTYPE3D( N ) = M3REAL
         
         IF( USE_ACM_CLOUD )THEN
             N = N + 1
             VNAME3D( N ) = 'SUBGRID_CFRAC'
             UNITS3D( N ) = '1'
             VDESC3D( N ) = 'Subgrid Cloud Fraction averaged over cloudy layers'
             VTYPE3D( N ) = M3REAL

             N = N + 1
             VNAME3D( N ) = 'SUBGRID_WBAR'
             UNITS3D( N ) = 'g m-3'
             VDESC3D( N ) = 'Subgrid Cloud Hydrometeor Content averaged over cloudy layers'
             VTYPE3D( N ) = M3REAL
         END IF             

         N = N + 1
         VNAME3D( N ) = 'TRANS_DIFFUSE'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band transmission coefficient for diffuse radiation at surface'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'TRANS_DIRECT'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band transmission coefficient for direct radiation at surface'
         VTYPE3D( N ) = M3REAL
 
         N = N + 1
         VNAME3D( N ) = 'REFLECTION'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band reflection coefficient at top of atmosphere'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'CLR_TRANS_DIF'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band diffuse transmission for clear sky at surface'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'CLR_TRANS_DIR'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band direct transmission for clear sky at surface'
         VTYPE3D( N ) = M3REAL
              
         N = N + 1
         VNAME3D( N ) = 'CLR_REFLECTION'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'broad band reflection for clear sky at top of atmosphere'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'TROPO_O3_EXCEED'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'Average Exceedance of modeled ozone column from max fraction of Total Column, '
     &               // ' a relative fraction from total column.'         
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'N_EXCEED_TROPO3'
         UNITS3D( N ) = ''
         VDESC3D( N ) = '# of times predicted tropospheric ozone column exceeds observed total column '
     &               // 'per file time step'          
         VTYPE3D( N ) = M3REAL


         DO JWL = 1, NWL

C...assumes that lamba in nanometers is on order of 100 or less

            WRITE( LAMBDA,'(I3.3)' ) INT( WAVELENGTH( JWL ) )

            N = N + 1
            VNAME3D( N ) = 'ETOT_SFC_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'W m-2'
            VDESC3D( N ) = 'Total Downward Irradiance at surface at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'AOD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Aerosol Optical Depth at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'TAU_CLOUD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Cloud Optical Depth at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
#ifdef phot_debug
            N = N + 1
            VNAME3D( N ) = 'SSA_CLOUD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = '1'
            VDESC3D( N ) = 'Column Averaged Cloud Single Scattering Albedo at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'ASY_CLOUD_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Column Averaged Cloud Asymmetry Factor at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
#endif
            N = N + 1
            VNAME3D( N ) = 'TAU_TOT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Total Optical Depth at'
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'TAUO3_TOP_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Optical Depth of O3 above model domain at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'ALBEDO_W' // TRIM( LAMBDA )
            UNITS3D( N ) = '1'
            VDESC3D( N ) = 'Surface Albedo at the wavelength at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

         ENDDO

         N = N + 1
         VNAME3D( N ) = 'AOD_W550_ANGST' 
         UNITS3D( N ) = ''
         VDESC3D( N ) = 'Aerosol Optical Depth at'
     &                // ' 550 nm based on an Angstrom Interpolation'
            VTYPE3D( N ) = M3REAL

         NVARS3D = N

         FDESC3D( 1 ) = 'Surface Values of Optical Inputs and Radiative Results '
         FDESC3D( 2 ) = 'from the In-line calculation of Photolysis Rates '
         FDESC3D( 3 ) = 'for the ' // TRIM( MECHNAME ) // ' photochemical mechanism '
         DO L = 4, MXDESC3
            FDESC3D( L ) = ' '
         END DO

!C...Write ascii table describing variables
!         WRITE(LOGDEV,'(A)')'*PHOTDIAG1 File Contents'
!         WRITE(LOGDEV,'(A)')'**Surface Values of Optical Inputs and Radiative '
!     &                   // 'Results from the In-line calculation of Photolysis Rates '
!         WRITE(LOGDEV,99950)
!         WRITE(LOGDEV,99951)
!         DO L = 1, NVARS3D
!            WRITE(LOGDEV,99952)TRIM(VNAME3D( L )),TRIM(UNITS3D( L )),TRIM(VDESC3D( L ))
!         END DO

C...Open the 1st photolysis diagnostic file

         IF ( .NOT. OPEN3( CTM_RJ_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_RJ_1 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF
    
C...Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_RJ_2, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_RJ_2 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG ( XMSG )

C...Set output file characteristics based on COORD.EXT and open
C...  the photolysis diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP

         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D = NLAYS_DIAG
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO

         FDESC3D( 1 ) = 'Three dimensional values of Photolysis rates '
         FDESC3D( 2 ) = 'used to make predictions for the ' // TRIM( MECHNAME )
         FDESC3D( 3 ) = 'photochemical mechanism from the In-line calculation.'
         FDESC3D( 4 ) = 'Data files can be found in CMAQ repository under subdirectory,'
         FDESC3D( 5 ) = 'UTIL/inline_phot_preproc/photolysis_CSQY_data'
         DO N = 6, MXDESC3
            FDESC3D( N ) = ' '
         END DO

C...load data from photolysis reaction list

         DO N = 1, NPHOTAB
            VNAME3D( N ) = PHOTAB( N )
            VTYPE3D( N ) = M3REAL
            UNITS3D( N ) = 'min-1'
            VDESC3D( N ) = 'Photolysis rates calculated based on data file; ' // VNAME3D(N)
         END DO

         NVARS3D = NPHOTAB
         
!C...Write ascii table describing variables
!         WRITE(LOGDEV,'(A)')'*PHOTDIAG2 File Contents'
!         WRITE(LOGDEV,'(A)')'**Three dimensionals values of Photolysis rates '
!     &                   // 'used to make predictions from the In-line calculation '
!     &                   // ' of Photolysis Rates '
!         WRITE(LOGDEV,99950)
!         WRITE(LOGDEV,99951)
!         DO L = 1, NVARS3D
!            WRITE(LOGDEV,99952)TRIM(VNAME3D( L )),TRIM(UNITS3D( L )),TRIM(VDESC3D( L ))
!         END DO

         IF ( .NOT. OPEN3( CTM_RJ_2, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_RJ_2 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF

C...Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_RJ_3, FSRDWR3, PNAME ) ) THEN

         XMSG = 'Could not open ' // CTM_RJ_3 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG ( XMSG )

C...Set output file characteristics based on COORD.EXT and open
C...  the photolysis diagnostic file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP

         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D = NLAYS_DIAG
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO

         FDESC3D( 1 ) = 'Three dimensionals values of Optical Inputs and Radiative'
         FDESC3D( 2 ) = 'Results from the In-line photolysis calculation using the'
         FDESC3D( 3 ) =  TRIM( MECHNAME ) // ' photochemical mechanism.'

         DO N = 4, MXDESC3
            FDESC3D( N ) = ' '
         END DO
         
         N = 0
         
         DO L = 1, N_DIAG_WVL

C...assumes that lamba in nanometers is on order of 100 or less

            JWL = DIAG_WVL( L )
            
            WRITE( LAMBDA,'(I3.3)' ) INT( WAVELENGTH( JWL ) )

            N = N + 1
            VNAME3D( N ) = 'AERO_SSA_W' // TRIM( LAMBDA )
            UNITS3D( N ) = '1'
            VDESC3D( N ) = 'Aerosol Single Scattering Albedo at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'AERO_ASYM_W' // TRIM( LAMBDA )
            UNITS3D( N ) = ''
            VDESC3D( N ) = 'Aerosol Asymmetry Factor at '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'EXT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Mm-1'
            VDESC3D( N ) = 'Total Extinction of layer for '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

            N = N + 1
            VNAME3D( N ) = 'GAS_EXT_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Mm-1' 
            VDESC3D( N ) = 'Total Extinction from Rayleigh scattering NO2 and O3 in layer for '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
 
            N = N + 1
            VNAME3D( N ) = 'EXT_AERO_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'Mm-1'
            VDESC3D( N ) = 'Aerosol Extinction in layer for '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL
            
            N = N + 1
            VNAME3D( N ) = 'ACTINIC_FX_W' // TRIM( LAMBDA )
            UNITS3D( N ) = 'W m-2'
            VDESC3D( N ) = 'Net Actinic Flux, '
     &                   // TRIM( LAMBDA ) // ' nm'
            VTYPE3D( N ) = M3REAL

        END DO
        
         N = N + 1
         VNAME3D( N ) = 'CFRAC_3D'
         UNITS3D( N ) = '1'
         VDESC3D( N ) = 'Resolved Cloud Fraction in grid cell'
         VTYPE3D( N ) = M3REAL

         N = N + 1
         VNAME3D( N ) = 'EXT_AERO_W550'
         UNITS3D( N ) = 'Mm-1'
         VDESC3D( N ) = ' Aerosol Extinction of layer for '
     &                // '550 nm based on an Angstrom Interpolation'
         VTYPE3D( N ) = M3REAL
        

        NVARS3D = N

!C...Write ascii table describing variables
!         WRITE(LOGDEV,'(A)')'*PHOTDIAG3 File Contents'
!         WRITE(LOGDEV,'(A)')'**Three dimensionals values of Optical Inputs and Radiative '
!     &                    // 'Results from the In-line photolysis calculation.'
!         WRITE(LOGDEV,99950)
!         WRITE(LOGDEV,99951)
!         DO L = 1, NVARS3D
!            WRITE(LOGDEV,99952)TRIM(VNAME3D( L )),TRIM(UNITS3D( L )),TRIM(VDESC3D( L ))
!         END DO

C...Open the 3rd photolysis diagnostic file

         IF ( .NOT. OPEN3( CTM_RJ_3, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_RJ_3 // ' file'
            CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF
99950    FORMAT('|Variable Name|Units|Description                                   |')         
99951    FORMAT('|:----|:----:|:---------------------------------------------|')
99952    FORMAT('|', A16, '|', A16, '|', A, '|')

      RETURN

      END SUBROUTINE OPPHOT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_INIT( CGRID, SDATE, STIME, TSTEP )
 
C-----------------------------------------------------------------------
 
C Function: Create the Process Analysis ouput files and initialize
C           Process Analysis arrays           
 
C Preconditions: None
 
C Key Subroutines/Functions Called: SUBST_PA_INDEX, SUBST_IRR_INDEX,
C                                   PA_MKHDR, SUBST_4D_DATA_COPY
 
C  Revision History:
C  Prototype created by Jerry Gipson, July, 1996
C  allow env var for file names Jeff, Dec, 1996
C  Changed CGOUT dimension parameter from NSPCSD to NSPCS -- Jerry Gipson, May, 1997.
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified June 1997 by Jerry Gipson to change CGOUT to CGRID       
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jun, 1998 by Jerry Gipson to add PA domain error check
C  Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C                      -- modify PA_INDEX function call parameter list
C                      -- add DATA_COPY function call to redistribute PA grid
C  Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C                         three .EXT files
C                      -- call SUBST_IRR_INDEX to determine row, column, and
C                         level loop indexes which are associated with IRR
C                         calculations
C                      -- renamed DATA_COPY function name
C                      -- use ifdef statement to distinguish parallel
C                         implementation of IRR calculation which does not 
C                         shift to the origin
C  Modified 4/12/00 by Jerry Gipson to correct units for aerosol IPRs writen to IO/API file
C  Modified 1 Jul 2000 by Jeff Young to allow for file updating - added PA_MKHDR
C  Modified 22 Nov 00 by J.Young: Dave Wong`s f90 stenex SUBGRID_INDEX and DATA_COPY
C  6 Oct 01 J.Young: dyn alloc - generic CGRID declaration; Use PAGRD_DEFN,
C                                which uses HGRD_DEFN; new pario
C  Modified 10 Oct 01 by David Wong
C                      -- let other processors open PA output files after
C                         processor has created them.
C                      -- used a new formula to compute number of IPR and IRR 
C                         output files
C  31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                                 domain specifications in one module (GRID_CONF)
C  16 Jan 06 J.Young: move PAGRD_INIT to par_init
C   1 Apr 09 J.Young: remove cruft
C   8 Jul 10 J.Young: restructure
C  23 Jul 10 D.Wong:  move first OPEN3 try inside IF ( MYPE .EQ. 0 ) clause
C  16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  11 May 11 D.Wong: incorporated twoway model implementation
C  16 Sep 16 J.Young: update for inline procan
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif
      USE PA_DEFN               ! Process Anaylsis control and data variables

      IMPLICIT NONE 

C..Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C..Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: SDATE      !  starting date, format YYYYDDD
      INTEGER, INTENT( IN ) :: STIME      !  starting time, format HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                             ! TSTEP(1) = local output step
                             ! TSTEP(2) = sciproc sync. step (chem)
                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                             !            step and wrf/cmaq call frequency

C..Parameters:

C..External Functions: None

C..Local Variables:
      CHARACTER(  16 ) :: ENV_DFLT  ! Environment variable default value
      CHARACTER(  80 ) :: ENV_DESC  ! Environment variab;e description
      CHARACTER(  16 ) :: OUTFNAME  ! Assigned IPR or IRR output file name
      CHARACTER(  16 ) :: PNAME = 'PA_INIT' ! Routine Name
      CHARACTER( 128 ) :: XMSG = ' '
      CHARACTER( 256 ) :: RET_VAL   ! Returned value of environment variable

      LOGICAL LSTOP     ! Flag to stop because a PA file not assigned
 
      INTEGER C         ! Loop index for columns
      INTEGER R         ! Loop index for rows
      INTEGER L         ! Loop index for layers
      INTEGER PC        ! Index for PA output column
      INTEGER PL        ! Index for PA output level
      INTEGER PR        ! Index for PA output row
      INTEGER ICG       ! Index for species in cgout array
      INTEGER NIRR      ! Loop index for IRR outputs
      INTEGER NFL       ! Loop index for no. of files
      INTEGER NOUT      ! Loop index for process monitoring outputs
      INTEGER NS        ! Loop index for number cgout concs saved
      INTEGER NUMFLS    ! Number of PA or IRR output files needed
      INTEGER STATUS    ! Status Code

C-----------------------------------------------------------------------

      LSTOP = .FALSE.         

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Open the Integrated Process Rates output file(s) if needed
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      IF ( LIPR ) THEN

C..compute the number of files needed

         NUMFLS = ( NIPRVAR - 1 ) / MXVARS3 + 1

C..open each one 
         DO NFL = 1, NUMFLS

            IF ( NFL .EQ. 1 ) THEN
               OUTFNAME = CTM_IPR_1
            ELSE IF ( NFL .EQ. 2 ) THEN
               OUTFNAME = CTM_IPR_2
            ELSE IF ( NFL .EQ. 3 ) THEN
               OUTFNAME = CTM_IPR_3
            ELSE IF ( NFL .GT. 3 ) THEN
               XMSG = 'Maximum number of IPR output files exceeded'
               CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
            END IF

            ENV_DESC = 'IPR Output file ' // OUTFNAME 
            ENV_DFLT = ' '       
            XMSG = 'IPR output file ' // TRIM( OUTFNAME ) // ' not assigned'
            CALL ENVSTR( OUTFNAME, ENV_DESC, ENV_DFLT, RET_VAL, STATUS)
            IF ( STATUS .NE. 0 ) CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )

            IF ( MYPE .EQ. 0 ) THEN

C..try to open existing file for update
               IF ( .NOT. OPEN3( OUTFNAME, FSRDWR3, PNAME ) ) THEN

                  XMSG = 'Could not open ' // TRIM( OUTFNAME )
     &                 // ' file for update - try to open new'
                  CALL M3MESG( XMSG )

                  CALL PA_MKHDR( 'IPR', NFL, OUTFNAME, SDATE, STIME, TSTEP )

                  IF ( OPEN3( OUTFNAME, FSNEW3, PNAME ) ) THEN   ! open new
                     XMSG = 'Opened Integrated Reaction Rate Output File: '
     &                    // OUTFNAME
                     CALL M3MESG( XMSG )
                  ELSE
                     XMSG = 'Could not open Integrated Process Rate Output File: ' 
     &                   // OUTFNAME
                     CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
                  END IF

               END IF

            END IF

            CALL SUBST_BARRIER

         END DO   ! NUMFLS

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Initialize arrays
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         DELC = 0.0

         DO NS = 1, NCSAVE
            ICG = SAV2GRD( NS )
#ifdef parallel
            CALL SUBST_DATA_COPY( CGRID, CSAV, ICG, NS )
#else
            CSAV( :,:,:,NS ) = CGRID( MY_BEGCOL:MY_ENDCOL,
     &            MY_BEGROW:MY_ENDROW,MY_BEGLEV:MY_ENDLEV,ICG )
#endif
         END DO

      END IF   ! LIPR

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Open the Integrated Reaction Rates output file(s) if needed
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      IF ( LIRR ) THEN

C..compute the number of files needed

         NUMFLS = ( NIRRVAR - 1 ) / MXVARS3 + 1

C..open each one
         DO NFL = 1, NUMFLS

            IF ( NFL .EQ. 1 ) THEN
               OUTFNAME = CTM_IRR_1
            ELSE IF ( NFL .EQ. 2 ) THEN
               OUTFNAME = CTM_IRR_2
            ELSE IF ( NFL .EQ. 3 ) THEN
               OUTFNAME = CTM_IRR_3
            ELSE IF ( NFL .GT. 3 ) THEN
               XMSG = 'Maximum number of IRR output files exceeded'
               CALL M3EXIT(PNAME, SDATE, STIME, XMSG, XSTAT2 )
            END IF

            ENV_DESC = 'IRR Output file ' // OUTFNAME 
            ENV_DFLT = ' '       
            CALL ENVSTR( OUTFNAME, ENV_DESC, ENV_DFLT, RET_VAL, STATUS )
            XMSG = 'IRR output file ' // TRIM( OUTFNAME ) // ' not assigned'
            IF ( STATUS .NE. 0 ) CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )

            IF ( MYPE .EQ. 0 ) THEN

C..try to open existing file for update
               IF ( .NOT. OPEN3( OUTFNAME, FSRDWR3, PNAME ) ) THEN

                  XMSG = 'Could not open ' // TRIM( OUTFNAME )
     &                 // ' file for update - try to open new'
                  CALL M3MESG( XMSG )

                  CALL PA_MKHDR( 'IRR', NFL, OUTFNAME, SDATE, STIME, TSTEP )

                  IF ( OPEN3( OUTFNAME, FSNEW3, PNAME ) ) THEN   ! open new
                     XMSG = 'Opened Integrated Reaction Rate Output File: '
     &                    // OUTFNAME
                     CALL M3MESG( XMSG )
                  ELSE
                     XMSG = 'Could not open Integrated Reaction Rate Output'
     &                    // ' File ' // OUTFNAME
                     CALL M3EXIT( PNAME, SDATE, STIME, XMSG, XSTAT1 )
                  END IF

               END IF

            END IF

            CALL SUBST_BARRIER

         END DO   ! NFL

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Initialize arrays
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

         IRROUT = 0.0

      END IF   !   LIRR

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STK_EMIS

C-----------------------------------------------------------------------
C Function: stack emissions by source from stack emissions file and
C           3d point source emissions

C Revision History:
C     16 Jan 2007 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     30 Apr 2016 J.Young: add multiple fire source capability, in affiliation with
C                          Yongtao Hu (Georgia Tech)
C-----------------------------------------------------------------------

      USE UDTYPES, ONLY: RARRY1, CARRY1
      USE EMIS_VARS

      IMPLICIT NONE

      INTEGER,        ALLOCATABLE, SAVE :: NSRC_EMIS( : )   ! no. of pt sources
      INTEGER,        ALLOCATABLE, SAVE :: NVARS_EMIS( : )  ! no. of species
      INTEGER, PARAMETER                :: NVARS_FIRE = 1   ! default

      LOGICAL,        ALLOCATABLE, SAVE :: FIREFLAG( : )    ! which is the fire file?

      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STKEMIS( : )   ! stack emissions [mol/s]
      TYPE( CARRY1 ), ALLOCATABLE, SAVE :: STKSPC( : )    ! emitted species names
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: FIREVAR( : )   ! fire variables, just H-Flux

      INTEGER FGRPS

      CONTAINS

C-----------------------------------------------------------------------

         FUNCTION STK_EMIS_INIT ( STKENAME, JDATE, JTIME ) RESULT ( SUCCESS )

         USE UTILIO_DEFN
         USE AERO_DATA, ONLY : MGPG, GPKG

         IMPLICIT NONE

         CHARACTER( 16 ), INTENT( IN ) :: STKENAME( : )  ! stack groups emis file names
         INTEGER, INTENT( IN )         :: JDATE, JTIME
         LOGICAL SUCCESS

         INTEGER I, J, N, NGRPS, LEN1, LEN2, ISRM, X

         INTEGER ASTAT
         CHARACTER( 96 ) :: XMSG = ' '
         CHARACTER( 16 ) :: PNAME = 'STK_EMIS_INIT'
         CHARACTER( 16 ) :: UNITSCK

         SUCCESS = .TRUE.

         NGRPS = SIZE( STKENAME )
         FGRPS = NGRPS

         ALLOCATE ( NSRC_EMIS( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'NSRC_EMIS', PNAME )

         ALLOCATE ( NVARS_EMIS( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'NVARS_EMIS', PNAME )

         ALLOCATE ( STKEMIS( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKEMIS', PNAME )

         ALLOCATE ( STKSPC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKSPC', PNAME )

         ALLOCATE ( FIREFLAG( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'FIREFLAG', PNAME )
         FIREFLAG = .FALSE.   ! array

         ALLOCATE ( FIREVAR( FGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'FIREVAR', PNAME )

         DO N = 1, NGRPS
            ISRM = MAP_PTtoISRM( N )

            IF ( .NOT. OPEN3( STKENAME( N ), FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open '// TRIM( STKENAME( N ) ) // ' file'
               CALL M3MESG( XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            IF ( .NOT. DESC3( STKENAME( N ) ) ) THEN
               XMSG = 'Could not get ' // TRIM( STKENAME( N ) ) // ' file description'
               CALL M3MESG( XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ! Each file will use the default jdate, unless specified by the user 
            ! that the file is a representative day file
            EM_FILE_DATE( ISRM ) = JDATE    
            IF ( EM_FILE_SYM_DATE( ISRM ) ) EM_FILE_DATE( ISRM ) = SDATE3D

            NSRC_EMIS( N ) = NROWS3D
            NVARS_EMIS( N ) = NVARS3D
            LEN1 = NSRC_EMIS( N )
            LEN2 = NVARS_EMIS( N )
            DO I = 1, LEN2
               ! Use HFLUX to determine Fire sources in PT3D_DEFN via
               ! the FIRENAM variable
               IF ( VNAME3D( I ) .EQ. 'HFLUX' ) THEN
                   FIREFLAG( N ) = .TRUE.
                   EM_FILE_FIRE( ISRM ) = .TRUE.
               END IF
            END DO
            IF ( FIREFLAG( N ) ) THEN   ! subtract off 'HFLUX'
               LEN2 = LEN2 - NVARS_FIRE
               NVARS_EMIS( N ) = LEN2
            END IF

            STKEMIS( N )%LEN = LEN1
            ALLOCATE ( STKEMIS( N )%ARRY( LEN1 ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKEMIS', PNAME )
            STKEMIS( N )%ARRY = 0.0   ! array

            EM_FILE_SURR( ISRM )%LEN = LEN2
            ALLOCATE ( EM_FILE_SURR( ISRM )%ARRY( LEN2 ), STAT = ASTAT )
            ALLOCATE ( EM_FILE_SURR( ISRM )%UNITS( LEN2 ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'EM_FILE_SURR', PNAME )

            IF ( FIREFLAG( N ) ) THEN   ! subtract and save off 'HFLUX'
               ALLOCATE ( FIREVAR( N )%ARRY( LEN1 ), STAT = ASTAT )
               CALL CHECKMEM( ASTAT, 'FIREVAR', PNAME )
               I = 0
               DO J = 1, NVARS3D
                  IF ( VNAME3D( J ) .NE. 'HFLUX' ) THEN
                     I = I + 1
                     EM_FILE_SURR( ISRM )%ARRY( I ) = VNAME3D( J )
                     EM_FILE_SURR( ISRM )%UNITS( I )= UNITS3D( J )
                  END IF
               END DO
               FIREVAR( N )%LEN = LEN1
            ELSE
               DO J = 1, EM_FILE_SURR( ISRM )%LEN
                  EM_FILE_SURR( ISRM )%ARRY( J ) = VNAME3D( J )
                  EM_FILE_SURR( ISRM )%UNITS( J )= UNITS3D( J )
               END DO
            END IF

         END DO

         RETURN

         END FUNCTION STK_EMIS_INIT

      END MODULE STK_EMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE PM3ERR( CALLER, JDATE, JTIME, ERRTXT, FATAL )
C.....................................................................
C
C  PURPOSE:   Provides M3ERR functionality in a parallel environment.
C             The processor-id suffix is appended to the name of the
C             caller. Generate simple error messages for Models-3, and
C             terminate program execution via MPI_ABORT iff FATAL.
C
C
C  PRECONDITIONS REQUIRED:  Same as for M3EXIT.
C
C
C  REVISION  HISTORY:
C       Original version 07/1999 by Al Bourgeois to provide proper
C           program exiting in parallel environment.
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO; removed
C             deprecated TRIMLEN
C
C
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER*(*)   CALLER       ! Name of the caller.
C     INTEGER         JDATE        ! Model date for the error.
C     INTEGER         JTIME        ! Model time for the error.
C     CHARACTER*(*)   ERRTXT       ! Error message.
C     LOGICAL         FATAL        ! Terminate program iff TRUE.
C
C     COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE               !  Local processor id.
C
C  OUT: none
C
C  SUBROUTINES AND FUNCTIONS CALLS:  INIT3, SHUT3, MPI_ABORT, INQUIRE.
C
C***********************************************************************

      USE M3UTILIO              ! i/o api
      USE RUNTIME_VARS

      IMPLICIT NONE

C...........   INCLUDES:

      INCLUDE 'mpif.h'           ! MPI definitions and parameters.
      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.


C...........   ARGUMENTS and their descriptions:

      CHARACTER*(*)   CALLER       ! Name of the caller.
      INTEGER         JDATE        ! Model date for the error.
      INTEGER         JTIME        ! Model time for the error.
      CHARACTER*(*)   ERRTXT       ! Error message.
      LOGICAL         FATAL        ! Terminate program iff TRUE.


C...........   LOCAL VARIABLES

      INTEGER      LENSTR       ! String length of CALLER.
      INTEGER      IDEV         ! Loop counter over FORTRAN unit numbers.
      INTEGER      ERRCODE      ! Error code from abort attempt.
      INTEGER      IERROR       ! Error from MPI_ABORT routine.
      LOGICAL      OFLAG        ! Flag for indicating file open.
      CHARACTER*24 DTBUF        ! Scratch area for date string.
      CHARACTER*7  PE_STR       ! String suffix to go with processor ID.
      CHARACTER*16 CALL16       ! First 16 characters of CALLER.
      CHARACTER*26 PCALLER      ! New caller string with PE information.

C.............................................................................
C   begin subroutine PM3ERR


C.......  Construct new CALLER string.
      WRITE (PE_STR,'(A7)') ' on PE '


C.......  Construct new CALLER string.
      LENSTR = MIN( 16, LEN_TRIM( CALLER ) )
      CALL16 = CALLER( 1: LENSTR )
      PCALLER = CALL16(1:LENSTR)//PE_STR//CMYPE


C.......  Do M3ERR tasks.

        IF ( FATAL ) THEN     ! Print error messages and exit.

            WRITE( LOGDEV,91010 ) PCALLER, TRIM( ERRTXT )

            IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 ) THEN
                DTBUF = DT2STR( JDATE, JTIME )
                WRITE( LOGDEV,* ) 'PM3ERR:  DTBUF ', DTBUF
                WRITE( LOGDEV,91011 ) DTBUF, JDATE, JTIME
            ELSE
                WRITE( LOGDEV,* )  'PM3ERR:  date&time specified as 0'
                WRITE( LOGDEV,91012 ) 'Date&time specified as 0'
            END IF

            IF ( .NOT. SHUT3() ) THEN
                WRITE( LOGDEV,91000 )
     &              'Could not shut down I/ O API files correctly',
     &              ' ', ' '
            END IF

            DO  11  IDEV = 10, 99
                INQUIRE( UNIT = IDEV, OPENED = OFLAG )
                IF ( OFLAG ) CLOSE( IDEV )
11          CONTINUE


C.......  Abort all parallel tasks.
          CALL MPI_ABORT( MPI_COMM_WORLD, ERRCODE, IERROR )



        ELSE    !  Print error message but do not exit.


            WRITE( LOGDEV,91020 ) PCALLER, TRIM( ERRTXT )

            IF ( JDATE .GT. 0  .OR.  JTIME .GT. 0 )  THEN
                WRITE( LOGDEV,91011 )
     &             DT2STR( JDATE, JTIME ), JDATE, JTIME
            END IF

            RETURN


        END IF

C******************  FORMAT  STATEMENTS   ******************************

C...........   Error and warning message formats..... 91xxx

91000   FORMAT ( //5X , '*** ERROR ABORT in subroutine PM3ERR ***',
     &            /5X , A , // )

91010   FORMAT ( //5X , '*** ERROR ABORT in subroutine ', A,
     &            /5X , A )

91011   FORMAT ( 5X , 'Date and time ', A, :,
     &                  ' (', I7, ':', I6.6, ')' )

91012   FORMAT ( 5X , A )

91020   FORMAT (  /5X , '>>--->> WARNING in subroutine ', A,
     &            /5X , A )

        END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CONV_CGRID ( CGRID, JDATE, JTIME, CNGRD )

C-----------------------------------------------------------------------
C Function:
C   Convert decoupled aerosol species to molar units (ppm and m**2/mol)
C   and reorder dimensions

C Revision History:
C   Written by: J.Young 21 Aug 03
C   J.Young 31 Jan 05: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE VDIFF_MAP
      use CENTRALIZED_IO_MODULE, only : interpolate_var
      
#ifdef isam
      USE SA_DEFN
#endif

      IMPLICIT NONE

      INCLUDE SUBST_CONST     ! constants
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )            ! concentrations
      INTEGER, INTENT( IN )    :: JDATE            ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )    :: JTIME            ! current model time, coded HHMMSS
      REAL,    INTENT( INOUT ) :: CNGRD( :,:,:,: ) ! cgrid replacement
#ifdef isam
      INTEGER IBGN, JSPCTAG
#endif

C Parameters:
      REAL, PARAMETER :: MWAIR_SI = MWAIR / 1.0E+03 ! kg mol-1

C Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 16 ), SAVE :: PNAME = 'CONV_CGRID'
      CHARACTER( 96 ) :: XMSG = ' '

      REAL      DENS( NCOLS,NROWS,NLAYS )  ! air density (kg m-3)
      REAL      FAC1( NCOLS,NROWS,NLAYS )  ! conversion factor

      INTEGER   NSPCS, OFF
      INTEGER   C, R, L, S, V, I           ! loop induction variables
      INTEGER IOS

      REAL    CONV            ! temp var

C-----------------------------------------------------------------------

      call interpolate_var ('DENS', jdate, jtime, DENS) ! kg m-3
      FAC1 = MWAIR_SI / DENS  ! m3 mol-1

C Convert non-molar mixing ratio species and re-order CGRID
      DO L = 1, NLAYS

        DO I = 1,N_CGRID_SPC
            ! Gas - no conversion
            IF ( CGRID_MASK_GAS( I ) .OR.
     &           CGRID_MASK_NR( I )  .OR.
     &           CGRID_MASK_TRAC( I ) )
     &         CNGRD( I,L,:,: ) = CGRID( :,:,L,I )

            ! Aerosol Mass: ug/m3 -> ppmv
            IF ( CGRID_MASK_AERO( I ) .AND.
     &           .NOT. CGRID_MASK_NUM( I ) .AND.
     &           .NOT. CGRID_MASK_SRF( I )  )
     &         CNGRD( I,L,:,: ) = CGRID( :,:,L,I ) 
     &                          * FAC1( :,:,L ) / CGRID_MW( I )

            ! Aerosol Number: N m-3 -> N mol-1
            ! Aerosol Surface Area: m2/m3 -> m2 / mol air
            IF ( CGRID_MASK_NUM( I ) .OR.
     &           CGRID_MASK_SRF( I )      )
     &         CNGRD( I,L,:,: ) = CGRID( :,:,L,I ) * FAC1( :,:,L )
        END DO
      
      END DO

#ifdef isam
      ! Convert PM Mass Only
      CONV_SPCTAG: DO JSPCTAG = 1, N_SPCTAG
         IBGN = INDEX( VNAM_SPCTAG( JSPCTAG ), '_', .FALSE. ) - 1
         S = INDEX1( VNAM_SPCTAG( JSPCTAG )( 1:IBGN ), N_AE_SPC, AE_SPC )
         IF ( S .GT. 0 ) THEN
            DO L = 1, NLAYS
               ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) =
     &            ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) )
     &              * FAC1( :,:,L ) / AE_MOLWT( S )
            END DO 
         END IF
      END DO CONV_SPCTAG
#endif

      RETURN

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      ENTRY REV_CGRID ( CNGRD, JDATE, JTIME, CGRID )

C Revert non-molar mixing ratio species and re-order CGRID

      call interpolate_var ('DENS', jdate, jtime, DENS) ! kg m-3
      FAC1 = DENS / MWAIR_SI  ! mol m-3

       DO L = 1, NLAYS
         DO I = 1,N_CGRID_SPC
             ! Gas - no conversion
             IF ( CGRID_MASK_GAS( I ) .OR.
     &            CGRID_MASK_NR( I )  .OR.
     &            CGRID_MASK_TRAC( I ) )
     &          CGRID( :,:,L,I ) = CNGRD( I,L,:,: )

             ! Aerosol Mass:  ppmv -> ug m-3
             IF ( CGRID_MASK_AERO( I ) .AND.
     &            .NOT. CGRID_MASK_NUM( I ) .AND.
     &            .NOT. CGRID_MASK_SRF( I )  )
     &          CGRID( :,:,L,I ) = CNGRD( I,L,:,: ) 
     &                           * FAC1( :,:,L ) * CGRID_MW( I )

             ! Aerosol Number: N mol-1 -> N m-3
             ! Aerosol Surface Area: m2 mol-1 -> m2 m-3
             IF ( CGRID_MASK_NUM( I ) .OR.
     &            CGRID_MASK_SRF( I )      )
     &          CGRID( :,:,L,I ) = CNGRD( I,L,:,: ) * FAC1( :,:,L )
         END DO
      END DO
#ifdef isam
Ckrt....JSPCTAG loop on PM mass only.....
      REV_SPCTAG: DO JSPCTAG = 1, N_SPCTAG
         IBGN = INDEX( VNAM_SPCTAG( JSPCTAG ), '_', .FALSE. ) - 1
         S = INDEX1( VNAM_SPCTAG( JSPCTAG )( 1:IBGN ), N_AE_SPC, AE_SPC )
         IF ( S .GT. 0 ) THEN
            DO L = 1, NLAYS
                ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) ) =
     &             ISAM( :,:,L,S_SPCTAG( JSPCTAG ),T_SPCTAG( JSPCTAG ) )
     &              * FAC1( :,:,L ) * AE_MOLWT( S )
            END DO
         END IF
      END DO REV_SPCTAG
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module sedimentation

C Revision History:
C 03 Jul 15 J.Young: inital

      implicit none

      public sedi
      private

      include SUBST_CONST     ! constants
      include SUBST_FILES_ID  ! file name parameters

      real,    allocatable, save :: cgrd( :,: )   ! density units
      real,    allocatable, save :: conc( :,: )   ! mixing ratio units

      real,    allocatable, save :: ldens( : )    ! local density kg m-3

      integer, save :: nqae              ! number of micro-grams/m**3 species
      integer, save :: nnae              ! number of #/m**3 species
      integer, save :: nsae              ! number of m**2/m**3 species
      integer, save :: cg_off            ! cngrd offset to aero species
      integer, allocatable, save :: qae( : ) ! cgrd pointer to micro-grams/m**3 species
      integer, allocatable, save :: nae( : ) ! cgrd pointer to #/m**3 species
      integer, allocatable, save :: sae( : ) ! cgrd pointer to m**2/m**3 species
      real,    allocatable, save :: molwt( : ) ! only for "qae" species
!     integer, save :: odate, otime
      real    conv, fac            ! temp var
      integer ios

      integer gxoff, gyoff         ! global origin offset from file
C for interpx
      integer, save :: strtcolmc3, endcolmc3, strtrowmc3, endrowmc3
      integer, allocatable, save :: map_sedi2cgrid( : )
      integer, save :: n_sedi_map   ! aero species, all modes

      contains

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine sedi ( jdate, jtime, dtsec, sedvel, cgrid, cngrd )

C Revision History:
C           J.Young, J.Pleim: inital
C 07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C 05 Mar 15 J.Pleim: correct layer thickness index off by 1
C 15 Jul 15 J.Young: correct sub timestep calculation and apply Martin Otte`s
C                    correction for the first-order upstream sedimentation
C  1 Feb 19 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      use cgrid_spcs          ! cgrd mechanism species
      use grid_conf
      use asx_data_mod
      use vdiff_map
      use utilio_defn
      use vdiff_diag, dtccr => dtccr_mean
      implicit none

C Arguments:
      integer, intent( in )    :: jdate, jtime       !
      real,    intent( in )    :: dtsec              ! model time step in seconds
C grav settling velocity applies only to coarse mode aerosols (J-,K-mode), but the VGS
C array is filled for *all* cgrd diffused species. VGS is set to zero for all the non-
C coarse mode aerosols.
      real,    intent( out )   :: sedvel( :,:,:,: )  ! grav settling vel. for diagnostic
      real,    pointer         :: cgrid ( :,:,:,: )
      real,    intent( inout ) :: cngrd ( :,:,:,: )  ! cgrid replacement

c Parameters:
      real, parameter :: alpha = 1.1
!     real, parameter :: alpha = 2.0

c External Functions:

C Local Variables:

      character( 120 ) :: xmsg = ' '
      character( 16 ), save :: pname = 'SEDI'
      logical, save :: firstime = .TRUE.

      real,    allocatable, save :: vsed    ( :,: ) ! settling vel.
      real,    allocatable, save :: vsed_ae ( :,: ) ! settling vel.
      real,    allocatable, save :: dtsvsed ( :,: ) ! settling vel. factor
      real,    allocatable, save :: sumvsed ( :,: ) ! for diagnostics
      real,    allocatable, save :: rdl     ( : )   ! subloop var
      real,    allocatable, save :: rrhodz  ( : )   ! reciprocal rho * deltaZ
      integer, allocatable, save :: sedi_map( : )
      integer, allocatable, save :: conc_map( : )
      real       adts, dts, rdts
      real       ldt, fs
      integer    off, dtc, iter 
      integer    c, r, l, n, s, v
      integer    astat
      integer    mdate, mtime

      interface   ! for external procedures
         subroutine aero_sedv ( col, row, cgrd, vsed_ae )
            integer, intent( in )  :: col, row
            real,    intent( in )  :: cgrd( :,: )
            real,    intent( out ) :: vsed_ae( :,: )
         end subroutine aero_sedv
      end interface

C-----------------------------------------------------------------------

      if ( firstime ) then

         firstime = .false.

         mdate = 0; mtime = 0

c sedi_map - from ae_trns to ae_spc (currently, all ae spc`s are transported)
c conc_map - from cgrid to ae_trns species
         allocate ( sedi_map( n_ae_spc ),
     &              map_sedi2cgrid( n_cgrid_spc ),
     &              conc_map( n_ae_spc ),  stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating VSED_MAP or CONC_MAP'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if

         map_sedi2cgrid = 0
         off = n_gc_trns   
         cg_off = ae_strt - 1   
         n_sedi_map = 0
         do v = 1, n_ae_spc
            n = index1( ae_spc( v ), n_ae_trns, ae_trns )
            if ( n .gt. 0 ) then
               n_sedi_map = n_sedi_map + 1
               sedi_map( n_sedi_map ) = n
               map_sedi2cgrid( n_sedi_map ) = n+cg_off
               conc_map( n_sedi_map ) = diff_map( n + off )
            end if
         end do
         write( logdev,'( 19x, "SEDI_MAP", 4x, "CONC_MAP" )' )
         do v = 1, n_sedi_map
            write( logdev,* ) v, sedi_map( v ), conc_map( v )
         end do

         allocate ( vsed_ae( n_ae_spc,nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating VSED_AE'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
         vsed_ae = 0.0  ! array assignment

         allocate ( cgrd( nlays,size( cgrid,4 ) ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating CGRD'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if

         allocate ( conc( n_sedi_map,nlays ),
     &              vsed( n_sedi_map,nlays ),
     &              dtsvsed( n_sedi_map,nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating CONC, VSED,  or DTSVSED'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if
         conc = 0.0  ! array assignment
         vsed = 0.0  ! array assignment

         allocate ( rdl( nlays ),
     &              rrhodz( nlays ),
     &              ldens( nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating RDL, RRHODZ, or LDENS'
            call m3exit( pname, mdate, mtime, xmsg, xstat1 )
         end if

         if ( vdiffdiag ) then
            allocate ( sumvsed( n_ae_spc,nlays ), stat = astat )
            if ( astat .ne. 0 ) then
               xmsg = 'Failure allocating SUMVSED'
               call m3exit( pname, mdate, mtime, xmsg, xstat1 )
            end if
         end if

      end if   !  if firstime

      do 345 r = 1, nrows
      do 344 c = 1, ncols

C subset all the layers and species in cgrid for this grid cell
         do v = 1, size( cgrid,4 )
            do l = 1, nlays
               cgrd( l,v ) = cgrid( c,r,l,v )
            end do
         end do

         do l = 1, nlays
            rdl( l ) = alpha * Met_Data%rjacf( c,r,l ) * Grid_Data%rdx3f( l )
            rrhodz( l ) = Met_Data%rrhoj( c,r,l ) * Grid_Data%rdx3f( l )
            ldens( l ) = Met_Data%dens( c,r,l )
         end do

         if ( vdiffdiag ) then
            sumvsed = 0.0   ! array assignment
         end if
         adts = 0.0; dtc = 0; iter = 0

         do while ( adts .lt. dtsec .and. iter .le. 10 )
            iter = iter + 1

            call aero_sedv( c, r, cgrd, vsed_ae )
            if ( vdiffdiag ) sumvsed = sumvsed + vsed_ae

            ! cgrd -> conc: from density units to mixing ratio units
            call conv_cgrd( )

            do v = 1, n_sedi_map
               vsed( v,: ) = vsed_ae( sedi_map( v ),: )
            end do

            ! Assess reciprocal of the time step and increase it if
            ! one of the surrogates shows a very fast sedimentation 
            ! velocity
            rdts = 1.0 / dtsec
            do l = 1, nlays
               do v = 1, n_sedi_map
                  fs = rdl( l ) * vsed( v,l )
                  if ( rdts .lt. fs ) rdts = fs
               end do
            end do
            dts = 1.0 / rdts
            
            ! Add the new time step increment
            adts = adts + dts
            if ( adts .gt. dtsec ) then   ! don`t overshoot the timestep
               dts = dtsec - (adts - dts)
               adts = dtsec
            end if

            dtc = dtc + 1

            ! Integrate sedimentation velocity change in time
            do l = 1, nlays
               ldt = dts * ldens( l )
               do v = 1, n_sedi_map
                  dtsvsed( v,l ) = ldt * vsed( v,l )
               end do
            end do

            ! Important Issue: Are these rrhodz values being applied
            ! correctly or should they be matched to each layer?

            ! Apply sedimentation from layer 2 to layer 1, only
            ! production
            l = 1
            do v = 1, n_sedi_map
               conc( v,l ) = conc( v,l )
     &                     + dtsvsed( v,l+1 ) * conc( v,l+1 ) * rrhodz( l )
            end do

            ! Apply production and loss to layers 2 through NZ-1
            do l = 2, nlays-1
               do v = 1, n_sedi_map
                  conc( v,l ) = conc( v,l )
     &                        + ( dtsvsed( v,l+1 ) * conc( v,l+1 )
     &                        -   dtsvsed( v,l )   * conc( v,l ) ) * rrhodz( l )
               end do
            end do

            ! Apply only loss to layer NZ
            l = nlays
            do v = 1, n_sedi_map
               conc( v,l ) = conc( v,l )
     &                     - dtsvsed( v,l ) * conc( v,l ) * rrhodz( l )
            end do

            ! conc -> cgrd: from mixing ratio units to density units
            call conv_conc( )
         end do   ! while
         if ( vdiffdiag ) then
            dtccr( c,r ) = real( dtc )
            do l = 1, nlays
               do v = 1, n_ae_spc
                  sedvel( v,l,c,r ) = sumvsed( v,l ) / real( dtc )
               end do
            end do
         end if

         do l = 1, nlays
            do v = 1, n_sedi_map
               cngrd( conc_map( v ),l,c,r ) = conc( v,l )
            end do
         end do
344   continue         !  end loop on col C
345   continue         !  end loop on row R

      return
      end subroutine sedi

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      subroutine conv_cgrd( )
         use cgrid_spcs          ! cgrd mechanism species
         use grid_conf        ! horizontal & vertical domain specifications
         use utilio_defn
         use asx_data_mod
         use vdiff_map

         implicit none

         integer   i, l, v            ! loop induction variables
         real FAC1( nlays )
         real, parameter :: mwair_si = mwair * 1.0e-3

C-----------------------------------------------------------------------

      FAC1 = MWAIR_SI / LDENS  ! kg m-3 -> m3 mol-1

      DO I = 1,N_SEDI_MAP
          ! Aerosol Mass: ug/m3 -> ppmv
          IF ( CGRID_MASK_AERO( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )  )
     &       CONC( I,: ) = CGRD( :,MAP_SEDI2CGRID(I) ) 
     &                    *FAC1( : ) / CGRID_MW( MAP_SEDI2CGRID(I) )

          ! Aerosol Number: N m-3 -> N mol-1
          ! Aerosol Surface Area: m2/m3 -> m2 / mol air
          IF ( CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .OR.
     &         CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )      )
     &       CONC( I,: ) = CGRD( :,MAP_SEDI2CGRID(I) ) * FAC1( : )

      END DO

      RETURN

      end subroutine conv_cgrd

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      subroutine conv_conc ( )
         use cgrid_spcs          ! cgrd mechanism species
         use grid_conf        ! horizontal & vertical domain specifications
         use vdiff_map

         implicit none

         integer   i, l, v            ! loop induction variables
         real, parameter :: mwair_si = mwair * 1.0e-3
         real fac1( nlays )

C-----------------------------------------------------------------------
      FAC1 = LDENS / MWAIR_SI  ! kg m-3 -> mol m-3

      DO I = 1,N_SEDI_MAP
          ! Aerosol Mass: ug/m3 -> ppmv
          IF ( CGRID_MASK_AERO( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .AND.
     &         .NOT. CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )  )
     &      CGRD( :,MAP_SEDI2CGRID(I) ) = CONC( I,: ) * FAC1( : ) 
     &                                  * CGRID_MW( MAP_SEDI2CGRID(I) )

          ! Aerosol Number: N m-3 -> N mol-1
          ! Aerosol Surface Area: m2/m3 -> m2 / mol air
          IF ( CGRID_MASK_NUM( MAP_SEDI2CGRID(I) ) .OR.
     &         CGRID_MASK_SRF( MAP_SEDI2CGRID(I) )      ) 
     &      CGRD( :,MAP_SEDI2CGRID(I) ) = CONC( I,: ) * FAC1( : )

      END DO
 
      RETURN

      end subroutine conv_conc

      end module sedimentation

      module log_header

      contains

      subroutine LOAD_HEADER( HEADER_TXT )

      IMPLICIT NONE

      CHARACTER( 90 ) :: HEADER_TXT( : )

      HEADER_TXT( : ) = ''

      HEADER_TXT( 1:21 ) = (/   
     &   '================================================================================', 
     &   '|                                                                              |', 
     &   '|               The Community Multiscale Air Quality (CMAQ) Model              |', 
     &   '|                                   Version 5.3.2                              |', 
     &   '|                                                                              |', 
     &   '|                          Built and Maintained by the                         |', 
     &   '|                        Office of Research and Development                    |', 
     &   '|                   United States Environmental Protection Agency              |', 
     &   '|                                                                              |', 
     &   '|                            https://www.epa.gov/cmaq                          |', 
     &   '|                                                                              |', 
     &   '|       Source Code:   https://www.github.com/USEPA/cmaq/tree/master           |', 
     &   '|       Documentation: https://www.github.com/USEPA/cmaq/tree/master/DOCS      |', 
     &   '|                                                                              |', 
     &   '|         The CMAQ Model is tested and released with cooperation from          |', 
     &   '|         the Community Modeling and Analysis System (CMAS) Center via         |', 
     &   '|         contract support. CMAS is managed by the Institute for the           |', 
     &   '|         Environment, University of North Carolina at Chapel Hill.            |', 
     &   '|         CMAS URL: (https://www.cmascenter.org)                               |', 
     &   '|                                                                              |', 
     &   '================================================================================'  
     &      /)

       end subroutine LOAD_HEADER 

      end module log_header

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE AERO_EMIS

C  Emissions data and code required for the modal aerosol module in CMAQ
C  Based on original codes by Dr. Francis S. Binkowski and J. Young
 
C  Dependent Upon:  NONE
 
C  Revision History:
 
C   30 Aug 01 J.Young:  dyn alloc - Use HGRD_DEFN
C   09 Oct 03 J.Gipson: added MW array for AE emis species to module contents
C   31 Jan 05 J.Young:  dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module, GRID_CONF
C   26 Apr 05 P.Bhave:  removed code supporting the "old type" of emission 
C                        files that had unspeciated PM10 and PM2.5 only
C                       removed need for 'AERO_SPC.EXT' by declaring the 
C                        required variables locally
C   13 Jun 05 P.Bhave:  added vars needed for sea-salt emission processing
C                       inherit N_AE_EMIS,AE_EMIS,AE_EMIS_MAP from AE_EMIS.EXT
C                       moved RHO* parameters from RDEMIS_AE to this module
C                        for use by SSEMIS routine
C   24 Aug 07 J.Young:  Modified to enable in-line plume rise calculation for
C                       3D pt source emissions. Distinguish between PM (primary,
C                       unspeciated, file data) and AE (model speciated). Re-
C                       named RDEMIS_AE to GET_AERO_EMIS.
C   11 Apr 08 J.Kelly:  added code to emit coarse surface area
C    4 Jan 10 J.Young:  restructure; eliminate ref to older AERO versions
C   21 Feb 10 J.Young:  move sea salt emissions to its own module (SSEMIS)
C   23 Apr 10 J.Young:  replace include files with mechanism namelists
C   30 Apr 10 J.Young:  update to use aero_reeng by Steve Howard, Prakash Bhave,
C                       Jeff Young, and Sergey Napelenok
C   23 Jul 10 D.Wong:   remove CLOSE3 and BARRIER
C   24 Feb 11 J.Young:  Reorganized module with initialization and timestepping
C                       procedures
C   25 Feb 11 J.Young:  add windblown dust module
C   25 Mar 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   18 Aug 11 David Wong: In the merge inline point source PM species calculation,
C                         arrays EMBUFF and PMEMIS_PT have incorrect index values
C   17 Apr 13 J.Young: replace "SPFC ASO4" (found by Havala Pye) with "SPFC_ASO4"
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C-----------------------------------------------------------------------

      USE AERO_DATA, ONLY: N_EM_AERO_REF, N_MODE
      USE EMIS_VARS, ONLY: EMLAYS, EM_STREAM_SIZE, N_EM_SRM

      IMPLICIT NONE
      SAVE 
C aerosol emissions: [ppmv/s] for mass & number spcs, [m2/mol/s] for surface area spcs
      PUBLIC EMISS_SIZE_DIST, AERO_EMIS_INIT,
     &       MAP_EMtoAERO, MAP_EMtoMODE, MAP_NUMtoEM, MAP_SRFtoEM,
     &       MAP_EMtoNUM, MAP_EMtoSRF, MAP_EMtoSD, EM_STREAM_SIZE, SD_SPLIT,
     &       CELLVOL, CELLHGT, EM_SD_INIT
      PRIVATE

C Variables for converting mass emissions rate to number emissions rate
      REAL   :: FACNUM( N_EM_AERO_REF,N_MODE )

C Variables for converting mass emissions rate to 2nd moment emissions rate
      REAL    :: FACSRF( N_EM_AERO_REF,N_MODE )

C Variables for Saving split factors between emission modes
      REAL, ALLOCATABLE :: SD_SPLIT( :,: )

C Variables for the thickness and volume of each grid cell
      REAL,    ALLOCATABLE :: CELLHGT( : ) ! grid-cell height [sigma]
      REAL,    ALLOCATABLE :: CELLVOL( : ) ! grid-cell volume [m2*sigma]
 
C Emission rate of all aerosol species interpolated to current time
      INTEGER, ALLOCATABLE :: MAP_EMtoAERO( : )   
      INTEGER, ALLOCATABLE :: MAP_EMtoMODE( : )   
      INTEGER, ALLOCATABLE :: MAP_NUMtoEM ( : )  
      INTEGER, ALLOCATABLE :: MAP_SRFtoEM ( : )   
      INTEGER, ALLOCATABLE :: MAP_EMtoNUM ( : )  
      INTEGER, ALLOCATABLE :: MAP_EMtoSRF ( : )   
      INTEGER, ALLOCATABLE :: MAP_EMtoSD  ( :,: ) 
      INTEGER, ALLOCATABLE :: MAP_AEROtoDIFF( :,: )     ! indices of aero species to CGRID

C DUST_MAP   windblown dust emission rate index in DUSTOUTM

C Domain decomposition info from emission and meteorology files
      INTEGER :: STARTCOL, ENDCOL, STARTROW, ENDROW
      INTEGER :: STRTCOLMC3, ENDCOLMC3, STRTROWMC3, ENDROWMC3

C Miscellaneous variables
      INTEGER :: IDX
      CHARACTER( 200 ) :: XMSG = ' '

      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION  AERO_EMIS_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS)

C  Revision History:
 
C   30 Aug 01 J.Young:  dynamic allocation - Use INTERPX
C   29 Jul 03 P.Bhave:  added compatibility with emission files that contain 
C                       PM10, PEC, POA, PNO3, PSO4, and PMF, but do not 
C                       contain PMC
C   20 Aug 03 J.Young:  return aero emissions in molar mixing ratio, ppm units
C   09 Oct 03 J.Gipson: added MW array for AE emis species to module contents
C   01 Sep 04 P.Bhave:  changed MW for primary organics from 120 to 220 g/mol,
C                       to match MWPOA in subroutine ORGAER3.
C   31 Jan 05 J.Young:  dyn alloc - removed HGRD_ID, VGRID_ID, and COORD_ID 
C                       include files because those parameters are now 
C                       inherited from the GRID_CONF module
C   26 Apr 05 P.Bhave:  removed code supporting the "old type" of emission 
C                        files that had unspeciated PM10 and PM2.5 only
C                       removed need for 'AERO_CONST.EXT' by declaring the
C                        required variables locally
C                       simplified the CONVM, CONVN, CONVS calculations
C                       updated and enhanced in-line documentation
C   03 May 05 P.Bhave:  fixed bug in the H2SO4 unit conversion, initially
C                        identified by Jinyou Liang of CARB
C   13 Jun 05 P.Bhave:  calculate sea-salt emissions; execute if MECHNAME = AE4
C                        read input fields from new OCEAN_1 file
C                        read extra input fields from MET_CRO_2D and MET_CRO_3D
C                        write diagnostic sea-salt emission file
C                        added TSTEP to call vector for diagnostic output file
C                       inherit MWs from AE_SPC.EXT instead of hardcoding
C                       find pointers to CGRID indices instead of hardcoding
C   08 Mar 07 P.Bhave&   added capability for emission files that contain 
C             S.Roselle:  POC or POA
C   30 Jan 08 P.Bhave:  added compatibility with AE5 mechanisms
C   23 Mar 08 J.Young:  modifications to allow for in-line point source emissions
C   11 Apr 08 J.Kelly:  added code to emit coarse surface area
C   09 Sep 08 P.Bhave:  backward compatibility with AE4 mechanisms
C   20 Feb 10 J.Young:  move ssemis out to its own F90 module
C   24 Feb 11 J.Young:  add windblown dust emissions option
C   25 Mar 11 S.Roselle: Replaced I/O API include files with UTILIO_DEFN
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   17 Sep 14 K.Fahey:  Changed geometric mean diameter and geometric
C                       standard deviation of emitted particles according to 
C                       Elleman and Covert (2010)
C   15 Apr 16 J.Young: Use aerosol factors from the AERO_DATA module's named constants;
C                      Moved K.Fahey's mods to geometric mean diameter and standard
C                      deviation to the AERO_DATA module
 
C  References:
C    CRC76,        "CRC Handbook of Chemistry and Physics (76th Ed)",
C                   CRC Press, 1995
C    Elleman & Covert, "Aerosol size distribution modeling with the Community
C                   Multiscale Air Quality modeling system in the Pacific
C                   Northwest: 3. Size distribution of particles emitted
C                   into a mesoscale model", J. Geophys. Res., Vol 115,
C                   No D3, doi:10.1029/2009JD012401, 2010
C    Hobbs, P.V.   "Basic Physical Chemistry for the Atmospheric Sciences",
C                   Cambridge Univ. Press, 206 pp, 1995.
C    Snyder, J.P.  "Map Projections-A Working Manual", U.S. Geological Survey
C                   Paper 1395 U.S.GPO, Washington, DC, 1987.
C    Binkowski & Roselle  Models-3 Community Multiscale Air Quality (CMAQ)
C                   model aerosol component 1: Model Description.  
C                   J. Geophys. Res., Vol 108, No D6, 4183 
C                   doi:10.1029/2001JD001409, 2003
C-----------------------------------------------------------------------

         USE AERO_DATA, ONLY: EM_AERO_REF, N_AEROSPC, AEROSPC, 
     &                        AERO_MISSING, MAP_AERO
         USE GRID_CONF, ONLY: GDTYP_GD, XCELL_GD, YCELL_GD, YORIG_GD, GL_NROWS, X3FACE_GD
         USE DUST_EMIS, ONLY: DUST_EMIS_INIT
         USE EMIS_VARS, ONLY: MAP_EMtoSURR
         USE PRECURSOR_DATA, ONLY: MAP_PRECURSOR
         USE RUNTIME_VARS, ONLY:  OCEAN_CHEM, WB_DUST
         USE SSEMIS, ONLY:    SSEMIS_INIT
         USE UTILIO_DEFN, ONLY: INDEX1, M3EXIT, LATGRD3, XSTAT1, XSTAT2
         USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_SPC
     
         INCLUDE SUBST_CONST     ! physical and mathematical constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

         INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: TSTEP      ! time step vector (HHMMSS)
                                             ! TSTEP(1) = local output step
         LOGICAL SUCCESS

C External Functions:
         INTEGER, EXTERNAL :: FINDEX       !  looks up number in table.

C Local Variables:
         REAL  DGV, SG, SPLIT_ACCUM

C Variables for calculating the volume of each grid cell
         REAL  DX1, DX2                            ! grid-cell width and length [m]
         REAL  CELLAREA                            ! grid-cell area [m2]

C Domain decomposition info from emission and meteorology files
         INTEGER GXOFF, GYOFF          ! origin offset

C Miscellaneous variables
         INTEGER STATUS                   ! ENV..., ALLOCATE status
         CHARACTER( 16 ), SAVE :: PNAME = 'AERO_EMIS_INIT  '
         CHARACTER( 16 ) :: VNAME         ! temp var for species names
         CHARACTER( 50 ) :: VARDESC       ! variable for reading environ. variables
         INTEGER L, N, S, V, IAERO, ISRM, ! Loop indices
     &           IEM, IDIFF, ISPC

C ----------------------------------------------------------------------

         SUCCESS = .TRUE.

C *** Map data modules
         CALL MAP_AERO()
         CALL MAP_PRECURSOR()

C *** set up for sea-spray emission processing
         IF ( OCEAN_CHEM ) THEN
            IF ( .NOT. SSEMIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
               XMSG = 'Failure initializing sea-spray emission processing'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
         END IF

C *** set up for dust emission processing
         IF ( WB_DUST ) THEN
            IF ( .NOT. DUST_EMIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
               XMSG = 'Failure initializing dust emission processing'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
         END IF

C *** Set up emissions size distribution arrays
      ! Calculate factors for converting 3rd moment emission rates into 
      ! number and surface area emission rates.  See Equation 7b of 
      ! Binkowski & Roselle (2003)
         DO IEM = 1,N_EM_AERO_REF
           DO N = 1, N_MODE
              DGV = EM_AERO_REF( IEM )%DGVEM( N )
              SG  = EM_AERO_REF( IEM )%SGEM ( N )

              IF ( EM_AERO_REF( IEM )%SPLIT( N ) .GT. 0.0 ) THEN
                FACNUM( IEM,N ) = EXP( 4.5 * LOG( SG ) ** 2 ) / DGV ** 3
                FACSRF( IEM,N ) = PI * EXP( 0.5 * LOG( SG ) ** 2 ) / DGV
              ELSE
                FACNUM( IEM,N ) = 0.0
                FACSRF( IEM,N ) = 0.0
              END IF
           END DO

         END DO

       ! Map the Modal-Dependent Names to Transported Species
       ALLOCATE ( MAP_AEROtoDIFF( N_AEROSPC, N_MODE ) )
       DO ISPC = 1,N_AEROSPC
         DO N = 1,N_MODE
           MAP_AEROtoDIFF( ISPC, N ) = INDEX1( AEROSPC( ISPC )%name( N ), 
     &                                 N_SPC_DIFF, DIFF_SPC )
         END DO
       END DO

     
       ! Modify the reference emissions splits based on what transported 
       ! aerosol species are actually available. For example, if the aerosol
       ! namelist only includes the accumulation mode (J) but not the 
       ! Aitken mode (I) for a particular species, then the split for
       ! Aitken mode should be added to the Accumulation mode. Save
       ! these scale factors as a function of transported species and
       ! mode. 
       ALLOCATE( SD_SPLIT( N_SPC_DIFF, N_EM_AERO_REF ) )
       SD_SPLIT = 0.0
       DO IEM = 1,N_EM_AERO_REF
         ! For the Fine Mode Reference Distribution, lump Aitken
         ! with Accumulation mode if Aitken Mode does not exist
         IF ( EM_AERO_REF( IEM )%NAME .EQ. 'FINE_REF' ) THEN
            DO ISPC = 1,N_AEROSPC
              SPLIT_ACCUM = 0.0
              DO N = 1,N_MODE-1
                IF ( AERO_MISSING( ISPC,N ) ) THEN
                  SPLIT_ACCUM = SPLIT_ACCUM + EM_AERO_REF( IEM )%SPLIT( N )
                ELSE
                  SD_SPLIT( MAP_AEROtoDIFF( ISPC,N ),IEM ) = 
     &               SD_SPLIT( MAP_AEROtoDIFF( ISPC,N ),IEM ) +
     &               EM_AERO_REF( IEM )%SPLIT( N ) + SPLIT_ACCUM
                  SPLIT_ACCUM = 0.0
                END IF
              END DO
            END DO
         ELSE 
            ! Arbitrary Distribution -> Apply factor to species
            ! if it exists in each mode
            DO ISPC = 1, N_AEROSPC
              DO N = 1, N_MODE
                IF ( .NOT. AERO_MISSING( ISPC,N ) ) THEN
                  SD_SPLIT( MAP_AEROtoDIFF( ISPC,N ),IEM ) = 
     &               EM_AERO_REF( IEM )%SPLIT( N ) 
                END IF
              END DO
            END DO
         END IF
       END DO

C *** Allocate memory for CELLHGT and CELLVOL
         ALLOCATE ( CELLHGT( EMLAYS ),
     &              CELLVOL( EMLAYS ), STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = '*** CELLHGT or CELLVOL memory allocation failed'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( MAP_NUMtoEM ( N_MODE ),
     &              MAP_SRFtoEM ( N_MODE ), STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = '*** memory allocation failed for '
     &           // 'NUM_MAP, NUM_FAC, SRF_MAP, SRF_FAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C *** Get length and width of each grid cell
C     note: crude estimate is made for LAT/LONG coordinate systems
         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m
            DX2 = DG2M * YCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD
     &          * FLOAT( GL_NROWS/2 ) ) ) ! in m
         ELSE
            DX1 = XCELL_GD        ! in m
            DX2 = YCELL_GD        ! in m
         END IF

C *** Get height of grid cell in each layer in sigma coordinates
C     Multiply by grid area [m2] to obtain grid volume
         CELLAREA = DX1 * DX2
         DO L = 1, EMLAYS
            CELLHGT( L ) = X3FACE_GD( L ) - X3FACE_GD( L-1 )
            CELLVOL( L ) = CELLHGT( L ) * CELLAREA
         END DO

         END FUNCTION  AERO_EMIS_INIT

C-----------------------------------------------------------------------

       SUBROUTINE EM_SD_INIT ( JDATE, JTIME )

C  EM_SD_INIT initializes the structures that map modes and streams to
C  reference modes including splits, diameters, and standard deviations.

C-----------------------------------------------------------------------
       USE AERO_DATA, ONLY: EM_AERO_REF, N_EM_AERO_REF
       USE EMIS_VARS, ONLY: SD_NML, INTERPRET_EM_RULE_STREAM
       USE UTILIO_DEFN, ONLY: INDEX1, XSTAT1
         
       IMPLICIT NONE

       INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
       INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
       INTEGER ISRM
       
       INTEGER                          :: N_SD_RULE
       INTEGER                          :: N_SD( N_EM_SRM )
       CHARACTER( 16 )                  :: SD_NAME( N_EM_SRM, 10 )
       INTEGER                          :: SD( N_EM_SRM, 10 )
       LOGICAL                          :: EM_STREAM_RULE( N_EM_SRM )
       CHARACTER( 16 )                  :: CSUR
       CHARACTER( 16 ), SAVE            :: PNAME = 'EM_SD_INIT  '
       CHARACTER( 20 )                  :: EM_AERO_REF_CAPS( N_EM_AERO_REF )

       INTEGER IRULE, ISUR, N, NLEN, ISD, IM, IEM, NRULE
       LOGICAL   :: LREMOVE
       
       ! Find Total Number of Size Distribution Registries
       N_SD_RULE = SIZE( SD_NML )
       NRULE = 0
       DO IRULE = 1,N_SD_RULE
          IF ( SD_NML( IRULE )%STREAM .EQ. '' ) EXIT
          NRULE = NRULE + 1
       END DO
       N_SD_RULE = NRULE

       ! First Load all of the Streams with the Default FINE, COARSE, and
       ! AERO Mode references
       SD = 0
       SD_NAME = ''

       ! Capitalize EM_AERO_REF(:)%NAME
       DO IM = 1,N_EM_AERO_REF
          EM_AERO_REF_CAPS( IM ) = EM_AERO_REF( IM )%NAME
          CALL UPCASE( EM_AERO_REF_CAPS( IM ) )
       ENDDO

       DO ISRM = 1,N_EM_SRM
         N_SD( ISRM ) = 2
         SD_NAME( ISRM,1 ) = 'FINE'
         SD( ISRM,1 ) = INDEX1( 'FINE_REF',   N_EM_AERO_REF, EM_AERO_REF_CAPS( : ) )
         SD_NAME( ISRM,2 ) = 'COARSE'
         SD( ISRM,2 ) = INDEX1( 'COARSE_REF', N_EM_AERO_REF, EM_AERO_REF_CAPS( : ) )
       END DO
       
       ! Now Modify those defaults or add new modes to desired streams
       DO IRULE = 1, N_SD_RULE
         ! Expand Size Distribution Rule to All Streams if Requested
         LREMOVE = .FALSE.
         IF ( SD_NML( IRULE )%STREAM .EQ. '' ) CYCLE
         CALL INTERPRET_EM_RULE_STREAM( SD_NML( IRULE )%STREAM, IRULE, 
     &                 EM_STREAM_RULE, LREMOVE )
         IF ( LREMOVE ) CYCLE

         ! Loop through streams, set defaults, and build map array
         DO ISRM = 1, N_EM_SRM
            IF ( EM_STREAM_RULE( ISRM ) ) THEN
               ! This Stream is Being Modified by a Size Distribution
               ! rule
               CALL UPCASE( SD_NML( IRULE )%MODE_REF )
               IF ( SD_NML( IRULE )%MODE .EQ. 'FINE' ) THEN
                   ! Overwrite the FINE mode. All fine particle species
                   ! will go to this mode by default
                   SD( ISRM,1 ) = INDEX1( SD_NML( IRULE )%MODE_REF,
     &                               N_EM_AERO_REF, EM_AERO_REF_CAPS( : ) )
                   IF ( SD( ISRM,1 ) .EQ. 0 ) THEN
                      WRITE( XMSG,'(A,A,A,/,A,I2,A)' ), '*** Reference Aerosol Mode (', 
     &                       SD_NML( IRULE )%MODE_REF, 'Specified in Emissions Size ',
     &                       'Dist Rule ',IRULE,' does not exist in AERO_DATA.'
                      CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                   END IF

               ELSEIF ( SD_NML( IRULE )%MODE .EQ. 'COARSE' ) THEN
                   ! Overwrite the COARSE mode. All coarse particle
                   ! species will go to this mode by default
                   SD( ISRM,2 ) = INDEX1( SD_NML( IRULE )%MODE_REF,
     &                               N_EM_AERO_REF, EM_AERO_REF_CAPS( : ) )
                   IF ( SD( ISRM,2 ) .EQ. 0 ) THEN
                      WRITE( XMSG,'(A,A,A,/,A,I2,A)' ), '*** Reference Aerosol Mode (', 
     &                       SD_NML( IRULE )%MODE_REF, 'Specified in Emissions Size ',
     &                       'Dist Rule ',IRULE,' does not exist in AERO_DATA.'
                      CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                   END IF

               ELSE
                   ! Add a New Available Mode. For example, add a mode
                   ! just for BC, call it PUREBC, and make sure the AEC
                   ! for this stream is pointing to this mode. Also make
                   ! sure you set AEC for FINE mode aerosol to 0.0 if
                   ! you have default mapping turned on.
                   N_SD( ISRM ) = N_SD( ISRM ) + 1
                   SD_NAME( ISRM,N_SD( ISRM ) ) = SD_NML( IRULE )%MODE
                   SD( ISRM,N_SD( ISRM ) ) = INDEX1( SD_NML( IRULE )%MODE_REF,
     &                                 N_EM_AERO_REF, EM_AERO_REF_CAPS( : ) )
                   IF ( SD( ISRM,N_SD( ISRM )) .EQ. 0 ) THEN
                      WRITE( XMSG,'(A,A,A,/,A,I2,A)' ), '*** Reference Aerosol Mode (', 
     &                       SD_NML( IRULE )%MODE_REF, 'Specified in Emissions Size ',
     &                       'Dist Rule ',IRULE,' does not exist in AERO_DATA.'
                      CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                   END IF

               END IF
           END IF
         END DO
      END DO
 
      ! Finally, transfer this data to a global variable which
      ! captures and organizes the modes of each stream
      ALLOCATE( EM_STREAM_SIZE( N_EM_SRM ) )
      DO ISRM = 1,N_EM_SRM
          N = N_SD( ISRM )
          EM_STREAM_SIZE( ISRM )%LEN = N + 1
          ALLOCATE( EM_STREAM_SIZE( ISRM )%NAME( N+1 ) )
          ALLOCATE( EM_STREAM_SIZE( ISRM )%REF( N+1 ) )
          ALLOCATE( EM_STREAM_SIZE( ISRM )%FACNUM( N+1,N_MODE ) )
          ALLOCATE( EM_STREAM_SIZE( ISRM )%FACSRF( N+1,N_MODE ) )

          EM_STREAM_SIZE( ISRM )%NAME( 2:N+1 ) = SD_NAME( ISRM,1:N )
          EM_STREAM_SIZE( ISRM )%REF( 2:N+1 )  = SD( ISRM,1:N )
          EM_STREAM_SIZE( ISRM )%NAME( 1 ) = 'GAS'
          EM_STREAM_SIZE( ISRM )%REF( 1 )  = 0

          ! Map Factors for Converting Aerosol Mass to Number and
          ! Surface Area to each Emission Stream
          EM_STREAM_SIZE( ISRM )%FACNUM( :,: ) = 0.0
          EM_STREAM_SIZE( ISRM )%FACSRF( :,: ) = 0.0
          DO ISD = 2,N+1
             IEM = EM_STREAM_SIZE( ISRM )%REF( ISD )
             DO IM = 1,N_MODE
                 EM_STREAM_SIZE( ISRM )%FACNUM( ISD,IM ) = FACNUM( IEM,IM ) 
                 EM_STREAM_SIZE( ISRM )%FACSRF( ISD,IM ) = FACSRF( IEM,IM )
             END DO
          END DO
      END DO

      END SUBROUTINE EM_SD_INIT    


C-----------------------------------------------------------------------

         SUBROUTINE EMISS_SIZE_DIST ( ISRM, VDEMIS, NL )

C  EMISS_SIZE_DIST distributes bulk aerosol emissions into size space
C  using parameters precompiled in the AERO_DATA module. 
C
C  Revision History:

C   16 AUG 17 BMURPHY: Created
C                      
C ----------------------------------------------------------------------

         USE AERO_DATA, ONLY: AEROSPC, N_AEROSPC, AEROSPC_MWINV 
         USE AEROMET_DATA, ONLY: F6DPI
         USE ASX_DATA_MOD, ONLY: MET_DATA
         USE EMIS_VARS, ONLY: N_EMIS_ISTR, IDUSTSRM, ISEASRM
         USE GRID_CONF, ONLY: NCOLS, NROWS
         USE SSEMIS, ONLY: SEA_FACTNUM, SEA_FACTSRF

         INTEGER, INTENT( IN ) :: ISRM, NL
         REAL, INTENT( INOUT ) :: VDEMIS ( :,:,:,: ) 

         INTEGER :: N, S, IAERO, IM, ISD, ISTR   ! Looping Variables
         INTEGER :: ROW, COL, LAY, N_SD, INUM, ISRF
         REAL    :: FACNUM, FACSRF, MW_FAC
         REAL, ALLOCATABLE       :: EMISM3( :,:,:,:,: ) 
         REAL, ALLOCATABLE, SAVE :: GSFAC( :,:,: )
         REAL, ALLOCATABLE, SAVE :: DENS_FAC( : )
         REAL, PARAMETER   :: F6DPIM9 = 1.0E-9 * F6DPI  ! 1.0E-9 = Kg/ug
         LOGICAL, SAVE     :: FIRST_TIME = .TRUE.

C *** Initialize Variables  
         IF ( FIRST_TIME ) THEN
             FIRST_TIME = .FALSE.
             ALLOCATE( GSFAC ( EMLAYS,NCOLS,NROWS ) )

             ALLOCATE( DENS_FAC( N_AEROSPC ) )
             DO IAERO = 1,N_AEROSPC
                 DENS_FAC( IAERO ) = F6DPIM9 / AEROSPC( IAERO )%DENSITY
             END DO

         END IF

         N_SD   = EM_STREAM_SIZE( ISRM )%LEN 
         ALLOCATE( EMISM3( EMLAYS,NCOLS,NROWS,N_MODE,N_SD ) )
         EMISM3 = 0.0
         !NL = EMLAYS

C *** Calculate scaling factor for converting mass emissions into [ug/m3/s]
C     note: RJACM converts grid heights from sigma coordinates to meters
C     Also calculate scaling factors for converting to molar-mixing-ratio units
         DO LAY = 1,NL
           GSFAC( LAY,:,: ) = Met_Data%RJACM( :,:,LAY ) / CELLVOL( LAY ) ![ug/s] to [ug/m3/s]
         END DO
 
C *** Apply Aerosol Size Distribution
         DO ISTR = 1, N_EMIS_ISTR
             ! Find which Size Distribution or Phase this emissions species belongs 
             ! to for this stream. If the value is a 0, then there are no emissions 
             ! for this species from this stream. If it is a 1, then this species is
             ! a gas and the following aerosol conversions should be skipped.
             ISD   = MAP_EMtoSD( ISTR,ISRM )
             IF ( ISD .LE. 1 ) CYCLE
             
             ! Look up Aerosol Species and Mode of Interest
             IAERO = MAP_EMtoAERO( ISTR )   !This maps to the CMAQ aerosol
                                            !  species so we can retrieve density
             IM    = MAP_EMtoMODE( ISTR )   !This maps to the internal CMAQ modes 
                                            !  (ie. I, J, and K)
             !DENS_FAC = F6DPIM9 / AEROSPC( IAERO )%DENSITY 

             ! Convert Aerosol from [g/s] to [ug/m3/s] for all streams
             ! except Dust and Sea Spray. For those streams, convert
             ! [g/m3/s] to [ug/m3/s]
             VDEMIS( ISTR,1:NL,:,: ) = VDEMIS( ISTR,1:NL,:,: )  * 1.0E6
             IF ( ISRM .NE. ISEASRM .AND. ISRM .NE. IDUSTSRM ) THEN
                VDEMIS( ISTR,1:NL,:,: ) = VDEMIS( ISTR,1:NL,:,: ) * GSFAC( 1:NL,:,: ) 
             END IF

             ! Sum Total Volume of Mode N [m3/m3/s]
             IF ( .NOT. AEROSPC( IAERO )%TRACER ) 
     &             EMISM3( 1:NL,:,:,IM,ISD ) = EMISM3( 1:NL,:,:,IM,ISD ) + 
     &                  VDEMIS( ISTR,1:NL,:,: ) * DENS_FAC( IAERO )

             ! Convert Mass Emission Rates from [ug/m3/s] to [umol/m3/s]
             VDEMIS( ISTR,1:NL,:,: ) = VDEMIS( ISTR,1:NL,:,: ) * AEROSPC_MWINV( IAERO )
         END DO          

C *** Calculate the number emissions rate for each mode [1/m3/s], using 
C     Equation 7b of Binkowski & Roselle (2003).
C     Calculate the surface area emissions rate for the fine modes [m2/m3/s],
C     using Equation 7c of Binkowski & Roselle (2003).  Multiplying by PI 
C     converts 2nd moment to surface area.
            
         DO ISD = 2, N_SD   ! Skip the Index for the Gas Phase
            !IF ( EM_AERO_REF( EM_STREAM_SIZE( ISRM )%REF( ISD ) )%NAME .EQ. 'SEASPRAY' ) THEN
            IF ( ISRM .EQ. ISEASRM ) THEN
               ! Apply Spatially-Dependent Number and Surface Area Scale Factors
               DO IM = 1, N_MODE
                  VDEMIS( MAP_NUMtoEM(IM),1,:,: ) = VDEMIS( MAP_NUMtoEM(IM),1,:,: ) 
     &                     + EMISM3( 1,:,:,IM,ISD ) * SEA_FACTNUM( IM,:,: ) 
                  VDEMIS( MAP_SRFtoEM(IM),1,:,: ) = VDEMIS( MAP_SRFtoEM(IM),1,:,: ) 
     &                     + EMISM3( 1,:,:,IM,ISD ) * SEA_FACTSRF( IM,:,: ) 
               END DO
            ELSE
               ! Apply Homogeneous Scale Factors Consistent with this Stream
               DO IM = 1, N_MODE
                  INUM = MAP_NUMtoEM(IM)
                  FACNUM = EM_STREAM_SIZE( ISRM )%FACNUM( ISD,IM )
                  VDEMIS( INUM,1:NL,:,: ) = VDEMIS( INUM,1:NL,:,: ) + EMISM3( 1:NL,:,:,IM,ISD ) * FACNUM
                  ISRF = MAP_SRFtoEM(IM)
                  FACSRF = EM_STREAM_SIZE( ISRM )%FACSRF( ISD,IM )
                  VDEMIS( ISRF,1:NL,:,: ) = VDEMIS( ISRF,1:NL,:,: ) + EMISM3( 1:NL,:,:,IM,ISD ) * FACSRF
               END DO
            END IF
         END DO
 
         END SUBROUTINE EMISS_SIZE_DIST
 
      END MODULE AERO_EMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from LUS_DEFN.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation
!  12 Aug 2019 F.Sidi Moved vnmld to its on type, and created a integer entry 
!                     to map dust categories from LUFRAC. **NOTE land use type
!                     with no mapped index has a dummy -999 value.** 
!------------------------------------------------------------------------!

          module lus_data_module

            implicit none

            type lus_type
               character( 16 ) :: name
               character( 64 ) :: desc
            end type lus_type
            
            type lus_type_2
               character( 16 ) :: name
               character( 64 ) :: desc
               integer :: lu_idx
            end type lus_type_2


            type( lus_type_2 ), allocatable :: vnmld( : )
            type( lus_type ), allocatable :: vnmlu( : )

            real, allocatable    :: ladut( :,:,: ) ! % of desertland
            real, allocatable    :: lut( :,:,: )   ! landuse category fraction
            real, allocatable    :: dmsk( : )      ! desert fraction mask
            real, allocatable    :: uland( :,:,: ) ! % of 4 land categories groups
            integer, allocatable :: dmap( : )      ! desert land map to BELD3

            character( 16 ) :: lufile( 2 ) = ' '
            logical         :: isbeld
            integer         :: n_dlcat        ! number of desert land categories
            integer         :: n_lucat        ! number of landuse categories

! BELD - Biogenic Emission Landcover Database
! USGS - United States Geological Survey
! NOAH - A community land-surface model [N=NCEP, O=Oregon State Univ.,
!        A=Air Force, H=Hydrologic Research Lab - NWS(now OHD: Office of
!        Hydrologic Devel.)]
! MODIS - MODerate resolution Imaging Spectroradiometer
! NLCD - National Land Cover Dataset
! IGBP - International Geosphere-Biosphere Programme

! BELD3 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read files: DUST_LU_1 & DUST_LU_2

            integer, parameter :: n_dlcat_beld3 = 3   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_beld3( n_dlcat_beld3 ) = (/
     &            lus_type_2( 'USGS_shrubland ', 'shrub_land    ',-999 ),
     &            lus_type_2( 'USGS_shrubgrass', 'shrub_grass   ',-999 ),
     &            lus_type_2( 'USGS_sprsbarren', 'sparse_barren ',-999 ) /)

            real :: dmsk_beld3( n_dlcat_beld3 ) = ! land use type desert fraction
     &               (/ 0.50,    ! shrubland
     &                  0.25,    ! shrubgrass
     &                  0.75 /)  ! barrenland

            integer :: dmap_beld3( n_dlcat_beld3+1 ) = ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              2,       ! shrubgrass
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_beld3 = 20   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_beld3( n_lucat_beld3 ) = (/
     &            lus_type( 'USGS_urban      ', 'urban               ' ),
     &            lus_type( 'USGS_drycrop    ', 'non_irrigated crops ' ),
     &            lus_type( 'USGS_irrcrop    ', 'irrigated crops     ' ),
     &            lus_type( 'USGS_cropgrass  ', 'crop_grass          ' ),
     &            lus_type( 'USGS_cropwdlnd  ', 'crop_wood land      ' ),
     &            lus_type( 'USGS_grassland  ', 'grass land          ' ),
     &            lus_type( 'USGS_shrubland  ', 'shrub land          ' ),
     &            lus_type( 'USGS_shrubgrass ', 'shrub_grass         ' ),
     &            lus_type( 'USGS_savanna    ', 'savanna             ' ),
     &            lus_type( 'USGS_decidforest', 'deciduous forest    ' ),
     &            lus_type( 'USGS_evbrdleaf  ', 'evergreen_broad_leaf' ),
     &            lus_type( 'USGS_coniferfor ', 'coniferous forest   ' ),
     &            lus_type( 'USGS_mxforest   ', 'mixed forest        ' ),
     &            lus_type( 'USGS_water      ', 'water               ' ),
     &            lus_type( 'USGS_wetwoods   ', 'wet_woods           ' ),
     &            lus_type( 'USGS_sprsbarren ', 'sparse_barren       ' ),
     &            lus_type( 'USGS_woodtundr  ', 'wood_tundra         ' ),
     &            lus_type( 'USGS_mxtundra   ', 'mixed_tundra        ' ),
     &            lus_type( 'USGS_snowice    ', 'snow_ice            ' ),
     &            lus_type( 'FOREST          ', 'total forest        ' ) /)  ! DUST_LU_2

! BELD4 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: E2C_LU

            integer, parameter :: n_dlcat_beld4 = 6   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_beld4( n_dlcat_beld4 ) = (/
     &            lus_type_2( 'NLCD_52 ', 'Shrub/Scrub                 ',-999 ),  ! shrubland?
     &            lus_type_2( 'MODIS_6 ', 'closed shrublands           ',-999 ),
     &            lus_type_2( 'MODIS_7 ', 'open shrublands             ',-999 ),
     &            lus_type_2( 'NLCD_51 ', 'Dwarf Scrub                 ',-999 ),  ! shrubgrass?
     &            lus_type_2( 'NLCD_31 ', 'Barren Land (Rock/Sand/Clay)',-999 ),
     &            lus_type_2( 'MODIS_16', 'barren or sparsely vegetated',-999 ) /)

            real :: dmsk_beld4( n_dlcat_beld4 ) = ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.25,    ! shrubgrass
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_beld4( n_dlcat_beld4+1 ) = ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              1,       ! shrubland
     &              2,       ! shrubgrass
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_beld4 = 50  ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_beld4( n_lucat_beld4 ) = (/
     &            lus_type( 'NLCD_11  ', 'Open Water                                  '),   !  1
     &            lus_type( 'NLCD_12  ', 'Perennial Ice/Snow                          '),   !  2
     &            lus_type( 'NLCD_21  ', 'Developed Open Space (not used)             '),   !  3 ?
     &            lus_type( 'NLCD_22  ', 'Developed Low Intensity                     '),   !  4
     &            lus_type( 'NLCD_23  ', 'Developed Medium Intensity                  '),   !  5
     &            lus_type( 'NLCD_24  ', 'Developed High Intensity                    '),   !  6
     &            lus_type( 'NLCD_31  ', 'Barren Land (Rock/Sand/Clay)                '),   !  7
     &            lus_type( 'NLCD_32  ', 'Unconsolidated Shore (not used)             '),   !  8 ?
     &            lus_type( 'NLCD_41  ', 'Deciduous Forest                            '),   !  9
     &            lus_type( 'NLCD_42  ', 'Evergreen Forest                            '),   ! 10
     &            lus_type( 'NLCD_43  ', 'Mixed Forest                                '),   ! 11
     &            lus_type( 'NLCD_51  ', 'Dwarf Scrub                                 '),   ! 12
     &            lus_type( 'NLCD_52  ', 'Shrub/Scrub                                 '),   ! 13
     &            lus_type( 'NLCD_71  ', 'Grassland/Herbaceous                        '),   ! 14
     &            lus_type( 'NLCD_72  ', 'Sedge/Herbaceous                            '),   ! 15
     &            lus_type( 'NLCD_73  ', 'Lichens                                     '),   ! 16
     &            lus_type( 'NLCD_74  ', 'Moss                                        '),   ! 17
     &            lus_type( 'NLCD_75  ', 'Tundra                                      '),   ! 18
     &            lus_type( 'NLCD_81  ', 'Pasture/Hay                                 '),   ! 19
     &            lus_type( 'NLCD_82  ', 'Cultivated Crops                            '),   ! 20
     &            lus_type( 'NLCD_90  ', 'Woody Wetlands                              '),   ! 21
     &            lus_type( 'NLCD_91  ', 'Palustrine Forested Wetland                 '),   ! 22
     &            lus_type( 'NLCD_92  ', 'Palustrine Scrub/Shrub Wetland (not used)   '),   ! 23 ?
     &            lus_type( 'NLCD_93  ', 'Estuarine Forested Wetland                  '),   ! 24
     &            lus_type( 'NLCD_94  ', 'Estuarine Scrub_Shrub Wetland (not used)    '),   ! 25 ?
     &            lus_type( 'NLCD_95  ', 'Emergent Herbaceous Wetlands (not used)     '),   ! 26 ?
     &            lus_type( 'NLCD_96  ', 'Palustrine Emergent Wetland (not used)      '),   ! 27 ?
     &            lus_type( 'NLCD_97  ', 'Estuarine Emergent Wetland (not used)       '),   ! 28 ?
     &            lus_type( 'NLCD_98  ', 'Palustrine Aquatic Bed (not used)           '),   ! 29 ?
     &            lus_type( 'NLCD_99  ', 'Estuarine Aquatic Bed  (not used)           '),   ! 30 ?
     &            lus_type( 'MODIS_0  ', 'water                                       '),   ! 31
     &            lus_type( 'MODIS_1  ', 'evergreen needleleaf forest                 '),   ! 32
     &            lus_type( 'MODIS_2  ', 'evergreen broadleaf forest                  '),   ! 33
     &            lus_type( 'MODIS_3  ', 'deciduous needleleaf forest                 '),   ! 34
     &            lus_type( 'MODIS_4  ', 'deciduous broadleaf forest                  '),   ! 35
     &            lus_type( 'MODIS_5  ', 'mixed forests                               '),   ! 36
     &            lus_type( 'MODIS_6  ', 'closed shrublands                           '),   ! 37
     &            lus_type( 'MODIS_7  ', 'open shrublands                             '),   ! 38
     &            lus_type( 'MODIS_8  ', 'woody savannas                              '),   ! 39
     &            lus_type( 'MODIS_9  ', 'savannas                                    '),   ! 40
     &            lus_type( 'MODIS_10 ', 'grasslands                                  '),   ! 41
     &            lus_type( 'MODIS_11 ', 'permanent wetlands                          '),   ! 42
     &            lus_type( 'MODIS_12 ', 'croplands                                   '),   ! 43
     &            lus_type( 'MODIS_13 ', 'urban and built up                          '),   ! 44
     &            lus_type( 'MODIS_14 ', 'cropland / natural vegetation mosaic        '),   ! 45
     &            lus_type( 'MODIS_15 ', 'permanent snow and ice                      '),   ! 46
     &            lus_type( 'MODIS_16 ', 'barren or sparsely vegetated                '),   ! 47
     &            lus_type( 'MODIS_17 ', 'IGBP water                                  '),   ! 48
     &            lus_type( 'MODIS_254', 'unclassified (not used)                     '),   ! 49 ?
     &            lus_type( 'MODIS_255', 'fill value (normally ocean water) (not used)') /) ! 50 ?

! USGS24 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D

            integer, parameter :: n_dlcat_usgs24 = 4   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_usgs24( n_dlcat_usgs24 ) = (/
     &            lus_type_2( 'LUFRAC_08', 'Shrubland                   ',8  ),
     &            lus_type_2( 'LUFRAC_19', 'Barren or Sparsely Vegetated',19 ),
     &            lus_type_2( 'LUFRAC_22', 'Mixed Tundra                ',22 ),
     &            lus_type_2( 'LUFRAC_23', 'Bare Ground Tundra          ',23 ) /)

!!!!!    Is some 'tundra' desert land?

            real :: dmsk_usgs24( n_dlcat_usgs24 ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_usgs24( n_dlcat_usgs24+1 ) =   ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_usgs24 = 24   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_usgs24( n_lucat_usgs24 ) = (/
     &            lus_type( 'LUFRAC_01', 'Urban Land                                      ' ),
     &            lus_type( 'LUFRAC_02', 'Dryland Cropland and Pasture                    ' ),
     &            lus_type( 'LUFRAC_03', 'Irrigated Cropland and Pasture                  ' ),
     &            lus_type( 'LUFRAC_04', 'Mixed Dryland and Irrigated Cropland and Pasture' ),
     &            lus_type( 'LUFRAC_05', 'Cropland-Grassland Mosaic                       ' ),
     &            lus_type( 'LUFRAC_06', 'Cropland-Woodland Mosaic                        ' ),
     &            lus_type( 'LUFRAC_07', 'Grassland                                       ' ),
     &            lus_type( 'LUFRAC_08', 'Shrubland                                       ' ),
     &            lus_type( 'LUFRAC_09', 'Mixed Shrubland-Grassland                       ' ),
     &            lus_type( 'LUFRAC_10', 'Savannah                                        ' ),
     &            lus_type( 'LUFRAC_11', 'Deciduous Broadleaf Forest                      ' ),
     &            lus_type( 'LUFRAC_12', 'Deciduous Needleleaf Forest                     ' ),
     &            lus_type( 'LUFRAC_13', 'Evergreen Broadleaf Forest                      ' ),
     &            lus_type( 'LUFRAC_14', 'Evergreen Needleleaf Forest                     ' ),
     &            lus_type( 'LUFRAC_15', 'Mixed Forest                                    ' ),
     &            lus_type( 'LUFRAC_16', 'Water                                           ' ),
     &            lus_type( 'LUFRAC_17', 'Herbaceous Wetland                              ' ),
     &            lus_type( 'LUFRAC_18', 'Wooded Wetland                                  ' ),
     &            lus_type( 'LUFRAC_19', 'Barren or Sparsely Vegetated                    ' ),
     &            lus_type( 'LUFRAC_20', 'Herbaceous Tundra                               ' ),
     &            lus_type( 'LUFRAC_21', 'Wooded Tundra                                   ' ),
     &            lus_type( 'LUFRAC_22', 'Mixed Tundra                                    ' ),
     &            lus_type( 'LUFRAC_23', 'Bare Ground Tundra                              ' ),
     &            lus_type( 'LUFRAC_24', 'Snow or Ice                                     ' ) /)

! MODIS - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D

            integer, parameter :: n_dlcat_modis = 1   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_modis( n_dlcat_modis ) = (/
     &            lus_type_2( 'nada', 'nada',-999 ) /)
            real :: dmsk_modis( n_dlcat_modis ) = 0.0  ! land use type desert fraction
            integer :: dmap_modis( n_dlcat_modis+1 ) = 0 ! land use type desert map to BELD3
            integer, parameter :: n_lucat_modis = 1   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_modis( n_lucat_modis ) = (/
     &            lus_type( 'nada', 'nada' ) /)

! 1  MODIS_0:    31. MODIS: 0 water
! 4  MODIS_1:    32. MODIS: 1 evergreen needleleaf forest
! 4  MODIS_2:    33. MODIS: 2 evergreen broadleaf forest
! 4  MODIS_3:    34. MODIS: 3 deciduous needleleaf forest
! 4  MODIS_4:    35. MODIS: 4 deciduous broadleaf forest
! 4  MODIS_5:    36. MODIS: 5 mixed forests
! 2  MODIS_6:    37. MODIS: 6 closed shrublands
! 2  MODIS_7:    38. MODIS: 7 open shrublands
! 4  MODIS_8:    39. MODIS: 8 woody savannas
! 2  MODIS_9:    40. MODIS: 9 savannas
! 2  MODIS_10:   41. MODIS: 10 grasslands
! 4  MODIS_11:   42. MODIS: 11 permanent wetlands
! 2  MODIS_12:   43. MODIS: 12 croplands
! 3  MODIS_13:   44. MODIS: 13 urban and built up
! 2  MODIS_14:   45. MODIS: 14 cropland / natural vegetation mosaic
! 1  MODIS_15:   46. MODIS: 15 permanent snow and ice
! 1  MODIS_16:   47. MODIS: 16 barren or sparsely vegetated
! 1  MODIS_17:   48. MODIS: 17 IGBP water
! -  MODIS_254:  49. MODIS: 254 unclassified
! -  MODIS_255:  50. MODIS: 255 fill value (normally ocean water)

! MODIS_NOAH
!     read file: GRID_CRO_2D

            integer, parameter :: n_dlcat_modis_noah = 4   ! number of desert land categories
            type( lus_type_2 ), parameter :: vnmld_modis_noah( n_dlcat_modis_noah ) = (/
     &            lus_type_2( 'LUFRAC_06', 'Closed Shrublands           ',6  ),
     &            lus_type_2( 'LUFRAC_07', 'Open Shrublands             ',7  ),
     &            lus_type_2( 'LUFRAC_16', 'Barren or Sparsely Vegetated',16 ),
     &            lus_type_2( 'LUFRAC_20', 'Barren Tundra               ',20 ) /)

            real :: dmsk_modis_noah( n_dlcat_modis_noah ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_modis_noah( n_dlcat_modis_noah+1 ) =  ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_modis_noah = 20   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_modis_noah( n_lucat_modis_noah ) = (/
     &            lus_type( 'LUFRAC_01', 'Evergreen Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_02', 'Evergreen Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_03', 'Deciduous Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_04', 'Deciduous Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_05', 'Mixed Forests                     ' ),
     &            lus_type( 'LUFRAC_06', 'Closed Shrublands                 ' ),
     &            lus_type( 'LUFRAC_07', 'Open Shrublands                   ' ),
     &            lus_type( 'LUFRAC_08', 'Woody Savannas                    ' ),
     &            lus_type( 'LUFRAC_09', 'Savannas                          ' ),
     &            lus_type( 'LUFRAC_10', 'Grasslands                        ' ),
     &            lus_type( 'LUFRAC_11', 'Permanent Wetlands                ' ),
     &            lus_type( 'LUFRAC_12', 'Croplands                         ' ),
     &            lus_type( 'LUFRAC_13', 'Urban and Built-Up                ' ),
     &            lus_type( 'LUFRAC_14', 'Cropland-Natural Vegetation Mosaic' ),
     &            lus_type( 'LUFRAC_15', 'Snow and Ice                      ' ),
     &            lus_type( 'LUFRAC_16', 'Barren or Sparsely Vegetated      ' ),
     &            lus_type( 'LUFRAC_17', 'Water                             ' ),
     &            lus_type( 'LUFRAC_18', 'Wooded Tundra                     ' ),
     &            lus_type( 'LUFRAC_19', 'Mixed Tundra                      ' ),
     &            lus_type( 'LUFRAC_20', 'Barren Tundra                     ' ) /)

! NLCD_MODIS or NLCD50 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D
! includes both nlcd and MODIS versions of shrublands
            integer, parameter :: n_dlcat_nlcd_modis = 7   ! number of desert land types
            type( lus_type_2 ), parameter :: vnmld_nlcd_modis( n_dlcat_nlcd_modis ) = (/
     &            lus_type_2( 'LUFRAC_37', 'Closed Shrublands           ',37 ),
     &            lus_type_2( 'LUFRAC_38', 'Open Shrublands             ',38 ),
     &            lus_type_2( 'LUFRAC_07', 'Barren Land (Rock-Sand-Clay)',7  ),
     &            lus_type_2( 'LUFRAC_12', 'Dwarf Scrub                 ',12 ),
     &            lus_type_2( 'LUFRAC_13', 'Shrub-Scrub                 ',13 ),
     &            lus_type_2( 'LUFRAC_18', 'Tundra                      ',18 ),
     &            lus_type_2( 'LUFRAC_47', 'Barren or Sparsely Vegetated',47 ) /)

            real :: dmsk_nlcd_modis( n_dlcat_nlcd_modis ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_nlcd_modis( n_dlcat_nlcd_modis+1 ) = ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_nlcd_modis = 50   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_nlcd_modis( n_lucat_nlcd_modis ) = (/
     &            lus_type( 'LUFRAC_01', 'Open Water' ),
     &            lus_type( 'LUFRAC_02', 'Perennial Ice-Snow                ' ),
     &            lus_type( 'LUFRAC_03', 'Developed Open Space              ' ),  ! ?
     &            lus_type( 'LUFRAC_04', 'Developed Low Intensity           ' ),
     &            lus_type( 'LUFRAC_05', 'Developed Medium Intensity        ' ),
     &            lus_type( 'LUFRAC_06', 'Developed High Intensity          ' ),
     &            lus_type( 'LUFRAC_07', 'Barren Land (Rock-Sand-Clay)      ' ),
     &            lus_type( 'LUFRAC_08', 'Unconsolidated Shore              ' ),  ! ?
     &            lus_type( 'LUFRAC_09', 'Deciduous Forest                  ' ),
     &            lus_type( 'LUFRAC_10', 'Evergreen Forest                  ' ),
     &            lus_type( 'LUFRAC_11', 'Mixed Forest                      ' ),
     &            lus_type( 'LUFRAC_12', 'Dwarf Scrub                       ' ),
     &            lus_type( 'LUFRAC_13', 'Shrub-Scrub                       ' ),
     &            lus_type( 'LUFRAC_14', 'Grassland-Herbaceous              ' ),
     &            lus_type( 'LUFRAC_15', 'Sedge-Herbaceous                  ' ),
     &            lus_type( 'LUFRAC_16', 'Lichens                           ' ),
     &            lus_type( 'LUFRAC_17', 'Moss                              ' ),
     &            lus_type( 'LUFRAC_18', 'Tundra                            ' ),
     &            lus_type( 'LUFRAC_19', 'Pasture-Hay                       ' ),
     &            lus_type( 'LUFRAC_20', 'Cultivated Crops                  ' ),
     &            lus_type( 'LUFRAC_21', 'Woody Wetlands                    ' ),
     &            lus_type( 'LUFRAC_22', 'Palustrine Forested Wetland       ' ),
     &            lus_type( 'LUFRAC_23', 'Palustrine Scrub-Shrub Wetland    ' ),  ! ?
     &            lus_type( 'LUFRAC_24', 'Estuarine Forested Wetland        ' ),
     &            lus_type( 'LUFRAC_25', 'Estuarine Scrub_Shrub Wetland     ' ),  ! ?
     &            lus_type( 'LUFRAC_26', 'Emergent Herbaceous Wetlands      ' ),  ! ?
     &            lus_type( 'LUFRAC_27', 'Palustrine Emergent Wetland       ' ),  ! ?
     &            lus_type( 'LUFRAC_28', 'Estuarine Emergent Wetland        ' ),  ! ?
     &            lus_type( 'LUFRAC_29', 'Palustrine Aquatic Bed            ' ),  ! ?
     &            lus_type( 'LUFRAC_30', 'Estuarine Aquatic Bed             ' ),  ! ?
     &            lus_type( 'LUFRAC_31', 'Water                             ' ),
     &            lus_type( 'LUFRAC_32', 'Evergreen Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_33', 'Evergreen Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_34', 'Deciduous Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_35', 'Deciduous Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_36', 'Mixed Forests                     ' ),
     &            lus_type( 'LUFRAC_37', 'Closed Shrublands                 ' ),
     &            lus_type( 'LUFRAC_38', 'Open Shrublands                   ' ),
     &            lus_type( 'LUFRAC_39', 'Woody Savannas                    ' ),
     &            lus_type( 'LUFRAC_40', 'Savannas                          ' ),
     &            lus_type( 'LUFRAC_41', 'Grasslands                        ' ),
     &            lus_type( 'LUFRAC_42', 'Permanent Wetlands                ' ),
     &            lus_type( 'LUFRAC_43', 'Croplands                         ' ),
     &            lus_type( 'LUFRAC_44', 'Urban and Built Up                ' ),
     &            lus_type( 'LUFRAC_45', 'Cropland-Natural Vegetation Mosaic' ),
     &            lus_type( 'LUFRAC_46', 'Permanent Snow and Ice            ' ),
     &            lus_type( 'LUFRAC_47', 'Barren or Sparsely Vegetated      ' ),
     &            lus_type( 'LUFRAC_48', 'IGBP Water                        ' ),
     &            lus_type( 'LUFRAC_49', 'unclassified                      ' ),  ! ?
     &            lus_type( 'LUFRAC_50', 'fill value                        ' ) /)  ! ?

! NLCD40 - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
!     read file: GRID_CRO_2D
! includes both nlcd and MODIS versions of shrublands
            integer, parameter :: n_dlcat_nlcd40 = 6   ! number of desert land types
            type( lus_type_2 ), parameter :: vnmld_nlcd40( n_dlcat_nlcd40 ) = (/
     &            lus_type_2( 'LUFRAC_06', 'Closed Shrublands           ',6  ),
     &            lus_type_2( 'LUFRAC_07', 'Open Shrublands             ',7  ),
     &            lus_type_2( 'LUFRAC_27', 'Barren Land (Rock-Sand-Clay)',27 ),
     &            lus_type_2( 'LUFRAC_31', 'Dwarf Scrub                 ',31 ),
     &            lus_type_2( 'LUFRAC_32', 'Shrub-Scrub                 ',32 ),
     &            lus_type_2( 'LUFRAC_16', 'Barren or Sparsely Vegetated',16 ) /)

            real :: dmsk_nlcd40( n_dlcat_nlcd40 ) =   ! land use type desert fraction
     &           (/ 0.50,    ! shrubland
     &              0.50,    ! shrubland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75,    ! barrenland
     &              0.75 /)  ! barrenland

            integer :: dmap_nlcd40( n_dlcat_nlcd40+1 ) = ! land use type desert map to BELD3
     &           (/ 1,       ! shrubland
     &              1,       ! shrubland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3,       ! barrenland
     &              3 /)     ! ag landuse surrogate

            integer, parameter :: n_lucat_nlcd40 = 40   ! number of landuse categories
            type( lus_type ), parameter :: vnmlu_nlcd40( n_lucat_nlcd40 ) = (/
     &            lus_type( 'LUFRAC_01', 'Evergreen Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_02', 'Evergreen Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_03', 'Deciduous Needleleaf Forest       ' ),
     &            lus_type( 'LUFRAC_04', 'Deciduous Broadleaf Forest        ' ),
     &            lus_type( 'LUFRAC_05', 'Mixed Forests                     ' ),
     &            lus_type( 'LUFRAC_06', 'Closed Shrublands                 ' ),
     &            lus_type( 'LUFRAC_07', 'Open Shrublands                   ' ),
     &            lus_type( 'LUFRAC_08', 'Woody Savannas                    ' ),
     &            lus_type( 'LUFRAC_09', 'Savannas                          ' ),
     &            lus_type( 'LUFRAC_10', 'Grasslands                        ' ),
     &            lus_type( 'LUFRAC_11', 'Permanent Wetlands                ' ),
     &            lus_type( 'LUFRAC_12', 'Croplands                         ' ),
     &            lus_type( 'LUFRAC_13', 'Urban and Built Up                ' ),
     &            lus_type( 'LUFRAC_14', 'Cropland-Natural Vegetation Mosaic' ),
     &            lus_type( 'LUFRAC_15', 'Permanent Snow and Ice            ' ),
     &            lus_type( 'LUFRAC_16', 'Barren or Sparsely Vegetated      ' ),
     &            lus_type( 'LUFRAC_17', 'IGBP Water                        ' ),
     &            lus_type( 'LUFRAC_18', 'unclassified                      ' ),  ! ?
     &            lus_type( 'LUFRAC_19', 'fill value                        ' ),
     &            lus_type( 'LUFRAC_20', 'unclassified                      ' ),  ! ?
     &            lus_type( 'LUFRAC_21', 'Open Water                        ' ),
     &            lus_type( 'LUFRAC_22', 'Perennial Ice-Snow                ' ),
     &            lus_type( 'LUFRAC_23', 'Developed Open Space              ' ),  ! ?
     &            lus_type( 'LUFRAC_24', 'Developed Low Intensity           ' ),
     &            lus_type( 'LUFRAC_25', 'Developed Medium Intensity        ' ),
     &            lus_type( 'LUFRAC_26', 'Developed High Intensity          ' ),
     &            lus_type( 'LUFRAC_27', 'Barren Land (Rock-Sand-Clay)      ' ),
     &            lus_type( 'LUFRAC_28', 'Deciduous Forest                  ' ),
     &            lus_type( 'LUFRAC_29', 'Evergreen Forest                  ' ),
     &            lus_type( 'LUFRAC_30', 'Mixed Forest                      ' ),
     &            lus_type( 'LUFRAC_31', 'Dwarf Scrub                       ' ),
     &            lus_type( 'LUFRAC_32', 'Shrub-Scrub                       ' ),
     &            lus_type( 'LUFRAC_33', 'Grassland-Herbaceous              ' ),
     &            lus_type( 'LUFRAC_34', 'Sedge-Herbaceous                  ' ),
     &            lus_type( 'LUFRAC_35', 'Lichens                           ' ),
     &            lus_type( 'LUFRAC_36', 'Moss                              ' ),
     &            lus_type( 'LUFRAC_37', 'Pasture-Hay                       ' ),
     &            lus_type( 'LUFRAC_38', 'Cultivated Crops                  ' ),
     &            lus_type( 'LUFRAC_39', 'Woody Wetlands                    ' ),
     &            lus_type( 'LUFRAC_40', 'Emergent Herbaceous Wetlands      ' )  /)  ! ?

          end module lus_data_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C....................................................................
C  CONTAINS:  This module provides the interface to the Models3 IOAPI
C     using the M3UTILIO module.  For parallel implementation of CMAQ, 
C     several IOAPI routines are replaced with PARIO versions.  For
C     example, the IOAPI function WRITE3 is renamed to an unused 
C     function name "EXCLUDE_WRITE3", and the PARIO function PWRITE3
C     is aliased to WRITE3.  So when WRITE3 is used in CMAQ, then the
C     PARIO function PWRITE3 is accessed.  This approach allows
C     flexibility in naming within CMAQ and eliminated the usage of
C     "cpp" flags to achieve the function overloading.
C              
C  REVISION HISTORY:
C       Original version 03/2011 by Shawn Roselle
C                        08/2011 by David Wong
C                          -- extended to handle buffer file
C                        08/2015 by David Wong
C                          -- defined WRITE3 under parallel I/O
C                             implementation
C                        02/2019 by David Wong
C                          -- removed INTERPB declaration which is
C                             not needed with centralized I/O
C                             implementation
C....................................................................

      MODULE UTILIO_DEFN

#ifdef parallel

         USE M3UTILIO, EXCLUDE_INTERPB => INTERP3,
     &                 EXCLUDE_M3EXIT  => M3EXIT,
     &                 EXCLUDE_M3WARN  => M3WARN,
     &                 EXCLUDE_SHUT3   => SHUT3,
     &                 EXCLUDE_WRITE3  => WRITE3,
     &                 BUF_WRITE3      => WRITE3

         USE PARUTILIO, 
     &                  M3ERR   => PM3ERR,
     &                  M3EXIT  => PM3EXIT,
     &                  M3WARN  => PM3WARN,
#ifdef parallel_io
     &                  SHUT3   => PSHUT3

         LOGICAL, EXTERNAL :: WRITE3
#else
     &                  SHUT3   => PSHUT3,
     &                  WRITE3  => PWRITE3
#endif
#else
         USE M3UTILIO, INTERPB => INTERP3
#endif

      END MODULE UTILIO_DEFN

! Revision History:
!  2016/02/23 David Wong extracted the complex number module and put it in a file
!  2016/05/23 David Wong - replaced rrtmg_aero_optical_util_module with
!                          cmaq_rrtmg_aero_optical_util_module to avoid duplication 
!                          of the same module name on WRF side of the two-way model

MODULE cmaq_rrtmg_aero_optical_util_module


     Integer      :: AERO_UTIL_LOG = 0 
private
public :: aero_optical, aero_optical2, aero_optical_CS, AERO_UTIL_LOG

interface ghintBH 
  module procedure ghintBH_1, ghintBH_2, ghintBH_Odd
end interface

interface ghintBH_CS
  module procedure ghintBH_CS_even, ghintBH_CS_odd
end interface

      Logical, Parameter :: Use_Odd_Quadrature = .True.
       Integer, Parameter :: Quadrature_Points = 3
!      Integer, Parameter :: Quadrature_Points = 1
      
!B.Hutzell One point quadature IGH = 1

       real, parameter :: ghxi_1(1) = 0.00000000000
       real, parameter :: ghwi_1(1) = 1.77245385091
       
!B.Hutzell Three point quadature IGH = 3
       real, parameter :: ghxi_3(3) = (/ -1.22474487139,   &
                                          0.00000000000,   &
                                          1.22474487139 /)

       real, parameter :: ghwi_3(3) = (/ 0.295408975151,   &
                                         1.181635900000,   &
                                         0.295408975151 /)
                                         
!B.Hutzell Five point quadature IGH = 5
       real(8), parameter :: ghxi_5(5) = (/ -2.02018287046d0,  &
                                            -0.958572464614d0, & 
                                             0.00000000000d0,  &
                                             0.958572464614d0, &
                                             2.02018287046d0 /)

       real(8), parameter :: ghwi_5(5) = (/ 0.019953242059d0,   &
                                            0.393619323152d0,   &
                                            0.945308720483d0,   &
                                            0.393619323152d0,   &
                                            0.019953242059d0 /)

                                         

!B.Hutzell Nine point quadature IGH = 9 points
!No.  Abscissas  Weight  Total Weight  
       real, parameter :: ghxi_9(9) = (/ -3.19099320178,  &  
                                         -2.26658058453,  &  
                                         -1.46855328922,  &  
                                         -0.72355101875,  & 
                                          0.00000000000,  &  
                                          0.72355101875,  & 
                                          1.46855328922,  &  
                                          2.26658058453,  &   
                                          3.19099320178 /)  

       real, parameter :: ghwi_9(9) = (/ 3.96069772633E-5, &
                                         0.00494362428,    &
                                         0.08847452739,    &
                                         0.43265155900,    &
                                         0.72023521561,    &
                                         0.43265155900,    &
                                         0.08847452739,    &
                                         0.004943624275,   &
                                         3.96069772633E-5 /)



contains

! ------------------------------------------------------------------
       subroutine getqext_BH (xx, crefin, qextalf, qscatalf, gscatalfg,SUCCESS)
       implicit none

       real, intent(in)     :: XX 
       real, intent(out)    :: qextalf, qscatalf, gscatalfg
       complex, intent(in)  :: CREFIN
       logical, intent(out) :: success
!local        
       real( 8 ), parameter  :: one_third = 1.0d0 / 3.0d0
       integer              :: NXX
       integer              :: nstop, modulus

       real :: QEXT, QSCA, QBACK, G_MIE, xx1
       
       real( 8 )    :: x
       complex( 8 ) :: refractive_index
       
       x = real( XX, 8 )
       refractive_index = dcmplx( real( CREFIN ), imag( CREFIN ) )
       
       modulus = int( abs( x * refractive_index ) )      
       nstop = int( x + 4.0d0 * x**one_third + 2.0d0 )
       
       nxx = max( modulus, nstop ) + 15
       
       xx1 = 1.0 / XX
       
!       CALL BHMIE (XX,CREFIN,QEXT,QSCA,QBACK,G_MIE, SUCCESS)
        CALL BHMIE_FLEXI (XX, NXX, NSTOP, CREFIN,QEXT,QSCA,QBACK,G_MIE, SUCCESS)

       qextalf   = QEXT * xx1
       qscatalf  = QSCA * xx1
       gscatalfg = qscatalf * G_MIE

       end subroutine getqext_bh

! ------------------------------------------------------------------
       SUBROUTINE BHMIE (X, REFREL, QQEXT, QQSCA, QBACK, GSCA, SUCCESS)

! FSB Changed the call vector to return only QEXT, QSCAT QBACK GSCA
!     and ignore NANG, S1 and S2 and all calculations for them

       implicit none 

! Arguments:
       real, intent(in)    :: X        ! X = pi*particle_diameter / Wavelength
       complex, intent(in) :: REFREL

!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    in the current use the index of refraction of the the medium
!    i taken at 1.0 real.
!
!    Output

       real,    intent(out) :: QQEXT, QQSCA, QBACK, GSCA
       logical, intent(out) :: SUCCESS

!     QQEXT   Efficiency factor for extinction
!     QQSCA   Efficiency factor for scattering
!     QQBACK  Efficiency factor for back scatter
!     GSCA    asymmetry factor <cos>
!     SUCCESS flag for successful calculation
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
! FSB
!    This code was originally listed in Appendix A. pp 477-482.
!    As noted below, the original code was subsequently 
!    modified by Prof. Bruce T. Drain of Princetion University.
!    The code was further modified for a specific application
!    in a large three-dimensional code requiring as much 
!    computational efficiency as possible. 
!    Prof. Francis S. Binkowski of The University of North
!    Carolina at Chapel Hill. 

! Declare parameters:
! Note: important that MXNANG be consistent with dimension of S1 and S2
!       in calling routine!

       integer, parameter :: MXNANG=10, NMXX=600000   ! FSB new limits
       real*8, parameter  :: PII = 3.1415916536D0
       real*8, parameter  :: ONE = 1.0D0, TWO = 2.0D0

! Local variables:
       integer    :: NANG
       integer    :: N,NSTOP,NMX,NN
       real*8     :: QSCA, QEXT, DX1, DXX1      
       real*8     :: CHI,CHI0,CHI1,DX,EN,P,PSI,PSI0,PSI1,XSTOP,YMOD               
       real*8     :: TWO_N_M_ONE, TWO_N_P_ONE, EN1, FACTOR
       complex*16 :: AN,AN1,BN,BN1,DREFRL,XI,XI1,Y, Y1, DREFRL1
       complex*16 :: D(NMXX), FAC1, FAC2
       complex*16   :: XBACK

!***********************************************************************
! Subroutine BHMIE is the Bohren-Huffman Mie scattering subroutine
!    to calculate scattering and absorption by a homogenous isotropic
!    sphere.
! Given:
!    X = 2*pi*a/lambda
!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    real refractive index of medium taken as 1.0 
! Returns:
!    QEXT  = efficiency factor for extinction
!    QSCA  = efficiency factor for scattering
!    QBACK = efficiency factor for backscatter
!            see Bohren & Huffman 1983 p. 122
!    GSCA = <cos> asymmetry for scattering
!
! Original program taken from Bohren and Huffman (1983), Appendix A
! Modified by Prof. Bruce T.Draine, Princeton Univ. Obs., 90/10/26
! in order to compute <cos(theta)>
! 91/05/07 (BTD): Modified to allow NANG=1
! 91/08/15 (BTD): Corrected error (failure to initialize P)
! 91/08/15 (BTD): Modified to enhance vectorizability.
! 91/08/15 (BTD): Modified to make NANG=2 if called with NANG=1
! 91/08/15 (BTD): Changed definition of QBACK.
! 92/01/08 (BTD): Converted to full double precision and double complex
!                 eliminated 2 unneed lines of code
!                 eliminated redundant variables (e.g. APSI,APSI0)
!                 renamed RN -> EN = double precision N
!                 Note that DOUBLE COMPLEX and DCMPLX are not part
!                 of f77 standard, so this version may not be fully
!                 portable.  In event that portable version is
!                 needed, use src/bhmie_f77.f
! 93/06/01 (BTD): Changed AMAX1 to generic function MAX
! FSB April 09,2012 This code was modified by: 
! Prof.  Francis S. Binkowski University of North Carolina at
! Chapel Hill, Institue for the Environment.
!
! The modifications were made to enhance computation speed 
! for use in a three-dimensional code. This was done by
! removing code that calculated angular scattering. The method
! of calculating QEXT, QBACK was also changed. 
 
!***********************************************************************
!*** Safety checks

       SUCCESS = .TRUE.
       NANG = 2 ! FSB only this value 
! IF(NANG.GT.MXNANG)STOP'***Error: NANG > MXNANG in bhmie'
!      IF (NANG .LT. 2) NANG = 2

       DX = REAL( X, 8 )
! FSB Define reciprocals so that divisions can be replaced by multiplications.      
       DX1  = ONE / DX
       DXX1 = DX1 * DX1
       DREFRL = DCMPLX( REFREL ) 
       DREFRL1 = ONE / DREFRL
       Y = DX * DREFRL
       Y1 = ONE / Y
       YMOD = ABS(Y)
 
!*** Series expansion terminated after NSTOP terms
!    Logarithmic derivatives calculated from NMX on down
       XSTOP = REAL( X + 4.0 * X**0.3333 + 2.0, 8)
       NMX  = INT( MAX(XSTOP,YMOD) ) + 15

! BTD experiment 91/1/15: add one more term to series and compare results
!      NMX=AMAX1(XSTOP,YMOD)+16
! test: compute 7001 wavelengths between .0001 and 1000 micron
! for a=1.0micron SiC grain.  When NMX increased by 1, only a single
! computed number changed (out of 4*7001) and it only changed by 1/8387
! conclusion: we are indeed retaining enough terms in series!
       NSTOP = INT( XSTOP )
       FACTOR = 1.0D0
 
       IF (NMX .GT. NMXX) THEN
          WRITE(6,*)'Error: NMX > NMXX=',NMXX,' for |m|x=',YMOD
          SUCCESS = .FALSE.
          RETURN
       END IF

! FSB all code relating to scattering angles is removed out for
!     reasons of efficiency when running in a three-dimensional 
!     code. We only need QQSCA, QQEXT, GSCA AND QBACK

 
!*** Logarithmic derivative D(J) calculated by downward recurrence
!    beginning with initial value (0.,0.) 
 
       D(NMX) = DCMPLX(0.0D0,0.0D0)
       NN = NMX - 1
       DO N = 1,NN
          EN  = REAL(NMX - N + 1, 8 )
! FSB In the following division by Y has been replaced by 
!     multiplication by Y1, the reciprocal of Y.          
          D(NMX-N) = ( EN * Y1 ) - (ONE / ( D(NMX-N+1) + EN * Y1)) 
       END DO
 
!*** Riccati-Bessel functions with real argument X
!    calculated by upward recurrence
 
       PSI0 =  COS(DX)
       PSI1 =  SIN(DX)
       CHI0 = -SIN(DX)
       CHI1 =  PSI0
       XI1  =  DCMPLX(PSI1,-CHI1)
       QSCA =  0.0D0
       GSCA =  0.0D0
       QEXT =  0.0D0
       P    = -ONE
       XBACK = (0.0d0,0.0d0)

! FSB Start main loop       
       DO N = 1,NSTOP
          EN        = REAL( N, 8)
          EN1       = ONE / EN
          TWO_N_M_ONE = TWO * EN - ONE
! for given N, PSI  = psi_n        CHI  = chi_n
!              PSI1 = psi_{n-1}    CHI1 = chi_{n-1}
!              PSI0 = psi_{n-2}    CHI0 = chi_{n-2}
! Calculate psi_n and chi_n
          PSI = TWO_N_M_ONE * PSI1 * DX1 - PSI0
          CHI = TWO_N_M_ONE * CHI1 * DX1 - CHI0
          XI  = DCMPLX(PSI,-CHI)
 
!*** Compute AN and BN:
! FSB Rearrange to get common terms
          FAC1 = D(N) * DREFRL1 + EN * DX1 
          AN   = (FAC1) * PSI - PSI1
          AN   = AN / ( (FAC1 )* XI - XI1 )
          FAC2 = ( DREFRL * D(N) + EN * DX1)
          BN   = ( FAC2) * PSI -PSI1
          BN   = BN / ((FAC2) * XI - XI1 )

! FSB calculate sum for QEXT as done by Wiscombe
!     get common factor
          TWO_N_P_ONE = (TWO * EN + ONE)
          QEXT = QEXT + (TWO_N_P_ONE) * (REAL(AN) + REAL(BN) ) 
          QSCA = QSCA + (TWO_N_P_ONE) * ( ABS(AN)**2+ ABS(BN)**2 )
          
! FSB calculate XBACK from B & H Page 122          
          FACTOR = -1.0d0 * FACTOR  ! calculate (-1.0 ** N)
          XBACK = XBACK + (TWO_N_P_ONE) * factor * (AN - BN)
          
! FSB calculate asymmetry factor   
           GSCA = GSCA + REAL( ((TWO_N_P_ONE)/(EN * (EN + ONE))) *     &
                 (REAL(AN)*REAL(BN)+IMAG(AN)*IMAG(BN)))

          IF (N .GT. 1)THEN
             GSCA = GSCA + REAL( (EN - EN1) *                         &
                    (REAL(AN1)*REAL(AN) + IMAG(AN1)*IMAG(AN) +  &
                     REAL(BN1)*REAL(BN) + IMAG(BN1)*IMAG(BN)))
          ENDIF

!*** Store previous values of AN and BN for use in computation of g=<cos(theta)>
          AN1 = AN
          BN1 = BN

! FSB set up for next iteration
          PSI0 = PSI1
          PSI1 = PSI
          CHI0 = CHI1
          CHI1 = CHI
          XI1  = DCMPLX(PSI1,-CHI1)

       END DO   ! main  loop on n
 
!*** Have summed sufficient terms.

!    Now compute QQSCA,QQEXT,QBACK,and GSCA
       GSCA  = REAL( TWO / QSCA )  * GSCA

! FSB in the following, divisions by DX * DX has been replaced by
!      multiplication by DXX1 the reciprocal of 1.0 / (DX *DX)           
       QQSCA = REAL( TWO * QSCA * DXX1 )
       QQEXT = REAL( TWO * QEXT * DXX1 ) 
       QBACK = REAL( REAL ( 0.5d0 * XBACK * CONJG(XBACK), 8 ) * DXX1 )  ! B&H Page 122

       END subroutine BHMIE

! ------------------------------------------------------------------
       subroutine aero_optical ( lamda_in, nmode, nr, ni, Vol,   &
                                 dgn, sig, bext, bscat, g_bar,   &
                                 modulus, success )
     
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

      IMPLICIT NONE
! *** input variables
      real, intent(in)    :: lamda_in               ! wavelengths  [micro-m]
      INTEGER, intent(in) :: nmode                  ! number of lognormal modes
      real, intent(in)    :: nr( nmode), ni(nmode)  ! real and imaginary 
                                                    ! refractive indices
      real, intent(in)    :: Vol(nmode)             ! modal aerosol volumes [m**3 /m**3]
      real, intent(in)    :: dgn(nmode)             ! geometric mean diameters 
                                                    ! for number distribution [ m]
      real, intent(in)    :: sig(nmode)             ! geometric standard deviation 

      real, intent(in), optional :: modulus(nmode)  ! modulus of refracive index                          
      
! *** output variables 
      real, intent(out)    :: bext    ! extinction coefficient [ 1 / m ]
      real, intent(out)    :: bscat   ! scattering coefficient [ 1 / m ]
      real, intent(out)    :: g_bar   ! assymetry factor for Mie and molecular scattering
      logical, intent(out) :: success ! flag for successful calculation
! *** internal variables
      INTEGER  :: j             ! loop index
!     real     :: xlnsig(nmode) ! natural log of geometric standard deviations      
      real     :: beta_Sc, bsc  !aerosol scattering coefficient 
 
      real     :: beta_Ex       ! aerosol extinction coefficients       
      real     :: G             ! modal aerosol assymetry factors
      real     :: sum_g
      real     :: LSIGX
      real     :: lamdam1       ! 1/ lamda
      real     :: alphav        ! Mie size parameter
      real     :: vfac
      real     :: modalph

      real, parameter :: pi = 3.14159265359

       Logical, Save :: Initialize = .True.
       
! *** coded 09/08/2004 by Dr. Francis S. Binkowski
! FSB Modified for RRTMG version December 2009.
! FSB modified 10/06/2004, 10/12/2004, 10/18/2005
! FSB 01/12/2006
!     Formerly Carolina Environmental Program
! FSB now the Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu


! *** initialize variables
       lamdam1 = 1.0e6 / lamda_in   ! lamda now in [ m ]
       bext    = 0.0
       bscat   = 0.0
       sum_g   = 0.0
        
!      write(30,*) ' inside aero_optical', ' lamda = ', lamda
      
       DO j = 1, nmode
!    calculate the extinction and scattering coefficients
!    for each mode 
!         write(20,*) ' j = ', j
          LSIGX = log(sig(j))

!         write(30,*) 'j = ', j
!         write(30,*) 'VLX = ', Vol(j)
!         write(30,*) 'DGX = ', dgn(j)
!         write(30,*) 'SIGX = ', sig(j)
!         write(30,*) 'NRX =', nr(j)
!         write(30,*) 'NIX = ', ni(j)
!         write(30,*) 'LSIGX = ', LSIGX
       
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
          alphav =  pi * dgn(j) * exp(3.0 * LSIGX * LSIGX) * lamdam1

          if (present(modulus)) then
             modalph = alphav * modulus(j)   
          end if

!         Write(30,*) ' alphav = ', alphav
       
!         write(20,*) j, alphav, modalph, modulus(j)
!         write(20,*) j, alphav, modalph, nr(j), ni(j)
      
 
          CALL ghintBH (nr(j), ni(j), alphav, LSIGX, beta_EX, beta_Sc, G, success)            

!         write(30,*) 'after Call to ghintBH ',' j = ', j 
!         write(30,*) ' beta_EX =', beta_EX
!         write(30,*) ' beta_SC = ', beta_Sc
!         write(30,*) ' G = ', G

! *** ghintBH returns the normalized values
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength
         
         
          vfac  =  Vol(j) * lamdam1 

!         write(20,*)' vfac = ', vfac
!         write(20,*)' G = ', G
!         write(20,*) ' beta_Ex = ', beta_Ex
!         write(20,*) ' beta_Sc = ', beta_Sc
        
! *** sum to get total extinction and scattering 
!     and contribution to the overal assymetry factor

          bext    = bext  + vfac * beta_Ex  ! [ 1 / m ]
          bsc     = vfac * beta_Sc
          bscat   = bscat + bsc          
          sum_g   = sum_g + bsc * G

       END DO  ! loop on modes  
       
! *** calculate combined assymetry factor for all modes  

       g_bar = sum_g / bscat ! changed to divide by bscat

!      write(30,*) ' inside aero_optical after loop '       
!      write(30,*) ' g_bar = ', g_bar
!      write(20,*) ' bext = ', bext
!      write(20,*) ' bscat = ', bscat
!      write(20,*) ' gbar = ', g_bar 
      
       END SUBROUTINE aero_optical

! ------------------------------------------------------------------
       subroutine ghintBH_1 (nr, ni, alfv, xlnsig, Qext_GH, Qscat_GH, g_gh, success) 

! FSB *********** This is the newest (05_30_2012) version of GhintBH
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
! FSB Calls Penndorf codes for alfv .le.  0.3 

!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
 
       implicit none

       real, intent(in)     :: nr, ni     ! refractive indices
       real, intent(in)     :: alfv       ! Mie parameter for dgv
       real, intent(in)     :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)    :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)    :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)    :: g_GH       ! asymmetry factor <cos>
       logical, intent(out) :: success    ! flag for successful calculation
      
       real    :: bext_P, bscat_P, babs_P, g_PCS, xlnsg2  ! see below for definition
      
       real    :: aa1                ! see below for definition
       real    :: alfaip, alfaim     ! Mie parameters at abscissas
     
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor
       integer :: IGH                ! index for GH quadrature      

! FSB define parameters 
       real, parameter :: pi = 3.14159265
       real, parameter :: sqrtpi = 1.772454 
       real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
       real, parameter :: sqrt2 = 1.414214 
       real, parameter :: three_pi_two = 3.0 * pi / 2.0 
       real, parameter :: const = three_pi_two * sqrtpi1 
      
       integer :: i
       complex :: crefin                  ! complex index of refraction      
       real    :: sum_e,sum_s, xi,wxi,xf
       real    :: sum_sg

! Gauss-Hermite abscissas and weights
! *** the following weights and abscissas are from Abramowitz
!     Stegun, Table 25.10 page 924 
! FSB full precision from Table 25.10 

! FSB ten-point  - IGH = 5
       real, parameter :: ghxi_10(5) = (/ 0.342901327223705,     &
                                          1.036610829789514,     &
                                          1.756683649299882,     &
                                          2.532731674232790,     &
                                          3.436159118837738 /)

       real, parameter :: ghwi_10(5) = (/ 6.108626337353e-01,    &
                                          2.401386110823e-01,    &
                                          3.387439445548e-02,    &
                                          1.343645746781e-03,    &
                                          7.640432855233e-06 /)

! FSB six-point - IGH = 3
       real, parameter :: ghxi_6(3) = (/ 0.436077411927617,      &
                                         1.335849074013597,      &
                                         2.350604973674492 /)

       real, parameter :: ghwi_6(3) = (/ 7.246295952244e-01,     &
                                         1.570673203229e-01,     &
                                         4.530009905509e-03 /)

! FSB two-point - IGH = 1
       real, parameter :: ghxi_2(1) = (/ 0.707106781186548 /)

       real, parameter :: ghwi_2(1) = (/ 8.862269254528e-01 /)

       real    :: GHXI(5), GHWI(5) ! weight and abscissas
       integer :: NMAX             ! number of weights and abscissa

! FSB Check for valid range of Penndorf application.     
       if ( alfv .le. 0.3) then
          xlnsg2 = xlnsig*xlnsig
          call pennfsb (nr,ni,alfv,xlnsg2,bext_P,bscat_P,babs_P,g_PCS)
          Qext_GH  = bext_P
          Qscat_GH = bscat_p
          g_GH     = g_PCS * exp(4.0 * xlnsg2) ! match GH integral            
       else

! FSB We need to do a full Mie calculation now 
!     Choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.

          IGH=3 ! default value; six_point is sufficient generally
! six point
          NMAX = 3

          if (nr .ge. 1.7) then 
! 10 point     
             IGH = 5 ! more points needed here
             NMAX = 5
          end if

          if ( alfv .gt. 20.0 .or. alfv .lt. 0.5 ) then
             IGH  = 1 ! in  this range fewer points are needed
             NMAX = 1
          end if

          if (IGH == 1) then
             GHXI(1)    = ghxi_2(1)
             GHWI(1)    = ghwi_2(1)
          else if (IGH == 3) then
             do i = 1, NMAX
                GHXI(i) = ghxi_6(i)
                GHWI(i) = ghwi_6(i)
             end do 
          else
             do i = 1,NMAX
                GHXI(i) = ghxi_10(i)
                GHWI(i) = ghwi_10(i)
             end do  
          end if ! set up number of abscissas and weights 
 
! FSB set  complex refractive index.      
          crefin= cmplx(nr,ni)      

! FSB now start the integration code
          aa1 = sqrt2 * xlnsig   ! This 1.0 / Sqrt( A ) in derivation of the integral
                                 ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 
          sum_e  = 0.0
          sum_s  = 0.0
          sum_sg = 0.0
! FSB do NMAX calls to the MIE codes
          do i = 1,NMAX
             xi      = GHXI(i)
             wxi     = GHWI(i)
             xf      = exp( xi * aa1 )
             alfaip  = alfv * xf
             alfaim  = alfv / xf ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

             call getqext_BH (alfaip, crefin, qalfip_e, qalfip_s, gsalfp, success)
             call getqext_BH (alfaim, crefin, qalfim_e, qalfim_s, gsalfm, success)

             sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
             sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
             sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 
          end do 

          g_GH     = sum_sg / sum_s ! this is <cos>
          Qext_GH  = const * sum_e  ! 
          Qscat_GH = const * sum_s  
       end if

       end subroutine ghintBH_1

! ------------------------------------------------------------------
       subroutine pennfsb (n, k, xx, lnsg2, bext, bscat, babs, g)

! FSB a new version of Penndorf's equations. This version does 
!     analytical integration for Qext, Qscat, Qabs to generate
!     bext, bscat, babs. Note that the expressions for Qext & Qscat
!     hve been divide through by xx.
!
!     Reference:
!     Caldas, M., V. Semiao, 2001, Radiative properties of small
!                     particles: and extension of the Penndorff Model. Journal 
!                     of the Optical Society of America A, Vol. 18, No. 4, 
!                     pp 831-838.  

!       Penndorf, R., 1962a,Scattering and extinction coefficients for small
!                     absorbing and nonabsorbing aerosols,
!                     J. Optical Society of America, 52, 896-904.

!       Penndorf, P., 1962b,Scattering and extinction coefficients for 
!                     small Spherical aerosols, J. Atmos. Sci., 19, p 193

! FSB Coded by Dr. Francis S. Binkowski on October 25, 2011 by combining
!     two previous versions to get a common code for the Penndorf and
!     and Caldas & Semiao approaches. The Penndorf Qext, Qscat are much
!     better than the versions from Caldas & Semiao despite claims to
!     the contrary. The values of the asymmetry factor from Caldas & Semiao 
!     are better than can be obtained from Penndorf. 

! FSB This version does the analytical integral ove a lognormal 
!     size distribution.

       implicit none 
!     input variables
       real, intent(in)  :: n, k     ! refractive index
       real, intent(in)  :: xx       ! pi * diameter / wavelength
       real, intent(in)  :: lnsg2    ! log(sigma_g)**2       
       real, intent(out) :: bext     ! extinction coefficient
       real, intent(out) :: bscat    ! scattering coefficient
       real, intent(out) :: babs     ! absorption coefficient
       real, intent(out) :: g        ! asmmetry factor

!     internal variables
       complex*16  :: m, m2,m4,m6,m21,m22 
       complex*16  :: P,Q,R,S,T,U,V,W
       complex*16  :: Qprime, Rprime,Sprime,Tprime
       complex*16  :: Uprime, Vprime, Wprime
       real*8      :: Qs, gQs, gpennCS
       real*8      :: P1,P2, Q1, Q2 , S2,V1, V2 ! see usage
       real*8      :: P1SQ, P2SQ  ! see usage
       real*8      :: y, y2, y3, y4, y6, y7,  y8, y9       
       real*8      :: x, x2, x3, x4, x6, x7,  x8, x9 
       real        :: mag, modalf
! FSB define useful numbers and fractions 
       real, parameter :: pi = 3.14159265358979324d0 
       real, parameter :: three_pi_two = 1.5d0 * pi

       real*8, parameter :: one = 1.0d0
       real*8, parameter :: two = 2.0d0
       real*8, parameter :: three = 3.0d0
       real*8, parameter :: four = 4.0d0
       real*8, parameter :: five = 5.0d0
       real*8, parameter :: six = 6.0d0
       real*8, parameter :: eight = 8.0d0
       real*8, parameter :: nine = 9.0d0
       real*8, parameter :: fifteen = 15.0d0
       real*8, parameter :: fortyfive = 45.0d0
!      real*8, parameter :: two5ths = two / five
       real*8, parameter :: twothrds = two / three
       real*8, parameter :: fourthirds = four / three
       real*8, parameter :: onefifteenth = one / fifteen
       real*8, parameter :: twofifteenths = two * onefifteenth
!      real*8, parameter :: fourninths = four / nine
       real*8, parameter :: eightthirds = two * fourthirds
       real*8, parameter :: one_big = one / 31500.0d0
       real*8, parameter :: two_fortyfive = two / fortyfive
       real*8, parameter :: four_225 = four / 225.0d0 
       real*8, parameter :: one_210 = one / 210.0d0
!      real*8, parameter :: one_half = one / two 
!      real*8, parameter :: four_two = two
       real*8, parameter :: nine_two = 4.5d0
!      real*8, parameter :: sixteen_two = eight
!      real*8, parameter :: thirtysix_two = 36.0 / two
!      real*8, parameter :: twentyfive_two = 25.0d0 / two
!      real*8, parameter :: sixtyfour_two = 64.0d0 / two
!      real*8, parameter :: fortynine_two = 49.0d0 / two
!      real*8, parameter :: eightyone_two = 81.0d0 / two
       real*8            :: A,B,C,D,E, AA,BB,CC

! FSB start code
       mag = sqrt( n * n + k * k )
       modalf = mag * xx
       y  = REAL( xx, 8 ) ! convert to real*8
! FSB get powers of y        
       y2 = y * y
       y3 = y2 * y
       y4 = y3 * y
       y6 = y3 * y3
       y7 = y3 * y4
       y8 = y4 * y4
       y9 = y6 * y3 

! FSB Calculate integrals ove the lognormal distribution
!     this is done term by term and the form is
!     xn = yn * exp( (n**2) * lnsig2 /2.0d0)

       x  = y 
       x2 = y2 * exp( two              * lnsg2)
       x3 = y3 * exp( nine_two         * lnsg2)
       x4 = y4 ! * exp( eight            * lnsg2)      
       x6 = y6 ! * exp( thirtysix_two    * lnsg2)
       x7 = y7 ! * exp( fortynine_two    * lnsg2)
       x8 = y8 ! * exp( fortynine_two    * lnsg2)
       x9 = y9 ! * exp( eightyone_two    * lnsg2)

        
! FSB explicitly calculate complex refrative index m        
       m = dcmplx(n,-k)
! FSB get powers and functions of m        
       m2 = m * m
       m4 = m2 * m2
       m6 = m2 * m4
       m21 = m2 - one
       m22 = m2 + two

! FSB calculate Penndorf's definitions from Table II of Penndorf (1962a)        
       P = m21 / m22
       Q = (m2 - two ) / m22
       S = m21 / ( two * m2 + three)
       V = m21
! FSB get real & imaginary parts following Penndorf's mptation        
       P1 = real(P)
       P2 = -aimag(P)
       P1SQ = P1 * P1
       P2SQ = P2 * P2

       Q1 = real(Q)
       Q2 = -aimag(Q)
       S2 = -aimag(S)
       V1 = real(V)
       v2 = -aimag(V)


! FSB Get bext from Penndorf (1962a) Equation (7) up to x4 
!     consistent with equation (8)
!     We have then divided through by x and integrated analytically
       bext = REAL( four * P2 + ( 2.4d0 * (P1 * Q2 + P2 * Q1 ) +  twothrds * S2          &
            + twofifteenths * V2 ) * x2 + ( eightthirds * ( P1SQ - P2SQ ) ) * x3, 4 )

! FSB get bscat from Penndorf Equation (9) up to x4 
!     we have divided through by x and integrated analytically
       bscat = REAL( eightthirds * ( P1SQ + P2SQ ) * x3 )
! FSB calculate babs
!      babs = bext - bscat

! FSB now get asymmetry factor from Caldas & Semiao (2001)      
!    
! *** The following additional variables from Caldas & Semiao (2001)
!     are defined in Equations 10a to 10h.

       R = (m6 + 20.0d0*m4 -200.0d0*m2 + 200.0d0) / m22**2
       T = m21 / ( ( 2.0d0 * M2 + 3.0d0) **2 )
       U = m21 / (3.0d0 * M2 + 4.0d0 )
       W = m21 * ( 2.0d0 * m2 - 5.0d0)

! *** further definitions from Caldas & Semiao (2001)      
       Qprime = Q
       Rprime = 18.0d0 * R
       Sprime = 5.0d0 * S / P
       Tprime = 375.0d0 * T / P
!      Uprime = 28.0d0 * U / P
       Vprime = V / P
       Wprime = 5.0d0 * W / P

! FSB calculate gQs and Qs from Caldas & Semiao (2001)
! *** calculate Qs equation 13
!      Qs = eightthirds * abs(P)**2                                        &
!           * (x4 + onefifteenth * real(Qprime) * x6                       &
!           + fourthirds * aimag(P) * x7                                   &
!           + one_big * ( 35.0d0 * abs(Qprime)**2                          &
!           + 20.0d0 * real(Rprime) + 35.0d0 * abs(Vprime)**2              &
!           + 21.0d0 * abs(Sprime)**2 ) * x8                               &
!           + two_fortyfive * aimag( Qprime * ( P - conjg(P) )) * x9 ) 

! *** calculate gQs equation 15
      
!      gQs = four_225 * abs(P)**2 * (                                      &
!              (5.0d0 * Real(Vprime) + 3.0d0 * real(Sprime) ) * x6         &
!             + one_210 * ( 35.0d0 * real(Vprime*conjg(Qprime) )           &
!             + 21.0d0 * real(Sprime * conjg(Qprime) )                     &
!             + 10.0d0 * real(Wprime)- 6.0d0 * real(Tprime) ) * x8         &
!             - twothrds * ( 5.0d0 * aimag(Vprime * conjg(P) )             &
!             + 3.0d0 * aimag(Sprime * conjg(P) ) ) * x9    )

! FSB recast into specific terms 
       A = 1.0D0 * x4
       B = onefifteenth * real(Qprime) * x6 
       C = fourthirds * aimag(P) * x7
       D = one_big * ( 35.0d0 * abs(Qprime)**2                             &
           + 20.0d0 * real(Rprime) + 35.0d0 * abs(Vprime)**2               &
           + 21.0d0 * abs(Sprime)**2 ) * x8     
       E = two_fortyfive * aimag( Qprime * ( P - conjg(P) )) * x9   
       
       Qs = eightthirds * abs(P)**2 *( A + B + C + D + E )
       
       AA = (5.0d0 * Real(Vprime) + 3.0d0 * real(Sprime) ) * x6 
       BB = one_210 * ( 35.0d0 * real(Vprime*conjg(Qprime) )               &
            + 21.0d0 * real(Sprime * conjg(Qprime) )                       &
            + 10.0d0 * real(Wprime)- 6.0d0 * real(Tprime) ) * x8         
       CC = twothrds * ( 5.0d0 * aimag(Vprime * conjg(P) )                 &
            + 3.0d0 * aimag(Sprime * conjg(P) ) ) * x9    

       gQs = four_225 * abs(P)**2 * ( AA + BB + CC )
      
! FSB calculate asymmetry factor and adjust with empirical term.      
       g = REAL(gQs / Qs)
!  FSB now multiply by three_pi_two  get output  values        
       bext  = three_pi_two * bext  
       bscat = three_pi_two * bscat 
! FSB calculate babs
       babs = bext - bscat
        
       end subroutine pennfsb
        
! ------------------------------------------------------------------
       subroutine aero_optical2( lamda_in, crefin, Vol, dgn, &
                                 sig, bext, bscat, gfac, success )

! FSB NOTE: this subroutine calculates for single mode     
     
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

      IMPLICIT NONE

! *** input variables
      real, intent(in)    :: lamda_in   ! wavelengths  [micro-m]
      complex, intent(in) :: crefin     ! Complex refractive index 
      real, intent(in)    :: Vol        ! modal aerosol volumes [m**3 /m**3]
      real, intent(in)    :: dgn        ! geometric mean diameters 
                                        ! for number distribution [ m]
      real, intent(in)    :: sig        ! geometric standard deviation 
      
! *** output variables 
      real, intent(out)    :: bext         ! extinction coefficient [ 1 / m ]
      real, intent(out)    :: bscat        ! scattering coefficient [ 1 / m ]
      real, intent(out)    :: gfac         ! assymetry factor for Mie and molecular scattering
      logical, intent(out) :: success      ! flag for successful calculation

      
      
! *** internal variables
!     real :: xlnsig(nmode) ! natural log of geometric standard deviations      
      real :: beta_Sc       ! aerosol scattering coefficient 
 
      real :: beta_Ex       ! aerosol extinction coefficients       
      real :: G             ! modal aerosol assymetry factors
      real :: sum_g
      real :: LSIGX
      real :: lamdam1       ! 1/ lamda
      real :: alphav        ! Mie size parameter
      real :: vfac
      real, parameter :: pi = 3.14159265359

       Logical, Save :: Initialize = .True.
      
       
! FSB coded 04/15/2012 by Dr. Francis S. Binkowski
!     modified from an earlier version
!     Center for Environmental Modeling for PolicyDevelopment
!     Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu

! *** initialize variables
       lamdam1 = 1.0e6 / lamda_in ! lamda now in [ m ]
       bext  = 0.0
       bscat = 0.0
       sum_g = 0.0
!      write(20,*) ' j = ', j
       LSIGX = log(sig)
       
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
       alphav =  pi * dgn * exp(3.0 * LSIGX * LSIGX) * lamdam1
       
!      write(20,*) j, alphav, modalph, modulus(j)
!      write(20,*) j, alphav, modalph, NRX, NIX

       If(Initialize .And. AERO_UTIL_LOG .GT. 0 )Then
          If( Use_Odd_Quadrature )then
              write(AERO_UTIL_LOG,99501)Quadrature_Points
          else
              write(AERO_UTIL_LOG,99504)
              Initialize = .False.
          End If
       End If

       If( Use_Odd_Quadrature )then
           CALL ghintBH (Initialize, crefin, alphav, LSIGX, beta_EX, beta_Sc, G, success)
       Else
           CALL ghintBH (crefin, alphav, LSIGX, beta_EX, beta_Sc, G, success)
       End If
       

! *** ghintBH returns the normalized values
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength
         
         
       vfac  =  Vol * lamdam1         
       bext    = vfac * beta_Ex  ! [ 1 / m ]
       bscat   = vfac * beta_Sc  ! [ 1 / m ]
       gfac    = G
99501  Format(I2,' Quadrature Points for Volume Averaged Aerosol Optics')
99504  Format('Even Number Quadrature Points for Volume Averaged Aerosol Optics')
       
       END SUBROUTINE aero_optical2

! ------------------------------------------------------------------
       subroutine aero_optical_CS ( lamda_in, refcor,refshell, VOLCOR,   &
                                    VOLSHELL, DGNCOR, DGNSHELL, SIG,     &
                                    bext, bscat, gfac, succesS )
     
! FSB NOTE: values for one mode are returend      
! *** calculate the extinction and scattering coefficients and
!     assymetry factors for each wavelength as a sum over the 
!     individual lognormal modes. Each mode may have a different 
!     set of refractive indices.

       IMPLICIT NONE
! *** input variables
       real,intent(in)    :: lamda_in   ! wavelengths  [micro-m]                      
       complex,intent(in) :: refcor     ! Complex refractive index -core
       complex,intent(in) :: refshell   ! Complex refractive index -shell
       real,intent(in)    ::  VOLCOR    ! volume of core
       real,intent(in)    ::  VOLSHELL  ! volume of shell
       real,intent(in)    ::  DGNCOR    ! geometric mean diameters  
                                        ! for number distribution [m]
       real,intent(in)    ::  DGNSHELL  ! geometric mean diameters  
                                        ! for number distribution [m]
       real,intent(in)    ::  SIG       ! geometric standard deviation 
      
! *** output variables 
       real,intent(out)     ::  bext      ! extinction coefficient [ 1 / m ]
       real,intent(out)     ::  bscat     ! scattering coefficient [ 1 / m ]
       real,intent(out)     ::  gfac      ! assymetry factor 
       logical, intent(OUT) :: success    ! flag for successful calculation
      
! *** internal variables
!      real    :: xlnsig(nmode)    ! natural log of geometric standard deviations      
       real    :: beta_Sc          ! aerosol scattering coefficient 
 
       real    :: beta_Ex          ! aerosol extinction coefficients       
       real    :: G                ! modal aerosol assymetry factors
       real    :: LSIGX
       real    :: XX, YY           ! Mie size parameter
       real    :: expfac
       real    :: lamdam1          ! 1/ lamda
       real    :: vfac
       
       Logical, Save :: Initialize = .True.

       real, parameter :: pi = 3.14159265359
       
! FSB coded 04/15/2012 by Dr. Francis S. Binkowski
!     modified from an earlier version
!     Center for Environmental Modeling for PolicyDevelopment
!     Institute for the Environment
!     University of North Carolina at Chapel Hill
!     email: frank_binkowski@unc.edu


! *** initialize variables
       lamdam1 = 1.0e6 / lamda_in ! lamda now in [ m ]
        
!      write(20,*) ' inside aero_optical', ' lamda = ', lamda
      
!    calculate the extinction and scattering coefficients
       LSIGX  = log(SIG)
       expfac = pi * exp(3.0 * LSIGX * LSIGX) * lamdam1
        
!     calculate Mie size parameter for volume distribution
!     exp(3.0 * xlnsig*xlnsig)  converts dgn to dgv (volume diameter)
       XX =  DGNCOR * expfac                                       
       YY =  DGNSHELL * expfac
       
       If(Initialize .And. AERO_UTIL_LOG .GT. 0 )Then
          If( Use_Odd_Quadrature )then
              write(AERO_UTIL_LOG,99500)Quadrature_Points
          else
              write(AERO_UTIL_LOG,99502)
              Initialize = .False.
          End If
       End If
       
       If( Use_Odd_Quadrature )then
           CALL ghintBH_CS(Initialize,refcor,refshell,XX,YY,LSIGX,beta_EX,beta_Sc,G, success)
       Else
           CALL ghintBH_CS(refcor,refshell,XX,YY,LSIGX,beta_EX,beta_Sc,G, success)
       End If            

! FSB ghintBH_CS returns the normalized values
!     Calculate the actual extinction and scattering coefficients 
!     by multplying by the modal volume and dividing by the wavelength.
!     For the coated-sphere (core-shell) calculation use the combined
!     volume         
         
       vfac   =  (VOLCOR + VOLSHELL) * lamdam1         
       bext   = vfac * beta_Ex  ! [ 1 / m ]
       bscat  = vfac * beta_Sc  ! [ 1 / m ]
       gfac   = G
99500  Format(I2,' Quadrature Points for Core-Shell Aerosol Optics')
99502  Format('Even Number Quadrature Points for Core-Shell Aerosol Optics')
       END SUBROUTINE aero_optical_CS

! ------------------------------------------------------------------
       subroutine ghintBH_2 (crefin,alfv,xlnsig,Qext_GH,Qscat_GH,g_gh, success) 

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of GhintBH
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none

       complex, intent(in) :: crefin     ! complex index of refraction
       real, intent(in)    :: alfv       ! Mie parameter for dgv
       real, intent(in)    :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)   :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)   :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)   :: g_GH       ! asymmetry factor <cos>
       logical, intent(out) :: success   ! flag for successful calculation
       
       real    :: nr                 ! real part of  refractive index      
       real    :: aa1                ! see below for definition
       real    :: alfaip, alfaim     ! Mie parameters at abscissas
     
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor
       integer :: IGH                ! index for GH quadrature      

! FSB define parameters 
       real, parameter :: pi = 3.14159265
       real, parameter :: sqrtpi = 1.772454 
       real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
       real, parameter :: sqrt2 = 1.414214 
       real, parameter :: three_pi_two = 3.0 * pi / 2.0 
       real, parameter :: const = three_pi_two * sqrtpi1 
       
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf
       real    ::  sum_sg

! Gauss-Hermite abscissas and weights
! *** the following weights and abscissas are from Abramowitz
!     Stegun, Table 25.10 page 924
! FSB full precision from Table 25.10 

! FSB ten-point  - IGH = 5
       real, parameter :: ghxi_10(5) = (/ 0.342901327223705,     &
                                          1.036610829789514,     &
                                          1.756683649299882,     &
                                          2.532731674232790,     &
                                          3.436159118837738 /)

       real, parameter :: ghwi_10(5) = (/ 6.108626337353e-01,    &
                                          2.401386110823e-01,    &
                                          3.387439445548e-02,    &
                                          1.343645746781e-03,    &
                                          7.640432855233e-06 /)

! FSB six-point - IGH = 3
       real, parameter :: ghxi_6(3) = (/ 0.436077411927617,      &
                                         1.335849074013597,      &
                                         2.350604973674492 /)

       real, parameter :: ghwi_6(3) = (/ 7.246295952244e-01,     &
                                         1.570673203229e-01,     &
                                         4.530009905509e-03 /)

! FSB two-point - IGH = 1
       real, parameter :: ghxi_2(1) = (/ 0.707106781186548 /)

       real, parameter :: ghwi_2(1) = (/ 8.862269254528e-01 /)

       real    :: GHXI(5), GHWI(5) ! weight and abscissas
       integer :: NMAX             ! number of weights and abscissa


! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.


       nr = real(crefin)      

       IGH=3 ! default value; six_point is sufficient generally
! six point
       NMAX = 3

       if (nr .ge. 1.7) then 
! 10 point     
          IGH = 5 ! more points needed here
          NMAX = 5
       end if

       if( alfv .gt. 20.0 .or. alfv .lt. 0.5 ) then
          IGH  = 1 ! in  this range fewer points are needed
          NMAX = 1
       end if

       if (IGH == 1) then
! two point
          GHXI(1)    = ghxi_2(1)
          GHWI(1)    = ghwi_2(1)
       else if (IGH == 3) then
          do i = 1, NMAX
             GHXI(i) = ghxi_6(i)
             GHWI(i) = ghwi_6(i)
          end do 
       else
          do i = 1,NMAX
             GHXI(i) = ghxi_10(i)
             GHWI(i) = ghwi_10(i)
          end do  
       end if ! set up number of abscissas and weights 
      
! FSB now start the integration code
       aa1 = sqrt2 * xlnsig    ! This 1.0 / Sqrt( A ) in derivation of the integral
                               ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 

       sum_e  = 0.0
       sum_s  = 0.0
       sum_sg = 0.0
! FSB do NMAX calls to the MIE codes      
       do i = 1,NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          alfaip  = alfv * xf
          alfaim  = alfv / xf ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqext_BH(alfaip,crefin,qalfip_e,qalfip_s, gsalfp, success)
          call getqext_BH(alfaim,crefin,qalfim_e,qalfim_s, gsalfm, success)

          sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 

       end do 

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  

       end subroutine ghintBH_2

! ------------------------------------------------------------------
       subroutine ghintBH_CS_even (RCORE, RSHELL , XX, YY, xlnsig,  &                  
                              Qext_GH,Qscat_GH, g_gh, success)

! FSB code for coated-sphere (core-shell) version

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of ghintBH_CS
!      for the coated-sphere (core-shell) method using BHCOAT
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
       
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none
       complex, intent(in) :: RCORE      ! refractive index of core
       complex, intent(in) :: RSHELL     ! refractive index of shell
       real, intent(in)    :: XX         ! Mie parameter for core
       real, intent(in)    :: YY         ! Mie parameter for shell
       real, intent(in)    :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)   :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)   :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)   :: g_GH       ! asymmetry factor <cos>
       logical, intent(out) :: success   ! flag for successful calculation

       real    :: nr                     ! real part of  refractive index      
       real    :: aa1                    ! see below for definition
       real    :: XXP, XXM               ! Mie parameters at abscissas - CORE
       real    :: YYP, YYM               ! Mie parameters at abscissas - SHELL
     
! FSB define parameters 
      real, parameter :: pi = 3.14159265
      real, parameter :: sqrtpi = 1.772454 
      real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
      real, parameter :: sqrt2 = 1.414214 
      real, parameter :: three_pi_two = 3.0 * pi / 2.0 
      real, parameter ::  const = three_pi_two * sqrtpi1 
 
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e     ! extinction  
       real    :: qalfip_s, qalfim_s     ! scattering
       real    :: gsalfp, gsalfm         ! scattering times asymmetry factor
       integer :: IGH                    ! index for GH quadrature      
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf, temp
       real    ::  sum_sg

! Gauss-Hermite abscissas and weights
! *** the following weights and abscissas are from Abramowitz
!     Stegun, Table 25.10 page 924
! FSB full precision from Table 25.10 

! FSB ten-point  - IGH = 5
       real, parameter :: ghxi_10(5) = (/ 0.342901327223705,     &
                                          1.036610829789514,     &
                                          1.756683649299882,     &
                                          2.532731674232790,     &
                                          3.436159118837738 /)

       real, parameter :: ghwi_10(5) = (/ 6.108626337353e-01,    &
                                          2.401386110823e-01,    &
                                          3.387439445548e-02,    &
                                          1.343645746781e-03,    &
                                          7.640432855233e-06 /)

! FSB six-point - IGH = 3
       real, parameter :: ghxi_6(3) = (/ 0.436077411927617,      &
                                         1.335849074013597,      &
                                         2.350604973674492 /)

       real, parameter :: ghwi_6(3) = (/ 7.246295952244e-01,     &
                                         1.570673203229e-01,     &
                                         4.530009905509e-03 /)

! FSB two-point - IGH = 1
       real, parameter :: ghxi_2(1) = (/ 0.707106781186548 /)

       real, parameter :: ghwi_2(1) = (/ 8.862269254528e-01 /)

       real GHXI(5), GHWI(5) ! weight and abscissas
       integer NMAX ! number of weights and abscissa

! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.


       nr = real(RSHELL)      

       IGH=3 ! default value; six_point is sufficient generally
! six point
       NMAX = 3

       if (nr .ge. 1.7) then 
! 10 point     
          IGH = 5 ! more points needed here
          NMAX = 5
       end if

       if ( XX .gt. 20.0 .or. XX .lt. 0.5 ) then
          IGH  = 1 ! in  this range fewer points are needed
          NMAX = 1
       end if

       if (IGH == 1) then
! two point
          GHXI(1)    = ghxi_2(1)
          GHWI(1)    = ghwi_2(1)
       else if (IGH == 3) then
          do i = 1, NMAX
             GHXI(i) = ghxi_6(i)
             GHWI(i) = ghwi_6(i)
          end do 
       else
          do i = 1,NMAX
             GHXI(i) = ghxi_10(i)
             GHWI(i) = ghwi_10(i)
          end do  
       end if ! set up number of abscissas and weights 

! FSB now start the integration code
       aa1 = sqrt2 * xlnsig   ! This 1.0 / Sqrt( A ) in derivation of the integral
                              ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 
       sum_e  = 0.0
       sum_s  = 0.0
       sum_sg = 0.0
! FSB do NMAX calls to the MIE codes      
       do i = 1,NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          temp    = 1.0 / xf
          XXP     = XX * xf
          XXM     = XX * temp ! division cheaper than another exp()
          YYP     = YY * xf
          YYM     = YY * temp ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqsgBHCS(XXP,YYP,RCORE,RSHELL,qalfip_e,qalfip_s,gsalfp, success)
          call getqsgBHCS(XXM,YYM,RCORE,RSHELL,qalfim_e,qalfim_s,gsalfm, success)
          
          sum_e  = sum_e  + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s  + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi  * ( gsalfp   + gsalfm   ) 
       end do 

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  

       end subroutine ghintBH_CS_even
      
! ------------------------------------------------------------------
       subroutine getqsgBHCS (XX,YY,RRFRL1,RRFRL2,qxtalf,qscalf,qsgalf, success)
       implicit none

       real, intent(in)    :: XX, YY
       real, intent(out)   :: qxtalf, qscalf, qsgalf
       complex, intent(in) :: RRFRL1,RRFRL2            ! refractive indices Core , Shell 
       logical, intent(out) :: success                 ! flag for successful calculation

       real    :: QEXT, QSCA, QBACK, G_MIE
       real    :: xx1
       character (len = 20) :: mystr1, mystr2, mystr3, mystr4

       xx1    = 1.0 / YY

!      if (     (xx *  real(RRFRL1) >= 30.0)   &
!          .or. (xx * aimag(RRFRL1) >= 30.0)   &
!          .or. (yy * aimag(RRFRL2) >= 30.0)) then
!         print *, ' ==d== bhcoat error'
!      end if

       call BHCOAT (XX,YY,RRFRL1,RRFRL2,QEXT,QSCA,QBACK,G_MIE, SUCCESS)

!      write (mystr1, *) QEXT
!      write (mystr2, *) QSCA
!      write (mystr3, *) QBACK
!      write (mystr4, *) G_MIE

!      if ((trim(mystr1) == ' NaN') .or.  &
!          (trim(mystr2) == ' NaN') .or.  &
!          (trim(mystr3) == ' NaN') .or.  &
!          (trim(mystr4) == ' NaN')) then
!          call BHCOAT (XX,YY,RRFRL1,RRFRL2,QEXT,QSCA,QBACK,G_MIE)
!      end if

       qxtalf = QEXT * xx1
       qscalf = QSCA * xx1
       qsgalf = qscalf * G_MIE 

       END subroutine getqsgBHCS


! ------------------------------------------------------------------
      SUBROUTINE BHCOAT (XX, YY, RRFRL1, RRFRL2, QQEXT, QQSCA, QBACK, GGSCA, SUCCESS)
      
      use complex_number_module

      implicit none ! added by FSB

! Arguments:
       real, intent(in)    :: XX,YY             ! Defined below
       complex, intent(in) :: RRFRL1,RRFRL2     ! Defined below
       real, intent(out)   :: QQEXT,QQSCA,QBACK ! Defined below
       real, intent(out)   :: GGSCA             ! asymmetry factor <cos> added by FSB
       logical,intent(out) :: success

! Local variables:
     
       real*8, parameter     :: DEL = 1.0D-08  
       real*8, parameter     :: ONE = 1.0D0, TWO = 2.0D0 
!      complex*16, save :: II
!      data II/(0.D0,1.D0)/
       type(complex_number) :: II

       integer :: IFLAG,N,NSTOP

       character (len = 100) :: mystr

!         -----------------------------------------------------------
!              del is the inner sphere convergence criterion
!         -----------------------------------------------------------
     
       real*8 :: CHI0Y,CHI1Y,CHIY,PSI0Y,PSI1Y,PSIY,QEXT,RN,QSCA,X,Y,YSTOP,GSCA
       real*8 :: TWO_N_M_ONE, TWO_N_P_ONE
       real*8 :: RY, RYY, RNRY, RN1, factor
       
!      complex*16 :: AMESS1,AMESS2,AMESS3,AMESS4,AN,ANCAP,AN1, BN,BNCAP,BN1, BRACK,   &
       type(complex_number) :: AMESS1,AMESS2,AMESS3,AMESS4,AN,ANCAP,AN1, BN,BNCAP,BN1, BRACK,   &
                     CHI0X2,CHI0Y2,CHI1X2,CHI1Y2,CHIX2,CHIPX2,CHIPY2,CHIY2,CRACK,     &
                     D0X1,D0X2,D0Y2,D1X1,D1X2,D1Y2,DNBAR,GNBAR,                       &
                     REFREL,RFREL1,RFREL2, XBACK,XI0Y,XI1Y,XIY,                       &
                     X1,X2,Y2,RCX1, RCX2,RCY2, FAC1, FAC2

!***********************************************************************
! NOTES from Prof. Bruce T. Draine, Princeton University
! Subroutine BHCOAT calculates Q_ext, Q_sca, Q_back for coated sphere.
! All bessel functions computed by upward recurrence.
! Input:
!        XX = 2*PI*RCORE*REFMED/WAVEL
!        YY = 2*PI*RMANT*REFMED/WAVEL
!        RFREL1 = REFCOR/REFMED
!        RFREL2 = REFMAN/REFMED 
! where  REFCOR = complex refr.index of core)
!        REFMAN = complex refr.index of mantle)
!        REFMED = real refr.index of medium)
!        RCORE = radius of core
!        RMANT = radius of mantle
!        WAVEL = wavelength of light in ambient medium
!
! Routine BHCOAT is taken from Bohren & Huffman (1983)
! Obtained from C.L.Joseph
!
! History:
! 92/11/24 (BTD) Explicit declaration of all variables
! April 30,2012 (FSB) added additional code to optimize
!  run time by finding common terms and replacing multiple
!  divisions by multiplication by a reciprocal. 
! April 09, 2012  code transferred from BTD's BMHMIE to
! calculate the asymmetry factor by  Prof. Francis S. Binkowski of 
! The University of North Carolina at Chapel Hill.
! April 30,2012 (FSB) added additional code to optimize
!  run time by finding common terms and replacing multiple
!  divisions by multiplication by a reciprocal. 
! July 16, 2010  more optimization by Dr. David Wong (DW) at US EPA
 
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
!    This code was originally listed in Appendix B. pp 483-489.
!    As noted above , the original code was subsequently 
!    modified by Prof. Bruce T. Draine of Princeton University.
! 
! FSB The background for this code is discussed in Borhen & Huffman (1983)
! on pages 181-183 ( Equations 8.2 ) and on pages 483-484. 
!***********************************************************************
!
! Start Code 

       SUCCESS = .TRUE.      

       II = c_set(0.0D0, 1.0D0)

! this technique will make the second 4 byte in the 8 byte variable be 0
! rather than arbitrary digits to increase accuracy
       write (mystr, *) xx, yy, real(RRFRL1), aimag(RRFRL1), real(RRFRL2), aimag(RRFRL2)
       read  (mystr, *) x,  y,  RFREL1, RFREL2

!      X      = XX
!      Y      = YY
       RY     = ONE / Y
       RYY    = RY * RY
!      RFREL1%real_part = real(RRFRL1)
!      RFREL1%imag_part = aimag(RRFRL1)
!      RFREL2%real_part = real(RRFRL2)
!      RFREL2%imag_part = aimag(RRFRL2)
       x1     = c_mul(x, rfrel1)
       x2     = c_mul(x, rfrel2)
       y2     = c_mul(y, rfrel2)
       RCX1   = c_div(ONE, X1)
       RCX2   = c_div(ONE, X2)
       RCY2   = c_div(ONE, Y2)
       refrel = c_div(rfrel2, rfrel1)
       ystop  = y + 4.0 * y**0.3333 + 2.0
       nstop  = INT( ystop )

!         -----------------------------------------------------------
!              series terminated after nstop terms
!         -----------------------------------------------------------

!   initialize variables 
       d0x1   = c_div(c_cos(x1), c_sin(x1))
       d0x2   = c_div(c_cos(x2), c_sin(x2))
       d0y2   = c_div(c_cos(y2), c_sin(y2))

       psi0y  = cos(y)
       psi1y  = sin(y)
       chi0y  = -sin(y)
       chi1y  = cos(y)

       xi0y   = c_sub(psi0y, c_mul(chi0y, II))
       xi1y   = c_sub(psi1y, c_mul(chi1y, II))

       chi0y2 = c_mul(-1.0d0, c_SIN(y2))
       chi1y2 = c_COS(y2)
       chi0x2 = c_mul(-1.0d0, c_SIN(x2))
       chi1x2 = c_COS(x2)
       qsca   = 0.0d0
       qext   = 0.0d0
       GSCA   = 0.0d0
       xback  = c_set(0.0d0, 0.0d0)
       iflag  = 0
       factor = 1.0d0

!      print *, ' ==d== N ', nstop

! FSB Start main loop      
       DO n = 1, nstop
          rn = REAL( n, 8 )
          RN1 = ONE / RN
          TWO_N_M_ONE = TWO * RN - ONE
          TWO_N_P_ONE = TWO * RN + ONE
          psiy = (TWO_N_M_ONE)*psi1y*RY - psi0y
          chiy = (TWO_N_M_ONE)*chi1y*RY - chi0y
          xiy  = c_sub(psiy, c_mul(chiy, II))
          d1y2 = c_sub(c_div(ONE, c_sub(c_mul(rn, RCY2), d0y2)), c_mul(rn, RCY2))

          IF (iflag .eq. 0) THEN
! *** Calculate inner sphere ancap, bncap
!      and brack and crack
             d1x1   = c_sub(c_div(ONE, c_sub(c_mul(rn, RCX1), d0x1)), c_mul(rn, RCX1))
             d1x2   = c_sub(c_div(ONE, c_sub(c_mul(rn, RCX2), d0x2)), c_mul(rn, RCX2))

             chix2  = c_sub(c_mul(c_mul(TWO*rn - ONE, chi1x2), RCX2), chi0x2)
             chiy2  = c_sub(c_mul(c_mul(TWO*rn - ONE, chi1y2), RCY2), chi0y2)

             chipx2 = c_sub(chi1x2, c_mul(c_mul(rn, chix2), RCX2))
             chipy2 = c_sub(chi1y2, c_mul(c_mul(rn, chiy2), RCY2))

!            ANCAP  = (REFREL*D1X1 - D1X2) /                              & 
!                     ( (REFREL*D1X1*CHIX2 - CHIPX2) * (CHIX2*D1X2 - CHIPX2) )

             ANCAP = c_sub(c_mul(c_mul(REFREL, D1X1), CHIX2), CHIPX2)
             ANCAP = c_mul(ANCAP, c_sub(c_mul(CHIX2, D1X2), CHIPX2))
             ANCAP = c_div(c_sub(c_mul(REFREL, D1X1), D1X2), ANCAP)

             brack  = c_mul(ancap, c_sub(c_mul(chiy2, d1y2), chipy2))

             bncap  = c_sub(c_mul(refrel, d1x2), d1x1)
             bncap  = c_div(bncap, c_sub(c_mul(refrel, chipx2), c_mul(d1x1, chix2)))
             bncap  = c_div(bncap, c_sub(c_mul(chix2, d1x2), chipx2))

             crack  = c_mul(bncap, c_sub(c_mul(chiy2, d1y2), chipy2))
! *** calculate convergence test expressions
!     for inner sphere.
! *** see pages 483-485 of Bohren & Huffman for
!     definitions. 
             amess1 = c_mul(brack, chipy2)
             amess2 = c_mul(brack, chiy2)
             amess3 = c_mul(crack, chipy2)
             amess4 = c_mul(crack, chiy2)

! Now test for convergence for inner sphere
!  All four criteria must be satisfied. See page 484 of B & H
             IF (c_ABS(amess1) .LE. del*c_ABS(d1y2)  .AND.                          &
                (c_ABS(amess2) .LE. del)             .AND.                          &
                (c_ABS(amess3) .LE. del*c_ABS(d1y2)) .AND.                          &
                (c_ABS(amess4) .LE. del)                ) THEN
!               convergence for inner sphere        
                brack = c_set(0.0D0,0.0D0)
                crack = c_set(0.0D0,0.0D0)
                iflag = 1
!         ELSE
! no convergence yet
!            iflag = 0
             END IF 
          END IF ! test on iflag .eq. 0

! *** note usage of brack and crack See equations on
!     Page 485  and discussion on pages 486 -487 of B & H      
          dnbar = c_sub(d1y2, c_mul(brack, chipy2))
          dnbar = c_div(dnbar, c_sub(ONE, c_mul(brack, chiy2)))
          gnbar = c_sub(d1y2, c_mul(crack, chipy2))
          gnbar = c_div(gnbar, c_sub(ONE, c_mul(crack, chiy2)))
!*** Store previous values of an and bn for use 
!    in computation of g=<cos(theta)>
          IF (N .GT. 1) THEN
             AN1 = an
             BN1 = bn
          END IF    
! *** update an and bn  
          RNRY = rn * RY 
          FAC1 = c_add(c_div(dnbar, rfrel2), RNRY)

          an = c_sub(c_mul(psiy, FAC1), psi1y)
          an = c_div(an, c_sub(c_mul(FAC1, xiy), xi1y))
          FAC2 = c_add(c_mul(rfrel2, gnbar), RNRY)
          bn = c_sub(c_mul(psiy, FAC2), psi1y)
          bn = c_div(bn, c_sub(c_mul(FAC2, xiy), xi1y))
      
! *** Calculate sums for qsca, qext, xback      
          qsca  = qsca + (TWO_N_P_ONE) * (c_ABS(an)**2 + c_ABS(bn)**2)
      
          qext  = qext + TWO_N_P_ONE * (an%real_part + bn%real_part)
      
! DW        XBACK = XBACK +  (TWO_N_P_ONE) * (-1.)**N * (AN-BN)
          FACTOR = FACTOR * (-1.0D0)
          XBACK = c_add(XBACK, c_mul(TWO_N_P_ONE * FACTOR, c_sub(AN, BN)))

! FSB calculate the sum for the asymmetry factor 

          GSCA = GSCA + ((TWO_N_P_ONE)/(RN* (RN + ONE)))*                     &
                 (an%real_part*bn%real_part + an%imag_part*bn%imag_part)
 
          IF (n .GT. 1) THEN
        
! DW         GSCA = GSCA + ((RN - ONE) * (RN + ONE) * RN1) *             &
             GSCA = GSCA + (RN - RN1) *                                  &
                   (AN1%real_part*AN%real_part + AN1%imag_part*AN%imag_part +            &
                    BN1%real_part*BN%real_part + BN1%imag_part*BN%imag_part)
     
          END IF
! continue update for next interation        
          psi0y  = psi1y
          psi1y  = psiy
          chi0y  = chi1y
          chi1y  = chiy
          xi1y   = c_sub(psi1y, c_mul(chi1y, II))
          chi0x2 = chi1x2
          chi1x2 = chix2
          chi0y2 = chi1y2
          chi1y2 = chiy2
          d0x1   = d1x1
          d0x2   = d1x2
          d0y2   = d1y2
       END DO  ! end of main loop 
  
!*** Have summed sufficient terms.
!    Now compute QQSCA,QQEXT,QBACK,and GSCA
       GGSCA = REAL( TWO * GSCA / qsca )
       QQSCA = REAL( TWO * qsca * RYY )
       QQEXT = REAL( TWO * qext * RYY )
!      QBACK = 0.5 * REAL ( ( xback * conjg(xback) ) * RYY )

       QBACK = 0.5 * real((xback%real_part**2 + xback%imag_part**2) * RYY)
!      QBACK = real((xback%real_part**2 + xback%imag_part**2) * RYY)

!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', GGSCA, GSCA, qsca
!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', QQSCA, qsca, RYY
!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', QQEXT, qext, RYY
!       write (6, '(a19, 20e18.10)') ' ==d== bhcoat z ', QBACK, xback, RYY

       end subroutine BHCOAT

       subroutine ghintBH_Odd (INIT, crefin,alfv,xlnsig,Qext_GH,Qscat_GH,g_gh, success ) 

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of GhintBH
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none

       logical, intent(INOUT)        :: INIT       ! initialize number of qudraure points
       complex, intent(in)           :: crefin     ! complex index of refraction
       real, intent(in)              :: alfv       ! Mie parameter for dgv
       real, intent(in)              :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)             :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)             :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)             :: g_GH       ! asymmetry factor <cos>
       logical, intent(out)          :: success    ! flag for successful calculation
       
       real    :: nr                 ! real part of  refractive index      
       real    :: aa1                ! see below for definition
       real    :: alfaip, alfaim     ! Mie parameters at abscissas
     
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e ! extinction  
       real    :: qalfip_s, qalfim_s ! scattering
       real    :: gsalfp, gsalfm     ! scattering times asymmetry factor

! FSB define parameters 
       real, parameter :: pi = 3.14159265
       real, parameter :: sqrtpi = 1.772454 
       real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
       real, parameter :: sqrt2 = 1.414214 
       real, parameter :: three_pi_two = 3.0 * pi / 2.0 
       real, parameter :: const = three_pi_two * sqrtpi1 
       
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf
       real    ::  sum_sg

       real,    allocatable,  save  :: GHXI(:), GHWI(:) ! weight and abscissas
       integer, save  :: IGH                            ! number of weights and abscissa
       integer, save  :: NMAX                           ! optimumized number of weights and abscissa


! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.

     If( INIT )Then

          Select Case( Quadrature_Points )
            Case( 1,3,9 )
              IGH = Quadrature_Points
            Case Default
              IGH = 3
          End Select

          NMAX = Max( Int( IGH / 2 ), 0)

          If( Allocated( GHXI ) .Or. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If
          
          Allocate( GHXI( NMAX + 1 ), GHWI( NMAX + 1 ) )
 
          Select Case ( IGH ) 
            Case ( 1 )
              GHXI(1)  = ghxi_1(1)
              GHWI(1)  = ghwi_1(1)
            Case ( 3 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_3(i)
                GHWI(i) = ghwi_3(i)
              end do 
            Case ( 9 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_9(i)
                GHWI(i) = ghwi_9(i)
              end do 
          end select 
          
          If( AERO_UTIL_LOG .GT. 0 )Then
              write(AERO_UTIL_LOG,*)'BHMIE: IGH,(NMAX + 1) = ',IGH,(NMAX + 1)
              do i = 1, NMAX + 1
                write(AERO_UTIL_LOG,*)'BHMIE: i, GHXI(i), GHWI(i) = ',i, GHXI(i), GHWI(i)
              end do
          End If
          
          INIT = .False.
       Else
          If( .Not. Allocated( GHXI ) .Or. .Not. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If                
       End If ! set up number of abscissas and weights 
 
       nr = real(crefin)      

      
! FSB now start the integration code
       aa1 = sqrt2 * xlnsig    ! This 1.0 / Sqrt( A ) in derivation of the integral
                               ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 

!start integration at zero point
       xi      = 0.0
       wxi     = GHWI(NMAX+1)
       xf      = 1.0
       alfaip  = alfv
! fetch the effficiencies at zero point

       call getqext_BH(alfaip,crefin,qalfip_e,qalfip_s, gsalfp, success)

       sum_e  = wxi * qalfip_e
       sum_s  = wxi * qalfip_s
       sum_sg = wxi * gsalfp

! FSB do NMAX calls to the MIE codes      
       do i = 1, NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          alfaip  = alfv * xf
          alfaim  = alfv / xf ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqext_BH(alfaip,crefin,qalfip_e,qalfip_s, gsalfp, success)
          call getqext_BH(alfaim,crefin,qalfim_e,qalfim_s, gsalfm, success)

          sum_e  = sum_e + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi * ( gsalfp + gsalfm ) 

       end do
       

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  

       end subroutine ghintBH_Odd
! ------------------------------------------------------------------
       subroutine ghintBH_CS_Odd (INIT, RCORE, RSHELL , XX, YY, xlnsig,  &                  
                                  Qext_GH,Qscat_GH, g_gh, success)

! FSB code for coated-sphere (core-shell) version

! *************** REVISED VERSION < NOTE
! FSB *********** This is the newest (04_14_2012) version of ghintBH_CS
!      for the coated-sphere (core-shell) method using BHCOAT
!      this version does the Mie method and calculates the optimum set of 
!      set of Gauss-Hermite abscissas and weights. 
!      Dr. Francis S. Binkowski, The University of North Carolina
!                                at Chapel Hill
       
! FSB this code file now contains all of the necessary subroutines that 
!     are called to perform an integral of the Bohren and Huffman
!     Mie codes ( as updated by Prof. Bruce C. Drain of Princeton)
!       calculates the extinction and scattering coefficients 
!       normalized by wavelength and total particle volume
!       concentration for a log normal particle distribution 
!       with the logarithm of the geometric  standard deviation
!       given by xlnsig. The integral of the
!       asymmetry factor g is also calculated.
! FSB Change 12/20/2011 This code now has a choice of IGH based
!     upon alfv and nr. 
! FBB Changes Simplified code. Eliminated Penndorf code
!  *** Does Gauss-Hermite quadrature of Qext / alfa & Qscat / alfa
!      and asymmetry factor <cos> over log normal distribution using 
!      symmetric  points.
!
       implicit none

       logical, intent(inout) :: INIT       ! initialize number of qudraure points
       complex, intent(in)    :: RCORE      ! refractive index of core
       complex, intent(in)    :: RSHELL     ! refractive index of shell
       real, intent(in)       :: XX         ! Mie parameter for core
       real, intent(in)       :: YY         ! Mie parameter for shell
       real, intent(in)       :: xlnsig     ! log of geometric  standard deviation
       real, intent(out)      :: Qext_GH    ! normalized extinction efficiency
       real, intent(out)      :: Qscat_GH   ! normalized scattering efficiency
       real, intent(out)      :: g_GH       ! asymmetry factor <cos>
       logical, intent(out)   :: success   ! flag for successful calculation

       real    :: nr                     ! real part of  refractive index      
       real    :: aa1                    ! see below for definition
       real    :: XXP, XXM               ! Mie parameters at abscissas - CORE
       real    :: YYP, YYM               ! Mie parameters at abscissas - SHELL
     
! FSB define parameters 
      real, parameter :: pi = 3.14159265
      real, parameter :: sqrtpi = 1.772454 
      real, parameter :: sqrtpi1 = 1.0 / sqrtpi 
      real, parameter :: sqrt2 = 1.414214 
      real, parameter :: three_pi_two = 3.0 * pi / 2.0 
      real, parameter ::  const = three_pi_two * sqrtpi1 
 
!  *** these are Qext/alfa and Qscat/alfv at the abscissas
       real    :: qalfip_e, qalfim_e     ! extinction  
       real    :: qalfip_s, qalfim_s     ! scattering
       real    :: gsalfp, gsalfm         ! scattering times asymmetry factor
       integer ::  i
       real    ::  sum_e,sum_s, xi,wxi,xf, temp
       real    ::  sum_sg


       real,    allocatable,  save  :: GHXI(:), GHWI(:) ! weight and abscissas
       integer,               save  :: IGH              ! number of weights and abscissa
       integer,               save  :: NMAX             ! optimized number of weights and abscissa

! start code
! FSB now choose IGH. These choices are designed to improve
!     the computational efficiency without sacrificing accuracy.

     If( INIT )Then

          Select Case( Quadrature_Points )
            Case( 1,3,9 )
              IGH = Quadrature_Points
            Case Default
              IGH = 3
          End Select
                    
          If( Allocated( GHXI ) .Or. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If

          NMAX = Max( Int( IGH / 2 ), 0)
          
          Allocate( GHXI( NMAX + 1 ), GHWI( NMAX + 1 ) )

          Select Case ( IGH ) 
            Case ( 1 )
              GHXI(1)  = ghxi_1(1)
              GHWI(1)  = ghwi_1(1)
            Case ( 3 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_3(i)
                GHWI(i) = ghwi_3(i)
              end do 
            Case ( 9 )
              do i = 1, NMAX + 1
                GHXI(i) = ghxi_9(i)
                GHWI(i) = ghwi_9(i)
              end do  
          end select 

          If( AERO_UTIL_LOG .GT. 0 )Then
              write(AERO_UTIL_LOG,*)'BHCoat: IGH,(NMAX + 1) = ',IGH,(NMAX + 1)
              do i = 1, NMAX + 1
                write(AERO_UTIL_LOG,*)'BHCoat: i, GHXI(i), GHWI(i) = ',i, GHXI(i), GHWI(i)
              end do
          End If
          
          INIT = .False.
          
       Else
          If( .Not. Allocated( GHXI ) .Or. .Not. Allocated( GHWI ) )Then
              Success = .False.
              Return             
          End If      
       End If ! set up number of abscissas and weights 

       nr = real(RSHELL)      

! FSB now start the integration code
       aa1 = sqrt2 * xlnsig   ! This 1.0 / Sqrt( A ) in derivation of the integral
                              ! where A = 1.0 / ( 2.0 * xlnsg**2 ) 

! Then alpha = alfv * exp[ u / sqrt(A) ]
! For Gauss-Hermite Quadrature u = xi 
! Therefore, xf = exp( xi / sqrt(A) ),
!  or xf = exp( xi * aa1 ) 

!start integration at zero point

          xi      = 0.0
          wxi     = GHWI(NMAX+1)
          xf      = 1.0
          XXP     = XX
          YYP     = YY

! fetch the effficiencies at zero point

          call getqsgBHCS(XXP,YYP,RCORE,RSHELL,qalfip_e,qalfip_s,gsalfp, success)
          
          sum_e  = wxi  * qalfip_e
          sum_s  = wxi  * qalfip_s
          sum_sg = wxi  * gsalfp   

! FSB do NMAX calls to the MIE codes      
       do i = 1, NMAX
          xi      = GHXI(i)
          wxi     = GHWI(i)
          xf      = exp( xi * aa1 )
          temp    = 1.0 / xf
          XXP     = XX * xf
          XXM     = XX * temp ! division cheaper than another exp()
          YYP     = YY * xf
          YYM     = YY * temp ! division cheaper than another exp()
! *** call subroutine to fetch the effficiencies

          call getqsgBHCS(XXP,YYP,RCORE,RSHELL,qalfip_e,qalfip_s,gsalfp, success)
          call getqsgBHCS(XXM,YYM,RCORE,RSHELL,qalfim_e,qalfim_s,gsalfm, success)
          
          sum_e  = sum_e  + wxi  * ( qalfip_e + qalfim_e ) 
          sum_s  = sum_s  + wxi  * ( qalfip_s + qalfim_s ) 
          sum_sg = sum_sg + wxi  * ( gsalfp   + gsalfm   ) 
       end do 

       g_GH     = sum_sg / sum_s ! this is <cos>
       Qext_GH  = const * sum_e  ! 
       Qscat_GH = const * sum_s  


       end subroutine ghintBH_CS_Odd        
    

! ------------------------------------------------------------------
       SUBROUTINE BHMIE_FLEXI (X, NMX, NSTOP, REFREL, QQEXT, QQSCA, QBACK, GSCA, SUCCESS)

! FSB Changed the call vector to return only QEXT, QSCAT QBACK GSCA
!     and ignore NANG, S1 and S2 and all calculations for them

       implicit none 

! Arguments:
       real,    intent(in) :: X        ! X = pi*particle_diameter / Wavelength
       integer, intent(in) :: NMX      ! maximum number of terms in Mie series 
       integer, intent(in) :: NSTOP    ! minumum number of terms in Mie series 
       complex, intent(in) :: REFREL   ! refractive index

!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    in the current use the index of refraction of the the medium
!    i taken at 1.0 real.
!
!    Output

       real,    intent(out) :: QQEXT, QQSCA, QBACK, GSCA
       logical, intent(out) :: SUCCESS

!     QQEXT   Efficiency factor for extinction
!     QQSCA   Efficiency factor for scattering
!     QQBACK  Efficiency factor for back scatter
!     GSCA    asymmetry factor <cos>
!     SUCCESS flag for successful calculation
! REFERENCE: 
!  Bohren, Craig F. and Donald R. Huffman, Absorption and 
!    Scattering of Light by Small Particles, Wiley-Interscience
!    copyright 1983. Paperback Published 1998.
! FSB
!    This code was originally listed in Appendix A. pp 477-482.
!    As noted below, the original code was subsequently 
!    modified by Prof. Bruce T. Drain of Princetion University.
!    The code was further modified for a specific application
!    in a large three-dimensional code requiring as much 
!    computational efficiency as possible. 
!    Prof. Francis S. Binkowski of The University of North
!    Carolina at Chapel Hill. 

! Declare parameters:
! Note: important that MXNANG be consistent with dimension of S1 and S2
!       in calling routine!

       integer, parameter    :: MXNANG=10, NMXX=150000   ! FSB new limits
       integer, parameter    :: NANG  = 2
       real*8, parameter     :: PII = 3.1415916536D0
       real*8, parameter     :: ONE = 1.0D0, TWO = 2.0D0
       complex*16, parameter :: COMPLEX_DZERO = (0.0D0,0.0D0)
       complex,    parameter :: COMPLEX_ZERO  = (0.0,0.0)

! Local variables:
       integer    :: N, NN
       real*8     :: QSCA, QEXT, DX1, DXX1      
       real*8     :: CHI,CHI0,CHI1,DX,EN,P,PSI,PSI0,PSI1,XSTOP,YMOD               
       real*8     :: TWO_N_M_ONE, TWO_N_P_ONE, EN1, FACTOR
       complex*16 :: AN,AN1,BN,BN1,DREFRL,XI,XI1,Y, Y1, DREFRL1
       complex*16 :: D(NMX)
       complex*16 :: FAC1, FAC2
       complex*16 :: XBACK

!***********************************************************************
! Subroutine BHMIE is the Bohren-Huffman Mie scattering subroutine
!    to calculate scattering and absorption by a homogenous isotropic
!    sphere.
! Given:
!    X = 2*pi*a/lambda
!    REFREL = (complex refr. index of sphere)/(real index of medium)
!    real refractive index of medium taken as 1.0 
! Returns:
!    QEXT  = efficiency factor for extinction
!    QSCA  = efficiency factor for scattering
!    QBACK = efficiency factor for backscatter
!            see Bohren & Huffman 1983 p. 122
!    GSCA = <cos> asymmetry for scattering
!
! Original program taken from Bohren and Huffman (1983), Appendix A
! Modified by Prof. Bruce T.Draine, Princeton Univ. Obs., 90/10/26
! in order to compute <cos(theta)>
! 91/05/07 (BTD): Modified to allow NANG=1
! 91/08/15 (BTD): Corrected error (failure to initialize P)
! 91/08/15 (BTD): Modified to enhance vectorizability.
! 91/08/15 (BTD): Modified to make NANG=2 if called with NANG=1
! 91/08/15 (BTD): Changed definition of QBACK.
! 92/01/08 (BTD): Converted to full double precision and double complex
!                 eliminated 2 unneed lines of code
!                 eliminated redundant variables (e.g. APSI,APSI0)
!                 renamed RN -> EN = double precision N
!                 Note that DOUBLE COMPLEX and DCMPLX are not part
!                 of f77 standard, so this version may not be fully
!                 portable.  In event that portable version is
!                 needed, use src/bhmie_f77.f
! 93/06/01 (BTD): Changed AMAX1 to generic function MAX
! FSB April 09,2012 This code was modified by: 
! Prof.  Francis S. Binkowski University of North Carolina at
! Chapel Hill, Institue for the Environment.
!
! The modifications were made to enhance computation speed 
! for use in a three-dimensional code. This was done by
! removing code that calculated angular scattering. The method
! of calculating QEXT, QBACK was also changed. 
 
!***********************************************************************
!*** Safety checks

       SUCCESS = .TRUE.
!       NANG = 2 ! FSB only this value 
! IF(NANG.GT.MXNANG)STOP'***Error: NANG > MXNANG in bhmie'
!      IF (NANG .LT. 2) NANG = 2

       DX = REAL( X, 8 )
! FSB Define reciprocals so that divisions can be replaced by multiplications.      
       DX1  = ONE / DX
       DXX1 = DX1 * DX1
       DREFRL = DCMPLX( REAL( REFREL ), IMAG( REFREL ) )
       DREFRL1 = ONE / DREFRL
       Y = DX * DREFRL
       Y1 = ONE / Y
!       YMOD = ABS(Y)
 
!*** Series expansion terminated after NSTOP terms
!    Logarithmic derivatives calculated from NMX on down
!       XSTOP = X + 4.0 * X**0.3333 + 2.0
!       NMX  = MAX(XSTOP,YMOD) + 15

! BTD experiment 91/1/15: add one more term to series and compare results
!      NMX=AMAX1(XSTOP,YMOD)+16
! test: compute 7001 wavelengths between .0001 and 1000 micron
! for a=1.0micron SiC grain.  When NMX increased by 1, only a single
! computed number changed (out of 4*7001) and it only changed by 1/8387
! conclusion: we are indeed retaining enough terms in series!

       FACTOR = 1.0D0
 
!       IF (NMX .GT. NMXX) THEN
!          WRITE(6,*)'Error: NMX > NMXX=',NMXX,' for |m|x=',YMOD
!          SUCCESS = .FALSE.
!          RETURN
!       END IF

! FSB all code relating to scattering angles is removed out for
!     reasons of efficiency when running in a three-dimensional 
!     code. We only need QQSCA, QQEXT, GSCA AND QBACK

 
!*** Logarithmic derivative D(J) calculated by downward recurrence
!    beginning with initial value (0.,0.) 
 
       D(NMX) = COMPLEX_DZERO
       NN = NMX - 1
       DO N = 1,NN
          EN  = REAL( NMX - N + 1, 8 )
! FSB In the following division by Y has been replaced by 
!     multiplication by Y1, the reciprocal of Y.          
          D(NMX-N) = ( EN * Y1 ) - (ONE / ( D(NMX-N+1) + EN * Y1)) 
       END DO
 
!*** Riccati-Bessel functions with real argument X
!    calculated by upward recurrence
 
       PSI0 =  COS(DX)
       PSI1 =  SIN(DX)
       CHI0 = -SIN(DX)
       CHI1 =  PSI0
       XI1  =  DCMPLX(PSI1,-CHI1)
       QSCA =  0.0D0
       GSCA =  0.0D0
       QEXT =  0.0D0
       P    = -ONE
       XBACK = COMPLEX_DZERO

! FSB Start main loop       
       DO N = 1,NSTOP
          EN        = REAL( N, 8 )
          EN1       = ONE / EN
          TWO_N_M_ONE = TWO * EN - ONE
! for given N, PSI  = psi_n        CHI  = chi_n
!              PSI1 = psi_{n-1}    CHI1 = chi_{n-1}
!              PSI0 = psi_{n-2}    CHI0 = chi_{n-2}
! Calculate psi_n and chi_n
          PSI = TWO_N_M_ONE * PSI1 * DX1 - PSI0
          CHI = TWO_N_M_ONE * CHI1 * DX1 - CHI0
          XI  = DCMPLX(PSI,-CHI)
 
!*** Compute AN and BN:
! FSB Rearrange to get common terms
          FAC1 = D(N) * DREFRL1 + EN * DX1 
          AN   = (FAC1) * PSI - PSI1
          AN   = AN / ( (FAC1 )* XI - XI1 )
          FAC2 = ( DREFRL * D(N) + EN * DX1)
          BN   = ( FAC2) * PSI -PSI1
          BN   = BN / ((FAC2) * XI - XI1 )

! FSB calculate sum for QEXT as done by Wiscombe
!     get common factor
          TWO_N_P_ONE = (TWO * EN + ONE)
          QEXT = QEXT + (TWO_N_P_ONE) * (REAL(AN) + REAL(BN) ) 
          QSCA = QSCA + (TWO_N_P_ONE) * ( ABS(AN)**2 + ABS(BN)**2 )
          
! FSB calculate XBACK from B & H Page 122          
          FACTOR = -1.0d0 * FACTOR  ! calculate (-1.0 ** N)
          XBACK = XBACK + (TWO_N_P_ONE) * factor * (AN - BN)
          
! FSB calculate asymmetry factor   
       
          GSCA = GSCA + REAL((TWO_N_P_ONE)/(EN * (EN + ONE)) *     &
                 (REAL(AN)*REAL(BN)+IMAG(AN)*IMAG(BN)))

          IF (N .GT. 1)THEN
             GSCA = GSCA + REAL((EN - EN1) *                         &
                    (REAL(AN1)*REAL(AN) + IMAG(AN1)*IMAG(AN) +  &
                     REAL(BN1)*REAL(BN) + IMAG(BN1)*IMAG(BN)))
          ENDIF

!*** Store previous values of AN and BN for use in computation of g=<cos(theta)>
          AN1 = AN
          BN1 = BN

! FSB set up for next iteration
          PSI0 = PSI1
          PSI1 = PSI
          CHI0 = CHI1
          CHI1 = CHI
          XI1  = DCMPLX(PSI1,-CHI1)

       END DO   ! main  loop on n
 
!*** Have summed sufficient terms.

!    Now compute QQSCA,QQEXT,QBACK,and GSCA
       GSCA  = REAL( TWO / QSCA ) * GSCA

! FSB in the following, divisions by DX * DX has been replaced by
!      multiplication by DXX1 the reciprocal of 1.0 / (DX *DX)           
       QQSCA = REAL( TWO * QSCA * DXX1 )
       QQEXT = REAL( TWO * QEXT * DXX1 )
       QBACK = REAL( REAL( 0.5D0 * XBACK * CONJG(XBACK), 8 ) * DXX1 ) ! B&H Page 122

       END subroutine BHMIE_FLEXI


END MODULE cmaq_rrtmg_aero_optical_util_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     
c      [2] write tssa concentration data 
c     
C     Revision history
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE WR_SA_CGRID ( JDATE, JTIME, TSTEP )

C20140428  Writes full ISAM values to a restart file SA_CGRID_1 which would serve as
C          initial conditions for next day's run
C
C          Called by driver.F

      USE GRID_CONF
      USE UTILIO_DEFN           ! 20120615
c     USE SUBST_MODULES         ! stenex
      USE SA_DEFN               ! Mc06
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

C...Arguments Declaration
      INTEGER    JDATE          ! current model date, coded YYYYDDD
      INTEGER    JTIME          ! current model time, coded HHMMSS
      !INTEGER    TSTEP(2)       ! format 10000, 0, 0
      INTEGER    TSTEP          ! format 10000

C...End of argument declaration

C Local variables:
      
c     INTEGER          ALLOCSTAT, LOGDEV
      INTEGER          ALLOCSTAT

      CHARACTER( 16 ) :: PNAME = 'WR_SA_CGRID'
      CHARACTER( 96 ) :: XMSG = ' '
      
c     INTEGER   C,R,S,K,N, L, ITAG, JSPC    ! loop induction variables
      INTEGER   C,R,S,K,N, L, JSPC    ! loop induction variables

      REAL, ALLOCATABLE :: ISAM_BUFF ( :,:,:,: )
!20140519
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
        
        FIRSTIME = .FALSE.

        CALL SUBST_BARRIER

!20140519 add subst_global_logical call as done in wr_cgrid
        OK = OPEN3( SA_CGRID_1, FSRDWR3, PNAME )
        CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )

        IF ( .NOT. OK ) THEN
          XMSG = 'Could not open ' // SA_CGRID_1 // 
     & ' file for update - try to open new'
          CALL M3MESG( XMSG )

          IF ( MYPE .EQ. 0 ) THEN
            ! open sa_conc_1
            IF ( .NOT. OPEN3( SA_CONC_1, FSRDWR3, PNAME ) ) THEN
              XMSG = 'Could not open ' // SA_CONC_1 // 
     & ' file for update '
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF ! sa_conc_1 opened ?
      
            ! Get description of sa_conc_1
            IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
              XMSG = 'Could not get file description from ' // SA_CONC_1
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF ! sa_conc_1 description obtained ?

            SDATE3D = JDATE
            STIME3D = JTIME
            NLAYS3D = NLAYS

            ! Create sa_cgrid_1
            IF ( .NOT. OPEN3( SA_CGRID_1, FSNEW3, PNAME ) ) THEN
              XMSG = 'Could not open' // SA_CGRID_1 
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF !
          ENDIF ! mype0 ?

        ELSE ! 20140519 sa_cgrid already opened by any processor

          IF ( MYPE .EQ. 0 ) THEN

            IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
              XMSG = 'Could not get' // TRIM(SA_CONC_1) //
     &  'file description'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF

            TSTEP_RF = TSTEP3D
            NTHIK_RF = NTHIK3D
            NCOLS_RF = NCOLS3D
            NROWS_RF = NROWS3D
            GDTYP_RF = GDTYP3D
            P_ALP_RF = P_ALP3D
            P_BET_RF = P_BET3D
            P_GAM_RF = P_GAM3D
            XCENT_RF = XCENT3D
            YCENT_RF = YCENT3D
            XORIG_RF = XORIG3D
            YORIG_RF = YORIG3D
            XCELL_RF = XCELL3D
            YCELL_RF = YCELL3D
            VGTYP_RF = VGTYP3D
            VGTOP_RF = VGTOP3D

            IF ( .NOT. DESC3( SA_CGRID_1 ) ) THEN
              XMSG = 'Could not get' // TRIM(SA_CGRID_1) // 
     &  'file description'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ENDIF

            IF ( TSTEP_RF .NE. ABS( TSTEP3D ) .OR.
     &           NTHIK_RF .NE. NTHIK3D .OR.
     &           NCOLS_RF .NE. NCOLS3D .OR.
     &           NROWS_RF .NE. NROWS3D .OR.
     &           GDTYP_RF .NE. GDTYP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &           P_BET_RF .NE. P_BET3D .OR.
     &           P_GAM_RF .NE. P_GAM3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCENT_RF .NE. XCENT3D .OR.
     &           YCENT_RF .NE. YCENT3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XORIG_RF .NE. XORIG3D .OR.
     &           YORIG_RF .NE. YORIG3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( XCELL_RF .NE. XCELL3D .OR.
     &           YCELL_RF .NE. YCELL3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTYP_RF .NE. VGTYP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( VGTOP_RF .NE. VGTOP3D ) THEN
                 XMSG = 'Header inconsistent on existing SA_CGRID_1'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

          ENDIF  ! mype 0

        END IF ! sa_cgrid_1 opened ?

        CALL SUBST_BARRIER

        ALLOCATE ( ISAM_BUFF( NCOLS, NROWS, NLAYS, N_SPCTAG ),
     &     STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating ISAM_BUFF'
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        ENDIF

      ENDIF  !firstime

      ISAM_BUFF = 0.0
    
      DO S = 1, N_SPCTAG
        ISAM_BUFF( :,:,:,S ) = ISAM( :,:,:,S_SPCTAG(S),T_SPCTAG(S) )
!20140319        IF ( .NOT. WRITE3( SA_CGRID_1, VNAME3D(S), JDATE, JTIME,
        IF ( .NOT. WRITE3( SA_CGRID_1, VNAM_SPCTAG(S), JDATE, JTIME,
     &          ISAM_BUFF(:,:,:,S)) ) THEN
           XMSG = 'Could not write to ' 
     &           // SA_CGRID_1 
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
      END DO ! S
!      DEALLOCATE( ISAM_BUFF )
      
      return
      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPWDEP ( JDATE, JTIME, TSTEP )

!-----------------------------------------------------------------------
!
!  FUNCTION:  Open wet dep file(s)
!
!  PRECONDITIONS:
!       Dates and times represented YYYYDDD:HHMMSS.
!
!  REVISION  HISTORY:
!      Date   Who             What
!    -------- ---             -----------------------------------------
!     07/17/15 D. Wong        initial version
!     12/30/19 S. Napelenok   ddm-3d implemenation for v5.3.1
!-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, SEN_PAR, SENNUM, S_WETDEPSPC
#endif

      IMPLICIT NONE

!...........INCLUDES

      INCLUDE SUBST_CONST            ! constants
      INCLUDE SUBST_FILES_ID         ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' ' ! exit message string

!...........PARAMETERS

! # of wet deposition species
      INTEGER, SAVE :: N_SPC_WDEP

!...........ARGUMENTS

      INTEGER, INTENT (IN) :: JDATE            ! current model date, coded YYYYDDD
      INTEGER, INTENT (IN) :: JTIME            ! current model time, coded HHMMSS
      INTEGER, INTENT (IN) :: TSTEP            ! model time step, coded HHMMSS

!...........Local Variables

      CHARACTER( 16 ), SAVE :: PNAME = 'OPWDEP' ! driver program name

      INTEGER       FINI             ! ending position
      INTEGER       L                ! loop counter
      INTEGER       SPC              ! species subscript indices
      INTEGER       STRT             ! starting position
      INTEGER       VAR              ! variable subscript indices

!-----------------------------------------------------------------------

!...Initialization

!...first check to make sure that some species in CGRID were specified
!...for output in the wet deposition array, otherwise notify the user
!...and return

        N_SPC_WDEP = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
        IF ( N_SPC_WDEP .LE. 0 ) THEN

          XMSG = 'No species were specified for wet deposition ' //
     &           'tracking'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )

          XMSG = 'ONLY CLOUD DIAGNOSTICS WILL BE WRITTEN TO THE ' //
     &           'WETDEP OUTPUT FILE!'
          CALL M3MESG ( XMSG )

        END IF

C Try to open existing wet deposition file for update

        IF ( IO_PE_INCLUSIVE ) THEN
           WRITE( LOGDEV, * )
           IF ( .NOT. OPEN3( CTM_WET_DEP_1, FSRDWR3, PNAME ) ) THEN

              XMSG = 'Could not open ' // CTM_WET_DEP_1 // ' file for update - '
     &               // 'try to open new'
              CALL M3MESG( XMSG )

!...Create wet deposition file:
!...   copy most of header description from
!...   MET_CRO_2D and initialize depositions to zero.

!...open MET_CRO_2D

              IF ( .NOT. OPEN3( MET_CRO_2D, FSREAD3, PNAME ) ) THEN
                XMSG = 'Could not open '// MET_CRO_2D // ' file'
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
              END IF

!...get description from the met file

              IF ( .NOT. DESC3( MET_CRO_2D ) ) THEN
                XMSG = 'Could not get ' // MET_CRO_2D //' file description'
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
              END IF

              NCOLS3D = GL_NCOLS
              NROWS3D = GL_NROWS

              XORIG3D = XORIG_GD
              YORIG3D = YORIG_GD

!...advance to time variable for the output file to the next hour

              SDATE3D = JDATE
              STIME3D = 10000 * ( JTIME / 10000 )     !  clear MMSS fields
              TSTEP3D = TSTEP     
              CALL NEXTIME ( SDATE3D, STIME3D, TSTEP3D ) !  on the next hour

              NVARS3D = N_SPC_WDEP + 1

!...define wet deposition output descriptors for gaseous species

              SPC = 0
              STRT = 1
              FINI = N_GC_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = GC_WDEP( SPC )
                 UNITS3D ( VAR ) = 'kg ha-1'
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define wet deposition output descriptors for aerosol species

              SPC = 0
              STRT = N_GC_WDEP + 1
              FINI = N_GC_WDEP + N_AE_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = AE_WDEP( SPC )
                 IF ( INDEX( AE_WDEP( SPC ), 'NUM' ) .GT. 0 ) THEN
                    UNITS3D ( VAR ) = 'ha-1'
                 ELSE IF ( INDEX( AE_WDEP( SPC ), 'SRF' ) .GT. 0 ) THEN
                    UNITS3D ( VAR ) = 'm2 ha-1'
                 ELSE
                    UNITS3D ( VAR ) = 'kg ha-1'
                 END IF
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define wet deposition output descriptors for non-reactive species

              SPC = 0
              STRT = N_GC_WDEP + N_AE_WDEP + 1
              FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = NR_WDEP( SPC )
                 UNITS3D ( VAR ) = 'kg ha-1'
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define wet deposition output descriptors for tracer species

              SPC = 0
              STRT = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + 1
              FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
              DO VAR = STRT, FINI
                 SPC = SPC + 1
                 VTYPE3D ( VAR ) = M3REAL
                 VNAME3D ( VAR ) = TR_WDEP( SPC )
                 UNITS3D ( VAR ) = 'kg ha-1'
                 VDESC3D ( VAR ) = 'hourly wet deposition values'
              END DO

!...define output descriptor for hydrogen concentration

              VAR = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP + 1
              VTYPE3D( VAR ) = M3REAL
              VNAME3D( VAR ) = 'HPLUS'
              UNITS3D( VAR ) = 'kg ha-1'
              VDESC3D( VAR ) = 'hourly wet deposition values'

!...initialize the file descriptors

              FDESC3D( 1 ) = 'hourly 1-layer cross-point wet deposition'
     &                       // ' from all cloud types'
              DO L = 2 , MXDESC3
                 FDESC3D( L ) = ' '
              END DO

              GDNAM3D = GRID_NAME  ! from HGRD_DEFN

!...try to open the output file new

              IF ( .NOT. OPEN3( CTM_WET_DEP_1, FSNEW3, PNAME ) ) THEN
                 XMSG = 'Could not create '// CTM_WET_DEP_1 // ' file'
                 CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
              END IF

           END IF   ! open CTM_WET_DEP_1 read/write

#ifdef sens
           IF ( .NOT. OPEN3( CTM_SWETDEP_1, FSRDWR3, PNAME ) ) THEN
               XMSG = 'Could not open ' // CTM_SWETDEP_1 //
     &                ' file for update - try to open new'
               CALL M3MESG( XMSG )

C...Create sensitivity wet deposition file:
               NVARS3D = ( N_SPC_WDEP + 1 ) * NPMAX

               ALLOCATE ( S_WETDEPSPC( NVARS3D ) )
               S_WETDEPSPC = 'blank'

               VTYPE3D = M3REAL
               VDESC3D = 'Sens of hourly wet dep values'              

C...define sens wet deposition output descriptors for gaseous species
               SPC = 0
               STRT = 1
               FINI = N_GC_WDEP
               DO VAR = STRT, FINI
                 SPC = SPC + 1
                 DO NP = 1, NPMAX
                   SENNUM = ( SPC - 1 ) * NPMAX + NP
                   VNAME3D ( SENNUM ) = TRIM( GC_WDEP( SPC )( 1:7 ) ) //'_'// SEN_PAR( NP )
                   UNITS3D ( SENNUM ) = 'kg/hectare'
                   S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                 END DO
               END DO

C...define wet deposition output descriptors for aerosol species
               SPC = 0
               STRT = N_GC_WDEP + 1
               FINI = N_GC_WDEP + N_AE_WDEP
               DO VAR = STRT, FINI
                  SPC = SPC + 1
                  DO NP = 1, NPMAX
                     SENNUM = ( NPMAX * N_GC_WDEP ) + ( SPC - 1 ) *NPMAX + NP
                     VNAME3D ( SENNUM ) = TRIM( AE_WDEP( SPC )( 1:7 ) ) //'_'// SEN_PAR( NP )
                     IF ( INDEX( AE_WDEP( SPC ), 'NUM' ) .GT. 0 ) THEN
                        UNITS3D ( SENNUM ) = 'number/hectare'
                     ELSE IF ( INDEX( AE_WDEP( SPC ), 'SRF' ) .GT. 0 ) THEN
                        UNITS3D ( SENNUM ) = 'm2/hectare'
                     ELSE
                        UNITS3D ( SENNUM ) = 'kg/hectare'
                     END IF
                     S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                  END DO
               END DO

C...define wet deposition output descriptors for non-reactive species
               SPC = 0
               STRT = N_GC_WDEP + N_AE_WDEP + 1
               FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP
               DO VAR = STRT, FINI
                  SPC = SPC + 1
                  DO NP = 1, NPMAX
                     SENNUM = NPMAX * ( N_GC_WDEP + N_AE_WDEP ) + ( SPC - 1 ) * NPMAX + NP
                     VNAME3D ( SENNUM ) = TRIM( NR_WDEP( SPC )( 1:7 ) ) //'_'// SEN_PAR( NP )
                     UNITS3D ( SENNUM ) = 'kg/hectare'
                     S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                  END DO
               END DO

C...define wet deposition output descriptors for tracer species
               SPC = 0
               STRT = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + 1
               FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
               DO VAR = STRT, FINI
                  SPC = SPC + 1
                  DO NP = 1, NPMAX
                     SENNUM = NPMAX * ( N_GC_WDEP + N_AE_WDEP + N_NR_WDEP ) + ( SPC - 1 ) * NPMAX + NP
                     VNAME3D ( SENNUM ) = TRIM( TR_WDEP( SPC )( 1:7 ) ) //'_'// SEN_PAR( NP )
                     UNITS3D ( SENNUM ) = 'kg/hectare'
                     S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
                  END DO
               END DO

C...define output descriptor for hydrogen concentration
               VAR = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
               DO NP = 1, NPMAX
                  SENNUM = NPMAX * VAR + NP
                  VNAME3D ( SENNUM ) = 'HPLUS_' // SEN_PAR( NP )
                  UNITS3D ( SENNUM ) = 'kg/hectare'
                  S_WETDEPSPC ( SENNUM ) = VNAME3D ( SENNUM )
               END DO

C...initialize the file descriptors
               FDESC3D = ' '
               FDESC3D( 1 ) = 'Sensitivity of hourly 1-layer '
     &                        // 'cross-point wet deposition '
     &                        // 'from all cloud types'
C...try to open the output file new
               IF ( .NOT. OPEN3( CTM_SWETDEP_1, FSNEW3, PNAME ) ) THEN
                  XMSG = 'Could not create '// CTM_SWETDEP_1 // ' file'
                  CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
               END IF

           END IF   ! open CTM_SWETDEP_1 read/write
#endif

!...open the diagnostic file if user asked for it

           IF ( CLD_DIAG ) THEN

!...Try to open existing file for update
              WRITE( LOGDEV, * )
              IF ( .NOT. OPEN3( CTM_WET_DEP_2, FSRDWR3, PNAME ) ) THEN

                 XMSG = 'Could not open ' // CTM_WET_DEP_2 // ' file for update - '
     &                  // 'try to open new'
                 CALL M3MESG( XMSG )

!...copy most of header description from
!...CTM_WET_DEP_1 and initialize depositions to zero.

!...get description from the other wet dep file

                 IF ( .NOT. DESC3( CTM_WET_DEP_1 ) ) THEN
                    XMSG = 'Could not get ' // CTM_WET_DEP_1 //' file description'
                    CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                 END IF

!...advance to time variable for the output file to the next hour

                 SDATE3D = JDATE
                 STIME3D = 10000 * ( JTIME / 10000 )     !  clear MMSS fields
                 TSTEP3D = TSTEP     
                 CALL NEXTIME ( SDATE3D, STIME3D, TSTEP3D ) !  on the next hour

                 NVARS3D = N_SPC_WDEP + 8 + 4

!...define output descriptor for pressure at the lifting condensation
!...level (LCL)

                 VAR = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP + 2
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PLCL'
                 UNITS3D( VAR ) = 'Pa'
                 VDESC3D( VAR ) = 'pressure at lifting condensation level, '
     &                            // 'or MISSING = -9999.9'

!...define output descriptor for cloud bottom layer number

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'CLOUD_BOTTOM'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'layer number containing bottom of cloud, or MISSING = -9999.9'

!...define output descriptor for precipitating cloud top layer number

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PR_CLOUDTOP'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'layer number containing top of PR cloud, or MISSING = -9999.9'

!...define output descriptor for non-precipitating cloud top layer number

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'NP_CLOUDTOP'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'layer number containing top of NP cloud, or MISSING = -9999.9'

!...define output descriptor for rain event flag

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'RAIN_FLAG'
                 UNITS3D( VAR ) = ''
                 VDESC3D( VAR ) = 'Rain-event flag (values: 1,0)'
 
!...define output descriptor for precitating cloud fraction

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PR_CLDFRAC'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Precipitating cloud fraction'

!...define output descriptor for non-precipitating cloud fraction

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'NP_CLDFRAC'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Non-precipitating cloud fraction'

!...define output descriptor for precipitating cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'PR_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Precipitating cloud transmissivity'

!...define output descriptor for non-precipitating cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'NP_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Non-precipitating cloud transmissivity'

!...define output descriptor for resolved cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'RES_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Resolved cloud transmissivity'

!...define output descriptor for overall cloud transmissivity

                 VAR = VAR + 1
                 VTYPE3D( VAR ) = M3REAL
                 VNAME3D( VAR ) = 'CLD_TRANS'
                 UNITS3D( VAR ) = '1'
                 VDESC3D( VAR ) = 'Total cloud transmissivity'

!...initialize the file descriptors

                 FDESC3D( 1 ) = 'hourly 1-layer cross-point wet deposition '
     &                           // 'from sub-grid clouds and cloud data'
                 DO L = 2 , MXDESC3
                    FDESC3D( L ) = ' '
                 END DO

!...try to open the diagnostic output file

                 IF ( .NOT. OPEN3( CTM_WET_DEP_2, FSNEW3, PNAME ) ) THEN
                    XMSG = 'Could not create '// CTM_WET_DEP_2 // ' file'
                    CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
                 END IF

              END IF   ! open CTM_WET_DEP_2 read/write

           END IF   ! CLD_DIAG

        END IF   ! IO_PE_INCLUSIVE

      END SUBROUTINE OPWDEP

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE INITSCEN ( CGRID, TSTEP)

C-----------------------------------------------------------------------
C Function:
C   Initialize simulation time period and time stepping constants for
C   core model driver
C   Environment variable can reference a previous CONC file to use as
C   initial data.
C   Write initial conc data as step "0" on output conc file
 
C Preconditions:
 
C Subroutines and functions called:
C   M3EXIT, OPEN3, CLOSE3, DESC3, TIME2SEC, HHMMSS
 
C Revision history:
C   prototype 6/92 by CJC for "concept model"
C   revised   2/93 by CJC for initial M3 Prototype Alpha
C   revised   6/14/94 by Dongming Hwang for configuration management prototype
C   revised   8/30/94 by Dongming Hwang: If CTM_CONC_1 file doesn't exist,
C             use header info from CHEMINIT3D file.
 
C Interim Version ... (Jeff)

C   revised  6/12/97 by Jerry Gipson: Get ICs by species name, by surrogate
C            name, or zero
C   Jeff - Aug 97 - fixed problems, cleaned up
C   Jeff - Dec 97 - add CMIN
C   Jeff - Dec 97 - put in aerosol sulfate inititalization
C   Jeff - Feb 98 - close init cond files after reading
C   2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   revised 10/7/99 by Shawn Roselle: added surface area species to
C            aerosol species types
C   Jeff - Dec 00 - check if append, split out opconc and load_cgrid
C                 - move CGRID_MAP into f90 module
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; assumed shape arrays
C   17 Mar 03 D.Wong: move barrier to avoid race conditions
C   28 Aug 03 J.Young: following Zion Wang at CERT, only pe 0 closes
C   30 May 05 J.Young: add call to load RHOJ into CGRID
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   Aug 15 D.Wong:    Added two new subroutine calls to open ACONC and WDEP files
C   Dec 15 D.Wong: new routine wr_init to write the initial data to the CONC file
C   1 Feb 19 David Wong: Implemented centralized I/O approach, removed
C                        all MY_N clauses
C   29 Oct 18 L.Zhou, S.Napelenok: isam implementation
C   26 Nov 19 S. Napelenok: DDM3D implementation for CMAQ v5.3.1
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE HGRD_DEFN             ! horizontal domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
#ifdef parallel
      USE VERTEXT_MODULE
#endif

#ifdef isam
      USE SA_DEFN
#endif

#ifdef sens
      USE DDM3D_DEFN
      USE VGRD_DEFN, ONLY: NLAYS
#endif

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

!     REAL      :: CGRID( :,:,:,: )  ! for initial CONC
      REAL, POINTER :: CGRID( :,:,:,: )  ! for initial CONC
      INTEGER      TSTEP( 3 )   ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency
!     INTEGER      NSTEPS       ! run duration, as number of output time steps

C Parameters:

      REAL, PARAMETER :: CMIN = 1.0E-30

C Local Variables
      CHARACTER( 16 ) :: PNAME = 'INITSCEN'
      CHARACTER( 16 ) :: FNAME
      CHARACTER( 96 ) :: MSG = ' '

      INTEGER      STEPSECS          ! seconds per time step
      INTEGER      TOTSECS           ! run duration seconds

#ifdef Verbose3
      real sumcg
      integer c, r, l, s, v
#endif

#ifdef sens
      integer COL,ROW,LAY,SPC
#endif

      INTERFACE
         SUBROUTINE LOAD_CGRID ( FNAME, SPC_CAT, CMIN, CGRID )
            CHARACTER( 16 ), INTENT( IN ) :: FNAME
            CHARACTER(  2 ), INTENT( IN ) :: SPC_CAT
            REAL,    INTENT( IN )         :: CMIN
            REAL, POINTER                 :: CGRID( :,:,:,: )
         END SUBROUTINE LOAD_CGRID
         SUBROUTINE WR_INIT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER                 :: CGRID(:,:,:,:)
            INTEGER, INTENT( IN )         :: JDATE
            INTEGER, INTENT( IN )         :: JTIME
            INTEGER, INTENT( IN )         :: TSTEP
         END SUBROUTINE WR_INIT
#ifdef isam
         SUBROUTINE SA_ARRAY_INIT ( CGRID )
            IMPLICIT NONE
            REAL, POINTER                 :: CGRID( :,:,:,: )
         END SUBROUTINE SA_ARRAY_INIT
         SUBROUTINE OP_SA ( JDATE, JTIME, TSTEP, NSTEPS, FNAME )
            IMPLICIT NONE
            INTEGER :: JDATE, JTIME
            INTEGER :: TSTEP(2)
            INTEGER :: NSTEPS
            CHARACTER( 16 ) :: FNAME
         END SUBROUTINE OP_SA
         SUBROUTINE SA_OPWDDEP ( SADEPFILE, JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            CHARACTER( 16 ) :: SADEPFILE ! Dry or wet dep file for tags
            INTEGER         :: JDATE, JTIME, TSTEP
         END SUBROUTINE SA_OPWDDEP
#endif
#ifdef sens
         SUBROUTINE LOAD_SENGRID ( FNAME, STDATE, STTIME, SPC_CAT )
            IMPLICIT NONE
            CHARACTER( 16 ), INTENT( IN ) :: FNAME
            INTEGER, INTENT( IN )         :: STDATE, STTIME
            CHARACTER(  2 ), INTENT( IN ) :: SPC_CAT
         END SUBROUTINE LOAD_SENGRID
#endif
      END INTERFACE

C-----------------------------------------------------------------------

      TSTEP( 1 ) = LOCAL_TSTEP 

#ifdef isam
      IF ( MYPE .EQ. 0 ) THEN
         WRITE( LOGDEV,* ) 'Entered INITSCEN...'
         WRITE( LOGDEV,* ) 'NSPC_SA, NTAG_SA:', NSPC_SA, NTAG_SA
      END IF
#endif

C Initialize the CGRID array
      CGRID = CMIN

C Load CGRID
      IF ( N_GC_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'GC', CMIN, CGRID )
#ifdef Verbose3
         write( logdev,'(/"@@@c ", i8, i7.6)') stdate, sttime
         l = 1
         do v = gc_strt, gc_fini
            s = v + 1 - gc_strt
            sumcg = 0.0
            do r = 1, nrows
               do c = 1, ncols
                  sumcg = sumcg + cgrid( c,r,l,v )
               end do
            end do
            write( logdev,'("@@@c ", a, i5, g16.6)') gc_spc( s ), s, sumcg
         end do
#endif
      END IF  ! N_GC_SPC > 0

C load rhoj
      FNAME = MET_CRO_3D
      CALL LOAD_CGRID ( FNAME, 'RJ', CMIN, CGRID )

C Get aerosols IC's
      IF ( N_AE_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'AE', CMIN, CGRID )
      END IF  ! N_AE_SPC > 0

C Get non-reactives IC's
      IF ( N_NR_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'NR', CMIN, CGRID )
      END IF  ! N_NR_SPC > 0

C Get tracer IC's
      IF ( N_TR_SPC .GT. 0 ) THEN
         FNAME = INIT_CONC_1
         CALL LOAD_CGRID ( FNAME, 'TR', CMIN, CGRID )
      END IF  ! N_TR_SPC > 0

C Test opening existing conc file for update
      CALL LOG_HEADING( LOGDEV, "Open or Create Concentration File" )

      IF ( .NOT. OPEN3( CTM_CONC_1, FSRDWR3, PNAME ) ) THEN
#ifndef twoway
         BACKSPACE( LOGDEV )
#endif
         MSG = 'Could not open ' // TRIM( CTM_CONC_1 ) // ' for update - '
     &        // 'try to open new'
         CALL M3MESG( MSG )
         ! Open the file new
         CALL SUBST_BARRIER
         CALL OPCONC ( STDATE, STTIME, TSTEP( 1 ) )
#ifdef parallel
         CALL OPVEXT ( STDATE, STTIME, TSTEP( 1 ) )
#endif
      END IF

      CALL WR_INIT ( CGRID, STDATE, STTIME, TSTEP( 1 ) )
      
      CALL LOG_HEADING( LOGDEV, "Open or Create Average Concentration File" )
      CALL OPACONC ( STDATE, STTIME, TSTEP( 1 ) )
      
      CALL LOG_HEADING( LOGDEV, "Open or Create Wet Deposition File" )
      CALL OPWDEP  ( STDATE, STTIME, TSTEP( 1 ) )

#ifdef sens
      CALL OPASENS( STDATE, STTIME, TSTEP( 1 ) )
#endif

#ifdef isam
C Initialize ISAM array
      CALL SA_ARRAY_INIT ( CGRID )

C Open SA_CONC_1 and SA_CGRID_1
      CALL OP_SA ( STDATE, STTIME, TSTEP, 1, SA_CONC_1 )
      IF ( MYPE .EQ. 0 ) CALL SA_OPWDDEP ( SA_WD_1, STDATE, STTIME, TSTEP( 1 ) )
#endif

#ifdef sens
      IF ( RST ) THEN ! Load SENGRID from a file

         IF ( N_GC_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'GC' )
         END IF  ! N_GC_SPC > 0

         FNAME = MET_CRO_3D
         CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'RJ' )

         IF ( N_AE_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'AE')
         END IF  ! N_AE_SPC > 0

         IF ( N_NR_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'NR' )
         END IF  ! N_NR_SPC > 0

         IF ( N_TR_SPC .GT. 0 ) THEN
            FNAME = INIT_SENS_1
            CALL LOAD_SENGRID ( FNAME, STDATE, STTIME, 'TR' )
         END IF  ! N_TR_SPC > 0

      ELSE  ! Set to initial conditions or 0.0

         DO NP = 1, NPMAX
            IF ( IPT( NP ) .EQ. 1 ) THEN
               DO SPC = 1, NSPCSD
                  DO LAY = 1, NLAYS
                     DO ROW = 1, NROWS
                        DO COL = 1, NCOLS
                           SENGRID( COL, ROW, LAY, NP, SPC) =
     &                               CGRID( COL, ROW, LAY, SPC )
     &                             * REAL( IPARM( NP, SPC ) )
     &                             * IREGION( COL, ROW, LAY, NP )
                        END DO
                     END DO
                  END DO
               END DO
            ELSE
               DO SPC = 1, NSPCSD
                  DO LAY = 1, NLAYS
                     DO ROW = 1, NROWS
                        DO COL = 1, NCOLS
                           SENGRID( COL, ROW, LAY, NP, SPC) = 0.0
                        END DO
                     END DO
                  END DO
               END DO
            END IF
         END DO

      END IF
#endif

      CALL SUBST_BARRIER

      CALL LOG_HEADING( LOGDEV, "Check Initial Concentrations" )

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AQCHEM ( JDATE, JTIME, TEMP, PRES_PA, TAUCLD, PRCRATE,
     &                    WCAVG, WTAVG, AIRM, ALFA0, ALFA2, ALFA3, GAS,
     &                    AEROSOL, GASWDEP, AERWDEP, HPWDEP, BETASO4, DARK )

C-----------------------------------------------------------------------
C  Description:
C    Compute concentration changes in cloud due to aqueous chemistry,
C    scavenging and wet deposition amounts.
C
C  Revision History:
C      No   Date   Who  What
C      -- -------- ---  -----------------------------------------
C      0  / /86    CW   BEGIN PROGRAM - Walceks's Original Code
C      1  / /86    RB   INCORPORATE INTO RADM
C      2  03/23/87 DH   REFORMAT
C      3  04/11/88 SJR  STREAMLINED CODE - ADDED COMMENTS
C      4  08/27/88 SJR  COMMENTS, MODIFIED FOR RPM
C      4a 03/15/96 FSB  Scanned hard copy to develop Models3
C                       Version.
C      5  04/24/96 FSB  Made into Models3 Format
C      6  02/18/97 SJR  Revisions to link with Models3
C      7  08/12/97 SJR  Revised for new concentration units (moles/mole)
C                       and new treatment of nitrate and nitric acid
C      8  01/15/98 sjr  revised to add new aitken mode scavenging
C                       and aerosol number scavenging
C      9  12/15/98 David Wong at LM:
C             -- change division of XL, TEMP to multiplication of XL, TEMP
C                reciprocal, respectively
C             -- change / TOTOX / TSIV to / ( TOTOX * TSIV )
C     10  03/18/99 David Wong at LM:
C             -- removed "* 1.0" redundant calculation at TEMP1 calculation
C     11  04/27/00 sjr  Added aerosol surface area as modeled species
C     12  12/02    sjr  changed calls to HLCONST and updated the dissociation
C                       constants
C     13  06/26/03 sjr  revised calculations of DTW based on CMAS website
C                       discussions
C     14  08/05/03 sjr  revision made to the coarse aerosol number washout
C     15  04/20/05  us  revisions to add sea salt species in the fine and
C                       coarse aerosol modes, and HCl dissolution/dissociation
C         08/01/05 sjr  Modified for sulfate tracking model
C     16  10/13/05 sjr  fixed bug in the integration time step calculation
C                       (reported by Bonyoung Koo)
C     17  03/01/06 sjr  added elemental carbon aerosol; organic aerosols
C                       replaced with primary, secondary biogenic, and
C                       secondary anthropogenic; fixed 3rd moment calc to
C                       include EC and primary organics (not secondary);
C                       re-arranged logic for setting Cl & Na ending conc;
C                       added pointers/indirect addressing for arrays WETDEP
C                       and LIQUID
C     16  03/30/07 sjr  Limit integration timestep by cloud washout time
C     17  04/10/07 sjr  increased loop limits as follows: I20C <10000,
C                       I7777C <10000, I30C <10000, ICNTAQ <60000
C     18  01/10/07 agc  added organic chemistry for GLY and MGLY oxidation
C     19  09/10/07 sln  updated SOA species list for AE5
C     20  01/29/08 agc  updated DOHDT calculation
C     21  04/14/08 jtk  added coding for coarse NH4 and scavenging of
c                       coarse surface area
C     22  05/20/08 agc  for CB05, use the Henry's Law constant for glyoxal
C                       as a surrogate for methyl glyoxal
C     23  04/15/09 sjr& Several changes made to improve mass conservation in the
C                  agc  solver.  (1) OH concentration is now considered to be
C                       steady state; (2) only allow sulfur oxidation to affect
C                       time step; (3) implemented mass conservation checks -
C                       limit oxidation rates by the available mass for the
C                       specified timestep.
C   10 Oct 10 J.Young:  update to use aero_reeng by Steve Howard, Prakash Bhave,
C                       Jeff Young, Sergey Napelenok, and Shawn Roselle
C   01 Mar 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    9 Mar 11 S.Napelenok: update for AE6 - pH calculation now expanded to
C                       include Ca Mg K SOIL CORS SEAS
C   23 May 11 G.Sarwar: update S(VI) production rate via H2O2, O3, MHP, PAA
C                       pathways (Jacobson 1997)
C   23 May 11 G.Sarwar: update S(VI) production rate via O2 pathway (metal
C                       catalysis) (Martin and Goodman, 1991)
C   01 Jul 11 G.Sarwar: Incorporate day and night dependent Fe III oxidation
C                       state (Alexander et al.,  2009)
C   12 Aug 11 G.Sarwar: Revise Fe and Mn solubility based on
C                       Alexander et al., 2009
C
C    8 Mar 12 J.Bash:   FE_OX and MN_OX were calculated from FE and MN before
C                       a floor value of 0.0 was established for these
C                       concentrations sometimes resulting in negative
C                       concentrations and model crashes. The code used to
C                       estimate FE_OX and MN_OX was moved to be after a floor
C                       value for FE and MN was set. Also the washout rate was
C                       removed from the calculation of the estimate for doubling
C                       the time step based on sulfur oxidized < 5%.
C   28 Nov 12 G.Sarwar: Sulfate inhibition effect is implemented in the metal catalysis pathway
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   12 Feb 15 B.Hutzell: reduced number of exp(...) calculations for scavenging aitken
C                        aerosols to improve efficiency
C   15 Jun 15 J.Young:  Fixed bug found by Martin Otte in calculations for scavenging
C                       aitken aerosols
C   15 Apr 16 J.Young:  Use aerosol factors from AERO_DATA module named constants
C   19 Apr 18 K.Fahey:  For species with both gas phase and coarse mode aerosol components, avoid
C                       introducing extra mass when the coarse mode concentration is greater than 
C                       the total amount left in the aqueous phase after redistribution between the 
C                       phases. 
C   26 Nov 18 S.Napelenok: ISAM implementation
C   31 Dec 19 S.Napelenok: DDM-3D implementation for version 5.3.1

C
C  References:
C     Walcek & Taylor, 1986, A theoretical Method for computing
C        vertical distributions of acidity and sulfate within cumulus
C        clouds, J. Atmos Sci.,  Vol. 43, no. 4 pp 339 - 355
C     Carlton, A.G., B.J. Turpin, K.E. Altieri, S.P. Seitzinger, R. Mathur,
C        S.J. Roselle, and R.J. Weber, CMAQ Model Performance Enhanced When
C        In-Cloud Secondary Organic Aerosol is Included:  Comparison of Organic
C        Carbon Predictions with Measurements, Environ. Sci. Technol., 42(23),
C        8798-8802, 2008.
C     Jacobson, M., Development and application of a new air pollution modeling
C        system II. Aerosol module structure and design, Atmospheric
C        Environment, 31, 131-144, 1997
C     Martin, R.L. and T.W. Good, catalyzed oxidation of sulfur dioxide in
C        solution: the iron-manganese synercism, Atmospheric Environment, 25A,
C        2395-2399, 1991
C     Alexander, B., R.J. Park, D.J. jacob, S. Gong, Transition metal-catalyzed
C        oxidation of atmospheric sulfur: global implications for the sulfur
C        budget, GRL, 114, D02309, 2009

C  Called by:  AQMAP

C  Calls the following subroutines:  none

C  Calls the following functions:  HLCONST

C  Arguments     Type      I/O       Description
C  ---------     ----  ------------  --------------------------------
C  GAS(ngas)     real  input&output  Concentration for species i=1,15
C  GASWDEP(ngas) real     output     wet deposition for species

C  AEROSOL(naer,nmodes) real input&output   Concentration for species i=1,51
C  AERWDEP(naer,nmodes) real     output     wet deposition for species
C-----------------------------------------------------------------------

      USE RXNS_DATA       ! chemical mechanism data
      USE AQ_DATA         ! doesn't inherit; gets only n_aerospc, conmin from AERO_DATA
      USE AERO_DATA
      USE UTILIO_DEFN
#ifdef isam
      USE SA_DEFN, ONLY: DEPSUM_SAVE, DS4_SAVE, REMOV_SAVE
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_POLC, S_CEND, S_REMOV,
     &                       S_REMOVAC, S_HPWDEP, S_GAS, S_GASWDEP,
     &                       S_AEROSOL, S_AERWDEP, IHIGH, IPT
#endif

      IMPLICIT NONE

      INCLUDE SUBST_CONST          ! constants

      CHARACTER( 120 ) :: XMSG = ' '  ! Exit status message

C...........Parameters:

      INTEGER, PARAMETER :: NUMOX = 5          ! number of oxidation reactions

      REAL( 8 ), PARAMETER :: H2ODENS = 1000.0D0   ! water density at 20 C and 1 ATM (kg/m3)
      REAL( 8 ), PARAMETER :: SEC2HR  = 1.0D0 / 3600.0D0 ! convert seconds to hours
      REAL( 8 ), PARAMETER :: SCVEFF  = 100.0D0    ! Scavenging efficiency (%)

C...........Arguments:

      INTEGER,   INTENT( IN )  :: JDATE  ! current model date, coded YYYYDDD
      INTEGER,   INTENT( IN )  :: JTIME  ! current model time, coded HHMMSS

      REAL,      INTENT( IN )  :: AIRM      ! total air mass in cloudy layers (mol/m2)
      REAL,      INTENT( IN )  :: ALFA0     ! scav coef for aitken aerosol number
      REAL,      INTENT( IN )  :: ALFA2     ! scav coef for aitken aerosol sfc area
      REAL,      INTENT( IN )  :: ALFA3     ! scav coef for aitken aerosol mass
      REAL,      INTENT( OUT ) :: HPWDEP    ! hydrogen wet deposition (mm mol/liter)
      REAL( 8 ), INTENT( OUT ) :: BETASO4
      REAL,      INTENT( IN )  :: PRCRATE   ! precip rate (mm/hr)
      REAL,      INTENT( IN )  :: PRES_PA   ! pressure (Pa)
      REAL,      INTENT( IN )  :: TAUCLD    ! timestep for cloud (s)
      REAL,      INTENT( IN )  :: TEMP      ! temperature (K)
      REAL,      INTENT( IN )  :: WCAVG     ! liquid water content (kg/m3)
      REAL,      INTENT( IN )  :: WTAVG     ! total water content (kg/m3)
      REAL( 8 ), INTENT( INOUT ) :: GAS    ( : )   ! gas phase concentrations (mol/molV)
      REAL( 8 ), INTENT( INOUT ) :: AEROSOL( :,: ) ! aerosol concentrations (mol/molV)
      REAL( 8 ), INTENT( INOUT ) :: GASWDEP( : )   ! gas phase wet deposition array (mm mol/liter)
      REAL( 8 ), INTENT( INOUT ) :: AERWDEP( :,: ) ! aerosol wet deposition array (mm mol/liter)
      LOGICAL,   INTENT( IN )    :: DARK           ! DARK = TRUE is night,  DARK = FALSE is day

C...........Local Variables (scalars):

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru

      CHARACTER( 16 ), SAVE :: PNAME = 'AQCHEM'             ! driver program name
      CHARACTER( 16 ), SAVE :: MGLYSUR = 'METHYL_GLYOXAL  ' ! Henry's law surrogate for MGLY

      INTEGER      ISPC            ! loop counter for species
      INTEGER      I20C            ! loop counter for do loop 20
      INTEGER      I30C            ! loop counter for do loop 30
      INTEGER      ITERAT          ! # iterations of aqueous chemistry solver
      INTEGER      I7777C          ! aqueous chem iteration counter
      INTEGER      ICNTAQ          ! aqueous chem iteration counter
      INTEGER      LIQ             ! loop counter for liquid species
      INTEGER      IGAS            ! loop counter for gas species
      INTEGER      IOX             ! index over oxidation reactions

      REAL( 8 ) :: DEPSUM
      REAL( 8 ) :: A               ! iron's anion concentration
      REAL( 8 ) :: HPLUS           ! H+ concentration in cloudwater (mol/liter)
      REAL( 8 ) :: ACT1            ! activity correction factor, single ions
      REAL( 8 ) :: ACT2            ! activity factor correction, double ions
      REAL( 8 ) :: ACTB            !
      REAL( 8 ) :: AE              ! guess for H+ conc in cloudwater (mol/liter)
      REAL( 8 ) :: B               ! manganese's anion concentration
      REAL( 8 ) :: PRES_ATM        ! pressure (Atm)
      REAL( 8 ) :: BB              ! lower limit guess of cloudwater pH
      REAL( 8 ) :: CA              ! Calcium conc in cloudwater (mol/liter)
      REAL( 8 ) :: CL              ! total Cl-  conc in cloudwater (mol/liter)
      REAL( 8 ) :: CLACC           ! fine Cl- in cloudwater (mol/liter)
      REAL( 8 ) :: CLCOR           ! coarse Cl-  conc in cloudwater (mol/liter)
      REAL( 8 ) :: CO2H            ! Henry's Law constant for CO2
      REAL( 8 ) :: CO21            ! First dissociation constant for CO2
      REAL( 8 ) :: CO22            ! Second dissociation constant for CO2
      REAL( 8 ) :: CO212           ! CO21*CO22
      REAL( 8 ) :: CO212H          ! CO2H*CO21*CO22
      REAL( 8 ) :: CO21H           ! CO2H*CO21
      REAL( 8 ) :: CO2L            ! CO2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: CO3             ! CO3= conc in cloudwater (mol/liter)
      REAL( 8 ) :: CTHK1           ! cloud thickness (m)
      REAL( 8 ) :: DSIV_SCALE      ! mass conservation scale factor for S(IV)
      REAL( 8 ) :: DTRMV           !
      REAL( 8 ) :: DTS6            !
      REAL( 8 ) :: DGLYDT          ! change in GLY (mol/liter/sec)
      REAL( 8 ) :: DMGLYDT         ! change in MGLY (mol/liter/sec)
!     REAL( 8 ) :: DOHDT           ! change in OH
      REAL( 8 ) :: DGLY1           ! change due to Rxn. in GLY for DTW(0) time step
      REAL( 8 ) :: DMGLY1          ! change due to Rxn. in MGLY for DTW(0) time step
!     REAL( 8 ) :: DOH1            ! change in OH for DTW(0) time step
      REAL( 8 ) :: DORGC           ! change in ORGC for DTW(0) time step (mol/liter)
      REAL( 8 ) :: EBETASO4T       ! EXP( -BETASO4 * TAUCLD )
      REAL( 8 ) :: EALFA0T         ! EXP( -ALFA0 * TAUCLD )
      REAL( 8 ) :: EALFA2T         ! EXP( -ALFA2 * TAUCLD )
      REAL( 8 ) :: EALFA3T         ! EXP( -ALFA3 * TAUCLD )
      REAL( 8 ) :: EC              ! elemental carbon acc+akn aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: FA              ! functional value ??
      REAL( 8 ) :: FB              ! functional value ??
      REAL( 8 ) :: FCLCOR          ! frac weight of coarse CL to (acc+coarse) CL
      REAL( 8 ) :: FE              ! Fe+++ conc in cloudwater (mol/liter)
      REAL( 8 ) :: FHNO3           ! frac weight of HNO3 to total NO3
      REAL( 8 ) :: FNH3            ! frac weight of NH3 to total ammonia
      REAL( 8 ) :: FNH4ACC         ! frac weight of NH4 acc to total ammonia
      REAL( 8 ) :: FNH4COR         ! frac weight of coarse NH4 to (acc+coarse) NH4
      REAL( 8 ) :: FNO3ACC         ! frac weight of NO3 acc to total NO3     
      REAL( 8 ) :: FNO3COR         ! frac weight of coarse NO3 to (acc+coarse) NO3
      REAL( 8 ) :: FRACLIQ         ! fraction of water in liquid form
      REAL( 8 ) :: FOA1            ! First dissociation constant for FOA (Formic Acid)
      REAL( 8 ) :: FOAH            ! Henry's Law constant for FOA
      REAL( 8 ) :: FOA1H           ! FOAH*FOA1
      REAL( 8 ) :: FOAL            ! FOA conc in cloudwater (mol/liter)
      REAL( 8 ) :: FTST            !
      REAL( 8 ) :: GLYH            ! Henry's Law constant for glyoxal
      REAL( 8 ) :: GLYL            ! glyoxal conc in cloud water (mol/liter)
      REAL( 8 ) :: GM              !
      REAL( 8 ) :: GM1             !
      REAL( 8 ) :: GM1LOG          !
      REAL( 8 ) :: GM2             ! activity correction factor
      REAL( 8 ) :: GM2LOG          !
      REAL( 8 ) :: HA              !
      REAL( 8 ) :: HB              !
      REAL( 8 ) :: H2OW            !
      REAL( 8 ) :: H2O2H           ! Henry's Law Constant for H2O2
      REAL( 8 ) :: H2O2L           ! H2O2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HCLH            ! Henry's Law Constant for HCL
      REAL( 8 ) :: HCL1            ! First dissociation constant for HCL
      REAL( 8 ) :: HCL1H           ! HCL1*HCLH
      REAL( 8 ) :: HCLL            ! HCl  conc in  cloudwater (mol/liter)
      REAL( 8 ) :: HCO2            ! HCO2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HCO3            ! HCO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HNO3H           ! Henry's Law Constant for HNO3
      REAL( 8 ) :: HNO31           ! First dissociation constant for HNO3
      REAL( 8 ) :: HNO31H          !
      REAL( 8 ) :: HNO3L           ! HNO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HOH             ! Henry's Law Constant for HO
      REAL( 8 ) :: HSO3            ! HSO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: HSO4            ! HSO4 concn in cloudwater (mol/liter)
      REAL( 8 ) :: HSO4ACC         ! accumulation mode HSO4 concn in cloudwater (mol/liter)
      REAL( 8 ) :: HSO4COR         ! coarse HSO4 concn in cloudwater (mol/liter)
      REAL( 8 ) :: HTST            !
      REAL( 8 ) :: K               ! K conc in cloudwater (mol/liter)
      !REAL( 8 ) :: LGTEMP          ! log of TEMP
      REAL( 8 ) :: MG              !
      REAL( 8 ) :: MGLYH           ! Henry's Law Constant for methylglyoxal
      REAL( 8 ) :: MGLYL           ! MGLY conc in cloud water (mol/liter)
      REAL( 8 ) :: MHPH            ! Henry's Law Constant for MHP
      REAL( 8 ) :: MHPL            ! MHP conc in cloudwater (mol/liter)
      REAL( 8 ) :: MN              ! Mn++ conc in cloudwater (mol/liter)
      REAL( 8 ) :: NA              ! Na conc in cloudwater (mol/liter)
      REAL( 8 ) :: NAACC           ! Na in cloudwater (mol/liter)
      REAL( 8 ) :: NACOR           ! coarse Na in cloudwater (mol/liter)
      REAL( 8 ) :: NH31            ! First dissociation constant for NH3
      REAL( 8 ) :: NH3H            ! Henry's Law Constant for NH3
      REAL( 8 ) :: NH3DH20         !
      REAL( 8 ) :: NH31HDH         !
      REAL( 8 ) :: NH3L            ! NH3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: NH4             ! NH4+ conc in cloudwater (mol/liter)
      REAL( 8 ) :: NH4ACC          ! NH4 acc conc in cloudwater (mol/liter)
      REAL( 8 ) :: NH4COR          ! NH4 coarse conc in cloudwater (mol/liter)
      !REAL( 8 ) :: NITAER          ! total aerosol nitrate
      REAL( 8 ) :: NO3             ! NO3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: NO3ACC          ! NO3 acc conc in cloudwater (mol/liter)
      REAL( 8 ) :: NO3COR          ! NO3 coarse conc in cloudwater (mol/liter)
      REAL( 8 ) :: NUMCOR          ! coarse aerosol number in cloudwater (mol/liter)
      REAL( 8 ) :: O3H             ! Henry's Law Constant for O3
      REAL( 8 ) :: O3L             ! O3 conc in cloudwater (mol/liter)
      REAL( 8 ) :: OH              ! OH conc in cloudwater (mol/liter)
      REAL( 8 ) :: OHL             ! OH radical conc in cloudwater (mol/liter)
      REAL( 8 ) :: SOA             ! secondary organic aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: ORGC            ! cloud-produced SOA in cloudwater (treated as primary)
      REAL( 8 ) :: POA             ! primary organic aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: PAAH            ! Henry's Law Constant for PAA
      REAL( 8 ) :: PAAL            ! PAA conc in cloudwater (mol/liter)
      REAL( 8 ) :: PCO2F           ! gas only CO2 partial pressure (atm)
      REAL( 8 ) :: PFOAF           ! gas only ORGANIC ACID partial press (atm)
      REAL( 8 ) :: PGLYF           ! gas only GLY partial pressure (atm)
      REAL( 8 ) :: PH2O2F          ! gas only H2O2 partial pressure (atm)
      REAL( 8 ) :: PHCLF           ! gas only HCL partial pressure (atm)
      REAL( 8 ) :: PHNO3F          ! gas only HNO3 partial pressure (atm)
      REAL( 8 ) :: PHOF            ! gas only HO partial pressure (atm)
      REAL( 8 ) :: PMGLYF          ! gas only MGLY parital pressure (atm)
      REAL( 8 ) :: PMHPF           ! gas only MHP partial pressure (atm)
      REAL( 8 ) :: PNH3F           ! gas only NH3 partial pressure (atm)
      REAL( 8 ) :: PO3F            ! gas only O3 partial pressure (atm)
      REAL( 8 ) :: PPAAF           ! gas only PAA partial pressure (atm)
      REAL( 8 ) :: PRIM            ! PRIMARY acc+akn aerosol in cloudwater (mol/liter)
!     REAL( 8 ) :: PRIMCOR         ! PRIMARY coarse aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: PSO2F           ! gas only SO2 partial pressure (atm)
      !REAL( 8 ) :: RATE            !
      REAL( 8 ) :: RECIPA1         !
      REAL( 8 ) :: RECIPA2         !
      REAL( 8 ) :: RECIPAP1        ! one over pressure (/atm)
      REAL( 8 ) :: RGLY3           ! liter/(mol sec)
      REAL( 8 ) :: RH2O2           !
      REAL( 8 ) :: RMGLY3          ! liter/(mol sec)
      REAL( 8 ) :: RMHP            !
      REAL( 8 ) :: RPAA            !
      REAL( 8 ) :: RT              ! gas const * temperature (liter atm/mol)
      REAL( 8 ) :: SIV             ! dissolved so2 in cloudwater (mol/liter)
      REAL( 8 ) :: SK6             !
      REAL( 8 ) :: SK6TS6          !
      REAL( 8 ) :: SO21            ! First dissociation constant for SO2
      REAL( 8 ) :: SO22            ! Second dissociation constant for SO2
      REAL( 8 ) :: SO2H            ! Henry's Law Constant for SO2
      REAL( 8 ) :: SO212           ! SO21*SO22
      REAL( 8 ) :: SO212H          ! SO21*SO22*SO2H
      REAL( 8 ) :: SO21H           ! SO21*SO2H
      REAL( 8 ) :: SO2L            ! SO2 conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO3             ! SO3= conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO4             ! SO4= conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO4ACC          ! accumulation mode SO4= conc in cloudwater (mol/liter)
      REAL( 8 ) :: SO4COR          ! coarse SO4= conc in cloudwater (mol/liter)
      REAL( 8 ) :: STION           ! ionic strength
      REAL( 8 ) :: TAC             !
      REAL( 8 ) :: TCLa            ! sum of accumulation and coarse mode chloride
      REAL( 8 ) :: TEMP1           ! (1/T) - (1/298) (1/K)
      REAL( 8 ) :: TIMEW           ! cloud chemistry clock (sec)
!     REAL( 8 ) :: THO             ! total hydroxyl radical available for oxidation
      REAL( 8 ) :: TGLY            ! total glyoxal available for oxidation
      REAL( 8 ) :: TMGLY           ! total methylglyoxal available for oxidation
      !REAL( 8 ) :: TOTOX           !
      REAL( 8 ) :: TH2O2
      REAL( 8 ) :: TO3
      REAL( 8 ) :: TMHP      
      REAL( 8 ) :: TNH4a           ! sum of accumulation and coarse mode ammonium
      REAL( 8 ) :: TNO3a           ! sum of accumulation and coarse mode nitrate      
      REAL( 8 ) :: TPAA
      REAL( 8 ) :: TOTAMM          ! total ammonium
      REAL( 8 ) :: TOTNIT          ! total nitrate (excluding coarse mode)
      REAL( 8 ) :: TS6             ! SO4 conc in cloudwater (mol/liter)
      REAL( 8 ) :: TS6ACC          ! SO4 acc conc in cloudwater (mol/liter)
      REAL( 8 ) :: TS6COR          ! coarse SO4 conc in cloudwater   (mol/liter)
C...for sulfur tracking
      REAL( 8 ) :: TS6AQH2O2       ! SO4 conc from reaction 1 (mol/liter)
      REAL( 8 ) :: TS6AQO3         ! SO4 conc from reaction 2 (mol/liter)
      REAL( 8 ) :: TS6AQFEMN       ! SO4 conc from reaction 3 (mol/liter)
      REAL( 8 ) :: TS6AQMHP        ! SO4 conc from reaction 4 (mol/liter)
      REAL( 8 ) :: TS6AQPAA        ! SO4 conc from reaction 5 (mol/liter)

      REAL( 8 ) :: TSIV            ! total S(iv) available for oxidation
      REAL( 8 ) :: TST             !
      REAL( 8 ) :: TWASH           ! washout time for clouds (sec)
      REAL( 8 ) :: WETFAC          ! converts mol/l to mm-mol/l based on precip
      REAL( 8 ) :: XC1             ! (/mm)
      REAL( 8 ) :: XC2             ! (liter-atm/mol/mm)
      REAL( 8 ) :: XL              ! conversion factor (liter-atm/mol)
      REAL( 8 ) :: ONE_OVER_XL     ! 1.0 / XL
      REAL( 8 ) :: PRES_ATM_OVER_XL ! PRES_ATM / XL
      REAL( 8 ) :: SCAVENGED       ! aitken scavenging factor by cloud water
      REAL( 8 ) :: XLCO2           !
      REAL( 8 ) :: XLH2O2          !
      REAL( 8 ) :: XLHCL           ! const in calc of HCL final partial pres
      REAL( 8 ) :: XLHNO3          !
      REAL( 8 ) :: XLMHP           !
      REAL( 8 ) :: XLNH3           !
      REAL( 8 ) :: XLO3            !
      REAL( 8 ) :: XLPAA           !
      REAL( 8 ) :: XLSO2           !
      REAL( 8 ) :: CAACC           ! accumulation mode Calcium (AE6) SLN 16March2011
      REAL( 8 ) :: MGACC           ! accumulation mode Magnesium (AE6) SLN 16March2011
      REAL( 8 ) :: KACC            ! accumulation mode Potassium (AE6) SLN 16March2011
      REAL( 8 ) :: CACOR           ! coarse mode Calcium (AE6) SLN 16March2011
      REAL( 8 ) :: MGCOR           ! coarse mode Magnesium (AE6) SLN 16March2011
      REAL( 8 ) :: KCOR            ! coarse mode Potassium (AE6) SLN 16March2011
      REAL( 8 ) :: SOILCOR         ! coarse mode SOIL (AE6) SLN 16March2011
      REAL( 8 ) :: ANTHCOR         ! coarse mode CORS (AE6) SLN 16March2011
      REAL( 8 ) :: SEASCOR         ! coarse mode SEAS (AE6) SLN 16March2011
      REAL( 8 ) :: FEACC           ! accumulation mode Fe (AE6) SLN 22March2011
      REAL( 8 ) :: MNACC           ! accumulation mode Mn (AE6) SLN 22March2011
      REAL( 8 ) :: FECOR           ! coarse mode Fe (AE6) SLN 22March2011
      REAL( 8 ) :: MNCOR           ! coarse mode Mn (AE6) SLN 22March2011
      REAL( 8 ) :: FE_OX           ! Fe(III) available for sulfate oxidation
      REAL( 8 ) :: MN_OX           ! Mn(II) available for sulfate oxidation
      REAL( 8 ) :: FE_III          ! Fractional Fe(III) partitioning, GS - July 1, 2011
      REAL( 8 ) :: MN_II           ! Fractional Mn(II) partitioning, GS - July 1, 2011

      REAL( 8 ) :: FE_SOL          ! Fractional Fe solubility, GS - July 1, 2011
      REAL( 8 ) :: MN_SOL          ! Fractional Mn solubility, GS - July 1, 2011

      REAL( 8 ), SAVE :: SOIL_FE_FAC  ! Fe molar fraction of ASOIL
      REAL( 8 ), SAVE :: CORS_FE_FAC  ! Fe molar fraction of ACORS
      REAL( 8 ), SAVE :: SOIL_MN_FAC  ! etc.
      REAL( 8 ), SAVE :: CORS_MN_FAC
      REAL( 8 ), SAVE :: SEAS_NA_FAC  ! Na molar fraction of ASEACAT
      REAL( 8 ), SAVE :: SOIL_NA_FAC
      REAL( 8 ), SAVE :: CORS_NA_FAC
      REAL( 8 ), SAVE :: SEAS_MG_FAC
      REAL( 8 ), SAVE :: SOIL_MG_FAC
      REAL( 8 ), SAVE :: CORS_MG_FAC
      REAL( 8 ), SAVE :: SEAS_CA_FAC
      REAL( 8 ), SAVE :: SOIL_CA_FAC
      REAL( 8 ), SAVE :: CORS_CA_FAC
      REAL( 8 ), SAVE :: SEAS_K_FAC
      REAL( 8 ), SAVE :: SOIL_K_FAC
      REAL( 8 ), SAVE :: CORS_K_FAC

C...........Local Variables (arrays):

      REAL( 8 ) :: LOADING( MAX_NAER, NMODES ) ! aerosol loading (mol/liter)
      REAL( 8 ) :: INITGAS( NGAS ) ! initial gas partial pressure (atm)
      REAL( 8 ) :: LIQUID( NLIQS ) ! wet deposition array (mm mol/liter)
      REAL( 8 ) :: WETDEP( NLIQS ) ! wet deposition array (mm mol/liter)
      REAL( 8 ) :: DSIVDT( 0:NUMOX ) ! rate of so2 oxid incloud (mol/liter/sec)
      REAL( 8 ) :: DS4   ( 0:NUMOX ) ! S(IV) oxidized over timestep DTW(0)
      REAL( 8 ) :: DTW   ( 0:NUMOX ) ! cloud chemistry timestep (sec)

      REAL( 8 ) :: ONE_OVER_TEMP     ! 1.0 / TEMP

C...........External Functions:

      REAL, EXTERNAL :: HLCONST

!For Varaible used by TXHG Version
      !LOGICAL, SAVE :: TRUST_TXHG_CHEM = .TRUE.  ! allow effects for TXHG version on ion and ph
      REAL( 8 ) :: TRACER           ! TRACER acc+akn aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: TRACERCOR        ! TRACER coarse aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: HGFINE           ! mercury PM acc+akn aerosol in cloudwater (mol/liter)
      REAL( 8 ) :: HGCOR            ! mercury PM coarse aerosol in cloudwater (mol/liter)


#ifdef sens
      INCLUDE 'AQCHEM_DDM3D.EXT'   ! ddm-3d variables 
#endif


C*********************************************************************

C...Initialization

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

C... set MW ratios and speciation factors for molar concentrations of coarse
C... soluble aerosols

        SOIL_FE_FAC = ASOIL_FE_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AFE_IDX ), 8 ) / ASOIL_RENORM
        CORS_FE_FAC = ACORS_FE_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AFE_IDX ), 8 ) / ACORSEM_RENORM

        SOIL_MN_FAC = ASOIL_MN_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMN_IDX ), 8 ) / ASOIL_RENORM
        CORS_MN_FAC = ACORS_MN_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMN_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_NA_FAC = ASCAT_NA_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ANA_IDX ), 8 )
        SOIL_NA_FAC = ASOIL_NA_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ANA_IDX ), 8 ) / ASOIL_RENORM
        CORS_NA_FAC = ACORS_NA_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ANA_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_MG_FAC = ASCAT_MG_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMG_IDX ), 8 )
        SOIL_MG_FAC = ASOIL_MG_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMG_IDX ), 8 ) / ASOIL_RENORM
        CORS_MG_FAC = ACORS_MG_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AMG_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_CA_FAC = ASCAT_CA_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ACA_IDX ), 8 )
        SOIL_CA_FAC = ASOIL_CA_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ACA_IDX ), 8 ) / ASOIL_RENORM
        CORS_CA_FAC = ACORS_CA_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( ACA_IDX ), 8 ) / ACORSEM_RENORM

        SEAS_K_FAC = ASCAT_K_FAC * REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AK_IDX ), 8 )
        SOIL_K_FAC = ASOIL_K_FAC * REAL( AEROSPC_MW( ASOIL_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AK_IDX ), 8 ) / ASOIL_RENORM
        CORS_K_FAC = ACORS_K_FAC * REAL( AEROSPC_MW( ACORS_IDX ), 8 )
     &                             / REAL( AEROSPC_MW( AK_IDX ), 8 ) / ACORSEM_RENORM

      END IF    ! FIRSTIME

      ONE_OVER_TEMP = 1.0D0 / TEMP

C...check for bad temperature, cloud air mass, or pressure

      IF ( TEMP .LE. 0.0D0 .OR. AIRM .LE. 0.0D0 .OR. PRES_PA .LE. 0.0D0 ) THEN
        XMSG = 'MET DATA ERROR'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
      END IF

C...initialize counters and compute several conversion factors

      ICNTAQ     = 0
      ITERAT     = 0
      DSIV_SCALE = 1.0D0
      RT         = ( MOLVOL / STDTEMP ) * TEMP         ! R * T (liter atm / mol)
      PRES_ATM   = PRES_PA /  STDATMPA                 ! pressure (atm)
      CTHK1      = AIRM * RT / ( PRES_ATM * 1000.0D0 ) ! cloud thickness (m)
      XL         = WCAVG * RT / H2ODENS                ! conversion factor (l-atm/mol)
      ONE_OVER_XL      = 1.0D0 / XL
      PRES_ATM_OVER_XL = PRES_ATM / XL
      TST       = 0.999D0
      GM        = SCVEFF / 100.0D0
      ACT1      = 1.0D0
      ACT2      = 1.0D0
      GM2       = 1.0D0
      TIMEW     = 0.0D0
      RECIPAP1  = 1.0D0 / PRES_ATM
      XC1       = 1.0D0 / ( WCAVG * CTHK1 )
      XC2       = RT / ( 1000.0D0 * CTHK1 )
      FRACLIQ   = WCAVG / WTAVG
      TWASH     = WTAVG * 1000.0D0 * CTHK1 * 3600.0D0
     &          / ( H2ODENS * MAX( 1.0D-20, REAL( PRCRATE,8 ) ) )

C...set equilibrium constants as a function of temperature
C...   Henry`s law constants

      SO2H  = HLCONST( 'SO2             ', TEMP, .FALSE., 0.0 )
      CO2H  = HLCONST( 'CO2             ', TEMP, .FALSE., 0.0 )
      NH3H  = HLCONST( 'NH3             ', TEMP, .FALSE., 0.0 )
      H2O2H = HLCONST( 'H2O2            ', TEMP, .FALSE., 0.0 )
      O3H   = HLCONST( 'O3              ', TEMP, .FALSE., 0.0 )
      HCLH  = HLCONST( 'HCL             ', TEMP, .FALSE., 0.0 )
      HNO3H = HLCONST( 'HNO3            ', TEMP, .FALSE., 0.0 )
      MHPH  = HLCONST( 'METHYLHYDROPEROX', TEMP, .FALSE., 0.0 )
      PAAH  = HLCONST( 'PEROXYACETIC_ACI', TEMP, .FALSE., 0.0 )
      FOAH  = HLCONST( 'FORMIC_ACID     ', TEMP, .FALSE., 0.0 )
      GLYH  = HLCONST( 'GLYOXAL         ', TEMP, .FALSE., 0.0 )
      MGLYH = HLCONST( MGLYSUR,            TEMP, .FALSE., 0.0 )
      HOH   = HLCONST( 'OH              ', TEMP, .FALSE., 0.0 )

      TEMP1 = ONE_OVER_TEMP - 1.0D0 / 298.0D0

C...dissociation constants

      FOA1  = 1.80D-04 * EXP( -2.00D+01 * TEMP1 )      ! Martell and Smith (1977)
      SK6   = 1.02D-02 * EXP(  2.72D+03 * TEMP1 )      ! Smith and Martell (1976)
      SO21  = 1.30D-02 * EXP(  1.96D+03 * TEMP1 )      ! Smith and Martell (1976)
      SO22  = 6.60D-08 * EXP(  1.50D+03 * TEMP1 )      ! Smith and Martell (1976)
      CO21  = 4.30D-07 * EXP( -1.00D+03 * TEMP1 )      ! Smith and Martell (1976)
      CO22  = 4.68D-11 * EXP( -1.76D+03 * TEMP1 )      ! Smith and Martell (1976)
      H2OW  = 1.00D-14 * EXP( -6.71D+03 * TEMP1 )      ! Smith and Martell (1976)
      NH31  = 1.70D-05 * EXP( -4.50D+02 * TEMP1 )      ! Smith and Martell (1976)
      HCL1  = 1.74D+06 * EXP(  6.90D+03 * TEMP1 )      ! Marsh and McElroy (1985)
      HNO31 = 1.54D+01 * EXP(  8.70D+03 * TEMP1 )      ! Schwartz (1984)

C...Kinetic oxidation rates

C...   From Jacobson  (1997)

      RH2O2 = 7.45D+07 * EXP( -15.96D0 * ( ( 298.0D0 / TEMP )  - 1.0D0 ) )

C...   From Jacobson, 1997

      RMHP = 1.90D+07 * EXP( -12.75D0 * ( ( 298.0D0 / TEMP )  - 1.0D0 ) )
      RPAA = 3.60D+07 * EXP( -13.42D0 * ( ( 298.0D0 / TEMP )  - 1.0D0 ) )

C...From Carlton et al. (2007)

      RGLY3  = 3.0D+10   ! rate constant measured at 298K
      RMGLY3 = 3.0D+10   ! assumed to be the same as GLY

C...make initializations

      WETDEP  = 0.0D0
      LOADING = 0.0D0
      INITGAS = 0.0D0

      DSIVDT = 0.0D0
      DTW    = 0.0D0
      DS4    = 0.0D0

      DGLY1  = 0.0D0
      DMGLY1 = 0.0D0
      DORGC  = 0.0D0
!     DOH1   = 0.0

#ifdef sens 
      S_WETDEP = 0.0D0
      S_LOADING = 0.0D0
      S_INITGAS = 0.0D0

      S_DSIVDT = 0.0D0
      S_DS4    = 0.0D0

      S_DGLY1  = 0.0D0
      S_DMGLY1 = 0.0D0
      S_DORGC  = 0.0D0
#endif

C...compute fractional weights for several species

      TOTNIT = GAS( LHNO3 ) + AEROSOL( LNO3, ACC )
      IF ( TOTNIT .GT. 0.0D0 ) THEN
        FHNO3   = GAS( LHNO3 ) / TOTNIT
        FNO3ACC = AEROSOL( LNO3, ACC ) / TOTNIT
      ELSE
        FHNO3   = 1.0D0
        FNO3ACC = 0.0D0
      END IF

      TOTAMM = GAS( LNH3 ) + AEROSOL( LNH4, ACC )
      IF ( TOTAMM .GT. 0.0D0 ) THEN
        FNH3    = GAS( LNH3 ) / TOTAMM
        FNH4ACC = AEROSOL( LNH4, ACC ) / TOTAMM
      ELSE
        FNH3    = 1.0D0
        FNH4ACC = 0.0D0
      END IF

      TNO3a = AEROSOL( LNO3, ACC ) + AEROSOL( LNO3, COR ) 
      IF ( TNO3a .GT. 0.0D0) THEN
         FNO3COR = AEROSOL( LNO3, COR ) / TNO3a
      ELSE
         FNO3COR = 0.0D0
      END IF
      
      TNH4a = AEROSOL( LNH4, ACC ) + AEROSOL( LNH4, COR )
      IF ( TNH4a .GT. 0.0D0) THEN
         FNH4COR = AEROSOL( LNH4, COR ) / TNH4a
      ELSE
         FNH4COR = 0.0D0
      END IF
      
      TCLa  = AEROSOL( LCL, ACC )  + AEROSOL( LCL, COR )
      IF ( TCLa .GT. 0.0D0) THEN
         FCLCOR = AEROSOL( LCL, COR ) / TCLa
      ELSE
         FCLCOR = 0.0D0
      END IF

#ifdef sens
      DO NP = 1, NPMAX

        S_TOTNIT( NP ) = S_GAS( NP, LHNO3 ) + S_AEROSOL( NP, LNO3, ACC )
        IF ( S_TOTNIT( NP ) .NE. 0.0D0 ) THEN
          S_FHNO3( NP )   = S_GAS( NP,LHNO3 ) / S_TOTNIT( NP )
          S_FNO3ACC( NP ) = S_AEROSOL( NP,LNO3, ACC ) / S_TOTNIT( NP )
        ELSE
          S_FHNO3( NP )   = 1.0D0
          S_FNO3ACC( NP ) = 0.0D0
        END IF

        S_TOTAMM( NP ) = S_GAS( NP, LNH3 ) + S_AEROSOL( NP, LNH4, ACC )
        IF ( S_TOTAMM( NP ) .NE. 0.0D0 ) THEN
          S_FNH3( NP )    = S_GAS( NP, LNH3 ) / S_TOTAMM( NP )
          S_FNH4ACC( NP ) = S_AEROSOL( NP, LNH4, ACC ) / S_TOTAMM( NP )
        ELSE
          S_FNH3( NP )    = 1.0D0
          S_FNH4ACC( NP ) = 0.0D0
        END IF

      END DO
#endif
      
C...Assign fraction partitioning of FE(III) and MN(II)

      IF ( DARK ) THEN
        FE_III = 0.9D0  ! Night time, GS 01July2011
      ELSE
        FE_III = 0.1D0  ! Day time, GS 01July2011
      END IF

      MN_II = 1.0D0                     ! Same for day and night, GS  01July2011

C...Assign solubility of Fe and Mn

      FE_SOL = 0.1D0                   ! GS 01July2011
      MN_SOL = 0.5D0                   ! GS 28July2011

C...initial concentration from accumulation-mode aerosol loading (mol/liter)
C...  an assumption is made that all of the accumulation-mode
C...  aerosol mass in incorporated into the cloud droplets

      DO ISPC = 1, NAER
        LOADING( ISPC, ACC ) = AEROSOL( ISPC, ACC ) * PRES_ATM_OVER_XL
      END DO

      LOADING( LSO4, ACC ) = ( AEROSOL( LSO4, ACC ) + GAS( LH2SO4 ) ) * PRES_ATM_OVER_XL

#ifdef sens
      DO NP = 1, NPMAX
        DO ISPC = 1, NAER
           S_LOADING( NP,ISPC, ACC ) = S_AEROSOL( NP,ISPC, ACC ) * PRES_ATM_OVER_XL
        END DO
        S_LOADING( NP,LSO4, ACC ) = ( S_AEROSOL( NP,LSO4, ACC ) + S_GAS( NP,LH2SO4 ) ) * PRES_ATM_OVER_XL
      END DO
#endif

C...initial concentration from coarse-mode aerosol loading (mol/liter)
C...  an assumption is made that all of the coarse-mode
C...  aerosol mass in incorporated into the cloud droplets

      DO ISPC = 1, NAER
        LOADING( ISPC, COR ) = AEROSOL( ISPC, COR ) * PRES_ATM_OVER_XL
      END DO

!     LOADING( LCACO3, COR ) = ( AEROSOL( LCACO3, COR ) + AEROSOL( LMGCO3, COR ) )
!    &                       * PRES_ATM_OVER_XL

#ifdef sens
      DO NP = 1, NPMAX
        DO ISPC = 1, NAER
          S_LOADING( NP, ISPC, COR ) = S_AEROSOL( NP,ISPC, COR ) * PRES_ATM_OVER_XL
        END DO
      END DO
#endif

C...set constant factors that will be used in later multiplications (moles/atm)

      XLH2O2  = H2O2H * XL
      XLO3    = O3H   * XL
      XLMHP   = MHPH  * XL
      XLPAA   = PAAH  * XL
      XLSO2   = SO2H  * XL
      XLNH3   = NH3H  * XL
      XLHCL   = HCLH  * XL
      XLHNO3  = HNO3H * XL
      XLCO2   = CO2H  * XL

      SO212   = SO21  * SO22
      SO21H   = SO21  * SO2H
      SO212H  = SO212 * SO2H
      CO212   = CO21  * CO22
      CO21H   = CO21  * CO2H
      CO212H  = CO22  * CO21H
      NH3DH20 = NH31  / H2OW
      NH31HDH = NH3H  * NH3DH20
      FOA1H   = FOA1  * FOAH
      HCL1H   = HCL1  * HCLH
      HNO31H  = HNO31 * HNO3H

C...loop If kinetic calculations are made, return to this point

      DO I20C = 1, 10001

        IF ( I20C .GE. 10000 ) THEN
          XMSG = 'EXCESSIVE LOOPING AT I20C'
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
        END IF

C...set aitken-mode aerosol loading (mol/liter)

        SCAVENGED = PRES_ATM_OVER_XL * ( 1.0D0 - EXP( -REAL( ALFA3, 8 ) * TIMEW ) )
        DO ISPC = 1, NAER
          LOADING( ISPC, AKN ) = AEROSOL( ISPC, AKN ) * SCAVENGED
        END DO

#ifdef sens
        DO NP = 1, NPMAX
          DO ISPC = 1, NAER
            S_LOADING( NP, ISPC, AKN ) = S_AEROSOL( NP, ISPC, AKN ) * SCAVENGED
          END DO
        END DO
#endif

C...Initial gas phase partial pressures (atm)
C...   = initial partial pressure - amount deposited partial pressure

        INITGAS( LSO2 )  = GAS( LSO2  ) * PRES_ATM
     &                   + DS4( 0 ) * XL
     &                   - ( WETDEP( LSO3L ) + WETDEP( LHSO3L ) + WETDEP( LSO2L ) ) * XC2
        INITGAS( LNH3 )  = GAS( LNH3  ) * PRES_ATM
     &                   + ( LOADING( LNH4, ACC ) + LOADING( LNH4, COR ) + LOADING( LNH4, AKN ) ) * XL
     &                   - ( WETDEP( LNH4ACCL ) + WETDEP( LNH3L ) + WETDEP( LNH4CORL ) ) * XC2
        INITGAS( LHNO3 ) = ( GAS( LHNO3 ) + 2.0 * GAS( LN2O5 ) ) * PRES_ATM
     &                   + ( LOADING( LNO3, ACC ) + LOADING( LNO3, COR ) + LOADING( LNO3, AKN ) ) * XL
     &                   - ( WETDEP( LNO3ACCL ) + WETDEP( LHNO3L ) + WETDEP( LNO3CORL ) ) * XC2
        INITGAS( LHCL )  = GAS(  LHCL ) * PRES_ATM
     &                   + ( LOADING( LCL, ACC ) + LOADING( LCL, COR ) + LOADING( LCL, AKN ) ) * XL ! new for sea salt
     &                   - ( WETDEP( LCLACCL ) + WETDEP( LHCLL ) + WETDEP( LCLCORL ) ) * XC2
        INITGAS( LH2O2 ) = GAS( LH2O2 ) * PRES_ATM - WETDEP( LH2O2L ) * XC2
        INITGAS( LO3 )   = GAS( LO3   ) * PRES_ATM - WETDEP( LO3L   ) * XC2
        INITGAS( LFOA )  = GAS( LFOA  ) * PRES_ATM
     &                   - ( WETDEP( LFOAL ) + WETDEP( LHCO2L ) ) * XC2
        INITGAS( LMHP )  = GAS( LMHP  ) * PRES_ATM - WETDEP( LMHPL  ) * XC2
        INITGAS( LPAA )  = GAS( LPAA  ) * PRES_ATM - WETDEP( LPAAL  ) * XC2
        INITGAS( LCO2 )  = GAS( LCO2  ) * PRES_ATM
!    &                   + ( LOADING( LCACO3, COR ) + LOADING( LMGCO3, COR ) ) * XL
     &                   - ( WETDEP( LCO3L ) + WETDEP( LHCO3L ) + WETDEP( LCO2L ) ) * XC2
        INITGAS( LGLY )  = GAS( LGLY  ) * PRES_ATM
     &                   + DGLY1 * XL
     &                   - WETDEP( LGLYL ) * XC2
        INITGAS( LMGLY ) = GAS( LMGLY  ) * PRES_ATM
     &                   + DMGLY1 * XL
     &                   - WETDEP( LMGLYL ) * XC2
        INITGAS( LHO )   = GAS( LHO ) * PRES_ATM
!steadystate     &                   + DOH1 * XL
!steadystate     &                   - WETDEP( LOHL ) * XC2

#ifdef sens
        DO NP = 1, NPMAX
          S_INITGAS( NP, LSO2 )  = S_GAS( NP, LSO2  ) * PRES_ATM
     &                           + S_DS4( NP, 0 ) * XL
     &                           - ( S_WETDEP( NP, LSO3L ) + S_WETDEP( NP, LHSO3L ) + S_WETDEP( NP, LSO2L ) ) * XC2
          S_INITGAS( NP, LNH3 )  = S_GAS( NP,LNH3  ) * PRES_ATM
     &              + ( S_LOADING( NP, LNH4, ACC ) + S_LOADING( NP, LNH4, COR ) + S_LOADING( NP, LNH4, AKN ) ) * XL
     &              - ( S_WETDEP( NP, LNH4ACCL ) + S_WETDEP( NP, LNH3L ) + S_WETDEP( NP, LNH4CORL ) ) * XC2
          S_INITGAS( NP, LHNO3 ) = ( S_GAS( NP, LHNO3 ) + 2.0 * S_GAS( NP, LN2O5 ) ) * PRES_ATM
     &              + ( S_LOADING( NP, LNO3, ACC ) + S_LOADING( NP, LNO3, COR ) + S_LOADING( NP, LNO3, AKN ) ) * XL
     &              - ( S_WETDEP( NP, LNO3ACCL ) + S_WETDEP( NP, LHNO3L ) + S_WETDEP( NP, LNO3CORL ) ) * XC2
          S_INITGAS( NP, LHCL )  = S_GAS(  NP, LHCL ) * PRES_ATM
     &              + ( S_LOADING( NP, LCL, ACC ) + S_LOADING( NP, LCL, COR ) + S_LOADING( NP, LCL, AKN ) ) * XL ! new for sea salt
     &              - ( S_WETDEP( NP, LCLACCL ) + S_WETDEP( NP, LHCLL ) + S_WETDEP( NP, LCLCORL ) ) * XC2
          S_INITGAS( NP, LH2O2 ) = S_GAS( NP, LH2O2 ) * PRES_ATM - S_WETDEP( NP, LH2O2L ) * XC2
          S_INITGAS( NP, LO3 )   = S_GAS( NP, LO3   ) * PRES_ATM - S_WETDEP( NP, LO3L   ) * XC2
          S_INITGAS( NP, LFOA )  = S_GAS( NP, LFOA  ) * PRES_ATM
     &                           - ( S_WETDEP( NP, LFOAL ) + S_WETDEP( NP, LHCO2L ) ) * XC2
          S_INITGAS( NP, LMHP )  = S_GAS( NP, LMHP  ) * PRES_ATM - S_WETDEP( NP, LMHPL  ) * XC2
          S_INITGAS( NP, LPAA )  = S_GAS( NP, LPAA  ) * PRES_ATM - S_WETDEP( NP, LPAAL  ) * XC2
          S_INITGAS( NP, LCO2 )  = S_GAS( NP, LCO2  ) * PRES_ATM
     &                           - ( S_WETDEP( NP, LCO3L ) + S_WETDEP( NP, LHCO3L ) + S_WETDEP( NP, LCO2L ) ) * XC2
          S_INITGAS( NP, LGLY )  = S_GAS( NP, LGLY  ) * PRES_ATM
     &                           + S_DGLY1( NP ) * XL
     &                           - S_WETDEP( NP, LGLYL ) * XC2
          S_INITGAS( NP, LMGLY ) = S_GAS( NP, LMGLY  ) * PRES_ATM
     &                           + S_DMGLY1( NP ) * XL
     &                           - S_WETDEP( NP, LMGLYL ) * XC2
          S_INITGAS( NP, LHO )   = S_GAS( NP, LHO ) * PRES_ATM
        END DO
#endif


C...don`t allow gas concentrations to go below zero

C...Molar concentrations of soluble aerosols
C...   = Initial amount - amount deposited  (mol/liter)

        TS6COR  = MAX( LOADING( LSO4,  COR ) - WETDEP( LTS6CORL ) * XC1, 0.0D0 )
        NO3COR  = MAX( LOADING( LNO3,  COR ) - WETDEP( LNO3CORL ) * XC1, 0.0D0 )
!       NACOR   = MAX( LOADING( LNA,   COR ) - WETDEP( LNACORL  ) * XC1, 0.0D0 ) ! SLN 29March2011
        CLCOR   = MAX( LOADING( LCL,   COR ) - WETDEP( LCLCORL  ) * XC1, 0.0D0 )
        NH4COR  = MAX( LOADING( LNH4,  COR ) - WETDEP( LNH4CORL ) * XC1, 0.0D0 )
        SOILCOR = MAX( LOADING( LSOILC,COR ) - WETDEP( LSOILCL  ) * XC1, 0.0D0 ) ! SLN 16March2011
        ANTHCOR = MAX( LOADING( LANTHC,COR ) - WETDEP( LANTHCL  ) * XC1, 0.0D0 ) ! SLN 16March2011
        SEASCOR = MAX( LOADING( LSEASC,COR ) - WETDEP( LSEASCL  ) * XC1, 0.0D0 ) ! SLN 16March2011
        FECOR   = SOIL_FE_FAC * SOILCOR + CORS_FE_FAC * ANTHCOR     ! SLN 22Mar2011
        MNCOR   = SOIL_MN_FAC * SOILCOR + CORS_MN_FAC * ANTHCOR
        NACOR   = SEAS_NA_FAC * SEASCOR + SOIL_NA_FAC * SOILCOR + CORS_NA_FAC * ANTHCOR
        MGCOR   = SEAS_MG_FAC * SEASCOR + SOIL_MG_FAC * SOILCOR + CORS_MG_FAC * ANTHCOR
        CACOR   = SEAS_CA_FAC * SEASCOR + SOIL_CA_FAC * SOILCOR + CORS_CA_FAC * ANTHCOR
        KCOR    = SEAS_K_FAC  * SEASCOR + SOIL_K_FAC  * SOILCOR + CORS_K_FAC  * ANTHCOR

        TS6     = LOADING( LSO4,  AKN ) + LOADING( LSO4, ACC ) + TS6COR
     &          - ( WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL ) ) * XC1
     &          - DS4( 0 )
        IF ( STM ) THEN
          TS6AQH2O2 = LOADING( LSO4AQH2O2, ACC ) - WETDEP( LTS6AQH2O2L ) * XC1
     &              - DS4( 1 )
          TS6AQO3   = LOADING( LSO4AQO3, ACC ) - WETDEP( LTS6AQO3L ) * XC1
     &              - DS4( 2 )
          TS6AQFEMN = LOADING( LSO4AQFEMN, ACC ) - WETDEP( LTS6AQFEMNL ) * XC1
     &              - DS4( 3 )
          TS6AQMHP  = LOADING( LSO4AQMHP, ACC ) - WETDEP( LTS6AQMHPL ) * XC1
     &              - DS4( 4 )
          TS6AQPAA  = LOADING( LSO4AQPAA, ACC ) - WETDEP( LTS6AQPAAL ) * XC1
     &              - DS4( 5 )
        END IF

        NA      = LOADING( LNA,   ACC ) + LOADING( LNA, AKN ) + NACOR
     &          - WETDEP( LNAACCL ) * XC1
!       CA      = LOADING( LCACO3,COR ) - WETDEP( LCAL ) * XC1
!       MG      = LOADING( LMGCO3,COR ) - WETDEP( LMGL ) * XC1
!       K       = LOADING( LK,    COR ) - WETDEP( LKL  ) * XC1
!       FE      = LOADING( LA3FE, COR ) - WETDEP( LFEL ) * XC1
!       MN      = LOADING( LB2MN, COR ) - WETDEP( LMNL ) * XC1
        CA      = LOADING( LCAACC, ACC) - WETDEP( LCAACCL ) * XC1 + CACOR
        MG      = LOADING( LMGACC, ACC) - WETDEP( LMGACCL ) * XC1 + MGCOR
        K       = LOADING( LKACC,  ACC) - WETDEP( LKACCL  ) * XC1 + KCOR
        FE      = LOADING( LFEACC, ACC) - WETDEP( LFEACCL ) * XC1 + FECOR
        MN      = LOADING( LMNACC, ACC) - WETDEP( LMNACCL ) * XC1 + MNCOR
        SOA     = LOADING( LSOA,  ACC ) - WETDEP( LSOAL  ) * XC1
        ORGC    = LOADING( LORGC, ACC ) + DORGC - WETDEP( LORGCL ) * XC1             ! new in-cloud organic
        POA     = LOADING( LPOA,  ACC ) + LOADING( LPOA, AKN ) - WETDEP( LPOAL ) * XC1
        EC      = LOADING( LEC,   ACC ) + LOADING( LEC,   AKN ) - WETDEP( LECL   ) * XC1
        PRIM    = LOADING( LPRI,  ACC ) + LOADING( LPRI,  AKN ) - WETDEP( LPRIML ) * XC1
!       PRIMCOR = LOADING( LPRICOR, COR ) - WETDEP( LPRIMCORL ) * XC1
        NUMCOR  = LOADING( LNUM,  COR ) - WETDEP( LNUMCORL  ) * XC1
!       A       = 3.0D0 * FE
!       B       = 2.0D0 * MN

!       FE_OX = 0.5D0 * 0.62D0 * FE      ! SLN 28March2011
!       MN_OX = 1.0D0 * 0.84D0 * MN      ! SLN 28March2011

# ifdef sens
        DO NP = 1, NPMAX
          S_TS6COR(NP)  = S_LOADING( NP, LSO4,  COR ) - S_WETDEP( NP, LTS6CORL ) * XC1
          S_NO3COR(NP)  = S_LOADING( NP, LNO3,  COR ) - S_WETDEP( NP, LNO3CORL ) * XC1
          S_CLCOR(NP)   = S_LOADING( NP, LCL,   COR ) - S_WETDEP( NP, LCLCORL  ) * XC1
          S_NH4COR(NP)  = S_LOADING( NP, LNH4,  COR ) - S_WETDEP( NP, LNH4CORL ) * XC1
          S_SOILCOR(NP) = S_LOADING( NP, LSOILC,COR ) - S_WETDEP( NP, LSOILCL  ) * XC1
          S_ANTHCOR(NP) = S_LOADING( NP, LANTHC,COR ) - S_WETDEP( NP, LANTHCL  ) * XC1
          S_SEASCOR(NP) = S_LOADING( NP, LSEASC,COR ) - S_WETDEP( NP, LSEASCL  ) * XC1
          S_FECOR(NP)   = SOIL_FE_FAC * S_SOILCOR( NP ) + CORS_FE_FAC * S_ANTHCOR( NP )
          S_MNCOR(NP)   = SOIL_MN_FAC * S_SOILCOR( NP ) + CORS_MN_FAC * S_ANTHCOR( NP )
          S_NACOR(NP)   = SEAS_NA_FAC * S_SEASCOR( NP ) + SOIL_NA_FAC * S_SOILCOR( NP ) + CORS_NA_FAC * S_ANTHCOR( NP )
          S_MGCOR(NP)   = SEAS_MG_FAC * S_SEASCOR( NP ) + SOIL_MG_FAC * S_SOILCOR( NP ) + CORS_MG_FAC * S_ANTHCOR( NP )
          S_CACOR(NP)   = SEAS_CA_FAC * S_SEASCOR( NP ) + SOIL_CA_FAC * S_SOILCOR( NP ) + CORS_CA_FAC * S_ANTHCOR( NP )
          S_KCOR(NP)    = SEAS_K_FAC  * S_SEASCOR( NP ) + SOIL_K_FAC  * S_SOILCOR( NP ) + CORS_K_FAC  * S_ANTHCOR( NP )

          S_TS6(NP)     = S_LOADING( NP, LSO4,  AKN ) + S_LOADING( NP, LSO4, ACC ) + S_TS6COR( NP )
     &            - ( S_WETDEP( NP, LSO4ACCL ) + S_WETDEP( NP, LHSO4ACCL ) ) * XC1
     &            - S_DS4( NP, 0 )
          S_NA(NP)      = S_LOADING( NP, LNA,   ACC ) + S_LOADING( NP, LNA, AKN ) + S_NACOR( NP )
     &            - S_WETDEP( NP, LNAACCL ) * XC1
          S_CA(NP)      = S_LOADING( NP, LCAACC, ACC) - S_WETDEP( NP, LCAACCL ) * XC1 + S_CACOR( NP )
          S_MG(NP)      = S_LOADING( NP, LMGACC, ACC) - S_WETDEP( NP, LMGACCL ) * XC1 + S_MGCOR( NP )
          S_K(NP)       = S_LOADING( NP, LKACC,  ACC) - S_WETDEP( NP, LKACCL  ) * XC1 + S_KCOR( NP )
          S_FE(NP)      = S_LOADING( NP, LFEACC, ACC) - S_WETDEP( NP, LFEACCL ) * XC1 + S_FECOR( NP )
          S_MN(NP)      = S_LOADING( NP, LMNACC, ACC) - S_WETDEP( NP, LMNACCL ) * XC1 + S_MNCOR( NP )
          S_SOA(NP)     = S_LOADING( NP, LSOA,  ACC ) - S_WETDEP( NP, LSOAL  ) * XC1
          S_ORGC(NP)    = S_LOADING( NP, LORGC, ACC ) + S_DORGC( NP ) - S_WETDEP( NP, LORGCL ) * XC1
          S_POA(NP)     = S_LOADING( NP, LPOA,  ACC ) + S_LOADING( NP, LPOA, AKN ) - S_WETDEP( NP, LPOAL ) * XC1
          S_EC(NP)      = S_LOADING( NP, LEC,   ACC ) + S_LOADING( NP, LEC,   AKN ) - S_WETDEP( NP, LECL   ) * XC1
          S_PRIM(NP)    = S_LOADING( NP, LPRI,  ACC ) + S_LOADING( NP, LPRI,  AKN ) - S_WETDEP( NP, LPRIML ) * XC1
          S_NUMCOR(NP)  = S_LOADING( NP, LNUM,  COR ) - S_WETDEP( NP, LNUMCORL  ) * XC1
        END DO
#endif


C...don't allow aerosol concentrations to go below zero

        TS6     = MAX( TS6,     0.0D0 )
        IF ( STM ) THEN
          TS6AQH2O2 = MAX( TS6AQH2O2, 0.0D0 )
          TS6AQO3   = MAX( TS6AQO3,   0.0D0 )
          TS6AQFEMN = MAX( TS6AQFEMN, 0.0D0 )
          TS6AQMHP  = MAX( TS6AQMHP,  0.0D0 )
          TS6AQPAA  = MAX( TS6AQPAA,  0.0D0 )
        END IF
        NA      = MAX( NA,      0.0D0 )
        CA      = MAX( CA,      0.0D0 )
        MG      = MAX( MG,      0.0D0 )
        K       = MAX( K,       0.0D0 )
        FE      = MAX( FE,      0.0D0 )
        MN      = MAX( MN,      0.0D0 )
        SOA     = MAX( SOA,     0.0D0 )
        ORGC    = MAX( ORGC,    0.0D0 )
        POA     = MAX( POA,     0.0D0 )
        EC      = MAX( EC,      0.0D0 )
        PRIM    = MAX( PRIM,    0.0D0 )
!       PRIMCOR = MAX( PRIMCOR, 0.0D0 )
        NUMCOR  = MAX( NUMCOR,  0.0D0 )

        FE_OX = FE_III * FE_SOL * FE     ! GS 01July2011
        MN_OX = MN_II  * MN_SOL * MN     ! GS 01July2011

        A = 3.0D0 * FE_OX
        B = 2.0D0 * MN_OX

        SK6TS6 = SK6 * TS6

#ifdef sens
        IF ( TS6 .EQ. 0.0D0 ) THEN
          DO NP =1 , NPMAX
            S_TS6( NP ) = 0.0D0
          END DO
        END IF

        IF ( NA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_NA( NP ) = 0.0D0
          END DO
        END IF

        IF ( CA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_CA( NP ) = 0.0D0
          END DO
        END IF

        IF ( MG .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MG( NP ) = 0.0D0
          END DO
        END IF

        IF ( K .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_K( NP ) = 0.0D0
          END DO
        END IF

        IF ( FE .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_FE( NP ) = 0.0D0
          END DO
        END IF

        IF ( MN .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MN( NP ) = 0.0D0
          END DO
        END IF

        IF ( SOA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_SOA( NP ) = 0.0D0
          END DO
        END IF

        IF ( ORGC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_ORGC( NP ) = 0.0D0
          END DO
        END IF

        IF ( POA .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_POA( NP ) = 0.0D0
          END DO
        END IF

        IF ( EC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_EC( NP ) = 0.0D0
          END DO
        END IF

        IF ( PRIM .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PRIM( NP ) = 0.0D0
          END DO
        END IF

        IF ( NUMCOR .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_NUMCOR( NP ) = 0.0D0
          END DO
        END IF

        DO NP = 1, NPMAX

          S_FE_OX( NP ) = FE_III * FE_SOL * S_FE( NP )
          S_MN_OX( NP ) = MN_II  * MN_SOL * S_MN( NP )

          S_A( NP ) = 3.0D0 * S_FE_OX( NP )
          S_B( NP ) = 2.0D0 * S_MN_OX( NP )

          S_SK6TS6( NP ) = SK6 * S_TS6( NP )

        END DO
#endif


C...find solution of the equation using a method of reiterative
C...  bisections Make initial guesses for pH:   between .01  to  10.

        HA =  0.01D0
        HB = 10.0D0

C...don't allow gas concentrations to go below zero

        DO IGAS = 1, NGAS
          INITGAS( IGAS ) = MAX( INITGAS( IGAS ), 0.0D0 )
        END DO

#ifdef sens
        DO IGAS = 1, NGAS
          IF ( INITGAS( IGAS ) .EQ. 0.0D0 ) THEN
            DO NP = 1, NPMAX
              S_INITGAS( NP, IGAS ) = 0.0D0
            END DO
          END IF
        END DO
#endif

C...Aerosol specific to TXHG Versions

        TRACER     = LOADING( LTRACER_ACC,  ACC ) + LOADING( LTRACER_AKN,  AKN )
     &             - WETDEP( LTRACERL ) * XC1
        TRACER    = MAX( TRACER,    0.0D0 )
        
        TRACERCOR  = LOADING( LTRACER_COR,  COR ) - WETDEP( LTRACERCORL ) * XC1
        TRACERCOR = MAX( TRACERCOR, 0.0D0 )
 
        HGFINE    = LOADING( LPHG_ACC,  ACC ) + LOADING( LPHG_AKN,  AKN )
     &             - WETDEP( LPHGFINEL ) * XC1
        HGFINE    = MAX( HGFINE,    0.0D0 )

        HGCOR     = LOADING( LPHG_COR, COR ) - WETDEP( LPHGCORL ) * XC1
        HGCOR     = MAX( HGCOR ,     0.0D0 )

        DO I7777C = 1, 10001

          IF ( I7777C .GE. 10000 ) THEN
            XMSG = 'EXCESSIVE LOOPING AT I7777C'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
          END IF

          HA = MAX( HA - 0.8D0, 0.1D0 )
          HB = MIN( HB + 0.8D0, 9.9D0 )
          AE = 10.0D0 ** ( -HA )

          RECIPA1 = 1.0D0 / ( AE * ACT1 )
          RECIPA2 = 1.0D0 / ( AE * AE * ACT2 )

C...calculate final gas phase partial pressure of SO2, NH3, HNO3
C...  HCOOH, and CO2 (atm)

          PSO2F = INITGAS( LSO2 ) / ( 1.0D0 + XLSO2 * ( 1.0D0 + SO21 * RECIPA1
     &          + SO212 * RECIPA2 ) )

          PNH3F = INITGAS( LNH3 ) / ( 1.0D0 + XLNH3 * ( 1.0D0 + NH3DH20 * AE ) )

          PHCLF = INITGAS( LHCL ) / ( 1.0D0 + XLHCL *  ( 1.0D0 + HCL1 * RECIPA1 ) )

          PFOAF = INITGAS( LFOA ) / ( 1.0D0 + XL * ( FOAH + FOA1H * RECIPA1 ) )

          PHNO3F = INITGAS( LHNO3 ) / ( 1.0D0 + XLHNO3 * ( 1.0D0 + HNO31 * RECIPA1 ) )

          PCO2F = INITGAS( LCO2 ) / ( 1.0D0 + XLCO2 * ( 1.0D0 + CO21 * RECIPA1
     &          + CO212 * RECIPA2 ) )

C...calculate liquid phase concentrations (moles/liter)

          SO4  = SK6TS6 / ( AE * GM2 + SK6 )
          HSO4 = TS6 - SO4
          SO3  = SO212H  * PSO2F  * RECIPA2
          HSO3 = SO21H   * PSO2F  * RECIPA1
          CO3  = CO212H  * PCO2F  * RECIPA2
          HCO3 = CO21H   * PCO2F  * RECIPA1
          OH   = H2OW    * RECIPA1
          NH4  = NH31HDH * PNH3F  * AE
          HCO2 = FOA1H   * PFOAF  * RECIPA1
          NO3  = HNO31H  * PHNO3F * RECIPA1
          CL   = HCL1H   * PHCLF  * RECIPA1 ! new for sea salt

C...compute functional value

!         FA = AE + NH4 + NA + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )
!    &       - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL
          FA = AE + NH4 + NA + K + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )  ! SLN 16March2011
     &       - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL

C...Start iteration and bisection ****************<<<<<<<
          DO I30C = 1, 10000

            IF ( I30C .GE. 10000 ) THEN
              XMSG = 'EXCESSIVE LOOPING AT I30C'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            BB = ( HA + HB ) / 2.0D0
            AE = 10.0D0 ** ( -BB )

            ICNTAQ = ICNTAQ + 1
            IF ( ICNTAQ .GE. 60000 ) THEN
              XMSG = 'Maximum AQCHEM total iterations exceeded'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            RECIPA1 = 1.0D0 / ( AE * ACT1 )
            RECIPA2 = 1.0D0 / ( AE * AE * ACT2 )

C...calculate final gas phase partial pressure of SO2, NH3, HCL, HNO3
C...  HCOOH, and CO2 (atm)

            PSO2F = INITGAS( LSO2 ) / ( 1.0D0 + XLSO2
     &            * ( 1.0D0 + SO21 * RECIPA1 + SO212 * RECIPA2 ) )

            PNH3F = INITGAS( LNH3 ) / ( 1.0D0 + XLNH3 * ( 1.0D0 + NH3DH20 * AE ) )

            PHCLF = INITGAS( LHCL ) / ( 1.0D0 + XLHCL *  ( 1.0D0 + HCL1 * RECIPA1 ) )

            PHNO3F = INITGAS( LHNO3 ) / ( 1.0D0 + XLHNO3 * ( 1.0D0 + HNO31 * RECIPA1 ) )

            PFOAF = INITGAS( LFOA ) / ( 1.0D0 + XL * ( FOAH + FOA1H * RECIPA1 ) )

            PCO2F = INITGAS( LCO2 ) / ( 1.0D0 + XLCO2 * ( 1.0D0 + CO21 * RECIPA1
     &            + CO212 * RECIPA2 ) )

C...calculate liquid phase concentrations (moles/liter)

            SO4  = SK6TS6 / ( AE * GM2 + SK6 )
            HSO4 = TS6 - SO4
            SO3  = SO212H  * PSO2F  * RECIPA2
            HSO3 = SO21H   * PSO2F  * RECIPA1
            CO3  = CO212H  * PCO2F  * RECIPA2
            HCO3 = CO21H   * PCO2F  * RECIPA1
            OH   = H2OW    * RECIPA1
            NH4  = NH31HDH * PNH3F  * AE
            HCO2 = FOA1H   * PFOAF  * RECIPA1
            NO3  = HNO31H  * PHNO3F * RECIPA1
            CL   = HCL1H   * PHCLF  * RECIPA1 ! new for sea salt

C...compute functional value
!           FB = AE + NH4 + NA + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )
!    &         - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL
            FB = AE + NH4 + NA + K + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )  ! SLN 16March2011
     &         - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL

C...Calculate and check the sign of the product of the two functional values

            FTST = FA * FB
            IF ( FTST .LE. 0.0D0 ) THEN
              HB = BB
            ELSE
              HA = BB
              FA = FB
            END IF

C...Check convergence of solutions

            HTST = HA / HB
            IF ( HTST .GT. TST ) EXIT  ! exit loop I30C
          END DO   ! I30C

C...end of zero-finding routine ****************<<<<<<<<<<<<

C...compute Ionic strength and activity coefficient by the Davies equation

          STION = 0.5D0
     &          * ( AE + NH4 + OH + HCO3 + HSO3
     &              + 4.0D0 * ( SO4 + CO3 + SO3 + CA + MG + MN_OX )
     &              + NO3 + HSO4 + 9.0D0 * FE_OX + NA + K + CL + A + B + HCO2 ) ! KMF 08September2011
C     &              + 4.0D0 * ( SO4 + CO3 + SO3 + CA + MG + MN )
C     &              + NO3 + HSO4 + 9.0D0 * FE + NA + K + CL + A + B + HCO2 )
          GM1LOG = -0.509D0 * ( SQRT( STION )
     &           / ( 1.0D0 + SQRT( STION ) ) - 0.2D0 * STION )
          GM2LOG = GM1LOG * 4.0D0
          GM1  = 10.0D0 ** GM1LOG
          GM2  = MAX( 10.0D0 ** GM2LOG, 1.0D-30 )
          ACTB = ACT1
          ACT1 = MAX( GM1 * GM1, 1.0D-30 )
          ACT2 = MAX( GM1 * GM1 * GM2, 1.0D-30 )

#ifdef verbose
          if ( stion .gt. 1.0 ) then
             write( logdev,'( /5x, a, 2i4, i10.6 )' )
     &                     'aqchem-I7777C,I20C: ', i7777c, i20c, jtime
             write( logdev,'( 5x, a, e10.3 )' ) 'stion: ', stion
             write( logdev,'( 5x, a, e10.3 )' ) 'AE:   ', ae
             write( logdev,'( 5x, a, e10.3 )' ) 'NH4:  ', nh4
             write( logdev,'( 5x, a, e10.3 )' ) 'OH:   ', oh
             write( logdev,'( 5x, a, e10.3 )' ) 'HCO3: ', hco3
             write( logdev,'( 5x, a, e10.3 )' ) 'HSO3: ', hso3
             write( logdev,'( 5x, a, e10.3 )' ) 'SO4:  ', so4
             write( logdev,'( 5x, a, e10.3 )' ) 'CO3:  ', co3
             write( logdev,'( 5x, a, e10.3 )' ) 'SO3:  ', so3
             write( logdev,'( 5x, a, e10.3 )' ) 'CA:   ', ca
             write( logdev,'( 5x, a, e10.3 )' ) 'MG:   ', mg
             write( logdev,'( 5x, a, e10.3 )' ) 'MN:   ', mn
             write( logdev,'( 5x, a, e10.3 )' ) 'NO3:  ', no3
             write( logdev,'( 5x, a, e10.3 )' ) 'HSO4: ', hso4
             write( logdev,'( 5x, a, e10.3 )' ) 'FE:   ', fe
             write( logdev,'( 5x, a, e10.3 )' ) 'NA:   ', na
             write( logdev,'( 5x, a, e10.3 )' ) 'K:    ', k
             write( logdev,'( 5x, a, e10.3 )' ) 'CL:   ', cl
             write( logdev,'( 5x, a, e10.3 )' ) 'A:    ', a
             write( logdev,'( 5x, a, e10.3 )' ) 'B:    ', b
             write( logdev,'( 5x, a, e10.3 )' ) 'HCO2: ', hco2
             write( logdev,'( 5x, a, e10.3 )' ) 'gm1log:', gm1log
             write( logdev,'( 5x, a, e10.3 )' ) 'gm2log:', gm2log
             write( logdev,'( 5x, a, e10.3 )' ) 'gm1:   ', gm1
             write( logdev,'( 5x, a, e10.3 )' ) 'gm2:   ', gm2
             write( logdev,'( 5x, a, e10.3 )' ) 'actb:  ', actb
             write( logdev,'( 5x, a, e10.3 )' ) 'act1:  ', act1
             write( logdev,'( 5x, a, e10.3 )' ) 'act2:  ', act2
          end if
#endif

C...check for convergence and possibly go to I7777C, to recompute
C...  Gas and liquid phase concentrations

          TAC = ABS( ACTB - ACT1 ) / ACTB
          IF ( TAC .LT. 1.0D-2 ) EXIT    ! exit loop I7777C
        END DO     ! end of do loop I7777C

C...return an error if the pH is not in range

        IF ( ( HA .LT. 0.1D0 ) .OR. ( HA .GT. 9.9D0 ) ) THEN
!         write( logdev,* ) ha
          XMSG = 'PH VALUE OUT OF RANGE'
          CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
        END IF

#ifdef sens
        DO NP = 1, NPMAX
C...calculate final gas phase partial pressure of SO2, NH3, HCL, HNO3
C...  HCOOH, and CO2 (atm)
            S_PSO2F( NP ) = S_INITGAS( NP, LSO2 ) / ( 1.0D0 + XLSO2
     &                    * ( 1.0D0 + SO21 * RECIPA1 + SO212 * RECIPA2 ) )
            S_PNH3F( NP ) = S_INITGAS( NP, LNH3 ) / ( 1.0D0 + XLNH3 * ( 1.0D0 + NH3DH20 * AE ) )
            S_PHCLF( NP ) = S_INITGAS( NP, LHCL ) / ( 1.0D0 + XLHCL *  ( 1.0D0 + HCL1 * RECIPA1 ) )
            S_PHNO3F( NP ) = S_INITGAS( NP, LHNO3 ) / ( 1.0D0 + XLHNO3 * ( 1.0D0 + HNO31 * RECIPA1 ) )
            S_PFOAF( NP ) = S_INITGAS( NP, LFOA ) / ( 1.0D0 + XL * ( FOAH + FOA1H * RECIPA1 ) )
            S_PCO2F( NP ) = S_INITGAS( NP, LCO2 ) / ( 1.0D0 + XLCO2 * ( 1.0D0 + CO21 * RECIPA1
     &                    + CO212 * RECIPA2 ) )
C...calculate liquid phase concentrations (moles/liter)
            S_SO4( NP )  = S_SK6TS6( NP ) / ( AE * GM2 + SK6 )
            S_HSO4( NP ) = S_TS6( NP ) - S_SO4( NP )
            S_SO3( NP )  = SO212H  * S_PSO2F( NP )  * RECIPA2
            S_HSO3( NP ) = SO21H   * S_PSO2F( NP )  * RECIPA1
            S_CO3( NP )  = CO212H  * S_PCO2F( NP )  * RECIPA2
            S_HCO3( NP ) = CO21H   * S_PCO2F( NP )  * RECIPA1
            S_NH4( NP )  = NH31HDH * S_PNH3F( NP )  * AE
            S_HCO2( NP ) = FOA1H   * S_PFOAF( NP )  * RECIPA1
            S_NO3( NP )  = HNO31H  * S_PHNO3F( NP ) * RECIPA1
            S_CL( NP )   = HCL1H   * S_PHCLF( NP )  * RECIPA1
C...compute functional value
c           FB = AE + NH4 + NA + K + 2.0D0 * ( CA + MG - CO3 - SO3 - SO4 )
c    &         - OH - HCO3 - HSO3 - NO3 - HSO4 - HCO2 - CL
        END DO
#endif

C...Make those concentration calculations which can be made outside
C...  of the function.

        SO2L = SO2H * PSO2F
        HPLUS = 10.0D0 ** ( -BB )
        SIV = SO3 + HSO3 + SO2L

C...Calculate final gas phase concentrations of oxidants (atm)

        PH2O2F = ( INITGAS( LH2O2 ) + XL * DS4( 1 ) ) / ( 1.0D0 + XLH2O2 )
        PO3F   = ( INITGAS( LO3 )   + XL * DS4( 2 ) ) / ( 1.0D0 + XLO3   )
        PMHPF  = ( INITGAS( LMHP )  + XL * DS4( 4 ) ) / ( 1.0D0 + XLMHP  )
        PPAAF  = ( INITGAS( LPAA )  + XL * DS4( 5 ) ) / ( 1.0D0 + XLPAA  )
        PGLYF  = ( INITGAS( LGLY )                  ) / ( 1.0D0 + GLYH * XL )
        PMGLYF = ( INITGAS( LMGLY )                 ) / ( 1.0D0 + MGLYH * XL )
        PHOF   = ( INITGAS( LHO )                   ) / ( 1.0D0 + HOH * XL)

        PH2O2F = MAX( PH2O2F, 0.0D0 )
        PO3F   = MAX( PO3F,   0.0D0 )
        PMHPF  = MAX( PMHPF,  0.0D0 )
        PPAAF  = MAX( PPAAF,  0.0D0 )

C...Calculate liquid phase concentrations of oxidants (moles/liter)

        H2O2L = PH2O2F * H2O2H
        O3L   = PO3F   * O3H
        MHPL  = PMHPF  * MHPH
        PAAL  = PPAAF  * PAAH
        FOAL  = PFOAF  * FOAH
        NH3L  = PNH3F  * NH3H
        CO2L  = PCO2F  * CO2H
        HCLL  = PHCLF  * HCLH
        HNO3L = PHNO3F * HNO3H
        GLYL  = PGLYF  * GLYH
        MGLYL = PMGLYF * MGLYH
        OHL   = PHOF   * HOH

C...compute modal concentrations

        SO4COR  = SK6 * TS6COR / ( AE * GM2 + SK6 )
        HSO4COR = MAX( TS6COR - SO4COR, 0.0D0 )

        TS6ACC  = MAX( TS6  - TS6COR,   0.0D0 )
        SO4ACC  = MAX( SO4  - SO4COR,   0.0D0 )
        HSO4ACC = MAX( HSO4 - HSO4COR,  0.0D0 )
        NAACC   = MAX( NA   - NACOR,    0.0D0 )
        CAACC   = MAX( CA   - CACOR,    0.0D0 ) ! AE6
        MGACC   = MAX( MG   - MGCOR,    0.0D0 ) ! AE6
        KACC    = MAX( K    - KCOR,     0.0D0 ) ! AE6
        FEACC   = MAX( FE   - FECOR,    0.0D0 ) ! AE6
        MNACC   = MAX( MN   - MNCOR,    0.0D0 ) ! AE6

#ifdef sens
        DO NP = 1, NPMAX
          S_SO2L( NP )    = SO2H * S_PSO2F( NP )
          S_SIV( NP )     = S_SO3( NP ) + S_HSO3( NP ) + S_SO2L( NP )

          S_PH2O2F( NP )  = ( S_INITGAS( NP, LH2O2 ) + XL * S_DS4( NP, 1 ) ) / ( 1.0D0 + XLH2O2 )
          S_PO3F( NP )    = ( S_INITGAS( NP, LO3 )   + XL * S_DS4( NP, 2 ) ) / ( 1.0D0 + XLO3   )
          S_PMHPF( NP )   = ( S_INITGAS( NP, LMHP )  + XL * S_DS4( NP, 4 ) ) / ( 1.0D0 + XLMHP  )
          S_PPAAF( NP )   = ( S_INITGAS( NP, LPAA )  + XL * S_DS4( NP, 5 ) ) / ( 1.0D0 + XLPAA  )
          S_PGLYF( NP )   = ( S_INITGAS( NP, LGLY ) ) / ( 1.0D0 + GLYH * XL )
          S_PMGLYF( NP )  = ( S_INITGAS( NP, LMGLY ) ) / ( 1.0D0 + MGLYH * XL )
          S_PHOF( NP )    = ( S_INITGAS( NP, LHO ) ) / ( 1.0D0 + HOH * XL)
        END DO

        IF ( PH2O2F .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PH2O2F( NP ) = 0.0D0
          END DO
        END IF

        IF ( PO3F .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PO3F( NP ) = 0.0D0
          END DO
        END IF

        IF ( PMHPF .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PMHPF( NP ) = 0.0D0
          END DO
        END IF

        IF ( PPAAF .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_PPAAF( NP ) = 0.0D0
          END DO
        END IF

        DO NP = 1, NPMAX
          S_H2O2L( NP )   = S_PH2O2F( NP ) * H2O2H
          S_O3L( NP )     = S_PO3F( NP )   * O3H
          S_MHPL( NP )    = S_PMHPF( NP )  * MHPH
          S_PAAL( NP )    = S_PPAAF( NP )  * PAAH
          S_FOAL( NP )    = S_PFOAF( NP )  * FOAH
          S_NH3L( NP )    = S_PNH3F( NP )  * NH3H
          S_CO2L( NP )    = S_PCO2F( NP )  * CO2H
          S_HCLL( NP )    = S_PHCLF( NP )  * HCLH
          S_HNO3L( NP )   = S_PHNO3F( NP ) * HNO3H
          S_GLYL( NP )    = S_PGLYF( NP )  * GLYH
          S_MGLYL( NP )   = S_PMGLYF( NP ) * MGLYH
          S_OHL( NP )     = S_PHOF( NP )   * HOH

          S_SO4COR( NP )  = SK6 * S_TS6COR( NP ) / ( AE * GM2 + SK6 )
          S_HSO4COR( NP ) = S_TS6COR( NP ) - S_SO4COR( NP )
          S_TS6ACC( NP )  = S_TS6( NP )    - S_TS6COR( NP )
          S_SO4ACC( NP )  = S_SO4( NP )    - S_SO4COR( NP )
          S_HSO4ACC( NP ) = S_HSO4( NP )   - S_HSO4COR( NP )
          S_NO3ACC( NP )  = S_NO3( NP )    - S_NO3COR( NP )
          S_NAACC( NP )   = S_NA( NP )     - S_NACOR( NP )
          S_CLACC( NP )   = S_CL( NP )     - S_CLCOR( NP )
          S_NH4ACC( NP )  = S_NH4( NP )    - S_NH4COR( NP )
          S_CAACC( NP )   = S_CA( NP )     - S_CACOR( NP )
          S_MGACC( NP )   = S_MG( NP )     - S_MGCOR( NP )
          S_KACC( NP )    = S_K( NP )      - S_KCOR( NP )
          S_FEACC( NP )   = S_FE( NP )     - S_FECOR( NP )
          S_MNACC( NP )   = S_MN( NP )     - S_MNCOR( NP )
        END DO

c       IF ( HSO4COR .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_HSO4COR( NP ) = 0.0D0
c         END DO
c       END IF

        IF ( TS6ACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_TS6ACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( SO4ACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_SO4ACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( HSO4ACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_HSO4ACC( NP ) = 0.0D0
          END DO
        END IF

c       IF ( NO3ACC .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_NO3ACC( NP ) = 0.0D0
c         END DO
c       END IF

        IF ( NAACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_NAACC( NP ) = 0.0D0
          END DO
        END IF

c       IF ( CLACC .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_CLACC( NP ) = 0.0D0
c         END DO
c       END IF

c       IF ( NH4ACC .EQ. 0.0D0 ) THEN
c         DO NP = 1, NPMAX
c           S_NH4ACC( NP ) = 0.0D0
c         END DO
c       END IF

        IF ( CAACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_CAACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( MGACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MGACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( KACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_KACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( FEACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_FEACC( NP ) = 0.0D0
          END DO
        END IF

        IF ( MNACC .EQ. 0.0D0 ) THEN
          DO NP = 1, NPMAX
            S_MNACC( NP ) = 0.0D0
          END DO
        END IF
#endif

C...Avoid adding mass when the coarse mode concentration is greater
C...  than the total amount left in the aqueous phase after redistribution
C...  of a species between the gas/aqueous phases

        IF ( NO3COR .GT. NO3 ) then
           NO3ACC = (1.0D0 - FNO3COR) * NO3
           NO3COR = FNO3COR * NO3
        ELSE
           NO3ACC  = MAX( NO3  - NO3COR,   0.0D0 )
        END IF

        IF ( CLCOR .GT. CL ) then
           CLACC = (1.0D0 - FCLCOR) * CL
           CLCOR = FCLCOR * CL
        ELSE
           CLACC   = MAX( CL   - CLCOR,    0.0D0 )
        END IF

        IF ( NH4COR .GT. NH4 ) THEN
           NH4ACC = (1.0D0 - FNH4COR) * NH4
           NH4COR = FNH4COR * NH4
        ELSE
           NH4ACC  = MAX( NH4  - NH4COR,   0.0D0 )
        END IF

C...load the liquid concentration array with current values

        LIQUID( LACL      ) = HPLUS
        LIQUID( LNH4ACCL  ) = NH4ACC
        LIQUID( LCACORL   ) = CACOR
        LIQUID( LNAACCL   ) = NAACC
        LIQUID( LOHL      ) = OHL
        LIQUID( LSO4ACCL  ) = SO4ACC
        LIQUID( LHSO4ACCL ) = HSO4ACC
        LIQUID( LSO3L     ) = SO3
        LIQUID( LHSO3L    ) = HSO3
        LIQUID( LSO2L     ) = SO2L
        LIQUID( LCO3L     ) = CO3
        LIQUID( LHCO3L    ) = HCO3
        LIQUID( LCO2L     ) = CO2L
        LIQUID( LNO3ACCL  ) = NO3ACC
        LIQUID( LNH3L     ) = NH3L
        LIQUID( LCLACCL   ) = CLACC
        LIQUID( LH2O2L    ) = H2O2L
        LIQUID( LO3L      ) = O3L
        LIQUID( LFECORL   ) = FECOR
        LIQUID( LMNCORL   ) = MNCOR
        LIQUID( LAL       ) = A
        LIQUID( LFOAL     ) = FOAL
        LIQUID( LHCO2L    ) = HCO2
        LIQUID( LMHPL     ) = MHPL
        LIQUID( LPAAL     ) = PAAL
        LIQUID( LHCLL     ) = HCLL
        LIQUID( LPRIML    ) = PRIM
        LIQUID( LMGCORL   ) = MGCOR
        LIQUID( LKCORL    ) = KCOR
        LIQUID( LBL       ) = B
        LIQUID( LHNO3L    ) = HNO3L
!       LIQUID( LPRIMCORL ) = PRIMCOR
        LIQUID( LNUMCORL  ) = NUMCOR
        LIQUID( LTS6CORL  ) = TS6COR
        LIQUID( LNACORL   ) = NACOR
        LIQUID( LCLCORL   ) = CLCOR
        LIQUID( LNO3CORL  ) = NO3COR
        LIQUID( LNH4CORL  ) = NH4COR
        LIQUID( LPOAL     ) = POA
        LIQUID( LECL      ) = EC
        LIQUID( LSOAL     ) = SOA
        LIQUID( LORGCL    ) = ORGC
        LIQUID( LGLYL     ) = GLYL
        LIQUID( LMGLYL    ) = MGLYL
        LIQUID( LCAACCL   ) = CAACC   ! AE6 - SLN 16March2011
        LIQUID( LMGACCL   ) = MGACC   ! AE6 - SLN 16March2011
        LIQUID( LKACCL    ) = KACC    ! AE6 - SLN 16March2011
        LIQUID( LSOILCL   ) = SOILCOR ! AE6 - SLN 16March2011
        LIQUID( LANTHCL   ) = ANTHCOR ! AE6 - SLN 16March2011
        LIQUID( LSEASCL   ) = SEASCOR ! AE6 - SLN 16March2011
        LIQUID( LFEACCL   ) = FEACC   ! AE6 - SLN 22March2011
        LIQUID( LMNACCL   ) = MNACC   ! AE6 - SLN 22March2011
        IF ( STM ) THEN
          LIQUID( LTS6AQH2O2L   ) = TS6AQH2O2
          LIQUID( LTS6AQO3L     ) = TS6AQO3
          LIQUID( LTS6AQFEMNL   ) = TS6AQFEMN
          LIQUID( LTS6AQMHPL    ) = TS6AQMHP
          LIQUID( LTS6AQPAAL    ) = TS6AQPAA
        END IF

#ifdef sens
        S_LIQUID = 0.0D0
        DO NP = 1, NPMAX
c         S_LIQUID( NP, LACL      ) = S_AC( NP )    
          S_LIQUID( NP, LNH4ACCL  ) = S_NH4ACC( NP)
          S_LIQUID( NP, LCACORL   ) = S_CACOR( NP )
          S_LIQUID( NP, LNAACCL   ) = S_NAACC( NP )
          S_LIQUID( NP, LOHL      ) = S_OHL( NP )
          S_LIQUID( NP, LSO4ACCL  ) = S_SO4ACC( NP )
          S_LIQUID( NP, LHSO4ACCL ) = S_HSO4ACC( NP )
          S_LIQUID( NP, LSO3L     ) = S_SO3( NP )
          S_LIQUID( NP, LHSO3L    ) = S_HSO3( NP )
          S_LIQUID( NP, LSO2L     ) = S_SO2L( NP )
          S_LIQUID( NP, LCO3L     ) = S_CO3( NP )
          S_LIQUID( NP, LHCO3L    ) = S_HCO3( NP )
          S_LIQUID( NP, LCO2L     ) = S_CO2L( NP )
          S_LIQUID( NP, LNO3ACCL  ) = S_NO3ACC( NP )
          S_LIQUID( NP, LNH3L     ) = S_NH3L( NP )
          S_LIQUID( NP, LCLACCL   ) = S_CLACC( NP )
          S_LIQUID( NP, LH2O2L    ) = S_H2O2L( NP )
          S_LIQUID( NP, LO3L      ) = S_O3L( NP )
          S_LIQUID( NP, LFECORL   ) = S_FECOR( NP )
          S_LIQUID( NP, LMNCORL   ) = S_MNCOR( NP )
c         S_LIQUID( NP, LAL       ) = S_A( NP )
          S_LIQUID( NP, LFOAL     ) = S_FOAL( NP )
          S_LIQUID( NP, LHCO2L    ) = S_HCO2( NP )
          S_LIQUID( NP, LMHPL     ) = S_MHPL( NP )
          S_LIQUID( NP, LPAAL     ) = S_PAAL( NP )
          S_LIQUID( NP, LHCLL     ) = S_HCLL( NP )
          S_LIQUID( NP, LPRIML    ) = S_PRIM( NP )
          S_LIQUID( NP, LMGCORL   ) = S_MGCOR( NP )
          S_LIQUID( NP, LKCORL    ) = S_KCOR( NP )
c         S_LIQUID( NP, LBL       ) = S_B( NP )
          S_LIQUID( NP, LHNO3L    ) = S_HNO3L( NP )
          S_LIQUID( NP, LNUMCORL  ) = S_NUMCOR( NP )
          S_LIQUID( NP, LTS6CORL  ) = S_TS6COR( NP )
          S_LIQUID( NP, LNACORL   ) = S_NACOR( NP )
          S_LIQUID( NP, LCLCORL   ) = S_CLCOR( NP )
          S_LIQUID( NP, LNO3CORL  ) = S_NO3COR( NP )
          S_LIQUID( NP, LNH4CORL  ) = S_NH4COR( NP )
          S_LIQUID( NP, LPOAL     ) = S_POA( NP )
          S_LIQUID( NP, LECL      ) = S_EC( NP )
          S_LIQUID( NP, LSOAL     ) = S_SOA( NP )
          S_LIQUID( NP, LORGCL    ) = S_ORGC( NP )
          S_LIQUID( NP, LGLYL     ) = S_GLYL( NP )
          S_LIQUID( NP, LMGLYL    ) = S_MGLYL( NP )
          S_LIQUID( NP, LCAACCL   ) = S_CAACC( NP )
          S_LIQUID( NP, LMGACCL   ) = S_MGACC( NP )
          S_LIQUID( NP, LKACCL    ) = S_KACC( NP )
          S_LIQUID( NP, LSOILCL   ) = S_SOILCOR( NP )
          S_LIQUID( NP, LANTHCL   ) = S_ANTHCOR( NP )
          S_LIQUID( NP, LSEASCL   ) = S_SEASCOR( NP )
          S_LIQUID( NP, LFEACCL   ) = S_FEACC( NP )
          S_LIQUID( NP, LMNACCL   ) = S_MNACC( NP )
        END DO
#endif

C...Load array variable TXHG Version

        LIQUID( LTRACERL    )  = TRACER
        LIQUID( LTRACERCORL )  = TRACERCOR
        LIQUID( LPHGFINEL   )  = HGFINE
        LIQUID( LPHGCORL    )  = HGCOR


C...if the maximum cloud lifetime has not been reached, then compute
C...  the next timestep, else exit loop 20.

        IF ( TIMEW .GE. TAUCLD ) EXIT   ! exit 20 loop

C...make kinetics calculations
C...  note: DS4(i) and DSIV(I) are negative numbers!

        DTRMV = TAUCLD / 3.0D0
        IF ( ( CTHK1 .GT. 1.0D-10 ) .AND. ( PRCRATE .GT. 1.0D-10 ) )
     &     DTRMV = 3.6D0 * WTAVG * 1000.0D0 * CTHK1 / PRCRATE  ! <<<uma found bug, was .36
        DTRMV = MIN( DTRMV, 300.0D0 )
        ITERAT = ITERAT + 1

C...Define the total S(iv) available for oxidation

        TSIV = INITGAS( LSO2 ) * ONE_OVER_XL

#ifdef sens
        DO NP = 1, NPMAX
          S_TSIV( NP ) = S_INITGAS( NP,LSO2 ) * ONE_OVER_XL
        END DO
#endif

C...Calculate sulfur iv oxidation rate due to H2O2 (Jacobson, 1997)

        DSIVDT( 1 ) = -RH2O2 * H2O2L * HSO3 * HPLUS / ( 1.0D0 + 13.0D0 * HPLUS )
        TH2O2 = INITGAS( LH2O2 ) * ONE_OVER_XL
        IF ( ( DSIVDT( 1 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TH2O2 .LE. CONMIN ) ) THEN
          DTW( 1 ) = DTRMV
        ELSE
          DTW( 1 ) = -0.05D0 * MIN( TH2O2, TSIV ) / DSIVDT( 1 )
        END IF

#ifdef sens
C... no sensitivity to pH now
        DO NP = 1, NPMAX
          S_TH2O2( NP ) = S_INITGAS( NP, LH2O2 ) * ONE_OVER_XL
          C1 = -RH2O2 * HPLUS / ( 1.0D0 + 13.0D0 * HPLUS )
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            S_DSIVDT( NP,1 ) = C1 * ( S_H2O2L( NP )  * HSO3          + S_H2O2L( IP1 ) * S_HSO3( IP2 )
     &                              + S_H2O2L( IP2 ) * S_HSO3( IP1 ) + H2O2L          * S_HSO3( NP )  )
          ELSE
            S_DSIVDT( NP,1 ) = C1 * ( S_H2O2L( NP ) * HSO3 + H2O2L * S_HSO3( NP ) )
          END IF
        END DO
#endif

C...Calculate sulfur iv oxidation rate due to O3 (Jacobson, 1997)

        DSIVDT( 2 ) = -( 2.4D4 * SO2L                                          +
     &                   3.7D5 * EXP( -18.56 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) ) * HSO3 +
     &                   1.5D9 * EXP( -17.72 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) ) * SO3 ) * O3L

        TO3 = INITGAS( LO3 ) * ONE_OVER_XL
        IF ( ( DSIVDT( 2 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TO3 .LE. CONMIN ) ) THEN
          DTW( 2 ) = DTRMV
        ELSE
          DTW( 2 ) = -0.01D0 * MIN( TO3, TSIV ) / DSIVDT( 2 )
        END IF

#ifdef sens
        C1 = 2.4D4
        C2 = 3.7D5 * EXP( -18.56 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) )
        C3 = 1.5D9 * EXP( -17.72 * ( ( 298.0D0 / TEMP ) - 1.0D0 ) )
        DO NP = 1, NPMAX
          S_TO3( NP ) = S_INITGAS( NP, LO3 ) * ONE_OVER_XL
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            S_DSIVDT( NP,2 ) =  -C1 * ( S_SO2L( NP )  * O3L          + S_SO2L( IP1 ) * S_O3L( IP2 )
     &                                + S_SO2L( IP2 ) * S_O3L( IP1 ) + SO2L          * S_O3L( NP ) )
     &                         - C2 * ( S_HSO3( NP )  * O3L          + S_HSO3( IP1 ) * S_O3L( IP2 )
     &                                + S_HSO3( IP2 ) * S_O3L( IP1 ) + HSO3          * S_O3L( NP ) )
     &                         - C3 * ( S_SO3 ( NP )  * O3L          + S_SO3 ( IP1 ) * S_O3L( IP2 )
     &                                + S_SO3 ( IP2 ) * S_O3L( IP1 ) + SO3           * S_O3L( NP ) )
          ELSE
            S_DSIVDT( NP,2 ) =  -C1 * ( S_SO2L( NP ) * O3L + SO2L * S_O3L( NP ) )
     &                         - C2 * ( S_HSO3( NP ) * O3L + HSO3 * S_O3L( NP ) )
     &                         - C3 * ( S_SO3 ( NP ) * O3L + SO3  * S_O3L( NP ) )
          END IF
        END DO
#endif

C...Calculate sulfur iv oxidation rate due to 02 catalyzed by Mn++ and Fe+++
C...(Martin and Goodman, 1991)
C...Implement sulfate inhibition based on Martin and Good, 1991

        DSIVDT( 3 ) = - ( 750.0D0  * MN_OX * SIV +                 ! GS 4May2011
     &                    2600.0D0 * FE_OX * SIV +                 ! GS 4May2011
     &                    1.0D10   * MN_OX * FE_OX * SIV )         ! GS 4May2011
     &                / ( 1.0D0 + 75.0D0 *( TS6**0.67D0 ))         ! GS 28Nov2012     

        IF ( ( DSIVDT( 3 ) .EQ. 0.0D0 ) .OR. ( TSIV .LE. CONMIN ) ) THEN
          DTW( 3 ) = DTRMV
        ELSE
          DTW( 3 ) = -0.1D0 * TSIV / DSIVDT( 3 )
        END IF

#ifdef sens
        DO NP = 1, NPMAX
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            IF (TS6 .GT. 0.0) THEN
              pwr1D = -(0.33D0*TS6**(-1.33D0)*S_TS6(IP2))
            ELSE
              pwr1D = 0.0
            END IF
            pwr1 = TS6**(-0.33D0)
            S_DSIVDT( NP, 3 ) = -((((750.0D0*(S_MN_OX(NP)*SIV+S_MN_OX(IP1)*S_SIV(IP2)+S_MN_OX(IP2)*S_SIV(IP1)+
     &        MN_OX*S_SIV(NP))+2600.0D0*(S_FE_OX(NP)*SIV+S_FE_OX(IP1)*S_SIV(IP2)+S_FE_OX(IP2)*S_SIV(IP1)+
     &        FE_OX*S_SIV(NP))+1.0D10*((S_MN_OX(NP)*FE_OX+S_MN_OX(IP1)*S_FE_OX(IP2)+S_MN_OX(IP2)*
     &        S_FE_OX(IP1)+MN_OX*S_FE_OX(NP))*SIV+(S_MN_OX(IP1)*FE_OX+MN_OX*S_FE_OX(IP1))*S_SIV(IP2)+(
     &        S_MN_OX(IP2)*FE_OX+MN_OX*S_FE_OX(IP2))*S_SIV(IP1)+MN_OX*FE_OX*S_SIV(NP)))*(1.0D0+
     &        75.0D0*TS6**0.67D0)+(750.0D0*(S_MN_OX(IP1)*SIV+MN_OX*S_SIV(IP1))+2600.0D0*(
     &        S_FE_OX(IP1)*SIV+FE_OX*S_SIV(IP1))+1.0D10*((S_MN_OX(IP1)*FE_OX+MN_OX*S_FE_OX(IP1))*SIV+
     &        MN_OX*FE_OX*S_SIV(IP1)))*75.0D0*0.67D0*TS6**(-0.33D0)*S_TS6(IP2)-75.0D0*
     &        0.67D0*((750.0D0*(S_MN_OX(IP2)*SIV+MN_OX*S_SIV(IP2))+2600.0D0*(S_FE_OX(IP2)*SIV
     &        +FE_OX*S_SIV(IP2))+1.0D10*((S_MN_OX(IP2)*FE_OX+MN_OX*S_FE_OX(IP2))*SIV+MN_OX*
     &        FE_OX*S_SIV(IP2)))*pwr1*S_TS6(IP1)+(750.0D0*MN_OX*SIV+2600.0D0*FE_OX*SIV+
     &        1.0D10*MN_OX*FE_OX*SIV)*(pwr1D*S_TS6(IP1)+pwr1*S_TS6(NP))))*(1.0D0+75.0D0*
     &        TS6**0.67D0)**2-((750.0D0*(S_MN_OX(IP1)*SIV+MN_OX*S_SIV(IP1))+2600.0D0*(
     &        S_FE_OX(IP1)*SIV+FE_OX*S_SIV(IP1))+1.0D10*((S_MN_OX(IP1)*FE_OX+MN_OX*S_FE_OX(IP1))*SIV+
     &        MN_OX*FE_OX*S_SIV(IP1)))*(1.0D0+75.0D0*TS6**0.67D0)-(750.0D0*MN_OX*SIV
     &        +2600.0D0*FE_OX*SIV+1.0D10*MN_OX*FE_OX*SIV)*75.0D0*0.67D0*pwr1*
     &        S_TS6(IP1))*2*(1.0D0+75.0D0*TS6**0.67D0)*75.0D0*0.67D0*TS6**(-0.33D0)*
     &        S_TS6(IP2))/((1.0D0+75.0D0*TS6**0.67D0)**2)**2)
          ELSE
            S_DSIVDT( NP, 3 ) = -(((750.0D0*(S_MN_OX(NP)*SIV+MN_OX*S_SIV(NP))+2600.0D0*(S_FE_OX(NP)*SIV
     &        +FE_OX*S_SIV(NP))+1.0D10*((S_MN_OX(NP)*FE_OX+MN_OX*S_FE_OX(NP))*SIV+MN_OX*FE_OX
     &        *S_SIV(NP)))*(1.0D0+75.0D0*TS6**0.67D0)-(750.0D0*MN_OX*SIV+2600.0D0*
     &        FE_OX*SIV+1.0D10*MN_OX*FE_OX*SIV)*75.0D0*0.67D0*TS6**(-0.33D0)*
     &        S_TS6(NP))/(1.0D0+75.0D0*TS6**0.67D0)**2)
          END IF
        END DO
#endif

C...Calculate sulfur oxidation rate due to MHP (Jacobson,  1997)

        DSIVDT( 4 ) = -RMHP * HPLUS * MHPL * HSO3
        TMHP = INITGAS( LMHP ) * ONE_OVER_XL
        IF ( ( DSIVDT( 4 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TMHP .LE. CONMIN ) ) THEN
          DTW( 4 ) = DTRMV
        ELSE
          DTW( 4 ) = -0.1D0 * MIN( TMHP, TSIV ) / DSIVDT( 4 )
        END IF

#ifdef sens
c... no sensitivity to pH now
        DO NP = 1, NPMAX
          S_TMHP( NP ) = S_INITGAS( NP, LMHP ) * ONE_OVER_XL
          C1 = -RMHP * HPLUS
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            S_DSIVDT( NP, 4 ) = C1 * ( S_MHPL( NP )  * HSO3          + S_MHPL( IP1 ) * S_HSO3( IP2 )
     &                               + S_MHPL( IP2 ) * S_HSO3( IP1 ) + MHPL          * S_HSO3( NP )  )
          ELSE
            S_DSIVDT( NP, 4 ) = C1 * ( S_MHPL( NP ) * HSO3 + MHPL * S_HSO3( NP ) )
          END IF
        END DO
#endif

C...Calculate sulfur oxidation due to PAA (Jacobson,  1997)

        DSIVDT( 5 ) = -( RPAA * HPLUS + 7.00D2 ) * HSO3 * PAAL
        TPAA = INITGAS( LPAA ) * ONE_OVER_XL
        IF ( ( DSIVDT( 5 ) .EQ. 0.0D0 ) .OR.
     &       ( TSIV  .LE. CONMIN ) .OR.
     &       ( TPAA .LE. CONMIN ) ) THEN
          DTW( 5 ) = DTRMV
        ELSE
          DTW( 5 ) = -0.1D0 * MIN( TPAA, TSIV ) / DSIVDT( 5 )
        END IF

#ifdef sens
c... no sensitivity to pH now
        DO NP = 1, NPMAX
          S_TPAA( NP ) = S_INITGAS( NP, LPAA ) * ONE_OVER_XL
          IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
            IP1 = IHIGH(NP,1)
            IP2 = IHIGH(NP,2)
            C1 = -( RPAA * HPLUS + 7.00D2 )
            S_DSIVDT( NP, 5 ) = C1 * ( S_HSO3( NP )  * PAAL          + S_HSO3( IP1 ) * S_PAAL( IP2 )
     &                               + S_HSO3( IP2 ) * S_PAAL( IP1 ) + HSO3          * S_PAAL( NP )  )
          ELSE
            S_DSIVDT( NP, 5 ) = C1 * ( S_HSO3( NP ) * PAAL + HSO3 * S_PAAL( NP ) )
          END IF
        END DO
#endif

C...Calculate total sulfur iv oxidation rate

        DSIVDT( 0 ) = 0.0D0
        DO IOX = 1, NUMOX
          DSIVDT( 0 ) = DSIVDT( 0 ) + DSIVDT( IOX )
        END DO

#ifdef sens
        S_DSIVDT( :, 0 ) = 0.0D0
        DO NP = 1, NPMAX
          DO IOX = 1, NUMOX
            S_DSIVDT( NP,0 ) = S_DSIVDT( NP, 0 ) + S_DSIVDT( NP, IOX )
          END DO
        END DO
#endif

C...Calculate a minimum time step required

        DTW( 0 ) = MIN( DTW( 1 ), DTW( 2 ), DTW( 3 ),
     &                  DTW( 4 ), DTW( 5 ) )

C...check for large time step

        IF ( DTW( 0 ) .GT. 8.0D+37 ) THEN
          WRITE(LOGDEV,1001) PRCRATE, DSIVDT(0), TS6, DTW(0), CTHK1, WTAVG
        ELSE

C...CALCULATE IN-CLOUD SOA PRODUCTION
C...  Reference:  Carlton, A.G., B.J. Turpin, K.E. Altieri, A. Reff,
C...  S. Seitzinger, H.J. Lim, and B. Ervens (2007), Atmospheric Oxalic
C...  Acid and SOA Production from Glyoxal: Results of Aqueous
C...  Photooxidation Experiments, Atmos. Environ., 41(35), 7588-7602.

C...Define the total glyoxal available for oxidation

          TGLY = INITGAS( LGLY ) * ONE_OVER_XL

C...Calculate GLY oxidation due to OH

          DGLYDT = -RGLY3 * GLYL * OHL

C...Define the total methylglyoxal available for oxidation

          TMGLY = INITGAS( LMGLY ) * ONE_OVER_XL

C...Calculate MGLY oxidation due to OH

          DMGLYDT = -RMGLY3 * MGLYL * OHL

!ccC...Define the total OH available for oxidation
!cc
!cc          THO = PHO0 * ONE_OVER_XL

C...Calculate OH consumption

!steadystate          DOHDT = -( RGLY3 * GLYL + RMGLY3 * MGLYL ) * OHL

#ifdef sens
          DO NP = 1, NPMAX
            S_TGLY( NP )  = S_INITGAS( NP, LGLY ) * ONE_OVER_XL
            S_TMGLY( NP ) = S_INITGAS( NP, LMGLY ) * ONE_OVER_XL
c           IF ( IPT(NP) .EQ. 4 ) THEN ! hddm
c             IP1 = IHIGH(NP,1)
c             IP2 = IHIGH(NP,2)
c             S_DGLYDT( NP ) = -RGLY3 * ( S_GLYL( NP )  * OHL          + S_GLYL( IP1 ) * S_OHL( IP2 )
c    &                                  + S_GLYL( IP2 ) * S_OHL( IP1 ) + GLYL          * S_OHL( NP ) )
c             S_DMGLYDT( NP ) = -RMGLY3 * ( S_MGLYL( NP )  * OHL + S_MGLYL( IP1 ) * S_OHL( IP2 )
c    &                                    + S_MGLYL( IP2 ) * S_OHL( IP1 ) + MGLYL          * S_OHL( NP ) )
c           ELSE
c             S_DGLYDT( NP ) = -RGLY3 * ( S_GLYL( NP ) * OHL + GLYL * S_OHL( NP ) )
c             S_DMGLYDT( NP ) = -RMGLY3 * ( S_MGLYL( NP ) * OHL + MGLYL * S_OHL( NP ) )
c           ENDIF

c assume no OH sensitivity for now, because it causes instability in sensitvities
            S_DGLYDT( NP ) = -RGLY3 * S_GLYL( NP ) * OHL
            S_DMGLYDT( NP ) = -RMGLY3 * S_MGLYL( NP ) * OHL

          END DO
#endif

C...calculate the change in sulfur iv for this time step

60        CONTINUE
          DTS6 = ABS( DTW( 0 ) * DSIVDT( 0 ) )

C...If DSIV(0), sulfur iv oxidized during this time step would be
C... less than 5% of sulfur oxidized since time 0, then double DT

          IF ( DTW( 0 ) .LE. TAUCLD ) THEN
            IF ( DTS6 .LT. 0.05D0 * TS6 ) THEN
              DTW( 0 ) = DTW( 0 ) * 2.0D0
              GO TO 60
            END IF
          END IF
        END IF
        DTW( 0 ) = MIN( DTW( 0 ), DTRMV )

C...Limit the timestep to prevent negative SO2 concentrations and mass creation
C...  for sulfate (suggested by Bonyoung Koo)

        IF ( DSIVDT( 0 ) .LT. 0.0D0 ) THEN
!         DTW( 0 ) = MIN( DTW( 0 ), -TSIV * 1.00001 / DSIVDT( 0 ) )
          DTW( 0 ) = MIN( DTW( 0 ), -TSIV / DSIVDT( 0 ) )
        END IF
!       IF ( DGLYDT .LT. 0.0 ) THEN
!         DTW( 0 ) = MIN( DTW( 0 ), -TGLY * 1.00001 / DGLYDT )
!       END IF
!       IF ( DMGLYDT .LT. 0.0 ) THEN
!         DTW( 0 ) = MIN( DTW( 0 ), -TMGLY * 1.00001 / DMGLYDT )
!       END IF
!       IF ( DOHDT .LT. 0.0 ) THEN
!         DTW( 0 ) = MIN( DTW( 0 ), -THO * 1.00001 / DOHDT )
!       END IF

C...If the total time after this time increment will be greater than
C...  TAUCLD sec., then set DTW(0) so that total time will be TAUCLD

        IF ( TIMEW + DTW( 0 ) .GT. TAUCLD ) DTW( 0 ) = TAUCLD - TIMEW
!       IF ( TS6 .LT. 1.0D-11 ) DTW( 0 ) = TAUCLD - TIMEW
!       IF ( ITERAT .GT. 100 ) DTW( 0 ) = TAUCLD - TIMEW
        IF ( ITERAT .GT. 100 ) DTW( 0 ) = MAX( 1.0D0, DTW( 0 ) )

C...limit timestep to no more than the washout time

        DTW( 0 ) = MIN( DTW( 0 ), TWASH )

C...force mass balance for the specified timestep
C...  for GLY and MGLY, assume that OH is in steady state

        DGLYDT  = MAX( DGLYDT,  -TGLY  / DTW( 0 ) )
        DMGLYDT = MAX( DMGLYDT, -TMGLY / DTW( 0 ) )

C...  for S(IV), also limit by oxidants (except assume O2 in steady state)

        DSIVDT( 1 ) = MAX( DSIVDT( 1 ), -MIN( TSIV, TH2O2 ) / DTW( 0 ) )
        DSIVDT( 2 ) = MAX( DSIVDT( 2 ), -MIN( TSIV, TO3   ) / DTW( 0 ) )
        DSIVDT( 3 ) = MAX( DSIVDT( 3 ), -TSIV / DTW( 0 ) )
        DSIVDT( 4 ) = MAX( DSIVDT( 4 ), -MIN( TSIV, TMHP  ) / DTW( 0 ) )
        DSIVDT( 5 ) = MAX( DSIVDT( 5 ), -MIN( TSIV, TPAA  ) / DTW( 0 ) )

#ifdef sens
        DO NP = 1, NPMAX

          IF ( DGLYDT .EQ. -TGLY  / DTW( 0 ) ) THEN
            S_DGLYDT( NP ) = -S_TGLY( NP ) / DTW( 0 )
          END IF

          IF ( DMGLYDT .EQ. -TMGLY / DTW( 0 ) ) THEN
            S_DMGLYDT( NP ) = - S_TMGLY( NP ) / DTW( 0 )
          END IF

          IF ( DSIVDT( 1 ) .EQ. -MIN( TSIV, TH2O2 ) / DTW( 0 ) ) THEN
            IF ( TSIV .LT. TH2O2 ) THEN
              S_DSIVDT( NP, 1 ) = -S_TSIV( NP ) / DTW( 0 )
            ELSE
              S_DSIVDT( NP, 1 ) = -S_TH2O2( NP ) / DTW( 0 )
            END IF
          END IF

          IF ( DSIVDT( 2 ) .EQ. -MIN( TSIV, TO3   ) / DTW( 0 ) ) THEN
            IF ( TSIV .LT. TO3 ) THEN
              S_DSIVDT( NP, 2 ) = -S_TSIV( NP ) / DTW( 0 )
            ELSE
              S_DSIVDT( NP, 2 ) = -S_TO3( NP ) / DTW( 0 )
            END IF
          END IF

          IF ( DSIVDT( 3 ) .EQ. -TSIV / DTW( 0 ) ) THEN
            S_DSIVDT( NP, 3 ) = -S_TSIV( NP ) / DTW( 0 )
          END IF

          IF ( DSIVDT( 4 ) .EQ. -MIN( TSIV, TMHP  ) / DTW( 0 ) ) THEN
            IF ( TSIV .LT. TMHP ) THEN
              S_DSIVDT( NP, 4 ) = -S_TSIV( NP ) / DTW( 0 )
            ELSE
              S_DSIVDT( NP, 4 ) = -S_TMHP( NP ) / DTW( 0 )
            END IF
          END IF

          IF ( DSIVDT( 5 ) .EQ. -MIN( TSIV, TPAA  ) / DTW( 0 ) ) THEN
            IF ( TSIV .LT. TPAA ) THEN
              S_DSIVDT( NP, 5 ) = -S_TSIV( NP ) / DTW( 0 )
            ELSE
              S_DSIVDT( NP, 5 ) = -S_TPAA( NP ) / DTW( 0 )
            END IF
          END IF

        END DO
#endif

C...  recalculate the total S(iv) oxidation rate

        DSIVDT( 0 ) = 0.0
        DO IOX = 1, NUMOX
          DSIVDT( 0 ) = DSIVDT( 0 ) + DSIVDT( IOX )
        END DO

#ifdef sens
        S_DSIVDT( :, 0 ) = 0.0D0
        DO NP = 1, NPMAX
          DO IOX = 1, NUMOX
            S_DSIVDT( NP,0 ) = S_DSIVDT( NP, 0 ) + S_DSIVDT( NP, IOX )
          END DO
        END DO
#endif

C...  if the total S(iv) oxidation rate over the timestep exceeds the amount of
C...    S(iv) available then scale the rates to conserve mass

        IF ( -DSIVDT( 0 ) * DTW( 0 ) .GT. TSIV ) THEN
          DSIV_SCALE = TSIV / ( -DSIVDT( 0 ) * DTW( 0 ) )
          DSIVDT( 0 ) = DSIVDT( 0 ) * DSIV_SCALE
          DSIVDT( 1 ) = DSIVDT( 1 ) * DSIV_SCALE
          DSIVDT( 2 ) = DSIVDT( 2 ) * DSIV_SCALE
          DSIVDT( 3 ) = DSIVDT( 3 ) * DSIV_SCALE
          DSIVDT( 4 ) = DSIVDT( 4 ) * DSIV_SCALE
          DSIVDT( 5 ) = DSIVDT( 5 ) * DSIV_SCALE
#ifdef sens
          DO NP = 1, NPMAX
            S_DSIVDT( NP, 0 ) = S_DSIVDT( NP, 0 ) * DSIV_SCALE
            S_DSIVDT( NP, 1 ) = S_DSIVDT( NP, 1 ) * DSIV_SCALE
            S_DSIVDT( NP, 2 ) = S_DSIVDT( NP, 2 ) * DSIV_SCALE
            S_DSIVDT( NP, 3 ) = S_DSIVDT( NP, 3 ) * DSIV_SCALE
            S_DSIVDT( NP, 4 ) = S_DSIVDT( NP, 4 ) * DSIV_SCALE
            S_DSIVDT( NP, 5 ) = S_DSIVDT( NP, 5 ) * DSIV_SCALE
          END DO
#endif
        END IF

C...Set DSIV(I), I = 0,NUMOX, the amount of S(IV) oxidized by each
C... individual oxidizing agent, as well as the total.

        DO IOX = 0, NUMOX
          DS4( IOX ) = DS4( IOX ) + DTW( 0 ) * DSIVDT( IOX )
        END DO

        DGLY1  = DGLY1  + DTW( 0 ) * DGLYDT

        DMGLY1 = DMGLY1 + DTW( 0 ) * DMGLYDT

csteadystate        DOH1   = DOH1   + DTW( 0 ) * DOHDT

C...Calculate AORGC Production:  4% SOAcld (ORGC) yield from glyoxal
C...  and methylglyoxal is assumed

        DORGC = DORGC - ( 0.04D0 * ( DGLYDT + DMGLYDT ) * DTW( 0 ) )

#ifdef sens
        DO NP = 1, NPMAX

          DO IOX = 0, NUMOX
            S_DS4( NP, IOX ) = S_DS4( NP, IOX ) + DTW( 0 ) * S_DSIVDT( NP, IOX )
          END DO

          S_DGLY1( NP )  = S_DGLY1( NP )  + DTW( 0 ) * S_DGLYDT( NP )

          S_DMGLY1( NP ) = S_DMGLY1( NP ) + DTW( 0 ) * S_DMGLYDT( NP )

          S_DORGC( NP )  = S_DORGC( NP ) - ( 0.04D0 * ( S_DGLYDT( NP ) + S_DMGLYDT( NP ) ) * DTW( 0 ) )

        END DO
#endif

C...Compute depositions and concentrations for each species

!!!     WETFAC = PRCRATE * FRACLIQ * DTW( 0 ) * SEC2HR     !!!numerical integration errors with this expression
        WETFAC = ( 1.0D0 - EXP( -DTW( 0 ) / TWASH ) ) / XC1  !!!new analytic soln to be used in CMAQv5.0

        DO LIQ = 1, NLIQS
          WETDEP( LIQ ) = WETDEP( LIQ ) + LIQUID( LIQ ) * WETFAC
        END DO

        TIMEW = TIMEW + DTW( 0 )

#ifdef sens
        DO NP = 1, NPMAX
          DO LIQ = 1, NLIQS
            S_WETDEP( NP, LIQ ) = S_WETDEP( NP, LIQ ) + S_LIQUID( NP, LIQ ) * WETFAC
          END DO
        END DO
#endif

      END DO     ! I20C loop

C...At this point, TIMEW=TAUCLD
C...  compute the scavenging coefficient for SO4 which will be used for
C...  scavenging aerosol number in the accumulation mode

      DEPSUM = ( WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL ) ) * XC1

      IF ( ( LOADING( LSO4, ACC ) + LOADING( LSO4, AKN ) - DS4( 0 ) ) .NE. 0.0D0 ) THEN
        BETASO4 = DEPSUM / ( ( LOADING( LSO4, ACC ) + LOADING( LSO4, AKN ) - DS4( 0 ) ) * TAUCLD )
      ELSE
        BETASO4 = 0.0D0
      END IF

      EBETASO4T = EXP( -BETASO4 * TAUCLD )
      EALFA0T   = EXP( -ALFA0 * TAUCLD )
      EALFA2T   = EXP( -ALFA2 * TAUCLD )
      EALFA3T   = EXP( -ALFA3 * TAUCLD )

C...Compute the output concentrations and wet deposition amounts

      TOTAMM = ( PNH3F  + ( NH4ACC + NH3L  ) * XL ) * RECIPAP1
      TOTNIT = ( PHNO3F + ( NO3ACC + HNO3L ) * XL ) * RECIPAP1

#ifdef sens
      DO NP = 1, NPMAX
         S_TOTAMM( NP ) = ( S_PNH3F( NP )  + ( S_NH4ACC( NP ) + S_NH3L( NP )  ) * XL ) * RECIPAP1
         S_TOTNIT( NP ) = ( S_PHNO3F( NP ) + ( S_NO3ACC( NP ) + S_HNO3L( NP ) ) * XL ) * RECIPAP1
      END DO
#endif

C...gas-phase species wet deposition (mm mol/lit)

      GASWDEP( LSO2   ) = WETDEP( LSO3L  ) + WETDEP( LHSO3L )
     &                  + WETDEP( LSO2L  )
      GASWDEP( LNH3   ) = WETDEP( LNH3L  )
      GASWDEP( LH2O2  ) = WETDEP( LH2O2L )
      GASWDEP( LO3    ) = WETDEP( LO3L   )
      GASWDEP( LCO2   ) = WETDEP( LCO3L  ) + WETDEP( LHCO3L )
     &                  + WETDEP( LCO2L  )
      GASWDEP( LFOA   ) = WETDEP( LFOAL  ) + WETDEP( LHCO2L )
      GASWDEP( LMHP   ) = WETDEP( LMHPL  )
      GASWDEP( LPAA   ) = WETDEP( LPAAL  )
      GASWDEP( LHCL   ) = WETDEP( LHCLL  )
      GASWDEP( LHNO3  ) = WETDEP( LHNO3L )
      GASWDEP( LN2O5  ) = 0.0D0
      GASWDEP( LH2SO4 ) = 0.0D0
      GASWDEP( LGLY   ) = WETDEP( LGLYL  )
      GASWDEP( LMGLY  ) = WETDEP( LMGLYL )
!     GASWDEP( LHO    ) = WETDEP( LOHL   )

#ifdef sens
      DO NP = 1, NPMAX
        S_GASWDEP( NP, LSO2   ) = S_WETDEP( NP, LSO3L  ) + S_WETDEP( NP, LHSO3L )
     &                          + S_WETDEP( NP, LSO2L  )
        S_GASWDEP( NP, LNH3   ) = S_WETDEP( NP, LNH3L  )
        S_GASWDEP( NP, LH2O2  ) = S_WETDEP( NP, LH2O2L )
        S_GASWDEP( NP, LO3    ) = S_WETDEP( NP, LO3L   )
        S_GASWDEP( NP, LCO2   ) = S_WETDEP( NP, LCO3L  ) + S_WETDEP( NP, LHCO3L )
     &                          + S_WETDEP( NP, LCO2L  )
        S_GASWDEP( NP, LFOA   ) = S_WETDEP( NP, LFOAL  ) + S_WETDEP( NP, LHCO2L )
        S_GASWDEP( NP, LMHP   ) = S_WETDEP( NP, LMHPL  )
        S_GASWDEP( NP, LPAA   ) = S_WETDEP( NP, LPAAL  )
        S_GASWDEP( NP, LHCL   ) = S_WETDEP( NP, LHCLL  )
        S_GASWDEP( NP, LHNO3  ) = S_WETDEP( NP, LHNO3L )
        S_GASWDEP( NP, LN2O5  ) = 0.0D0
        S_GASWDEP( NP, LH2SO4 ) = 0.0D0
        S_GASWDEP( NP, LGLY   ) = S_WETDEP( NP, LGLYL  )
        S_GASWDEP( NP, LMGLY  ) = S_WETDEP( NP, LMGLYL )
      END DO
#endif

C...gas concentrations (mol/molV)

      GAS( LSO2   ) = ( PSO2F  + XL *  SIV )   * RECIPAP1
      GAS( LH2O2  ) = ( PH2O2F + XL *  H2O2L ) * RECIPAP1
      GAS( LO3    ) = ( PO3F   + XL *  O3L )   * RECIPAP1
      GAS( LCO2   ) = ( PCO2F  + XL *  CO2L )  * RECIPAP1
      GAS( LFOA   ) = ( PFOAF  + XL * ( FOAL + HCO2 ) ) * RECIPAP1
      GAS( LMHP   ) = ( PMHPF  + XL *  MHPL )  * RECIPAP1
      GAS( LPAA   ) = ( PPAAF  + XL *  PAAL )  * RECIPAP1
      GAS( LHCL   ) = ( PHCLF  + XL *  HCLL )  * RECIPAP1
      GAS( LGLY   ) = ( PGLYF  + XL *  GLYL )  * RECIPAP1
      GAS( LMGLY  ) = ( PMGLYF + XL *  MGLYL)  * RECIPAP1
!     GAS( LHO    ) = ( PHOF   + XL *  OHL  )  * RECIPAP1

      GAS( LNH3   ) = FNH3  * TOTAMM
      GAS( LHNO3  ) = FHNO3 * TOTNIT
      GAS( LN2O5  ) = 0.0D0 ! assume all into aerosol
      GAS( LH2SO4 ) = 0.0D0 ! assume all into aerosol

#ifdef sens
      DO NP = 1, NPMAX
        S_GAS( NP, LSO2   ) = ( S_PSO2F( NP )  + XL *  S_SIV( NP ) )   * RECIPAP1
c       S_GAS( NP, LH2O2  ) = ( S_PH2O2F( NP ) + XL *  S_H2O2L( NP ) ) * RECIPAP1
c       S_GAS( NP, LO3    ) = ( S_PO3F( NP )   + XL *  S_O3L( NP ) )   * RECIPAP1
c       S_GAS( NP, LCO2   ) = ( S_PCO2F( NP )  + XL *  S_CO2L( NP ) )  * RECIPAP1
c       S_GAS( NP, LFOA   ) = ( S_PFOAF( NP )  + XL * ( S_FOAL( NP ) + S_HCO2( NP ) ) ) * RECIPAP1
c       S_GAS( NP, LMHP   ) = ( S_PMHPF( NP )  + XL *  S_MHPL( NP ) )  * RECIPAP1
c       S_GAS( NP, LPAA   ) = ( S_PPAAF( NP )  + XL *  S_PAAL( NP ) )  * RECIPAP1
c       S_GAS( NP, LHCL   ) = ( S_PHCLF( NP )  + XL *  S_HCLL( NP ) )  * RECIPAP1
        S_GAS( NP, LGLY   ) = ( S_PGLYF( NP )  + XL *  S_GLYL( NP ) )  * RECIPAP1
        S_GAS( NP, LMGLY  ) = ( S_PMGLYF( NP ) + XL *  S_MGLYL( NP ))  * RECIPAP1
c       S_GAS( NP, LNH3   ) = S_FNH3( NP )  * S_TOTAMM( NP )
c       S_GAS( NP, LHNO3  ) = S_FHNO3( NP ) * S_TOTNIT( NP )
        S_GAS( NP, LN2O5  ) = 0.0D0 ! assume all into aerosol
        S_GAS( NP, LH2SO4 ) = 0.0D0 ! assume all into aerosol
      END DO
#endif

C...aerosol species wet deposition (mm mol/lit)
C...  there is no wet deposition of aitken particles, they attached
C...  to the accumulation mode particles

      AERWDEP( LSO4, AKN ) = 0.0D0
      AERWDEP( LNH4, AKN ) = 0.0D0
      AERWDEP( LNO3, AKN ) = 0.0D0
      AERWDEP( LEC,  AKN ) = 0.0D0
      AERWDEP( LPRI, AKN ) = 0.0D0

      AERWDEP( LPOA, AKN ) = 0.0D0

      AERWDEP( LSO4, ACC ) = WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL )
      IF ( STM ) THEN
        AERWDEP( LSO4AQH2O2, ACC ) = WETDEP( LTS6AQH2O2L )
        AERWDEP( LSO4AQO3,   ACC ) = WETDEP( LTS6AQO3L   )
        AERWDEP( LSO4AQFEMN, ACC ) = WETDEP( LTS6AQFEMNL )
        AERWDEP( LSO4AQMHP,  ACC ) = WETDEP( LTS6AQMHPL  )
        AERWDEP( LSO4AQPAA,  ACC ) = WETDEP( LTS6AQPAAL  )
      END IF
      AERWDEP( LNH4, ACC ) = WETDEP( LNH4ACCL )
      AERWDEP( LNO3, ACC ) = WETDEP( LNO3ACCL )
      AERWDEP( LEC,  ACC ) = WETDEP( LECL     )
      AERWDEP( LPRI, ACC ) = WETDEP( LPRIML   )

      AERWDEP( LSOA,  ACC ) = WETDEP( LSOAL  )
      AERWDEP( LORGC, ACC ) = WETDEP( LORGCL )
      AERWDEP( LPOA,  ACC ) = WETDEP( LPOAL )

      AERWDEP( LSO4, COR ) = WETDEP( LTS6CORL  )
      AERWDEP( LNO3, COR ) = WETDEP( LNO3CORL  )
      AERWDEP( LNH4, COR ) = WETDEP( LNH4CORL  )
!     AERWDEP( LPRICOR, COR ) = WETDEP( LPRIMCORL )

      AERWDEP( LNA, AKN  ) = 0.0D0
      AERWDEP( LCL, AKN  ) = 0.0D0
      AERWDEP( LNA, ACC  ) = WETDEP( LNAACCL )
      AERWDEP( LCL, ACC  ) = WETDEP( LCLACCL )
!     AERWDEP( LNA, COR  ) = WETDEP( LNACORL )
      AERWDEP( LCL, COR  ) = WETDEP( LCLCORL )

!     AERWDEP( LK,     COR ) = WETDEP( LKCORL  )
!     AERWDEP( LA3FE,  COR ) = WETDEP( LFECORL )
!     AERWDEP( LB2MN,  COR ) = WETDEP( LMNCORL )
!     AERWDEP( LCACO3, COR ) = WETDEP( LCACORL )
!     AERWDEP( LMGCO3, COR ) = WETDEP( LMGCORL )

      AERWDEP( LCAACC, ACC ) = WETDEP( LCAACCL )  ! AE6 - SLN 16March2011
      AERWDEP( LMGACC, ACC ) = WETDEP( LMGACCL )  ! AE6 - SLN 16March2011
      AERWDEP( LKACC,  ACC ) = WETDEP( LKACCL  )  ! AE6 - SLN 16March2011
      AERWDEP( LSOILC, COR ) = WETDEP( LSOILCL )  ! AE6 - SLN 16March2011
      AERWDEP( LANTHC, COR ) = WETDEP( LANTHCL )  ! AE6 - SLN 16March2011
      AERWDEP( LSEASC, COR ) = WETDEP( LSEASCL )  ! AE6 - SLN 16March2011
      AERWDEP( LFEACC, ACC ) = WETDEP( LFEACCL )  ! AE6 - SLN 22March2011
      AERWDEP( LMNACC, ACC ) = WETDEP( LMNACCL )  ! AE6 - SLN 22March2011

!     AERWDEP( LNUM, AKN ) = 0.0D0
!     AERWDEP( LNUM, ACC ) = 0.0D0
!     AERWDEP( LNUM, COR ) = 0.0D0
!     AERWDEP( LSRF, AKN ) = 0.0D0
!     AERWDEP( LSRF, ACC ) = 0.0D0
!     AERWDEP( LSRF, COR ) = 0.0D0

#ifdef sens
      DO NP = 1, NPMAX
        S_AERWDEP( NP, LSO4, AKN )   = 0.0D0
        S_AERWDEP( NP, LNH4, AKN )   = 0.0D0
        S_AERWDEP( NP, LNO3, AKN )   = 0.0D0
        S_AERWDEP( NP, LEC,  AKN )   = 0.0D0
        S_AERWDEP( NP, LPRI, AKN )   = 0.0D0
        S_AERWDEP( NP, LPOA, AKN )   = 0.0D0
        S_AERWDEP( NP, LSO4, ACC )   = S_WETDEP( NP, LSO4ACCL ) + S_WETDEP( NP, LHSO4ACCL )
        S_AERWDEP( NP, LNH4, ACC )   = S_WETDEP( NP, LNH4ACCL )
        S_AERWDEP( NP, LNO3, ACC )   = S_WETDEP( NP, LNO3ACCL )
        S_AERWDEP( NP, LEC,  ACC )   = S_WETDEP( NP, LECL     )
        S_AERWDEP( NP, LPRI, ACC )   = S_WETDEP( NP, LPRIML   )
        S_AERWDEP( NP, LSOA,  ACC )  = S_WETDEP( NP, LSOAL  )
        S_AERWDEP( NP, LORGC, ACC )  = S_WETDEP( NP, LORGCL )
        S_AERWDEP( NP, LPOA,  ACC )  = S_WETDEP( NP, LPOAL )
        S_AERWDEP( NP, LSO4, COR )   = S_WETDEP( NP, LTS6CORL  )
        S_AERWDEP( NP, LNO3, COR )   = S_WETDEP( NP, LNO3CORL  )
        S_AERWDEP( NP, LNH4, COR )   = S_WETDEP( NP, LNH4CORL  )
        S_AERWDEP( NP, LNA, AKN  )   = 0.0D0
        S_AERWDEP( NP, LCL, AKN  )   = 0.0D0
        S_AERWDEP( NP, LNA, ACC  )   = S_WETDEP( NP, LNAACCL )
        S_AERWDEP( NP, LCL, ACC  )   = S_WETDEP( NP, LCLACCL )
        S_AERWDEP( NP, LCL, COR  )   = S_WETDEP( NP, LCLCORL )
        S_AERWDEP( NP, LCAACC, ACC ) = S_WETDEP( NP, LCAACCL )
        S_AERWDEP( NP, LMGACC, ACC ) = S_WETDEP( NP, LMGACCL )
        S_AERWDEP( NP, LKACC,  ACC ) = S_WETDEP( NP, LKACCL  )
        S_AERWDEP( NP, LSOILC, COR ) = S_WETDEP( NP, LSOILCL )
        S_AERWDEP( NP, LANTHC, COR ) = S_WETDEP( NP, LANTHCL )
        S_AERWDEP( NP, LSEASC, COR ) = S_WETDEP( NP, LSEASCL )
        S_AERWDEP( NP, LFEACC, ACC ) = S_WETDEP( NP, LFEACCL )
        S_AERWDEP( NP, LMNACC, ACC ) = S_WETDEP( NP, LMNACCL )
      END DO
#endif

C...Compute for Aerosol species in  TXHG Version

      AERWDEP( LTRACER_AKN, AKN ) = 0.0D0
      AERWDEP( LTRACER_ACC, ACC ) = WETDEP( LTRACERL )
      AERWDEP( LTRACER_COR, COR ) = WETDEP( LTRACERCORL )
      AERWDEP( LPHG_AKN, AKN ) = 0.0D0
      AERWDEP( LPHG_ACC, ACC ) = WETDEP( LPHGFINEL )
      AERWDEP( LPHG_COR, COR ) = WETDEP( LPHGCORL )

C...aerosol concentrations (mol/molV)

      AEROSOL( LSO4, AKN ) = AEROSOL( LSO4, AKN ) * EALFA3T
      AEROSOL( LNH4, AKN ) = AEROSOL( LNH4, AKN ) * EALFA3T
      AEROSOL( LNO3, AKN ) = AEROSOL( LNO3, AKN ) * EALFA3T
      AEROSOL( LEC,  AKN ) = AEROSOL( LEC,  AKN ) * EALFA3T
      AEROSOL( LPRI, AKN ) = AEROSOL( LPRI, AKN ) * EALFA3T

      AEROSOL( LPOA, AKN ) = AEROSOL( LPOA, AKN ) * EALFA3T

      AEROSOL( LSO4, ACC ) = TS6ACC * XL * RECIPAP1
      IF ( STM ) THEN
        AEROSOL( LSO4AQH2O2, ACC ) = TS6AQH2O2  * XL * RECIPAP1
        AEROSOL( LSO4AQO3,   ACC ) = TS6AQO3    * XL * RECIPAP1
        AEROSOL( LSO4AQFEMN, ACC ) = TS6AQFEMN  * XL * RECIPAP1
        AEROSOL( LSO4AQMHP,  ACC ) = TS6AQMHP   * XL * RECIPAP1
        AEROSOL( LSO4AQPAA,  ACC ) = TS6AQPAA   * XL * RECIPAP1
      END IF
      AEROSOL( LEC,  ACC ) = EC     * XL * RECIPAP1
      AEROSOL( LPRI, ACC ) = PRIM   * XL * RECIPAP1

      AEROSOL( LSOA,  ACC ) = SOA  * XL * RECIPAP1
      AEROSOL( LORGC, ACC ) = ORGC * XL * RECIPAP1
      AEROSOL( LPOA,  ACC ) = POA  * XL * RECIPAP1

      AEROSOL( LNH4, ACC ) = FNH4ACC * TOTAMM
      AEROSOL( LNO3, ACC ) = FNO3ACC * TOTNIT

      AEROSOL( LSO4, COR )    = TS6COR * XL * RECIPAP1
      AEROSOL( LNO3, COR )    = NO3COR * XL * RECIPAP1
      AEROSOL( LNH4, COR )    = NH4COR * XL * RECIPAP1
!     AEROSOL( LPRICOR, COR ) = PRIMCOR* XL * RECIPAP1
!     AEROSOL( LK, COR )      = KCOR   * XL * RECIPAP1
!     AEROSOL( LA3FE, COR )   = FECOR  * XL * RECIPAP1
!     AEROSOL( LB2MN, COR )   = MNCOR  * XL * RECIPAP1
!     AEROSOL( LCACO3, COR )  = CACOR  * XL * RECIPAP1
!     AEROSOL( LMGCO3, COR )  = MGCOR  * XL * RECIPAP1

      AEROSOL( LNA, AKN  ) = AEROSOL( LNA, AKN ) * EALFA3T
      AEROSOL( LCL, AKN  ) = AEROSOL( LCL, AKN ) * EALFA3T
      AEROSOL( LNA, ACC  ) = NAACC * XL * RECIPAP1
      AEROSOL( LCL, ACC  ) = CLACC * XL * RECIPAP1
!     AEROSOL( LNA, COR  ) = NACOR * XL * RECIPAP1
      AEROSOL( LCL, COR  ) = CLCOR * XL * RECIPAP1

      AEROSOL( LNUM, AKN ) = AEROSOL( LNUM, AKN ) * EALFA0T
      AEROSOL( LNUM, ACC ) = AEROSOL( LNUM, ACC ) * EBETASO4T
      AEROSOL( LNUM, COR ) = AEROSOL( LNUM, COR ) * EXP(-TAUCLD / TWASH )

      AEROSOL( LCAACC, ACC ) = CAACC   * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LMGACC, ACC ) = MGACC   * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LKACC,  ACC ) = KACC    * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LSOILC, COR ) = SOILCOR * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LANTHC, COR ) = ANTHCOR * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LSEASC, COR ) = SEASCOR * XL * RECIPAP1 ! AE6 - SLN 16March2011
      AEROSOL( LFEACC, ACC ) = FEACC   * XL * RECIPAP1 ! AE6 - SLN 22March2011
      AEROSOL( LMNACC, ACC ) = MNACC   * XL * RECIPAP1 ! AE6 - SLN 22March2011

#ifdef sens
      DO NP =1, NPMAX
        S_AEROSOL( NP, LSO4, AKN )   = S_AEROSOL( NP, LSO4, AKN ) * EALFA3T
        S_AEROSOL( NP, LNH4, AKN )   = S_AEROSOL( NP, LNH4, AKN ) * EALFA3T
        S_AEROSOL( NP, LNO3, AKN )   = S_AEROSOL( NP, LNO3, AKN ) * EALFA3T
        S_AEROSOL( NP, LEC,  AKN )   = S_AEROSOL( NP, LEC,  AKN ) * EALFA3T
        S_AEROSOL( NP, LPRI, AKN )   = S_AEROSOL( NP, LPRI, AKN ) * EALFA3T
        S_AEROSOL( NP, LPOA, AKN )   = S_AEROSOL( NP, LPOA, AKN ) * EALFA3T
        S_AEROSOL( NP, LSO4, ACC )   = S_TS6ACC( NP ) * XL * RECIPAP1
        S_AEROSOL( NP, LEC,  ACC )   = S_EC( NP )     * XL * RECIPAP1
        S_AEROSOL( NP, LPRI, ACC )   = S_PRIM( NP )   * XL * RECIPAP1
        S_AEROSOL( NP, LSOA,  ACC )  = S_SOA( NP )  * XL * RECIPAP1
        S_AEROSOL( NP, LORGC, ACC )  = S_ORGC( NP ) * XL * RECIPAP1
        S_AEROSOL( NP, LPOA,  ACC )  = S_POA( NP )  * XL * RECIPAP1
c       S_AEROSOL( NP, LNH4, ACC )   = S_FNH4ACC( NP ) * S_TOTAMM( NP )
c       S_AEROSOL( NP, LNO3, ACC )   = S_FNO3ACC( NP ) * S_TOTNIT( NP )
        S_AEROSOL( NP, LSO4, COR )   = S_TS6COR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LNO3, COR )   = S_NO3COR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LNH4, COR )   = S_NH4COR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LNA, AKN  )   = S_AEROSOL( NP, LNA, AKN ) * EALFA3T
c       S_AEROSOL( NP, LCL, AKN  )   = S_AEROSOL( NP, LCL, AKN ) * EALFA3T
c       S_AEROSOL( NP, LNA, ACC  )   = S_NAACC( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LCL, ACC  )   = S_CLACC( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LCL, COR  )   = S_CLCOR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LNUM, AKN )   = S_AEROSOL( NP, LNUM, AKN ) * EALFA0T
c       S_AEROSOL( NP, LNUM, ACC )   = S_AEROSOL( NP, LNUM, ACC ) * EBETASO4T
c       S_AEROSOL( NP, LNUM, COR )   = S_NUMCOR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LCAACC, ACC ) = S_CAACC( NP )   * XL * RECIPAP1
c       S_AEROSOL( NP, LMGACC, ACC ) = S_MGACC( NP )   * XL * RECIPAP1
c       S_AEROSOL( NP, LKACC,  ACC ) = S_KACC( NP )    * XL * RECIPAP1
c       S_AEROSOL( NP, LSOILC, COR ) = S_SOILCOR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LANTHC, COR ) = S_ANTHCOR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LSEASC, COR ) = S_SEASCOR( NP ) * XL * RECIPAP1
c       S_AEROSOL( NP, LFEACC, ACC ) = S_FEACC( NP )   * XL * RECIPAP1
c       S_AEROSOL( NP, LMNACC, ACC ) = S_MNACC( NP )   * XL * RECIPAP1
      END DO
#endif

C...Compute for Aerosol species in  TXHG Version

      AEROSOL( LTRACER_AKN, AKN ) = AEROSOL( LTRACER_AKN, AKN ) * EALFA3T
      AEROSOL( LTRACER_ACC, ACC ) = TRACER    * XL * RECIPAP1
      AEROSOL( LTRACER_COR, COR ) = TRACERCOR * XL * RECIPAP1
      AEROSOL( LPHG_AKN, AKN )    = AEROSOL( LPHG_AKN, AKN ) * EALFA3T
      AEROSOL( LPHG_ACC, ACC )    = HGFINE * XL * RECIPAP1
      AEROSOL( LPHG_COR, COR )    = HGCOR * XL * RECIPAP1

C...store the amount of hydrogen deposition

      HPWDEP = REAL( WETDEP( LACL ), 4 )
#ifdef sens
      DO NP =1, NPMAX
        S_HPWDEP( NP ) = S_WETDEP( NP, LACL )
      END DO
#endif

#ifdef isam
C... store sulfate production/loss quantities
      DEPSUM_SAVE =        DEPSUM * XL * RECIPAP1
      DS4_SAVE    = -1.0 * DS4(0) * XL * RECIPAP1
      REMOV_SAVE  = WETDEP( LSO4ACCL ) + WETDEP( LHSO4ACCL )
#endif

      RETURN

C...formats

1001  FORMAT ( 1X, 'STORM RATE=', F6.3, 'DSIVDT(0) =', F10.5,
     &       'TS6=', F10.5, 'DTW(0)=', F10.5, 'CTHK1=', F10.5,
     &       'WTAVG=', F10.5 )

C1002  FORMAT( 65(1X, ES12.4, 4X) )
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HVELOC ( JDATE, JTIME, TSTEP, UWIND, VWIND, HDIV )
      
C-----------------------------------------------------------------------
C Function:
C    This subroutine reads physical velocities in the x1 and x2 directions
C    and returns the contravariant velocities and the horizontal divergence
 
C Preconditions:
C    This routine can be used only for conformal map coordinates 
C    in the horizontal.
C    Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C    INTERPX, INTERPB, M3EXIT, TIME2SEC, SEC2TIME, NEXTIME
      
C Revision history:
C   January 30, 1996 by Clint L. Ingram at NCSC: created for
C   RADM-coordinates

C   22 Apr 97 Jeff:
C    7 Aug 97 Jeff: for NTHIK = 1
C    4 Feb 98 Jeff: deal with end-of-scenario
C   20 Sep 98 David Wong: parallelized the code
C                         -- adjust the data declaration for DENSJ
C                         -- remove indirect index reference, and re-adapt to
C                            a general case
C                         -- invoke stencil exchange library
C   21 Nov 00 J.Young: PE_COMM3 -> Dave Wong's f90 stenex COMM
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C    6 Apr 01 J.Young: Eliminate NTHIN confusion (assumes NTHIK = 1)
C   12 Apr 01 J.Young: Use PINTERPB for boundary data
C   23 Jun 03 J.Young: for layer dependent advection tstep
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   15 Mar 10 J.Young: revert back to 3D arrays and calculate the horiz. div.
C                      (similar to the deform.F code)
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: incorporated twoway model implementation
C   28 Jul 11 David Wong: set REVERT to .false. for twoway model case since
C                         buffered file has only two time steps data
C   01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE)
#endif
      USE CENTRALIZED_IO_MODULE, only : interpolate_var, window
!    &                              STRTCOLMC2,  ENDCOLMC2,  STRTROWMC2,  ENDROWMC2


      IMPLICIT NONE

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction
 
C Parameters
      
C Arguments:
      INTEGER, INTENT( IN )  :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT( IN )  :: TSTEP        ! time step (HHMMSS)
!     REAL         WIND( NCOLS+1,NROWS+1 ) ! CX xi-velocity 
      REAL,    INTENT( OUT ) :: UWIND( :,:,: )  ! CX xi-velocity 
      REAL,    INTENT( OUT ) :: VWIND( :,:,: )  ! CX yi-velocity 
      REAL,    INTENT( OUT ) :: HDIV ( :,:,: )  ! horizontal divergence
      
C file variables:
!     REAL      DENSJ_BUF( NCOLS,NROWS,NLAYS )     ! Jacobian * air density
!     REAL      DENSJ_BND( NBNDY,NLAYS )           ! bndy Jacobian * air density
!     REAL      DENSJ( 0:NCOLS+1,0:NROWS+1,NLAYS )
      REAL, ALLOCATABLE, SAVE :: DENSJ_BUF( :,:,: )  ! Jacobian * air density
      REAL, ALLOCATABLE, SAVE :: DENSJ_BND( :,: )    ! bndy Jacobian * air density
      REAL, ALLOCATABLE, SAVE :: DENSJ( :,:,: )      ! Jacobian * air density
 
C External Functions:

C local variables:
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
       
      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
      INTEGER   STEP              ! advection time step in seconds
      INTEGER, SAVE :: LDATE( 3 ) ! last date for data on file
      INTEGER, SAVE :: LTIME( 3 ) ! last time for data on file
      LOGICAL   REVERT            ! recover last time step if true
      REAL      DJ                ! temporary Jacobian * air density
      REAL       :: DX1, DX2      ! X1 & X2 grid size
      REAL, SAVE :: RDX1, RDX2    ! inverse of DX1 & DX2

      INTEGER   C, C1, R, R1, L   ! induction variables
      INTEGER   BND               ! cell index for constructing density array.
      INTEGER   ALLOCSTAT
 
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'HVELOC'
      CHARACTER( 16 ) :: AMSG
      CHARACTER( 96 ) :: XMSG = ' '
 
      CHARACTER( 8 ), SAVE :: COMMSTR

!     INTEGER       :: NCOLSDENS, NROWSDENS       ! local for DENSJ_BUF
C for INTERPX
!     INTEGER, SAVE :: STRTCOL,   ENDCOL,   STRTROW,   ENDROW
!     INTEGER       :: STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC
!     INTEGER, SAVE :: STRTCOLMD, ENDCOLMD, STRTROWMD, ENDROWMD

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         CALL LSTEPF( MET_CRO_3D, LDATE( 1 ), LTIME( 1 ) )
!        CALL LSTEPF( MET_BDY_3D, LDATE( 2 ), LTIME( 2 ) )
         CALL LSTEPF( MET_DOT_3D, LDATE( 3 ), LTIME( 3 ) )
 
!        LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 2 ), LDATE( 3 ) )
!        LTIME( 1 ) = SEC2TIME( MIN(
!    &                         TIME2SEC( LTIME( 1 ) ),
!    &                         TIME2SEC( LTIME( 2 ) ),
!    &                         TIME2SEC( LTIME( 3 ) )
!    &                         ) )

         LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 3 ) )
         LTIME( 1 ) = SEC2TIME( MIN(
     &                         TIME2SEC( LTIME( 1 ) ),
     &                         TIME2SEC( LTIME( 3 ) )
     &                         ) )

         WRITE( COMMSTR,'(4I2)' )  1, 1-NTHIK, 2, 1-NTHIK  ! ' 1 0 2 0'

C Get/compute DX1 & DX2

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD *
     &         COS( PI180*( YORIG_GD + YCELL_GD * FLOAT( GL_NROWS/2 ))) !in m
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF

         RDX1 = 1.0 / DX1
         RDX2 = 1.0 / DX2

         ALLOCATE ( DENSJ( 0:NCOLS+1,0:NROWS+1,NLAYS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DENSJ'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( .NOT. WINDOW ) THEN

            ALLOCATE ( DENSJ_BUF( ncols, nrows, NLAYS ),STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DENSJ_BUF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( DENSJ_BND( NBNDY,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DENSJ_BND'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF

      END IF     ! if firstime
 
      MDATE  = JDATE
      MTIME  = JTIME
      STEP   = TIME2SEC( TSTEP )
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

#ifdef twoway
      REVERT = .FALSE.
#else
      IF ( MDATE .LT. LDATE( 1 ) ) THEN
         REVERT = .FALSE.
      ELSE IF ( MDATE .EQ. LDATE( 1 ) ) THEN
         IF ( MTIME .LE. LTIME( 1 ) ) THEN
            REVERT = .FALSE.
         ELSE
            REVERT = .TRUE.
         END IF
      ELSE   ! MDATE .GT. LDATE
         REVERT = .TRUE.
      END IF
#endif
 
      IF ( REVERT ) THEN
         XMSG = 'Current scenario interpolation step not available in all of '
     &        // TRIM( MET_CRO_3D ) // ', '
     &        // TRIM( MET_BDY_3D ) // ' and '
     &        // TRIM( MET_DOT_3D )
         CALL M3MESG( XMSG )
         WRITE( AMSG,'( 2I8 )' ) LDATE( 1 ), LTIME( 1 )
         XMSG = 'Using data for last file step: ' // TRIM( AMSG )
         CALL M3MESG( XMSG )
         MDATE = LDATE( 1 )
         MTIME = LTIME( 1 )
      END IF
 
C Interpolate Jacobian X Air Density
 
      IF ( WINDOW ) THEN

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ)

      ELSE  ! need to extend data from bndy file

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BUF)

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BND, 'b')

C Load DENSJ array

         DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DENSJ( C,R,L ) = DENSJ_BUF( C,R,L )
               END DO
            END DO
         END DO

C Fill in DENSJ array for boundaries

         DO L = 1, NLAYS
            BND = 0
            DO R = 0, 0
               DO C = 1, NCOLS+1
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! South
               END DO
            END DO
            DO R = 1, NROWS+1
               DO C = NCOLS+1, NCOLS+1
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! East
               END DO
            END DO
            DO R = NROWS+1, NROWS+1
               DO C = 0, NCOLS
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! North
               END DO
            END DO
            DO R = 0, NROWS
               DO C = 0, 0
                  BND = BND + 1
                  DENSJ( C,R,L ) = DENSJ_BND( BND,L )  ! West
               END DO
            END DO
         END DO

      END IF   ! WINDOW

C Interpolate Contravariant Velocity components (already at flux points)
C X Jacobian X Air Density

      call interpolate_var ('UHAT_JD', mdate, mtime, UWIND)

      call interpolate_var ('VHAT_JD', mdate, mtime, VWIND)

C Obtain flux point values of Jacobian * air density and retrieve
C contravariant velocities 

C store actual north, east, south, and west displacement
C define communication pattern

      CALL SUBST_COMM ( DENSJ, DSPL_N0_E0_S0_W1, DRCN_W, COMMSTR )
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS+1
               DJ = 0.5 * ( DENSJ( C,R,L ) + DENSJ( C-1,R,L ) )
               UWIND( C,R,L ) = UWIND( C,R,L ) / DJ
            END DO
         END DO
      END DO

C store actual north, east, south, and west displacement
C define communication pattern

      CALL SUBST_COMM ( DENSJ, DSPL_N0_E0_S1_W0, DRCN_S, COMMSTR )
      DO L = 1, NLAYS
         DO R = 1, NROWS+1
            DO C = 1, NCOLS
               DJ = 0.5 * ( DENSJ( C,R,L ) + DENSJ( C,R-1,L ) )
               VWIND( C,R,L ) = VWIND( C,R,L ) / DJ
            END DO
         END DO
      END DO

C Compute horizontal divergence

      CALL SUBST_COMM ( UWIND, DSPL_N0_E1_S0_W0, DRCN_E_W )
      CALL SUBST_COMM ( VWIND, DSPL_N1_E0_S0_W0, DRCN_N_S )

#ifdef parallel
!     CALL SWAP3D( UWIND( 1,1,1 ), UWIND( NCOLS+1,1,1 ),
!    &             1, NROWS+1, NLAYS, NCOLS+1, NROWS+1, EAST )
!     CALL SWAP3D( VWIND( 1,1,1 ), VWIND( 1,NROWS+1,1 ),
!    &             NCOLS+1, 1, NLAYS, NCOLS+1, NROWS+1, NORTH )
#endif

      DO L = 1, NLAYS
         DO R = 1, NROWS
            R1 = R + 1
            DO C = 1, NCOLS
               C1 = C + 1
               HDIV( C,R,L ) = ( UWIND( C1,R,L ) - UWIND( C,R,L ) ) * RDX1
     &                       + ( VWIND( C,R1,L ) - VWIND( C,R,L ) ) * RDX2
            END DO
         END DO
      END DO


      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE TMPBEIS312( JDATE, JTIME, TSTEP, BEIS_MAP, EMISL )

C-----------------------------------------------------------------------
 
C Description:
C   Computes hourly time stepped gridded biogenic emissions using 
C   normalized gridded emissions from Normbeis3 (3.12) and postprocessed MM5
C   meteorology.
 
C Preconditions:
C   Postprocessed MM5 meteorology that contains temperature, 
C   solar radiation, and pressure data. 
C   Normalized gridded emissions B3GRD from Normbeis3 (3.12) 
 
C Subroutines and Functions Called:
C   BEIS, HRNO,  
C   CURRSTEP, HHMMSS, UPCASE, CHECKMEM, M3EXIT, M3MSG2,
C   WRITE3, OPEN3, CLOSE3, NEXTIME, TIME2SEC
 
C Revision History:
C   3/01: Prototype by Jeff Vukovich
C         Tested only on 36km Lambert domain 
C         Summer/winter switch file option not tested
C   8/04: Updated for BEIS v3.12
C  10/06: J.Young - CMAQ inline
C                 - assumes first call is scenario start date/time
C                 - optional integral average mass diagnostic emissions file
C  10/09: J.Young - intel compiler problem; move last EMISS calculation as
C                   separate assignment
C  01/10: J.Young - move soil NO data and required input data processing to hrno
C  01/10: D. Wong - Eliminate potential race condition at the MYPE = 0
C                   to open the diagnostic file. Eliminate the BARRIER
C                   and the CLOSE3 and OPEN3.
C  02/11: S.Roselle-Replaced I/O API include files with UTILIO_DEFN
C  05/11: D.Wong-incorporated twoway model implementation
C  07/14: J.Bash-Added meteorological variables needed for leaf temperature
C                calculations.
C  08/14: J.Bash-Added backwards compatibility for earlier versions of MCIP
C  07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C  12 Aug 15 D.Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
C  07 May 18 D. Schwede: Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C  01 Feb 19 D. Wong: Implemented centralized I/O approach, removed all MY_N clauses
C-----------------------------------------------------------------------
C Modified from:
 
C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C                System
C File: @(#)$Id: tmpbeis.F,v 1.6 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/tmpbeis.F,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE BIOG_EMIS             ! beis
      USE centralized_io_module, only : AVGEMIS, AVGLAI, interpolate_var

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Includes:
        
C Arguments:
      INTEGER, INTENT(  IN ) :: JDATE   ! current simulation date (YYYYDDD)
      INTEGER, INTENT(  IN ) :: JTIME   ! current simulation time (HHMMSS)
      INTEGER, INTENT(  IN ) :: TSTEP( 3 )      ! timestep vector
      INTEGER, INTENT(  IN ) :: BEIS_MAP( : )   ! mapping from beis3 to model species
      REAL,    INTENT( OUT ) :: EMISL( :,:,: )  ! emissions in moles/sec

C External Functions
      LOGICAL,         EXTERNAL :: CHKGRID

C Parameters:
      REAL,    PARAMETER :: HR2SEC = 1.0 / 3600.0

C Gridded meteorology data:
      INTEGER, ALLOCATABLE, SAVE :: SWITCH( :,: )     ! Seasonal switch

C Gridded beis emissions
!     REAL,    ALLOCATABLE, SAVE :: AVGEMIS( :,:,:,: ) ! avg emissions (3.12)
!     REAL,    ALLOCATABLE, SAVE :: AVGLAI ( :,:,:,: ) ! avg leaf index

C Gridded normalized emissions:
      REAL,    ALLOCATABLE, SAVE :: SEMIS( :,:,: )    ! Normailized Beis emissions
      REAL,    ALLOCATABLE, SAVE :: SLAI ( :,:,: )    ! Normailized Beis LAI

C Mole and mass factors:
      REAL MLFC, MSFC, EMPL

C Diagnostic file avg factor
      REAL DIVFAC

C BEIS3 internal, output species:
      REAL,    ALLOCATABLE, SAVE :: EMPOL( :,:,: )  ! emissions of biogenic categories
      REAL,    ALLOCATABLE, SAVE :: BIPOL( :,:,: )  ! emissions of biogenic categories
      REAL,    ALLOCATABLE, SAVE :: NOPOL( :,: )    ! emissions of NO
C EMPOL( :,:,NSEF )     = biog  emissions
C BIPOL( :,:,1:NSEF-1 ) = beis3 emissions
C NOPOL( :,: )          = hrno  emissions
      REAL,    ALLOCATABLE, SAVE :: EMISS( :,:,: )    ! emissions in g/s

C Logical names and unit numbers:
            
      CHARACTER( 16 ), SAVE :: SNAME   ! logical name for diagnostic emis output (mass)
      CHARACTER( 16 ), SAVE :: NNAME   ! logical name for normalized-emissions input
      CHARACTER( 16 ), SAVE :: GNAME   ! logical name for GRID_CRO_2D
      CHARACTER( 16 ), SAVE :: BNAME   ! logical name for frost switch input
      CHARACTER( 16 ), SAVE :: MNAME   ! logical name for MET_CRO_2D

C Other variables:
      INTEGER, SAVE :: IHR        ! current simulation hour
      INTEGER          IOS        ! IO or memory allocation status
      INTEGER, SAVE :: LDATE      ! previous simulation date
      INTEGER, SAVE :: MDATE      ! test date to update beis diag avg
      INTEGER, SAVE :: MTIME      ! test time to update beis diag avg
      INTEGER, SAVE :: NSTEPS     ! run duration
      INTEGER, SAVE :: WSTEP  = 0 ! local write counter
      INTEGER          PARTYPE    ! method number to calculate PAR
      INTEGER          C, R, I, J, K, S  ! loop counters and subscripts

      LOGICAL          OK        ! check flag
      LOGICAL, SAVE :: LASTTIC                ! true: last sync step this output tstep
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 256 ) :: MESG       ! message buffer
      CHARACTER( 256 ) :: EQNAME     ! equivalent filename
      CHARACTER(  16 ) :: VAR        ! variable name
      CHARACTER(  16 ) :: PNAME = 'TMPBEIS312'   ! prodedure name

#ifdef verbose_tmpbeis
      REAL,    ALLOCATABLE, SAVE :: EMISX( : )
      INTEGER, ALLOCATABLE, SAVE :: CX( : ), RX( : )
#endif

      INTERFACE
         SUBROUTINE BEIS3( JDATE, JTIME, NX, NY, MSPCS, SEMIS,
     &                     SLAI, BIPOL )
            INTEGER, INTENT( IN ) :: JDATE
            INTEGER, INTENT( IN ) :: JTIME
            INTEGER, INTENT( IN ) :: NX
            INTEGER, INTENT( IN ) :: NY
            INTEGER, INTENT( IN ) :: MSPCS
            REAL,    INTENT( IN ) :: SEMIS ( :,:,: )
            REAL,    INTENT( IN ) :: SLAI  ( :,:,: )
            REAL,    INTENT( OUT ) :: BIPOL( :,:,: )
         END SUBROUTINE BEIS3
         SUBROUTINE HRNO( JDATE, JTIME, TSTEP, NOPOL )
            INTEGER, INTENT( IN )  :: JDATE
            INTEGER, INTENT( IN )  :: JTIME
            INTEGER, INTENT( IN )  :: TSTEP( 3 )
            REAL,    INTENT( OUT ) :: NOPOL( :,: )
         END SUBROUTINE HRNO
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C Determine last timestamp
         NSTEPS = RUNLEN / TSTEP( 1 )           ! initscen guarantees divisibility

C Open and check bioseason file if using
         IF ( BIOGEMIS_SEASON ) THEN

            ALLOCATE( SWITCH( NCOLS,NROWS ), STAT=IOS )
            CALL CHECKMEM( IOS, 'SWITCH', PNAME )
            SWITCH = 0   ! array

         END IF

C Ensure met data time and grid for this run match beis emissions data files
         MNAME = PROMPTMFILE( 
     &           'Enter name for gridded met input file',
     &           FSREAD3, 'MET_CRO_2D', PNAME )

C Get description of met file 
         IF ( .NOT. DESC3( MNAME ) ) THEN
            MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
            CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
         END IF

C Check that grid description matches BGRD file
         IF ( .NOT. CHKGRID( MNAME ) ) THEN
            MESG = 'Grid in file "' // TRIM( MNAME )
     &           // '" does not match previously set grid.'
            CALL M3WARN( PNAME, 0, 0, MESG )
         END IF

         IF ( BEMIS_DIAG ) THEN
C Build description for, and open beis diagnostic file
            MDATE = STDATE; MTIME = STTIME
            CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )

            GDNAM3D = GRID_NAME  ! from HGRD_DEFN
            SDATE3D = MDATE
            STIME3D = MTIME
            TSTEP3D = TSTEP( 1 )
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D =     1
            NTHIK3D =     1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD

            DO I = 1, NLAYS3D + 1
               VGLVS3D( I ) = VGLVS_GD( I )
            END DO
  

            J = 0
            DO I = 1, MSPCS
               IF ( BEIS_MAP( I ) .GT. 0 ) THEN
                  J = J + 1
                  VNAME3D( J ) = EMSPC( I )
                  VDESC3D( J ) = 'biogenic emissions of the indicated species'
                  VTYPE3D( J ) = M3REAL
                  UNITS3D( J ) = 'gm s-1'
               END IF
            END DO

            NVARS3D = J
            FDESC3D = ' '   ! array

            FDESC3D( 1 ) = 'Gridded biogenic emissions from CMAQ-BEIS3'
            FDESC3D( 2 ) = '/from/ ' // PNAME
            FDESC3D( 3 ) = '/Version/ CMAQ'

C Open mass output file (tons/hour)

            SNAME = 'B3GTS_S'
            CALL SUBST_BARRIER
            IF ( IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( SNAME, FSNEW3, PNAME ) ) THEN
                  MESG = 'Could not open "' // TRIM( SNAME ) // '" file'
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT1 )
               END IF
            END IF

         END IF

C Allocate memory for arrays
         
         ALLOCATE( EMPOL( NCOLS,NROWS,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'EMPOL', PNAME )

         ALLOCATE( BIPOL( NCOLS,NROWS,NSEF-1 ), STAT=IOS )
         CALL CHECKMEM( IOS, 'BIPOL', PNAME )

         ALLOCATE( NOPOL( NCOLS,NROWS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'NOPOL', PNAME )

         IF ( BEMIS_DIAG ) THEN
            ALLOCATE( EMISS( NCOLS,NROWS,MSPCS ), STAT=IOS )
            CALL CHECKMEM( IOS, 'EMISS', PNAME )
         END IF

         ALLOCATE( SEMIS( NCOLS,NROWS,NSEF-1 ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SEMIS', PNAME )

         ALLOCATE( SLAI( NCOLS,NROWS,NLAI ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SLAI', PNAME )

C Initialize normalized emissons to be used 
         IF ( ASSUME_SUMMER ) THEN
            SEMIS = AVGEMIS( 1:NCOLS,1:NROWS,:,NSUMMER )
            SLAI  = AVGLAI ( 1:NCOLS,1:NROWS,:,NSUMMER )
         ELSE
            SEMIS = AVGEMIS( 1:NCOLS,1:NROWS,:,NWINTER )
            SLAI  = AVGLAI ( 1:NCOLS,1:NROWS,:,NWINTER )
         END IF

         LDATE = 0

#ifdef verbose_tmpbeis
         ALLOCATE( EMISX( MSPCS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'EMISX', PNAME )
         ALLOCATE( CX( MSPCS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'CX', PNAME )
         ALLOCATE( RX( MSPCS ), STAT=IOS )
         CALL CHECKMEM( IOS, 'RX', PNAME )
#endif

         IF ( BEMIS_DIAG ) THEN
            EMISS = 0.0   ! array
#ifdef parallel_io
            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( SNAME, FSREAD3, PNAME ) ) THEN
                  MESG = 'Could not open ' // TRIM(SNAME)
                  CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
               END IF
            END IF
#endif
         END IF

      END IF   ! FIRSTIME

C Loop thru the number of time steps (hourly)

      EMISL = 0.0   ! array
      EMPOL = 0.0   ! array
#ifdef verbose_tmpbeis
      EMISX = 0.0   ! array
#endif

      IF ( JDATE .NE. LDATE ) THEN

         CALL WRDAYMSG( JDATE, MESG )               

C If new date, read season switch 
         IF ( BIOGEMIS_SEASON ) THEN
            MESG = 'Reading gridded season switch data...'
            CALL M3MSG2( MESG ) 
             
            call interpolate_var ('SEASON', jdate, 0, SWITCH)

            MESG = 'Applying gridded season switch data...' 
            CALL M3MSG2( MESG )

            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( SWITCH( C,R ) .EQ. 0 ) THEN   ! use winter normalized emissions
                     SEMIS( C,R,1:NSEF-1 ) = AVGEMIS( C,R,1:NSEF-1,NWINTER )
                     SLAI ( C,R,1:NLAI   ) =  AVGLAI( C,R,1:NLAI,  NWINTER )
                  ELSE
                     SEMIS( C,R,1:NSEF-1 ) = AVGEMIS( C,R,1:NSEF-1,NSUMMER )
                     SLAI ( C,R,1:NLAI   ) =  AVGLAI( C,R,1:NLAI,  NSUMMER )
                  END IF                      
               END DO
            END DO
 
         END IF   ! if using switch file

      END IF   ! if new day

      WRITE( MESG,94030 ) HHMMSS( JTIME )
      CALL M3MSG2( MESG )

C repopulate the met_cro_2d variable attributes
      IF ( .NOT. DESC3( MNAME ) ) THEN
         MESG = 'Could not get description of file "'
     &           // TRIM( MNAME ) // '"'
         CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
      END IF

C Calculate temporal non-speciated beis emissions
      CALL BEIS3( JDATE, JTIME, NCOLS, NROWS, MSPCS, SEMIS, SLAI, BIPOL )

C Calculate temporal non-speciated soil NO emissions
      CALL HRNO( JDATE, JTIME, TSTEP, NOPOL )

      EMPOL( :,:,1:NSEF-1 ) = BIPOL
      EMPOL( :,:,NSEF )     = NOPOL

C Speciate emissions
      DO K = 1, NSEF
         DO R = 1, NROWS
            DO C = 1, NCOLS
               EMPL = EMPOL( C,R,K ) * HR2SEC
               IF ( EMPL .GT. 0.0 ) 
     &            EMISL( :,C,R ) = EMISL( :,C,R ) + EMPL * MLFAC( :,K )
            END DO
         END DO
      END DO

#ifdef verbose_tmpbeis
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) '       from TMPBEIS312'
      WRITE( LOGDEV,* ) '    Spc   EMISL  MaxC MaxR'
      DO S = 1, MSPCS
         WRITE( LOGDEV,'( 4X, I3, F10.5, 2I4 )' ) S, EMISX( S ), CX( S ), RX( S )
      END DO

      EMISX = 0.0    ! array
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) '                   from TMPBEIS312'
      WRITE( LOGDEV,* ) '    Spc SpcName  Pol  MLFAC     EMPOL     EMISL( Spc,32,7 )'
      C = 32; R = 7
      DO K = 1, NSEF
         EMPL = EMPOL( C,R,K ) * HR2SEC
         IF ( EMPL .LE. 0.0 ) CYCLE
         DO S = 1, MSPCS
            IF ( BEIS_MAP( S ) .GT. 0 ) THEN
               MLFC = MLFAC( S,K )
               EMISX( S ) = EMISX( S ) + EMPL * MLFC
               IF ( MLFC .NE. 0.0 )
     &            WRITE( LOGDEV,'( 4X, I3, 2X, A6, 2X, I3, 1X, 3( 1PE10.3 ) )' )
     &                              S, EMSPC( S ), K,  MLFC, EMPL, EMISX( S )
            END IF
         END DO
      END DO
#endif

      WSTEP   =   WSTEP + TIME2SEC( TSTEP( 2 ) )
      LASTTIC = ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) )

      IF ( BEMIS_DIAG ) THEN
         DO K = 1, NSEF
            DO S = 1, MSPCS
! Unit conversion for the emission and fraction of the sync time step to the output time step
                  MSFC = MSFAC( S,K ) * FLOAT( TIME2SEC( TSTEP( 2 ) ) ) / FLOAT( TIME2SEC( TSTEP( 1 ) ) )
! Add the emission for the model output time step
                  EMISS( :,:,S ) = EMISS( :,:,S ) + EMPOL( :,:,K ) * MSFC
            END DO
         END DO
         IF ( LASTTIC ) THEN
            EMISS = EMISS * HR2SEC   ! convert from gm/h to gm/s
            DO S = 1,MSPCS
               IF ( BEIS_MAP( S ) .GT. 0 ) THEN
                  IF ( .NOT. WRITE3( SNAME, EMSPC( S ), MDATE, MTIME, EMISS(:,:,S) ) ) THEN
                     MESG = 'Could not write to output file "' // TRIM( SNAME ) // '"'
                     CALL M3EXIT( PNAME, JDATE, JTIME, MESG, XSTAT2 )
                  END IF
               END IF
            END DO
            WRITE( LOGDEV,94040 )
     &            'Timestep written to', SNAME,
     &            'for date and time', MDATE, MTIME
            EMISS = 0.0   ! array
            WSTEP = 0
            CALL NEXTIME( MDATE, MTIME, TSTEP( 1 ) )
         END IF
      END IF

C Save date
      LDATE = JDATE

      RETURN

C------------------  FORMAT  STATEMENTS   ------------------------------

94010 FORMAT( 10( A, ':', I8, ':', 1X ) )
94020 FORMAT( 1X, I7, ":", I6.7 )
94030 FORMAT( 5X, 'Temporal BEIS at time ', A8 )
94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

      END SUBROUTINE TMPBEIS312  

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_WRTPADEFN

C-----------------------------------------------------------------------
 
C Function: To write the Models-3 Process Analysis Control PA_DEFN module 
 
C Preconditions: Requires mechanism to have been processed
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jan, 2006 by J. Young I couldn't resist the temptation to F90-ize the output
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI's M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE PA_VARS, Only: TDATOUT
      USE PA_IPRVARS, Only: MAXIPROUT
      USE PA_PARSE
      USE PA_DEFN

      IMPLICIT NONE
      
C Includes: None
      
C Arguments: None
                                        
C Parameters: None

C External Functions: None

C Local Variables:

!     CHARACTER(  1 ) :: DOT = '.'  ! Dot character
      CHARACTER(  1 ) :: DIT = '='  ! Dit character
      CHARACTER( 72 ) :: DELIM      ! Delimiter line output
      CHARACTER( 72 ) :: CEES       ! Line of 'c's
      CHARACTER( 80 ) :: LINOUT     ! Output line

      INTEGER IOUT            ! Unit number for include file
      INTEGER N               ! Loop index
         
      INTEGER MXCGRIDD        ! Dimension for number of familys for PA
      INTEGER MXNIRRRXNSD     ! Dimension parameter for MXNIRRRXNS
      INTEGER MXTEMPTRMSD     ! Dimension parameter for MXTEMPTRMS
      INTEGER NCSAVED         ! Dimension for NCSAVE
      INTEGER NIRRVARD        ! Dimension of IRR output variables
      INTEGER N_IPR_SPCD      ! Dimension statement for no. of PA species
      INTEGER NIPRVARD        ! Dimension of PA output variables
      INTEGER NUMTEMPSD       ! Dimension for number of temp IRRs
      INTEGER NUMOUTPOSD      ! Dimension parameter for NUMOUTPOS
      INTEGER NUMOUTNEGD      ! Dimension parameter for NUMOUTNEG
      INTEGER NUMOUTINDD      ! Dimension parameter for NUMOUTIND

      CHARACTER(  7 ) :: BUF6 ( MAXIPROUT )  ! 6-Character buffer
      CHARACTER( 13 ) :: BUF12( MAXIPROUT )  ! 12-Character buffer
      CHARACTER( 21 ) :: BUF20( MAXIPROUT )  ! 20-Character buffer

      INTEGER :: MAXCNT = 99  ! Maximum number of continuation lines
      INTEGER NHI             ! Highest index of loop
      INTEGER NIRR            ! IRR loop index
      INTEGER NLO             ! Lowest index of loop
      INTEGER NPA             ! IPR species loop index
      INTEGER NS              ! Loop index for sets of data statments
      INTEGER NSETS           ! Number of sets of data statements to write

C-----------------------------------------------------------------------

      DO N = 1, 72
         DELIM( N:N ) = DIT
         CEES( N:N ) = 'c'
      END DO     
      DELIM( 1:1 ) = 'C'

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Open and Control Include file and write the header data
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IOUT = JUNIT(  )
      OPEN( UNIT = IOUT, FILE = 'PA_DEFN_REPORT' )
      WRITE( IOUT, 94000 ) DELIM( 1:72 )
      LINOUT = '      MODULE PA_DEFN'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      WRITE( IOUT, 94000 ) LINOUT( 1:1 )
      LINOUT = 'C Contains: Control parameters for Process Analysis'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      WRITE( IOUT, 94000 ) LINOUT( 1:1 )
      LINOUT = 'C Dependent On: Mechanism Input file'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      WRITE( IOUT, 94000 ) LINOUT( 1:1 )
      LINOUT = 'C Created By: Process Analysis Control Program'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = 'C           ' // TDATOUT
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the control parameters
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 94020 )
      WRITE( IOUT, 94040 )      
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )

c..LIPR -- for integrated process rates
      IF ( N_IPR_SPC .GT. 0 ) THEN
         WRITE( IOUT, 94080 )
      ELSE
         WRITE( IOUT, 94100 )
      END IF

c..LIRR -- for integrated reaction rates     
      IF ( LFULLIRR .OR. LPARTIRR ) THEN
         WRITE( IOUT, 94140 )
      ELSE
         WRITE( IOUT, 94160 )
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write messages about array dimensioning if needed
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( .NOT. LIRR ) THEN
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 95020 )
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 94000 )
      END IF

      IF ( .NOT. LIPR ) THEN
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 95040 )
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 94000 ) 
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write output file variables 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95120 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95140 ) 
      WRITE( IOUT, 94000 ) CEES
      NIPRVARD = MAX( NIPRVAR, 1 )
      NIRRVARD = MAX( NIRRVAR, 1 )
      WRITE( IOUT, 95160 ) NIPRVAR, NIPRVARD
      WRITE( IOUT, 95180 ) NIRRVAR, NIRRVARD
      WRITE( IOUT, 95200 )
 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write integrated process rate variables 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95260 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95280 ) 
      WRITE( IOUT, 94000 ) CEES

      N_IPR_SPCD  = MAX( N_IPR_SPC, 1 )
      NCSAVED     = MAX( NCSAVE, 1 )
      MXCGRIDD    = MAX( MXCGRID, 1 )

      WRITE( IOUT, 95300 ) NPRCS,
     &                     N_IPR_SPC, N_IPR_SPCD,
     &                     NCSAVE, NCSAVED,
     &                     MXCGRID, MXCGRIDD
      WRITE( IOUT, 95320 )
      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write integrated reaction rate variables 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95360 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 95380 ) 
      WRITE( IOUT, 94000 ) CEES

      IF ( LFULLIRR ) THEN
         WRITE( IOUT, 95420 )
      ELSE
         WRITE( IOUT, 95440 )
      END IF

      IF ( LPARTIRR ) THEN
         WRITE( IOUT, 95480 )
      ELSE
         WRITE( IOUT, 95500 )
      END IF

!     IF ( .NOT. LPARTIRR ) THEN
!        NUMTEMPS   = 0
!        NUMOUTPOS  = 0
!        NUMOUTNEG  = 0
!        NUMOUTIND  = 0
!        MXNIRRRXNS = 0
!        MXTEMPTRMS = 0
!     END IF

      NUMTEMPSD    = MAX( NUMTEMPS,   1 )
      NUMOUTPOSD   = MAX( NUMOUTPOS,  1 )
      NUMOUTNEGD   = MAX( NUMOUTNEG,  1 )
      NUMOUTINDD   = MAX( NUMOUTIND,  1 )
      MXNIRRRXNSD  = MAX( MXNIRRRXNS, 1 )
      MXTEMPTRMSD  = MAX( MXTEMPTRMS, 1 )

      WRITE( IOUT, 95520 ) NUMTEMPS, NUMTEMPSD,
     &                     NUMOUTPOS, NUMOUTPOSD,
     &                     NUMOUTNEG, NUMOUTNEGD,
     &                     NUMOUTIND, NUMOUTINDD,
     &                     MXNIRRRXNS, MXNIRRRXNSD,
     &                     MXTEMPTRMS, MXTEMPTRMSD

      IF ( NIRRVAR .NE. 0 ) THEN
         WRITE( IOUT, 95542 )
      ELSE 
         WRITE( IOUT, 95544 )
      END IF

      WRITE( IOUT, 95580 )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write monocode extensions (declarations and common block) and end
c  line and return
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( .NOT. LIPR .AND. .NOT. LIRR ) THEN
         WRITE( IOUT, 96110 )
         GO TO 999
      END IF         

C-----------------------------------------------------------------------
      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = 'C Initialize variable arrays via DATA stmts.'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write data statements for output file variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 96120 ) 
      WRITE( IOUT, 94000 ) CEES
      WRITE( IOUT, 96200 ) 
 
      IF ( NIPRVAR .GT. 0 ) THEN
         NSETS = ( ( NIPRVAR - 1 ) / ( 3 * MAXCNT ) ) + 1
         write( *,* ) 'n IPR var nsets 1: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 3 * MAXCNT ) + 1
            NHI = MIN( ( NS * 3 * MAXCNT ), NIPRVAR )
            write( *,* ) 'n IPR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96220 ) NLO,  NHI
            DO NPA = NLO, NHI
               BUF20( NPA ) = ' "' // IPRNAME( NPA ) // '",'
            END DO
            BUF20( NHI )( 20:21 ) = ' /'
            call listout( NLO, NHI, 3, IOUT, BUF20 )
         END DO

         NSETS = ( ( NIPRVAR - 1 ) / MAXCNT ) + 1
         write( *,* ) 'n IPR var nsets 2: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( MAXCNT ) + 1
            NHI = MIN( ( NS * MAXCNT ), NIPRVAR )         
            write( *,* ) 'n IPR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96240 ) NLO,  NHI
            DO NPA = NLO, NHI
               LINOUT = '     &  "' // IPRDESC( NPA ) // '",'
               IF ( NPA .EQ. NHI ) LINOUT( 71:71 ) = '/'
               WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
            END DO
         END DO
      END IF

      IF ( NIRRVAR .GT. 0 ) THEN
         NSETS = ( ( NIRRVAR - 1 ) / ( 3 * MAXCNT ) ) + 1
         write( *,* ) 'n IRR var nsets 1: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 3 * MAXCNT ) + 1
            NHI = MIN( ( NS * 3 * MAXCNT ), NIRRVAR )
            write( *,* ) 'n IRR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96260 ) NLO, NHI
            DO NIRR = NLO, NHI
               BUF20( NIRR ) = ' "' // IRRNAME( NIRR ) // '",'
            END DO
            BUF20( NHI )( 20:21 ) = ' /'
            call listout( NLO, NHI, 3, IOUT, BUF20 )
         END DO

         NSETS = ( ( NIRRVAR - 1 ) / MAXCNT ) + 1
         write( *,* ) 'n IRR var nsets 2: ', nsets
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( MAXCNT ) + 1
            NHI = MIN( ( NS * MAXCNT ), NIRRVAR )         
            write( *,* ) 'n IRR var nlo nhi: ', nlo, nhi
            WRITE( IOUT, 96280 ) NLO,  NHI
            DO NIRR = NLO, NHI
               LINOUT = '     &  "' // IRRDESC( NIRR ) // '",'
               IF ( NIRR .EQ. NHI ) LINOUT( 71:71 ) = '/'
               WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
            END DO
         END DO
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write data statements for integrated Process rate variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIPR ) THEN
         WRITE( IOUT, 94000 ) ''
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 96140 ) 
         WRITE( IOUT, 94000 ) CEES

         NSETS = ( ( NPRCS - 1 ) / ( 3 * MAXCNT ) ) + 1
         DO NS = 1,  NSETS
            NLO = ( NS - 1 ) * ( 3 * MAXCNT ) + 1
            NHI = MIN( ( NS * 3 * MAXCNT ),  NPRCS )         
            WRITE( IOUT, 96290 ) NLO, NHI
            DO NPA = NLO, NHI
               BUF20( NPA ) = ' "' // PROCNAME( NPA ) // '",' 
            END DO
            BUF20( NHI )( 20:21 ) = ' /'
            call listout( NLO, NHI, 3, IOUT, BUF20 )
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         NSETS = ( ( N_IPR_SPC - 1 ) / ( 10 * MAXCNT ) ) + 1
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
            NHI = MIN( ( NS * 10 * MAXCNT ), N_IPR_SPC )         
            WRITE( IOUT, 96300 ) NLO, NHI
            DO NPA = NLO,  NHI
               WRITE( BUF6( NPA ), "( I5, ',' )" ) NCGRID( NPA )
            END DO
            BUF6( NHI )( 6:7 ) = ' /'
            call listout( NLO, NHI, 10, IOUT, BUF6 )
         END DO
      END IF

      IF ( NCSAVE .GT. 0 ) THEN
         NSETS = ( ( NCSAVE - 1 ) / ( 10 * MAXCNT ) ) + 1
         DO NS = 1, NSETS
            NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
            NHI = MIN( ( NS * 10 * MAXCNT ), NCSAVE )         
            WRITE( IOUT, 96320 ) NLO, NHI
            DO NPA = NLO,  NHI
               WRITE( BUF6( NPA ), 96080 ) SAV2GRD( NPA )
            END DO
            BUF6( NHI )( 6:7 ) = ' /'
            call listout( NLO, NHI, 10, IOUT, BUF6 )
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NPRCS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NPRCS )         
               WRITE( IOUT, 96340 ) NPA, NLO, NHI
               DO N = NLO,  NHI
                  WRITE( BUF6( N ), 96080 ) IPROUT( NPA, N )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO 
         END DO
      END IF 

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NCGRID( NPA ) - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ),  NCGRID( NPA ) )         
               WRITE( IOUT, 96360 ) NPA, NLO, NHI
               DO N = NLO, NHI
                  WRITE( BUF6( N ), 96080 ) IPR2GRD( NPA, N )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO 
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NCGRID( NPA ) - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NCGRID( NPA ) )         
               WRITE( IOUT, 96380 ) NPA,  NLO,  NHI
               DO N = NLO, NHI
                  WRITE( BUF6( N ), 96080 ) IPR2SAV( NPA, N )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO 
         END DO
      END IF

      IF ( LIPR ) THEN
         NSETS = ( ( NPRCS - 1 ) / ( 5 * MAXCNT ) ) + 1
         DO NS = 1,  NSETS
            NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
            NHI = MIN( ( NS * 5 * MAXCNT ), NPRCS )         
            WRITE( IOUT, 96400 ) NLO,  NHI
            DO N = NLO, NHI
               IF ( LPROCOUT( N ) ) THEN
                  BUF12( N ) = '     .TRUE., '
               ELSE
                  BUF12( N ) = '    .FALSE., '
               END IF
            END DO
            BUF12( NHI )( 12:13 ) = ' /'  
!           WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
            call listout( NLO, NHI, 5, IOUT, BUF12 )
         END DO
      END IF

      IF ( N_IPR_SPC .GT. 0 ) THEN
         DO NPA = 1, N_IPR_SPC
            NSETS = ( ( NCGRID( NPA ) - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NCGRID( NPA ) )         
               WRITE( IOUT, 96420 ) NPA, NLO, NHI
               DO N = 1,  NCGRID( NPA )
                  WRITE( BUF12( N ), 96100 ) SPCOEF( NPA,  N )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
               WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
            END DO 
         END DO
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write data statements for IRR variables
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LPARTIRR ) THEN
         WRITE( IOUT, 94000 )
         WRITE( IOUT, 94000 ) CEES
         WRITE( IOUT, 96160 ) 
         WRITE( IOUT, 94000 ) CEES

         IF ( NIRRVAR .GT. 0 ) THEN
            NSETS = ( ( NIRRVAR - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NIRRVAR )         
               WRITE( IOUT, 96440 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) NIRRRXNS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF     

         IF ( NUMTEMPS .GT. 0 ) THEN
            NSETS = ( ( NUMTEMPS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ),  NUMTEMPS )         
               WRITE( IOUT, 96460 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPTERMS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF     
 
         IF ( NUMOUTPOS .GT. 0 ) THEN
            NSETS = ( ( NUMOUTPOS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN(  ( NS * 10 * MAXCNT ),  NUMOUTPOS )         
               WRITE( IOUT, 96480 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPOUTPOS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 
             
         IF ( NUMOUTNEG .GT. 0 ) THEN
            NSETS = ( ( NUMOUTNEG - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ),  NUMOUTNEG )         
               WRITE( IOUT, 96500 ) NLO,  NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPOUTNEG( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTIND .GT. 0 ) THEN
            NSETS = ( ( NUMOUTIND - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTIND )         
               WRITE( IOUT, 96520 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) TEMPOUTIND( NIRR )
              END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTPOS .GT. 0 ) THEN
            NSETS = ( ( NUMOUTPOS - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTPOS )         
               WRITE( IOUT, 96540 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) INDXOUTPOS( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTNEG .GT. 0 ) THEN
            NSETS = ( ( NUMOUTNEG - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTNEG )       
               WRITE( IOUT, 96560 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) INDXOUTNEG( NIRR )
              END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF 

         IF ( NUMOUTIND .GT. 0 ) THEN
            NSETS = ( ( NUMOUTIND - 1 ) / ( 10 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
               NHI = MIN( ( NS * 10 * MAXCNT ), NUMOUTIND )       
               WRITE( IOUT, 96580 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF6( NIRR ), 96080 ) INDXOUTIND( NIRR )
               END DO
               BUF6( NHI )( 6:7 ) = ' /'
               call listout( NLO, NHI, 10, IOUT, BUF6 )
            END DO
         END IF

         IF ( NIRRVAR .GT. 0 ) THEN
            DO NIRR = 1, NIRRVAR
               IF ( NIRRRXNS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( NIRRRXNS( NIRR ) - 1 ) / ( 10 * MAXCNT ) ) + 1
                  DO NS = 1,  NSETS
                     NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
                     NHI = MIN( ( NS * 10 * MAXCNT ), NIRRRXNS( NIRR ) )         
                     WRITE( IOUT, 96600 ) NIRR, NLO, NHI
                     DO N = NLO, NHI
                        WRITE( BUF6( N ), 96080 ) IRRRXN( NIRR, N )
                     END DO
                     BUF6( NHI )( 6:7 ) = ' /'
                     call listout( NLO, NHI, 10, IOUT, BUF6 )
                  END DO
               END IF 
            END DO
         END IF

         IF ( NUMTEMPS .GT. 0 ) THEN
            DO NIRR= 1, NUMTEMPS
               IF ( TEMPTERMS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( TEMPTERMS( NIRR ) - 1 ) / ( 10 * MAXCNT ) ) + 1
                  DO NS = 1, NSETS
                     NLO = ( NS - 1 ) * ( 10 * MAXCNT ) + 1
                     NHI = MIN( ( NS * 10 * MAXCNT ), TEMPTERMS( NIRR ) )         
                     WRITE( IOUT, 96620 ) NIRR,  NLO,  NHI
                     DO N = NLO, NHI
                        WRITE( BUF6( N ), 96080 ) TEMPRXN( NIRR, N )
                     END DO
                     BUF6( NHI )( 6:7 ) = ' /'
                     call listout( NLO, NHI, 10, IOUT, BUF6 )
                  END DO
               END IF
            END DO
         END IF

         IF ( NUMOUTPOS .GT. 0 ) THEN
            NSETS = ( ( NUMOUTPOS - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NUMOUTPOS )         
               WRITE( IOUT, 96640 ) NLO, NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF12( NIRR ), 96100 ) COEFOUTPOS( NIRR )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
!              WRITE( IOUT, 96060 ) ( BUF12( NIRR ), NIRR = NLO, NHI )
               call listout( NLO, NHI, 5, IOUT, BUF12 )
            END DO
         END IF

         IF ( NUMOUTNEG .GT. 0 ) THEN
            NSETS = ( ( NUMOUTNEG - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NUMOUTNEG )         
               WRITE( IOUT, 96660 ) NLO,  NHI
               DO NIRR = NLO, NHI
                  WRITE( BUF12( NIRR ), 96100 ) COEFOUTNEG( NIRR )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
!              WRITE( IOUT, 96060 ) ( BUF12( NIRR ), NIRR = NLO, NHI )
               call listout( NLO, NHI, 5, IOUT, BUF12 )
            END DO
         END IF

         IF ( NUMOUTIND .GT. 0 ) THEN
            NSETS = ( ( NUMOUTIND - 1 ) / ( 5 * MAXCNT ) ) + 1
            DO NS = 1, NSETS
               NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
               NHI = MIN( ( NS * 5 * MAXCNT ), NUMOUTIND )         
               WRITE( IOUT, 96680 ) NLO,  NHI
               DO NIRR = NLO, NHI
                 WRITE( BUF12( NIRR ), 96100 ) COEFOUTIND( NIRR )
               END DO
               BUF12( NHI )( 12:13 ) = ' /'
!              WRITE( IOUT, 96060 ) ( BUF12( NIRR ), NIRR = NLO, NHI )
               call listout( NLO, NHI, 5, IOUT, BUF12 )
            END DO
         END IF

         IF ( NUMTEMPS .GT. 0 ) THEN
            DO NIRR= 1, NUMTEMPS
               IF ( TEMPTERMS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( TEMPTERMS( NIRR ) - 1 ) / ( 5 * MAXCNT ) ) + 1
                  DO NS = 1, NSETS
                     NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
                     NHI = MIN(  ( NS * 5 * MAXCNT ), TEMPTERMS( NIRR ) )         
                     WRITE( IOUT, 96700 ) NIRR, NLO, NHI
                     DO N = NLO, NHI
                        WRITE( BUF12( N ), 96100 ) TEMPCOEF( NIRR, N )
                     END DO
                     BUF12( NHI )( 12:13 ) = ' /'
!                    WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
                     call listout( NLO, NHI, 5, IOUT, BUF12 )
                 END DO
               END IF 
            END DO
         END IF

         IF ( NIRRVAR .GT. 0 ) THEN
            DO NIRR = 1, NIRRVAR
               IF ( NIRRRXNS( NIRR ) .GT. 0 ) THEN
                  NSETS = ( ( NIRRRXNS( NIRR ) - 1 ) / ( 5 * MAXCNT ) ) + 1
                  DO NS = 1, NSETS
                     NLO = ( NS - 1 ) * ( 5 * MAXCNT ) + 1
                     NHI = MIN( ( NS * 5 * MAXCNT ), NIRRRXNS( NIRR ) )         
                     WRITE( IOUT, 96720 ) NIRR,  NLO,  NHI
                     DO N = NLO, NHI
                        WRITE( BUF12( N ), 96100 ) IRRCOEF( NIRR, N )
                     END DO
                     BUF12( NHI )( 12:13 ) = ' /'
!                    WRITE( IOUT, 96060 ) ( BUF12( N ), N = NLO, NHI )
                     call listout( NLO, NHI, 5, IOUT, BUF12 )
                  END DO
               END IF 
            END DO
         END IF
      END IF

999   CONTINUE

      LINOUT = ''
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      LINOUT = '      END MODULE PA_DEFN'
      WRITE( IOUT, 94000 ) LINOUT( 1:LEN_TRIM( LINOUT ) )
      CLOSE( IOUT )

      RETURN 
     
C----------------------- FORMAT Statements -----------------------------

94000 FORMAT( A )     
94020 FORMAT( 
     & 'c  The following variables are used to control calls to', 
     &     ' the Integrated' /
     & 'c  Process Rate and Integrated Reaction Rate routines:' )
94040 FORMAT( 
     & 'c     LIPR = Flag for calculating Integrated Process Rates' /
     & 'c     LIRR = Flag for calculating Integrated Reaction Rates' )
94080 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIPR = .TRUE.' / )
94100 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIPR = .FALSE.' / )
94140 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIRR = .TRUE.' / )
94160 FORMAT(   6X, 'LOGICAL, PARAMETER :: LIRR = .FALSE.' / )

C----------------------- FORMAT Statements -----------------------------

95020 FORMAT( 
     & 'c  Integrated Reaction Rates are not being computed.  All',
     &     ' associated'/
     & 'c  arrays will be set to the smallest possible dimension.' )

95040 FORMAT( 
     & 'c  Integrated Process Rates are not being computed.  All',
     &     ' associated'/
     & 'c  arrays will be set to the smallest possible dimension.' )

95120 FORMAT( 
     &'c  The following variables are used in the output file ', 
     &      'descriptions' )
95140 FORMAT( 
     &'c     NIPRVAR   = Number of IPR output variables'/
     &'c     NIRRVAR   = Number of IRR output variables'/
     &'c     NIPRVARD  = Dimension for IPR output variables'/
     &'c     NIRRVARD  = Dimension for IRR output variables'/
     &'c     IPRNAME   = Name of IPR output variable'/
     &'c     IRRNAME   = Name of IRR output variable'/
     &'c     IPRDESC   = Extended name of IPR output variable'/
     &'c     IRRDESC   = Extended name of IRR output variable' )

95160 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NIPRVAR =', I4, ',',
     & 2X,                       'NIPRVARD =', I4 )

95180 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NIRRVAR =', I4, ',',
     & 2X,                       'NIRRVARD =', I4 / )

95200 FORMAT( 
     & 6X, 'CHARACTER( 16 ) :: IPRNAME( NIPRVARD )' /
     & 6X, 'CHARACTER( 60 ) :: IPRDESC( NIPRVARD )' /
     & 6X, 'CHARACTER( 16 ) :: IRRNAME( NIRRVARD )' /
     & 6X, 'CHARACTER( 60 ) :: IRRDESC( NIRRVARD )' / )

95260 FORMAT( 
     & 'c  The following variables are used in the integrated process', 
     &     ' rate '/'c  computations.' )

95280 FORMAT( 
     & 'c    NPRCS      = No. of science processes that can be monitored' /
     & 'c    N_IPR_SPC  = Number of families for IPR' /
     & 'c    NCSAVE     = Number of CTM species concs to save for IPR' /
     & 'c    MXCGRID    = Max number of CTM species in an IPR family' /
     & 'c    N_IPR_SPCD = Dimension for number of families for IPR' /
     & 'c    NCSAVED    = Dimension for NCSAVE' /
     & 'c    MXCGRIDD   = Dimension for MXCGRID' /
     & 'c    NCGRID     = Array of no. of CTM species in an IPR family' /
     & 'c    IPROUT     = Array of IPR output variable indices' /
     & 'c    IPR2GRD    = Array of CTM species indices for IPR families' /
     & 'c    IPR2SAV    = Array of saved species indices for IPR families' /
     & 'c    SV2GRD     = Array of CTM indicies for saved concs' /
     & 'c    SPCOEF     = Array of coefficients for IPR familys' ) 

95300 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NPRCS      =', I4 /
     & 6X, 'INTEGER, PARAMETER :: N_IPR_SPC  =', I4, ',',
     & 2X,                       'N_IPR_SPCD =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NCSAVE     =', I4, ',',
     & 2X,                       'NCSAVED    =', I4 /
     & 6X, 'INTEGER, PARAMETER :: MXCGRID    =', I4, ',',
     & 2X,                       'MXCGRIDD   =', I4 / )

95320 FORMAT( 
     & 6X, 'CHARACTER( 16 ) :: PROCNAME( NPRCS )' /
     & 6X, 'LOGICAL            LPROCOUT( NPRCS )' //
     & 6X, 'INTEGER NCGRID ( N_IPR_SPCD )' /
     & 6X, 'INTEGER SV2GRD ( NCSAVED )' /
     & 6X, 'INTEGER IPROUT ( N_IPR_SPCD,NPRCS )' /
     & 6X, 'INTEGER IPR2GRD( N_IPR_SPCD,MXCGRIDD )' /
     & 6X, 'INTEGER IPR2SAV( N_IPR_SPCD,MXCGRIDD )' //
     & 6X, 'REAL    SPCOEF ( N_IPR_SPCD,MXCGRIDD )' )

95360 FORMAT( 
     & 'c  The following variables are used in the integrated reaction', 
     &     ' rate' / 'c  computations.' )

95380 FORMAT( 
     & 'c    LFULLIRR     = Flag for computing IRRs for every reaction' /
     & 'c    LPARTIRR     = Flag for computing IRRs for selected', 
     &                    ' reactions' /
     & 'c    NUMTEMPS     = No. of temporary intermediate IRRs to', 
     &                    ' compute' /
     & 'c    NUMOUTPOS    = No. of temp. IRR terms to add iff the', 
     &                   ' IRR > 0' /
     & 'c    NUMOUTNEG    = No. of temp. IRR terms to add iff the', 
     &                   ' IRR < 0' /
     & 'c    NUMOUTIND    = No. of temp. IRR terms to add regardless', 
     &                   ' of sign' /
     & 'c    MXNIRRRXNS   = Max no. of reaction terms in an output IRR' /
     & 'c    MXTEMPTRMS   = Max no. of reaction terms in a temp. IRR' /
     & 'c    NUMTEMPSD    = Dimension for number of temp IRRs' /
     & 'c    NUMOUTPOSD   = Dimension parameter for NUMOUTPOS' /
     & 'c    NUMOUTNEGD   = Dimension parameter for NUMOUTNEG' /
     & 'c    NUMOUTINDD   = Dimension parameter for NUMOUTIND' /
     & 'c    MXNIRRRXNSD  = Dimension parameter for MXNIRRRXNS' /
     & 'c    MXTEMPTRMSD  = Dimension parameter for MXTEMPTRMS' /
     & 'c    NIRRRXNS     = Vector of no. of reaction terms in an', 
     &                    ' output IRR' /
     & 'c    TEMPTERMS    = Vector of no. of terms in a temporary IRR' /
     & 'c    TEMPOUTPOS   = Vector of no. of IRR terms to add if', 
     &                    ' IRR > 0' /
     & 'c    TEMPOUTNEG   = Vector of no. of IRR terms to add if', 
     &                    ' IRR < 0' /
     & 'c    TEMPOUTIND   = Vector of no. of IRR terms to add', 
     &                    ' regardless of sign' /
     & 'c    INDXOUTPOS   = Vector of indices pointing to IRR output', 
     &                    ' variable' /
     & 'c    INDXOUTNEG   = Vector of indices pointing to IRR output', 
     &                    ' variable' /
     & 'c    INDXOUTIND   = Vector of indices pointing to IRR output', 
     &                    ' variable' /
     & 'c    COEFOUTPOS   = Vector of temp IRR coefficients' /
     & 'c    COEFOUTNEG   = Vector of temp IRR coefficients' /
     & 'c    COEFOUTIND   = Vector of temp IRR coefficients' /
     & 'c    TEMPRXN      = Array of reaction nos. for a temp. IRR' /
     & 'c    IRRRXN       = Array of reaction nos. for an output IRR' /
     & 'c    TEMPCOEF     = Array of reaction coefficients for a', 
     &                    ' temp IRR' /
     & 'c    IRRCOEF      = Array of reaction coefficients for an', 
     &                   ' output IRR' /
     & 'c    IRRSTEP      = Array of output IRRs for one time step' /
     & 'c    IRRBLK       = Array of output IRRs for a block of cells' /
     & 'c    IRROUT       = Array of IRRs to output' ) 

95420 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LFULLIRR = .TRUE.' )
95440 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LFULLIRR = .FALSE.' )  
95480 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LPARTIRR = .TRUE.' )
95500 FORMAT( / 6X,  'LOGICAL, PARAMETER :: LPARTIRR = .FALSE.' ) 

95520 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: NUMTEMPS   =', I4, ',',
     & 2X,                       'NUMTEMPSD   =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NUMOUTPOS  =', I4, ',',
     & 2X,                       'NUMOUTPOSD  =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NUMOUTNEG  =', I4, ',',
     & 2X,                       'NUMOUTNEGD  =', I4 /
     & 6X, 'INTEGER, PARAMETER :: NUMOUTIND  =', I4, ',',
     & 2X,                       'NUMOUTINDD  =', I4 /
     & 6X, 'INTEGER, PARAMETER :: MXNIRRRXNS =', I4, ',',
     & 2X,                       'MXNIRRRXNSD =', I4 /
     & 6X, 'INTEGER, PARAMETER :: MXTEMPTRMS =', I4, ',',
     & 2X,                       'MXTEMPTRMSD =', I4 )

95542 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: BLKSIZED = BLKSIZE' )

95544 FORMAT( /
     & 6X, 'INTEGER, PARAMETER :: BLKSIZED = 1' )

95580 FORMAT( /
     & 6X, 'INTEGER NIRRRXNS  ( NIRRVARD )' /
     & 6X, 'INTEGER TEMPTERMS ( NUMTEMPSD )' /
     & 6X, 'INTEGER TEMPOUTPOS( NUMOUTPOSD )' /
     & 6X, 'INTEGER INDXOUTPOS( NUMOUTPOSD )' /
     & 6X, 'INTEGER TEMPOUTNEG( NUMOUTNEGD )' /
     & 6X, 'INTEGER INDXOUTNEG( NUMOUTNEGD )' /
     & 6X, 'INTEGER TEMPOUTIND( NUMOUTINDD )' /
     & 6X, 'INTEGER INDXOUTIND( NUMOUTINDD )' /
     & 6X, 'INTEGER IRRRXN    ( NIRRVARD,MXNIRRRXNSD )' /
     & 6X, 'INTEGER TEMPRXN   ( NUMTEMPSD,MXTEMPTRMSD )' //
     & 6X, 'REAL    COEFOUTPOS( NUMOUTPOSD )' /
     & 6X, 'REAL    COEFOUTNEG( NUMOUTNEGD )' /
     & 6X, 'REAL    COEFOUTIND( NUMOUTINDD )' /
     & 6X, 'REAL    TEMPCOEF  ( NUMTEMPSD,MXTEMPTRMSD )' /
     & 6X, 'REAL    IRRCOEF   ( NIRRVARD,MXNIRRRXNSD )' /
     & 6X, 'REAL    IRRSTEP   ( BLKSIZED,NIRRVARD )' /
     & 6X, 'REAL    IRRBLK    ( BLKSIZED,NIRRVARD )' )
 
C----------------------- FORMAT Statements -----------------------------

96060 FORMAT( 5X, '&  ', 5A13 )
96080 FORMAT( I5, ',' )
96100 FORMAT( F11.4, ',' )
96110 FORMAT( 'c  Neither IPR nor IRR calculations are being done.' /
     &        'c  Additional data are not required' )
96120 FORMAT( 'c  Output file descriptor data' )
96140 FORMAT( 'c  IPR data' )
96160 FORMAT( 'c  IRR data' )
96200 FORMAT( /6X, 'INTEGER TERM' )
96220 FORMAT( /6X, 'DATA ( IPRNAME( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96240 FORMAT( /6X, 'DATA ( IPRDESC( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96260 FORMAT( /6X, 'DATA ( IRRNAME( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96280 FORMAT( /6X, 'DATA ( IRRDESC( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96290 FORMAT( /6X, 'DATA ( PROCNAME( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96300 FORMAT( /6X, 'DATA ( NCGRID( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96320 FORMAT( /6X, 'DATA ( SV2GRD( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96340 FORMAT( /6X, 'DATA ( IPROUT( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96360 FORMAT( /6X, 'DATA ( IPR2GRD( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96380 FORMAT( /6X, 'DATA ( IPR2SAV( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96400 FORMAT( /6X, 'DATA ( LPROCOUT( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96420 FORMAT( /6X, 'DATA ( SPCOEF( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96440 FORMAT( /6X, 'DATA ( NIRRRXNS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96460 FORMAT( /6X, 'DATA ( TEMPTERMS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96480 FORMAT( /6X, 'DATA ( TEMPOUTPOS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96500 FORMAT( /6X, 'DATA ( TEMPOUTNEG( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96520 FORMAT( /6X, 'DATA ( TEMPOUTIND( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96540 FORMAT( /6X, 'DATA ( INDXOUTPOS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96560 FORMAT( /6X, 'DATA ( INDXOUTNEG( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96580 FORMAT( /6X, 'DATA ( INDXOUTIND( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96600 FORMAT( /6X, 'DATA ( IRRRXN( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96620 FORMAT( /6X, 'DATA ( TEMPRXN( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96640 FORMAT( /6X, 'DATA ( COEFOUTPOS( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96660 FORMAT( /6X, 'DATA ( COEFOUTNEG( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96680 FORMAT( /6X, 'DATA ( COEFOUTIND( TERM ), TERM =', I4, ', ', I4, ' ) /' )
96700 FORMAT( /6X, 'DATA ( TEMPCOEF( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )
96720 FORMAT( /6X, 'DATA ( IRRCOEF( ', I3, ', TERM ), TERM =', I4, ', ', I4, ' ) /' )

      contains
C=======================================================================
         subroutine listout ( lo, hi, n_form, iout, buf )

C    format a list and write to iout
C    n_form can be 3, 5, or 10

         integer, intent (in ) :: lo, hi, n_form, iout
         character( * ), intent( in ) :: buf( * )

         character( 80 ) :: linout
         character( 19 ) :: fstr
         integer i, j, k, n, rng, last

         select case ( n_form )
            case(  3 )   ! associated w/ buf20
               fstr = "( 5x, '&  ', 3a21 )"
            case(  5 )   ! associated w/ buf12
               fstr = "( 5x, '&  ', 5a13 )"
            case( 10 )   ! associated w/ buf6
               fstr = "( 5x, '&  ', 10a7 )"
            case default
               write( *,* ) '*** INVALID format ', n_form
               stop
         end select

         rng = hi - lo + 1
         last = mod( rng, n_form )
         i = lo
         do k = 1, rng / n_form
            j = i + n_form - 1
            write( linout, fstr ) ( buf( n ), n = i, j )
            write( iout, '( a )' ) linout( 1:len_trim( linout ) )
            i = j + 1
         end do
         if ( last .gt. 0 ) then
         j = i + last - 1
         write( linout, fstr ) ( buf( n ), n = i, j )
         write( iout, '( a )' ) linout( 1:len_trim( linout ) )
         end if


         end subroutine listout

      END SUBROUTINE PA_WRTPADEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module cgrid_spcs

c CGRID gas chem, aerosol, non-reactive, and tracer species definitions
c based on namelist specifications
c Revision History:
c Jeff Young 31 Aug 09: created
c Bill Hutzell 8 Oct 10: added Gas Chemistry consistency check
C Shawn Roselle 16 Feb 11: replaced I/O API include files with UTILIO_DEFN
C 07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C 21 Apr 16 D.Luecken:  increased spc_dim to 1000
C 07 Mar 2019 F. Sidi:  Split up ICBC for CMAQ species  namelist 
c-----------------------------------------------------------------------
      USE RUNTIME_VARS
      Use rxns_data, only: mechname       ! chemical mechanism data

      implicit none

c main CGRID table
      integer,                      save :: n_gc_spc = 0, n_ae_spc = 0, n_nr_spc = 0, n_tr_spc = 0
      character( 16 ), allocatable, save :: gc_spc( : ),  ae_spc( : ),  nr_spc( : ),  tr_spc( : )
      real, allocatable,            save :: gc_molwt( : ), ae_molwt( : ), nr_molwt( : ), tr_molwt( : )

      integer,                      save :: n_gc_spcd = 0

c Starting and ending index of gas chemistry species in CGRID
      integer,                      save :: gc_strt = 1
      integer,                      save :: gc_fini = 0

c Starting and ending index of aerosol species in CGRID
      integer,                      save :: ae_strt = 0
      integer,                      save :: ae_fini = 0

c Starting and ending index of non-reactive species in CGRID
      integer,                      save :: nr_strt = 0
      integer,                      save :: nr_fini = 0

c Starting and ending index of tracer species in CGRID
      integer,                      save :: tr_strt = 0
      integer,                      save :: tr_fini = 0

c number of species in CGRID
      integer,                      save :: nspcsd = 1

c surrogate species
      integer,                      save :: n_gc_ic = 0,   n_ae_ic = 0,   n_nr_ic = 0,   n_tr_ic = 0,
     &                                      n_gc_bc = 0,   n_ae_bc = 0,   n_nr_bc = 0,   n_tr_bc = 0,
     &                                      n_gc_depv = 0, n_ae_depv = 0, n_nr_depv = 0, n_tr_depv = 0,
     &                                      n_gc_scav = 0, n_ae_scav = 0, n_nr_scav = 0, n_tr_scav = 0,
     &                                      n_gc_g2ae = 0,                n_nr_n2ae = 0, n_tr_t2ae = 0,
     &                                      n_gc_g2aq = 0, n_ae_a2aq = 0, n_nr_n2aq = 0, n_tr_t2aq = 0
      character( 16 ), allocatable, save :: gc_ic( : ),   ae_ic( : ),   nr_ic( : ),   tr_ic( : ), 
     &                                      gc_bc( : ),   ae_bc( : ),   nr_bc( : ),   tr_bc( : ),   
     &                                      gc_depv( : ), ae_depv( : ), nr_depv( : ), tr_depv( : ),
     &                                      gc_scav( : ), ae_scav( : ), nr_scav( : ), tr_scav( : ),
     &                                      gc_g2ae( : ),               nr_n2ae( : ), tr_t2ae( : ),
     &                                      gc_g2aq( : ), ae_a2aq( : ), nr_n2aq( : ), tr_t2aq( : )
      integer, allocatable,         save :: gc_ic_map( : ),   ae_ic_map( : ),   nr_ic_map( : ),   tr_ic_map( : ),
     &                                      gc_bc_map( : ),   ae_bc_map( : ),   nr_bc_map( : ),   tr_bc_map( : ),  
     &                                      gc_depv_map( : ), ae_depv_map( : ), nr_depv_map( : ), tr_depv_map( : ),
     &                                      gc_scav_map( : ), ae_scav_map( : ), nr_scav_map( : ), tr_scav_map( : ),
     &                                      gc_g2ae_map( : ),                   nr_n2ae_map( : ), tr_t2ae_map( : ),
     &                                      gc_g2aq_map( : ), ae_a2aq_map( : ), nr_n2aq_map( : ), tr_t2aq_map( : )

      real, allocatable,            save :: gc_ic_fac( : ),   ae_ic_fac( : ),   nr_ic_fac( : ),   tr_ic_fac( : ),
     &                                      gc_bc_fac( : ),   ae_bc_fac( : ),   nr_bc_fac( : ),   tr_bc_fac( : ),
     &                                      gc_depv_fac( : ), ae_depv_fac( : ), nr_depv_fac( : ), tr_depv_fac( : ),
     &                                      gc_scav_fac( : ), ae_scav_fac( : ), nr_scav_fac( : ), tr_scav_fac( : )

c control species
      integer,                      save :: n_gc_trns = 0, n_ae_trns = 0, n_nr_trns = 0, n_tr_adv = 0, n_tr_diff = 0,
     &                                      n_gc_ddep = 0, n_ae_ddep = 0, n_nr_ddep = 0, n_tr_ddep = 0,
     &                                      n_gc_wdep = 0, n_ae_wdep = 0, n_nr_wdep = 0, n_tr_wdep = 0,
     &                                      n_gc_conc = 0, n_ae_conc = 0, n_nr_conc = 0, n_tr_conc = 0
      character( 16 ), allocatable, save :: gc_trns( : ), ae_trns( : ), nr_trns( : ), tr_adv( : ), tr_diff( : ),
     &                                      gc_ddep( : ), ae_ddep( : ), nr_ddep( : ), tr_ddep( : ),
     &                                      gc_wdep( : ), ae_wdep( : ), nr_wdep( : ), tr_wdep( : ),
     &                                      gc_conc( : ), ae_conc( : ), nr_conc( : ), tr_conc( : )
      integer, allocatable,         save :: gc_trns_map( : ), ae_trns_map( : ), nr_trns_map( : ), tr_adv_map( : ), tr_diff_map( : ),
     &                                      gc_ddep_map( : ), ae_ddep_map( : ), nr_ddep_map( : ), tr_ddep_map( : ),
     &                                      gc_wdep_map( : ), ae_wdep_map( : ), nr_wdep_map( : ), tr_wdep_map( : ),
     &                                      gc_conc_map( : ), ae_conc_map( : ), nr_conc_map( : ), tr_conc_map( : )

      LOGICAL :: LTRNS, LDDEP, LWDEP, LCONC, LADVC, LDIFF


      INTEGER, SAVE              :: N_CGRID_SPC
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: CGRID_NAME     ( : )
      REAL,    ALLOCATABLE, SAVE :: CGRID_MW       ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_GAS ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_AERO( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_NUM ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_SRF ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_NR  ( : )
      LOGICAL, ALLOCATABLE, SAVE :: CGRID_MASK_TRAC( : )


      type, public :: base_type
         private
         character( 16 ) :: name
         real            :: mw
      end type
      type, public :: surr1_type
         private
         character( 16 ) :: name
         integer         :: map
         real            :: fac
      end type
      type, public :: surr2_type
         private
         character( 16 ) :: name
         integer         :: map
      end type
      type, public :: ctrl_type
         private
         character( 16 ) :: name
         integer         :: map
      end type

      contains

c init routine to allocate the above allocatables
c !! NO   and to populate the allocated arrays from the stnd gc_spc.ext  !!! NO

         function cgrid_spcs_init() result ( success )
            use UTILIO_DEFN
            use stm_vars

            implicit none

            logical success
            integer, save :: dev_gc_nml, dev_ae_nml, dev_nr_nml, dev_tr_nml
            integer i, ios, IGC, IAE, INR, ITR
            character(  1 ), parameter :: bl = ' '
            integer, parameter :: spc_dim = 1000
            logical :: order = .true., found = .true.
            character( 120 ) :: xmsg
            INTEGER :: ISPC, IGRID

c namelist variables
            ! Namelist Registry Format for Gases and Nonreactives
            TYPE SPECIES_DATA_REG_1
                CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
                REAL            :: MOLWT         ! g mol-1
                CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
                REAL            :: IC_FAC        ! IC Scale Factor
                CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
                REAL            :: BC_FAC        ! BC Scale Factor
                CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
                REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
                CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
                REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
                CHARACTER( 16 ) :: AERO_SURR     ! Aerosol Module Surrogate
                CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
                CHARACTER( 16 ) :: TRNS_FLAG     ! Do Transport (ADV + DIFF)?
                CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
                CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
                CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
            END TYPE SPECIES_DATA_REG_1

            ! Namelist Registry Format for Aerosols
            TYPE SPECIES_DATA_REG_2
                CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
                REAL            :: MOLWT         ! g mol-1
                CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
                REAL            :: IC_FAC        ! IC Scale Factor
                CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
                REAL            :: BC_FAC        ! BC Scale Factor
                CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
                REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
                CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
                REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
                CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
                CHARACTER( 16 ) :: TRNS_FLAG     ! Do Transport?
                CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
                CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
                CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
            END TYPE SPECIES_DATA_REG_2

            ! Namelist Registry Format for Tracers
            TYPE SPECIES_DATA_REG_3
                CHARACTER( 16 ) :: SPECIES_NAME  ! CMAQ Species Name
                REAL            :: MOLWT         ! g mol-1
                CHARACTER( 16 ) :: IC_SURR       ! IC Surrogate
                REAL            :: IC_FAC        ! IC Scale Factor
                CHARACTER( 16 ) :: BC_SURR       ! BC Surrogate
                REAL            :: BC_FAC        ! BC Scale Factor
                CHARACTER( 16 ) :: DEPV_SURR     ! Dry Deposition Surrogate
                REAL            :: DEPV_FAC      ! Dry Deposition Scale Factor
                CHARACTER( 16 ) :: SCAV_SURR     ! Wet Scavenging Surrogate
                REAL            :: SCAV_FAC      ! Wet Scavenging Scale Factor
                CHARACTER( 16 ) :: AERO_SURR     ! Aerosol Module Surrogate
                CHARACTER( 16 ) :: CLOUD_SURR    ! Cloud Chemistry Surrogate
                CHARACTER( 16 ) :: ADVC_FLAG     ! Do Advection?
                CHARACTER( 16 ) :: DIFF_FLAG     ! Do Dispersion (i.e. Diffusion)?
                CHARACTER( 16 ) :: DDEP_FLAG     ! Output Dry Deposition Velocities
                CHARACTER( 16 ) :: WDEP_FLAG     ! Output Wet Scavenging Fluxes
                CHARACTER( 16 ) :: CONC_FLAG     ! Output Concentration
            END TYPE SPECIES_DATA_REG_3

 
 
            TYPE (SPECIES_DATA_REG_1), ALLOCATABLE :: GC_SPECIES_DATA(:)
            TYPE (SPECIES_DATA_REG_2), ALLOCATABLE :: AE_SPECIES_DATA(:)
            TYPE (SPECIES_DATA_REG_1), ALLOCATABLE :: NR_SPECIES_DATA(:)
            TYPE (SPECIES_DATA_REG_3), ALLOCATABLE :: TR_SPECIES_DATA(:)
 
            namelist / GC_NML / GC_SPECIES_DATA
            namelist / AE_NML / AE_SPECIES_DATA
            namelist / NR_NML / NR_SPECIES_DATA
            namelist / TR_NML / TR_SPECIES_DATA

c----------------------------------------------------------------------------------------
            success = .true.

            CALL LOG_HEADING( LOGDEV, "Retrieve Species Namelist" )

            ! Gas (GC) Namelist
            ALLOCATE( GC_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            GC_SPECIES_DATA%SPECIES_NAME = ''
            GC_SPECIES_DATA%MOLWT = 0.
            GC_SPECIES_DATA%IC_SURR = ''
            GC_SPECIES_DATA%IC_FAC = 0.
            GC_SPECIES_DATA%BC_SURR = ''
            GC_SPECIES_DATA%BC_FAC = 0.
            GC_SPECIES_DATA%DEPV_SURR = ''
            GC_SPECIES_DATA%DEPV_FAC = 0.
            GC_SPECIES_DATA%SCAV_SURR = ''
            GC_SPECIES_DATA%SCAV_FAC = 0.
            GC_SPECIES_DATA%AERO_SURR = ''
            GC_SPECIES_DATA%CLOUD_SURR = ''
            GC_SPECIES_DATA%TRNS_FLAG = ''
            GC_SPECIES_DATA%DDEP_FLAG = ''
            GC_SPECIES_DATA%WDEP_FLAG = ''
            GC_SPECIES_DATA%CONC_FLAG = ''
                                                                                             
            dev_gc_nml = junit()                                                             
            open( file = trim( gc_namelist ), unit = dev_gc_nml,                             
     &            status = 'old', position = 'rewind' )                                      
            read( nml = GC_nml, unit = dev_gc_nml )                                          
                                                                                             
            ! Determine Number of Gas Species                                                
            N_GC_SPC = 0                                                                     
            DO IGC = 1,SPC_DIM                                                              
                IF ( GC_SPECIES_DATA( IGC )%SPECIES_NAME .EQ. '' ) EXIT                      
                N_GC_SPC = IGC
                IF ( GC_SPECIES_DATA( IGC )%IC_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%IC_FAC = 0.
                IF ( GC_SPECIES_DATA( IGC )%BC_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%BC_FAC = 0.
                IF ( GC_SPECIES_DATA( IGC )%DEPV_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%DEPV_FAC = 0.
                IF ( GC_SPECIES_DATA( IGC )%SCAV_FAC .EQ. -1. )
     &               GC_SPECIES_DATA( IGC )%SCAV_FAC = 0.
            END DO                                                                           
                                                                                             
            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      gc_spc( n_gc_spc+1 ), gc_molwt( n_gc_spc+1 ),
     &      gc_ic( n_gc_spc+1 ),   gc_ic_map( n_gc_spc+1 ),   gc_ic_fac( n_gc_spc+1 ),
     &      gc_bc( n_gc_spc+1 ),   gc_bc_map( n_gc_spc+1 ),   gc_bc_fac( n_gc_spc+1 ),
     &      gc_depv( n_gc_spc+1 ), gc_depv_map( n_gc_spc+1 ), gc_depv_fac( n_gc_spc+1 ),
     &      gc_scav( n_gc_spc+1 ), gc_scav_map( n_gc_spc+1 ), gc_scav_fac( n_gc_spc+1 ),
     &      gc_g2ae( n_gc_spc+1 ), gc_g2ae_map( n_gc_spc+1 ),
     &      gc_g2aq( n_gc_spc+1 ), gc_g2aq_map( n_gc_spc+1 ),
     &      gc_trns( n_gc_spc+1 ), gc_trns_map( n_gc_spc+1 ),
     &      gc_ddep( n_gc_spc+1 ), gc_ddep_map( n_gc_spc+1 ),
     &      gc_wdep( n_gc_spc+1 ), gc_wdep_map( n_gc_spc+1 ),
     &      gc_conc( n_gc_spc+1 ), gc_conc_map( n_gc_spc+1 ),
     &      stat = ios )

            gc_spc = bl; gc_molwt = 0.0                        !  .
            gc_ic = bl;   gc_ic_map = 0;   gc_ic_fac = 0.0     !  .
            gc_bc = bl;   gc_bc_map = 0;   gc_bc_fac = 0.0     !  .
            gc_depv = bl; gc_depv_map = 0; gc_depv_fac = 0.0   !  .
            gc_scav = bl; gc_scav_map = 0; gc_scav_fac = 0.0   ! array
            gc_g2ae = bl; gc_g2ae_map = 0                      !  .
            gc_g2aq = bl; gc_g2aq_map = 0                      ! assignments
            gc_trns = bl; gc_trns_map = 0                      !  .
            gc_ddep = bl; gc_ddep_map = 0                      !  .
            gc_wdep = bl; gc_wdep_map = 0                      !  .
            gc_conc = bl; gc_conc_map = 0                      !  .


            ! Pass Data from GC Namelist to Internal Variables
            N_GC_IC = 0; N_GC_BC = 0; N_GC_DEPV = 0; N_GC_SCAV = 0
            N_GC_G2AE = 0; N_GC_G2AQ = 0; N_GC_TRNS = 0; N_GC_DDEP = 0; N_GC_WDEP = 0
            N_GC_CONC = 0

            DO IGC = 1,N_GC_SPC
                
                GC_SPC( IGC )      = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                GC_MOLWT( IGC )    = GC_SPECIES_DATA( IGC )%MOLWT

                ! Gas ICs
                IF ( GC_SPECIES_DATA( IGC )%IC_SURR .NE. '' ) THEN
                    N_GC_IC = N_GC_IC + 1
                    GC_IC( N_GC_IC )     = GC_SPECIES_DATA( IGC )%IC_SURR 
                    GC_IC_MAP( N_GC_IC ) = IGC
                    GC_IC_FAC( N_GC_IC ) = GC_SPECIES_DATA( IGC )%IC_FAC
                END IF

                ! Gas BCs
                IF ( GC_SPECIES_DATA( IGC )%BC_SURR .NE. '' ) THEN
                    N_GC_BC = N_GC_BC + 1
                    GC_BC( N_GC_BC )     = GC_SPECIES_DATA( IGC )%BC_SURR 
                    GC_BC_MAP( N_GC_BC ) = IGC
                    GC_BC_FAC( N_GC_BC ) = GC_SPECIES_DATA( IGC )%BC_FAC
                END IF
                
                ! Gas Dry Deposition Surrogates
                IF ( GC_SPECIES_DATA( IGC )%DEPV_SURR .NE. '' ) THEN
                    N_GC_DEPV = N_GC_DEPV + 1
                    GC_DEPV( N_GC_DEPV )     = GC_SPECIES_DATA( IGC )%DEPV_SURR 
                    GC_DEPV_MAP( N_GC_DEPV ) = IGC
                    GC_DEPV_FAC( N_GC_DEPV ) = GC_SPECIES_DATA( IGC )%DEPV_FAC
                END IF
                 
                ! Gas Wet Scavenging Surrogates
                IF ( GC_SPECIES_DATA( IGC )%SCAV_SURR .NE. '' ) THEN
                    N_GC_SCAV = N_GC_SCAV + 1
                    GC_SCAV( N_GC_SCAV )     = GC_SPECIES_DATA( IGC )%SCAV_SURR 
                    GC_SCAV_MAP( N_GC_SCAV ) = IGC
                    GC_SCAV_FAC( N_GC_SCAV ) = GC_SPECIES_DATA( IGC )%SCAV_FAC
                END IF
                
                ! Gas -to-Aerosol Module Surrogates
                IF ( GC_SPECIES_DATA( IGC )%AERO_SURR .NE. '' ) THEN
                    N_GC_G2AE = N_GC_G2AE + 1
                    GC_G2AE( N_GC_G2AE )     = GC_SPECIES_DATA( IGC )%AERO_SURR 
                    GC_G2AE_MAP( N_GC_G2AE ) = IGC
                END IF
                
                ! Gas -to-Cloud Chemistry Surrogates
                IF ( GC_SPECIES_DATA( IGC )%CLOUD_SURR .NE. '' ) THEN
                    N_GC_G2AQ = N_GC_G2AQ + 1
                    GC_G2AQ( N_GC_G2AQ )     = GC_SPECIES_DATA( IGC )%CLOUD_SURR 
                    GC_G2AQ_MAP( N_GC_G2AQ ) = IGC
                END IF
                
                ! Gas - Perform Transport
                LTRNS = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%TRNS_FLAG )
                IF ( LTRNS ) THEN
                    N_GC_TRNS = N_GC_TRNS + 1
                    GC_TRNS( N_GC_TRNS )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_TRNS_MAP( N_GC_TRNS ) = IGC
                END IF
                
                ! Gas - Output Deposition Velocity
                LDDEP = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_GC_DDEP = N_GC_DDEP + 1
                    GC_DDEP( N_GC_DDEP )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_DDEP_MAP( N_GC_DDEP ) = IGC
                END IF
                
                ! Gas - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_GC_WDEP = N_GC_WDEP + 1
                    GC_WDEP( N_GC_WDEP )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_WDEP_MAP( N_GC_WDEP ) = IGC
                END IF
                
                ! Gas - Output Concentration Field
                LCONC = GET_LOGICAL_NML( GC_SPECIES_DATA( IGC )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_GC_CONC = N_GC_CONC + 1
                    GC_CONC( N_GC_CONC )     = GC_SPECIES_DATA( IGC )%SPECIES_NAME
                    GC_CONC_MAP( N_GC_CONC ) = IGC
                END IF
                
            END DO

            GC_FINI   = GC_STRT + N_GC_SPC - 1
            N_GC_SPCD = GC_FINI + 1



            ! Aerosol (AE) Namelist
            ALLOCATE( AE_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            AE_SPECIES_DATA%SPECIES_NAME = ''
            AE_SPECIES_DATA%MOLWT = 0.
            AE_SPECIES_DATA%IC_SURR = ''
            AE_SPECIES_DATA%IC_FAC = 0.
            AE_SPECIES_DATA%BC_SURR = ''
            AE_SPECIES_DATA%BC_FAC = 0.
            AE_SPECIES_DATA%DEPV_SURR = ''
            AE_SPECIES_DATA%DEPV_FAC = 0.
            AE_SPECIES_DATA%SCAV_SURR = ''
            AE_SPECIES_DATA%SCAV_FAC = 0.
            AE_SPECIES_DATA%CLOUD_SURR = ''
            AE_SPECIES_DATA%TRNS_FLAG = ''
            AE_SPECIES_DATA%DDEP_FLAG = ''
            AE_SPECIES_DATA%WDEP_FLAG = ''
            AE_SPECIES_DATA%CONC_FLAG = ''
                                                                                             

            dev_ae_nml = junit()
            open( file = trim( ae_namelist ), unit = dev_ae_nml,
     &            status = 'old', position = 'rewind' )
            read( nml = AE_nml, unit = dev_ae_nml ) 

            ! Determine Number of Gas Species
            N_AE_SPC = 0
            DO IAE = 1,SPC_DIM
                IF ( AE_SPECIES_DATA( IAE )%SPECIES_NAME .EQ. '' ) EXIT
                N_AE_SPC = IAE
                IF ( AE_SPECIES_DATA( IAE )%IC_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%IC_FAC = 0.
                IF ( AE_SPECIES_DATA( IAE )%BC_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%BC_FAC = 0.
                IF ( AE_SPECIES_DATA( IAE )%DEPV_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%DEPV_FAC = 0.
                IF ( AE_SPECIES_DATA( IAE )%SCAV_FAC .EQ. -1. )
     &               AE_SPECIES_DATA( IAE )%SCAV_FAC = 0.
            END DO

            IF ( STM ) THEN
               IF ( ( N_AE_SPC + N_STM_AE_SPC ) .GT. SPC_DIM ) THEN
                  WRITE( LOGDEV,* ) '*** Allocated dimension exceeded for AE ', 
     &                              ' species in Sulfur Tracking Model' 
                  SUCCESS = .FALSE.
                  RETURN
               END IF
               
               DO IAE = 1, N_STM_AE_SPC
                  N_AE_SPC = N_AE_SPC + 1
                  AE_SPECIES_DATA( N_AE_SPC )%SPECIES_NAME = STM_AE_SPECIES_DATA( IAE )%SPECIES_NAME
                  AE_SPECIES_DATA( N_AE_SPC )%MOLWT        = STM_AE_SPECIES_DATA( IAE )%MOLWT
                  AE_SPECIES_DATA( N_AE_SPC )%IC_SURR      = STM_AE_SPECIES_DATA( IAE )%IC_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%IC_FAC       = STM_AE_SPECIES_DATA( IAE )%IC_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%BC_SURR      = STM_AE_SPECIES_DATA( IAE )%BC_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%BC_FAC       = STM_AE_SPECIES_DATA( IAE )%BC_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%DEPV_SURR    = STM_AE_SPECIES_DATA( IAE )%DEPV_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%DEPV_FAC     = STM_AE_SPECIES_DATA( IAE )%DEPV_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%SCAV_SURR    = STM_AE_SPECIES_DATA( IAE )%SCAV_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%SCAV_FAC     = STM_AE_SPECIES_DATA( IAE )%SCAV_FAC
                  AE_SPECIES_DATA( N_AE_SPC )%CLOUD_SURR   = STM_AE_SPECIES_DATA( IAE )%CLOUD_SURR
                  AE_SPECIES_DATA( N_AE_SPC )%TRNS_FLAG    = STM_AE_SPECIES_DATA( IAE )%TRNS_FLAG
                  AE_SPECIES_DATA( N_AE_SPC )%DDEP_FLAG    = STM_AE_SPECIES_DATA( IAE )%DDEP_FLAG
                  AE_SPECIES_DATA( N_AE_SPC )%WDEP_FLAG    = STM_AE_SPECIES_DATA( IAE )%WDEP_FLAG
                  AE_SPECIES_DATA( N_AE_SPC )%CONC_FLAG    = STM_AE_SPECIES_DATA( IAE )%CONC_FLAG
               END DO

               If ( ( Index( mechname, 'SAPRC07TIC_AE6I' ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'SAPRC07TIC_AE7I' ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'CB6R3_AE7'       ) .Gt. 0 ) .OR.
     &              ( Index( mechname, 'CB6R3M_AE7'      ) .Gt. 0 ) ) Then
                
                  ORGANOSULF = .TRUE.

                  IF ( ( N_AE_SPC + N_STM_OAE_SPC ) .GT. SPC_DIM ) THEN
                     WRITE( LOGDEV,* ) '*** Allocated dimension exceeded for AE ', 
     &                                 ' species in Sulfur Tracking Model' 
                     SUCCESS = .FALSE.
                     RETURN
                  END IF
                  
                  DO IAE = 1, N_STM_OAE_SPC
                     N_AE_SPC = N_AE_SPC + 1
                     AE_SPECIES_DATA( N_AE_SPC )%SPECIES_NAME = STM_OAE_SPECIES_DATA( IAE )%SPECIES_NAME
                     AE_SPECIES_DATA( N_AE_SPC )%MOLWT        = STM_OAE_SPECIES_DATA( IAE )%MOLWT
                     AE_SPECIES_DATA( N_AE_SPC )%IC_SURR      = STM_OAE_SPECIES_DATA( IAE )%IC_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%IC_FAC       = STM_OAE_SPECIES_DATA( IAE )%IC_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%BC_SURR      = STM_OAE_SPECIES_DATA( IAE )%BC_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%BC_FAC       = STM_OAE_SPECIES_DATA( IAE )%BC_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%DEPV_SURR    = STM_OAE_SPECIES_DATA( IAE )%DEPV_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%DEPV_FAC     = STM_OAE_SPECIES_DATA( IAE )%DEPV_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%SCAV_SURR    = STM_OAE_SPECIES_DATA( IAE )%SCAV_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%SCAV_FAC     = STM_OAE_SPECIES_DATA( IAE )%SCAV_FAC
                     AE_SPECIES_DATA( N_AE_SPC )%CLOUD_SURR   = STM_OAE_SPECIES_DATA( IAE )%CLOUD_SURR
                     AE_SPECIES_DATA( N_AE_SPC )%TRNS_FLAG    = STM_OAE_SPECIES_DATA( IAE )%TRNS_FLAG
                     AE_SPECIES_DATA( N_AE_SPC )%DDEP_FLAG    = STM_OAE_SPECIES_DATA( IAE )%DDEP_FLAG
                     AE_SPECIES_DATA( N_AE_SPC )%WDEP_FLAG    = STM_OAE_SPECIES_DATA( IAE )%WDEP_FLAG
                     AE_SPECIES_DATA( N_AE_SPC )%CONC_FLAG    = STM_OAE_SPECIES_DATA( IAE )%CONC_FLAG
                  END DO

               End If
            END IF

            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      ae_spc( n_ae_spc ), ae_molwt( n_ae_spc ),
     &      ae_ic( n_ae_spc ),   ae_ic_map( n_ae_spc ),   ae_ic_fac( n_ae_spc ),
     &      ae_bc( n_ae_spc ),   ae_bc_map( n_ae_spc ),   ae_bc_fac( n_ae_spc ),
     &      ae_depv( n_ae_spc ), ae_depv_map( n_ae_spc ), ae_depv_fac( n_ae_spc ),
     &      ae_scav( n_ae_spc ), ae_scav_map( n_ae_spc ), ae_scav_fac( n_ae_spc ),
     &      ae_a2aq( n_ae_spc ), ae_a2aq_map( n_ae_spc ),
     &      ae_trns( n_ae_spc ), ae_trns_map( n_ae_spc ),
     &      ae_ddep( n_ae_spc ), ae_ddep_map( n_ae_spc ),
     &      ae_wdep( n_ae_spc ), ae_wdep_map( n_ae_spc ),
     &      ae_conc( n_ae_spc ), ae_conc_map( n_ae_spc ),
     &      stat = ios )

            ae_spc = bl; ae_molwt = 0.0                        !  .
            ae_ic = bl;   ae_ic_map = 0;   ae_ic_fac = 0.0     !  .
            ae_bc = bl;   ae_bc_map = 0;   ae_bc_fac = 0.0     !  .
            ae_depv = bl; ae_depv_map = 0; ae_depv_fac = 0.0   !  .
            ae_scav = bl; ae_scav_map = 0; ae_scav_fac = 0.0   ! array
            ae_a2aq = bl; ae_a2aq_map = 0                      !  .
            ae_trns = bl; ae_trns_map = 0                      ! assignments
            ae_ddep = bl; ae_ddep_map = 0                      !  .
            ae_wdep = bl; ae_wdep_map = 0                      !  .
            ae_conc = bl; ae_conc_map = 0                      !  .

            ! Pass Data from AE Namelist to Internal Variables
            N_AE_IC = 0; N_AE_BC = 0; N_AE_DEPV = 0; N_AE_SCAV = 0
            N_AE_A2AQ = 0; N_AE_TRNS = 0; N_AE_DDEP = 0; N_AE_WDEP = 0
            N_AE_CONC = 0

            DO IAE = 1,N_AE_SPC

                AE_SPC( IAE )      = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                AE_MOLWT( IAE )    = AE_SPECIES_DATA( IAE )%MOLWT

                ! Aerosol ICs
                IF ( AE_SPECIES_DATA( IAE )%IC_SURR .NE. '' ) THEN
                    N_AE_IC = N_AE_IC + 1
                    AE_IC( N_AE_IC )     = AE_SPECIES_DATA( IAE )%IC_SURR 
                    AE_IC_MAP( N_AE_IC ) = IAE
                    AE_IC_FAC( N_AE_IC ) = AE_SPECIES_DATA( IAE )%IC_FAC
                END IF

                ! Aerosol BCs
                IF ( AE_SPECIES_DATA( IAE )%BC_SURR .NE. '' ) THEN
                    N_AE_BC = N_AE_BC + 1
                    AE_BC( N_AE_BC )     = AE_SPECIES_DATA( IAE )%BC_SURR 
                    AE_BC_MAP( N_AE_BC ) = IAE
                    AE_BC_FAC( N_AE_BC ) = AE_SPECIES_DATA( IAE )%BC_FAC
                END IF
                
                ! Aerosol Dry Deposition Surrogates
                IF ( AE_SPECIES_DATA( IAE )%DEPV_SURR .NE. '' ) THEN
                    N_AE_DEPV = N_AE_DEPV + 1
                    AE_DEPV( N_AE_DEPV )     = AE_SPECIES_DATA( IAE )%DEPV_SURR 
                    AE_DEPV_MAP( N_AE_DEPV ) = IAE
                    AE_DEPV_FAC( N_AE_DEPV ) = AE_SPECIES_DATA( IAE )%DEPV_FAC
                END IF
                 
                ! Aerosol Wet Scavenging Surrogates
                IF ( AE_SPECIES_DATA( IAE )%SCAV_SURR .NE. '' ) THEN
                    N_AE_SCAV = N_AE_SCAV + 1
                    AE_SCAV( N_AE_SCAV )     = AE_SPECIES_DATA( IAE )%SCAV_SURR 
                    AE_SCAV_MAP( N_AE_SCAV ) = IAE
                    AE_SCAV_FAC( N_AE_SCAV ) = AE_SPECIES_DATA( IAE )%SCAV_FAC
                END IF
                
                ! Aerosol -to-Cloud Chemistry Surrogates
                IF ( AE_SPECIES_DATA( IAE )%CLOUD_SURR .NE. '' ) THEN
                    N_AE_A2AQ = N_AE_A2AQ + 1
                    AE_A2AQ( N_AE_A2AQ )     = AE_SPECIES_DATA( IAE )%CLOUD_SURR 
                    AE_A2AQ_MAP( N_AE_A2AQ ) = IAE
                END IF
                
                ! Aerosol - Perform Transport
                LTRNS = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%TRNS_FLAG )
                IF ( LTRNS ) THEN
                    N_AE_TRNS = N_AE_TRNS + 1
                    AE_TRNS( N_AE_TRNS )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_TRNS_MAP( N_AE_TRNS ) = IAE
                END IF
                
                ! Aerosol - Output Deposition Velocity
                LDDEP = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_AE_DDEP = N_AE_DDEP + 1
                    AE_DDEP( N_AE_DDEP )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_DDEP_MAP( N_AE_DDEP ) = IAE
                END IF
                
                ! Aerosol - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_AE_WDEP = N_AE_WDEP + 1
                    AE_WDEP( N_AE_WDEP )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_WDEP_MAP( N_AE_WDEP ) = IAE
                END IF
                
                ! Aerosol - Output Concentration Field
                LCONC = GET_LOGICAL_NML( AE_SPECIES_DATA( IAE )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_AE_CONC = N_AE_CONC + 1
                    AE_CONC( N_AE_CONC )     = AE_SPECIES_DATA( IAE )%SPECIES_NAME
                    AE_CONC_MAP( N_AE_CONC ) = IAE
                END IF
                
            END DO

            AE_STRT   = GC_FINI + 2
            AE_FINI   = AE_STRT + N_AE_SPC - 1
 


            ! Nonreactive (NR) Namelist
            ALLOCATE( NR_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            NR_SPECIES_DATA%SPECIES_NAME = ''
            NR_SPECIES_DATA%MOLWT = 0.
            NR_SPECIES_DATA%IC_SURR = ''
            NR_SPECIES_DATA%IC_FAC = 0.
            NR_SPECIES_DATA%BC_SURR = ''
            NR_SPECIES_DATA%BC_FAC = 0.
            NR_SPECIES_DATA%DEPV_SURR = ''
            NR_SPECIES_DATA%DEPV_FAC = 0.
            NR_SPECIES_DATA%SCAV_SURR = ''
            NR_SPECIES_DATA%SCAV_FAC = 0.
            NR_SPECIES_DATA%AERO_SURR = ''
            NR_SPECIES_DATA%CLOUD_SURR = ''
            NR_SPECIES_DATA%TRNS_FLAG = ''
            NR_SPECIES_DATA%DDEP_FLAG = ''
            NR_SPECIES_DATA%WDEP_FLAG = ''
            NR_SPECIES_DATA%CONC_FLAG = ''

            dev_nr_nml = junit()
            open( file = trim( nr_namelist ), unit = dev_nr_nml,
     &            status = 'old', position = 'rewind' )
            read( nml = NR_nml, unit = dev_nr_nml ) 
           
            ! Determine Number of Gas Species
            N_NR_SPC = 0
            DO INR = 1,SPC_DIM
                IF ( NR_SPECIES_DATA( INR )%SPECIES_NAME .EQ. '' ) EXIT
                N_NR_SPC = INR
                IF ( NR_SPECIES_DATA( INR )%IC_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%IC_FAC = 0.
                IF ( NR_SPECIES_DATA( INR )%BC_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%BC_FAC = 0.
                IF ( NR_SPECIES_DATA( INR )%DEPV_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%DEPV_FAC = 0.
                IF ( NR_SPECIES_DATA( INR )%SCAV_FAC .EQ. -1. )
     &               NR_SPECIES_DATA( INR )%SCAV_FAC = 0.
            END DO

            IF ( STM ) THEN
               IF ( ( N_NR_SPC + N_STM_NR_SPC ) .GT. SPC_DIM ) THEN
                  WRITE( LOGDEV,* ) '*** Allocated dimension exceeded for NR ', 
     &                              ' species in Sulfur Tracking Model' 
                  SUCCESS = .FALSE.
                  RETURN
               END IF
               
               DO INR = 1, N_STM_NR_SPC
                  N_NR_SPC = N_NR_SPC + 1
                  NR_SPECIES_DATA( N_NR_SPC )%SPECIES_NAME = STM_NR_SPECIES_DATA( INR )%SPECIES_NAME
                  NR_SPECIES_DATA( N_NR_SPC )%MOLWT        = STM_NR_SPECIES_DATA( INR )%MOLWT
                  NR_SPECIES_DATA( N_NR_SPC )%IC_SURR      = STM_NR_SPECIES_DATA( INR )%IC_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%IC_FAC       = STM_NR_SPECIES_DATA( INR )%IC_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%BC_SURR      = STM_NR_SPECIES_DATA( INR )%BC_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%BC_FAC       = STM_NR_SPECIES_DATA( INR )%BC_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%DEPV_SURR    = STM_NR_SPECIES_DATA( INR )%DEPV_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%DEPV_FAC     = STM_NR_SPECIES_DATA( INR )%DEPV_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%SCAV_SURR    = STM_NR_SPECIES_DATA( INR )%SCAV_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%SCAV_FAC     = STM_NR_SPECIES_DATA( INR )%SCAV_FAC
                  NR_SPECIES_DATA( N_NR_SPC )%AERO_SURR    = STM_NR_SPECIES_DATA( INR )%AERO_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%CLOUD_SURR   = STM_NR_SPECIES_DATA( INR )%CLOUD_SURR
                  NR_SPECIES_DATA( N_NR_SPC )%TRNS_FLAG    = STM_NR_SPECIES_DATA( INR )%TRNS_FLAG
                  NR_SPECIES_DATA( N_NR_SPC )%DDEP_FLAG    = STM_NR_SPECIES_DATA( INR )%DDEP_FLAG
                  NR_SPECIES_DATA( N_NR_SPC )%WDEP_FLAG    = STM_NR_SPECIES_DATA( INR )%WDEP_FLAG
                  NR_SPECIES_DATA( N_NR_SPC )%CONC_FLAG    = STM_NR_SPECIES_DATA( INR )%CONC_FLAG
               END DO
            END IF ! stm

            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      NR_spc( n_nr_spc ), NR_molwt( n_nr_spc ),
     &      NR_ic( n_nr_spc ),   NR_ic_map( n_nr_spc ),   NR_ic_fac( n_nr_spc ),
     &      NR_bc( n_nr_spc ),   NR_bc_map( n_nr_spc ),   NR_bc_fac( n_nr_spc ),
     &      NR_depv( n_nr_spc ), NR_depv_map( n_nr_spc ), NR_depv_fac( n_nr_spc ),
     &      NR_scav( n_nr_spc ), NR_scav_map( n_nr_spc ), NR_scav_fac( n_nr_spc ),
     &      NR_n2ae( n_nr_spc ), NR_n2ae_map( n_nr_spc ),
     &      NR_n2aq( n_nr_spc ), NR_n2aq_map( n_nr_spc ),
     &      NR_trns( n_nr_spc ), NR_trns_map( n_nr_spc ),
     &      NR_ddep( n_nr_spc ), NR_ddep_map( n_nr_spc ),
     &      NR_wdep( n_nr_spc ), NR_wdep_map( n_nr_spc ),
     &      NR_conc( n_nr_spc ), NR_conc_map( n_nr_spc ),
     &      stat = ios )

            NR_spc = bl; NR_molwt = 0.0                        !  .
            NR_ic = bl;   NR_ic_map = 0;   NR_ic_fac = 0.0     !  .
            NR_bc = bl;   NR_bc_map = 0;   NR_bc_fac = 0.0     !  .
            NR_depv = bl; NR_depv_map = 0; NR_depv_fac = 0.0   !  .
            NR_scav = bl; NR_scav_map = 0; NR_scav_fac = 0.0   ! array
            NR_n2ae = bl; NR_n2ae_map = 0                      !  .
            NR_n2aq = bl; NR_n2aq_map = 0                      !  .
            NR_trns = bl; NR_trns_map = 0                      ! assignments
            NR_ddep = bl; NR_ddep_map = 0                      !  .
            NR_wdep = bl; NR_wdep_map = 0                      !  .
            NR_conc = bl; NR_conc_map = 0                      !  .

            ! Pass Data from NR Namelist to Internal Variables
            N_NR_IC = 0; N_NR_BC = 0; N_NR_DEPV = 0; N_NR_SCAV = 0
            N_NR_N2AE = 0; N_NR_N2AQ = 0; N_NR_TRNS = 0; N_NR_DDEP = 0; N_NR_WDEP = 0
            N_NR_CONC = 0

            DO INR = 1,N_NR_SPC

                NR_SPC( INR )      = NR_SPECIES_DATA( INR )%SPECIES_NAME
                NR_MOLWT( INR )    = NR_SPECIES_DATA( INR )%MOLWT

                ! Nonreactive ICs
                IF ( NR_SPECIES_DATA( INR )%IC_SURR .NE. '' ) THEN
                    N_NR_IC = N_NR_IC + 1
                    NR_IC( N_NR_IC )     = NR_SPECIES_DATA( INR )%IC_SURR 
                    NR_IC_MAP( N_NR_IC ) = INR
                    NR_IC_FAC( N_NR_IC ) = NR_SPECIES_DATA( INR )%IC_FAC
                END IF

                ! Nonreactive BCs
                IF ( NR_SPECIES_DATA( INR )%BC_SURR .NE. '' ) THEN
                    N_NR_BC = N_NR_BC + 1
                    NR_BC( N_NR_BC )     = NR_SPECIES_DATA( INR )%BC_SURR 
                    NR_BC_MAP( N_NR_BC ) = INR
                    NR_BC_FAC( N_NR_BC ) = NR_SPECIES_DATA( INR )%BC_FAC
                END IF
                
                ! Nonreactive Dry Deposition Surrogates
                IF ( NR_SPECIES_DATA( INR )%DEPV_SURR .NE. '' ) THEN
                    N_NR_DEPV = N_NR_DEPV + 1
                    NR_DEPV( N_NR_DEPV )     = NR_SPECIES_DATA( INR )%DEPV_SURR 
                    NR_DEPV_MAP( N_NR_DEPV ) = INR
                    NR_DEPV_FAC( N_NR_DEPV ) = NR_SPECIES_DATA( INR )%DEPV_FAC
                END IF
                 
                ! Nonreactive Wet Scavenging Surrogates
                IF ( NR_SPECIES_DATA( INR )%SCAV_SURR .NE. '' ) THEN
                    N_NR_SCAV = N_NR_SCAV + 1
                    NR_SCAV( N_NR_SCAV )     = NR_SPECIES_DATA( INR )%SCAV_SURR 
                    NR_SCAV_MAP( N_NR_SCAV ) = INR
                    NR_SCAV_FAC( N_NR_SCAV ) = NR_SPECIES_DATA( INR )%SCAV_FAC
                END IF
 
                ! Nonreactive -to-Aerosol Module Surrogates
                IF ( NR_SPECIES_DATA( INR )%AERO_SURR .NE. '' ) THEN
                    N_NR_N2AE = N_NR_N2AE + 1
                    NR_N2AE( N_NR_N2AE )     = NR_SPECIES_DATA( INR )%AERO_SURR 
                    NR_N2AE_MAP( N_NR_N2AE ) = INR
                END IF
                
                ! Nonreactive -to-Cloud Chemistry Surrogates
                IF ( NR_SPECIES_DATA( INR )%CLOUD_SURR .NE. '' ) THEN
                    N_NR_N2AQ = N_NR_N2AQ + 1
                    NR_N2AQ( N_NR_N2AQ )     = NR_SPECIES_DATA( INR )%CLOUD_SURR 
                    NR_N2AQ_MAP( N_NR_N2AQ ) = INR
                END IF
                
                ! Nonreactive - Perform Transport
                LTRNS = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%TRNS_FLAG )
                IF ( LTRNS ) THEN
                    N_NR_TRNS = N_NR_TRNS + 1
                    NR_TRNS( N_NR_TRNS )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_TRNS_MAP( N_NR_TRNS ) = INR
                END IF
                
                ! Nonreactive - Output Deposition Velocity
                LDDEP = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_NR_DDEP = N_NR_DDEP + 1
                    NR_DDEP( N_NR_DDEP )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_DDEP_MAP( N_NR_DDEP ) = INR
                END IF
                
                ! Nonreactive - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_NR_WDEP = N_NR_WDEP + 1
                    NR_WDEP( N_NR_WDEP )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_WDEP_MAP( N_NR_WDEP ) = INR
                END IF
                
                ! Nonreactive - Output Concentration Field
                LCONC = GET_LOGICAL_NML( NR_SPECIES_DATA( INR )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_NR_CONC = N_NR_CONC + 1
                    NR_CONC( N_NR_CONC )     = NR_SPECIES_DATA( INR )%SPECIES_NAME
                    NR_CONC_MAP( N_NR_CONC ) = INR
                END IF
                
            END DO

            NR_STRT   = AE_FINI + 1
            NR_FINI   = NR_STRT + N_NR_SPC - 1
 

            ! Tracer (TR) Namelists
            ALLOCATE( TR_SPECIES_DATA( SPC_DIM ), STAT=IOS )
            TR_SPECIES_DATA%SPECIES_NAME = ''
            TR_SPECIES_DATA%MOLWT = 0.
            TR_SPECIES_DATA%IC_SURR = ''
            TR_SPECIES_DATA%IC_FAC = 0.
            TR_SPECIES_DATA%BC_SURR = ''
            TR_SPECIES_DATA%BC_FAC = 0.
            TR_SPECIES_DATA%DEPV_SURR = ''
            TR_SPECIES_DATA%DEPV_FAC = 0.
            TR_SPECIES_DATA%SCAV_SURR = ''
            TR_SPECIES_DATA%SCAV_FAC = 0.
            TR_SPECIES_DATA%AERO_SURR = ''
            TR_SPECIES_DATA%CLOUD_SURR = ''
            TR_SPECIES_DATA%ADVC_FLAG = ''
            TR_SPECIES_DATA%DIFF_FLAG = ''
            TR_SPECIES_DATA%DDEP_FLAG = ''
            TR_SPECIES_DATA%WDEP_FLAG = ''
            TR_SPECIES_DATA%CONC_FLAG = ''



            dev_tr_nml = junit()
            open( file = trim( tr_namelist ), unit = dev_tr_nml,
     &            status = 'old', position = 'rewind' )
            read( nml = TR_nml, unit = dev_tr_nml )

            ! Determine Number of Gas Species
            N_TR_SPC = 0
            DO ITR = 1,SPC_DIM
                IF ( TR_SPECIES_DATA( ITR )%SPECIES_NAME .EQ. '' ) EXIT
                N_TR_SPC = ITR
                IF ( TR_SPECIES_DATA( ITR )%IC_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%IC_FAC = 0.
                IF ( TR_SPECIES_DATA( ITR )%BC_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%BC_FAC = 0.
                IF ( TR_SPECIES_DATA( ITR )%DEPV_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%DEPV_FAC = 0.
                IF ( TR_SPECIES_DATA( ITR )%SCAV_FAC .EQ. -1. )
     &               TR_SPECIES_DATA( ITR )%SCAV_FAC = 0.
            END DO

            ! Allocate and Initialize Permanent Variables
            allocate ( 
     &      TR_spc( n_tr_spc ), TR_molwt( n_tr_spc ),
     &      TR_ic( n_tr_spc ),   TR_ic_map( n_tr_spc ),   TR_ic_fac( n_tr_spc ),
     &      TR_bc( n_tr_spc ),   TR_bc_map( n_tr_spc ),   TR_bc_fac( n_tr_spc ),
     &      TR_depv( n_tr_spc ), TR_depv_map( n_tr_spc ), TR_depv_fac( n_tr_spc ),
     &      TR_scav( n_tr_spc ), TR_scav_map( n_tr_spc ), TR_scav_fac( n_tr_spc ),
     &      TR_t2ae( n_tr_spc ), TR_t2ae_map( n_tr_spc ),
     &      TR_t2aq( n_tr_spc ), TR_t2aq_map( n_tr_spc ),
     &      TR_adv( n_tr_spc ),  TR_adv_map( n_tr_spc ),
     &      TR_diff( n_tr_spc ), TR_diff_map( n_tr_spc ),
     &      TR_ddep( n_tr_spc ), TR_ddep_map( n_tr_spc ),
     &      TR_wdep( n_tr_spc ), TR_wdep_map( n_tr_spc ),
     &      TR_conc( n_tr_spc ), TR_conc_map( n_tr_spc ),
     &      stat = ios )

            TR_spc = bl; TR_molwt = 0.0                        !  .
            TR_ic = bl;   TR_ic_map = 0;   TR_ic_fac = 0.0     !  .
            TR_bc = bl;   TR_bc_map = 0;   TR_bc_fac = 0.0     !  .
            TR_depv = bl; TR_depv_map = 0; TR_depv_fac = 0.0   !  .
            TR_scav = bl; TR_scav_map = 0; TR_scav_fac = 0.0   ! array
            TR_t2ae = bl; TR_t2ae_map = 0                      !  .
            TR_t2aq = bl; TR_t2aq_map = 0                      !  .
            TR_adv  = bl; TR_adv_map = 0                       ! assignments
            TR_diff = bl; TR_diff_map = 0                      ! assignments
            TR_ddep = bl; TR_ddep_map = 0                      !  .
            TR_wdep = bl; TR_wdep_map = 0                      !  .
            TR_conc = bl; TR_conc_map = 0                      !  .

            ! Pass Data from TR Namelist to Internal Variables
            N_TR_IC = 0; N_TR_BC = 0; N_TR_DEPV = 0; N_TR_SCAV = 0
            N_TR_T2AE = 0; N_TR_T2AQ = 0; N_TR_ADV = 0;  N_TR_DDEP = 0; N_TR_WDEP = 0
            N_TR_CONC = 0; N_TR_DIFF = 0

            DO ITR = 1,N_TR_SPC

                TR_SPC( ITR )      = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                TR_MOLWT( ITR )    = TR_SPECIES_DATA( ITR )%MOLWT

                ! Tracer IC
                IF ( TR_SPECIES_DATA( ITR )%IC_SURR .NE. '' ) THEN
                    N_TR_IC = N_TR_IC + 1
                    TR_IC( N_TR_IC )     = TR_SPECIES_DATA( ITR )%IC_SURR 
                    TR_IC_MAP( N_TR_IC ) = ITR
                    TR_IC_FAC( N_TR_IC ) = TR_SPECIES_DATA( ITR )%IC_FAC
                END IF

                ! Tracer BC
                IF ( TR_SPECIES_DATA( ITR )%BC_SURR .NE. '' ) THEN
                    N_TR_BC = N_TR_BC + 1
                    TR_BC( N_TR_BC )     = TR_SPECIES_DATA( ITR )%BC_SURR 
                    TR_BC_MAP( N_TR_BC ) = ITR
                    TR_BC_FAC( N_TR_BC ) = TR_SPECIES_DATA( ITR )%BC_FAC
                END IF
                                
                ! Tracer Dry Deposition Surrogates
                IF ( TR_SPECIES_DATA( ITR )%DEPV_SURR .NE. '' ) THEN
                    N_TR_DEPV = N_TR_DEPV + 1
                    TR_DEPV( N_TR_DEPV )     = TR_SPECIES_DATA( ITR )%DEPV_SURR 
                    TR_DEPV_MAP( N_TR_DEPV ) = ITR
                    TR_DEPV_FAC( N_TR_DEPV ) = TR_SPECIES_DATA( ITR )%DEPV_FAC
                END IF
                 
                ! Tracer Wet Scavenging Surrogates
                IF ( TR_SPECIES_DATA( ITR )%SCAV_SURR .NE. '' ) THEN
                    N_TR_SCAV = N_TR_SCAV + 1
                    TR_SCAV( N_TR_SCAV )     = TR_SPECIES_DATA( ITR )%SCAV_SURR 
                    TR_SCAV_MAP( N_TR_SCAV ) = ITR
                    TR_SCAV_FAC( N_TR_SCAV ) = TR_SPECIES_DATA( ITR )%SCAV_FAC
                END IF
 
                ! Tracer -to-Aerosol Module Surrogates
                IF ( TR_SPECIES_DATA( ITR )%AERO_SURR .NE. '' ) THEN
                    N_TR_T2AE = N_TR_T2AE + 1
                    TR_T2AE( N_TR_T2AE )     = TR_SPECIES_DATA( ITR )%AERO_SURR 
                    TR_T2AE_MAP( N_TR_T2AE ) = ITR
                END IF
                
                ! Tracer -to-Cloud Chemistry Surrogates
                IF ( TR_SPECIES_DATA( ITR )%CLOUD_SURR .NE. '' ) THEN
                    N_TR_T2AQ = N_TR_T2AQ + 1
                    TR_T2AQ( N_TR_T2AQ )     = TR_SPECIES_DATA( ITR )%CLOUD_SURR 
                    TR_T2AQ_MAP( N_TR_T2AQ ) = ITR
                END IF
                
                ! Tracer - Perform Advection?
                LADVC = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%ADVC_FLAG )
                IF ( LADVC ) THEN
                    N_TR_ADV = N_TR_ADV + 1
                    TR_ADV( N_TR_ADV )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_ADV_MAP( N_TR_ADV ) = ITR
                END IF
                
                ! Tracer - Perform Dispersion (i.e. Diffusion)?
                LDIFF = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%DIFF_FLAG )
                IF ( LDIFF ) THEN
                    N_TR_DIFF = N_TR_DIFF + 1
                    TR_DIFF( N_TR_DIFF )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_DIFF_MAP( N_TR_DIFF ) = ITR
                END IF
                
                ! Tracer - Output Deposition Velocity
                LDDEP = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%DDEP_FLAG )
                IF ( LDDEP ) THEN
                    N_TR_DDEP = N_TR_DDEP + 1
                    TR_DDEP( N_TR_DDEP )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_DDEP_MAP( N_TR_DDEP ) = ITR
                END IF
                
                ! Tracer - Output Wet Scavenging Flux
                LWDEP = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%WDEP_FLAG )
                IF ( LWDEP ) THEN
                    N_TR_WDEP = N_TR_WDEP + 1
                    TR_WDEP( N_TR_WDEP )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_WDEP_MAP( N_TR_WDEP ) = ITR
                END IF
                
                ! Tracer - Output Concentration Field
                LCONC = GET_LOGICAL_NML( TR_SPECIES_DATA( ITR )%CONC_FLAG )
                IF ( LCONC ) THEN
                    N_TR_CONC = N_TR_CONC + 1
                    TR_CONC( N_TR_CONC )     = TR_SPECIES_DATA( ITR )%SPECIES_NAME
                    TR_CONC_MAP( N_TR_CONC ) = ITR
                END IF
                
            END DO

            TR_STRT   = NR_FINI + 1
            TR_FINI   = TR_STRT + N_TR_SPC - 1
 

            ! Sum Up All Species Across Phases and Types
            NSPCSD = N_GC_SPCD + N_AE_SPC + N_NR_SPC + N_TR_SPC
            
            ! Move Data To CGRID_xxx Master Arrays
            N_CGRID_SPC = NSPCSD
            ALLOCATE( CGRID_NAME( N_CGRID_SPC ),
     &                CGRID_MW  ( N_CGRID_SPC ),
     &                CGRID_MASK_GAS( N_CGRID_SPC ),
     &                CGRID_MASK_AERO( N_CGRID_SPC ),
     &                CGRID_MASK_NUM( N_CGRID_SPC ),
     &                CGRID_MASK_SRF( N_CGRID_SPC ),
     &                CGRID_MASK_NR( N_CGRID_SPC ),
     &                CGRID_MASK_TRAC( N_CGRID_SPC ) )
            CGRID_NAME = ''
            CGRID_MW   = 0.
            CGRID_MASK_GAS = .FALSE.
            CGRID_MASK_AERO= .FALSE.
            CGRID_MASK_NUM = .FALSE.
            CGRID_MASK_SRF = .FALSE.
            CGRID_MASK_NR  = .FALSE.
            CGRID_MASK_TRAC= .FALSE.

            IGRID = 0
            DO ISPC = gc_strt,n_gc_spcd
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = GC_SPC( ISPC )
                CGRID_MW( IGRID )   = GC_MOLWT( ISPC )
                CGRID_MASK_GAS( IGRID )   = .TRUE.
            END DO
            DO ISPC = 1,n_ae_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = AE_SPC( ISPC )
                CGRID_MW( IGRID )   = AE_MOLWT( ISPC )
                CGRID_MASK_AERO( IGRID )   = .TRUE.
                IF ( INDEX( AE_SPC( ISPC ),'NUM') .NE. 0 ) CGRID_MASK_NUM( IGRID )   = .TRUE.
                IF ( INDEX( AE_SPC( ISPC ),'SRF') .NE. 0 ) CGRID_MASK_SRF( IGRID )   = .TRUE.
            END DO
            DO ISPC = 1,n_nr_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = NR_SPC( ISPC )
                CGRID_MW( IGRID )   = NR_MOLWT( ISPC )
                CGRID_MASK_NR( IGRID )   = .TRUE.
            END DO
            DO ISPC = 1,n_tr_spc
                IGRID = IGRID + 1
                CGRID_NAME( IGRID ) = TR_SPC( ISPC )
                CGRID_MW( IGRID )   = TR_MOLWT( ISPC )
                CGRID_MASK_TRAC( IGRID )   = .TRUE.
            END DO


         return

         end function cgrid_spcs_init

c----------------------------------------------------------------------------------------
         FUNCTION GET_LOGICAL_NML( OP_FLAG ) RESULT ( LFLAG )

         IMPLICIT NONE

         CHARACTER( 16 ) :: OP_FLAG
         LOGICAL         :: LFLAG

         LFLAG = .FALSE.

         IF ( OP_FLAG .EQ. 'yes' .OR. OP_FLAG .EQ. 'Yes' .OR.
     &        OP_FLAG .EQ. 'YES' .OR. OP_FLAG .EQ. 'Y'   .OR.
     &        OP_FLAG .EQ. 'y'   .OR. OP_FLAG .EQ. 'T'   .OR.
     &        OP_FLAG .EQ. 't'   .OR. OP_FLAG .EQ. 'on'  .OR.
     &        OP_FLAG .EQ. 'On'  .OR. OP_FLAG .EQ. 'ON'  .OR.
     &        OP_FLAG .EQ. '1'        ) 
     &     LFLAG = .TRUE.
   
         RETURN

         END FUNCTION GET_LOGICAL_NML

c----------------------------------------------------------------------------------------
         subroutine get_list( ic, str_in, base_out,
     &                        n_surr1, surr1_out, n_surr2, surr2_out, n_ctrl, ctrl_out )

c assume chem mechanism types are in the order of:
c 1) CGRID species, CGRID species molecular weight <- base type
c 2) IC, BC, DEPV, SCAV  [any order]               <- surrogate type 1 (surr name, surr fac)
c 3) x2AE, x2AQ  [any order]                       <- surrogate type 2 (surr name only )
c 4) DIFF, DDEP, WDEP, CONC  [any order]           <- control type

            use UTILIO_DEFN

            implicit none


            integer,            intent ( in out ) :: ic
            character( * ),     intent (  in ) :: str_in
            type( base_type ),  intent ( out ) :: base_out
            integer,            intent (  in ) :: n_surr1
            type( surr1_type ), intent ( out ) :: surr1_out( n_surr1 )
            integer,            intent (  in ) :: n_surr2
            type( surr2_type ), intent ( out ) :: surr2_out( n_surr2 )
            integer,            intent (  in ) :: n_ctrl
            type( ctrl_type ),  intent ( out ) :: ctrl_out( n_ctrl )

            integer, parameter :: nfld = 20
            character(  1 ), parameter :: dc = ':', bl = ' '  ! namelist field delimiting character, blank character
            character( 32 ) :: str( nfld ) = bl               ! field substring
            character(  1 ) :: chr, lastchr
            integer ip, is, n
            integer fn                                        ! field number
            integer :: jp( nfld ), kp( nfld )                 ! field starting and ending position
            logical :: nbf( nfld )                            ! non-blank field
            integer maxlen
!           integer, save :: ic = 0   ! subroutine call count

            ic = ic + 1
            maxlen = len_trim( str_in )
            fn = 1; ip = 0

101         continue    ! consume leading blanks in field
            nbf( fn ) = .true.   ! posit non-blank field
            ip = ip + 1
            if ( ip .gt. maxlen ) go to 301   ! end of line
            chr = str_in( ip:ip )
            if ( chr .eq. bl ) go to 101   ! skip leading blanks before valid char
            lastchr = chr
            jp( fn ) = ip   ! 1st non-blank char in field

201         continue
            if ( chr .ne. dc ) then
               if ( chr .ne. bl ) lastchr = chr
               ip = ip + 1
               if ( ip .gt. maxlen ) go to 301   ! end of line
               chr = str_in( ip:ip )
               go to 201
            else
               if ( lastchr .eq. dc ) nbf( fn ) = .false.   ! we've got a blank field
               kp( fn ) = ip - 1
               fn = fn + 1
            end if
            go to 101

301         continue
            kp( fn ) = ip - 1
            if ( chr .eq. dc ) nbf( fn ) = .false.

            do n = 1, fn
#ifdef Verbose
               write( logdev,'(3i4,l)' ) n, jp( n ), kp( n ), nbf( n )
               if ( kp( n ) .lt. jp( n ) ) then   ! don't depend on this - use bf( n )
                  write( logdev,* ) n, 'end of string < start'
               end if
#endif
               if ( nbf( n ) ) then
                  str( n ) = str_in( jp( n ):kp( n ) )
#ifdef Verbose
                  write( logdev,* ) n, len_trim( str( n ) ), str( n )
#endif
               end if
            end do

c assumed group order: {CGRID spc, mw},
c                      {IC, BC, DEPV, SCAV} group,
c                      {x2AE, x2AQ} group,
c                      {TRNS, DDEP, WDEP, CONC} group
c str( 1 ) = CGRID name, str( 2 ) = CGRID name molec. wt.

            read( str( 1 ),'( a16 )' )  base_out%name
            if ( index( str( 2 ), '.' ) .le. 0 ) then   ! integer
               read( str( 2 ),'( i7 )' ) is
               base_out%mw = real( is )
            else
               read( str( 2 ),'( f7.2 )' ) base_out%mw
            end if

c type 1 surrogate (surr1)
c if there is a surrogate name and the factor field is blank, assume fac = 1.0
            ip = 3
            do n = 1, n_surr1
               if ( nbf( ip ) ) then
                  read( str( ip ),'( a16 )' ) surr1_out( n )%name
                  surr1_out( n )%map = ic
                  if ( nbf( ip+1 ) ) then
                     if ( index( str( ip+1 ), '.' ) .le. 0 ) then   ! integer
                        read( str( ip+1 ),'( i7 )' ) is
                        surr1_out( n )%fac = real( is )
                     else
                        read( str( ip+1 ),'( f7.2 )' ) surr1_out( n )%fac
                     end if
                  else
                     surr1_out( n )%fac = 1.0
                  end if
               else
                  surr1_out( n )%name = bl
                  surr1_out( n )%map = 0
                  surr1_out( n )%fac = 0.0
               end if
               ip = ip + 2
            end do

c type 2 surrogate (surr2)
            do n = 1, n_surr2
               if ( nbf( ip ) ) then
                  surr2_out( n )%map = ic
                  read( str( ip ),'( a16 )' ) surr2_out( n )%name
               else
                  surr2_out( n )%name = bl
                  surr2_out( n )%map = 0
               end if
               ip = ip + 1
            end do

            do n = 1, n_ctrl
               if ( nbf( ip ) ) then
                  if ( str( ip ) .eq. 'yes' .or.
     &                 str( ip ) .eq. 'Yes' .or.
     &                 str( ip ) .eq. 'YES' ) then  ! use call upcase
                     read( str( 1 ),'( a16 )' ) ctrl_out( n )%name
                     ctrl_out( n )%map = ic
                  else
                     ctrl_out( n )%name = bl
                  end if
               else
                  ctrl_out( n )%name = bl
                  ctrl_out( n )%map = 0
               end if
               ip = ip + 1
            end do

            return
            end subroutine get_list

c----------------------------------------------------------------------------------------
            subroutine bubble ( n, ia, aa )

            use UTILIO_DEFN

            implicit none

            integer, intent( in ) :: n
            integer, intent( in out ) :: ia( n )
            character( * ), intent( in out ) :: aa( n )
            character( 8 ) :: at
            integer i, it
            logical :: no_swap

            do
               no_swap = .true.
               do i = 1, n - 1
                   if ( ia( i ) .gt. ia( i+1 ) ) then
                      it = ia( i ); ia( i ) = ia( i+1 ); ia( i+1 ) = it
                      at = aa( i ); aa( i ) = aa( i+1 ); aa( i+1 ) = at
                      no_swap = .false.
                   end if
               end do
               if ( no_swap ) exit
             end do

            it = 0
            do i = 1, n
               if ( ia( i ) .gt. 0 ) then
                  it = it + 1
                  ia( i ) = it
               else
                  aa( i ) = ' '
               end if
            end do

c compress list; move blanks to end
            it = 1
            do i = 1, n
               if ( aa( i ) .ne. ' ' ) then
                  aa( it ) = aa( i )
                  ia( it ) = ia( i )
                  it = it + 1
               end if
            end do
            do i = it, n
               aa( i ) = ' '
               ia( i ) = 0
            end do

            return
            end subroutine bubble

c----------------------------------------------------------------------------------------
            integer function index1a ( name, n, nlist )
            implicit none
            character( * ) name        ! character string being searched for
            integer n                  ! length of array to be searched
            character( * ) nlist( : )  ! array to be searched

            integer i

            do i = 1, n
               if ( name .eq. nlist( i ) ) then
                  index1a = i
                  return
               end if
           end do
           index1a = 0
           return

           end function index1a

      end module cgrid_spcs

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GAS_DEPV_MAP ( N_DEPV_NAMES, DEPV_NAMES, DEPV_SUR )

C----------------------------------------------------------------------
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C----------------------------------------------------------------------

      USE CGRID_SPCS            ! CGRID mechanism species
      USE DEPVVARS
      USE UTILIO_DEFN

      IMPLICIT NONE

C Arguments:

      INTEGER,         INTENT( IN )    :: N_DEPV_NAMES  ! number of unique dep vel species
      CHARACTER( 16 ), INTENT( INOUT ) :: DEPV_NAMES( : ) ! names of dep vel species
      INTEGER,         INTENT( OUT )   :: DEPV_SUR( : ) ! pointers to model species for
                                                        ! calculated deposition velocities
                                                        ! (surrogate dep vels [m/s**2])

C Local variables:

      INTEGER :: JDATE = 0
      INTEGER :: JTIME = 0

      CHARACTER( 16 ), SAVE :: PNAME = 'GAS_DEPV_MAP'

      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 16 ) :: VNAME            ! scratch string

      INTEGER ALLOCSTAT
      INTEGER V, N
      INTEGER STRT, FINI

C----------------------------------------------------------------------

      IF ( ( N_GC_SPC + N_NR_SPC + N_TR_SPC ) .LE. 0 ) THEN
         XMSG = 'Model not compiled for gases'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF

C Set up names and indices

      IF ( .NOT. DEPVVARS_INIT( ) ) THEN
         XMSG = 'Failure initializing depvvars module'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF

C Set up the DEPV pointers to calculated deposition velocities

#ifdef Verbose
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) ' > Unique DEPV versus DEPSPC'
#endif

      DO V = 1, N_DEPV_NAMES
         VNAME = DEPV_NAMES( V )( 4:LEN_TRIM( DEPV_NAMES( V ) ) )
         N = INDEX1( VNAME, LTOTG, DEPSPC )
         IF ( N .NE. 0 ) THEN
            IF ( .NOT. USE_DEPSPC( N ) ) THEN
               USE_DEPSPC( N ) = .TRUE.
               N_USE_DEPSPC = N_USE_DEPSPC + 1
#ifdef Verbose
               WRITE( LOGDEV,1005 ) V, DEPV_NAMES( V ), N, DEPSPC( N )
#endif
            END IF    
         ELSE
            XMSG = 'Could not find ' // TRIM( DEPV_NAMES( V ) ) // 
     &             ' in '            // TRIM( DEPV_METHOD )     //
     &             ' surrogate table.'
!    &             ' surrogate table. >>> Dep vel set to zero <<< '
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

C Sort DEPV_NAMES based on the order in DEPSPC (DEPVVARS module)

#ifdef Verbose
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) ' > Sorted DEPV names (1st index from total m3dry list)'
#endif

      N = 0
      DO V = 1, LTOTG            
!        IF ( .NOT. USE_DEPSPC( V ) ) CYCLE
         IF ( .NOT. USE_DEPSPC( V ) ) THEN
#ifdef Verbose
            WRITE( LOGDEV,1009 ) V, USE_DEPSPC( v ), 0, ' '
#endif
         ELSE
            N = N + 1
            VNAME = 'VD_' // DEPSPC( V )( 1:LEN_TRIM( DEPSPC( V ) ) )
            DEPV_NAMES( N ) = VNAME
#ifdef Verbose
            WRITE( LOGDEV,1009 ) V, USE_DEPSPC( V ), N, DEPV_NAMES( N )
#endif
         END IF
      END DO

C Locate model species' DEPVs in the unique DEPV_NAMES list

      DO V = 1, N_GC_DEPV
         VNAME = GC_DEPV( V )
         N = INDEX1( VNAME, N_DEPV_NAMES, DEPV_NAMES )
         IF ( N .NE. 0 ) THEN
            DEPV_SUR( V ) = N
         ELSE
            XMSG = 'Could not find ' // TRIM( GC_DEPV( V ) )
     &           // ' in DEPV table.'  
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      STRT = N_GC_DEPV + 1
      FINI = N_GC_DEPV + N_NR_DEPV 
      DO V = STRT, FINI
         VNAME = NR_DEPV( V - ( STRT-1 ) )
         N = INDEX1( VNAME, N_DEPV_NAMES, DEPV_NAMES )
         IF ( N .NE. 0 ) THEN
            DEPV_SUR( V ) = N
         ELSE
            XMSG = 'Could not find ' // TRIM( NR_DEPV( V ) )
     &           // ' in DEPV table.'  
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      STRT = N_GC_DEPV + N_NR_DEPV + 1
      FINI = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV
      DO V = STRT, FINI
         VNAME = TR_DEPV( V - (STRT-1) )
         N = INDEX1( VNAME, N_DEPV_NAMES, DEPV_NAMES )
         IF ( N .NE. 0 ) THEN
            DEPV_SUR( V ) = N
         ELSE
            XMSG = 'Could not find ' // TRIM( TR_DEPV( V ) )
     &           // ' in DEPV table.'  
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

#ifdef Verbose
      WRITE( LOGDEV,* ) ' '
      WRITE( LOGDEV,* ) ' > ', PNAME, 'Final Gas DEPV Map'

      STRT = 0
      DO V = 1, N_GC_DEPV
         WRITE( LOGDEV,1019 ) V, GC_DEPV( V ), DEPV_SUR( V+STRT ),
     &                        DEPV_NAMES( DEPV_SUR( V+STRT) )
      END DO

      STRT = N_GC_DEPV
      DO V = 1, N_NR_DEPV
         WRITE( LOGDEV,1019 ) V, NR_DEPV( V ), DEPV_SUR( V+STRT ),
     &                        DEPV_NAMES( DEPV_SUR( V+STRT) )
      END DO

      STRT = N_GC_DEPV + N_NR_DEPV 
      DO V = 1, N_TR_DEPV
         WRITE( LOGDEV,1019 ) V, TR_DEPV( V ), DEPV_SUR( V+STRT ),
     &                        DEPV_NAMES( DEPV_SUR( V+STRT) )
      END DO
#endif

      RETURN
 
      RETURN

1005  FORMAT( I5, 1X, A16, I3, 1X, A16 )

!009  FORMAT( I5, 1X, I4, 1X, A16 )
1009  FORMAT( I5, 1X, L3, 1X, I4, 1X, A16 )

1019  FORMAT( 3( I3, 1X, A16, 1X ) )

      END SUBROUTINE GAS_DEPV_MAP

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PHOTOLYSIS_ALBEDO
 
C-----------------------------------------------------------------------
C  FUNCTION: Module contains a function and subroutine use to calculate the diffuse
C  and direct spectral albedo based on the fractional land use for each grid cell
C
C  History:
C  06/04/13 Bill Hutzell - Initial based on the albedo algorithm from phot.F
C                          from CMAQ 5.01
C  08/08/14 Bill Hutzell - 1) commented out snow effect for water surfaces based on 
C                          assumption that snow disolves on contact and causes no
C                          change on reflectivity
C                          2) changed how snow correction for land and sea ice takes
C                          place. The change uses a snow albedo, computed in the
C                          initialization routine instead of using the the snow
C                          correction factor at each call for the surface albedo
C                          calculation. The goal is to make the code easier to modify.
C  02/01/19 David Wong   - Implemented centralized I/O approach, removed all MY_N
C                          clauses
C-----------------------------------------------------------------------

         IMPLICIT NONE 

         REAL, ALLOCATABLE :: SURFACE_ALBEDO( :,:,: ) ! time dependent surface albedo
         REAL, ALLOCATABLE :: DIFFUSE_ALBEDO( :,:,: ) ! time dependent surface albedo
         REAL, ALLOCATABLE :: WATER_FRACTION( :,: )   ! cell fraction covered by water or ocean
         REAL, ALLOCATABLE :: SEAICE        ( :,: )   ! sea ice cover (fraction)
         REAL, ALLOCATABLE :: SNOCOV        ( :,: )   ! snow cover (fractional)

         INTEGER :: STDATE ! starting GMT [YYYYDDD]
         INTEGER :: STTIME ! starting time [HHMMSS]
         INTEGER :: STRTHR ! starting GMT hour [HH]
         REAL    :: JYFREQ ! 2PI/(# days in JYEAR)

! public variables:
         PUBLIC SURFACE_ALBEDO, DIFFUSE_ALBEDO, WATER_FRACTION, SEAICE, SNOCOV,
     &          STDATE, STTIME, STRTHR, JYFREQ

! public procedures:
         PUBLIC INITIALIZE_ALBEDO, GET_ALBEDO

         PRIVATE

         REAL, PARAMETER :: SEAICE_POINT = 271.36 ! [K] -threshold to form sea ice
                                                  ! based 2005 WRF model Documentation

         CHARACTER( 80 )      :: LAND_SCHEME
         INTEGER              :: NUMB_LANDUSE
         INTEGER              :: N_LAND_CLASSES            ! number of land classes in scheme
         INTEGER              :: N_WATER_CLASSES           ! number of water classes in scheme

         REAL,    ALLOCATABLE :: LANDMASK( :,: )           ! land-water mask: 1 for land and 0 for water
         INTEGER, ALLOCATABLE :: ALBMAP_TO_REF( : )        ! map from reference to used landuse for albedo
         REAL,    ALLOCATABLE :: ALBFAC_TO_REF( : )        ! factor from reference to used landuse for albedo

         REAL,    ALLOCATABLE :: LAND_ANNUAL   ( :,:,:,: ) ! annual average of land albedo weighted by class
         REAL,    ALLOCATABLE :: WATER_ANNUAL  ( :,:,:,: ) ! annual average for water albedo weighted class
         REAL,    ALLOCATABLE :: LAND_SNOW     ( :,:,:,: ) ! snow covered albedo for land weighted by class
         REAL,    ALLOCATABLE :: MAXIMUM_ALBEDO( : )       ! maximum allowed albedo per wavelength
         REAL,    ALLOCATABLE :: WATER_SEASONAL( : )   ! seasonal coefficient for water albedo
         REAL,    ALLOCATABLE :: WATER_ZENITH  ( : )   ! solar zenith coefficient for water albedo

         REAL,    ALLOCATABLE :: LAND_SEASONAL ( : )   ! seasonal coefficient for land albedo
         REAL,    ALLOCATABLE :: LAND_ZENITH   ( : )   ! solar zenith coefficient for land albedo

         REAL,    ALLOCATABLE :: SEAICE_ANNUAL ( : )     ! annual average for sea ice 
         REAL,    ALLOCATABLE :: SEAICE_SNOW   ( : )     ! snow covered albedo for sea ice 
         REAL                 :: SEAICE_SEASONAL          ! seasonal coefficient for sea ice albedo
         REAL                 :: SEAICE_ZENITH            ! solar zenith coefficient for sea ice albedo
 
         REAL,    ALLOCATABLE :: SFACTOR_LAND ( : )   ! seasonal correction for land albedo for land class
         REAL,    ALLOCATABLE :: SFACTOR_WATER( : )   ! seasonal correction for water albedo for water class
         REAL,    ALLOCATABLE :: ZFACTOR_LAND ( : )   ! combined seasonal and solar zenith angle correction for land class
         REAL,    ALLOCATABLE :: ZFACTOR_WATER( : )   ! combined seasonal and solar zenith angle correction for water class
         REAL,    ALLOCATABLE    :: TEMPG  ( :,: )       ! ground surface temperature [K]

         REAL WATER_SCALE     ! water scaling factor used to calculate surface albedo
         REAL SEASONAL_COEFF  ! coefficient for seasonal correction to surface albedo
         REAL ZENITH_COEFF    ! coefficient for zenith angle correction to surface albedo
         REAL SNOW_COEFF      ! coefficient for snow cover correction to surface albedo
         REAL SEA_MODULATE    ! seasonal modulation in surface albedo
         REAL ZEN_MODULATE    ! zenith angle modulation in surface albedo

      CONTAINS

         FUNCTION INITIALIZE_ALBEDO( MDATE, MTIME ) RESULT ( SUCCESS )
C...        Function sets up arrays and data needed to calculate surface albedos
C           use in radiative transfer calculation for actinic fluxes

            USE UTILIO_DEFN       ! IOAPI declaratiion and utilities
#ifdef parallel
            USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
            USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
            USE PHOT_MOD          ! photolysis in-line module
            USE PCGRID_DEFN       ! get cgrid

            USE LSM_MOD, ONLY: N_LUFRAC, LSM_SCHEME => LAND_SCHEME

            USE CENTRALIZED_IO_MODULE, only : interpolate_var, LWMASK, LUFRAC, HAS_SEAICE

            IMPLICIT NONE

            INCLUDE SUBST_FILES_ID   ! file name parameters

C...Arguments:

            INTEGER, INTENT( IN ) :: MDATE     ! Julian date (YYYYDDD)
            INTEGER, INTENT( IN ) :: MTIME     ! time        (HHMMSS)

C...Local:
            REAL                       :: JYEAR                      ! year, ADE
            REAL                       :: MSCALE                    ! scaling factor 
            REAL, ALLOCATABLE          :: FRACTION_LANDUSE( :,:,: ) ! fractional cover for a landuse

            LOGICAL                    :: SUCCESS
            CHARACTER(  2 )            :: LU_INDEX
            CHARACTER( 17 ), PARAMETER :: PNAME  = 'INITIALIZE_ALBEDO' 
            CHARACTER( 16 )            :: VARNM
            CHARACTER( 240 )           :: XMSG   = ' '

            INTEGER                    :: ROW
            INTEGER                    :: COL
            INTEGER                    :: LEV
            INTEGER                    :: SPC
            INTEGER                    :: L
            INTEGER                    :: NL, NW
            INTEGER                    :: V, N, MODE
            INTEGER                    :: ALLOCSTAT
            INTEGER                    :: IWAVE

            LOGICAL, SAVE :: INITIALIZED  = .FALSE.

            IF ( INITIALIZED ) THEN
               RETURN
            END IF

C...compute start time data and frequency of annual cycle considering leap year

            STDATE = MDATE
            STTIME = MTIME
            STRTHR =  MTIME / 10000
            JYEAR  = FLOAT( MDATE / 1000 )   !   Check this more carefully

            IF ( MOD( JYEAR, 4.0 ) .EQ. 0.0 ) THEN
               JYFREQ = 2.0 * PI / 366.0
            ELSE
               JYFREQ = 2.0 * PI / 365.0
            END IF

            SELECT CASE( LSM_SCHEME )
               CASE( 'USGS24' )
                  NUMB_LANDUSE = NUMB_LANDUSE_USGS  ! 24
                  LAND_SCHEME  = LSM_SCHEME
               CASE( 'MODIS' )
                  NUMB_LANDUSE = NUMB_LANDUSE_MODIS ! 33
                  LAND_SCHEME  = LSM_SCHEME
               CASE( 'NLCD50' )
                  NUMB_LANDUSE = NUMB_LANDUSE_NLCD50  ! 50
                  LAND_SCHEME  = LSM_SCHEME
               CASE( 'NLCD40' )
                  NUMB_LANDUSE = NUMB_LANDUSE_NLCD40  ! 40
                  LAND_SCHEME  = LSM_SCHEME
                  IF ( NO_NLCD40 ) THEN
                     XMSG =  'GRID_CRO_2D uses NLCD40 landuse scheme but '
     &                    // 'CSQY_FILE does not have albedo factors for '
     &                    // 'NLCD40'
                     WRITE( LOGDEV,'( A )' ) TRIM( PNAME ) // ' : ' // XMSG
                     SUCCESS = .FALSE.
                     RETURN
                  END IF
               CASE DEFAULT
                  LAND_SCHEME = 'UNKNOWN'
                  NUMB_LANDUSE = 2 ! simple land-water surface albedo
            END SELECT

            IF ( NUMB_LANDUSE .NE. 2 ) THEN ! test N_LUFRAC
               IF ( NUMB_LANDUSE .NE. N_LUFRAC ) THEN
                  XMSG =  TRIM( LAND_SCHEME ) // ' Landuse Scheme from (LSM) does '
     &                 // 'not match number of classes expected in PHOT_OPTICS_DATA '
     &                 // 'file'
                  WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  WRITE(LOGDEV,'( 2(A,I4) )')'PHOT_OPTICS_DATA Value: ',NUMB_LANDUSE,
     &            ' Value from Land Surface Module (LSM): ', N_LUFRAC
                  IF( TRIM( LAND_SCHEME ) .EQ. 'MODIS' .AND. N_LUFRAC .EQ. 20 )THEN
                      NUMB_LANDUSE = 20
                      XMSG = 'Special Case MODIS landuse: MET data has only first 20 classes'
                      WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                      XMSG = 'Albedo calculations use only these classes'
                      WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  ELSE
                      SUCCESS = .FALSE.
                      RETURN
                  END IF
               END IF
            END IF

            ALLOCATE ( ALBMAP_TO_REF( NUMB_LANDUSE ), ALBFAC_TO_REF( NUMB_LANDUSE ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALBMAP_TO_REF and ALBFAC_TO_REF'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( FRACTION_LANDUSE( NUMB_LANDUSE,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating FRACTION_LANDUSE'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            FRACTION_LANDUSE = 0.0
            ALBMAP_TO_REF    = -1
            ALBFAC_TO_REF    = 0.0

            SELECT CASE( LAND_SCHEME )
               CASE( 'USGS24' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2USGS( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2USGS( 1:NUMB_LANDUSE )
               CASE( 'MODIS' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2MODIS( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2MODIS( 1:NUMB_LANDUSE )
               CASE( 'NLCD50' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2NLCD50( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2NLCD50( 1:NUMB_LANDUSE )
               CASE( 'NLCD40' )
                  ALBMAP_TO_REF( 1:NUMB_LANDUSE ) = ALBMAP_REF2NLCD40( 1:NUMB_LANDUSE )
                  ALBFAC_TO_REF( 1:NUMB_LANDUSE ) = ALBFAC_REF2NLCD40( 1:NUMB_LANDUSE )
               CASE DEFAULT
                  ALBMAP_TO_REF( 1 ) = INDEX_GRASSLAND_REF
                  ALBFAC_TO_REF( 1 ) = 1.0
                  ALBMAP_TO_REF( 2 ) = INDEX_OCEAN_REF
                  ALBFAC_TO_REF( 2 ) = 1.0
                  N_WATER_CLASSES = 1
                  N_LAND_CLASSES  = 1
            END SELECT

            IF ( LAND_SCHEME .NE. 'UNKNOWN' ) THEN
               WRITE( LOGDEV,'( 5X, A /5X, A )' ) TRIM( PNAME )
     &              // ': Identified ' // TRIM( LAND_SCHEME ) // ' land use scheme',
     &                 ' for surface albedo used by inline photolysis calculation.'

               N_WATER_CLASSES = 0
               DO V = 1, NUMB_LANDUSE
                  IF ( ALBMAP_TO_REF( V ) .EQ. INDEX_OCEAN_REF ) THEN
                      N_WATER_CLASSES = N_WATER_CLASSES + 1
                  END IF
                  DO ROW = 1, NROWS
                     DO COL = 1, NCOLS
                        FRACTION_LANDUSE( V,COL,ROW ) = LUFRAC( COL,ROW,V )
                     END DO
                  END DO
               END DO
               N_LAND_CLASSES = NUMB_LANDUSE - N_WATER_CLASSES
               
               IF ( N_LAND_CLASSES .LE. 0 .OR. N_WATER_CLASSES .GE. NUMB_LANDUSE ) THEN
                    WRITE(LOGDEV,'( A, I3,1X,I3 )')' N_WATER_CLASSES, N_LAND_CLASSES = ',
     &              N_WATER_CLASSES, N_LAND_CLASSES
                    XMSG = 'No Land classes found in ' // GRID_CRO_2D //
     &              'as expected for the ' // TRIM( LAND_SCHEME ) // ' land use scheme'
                    WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                    SUCCESS = .FALSE.
                    RETURN
               END IF
               IF ( N_LAND_CLASSES .GE. NUMB_LANDUSE .OR. N_WATER_CLASSES .LE. 0 ) THEN
                  WRITE(LOGDEV,'( A, I3,1X,I3 )')' N_WATER_CLASSES, N_LAND_CLASSES = ',
     &            N_WATER_CLASSES, N_LAND_CLASSES
                  XMSG = 'No water classes found in ' // GRID_CRO_2D //
     &            'as expected for the ' // TRIM( LAND_SCHEME ) // ' land use scheme'
                  WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  SUCCESS = .FALSE.
                  RETURN
               END IF
            ELSE
               XMSG = ': Undentified ' // TRIM( LAND_SCHEME )
     &              // ' land use scheme for inline photolysis calculation.'
     &              // ' Using default land-water albedo for inline photolysis'
     &              // ' calculation.'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     IF ( LWMASK( COL,ROW ) .LT. 0.5 ) THEN
                        FRACTION_LANDUSE( 2,COL,ROW ) = 1.0
                     ELSE
                        FRACTION_LANDUSE( 1,COL,ROW ) = 1.0
                     END IF
                  END DO
               END DO
            END IF

            ALLOCATE ( SNOCOV( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SNOCOV array'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SEAICE( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SEAICE array'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            IF ( .NOT. HAS_SEAICE ) THEN
               XMSG = 'MET_CRO_2D DOES NOT CONTAIN SEA ICE DATA. THE SURFACE ALBEDO '
     &              // 'DOES NOT INCLUDE ITS EFFECTS. Setting to one if water surface '
     &              // 'temperaure is less than 271.36K (WRF formation threshold).'
               WRITE( LOGDEV, '(A)' ) XMSG
               ALLOCATE ( TEMPG( NCOLS,NROWS  ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating TEMPG array'
                  WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
                  SUCCESS = .FALSE.
                  RETURN
               END IF
            END IF

            ALLOCATE ( MAXIMUM_ALBEDO( NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating MAXIMUM_ALBEDO'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SURFACE_ALBEDO( NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SURFACE_ALBEDO'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( DIFFUSE_ALBEDO( NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DIFFUSE_ALBEDO'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_ANNUAL ( N_LAND_CLASSES,NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating LAND_ANNUAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_SEASONAL( N_LAND_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating LAND_SEASONAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_ZENITH( N_LAND_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALBEDO_ZENITH'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( LAND_SNOW( N_LAND_CLASSES,NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALBEDO_SNOW'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SFACTOR_LAND( N_LAND_CLASSES ), ZFACTOR_LAND( N_LAND_CLASSES ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SFACTOR_LAND and ZFACTOR_LAND'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_ANNUAL( N_WATER_CLASSES,NWL,NCOLS,NROWS ),
     &                 STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_ANNUAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE( SFACTOR_WATER( N_LAND_CLASSES ), ZFACTOR_WATER( N_WATER_CLASSES ),
     &                STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating SFACTOR_WATER and ZFACTOR_WATER'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SEAICE_ANNUAL( NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating SEAICE_ANNUAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( SEAICE_SNOW( NWL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating SEAICE_SNOW'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_FRACTION( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_FRACTION'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_SEASONAL( N_WATER_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_SEASONAL'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            ALLOCATE ( WATER_ZENITH( N_WATER_CLASSES ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating WATER_ZENITH'
               WRITE(LOGDEV,'( A )')TRIM( PNAME ) // ' : ' // XMSG
               SUCCESS = .FALSE.
               RETURN
            END IF

            SURFACE_ALBEDO  = 0.0
            DIFFUSE_ALBEDO  = 0.0
            LAND_ANNUAL     = 0.0
            LAND_SEASONAL   = 0.0
            LAND_ZENITH     = 0.0
            LAND_SNOW       = 0.0

C...determine average albedo and its adjustment factors for zenith angle, season and snow cover

            WATER_FRACTION = 0.0

            WATER_SEASONAL = 1.0
            WATER_ZENITH   = 0.0
            WATER_ANNUAL   = 0.0

            LAND_SEASONAL  = 1.0
            LAND_ZENITH    = 0.0
            LAND_SNOW      = 0.0
            LAND_ANNUAL    = 0.0

            MAXIMUM_ALBEDO = 0.0

            NW = 0
            NL = 0
            DO V = 1, NUMB_LANDUSE
! set values for maximum allowed albedo; should correspond to fresh snow           
               L = ALBMAP_TO_REF( V )
               DO IWAVE = 1, NWL
                  MAXIMUM_ALBEDO( IWAVE ) = MAX( MAXIMUM_ALBEDO( IWAVE ),
     &                                      ALBFAC_TO_REF( V )* SPECTRAL_ALBEDO_REF( IWAVE, L ) )
               END DO                 
               IF ( L .EQ. INDEX_OCEAN_REF ) THEN
                  NW = NW + 1
                  WATER_SEASONAL( NW ) = SEASON_COEFF_REF( L )
                  WATER_ZENITH  ( NW ) = ZENITH_COEFF_REF( L )
                  DO ROW = 1, NROWS
                     DO COL = 1, NCOLS
                        WATER_FRACTION( COL,ROW ) = WATER_FRACTION( COL,ROW )
     &                                             + FRACTION_LANDUSE( V,COL,ROW )
                        WATER_SCALE = ALBFAC_TO_REF( V ) * FRACTION_LANDUSE( V,COL,ROW )
                        DO IWAVE = 1, NWL
                           WATER_ANNUAL( NW,IWAVE,COL,ROW ) = WATER_SCALE * SPECTRAL_ALBEDO_REF( IWAVE, L )
                        END DO          
                     END DO
                  END DO 
               ELSE
                  NL = NL + 1
                  LAND_SEASONAL( NL ) = SEASON_COEFF_REF( L )
                  LAND_ZENITH  ( NL ) = ZENITH_COEFF_REF( L )
                  DO ROW = 1, NROWS
                     DO COL = 1, NCOLS
                        MSCALE = ALBFAC_TO_REF( V ) * FRACTION_LANDUSE( V, COL, ROW )
                        DO IWAVE = 1, NWL
                           LAND_ANNUAL( NL,IWAVE,COL,ROW ) = MSCALE * SPECTRAL_ALBEDO_REF( IWAVE, L )
                           LAND_SNOW  ( NL,IWAVE,COL,ROW ) = SNOW_COEFF_REF( L ) * LAND_ANNUAL( NL,IWAVE,COL,ROW )
                        END DO
                     END DO
                  END DO 
               END IF
            END DO                       
         
C...set up sea ice annual and snow albedos along with correction factors

            L = INDEX_SEA_ICE
            SEAICE_SEASONAL = SEASON_COEFF_REF( L )
            SEAICE_ZENITH   = ZENITH_COEFF_REF( L )
            DO IWAVE = 1, NWL
               SEAICE_ANNUAL( IWAVE ) = SPECTRAL_ALBEDO_REF( IWAVE, L )
               SEAICE_SNOW  ( IWAVE ) = SNOW_COEFF_REF( L ) * SEAICE_ANNUAL( IWAVE )
!              write(logdev,*)'SEAICE, SEAICE_ANNUAL, SEAICE_SNOW, SEAICE_SEASONAL, SEAICE_ZENITH = ', 
!     &         SEAICE_ANNUAL( IWAVE), SEAICE_SNOW( IWAVE ),SEAICE_SEASONAL
            END DO
         
            SUCCESS = .TRUE.
            
            RETURN
            
         END FUNCTION INITIALIZE_ALBEDO
            
         SUBROUTINE GET_ALBEDO( MDATE, MTIME, COSZENS, LAT, LON )
            
C... Subroutine calculates diffuse and direct surface albedo versus wavelength over a set of
C    latitudes and longitudes

            USE UTILIO_DEFN       ! IOAPI declaratiion and utilities
            USE PHOT_MOD          ! photolysis in-line module
#ifdef parallel
            USE SE_MODULES        ! stenex (using SE_UTIL_MODULE)
#else
            USE NOOP_MODULES      ! stenex (using NOOP_UTIL_MODULE)
#endif
            USE PCGRID_DEFN       ! get cgrid
            USE CENTRALIZED_IO_MODULE, only : interpolate_var, HAS_SEAICE

            IMPLICIT NONE

            INCLUDE SUBST_FILES_ID   ! file name parameters

C arguments:

            INTEGER, INTENT( IN ) :: MDATE            ! Julian date (YYYYDDD)
            INTEGER, INTENT( IN ) :: MTIME            ! time        (HHMMSS)
            REAL,    INTENT( IN ) :: COSZENS( :,: )   ! cosine of the solar zenith angle
            REAL,    INTENT( IN ) :: LAT( :,: )       ! north lat at cell center [deg]
            REAL,    INTENT( IN ) :: LON( :,: )       ! west long at cell center [deg] 

C local:
            REAL                        :: CURRENT_HOUR  ! current GMT hour [sec]
            REAL                        :: JULIAN_DAY    ! julian day       [days]
            REAL                        :: CURRHR_LST    ! local standard time at each grid cell
            REAL                        :: EQUATION_TIME ! equation of time
            REAL                        :: COSZEN        ! working cosine of the solar zenith angle
            REAL                        :: SINLAT        ! sine of latitude
            REAL                        :: COSLAT        ! cosine of latitude
            REAL                        :: MSCALE        ! scaling factor 

            REAL                        :: ALBEDO_LAND   ! scratch variable for land fraction
            REAL                        :: ALBEDO_WATER  ! scratch variable for water fraction
            REAL                        :: ALBEDO_SEAICE ! scratch variable for seaice fraction

            REAL                        :: SFACTOR_SEAICE ! seasonal correction for seaice albedo
            REAL                        :: ZFACTOR_SEAICE ! solar zenith angle correction for seaice albedo
            REAL                        :: SNOW_FREE      ! snow free fraction of cell
            REAL                        :: ICE_FREE       ! water fraction free sea ice 
            CHARACTER(  17 ), PARAMETER :: PNAME  = 'GET_ALBEDO'
            CHARACTER(  16 )            :: VARNM
            CHARACTER( 240 )            :: XMSG   = ' '

            INTEGER                     :: ROW
            INTEGER                     :: COL
            INTEGER                     :: LEV
            INTEGER                     :: SPC
            INTEGER                     :: L
            INTEGER                     :: IWAVE
            INTEGER                     :: NW, NL
            INTEGER                     :: V, N, MODE
            INTEGER                     :: ALLOCSTAT

C...Read & Interpolate SNOCOV

            call interpolate_var ('SNOCOV', mdate, mtime, SNOCOV)

            IF ( HAS_SEAICE ) THEN

               call interpolate_var ('SEAICE', mdate, mtime, SEAICE)

            ELSE

               call interpolate_var ('TEMPG', mdate, mtime, TEMPG)

            END IF

C...Calculate current hour in GMT and julian day

            CURRENT_HOUR = REAL( STRTHR, 4 )
     &                   + REAL( SECSDIFF( STDATE, STTIME, MDATE, MTIME ), 4 )
     &                   / 3600.0

            JULIAN_DAY   = REAL(MOD( MDATE, 1000 ), 4 )

C...Calculate cosines of the zenith angles

            DO ROW = 1, NROWS
               DO COL = 1, NCOLS

                  SINLAT = SIN( PI180 * LAT ( COL,ROW ) )
                  COSLAT = COS( PI180 * LAT ( COL,ROW ) )

C...correct  CURRHR for current *positive* West longitude convention
C...  to obtain LST.

C...this convention on longititude should be reexamined for different domains

                  CURRHR_LST = CURRENT_HOUR + LON( COL,ROW ) / 15.0

                  IF ( .NOT. HAS_SEAICE ) THEN ! determine sea ice can form
                     IF ( TEMPG( COL,ROW ) .LT. SEAICE_POINT .AND.
     &                    WATER_FRACTION( COL,ROW ) .GE. 0.95 ) THEN
                        SEAICE( COL,ROW ) = 1.0
                     ELSE
                        SEAICE( COL,ROW ) = 0.0
                     END IF
                  END IF

C...determine seasonal and snow corrections to surface albedo
C...  convert julian into time of year for grid cell
C...  seasonal adjustment has an 11 day phase delay in the solar cycle

                  IF ( LAT( COL,ROW ) .GE. 0.0 ) THEN
                     SEA_MODULATE = COS( JYFREQ * ( JULIAN_DAY + CURRHR_LST / 24.0 + 11.0 ) )
                  ELSE
                     SEA_MODULATE = COS( JYFREQ * ( JULIAN_DAY + CURRHR_LST / 24.0 + 11.0 ) + PI )
                  END IF

                  IF ( SEA_MODULATE .GE. 0.0 ) THEN
                     MSCALE = 0.5 * ( 1.0 + SQRT( SEA_MODULATE ) )
                  ELSE
                     SEA_MODULATE = ABS( SEA_MODULATE )
                     MSCALE = 0.5 * ( 1.0 - SQRT( SEA_MODULATE ) )
                  END IF

!.. MSCALE equals 1 and 0 on winter and summer soltices, respectively
!... Note that seasonal factors are equal to or less than 1.0
 
                  FORALL ( NL = 1:N_LAND_CLASSES )
                     SFACTOR_LAND( NL ) = 1.0 /( 1.0 + MSCALE * (LAND_SEASONAL ( NL ) - 1.0) )
                  END FORALL
! assume that open water has no other effect than sea ice that is a seasonal effect
!                 FORALL ( NW = 1:N_WATER_CLASSES )
!                    SFACTOR_WATER( NW ) = 1.0 /( 1.0 + MSCALE * (WATER_SEASONAL( NW ) - 1.0) )
!                 END FORALL
!                 SFACTOR_SEAICE = 1.0 /( 1.0 + MSCALE * (SEAICE_SEASONAL-1.0) )

C..Determine zenith angle correction to albedos
C...First, test whether zenith angle is greater than 90 degrees.
                  IF ( COSZENS( COL,ROW ) .LE. 0.0 ) THEN
                     FORALL ( NL = 1:N_LAND_CLASSES )
                        ZFACTOR_LAND( NL ) = MAX( 0.8, ( 1.0 + LAND_ZENITH( NL ) ) )
                        ZFACTOR_LAND( NL ) = ZFACTOR_LAND( NL ) * SFACTOR_LAND( NL )
                     END FORALL
! Note that water zenith correction is later combined with seasonal correction
                     FORALL ( NW = 1:N_WATER_CLASSES )
                        ZFACTOR_WATER( NW ) = MAX( 0.8,( 1.0 + WATER_ZENITH( NW ) ) )
                     END FORALL
                     ZFACTOR_SEAICE = MAX( 0.8, ( 1.0 + SEAICE_ZENITH ) )
                  ELSE
                     FORALL ( NL = 1:N_LAND_CLASSES )
                        ZFACTOR_LAND( NL ) = MAX( 0.8, ( 1.0 + LAND_ZENITH( NL ) )
     &                                     / ( 1.0 + 2.0 * COSZENS( COL,ROW ) * LAND_ZENITH( NL ) ) )
                        ZFACTOR_LAND( NL ) = ZFACTOR_LAND( NL ) * SFACTOR_LAND( NL )
                     END FORALL
! Note that water zenith correction is later combined with seasonal correction
                     FORALL ( NW = 1:N_WATER_CLASSES )
                        ZFACTOR_WATER( NW ) = MAX( 0.8, ( 1.0 + WATER_ZENITH( NW ) )
     &                                      / ( 1.0 + 2.0 * COSZENS( COL,ROW ) * WATER_ZENITH( NW ) ) )
                     END FORALL
                     ZFACTOR_SEAICE = MAX( 0.8, ( 1.0 + SEAICE_ZENITH )
     &                              / ( 1.0 + 2.0 * COSZENS( COL,ROW ) * SEAICE_ZENITH ) )
                  END IF

                  SNOW_FREE = MAX( ( 1.0 - SNOCOV( COL,ROW ) ), 0.0 )
                  ICE_FREE  = MAX( ( 1.0 - SEAICE( COL,ROW ) ), 0.0 )

!...Update the season and zenith corrections for water and sea ice based on ice and water coverage, in
!...the case for sea ice  
 
                  FORALL ( NW = 1:N_WATER_CLASSES )
                     SFACTOR_WATER( NW ) = ICE_FREE  !!! * SFACTOR_WATER( NW )
                     ZFACTOR_WATER( NW ) = ZFACTOR_WATER( NW ) * SFACTOR_WATER( NW )
                  END FORALL

                  SFACTOR_SEAICE = SEAICE( COL,ROW ) * WATER_FRACTION( COL,ROW )

                  DO IWAVE = 1, NWL

C...compute seasonal diffuse albedos for land, water and seaice separately

                     ALBEDO_LAND  = 0.0
                     ALBEDO_WATER = 0.0

                     DO NL = 1, N_LAND_CLASSES
                        IF ( LAND_ANNUAL( NL,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_LAND  = ALBEDO_LAND +  SFACTOR_LAND( NL )
     &                               * ( SNOW_FREE * LAND_ANNUAL( NL,IWAVE,COL,ROW )
     &                               +   SNOCOV( COL,ROW ) * LAND_SNOW( NL,IWAVE,COL,ROW ) )
                     END DO
                     DO NW = 1, N_WATER_CLASSES
                        IF ( WATER_ANNUAL( NW,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_WATER = ALBEDO_WATER  
     &                               + SFACTOR_WATER( NW ) * WATER_ANNUAL( NW,IWAVE,COL,ROW )
                     END DO

                     ALBEDO_SEAICE = SFACTOR_SEAICE
     &                             * ( SNOW_FREE * SEAICE_ANNUAL( IWAVE )
     &                             +   SNOCOV( COL,ROW ) * SEAICE_SNOW( IWAVE ) )

C...sum for net diffuse albedo

                     DIFFUSE_ALBEDO( IWAVE,COL,ROW ) = ALBEDO_LAND 
     &                                               + ALBEDO_WATER 
     &                                               + ALBEDO_SEAICE

                     MSCALE = MAXIMUM_ALBEDO( IWAVE )

                     DIFFUSE_ALBEDO( IWAVE,COL,ROW ) = MIN( MSCALE, DIFFUSE_ALBEDO( IWAVE,COL,ROW ) )

C...Calculate albedos for combined correction from solar zenith angle and season

                     ALBEDO_LAND  = 0.0
                     ALBEDO_WATER = 0.0

                     DO NL = 1, N_LAND_CLASSES
                        IF ( LAND_ANNUAL( NL,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_LAND = ALBEDO_LAND + ZFACTOR_LAND( NL ) 
     &                              * ( SNOW_FREE * LAND_ANNUAL( NL,IWAVE,COL,ROW )
     &                              +   SNOCOV( COL,ROW ) * LAND_SNOW( NL,IWAVE,COL,ROW ) )
                     END DO
                     DO NW = 1, N_WATER_CLASSES
                        IF ( WATER_ANNUAL( NW,IWAVE,COL,ROW ) .LT. 1.0E-6 ) CYCLE
                        ALBEDO_WATER = ALBEDO_WATER 
     &                               + ZFACTOR_WATER( NW ) * WATER_ANNUAL(NW,IWAVE,COL,ROW )
                     END DO

                     ALBEDO_SEAICE = ZFACTOR_SEAICE * ALBEDO_SEAICE

C....sum for net direct albedo

                     SURFACE_ALBEDO( IWAVE,COL,ROW ) = ALBEDO_LAND 
     &                                               + ALBEDO_WATER 
     &                                               + ALBEDO_SEAICE

                     SURFACE_ALBEDO( IWAVE,COL,ROW ) = MIN( MSCALE, SURFACE_ALBEDO( IWAVE,COL,ROW ) )

                  END DO   ! iwave

               END DO   ! col
            END DO   ! row

            RETURN

         END SUBROUTINE GET_ALBEDO

      END MODULE PHOTOLYSIS_ALBEDO

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/vdiff/acm2/rddepv.F,v 1.6 2011/12/09 14:19:17 yoj Exp $
 
C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE RDDEPV ( JDATE, JTIME, DEPV )

C-----------------------------------------------------------------------
C Function:
C   Get deposition velocities for vertical diffusion
 
C Preconditions:
 
C Subroutines and functions called:
C INTERP3, M3EXIT, AERO_DEPV
 
C Revision History:
C   Jeff - Sep 97 - targetted, call subroutine for aerosol species
C   Jeff - Dec 97 - add MDEPV
C   2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   Jeff - May 2000 - correct DEPV to "real world" values
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C   15 Mar 03 J.Young: swap depv and mdepv dimensions
C   21 Jul 03 J.Gipson: revised to compute avg DEPV for aero3 NR CG/SOA species
C   22 Aug 03 J.Young: aero in ppm units, eliminate MDEPV
C   23 Oct 03 J.Young: change depv from flux to m/s
C   14 Sep 04 J.Gipson: generalized avg DEPV calcs for aero3 SGTOT species
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   07 Jun 05 P.Bhave: added logic for 'AE4' mechanism
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   16 May 11 J.Young: remove references to AERO3 and AERO4
C   09 Dec 11 J.Young: remove unused Flag for SGTOT species
C   07 Jul 14 B.Hutzell: replace mechanism include file(s) with fortran module
C    1 Feb 19 D. Wong: Implemented centralized I/O approach, removed all MY_N
C                      clauses
C-----------------------------------------------------------------------

      USE HGRD_DEFN           ! horizontal grid specifications
      USE RXNS_DATA           ! chemical mechanism data
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      INTEGER, INTENT( IN )  :: JDATE, JTIME ! internal simulation date&time, tstep
      REAL,    INTENT( OUT ) :: DEPV( :,:,: )

C Paramters:

C External Functions:

C Local variables:

      REAL, ALLOCATABLE, SAVE :: DBUFF( :,: )       ! read buffer

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 16 ), SAVE :: PNAME = 'RDDEPV'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER ALLOCSTAT
      INTEGER C, R, V, N                      ! loop induction variables
      INTEGER STRT, FINI                      ! loop induction variables

C-----------------------------------------------------------------------

      IF ( FIRSTIME )  THEN

         FIRSTIME  =  .FALSE.

         ALLOCATE ( DBUFF( NCOLS,NROWS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating BUFF'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

      END IF   ! Firstime

      N = 0
      STRT = 1
      FINI = N_GC_DEPV
      DO V = STRT, FINI
         N = N + 1

C                                        vvvvvvv - dep vel surrogate name
         call interpolate_var (GC_DEPV( N ), jdate, jtime, DBUFF)

         DO R = 1, NROWS
            DO C = 1, NCOLS
               DEPV( V,C,R ) = GC_DEPV_FAC( N ) * DBUFF( C,R ) 
            END DO
         END DO

      END DO

      N = 0
      STRT = N_GC_DEPV + N_AE_DEPV + 1
      FINI = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV
      DO V = STRT, FINI
         N = N + 1

C                                        vvvvvvv - dep vel surrogate name
         call interpolate_var (NR_DEPV( N ), jdate, jtime, DBUFF)

         DO R = 1, NROWS
            DO C = 1, NCOLS
               DEPV( V,C,R ) = NR_DEPV_FAC( N ) * DBUFF( C,R )
            END DO
         END DO

      END DO

      N = 0
      STRT = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + 1
      FINI = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + N_TR_DEPV 
      DO V = STRT, FINI
         N = N + 1

C                                         vvvvvvv - dep vel surrogate name
         call interpolate_var (TR_DEPV( N ), jdate, jtime, DBUFF)

         DO R = 1, NROWS
            DO C = 1, NCOLS
               DEPV( V,C,R ) = TR_DEPV_FAC( N ) * DBUFF( C,R ) 
            END DO
         END DO

      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C >>> 08/04/2000 Changes necessary to be able to read and process
C two different types of emissions files.
C the first type is the existing opperational PM2.5 & PM10 unspeciated
C file. The new file format has speciated emissions.
C >>> This version uses the FORTRAN 90 feature for runtime memory
C allocation.

C 1/12/99 David Wong at LM:
C   -- introduce new variable MY_NUMBLKS (eliminate NUMBLKS)
C   -- re-calculate NOXYZ accordingly
C FSB Updated for inclusion of surface area / second moment
C 25 Sep 00 (yoj) various bug fixes, cleanup to coding standards
C   Jeff - Dec 00 - move CGRID_MAP into f90 module
C FSB/Jeff - May 01 - optional emissions processing
C   Jerry Gipson - Jun 01 - added SOA linkages for saprc99
C   Bill Hutzell - Jun 01 - simplified CBLK mapping
C   Jerry Gipson - Jun 03 - modified for new soa treatment
C   Jerry Gipson - Aug 03 - removed SOA prod form alkenes & added
C       emission adjustment factors for ALK & TOL ( RADM2 & SAPRC99 only)
C   Shawn Roselle - Jan 04
C   - removed SOA from transported aerosol surface area
C   - fixed bug in calculation of wet parameters.  Previously, DRY aerosol
C      parameters were being written to the AERDIAG files and mislabeled
C      as WET.
C   Prakash Bhave - May 04
C   - changed AERODIAG species (added RH; removed M0 & M2dry)
C   Jeff Young - Jan 05 - dyn alloc
C   - establish both horizontal & vertical domain specifications in one module
c   Uma Shankar and Prakash Bhave - Jun 05
c   - added code to handle the following species: ANAI, ANAJ, ANAK, ACLI,
c     ACLJ, ACLK, ASO4K, AH2OK, ANO3K, and HCL; removed code for ASEAS
c   - removed obsolete MW variables
C   Prakash Bhave - Jul 05 - added PM25 mass-fraction calculations
C   Jeff Young - Feb 06 - trap fractional humidity above 0.005
C   Prakash Bhave - Apr 06 - added GAMMA_N2O5 to the AEROPROC call vector
C       and the aerosol diagnostic file
C   Prakash Bhave - May 06 - changed units of DG variables from m to um in
C       the aerosol diagnostic file as suggested by Dr. Bill Hutzell
C   Sergey Napelenok - Sep 07 - SOA updates
C   - added code to handle the following species: AALKJ, ATOL1J, ATOL2J,
C     ATOL3J, AXYL1J, AXYL2J, AXYL3J, ABNZ1J, ABNZ2J, ABNZ3J, AISO1J, AISO2J,
C     AISO3J, ATRP1J, ATRP2J, ASQTJ, AORGCJ, TOLNRXN, TOLHRXN, XYLNRXN,
C     XYLHRXN, BNZNRXN, BNZHRXN, ISOPRXN, and SESQRXN
C   - removed following species: AORGAI, AORGAJ, AORGBI, AORGBJ, OLIRXN,
C     CSLRXN, TOLRXN, XYLRXN
C   Prakash Bhave - Oct 07 - SOA updates
C   - added semi-volatile vapors to the CBLK array; moved ppm -> ug/m3 unit
C     conversion from the ORGAER subroutine to this program
C   - updated definition of DRY aerosol to include nonvolatile SOA species
C   - removed adjustment factors for TOLAER (SPTOL, RDTOL) because benzene is
C     now an explicit species so all of the reacted TOL can produce SOA
C   - removed code to handle TERPSP (obsolete); renamed TERPRXN as TRPRXN
C   David Wong - Jan 08 - rearranged calculation of dry 3rd moments to avoid
C      NaN on some compilers (using the M3SUBT variable)
C   Prakash Bhave - Jan 08 - updated MECHNAME check from AE4 to AE5
C   Golam Sarwar -  Mar 08 - added a heterogeneous reaction producing HONO
C   Jim Kelly - Apr 08 - coarse mode updates
C   - added code to account for new species (ANH4K & SRFCOR) and variable
C     coarse std. deviation
C   - removed MW coding now located in AERO_INFO.f
C   - added FIXED_sg flag for call to GETPAR
C   Jeff Young - Aug 10 - convert for Namelist redesign (replace include files)
C   Steve Howard - Mar 11 - Renamed met_data to aeromet_data
C   S.Roselle- Mar 11 - replaced I/O API include files with UTILIO_DEFN
C   David Wong - Aug 11 - put in twoway model implementation
C   David Wong - Oct 11 - extended the twoway implementation to handle finer
C                         time resolution
C
C   Bill Hutzell - Sept 13 - inserted module for AEROSOL_CHEMISTRY to support
C                            diagnostic outputs on reaction gamma and yield 
C                            values 
C   HOT Pye - Jan 13 - Additional information for IEPOX aerosol 
C                      written to AERODIAG file
C   David Wong - Aug 15 - Used IO_PE_INCLUSIVE rather than MYPE to facilitate
C                         parallel I/O implementation
C                       - Used a new logical variable, FIRST_CTM_VIS_1 to
C                         determine when to open CTM_VIS_1 
C  B.Hutzell 22 Feb 16 - Added test to determine to write diagnostics from aerosol
C                        chemistry
C  H Pye and B Murphy April 2016 - Updated dry/wet moment process to use
C                        Extract_aero and Update_aero for getting moment/saving surface area
C  D. Wong 10 May 2016 - added calculation of average PMDIAG species w.r.t.
C                        environment variable CTM_PMDIAG, APMDIAG_BLEV_ELEV, 
C                        and AVG_PMDIAG_SPCS
C                      - added calculation of average visibility species w.r.t.
C                        environment variable CTM_AVISDIAG
C                      - renamed AERODIAM to PMDIAG and CTM_AERDIAG to CTM_PMDIAG
C                      - added flexibility to handle AE6 and AE6i
C                      - renamed DIAM to PMDIAG
C  D. Wong 19 May 2016 - renamed ACONC_END_TIME to AVG_FILE_ENDTIME
C                      - updated the way to define NUM_PMDIAG_SPC
C                      - set CTM_PMDIAG default value to .TRUE.
C  D. Wong 31 Jan 2019 - adopted the idea to process all twoway related environment
C                        variables in one place
C    1 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C    1 Aug 19 David Wong: Added a few more variables in the USE Only blcok for two-way model
C   30 Dec 19 S. Napelenok: ddm-3d implementation for v 5.3.1
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO ( CGRID, JDATE, JTIME, TSTEP )

      USE GRID_CONF, ONLY: NCOLS, NROWS, NLAYS, IO_PE_INCLUSIVE
      USE RXNS_DATA, ONLY: MECHNAME
      USE AERO_DATA, ONLY: COAG_BUDGET, COND_BUDGET, GROWTH_BUDGET, NPF_BUDGET,
     &                     FIXED_sg, AEROMODE_DIAM, AEROMODE_LNSG, AEROMODE_DENS,
     &                     MOMENT0_CONC, MOMENT2_CONC, MOMENT3_CONC,
     &                     AEROSPC, AEROSPC_CONC, N_MODE, AH2O_IDX,
     &                     EXTRACT_AERO, UPDATE_AERO, CALCMOMENTS
      USE PRECURSOR_DATA, ONLY: SULPRD_IDX, SO4RATE, PRECURSOR_CONC,
     &                          PHGRXN_IDX, PHG_RATE,
     &                          EXTRACT_PRECURSOR, UPDATE_PRECURSOR
      USE SOA_DEFN, ONLY: EXTRACT_SOA, UPDATE_ORGVAPOR
      USE AEROMET_DATA, ONLY: AIRTEMP, AIRPRES, AIRQV, AIRDENS, AIRRH, 
     &                        H2OSATVP, H2OVP, MWWAT, MWAIR
      USE UTILIO_DEFN, ONLY: OPEN3, INTERPX, WRITE3, FSREAD3, ALLVAR3,
     &                       XSTAT1, TIME2SEC, SEC2TIME
#ifdef twoway
     &                       , INDEX1, XSTAT3
#endif
      USE CGRID_SPCS, ONLY: NSPCSD
#ifdef twoway
     &                      , N_GC_CONC, GC_CONC, GC_STRT, GC_CONC_MAP
#endif
      USE AEROSOL_CHEMISTRY, ONLY : GAMMA_N2O5IJ, GAMMA_N2O5K, YCLNO2IJ, YCLNO2K, 
     &                              GAMMA_IEPOX, GAMMA_IMAE, KPARTIEPOX, AERO_CHEM_SET
      USE PMDIAG_DATA_MODULE, ONLY: NUM_PMDIAG_SPC, A_PMDIAG_SPC_MAP, PMDIAG_SPC_RECORD
      USE RUNTIME_VARS, ONLY: LOGDEV, PMDIAG, APMDIAG, APMDIAG_ZHI, END_TIME
      USE AERO_BUDGET, ONLY: AERO_COAG, AERO_COND, AERO_GROWTH, AERO_NPF

#ifdef twoway
      USE twoway_data_module
#endif
      use CENTRALIZED_IO_MODULE, only : interpolate_var

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, SENGRID
      Use aero_ddm3d, ONLY : s_so4rate, s_precursor_conc, s_aerospc_conc, s_phg_rate
#endif 


      IMPLICIT NONE

C *** Includes:

      INCLUDE SUBST_FILES_ID  ! file name parameters (req IOPARMS)

C *** Arguments:

C *** CGRID is conc field (including gas and aerosol variables)
      REAL, POINTER :: CGRID( :,:,:,: )              !  concentrations
      INTEGER      JDATE        ! Current model date , coded YYYYDDD
      INTEGER      JTIME        ! Current model time , coded HHMMSS
      INTEGER      TSTEP( 3 )   ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C *** Local Variables:

      CHARACTER( 16 ), SAVE :: PNAME = 'AERO_DRIVER'
      CHARACTER( 16 ) :: VNAME            ! variable name
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER   MDATE, MTIME, MSTEP  ! julian date, time and
                                     ! timestep in sec
      INTEGER   C, R, L, V, N        ! loop counters
      INTEGER   SPC                  ! species loop counter
      INTEGER   STRT, FINI           ! loop induction variables
      INTEGER   ALLOCSTAT            ! memory allocation status

      LOGICAL   LERROR               ! Error flag

C *** Grid Description
      REAL DX1                 ! Cell x-dimension
      REAL DX2                 ! Cell y-dimension

C *** Variable to set time step for writing visibility file
      INTEGER, SAVE :: WSTEP  = 0   ! local write counter
      LOGICAL, SAVE :: WRITETIME = .FALSE. ! local write flag

C *** meteorological variables
      REAL PRES   ( NCOLS,NROWS,NLAYS )  ! Atmospheric pressure [ Pa ]
      REAL TA     ( NCOLS,NROWS,NLAYS )  ! Air temperature [ K ]
      REAL DENS   ( NCOLS,NROWS,NLAYS )  ! Air density [ kg/m**-3 ]
      REAL QV     ( NCOLS,NROWS,NLAYS )  ! Water vapor mixing ratio [ kg/kg ]

C *** variables computed and output but not carried in CGRID

C *** aerosol size distribution variables
!     REAL DIAM_SPC( NCOLS,NROWS,NLAYS,39 )
      REAL, ALLOCATABLE, SAVE :: PMDIAG_SPC( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: A_PMDIAG_SPC( :,:,:,: )
      CHARACTER( 16 ) :: V_LIST( 2 )

      INTEGER, SAVE :: N_APMDIAG_STEP

C *** atmospheric properties
      REAL XLM             ! atmospheric mean free path [ m ]
      REAL AMU             ! atmospheric dynamic viscosity [ kg/m s ]

C *** mass fraction of each mode less than Specified Aerodynamic Diameters
      REAL fPM1 ( N_MODE )  ! PM1 fraction
      REAL fPM25( N_MODE )  ! PM2.5 fraction
      REAL fPM10( N_MODE )  ! PM10 fraction
      REAL fAMS ( N_MODE )  ! AMS Transmission Fraction

C *** visual range information
      REAL BLKDCV1         ! block deciview (Mie)
      REAL BLKEXT1         ! block extinction [ km**-1 ] (Mie)

      REAL BLKDCV2         ! block deciview (Reconstructed)
      REAL BLKEXT2         ! block extinction [ km**-1 ] (Reconstructed)


C *** other internal aerosol variables
      INTEGER IND                         ! index to be used with INDEX1

C *** synchronization time step [ s ]
      REAL DT

C *** variables to set up for "dry transport "
      REAL M3_WET( N_MODE ), M3_DRY( N_MODE )   ! third moment with and without water
      REAL M2_WET( N_MODE ), M2_DRY( N_MODE )   ! second moment with and without water

C *** variables aerosol diagnostic file flag
      INTEGER      STATUS            ! ENV... status
      CHARACTER( 80 ) :: VARDESC     ! environment variable description

C *** first pass flag
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: FIRST_CTM_PMDIAG_1 = .TRUE.

C *** ratio of molecular weights of water vapor to dry air = 0.622015
      REAL, PARAMETER :: EPSWATER = MWWAT / MWAIR

C *** dry moment factor
      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0

      LOGICAL :: TIME_TO_CALL_FEEDBACK_WRITE

C *** Statement Function **************
      REAL ESATL ! arithmetic statement function for vapor pressure [Pa]
      REAL TT
C *** Coefficients for the equation, ESATL defining saturation vapor pressure
      REAL, PARAMETER :: AL = 610.94
      REAL, PARAMETER :: BL = 17.625
      REAL, PARAMETER :: CL = 243.04

      INTEGER, SAVE :: O3

      CHARACTER( 16 ) :: AVG_FILE_ENDTIME = 'AVG_FILE_ENDTIME'

      REAL, ALLOCATABLE, SAVE :: TEMP_DATA(:)

C *** values of AL, BL, and CL are from:
C     Alduchov and Eskridge, "Improved Magnus Form Approximations of
C                            Saturation Vapor Pressure,"
C                            Jour. of Applied Meteorology, vol. 35,
C                            pp 601-609, April, 1996.

      ESATL( TT ) = AL * EXP( BL * ( TT - 273.15 ) / ( TT - 273.15 + CL ) )

C *** End Statement Function  ********

      logical, save :: now = .true.

#ifdef twoway
      INTERFACE
        SUBROUTINE FEEDBACK_WRITE (C, R, L, CGRID_DATA, O3_VALUE, JDATE, JTIME)
          REAL, INTENT( IN ) :: CGRID_DATA(:), O3_VALUE
          INTEGER, INTENT( IN ) :: C, R, L, JDATE, JTIME
        END SUBROUTINE FEEDBACK_WRITE
      END INTERFACE
#endif

C ------------------ begin body of AERO_DRIVER -------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         IF ( ( INDEX(MECHNAME, 'SAPRC07TIC_AE6I_AQ') .GT. 0 ) .OR.
     &        ( INDEX(MECHNAME, 'SAPRC07TIC_AE7I_AQ') .GT. 0 ) ) THEN
            NUM_PMDIAG_SPC = 41
         ELSE
            NUM_PMDIAG_SPC = 39
         END IF

         ALLOCATE (   PMDIAG_SPC( NCOLS,NROWS,NLAYS,NUM_PMDIAG_SPC ),
     &              A_PMDIAG_SPC( NCOLS,NROWS,NLAYS,NUM_PMDIAG_SPC ),
     &              TEMP_DATA( NUM_PMDIAG_SPC ), 
     &              AERO_COND(   NCOLS,NROWS,NLAYS,NSPCSD ),
     &              AERO_COAG(   NCOLS,NROWS,NLAYS,NSPCSD,N_MODE ),
     &              AERO_NPF (    NCOLS,NROWS,NLAYS,NSPCSD ),
     &              AERO_GROWTH ( NCOLS,NROWS,NLAYS,NSPCSD ),
     &              COND_BUDGET( NSPCSD ),
     &              COAG_BUDGET( NSPCSD,N_MODE ),
     &              NPF_BUDGET( NSPCSD ),
     &              GROWTH_BUDGET( NSPCSD ),
     &              STAT=ALLOCSTAT)

         A_PMDIAG_SPC  = 0.0
         N_APMDIAG_STEP = 0

#ifdef twoway
! -- this is for twoway
         VNAME = 'O3'
         N = INDEX1( VNAME, N_GC_CONC, GC_CONC )
         IF ( N .NE. 0 ) THEN
            O3 = GC_STRT - 1 + GC_CONC_MAP( N )
         ELSE
            XMSG = 'Could not find ' // VNAME // 'in gas chem aerosol table'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF
#endif

C *** Open the aerosol parameters file (diameters and standard deviations).

         IF ( PMDIAG .AND. IO_PE_INCLUSIVE ) CALL OPPMDIAG ( JDATE, JTIME, TSTEP( 1 ) )
         IF ( APMDIAG ) CALL OPAPMDIAG ( JDATE, JTIME, TSTEP( 1 ) )

      END IF    ! FIRSTIME

      MDATE  = JDATE
      MTIME  = JTIME
      MSTEP = TIME2SEC( TSTEP( 2 ) )
      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( MSTEP / 2 ) )

      WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
      IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) WRITETIME = .TRUE.

C *** Set floating point synchronization time step:
      DT = FLOAT( MSTEP ) ! set time step in seconds

C *** Get Meteorological Variables

C *** pressure [Pa]
      call interpolate_var ('PRES', mdate, mtime, PRES)

C *** temperature [K]
      call interpolate_var ('TA', mdate, mtime, TA)

C *** specific humidity [g H2O/g air]
      call interpolate_var ('QV', mdate, mtime, QV)

C *** air density [kg/m3]
      call interpolate_var ('DENS', mdate, mtime, DENS)

#ifdef twoway
! call FEEDBACK_WRITE when JTIME is mulitple of WRF time step
      IF ( CMAQ_WRF_FEEDBACK ) THEN
         IF ( MOD( TIME2SEC(MOD( JTIME, 10000 )), TIME2SEC(TSTEP( 3 )) ) .EQ. 0 ) THEN
            TIME_TO_CALL_FEEDBACK_WRITE = .TRUE.
         ELSE
            TIME_TO_CALL_FEEDBACK_WRITE = .FALSE.
         END IF
      END IF
#endif

! *** Initialize Shared Arrays for Aerosol Budget
      AERO_COND   = 0.
      AERO_COAG   = 0.
      AERO_NPF    = 0.
      AERO_GROWTH = 0.


C --------------------- Begin loops over grid cells --------------------------

C *** initialize conc arrays

      N_APMDIAG_STEP = N_APMDIAG_STEP + 1

      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS

C *** Grid cell meteorological data.
               AIRTEMP  = TA   ( C,R,L )
               AIRPRES  = PRES ( C,R,L )   ! Note pascals
               AIRQV    = QV   ( C,R,L )
               AIRDENS  = DENS ( C,R,L )
               H2OSATVP = ESATL( AIRTEMP )
               H2OVP    = AIRPRES * AIRQV / ( EPSWATER  + AIRQV )
               AIRRH    = MAX( 0.005, MIN( 0.99, H2OVP / H2OSATVP ) )

! *** Initialize aerosol process variables
               COND_BUDGET = 0.
               COAG_BUDGET = 0.
               NPF_BUDGET = 0.
               GROWTH_BUDGET = 0.

C *** Extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module (set minimum)
#ifdef sens
               CALL EXTRACT_AERO( CGRID( C,R,L,: ), .TRUE., SENGRID( C,R,L,:,: ), .TRUE. )
#else
               CALL EXTRACT_AERO( CGRID( C,R,L,: ), .TRUE. )
#endif

C *** Extract grid cell concentrations of gas precursors from CGRID (ppm)
C     into precursr_conc in precursor_data
               CALL EXTRACT_PRECURSOR( CGRID( C,R,L,: ) )

C *** Calculate SO4RATE stored in module
               SO4RATE = REAL( PRECURSOR_CONC( SULPRD_IDX ), 4 ) / DT
 
               IF ( PHGRXN_IDX .GT. 0 ) THEN
C *** Calculate PHG_RATE stored in module
                  PHG_RATE = REAL( PRECURSOR_CONC( PHGRXN_IDX ), 4 ) / DT
               ELSE
                  PHG_RATE = 0.0
               END IF

C *** Extract soa concentrations from CGRID and 
C     convert M2 to wet
               CALL EXTRACT_SOA( CGRID( C,R,L,: ) )

C *** Aerosol process routines
               CALL AEROPROC( DT, C, R, L )

C *** Update aerosol variables conc back into CGRID (set minimum) 
C     and convert M2 to dry and save as surface area
#ifdef sens
               CALL UPDATE_AERO( CGRID( C,R,L,: ), .TRUE., SENGRID(C,R,L,:,: ) )
#else
               CALL UPDATE_AERO( CGRID( C,R,L,: ), .TRUE. )
#endif

C *** Update precursor variables conc back into CGRID
               CALL UPDATE_PRECURSOR( CGRID( C,R,L,: ) )

C *** Update gas soa concentrations back to CGRID
               CALL UPDATE_ORGVAPOR( CGRID( C,R,L,: ) )

C *** OUTPUT DIAGNOSTIC INFORMATION
C *** Get wet moment info (dry will be converted to wet)
               CALL calcmoments( .true. )
               CALL GETPAR( FIXED_sg ) ! update AEROMODE_DIAM,DENS,SDEV
                   
C *** Calculate volume fraction of each mode for measurement applications
               DO N = 1, N_MODE
                  ! Calculate transmission of each mode in aerosol impactors.
                  ! Report fraction of PM1, PM2.5, and PM10.0 for all modes
                  ! after converting to aerodynamic diameter.
                  CALL AERO_INLET ( AEROMODE_DIAM( N ), AEROMODE_LNSG( N ),
     &                              AEROMODE_DENS( N ), fPM1( N ), fPM25( N ),
     &                              fPM10( N ) )
           
                  ! Calculate AMS Transmission Fraction. Aerosol water will
                  ! be excluded from the calculation since AMS standard
                  ! procedures recommend drying particles before they enter
                  ! the intstrument.
                  CALL AERO_AMS ( MOMENT3_CONC( N ), MOMENT2_CONC( N ),
     &                            MOMENT0_CONC( N ), AEROSPC_CONC( AH2O_IDX,N ), 
     &                            AEROMODE_DENS( N ),AEROSPC( AH2O_IDX)%DENSITY, 
     &                            fAMS( N ) )
               END DO

C *** Write aerosol extinction coefficients and deciviews to visibility
C     diagnostic array (lowest vertical layer only)

               IF ( PMDIAG .OR. APMDIAG ) THEN
                  TEMP_DATA(  7 ) = AEROMODE_DIAM( 1 ) * 1.0E6  ! wet i-mode diam.
                  TEMP_DATA(  8 ) = AEROMODE_DIAM( 2 ) * 1.0E6  ! wet j-mode diam.
                  TEMP_DATA(  9 ) = AEROMODE_DIAM( 3 ) * 1.0E6  ! wet k-mode diam.
                  TEMP_DATA( 10 ) = MOMENT2_CONC( 1 )     ! wet i-mode 2nd moment
                  TEMP_DATA( 11 ) = MOMENT2_CONC( 2 )     ! wet j-mode 2nd moment
                  TEMP_DATA( 12 ) = MOMENT2_CONC( 3 )     ! wet k-mode 2nd moment
                  TEMP_DATA( 16 ) = MOMENT3_CONC( 1 )     ! wet i-mode 3rd moment
                  TEMP_DATA( 17 ) = MOMENT3_CONC( 2 )     ! wet j-mode 3rd moment
                  TEMP_DATA( 18 ) = MOMENT3_CONC( 3 )     ! wet k-mode 3rd moment
                  TEMP_DATA( 20 ) = fPM1( 1 )             ! i-mode PM1 fraction
                  TEMP_DATA( 21 ) = fPM1( 2 )             ! j-mode PM1 fraction
                  TEMP_DATA( 22 ) = fPM1( 3 )             ! k-mode PM1 fraction
                  TEMP_DATA( 23 ) = fPM25( 1 )            ! i-mode fine fraction
                  TEMP_DATA( 24 ) = fPM25( 2 )            ! j-mode fine fraction
                  TEMP_DATA( 25 ) = fPM25( 3 )            ! k-mode fine fraction
                  TEMP_DATA( 26 ) = fPM10( 1 )            ! i-mode PM10 fraction
                  TEMP_DATA( 27 ) = fPM10( 2 )            ! j-mode PM10 fraction
                  TEMP_DATA( 28 ) = fPM10( 3 )            ! k-mode PM10 fraction
                  TEMP_DATA( 29 ) = fAMS( 1 )             ! i-mode fraction transmitted through AMS
                  TEMP_DATA( 30 ) = fAMS( 2 )             ! j-mode fraction transmitted through AMS
                  TEMP_DATA( 31 ) = fAMS( 3 )             ! k-mode fraction transmitted through AMS

                  IF ( AERO_CHEM_SET ) THEN
                     TEMP_DATA( 32 ) = GAMMA_N2O5IJ( C,R,L ) ! fine N2O5 heterorxn probability
                     TEMP_DATA( 33 ) = GAMMA_N2O5K( C,R,L )  ! coarse N2O5 heterorxn probability
                     TEMP_DATA( 34 ) = YCLNO2IJ( C,R,L )     ! fine CLNO2 heterorxn yield
                     TEMP_DATA( 35 ) = YCLNO2K( C,R,L )      ! coarse CLNO2 heterorxn yield
                     TEMP_DATA( 36 ) = GAMMA_IEPOX( C,R,L )  ! IEPOX heterorxn uptake coeff
                  ELSE
                     TEMP_DATA( 32:36 ) = 0.0
                  END IF
                  TEMP_DATA( 37 ) = AEROMODE_DENS( 1 )    ! Aitken Mode Density [kg m-3]
                  TEMP_DATA( 38 ) = AEROMODE_DENS( 2 )    ! Accumulation Mode Density [kg m-3]
                  TEMP_DATA( 39 ) = AEROMODE_DENS( 3 )    ! Coarse Mode Density [kg m3-]
                  IF ( NUM_PMDIAG_SPC .GT. 39 ) THEN ! AERO6i
                     TEMP_DATA( 40 ) = KPARTIEPOX( C,R,L )  ! Particle-Phase Rxn Rate Constant
                     TEMP_DATA( 41 ) = GAMMA_IMAE( C,R,L )  ! IMAE Heterorxn Uptake Coeff
                  END IF
               END IF

! *** Calculate 2nd and 3rd moments of the "dry" aerosol distribution
!     NOTE! "dry" aerosol excludes both H2O and SOA  (Jan 2004 --SJR)
!     EXCEPT!  nonvolatile SOA is part of dry aerosol (Oct 2007 --PVB)
               CALL CALCMOMENTS( .FALSE. )
               CALL GETPAR( FIXED_sg ) ! update AEROMODE_DIAM,DENS,SDEV

               IF ( PMDIAG .OR. APMDIAG ) THEN
                  TEMP_DATA(  1 ) = EXP( AEROMODE_LNSG( 1 ) )
                  TEMP_DATA(  2 ) = EXP( AEROMODE_LNSG( 2 ) )
                  TEMP_DATA(  3 ) = EXP( AEROMODE_LNSG( 3 ) )
                  TEMP_DATA(  4 ) = AEROMODE_DIAM( 1 ) * 1.0E6  ! dry i-mode diam.
                  TEMP_DATA(  5 ) = AEROMODE_DIAM( 2 ) * 1.0E6  ! dry j-mode diam.
                  TEMP_DATA(  6 ) = AEROMODE_DIAM( 3 ) * 1.0e6  ! dry k-mode diam.
                  TEMP_DATA( 13 ) = MOMENT3_CONC( 1 )    ! dry i-mode 3rd moment
                  TEMP_DATA( 14 ) = MOMENT3_CONC( 2 )    ! dry j-mode 3rd moment
                  TEMP_DATA( 15 ) = MOMENT3_CONC( 3 )    ! dry k-mode 3rd moment
                  TEMP_DATA( 19 ) = AIRRH                ! relative humidity
               END IF

C *** Accumulate wet diameters, 2nd, and 3rd moments to average aerosol diagnostic array
               IF ( APMDIAG .AND. L .LE. APMDIAG_ZHI ) THEN
                  DO V = 1, NUM_PMDIAG_SPC
                     IF ( A_PMDIAG_SPC_MAP( V ) .EQ. 1 ) THEN
                        A_PMDIAG_SPC( C,R,L,V ) = A_PMDIAG_SPC( C,R,L,V ) + TEMP_DATA( V )
                     END IF
                  END DO 
               END IF

! *** Write dry aerosol distribution parameters to aerosol diagnostic array
               IF ( WRITETIME .AND. PMDIAG ) PMDIAG_SPC( C,R,L,: ) = TEMP_DATA

! *** Collect Aerosol Sub-Process Rates in shared arrays
               AERO_COND  ( C,R,L,: ) = COND_BUDGET( : )
               AERO_COAG  ( C,R,L,:,: )=COAG_BUDGET( :,: )
               AERO_NPF   ( C,R,L,: ) = NPF_BUDGET( : )
               AERO_GROWTH( C,R,L,: ) = GROWTH_BUDGET( : )

#ifdef twoway
               IF ( CMAQ_WRF_FEEDBACK ) THEN
                  IF ( TIME_TO_CALL_FEEDBACK_WRITE ) THEN
                     CALL FEEDBACK_WRITE ( C, R, L, CGRID(C,R,L,:), CGRID(C,R,L,O3),
!    &                                     aeromode_diam, AEROMODE_LNSG, jdate, jtime)
     &                                     JDATE, JTIME )
                  END IF
               END IF
#endif

            END DO ! loop on COLS
         END DO ! loop on ROWS
      END DO ! loop on NLAYS

C *** From AEROPROC call to ORGAER...
!     If ( pfc .gt. 0 ) Then
!        Write( xmsg,'(a,i8)' ) 'possible false convergences in soa bisection:', pfc
!        Call m3warn( pname, 0, 0, xmsg )
!        pfc = 0
!     End If

C *** If last call this hour, write visibility information.
      IF ( WRITETIME ) THEN
         MDATE = JDATE
         MTIME = JTIME
         CALL NEXTIME ( MDATE, MTIME, TSTEP( 2 ) )
         WSTEP = 0
         WRITETIME = .FALSE.

#ifdef parallel_io
         IF ( FIRST_CTM_PMDIAG_1 ) THEN
            FIRST_CTM_PMDIAG_1 = .FALSE.
            IF ( PMDIAG ) THEN
               IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_PMDIAG_1, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM( CTM_PMDIAG_1 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF
            END IF
            IF ( APMDIAG ) THEN
               IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_APMDIAG_1, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM( CTM_APMDIAG_1 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF
            END IF
         END IF
#endif

C *** Write data to the aerosol diagnostic file.
         IF ( PMDIAG ) THEN

            IF ( .NOT. WRITE3( CTM_PMDIAG_1, ALLVAR3,
     &                         MDATE, MTIME, PMDIAG_SPC ) ) THEN
               XMSG = 'Could not write ' // CTM_PMDIAG_1 // ' file'
               CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            END IF

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &                     'Timestep written to', CTM_PMDIAG_1,
     &                     'for date and time', MDATE, MTIME

         END IF
     
         IF ( APMDIAG ) THEN
            IF ( .NOT. END_TIME ) THEN   ! ending time timestamp
               CALL NEXTIME ( MDATE, MTIME, -TSTEP(1) )
            END IF
         END IF

C *** Write data to the average aerosol diagnostic file.
         IF ( APMDIAG ) THEN

            DO V = 1, NUM_PMDIAG_SPC
 
               IF ( A_PMDIAG_SPC_MAP( V ) .EQ. 1 ) THEN
                  A_PMDIAG_SPC( :,:,:,V ) = A_PMDIAG_SPC( :,:,:,V ) / N_APMDIAG_STEP 

                  IF ( .NOT. WRITE3( CTM_APMDIAG_1, PMDIAG_SPC_RECORD( V )%SPC_NAME,
     &                               MDATE, MTIME, A_PMDIAG_SPC( :,:,:,V ) ) ) THEN
                     XMSG = 'Could not write ' // CTM_APMDIAG_1 // ' file'
                     CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
                  END IF
                  A_PMDIAG_SPC( :,:,:,V ) = 0.0
               END IF
            END DO

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &                     'Timestep written to', CTM_APMDIAG_1,
     &                     'for date and time', MDATE, MTIME

            N_APMDIAG_STEP = 0
         END IF
     
      END IF   ! WRITETIME

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker] 
C $Header: /project/work/rep/PARIO/src/pio_re_init.f,v 1.6 2011/03/30 18:13:02 sjr Exp $

      LOGICAL FUNCTION PIO_INIT ( COLROW, GL_NCOLS, GL_NROWS, NLAYS,
     &                            NTHIK, NCOLS, NROWS, NPCOL, NPROW,
     &                            NPROCS, MYPE, WFLG, IO_PE_INCLUSIVE )
C ....................................................................
 
C  PURPOSE:    Initialize parallel Models-3 I/O API library routines.
C              This includes starting up the I/O API and calculating
C              processor-to-subdomain maps.
 
C  RETURN VALUE: The function as written always returns a value of TRUE.
C       (i.e., this could have been written as a subroutine, but is
C       written as a FUNCTION in the anticipation that failure conditions
C       will be added.) If subroutine ALLOINT a non-zero error code,
C       M3WARN is called and execution is terminated. Subroutine
C       SUBDMAP will also terminate program execution if an error is
C       detected during memory allocation.
 
C  REVISION HISTORY: 
C       Original version  2/96 by Al Bourgeois for parallel implementation
C       Modified 6/98 by AJB for PAR_IO library, added error code
C       Modified 07/08/1998 by AJB to set IO_GRP and MY_IO_PE
C       Modified 07/29/1998 by AJB to allow setting of NPROW, NPCOL outside
C                Also added synchronization of return code across processors
C       Modified 08/25/1998 to remove MPI initialization, and to pass in
C                grid decomposition variables through the argument list
C       Modified 12/07/1998 by Al Bourgeois to add EXTERNAL declarations
C       Modified 01/26/1999 by Al Bourgeois to allocate memory for write maps
C       Modified 06/16/1999 by Al Bourgeois to remove interprocessor
C          synchronization. This removes the guarantee that all processors
C          return the same error code, and a "hang" state can occur if
C          PM3EXIT is not called on the condition that this function fails
C       Modified 08/06/1999 by Al Bourgeois to simplify error handling
C                12 Apr 2001 by J. Young to eliminate I/O processors
C       Modified 02/06/2004 by David Wong
C          -- uses f90 syntax to allocate memory to avoid using DYNMEM
C             library
C       Modified 08/26/2004 by David Wong
C          -- added a statement to check whether allocated memory is already
C             exist
C                01/07/2006 Jeff Young, add arg list flag to optionally print
C                decomposition map
C       Modified 02/23/2011 by Shawn Roselle
C          -- Replaced I/O API include files with M3UTILIO
C       Modified 12/05/2015 by David Wong
C          -- Initialized PIO_GL_NCOLS and PIO_GL_NROWS
C       Modified 12/09/2015 by David Wong
C          -- Added an optional argument in PIO_RE_INIT routine
C       Modified 01/26/2016 by Jeff Young
C          -- Change WFLG to an optional argument and make PIO_RE_INIT the only
C             PIO_INIT routine
 
C  ARGUMENT LIST DESCRIPTION:
C  IN:
C     CHARACTER( 2 ) :: COLROW   ! Columns/Rows orientation check
C     INTEGER GL_NCOLS           ! Number of columns in entire grid
C     INTEGER GL_NROWS           ! Number of rows in entire grid
C     INTEGER NLAYS              ! Number of layers in entire grid
C     INTEGER NTHIK              ! Cell thickness of grid boundary
C     INTEGER NPCOL              ! Number of processors across grid columns
C     INTEGER NPROW              ! Number of processors across grid rows
C     INTEGER NCOLS              ! Column dimension of local-processor arrays
C     INTEGER NROWS              ! Row dimension of local-processor arrays
C     INTEGER NPROCS             ! Number of processors
C     INTEGER MYPE               ! Local processor id
C     LOGICAL WFLG               ! If present print out decompostion map
C     LOGICAL IO_PE_INCLUSIVE    ! If present
 
C  OUT:
C   COMMON BLOCK PIOGRID:
C     INTEGER  NPCOLD            ! Number of processors across grid columns
C     INTEGER  NPROWD            ! Number of processors across grid rows
C     INTEGER  GNCOLS            ! Number of columns in global grid
C     INTEGER  GNROWS            ! Number of rows in global grid
C     INTEGER  BTHICK            ! Cell thickness of grid boundary
C     INTEGER  NUMCOLS           ! Column dimension of local-processor arrays
C     INTEGER  NUMROWS           ! Row dimension of local-processor arrays
C     INTEGER  MY_NCOLS          ! Local number of grid columns
C     INTEGER  MY_NROWS          ! Local number of grid rows
C     INTEGER  MAXCELLS          ! Maximum subdomain size over PEs
C     INTEGER  NGB_PE(8)         ! PE neighborhood, first north then clockwise
 
C   COMMON BLOCK PIOVARS:
C     INTEGER  MY_PE             ! Local processor id
C     INTEGER  IO_PE             ! Id of processor used for file I/O
 
C   COMMON BLOCK PIOMAPS:
C     INTEGER  NUMPROCS             ! Number of processors
C     INTEGER  NCOLS_PE(NUMPROCS)   ! Number columns in each processor
C     INTEGER  NROWS_PE(NUMPROCS)   ! Number rows in each processor
C     INTEGER  COLSX_PE(2,NUMPROCS) ! Column range for each PE
C     INTEGER  ROWSX_PE(2,NUMPROCS) ! Row range for each PE
         
C  LOCAL VARIABLE DESCRIPTION:  see below
 
C  CALLS:  SUBDMAP, WRSUBDMAP, ALLOINT, SETINT, M3WARN
 
C  NOTES: Uses dynamic memory allocation for processor-to-subdomain
C    maps NROWS_PE, ROWSX_PE, NCOLS_PE, and COLSX_PE
 
C    To hide parallelism, domain decomposition information is maintained
C    via COMMON blocks instead of subroutine arguments.
 
C    The group-I/O flag, IO_GRP, determines if a processor will partici-
C    pate in file reading operations. This depends on the arrangement
C    of processors distributed across grid rows (NPROW). The following
C    diagram shows the situation for an example subdomain layout. In the
C    example, IO_GRP would be set to 1 on PE 0 and PE 4, and set to 0 on
C    all other PEs.
 
C                                                    NPCOL
C  Example subdomain layout         _____________________________________
C  for 8 processors with           |         |         |        |        |
C  NPROW=2, NPCOL=4                | I/O     |         |        |        |
C                                  |    4    |    5    |    6   |    7   |
C  PE 0 will read                  |         |         |        |        |
C  for PEs 0,1,2,3          NPROW  |_________|_________|________|________|
C                                  |         |         |        |        |
C  PE 4 will read                  | I/O     |         |        |        |
C  for PEs 4,5,6,7                 |    0    |    1    |    2   |    3   |
C                                  |         |         |        |        |
C                                  |         |         |        |        |
C                                  |_________|_________|________|________|
 
C .......................................................................

      USE PIOMAPS_MODULE
      USE M3UTILIO              ! i/o api

      IMPLICIT  NONE

C INCLUDE FILES

      INCLUDE 'PIOGRID.EXT'      ! Parallel grid dimensions
      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation
!     INCLUDE 'PIOMAPS.EXT'      ! Parallel processor-to-subdomain maps

C ARGUMENTS:

      CHARACTER( 2 ), INTENT( INOUT ) :: COLROW  ! Columns/Rows orientation check
      INTEGER, INTENT( IN ) :: GL_NCOLS ! Number of columns in entire grid
      INTEGER, INTENT( IN ) :: GL_NROWS ! Number of rows in entire grid
      INTEGER, INTENT( IN ) :: NLAYS    ! Number of layers in entire grid
      INTEGER, INTENT( IN ) :: NTHIK    ! Cell thickness of grid boundary
      INTEGER, INTENT( IN ) :: NPCOL    ! Number of processors across grid cols
      INTEGER, INTENT( IN ) :: NPROW    ! Number of processors across grid rows
      INTEGER, INTENT( IN ) :: NCOLS    ! Col dimension of local-processor arrays
      INTEGER, INTENT( IN ) :: NROWS    ! Row dimension of local-processor arrays
      INTEGER, INTENT( IN ) :: NPROCS   ! Number of processors
      INTEGER, INTENT( IN ) :: MYPE     ! Local processor id
      LOGICAL, INTENT( IN ), OPTIONAL :: WFLG  ! If present print out decomposition map
      LOGICAL, INTENT( IN ), OPTIONAL :: IO_PE_INCLUSIVE

C EXTERNAL FUNCTIONS:

      EXTERNAL      SUBDMAP, WRSUBDMAP  ! Parallel M3IO library

C LOCAL VARIABLES: 

      INTEGER I                  ! Loop index
      INTEGER J                  ! Loop index
      INTEGER LOCI               ! Row index of MYPE in Cartesian coordinate
      INTEGER LOCJ               ! Col. index of MYPE in Cartesian coordinate
      INTEGER POS                ! Index into neighborhood conversion table
      INTEGER CONV( 8 )          ! Processor neighborhood conversion table
      INTEGER IERROR             ! Error code
      INTEGER LOGDEV             ! FORTRAN unit number for log file
      CHARACTER( 80 ) :: MSG     ! For message issued from M3WARN
      CHARACTER( 16 ), SAVE :: PNAME = 'PIO_INIT'

C   Equivalence of the conversion table:
C
C   (LOCI+1, LOCJ-1) (LOCI+1, LOCJ) (LOCI+1, LOCJ+1)                8  1  2
C   ( LOCI,  LOCJ-1) ( LOCI,  LOCJ) ( LOCI,  LOCJ+1) equivalent to  7     3
C   (LOCI-1, LOCJ-1) (LOCI-1, LOCJ) (LOCI-1, LOCJ+1)                6  5  4
      DATA CONV / 8, 1, 2, 7, 3, 6, 5, 4 /

C .......................................................................

C Initialize return value and error code
      CALL UPCASE ( COLROW )
      IF ( COLROW .eq. 'CR' ) THEN
         PIO_INIT = .TRUE.
      ELSE
         MSG = 'Argument list must have cols/rows orientation.'
         CALL M3WARN( PNAME, 0, 0, MSG )
         PIO_INIT = .FALSE.; RETURN
      END IF
      IERROR = 0

C Set COMMON block variables.
      NUMPROCS = NPROCS      ! Number of processors                      A
      MY_PE    = MYPE        ! Local processor id                        B
      IO_PE    = 0           ! I/O processor id                          B
      NPCOLD   = NPCOL       ! Number of processors across grid columns  C
      NPROWD   = NPROW       ! Number of processors across grid rows     C
      GNCOLS   = GL_NCOLS    ! Number of columns in global grid          C
      GNROWS   = GL_NROWS    ! Number of rows in global grid             C
      GNLAYS   = NLAYS       ! Number of layers in global grid           C
      BTHICK   = NTHIK       ! Cell thickness of grid boundary           C
      NUMCOLS  = NCOLS       ! Number of columns in local subgrid        C
      NUMROWS  = NROWS       ! Number of rows in local subgrid           C
      PIO_GL_NCOLS = GL_NCOLS  ! Number of columns in global grid        C
      PIO_GL_NROWS = GL_NROWS  ! Number of rows in global grid           C
C A - PIOMAPS_MODULE
C B - PIOVARS.EXT
C C - PIOGRID.EXT

C set flag in PIOMAPS_MODULE for PSHUT3

      IF ( PRESENT( IO_PE_INCLUSIVE ) ) THEN
         PARIO_IO_PE_INCLUSIVE = IO_PE_INCLUSIVE
      END IF

C Compute processor neighborhood

      LOCI = MY_PE / NPCOL
      LOCJ = MOD ( MY_PE, NPCOL )
      POS = 0
      DO I = LOCI+1, LOCI-1, -1
         DO J = LOCJ-1, LOCJ+1
            IF ( ( I .NE. LOCI ) .OR. ( J .NE. LOCJ ) ) THEN
               POS = POS + 1
               IF ( ( I .GE. 0 )     .AND.
     &              ( I .LT. NPROW ) .AND.
     &              ( J .GE. 0 )     .AND.
     &              ( J .LT. NPCOL ) ) THEN
                  NGB_PE( CONV( POS ) ) = I * NPCOL + J
               ELSE
                  NGB_PE( CONV( POS ) ) = -1
               END IF
            END IF
         END DO
      END DO

C Allocate memory for processor-to-subdomain maps

      IF ( .NOT. ALLOCATED ( NCOLS_PE ) ) THEN
         ALLOCATE ( NCOLS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating NCOLS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( NROWS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating NROWS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( COLSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating COLSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( ROWSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating ROWSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

C Allocate memory for processor-to-subdomain write maps

         ALLOCATE ( WR_NCOLS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_NCOLS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( WR_NROWS_PE( NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_NROWS_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( WR_COLSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_COLSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

         ALLOCATE ( WR_ROWSX_PE( 2,NUMPROCS ), STAT = IERROR )
         IF ( IERROR .NE. 0 ) THEN
            MSG = 'Error allocating WR_ROWSX_PE.'
            CALL M3WARN( PNAME, 0, 0, MSG )
            PIO_INIT = .FALSE.; RETURN
         END IF

      END IF

C Calculate processor-to-subdomain maps

      CALL SUBDMAP ( NUMPROCS, GL_NCOLS, GL_NROWS, NLAYS, NPCOL, NPROW,
     &               NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE,
     &               MAXCELLS, IERROR )
      IF ( IERROR .NE. 0 ) THEN
         MSG = 'Error in SUBDMAP'
         CALL M3WARN( PNAME, 0, 0, MSG )
         PIO_INIT = .FALSE.; RETURN
      END IF

C Write out processor-to-subdomain map

      IF ( MY_PE .EQ. IO_PE ) THEN
         IF ( PRESENT( WFLG ) )
     &      CALL WRSUBDMAP ( NUMPROCS, NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE )
      END IF

C Set number of rows and columns for (this) local processor

      MY_NCOLS = NCOLS_PE( MY_PE+1 )   ! COMMON block
      MY_NROWS = NROWS_PE( MY_PE+1 )   ! COMMON block

      RETURN
      END FUNCTION PIO_INIT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/cloud/cloud_acm_ae5/scavwdep.F,v 1.7 2011/10/21 16:10:28 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                      CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                      REMOV, REMOVAC, ALFA0, ALFA2, ALFA3 )
C-----------------------------------------------------------------------
C  Description: Compute simplistic incloud scavenging and wet removal
 
C  Revision History:
C      No   Date   Who  What
C      -- -------- ---  -----------------------------------------
C       0 01/15/98 sjr  created program
C       1 07/27/99 sjr  added scavenging coefficient scaling factors
C       3 Dec 00   Jeff move CGRID_MAP into f90 module
C       4 Dec 02   sjr  revised calls to HLCONST
C       5 Jun 10   J.Young: convert for Namelist redesign
C       6 Mar 11   S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                       removed deprecated TRIMLEN
C       6 Mar 11   B.Hutzell: added TRACER string for AE_SPCs to omit while
C                       computing Aitken mode mass
C    1 Dec 15 S.L.Napelenok:  ddm-3d implementaiton for version 5.1.1
 
C  Called by:  RADMCLD and RESCLD
 
C  Calls the following subroutines:  GETALPHA
 
C  Calls the following functions:  HLCONST
 
C  Arguments    Type      I/O       Description
C  ---------   -------  ------  --------------------------------
C    JDATE     integer   input  current model julian date (yyyyddd)
C    JTIME     integer   input  current model time (hhmmss)
C    WTBAR      real     input  avg total water content (kg/m3)
C    WCBAR      real     input  avg liquid water content (kg/m3)
C    TBARC      real     input  avg cloud temperature (K)
C    PBARC      real     input  avg cloud pressure (Pa)
C    CTHK1      real     input  cloud thickness (m)
C    AIRM       real     input  total air mass (moles/m2) in cloudy air
C    PRATE1     real     input  precipitation rate (mm/hr)
C    TAUCLD     real     input  cloud lifetime (s)
C    POLC       real     input  ave vert conc incloud (moles sp/ mole air)
C    CEND       real    output  ending incloud conc (moles/mole)
C    REMOV      real    output  moles/m2 or mm*mol/lit scavenged
C    REMOVAC    real    output  variable storing H+ deposition
C    ALFA0      real    output  scav coef for aitken aerosol number
C    ALFA2      real    output  scav coef for aitken mode sfc area
C    ALFA3      real    output  scav coef for aitken aerosol mass
 
C-----------------------------------------------------------------------

      USE CGRID_SPCS                    ! CGRID mechanism species
      USE UTILIO_DEFN

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_POLC, S_CEND, S_REMOV, S_REMOVAC
#endif 

      IMPLICIT NONE

C...........Includes:

      INCLUDE SUBST_CONST               ! constants

      CHARACTER( 120 ) :: XMSG = ' '    ! Exit status message

C...........Parameters:

      REAL, PARAMETER :: H2ODENS = 1000.0  ! density of water at 20 C
                                           ! and 1 ATM (kg/m3)

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS

C Number of species scavenged
      INTEGER, SAVE :: N_CGRID_SCAV

      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0

      REAL, PARAMETER :: KGPG = 1.0E-03   ! kilograms per gram

C...........Arguments:

      INTEGER, INTENT(  IN ) :: JDATE   ! current model date, coded YYYYDDD
      INTEGER, INTENT(  IN ) :: JTIME   ! current model time, coded HHMMSS
      REAL,    INTENT(  IN ) :: WTBAR   ! total wat cont (kg/m2) int. thru cloud depth
      REAL,    INTENT(  IN ) :: WCBAR   ! liq water content of cloud (kg/m3)
      REAL,    INTENT(  IN ) :: TBARC   ! mean cloud temp (K)
      REAL,    INTENT(  IN ) :: PBARC   ! mean cloud pressure (Pa)
      REAL,    INTENT(  IN ) :: CTHK1   ! aq chem calc cloud thickness
      REAL,    INTENT(  IN ) :: AIRM    ! total air mass (moles/m2) in cloudy air
      REAL,    INTENT(  IN ) :: PRATE1  ! storm rainfall rate (mm/hr)
      REAL,    INTENT(  IN ) :: TAUCLD  ! cloud lifetime
      REAL,    INTENT( OUT ) :: ALFA0   ! scav coef for aitken aerosol number
      REAL,    INTENT( OUT ) :: ALFA2   ! scav coef for aitken aerosol sfc area
      REAL,    INTENT( OUT ) :: ALFA3   ! scav coef for aitken aerosol mass
      REAL,    INTENT( OUT ) :: REMOVAC ! variable storing H+ deposition
      REAL,    INTENT(  IN ) :: POLC ( : )  ! avg vert conc incloud (moles/mole)
      REAL,    INTENT( OUT ) :: CEND ( : )  ! ending incloud conc (moles/mole)
      REAL,    INTENT( OUT ) :: REMOV( : )  ! moles/m2 or mm*mol/lit scavenged

C...........Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.   ! flag for first pass thru
      CHARACTER( 16 ), SAVE :: PNAME = 'SCAVWDEP'  ! program name

      CHARACTER( 16 ), ALLOCATABLE, SAVE :: CGRID_SCAV( : )  ! CGRID species scavenged
      INTEGER, ALLOCATABLE, SAVE :: CGRID_SCAV_MAP( : ) ! CGRID map to scavenged spc
      REAL, ALLOCATABLE,    SAVE :: CGRID_SCAV_FAC( : )  ! CGRID scav coef factors
      INTEGER, ALLOCATABLE, SAVE :: L_NUMAKN( : ) ! pointers to aitken aerosol #
      INTEGER, ALLOCATABLE, SAVE :: L_MASAKN( : ) ! pointers to aitken aerosols
      INTEGER, ALLOCATABLE, SAVE :: L_SRFAKN( : ) ! pntrs to aitken aerosol surface area
      INTEGER ASTAT

      INTEGER       I
      INTEGER, SAVE :: N_NUMAKN            ! # aitken aerosol number species
      INTEGER, SAVE :: N_MASAKN            ! # aitken aerosol mass species
      INTEGER, SAVE :: N_SRFAKN            ! # aitken aerosol sfc area species
      INTEGER       PNTR                ! relative pointer variable
      INTEGER       SPC                 ! liquid species loop counter
      INTEGER       VAR                 ! variable loop counter

      REAL          ALFA                ! scavenging coefficient (1/s)
      REAL          KH                  ! Henry's law constant (mol/l/atm)
      REAL          NUMAKN              ! Aitken mode aerosol # (#/m3)
      REAL          MASAKN              ! Total Aitken mode mass (ug/m3)
      REAL          SRFAKN
      REAL          ONE_OVER_TWASH      ! 1 / TWASH
      REAL,    SAVE :: HPLUS = 1.0E-4   ! typical value hydrogen ion concentration [mol/l]
      REAL          RHOAIR              ! air density in kg/m3
      REAL          RTCH                ! chemical gas const times temp
      REAL          TWASH               ! washout time for clouds (sec) with low liq wat content
      REAL          TWF                 ! washout scaling factor (mol/l/atm)

C...........External Functions:

      INTEGER, EXTERNAL :: INDEXN
      REAL,    EXTERNAL :: HLCONST

C-----------------------------------------------------------------------

C...INITIALIZATION SCAVWDEP module:
C...  event-statistics variables.  Open output files.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

        N_CGRID_SCAV = N_GC_SCAV + N_AE_SCAV + N_NR_SCAV + N_TR_SCAV

C...first check to make sure that some species in CGRID were specified
C...  for scavenging, otherwise notify the user and return

        IF ( N_CGRID_SCAV .LE. 0 ) THEN
          XMSG = 'No species were specified for scavenging by cloud ' //
     &           'or rain water...SCAVENGING WILL NOT BE PERFORMED!'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
          RETURN
        END IF

        ALLOCATE ( CGRID_SCAV    ( N_CGRID_SCAV ),
     &             CGRID_SCAV_MAP( N_CGRID_SCAV ),
     &             CGRID_SCAV_FAC( N_CGRID_SCAV ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CGRID_SCAV, CGRID_SCAV_MAP or CGRID_SCAV_FAC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        MXSPCS = N_GC_SPCD + N_AE_SPC + N_NR_SPC + N_TR_SPC

        ALLOCATE ( L_NUMAKN( MXSPCS ),
     &             L_MASAKN( MXSPCS ),
     &             L_SRFAKN( MXSPCS ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating L_NUMAKN, L_MASAKN or L_SRFAKN'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

C...prepare indices for scavenged species

C...  load the CGRID to scavenged species pointers for the gases

        SPC = 0
        DO VAR=1, N_GC_SCAV
          SPC = SPC + 1
          CGRID_SCAV( SPC ) = GC_SCAV( VAR )
          CGRID_SCAV_MAP( SPC ) = GC_SCAV_MAP( VAR ) + GC_STRT - 1
          CGRID_SCAV_FAC( SPC ) = GC_SCAV_FAC( VAR )
        END DO

C...  load the CGRID to scavenged species pointers for the aerosols

        DO VAR=1, N_AE_SCAV
          SPC = SPC + 1
          CGRID_SCAV( SPC ) = AE_SCAV( VAR )
          CGRID_SCAV_MAP( SPC ) = AE_SCAV_MAP( VAR ) + AE_STRT - 1
          CGRID_SCAV_FAC( SPC ) = AE_SCAV_FAC( VAR )
        END DO

C...  load the CGRID to scavenged species pointers for the non-reactives

        DO VAR=1, N_NR_SCAV
          SPC = SPC + 1
          CGRID_SCAV( SPC ) = NR_SCAV( VAR )
          CGRID_SCAV_MAP( SPC ) = NR_SCAV_MAP( VAR ) + NR_STRT - 1
          CGRID_SCAV_FAC( SPC ) = NR_SCAV_FAC( VAR )
        END DO

C...  load the CGRID to scavenged species pointers for the tracers

        DO VAR=1, N_TR_SCAV
          SPC = SPC + 1
          CGRID_SCAV( SPC ) = TR_SCAV( VAR )
          CGRID_SCAV_MAP( SPC ) = TR_SCAV_MAP( VAR ) + TR_STRT - 1
          CGRID_SCAV_FAC( SPC ) = TR_SCAV_FAC( VAR )
        END DO

C...create the pointers from CGRID to the species needed by AQCHEM

        N_NUMAKN = INDEXN( 'NUM_AITKEN      ', N_CGRID_SCAV, CGRID_SCAV,
     &                     L_NUMAKN )
        N_MASAKN = INDEXN( 'AITKEN', N_CGRID_SCAV, CGRID_SCAV, L_MASAKN )
        N_SRFAKN = INDEXN( 'SRF_AITKEN      ', N_CGRID_SCAV, CGRID_SCAV,
     &                     L_SRFAKN )

      END IF

C...for subsequent calls, check to make sure some species were
C...  specified, otherwise there is no need to perform scavenging

      IF ( N_CGRID_SCAV .LE. 0 ) THEN
        RETURN
      END IF

      RTCH = ( MOLVOL / STDTEMP ) * TBARC
      TWASH = WTBAR * 1000.0 * CTHK1 * 3600.0
     &      / ( H2ODENS * AMAX1( 1.0E-20, PRATE1 ) )
ccc          TWASH = AMAX1( TWASH, TAUCLD / 60.0 )   ! <different units?sec&min
      TWASH = AMAX1( TWASH, TAUCLD )
      ONE_OVER_TWASH = 1.0 / TWASH
      TWF = H2ODENS / ( WTBAR * RTCH )
      REMOVAC = 0.0

#ifdef sens
      S_REMOVAC = 0.0
#endif

      RHOAIR = ( AIRM / CTHK1 ) * MWAIR * KGPG

C...compute total Aitken mode number (#/m3)

      NUMAKN = 0.0

      DO I = 1, N_NUMAKN
        PNTR = CGRID_SCAV_MAP( L_NUMAKN( I ) )
        NUMAKN = NUMAKN + ( POLC( PNTR ) * AIRM / CTHK1 )
      END DO

C...compute total Aitken mode mass (ug/m3)

      MASAKN = 0.0

      DO I = 1, N_MASAKN
        PNTR = CGRID_SCAV_MAP( L_MASAKN( I ) )
        IF (( INDEX( CGRID_SCAV( L_MASAKN( I ) ), 'NUM' ) .EQ. 0 ) .AND.
     &      ( INDEX( CGRID_SCAV( L_MASAKN( I ) ), 'SRF' ) .EQ. 0 ) .AND.
     &      ( INDEX( CGRID_SCAV( L_MASAKN( I ) ), 'H2O' ) .EQ. 0 ) .AND.
     &      ( INDEX( CGRID_SCAV( L_MASAKN( I ) ), 'TRACER' ) .EQ. 0 ) ) THEN
          MASAKN = MASAKN + ( POLC( PNTR ) * AIRM / CTHK1
     &           * AE_MOLWT( PNTR - AE_STRT + 1 ) * 1.0E6 )
        END IF
      END DO

C...compute total Aitken mode surface area (m2/m3)

      SRFAKN = 0.0

      DO I = 1, N_SRFAKN
        PNTR = CGRID_SCAV_MAP( L_SRFAKN( I ) )
        SRFAKN = SRFAKN + ( POLC( PNTR ) * AIRM / CTHK1 )
      END DO

C...compute the scavenging coefficients for aitken mode aerosol mass
C...  and number
C...  NOTE:  for now, scavenging coefficients are computed for only
C...         the liquid water content, not on the total water content
C...         therefore, no ice phase scavenging is considered at this
C...         time, but it should be added in the future!

      CALL GETALPHA ( NUMAKN, MASAKN, SRFAKN, WCBAR, TBARC, PBARC,
     &                RHOAIR, ALFA0, ALFA2, ALFA3 )

C...gas scavenging and wet deposition

      SPC = 0

      DO VAR = 1, N_GC_SCAV
        SPC = SPC + 1
        PNTR = CGRID_SCAV_MAP( SPC )
        KH = HLCONST( CGRID_SCAV( SPC ), TBARC, .TRUE., HPLUS )
        IF ( KH .GT. 0.0 ) THEN
          ALFA = CGRID_SCAV_FAC( SPC ) * ONE_OVER_TWASH / ( 1.0 + TWF / KH )
          CEND ( PNTR ) = POLC( PNTR ) * EXP( -ALFA * TAUCLD )
          REMOV( PNTR ) = ( POLC( PNTR ) - CEND( PNTR ) ) * AIRM
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND ( NP, PNTR ) = S_POLC( NP, PNTR ) * EXP( -ALFA * TAUCLD )
            S_REMOV( NP, PNTR ) = ( S_POLC( NP, PNTR ) - S_CEND( NP, PNTR ) ) * AIRM
          END DO
#endif
        ELSE
          ALFA = 0.0
          CEND ( PNTR ) = POLC( PNTR )
          REMOV( PNTR ) = 0.0
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND( NP, PNTR )  = S_POLC( NP, PNTR )
            S_REMOV( NP, PNTR ) = 0.0
          END DO
#endif
        END IF
      END DO

C...aerosol scavenging and wet deposition

      DO VAR = 1, N_AE_SCAV
        SPC = SPC + 1

        PNTR = CGRID_SCAV_MAP( SPC )

        IF ( INDEX( CGRID_SCAV( SPC ), 'AITKEN' ) .GT. 0 ) THEN
          IF ( INDEX( CGRID_SCAV( SPC ), 'NUM' ) .GT. 0 ) THEN
            ALFA = CGRID_SCAV_FAC( SPC ) * ALFA0
          ELSE IF ( INDEX( CGRID_SCAV( SPC ), 'SRF' ) .GT. 0 ) THEN
            ALFA = CGRID_SCAV_FAC( SPC ) * ALFA2
          ELSE
            ALFA = CGRID_SCAV_FAC( SPC ) * ALFA3
          END IF
        ELSE
csjr          IF ( INDEX( CGRID_SCAV( SPC ), 'SRF' ) .EQ. 0 ) THEN
            ALFA = CGRID_SCAV_FAC( SPC ) * ONE_OVER_TWASH
csjr          ELSE
csjr            ALFA = CGRID_SCAV_FAC( SPC ) * TWOTHIRDS * ONE_OVER_TWASH
csjr          END IF
        END IF

        CEND ( PNTR ) = POLC( PNTR ) * EXP( -ALFA * TAUCLD )
        REMOV( PNTR ) = ( POLC( PNTR ) - CEND( PNTR ) ) * AIRM

#ifdef sens
        DO NP = 1, NPMAX
          S_CEND ( NP,PNTR ) = S_POLC( NP,PNTR ) * EXP( -ALFA * TAUCLD )
          S_REMOV( NP,PNTR ) = ( S_POLC( NP,PNTR ) - S_CEND( NP, PNTR ) ) * AIRM
        ENDDO
#endif

      END DO

C...non-reactive scavenging and wet deposition

      DO VAR = 1, N_NR_SCAV
        SPC = SPC + 1
        PNTR = CGRID_SCAV_MAP( SPC )
        KH = HLCONST( CGRID_SCAV( SPC ), TBARC, .TRUE., HPLUS )
        IF ( KH .GT. 0.0 ) THEN
          ALFA = CGRID_SCAV_FAC( SPC ) * ONE_OVER_TWASH / ( 1.0 + TWF / KH )
          CEND ( PNTR ) = POLC( PNTR ) * EXP( -ALFA * TAUCLD )
          REMOV( PNTR ) = ( POLC( PNTR ) - CEND( PNTR ) ) * AIRM
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND ( NP, PNTR ) = S_POLC( NP,PNTR ) * EXP( -ALFA * TAUCLD )
            S_REMOV( NP, PNTR ) = ( S_POLC( NP,PNTR ) - S_CEND( NP, PNTR ) ) * AIRM
          END DO
#endif
        ELSE
          ALFA = 0.0
          CEND ( PNTR ) = POLC( PNTR )
          REMOV( PNTR ) = 0.0
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND( NP, PNTR )  = S_POLC( NP, PNTR )
            S_REMOV( NP, PNTR ) = 0.0
          END DO
#endif
        END IF
      END DO

C...tracer scavenging and wet deposition

      DO VAR = 1, N_TR_SCAV
        SPC = SPC + 1
        PNTR = CGRID_SCAV_MAP( SPC )
        KH = HLCONST( CGRID_SCAV( SPC ), TBARC, .TRUE., HPLUS )
        IF ( KH .GT. 0.0 ) THEN
          ALFA = CGRID_SCAV_FAC( SPC ) * ONE_OVER_TWASH / ( 1.0 + TWF / KH )
          CEND ( PNTR ) = POLC( PNTR ) * EXP( -ALFA * TAUCLD )
          REMOV( PNTR ) = ( POLC( PNTR ) - CEND( PNTR ) ) * AIRM
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND ( NP, PNTR ) = S_POLC( NP,PNTR ) * EXP( -ALFA * TAUCLD )
            S_REMOV( NP, PNTR ) = ( S_POLC( NP,PNTR ) - S_CEND( NP, PNTR ) ) * AIRM
          END DO
#endif
        ELSE
          ALFA = 0.0
          CEND ( PNTR ) = POLC( PNTR )
          REMOV( PNTR ) = 0.0
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND( NP, PNTR )  = S_POLC( NP, PNTR )
            S_REMOV( NP, PNTR ) = 0.0
          END DO
#endif
        END IF
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_CGRID ( CGRID, JDATE, JTIME, TSTEP )

C Save the instantaneous state of CGRID in an I/O-API "circular buffer"
C file to use for restart/continuation for subsequent simulation. This
C file will replace the CONC file for such use, allowing users to reduce
C the number of variables and/or layers saved to the CONC file.

C Revision History:
C      May 06 J.Young: initial
C      Feb 08 J.Young: fix VDESC3D bug
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   12 Aug 15 D.Wong:  Replaced MYPE with IO_PE_INCLUSIVE and added code
C                        to handle parallel I/O implementation
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! file name parameters

      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'WR_CGRID'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER K, MXK, SPC, VAR
      INTEGER ALLOCSTAT

      INTEGER TSTEP_RF, NTHIK_RF, NCOLS_RF, NROWS_RF, GDTYP_RF
      REAL( 8 ) :: P_ALP_RF, P_BET_RF, P_GAM_RF
      REAL( 8 ) :: XCENT_RF, YCENT_RF
      REAL( 8 ) :: XORIG_RF, YORIG_RF
      REAL( 8 ) :: XCELL_RF, YCELL_RF
      INTEGER VGTYP_RF
      REAL VGTOP_RF

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL OK

      LOGICAL, EXTERNAL :: FLUSH3

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

C Try to open existing file for update

         CALL SUBST_BARRIER

         OK = OPEN3( S_CGRID, FSRDWR3, PNAME )
         CALL SUBST_GLOBAL_LOGICAL( OK, 'AND' )
         IF ( .NOT. OK ) THEN

            XMSG = 'Could not open ' // TRIM( S_CGRID )
     &           // ' file for update - try to open new'
            CALL M3MESG( XMSG )

            IF ( IO_PE_INCLUSIVE ) THEN

C Get default file header attibutes from CONC file (assumes file already open)

               IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( CTM_CONC_1 )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

C Set tstep negative to create "circular buffer" type file

!              TSTEP3D = -TSTEP
               SDATE3D = JDATE
               STIME3D = JTIME

C Get CGRID nvars

               NVARS3D = NSPCSD
               NLAYS3D = NLAYS

C Set file header attributes that differ from CONC and open the file

               FDESC3D = ' '
               FDESC3D( 1 ) = 'Computational grid instantaneous concentrations'
               FDESC3D( 2 ) = '- for scenario continuation.'

               WRITE( LOGDEV,* ) ' '
               WRITE( LOGDEV,* ) '       State CGRID File Header Description:'
               DO K = 1, 2
                  WRITE( LOGDEV,* ) '    => ',
     &            TRIM( FDESC3D( K ) )
               END DO

               VAR = 0

               DO SPC = 1, N_GC_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = GC_SPC( SPC )
                  UNITS3D( VAR ) = 'ppmV'
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

C pick up transported RHOJ

               VAR = VAR + 1
               VTYPE3D( VAR ) = M3REAL
               VNAME3D( VAR ) = 'RHOJ'
               UNITS3D( VAR ) = 'm kg m-3'
               VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )

               DO SPC = 1, N_AE_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = AE_SPC( SPC )
                  IF ( VNAME3D( VAR )(1:3) .EQ. 'NUM' ) THEN
                     UNITS3D( VAR ) = 'm-3'
                  ELSE IF ( VNAME3D( VAR )(1:3) .EQ. 'SRF' ) THEN
                     UNITS3D( VAR ) = 'm2 m-3'
                  ELSE
                     UNITS3D( VAR ) = 'ug m-3'
                  END IF
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

               DO SPC = 1, N_NR_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = NR_SPC( SPC )
                  UNITS3D( VAR ) = 'ppmV'
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

               DO SPC = 1, N_TR_SPC
                  VAR = VAR + 1
                  VTYPE3D( VAR ) = M3REAL
                  VNAME3D( VAR ) = TR_SPC( SPC )
                  UNITS3D( VAR ) = 'ppmV'
                  VDESC3D( VAR ) = 'Variable ' // VNAME3D( VAR )
               END DO

               WRITE( LOGDEV,* ) ' '
               WRITE( LOGDEV,* ) '       State CGRID File Variable List:'
               DO SPC = 1, VAR
                  WRITE( LOGDEV,'( 5X, "=> VNAME3D(", I3, " ): ", A )' )
     &                   SPC, VNAME3D( SPC )
               END DO

               IF ( .NOT. OPEN3( S_CGRID, FSNEW3, PNAME ) ) THEN
                  XMSG = 'Could not open '
     &                 // TRIM( S_CGRID ) // ' file'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

            END IF   ! IO_PE_INCLUSIVE

         ELSE

C File exists. Check header data with CONC file as reference. Currently only
C proc 0 has CTM_CONC_1 open

            IF ( IO_PE_INCLUSIVE ) THEN

               IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( CTM_CONC_1 )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

               TSTEP_RF = TSTEP3D
               NTHIK_RF = NTHIK3D
               NCOLS_RF = NCOLS3D
               NROWS_RF = NROWS3D
               GDTYP_RF = GDTYP3D
               P_ALP_RF = P_ALP3D
               P_BET_RF = P_BET3D
               P_GAM_RF = P_GAM3D
               XCENT_RF = XCENT3D
               YCENT_RF = YCENT3D
               XORIG_RF = XORIG3D
               YORIG_RF = YORIG3D
               XCELL_RF = XCELL3D
               YCELL_RF = YCELL3D
               VGTYP_RF = VGTYP3D
               VGTOP_RF = VGTOP3D

               IF ( .NOT. DESC3( S_CGRID ) ) THEN
                  XMSG = 'Could not get '
     &                 // TRIM( S_CGRID )
     &                 // ' file description'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

               IF ( TSTEP_RF .NE. ABS( TSTEP3D ) .OR.
     &              NTHIK_RF .NE. NTHIK3D .OR.
     &              NCOLS_RF .NE. NCOLS3D .OR.
     &              NROWS_RF .NE. NROWS3D .OR.
     &              GDTYP_RF .NE. GDTYP3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( P_ALP_RF .NE. P_ALP3D .OR.
     &              P_BET_RF .NE. P_BET3D .OR.
     &              P_GAM_RF .NE. P_GAM3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( XCENT_RF .NE. XCENT3D .OR.
     &              YCENT_RF .NE. YCENT3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( XORIG_RF .NE. XORIG3D .OR.
     &              YORIG_RF .NE. YORIG3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( XCELL_RF .NE. XCELL3D .OR.
     &              YCELL_RF .NE. YCELL3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( VGTYP_RF .NE. VGTYP3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF
               IF ( VGTOP_RF .NE. VGTOP3D ) THEN
                    XMSG = 'Header inconsistent on existing S_CGRID'
                    CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF

            END IF   ! IO_PE_INCLUSIVE

         END IF   ! .NOT. OPEN S_CGRID

      END IF   ! FIRSTIME

#ifdef parallel_io
      IF ( IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. FLUSH3 ( S_CGRID ) ) THEN
            XMSG = 'Could not sync to disk ' // TRIM( S_CGRID )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
      CALL SUBST_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( S_CGRID, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open ' // TRIM( S_CGRID )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF

      IF ( .NOT. WRITE3( S_CGRID, ALLVAR3, JDATE, JTIME, CGRID ) ) THEN
         XMSG = 'Could not write S_CGRID'
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#else

#ifdef parallel
      IF ( .NOT. PTRWRITE3( S_CGRID, ALLVAR3, JDATE, JTIME, CGRID ) ) THEN
         XMSG = 'Could not write S_CGRID'
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#else
      IF ( .NOT. WRITE3( S_CGRID, ALLVAR3, JDATE, JTIME, CGRID ) ) THEN
         XMSG = 'Could not write S_CGRID'
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
#endif

#endif

      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', S_CGRID,
     &      'for date and time', JDATE, JTIME

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PHOT ( CGRID, JDATE, JTIME, DTSTEP )

!-----------------------------------------------------------------------
!
! Function:  Calculates the photolysis rate constant to be used by the
!     chemical solver.  It calculates these rates at each gridcell using
!     codes adapted from JPROC.  Cloud correction now called within the
!     loops over MY-ROW & MY_COLS
!
! Preconditions: HGRD_INIT() called from PAR_INIT, which is called from
!     DRIVER
!
! Subroutines/Functions called: M3EXIT, SUBHFILE, CGRID_MAP,
!     OPPHOT, LOAD_CSQY_DATA, LOAD_OPTICS_DATA, INITIALIZE_ALBEDO, 
!     GET_PHOT_MET, UPDATE_SUN, GET_ALBEDO, GET_DROPLET_OPTICS, 
!     GET_ICE_OPTICS, GET_AGGREGATE_OPTICS, CLEAR_HYDROMETEOR_OPTICS, 
!     GET_AERO_DATA, O3TOTCOL, and NEW_OPTICS, GET_ENVLIST
!
! Revision History.
!     Started 10/08/2004 with existing PHOT and JPROC coded by
!         Dr. Francis S. Binkowski
!         Carolina Environmental Program
!         University of North Carolina at Chapel Hill
!         email: frank_binkowski@unc.edu
!     August 2005, Sarav Arunachalam, CEP, UNC-CH
!       - Minor revisions while integrating with CMAQ
!       - Error check for NPHOTS added (this version works only for SAPRC-99)
!       - Added creation of new file CTM_RJ_1 to write out RJ values
!         for O3 and NO2 (both clear sky and cloud effects), and
!         ETOT_SFC, TAU_AERO, TAU_TOT and TAUO3_TOP values for 7 wavelengths
!     June 2007, David Wong
!       -- inline with CMAQ
!       - declare RJ as assumed shape array to match with the caller routine
!       - allow PE 0 only to open the output file
!       - output species: NO2_CLOUD and O3_CLOUD with AMISS value when all cells
!         are dark and JTIME_CHK = 0
!       - output species: NO2_CLOUD and O3_CLOUD with AMISS value when CLDATT is
!         0 and JTIME_CHK = 0
!     December 2007, Francis Binkowski
!         code has been modified to call the new on-line version that
!         has the cloud effects built in.  new photolysis routine to
!         replace PHOT in CMAQ
!     January 2008, Shawn Roselle
!       - reformatted for inclusion in CMAQ
!       - added additional 3-d photolysis rate diagnostic file
!       - moved code for opening the diagnostic files to a separate subroutine
!       - moved aerosol pointer evaluation to a FORTRAN module
!       - simplified code for writing the diagnostic file
!       - changed code to call NEW_OPTICS twice, once for clear sky and
!         another time for the cloudy fraction of the grid cell.  RJ's are
!         computed based on the cloud fraction weighting.
!      March 2011, Bill Hutzell
!       - enable wavelength dependent arrays to have an allocatable number
!         of wavelength bins
!       - added data structure and algorithm to compute a surface albedo that
!         depends on time and landuse catagory based on work by John Striecher
!         (AMAD/USEPA)
!       - revised writing to RJ1 file to include surface albedo
!       - moved photolysis and opacity data from CSQY module to an ASCII input
!         file
!       - added routine called LOAD_REF_DATA (inside the PHOT_MOD module) that i
!         reads this input file
!       - added call to a routine called AERO_PHOTDATA that returns opacity data
!         on the aerosol distribution
!       - revised NEW_OPTICS' arguments based on aerosol redesign in CMAQ
!         version 5.0
!     March 29, 2011 S.Roselle
!       - Replaced I/O API include files with UTILIO_DEFN
!     07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
!     26 Sep 14 B.Hutzell: 1) moved calculation of surface albedo to its own
!                             fortran module
!                          2) changed loading procedure for loading optical data;
!                             two files now used
!                          3) reading and calculation of met and geo data
!                             now acomplished by a fortran module
!                          4) changed description and accounting of cloud effects
!                             from 2D liquid water clouds to 3D resolved and subgrid
!                             clouds with multi-phases of water
!                          5) inserted calculation of aerosol optical properties via
!                             fortran module to improve efficiency in radiative
!                             transfer solution
!                          6) moved the O3TOTCOL routine from the PHOT_MOD to simplify
!                             the NEW_OPTICS routine
!                          7) Several miscellaneous changes attempting to improve efficiency
!     June 10 15 J.Young: Modified diagnostic output timestamp to fix for other than one
!                         hour time steps.
!     Aug 12, 15 D. Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O implementation
!     Feb 01, 19 David Wong: Implemented centralized I/O approach, removed all MY_N
!                            clauses

!----------------------------------------------------------------------

C...modules

      USE RXNS_DATA            ! chemistry varaibles and data
      USE GRID_CONF            ! horizontal & vertical domain specifications
      USE CGRID_SPCS           ! CGRID species number and offsets
      USE UTILIO_DEFN
      USE AERO_DATA            ! describes aerosol distribution
      USE PHOT_MOD             ! photolysis in-line module - inherits CSQY_DATA module
      USE AERO_PHOTDATA        ! arrays and routines for aerosol dimensions and refractive indices
      USE PHOTOLYSIS_ALBEDO    ! surface albedo data and routines
      USE PHOT_MET_DATA        ! Met and Grid data
      USE CLOUD_OPTICS         ! data and routines for optics of cloud hydrometeors
      USE SEAS_STRAT_O3_MIN    ! monthly minimum fraction of ozone column density above Pressure TOP
      USE CENTRALIZED_IO_MODULE, ONLY : LAT, LON, HT

#ifdef parallel
      USE SE_MODULES           ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES         ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

!...include files

      INCLUDE SUBST_FILES_ID   ! file name parameters

!...arguments

      REAL,    POINTER      :: CGRID( :,:,:,: )  ! Species concentrations
      INTEGER, INTENT( IN ) :: JDATE         ! current Julian date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME         ! current time (HHMMSS)
      INTEGER, INTENT( IN ) :: DTSTEP( : )   ! time step vector (HHMMSS)


!...parameters

      LOGICAL, PARAMETER :: CLDATT = .TRUE.   ! include cloud attenuation

      REAL, PARAMETER :: DENS_CONV = ( 1.0E+03 * AVO / MWAIR ) * 1.0E-06  ! convert from kg/m**3 to #/cc
      REAL, PARAMETER :: PPM_MCM3  = 1.0E-06  ! convert from ppm to molecules / cc mol_Spec/mol_Air = ppm * 1E-06
      REAL, PARAMETER :: PRES_CONV = 1.0 / STDATMPA ! conversion factor Pa to atm
      REAL, PARAMETER :: ZTOA      = 50.0E3   ! height of top of atmosphere [ m ] (=50km)
                                              ! based a 2005 WRF model Documentation

      REAL, PARAMETER   :: EPSLON  = 1.0E-30  ! Small number

!...external functions: none

!...local variables

      LOGICAL, SAVE :: FIRSTIME = .TRUE.  ! Flag for first call to PHOT

      LOGICAL, SAVE :: CALL_INIT_ALBEDO = .TRUE.
      LOGICAL, SAVE :: CALL_GET_ALBEDO  = .TRUE.

      LOGICAL       :: ZERO_ICE

      CHARACTER(   3 ), ALLOCATABLE, SAVE :: WLTXT( : )
      CHARACTER(  16 )                    :: VARNM
      CHARACTER(  16 ), SAVE              :: PNAME = 'PHOT'
      CHARACTER(  16 )                    :: V_LIST( 2 )
      CHARACTER(  16 )                    :: REQUESTED_WAVE
      CHARACTER(  16 ), ALLOCATABLE       :: WAVE_LIST( : )

      CHARACTER(  80 ) :: VARDESC  ! environment variable description
      CHARACTER( 240 ) :: XMSG = ' '

      INTEGER,    SAVE :: LGC_O3   = 0 ! pointer to O3 in CGRID
      INTEGER,    SAVE :: LGC_NO2  = 0 ! pointer to NO2 in CGRID
      INTEGER,    SAVE :: LGC_CO   = 0 ! pointer to CO in CGRID
      INTEGER,    SAVE :: LGC_SO2  = 0 ! pointer to SO2 in CGRID
      INTEGER,    SAVE :: LGC_HCHO = 0 ! pointer to formaldehyde  in CGRID
      INTEGER,    SAVE :: TSTEP    ! output timestep in sec

      INTEGER ESTAT                ! status from environment var check
      INTEGER IPHOT                ! photolysis rate loop index
      INTEGER ROW
      INTEGER COL
      INTEGER LEV
      INTEGER SPC
      INTEGER IWL
      INTEGER L
      INTEGER V, N, MODE
      LOGICAL JTIME_CHK            ! To check for JTIME to write RJ values
      INTEGER ODATE                ! output date
      INTEGER OTIME                ! output time

      INTEGER ALLOCSTAT

      INTEGER ITMSTEP              ! one half synchronization timestep (sec)
      INTEGER MIDDATE              ! Date at time step midpoint
      INTEGER MIDTIME              ! Time at time step midpoint

      INTEGER, SAVE :: TDATE
      INTEGER, SAVE :: PECOL_OFFSET        ! Local Column Offset for processor
      INTEGER, SAVE :: PEROW_OFFSET        ! Local Column Offset for processor
      INTEGER, SAVE :: TSTEP_COUNT         ! counter between calls to write diagnostics

      REAL CURRHR          ! current GMT hour
      REAL JULIAN_DAY      ! time of year [days]
      REAL CURRHR_LST      ! local standard time at each grid cell
      REAL CTOP            ! cloud top in single dimension
      REAL CBASE           ! cloud base in single dimension
      REAL ZLEV            ! height in single dimension
      REAL ZEN             ! cosine of zenith angle
      REAL SINLAT          ! sine of latitude
      REAL COSLAT          ! cosine of latitude
      REAL RSQD            ! square of soldist
      REAL ZSFC            ! surface height (msl) [ m ]
      REAL EQT             ! equation of time
      REAL SOLDIST         ! solar distance [ au ]
      REAL SINDEC          ! sine of the solar declination
      REAL COSDEC          ! cosine of the solar declination
      REAL COSZEN          ! working cosine of the solar zenith angle
      REAL SINZEN          ! working sine of the solar zenith angle
      REAL LATCR           ! local latitude
      REAL LONCR           ! local longitude
      REAL OWATER_FRAC     ! Open water fraction
      REAL SNOW_FRAC       ! Snow fractional coverage
      REAL SEAICE_FRAC     ! Sea Ice fraction
      REAL RES_SKY_REFLECT ! reflection coefficient based on resolved sky
      REAL RES_SKY_TRANS   ! diffuse transmission coefficient based on resolved sky
      REAL RES_SKY_TRANSD  ! direct transmission coefficient based on resolved sky

      REAL                    :: TOTAL_O3_COLUMN ! total ozone column density, DU

      REAL,              SAVE :: JYEAR          = 0.0 ! year
      REAL,              SAVE :: JD_STRAT_O3MIN = 0.0 ! Julian day (YYYYDDD) of min fraction for stratos ozone

      INTEGER, PARAMETER  :: DAYS( 12 ) = (/ 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30 /)
      INTEGER, SAVE       :: IMONTH = 0

      REAL, ALLOCATABLE, SAVE :: ETOT_SFC ( : )      ! total downward irradiance at sfc [ Watts / m**2  ]
      REAL, ALLOCATABLE, SAVE :: TAUO3_TOP( : )      ! optical depth of ozone above model domain
      REAL, ALLOCATABLE, SAVE :: TAU_RAY  ( : )      ! Rayleigh optical depth above model domain
      REAL, ALLOCATABLE, SAVE :: TAUC_AERO( :,: )    ! aerosol optical depth at layer bottom
      REAL, ALLOCATABLE, SAVE :: TAU_TOT  ( :,: )    ! total optical depth at layer bottom
      REAL, ALLOCATABLE, SAVE :: TAU_CLOUD( :,: )    ! cloud optical depth at layer bottom

      REAL, ALLOCATABLE, SAVE :: SSA      ( : ) ! aerosol single scattering albedo, column average

      REAL MSCALE          ! combined factor to scale ppm to Molecules / cm**3
                           ! and correct for ambient temperaure and pressure

! FSB new arrays for new on-line cloud version

      REAL, ALLOCATABLE, SAVE :: LWC    ( : )      ! cloud liquid water content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: RWC    ( : )      ! rain water content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: IWC    ( : )      ! ice liquid water content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: SWC    ( : )      ! snow content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: GWC    ( : )      ! graupel content [ g/m**3 ]
      REAL, ALLOCATABLE, SAVE :: CLDFRAC( : )      ! fractional cloud cover
      REAL, ALLOCATABLE, SAVE :: BLKPRS ( : )      ! Air pressure in [ Pa ]
      REAL, ALLOCATABLE, SAVE :: BLKTA  ( : )      ! Air temperature [ K ]
      REAL, ALLOCATABLE, SAVE :: BLKDENS( : )      ! Air density  [ molecules / m**3 ]
      REAL, ALLOCATABLE, SAVE :: BLKZH  ( : )      ! layer half-height [ m ]
      REAL, ALLOCATABLE, SAVE :: BLKO3  ( : )      ! O3 concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE, SAVE :: BLKNO2 ( : )      ! NO2 concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE, SAVE :: BLKZF  ( : )      ! layer full-height [ m ]

      REAL, ALLOCATABLE, SAVE :: BLKRJ_RES( :, : ) ! photolysis rates
      REAL, ALLOCATABLE, SAVE :: BLKRJ_ACM( :, : ) ! photolysis rates

      LOGICAL, ALLOCATABLE, SAVE :: CLOUDS( : )    ! Does layer have clouds?
      LOGICAL                    :: NEW_PROFILE    ! Has atmospheric temperature and density profile changed?
      LOGICAL                    :: DARK           ! Are this processor's cells in darkness?

!...Variables for diagnostic outputs

      REAL, ALLOCATABLE, SAVE :: N_EXCEED_TROPO3( :,: )  ! Number of adjustments tropospheric ozone optical depth

      REAL, ALLOCATABLE, SAVE :: TOTAL_OC( :,: )         ! total ozone column [DU]
      REAL, ALLOCATABLE, SAVE :: TROPO_OC( :,: )         ! tropospheric ozone column [DU]
      REAL, ALLOCATABLE, SAVE :: NO2_COLUMN ( :,: )      ! tropospheric NO2 column []
      REAL, ALLOCATABLE, SAVE :: CO_COLUMN  ( :,: )      ! tropospheric CO column  []
      REAL, ALLOCATABLE, SAVE :: HCHO_COLUMN( :,: )      ! tropospheric HCHO column [DU]
      REAL, ALLOCATABLE, SAVE :: SO2_COLUMN ( :,: )      ! tropospheric SO2 column [DU]
      REAL, ALLOCATABLE, SAVE :: TROPO_O3_EXCEED( :,: )   ! Factor used to adjust tropospheric ozone optical depth
      REAL, ALLOCATABLE, SAVE :: TRANSMIS_DIFFUSE( :,: ) ! diffuse transmission coefficient at surface
      REAL, ALLOCATABLE, SAVE :: TRANSMIS_DIRECT( :,: )  ! direct transmission coefficient at surface
      REAL, ALLOCATABLE, SAVE :: REFLECT_COEFF( :,: )    ! reflection coefficient at top of atmosphere
      REAL, ALLOCATABLE, SAVE :: TAU_AERO_WL ( :,:,: )   ! total aerosol optical depth
      REAL, ALLOCATABLE, SAVE :: TAU_CLOUD_WL( :,:,: )   ! total cloud optical depth
      REAL, ALLOCATABLE, SAVE :: CLR_TRANSMISSION( :,: ) ! diffuse transmission coefficient of clouds
      REAL, ALLOCATABLE, SAVE :: CLR_REFLECTION  ( :,: ) ! reflection coefficient of cloud
      REAL, ALLOCATABLE, SAVE :: CLR_TRANS_DIRECT( :,: ) ! direct transmission coefficient of clouds
      REAL, ALLOCATABLE, SAVE :: TAU_AERO_550    ( :,: ) ! total aerosol optical depth at 550 nm (Angstrom Interpolation)
#ifdef phot_debug
      REAL, ALLOCATABLE, SAVE :: ASY_CLOUD_WL( :,:,: ) ! columm average of cloud asymmetry factor
      REAL, ALLOCATABLE, SAVE :: SSA_CLOUD_WL( :,:,: ) ! columm average of cloud single scattering albedo
#endif
      REAL, ALLOCATABLE, SAVE :: TAU_TOT_WL  ( :,:,: ) ! total optical depth
      REAL, ALLOCATABLE, SAVE :: TAUO3_TOP_WL( :,:,: ) ! optical depth of ozone above model domain

      REAL, ALLOCATABLE, SAVE :: AERO_SSA  ( :,:,:,: ) ! aerosol single scattering albedo
      REAL, ALLOCATABLE, SAVE :: AERO_ASYM ( :,:,:,: ) ! aerosol asymmetry factor
      REAL, ALLOCATABLE, SAVE :: TOT_EXT   ( :,:,:,: ) ! total extinction for layer [1/m]
      REAL, ALLOCATABLE, SAVE :: GAS_EXT   ( :,:,:,: ) ! clear sky extinction for layer [1/m]
      REAL, ALLOCATABLE, SAVE :: AERO_EXT  ( :,:,:,: ) ! aerosol extinction for layer [1/m]
      REAL, ALLOCATABLE, SAVE :: ACTINIC_FX( :,:,:,: ) ! net actinic flux [watts/m**2]
      REAL, ALLOCATABLE, SAVE :: AERO_EXT_550( :,:,: ) ! aerosol extinction at 550 nm for layer [1/m]
      REAL, ALLOCATABLE, SAVE :: OUTPUT_BUFF ( :,:,: ) ! output buffer for DIAG2 and DIAG3 files

      INTERFACE
         SUBROUTINE O3TOTCOL ( LATITUDE, LONGITUDE, JDATE, JTIME, OZONE )
            INTEGER, INTENT( IN )    :: JDATE      ! Julian day of the year (yyyyddd)
            INTEGER, INTENT( IN )    :: JTIME      ! time (hhmmss)
            REAL,    INTENT( IN )    :: LATITUDE   ! latitude of point on earth's surface
            REAL,    INTENT( IN )    :: LONGITUDE  ! longitude of point on earth's surface
            REAL,    INTENT( INOUT ) :: OZONE      ! total column ozone [DU]
         END SUBROUTINE O3TOTCOL
         SUBROUTINE CONVCLD_PROP_ACM( JDATE, JTIME, TSTEP )
            INTEGER, INTENT( IN )    :: JDATE
            INTEGER, INTENT( IN )    :: JTIME
            INTEGER, INTENT( IN )    :: TSTEP( 3 )
         END SUBROUTINE CONVCLD_PROP_ACM
      END INTERFACE

! ----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         TSTEP  = TIME2SEC( DTSTEP( 1 ) ) ! output timestep for phot diagnostic files

!...Set flag to initialize calculating aerosol extinction at 550 nm via Angstrom Exponents
         CALCULATE_EXT_550 = PHOTDIAG

         PECOL_OFFSET = COLSD_PE( 1, MYPE+1 ) - 1
         PEROW_OFFSET = ROWSD_PE( 1, MYPE+1 ) - 1

         CALL INIT_PHOT_SHARED()

!...Allocate array needed to calculation aerosol and cloud optical properties

         CALL INIT_AERO_DATA(  )

         CALL INIT_CLOUD_OPTICS(  )

! set cosine values for sun effectively below horizon
         COS85 = COS( 85.0 * PI180 )

!...Initialize Surface albedo method

         IF ( .NOT. INITIALIZE_ALBEDO( JDATE, JTIME ) ) THEN
              XMSG = 'Failure initializing photolysis surface albedo algorithm'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE( ETOT_SFC ( NWL ) )

         ALLOCATE( LWC    ( NLAYS ) )
         ALLOCATE( RWC    ( NLAYS ) )
         ALLOCATE( IWC    ( NLAYS ) )
         ALLOCATE( SWC    ( NLAYS ) )
         ALLOCATE( GWC    ( NLAYS ) )
         ALLOCATE( BLKPRS ( NLAYS ) )
         ALLOCATE( BLKTA  ( NLAYS ) )
         ALLOCATE( BLKDZ  ( NLAYS ) )
         ALLOCATE( BLKDENS( NLAYS ) )
         ALLOCATE( BLKZH  ( NLAYS ) )
         ALLOCATE( BLKO3  ( NLAYS ) )
         ALLOCATE( BLKNO2 ( NLAYS ) )
         ALLOCATE( BLKZF  ( NLAYS+1 ) )
         ALLOCATE( CLOUDS ( NLAYS ) )
         ALLOCATE( CLDFRAC( NLAYS ) )

         ALLOCATE( BLKRJ_RES( NLAYS,NPHOTAB ) )
         ALLOCATE( BLKRJ_ACM( NLAYS,NPHOTAB ) )

         ALLOCATE( TAUO3_TOP( NWL ) )
         ALLOCATE( TAU_RAY  ( NWL ) )
         ALLOCATE( SSA      ( NWL ) )

         ALLOCATE( TAU_CLOUD( NLAYS,NWL ) )
         ALLOCATE( TAUC_AERO( NLAYS,NWL ) )
         ALLOCATE( TAU_TOT  ( NLAYS,NWL ) )

         ALLOCATE( TOTAL_OC ( NCOLS,NROWS ) )

         IF ( PHOTDIAG ) THEN

            ALLOCATE( TROPO_OC   ( NCOLS,NROWS ) )
            ALLOCATE( CO_COLUMN  ( NCOLS,NROWS ) )
            ALLOCATE( SO2_COLUMN ( NCOLS,NROWS ) )
            ALLOCATE( NO2_COLUMN ( NCOLS,NROWS ) )
            ALLOCATE( HCHO_COLUMN( NCOLS,NROWS ) )
            ALLOCATE( TROPO_O3_EXCEED( NCOLS,NROWS ) )
            ALLOCATE( N_EXCEED_TROPO3( NCOLS,NROWS ) )
            ALLOCATE( TRANSMIS_DIFFUSE( NCOLS,NROWS ) )
            ALLOCATE( TRANSMIS_DIRECT ( NCOLS,NROWS ) )
            ALLOCATE( REFLECT_COEFF   ( NCOLS,NROWS ) )
            ALLOCATE( CLR_TRANSMISSION( NCOLS,NROWS ) )
            ALLOCATE( CLR_TRANS_DIRECT( NCOLS,NROWS ) )
            ALLOCATE( CLR_REFLECTION  ( NCOLS,NROWS ) )
            ALLOCATE( TAU_AERO_550    ( NCOLS,NROWS ) )
            ALLOCATE( TAU_AERO_WL     ( NCOLS,NROWS,NWL ) )
            ALLOCATE( TAU_CLOUD_WL    ( NCOLS,NROWS,NWL ) )
#ifdef phot_debug
            ALLOCATE( SSA_CLOUD_WL( NCOLS,NROWS,NWL ) )
            ALLOCATE( ASY_CLOUD_WL( NCOLS,NROWS,NWL ) )
#endif
            ALLOCATE( TAU_TOT_WL  ( NCOLS,NROWS,NWL ) )
            ALLOCATE( TAUO3_TOP_WL( NCOLS,NROWS,NWL ) )

            N_EXCEED_TROPO3 = 0.0
            TROPO_O3_EXCEED = 0.0
            TSTEP_COUNT     = 0
            TAU_AERO_550    = 0.0
            TROPO_OC        = 0.0
            CO_COLUMN       = 0.0
            SO2_COLUMN      = 0.0
            NO2_COLUMN      = 0.0
            HCHO_COLUMN     = 0.0
     
   
!...write wavelength data to a character array

            ALLOCATE ( WLTXT( NWL ) )

            DO IWL = 1, NWL
               WRITE( WLTXT( IWL ),'(I3.3)' ) INT( WAVELENGTH( IWL ) )
            END DO

! get wanted number of layers for PHOTDIAG2 and PHOTDIAG3 files 
            IF ( NLAYS_DIAG .EQ. 0 ) NLAYS_DIAG = NLAYS
            NLAYS_DIAG = MAX( 1, MIN( NLAYS_DIAG, NLAYS))

! get wanted wavelengths for PHOTDIAG2 and PHOTDIAG3 files
            ALLOCATE( WAVE_LIST( NWL ) )
            WAVE_LIST( : ) = ''
            IF ( NWAVE .GT. NWL )
     &          CALL LOG_MESSAGE( LOGDEV, 'Error: the number of ' //
     &          'wavelengths the user has requested for diagnostic ' //
     &          'photolysis output exceeds the number of internal model ' //
     &          'wavelengths.' )
            IF ( NWAVE .EQ. 0 ) THEN ! use all wavelenghts
               N_DIAG_WVL = NWL
               ALLOCATE ( DIAG_WVL( N_DIAG_WVL ) , STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DIAG_WVL'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
               DO IWL = 1, NWL
                  DIAG_WVL( IWL )  = IWL
               END DO
               WRITE(LOGDEV,'(5X,A,I3)')'Environment Variable NWAVE_PHOTDIAG not found '
     &      // 'setting PHOTDIAG2 and PHOTDIAG3 to output all wavelengths. Integer '
     &      // 'truncated values are below.'
               DO IWL = 1, N_DIAG_WVL
                  SPC = DIAG_WVL( IWL )
                  WRITE(LOGDEV,'(5X,I3,1X,A16)')IWL, WLTXT(SPC)
               END DO
            ELSE ! use the environment list
                WAVE_LIST( 1:NWAVE ) = WAVE_ENV( 1:NWAVE )
                N_DIAG_WVL = 0
                 ! first remove identical values
                DO V = 1, NWAVE-1
                   DO L = (V+1), NWAVE
                      IF( TRIM( WAVE_LIST( V ) ) .EQ. TRIM( WAVE_LIST( L ) ) )THEN
                         WAVE_LIST( L ) = " "
                      END IF
                   END DO
                END DO
                 ! Now count number of unique values
                DO V = 1, NWAVE
                   IF( LEN_TRIM( WAVE_LIST( V ) ) .GT. 0 )N_DIAG_WVL = N_DIAG_WVL + 1
                END DO
                ALLOCATE ( DIAG_WVL( N_DIAG_WVL ) , STAT = ALLOCSTAT )
                IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DIAG_WVL'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
                ! Next find unique list value in wavelenght spectrum
               IWL = 0
               DO V = 1, NWAVE
                   IF( LEN_TRIM( WAVE_LIST( V ) ) .LT. 1 )CYCLE
                   IWL = IWL + 1
                   DIAG_WVL( IWL )  = INDEXR ( TRIM( WAVE_LIST( V ) ), NWL, WLTXT )
                   IF ( DIAG_WVL( IWL ) .LT. 1 ) THEN
                      WRITE(LOGDEV,'(5X,A)')'PHOT: Cannot find requested wavelength, '
     &                              // TRIM(  WAVE_LIST( IWL ) ) // ' for DIAG2 and DIAG3 files '
     &                              // ' in spectrum '
                   END IF
               END DO
               IF( MINVAL( DIAG_WVL ) .LT. 1 )THEN
                  XMSG = 'FAILED TO find the above requested wavelenght spectrum '
                  WRITE( LOGDEV,'(5X,A)')XMSG
                  XMSG = 'Permitted integer truncated values of wavelenght spectrum '
                  DO IWL = 1, NWL
                     WRITE(LOGDEV,'(10X,I3,1X,A16)')IWL, WLTXT(IWL)
                  END DO
                  XMSG = 'ERROR using the environment variable, NWAVE_PHOTDIAG '
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               ELSE
                  WRITE(LOGDEV,'(5X,A,I3)')'Environment Variable NWAVE_PHOTDIAG found '
     &      //    'setting PHOTDIAG2 and PHOTDIAG3 to output below wavelenghts'
                  DO IWL = 1, N_DIAG_WVL
                     SPC = DIAG_WVL( IWL )
                     WRITE(LOGDEV,'(5X,I3,1X,A16)')IWL, WLTXT(SPC)
                  END DO
               END IF
            END IF
            WRITE(LOGDEV,'(/)')


            ALLOCATE ( AERO_ASYM( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_ASYM'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( AERO_SSA( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_SSA'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( AERO_EXT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_EXT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( AERO_EXT_550( NCOLS,NROWS,NLAYS_DIAG ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D AERO_EXT_550'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( TOT_EXT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D TOT_EXT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( GAS_EXT( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating 3D GAS_EXT'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( ACTINIC_FX( NCOLS,NROWS,NLAYS_DIAG,N_DIAG_WVL ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACTINIC_FX'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE ( OUTPUT_BUFF( NCOLS,NROWS,NLAYS_DIAG ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating OUTPUT_BUFF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF


         VARNM = 'CO'
         LGC_CO = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_CO .LE. 0 ) THEN
            XMSG = 'Could not find ' // VARNM // 'in species table'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            WRITE(LOGDEV,95101)
         END IF

         VARNM = 'SO2'
         LGC_SO2 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_SO2 .LE. 0 ) THEN
            XMSG = 'Could not find ' // VARNM // 'in species table'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            WRITE(LOGDEV,95101)
         END IF

         VARNM = 'HCHO'
         LGC_HCHO = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_HCHO .LE. 0 ) THEN
            VARNM = 'FORM'
            LGC_HCHO = INDEX1( VARNM, N_GC_SPC, GC_SPC )
            IF ( LGC_HCHO .LE. 0 ) THEN
               XMSG = 'Could not find HCHO or FORM, i.e., formaldehyde, in species table'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               WRITE(LOGDEV,95101)
            END IF
         END IF
!...open the photolysis rate diagnostic files

            ODATE = JDATE; OTIME = JTIME
#ifndef phot_extra_tstep
            CALL NEXTIME ( ODATE, OTIME, DTSTEP( 1 ) )  ! output timestamp ending time
#endif
            IF ( IO_PE_INCLUSIVE ) CALL OPPHOT ( ODATE, OTIME, DTSTEP( 1 ) )

            CALL SUBST_BARRIER

         END IF  ! photdiag

!...set pointers to species O3 and NO2 in CGRID

         VARNM = 'O3'
         LGC_O3 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_O3 .LE. 0 ) THEN
            XMSG = 'Could not find ' // VARNM // 'in species table'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF

         VARNM = 'NO2'
         LGC_NO2 = INDEX1( VARNM, N_GC_SPC, GC_SPC )
         IF ( LGC_NO2 .LE. 0 ) THEN
            XMSG = 'Could not find ' // VARNM // 'in species table'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
         END IF



#ifdef phot_extra_tstep
      ELSE
         IF ( PHOTDIAG ) THEN
            ODATE = JDATE; OTIME = JTIME
            CALL NEXTIME ( ODATE, OTIME, DTSTEP( 2 ) )  ! sync time step
         END IF
#endif
      END IF  ! firstime

      IF ( INT ( JD_STRAT_O3MIN ) .NE. JDATE ) THEN
!...set minimum fraction of ozone column above PTOP
         CALL SEASONAL_STRAT_O3( JDATE, JTIME )
         MIN_STRATO3_FRAC = MONTH_STRAT_03_FRAC
         MAX_TROPOO3_FRAC = MAX( 1.0 - MONTH_STRAT_03_FRAC, 0.0 )
         JD_STRAT_O3MIN = REAL( JDATE, 4)
      END IF
!...initialize variables tracking whether stratosphere ozone column satisfies
!...climatological averages.

      O3_TOGGLE_AVE     = 0.0
      O3_TOGGLE_MIN     = 1.0
      N_TROPO_O3_TOGGLE = 0
      TSTEP_COUNT       = TSTEP_COUNT + 1

      MIDDATE = JDATE
      MIDTIME = JTIME
      ITMSTEP = TIME2SEC( DTSTEP( 2 ) ) / 2
      CALL NEXTIME( MIDDATE, MIDTIME, SEC2TIME( ITMSTEP ) )

      CALL CONVCLD_PROP_ACM( JDATE, JTIME, DTSTEP )
      CALL GET_PHOT_MET( JDATE, JTIME, MIDDATE, MIDTIME )

!...Get cosine of solar parameters and set DARK

      CALL UPDATE_SUN( JDATE, JTIME, MIDDATE, MIDTIME )

      RSQD = DIST_TO_SUN * DIST_TO_SUN

      IF ( MAXVAL( COSINE_ZENITH ) .LE. 0.0 ) THEN
         DARK = .TRUE.
      ELSE
         DARK = .FALSE.
      END IF

!...set surface albedos

      CALL GET_ALBEDO( MIDDATE, MIDTIME, COSINE_ZENITH, LAT, LON )

!...SA  Write COSINE_ZENITH array at the end of each output tstep

      IF ( PHOTDIAG ) THEN
#ifndef phot_extra_tstep
         ODATE = JDATE; OTIME = JTIME
         CALL NEXTIME ( ODATE, OTIME, DTSTEP( 2 ) )  ! sync time step
#endif
         JTIME_CHK = ( MOD( TIME2SEC( OTIME ), TSTEP ) .EQ. 0 )
#ifdef parallel_io
         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( CTM_RJ_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM(CTM_RJ_1)
               CALL M3EXIT( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. OPEN3( CTM_RJ_2, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM(CTM_RJ_2)
               CALL M3EXIT( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF
            IF ( .NOT. OPEN3( CTM_RJ_3, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM(CTM_RJ_3)
               CALL M3EXIT( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF
         END IF
#endif
      ELSE
         JTIME_CHK         = .FALSE.
      END IF

      CALCULATE_EXT_550 = JTIME_CHK

!...If sun below horizon at all cells, zero photolysis rates & exit
!...  (assumes sun below horizon at *all* levels!)

      IF ( DARK ) THEN

         RJ = 0.0
         RJ_SUB = 0.0
         RJ_RES = 0.0
         ETOT_SFC_WL  = 0.0


!...Initialize ETOT_SFC, TAU_AERO, TAU_TOT, TAUO3_TOP to 0.0

!...Write data to output diagnostic file

         IF ( JTIME_CHK ) THEN

            TAUO3_TOP_WL = 0.0
            TAU_AERO_WL  = 0.0
! commented out because TAU_AERO_550 is set to zero after allocation and after written to PHOTDIAG1
!           TAU_AERO_550 = 0.0
            TAU_CLOUD_WL = 0.0
#ifdef phot_debug
            SSA_CLOUD_WL = 0.0
            ASY_CLOUD_WL = 0.0
#endif
            TAU_TOT_WL   = 0.0
            TOT_EXT      = 0.0
            GAS_EXT      = 0.0
            AERO_EXT     = 0.0
            AERO_EXT_550 = 0.0
            AERO_SSA     = 0.0
            AERO_ASYM    = 0.0
            ACTINIC_FX   = 0.0

            TRANSMIS_DIFFUSE  = 0.0
            TRANSMIS_DIRECT   = 0.0
            REFLECT_COEFF     = 0.0
            CLR_TRANSMISSION  = 0.0
            CLR_TRANS_DIRECT  = 0.0
            CLR_REFLECTION    = 0.0

            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  BLKDENS( 1 ) = DENS ( COL,ROW,1 ) * DENS_CONV ! [molecules / cm**3]
                  BLKDZ  ( 1 ) = ZFULL( COL,ROW,1 )
                  DO L = 2, NLAYS
                     BLKDENS( L ) = DENS( COL,ROW,L ) * DENS_CONV ! [molecules / cm**3]
                     BLKDZ  ( L ) = ZFULL( COL,ROW,L ) - ZFULL( COL,ROW,L-1 )
                  END DO
                  MSCALE = 1.0E-19 ! 100.0*10E-15*PPM_MCM3, so units are petamolecules/cm2
                  CALL COLUMN_GAS( IGAS=LGC_CO,   UNIT_FACTOR=MSCALE, COLUMN_DENSITY=CO_COLUMN   )
                  CALL COLUMN_GAS( IGAS=LGC_SO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=SO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_NO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=NO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_HCHO, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=HCHO_COLUMN )
                  MSCALE = 1.0E-4 * CONC_TO_DU ! so units are Dobsons
                  CALL COLUMN_GAS( IGAS=LGC_O3, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=TROPO_OC )                     
!...get total ozone column based on OMI observations
                  CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE, MIDTIME, TOTAL_OC( COL,ROW ) )
               END DO
            END DO   

         END IF  ! if JTIME_CHK

      ELSE  ! all cells not dark

!...MAIN loop over all rows and columns
         LOOP_ROWS: DO ROW = 1, NROWS
            LOOP_COLS: DO COL = 1, NCOLS

               PHOT_COL = COL + PECOL_OFFSET
               PHOT_ROW = ROW + PEROW_OFFSET

               COSZEN = COSINE_ZENITH( COL,ROW ) ! local cosine of solar zenith angle

               IF ( COSZEN .LE. 0.0 ) THEN
!...the cell is dark: set variables to zero and cycle
                  RJ( COL,ROW, :,: ) = 0.0
                  RJ_RES( COL,ROW, :,: ) = 0.0
                  RJ_SUB( COL,ROW, :,: ) = 0.0
                  ETOT_SFC_WL ( COL,ROW, : ) = 0.0

                  IF ( JTIME_CHK ) THEN
                     TAUO3_TOP_WL( COL,ROW, : ) = 0.0
                     TAU_AERO_WL ( COL,ROW, : ) = 0.0
                     TAU_CLOUD_WL( COL,ROW, : ) = 0.0
#ifdef phot_debug
                     SSA_CLOUD_WL( COL,ROW, : ) = 0.0
                     ASY_CLOUD_WL( COL,ROW, : ) = 0.0
#endif
                     TAU_TOT_WL  ( COL,ROW, : )   = 0.0
                     TOT_EXT     ( COL,ROW, :,: ) = 0.0
                     GAS_EXT     ( COL,ROW, :,: ) = 0.0
                     AERO_EXT    ( COL,ROW, :,: ) = 0.0
                     AERO_EXT_550( COL,ROW, : )   = 0.0
                     AERO_SSA    ( COL,ROW, :,: ) = 0.0
                     AERO_ASYM   ( COL,ROW, :,: ) = 0.0
                     ACTINIC_FX  ( COL,ROW, :,: ) = 0.0

!                     TROPO_O3_EXCEED( COL,ROW )  = 0.0
                     TRANSMIS_DIFFUSE( COL,ROW ) = 0.0
                     TRANSMIS_DIRECT ( COL,ROW ) = 0.0
                     REFLECT_COEFF   ( COL,ROW ) = 0.0
                     CLR_TRANSMISSION( COL,ROW ) = 0.0
                     CLR_TRANS_DIRECT( COL,ROW ) = 0.0
                     CLR_REFLECTION  ( COL,ROW ) = 0.0
                     
                     BLKDENS( 1 ) = DENS ( COL,ROW,1 ) * DENS_CONV ! [molecules / cm**3]
                     BLKDZ  ( 1 ) = ZFULL( COL,ROW,1 )
                     DO L = 2, NLAYS
                        BLKDENS( L ) = DENS( COL,ROW,L ) * DENS_CONV ! [molecules / cm**3]
                        BLKDZ  ( L ) = ZFULL( COL,ROW,L ) - ZFULL( COL,ROW,L-1 )
                     END DO
                     MSCALE = 1.0E-19 ! 100.0*10E-15*PPM_MCM3, so units are petamolecules/cm2
                     CALL COLUMN_GAS( IGAS=LGC_CO,   UNIT_FACTOR=MSCALE, COLUMN_DENSITY=CO_COLUMN   )
                     CALL COLUMN_GAS( IGAS=LGC_SO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=SO2_COLUMN  )
                     CALL COLUMN_GAS( IGAS=LGC_NO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=NO2_COLUMN  )
                     CALL COLUMN_GAS( IGAS=LGC_HCHO, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=HCHO_COLUMN )
                     MSCALE = 1.0E-4 * CONC_TO_DU ! so units are Dobsons
                     CALL COLUMN_GAS( IGAS=LGC_O3, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=TROPO_OC )                     
!...get total ozone column based on OMI observations
                     CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE, MIDTIME, TOTAL_OC( COL,ROW ) )
                  END IF

                  CYCLE LOOP_COLS

               END IF

!...initialize BLKRJ using F90 array operations.

               BLKRJ_RES = 0.0
               BLKRJ_ACM = 0.0

!...Set height of lowest level to zero

               BLKZF( 1 ) = 0.0

               ZSFC   = HT( COL,ROW ) ! surface height [m]
               SINZEN = SQRT( 1.0 - COSZEN * COSZEN ) ! sine of zenith angle

!...get total ozone column based on OMI observations
               CALL O3TOTCOL ( LAT( COL,ROW ), LON( COL,ROW ), MIDDATE, MIDTIME, TOTAL_O3_COLUMN )

               IF ( USE_ACM_CLOUD .OR. CLDATT ) THEN
                  OWATER_FRAC = MAX( ( 1.0 - SEAICE( COL,ROW ) ), 0.0 )
     &                        * WATER_FRACTION( COL,ROW )
                  SEAICE_FRAC = SEAICE( COL,ROW ) * WATER_FRACTION( COL,ROW )
                  SNOW_FRAC   = SNOCOV( COL,ROW )
                  COL_CLOUD   = PHOT_COL
                  ROW_CLOUD   = PHOT_ROW
               END IF

!...loop over vertical layers ambient air conditions and gas concentration
               DO L = 1, NLAYS
!...Fetch the grid cell ambient data at each layer.

                  BLKTA  ( L )   = TA   ( COL,ROW,L ) ! temperature [K]
                  BLKPRS ( L )   = PRES ( COL,ROW,L ) / STDATMPA  ! [atmospheres]
                  BLKDENS( L )   = DENS ( COL,ROW,L ) * DENS_CONV ! [molecules / cm**3]
                  BLKZH  ( L )   = ZM   ( COL,ROW,L ) ! mid layer height [m]
                  BLKZF  ( L+1 ) = ZFULL( COL,ROW,L ) ! full layer height [m]

!...set scale factor for [ppm] -> [molecule / cm**3]
!...  To go from ppm to molecule/cc:
!...  molecule/cc = ppm *  1.0E-06 * DENS (given in molecule/cc)

                  MSCALE = BLKDENS( L ) * PPM_MCM3

!...fetch ozone and no2 and convert to [ molecules / cm **3 ]
!...  and adjust the volume for ambient temperature and pressure.

                  BLKO3 ( L ) = CGRID( COL,ROW,L,LGC_O3  ) * MSCALE
                  BLKNO2( L ) = CGRID( COL,ROW,L,LGC_NO2 ) * MSCALE
                  ZLEV = BLKZF( L )
               END DO ! loop on layers ambient conditions and gases

               IF ( CLDATT .AND. CFRAC_2D( COL,ROW ) .GT. 0.0 ) THEN
                  DO L = 1, NLAYS

                     IF ( CFRAC_3D( COL,ROW,L ) .GT. 0.0 ) THEN
                        CLOUDS ( L )        = .TRUE.
                        CLOUD_LAYERING( L ) = .TRUE.
                        CLDFRAC( L )        = CFRAC_3D( COL,ROW,L )
!... set hydrometeor concentrations for resolved cloud
                        MSCALE   = 1.0E+3 * DENS ( COL,ROW,L )
                        IWC( L ) = MSCALE * QI( COL,ROW,L )
                        GWC( L ) = MSCALE * QG( COL,ROW,L )
                        SWC( L ) = MSCALE * QS( COL,ROW,L )
                        LWC( L ) = MSCALE * QC( COL,ROW,L )
                        RWC( L ) = MSCALE * QR( COL,ROW,L )
                     ELSE
                        CLOUDS ( L )        = .FALSE.
                        CLOUD_LAYERING( L ) = .FALSE.
                        CLDFRAC( L )        = 0.0
                        IWC( L ) = 0.0
                        GWC( L ) = 0.0
                        SWC( L ) = 0.0
                        LWC( L ) = 0.0
                        RWC( L ) = 0.0
                     END IF
                  END DO ! loop on layers clouds
! get optical properties of resolved cloud hydrometeors
                  CALL GET_DROPLET_OPTICS( NLAYS, BLKTA, OWATER_FRAC, SEAICE_FRAC, SNOW_FRAC, LWC )
                  CALL GET_ICE_OPTICS( NLAYS, BLKTA, IWC )
                  CALL GET_AGGREGATE_OPTICS( NLAYS, RWC, SWC, GWC )
               ELSE
                  CLOUDS         = .FALSE.
                  CLOUD_LAYERING = .FALSE.
                  CLDFRAC        = 0.0
!  hydrometeor concentrations
                  LWC = 0.0
                  IWC = 0.0
                  RWC = 0.0
                  SWC = 0.0
                  RWC = 0.0
                  CALL CLEAR_HYDROMETEOR_OPTICS()
               END IF

!..calculate needed aerosol properties in column

!              IF ( CORE_SHELL ) THEN
                  CALL GET_AERO_DATA ( COL,ROW, NLAYS, CGRID )
!              ELSE
!                 CALL AERO_OPTICS_INTERNAL( COL,ROW, NLAYS, CGRID )
!              END IF

! set surface albedo

               DO IWL = 1, NWL
                  ALB( IWL ) = SURFACE_ALBEDO( IWL, COL,ROW )
               END DO
!...calculate resolved-sky photolysis rates at all layers:

               NEW_PROFILE    = .TRUE.
               ONLY_SOLVE_RAD = .FALSE.

               CALL NEW_OPTICS ( JDATE, JTIME, NLAYS,
     &                           BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                           BLKO3, BLKNO2,
     &                           ZSFC, COSZEN, SINZEN, RSQD,
     &                           NEW_PROFILE, CLOUDS, CLDFRAC,
     &                           BLKRJ_RES, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                           TAU_RAY, SSA, TAU_CLOUD, TOTAL_O3_COLUMN )

!...load diagnostic file arrays
               IF ( PHOTDIAG .AND. .NOT. STRATO3_MINS_MET ) THEN
                    N_EXCEED_TROPO3( COL,ROW ) =  N_EXCEED_TROPO3( COL,ROW ) + 1.0
                    TROPO_O3_EXCEED( COL,ROW ) = TROPO_O3_COLUMN/(MAX_TROPOO3_FRAC*TOTAL_O3_COLUMN) - 1.0
     &                                         + TROPO_O3_EXCEED( COL,ROW )
               END IF

               FORALL ( IWL = 1:NWL )
                  ETOT_SFC_WL ( COL,ROW,IWL ) = IRRADIANCE( 1,IWL )
               END FORALL   

               IF ( JTIME_CHK  ) THEN
                  TOTAL_OC( COL,ROW )         = TOTAL_O3_COLUMN
                  TRANSMIS_DIFFUSE( COL,ROW ) = TRANSMISSION
                  TRANSMIS_DIRECT( COL,ROW )  = TRANS_DIRECT
                  REFLECT_COEFF( COL,ROW )    = REFLECTION


                  DO IWL = 1, NWL
                     TAUO3_TOP_WL( COL,ROW,IWL )     = TAUO3_TOP( IWL )
                     TAU_AERO_WL ( COL,ROW,IWL )     = TAUC_AERO( 1,IWL )
                     TAU_TOT_WL  ( COL,ROW,IWL )     = TAU_TOT  ( 1,IWL )
                     TAU_CLOUD_WL( COL,ROW,IWL )     = TAU_CLOUD( 1,IWL )
#ifdef phot_debug
                     SSA_CLOUD_WL( COL,ROW,IWL ) = AVE_SSA_CLD  ( IWL )
                     ASY_CLOUD_WL( COL,ROW,IWL ) = AVE_ASYMM_CLD( IWL )
#endif
                  END DO

                  FORALL ( L = 1:NLAYS_DIAG )
                     AERO_EXT_550( COL,ROW,L ) = 1000.0 * AERO_EXTI_550( L )
                  END FORALL
                  DO LEV = 1, NLAYS
                     TAU_AERO_550 ( COL,ROW ) = TAU_AERO_550 ( COL,ROW )
     &                                        + AERO_EXTI_550( LEV ) * BLKDZ( LEV )
                  END DO

                  DO L = 1, N_DIAG_WVL
                     IWL = DIAG_WVL( L )
                     FORALL ( LEV = 1:NLAYS_DIAG )
                        ACTINIC_FX( COL,ROW,LEV,L )  = ACTINIC_FLUX( LEV,IWL )
                        TOT_EXT ( COL,ROW,LEV,L )    = 1000.0 * EXTINCTION( LEV,IWL )
                        GAS_EXT ( COL,ROW,LEV,L )    = 1000.0 * GAS_EXTINCTION( LEV,IWL )
                        AERO_EXT( COL,ROW,LEV,L )    = 1000.0 * AERO_EXTI_COEF( LEV,IWL )
                     END FORALL
                     FORALL ( LEV = 1:NLAYS_DIAG, AERO_EXTI_COEF( LEV,IWL ) .GT. EPSLON )
                        AERO_SSA ( COL,ROW,LEV,L ) = AERO_SCAT_COEF( LEV,IWL )
     &                                             / AERO_EXTI_COEF( LEV,IWL )
                        AERO_ASYM( COL,ROW,LEV,L ) = AERO_ASYM_FAC( LEV,IWL )
                     END FORALL
                     FORALL ( LEV = 1:NLAYS_DIAG, AERO_EXTI_COEF( LEV,IWL ) .LE. EPSLON )
                        AERO_SSA ( COL,ROW,LEV,L ) = 1.0
                        AERO_ASYM( COL,ROW,LEV,L ) = 0.0
                     END FORALL
                  END DO
                  IF ( COSZEN .LE. COS85 ) THEN 
                  ! calculate because NEW_OPTICS sets BLKDZ and TROPO_O3_COLUMN to zero
                     BLKDZ( 1 ) = BLKZF( 2 )
                     DO L = 2, NLAYS
                        BLKDZ( L ) = BLKZF( L+1 ) - BLKZF( L )
                     END DO
                     MSCALE = 1.0E-4 * CONC_TO_DU ! so units are Dobsons
                     CALL COLUMN_GAS( IGAS=LGC_O3, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=TROPO_OC )
                  ELSE
                     TROPO_OC( COL,ROW ) = TROPO_O3_COLUMN
                  END IF   
                  MSCALE = 1.0E-19 ! 100.0*10E-15*PPM_MCM3, so units are petamolecules/cm2
                  CALL COLUMN_GAS( IGAS=LGC_CO,   UNIT_FACTOR=MSCALE, COLUMN_DENSITY=CO_COLUMN   )
                  CALL COLUMN_GAS( IGAS=LGC_SO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=SO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_NO2,  UNIT_FACTOR=MSCALE, COLUMN_DENSITY=NO2_COLUMN  )
                  CALL COLUMN_GAS( IGAS=LGC_HCHO, UNIT_FACTOR=MSCALE, COLUMN_DENSITY=HCHO_COLUMN )
               END IF

!Set Photolysis rates to resolved sky values
               FORALL ( L = 1:NLAYS, IPHOT = 1:NPHOTAB )
                  RJ( COL,ROW, L,IPHOT ) = 60.0 * BLKRJ_RES( L,IPHOT )
               END FORALL ! Loop on layers and NPHOTAB
               FORALL ( L = 1:NLAYS, IPHOT = 1:NPHOTAB )
                  RJ_RES( COL,ROW, L,IPHOT ) = 60.0 * BLKRJ_RES( L,IPHOT )
               END FORALL  ! Loop on layers and NPHOTAB

               IF ( USE_ACM_CLOUD ) THEN
                  IF ( ACM_CLOUDS( COL,ROW ) .GT. 0.0 ) THEN
! save resolved sky reflection and transmission coefficients for possible latter use
                     RES_SKY_REFLECT = REFLECTION
                     RES_SKY_TRANS   = TRANSMISSION
                     RES_SKY_TRANSD  = TRANS_DIRECT
!...find the highest layer of the sub-grid (convective) cloud
                     DO LEV = NLAYS, 1, -1
                        IF ( ACM_CFRAC( LEV, COL,ROW ) .GT. 0.0 ) EXIT
                     END DO
!...replace the lower layers with sub-grid cloud properties
                     DO L = 1, LEV
                        SWC( L ) = 0.0
                        IF ( ACM_CFRAC( L,COL,ROW ) .GT. 0.0 ) THEN
                           CLOUDS ( L ) = .TRUE.
                           CLDFRAC( L ) = 1.0
                           MSCALE = 1.0E+3 * DENS ( COL,ROW, L )
                           LWC( L ) = MSCALE * ACM_QC( L,COL,ROW )
                           IWC( L ) = MSCALE * ACM_QI( L,COL,ROW )
                           RWC( L ) = MSCALE * ACM_QR( L,COL,ROW )
                           GWC( L ) = MSCALE * ACM_QG( L,COL,ROW )
                        ELSE
                           CLOUDS( L )  = .FALSE.
                           CLDFRAC( L ) = 0.0
                           LWC( L )     = 0.0
                           IWC( L )     = 0.0
                           RWC( L )     = 0.0
                           GWC( L )     = 0.0
                        END IF
                        CLOUD_LAYERING( L ) = .FALSE.
                     END DO

! get optical properties of of subgrid cloud hydrometeors
                     CALL GET_DROPLET_OPTICS( LEV, BLKTA, OWATER_FRAC, SEAICE_FRAC, SNOW_FRAC, LWC )
                     CALL GET_ICE_OPTICS( LEV, BLKTA, IWC )
                     CALL GET_AGGREGATE_OPTICS( LEV, RWC, SWC, GWC )

!...calculate the acm-cloud photolysis rates for all layers:
                     NEW_PROFILE = .FALSE.
                     CALL NEW_OPTICS ( JDATE, JTIME, NLAYS,
     &                                 BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                                 BLKO3, BLKNO2,
     &                                 ZSFC, COSZEN, SINZEN, RSQD,
     &                                 NEW_PROFILE, CLOUDS, CLDFRAC,
     &                                 BLKRJ_ACM, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                                 TAU_RAY, SSA, TAU_CLOUD, TOTAL_O3_COLUMN )

!...load diagnostic file arrays
!...compute a cloud-fraction weighted average of ETOT_SFC and TAU_TOT
!...  note that both TAUC_AERO and TAUO3_TOP are the same for clear and
!...  cloudy regions
                     MSCALE = MAX( 1.0 - ACM_CLOUDS( COL,ROW ), 0.0 )
                     DO IWL = 1, NWL
                       ETOT_SFC_WL ( COL,ROW,IWL ) = MSCALE * ETOT_SFC_WL( COL,ROW,IWL )
     &                                             + ACM_CLOUDS( COL,ROW ) * IRRADIANCE( 1,IWL )
                     END DO

                     IF ( JTIME_CHK ) THEN

                        TRANSMIS_DIRECT( COL,ROW )  = MSCALE * TRANSMIS_DIRECT( COL,ROW )
     &                                              + ACM_CLOUDS( COL,ROW ) * TRANS_DIRECT
                        TRANSMIS_DIFFUSE( COL,ROW ) = MSCALE * TRANSMIS_DIFFUSE( COL,ROW )
     &                                              + ACM_CLOUDS( COL,ROW ) * TRANSMISSION
                        REFLECT_COEFF( COL,ROW )    = MSCALE * REFLECT_COEFF( COL,ROW )
     &                                              + ACM_CLOUDS( COL,ROW ) * REFLECTION
                        DO IWL = 1, NWL
                           TAU_TOT_WL  ( COL,ROW,IWL ) = MSCALE * TAU_TOT_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * TAU_TOT( 1,IWL )
                           TAU_CLOUD_WL( COL,ROW,IWL ) = MSCALE * TAU_CLOUD_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * TAU_CLOUD( 1,IWL )
#ifdef phot_debug
                           SSA_CLOUD_WL( COL,ROW,IWL ) = MSCALE * SSA_CLOUD_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * AVE_SSA_CLD ( IWL )
                           ASY_CLOUD_WL( COL,ROW,IWL ) = MSCALE * ASY_CLOUD_WL( COL,ROW,IWL )
     &                                                 + ACM_CLOUDS( COL,ROW ) * AVE_ASYMM_CLD( IWL )
#endif
                        END DO   ! iwl

                        DO LEV = 1, NLAYS_DIAG
                           DO L = 1, N_DIAG_WVL
                              IWL = DIAG_WVL( L )
                              TOT_EXT( COL,ROW,LEV,L )    = MSCALE * TOT_EXT( COL,ROW,LEV,L )
     &                                                    + ACM_CLOUDS( COL,ROW ) * EXTINCTION( LEV,IWL )
                              ACTINIC_FX( COL,ROW,LEV,L ) = MSCALE * ACTINIC_FX( COL,ROW,LEV,L )
     &                                                    + ACM_CLOUDS( COL,ROW ) * ACTINIC_FLUX( LEV,IWL )
                           END DO
                        END DO
                     END IF  ! photdiag
!Photolysis rates become a weighted average of the values from resolved and ACM skies
                     FORALL ( L = 1:NLAYS, IPHOT = 1:NPHOTAB )
                         RJ_SUB( COL,ROW, L, IPHOT ) = 60.0 * BLKRJ_ACM( L,IPHOT )
                         RJ( COL,ROW, L, IPHOT )     = ACM_CLOUDS( COL,ROW ) *  RJ_SUB( COL,ROW, L, IPHOT )
     &                                               + MSCALE * RJ( COL,ROW,L,IPHOT )
                     END FORALL ! Loop on layers and PHOT
                  END IF
               END IF ! not USE_ACM_CLOUD and  ACM_CLOUDS > 0

               IF ( JTIME_CHK ) THEN ! compute clear sky reflection and transmission coefficients
                  IF ( ANY( CLOUDS ) ) THEN
                     IF ( CFRAC_2D( COL,ROW ) .GT. 0.0 ) THEN ! resolved and subgrid clouds exist
                        CLOUDS         = .FALSE.
                        NEW_PROFILE    = .FALSE.
                        ONLY_SOLVE_RAD = .TRUE.
                        CALL NEW_OPTICS ( JDATE, JTIME, NLAYS,
     &                                    BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                                    BLKO3, BLKNO2,
     &                                    ZSFC, COSZEN, SINZEN, RSQD,
     &                                    NEW_PROFILE, CLOUDS, CLDFRAC,
     &                                    BLKRJ_RES, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                                    TAU_RAY, SSA, TAU_CLOUD, TOTAL_O3_COLUMN)
                        CLR_REFLECTION  ( COL,ROW ) = REFLECTION
                        CLR_TRANSMISSION( COL,ROW ) = TRANSMISSION
                        CLR_TRANS_DIRECT( COL,ROW ) = TRANS_DIRECT
                     ELSE ! only subgrid clouds exist
                        CLR_REFLECTION  ( COL,ROW ) = RES_SKY_REFLECT
                        CLR_TRANSMISSION( COL,ROW ) = RES_SKY_TRANS
                        CLR_TRANS_DIRECT( COL,ROW ) = RES_SKY_TRANSD
                     END IF
                  ELSE ! no cloud in vertical column
                     CLR_REFLECTION  ( COL,ROW ) = REFLECTION
                     CLR_TRANSMISSION( COL,ROW ) = TRANSMISSION
                     CLR_TRANS_DIRECT( COL,ROW ) = TRANS_DIRECT
                  END IF
               END IF

            END DO LOOP_COLS
         END DO LOOP_ROWS

      END IF

!...report on whether stratospheric ozone column satisfies climatological minimums
      IF( N_TROPO_O3_TOGGLE .GT. 0 )THEN
         O3_TOGGLE_AVE = O3_TOGGLE_AVE / REAL( N_TROPO_O3_TOGGLE )
         WRITE( LOGDEV, 9500 )'PHOT: Exceedance of tropospheric ozone column ',
     &   'or below top of model domains based on stratospheric column minimum ',
     &   'at date and time; ', JDATE, JTIME, N_TROPO_O3_TOGGLE, (1.0/O3_TOGGLE_AVE - 1.0),
     &    (1.0/O3_TOGGLE_MIN - 1.0)
      END IF

!...write diagnostic data to output file at the end of every output tstep

      IF ( JTIME_CHK ) THEN

         VARNM = 'COSZENS'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME,
     &                     COSINE_ZENITH ) ) THEN
             XMSG = 'Error writing variable ' // VARNM
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'OZONE_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TOTAL_OC ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CO_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CO_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         VARNM = 'SO2_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, SO2_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         VARNM = 'NO2_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, NO2_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         VARNM = 'HCHO_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, HCHO_COLUMN ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'TROPO_O3_COLUMN'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TROPO_OC ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF


         VARNM = 'TRANS_DIFFUSE'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TRANSMIS_DIFFUSE ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'TRANS_DIRECT'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TRANSMIS_DIRECT ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'REFLECTION'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, REFLECT_COEFF ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CLR_TRANS_DIF'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CLR_TRANSMISSION ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CLR_TRANS_DIR'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CLR_TRANS_DIRECT ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'CLR_REFLECTION'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CLR_REFLECTION ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'TROPO_O3_EXCEED'
         TROPO_O3_EXCEED = TROPO_O3_EXCEED / REAL( MAX(1, TSTEP_COUNT) )
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TROPO_O3_EXCEED ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         TROPO_O3_EXCEED = 0.0 ! reset sum and counter
         TSTEP_COUNT     = 0

         VARNM = 'N_EXCEED_TROPO3'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, N_EXCEED_TROPO3 ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         N_EXCEED_TROPO3 = 0.0 ! reset counter

         VARNM = 'JNO2'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, RJ( :,:,1, LNO2 ) ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'JO3O1D'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, RJ( :,:,1,LO3O1D ) ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'RESOLVED_CFRAC'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, CFRAC_2D ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         VARNM = 'RESOLVED_WBAR'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, AVE_HYDROMETEORS ) ) THEN
             XMSG = 'Error writing variable ' // VARNM
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         IF ( USE_ACM_CLOUD ) THEN
             VARNM = 'SUBGRID_CFRAC'
             IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, ACM_CLOUDS ) ) THEN
                XMSG = 'Error writing variable ' // VARNM
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
             END IF
             VARNM = 'SUBGRID_WBAR'
             IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, ACM_AVE_H2O ) ) THEN
                XMSG = 'Error writing variable ' // VARNM
                CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
             END IF
         END IF

         DO IWL = 1, NWL

            VARNM = 'ETOT_SFC_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, ETOT_SFC_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, ODATE, OTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AOD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_AERO_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'TAU_CLOUD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_CLOUD_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

#ifdef phot_debug
            VARNM = 'SSA_CLOUD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, SSA_CLOUD_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'ASY_CLOUD_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, ASY_CLOUD_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
#endif

            VARNM = 'TAU_TOT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAU_TOT_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'TAUO3_TOP_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE,
     &                         OTIME, TAUO3_TOP_WL( :,:,IWL ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'ALBEDO_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME,
     &                         SURFACE_ALBEDO( IWL,:,: ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END DO  ! iwl

         VARNM = 'AOD_W550_ANGST'
         IF ( .NOT. WRITE3( CTM_RJ_1, VARNM, ODATE, OTIME, TAU_AERO_550 ) ) THEN
            XMSG = 'Error writing variable ' // VARNM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         TAU_AERO_550 = 0.0

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &          'Photolysis Surface Summary written to', CTM_RJ_1,
     &          'for date and time', ODATE, OTIME

         DO IPHOT = 1, NPHOTAB
            OUTPUT_BUFF( 1:NCOLS,1:NROWS,1:NLAYS_DIAG ) = RJ( 1:NCOLS,1:NROWS,1:NLAYS_DIAG,IPHOT )
            IF ( .NOT. WRITE3( CTM_RJ_2, PHOTAB( IPHOT ), ODATE,
     &                         OTIME, OUTPUT_BUFF  ) ) THEN
               XMSG = 'Could not write ' // CTM_RJ_2 // ' file'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END DO

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &          'Photolysis Rates written to', CTM_RJ_2,
     &          'for date and time', ODATE, OTIME

         VARNM = 'CFRAC_3D'
         OUTPUT_BUFF( 1:NCOLS,1:NROWS,1:NLAYS_DIAG ) = CFRAC_3D( 1:NCOLS,1:NROWS,1:NLAYS_DIAG )
         IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, OUTPUT_BUFF ) ) THEN
              XMSG = 'Could not write ' // TRIM( VARNM ) // ' to ' // CTM_RJ_3 // ' file'
              CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         DO L = 1, N_DIAG_WVL
            IWL = DIAG_WVL( L )

            VARNM = 'ACTINIC_FX_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, ACTINIC_FX( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AERO_SSA_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_SSA( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'AERO_ASYM_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_ASYM( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'EXT_AERO_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_EXT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'EXT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, TOT_EXT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            VARNM = 'GAS_EXT_W' // WLTXT( IWL )
            IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, GAS_EXT( :,:,:,L ) ) ) THEN
               XMSG = 'Error writing variable ' // VARNM
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END DO

         VARNM = 'EXT_AERO_W550'
         IF ( .NOT. WRITE3( CTM_RJ_3, VARNM, ODATE, OTIME, AERO_EXT_550( :,:,: ) ) ) THEN
             XMSG = 'Error writing variable ' // VARNM
             CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &          'Radiative and Optical Data written to', CTM_RJ_3,
     &          'for date and time', ODATE, OTIME

      END IF   ! if JTIME_CHK

1003  FORMAT( 8X, 'Processor ',I4.4,' is in darkness at ', I8.7, ':', I6.6,
     &        1X, 'GMT - no photolysis')
9500  FORMAT(3(/ A), I7, 1X, I6.6, 1X, / "Total Number: ", I9, ";Mean Value: ", F9.6,
     &       "; Max Value: ",F9.6 /)

95101 FORMAT('Diagnostic Output will have zero values for the column density.',
     &     / 'The lack of information does not affect model predictions.' )
      
      CONTAINS      
          SUBROUTINE COLUMN_GAS( IGAS, UNIT_FACTOR, COLUMN_DENSITY )
! Purpose: calculates column density in unit based on the value of UNIT_FACTOR
             IMPLICIT NONE
! argument:          
               INTEGER, INTENT( IN  ) :: IGAS                  ! species index in CGRID
               REAL,    INTENT( OUT ) :: COLUMN_DENSITY( :,: ) ! units determined by inputs
               REAL,    INTENT( IN  ) :: UNIT_FACTOR           ! converts from 10E6*molecules*cm-2
! local parameter:                
!               REAL, PARAMETER :: UNIT_FACTOR = 1.0E-6 * CONC_TO_DU ! unit conversion factor
               
               IF( IGAS .LE. 0 )RETURN ! assumes column_density set to zero at allocation
               
               COLUMN_DENSITY( COL,ROW ) = 0.0
               DO LEV = 1, NLAYS
                  COLUMN_DENSITY( COL,ROW ) = ( UNIT_FACTOR * BLKDENS( LEV ) )
     &                                      * CGRID( COL,ROW,LEV,IGAS  ) * BLKDZ ( LEV )
     &                                      + COLUMN_DENSITY( COL,ROW )                  
               END DO
               
          END SUBROUTINE COLUMN_GAS              
      END SUBROUTINE PHOT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SETUP_LOGDEV () 

C Purpose
C   Establish ancillary run time log files for each parallel processor
C   Effectively no operation, if serial

C Revision History:
C   ???      J.Young - initial
C   26 Dec, 01 David Wong
C      -- removed MPI_INIT call since the same function has been called in
C         subroutine PAR_INIT
C   11 Jun 02 J.Young - minor mods
C   23 Feb 11 J.Young - SETENVVAR is a function, not a subroutine
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   12 Aug 15 D.Wong:   Replaced SUBST_MPI with mpif.h

      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE LOG_HEADER

      IMPLICIT NONE

#ifdef parallel      
      include 'mpif.h'
#endif
      INTEGER, PARAMETER :: MAXLEN_CTM_LOG   = MAXLEN_CCTM_APPL + 11

      CHARACTER(  8 ) :: PRESTR  = 'CTM_LOG_'
      CHARACTER( MAXLEN_CTM_LOG ) :: IOLOGEQ

      INTEGER :: IOST, IHEAD
      INTEGER :: NIOAPI_HEAD, NCMAQ_HEAD
      INTEGER, PARAMETER :: NHEAD = 200
      CHARACTER( 90 ) :: CMAQ_HEADER( NHEAD )
      CHARACTER( 90 ) :: IOAPI_HEADER( NHEAD )

      ! Fetch CMAQ Header
      CALL LOAD_HEADER( CMAQ_HEADER )
      DO IHEAD = SIZE( CMAQ_HEADER ),1,-1
          ! Check for End of File
          IF ( CMAQ_HEADER( IHEAD ) .NE. '' ) THEN
             NCMAQ_HEAD = IHEAD 
             EXIT
          END IF
      END DO


      ! Create Log Filename using the processor rank and initialize
      ! I/O-API and Logs
      WRITE ( CMYPE, '(I3.3)' ) MYPE
      IOLOGEQ = PRESTR // CMYPE // '.' // TRIM( APPL_NAME )
      IF ( .NOT. SETENVVAR ( 'LOGFILE', IOLOGEQ ) ) THEN
         WRITE( *,* ) '*** Could not set environment variable for ' // IOLOGEQ
         CALL M3EXIT( 'SETUP_LOGDEV', 0, 0, '', 2 )
      END IF

#ifndef twoway
      ! Write CMAQ Header to Screen
      IF ( MYPE .EQ. 0 ) THEN
         DO IHEAD = 1,NCMAQ_HEAD
            WRITE( OUTDEV, '(A)' ) CMAQ_HEADER( IHEAD )
         END DO
      END IF
#endif

      ! Redirect Standard Output
      IF ( MYPE .NE. 0 ) OPEN( UNIT = 6, FILE = "/dev/null", STATUS = "OLD" )

      LOGDEV = INIT3() 

      ! Put Standard Output Back to File Unit 6 By Closing File Unit 6
      IF ( MYPE .NE. 0 ) CLOSE( 6 ) 

      ! Fetch I/O-API Header
#ifndef twoway
      REWIND( LOGDEV )
      DO IHEAD = 1,NHEAD
          READ( LOGDEV, '(A)', IOSTAT=IOST ), IOAPI_HEADER( IHEAD )
          ! Check for End of File
          IF ( IOST .LT. 0 ) THEN
             NIOAPI_HEAD = IHEAD - 1
             EXIT
          END IF
      END DO
      REWIND( LOGDEV )
#endif

      ! Write CMAQ Header and then I/O-API Header
      DO IHEAD = 1,NCMAQ_HEAD
          WRITE( LOGDEV, '(A)' ) CMAQ_HEADER( IHEAD )
      END DO
      WRITE( LOGDEV, * )
#ifndef twoway
      DO IHEAD = 1,NIOAPI_HEAD
          WRITE( LOGDEV, '(A)' ) IOAPI_HEADER( IHEAD )
      END DO
#endif

      END SUBROUTINE SETUP_LOGDEV 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE DEGRADE_DATA()
C**********************************************************************
C
C  FUNCTION:  Allocate arrays and define data used by degradation routines
C
C    react(i) does not need the maximum number of causes for degradation.
C    Set "un-used" causes to "' '".
C
C    Note, OH and HO both refer to hydroxyl concentrations. The redundancy exists because
C    current mechanisms for gas chemistry use OH or HO to refer to the radical.
C
C  CALLED BY: INIT_DEGRADE
C
C  REVISION HISTORY: : 07/29/05 : B.Hutzell - Initial version
C                      10/23/07 : B.Hutzell - added CL reactions for specific HAPs
C                      04/14/08 : B.Hutzell - Removed Benzene for AERO5 module
C                      08/31/11 : B.Hutzell - Removed removed capabilities with previous 
C                                             HAPs mechanisms
C**********************************************************************

      USE RXNS_DATA
      USE DEGRADE_SETUP_TOX

      IMPLICIT NONE


C**********************************************************************


C..looping data

      UNI_START   = 1
      BI_START    = UNI_START + N_UNI_LOSS
      TRI_START   = BI_START  + N_BI_LOSS
      PHOTO_START = TRI_START + N_TRI_LOSS

      UNI_STOP   = BI_START    - 1
      BI_STOP    = TRI_START   - 1
      TRI_STOP   = PHOTO_START - 1
      PHOTO_STOP = N_PROCESSES

      ALLOCATE( REACT     ( N_REACT ) )                 ! names of species being degraded
      ALLOCATE( BICAUSE   ( N_REACT, N_BI_LOSS ) )      ! species name that cause degradation
      ALLOCATE( TRICAUSE  ( N_REACT, N_TRI_LOSS, 2 ) )  ! species name that cause degradation
      ALLOCATE( PHOTO_NAME( N_REACT, N_PHOTO_LOSS ) )   ! name of photolysis rate for react(i)

      ALLOCATE( UNIRATE  ( N_REACT, N_UNI_LOSS ) )  ! rate for unimolecular decay for react(i) [molecules/sec^1]
      ALLOCATE( UNI_ACT  ( N_REACT, N_UNI_LOSS ) )  ! activation energy for UNIRATE(I) [K]. Positive if exothermic
      ALLOCATE( UNI_TEXP ( N_REACT, N_UNI_LOSS ) )  ! exponent of Temperature and UNIRATE(I) factored by (1/298)**UNI_TEXP
      ALLOCATE( UNI_PROD ( N_REACT, N_UNI_LOSS ) )  ! name of daughter product for react(i)
      ALLOCATE( UNI_YIELD( N_REACT, N_UNI_LOSS ) )  ! yield of daughter product for react(i)

      ALLOCATE( BIRATE  ( N_REACT, N_BI_LOSS ) )  ! degradation rates for bimolecular reactions,  [cm^3/(sec*molecules)]
      ALLOCATE( BI_ACT  ( N_REACT, N_BI_LOSS ) )  ! activation energy for BIRATE(I) [K]. Positive if exothermic
      ALLOCATE( BI_TEXP ( N_REACT, N_BI_LOSS ) )  ! exponent of Temperature and BIRATE(I) factored by (1/298)**BI_TEXP
      ALLOCATE( BI_PROD ( N_REACT, N_BI_LOSS ) )  ! name of daughter product for react(i)
      ALLOCATE( BI_YIELD( N_REACT, N_BI_LOSS ) )  ! yield of daughter product for react(i)

      ALLOCATE( TRIRATE  ( N_REACT, N_TRI_LOSS ) )  ! degradation rates for trimolecular reactions,  [cm^3/(sec*molecules)]
      ALLOCATE( TRI_ACT  ( N_REACT, N_TRI_LOSS ) )  ! activation energy for TRIRATE(I) [K]. Positive if exothermic
      ALLOCATE( TRI_TEXP ( N_REACT, N_TRI_LOSS ) )  ! exponent of Temperature and TRIRATE(I) factored by (1/298)**TRI_TEXP
      ALLOCATE( TRI_PROD ( N_REACT, N_TRI_LOSS ) )  ! name of daughter product for react(i)
      ALLOCATE( TRI_YIELD( N_REACT, N_TRI_LOSS ) )  ! yield of daughter product for react(i)

      ALLOCATE( A_PHOTO    ( N_REACT, N_PHOTO_LOSS ) )  ! multiplier of photolysis rates
      ALLOCATE( PHOTO_PROD ( N_REACT, N_PHOTO_LOSS ) )  ! name of daughter product for react(i)
      ALLOCATE( PHOTO_YIELD( N_REACT, N_PHOTO_LOSS ) )  ! yield of daughter product for react(i)

      ALLOCATE( RATE_CONST( N_REACT, N_PROCESSES ) )
      ALLOCATE( RATE_YIELD( N_REACT, N_PROCESSES ) )

C..arrays to store indices to CGRID

      ALLOCATE( RXTANT_MAP( N_REACT ) )
      ALLOCATE( PROD_MAP  ( N_REACT, N_PROCESSES ) )
      ALLOCATE( RAD_MAP   ( N_REACT, N_BI_LOSS ) )
      ALLOCATE( RAD2_MAP  ( N_REACT, N_TRI_LOSS, 2 ) )
      ALLOCATE( PHOTO_MAP ( N_REACT, N_PHOTO_LOSS ) )

      REACT      = BLANK
      PHOTO_NAME = BLANK
      BICAUSE    = BLANK
      TRICAUSE   = BLANK

      UNI_ACT   = 0.0D0
      UNIRATE   = 0.0D0
      UNI_TEXP  = 0.0D0
      UNI_YIELD = 0.0

      BI_ACT   = 0.0D0
      BIRATE   = 0.0D0
      BI_TEXP  = 0.0D0
      BI_YIELD = 0.0

      TRI_ACT   = 0.0D0
      TRIRATE   = 0.0D0
      TRI_TEXP  = 0.0D0
      TRI_YIELD = 0.0

      A_PHOTO     = 0.0D0
      PHOTO_YIELD = 0.0

      RATE_YIELD = 1.0D0

! product are unused aspect and results not returned cgrid 
      UNI_PROD   = BLANK
      BI_PROD    = BLANK
      TRI_PROD   = BLANK
      PHOTO_PROD = BLANK

C..Initialize maps

      RXTANT_MAP = -1
      RAD_MAP    = -1
      RAD2_MAP   = -1
      PROD_MAP   = -1
      PHOTO_MAP  = -1

C..toxic VOC's

C.. ACRYLONITRILE

      REACT(1)       = 'ACRYLONITRILE'
      UNIRATE( 1, 1) = 0.0D0
      UNI_ACT( 1, 1) = 0.0D0
      UNI_TEXP(1, 1) = 0.0
      BICAUSE(1,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(1,1:5)  = (/ 4.8D-12, 4.8D-12, 1.9D-19, 6.3D-18, 5.2D-14/)
      BI_ACT(1,1:5)  = (/   0.0D0,   0.0D0, 0.0D0, 0.0D0, -1.4D+3/)

C.. CARBON TETRACHLORIDE

      REACT(2)       = 'CARBONTET'
      UNIRATE( 2, 1) = 0.0D0
      UNI_ACT( 2, 1) = 0.0D0
      UNI_TEXP(2, 1) = 0.0
      BICAUSE(2,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(2,1:5)  = (/ 1.0D-12, 1.0D-12, 0.0D0, 0.0D0, 9.55D-11/)
      BI_ACT(2,1:5)  = (/2300.0D0,2300.0D0, 0.0D0, 0.0D0, 7.80D+03/)

C.. PROPYLENE DICHLORIDE

      REACT(3)       = 'PROPDICHLORIDE'
      UNIRATE( 3, 1) = 0.0D0
      UNI_ACT( 3, 1) = 0.0D0
      UNI_TEXP(3, 1) = 0.0
      BICAUSE(3,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(3,1:5)  = (/ 2.2D-13, 2.2D-13, 0.0D0, 0.0D0, 1.1D-11/)
      BI_ACT(3,1:5)  = (/   0.0D0,   0.0D0, 0.0D0, 0.0D0, 0.0D0/)

C.. DICHLORIPROPENE

      REACT(4)       = 'DICHLOROPROPENE'
      UNIRATE( 4, 1) = 0.0D0
      UNI_ACT( 4, 1) = 0.0D0
      UNI_TEXP(4, 1) = 0.0
      BICAUSE(4,1:4) = (/'OH ','HO ','O3 ','NO3'/)
      BIRATE(4,1:4)  = (/1.04D-11, 1.04D-11, 4.10D-19, 0.0D0/)
      BI_ACT(4,1:4)  = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0/)

C.. 1,1,2,2TETRACHLOROETHANE

      REACT(5)       = 'CL4_ETHANE1122'
      UNIRATE( 5, 1) = 0.0D0
      UNI_ACT( 5, 1) = 0.0D0
      UNI_TEXP(5, 1) = 0.0
      BICAUSE(5,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(5,1:5)  = (/2.46D-13, 2.46D-13, 0.0D0, 0.0D0, 1.91D-13/)
      BI_ACT(5,1:5)  = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0, 0.00D0/)

C.. CHLOROFORM

      REACT(6)       = 'CHCL3'
      UNIRATE( 6, 1) = 0.0D0
      UNI_ACT( 6, 1) = 0.0D0
      UNI_TEXP(6, 1) = 0.0
      BICAUSE(6,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(6,1:5)  = (/6.30D-18, 6.30D-18, 0.0D0, 0.0D0, 4.9D-12/)
      BI_ACT(6,1:5)  = (/  504.D0,   504.D0, 0.0D0, 0.0D0, 1.24D+3/)
      BI_TEXP(6,1:2) = (/   2.0D0,    2.0D0/)

C.. 1,2DIBROMOETHANE

      REACT(7)       = 'BR2_C2_12'
      UNIRATE( 7, 1) = 0.0D0
      UNI_ACT( 7, 1) = 0.0D0
      UNI_TEXP(7, 1) = 0.0
      BICAUSE(7,1:4) = (/'OH ','HO ','O3 ','NO3'/)
      BIRATE(7,1:4)  = (/1.03D-17, 1.03D-17, 0.0D0, 0.0D0/)
      BI_ACT(7,1:4)  = (/  422.D0,   422.D0, 0.0D0, 0.0D0/)
      BI_TEXP(7,1:2) = (/   2.0D0,    2.0D0/)

C.. 1,2DICHLOROTHANE

      REACT(8)       = 'CL2_C2_12'
      UNIRATE( 8, 1) = 0.0D0
      UNI_ACT( 8, 1) = 0.0D0
      UNI_TEXP(8, 1) = 0.0
      BICAUSE(8,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(8,1:5)  = (/1.10D-17, 1.10D-17, 0.0D0, 0.0D0, 4.93D-11/)
      BI_ACT(8,1:5)  = (/  409.D0,   409.D0, 0.0D0, 0.0D0, 1.09D+3/)
      BI_TEXP(8,1:2) = (/   2.0D0,    2.0D0/)

C.. ETHYLENE OXIDE

      REACT(9)       = 'ETOX'
      UNIRATE( 9, 1) = 0.0D0
      UNI_ACT( 9, 1) = 0.0D0
      UNI_TEXP(9, 1) = 0.0
      BICAUSE(9,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(9,1:5)  = (/7.60D-14, 7.60D-14, 0.0D0, 0.0D0, 5.0D-12/)
      BI_ACT(9,1:5)  = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0, 0.0D0/)

C.. METHYLENE CHLORIDE

      REACT(10)       = 'CL2_ME'
      UNIRATE( 10, 1) = 0.0D0
      UNI_ACT( 10, 1) = 0.0D0
      UNI_TEXP(10, 1) = 0.0
      BICAUSE(10,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(10,1:5)  = (/8.54D-18, 8.54D-18, 0.0D0, 0.0D0, 2.81D-11/)
      BI_ACT(10,1:5)  = (/  500.D0,   500.D0, 0.0D0, 0.0D0, 1.3D+3/)
      BI_TEXP(10,1:2) = (/   2.0D0,    2.0D0/)

C.. PERCHLOROETHYLENE

      REACT(11)       = 'CL4_ETHE'
      UNIRATE(11, 1)  = 0.0D0
      UNI_ACT( 11, 1) = 0.0D0
      UNI_TEXP(11, 1) = 0.0
      BICAUSE(11,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(11,1:5)  = (/9.64D-12, 9.64D-12, 0.0D0, 0.0D0, 3.72D-8/)
      BI_ACT(11,1:5)  = (/ 1209.D0,  1209.D0, 0.0D0, 0.0D0, 0.0D0/)
      BI_TEXP(11,1:5) = (/   0.0D0,    0.0D0, 0.0D0, 0.0D0,-1.2D0/)

C.. TRICHLOROETHYLENE

      REACT(12)       = 'CL3_ETHE'
      UNIRATE( 12, 1) = 0.0D0
      UNI_ACT( 12, 1) = 0.0D0
      UNI_TEXP(12, 1) = 0.0
      BICAUSE(12,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(12,1:5)  = (/5.63D-13, 5.63D-13, 0.0D0, 0.0D0, 8.07D-11/)
      BI_ACT(12,1:5)  = (/ -427.D0,  -427.D0, 0.0D0, 0.0D0, 0.0D0/)

C.. VINYL CHLORIDE

      REACT(13)       = 'CL_ETHE'
      UNIRATE(13, 1)  = 0.0D0
      UNI_ACT( 13, 1) = 0.0D0
      UNI_TEXP(13, 1) = 0.0
      BICAUSE(13,1:5) = (/'OH ','HO ','O3 ','NO3', 'CL '/)
      BIRATE(13,1:5)  = (/1.69D-12, 1.69D-12, 0.0D0,1.84D-13, 1.27D-10/)
      BI_ACT(13,1:5)  = (/ -422.D0,  -422.D0, 0.0D0, 1764.D0, 0.0D0/)

C.. NAPHTHALENE

      REACT(14)       = 'NAPHTHALENE'
      BICAUSE(14,1:3) = (/'OH ','HO ','O3 '/)
      BIRATE(14,1:3)  = (/1.05D-12, 1.05D-12, 2.01D-19/)
      BI_ACT(14,1:3)  = (/ -901.D0,  -901.D0,    0.0D0/)
      TRICAUSE(14,1,1:2) = (/'NO3 ','NO2 '/)
      TRIRATE( 14,1)     =  3.94D-34
      TRI_ACT( 14,1)     = -4.10D+03

C.. QUINOLINE

      REACT(15)       = 'QUINOLINE'
      BICAUSE(15,1:4) = (/'OH ','HO ','O3 ','NO2'/)
      BIRATE(15,1:4)  = (/1.16D-11, 1.16D-11, 1.00D-19, 1.60D-20/)

C.. HEXAMETHYLENE DIISOCAYNATE

      REACT(16)       = 'HEXAMETHY_DIIS'
      BICAUSE(16,1:2) = (/'OH ','HO '/)
      BIRATE(16,1:2)  = (/7.94D-12, 7.94D-12/)

C.. HYDRAZINE

      REACT(17)       = 'HYDRAZINE'
      BICAUSE(17,1:3) = (/'OH ','HO ','O3 '/)
      BIRATE(17,1:3)  = (/3.60D-11, 3.60D-11, 3.00D-17/)

C.. MALEIC ANHYDRIDE

      REACT(18)       = 'MAL_ANHYDRIDE'
      BICAUSE(18,1:3) = (/'OH  ','HO  ','NO3 '/)
      BIRATE(18,1:3)  = (/1.45D-12, 1.45D-12, 1.02D-13/)

C.. TOULENE DIISOCYANATE 

      REACT(19)       = 'TOL_DIIS'
      BICAUSE(19,1:2) = (/'OH ','HO '/)
      BIRATE(19,1:2)  = (/7.41D-12, 7.41D-12/)

C.. TRIETHYLAMINE

      REACT(20)       = 'TRIETHYLAMINE'
      BICAUSE(20,1:5) = (/'OH  ','HO  ','O   ','O3P ', 'O3  '/)
      BIRATE(20,1:5)  = (/3.60D-11, 3.60D-11, 1.09D-11, 1.09D-11, 7.84D-18/)

C.. P-DICHLOROBENZENE 

      REACT(21)       = 'DICHLOROBENZENE'
      BICAUSE(21,1:2) = (/'OH ','HO '/)
      BIRATE(21,1:2)  = (/3.60D-13, 3.60D-13/)

C.. XYLENE

      REACT(22)       = 'XYLENE         '
      BICAUSE(22,1:3) = (/'OH','HO','CL'/)
      BIRATE(22,1:3)  = (/1.717D-11,                  1.717D-11,         1.433D-10/)

C.. STYRENE

      REACT(23)       = 'STYRENE        '
      BICAUSE(23,1:4) = (/'OH','HO','O3','CL'/)
      BIRATE(23,1:4)  = (/1.02D-11, 1.02D-11, 1.51D-13, 3.6D-10/)
      BI_ACT(23,1:2)  = (/   -532.0D0,  -532.0D0/)

C.. ACETONITRILE

      REACT(24)       = 'ACETONITRILE   '
      BICAUSE(24,1:3) = (/'OH','HO','CL'/)
      BIRATE(24,1:3)  = (/          8.31D-13,          8.31D-13,          1.60D-11/)
      BI_ACT(24,1:3)  = (/          1080.0D0,          1080.0D0,          2140.0D0/)

C.. ACRYACID

      REACT(25)       = 'ACRYACID       '
      BICAUSE(25,1:4) = (/'OH','HO','O3','CL'/)
      BIRATE(25,1:4)  = (/1.75D-11, 1.75D-11, 6.50D-19, 4.00D-10/)

C.. HEXANE 
 
      REACT(26)       = 'HEXANE         '
      BICAUSE(26,1:3) = (/'OH','HO','CL'/)
      BIRATE(26,1:3)  = (/          1.98D-11,          1.91D-11,          3.30D-10/)
      BI_ACT(26,1:2)  = (/           394.0D0,           394.0D0/)

C.. METHCHLORIDE
 
      REACT(27)       = 'METHCHLORIDE   '
      BICAUSE(27,1:3) = (/'OH','HO','CL'/)
      BIRATE(27,1:3)  = (/          2.10D-12,          2.10D-12,          1.80D-11/)
      BI_ACT(27,1:3)  = (/          1210.0D0,          1210.0D0,            1081D0/)

C.. CARBSULFIDE

      REACT(28)       = 'CARBSULFIDE    '
      BICAUSE(28,1:3) = (/'OH','HO','O3'/)
      BIRATE(28,1:3)  = (/          1.10D-13,          1.10D-13,           3.01D-16/)
      BI_ACT(28,1:2)  = (/          1200.0D0,          1200.0D0/)

C.. CHLOROPRENE

      REACT(29)       = 'CHLOROPRENE    '
      BICAUSE(29,1:5) = (/'OH ','HO ','O3 ','NO3','CL '/)
      BIRATE(29,1:5)  = (/          6.20D-11,          6.20D-11,          1.40D-16,
     &                              3.60D-13,          3.62D-10/)

C.. ETHYLBENZENE

      REACT(30)       = 'ETHYLBENZENE   '
      BICAUSE(30,1:4) = (/'OH ','HO ','NO3','CL '/)
      BIRATE(30,1:4)  = (/          7.00D-12,          7.00D-12,          5.70D-16,
     &                              1.15D-10/)

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/czangle.F,v 1.4 2012/03/28 16:05:37 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE  CZANGLE( JDATE, JTIME, NX, NY )

C----------------------------------------------------------------------
C Description:
C   Computes cosine of zenith angle for routine HRBIO()
C   The zenith angle is the angle measured from the zenith to the line of
C   sight to the sun
 
C Preconditions:
C   JDATE:JTIME represented in GMT
 
C Subroutines and Functions called:  none
 
C Revision History:
C   11/99: by Jeff Vukovich taken from v4.2 SMOKE prototype
C   10/06: yoj
C   02/11: Shawn Roselle: Replaced I/O API include files with UTILIO_DEFN
C   03/12: J. Bash: Bound COSZEN against numerical rounding errors
C   11/14: J. Bash: Lat and Lon now stored in ASX_DATA_MOD to reduce redundant
C             memory allocation and reads from file.
C   07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C   07 May 18 D. Schwede: Updated to have coszen defined in ASX_DATA_MOD
C   24 Jul 18 C. Nolte: removed call to INIT_MET that was causing conflict.
C             Met should already be initialized by this point.
C----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: czangle.F,v 1.4 2012/03/28 16:05:37 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/czangle.F,v $
C Last updated: $Date: 2012/03/28 16:05:37 $ 
C----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE ASX_DATA_MOD, Only: Grid_Data, Met_Data

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_CONST     ! constants

C Arguments:

      INTEGER, INTENT( IN )  :: JDATE   ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN )  :: JTIME   ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN )  :: NX      ! no. columns
      INTEGER, INTENT( IN )  :: NY      ! no. rows


C Parameters:
 
      REAL, PARAMETER ::
     &            AA =   0.15,
     &            BB =   3.885,
     &            CC = - 1.253,
     &          SIGA = 279.9348,
     &          SDEC =   0.39784984,  ! SIN (23^26'37.8") the declination angle
     &           D60 = 1.0 / 60.0,
     &           D15 = 1.0 / 15.0,
     &           D24 = 1.0 / 24.0,
     &        ROTDAY = 360.0 / 365.242 ! fraction of a complete rotation per day

C Local variables:

      INTEGER    IOS, R, C
      REAL       SLA, GMT,  TK, DAD, DF,
     &           DESIN, DECOS, DESIN2, DECOS2, SIG, DECSIN, DECCOS,
     &           EQT, TST, HRANGL
                     
      REAL, ALLOCATABLE, SAVE :: SINLAT( :,: )
      REAL, ALLOCATABLE, SAVE :: COSLAT( :,: )  

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 16 ) :: PNAME = 'CZANGLE'   !  procedure name

C----------------------------------------------------------------------

C compute sine of lat and lon first time through

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

         ALLOCATE( SINLAT( NX,NY  ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SINLAT', PNAME )

         ALLOCATE( COSLAT( NX,NY ), STAT=IOS )
         CALL CHECKMEM( IOS, 'COSLAT', PNAME )

         DO R = 1, NY
            DO C = 1, NX
               SLA = PI180 * Grid_Data%LAT( C,R )
               SINLAT( C,R ) = SIN( SLA )
               COSLAT( C,R ) = COS( SLA )
            END DO
         END DO

      END IF   ! if firstime

C Convert time to hours and add time-zone offset
      
      GMT    = FLOAT( JTIME / 10000 )                        !  hr part
     &       + D60 * ( FLOAT( MOD( JTIME / 100 , 100 ) )     !  min part
     &       + D60 *   FLOAT( MOD( JTIME, 100 ) ) )          !  sec part
      DAD    = GMT * D24 + MOD( JDATE, 1000 )
      DF     = ROTDAY * PI180 * DAD      !  The terrestrial-rotation angle
           
      DESIN  = SIN( DF )          !  SINE   of this angle
      DECOS  = COS( DF )          !  COSINE of this angle
           
      DESIN2 = SIN( DF + DF )     !  SINE   of twice the angle
      DECOS2 = COS( DF + DF )     !  COSINE of twice the angle
           
      SIG  =  DF
     &     +  PI180 * ( SIGA
     &                + 1.914827 * DESIN  - 0.079525 * DECOS
     &                + 0.019938 * DESIN2 - 0.00162  * DECOS2 )
           
C The sine and cosine of the declination
      
      DECSIN = SDEC * SIN( SIG )
      DECCOS = SQRT( 1.0 - DECSIN * DECSIN )
           
C The equation of time adjustment
      
      EQT = 0.123470 * DESIN  - 0.004289 * DECOS
     &    + 0.153809 * DESIN2 + 0.060783 * DECOS2

      DO R = 1, NY
         DO C = 1, NX

            TK     =  GMT + Grid_Data%LON( C,R ) * D15 !  Distance in hours from LON=0
            TST    =  TK - EQT                         !  true solar time
            HRANGL =  PI180 * 15.0 * ABS( TST - 12.0 ) !  hour angle
                   
C Compute the cosine of zenith angle (sine of the solar elevation)
          
            MET_DATA%COSZEN( C,R ) = DECSIN * SINLAT( C,R )
     &                    + DECCOS * COSLAT( C,R ) * COS( HRANGL )

C Bound against numerical rounding errors

            MET_DATA%COSZEN( C,R ) = MIN( MAX( MET_DATA%COSZEN( C,R ), -1.0 ), 1.0 )
                   
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


      MODULE SA_IRR_DEFN

C***********************************************************************
C20140428                       
C  
C  (1) Stores initial reaction rates in a C-R-L-nrxns array
C  (2) Contains subroutines SA_IRR_INIT
C                       and ACCUMRR
C
C    Aug 16, 2011: chemical integration time interval is in MINUTES
C
C***********************************************************************


      IMPLICIT NONE


      REAL, ALLOCATABLE :: RXINIT( :,:,:,: )
      REAL, ALLOCATABLE :: RKI_INIT( :,:,:,: )
      REAL, ALLOCATABLE :: YC_INIT( :,:,:,: )
      REAL, ALLOCATABLE :: PRDRATE( : )
      REAL, ALLOCATABLE :: RKMID ( : )

!20140307 Integrated Rates


      INTEGER              :: ISAM_CHEMISTRY_SPC ! number of ISAM species om photochemistry
      INTEGER, ALLOCATABLE :: ISAM_SPC_MAP( : ) ! index in ISAM species array
      INTEGER, ALLOCATABLE :: ISAM_TO_CHEM( : ) ! index is CHEMSITRY_SPC array
      LOGICAL, ALLOCATABLE :: CONVERT_ISAM( : ) ! whether to ISAM concentration for photochemsitry 
      
      REAL                   :: CONMIN_TAG               ! min tag concentration uploaded
      REAL( 8 )              :: NUMB_ISAM_CELLS = 0.0D0
      REAL( 8 )              :: DCONCMIN                 ! internal min concentration
      REAL( 8 )              :: DCONMIN_TAG              ! internal min tag concentration
      REAL( 8 )              :: UNIFORM_DCONMIN_TAG      ! min tag concentration evenly distributed
!      REAL( 8 ), ALLOCATABLE :: SRK( : )
      REAL( 8 ), ALLOCATABLE :: UGM3_TO_PPM( : )      ! CGRID to CHEM Species conversion factor
      REAL,      ALLOCATABLE :: PPM_TO_UGM3( : )      ! CHEM to CGRID Species conversion factor
      REAL( 8 ), ALLOCATABLE :: SOLD( :,: )           ! local source concentrations
!     REAL( 8 ), ALLOCATABLE :: FRAC_TOTAL( : )       ! tag's fraction in sum of tags;Used in SA_IRR_EXTRACT
!     REAL( 8 ), ALLOCATABLE :: ISAM_FRACTION ( :,: ) ! isam tag concentration over cgrid value
!     REAL( 8 ), ALLOCATABLE :: TOT_ISAM_RATIO( : )   ! sum of tag concentration over cgrid value
      
!      REAL( 8 ), ALLOCATABLE  :: MAX_ERROR ( : )
!      REAL( 8 ), ALLOCATABLE  :: RMSE_CONC ( : )
!      REAL( 8 ), ALLOCATABLE  :: BIAS_CONC ( : )
!      REAL( 8 ), ALLOCATABLE  :: MEAN_CONC ( : )
      
      LOGICAL, ALLOCATABLE :: ISAM_SPECIES( : )
      LOGICAL              :: ISAM_NOT_FOUND = .FALSE.
!      LOGICAL              :: ISAM_SUBSET    = .FALSE.



      TYPE SPECIES_BUDGET
         CHARACTER(16)        :: SPECIES_NAME = ' '
         INTEGER              :: NREACTIONS   = 0
         INTEGER, ALLOCATABLE :: IREACTION( : )
         REAL(8), ALLOCATABLE :: COEFF_NET( : )
         INTEGER              :: NRXNS_PROD   = 0
         INTEGER, ALLOCATABLE :: IRXN_PROD( : )
         REAL(8), ALLOCATABLE :: COEFF_POS( : )
         INTEGER              :: NRXNS_LOSS   = 0
         INTEGER, ALLOCATABLE :: IRXN_LOSS( : )
         REAL(8), ALLOCATABLE :: COEFF_NEG( : )
      END TYPE SPECIES_BUDGET
      
      TYPE(SPECIES_BUDGET), ALLOCATABLE :: MECHANISM_BUDGET ( : )
      TYPE(SPECIES_BUDGET), ALLOCATABLE :: OX_RADICAL_BUDGET( : )
      TYPE(SPECIES_BUDGET), ALLOCATABLE :: ISAM_SPC_BUDGET  ( : )
      
      INTEGER :: ISAM_LOG        ! Unit number of output log
      INTEGER :: ISAM_JDATE = 0
      INTEGER :: ISAM_JTIME = 0
      INTEGER :: ISAM_NSTEP = 0
#ifdef verbose_isam
      LOGICAL :: CHECK_ISAM  = .TRUE.
      LOGICAL :: WRITE_BUDGET_REPORT = .TRUE.
#else
      LOGICAL :: CHECK_ISAM  = .FALSE.
      LOGICAL :: WRITE_BUDGET_REPORT = .FALSE.
#endif      
      LOGICAL :: WRITE_CELL  = .FALSE.
      LOGICAL :: UPDATE_SOLD = .FALSE.
      LOGICAL :: UPDATE_PROBABILITIES = .FALSE.

      INTEGER, PARAMETER :: N_OX_RADICALS = 13
      CHARACTER( 16 )    :: OX_RADICALS( N_OX_RADICALS ) = 
     &                      (/ 'O               ',      
     &                         'O1D             ',      
     &                         'ACO3            ',      
     &                         'MEO3            ',      
     &                         'C2O3            ',      
     &                         'O3P             ',      
     &                         'NO              ',
     &                         'NO2             ',     
     &                         'NO3             ',     
     &                         'N2O5            ',     
     &                         'HO2             ',
     &                         'MEO2            ',
     &                         'MO2             ' /)
     
       LOGICAL, ALLOCATABLE :: IS_ISAM_OX_RADICAL( : )
       LOGICAL, ALLOCATABLE :: IS_CHEM_OX_RADICAL( : )
       LOGICAL, ALLOCATABLE :: IS_TAG_NONZERO( : )

       INTEGER              :: OX_RADICAL_FOUND = 0   
       INTEGER              :: OZONE_INDEX      = 0     
       INTEGER, ALLOCATABLE :: OX_INDEX ( : )
       
       LOGICAL :: ISAM_WITH_OZONE = .FALSE.

       REAL( 8 ), PARAMETER, PRIVATE :: ONE    = 1.0D0
       REAL( 8 ), PARAMETER, PRIVATE :: ZERO   = 0.0D0
       REAL( 8 ), PARAMETER, PRIVATE :: CUTOFF = 1.0D-23
       REAL( 8 ), PARAMETER, PRIVATE :: BULK_CUTOFF = ZERO
       
      CONTAINS
        SUBROUTINE SA_IRR_INIT

          USE HGRD_DEFN
          USE VGRD_DEFN
          USE UTILIO_DEFN
          USE RXNS_DATA
          USE SA_DEFN
C Initialize arrays and maps that store reaction rates in each grid cell and that
C         relate ISAM species to chemistry species
C
C         Called by chemistry driver

        IMPLICIT NONE

C..Includes:
         INCLUDE SUBST_CONST     ! CMAQ constants
 
         CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_IRR_INIT'     ! Program name

         INTEGER :: I, J, RXN, IP, IL 
         INTEGER :: IOSTAT
         INTEGER :: C, L, R, S   ! Loop indices
         INTEGER :: SPC          ! array index
         INTEGER :: IOS


         CHARACTER( 132 ) :: MSG           ! Message text
! temporary arrays to set maps between isam to chemistry species
         INTEGER, ALLOCATABLE :: ISAM_SPC_IDX( : )
         INTEGER, ALLOCATABLE :: ISAM_2_CHEMI( : )
         LOGICAL, ALLOCATABLE :: NO_CHEMISTRY( : )

         CHARACTER(16), ALLOCATABLE :: FIND_IN_ISAM( : )

! temporary variables to define MECHANISM_BUDGET

         INTEGER, ALLOCATABLE :: IREACTION( : )
         INTEGER, ALLOCATABLE :: IRXN_PROD( : )
         INTEGER, ALLOCATABLE :: IRXN_LOSS( : )
         REAL(8), ALLOCATABLE :: COEFF_NET( : )
         REAL(8), ALLOCATABLE :: COEFF_POS( : )
         REAL(8), ALLOCATABLE :: COEFF_NEG( : )
         REAL(8)              :: COEFF
         
C=======================================================

        ISAM_LOG = INIT3( )
        


        ALLOCATE( ISAM_2_CHEMI( NSPC_SA + 1 ) )
        ALLOCATE( ISAM_SPC_IDX( NSPC_SA + 1 ) )
        ALLOCATE( NO_CHEMISTRY( NSPC_SA + 1 ) )
        ALLOCATE( FIND_IN_ISAM( NSPC_SA + 1 ) )
        ! krt Identify species index in ISAM array
        ISAM_SPC_IDX = 0
        ISAM_2_CHEMI = 0
        NO_CHEMISTRY = .TRUE.
        FIND_IN_ISAM = ' '

        SPC = 0
        
        DO S = 1, NSPC_SA
           FIND_IN_ISAM( S ) = SPC_NAME( S,OTHRTAG )
           ISAM_SPC_IDX( S ) = S
        END DO
        SPC = NSPC_SA
! find tagged species in chemistry_spc array to set value of convert_isam
        ISAM_CHEMISTRY_SPC = 0
        DO S = 1, SPC
           R  = INDEX1( TRIM(FIND_IN_ISAM( S )), NUMB_MECH_SPC, CHEMISTRY_SPC )
           IF ( R .LE. 0 ) THEN
              MSG = 'ISAM SPECIES: ' 
     &           // TRIM( FIND_IN_ISAM( S ) ) 
     &           // ' not found in CHEMISTRY_SPC array  '
              CALL M3WARN( PNAME, 0, 0, MSG )
              CYCLE
           END IF
           ISAM_CHEMISTRY_SPC = ISAM_CHEMISTRY_SPC
     &                        + 1           
           ISAM_2_CHEMI( S )  = R
           NO_CHEMISTRY( S )  = .FALSE.
        END DO

        IF( ANY(  .NOT. NO_CHEMISTRY ) )THEN
C..Save pointer for isam species found in chemistry species
           ALLOCATE( ISAM_TO_CHEM( ISAM_CHEMISTRY_SPC ) )
           ALLOCATE( ISAM_SPC_MAP( ISAM_CHEMISTRY_SPC ) )
           WRITE(ISAM_LOG,'(/A)')'Below isam species participate in photochemistry'
           WRITE(ISAM_LOG,'("SPC     ISAM_SPC     SPC PHOTOCHEM_SPC  ")')
           L = 0 
           DO S = 1, SPC
              IF ( .NOT. NO_CHEMISTRY( S ) ) THEN
                 L = L + 1
                 C = ISAM_SPC_IDX( S )
                 R = ISAM_2_CHEMI( S )
                 ISAM_SPC_MAP( L ) = ISAM_SPC_IDX( S )
                 ISAM_TO_CHEM( L ) = ISAM_2_CHEMI( S )
                 WRITE(ISAM_LOG,'(I3,1X,A16,1x,I3,1X,A16)') 
     &           C, FIND_IN_ISAM( S ), R, CHEMISTRY_SPC( R )
              END IF
           END DO
           IF( L .NE. ISAM_CHEMISTRY_SPC )THEN
             MSG = 'ERROR mapping isam to chemistry species: inconsistent number found'
             CALL M3EXIT ( PNAME, 0, 0, MSG, XSTAT1 )
           END IF
        ELSE
           MSG = 'NO ISAM species participate in photochemistry '
           CALL M3WARN ( PNAME, 0, 0, MSG )
        END IF
        L = 0
        DO S = 1, SPC
           IF( NO_CHEMISTRY( S ) )THEN
                C = ISAM_SPC_IDX( S )
                IF( C .LE. 0 )CYCLE
                L = L + 1
                IF( L .LT. 2 )THEN
                    WRITE(ISAM_LOG,'(/A)')'Below isam species DO NOT participate in photochemistry'
                    WRITE(ISAM_LOG,'("SPC     ISAM_SPC")')
                END IF    
                WRITE(ISAM_LOG,'(I3,1X,A16,1x,I3,A16)') C, FIND_IN_ISAM( S )
           END IF
        END DO

        DEALLOCATE( ISAM_2_CHEMI )
        DEALLOCATE( ISAM_SPC_IDX )
        DEALLOCATE( NO_CHEMISTRY )

C...Allocate and set conversion factors for isam chemistry species
        ALLOCATE( CONVERT_ISAM( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating CONVERT_ISAM'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
              
        ALLOCATE( UGM3_TO_PPM( ISAM_CHEMISTRY_SPC ),
     &            PPM_TO_UGM3( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating UGM3_TO_PPM or PPM_TO_UGM3'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        ALLOCATE( IS_ISAM_OX_RADICAL( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating IS_ISAM_A_RADICAL'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        IS_ISAM_OX_RADICAL = .FALSE.

        ALLOCATE( IS_CHEM_OX_RADICAL( NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating IS_ISAM_A_RADICAL'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        IS_CHEM_OX_RADICAL = .FALSE.

        WRITE(ISAM_LOG,'(/A)')'Final Table of ISAM chemistry species'
        WRITE(ISAM_LOG,'("SPC     ISAM_SPC     SPC PHOTOCHEM_SPC  Mol.Wei Convert Conc. Radical Spc")')
              
        ALLOCATE( IS_TAG_NONZERO( NTAG_SA ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating IS_TAG_NONZERO'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

!       ALLOCATE( FRAC_TOTAL( NTAG_SA ), STAT = IOS )
!       IF ( IOS .NE. 0 ) THEN
!            MSG = 'Error allocating FRAC_TOTAL'
!            CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
!       END IF 

        ALLOCATE( ISAM_SPECIES( NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating ISAM_SPECIES'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF
        ISAM_SPECIES = .FALSE. 

        DO S = 1, ISAM_CHEMISTRY_SPC
           C = ISAM_SPC_MAP( S )
           R = ISAM_TO_CHEM( S )
           IF( FIND_IN_ISAM( C ) .EQ. 'O3' )THEN
               ISAM_WITH_OZONE = .TRUE.
               OZONE_INDEX     =  R
               WRITE(ISAM_LOG,'(A)')'ISAM Species include ozone'
           END IF    
           DO L = 1, N_OX_RADICALS
              IF( FIND_IN_ISAM( C ) .EQ. OX_RADICALS( L ) )THEN
                  IS_ISAM_OX_RADICAL( S ) = .TRUE.
              END IF    
              IF( CHEMISTRY_SPC( R ) .EQ. OX_RADICALS( L ) )THEN
                  IS_CHEM_OX_RADICAL( R ) = .TRUE.
                  OX_RADICAL_FOUND        = OX_RADICAL_FOUND + 1
              END IF    
           END DO
           CONVERT_ISAM( S ) = CONVERT_CONC( R )
           ISAM_SPECIES( R ) = .TRUE.
           UGM3_TO_PPM ( S ) = REAL( 1.0E-3 * MWAIR / SPECIES_MOLWT( R ), 8 )
           PPM_TO_UGM3 ( S ) = 1.0E+3 / MWAIR * SPECIES_MOLWT( R )
           WRITE(ISAM_LOG,'(I3,1X,A16,1x,I3,1X,A16,2X,F7.2,3(1X,L14))') 
     &     C, FIND_IN_ISAM( C ), R, CHEMISTRY_SPC( R ), SPECIES_MOLWT( R ), 
     &     CONVERT_ISAM( S ), IS_ISAM_OX_RADICAL( S ),IS_CHEM_OX_RADICAL( R )
        END DO
        
        DEALLOCATE( FIND_IN_ISAM )

        ALLOCATE( OX_INDEX( OX_RADICAL_FOUND ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating SOLD'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        OX_INDEX = 0

        DCONMIN_TAG = 1.0D-40 
        DCONCMIN    = 1.0D-30 
        CONMIN_TAG  = 1.0E-30
         
        UNIFORM_DCONMIN_TAG = DCONMIN_TAG / REAL( NTAG_SA,8 ) 

        ALLOCATE( SOLD( NTAG_SA, NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating SOLD'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 
        
        ALLOCATE( MECHANISM_BUDGET( NUMB_MECH_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating MECHANISM_BUDGET'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        ALLOCATE( IREACTION( NRXNS ),
     &            IRXN_PROD( NRXNS ),
     &            IRXN_LOSS( NRXNS ),
     &            COEFF_POS( NRXNS ),
     &            COEFF_NEG( NRXNS ),
     &            COEFF_NET( NRXNS ),  STAT = IOS )     
        IF ( IOS .NE. 0 ) THEN
           MSG = 'Error allocating IREACTION and COEFF_NET arrays'
           CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        ISAM_WITH_OZONE = ( ISAM_WITH_OZONE .AND. OX_RADICAL_FOUND .GT. 0 )
        IF( OX_RADICAL_FOUND .GT. 0  )THEN
           ALLOCATE( OX_RADICAL_BUDGET( OX_RADICAL_FOUND ), STAT = IOS )
           IF ( IOS .NE. 0 ) THEN
              MSG = 'Error allocating MECHANISM_BUDGET'
              CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
           END IF 
        END IF

! find how reactions affect all chemistry species
        L = 0
        DO SPC = 1, NUMB_MECH_SPC
           S  = 0
           IP = 0
           IL = 0
           MECHANISM_BUDGET( SPC )%SPECIES_NAME = CHEMISTRY_SPC( SPC )
           MECHANISM_BUDGET( SPC )%NREACTIONS   = 0
           MECHANISM_BUDGET( SPC )%NRXNS_PROD   = 0
           MECHANISM_BUDGET( SPC )%NRXNS_LOSS   = 0
           IREACTION = 0
           COEFF_NET = 0.0D0
           COEFF_POS = 0.0D0
           COEFF_NEG = 0.0D0           
! set indices for Ox radicals
           IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
               L = L + 1
               OX_INDEX( L ) = SPC
               OX_RADICAL_BUDGET( L )%SPECIES_NAME = CHEMISTRY_SPC( SPC )
               OX_RADICAL_BUDGET( L )%NREACTIONS   = 0
               OX_RADICAL_BUDGET( L )%NRXNS_PROD   = 0
               OX_RADICAL_BUDGET( L )%NRXNS_LOSS   = 0
           END IF    
! find effect on CHEMISTRY_SPC( SPC ) and save results
           DO R = 1, NRXNS
              COEFF = EFFECT_REACTION( SPC, R, C )
              IF( ABS( COEFF ) .GT. 1.0D-8 )THEN
                 S = S + 1
                 IREACTION( S ) = R
                 COEFF_NET( S ) = COEFF
                 IF( COEFF  .GT. 0.0D0 )THEN
                   IP = IP + 1
                   IRXN_PROD( IP ) = R
                   COEFF_POS( IP ) = COEFF
                 ELSE
                   IL = IL + 1
                   IRXN_LOSS( IL ) = R
                   COEFF_NEG( IL ) = ABS( COEFF )
                 END IF
              END IF
           END DO
! set up species budget                
           IF( S .GT. 0 )THEN
               MECHANISM_BUDGET( SPC )%NREACTIONS = S
               ALLOCATE( MECHANISM_BUDGET( SPC )%IREACTION( S ),
     &                   MECHANISM_BUDGET( SPC )%COEFF_NET( S ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating bulk MECHANISM_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF 
               MECHANISM_BUDGET( SPC )%IREACTION( 1:S ) = IREACTION( 1:S )
               MECHANISM_BUDGET( SPC )%COEFF_NET( 1:S ) = COEFF_NET( 1:S )
               IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
                   OX_RADICAL_BUDGET( L )%NREACTIONS = S
                   ALLOCATE( OX_RADICAL_BUDGET( L )%IREACTION( S ),
     &                       OX_RADICAL_BUDGET( L )%COEFF_NET( S ),  STAT = IOS )
                   IF ( IOS .NE. 0 ) THEN
                       MSG = 'Error allocating production OX_RADICAL_BUDGET arrays'
                       CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                   END IF 
                   OX_RADICAL_BUDGET( L )%IREACTION( 1:S )  = IRXN_PROD( 1:S )
                   OX_RADICAL_BUDGET( L )%COEFF_NET( 1:S )  = COEFF_NET( 1:S )
               END IF
               IF( IP .GT. 0 )THEN
! define production information
                  MECHANISM_BUDGET( SPC )%NRXNS_PROD = IP
                  ALLOCATE( MECHANISM_BUDGET( SPC )%IRXN_PROD( IP ),
     &                      MECHANISM_BUDGET( SPC )%COEFF_POS( IP ),  STAT = IOS )
                  IF ( IOS .NE. 0 ) THEN
                       MSG = 'Error allocating production MECHANISM_BUDGET arrays'
                      CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                  END IF 
                  MECHANISM_BUDGET( SPC )%IRXN_PROD( 1:IP )  = IRXN_PROD( 1:IP )
                  MECHANISM_BUDGET( SPC )%COEFF_POS( 1:IP )  = COEFF_POS( 1:IP )
! capture production information if OX radical
                  IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
                     OX_RADICAL_BUDGET( L )%NRXNS_PROD = IP
                     ALLOCATE( OX_RADICAL_BUDGET( L )%IRXN_PROD( IP ),
     &                         OX_RADICAL_BUDGET( L )%COEFF_POS( IP ),  STAT = IOS )
                     IF ( IOS .NE. 0 ) THEN
                         MSG = 'Error allocating production OX_RADICAL_BUDGET arrays'
                         CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                     END IF 
                     OX_RADICAL_BUDGET( L )%IRXN_PROD( 1:IP )  = IRXN_PROD( 1:IP )
                     OX_RADICAL_BUDGET( L )%COEFF_POS( 1:IP )  = COEFF_POS( 1:IP )
                  END IF
               END IF
               
               IF( IL .GT. 0 )THEN
! define destruction information
                  MECHANISM_BUDGET( SPC )%NRXNS_LOSS = IL
                  ALLOCATE( MECHANISM_BUDGET( SPC )%IRXN_LOSS( IL ),
     &                      MECHANISM_BUDGET( SPC )%COEFF_NEG( IL ),  STAT = IOS )
                  IF ( IOS .NE. 0 ) THEN
                       MSG = 'Error allocating destruction MECHANISM_BUDGET arrays'
                      CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                  END IF 
                  MECHANISM_BUDGET( SPC )%IRXN_LOSS( 1:IL ) = IRXN_LOSS( 1:IL )
                  MECHANISM_BUDGET( SPC )%COEFF_NEG( 1:IL ) = COEFF_NEG( 1:IL )
! capture destruction information if OX radical
                  IF( IS_CHEM_OX_RADICAL( SPC ) )THEN
                     OX_RADICAL_BUDGET( L )%NRXNS_LOSS = IL
                     ALLOCATE( OX_RADICAL_BUDGET( L )%IRXN_LOSS( IL ),
     &                         OX_RADICAL_BUDGET( L )%COEFF_NEG( IL ),  STAT = IOS )
                     IF ( IOS .NE. 0 ) THEN
                         MSG = 'Error allocating production OX_RADICAL_BUDGET arrays'
                         CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
                     END IF 
                     OX_RADICAL_BUDGET( L )%IRXN_LOSS( 1:IL )  = IRXN_LOSS( 1:IL )
                     OX_RADICAL_BUDGET( L )%COEFF_NEG( 1:IL )  = COEFF_NET( 1:IL )
                  END IF
               END IF
           END IF                  
        END DO

        DEALLOCATE( IREACTION,
     &              IRXN_PROD,
     &              IRXN_LOSS,
     &              COEFF_POS,
     &              COEFF_NEG,
     &              COEFF_NET )     


        ALLOCATE( ISAM_SPC_BUDGET( ISAM_CHEMISTRY_SPC ), STAT = IOS )
        IF ( IOS .NE. 0 ) THEN
             MSG = 'Error allocating ISAM_SPC_BUDGET'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
        END IF 

        DO SPC = 1, ISAM_CHEMISTRY_SPC
           R = ISAM_TO_CHEM( SPC )
           ISAM_SPC_BUDGET( SPC )%SPECIES_NAME = MECHANISM_BUDGET( R )%SPECIES_NAME
           ISAM_SPC_BUDGET( SPC )%NREACTIONS   = MECHANISM_BUDGET( R )%NREACTIONS  
           ISAM_SPC_BUDGET( SPC )%NRXNS_PROD   = MECHANISM_BUDGET( R )%NRXNS_PROD  
           ISAM_SPC_BUDGET( SPC )%NRXNS_LOSS   = MECHANISM_BUDGET( R )%NRXNS_LOSS  
! define net information
           S =  ISAM_SPC_BUDGET( SPC )%NREACTIONS
           IF( S .GT. 0 )THEN
               ALLOCATE( ISAM_SPC_BUDGET( SPC )%IREACTION( S ),
     &                   ISAM_SPC_BUDGET( SPC )%COEFF_NET( S ),  STAT = IOS )
               IF ( IOS .NE. 0 ) THEN
                    MSG = 'Error allocating bulk ISAM_SPC_BUDGET arrays'
                   CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
               END IF 
               ISAM_SPC_BUDGET( SPC )%IREACTION( 1:S ) = MECHANISM_BUDGET( R )%IREACTION( 1:S )
               ISAM_SPC_BUDGET( SPC )%COEFF_NET( 1:S ) = MECHANISM_BUDGET( R )%COEFF_NET( 1:S )
           END IF          
           IP = ISAM_SPC_BUDGET( SPC )%NRXNS_PROD
           IF( IP .GT. 0 )THEN
! define production information
              ALLOCATE( ISAM_SPC_BUDGET( SPC )%IRXN_PROD( IP ),
     &                  ISAM_SPC_BUDGET( SPC )%COEFF_POS( IP ),  STAT = IOS )
              IF ( IOS .NE. 0 ) THEN
                  MSG = 'Error allocating production ISAM_SPC_BUDGET arrays'
                  CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
              END IF 
              ISAM_SPC_BUDGET( SPC )%IRXN_PROD( 1:IP )  = MECHANISM_BUDGET( R )%IRXN_PROD( 1:IP )
              ISAM_SPC_BUDGET( SPC )%COEFF_POS( 1:IP )  = MECHANISM_BUDGET( R )%COEFF_POS( 1:IP )
           END IF       
           IL = ISAM_SPC_BUDGET( SPC )%NRXNS_LOSS
           IF( IL .GT. 0 )THEN
! define destruction information
              ALLOCATE( ISAM_SPC_BUDGET( SPC )%IRXN_LOSS( IL ),
     &                  ISAM_SPC_BUDGET( SPC )%COEFF_NEG( IL ),  STAT = IOS )
              IF ( IOS .NE. 0 ) THEN
                  MSG = 'Error allocating production ISAM_SPC_BUDGET arrays'
                  CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
              END IF 
              ISAM_SPC_BUDGET( SPC )%IRXN_LOSS( 1:IL )  = MECHANISM_BUDGET( R )%IRXN_LOSS( 1:IL )
              ISAM_SPC_BUDGET( SPC )%COEFF_NEG( 1:IL )  = MECHANISM_BUDGET( R )%COEFF_NEG( 1:IL )
           END IF  
           WRITE(ISAM_LOG,*)SPC, ISAM_SPC_BUDGET( SPC )%SPECIES_NAME,IP,IL    
        END DO          
        
! report budget for mechanism species and OX radicals
        IF( WRITE_BUDGET_REPORT ) THEN
            CALL REPORT_MECH_BUDGET( ISAM_LOG )
            IF( OX_RADICAL_FOUND .GT. 0  )THEN
               CALL REPORT_OX_RADICALS( ISAM_LOG )
            ELSE
               MSG = "Note that no Oxygen Radicals were found in mechanism."   
               WRITE(ISAM_LOG,'(A)')TRIM( MSG )
            END IF
            IF( ISAM_CHEMISTRY_SPC .GT. 0 )THEN
               CALL REPORT_ISAM_BUDGET( ISAM_LOG )
            ELSE
               MSG = "Note that ISAM found in mechanism."   
               WRITE(ISAM_LOG,'(A)')TRIM( MSG )
            END IF
        END IF    
        
        END SUBROUTINE SA_IRR_INIT
      REAL(8) FUNCTION EFFECT_REACTION( NAMINDX, NRX, OCCURS )

C-----------------------------------------------------------------------
C Function: To find net effect on the number of species molecules from a reaction 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Bill Hutzell, May, 2018
C-----------------------------------------------------------------------
      USE RXNS_DATA

      IMPLICIT NONE
      
C Includes: None
      
C Arguments:
      INTEGER,        INTENT(IN )   :: NAMINDX  ! Index for chemistry species 
      INTEGER,        INTENT(IN )   :: NRX      ! Reaction number
      INTEGER,        INTENT(INOUT) :: OCCURS   ! Number of products and reaction 
                                        
C Parameters: None

C External Functions: None 

C Local Variables:

      CHARACTER( 16 ) :: SPECIS    ! Species name to check

      INTEGER INDX       ! Pointer to reactant or product in CHEMISTRY_SPC array
      INTEGER IRRPNTR    ! Pointer to reactant or product in IRR array
      INTEGER N          ! Loop index over IRR array

      REAL(8) TOTAL      ! Sum of molecular production and loss coeffecients
         
C-----------------------------------------------------------------------
      OCCURS = 0
      TOTAL  = 0.0D0

      SPECIS = CHEMISTRY_SPC( NAMINDX )
c..Subtract the number of species molecules lost in this reaction
      DO N = 1, NREACT( NRX )
         INDX = IRR( NRX, N )
         IF ( INDX .EQ. NAMINDX ) THEN
             TOTAL  = TOTAL - 1.0D0
             OCCURS = OCCURS + 1
         END IF    
      END DO
      
c..Add the number of species molecules produced in this reaction
      DO N = 1, NPRDCT( NRX )
         IRRPNTR = N + 3
         INDX = IRR( NRX, IRRPNTR )
         IF ( INDX .EQ. NAMINDX ) THEN
             TOTAL  = TOTAL + REAL( SC( NRX,N ), 8)
             OCCURS = OCCURS + 1
         END IF    
      END DO

      EFFECT_REACTION = TOTAL

      RETURN

      END FUNCTION EFFECT_REACTION
      SUBROUTINE REPORT_MECH_BUDGET( OUT_UNIT )
!        purpose writes out 
         USE RXNS_DATA

         IMPLICIT NONE


!..Arguments:
         INTEGER,   INTENT( IN ) ::  OUT_UNIT  ! output unit #
         
        INTEGER SPC
        INTEGER IR, NR
         
        DO SPC = 1, NUMB_MECH_SPC
           WRITE(OUT_UNIT,95000)MECHANISM_BUDGET( SPC )%SPECIES_NAME, 
     &                          MECHANISM_BUDGET( SPC )%NREACTIONS
           DO NR = 1, MECHANISM_BUDGET( SPC )%NREACTIONS
              IR = MECHANISM_BUDGET( SPC )%IREACTION( NR )
              WRITE(OUT_UNIT,95001)RXLABEL( IR ),MECHANISM_BUDGET( SPC )%COEFF_NET( NR )
           END DO
              WRITE(OUT_UNIT,95005)MECHANISM_BUDGET( SPC )%SPECIES_NAME, 
     &                             MECHANISM_BUDGET( SPC )%NRXNS_PROD
              DO NR = 1, MECHANISM_BUDGET( SPC )%NRXNS_PROD
                 IR = MECHANISM_BUDGET( SPC )%IRXN_PROD( NR )
                 WRITE(OUT_UNIT,95001)RXLABEL( IR ),MECHANISM_BUDGET( SPC )%COEFF_POS( NR )
              END DO
        END DO
        
95000   FORMAT("Chemistry species, ",A16,", changed by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95001   FORMAT(3X,A16,1X,ES12.4)
95005   FORMAT("Radical  species, ",A16,", produced by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )

      END SUBROUTINE REPORT_MECH_BUDGET    
      SUBROUTINE REPORT_OX_RADICALS( OUT_UNIT )
!        purpose writes out production and loss reaction for each OX radical
         USE RXNS_DATA

         IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  OUT_UNIT  ! output unit #
         
        INTEGER SPC
        INTEGER IR, NR
         
        DO SPC = 1, OX_RADICAL_FOUND
           IF( OX_RADICAL_BUDGET( SPC )%NRXNS_PROD .GT. 0 )THEN
              WRITE(OUT_UNIT,95005)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME, 
     &                             OX_RADICAL_BUDGET( SPC )%NRXNS_PROD
              DO NR = 1, OX_RADICAL_BUDGET( SPC )%NRXNS_PROD
                 IR = OX_RADICAL_BUDGET( SPC )%IRXN_PROD( NR )
                 WRITE(OUT_UNIT,95001)RXLABEL( IR ),OX_RADICAL_BUDGET( SPC )%COEFF_POS( NR )
              END DO
           ELSE   
              WRITE(OUT_UNIT,95003)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME 
           END IF   
           IF( OX_RADICAL_BUDGET( SPC )%NRXNS_LOSS .GT. 0 )THEN
              WRITE(OUT_UNIT,95002)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME, 
     &                             OX_RADICAL_BUDGET( SPC )%NRXNS_LOSS
              DO NR = 1, OX_RADICAL_BUDGET( SPC )%NRXNS_LOSS
                 IR = OX_RADICAL_BUDGET( SPC )%IRXN_LOSS( NR )
                 WRITE(OUT_UNIT,95001)RXLABEL( IR ),OX_RADICAL_BUDGET( SPC )%COEFF_NEG( NR )
              END DO
           ELSE
              WRITE(OUT_UNIT,95004)OX_RADICAL_BUDGET( SPC )%SPECIES_NAME 
           END IF   
        END DO
        
95005   FORMAT("Radical  species, ",A16,", produced by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95001   FORMAT(3X,A16,1X,ES12.4)
95002   FORMAT("Radical  species, ",A16,", destoryed by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95003   FORMAT(A16, " radical not produced by any reactions.")
95004   FORMAT(A16, " radical not destoryed by any reactions.")

      END SUBROUTINE REPORT_OX_RADICALS
      SUBROUTINE REPORT_ISAM_BUDGET( OUT_UNIT )
!        purpose writes out 
         USE RXNS_DATA

         IMPLICIT NONE


!..Arguments:
         INTEGER,   INTENT( IN ) ::  OUT_UNIT  ! output unit #
         
        INTEGER SPC
        INTEGER IR, NR
         
        DO SPC = 1, ISAM_CHEMISTRY_SPC
           WRITE(OUT_UNIT,95100)ISAM_SPC_BUDGET( SPC )%SPECIES_NAME, 
     &                          ISAM_SPC_BUDGET( SPC )%NREACTIONS
           DO NR = 1, ISAM_SPC_BUDGET( SPC )%NREACTIONS
              IR = ISAM_SPC_BUDGET( SPC )%IREACTION( NR )
              WRITE(OUT_UNIT,95101)RXLABEL( IR ),ISAM_SPC_BUDGET( SPC )%COEFF_NET( NR )
           END DO
              WRITE(OUT_UNIT,95105)ISAM_SPC_BUDGET( SPC )%SPECIES_NAME, 
     &                             ISAM_SPC_BUDGET( SPC )%NRXNS_PROD
              DO NR = 1, ISAM_SPC_BUDGET( SPC )%NRXNS_PROD
                 IR = ISAM_SPC_BUDGET( SPC )%IRXN_PROD( NR )
                 WRITE(OUT_UNIT,95101)RXLABEL( IR ),ISAM_SPC_BUDGET( SPC )%COEFF_POS( NR )
              END DO
        END DO
        
95100   FORMAT("   ISAM  species, ",A16,", changed by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )
95101   FORMAT(3X,A16,1X,ES12.4)
95105   FORMAT("   ISAM  species, ",A16,", produced by the ",I4," below reactions",
     &         / 3X, "Reaction Label  ",1X,"Net Coeff."  )

      END SUBROUTINE REPORT_ISAM_BUDGET    
      SUBROUTINE SA_IRR_EXTRACT( COL, ROW, LAY, DENS, CONC )
                
          USE HGRD_DEFN
          USE VGRD_DEFN
          USE RXNS_DATA
          USE UTILIO_DEFN
          USE SA_DEFN  

         IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  COL        ! cell column index
         INTEGER,   INTENT( IN ) ::  ROW        ! cell row index 
         INTEGER,   INTENT( IN ) ::  LAY        ! cell layer index      
         REAL,      INTENT( IN ) ::  DENS       ! air mass density, kg/m3
         REAL(8),   INTENT( IN ) ::  CONC( : )  ! cgrid concentrations

C..Includes:
         INCLUDE SUBST_CONST     ! CMAQ constants

!..Local:
         CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_IRR_EXTRACT'     ! Program name

         REAL      :: FACTOR2
         REAL( 8 ) :: TOTAL, FACTOR1, FACTOR3
         REAL( 8 ) :: INV_DENS       ! one over air mass density, m3/kg

         INTEGER :: JSPC, KTAG
!..variables borrowed from DDM
         INTEGER :: I, J, RXN
         INTEGER :: C, L, R, S   ! Loop indices
         INTEGER :: SPC          ! array index
!        REAL(8) :: TAGS_TOTAL
         
!         INTEGER :: IOS         
!         CHARACTER( 132 )  :: MSG

          SOLD = ZERO

          INV_DENS = REAL( ONE/DENS, 8 )
          
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             S       = ISAM_TO_CHEM( JSPC )
             SPC     = ISAM_SPC_MAP( JSPC )
             IS_TAG_NONZERO = .FALSE.
             LOAD_SOLD: DO KTAG = 1, NTAG_SA
                SOLD( KTAG, S ) = MAX( ZERO,
     &                            REAL( ISAM( COL,ROW,LAY,SPC,KTAG ),8 ))
             END DO LOAD_SOLD ! ktag loop
!            TAGS_TOTAL = SUM( SOLD( 1:NTAG_SA, S ) )
!            TAGS_TOTAL = 1.0D0 / MAX( TAGS_TOTAL, DCONMIN_TAG )
             FILTER_SOLD: DO KTAG = 1, NTAG_SA
!               FRAC_TOTAL( KTAG ) = SOLD( KTAG, S ) * TAGS_TOTAL
                IF( SOLD( KTAG, S ) .GT. ZERO )THEN
                   IS_TAG_NONZERO( KTAG ) = .TRUE.
                   IF( CONVERT_ISAM( JSPC ) )THEN
                      SOLD( KTAG, S ) = SOLD( KTAG, S )
     &                                * INV_DENS * UGM3_TO_PPM( JSPC )
                   END IF
                   IF( SOLD( KTAG,S ) .LT. CUTOFF )THEN
                      SOLD( KTAG,S ) = ZERO
                   END IF
                END IF
             END DO FILTER_SOLD ! ktag loop

! Remove bangs to prevent All SOLD equaling zero               
!             IF( MAXVAL( SOLD( 1:NTAG_SA,S ) ) .LE. ZERO )THEN
!                IF( ANY( IS_TAG_NONZERO ) )THEN
!                    DO KTAG = 1, NTAG_SA                    
!                       IF( IS_TAG_NONZERO( KTAG ) )THEN
!                          SOLD( KTAG,S ) = FRAC_TOTAL( KTAG ) * DCONMIN_TAG
!                       END IF
!                    END DO
!             END IF    
          END DO ! loop jspc

#ifdef verbose_isam          
          IF( WRITE_CELL )THEN
             DO KTAG = 1, NTAG_SA
               WRITE(ISAM_LOG,*)' '
               WRITE(ISAM_LOG,'(A24,2(1X,ES12.4))')'Initial MAX Values',
     &         MAXVAL(ISAM(:,:,:,:,KTAG))
             END DO ! ktag loop
             DO JSPC = 1, NSPC_SA 
                  TOTAL = SUM( ISAM( COL,ROW,LAY,JSPC,1:NTAG_SA ) )
                  WRITE(ISAM_LOG,'(A16,11(1X,ES12.4))')SPC_NAME( JSPC,OTHRTAG ),
     &            (ISAM( COL,ROW,LAY,JSPC,KTAG ),KTAG = 1, NTAG_SA), TOTAL
             END DO
             WRITE(ISAM_LOG,*)'EX: Initial Totals'
             DO JSPC = 1, ISAM_CHEMISTRY_SPC
                S   = ISAM_TO_CHEM( JSPC )
                SPC = ISAM_SPC_MAP( JSPC ) 
                TOTAL = 0.0
                DO KTAG = 1, NTAG_SA
                   TOTAL = TOTAL + ISAM( COL,ROW,LAY,SPC,KTAG )
                END DO 
                WRITE(ISAM_LOG,'(2(A16,1X),5(1X,ES12.4))')SPC_NAME( SPC,OTHRTAG ), CHEMISTRY_SPC(S), 
     &          TOTAL, CONC( S ),TOTAL-CONC( S ), TOTAL/CONC( S )
             END DO ! loop jspc
          END IF
#endif
        END SUBROUTINE SA_IRR_EXTRACT
        SUBROUTINE SA_IRR_UPLOAD( COL, ROW, LAY, DENS, CONC )
                
          USE HGRD_DEFN
          USE VGRD_DEFN
          USE RXNS_DATA
          USE UTILIO_DEFN
          USE SA_DEFN    ! 20130517

         IMPLICIT NONE

!..Arguments:
         INTEGER,   INTENT( IN ) ::  COL        ! cell column index
         INTEGER,   INTENT( IN ) ::  ROW        ! cell row index 
         INTEGER,   INTENT( IN ) ::  LAY        ! cell layer index      
         REAL,      INTENT( IN ) ::  DENS       ! air mass density, kg/m3
         REAL(8),   INTENT( IN ) ::  CONC( : )  ! cgrid concentrations

C..Includes:
         INCLUDE SUBST_CONST     ! CMAQ constants

!..Local:
         CHARACTER( 16 ), PARAMETER :: PNAME = 'SA_IRR_UPLOAD'     ! Program name

         REAL      :: TOTAL
         REAL( 8 ) :: INV_DENS       ! one over air mass density, m3/kg

         INTEGER :: JSPC, KTAG
         INTEGER :: I, J, RXN
         INTEGER :: C, L, R, S   ! Loop indices
         INTEGER :: SPC          ! array index
         
!         INTEGER :: IOS         
!         CHARACTER( 132 )  :: MSG

         REAL :: TEMP_VALUE

         DO JSPC = 1, ISAM_CHEMISTRY_SPC
            S   = ISAM_TO_CHEM( JSPC )
            SPC = ISAM_SPC_MAP( JSPC ) 
            LOAD_ISAM: DO KTAG = 1, NTAG_SA
               IF( SOLD( KTAG,S ) .GT. DCONCMIN )THEN
                 TEMP_VALUE = REAL( SOLD( KTAG,S ) )
                 IF( CONVERT_ISAM( JSPC ) )THEN
                     TEMP_VALUE = TEMP_VALUE
     &                          * DENS * PPM_TO_UGM3( JSPC )
                 END IF
                 ISAM( COL,ROW,LAY,SPC,KTAG ) = MAX( CONMIN_TAG, TEMP_VALUE )
               ELSE
                 ISAM( COL,ROW,LAY,SPC,KTAG ) = ZERO
               END IF    
            END DO LOAD_ISAM ! ktag loop     
         END DO   ! jspc
 
#ifdef verbose_isam             
          IF( WRITE_CELL )THEN
             DO KTAG = 1, NTAG_SA
               WRITE(ISAM_LOG,*)' '
               WRITE(ISAM_LOG,'(A24,2(1X,ES12.4))')'Final MAX Values',
     &         MAXVAL(ISAM(:,:,:,:,KTAG))
             END DO ! ktag loop
             DO JSPC = 1, NSPC_SA 
                  TOTAL = SUM( ISAM( COL,ROW,LAY,JSPC,1:NTAG_SA ) )
                  WRITE(ISAM_LOG,'(A16,11(1X,ES12.4))')SPC_NAME( JSPC,OTHRTAG ),
     &            (ISAM( COL,ROW,LAY,JSPC,KTAG ),KTAG = 1, NTAG_SA), TOTAL
             END DO
             WRITE(ISAM_LOG,*)'UP: Final Totals'
             DO JSPC = 1, ISAM_CHEMISTRY_SPC
                S   = ISAM_TO_CHEM( JSPC )
                SPC = ISAM_SPC_MAP( JSPC )
                TEMP_VALUE =  MAX( REAL(CONC( S )),1.0E-30 )
                TOTAL = 0.0
                DO KTAG = 1, NTAG_SA
                   TOTAL = TOTAL + ISAM( COL,ROW,LAY,SPC,KTAG )
                END DO 
                WRITE(ISAM_LOG,'(2(A16,1X),3(1X,ES12.4))')SPC_NAME( SPC,OTHRTAG ), CHEMISTRY_SPC(S), 
     &          TOTAL,TEMP_VALUE,TOTAL-TEMP_VALUE
             END DO ! loop jspc
          END IF
#endif
        END SUBROUTINE SA_IRR_UPLOAD
C----------------------------------------------------------------------
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SA_IRR_UNBLOCKED ( LSTART, RK, CONC, DELT )

C-----------------------------------------------------------------------
C  Function: Iupdate tag concentrations
 
C  Preconditions: None
 
C  Key Subroutines/Functions Called: None
 
C  Revision History:
C   Prototype created by Jerry Gipson, September, 1996
C   global BLKPRM Jeff Dec 96
C   Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C   Modified Jun, 1998 by Jerry Gipson to add reaction number error checks
C   Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C   Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C                         three .EXT files
C   31 Mar 01 J.Young: Use HGRD_DEFN; eliminate BLKPRM.EXT
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   19 Aug 11 J.Young: Replaced I/O API include files with UTILIO_DEFN
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module

C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE RXNS_DATA             ! chemical mechanism data
      USE CGRID_SPCS            ! CGRID mechanism species
      USE SA_DEFN
      USE UTILIO_DEFN

      IMPLICIT NONE 

C..Includes: None
      
C..Arguments: 
      LOGICAL, INTENT( IN ) :: LSTART   ! Flag to indicate start of chemical integration period

      REAL( 8 ),    INTENT( IN ) :: RK  ( : )    ! Reaction rate coefficients
      REAL( 8 ),    INTENT( IN ) :: CONC( : )    ! species concentrations
      REAL( 8 ),    INTENT( IN ) :: DELT         ! Chemistry integration time size

C..Parameters: None

C..External Functions: None
 
      CHARACTER( 16 ) , SAVE :: PNAME = 'PA_IRR'   ! Program name
      CHARACTER( 132)        :: MSG

      LOGICAL, SAVE :: LFIRST = .TRUE.   ! Flag for first call to subroutine

C..Scratch Local Variables:
      INTEGER ISP1, ISP2, ISP3  ! Species indices
      INTEGER    S, JSPC,  SPC  ! Species indices
      INTEGER NCELL             ! Loop index for cells
      INTEGER NIRR              ! Loop index for IRR outputs
      INTEGER NOUT              ! IRR output index
      INTEGER NRX               ! Loop index for reactions
      INTEGER NTEMP             ! Loop index for temp IRRs
      INTEGER NTERM             ! Loop index for terms
      INTEGER ASTAT             ! allocation status
      INTEGER KTAG              ! Loop index/pointer for source
      INTEGER POSITIVE          ! count of tag concentration greater than zero

      REAL(8) TOTAL                   ! scratch term for summations
      REAL(8) TOTAL_PROD              ! scratch term for total bulk production
      REAL(8) ISAM_PROD               ! scratch term for total isam production
      REAL(8) TERM                    ! scratch term for summations
      REAL(8) TOTAL_LOSS              ! scratch term for total bulk loss
      REAL(8) ISAM_LOSS               ! scratch term for total isam loss
      REAL(8) LOSS_FACT               ! effective loss frequency
      REAL(8) DELTA_BULK              ! change in bulk concentration
      REAL(8) COEFF                   ! Coefficient of IRR term
      REAL(8) TOTAL_PROBABILITY       ! normalization coefficient for SOURCE_PROBABILITY
      REAL(8) ISAM_TOTAL_PROBABILITY  ! normalization coefficient for ISAM_PROBABILITY
      
      LOGICAL :: REMOVED                 = .FALSE.   ! whether initial concentrations are wiped out
      LOGICAL, SAVE :: DISTRIBUTE_TO_ALL = .TRUE.    ! distribute extra production among all source tags 
                                                     ! or just to the other source tag
                                                     
      LOGICAL, ALLOCATABLE, SAVE   :: SOURCE_ZERO( : ) ! whether source concentration greater than zero 
C..Saved Local Variables:

      REAL( 8 ), ALLOCATABLE, SAVE :: YCOLD  ( : )     ! bulk concentrations from previous time step
      REAL( 8 ), ALLOCATABLE, SAVE :: OUTSIDE( : )     ! species concentration outside isam tags
      REAL( 8 ), ALLOCATABLE, SAVE :: YCMID  ( : )     ! bulk concentrations from previous time step
      REAL( 8 ), ALLOCATABLE, SAVE :: YCRATES( : )     ! bulk concentration used to calculate reactionvrates 
      REAL( 8 ), ALLOCATABLE, SAVE :: RXRAT  ( : )     ! reactions rates   
      REAL( 8 ), ALLOCATABLE, SAVE :: INTRXN ( : )     ! Integrated reaction rates

      REAL( 8 ) :: ONE_OVER_CONC      ! reciprocal of total species concentrations
      REAL( 8 ), ALLOCATABLE, SAVE :: TOTAL_ISAM_CONC( : )      ! total concentrations from isam sources
      REAL( 8 ), ALLOCATABLE, SAVE :: NOT_OUTSIDE_ISAM( : )     ! fraction of species not from non-isam sources
      REAL( 8 ), ALLOCATABLE, SAVE :: NOT_ISAM_SOURCE( :,: )    ! fraction of species not from an isam source
      REAL( 8 ), ALLOCATABLE, SAVE :: ISAM_SOURCE( :,: )        ! fraction of species from an isam source
      REAL( 8 ), ALLOCATABLE, SAVE :: SOURCE_PROBABILITY( :,: ) ! probability or amount that a source contributes to reaction
      REAL( 8 ), ALLOCATABLE, SAVE :: SOURCE_DELTA   ( :,: )    ! change in source tag species 
      REAL( 8 ), ALLOCATABLE, SAVE :: SA_DELTA( : )
      REAL( 8 ), ALLOCATABLE, SAVE :: SA_LOSS( : )
      REAL( 8 ), ALLOCATABLE, SAVE :: ISAM_PROBABILITY  ( :,: ) ! probability or amount that a source contributes to reaction      
      LOGICAL,   ALLOCATABLE, SAVE :: ZERO_ISAM( :           )  ! whether isam species have no effect on reaction
      LOGICAL,   ALLOCATABLE, SAVE :: REBALANCE( : )            ! renormalize tag concentration when production occurs
      LOGICAL,   ALLOCATABLE, SAVE :: SOURCE_NONZERO( :,: )     ! fraction of species not from an isam source
      
      

C-----------------------------------------------------------------------

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  On first call, flag the reactions for which to calculate IRRS
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LFIRST ) THEN

C Allocate arrays:

        ALLOCATE( YCOLD( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCOLD variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF

        ALLOCATE( YCMID( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCOLD variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF
        
        ALLOCATE( YCRATES( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCRATES variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF
        
        ALLOCATE( OUTSIDE( NUMB_MECH_SPC ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating YCOLD variable'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF
        
        OUTSIDE = 0.0D0
        
        ALLOCATE( RXRAT  ( NRXNS ),
     &            INTRXN ( NRXNS ), STAT = ASTAT )
        IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
        END IF

!         ALLOCATE( ONE_OVER_CONC( NUMB_MECH_SPC ), STAT = ASTAT )
!         IF ( ASTAT .NE. 0 ) THEN
!           MSG = 'ERROR allocating SA_IRR variables'
!           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
!         END IF

         ALLOCATE( TOTAL_ISAM_CONC( NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( NOT_ISAM_SOURCE( NTAG_SA, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( ISAM_SOURCE( NTAG_SA, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SOURCE_PROBABILITY( NTAG_SA + 1, NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( ISAM_PROBABILITY( NTAG_SA, NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating ISAM_PROBABILITY variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( ZERO_ISAM( NRXNS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating ZERO_ISAM '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( REBALANCE( NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating REBALANCE '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
         REBALANCE = .FALSE.
             
         ALLOCATE( SOURCE_DELTA( NTAG_SA + 1, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SOURCE_DELTA '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SA_DELTA( NTAG_SA ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_DELTA '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SA_LOSS( NTAG_SA ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_LOSS '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SOURCE_ZERO( NTAG_SA + 1 ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SOURCE_ZERO '
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF
         LFIRST = .FALSE.

         ALLOCATE( NOT_OUTSIDE_ISAM( NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         ALLOCATE( SOURCE_NONZERO( NTAG_SA, NUMB_MECH_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
           MSG = 'ERROR allocating SA_IRR variables'
           CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
         END IF

         SOURCE_NONZERO = .TRUE.

C...Assume that ISAM_SPECIES is fixed over the domain and simulation        
         WHERE ( ISAM_SPECIES ) 
            NOT_OUTSIDE_ISAM = 1.0D0
         ELSE WHERE
            NOT_OUTSIDE_ISAM = 0.0D0
         END WHERE            
         DO ISP2 = 1, NUMB_MECH_SPC
            IF( .NOT. ISAM_SPECIES( ISP2 ) )THEN            
              DO KTAG = 1, NTAG_SA
                NOT_ISAM_SOURCE( KTAG,ISP2 ) = 1.0D0
              END DO
            END IF
         END DO            
      END IF ! LFIRST
      UPDATE_PROBABILITIES = .TRUE.
      
      IF( LSTART )THEN
!         UPDATE_SOLD = .FALSE.
         SOURCE_DELTA = 0.0D0
         DO NIRR = 1, NUMB_MECH_SPC 
            YCOLD( NIRR ) = CONC( NIRR )
         END DO
         YCMID = YCOLD
         RETURN
      END IF
      
C...filter bulk concentrations for concentrations used for reaction rates   
      WHERE ( CONC .GE. BULK_CUTOFF )
         YCRATES = CONC
      ELSE WHERE
         YCRATES = 0.0D0
      END WHERE   

C...check for bad values
         TOTAL_ISAM_CONC = 0.0D0 ! 1.0D-40
         DO ISP2 = 1, NUMB_MECH_SPC
            DO KTAG = 1, NTAG_SA
               TOTAL_ISAM_CONC( ISP2 ) = TOTAL_ISAM_CONC( ISP2 )
     &                                 + SOLD( KTAG,ISP2 )
               IF( SOLD( KTAG,ISP2 ) .LT. 0.0D0 )
     &         WRITE(ISAM_LOG,*)TRIM(CHEMISTRY_SPC(ISP2)) // ' bad value = ',SOLD( KTAG,ISP2 )
            END DO
         END DO
C..compute species fractions from ISAM groups and the remainder group for all mechanism species
!  Note that remainder group (NTAG_SA+1) exists to handle untracked model species 
      DO ISP2 = 1, NUMB_MECH_SPC
         IF( ISAM_SPECIES( ISP2 ) )THEN          
           ONE_OVER_CONC   = 1.0D0 / MAX( TOTAL_ISAM_CONC( ISP2 ), DCONMIN_TAG )
           DO KTAG = 1, NTAG_SA
             ISAM_SOURCE( KTAG,ISP2 )     = SOLD( KTAG,ISP2 )*ONE_OVER_CONC
             NOT_ISAM_SOURCE( KTAG,ISP2 ) = MAX( 0.0D0, 1.0D0-ISAM_SOURCE( KTAG,ISP2 ))
           END DO
           OUTSIDE( ISP2 ) = 0.0D0    
           NOT_OUTSIDE_ISAM( ISP2 ) = 1.0D0
         ELSE
           ONE_OVER_CONC   = 1.0D0 / MAX( YCMID( ISP2 ), DCONMIN_TAG )
           DO KTAG = 1, NTAG_SA
             ISAM_SOURCE( KTAG,ISP2 )     = SOLD( KTAG,ISP2 )*ONE_OVER_CONC
             NOT_ISAM_SOURCE( KTAG,ISP2 ) = MAX( 0.0D0, 1.0D0-ISAM_SOURCE( KTAG,ISP2 ))
           END DO
           IF ( TOTAL_ISAM_CONC( ISP2 ) .GT. DCONMIN_TAG ) THEN
              TERM = MAX( (YCMID( ISP2 )-TOTAL_ISAM_CONC( ISP2 )), 0.0D0 )
           ELSE
              TERM =  YCMID( ISP2 )
           END IF
           OUTSIDE( ISP2 ) = TERM    
           NOT_OUTSIDE_ISAM( ISP2 ) = MAX( 1.0D0 - TERM * ONE_OVER_CONC, 0.0D0 )
         END IF
         DO KTAG = 1, NTAG_SA
           IF( SOLD( KTAG,ISP2 ) .GE. DCONMIN_TAG )THEN
              SOURCE_NONZERO(  KTAG,ISP2 ) = .TRUE.
           ELSE
              SOURCE_NONZERO(  KTAG,ISP2 ) = .FALSE.
           END IF  
        END DO
      END DO 

C...Calculate reaction rates and source probabilties
        DO NRX = 1, NRXNS
            IF ( NREACT( NRX ) .EQ. 1 ) THEN
               ISP1 = IRR( NRX,1 )
               RXRAT( NRX ) = RK( NRX )
     &                      * YCRATES( ISP1 )
               DO KTAG = 1, NTAG_SA
                 SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 - NOT_ISAM_SOURCE( KTAG,ISP1 ) 
               END DO
               KTAG = NTAG_SA + 1
               SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 - NOT_OUTSIDE_ISAM( ISP1 ) 
            ELSE IF ( NREACT( NRX ) .EQ. 2 ) THEN
               ISP1 = IRR( NRX,1 )
               ISP2 = IRR( NRX,2 )
               RXRAT( NRX ) = RK( NRX )
     &                      * YCRATES( ISP1 )
     &                      * YCRATES( ISP2 ) 
               DO KTAG = 1, NTAG_SA
                 SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                          -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
     &                                          *  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
               END DO
               KTAG = NTAG_SA + 1
               SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                        -  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                        *  NOT_OUTSIDE_ISAM( ISP2 ) 
            ELSE IF ( NREACT( NRX ) .EQ. 3 ) THEN
               ISP1 = IRR( NRX,1 )
               ISP2 = IRR( NRX,2 )
               ISP3 = IRR( NRX,3 )
               RXRAT( NRX ) = RK( NRX )
     &                      * YCRATES( ISP1 )
     &                      * YCRATES( ISP2 )
     &                      * YCRATES( ISP3 ) 
               DO KTAG = 1, NTAG_SA
                 SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                          -  NOT_ISAM_SOURCE( KTAG,ISP1 ) 
     &                                          *  NOT_ISAM_SOURCE( KTAG,ISP2 ) 
     &                                          *  NOT_ISAM_SOURCE( KTAG,ISP3 ) 
               END DO
               KTAG = NTAG_SA + 1
               SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
     &                                        -  NOT_OUTSIDE_ISAM( ISP1 ) 
     &                                        *  NOT_OUTSIDE_ISAM( ISP2 ) 
     &                                        *  NOT_OUTSIDE_ISAM( ISP3 ) 
            ELSE IF (NREACT( NRX ) .EQ. 0 ) THEN
               RXRAT( NRX ) = RK( NRX )
               DO KTAG = 1, NTAG_SA
                  SOURCE_PROBABILITY( KTAG,NRX ) = 0.0D0 
               END DO
               KTAG = NTAG_SA + 1
               SOURCE_PROBABILITY( KTAG,NRX ) = 1.0D0 
            END IF
C..Normalize sources probabilities for reaction
            ISAM_TOTAL_PROBABILITY  =  0.0D0
            DO KTAG = 1, NTAG_SA
               SOURCE_PROBABILITY( KTAG,NRX ) = MAX( SOURCE_PROBABILITY( KTAG,NRX ), 0.0D0 )
               ISAM_PROBABILITY  ( KTAG,NRX ) = SOURCE_PROBABILITY( KTAG,NRX )
               ISAM_TOTAL_PROBABILITY = ISAM_TOTAL_PROBABILITY + ISAM_PROBABILITY( KTAG,NRX )
            END DO
            KTAG = NTAG_SA + 1
            SOURCE_PROBABILITY( KTAG,NRX ) = MAX( SOURCE_PROBABILITY( KTAG,NRX ), 0.0D0 )
            TOTAL_PROBABILITY = ISAM_TOTAL_PROBABILITY + SOURCE_PROBABILITY( KTAG,NRX )
            IF( ISAM_TOTAL_PROBABILITY .LE. 1.0D-30 )THEN
                ZERO_ISAM( NRX ) = .TRUE. 
                DO KTAG = 1, NTAG_SA
                   ISAM_PROBABILITY( KTAG,NRX ) = 0.0D0
                END DO
!               ISAM_PROBABILITY( OTHRTAG,NRX ) = 1.0D0
            ELSE
                ZERO_ISAM( NRX ) = .FALSE.
                ISAM_TOTAL_PROBABILITY = 1.0D0 / ISAM_TOTAL_PROBABILITY
                DO KTAG = 1, NTAG_SA
                   ISAM_PROBABILITY( KTAG,NRX ) = ISAM_PROBABILITY( KTAG,NRX )
     &                                          * ISAM_TOTAL_PROBABILITY
                END DO
            END IF    
            IF( TOTAL_PROBABILITY .LT. 0.0D0 )THEN
               DO JSPC = 1, ISAM_CHEMISTRY_SPC
                  S   = ISAM_TO_CHEM( JSPC )
                  SPC = ISAM_SPC_MAP( JSPC ) 
                  WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(S),(SOLD( KTAG, S ),KTAG=1,NTAG_SA ),
     &            YCOLD( S )
               END DO ! loop jspc
               MSG = 'Fraction Results, note that last column is total isam over total species CONCentration'
               WRITE(ISAM_LOG,'(A)')TRIM(MSG)
               WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Species/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
               DO ISP2 = 1, NUMB_MECH_SPC
                  WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(ISP2),
     &           (1.0D0-NOT_ISAM_SOURCE( KTAG,ISP2 ),KTAG=1,NTAG_SA),1.0D0-NOT_OUTSIDE_ISAM( ISP2 )
               END DO

               MSG = 'Unnormalized Source Probabilities, note that last column is for NonISAM CONCentrations'
               WRITE(ISAM_LOG,'(A)')TRIM(MSG)
               WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Reaction/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
               WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')RXLABEL( NRX ),
     &         (SOURCE_PROBABILITY( KTAG,NRX ),KTAG=1,NTAG_SA+1)

               MSG = 'TOTAL_PROBABILITY < zero from reaction label: ' 
     &             // TRIM( RXLABEL( NRX ) )
               CALL M3EXIT ( 'SA_IRR', 0, 0, MSG, XSTAT2 )
            ELSE IF( TOTAL_PROBABILITY .EQ. 0.0D0 )THEN   
               TOTAL_PROBABILITY = 1.0D0
            END IF
            TOTAL_PROBABILITY = 1.0D0 / TOTAL_PROBABILITY
            DO KTAG = 1, NTAG_SA + 1
               SOURCE_PROBABILITY( KTAG,NRX ) = SOURCE_PROBABILITY( KTAG,NRX )
     &                                        * TOTAL_PROBABILITY
            END DO
        END DO
#ifdef verbose_isam
        IF( WRITE_CELL )THEN
           MSG = 'Calculated Source Probabilities, note that last column is for NonISAM concentrations'
           WRITE(ISAM_LOG,'(A)')TRIM(MSG)
           WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Reaction/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
           DO NRX = 1, NRXNS
              WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')RXLABEL( NRX ),
     &        (SOURCE_PROBABILITY( KTAG,NRX ),KTAG=1,NTAG_SA+1)
           END DO
           MSG = 'Caculated ISAM Probabilities, note that last column is their sum'
           WRITE(ISAM_LOG,'(A)')TRIM(MSG)
           WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Reaction/Tag #',(KTAG,KTAG=1,NTAG_SA+1)
           DO NRX = 1, NRXNS
              ISAM_TOTAL_PROBABILITY = SUM( ISAM_PROBABILITY( 1:NTAG_SA,NRX ) )
              WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')RXLABEL( NRX ),
     &       (ISAM_PROBABILITY( KTAG,NRX ),KTAG=1,NTAG_SA),ISAM_TOTAL_PROBABILITY
           END DO
         END IF ! WRITE_CELL  
#endif         

C..Compute integrated reaction rates
      DO NRX = 1, NRXNS
          INTRXN( NRX ) = DELT * RXRAT( NRX )
      END DO

c..Compute change in source concentrations for updating source concentrations
        DO JSPC = 1, NUMB_MECH_SPC
! compute species total production and isam production 
             ISAM_PROD  = 0.0D0
             TOTAL_PROD = 0.0D0
             SA_DELTA   = 0.0D0
             DO NTERM = 1, MECHANISM_BUDGET( JSPC )%NRXNS_PROD
                NRX   = MECHANISM_BUDGET( JSPC )%IRXN_PROD( NTERM )
                COEFF = MECHANISM_BUDGET( JSPC )%COEFF_POS( NTERM )
     &                * INTRXN( NRX )
                TOTAL_PROD = TOTAL_PROD + COEFF
                IF( .NOT. ZERO_ISAM( NRX ) )THEN
                  DO KTAG = 1, NTAG_SA
                     TERM      = COEFF 
     &                         * MIN( (SOURCE_PROBABILITY( KTAG,NRX ) 
     &                         +       SOURCE_PROBABILITY((NTAG_SA+1),NRX )
     &                         *       ISAM_PROBABILITY  ( KTAG,NRX )),
     &                                 1.0D0 )
                     ISAM_PROD = ISAM_PROD + TERM
                     SA_DELTA( KTAG ) = SA_DELTA( KTAG ) + TERM
                  END DO                    
                END IF
             END DO
             IF( ISAM_PROD .GT. TOTAL_PROD )TOTAL_PROD = ISAM_PROD
! compute species loss
             ISAM_LOSS  = 0.0D0
             TOTAL_LOSS = 0.0D0
             SA_LOSS    = 0.0D0
             DO NTERM = 1, MECHANISM_BUDGET( JSPC )%NRXNS_LOSS
                NRX   = MECHANISM_BUDGET( JSPC )%IRXN_LOSS( NTERM )
                COEFF = MECHANISM_BUDGET( JSPC )%COEFF_NEG( NTERM )
     &                * INTRXN( NRX )
                TOTAL_LOSS = TOTAL_LOSS + INTRXN( NRX )
             END DO
             NIRR = JSPC
             DELTA_BULK        = (CONC( JSPC )-YCMID( JSPC ))
             REMOVED           = .FALSE. 
             REBALANCE( JSPC ) = .FALSE. 
             IF( TOTAL_PROD .GT. 1.0D-30 )THEN
! estimate net change concentration inside and outside source tags based on total loss
                 IF( TOTAL_LOSS .GT. 1.0D-30 )THEN
! correct outside and isam production/concentration based on the bulk average loss frequency times timestep
                    LOSS_FACT  =  TOTAL_LOSS / CONC( JSPC )
                    IF ( LOSS_FACT .LT. 14.0D0 ) THEN ! > one millionth of initial concentration remains
!                    IF ( LOSS_FACT .LT. 34.5D0 ) THEN ! > one millionth of initial concentration remains
                       REBALANCE( JSPC ) = .TRUE.
                       TERM              = ( 1.0D0 - EXP( -LOSS_FACT ) )
                       COEFF             = TERM / LOSS_FACT
                       TOTAL_PROD        = TOTAL_PROD * COEFF                    
                       DO KTAG = 1, NTAG_SA
                          SA_LOSS ( KTAG )          = SOLD( KTAG,JSPC ) * TERM
                          SA_DELTA( KTAG )          = SA_DELTA(  KTAG ) * COEFF
                          SOURCE_DELTA( KTAG,JSPC ) = MAX( SA_DELTA( KTAG ) - SA_LOSS( KTAG ),
     &                                                    -SOLD( KTAG,JSPC ) )
                       END DO
                       ISAM_PROD  = SUM( SA_DELTA( 1:NTAG_SA ) )
! estimate changes in outside concentration based on surplus production 
                       OUTSIDE( JSPC ) = OUTSIDE( JSPC ) * ( 1.0D0 - TERM )
     &                                 + (TOTAL_PROD-ISAM_PROD) 
                       OUTSIDE( JSPC ) = MAX(  OUTSIDE( JSPC ),0.0D0 )  
                    ELSE 
! tag change removes initial value and apportions bulk concentration to the tag based on its relative production
                       REMOVED = .TRUE.
                       COEFF = CONC( JSPC ) / MAX( TOTAL_PROD,1.0D-30 )
                       DO KTAG = 1, NTAG_SA
                          SOURCE_DELTA( KTAG,JSPC ) = SA_DELTA( KTAG )*COEFF - SOLD( KTAG,JSPC )
                       END DO   
                       OUTSIDE( JSPC ) = COEFF * MAX( TOTAL_PROD-ISAM_PROD,0.0D0 ) 
                     END IF  
                 ELSE
! simply scale tag changes based their fraction of production
                    LOSS_FACT  = -1.0D0
                    COEFF      = DELTA_BULK / MAX( TOTAL_PROD,1.0D-30 )
                    DO KTAG = 1, NTAG_SA
                       SOURCE_DELTA( KTAG,JSPC ) = SA_DELTA(  KTAG ) * COEFF
                    END DO
! estimate changes in outside concentration based on surplus production and loss
                    OUTSIDE( JSPC ) = OUTSIDE( JSPC ) 
     &                              + COEFF * MAX( TOTAL_PROD-ISAM_PROD, 0.0D0 )
                 END IF     
! add surplus concentration to tags based on whether species is tracked
                 IF( ISAM_SPECIES( JSPC ) )THEN
                    IF ( ISAM_PROD .GT. 1.0D-30 ) THEN
! add outside concentration to tag based on their production relative to the isam total
                       TERM = 1.0D0 / ISAM_PROD
                       DO KTAG = 1, NTAG_SA
                          SA_DELTA( KTAG ) = TERM * SA_DELTA( KTAG )
                          SOURCE_DELTA( KTAG,JSPC ) = SOURCE_DELTA( KTAG,JSPC )
     &                                              + OUTSIDE( JSPC ) * SA_DELTA( KTAG )
                       END DO
                    ELSE  ! add to other tag
                       TERM = 1.0D0
                       SOURCE_DELTA( OTHRTAG,JSPC ) = SOURCE_DELTA( OTHRTAG,JSPC )
     &                                              + OUTSIDE( JSPC )                     
                    END IF                    
                 END IF  
!                 WRITE( LOGDEV,'(A,6(ES20.10,1X))')'Surplus Changes for ' // CHEMISTRY_SPC( JSPC ) // ' = ',
!     &           TOTAL_PROD,TOTAL_LOSS,OUTSIDE( JSPC ),COEFF,SUM( SOURCE_DELTA( :,JSPC ) ),ISAM_LOSS
#ifdef verbose_isam
                 IF( ISAM_SPECIES( JSPC ) )THEN
                    IF( REMOVED )DELTA_BULK = CONC( JSPC )
                    IF( WRITE_CELL )WRITE(ISAM_LOG,'(2A,30(1X,ES20.10))', ADVANCE = 'NO')MECHANISM_BUDGET( JSPC )%SPECIES_NAME,
     &              ' P ',-LOSS_FACT,(SOURCE_DELTA( KTAG,JSPC ),KTAG =1, NTAG_SA), OUTSIDE( JSPC ), TERM, DELTA_BULK                 
                 END IF
#endif     
                 IF( ISAM_SPECIES( JSPC ) ) OUTSIDE( JSPC ) = 0.0D0
             ELSE !!!!IF ( DELTA_BULK .LT. 0.0D0 ) THEN
! scale by relative change in bulk and fraction of species in tag             
               LOSS_FACT = MAX( -1.0D0, DELTA_BULK / MAX( YCMID( JSPC ),DCONMIN_TAG ) ) 
               DO KTAG = 1, NTAG_SA
                  SOURCE_DELTA( KTAG,JSPC ) = SOURCE_DELTA( KTAG, JSPC )
     &                                      + SOLD( KTAG,JSPC ) * LOSS_FACT
               END DO
!  have to add lines for outside change?
#ifdef verbose_isam
                 IF( ISAM_SPECIES( JSPC ) )THEN
                    IF( WRITE_CELL )WRITE(ISAM_LOG,'(2A,30(1X,ES20.10))',ADVANCE = 'NO')MECHANISM_BUDGET( JSPC )%SPECIES_NAME,
     &              ' L ',-LOSS_FACT,(SOURCE_DELTA( KTAG,JSPC ),KTAG =1, NTAG_SA),OUTSIDE( JSPC ),COEFF,
     &              DELTA_BULK            
                 END IF
#endif     
             END IF
!
#ifdef verbose_isam
             IF( ISAM_SPECIES( JSPC ) )THEN
                TOTAL = SUM( SOURCE_DELTA( 1:NTAG_SA,JSPC ))
                IF( WRITE_CELL )WRITE(ISAM_LOG,'(A,ES12.4,A,ES12.4)')
     &          ' Net ISAM Change ', TOTAL,': Change ISAM-BULK ',( TOTAL-DELTA_BULK )
             END IF
#endif
             DO KTAG = 1, NTAG_SA
                IF( SOURCE_DELTA( KTAG, JSPC ) .LT. -SOLD( KTAG, JSPC ) )THEN
                   SOURCE_DELTA( KTAG, JSPC ) = -SOLD( KTAG, JSPC )
                END IF 
             END DO   
       END DO

C...update SOLD using SOURCE_DELTA       
        DO JSPC = 1,NUMB_MECH_SPC
           NIRR = JSPC 
           DO KTAG = 1, NTAG_SA
              SOLD( KTAG, JSPC ) = SOLD( KTAG, JSPC ) + SOURCE_DELTA( KTAG, JSPC )
               IF( SOLD( KTAG,JSPC ) .LT. DCONMIN_TAG )SOLD( KTAG,JSPC ) = 0.0D0
           END DO           
           IF( REBALANCE( JSPC ) )THEN 
!     adjust tags based on final bulk concentration
              TERM  = MAX( OUTSIDE( JSPC ) + SUM( SOLD(1:NTAG_SA,JSPC) ), DCONMIN_TAG ) 
              COEFF = CONC( JSPC ) / TERM            
              DO KTAG = 1, NTAG_SA
                 SOLD( KTAG,JSPC ) = COEFF * SOLD( KTAG,JSPC )
                 IF( SOLD( KTAG,JSPC ) .LT. DCONMIN_TAG )SOLD( KTAG,JSPC ) = 0.0D0
              END DO
              OUTSIDE( JSPC ) = COEFF * OUTSIDE ( JSPC )
           END IF
! set tags to conmin if initially nonzero
           IF( MAXVAL( SOLD( 1:NTAG_SA,JSPC ) ) .LT. DCONMIN_TAG )THEN
              DO KTAG = 1, NTAG_SA
                 IF( SOURCE_NONZERO( KTAG,JSPC ) )SOLD( KTAG,JSPC ) = DCONMIN_TAG
              END DO
! zero out ICON tag
!             SOLD( NTAG_SA,JSPC )   = 0.0D0
           END IF    
        END DO

#ifdef verbose_isam
       IF( WRITE_CELL )THEN
          WRITE(ISAM_LOG,'(A)')'Source Delta Concentration include extra delta then last two columns, Solver Change and Sum Deltas'
          WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Species/Tag #',(KTAG,KTAG=1,NTAG_SA),0,NTAG_SA+1
!          DO S = 1, NUMB_MECH_SPC 
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             S = ISAM_TO_CHEM( JSPC )
             WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(S),(SOURCE_DELTA( KTAG, JSPC ),KTAG=1,NTAG_SA ),
     &      (CONC( S )-YCMID( S )),SUM(SOURCE_DELTA( 1:(NTAG_SA), JSPC ))
          END DO
          WRITE(ISAM_LOG,*)' '
          WRITE(ISAM_LOG,'(A21,5(1X,A12))')'ISAM_CHEMISTRY_SPC,','  IRR Conc,  ',' True Conc,  correction ',
     &                                    '  IRR Change,  ','  True Change  ',' Difference '
!          DO NIRR = 1, NUMB_MECH_SPC 
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             NIRR = ISAM_TO_CHEM( JSPC )
             COEFF = 0.0D0
             TERM  = 0.0D0
             DO KTAG = 1, NTAG_SA
!                SOLD( KTAG, NIRR ) = MAX( SOLD( KTAG, NIRR ) + SOURCE_DELTA( KTAG, JSPC ), 0.0D0 )
                TERM  = TERM  + SOLD( KTAG, NIRR )
                COEFF = COEFF + SOURCE_DELTA( KTAG, JSPC )
             END DO
             DELTA_BULK =  CONC( NIRR )- YCMID( NIRR )             
             WRITE(ISAM_LOG,'(A21,5(1X,",",ES12.4))')'ISAM_' // CHEMISTRY_SPC(NIRR),
     &       MAX(0.0D0,TERM),CONC( NIRR ),COEFF,DELTA_BULK,(DELTA_BULK-COEFF)
          END DO
       END IF
#endif

       DO NIRR = 1, NUMB_MECH_SPC 
          YCMID( NIRR ) = CONC( NIRR )
       END DO
          
C..Clear source deltas
       SOURCE_DELTA = 0.0D0
C..Save concentrations
       DO NIRR = 1, NUMB_MECH_SPC 
          YCOLD( NIRR ) = CONC( NIRR )
       END DO
#ifdef verbose_isam
       IF( WRITE_CELL )THEN
          WRITE(ISAM_LOG,'(A,I7,1X,I6.6,1X,I3)')'At Date, Time, Nstep = ',ISAM_JDATE,ISAM_JTIME,ISAM_NSTEP
          WRITE(ISAM_LOG,*)'Final Source Concentration then New Total (Last Column) Concentrations'
          WRITE(ISAM_LOG,'(A16,86(1X,I12))')'Species/Tag #',(KTAG,KTAG=1,NTAG_SA),0,NTAG_SA+1
!          DO S = 1, NUMB_MECH_SPC 
          DO JSPC = 1, ISAM_CHEMISTRY_SPC
             S = ISAM_TO_CHEM( JSPC )
             WRITE(ISAM_LOG,'(A16,86(1X,ES12.4))')CHEMISTRY_SPC(S),(SOLD( KTAG, S ),KTAG=1,NTAG_SA ),
     &       CONC( S ),SUM(SOLD(1:NTAG_SA,S) )
          END DO
       END IF
#endif        
      

      RETURN
      END SUBROUTINE SA_IRR_UNBLOCKED
      END MODULE SA_IRR_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/emis/emis/tfabove.F,v 1.3 2011/10/21 16:10:48 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine tfabove ( tfa )

C-----------------------------------------------------------------------
C Description:
C   Calculate transport fraction considering removal by flow above canopy
 
C Subroutines and Functions Called: None

C Revison History:
C  Shan He at RTP 2003
C  Jun 2009 D. Tong
C  Jan 2011 J. Young: mods for inline wind-blown dust module
C  Jun 2011 J. Young: add reshape to vd initialization for pgf90 compiler
C  Oct 2018 D. Wong: With new re-structure of LUS_DEFN, most of the data
C                    declaration has been moved to lus_data_module
C  Feb 2019 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      use hgrd_defn                    ! horizontal domain specifications
      use asx_data_mod                 ! meteorology data
      use lus_data_module, only: uland

      implicit none
 
C Includes:

C Arguments:

      real, intent( out ) :: tfa  ( :,: )   ! above canopy transport factor

C Parameters:

C Local Variables:

      integer c, r, i   ! loop indicies
      integer indx      ! windspeed index

C Based on Slinn 1982, fugitive dust in coarse mode, Vd average from
C PM2~PM10; 3 wind velocities: 10, 5, 1 m/s; 4 canopy characteristics:
C water and lamda = 1.0, 3.5, 5.0

      real, parameter :: vd( 4,3 ) = reshape (  ! deposition velocity [m/s]
     &            (/ 0.0051,    ! natural water Vd(1,1), WindSpeed = 10 m/s
     &               0.0152,    ! lamda = 2.0   Vd(2,1), WindSpeed = 10 m/s
     &               0.0268,    ! lamda = 3.5   Vd(3,1), WindSpeed = 10 m/s 
     &               0.0382,    ! lamda = 5.0   Vd(4,1), WindSpeed = 10 m/s
     &               0.0018,    ! natural water Vd(1,2), WindSpeed =  5 m/s
     &               0.0056,    ! lamda = 2.0   Vd(2,2), WindSpeed =  5 m/s
     &               0.0099,    ! lamda = 3.5   Vd(3,2), WindSpeed =  5 m/s
     &               0.0141,    ! lamda = 5.0   Vd(4,2), WindSpeed =  5 m/s
     &               0.0018,    ! natural water Vd(1,3), WindSpeed =  1 m/s
     &               0.0020,    ! lamda = 2.0   Vd(2,3), WindSpeed =  1 m/s
     &               0.0021,    ! lamda = 3.5   Vd(3,3), WindSpeed =  1 m/s
     &               0.0030 /), ! lamda = 5.0   Vd(4,3), WindSpeed =  1 m/s
     &           (/ 4,3 /), order = (/ 1,2 /) )

      character( 16 ) :: pname = 'tfabove'
 
      real   :: ul( 4 )
      real   :: ku              ! k=0.08u*
      real   :: omeg            ! transport factor variable

C ----------------------------------------------------------------------
      do r = 1, nrows
      do c = 1, ncols
         tfa( c,r ) = 0.0
         if ( Met_Data%wspd10( c,r ) .le. 2.0 ) then        ! surface wind [0-2] range
            indx = 3
         else if ( Met_Data%wspd10( c,r ) .lt. 7.0 ) then   ! surface wind (2-7) range
            indx = 2
         else                                     ! surface wind [7-^) range
            indx = 1
         end if
         ul = uland( c,r,: )   ! array asignment
         ku = 0.08 * Met_Data%ustar( c,r )
         do i = 1, 4                              ! landuse loop
            omeg = 0.0
            if ( ul( i ) .gt. 0.0 ) then          ! non-zero landuse
               omeg = ku / ( vd( i,indx ) + ku )  ! ratio dqup/dqrd    
               tfa( c,r ) = tfa( c,r ) + 0.01 * omeg * ul( i )
            end if
         end do
      end do
      end do

      return
      end

C SWIND     0..1..2..3..4..5..6..7..8..9..10.....
C           |  .  .  .  .  .  .  .  .  .  |
C INDX      [ -3- ]     -2-      )         -1->
C WindSpeed |--1--|------5-------|----------10---> m/s

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from BIOG_EMIS.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module biog_emis_param_module

! Former include file  B3V12DIMS3.EXT
! dimensioning parameters for BEIS v3.12 

            INTEGER, PARAMETER :: NSEF     = 35 ! # of em class in Summer emis factor table
            INTEGER, PARAMETER :: NSEASONS = 2  ! number of seasons modeled (2 for now)
            INTEGER, PARAMETER :: NLAI     = 3  ! no. of different LAIs (ISOP and MBO)
            INTEGER, PARAMETER :: NSUMMER  = 1  ! summer flag
            INTEGER, PARAMETER :: NWINTER  = 2  ! winter flag

! Names for BEIS species, emitted model species
! DO NOT CHANGE THE ORDER OF THESE ARRAYS

            CHARACTER( 5 ), PARAMETER :: BIOTYPES( NSEF ) =
     &                          (/ 'ISOP ', 'MBO  ', 'METH ',
     &                             'APIN ', 'BPIN ', 'D3CAR', 'DLIM ',
     &                             'CAMPH', 'MYRC ', 'ATERP', 'BPHE ',
     &                             'SABI ', 'PCYM ', 'OCIM ', 'ATHU ',
     &                             'TRPO ', 'GTERP', 'ETHE ', 'PROPE',
     &                             'ETHO ', 'ACET ', 'HEXA ', 'HEXE ',
     &                             'HEXY ', 'FORM ', 'ACTAL', 'BUTE ',
     &                             'ETHA ', 'FORAC', 'ACTAC', 'BUTO ',
     &                             'CO   ', 'ORVOC', 'SESQT',
     &                             'NO   ' /)

            CHARACTER( 5 ), PARAMETER :: LAITYPES( NLAI ) =
     &                          (/ 'ISOP ', 'MBO  ', 'METH ' /)

            CHARACTER( 1 ), PARAMETER :: SEASON( NSEASONS ) =
     &                          (/ 'S', 'W' /)

          end module biog_emis_param_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PHOT_MOD

C-----------------------------------------------------------------------
C
C  FSB This version has NO internal write statements
C  FSB This version has the code for XR96 added.
C  FSB change indices from L to II in newOptics loop 08/17/2006
C  FSB This version has all write statements commented out.(08/03/2006)
C
C  FSB NOTE - this code assumes that the top of the modeling domain
C  is about 100 [mb] or 10 [kPa] ~ 16 [km] in altitude. If a
C  higher altitude top is used , the method of calculating the
C  ozone column and the ozone optical depth will be necessary.
C
C  FSB This version has the addition of Rayleigh optical depth for the
C  stratosphere as well as the calculation of single scattering
C  albedo for the AOD calculation. (01/17/2006)
C  FSB This version has deleted the JPROC values of Cs and Qy as well as
C  the default aerosol.  It also contains the fast optics
C  routines.
C  FSB This module supports the SAPRC99 Chemical mechanism within
C  CMAQ.
C  FSB This version calls a fast optical routine for aerosol
C  extinction and scattering
C  FSB This version uses a set of constant refractive indices
C  The new subroutine GETNEWPAR now sets up the refractive indices.
C  
C  Bill Hutzell(Mar 2011) moved determining refractive indices to a
C  separate file and new subroutine called AERO_PHOTDATA.
C  
C  Bill Hutzell(Jun 2011) modified TWOSTREAM_S subroutine to account for 
C  GAM2 equal to zero in the Toon et al. (1989) solution to the two stream
C  of the radiative transfer equation based on how the NCAR TUV model 
C  implements the approximation
C
C  Bill Hutzell(May 2013) modified optical depth agruments to give vetical
C  profile rather than surface values. Note that TAU_TOT now includes 
C  stratospheric values.
! Bill Hutzell(Mar 2014) modified calculation of aerosol and cloud optical
! properites as well as their calculated optical depths. The changes employ
! FORTRAN modules that contain the layer level of the optical properties.
C  07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C  10/10/14 - DJL added references to IUPAC10 to NO2 and O3 photo rates
C  23Jun15   B.Hutzell: made TWOSTREAM and TRIDIAGONAL routine use REAL(8) variables
C  30Jul15  J.Young: REAL(4) -> REAL for code portability
C-----------------------------------------------------------------------

      USE RUNTIME_VARS    
      USE CSQY_DATA

      IMPLICIT NONE

!***include files

      INCLUDE SUBST_CONST      ! physical constants

!***parameters

      REAL, PARAMETER :: SMALL = 1.0E-36    ! a small number

!***Fundamental Constants: ( Source: CRC76, pp 1-1 to 1-6)

      REAL, PARAMETER :: PLANCK_C = 6.62606876E-34 ! Planck's Constant [Js]
      REAL, PARAMETER :: LIGHT_SPEED = 299792458.0 ! speed of light in a vacuum

      REAL, PARAMETER :: DU_TO_CONC = 2.6879E16        ! factor from [DU] to [molecules/cm^2]
      REAL, PARAMETER :: CONC_TO_DU = 1.0 / DU_TO_CONC 
      
      LOGICAL, PARAMETER :: ADJUST_OZONE = .FALSE.     ! Flag to correct tropospheric ozone optical depth based
                                                       ! on climatology

       REAL :: MIN_STRATO3_FRAC ! minimum fraction of O3 column in statosphere
       REAL :: MAX_TROPOO3_FRAC ! maximum fraction of O3 column in troposphere

!      REAL, PARAMETER :: MIN_STRATO3_FRAC = 0.55                   ! minimum fraction of O3 column in statosphere
                                                                    !  if PTOP = 50 mb
!      REAL, PARAMETER :: MAX_TROPOO3_FRAC = 1.0 - MIN_STRATO3_FRAC ! maximum fraction of O3 column in troposphere

!***LOGDEV for NEW_OPTICS and supporting routines
      
      INTEGER, SAVE :: NEW_OPTICS_LOG

      INTEGER, SAVE              :: N_DIAG_WVL    ! number of diagnostic wavelengths in PHOTDIAG3 file
      INTEGER, ALLOCATABLE, SAVE :: DIAG_WVL( : ) ! pointers to diagnostic wavelengths
      
      INTEGER            :: N_TROPO_O3_TOGGLE      ! number of adjustments to ozone extinction 
 
      REAL, ALLOCATABLE  :: RJ      ( :, :, :, : ) ! average grid cell J-values (min-1)
      REAL, ALLOCATABLE  :: RJ_RES  ( :, :, :, : ) ! resolved cloud J-values (min-1)
      REAL, ALLOCATABLE  :: RJ_SUB  ( :, :, :, : ) ! subgrid cloud J-values (min-1)
      REAL, ALLOCATABLE  :: ETOT_SFC_WL ( :,:,: )  ! total downward irradiance at sfc [ Watts / m**2  ]
      
      REAL, ALLOCATABLE  :: BLKHCHO( : )           ! formaldehyde concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE  :: BLKCO  ( : )           ! CO concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE  :: BLKSO2 ( : )           ! SO2 concentration [ molecules/cm**3 ]
      REAL, ALLOCATABLE  :: BLKDZ  ( : )           ! layer thicknesses [ m ]
      REAL, ALLOCATABLE  :: GAS_EXTINCTION( :,: )  ! extinction from gases per layer [1/m]
      REAL, ALLOCATABLE  :: EXTINCTION    ( :,: )  ! total extinction per layer [1/m]
      REAL, ALLOCATABLE  :: ACTINIC_FLUX  ( :,: )  ! actinic fluxes, initially [Photons/(cm^2s)] then  [Watts/m^2] 
      REAL, ALLOCATABLE  :: IRRADIANCE    ( :,: )  ! total downward irradiance [Watts/m^2]
      REAL               :: REFLECTION             ! broad band reflection coefficient (diffuse) at model top 
      REAL               :: TRANSMISSION           ! broad band transmission coefficient (diffuse) at surface
      REAL               :: TRANS_DIRECT           ! broad band direct transmission coefficient at surface
      REAL               :: TROPO_O3_COLUMN        ! ozone column density in the troposphere [Dobson Units]
      REAL               :: TROPO_O3_TOGGLE        ! factor correcting tropospheric ozone column 
      REAL               :: O3_TOGGLE_AVE          ! average of nonunity factors adjusting ozone extinction 
      REAL               :: O3_TOGGLE_MIN          ! Max of nonunity factors adjusting ozone extinction 
      REAL               :: COS85                  ! cosine of 85 degrees
  
      LOGICAL            :: ONLY_SOLVE_RAD             ! only compute fluxes     
      LOGICAL            :: OBEY_STRATO3_MINS = .TRUE. ! Has stratospheric O3 column not violated 
                                                       ! climatological minimums, yet?
      LOGICAL            :: STRATO3_MINS_MET           ! Does the call to NEW_OPTICS meet the stratospheric O3 column
                                                       ! climatological minimums?

           
      CHARACTER( 133 )   :: PHOT_MOD_MSG
      
      INTEGER            :: PHOT_COL   ! cell column of routine calling module routine
      INTEGER            :: PHOT_ROW   ! cell row of routine calling module routine


      CONTAINS
      
      SUBROUTINE INIT_PHOT_SHARED()

          USE RXNS_DATA            ! chemistry variables and data
          USE GRID_CONF            ! horizontal & vertical domain specifications
          USE UTILIO_DEFN
! Purpose: initialize data and arrays shared by other science processes      
          IMPLICIT NONE
!Arguments: None

!Local:          
          INTEGER          :: ALLOCSTAT
          CHARACTER( 240 ) :: XMSG = ' '
          LOGICAL, SAVE    :: INITIALIZED = .FALSE.
          
          IF ( INITIALIZED ) RETURN
          
          INITIALIZED = .TRUE.

          CALL LOAD_CSQY_DATA( )

          CALL LOAD_OPTICS_DATA( )

          ALLOCATE( RJ      ( NCOLS, NROWS, NLAYS, NPHOTAB ),
     &              RJ_RES  ( NCOLS, NROWS, NLAYS, NPHOTAB ),
     &              RJ_SUB  ( NCOLS, NROWS, NLAYS, NPHOTAB ), STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
              XMSG = 'Failure allocating photolysis rate arrays'
              CALL M3EXIT ( 'INIT_PHOT_SHARED', 0, 0, XMSG, XSTAT1 )
          END IF

          ALLOCATE( ETOT_SFC_WL( NCOLS,NROWS,NWL ), STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
              XMSG = 'Failure allocating irradiance rate array'
              CALL M3EXIT ( 'INIT_PHOT_SHARED', 0, 0, XMSG, XSTAT1 )
          END IF

          RJ = 0.0; RJ_RES = 0.0; RJ_SUB = 0.0
          ETOT_SFC_WL = 0.0
          
      END SUBROUTINE INIT_PHOT_SHARED

C///////////////////////////////////////////////////////////////////////
      SUBROUTINE NEW_OPTICS ( JDATE, JTIME, NLAYS, 
     &                        BLKTA, BLKPRS, BLKDENS, BLKZH, BLKZF,
     &                        BLKO3, BLKNO2,
     &                        ZSFC, COSZEN, SINZEN, RSQD,
     &                        NEW_PROFILE, CLOUDS, CLDFRC,
     &                        BLKRJ, TAUC_AERO, TAU_TOT, TAUO3_TOP,
     &                        TAU_RAY, SSA_AERO, TAU_CLOUD, TOTAL_O3_COLUMN )
C-----------------------------------------------------------------------
C
C  FSB  NOTE new call vector <<<<<<<<<<<<< **********
C
C  FSB This version has clouds
C  FSB calculates the photolysis rates as a function of species and height
C
C  first coded 10/19/2004 by Dr. Francis S. Binkowski
C     Carolina Environmental Program
C     University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C  modified by FSB  July 29, 2005, 01/19/2006  by FSB
C
C  Mar 2011 Bill Hutzell
C      -revised arguement to account for aerosol redesign in 
C       CMAQ version 5.0
C      -change array declaration to allow flexible number of
C       wavelength bins 
C  Apr 2012 Bill Hutzell
C      -revised error checking to needed photolysis data 
C      -modified case statement for RACM2 photolysis rates
C      -moved aerosol optics to its own module
C  07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE RXNS_DATA            ! chemical mechanism data
      USE CLOUD_OPTICS         ! data and routines for optics of cloud hydrometeors

      USE AERO_PHOTDATA
      
      IMPLICIT NONE

!***arguments
      INTEGER, INTENT(IN) :: JDATE   ! julian date YYYYDDD
      INTEGER, INTENT(IN) :: JTIME   ! TIME HHMMSS
      INTEGER, INTENT(IN) :: NLAYS   ! # of vertical layers
      
      REAL,    INTENT(IN) :: BLKPRS ( : )       ! Air pressure in [ atm ]
      REAL,    INTENT(IN) :: BLKTA  ( : )       ! Air temperature [ K ]
      REAL,    INTENT(IN) :: BLKDENS( : )       ! Air density  [ molecules / cm**3 ]
      REAL,    INTENT(IN) :: BLKZH  ( : )       ! layer half-height [ m ]
      REAL,    INTENT(IN) :: BLKZF  ( : )       ! layer full height[ m ]
      REAL,    INTENT(IN) :: BLKO3  ( : )       ! O3 concentration [ molecules / cm**3 ]
      REAL,    INTENT(IN) :: BLKNO2 ( : )       ! NO2 concentration [ molecules / cm**3 ]
      REAL,    INTENT(IN) :: ZSFC               ! surface height (msl) [ m ]
      REAL,    INTENT(IN) :: COSZEN, SINZEN     ! sine and cosine of the zenith angle
      REAL,    INTENT(IN) :: RSQD               ! square of  solar distance [ au**2 ]

      LOGICAL, INTENT(IN) :: NEW_PROFILE     ! Has the atmospheric profile changed since last call?
      LOGICAL, INTENT(IN) :: CLOUDS( : )  ! Does layer have clouds
      REAL,    INTENT(IN) :: CLDFRC( : )  ! fraction of gridcell covered by cloud
      

      REAL,    INTENT(OUT) :: BLKRJ( :,: )  ! photolysis rates [ 1 / sec ]

      REAL,    INTENT(OUT) :: TAUC_AERO( :,: )  ! aerosol optical depth, bottom of layer
      REAL,    INTENT(OUT) :: TAU_TOT  ( :,: )  ! total optical depth, bottom of layer
      REAL,    INTENT(OUT) :: TAU_CLOUD( :,: )  ! cloud optical depth, bottom of layer

      REAL,    INTENT(INOUT) :: TAUO3_TOP( : )  ! optical depth of ozone above model domain
      REAL,    INTENT(INOUT) :: TAU_RAY  ( : )  ! Rayleigh optical depth above model domain
      REAL,    INTENT(OUT)   :: SSA_AERO ( : )  ! single scatering albedo for aerosol column
      
      REAL, INTENT(INOUT) :: TOTAL_O3_COLUMN  ! total ozone colum density [ DU ]

!***internal
      REAL, PARAMETER :: ONE_OVER_PI = 1.0 / PI 
      REAL, PARAMETER :: STRAT_TEMP  = 225.0    ! stratospheric temperature
      REAL, PARAMETER :: ZTOA        = 50.0E3   ! top of the atmosphere [ m ]

      INTEGER L, I, IWL, II, ILEV, IPHOT, MODE ! loop indices

      INTEGER NLEVEL
      REAL SOLAR_FLUX        ! solar flux at atmosphere top in a wavelength band, [photons/(cm^2*s)]
      REAL INSOLATION        ! downward solar flux at atmosphere top summed over wavelength bands, [photons/(cm^2*s)]

      REAL DELTA_O3_COLUMN   ! change in ozone column density [molecules/cm2]
      REAL STRAT_O3_COLUMN   ! ozone column density in the stratosphere [molecules/cm2]
      REAL STRAT_O3_COLMIN   ! ozone minium column density in the stratosphere [molecules/cm2]
      REAL TAU_O3            ! optical depth of stratospheric ozone [ m ]
      REAL DENSTOM           ! estimated air density at top of model [ molecules / cm**3 ]
      REAL LAMDA             ! wavelength  [ nm ]
      REAL INV_LAMBDA        ! reciprocal of wavelength [ 1/nm ]
      REAL LAMDA_UM          ! wavelength  [ um ]

!***working absorption cross sections [ cm**2 ]. These have been corrected
!***  for ambient ( pressure and temperature ) conditions.

      REAL AO3
      REAL ANO2
      REAL BETA_M     ! molecular scattering coefficient [ 1/m ]
      REAL BEXT       ! total aerosol extinction coefficient [ 1/m ]
      REAL VFAC, BSC  ! unit correction factors
      REAL BSCAT      ! total aerosol scattering coefficient [ 1/m ]
      REAL G_BAR      ! total aerosol asymmetry factor

!***FSB The following variable is aq switch that allows a fast version of
!***  aerosol optics to be used when set to .TRUE.

!***scattering and absorption for the layer

      REAL DTABS_A, DTABS_M, DTSCAT_A, DTSCAT_M, DTSCAT, DTABS

!***variables describing the layer heights and slants
!     REAL DJ, DF
      REAL ZTOM                               ! top of model  [ m ]
      REAL, ALLOCATABLE, SAVE :: DSDH_TD( : ) ! slant path function from top down
      REAL, ALLOCATABLE, SAVE :: DSDH( : )    ! slant path function
      REAL, SAVE              :: DSDH_TOP     ! slantpath function from ZTOM to ZTOA

!***Increment of optical depth

      REAL, ALLOCATABLE, SAVE :: DTAU    ( : )   ! total depth at level
      REAL, ALLOCATABLE, SAVE :: DT_AERO ( : )   ! aerosol contribution at level
      REAL, ALLOCATABLE, SAVE :: DT_CLOUD( : )   ! cloud contribution at level

!***single scattering albedo for layer

      REAL, ALLOCATABLE, SAVE :: OM( : )

!***asymmetry factor

      REAL, ALLOCATABLE, SAVE :: G( : )

!***arrays for fluxes and irradiances used in

!***delta-Eddington code

      REAL, ALLOCATABLE, SAVE :: FDIR( : )   ! direct actinic flux
      REAL, ALLOCATABLE, SAVE :: FUP ( : )   ! diffuse upward actinic flux
      REAL, ALLOCATABLE, SAVE :: FDN ( : )   ! diffuse downward flux
      REAL, ALLOCATABLE, SAVE :: EDIR( : )   ! direct irradiance
      REAL, ALLOCATABLE, SAVE :: EUP ( : )   ! diffuse upward irradiance
      REAL, ALLOCATABLE, SAVE :: EDN ( : )   ! diffuse downward irradiance

!***surface albedo

      REAL RSFC

      REAL FX
      REAL, ALLOCATABLE, SAVE :: ESUM( : )   ! total downward irradiance
      REAL, ALLOCATABLE, SAVE :: FSUM( : )   ! total actinic flux

!***needed for stratospheric Raleigh optical depth
      REAL, PARAMETER :: R_G = 100.0 * RDGAS / GRAV  ! dry air gas constant
                                                     ! divided by gravitational
                                                     ! acceleration [cm/K] NOTE: cgs units

      REAL HSCALE               ! Scale height [cm] ! NOTE: cgs units

      REAL NBAR                 ! total number of air molecules [ # /cm**2 ]
                                ! above top of model domain


!***FSB Cloud properties.
!***  FSB These properties are taken fro HU & Stamnes,1993,
!***  An accurate parameterizationof the radiative properties of
!***  water clouds suitable for use in climate models, Journal of
!***  Climate, vol. 6, pp. 728-742. The values in the data statements
!***  were calculated with an equivalent radius of 10 micrometers.
!***  Note: Hu &Stamnes give beta in [ 1 / km/ for LWC in [ g / m**3 ]
!***  the values for beta/ LWC also give beta in [1/m] with LWC in [g/m **3]

      REAL G_CLOUD              ! local cloud asymmetry factor
      REAL OM_CLOUD             ! local cloud single scattering albedo
      REAL DTSCAT_CLOUD         ! level increment in cloud scattering optical
      REAL TAU_SCAT_CLD         ! total scattering optical depth of cloud
      REAL LAYERING_FACTOR      ! correction factor for cloud layering
      REAL STOZONE

      LOGICAL, SAVE :: FIRST = .TRUE.  ! Flag for first call
      LOGICAL       :: SUCCESS

!***arrays for fluxes and irradiances used in
      REAL, ALLOCATABLE, SAVE :: SRAYL( : )        ! Molecular scattering cross sections [ cm ** 2]
      REAL, ALLOCATABLE, SAVE :: TAU_SCAT( : )     ! aerosol scattering optical depth
      REAL, ALLOCATABLE, SAVE :: CONV_WM2( : )     ! conversion factor [photons/(cm**2 s )] to [Watts/m**2]

!***three-dimensional array for Cs and Qy
!***  (temperature, wavelength, species)
!***(layer, wavelength species)

      REAL, ALLOCATABLE, SAVE :: CSZ( :,:,: )
      REAL, ALLOCATABLE, SAVE :: QYZ( :,:,: )

      IF ( FIRST ) THEN

         ALLOCATE( CONV_WM2( NWL ) )
         ALLOCATE( SRAYL   ( NWL ) )
         ALLOCATE( TAU_SCAT( NWL ) )
         ALLOCATE( CSZ( NLAYS,NWL,NPHOTAB ) )
         ALLOCATE( QYZ( NLAYS,NWL,NPHOTAB ) )
         
         ALLOCATE( GAS_EXTINCTION( NLAYS,NWL ) )
         ALLOCATE( EXTINCTION    ( NLAYS,NWL ) )
         ALLOCATE( ACTINIC_FLUX  ( NLAYS,NWL ) )
         ALLOCATE( IRRADIANCE    ( NLAYS,NWL ) )
         
         ALLOCATE( DSDH_TD ( NLAYS+1 ),
     &             DSDH    ( NLAYS ),
     &             DTAU    ( NLAYS+1 ),
     &             DT_AERO ( NLAYS+1 ),
     &             DT_CLOUD( NLAYS+1 ),
     &             OM      ( NLAYS+1 ),
     &             G       ( NLAYS+1 ),
     &             FDIR    ( NLAYS+1 ),
     &             FUP     ( NLAYS+1 ),
     &             FDN     ( NLAYS+1 ),
     &             EDIR    ( NLAYS+1 ),
     &             EUP     ( NLAYS+1 ),
     &             EDN     ( NLAYS+1 ),
     &             ESUM    ( NLAYS ),
     &             FSUM    ( NLAYS ) )

!***FSB Set up conversion factor for
!***  [photons / ( cm**2 s) ] to [Watts / m**2 ]
!***  THE 1.0E13 FACTO IS 1.0E9 * 1.0 E4
!***  The 1.0e9 is for the wavelength [ nm ] -> [ m ]
!***  The 1.0e4 is for the area [ cm **2 ] -> [ m**2 ]

         DO IWL = 1, NWL
            LAMDA = WAVELENGTH( IWL )
            CONV_WM2( IWL ) = 1.0E13 * ( PLANCK_C * LIGHT_SPEED ) / LAMDA
         END DO

!         COS85 = COS( 85.0 * PI180 )

!***get molecular scattering cross sections

         CALL GETSRAY ( NWL, WAVELENGTH, SRAYL )

         FIRST = .FALSE.

      END IF   ! FIRSTIME

!***initialize BLKRJ and other layer variables

      BLKRJ          = 0.0
      BLKDZ          = 0.0
      GAS_EXTINCTION = 0.0
      EXTINCTION     = 0.0
      ACTINIC_FLUX   = 0.0
      IRRADIANCE     = 0.0
      REFLECTION     = 0.0
      TRANSMISSION   = 0.0
      TRANS_DIRECT   = 0.0
      INSOLATION     = 0.0
      TROPO_O3_TOGGLE  = 1.0
      STRATO3_MINS_MET = .TRUE.
!***Initialize sums or set default values for outputs: 
!   TAUC_AERO, TAU_TOT, TAUO3_TOP, TAU_RAY, SSA_AERO, etc.

      TAUC_AERO = 0.0
      TAU_TOT   = 0.0
      TAU_CLOUD = 0.0
      TAU_SCAT  = 0.0
      SSA_AERO  = 0.0
      TOTAL_TAU_CLD = 0.0
#ifdef phot_debug      
      AVE_SSA_CLD   = 0.0
      AVE_ASYMM_CLD = 0.0
#endif
!***Test zenith angle. If coszen is zero or negative, zenith angle is
!***  equal to or greater than 90 degrees, i.e. before sunrise or
!***  after sunset at the surface.
!***  Return  all photolysis rates set to zero. Ignore possible twilight
!***  processes in upper troposphere.

!***FSB NOTE: tests of the algorithm for slant path show that the
!***  critical zenith angle for the tropospheric slant path is 88 degrees,
!***  but the critical zenith angle for the stratospheric slant path is
!***  85 degrees.  Thus, the code returns zeros for angles greater then or
!***  equalt to 85 degrees. cos( 85 degrees ) equals 8.715574e-02.

      IF ( COSZEN .LE. COS85 ) THEN
         TAUO3_TOP = 0.0
         TAU_RAY   = 0.0
         TROPO_O3_COLUMN = 0.0
         TROPO_O3_TOGGLE = 1.0
         RETURN
      END IF

      IF ( NEW_PROFILE ) THEN  ! update based on new temperature and density profile
!***Adjust cross sections and quantum yields for ambient conditions

         CALL GET_CSQY ( BLKTA, BLKDENS, CSZ, QYZ )

!***calculate scale height from top of model domain

         HSCALE = R_G * BLKTA( NLAYS )

!***estimate air density at top of model domain

         DENSTOM = BLKDENS( NLAYS )
     &           * EXP( -100.0 * ( BLKZF( NLAYS + 1 ) - BLKZH( NLAYS ) )
     &           / HSCALE )

!***calculate the total number of air molecules [ # / cm**2 ]
!***  above top of model domain.

         NBAR = HSCALE * DENSTOM

!***set top of modeling domain

         ZTOM = BLKZF( NLAYS + 1 )

!***get layer thicknesses and slantpath starting at the TOP

         CALL SLANTPATH2 ( NLAYS, BLKZF, ZSFC, REARTH, SINZEN, BLKDZ, DSDH )

!***get slantpath from ZTOM to ZTOA

         CALL SLANTPATHTOP ( ZTOM, ZTOA, ZSFC, REARTH, SINZEN, DSDH_TOP )

C*** find ozone column density for atmosphere, stratosphere, and troposphere
         STRAT_O3_COLUMN = DU_TO_CONC * REAL( TOTAL_O3_COLUMN )
!         STRAT_O3_COLMIN = 0.10 * STRAT_O3_COLUMN
         STRAT_O3_COLMIN = MIN_STRATO3_FRAC * STRAT_O3_COLUMN
         SUCCESS = .TRUE.
         TROPO_O3_COLUMN = 0.0
         DO L = NLAYS, 1, -1
            DELTA_O3_COLUMN = 100.0 * BLKO3( L ) * BLKDZ( L )
            STRAT_O3_COLUMN = STRAT_O3_COLUMN - DELTA_O3_COLUMN
            TROPO_O3_COLUMN = TROPO_O3_COLUMN + DELTA_O3_COLUMN
            IF ( STRAT_O3_COLUMN .LT. STRAT_O3_COLMIN  .AND. SUCCESS ) THEN
               IF( OBEY_STRATO3_MINS )THEN
                   WRITE( LOGDEV,'( /A, F5.2, A, 3(/A), I3, A,  F8.3, A , 2(I4,1X) )' )
     &             'PHOT WARNING: First Occurance where computed stratospheric O3 column < ',
     &              100.0*MIN_STRATO3_FRAC,'%',
     &             'observed total column. The percentage is a global minimum based on ',
     &             'climatological ozone profiles. ',
     &             'The Error accumulates downward from layer = ', L, ' or alt= ', 
     &              0.001*BLKZF( L ),' Km for col,row = ', PHOT_COL, PHOT_ROW
               END IF
               SUCCESS = .FALSE.
            END IF
         END DO

         STRAT_O3_COLUMN = CONC_TO_DU * STRAT_O3_COLUMN
         TROPO_O3_COLUMN = CONC_TO_DU * TROPO_O3_COLUMN

#ifdef verbose_PHOT_MOD
         IF( PHOT_COL .EQ. 1 .AND. PHOT_ROW .EQ. 1 )THEN
              WRITE( LOGDEV,*)'TOTAL_O3_COLUMN, TROPO_O3_COLUMN = ',TOTAL_O3_COLUMN, TROPO_O3_COLUMN
         END IF
#endif

         IF ( .NOT. SUCCESS ) THEN
            TROPO_O3_TOGGLE   = MAX_TROPOO3_FRAC * TOTAL_O3_COLUMN
     &                        / TROPO_O3_COLUMN
            N_TROPO_O3_TOGGLE = N_TROPO_O3_TOGGLE + 1 
            O3_TOGGLE_AVE     = O3_TOGGLE_AVE + TROPO_O3_TOGGLE
            O3_TOGGLE_MIN     = MIN( O3_TOGGLE_MIN, TROPO_O3_TOGGLE)
            STRATO3_MINS_MET  = .FALSE. 
            STRAT_O3_COLUMN = CONC_TO_DU * STRAT_O3_COLMIN
           IF( OBEY_STRATO3_MINS )THEN ! write to PE log for first occurance
               WRITE( LOGDEV, 99983)STRAT_O3_COLUMN
               IF( ADJUST_OZONE ) WRITE( LOGDEV, 99984)TROPO_O3_TOGGLE
               WRITE( LOGDEV, 99887)
               WRITE( LOGDEV, 99888)TOTAL_O3_COLUMN, TROPO_O3_COLUMN, MAX_TROPOO3_FRAC
               WRITE( LOGDEV, 99999)
               OBEY_STRATO3_MINS = .FALSE.
            END IF
            IF( .NOT. ADJUST_OZONE ) TROPO_O3_TOGGLE = 1.0 ! reset toggle to one 
         ELSE
            TROPO_O3_TOGGLE = 1.0
         END IF


99983    FORMAT( 'Corrective Action: 1) Stratospheric O3 column set to ',F8.3,' DU' ) 
99984    FORMAT( 'and 2) Extinction from Model Domain O3 multiplied by ',F9.6 )
99887    FORMAT(/'Check TROPO_O3_EXCEED and N_EXCEED_TROPO3 in PHOTDIAG1 file for '
     &          /'values greater than zero to assess the extent of the '
     &          /'problem. TROPO_O3_EXCEED and N_EXCEED_TROPO3 are the average '
     &          /'exceedance and their number over file time step for each grid cell,'
     &          /'respectively. Exceedance depends on the predicted tropospheric'
     &          /'fraction over the maximum allowed fraction of the total ozone column.'
     &          /'Its value equals the ratio minus one if ratio is greater than one and'
     &          /'zero if the ratio is less than or equal to one. N_EXCEED_TROPO3 '
     &          /'counts the number of nonzero values per timestep')
99888    FORMAT(/'Direct Cause: Predicted O3 tropospheric Column exceeds maximum allowed '
     &          /'fraction of total OMI column.',
     &          /'OMI Total O3 Column = ',F8.3,' DU: Model Tropospheric O3 Column = ',F8.3,' DU',
     &          /'Climatological Expected Tropospheric Fraction = ',F9.6)
99999    FORMAT(/'ULTIMATE causes include boundary condition and meteorological input files. '
     &          /'Check the former for unrealistic concentrations of ozone and its precursors.'
     &          /'Check the latter for unrealistic advection and diffusion parameters.')           
         
         DO IWL = 1, NWL
!***Get optical depth for stratospheric ozone column
!***Note that stratosphere ozone coluumn assumed to exist above model domain
            CALL GET_TAUO3 ( IWL, STRAT_O3_COLUMN, STRAT_TEMP, TAUO3_TOP( IWL ) )
!***get Rayleigh optical depth for stratosphere
            TAU_RAY( IWL ) = NBAR * SRAYL( IWL )         
         END DO
      END IF ! for NEW_PROFILE

!***loop over wavelengths
      DO IWL = 1, NWL           ! outermost loop

!        RSFC       = ALB( IWL )        ! surface albedo

!***set scaling factor for reducing extraterrestrial flux
!***  add ozone and Rayleigh optical depths. Use the
!***  pseudospherical correction for the stratosphere.

         SOLAR_FLUX = FEXT( IWL ) / RSQD

!*** initialize tau, delta tau's, other variables and loop over layers

         DTAU         = 0.0
         DT_AERO      = 0.0
         DT_CLOUD     = 0.0
         DTSCAT_CLOUD = 0.0
         TAU_SCAT_CLD = 0.0
         
         DO L = 2, NLAYS + 1
            II = NLAYS + 2 - L  ! from top to bottom

!***in the following statements the factor of 100.0 converts
!***  converts [ 1 / cm ] to [ 1 / m ]

            BETA_M = SRAYL( IWL )         * BLKDENS( II ) * 100.0
            AO3    = CSZ( II,IWL,LO3O3P ) * BLKO3  ( II ) * 100.0
            AO3    = TROPO_O3_TOGGLE      * AO3
            ANO2   = CSZ( II,IWL,LNO2   ) * BLKNO2 ( II ) * 100.0

!***set up aerosol optical properties

            G_BAR = AERO_ASYM_FAC ( II,IWL )
            BEXT  = AERO_EXTI_COEF( II,IWL )
            BSCAT = AERO_SCAT_COEF( II,IWL )

!***calculate total absorption and scattering contributions
!***to optical depth

!***The contributions to scattering and absorption from molecules and particles
!***  are calculated separately to facilitate the calculation
!***  of the total single scatering albedo of the column of aerosols
!***  as measured by satellites.

            DTSCAT_M = BETA_M * BLKDZ( II ) ! molecular scattering
            DTSCAT_A = BSCAT  * BLKDZ( II ) ! particle scattering

            DTSCAT_M = MAX( DTSCAT_M, SMALL )
            DTSCAT_A = MAX( DTSCAT_A, SMALL )


            DTABS_M  = ( AO3 + ANO2  )  * BLKDZ( II ) ! molecular absorption
            DTABS_A  = ( BEXT - BSCAT ) * BLKDZ( II ) ! particle absorption

            DTABS_M  = MAX( DTABS_M, SMALL )
            DTABS_A  = MAX( DTABS_A, SMALL )

            GAS_EXTINCTION( II,IWL ) = BETA_M + AO3 + ANO2        ! gas extinction
            EXTINCTION( II,IWL )     = BETA_M + BEXT + AO3 + ANO2 ! gas and aerosol extinction
            
            IF ( CLOUDS( II ) ) THEN 
     
               DT_CLOUD( L ) = ( CLOUD_LIQUID_EXT( II,IWL ) 
     &                       +   CLOUD_ICE_EXT( II,IWL )
     &                       +   CLOUD_AGGREG_EXT( II,IWL ) ) * BLKDZ( II )
               DTSCAT_CLOUD  = ( CLOUD_LIQUID_SCAT( II,IWL )
     &                       +   CLOUD_ICE_SCAT( II,IWL )
     &                       +   CLOUD_AGGREG_SCAT( II,IWL ) ) * BLKDZ( II )

!Adjust DT_CLOUD for cloud fraction by 1/2 power of CLDFRC to approximate cloud overlap.
!Note that the power results because the resolved cloud conentrations are averaged over
!the grid cell so the net overlap correction equal cfrac**(3/2) from Briegleb (1992) times
!cfrac**(-1) for actual in-cloud concentrations (see Voulgarakis et al., 2009, Geosci Model
!Dev., vol. 2, pp. 59-72.

               IF ( CLOUD_LAYERING( II ) ) THEN
                  LAYERING_FACTOR = SQRT( CLDFRC( II ) )
               ELSE
                  LAYERING_FACTOR = CLDFRC( II )
               END IF
               DT_CLOUD( L ) = DT_CLOUD( L ) * LAYERING_FACTOR
               DTSCAT_CLOUD  = DTSCAT_CLOUD  * LAYERING_FACTOR
 
               EXTINCTION( II,IWL ) = EXTINCTION( II,IWL )
     &                              + ( CLOUD_LIQUID_EXT( II,IWL ) 
     &                              +   CLOUD_ICE_EXT( II,IWL )
     &                              +   CLOUD_AGGREG_EXT( II,IWL ) ) * LAYERING_FACTOR
    
               TAU_SCAT_CLD = TAU_SCAT_CLD + DTSCAT_CLOUD

               IF ( DT_CLOUD( L ) .GT. 1.0E-6 ) THEN
                  OM_CLOUD = MAX( DTSCAT_CLOUD /DT_CLOUD( L ), 1.0) 
                  IF ( OM_CLOUD .LT. 0.0 .OR. OM_CLOUD .GT. 1.0 .OR. OM_CLOUD .NE. OM_CLOUD) THEN
                     WRITE( LOGDEV,'(A,I3,A,ES12.4,A)',ADVANCE = 'NO')
     &               'OM_CLOUD( L = ', L, ' ) = ', OM_CLOUD,' resetting to '
                     OM_CLOUD = MAX( 0.000001, MIN( OM_CLOUD, 0.99999))
                     WRITE( LOGDEV,'(ES12.4)')OM_CLOUD
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'LIQUID_EXT, LIQUID_SCAT = ',
     &               CLOUD_LIQUID_EXT( II,IWL ), CLOUD_LIQUID_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'ICE_EXT, ICE_SCAT = ',
     &               CLOUD_ICE_EXT( II,IWL ), CLOUD_ICE_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))')'AGGREG_EXT, AGGREG_SCAT = ',
     &               CLOUD_AGGREG_EXT( II,IWL ), CLOUD_AGGREG_SCAT( II,IWL )
                     CALL M3EXIT( 'NEW_OPTICS', JDATE, JTIME, ' ', XSTAT1 )
                  END IF
               ELSE 
                  OM_CLOUD = 1.0
               END IF


               IF ( DTSCAT_CLOUD .GT. 1.0E-6 ) THEN
               
                  G_CLOUD = ( (CLOUD_LIQUID_ASY( II,IWL ) * CLOUD_LIQUID_SCAT( II,IWL ))
     &                    +   (CLOUD_ICE_ASY( II,IWL )    * CLOUD_ICE_SCAT( II,IWL ))
     &                    +   (CLOUD_AGGREG_ASY( II,IWL ) * CLOUD_AGGREG_SCAT( II,IWL )) )
     &                    *   BLKDZ( II ) * LAYERING_FACTOR


#ifdef phot_debug
                  IF ( .NOT. ONLY_SOLVE_RAD ) THEN
                     AVE_ASYMM_CLD( IWL ) = AVE_ASYMM_CLD( IWL ) + G_CLOUD
                     IF ( AVE_ASYMM_CLD( IWL ) .GT. TAU_SCAT_CLD ) THEN
                        WRITE( LOGDEV,'(A,I3,2(A,ES12.4))' )
     &                  'Sum for AVE_ASYMM_CLD at L (', L,') = ', AVE_ASYMM_CLD( IWL ),
     &                  ' Sum for TAU_SCAT_CLD = ',TAU_SCAT_CLD 
                        WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'AVE_ASYMM_CLD Increment = ', G_CLOUD
                        WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'TAU_SCAT_CLD Increment = ', DTSCAT_CLOUD
                     END IF
                  END IF
#endif                   

                  G_CLOUD  = G_CLOUD / DTSCAT_CLOUD

                  IF ( G_CLOUD .GE. 1.0 .OR. G_CLOUD .LE. -1.0 .OR. G_CLOUD .NE. G_CLOUD ) THEN
                     WRITE( LOGDEV,'(A,I3,A,ES12.4,A)',ADVANCE = 'NO' )
     &                  'G_CLOUD( L = ', L, ' ) = ', G_CLOUD,' resetting to '
                        G_CLOUD = MIN( 0.9999, MAX( G_CLOUD, -0.9999) )
                     WRITE( LOGDEV,'(ES12.4)') G_CLOUD
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'LIQUID_ASY, LIQUID_SCAT = ',
     &                  CLOUD_LIQUID_ASY( II,IWL ), CLOUD_LIQUID_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'ICE_ASY, ICE_SCAT = ',
     &                  CLOUD_ICE_ASY( II,IWL ), CLOUD_ICE_SCAT( II,IWL )
                     WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &                  'AGGREG_ASY, AGGREG_SCAT = ',
     &                  CLOUD_AGGREG_ASY( II,IWL ), CLOUD_AGGREG_SCAT( II,IWL )
                     CALL M3EXIT( 'NEW_OPTICS', JDATE, JTIME, ' ', XSTAT1 )
                  END IF
               ELSE
                  G_CLOUD = 0.0
               END IF            
            ELSE
               DTSCAT_CLOUD = 0.0
               G_CLOUD      = 0.0
               OM_CLOUD     = 1.0
            END IF

!***calculate total absorption and scattering contributions
!***to optical depth

            DTSCAT = DTSCAT_M + DTSCAT_A + DTSCAT_CLOUD
            DTABS  = DTABS_M  + DTABS_A + MAX(( 1.0 - OM_CLOUD ), 0.0) * DT_CLOUD( L )

!***set aerosol optical depth for later use

            DT_AERO ( L ) = BEXT * BLKDZ( II )

!***Now calculate the vertical profiles of optical depth,
!***  single scattering albedo, asymmetry factor
!***  and DSDH starting at the top.

            DTAU( L ) = DTSCAT + DTABS
            OM  ( L ) = DTSCAT / ( DTSCAT + DTABS )
            G   ( L ) = ( G_BAR * DTSCAT_A + G_CLOUD * DTSCAT_CLOUD ) / DTSCAT

            IF ( G( L ) .GE. 1.0 .OR. G( L ) .LE. -1.0 .OR. G( L ) .NE. G( L ) ) THEN
               WRITE( LOGDEV,'(A,ES12.4,A)',ADVANCE = 'NO' )
     &         'G( L ) = ', G( L ),' resetting to '
               G( L ) = MIN( 0.9999, MAX( G( L ), -0.9999) )
               WRITE( LOGDEV,'(ES12.4)')G( L )
               WRITE( LOGDEV,'(A,10(1X,ES12.4))' )
     &         'DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD, G_BAR, G_CLOUD = ',
     &          DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD, G_BAR, G_CLOUD
            END IF

            IF ( OM( L ) .GT. 1.0 .OR. OM( L ) .LE. 0.0 .OR. OM( L ) .NE. OM( L ) ) THEN
               WRITE( LOGDEV,'(A,ES12.4,A)',ADVANCE = 'NO' )
     &         'OM( L ) = ', OM( L ),' resetting to '
               OM( L ) = MIN( 0.9999, MAX( OM( L ), 0.0001) )
#ifdef phot_debug
               WRITE( LOGDEV,'(ES12.4)' ) OM( L )
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         'DTSCAT, DTABS, ( DTSCAT + DTABS) = ',
     &         DTSCAT, DTABS, ( DTSCAT + DTABS )
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         'DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD = ',
     &         DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         'DDTABS_M, DTABS_A, MAX(( 1.0-OM_CLOUD ), 0.0) * DT_CLOUD( L ) = ',
     &         DTABS_M, DTABS_A, MAX(( 1.0 - OM_CLOUD ), 0.0) * DT_CLOUD( L )
               WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &         ' AO3, ANO2,AERO_BEXT, AERO_BSCAT = ',
     &         AO3, ANO2,BEXT, BSCAT
#endif
            ELSE
#ifdef phot_debug
               IF ( OM( L ) .EQ. 1.0 ) THEN
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'DTSCAT, DTABS, ( DTSCAT + DTABS ) = ',
     &             DTSCAT, DTABS, (DTSCAT + DTABS)
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD = ',
     &             DTSCAT_M, DTSCAT_A, DTSCAT_CLOUD
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'DDTABS_M, DTABS_A, MAX(( 1.0-OM_CLOUD ), 0.0) * DT_CLOUD( L ) = ',
     &            DTABS_M, DTABS_A, MAX(( 1.0 - OM_CLOUD ), 0.0 ) * DT_CLOUD( L)
                  WRITE( LOGDEV,'(A,4(1X,ES12.4))' )
     &            'AO3, ANO2,AERO_BEXT, AERO_BSCAT = ',
     &            AO3, ANO2,BEXT, BSCAT
               END IF
#endif
               OM( L ) = MIN( 0.9999,  OM( L ) )
            END IF

            DSDH_TD( L ) = DSDH( L - 1 )

            IF ( ONLY_SOLVE_RAD ) CYCLE
!***FSB get sums of unscaled optical depths

            TAU_SCAT( IWL ) = TAU_SCAT ( IWL ) + DTSCAT_A

!***initialize optical depth profiles to the layer increment
     
            TAUC_AERO( II,IWL ) = DT_AERO( L )  ! aerosol optical depth
            TAU_TOT  ( II,IWL ) = DTAU( L )     ! total optical depth
            TAU_CLOUD( II,IWL ) = DT_CLOUD( L ) ! cloud optical depth
!***change extinction units from meters to Megameters
            EXTINCTION( II,IWL ) = 1000.0 * EXTINCTION( II,IWL )

         END DO                 ! loop over layers

!***set values for the stratosphere

         OM     ( 1 ) = TAU_RAY( IWL ) / ( TAU_RAY( IWL ) + TAUO3_TOP( IWL ) )
         G      ( 1 ) = 0.05
         DTAU   ( 1 ) = TAUO3_TOP( IWL ) + TAU_RAY( IWL )
         DSDH_TD( 1 ) = DSDH_TOP

         NLEVEL = NLAYS + 1

         IF ( .NOT. ONLY_SOLVE_RAD ) THEN
!***calculate optical depth profiles
            TAU_TOT  ( NLAYS,IWL ) = TAU_TOT  ( NLAYS,IWL ) + DTAU( 1 )
            TAUC_AERO( NLAYS,IWL ) = TAUC_AERO( NLAYS,IWL ) + DT_AERO( 1 )  
            TAU_CLOUD( NLAYS,IWL ) = TAU_CLOUD( NLAYS,IWL ) + DT_CLOUD( 1 ) 

            DO L =  NLAYS-1, 1, -1
               TAU_TOT  ( L,IWL ) = TAU_TOT  ( L,IWL ) + TAU_TOT  ( L+1,IWL )
               TAUC_AERO( L,IWL ) = TAUC_AERO( L,IWL ) + TAUC_AERO( L+1,IWL ) 
               TAU_CLOUD( L,IWL ) = TAU_CLOUD( L,IWL ) + TAU_CLOUD( L+1,IWL )
            END DO
         END IF
         
!***Set fluxes to zero

         FDIR = 0.0
         FUP  = 0.0
         FDN  = 0.0
         EDIR = 0.0
         EUP  = 0.0
         EDN  = 0.0

!***calculate fluxes and irradiances
         CALL TWOSTREAM_S ( NLEVEL, COSZEN, ALB( IWL ), DTAU, OM, G, DSDH_TD,
     &                      FDIR, FUP, FDN, EDIR, EUP, EDN )

         DO L = 1, NLAYS
            II = NLAYS + 2 - L
            FSUM( L ) = FDIR( II ) + FDN( II ) + FUP( II ) ! actinic flux
            ESUM( L ) = EDIR( II ) + EDN( II )             ! downward irradiance
         END DO                 ! loop over layers

! add diffusion and direct components for calculating reflectivity and transmissivity
         INSOLATION    = INSOLATION    + SOLAR_FLUX 
         REFLECTION    = REFLECTION    + SOLAR_FLUX * EUP( 1 )
         TRANSMISSION  = TRANSMISSION  + SOLAR_FLUX * EDN( NLEVEL )
         TRANS_DIRECT  = TRANS_DIRECT  + SOLAR_FLUX * EDIR( NLEVEL ) 

         IF ( ONLY_SOLVE_RAD ) CYCLE

!***FSB Calculate column averaged scattering albedo and asymmetry factor

         IF ( TAUC_AERO( 1,IWL ) .GT. 1.0E-30 ) THEN
            SSA_AERO( IWL ) = TAU_SCAT( IWL ) / TAUC_AERO( 1,IWL )
         END IF

         TOTAL_TAU_CLD( IWL ) = TAU_CLOUD( 1,IWL )

#ifdef phot_debug
         IF ( TAU_CLOUD( 1,IWL ) .GT. 1.0E-20 ) THEN
            IF ( AVE_ASYMM_CLD( IWL ) .GT. TAU_SCAT_CLD ) THEN
               WRITE( LOGDEV,'(A,I3,2(A,ES12.4))' )
     &         'Sum for AVE_ASYMM_CLD at L(', 1,') = ', AVE_ASYMM_CLD( IWL ),
     &         'Sum for TAU_SCAT_CLD = ',TAU_SCAT_CLD 
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'AVE_ASYMM_CLD Increment = ', G_CLOUD
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'TAU_SCAT_CLD Increment = ',
     &         DTSCAT_CLOUD
            END IF
            IF ( TAU_SCAT_CLD .GT. 1.0E-20 ) THEN
               AVE_ASYMM_CLD( IWL ) = AVE_ASYMM_CLD( IWL ) / TAU_SCAT_CLD
               AVE_SSA_CLD  ( IWL ) = TAU_SCAT_CLD / TAU_CLOUD( 1,IWL )
            ELSE
               AVE_ASYMM_CLD( IWL ) = 0.0
               AVE_SSA_CLD  ( IWL ) = 0.0
            END IF
            IF ( ABS( AVE_ASYMM_CLD( IWL ) ) .GE.  1.0 ) THEN
               WRITE( LOGDEV,'(A,I3,2(A,ES12.4))' )
     &         'Sum for AVE_ASYMM_CLD at L(', 1,') = ', AVE_ASYMM_CLD( IWL )*TAU_SCAT_CLD,
     &         'Sum for TAU_SCAT_CLD = ',TAU_SCAT_CLD 
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'AVE_ASYMM_CLD Increment = ', G_CLOUD
               WRITE( LOGDEV,'(A,2(ES12.4,1X))' )
     &         'TAU_SCAT_CLD Increment = ', DTSCAT_CLOUD
            END IF
         ELSE
            TOTAL_TAU_CLD( IWL ) = 0.0
            AVE_SSA_CLD  ( IWL ) = 0.0
            AVE_ASYMM_CLD( IWL ) = 0.0
         END IF
#endif
         
!***FSB capture the total downward irradiance at the surface [ W / m**2]
!
!        ETOT_SFC( IWL ) = CONV_WM2( IWL ) * FLXSCALE * FEXT( IWL )
!     &                  * ESUM( 1 )

         FORALL( L = 1:NLAYS )
!***multiply by the solar flux at the domain top for 
!***actinic flux and irradiance; keeping actinic flux in photons/(cm^2*s)
            ACTINIC_FLUX( L,IWL ) = SOLAR_FLUX * FSUM( L )
            IRRADIANCE  ( L,IWL ) = SOLAR_FLUX * CONV_WM2( IWL ) * ESUM( L )
         END FORALL
      END DO    ! loop over wavelengths

! normalize reflection and transmission coefficients 
      INSOLATION   = 1.0 / ( COSZEN * INSOLATION )
      TRANS_DIRECT = TRANS_DIRECT * INSOLATION
      REFLECTION   = ONE_OVER_PI * REFLECTION * INSOLATION 
      TRANSMISSION = ONE_OVER_PI * TRANSMISSION * INSOLATION

      IF ( ONLY_SOLVE_RAD ) RETURN 
               
! compute photolysis rates
      DO IPHOT = 1, NPHOTAB
         DO IWL = 1, NWL
            DO L = 1, NLAYS 
               BLKRJ( L,IPHOT ) = BLKRJ( L,IPHOT ) 
     &                          + ACTINIC_FLUX( L,IWL ) 
     &                          * CSZ( L,IWL,IPHOT ) * QYZ( L,IWL,IPHOT ) ! [ 1 / sec ]
            END DO
         END DO
      END DO  ! loop on layers, wavelength,  IPHOT
! convert actinic flux to watts/m^2    
      FORALL( L = 1:NLAYS, IWL=1:NWL  )
         ACTINIC_FLUX( L,IWL ) = ACTINIC_FLUX( L,IWL ) * CONV_WM2( IWL )
      END FORALL

!***compute rate of photolysis (j-values) for each reaction        

9503  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN_CORE(m) = ',ES12.4,
     &       ' DGN_SHELL(m) = ', ES12.4 / ' REFRACT_IDX_SHELL(NR,NI) = ', 2(ES12.4,1X),
     &       ' REFRACT_IDX_CORE(NR,NI) = ', 2(ES12.4,1X) / ' LN(GEO.STD.DEV.) = ',
     &       ES12.4)
9504  FORMAT('LAYER = ',I3,' MODE = ',I3,' LAMBDA(nm)  = ',ES12.4,' DGN(m) = ',ES12.4,
     &       ' REFRACT_IDX(NR,NI) = ', 2(ES12.4,1X) / ' VOL.DENS. = ', ES12.4,
     &       ' LN(GEO.STD.DEV.) = ', ES12.4)

99985 FORMAT('ERROR: Modeled Troposheric Ozone Column downward from layer ',I3,1X)
99986 FORMAT('exceeds Top Ozone Column based on OMI.data file. Negative Optical Depths ')
99987 FORMAT('but are physically unlikey.')
99988 FORMAT(' SETTING O3 Column ABOVE PTOP TO 25% of OMI.dat value  ')
99989 FORMAT(' FOR ROW/COL = ',2(1X,I4))

      RETURN
      END SUBROUTINE NEW_OPTICS

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE GETSRAY ( NWL, LAMDA, SRAYL )
C-----------------------------------------------------------------------
C  calculate molecular (Rayleigh) scattering cross section, srayl
C
C  coded 09/08/2004 by Dr. Francis S. Binkowski
C     Carolina Environmental Program
C     University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C
C  Reference:
C     Nicolet, M., On the molecular scattering in the terrestrial
C     atmosphere: An empirical formula for its calculation in the
C     homoshpere, Planetary and Space Science. Vol. 32,No. 11,
C     Pages 1467-1468, November 1984.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: NWL           ! number of wavelength bins
      REAL,    INTENT( IN )  :: LAMDA( : )  ! wavelengths  [nm]
      REAL,    INTENT( OUT ) :: SRAYL( : )  ! molecular scattering cross sections [cm**2]

!***Internal variables

      INTEGER I
      REAL    WMICRN               ! wavelenght in micrometers
      REAL    WMICRN1              ! 1 / wmicrn
      REAL    XX                   ! variable in Nicolet method

!***get molecular scattering cross section. This is a fixed
!***  function of wavelength.

      DO I = 1, NWL
         WMICRN = 1.0E-3 * LAMDA( I ) ! wavelength in micrometers
         WMICRN1 = 1.0 / WMICRN

         IF ( WMICRN .LE. 0.55 ) THEN
            XX = 3.6772 + 0.389 * WMICRN + 0.09426 * WMICRN1
         ELSE
            XX = 4.04
         END IF

         SRAYL( I ) = 4.02E-28 * WMICRN1**XX    ! in [cm**2]

      END DO

      RETURN
      END SUBROUTINE GETSRAY


      SUBROUTINE GET_TAUO3 ( IWL, STOZONE, STRAT_TEMP, TAU_O3 )
C-----------------------------------------------------------------------
C  subroutine to calculate the optical depth of ozone in the
C     stratosphere
C
C  special cross sections for calculating stratospheric ozone
C     optical depth
C
C  the following temperatures and cross sections are from
C     Fast-J
C     REFERENCE:
C     Wild, O., X. Zhu, and M.J. Prather, Fast-J: Accurate simulation
C     of in- and below-clolud photolysis in tropospheric chemical
C     models,
C     Journal of Atmospheric Chemistry, Vol. 37, pp 245-282, 2000
C
C  coded 10/20/2004 by Dr. Francis S. Binkowski
C     Carolina Environmental Program
C     University of North Carolina at Chapel Hill
C     email: frank_binkowski@unc.edu
C     Updated to Fast-JX version 5.0
C  Mar 2011 Bill Hutzell
C     revised interpolation method for a general number of
C     interpolation points
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: IWL         ! wavelenth index

      REAL,    INTENT( IN )  :: STOZONE     ! ozone column amount [ DU ]
      REAL,    INTENT( IN )  :: STRAT_TEMP  ! average temperature for stratosphere [ K ]
      REAL,    INTENT( OUT ) :: TAU_O3      ! optical depth for statosphere

!***Local

      INTEGER IXT, IXTEMP

      REAL OZONE_CS        ! interpolated ozone absorption cross section
      REAL YTT             ! interpolation variable

!***Find temperature range:

      IF ( STRAT_TEMP .LE. TEMP_O3_STRAT( 1 ) ) IXTEMP = 0

      DO IXT = 1, NTEMP_STRAT - 1
         IF ( STRAT_TEMP .GT. TEMP_O3_STRAT( IXT ) .AND.
     &        STRAT_TEMP .LT. TEMP_O3_STRAT( IXT + 1 ) ) THEN
            IXTEMP = IXT
            YTT = ( STRAT_TEMP - TEMP_O3_STRAT( IXT ) )
     &          / ( TEMP_O3_STRAT( IXT + 1 ) - TEMP_O3_STRAT( IXT ) )
         END IF
      END DO

      IF ( STRAT_TEMP .GE. TEMP_O3_STRAT( NTEMP_STRAT ) ) THEN
         IXTEMP = NTEMP_STRAT
         YTT = 0.0
      END IF

!***do linear interpolation

      IF ( IXTEMP .EQ. 0 ) THEN
         OZONE_CS = XO3CS( 1, IWL )
      ELSE IF ( IXTEMP .GE. 1 .AND. IXTEMP .LT. NTEMP_STRAT ) THEN
         OZONE_CS = XO3CS( IXTEMP, IWL ) +
     &            ( XO3CS( IXTEMP+1, IWL ) - XO3CS( IXTEMP, IWL ) ) * YTT
      ELSE IF ( IXTEMP .EQ. NTEMP_STRAT ) THEN
         OZONE_CS = XO3CS( IXTEMP, IWL )
      END IF

      TAU_O3 = DU_TO_CONC * STOZONE * OZONE_CS

      RETURN
      END SUBROUTINE GET_TAUO3

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE O3AMT ( XLAT, XLONG, MDAY, OZONE )
C-----------------------------------------------------------------------
C  This subroutine implements an algorithm for the annual behavior
C     of total ozone ( taken here to be stratospheric) from
C     climatology
C  Reference:
C     Van Heuklon, Thomas K., Estimating atmospheric ozone for solar
C     radiation models, Solar Energy, Vol. 22, pp 63-68, 1979.
C  updated from an earlier version by
C     Dr. Francis S. Binkowski, The Carolina Environmental Program,
C     The University of North Carolina at Chapel Hill.
C     Email: frank_binkowski@unc.edu
C     November 03. 2004.
C  Only Northern Hemisphere is implemented.
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: MDAY  ! Day number during the year
                                      ! Jan 1st = 1.0, Feb 1st = 32, etc.

      REAL,    INTENT( IN )  :: XLAT  ! latitude of point on earth's surface
      REAL,    INTENT( IN )  :: XLONG ! longitude of point on earth's surface
      REAL,    INTENT( OUT ) :: OZONE ! Total column amount of ozone [ DU ]

!***Internal:

!***The following parameters are from Table 1 of Van Heuklon (1979).

      REAL, SAVE ::  A, B, C, D, F, G, H, FJ
      DATA A/150.0/, B/1.28/, C/40.0/, D/0.9865/, F/-30.0/, G/20.0/,
     &     H/3.0/, FJ/235.0/

!***FSB FJ is the equatorial annual average of atmospheric ozone
!***  content, as noted on page 65 of Nav Heulklon (1979). This value
!***  sets the basic background for ozone.

      REAL, PARAMETER :: RD = 0.017453   ! degrees to radians

!***Variables of convenience

      REAL E, FI, BPHI, DEF, HLI, SINB, SINB2

!***set the day

      E = FLOAT( MDAY )
      FI = 20.0
      IF ( XLONG .LT. 0.0 ) FI = 0.0
      BPHI  = B * XLAT * RD
      DEF   = D * ( E + F ) * RD
      HLI   = H * ( XLONG + FI ) * RD
      SINB  = SIN( BPHI )
      SINB2 = SINB * SINB

!***the following equation implements equation (4) of VanHeuklon (1979)

      OZONE  = FJ + ( A + C * SIN( DEF ) + G * SIN( HLI ) ) * SINB2

      RETURN
      END SUBROUTINE O3AMT

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE SLANTPATH2 ( NLAYS, Z, ZSFC, REARTH, SINZEN, DZ, DSDH )
C-----------------------------------------------------------------------
C  PURPOSE:
C     Calculate slant path, ds/dh, over vertical depth in spherical
C     geometry also calculates the layer thicknesses.
C     NOTE!!!
C     This version is restricted to zenith angle less than 90 degrees
C-----------------------------------------------------------------------
C  ARGUMENTS:
C     INPUT:
C       NLAYS   - INTEGER, number of specified altitude levels
C       z       - REAL, altitude (agl) [m] <<<    meters
C       This is from file ZF ( full layers ) from METCRO3D
C       Z(1) is zero.
C       zsfc    - REAL, ground elevation (msl) [m]
C       rearth  - REAL, radius of the earth [m]
C       sinzen  - REAL, sine of solar zenith angle
C
C     OUTPUT:
C       dz      - REAL, layer thicknesses [ m ]
C       dsdh    - REAL, slant path of direct beam through each layer
C       when travelling from the top of the atmosphere downward
C-----------------------------------------------------------------------
C  EDIT HISTORY:
C     Inspired by sphers from TUV
C     09/08/2004 modified to specialize for CMAQ application
C     by Dr. Francis S. Binkowski
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
C
C-----------------------------------------------------------------------
C  REFERENCE:
C     Dahlback, A. and K. Stamnes, A new spherical model for computing
C     the radiation field available for photolysis and heating at
C     twilight, Planetary and Space Sciences, Vol. 39, No. 5,
C     pp 671-683, 1991.
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      INTEGER, INTENT( IN )  :: NLAYS

      REAL,    INTENT( IN )  :: Z   ( : )
      REAL,    INTENT( IN )  :: ZSFC
      REAL,    INTENT( IN )  :: REARTH
      REAL,    INTENT( IN )  :: SINZEN
      REAL,    INTENT( OUT ) :: DZ  ( : )  ! layer thicknesses counting from surface upward
      REAL,    INTENT( OUT ) :: DSDH( : )

!***Internal

      INTEGER I, J, K           ! loop indices
      REAL RE
      REAL DSJ                  ! slant path length [m]
      REAL DHJ                  ! layer thickness [m]
      REAL( 8 ) :: RJ, RJP1
      REAL( 8 ) :: RPSINZ            ! rpsinz = (re + zd(i)) * sinzen
      REAL( 8 ) :: RPSINZ2           ! rpsinz * rpsinz
      REAL( 8 ) :: GA, GB            ! see usage
      REAL      :: ZE( NLAYS + 1 )   ! altitudes MSL
      REAL      :: ZD( NLAYS + 1 )   ! array of altitudes indexed from top
      REAL      :: DZI( NLAYS )      ! layer thicknesses counting downward from the top

C-----------------------------------------------------------------------

!***re include the altitude above sea level to the radius of the earth

      RE = REARTH + ZSFC

!***ze is the altitude above msl

      DO K = 1, NLAYS + 1
         ZE( K ) = Z( K )
!!sjr    ZE(K) = Z(K) - ZSFC
      END DO

!***  DZ(1) = ZE(2) - ZE(1)
!***  DZI(1) = ZE(NLAYS + 1) - ZE(NLAYS)

!***calculate dz

      DO K = 1, NLAYS
         DZ( K ) = ZE( K + 1 ) - ZE( K )
      END DO

!***zd, dzi are inverse coordinates of ze & dz

      DO K = 1, NLAYS + 1
         J = NLAYS + 1 - K + 1
         ZD( J ) = ZE( K )
      END DO

      DO K = 1, NLAYS
         J = NLAYS + 1 - K
         DZI( J ) = DZ( K )
      END DO

!***initialize dsdh

      DO I = 1, NLAYS
         DSDH( I ) = 0.0
      END DO

!***FSB The following code is a direct implementation of appendix B
!***  of Dahlbeck and Stamnes (1991) for the case of solar zenith
!***  angle less than 90 degree.

!***calculate ds/dh of every layer starting at the top

      DO J = 1, NLAYS
!***  K = NLAYS - J +1
         RPSINZ  = REAL( ( RE + ZD( J ) ) * SINZEN , 8 )
         RPSINZ2 = RPSINZ * RPSINZ

         IF ( J .LT. NLAYS ) THEN
            RJ   = REAL( RE + ZD( J ), 8 )
            RJP1 = REAL( RE + ZD( J + 1 ), 8 )
            DHJ  = DZI( J )
         ELSE
            RJ   = REAL( RE + ZD( J ), 8)
            RJP1 = REAL( RE, 8 )
            DHJ  = DZI( J )
         END IF

!***define GA and GB

         GB = SQRT( MAX( 0.0D0, RJ * RJ     - RPSINZ2 ) )
         GA = SQRT( MAX( 0.0D0, RJP1 * RJP1 - RPSINZ2 ) )

!***This is equation B1 from Dahlbeck and Stamnes (1991)

         DSJ = ABS( REAL(GB - GA, 4 ) )

!***this is the slant path (Chapman) function.

         DSDH( J ) = DSJ / DHJ    ! Note dsdh is on a top to bottom grid.

      END DO   ! loop over altitude

      RETURN
      END SUBROUTINE SLANTPATH2

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE SLANTPATHTOP ( ZTOM, ZTOA, ZSFC, REARTH, SINZEN,
     &                          DSDHTOP )
C-----------------------------------------------------------------------
C  FSB This is a SPECIAL version to get the slant path from the top of
C    the modeling domain (ztom) to the top of the atmosphere (ztoa).
C-----------------------------------------------------------------------
C  PURPOSE:
C     Calculate slant path, ds/dh, over vertical depth in spherical
C     geometry also calculates the layer thicknesses.
C     NOTE!!!
C     This version is restricted to zenith angle less than 90 degrees
C-----------------------------------------------------------------------
C  ARGUMENTS:
C     INPUT:
C       ztom    - REAL, altitude (agl) of top of modeling domain [m] <<<meters
C       This is from file ZF ( full layers ) from METCRO3D
C       Z(1) is zero.
C       ztoa    - REAL altitude (msl) of top of atmosphere [ m ]
C       zsfc    - REAL, ground elevation (msl) [m]
C       rearth  - REAL, radius of the earth [m]
C       sinzen  - REAL, sine of solar zenith angle
C
C     OUTPUT:
C       dsdhtop   - REAL, slant path of direct beam through each layer
C       when travelling from the top of the atmosphere downward
C       to the top of top model
C-----------------------------------------------------------------------
C  EDIT HISTORY:
C     Inspired by sphers from TUV
C     09/08/2004 modified  to specialize for CMAQ application
C     11/11/2004 modified to do just the one layer from ztom to ztoa.
C     by Dr. Francis S. Binkowski
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
C
C-----------------------------------------------------------------------
C  REFERENCE:
C     Dahlback, A. and K. Stamnes, A new spherical model for computing
C     the radiation field available for photolysis and heating at
C     twilight, Planetary and Space Sciences, Vol. 39, No. 5,
C     pp 671-683, 1991.
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***arguments

      REAL, INTENT(IN)  :: ZTOM
      REAL, INTENT(IN)  :: ZTOA
      REAL, INTENT(IN)  :: ZSFC
      REAL, INTENT(IN)  :: REARTH
      REAL, INTENT(IN)  :: SINZEN
      REAL, INTENT(OUT) :: DSDHTOP

!***Internal

      INTEGER :: I, J, K  ! loop indices
      REAL    :: RE
      REAL    :: DSJ      ! slant path length [m]
      REAL    :: DHJ      ! layer thickness [m]
      REAL(8) :: RJ, RJP1
      REAL(8) :: RPSINZ   ! rpsinz = (re + zd(i)) * sinzen
      REAL(8) :: RPSINZ2  ! rpsinz * rpsinz
      REAL(8) :: GA, GB   ! see usage

C-----------------------------------------------------------------------

!***re include the altitude above sea level to the radius of the earth

      RE = REARTH + ZSFC

!!sjr DHJ = ZTOA - ZTOM
      DHJ = ZTOA - ( ZTOM + ZSFC )

!***FSB The following code is a direct implementation of appendix B
!***  of Dahlbeck and Stamnes (1991) for the case of solar zenith
!***  angle less than 90 degree.

!***  calculate ds/dh of every layer starting at the top

      RPSINZ  = REAL( ( REARTH + ZTOA ) * SINZEN, 8 )
      RPSINZ2 = RPSINZ * RPSINZ

!!sjr RJ = RE + ZTOA
      RJ   = REAL( REARTH + ZTOA, 8 )
      RJP1 = REAL( RE + ZTOM, 8 )

!***define GA and GB

      GB = SQRT( MAX( 0.0D0, RJ * RJ     - RPSINZ2 ) )
      GA = SQRT( MAX( 0.0D0, RJP1 * RJP1 - RPSINZ2 ) )

!***This is equation B1 from Dahlbeck and Stamnes (1991)

      DSJ = REAL( GB - GA, 4 )

!***this is the slant path (Chapman) function.

      DSDHTOP = DSJ / DHJ

      RETURN
      END SUBROUTINE SLANTPATHTOP

C///////////////////////////////////////////////////////////////////////

      SUBROUTINE TWOSTREAM_S ( NLEVEL, MU, RSFC, TAUU, OMU, GU, DSDH,
     &                         FDR, FUP, FDN, EDR, EUP, EDN )
C-----------------------------------------------------------------------
C  PURPOSE:
C     Solve two-stream equations for multiple layers.  The subroutine is
C     based on equations from:  Toon et al., 1989.
C     It contains only the Delta Eddington method.
C     A pseudo-spherical correction has also been added.
C     FSB This version is restricted to solar zenith angle LESS THAN 90
C     degrees
C-----------------------------------------------------------------------
C  ARGUMENTS:
C     INPUT:
C       nlevel - INTEGER, number of specified altitude levels in the
C                working grid
C       mu     - REAL, cosine of solar senith angle
C       rsfc   - REAL, surface albedo at current wavelength
C       tauu   - REAL, unscaled optical depth of each layer
C       omu    - REAL, unscaled single scattering albedo of each layer
C       gu     - REAL, unscaled asymmetry parameter of each layer
C       dsdh   - REAL, slant path of direct beam through each layer
C                crossed when travelling from the top of the atmosphere
C                to layer
C     OUTPUT:
C       fdr - REAL, contribution of the direct component to the total
C             actinic flux at each altitude level
C       fup - REAL, contribution of the diffuse upwelling component to
C             the total actinic flux at each altitude level
C       fdn - REAL, contribution of the diffuse downwelling component to
C             the total actinic flux at each altitude level
C       edr - REAL, contribution of the direct component to the total
C             spectral irradiance at each altitude level
C       eup - REAL, contribution of the diffuse upwelling component to
C             the total spectral irradiance at each altitude level
C       edn - REAL, contribution of the diffuse downwelling component to
C             the total spectral irradiance at each altitude level
C-----------------------------------------------------------------------
C  EDIT HISTORY:
C     This is a modification of ps2str.f from TUV
C     this routine has been modified from the original TUV code by
C     Dr. Francis S. Binkowski, Carolina Environmental Program
C     09/2004 removed various two-stream methods (FSB)
C     09/2004 made mu an input (FSB)
C     09/2004 simplified for case of solar zenith angle less than
C             90 degrees
C-----------------------------------------------------------------------
C  References:
C
C     Joseph, J.H., W.J. Wiscombe, and J.A. Weinman, The delta-Eddington
C     Approximation for radiative flux transfer, Jour. Atmos. Res.,
C     Vol.33, No. 12, pages 2452 - 2459, December , 1976.
C     (the method implemented here)
C
C     Toon, O.B., C.P. McKay, T.P. Ackerman, and K. Santhanam, Rapid
C     calculation of radiative heating rates and photodissociation rates
C     in inhomogeneous multiple scattering atmospheres, J. Geophys. Res.
C     Vol. 94, No. D13, Pages 16,287 - 16,301, November 20, 1989.
C     (all citations for equation numbers and page numbers are to this
C     reference)
C
C     Zeng, J., S. Madronich, and K. Stamnes, A note on the use of the
C     two-stream delta-scaling approximation for calculating atmospheric
C     photolysis rate coefficients, Journal of Geophysical Research,
C     vol 101, D9, pp 14,525 - 14530, June 20, 1996.
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, PARAMETER :: KZ = 100
      INTEGER, PARAMETER :: NROWS = 2 * KZ

!***arguments

      INTEGER, INTENT( IN ) :: NLEVEL

      REAL,    INTENT(IN )  :: MU
      REAL,    INTENT(IN )  :: RSFC
      REAL,    INTENT(IN )  :: TAUU( : )
      REAL,    INTENT(IN )  :: OMU ( : )
      REAL,    INTENT(IN )  :: GU  ( : )
      REAL,    INTENT(IN )  :: DSDH( : )
      REAL,    INTENT(OUT ) :: FUP ( : )
      REAL,    INTENT(OUT ) :: FDN ( : )
      REAL,    INTENT(OUT ) :: FDR ( : )
      REAL,    INTENT(OUT ) :: EUP ( : )
      REAL,    INTENT(OUT ) :: EDN ( : )
      REAL,    INTENT(OUT ) :: EDR ( : )

!***local:

      REAL( 8 ) :: TAUC  ( 0:KZ )        ! optical depth variable
      REAL( 8 ) :: TAUSLA( 0:KZ )        ! slant path optical depth
      REAL( 8 ) :: MU2   ( 0:KZ )        ! replaces mu1 for slant path

!***internal coefficients and matrix

      REAL( 8 ) :: LAM( KZ ), TAUN( KZ ), BGAM( KZ )
      REAL( 8 ) :: E1( KZ ), E2( KZ ), E3( KZ ), E4( KZ )
      REAL( 8 ) :: CUP( KZ ), CDN( KZ ), CUPTN( KZ ), CDNTN( KZ )
      REAL( 8 ) :: A( NROWS ), B( NROWS ), D( NROWS ), E( NROWS ), Y( NROWS )

!***other:

      REAL( 8 ) :: GI( KZ ), OMI( KZ ), TEMPG
      REAL( 8 ) :: PIFS, FDN0
      REAL( 8 ) :: F, G, OM
      REAL( 8 ) :: GAM1, GAM2, GAM3, GAM4

      REAL( 8 ) :: EXPON0, EXPON1
      REAL( 8 ) :: EXPON, DIVISR, TEMP, UP, DN
      REAL( 8 ) :: SSFC

      REAL( 8 ) :: MU1  ! reciprocal of constant from delta_Eddington method

      INTEGER   :: ROW
      INTEGER   :: I, J
      INTEGER   :: NLAYER, MROWS, LEV

!***Some additional program constants:

!!!!from above      REAL, PARAMETER :: PI          = 3.1415926535898  ! pi
      REAL( 8 ), PARAMETER :: LARGEST     = 1.0D+36 ! largest machine number
      REAL( 8 ), PARAMETER :: SMALLEST    = 1.0D-36 ! smallest machine number
      REAL( 8 ), PARAMETER :: SQRTLRGST   = 1.0D+18 ! sqrt(largest)
      REAL( 8 ), PARAMETER :: SQRTLRGSTM1 = 1.0D-18 ! 1/sqrt(largest)
      REAL( 8 ), PARAMETER :: EPS         = 1.0D-03
      REAL( 8 ), PARAMETER :: PRECIS      = ( 1.0D0 - 1.0D-07 )

      REAL( 8 ), PARAMETER :: LOG_DBLE_SMALLEST = -709.090848126508D0
      REAL( 8 ), PARAMETER :: LOG_DBLE_LARGEST  =  709.090848126508D0

C-----------------------------------------------------------------------

!***boundary conditions:

      PIFS = 1.0D0                ! solar flux is set to unity here.
      FDN0 = 0.0D0                ! no downward diffuse flux

      NLAYER = NLEVEL - 1

      DO J = 0, KZ
         TAUC  ( J ) = 0.0D0
         TAUSLA( J ) = 0.0D0
         MU2   ( J ) = SQRTLRGST
      END DO

!***scaling for delta-Eddington approximation

!***start diagnostic prinout

      DO I = 1, NLAYER
      
!         print*,'ACM TWSTREAM GU, F = ', F, GU(I)
         F = REAL( GU(I) * GU(I), 8 )
         GI  (I) = ( REAL( GU(I), 8 ) - F ) / ( 1.0D0 - F )
         OMI (I) = ( 1.0D0 - F ) * REAL( OMU(I), 8 ) 
     &           / ( 1.0D0 - REAL( OMU(I), 8 ) * F )
         TAUN(I) = ( 1.0D0 - REAL( OMU(I), 8 ) * F ) 
     *           *  REAL( TAUU(I), 8)
      END DO

!***set  tausla to be slant optical path contribution for each layer.

      DO I = 1, NLAYER
         TAUSLA(I) = TAUN(I) * REAL( DSDH(I), 8 )
      END DO

      TAUC(1)   = TAUN(1)

      DO I = 1, NLAYER
         TAUN(I)   = TAUN(I)
         TAUSLA(I) = TAUSLA(I-1) + TAUSLA(I) ! NOTE redefinition of tausla
                                             ! to be a sum over altitude.
         TAUC(I)   = TAUC(I-1) + TAUN(I)

!***FSB calculate MU2(i). This is the substitute for mu ( = 1/ coszen) for the
!***  pseudo spherical approximation. It is ther ratio of vertical optical
!***  depth to the slant optical depth.
!***  This has been simplified from TUV ps2str because only
!***  zenith angles < or = 90 degrees are considered.

!         IF ( TAUSLA(I) .EQ. TAUSLA(I-1) ) THEN
!            MU2(I) = SQRTLRGST
!         ELSE
!            MU2(I) = (TAUC(I) - TAUC(I-1)) / (TAUSLA(I) - TAUSLA(I-1))
!            MU2(I) = SIGN( MAX( ABS( MU2(I)), SQRTLRGSTM1 ), MU2(I) )
!         END IF
!         MU2(I) = 1.0D0 / MU2(I)
!      END DO

         IF ( TAUSLA(I) .EQ. TAUSLA(I-1) ) THEN
            MU2(I) = SQRTLRGSTM1
         ELSE
            MU2(I) =  (TAUSLA(I) - TAUSLA(I-1)) / (TAUC(I) - TAUC(I-1)) 
            MU2(I) = SIGN( MIN( ABS( MU2(I)), SQRTLRGST ), MU2(I) )
         END IF
      END DO

!***compute coefficients for each layer:
!***  gam1 - gam4 = 2-stream coefficients
!***  expon0 = calculation of e when tau is zero
!***  expon1 = calculation of e when tau is taun
!***  cup and cdn = calculation when tau is zero
!***  cuptn and cdntn = calc. when tau is taun
!***  divisr = prevents division by zero

      DO 11, I = 1, NLAYER

         G = GI(I)
         OM = OMI(I)
!***stay away from 1 by precision.  For g, also stay away from -1

!        TEMPG = MIN( ABS( G ), 1.0D0 - PRECIS )
         TEMPG = MIN( ABS( G ), PRECIS )
         G = SIGN( TEMPG, G )
!        OM = MIN( OM, 1.0D0 - PRECIS )
         OM = MIN( OM, PRECIS )

!***calculate the gamma values from line 1 Table 1, page 16,289

         GAM1 =  ( 7.0D0 - OM * ( 4.0D0 + 3.0D0 * G ) ) * 0.25D0
         GAM2 = -( 1.0D0 - OM * ( 4.0D0 - 3.0D0 * G ) ) * 0.25D0
         GAM3 =  ( 2.0D0 - 3.0D0 * G * REAL( MU, 8 )  ) * 0.25D0
         GAM4 =  1.0D0 - GAM3
         MU1  =  2.0D0

!***lambda = pg 16,290 equation 21
!***big gamma = pg 16,290 equation 22

         IF ( ABS( GAM2 ) .LE. SMALLEST ) THEN
            WRITE( LOGDEV, 2609) I, GI(I), OMI(I), G, OM, GAM1, GAM2
            WRITE( LOGDEV, 2610)
         END IF

         IF ( ( GAM1*GAM1 - GAM2*GAM2 ) .LT. 0.0D0 ) THEN
            WRITE( LOGDEV, 2609) I, GI(I), OMI(I), G, OM, GAM1, GAM2
            WRITE( LOGDEV, 2611)
         END IF
 
     
         LAM(I) = SQRT( GAM1*GAM1 - GAM2*GAM2 )

         IF ( ABS( GAM2 ) .LE. SMALLEST ) THEN 
!***adjustment based on NCAR TUV model
            BGAM(I) = 0.0D0
         ELSE
            BGAM(I) = ( GAM1 - LAM(I) ) / GAM2
         END IF

         EXPON = EXP( MAX( LOG_DBLE_SMALLEST, -LAM(I) * TAUN(I) ) ) 

!***e1 - e4 = pg 16,292 equation 44

         E1(I) = 1.0D0 + BGAM(I) * EXPON
         E2(I) = 1.0D0 - BGAM(I) * EXPON
         E3(I) = BGAM(I) + EXPON
         E4(I) = BGAM(I) - EXPON

!***the following sets up for the C equations 23, and 24
!***  found on page 16,290
!***  prevent division by zero (if LAMBDA = 1 / MU,
!***  shift 1/MU^2 by  EPS = 1.E-3
!***  which is approx equiv to shifting MU by 0.5*EPS* (MU)**3

         DIVISR = LAM(I) * LAM(I) - MU2(I) * MU2(I)
         TEMP = MAX( EPS, ABS( DIVISR ) )
         DIVISR = SIGN( TEMP , DIVISR )
         UP = OM * PIFS *
     &        ( ( GAM1 - MU2(I) ) * GAM3 + GAM4 * GAM2 ) / DIVISR


         DN = OM * PIFS *
     &        ( ( GAM1 + MU2(I) ) * GAM4 + GAM2 * GAM3 ) / DIVISR

!***cup and cdn are when tau is equal to zero
!***cuptn and cdntn are when tau is equal to taun

         EXPON0 = EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(I-1) ) )
         EXPON1 = EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(I) ) )

         CUP(I)   = UP * EXPON0
         CDN(I)   = DN * EXPON0
         CUPTN(I) = UP * EXPON1
         CDNTN(I) = DN * EXPON1

 11   CONTINUE                  ! loop on layer

!***set up matrix
!*** ssfc = pg 16,292 equation 37  where pi Fs is one (unity).
      SSFC   = REAL( RSFC * MU, 8 ) * PIFS
     &       * EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA( NLAYER ) ) ) 

!***MROWS = the number of rows in the matrix

      MROWS = 2 * ( NLAYER )

!*** the following are from pg 16,292  equations 39 - 43.
!*** set up first row of matrix:

      I = 1
      A(1) = 0.0D0
      B(1) = E1(I)
      D(1) = -E2(I)
      E(1) = FDN0 - CDN(I)

      ROW = 1

!***set up odd rows 3 thru (MROWS - 1):

      I = 0
      DO 20, ROW = 3, MROWS - 1, 2
         I = I + 1
         A(ROW) = E2(I) * E3(I) - E4(I) * E1(I)
         B(ROW) = E1(I) * E1(I + 1) - E3(I) * E3(I + 1)
         D(ROW) = E3(I) * E4(I + 1) - E1(I) * E2(I + 1)
         E(ROW) = E3(I) * ( CUP(I + 1) - CUPTN(I) ) +
     &            E1(I) * ( CDNTN(I) - CDN(I + 1) )
 20   CONTINUE

!***set up even rows 2 thru (MROWS - 2):

      I = 0
      DO 30, ROW = 2, MROWS - 2, 2
         I = I + 1
         A(ROW) = E2(I + 1) * E1(I) - E3(I) * E4(I + 1)
         B(ROW) = E2(I) * E2(I + 1) - E4(I) * E4(I + 1)
         D(ROW) = E1(I + 1) * E4(I + 1) - E2(I + 1) * E3(I + 1)
         E(ROW) = ( CUP(I + 1) - CUPTN(I) ) * E2(I + 1) -
     &            ( CDN(I + 1) - CDNTN(I) ) * E4(I + 1)
 30   CONTINUE

!***set up last row of matrix at MROWS:

      ROW = MROWS
      I = NLAYER
      F = REAL( RSFC, 8 )
      A(ROW) = E1(I) - F * E3(I)
      B(ROW) = E2(I) - F * E4(I)
      D(ROW) = 0.0D0
      E(ROW) = SSFC - CUPTN(I) + F * CDNTN(I)

!***solve tri-diagonal matrix:
      CALL TRIDIAGONAL ( A, B, D, E, Y, MROWS )

!*** unfold solution of matrix, compute output fluxes:

      ROW = 1
      LEV = 1
      J = 1

!***the following equations are from pg 16,291  equations 31 & 32

      FDR(LEV) = 1.0    ! this the downward flux at the top of the model
      EDR(LEV) = MU * REAL( FDR(LEV) )
      EDN(LEV) = REAL( FDN0 )
      EUP(LEV) = REAL( Y(ROW) * E3(J) - Y(ROW + 1) * E4(J) + CUP(J) )
      FDN(LEV) = EDN(LEV) * REAL( MU1 )
      FUP(LEV) = EUP(LEV) * REAL( MU1 )

      DO 60, LEV = 2, NLAYER + 1
         FDR(LEV) = REAL( EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(LEV-1) )  ) )
!         FDR(LEV) = REAL( EXPONS(LEV-1) ) ! REAL( EXP( MAX( LOG_DBLE_SMALLEST, -TAUSLA(LEV-1) )  ) )
         EDR(LEV) = MU * FDR(LEV)
         EDN(LEV) = REAL( Y(ROW) * E3(J) + Y(ROW + 1) * E4(J) + CDNTN(J) )
         EUP(LEV) = REAL( Y(ROW) * E1(J) + Y(ROW + 1) * E2(J) + CUPTN(J) )
         FDN(LEV) = EDN(LEV) * REAL( MU1 )
         FUP(LEV) = EUP(LEV) * REAL( MU1 )

         ROW = ROW + 2
         J = J + 1
 60   CONTINUE

2609  FORMAT(/ 'PHOT_MOD: Instability in Two Stream RadTran Subroutine'
     &       / 'Layer: I = ', I3
     &       / 'Asymmetry Factor: GI = ', ES12.4
     &       / 'Single Scattering Albedo: OMI = ', ES12.4
     &       / 'SIGN( MIN( ABS( GI ), 1.0 - 1.0E-7), GI ): G = ', ES12.4
     &       / 'MIN( OMI, 1.0 - 1.0E-7 ): OM = ', ES12.4
     &       / '0.25*( 7.0 - OM * ( 4.0 + 3.0 * G ) ): GAM1 = ', ES12.4
     &       / '0.25*( OM * ( 4.0 + 3.0 * G ) - 1.0 ): GAM2 = ', ES12.4  /)

2610  FORMAT(/ 'Setting (GAM1 - SQRT(GAM1**2 - GAM2**2))/GAM2 to zero' /)

2611  FORMAT(/ ' ( GAM1**2 - GAM2**2 ) < 0: NaNs introduced into solution ' /)

      RETURN
      END SUBROUTINE TWOSTREAM_S


      SUBROUTINE TRIDIAGONAL ( A, B, D, E, Y, N )
C-----------------------------------------------------------------------
C  This version has the same variable names as in twostream_s, that
C  is D is the superdiagonal and E is the right hand side, and Y is
C  the  solution. The size of A,B,D,E and Y is now N, the
C  number of rows in the matrix.
C-----------------------------------------------------------------------
C
C  Function:
C     Solves tridiagonal system by Thomas algorithm.  Algorithm fails
C     if first pivot is zero.  In that case, rewrite the
C     equation as a set of order N-1, with U(2) trivially eliminated.
C     The associated tri-diagonal system is stored in 3 arrays
C     B: diagonal
C     A: sub-diagonal
C     D: super-diagonal
C     E: right hand side function
C     U : return solution from tridiagonal solver
C
C     [ B(1) D(1) 0    0    0 ...       0     ]
C     [ A(2) B(2) D(2) 0    0 ...       .     ]
C     [ 0    A(3) B(3) D(3) 0 ...       .     ]
C     [ .       .     .     .           .     ] Y(i) = E(i)
C     [ .             .     .     .     0     ]
C     [ .                   .     .     .     ]
C     [ 0                           A(N) B(N) ]
C
C  Preconditions:
C
C  Subroutines and Functions Called:
C
C  Revision History:
C     NO.   DATE     WHO      WHAT
C     __    ____     ___      ____
C     5     11/09/04  FSB  Changed symbols to match twostream_s
C                          made arrays variable.
C     4     4/3/96    SJR  copied code and modified for use in JPROC
C     3     8/16/94   XKX  configuration management include statements
C     2     3/15/92   CJC  For use in Models-3 LCM.
C     1     10/19/89  JKV  converted for use on IBM
C     0      3/89     BDX  Initial version
C     yoj
C-----------------------------------------------------------------------

      IMPLICIT NONE

!***Arguments:

      INTEGER,   INTENT( IN )  :: N        ! number of rows in matrix
      REAL( 8 ), INTENT( IN )  :: A( : )   ! subdiagonal
      REAL( 8 ), INTENT( IN )  :: B( : )   ! diagonal
      REAL( 8 ), INTENT( IN )  :: D( : )   ! superdiagonal
      REAL( 8 ), INTENT( IN )  :: E( : )   ! R.H. side
      REAL( 8 ), INTENT( OUT ) :: Y( : )   ! solution

!***Local Variables:

      INTEGER J   ! loop index

      REAL( 8 ) :: BET        !
      REAL( 8 ) :: GAM( N )   !

!***Decomposition and forward substitution:

      BET = 1.0D0 / B( 1 )
      Y( 1 ) = BET * E( 1 )

      DO J = 2, N
         GAM( J ) = BET * D( J - 1 )
         BET = 1.0D0 / ( B( J ) - A( J ) * GAM( J ) )
         Y( J ) = BET * ( E( J ) - A( J ) * Y( J - 1) )
      END DO

!***Back-substitution:

      DO J = N - 1, 1, -1
         Y( J ) = Y( J ) - GAM( J + 1 ) * Y( J + 1 )
      END DO

      RETURN

      END SUBROUTINE TRIDIAGONAL

C///////////////////////////////////////////////////////////////////////

      INTEGER FUNCTION INDEXR0 ( NAME1, N, NAME2 )
C-----------------------------------------------------------------------
C
C  Function:
C     This routine searches for NAME1 in list NAME2
C
C  Revision History:
C     5/88   Modified for ROMNET
C     July 29, 2005 by FSB
C     Changed name to avoid conflict FSB
C     copied from CMAQ routine INDEX2 to allow internal use
C
C  Argument List Description:
C
C  Input Arguments:
C     NAME1       Character string being searched for
C     N           Length of array to be searched
C     NAME2       Character array to be searched
C
C  Output Arguments:
C     INDEX1      The position within the NAME2 array that NAME1
C                 found. If string was not found, INDEX1 = 0
C
C  Local Variable Description:
C     None
C
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, INTENT(IN) :: N

      CHARACTER*(*), INTENT(IN) :: NAME1
      CHARACTER*(*), INTENT(IN) :: NAME2(*)

      INTEGER I

!***Assume NAME1 is not in list NAME2

      INDEXR0 = 0

      DO I = 1, N
         IF ( INDEX( NAME2( I ), NAME1 ) .EQ. 1 ) THEN
            INDEXR0 = I
            RETURN
         END IF
      END DO

      RETURN
      END FUNCTION INDEXR0

      END MODULE PHOT_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE PA_REPORT

C-----------------------------------------------------------------------
C Function: To provide an output listing that symbolically represents
C           the operations to be performed in Process Analysis 
 
C Preconditions: None
  
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified Jun, 1998 by Jerry Gipson to change name of output report
C  Modified May 2002 by Jerry Gipson to add comma in format statements
C  Aug 2011 Jeff Young: Replaced I/O API include files with IOAPI`s M3UTILIO
C  Sep 2018 C. Nolte, S. Roselle: replace M3UTILIO with UTILIO_DEFN
C-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE PA_GLOBAL     ! Mech data used 
      USE PA_VARS
      USE PA_IPRVARS
      USE PA_DEFN, Only: LFULLIRR, LPARTIRR, N_IPR_SPC, IRRNAME
      USE PA_PARSE

      IMPLICIT NONE
      
C Includes: None
C Arguments: None
C Parameters:
      CHARACTER( 20 ), PARAMETER :: PACM_REPORT = 'PACM_REPORT'  
      CHARACTER( 16 ), PARAMETER :: PNAME = 'PA_REPORT'  

C External Functions: None

C Local Variables
      CHARACTER(  1 ) :: C = 'c'   ! Lowercase c
      CHARACTER(  3 ) :: LABL      ! Output reaction label or term number
      CHARACTER(  3 ) :: OUTLBL    ! Output label number
      CHARACTER(  4 ) :: OPNAM     ! Operator variable name
      CHARACTER(  4 ) :: TYPE      ! Operator type
      CHARACTER(  7 ) :: PNFLG     ! Pos or Neg only flag
      CHARACTER( 11 ) :: COUT      ! Output coefficient
      CHARACTER( 80 ) :: CEES      ! Line of asterisks
      CHARACTER( 80 ) :: LINOUT    ! line of output
      CHARACTER(  5 ) :: TZ        ! Time zone label
      CHARACTER( 24 ) :: TIMNDAT   ! Wall clock time and date

      CHARACTER( 50 ) :: STRING( 20 )             ! Strings to concatenate
      CHARACTER( LABLEN ) :: RJLABL( MXRXNS ) ! Right justified reaction label
      CHARACTER(  4 ) ::  SAVOP( MAXTERMS )        ! Operator name
      CHARACTER(  3 ) ::  SAVLBL( MAXTERMS )       ! Operator label

      INTEGER E1, E2, E3 ! Ending character positions
      INTEGER EQPOS1     ! Position of equal sign plus 1
      INTEGER ICOUNT     ! Counter of no. of output terms
      INTEGER IE1, IE2   ! Pointer to ending positions in a string
      INTEGER IEND       ! Pointer to end of output line 
      INTEGER INDX       ! Pointer to reaction number
      INTEGER IOUT       ! Unit number for output report   
      INTEGER IS1, IS2   ! Pointer to startinging positions in a string
      INTEGER LEN1       ! Length of a string
      INTEGER :: LINLEN = 80  ! Length of output line
      INTEGER MAXLEN     ! Length of longest reaction label
      INTEGER N          ! Loop index for specis and defined names
      INTEGER NCYC       ! Loop index for number of cycles
      INTEGER NNETR      ! No. of net reaction operators in OUTPUT request
      INTEGER NNLOS      ! No. of net loss operators in OUTPUT request
      INTEGER NLN        ! Loop index for no. of mech lines
      INTEGER NLOSS      ! No. of loss operators in OUTPUT request
      INTEGER NFAM       ! Loop index for number of familys
      INTEGER NNPRD      ! No. of net production operators in OUTPUT request
      INTEGER NOUT       ! Loop index for number of output requests
      INTEGER NIPR       ! Loop index for IPR species
      INTEGER NPROD      ! No. of net production operators in OUTPUT request
      INTEGER NRX        ! Loop index for number of reactions
      INTEGER NR         ! Total number of reactions in operator
      INTEGER NTERM      ! Loop index for number of terms in output request
      INTEGER NUMSTRNGS  ! Number of strings to concatenate
      INTEGER SPOS       ! Starting position of right justified label
      INTEGER IDATE      ! Wall-clock date
      INTEGER ITIME      ! Wall clock time

      INTEGER RXNUMS( MXRXNS )  ! Rx nos. of reactions in operator term

      LOGICAL LFIRST     ! Flag for first time throuhh a loop
      LOGICAL LINITFLG   ! Flag to indicate initialization present

      LOGICAL LRDONLY    ! Flag for read only file
      LOGICAL LFMTTED    ! Flag for formatted file

      LOGICAL LRXINC( MXRXNS )  ! Flag to include reaction in prod,
                                ! loss, or net operations
      REAL    COEFFS( MXRXNS )  ! Coefficients of operator reactions

C-----------------------------------------------------------------------

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Open file and write report header
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      LRDONLY = .FALSE.
      LFMTTED = .TRUE.

      IOUT = GETEFILE ( PACM_REPORT, LRDONLY, LFMTTED, PNAME )
      IF ( IOUT .LT. 0 ) THEN
         MSG = 'ERROR: Could not open PA_REPORT output file'
         CALL M3EXIT( PNAME, IZERO, IZERO, MSG, XSTAT2 )
      END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Get the time and date to be used as the time stamp for all outputs;
c  Convert from GMT to EDT or EST
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      CALL GETDTTIME( IDATE, ITIME )

      IF ( ISDSTIME( IDATE ) ) THEN
         CALL NEXTIME( IDATE, ITIME, -40000 )
         TZ = ' EDT '
      ELSE
         CALL NEXTIME( IDATE, ITIME, -50000 )
         TZ = ' EST '
      END IF

      TIMNDAT = DT2STR( IDATE, ITIME )
      TDATOUT = TIMNDAT( 1:8 ) // TZ // TIMNDAT( 10:24 )

      WRITE( IOUT, 93020 ) TDATOUT
      WRITE( IOUT, 93000 )

      DO N = 1, 80
         CEES( N:N ) = C
      END DO

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Do the integrated process rate section
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LINOUT = CEES
      WRITE( IOUT, 93000 ) LINOUT
      IF ( N_IPR_SPC .LE. 0 ) THEN
         WRITE( IOUT, 93080 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         WRITE( IOUT, 93000 )
         WRITE( IOUT, 93000 )
      ELSE 
         WRITE( IOUT, 93100 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         LFIRST = .TRUE.
         DO NIPR = 1, N_IPR_SPC
            IF ( IPR_SPTYPE( NIPR ) .EQ. 'FAM' ) THEN
               IF ( LFIRST ) THEN
                  WRITE( IOUT, 93120 )
                  LFIRST = .FALSE.
               END IF 
               INDX = IPR_SPNUM( NIPR )
               DO N = 1, FAMNUMLNS( INDX )
                  WRITE( IOUT, 93000 ) FAMLINE( INDX,N )
               END DO
               WRITE( IOUT, 93140 ) 
               WRITE( IOUT, 93000 ) LINOUT
            END IF
         END DO
         ICOUNT = 0
         DO NIPR = 1, N_IPR_SPC  
            DO N = 1, N_IPR_OPS( NIPR )
               ICOUNT = ICOUNT + 1
               E1 = LEN_TRIM( IPR_OPNAME( NIPR,N ) )
               WRITE( IOUT, 93160 ) ICOUNT, 
     &                              IPR_OPNAME( NIPR, N )( 1:E1 ),  
     &                              IPR_SPNAM( NIPR )
            END DO
         END DO
         WRITE( IOUT, 93000 ) 
         WRITE( IOUT, 93000 ) 
      END IF              

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  If not doing a partial IRR,  write a header and skip to the end
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( .NOT. LPARTIRR ) THEN
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         IF ( LFULLIRR ) THEN 
            WRITE( IOUT, 93180 ) 
         ELSE
            WRITE( IOUT, 93200 )
         END IF
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         GO TO 999
      END IF 

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the section header for the partial IRR section
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      LINOUT = CEES
      WRITE( IOUT, 93000 ) LINOUT
      WRITE( IOUT, 93220 )
      LINOUT = CEES
      WRITE( IOUT, 93000 ) LINOUT

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Find the longest reaction label length, right justify and save
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      MAXLEN = 0
      DO NRX = 1, NRXNS
         MAXLEN = MAX( MAXLEN, LEN_TRIM( RXLABEL( NRX ) ) )
      END DO
       
      DO NRX = 1, NRXNS
         DO N = 1, LABLEN
            RJLABL( NRX )( N:N ) = ' '
         END DO
         IS1 = LBLANK( RXLABEL( NRX ) ) + 1
         IE1 = LEN_TRIM( RXLABEL( NRX ) )
         LEN1 = IE1 - IS1 + 1
         IE2 = LABLEN
         IS2 = LABLEN - LEN1 + 1
         RJLABL( NRX )( IS2:IE2 ) = RXLABEL( NRX )( IS1:IE1 )       
      END DO

      SPOS = LABLEN - MAXLEN + 1

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Top of loop for doing each IRR_OUTPUT report
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      DO 540 NOUT = 1, NIRROUT
         WRITE( OUTLBL, '( I3 )' ) NOUT

c..Write the header for each output
         WRITE( IOUT, 93240 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT
         STRING( 1 ) = '   Summary of Input IRR Commands for OUTPUT'
         STRING( 2 ) = INT2CHR( NOUT )
         IEND = LEN_TRIM( STRING( 2 ) )
         STRING( 2 ) = STRING( 2 )( 1:IEND ) // ':'
         STRING( 3 ) = IRRNAME( NOUT )
         NUMSTRNGS = 3         
         CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
         WRITE( IOUT, 93000 ) LINOUT
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the input IRR commands
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         WRITE( IOUT, 93140 )
         WRITE( IOUT, 93260 )
         WRITE( IOUT, 93140 )
         LINOUT = '       IRROUT(' // OUTLBL // ') = '
         IEND = LEN_TRIM( LINOUT ) + 1
         EQPOS1 = IEND
         DO 100 NTERM = 1, NIRRTERMS( NOUT )

            CALL DOCOEFF( OUTSC( NOUT,NTERM ), COUT )
            IF ( NTERM .EQ. 1 .AND. OUTSC( NOUT,NTERM ) .GT. 0.0 )
     &            COUT( 1:1 ) = ' '
            LINOUT = LINOUT( 1:EQPOS1 ) // COUT
            IEND = EQPOS1 + 12
            TYPE = OUTTYPE( NOUT,NTERM )
            E1 = MIN( LEN_TRIM( OUTSPEC1( NOUT,NTERM ) ), 6 )
            E2 = MIN( LEN_TRIM( OUTSPEC2( NOUT,NTERM ) ), 6 )
            E3 = MIN( LEN_TRIM( OUTSPEC3( NOUT,NTERM ) ), 6 )

            IF ( TYPE .EQ. 'NAME' ) THEN

               LINOUT = LINOUT( 1:IEND ) // OUTSPEC1( NOUT, NTERM )
               IEND = LEN_TRIM( LINOUT )
               IF ( OUTPNFLAG( NOUT,NTERM ) .EQ. 'POSONLY' ) THEN
                  LINOUT = LINOUT( 1:IEND ) // '[POSONLY]'
               ELSE IF ( OUTPNFLAG( NOUT,NTERM ) .EQ. 'NEGONLY' ) THEN
                  LINOUT = LINOUT( 1:IEND ) // '[NEGONLY]'
               END IF

            ELSE IF ( TYPE .EQ. 'PROD' .OR. TYPE .EQ. 'NETP' ) THEN

               OPNAM = TYPE
               LINOUT = LINOUT( 1:IEND ) // OPNAM // ' [' //
     &                  OUTSPEC1( NOUT,NTERM )( 1:E1 ) // ']'
               IEND   = LEN_TRIM( LINOUT )
               IF ( OUTSPEC2( NOUT,NTERM ) .NE. '' ) THEN
                  LINOUT = LINOUT( 1:IEND ) // ' FROM [' //
     &                     OUTSPEC2( NOUT,NTERM )( 1:E2 ) // ']'
                  IEND   = LEN_TRIM( LINOUT )
               END IF
               IF ( OUTSPEC3( NOUT,NTERM ) .NE. '' ) THEN
                  IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                     LINOUT = LINOUT( 1:IEND ) // ' AND [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  ELSE
                     LINOUT = LINOUT( 1:IEND ) // ' OR [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  END IF
                  IEND = LEN_TRIM( LINOUT )
               END IF

            ELSE IF ( TYPE .EQ. 'LOSS' .OR. TYPE .EQ. 'NETL' ) THEN

               OPNAM = TYPE
               LINOUT = LINOUT( 1:IEND ) // OPNAM // ' [' //
     &                  OUTSPEC1( NOUT,NTERM )( 1:E1 ) // ']'
               IEND = LEN_TRIM( LINOUT )
               IF ( OUTSPEC3( NOUT,NTERM ) .NE. '' ) THEN
                  IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                     LINOUT = LINOUT( 1:IEND ) // ' AND [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  ELSE
                     LINOUT = LINOUT( 1:IEND ) // ' OR [' //
     &                        OUTSPEC3( NOUT,NTERM )( 1:E3 ) // ']'
                  END IF
                  IEND = LEN_TRIM( LINOUT )
               END IF

            ELSE IF ( TYPE .EQ. 'NET' ) THEN

               OPNAM = TYPE
               LINOUT = LINOUT( 1:IEND ) // OPNAM // ' [' //
     &                  OUTSPEC1( NOUT,NTERM )( 1:E1 ) // ']'
               IEND = LEN_TRIM( LINOUT )

            ELSE IF ( TYPE .EQ. 'RXN' ) THEN

               INDX = OUTRN( NOUT,NTERM )
               LINOUT = LINOUT( 1:IEND ) // 'IRR<' //
     &                  RJLABL( INDX )( SPOS:LABLEN ) // '>'
            END IF

            WRITE( IOUT, 93000 ) LINOUT
            LINOUT = '      &'
            LINOUT = LINOUT( 1:EQPOS1 )

100      CONTINUE
         WRITE( IOUT, 93140 )
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT   

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the descriptions for any families referenced
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTFAMS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93280 )
            DO NFAM = 1, NOUTFAMS( NOUT )
               INDX = OUTFAMS( NOUT,NFAM )
               DO N = 1, FAMNUMLNS( INDX )
                  WRITE( IOUT, 93000 ) FAMLINE( INDX,N )
               END DO
               WRITE( IOUT, 93140 ) 
            END DO
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output descriptions of all cycles referenced
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTCYCS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93300 )
            DO 200 N = 1, NOUTCYCS( NOUT )
               NCYC = OUTCYCS( NOUT,N )

c..Write the cycle name
               STRING( 1 ) = 'c..CYCLE'
               STRING( 2 ) = INT2CHR( NCYC )
               IEND = LEN_TRIM( STRING( 2 ) )
               STRING( 2 ) = STRING( 2 )( 1:IEND )
               STRING( 3 ) = CYCLNAME( NCYC )
               NUMSTRNGS = 3         
               CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
               WRITE( IOUT, 93000 ) LINOUT

c..Write reactions used in the cycle
               WRITE( LABL, '( I3 )' ) NCYC
               LINOUT = '      CYSM(' // LABL // ') ='
               IEND = LEN_TRIM( STRING( 2 ) )

               IF ( NCYTERMS( NCYC ) .EQ. 0 ) THEN
                  LINOUT = LINOUT( 1:IEND ) // ' 0.0'
                  WRITE( IOUT, 93000 ) LINOUT
               ELSE
                  WRITE( IOUT, 93000 ) LINOUT
                  DO NTERM = 1, NCYTERMS( NCYC )
                     INDX = CYRXNUM( NCYC,NTERM )
                     CALL DOCOEFF( CYSC( NCYC,NTERM ), COUT )
                     LINOUT = MECLINE( INDX,1 )
                     LINOUT( 9:19 ) = COUT
                     WRITE( IOUT, 93000 ) LINOUT
                     IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                        DO NLN = 2, MECNUMLNS( INDX )
                           WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                        END DO
                     END IF
                  END DO
                  WRITE( IOUT, 93140 )
               END IF

200         CONTINUE
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output descriptions of all reaction sums referenced
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTRXSUMS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93320 )
            DO 300 N = 1, NOUTRXSUMS( NOUT )
               NRX = OUTRXSUMS( NOUT,N )

c..Write the reaction sum name
               STRING( 1 ) = 'c..RXSUM'
               STRING( 2 ) = INT2CHR( NRX )
               IEND = LEN_TRIM( STRING( 2 ) )
               STRING( 2 ) = STRING( 2 )( 1:IEND )
               STRING( 3 ) = RXSUMNAME( NRX )
               NUMSTRNGS = 3         
               CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
               WRITE( IOUT, 93000 ) LINOUT

c..Write reactions used in the reaction sum
               WRITE( LABL, '( I3 )' ) NRX
               LINOUT = '      RXSM(' // LABL // ') ='
               WRITE( IOUT, 93000 ) LINOUT
               IEND = LEN_TRIM( STRING( 2 ) )

               IF ( NRXTERMS( NRX ) .EQ. 0 ) THEN
                  LINOUT = LINOUT( 1:IEND ) // ' 0.0'
                  WRITE( IOUT, LINOUT )
               ELSE
                  DO NTERM = 1, NRXTERMS( NRX )
                     INDX = RXSUMRN( NRX,NTERM )
                     CALL DOCOEFF( RXNSC( NRX,NTERM ), COUT )
                     LINOUT = MECLINE( INDX,1 )
                     LINOUT( 9:19 ) = COUT
                     WRITE( IOUT, 93000 ) LINOUT
                     IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                        DO NLN = 2, MECNUMLNS( INDX )
                           WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                        END DO
                     END IF
                  END DO
               END IF 
               WRITE( IOUT, 93140 )
300         CONTINUE
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Before doing operators, flag all reactions included in cycles for
c  elimination from production/loss/net operators 
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         DO NRX = 1, NRXNS
            LRXINC( NRX ) = .TRUE.
         END DO

         IF ( NOUTCYCS( NOUT ) .GT. 0 ) THEN
            DO N = 1, NOUTCYCS( NOUT )
               NCYC = OUTCYCS( NOUT, N )
               DO NTERM = 1, NCYTERMS( NCYC )
                  INDX = CYRXNUM( NCYC, NTERM )
                  LRXINC( INDX ) = .FALSE.
               END DO
            END DO
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output descriptions of production/loss/net operator
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTOPS( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93340 )
            NPROD = 0
            NNPRD = 0
            NLOSS = 0
            NNLOS = 0
            NNETR = 0
            DO 400 NTERM = 1, NIRRTERMS( NOUT )

               TYPE = OUTTYPE( NOUT,NTERM ) 

               IF ( TYPE .NE. 'NAME' .AND. TYPE .NE. 'RXN' ) THEN             

                  CALL GETRXNS( NOUT, NTERM, NR, RXNUMS, COEFFS, LRXINC )

c..Write the operator description
                  IF ( TYPE .EQ. 'PROD' ) THEN
                     STRING( 1 ) = 'c..Production of'
                     OPNAM = 'PROD'
                     NPROD = NPROD + 1
                     WRITE( LABL, '( I3 )' ) NPROD
                  ELSE IF ( TYPE .EQ. 'NETP' ) THEN
                     STRING( 1 ) = 'c..Net production of'
                     OPNAM = 'NPRD'
                     NNPRD = NNPRD + 1
                     WRITE( LABL, '( I3 )' ) NNPRD
                  ELSE IF ( TYPE .EQ. 'LOSS' ) THEN
                     STRING( 1 ) = 'c..Loss of'
                     OPNAM = 'LOSS'
                     NLOSS = NLOSS + 1
                     WRITE( LABL, '( I3 )' ) NLOSS
                  ELSE IF ( TYPE .EQ. 'NETL' ) THEN
                     STRING( 1 ) = 'c..Net loss of'
                     OPNAM = 'NLOS'
                     NNLOS = NNLOS + 1
                     WRITE( LABL, '( I3 )' ) NNLOS
                  ELSE IF ( TYPE .EQ. 'NET' ) THEN
                     STRING( 1 ) = 'c..Net reaction of'
                     OPNAM = 'NETR'
                     NNETR = NNETR + 1
                     WRITE( LABL, '( I3 )' ) NNETR
                  END IF

                  SAVOP( NTERM ) = OPNAM
                  SAVLBL( NTERM ) = LABL

                  STRING( 2 ) = OUTSPEC1( NOUT,NTERM )
                  NUMSTRNGS = 2

                  IF ( OUTSPEC2( NOUT,NTERM ) .NE. '' ) THEN
                     STRING( 3 ) = 'from'
                     STRING( 4 ) = OUTSPEC2( NOUT,NTERM )
                     NUMSTRNGS = 4
                  END IF                  

                  IF ( OUTSPEC3( NOUT,NTERM ) .NE. '' ) THEN
                     IF ( OUTOP2( NOUT,NTERM ) .EQ. 'AND' ) THEN
                        STRING( NUMSTRNGS + 1 ) = 'and'
                     ELSE
                        STRING( NUMSTRNGS + 1 ) = 'or'
                     END IF
                     STRING( NUMSTRNGS + 2 ) = OUTSPEC3( NOUT,NTERM )
                     NUMSTRNGS = NUMSTRNGS + 2
                  END IF

                  CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
                  IEND = LEN_TRIM( LINOUT )
                  WRITE( IOUT, 93000 ) LINOUT

c..Write reactions used in the operator
                           !123456     7890      1     234      567
                  LINOUT = '      ' // OPNAM // '(' // LABL // ') ='
                  IEND = LEN_TRIM( LINOUT )   ! = 17
                  IF ( NR .LE. 0 ) THEN
                     LINOUT = LINOUT( 1:IEND ) // ' 0.0'
                     WRITE( IOUT, 93000 ) LINOUT                  
                  ELSE
                     WRITE( IOUT, 93000 ) LINOUT
                     DO N = 1, NR
                        INDX = RXNUMS( N )
                        CALL DOCOEFF( COEFFS( N ), COUT )
                        LINOUT = MECLINE( INDX,1 )
                        LINOUT( 9:19 ) = COUT
                        WRITE( IOUT, 93000 ) LINOUT
                        IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                           DO NLN = 2, MECNUMLNS( INDX )
                              WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                           END DO
                        END IF
                     END DO
                  END IF
                  WRITE( IOUT, 93140 )
               END IF
400         CONTINUE 
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Output list of all reactions referenced in the OUTPUT command
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         IF ( NOUTRXN( NOUT ) .GT. 0 ) THEN
            WRITE( IOUT, 93140 )
            WRITE( IOUT, 93360 )
            IF ( NOUTRXN( NOUT ) .GT. 0 ) THEN
               DO NTERM = 1, NIRRTERMS( NOUT )
                  TYPE = OUTTYPE( NOUT,NTERM ) 
                  IF ( TYPE .EQ. 'RXN' ) THEN
                     INDX = OUTRN( NOUT,NTERM )
                     LINOUT = MECLINE( INDX, 1 )
                     LINOUT( 6:6 ) = ' '
                     WRITE( IOUT, 93000 ) LINOUT
                     IF ( MECNUMLNS( INDX ) .GT. 1 ) THEN
                        DO NLN = 2, MECNUMLNS( INDX )
                           WRITE( IOUT, 93000 ) MECLINE( INDX,NLN )
                        END DO
                     END IF
                  END IF
               END DO
            END IF
            WRITE( IOUT, 93140 )
            LINOUT = CEES
            WRITE( IOUT, 93000 ) LINOUT
         END IF           

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Write the pseudocode for IRROUT
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         STRING( 1 ) = '   Pseudocode for OUTPUT'
         STRING( 2 ) = INT2CHR( NOUT )
         IEND = LEN_TRIM( STRING( 2 ) )
         STRING( 2 ) = STRING( 2 )( 1:IEND ) // ':'
         STRING( 3 ) = IRRNAME( NOUT )
         NUMSTRNGS = 3         
         CALL CATSTRING( NUMSTRNGS, STRING, LINOUT, LINLEN )
         WRITE( IOUT, 93000 ) LINOUT
         LINOUT = CEES
         WRITE( IOUT, 93000 ) LINOUT

c..Write the pseudocode for the initialization terms
         LINITFLG = .FALSE.
         LFIRST = .TRUE.
         DO 500  NTERM = 1, NIRRTERMS( NOUT )
            PNFLG = OUTPNFLAG( NOUT,NTERM )

            IF ( PNFLG .NE. '' ) THEN
               LINITFLG = .TRUE.
               TYPE = OUTS1TYP( NOUT,NTERM )
               WRITE( LABL, '( I3 )' ) OUTS1NUM( NOUT,NTERM )
               IF ( LFIRST ) THEN
                  LINOUT = '      IRROUT(' // OUTLBL // ') = 0.0' 
                  WRITE( IOUT, 93000 ) LINOUT
                  WRITE( IOUT, 93000 )
                  LFIRST = .FALSE.
               END IF

               IF ( TYPE .EQ. 'CYCL' ) THEN
                  OPNAM = 'CYSM'
               ELSE
                  OPNAM = 'RXSM'
               END IF

               CALL DOCOEFF( OUTSC( NOUT,NTERM ), COUT )
               IF ( ABS( OUTSC( NOUT,NTERM ) ) .NE. 1.0 ) THEN
                  E1 = 11
               ELSE
                  E1 = 1
               END IF      

               IF ( PNFLG .EQ. 'POSONLY' ) THEN
                  LINOUT = '      IF ( ' // OPNAM // '(' // LABL // 
     &                     ') .GT. 0.0 ) THEN'
               ELSE
                  LINOUT = '      IF ( ' // OPNAM // '(' // LABL // 
     &                     ') .LT. 0.0 ) THEN'
               END IF

               WRITE( IOUT, 93000 ) LINOUT
               IF ( PNFLG .EQ. 'POSONLY' ) THEN
                  LINOUT = '         IRROUT(' // OUTLBL // 
     &                     ') = IRROUT(' // OUTLBL // ') ' //
     &                     COUT( 1:E1 ) // ' ' // OPNAM  //
     &                    '(' // LABL // ')'
               ELSE
                  LINOUT = '         IRROUT(' // OUTLBL //
     &                     ') = IRROUT(' // OUTLBL // ') ' //
     &                     COUT( 1:E1 ) // ' ABS('  // OPNAM //
     &                     '(' // LABL // '))'
               END IF

               WRITE( IOUT, 93000 ) LINOUT
               LINOUT = '      END IF'
               WRITE( IOUT, 93000 ) LINOUT
               WRITE( IOUT, 93000 )
            END IF

500      CONTINUE               

c..Write the final equation for the output integrated reaction rates
         IF ( NIRRTERMS( NOUT ) .EQ. 0 ) THEN
            LINOUT = '       IRROUT(' // OUTLBL // ') = 0.0'
            WRITE( IOUT, 93000 ) LINOUT
         ELSE
            ICOUNT = 0
            DO 520 NTERM = 1, NIRRTERMS( NOUT )
               IF ( NTERM .EQ. 1 ) THEN
                  LINOUT = '      IRROUT(' // OUTLBL // ') = '
                  EQPOS1 = LEN_TRIM( LINOUT ) 
                  IF ( LINITFLG ) THEN
                     LINOUT = LINOUT( 1:EQPOS1 ) // ' IRROUT(' //
     &                        OUTLBL // ')'
                     WRITE( IOUT, 93000 ) LINOUT
                     LINOUT ='     &'
                     LINOUT = LINOUT( 1:EQPOS1 )
                     ICOUNT = ICOUNT + 1
                  END IF 
               ELSE
                  LINOUT ='     &'
                  LINOUT = LINOUT( 1:EQPOS1 )
               END IF

               TYPE = OUTTYPE( NOUT,NTERM )
               IF ( TYPE .EQ. 'NAME' ) TYPE = OUTS1TYP( NOUT,NTERM ) 
               PNFLG = OUTPNFLAG( NOUT,NTERM )

               IF ( PNFLG .EQ. 'POSONLY' .OR. PNFLG .EQ. 'NEGONLY' )
     &             GO TO 520
               IF ( TYPE .EQ. 'CYCL' .AND. PNFLG .EQ. '' ) THEN
                  OPNAM = 'CYSM'
                  WRITE( LABL, '( I3 )' ) OUTS1NUM( NOUT,NTERM )
               ELSE IF ( TYPE .EQ. 'RXSM' .AND. PNFLG .EQ. '' ) THEN
                  OPNAM = 'RXSM'
                  WRITE( LABL, '( I3 )' ) OUTS1NUM( NOUT,NTERM )
               ELSE IF ( TYPE .EQ. 'RXN' ) THEN
                  OPNAM = ' IRR' 
                  INDX = OUTRN( NOUT,NTERM )
               ELSE
                  OPNAM = SAVOP( NTERM )
                  LABL  = SAVLBL( NTERM )
               END IF

               CALL DOCOEFF( OUTSC( NOUT,NTERM ), COUT )
               ICOUNT = ICOUNT + 1
               IF ( OUTSC( NOUT,NTERM ) .GT. 0.0 .AND. ICOUNT .EQ. 1 ) 
     &              COUT( 1:1 ) = ' '
               IF ( TYPE .EQ. 'RXN' ) THEN
                  LINOUT = LINOUT( 1:EQPOS1 ) // COUT // ' ' // 
     &                     OPNAM // '<'  // 
     &                     RJLABL( INDX )( SPOS:LABLEN ) // '>'
               ELSE
                  LINOUT = LINOUT( 1:EQPOS1 ) // COUT // ' ' // 
     &                     OPNAM // '(' // LABL( 1:3 ) // ')'
               END IF
               WRITE( IOUT, 93000 ) LINOUT
520         CONTINUE
         END IF
540   CONTINUE

999   CONTINUE
    
      WRITE( IOUT, 93380 ) 
      CLOSE( IOUT )
      RETURN
      
C----------------------- Format Statements -----------------------------
93000 FORMAT( A )

93020 FORMAT( //'============ Process Analysis Control Module Output', 
     &        ' Report ============'/18X, 'Created  ', A/ )

!3040 FORMAT( ' ', 24X, 'OUTPUT DOMAIN SECTION'/
!    &        '   Process Monitoring and IRR outputs will be generated', 
!    &        ' for the'/
!    &        '   following cells relative to the full modeling domain.' )
!3060 FORMAT( '       Starting column:', I4/
!    &        '       Ending column:  ', I4/
!    &        '       Starting row:   ', I4/
!    &        '       Ending row:     ', I4/ 
!    &        '       Starting layer: ', I4/
!    &        '       Ending layer:   ', I4 ) 

93080 FORMAT( 20X, 'Integrated Process Rate Section'/
     &        '   No requests for IPR outputs were included', 
     &        ' in the command file.' )

93100 FORMAT( 20X, 'Integrated Process Rate Section'/
     &        '   The following section lists the IPR ', 
     &        'outputs generated from the'/
     &        '   command file inputs.' )

93120 FORMAT( ' '/
     &        '   The referenced families are defined as follows:'/
     &        ' ' )
93140 FORMAT( ' ' )
93160 FORMAT( '      IPR_OUTPUT(', I3, ') = ', A, ' of ', A ) 
93180 FORMAT( 20X, 'Integrated Reaction Rate Section'/
     &        '   A FULL IRR analysis has been requested. Each reaction', 
     &          ' rate will be'/
     &        '   integrated individually and output for the',
     &          ' specified domain.' )
93200 FORMAT( 20X, 'Integrated Reaction Rate Section'/
     &        '   No requests for IRR analysis were included in the', 
     &        ' command file.' )
93220 FORMAT( 20X, 'Integrated Reaction Rate Section'/
     &        '   The following section gives a symbolic representation', 
     &        ' of how the'/
     &        '   PARTIAL IRR outputs are calculated given the commands', 
     &        ' that were'/
     &        '   included in the command file. The report includes', 
     &        ' pseudocode showing'/
     &        '   how individual integrated reactions rates are', 
     &        ' combined to produce the '/
     &        '   requested output.  In the pseudocode that follows'/
     &        ' '/
     &        '         IRR< x > = the integrated reaction rate for '/
     &        '                    the reaction with label x as '/
     &        '                    defined in the chemical mechanism'/
     &        ' '/
     &        '         IRROUT( n ) = the nth integrated reaction rate'/
     &        '                       output that was requested'/
     &        ' ' )  
93240 FORMAT( //1X )
93260 FORMAT( '   The IRR_OUTPUT command was specified as follows:' )
93280 FORMAT( '   The referenced families are defined as follows:'/' ' )
93300 FORMAT( '   The referenced cycles are defined as follows:'/' ' )
93320 FORMAT( '   The referenced reaction sums are defined as follows:'/
     &        ' ' )
93340 FORMAT( '   The referenced operators are defined as follows:'/' ' )
93360 FORMAT( '   The following reactions are referenced individually:'/
     &        ' ' )
93380 FORMAT( ///'========= End of Process Analysis Control Module', 
     &         ' Output Report ========='  )  
C-----------------------------------------------------------------------

      CONTAINS

         SUBROUTINE DOCOEFF( COEF, COUT )

C-----------------------------------------------------------------------
C Function: Transform a coefficient from numerical to character form for
C           output reports   
C-----------------------------------------------------------------------

         IMPLICIT NONE
      
C Arguments:
         REAL    COEF              ! Coefficient for output term 
         CHARACTER( * ) :: COUT    ! Output coefficient
                                        
C Local Variables
         INTEGER N   ! Loop index
         
C-----------------------------------------------------------------------

         DO N = 1, LEN( COUT )
            COUT( N:N ) = ' '
         END DO

         IF ( ABS( COEF ) .NE. 1.0 ) THEN
            WRITE( COUT, '( 2X, F7.4 )' ) ABS( COEF )
            COUT( 11:11 ) = '*'
         END IF   

         IF ( COEF .GE. 0.0 ) THEN
            COUT( 1:1 ) = '+'
         ELSE
            COUT( 1:1 ) = '-'
         END IF

         RETURN 

         END SUBROUTINE DOCOEFF

         FUNCTION INT2CHR( NOUT ) RESULT( INTSTR )

C-----------------------------------------------------------------------
C Function: Convert an integer number into character representation
C           that is left justified in a string 
C-----------------------------------------------------------------------
         USE UTILIO_DEFN

         IMPLICIT NONE
      
C Arguments:
         INTEGER NOUT               ! Integer number to convert
         CHARACTER( 10 ) :: INTSTR  ! string holder

C Local Variables:
         INTEGER EPOS1         ! Ending positions
         INTEGER SPOS1         ! Starting positions
         INTEGER LEN1          ! Length of string
         INTEGER N             ! Loop index
C-----------------------------------------------------------------------

         WRITE( INTSTR, '( I10 )' ) NOUT
         DO N = 1, 10
            INTSTR( N:N ) = ' '
         END DO

c..Left justify the numeric string
         SPOS1 = LBLANK( INTSTR ) + 1
         EPOS1 = LEN_TRIM( INTSTR )
         LEN1 = EPOS1 - SPOS1 + 1
         INTSTR( 1:LEN1 ) = INTSTR( SPOS1:EPOS1 )

         RETURN
         END FUNCTION INT2CHR

      END SUBROUTINE PA_REPORT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module aq_data

C  Defines gas and aerosol surrogate data.
C  this module replace the AQ_PARAMS.EXT include file
C
C  Revision History:
C     First version was coded in May 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     Feb 2011: Steve Howard, Shawn Roselle, Prakash Bhave, Bill Hutzell -
C     Mar 2011: Sergey Napelenok - AE6 update for Ca/Mg/K/Fe/Mn 
C               indexing, density, variable names
C     Mar 2011: Shawn Roselle, replaced I/O API include files with UTILIO_DEFN
C     Sep 2011: B.Hutzell: adapted for mercury and HAP mechanisms
C     Jun 2012: J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C     Oct 2014: B.Hutzell:forcing to skip mapping if aerosol species
C     index equals the values for H3OP species as for aerosol water
C     species 
C-----------------------------------------------------------------------
      Use aero_data, Only: n_aerolist, n_aerospc, conmin
      Use runtime_vars

      Implicit None

      Integer, Parameter :: ngas = 15   ! number of gas-phase species for AQCHEM
!     Integer, Parameter :: naddaer = 7 ! number of additional aerosol surrogate species for AQCHEM
      Integer, Parameter :: naddaer = 2 ! number of additional aerosol surrogate species for AQCHEM
      Integer, Parameter :: nadd_tx = 6 ! number of surrogates for HAPS aerosol species for AQCHEM

      Integer, Parameter :: max_naer = n_aerolist + naddaer +  nadd_tx ! max number aero surrogates

      Integer, Save      :: naer        ! number of aerosol surrogate species for AQCHEM
      Integer, Parameter :: nliqs = 60  ! number of liquid-phase species in AQCHEM
      Integer, Parameter :: nmodes = 3  ! number of aerosol modes
      Integer, Parameter :: mxsrg = 70  ! maximum number of species for surrogate

      integer, parameter :: akn = 1     ! number for Aitken mode
      Integer, Parameter :: acc = 2     ! number for Accumulation mode
      Integer, Parameter :: cor = 3     ! number for Coarse mode

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C...Gas surrogates species 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      Type sur_gas_type
         Character( 16 ) :: name               ! surrogate name
         Real            :: backgnd            ! background value
      End Type sur_gas_type

      Type ( sur_gas_type ), Parameter :: srggas( ngas ) = (/
C                          Name       Background
C                       ----------    ----------
     & sur_gas_type( 'SO2       ',        0.0 ),
     & sur_gas_type( 'HNO3      ',        0.0 ),
     & sur_gas_type( 'N2O5      ',        0.0 ),
     & sur_gas_type( 'CO2       ',      340.0 ),
     & sur_gas_type( 'NH3       ',        0.0 ),
     & sur_gas_type( 'H2O2      ',        0.0 ),
     & sur_gas_type( 'O3        ',        0.0 ),
     & sur_gas_type( 'FOA       ',        0.0 ),
     & sur_gas_type( 'MHP       ',        0.0 ),
     & sur_gas_type( 'PAA       ',        0.0 ),
     & sur_gas_type( 'H2SO4     ',        0.0 ),
     & sur_gas_type( 'HCL       ',        0.0 ),
     & sur_gas_type( 'GLY       ',        0.0 ),
     & sur_gas_type( 'MGLY      ',        0.0 ),
     & sur_gas_type( 'HO        ',        0.0 ) / )

C...Required gas species
      Character( 16 ), Parameter, Private :: req_so2   = 'SO2'
      Character( 16 ), Parameter, Private :: req_hno3  = 'HNO3'
      Character( 16 ), Parameter, Private :: req_n2o5  = 'N2O5'
      Character( 16 ), Parameter, Private :: req_co2   = 'CO2'
      Character( 16 ), Parameter, Private :: req_nh3   = 'NH3'
      Character( 16 ), Parameter, Private :: req_h2o2  = 'H2O2'
      Character( 16 ), Parameter, Private :: req_o3    = 'O3'
      Character( 16 ), Parameter, Private :: req_foa   = 'FOA'
      Character( 16 ), Parameter, Private :: req_mhp   = 'MHP'
      Character( 16 ), Parameter, Private :: req_paa   = 'PAA'
      Character( 16 ), Parameter, Private :: req_h2so4 = 'H2SO4'
      Character( 16 ), Parameter, Private :: req_hcl   = 'HCL'
      Character( 16 ), Parameter, Private :: req_gly   = 'GLY'
      Character( 16 ), Parameter, Private :: req_mgly  = 'MGLY'
      Character( 16 ), Parameter, Private :: req_ho    = 'HO'

C...Pointers for the AQCHEM array GAS

      Integer :: lso2     ! Sulfur Dioxide
      Integer :: lhno3    ! Nitric Acid
      Integer :: ln2o5    ! Dinitrogen Pentoxide
      Integer :: lco2     ! Carbon Dioxide
      Integer :: lnh3     ! Ammonia
      Integer :: lh2o2    ! Hydrogen Peroxide
      Integer :: lo3      ! Ozone
      Integer :: lfoa     ! Formic Acid
      Integer :: lmhp     ! Methyl Hydrogen Peroxide
      Integer :: lpaa     ! Peroxyacetic Acid
      Integer :: lh2so4   ! Sulfuric Acid
      Integer :: lhcl     ! Hydrogen Chloride
      Integer :: lgly     ! Glyoxal
      Integer :: lmgly    ! Methylglyoxal
      Integer :: lho      ! OH, hydroxyl radical

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C...Aerosol surrogates species 
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      Type sur_aer_type
         Character( 16 ) :: name( nmodes )     ! surrogate name
         Real            :: backgnd            ! background value
         Real            :: molwt              ! molecular weight
         Real            :: density            ! density [kg m-3] 
      End Type sur_aer_type

      Type ( sur_aer_type ), Allocatable, Save  :: srgaer( : )

C... Additional Aerosol surrogate species to add to aerosol list
      Type ( sur_aer_type ), private :: addsrgaer( naddaer ) = (/
C                         Aitken           Accum            Coarse        Background MolWt  Density
C                      -------------    -------------    -------------    ---------- -----  ------
!    & sur_aer_type((/'             ', '             ', 'CACO3        '/),   0.0,    100.1, 2200.0),
!    & sur_aer_type((/'             ', '             ', 'MGCO3        '/),   0.0,     84.3, 2200.0),
!    & sur_aer_type((/'             ', '             ', 'A3FE         '/),   0.0,     55.8, 2000.0),
!    & sur_aer_type((/'             ', '             ', 'B2MN         '/),   0.0,     54.9, 2000.0),
!    & sur_aer_type((/'             ', '             ', 'K            '/),   0.0,     39.1, 2200.0),
     & sur_aer_type((/'NUM_AITKEN   ', 'NUM_ACCUM    ', 'NUM_COARSE   '/),   0.0,      0.0,    1.0),
     & sur_aer_type((/'SRF_AITKEN   ', 'SRF_ACCUM    ', 'SRF_COARSE   '/),   0.0,      0.0,    1.0)/)

C...TX species added to Aerosol surrogate if not found in AE namelist file      
      Type ( sur_aer_type ), private :: srgaer_addtx( nadd_tx ) = (/
C                         Aitken           Accum            Coarse        Background MolWt  Density
C                      -------------    -------------    -------------    ---------- -----  ------
     & sur_aer_type((/'TRACER_AITKEN', '             ', '             '/),   0.0,    100.0, 2200.0),
     & sur_aer_type((/'             ', 'TRACER_ACCUM ', '             '/),   0.0,    100.0, 2200.0),
     & sur_aer_type((/'             ', '             ', 'TRACER_COARSE'/),   0.0,    100.0, 2200.0),
     & sur_aer_type((/'PHG_AITKEN   ', '             ', '             '/),   0.0,    200.5, 2200.0),
     & sur_aer_type((/'             ', 'PHG_ACCUM    ', '             '/),   0.0,    200.5, 2200.0),
     & sur_aer_type((/'             ', '             ', 'PHG_COARSE   '/),   0.0,    200.5, 2200.0)/)

C...Required aerosol species
      Character( 16 ), Parameter, Private :: req_aso4   = 'SO4_ACCUM'
      Character( 16 ), Parameter, Private :: req_anh4   = 'NH4_ACCUM'
      Character( 16 ), Parameter, Private :: req_ano3   = 'NO3_ACCUM'
      Character( 16 ), Parameter, Private :: req_asoa   = 'SOA_ACCUM'
      Character( 16 ), Parameter, Private :: req_aorgc  = 'AORGC_ACCUM'
      Character( 16 ), Parameter, Private :: req_apoa   = 'POA_ACCUM'
      Character( 16 ), Parameter, Private :: req_aec    = 'EC_ACCUM'
      Character( 16 ), Parameter, Private :: req_apri   = 'PRI_ACCUM'
!     Character( 16 ), Parameter, Private :: req_apric  = 'PRI_COARSE'  ! SLN 16March2011
      Character( 16 ), Parameter, Private :: req_ana    = 'NA_ACCUM'
      Character( 16 ), Parameter, Private :: req_acl    = 'CL_ACCUM'
      Character( 16 ), Parameter, Private :: req_acaco3 = 'CACO3'
      Character( 16 ), Parameter, Private :: req_amgco3 = 'MGCO3'
      Character( 16 ), Parameter, Private :: req_aa3fe  = 'A3FE'
      Character( 16 ), Parameter, Private :: req_ab2mn  = 'B2MN'
      Character( 16 ), Parameter, Private :: req_ak     = 'K'
      Character( 16 ), Parameter, Private :: req_num    = 'NUM_ACCUM'
      Character( 16 ), Parameter, Private :: req_srf    = 'SRF_ACCUM'

      Character( 16 ), Parameter, Private :: req_caacc  = 'CA_ACCUM'    ! SLN 16March2011
      Character( 16 ), Parameter, Private :: req_mgacc  = 'MG_ACCUM'    ! SLN 16March2011
      Character( 16 ), Parameter, Private :: req_kacc   = 'K_ACCUM'     ! SLN 16March2011
      Character( 16 ), Parameter, Private :: req_feacc  = 'FE_ACCUM'    ! SLN 22March2011
      Character( 16 ), Parameter, Private :: req_mnacc  = 'MN_ACCUM'    ! SLN 22March2011
      Character( 16 ), Parameter, Private :: req_soilc  = 'SOIL_COARSE' ! SLN 16March2011
      Character( 16 ), Parameter, Private :: req_anthc  = 'ANTH_COARSE' ! SLN 16March2011
      Character( 16 ), Parameter, Private :: req_seasc  = 'SEAS_COARSE' ! SLN 16March2011
C...For TX version      
      Character( 16 ), Parameter, Private :: req_traceri = 'TRACER_AITKEN'
      Character( 16 ), Parameter, Private :: req_tracerj = 'TRACER_ACCUM'
      Character( 16 ), Parameter, Private :: req_tracerk = 'TRACER_COARSE'
      Character( 16 ), Parameter, Private :: req_phgi    = 'PHG_AITKEN'
      Character( 16 ), Parameter, Private :: req_phgj    = 'PHG_ACCUM'
      Character( 16 ), Parameter, Private :: req_phgk    = 'PHG_COARSE'
C...For Sulfur tracking
      Character( 16 ), Parameter, Private :: req_aso4aqh2o2 = 'SO4_AQH2O2_ACCUM'
      Character( 16 ), Parameter, Private :: req_aso4aqo3   = 'SO4_AQO3_ACCUM'
      Character( 16 ), Parameter, Private :: req_aso4aqfemn = 'SO4_AQFEMN_ACCUM'
      Character( 16 ), Parameter, Private :: req_aso4aqmhp  = 'SO4_AQMHP_ACCUM'
      Character( 16 ), Parameter, Private :: req_aso4aqpaa  = 'SO4_AQPAA_ACCUM'


C...Pointers for the AQCHEM array AEROSOL
      Integer :: lso4     !  Sulfate
      Integer :: lnh4     !  Ammonium
      Integer :: lno3     !  Nitrate
      Integer :: lsoa     !  SOA
      Integer :: lorgc    !  SOA (anthropogenic organic oligomers)
      Integer :: lpoa     !  Primary organic aerosol
      Integer :: lec      !  Elemental carbon
      Integer :: lpri     !  Primary aerosol (Aitken and Accumulation)
!     Integer :: lpricor  !  Primary aerosol (coarse)
      Integer :: lna      !  Sodium
      Integer :: lcl      !  Chloride ion
!     Integer :: lcaco3   !  Calcium Carbonate aerosol (place holder)
!     Integer :: lmgco3   !  Magnesium Carbonate aerosol (place holder)
!     Integer :: la3fe    !  Iron aerosol (place holder)
!     Integer :: lb2mn    !  Manganese aerosol (place holder)
!     Integer :: lk       !  Potassium aerosol (Cl- tracked separately) (place holder)
      Integer :: lnum     !  Number
      Integer :: lsrf     !  Surface area
C...TXHG aersosols      
      Integer :: ltracer_akn  !  Tracer aerosols (Aitken)
      Integer :: ltracer_acc  !  Tracer aerosols (Accumulation)
      Integer :: ltracer_cor  !  Tracer aerosols (Coarse)
      Integer :: lphg_akn     !  Mercuric aerosols (Aitken and Accumulation)
      Integer :: lphg_acc     !  Mercuric aerosols (Aitken and Accumulation)
      Integer :: lphg_cor     !  Mercuric aerosols (Coarse)
C...Sulfur Tracking Model      
      Integer :: lso4aqh2o2 ! Sulfate from aq H2O2 rxn
      Integer :: lso4aqo3   ! Sulfate from aq O3 rxn
      Integer :: lso4aqfemn ! Sulfate from aq rxn catalyzed by FE&MN
      Integer :: lso4aqmhp  ! Sulfate from aq MHP rxn
      Integer :: lso4aqpaa  ! Sulfate from aq PAA rxn

      Integer :: lcaacc   !  Ca in Accumulation mode (AE6) SLN 16March2011
      Integer :: lmgacc   !  Mg in Accumulation mode (AE6) SLN 16March2011
      Integer :: lkacc    !  K in Accumulation mode (AE6)  SLN 16March2011
      Integer :: lfeacc   !  Fe in Accumulation mode (AE6) SLN 22March2011
      Integer :: lmnacc   !  Mn in Accumulation mode (AE6) SLN 22March2011
      Integer :: lsoilc   !  SOIL in Coarse mode (AE6)     SLN 16March2011
      Integer :: lanthc   !  CORS in Coarse mode (AE6)     SLN 16March2011
      Integer :: lseasc   !  SEAS in Coarse mode (AE6)     SLN 16March2011

C...Pointers for the AQCHEM arrays LIQUID and WETDEP
      Integer, Parameter :: lacl        = 01  ! Hydrogen ion
      Integer, Parameter :: lnh4accl    = 02  ! Ammonium(attributed to accum. mode)
      Integer, Parameter :: lcacorl     = 03  ! coarse mode Calcium 
      Integer, Parameter :: lnaaccl     = 04  ! Sodium
      Integer, Parameter :: lohl        = 05  ! Hydroxyl radical
      Integer, Parameter :: lso4accl    = 06  ! Sulfate (attributed to accumulation mode)
      Integer, Parameter :: lhso4accl   = 07  ! bisulfate (attributed to accumulation mode)
      Integer, Parameter :: lso3l       = 08  ! sulfite
      Integer, Parameter :: lhso3l      = 09  ! bisulfite
      Integer, Parameter :: lso2l       = 10  ! sulfur dioxide
      Integer, Parameter :: lco3l       = 11  ! carbonate
      Integer, Parameter :: lhco3l      = 12  ! bicarbonate
      Integer, Parameter :: lco2l       = 13  ! carbon dioxide
      Integer, Parameter :: lno3accl    = 14  ! nitrate(attributed to accumulation mode)
      Integer, Parameter :: lnh3l       = 15  ! ammonia
      Integer, Parameter :: lclaccl     = 16  ! chloride ion (attributed to accumulation mode)
      Integer, Parameter :: lh2o2l      = 17  ! hydrogen peroxide
      Integer, Parameter :: lo3l        = 18  ! ozone
      Integer, Parameter :: lfecorl     = 19  ! iron
      Integer, Parameter :: lmncorl     = 20  ! Manganese
      Integer, Parameter :: lal         = 21  ! generalized anion associated with iron
      Integer, Parameter :: lfoal       = 22  ! Formic acid
      Integer, Parameter :: lhco2l      = 23  ! HCOO- ion
      Integer, Parameter :: lmhpl       = 24  ! Methyl hydrogen peroxide
      Integer, Parameter :: lpaal       = 25  ! Peroxyacidic acid
      Integer, Parameter :: lhcll       = 26  ! Hydrogen chloride
      Integer, Parameter :: lpriml      = 27  ! primary aerosol
      Integer, Parameter :: lmgcorl     = 28  ! coarse mode Magnesium
      Integer, Parameter :: lkcorl      = 29  ! coarse mode Potassium
      Integer, Parameter :: lbl         = 30  ! generalized anion associated with manganese
      Integer, Parameter :: lhno3l      = 31  ! nitric acid
!     Integer, Parameter :: lprimcorl   = 32  ! coarse-mode primary aerosol
      Integer, Parameter :: lnumcorl    = 32  ! coarse-mode number
      Integer, Parameter :: lts6corl    = 33  ! sulfate (attributed to coarse mode)
      Integer, Parameter :: lnacorl     = 34  ! sodium (attributed to coarse mode)
      Integer, Parameter :: lclcorl     = 35  ! chloride ion (attributed to coarse mode)
      Integer, Parameter :: lno3corl    = 36  ! nitrate (attributed to coarse mode)
      Integer, Parameter :: lnh4corl    = 37  ! ammonium (attributed to coarse mode)
      Integer, Parameter :: lsoal       = 38  ! secondary organic aerosols
      Integer, Parameter :: lorgcl      = 39  ! in-cloud soa
      integer, parameter :: lpoal       = 40  ! primary organic aerosols
      Integer, Parameter :: lecl        = 41  ! elemental carbon
      Integer, Parameter :: lglyl       = 42  ! glyoxal
      Integer, Parameter :: lmglyl      = 43  ! methylglyoxal
      Integer, Parameter :: lcaaccl     = 44  ! accumulation mode Calcium (AE6)   SLN 16March2011
      Integer, Parameter :: lmgaccl     = 45  ! accumulation mode Magnesium (AE6) SLN 16March2011
      Integer, Parameter :: lkaccl      = 46  ! accumulation mode Potassium (AE6) SLN 16March2011
      Integer, Parameter :: lsoilcl     = 47  ! coarse mode SOIL (AE6)   SLN 16March2011
      Integer, Parameter :: lanthcl     = 48  ! coarse mode CORS (lol) (AE6)   SLN 16March2011
      Integer, Parameter :: lseascl     = 49  ! coarse mode SEAS (AE6) SLN 16March2011
      Integer, Parameter :: lfeaccl     = 50  ! accumulation mode Iron (AE6)      SLN 22March2011
      Integer, Parameter :: lmnaccl     = 51  ! accumulation mode Manganese (AE6) SLN 22March2011
C for TX version
      integer, parameter :: ltracerl    = 52 ! TRACER
      integer, parameter :: ltracercorl = 53 ! Coarse-mode TRACER
      integer, parameter :: lphgfinel   = 54 ! Fine-mode Mercury Tracer
      integer, parameter :: lphgcorl    = 55 ! Coarse-mode Mercury Tracer
C for sulfur tracking model
      Integer, Parameter :: lts6aqh2o2l = 56 ! total S(VI) from aq H2O2 rxn
      Integer, Parameter :: lts6aqo3l   = 57 ! total S(VI) from aq O3 rxn
      Integer, Parameter :: lts6aqfemnl = 58 ! total S(VI) from aq FE&MN catalyzed rxn
      Integer, Parameter :: lts6aqmhpl  = 59 ! total S(VI) from aq MHP rxn
      Integer, Parameter :: lts6aqpaal  = 60 ! total S(VI) from aq PAA rxn

      Integer    :: nsrggas( ngas )           ! # surrogates in CGRID for each gas
      Integer    :: lsrggas( ngas,mxsrg )

      Integer, Allocatable, Save :: nsrgaer( :,: )    ! # surrogates in CGRID for each aerosol
      Integer, Allocatable, Save :: lsrgaer( :,:,: )

      Integer, Allocatable, Save :: cgrid2aq_map( : ) ! allocated in AQ_DATA_INIT
      Character( 16 ), Allocatable, Save :: cgrid2aq_name( : ) ! allocated in AQ_DATA_INIT

      Real( 8 )   :: jh2o2_hydrometeors    ! H2O2 photolysis rate in condensed water [sec-1]
      Real( 8 )   :: jhno3_hydrometeors    ! HNO3 photolysis rate in condensed water [sec-1]

      Logical, Private, Save :: mapped = .False.

      Contains
 
C------------------------------------------------------------------------
      Subroutine aq_data_init()

C  Defines mapping from CGRID for species concentration and moments.
 
C  Revision History:
C     First version was coded in May 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     Jan 2017: Additional error check added to avoid array out of
C     bounds when additional aerosol species are added. HOT Pye.
C-----------------------------------------------------------------------

      Use cgrid_spcs          ! CGRID mechanism species
      Use utilio_defn
      Use aero_data 
      Use phot_mod, Only: init_phot_shared  ! set-up shared photolysis arrays
      
      Implicit None

C Functions:
      Integer, External :: indexn

C Local Variables:
      Character( 100 ) :: xmsg
      Character( 16 ), Allocatable, Save :: aename( : )
      Character( 16 ), Allocatable, Save :: cgrid2aq( : )
      Character( 10 ) :: bkground
      Integer :: igas
      Integer :: iaer
      Integer :: isrg
      Integer :: spc
      Integer :: mode
      Integer :: i
      Integer :: n
      Integer :: var
      Logical :: new
      Integer :: lsrg( mxsrg )
      Integer :: n_cgrid2aq
      Integer :: ios
C Local Variable used to determine what optional TX to add to surrogates
      !Logical :: found_all_modes
      !Integer :: n_missing_tx
      !Integer :: n_which_txadd( nadd_tx )

      Logical, Save :: Firstcall = .True.
      
C-----------------------------------------------------------------------


      If ( Firstcall ) Then
         Firstcall = .False.
      Else
         Return
      End if
 
      Call init_phot_shared()
      
      Allocate ( aename( n_ae_a2aq ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating aename'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

C...Build array of AE names that are mapped to AE_A2AQ
      Do spc = 1, n_ae_a2aq
         aename( spc ) = ae_spc( ae_a2aq_map( spc ) )
      End Do

C...Set number of species in CGRID and used in Aqueous module
      n_cgrid2aq = n_gc_g2aq + n_ae_a2aq + n_nr_n2aq + n_tr_t2aq

!     Allocate ( cgrid2aq( n_cgrid2aq ),
!    &           cgrid2aq_map( n_cgrid2aq ), stat = ios )
!     If ( ios .Ne. 0 ) Then
!        xmsg = '*** Error allocating cgrid2aq or cgrid2aq_map'
!        Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
!     End If

      Allocate ( cgrid2aq( n_cgrid2aq ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating cgrid2aq'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( cgrid2aq_map( n_cgrid2aq ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating cgrid2aq_map'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( cgrid2aq_name( n_cgrid2aq ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating cgrid2aq_name'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

C...Map aero species
      Call map_aero()

      naer = n_aerospc + naddaer + nadd_tx

      Allocate ( srgaer( naer ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating srgaer'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( nsrgaer( naer,nmodes ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating nsrgaer'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

      Allocate ( lsrgaer( naer,nmodes,mxsrg ), stat = ios )
      If ( ios .Ne. 0 ) Then
         xmsg = '*** Error allocating lsrgaer'
         Call m3exit( 'aq_data_init', 0, 0, xmsg, xstat3 )
      End If

C...Populate optional aerosol surrogate species (e.g.
C   TRACER_AITKEN, TRACER_ACCUM, TRACER_COARSE, 
C   PHG_AITKEN,    PHG_ACCUM,    PHG_COARSE     )
      Do spc = 1, nadd_tx
         srgaer( spc ) = srgaer_addtx( spc )
      End Do

C...Initialize aerosol surrogate species from AERO_DATA table
      Do var = 1, n_aerospc
         spc = nadd_tx + var
         srgaer( spc ) = sur_aer_type( (/' ',' ',' '/), 0.0, 0.0, 0.0 )

         ! Skip H2O, H2OP, and SOIL species
         If ( var .Eq. ah2o_idx .Or. var .Eq. ah3op_idx ) Then
              write(xmsg,'(4(A,1x))')'Skipping AQ surrogate for AEROSPC ',
     &                               aerospc( spc-nadd_tx )%name( 1:n_mode )
              Call m3warn( 'aq_data_init', 0, 0, xmsg )
              Cycle
         End if

         Do mode = 1, n_mode
            n = index1( aerospc( var )%name( mode ), n_ae_a2aq, aename )
            If ( n .Gt. 0 ) Then
               ! Verify that surrogate is new
               new = .True. 
               Do i = 1, spc
                  If ( ae_a2aq( n ) .Eq. srgaer( i )%name( mode ) ) Then
                     new = .False.; Exit
                  End If
               End Do
               If ( new ) Then
                  srgaer( spc )%name( mode ) = ae_a2aq( n )
                  srgaer( spc )%density = aerospc( var )%density
                  srgaer( spc )%molwt = aerospc_mw( var )
               End If
           End If
         End Do   ! mode
      End Do   ! spc

C...Initialize aerosol moment surrogates (i.e.
C   NUM_AITKEN, NUM_ACCUM, NUM_COARSE,
C   SRF_AITKEB, SRF_ACCUM, SRF_COARSE )
      Do n = 1, naddaer
         spc = n_aerospc + nadd_tx + n
         srgaer( spc ) = addsrgaer( n )
      End Do
   

#ifdef verbose_cloud
C...write out SRGGAS and SRGAER to verify
      Write( logdev, 1005 )ngas
      Do spc = 1, ngas
         Write( logdev,1007 ) srggas( spc )%name, srggas( spc )%backgnd
      End Do
      Write( logdev,1009 ) naer
      Do spc = 1, naer
         Write( logdev,1111 ) srgaer( spc )%name, srgaer( spc )%density,
     &                        srgaer( spc )%molwt, srgaer( spc )%backgnd
      End Do
#endif      

C...Prepare indices for aqueous species

C...CGRID map to aqueous species pointers for the gases
      spc = 0
      Do var = 1, n_gc_g2aq
         spc = spc + 1
         cgrid2aq( spc ) = gc_g2aq( var )
         cgrid2aq_map( spc ) = gc_g2aq_map( var ) + gc_strt - 1
         cgrid2aq_name( spc ) = gc_spc( gc_g2aq_map( var ) )
      End Do

C...CGRID map to aqueous species pointers for the aerosols
      Do var = 1, n_ae_a2aq
         spc = spc + 1
         cgrid2aq( spc ) = ae_a2aq( var )
         cgrid2aq_map( spc ) = ae_a2aq_map( var ) + ae_strt - 1
         cgrid2aq_name( spc ) = ae_spc( ae_a2aq_map( var ) )
      End Do

C...CGRID map to aqueous species pointers for the non-reactives
      Do var = 1, n_nr_n2aq
         spc = spc + 1
         cgrid2aq( spc ) = nr_n2aq( var )
         cgrid2aq_map( spc ) = nr_n2aq_map( var ) + nr_strt - 1
         cgrid2aq_name( spc ) = nr_spc( nr_n2aq_map( var ) )
      End Do

C...CGRID map to aqueous species pointers for the tracers
      Do var = 1, n_tr_t2aq
         spc = spc + 1
         cgrid2aq( spc ) = tr_t2aq( var )
         cgrid2aq_map( spc ) = tr_t2aq_map( var ) + tr_strt - 1
         cgrid2aq_name( spc ) = tr_spc( tr_t2aq_map( var ) )
      End Do

      write(logdev, 1114)
C...Create the pointers from CGRID to the gaseous species needed by AQCHEM
      nsrggas = 0
      Do igas = 1, ngas
         nsrggas( igas ) = indexn( srggas( igas )%name, n_cgrid2aq, cgrid2aq, lsrg )
         If ( nsrggas( igas ) .Eq. 0 ) Then
            Write ( bkground, '(F8.4)' ) srggas( igas )%backgnd
            xmsg = trim( srggas( igas )%name )
     &           // ' is not in GC or NR namelist so using background value of '
     &           // trim( bkground )
            Call m3mesg( xmsg )
         Else
            Do isrg = 1, nsrggas( igas )
               lsrggas( igas,isrg ) = lsrg( isrg )
#ifdef verbose_cloud
               write( logdev,1113 ) cgrid2aq_name( lsrggas( igas,isrg ) ),
     &         cgrid2aq_map( lsrggas( igas,isrg ) ), srggas( igas )%name,
     &         igas,lsrggas( igas,isrg )
#endif                  
            End Do
         End If
      End Do

C...Create the pointers from CGRID to the aerosol species needed by AQCHEM
      nsrgaer = 0
      write(logdev, 1114)
      Do iaer = 1, naer
         Do n = 1, nmodes
            If ( srgaer( iaer )%name( n ) .Ne. ' ' ) Then
               nsrgaer( iaer,n ) = indexn( srgaer( iaer )%name( n ), n_cgrid2aq,
     &                                     cgrid2aq, lsrg )
               If ( nsrgaer( iaer,n ) .Eq. 0 ) Then
                  Write ( bkground, '(f8.4)' ) srgaer( iaer )%backgnd
                  xmsg = trim( srgaer( iaer )%name( n ) )
     &           // ' is not in AE namelist so using background value of '
     &           // trim( bkground )
                  Call m3mesg( xmsg )
               Else
                  Do isrg = 1, nsrgaer( iaer,n )
                     If ( isrg .Gt. mxsrg ) Then
                        xmsg = 'lsrg will index out of bounds. Increase mxsrg in AQ_DATA.F'
                        Call m3exit( 'AQ_DATA', 0, 0, xmsg, xstat3 )
                     End If
                     lsrgaer( iaer,n,isrg ) = lsrg( isrg )
#ifdef verbose_cloud
                     write( logdev,1113 ) cgrid2aq_name( lsrgaer( iaer,n,isrg ) ),
     &               cgrid2aq_map( lsrgaer( iaer,n,isrg ) ), srgaer( iaer )%name( n ),
     &               iaer, lsrgaer( iaer,n,isrg )
#endif                  
                  End Do
               End If
            End If
         End Do
      End Do

C...Create the pointers for required gas surrogate species needed by AQCHEM
      lso2   = findSgrGas( req_so2 )    ! Sulfur Dioxide
      lhno3  = findSgrGas( req_hno3 )   ! Nitric Acid
      ln2o5  = findSgrGas( req_n2o5 )   ! Dinitrogen Pentoxide
      lco2   = findSgrGas( req_co2 )    ! Carbon Dioxide
      lnh3   = findSgrGas( req_nh3 )    ! Ammonia
      lh2o2  = findSgrGas( req_h2o2 )   ! Hydrogen Perioxide
      lo3    = findSgrGas( req_o3 )     ! Ozone
      lfoa   = findSgrGas( req_foa )    ! Formic Acid
      lmhp   = findSgrGas( req_mhp )    ! Methyl Hydrogen Peroxide
      lpaa   = findSgrGas( req_paa )    ! Peroxyacidic Acid
      lh2so4 = findSgrGas( req_h2so4 )  ! Sulfuric Acid
      lhcl   = findSgrGas( req_hcl )    ! Hydrogen Chloride
      lgly   = findSgrGas( req_gly )    ! Glyoxal
      lmgly  = findSgrGas( req_mgly )   ! Methylglyoxal
      lho    = findSgrGas( req_ho )     ! OH, hydroxyl radical

C...Create the pointers for required aerosol surrogate species needed by AQCHEM
      lso4   = findSgrAer( req_aso4 )    !  Sulfate
      lnh4   = findSgrAer( req_anh4 )    !  Ammonium
      lno3   = findSgrAer( req_ano3 )    !  Nitrate
      lsoa   = findSgrAer( req_asoa )    !  SOA
      lorgc  = findSgrAer( req_aorgc )   !  SOA (anthropogenic organic oligomers)
      lpoa   = findSgrAer( req_apoa )    !  Primary organic aerosol
      lec    = findSgrAer( req_aec )     !  Elemental carbon
      lpri   = findSgrAer( req_apri )    !  Primary aerosol (Aitken and Accumulation)
!     lpricor= findSgrAer( req_apric )   !  Primary aerosol (coarse)
      lna    = findSgrAer( req_ana )     !  Sodium
      lcl    = findSgrAer( req_acl )     !  Chloride ion
!     lcaco3 = findSgrAer( req_acaco3 )  !  Calcium Carbonate aerosol (place holder)
!     lmgco3 = findSgrAer( req_amgco3 )  !  Magnesium Carbonate aerosol (place holder)
!     la3fe  = findSgrAer( req_aa3fe )   !  Iron aerosol (place holder)
!     lb2mn  = findSgrAer( req_ab2mn )   !  Manganese aerosol (place holder)
!     lk     = findSgrAer( req_ak )      !  Potassium aerosol (Cl- tracked separately)
      lnum   = findSgrAer( req_num )     !  Number
      lsrf   = findSgrAer( req_srf )     !  Surface area
      lcaacc = findSgrAer( req_caacc )   !  Ca in Accumulation mode (AE6) SLN 16March2011
      lmgacc = findSgrAer( req_mgacc )   !  Mg in Accumulation mode (AE6) SLN 16March2011
      lkacc  = findSgrAer( req_kacc )    !  K in Accumulation mode (AE6)  SLN 16March2011
      lfeacc = findSgrAer( req_feacc )   !  Fe in Accumulation mode (AE6) SLN 22March2011
      lmnacc = findSgrAer( req_mnacc )   !  Mn in Accumulation mode (AE6) SLN 22March2011
      lsoilc = findSgrAer( req_soilc )   !  SOIL in Coarse mode  (AE6)    SLN 16March2011
      lanthc = findSgrAer( req_anthc )   !  CORS in Coarse mode  (AE6)    SLN 16March2011
      lseasc = findSgrAer( req_seasc )   !  SEAS in Coarse mode  (AE6)    SLN 16March2011
C...For TXHG version
      ltracer_akn    = findSgrAer( req_traceri  )   !  Tracer aitken mode 
      ltracer_acc    = findSgrAer( req_tracerj  )   !  Tracer accumation mode 
      ltracer_cor    = findSgrAer( req_tracerk  )   !  Tracer coarse mode 
      lphg_akn       = findSgrAer( req_phgi )       !  Mercuric aitken and accumulation modes
      lphg_acc       = findSgrAer( req_phgj )       !  Mercuric aitken and accumulation modes
      lphg_cor       = findSgrAer( req_phgk )       !  Mercuric coarse mode
C...For sulfur tracking model
      If ( stm ) Then
         lso4aqh2o2 = findSgrAer( req_aso4aqh2o2 ) ! Sulfate from aq H2O2 rxn
         lso4aqo3   = findSgrAer( req_aso4aqo3 )   ! Sulfate from aq O3 rxn
         lso4aqfemn = findSgrAer( req_aso4aqfemn ) ! Sulfate from aq rxn catalyzed by FE&MN
         lso4aqmhp  = findSgrAer( req_aso4aqmhp )  ! Sulfate from aq MHP rxn
         lso4aqpaa  = findSgrAer( req_aso4aqpaa )  ! Sulfate from aq PAA rxn
      End If

      mapped = .True.

#ifdef verbose_cloud
      Write( logdev,'( /5x, a )' ) 'AQCHEM gas surrogate species'
      Write( logdev,'( 5x, a, i4 )' ) 'lso2:   ', lso2
      Write( logdev,'( 5x, a, i4 )' ) 'lhno3:  ', lhno3
      Write( logdev,'( 5x, a, i4 )' ) 'ln2o5:  ', ln2o5
      Write( logdev,'( 5x, a, i4 )' ) 'lco2:   ', lco2
      Write( logdev,'( 5x, a, i4 )' ) 'lnh3:   ', lnh3
      Write( logdev,'( 5x, a, i4 )' ) 'lh2o2:  ', lh2o2
      Write( logdev,'( 5x, a, i4 )' ) 'lo3:    ', lo3
      Write( logdev,'( 5x, a, i4 )' ) 'lfoa:   ', lfoa
      Write( logdev,'( 5x, a, i4 )' ) 'lmhp:   ', lmhp
      Write( logdev,'( 5x, a, i4 )' ) 'lpaa:   ', lpaa
      Write( logdev,'( 5x, a, i4 )' ) 'lh2so4: ', lh2so4
      Write( logdev,'( 5x, a, i4 )' ) 'lhcl:   ', lhcl
      Write( logdev,'( 5x, a, i4 )' ) 'lgly:   ', lgly
      Write( logdev,'( 5x, a, i4 )' ) 'lmgly:  ', lmgly
      Write( logdev,'( 5x, a, i4 )' ) 'lho:    ', lho

      Write( logdev,'( /5x, a )' ) 'AQCHEM aer  osol surrogate species'
      Write( logdev,'( 5x, a, i4 )' ) 'lso4:     ', lso4
      Write( logdev,'( 5x, a, i4 )' ) 'lnh4:     ', lnh4
      Write( logdev,'( 5x, a, i4 )' ) 'lno3:     ', lno3
      Write( logdev,'( 5x, a, i4 )' ) 'lsoa:     ', lsoa
      Write( logdev,'( 5x, a, i4 )' ) 'lorgc:    ', lorgc
      Write( logdev,'( 5x, a, i4 )' ) 'lpoa:     ', lpoa
      Write( logdev,'( 5x, a, i4 )' ) 'lec:      ', lec
      Write( logdev,'( 5x, a, i4 )' ) 'lpri:     ', lpri
      Write( logdev,'( 5x, a, i4 )' ) 'lna:      ', lna
      Write( logdev,'( 5x, a, i4 )' ) 'lcl:      ', lcl
      Write( logdev,'( 5x, a, i4 )' ) 'lnum:     ', lnum
      Write( logdev,'( 5x, a, i4 )' ) 'lsrf:     ', lsrf
      Write( logdev,'( 5x, a, i4 )' ) 'lcaacc:   ', lcaacc
      Write( logdev,'( 5x, a, i4 )' ) 'lmgacc:   ', lmgacc
      Write( logdev,'( 5x, a, i4 )' ) 'lkacc:    ', lkacc
      Write( logdev,'( 5x, a, i4 )' ) 'lfeacc:   ', lfeacc
      Write( logdev,'( 5x, a, i4 )' ) 'lmnacc:   ', lmnacc
      Write( logdev,'( 5x, a, i4 )' ) 'lsoilc:   ', lsoilc
      Write( logdev,'( 5x, a, i4 )' ) 'lanthc:   ', lanthc
      Write( logdev,'( 5x, a, i4 )' ) 'lseasc:   ', lseasc
      Write( logdev,'( 5x, a, i4 )' ) 'ltracer_akn:  ', ltracer_akn
      Write( logdev,'( 5x, a, i4 )' ) 'ltracer_acc:  ', ltracer_acc
      Write( logdev,'( 5x, a, i4 )' ) 'ltracer_cor:  ', ltracer_cor
      Write( logdev,'( 5x, a, i4 )' ) 'lphg_akn:     ', lphg_akn
      Write( logdev,'( 5x, a, i4 )' ) 'lphg_acc:     ', lphg_acc
      Write( logdev,'( 5x, a, i4 )' ) 'lphg_cor:     ', lphg_cor
      If ( stm ) Then
         Write( logdev,'( 5x, a, i4 )' ) 'lso4aqh2o2:', lso4aqh2o2
         Write( logdev,'( 5x, a, i4 )' ) 'lso4aqo3:  ', lso4aqo3
         Write( logdev,'( 5x, a, i4 )' ) 'lso4aqfemn:', lso4aqfemn
         Write( logdev,'( 5x, a, i4 )' ) 'lso4aqmhp: ', lso4aqmhp
         Write( logdev,'( 5x, a, i4 )' ) 'lso4aqpaa: ', lso4aqpaa
      End If
#endif

      Write( logdev,'( / 5x, a / )' ) ' --- AQCHEM Gas and Aerosol Species Mapped ---'

C1005  Format( / "GASES" / "NGAS = ", i3 / "    name   "," backgrd" // )
C1007  Format( a16, 1x, f8.2 )
C1009  Format( / "AEROSOLS" / "NAER = ", i3 / "    name(1)   ", "    name(2)   ",
C     &        "    name(3)   ", " dens ", " backgrd" // )
C1111  Format( 3(a16,1x), f6.0, 2(1x, f8.2) )
C1113  Format( a16, 1x, i4, 1x, a16, 1x, i4, 1x, i4)     
1114  Format( / "   CGRID_SPC    ", 1x, "SPC ", 1x, "   SURROGATE   ", 1x, "ISRG", 1x, "IDX " )

      Return
      End Subroutine aq_data_init

C-----------------------------------------------------------------------
      Function findSgrGas( vname ) Result ( idx )

C  Finds the index of 'required' gas surrogate species in the srggas list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C-----------------------------------------------------------------------

      Use utilio_defn

      Implicit None

C Arguments:
      Character( 16 ) :: vname
      Integer idx

C Local Variables:
      Character( 80 ) :: xmsg
      Integer spc

      idx = 0
      Do spc = 1, ngas      
         If ( srggas( spc )%name .Eq. vname ) Then
            idx = spc
            ! Write( *,'(a,i5)' ) vname, idx
            Return
         End If
      End Do

      xmsg = 'Required Species ' // Trim( vname ) // ' Not found in SgrGas names array'
      Call m3exit( 'AQ_DATA', 0, 0, xmsg, xstat3 )

      Return
      End Function findSgrGas

C-----------------------------------------------------------------------
      Function findSgrAer( vname ) Result ( idx )

C  Finds the index of 'required' Aerosol surrogate species in the srgaer list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C-----------------------------------------------------------------------

      Use utilio_defn

      Implicit None

C Arguments:
      Character( 16 ) :: vname
      Integer idx

C Local Variables:
      Character( 80 ) :: xmsg
      Integer spc, n

      idx = 0
      Do spc = 1, naer
         Do n = 1, nmodes
            ! Write( *,'(a,i5)' ) vname, spc
            If ( srgaer( spc )%name( n ) .Eq. vname ) Then
               idx = spc
               ! Write( *,'(a,i5)' ) vname, idx
               Return
            End If
         End Do
      End Do

      xmsg = 'Required Species ' // Trim( vname ) // ' Not found in SgrAer names array'
      Call m3exit( 'AQ_DATA', 0, 0, xmsg, xstat3 )

      Return
      End Function findSgrAer

C-----------------------------------------------------------------------
      Subroutine set_aeconcmin( aeconcmin )
C-----------------------------------------------------------------------
C
C  Function:
C       set minimum concentrations for aerosol species
C       routine called from convcld_acm
C
C  Preconditions:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C  Revision History:
C       5/05 copied code from aero_depv to begin subroutine
C       4/08 J.Kelly: added code to set min for coarse surface area
C       21 Jun 10 J.Young: convert for Namelist redesign
C-----------------------------------------------------------------------

      Use cgrid_spcs            ! CGRID mechanism species
      Use aero_data
      Use utilio_defn

      Implicit None

C..Includes:
      Include SUBST_CONST               ! constants

C..Functions:

C..Arguments:
      Real, Intent( Out ) :: aeconcmin( : ) ! array of minimum concentrations

C..Local Variables:
      !Character( 16 ) :: pname = 'SET_AECONCMIN'   ! program name

      Integer m        ! mode loop counter
      Integer n        ! aerospc loop counter
      Integer spc      ! species loop counter


      ! compute minimums for numbers and surfaces

      Do m = 1, n_mode
         spc = index1( aeromode( m )%num_name, n_ae_spc, ae_spc )
         aeconcmin( spc ) = aeromode_minNum( m ) * mwair * 1.0E-3

         spc = index1( aeromode( m )%srf_name, n_ae_spc, ae_spc )
         aeconcmin( spc ) = aeromode_minM2( m ) * mwair * 1.0E-3
      End Do

      ! compute minimums for aerosol species
      Do m = 1, n_mode
         Do n = 1, n_aerospc
            If ( .NOT. aero_missing(n,m) ) Then
               spc = index1( aerospc( n )%name( m ), n_ae_spc, ae_spc )
               If ( spc .Ne. 0 ) Then
                  aeconcmin( spc ) = aerospc( n )%min_conc( m ) * mwair * 1.0E-9 / ae_molwt( spc )
               End If               
            End If
         End Do
      End Do 

      Return
      End Subroutine set_aeconcmin

      End Module aq_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module precursor_data

C  Defines gas phase aerosol precursor data.

C  Contains:
C     Subroutine extract_precursor
C     Subroutine map_precursor
C     Subroutine update_precursor
C     Function findPrecursor

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS  03/10/11 Made OH a required species
C    -added OH to "precursor" array (set rxncounter to .FALSE.);
C    -added "update" column to precursor array to note which species
C     concentrations will be affected by aerosol routines
C    -added req_OH and OH_idx variables
C    -changed precursor_conc to Real(8)

C H.Pye 05/22/11: added ALK5RXN to precursor list for SAPRC mechanisms
 
C JY  06/08/12 remove full character blank padding put in for GNU Fortran (GCC) 4.1.2
C H. Pye 09/2014: added alkane and PAH SOA precursor

C D.Wong  02/01/19 added one more variable in the USE clause
C-----------------------------------------------------------------------

      Implicit None

      Integer, Parameter :: n_precursor = 24   ! # of precursors

      Type precursor_type
         Character( 16 ) :: name               ! species name
         Logical         :: rxncounter         ! flag to reset counter species
         Logical         :: update             ! update precursor concentration
                                               ! in cgrid after aeroproc
         Logical         :: required           ! required for model run
      End Type precursor_type

      Type ( precursor_type ), Private :: precursor( n_precursor ) = (/
C                       Name    RxnCounter  Update  Required
C                    ---------   ---------- ------  ------
     & precursor_type( 'NO2    ', .False. , .True., .True.  ),
     & precursor_type( 'N2O5   ', .False. , .True., .True.  ),
     & precursor_type( 'HNO3   ', .False. , .True., .True.  ),
     & precursor_type( 'HONO   ', .False. , .True., .True.  ),
     & precursor_type( 'ISOPRXN', .True.  , .True., .False. ),
     & precursor_type( 'TRPRXN ', .True.  , .True., .False. ),
     & precursor_type( 'SULF   ', .False. , .True., .True.  ),
     & precursor_type( 'SULPRD ', .True.  , .True., .True.  ),
     & precursor_type( 'HCL    ', .False. , .True., .True.  ),
     & precursor_type( 'ALK5RXN', .True.  , .True., .False. ),
     & precursor_type( 'ALKRXN ', .True.  , .True., .False. ),
     & precursor_type( 'TOLNRXN', .True.  , .True., .False. ),
     & precursor_type( 'TOLHRXN', .True.  , .True., .False. ),
     & precursor_type( 'XYLNRXN', .True.  , .True., .False. ),
     & precursor_type( 'XYLHRXN', .True.  , .True., .False. ),
     & precursor_type( 'BNZNRXN', .True.  , .True., .False. ),
     & precursor_type( 'BNZHRXN', .True.  , .True., .False. ),
     & precursor_type( 'SESQRXN', .True.  , .True., .False. ),
     & precursor_type( 'NH3    ', .False. , .True.,  .True. ),
     & precursor_type( 'OH     ', .False. , .False., .True. ),
     & precursor_type( 'PAHNRXN', .True.  , .True., .False. ),
     & precursor_type( 'PAHHRXN', .True.  , .True., .False. ),
     & precursor_type( 'PCSOARXN',.True.  , .True., .False. ),
     & precursor_type( 'PHGRXN ', .True.  , .True., .False. )/)

C Required species
      Character( 16 ), Private, Parameter :: req_NO2    = 'NO2'
      Character( 16 ), Private, Parameter :: req_N2O5   = 'N2O5'
      Character( 16 ), Private, Parameter :: req_HNO3   = 'HNO3'
      Character( 16 ), Private, Parameter :: req_HONO   = 'HONO'
      Character( 16 ), Private, Parameter :: req_SULF   = 'SULF'
      Character( 16 ), Private, Parameter :: req_SULPRD = 'SULPRD'
      Character( 16 ), Private, Parameter :: req_HCL    = 'HCL'
      Character( 16 ), Private, Parameter :: req_NH3    = 'NH3'
      Character( 16 ), Private, Parameter :: req_OH     = 'OH'
      Character( 16 ), Private, Parameter :: req_PHGRXN = 'PHGRXN'

C Indices of required species
      Integer :: NO2_idx
      Integer :: N2O5_idx
      Integer :: HNO3_idx
      Integer :: HONO_idx
      Integer :: SULF_idx
      Integer :: SULPRD_idx
      Integer :: HCL_idx
      Integer :: NH3_idx
      Integer :: OH_idx
      Integer :: PHGRXN_idx

      Real( 8 ) :: precursor_mw( n_precursor )   ! mol wt from cgrid_spcs [g/mol]

      Real( 8 ) :: precursor_conc( n_precursor ) ! precursor concentration [ug/m^3]

      Real    :: so4rate                       ! sulfate gas-phase production rate [ug/m^3*s]
      Real    :: phg_rate                      ! particulate mercury gas-phase production rate [ug/m^3*s]

C Private variables for loading and unloading to CGRID array
      Integer          :: precursor_map( n_precursor )  ! pointers to CGRID
      Logical, Private, Save :: mapped          = .False.
      Logical, Private, Save :: Precursor_eflag = .False.

      Character( 16 ), Private, Save :: pname = 'precursor_data'

      Contains

C-----------------------------------------------------------------------
      Subroutine map_precursor()

C  Defines mapping from CGRID for species concentration and moments.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS  03/10/11 Changed vtmp to real(8)
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C----------------------------------------------------------------------

      Use rxns_data, only:  mechname
      Use aero_data, only: ae6hg, aphgj_idx
      Use cgrid_spcs, only: n_gc_g2ae, gc_g2ae, gc_g2ae_map, gc_molwt, gc_strt,
     &                      n_nr_n2ae, nr_n2ae, nr_n2ae_map, nr_molwt, nr_strt
      Use utilio_defn, only: index1, xstat3
      Use runtime_vars, only: logdev, LOG_MESSAGE

      Implicit None

C Local Variables:
      Character( 180 ) :: xmsg
      Integer          :: n
      Integer          :: spc

C If the species are mapped already, skip the mapping algorithm
      If ( mapped ) Return
      CALL LOG_MESSAGE( LOGDEV, 'Map SOA Precursors' )

C Initialize Precursor Map Variables
      precursor_mw = 0.0d0
      precursor_map = 0

C Build mapping to CGRID for each precursor species
      Do spc = 1, n_precursor
         n = index1( precursor( spc )%name, n_gc_g2ae, gc_g2ae )
         If ( n .Ne. 0 ) Then
            precursor_mw( spc ) = real( gc_molwt( gc_g2ae_map( n ) ), 8 )
            precursor_map( spc ) = gc_strt - 1 + gc_g2ae_map( n )
         Else
            n = index1( precursor( spc )%name, n_nr_n2ae, nr_n2ae )
            If ( n .Ne. 0 ) Then
               precursor_mw( spc ) = real( nr_molwt( nr_n2ae_map( n ) ), 8 )
               precursor_map( spc ) = nr_strt - 1 + nr_n2ae_map( n )
            Else
                If ( precursor( spc )%required ) Then
                  Precursor_eflag = .True.
                  xmsg = 'FATAL: Simulation requires a species in GC or NR namelist ' //
     &                   'to have its G2AE or N2AE value set to ' // Trim( precursor( spc )%name )
                  Call m3warn( 'map_precursor', 0, 0, xmsg )
                Else
                  write(logdev,99902)Trim( precursor( spc )%name )
                End If 
            End If
         End If
      End Do

C Find indices of required species
      NO2_idx    = findPrecursor( req_NO2,    .true.)
      N2O5_idx   = findPrecursor( req_N2O5,   .true.)
      HNO3_idx   = findPrecursor( req_HNO3,   .true.)
      HONO_idx   = findPrecursor( req_HONO,   .true.)
      SULF_idx   = findPrecursor( req_SULF,   .true.)
      SULPRD_idx = findPrecursor( req_SULPRD, .true.)
      HCL_idx    = findPrecursor( req_HCL,    .true.)
      NH3_idx    = findPrecursor( req_NH3,    .true.)
      OH_idx     = findPrecursor( req_OH,     .true.)
      If( ae6hg )then
         PHGRXN_idx = findPrecursor( req_phgrxn,  .false.)
         If(   precursor_map( PHGRXN_idx ) .Lt. 1  )Then
           xmsg = ' Gas Phase Precursor ' // Trim( req_PHGRXN )
     &         // ' not found -> NO gas production of APHG species'
           Call m3warn( 'map_precursor', 0, 0, xmsg )
         End If 
#ifdef verbose_aero
      Else 
         xmsg = ' NO particulate mercury in model.'
         Call m3warn( 'map_precursor', 0, 0, xmsg )
         PHGRXN_idx = 0
#endif
      end if

#ifdef verbose_aero
      Write( logdev,'( /5x, a )' ) 'map_precursor required species'
      Write( logdev,'( 5x, a, i4 )' ) 'NO2_idx:    ', NO2_idx
      Write( logdev,'( 5x, a, i4 )' ) 'N2O5_idx:   ', N2O5_idx
      Write( logdev,'( 5x, a, i4 )' ) 'HNO3_idx:   ', HNO3_idx
      Write( logdev,'( 5x, a, i4 )' ) 'HONO_idx:   ', HONO_idx
      Write( logdev,'( 5x, a, i4 )' ) 'SULF_idx:   ', SULF_idx
      Write( logdev,'( 5x, a, i4 )' ) 'SULPRD_idx: ', SULPRD_idx
      Write( logdev,'( 5x, a, i4 )' ) 'HCL_idx:    ', HCL_idx
      Write( logdev,'( 5x, a, i4 )' ) 'NH3_idx:    ', NH3_idx
      Write( logdev,'( 5x, a, i4 )' ) 'OH_idx:     ', OH_idx
      if( aphgj_idx .gt. 0 )then
          Write( logdev,'( 5x, a, i4 )' ) 'PHGRXN_idx:     ', PHGRXN_idx
      end if
#endif

      If( Precursor_eflag )Then
         Write(logdev,99901) Trim( mechname )
             xmsg = 'The FATAL errors found in namelist used. Check '
     &          //  'the log of exiting processor if more details are needed.'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If 

      mapped = .True.

99901 Format( 'FATAL error(s) found in the GC and/or NR namelists used. Check that '
     &     /  'these namelists contain the above required data as the respective files '
     &     /  'in the repository version of the mechanism: ' , a )
99902 Format( 5x,'Note: Optional species ', a, ' is not found in G2AE or N2AE values of',
     &    /   7x,'the GC or NR namelist. Simulation will ignore this species.' )

      Return
      End Subroutine map_precursor

C-----------------------------------------------------------------------
      Subroutine extract_precursor( conc )

C  Extracts the required precursor data from CGRID into conc.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C SH  03/10/11 Renamed met_data to aeromet_data
C HS  03/10/11 Changed vtmp and gasconv to real(8)
C-----------------------------------------------------------------------

      Use aeromet_data, only: airdens, inv_mwair, min_gasconc

      Implicit None

C Arguments:
      Real, Intent( In ) :: conc( : )

C Local Variables:
      Real( 8 )       :: gasconv       ! converts from [ppm] to [ug/m^3]
      Real( 8 )       :: vtmp
      Integer         :: n
      Integer         :: spc

      Call map_precursor()

C Compute gas conversion constant
      gasconv = Real( airdens * inv_mwair, 8 )

C Copy grid cell concentrations of precursor species
      precursor_conc = 0.0d0

      Do spc = 1, n_precursor
         n = precursor_map( spc )
         If ( n .Ne. 0 ) Then
            vtmp = gasconv * precursor_mw( spc )
            precursor_conc( spc ) = Max( Real( conc( n ), 8) * vtmp, Real( min_gasconc, 8) )
         End If
      End Do

      Return
      End Subroutine extract_precursor

C------------------------------------------------------------------------
      Subroutine update_precursor( conc )

C  Updates CGRID aerosol precursor values from the conc array.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C SH  03/10/11 Renamed met_data to aeromet_data
C HS  03/10/11 Only update conc for species with "update" = .TRUE.;
C    -changed vtmp and gasconv to real(8)
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      Use aeromet_data, only: airdens, inv_mwair, min_gasconc
      Use utilio_defn, only: xstat3
      Use aero_data, only : COND_BUDGET, COAG_BUDGET, NPF_BUDGET, GROWTH_BUDGET

      Implicit None

C arguments:
      Real, Intent( Out ) :: conc( : )

C local variables:
      Character( 80 ) :: xmsg
      Real( 8 )       :: gasconv       ! converts from [ppm] to [ug/m^3]
      Real( 8 )       :: vtmp
      Integer         :: n
      Integer         :: spc

      If ( .Not. mapped ) Then
         xmsg = 'CGRID Species has not been mapped'
         Call m3exit( 'update_precursor', 0, 0, xmsg, xstat3 )
      End If

C compute gas conversion constant
      gasconv = Real( airdens * inv_mwair, 8 )

C copy precursor_conc back to grid cell concentrations
      Do spc = 1, n_precursor
         n = precursor_map( spc )
         If ( n .Ne. 0 ) Then
            If ( precursor( spc )%update ) Then
               If ( precursor( spc )%rxncounter ) Then
                  conc( n ) = 0.0
               Else
                  vtmp = precursor_mw( spc ) * gasconv
                  conc( n ) = Max( real( precursor_conc( spc ) / vtmp, 4 ), min_gasconc  )
          
                  ! Convert Budget Process Numbers from ug m-3 to ppmv
                  ! for application to process analysis and ISAM
                  COND_BUDGET( n )   = COND_BUDGET( n )   / vtmp
                  COAG_BUDGET( n,: ) = COAG_BUDGET( n,: ) / vtmp
                  NPF_BUDGET( n )    = NPF_BUDGET( n )    / vtmp
                  GROWTH_BUDGET( n ) = GROWTH_BUDGET( n ) / vtmp
               End If
            End If
         End If
      End Do

      Return
      End Subroutine update_precursor

C-----------------------------------------------------------------------
      Function findPrecursor( vname, required ) Result ( ndx )

C  Finds the index of 'required' aerosol species in the precursor list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

      Implicit None

C Arguments:
      Character( * ) :: vname
      Logical        :: required
      
      Integer ndx

C Local Variables:
      Integer         :: spc
      Character( 80 ) :: xmsg

      ndx = 0
      
      Do spc = 1, n_precursor
         If ( Index( precursor( spc )%name, trim(vname) ) .Gt. 0 ) Then
            ndx = spc
            Return
         End If
      End Do

      xmsg = 'FATAL: ' // Trim( vname )
     &    // ' is not found in the G2AE or N2AE values of GC or NR namelists'
      Precursor_eflag  = .True.
      Call m3warn( pname, 0, 0, xmsg )

      Return
      End Function findPrecursor

      End Module precursor_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE CHEM( CGRID, JDATE, JTIME, TSTEP )
C**********************************************************************
C
C  FUNCTION: Driver subroutine for Euler Backward Iterative solver
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED:  HRINIT, HRCALCKS, HRSOLVER
C                                     FIND_DEGRADED, INIT_DEGRADE, FINAL_DEGRADE
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C                       Based on the algorithm in "Test of Two Numerical
C                       Schemes for Use in Atmospheric Transport-Chemistry
C                       Models", O. Hertel, R. Berkowicz, J. Christensen,
C                       and O. Hov, Atm Env., Vol. 27A, No. 16, 1993.
C                       Original MEBI code developed by Ho-Chun Huang,
C                       SUNY, Albany -- "On the performance of numerical
C                       solvers for a chemistry submodel in three-dimensional
C                       air quality models 1. Box model simulations",
C                       H. Huang and J.S. Chang, JGR, Vol 106, No. D17, 2001.
C                       This version replaces Huang and Chang use of numerical
C                       solutions with analytical solutions derived in
C                       Hertel et al.
C   21 Jun 10 J.Young: convert for Namelist redesign
C   11 May 11 D.Wong: incorporated twoway model implementation
C   27 Sep 11 B.Hutzell: revised method for defining CALL_DEG variable
C   18 Jul 14 B.Hutzell: revised: 1) to use the RXNS_DATA and RXNS_FUNCTION
C                        modules instead of include files, 2) to enable
C                        reactions between species types, 3) to calculate
C                        heterogeneous rate constants via AEROSOL_CHEMISTRY
C                        module, 4) to replace call to HRCALCKS with
C                        subroutine in RXNS_FUNCTION module and 5) to change
C                        how degrade routines are used, if present
C   02 Dec 14 B.Hutzell: 1) added terrestrial data to conduct surface
C                        dependent reactions and 2) modified the call CALC_RCONST
C                        routine
C   01 Feb 19 D.Wong:    Implemented centralized I/O approach, removed all MY_N
C                        clauses
C   27 Dec 19 S.Napelenok: DDM-3D implementation for version 5.3.1
C**********************************************************************

      USE HGRD_DEFN             ! horizontal domain specifications
      USE VGRD_DEFN             ! vertical layer specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN           ! IOAPI parameters and functions declarations
      USE RXNS_DATA
      USE AEROSOL_CHEMISTRY
      USE RXNS_FUNCTION
#ifdef isam
      USE SA_IRR_DEFN
      USE SA_DEFN
#endif
      USE HRDATA
      USE PHOT_MOD, Only: INIT_PHOT_SHARED, RJ     ! photolysis rate, in-line module
      USE PA_DEFN, Only: LIRR                      ! Process Analysis control and data variable
      USE PA_IRR_CLT
      USE DEGRADE_SETUP_TOX, ONLY : N_REACT, RXTANT_MAP
      USE CENTRALIZED_IO_MODULE, ONLY : INTERPOLATE_VAR, OCEAN, SZONE

#ifdef sens
      USE DDM3D_CHEM
      Use DDM3D_DEFN, Only: DATENUM, STARTDATE, IPT, IDATE, HIGH, NP, NPMAX, CKTIME
#endif 


      IMPLICIT NONE

C..Includes:
      INCLUDE SUBST_FILES_ID  ! CMAQ files
      INCLUDE SUBST_CONST     ! CMAQ constants

      INCLUDE SUBST_EMISPRM   ! Emissions processing control parameters

C..Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )  ! Species concentrations
      INTEGER JDATE           ! Current date (YYYYDDD)
      INTEGER JTIME           ! Current time (HHMMSS)
      INTEGER TSTEP( 3 )      ! Time step vector (HHMMSS)

C..Parameters:
      REAL( 8 ), PARAMETER :: DCONMIN = 1.0D-30               ! minimum species concentration allowed
      REAL,      PARAMETER :: CONCMIN = 1.0E-30               ! minimum species concentration allowed
      REAL,      PARAMETER :: MAOMV   = 1.0E6 * MWAIR / MWWAT ! Mol Wt of air over Mol Wt of water times 1.0E6

C..External Functions:


C..Saved Local Variables:

      CHARACTER( 16 ), SAVE :: PNAME = 'HRDRIVER'     ! Program name

      INTEGER, SAVE :: ISTFL            ! Unit no. of iteration stat output file
      LOGICAL, SAVE :: LFIRST = .TRUE.  ! Flag for first call to this subroutine

      REAL( 8 ), SAVE :: PA2ATM   ! Pascal to atm conv fac

C..Scratch Local Variables:
      CHARACTER( 132 ) :: MSG           ! Message text
      CHARACTER(  16 ) :: VNAME         ! Name of I/O API data variable

      INTEGER C, E, L, R, S   ! Loop indices
      INTEGER ISP             ! array index

      INTEGER AVGEBI          ! Average no. of EBI iterations
      INTEGER DELT_SEC        ! EBI max time step in seconds
      INTEGER ESP             ! Loop index for emissions species
      INTEGER ITMSTEP         ! Chemistry integration interval (sec)
      INTEGER LEV             ! Layer index
      INTEGER MIDDATE         ! Date at time step midpoint
      INTEGER MIDTIME         ! Time at time step midpoint
      INTEGER NPH             ! Index for number of phot. rxns in PHOT
      INTEGER SPC             ! Species loop index
#ifdef hrstats
      INTEGER MNEBI           ! Min no. of EBI iterations
      INTEGER MXEBI           ! Max no. of EBI iterations
#endif

      LOGICAL LSUNLIGHT       ! Flag for sunlight

      REAL       INV_DENS     ! reciprocal of air mass density, m3/Kg
#ifdef hrstats
      REAL       SUMEBI       ! Sum of EBI iterations
#endif

      REAL( 8 )  CHEMSTEP     ! Chemistry integration interval (min)

      INTERFACE
        SUBROUTINE HRSOLVER( JDATE, JTIME, C, R, L )
           INTEGER, INTENT( IN ) :: JDATE    ! Current date (YYYYDDD)
           INTEGER, INTENT( IN ) :: JTIME    ! Current time (HHMMSS)
           INTEGER, INTENT( IN ) :: C, R, L  ! Cell col, row, lev
        END SUBROUTINE HRSOLVER
         SUBROUTINE FIND_DEGRADED( JDATE, JTIME, CALL_DEGRADE )
           INTEGER, INTENT( IN )  :: JDATE        ! current model date , coded YYYYDDD
           INTEGER, INTENT( IN )  :: JTIME        ! current model time , coded HHMMSS
           LOGICAL, INTENT( OUT ) :: CALL_DEGRADE ! whether to call degradation routines
         END SUBROUTINE FIND_DEGRADED
         SUBROUTINE INIT_DEGRADE( CBLK, TCELL, DCELL, PHOTO_CELL, JDATE, JTIME )
           REAL( 8 ), INTENT( IN ) :: CBLK( : )       !  species concentration in cell
           REAL,      INTENT( IN ) :: TCELL           !  cell temperature  [ k ]
           REAL,      INTENT( IN ) :: DCELL           !  cell air density  [ kg/m^3 ]
           REAL( 8 ), INTENT( IN ) :: PHOTO_CELL( : ) !  Photolysis table for cell [1/s]
           INTEGER,   INTENT( IN ) :: JDATE  ! current model date , coded YYYYDDD
           INTEGER,   INTENT( IN ) :: JTIME  ! current model time , coded HHMMSS
         END SUBROUTINE INIT_DEGRADE
         SUBROUTINE FINAL_DEGRADE( CBLK )
           REAL( 8 ), INTENT( INOUT ) :: CBLK( : )    !  species concentration in cell
         END SUBROUTINE FINAL_DEGRADE
        SUBROUTINE HETCHEM_UPDATE_AERO( CGRID )
           REAL, POINTER :: CGRID( :,:,:,: )  !  species concentration in cell
        END SUBROUTINE HETCHEM_UPDATE_AERO
      END INTERFACE

C**********************************************************************

      IF( NUMB_MECH_SPC .EQ. 0 ) RETURN

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  On first call, call routines to set-up for EBI solver
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF( LFIRST ) THEN

         IF( MECHNAME .NE. 'CB6R3_AE7_AQ' ) THEN
             MSG = 'This version of the EBI solver can only be used with'
     &            // ' the CB6R3_AE7_AQ chemical mechanism'
             CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
         END IF

#ifdef emis_chem
         EMISVD = .FALSE.
#else
         EMISVD = .TRUE.
#endif

         IF( INDEX( MECHNAME, 'AE' ) .NE. 0 ) THEN
           L_AE_VRSN = .TRUE.
         ELSE
           L_AE_VRSN = .FALSE.
         END IF

         IF( INDEX( MECHNAME, 'AQ' ) .NE. 0 ) THEN
           L_AQ_VRSN = .TRUE.
         ELSE
           L_AQ_VRSN = .FALSE.
         END IF

         IF( LIRR ) THEN
            CALL_IRR = .TRUE.
         ELSE
            CALL_IRR = .FALSE.
         END IF

         MODEL_SPECIES = NSPCSD    ! WTH: find number of model species

! Determine whether DEGRADE rountines are needed.

         CALL FIND_DEGRADED( JDATE, JTIME, CALL_DEG )
         IF( CALL_DEG )THEN
            WRITE(LOGDEV,*)'TX DEGRADE ROUTINES USED'
            WRITE(LOGDEV,*)'Mechanism contains degraded species'
#ifdef verbose_gas
         ELSE
            WRITE(LOGDEV,*)'TX DEGRADE ROUTINES OMITTED'
            WRITE(LOGDEV,*)'MECHANISM does not include degraded species'
#endif
         END IF

         CALL HRINIT

         ITMSTEP = TIME2SEC( TSTEP( 2 ) )
         CHEMSTEP = REAL( ITMSTEP, 8 ) / 60.0D0
         WRITE( LOGDEV, 92000 ) CHEMSTEP, DELTAT

         WRITE( LOGDEV, 92020 )
         DO SPC = 1, NUMB_MECH_SPC
            WRITE( LOGDEV, 92040 ) CHEMISTRY_SPC( SPC ), RTOL( SPC )
         END DO

         PA2ATM =  REAL( 1.0 / STDATMPA, 8)

c..If emissions processing requested stop
         IF( .NOT. EMISVD ) THEN  ! assumes emis processing in gas chem

            MSG = 'ERROR: EBI solver not configured to '//
     &            'process emissions in chemistry'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )

         END IF   ! End if doing emissions


#ifdef hrstats
         ISTFL = JUNIT()
         OPEN( UNIT=ISTFL, FILE='iterstat.dat' )
         WRITE( ISTFL, 94020 )
#endif
C Define processor offsets

         PECOL_OFFSET = COLSD_PE( 1, MYPE+1 ) - 1
         PEROW_OFFSET = ROWSD_PE( 1, MYPE+1 ) - 1

         ALLOCATE( LAND_ZONE( NCOLS, NROWS ) )
         DO R = 1, NROWS
            DO C = 1, NCOLS
               IF( OCEAN( C,R ) + SZONE( C,R ) .GT. 0.0 )THEN
                   LAND_ZONE( C,R ) = .FALSE.
               ELSE
                   LAND_ZONE( C,R ) = .TRUE.
               END IF
             END DO
         END DO

         ALLOCATE( DENS( NCOLS, NROWS, NLAYS ), PRES( NCOLS, NROWS, NLAYS ),
     &             QV  ( NCOLS, NROWS, NLAYS ), TA  ( NCOLS, NROWS, NLAYS ),
     &             SEAICE( NCOLS, NROWS ) )

C..Initialize shared photolysis data
         CALL INIT_PHOT_SHARED()

C..Determine which cells need IRR
         ALLOCATE( LFLAGIRR ( NCOLS, NROWS, NLAYS ) )
         CALL      PA_IRR_CKCELLS ( LFLAGIRR )

#ifdef isam
        NUMB_ISAM_CELLS = 1.0D0 / ( NCOLS * NROWS * NLAYS )
        CALL SA_IRR_INIT
#endif
         LFIRST = .FALSE.

#ifdef sens
         CALL INIT_DDM3D_CHEM()

C For higher order sensitivities
         IF ( HIGH ) THEN
            DO RXN = 1, NRXNS
               IF( NREACT( RXN ) .EQ. 1 ) THEN
                  ORDER1( RXN ) = .TRUE.
               ELSE
                  ORDER1( RXN ) = .FALSE.
               END IF
            END DO
         END IF
#endif

      END IF      ! First time

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Set date and time to center of time step, get necessary physical
C  data
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      MIDDATE = JDATE
      MIDTIME = JTIME
      ITMSTEP = TIME2SEC( TSTEP( 2 ) )
      CHEMSTEP = REAL( ITMSTEP, 8 ) / 60.0D0
      CALL NEXTIME( MIDDATE, MIDTIME, SEC2TIME( ITMSTEP / 2 ) )

C.. Compute number of time step loops and step size for EBI solver
      DELT_SEC = INT( DELTAT * 60.0D0 + 0.1D0 )
      IF( DELT_SEC .GE. ITMSTEP ) THEN
         N_EBI_STEPS = 2
         EBI_TMSTEP  = 0.5D0 * CHEMSTEP
      ELSE
         IF( MOD( ITMSTEP, DELT_SEC ) .EQ. 0 ) THEN
            N_EBI_STEPS = ITMSTEP / DELT_SEC
         ELSE
            N_EBI_STEPS = ITMSTEP / DELT_SEC + 1
         END IF
         EBI_TMSTEP =  CHEMSTEP / REAL( N_EBI_STEPS, 8 )
      END IF

      N_INR_STEPS = 1


C.. Get fractional seaice coverage from the METCRO2D file.

      CALL INTERPOLATE_VAR ('SEAICE', MIDDATE, MIDTIME, SEAICE)

C.. Get ambient temperature in K

      CALL INTERPOLATE_VAR ('TA', MIDDATE, MIDTIME, TA)

C.. Get specific humidity in Kg H2O / Kg air
      CALL INTERPOLATE_VAR ('QV', MIDDATE, MIDTIME, QV)

! Get ambient MASS DENSITY in Kg/m^3
      CALL INTERPOLATE_VAR ('DENS', MIDDATE, MIDTIME, DENS)

C.. Get pressure in Pascals
      CALL INTERPOLATE_VAR ('PRES', MIDDATE, MIDTIME, PRES)

C.. Get Heteorogeneous rates and Update Aerosol Distribution Properties
      CALL HETCHEM_RATES( TA, PRES, QV, CGRID, DENS )

#ifdef sens
      DATENUM = 1 + JDATE - STARTDATE !  Set the date and hour counters used in sensitivity calls

C For reaction rate sensitivities
      DO NP = 1, NPMAX
         IF ( IPT( NP ) .EQ. 5 ) THEN
            CALL CKTIME( JDATE,JTIME,NP,RXNFLAG(NP) ) ! Rxnflag set to true iff ipt=5 and time, date within bounds
            IF ( IDATE( NP, DATENUM ) .NE. 1 ) RXNFLAG( NP ) = .FALSE.
         ELSE
            RXNFLAG( NP ) = .FALSE.
         END IF
      END DO

C For higher order sensitivities
c     IF ( HIGH ) THEN
c        DO RXN = 1, NRXNS
c           IF( NREACT( RXN ) .EQ. 1 ) THEN
c              ORDER1( RXN ) = .TRUE.
c           ELSE
c              ORDER1( RXN ) = .FALSE.
c           END IF
c        END DO
c     END IF
#endif sens



ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Top of loop over cells
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

#ifdef hrstats
      MNEBI = 1000
      MXEBI = 0
      SUMEBI = 0.0
#endif

      NCELL = 1

      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS

c..reset CALL_IRR based on cell's values
               CALL_IRR = LFLAGIRR( C,R,L )

c..Load ICs
               INV_DENS = 1.0 / DENS( C,R,L )
               DO SPC = 1, NUMB_MECH_SPC
                  S = CGRID_INDEX( SPC )
                  IF( CONVERT_CONC( SPC ) )THEN
                      YC( SPC ) = REAL( MAX( CONCMIN,
     &                            INV_DENS*FORWARD_CONV( SPC )*CGRID( C,R,L,S )), 8 )
                  ELSE
                      YC( SPC ) = REAL( MAX( CGRID( C,R,L,S ), CONCMIN), 8 )
                  END IF
               END DO

               IF(CALL_DEG)THEN ! INITIALIZE degradation routines

                  YCCELL = 0.0D0
                  DO S = 1, MODEL_SPECIES
                     YCCELL( S ) = REAL( CGRID(C,R,L,S), 8)
                  END DO
                  CALL INIT_DEGRADE(YCCELL,TA(C,R,L),DENS(C,R,L),RJIN(NCELL,:),
     &                              JDATE, JTIME)
               END IF

c..Set physical quantities
               TEMP( NCELL )     = REAL( TA( C,R,L ), 8)
               DENSITY( NCELL )  = REAL( DENS( C,R,L ), 8)
!                PRESCELL( NCELL ) = REAL( PRES( C,R,L ), 8)
               ATMPRES( NCELL )  = PA2ATM * REAL( PRES( C,R,L ), 8)
               H2O( NCELL )      = REAL( MAX ( MAOMV * QV( C,R,L ), 0.0 ), 8)

               IF( LAND_ZONE( C,R ) .OR. SEAICE ( C,R ) .GT. 0.0 )THEN
                   LAND (NCELL) = .TRUE.
               ELSE
                   LAND (NCELL) = .FALSE.
               END IF

c..Get rate constants
               LSUNLIGHT = .FALSE.
               FORALL( NPH = 1:NPHOTAB ) RJIN( NCELL,NPH ) = REAL( RJ( C,R,L,NPH ), 8)
               IF( MAXVAL(RJIN) .GT. 0.0D0 ) LSUNLIGHT = .TRUE.

               FORALL ( NPH = 1:NHETERO )HET( NCELL,NPH ) = REAL( KHETERO( NPH,C,R,L ), 8)

               CALL CALC_RCONST( TEMP, ATMPRES, H2O, RJIN, HET, LSUNLIGHT, LAND, RKI_SAV, NCELL )
               FORALL( NPH = 1:NRXNS )RKI( NPH ) = RKI_SAV( NCELL, NPH )

#ifdef isam
#if defined(isam) || defined(verbose_isam)
C...For diagnosing IRR calculations in log files
                IF( CHECK_ISAM )THEN
                   WRITE_CELL = .FALSE.
                   IF( C .EQ. MAX(1, NCOLS/2) .AND. R .EQ. MAX(1,NROWS/2) .AND. L .EQ. 1 )THEN
                        WRITE_CELL = .TRUE.
                        WRITE(LOGDEV,*)'WRITE_CELL = .TRUE.'
                   ELSE
                        WRITE_CELL = .FALSE.
                   END IF
                END IF
#endif
               CALL SA_IRR_EXTRACT( C, R, L, DENS( C,R,L ),YC )
#endif

c..Call EBI solver
               N_EBI_IT = 0

               CALL HRSOLVER( JDATE, JTIME, C, R, L )

#ifdef hrstats
               MXEBI  = MAX( MXEBI, N_EBI_IT )
               MNEBI  = MIN( MNEBI, N_EBI_IT )
               SUMEBI = SUMEBI + REAL( N_EBI_IT )
#endif


c..Update concentration array
               DO SPC = 1, NUMB_MECH_SPC
                  S = CGRID_INDEX( SPC )
                  IF( CONVERT_CONC( SPC ) )THEN
                      CGRID( C,R,L,S ) = REAL( REVERSE_CONV( SPC ) * DENS( C,R,L )
     &                                 * MAX( YC( SPC ), DCONMIN), 4)
                  ELSE
                      CGRID( C,R,L,S ) = REAL( MAX( YC( SPC ), DCONMIN), 4)
                  END IF
               END DO

               IF(CALL_DEG)THEN  ! WTH: update based on degrade routines
                  CALL FINAL_DEGRADE(YCCELL)
                  UPDATE_DEGRADED: DO SPC = 1, N_REACT
                     ISP = RXTANT_MAP( SPC )
                     IF( ISP .LE. 0 )CYCLE UPDATE_DEGRADED
                     DO S = 1, NUMB_MECH_SPC
                        IF(  CGRID_INDEX( S ) .EQ. ISP )CYCLE UPDATE_DEGRADED
                     END DO
                     CGRID(C,R,L,ISP) = REAL( YCCELL(ISP), 4)
                  END DO UPDATE_DEGRADED
               END IF

#ifdef isam
               CALL SA_IRR_UPLOAD( C, R, L, DENS( C,R,L ), YC )
#endif

c..update irrout arrays if needed
               IF ( LFLAGIRR( C,R,L ) )CALL PA_IRR_CELLENDF( C, R, L )

#ifdef sens
               DO RXN = 1, NRXNS
                  SRK( RXN ) = RKI( RXN )
                  IF ( HIGH ) THEN
                     IF ( ORDER1 (RXN ) ) THEN
                        SRK2( RXN ) = 0.0
                     ELSE
                        SRK2( RXN ) = RKI( RXN )
                     END IF
                  END IF
               END DO


               CALL SOLVE_DDM3D_CHEM( C,R,L,CHEMSTEP )
#endif

            END DO
         END DO
      END DO

!  Update Aerosol Surface Area
      CALL HETCHEM_UPDATE_AERO( CGRID )

#ifdef hrstats
      AVGEBI = SUMEBI / REAL( NCOLS * NROWS * NLAYS )
      WRITE( ISTFL, 94040 ) JDATE, JTIME, MNEBI, AVGEBI, MXEBI
#endif

      RETURN

C*********************** FORMAT STATEMENTS ****************************

92000 FORMAT( / 10X, 'Euler Backward Iterative Parameters -'
     &        / 10X, 'Chemistry Integration Time Interval (min):', F12.4,
     &        / 10X, 'EBI maximum time step (min):              ', F12.4 )

92020 FORMAT( //10X, 'Species convergence tolerances:' )

92040 FORMAT(   10X, A16, 2X, 1PE12.2 )

92060 FORMAT( / 10X, 'Emissions Processing in Chemistry ...'
     &        / 10X, 'Number of Emissions Layers:         ', I3
     &        / 10X, 'out of total Number of Model Layers:', I3 )


94020 FORMAT( 'DATE      TIME ', 'MNEBI AVEBI MXEBI' )

94040 FORMAT( I7, 1X, I6, 1X, 3( I5, 1X ) )
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! Revision history: 01 Feb, 19 D. Wong: Implemented centralized I/O approach, 
!                                       removed all MY_N clauses

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      MODULE PHOT_MET_DATA

         IMPLICIT NONE

         REAL, ALLOCATABLE :: QC( :,:,: )  ! cloud water content [kg/kg]
         REAL, ALLOCATABLE :: QR( :,:,: )  ! rain water content [kg/kg]
         REAL, ALLOCATABLE :: QI( :,:,: )  ! ice content [kg/kg]
         REAL, ALLOCATABLE :: QS( :,:,: )  ! snow content [kg/kg]
         REAL, ALLOCATABLE :: QG( :,:,: )  ! graupel content [kg/kg]
         REAL, ALLOCATABLE :: QV( :,:,: )  ! water vapor content [kg/kg]
           
         REAL, ALLOCATABLE :: CFRAC_3D( :,:,: ) ! 3D fractional cloud coverage
         REAL, ALLOCATABLE :: CFRAC_2D( :,: )   ! layer averaged 3D fractional cloud coverage
         REAL, ALLOCATABLE :: AVE_HYDROMETEORS( :,: ) ! Cloud Hydrometeor Content averaged over cloudy layers, [g/m3]

! properties of ACM unresolved cloud
         LOGICAL           :: USE_ACM_CLOUD = .TRUE.
           
         REAL, ALLOCATABLE :: ACM_CFRAC( :,:,: )   ! total fractional cloud coverage
         REAL, ALLOCATABLE :: ACM_QC   ( :,:,: )   ! cloud water content [kg/kg]
         REAL, ALLOCATABLE :: ACM_QR   ( :,:,: )   ! rain water content [kg/kg]
         REAL, ALLOCATABLE :: ACM_QI   ( :,:,: )   ! ice content [kg/kg]
         REAL, ALLOCATABLE :: ACM_QG   ( :,:,: )   ! graupel content [kg/kg]
         REAL, ALLOCATABLE :: ACM_CLOUDS ( :,: )   ! subgrid cloud fractions averaged over cloudy layer
         REAL, ALLOCATABLE :: ACM_AVE_H2O( :,: )   ! subgrid cloud water content averaged over cloudy layer, [g/m3]

         REAL, ALLOCATABLE :: COSINE_ZENITH( :,: ) ! cosine of solar zenith angle
           
         REAL, ALLOCATABLE :: DENS   ( :,:,: )     ! air density [Kg/m **3]
         REAL, ALLOCATABLE :: TA     ( :,:,: )     ! air temperature [K]
         REAL, ALLOCATABLE :: PRES   ( :,:,: )     ! air pressure [Pa]
         REAL, ALLOCATABLE :: ZM     ( :,:,: )     ! layer half height agl [m]
         REAL, ALLOCATABLE :: ZFULL  ( :,:,: )     ! layer full height agl [m]
          
         REAL              :: DIST_TO_SUN          ! solar distance [au]

! public variables:
         PUBLIC :: QC, QR, QI, QS, QG, QV,
     &             CFRAC_2D, CFRAC_3D, AVE_HYDROMETEORS,
     &             USE_ACM_CLOUD, ACM_CFRAC, ACM_QC, ACM_QR, ACM_QI, ACM_QG,
     &             ACM_CLOUDS, ACM_AVE_H2O,
     &             COSINE_ZENITH,
     &             DENS, TA, PRES, ZM, ZFULL, DIST_TO_SUN

! public procedures:
         PUBLIC :: GET_PHOT_MET, UPDATE_SUN, CLEAR_ACM_CLOUD, 
     &             CAPTURE_ACM_CLOUD
           
         PRIVATE

         INTEGER           :: HYDROMETEORS ! denotes mix of hydrometeors available
!        value   cloud water  rain       ice        snow     graupel
!          1        x          x
!          2        x          x          x          x
!          3        x          x          x          x          x

         REAL, ALLOCATABLE :: CFRAC   ( :,: )      ! total fractional cloud coverage
         REAL, ALLOCATABLE :: DELTA_Z( :,:,: )     ! layer thickness [m]

! flags for hydrometeors available on file:
!        LOGICAL           :: QV_AVAIL       = .TRUE.   ! QV (vapor)
!        LOGICAL           :: QC_AVAIL       = .TRUE.   ! QC (liquid)
!        LOGICAL           :: QR_AVAIL       = .TRUE.   ! QR (rain)
!        LOGICAL           :: QI_AVAIL       = .TRUE.   ! QI (ice)
!        LOGICAL           :: QS_AVAIL       = .TRUE.   ! QS (snow)
!        LOGICAL           :: QG_AVAIL       = .TRUE.   ! QG (graupel)
!        LOGICAL           :: CFRAC_3D_AVAIL = .TRUE.   ! CFRAC_3D

         LOGICAL           :: FIRSTIME = .TRUE. ! flag for first pass thru

         CHARACTER( 16 )   :: VARNM            ! variable name for IOAPI to get
         CHARACTER( 16 )   :: VNAME_RN
         CHARACTER( 300 )  :: XMSG = ' '       ! Exit status message

         INTEGER           :: LDATE             ! last jdate MET data updated
         INTEGER           :: LTIME             ! last jtime MET data updated
         INTEGER           :: STDATE            ! jdate MET module initiated
         INTEGER           :: STTIME            ! jtime MET module initiated
         INTEGER           :: ACM_DATE = -1     ! last date routine called
         INTEGER           :: ACM_TIME = -1     ! last time routine called
          
         INTEGER           :: GXOFF, GYOFF      ! global origin offset from file

         REAL, ALLOCATABLE :: SINLATS( :,: ) ! sine of latitude
         REAL, ALLOCATABLE :: COSLATS( :,: ) ! cosine of latitude
         REAL              :: STRTHR         ! starting GMT hour

         LOGICAL           :: SET_ACM_ARRAYS = .TRUE.

         CONTAINS 
       
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE INIT_PHOT_MET( JDATE, JTIME )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
         USE CENTRALIZED_IO_MODULE

         IMPLICIT NONE

!...........Includes:

         INCLUDE SUBST_CONST                ! constants
         INCLUDE SUBST_FILES_ID             ! file name parameters
       
!...........Inputs:       

         INTEGER, INTENT( IN ) :: JDATE     ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME     ! current model time, coded HHMMSS
       
!...........Local:
         INTEGER               :: COL       ! column loop counter
         INTEGER               :: ROW       ! row loop counter
         INTEGER               :: ASTAT     ! memory allocation status

         CHARACTER( 16 )       :: PNAME = 'INIT_PHOT_MET' 
       
         LOGICAL,  SAVE        :: INITIALIZED = .FALSE.
       
         IF ( INITIALIZED ) RETURN
       
         INITIALIZED = .TRUE.
       
! set up variables for calculating cosine of solar zenith angle

         ALLOCATE ( SINLATS( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SINLATS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( COSLATS( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating COSLATS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
                SINLATS( COL,ROW ) = SIN( PI180 * LAT ( COL,ROW ) )
                COSLATS( COL,ROW ) = COS( PI180 * LAT ( COL,ROW ) )
             END DO
         END DO

         ALLOCATE ( COSINE_ZENITH( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating COSINE_ZENITH'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( CFRAC( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CFRAC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( DENS( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DENS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( TA( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating TA'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( PRES( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating PRES'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( ZM( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ZM'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( ZFULL( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ZFULL'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( DELTA_Z( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DELTA_Z'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( QV( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QV'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( QC( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QC'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( QR( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QR'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         HYDROMETEORS = 1   ! always cloud water and rain

! test for which optional hydrometeors are available
! For WRF/MCIP: if GQ is available, all hydrometeors are available
!               else if QI or QS is available, QC and QR are available

         IF ( QG_AVAIL ) THEN
            HYDROMETEORS = 3
         ELSE
            WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &           'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &           'in the Meteorological Model did not include graupel.  If',
     &           'it did, then you need to reprocess the meteorological data',
     &           'through MCIP and pass QG to file ',
     &           TRIM( MET_CRO_3D ), ' to avoid',
     &           'errors in the photolysis simulation.'
            WRITE( LOGDEV, '((/5X,A),/)' )
     &           'Processing will continue with QG set to ZERO.  <<--<<'
            IF ( QI_AVAIL ) THEN
               HYDROMETEORS = 2
            ELSE
               WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &              'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &              'in the Meteorological Model did not include ice/snow.  If',
     &              'it did, then you need to reprocess the meteorological data',
     &              'through MCIP and pass QI to file ',
     &              TRIM( MET_CRO_3D ), ' to avoid',
     &              'errors in the photolysis simulation.'
               WRITE( LOGDEV, '((/5X,A),/)' )
     &              'Processing will continue with QI set to ZERO.  <<---<<'
            END IF
         END IF

         ALLOCATE ( QG( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QG'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF        
         QG = 0.0
        
         ALLOCATE ( QI( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QI'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         QI = 0.0

         ALLOCATE ( QS( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         QS = 0.0

         IF ( SET_ACM_ARRAYS .AND. USE_ACM_CLOUD ) THEN
            CALL INIT_ACM_CLOUD( 0, 0 )
            SET_ACM_ARRAYS = .FALSE.
         END IF

         IF ( .NOT. CFRAC_3D_AVAIL ) THEN
            XMSG = 'Variable CFRAC_3D (cloud fraction) not found in ' // MET_CRO_3D
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            WRITE( LOGDEV, * )
            WRITE( XMSG, '(4A)' )
     &           'Model will diagnose layer cloud fraction using Randall (1995) ',
     &           'and Hong (1998), based on mixing ratios of water vapor and its ',
     &           'condensed states. You may want to reprocess the meteorological ',
     &           'data to obtain layer cloud fractions if possible.'
            CALL LOG_MESSAGE( LOGDEV, XMSG )

         END IF
        
         ALLOCATE ( CFRAC_3D( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CFRAC_3D'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         CFRAC_3D = 0.0

         ALLOCATE ( CFRAC_2D( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CFRAC_2D'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( AVE_HYDROMETEORS( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating AVE_HYDROMETEORS'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

! report out hydrometeors found
         SELECT CASE( HYDROMETEORS )
            CASE( 1 )
                 WRITE( LOGDEV,2021 ) TRIM( PNAME ), "QC and QR"
            CASE( 2 )
                 WRITE( LOGDEV,2021 ) TRIM( PNAME ), "QC, QR, QI and QS"
            CASE( 3 )
                 WRITE( LOGDEV,2021 ) TRIM( PNAME ), "QC, QR, QG, QI and QS"
         END SELECT        
2021     FORMAT( /10X, A, ": Cloud has ", A )
        
         LDATE  = 0
         LTIME  = 0

         STDATE = JDATE
         STTIME = JTIME
         STRTHR = FLOAT( JTIME / 10000 )

         FIRSTIME = .FALSE.
        
         END SUBROUTINE INIT_PHOT_MET

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_PHOT_MET( JDATE, JTIME, MDATE, MTIME )
        
         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN         ! IO routines & utilties
         USE CENTRALIZED_IO_MODULE

         IMPLICIT NONE

!  REVISION  HISTORY:
!  B.Hutzell Oct 13, 2015 Changed computation of effective resolved fraction, CFRAC_2D,
!             to be consisitent with random cloud overlap model that in used in the 
!             radiative transfer calculation. Consult Tain and Curry (1989), JGR, vol.94,
!             9925-9935 for more information.
!...........Includes:

         INCLUDE SUBST_CONST                ! constants
         INCLUDE SUBST_FILES_ID             ! file name parameters

         INTEGER, INTENT( IN ) :: JDATE     ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME     ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: MDATE     ! date for calculation/interpolation(yyyyddd)
         INTEGER, INTENT( IN ) :: MTIME     ! time for calculation/interpolation (hhmmss)

!..........Local:

         CHARACTER( 16 ), SAVE :: PNAME =  'GET_PHOT_MET'
        
         INTEGER               :: COL       ! column loop counter
         INTEGER               :: ROW       ! row loop counter
         INTEGER               :: LAY       ! layer loop counter
        
         INTEGER               :: ASTAT           ! allocation status measure
        
         REAL                  :: SUM_WEIGHTS
         REAL                  :: WEIGHT
         REAL                  :: WATER
       
       
         IF ( FIRSTIME ) THEN
            CALL INIT_PHOT_MET( JDATE, JTIME )
         END IF

!...store met file time, date, and step information and compute
!...  the met timestep in hours

         IF ( LDATE .EQ. MDATE .AND. LTIME .EQ. MTIME ) RETURN
        
         LDATE = MDATE
         LTIME = MTIME

!...  Interpolate time dependent layered input variables

         VARNM = 'ZH' ! midlayer height
         call interpolate_var (VARNM, mdate, mtime, ZM)

         VARNM = 'ZF' ! full layer height
         call interpolate_var (VARNM, mdate, mtime, ZFULL)

!...Get air density (kg/m3)

         VARNM = 'DENS'
         call interpolate_var (VARNM, mdate, mtime, DENS)

!...get temperature [K]

         VARNM = 'TA'
         call interpolate_var (VARNM, mdate, mtime, TA)
 
!...pressure [Pa]

         VARNM = 'PRES'
         call interpolate_var (VARNM, mdate, mtime, PRES)

!...Get resolved cloud fractions

         VARNM = 'CFRAC'
         call interpolate_var (VARNM, mdate, mtime, CFRAC)

!...Get resolved water vapor mixing ratio (kg H2O / kg air)

         VARNM = 'QV'
         call interpolate_var (VARNM, mdate, mtime, QV)

!...Get resolved cloud water mixing ratio (kg H2O / kg air)
         VARNM = 'QC'
         call interpolate_var (VARNM, mdate, mtime, QC)

!...Get resolved rain water mixing ratio (kg H2O / kg air)
         VARNM = 'QR'
         call interpolate_var (VARNM, mdate, mtime, QR)

         IF ( QG_AVAIL ) THEN
!...read resolved graupel and the other hydrometeor mixing ratios (kg H2O / kg air)
!...from the met file if available
            VARNM = 'QG'
            call interpolate_var (VARNM, mdate, mtime, QG)

!...read resolved ice and snow mixing ratios (kg H2O / kg air)
            VARNM = 'QI'
            call interpolate_var (VARNM, mdate, mtime, QI)

            VARNM = 'QS'
            call interpolate_var (VARNM, mdate, mtime, QS)

         ELSE IF ( QI_AVAIL ) THEN
!...read resolved ice and snow mixing ratios (kg H2O / kg air) from the met
!...from the met file if available
            VARNM = 'QI'
            call interpolate_var (VARNM, mdate, mtime, QI)

            VARNM = 'QS'
            call interpolate_var (VARNM, mdate, mtime, QS)

         END IF
         
! floor values of QC, QR, QI, QS, and QG to zero

         IF ( QG_AVAIL ) THEN
            DO LAY = 1, NLAYS
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     QC( COL,ROW,LAY ) = MAX( QC( COL,ROW,LAY ), 0.0 )
                     QR( COL,ROW,LAY ) = MAX( QR( COL,ROW,LAY ), 0.0 )
                     QI( COL,ROW,LAY ) = MAX( QI( COL,ROW,LAY ), 0.0 )
                     QS( COL,ROW,LAY ) = MAX( QS( COL,ROW,LAY ), 0.0 )
                     QG( COL,ROW,LAY ) = MAX( QG( COL,ROW,LAY ), 0.0 )
                  END DO
               END DO
            END DO
         ELSE IF ( QI_AVAIL ) THEN
            DO LAY = 1, NLAYS
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     QC( COL,ROW,LAY ) = MAX( QC( COL,ROW,LAY ), 0.0 )
                     QR( COL,ROW,LAY ) = MAX( QR( COL,ROW,LAY ), 0.0 )
                     QI( COL,ROW,LAY ) = MAX( QI( COL,ROW,LAY ), 0.0 )
                     QS( COL,ROW,LAY ) = MAX( QS( COL,ROW,LAY ), 0.0 )
                  END DO
               END DO
            END DO
         ELSE
            DO LAY = 1, NLAYS
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     QC( COL,ROW,LAY ) = MAX( QC( COL,ROW,LAY ), 0.0 )
                     QR( COL,ROW,LAY ) = MAX( QR( COL,ROW,LAY ), 0.0 )
                  END DO
               END DO
            END DO
         END IF

         DO ROW = 1, NROWS 
            DO COL = 1, NCOLS
               DELTA_Z( COL,ROW,1 ) = ZFULL( COL,ROW,1 )
               FORALL ( LAY = 2:NLAYS )
                  DELTA_Z( COL,ROW,LAY ) = ZFULL( COL,ROW,LAY ) - ZFULL( COL,ROW,LAY-1 )
               END FORALL
            END DO
         END DO

         IF ( CFRAC_3D_AVAIL ) THEN  ! read from file
            VARNM = 'CFRAC_3D'
            call interpolate_var (VARNM, mdate, mtime, CFRAC_3D)
 
         ELSE  ! diagnose CFRAC_3D from available data

            CALL CAL_CFRAC_3D()

         END IF

! compute averages for resolved cloud                

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
               SUM_WEIGHTS = 0.0
               CFRAC_2D( COL,ROW ) = 1.0
               AVE_HYDROMETEORS( COL,ROW ) = 0.0
               DO LAY = 1, NLAYS
                  IF ( CFRAC_3D( COL,ROW,LAY ) .LE. 0.0 ) CYCLE
                  WEIGHT = DELTA_Z( COL,ROW,LAY ) 
                  CFRAC_2D( COL,ROW ) = CFRAC_2D( COL,ROW )
     &                                * ( 1.0 - CFRAC_3D( COL,ROW,LAY ) )
                  SUM_WEIGHTS = SUM_WEIGHTS + WEIGHT

                  WATER = QC( COL,ROW,LAY ) + QR( COL,ROW,LAY ) + QI( COL,ROW,LAY )
     &                  + QS( COL,ROW,LAY ) + QG( COL,ROW,LAY )

                  AVE_HYDROMETEORS( COL,ROW ) = AVE_HYDROMETEORS( COL,ROW )
     &                                        + DENS( COL,ROW,LAY ) * WATER * WEIGHT
#ifdef phot_debug     
                  if ( cfrac_2d( col,row ) .ne. cfrac_2d( col,row ) .or.
     &                 sum_weights .ne. sum_weights ) then
                     write( logdev,"(a,2es12.4)" ) "WEIGHT, CFRAC_3D = ",
     &                                             weight, cfrac_3d( col,row,lay ) 
                     xmsg = 'Floating point exception for CFRAC_2D'
                     call m3exit ( pname, jdate, jtime, xmsg, xstat1 )
                  end if
#endif              
               END DO
               IF ( SUM_WEIGHTS .LT. 1.0 ) THEN 
                    CFRAC_2D( COL,ROW ) = 0.0
               ELSE
                    CFRAC_2D( COL,ROW ) = 1.0 - CFRAC_2D( COL,ROW )
                    AVE_HYDROMETEORS( COL,ROW ) = 1.0E+3 * AVE_HYDROMETEORS( COL,ROW ) / SUM_WEIGHTS
               END IF
            END DO
         END DO

         IF ( USE_ACM_CLOUD ) THEN ! compute averages for subgrid clouds                
            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  SUM_WEIGHTS  = 0.0
!                 ACM_CLOUDS( COL,ROW )  = 0.0
                  ACM_AVE_H2O( COL,ROW ) = 0.0
                  DO LAY = 1, NLAYS
                     IF ( ACM_CFRAC( LAY,COL,ROW ) .LE. 0.0 ) CYCLE
                     WEIGHT      = DELTA_Z( COL,ROW,LAY ) 
                     SUM_WEIGHTS = SUM_WEIGHTS + WEIGHT
! acm clouds do not contain snow
                     WATER = ACM_QC( LAY,COL,ROW ) + ACM_QI( LAY,COL,ROW ) 
     &                     + ACM_QG( LAY,COL,ROW ) + ACM_QR( LAY,COL,ROW )  

! assume acm cloud is uniform or constant if it does not equal zero so set in  
! subroutine CAPTURE_ACM_CLOUD
!                    ACM_CLOUDS( COL,ROW ) = ACM_CLOUDS( COL,ROW )
!     &                                    + WEIGHT * ACM_CFRAC( LAY,COL,ROW ) 

                     ACM_AVE_H2O( COL,ROW ) = ACM_AVE_H2O( COL,ROW )
     &                                      + DENS( COL,ROW,LAY ) * WEIGHT * WATER
                  END DO
                  IF ( SUM_WEIGHTS .LT. 1.0 ) CYCLE
!                    ACM_CLOUDS( COL,ROW )  = ACM_CLOUDS( COL,ROW ) / SUM_WEIGHTS
                     ACM_AVE_H2O( COL,ROW ) = 1.0E+3 * ACM_AVE_H2O( COL,ROW ) / SUM_WEIGHTS
               END DO
            END DO
         END IF

         END SUBROUTINE GET_PHOT_MET

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE UPDATE_SUN( JDATE, JTIME, MDATE, MTIME )

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN         ! IO routines & utilties
         USE CENTRALIZED_IO_MODULE
  
         IMPLICIT NONE     
          
!***include files

         INCLUDE SUBST_CONST      ! physical constants
           
! Inputs:  
         INTEGER, INTENT( IN ) :: JDATE            ! current model date, coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME            ! current model time, coded HHMMSS
         INTEGER, INTENT( IN ) :: MDATE            ! date for calculation/interpolation(yyyyddd)
         INTEGER, INTENT( IN ) :: MTIME            ! time for calculation/interpolation (hhmmss)

! Local:
         INTEGER, SAVE         :: PDATE = 0        ! previous date called (yyyyddd)
         INTEGER, SAVE         :: PTIME = 0        ! previous time called (hhmmss)
         INTEGER               :: COL              ! column loop counter
         INTEGER               :: ROW              ! row loop counter

         REAL                  :: SINDEC           ! sine of the solar declination
         REAL                  :: COSDEC           ! cosine of the solar declination
         REAL                  :: JYEAR            ! year
         REAL                  :: JDAY             ! current Julian day (DDD)
         REAL                  :: EQUATION_OF_TIME ! equation of time
         REAL                  :: CURRHR           ! current GMT hour
         REAL                  :: CURRHR_LST       ! local standard time at each grid cell
        
         REAL, PARAMETER       :: ONE_OVER_15   = 1.0 / 15.0
         REAL, PARAMETER       :: ONE_OVER_3600 = 1.0 / 3600     

         IF ( FIRSTIME ) CALL INIT_PHOT_MET( JDATE, JTIME )

         IF ( PDATE .EQ. JDATE .AND. PTIME .EQ. JTIME ) RETURN
        
         PDATE = JDATE
         PTIME = JTIME
   
! Compute distance to sun and set solar declination variables

         JDAY   = FLOAT( MOD( JDATE, 1000 ) )
         JYEAR  = FLOAT( JDATE / 1000  )        

         CURRHR = STRTHR
     &          + FLOAT( SECSDIFF( STDATE, STTIME, MDATE, MTIME ) )
     &          * ONE_OVER_3600

         CALL SOLEFM3 ( JYEAR, JDAY, EQUATION_OF_TIME, SINDEC, COSDEC, DIST_TO_SUN )
        
         DO ROW = 1, NROWS
            DO COL = 1, NCOLS

!...correct  CURRHR for current *positive* West longitude convention
!...to obtain LST.
!...this convention on longititude should be reexamined for different domains

               CURRHR_LST = CURRHR + LON( COL,ROW ) * ONE_OVER_15

               CALL GETZEN2 ( CURRHR_LST , SINLATS( COL,ROW ), COSLATS( COL,ROW ),
     &                        SINDEC, COSDEC, EQUATION_OF_TIME, 
     &                        COSINE_ZENITH( COL,ROW ) )

#ifdef verbose_update_sun
               if ( row .eq. 1 .and. col .eq. 1 ) then
                  write(logdev,"(a,3es12.4)") "PHT: JYEAR, JDSTRT, SOLDIST = ",
     &                                        jyear, jday, dist_to_sun
                  write(logdev,"(a,7es12.4)") "PHT: CURRHR_LST, SINLAT, COSLAT, " //
     &                                        "SINDEC, COSDEC, EQT, COSZEN = ",
     &                                         currhr_lst , sinlats( col,row ),
     &                                         coslats( col,row ), sindec, cosdec,
     &                                         equation_of_time, cosine_zenith( col,row )
               end if
#endif            

            END DO
         END DO
               
         END SUBROUTINE UPDATE_SUN

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE SOLEFM3 ( YEAR, DAY, EQT, SINDEC, COSDEC, SOLDIST )

C-----------------------------------------------------------------------
C  This subroutine calculates the sine and cosine of the solar
C     declination and the equation of time, and solar distance
C     using an approximation to equations used to generate the
C     tables in  The Astronomical Almanac.
 
C  input:
C     year = year (e.g. 1998)
C     day  = day of the year (e.g. Feb. 2 is 33)
C     lat  = latitude in degrees (north is positive)
C     long = longitude in degrees (east is positive)
 
C  output:
C     EQT    = Equation of Time
C     sindec = sine of the solar declination
C     cosdec = cosine of the solar declination
C     soldist = distance of sun in astronomical units

C  Revision history:
C  FSB Coded September 9, 2004 by Dr. Francis S. Binkowski
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
 
C  REFERENCE:The code is a modification of that  from
C     J.J. Michalsky, The Astronomical Almanac`s algorithm for
C     approximate solar position (1950-2050)
C     Solar Energy vol. 40, No. 3, pp 227-235, 1988.
C     who based it upon
C     The Astronomical Almanac, U.S. Gov`t. Printing Office,
C     Washington DC. Page c24 has the algorithm
 
C  The stated accuracy is 0.01 degree for the epoch ( 1950 - 2050).
C-----------------------------------------------------------------------

         IMPLICIT NONE

!***arugments

         REAL, INTENT( IN )  :: YEAR, DAY
         REAL, INTENT( OUT ) :: EQT, SINDEC, COSDEC, SOLDIST

!***include files

         INCLUDE SUBST_CONST      ! physical constants

!***parameters

! from SUBST_CONST:   REAL, PARAMETER :: PI = 3.1415927
         REAL, PARAMETER :: TWOPI = 2.0 * PI
! from SUBST_CONST:   REAL, PARAMETER :: PI180   = PI / 180.0
         REAL, PARAMETER :: RAD   = PI180
         REAL, PARAMETER :: RADM1 = 1.0 / RAD

!***FSB inline documentation defines the variables.

         REAL    :: DELTA, LEAP, JD, TIME, L, G, LAMDA, EPSILON
         REAL    :: ALPHA
         REAL    :: SING, SIN2G, COSG, COS2G
         REAL(8) :: NUM, DEN

!***start code
!***get current julian date, jd
!***  the offset year of 1949 is for convenience of having all
!***  positive numbers for the epoch (1950 - 2050)

         DELTA = YEAR - 1949.0
         LEAP  = AINT( DELTA / 4.0 )

!***jd = 32916.5 + 365.0 * delta + leap + hour / 24.0
!***set hour = 12.0 and 12.0 / 24.0 -> 0.5

         JD = 2432916.5 + 365.0 * DELTA + LEAP + DAY + 0.5

!***first number is jd for midnight 0 Jan 1949
!***  leap is leap days since 1949.

!***  calculate ecliptic conditions:

         TIME = JD - 2451545.0     ! 51545.0 is noon Jan 1, 2000

!***calculate mean solar longitude (L)

         L = 280.460 + 0.985674 * TIME ! mean solar longitude

!***now force L to be between 0.0 and 360. degrees

         L = MODULO( L, 360.0 )
         IF ( L .lt. 0.0 ) L = L + 360.0

!***calculate mean anomaly (g) in radians between 0 and twopi

         G = 357.528 + 0.9856003 * TIME
         G = MODULO( G, 360.0 )
         IF ( G .LT. 0.0 ) G = G + 360.0

         G = RAD * G    ! in radians now

!***calculate trig functions of g using identities
!***  this speeds up the calculations

         SING = SIN( G )
         COSG = COS( G )
         SIN2G = 2.0 * SING * COSG
         COS2G = COSG * COSG - SING * SING

!***calculate ecliptic longitude ( Lamda) and
!***  obliquity (epsilon) of ecliptic in radians

         LAMDA = L +  1.915 * SING  + 0.020 * SIN2G
         LAMDA = MODULO( LAMDA, 360.0 )
         IF ( LAMDA .LT. 0.0 ) LAMDA = LAMDA + 360.0

!***calculate obliquity (epsilon)

         EPSILON = 23.429 - 4.0E-7 * TIME
         LAMDA   = RAD * LAMDA    ! in radians
         EPSILON = RAD * EPSILON  ! in radians

!***now calculate right ascension (Alpha) Use this method to get the
!***  correct quadrant.

         NUM = REAL( COS( EPSILON ) * SIN( LAMDA ), 8 ) ! numerator
         DEN = REAL( COS( LAMDA ), 8 )                  ! denominator
         ALPHA = REAL( ATAN( NUM / DEN ), 4)

!***force right ascension to be between 0 and twopi

         IF ( DEN .LT. 0.0D0 ) THEN
            ALPHA = ALPHA + PI
         ELSE IF ( NUM .LT. 0.0D0 ) THEN
            ALPHA = ALPHA + TWOPI
         END IF

!***Alpha = atan2(num,den)
!***  Alpha = MOD(Alpha, 360.0)
!***  IF ( Alpha .lt. 0.0)  Alpha = Alpha + 360.0

         ALPHA = RADM1 * ALPHA     ! Alpha now in degrees

!***calculate the sine of the declination
!***  (sindec) cosine of the declination (cosdec)

         SINDEC = SIN( EPSILON ) * SIN( LAMDA )
         COSDEC = SQRT( 1.0 - SINDEC * SINDEC )

!***calculate the Equation of Time( EQT) in degrees.

         EQT = L - ALPHA
         IF ( EQT .GT. 350.0 ) EQT = EQT - 360.0 ! catch a problem

!***calculate solar distance

         SOLDIST = 1.00014 - 0.01671 * COSG - 0.00014 * COS2G

         RETURN
         END SUBROUTINE SOLEFM3

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GETZEN2 ( TIME, SINLAT, COSLAT, SINDEC, COSDEC, EQT,
     &                        COSZEN )
C-----------------------------------------------------------------------
C  calculate the zenith angle information at the present time step
 
C  input:
C     time    = LST in decimal hours <<NOTE: LST
C     sinlat  = sine of the latitude
C     coslat  = cosine of the latitude
C     sindec  = sine of the solar declination
C     cosdec  = cosine of the solar declination
C     EQT     = equation of time in degrees
 
C  Output:
C     coszen  = cosine of the zenith angle
 
C  Revision history:
C     FSB Coded September 10, 2004 by Dr. Francis S. Binkowski
C     FSB modified February 15, 2005 to increase efficiency
C     Environmental Modeling for Policy Development group,
C     The Carolina Environmental Program
C     The University of North Carolina-Chapel Hill
C     Email: frank_binkowski@unc.edu
 
C  Note: because this routine will be called frequently
C     during a simulation, the sines and cosines of the
C     latitude should be calculated once at the beginning of
C     simulation.
C-----------------------------------------------------------------------

         IMPLICIT NONE

!***include files

         INCLUDE SUBST_CONST      ! physical constants

!***arguments

         REAL, INTENT( IN )  :: TIME, SINLAT, COSLAT
         REAL, INTENT( IN )  :: SINDEC, COSDEC, EQT
         REAL, INTENT( OUT ) :: COSZEN

!***internal variables

         REAL HANGLE          ! local hour angle in degrees

! from SUBST_CONST:  REAL, PARAMETER :: PI = 3.1415927
! from SUBST_CONST:  REAL, PARAMETER :: PI180 = PI / 180.0
         REAL, PARAMETER :: RAD = PI180

         HANGLE = 15.0 * ( TIME - 12.0 )  + EQT
         COSZEN = SINDEC * SINLAT + COSLAT * COSDEC * COS( RAD * HANGLE )

!***do not allow zenith angle to be lower than 1 degree (COSZEN = 0.999998)
!***when COSZEN is 1.0, gas-phase chemistry solver does not work properly 
         COSZEN = MIN( COSZEN, 0.999998 )

         RETURN
         END SUBROUTINE GETZEN2        

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE CAL_CFRAC_3D ()

!---------------------------------------------------------------------
! DESCRIPTION:
! Compute cloud fraction from input ice and cloud water fields
! if provided.
!
! Whether QI or QC is active or not is determined from the indices of
! the fields into the 4D scalar arrays in WRF. These indices are 
! P_QI and P_QC, respectively, and they are passed in to the routine
! to enable testing to see if QI and QC represent active fields in
! the moisture 4D scalar array carried by WRF.
! 
! If a field is active its index will have a value greater than or
! equal to PARAM_FIRST_SCALAR, which is also an input argument to 
! this routine.
!
! References:
! 1) Randall, D. A. (1995), Parameterizing fractional cloudiness produced
!    by cumulus entrainment. Preprints, Workshop on Cloud Microphysics
!    Parameterizations in Global Atmospheric Circulation
!    Models, Kananaskis, AB, Canada, WMO, 1–16.
! 2) Xu, K. And D.A. Randall (1996), A semiempircal cloudiness 
!    parameterization for use in climate models, J. Atm. Sci., vol 53(21),
!    pp 3084-3102.
! 3) Hong et al. (1998). Implementation of Prognostic Cloud Scheme for a
!    Regional Spectral Model. Monhtly Weather Review, vol. 126, pp 2621-
!    2639.
! Routine copied from module_radiation_driver.F in WRF 3.5 and modified for
! CMAQ applications (Bill Hutzell), Revised somewhat by J. Young Nov,2014
!---------------------------------------------------------------------

         USE GRID_CONF           ! horizontal & vertical domain specifications
         USE UTILIO_DEFN         ! IO routines & utilties
         USE CENTRALIZED_IO_MODULE

         IMPLICIT NONE

! includes:
         INCLUDE SUBST_CONST     ! physical and mathematical constants

! arguments:

!  Local:
         INTEGER :: I, J, K   ! loop counters
          
         REAL    :: RHUM       ! relative humidty   (fraction)
         REAL    :: TC         ! temp               (degrees Celuis)
         REAL    :: ESW        ! water vapor liquid saturaturion vapor pressure (Pa)
         REAL    :: ESI        ! water vapor ice saturaturion vapor pressure (Pa)
         REAL    :: QVSW       ! water vapor saturation mixing ratio (Kg/Kg)
         REAL    :: QVSI       ! water ice saturation mixing ratio (Kg/Kg) 
         REAL    :: QVS_WEIGHT ! weighted average of liquid and ice mixing ratios
         REAL    :: DENOM      ! scratch varaible
         REAL    :: ARG        ! scratch varaible
         REAL    :: SUBSAT     ! scratch varaible
         REAL, ALLOCATABLE, SAVE :: QCLD  ( :,:,: ) ! cloud water mixing ratio
         REAL, ALLOCATABLE, SAVE :: WEIGHT( :,:,: ) ! weighting factor between liquid and ice content
         REAL    :: WHT        ! intermediate weighting factor
         INTEGER :: ASTAT      ! memory allocation status
         LOGICAL, SAVE :: FRSTCALL = .TRUE.

! Parameters:
! Used for saturation mixing ratio weighted based on fractions of water and ice. 
! Following:
!   Murray, F.W. 1966. ``On the computation of Saturation Vapor Pressure,'
!   J. Appl. Meteor.,  6, p. 204.
! For saturation vapor pressure for each water phase
! es (in mb) = 6.1078exp[ a(T-273.16)/ (T-b) ], 1 mb = 100 Pa
!     over water   over ice  
! a = 17.2693882   21.8745584
! b = 35.86         7.66 
!        REAL, PARAMETER :: SVP1  =   0.61078
         REAL, PARAMETER :: SVP1  = 610.78      ! [ Pa ]
         REAL, PARAMETER :: SVP2  =  17.2693882
         REAL, PARAMETER :: SVP3  =  35.86
         REAL, PARAMETER :: SVPI2 =  21.8745584
         REAL, PARAMETER :: SVPI3 =   7.66
!        REAL, PARAMETER :: SVPT0 = 273.15  STDTEMP in CONST.EXT
!        REAL, PARAMETER :: R_D   = 287.0   RDGAS in CONST.EXT
!        REAL, PARAMETER :: R_V   = 461.6   RWVAP in CONST.EXT
         REAL, PARAMETER :: SVPT0 = STDTEMP
         REAL, PARAMETER :: R_D   = RDGAS
         REAL, PARAMETER :: R_V   = RWVAP
         REAL, PARAMETER :: EP_2  = R_D / R_V
!-----------------------------------------------------------------------
!---  Parameters for GRID-SCALE CLOUD COVER FOR RADIATION
!     (modified by Ferrier, Feb '02)
!
!---  Cloud fraction parameterization follows Randall, 1994
!     (see Hong et al., 1998)
!-----------------------------------------------------------------------
         REAL, PARAMETER :: ALPHA0  = 1.0E+02
         REAL, PARAMETER :: GAMMA   = 0.49
         REAL, PARAMETER :: QCLDMIN = 1.0E-12
         REAL, PARAMETER :: PEXP    = 0.25
         REAL, PARAMETER :: RHGRID  = 1.0
   
         IF ( FRSTCALL ) THEN
            FRSTCALL = .FALSE.
            ALLOCATE ( QCLD  ( NCOLS,NROWS,NLAYS ),
     &                 WEIGHT( NCOLS,NROWS,NLAYS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating QCLD or WEIGHT'
               CALL M3EXIT ( 'CAL_CFRAC_3D', 0, 0, XMSG, XSTAT1 )
            END IF
         END IF

! Alternative calculation for critical RH for grid saturation
!     RHGRID = 0.90 + .08*((100.-DX)/95.)**.5
   
!---------------------------------------------------------------------

!--- Total "cloud" mixing ratio, QCLD.  Rain is not part of cloud,
!    only cloud water + cloud ice + snow
! Mixing ratios of rain are not considered in this scheme.

         CFRAC_3D = 0.0   ! array assignment
         
         IF ( QG_AVAIL ) THEN
            DO K = 1, NLAYS
               DO J = 1, NROWS
                  DO I = 1, NCOLS
                     QCLD(I,J,K) = QC(I,J,K) + QI(I,J,K) + QS(I,J,K) + QG(I,J,K)
                     IF ( QCLD(I,J,K) .GE. QCLDMIN ) THEN
                        WEIGHT(I,J,K) = ( QI(I,J,K) + QS(I,J,K) + QG(I,J,K) ) / QCLD(I,J,K)
                     ELSE
                        WEIGHT(I,J,K) = 0.0
                     END IF
                  END DO
               END DO
            END DO
         ELSE IF ( QI_AVAIL ) THEN
            DO K = 1, NLAYS
               DO J = 1, NROWS
                  DO I = 1, NCOLS
                     QCLD(I,J,K) = QC(I,J,K) + QI(I,J,K) + QS(I,J,K)
                     IF ( QCLD(I,J,K) .GE. QCLDMIN ) THEN
                        WEIGHT(I,J,K) = ( QI(I,J,K) + QS(I,J,K) ) / QCLD(I,J,K)
                     ELSE
                        WEIGHT(I,J,K) = 0.0
                     END IF
                  END DO
               END DO
            END DO
         ELSE IF ( QC_AVAIL ) THEN
            DO K = 1, NLAYS
               DO J = 1, NROWS
                  DO I = 1, NCOLS
                     QCLD(I,J,K) = QC(I,J,K)
                     IF ( QCLD(I,J,K) .GE. QCLDMIN ) THEN
                        IF ( TA(I,J,K) .GT. 273.15 ) WEIGHT(I,J,K) = 0.0
                        IF ( TA(I,J,K) .LE. 273.15 ) WEIGHT(I,J,K) = 1.0
                     ELSE
                        WEIGHT(I,J,K) = 0.0
                     END IF
                  END DO
               END DO
            END DO
         ELSE          
            RETURN
         END IF !  IF ( QG_AVAIL )

         DO K = 1, NLAYS
            DO J = 1, NROWS
               DO I = 1, NCOLS
!--- Determine cloud fraction (modified from original algorithm)
                  IF ( QCLD(I,J,K) .LT. QCLDMIN ) THEN
!--- Assume zero cloud fraction if there is no cloud mixing ratio
                     CFRAC_3D(I,J,K) = 0.0
                     CYCLE
                  END IF
                  
                  TC   = TA(I,J,K) - SVPT0
                  ESW  = SVP1 * EXP( SVP2  * TC / ( TA(I,J,K) - SVP3  ) )
                  ESI  = SVP1 * EXP( SVPI2 * TC / ( TA(I,J,K) - SVPI3 ) )
                  QVSW = EP_2 * ESW / ( PRES(I,J,K) - ESW )
                  QVSI = EP_2 * ESI / ( PRES(I,J,K) - ESI )
                  WHT  = WEIGHT(I,J,K)
!                 QVS_WEIGHT = ( 1.0 - WHT ) * QVSW + WHT * QVSI
                  QVS_WEIGHT = QVSW + WHT * ( QVSI - QVSW )
                  RHUM = QV(I,J,K) / QVS_WEIGHT   !--- Relative Humidity                  
                  
                  IF ( RHUM .GE. RHGRID ) THEN
!--- Assume cloud fraction of unity if near saturation and the cloud
!    mixing ratio is at or above the minimum threshold
                     CFRAC_3D(I,J,K) = 1.0
                     CYCLE
                  ELSE
!--- Adaptation of original algorithm (Randall, 1994; Zhao, 1995)
!    modified based on assumed grid-scale saturation at RH=RHgrid.
                     SUBSAT = MAX( 1.E-10, RHGRID * QVS_WEIGHT - QV(I,J,K) )
                     DENOM  = SUBSAT ** GAMMA
                     ARG    = MAX( -6.9, -ALPHA0 * QCLD(I,J,K) / DENOM )   ! <-- EXP(-6.9)=.001
                     CFRAC_3D(I,J,K) = ( RHUM / RHGRID ) ** PEXP * ( 1.0 - EXP( ARG ) )
                  END IF          !--- END IF (QCLD(I,J,K) .LT. QCLDMIN)

                  IF ( CFRAC_3D(I,J,K) .LT. 0.01 ) CFRAC_3D(I,J,K) = 0.0

                  IF ( CFRAC_3D(I,J,K) .NE. CFRAC_3D(I,J,K) .OR.
     &                 CFRAC_3D(I,J,K) .GT. 1.0 ) THEN 
                     WRITE( LOGDEV,'(/2X,A,3I6)' ) 'COL, ROW, LAY = ', I, J, K
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'TA, PRES = ', TA(I,J,K), PRES(I,J,K)
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'QV, QC, QI, QS = ', QV(I,J,K), QC(I,J,K), QI(I,J,K), QS(I,J,K)
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'ESW, ESI, QVSW, QVSI = ', ESW, ESI, QVSW, QVSI
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'WEIGH, QVS_WEIGH = ', WHT, QVS_WEIGHT 
                     WRITE( LOGDEV,'(/2X,A,4ES12.4)' )
     &                     'SUBSAT, RHUM, RHGRID, ARG = ', SUBSAT, RHUM, RHGRID, ARG
                     XMSG = 'Floating point exception for CFRAC_3D'
                     CALL M3EXIT ( 'CAL_CFRAC_3D', 0, 0, XMSG, XSTAT1 )
                  END IF

               END DO   ! i
            END DO   ! j
         END DO   ! k

         END SUBROUTINE CAL_CFRAC_3D

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE CAPTURE_ACM_CLOUD( JDATE, JTIME, COL, ROW, BOTTOM, TOP,
     &                                 FRACTION, WATER, ICE )

            USE CLOUD_OPTICS, ONLY : CLDMIN
         
            IMPLICIT NONE
! Purpose:
!   Save properties determined by ACM subgrid cloud at vertical column into
!   for radiation transfer calculations
!  REVISION  HISTORY:
!  12Jun15: BHutzell: comment out call to CLEAR_ACM_CLOUD because CONVCLD_ACM routine
!                     calls CLEAR_ACM_CLOUD at every synchronization time if acm 
!                     convection algorithm engaged, i.e., CONVCLD = .TRUE.
! Arguments:
            INTEGER, INTENT( IN )  :: JDATE      
            INTEGER, INTENT( IN )  :: JTIME                 
            INTEGER, INTENT( IN )  :: COL           ! array column index
            INTEGER, INTENT( IN )  :: ROW           ! array row index
            INTEGER, INTENT( IN )  :: TOP           ! vertical layer index
            INTEGER, INTENT( IN )  :: BOTTOM        ! vertical layer index
            REAL,    INTENT( IN )  :: FRACTION      ! cloud fraction of ACM cloud
            REAL,    INTENT( IN )  :: WATER( : )    ! liquid water droplet mixing ratio
            REAL,    INTENT( IN )  :: ICE( : )      ! ice partical mixing ratio

! Parameters:
!           None

! Local variables:
            INTEGER                :: LAY           ! loop index

            DO LAY = BOTTOM, TOP
               IF ( WATER( LAY ) + ICE( LAY ) .LT. CLDMIN ) CYCLE
               ACM_CFRAC( LAY,COL,ROW ) = FRACTION
               ACM_QC   ( LAY,COL,ROW ) = WATER( LAY )
               ACM_QI   ( LAY,COL,ROW ) =   ICE( LAY )
            END DO
                     
            DO LAY = 1, BOTTOM - 1
               IF ( WATER( LAY ) + ICE( LAY ) .LT. CLDMIN ) CYCLE
               ACM_CFRAC( LAY,COL,ROW ) = FRACTION
               ACM_QR   ( LAY,COL,ROW ) = WATER( LAY )
               ACM_QG   ( LAY,COL,ROW ) =   ICE( LAY )
            END DO

            ACM_CLOUDS( COL,ROW )  = FRACTION             
             
!           WRITE(LOGDEV,'(A,2(I3,1X),10(ES12.4,1X))')'COL,ROW,ACM_CFRAC = ',COL,ROW,
!     &     ACM_CFRAC( TOP,COL,ROW ), ACM_QC( TOP,COL,ROW ),ACM_QI( TOP,COL,ROW )            
            RETURN

         END SUBROUTINE CAPTURE_ACM_CLOUD

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE INIT_ACM_CLOUD( JDATE, JTIME )

            USE GRID_CONF           ! horizontal & vertical domain specifications
            USE UTILIO_DEFN         ! IO routines & utilties

!Arguments:
            INTEGER, INTENT( IN )  :: JDATE      
            INTEGER, INTENT( IN )  :: JTIME
! Local variables:             
            INTEGER                :: ASTAT     ! memory allocation status
             
            CHARACTER( 18 ), PARAMETER  :: PNAME = 'INIT_ACM_CLOUD'
                       
            WRITE( XMSG, '(3A)' ), 'ATTENTION: Attempt to include subgrid ',
     &             'cloud effects: photolysis rates include ACM CLOUD effects. ',
     &             'It would be prudent to examine diagnostic cloud fractions.'
            CALL LOG_MESSAGE( LOGDEV, XMSG)
            WRITE( LOGDEV, * )
             
            ALLOCATE ( ACM_CFRAC( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_CFRAC'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QC( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QC'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QI( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QI'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QR( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QR'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_QG( NLAYS,NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_QG'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_CLOUDS( NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_CLOUDS'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            ALLOCATE ( ACM_AVE_H2O( NCOLS,NROWS ), STAT = ASTAT )
            IF ( ASTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ACM_AVE_H2O'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
 
            ACM_CLOUDS  = 0.0
            ACM_CFRAC   = 0.0
            ACM_AVE_H2O = 0.0
            ACM_QC      = 0.0
            ACM_QI      = 0.0
            ACM_QR      = 0.0
            ACM_QG      = 0.0
             
            RETURN

         END SUBROUTINE INIT_ACM_CLOUD        

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE CLEAR_ACM_CLOUD( JDATE, JTIME )
          
            IMPLICIT NONE
! Purpose:
!          -Determine if acm cloud propeties have been set
!          -Zero out their array if not
! Arguments:
            INTEGER, INTENT( IN )  :: JDATE      
            INTEGER, INTENT( IN )  :: JTIME                 
! Local Variables: None

            IF ( SET_ACM_ARRAYS )THEN
               CALL INIT_ACM_CLOUD( JDATE, JTIME)
               SET_ACM_ARRAYS = .FALSE.
            END IF

            IF ( JDATE .NE. ACM_DATE .OR. JTIME .NE. ACM_TIME )THEN
               ACM_CFRAC   = 0.0   ! array assignment
               ACM_QC      = 0.0   !   "       "
               ACM_QI      = 0.0   !   "       "
               ACM_QR      = 0.0   !   "       "
               ACM_QG      = 0.0   !   "       "
               ACM_CLOUDS  = 0.0   !   "       "
               ACM_AVE_H2O = 0.0   !   "       "
               ACM_DATE    = JDATE
               ACM_TIME    = JTIME
            END IF

            RETURN

         END SUBROUTINE CLEAR_ACM_CLOUD
      END MODULE PHOT_MET_DATA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module aero_data

C  Defines aerosol species arrays and the parameters required in aerosol
C  processing.

C  Contains:
C     Subroutine map_aero
C     Subroutine extract_aero
C     Subroutine update_aero
C     Function findAero

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS = Heather Simon; GS = Golam Sarwar; SH = Steve Howard; SR = Shawn Roselle;
C JY = Jeff Young; HOTP = Havala Pye; KF = Kathleen Fahey, CGN = Chris Nolte;
C PL = Peng Liu; BM = Ben Murphy; BH = Bill Hutzell

C HS  01/24/11 Updated to initial AERO6; PMOTHR -> 9 species
C GS  03/02/11 Revised parameters for Mg, K, and Ca
C SH  03/10/11 Inserted functionality of PMEM_DEFN
C    -new subroutine map_pmemis
C HS  03/10/11 Made PNCOM a required species
C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN
C SH  04/04/11 Added sea-salt speciation factors
C GS  04/09/11 Updated sea-salt speciation; replaced ANAK with ASEACAT;
C              made MG, K, CA, SEACAT required species;
C JY  04/21/11 Added optional log messages (verbose_aero)
C JY  05/02/11 Added Reshape to aerospc_ssf initialization for pgf90 compiler
C BH  08/31/11 Adapted for mercury and HAP mechanisms
C JY  06/08/12 remove full character blank padding put in for GNU Fortran (GCC) 4.1.2
C HOTP 01/16/13 Removed isoprene acid enhanced aerosol and added new isoprene aerosol
C HOTP 01/18/13 Added information for particle phase reaction of isoprene products
C               based on Eddingsaas et al. 2010
C KF  09/17/14 Changed emitted modal PM mass fractions and geometric mean diameter and
C              geometric standard deviation of emitted particles according to
C              Elleman and Covert (2010)
C HOTP 09/27/14 Added alkane and PAH SOA species. PAH SOA densities follow Chan et al.
C JY  08/24/15 Changed visual index factors
C HOTP 2/17/2016 Updated SOA densities. BTX follows Ng et al. 2007.
C                1.4 g/cm3 used by default.
C JY  02/17/16 Created named constants for speciation and other factors for AERO_EMIS,
C              DUST_EMIS, aero_subs:VOLINORG, and aqchem
C CGN 04/14/16 Changed AMGJ speciation factor from 0.0 to 0.019 following Upadhyay et al.
C HOTP,BM  5/20/16 Updated to work with all ae6 mechs (6, 6i, 6mp)
C PL 05/15/16 Update visual_idx, and add visual_idx_large in spcs_type, due to ammonium sulfate, nitrate and OM
C             are split into small and large modes.
C             visual_idx for ammonium is zero, because it will be treated together with sulfate and nitrate
C             see Pitchford et al., Journal of the Air & Waste Management Association (57)(2007), pp 1326
C PL 05/15/16 Add "om" in spcs_type, to flag organic aerosols, which
C             will be used to calculate total mass of organic aerosls for estimating
C             aerosol extinction efficiency
C HOTP 7/17/2018 Added kappaorg hygroscopicity parameter (Petters and
C             Kreidenweis 2007 ACP) for organic aerosols. kappa should be zero for
C             species that are not organic. Water uptake onto inorganics calculated using ISORROPIA.
C             POC+NCOM kappa is set to zero and calculated in SOA_DEFN if those species are in use.
C             Current kappaorg values are based on species specific
C             OM/OC ratios (Pye et al. 2017 ACP).
C GS  08/17/81 Added bromide in seasalt
C SR 12/14/2018 Added sulfur tracking option
C SLN 12/30/2019 ddm-3d implementaiton for v 5.3.1

C References:
C 1. Eddingsaas, N. C., Vandervelde, D. G., Wennberg, P. O., "Kinetics and
C    products of the acid-catalyzed ring-opening of atmospherically relevant
C    butyl epoxy alcohols," J. Phys. Chem. A., 2010, 114, 8106-8113.
C 2. Chan, et al., "Secondary organic aerosol formation from photooxidation
C    of naphthalene and alkylnaphthalenes: implications for oxidation of
C    intermediate volatility organic compounds (IVOCs)", Atmos. Chem. Phys.,
C    2009, 9, 3049-3060.
C 3. Ng, N. L., Kroll, J. H., Chan, A. W. H., Chhabra, P. S., Flagan, R.
C    C., and Seinfeld, J. H.: Secondary organic aerosol formation from
C    m-xylene, toluene, and benzene, Atmos. Chem. Phys., 7, 3909-3922,
C    doi:10.5194/acp-7-3909-2007, 2007.
C 4. Elleman and Covert, "Aerosol size distribution modeling with the Community Multiscale
C    Air Quality modeling system in the Pacific Northwest: 3. Size distribution of
C    particles emitted into a mesoscale model", JGR, 115, D03204, 2010
C 5. Simon, et al., "The development and uses of EPA's SPECIATE database",
C    Atmos. Poll. Res., 1, 196-206, 2010
C 6. Upadhyay, et al., "Size-Differentiated Chemical Composition of Re-Suspended Soil
C    Dust from the Desert Southwest United States," Aero. and AQ Res., 2015, 387-398

C JY: From Christian Hogrefe...
C Based on Malm and Hand (Atmos. Env. 41, 3407-3427, 2007), the revised
C IMPROVE extinction calculation includes coarse particles, sea salt, and
C a relative humidity correction for sea salt. Also, the factor for "LAC"
C (light absorbing carbon, i.e. AECI and AECJ) should be 10, not 0 since
C both scattering and absorption contribute to total extinction.
C ASEACAT includes all sea-salt cations in coarse mode (Na, Ca, K, and Mg)
C Also note...
C In the Fortran user-derived spcs_type, below, visual_idx is an optimal dry mass
C extinction efficiency [m^2/g], see White, Atmos.Env., 294(10)(1990), pp 2673-1672
C and Malm, et al., JGR, 99(D1)(1994), pp 1347-1370
C----------------------------------------------------------------------
      USE RUNTIME_VARS
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      Use aero_ddm3d, ONLY : s_aerospc_conc, ae_ddm3d_ready,
     &                       init_aero_ddm3d, s_aerospc_conc
#endif 


      Implicit None

C Number of aerosol species and modes

      Integer, Parameter :: n_aerolist = 110    ! number of aero species
      Integer, Parameter :: n_mode = 3          ! number of modes:
                                                ! 1 = Aitken
                                                ! 2 = accumulation
                                                ! 3 = coarse
      Character(1), Parameter :: modesuff( n_mode ) = (/ 'I','J','K' /)

      Integer, Save :: n_aerospc ! number of aero species

C Default minimum concentration
      Real,    Parameter :: conmin  = 1.0E-23    ! [ ug m-3 ]
      Real(8), Parameter :: conminD = 1.0D-23    ! [ ug m-3 ]
      Real,    Parameter :: evapmin = 1.0E-20    ! [ ug m-3 ]
      Real(8), Parameter :: evapminD= 1.0D-20    ! [ ug m-3 ]
      Real,    Parameter :: cm_set( n_mode ) = (/conmin, conmin, conmin/)
      Real,    Parameter :: cm_so4( n_mode ) = (/conmin, conmin, conmin/)
      Real,    Parameter :: cm_cor( n_mode ) = (/conmin, conmin, conmin/)

      Real,    Parameter :: def_diam( n_mode )   = (/ 15.0E-9, 80.0E-9,  600.0E-9 /)  ! default background mean diameter for each mode
      Real,    Parameter :: min_diam_g( n_mode ) = (/ 1.0E-9,  30.0E-9,  120.0E-9 /)
      Real,    Parameter :: max_diam_g( n_mode ) = (/ 80.0E-9, 500.0E-9, 100.0E-6 /)

      Real,    Parameter :: def_sigma_g( n_mode ) = (/ 1.70, 2.0, 2.2 /)       ! default background sigma-g for each mode
      Real,    Parameter :: min_sigma_g = 1.05
      Real,    Parameter :: max_sigma_g = 2.5001
      Real,    Save      :: def_l2sg( n_mode ), max_l2sg, min_l2sg   

C If FIXED_sg = T, atkn & accum std. dev. are not changed by GETPAR
C If FIXED_sg = F, the second moment will be adjusted if the standard
C                  deviation (sigma_g) is outside of the bounds specified 
C                  by min_sigma_g and max_sigma_g.
      LOGICAL, PARAMETER :: FIXED_sg = .FALSE.

C Flag to obtain coagulation coefficients
C by analytical approximation (True) or by Gauss-Hermite quadrature (False)
      Logical, Parameter :: fastcoag_flag = .True.

C Define Logical values as T and F for the aerospc table
      Logical, Parameter, Private :: T = .true.
      Logical, Parameter, Private :: F = .false.

C-------------------------------------------------------------------------------------------------------

      Type spcs_type
         Character( 16 ) :: name( n_mode )       ! mode-dependent names of aerosol species
         Character( 16 ) :: bulkname             ! mode-independent names of aerosol species
         Real            :: min_conc( n_mode )   ! minimum concentration values for each mode
         Real            :: density              ! density [ kg m-3 ]
         Logical         :: no_M2Wet             ! flag to exclude from 2nd moment during transport
         Logical         :: tracer               ! tracer flag; does have not mass
         Integer         :: charge               ! electroneutrality charge
         Real            :: visual_idx           ! visual index factor [ m2 g-1 ]
         Real            :: visual_idx_large     ! visual index factor [ m2 g-1 ] for large mode, if not applicable, same value as visual_idx
         Logical         :: om                   ! flag for organic aerosols
         Character( 16 ) :: optic_surr           ! optical surrogate name
         Real            :: kappaorg             ! hygroscopicity parameter for organic aerosol (excluding POC+NCOM which must be calculated)
      End Type spcs_type
      Type( spcs_type ), Allocatable, Save :: aerospc ( : )
 

      ! Master List of Aerosol Species and Properties
      Type spcs_list_type
         Character( 16 ) :: bulkname             ! mode-independent names of aerosol species
         Real            :: min_conc( n_mode )   ! minimum concentration values for each mode
         Real            :: density              ! density [ kg m-3 ]
         Logical         :: no_M2Wet             ! flag to exclude from 2nd moment during transport
         Logical         :: tracer               ! tracer flag; does have not mass
         Integer         :: charge               ! electroneutrality charge
         Real            :: visual_idx           ! visual index factor [ m2 g-1 ]
         Real            :: visual_idx_large     ! visual index factor [ m2 g-1 ] for large mode, if not applicable, same value as visual_idx
         Logical         :: om                   ! flag for organic aerosols
         Character( 16 ) :: optic_surr           ! optical surrogate name
         Real            :: kappaorg             ! hygroscopicity parameter for organic aerosol (excluding POC+NCOM which must be calculated)
      End Type spcs_list_type

      Type( spcs_list_type ), Parameter :: aerolist( n_aerolist ) = (/
C                                                             Visidx_Large
C                                          no_M2Wet Tracer        |
C                     ---Name---                  | | Charge      | OM           
C                               Min_Concs Density | |   | Visidx  |  |  OptSurr  korg  
C                     ---------- -------- ------- + +   + ------ --- +  -------- ----- 
     & spcs_list_type('ASO4    ', cm_so4, 1800.0, F,F, -2,  2.2, 4.8,F, 'SOLUTE', 0.00), ! Sulfate
     & spcs_list_type('ANO3    ', cm_set, 1800.0, F,F, -1,  2.4, 5.1,F, 'SOLUTE', 0.00), ! Nitrate
     & spcs_list_type('ACL     ', cm_set, 2200.0, F,F, -1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! Chloride
     & spcs_list_type('ANH4    ', cm_set, 1800.0, F,F,  1,  0.0, 0.0,F, 'SOLUTE', 0.00), ! Ammonium
     & spcs_list_type('ANA     ', cm_set, 2200.0, F,F,  1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! Sodium
     & spcs_list_type('AMG     ', cm_set, 2200.0, F,F,  2,  1.0, 1.0,F, 'DUST  ', 0.00), ! Magnesium
     & spcs_list_type('AK      ', cm_set, 2200.0, F,F,  1,  1.0, 1.0,F, 'DUST  ', 0.00), ! Potassium
     & spcs_list_type('ACA     ', cm_set, 2200.0, F,F,  2,  1.0, 1.0,F, 'DUST  ', 0.00), ! Calcium
     & spcs_list_type('APOC    ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.00), ! POA Carbon
     & spcs_list_type('APNCOM  ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.00), ! POA Non-Carbon          #10
     & spcs_list_type('AEC     ', cm_set, 2200.0, F,F,  0, 10.0,10.0,F, 'SOOT  ', 0.00), ! Elemental (Black) Carbon
     & spcs_list_type('AFE     ', cm_set, 2200.0, F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Iron
     & spcs_list_type('AAL     ', cm_set, 2200.0, F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Aluminum
     & spcs_list_type('ASI     ', cm_set, 2200.0, F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Silicon
     & spcs_list_type('ATI     ', cm_set, 2200.0, F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Titanium
     & spcs_list_type('AMN     ', cm_set, 2200.0, F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Manganese
     & spcs_list_type('AH2O    ', cm_set, 1000.0, T,F,  0,  0.0, 0.0,F, 'WATER ', 0.00), ! Water
     & spcs_list_type('AORGH2O ', cm_set, 1000.0, T,F,  0,  0.0, 0.0,F, 'WATER ', 0.00), ! Organic Water
     & spcs_list_type('AH3OP   ', cm_set, 1000.0, T,T,  0,  0.0, 0.0,F, 'WATER ', 0.00), ! Hydronium
     & spcs_list_type('AOTHR   ', cm_set, 2200.0, F,F,  0,  1.0, 1.0,F, 'DUST  ', 0.00), ! Other                   #20
     & spcs_list_type('AALK1   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), ! Alkane SOA 1            
     & spcs_list_type('AALK2   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.06), ! Alkane SOA 2
     & spcs_list_type('AXYL1   ', cm_set, 1480.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.17), ! Xylene SOA 1
     & spcs_list_type('AXYL2   ', cm_set, 1480.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.11), ! Xylene SOA 2
     & spcs_list_type('AXYL3   ', cm_set, 1330.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Xylene SOA 3
     & spcs_list_type('ATOL1   ', cm_set, 1240.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Toluene SOA 1
     & spcs_list_type('ATOL2   ', cm_set, 1240.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! Toluene SOA 2
     & spcs_list_type('ATOL3   ', cm_set, 1450.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.20), ! Toluene SOA 3
     & spcs_list_type('ABNZ1   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.19), ! Benzene SOA 1
     & spcs_list_type('ABNZ2   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Benzene SOA 2           #30
     & spcs_list_type('ABNZ3   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.23), ! Benzene SOA 3           
     & spcs_list_type('ATRP1   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! Terpene SOA 1
     & spcs_list_type('ATRP2   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.10), ! Terpene SOA 2
     & spcs_list_type('AISO1   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.14), ! Isoprene SOA 1
     & spcs_list_type('AISO2   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Isoprene SOA 2
     & spcs_list_type('AISO3   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.21), ! Isoprene SOA 3
     & spcs_list_type('ASQT    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), ! Sesquiterpene SOA
     & spcs_list_type('APAH1   ', cm_set, 1480.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.08), ! PAH SOA 1
     & spcs_list_type('APAH2   ', cm_set, 1480.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.06), ! PAH SOA 2
     & spcs_list_type('APAH3   ', cm_set, 1550.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.09), ! PAH SOA 3               #40
     & spcs_list_type('AOLGA   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.18), ! Anth. Oligomer SOA      
     & spcs_list_type('AOLGB   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), ! Biogenic Oligomer SOA
     & spcs_list_type('AORGC   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.12), ! Cloud-Processed SOA
     & spcs_list_type('ASOIL   ', cm_set, 2600.0, F,F,  0,  0.6, 0.6,F, 'DUST  ', 0.00), ! Soil
     & spcs_list_type('ACORS   ', cm_cor, 2200.0, F,F,  0,  0.6, 0.6,F, 'DUST  ', 0.00), ! Coarse PM
     & spcs_list_type('ASEACAT ', cm_cor, 2200.0, F,F,  1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! SeaSpray Cations        
                                                                                   
       ! Associated with ae6i                                                           
     & spcs_list_type('AMTNO3  ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.11), ! Monoterpene Nitrate SOA
     & spcs_list_type('AISOPNN ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.32), ! Isoprene Nitrate SOA
     & spcs_list_type('AMTHYD  ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), ! 
     & spcs_list_type('AIETET  ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15), ! Iso. Tetrol SOA         #50
     & spcs_list_type('AIEOS   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.30), ! Iso. Organosulfate SOA  
     & spcs_list_type('ADIM    ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), !
     & spcs_list_type('AIMGA   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.18), !
     & spcs_list_type('AIMOS   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.36), !
                                                                                        
       ! Updated monoterpene SOA following Saha and Grieshop ES&T 2016                  
     & spcs_list_type('AMT1    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.08), ! MT SOA Lowest Volatility
     & spcs_list_type('AMT2    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.08), ! 
     & spcs_list_type('AMT3    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.09), !
     & spcs_list_type('AMT4    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), !
     & spcs_list_type('AMT5    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.07), !
     & spcs_list_type('AMT6    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.05), !                         #60
     & spcs_list_type('AMT7    ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.06), ! MT SOA Highest Volatility
                                                                                      
       ! ae6i and cb6                                                                 
     & spcs_list_type('AGLY    ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.13), ! Glyoxal SOA
                                                                                      
       ! Semivolatile POA                                                             
     & spcs_list_type('ALVPO1  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! LV-POA
     & spcs_list_type('ASVPO1  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.05), ! SV-POA 1
     & spcs_list_type('ASVPO2  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.04), ! SV-POA 2
     & spcs_list_type('ASVPO3  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! SV-POA 3
     & spcs_list_type('AIVPO1  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.03), ! IV-POA 
     & spcs_list_type('ALVOO1  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.15), ! LV-SOA 1                
     & spcs_list_type('ALVOO2  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.13), ! LV-SOA 2
     & spcs_list_type('ASVOO1  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.11), ! SV-SOA 1                #70
     & spcs_list_type('ASVOO2  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.09), ! SV-SOA 2
     & spcs_list_type('ASVOO3  ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.08), ! SV-SOA 3
     & spcs_list_type('APCSO   ', cm_set, 1400.0, T,F,  0,  4.0, 6.1,T, 'DUST  ', 0.12), ! pcSOA
                                                                                  
       ! Lumped anthropogenic SOA (introduced aero7, M. Qin, 8/2018)
     & spcs_list_type('AAVB1   ', cm_set, 1400.0, F,F,  0,  2.8, 6.1,T, 'DUST  ', 0.20),
     & spcs_list_type('AAVB2   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.15),
     & spcs_list_type('AAVB3   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.14),
     & spcs_list_type('AAVB4   ', cm_set, 1400.0, T,F,  0,  2.8, 6.1,T, 'DUST  ', 0.12),

       ! The following species are associated with the Multi-Pollutant code
     & spcs_list_type('ANI     ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Nickel
     & spcs_list_type('ACR_VI  ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Chromium 6
     & spcs_list_type('ACR_III ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Chromium 3              #80
     & spcs_list_type('ABE     ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Beryllium
     & spcs_list_type('APB     ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Lead                     
     & spcs_list_type('ADE_OTHR', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Fine PM          
     & spcs_list_type('ADE_EC  ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Black Carbon
     & spcs_list_type('ADE_OC  ', cm_set, 2000.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Organic Carbon
     & spcs_list_type('ADE_NO3 ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Nitrate
     & spcs_list_type('ADE_SO4 ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Sulfate
     & spcs_list_type('ADE_CORS', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Diesel Coarse PM
     & spcs_list_type('ACD     ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Cadmium
     & spcs_list_type('AMN_HAPS', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Manganese               #90
     & spcs_list_type('APHG    ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Mercury
     & spcs_list_type('AAS     ', cm_set, 2200.0, F,T,  0,  0.0, 0.0,F, 'DUST  ', 0.00), ! Arsenic                 #92

      ! The following species are associated with the marine chemistry code
     & spcs_list_type('ABR     ', cm_set, 2200.0, F,F, -1,  1.7, 1.7,F, 'SOLUTE', 0.00), ! Bromide 

      ! The following species are associated with the sulfur tracking model
     & spcs_list_type('ASO4AQH2O2', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous H2O2 rxn
     & spcs_list_type('ASO4AQO3  ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous O3 rxn
     & spcs_list_type('ASO4AQFEMN', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous FEMN cat rxn
     & spcs_list_type('ASO4AQMHP ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous MHP rxn
     & spcs_list_type('ASO4AQPAA ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous PAA rxn
     & spcs_list_type('ASO4GAS   ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from gas rxn
     & spcs_list_type('ASO4EMIS  ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! emitted SO4
     & spcs_list_type('ASO4ICBC  ', cm_so4, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from ICBCs

      ! The following species are associated with the sulfur tracking model, representing loss of tracked species to organosulfate
     & spcs_list_type('OSO4      ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 loss to organosulfate
     & spcs_list_type('OSO4AQH2O2', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous H2O2 rxn loss to organosulfate
     & spcs_list_type('OSO4AQO3  ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous O3 rxn loss to organosulfate
     & spcs_list_type('OSO4AQFEMN', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous FEMN cat rxn loss to organosulfate
     & spcs_list_type('OSO4AQMHP ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous MHP rxn loss to organosulfate
     & spcs_list_type('OSO4AQPAA ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from aqueous PAA rxn loss to organosulfate
     & spcs_list_type('OSO4GAS   ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from gas rxn loss to organosulfate
     & spcs_list_type('OSO4EMIS  ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00), ! SO4 from emitted SO4 loss to organosulfate
     & spcs_list_type('OSO4ICBC  ', cm_set, 1800.0, F,T,  0,  0.0, 0.0,F, 'SOLUTE', 0.00)  ! SO4 from ICBCs loss to organosulfate
     & /)
 
! Define Reference Emissions Size Distributions
!   Geometric mean diameter by volume (or mass) of emitted particles in
!   each mode [ m ] and geometric standard deviation of emitted particles.  
!   See paragraph #14 of Binkowski & Roselle (2003).
!   09/17/14 change by Kathleen Fahey - see Revision History, above.
      TYPE em_aero
          Character( 20 ) :: name
          Real            :: split( n_mode )  ! dimensionless
          Real            :: dgvem( n_mode )  ! meters
          Real            :: sgem ( n_mode )  ! dimensionless
      END TYPE em_aero
      INTEGER, PARAMETER  :: n_em_aero_ref = 9

      TYPE( em_aero ), Parameter :: em_aero_ref( n_em_aero_ref ) = (/

!              ----Name----     -----Split-----    ---Geo. Mean Diameter---   ---Stnd Dev.---
     & em_aero('FINE_REF       ',(/0.1,0.9,0.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Default Accum and Aitken Mode
     & em_aero('ACC_REF        ',(/0.0,1.0,0.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Just Accumulation Mode
     & em_aero('COARSE_REF     ',(/0.0,0.0,1.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Just Coarse Mode
     & em_aero('UNITY_REF      ',(/1.0,1.0,1.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Used for online sectors (e.g. SeaSpray)
     & em_aero('ZERO_REF       ',(/0.0,0.0,0.0/),(/0.06E-6,0.28E-6 ,6.0E-6 /),(/1.7,1.7,2.2/)), ! Zero out the emissions
     & em_aero('FINE_WBDUST    ',(/0.0,1.0,0.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/)), ! Default Fine Wind-Blown Dust Parameterization
     & em_aero('COARSE_WBDUST  ',(/0.0,0.0,1.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/)), ! Default Coarse Wind-Blown Dust Param.
     & em_aero('FINE_SEASPRAY  ',(/0.0,1.0,0.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/)), ! Fine Sea Spray Parameterization is Dynamic. 
     & em_aero('COARSE_SEASPRAY',(/0.0,0.0,1.0/),(/0.06E-6,1.391E-6,5.26E-6/),(/1.7,2.0,2.0/))  ! Coarse Sea Spray Parameterization is Dynamic. 
                                                                                                !  The values here are not actually used but
                                                                                                !  are replaced in SSEMIS when FACNUM and FACSRF
                                                                                                !  are calculated online.
     & /)

! Primary Organic Aerosol Volatility Distributions
      Integer, Parameter :: n_vbs_bin = 5
      Character( 10 ) :: poa_name( n_vbs_bin ) = (/ 'LVPO1', 'SVPO1', 'SVPO2', 'SVPO3', 'IVPO1' /)
      Real, Parameter :: poa_op_vf( n_vbs_bin ) = (/ 0.09,  0.09,  0.14,  0.18,  0.5 /)  ! Aggregated

! The Following Volatility Distributions are alternative options
! but at this point can only be implemented indivdually for the
! entire POA suite of compounds.
!     Real, Parameter :: poa_gv_vf(n_vbs_bin) = (/0.27,  0.15,   0.26,   0.15,   0.17/) ! Gasoline
!     Real, Parameter :: poa_dv_vf(n_vbs_bin) = (/0.03,  0.25,   0.37,   0.24,   0.11/) ! Diesel
!     Real, Parameter :: poa_bb_vf(n_vbs_bin) = (/0.2,   0.1,    0.1,    0.2,    0.4/)  ! Biomass Burning
!     Real, Parameter :: poa_nv_vf(n_vbs_bin) = (/1.0,   0.0,    0.0,    0.0,    0.0/)  ! Nonvolatile
!     Real, Parameter :: poa_mc_vf(n_vbs_bin) = (/0.35,  0.35,   0.1,    0.1,    0.1/)  ! Meat Cooking

! POA_AMF is the fraction of total emissions in the particle phase.
! This parameter is for distributing the total emissions between
! gas and particle BEFORE the aerosol size distribution is applied.
! This helps prevent numerical issues with shrinking the particles
! instantaneously.
      Real, Parameter :: poa_amf( n_vbs_bin ) = (/ 1.0, 0.5, 0.0, 0.0, 0.0 /)
      Real, Parameter :: pog_amf( n_vbs_bin ) = (/ 0.0, 0.5, 1.0, 1.0, 1.0 /)
 
! PCVOC_FAC is the scale factor for deriving PCVOC emissions from POA
! emissions. PCVOC is the vapor precursor to pcSOA formation.
      Real, Parameter :: PCVOC_FAC = 6.579  ! Scale factor for PCVOC/POA
                                            ! Murphy et al., 2017

C number of lognormal modes in windblown dust aerosol = n_mode
C - but only accumulation and coarse modes used
      Type emis_table
         Character( 16 ) :: description       ! Species Long Name
         Character( 16 ) :: name              ! Species Name
         Real            :: mw                ! Molecular weight (g/mol)
         Real            :: spcfac( 2 )       ! Speciation Factor for fine and coarse modes (g/g)
      End type emis_table

C For the wind-blown dust speciation factors, we used the median of the Desert Soil
C profiles 3398, 3403, 3408, and 3413 for the J mode from the SPECIATE database and
C profiles 3399, 3404, 3409, and 3414 for coarse PM. (G. Pouliot - private communication)
C See Ref. (4), above and https://cfpub.epa.gov/si/speciate/
! For toxic metal species, more recent sources were consulted because the above profiles give large uncertainties in their 
! speciation factors
! For the air toxics version of manganese, nickel, chromium(III), arsenic, and lead:
!    Table 2 in Y. Su, and R. Yang., Background concentrations of elements in surface soils and 
!    their changes as affected by agriculture use in the desert-oasis ecotone in the middle of Heihe
!    River Basin, North-west China, Journal of Geochemical Exploration, 98, 2008, 57–64 was used.
!    The table represents natural desert soils prior to cultivation. Note that all chromium is 
!    to be trivalent based on assuming low pH or anoxics conditions. 
! For cadmium:
!    The background mixing ratio was used from Table 3 in Su, C., Jiang, L.,and Zhang, W., 
!    A review on heavy metal contamination in the soil worldwide: Situation, impact and 
!    remediation techniques, Environmental Skeptics and Critics, 2014, 3(2): 24-38. 
!    The table reviews worldwide cultivation soils.
! For mercury:
!    Table 2 in D. Obrist et al., A synthesis of terrestrial mercury in the western United States: 
!    Spatial distribution defined by land cover and plant productivity, Science of the Total Environment, 
!    568, 2016, 522–535.
!    Factors were based on mixing ratios for barren and cultivated land cover type
! Speciation factors between j and k modes were assumed constant because no data was found.

C maximum number of chemical species in windblown dust aerosol
      Integer, Parameter :: ndust_spc = 28

       
      Type( emis_table ) :: dust_spc( ndust_spc ) = (/
C                    --description-- -- Species -- --MW--   ------ spcfac ------
C                                                             fine    coarse
     &   emis_table( 'Sulfate       ',  'SO4    ',  96.0, (/ 0.02250, 0.02655/) ),   ! Sulfate
     &   emis_table( 'Nitrate       ',  'NO3    ',  62.0, (/ 0.00020, 0.00160/) ),   ! Nitrate
     &   emis_table( 'Chlorine      ',  'CL     ',  35.5, (/ 0.00945, 0.01190/) ),   ! Chlorine
     &   emis_table( 'Ammonium      ',  'NH4    ',  18.0, (/ 0.00005, 0.0    /) ),   ! Ammonium
     &   emis_table( 'Sodium        ',  'NA     ',  23.0, (/ 0.03935, 0.0    /) ),   ! Sodium
     &   emis_table( 'Calcium       ',  'CA     ',  40.1, (/ 0.07940, 0.0    /) ),   ! Calcium
     &   emis_table( 'Magnesium     ',  'MG     ',  24.3, (/ 0.01900, 0.0    /) ),   ! Magnesium
     &   emis_table( 'Potassium     ',  'K      ',  39.1, (/ 0.03770, 0.0    /) ),   ! Potassium
     &   emis_table( 'Org. Carbon   ',  'POC    ', 220.0, (/ 0.01075, 0.0    /) ),   ! Organic Carbon
     &   emis_table( 'NonCarbon Org.',  'PNCOM  ', 220.0, (/ 0.00430, 0.0    /) ),   ! Non-Carbon Organic Matter
     &   emis_table( 'Low-Vol. POA  ',  'LVPO1  ', 218.0, (/ 0.01501, 0.0    /) ),   ! Non-Carbon Organic Matter
     &   emis_table( 'Low-Vol. OOA  ',  'LVOO1  ', 136.0, (/ 2.23E-5, 0.0    /) ),   ! Non-Carbon Organic Matter
     &   emis_table( 'Black Carbon  ',  'EC     ',  12.0, (/ 0.0,     0.0    /) ),   ! Black or Elemental Carbon
     &   emis_table( 'Iron          ',  'FE     ',  55.8, (/ 0.03355, 0.0    /) ),   ! Iron
     &   emis_table( 'Aluminum      ',  'AL     ',  27.0, (/ 0.05695, 0.0    /) ),   ! Aluminum
     &   emis_table( 'Silicon       ',  'SI     ',  28.1, (/ 0.19425, 0.0    /) ),   ! Silicon
     &   emis_table( 'Titanium      ',  'TI     ',  47.9, (/ 0.00280, 0.0    /) ),   ! Titanium
     &   emis_table( 'Manganese     ',  'MN     ',  54.9, (/ 0.00115, 0.0    /) ),   ! Manganese
     &   emis_table( 'Water         ',  'H2O    ',  18.0, (/ 0.00541, 0.00637/) ),   ! Water
     &   emis_table( 'Undefined Mass',  'OTHR   ', 200.0, (/ 0.48319, 0.0    /) ),   ! Other
     &   emis_table( 'Non-Anion Dust',  'SOIL   ', 100.0, (/ 0.0,     0.95358/) ),   ! Non-Anion Dust
     &   emis_table( 'Air Toxics Mn ',  'MN_HAPS',  54.9, (/ 0.00041, 0.00041/) ),   ! Air toxics Manganese J and K mode
     &   emis_table( 'Nickel        ',  'NI     ',  58.7, (/ 2.0E-05, 2.0E-05/) ),   ! Nickel J and K mode
     &   emis_table( 'Chromium III  ',  'CR_III ',  52.0, (/ 5.6E-05, 5.6E-05/) ),   ! Trivalent Chromium J and K mode
     &   emis_table( 'Arsenic       ',  'AS     ',  74.92,(/ 5.5E-06, 5.5E-06/) ),   ! Arsenic J and K mode
     &   emis_table( 'Lead          ',  'PB     ', 207.2, (/ 1.6E-05, 1.6E-05/) ),   ! Lead J and K mode
     &   emis_table( 'Cadmium       ',  'CD     ', 112.4, (/ 9.7E-08, 9.7E-08/) ),   ! Cadmium J and K mode
     &   emis_table( 'Mercury       ',  'PHG    ', 200.5, (/ 1.4E-08, 1.4E-08/) ) /) ! Mercury J and K mode

      ! Manually Enter the mode-dependent Density of the Dust Particles using the mass fractions in 
      ! the dust_spc table and user-defined densities for each component. You may reference the aerolist 
      ! for densities as well. Units are [kg/m3]. The appropriate calculation is:
      !    dust_dens = sum( frac_i ) / sum( frac_i / dens_i )
      ! Make sure to ignore any tracer species when performing this calculation.
      Real, Parameter :: dust_dens( n_mode ) = (/ 2200.0, 2156.55, 2536.92 /)

      Real, ALLOCATABLE, SAVE    :: DUSTOUTM( :,:,: ) ! Wind-Blown Dust Mass Emiss Rate [ug/m3/s]
      Real, ALLOCATABLE, SAVE    :: DUSTOUTN( :,:,: )   ! Wind-Blown Dust Number Emiss Rate [1/m3/s]
      Real, ALLOCATABLE, SAVE    :: DUSTOUTS( :,:,: )   ! Wind-Blown Dust Surface Area Emiss Rate [m2/m3/s]

C Sea-Spray Aerosol Speciation factors based on seawater composition:
! For toxic metal species, Use Table 1 in K.W. Bruland and M.C. Lohan, 6.02 - Controls of Trace Metals in Seawater, 
! In Treatise on Geochemistry, edited by Heinrich D. Holland and Karl K. Turekian, Pergamon, Oxford, 2003, Pages 23-47,
! ISBN 9780080437514, http://dx.doi.org/10.1016/B0-08-043751-6/06105-3.

C number of chemical species in seawater aerosol composition
      integer, parameter :: nsea_spc = 17

      Type( emis_table ), Parameter :: sea_spc( nsea_spc ) = (/
C                     -description--  -- Species -- --MW--  ------ spcfac ------
C                                                              fine    coarse
     &   emis_table( 'Sulfate       ',   'SO4    ',  96.0, (/ 0.07760, 0.07760/) ),   ! Sulfate
     &   emis_table( 'Chlorine      ',   'CL     ',  35.5, (/ 0.55380, 0.55380/) ),   ! Chlorine
     &   emis_table( 'Sodium        ',   'NA     ',  23.0, (/ 0.30860, 0.0    /) ),   ! Sodium
     &   emis_table( 'Calcium       ',   'CA     ',  40.1, (/ 0.01180, 0.0    /) ),   ! Calcium
     &   emis_table( 'Magnesium     ',   'MG     ',  24.3, (/ 0.03680, 0.0    /) ),   ! Magnesium
     &   emis_table( 'Potassium     ',   'K      ',  39.1, (/ 0.01140, 0.0    /) ),   ! Potassium
     &   emis_table( 'SeaSalt_Cation',   'SEACAT ',  23.75,(/ 0.0    , 0.36860/) ),   ! Sea-Salt Cations
     &   emis_table( 'Chromium VI   ',   'CR_VI  ',  52.0, (/ 5.95E-9, 5.95E-9/) ),   ! Hexavalent Chromium
     &   emis_table( 'Nickel        ',   'NI     ',  58.7, (/ 1.34E-8, 1.34E-8/) ),   ! Nickle
     &   emis_table( 'Arsenic       ',   'AS     ',  74.92,(/ 4.93E-8, 4.93E-8/) ),   ! Arsenic
     &   emis_table( 'Beryllium     ',   'BE     ',   9.0, (/ 5.2E-11, 5.2E-11/) ),   ! Beryllium
     &   emis_table( 'Mercury       ',   'PHG    ', 200.5, (/ 5.8E-11, 5.8E-11/) ),   ! Mercury
     &   emis_table( 'Lead          ',   'PB     ', 207.2, (/ 6.0E-11, 6.0E-11/) ),   ! Lead
     &   emis_table( 'Cadmium       ',   'CD     ', 112.4, (/ 1.93E-9, 1.93E-9/) ),   ! cadmium
     &   emis_table( 'Air Toxics Mn ',   'MN_HAPS',  54.9, (/ 4.7E-11, 4.7E-11/) ),   ! Air toxics Manganese
     &   emis_table( 'Bromine       ',   'BR     ',  79.9, (/ 0.00190, 0.00190/) ),   ! Bromine 
     &   emis_table( 'Water         ',   'H2O    ',  18.0, (/ 0.0    , 0.0    /) ) /) ! Water (uptake is calculated online)
 
      ! MAKE SURE WATER IS THE LAST COMPONENT IN THE TABLE ABOVE OR YOU
      ! WILL ENCOUNTER ISSUES WITH THE SEA SPRAY EMISSIONS MODULE.

      ! Manually Enter the mode-dependent density of the Sea Spray Particles using the mass fractions in 
      ! the sea_spc table and user-defined densities for each component. You may reference the aerolist 
      ! for densities as well. Units are [kg m-3]. The appropriate calculation is:
      !    seaspray_dens = sum( frac_i ) / sum( frac_i / dens_i )
      ! Make sure to ignore any tracer species when performing this calculation.
      Real, Parameter :: seaspray_dens( n_mode ) = (/ 2162.7, 2162.7, 2162.7 /)
      Real, Parameter :: specific_vol_h2o = 0.001  !Inverse Density of Particulate Water
 
C Constants used for simulating the ionic effects of sea-spray,
C windblown dust and anthropogenic dust in the coarse mode. These cation
C species are not transported individually in the domain but their
C relative abundance is assumed to be constant and scaled to the total
C SeaSalt_Cation, ASOIL, or Coarse-Mode Dust present.

      Real( 8 ), Parameter :: asoil_renorm = 1.0D0 - 0.04642D0  ! = 0.95358, same as ASOIL speciation factor in the dust_spc table above

      Real( 8 ), Parameter :: ascat_na_fac = 0.8373D0    ! for NA in coarse sea-spray aerosol
      Real( 8 ), Parameter :: asoil_na_fac = 0.0626D0    ! for NA in windblown dust
      Real( 8 ), Parameter :: acors_na_fac = 0.0023D0    ! for NA in anthropogenic coarse

      Real( 8 ), Parameter :: ascat_mg_fac = 0.0997D0    ! for MG in coarse sea-spray aerosol
      Real( 8 ), Parameter :: asoil_mg_fac = 0.0170D0    ! for MG in windblown dust
      Real( 8 ), Parameter :: acors_mg_fac = 0.0032D0    ! for MG in anthropogenic coarse

      Real( 8 ), Parameter :: ascat_k_fac =  0.0310D0    ! for K in coarse sea-spray aerosol
      Real( 8 ), Parameter :: asoil_k_fac =  0.0242D0    ! for K in windblown dust
      Real( 8 ), Parameter :: acors_k_fac =  0.0176D0    ! for K in anthropogenic coarse

      Real( 8 ), Parameter :: ascat_ca_fac = 0.0320D0    ! for CA in coarse sea spray aerosol
      Real( 8 ), Parameter :: asoil_ca_fac = 0.0838D0    ! for CA in windblown dust
      Real( 8 ), Parameter :: acors_ca_fac = 0.0562D0    ! for CA in anthropogenic coarse


      Real( 8 ), Parameter :: asoil_fe_fac = 0.02695D0   ! for FE in windblown dust
      Real( 8 ), Parameter :: acors_fe_fac = 0.0467D0    ! for FE in anthropogenic coarse

      Real( 8 ), Parameter :: asoil_mn_fac = 0.00075D0   ! for MN in windblown dust
      Real( 8 ), Parameter :: acors_mn_fac = 0.0011D0    ! for MN in anthropogenic coarse
 
C Coarse mode PMC speciation based on anthropogenic inventory composite from various
C sources (G. Pouliot - private communication):

      Real( 8 ), Parameter :: acorsem_aso4_fac = 0.00100D0
      Real( 8 ), Parameter :: acorsem_ano3_fac = 0.00048D0
      Real( 8 ), Parameter :: acorsem_acl_fac  = 0.00145D0
      Real( 8 ), Parameter :: acorsem_ah2o_fac = 0.00032D0
      Real( 8 ), Parameter :: acorsem_renorm   = 1.0D0
     &                                     - acorsem_aso4_fac
     &                                     - acorsem_ano3_fac
     &                                     - acorsem_acl_fac
     &                                     - acorsem_ah2o_fac
 
C Required species
      Character( 16 ), Private, Parameter :: req_so4    = 'ASO4'
      Character( 16 ), Private, Parameter :: req_no3    = 'ANO3'
      Character( 16 ), Private, Parameter :: req_cl     = 'ACL'
      Character( 16 ), Private, Parameter :: req_nh4    = 'ANH4'
      Character( 16 ), Private, Parameter :: req_na     = 'ANA'
      Character( 16 ), Private, Parameter :: req_mg     = 'AMG'
      Character( 16 ), Private, Parameter :: req_k      = 'AK'
      Character( 16 ), Private, Parameter :: req_ca     = 'ACA'
      Character( 16 ), Private, Parameter :: req_fe     = 'AFE'
      Character( 16 ), Private, Parameter :: req_mn     = 'AMN'
      Character( 16 ), Private, Parameter :: req_poc    = 'APOC'
      Character( 16 ), Private, Parameter :: req_ncom   = 'APNCOM'
      Character( 16 ), Private, Parameter :: req_h2o    = 'AH2O'
      Character( 16 ), Private, Parameter :: req_h3op   = 'AH3OP'
      Character( 16 ), Private, Parameter :: req_soil   = 'ASOIL'
      Character( 16 ), Private, Parameter :: req_cors   = 'ACORS'
      Character( 16 ), Private, Parameter :: req_seacat = 'ASEACAT'

C Indices of required species
      Integer :: aso4_idx
      Integer :: ano3_idx
      Integer :: acl_idx
      Integer :: anh4_idx
      Integer :: ana_idx
      Integer :: amg_idx
      Integer :: ak_idx
      Integer :: aca_idx
      Integer :: afe_idx
      Integer :: amn_idx
      Integer :: apoc_idx
      Integer :: apncom_idx
      Integer :: ah2o_idx
      Integer :: ah3op_idx
      Integer :: asoil_idx
      Integer :: acors_idx
      Integer :: aseacat_idx

C Flag if optional species present
      Logical :: ae6isoa = .False.
      Logical :: ae6hg   = .False.
      Logical :: ae7orgh2o = .False.
      Logical :: marine  = .False.

C Optional Species
      Character( 16 ), Private, Parameter :: req_ietet  = 'AIETET'
      Character( 16 ), Private, Parameter :: req_ieos   = 'AIEOS'
      Character( 16 ), Private, Parameter :: req_dim    = 'ADIM'
      Character( 16 ), Private, Parameter :: req_imga   = 'AIMGA'
      Character( 16 ), Private, Parameter :: req_imos   = 'AIMOS'
      Character( 16 ), Private, Parameter :: req_phgj   = 'APHGJ'
      Character( 16 ), Private, Parameter :: req_orgh2o = 'AORGH2O'
      Character( 16 ), Private, Parameter :: req_br     = 'ABR' 
      Character( 16 ), Private, Parameter :: req_so4aqh2o2 = 'ASO4AQH2O2'
      Character( 16 ), Private, Parameter :: req_so4aqo3   = 'ASO4AQO3'
      Character( 16 ), Private, Parameter :: req_so4aqfemn = 'ASO4AQFEMN'
      Character( 16 ), Private, Parameter :: req_so4aqmhp  = 'ASO4AQMHP'
      Character( 16 ), Private, Parameter :: req_so4aqpaa  = 'ASO4AQPAA'
      Character( 16 ), Private, Parameter :: req_so4gas    = 'ASO4GAS'
      Character( 16 ), Private, Parameter :: req_so4emis   = 'ASO4EMIS'
      Character( 16 ), Private, Parameter :: req_so4icbc   = 'ASO4ICBC'
      Character( 16 ), Private, Parameter :: req_oso4       = 'OSO4'
      Character( 16 ), Private, Parameter :: req_oso4aqh2o2 = 'OSO4AQH2O2'
      Character( 16 ), Private, Parameter :: req_oso4aqo3   = 'OSO4AQO3'
      Character( 16 ), Private, Parameter :: req_oso4aqfemn = 'OSO4AQFEMN'
      Character( 16 ), Private, Parameter :: req_oso4aqmhp  = 'OSO4AQMHP'
      Character( 16 ), Private, Parameter :: req_oso4aqpaa  = 'OSO4AQPAA'
      Character( 16 ), Private, Parameter :: req_oso4gas    = 'OSO4GAS'
      Character( 16 ), Private, Parameter :: req_oso4emis   = 'OSO4EMIS'
      Character( 16 ), Private, Parameter :: req_oso4icbc   = 'OSO4ICBC'

C Indices of Optional species
      Integer :: aietet_idx = 0
      Integer :: aieos_idx  = 0
      Integer :: adim_idx   = 0
      Integer :: aimga_idx  = 0
      Integer :: aimos_idx  = 0
      Integer :: aphgj_idx  = 0
      Integer :: aorgh2o_idx= 0
      Integer :: abr_idx    = 0
C Indices of Optional sulfur tracking species
      Integer :: aso4aqh2o2_idx = 0
      Integer :: aso4aqo3_idx   = 0
      Integer :: aso4aqfemn_idx = 0
      Integer :: aso4aqmhp_idx  = 0
      Integer :: aso4aqpaa_idx  = 0
      Integer :: aso4gas_idx    = 0
      Integer :: aso4emis_idx   = 0
      Integer :: aso4icbc_idx   = 0
      Integer :: oso4_idx       = 0
      Integer :: oso4aqh2o2_idx = 0
      Integer :: oso4aqo3_idx   = 0
      Integer :: oso4aqfemn_idx = 0
      Integer :: oso4aqmhp_idx  = 0
      Integer :: oso4aqpaa_idx  = 0
      Integer :: oso4gas_idx    = 0
      Integer :: oso4emis_idx   = 0
      Integer :: oso4icbc_idx   = 0

C Common Arrays for Aerosol Data
      Real, Allocatable :: aerospc_mw( : )     ! molecular weights (from AE_SPC Namelist) [ g/mol ]
      Real, Allocatable :: aerospc_mwinv( : )  ! reciprocal MWs (from AE_SPC Namelist) [ mol/g ]
      Real, Allocatable :: aerospc_conc( :,: ) ! aero species concentration [ ug/m^3 ]

C Common factors
      Real( 8 ) :: h2ofac                      ! converts mass concentrations [ug/m3] to 3rd moment concentrations [m3/m3]

C Variables for converting emission rates into molar-mixing-ratio units
      REAL,    PARAMETER :: GPKG = 1.0E+03     ! kg -> g
      REAL,    PARAMETER :: MGPG = 1.0E+06     ! g -> ug

C-------------------------------------------------------------------------------------------------------
      Type mode_type
         Character( 16 ) :: num_name     ! name of aerosol number variable
         Character( 16 ) :: srf_name     ! name of aerosol surface area variable
         Real            :: min_numconc  ! minimum number concentration
         Real            :: min_m2conc   ! minimum 2nd moment concentration
         Real            :: min_m3conc   ! minimum 3rd moment concentration
      End Type mode_type

      Type ( mode_type ), Parameter  :: aeromode( n_mode ) = (/
C                   number     surface   minimum minimum minimum
C                    name       name     numconc  m2conc  m3conc
C                  ----------  -------  -------- -------  ------
     &   mode_type('NUMATKN', 'SRFATKN', conmin,  conmin, conmin),
     &   mode_type('NUMACC ', 'SRFACC ', conmin,  conmin, conmin),
     &   mode_type('NUMCOR ', 'SRFCOR ', conmin,  conmin, conmin)/)


      Real          :: moment0_conc( n_mode )     ! 0th moment concentration
      Real          :: moment2_conc( n_mode )     ! 2nd moment concentration
      Real          :: moment3_conc( n_mode )     ! 3rd moment concentration
      Logical, save :: wet_moments_flag           ! T if M2 and M3 are wet, F otherwise

C Mass concentration (calculated by GETPAR)
      Real :: aeromode_mass( n_mode )   ! [ ug/m^3 ]

C Particle density (calculated by GETPAR)
      Real :: aeromode_dens( n_mode )   ! [ kg/m^3 ]

C Geometric mean diameter (calculated by GETPAR)
      Real :: aeromode_diam( n_mode )   ! [ m ]

C Log of geometric standard deviation (calculated by GETPAR )
      Real :: aeromode_lnsg( n_mode )

C Minimum number (calculated in map_aero routine)
      Real :: aeromode_minNum( n_mode )

C Minimum 2nd moment (calculated in map_aero routine)
      Real :: aeromode_minM2( n_mode )

C Mapping for loading from and unloading to CGRID array
      Integer, Allocatable :: aerospc_map( :,: )     ! indices of aero species to CGRID
      Integer              :: aeronum_map( n_mode )  ! indices of aero number variable to CGRID
      Integer              :: aerosrf_map( n_mode )  ! indices of aero surf area variable to CGRID

C Missing aerosol species map
      Logical, Allocatable :: aero_missing( :,: )  

      Logical, Save :: V51_SOA_mechanism   = .False. !
      Logical, Save :: AE_eflag            = .False. ! error flag for AERO_DATA
C IC/BC Correction Mapping
      !The following vectors store masks of the aerosol species
      !identities. For example, LBCNUM stores 1's for every species that
      !represents an aerosol number concentration and 0's otherwise.
      !   LBCNUM - Number Concentration
      !   LBCSURF - Surface Area Concentration
      !   LBCMASS - Mass Concentration
      !   LBCMODE - Mask for each aerosol mode
      LOGICAL, ALLOCATABLE, SAVE :: LBCNUM(:), LBCSRF(:), LBCMASS(:),
     &                        LBCMODE(:,:), LBCDRY(:)
      REAL, ALLOCATABLE, SAVE :: AEROCGRID_RHOINV( : ) !
      
C Private variables for loading from and unloading to CGRID array
      Logical, Private, Save :: mapped    = .False.
      Character( 16 ), Private, Save :: pname = 'Aero_Data'

! Variables for collecting tendencies for aerosol sub-processes and
! passing back to modules like Process analysis and ISAM. These vectors
! should be sized to the same length as the CGRID species dimension and
! be mapped to CGRID species order. Units for each are total
! concentration or mixing ratio gained or lost. These are not normalized
! by the time step. Ex (ppmv, ug m-3, N m-3, or m2 m-3)
      REAL, ALLOCATABLE :: COND_BUDGET( : )
      REAL, ALLOCATABLE :: COAG_BUDGET( :,: )
      REAL, ALLOCATABLE :: NPF_BUDGET( : )
      REAL, ALLOCATABLE :: GROWTH_BUDGET( : )

! Initial Reference Values for M2 and M3 used for Heterogenous Chemistry
! Module.
      REAL( 8 ), ALLOCATABLE, SAVE :: CHEM_M2DRY_INIT( :,:,:,: ),
     &                                CHEM_M3DRY_INIT( :,:,:,: )

      Contains

C-----------------------------------------------------------------------
      Subroutine map_aero()

C  Defines aerosol mapping from CGRID for species concentration and moments.
 
C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.

C HS  01/24/11 Renamed AORGPA as POC for AERO6
C GS  03/02/11 Find new req`d species for AERO6 (Mg, K, Ca)
C HS  03/10/11 Get index for new required species, PNCOM
C JY  03/22/16 Get index for new required species: Fe, Mn (aqchem)
C HOTP 05/11/16 Add IEPOX derived species
C-----------------------------------------------------------------------

      Use rxns_data       ! chemical mechanism data
      Use cgrid_spcs      ! CGRID mechanism species
      Use aeromet_data
      Use utilio_defn
      Use vdiff_data, only : n_spc_diff, diff_spc
      Implicit None

C Local Variables:
      Character( 256 ) :: xmsg
      Character( 256 ) :: xmsg2
      Real    :: mole_weight( n_aerolist )
      Integer :: map_listtogrid( n_aerolist,n_mode )
      Integer :: map_aerotolist( n_aerolist )

      Integer, Allocatable :: aerospc_in_dustlist( : )

      Integer l, m, n, spc, isea, idust
      Real    so4fac
      Real    anthfac

      Real    POA_OC    ! ratio of Elemental Oxygen to Carbon in POA
      Real    OOA_OC    ! ratio of Elemental Oxygen to Carbon in Oxygenated OA

      Integer dust_org1, dust_org2
      Logical ae6isoa
      Logical ae6hg
      Logical dust_match

      Character(16) sn

      If ( mapped ) Return

      Call LOG_SUBHEADING( LOGDEV, "Map Aerosol Species" )

      mole_weight = 0.0

      n_aerospc      = 0   ! Number of Used Aerosol Chemical Species
      map_listtogrid = 0   ! Pointer from aerolist to CGRID
      map_aerotolist = 0   ! Pointer from aerospc to aerolist
      AE_eflag       = .False.
      max_l2sg       = ( LOG( max_sigma_g ) ) ** 2
      min_l2sg       = ( LOG( min_sigma_g ) ) ** 2
      def_l2sg( : )  = ( LOG( def_sigma_g( : ) ) ) ** 2
      

      allocate( aerocgrid_rhoinv( n_ae_trns ), lbcnum( n_ae_trns ),
     &          lbcsrf( n_ae_trns ), lbcmass( n_ae_trns ),
     &          lbcmode( n_mode,n_ae_trns ), lbcdry( n_ae_trns ) )
      aerocgrid_rhoinv = 0.
      lbcnum = .False.
      lbcsrf = .False.
      lbcmass= .False.
      lbcmode= .False.
      lbcdry = .False.

C Build mapping to CGRID for each species in the master AeroList
      Do spc = 1, n_aerolist
         ! Check to see if this species is in the namelist
         do m = 1,n_mode
            if ( m .eq. n_mode .and. 
     &           (aerolist( spc )%bulkname .eq. 'ACORS'    .or.
     &            aerolist( spc )%bulkname .eq. 'ASOIL'    .or.
     &            aerolist( spc )%bulkname .eq. 'ASEACAT'  .or.
     &            aerolist( spc )%bulkname .eq. 'ADE_CORS' )    ) then
              sn = aerolist( spc )%bulkname
            else
              sn = trim( aerolist( spc )%bulkname ) // modesuff( m )
            end if

            n = index1( sn, n_ae_spc, ae_spc )

            If ( n .Ne. 0 ) Then
               ! Species is on the NameList
               If ( .Not. ( Any( map_listtogrid( spc,: ) .NE. 0 ) ) ) Then
                  ! Add this species to the map if it does not exist already
                  n_aerospc = n_aerospc + 1
                  map_aerotolist( n_aerospc ) = spc
                  ! Set the Molecular Weight
                  mole_weight( spc ) = ae_molwt( n )
               Else If ( mole_weight( spc ) .Ne. ae_molwt( n ) ) Then
                  ! If the species already exists and the
                  ! molecular weight from this mode on the
                  ! namelist is not matching the standing
                  ! molecular weight, throw an error
                  xmsg = 'The molecular weight of ' // Trim( sn )
     &                  // ' is different from that of the same species'
     &                  // ' in the same or another mode.'
                  Call m3warn( pname, 0, 0, xmsg )
                  Write( xmsg,* ) 'New Value(', n, ') = ', ae_molwt( n ),
     &                            'Expected value(', spc, ')= ', mole_weight( spc )
                  Call m3warn( pname, 0, 0, xmsg )
                  AE_eflag  = .True.
               End If
               ! Update the map from CGRID to AeroList for this mode
               map_listtogrid( spc,m ) = ae_strt - 1 + n
               lbcmode( m,n ) = .True.
               If ( .Not. aerolist( spc)%tracer )  lbcmass( n ) = .True.
               If ( .Not. aerolist( spc)%no_m2wet ) lbcdry( n ) = .True.
               !Map the CGRID Aerosol Species to their Densities
               aerocgrid_rhoinv( n ) = 1.0 / aerolist( spc )%density

            End If
         End Do
      End Do

      ! Migrate all of the user-requested aerosols from AeroList to
      ! AeroSpc. Begin by allocating all of the new arrays now that we
      ! know the value of n_aerospc
      Allocate ( aerospc       ( n_aerospc ) )
      Allocate ( aerospc_mw    ( n_aerospc ) )
      Allocate ( aerospc_mwinv ( n_aerospc ) )
      Allocate ( aerospc_map   ( n_aerospc, n_mode ) )
      Allocate ( aerospc_conc  ( n_aerospc, n_mode ) )
      Allocate ( aero_missing  ( n_aerospc, n_mode ) )

#ifdef sens
      Allocate ( s_aerospc_conc( n_aerospc,n_mode,npmax ) )
#endif

      aero_missing( :,: ) = .True.

      Do spc = 1, n_aerospc ! Loop through user-requested chemical species
         l = map_aerotolist( spc )

         ! Map AeroList Contents to AeroSpc
         aerospc( spc )%bulkname   = aerolist( l )%bulkname   
         aerospc( spc )%min_conc   = aerolist( l )%min_conc
         aerospc( spc )%density    = aerolist( l )%density   
         aerospc( spc )%no_M2wet   = aerolist( l )%no_M2Wet   
         aerospc( spc )%tracer     = aerolist( l )%tracer     
         aerospc( spc )%charge     = aerolist( l )%charge     
         aerospc( spc )%visual_idx = aerolist( l )%visual_idx 
         aerospc( spc )%visual_idx_large = aerolist( l )%visual_idx_large
         aerospc( spc )%om         = aerolist( l )%om         
         aerospc( spc )%optic_surr = aerolist( l )%optic_surr 
         aerospc( spc )%kappaorg   = aerolist( l )%kappaorg
         aerospc( spc )%name( : )  = ''

         ! Map mode-independent properties
         aerospc_mw( spc ) = mole_weight( l )
         aerospc_mwinv( spc ) = 1.0E0 / aerospc_mw( spc )

         Do n = 1,n_mode
            ! Map the Modal-Dependent CGRID Pointers from AeroSpc to AeroList
            aerospc_map( spc, n ) = map_listtogrid( l, n )

            ! Remove this Chemical/Mode Combination from the "missing" list 
            ! if it can be mapped to the cgrid list of variables
            if ( aerospc_map( spc,n ) .ne. 0 ) then
                aero_missing( spc,n ) = .False.
                ! Create Mode-Dependent Names
                if ( aerospc( spc )%bulkname .eq. 'ACORS'    .or.
     &               aerospc( spc )%bulkname .eq. 'ASOIL'    .or.
     &               aerospc( spc )%bulkname .eq. 'ASEACAT'  .or.
     &               aerospc( spc )%bulkname .eq. 'ADE_CORS'     ) then
                   aerospc( spc )%name( n ) = trim( aerospc( spc )%bulkname )
                else
                   aerospc( spc )%name( n ) = 
     &                 trim( aerospc( spc )%bulkname ) // modesuff( n )
                end if
            end if
         End Do

      End Do

C Build mapping to CGRID for aero # and surf area variables
      aeronum_map = 0
      aerosrf_map = 0

      Do m = 1, n_mode
         n = index1( aeromode( m )%num_name , n_ae_spc, ae_spc )
         If ( n .Eq. 0 ) Then
            xmsg = 'Species ' // Trim( aeromode( m )%num_name )
     &           //' is not in AE namelist'
            AE_eflag  = .True.
            Call m3warn( pname, 0, 0, xmsg )
!            Call m3exit( pname, 0, 0, xmsg, xstat3 )
         Else
            aeronum_map( m ) = ae_strt - 1 + n
            aerocgrid_rhoinv( n ) = 1.0
            lbcnum( n ) = .True.
            lbcmode( m,n ) = .True.
         End If

         n = index1( aeromode( m )%srf_name , n_ae_spc, ae_spc )
         If ( n .Eq. 0 ) Then
            xmsg = 'species ' // Trim( aeromode( m )%srf_name )
     &           // ' is not in AE namelist'
            AE_eflag  = .True.
            Call m3warn( pname, 0, 0, xmsg )
!            Call m3exit( pname, 0, 0, xmsg, xstat3 )
         Else
            aerosrf_map( m ) = ae_strt - 1 + n
            aerocgrid_rhoinv( n ) = 1.0
            lbcsrf( n ) = .True.
            lbcmode( m,n ) = .True.
         End If
      End Do

C Find indices of required species
      aso4_idx    = findAero( req_so4,    .True. )
      ano3_idx    = findAero( req_no3,    .True. )
      acl_idx     = findAero( req_cl,     .True. )
      anh4_idx    = findAero( req_nh4,    .True. )
      ana_idx     = findAero( req_na,     .True. )
      amg_idx     = findAero( req_mg,     .True. )
      ak_idx      = findAero( req_k,      .True. )
      aca_idx     = findAero( req_ca,     .True. )
      afe_idx     = findAero( req_fe,     .True. )
      amn_idx     = findAero( req_mn,     .True. )
      ah2o_idx    = findAero( req_h2o,    .True. )
      ah3op_idx   = findAero( req_h3op,   .True. )
      asoil_idx   = findAero( req_soil,   .True. )
      acors_idx   = findAero( req_cors,   .True. )
      aseacat_idx = findAero( req_seacat, .True. )
      apoc_idx    = findAero( req_poc,    .True. )
      apncom_idx  = findAero( req_ncom,   .True. )

      If ( ( Index( mechname, 'SAPRC07TIC_AE6I' ) .Gt. 0 ) .OR.
     &     ( Index( mechname, 'SAPRC07TIC_AE7I' ) .Gt. 0 )  ) Then
         ae6isoa     = .True.
         aietet_idx  = findAero( req_ietet, ae6isoa )
         aieos_idx   = findAero( req_ieos,  ae6isoa )
         adim_idx    = findAero( req_dim,   ae6isoa )
         aimga_idx   = findAero( req_imga,  ae6isoa )
         aimos_idx   = findAero( req_imos,  ae6isoa )
      Else
         aietet_idx  = 0
         aieos_idx   = 0
         adim_idx    = 0
         aimga_idx   = 0
         aimos_idx   = 0
         ae6isoa     = .False.
      End If

      If ( Index( mechname, 'CB6R3M_AE7_KMTBR' ) .Gt. 0 ) Then
         abr_idx     = findAero( req_br,     .True. )
         marine = .True.
      Else
         abr_idx     = 0
         marine = .False.
      End If

      aphgj_idx = findAero( req_phgj,  .False. )
      If ( aphgj_idx .Gt. 0 ) Then
         ae6hg     = .True.
      Else
         aphgj_idx = 0 
         ae6hg     = .False.
      End If

C AORGH2O is not required, but highly recommended for aero7
      aorgh2o_idx = findAero( req_orgh2o,  .False. )
      If ( aorgh2o_idx .Gt. 0 ) Then
         ae7orgh2o   = .True.
      Else
         aorgh2o_idx = 0
         ae7orgh2o   = .False.
      End If

      If ( stm ) Then
         aso4aqh2o2_idx = findAero( req_so4aqh2o2, .True. )
         aso4aqo3_idx   = findAero( req_so4aqo3,   .True. )
         aso4aqfemn_idx = findAero( req_so4aqfemn, .True. )
         aso4aqmhp_idx  = findAero( req_so4aqmhp,  .True. )
         aso4aqpaa_idx  = findAero( req_so4aqpaa,  .True. )
         aso4gas_idx    = findAero( req_so4gas,    .True. )
         aso4emis_idx   = findAero( req_so4emis,   .True. )
         aso4icbc_idx   = findAero( req_so4icbc,   .True. )
         If ( ( ae6isoa ) .OR.
     &        ( Index( mechname, 'CB6R3_AE7'       ) .Gt. 0 ) .OR.
     &        ( Index( mechname, 'CB6R3M_AE7'      ) .Gt. 0 ) ) Then
            oso4_idx       = findAero( req_oso4,       .True. )
            oso4aqh2o2_idx = findAero( req_oso4aqh2o2, .True. )
            oso4aqo3_idx   = findAero( req_oso4aqo3,   .True. )
            oso4aqfemn_idx = findAero( req_oso4aqfemn, .True. )
            oso4aqmhp_idx  = findAero( req_oso4aqmhp,  .True. )
            oso4aqpaa_idx  = findAero( req_oso4aqpaa,  .True. )
            oso4gas_idx    = findAero( req_oso4gas,    .True. )
            oso4emis_idx   = findAero( req_oso4emis,   .True. )
            oso4icbc_idx   = findAero( req_oso4icbc,   .True. )
         EndIf
      EndIf

C Compute common factors
      h2ofac = 1.0D-9 * f6dpi / Real( aerospc( ah2o_idx )%density, 8 )

C compute aeromode_minNum and aeromode_minM2
      so4fac  = 1.0E-9 * Real( f6dpi, 4 ) / aerospc( aso4_idx )%density
      anthfac = 1.0E-9 * Real( f6dpi, 4 ) / aerospc( acors_idx )%density

      Do m = 1, n_mode
         If ( m .Lt. n_mode ) Then
            aeromode_minNum( m ) = aerospc( aso4_idx )%min_conc( m ) /
     &           ( def_diam( m )**3 * Exp( 4.5 * Log( def_sigma_g( m ) )**2 ) )
            aeromode_minNum( m ) = aeromode_minNum( m ) * so4fac 
            aeromode_minNum( m ) = Max( aeromode_minNum( m ), conmin )
         Else
            aeromode_minNum( m ) = aerospc( acors_idx )%min_conc( m ) /
     &           ( def_diam( m )**3 * Exp( 4.5 * Log( def_sigma_g( m ) )**2 ) )
            aeromode_minNum( m ) = aeromode_minNum( m ) * anthfac 
            aeromode_minNum( m ) = Max( aeromode_minNum( m ), conmin )
         End If
         aeromode_minM2( m ) = aeromode_minNum( m ) *
     &             def_diam( m )**2 * Exp( 2.0 * Log( def_sigma_g( m ) )**2 )
      End do

      if( AE_eflag )Then
         Write(logdev,99901) Trim( mechname )
          xmsg = 'The FATAL errors found in namelist used. Check '
     &    //  'the log of exiting processor if more details are needed.'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If 

      mapped = .True.


99901 Format( 'FATAL Error(s) found in the AE namelist used. Check that' 
     &  /' this AE namelist contains the above required data '
     &  / 'as the file in '
     &  /'the respository version of the mechanism: ', a )
      Return
      End Subroutine map_aero

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine extract_aero( conc, minchk, s_conc, schk )
#else
      Subroutine extract_aero( conc, minchk )
#endif

C  Extracts aerosol data into the AERO_DATA:aerospc_conc array
C  The original idea is that the data for conc comes from CGRID
C  Also transfers dry surface area to wet 2nd moment.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     4/2016: Updated for 2nd moment by H. Pye and B. Murphy
C-----------------------------------------------------------------------

      Use aeromet_data, only : pi, f6pi  ! fundamental constants, data type definitions, etc.

      Implicit None

C Arguments:
      Real,    Intent( In ) :: conc( : )
      Logical, Intent( In ) :: minchk
#ifdef sens
      Real,    Intent( In ) :: s_conc( :,: )
      Logical, Intent( In ) :: schk  ! necessary because some routines don't require sensitivity updates
#endif

C Local Variables:
      Integer m, n, spc

      If ( .Not. mapped ) Then
         Call map_aero()
      End If

#ifdef sens
      If ( schk ) Then
         If ( .Not. ae_ddm3d_ready ) Then
            Call init_aero_ddm3d()
         End If
      End If
#endif

C Copy grid cell concentrations of aero species to aerospc_conc
      aerospc_conc = 0.0
#ifdef sens
      If ( schk ) Then
         s_aerospc_conc = 0.0D0
      End If
#endif
      If ( minchk ) Then
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                  aerospc_conc( spc,m ) = Max( conc( n ), aerospc( spc )%min_conc( m ) ) ! [ug/m^3]
#ifdef sens
                  If ( schk ) Then
                     Do np = 1, npmax
                        If ( aerospc_conc( spc,m ) .Eq. aerospc( spc )%min_conc( m ) ) Then
                           s_aerospc_conc( spc,m,np ) = 0.0D0
                        Else
                           s_aerospc_conc( spc,m,np ) = Real( s_conc( np,n ), 8 )
                        End If
                     End Do
                  End If
#endif
               End If
            End Do
         End Do
      Else
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                  aerospc_conc( spc,m ) = conc( n )   ! [ug/m^3]
#ifdef sens
                  If ( schk ) Then
                     Do np = 1, npmax
                        s_aerospc_conc( spc,m,np ) = Real( s_conc( np,n ), 8 )
                     End Do
                  End If
#endif
               End If
            End Do
         End Do
      End If

      ! Calculate Dry Third Moment [ m3 / m3 ]
      Do m = 1, n_mode
         moment3_conc( m ) = sum( aerospc_conc(:,m) / aerospc(:)%density,
     &      MASK= ( ( .NOT. aerospc%no_M2wet ) .AND.
     &              ( .NOT. aerospc%Tracer ) ) )
         moment3_conc( m ) = max( moment3_conc( m ) * 1.0E-9 * f6pi,
     &                            aeromode( m )%min_m3conc )
      End Do

C Copy grid cell concentrations of aero # and surf area
C Convert surface area to M2 and set wet_moments_flag

      moment0_conc = 0.0
      moment2_conc = 0.0

      If ( minchk ) Then
         Do m = 1, n_mode
            n = aeronum_map( m )
            moment0_conc( m ) = Max( conc( n ), aeromode( m )%min_numconc )
            n = aerosrf_map( m )
            moment2_conc( m ) = Max( conc( n ) / pi, aeromode( m )%min_m2conc )
         End Do
      Else
         Do m = 1, n_mode
            n = aeronum_map( m )
            moment0_conc( m ) = conc( n )
            n = aerosrf_map( m )
            moment2_conc( m ) = conc( n ) / pi
         End Do
      End If
      wet_moments_flag = .false.

C Convert dry 2,3 moment to wet 2,3 moment
C flag will be set to .true.
      Call calcmoments( .true. )

      Return
      End Subroutine extract_aero

C-----------------------------------------------------------------------
#ifdef sens
      Subroutine update_aero( conc, minchk, s_conc )
#else
      Subroutine update_aero( conc, minchk )
#endif

C  Updates conc from the AERO_DATA:aerospc_conc array.
C  The original idea is that the data in conc updates CGRID
C  Update_aero now also saves the updated surface area back to CGRID as
C  well. Moment2 will be dried if necessary and flag reset.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     4/2016: Updated for 2nd moment by H. Pye and B. Murphy
C-----------------------------------------------------------------------

      Use aeromet_data, only : pi     ! fundamental constants, data type definitions, etc.
      Use utilio_defn

      Implicit None

C Arguments:
      Real, Intent( Out ) :: conc( : )
      Logical, Intent( In ) :: minchk
#ifdef sens 
      Real,    Intent( Out ) :: s_conc( :,: )
#endif

C Local variables:
      Character( 80 ) :: xmsg
      Integer m, n, spc

      If ( .Not. mapped ) Then
         xmsg = 'CGRID Species has not been mapped'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If

C Copy aerospc_conc back to grid cell concentrations

      If ( minchk ) Then
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                    conc( n ) = Max( aerospc_conc( spc,m ), aerospc( spc )%min_conc( m ) )
#ifdef sens
                    Do np = 1, npmax
                       If ( conc( n ) .Eq. aerospc( spc )%min_conc( m ) ) Then
                          s_conc( np,n ) = 0.0
                       Else
                          s_conc( np,n ) = Real( s_aerospc_conc( spc,m,np ), 4 )
                       End If
                    End Do
#endif
               End If
            End Do
         End Do
      Else
         Do m = 1, n_mode
            Do spc = 1, n_aerospc
               n = aerospc_map( spc,m )
               If ( n .Ne. 0 ) Then
                    conc( n ) = aerospc_conc( spc,m )
#ifdef sens
                    Do np = 1, npmax
                       s_conc( np,n ) = Real( s_aerospc_conc( spc,m,np ), 4 )
                    End Do
#endif
               End If
            End Do
         End Do
      End If

C Copy aero number and surface area back to grid cell concentrations

      If ( minchk ) Then
         Do m = 1, n_mode
            n = aeronum_map( m )
            conc( n ) = Max( moment0_conc( m ), aeromode( m )%min_numconc )
         End Do
      Else
         Do m = 1, n_mode
            n = aeronum_map( m )
            conc( n ) = moment0_conc( m )
         End Do
      End If

C Save dry second moment to surface area (with pi conversion)
      If ( wet_moments_flag ) Then
         Call calcmoments( .False. ) ! called with the F flag, returns dry moments
      End If

      Do m = 1, n_mode
         n = aerosrf_map( m )
         conc( n ) = Real( pi, 4 ) * moment2_conc( m )
      End Do

      Return
      End Subroutine update_aero

C-----------------------------------------------------------------------
      Function findAero( vname, required ) Result ( idx )

C  Finds the index of 'required' aerosol species in the aerospc list

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C-----------------------------------------------------------------------

      Use utilio_defn

      Implicit None

C Arguments:
      Character( 16 ) :: vname
      Logical :: required
      Integer :: idx

C Local Variables:
      Character( 80 ) :: xmsg
      Integer spc, n

      idx = 0
C Find the substring vname in aerospc( spc )%name( n )
      Do spc = 1, n_aerospc
         If ( aerospc( spc )%bulkname .eq. vname ) Then
            idx = spc
            Return
         End If
         Do n = 1, n_mode
            If ( aerospc( spc )%name( n ) .eq. vname ) Then
               idx = spc
               Return
            End If
         End Do
      End Do

      If ( .Not. required ) Then
         xmsg = 'Optional Species '
     &       // Trim( vname ) // ' Not found in AE namelist.'
         write(logdev,'(5x,a)') xmsg
         Return
      End If

      xmsg = 'Required Species ' // Trim( vname ) // 
     &       ' Not found in AE namelist'
      AE_eflag  = .True.
      Call m3warn( pname, 0, 0, xmsg )

      Return
      End Function findAero

C-----------------------------------------------------------------------
      Subroutine calcmoments( addwet )

C Subroutine calculates wet (addwet=T) or dry (addwet=F) aerosol third
C and second moment and stores them in moment_conc arrays and
C updates wet_moments_flag.
C Note that third moment information will be overwritten no matter what
C the wet_moments_flag indicates. M2 will depend on the history
C of the moment (wet_moments_flag). This routine will not update
C M2 in the event of added mass due to processes other than
C wetting/drying.
C
C Notes:
C wet_moments_flag is obtained from AERO_DATA ! true =  H2O and SOA included in 2,3 moment
C                                             ! false = H2O and SOA excluded from 2,3 moment
C wet_moments_flag reflects the current state of the moment2,3_conc arrays.
C addwet will results in wet (T) or dry (F) moments.
C
C History:
C 4/2016: HOT Pye Created routine
C
C-----------------------------------------------------------------------

      Use aeromet_data, only: f6dpi, f6pi

      Implicit None

C Arguments:
      Logical :: addwet ! T: result in wet m3 and m2, F: result in dry m3 and m2

C Parameters:
      Real( 8 ), Parameter :: two3rds = 2.0D0 / 3.0D0

C Local variables:
      Integer :: spc, n ! loop variable
      Real( 4 ) :: m3( n_mode )       ! wet or dry M3
      Real( 4 ) :: m2( n_mode )       ! wet or dry M2
      Real( 8 ) :: drysumM3  ! dry M3 [ m**3 / m**3 ]
      Real( 8 ) :: wetsumM3  ! wet M3 [ m**3 / m**3 ]
      Real( 8 ) :: factor
      Real( 4 ) :: initialM3 ! initial M3 from moment3_conc [ m**3 /m**3 ]
      Real( 4 ) :: initialM2 ! initial M2 from moment2_conc [ m**2 /m**3 ]

      Character( 16 )  :: pname_loc = 'CalcMoments'
      Character( 100 ) :: xmsg

C *** Calculate aerosol 3rd moment concentrations [ m**3 / m**3 ], 2nd
C     moment [ m**2/m**3 ]

      If( addwet ) then

         Do n = 1, n_mode
            initialM2 = moment2_conc( n )
            If ( initialM2 .Eq. 0.0 ) Then
                write( xmsg,'(A32,I1,A42)') "Warning: Second Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                Call m3warn( pname_loc, 0, 0, xmsg )
            End If

            initialM3 = max( moment3_conc( n ), aeromode( n )%min_m3conc )
            If ( initialM3 .Eq. 0.0 ) Then
                write( xmsg,'(A31,I1,A42)') "Warning: Third Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                call m3warn( pname_loc, 0, 0, xmsg )
            End If

            wetsumM3 = 0.0d0
            Do spc = 1, n_aerospc
               If ( aerospc( spc )%tracer .Or. aero_missing(spc,n) ) Cycle
               factor = Real( 1.0E-9 * f6pi / aerospc( spc )%density, 8 )
               wetsumM3  = wetsumM3 + factor * Real( aerospc_conc( spc,n ), 8 )
            End Do
            m3( n ) = Max ( Real( wetsumM3, 4 ), aeromode( n )%min_m3conc )
            If ( wet_moments_flag ) Then
               m2( n ) = initialM2
            Else
               m2( n ) = initialM2 * ( Real( wetsumM3, 4 ) / initialM3 ) ** Real( two3rds, 4 )
            End if
         End Do

         ! Save back to aero_data variables
         moment2_conc( : ) = m2( : )
         moment3_conc( : ) = m3( : )
         wet_moments_flag = .True.

      Else ! produce dry moments

         Do n = 1, n_mode
            initialM2 = moment2_conc( n )
            If ( initialM2 .Eq. 0.0 )  Then
                write( xmsg,'(A32,I1,A42)') "Warning: Second Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                Call m3warn( pname_loc, 0, 0, xmsg )
            End If

            initialM3 = max( moment3_conc( n ), aeromode( n )%min_m3conc )
            If ( initialM3 .Eq. 0.0 )  Then
                write( xmsg,'(A31,I1,A42)') "Warning: Third Moment for Mode ",
     &                 n," is 0.0. This will cause numerical issues."
                Call m3warn( pname_loc, 0, 0, xmsg )
            End If

            drysumM3 = 0.0d0
            Do spc = 1, n_aerospc
               If ( aerospc( spc )%tracer .Or. aero_missing(spc,n) .Or.
     &              aerospc( spc )%no_M2Wet  ) Cycle
               factor = Real( 1.0E-9 * f6pi /  aerospc( spc )%density, 8 )
               drysumM3  = drysumM3 + factor * Real( aerospc_conc( spc,n ), 8 )
            End Do
            m3( n ) = Max ( Real( drysumM3, 4 ), aeromode( n )%min_m3conc )
            If ( wet_moments_flag) Then
               m2( n ) = initialM2 * ( Real( drysumM3, 4 ) / initialM3 ) ** Real( two3rds, 4 )
            Else ! already dry
               m2( n ) = initialM2
            End If
         End Do

         ! Save back to aero_data variables
         moment2_conc( : ) = m2( : )
         moment3_conc( : ) = m3( : )
         wet_moments_flag = .False.

      End If

      Return
      End Subroutine calcmoments

C
C-----------------------------------------------------------------------
      Subroutine CHECK_AERO_ICBC( IBCON, AE_MASS_UNIT, STAT, AER_PAR, LMODE )

C Subroutine corrects the scale factors for number, surface area when a 
C change has happened to the mass of any boundary condition species.
C Eventually this code should perform a similar operation for the
C initial conditions, but this is somewhat complicated and needs to be
C thought through more.
C
C Inputs:  IBCON - the actual initial or boundary conditions from the
C                  calling routine
C          ICBC_FAC - The scale factor used to modify IBCON right before
C                     this routine is called
C
C 11 May 16  B.Murphy  Program Written
C
C-----------------------------------------------------------------------
      Use AEROMET_DATA, only : pi, f6pi

      Implicit None

      REAL, INTENT(INOUT)        :: IBCON( : )
      LOGICAL, INTENT( IN ) :: AE_MASS_UNIT  ! FALSE for KGM3 input
                                             ! TRUE  for UGM3 input
      INTEGER, INTENT(OUT)       :: STAT     ! 0 - Distribution is ok
                                             ! 1 - Distribution is problematic
      REAL, INTENT(OUT) :: AER_PAR( 2, N_MODE, 5 ) !Track the modal parameters   (N, M2, M3, dg, sg) -Before
                                                   !before and after the BC      (N, M2, M3, dg, sg) -After
                                                   !check routine               
      INTEGER, INTENT(OUT) :: LMODE  !Identifies the problematic mode

      INTEGER          :: LSTAT

      REAL, PARAMETER  :: F1PI = 1.0 / pi
      REAL, PARAMETER  :: ONE_THIRD  = 1.0 / 3.0
      REAL, PARAMETER  :: TWO_THIRDS = 2.0 / 3.0


C Local variables:

      INTEGER   :: IMODE
      REAL      :: NUM, M2, M3, l2sg, dg, sg
      REAL, Parameter :: KGPMG = 1.0E-9 !Kilogram per microgram m-3

      LMODE   = 0
      STAT    = 0
      AER_PAR = 0.0
      dg      = 0.0
      sg      = 0.0
       
      CALL MAP_AERO()

      !Loop Through Each Aerosol Mode. Sum up the third moment, then
      !calculate the Dg and Sg of the mode and check to make sure they
      !are valid
      DO IMODE = 1,N_MODE
         LSTAT = 0

         NUM = SUM( IBCON( : ), MASK = ( LBCMODE( IMODE,: ) .AND. LBCNUM ) )
         M2  = SUM( IBCON( : ), MASK = ( LBCMODE( IMODE,: ) .AND. LBCSRF ) ) * F1PI

         M3 = SUM( IBCON( : ) * AEROCGRID_RHOINV * F6PI, 
     &             MASK = ( LBCMASS .AND. LBCMODE( IMODE,: ) .AND. LBCDRY( : ) )  )

         IF ( AE_MASS_UNIT ) M3 = M3 * KGPMG

         AER_PAR ( 1, IMODE, 1 ) = NUM
         AER_PAR ( 1, IMODE, 2 ) = M2
         AER_PAR ( 1, IMODE, 3 ) = M3
         AER_PAR ( 1, IMODE, 4 ) = 0.    
         AER_PAR ( 1, IMODE, 5 ) = 0.    

         IF ( M3 .LT. 1.0e-30 ) THEN
             LSTAT = 4
             LMODE = IMODE
         ELSE IF ( NUM .LT. 1.0e-30 .OR. M2 .LT. 1.0e-30 ) THEN
             LSTAT = 3
             LMODE = IMODE
         ELSE                  
             l2sg = ( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3 ) - LOG( M2 ))

             IF ( l2sg .LT. MIN_L2SG .OR. l2sg .GT. MAX_L2SG ) THEN 
                  LSTAT = 2
                  LMODE = IMODE
             ELSE

                  dg   = ( M3 / NUM * EXP( -4.5 * l2sg ) )  ** ( ONE_THIRD )
                  sg   = EXP( SQRT( l2sg ) )
                  AER_PAR( 1, IMODE, 4 ) = dg
                  AER_PAR( 1, IMODE, 5 ) = sg

                  IF ( dg .LT. MIN_DIAM_G( IMODE )  .OR. dg .GT. MAX_DIAM_G( IMODE ) ) THEN
                      LSTAT = 1
                      LMODE = IMODE
                  ENDIF
              ENDIF     
         ENDIF

         !Save Modal Properties After the Check
         AER_PAR( 2, IMODE, 1 ) = NUM
         AER_PAR( 2, IMODE, 2 ) = M2
         AER_PAR( 2, IMODE, 3 ) = M3
         AER_PAR( 2, IMODE, 4 ) = dg
         AER_PAR( 2, IMODE, 5 ) = sg

         IF ( LSTAT .GT. 0 .AND. LSTAT .LT. 4 ) THEN
           STAT = LSTAT

           !Rewrite Boundary Condition Number and Surface Area to Satisfy
           !Default Size Parameters
           l2sg = DEF_L2SG( IMODE )
           NUM = M3 * ( EXP( -4.5 * l2sg ) ) / ( DEF_DIAM( IMODE ) ) ** 3
           dg   = ( M3 / NUM * EXP( -4.5 * l2sg ) ) ** ( ONE_THIRD )
           sg   = EXP( SQRT( l2sg ) )
           
           !First Number Concentration
           WHERE( LBCMODE( IMODE,: ) .AND. LBCNUM ) IBCON = NUM
           
           !Then Surface Area Concentration
           M2 = EXP( ONE_THIRD * LOG( NUM ) + TWO_THIRDS * LOG( M3 ) - l2sg )
           WHERE( LBCMODE( IMODE,: ) .AND. LBCSRF ) IBCON = M2 * F1PI
         
           !Save Modal Properties After the Check
           AER_PAR( 2, IMODE, 1 ) = NUM
           AER_PAR( 2, IMODE, 2 ) = M2
           AER_PAR( 2, IMODE, 3 ) = M3
           AER_PAR( 2, IMODE, 4 ) = dg
           AER_PAR( 2, IMODE, 5 ) = sg

         ELSEIF ( LSTAT .EQ. 4 ) THEN
           STAT = LSTAT

           WHERE( LBCMODE( IMODE,: ) .AND. LBCNUM ) IBCON =
     &                             aeromode_minnum( IMODE )  !Number
           WHERE( LBCMODE( IMODE,: ) .AND. LBCSRF ) IBCON = 
     &                             aeromode_minM2 ( IMODE )  !Second Moment
           WHERE( LBCMODE( IMODE,: ) .AND. LBCMASS) IBCON = conmin  !Third Moment
           !Save Modal Properties After the Check
           AER_PAR( 2, IMODE, 1 ) = aeromode_minnum( IMODE )  !Number
           AER_PAR( 2, IMODE, 2 ) = aeromode_minM2 ( IMODE )  !Second Moment
           AER_PAR( 2, IMODE, 3 ) = conmin
           AER_PAR( 2, IMODE, 4 ) = 0.
           AER_PAR( 2, IMODE, 5 ) = 0.
         ENDIF

      ENDDO

      End Subroutine CHECK_AERO_ICBC

      End Module aero_data

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SUBHFILE ( FNAME, GXOFF, GYOFF,
     &                      STRTCOL, ENDCOL, STRTROW, ENDROW )

C 11 May 11 D.Wong: incorporated twoway model implementation
C 10 Mar 14 D.Wong: turned off GXOFF and GYOFF check for the twoway model
C                   since METCRO is one grid cell bigger than the other
C                   files to avoid M3EXIT issue
C  1 Feb 19 David Wong: removed all MY_N clauses

C returns local starting and ending column and row indices for file FNAME

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN

      IMPLICIT NONE
 
C Includes:
 
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      CHARACTER( 16 ), INTENT( IN )  :: FNAME
      INTEGER,         INTENT( OUT ) :: GXOFF ! X global origin offset from file (.ge. 0)
      INTEGER,         INTENT( OUT ) :: GYOFF ! Y global origin offset from file (.ge. 0)
      INTEGER,         INTENT( OUT ) :: STRTCOL ! local processor start colum in file
      INTEGER,         INTENT( OUT ) ::  ENDCOL ! local processor end colum in file
      INTEGER,         INTENT( OUT ) :: STRTROW ! local processor start row in file
      INTEGER,         INTENT( OUT ) ::  ENDROW ! local processor end row in file

C External Functions:
  
C Parameters

      REAL( 8 ), PARAMETER :: HALF = 0.5D+00
      REAL( 8 ), PARAMETER :: ONE  = 1.0D+00
      REAL( 8 ), PARAMETER :: TEN  = 1.0D+01
      REAL( 8 ), PARAMETER :: ONEK = 1.0D+03
      REAL( 8 ), PARAMETER :: TENK = 1.0D+04
      REAL( 8 ), PARAMETER :: TOL  = ONE / ONEK
      REAL( 8 ), PARAMETER :: THOU = 1.0D-03
      REAL( 8 ), PARAMETER :: MIN_DOUBLE = 1.0D-08

C local variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER       :: INDX                 ! because mype starts at 0
      CHARACTER( 16 ) :: PNAME = 'SubhFile_Cell'
      CHARACTER( 16 ) :: BNAME
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER       :: LOC_STRTCOL, LOC_ENDCOL, LOC_STRTROW, LOC_ENDROW

      REAL( 8 ), SAVE :: XORIG_B, YORIG_B
      REAL( 8 ), SAVE :: XCENT_B, YCENT_B
      REAL( 8 ), SAVE :: XCELL_B, YCELL_B
      REAL( 8 ), SAVE :: XORIG_C, YORIG_C  ! from GRIDDESC, in cell coord
      REAL( 8 ), SAVE :: XORIG_F, YORIG_F  ! from file, in cell coord

      INTEGER DOTFILE
      REAL( 8 ) :: RELOFFX, RELOFFY

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

C open cross file for subsequent comparison

         BNAME = TRIM( GRID_CRO_2D )

         IF ( .NOT. OPEN3( BNAME, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open '// BNAME
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF

         IF ( .NOT. DESC3( BNAME ) ) THEN
            XMSG = 'Could not get ' // BNAME // ' file description'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF

C set base header data

         XORIG_B = XORIG3D
         YORIG_B = YORIG3D
         XCENT_B = XCENT3D
         YCENT_B = YCENT3D
         XCELL_B = XCELL3D
         YCELL_B = YCELL3D

C Scale resolution

         XCELL_B = REAL( IDNINT( TENK * XCELL_B ), 8 ) / TENK
         YCELL_B = REAL( IDNINT( TENK * YCELL_B ), 8 ) / TENK

C Convert to grid cell coord and truncate

         XORIG_B = XORIG_B / XCELL_B
         XORIG_B = REAL( IDNINT( ONEK * XORIG_B ), 8 ) / ONEK
         YORIG_B = YORIG_B / YCELL_B
         YORIG_B = REAL( IDNINT( ONEK * YORIG_B ), 8 ) / ONEK

         XORIG_C = XORIG_GD / XCELL_GD
         XORIG_C = REAL( IDNINT( ONEK * XORIG_C ), 8 ) / ONEK
         YORIG_C = YORIG_GD / YCELL_GD
         YORIG_C = REAL( IDNINT( ONEK * YORIG_C ), 8 ) / ONEK

      END IF   ! FIRSTIME

C open existing file for readonly access

      IF ( .NOT. OPEN3( FNAME, FSREAD3, PNAME ) ) THEN
         XMSG = 'Could not open '// FNAME
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
      END IF

      IF ( .NOT. DESC3( FNAME ) ) THEN
         XMSG = 'Could not get ' // TRIM( FNAME )
     &        // ' file description'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C check some header data against the reference file in this met set -
C mother grid center and grid cell resolution

      IF ( ABS( XCENT3D - XCENT_B ) .GT.
     &     TOL * ABS( XCENT3D + XCENT_B + TOL ) .OR.
     &     ABS( YCENT3D - YCENT_B ) .GT.
     &     TOL * ABS( YCENT3D + YCENT_B + TOL ) .OR.
     &     ABS( XCELL3D - XCELL_B ) .GT. TOL * XCELL3D .OR.
     &     ABS( YCELL3D - YCELL_B ) .GT. TOL * YCELL3D ) THEN
         WRITE( LOGDEV,2003 ) XCENT_B, XCENT3D, YCENT_B, YCENT3D,
     &                        XCELL_B, XCELL3D, YCELL_B, YCELL3D
2003     FORMAT(/ 5X, 'XCENT_B:', F20.12, 2X, 'XCENT3D (file):', F20.12 
     &          / 5X, 'YCENT_B:', F20.12, 2X, 'YCENT3D (file):', F20.12
     &          / 5X, 'XCELL_B:', F20.12, 2X, 'XCELL3D (file):', F20.12 
     &          / 5X, 'YCELL_B:', F20.12, 2X, 'YCELL3D (file):', F20.12 )

         XMSG = 'File header inconsistent with GRID_CRO_2D'
#ifndef twoway
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
#endif
      END IF

C check some header data against GRIDDESC

      IF ( ABS( XCENT3D - XCENT_GD ) .GT.
     &     TOL * ABS( XCENT3D + XCENT_GD + TOL ) .OR.
     &     ABS( YCENT3D - YCENT_GD ) .GT.
     &     TOL * ABS( YCENT3D + YCENT_GD + TOL ) .OR.
     &     ABS( XCELL3D - XCELL_GD ) .GT. TOL * XCELL3D .OR.
     &     ABS( YCELL3D - YCELL_GD ) .GT. TOL * YCELL3D ) THEN
         WRITE( LOGDEV,2003 ) XCENT_GD, XCENT3D, YCENT_GD, YCENT3D,
     &                        XCELL_GD, XCELL3D, YCELL_GD, YCELL3D

         XMSG = 'File header inconsistent with GRIDDESC'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C Convert to grid cell coord and truncate

      XORIG_F = XORIG3D / XCELL3D
      XORIG_F = REAL( IDNINT( ONEK * XORIG_F ), 8 ) / ONEK
      YORIG_F = YORIG3D / YCELL3D
      YORIG_F = REAL( IDNINT( ONEK * YORIG_F ), 8 ) / ONEK
 
C Check if file (cross or dot) is "lined up"

      RELOFFX = THOU * REAL( IDNINT( ONEK * ( XORIG_B - XORIG_F ) ), 8 )
      RELOFFX = RELOFFX - ONE * REAL( IDNINT( RELOFFX ), 8 )

      IF ( ABS( RELOFFX ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFX ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFX ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFX: ', RELOFFX
            WRITE( LOGDEV,* ) '    XORIG_B, XORIG_F: ', XORIG_B, XORIG_F
            XMSG = 'Inconsistent Base/File Xorig'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF
      END IF

      RELOFFY = THOU * REAL( IDNINT( ONEK * ( YORIG_B - YORIG_F ) ), 8 )
      RELOFFY = RELOFFY - ONE * REAL( IDNINT( RELOFFY ), 8 )

      IF ( ABS( RELOFFY ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFY ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFY ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFY: ', RELOFFY
            WRITE( LOGDEV,* ) '    YORIG_B, YORIG_F: ', YORIG_B, YORIG_F
            XMSG = 'Inconsistent Base/File Yorig'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF
      END IF
      IF ( ABS( RELOFFX - RELOFFY ) .GT. MIN_DOUBLE ) THEN
         XMSG = 'Inconsistent X- and Y-resolution (file vs. file)'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C check the file against the processor setup (COORD.EXT), and get the offsets

      DOTFILE = 0
      RELOFFX = THOU * REAL( IDNINT( ONEK * ( XORIG_C - XORIG_F ) ), 8 )
      RELOFFX = RELOFFX - ONE * REAL( IDNINT( RELOFFX ), 8 )

      IF ( ABS( RELOFFX ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFX ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFX ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFX: ', RELOFFX
            WRITE( LOGDEV,* ) '    XORIG_GD, XORIG_F: ', XORIG_C, XORIG_F
            XMSG = 'File Xorig inconsistent with GRIDDESC'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            END IF
      END IF

      RELOFFY = THOU * REAL( IDNINT( ONEK * ( YORIG_C - YORIG_F ) ), 8 )
      RELOFFY = RELOFFY - ONE * REAL( IDNINT( RELOFFY ), 8 )

      IF ( ABS( RELOFFY ) .GT. MIN_DOUBLE ) THEN ! it better be a dot file
         IF ( ABS( RELOFFY ) .LT. HALF - MIN_DOUBLE .OR.
     &        ABS( RELOFFY ) .GT. HALF + MIN_DOUBLE ) THEN
            WRITE( LOGDEV,* ) '    RELOFFY: ', RELOFFY
            WRITE( LOGDEV,* ) '    YORIG_GD, YORIG_F: ', YORIG_C, YORIG_F
            XMSG = 'File Yorig inconsistent with GRIDDESC'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            ELSE
            DOTFILE = 1
            END IF
      END IF
      IF ( ABS( RELOFFX - RELOFFY ) .GT. MIN_DOUBLE ) THEN
         XMSG = 'Inconsistent X- and Y-resolution (file vs. model)'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

      INDX = MYPE + 1
      GXOFF = IDINT( XORIG_C - XORIG_F )
      LOC_STRTCOL = GXOFF + COLSX_PE( 1,INDX )
      LOC_ENDCOL  = LOC_STRTCOL + NCOLS - 1 + DOTFILE
      GYOFF = IDINT( YORIG_C - YORIG_F )
      LOC_STRTROW = GYOFF + ROWSX_PE( 1,INDX )
      LOC_ENDROW  = LOC_STRTROW + NROWS - 1 + DOTFILE
#ifndef twoway
      IF ( GXOFF .LT. 0 .OR. GYOFF .LT. 0 ) THEN
         XMSG = 'Model domain is outside file domain'
         CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF
#endif

#ifdef twoway
      IF ( ( FNAME .EQ. GRID_CRO_2D ) .OR.
     &     ( FNAME .EQ. GRID_DOT_2D ) ) THEN
         LOC_ENDCOL  = LOC_ENDCOL - LOC_STRTCOL + 1
         LOC_STRTCOL = 1
         LOC_ENDROW  = LOC_ENDROW - LOC_STRTROW + 1
         LOC_STRTROW = 1
      ELSE IF ( ( FNAME .EQ. MET_CRO_2D ) .OR.
     &          ( FNAME .EQ. MET_CRO_3D ) .OR.
     &          ( FNAME .EQ. MET_DOT_3D ) ) THEN
         LOC_ENDCOL  = LOC_ENDCOL - LOC_STRTCOL + 2
         LOC_STRTCOL = 2
         LOC_ENDROW  = LOC_ENDROW - LOC_STRTROW + 2
         LOC_STRTROW = 2
      END IF
#endif

      STRTCOL = LOC_STRTCOL
      ENDCOL  = LOC_ENDCOL
      STRTROW = LOC_STRTROW
      ENDROW  = LOC_ENDROW

      RETURN
      END SUBROUTINE SUBHFILE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from ABFLUX_MOD.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module depv_data_module

            implicit none

            integer, parameter :: e2c_cats = 42   ! number of crop catigories

! Some compilers do not pad with blank characters in data initialization
!              '12345678901234567890'
            character( 20 ), parameter :: Beld_Names( e2c_cats ) =
     &        (/ 'Hay                 ',  !  1
     &           'Hay_ir              ',  !  2
     &           'Alfalfa             ',  !  3
     &           'Alfalfa_ir          ',  !  4
     &           'Other_Grass         ',  !  5
     &           'Other_Grass_ir      ',  !  6
     &           'Barley              ',  !  7
     &           'Barley_ir           ',  !  8
     &           'BeansEdible         ',  !  9
     &           'BeansEdible_ir      ',  ! 10
     &           'CornGrain           ',  ! 11
     &           'CornGrain_ir        ',  ! 12
     &           'CornSilage          ',  ! 13
     &           'CornSilage_ir       ',  ! 14
     &           'Cotton              ',  ! 15
     &           'Cotton_ir           ',  ! 16
     &           'Oats                ',  ! 17
     &           'Oats_ir             ',  ! 18
     &           'Peanuts             ',  ! 19
     &           'Peanuts_ir          ',  ! 20
     &           'Potatoes            ',  ! 21
     &           'Potatoes_ir         ',  ! 22
     &           'Rice                ',  ! 23
     &           'Rice_ir             ',  ! 24
     &           'Rye                 ',  ! 25
     &           'Rye_ir              ',  ! 26
     &           'SorghumGrain        ',  ! 27
     &           'SorghumGrain_ir     ',  ! 28
     &           'SorghumSilage       ',  ! 29
     &           'SorghumSilage_ir    ',  ! 30
     &           'Soybeans            ',  ! 31
     &           'Soybeans_ir         ',  ! 32
     &           'Wheat_Spring        ',  ! 33
     &           'Wheat_Spring_ir     ',  ! 34
     &           'Wheat_Winter        ',  ! 35
     &           'Wheat_Winter_ir     ',  ! 36
     &           'Other_Crop          ',  ! 37
     &           'Other_Crop_ir       ',  ! 38
     &           'Canola              ',  ! 39
     &           'Canola_ir           ',  ! 40
     &           'Beans               ',  ! 41
     &           'Beans_ir            '   ! 42
     &           /)

            real, allocatable :: Beld_ag ( :,:,: )
!   for E2C_SOIL file
            real, allocatable :: pHs1    ( :,:,: )
            real, allocatable :: pHs2    ( :,:,: )
            real, allocatable :: por1    ( :,:,: )
            real, allocatable :: por2    ( :,:,: )
            real, allocatable :: wp1     ( :,:,: )
            real, allocatable :: wp2     ( :,:,: )
            real, allocatable :: cec1    ( :,:,: )
            real, allocatable :: cec2    ( :,:,: )
!   for E2C_CHEM file
            real, Allocatable :: NH4ps1  ( :,:,: ) ! Total Soil NH4 from EPIC
            real, Allocatable :: NH4ps2  ( :,:,: )
            real, Allocatable :: wep1    ( :,:,: )
            real, Allocatable :: wep2    ( :,:,: )
            real, Allocatable :: dep2    ( :,:,: )

          end module depv_data_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HCDIFF3D ( JDATE, JTIME, K11BAR, K22BAR, DT )
      
C-----------------------------------------------------------------------
C Function:
C   Computes the contravariant diffusivities in x1 or x2 directions
C   using a constant physical horizontal diffusivity.
      
C Preconditions:
C   This routine can only be used for conformal map coordinates 
C   in the horizontal.
C   Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C   INTERP3, M3EXIT, DEFORM 
 
C Revision history:
C   October 17, 1995 by M. Talat Odman and Clint L. Ingram at NCSC:
C   created for SAQM-type coordinates
      
C    5 Nov 97 Jeff targetted

C    Sep. 1998 David Wong
C      -- parallelize the code
C      -- use GLOBAL_MAX to compute the global max

C    1/19/99 David Wong
C      -- add a loop_index call
C      -- change loop index ending point to avoid accessing invalid region.
C         (reason to do this is to prevent using boundary data from PINTERP,
C          which sets pseudo-boundary data to 0)

C    Jul. 8 1999 David Wong
C      -- replace GLOBAL_MAX with GLOBAL_RMAX for naming consistency
C
C    10/10/2000 Daewon Byun
C      -- generalized 3d horizontal diffusivity

C    23 Dec 00 J.Young: GLOBAL_RMAX -> Dave Wong's f90 stenex GLOBAL_MAX
C                       PE_COMM3 -> Dave Wong's f90 stenex COMM

C    6 Aug 01 J.Young: Use HGRD_DEFN; replace INTERP3 with INTERPX;
C                      allocatable arrays
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C   03 Aug 11 David Wong: moved DT calculation outside the loop for efficency
C                         purposes
C   01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C-----------------------------------------------------------------------
      
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
      USE CENTRALIZED_IO_MODULE
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_GLOBAL_MAX_MODULE, SE_COMM_MODULE,
                                !               SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_GLOBAL_MAX_MODULE, NOOP_COMM_MODULE,
                                !               NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE
      
C Includes:
      
      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:
      
      INTEGER, INTENT( IN )  :: JDATE  ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME  ! current model time, coded HHMMSS
                                       ! Contravariant diffusivity
!     REAL         K11BAR3D( NCOLS+1,NROWS+1,NLAYS ) ! x1-flux points
!     REAL         K22BAR3D( NCOLS+1,NROWS+1,NLAYS ) ! x2-flux points
      REAL,    INTENT( OUT ) :: K11BAR( :,:,: ) ! x1-flux points
      REAL,    INTENT( OUT ) :: K22BAR( :,:,: ) ! x2-flux points
      REAL,    INTENT( OUT ) :: DT              ! diffusivity time step
 
C Parameters:
 
C Horizontal eddy diffusivity (m^2/s) 
!     REAL, PARAMETER :: KH = 3.3E+04 ! From Brost et al., J.Geophys.Res., 1988
!     REAL, PARAMETER :: KH = 50.0    ! For 12 km SARMAP simulation as per SAQM
      REAL, PARAMETER :: KH = 2000.0  ! For  4 km SARMAP simulation as per SAQM

      REAL, PARAMETER :: KHMIN = 200.0 ! For min KH assigned for deformation
      REAL, PARAMETER :: DXB = 4000.0
      REAL, PARAMETER :: ALP = 0.28

C "Courant" factor = 99%(1/sqrt(2))
!     REAL, PARAMETER :: CFC = 0.700
      REAL, PARAMETER :: CFC = 0.300
      
C local variables:
      
      CHARACTER( 16 ) :: PNAME = 'HCDIFF3D'
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER, SAVE :: MLAYS
 
      REAL, SAVE :: DX1, DX2            ! CX x1- and x2-cell widths
      REAL, SAVE :: KHA                 ! resolution-adjusted base diffusivity
      REAL, SAVE :: ACOEF               ! ALP**2 * DX1 * DX2
      REAL         KHD                 ! Deformation induced KH
      REAL         DEFORM3D( NCOLS+1,NROWS+1,NLAYS ) ! wind deformation

      REAL         EDDYH3D ( NCOLS+1,NROWS+1,NLAYS ) ! Contra. diffusivity

      REAL         EFFKB               ! Effective Kbar
!     REAL         EKHMAX              ! max Contra. diffusivity (diagnos)
!     REAL         MS2MAX              ! max squared map scale factor (diagnos)
 
      INTEGER      ALLOCSTAT
      INTEGER      COL, ROW, LVL       ! column,row,level indices

      INTEGER MY_TEMP
      INTEGER, SAVE :: STARTROW, ENDROW
      INTEGER, SAVE :: STARTCOL, ENDCOL
 
      INTERFACE
         SUBROUTINE DEFORM( JDATE, JTIME, DEFORM3D )
            INTEGER, INTENT( IN )  :: JDATE, JTIME
            REAL,    INTENT( OUT ) :: DEFORM3D( :,:,: )
         END SUBROUTINE DEFORM
      END INTERFACE

C-----------------------------------------------------------------------
      
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         MLAYS = SIZE ( K11BAR,3 )
 
         CALL SUBST_LOOP_INDEX ( 'R', 1, NROWS, 1, MY_TEMP, STARTROW, ENDROW )

         CALL SUBST_LOOP_INDEX ( 'C', 1, NCOLS, 1, MY_TEMP, STARTCOL, ENDCOL )

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD
     &        * COS( PI180*( YORIG_GD + YCELL_GD * FLOAT( GL_NROWS/2 ))) ! in m.
            ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
            END IF

C Get map scale factor

         KHA = ( DXB * DXB ) / ( DX1 * DX2 ) * KH 

         ACOEF = ALP * ALP * ( DX1 * DX2 )

         END IF                    ! if firstime
 
C get wind deformation 
 
      CALL DEFORM ( JDATE, JTIME, DEFORM3D )

      EDDYH3D = 0.0

      DO LVL = 1, MLAYS
!        EKHMAX = 0.0
         DO ROW = STARTROW, ENDROW      !   DO ROW = 1, NROWS+1
            DO COL = STARTCOL, ENDCOL   !       DO COL = 1, NCOLS+1
!              EDDYH3D( COL,ROW,LVL ) = MSFD2( COL,ROW ) *  
!    &               ( ACOEF * KHA * DEFORM3D( COL,ROW,LVL ) 
!    &              / ( KHA + ACOEF * DEFORM3D( COL,ROW,LVL ) ) 
!    &              + KHMIN )
! Daewon prefers the following
               KHD = MAX( KHMIN, ACOEF * DEFORM3D( COL,ROW,LVL ) )
               EDDYH3D( COL,ROW,LVL ) = MSFD2( COL,ROW )
     &                                * KHA * KHD / ( KHA + KHD )
!              EKHMAX = MAX( EKHMAX, EDDYH3D( COL,ROW,LVL ) )
            END DO
         END DO
      END DO

      CALL SUBST_COMM ( EDDYH3D, DSPL_N1_E1_S0_W0, DRCN_N_E )

C Obtain flux average values of contravariant diffusivities

      EFFKB = 0.0
      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS + 1
            DO COL = 1, NCOLS + 1
               K11BAR( COL,ROW,LVL ) = 0.0
               K22BAR( COL,ROW,LVL ) = 0.0
               END DO
             END DO
          END DO

1003  FORMAT( / '@2@Layer', 5X, 'Time Step', 9X, 'EffKB' )

      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS
            DO COL = STARTCOL, ENDCOL
               K11BAR( COL,ROW,LVL ) = 0.5 * ( EDDYH3D( COL,ROW+1,LVL )
     &                               +         EDDYH3D( COL,ROW,LVL ) )
               END DO
            END DO
         DO COL = STARTCOL, ENDCOL
            K11BAR( COL,NROWS+1,LVL ) = 0.0
            END DO

         DO ROW = STARTROW, ENDROW
            DO COL = 1, NCOLS
               K22BAR( COL,ROW,LVL ) = 0.5 * ( EDDYH3D( COL,ROW,LVL )
     &                               +         EDDYH3D( COL+1,ROW,LVL ) )
              END DO
            END DO
         DO ROW = STARTROW, ENDROW
            K22BAR( NCOLS+1,ROW,LVL ) = 0.0
            END DO

         DO ROW = 1, NROWS
            DO COL = 1, NCOLS
               EFFKB =  MAX ( EFFKB, 
     &                        K11BAR( COL,ROW,LVL ),
     &                        K22BAR( COL,ROW,LVL ) )
               END DO
            END DO

!        DT = CFC * DX1 * DX2 / SUBST_GLOBAL_MAX ( EFFKB )

1005     FORMAT( '@2@ ', I3, 1X, F18.7, 1X, F12.7 )

         END DO ! for LVL

      DT = CFC * DX1 * DX2 / SUBST_GLOBAL_MAX ( EFFKB )

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      REAL FUNCTION HLCONST ( CNAME, TEMP, EFFECTIVE, HPLUS )

C-----------------------------------------------------------------------
C
C  FUNCTION: return the Henry's law constant for the specified substance
C            at the given temperature
C
C  References:
C
C  1. Nguyen, T. B., Coggon, M. M., Bates, K. H., Zhang, X., Schwantes,
C     R. H., Schilling, K. A., Loza, C. L., Flagan, R. C., Wennberg, P. O.,
C     and Seinfeld, J. H.: Organic aerosol formation from the reactive
C     uptake of isoprene epoxydiols (IEPOX) onto non-acidified inorganic
C     seeds, Atmos. Chem. Phys., 14, 3497-3510,
C     doi:10.5194/acp-14-3497-2014, 2014.
C 
C  revision history:
C    who        when           what
C  ---------  --------  -------------------------------------
C  S.Roselle  08/15/97  code written for Models-3
C  J.Gipson   06/18/01  added Henry's Law constants 50-55 for saprc99
C  W.Hutzell  07/03/01  added Henry's Law constants 56-57 for Atrazine
C                       and the daughter products from Atrazine and OH
C                       reactions.
C  J.Gipson.  09/06/02  added Henry's Law constants 59-73   for toxics
C  S.Roselle  11/07/02  added capability for calculating the effective
C                       Henry's law constant and updated coefficients
C                       in Henry's law constant table
C  J.Gipson   08/06/03  added Henry's Law constants 77-79
C  G.Sarwar   11/21/04  added constants for chlorine chemistry (Henry's
C                       law constants 80-85 and dissociation constants
C                       14-16
C  R.Bullock  07/05/05  added Henry's Law constants 86-87 for mercury 
C                       with enthalpy calculated from cited laboratory 
C                       data fit to an Arrhenius equation
C  W.Hutzell  02/14/06  added HLC 88 to 116, dissociation constant for
C                       17 (hydrazine)
C  A.Carlton  09/20/06  updated Henry's Law constants for 1,7,19,20,21,30 
C                       O3, NO3, hexane, octane, nonane, methanol and
C                       isoprene reference
C  S.Roselle  10/10/07  changed pointers to parameters; reformatted
C                       variable declarations
C  W.Hutzell  03/07/08  added Henry's Law constants for 117 to 120
C  W.Hutzell  01/01/09  added Henry's Law constants for 121 to 125 for
C                       for SAPRC07T mechanism                 
C  Y.Xie      6/11/10  added Henry's Law constants for 126 to 130 for 
C                       isoprene chemistry in SAPRC07               
C  S.Roselle  03/01/11  replaced I/O API include files with UTILIO_DEFN;
C                       removed deprecated TRIMLEN
C  W.Hutzell  08/16/12  updated IOAPI and Henry Constant names to V5.01
C                       standards
C  W.Hutzell  01/30/13  updated PHENOL, and add values for CATECHOL and
C                       XYLENOL
C  H.Pye      02/05/13  added Henry's Law 133-134 for IEPOX and IMAE
C  G.Sarwar   12/18/13  added Henry's Law constants for 135 to 140
C  W.Hutzell  07/11/14  correct error in DATA from last revision
C  D.Luecken  07/11/14  added 141 through 144 for nitrates
C  H.Pye      05/05/15  added monoterpene and isoprene nitrates
C  H.Pye      01/26/2016 added SOA SVOCs
C  G.Sarwar   03/24/15  added iodine and bromine species
C  H.Pye      05/31/16  updated IEPOX H-law from 2.7e6 to 3.0e7 M/atm
C                       to reflect Nguyen et al. 2014.
C  W.Hutzell  09/16/16  1) removed HCHO dissociation because its henry's
C                        constant already accounts for the effect.
C                       2) added henry's constant for compounds 194 thru
C                        199 representing several toxic air pollutants
C  
C  D. Luecken 09/21/2016 
C       1. added HAPs in 194-200; 
C       2. modified existing HEXANE (19),N-HEXANE (117), and STYRENE (119); 
C       3. removed dissociation  calculation for formaldedhyde because the listed value 
C          is already an effective rate (Sander ACP, 2015, note 187)
C       4. added dissociation constant for acrylic acid (LACRYACID) (via B. Hutzell)
C  H.Pye       06/2017  added semivolatile monoterpene products
C  G.Sarwar    08/2018  added Henry's Law constant for ClNO3, FMBR, IBR, and updated iodine and bromine species
C  G. Sarwar   11/2018  added Henry's Law constant for CLO
C-----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE

C...........ARGUMENTS and their descriptions

      CHARACTER*(*), INTENT ( IN ) :: CNAME      ! name of substance
      REAL,          INTENT ( IN ) :: TEMP       ! temperature (K)
      LOGICAL,       INTENT ( IN ) :: EFFECTIVE  ! true=compute the effective henry's law constant
      REAL,          INTENT ( IN ) :: HPLUS      ! hydrogen ion concentration (mol/l)

C...........INCLUDES and their descriptions


C...........PARAMETERS and their descriptions:

      INTEGER, PARAMETER :: MXSPCS = 216     ! Number of substances
      INTEGER, PARAMETER :: MXDSPCS = 19     ! Number of dissociating species

C...pointers for the dissociation constants (array B and D)

      INTEGER, PARAMETER :: LSO2       =  1  ! SO2
      INTEGER, PARAMETER :: LHSO3      =  2  ! HSO3
      INTEGER, PARAMETER :: LHNO2      =  3  ! HNO3
      INTEGER, PARAMETER :: LHNO3      =  4  ! HNO3
      INTEGER, PARAMETER :: LCO2       =  5  ! CO2
      INTEGER, PARAMETER :: LHCO3      =  6  ! HCO3
      INTEGER, PARAMETER :: LH2O2      =  7  ! H2O2
      INTEGER, PARAMETER :: LHCOOH     =  8  ! HCOOH
      INTEGER, PARAMETER :: LHO2       =  9  ! HO2
      INTEGER, PARAMETER :: LNH4OH     = 10  ! NH4OH
      INTEGER, PARAMETER :: LH2O       = 11  ! H2O
      INTEGER, PARAMETER :: LATRA      = 12  ! Atrazine
      INTEGER, PARAMETER :: LCL2       = 13  ! CL2
      INTEGER, PARAMETER :: LHOCL      = 14  ! HOCL
      INTEGER, PARAMETER :: LHCL       = 15  ! HCL
      INTEGER, PARAMETER :: LHYDRAZINE = 16  ! Hydrazine
      INTEGER, PARAMETER :: LHBR       = 17  ! HBR
      INTEGER, PARAMETER :: LHI        = 18  ! HI
      INTEGER, PARAMETER :: LACRYACID  = 19  ! CCH3COOH


C...........SCRATCH LOCAL VARIABLES and their descriptions:

      CHARACTER( 16 ), SAVE :: PNAME = 'HLCONST'  ! program name
      CHARACTER( 16 ), SAVE :: SUBNAME( MXSPCS )  ! list of substance names

      CHARACTER( 120 ) :: XMSG = ' '    ! exit status message string

      INTEGER       S                   ! loop index
      INTEGER       SPC                 ! species index

      REAL          HPLUSI              ! 1 / HPLUS
      REAL          HPLUS2I             ! 1 / HPLUS**2
      REAL          CLMINUS             ! chlorine ion conc [CL-]
      REAL          CLMINUSI            ! 1 / CLMINUS
      REAL          TFAC                ! (298-T)/(T*298)
      REAL          AKEQ1               ! temp var for dissociation constant
      REAL          AKEQ2               ! temp var for dissociation constant
      REAL          OHION               ! OH ion concentration
      REAL          KH                  ! temp var for henry's law constant

C...Henry's law constant data taken mostly from Rolf Sanders' Compilation of
C...  Henry's Law Constants for Inorganic and Organic Species of Potential
C...  Importance in Environment Chemistry 1999

      REAL, SAVE :: A( MXSPCS )         ! Henry's law constants at 298.15K (M/atm)
      REAL, SAVE :: E( MXSPCS )         ! enthalpy (like activation energy) (K)

C...dissociation constant data taken mostly from 6.A.1 of Seinfeld and Pandis
C...  Atmospheric Chemistry and Physics, 1997

      REAL, SAVE :: B( MXDSPCS )        ! dissociation constant at 298.15K (M or M2)
      REAL, SAVE :: D( MXDSPCS )        ! -dH/R (K)

      DATA SUBNAME(  1), A(  1), E(  1) / 'O3              ', 1.14E-02, 2.3E+03 / ! Kosak 1983
      DATA SUBNAME(  2), A(  2), E(  2) / 'HO2             ', 4.0E+03, 5.9E+03 /  ! Hanson et al. 1992
      DATA SUBNAME(  3), A(  3), E(  3) / 'H2O2            ', 1.1E+05, 7.4E+03 /  ! E: O'Sullivan et al. 1996, A: Sander 1999 as used in Nguyen et al. 2015 PNAS
      DATA SUBNAME(  4), A(  4), E(  4) / 'NH3             ', 6.1E+01, 4.2E+03 /  ! Clegg and Brimblecombe 1989
      DATA SUBNAME(  5), A(  5), E(  5) / 'NO              ', 1.9E-03, 1.4E+03 /  ! Lide and Frederikse 1995
      DATA SUBNAME(  6), A(  6), E(  6) / 'NO2             ', 1.2E-02, 2.5E+03 /  ! Chameides 1984
      DATA SUBNAME(  7), A(  7), E(  7) / 'NO3             ', 0.6E+00, 0.0E+00 /  ! Rudich, Talukdar et al.1996
      DATA SUBNAME(  8), A(  8), E(  8) / 'N2O5            ', 1.0E+30, 0.0E+00 /  ! "inf" Sander and Crutzen 1996
      DATA SUBNAME(  9), A(  9), E(  9) / 'HNO2            ', 5.0E+01, 4.9E+03 /  ! Becker et al. 1996
      DATA SUBNAME( 10), A( 10), E( 10) / 'HNO3            ', 2.1E+05, 8.7E+03 /  ! Leieveld and Crutzen 1991
      DATA SUBNAME( 11), A( 11), E( 11) / 'HNO4            ', 1.2E+04, 6.9E+03 /  ! Regimbal and Mozurkewich 1997
      DATA SUBNAME( 12), A( 12), E( 12) / 'SO2             ', 1.4E+00, 2.9E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 13), A( 13), E( 13) / 'H2SO4           ', 1.0E+30, 0.0E+00 /  ! infinity
      DATA SUBNAME( 14), A( 14), E( 14) / 'METHANE         ', 1.4E-03, 1.6E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 15), A( 15), E( 15) / 'ETHANE          ', 1.9E-03, 2.3E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 16), A( 16), E( 16) / 'PROPANE         ', 1.5E-03, 2.7E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 17), A( 17), E( 17) / 'BUTANE          ', 1.1E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 18), A( 18), E( 18) / 'PENTANE         ', 8.1E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 19), A( 19), E( 19) / 'HEXANE          ', 6.18E-04,3.8E+03 /  ! Sander, ACP, 2015; Abraham Matteoli (1988)
      DATA SUBNAME( 20), A( 20), E( 20) / 'OCTANE          ', 2.9E-03, 7.8E+03 /  ! Hansen et al. 1993
      DATA SUBNAME( 21), A( 21), E( 21) / 'NONANE          ', 2.4E-03, 2.1E+02 /  ! Ashworth, Howe et al 1988
      DATA SUBNAME( 22), A( 22), E( 22) / 'DECANE          ', 1.4E-04, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 23), A( 23), E( 23) / 'ETHENE          ', 4.7E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 24), A( 24), E( 24) / 'PROPENE         ', 4.8E-03, 0.0E+00 /  ! Mackay and Shiu 1981
      DATA SUBNAME( 25), A( 25), E( 25) / 'ISOPRENE        ', 2.8E-02, 0.0E+00 /  ! Karl, Lindinger et al 2003
      DATA SUBNAME( 26), A( 26), E( 26) / 'ACETYLENE       ', 4.1E-02, 1.8E+03 /  ! Wilhelm et al. 1977
      DATA SUBNAME( 27), A( 27), E( 27) / 'BENZENE         ', 1.6E-01, 4.1E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 28), A( 28), E( 28) / 'TOLUENE         ', 1.5E-01, 4.0E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 29), A( 29), E( 29) / 'O-XYLENE        ', 1.9E-01, 4.0E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 30), A( 30), E( 30) / 'METHANOL        ', 2.2E+02, 5.2E+03 /  ! Snider and Dawson 1985
      DATA SUBNAME( 31), A( 31), E( 31) / 'ETHANOL         ', 1.9E+02, 6.6E+03 /  ! Snider and Dawson 1985
      DATA SUBNAME( 32), A( 32), E( 32) / '2-CRESOL        ', 8.2E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 33), A( 33), E( 33) / '4-CRESOL        ', 1.3E+02, 0.0E+00 /  ! Betterton 1992
      DATA SUBNAME( 34), A( 34), E( 34) / 'METHYLHYDROPEROX', 3.1E+02, 5.2E+03 /  ! O'Sullivan et al. 1996
      DATA SUBNAME( 35), A( 35), E( 35) / 'FORMALDEHYDE    ', 3.2E+03, 6.8E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 36), A( 36), E( 36) / 'ACETALDEHYDE    ', 1.4E+01, 5.6E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 37), A( 37), E( 37) / 'GENERIC_ALDEHYDE', 4.2E+03, 0.0E+00 /  ! Graedel and Goldberg 1983
      DATA SUBNAME( 38), A( 38), E( 38) / 'GLYOXAL         ', 3.6E+05, 0.0E+00 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 39), A( 39), E( 39) / 'ACETONE         ', 3.0E+01, 4.6E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 40), A( 40), E( 40) / 'FORMIC_ACID     ', 8.9E+03, 6.1E+03 /  ! Johnson et al. 1996
      DATA SUBNAME( 41), A( 41), E( 41) / 'ACETIC_ACID     ', 4.1E+03, 6.3E+03 /  ! Johnson et al. 1996
      DATA SUBNAME( 42), A( 42), E( 42) / 'METHYL_GLYOXAL  ', 3.2E+04, 0.0E+00 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 43), A( 43), E( 43) / 'CO              ', 9.9E-04, 1.3E+03 /  ! Linde and Frederikse 1995
      DATA SUBNAME( 44), A( 44), E( 44) / 'CO2             ', 3.6E-02, 2.2E+03 /  ! Zheng et al. 1997
      DATA SUBNAME( 45), A( 45), E( 45) / 'PAN             ', 2.8E+00, 6.5E+03 /  ! Kames et al. 1991
      DATA SUBNAME( 46), A( 46), E( 46) / 'MPAN            ', 1.7E+00, 0.0E+00 /  ! Kames and Schurath 1995
      DATA SUBNAME( 47), A( 47), E( 47) / 'OH              ', 3.0E+01, 4.5E+03 /  ! Hanson et al. 1992
      DATA SUBNAME( 48), A( 48), E( 48) / 'METHYLPEROXY_RAD', 2.0E+03, 6.6E+03 /  ! Lelieveld and Crutzen 1991
      DATA SUBNAME( 49), A( 49), E( 49) / 'PEROXYACETIC_ACI', 8.4E+02, 5.3E+03 /  ! O'Sullivan et al. 1996
      DATA SUBNAME( 50), A( 50), E( 50) / 'PROPANOIC_ACID  ', 5.7E+03, 0.0E+00 /  ! Kahn et al. 1995
      DATA SUBNAME( 51), A( 51), E( 51) / '2-NITROPHENOL   ', 7.0E+01, 4.6E+03 /  ! USEPA 1982
      DATA SUBNAME( 52), A( 52), E( 52) / 'PHENOL          ', 3.3E+03, 3.6E+03 /  ! Meylan and Howard (1991)
      DATA SUBNAME( 53), A( 53), E( 53) / 'BIACETYL        ', 7.4E+01, 5.7E+03 /  ! Betteron 1991
      DATA SUBNAME( 54), A( 54), E( 54) / 'BENZALDEHYDE    ', 3.9E+01, 4.8E+03 /  ! Staudinger and Roberts 1996
      DATA SUBNAME( 55), A( 55), E( 55) / 'PINENE          ', 4.9E-02, 0.0E+00 /  ! Karl and Lindinger 1997
      DATA SUBNAME( 56), A( 56), E( 56) / 'ATRA            ', 4.1E+05, 6.0E+03 /  ! CIBA Corp (1989) and Scholtz (1999)
      DATA SUBNAME( 57), A( 57), E( 57) / 'DATRA           ', 4.1E+05, 6.0E+03 /  ! assumed same as Atrazine
      DATA SUBNAME( 58), A( 58), E( 58) / 'ADIPIC_ACID     ', 2.0E+08, 0.0E+00 /  ! Saxena and Hildemann (1996)
      DATA SUBNAME( 59), A( 59), E( 59) / 'ACROLEIN        ', 8.2E+00, 0.0E+00 /  ! Meylan and Howard (1991)
      DATA SUBNAME( 60), A( 60), E( 60) / '13-BUTADIENE    ', 1.4E-02, 0.0E+00 /  ! Mackay and Shiu (1981)
      DATA SUBNAME( 61), A( 61), E( 61) / 'ACRYLONITRILE   ', 7.3E+00, 0.0E+00 /  ! Meylan and Howard (1991)
      DATA SUBNAME( 62), A( 62), E( 62) / 'CARBONTETRACHLOR', 3.4E-02, 4.2E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 63), A( 63), E( 63) / 'PROPYLENE_DICHLO', 3.4E-01, 4.3E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 64), A( 64), E( 64) / '13DICHLOROPROPEN', 6.5E-01, 4.2E+03 /  ! Wright et al (1992b)
      DATA SUBNAME( 65), A( 65), E( 65) / '1122-CL4ETHANE  ', 2.4E+00, 3.2E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 66), A( 66), E( 66) / 'CHLOROFORM      ', 2.5E-01, 4.5E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 67), A( 67), E( 67) / '12DIBROMOETHANE ', 1.5E+00, 3.9E+03 /  ! Ashworth et al (1988)
      DATA SUBNAME( 68), A( 68), E( 68) / '12DICHLOROETHANE', 7.3E-01, 4.2E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 69), A( 69), E( 69) / 'METHYLENE_CHLORI', 3.6E-01, 4.1E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 70), A( 70), E( 70) / 'PERCHLOROETHYLEN', 5.9E-02, 4.8E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 71), A( 71), E( 71) / 'TRICHLOROETHENE ', 1.0E-01, 4.6E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 72), A( 72), E( 72) / 'VINYL_CHLORIDE  ', 3.9E-02, 3.1E+03 /  ! Staudinger and Roberts (1996)
      DATA SUBNAME( 73), A( 73), E( 73) / 'ETHYLENE_OXIDE  ', 8.4E+00, 0.0E+00 /  ! CRC
      DATA SUBNAME( 74), A( 74), E( 74) / 'PPN             ', 2.9E+00, 0.0E+00 /  ! Kames and Schurath (1995)
      DATA SUBNAME( 75), A( 75), E( 75) / 'NAPHTHALENE     ', 2.0E+00, 3.6E+03 /  ! USEPA 1982
      DATA SUBNAME( 76), A( 76), E( 76) / 'QUINOLINE       ', 3.7E+03, 5.4E+03 /  ! USEPA 1982
      DATA SUBNAME( 77), A( 77), E( 77) / 'MEK             ', 2.0E+01, 5.0E+03 /  ! Zhou and Mopper 1990
      DATA SUBNAME( 78), A( 78), E( 78) / 'MVK             ', 4.1E+01, 0.0E+00 /  ! Iraci et al. 1998
      DATA SUBNAME( 79), A( 79), E( 79) / 'METHACROLEIN    ', 6.5E+00, 0.0E+00 /  ! Iraci et al. 1998
      DATA SUBNAME( 80), A( 80), E( 80) / 'CL2             ', 8.6E-02, 2.0E+03 /  ! ROLF SANDERS COMPILATION (1999)/KAVANAUGH AND TRUSSELL (1980)
      DATA SUBNAME( 81), A( 81), E( 81) / 'HOCL            ', 6.6E+02, 5.9E+03 /  ! ROLF SANDERS COMPILATION (1999)/HUTHWELKER ET AL (1995)
      DATA SUBNAME( 82), A( 82), E( 82) / 'HCL             ', 1.9E+01, 6.0E+02 /  ! ROLF SANDERS COMPILATION (1999)/DEAN (1992)
      DATA SUBNAME( 83), A( 83), E( 83) / 'FMCL            ', 1.1E+00, 0.0E+00 /  ! EPA SUITE PROGRAM/UNIT CONVERTED TO MATCH THE DEFINITION BY ROLF SANDERS.
      DATA SUBNAME( 84), A( 84), E( 84) / 'ICL1            ', 6.9E+01, 0.0E+00 /  ! EPA SUITE PROGRAM/UNIT CONVERTED TO MATCH THE DEFINITION BY ROLF SANDERS.
      DATA SUBNAME( 85), A( 85), E( 85) / 'ICL2            ', 6.9E+01, 0.0E+00 /  ! EPA SUITE PROGRAM/ASSUMED EQUAL TO THAT OF ICL1
      DATA SUBNAME( 86), A( 86), E( 86) / 'HG              ', 1.11E-01, 4.97E+03 /! Elemental Mercury from Clever et al. (1985)
      DATA SUBNAME( 87), A( 87), E( 87) / 'HGIIGAS         ', 1.41E+06, 5.26E+03 /! Hg(II) gas as mercuric chloride from Lindqvist and Rodhe (1985)
      DATA SUBNAME( 88), A( 88), E( 88) / 'TECDD_2378      ', 5.1E+00, 3.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 89), A( 89), E( 89) / 'PECDD_12378     ', 4.6E+00, 3.2E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 90), A( 90), E( 90) / 'HXCDD_123478    ', 8.1E+00, 2.9E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 91), A( 91), E( 91) / 'HXCDD_123678    ', 2.9E+00, 2.8E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 92), A( 92), E( 92) / 'HXCDD_123789    ', 6.5E+00, 2.7E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 93), A( 93), E( 93) / 'HPCDD_1234678   ', 1.2E+01, 2.4E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 94), A( 94), E( 94) / 'OTCDD           ', 9.8E+00, 2.3E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 95), A( 95), E( 95) / 'TECDF_2378      ', 8.5E+01, 3.7E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 96), A( 96), E( 96) / 'PECDF_12378     ', 5.2E+01, 2.9E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 97), A( 97), E( 97) / 'PECDF_23478     ', 1.8E+02, 3.0E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 98), A( 98), E( 98) / 'HXCDF_123478    ', 3.8E+01, 2.4E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME( 99), A( 99), E( 99) / 'HXCDF_123678    ', 9.0E+01, 2.9E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(100), A(100), E(100) / 'HXCDF_234678    ', 1.0E+02, 2.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(101), A(101), E(101) / 'HXCDF_123789    ', 5.6E+01, 2.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(102), A(102), E(102) / 'HPCDF_1234678   ', 2.8E+01, 1.6E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(103), A(103), E(103) / 'HPCDF_1234789   ', 8.0E+01, 2.1E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(104), A(104), E(104) / 'OTCDF           ', 7.6E+01, 2.4E+03 /  ! Paasivirta et al. (1999)
      DATA SUBNAME(105), A(105), E(105) / 'NAPHTHOL        ', 3.60E+03, 0.0E+00 / ! Eabraham et al. (1994)
      DATA SUBNAME(106), A(106), E(106) / '1NITRONAPHTHALEN', 5.68E+02, 0.0E+00 / ! Altschuh et al. (1999)
      DATA SUBNAME(107), A(107), E(107) / '2NITRONAPHTHALEN', 6.42E+02, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(108), A(108), E(108) / '14NAPHTHOQUINONE', 5.08E+05, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(109), A(109), E(109) / '24-TOLUENE_DIIS ', 7.25E+00, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(110), A(110), E(110) / 'HEXAMETHYLE_DIIS', 2.08E+01, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(111), A(111), E(111) / 'HYDRAZINE       ', 1.14E+03, 0.0E+00 / ! Daubert and Danner (1989), and Amoore and Hautala (1983)
      DATA SUBNAME(112), A(112), E(112) / 'MALEIC_ANHYDRIDE', 2.54E+02, 0.0E+00 / ! HENRYWIN v3.10 (Meylan and Howard, 1991)
      DATA SUBNAME(113), A(113), E(113) / 'TRIETHYLAMINE   ', 6.71E+00, 0.0E+00 / ! Yalkowsky and Dannenfelser (1992), and Riddick et al. (1986)
      DATA SUBNAME(114), A(114), E(114) / 'P_DICHLOROBENZEN', 2.38E+00, 0.0E+00 / ! MacKay and Shiu (1981), measured
      DATA SUBNAME(115), A(115), E(115) / 'M-XYLENE        ', 1.43E-01, 3.9E+03 / ! Staudinger and Roberts (2001)
      DATA SUBNAME(116), A(116), E(116) / 'P-XYLENE        ', 1.35E-01, 3.7E+03 / ! Staudinger and Roberts (2001)

      DATA SUBNAME(117), A(117), E(117) / 'N-HEXANE        ', 6.18E-04, 3.8E+03 /  ! Sander, ACP, 2015, Abraham Matteoli (1988)
      DATA SUBNAME(118), A(118), E(118) / 'PROPANAL        ', 1.64E+00, 5.4E+03 /  ! Staudinger and Roberts (2001)
      DATA SUBNAME(119), A(119), E(119) / 'STYRENE         ', 2.74E-01, 0.0E+00 /  ! Sander, ACP, 2015, Kim and Kim (2014)
      DATA SUBNAME(120), A(120), E(120) / '124TRIMETH_BENZE', 1.50E-01, 4.3E+03 /  ! Hanson et al. (1995)
      DATA SUBNAME(121), A(121), E(121) / 'CHLOROACETALDEHY', 4.18E+01, 0.0E+00 /  ! Bond Estimate by EPA SUITE PROGRAM  (2007)
      DATA SUBNAME(122), A(122), E(122) / 'CHLOROACETONE   ', 3.82E-01, 0.0E+00 /  ! Staudinger and Roberts (2001)

      DATA SUBNAME(123), A(123), E(123) / 'NITROSYL_CHLORID', 5.10E-01, 0.0E+00 /  ! Bond Estimate by EPA SUITE PROGRAM  (2007)
      DATA SUBNAME(124), A(124), E(124) / 'NITRYL_CHLORIDE ', 2.43E-02, 0.0E+00 /  ! Behnke et al. (1997), JGR, D102, 3795-3804
      DATA SUBNAME(125), A(125), E(125) / 'HEXYL_HYDROPEROX', 1.23E+01, 0.0E+00 /  ! Bond Estimated by EPA SUITE PROGRAM  (2007)

      DATA SUBNAME(126), A(126), E(126) / 'HYDROXY_NITRATES', 1.70E+04, 9.20E+03 /  ! Shepson et al. (1996), Treves et al. (2000)
      DATA SUBNAME(127), A(127), E(127) / 'HYDROXY_PEROXIDE', 8.30E+04, 7.40E+03 /  ! using value for H2O2
      DATA SUBNAME(128), A(128), E(128) / 'PROPNN          ', 1.00E+04, 0.00E+00 /  ! Nguyen et al. (2015) PNAS using Shepson (1996)
      DATA SUBNAME(129), A(129), E(129) / 'HACET           ', 2.93E+03, 0.00E+00 /  ! Spaulding et al. (2002)
      DATA SUBNAME(130), A(130), E(130) / 'PYRUVIC_ACID    ', 3.00E+05, 5.20E+03 /  ! Staudinger and Roberts (1996) 
      DATA SUBNAME(131), A(131), E(131) / 'XYLENOL         ', 1.05E+03, 0.00E+03 /  ! experimental value from EPA SUITE PROGRAM  (2008)
      DATA SUBNAME(132), A(132), E(132) / 'CATECHOL        ', 3.16E+05, 0.00E+03 /  ! experimental value from EPA SUITE PROGRAM  (2008)
      DATA SUBNAME(133), A(133), E(133) / 'IEPOX           ', 3.0E+07,  0.00E+00 /  ! Nguyen et al. ACP (2014)
      DATA SUBNAME(134), A(134), E(134) / 'IMAE            ', 1.2E+05,  0.00E+00 /  ! Pye et al. ES&T (2013)

      DATA SUBNAME(135), A(135), E(135) / 'DIETHYLKETONE   ', 2.00E+01, 9.2E+03 /   ! ROLF SANDERS COMPILATION (1999)/JANINI AND QUADDORA (1986)
      DATA SUBNAME(136), A(136), E(136) / 'N-PROPANOL      ', 1.10E+02, 0.0E+00 /   ! ROLF SANDERS COMPILATION (1999)/YAWS AND YANG (1992)
      DATA SUBNAME(137), A(137), E(137) / 'ETHYLENEGLYCOL  ', 4.00E+06, 0.0E+00 /   ! ROLF SANDERS COMPILATION (1999)/BONE ET AL. (1983)
      DATA SUBNAME(138), A(138), E(138) / 'HYDROXY-ACETONE ', 2.00E+04, 0.0E+00 /   ! MATSUNAGA ET AL., 41, 790-796, AE, (2007)            
      DATA SUBNAME(139), A(139), E(139) / '2NITRO_1BUTNL   ', 6.30E+03, 9.6E+03 /   ! Shepson et al., 1992 
      DATA SUBNAME(140), A(140), E(140) / 'PYROCATECHOL    ', 4.60E+03, 0.0E+00 /   ! Mackay et al., 1995            
      DATA SUBNAME(141), A(141), E(141) / 'NTR_ALK         ', 6.50E-01, 5.4E+03 /   ! 2-butylnitrate, from Sander
      DATA SUBNAME(142), A(142), E(142) / 'NTR_OH          ', 6.50E+03, 9.5E+03 /   ! 3-nitrooxy-butanol, from Sander
      DATA SUBNAME(143), A(143), E(143) / 'DINTR           ', 1.80E+01, 0.0E+00 /   ! 2,3-pentanedinitrate
      DATA SUBNAME(144), A(144), E(144) / 'NTR_PX          ', 3.40E+02, 6.0E+03 /   ! ethylhydroperoxide 
      DATA SUBNAME(145), A(145), E(145) / 'MTNO3           ', 1.5E+06,  0.0E+00 /   ! monoterpene nitrates HenryWin v3.2 
      DATA SUBNAME(146), A(146), E(146) / 'ISOPNN          ', 4.5E+08,  0.0E+00 /   ! isoprene dinitrate HenryWin v3.2
      DATA SUBNAME(147), A(147), E(147) / 'SVALK1          ', 6.2E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(148), A(148), E(148) / 'SVALK2          ', 4.5E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(149), A(149), E(149) / 'SVBNZ1          ', 2.1E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(150), A(150), E(150) / 'SVBNZ2          ', 2.0E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(151), A(151), E(151) / 'SVISO1          ', 4.3E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(152), A(152), E(152) / 'SVISO2          ', 3.7E+09,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(153), A(153), E(153) / 'SVPAH1          ', 5.1E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(154), A(154), E(154) / 'SVPAH2          ', 7.2E+05,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(155), A(155), E(155) / 'SVSQT           ', 6.2E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(156), A(156), E(156) / 'SVTOL1          ', 4.2E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(157), A(157), E(157) / 'SVTOL2          ', 7.3E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(158), A(158), E(158) / 'SVTRP1          ', 9.9E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(159), A(159), E(159) / 'SVTRP2          ', 1.4E+08,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(160), A(160), E(160) / 'SVXYL1          ', 6.2E+07,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL
      DATA SUBNAME(161), A(161), E(161) / 'SVXYL2          ', 4.0E+06,  6.0E+03 /   ! Pye 2016 est based on Hodzic 2014 GRL

      DATA SUBNAME(162), A(162), E(162) / 'I2              ', 3.10E+00, 4.6E+03 /   ! ROLF SANDERS COMPILATION (1999)/Berdnikov and Bazhin (1970)
      DATA SUBNAME(163), A(163), E(163) / 'I               ', 6.30E-03, 2.3E+03 /   ! ROLF SANDERS COMPILATION (1999)/Berdnikov and Bazhin (1970)
      DATA SUBNAME(164), A(164), E(164) / 'IO              ', 4.50E+02, 0.0E+00 /   ! Saiz-Lopez et al., ACPD, 2014
      DATA SUBNAME(165), A(165), E(165) / 'OIO             ', 1.00E+04, 0.0E+00 /   ! Saiz-Lopez et al., ACPD, 2014
      DATA SUBNAME(166), A(166), E(166) / 'I2O2            ', 1.00E+30, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(167), A(167), E(167) / 'I2O3            ', 1.00E+30, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(168), A(168), E(168) / 'I2O4            ', 1.00E+30, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(169), A(169), E(169) / 'HI              ', 2.50E+00, 5.3E+03 /   ! Schweitzer et al. (2000)
      DATA SUBNAME(170), A(170), E(170) / 'HOI             ', 1.53E+04, 8.3E+03 /   ! Sherwen et al., 2016      

      DATA SUBNAME(171), A(171), E(171) / 'INO             ', 5.00E-02, 0.0E+00 /   ! Same as ClNO which is from ROLF SANDERS COMPILATION (1999)/Scheer et al. (1997)
      DATA SUBNAME(172), A(172), E(172) / 'INO2            ', 3.00E-01, 0.0E+00 /   ! Same as BRNO2 which is from ROLF SANDERS COMPILATION (1999)/Frenzel et al. (1998)
      DATA SUBNAME(173), A(173), E(173) / 'INO3            ', 1.00E+30, 0.0E+00 /   ! Same as BRNO3; BRNO3 from Sander (2015)      
      DATA SUBNAME(174), A(174), E(174) / 'CH3I            ', 1.40E-01, 4.3E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(175), A(175), E(175) / 'MIC             ', 8.90E-01, 4.3E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(176), A(176), E(176) / 'MIB             ', 8.90E-01, 4.3E+03 /   ! Same as MIC, Final Report to TCEQ, Environ International, 2012
      DATA SUBNAME(177), A(177), E(177) / 'MI2             ', 2.30E+00, 5.0E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)

      DATA SUBNAME(178), A(178), E(178) / 'BRO             ', 7.10E-01, 0.0E+00 /   ! Parrella et al. (2012)
      DATA SUBNAME(179), A(179), E(179) / 'HOBR            ', 6.10E+03, 6.0E+03 /   ! Sherwen et al., 2016
      DATA SUBNAME(180), A(180), E(180) / 'HBR             ', 7.50E-01, 6.1E+03 /   ! A from Schweitzer et al. (2000) and E from Chmeides and Stelson (1992) - ROLF SANDERS COMPILATION (1999)
      DATA SUBNAME(181), A(181), E(181) / 'BR2             ', 7.60E-01, 4.1E+03 /   ! Dean et al. (1992)
      DATA SUBNAME(182), A(182), E(182) / 'BRNO3           ', 1.00E+30, 0.0E+00 /   ! Sander (2015)

      DATA SUBNAME(183), A(183), E(183) / 'MB3             ', 1.40E+00, 5.0E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(184), A(184), E(184) / 'CH3BR           ', 1.50E-01, 0.0E+00 /   ! ROLF SANDERS COMPILATION (1999)/Yaws and Yang et al. (1992)
      DATA SUBNAME(185), A(185), E(185) / 'MB2             ', 9.30E-01, 4.4E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(186), A(186), E(186) / 'MB2C            ', 7.30E-01, 4.9E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(187), A(187), E(187) / 'MBC2            ', 4.00E-01, 4.7E+03 /   ! ROLF SANDERS COMPILATION (1999)/Moore et al. (1995)
      DATA SUBNAME(188), A(188), E(188) / 'MBC             ', 8.90E-01, 4.3E+03 /   ! Same as MIC
      DATA SUBNAME(189), A(189), E(189) / 'BRNO2           ', 3.00E-01, 0.0E+00 /   ! Frenzel et al. (1998)
      DATA SUBNAME(190), A(190), E(190) / 'BRCL            ', 9.70E-01, 0.0E+00 /   ! Sherwen et al., 2016
      DATA SUBNAME(191), A(191), E(191) / 'ICL             ', 1.10E+02, 2.1E+03 /   ! Sherwen et al., 2016

      DATA SUBNAME(192), A(192), E(192) / 'DMS             ', 4.80E-01, 3.1E+03 /   ! ROLF SANDERS COMPILATION (1999)/De Bryuyn et al. (1995)
      DATA SUBNAME(193), A(193), E(193) / 'MSA             ', 7.70E+04, 0.0E+00 /   ! Meylan and Howard (1991), inverse of the value is used due to unit conversion
      DATA SUBNAME(194), A(194), E(194) / 'XYLENE          ', 1.90E-01, 4.2E+03  / ! .35/.3/.35 m/o/p, Sander ACP 2015, Staudinger and Roberts (2001) for m; Fogg and Sangster (2003) for o and p
      DATA SUBNAME(195), A(195), E(195) / 'ETHYLBENZENE    ', 1.42E-01, 4.8E+03 / ! Sander ACP 2015, Fogg Sangster (2003)
      DATA SUBNAME(196), A(196), E(196) / 'ACRYACID        ', 3.141E+03, 0.0E+00 / ! Sander ACP 2015, Lide Frederikse (1995)
      DATA SUBNAME(197), A(197), E(197) / 'ACETONITRILE    ', 5.269E+01, 4.0E+03 / ! Sander ACP 2015, Sander et al (2011)
      DATA SUBNAME(198), A(198), E(198) / 'CHLOROPRENE     ', 4.760E+00, 0.0E+00 / ! Sander ACP 2015, Mackay et al. (1993)
      DATA SUBNAME(199), A(199), E(199) / 'METHCHLORIDE    ', 1.320E-01, 3.3E+03 / ! Sander ACP 2015, Sander et al. (2011)
      DATA SUBNAME(200), A(200), E(200) / 'CARBSULFIDE     ', 2.130E-02, 3.3E+03 / ! Sander ACP 2015, Warneck Williams (2012)
      DATA SUBNAME(201), A(201), E(201) / '6_NITRO_O_CRESOL', 2.938E+01, 0.0E+00 / ! 6-methyl-2-nitrophenol from Sander ACP 2015, Tremp et. al (1992)
      DATA SUBNAME(202), A(202), E(202) / 'SVMT1           ', 7.1E+11,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(203), A(203), E(203) / 'SVMT2           ', 8.9E+10,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(204), A(204), E(204) / 'SVMT3           ', 1.1E+10,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(205), A(205), E(205) / 'SVMT4           ', 1.4E+09,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(206), A(206), E(206) / 'SVMT5           ', 1.8E+08,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(207), A(207), E(207) / 'SVMT6           ', 2.2E+07,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(208), A(208), E(208) / 'SVMT7           ', 2.8E+06,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(209), A(209), E(209) / 'SVAVB1          ', 5.5E+09,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(210), A(210), E(210) / 'SVAVB2          ', 7.9E+07,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(211), A(211), E(211) / 'SVAVB3          ', 1.2E+07,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(212), A(212), E(212) / 'SVAVB4          ', 1.8E+06,  6.0E+03 /   ! est based on Hodzic 2014 GRL
      DATA SUBNAME(213), A(213), E(213) / 'CLNO3           ', 1.00E+30, 0.0E+00 /   ! Sander (2015)
      DATA SUBNAME(214), A(214), E(214) / 'IBR             ', 2.43E+01, 4.9E+03 /   ! Sherwen et al., 2016
      DATA SUBNAME(215), A(215), E(215) / 'FMBR            ', 7.40E+01, 0.0E+00 /   ! Sander, R. ACP (2015), krysztofiak et al. (2012)
      DATA SUBNAME(216), A(216), E(216) / 'CLO             ', 7.00E-03, 0.0E+00 /   ! Sander et al., ACP, 2015

      DATA B( LSO2   ), D( LSO2   ) / 1.30E-02,  1.96E+03 /  ! SO2*H2O<=>HSO3+H     : Smith and Martell (1976)
      DATA B( LHSO3  ), D( LHSO3  ) / 6.60E-08,  1.50E+03 /  ! HSO3<=>SO3+H         : Smith and Martell (1976)
      DATA B( LHNO2  ), D( LHNO2  ) / 5.10E-04, -1.26E+03 /  ! HNO2(aq)<=>NO2+H     : Schwartz and White (1981)
      DATA B( LHNO3  ), D( LHNO3  ) / 1.54E+01,  8.70E+03 /  ! HNO3(aq)<=>NO3+H     : Schwartz (1984)
      DATA B( LCO2   ), D( LCO2   ) / 4.30E-07, -1.00E+03 /  ! CO2*H2O<=>HCO3+H     : Smith and Martell (1976)
      DATA B( LHCO3  ), D( LHCO3  ) / 4.68E-11, -1.76E+03 /  ! HCO3<=>CO3+H         : Smith and Martell (1976)
      DATA B( LH2O2  ), D( LH2O2  ) / 2.20E-12, -3.73E+03 /  ! H2O2(aq)<=>HO2+H     : Smith and Martell (1976)
      DATA B( LHCOOH ), D( LHCOOH ) / 1.80E-04, -2.00E+01 /  ! HCOOH(aq)<=>HCOO+H   : Martell and Smith (1977)
      DATA B( LHO2   ), D( LHO2   ) / 3.50E-05,  0.00E+00 /  ! HO2(aq)<=>H+O2       : Perrin (1982)
      DATA B( LNH4OH ), D( LNH4OH ) / 1.70E-05, -4.50E+02 /  ! NH4*OH<=>NH4+OH      : Smith and Martell (1976)
      DATA B( LH2O   ), D( LH2O   ) / 1.00E-14, -6.71E+03 /  ! H2O<=>H+OH           : Smith and Martell (1976)
      DATA B( LATRA  ), D( LATRA  ) / 2.09E-02,  0.00E+00 /  ! C8H14ClN5<=>C8H13ClN5+H  : Weber (1970)
      DATA B( LCL2   ), D( LCL2   ) / 5.01E-04,  0.00E+00 /  ! CL2*H2O <=> HOCL + H + CL : LIN AND PEHKONEN, JGR, 103, D21, 28093-28102, NOVEMBER 20, 1998. ALSO SEE NOTE BELOW
      DATA B( LHOCL  ), D( LHOCL  ) / 3.16E-08,  0.00E+00 /  ! HOCL <=>H + OCL      : LIN AND PEHKONEN, JGR, 103, D21, 28093-28102, NOVEMBER 20, 1998
      DATA B( LHCL   ), D( LHCL   ) / 1.74E+06,  6.90E+03 /  ! HCL <=> H + CL       : Marsh and McElroy (1985)
      DATA B( LHYDRAZINE), D( LHYDRAZINE) / 1.11E-08,  0.00E+00 /  ! HYDRAZINE <=> HYDRAZINE+ + OH-  : Moliner and Street (1989)
      DATA B( LHBR   ), D( LHBR   ) / 1.00E+09,  0.00E+00 /  ! HBR <=> H + BR       : Schweitzer et al. (2000)
      DATA B( LHI    ), D( LHI    ) / 3.20E+09,  0.00E+00 /  ! HI <=> H + I         : Schweitzer et al. (2000)
      DATA B( LACRYACID ), D( LACRYACID ) / 5.62E-05,  0.00E+00 /  ! CH3C(O)OH <=> H + CH3C(O)O  : Riddick et al. (1985)

!-------------------------------------------------------------------------------
! Note for dissociation constant for equation 14: CL2*H2O <=> HOCL + H + CL
! Need aqueous [CL-] concentration to calculate effective henry's law coefficient
! Used a value of 2.0 mM following Lin and Pehkonen, JGR, 103, D21, 28093-28102, November 20, 1998
!-------------------------------------------------------------------------------

C...........EXTERNAL FUNCTIONS:

C-----------------------------------------------------------------------

      SPC = 0
      DO S = 1, MXSPCS
        IF( CNAME .EQ. SUBNAME( S ) )THEN
            SPC = S
            EXIT
        END IF
      END DO

C...error if species not found in table

      IF ( SPC .LE. 0 ) THEN
        XMSG = TRIM( CNAME ) // ' not found in Henry''s '//
     &         ' Law Constant table in routine HLCONST.'
        CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2 )
      END IF

C...compute the Henry's Law Constant

      TFAC = ( 298.0 - TEMP) / ( 298.0 * TEMP )
      KH = A( SPC ) * EXP( E( SPC ) * TFAC )
      HLCONST = KH

C...compute the effective Henry's law constants

      IF ( EFFECTIVE ) THEN

        IF ( HPLUS .LE. 0.0 ) THEN
          XMSG = 'Negative or Zero [H+] concentration specified ' //
     &           'in HLCONST '
          CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT2 )
        END IF

        HPLUSI = 1.0 / HPLUS
        HPLUS2I = HPLUSI * HPLUSI

C...assign a value for clminus.  use 2.0 mM based on Lin and Pehkonene, 1998, JGR

        CLMINUS   = 2.0E-03                ! chlorine ion conc [CL-]
        CLMINUSI  = 1.0 / CLMINUS          ! 1 / CLMINUS

        CHECK_NAME: SELECT CASE ( CNAME )

        CASE ('SO2')            !   SO2H2O <=> HSO3- + H+
                                ! & HSO3- <=> SO3= + H+

          AKEQ1 = B( LSO2 )  * EXP( D( LSO2 )  * TFAC )
          AKEQ2 = B( LHSO3 ) * EXP( D( LHSO3 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI + AKEQ1 * AKEQ2 * HPLUS2I )

        CASE ('HNO2')           ! HNO2(aq) <=> NO2- + H+

          AKEQ1 = B( LHNO2 ) * EXP( D( LHNO2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ('HNO3')           ! HNO3(aq) <=> NO3- + H+

          AKEQ1 = B( LHNO3 ) * EXP( D( LHNO3 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ('CO2')            !   CO2H2O <=> HCO3- + H+
                                ! & HCO3- <=> CO3= + H+

          AKEQ1 = B( LCO2 )  * EXP( D( LCO2 )  * TFAC )
          AKEQ2 = B( LHCO3 ) * EXP( D( LHCO3 ) * TFAC )
          HLCONST = KH
     &            * ( 1.0 + AKEQ1 * HPLUSI + AKEQ1 * AKEQ2 * HPLUS2I )

        CASE ('H2O2')           ! H2O2(aq) <=> HO2- + H+

          AKEQ1 = B( LH2O2 ) * EXP( D( LH2O2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ('FORMIC_ACID')    ! HCOOH(aq) <=> HCOO- + H+

          AKEQ1 = B( LHCOOH ) * EXP( D( LHCOOH ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ('HO2')            ! HO2(aq) <=> H+ + O2-

          AKEQ1 = B( LHO2 ) * EXP( D( LHO2 ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ('NH3')            ! NH4OH <=> NH4+ + OH-

          AKEQ1 = B( LNH4OH ) * EXP( D( LNH4OH ) * TFAC )
          AKEQ2 = B( LH2O ) * EXP( D( LH2O ) * TFAC )
          OHION = AKEQ2 * HPLUSI
          HLCONST = KH * ( 1.0 + AKEQ1 / OHION )

        CASE ('HYDRAZINE')      ! HYDRAZINE <=> HYDRAZINE+ + OH-

          AKEQ1 = B( LHYDRAZINE ) * EXP( D( LHYDRAZINE ) * TFAC )
          AKEQ2 = B( LH2O ) * EXP( D( LH2O ) * TFAC )
          OHION = AKEQ2 * HPLUSI
          HLCONST = KH * ( 1.0 + AKEQ1 / OHION )

        CASE ('ATRA', 'DATRA')  !     ATRA(aq)  <=>  ATRA- + H
                                !  or DATRA(aq) <=> DATRA- + H

          AKEQ1   = B( LATRA ) * EXP( D( LATRA ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ( 'CL2' )          ! CL2*H2O <=> HOCL + H + CL
                                ! HOCL <=>H + OCL

          AKEQ1   = B( LCL2 )  * EXP( D( LCL2 ) * TFAC )
          AKEQ2   = B( LHOCL ) * EXP( D( LHOCL ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI * CLMINUSI
     &            + AKEQ1 * AKEQ2 * HPLUS2I * CLMINUSI )

        CASE ( 'HCL' )          ! HCL <=> H+ + CL-

          AKEQ1   = B( LHCL ) * EXP( D( LHCL ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ( 'HOCL' )         ! HOCL <=> H+ + OCL-

          AKEQ1   = B( LHOCL ) * EXP( D( LHOCL ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ( 'HBR' )          ! HBR <=> H+ + BR-

          AKEQ1   = B( LHBR ) * EXP( D( LHBR ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ( 'HI' )          ! HI <=> H+ + I-

          AKEQ1   = B( LHI ) * EXP( D( LHI ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        CASE ( 'ACRYACID' )    ! CH3C(O)OH <=> H + CH3C(O)O 

          AKEQ1   = B( LACRYACID ) * EXP( D( LACRYACID ) * TFAC )
          HLCONST = KH * ( 1.0 + AKEQ1 * HPLUSI )

        END SELECT CHECK_NAME

      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE HGRD_DEFN

C Define the horizontal domain, globally and for each processor, if parallel
C Revision History: David Wong 18 Feb 01: created
C                   Jeff Young 23 Feb 01: generalize
C                              31 Mar 01: add BLKPRM.EXT
C                              10 Nov 01: change to use GRIDDESC, env vars
C                   J Gipson   01 Sep 04: change block size to 50
C                   J Young    07 Dec 04: remove layer dependency (for MXCELLS,
C                                         MXBLKS) to implement vertical layer
C                                         dyn alloc appropriately
C                   J Young    22 Dec 05: move proc. anayl. stuff to PAGRD_DEFN
C                   S. Roselle 29 Mar 11: Replaced I/O API include files
C                                         with UTILIO_DEFN
C                   D. Wong    11 May 11: incorporated twoway model implementation
C                   D. Wong    Aug 15:    Added a new logical variable, IO_PE_INCLUSIVE
C                                           to facilitate parallel I/O implementation
C                   D. Wong    01 Feb 19: removed all MY_N clauses
C.......................................................................
      USE RUNTIME_VARS

      IMPLICIT NONE

C returned coordinate system (projection)
      CHARACTER( 16 ), SAVE :: COORD_SYS_NAME

C map projection type (should be named PRTYP_GD!)
      INTEGER, SAVE :: GDTYP_GD = 2 ! LAMGRD3

C first map projection parameter (degrees)
      REAL( 8 ), SAVE :: P_ALP_GD = 30.0

C second map projection parameter (degrees)
      REAL( 8 ), SAVE :: P_BET_GD = 60.0

C third map projection parameter (degrees)
      REAL( 8 ), SAVE :: P_GAM_GD = -90.0

C longitude for coord-system center (degrees)
      REAL( 8 ), SAVE :: XCENT_GD = -90.0

C latitude for coord-system center (degrees)
      REAL( 8 ), SAVE :: YCENT_GD = 40.0

      REAL( 8 ), SAVE :: XORIG_GD ! X-coordinate origin of computational grid
      REAL( 8 ), SAVE :: YORIG_GD ! Y-coordinate origin of computational grid

      REAL( 8 ), SAVE :: XCELL_GD ! X-coordinate cell width (M)
      REAL( 8 ), SAVE :: YCELL_GD ! Y-coordinate cell width (M)

      INTEGER, SAVE :: GL_NCOLS   ! no. of columns in global grid
      INTEGER, SAVE :: GL_NROWS   ! no. of rows in global grid
      INTEGER, SAVE :: GL_NBNDY   ! no. of cells in one layer of global boundary
 
      INTEGER, SAVE :: NCOLS      ! grid columns array dimension
      INTEGER, SAVE :: NROWS      ! grid rows array dimension
      INTEGER, SAVE :: NBNDY      ! no. of cells in one layer of local boundary
 
!     INTEGER, PARAMETER :: NTHIK = 1     ! boundary thickness (cells)
      INTEGER, SAVE :: NTHIK      ! boundary thickness (cells)
 
      INTEGER, SAVE :: MY_NCOLS_DOT ! local no. of dot file grid columns
      INTEGER, SAVE :: MY_NROWS_DOT ! local no. of dot file grid rows
C column range for each processor
      INTEGER, ALLOCATABLE, SAVE :: COLSX_PE( :,: )
      INTEGER, ALLOCATABLE, SAVE :: COLSD_PE( :,: )  ! dot file
C row range for each processor
      INTEGER, ALLOCATABLE, SAVE :: ROWSX_PE( :,: )
      INTEGER, ALLOCATABLE, SAVE :: ROWSD_PE( :,: )  ! dot file

C maximum stencil displacement in the north, east, south, and west direction
      INTEGER, PARAMETER :: MNDIS = 2
      INTEGER, PARAMETER :: MEDIS = 2
      INTEGER, PARAMETER :: MSDIS = 2
      INTEGER, PARAMETER :: MWDIS = 2

      LOGICAL :: IO_PE_INCLUSIVE

C BLKPRM

!     INTEGER, PARAMETER :: BLKSIZE = 500
!     INTEGER, PARAMETER :: BLKSIZE = 50
!     INTEGER, SAVE :: MXCELLS
!     INTEGER, SAVE :: MXBLKS

C Integral average conc

      CONTAINS

         FUNCTION HGRD_INIT ( NPROCS, MYID ) RESULT ( SUCCESS )

         USE UTILIO_DEFN

!        INCLUDE SUBST_VGRD_ID     ! vertical dimensioning parameters

         INTEGER, INTENT( IN ) :: NPROCS  ! total worker processors
         INTEGER, INTENT( IN ) :: MYID
         LOGICAL :: SUCCESS

         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         CHARACTER( 96 ) :: XMSG = ' '

C environment variable grid name to select from GRIDDESC
         INTEGER :: STATUS, ALST

         INTEGER, ALLOCATABLE :: NCOLS_PE( : )  ! Column range for each PE
         INTEGER, ALLOCATABLE :: NROWS_PE( : )  ! Row range for each PE

         INTEGER I

C-----------------------------------------------------------------------

C This function is expected to be called only once - at startup

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SUCCESS = .TRUE.

            MYPE = MYID


C With GRID_NAME (only input) retrieve all horizontal grid parameters from
C the grid description file pointed to by the GRIDDESC env var:
            WRITE( LOGDEV, * )
            CALL LOG_HEADING( LOGDEV, "Retrieve Horizontal Grid" )
            IF ( .NOT. DSCGRID ( GRID_NAME,
     &                           COORD_SYS_NAME, GDTYP_GD, 
     &                           P_ALP_GD, P_BET_GD, P_GAM_GD,
     &                           XCENT_GD, YCENT_GD,
     &                           XORIG_GD, YORIG_GD, XCELL_GD, YCELL_GD,
     &                           GL_NCOLS, GL_NROWS, NTHIK ) ) THEN
               XMSG = 'Failure retrieving horizontal grid parameters'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
 
            IF ( GL_NROWS .LE. 1 .AND. GL_NCOLS .LE. 1 ) COLUMN_MODEL = .TRUE.

C Check NPROCS against NPCOL*NPROW
            IF ( NPROCS .NE. NPCOL*NPROW ) THEN
               WRITE( LOGDEV,* ) ' --- Nprocs, NProw, NPcol ',
     &                                 NPROCS, NPROW, NPCOL
               XMSG = 'NPROCS is not equal to NPCOL*NPROW'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            IF ( NPROCS .GT. GL_NCOLS*GL_NROWS ) THEN

               WRITE( LOGDEV,* ) ' --- Nprocs, TOTAL_NCOLS, TOTAL_NROWS ',
     &                                 NPROCS, GL_NCOLS, GL_NROWS
               IF ( MYPE .EQ. 0 ) THEN
                  WRITE( OUTDEV,'(A,4(1X,I4))') ' --- Nprocs, TOTAL_NCOLS, TOTAL_NROWS ',
     &                                                NPROCS, GL_NCOLS, GL_NROWS
               END IF

               XMSG = 'NPROCS must be less than or equal to TOTAL_NCOLS*TOTAL_NROWS'
               IF ( MYPE .EQ. 0 ) THEN
                  WRITE(OUTDEV,'(A)')TRIM( XMSG )
               END IF 
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )

               XMSG = 'Change NPROCS, NPCOL, NPROW in runscript to fit TOTAL_NCOLS and TOTAL_NROWS'
               IF ( MYPE .EQ. 0 ) THEN
                  WRITE(OUTDEV,'(A,/)')TRIM( XMSG )
               END IF 
               WRITE(LOGDEV,'(A)')TRIM( XMSG )

               SUCCESS = .FALSE.; RETURN

            END IF

            ALLOCATE ( COLSX_PE( 2,NPROCS ),
     &                 ROWSX_PE( 2,NPROCS ), STAT = ALST )
            IF ( ALST .NE. 0 ) THEN
               XMSG = '*** COLSX_PE or ROWSX_PE Memory allocation failed'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE ( COLSD_PE( 2,NPROCS ),
     &                 ROWSD_PE( 2,NPROCS ), STAT = ALST )
            IF ( ALST .NE. 0 ) THEN
               XMSG = '*** COLSD_PE or ROWSD_PE  Memory allocation failed'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE ( NCOLS_PE( NPROCS ),
     &                 NROWS_PE( NPROCS ), STAT = ALST )
            IF ( ALST .NE. 0 ) THEN
               XMSG = '*** NCOLS_PE or NROWS_PE Memory allocation failed'
               CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Construct the processor-to-subdomain map for main domain
            CALL SUBHDOMAIN( NPROCS, NPCOL, NPROW, GL_NCOLS, GL_NROWS,
     &                       NCOLS_PE, NROWS_PE, COLSX_PE, ROWSX_PE )

C Get corresponding dot file map

            DO I = 1, NPROCS
               COLSD_PE( 1,I ) = COLSX_PE( 1,I )
               COLSD_PE( 2,I ) = COLSX_PE( 2,I )
               ROWSD_PE( 1,I ) = ROWSX_PE( 1,I )
               ROWSD_PE( 2,I ) = ROWSX_PE( 2,I )
            END DO

            DO I = NPCOL, NPROCS, NPCOL
               COLSD_PE( 2,I ) = COLSD_PE( 2,I ) + 1
            END DO

            DO I = NPROCS, NPROCS - NPCOL + 1, -1
               ROWSD_PE( 2,I ) = ROWSD_PE( 2,I ) + 1
            END DO

            NCOLS = NCOLS_PE( MYPE+1 )
            NROWS = NROWS_PE( MYPE+1 )
            NBNDY = 2*NTHIK * ( NCOLS + NROWS + 2*NTHIK )
            GL_NBNDY = 2*NTHIK * ( GL_NCOLS + GL_NROWS + 2*NTHIK )

            MY_NCOLS_DOT = COLSD_PE( 2,MYPE+1 ) - COLSD_PE( 1,MYPE+1 ) + 1
            MY_NROWS_DOT = ROWSD_PE( 2,MYPE+1 ) - ROWSD_PE( 1,MYPE+1 ) + 1

!           MXCELLS = NCOLS * NROWS * NLAYS
!           MXBLKS  = 1 + ( MXCELLS - 1 ) / BLKSIZE

            DEALLOCATE ( NCOLS_PE )
            DEALLOCATE ( NROWS_PE )

         ELSE
            XMSG = 'Horizontal domain decomposition already defined'
            CALL M3WARN ( 'HGRD_INIT', 0, 0, XMSG )
            SUCCESS = .FALSE.; RETURN

         END IF   ! FIRSTIME

         RETURN
         END FUNCTION HGRD_INIT
 
      END MODULE HGRD_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !!
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       MODULE AEROSOL_CHEMISTRY
!-----------------------------------------------------------------------
! Revision history
!
! 26 Sep 14 H. Pye: Heterogeneous uptake of IEPOX added 
! 27 Feb 15 J. Bash:
! 17 March 15 D. Luecken:  Added NTR heterogeneous hydrolysis as per
!    the CB6r3 chemical mechanism used by the Environ CAMX model consult 
!    references 8 and 9., 
! 22 Feb 16 B.Hutzell: Added Flag stating whether module is initialized
! 24 March 16 D. Luecken: removed the references to F_NTR2_ON so that all 
!  nitrates have the potential to partition to aerosol.  
! 24 Mar 16 G. Sarwar: Added heterogeneous uptake of BRONO2 on aerosols
! 10 May 16 H. Pye: Merged with AEROSOL_CHEMISTRY.F from aero6i
!                   Size of NAMES_AERO_RATES reduced to match RXN_DATA_MODULE
!    May 16 H. Pye, B. Murphy: Updated treatment of aerosol moments
! 23 May 16 D. Wong: Allow for calculation for APMDIAG even if PMDIAG is turned off.
! 10 Jun 16 B.Hutzell: reduce occurrences of numerical underflow
! 17 Jul 18 G. Sarwar: Added heterogeneous uptakes of CLNO3, bromine and iodine species
! 01 Feb 19 David Wong: removed MY_N clauses
! 03 Apr 19 H. Pye: Updated IEPOX to consume inorganic sulfate when OS are formed
!-----------------------------------------------------------------------

       IMPLICIT NONE
       
       REAL( 8 ), ALLOCATABLE :: KHETERO( :,:,:,: ) ! heterogeneous rx rates, 
                                                    ! [ppm**(RXN Order-1)*min]**-1
       REAL,      ALLOCATABLE :: GAMMA_N2O5IJ( :,:,:  ) ! Fine modes N2O5 rx effic.
       REAL,      ALLOCATABLE :: GAMMA_N2O5K(  :,:,:  ) ! Coarse mode N2O5 rx effic.
       REAL,      ALLOCATABLE :: KPARTIEPOX (  :,:,:  ) ! IEPOX particle-phase reaction rate constant (sec-1)
       REAL,      ALLOCATABLE :: GAMMA_IEPOX(  :,:,:  ) ! IEPOX uptake coeff
       REAL,      ALLOCATABLE :: GAMMA_IMAE (  :,:,:  ) ! IMAE uptake coeff
       REAL,      ALLOCATABLE :: YCLNO2IJ   (  :,:,:  ) ! Yield CLNO2 in Fine modes 
       REAL,      ALLOCATABLE :: YCLNO2K    (  :,:,:  ) ! Yield CLNO2 in coarse mode 

       LOGICAL                :: AERO_CHEM_SET = .FALSE.
      
       PUBLIC  KHETERO, GAMMA_N2O5IJ, GAMMA_N2O5K, KPARTIEPOX, GAMMA_IEPOX, GAMMA_IMAE, 
     &         YCLNO2IJ, YCLNO2K, HETCHEM_RATES, AERO_CHEM_SET
       
       PRIVATE 

       INTEGER, PARAMETER :: NUMB_AERO_RATES = 59
       
       CHARACTER( 16 ), PARAMETER :: NAMES_AERO_RATES( NUMB_AERO_RATES ) = 
     &                    (/ 'HETERO_N2O5IJ   ', 'HETERO_N2O5K    ', 
     &                       'HETERO_N2O5IJY  ', 'HETERO_N2O5KY   ', 
     &                       'HETERO_NO2      ', 'HETERO_H2NO3PAIJ',
     &                       'HETERO_H2NO3PBIJ', 'HETERO_H2NO3PAK ',
     &                       'HETERO_H2NO3PBK ', 'HETERO_H2NO3PAI ',
     &                       'HETERO_H2NO3PBI ', 'HETERO_H2NO3PAJ ',
     &                       'HETERO_H2NO3PBJ ', 'HETERO_N2O5I    ',
     &                       'HETERO_N2O5J    ', 'HETERO_PNCOMLI  ',
     &                       'HETERO_PNCOMLJ  ', 'HETERO_IEPOX    ',
     &                       'HETERO_TETROL   ', 'HETERO_IEPOXOS  ',
     &                       'HETERO_TETROLDIM', 'HETERO_IEPOXOSDI',
     &                       'HETERO_IMAE     ', 'HETERO_2MG      ',
     &                       'HETERO_IMAEOS   ', 'HETERO_NO3      ',
     &                       'HETERO_GLY      ', 'HETERO_MGLY     ',
     &                       'HETERO_NTR2     ', 'HETERO_CLNO3_WAJ',
     &                       'HETERO_CLNO3_WAK', 'HETERO_HBR_BRJ  ',
     &                       'HETERO_HBR_BRK  ', 'HETERO_BRNO3_WAJ',
     &                       'HETERO_BRNO3_WAK', 'HETERO_HOBR_CLJ ',
     &                       'HETERO_HOBR_CLK ', 'HETERO_HOBR_BRJ ',
     &                       'HETERO_HOBR_BRK ', 'HETERO_I2O2_AJ  ',
     &                       'HETERO_I2O2_AK  ', 'HETERO_I2O3_AJ  ',
     &                       'HETERO_I2O3_AK  ', 'HETERO_I2O4_AJ  ',
     &                       'HETERO_I2O4_AK  ', 'HETERO_INO3_CLJ ',
     &                       'HETERO_INO3_CLK ', 'HETERO_INO3_BRJ ',
     &                       'HETERO_INO3_BRK ', 'HETERO_INO2_CLJ ',
     &                       'HETERO_INO2_CLK ', 'HETERO_INO2_BRJ ',
     &                       'HETERO_INO2_BRK ', 'HETERO_HOI_CLJ  ',
     &                       'HETERO_HOI_CLK  ', 'HETERO_HOI_BRJ  ',
     &                       'HETERO_HOI_BRK  ', 'HETERO_HI_AJ    ',
     &                       'HETERO_HI_AK    '/)

       INTEGER, PARAMETER  :: IA_N2O5IJ         =   1
       INTEGER, PARAMETER  :: IA_N2O5K          =   2
       INTEGER, PARAMETER  :: IA_N2O5IJY        =   3
       INTEGER, PARAMETER  :: IA_N2O5KY         =   4
       INTEGER, PARAMETER  :: IA_NO2            =   5
       INTEGER, PARAMETER  :: IA_H2NO3PAIJ      =   6
       INTEGER, PARAMETER  :: IA_H2NO3PBIJ      =   7
       INTEGER, PARAMETER  :: IA_H2NO3PAK       =   8
       INTEGER, PARAMETER  :: IA_H2NO3PBK       =   9
       INTEGER, PARAMETER  :: IA_H2NO3PAI       =   10
       INTEGER, PARAMETER  :: IA_H2NO3PBI       =   11
       INTEGER, PARAMETER  :: IA_H2NO3PAJ       =   12
       INTEGER, PARAMETER  :: IA_H2NO3PBJ       =   13
       INTEGER, PARAMETER  :: IA_N2O5I          =   14
       INTEGER, PARAMETER  :: IA_N2O5J          =   15
       INTEGER, PARAMETER  :: IA_PNCOMLI        =   16
       INTEGER, PARAMETER  :: IA_PNCOMLJ        =   17
       INTEGER, PARAMETER  :: IA_IEPOX          =   18
       INTEGER, PARAMETER  :: IA_TETROL         =   19
       INTEGER, PARAMETER  :: IA_IEPOXOS        =   20
       INTEGER, PARAMETER  :: IA_TETROLDIM      =   21
       INTEGER, PARAMETER  :: IA_IEPOXOSDI      =   22
       INTEGER, PARAMETER  :: IA_IMAE           =   23
       INTEGER, PARAMETER  :: IA_2MG            =   24
       INTEGER, PARAMETER  :: IA_IMAEOS         =   25
       INTEGER, PARAMETER  :: IA_NO3            =   26
       INTEGER, PARAMETER  :: IA_GLY            =   27
       INTEGER, PARAMETER  :: IA_MGLY           =   28
       INTEGER, PARAMETER  :: IA_NTR2           =   29
       INTEGER, PARAMETER  :: IA_CLNO3_WAJ      =   30
       INTEGER, PARAMETER  :: IA_CLNO3_WAK      =   31          
       INTEGER, PARAMETER  :: IA_HBR_BRJ        =   32
       INTEGER, PARAMETER  :: IA_HBR_BRK        =   33  
       INTEGER, PARAMETER  :: IA_BRNO3_WAJ      =   34
       INTEGER, PARAMETER  :: IA_BRNO3_WAK      =   35      
       INTEGER, PARAMETER  :: IA_HOBR_CLJ       =   36
       INTEGER, PARAMETER  :: IA_HOBR_CLK       =   37
       INTEGER, PARAMETER  :: IA_HOBR_BRJ       =   38
       INTEGER, PARAMETER  :: IA_HOBR_BRK       =   39                  
       INTEGER, PARAMETER  :: IA_I2O2_AJ        =   40
       INTEGER, PARAMETER  :: IA_I2O2_AK        =   41       
       INTEGER, PARAMETER  :: IA_I2O3_AJ        =   42
       INTEGER, PARAMETER  :: IA_I2O3_AK        =   43       
       INTEGER, PARAMETER  :: IA_I2O4_AJ        =   44
       INTEGER, PARAMETER  :: IA_I2O4_AK        =   45                                          
       INTEGER, PARAMETER  :: IA_INO3_CLJ       =   46
       INTEGER, PARAMETER  :: IA_INO3_CLK       =   47        
       INTEGER, PARAMETER  :: IA_INO3_BRJ       =   48
       INTEGER, PARAMETER  :: IA_INO3_BRK       =   49        
       INTEGER, PARAMETER  :: IA_INO2_CLJ       =   50
       INTEGER, PARAMETER  :: IA_INO2_CLK       =   51        
       INTEGER, PARAMETER  :: IA_INO2_BRJ       =   52
       INTEGER, PARAMETER  :: IA_INO2_BRK       =   53    
       INTEGER, PARAMETER  :: IA_HOI_CLJ        =   54             
       INTEGER, PARAMETER  :: IA_HOI_CLK        =   55    
       INTEGER, PARAMETER  :: IA_HOI_BRJ        =   56             
       INTEGER, PARAMETER  :: IA_HOI_BRK        =   57   
       INTEGER, PARAMETER  :: IA_HI_AJ          =   58
       INTEGER, PARAMETER  :: IA_HI_AK          =   59  

       INTEGER, PARAMETER :: INDEX_AERO_RATES( NUMB_AERO_RATES ) = 
     &                    (/ IA_N2O5IJ   , IA_N2O5K    , 
     &                       IA_N2O5IJY  , IA_N2O5KY   , 
     &                       IA_NO2      , IA_H2NO3PAIJ,
     &                       IA_H2NO3PBIJ, IA_H2NO3PAK ,
     &                       IA_H2NO3PBK , IA_H2NO3PAI ,
     &                       IA_H2NO3PBI , IA_H2NO3PAJ ,
     &                       IA_H2NO3PBJ , IA_N2O5I    , 
     &                       IA_N2O5J    , IA_PNCOMLI  ,
     &                       IA_PNCOMLJ  , IA_IEPOX    ,
     &                       IA_TETROL   , IA_IEPOXOS  ,
     &                       IA_TETROLDIM, IA_IEPOXOSDI,
     &                       IA_IMAE     , IA_2MG      ,
     &                       IA_IMAEOS   , IA_NO3      ,
     &                       IA_GLY      , IA_MGLY     ,     
     &                       IA_NTR2     , IA_CLNO3_WAJ,         
     &                       IA_CLNO3_WAK, IA_HBR_BRJ  ,
     &                       IA_HBR_BRK  , IA_BRNO3_WAJ,
     &                       IA_BRNO3_WAK, IA_HOBR_CLJ ,          
     &                       IA_HOBR_CLK , IA_HOBR_BRJ ,            
     &                       IA_HOBR_BRK , IA_I2O2_AJ  ,     
     &                       IA_I2O2_AK  , IA_I2O3_AJ  ,
     &                       IA_I2O3_AK  , IA_I2O4_AJ  ,
     &                       IA_I2O4_AK  , IA_INO3_CLJ ,          
     &                       IA_INO3_CLK , IA_INO3_BRJ ,
     &                       IA_INO3_BRK , IA_INO2_CLJ ,               
     &                       IA_INO2_CLK , IA_INO2_BRJ ,
     &                       IA_INO2_BRK , IA_HOI_CLJ  ,
     &                       IA_HOI_CLK  , IA_HOI_BRJ  ,     
     &                       IA_HOI_BRK  , IA_HI_AJ    ,
     &                       IA_HI_AK   /)           

       INTEGER               :: SELECTED_AERO_RATES
       INTEGER, ALLOCATABLE  :: WHICH_AERO_RATE( : )
       
C *** Molecular weight
      REAL( 8 ), SAVE        :: MWTIEPOX      ! molecular weight of IEPOX [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_IEPOX ! factor used for the mean molecular speed of IEPOX [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTIMAE       ! molecular weight of IMAE [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_IMAE  ! factor used for the mean molecular speed of IMAE [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTNO3        ! molecular weight of NO3 [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_NO3   ! factor used for the mean molecular speed of NO3 [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTGLY        ! molecular weight of GLY [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_GLY   ! factor used for the mean molecular speed of GLY [m/(s^1*(deg K)^0.5)]
      REAL( 8 ), SAVE        :: MWTMGLY       ! molecular weight of MGLY [g/mol]
      REAL( 8 ), SAVE        :: CFACTOR_MGLY  ! factor used for the mean molecular speed of MGLY [m/(s^1*(deg K)^0.5)]

C *** 2nd and 3rd moments with wet species
      REAL( 8 ), ALLOCATABLE :: WET_M3( : ) ! WET_M3_I,  WET_M3_J, WET_M3_K   ! M3 w.H2O, svOA
      REAL( 8 ), ALLOCATABLE :: WET_M2( : ) ! WET_M2_I,  WET_M2_J, WET_M2_K   ! M2 w.H2O, svOA
      REAL( 8 ), ALLOCATABLE :: DE_WET( : ) ! DE_AT_WET, DE_AC_WET, DE_CO_WET ! Initial effective diameter w.H2O

C Isoprene product particle phase reaction rates (Eddingsaas et al. 2010) [1/(M^2 s)]
      REAL ( 8 ), PARAMETER :: K_H_WATER    = 9.0D-4
      REAL ( 8 ), PARAMETER :: K_H_NUC      = 2.0D-4
      REAL ( 8 ), PARAMETER :: K_H_SO4      = 8.83D-3 ! Piletic et al. 2013, Budisulistiorini et al. in prep
      REAL ( 8 ), PARAMETER :: K_HSO4_WATER = 1.31D-5
      REAL ( 8 ), PARAMETER :: K_HSO4_NUC   = 2.92D-6

C Acid catalyzed particle phase reactions
      TYPE ACID_CAT
         CHARACTER( 16 ) :: PARENT     ! gas-phase parent species
         CHARACTER( 16 ) :: NUC        ! aerosol-phase nucleophile that adds to epoxide ring
         CHARACTER( 16 ) :: ACID       ! acid that catalyzes epoxide ring opening
         INTEGER         :: IDX_ACID   ! array index for acid concentration
         INTEGER         :: IDX_REMOVE ! array index denoting whether to correct nucleophile for acid
         REAL( 8 )       :: KCHEM      ! particle phase rate constant [1/(M^2 s)]
         CHARACTER( 16 ) :: PROD       ! product of nucleophile+parent
      END TYPE ACID_CAT

C IEPOX uptake parameters 
      INTEGER, SAVE                       :: N_NUCPAIRS          ! NUMBER OF ACID/NUCLEOPHILE PAIRS 
      TYPE( ACID_CAT ), ALLOCATABLE, SAVE :: ACID_NUC_PAIRS( : )
      INTEGER, SAVE                       :: NUMVOC              ! number of VOCs treated (IEPOX, IMAE)

C IEPOX uptake parameters for standard AERO6 or AERO7 (condensed IEPOX SOA)
      INTEGER, PARAMETER       :: N_NUCPAIRS_AE = 6      ! NUMBER OF ACID/NUCLEOPHILE PAIRS 

C IEPOX uptake based on Eddingsaas et al. 2010 parameters with Piletic
C 2013 update for the organosulfate. Same as Pye et al. 2013
C implementation except dimers are not considered. 
      TYPE( ACID_CAT ), PARAMETER :: ACID_NUC_PAIRS_AE( N_NUCPAIRS_AE ) = (/
C                  Parent   Nucleophile     Acid     Acid    Remove   Rate Constant  Product
C                 (parent)    (nuc)        (acid)    Index   Index       (kchem)      (prod)
C                 --------  -----------  ----------  -----   ------   -------------  --------
     &   ACID_CAT('IEPOX',  'AH2OJ    ', 'HPLUS   ',   1,     0,       K_H_WATER,    'AISO3J' ),
     &   ACID_CAT('IEPOX',  'ASO4J    ', 'HPLUS   ',   1,     2,       K_H_SO4,      'AISO3J'  ),
     &   ACID_CAT('IEPOX',  'ANO3J    ', 'HPLUS   ',   1,     0,       K_H_NUC,      'AISO3J'  ),
     &   ACID_CAT('IEPOX',  'AH2OJ    ', 'HSO4    ',   2,     0,       K_HSO4_WATER, 'AISO3J' ),
     &   ACID_CAT('IEPOX',  'ASO4J    ', 'HSO4    ',   2,     2,       K_HSO4_NUC,   'AISO3J'  ),
     &   ACID_CAT('IEPOX',  'ANO3J    ', 'HSO4    ',   2,     0,       K_HSO4_NUC,   'AISO3J'  )/)

C IEPOX + MAE uptake parameters for AERO6i or AERO7i (explicit IEPOX SOA)
      INTEGER, PARAMETER :: N_NUCPAIRS_AEI = 12      ! NUMBER OF ACID/NUCLEOPHILE PAIRS

C IEPOX uptake following the implementation
C in Pye et al. 2013 ES&T base simulation except epoxide-derived organonitrates are no longer
C considered in saprc07tic_ae7i due to their predicted small contribution to ambient PM. In addition,
C oligomerization of MAE/HMML-derived aerosol is not considered also due to its predicted
C small contribution and desire to have the model "dimer" species be only IEPOX derived.
      TYPE( ACID_CAT ), PARAMETER :: ACID_NUC_PAIRS_AEI( N_NUCPAIRS_AEI ) = (/
C                  Parent   Nucleophile     Acid     Acid    Remove   Rate Constant  Product
C                 (parent)    (nuc)        (acid)    Index   Index       (kchem)      (prod)
C                 --------  -----------  ----------  -----   ------   -------------  --------
     &   acid_cat('IEPOX',  'AH2OJ    ', 'HPLUS   ',   1,     0,       k_H_water,    'AIETETJ' ),
     &   acid_cat('IEPOX',  'ASO4J    ', 'HPLUS   ',   1,     2,       k_H_SO4,      'AIEOSJ'  ),
     &   acid_cat('IEPOX',  'AIEOSJ   ', 'HPLUS   ',   1,     0,       k_H_nuc,      'ADIMJ'   ),
     &   acid_cat('IEPOX',  'AIETETJ  ', 'HPLUS   ',   1,     0,       k_H_nuc,      'ADIMJ'   ),
     &   acid_cat('IEPOX',  'AH2OJ    ', 'HSO4    ',   2,     0,       k_HSO4_water, 'AIETETJ' ),
     &   acid_cat('IEPOX',  'ASO4J    ', 'HSO4    ',   2,     2,       k_HSO4_nuc,   'AIEOSJ'  ),
     &   acid_cat('IEPOX',  'AIEOSJ   ', 'HSO4    ',   2,     0,       k_HSO4_nuc,   'ADIMJ'   ),
     &   acid_cat('IEPOX',  'AIETETJ  ', 'HSO4    ',   2,     0,       k_HSO4_nuc,   'ADIMJ'   ),
     &   acid_cat('IMAE',   'AH2OJ    ', 'HPLUS   ',   1,     0,       k_H_water,    'AIMGAJ'  ),
     &   acid_cat('IMAE',   'ASO4J    ', 'HPLUS   ',   1,     2,       k_H_nuc,      'AIMOSJ'  ),
     &   acid_cat('IMAE',   'AH2OJ    ', 'HSO4    ',   2,     0,       k_HSO4_water, 'AIMGAJ'  ),
     &   acid_cat('IMAE',   'ASO4J    ', 'HSO4    ',   2,     2,       k_HSO4_nuc,   'AIMOSJ'  )/)


C Mapping array for location of acid enhanced products and nucleophiles in aerospc_conc 
      INTEGER, ALLOCATABLE, SAVE :: ACID_PRODMAP_IDX( : )
      INTEGER, ALLOCATABLE, SAVE ::  ACID_NUCMAP_IDX( : )

      CONTAINS

      SUBROUTINE HETCHEM_RATES( TEMP, PRESS, WVAPOR, CGRID, DENS )

c Calculates the heterogeneous reactions for N2O5, NO2, CLNO2, and IEPOX. 
c
c Key Subroutines Called: EXTRACT_AERO, EXTRACT_SOA, PATPAR
c                         N2O5_GAMMA
c
c 09/18/13 - B.Hutzell - initial version adapted from the hetchem.F file
c            in aero6 module of CMAQ version 5.01. The adaptation includes
c            heterogeneous nitryl chloride production used for Sarwar et al.
c            (2012).
c 09/12/14 - G. Sarwar - revised the heterogeneous nitryl chloride production
c 09/26/14 - H. Pye - Heterogeneous uptake of IEPOX on acidic aerosol added
c            following Pye et al. (2013).
c 10/01/14 - B.Hutzell - change STP value for N205 diffusivity based on
c            review paper: 1)   M. J. Tang, R. A. Cox, and M. Kalberer.
c            Compilation and evaluation of gas-phase diffusion coefficients 
c            of inorganic reactive trace gases in the atmosphere. Atmos. Chem.
c            Phys. Discuss., 14, 15645–15682, 2014. 
c            www.atmos-chem-phys-discuss.net/14/15645/2014/doi:10.5194/acpd-14-15645-2014.pdf
c 09/12/14 - G. Sarwar - revised the heterogeneous nitryl chloride production
C 10/01/14 - B.Hutzell - change STP value for N205 diffusivity based on
C            review paper: 1)   M. J. Tang, R. A. Cox, and M. Kalberer.
C            Compilation and evaluation of gas-phase diffusion coefficients 
C            of inorganic reactive trace gases in the atmosphere. Atmos. Chem.
C            Phys. Discuss., 14, 15645–15682, 2014. 
C            www.atmos-chem-phys-discuss.net/14/15645/2014/doi:10.5194/acpd-14-15645-2014.pdf
c 01/02/15 - H. Pye - Heterogeneous uptake of MAE added to saprc07tic_ae6i version
C            heterogeneous nitryl chloride production used for Sarwar et al.
c            (2012).
C 02/09/15 - B.Hutzell - corrected NO2 rate by a factor of two based consulting the stoiciometery for 
c            reaction published in Sarwar et al. (2008) and its analytical solution
C 05/06/2015 H Pye - Added NO3 heterogeneous reaction using low end of
C            range from Mao et al 2013 
C 06/2015    H Pye - Added SOA from GLY and MGLY uptake onto particles
C 09/2015    B.Hutzell - Added data and varaibles to calculate pseudo-first order rate constant 
C            for heterogeneous hydrolysis that converts organic nitrate to nitric acid. Both are
C            assumed gas phase species. The reaction comes the CB6r3 chemical mechanism used by 
C            the Environ CAMX model consult references 9 and 10.
c 03/24/16 - G. Sarwar - Heterogeneous uptake of BRONO2 on aerosols
C 5/2016     H Pye - merged with AERO6i version (added NO3, GLY, MGLY, IMAE het rxn)
c 07/17/18 - G. Sarwar - Heterogeneous uptakes of chlorine, bromine and iodine species on aerosols
c
c  REFERENCES:
c   1. Pleim, J.E., F.S. Binkowski, J.K.S. Ching, R.L. Dennis, and N.V.
c      Gallani, An improved representation of the reaction of N2O5 on
c      aerosols for mesoscale air quality models.  In "Regional
c      Photochemical Measurement and Modeling Studies, Vol 2 - Results
c      and Status of Modeling," Eds A.J. Ranzieri and P.A. Solomon, pp
c      904-913, 1995.
c
c   2. Davis, J.M., P.V. Bhave, and K.M. Foley, Parameterization of N2O5
c      reaction probabilities on the surface of particles containing
c      ammonium, sulfate, and nitrate.  Atmos. Chem. Phys., 2008, in
c      press.
c
c   3. Vogel, B., H. Vogel, J. Kleffman, and R. Kurtenbach, Measured and
c      simulated vertical profiles of nitrous acid - Part II. Model
c      simulations and indications for a photolytic source, Atmospheric
c      Environment, 37, 2957-2966, 2003.
c
c   4. Sarwar, G., S.J. Roselle, R. Mathur, W. Appel, R.L. Dennis, and
c      B. Vogel, A comparison of CMAQ HONO predictions with observations
c      from the Northeast Oxidant and Particle Study, Atmospheric
c      Environment, 2008, in press.
C
C   5. Bertram, T. H. and J.A. Thornton, Toward a general parameterization
C      of N2O5 reactivity on aqueous particles: the competing effects of 
C      particle liquid water, nitrate, and chloride, ACP, 9, 8351-8363, 2009 
C
C   6. Sarwar, G., H. Simon2, P. Bhave1, and G. Yarwood. Examining the impact of 
C      heterogeneous nitryl chloride production on air quality across the United
C      States. Atmos. Chem. Phys., 12, 6455-6473, 2012.
C
C   7. Pye et al., Epoxide pathways improve model predictions of isoprene
C      markers and reveal key role of acidity in aerosol formation,
C      Environ. Sci. Technol., doi: 10.1021/es402106h, 2013.
C
C   8. Rollins, A.W., S. Pusede, P.Wooldridge, K.-E.Min, D.R. Gentner, A.H. 
C      Goldstein, S. Liu, D.A. Day, L.M. Russell, C.L. Rubitschun, J.D. Surratt,
C      and R.C. Cohen, Gas/particle partitioning of total alkyl nitrates 
C      observed with TD-LIF in Bakersfield.J.Geophys.Res., 118, 6651-6662, 2013.
C
C   9. Liu, S., J.E. Shilling, C. Song, N. Hiranuma, R.A. Zaveri, L.M. Russell,
C      Hydrolysis of Organonitrate Functional Groups in Aerosol Particles.
C      Aerosol Sci. Technol., 46, 1359-1369, 2012.
C
C  10. Yang, X., R. A. Cox, N. J. Warwick, J. A. Pyle, G. D. Carver, F. M.
C      O'Connor, and N. H. Savage, Tropospheric bromine chemistry
C      and its impacts on ozone: A model study, J. Geophys. Res., 110, D23311,
C      doi:10.1029/2005JD006244, 2005.
C
C  11. Mao et al. Ozone and organic nitrates over the eastern United
C      States: Sensitivity to isoprene chemistry, J. Geophys. Res. doi:
C      10.1002/jgrd.50817, 2013.

C  12. Fernandez et al., Bromine partitioning in the tropical tropopause layer: 
C      implications for stratospheric injection, ACP, 14, 13391-13410, 2014.
C
C  13. Schmidt et al., Modeling the observed tropospheric BrO background: Importance 
C      of multiphase chemistry and implications for ozone, OH, and mercury, 
C      J. Geophys. Res. doi: 10.1002/2015JD024229
C
C  14. Sherwen et al., Global impacts of tropospheric halogens on oxidants and 
C      composition in GEOS-CHEM: ACP, 16, 12239-12271, 2016
C
C  15. Deiber et al., Uptake of ClONO2 and BrONO2 by halide containing droplets
C      ACP, 4, 1291-1299, 2004
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE UTILIO_DEFN
      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE RXNS_DATA
      USE AERO_DATA
      USE AEROMET_DATA, ONLY: f6dpi
      USE PRECURSOR_DATA
      USE SOA_DEFN

      IMPLICIT NONE

      INCLUDE SUBST_CONST       ! CMAQ constants

C *** Arguments
      REAL,           POINTER       :: CGRID ( :,:,:,: )  ! pointer of model concentrations
      REAL,           INTENT( IN )  :: TEMP  ( :,:,: )    ! temperature [K]
      REAL,           INTENT( IN )  :: PRESS ( :,:,: )    ! pressure [Pa]
      REAL,           INTENT( IN )  :: WVAPOR( :,:,: )    ! water vapor mass mixing ratio(Kg/Kg air)
      REAL, OPTIONAL, INTENT( IN )  :: DENS ( :,:,: )     ! air density(Kg/m3 air)

      CHARACTER(16), SAVE ::  PNAME = 'HETCHEM_RATES'
      
C *** Parameters
      REAL( 8 ), PARAMETER :: AQUEOUS_FREQUENCY = 1.0D+9
      REAL( 8 ), PARAMETER :: INV_SQRT_MWNO2  = 1.47425932467825D-1
      REAL( 8 ), PARAMETER :: INV_SQRT_MWN2O5 = 9.62161363758323D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWCLNO3  = 1.012739360000D-1        
      REAL( 8 ), PARAMETER :: INV_SQRT_MWBRNO3 = 8.394770000000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWBRNO2  = 8.91220000000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHOBR   = 1.015869000D-1
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHBR    = 1.111797000D-1                   
      REAL( 8 ), PARAMETER :: INV_SQRT_MWI2O2 = 5.9151900D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWI2O3 = 5.7562500D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWI2O4 = 5.6090000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWINO3 = 7.275850000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWINO2 = 7.605050000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHOI  = 8.336220000D-2
      REAL( 8 ), PARAMETER :: INV_SQRT_MWHI   = 8.842289400D-2   

      REAL( 8 ), PARAMETER :: UGM3_CONV_FAC   = 8.31251724585556D00 ! =1.0E-3*AIRDENS_STD*(PRESS_STD/TEMP_STD)
      REAL( 8 ), PARAMETER :: COEF1           = 7.24382926227485D10 ! Molec/cc to ppm conv factor 
      REAL( 8 ), PARAMETER :: COEF2           = 2.14805198392421D13 ! convert air density [kg/m3] to number density [ppm]

      REAL( 8 ), PARAMETER :: GAMMA_NO3       = 1.0D-4 ! Mao et al. 2013
      REAL( 8 ), PARAMETER :: GAMMA_GLY       = 2.9D-3 ! Liggio et al. 2005

      REAL( 8 ), PARAMETER :: STD_DIFF_N2O5 = 0.0855D-4  ! N2O5 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_CLNO3  = 0.1014D-4    ! CLNO3 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]   
      REAL( 8 ), PARAMETER :: STD_DIFF_BRNO3  = 0.0855D-4    ! BRONO2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_BRNO2  = 0.0999D-4    ! BRNO2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_HOBR   = 0.1101D-4    ! HOBR molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]
      REAL( 8 ), PARAMETER :: STD_DIFF_HBR    = 0.1216D-4    ! HBR molecular diffusivity at 101325 Pa and 273.15 K [m2/sec]    
      REAL( 8 ), PARAMETER :: STD_DIFF_I2O2   = 0.0732D-4    ! I2O2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_I2O3   = 0.0707D-4    ! I2O3 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_I2O4   = 0.0684D-4    ! I2O4 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_INO3   = 0.0792D-4    ! INO3 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_INO2   = 0.0833D-4    ! INO2 molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_HOI    = 0.0972D-4    ! HOI molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 
      REAL( 8 ), PARAMETER :: STD_DIFF_HI     = 0.1045D-4    ! HI molecular diffusivity at 101325 Pa and 273.15 K [m2/sec] 

!     REAL,      PARAMETER :: GPKG        = 1.0E+03                      ! g/kg unit conversion
      REAL,      PARAMETER :: CFACTOR     = 8.0 * GPKG  * RGASUNIV / PI  ! factor in cbar_coeff
      REAL,      PARAMETER :: PA2ATM      = 1.0 / STDATMPA               ! Pascal to atm conv fac
      REAL,      PARAMETER :: WMASS2PPM   = 1.0E6 * MWAIR / MWWAT        ! H20 mixing ratio to ppm
      REAL,      PARAMETER :: MAOMV       = MWAIR / MWWAT
      REAL,      PARAMETER :: CONCOFM     = 1.0E+06        ! conc. of M = 1E+06 ppm
      REAL,      PARAMETER :: INV_STDTEMP = 1.0 / STDTEMP
      REAL,      PARAMETER :: EPSWATER    = MWWAT / MWAIR
C *** parameters for heterogeneous hydrolysis of NTR2
      REAL,      PARAMETER :: ON_ALPHA1   = 0.34,     ! Organic nitrate (ON) partitioning parameters
     &                        ON_ALPHA2   = 0.66,     ! based on Rollins et al., 2013
     &                        ON_CSTAR1   = 0.73,
     &                        ON_CSTAR2   = 1000.0

      REAL,      PARAMETER :: MIN_TOA     = 0.0001       ! Min. conc. of total OA for partitioning to occur [ug/m3]
      REAL,      PARAMETER :: KHON        = 2.7778E-03   ! heterogeneous ON hydrolysis rate [1/min] ~ 4/day

C *** Local Variables
      REAL( 8 )    :: AIRTEMP          ! air temperature [K]
      REAL( 8 )    :: AIRPRES          ! air pressure [Pa] 
      REAL( 8 )    :: GAMMA            ! fine mode N2O5->NO3 rxn probability
      REAL( 8 )    :: GAMMAIEPOX       ! IEPOX uptake coefficient
      REAL( 8 )    :: GAMMAIMAE        ! IMAE uptake coefficient
      REAL( 8 )    :: KPIEPOX          ! IEPOX particle-phase reaction rate const (pseudo 1st order, sec-1)
      REAL( 8 )    :: KN2O5( N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KNO3(  N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KGLY(  N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KMGLY( N_MODE  ) ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KNO2             ! pseudo-first order rate constant, sec-1
      REAL( 8 )    :: KIEPOX           ! pseudo-first order rate constant for IEPOX uptake, sec-1
      REAL( 8 )    :: KIMAE            ! pseudo-first order rate constant for MAE uptake, sec-1

      REAL( 8 )    :: K1               ! pseudo-first order rate constant, sec-1 
      REAL( 8 )    :: K2               ! pseudo-first order rate constant, sec-1 
      REAL( 8 ), PARAMETER :: MIN_VALUE = 1.0D-09      ! minimum concentration for activating chemistry

      REAL( 8 )    :: CBAR_COEFF       ! cell coefficient for mean molecular speed
      REAL( 8 )    :: ADJUST_DIFF      ! Cell temp and press correction to diffusivity
      REAL( 8 )    :: INV_DIFFUSIVITY  ! reciprocal molecular diffusivity [m2/sec] 

      REAL( 8 )    :: XXF( N_MODE )         ! XXF_AT,    XXF_AC,    XXF_CO    ! modal factors to calculate KN2O5
      REAL( 8 )    :: CL_PPM( N_MODE )      ! aerosol chlorine in ppm
      REAL( 8 )    :: BR_PPM( N_MODE )      ! aerosol bromine in ppm
      REAL( 8 )    :: YIELD_CLNO2( N_MODE ) ! model reactions yields of CLNO2      
      
      REAL( 8 )    :: H2OVP    ! ambient water vapor pressure [Atm]
      REAL( 8 )    :: AIRRH    ! Relative Humidity            [Fractional]
      REAL( 8 )    :: YIELDIJ  ! fine mode reaction yield, dimensionaless
      REAL( 8 )    :: TOTSURFA ! aerosol surface area (m**2/m**3)
      REAL( 8 )    :: FACTOR   ! scratch multiplicative factor
      REAL( 8 )    :: RFACTOR  ! factor converting rate constant from cm3/molec/sec to 1/ppm/min
      REAL( 8 )    :: RADIUS   ! effective particle radius [m]
      REAL( 8 )    :: RADIUS_K ! effective particle radius [m] - coarse mode  
      
      REAL( 8 )       :: CBAR             ! molecular velocity of N2O5 (m/s)
      REAL( 8 )       :: CBARIEPOX        ! molecular velocity of IEPOX (m/s)
      REAL( 8 )       :: CBARIMAE         ! molecular velocity of IMAE (m/s)
      REAL( 8 )       :: CBARNO3          ! molecular velocity of NO3 (m/s)
      REAL( 8 )       :: CBARGLY          ! molecular velocity of GLY (m/s)
      REAL( 8 )       :: CBARMGLY         ! molecular velocity of MGLY (m/s)
      REAL( 8 )       :: TETROL_PPM       ! accumulation mode aerosol tetrol in ppm
      REAL( 8 )       :: IEPOXOS_PPM      ! accumulation mode iepox organosulfate in ppm
      REAL( 8 )       :: ASO4J_PPM        ! accumulation mode inorganic sulfate in ppm
      REAL( 8 )       :: FH2O(2)          ! fraction of epoxide aerosol from  hydrolysis, index: IEPOX(1) and MAE(2)
      REAL( 8 )       :: FOS(2)           ! fraction of epoxide aerosol as organosulfate, index: IEPOX(1) and MAE(2)
      REAL( 8 )       :: FDIM1(2)         ! fraction of epoxide aerosol as dimer, index: IEPOX(1) and MAE(2)
      REAL( 8 )       :: FDIM2(2)         ! fraction of epoxide aerosol as organosulfate dimer, index: IEPOX(1) and MAE(2)
      REAL( 8 ), SAVE :: INV_MWIETET, INV_MWIEOS  ! reciprocal of molecular weight for tetrol, iepoxos [mol/g]
      REAL( 8 ), SAVE :: INV_MWASO4       ! reciprocal of molecular weight of particulate sulfate [mol/g]

      REAL( 8 )       :: CBAR_CLNO3        ! molecular velocity of CLNO3 (m/s)      
      REAL( 8 )       :: CBAR_HBR          ! molecular velocity of HOBR (m/s)        
      REAL( 8 )       :: CBAR_BRNO2        ! molecular velocity of BRNO2 (m/s)      
      REAL( 8 )       :: CBAR_BRNO3        ! molecular velocity of BRNO3 (m/s)
      REAL( 8 )       :: CBAR_HOBR         ! molecular velocity of HOBR (m/s)                                          
      REAL( 8 )       :: CBAR_I2O2         ! molecular velocity of I2O2 (m/s)  
      REAL( 8 )       :: CBAR_I2O3         ! molecular velocity of I2O3 (m/s) 
      REAL( 8 )       :: CBAR_I2O4         ! molecular velocity of I2O4 (m/s)   
      REAL( 8 )       :: CBAR_INO2         ! molecular velocity of INO2 (m/s) 
      REAL( 8 )       :: CBAR_INO3         ! molecular velocity of INO3 (m/s)  
      REAL( 8 )       :: CBAR_HOI          ! molecular velocity of HOI (m/s)        
      REAL( 8 )       :: CBAR_HI           ! molecular velocity of HI (m/s)  
      
      REAL( 8 )       :: CLNO3_H2O_RXN_TIME   ! CLNO3 reaction time per aerosol surface area density with H2O (s/m)  
      REAL( 8 )       :: HBR_RXN_TIME         ! HBR reaction time per aerosol surface area density with seasalt (s/m)
      REAL( 8 )       :: BRNO3_H2O_RXN_TIME   ! BRNO3 reaction time per aerosol surface area density with H2O (s/m)
      REAL( 8 )       :: HOBR_ASS_RXN_TIME    ! HOBR reaction time per aerosol surface area density with fine-mode ACL (s/m)    
      REAL( 8 )       :: I2O2_RXN_TIME        ! I2O2 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: I2O3_RXN_TIME        ! I2O3 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: I2O4_RXN_TIME        ! I2O4 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: INO2_RXN_TIME        ! INO2 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: INO3_RXN_TIME        ! INO3 reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: HOI_RXN_TIME         ! HOI reaction time per aerosol surface area density (s/m)
      REAL( 8 )       :: HI_RXN_TIME          ! HI reaction time per aerosol surface area density (s/m)

      REAL( 8 )       :: INV_DIFF_CLNO3       ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_HBR         ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_BRNO3       ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_BRNO2       ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_HOBR        ! reciprocal molecular diffusivity [m2/sec]                           
      REAL( 8 )       :: INV_DIFF_I2O2        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_I2O3        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_I2O4        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_INO3        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_INO2        ! reciprocal molecular diffusivity [m2/sec]
      REAL( 8 )       :: INV_DIFF_HOI         ! reciprocal molecular diffusivity [m2/sec]     
      REAL( 8 )       :: INV_DIFF_HI          ! reciprocal molecular diffusivity [m2/sec]  

      INTEGER, SAVE   :: IMAE_IDX
      !INTEGER, SAVE   :: IHMML_IDX
      INTEGER, SAVE   :: NO3_IDX
      INTEGER, SAVE   :: GLY_IDX
      INTEGER, SAVE   :: MGLY_IDX
      INTEGER, SAVE   :: BR_IDX   

C *** variables for parameterization by Bertram and Thornton 
      REAL         :: ACL           ! i+j or k mode chloride, ug/m3 
      REAL         :: ABR           ! i+j or k mode bromide, ug/m3   
      REAL         :: AH2O          ! i+j or k mode water, ug/m3          
      REAL         :: POC           ! i or j mode primary organic carbon, ug/m3 
      REAL         :: PNCOM         ! i or j mode primary noncarbon organic matter, ug/m3          
      REAL,      SAVE :: MWCLH2O       ! ratio of MWCL/MWH2O 
      REAL,      SAVE :: MWH2OCL       ! ratio of MWH20/MWCL 
      REAL,      SAVE :: MWCLCLNO2     ! ratio of MWCL/MWCLNO2
      REAL( 8 ), SAVE :: INV_MWCL      ! ratio of 1.0D0/MWCL 
      REAL( 8 ), SAVE :: INV_MWBR      ! ratio of 1.0D0/MWBR   
      REAL( 8 )       :: PPM_FACTOR    ! conversion factor to umoles/m3 to ppm
C *** variables for heterogeneous hydrolysis of NTR2
      REAL            :: CON_TOA       ! Conc. of total OA [ug/m3]
      REAL            :: F_PART_NTR2   ! NTR2 fraction in the particle phase
      
      
      LOGICAL, SAVE     :: FIRSTIME = .TRUE.

      INTEGER           :: IRATE        ! loop counter
      INTEGER           :: INDX         ! found array index
      INTEGER, SAVE     :: CLNO2_IDX
      INTEGER, SAVE     :: IEPOX_IDX

      INTEGER           :: C
      INTEGER           :: R
      INTEGER           :: L
      INTEGER           :: N
      INTEGER           :: I

      INTEGER      SPC        ! loop counter  
      
C *** variables for getting aerosol diagnostic file flag
      INTEGER           :: STATUS                      ! ENV... status
      CHARACTER( 80 )   :: VARDESC                     ! environment variable description
      
      CHARACTER( 132 )  :: XMSG
      
C *** Statement Function **************
      REAL( 8 )            :: INV_ESATL ! arithmetic statement function for reciprocal vapor pressure [Pa]
      REAL( 8 )            :: TT

C *** parameters for calculating GAMMA of HBR ---> ABR, Sherwen et al., ACP, 2016 and IUPAC
      REAL( 8 ) :: GAMMA_HBR                             ! uptake coefficient of HBR  
      REAL( 8 ) :: INV_GAMMA_HBR       
      
! reciprocal of rxn probability for CLNO3 on aerosol, Dieber et al., ACP, 2004
      REAL( 8 ), PARAMETER :: INV_GAMMA_CLNO3_H2O  = 1.0D0 / 0.024D0               ! Dieber et al., ACP, 2004 (with H2O)

! reciprocal of rxn probability for bromine species on aerosol
      REAL( 8 ), PARAMETER :: INV_GAMMA_BRNO3_H2O  = 1.0D0 / 0.03D0                ! Dieber et al., ACP, 2004
      REAL( 8 ), PARAMETER :: INV_GAMMA_HOBR_ASS   = 1.0D0 / 0.1D0                 ! Fernandez et al, 2014

! reciprocal of rxn probability for iodine species on aerosol, selective 
      REAL( 8 ), PARAMETER :: INV_GAMMA_I2O2  = 1.0D0 / 0.02D0                     ! Sherwen et al., 2016
      REAL( 8 ), PARAMETER :: INV_GAMMA_I2O3  = 1.0D0 / 0.02D0                     ! Sherwen et al., 2016
      REAL( 8 ), PARAMETER :: INV_GAMMA_I2O4  = 1.0D0 / 0.02D0                     ! Sherwen et al., 2016
      REAL( 8 ), PARAMETER :: INV_GAMMA_HOI   = 1.0D0 / 0.01D0                     ! Sherwen et al., 2016     
      REAL( 8 ), PARAMETER :: INV_GAMMA_INO3  = 1.0D0 / 0.01D0                     ! Saiz-Lopez et al. 2014
      REAL( 8 ), PARAMETER :: INV_GAMMA_INO2  = 1.0D0 / 0.02D0                     ! Saiz-Lopez et al. 2014
      REAL( 8 ), PARAMETER :: INV_GAMMA_HI    = 1.0D0 / 0.1D0                      ! Sherwen et al., 2016   

C *** Coefficients for the equation, ESATL defining saturation vapor pressure
      REAL( 8 ), PARAMETER :: AL = 610.94D0 
      REAL( 8 ), PARAMETER :: BL = 17.625D0
      REAL( 8 ), PARAMETER :: CL = 243.04D0
      REAL( 8 ), PARAMETER :: DL = 1.0D0 / AL


#ifdef verbose_aerosol_chemistry
       LOGICAL              :: DUMP_CELL
#endif

C *** values of AL, BL, and CL are from:
C     Alduchov and Eskridge, "Improved Magnus Form Approximations of
C                            Saturation Vapor Pressure,"
C                            Jour. of Applied Meteorology, vol. 35,
C                            pp 601-609, April, 1996.

      INV_ESATL( TT ) = DL * DEXP( BL * ( 273.15D0 - TT ) / ( TT - 273.15D0 + CL ) )
      
      INTERFACE
         SUBROUTINE GETPAR( FIXED_sg  )
           LOGICAL, INTENT( IN ) :: FIXED_sg    ! fix coarse and accum Sg's to the input value?
         END SUBROUTINE GETPAR
         Subroutine Hetchem_Extract_Aero( CONCVEC, C, R, L, WET_M2,
     &                                  WET_M3, DE_WET )
           Real, Intent( In )    :: CONCVEC( : )
           Integer, Intent(In)   :: C, R, L
           Real(8), Intent( Out ):: Wet_M2( : ), Wet_M3( : ), De_Wet( : )
         End Subroutine Hetchem_Extract_Aero
      END INTERFACE 
  
C-----------------------------------------------------------------------

      IF ( NHETERO .LT. 1 )RETURN

C *** compute only on first pass

      IF ( FIRSTIME ) THEN
      
        FIRSTIME = .FALSE.

        CALL MAP_AERO()
        CALL MAP_PRECURSOR()

        ALLOCATE( WHICH_AERO_RATE( NHETERO ) )
        
C *** 2nd and 3rd moments (w. H2O and svOA)
        ALLOCATE(  WET_M3( N_MODE ), 
     &             WET_M2( N_MODE ), 
     &             DE_WET( N_MODE ) )
C *** Allocate Gridded Dry Initial Moments so they can be saved for the
C     end of the gas-phase chemical driver
        WHICH_AERO_RATE = -1
        
        SELECTED_AERO_RATES = 0
        DO IRATE = 1, NHETERO
           INDX = INDEX1( HETERO( IRATE ), NUMB_AERO_RATES, NAMES_AERO_RATES )
           IF ( INDX .LT. 1 ) THEN
               XMSG = 'Heterogeneous Reaction Label '// TRIM ( HETERO( IRATE ) )
     &             // ' is not in list of available Reaction Rates.'
               CALL M3EXIT( 'HETCHEM_RATES', 0, 0, XMSG, XSTAT3 )
           END IF 
           SELECTED_AERO_RATES = SELECTED_AERO_RATES + 1
           WHICH_AERO_RATE( SELECTED_AERO_RATES ) = INDEX_AERO_RATES( INDX )
       END DO

       ALLOCATE( KHETERO( SELECTED_AERO_RATES, NCOLS,NROWS,NLAYS ) )
       
       IF ( PMDIAG .OR. APMDIAG ) THEN
          ALLOCATE( GAMMA_N2O5IJ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(  GAMMA_N2O5K( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(  GAMMA_IEPOX( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(   GAMMA_IMAE( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(   KPARTIEPOX( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(     YCLNO2IJ( NCOLS,NROWS,NLAYS ) )
          ALLOCATE(      YCLNO2K( NCOLS,NROWS,NLAYS ) )
       END IF

C ***  Determine molecular weights
       INV_MWCL  = REAL( 1.0 / aerospc_mw( ACL_IDX ), 8 )
       MWCLH2O   = aerospc_mw( ACL_IDX ) / aerospc_mw( AH2O_IDX )
       MWH2OCL   = 1.0 / MWCLH2O
       CLNO2_IDX = INDEX1( 'CLNO2', NUMB_MECH_SPC, CHEMISTRY_SPC )
       
       IF ( CLNO2_IDX .GT. 0 ) THEN
          MWCLCLNO2 = aerospc_mw( ACL_IDX) / SPECIES_MOLWT( CLNO2_IDX )
       ELSE
          MWCLCLNO2 = 0.0
       END IF

       IEPOX_IDX = INDEX1( 'IEPOX', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF ( IEPOX_IDX .GT. 0 ) THEN
          MWTIEPOX  = REAL( SPECIES_MOLWT( IEPOX_IDX ), 8 ) 
       ELSE
          MWTIEPOX  = 118.1D0
       END IF
       CFACTOR_IEPOX = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTIEPOX * DPI ) )

       IMAE_IDX = INDEX1( 'IMAE', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( IMAE_IDX .GT. 0 )THEN
           MWTIMAE  = REAL( SPECIES_MOLWT( IMAE_IDX ), 8 )
       ELSE
           MWTIMAE  = 102.0D0
       END IF
       CFACTOR_IMAE = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTIMAE * DPI ) )

       IF( AIETET_IDX .GT. 0 ) THEN
          INV_MWIETET = REAL( 1.0/ aerospc_mw( AIETET_IDX ), 8 )
       ELSE
          INV_MWIETET = 0.0D0
       END IF

       IF( AIEOS_IDX .GT. 0 ) THEN
          INV_MWIEOS  = REAL( 1.0/ aerospc_mw( AIEOS_IDX  ), 8 )
       ELSE 
          INV_MWIEOS = 0.0D0
       END IF

       IF( ASO4_IDX .GT. 0 )THEN
          INV_MWASO4 = REAL( 1.0/ aerospc_mw( ASO4_IDX ), 8 )
       ELSE
          INV_MWASO4 = 0D0
       END IF

       NO3_IDX = INDEX1( 'NO3', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( NO3_IDX .GT. 0 )THEN
           MWTNO3  = REAL( SPECIES_MOLWT( NO3_IDX ), 8 )
       ELSE
           MWTNO3  = 62.01D0
       END IF
       CFACTOR_NO3 = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTNO3 * DPI ) )

       GLY_IDX = INDEX1( 'GLY', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( GLY_IDX .GT. 0 )THEN
           MWTGLY  = REAL( SPECIES_MOLWT( GLY_IDX ), 8 )
       ELSE
           MWTGLY  = 58.04D0
       END IF
       CFACTOR_GLY = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTGLY * DPI ) )

       MGLY_IDX = INDEX1( 'MGLY', NUMB_MECH_SPC, CHEMISTRY_SPC )
       IF( MGLY_IDX .GT. 0 )THEN
           MWTMGLY  = REAL( SPECIES_MOLWT( MGLY_IDX ), 8 )
       ELSE
           MWTMGLY  = 72.07D0
       END IF
       CFACTOR_MGLY = DSQRT( 8.0D3 * REAL( RGASUNIV, 8 ) / ( MWTMGLY * DPI ) )

C ***  Map to acids/nucleophiles for epoxide uptake
       INDX =  INDEX1( NAMES_AERO_RATES( IA_IEPOX ), NHETERO, HETERO )   
       IF ( INDX .GT. 0 ) THEN ! Find indices for acid catalyzed species in IEPOX reaction
          If ( ( INDEX( MECHNAME, 'AE6I' ) .GT. 0 ) .OR.
     &         ( INDEX( MECHNAME, 'AE7I' ) .GT. 0 )  ) then
             NUMVOC         = 2 ! IEPOX + MAE/HMML
             N_NUCPAIRS     = N_NUCPAIRS_AEI
             ALLOCATE ( ACID_NUC_PAIRS( N_NUCPAIRS ) )
             ACID_NUC_PAIRS = ACID_NUC_PAIRS_AEI
          Else ! AERO6/7 (condensed IEPOX SOA)
             NUMVOC         = 1
             N_NUCPAIRS     = N_NUCPAIRS_AE
             ALLOCATE ( ACID_NUC_PAIRS( N_NUCPAIRS ) )
             ACID_NUC_PAIRS = ACID_NUC_PAIRS_AE
          END IF
          ALLOCATE ( ACID_PRODMAP_IDX( N_NUCPAIRS ) )
          ALLOCATE (  ACID_NUCMAP_IDX( N_NUCPAIRS ) )
          ACID_PRODMAP_IDX = 0
          ACID_NUCMAP_IDX  = 0
          DO N = 1, N_NUCPAIRS
            ACID_PRODMAP_IDX(N) = FINDAERO( ACID_NUC_PAIRS(N)%PROD, .TRUE. )
            ACID_NUCMAP_IDX(N)  = FINDAERO( ACID_NUC_PAIRS(N)%NUC,  .TRUE. )
#ifdef verbose_aerosol_chemistry        
            Write( logdev,'( 5x, a, i4 )' ) acid_nuc_pairs(n)%prod, acid_prodmap_idx(n)
            Write( logdev,'( 5x, a, i4 )' ) acid_nuc_pairs(n)%nuc,  acid_nucmap_idx(n)
#endif
          END DO
       END IF

       AERO_CHEM_SET = .TRUE.

      END IF   ! first time condition

      KHETERO = 0.0D0
      
      IF ( PMDIAG .OR. APMDIAG ) THEN
         GAMMA_N2O5IJ = 0.0
         GAMMA_N2O5K  = 0.0
         YCLNO2IJ     = 0.0
         YCLNO2K      = 0.0
         GAMMA_IEPOX  = 0.0
         GAMMA_IMAE   = 0.0
         KPARTIEPOX   = 0.0
      END IF
     
C *** Calculate rate constants at each grid cell location
      LOOP_LAY: DO L = 1, NLAYS
         LOOP_ROW: DO R = 1, NROWS
            LOOP_COL: DO C = 1, NCOLS
     
#ifdef verbose_aerosol_chemistry        
               IF ( L .EQ. 1 .AND. R .EQ. INT(NROWS/2)+1 .AND.
     &              C .EQ. INT(NCOLS/2)+1 ) THEN
                  DUMP_CELL = .TRUE.
               ELSE
                  DUMP_CELL = .FALSE.
               END IF
#endif         
C *** Extract aerosol concentrations and update aerosol volume, surface
C     area and diameter values.
               CALL HETCHEM_EXTRACT_AERO( CGRID( C,R,L,: ), C, R, L,
     &               WET_M2, WET_M3, DE_WET )

C *** Load Meteorological Variables
               AIRTEMP = REAL( TEMP( C,R,L ), 8 )
               AIRPRES = REAL(  PRESS( C,R,L ), 8 )   

C *** to compute RH & molecular kinetic factors
               H2OVP = REAL( PRESS( C,R,L ) * WVAPOR( C,R,L )
     &               / ( EPSWATER  + WVAPOR( C,R,L ) ), 8 )    
     
               AIRRH = MAX( 0.005D0, MIN( 0.99D0, H2OVP * INV_ESATL( AIRTEMP ) ) )

               CBAR_COEFF  = REAL( SQRT( CFACTOR * TEMP( C,R,L ) ), 8) 
               
               ADJUST_DIFF = REAL( ( TEMP( C,R,L ) * INV_STDTEMP ) ** 1.75 * ( STDATMPA / PRESS( C,R,L ) ), 8 )

               IF ( PRESENT( DENS ) ) THEN
                  PPM_FACTOR  = 1.0D-3 * REAL( MWAIR / DENS( C,R,L ), 8 )
               ELSE
                  PPM_FACTOR  = UGM3_CONV_FAC * REAL( TEMP( C,R,L ) / PRESS( C,R,L ), 8 )
               END IF
              
               RFACTOR = 60.0D0 * COEF1 * REAL( PRESS( C,R,L ) / TEMP( C,R,L ), 8 )

C *** calculate molecular speeds (m/s) using Eq 4 of Pleim et al (1995)
               CBAR = CBAR_COEFF * INV_SQRT_MWN2O5
               CBARNO3 = CFACTOR_NO3 * DSQRT( AIRTEMP )
               CBARGLY = CFACTOR_GLY  * DSQRT( AIRTEMP )
               CBARMGLY = CFACTOR_MGLY * DSQRT( AIRTEMP )

               CBAR_CLNO3 = CBAR_COEFF * INV_SQRT_MWCLNO3
               CBAR_HBR   = CBAR_COEFF * INV_SQRT_MWHBR
               CBAR_BRNO3 = CBAR_COEFF * INV_SQRT_MWBRNO3       
               CBAR_BRNO2 = CBAR_COEFF * INV_SQRT_MWBRNO2
               CBAR_HOBR  = CBAR_COEFF * INV_SQRT_MWHOBR                 
               CBAR_I2O2  = CBAR_COEFF * INV_SQRT_MWI2O2
               CBAR_I2O3  = CBAR_COEFF * INV_SQRT_MWI2O3
               CBAR_I2O4  = CBAR_COEFF * INV_SQRT_MWI2O4
               CBAR_INO3  = CBAR_COEFF * INV_SQRT_MWINO3
               CBAR_INO2  = CBAR_COEFF * INV_SQRT_MWINO2
               CBAR_HOI   = CBAR_COEFF * INV_SQRT_MWHOI
               CBAR_HI    = CBAR_COEFF * INV_SQRT_MWHI

C *** correct N2O5 molecular diffusivity for ambient conditions

               INV_DIFFUSIVITY = 1.0D0 / ( STD_DIFF_N2O5 * ADJUST_DIFF )

C *** correct molecular diffusivity for ambient conditions - assumed similar to that of N2O5

               INV_DIFF_CLNO3  = 1.0D0 / ( STD_DIFF_CLNO3 * ADJUST_DIFF )
               INV_DIFF_HBR    = 1.0D0 / ( STD_DIFF_HBR * ADJUST_DIFF )
               INV_DIFF_BRNO3  = 1.0D0 / ( STD_DIFF_BRNO3 * ADJUST_DIFF )
               INV_DIFF_BRNO2  = 1.0D0 / ( STD_DIFF_BRNO2 * ADJUST_DIFF )
               INV_DIFF_HOBR   = 1.0D0 / ( STD_DIFF_HOBR * ADJUST_DIFF )
               INV_DIFF_I2O2   = 1.0D0 / ( STD_DIFF_I2O2 * ADJUST_DIFF )
               INV_DIFF_I2O3   = 1.0D0 / ( STD_DIFF_I2O3 * ADJUST_DIFF )
               INV_DIFF_I2O4   = 1.0D0 / ( STD_DIFF_I2O4 * ADJUST_DIFF )
               INV_DIFF_INO3   = 1.0D0 / ( STD_DIFF_INO3 * ADJUST_DIFF )
               INV_DIFF_INO2   = 1.0D0 / ( STD_DIFF_INO2  * ADJUST_DIFF )
               INV_DIFF_HOI    = 1.0D0 / ( STD_DIFF_HOI * ADJUST_DIFF )
               INV_DIFF_HI     = 1.0D0 / ( STD_DIFF_HI * ADJUST_DIFF )

C *** get KN2O5 rate constants YIELD_CLNO2 for each mode
               YIELD_CLNO2 = 0.0D0
               YIELDIJ     = 0.0D0

               DO N = 1, N_MODE          

                  IF ( N .LE. 2 ) THEN
                     GAMMA = N2O5_GAMMA( AIRTEMP, AIRRH, 0 )
                     IF ( PMDIAG .OR. APMDIAG ) GAMMA_N2O5IJ( C,R,L ) = REAL( GAMMA, 4 )
                  ELSE IF ( N .EQ. 3 ) THEN
                     GAMMA = N2O5_GAMMA( AIRTEMP, AIRRH, 5 )
                     IF ( PMDIAG .OR. APMDIAG ) GAMMA_N2O5K( C,R,L ) = REAL( GAMMA, 4 )
                  ELSE
                     GAMMA = 0.0D0
                  END IF
                                     
                  XXF( N ) = WET_M2( N )
     &                    / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA * CBAR * INV_DIFFUSIVITY )
     
                  KN2O5( N ) = GAMMA * XXF( N )

                  IF ( GAMMA_NO3 .GT. 0.0D0 ) THEN
                     KNO3( N ) = GAMMA_NO3 * WET_M2( N ) 
     &                         / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA_NO3 
     &                         * CBARNO3 * INV_DIFFUSIVITY ) * CBARNO3 * DPI
                  ELSE
                     KNO3( N ) = 0.0d0
                  END IF

                  IF( GAMMA_GLY .GT. 0.0D0) THEN
                     KGLY( N ) = GAMMA_GLY * WET_M2( N ) 
     &                         / ( 4.0D0 + 0.5D0 * DE_WET( N ) * GAMMA_GLY 
     &                         * CBARGLY * INV_DIFFUSIVITY ) * CBARGLY * DPI
                     ! scale MGLY uptake by relative H-law (Marais et
                     ! al. ACPD approach) implemented 1/2016 H. Pye
                     KMGLY( N ) = 0.09 * GAMMA_GLY * WET_M2( N ) 
     &                          / ( 4.0D0 + 0.5D0 * DE_WET( N ) * 0.09 * GAMMA_GLY 
     &                          * CBARMGLY * INV_DIFFUSIVITY ) * CBARMGLY * DPI
                  ELSE
                     KGLY( N ) = 0.0D0
                     KMGLY( N ) = 0.0D0
                  END IF


c *** get fine aerosol H2O and chlorine concentrations in
                  AH2O = aerospc_conc( AH2O_IDX,N )
                  ACL  = aerospc_conc( ACL_IDX, N )
                  CL_PPM( N ) = PPM_FACTOR * ( ACL * INV_MWCL )

      If ( Index( mechname, 'CB6R3M_AE7_KMTBR' ) .Gt. 0 ) Then
         ABR  = aerospc_conc( ABR_IDX, N ) 
         INV_MWBR  = REAL( 1.0 / aerospc_mw( ABR_IDX ), 8 )  
         BR_PPM( N ) = PPM_FACTOR * ( ABR * INV_MWBR ) 
      Else
         BR_PPM( N ) = 0.0D0  
      End If

C *** If only a small amount of water is present on aerosol, keep YIELD_CLNO2 zero
                 IF ( AH2O .GT. 5.0E-01 .AND. ACL .GT. 1.0E-04 ) THEN
                     IF ( MWH2OCL * ACL .GT. 1.0E-4 * AH2O ) THEN 
                        YIELD_CLNO2( N ) = 1.0D0
     &                                   / ( 1.0D0 + ( 1.0D0 / 483.0D0 ) * ( AH2O / ACL ) * MWCLH2O )
                     END IF
                  END IF
 
               END DO ! End each mode 

c *** compute yield from lumped Aitken and Accumulations concentrations
               AH2O = aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 )
               ACL  = aerospc_conc( ACL_IDX,1 )  + aerospc_conc( ACL_IDX,2 )
               IF ( AH2O .GT. 5.0E-01 .AND. ACL .GT. 1.0E-04 ) THEN
                  IF ( MWH2OCL * ACL .GT. 1.0E-4 * AH2O ) THEN 
                     YIELDIJ = 1.0D0 / ( 1.0D0 + ( 1.0D0 / 483.0D0 )
     &                       * REAL( ( AH2O / ACL ) * MWCLH2O, 8 ) )
                  END IF
               END IF  
              
               KN2O5 = CBAR * DPI * KN2O5
C *** calculate aerosol surface area
               TOTSURFA = ( WET_M2( 1 ) + WET_M2( 2 ) ) * DPI

C *** Calculate IEPOX and MAE uptake information for accumulation mode
               RADIUS    = 0.5D0 * DE_WET( 2 ) ! particle size
               RADIUS_K     = 0.5D0 * DE_WET( 3 ) ! particle size - K-mode 

C *** calculate GAMMA_HBR  
      GAMMA_HBR = 1.3D-8 * DEXP ( 4290/ AIRTEMP) 
      INV_GAMMA_HBR = 1.0D0 / GAMMA_HBR
                                                                                                               
C *** set up variables needed for calculating K_BRONO2              
               CLNO3_H2O_RXN_TIME   = 4.0D0 * INV_GAMMA_CLNO3_H2O / CBAR_CLNO3
               HBR_RXN_TIME         = 4.0D0 * INV_GAMMA_HBR / CBAR_HBR 
               BRNO3_H2O_RXN_TIME   = 4.0D0 * INV_GAMMA_BRNO3_H2O / CBAR_BRNO3
               HOBR_ASS_RXN_TIME    = 4.0D0 * INV_GAMMA_HOBR_ASS  / CBAR_HOBR  
               I2O2_RXN_TIME        = 4.0D0 * INV_GAMMA_I2O2 / CBAR_I2O2
               I2O3_RXN_TIME        = 4.0D0 * INV_GAMMA_I2O3 / CBAR_I2O3
               I2O4_RXN_TIME        = 4.0D0 * INV_GAMMA_I2O4 / CBAR_I2O4
               INO3_RXN_TIME        = 4.0D0 * INV_GAMMA_INO3 / CBAR_INO3
               INO2_RXN_TIME        = 4.0D0 * INV_GAMMA_INO2 / CBAR_INO2
               HOI_RXN_TIME         = 4.0D0 * INV_GAMMA_HOI  / CBAR_HOI
               HI_RXN_TIME          = 4.0D0 * INV_GAMMA_HI  / CBAR_HOI
               
               CBARIEPOX = CFACTOR_IEPOX * DSQRT( AIRTEMP )
               CBARIMAE  = CFACTOR_IMAE  * DSQRT( AIRTEMP )

               ! Rate constants and concentrations
               CALL CALCISOPGAMMAS( RADIUS, AIRTEMP, GAMMAIEPOX,
     &                              GAMMAIMAE, KPIEPOX, FH2O, FOS, FDIM1, FDIM2)

               IF( GAMMAIEPOX .GT. 1.0D-72 ) THEN
                  KIEPOX = WET_M2( 2 ) * DPI
     &                   / ( RADIUS * INV_DIFFUSIVITY +  4.0D0 / ( CBARIEPOX * GAMMAIEPOX) )
                  If ( AIETET_IDX .GT. 0 ) Then
                     TETROL_PPM  = PPM_FACTOR
     &                       * REAL( aerospc_conc( AIETET_IDX,2 ), 8 ) * INV_MWIETET
                  Else
                     TETROL_PPM = 0.0D0
                  End If 
                  If ( AIEOS_IDX .GT. 0 ) Then
                     IEPOXOS_PPM = PPM_FACTOR
     &                     * REAL( aerospc_conc( AIEOS_IDX,2 ), 8 ) * INV_MWIEOS
                  Else
                     IEPOXOS_PPM = 0.0D0
                  End If
                  If ( ASO4_IDX .GT. 0 ) Then
                     ASO4J_PPM = PPM_FACTOR
     &                     * REAL( aerospc_conc( ASO4_IDX,2 ), 8 ) * INV_MWASO4
                  Else
                     ASO4J_PPM = 0.0D0
                  End If
               ELSE
                  KIEPOX = 0.0D0
                  TETROL_PPM = 0.0D0
                  IEPOXOS_PPM = 0.0D0
                  ASO4J_PPM = 0.0D0
               END IF

               IF( GAMMAIMAE .GT. 1.0D-72 ) THEN
                  KIMAE = WET_M2( 2 ) * DPI
     &                  / ( RADIUS * INV_DIFFUSIVITY + 4.0D0 / ( CBARIMAE * GAMMAIMAE ) )
               ELSE
                  KIMAE = 0.0d0
               END IF

               ! Diagnostic information
               IF ( PMDIAG .OR. APMDIAG ) GAMMA_IEPOX( C,R,L ) = REAL( GAMMAIEPOX,4 )
               IF ( PMDIAG .OR. APMDIAG ) GAMMA_IMAE(  C,R,L ) = REAL( GAMMAIMAE, 4 )
               IF ( PMDIAG .OR. APMDIAG ) KPARTIEPOX(  C,R,L ) = REAL( KPIEPOX,   4 )

               LOOP_RATES: DO IRATE = 1, SELECTED_AERO_RATES
 
               SELECT CASE( WHICH_AERO_RATE( IRATE ) )
                  CASE( IA_N2O5IJ )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * ( KN2O5( 1 ) + KN2O5( 2 ) )! convert to min-1
                          
                  CASE( IA_N2O5K )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KN2O5 (3) ! convert to min-1
                     
                  CASE( IA_N2O5J )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KN2O5 (2) ! convert to min-1
                     
                  CASE( IA_N2O5I )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KN2O5 (1) ! convert to min-1
                     
                  CASE( IA_N2O5IJY )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * YIELDIJ * ( KN2O5( 1 ) + KN2O5( 2 ) ) ! convert to min-1
                     IF ( PMDIAG .OR. APMDIAG ) YCLNO2IJ( C,R,L ) = REAL( YIELDIJ, 4 )

                  CASE( IA_N2O5KY )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * YIELD_CLNO2( 3 ) * KN2O5( 3 ) 
                     IF ( PMDIAG .OR. APMDIAG ) YCLNO2K( C,R,L ) = REAL( YIELD_CLNO2( 3 ), 4 )

                  CASE( IA_H2NO3PAIJ )  
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       *  MAX( ( 1.0D0 - YIELDIJ ), 0.0D0 ) 
                     IF ( PMDIAG .OR. APMDIAG ) YCLNO2IJ( C,R,L ) = REAL( YIELDIJ, 4 )
                     
                  CASE( IA_H2NO3PBIJ )  
                     IF ( YIELDIJ .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * YIELDIJ 
     &                                          / ( CL_PPM( 1 ) + CL_PPM( 2 ) )   ! 1/(min*ppm)
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF
                     
                  CASE( IA_H2NO3PAI )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       * MAX( ( 1.0D0 - YIELD_CLNO2( 1 ) ), 0.0D0 ) 

                  CASE( IA_H2NO3PBI )
                     IF ( YIELD_CLNO2( 1 ) .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * YIELD_CLNO2( 1 ) / CL_PPM( 1 ) ! (min*ppm)-1
                        IF ( PMDIAG .OR. APMDIAG ) THEN
                           FACTOR = CL_PPM( 1 ) / ( CL_PPM( 1 )+ CL_PPM( 2 ) )
                           YCLNO2IJ( C,R,L ) = REAL( FACTOR * YIELD_CLNO2( 1 ), 4 ) 
     &                                       + YCLNO2IJ( C,R,L )
                        END IF
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF 
                              
                  CASE( IA_H2NO3PAJ )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       * MAX( ( 1.0D0 - YIELD_CLNO2( 2 ) ), 0.0D0 ) 
                               
                  CASE( IA_H2NO3PBJ )
                     IF (  YIELD_CLNO2( 2 ) .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) =  60.0D0 * AQUEOUS_FREQUENCY
     &                                          *  YIELD_CLNO2( 2 ) / CL_PPM( 2 ) ! (min*ppm)-1
                        IF ( PMDIAG .OR. APMDIAG ) THEN
                           FACTOR = CL_PPM( 2 ) / ( CL_PPM( 1 )+ CL_PPM( 2 ) )
                           YCLNO2IJ( C,R,L ) = YCLNO2IJ( C,R,L ) + REAL( FACTOR * YIELD_CLNO2( 2 ), 4 ) 
                        END IF                               
                     ELSE
                          KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF 
                                
                  CASE( IA_PNCOMLI )
                     POC   = aerospc_conc( APOC_IDX,1 )
                     PNCOM = aerospc_conc( APNCOM_IDX,1 )
                     KHETERO( IRATE, C,R,L ) = RFACTOR * PNCOM_LOSS( POC, PNCOM )
                      
                  CASE( IA_PNCOMLJ )
                     POC   = aerospc_conc( APOC_IDX,2 )
                     PNCOM = aerospc_conc( APNCOM_IDX,2 )
                     KHETERO( IRATE, C,R,L ) = RFACTOR * PNCOM_LOSS( POC, PNCOM )

                  CASE( IA_H2NO3PAK )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                       *  MAX( ( 1.0D0 - YIELD_CLNO2( 3 ) ), 0.0D0 ) ! * KN2O5( 3 )
                               
                  CASE( IA_H2NO3PBK )
                     IF ( YIELD_CLNO2( 3 ) .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * YIELD_CLNO2( 3 ) / CL_PPM( 3 ) ! (min*ppm)-1
                        IF ( PMDIAG .OR. APMDIAG ) YCLNO2K( C,R,L ) = REAL( YIELD_CLNO2( 3 ), 4 ) 
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF 
                               
                  CASE( IA_NO2 )
C *** calculate pseudo-first order rate constant for NO2 loss using Eq 1 of Vogel
C     et al. (2003). Units of KNO2 is in 1/min in the paper; divide it
C     by 60 to convert it into 1/sec
                     KNO2 = MAX ( 0.0D0, 1.0D-04 * TOTSURFA )
                     KHETERO( IRATE, C,R,L )  = 60.0D0 * KNO2 ! convert to min-1

C ***            Isoprene epoxide uptake
                 CASE( IA_IEPOX )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KIEPOX ! min-1

                 CASE( IA_TETROL )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * FH2O( 1 )

                 CASE( IA_IEPOXOS )
                     IF ( ASO4J_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY 
     &                                          * FOS( 1 ) / ASO4J_PPM
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_TETROLDIM )
                     IF ( TETROL_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * FDIM1( 1 ) / TETROL_PPM ! min*ppm-1  
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_IEPOXOSDI )
                     IF ( IEPOXOS_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY
     &                                          * FDIM2( 1 ) / IEPOXOS_PPM ! min*ppm-1
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_IMAE )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * KIMAE ! min-1

                 CASE( IA_2MG )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY * FH2O(2)

                 CASE( IA_IMAEOS )
                     IF ( ASO4J_PPM .GT. 0.0D0 ) THEN
                        KHETERO( IRATE, C,R,L ) = 60.0D0 * AQUEOUS_FREQUENCY 
     &                                         * FOS(2) / ASO4J_PPM
                     ELSE
                        KHETERO( IRATE, C,R,L ) = 0.0D0
                     END IF

                 CASE( IA_NO3 )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * ( KNO3( 1 ) + KNO3( 2 ) ) ! min-1

                 CASE( IA_GLY )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KGLY( 2 ) ) ! min-1

                 CASE( IA_MGLY )
                     KHETERO( IRATE, C,R,L ) = 60.0D0 * (  KMGLY( 2 ) ) ! min-1

                 CASE( IA_NTR2 )
C *** calculate gas-particle partitioning of NTR2
                    CON_TOA = SUM( SUM( AEROSPC_CONC( :,1:2 ),2 ), 
     &                        MASK = AEROSPC( : )%OM )
                    
                    F_PART_NTR2 = 0.0
                    IF ( CON_TOA .GE. MIN_TOA ) THEN
                       F_PART_NTR2 = ON_ALPHA1 / ( 1.0 + ON_CSTAR1 / CON_TOA )
     &                             + ON_ALPHA2 / ( 1.0 + ON_CSTAR2 / CON_TOA )
                    END IF

C *** calculate pseudo-first order rate constant for heterogeneous NTR2
C hydrolysis
                     IF ( AIRRH .LE. 0.2D0 .OR. F_PART_NTR2 .LE. 0.0 ) THEN
                        KHETERO( IRATE, C, R, L ) = 0.0D0
                     ELSE IF ( AIRRH .GE. 0.4D0 ) THEN
                        KHETERO( IRATE, C, R, L ) = REAL( F_PART_NTR2 * KHON, 8 ) ! [1/min]
                     ELSE
                        KHETERO( IRATE, C, R, L ) = REAL( F_PART_NTR2 * KHON, 8 ) ! [1/min]
     &                                            * ( 5.0D0 * AIRRH - 1.0D0 )
                     END IF

                CASE( IA_CLNO3_WAJ )   
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_CLNO3 + CLNO3_H2O_RXN_TIME )  

                 CASE( IA_CLNO3_WAK )                              
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_CLNO3 + CLNO3_H2O_RXN_TIME )

                 CASE( IA_HBR_BRJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_HBR + HBR_RXN_TIME )

                 CASE( IA_HBR_BRK )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_HBR + HBR_RXN_TIME )

                 CASE( IA_BRNO3_WAJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_BRNO3 + BRNO3_H2O_RXN_TIME )

                 CASE( IA_BRNO3_WAK )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_BRNO3 + BRNO3_H2O_RXN_TIME )

                 CASE( IA_HOBR_CLJ )    
                  K1 = 0.85 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_HOBR + HOBR_ASS_RXN_TIME ) 
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2) 
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOBR_CLK )                                                                  
                  K1 = 0.85 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_HOBR + HOBR_ASS_RXN_TIME )
                  IF ( CL_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (3) 
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOBR_BRJ )    
                  K1 = 0.15 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_HOBR + HOBR_ASS_RXN_TIME ) 
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2) 
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOBR_BRK )                                                                  
                  K1 = 0.15 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_HOBR + HOBR_ASS_RXN_TIME ) 
                  IF ( BR_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (3) 
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF  

                 CASE( IA_I2O2_AJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_I2O2 + I2O2_RXN_TIME ) 
                  
                 CASE( IA_I2O2_AK )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_I2O2 + I2O2_RXN_TIME )    

                 CASE( IA_I2O3_AJ ) 
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_I2O3 + I2O3_RXN_TIME ) 

                 CASE( IA_I2O3_AK )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_I2O3 + I2O3_RXN_TIME )    

                 CASE( IA_I2O4_AJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_I2O4 + I2O4_RXN_TIME ) 

                 CASE( IA_I2O4_AK )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_I2O4 + I2O4_RXN_TIME )

                 CASE( IA_INO3_CLJ )          
                  K1 = 0.5 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_INO3 + INO3_RXN_TIME )
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF 
                  
                 CASE( IA_INO3_CLK )                                                
                  K1 = 0.5 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_INO3 + INO3_RXN_TIME ) 
                  IF ( CL_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (3)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO3_BRJ )          
                  K1 = 0.5 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_INO3 + INO3_RXN_TIME )
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF
                  
                 CASE( IA_INO3_BRK )                                                
                  K1 = 0.5 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_INO3 + INO3_RXN_TIME ) 
                  IF ( BR_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (3)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO2_CLJ )
                  K1 =  0.5 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_INO2 + INO2_RXN_TIME )
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO2_CLK )                                                   
                  K1 = 0.5 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_INO2 + INO2_RXN_TIME )
                  IF ( CL_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (3)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO2_BRJ )
                  K1 =  0.5 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_INO2 + INO2_RXN_TIME )
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_INO2_BRK )                                                   
                  K1 = 0.5 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_INO2 + INO2_RXN_TIME )
                  IF ( BR_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (3)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOI_CLJ )                            
                  K1 = 0.5 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_HOI + HOI_RXN_TIME )  
                  IF ( CL_PPM (2) .GT. MIN_VALUE ) THEN
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF 
                                        
                 CASE( IA_HOI_CLK )                                                
                  K1 = 0.5 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_HOI + HOI_RXN_TIME ) 
                  IF ( CL_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / CL_PPM (3)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF

                 CASE( IA_HOI_BRJ )                            
                  K1 = 0.5 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_HOI + HOI_RXN_TIME ) 
                  IF ( BR_PPM (2) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (2)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF
                 
                 CASE( IA_HOI_BRK )                                               
                  K1 = 0.5 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_HOI + HOI_RXN_TIME )  
                  IF ( BR_PPM (3) .GT. MIN_VALUE ) THEN
                   KHETERO( IRATE, C,R,L ) = 60.0D0 * K1 / BR_PPM (3)                                         ! 1/(min*ppm)
                  ELSE
                   KHETERO( IRATE, C,R,L ) = 0.0D0    
                  ENDIF
              
                 CASE( IA_HI_AJ )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 2 ) * DPI / ( RADIUS * INV_DIFF_HI + HI_RXN_TIME ) 
                  
                 CASE( IA_HI_AK )
                  KHETERO( IRATE, C,R,L ) = 60.0D0 * WET_M2( 3 ) * DPI / ( RADIUS_K * INV_DIFF_HI + HI_RXN_TIME )    

               END SELECT

            END DO LOOP_RATES

#ifdef verbose_aerosol_chemistry
            IF ( DUMP_CELL ) THEN

               WRITE( LOGDEV,* ) 'In GAS HETCHEM for MYPE = ', MYPE
               WRITE( LOGDEV,9499 ) C,R,L
               WRITE( LOGDEV,9500 ) 'TEMP        = ', AIRTEMP
               WRITE( LOGDEV,9500 ) 'AIRRH       = ', AIRRH
               WRITE( LOGDEV,9500 ) 'DIFFUSIVITY = ', 1.0 / INV_DIFFUSIVITY
               WRITE( LOGDEV,9500 ) 'INV_SQRT_MWN2O5 = ', INV_SQRT_MWN2O5
               WRITE( LOGDEV,9500 ) 'CBAR_COEFF      = ', CBAR_COEFF
               WRITE( LOGDEV,9500 ) 'CBAR        = ', CBAR
               WRITE( LOGDEV,9500 ) 'PPM_FACTORA = ',
     &                UGM3_CONV_FAC * REAL( TEMP( C,R,L ) / PRESS( C,R,L ), 8 )
               WRITE( LOGDEV,9500 ) 'PPM_FACTOR = ', PPM_FACTOR
               WRITE( LOGDEV,9500 ) 'PPM_FACTOR*INV_MWCL = ', PPM_FACTOR * INV_MWCL
               WRITE( LOGDEV,9500 ) 'PPM_FACTORA*INV_MWCL = ',
     &                UGM3_CONV_FAC * REAL( TEMP( C,R,L ) / PRESS( C,R,L ), 8 ) * INV_MWCL
               WRITE( LOGDEV,9500 ) 'ACLI_PPM  = ', CL_PPM( 1 )
               WRITE( LOGDEV,9500 ) 'ACLJ_PPM  = ', CL_PPM( 2 )
               WRITE( LOGDEV,9500 ) 'ACLK_PPM  = ', CL_PPM( 3 )
               WRITE( LOGDEV,9500 ) 'ANH4I = ', aerospc_conc( ANH4_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ANO3I = ', aerospc_conc( ANO3_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ASO4I = ', aerospc_conc( ASO4_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ACLI  = ', aerospc_conc( ACL_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'AH2OI = ', aerospc_conc( AH2O_IDX,1 ) 
               WRITE( LOGDEV,9500 ) 'ANH4J = ', aerospc_conc( ANH4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ANO3J = ', aerospc_conc( ANO3_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ASO4J = ', aerospc_conc( ASO4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ACLJ  = ', aerospc_conc( ACL_IDX,2) 
               WRITE( LOGDEV,9500 ) 'AH2OJ = ', aerospc_conc( AH2O_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ANH4IJ = ',
     &                aerospc_conc( ANH4_IDX,1 ) + aerospc_conc( ANH4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ANO3IJ = ',
     &                aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ASO4IJ = ',
     &                aerospc_conc( ASO4_IDX,1 ) + aerospc_conc( ASO4_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'ACLIJ  = ',
     &                aerospc_conc( ACL_IDX,1 ) + aerospc_conc( ACL_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'AH2OIJ = ',
     &                aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 ) 
               WRITE( LOGDEV,9500 ) 'GAMMA = ', N2O5_GAMMA( AIRTEMP, AIRRH, 0 )
               WRITE( LOGDEV,9500 ) 'ANH4K = ', aerospc_conc( ANH4_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'ANO3K = ', aerospc_conc( ANO3_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'ASO4K = ', aerospc_conc( ASO4_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'ACLK  = ', aerospc_conc( ACL_IDX, 3 ) 
               WRITE( LOGDEV,9500 ) 'AH2OK = ', aerospc_conc( AH2O_IDX,3 ) 
               WRITE( LOGDEV,9500 ) 'GAMMAK     = ', N2O5_GAMMA( AIRTEMP, AIRRH, 5 )
               WRITE( LOGDEV,9500 ) 'XXF_AT     = ', XXF( 1 )
               WRITE( LOGDEV,9500 ) 'XXF_AC     = ', XXF( 2 )
               WRITE( LOGDEV,9500 ) 'XXF_COR    = ', XXF( 3 )
               WRITE( LOGDEV,'( A )' ) 'Product/Nucleophile mapping for epox uptake:'
               DO N = 1, N_NUCPAIRS
                  WRITE( LOGDEV,'( 5X,A,I4 )' ) ACID_NUC_PAIRS( N )%PROD, ACID_PRODMAP_IDX( N )
                  WRITE( LOGDEV,'( 5X,A,I4 )' ) ACID_NUC_PAIRS( N )%NUC, ACID_NUCMAP_IDX( N )
               END DO
               WRITE( LOGDEV,9500 ) 'GAMMAIEPOX  = ', GAMMAIEPOX
               WRITE( LOGDEV,9500 ) 'GAMMAIMAE   = ', GAMMAIMAE
               WRITE( LOGDEV,9500 ) 'k_particle_iepox =       ', KPIEPOX
               WRITE( LOGDEV,9500 ) 'Fraction tetrol =        ', FH2O( 1 )
               WRITE( LOGDEV,9500 ) 'Fraction iepoxos =       ', FOS(  1 )
               WRITE( LOGDEV,9500 ) 'Fraction tetrol dimer =  ', FDIM1( 1 )
               WRITE( LOGDEV,9500 ) 'Fraction iepoxos dimer = ', FDIM2( 1 )
               WRITE( LOGDEV,9500 ) 'Fraction 2-MG =          ', FH2O( 2 )
               WRITE( LOGDEV,9500 ) 'Fraction mae-os =        ', FOS( 2 )
               WRITE( LOGDEV,9500 ) 'Fraction mae dimers = 0  ', FDIM1( 2 ) + FDIM2( 2 )
               WRITE( LOGDEV,9500 ) 'TETROL_PPM =             ', TETROL_PPM
               WRITE( LOGDEV,9500 ) 'IEPOXOS_PPM =            ', IEPOXOS_PPM
               WRITE( LOGDEV,9501 ) 'KN2O5IJ = ', 60.0D0 * ( KN2O5( 1 ) + KN2O5( 2 ) ),' 1/min'
               WRITE( LOGDEV,9501 ) 'KN2O5K =  ', 60.0D0 * KN2O5(3), ' 1/min'
               WRITE( LOGDEV,9501 ) 'KNO2  =   ', 60.0D0 * KNO2, ' 1/min'
               WRITE( LOGDEV,9501 ) 'YIELDI =  ', YIELD_CLNO2( 1 ), ' '
               WRITE( LOGDEV,9501 ) 'YIELDJ =  ', YIELD_CLNO2( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'YIELDIJ = ', YIELDIJ, ' '
               WRITE( LOGDEV,9501 ) 'YIELDK =  ', YIELD_CLNO2( 3 ), ' '
               WRITE( LOGDEV,9501 ) 'F_PART_NTR2 =  ', F_PART_NTR2, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_NO3= ', GAMMA_NO3, ' '
               WRITE( LOGDEV,9501 ) 'GAMMA_GLY= ', GAMMA_GLY, ' '
               WRITE( LOGDEV,9501 ) 'KNO3(1)= ', KNO3( 1 ), ' '
               WRITE( LOGDEV,9501 ) 'KNO3(2)= ', KNO3( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'KNO3(3)= ', KNO3( 3 ), ' '
               WRITE( LOGDEV,9501 ) 'KGLY(2)= ', KGLY( 2 ), ' '
               WRITE( LOGDEV,9501 ) 'KMGLY(2)= ', KMGLY( 2 ), ' '
               DO N = 1, NHETERO
                  WRITE( LOGDEV,9501 ) HETERO( N ) // ' = ', KHETERO( N, C,R,L ),' '
               END DO
            END IF          
9499        FORMAT( 'At COL = ',I3,' ROW = ',I3,' LAY = ',I3 )
9500        FORMAT( A, ES12.4 )
9501        FORMAT( A, ES12.4, A )          
#endif
        
            END DO LOOP_COL
         END DO  LOOP_ROW
      END DO LOOP_LAY

      RETURN

      END SUBROUTINE HETCHEM_RATES

C ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      REAL( 8 ) FUNCTION PNCOM_LOSS( POC, PNCOM )
! Calculates rate constant in cm3 molec-1 sec-1 for PNCOM loss by reacting 
! with OH, derived from the reactions in the below POA aging scheme 
! in CMAQ v5.0-v5.02:
! start with the definition of POCRm 
!      - POCRm = reduced primary organic carbon (molar concentration)
!  changes POCRm correspond to changes in PNCOM via a rate constant
!  koheff*[OH] that comes from Weitkamp et al (2008) and George et al (2007)
!
! POCRm = POC/12 - Omoles
!  where Omoles represent fraction that is already PNCOM oxidized
! Omoles = NCOM/(16 + PHOrat) if 14/12 < (POC + NCOM)/POC <  44/12 
!      - see Simon et al (2011) for derivation
! Omoles = NCOM/16            if (POC + NCOM)/POC >= 44/12 
!      - interpretted as POC is fully oxidized and all 
!        NCOM is oxygen 
! Omoles = 0                  if (POC + NCOM)/POC <= 14/12 
!      - if OM/OC < 1.167, then POC is fully reduced and all 
!        NCOM is hydrogen
!      - see Simon et al. (2011) for derivation
! note:we divide POC by 12 b/c we want moles of carbon atoms not moles 
!      of POC (since each carbon atom w\in the molecule is allowed 
!      to react)
! note: we calculate Omoles based on the equations above derived from 
!      Heald et al (2010) and documented in Simon et al (2011).
!
! The following rate equation comes from the reaction above:
!      dPOCRm/dt = POCRm*koheff*[OH] 
!        -assume that [OH] does not change as a result of this reaction
!      solve for POCRm at time, t
!        moles: POCRm(t) = POCRm(0)*EXP(-koheff*[OH]*t) = POCRm(0)*expdt
!
!      One mole of "NCOMm" is formed for every mole of POCRm that reacts:
!             -dPOCRm/dt = dNCOMm/det
!        moles of NCOMm: NCOMm = NCOMm(0) + POCRm(0)*[1-EXP(-koheff*[OH]*t)] = 
!                        NCOMm(0) + POCRm(0)*(1-expdt)
!        NCOMg = NCOMm*15.0 
!          - every mole of newly formed NCOM results in an average gain of 1 oxygen atom 
!            and an average loss of 1 hydrogen atoms (on average, two oxidation steps 
!            convert a CH3 functional group into a COOH functional group) 
!               -(based on Heald et al. (2010)) 
!      Rewrite NCOM formation equation using grams: 
!        NCOMg/15.0 = NCOMg(0)/15.0 + POCRm*(1-expdt) 
!                         V 
!        NCOMg == NCOM(0) + 15.0*POCRm*(1-expdt)
!                          or
!        dNCOMg/dt = (15.0/12.0)*POC*koheff*[OH]-15.0*Omoles*PNCOM*koheff*[OH]
!            ----> 15.0*Omoles*koheff is rate constant of PNCOM loss
! 
! Key Subroutines Called: none
!
! Key Functions Called: none
!
! Revision History:
!    June 2014:  Bill Hutzell-initial version based on the poaaging subroutine
!                in CMAQ v5.0 thru v5.0.2.
! 
!  REFERENCES:
!   1. George, I.J., Vlasenko, A., Slowik, J.G., Broekhuizen, K., 
!      Abbatt, J.P.D. (2007), Heterogeneous oxidation of saturated
!      organic aerosols by hydroxyl radicals: uptake kinetics, 
!      condesned-phase products, and particle size change, 
!      Atmospheric Chemistry and Physics, 7, 4187-4201 
!     
!   2. Heald, C.L., Kroll, J.H., Jimenez, J.L., Docherty, K.S., 
!      DeCarlo, P.F., Aiken, A.C., Chen, Q., Martin, S.T., Farmer, S.T.,
!      Artaxo, P. (2010), A simplified description of the evolution of 
!      organic aerosol composition in the atmosphere, GRL, 37, L08803. 
!
!   3. Simon, H. and Bhave, P.V. (2011), Simulating the degree of oxidation 
!      in atmospheric organic particles  
!      In Review at ES&T.
!
!   4. Weitkamp, E.A., Lambe, A.T., Donahue, N.M., Robinson, A.L. (2008),
!      Laboratory measurements of the heterogeneous oxidation of condensed-
!      phase organic molecular markers for motor vehicl exhaust, 42, 
!      7950-7956.
!-----------------------------------------------------------------------
      
      IMPLICIT NONE
      
! Arguments: Note specific units do not material as long as consistent
!           between arguments, i.e., the same
       REAL, INTENT( IN ) :: POC    ! concentration of primary organic carbon
       REAL, INTENT( IN ) :: PNCOM  ! concentration of primart noncarbon organic matter
! Parameter:
       REAL( 8 ), PARAMETER :: KOHEFF      =  2.5D-12  ! POC + OH rate constant, cm3 molec-1 sec-1
       REAL,      PARAMETER :: LOWER_LIMIT =  7.0/6.0
       REAL,      PARAMETER :: UPPER_LIMIT = 11.0/3.0
       REAL( 8 ), PARAMETER :: MAX_RATE    = 15.0D0/16.0D0 * KOHEFF ! max rate constant for PNCOM loss
! Local    
       REAL( 8 )            :: RATIO   ! the hydrogen to oxygen ratio in organic matter
       
        PNCOM_LOSS = 0.0D0

        IF (  POC .LE. 1.0D-30 ) RETURN
              
        RATIO = REAL( ( POC + PNCOM ) / POC, 8 )

        IF ( RATIO .GT. LOWER_LIMIT .AND. RATIO .LT. UPPER_LIMIT ) THEN
           PNCOM_LOSS = 15.0D0 * KOHEFF
     &                / ( 16.0D0 + (UPPER_LIMIT - RATIO) / (RATIO - LOWER_LIMIT) )
        ELSE IF ( RATIO .GE. UPPER_LIMIT ) THEN 
           PNCOM_LOSS = MAX_RATE
        END IF
        
        RETURN   
      END FUNCTION PNCOM_LOSS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      REAL( 8 ) FUNCTION N2O5_GAMMA( TEMP, RH, GPARAM )

C  Calculates the N2O5 heterogeneous reaction probability, which is the
C  fraction of collisions between a gaseous N2O5 molecule and a particle
C  surface that leads to nitrate production.  In the literature, this
C  probability is commonly referred to with the Greek letter, GAMMA.  To
C  avoid conflicts with the intrinsic GAMMA function on some compilers,
C  we refer to the reaction probability as N2O5_GAMMA in this function.

C  A variety of parameterizations of N2O5_GAMMA are available in this
C  function.  Users may select among the different parameterizations
C  by changing the input argument, GPARAM.  This argument may take on
C  the following values (see code for further details):
C     1. Constant value of 0.1 based on Dentener & Crutzen (1993)
C     2. Function of particle SO4 and NO3, based on Riemer et al. (2003)
C     3. Function of RH, Temp, and particle composition, based on a
C        combination of parameterizations by Evans & Jacob (2005) and
C        Riemer et al. (2003)
C  If GPARAM matches none of the above values, the default calculation
C  of N2O5_GAMMA is a function of RH, T, particle composition, and phase
C  state, based on the parameterization by Davis et al. (2008).

C  Key Subroutines Called: none

C  Key Functions Called: CRYSTALIZED, FREEZES

C  Revision History:
C    First version was coded in November 2007 by Dr. Prakash Bhave
C    using excerpts of the HETCHEM subroutine, which contained only
C    one option for computing N2O5_GAMMA (i.e., GPARAM = 3).
C
C  PVB 11/03/07 Removed code that sets N2O5_GAMMA to zero when RH < 1%.
C
C  PVB 11/05/07 Corrected GPARAM = 3 option to fix the typographical
C               error in the paper by Evans & Jacob (2005), which was
C               found by Dr. Jerry Davis.
C
C  PVB 04/11/08 Updated formulas for LAM1 & LAM2 based on revised paper
C               by Davis et al. (2008).  Added APNDX flag so users may
C               switch between base parameterization and the alternative
C               discussed in Appendix A by Davis et al.  Set default
C               parameterization to match equations in Appendix A.
C               Reduced all regression coefficients by one decimal place
C               for consistency with revised paper.
C
C  JTK 04/17/08 Moved molar mass to AERO_INFO.f
C
C  SH  12/08/09 Use new Fortran modules (aero_data, met_data) in lieu of
C               CBLK array and AERO_INFO module
C
C  SH  03/10/11 Renamed met_data to aeromet_data

C  GS  09/12/14 Added an opiton for N2O5 heterogeneous reaction probability
C               based on Bertram and Thornton (2009) (fine and coarse mode)
 
C References:
C   1. Dentener, F.J. and P.J. Crutzen, Reaction of N2O5 on tropospheric
C      aerosols: Impact of global distributions of NOx, O3, and OH.
C      J. Geophys. Res., Vol 98, 7149-7163, 1993.
C
C   2. Riemer, N., H. Vogel, B. Vogel, B. Schell, I. Ackermann, C.
C      Kessler, and H. Hass, Impact of the heterogeneous hydrolysis
C      of N2O5 on chemistry of nitrate aerosol formation in the lower
C      troposphere under photosmog conditions.  J. Geophys. Res., Vol
C      108, No D4, 4144, doi:10.1029/2002JD002436, 2003.
C
C   3. Evans, M.J. and D.J. Jacob, Impact of new laboratory studies of
C      N2O5 hydrolysis on global model budgets of tropospheric nitrogen
C      oxides, ozone, and OH.  Geophys. Res. Lett., 32, L09813,
C      doi:10.1029/2005GL022469, 2005.
C
C   4. Davis, J.M., P.V. Bhave, and K.M. Foley, Parameterization of N2O5
C      reaction probabilities on the surface of particles containing
C      ammonium, sulfate, and nitrate.  Atmos. Chem. Phys., 2008, in
C      press.
C
C   5. Mentel, T.F., M. Sohn, and A. Wahner, Nitrate effect in the
C      heterogeneous hydrolysis of dinitrogen pentoxide on aqueous
C      aerosols.  Phys. Chem. Chem. Phys., 1, 5451-5457, 1999.
C
C   6. Bertram, T. H. and J.A. Thornton, Toward a general parameterization
C      of N2O5 reactivity on aqueous particles: the competing effects of 
C      particle liquid water, nitrate, and chloride, ACP, 9, 8351-8363, 2009. 

C-----------------------------------------------------------------------

      USE AERO_DATA
      USE AEROMET_DATA   ! Includes CONST.EXT

      IMPLICIT NONE

C *** Arguments
      REAL( 8 ),    INTENT( IN ) :: TEMP     ! Air temperature [ K ]
      REAL( 8 ),    INTENT( IN ) :: RH       ! Fractional relative humidity
      INTEGER,      INTENT( IN ) :: GPARAM   ! switch to select among
                                             !  parameterizations

C *** Parameters

C *** switch for alternative parameterization of LAM1 & LAM2
C     when APNDX = .TRUE. (default), Eqs A1-A2 are used for reaction
C     probability on aqueous sulfate particles.  Alternatively, set
C     APNDX = .FALSE. to use Eqs 4-5.
      LOGICAL, PARAMETER :: APNDX = .TRUE.

C *** Local Variables

C *** chemical species concentrations [ug/m3]
      REAL      ANH4      ! i+j mode ammonium
      REAL      ANO3      ! i+j mode nitrate
      REAL      ASO4      ! i+j mode sulfate

C *** variables for computing N2O5_GAMMA when GPARAM = 2 or 3
      REAL      FRACSO4   ! aerosol mass ratio of SO4/(SO4+NO3)
      REAL      GAMMA1    ! upper limit of rxn prob
      REAL      GAMMA2    ! lower limit of rxn prob
      REAL      ALPHA     ! RH-dependent parameter to compute GAMMA1
      REAL      BETA      ! TEMP-dependent parameter to compute GAMMA1

C *** variables for default parameterization of N2O5_GAMMA
!     LOGICAL, EXTERNAL ::   CRYSTALIZED      ! function to determine if RH is below CRH
      LOGICAL   CRYSTAL   ! true if ambient RH < CRH, false otherwise
!     LOGICAL, EXTERNAL ::   FREEZES   ! function to determine whether RH exceeds IRH
      LOGICAL   FROZEN    ! true if ambient RH > IRH, false otherwise
      REAL      NNO3      ! particle-phase nitrate [micromoles/m3]
      REAL      NSO4      ! particle-phase sulfate [micromoles/m3]
      REAL      NNH4      ! particle-phase ammonium [micromoles/m3]
      REAL      NANI      ! particle-phase anions [micromoles/m3]
      REAL      X1        ! mole fraction of ammonium bisulfate
      REAL      X2        ! mole fraction of ammonium sulfate
      REAL      X3        ! mole fraction of ammonium nitrate
      REAL      LAM1      ! logit transformation of N2O5_GAMMA on
      REAL      LAM2      !   aqueous NH4HSO4 [LAM1], aqueous (NH4)2SO4
      REAL      LAM3      !   [LAM2], aqueous NH4NO3 [LAM3], and dry
      REAL      LAMD      !   sulfate-containing particles [LAMD]
      REAL      GAM1      ! reaction probability on aqueous NH4HSO4
      REAL      GAM2      !    "          "      "     "    (NH4)2SO4
      REAL      GAM3      !    "          "      "     "    NH4NO3
      REAL      GAMD      !    "          "      " dry sulfate particles
      REAL      T293,T291 ! temperature threshold variables
      REAL      RH46      ! RH threshold variable

C *** variables for parameterization based on Bertram and Thornton (2009)

      REAL      ACLF      ! I & J mode chloride, ug/m3 
      REAL      AH2OF     ! I & J mode water, ug/m3    
      REAL      ANO3F     ! I & J mode nitrate, ug/m3  

      REAL      ACLK      ! k mode chloride, ug/m3 
      REAL      AH2OK     ! k mode water, ug/m3    
      REAL      ANO3K     ! k mode nitrate, ug/m3  

      REAL      ACLM      ! chloride, [moles / liter of particles] 
      REAL      AH2OM     ! water,    [moles / liter of particles] 
      REAL      ANO3M     ! nitrate,  [moles / liter of particles] 
   
      REAL DEN1           ! local varible
      REAL DEN2           ! local varible
      REAL DEN            ! local varible
      REAL INV_VOL        ! local variable 
      
      REAL, PARAMETER :: A = 3.2E-08       ! Unit [s] - Table 2       
      REAL, PARAMETER :: BETA_BT = 1.15E06 ! Unit [1/s] - Table 2  
      REAL, PARAMETER :: DELTA = 1.3E-01   ! Unit [1/M] - Table 2  
      REAL, PARAMETER :: K3OK2B = 6.0E-02  ! Unit [ ] - Table 2  
      REAL, PARAMETER :: K4OK2B = 29.0     ! Unit [ ] - Table 2  
      REAL K2FP                            ! varible in eqn 10
                 
C *** statement function for inverting the logit transformation given
C     in Eq 7 by Davis et al (2008)
      REAL      LOGITINV  ! statement function
      REAL      XX        ! dummy argument for LOGITINV
      LOGITINV( XX ) = 1.0 / ( 1.0 + EXP( -XX ) )

C-----------------------------------------------------------------------

C *** retrieve fine-mode particle-phase ammonium, nitrate, and sulfate [ug/m3]
      ANH4 = aerospc_conc( ANH4_IDX,1 ) + aerospc_conc( ANH4_IDX,2 )
      ANO3 = aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 )
      ASO4 = aerospc_conc( ASO4_IDX,1 ) + aerospc_conc( ASO4_IDX,2 )

c *** Retrieve fine-mode particle-phase liquid water, chloride, nitrate [ug/m3]
      AH2OF  = aerospc_conc( AH2O_IDX,1 ) + aerospc_conc( AH2O_IDX,2 ) 
      ACLF   = aerospc_conc( ACL_IDX,1 )  + aerospc_conc( ACL_IDX,2 ) 
      ANO3F  = aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 )

c *** Retrieve coarse-mode particle-phase liquid water, chloride, nitrate [ug/m3]
      AH2OK  = aerospc_conc( AH2O_IDX,3 )
      ACLK   = aerospc_conc(  ACL_IDX,3 )
      ANO3K  = aerospc_conc( ANO3_IDX,3 )      

      WHAT_OPTION: SELECT CASE( GPARAM )

         CASE ( 1 )
C *** User Option: GPARAM = 1
C     Dentener and Crutzen (1993) recommended a constant value of
C     N2O5_GAMMA = 0.1, which was used in CMAQ prior to ver4.3.  In more
C     recent literature, this value has been recognized as an upper
C     estimate of N2O5_GAMMA so it should not be used for routine
C     simulations.  It is included here only to facilitate sensitivity
C     studies by CMAQ model users.

            N2O5_GAMMA = 0.1D0
            RETURN
            
         CASE( 2, 3 )
C *** User Options: GPARAM = 2 and 3
C     These options both employ Eqs 2 and 3 by Riemer et al (2003), in
C     which N2O5_GAMMA varies according to the particle-phase sulfate and
C     nitrate concentrations.  In both options, the NO3 effect (i.e.,
C     GAMMA1/GAMMA2) is assumed to be a factor of 10 based on Mentel et
C     al (1999) and Riemer et al (2003).
C      - When GPARAM = 2, upper limit of N2O5_GAMMA is fixed at 0.02.
C        This was the default setting in CMAQ ver4.3 through ver4.5.1.
C      - When GPARAM = 3, upper limit of N2O5_GAMMA is a function of
C        ambient TEMP & RH based on the "Sulfate" equation in Table 1
C        by Evans & Jacob (2005).  This was the default setting in CMAQ
C        ver4.6.  After that release, a typographical error was found
C        in the published equation of Evans & Jacob (2005) so this code
C        has been corrected accordingly.

            IF ( GPARAM .EQ. 2 ) THEN
            
                GAMMA1 = 0.02

            ELSE 
C        In this function, RH is in fractional units whereas the
C        published equation by Evans&Jacob refers to RH as a percentage.

               ALPHA = 2.79E-04
     &               + REAL( RH * ( 1.3D-02 + RH * ( -3.43D-02 + 7.52D-02 * RH ) ), 4 )

C        To fix the typographical error by Evans & Jacob (2005), the
C        sign of BETA has been switched in this code.

               IF ( TEMP .LT. 282.0D0 ) THEN
                  GAMMA1 = 3.0199517 * ALPHA   ! (10.0 ** 0.48) * ALPHA
               ELSE
                  BETA  = 0.04 * ( 294.0 - REAL( TEMP,4 ) )
                  GAMMA1 = ALPHA * ( 10.0 ** BETA )
               END IF
            END IF

            IF ( ANO3 .GT. 0.0 ) THEN
               FRACSO4 = ASO4 / ( ASO4 + ANO3 )
            ELSE
               FRACSO4 = 1.0
            END IF

            GAMMA2 = 0.1 * GAMMA1
            N2O5_GAMMA = REAL( ( GAMMA2 + FRACSO4 * ( GAMMA1 - GAMMA2 ) ), 8 )
   
            RETURN

         CASE ( 4 )

C *** User Option: GPARAM = 4  (fine-mode particles)
C *** It calculates N2O5_GAMMA based on Bertran and Thornton, 2009
  
            INV_VOL = 1.0E-9 * f6pi / REAL( ( WET_M3( 1 ) + WET_M3( 2 ) ), 4 )
        
            AH2OM = AH2OF * INV_VOL / aerospc_mw( AH2O_IDX )
            ACLM  = ACLF  * INV_VOL / aerospc_mw( ACL_IDX )
            ANO3M = ANO3F * INV_VOL / aerospc_mw( ANO3_IDX )
            
            K2FP =  BETA_BT - BETA_BT * EXP( -DELTA * AH2OM )
          
            DEN1 = K3OK2B * ( AH2OM / ANO3M )

            DEN2 = K4OK2B * ( ACLM  / ANO3M  )

            DEN  = DEN1 + 1.0 + DEN2
         
            N2O5_GAMMA = REAL( A * K2FP * (1.0 - 1.0 / DEN), 8 )
                   
            RETURN

         CASE ( 5 )
   
C *** User Option: GPARAM = 5 (coarse-mode particles)
C     It calculates N2O5_GAMMA based on Bertran and Thornton, 2009

            INV_VOL = 1.0E-9 * f6pi / REAL( WET_M3( 3 ), 4 )
        
            AH2OM = AH2OK * INV_VOL / aerospc_mw( AH2O_IDX )
            ACLM  = ACLK  * INV_VOL / aerospc_mw( ACL_IDX )
            ANO3M = ANO3K * INV_VOL / aerospc_mw( ANO3_IDX )
            
            K2FP =  BETA_BT - BETA_BT * EXP( -DELTA * AH2OM )
          
            DEN1 = K3OK2B * ( AH2OM / ANO3M )

            DEN2 = K4OK2B * ( ACLM  / ANO3M )

            DEN  = DEN1 + 1.0 + DEN2      

            N2O5_GAMMA = REAL( A * K2FP * (1.0 - 1.0 / DEN), 8)
                                                         
            RETURN
    
!           IF ( DUMP_CELL ) THEN
!              WRITE(*,*)'AH2OM = ',AH2OM
!              WRITE(*,*)'ACLM  = ',ACLM
!              WRITE(*,*)'ANO3M = ',ANO3M
!              WRITE(*,*)'DEN   = ',DEN
!              WRITE(*,*)'DEN1  = ',DEN1
!              WRITE(*,*)'DEN2  = ',DEN2
!              WRITE(*,*)'K2FP  = ',K2FP
!              WRITE(*,*)'GAMMAK = ',A * K2FP * (1.0 - 1.0 / DEN)
!           END IF
                                
!           RETURN
             
         CASE DEFAULT
      
C *** Default setting in current version of CMAQ:
C     This code implements the paramaterization given in Eq 15 by Davis
C     et al (2008), in which N2O5_GAMMA is a function of RH, TEMP,
C     particle composition, and phase state.  Note: In this function, RH
C     is in fractional units whereas the published equations refer to RH
C     as a percentage.

C *** Check whether the ambient RH is below the crystallization RH for
C     the given inorganic particle composition.
            CRYSTAL = CRYSTALIZED( RH, .TRUE. )

C *** Check whether the ambient RH exceeds the RH of ice formation.
            FROZEN = FREEZES( TEMP, RH )
      
            IF ( FROZEN ) THEN
C *** Set N2O5_GAMMA to constant value if particles contain ice, based on
C     Eq 14 by Davis et al (2008).

               N2O5_GAMMA = 0.02D0                               ! Eq 14

            ELSE
C *** Compute mole-fractional-composition of particles based on Eq 11 by
C     Davis et al (2008).
               NNO3 = ANO3 / aerospc_mw( ANO3_IDX )
               NSO4 = ASO4 / aerospc_mw( ASO4_IDX )
               NNH4 = ANH4 / aerospc_mw( ANH4_IDX )
               NANI = NNO3 + NSO4
         
               X3 = NNO3 / NANI
               X2 = MAX( 0.0, MIN( 1.0 - X3, NNH4/NANI - 1.0 ) )
               X1 = 1.0 - ( X2 + X3 )

C *** Compute N2O5_GAMMA on pure NH4NO3 particles using Eqs 6 and 8 by
C     Davis et al (2008).
               LAM3 = -8.10774 + 4.902 * REAL( RH, 4 )            ! Eq 6
               GAM3 = MIN( LOGITINV( LAM3 ), 0.0154 )             ! Eq 8

C *** Compute N2O5_GAMMA on dry particles using Eqs 9, 10, and 13 by
C     Davis et al (2008).
               IF ( CRYSTAL ) THEN
                  T293     = MAX( 0.0, REAL( TEMP ) - 293.0 )
                  LAMD     = -6.13376 + 3.592 * REAL( RH, 4 )     ! Eq 9
     &                     - 0.19688 * T293
                  GAMD     = MIN( LOGITINV( LAMD ), 0.0124 )      ! Eq 10
                  N2O5_GAMMA = REAL( ( X1 + X2 ) * GAMD           ! Eq 13
     &                       +         X3 * MIN( GAMD, GAM3 ), 8)

C *** Compute N2O5_GAMMA on aqeuous particles using Eqs A1, A2, 8, and 12
C     by Davis et al (2008).  When APNDX = .TRUE. (default), Eqs A1-A2
C     are used for reaction probability on aqueous sulfate particles.
C     Switch to .FALSE. if Eqs 4-5 are desired.  See Appendix A by
C     Davis et al. (2008) for a discussion of these options.
               ELSE
                  T291 = MAX( 0.0, REAL( TEMP ) - 291.0 )
                  IF ( APNDX ) THEN
                     RH46  = MIN( 0.0, REAL( RH )- 0.46 )
                     LAM2  = -3.64849 + 9.553 * RH46          ! Eq A2
                     LAM1  = LAM2 + 0.97579                   ! Eqs A1 & A2
     &                     - 0.20427 * T291
                  ELSE
                     LAM1  = -4.10612 + 2.386 * REAL( RH )    ! Eq 4
     &                     - 0.23771 * T291
                     LAM2  = LAM1 - 0.80570                   ! Eqs 4 & 5
     &                     + 0.10225 * T291
                  END IF

                  GAM1     = MIN( LOGITINV( LAM1 ), 0.08585 ) ! Eq 8
                  GAM2     = MIN( LOGITINV( LAM2 ), 0.053 )   ! Eq 9
                  N2O5_GAMMA = REAL( ( X1 * GAM1 )            ! Eq 12
     &                       +       ( X2 * GAM2 )
     &                       +       ( X3 * GAM3 ), 8 )

               END IF
            END IF

      END SELECT WHAT_OPTION


      RETURN

      END FUNCTION N2O5_GAMMA

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      LOGICAL FUNCTION CRYSTALIZED( RH, COMPLETE )

C  Determines whether the ambient RH is below the crystallization relative
C  humidity (CRH).  The output of this logical function is .TRUE. when the
C  ambient RH is below the CRH and .FALSE. otherwise.  The empirical
C  equations developed by Martin et al (2003) are applied to determine the
C  CRH for a given mixture of sulfate, nitrate, and ammonium.  Though those
C  equations are validated only at 293K, they are applied at all ambient
C  temperatures because insufficient data exist to estimate the temperature
C  dependence of the CRH of mixed sulfate-nitrate-ammonium particles.
C  Users can opt to compute either the RH of initial crystal formation
C (i.e., COMPLETE .EQ. .FALSE.) or the RH of compete crystallization (i.e.,
C  COMPLETE .EQ. .TRUE.).

C  References:
C   1. Martin, S.T., J.C. Schlenker, A. Malinowski, H.-M. Hung, and
C      Y. Rudich, Crystallization of atmospheric sulfate-nitrate-
C      ammonium particles.  Geophys. Res. Lett., 30(21), 2102,
C      doi:10.1029/2003GL017930, 2003.

C  Revision History:
C    PVB 11/05/07 Coded the first version.
C    JTK 04/17/08 Moved molar mass to AERO_INFO.f
C    SH  12/08/09 Use aero_data module in lieu of CBLK array

C-----------------------------------------------------------------------

      USE AERO_DATA

      IMPLICIT NONE

C *** Arguments
      REAL( 8 ), INTENT( IN )    :: RH        ! fractional relative humidity
      LOGICAL,   INTENT( IN )    :: COMPLETE  ! flag deciding which CRH
                                              !  equation to use

C *** Local Variables

C *** chemical species concentrations [micromoles/m3]
      REAL      NSO4     ! i+j mode sulfate
      REAL      NNO3     ! i+j mode nitrate
      REAL      NNH4     ! i+j mode ammonium
      REAL      NCAT     ! i+j mode cations
      REAL      NANI     ! i+j mode anions

C *** cation and anion mole fractions used in CRH equations
      REAL X         ! ammonium/cation mole fraction: NH4/(NH4+H)
      REAL Y         ! sulfate/anion mole fraction:  SO4/(SO4+NO3)

C *** intermediate variables used in CRH equations
      REAL X2, XY, Y2, X2Y, XY2, RDEN

      REAL CRH       ! crystallization RH (fractional units)

C-----------------------------------------------------------------------

C *** Experimental measurements of CRH are lacking below 1% relative
C     humidity.  Under those very dry conditions, we assume that
C     particles will crystallize.  Equations by Martin et al (2003) for
C     internally-mixed sulfate-nitrate-ammonium particles yield maximum
C     CRH values of 35.03% and 34.50% for initial crystal formation and
C     complete crystallization, respectively.  Therefore, the full CRH
C     calculation can be avoided when RH > 35.1%.
      IF ( RH .LE. 0.01D0 ) THEN
         CRYSTALIZED = .TRUE.    ! ambient particles are dry
         RETURN
      ELSE IF ( RH .GT. 0.351D0 ) THEN
         CRYSTALIZED = .FALSE.   ! ambient RH exceeds CRH
         RETURN
      END IF

C *** calculate total particle-phase composition [micromoles/m3]
      NNO3 = ( aerospc_conc( ANO3_IDX,1 ) + aerospc_conc( ANO3_IDX,2 ) )
     &     / aerospc_mw( ANO3_IDX )
      NSO4 = ( aerospc_conc( ASO4_IDX,1 ) + aerospc_conc( ASO4_IDX,2 ) )
     &     / aerospc_mw( ASO4_IDX )
      NNH4 = ( aerospc_conc( ANH4_IDX,1 ) + aerospc_conc( ANH4_IDX,2 ) )
     &     / aerospc_mw( ANH4_IDX )

C *** calculate total anion and cation concentrations
      NCAT = MAX( NNH4, 2.0 * NSO4 + NNO3 )
      NANI = NNO3 + NSO4

C *** calculate ammonium and sulfate mole fractions
      X = NNH4 / NCAT
      Y = NSO4 / NANI

C *** Experimental data of Martin et al. (2003) show no crystal
C     formation when X < 0.50 or Y < 0.22.  For these particle
C     compositions, the full CRH calculation can be avoided.
C
C     Note: Martin`s equation for initial crystal formation returns
C     very large CRH values when X and Y approach zero.  However,
C     those values were verified to be erroneous by personal
C     communication with Dr. Scot Martin on Aug. 30, 2007.
      IF ( ( X .LT. 0.50 ) .OR. ( Y .LT. 0.22 ) ) THEN
         CRYSTALIZED = .FALSE.   ! ambient RH exceeds CRH
         RETURN
      END IF

C *** store some terms needed to evaluate the CRH equations
      X2   = X * X
      XY   = X * Y
      X2Y  = X2 * Y
      Y2   = Y * Y
      XY2  = X * Y2
      RDEN = 1.0 / ( 25.0 + ( X - 0.7 ) * ( Y - 0.5 ) )

C *** calculate CRH using empirical equations of Martin et al (2003)
      IF ( COMPLETE ) THEN

         CRH = 3143.44 + (63.07 * X) + (0.114 * X2) + (87.97 * Y)
     &       - (125.73 * XY) + (0.586 * X2Y) + (0.95 * Y2)
     &       - (1.384 * XY2) - (79692.5 * RDEN)

      ELSE

         CRH = -697.908 - (15.351 * X) + (0.43 * X2) - (22.11 * Y)
     &       + (33.882 * XY) - (1.818 * X2Y) + (0.772 * Y2)
     &       - (1.636 * XY2) + (17707.6 * RDEN)

      END IF

C *** set value of the output variable, CRYSTALIZED
      IF ( RH .LE. REAL( CRH, 8 ) ) THEN
         CRYSTALIZED = .TRUE.    ! ambient particles are dry
      ELSE
         CRYSTALIZED = .FALSE.   ! ambient RH exceeds CRH
      END IF

      RETURN

      END FUNCTION CRYSTALIZED

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      LOGICAL FUNCTION FREEZES( TEMP, RH )

C  Determines whether the ambient RH has exceeded the RH of ice formation,
C  based on the Goff-Gratch equations as given by List (1984).

C  References:
C   1. Goff, J.A. and S. Gratch, Low-pressure properties of water from
C      -160 to 212 F, in Transactions of the American Society of Heating
C      and Ventilating Engineers, pp 95-122, New York, 1946.
C   2. List, R.J. (editor), Smithsonian Meteorological Tables, 5th ed.
C      pp. 350, 1984.

C  Revision History:
C   PVB 11/06/07 Coded the first version.
C-----------------------------------------------------------------------

      IMPLICIT NONE

C *** Arguments
      REAL( 8 ), INTENT( IN ) :: TEMP        ! Air temperature [ K ]
      REAL( 8 ), INTENT( IN ) :: RH          ! Fractional relative humidity

C *** Parameters

C *** The following values are taken from List (1984).  Note that
C     these differ slightly from the original equations published by
C     Goff & Gratch (1946).  We also note that T0 and PST differ
C     slightly from STDTEMP and STDATMPA in the AERO_INFO module.
C     Here, we use 273.16 K and 1013.246 hPa to be consistent with
C     the Goff-Gratch equations as given by List (1984).
      REAL( 8 ), PARAMETER :: TST = 373.16D0    ! steam-point temperature, K
      REAL( 8 ), PARAMETER :: T0  = 273.16D0    ! ice-point temperature, K
      REAL( 8 ), PARAMETER :: PST = 1013.246D0  ! sat vapor pres at TST, hPa
      REAL( 8 ), PARAMETER :: P0  = 6.1071D0    ! sat vapor pres at T0, hPa

      REAL( 8 ), PARAMETER :: LOGPST = 3.0057149D0     ! LOG10(PST)
      REAL( 8 ), PARAMETER :: LOGP0  = 0.78583503D0    ! LOG10(P0)

C *** Local Variables

C *** estimates of IRH using a polynomial approximation
      REAL( 8 )      EIRH   ! IRH approximated using 2nd order polynomial
      REAL( 8 )      LIRH   ! lower-bound of IRH
      REAL( 8 )      UIRH   ! upper-bound of IRH

C *** variables used to compute RH of ice formation
      REAL( 8 )      TSDT, TDTS, T0DT, TDT0  ! intermediate variables
      REAL( 8 )      LOGPW  ! log10 of saturation vapor pressure over H2O
      REAL( 8 )      LOGPI  ! log10 of saturation vapor pressure over ice

      REAL( 8 )      IRH    ! fractional RH at which ice forms

C-----------------------------------------------------------------------

      IF ( TEMP .LT. T0 ) THEN

C *** To mitigate the computational expense associated with Goff-Gratch
C     equations, use a 2nd order polynomial function to approximate IRH.
C     This approximation, EIRH, matches IRH from the full Goff-Gratch
C     equations within 0.004 over the entire low-temperature range of
C     interest (200 to 275K) and is used for screening purposes.
         EIRH = 1.61299D0 + TEMP * ( 4.4117437D-5 * TEMP - 1.4293888D-2 )
         LIRH = EIRH - 0.005D0
         UIRH = EIRH + 0.005D0

         IF ( RH .GT. UIRH ) THEN
            FREEZES = .TRUE.
         ELSE IF ( RH .LT. LIRH ) THEN
            FREEZES = .FALSE.
         ELSE

C *** Compute IRH using Goff-Gratch equations as given by List (1984)
            TSDT  = TST / TEMP
            TDTS  = TEMP / TST
            T0DT  = T0 / TEMP
            TDT0  = TEMP / T0
            LOGPW = -7.90298D0 * ( TSDT - 1.0D0 )
     &            + 5.02808D0 * LOG10( TSDT )
     &            - 1.3816D-7 * ( 10.0D0 ** ( 11.344D0 *  (1.0D0 - TDTS) ) - 1.0D0 )
     &            + 8.1328D-3 * ( 10.0D0 ** ( -3.49149D0 * (TSDT - 1.0D0) ) - 1.0D0 )
     &            + LOGPST
            LOGPI = -9.09718D0 * (T0DT - 1.0D0)
     &            - 3.56654D0 * LOG10( T0DT )
     &            + .876793D0 * (1.0D0 - TDT0)
     &            + LOGP0
            IRH   = 10.0D0 ** ( LOGPI - LOGPW )

            IF ( RH .GT. IRH ) THEN
               FREEZES = .TRUE.
            ELSE
               FREEZES = .FALSE.
            END IF

         END IF
      ELSE
         FREEZES = .FALSE.
      END IF

      RETURN

      END FUNCTION FREEZES

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CALCISOPGAMMAS( RADIUS, TEMPERATURE,
     &                           GAMMAIEPOX, GAMMAIMAE,
     &                           KPIEPOX, fTET, fOS, fdim1, fdim2 )

C  Calculates the uptake coefficients (gammas) for IEPOX, IMAE, and IHMML
C  based on particle phase H+ (EQLBH) and other particle constituents.
C  Also returns calculated particle phase reaction rate, fraction of uptake
C  producing tetrols, organosulfates, and dimers.

C  Note that indices 1 and 2 are used for both acids (1=H+, 2=bisulfate) and
C  the organics (1=IEPOX, 2=IMAE).

C  Key Subroutines Called: none

C  Key Functions Called: none

C  Revision History: 
C  HOTP 1/18/13 First coding
C  HOTP 9/26/14 Reduced form considering only IEPOX uptake with no
C               speciation developed for CB05
C  HOTP 5/10/16 Merged with AERO6I code. Now handles SAPRC07tic and MAE uptake.

C  References
C  1. Chan, M. N., et al. "Characterization and quantification of isoprene-
C     derived expoxydiols in ambient aerosol in the Southeastern United States,"
C     Environ. Sci. Technol., 2010, 44, 4590-4596.
C  2. Eddingsaas, N. C., VanderVelde, D. G., Wennberg, P. O. "Kinetics 
C     and products of the acid-catalyzed ring-opening of atmospherically
C     relevant butyl epoxy alcohols," J. Phys. Chem A., 2010, 114, 8106-8113.
C  3. Gharagheizi, F., et al. "Representation and prediction of molecular diffusivity
C     of nonelectrolyte organic compounds in water at infinite dilution using the
C     artificial neural network-group contribution method," J. Chemical & Engineering
C     Data, 2011, 46, 1741-1750.
C  4. Hanson, D. R., Ravishankara, A. R., Solomon, S. "Heterogeneous reactions in
C     sulfuric acid aerosols: A framework for model calculations," J. Geophys. Res.,
C     1994, 99, 3615-3629.
C  5. McNeill, V. F., et al. "Aqueous-phase secondary organic aerosol and organosulfate 
C     formation in atmospheric aerosols: A modeling study," Environ Sci Technol., 2012,
C     46, 8075-8081.
C  6. Pye et al., Epoxide pathways improve model predictions of isoprene
C     markers and reveal key role of acidity in aerosol formation,
C     Envion. Sci. Technol, 2013, doi: 10.1021/es402106h. 
C-----------------------------------------------------------------------

      Use aero_data
      Use precursor_data
      Use aeromet_data   ! Includes CONST.EXT (pi) and airtemp
      Use utilio_defn    ! error message and abort

      Implicit None

C *** Arguments
      Real( 8 ), Intent( IN )  :: RADIUS       ! Particle radius [m]
      Real( 8 ), Intent( IN )  :: TEMPERATURE  ! air temperature [deg K]
      Real( 8 ), Intent( OUT ) :: GAMMAIEPOX ! Uptake coeff for IEPOX []
      Real( 8 ), Intent( OUT ) :: GAMMAIMAE  ! Uptake coeff for MAE []
      Real( 8 ), Intent( OUT ) :: KPIEPOX ! Particle phase reaction rate for IEPOX [1/s]
      Real( 8 ), Intent( OUT ) :: fTET(2), fOS(2), fdim1(2), fdim2(2)
                                  ! fraction of tetrol, organosulfate, tetroldimer, osdimer []
                                  ! first value for IEPOX-derived, second for IMAE-derived
C *** Parameters
C     For gamma calculation
      Real( 8 ), Parameter :: inv_alpha    = 1.0d0/0.02d0 ! reciproaccomodation coefficient from McNeill et al. 2012 []
      Real( 8 ), Parameter :: diffusivity  = 1.0d-9    ! liquid phase diffusivity, based on C4-C5 epoxides 
                                                       ! and diols at infinite dilution in water (Gharagheizi et al. 2011) [m2/s]
      Real( 8 ), Parameter :: RgasLatmmolK = 0.08206d0 ! Universal gas constant [L atm/mol K]
      Real( 8 ), Parameter :: small        = 1.0d-8   ! small number to prevent calculations that may have precision issues
      Real( 8 ), Parameter :: smaller      = 1.0d-20  ! smaller number to prevent division by zero

C     Acid related
      Integer, Parameter   :: n_acids      = 2 ! number of acids: H+ and HSO4-
      Integer, Parameter   :: hacid_idx    = 1 ! H+ acid index
      Integer, Parameter   :: hso4acid_idx = 2 ! HSO4 acid index

C     Henry's law coeff for IEPOX (1) and IMAE (2) (HenryWin v 3.2)
      Real( 8 ) :: Heff(2)

C     Diagnostic
      Character (16 ), Parameter :: pname = 'CALCISOPGAMMAS'

C *** Local Variables
      Integer   :: i                   ! counter and temporary indices
      Real( 8 ) :: eqlbh               ! Particle Phase H+ from isoropia [mol/m**3]
      Real( 8 ) :: q, denom            ! quantities in Hanson et al. 1994 equation for gamma []
      Real( 8 ) :: nu                  ! molecular speed [m/s], note this is the same as CBAR but we want to avoid excessive passing
      Real( 8 ) :: acidmolconc( n_acids ) ! concentration of acid in mol/m3
      Real( 8 ) :: acid                ! temporary concentration of acid in mol/m3
      Real( 8 ) :: nuc                 ! nucleophile concentration in mol/m3
      Real( 8 ) :: charge              ! temporary for charge balance calculation [umol/m3]
      Real( 8 ) :: inv_volume          ! reciprocal of particle volume [m3 air/Liters particles]
      Real( 8 ) :: kchem, kparticle(2) 
      Real( 8 ) :: kchemtet(2),kchemos(2), kchemdim1(2), kchemdim2(2) ! particle phase rxn rates [1/s] 
      Real( 8 ) :: gammaisop(2)        ! temporary value for IEPOX (1) and IMAE (2) gammas
      Real( 8 ) :: cfactor_isop(2)     ! cfactor for IEPOX(1) and MAE(2)
      Real( 4 ) :: temp                ! air temperature [deg K]
      Character ( 80 ) :: xmsg         ! error message

C *** External functions
      Interface
         Real Function hlconst ( cname, temp, effective, hplus )
           Use utilio_defn
           Implicit None
           Character*(*), Intent ( In ) :: cname
           Real,          Intent ( In ) :: temp
           Logical,       Intent ( In ) :: effective
           Real,          Intent ( In ) :: hplus
        End Function hlconst
      End Interface

C-----------------------------------------------------------------------

C *** Determine H+ acid concentration of j mode [mol/m3]
      eqlbh = aerospc_conc( ah3op_idx, 2 ) / aerospc_mw( ah3op_idx ) * 1.0d-6
      acidmolconc( hacid_idx ) = Max( eqlbh, 0.0d0 ) 

C *** Calculate HSO4 by charge balance
C     Note: if isorropia has returned a negative H+ concentration
C     we effectively treat all H+ like HSO4 (slightly less effective
C     in catalyzing the ring-opening)
      charge = 0.0d0  ! umol/m3
      Do i = 1, n_aerospc
         If ( aerospc( i )%tracer ) Cycle
         If ( aero_missing( i,2 ) ) Cycle
         charge = charge - aerospc( i )%charge * aerospc_conc( i,2 )
     &          / aerospc_mw( i )
      End Do
      acidmolconc( hso4acid_idx ) = Max( ( charge*1.0d-6 - acidmolconc( hacid_idx ) ), 0.0d0 ) 

C *** J-mode particle volume [L/m**3 air]
      inv_volume = 0.0d0
      Do i = 1, n_aerospc 
         If ( aerospc( i )%tracer ) Cycle
         If ( aero_missing( i,2 ) ) Cycle
!        If ( aerospc( i )%no_M2Wet ) Cycle
         inv_volume = inv_volume + Real( aerospc_conc( i, 2 ) / aerospc(i)%density, 8 ) !  * 1.0d-6
      End Do
      inv_volume = 1.0d6 / inv_volume

C *** Loop over nucleophile/acid pairs defined in acid_nuc_pairs in AERO_DATA
C     and calculate rate of particle phase reaction
      kchem     = 0.0d0   ! intermediate value
      kparticle = 0.0d0   ! accumulating IEPOX and IMAE value
      kchemos   = 0.0d0   ! accumulating organosulfate for IEPOX and IMAE
      kchemtet  = 0.0d0   ! accumulating tetrols or equivalent for IEPOX and IMAE
      kchemdim1 = 0.0d0   ! accumulating tetrol-dimer or equivalent for IEPOX and IMAE
      kchemdim2 = 0.0d0   ! accumulating os-dimer or equivalent for IEPOX and IMAE

      Do i = 1, n_nucpairs

C        Find J-mode nucleophile concentration in ug/m3 and convert to mol/m3
         nuc = aerospc_conc( acid_nucmap_idx( i ), 2 ) 
     &       /  aerospc_mw( acid_nucmap_idx( i ) ) * 1.0d-6

         acid = acidmolconc( acid_nuc_pairs( i )%idx_acid ) ! mol/m3

C        Correct sulfate for presence of bisulfate
         If ( acid_nuc_pairs( i )%idx_remove .Ge. 1 ) Then
            nuc = Max( nuc - acidmolconc( acid_nuc_pairs( i )%idx_remove ), 0.0d0 )
         End If

C        Determine rate of particle phase rxn for a given pair (Eddingsaas et al.)
         kchem = acid_nuc_pairs( i )%kchem* nuc * acid * ( inv_volume*inv_volume )
         
C        Update sum
C        Store information with speciation for IEPOX
         if ( acid_nuc_pairs( i )%parent .eq. 'IEPOX' ) then
            kparticle( 1 )  = kparticle(1) + kchem
            if ( acid_nuc_pairs( i )%prod .eq. 'AIEOSJ' ) then !ae6i
              kchemos( 1 )  = kchemos(1)   + kchem
            else if ( (acid_nuc_pairs( i )%prod .eq. 'ADIMJ')
     &             .and. (acid_nuc_pairs( i )%nuc .eq. 'AIETETJ') ) then !ae6i
              kchemdim1( 1 ) = kchemdim1(1)  + kchem
            else if ( (acid_nuc_pairs( i )%prod .eq. 'ADIMJ')
     &             .and. (acid_nuc_pairs( i )%nuc .eq. 'AIEOSJ') ) then !ae6i
              kchemdim2( 1 ) = kchemdim2(1)  + kchem
            else if ( acid_nuc_pairs( i )%prod .eq. 'AIETETJ' ) then !ae6i
              kchemtet( 1 ) = kchemtet(1)  + kchem
            else if ( acid_nuc_pairs( i )%prod .eq. 'AISO3J' ) then !lumped treatments
               if ( acid_nuc_pairs( i )%nuc .eq. 'ASO4J' ) then !organosulfate
                 kchemos( 1 )  = kchemos(1)   + kchem
               else ! non sulfated species
                 kchemtet( 1 ) = kchemtet(1)  + kchem
               end if
            else
               xmsg = 'For IEPOX parent, reaction product not recognized '
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            end if
         end if

C        Store information with speciation for IMAE
         if ( acid_nuc_pairs( i )%parent .eq. 'IMAE' ) then
            kparticle( 2 )  = kparticle( 2 ) + kchem
            if( acid_nuc_pairs( i )%prod .eq. 'AIMOSJ' ) then
              kchemos( 2 )  = kchemos( 2 )   + kchem
            else if( acid_nuc_pairs( i )%prod .eq. 'AIMGAJ' ) then
              kchemtet( 2 ) = kchemtet( 2 )  + kchem
            else
               xmsg = 'For IMAE parent, reaction product not recognized '
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT2 )
            end if
         end if
      End Do      

C *** Calculate gamma following Pye et al. 2013 ES&T
C     (see also Hanson et al. 1994 JGR Eqn (2) for details)
C *** Calculate gammas for IEPOX and IMAE

C *** Henry's Law coefficients
      temp = real( TEMPERATURE, 4)
      Heff( 1 ) = REAL(HLCONST( 'IEPOX', temp, .False., 0.0 ), 8)
      Heff( 2 ) = REAL(HLCONST( 'IMAE',  temp, .False., 0.0 ), 8)

C *** Cfactor
      cfactor_isop( 1 ) = cfactor_iepox
      cfactor_isop( 2 ) = cfactor_imae

C     Loop over precursor species and calculate gamma
C     (see Hanson et al. 1994 JGR Eqn (2) for details)
      Do  i = 1, numvoc

C     Note that if the rate of particle phase reaction is very slow, there may not
C     be enough digits of precision to properly calculate q which can result in
C     erroneously high gamma values. Only calculate gamma if particle phase reaction
C     is faster than 1e-8 1/s

      ! Diffuso reactive parameter [ m * sqrt ( 1/s s/m2 ) = dim'less ]
      q = radius * dsqrt ( kparticle(i)/ diffusivity )

      If ( q / Tanh( q ) .Gt. 1.0d0 ) Then

         ! Molecular speed [ sqrt ( J/mol K * K / g * mol * g/ kg ) = sqrt (J/kg) = m/s ]
         nu = cfactor_isop( i ) * dsqrt( temperature )

         ! Gamma [ denom:  m/s / ( mol/L/atm * L atm /mol/ K * K * sqrt ( m2/s * 1/s )) = dim'less ]

          denom = ( inv_alpha + nu * radius
     &          / ( 4.0d0 * Heff( i )* RgasLatmmolK * temperature * diffusivity
     &            * ( q / Tanh( q ) -1.0d0 ) ) ) 

          gammaisop( i ) = 1.0d0 / denom

          ftet( i ) = kchemtet( i ) / kparticle( i )
          fos( i )  = kchemos( i ) / kparticle( i )
          fdim1( i ) = kchemdim1( i ) / kparticle( i )
          fdim2( i ) = kchemdim2( i ) / kparticle( i )

C     No/slow reaction
      Else

         gammaisop( i ) = 0.0d0
         ftet( i )  = 0d0
         fos( i )   = 0d0
         fdim1( i ) = 0d0
         fdim2( i ) = 0d0

      End If

      End Do

C *** Calculate final values to return
      gammaiepox = gammaisop( 1 )
      gammaimae  = gammaisop( 2 )
      kpiepox    = kparticle( 1 )

      RETURN
 
      END SUBROUTINE CALCISOPGAMMAS

      END MODULE AEROSOL_CHEMISTRY

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C......................................................................
      MODULE PA_IPRVARS

C Contains: data used in the Process Analysis Control Program

C Dependent Upon: None

C Revision History:
C......................................................................

      USE PA_GLOBAL, Only: MXSPEC
      USE PA_VARS, Only: MAXTERMS

      INTEGER, PARAMETER :: MAXIPRSPC = 600    ! Max no. of IPR species

      INTEGER, PARAMETER :: MAXIPROUT = MAXIPRSPC * 10   ! Max no. IPR outputs


      CHARACTER(  4 ) :: IPR_SPTYPE( MAXIPRSPC )   ! Type of mass balance species
      CHARACTER( 16 ) :: IPR_SPNAM ( MAXIPRSPC )   ! Name of mass balance species
      CHARACTER( 16 ) :: IPR_OPNAME( MAXIPRSPC,MAXTERMS )  ! Input IPR op names

      CHARACTER( 16 ) :: IPRNAME_TMP( MAXIPROUT )  ! Initial IPR variable names
      CHARACTER( 60 ) :: IPRDESC_TMP( MAXIPROUT )  ! Initial IPR variable descriptions

      INTEGER :: N_IPR_OPS ( MAXIPRSPC )   ! No. of input IPR operation names
      INTEGER :: IPR_SPNUM ( MAXIPRSPC )   ! Species or family-name number

      INTEGER :: SAV2GRD_TMP( MXSPEC )              ! Initial spcs pointer for saved concs
      INTEGER :: IPR2GRD_TMP( MAXIPRSPC,MAXTERMS )  ! Initial pointer to model spcs
      INTEGER :: IPR2SAV_TMP( MAXIPRSPC,MAXTERMS )  ! Initial spcs pointer to saved concs
      REAL    :: SPCOEF_TMP ( MAXIPRSPC,MAXTERMS )  ! Initial spcs coefficient

      END MODULE PA_IPRVARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module ABFlux_Mod

! Contains the shared variables and subroutines needed for the bidirectional 
! NH3 flux model in CMAQ
!
! INIT_ABFLUX - Intitializes the NH3 flux routines, allocates arrays, reads in
!               intial soil NH3 & H concentrations, and fertilizer application
!               amounts and timing for the model run
! 
! Revision History: J. Bash Dec 08 10:      Created
!                   J. Bash May 11 11:      Updated for CMAQ 5.0
!                   J.Young Oct 26 11:      KIND=16->KIND=8 for Portland Group compiler (pgi)
!                                           IsNaN function   "    "        "      "
!                                           (This Module must be compiled w/ -Kieee if pgi)
!                   J. Bash Jan 31 12:      New daily EPIC output now includes soil NH3 from 
!                                           mineralization of organic and no longer includes 
!                                           the monthly fertilizer totals. The initialization 
!                                           of soil NH3 was rewritten to reflect this.
!                   J. Bash Apr 19 12:      Set bounds on the soil moisture from the met. model
!                                           to be between saturation and residual soil moisture
!                                           to avoid errors in the soil resistance from rounding
!                                           errors. Corrected a units conversion error in the 
!                                           coupling of the soil NH4 to the atmospheric NH3.
!                                           This will maintain a better mass balance and have
!                                           a small impact on the model results ~ 1% of the
!                                           ambient NH3 concentrations.
!                   J. Bash Apr 19 12:      The apoplast compensation point for agricultural land use 
!                                           is now a function of the soil ammonium concentration 
!                                           following Massad et al. 2010 doi:10.5194/acp-10-10359-2010
!                   J. Bash Aug 29 12:      The subroutine was modified to utilize new EPIC output that 
!                                           estimates the ammonium content of fertilizer applied to the 
!                                           1cm and 5cm soil layers. 
!                   D. Schwede Sept 12 12:  Added code for NLCD40 land use classification
!                   J. Bash    Apr   4 13:  Brought in new water, agriculture and snow land use 
!                                           classification in LSM_MOD to simplify the case structures
C                   J. Bash:   Nov   7 14:  Modified for the restructuring of vidff.
!                   J. Pleim   Dec   2016:  Revised bidi using gamma from EPIC every day with no mosaic
!                   J. Pleim   April 2018:  Estimate available NH3 frac according to EPIC
!                   D. Wong    Feb.  1 19:  Implemented centralized I/O approach, removed all MY_N
!                                           clauses, and created a new module depv_data_module 
!                                           (model_data_module.F) to hold some of information
!                                           originally stored here to avoid cyclic dependence
C-------------------------------------------------------------------------------

      Implicit None
! shared variables

      Real, Save, Allocatable :: fcec1  ( :,: ) ! Volatility function of CEC from EPIC (Williams 1995) in L1
      Real, Save, Allocatable :: fcec2  ( :,: ) ! Volatility function of CEC from EPIC (Williams 1995) in L2
      
      Real, Save,              Private :: C_gam           ! Canadian fertilizer facter      
      Real, Parameter,         Private :: maxgam   = 1.0e6 ! removed 200000 limit since I can't find any justification
      Real, Parameter,         Private :: natgam   = 20.0  ! Background soil gamma
     
      Contains 
         Subroutine Init_ABFlux( jdate, jtime)
 
         Use HGRD_DEFN           ! horizontal grid specifications
         Use UTILIO_DEFN         
         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2
         Use depv_data_module

         Implicit None 
! Includes
         Include SUBST_CONST     ! constants
         Include SUBST_FILES_ID  ! file name parameters

! Local Variables

         Integer, Intent( In )  :: jdate
         Integer, Intent( In )  :: jtime   
         Integer                :: c,r,l,k
         Integer            :: gxoff, gyoff    ! global origin offset from file
         integer            :: strtcol, endcol, strtrow, endrow
         integer            :: strtcol_medi,  endcol_medi,  strtrow_medi,  endrow_medi
         integer            :: strtcol_fert,  endcol_fert,  strtrow_fert,  endrow_fert
         integer            :: strtcol_beld,  endcol_beld,  strtrow_beld,  endrow_beld
  
         Real                    :: Tot_Ag          ! total ag in the grid cell    
         Real, Parameter :: conv   = 7.142857e-06   ! ha/m**2 * mol/g N 
         Real            :: pHfac1
         Real            :: pHfac2
         Real, Parameter :: d1 = 0.01    ! Top soil layer depth (1 cm); Assume constant for all grid cells
         Real wres1, wres2
         Real tcec1, tcec2

         Character( 16 ), Parameter :: pname = 'Init_ABFlux' 
         Character( 16 )            :: vname
         Character( 96 )            :: xmsg = ' '
 
! Find the Canadian fertilizer factor based off of Sheppard et al 2010 Canadian J. Soil Sci. & 
! Zhang et al. 2010 JGR 
         Select Case( jdate )
            Case(  60:90 )
               C_gam = 811.5
            Case(  91:120 )
               C_gam = 3447.3
            Case( 121:151 )
               C_gam = 8702.8
            Case( 152:181 )
               C_gam = 1269.3
            Case( 182:212 )
               C_gam = 667.1
            Case( 213:243 )
               C_gam = 704.2
            Case( 244:273 )
               C_gam = 811.5
            Case( 274:304 )
               C_gam = 1376.7
            Case( 305:334 )
               C_gam = 1079.6
            Case Default
               C_gam = 630.0
         End Select           
                  
         Beld_ag = 0.01 * Beld_ag   ! convert to fraction

! Allocate variable needed soil processes 
         If ( .Not. Allocated ( gamma1 ) ) Then
            Allocate ( gamma1 ( ncols,nrows ) )
         End If
         gamma1 = 0.0
         If ( .Not. Allocated ( gamma2 ) ) Then
            Allocate ( gamma2 ( ncols,nrows ) )
         End If
         gamma2 = 0.0
         If ( .Not. Allocated ( MHp1 ) ) Then
            Allocate ( MHp1 ( ncols,nrows ) )
         End If         
         MHp1 = 0.0
         If ( .Not. Allocated ( MHp2 ) ) Then
            Allocate ( MHp2 ( ncols,nrows ) )
         End If
         MHp2 = 0.0
         If ( .Not. Allocated ( fcec1 ) ) Then
            Allocate ( fcec1 ( ncols,nrows ) )
         End If
         fcec1 = 0.0
         If ( .Not. Allocated ( fcec2 ) ) Then
            Allocate ( fcec2 ( ncols,nrows ) )
         End If
         fcec2 = 0.0

         ! parameters
            Do r = 1, nrows
               Do c = 1, ncols
                  Tot_Ag = 0.0      
                  tcec1   = 0.0    
                  tcec2   = 0.0
                  Do l = 1, e2c_cats
                     If( .Not. IsNaN( pHs1( c,r,l ) )   .And.
     &                   .Not. IsNaN( pHs2( c,r,l ) )   .And.
     &                   .Not. IsNaN( NH4ps1( c,r,l ) ) .And.
     &                   .Not. IsNaN( NH4ps2( c,r,l ) ) .And.
     &                    Beld_ag( c,r,l ) .Gt. 0.0 ) Then
                        If( pHs1( c,r,l ) .Gt. 0.0 ) Then
                           pHfac1 = 10.0 ** (-pHs1( c,r,l ) )
                           pHfac2 = 10.0 ** (-pHs2( c,r,l ) )
                        Else
                           pHfac1 = 1.0
                           pHfac2 = 1.0
                        End If
! convert units from kg/ha N to mol/l
                        If ( pHs1( c,r,l )   .Gt. 4.0       .And.
     &                       pHs2( c,r,l )   .Gt. 4.0       .And.
     &                       pHs1( c,r,l )   .Lt. 9.0       .And.
     &                       pHs2( c,r,l )   .Lt. 9.0       .And.
     &                       NH4ps1( c,r,l ) .Gt. 0.0       .And.
     &                       NH4ps2( c,r,l ) .Gt. 0.0     ) Then
   
                           wep1(c,r,l) = min (wep1(c,r,l),d1*1000.*por1(c,r,l)) ! don't let SM exceed saturation  
                           wep2(c,r,l) = min (wep2(c,r,l),dep2(c,r,l)*1000.*por2(c,r,l)) 
                           wres1       = 0.0065757 + 0.24909 * wp1(c,r,l) 
                           wres2       = 0.0065757 + 0.24909 * wp2(c,r,l) 
                           wep1(c,r,l) = max (wep1(c,r,l),d1*1000.*wres1)        ! don't let SM below Wres  
                           wep2(c,r,l) = max (wep2(c,r,l),dep2(c,r,l)*1000.*wres2)              
                           Tot_Ag        = Tot_Ag + Beld_ag( c,r,l )                        
                           gamma1( c,r ) = gamma1( c,r ) + conv * NH4ps1( c,r,l )
     &                                   * 1000.0 / (wep1(c,r,l) * pHfac1) * Beld_ag( c,r,l )
                           MHp1( c,r )   = MHp1( c,r ) + Beld_ag( c,r,l ) * pHfac1
                           gamma2( c,r ) = gamma2( c,r ) + conv * NH4ps2( c,r,l )
     &                                   * 1000.0 / (wep2(c,r,l) * pHfac2) * Beld_ag( c,r,l )
                           MHp2( c,r )   = MHp2( c,r ) + Beld_ag( c,r,l ) * pHfac2
                           tcec1         = tcec1        + Beld_ag( c,r,l ) * cec1(c,r,l)
                           tcec2         = tcec2        + Beld_ag( c,r,l ) * cec2(c,r,l)
                        End If
                     End If
                  End Do ! e2c_cats
                  If ( Tot_Ag .ge. 1.0e-6 ) then
                     If ( MHp1( c,r ) / Tot_Ag .Gt. 1.0e-9 .And.
     &                    MHp1( c,r ) / Tot_Ag .Lt. 1.0e-4 .And.
     &                    MHp2( c,r ) / Tot_Ag .Gt. 1.0e-9 .And.
     &                    MHp2( c,r ) / Tot_Ag .Lt. 1.0e-4 ) Then
! get the agricultrual only relevant number
                        MHp1( c,r ) = MHp1( c,r ) / Tot_Ag
                        MHp2( c,r ) = MHp2( c,r ) / Tot_Ag
                        gamma1( c,r ) = gamma1( c,r ) / Tot_Ag
                        gamma2( c,r ) = gamma2( c,r ) / Tot_Ag
! Set a minimum Gamma for Ag based off of Zhang et al. 2010
!                     gamma1( c,r ) = max( gamma1( c,r ), 630.0 )
!                     gamma2( c,r ) = max( gamma2( c,r ), 630.0 )
! NaN trap for debugging
!                        If ( IsNaN( gamma1( c,r ) ) .Or. IsNaN( gamma2( c,r ) ) .Or.
!     &                       IsNaN( MHp2( c,r ) ) .Or. IsNaN( MHp2( c,r ) ) ) Then
!                           xmsg = 'NaN in grid cell Gamma Calculation'
!                           Call M3exit( pname, jdate, jtime, xmsg, xstat1 )
!                        End If
                        tcec1         = tcec1 / Tot_Ag
                        tcec2         = tcec2 / Tot_Ag
                        fcec1(c,r)    = max(0.3, 1.0-0.038*tcec1) ! from EPIC (Wiliams 1995)
                        fcec2(c,r)    = max(0.3, 1.0-0.038*tcec2)
!                        if(r.eq.18.and.c.eq.27) then
!                            Write(Logdev,*) ' Bidi-Epic soil data'
!                            Write(Logdev,*) gamma1(c,r),gamma2(c,r),fcec1(c,r),tcec1
!                        Endif
                     Else
                        MHp1( c,r ) = 0.0
                        MHp2( c,r ) = 0.0
                        gamma1( c,r ) = 0.0
                        gamma2( c,r ) = 0.0
                     Endif
                  Else
                     MHp1( c,r ) = 0.0
                     MHp2( c,r ) = 0.0
                     gamma1( c,r ) = 0.0
                     gamma2( c,r ) = 0.0
                  End If
               End Do ! c
            End Do ! r
         
         Return
!------------------------------------------------------------------------------
! Error handling section
!------------------------------------------------------------------------------
1001     Continue
         Call M3exit( pname, jdate, jtime, xmsg, xstat1 )

C-------------------------------------------------------------------------------
C Format statements.
C-------------------------------------------------------------------------------

9001     Format( 'Failure reading ', a, 1x, 'from ', a )

         Return
         
         End Subroutine Init_ABFlux
                  
!------------------------------------------------------------------------------
! Subroutine to get the soil and canopy compensation point
!------------------------------------------------------------------------------          

         Subroutine Get_Flux( cNH3, rwetsfc, rgw, r, c, l, pvd, lnh3,
     &                         rb,rinc,rstom, delta,rgnd,femis)
         
         Use UTILIO_DEFN
         Use Bidi_Mod, Only: gamma1, gamma2, MHp1, MHp2
         Use ASX_DATA_MOD
         Use LSM_MOD
         
         Implicit None
         
         Include SUBST_FILES_ID  ! file name parameters

         Real,    Intent( IN )  :: cNH3
         Real,    Intent( IN )  :: rwetsfc        
         Real,    Intent( IN )  :: rgw
         Real,    Intent( IN )  :: rb
         Real,    Intent( IN )  :: rinc
         Real,    Intent( IN )  :: rstom
         Real,    Intent( IN )  :: delta
         Real,    Intent( IN )  :: rgnd

         Integer, Intent( IN )  :: r
         Integer, Intent( IN )  :: c
         Integer, Intent( IN )  :: l ! species index
         
         Real,    Intent( OUT ) :: pvd
         Real,    Intent( OUT ) :: lnh3
         Real,    Intent( OUT ) :: femis
         
         Real( 8 )              :: aq           ! Quadradic equation variable
         Real( 8 )              :: bq           ! Quadradic equation variable
         Real                   :: cnh3c        ! In canopy NH3 concentration [ppm]
         Real                   :: cnh3g1, cnh3g2, cnh3g   ! NH3 compensation concentration for ground [ppm]
         Real                   :: cnh3s        ! NH3 compensation concentration for stomatal [ppm]
         Real                   :: cnh3g1j, cnh3g2j, cnh3sj
         Real( 8 )              :: cq           ! Quadradic equation variable
         Real                   :: del0         ! for Rbg
         Real( 8 )              :: ga           ! Ga = 1/Ra [m/s]
         Real                   :: gammas       ! [NH4+]/[H+]
         Real( 8 )              :: gcw
         Real( 8 )              :: gg1 !( n_lufrac ) ! Gg = 1/(Rgnd(nh3)+Rinc) [m/s]  
         Real( 8 )              :: gsb          ! Gsb = 1/(Rstom(nh3)+Rb(nh3)) [m/s]
         Real( 8 )              :: gt
         Real( 8 )              :: qq           ! intermediate variable
         Real                   :: rbg  !j( n_lufrac )
!        Real,        Parameter :: rwm = 35.0   ! Minimum NH3 cuticle resistance [s/m]
         Real,        Parameter :: rwm = 20.0   ! Minimum NH3 cuticle resistance [s/m]
         Real                   :: rwmb         ! Rwmb = Rwm + Rb
         Real                   :: rwx          ! Rw = Rwm + Rwx * CNH3C [s/m]
         Real                   :: scn          ! for Rbg
         Real                   :: ustg         ! for Rbg
         Real                   :: vdg          ! Vd(nh3) to non-veg part [m/s]
         Real                   :: w5cm         ! soil moisture in top 5 cm (vol frc)
         Real,        Parameter :: d1 = 0.01    ! Top soil layer depth (1 cm)
         Real,        Parameter :: twothree = 2.0/3.0
         Real,        Parameter :: onethree = 1.0/3.0
         Real,        Parameter :: MolN     = 14.007  ! g/mol N
!         Real,        Parameter :: MolNH3   = 17.01  ! g/mol NH3
         Real( 8 )              :: ldry
         Real( 8 )              :: dp
         Real( 8 )              :: rsoil1
         Real( 8 )              :: rsoil2
         Real( 8 )              :: a1
         Real                   :: agfrac
         Real( 8 )              :: ddd
         Real                   :: watfrac ! water fraction
         Integer                :: k,j
         Real                   :: canfrac
         Real                   :: frac_sol1    ! Fraction of NHx in solution layer 1
         Real                   :: frac_sol2    ! Fraction of NHx in solution layer 2
         Real                   :: cnh3cdep
         Real                   :: cnh3cemis, rcut, gwd

         canfrac = 0.5    !exp(-1.)   

!> Compute quasi-laminar boundary layer resistance at the soil surface

         scn  = kvis / dif0( l )
         ustg = max( MET_DATA%USTAR( c,r ) * EXP( -MET_DATA%LAI( c,r ) ), 0.001 )         
         del0 = 1.0E-4 * kvis / ( karman * ustg )
         rbg = ( scn - LOG( 10.0 * del0 ) ) / ( karman * ustg )


!-- Compute soil resitance using soil moitsure in soil layer 1 (1 cm) from WRF
         ldry= d1 * ( Exp( ( 1.0 - MET_DATA%SOIM1( c,r ) / GRID_DATA%WSAT( c,r ) ) ** 5 ) - 1.0 ) / 1.718
         
         dp  = dif0( l ) * 1.0E-4 * GRID_DATA%WSAT( c,r )**2
     &       * ( 1.0 - GRID_DATA%WRES(c,r) / GRID_DATA%WSAT(c,r) ) ** ( 2.0 + 3.0 / GRID_DATA%BSLP(c,r) )
         
         rsoil1 = ldry / dp
         
         w5cm = 0.2 * MET_DATA%SOIM1( c,r ) + 0.8 * MET_DATA%SOIM2( c,r )
         w5cm = Min( w5cm, GRID_DATA%WSAT( c,r ) )
         w5cm = Max( w5cm, GRID_DATA%WRES( c,r ) )
          


         agfrac  = 0.0
         watfrac = 0.0
         pvd     = 0.0
         lnh3    = 0.0

!> If the soil is frozen assume not evasive flux and skip calculation of comp. points         
         If ( MET_DATA%Tempg( c,r ) .Le. 273.15 ) Then
            cnh3s  = 0.0
            cnh3g = 0.0
            Go To 101
         End If

!> Compute compensation point. gamma is specified according to the amount of 
!> cultivated vegetation  
             
         a1    = 161512.0d0 / real( MET_DATA%tempg( c,r ), 8 )
     &         * 10.0d0 ** ( -4507.11d0 / real( MET_DATA%tempg( c,r ), 8 ) )
         a1    = a1 * 17.0d9    ! microgram/m3  24.5d0 * 1.0d6  ! ppm    
         
!> Set a maximum [NH4]/[H+] ratio at 200,000 based on output from the AIM aerosol
!> model any [NH4] in excess of this ratio is assumed to partition into the solid
!> phase. Canada soil gamma taken from Zhang et al 2010 JGR Table 5

         cnh3g1 = 0.0
         cnh3g2 = 0.0
         cnh3s = 0.0
!---- removed division of gamma by soil moisture -- jep 12/16
         Do j = 1, n_lufrac
            If ( GRID_DATA%LUFRAC( c,r,j ) .Gt. 0.0 ) Then
               cnh3sj = a1 * luf_fac( j )
               Select Case( cat_lu( j ) )
                  Case( 'WATER' ) ! water
                     cnh3g1j = 0.0
                     cnh3g2j = 0.0
                     cnh3sj  =0.0
                     watfrac = watfrac + GRID_DATA%LUFRAC( c,r,j )
                  Case( 'SNOWICE' ) ! ice or snow
                     cnh3g1j = 0.0
                     cnh3g2j = 0.0
                     cnh3sj  =0.0
!---- Gamma soil 
                  Case( 'AG','AGMOS' ) ! Ag
                      if (fcec1(c,r).gt. 0.299 ) Then                
                        frac_sol1= fcec1(c,r) 
                        frac_sol2= fcec2(c,r)
                      else
                        frac_sol1= 0.55
                        frac_sol2= 0.55
                      endif
                     
                    if( cat_lu( j ).eq.'AG' ) then   ! Ag
                        cnh3g1j = Min( Max( frac_sol1*gamma1( c,r ), C_gam / MET_DATA%SOIM1( c,r ) ),
     &                                     maxgam)

                        cnh3g2j = Min( Max( frac_sol2*gamma2( c,r ), C_gam / w5cm), 
     &                                     maxgam )
                        agfrac  = agfrac  + GRID_DATA%LUFRAC( c,r,j )
                     else                             ! Ag mosaic 67% ag 33% mosaic 
                        cnh3g1j = Min( Max( frac_sol1*gamma1( c,r ), C_gam / MET_DATA%SOIM1( c,r ))
     &                                    * twothree + onethree * natgam , maxgam )
                        cnh3g2j = Min( Max( frac_sol2*gamma2( c,r ), C_gam / w5cm )
     &                                    * twothree + onethree * natgam , maxgam )
                        agfrac  = agfrac  + twothree * GRID_DATA%LUFRAC( c,r,j )
                     endif

                  Case Default ! not ag
                     cnh3g1j = Min( natgam , maxgam )
                     cnh3g2j = Min( natgam , maxgam )
               End Select
               cnh3g1  = cnh3g1 + GRID_DATA%LUFRAC( c,r,j ) * cnh3g1j             
               cnh3g2  = cnh3g2 + GRID_DATA%LUFRAC( c,r,j ) * cnh3g2j
               cnh3s   = cnh3s  + GRID_DATA%LUFRAC( c,r,j ) * cnh3sj
            End If
         End Do
         cnh3g1 = a1 * Max( cnh3g1, 0.01 ) / (1.0 - watfrac)   ! Land only (microgram/m3)
         cnh3g2 = a1 * Max( cnh3g2, 0.01 ) / (1.0 - watfrac)   ! Land only (microgram/m3)
         cnh3g  = Max (cnh3g1, cnh3g2)   ! use greater of layer concs
         cnh3s = cnh3s / (1.0 - watfrac)   ! Land only (microgram/m3)
!         if(agfrac.GT.0.5.and.gamma1( c,r ).gt.50000.) then
!            write(logdev,*) ' frac_sol1',frac_sol1,' cnh3g1',cnh3g1,' gamma1',gamma1( c,r )
!            write(logdev,*) ' c,r=',c,r,' gamma2',gamma2( c,r )
!         endif
101      Continue

!> Cuticle resistance : rw = rwx * cnh3c + rwm
         If ( MET_DATA%LAI( c,r ) .Gt. 0.0 ) Then

            rwx   = rwetsfc   
            rwmb  = rwm + rwx + (100.0-max(MET_DATA%RH2( c,r ),60.0) + Rb) * MET_DATA%LAI( c,r )  ! from Pleim et al 2013 JGR
            ga    = 1.0 / ( MET_DATA%RA( c,r ) + canfrac * rinc ) !
            gsb   = 1.0 / ( rstom + rb )
            gg1   = 1.0 / ( rbg + (1.-canfrac) * rinc + rsoil1 )
            gcw   = 1.0 / ( rb + rwetsfc/MET_DATA%LAI( c,r ) )
            gt    = gsb + gg1  + ga + delta * gcw   ! single soil layer
            qq    = ga * cnh3 + gsb * cnh3s + gg1 * cnh3g 
            aq    = rwx * gt
            bq    = rwmb * gt + MET_DATA%LAI( c,r ) * ( 1.0 - delta ) - rwx * qq
            cq    = -rwmb * qq
! Microg/m3
            cnh3c = (-bq + sqrt( bq**2 - 4.0d0 * aq * cq))/(2.0d0 * aq)  ! this should always yield non-negative result
           
! if the compensation point less than zero reset it to zero
            cnh3c = max( cnh3c, 0.0 )   

!-- compute emission component using cnh3c from bidi flux for Rcut
!         rcut = rwm + rwx*(cnh3c+1.) + (100.0-max(MET_DATA%RH( c,r ),60.0) + Rb) * MET_DATA%LAI( c,r )
            rcut = rwmb + rwx* cnh3c
            gwd = ( 1.0 - delta )* MET_DATA%LAI( c,r )/rcut
            cnh3cemis = (gsb * cnh3s + gg1 * cnh3g)/( gt + gwd)
         else
            cnh3c = 0.0
            cnh3cemis = 0.0

         End If  ! lai > 0.0

         ddd = ( 1.0 - delta ) / rgnd
     &       + delta / rgw

         vdg = 1.0 / ( MET_DATA%RA( c,r ) + rb + 1.0 / ddd )

         pvd  = cnh3c * ga * MET_DATA%VEG( c,r )                  ! microg/m2/s
         lnh3  = vdg + MET_DATA%VEG( c,r ) * ( ga - vdg )
         femis  = ga*(cnh3cemis)*MET_DATA%VEG( c,r ) 

!         if(r.eq.18.and.c.eq.27) then
!            Write(Logdev,*) ' Bidi-Epic conc'
!            Write(Logdev,*) cnh3g1,cnh3g2,cnh3g,cnh3s,cnh3c,cnh3
!            Write(Logdev,*) agfrac,rsoil1,MET_DATA%VEG( c,r ),ga,rbg
!          Endif
 

         Return        
         End Subroutine Get_Flux


         Logical Function IsNaN( a ) ! required for Portland Group compiler (pgi)
            Real :: a
            If ( a .Eq. a ) Then   ! requires -Kieee flag for pgi
!              write( *,* ) '==IsNaN false: ', a
               IsNaN = .false.
            Else
!              write( *,* ) '==IsNaN true: ', a
               IsNaN = .true.
            End If
            Return
         End Function IsNaN  ! error, if pgf90
!        End  ! error, if ifort

      End Module ABFlux_Mod

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
#ifdef isam
      SUBROUTINE RESCLD ( CGRID, JDATE, JTIME, TSTEP,
     &                    N_SPC_WDEP, WDEP_MAP, DEP, RESTRANS,
     &                    SA_DEP)

#else
      SUBROUTINE RESCLD ( CGRID, JDATE, JTIME, TSTEP,
     &                    N_SPC_WDEP, WDEP_MAP, DEP, RESTRANS )
#endif

C-----------------------------------------------------------------------
C  FUNCTION: Resolved-scale CLOUD processor Models-3 science process:
 
C  Revision History:
C      No   Date   Who   What
C      -- -------- ---  -----------------------------------------
C       0 01/15/98 sjr  created program
C       1 03/09/98 sjr  made several revisions: fix to read sub-hourly
C                       rainfall data, reordered some of the code
C       2 12/15/98 David Wong at LM
C           -- changed division of GPKG to multiplication of GPKG reciprocal
C           -- interchanged loops structure in line 317
C       3 03/18/99 David Wong at LM
C           -- replace "* M2PHA * ONE_OVER_GPKG" by "* M2PHA_OVER_GPKG" which
C              is a new constant defined as M2PHA / GPKG
C       4 08/30/99 sjr  revised for new aerosol model (with 2nd moments)
C       5 Dec 00   Jeff move CGRID_MAP into f90 module
C       6 01/04/01 sjr  added QS and QI to total water content calcul.
C       7 Sep 01   Jeff Dyn Alloc - Use HGRD_DEFN
C       8 12/18/03 sjr & jp added QG in the water content calc
C       9 07 Dec 04 J.Young: Vert Dyn Alloc - Use VGRD_DEFN
C      10 31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                            domain specifications in one module
C      11 25 Mar 08 sjr fixed bug in the precipitation flux calculation:
C                       layer thickness now included in column integrated
C                       water content and in precipitation flux 
C                       calculations (bug reported by Raymond D Wright)
C      12 12 Aug 10 J.Young: replace CGRID mechanism include files with
C                    namelists and merge Shawn Roselle's, Sergey Napelenok's
C                    and Steve Howard's aerosol reengineering
C      13 01 Mar 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                    removed deprecated TRIMLEN
C      14 11 May D.Wong: incorporated twoway model implementation
C      15 01 Jul 11 G. Sarwar: calculate zenith angle to determine daytime and  
C                    nightime needed for sulfur oxidation via metal catalysis
C      16 02Aug12 S.Roselle:  instrumented to calculate and return
C                             transmissivity for resolved clouds
C      07 Nov 14 J.Bash: Updated call to czangle.F for the ASX_DATA_MOD shared data module. 
C      07 May 18 D. Schwede: Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C      26 Nov 18 S. Napelenok: ISAM implementation
C       1 Feb 19 D. Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses
C      01 AUG 19 D. Wong: Modified code to work with two-way model
C      11 Nov 19 F. Sidi: Changed MSTEP to accomdate Centralized I/O changesC      
C      30 Dec 19 S. Napelenok: ddm-3d implementaiton for version 5.3.1


C  Called by:  CLDPROC
 
C  Calls the following subroutines:  SCAVWDEP and AQ_MAP
C-----------------------------------------------------------------------

      USE RUNTIME_VARS, ONLY: STM
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      USE AQ_DATA,       ONLY: JH2O2_HYDROMETEORS,  JHNO3_HYDROMETEORS
      USE AERO_DATA, ONLY : ASO4GAS_IDX, MAP_AERO, AEROSPC_MAP
      USE PRECURSOR_DATA, ONLY: SULF_IDX, PRECURSOR_MAP, MAP_PRECURSOR
      USE ASX_DATA_MOD,  ONLY: MET_DATA
      USE PHOT_MOD,      ONLY: RJ, RJ_RES, RJ_SUB, LH2O2, LHNO3
      USE CENTRALIZED_IO_MODULE
#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, NTAG_SA, SPC_INDEX, OTHRTAG, 
     &                   SPC_NAME, DEPSUM_SAVE, DS4_SAVE, REMOV_SAVE,
     &                   ITAG

#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NP, NPMAX, S_CONDEP, S_POLC, 
     &                      S_CEND, S_REMOV, S_REMOVAC, S_CONDEP, 
     &                      S_TOTDEP
#endif 



      IMPLICIT NONE

C...........Includes:

      INCLUDE SUBST_CONST                ! constants
      INCLUDE SUBST_FILES_ID             ! file name parameters

C...........Arguments:
      REAL, POINTER            :: CGRID( :,:,:,: ) ! concentrations
      INTEGER, INTENT( IN )    :: JDATE            ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )    :: JTIME            ! current model time, coded HHMMSS
      INTEGER, INTENT( IN )    :: TSTEP( 3 )       ! model time steps, coded HHMMSS
      INTEGER, INTENT( IN )    :: N_SPC_WDEP       ! # of wet deposition species
      INTEGER, INTENT( IN )    :: WDEP_MAP( : )    ! wet deposition species map to CGRID
      REAL,    INTENT( INOUT ) :: DEP( :,:,: )     ! wet deposition
      REAL,    INTENT( OUT )   :: RESTRANS( :,: )  ! resolved cloud transmissivity
#ifdef isam
      REAL,    INTENT( INOUT ) :: SA_DEP( :,:,:,: )
#endif

      CHARACTER( 120 ) :: XMSG  = ' '    ! Exit status message

C...........Parameters:
      REAL, PARAMETER :: PERMIN_TO_PERSEC = 1.0 / 60.0
      REAL, PARAMETER :: GPKG = 1.0E+03  ! g/kg
      REAL, PARAMETER :: M2PHA = 1.0E+04 ! 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: M2PHA_OVER_GPKG = M2PHA / GPKG

C Number of species in CGRID
      INTEGER, SAVE :: MXSPCS


C...........Local Variables:

      LOGICAL, SAVE :: FIRSTIME = .TRUE.   ! flag for first pass thru

      CHARACTER( 16 ), SAVE :: PNAME = 'RESCLD'    ! process name
      CHARACTER( 16 ), SAVE :: VNAME_RN

      INTEGER       COL                 ! column loop counter
      INTEGER       ROW                 ! row loop counter
      INTEGER       LAY                 ! layer loop counter
      INTEGER       FINI                ! ending position
      INTEGER       MDATE               ! process date (yyyyddd)
      INTEGER, SAVE :: MSTEP            ! met file time step (hhmmss)
      INTEGER       MTIME               ! process time (hhmmss)
      INTEGER, SAVE :: SDATE            ! met file start date
      INTEGER       SPC                 ! liquid species loop counter
      INTEGER       STRT                ! starting position
      INTEGER, SAVE :: STIME            ! met file start time
      INTEGER       TCLD                ! cloud lifetime (sec)
      INTEGER       VAR                 ! variable loop counter
      INTEGER       ALLOCSTAT           ! memory allocation status

      REAL          AIRM                ! total airmass (mol/m2) in cloudy air
      REAL          ALFA0               ! aitken mode number scavenging coef
      REAL          ALFA2               ! aitken mode sfc area scavenging coef
      REAL          ALFA3               ! aitken mode mass scavenging coef
      REAL          CTHK1               ! cloud thickness (m)
      REAL          METSTEP             ! timestep on the met file (hr)
      SAVE          METSTEP
      REAL          PBARC               ! mean cloud pressure (Pa)
      REAL          PRATE1              ! storm rainfall rate (mm/hr)
      REAL          QCRGCOL             ! vert column integrated liquid water content
      REAL          QCRISGCOL           ! vert column integrated total water content
      REAL          QRSGCOL             ! vert column integrated precip content
      REAL          QCICOL              ! vert column integrated cloud content
      REAL          RAIN                ! non-conv rainfall rate (mm/hr)
      REAL          REMOVAC             ! variable storing H+ deposition
      REAL          TAUCLD              ! cloud lifetime (sec)
      REAL          TBARC               ! mean cloud temp (K)
      REAL          WCBAR               ! liq water content of cloud (kg/m3)
      REAL          WPBAR               ! precipitation water content (kg/m3)
      REAL          WTBAR               ! total water content of cloud (kg/m3)
      REAL          LWP, CLOD

      REAL, ALLOCATABLE, SAVE :: POLC ( : )   ! incloud conc (mol/mol)
      REAL, ALLOCATABLE, SAVE :: CEND ( : )   ! ending conc (mol/mol)
      REAL, ALLOCATABLE, SAVE :: REMOV( : )   ! moles/m2 or mm*mol/lit scavenged

      REAL          RN   ( NCOLS, NROWS ) ! non-convective rainfall (cm)
      REAL          DENS ( NCOLS, NROWS, NLAYS )  ! air density (kg/m3)
      REAL          DZZ  ( NCOLS, NROWS, NLAYS )  ! layer thickness (m)
      REAL          PRES ( NCOLS, NROWS, NLAYS )  ! air pressure (Pa)
      REAL          QC   ( NCOLS, NROWS, NLAYS )  ! cloud water content (kg/kg)
      REAL          QG   ( NCOLS, NROWS, NLAYS )  ! graupel content (kg/kg)
      REAL          QI   ( NCOLS, NROWS, NLAYS )  ! ice content (kg/kg)
      REAL          QR   ( NCOLS, NROWS, NLAYS )  ! rain water content (kg/kg)
      REAL          QS   ( NCOLS, NROWS, NLAYS )  ! snow content (kg/kg)
      REAL          TA   ( NCOLS, NROWS, NLAYS )  ! air temperature (K)
      REAL          ZF   ( NCOLS, NROWS, NLAYS )  ! level/layer-face height (m)

C Gridded meteorology data:
C Latitude and longitude for zenith angle calculation: Golam Sarwar * July 1, 2011 
      REAL          COSZ                            ! local cosine of zenith angle
      REAL          JH2O2                           ! H2O2 photolysis rate, 1/min 
      REAL          JHNO3                           ! HNO3 photolysis rate, 1/min 
      LOGICAL       DARK                            ! DARK = TRUE is night,  DARK = FALSE is day

#ifdef isam
      INTEGER, SAVE           :: S_SO2, S_SO4J, S_SULF
      INTEGER, SAVE           :: C_SO2, C_SO4J, C_SULF
      REAL, ALLOCATABLE, SAVE :: SA_POLC   ( :,: )
      REAL, ALLOCATABLE, SAVE :: SA_CEND   ( :,: )
      INTEGER                 :: CSPC
      REAL, ALLOCATABLE, SAVE :: SA_DS4    ( : )
      REAL                    :: SA_SUM
      REAL, ALLOCATABLE, SAVE :: SA_REMOV  ( :,: )
#endif

C...........External Functions:

      INTERFACE
        SUBROUTINE SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                        CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                        REMOV, REMOVAC, ALFA0, ALFA2, ALFA3 )
           INTEGER, INTENT( IN )  :: JDATE, JTIME
           REAL,    INTENT( IN )  :: WTBAR, WCBAR, TBARC, PBARC,
     &                               CTHK1, AIRM, PRATE1, TAUCLD
           REAL,    INTENT( IN )  :: POLC ( : )
           REAL,    INTENT( OUT ) :: REMOVAC
           REAL,    INTENT( OUT ) :: CEND( : ), REMOV( : )
           REAL,    INTENT( OUT ) :: ALFA0, ALFA2, ALFA3
        END SUBROUTINE SCAVWDEP
        SUBROUTINE AQ_MAP( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                     CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                     REMOV, REMOVAC, ALFA0, ALFA2, ALFA3, DARK )
           INTEGER, INTENT( IN )    :: JDATE, JTIME
           REAL,    INTENT( IN )    :: WTBAR, WCBAR, TBARC, PBARC,
     &                                 CTHK1, AIRM, PRATE1, TAUCLD
           REAL,    INTENT( IN )    :: POLC ( : )
           REAL,    INTENT( INOUT ) :: REMOVAC
           REAL,    INTENT( INOUT ) :: CEND( : ), REMOV( : )
           REAL,    INTENT( IN )    :: ALFA0, ALFA2, ALFA3
           LOGICAL, INTENT( IN )    :: DARK                  !Golam Sarwar, July 1, 2011
        END SUBROUTINE AQ_MAP
      END INTERFACE
C-----------------------------------------------------------------------

C...Initialization

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

C...Sulfur tracking
        IF ( STM ) THEN
          CALL MAP_AERO()
          CALL MAP_PRECURSOR()
        END IF

        IF (RNA_AVAIL) THEN
           VNAME_RN = 'RNA'
        ELSE
           VNAME_RN = 'RN'
        END IF

C...store met file time, date, and step information and compute
C...  the met timestep in hours

        SDATE = cio_model_sdate
        STIME = cio_model_stime
        MSTEP = file_tstep(f_met)

        METSTEP = FLOAT( TIME2SEC( MSTEP ) ) / 3600.0

        if ( .not. QI_AVAIL) then
          write (logdev, '(a)') 'Parameter QI (cloud ice) was not found on file '
          WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &           'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &           'in the Meteorological Model did not include ice/snow.  If',
     &           'it did, then you need to reprocess the meteorological data',
     &           'through MCIP and pass QI to file ',
     &           TRIM( MET_CRO_3D ), ' to avoid',
     &           'errors in the wet deposition.'
          WRITE( LOGDEV, '((/5X,A),/)' )
     &           'Processing will continue with QI set to ZERO.  <<---<<'
        END IF

        if ( .not. QS_AVAIL) then
          write (logdev, '(a)') 'Parameter QS (snow) was not found on file '
          WRITE( LOGDEV, '(3(/10X,A),(/10X,3(A,1X)),(/10X,A))' )
     &           'YOU SHOULD VERIFY that the cloud microphysics scheme used',
     &           'in the Meteorological Model did not include ice/snow.  If',
     &           'it did, then you need to reprocess the meteorological data',
     &           'through MCIP and pass QS to file ',
     &           TRIM( MET_CRO_3D ), ' to avoid',
     &           'errors in the wet deposition.'
          WRITE( LOGDEV, '((/5X,A),/)' )
     &           'Processing will continue with QS set to ZERO.  <<--<<'
        END IF

        MXSPCS = N_GC_SPCD + N_AE_SPC + N_NR_SPC + N_TR_SPC

        ALLOCATE ( CEND ( MXSPCS ),
     &             POLC ( MXSPCS ),
     &             REMOV( MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CEND, POLC or REMOV'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#ifdef isam
! move all this somewhere else eventually

        S_SO2  = INDEX1( 'SO2', NSPC_SA, SPC_NAME(:,OTHRTAG) )
        S_SO4J = INDEX1( 'ASO4J', NSPC_SA, SPC_NAME(:,OTHRTAG) )
        S_SULF = INDEX1( 'SULF', NSPC_SA, SPC_NAME(:,OTHRTAG) )

        C_SO2  = INDEX1( 'SO2',   N_GC_SPC, GC_SPC )
        C_SO4J = INDEX1( 'ASO4J', N_AE_SPC, AE_SPC ) + 1 + N_GC_SPC
        C_SULF = INDEX1( 'SULF',  N_GC_SPC, GC_SPC )

        ALLOCATE ( SA_POLC  ( NSPC_SA, NTAG_SA ),
     &             SA_CEND  ( NSPC_SA, NTAG_SA ),
     &             SA_DS4   ( NTAG_SA ),
     &             SA_REMOV ( NSPC_SA, NTAG_SA ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SA_POLC or SA_CEND'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
#endif

#ifdef sens
        IF ( .NOT. ALLOCATED( S_CEND ) ) ALLOCATE ( S_CEND ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_CEND'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_POLC ) ) ALLOCATE ( S_POLC ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_POLC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_REMOV ) ) ALLOCATE ( S_REMOV ( NPMAX, MXSPCS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOV'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( .NOT. ALLOCATED( S_REMOVAC ) ) ALLOCATE ( S_REMOVAC ( NPMAX ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_REMOVAC'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF 
        S_REMOVAC = 0.0
#endif

      END IF  ! FIRSTIME

      MDATE = JDATE
      MTIME = JTIME

C...set the cloud lifetime (=adv timestep)

      TCLD = TIME2SEC( TSTEP( 2 ) )
      TAUCLD = REAL( TCLD )

C...set time to the midpoint of this timestep for data interpolation

      CALL NEXTIME ( MDATE, MTIME, SEC2TIME( TCLD / 2 ) )

C...Actual Science Process (loop on internal process time steps):
C...  Interpolate time dependent layered input variables
C...  (reading those variables for which it is necessary)

C...  Get ambient temperature (K)

      call interpolate_var ('TA', mdate, mtime, TA)

C...Get resolved cloud water mixing ratio (kg H2O / kg air)

      call interpolate_var ('QC', MDATE, MTIME, QC )

C...Get resolved rain water mixing ratio (kg H2O / kg air)

      call interpolate_var ('QR', MDATE, MTIME, QR )

C...read resolved ice mixing ratio (kg H2O / kg air) from the met
C...  file if it is available

      IF ( QI_AVAIL ) THEN

        call interpolate_var ('QI', MDATE, MTIME, QI )

      ELSE

        QI = 0.0    ! otherwise fill the array with zeros

      END IF

C...read resolved snow mixing ratio (kg H2O / kg air) from the met
C...  file if it is available

      IF ( QS_AVAIL ) THEN

        call interpolate_var ('QS', MDATE, MTIME, QS )

      ELSE

        QS = 0.0    ! otherwise fill the array with zeros

      END IF

C...read graupel mixing ratio (kg H2O / kg air) from the met
C...  file if it is available

      IF ( QG_AVAIL ) THEN

         call interpolate_var ('QG', MDATE, MTIME, QG )

      ELSE

        QG = 0.0    ! otherwise fill the array with zeros

      END IF

C...Get level heights / layer faces (m)

      call interpolate_var ('ZF', MDATE, MTIME, ZF )

C...Get pressure (Pa)

      call interpolate_var ('PRES', MDATE, MTIME, PRES )

C...Get air density (kg/m3)

      call interpolate_var ('DENS', MDATE, MTIME, DENS )

C...compute layer thicknesses (m)

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS
          DZZ( COL, ROW, 1 ) = ZF( COL, ROW, 1 )
          DO LAY = 2, NLAYS
            DZZ( COL, ROW, LAY ) = ZF( COL, ROW, LAY )
     &                           - ZF( COL, ROW, LAY - 1 )
          END DO
        END DO
      END DO

C...advance the MDATE and MTIME to the next time on the met file
C...  to get ready to read the precipitation amounts.
C...  Precipitation data WILL NOT BE INTERPOLATED!  Precipitation data
C...  on the input file are amounts within the metfiles timestep.

      IF ( .NOT. CURRSTEP( JDATE, JTIME, SDATE, STIME, MSTEP,
     &                     MDATE, MTIME ) ) THEN
        XMSG = 'Cannot get step-starting date and time'
        CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
      END IF

      CALL NEXTIME ( MDATE, MTIME, MSTEP )  ! set mdate:mtime to the hour

C...Get nonconvective precipitation amount (cm)

      call interpolate_var (VNAME_RN, MDATE, MTIME, RN )

C...Loop through all grid cells

      DO ROW = 1, NROWS
        DO COL = 1, NCOLS

C...Convert the rainfall into a rainfall rate (mm/hr)

          RAIN = 10.0 * RN( COL, ROW ) / METSTEP

          IF ( RAIN .LT. 0.0 ) THEN
            XMSG = 'NEGATIVE RAIN...PROBABLE BAD MET DATA...'
     &              // MET_CRO_2D
            CALL M3EXIT ( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
          END IF

C...calculate the integrated column cloud+rain water content
C... JP & SJR:  treat graupel as rainwater until we have a more
C...            advanced cloud microphysics scheme
C... include layer thickness in the column integration

          QCRGCOL   = 0.0
          QCRISGCOL = 0.0
          QRSGCOL   = 0.0
          QCICOL    = 0.0
          DO LAY = 1, NLAYS
            QC( COL, ROW, LAY ) = MAX( QC( COL, ROW, LAY ), 0.0 )
            QR( COL, ROW, LAY ) = MAX( QR( COL, ROW, LAY ), 0.0 )
            QI( COL, ROW, LAY ) = MAX( QI( COL, ROW, LAY ), 0.0 )
            QS( COL, ROW, LAY ) = MAX( QS( COL, ROW, LAY ), 0.0 )
            QG( COL, ROW, LAY ) = MAX( QG( COL, ROW, LAY ), 0.0 )
            QCRGCOL   = QCRGCOL   + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) )
            QCRISGCOL = QCRISGCOL + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QI( COL, ROW, LAY ) + QS( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) )
            QRSGCOL   = QRSGCOL   + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QR( COL, ROW, LAY ) + QS( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) )
            QCICOL    = QCICOL + DENS( COL, ROW, LAY )
     &                * DZZ( COL, ROW, LAY )
     &                * ( QC( COL, ROW, LAY ) + QI( COL, ROW, LAY ) )
          END DO

C...Calculate the cloud optical depth using a formula derived from
C...  Stephens (1978), JAS(35), pp2111-2132.
C...  only calculate the cloud optical depth when the liquid water
C...  path is >= 10 g/m2

          LWP = QCICOL * 1000.0  ! converts to g/m2
          IF ( LWP .GE. 10.0 ) THEN
             CLOD = 10.0**( 0.2633 + 1.7095 * LOG( LOG10( LWP ) ) )
          ELSE
             CLOD = 0.0
          END IF

C...If no cloud or optical depth < 5, set clear sky values.
C...  (i.e. don't do anything)

          IF ( CLOD .GE. 5.0 ) THEN

             RESTRANS( COL, ROW ) = ( 5.0 - EXP ( -CLOD ) ) / ( 4.0 + 0.42 * CLOD )
              
          END IF

C...loop through layers

          IF ( QCRGCOL .GT. 0.0 ) THEN
            DO LAY = 1, NLAYS

C...Compute cloud quantities

              IF ( ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &               + QG( COL, ROW, LAY ) ) .GT. 0.00005 ) THEN

                TBARC = TA( COL, ROW, LAY )

                PBARC = PRES( COL, ROW, LAY )

                CTHK1 = DZZ( COL, ROW, LAY )

                AIRM = PBARC * CTHK1 * 1.0E3 / ( RDGAS * MWAIR * TBARC )

                WCBAR = ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QG( COL, ROW, LAY ) ) * DENS( COL, ROW, LAY )

                WTBAR = ( QC( COL, ROW, LAY ) + QR( COL, ROW, LAY )
     &                +   QI( COL, ROW, LAY ) + QS( COL, ROW, LAY ) 
     &                +   QG( COL, ROW, LAY ) ) * DENS( COL, ROW, LAY )

C...Compute precipitation flux
C...  include layer thickness in the calculation

                IF ( QRSGCOL .GT. 0.0 ) THEN
                  WPBAR = ( QR( COL, ROW, LAY ) + QS( COL, ROW, LAY )
     &                  +   QG( COL, ROW, LAY ) ) * DENS( COL, ROW, LAY )
                  PRATE1 = RAIN * WPBAR * CTHK1 / QRSGCOL  ! convert to mm/hr
                ELSE
                  PRATE1 = RAIN * WTBAR * CTHK1 / QCRISGCOL  ! convert to mm/hr
                END IF

C...Finally, get in-cloud pollutant concentrations in moles sp
C...  per mole air

                DO SPC = 1, NSPCSD
                  POLC ( SPC ) = CGRID( COL, ROW, LAY, SPC )
                  CEND ( SPC ) = POLC( SPC )
                  REMOV( SPC ) = 0.0
                END DO

#ifdef isam
                DO SPC = 1, NSPC_SA
                  DO ITAG = 1, NTAG_SA
                    SA_POLC( SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG )
                    SA_CEND( SPC, ITAG ) = SA_POLC( SPC, ITAG )
                    SA_REMOV( SPC, ITAG ) = 0.0
                  END DO
                END DO
#endif 

#ifdef sens
                DO NP = 1, NPMAX
                  DO SPC = 1, NSPCSD
                    S_POLC ( NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC )
                    S_CEND ( NP, SPC ) = S_POLC( NP, SPC)
                    S_REMOV( NP, SPC ) = 0.0
                  END DO
                END DO
#endif

C...perform scavenging and aqueous chemistry within the cloud
C...  and re-adjust the ending and removed amounts for those species
C...  that were scavenged or that participated in cloud chemistry

                CALL SCAVWDEP ( JDATE, JTIME, WTBAR, WCBAR, TBARC,
     &                          PBARC, CTHK1, AIRM, PRATE1, TAUCLD,
     &                          POLC, CEND, REMOV, REMOVAC, ALFA0,
     &                          ALFA2, ALFA3 )

#ifdef isam
                DO SPC = 1, NSPC_SA
                  CSPC = SPC_INDEX(SPC,2)
c                 IF ( POLC( CSPC ) .GT. 1.0E-30 .AND. CEND( CSPC ) .GT. 1.0E-09 ) THEN
                  IF ( POLC( CSPC ) .GT. 1.0E-30 ) THEN
                    DO ITAG = 1, NTAG_SA
                      SA_CEND( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                     * ( CEND( CSPC )
     &                                       / POLC( CSPC ) )
                      SA_REMOV( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                      * ( REMOV( CSPC )
     &                                        / POLC( CSPC ) )
                    END DO
                  ELSE ! no update
                    DO ITAG = 1, NTAG_SA
                      SA_CEND( SPC, ITAG )  = 0.0
                      SA_REMOV( SPC, ITAG ) = 0.0
                    END DO
                  END IF
                END DO
#endif

C...if the liquid water content is above the specified threshold
C...  then perform the aqueous chemistry within the cloud and
C...  re-adjust the ending and removed amounts for those species
C...  that participated in cloud chemistry

                IF ( WCBAR .GT. 0.00001 ) THEN

C...  calculate cosine of zenith angle for the cell and determine day or night; Golam Sarwar 

                  COSZ = MET_DATA%COSZEN( COL, ROW )
                  IF ( COSZ .LE. 0.0 ) THEN 
                    DARK = .TRUE.   ! night
                    JH2O2_HYDROMETEORS = 0.0D0
                    JHNO3_HYDROMETEORS = 0.0D0
                  ELSE
                    DARK = .FALSE.  ! day
                    JH2O2 = RJ_RES( COL, ROW, LAY, LH2O2 )
                    JHNO3 = RJ_RES( COL, ROW, LAY, LHNO3 )
                    JH2O2_HYDROMETEORS = REAL( JH2O2*PERMIN_TO_PERSEC, 8 )
                    JHNO3_HYDROMETEORS = REAL( JHNO3*PERMIN_TO_PERSEC, 8 )
                  END IF

C...in aqchem, H2SO4 gas is added to ASO4J
C...  mimic this for the ASO4GASJ tracking species
                  IF ( STM ) THEN
                    POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) ) = POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) )
     &                                                    + POLC( PRECURSOR_MAP( SULF_IDX ) )
                    CEND( AEROSPC_MAP( ASO4GAS_IDX, 2 ) ) = POLC( AEROSPC_MAP( ASO4GAS_IDX, 2 ) )
                  END IF

                  CALL AQ_MAP ( JDATE, JTIME, WTBAR, WCBAR, TBARC,
     &                          PBARC, CTHK1, AIRM, PRATE1, TAUCLD,
     &                          POLC, CEND, REMOV, REMOVAC, ALFA0,
     &                          ALFA2, ALFA3, DARK )

#ifdef isam
                  DO SPC = 1, NSPC_SA ! general case
                    CSPC = SPC_INDEX(SPC,2)
                    DO ITAG = 1, NTAG_SA
c                     IF ( POLC( CSPC ) .GT. 1.0E-30 .AND. CEND( CSPC ) .GT. 1.0E-09 ) THEN
                      IF ( POLC( CSPC ) .GT. 1.0E-30 ) THEN
                        SA_CEND( SPC, ITAG ) = SA_POLC( SPC,ITAG )
     &                                       * ( CEND( CSPC )
     &                                         / POLC( CSPC ) )
                        SA_REMOV( SPC, ITAG ) = SA_POLC( SPC, ITAG )
     &                                        * ( REMOV( CSPC )
     &                                          / POLC( CSPC ) )
                      ELSE !
                        SA_CEND( SPC, ITAG )  = 0.0
                        SA_REMOV( SPC, ITAG ) = 0.0
                      END IF
                    END DO
                  END DO

                  IF (S_SO4J .NE. 0 ) THEN ! sulfate case

                    DO ITAG = 1, NTAG_SA  ! sulfate from H2SO4
                      SA_DS4( ITAG ) = SA_POLC( S_SULF,ITAG )
                      SA_CEND( S_SULF,ITAG )  = 1.0E-30
                    END DO

c                   DS4_SAVE = MAX( ( DS4_SAVE - SUM( SA_DS4 ) ), 0.0 ) !sulfate produced from SO2

                    DO ITAG = 1, NTAG_SA
                      SA_DS4( ITAG ) = SA_DS4( ITAG ) + DS4_SAVE ! total sulfate produced
     &                               * SA_POLC( S_SO2,ITAG )
     &                               / SUM ( SA_POLC( S_SO2,: ) )
                      SA_CEND( S_SO4J,ITAG ) = SA_POLC( S_SO4J,ITAG )  ! sulfate before removal
     &                                       + SA_DS4( ITAG )
                    END DO
 
                    SA_SUM = SUM ( SA_CEND( S_SO4J,: ) ) ! total apportioned sulfate before removal

                    DO ITAG = 1, NTAG_SA ! final sulfate removal and concentration
                      SA_REMOV( S_SO4J,ITAG ) = REMOV_SAVE
     &                                        * SA_CEND( S_SO4J,ITAG )
     &                                        / SA_SUM
                      SA_CEND( S_SO4J,ITAG ) = SA_CEND( S_SO4J,ITAG )
     &                                       - DEPSUM_SAVE
     &                                       * SA_CEND( S_SO4J,ITAG )
     &                                       / SA_SUM
                      SA_CEND( S_SO4J,ITAG ) = MAX ( SA_CEND( S_SO4J,ITAG ), 1.0E-30 )
                    END DO
          
                  END IF
#endif
                END IF

C...convert from moles/m**2 to kg/m**2 and kg/m**2 to kg/hectare

C...  for gases

                SPC = 0
                STRT = GC_STRT
                FINI = GC_STRT - 1 + N_GC_SPC
                DO VAR = STRT, FINI
                  SPC = SPC + 1
                  REMOV( VAR ) = REMOV( VAR ) * GC_MOLWT( SPC )
     &                         * M2PHA_OVER_GPKG
#ifdef isam
                  CSPC = 0
                  CSPC = INDEXINT1(VAR,NSPC_SA,SPC_INDEX(:,2))
                  IF ( CSPC .GT. 0 ) THEN
                    DO ITAG = 1, NTAG_SA
                      SA_REMOV( CSPC,ITAG ) = SA_REMOV( CSPC,ITAG ) * GC_MOLWT( SPC )
     &                                      * M2PHA_OVER_GPKG
                    END DO
                  END IF
#endif

#ifdef sens
                  DO NP = 1, NPMAX
                    S_REMOV( NP, VAR ) = S_REMOV( NP, VAR ) * GC_MOLWT( SPC )
     &                                 * M2PHA_OVER_GPKG
                  END DO
#endif

                END DO

C...  for aerosols

                SPC = 0
                STRT = AE_STRT
                FINI = AE_STRT - 1 + N_AE_SPC
                DO VAR = STRT, FINI
                  SPC = SPC + 1
                  IF (( INDEX( AE_SPC( SPC ), 'NUM' ) .EQ. 0 ) .AND.
     &                ( INDEX( AE_SPC( SPC ), 'SRF' ) .EQ. 0 )) THEN
                    REMOV( VAR ) = REMOV( VAR ) * AE_MOLWT( SPC )
     &                           * M2PHA_OVER_GPKG
#ifdef sens
                    DO NP = 1, NPMAX
                      S_REMOV( NP, VAR ) = S_REMOV( NP, VAR ) * AE_MOLWT( SPC )
     &                                   * M2PHA_OVER_GPKG
                    END DO
#endif
                  ELSE
                    REMOV( VAR ) = REMOV( VAR ) * M2PHA
#ifdef sens
                    DO NP = 1, NPMAX
                      S_REMOV( NP, VAR ) = S_REMOV( NP, VAR ) * M2PHA
                    END DO
#endif
                  END IF
#ifdef isam
                  CSPC = 0
                  CSPC = INDEXINT1(VAR,NSPC_SA,SPC_INDEX(:,2))
                  IF ( CSPC .GT. 0 ) THEN
                    DO ITAG = 1, NTAG_SA
                      SA_REMOV( CSPC,ITAG ) = SA_REMOV( CSPC,ITAG ) * AE_MOLWT( SPC )
     &                                      * M2PHA_OVER_GPKG
                    END DO
                  END IF
#endif
                END DO

C...  for non-reactives

                SPC = 0
                STRT = NR_STRT
                FINI = NR_STRT - 1 + N_NR_SPC
                DO VAR = STRT, FINI
                  SPC = SPC + 1
                  REMOV( VAR ) = REMOV( VAR ) * NR_MOLWT( SPC )
     &                         * M2PHA_OVER_GPKG
#ifdef isam
                  CSPC = 0
                  CSPC = INDEXINT1(VAR,NSPC_SA,SPC_INDEX(:,2))
                  IF ( CSPC .GT. 0 ) THEN
                    DO ITAG = 1, NTAG_SA
                      SA_REMOV( CSPC,ITAG ) = SA_REMOV( CSPC,ITAG ) * NR_MOLWT( SPC )
     &                                      * M2PHA_OVER_GPKG
                    END DO
                  END IF
#endif

#ifdef sens
                  DO NP = 1, NPMAX
                    S_REMOV( NP, VAR ) = S_REMOV( NP, VAR ) * NR_MOLWT( SPC )
     &                                 * M2PHA_OVER_GPKG
                  END DO
#endif

                END DO

C...  for tracers

                SPC = 0
                STRT = TR_STRT
                FINI = TR_STRT - 1 + N_TR_SPC
                DO VAR = STRT, FINI
                  SPC = SPC + 1
                  REMOV( VAR ) = REMOV( VAR ) * TR_MOLWT( SPC )
     &                         * M2PHA_OVER_GPKG
#ifdef sens
                  DO NP = 1, NPMAX
                    S_REMOV( NP, VAR ) = S_REMOV( NP, VAR ) * TR_MOLWT( SPC )
     &                                 * M2PHA_OVER_GPKG
                  END DO
#endif
                END DO

C...load deposition amounts into the DEP array

                DO VAR = 1, N_SPC_WDEP
                  DEP( COL, ROW, VAR ) = DEP( COL, ROW, VAR )
     &                                 + REMOV( WDEP_MAP( VAR ) )
                END DO

C...load H+ concentration into the deposition array as well

                DEP( COL, ROW, N_SPC_WDEP+1 ) =
     &                         DEP( COL, ROW, N_SPC_WDEP+1 ) + REMOVAC
 
C...set cgrid to the ending concentrations

                DO SPC = 1, NSPCSD
                  IF ( SPC .NE. N_GC_SPCD ) THEN
                    CGRID( COL, ROW, LAY, SPC ) = CEND( SPC )
                  END IF
                END DO

#ifdef isam
                DO SPC = 1, NSPC_SA
                  DO ITAG = 1, NTAG_SA
                    SA_DEP( COL, ROW, SPC, ITAG ) = SA_DEP( COL, ROW, SPC, ITAG )
     &                                    + SA_REMOV( SPC, ITAG )
                    ISAM( COL,ROW,LAY,SPC,ITAG ) = SA_CEND( SPC, ITAG )
                  END DO
                END DO
#endif

#ifdef sens
                DO NP = 1, NPMAX

                  DO VAR = 1, N_SPC_WDEP
                    S_TOTDEP( COL, ROW, NP, VAR ) = S_TOTDEP( COL, ROW, NP, VAR )
     &                                            + S_REMOV( NP, WDEP_MAP( VAR ) )
                  END DO

                  S_TOTDEP( COL, ROW, NP, N_SPC_WDEP+1 ) =
     &                     S_TOTDEP( COL, ROW, NP, N_SPC_WDEP+1 ) + S_REMOVAC( NP )

                  DO SPC = 1, NSPCSD
                    IF ( SPC .NE. N_GC_SPCD ) THEN
                      SENGRID( COL, ROW, LAY, NP, SPC ) = S_CEND( NP, SPC )
                    END IF
                  END DO

                END DO
#endif

              END IF        ! Sum( QC,QR,QG ) > 0.00005 ?
            END DO       ! lay
          END IF      ! QCRGCOL > 0 ?

        END DO   ! col
      END DO   ! row

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE HRG4( DTC )

C**********************************************************************
C
C  FUNCTION:  To solve for the concentration of NO3 and N2O5
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables
C**********************************************************************
      USE HRDATA

      IMPLICIT NONE


C..INCLUDES: NONE


C..ARGUMENTS:
      REAL( 8 ), INTENT( IN ) :: DTC             ! Time step


C..PARAMETERS: NONE


C..EXTERNAL FUNCTIONS: NONE


C..SAVED LOCAL VARIABLES:
!     CHARACTER( 16 ), SAVE   ::  PNAME = 'HRG4'    ! Program name


C..SCRATCH LOCAL VARIABLES:
      REAL( 8 ) ::   A, B, C, Q   ! Quadratic equation terms
      REAL( 8 ) ::   CMN          ! Temp scalar
      REAL( 8 ) ::   L15          ! Loss of NO3
      REAL( 8 ) ::   L16          ! Loss of N2O5
      REAL( 8 ) ::   P15          ! Production of NO3
      REAL( 8 ) ::   K15_15       ! Kno3+no3 * delta t
      REAL( 8 ) ::   R15_16       ! Kn2o5-->no3 * delta t
      REAL( 8 ) ::   R16_15       ! Kno3+no2-->n2o5[NO2] * delta t


C**********************************************************************


c..Production of NO3 (except from N2O5 )
      P15 =                 RKI(     6 ) * YCP( O            ) * YCP( NO2          )      ! O+NO2=NO3
     &    +                 RKI(    26 ) * YCP( NO2          ) * YCP( O3           )      ! NO2+O3=NO3
     &    +                 RKI(    46 ) * YC ( HNO3         ) * YCP( OH           )      ! HNO3+OH=NO3
     &    +    4.1000D-01 * RKI(    50 ) * YC ( PNA          )                            ! PNA=0.4100D+00*NO3+0.5900D+...
     &    +    4.0000D-01 * RKI(    56 ) * YC ( PAN          )                            ! PAN=0.4000D+00*NO3+0.6000D+...
     &    +    4.0000D-01 * RKI(    64 ) * YC ( PANX         )                            ! PANX=0.4000D+00*NO3+...
     &    +    1.8500D-01 * RKI(   170 ) * YC ( INTR         ) * YCP( OH           )      ! INTR+OH=0.1850D+00*NO3+...
     &    +                 RKI(   254 ) * YC ( CLNO3        )                            ! CLNO3=NO3+CL

c..Loss frequency of NO3 ( except NO3 + NO3 if present )
      L15 =                 RKI(    27 )                         ! NO3=NO2+O
     &    +                 RKI(    28 )                         ! NO3=NO
     &    +                 RKI(    29 ) * YCP( NO           )   ! NO3+NO=0.2000D+...
     &    +                 RKI(    30 ) * YCP( NO2          )   ! NO3+NO2=NO+NO2
     &    +                 RKI(    31 ) * YCP( O            )   ! NO3+O=NO2
     &    +                 RKI(    32 ) * YCP( OH           )   ! NO3+OH=HO2+NO2
     &    +                 RKI(    33 ) * YCP( HO2          )   ! NO3+HO2=OH+NO2
     &    +                 RKI(    34 ) * YCP( O3           )   ! NO3+O3=NO2
     &    +                 RKI(    36 ) * YCP( NO2          )   ! NO3+NO2=N2O5
     &    +                 RKI(   100 ) * YC ( FORM         )   ! NO3+FORM=HNO3+HO2+CO
     &    +                 RKI(   107 ) * YC ( ALD2         )   ! NO3+ALD2=C2O3+HNO3
     &    +                 RKI(   111 ) * YC ( ALDX         )   ! NO3+ALDX=CXO3+HNO3
     &    +                 RKI(   115 ) * YC ( GLYD         )   ! NO3+GLYD=HNO3+C2O3
     &    +                 RKI(   118 ) * YC ( GLY          )   ! NO3+GLY=HNO3+...
     &    +                 RKI(   120 ) * YC ( MGLY         )   ! NO3+MGLY=HNO3+...
     &    +                 RKI(   140 ) * YC ( ETH          )   ! NO3+ETH=0.5000D+...
     &    +                 RKI(   144 ) * YC ( OLE          )   ! NO3+OLE=0.5000D+...
     &    +                 RKI(   148 ) * YC ( IOLE         )   ! NO3+IOLE=0.5000D+...
     &    +                 RKI(   157 ) * YC ( ISOP         )   ! NO3+ISOP=0.3500D+...
     &    +                 RKI(   160 ) * YC ( ISPD         )   ! NO3+ISPD=0.7170D+...
     &    +                 RKI(   164 ) * YC ( HPLD         )   ! NO3+HPLD=HNO3+ISPD
     &    +                 RKI(   174 ) * YC ( TERP         )   ! NO3+TERP=0.4700D+...
     &    +                 RKI(   178 ) * YC ( APIN         )   ! NO3+APIN=0.4700D+...
     &    +                 RKI(   196 ) * YC ( CRES         )   ! NO3+CRES=0.3000D+...
     &    +                 RKI(   200 ) * YC ( CRON         )   ! NO3+CRON=NTR2+...
     &    +                 RKI(   205 ) * YC ( XOPN         )   ! NO3+XOPN=0.5000D+...
     &    +                 RKI(   209 ) * YC ( OPEN         )   ! NO3+OPEN=OPO3+HNO3
     &    +                 RKI(   211 ) * YC ( CAT1         )   ! NO3+CAT1=CRO+HNO3

c..Loss frequency of N2O5
      L16 =                 RKI(    37 )                         ! N2O5=NO3+NO2
     &    +                 RKI(    38 )                         ! N2O5=NO2+NO3
     &    +                 RKI(    39 )                         ! N2O5=0.2000D+01*HNO3
     &    +                 RKI(   269 )                         ! N2O5=HNO3+H2NO3PIJ
     &    +                 RKI(   270 )                         ! N2O5=HNO3+H2NO3PK

c..K15_15, R15_16, and R16_15 terms
      K15_15  = RKI(    35 ) * DTC

      R15_16  = ( RKI(    37 )
     &        +   RKI(    38 ) ) * DTC 


      R16_15  = RKI(    36 ) * YCP( NO2 ) * DTC

c..Solution of quadratic equation to get NO3 & N2O5
      CMN = 1.0D0 + L16 * DTC
      A = 2.0D0 * K15_15 * CMN
      B = CMN * ( 1.0D0 + L15 * DTC ) - R15_16 * R16_15
      C = CMN * ( YC0( NO3 ) + P15 * DTC ) +  R15_16 * YC0( N2O5 )

      Q = -0.5D0 * ( B + SIGN( 1.0D0, B ) * SQRT( B * B + 4.0D0 * A * C ) )
      YCP( NO3 ) = MAX( Q / A , -C / Q  )
      YCP( N2O5 ) = ( YC0( N2O5 ) + R16_15 * YCP( NO3 ) ) / CMN

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPDEPV_DIAG ( JDATE, JTIME, TSTEP,
     &                         N_GDEPV_NAMES, GDEPV_NAMES,
     &                         N_ADEPV_NAMES, ADEPV_NAMES )
!    &                         N_SDEPV_NAMES, SDEPV_NAMES)

C 2006-Jun-30 - created by W Hutzell
C 2006-Dec-05 - modified by J.Young
C 2010-Jan-29 - removed unneccesary CLOSE3 statement for CTM_DEPV_DIAG file
C               to eliminate potential MPI race condition (D.Wong)
C 2011-Feb-16 - replaced I/O API include files with UTILIO_DEFN (S.Roselle)
C 2011-May-20 - modified diagnostic file header creation (D.Schwede)
C 2015-Aug    - added a conditional statement to allow only I/O
C                 processors to open CTM_DEPV_DIAG file (D. Wong)

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE DEPVVARS
      USE UTILIO_DEFN
!     USE pio_module

      IMPLICIT NONE
 
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      INTEGER, INTENT( IN ) :: JDATE   ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME   ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP   ! output time step

C number and names of gas deposition velocities
      INTEGER, INTENT( IN ) :: N_GDEPV_NAMES
      CHARACTER( 16 ), INTENT( IN ) :: GDEPV_NAMES( : )

C number and names of aerosol deposition velocities
      INTEGER, INTENT( IN ) :: N_ADEPV_NAMES
      CHARACTER( 16 ), INTENT( IN ) :: ADEPV_NAMES( : )

C number and names of (SOA+aerosol) species deposition velocities
!     INTEGER, INTENT( IN ) :: N_SDEPV_NAMES
!     CHARACTER( 16 ), INTENT( IN ) :: SDEPV_NAMES( : )

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'OPDDEP_DIAG'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      V, N, L     ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update

      IF ( IO_PE_INCLUSIVE ) THEN   ! open new

         IF ( .NOT. OPEN3( CTM_DEPV_DIAG, FSRDWR3, PNAME ) ) THEN

            XMSG = 'Could not open ' // CTM_DEPV_DIAG // ' file for update - '
     &           // 'try to open new'
            CALL M3MESG( XMSG )

C Set output file characteristics based on GRIDDESC and open the dep velocity dignostic file

            SDATE3D = JDATE
            STIME3D = JTIME
            TSTEP3D = TSTEP
            CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

            FTYPE3D = GRDDED3
!           NVARS3D = N_GDEPV_NAMES + N_ADEPV_NAMES + N_SDEPV_NAMES
            NVARS3D = N_GDEPV_NAMES + N_ADEPV_NAMES
            NCOLS3D = GL_NCOLS
            NROWS3D = GL_NROWS
            NLAYS3D =     1
            NTHIK3D =     1
            GDTYP3D = GDTYP_GD
            P_ALP3D = P_ALP_GD
            P_BET3D = P_BET_GD 
            P_GAM3D = P_GAM_GD
            XORIG3D = XORIG_GD
            YORIG3D = YORIG_GD
            XCENT3D = XCENT_GD
            YCENT3D = YCENT_GD
            XCELL3D = XCELL_GD
            YCELL3D = YCELL_GD
            VGTYP3D = VGTYP_GD
            VGTOP3D = VGTOP_GD
            DO L = 1, NLAYS3D + 1
               VGLVS3D( L ) = VGLVS_GD( L )
            END DO
            GDNAM3D = GRID_NAME  ! from HGRD_DEFN

            FDESC3D = ' '   ! array

            L = LEN_TRIM( DEPV_METHOD )
            FDESC3D( 1 ) = 'Instanteous values of dry deposition velocities:'
     &                  // ' the gas phase velocities are' 
            FDESC3D( 2 ) = 'estimated by the '
     &                  //  DEPV_METHOD( 1:L ) // ' algorithm.'

            N = 0

            DO V = 1, N_GDEPV_NAMES
               N = N + 1
               VTYPE3D( V ) = M3REAL
               VNAME3D( V ) = GDEPV_NAMES( V )
               UNITS3D( V ) = 'cm s-1'
               VDESC3D( V ) = 'gas phase dry deposition velocity'
            END DO

            N = N_GDEPV_NAMES

            DO V = 1, N_ADEPV_NAMES
               N = N + 1
               VTYPE3D( N ) = M3REAL
               VNAME3D( N ) = ADEPV_NAMES( V )
               UNITS3D( N ) = 'cm s-1'
               VDESC3D( N ) = 'aerosol phase dry deposition velocity'
            END DO

!        N = N_GDEPV_NAMES + N_ADEPV_NAMES

!        DO V = 1, N_SDEPV_NAMES
!           N = N + 1
!           VTYPE3D( N ) = M3REAL
!           VNAME3D( N ) = SDEPV_NAMES( V )
!           UNITS3D( N ) = 'cm s-1'
!           VDESC3D( N ) = 'deposition velocity for (GAS-AEROSOL) '
!    &                  // ' semi-volatile compound'
!        END DO

C Open diagnostic file, then close it for subsequent open by all processors

            IF ( .NOT. OPEN3( CTM_DEPV_DIAG, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not create '// TRIM( CTM_DEPV_DIAG ) // ' file'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF
      END IF   ! IO_PE_INCLUSIVE

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     
c      [2] write tssa concentration data 
c     
C     Revision history
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE WR_SA ( JDATE, JTIME, TSTEP, NSTEPS )

C20140428  Writes ISAM values to SA_CONC_1 file
C
C          Called by driver.F

!      USE HGRD_DEFN             ! horizontal domain specifications
      USE GRID_CONF
      USE UTILIO_DEFN           ! 20120615
c     USE SA_LAYERS
      USE SA_DEFN               ! Mc06
c     USE SUBST_MODULES         ! stenex
      USE RUNTIME_VARS

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

C...Arguments Declaration
      INTEGER    JDATE          ! current model date, coded YYYYDDD
      INTEGER    JTIME          ! current model time, coded HHMMSS
      INTEGER    TSTEP(3)       ! format 10000, 0, 0
cyqw
      INTEGER    NSTEPS         ! Number of time steps of 3D output
cyqw
!0711 CHARACTER( 16 )       :: FILE_NAME

C...End of argument declaration

C Local variables:
      
c     INTEGER          ALLOCSTAT, LOGDEV
      INTEGER          ALLOCSTAT
      LOGICAL, SAVE :: FIRSTIME = .TRUE.    !20140228

      CHARACTER( 16 ) :: PNAME = 'WR_SA'
      CHARACTER( 96 ) :: XMSG = ' '
      
      INTEGER   C,R,S,K,N, L, JSPC    ! loop induction variables

      REAL, ALLOCATABLE, SAVE :: ISAM_BUFF ( :,:,:,: )  ! save added on 20140306

C-----------------------------------------------------------------------


      CALL SUBST_BARRIER


Ckrt     print*,'N_SPCTAG, JDATE, JTIME '
Ckrt     print*, N_SPCTAG, JDATE, JTIME  

!0710    IF ( .NOT. OPEN3( FILE_NAME, FSRDWR3, PNAME ) ) THEN
!0710       XMSG = 'Could not open ' // FILE_NAME // ' file for update'
!0710       CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!0710    END IF

!0711    IF ( .NOT. DESC3( FILE_NAME ) ) THEN
!0711       XMSG = 'Could not get file description from ' // FILE_NAME
!0711       CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!0711    END IF

      IF ( FIRSTIME ) THEN  ! 20140228

        FIRSTIME = .FALSE.
        LOGDEV = INIT3 ()

        IF ( MYPE .NE. 0 ) THEN
          IF ( .NOT. OPEN3( SA_CONC_1, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open ' // SA_CONC_1 // 'file for update'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF !open3
        END IF ! mype nonzero

        IF ( .NOT. DESC3( SA_CONC_1 ) ) THEN
          XMSG = 'Could not get file description from ' // SA_CONC_1
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        IF ( ISAM_ELEV .EQ. -1 ) ISAM_ELEV = NLAYS
        SA_NLAYS = ISAM_ELEV - ISAM_BLEV + 1

!20140306 relocated here the following five lines
         ALLOCATE ( ISAM_BUFF( NCOLS, NROWS, SA_NLAYS, N_SPCTAG ),
     &     STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating ISAM_BUFF'
           CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         ENDIF

      IF ( ISAM_ELEV .EQ. -1 ) ISAM_ELEV = NLAYS

      END IF ! firstime

      ISAM_BUFF = 0.0
!Ckrt  print*,'S,VNAME3D(S),S_SPCTAG(S),T_SPCTAG(S)'
      DO S = 1, N_SPCTAG
       DO L = ISAM_BLEV, ISAM_ELEV
        DO R = 1, NROWS
         DO C = 1, NCOLS
          ISAM_BUFF( C,R,L,S ) = ISAM( C,R,L,S_SPCTAG(S),T_SPCTAG(S) )
         ENDDO
        ENDDO
       ENDDO


!20140306 Mentioning of vname3d is dangerous. Use vnam_spctag instead
!20140306       IF ( .NOT. WRITE3( SA_CONC_1, VNAME3D(S), JDATE, JTIME,
       IF ( .NOT. WRITE3( SA_CONC_1, VNAM_SPCTAG(S), JDATE, JTIME,
     &    ISAM_BUFF(:,:,:,S)) ) THEN
         XMSG = 'Could not write to ' 
!0711&        // FILE_NAME 
     &        // SA_CONC_1 
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
       END IF
      END DO
!20140306         IF ( ALLOCATED(ISAM_BUFF) ) DEALLOCATE( ISAM_BUFF )
      
c.....couple ISAM after writing

      return
      end

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AQ_MAP ( JDATE, JTIME, WTBAR, WCBAR, TBARC, PBARC,
     &                    CTHK1, AIRM, PRATE1, TAUCLD, POLC, CEND,
     &                    REMOV, REMOVAC, ALFA0, ALFA2, ALFA3, DARK )

C-----------------------------------------------------------------------
C  DESCRIPTION:  This is an interface processor between the cloud dynamics
C     module(s) and the aqueous chemistry module.  It uses indices to
C     map species from their order in the array POLC, CEND, REMOV to
C     the species that are expected for AQCHEM, ie GAS and AEROSOL.
 
C  Revision History:
C      No   Date   Who  What
C      -- -------- ---  -----------------------------------------
C       0 01/15/98 sjr  created program
C       1 02/13/98 sjr  modified/generalized the mapping procedure
C         Dec 00   Jeff move CGRID_MAP into f90 module
C       3 06/07/05 sjr  added logic for coarse sulfate
C       4 04/11/08 jtk  added logic for coarse ammonium
C       5 10/10/10 yoj  update to use aero_reeng by Steve Howard, Prakash Bhave,
C                       Jeff Young, Sergey Napelenok, and Shawn Roselle
C       6 03/01/11 sjr  replaced I/O API include files with UTILIO_DEFN;
C       7 07/01/01 gs   calculate zenith angle to determine daytime and nightime 
C                       needed for sulfur oxidation via metal catalysis
C       8 09/10/11 wth  adapted for multiple pollutant model, i.e., Gas phase mercury 
C                       PM mercury and tracer species
C       07 Jul 14  wth: replaced mechanism include file(s) with fortran module
C       01 Feb 19 D.Wong: replaced run time dynamic arrays with allocatable arrays
C       30 Dec 19 S.Napelenok: ddm-3d implementation for v 5.3.1
 
C  Called by:  RADMCLD and RESCLD
 
C  Calls the following subroutines:  AQCHEM
 
C  ARGUMENTS    TYPE      I/O       DESCRIPTION
C  ---------   -------  ------  --------------------------------
C    JDATE     integer   input  current model julian date (yyyyddd)
C    JTIME     integer   input  current model time (hhmmss)
C    WTBAR      real     input  avg total water content (kg/m3)
C    WCBAR      real     input  avg liquid water content (kg/m3)
C    TBARC      real     input  avg cloud temperature (K)
C    PBARC      real     input  avg cloud pressure (Pa)
C    CTHK1      real     input  cloud thickness (m)
C    AIRM       real     input  total air mass (moles/m2) in cloudy air
C    PRATE1     real     input  precipitation rate (mm/hr)
C    TAUCLD     real     input  cloud lifetime (s)
C    POLC       real     input  ave vert conc incloud (moles sp/ mole air)
C    CEND       real    output  ending incloud conc (moles/mole)
C    REMOV      real    output  moles/m2 or mm*mol/lit scavenged
C    REMOVAC    real    output  variable storing H+ deposition
C    ALFA0      real     input  scav coef for aitken aerosol number
C    ALFA2      real     input  scav coef for aitken aerosol surface area
C    ALFA3      real     input  scav coef for aitken aerosol mass
C    DARK       logical  input DARK = TRUE is night,  DARK = FALSE is day
C-----------------------------------------------------------------------

      USE CGRID_SPCS     ! CGRID mechanism species
      USE AERO_DATA      ! aerosol shared parameters
      USE AQ_DATA        ! aqueous chemistry shared parameters
      USE UTILIO_DEFN
#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_POLC, S_CEND, S_REMOV,
     &                       S_REMOVAC, S_HPWDEP, S_GAS, S_GASWDEP,
     &                       S_AEROSOL, S_AERWDEP, S_WSRGGAS, S_WSRGAER
#endif 

      IMPLICIT NONE
      INCLUDE SUBST_CONST   ! for DPI
      
      CHARACTER( 120 ) :: XMSG = ' '    ! Exit status message

C Parameters:

      INTEGER, SAVE :: MXSPCS   ! Number of species in CGRID

      REAL, PARAMETER :: ONETHIRD  = 1.0 / 3.0
      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0

C Arguments:

      INTEGER, INTENT( IN )    :: JDATE     ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )    :: JTIME     ! current model time, coded HHMMSS

      REAL,    INTENT( IN )    :: WTBAR     ! total wat cont (kg/m2) int. thru cld
      REAL,    INTENT( IN )    :: WCBAR     ! liq water content of cloud (kg/m3)
      REAL,    INTENT( IN )    :: TBARC     ! mean cloud temp (K)
      REAL,    INTENT( IN )    :: PBARC     ! mean cloud pressure (Pa)
      REAL,    INTENT( IN )    :: CTHK1     ! aq chem calc cloud thickness
      REAL,    INTENT( IN )    :: AIRM      ! total air mass (moles/m2) in cloudy air
      REAL,    INTENT( IN )    :: PRATE1    ! storm rainfall rate (mm/hr)
      REAL,    INTENT( IN )    :: TAUCLD    ! cloud lifetime
      REAL,    INTENT( IN )    :: POLC ( : )  ! avg vert conc incloud (moles/mole)
      REAL,    INTENT( INOUT ) :: CEND ( : )  ! ending incloud conc (moles/mole)
      REAL,    INTENT( INOUT ) :: REMOV( : )  ! moles/m2 or mm*mol/lit scavenged
      REAL,    INTENT( INOUT ) :: REMOVAC   ! variable storing H+ deposition
      REAL,    INTENT( IN )    :: ALFA0     ! scav coef for aitken aerosol number
      REAL,    INTENT( IN )    :: ALFA2     ! scav coef for aitken aerosol sfc area
      REAL,    INTENT( IN )    :: ALFA3     ! scav coef for aitken aerosol mass
      LOGICAL, INTENT( IN )    :: DARK      ! DARK = TRUE is night,  DARK = FALSE is day

C Local Variables (scalars):

      LOGICAL, SAVE :: FIRSTIME = .TRUE.      ! flag for first pass thru

      CHARACTER(16), SAVE :: PNAME = 'AQ_MAP' ! program name

      INTEGER       IAER                ! aerosol loop counter
      INTEGER       IMODE               ! aerosol mode loop counter
      INTEGER       IGAS                ! gas loop counter
      INTEGER       ISRG                ! surrogate loop counter
      INTEGER       PNTR                ! relative pointer variable
      INTEGER       SPC                 ! liquid species loop counter
      INTEGER ::    STAT

      REAL( 8 )  :: BETASO4
      REAL       :: EALFA2T                ! EXP( -ALFA2 * TAUCLD )
      REAL( 8 )  :: M3NEW( NMODES )        ! modal mass at time t
      REAL( 8 )  :: M3OLD( NMODES )        ! modal mass at time 0
      REAL( 8 )  :: Dens_wmean_old( NMODES ) ! concentration weighted molecular weight g/mol
      REAL( 8 )  :: Dens_wmean_new( NMODES ) ! concentration weighted molecular weight g/mol

      REAL       :: HPWDEP                        ! hydrogen wet dep (mm mol/liter)
      REAL( 8 ), ALLOCATABLE, SAVE :: GAS    ( : )    ! gas phase conc (mol/mol)
      REAL( 8 ), ALLOCATABLE, SAVE :: GASWDEP( : )    ! gas phase wet dep array (mm mol/liter)
      REAL( 8 ), ALLOCATABLE, SAVE :: AEROSOL( :, :)  ! aerosol conc (mol/mol)
      REAL( 8 ), ALLOCATABLE, SAVE :: AERWDEP( :, :)  ! aerosol wet dep array (mm mol/liter)
      REAL( 8 )  :: WSRGGAS( NGAS, MXSRG)             ! weights for surrogate
      REAL( 8 )  :: WSRGAER( MAX_NAER, NMODES, MXSRG) ! weights for surrogate

C External Functions:

      INTEGER, EXTERNAL :: INDEXN           ! external func to get species pointers


      INTERFACE
        SUBROUTINE AQCHEM ( JDATE, JTIME, TEMP, PRES_PA, TAUCLD, PRCRATE,
     &                      WCAVG, WTAVG, AIRM, ALFA0, ALFA2, ALFA3, GAS,
     &                      AEROSOL, GASWDEP, AERWDEP, HPWDEP, BETASO4, DARK )
           INTEGER,   INTENT( IN )  :: JDATE  ! current model date, coded YYYYDDD
           INTEGER,   INTENT( IN )  :: JTIME  ! current model time, coded HHMMSS
           REAL,      INTENT( IN )  :: AIRM      ! total air mass in cloudy layers (mol/m2)
           REAL,      INTENT( IN )  :: ALFA0     ! scav coef for aitken aerosol number
           REAL,      INTENT( IN )  :: ALFA2     ! scav coef for aitken aerosol sfc area
           REAL,      INTENT( IN )  :: ALFA3     ! scav coef for aitken aerosol mass
           REAL,      INTENT( OUT ) :: HPWDEP    ! hydrogen wet deposition (mm mol/liter)
           REAL( 8 ), INTENT( OUT ) :: BETASO4  
           REAL,      INTENT( IN )  :: PRCRATE   ! precip rate (mm/hr)
           REAL,      INTENT( IN )  :: PRES_PA   ! pressure (Pa)
           REAL,      INTENT( IN )  :: TAUCLD    ! timestep for cloud (s)
           REAL,      INTENT( IN )  :: TEMP      ! temperature (K)
           REAL,      INTENT( IN )  :: WCAVG     ! liquid water content (kg/m3)
           REAL,      INTENT( IN )  :: WTAVG     ! total water content (kg/m3)
           REAL( 8 ), INTENT( INOUT ) :: GAS    ( : )   ! gas phase concentrations (mol/molV)
           REAL( 8 ), INTENT( INOUT ) :: AEROSOL( :,: ) ! aerosol concentrations (mol/molV)
           REAL( 8 ), INTENT( INOUT ) :: GASWDEP( : )   ! gas phase wet deposition array (mm mol/liter)
           REAL( 8 ), INTENT( INOUT ) :: AERWDEP( :,: ) ! aerosol wet deposition array (mm mol/liter)
           LOGICAL,   INTENT( IN )    :: DARK           ! DARK = TRUE is night,  DARK = FALSE is day
        END SUBROUTINE AQCHEM
      END INTERFACE      

C-----------------------------------------------------------------------

C...Initialization
C...  event-statistics variables.

      IF ( FIRSTIME ) THEN

        FIRSTIME = .FALSE.

        CALL AQ_DATA_INIT()      

        ALLOCATE ( GAS    ( NGAS ),
     &             GASWDEP( NGAS ),
     &             AEROSOL( NAER, NMODES),
     &             AERWDEP( NAER, NMODES),
     &             STAT = STAT)
        IF (STAT .NE. 0) THEN
           XMSG = 'Memory allocation failure'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#ifdef sens
C... Allocate sensitivity arrays
        ALLOCATE ( S_HPWDEP( NPMAX ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_HPWDEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_GAS( NPMAX,NGAS ), S_GASWDEP( NPMAX,NGAS ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_GAS or S_GASWDEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_AEROSOL( NPMAX,NAER,NMODES ), S_AERWDEP( NPMAX,NAER,NMODES ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_AEROSOL or S_AERWDEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

        ALLOCATE ( S_WSRGGAS( NPMAX,NGAS,MXSRG ), S_WSRGAER( NPMAX,NAER,NMODES,MXSRG ), STAT = STAT )
        IF ( STAT .NE. 0 ) THEN
          XMSG = 'Failure allocating S_WSRGGAS or S_WSRGAER'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
#endif

      END IF

C...for subsequent calls, check to make sure some surrogates were
C...  specified, otherwise there is no need to perform aqueous chemistry

      IF ( SIZE( CGRID2AQ_MAP ) .EQ. 0 ) THEN
        RETURN
      END IF

C...load gas-phase concentrations

      GAS     = 0.0D0
      WSRGGAS = 0.0D0
      GASWDEP = 0.0D0

#ifdef sens
      S_GAS = 0.0D0
      S_WSRGGAS = 0.0D0
      S_GASWDEP = 0.0D0
#endif

      DO IGAS = 1, NGAS

        DO ISRG = 1, NSRGGAS( IGAS )
          PNTR = CGRID2AQ_MAP( LSRGGAS( IGAS, ISRG ) )
          GAS( IGAS ) = GAS( IGAS ) + REAL( POLC( PNTR ), 8 )
#ifdef sens
          DO NP = 1, NPMAX
            S_GAS( NP, IGAS ) = S_GAS( NP, IGAS ) + S_POLC ( NP, PNTR )
          ENDDO
#endif
        END DO

        IF ( GAS( IGAS ) .GT. 0.0D0 ) THEN
          DO ISRG = 1, NSRGGAS( IGAS )
            PNTR = CGRID2AQ_MAP( LSRGGAS( IGAS, ISRG ) )
            WSRGGAS( IGAS, ISRG ) = REAL( POLC( PNTR ), 8 ) / GAS( IGAS )
#ifdef sens
            DO NP = 1, NPMAX
               IF ( S_GAS( NP, IGAS ) .NE. 0.0D0 ) THEN
                  S_WSRGGAS( NP, IGAS, ISRG ) = S_POLC( NP,PNTR ) / S_GAS(NP,IGAS)
               ELSE
                  S_WSRGGAS( NP, IGAS, ISRG ) = 0.0D0
               END IF
            END DO
#endif
          END DO
        ELSE
          DO ISRG = 1, NSRGGAS( IGAS )
            WSRGGAS( IGAS, ISRG ) = 1.0D0 / REAL( NSRGGAS( IGAS ), 8 )
#ifdef sens
            DO NP = 1, NPMAX
               S_WSRGGAS( NP, IGAS, ISRG ) = 0.0D0
            END DO
#endif
          END DO
        END IF

C...set background values for gases if no surrogates were specified

        IF ( NSRGGAS( IGAS ) .EQ. 0 ) THEN
          GAS( IGAS ) = REAL( SRGGAS( IGAS )%BACKGND, 8 ) * 1.0D-6
#ifdef sens
          DO NP =1, NPMAX
             S_GAS( NP, IGAS ) = 0.0D0
          ENDDO
#endif
        END IF

      END DO

C...load aerosol concentrations

      AEROSOL = 0.0D0
      WSRGAER = 0.0D0
      AERWDEP = 0.0D0

#ifdef sens
      S_AEROSOL = 0.0D0
      S_WSRGAER = 0.0D0
      S_AERWDEP = 0.0D0
#endif

      DO IAER = 1, NAER
        DO IMODE = 1, NMODES

          IF ( SRGAER( IAER )%NAME( IMODE ) .NE. ' ' ) THEN
            AEROSOL( IAER, IMODE ) = 0.0D0
#ifdef sens
            DO NP =1, NPMAX
               S_AEROSOL( NP, IAER, IMODE ) = 0.0D0
            ENDDO
#endif
            DO ISRG = 1, NSRGAER( IAER, IMODE )
              PNTR = CGRID2AQ_MAP( LSRGAER( IAER, IMODE, ISRG ) )
              AEROSOL( IAER, IMODE ) = AEROSOL( IAER, IMODE ) + REAL( POLC( PNTR ), 8 )
#ifdef sens
              DO NP = 1, NPMAX
                S_AEROSOL( NP, IAER, IMODE ) = S_AEROSOL( NP, IAER, IMODE ) + S_POLC( NP, PNTR )
              ENDDO
#endif
            END DO

            IF ( AEROSOL( IAER, IMODE ) .GT. 0.0D0 ) THEN
              DO ISRG = 1, NSRGAER( IAER, IMODE )
                PNTR = CGRID2AQ_MAP( LSRGAER( IAER, IMODE, ISRG ) )
                WSRGAER( IAER, IMODE, ISRG ) = REAL( POLC( PNTR ), 8 )
     &                                       / REAL( AEROSOL( IAER, IMODE ), 8 )
#ifdef sens
               DO NP = 1, NPMAX
                  IF ( S_AEROSOL( NP, IAER, IMODE ) .NE. 0.0D0 ) THEN
                     S_WSRGAER( NP, IAER, IMODE, ISRG ) = S_POLC( NP, PNTR )
     &                                               / S_AEROSOL( NP, IAER, IMODE )
                  ELSE
                     S_WSRGAER( NP, IAER, IMODE, ISRG ) = 0.0D0
                  END IF
               END DO
#endif
              END DO
            ELSE
              DO ISRG = 1, NSRGAER( IAER, IMODE )
                WSRGAER( IAER, IMODE, ISRG ) = 1.0D0 / REAL( NSRGAER( IAER, IMODE ), 8 )
#ifdef sens
                DO NP = 1, NPMAX
                    S_WSRGAER( NP, IAER, IMODE, ISRG ) = 0.0D0
                ENDDO
#endif
              END DO
            END IF

C...set background values for aerosols if no surrogates were specified

            IF ( NSRGAER( IAER, IMODE ) .EQ. 0 ) THEN
              IF ( SRGAER( IAER )%MOLWT .GT. 0.0 ) THEN
                AEROSOL( IAER, IMODE ) = REAL( SRGAER( IAER )%BACKGND * 1.0E-6 * CTHK1, 8 )
     &                                 / REAL( SRGAER( IAER )%MOLWT * AIRM, 8 )
              ELSE
                AEROSOL( IAER, IMODE ) = REAL( SRGAER( IAER )%BACKGND * CTHK1 / AIRM, 8 )
              END IF
#ifdef sens
              DO NP = 1, NPMAX
                S_AEROSOL( NP, IAER, IMODE ) = 0.0D0
              ENDDO
#endif             
            END IF
          END IF
        END DO
      END DO

C *** extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module

#ifdef sens
      CALL EXTRACT_AERO ( POLC, .FALSE., REAL(S_POLC,4), .TRUE. )
#else
      CALL EXTRACT_AERO ( POLC, .FALSE. )
#endif

C *** Calculate pseudo aerosol 3rd moment (ignore factors that cancel in the division)
C ... M3OLD is in units of m3/kmol_air
      M3OLD = 0.0
      Dens_wmean_old = 0.0
      DO IMODE = 2, N_MODE

        DO SPC = 1, N_AEROSPC
          IF (  AEROSPC( SPC )%TRACER ) CYCLE 
          IF ( ( AEROSPC( SPC )%NAME( IMODE ) .NE. ' ' ) .AND.
     &         ( .NOT. AEROSPC( SPC )%NO_M2WET ) ) THEN
             M3OLD( IMODE ) = M3OLD( IMODE )
     &                      + ( AEROSPC_CONC( SPC,IMODE ) * AEROSPC_MW( SPC )
     &                      / AEROSPC( SPC )%DENSITY )
             Dens_wmean_old( IMODE ) = Dens_wmean_old( IMODE )  
     &                      + AEROSPC_CONC( SPC,IMODE ) * AEROSPC_MW( SPC )
          END IF
        END DO
      END DO
      Dens_wmean_old(2:N_MODE) = Dens_wmean_old(2:N_MODE) / M3OLD(2:N_MODE)

C...perform aqueous-phase chemistry calculations

      CALL AQCHEM ( JDATE, JTIME, TBARC, PBARC, TAUCLD, PRATE1,
     &              WCBAR, WTBAR, AIRM, ALFA0, ALFA2, ALFA3, GAS,
     &              AEROSOL, GASWDEP, AERWDEP, HPWDEP, BETASO4, DARK )

C...  compute the scavenging coefficient
      EALFA2T = EXP( -ALFA2 * TAUCLD )

C...store the amount of hydrogen deposition

      REMOVAC = HPWDEP
#ifdef sens
      DO NP = 1, NPMAX
        S_REMOVAC( NP ) = S_HPWDEP( NP )
      END DO
#endif

C...Now, re-apportion mass back into cend/remov (cgrid-type) array

      DO IGAS = 1, NGAS
        DO ISRG = 1, NSRGGAS( IGAS )
          PNTR = CGRID2AQ_MAP( LSRGGAS( IGAS, ISRG ) )
          CEND ( PNTR ) = GAS    ( IGAS ) * WSRGGAS( IGAS, ISRG )
          REMOV( PNTR ) = GASWDEP( IGAS ) * WSRGGAS( IGAS, ISRG )
#ifdef sens
          DO NP = 1, NPMAX
            S_CEND ( NP, PNTR ) = S_GAS    ( NP, IGAS ) * S_WSRGGAS( NP, IGAS, ISRG )
            S_REMOV( NP, PNTR ) = S_GASWDEP( NP, IGAS ) * S_WSRGGAS( NP, IGAS, ISRG )
          ENDDO
#endif
        END DO
      END DO

      DO IAER = 1, NAER
        DO IMODE = 1, NMODES
          IF( SRGAER( IAER )%NAME( IMODE ) .NE. ' ' ) THEN
            DO ISRG = 1, NSRGAER( IAER, IMODE )
              PNTR = CGRID2AQ_MAP( LSRGAER( IAER, IMODE, ISRG ) )
              CEND ( PNTR ) = AEROSOL( IAER, IMODE ) * WSRGAER( IAER, IMODE, ISRG )
              REMOV( PNTR ) = AERWDEP( IAER, IMODE ) * WSRGAER( IAER, IMODE, ISRG )
#ifdef sens
              DO NP = 1, NPMAX
                S_CEND ( NP, PNTR ) = S_AEROSOL( NP, IAER, IMODE ) * S_WSRGAER( NP, IAER, IMODE, ISRG )
                S_REMOV( NP, PNTR ) = S_AERWDEP( NP, IAER, IMODE ) * S_WSRGAER( NP, IAER, IMODE, ISRG )
              ENDDO
#endif
            END DO
          END IF 
        END DO
      END DO

C *** extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module

#ifdef sens
      CALL EXTRACT_AERO ( CEND, .FALSE., REAL(S_CEND,4), .TRUE. )
#else
      CALL EXTRACT_AERO ( CEND, .FALSE. )
#endif

C *** Calculate pseudo aerosol 3rd moment (ignore factors that cancel in the division)
C ... M3NEW is in units of m3/kmol_air
      M3NEW = 0.0
      Dens_wmean_new = 0.0
      DO IMODE = 2, NMODES

        DO SPC = 1, N_AEROSPC
          IF (  AEROSPC( SPC )%TRACER ) CYCLE 
          IF ( ( AEROSPC( SPC )%NAME( IMODE ) .NE. ' ' ) .AND.
     &         ( .NOT. AEROSPC( SPC )%NO_M2WET ) ) THEN
             M3NEW( IMODE ) = M3NEW( IMODE )
     &                      + ( AEROSPC_CONC( SPC,IMODE ) * AEROSPC_MW( SPC )
     &                      / AEROSPC( SPC )%DENSITY )
             Dens_wmean_new( IMODE ) = Dens_wmean_new( IMODE )  
     &                      + AEROSPC_CONC( SPC,IMODE ) * AEROSPC_MW( SPC )
          END IF
        END DO
      END DO

C...Update aerosol number 
      CEND( AERONUM_MAP( 1 ) ) = MAX( CEND( AERONUM_MAP( 1 ) ), aeromode_minNum( 1 )/ (AIRM/CTHK1) )
      CEND( AERONUM_MAP( 2 ) ) = MAX( CEND( AERONUM_MAP( 2 ) ), aeromode_minNum( 2 )/ (AIRM/CTHK1) )
      CEND( AERONUM_MAP( 3 ) ) = MAX( CEND( AERONUM_MAP( 3 ) ), aeromode_minNum( 3 )/ (AIRM/CTHK1) )

#ifdef sens
C... Remove number sensitivity calculations for now
      S_CEND( :, AERONUM_MAP( 1 ) ) = 0.0
      S_CEND( :, AERONUM_MAP( 2 ) ) = 0.0
      S_CEND( :, AERONUM_MAP( 3 ) ) = 0.0
#endif

C...check for minimums
C...ug/m3*m3/mol_air*1e3 mol_air/kmol_air*1e-9kg/ug*m3/kg=> m3/kmol_air
      DO IMODE = 2, NMODES
        IF ( M3NEW( IMODE ) .GT. 0.0D0 ) THEN  ! Dens_wmean_new will be .GT. 0 also
           Dens_wmean_new( IMODE ) = Dens_wmean_new( IMODE ) / M3NEW( IMODE )
           M3OLD( IMODE ) = MAX( M3OLD( IMODE ), CONMIND * 1.0d-6 / ( Dens_wmean_old( IMODE ) * AIRM / CTHK1 ) )
           M3NEW( IMODE ) = MAX( M3NEW( IMODE ), CONMIND * 1.0d-6 / ( Dens_wmean_new( IMODE ) * AIRM / CTHK1 ) )
        END IF
      END DO

C...Update surface area

      CEND( AEROSRF_MAP( 1 ) ) = POLC( AEROSRF_MAP( 1 ) ) * EALFA2T
      CEND( AEROSRF_MAP( 1 ) ) = MAX( CEND( AEROSRF_MAP( 1 ) ), aeromode_minM2( 1 ) * DPI / (AIRM/CTHK1) )
      
      CEND( AEROSRF_MAP( 2 ) ) = POLC( AEROSRF_MAP( 2 ) )
     &                         * EXP( -BETASO4 * TAUCLD * ONETHIRD )
     &                         * ( M3NEW( 2 ) / M3OLD( 2 ) ) ** TWOTHIRDS
      CEND( AEROSRF_MAP( 2 ) ) = MAX( CEND( AEROSRF_MAP( 2 ) ), aeromode_minM2( 2 ) * DPI / (AIRM/CTHK1) )

      CEND( AEROSRF_MAP( 3 ) ) = POLC( AEROSRF_MAP( 3 ) )
     &                         * ( CEND( AERONUM_MAP( 3 ) )
     &                             / POLC( AERONUM_MAP( 3 ) ) ) ** ONETHIRD
     &                         * ( M3NEW( 3 ) / M3OLD( 3 ) ) ** TWOTHIRDS
      CEND( AEROSRF_MAP( 3 ) ) = MAX( CEND( AEROSRF_MAP( 3 ) ), aeromode_minM2( 3 ) * DPI / (AIRM/CTHK1) )

#ifdef sens
C... Remove surface area sensitivity calculations for now
      S_CEND( :, AEROSRF_MAP( 1 ) ) = 0.0
      S_CEND( :, AEROSRF_MAP( 2 ) ) = 0.0
      S_CEND( :, AEROSRF_MAP( 3 ) ) = 0.0
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       SUBROUTINE HRG3( DTC )

C**********************************************************************
C
C  FUNCTION:  To solve for the concentration of C2O3 and PAN
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables
C**********************************************************************
      USE HRDATA

      IMPLICIT NONE

C..INCLUDES:  NONE

C..ARGUMENTS:
      REAL( 8 ), INTENT( IN ) :: DTC              ! Time step


C..PARAMETERS: NONE


C..EXTERNAL FUNCTIONS: NONE


C..SAVED LOCAL VARIABLES:
!     CHARACTER( 16 ), SAVE  :: PNAME = 'HRG3'      ! Program name


C..SCRATCH LOCAL VARIABLES:
      REAL( 8 ) ::   A, B, C, Q   ! Quadratic equation terms
      REAL( 8 ) ::   CMN          ! Temp scalar
      REAL( 8 ) ::   L8           ! Loss of CCO_O2
      REAL( 8 ) ::   L9           ! Loss of PAN
      REAL( 8 ) ::   P8           ! Production of CCO_O2

      REAL( 8 ) ::   K8_8         ! Kc2o3+c2o3 * delta t
      REAL( 8 ) ::   R8_9         ! Kpan-->c2o3 * delta t
      REAL( 8 ) ::   R9_8         ! Kc2o3+no2-->pan * [NO2] * delta t

C**********************************************************************


c..Production of C2O3 (except from PAN )
      P8 =                 RXRAT(    95 )      ! PACD+OH=C2O3
     &   +                 RXRAT(   105 )      ! ALD2+O=C2O3+OH
     &   +                 RXRAT(   106 )      ! ALD2+OH=C2O3
     &   +                 RXRAT(   107 )      ! ALD2+NO3=C2O3+HNO3
     &   +    8.0000D-01 * RXRAT(   113 )      ! GLYD+OH=0.8000D+00*C2O3+...
     &   +                 RXRAT(   115 )      ! GLYD+NO3=C2O3+HNO3
     &   +                 RXRAT(   119 )      ! MGLY=C2O3+HO2+CO
     &   +                 RXRAT(   120 )      ! MGLY+NO3=C2O3+HNO3+XO2+RO2
     &   +                 RXRAT(   121 )      ! MGLY+OH=C2O3+CO
     &   +    5.0000D-01 * RXRAT(   128 )      ! KET=0.5000D+00*C2O3+...
     &   +    6.2000D-01 * RXRAT(   129 )      ! ACET=0.6200D+00*C2O3+...
     &   +                 RXRAT(   130 )      ! ACET+OH=C2O3+FORM+XO2+RO2
     &   +    2.6900D-01 * RXRAT(   158 )      ! ISPD+OH=0.2690D+00*C2O3+...
     &   +    1.4300D-01 * RXRAT(   159 )      ! ISPD+O3=0.1430D+00*C2O3+...
     &   +    2.0800D-01 * RXRAT(   161 )      ! ISPD=0.2080D+00*C2O3+...
     &   +    3.0000D-01 * RXRAT(   202 )      ! XOPN=0.3000D+00*C2O3+XO2H+...
     &   +    6.0000D-01 * RXRAT(   204 )      ! XOPN+O3=0.6000D+00*C2O3+...
     &   +    1.2000D-01 * RXRAT(   208 )      ! OPEN+O3=0.1200D+00*C2O3+...
     &   +                 RXRAT(   243 )      ! CL+ALD2=C2O3+HCL

c..Loss frequency of C2O3 ( not including C2O3 + C2O3 )
      L8 =                 RKI(    53 ) * YC ( NO           )   ! C2O3+NO=NO2+MEO2+RO2
     &   +                 RKI(    54 ) * YC ( NO2          )   ! C2O3+NO2=PAN
     &   +                 RKI(    57 ) * YC ( HO2          )   ! C2O3+HO2=0.4100D+...
     &   +                 RKI(    60 ) * YC ( CXO3         )   ! C2O3+CXO3=MEO2+...
     &   +                 RKI(    73 ) * YC ( MEO2         )   ! C2O3+MEO2=FORM+...
     &   +                 RKI(    77 ) * YC ( XO2H         )   ! C2O3+XO2H=...
     &   +                 RKI(    81 ) * YC ( XO2          )   ! C2O3+XO2=0.8000D+...
     &   +                 RKI(    85 ) * YC ( XO2N         )   ! C2O3+XO2N=...
     &   +                 RKI(   153 ) * YC ( ISO2         )   ! C2O3+ISO2=...
     &   +                 RKI(   168 ) * YC ( EPX2         )   ! C2O3+EPX2=...
     &   +                 RKI(   181 ) * YC ( BZO2         )   ! C2O3+BZO2=GLY+...
     &   +                 RKI(   186 ) * YC ( TO2          )   ! C2O3+TO2=0.4800D+...
     &   +                 RKI(   193 ) * YC ( XLO2         )   ! C2O3+XLO2=...
     &   +                 RKI(   216 ) * YC ( OPO3         )   ! C2O3+OPO3=MEO2+...

c..Loss frequency of PAN
      L9 =                 RKI(    55 )                         ! PAN=NO2+C2O3
     &   +                 RKI(    56 )                         ! PAN=0.6000D+...

c..K8_8, R8_9, and R9_8 terms
      K8_8  = RKI(    59 ) * DTC

      R8_9  = ( RKI(    55 )
     &      +   RKI(    56 ) ) * DTC 

      R9_8  = ( RKI(    54 ) * YC( NO2 ) ) * DTC 

c..Solution of quadratic equation to get C2O3 & PAN
      CMN = 1.0 + L9 * DTC
      A = 2.0D0 * K8_8 * CMN
      B = CMN * ( 1.0D0 + L8 * DTC ) - R8_9 * R9_8
      C = CMN * ( YC0( C2O3 ) + P8 * DTC ) +  R8_9 * YC0( PAN )

      Q = -0.5D0 * ( B + SIGN( 1.0D0, B ) * SQRT( B * B + 4.0D0 * A * C ) )

      YCP( C2O3 ) = MAX( Q / A , -C / Q  )

      YCP( PAN ) = ( YC0( PAN ) +  R9_8 * YCP( C2O3 ) ) / CMN

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_UPDATE( PRNAME, CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function: Update the Process Analysis output arrays (for IPR only)
 
C Preconditions: None
 
C Key Subroutines/Functions Called: None
 
C Revision History:
C  Prototype created by Jerry Gipson, July, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified March, 1998 by Jerry Gipson to use units of moles/s for all
C                                       emisssions except aerosols
C  Modified Jun, 1998 by Jerry Gipson to add PING process
C  Modified Jun, 1998 by Jerry Gipson to print warning for unexpected
C                                     processes rather than abort
C  Modified 1/19/99 by David Wong at LM:
C                      -- add DATA_COPY function call to redistribute PA grid
C  Modified 2/26/99 by David Wong at LM:
C                      -- replaced DATA_COPY function with dimension specific
C                         DATA_COPY function and modified its argument list
C                      -- used ifdef statement to distinguish parallel
C                         implementation of IRR calculation which does not
C                         start at the origin
C  Modified 4/13/00 by Jerry Gipson to add AE surface area and correct AE
C                                   deposition sign
C  Modified 4/17/00 by David Wong at LM:
C                      -- bug fix: declare TDDEP as a 2D data rather than 3D,
C                         and use 2DE DATA COPY communication routine rather
C                         than 3D DATA COPY routine
C  Modified 5/4/00 by Jerry Gipson to correct DDEP calculations
C  Modified 22 Nov 00 by J.Young: Dave Wong`s f90 stenex DATA_COPY -
C                                 must explicitlt dimension CGRID, VEMIS, and DDEP
C  Modified 20 Jun 01 by J.Young: VEMIS, assumed shape
C                                 VEMIS assumed converted to ppm/sec form
C                                 NOTE: the arguments to DATA_COPY must have the layer
C                                 dimension the same as the full domain.
C  Modified 28 aug 01 by J.Young: dyn alloc - Use PAGRD_DEFN,
C                                 which uses HGRD_DEFN; replace INTERP3 with INTERPX
C                                 7 Mar 02 - J.Young: add units string variations
C  Modified  9 Oct 03 by J.Gipson: fixed subscript error for NR EMIS IPRs & re-did
C                                  AE EMIS IPRS for VEMIS in ppm units rather than
C                                  ug/m3 units
C  Modified 5 Nov 03 by J. Gipson to fix DDEP IPRs
C  Modified 25 Nov 03 by J Gipson to use step end time for couple/decouple
C  Modified 31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                              domain specifications in one module (GRID_CONF)
C   3 Apr 09 J.Young: replace EMISPRM... include files with simpler implementation
C  21 Jun 10 J.Young: convert for Namelist redesign
C  16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  11 May 11 D.Wong: incorporated twoway model implementation
C  19 Jan 16 J.Young: flag for couple/decouple
C   6 May 16 J.Young: don`t couple/decouple; copy cgrid locally; only decouple the copy
C  16 Sep 16 J.Young: update for inline procan (IRR)
C  01 Feb 19 D.Wong: Implemented centralized I/O approach
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain configuration
      USE CGRID_SPCS, ONLY : N_CGRID_SPC, CGRID_NAME, CGRID_MASK_AERO,
     &                       AE_STRT, GC_STRT, N_GC_DEPV, GC_DEPV_MAP,
     &                       GC_MOLWT, NR_STRT, N_AE_DEPV, AE_DEPV_MAP, AE_SPC,
     &                       TR_STRT, N_NR_DEPV, NR_DEPV_MAP, NR_MOLWT,
     &                       TR_MOLWT, N_AE_SPC ! CGRID mechanism species
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_SPC, DIFF_MW,
     &                       DIFF_MASK_AERO, DIFF_MASK_NUM, DIFF_MASK_SRF
      USE PA_DEFN               ! Process Anaylsis control and data variables
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE UTILIO_DEFN           ! inherits PARUTILIO
      USE EMIS_VARS
      USE CENTRALIZED_IO_MODULE
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif

      IMPLICIT NONE 

C Includes:
      INCLUDE SUBST_CONST       ! Constants
      INCLUDE SUBST_FILES_ID    ! file name parameters
      INCLUDE SUBST_EMISPRM     ! Emissions processing control parameters
      
C Arguments:
      CHARACTER( * ), INTENT( IN ) :: PRNAME   ! Last process called
      REAL, POINTER :: CGRID( :,:,:,: )  ! Conc array
      INTEGER, INTENT( IN ) :: JDATE       !  current date,    format YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME       !  current time,    format HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 )  ! time step vector (HHMMSS)
                             ! TSTEP(1) = local output step
                             ! TSTEP(2) = sciproc sync. step (chem)
                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                             !            step and wrf/cmaq call frequency

C..Additional or other Arguments for ENTRY`s
      REAL,    INTENT( IN ) :: VEMIS ( :,:,:,: )  ! Emission rates (g/s)
      REAL,    INTENT( IN ) :: DDEP ( :,:,: )     ! Dry dep (Kg/ha)

C Maximum allowable number of unexpected processes
      INTEGER, PARAMETER :: MXUNEXP = 50

C 1 hectare = 1.0e4 m**2
      REAL, PARAMETER :: CONVH2M = 1.0E-4

C mass to ppm factor
      REAL, PARAMETER :: CONVMW = 1.0E+06 * MWAIR

C aerosol emission conversion factor terms
      REAL, PARAMETER :: GPKG = 1.0E+03              ! g/kg
      REAL, PARAMETER :: MGPG = 1.0E+06              ! micro-g/g
      REAL, PARAMETER :: REFAC = 1.0E-06 * GPKG * MGPG / MWAIR

C External Functions: 
      INTEGER, EXTERNAL :: FINDEX    ! Finds the index of a number in a list

C Saved Local Variables:
      CHARACTER( 16 ), SAVE :: UNEXPPR( MXUNEXP )

      INTEGER, SAVE :: NUNEXP = 0 ! Number of unexpected processes
      INTEGER, SAVE :: PRINDEM   ! Emissions output index
      INTEGER, SAVE :: PRINDVD   ! Vertical diffusion output index
      INTEGER, SAVE :: PRINDCH   ! Chemistry output index
      INTEGER, SAVE :: PRINDDD   ! Dry deposition output index
      INTEGER, SAVE :: PRINDAE   ! Dry deposition output index

C Indices for emission species in IPR outputs
      INTEGER, ALLOCATABLE, SAVE :: IPR_NGR2EM( :,: )  ! ( N_IPR_SPC,MXCGRID )

C Indices for dep species in IPR outputs
      INTEGER, ALLOCATABLE, SAVE :: IPR_NGR2DD( :,: )    ! ( N_IPR_SPC,MXCGRID )

      LOGICAL, SAVE :: LEMFIRST = .TRUE. ! Flag for 1st call of emis processing
      LOGICAL, SAVE :: LDDFIRST = .TRUE. ! Flag for 1st call of ddep processing

      LOGICAL, SAVE :: LAE_EM_IPR = .FALSE.  ! AE EMIS IPR requested?

      REAL, SAVE :: CONVDD( 1 )       ! Conversion factor for dry dep

      REAL, ALLOCATABLE, SAVE :: NUMFAC( : )  ! ddep conversion factor (AE only)
C ddep species mass to molar conversion factor
      REAL, ALLOCATABLE, SAVE :: RELWTDD( : )
C emiss species mass to molar conversion factor 
      REAL, ALLOCATABLE, SAVE :: RELWTEM( : )
C ae_conversion factors
      REAL, ALLOCATABLE, SAVE :: PA_EM_CONV( : )

C Reciprocal of map scale factor
      REAL, ALLOCATABLE, SAVE :: RMSFX2( :,: )   
      REAL, ALLOCATABLE, SAVE :: TRMSFX2( :,: )   

C for copy of CGRID
      REAL, ALLOCATABLE, SAVE :: CNGRD( :,:,:,: )   

C Flag for couple/decouple HADV, ZADV, and HDIFF
      LOGICAL, SAVE :: LCOUPLE

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

C Local Variables:
      CHARACTER( 80 ) :: MSG                  ! Message for output log
      CHARACTER( 16 ) :: PNAME = 'PA_UPDATE'  ! Routine name
      CHARACTER( 16 ) :: UNITS                ! Units of emissions
      CHARACTER( 16 ) :: VNAME                !  input variable name list

      INTEGER ASTAT     ! Allocate status code
      INTEGER C         ! Loop index for columns
      INTEGER ICG       ! Index for species in cgrid array
      INTEGER IDD       ! Index for deposition species
      INTEGER IEM       ! Index for emission species
      INTEGER IND       ! Species index
      INTEGER IPA       ! Index of process monitoring output
      INTEGER IPDD      ! Index of PA deposition output variable
      INTEGER IPEM      ! Index of PA emissions output variable
      INTEGER IPAJ      ! Index of PA vert. diff./chem output variable
      INTEGER ISV       ! Index for saved species conc array 
      INTEGER L         ! Loop index for layers
      INTEGER MDATE     ! Date of mid-point of timestep
      INTEGER MTIME     ! Time of mid-point of timestep
      INTEGER N         ! Loop index for saved species conc array
      INTEGER NGR       ! Loop index for number of cgrid species
      INTEGER NPA       ! No. of process monitoring outputs
      INTEGER PC        ! Index for PA output column
      INTEGER PL        ! Index for PA output level
      INTEGER PR        ! Index for PA output row
      INTEGER PRIND     ! Science process index
      INTEGER R         ! Loop index for rows
      INTEGER SP_INDX   ! Index of species in its class
      INTEGER SDATE     ! Date at end of timestep
      INTEGER STIME     ! Time at end of timestep
      INTEGER UNIND     ! Index for unexpected processes

      LOGICAL LAESP     ! Flag for AE species

      REAL    CONVFC    ! Temporary conversion factor
      REAL    DT        ! Timestep in seconds
      REAL    DDX       ! Cell inverse x-width
      REAL    DDY       ! Cell inverse y-width
      REAL    DX        ! Cell x-width
      REAL    DY        ! Cell y-width

      REAL :: TCGRID  ( MY_PACOLS,MY_PAROWS,PALEVS )  
      REAL :: DENSA_J ( NCOLS,NROWS,NLAYS )  ! Density times Jacobian
      REAL :: TDENSA_J( MY_PACOLS,MY_PAROWS,PALEVS )  
      REAL :: DENS    ( NCOLS,NROWS,NLAYS )  ! Density of air
      REAL :: TDENS   ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
      REAL :: TVEMIS  ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
      REAL :: EM      ( MY_PACOLS,MY_PAROWS,PALEVS )  ! Computed emission rate
      REAL :: TDDEP   ( MY_PACOLS,MY_PAROWS )
      REAL    NETDEP  ( MY_PACOLS,MY_PAROWS )  ! Net dep for hour, converted to  kg/m**3
      REAL :: ZF      ( NCOLS,NROWS,NLAYS )  ! Layer heights
      REAL :: TZF     ( MY_PACOLS,MY_PAROWS,PALEVS )

      REAL :: X3FACE( 0:NLAYS )   ! vertical coordinate layer surface

      INTERFACE
         SUBROUTINE DECOUPLE_PA ( CONC, JDATE, JTIME )
            REAL,    INTENT( INOUT ) :: CONC( :,:,:,: )
            INTEGER, INTENT( IN ) :: JDATE, JTIME
         END SUBROUTINE DECOUPLE_PA
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ALLOCATE ( CNGRD( NCOLS,NROWS,NLAYS,SIZE( CGRID,4 ) ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = '*** ERROR allocating CNGRD'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF
      END IF

C Get process index and convert units if necessary
      PRIND = INDEX1( PRNAME, NPRCS, PROCNAME )

      IF ( PRIND .EQ. 0 ) THEN
         UNIND = INDEX1( PRNAME, MXUNEXP, UNEXPPR )
         IF ( UNIND .EQ. 0 ) THEN
            MSG = 'Warning: Process Analysis not expecting process ' // PRNAME 
            CALL M3MESG( MSG )
            NUNEXP = NUNEXP + 1
            IF ( NUNEXP .GT. MXUNEXP ) THEN
               MSG = 'Maximum number of unexpected processes for '
     &              // 'Process Analysis exceeded' 
               CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
            END IF
            UNEXPPR( NUNEXP ) = PRNAME
         END IF
      END IF

      CNGRD = CGRID  ! local copy (separate memory)
      
      LCOUPLE = PRNAME .EQ. 'HADV' .OR. PRNAME .EQ. 'ZADV' .OR. PRNAME .EQ. 'HDIF'
      IF ( LCOUPLE ) THEN
         SDATE = JDATE; STIME = JTIME
         CALL NEXTIME( SDATE, STIME, TSTEP( 2 ) )
         CALL DECOUPLE_PA( CNGRD, SDATE, STIME )
      END IF

C..Compute delta conc for this process if requested
      IF ( PRIND .GT. 0 .AND. LPROCOUT( PRIND ) ) THEN
         DO NPA = 1, N_IPR_SPC
            IPA = IPROUT( NPA,PRIND )
            IF ( IPA .NE. 0 ) THEN
               DO NGR = 1, NCGRID( NPA )
                  ICG = IPR2GRD( NPA,NGR )
                  ISV = IPR2SAV( NPA,NGR )
#ifdef parallel
                  CALL SUBST_DATA_COPY( CNGRD, TCGRID, ICG )
#else
                  TCGRID( :,:,: ) = CNGRD( PA_BEGCOL:PA_ENDCOL,PA_BEGROW:PA_ENDROW,
     &                                     PA_BEGLEV:PA_ENDLEV,ICG )
#endif
                  DELC( :,:,:,IPA ) = DELC( :,:,:,IPA ) + SPCOEF( NPA,NGR ) 
     &                 * ( TCGRID( :,:,: ) - CSAV( :,:,:,ISV ) )
               END DO
            END IF
         END DO 
      END IF

C..Save concentrations for next delta c
      DO N = 1, NCSAVE
         ICG = SAV2GRD( N )
#ifdef parallel
         CALL SUBST_DATA_COPY( CNGRD, CSAV, ICG, N )
#else
         CSAV( :,:,:,N ) = 
     &       CNGRD( PA_BEGCOL:PA_ENDCOL,PA_BEGROW:PA_ENDROW,
     &              PA_BEGLEV:PA_ENDLEV,ICG )
#endif
      END DO

      RETURN

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Emissions processing section
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ENTRY PA_UPDATE_EMIS( PRNAME, VEMIS, JDATE, JTIME, TSTEP )

C..On first call, set pointers to emission species
      IF ( LEMFIRST ) THEN
         LEMFIRST = .FALSE.

         ALLOCATE ( IPR_NGR2EM( N_IPR_SPC,MXCGRID ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating IPR_NGR2EM'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF

         ALLOCATE ( PA_EM_CONV( N_SPC_DIFF ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating PA_EM_CONV'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF
         PA_EM_CONV = 1.0

C..Set-up pointers to emis, vdiff, chem, and aero processes         
         PRINDEM = INDEX1( 'EMIS', NPRCS, PROCNAME )
         PRINDVD = INDEX1( 'VDIF', NPRCS, PROCNAME )

C..Set the pointers to the emission array
         DO NPA = 1, N_IPR_SPC            ! foreach family

            DO NGR = 1, NCGRID( NPA )     ! foreach species in the family

               ICG = IPR2GRD( NPA,NGR )  ! CTM species index in the family
               IPR_NGR2EM( NPA,NGR ) = 0 
               IND = 0

               ! Determine Position of Species on Emission Rate Array
               IND = INDEX1( CGRID_NAME( ICG ), N_SPC_DIFF, DIFF_SPC )
               IF ( IND .GT. 0 ) THEN
                  IPR_NGR2EM( NPA,NGR ) = IND 
                  IF ( CGRID_MASK_AERO( ICG ) ) LAE_EM_IPR = .TRUE.
               END IF   

            END DO      ! end species in the family loop
         END DO         ! end family loop

C..set cell widths
         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX = DG2M * XCELL_GD          ! in m.
            DY = DG2M * YCELL_GD *
     &           COS( PI180 * ( YORIG_GD + YCELL_GD * 
     &           FLOAT( NROWS ) ) )       ! in m.
         ELSE
            DX = XCELL_GD                  ! in m
            DY = YCELL_GD                  ! in m
         END IF
         DDX = 1.0 / DX
         DDY = 1.0 / DY

C..get conversion factors for aero emissions; as of sep 03 release, incoming
C  units are in ppmV/sec for ae species, # aer x 10**6/ # molec air / sec for
C  NUM, and m2/mol sec for SRF.  Conversion factors convert to 
C  ug/m3 sec, #/m3 sec, and m2/m3 sec, respectively.
         IF ( LAE_EM_IPR ) THEN
             WHERE ( DIFF_MASK_NUM ) 
                 PA_EM_CONV( : ) = REFAC * AVO / MGPG
             ELSEWHERE ( DIFF_MASK_SRF ) 
                 PA_EM_CONV( : ) = 1.0E+06 * REFAC / MGPG
             ELSEWHERE
                 PA_EM_CONV( : ) = REFAC * DIFF_MW( : )
             END WHERE
         END IF

      END IF  ! LEMFIRST

C..get midpoint of time step
      MDATE = JDATE
      MTIME = JTIME
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( TIME2SEC( TSTEP( 2 ) ) / 2 ) ) 

C..Get air density if needed
      IF ( LAE_EM_IPR ) THEN
         call interpolate_var ('DENS', mdate, mtime, DENS)
      END IF

C..Compute delta conc due to emissions and adjust vdiff or chem
C..output if necessary for each output species
      DT = FLOAT( TIME2SEC( TSTEP( 2 ) ) )

      DO NPA = 1, N_IPR_SPC              ! foreach family
         IPEM = IPROUT( NPA,PRINDEM )    ! emis species index for this process
         IPAJ = IPROUT( NPA,PRINDVD )
         IF ( IPEM + IPAJ .EQ. 0 ) CYCLE

         DO NGR = 1, NCGRID( NPA )       ! foreach species in the family
            IEM = IPR_NGR2EM( NPA,NGR )
            IF ( IEM .EQ. 0 ) CYCLE  ! Skip Species without emissions PA output

            ICG = IPR2GRD( NPA,NGR )     ! CTM species index in the family
            LAESP = CGRID_MASK_AERO( ICG ) ! Flag for aerosol species

#ifdef parallel
               CALL SUBST_DATA_COPY ( VEMIS, TVEMIS, IEM )
               IF ( LAESP ) CALL SUBST_DATA_COPY ( DENS, TDENS )
#else
               TVEMIS( :,:,: ) = VEMIS( PA_BEGROW:PA_ENDROW,
     &                                  PA_BEGCOL:PA_ENDCOL,
     &                                  PA_BEGLEV:PA_ENDLEV,
     &                                  IEM )
               TDENS = DENS( PA_BEGROW:PA_ENDROW,PA_BEGCOL:PA_ENDCOL,
     &                       PA_BEGLEV:PA_ENDLEV )
#endif
               EM( :,:,: ) = TVEMIS( :,:,: ) * DT
               IF ( LAESP ) EM = EM * TDENS( :,:,: ) * PA_EM_CONV( IEM )

               ! Modify both the emiss process and the calling process
               IF ( IPEM .NE. 0 )
     &            DELC( :,:,:,IPEM ) = DELC( :,:,:,IPEM )
     &                              + SPCOEF( NPA,NGR ) * EM( :,:,: )
               IF ( IPAJ .NE. 0 )
     &            DELC( :,:,:,IPAJ ) = DELC( :,:,:,IPAJ )
     &                              - SPCOEF( NPA,NGR ) * EM( :,:,: )
         END DO
      END DO

      RETURN

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Dry Deposition processing section
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      ENTRY PA_UPDATE_DDEP( PRNAME, DDEP, JDATE, JTIME, TSTEP )

C..On first call, set pointers to deposition species 
      IF ( LDDFIRST ) THEN

         ALLOCATE ( IPR_NGR2DD( N_IPR_SPC,MXCGRID ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating IPR_NGR2DD'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF
 
         ALLOCATE ( NUMFAC( N_CGRID_SPC ),
     &              RELWTDD( N_CGRID_SPC ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating NUMFAC or RELWTDD'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF

         PRINDDD = INDEX1( 'DDEP', NPRCS, PROCNAME )
         PRINDVD = INDEX1( 'VDIF', NPRCS, PROCNAME )

C..set pointers for the ddep array
         DO NPA = 1, N_IPR_SPC 
            DO NGR = 1, NCGRID( NPA )

               ICG = IPR2GRD( NPA, NGR )
               IPR_NGR2DD( NPA, NGR ) = 0
               IND = 0

               IF ( ICG .LT. AE_STRT ) THEN

                  SP_INDX = ICG - GC_STRT + 1
                  IND = FINDEX ( SP_INDX, N_GC_DEPV, GC_DEPV_MAP )

                  IF ( IND .NE. 0 ) THEN                  
                     IPR_NGR2DD( NPA, NGR ) = IND
                     RELWTDD( ICG ) = CONVMW / GC_MOLWT( ICG )
                  END IF

               ELSE IF ( ICG .GE. AE_STRT .AND. ICG .LT. NR_STRT ) THEN

                  SP_INDX = ICG - AE_STRT + 1
                  IND = FINDEX ( SP_INDX, N_AE_DEPV, AE_DEPV_MAP )

                  IF ( IND .NE. 0 ) THEN                 
                     IPR_NGR2DD( NPA, NGR ) = N_GC_DEPV + IND
                     IF ( AE_SPC( SP_INDX )( 1:3 ) .EQ. 'NUM' ) THEN
                        NUMFAC( ICG ) = 1.0
                     ELSE IF ( AE_SPC( SP_INDX )( 1:3 ) .EQ. 'SRF' ) THEN
                        NUMFAC( ICG ) = 1.0
                     ELSE
                        NUMFAC( ICG ) = 1.0E+09
                     END IF
                  END IF

               ELSE IF ( ICG .GE. NR_STRT .AND. ICG .LT. TR_STRT ) THEN

                  SP_INDX = ICG - NR_STRT + 1
                  IND = FINDEX ( SP_INDX, N_NR_DEPV, NR_DEPV_MAP )

                  IF ( IND .NE. 0 )  THEN
                     IPR_NGR2DD( NPA, NGR ) = N_GC_DEPV + N_AE_DEPV + IND
                     RELWTDD( ICG ) = CONVMW / NR_MOLWT( SP_INDX )
                  END IF

               ELSE IF ( ICG .GE. TR_STRT ) THEN

                  SP_INDX = ICG - TR_STRT + 1
                  IND = FINDEX ( SP_INDX, N_NR_DEPV, NR_DEPV_MAP )

                  IF ( IND .NE. 0 ) THEN
                     IPR_NGR2DD( NPA, NGR ) = N_GC_DEPV + N_AE_DEPV
     &                                      + N_NR_DEPV + IND
                     RELWTDD( ICG ) = CONVMW / TR_MOLWT( SP_INDX )
                  END IF
               END IF
            END DO            
         END DO

C..set layer layer thickenesses
         X3FACE( 0 ) = VGLVS_GD( 1 )
         DO L = 1, NLAYS
            X3FACE( L ) = VGLVS_GD( L + 1 )
         END DO

         L = 1
         CONVDD( L ) = 1.0 / ABS ( X3FACE( L ) - X3FACE( L - 1 ) ) 

         ALLOCATE ( RMSFX2( NCOLS,NROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating RMSFX4'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF

         RMSFX2 = 1.0 /  MSFX2        ! Array calculation

         ALLOCATE ( TRMSFX2( MY_PACOLS,MY_PAROWS ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            MSG = 'Failure allocating RMSFX4'
            CALL M3EXIT( PNAME, JDATE, JTIME, MSG, XSTAT1 )
         END IF
#ifdef parallel
!        CALL SUBST_DATA_COPY( RMSFX2, TRMSFX2 )
         CALL SUBST_DATA_COPY( MSFX2, TRMSFX2 )
#else
         TRMSFX2 = RMSFX2( PA_BEGCOL:PA_ENDCOL,PA_BEGROW:PA_ENDROW )

#endif
         
         LDDFIRST = .FALSE.           

      END IF

      IF ( MY_BEGLEV .GT. 1 ) RETURN

C..get midpoint of time step
      MDATE = JDATE
      MTIME = JTIME
      CALL NEXTIME( MDATE, MTIME, SEC2TIME( TIME2SEC( TSTEP( 2 ) ) / 2 ) )

C..get density x jacobian and layer heights

      call interpolate_var ('DENSA_J', mdate, mtime, DENSA_J)

      IF ( N_AE_SPC .GT. 0 ) THEN

         call interpolate_var ('ZF', mdate, mtime, ZF)

      END IF

#ifdef parallel
      CALL SUBST_DATA_COPY( DENSA_J, TDENSA_J )
      IF ( N_AE_SPC .GT. 0 ) CALL SUBST_DATA_COPY ( ZF, TZF )
#else
      TDENSA_J = DENSA_J( PA_BEGCOL:PA_ENDCOL,PA_BEGROW:PA_ENDROW,
     &                    PA_BEGLEV:PA_ENDLEV )
      IF ( N_AE_SPC .GT. 0 ) TZF = ZF( PA_BEGCOL:PA_ENDCOL,
     &                       PA_BEGROW:PA_ENDROW,PA_BEGLEV:PA_ENDLEV )
#endif

C..Compute delta conc due to ddep and adjust vdiff output if necessary
      DO NPA = 1, N_IPR_SPC
         IPDD = IPROUT( NPA,PRINDDD )
         IPAJ = IPROUT( NPA,PRINDVD ) 
         IF ( IPDD + IPAJ .EQ. 0 ) CYCLE

         DO NGR = 1, NCGRID( NPA )                       
            IDD = IPR_NGR2DD( NPA,NGR )
            IF ( IDD .EQ. 0 ) CYCLE

            ICG = IPR2GRD( NPA,NGR )
#ifdef parallel
            CALL SUBST_DATA_COPY( DDEP, TDDEP, IDD )
#else
            TDDEP = DDEP( PA_BEGCOL:PA_ENDCOL,PA_BEGROW:PA_ENDROW,
     &                    IDD )
#endif

C..compute the dep in ppm
            IF ( ICG .GE. AE_STRT. AND. ICG .LT. NR_STRT ) THEN
               NETDEP( :,: ) = TDDEP( :,: ) * CONVH2M
     &                * NUMFAC( ICG ) / TZF( :,:,1 )
            ELSE
               NETDEP( :,: ) = TDDEP( :,: ) * CONVH2M
     &                * RELWTDD( ICG ) * CONVDD( 1 )
     &                * TRMSFX2( :,: ) / TDENSA_J( :,:,1 ) 
            END IF

C..adjust the process analysis output arrays
            IF ( IPDD .NE .0 )
     &         DELC( :,:,1,IPDD ) = DELC( :,:,1,IPDD )
     &                              - SPCOEF( NPA,NGR ) * NETDEP( :,: )

            IF ( IPAJ .NE. 0 )
     &         DELC( :,:,1,IPAJ ) = DELC( :,:,1,IPAJ )  
     &                              + SPCOEF( NPA,NGR ) * NETDEP( :,: )
         END DO   ! NGR
      END DO   ! NPA

      RETURN

      END SUBROUTINE PA_UPDATE

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE PA_UPDATE_AERO ( JDATE, JTIME )

C-----------------------------------------------------------------------
      USE AERO_BUDGET
      USE PA_DEFN
      USE UTILIO_DEFN
      USE PAGRD_DEFN


      IMPLICIT NONE

      INTEGER JDATE, JTIME

      INTEGER :: PCOAG, PCOND, PNPF, PGROWTH
      INTEGER :: IPCOAG, IPCOND, IPNPF, IPGROWTH
      INTEGER :: NPA, NGR, ICG

      PCOAG  = INDEX1( 'COAG',NPRCS,PROCNAME )
      PCOND  = INDEX1( 'COND',NPRCS,PROCNAME )
      PNPF   = INDEX1( 'NPF' ,NPRCS,PROCNAME )
      PGROWTH= INDEX1( 'GROW',NPRCS,PROCNAME )

      DO NPA = 1, N_IPR_SPC              ! foreach family
          
         IPCOAG = IPROUT( NPA, PCOAG  )  ! coag index for this process
         IPCOND = IPROUT( NPA, PCOND  )  ! cond index for this process
         IPNPF  = IPROUT( NPA, PNPF   )  ! NPF index for this process
         IPGROWTH=IPROUT( NPA, PGROWTH)  ! Growth index for this process
         IF ( IPCOAG + IPCOND + IPNPF + IPGROWTH .EQ. 0 ) CYCLE

         DO NGR = 1,NCGRID( NPA )          ! foreach species in the family
            ICG = IPR2GRD( NPA,NGR )       ! CGRID species index 

               ! Modify both the emiss process and the calling process
               IF ( IPCOAG .NE. 0 )
     &            DELC( :,:,:,IPCOAG ) = DELC( :,:,:,IPCOAG )
     &                              + SPCOEF( NPA,NGR ) * SUM( AERO_COAG( :,:,:,ICG,: ),4 )
               IF ( IPCOND .NE. 0 )
     &            DELC( :,:,:,IPCOND ) = DELC( :,:,:,IPCOND )
     &                              + SPCOEF( NPA,NGR ) * AERO_COND( :,:,:,ICG )
               IF ( IPNPF .NE. 0 )
     &            DELC( :,:,:,IPNPF  ) = DELC( :,:,:,IPNPF )
     &                              + SPCOEF( NPA,NGR ) * AERO_NPF( :,:,:,ICG )
               IF ( IPGROWTH .NE. 0 ) 
     &            DELC( :,:,:,IPGROWTH)= DELC( :,:,:,IPGROWTH )
     &                              + SPCOEF( NPA,NGR ) * AERO_GROWTH( :,:,:,ICG )
         END DO
      END DO

      RETURN
 



      END SUBROUTINE PA_UPDATE_AERO

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DECOUPLE_PA ( CONC, JDATE, JTIME )
C-----------------------------------------------------------------------
C Function:
C   Convert units and decouple concentration values in CGRID from transport
C   CONC is a copy of the current CGRID
 
C Preconditions:
 
C Subroutines and functions called:
C   INTERPX, M3EXIT
 
C Revision History:
C  6 May 16 J.Young: initial - part of pa_update.F file
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_MASK_SRF, DIFF_MASK_NUM, DIFF_MAP,
     &                      DIFF_MASK_AERO
      use CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE   

C Include files:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      REAL,    INTENT( INOUT ) :: CONC( :,:,:,: )   ! concentrations
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS

C Parameters:
      REAL, PARAMETER :: GPKG = 1.0E+03   ! g/kg
      REAL, PARAMETER :: MGPG = 1.0E+06   ! micro-g/g
      REAL, PARAMETER :: CONV = GPKG * MGPG

C External Functions:

C File Variables:
      REAL       RJACOBM( NCOLS,NROWS,NLAYS )  ! reciprocal midlayer Jacobian
      REAL       RRHOJ  ( NCOLS,NROWS,NLAYS )  ! reciprocal Jacobian * air density

C Local Variables:
      CHARACTER( 16 ) :: PNAME = 'DECOUPLE_PA'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER     V  ! loop counters
      INTEGER     RHOJ_LOC         ! pointer to transported RHOJ (in CONC)

C-----------------------------------------------------------------------

C retrieve transported RhoJ
      RHOJ_LOC = GC_STRT + N_GC_SPC
      RRHOJ( :,:,: ) = CONC( :,:,:,RHOJ_LOC )
      RRHOJ = 1.0 / RRHOJ   ! array assignment

      call interpolate_var ('JACOBM', jdate, jtime, RJACOBM)

      RJACOBM = 1.0 / RJACOBM   ! array assignment
 
C decouple for chemistry and diffusion
C The CONC array is ordered like CGRID but only the DIFF species should
C be modified. Use DIFF_MAP
      DO V = 1,N_SPC_DIFF
          IF ( DIFF_MASK_NUM( V ) .OR. DIFF_MASK_SRF( V ) ) THEN 
            CONC( :,:,:,DIFF_MAP( V ) ) = 
     &          CONC( :,:,:,DIFF_MAP( V ) ) * RJACOBM( :,:,: )
          ELSE IF ( DIFF_MASK_AERO( V ) ) THEN
            CONC( :,:,:,DIFF_MAP( V ) ) = 
     &          CONC( :,:,:,DIFF_MAP( V ) ) * CONV * RJACOBM( :,:,: )
          ELSE
            CONC( :,:,:,DIFF_MAP( V ) ) = 
     &          CONC( :,:,:,DIFF_MAP( V ) ) * RRHOJ( :,:,: )
          END IF
      END DO

      RETURN

      END SUBROUTINE DECOUPLE_PA

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE STK_PRMS

C-----------------------------------------------------------------------
C Function: stack parameters from stack groups file

C Revision History:
C     29 Dec 2006 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C      3 Nov 2011 D.Wong: fix source location within grid determination bug
C     30 Apr 2016 J.Young: add multiple fire source capability, in affiliation with
C                          Yongtao Hu (Georgia Tech)
C     01 Feb 2019 D.Wong: Implemented centralized I/O approach and moved some of
C                         data declaration in this module to stack_group_data_module 
C                         (model_data_module.f) to avoid cyclic dependence
C-----------------------------------------------------------------------

      USE UDTYPES, ONLY: IARRY1, RARRY1

      IMPLICIT NONE

      INTEGER,        ALLOCATABLE, SAVE :: MY_NSRC( : )

      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: SOURCE     ( : ) ! my stack source index
      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: MY_STKCOL  ( : )
      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: MY_STKROW  ( : )
      TYPE( IARRY1 ), ALLOCATABLE, SAVE :: MY_STKID   ( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: MY_XLOCA   ( : ) ! X-location [grid coord]
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: MY_YLOCA   ( : ) ! Y-location [grid coord]
      INTEGER,        ALLOCATABLE, SAVE :: MY_STRT_SRC( : )
      INTEGER,        ALLOCATABLE, SAVE :: MY_END_SRC ( : )

      CONTAINS

         FUNCTION STK_PRMS_INIT ( STKPRMS ) RESULT ( SUCCESS )

         USE HGRD_DEFN             ! horizontal domain specifications
         USE UTILIO_DEFN
         USE stack_group_data_module

         IMPLICIT NONE

         CHARACTER( 16 ), INTENT( IN ) :: STKPRMS( : )   ! stack groups file names
         LOGICAL SUCCESS

         INTEGER, ALLOCATABLE :: LOC_MAP( : )

         INTEGER SCOL, ECOL, SROW, EROW
         INTEGER C, R, STRT_SRC, END_SRC, MY_DELTA, N, NGRPS
         REAL    X, Y

         INTEGER M, S, SRC, V, ASTAT
         CHARACTER( 96 ) :: XMSG = ' '
         CHARACTER( 16 ) :: PNAME = 'STK_PRMS_INIT'

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         M = MYPE + 1
         SCOL = COLSX_PE( 1,M ); ECOL = COLSX_PE( 2,M )
         SROW = ROWSX_PE( 1,M ); EROW = ROWSX_PE( 2,M )

         NGRPS = SIZE( STKPRMS )

         ALLOCATE ( MY_NSRC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_NSRC', PNAME )

         ALLOCATE ( SOURCE( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'SOURCE', PNAME )

         ALLOCATE ( MY_STKCOL( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STKCOL', PNAME )

         ALLOCATE ( MY_STKROW( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STKROW', PNAME )

         ALLOCATE ( MY_STKID( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STKID', PNAME )

         ALLOCATE ( MY_XLOCA( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_XLOCA', PNAME )

         ALLOCATE ( MY_YLOCA( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_YLOCA', PNAME )

         ALLOCATE ( MY_STRT_SRC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_STRT_SRC', PNAME )

         ALLOCATE ( MY_END_SRC( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'MY_END_SRC', PNAME )

         ALLOCATE ( STKDIAM( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKDIAM', PNAME )

         ALLOCATE ( STKHT( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKHT', PNAME )

         ALLOCATE ( STKTK( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKTK', PNAME )

         ALLOCATE ( STKVEL( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'STKVEL', PNAME )

         ALLOCATE ( ACRES_BURNED( NGRPS ), STAT = ASTAT )
         CALL CHECKMEM( ASTAT, 'ACRES_BURNED', PNAME )

         DO N = 1, NGRPS

!           IF ( .NOT. OPEN3( STKPRMS( N ), FSREAD3, PNAME ) ) THEN
!              XMSG = 'Could not open '// TRIM( STKPRMS( N ) ) // ' file'
!              CALL M3MESG( XMSG )
!              SUCCESS = .FALSE.; RETURN
!           END IF

!           IF ( .NOT. DESC3( STKPRMS( N ) ) ) THEN
!              XMSG = 'Could not get ' // TRIM( STKPRMS( N ) ) // ' file description'
!              CALL M3MESG( XMSG )
!              SUCCESS = .FALSE.; RETURN
!           END IF

            ALLOCATE ( LOC_MAP( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'LOC_MAP', PNAME )

            SOURCE( N )%LEN = NSRC( N )
            ALLOCATE ( SOURCE( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'SOURCE', PNAME )

            MY_STKCOL( N )%LEN = NSRC( N )
            ALLOCATE ( MY_STKCOL( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_STKCOL', PNAME )

            MY_STKROW( N )%LEN = NSRC( N )
            ALLOCATE ( MY_STKROW( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_STKROW', PNAME )

            MY_STKID( N )%LEN = NSRC( N )
            ALLOCATE ( MY_STKID( N )%ARRY( NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_STKID', PNAME )

            MY_NSRC( N ) = 0
            STRT_SRC = 0; END_SRC = 0
            DO S = 1, NSRC( N )
               X = ( XLOCA( S, N ) - REAL( XORIG_GD, 4 ) ) / REAL( XCELL_GD, 4 )
               IF ( X .GE. 0.0 ) THEN
                  C = 1 + INT( X )
               ELSE
                  C = -1 - INT( -X )
               END IF
               IF ( C .GE. SCOL .AND. C .LE. ECOL ) THEN
                  Y = ( YLOCA( S, N ) - REAL( YORIG_GD, 4 ) ) / REAL( YCELL_GD, 4 )
                  IF ( Y .GE. 0.0 ) THEN
                     R = 1 + INT( Y )
                  ELSE
                     R = -1 - INT( -Y )
                  END IF
                  IF ( R .GE. SROW .AND. R .LE. EROW ) THEN
                     IF ( STRT_SRC .LE. 0 ) STRT_SRC = S
                     END_SRC = S
                     MY_NSRC( N ) = MY_NSRC( N ) + 1
                     LOC_MAP( MY_NSRC( N ) ) = S
                     SOURCE( N )%ARRY( MY_NSRC( N ) ) = S - STRT_SRC + 1  !**
                     MY_STKCOL( N )%ARRY( MY_NSRC( N ) ) = C - SCOL + 1
                     MY_STKROW( N )%ARRY( MY_NSRC( N ) ) = R - SROW + 1
                     MY_STKID( N )%ARRY( MY_NSRC( N ) ) = STKID( S, N )
                  END IF
               END IF
            END DO

C** SOURCE is the mapping from STKEMIS read by INTERPX starting at one.
C INTERPX reads a contiguous set from MY_STRT_SRC to MY_END_SRC into STKEMIS.
C So MY_STRT_SRC maps into the first index of STKEMIS.
C SOURCE must map skips in data between MY_STRT_SRC and MY_END_SRC.
C SOURCE maps STKEMIS read from stk emis file to local STKEM in GET_PT3D_EMIS.

            MY_STRT_SRC( N ) = STRT_SRC
            MY_END_SRC( N ) = END_SRC
            MY_DELTA = END_SRC - STRT_SRC + 1

            STKDIAM( N )%LEN = MY_DELTA
            ALLOCATE ( STKDIAM( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKDIAM', PNAME )

            STKHT( N )%LEN = MY_DELTA
            ALLOCATE ( STKHT( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKHT', PNAME )

            STKTK( N )%LEN = MY_DELTA
            ALLOCATE ( STKTK( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKTK', PNAME )

            STKVEL( N )%LEN = MY_DELTA
            ALLOCATE ( STKVEL( N )%ARRY( MY_DELTA ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'STKVEL', PNAME )

            IF ( FIRE_ON( N ) ) THEN
               ACRES_BURNED( N )%LEN = MY_DELTA
               ALLOCATE ( ACRES_BURNED( N )%ARRY( MY_DELTA ), STAT = ASTAT )
               CALL CHECKMEM( ASTAT, 'ACRES_BURNED', PNAME )
            END IF

            MY_XLOCA( N )%LEN = MY_NSRC( N )
            ALLOCATE ( MY_XLOCA( N )%ARRY( MY_NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_XLOCA', PNAME )
            MY_XLOCA( N )%ARRY = 0.0   ! array

            MY_YLOCA( N )%LEN = MY_NSRC( N )
            ALLOCATE ( MY_YLOCA( N )%ARRY( MY_NSRC( N ) ), STAT = ASTAT )
            CALL CHECKMEM( ASTAT, 'MY_YLOCA', PNAME )
            MY_YLOCA( N )%ARRY = 0.0   ! array

            IF ( MY_NSRC( N ) .LE. 0 ) THEN

               MY_DELTA = 0

               MY_XLOCA( N )%LEN = MY_NSRC( N )
               MY_YLOCA( N )%LEN = MY_NSRC( N )

            END IF   ! MY_NSRC( N ) .GT. 0
        
            DO S = 1, MY_NSRC( N )
               SRC = LOC_MAP( S )
               MY_XLOCA( N )%ARRY( S ) = XLOCA( SRC, N )
               MY_YLOCA( N )%ARRY( S ) = YLOCA( SRC, N )
            END DO

            DEALLOCATE ( LOC_MAP )

         END DO   ! NGRPS

         RETURN

         END FUNCTION STK_PRMS_INIT

      END MODULE STK_PRMS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C......................................................................
      MODULE PA_IPRDEF
 
C CONTAINS: Defines science processes contained in the CMAQ and the 
C           IPR operators that can be used
 
C DEPENDENT UPON: Nothing, but if the process names and/or operator
C                 names are changed, the definitions of the 
C                 operators must be re-programmed in pa_setup_ipr.F.
 
C REVISION HISTORY:
C  Prototype created by Jerry Gipson, Sept, 1997 for the targeted CTM
C  Modified June 3, 1998 by Jerry Gipson to add PING to the CTM science processes
C  Modified June 4, 2005 by Jeff Young to deal with Yamo (Yamartino-type)
C  advection scheme 
C  27 Jan 2006, J.Young: change all operator names to be 4 chars - they prepend
C  species names, which must remain less that 12 chars, i.e. OPNM_<__SPECIES__>
C                                                            12345 67890123456
C  27 Jun 2016, J.Young: moved PA_IPRDEF.EXT to PA_IPRDEF.F module
C......................................................................

      USE PA_DEFN, Only: NPRCS, PROCNAME

      IMPLICIT NONE

      INTEGER, PARAMETER :: NOPNAMES = 16  ! Number of IPR_OUTPUT operators

      CHARACTER( 16 ) :: OPNAME( NOPNAMES ) = (/  ! IPR_OUTPUT Operator names
     &                   'ZADV         ',  !  1
     &                   'HADV         ',  !  2
     &                   'HDIF         ',  !  3
     &                   'VDIF         ',  !  4
     &                   'EMIS         ',  !  5
     &                   'DDEP         ',  !  6
     &                   'CLDS         ',  !  7
     &                   'CHEM         ',  !  8
     &                   'COND         ',  !  9
     &                   'COAG         ',  ! 10
     &                   'NPF          ',  ! 11
     &                   'GROW         ',  ! 12
     &                   'AERO         ',  ! 13
     &                   'MADV         ',  ! 14
     &                   'TDIF         ',  ! 15
     &                   'TRNM         ' /)! 16

      END MODULE PA_IPRDEF

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains utility functions to support centralized I/O 
! implementation

! Revision History:
!  02/01/19, D. Wong: initial implementation
!  08/01/19, D. Wong: modified code to work with two-way model
!  11/20/19, F. Sidi: Modified time to sec to handle negative numbers
!------------------------------------------------------------------------!

      module centralized_io_util_module

        implicit none

        interface quicksort
          module procedure quicksort1d,
     &                     quicksort2d
        end interface

        contains

! -------------------------------------------------------------------------
        recursive subroutine quicksort1d (name, begin, end)

          character (*), intent(out) :: name(:)
          integer, intent(in)         :: begin, end

          integer        :: i, j
          character (50) :: str1, str2
          logical        :: done

          str1 = name( (begin + end) / 2 )
          i = begin
          j = end
          done = .false.
          do while (.not. done)
             do while (name(i) < str1)
                i = i + 1
             end do
             do while (str1 < name(j))
                j = j - 1
             end do
             if (i .ge. j) then
                done = .true.
             else
                str2 = name(i)  
                name(i) = name(j)
                name(j) = str2
                i = i + 1
                j = j - 1
             end if
          end do
          if (begin < i-1) call quicksort(name, begin, i-1)
          if (j+1 < end)   call quicksort(name, j+1, end)

        end subroutine quicksort1d

! -------------------------------------------------------------------------
        recursive subroutine quicksort2d (name, begin, end)

          character (*), intent(out) :: name(:,:)
          integer, intent(in)         :: begin, end

          integer        :: i, j, dsize
          character (50) :: str1, str2(3)
          logical        :: done

          dsize = size(name,2)
          str1 = name( (begin + end) / 2, 1 )
          i = begin
          j = end
          done = .false.
          do while (.not. done)
             do while (name(i,1) < str1)
                i = i + 1
             end do
             do while (str1 < name(j, 1))
                j = j - 1
             end do
             if (i .ge. j) then
                done = .true.
             else
                str2(1:dsize) = name(i,:)  
                name(i,:) = name(j,:)
                name(j,:) = str2(1:dsize)
                i = i + 1
                j = j - 1
             end if
          end do
          if (begin < i-1) call quicksort(name, begin, i-1)
          if (j+1 < end)   call quicksort(name, j+1, end)

        end subroutine quicksort2d

! -------------------------------------------------------------------------
        function binary_search (name, list, n) result (loc)

          character (*), intent(in) :: name, list(:)
          integer, intent(in)        :: n
          integer :: loc

          logical :: found
          integer :: mid_loc, start_loc, end_loc

          start_loc = 1
          end_loc   = n
          found = .false.
          do while ((start_loc .le. end_loc) .and. (.not. found))
             mid_loc = start_loc + (end_loc - start_loc) / 2
             if (name .lt. list(mid_loc)) then
                end_loc = mid_loc - 1
             else if (name .gt. list(mid_loc)) then
                start_loc = mid_loc + 1
             else
                found = .true.
             end if
          end do

          if (found) then
             loc = mid_loc
          else
             loc = -1
          end if

        end function binary_search

! -------------------------------------------------------------------------
        function search (name, list, n) result (loc)

          character (*), intent(in) :: name, list(:)
          integer, intent(in)        :: n
          integer :: loc

          logical :: found
          integer :: lloc

          lloc = 0
          found = .false.
          do while ((lloc .le. n) .and. (.not. found))
             lloc = lloc + 1
             if (name .eq. list(lloc)) then
                found = .true.
             end if
          end do

          if (found) then
             loc = lloc
          else
             loc = -1
          end if

        end function search

! -------------------------------------------------------------------------
        integer function time_to_sec (time)

          integer, intent(in) :: time
          integer :: neg_time
          integer :: time_in_sec, hr, min, sec

          if (time .gt. 0) then
             hr = time / 10000
             min = mod(time/100, 100)
             sec = mod(time, 100)
             time_to_sec = hr * 3600 + min * 60 + sec
          else
             neg_time = abs(time)
             hr = neg_time / 10000
             min = mod(neg_time/100, 100)
             sec = mod(neg_time, 100)
             time_to_sec = -1*(hr * 3600 + min * 60 + sec)
          end if
          
        end function time_to_sec

! -------------------------------------------------------------------------
        integer function time_diff (time1, time2)

          integer, intent(in) :: time1, time2

          time_diff = time_to_sec(time1) - time_to_sec(time2)

        end function time_diff

!--------------------------------------------------------------------------
       integer function next_day (jday)

! This function determermins the next day for time interpolation 
          implicit none
          
          integer, intent(in) :: jday 
          integer year, day

          day  = MOD(jday,1000)
          year = INT(jday/1000)

          If( day .LT. 365 ) Then
             next_day = jday+1
          Else
             If( MOD(year,4) .Eq. 0 .And. MOD(year,100) .Ne. 0 ) Then
! Leap Year        
                If( day .Eq. 365 ) Then
                   next_day = jday + 1
                Else
                   next_day = (INT(jday/1000)+1)*1000+1
                End If
             Else If(MOD(year,400) .Eq. 0 ) Then
! also a leap year, e.g. 2000 but not 2100
                If( day .Eq. 365 ) Then
                   next_day = jday + 1
                Else
                   next_day = (INT(jday/1000)+1)*1000+1
                End If
             Else
! not a leap year
                next_day = (INT(jday/1000)+1)*1000+1
             End If
          End If

       end function next_day

      end module centralized_io_util_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/depv/m3dry/DEPVVARS.F,v 1.7 2012/01/19 14:21:45 yoj Exp $

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE DEPVVARS

C-----------------------------------------------------------------------
C Name:     Dry Deposition Variables
C Purpose:  Contains arrays specific to dry deposition species.
C           Initializes dry deposition arrays.
C Revised:  19 Aug 2005  Original version.  (T. Otte and W. Hutzell)
C           25 Nov 2006 J.Young: combine
C           30 Apr 2008  Removed references to RADMDRY.  Added five air
C                        toxic species to LTOTG.  (T. Otte and W. Hutzell)
C           16 Feb 2011 S.Roselle: replaced I/O API include files with
C                        UTILIO_DEFN
C           11 May 2011 J.Bash: Updated for NH3 bidirectional exchange
C           04 Jan 2012 J.Young: Initialize char variables with blank padding
C           28 Aug 2014  G. Sarwar: added deposition for CLNO2 
C           07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C           05 May 2015: H.Pye: Added ISOPNN and MTNO3 with Donna Schwede
C           24 Aug 2015: H.Pye: Added IEPOX and HACET with Donna Schwede
C           26 Jan 2016: H. Pye added info for SOA SVOCs
C           24 Mar 2016: G. Sarwar: added iodine and bromine species
C           26 Sep 2016: D. Wong: removed unnecessary use module statements
C           29 Dec 2015: H.Pye: added new monoterpene SOA surrogates
C           06 Aug 2018: M.Qin: added new lumped anthropogenic semivolatiles
C           16 Aug 2018: G. Sarwar: added ClNO3 and FMBR, and updated INO3 and BRNO3 name changes
C           21 Nov 2018: G. Srawar: added several halogen species
C-----------------------------------------------------------------------

      INTEGER, PARAMETER :: LDDEP = 4
      INTEGER, PARAMETER :: LTOTG = 178
      INTEGER, PARAMETER :: LCMP  = 8
      CHARACTER( 16 )    :: DEPV_METHOD

C-----------------------------------------------------------------------
C General dry deposition arrays.
C-----------------------------------------------------------------------

      INTEGER, SAVE         :: N_USE_DEPSPC        
      LOGICAL, SAVE         :: USE_DEPSPC( LTOTG )
      CHARACTER( 16 ), SAVE :: DEPSPC( LTOTG )

C----------------------------------------------------------------------
C local deposition velocites [ m/s ]
C----------------------------------------------------------------------

      CONTAINS

         FUNCTION DEPVVARS_INIT( ) RESULT ( SUCCESS )

         IMPLICIT NONE

         LOGICAL SUCCESS

         INTEGER ALLOCSTAT
         CHARACTER( 96 ) :: XMSG

         SUCCESS = .TRUE.

C-------------------------------------------------------------------------------
C For M3DRY, set up core species, and include toxic and chlorine compounds.
C-------------------------------------------------------------------------------

         DEPV_METHOD  = 'M3DRY           '

         DEPSPC(  1 ) = 'SO2             '
         DEPSPC(  2 ) = 'SULF            '
         DEPSPC(  3 ) = 'NO2             '
         DEPSPC(  4 ) = 'NO              '
         DEPSPC(  5 ) = 'O3              '
         DEPSPC(  6 ) = 'HNO3            '
         DEPSPC(  7 ) = 'H2O2            '
         DEPSPC(  8 ) = 'ALD             '
         DEPSPC(  9 ) = 'HCHO            '
         DEPSPC( 10 ) = 'OP              '
         DEPSPC( 11 ) = 'PAA             '
         DEPSPC( 12 ) = 'ORA             '
         DEPSPC( 13 ) = 'NH3             '
         DEPSPC( 14 ) = 'PAN             '
         DEPSPC( 15 ) = 'HONO            '
         DEPSPC( 16 ) = 'CO              '
         DEPSPC( 17 ) = 'METHANOL        '
         DEPSPC( 18 ) = 'N2O5            '
         DEPSPC( 19 ) = 'NO3             '
         DEPSPC( 20 ) = 'GEN_ALD         '
         DEPSPC( 21 ) = 'CL2             '
         DEPSPC( 22 ) = 'HOCL            '
         DEPSPC( 23 ) = 'HCL             '
         DEPSPC( 24 ) = 'FMCL            '
         DEPSPC( 25 ) = 'HG              '
         DEPSPC( 26 ) = 'HGIIGAS         '
         DEPSPC( 27 ) = 'TECDD_2378      '
         DEPSPC( 28 ) = 'PECDD_12378     '
         DEPSPC( 29 ) = 'HXCDD_123478    '
         DEPSPC( 30 ) = 'HXCDD_123678    '
         DEPSPC( 31 ) = 'HXCDD_123789    '
         DEPSPC( 32 ) = 'HPCDD_1234678   '
         DEPSPC( 33 ) = 'OTCDD           '
         DEPSPC( 34 ) = 'TECDF_2378      '
         DEPSPC( 35 ) = 'PECDF_12378     '
         DEPSPC( 36 ) = 'PECDF_23478     '
         DEPSPC( 37 ) = 'HXCDF_123478    '
         DEPSPC( 38 ) = 'HXCDF_123678    '
         DEPSPC( 39 ) = 'HXCDF_234678    '
         DEPSPC( 40 ) = 'HXCDF_123789    '
         DEPSPC( 41 ) = 'HPCDF_1234678   '
         DEPSPC( 42 ) = 'HPCDF_1234789   '
         DEPSPC( 43 ) = 'OTCDF           '
         DEPSPC( 44 ) = 'NAPHTHALENE     '
         DEPSPC( 45 ) = '1NITRONAPHTHA   '
         DEPSPC( 46 ) = '2NITRONAPHTHA   '
         DEPSPC( 47 ) = '14NAPHTHOQUIN   '
         DEPSPC( 48 ) = 'HEXMETH_DIIS    '
         DEPSPC( 49 ) = 'HYDRAZINE       '
         DEPSPC( 50 ) = 'MAL_ANHYDRIDE   '
         DEPSPC( 51 ) = 'TOLUENE_DIIS    '
         DEPSPC( 52 ) = 'TRIETHYLAMINE   '
         DEPSPC( 53 ) = 'NTR             '
         DEPSPC( 54 ) = 'NTRM            '
         DEPSPC( 55 ) = 'MPAN            '
         DEPSPC( 56 ) = 'PPN             '
         DEPSPC( 57 ) = 'ISPD            '
         DEPSPC( 58 ) = 'NTRDN           '
         DEPSPC( 59 ) = 'NTRALK          '
         DEPSPC( 60 ) = 'NTROH           '
         DEPSPC( 61 ) = 'NTRPX           '
         DEPSPC( 62 ) = 'PROPNN          '
         DEPSPC( 63 ) = 'CLNO2           '
         DEPSPC( 64 ) = 'ISOPNN          '
         DEPSPC( 65 ) = 'MTNO3           '
         DEPSPC( 66 ) = 'IEPOX           '
         DEPSPC( 67 ) = 'HACET           '
         DEPSPC( 68 ) = 'SVALK1          '
         DEPSPC( 69 ) = 'SVALK2          '
         DEPSPC( 70 ) = 'SVBNZ1          '
         DEPSPC( 71 ) = 'SVBNZ2          '
         DEPSPC( 72 ) = 'SVISO1          '
         DEPSPC( 73 ) = 'SVISO2          '
         DEPSPC( 74 ) = 'SVPAH1          '
         DEPSPC( 75 ) = 'SVPAH2          '
         DEPSPC( 76 ) = 'SVSQT           '
         DEPSPC( 77 ) = 'SVTOL1          '
         DEPSPC( 78 ) = 'SVTOL2          '
         DEPSPC( 79 ) = 'SVTRP1          '
         DEPSPC( 80 ) = 'SVTRP2          '
         DEPSPC( 81 ) = 'SVXYL1          '
         DEPSPC( 82 ) = 'SVXYL2          '
         DEPSPC( 83 ) = 'IO              '
         DEPSPC( 84 ) = 'OIO             '
         DEPSPC( 85 ) = 'I2O2            '
         DEPSPC( 86 ) = 'I2O3            '
         DEPSPC( 87 ) = 'I2O4            '
         DEPSPC( 88 ) = 'HI              '
         DEPSPC( 89 ) = 'HOI             '
         DEPSPC( 90 ) = 'INO             '
         DEPSPC( 91 ) = 'INO2            '
         DEPSPC( 92 ) = 'INO3            '
         DEPSPC( 93 ) = 'BRO             '
         DEPSPC( 94 ) = 'HOBR            '
         DEPSPC( 95 ) = 'HBR             '
         DEPSPC( 96 ) = 'BRNO3           '
         DEPSPC( 97 ) = 'BRNO2           '
         DEPSPC( 98 ) = 'BRCL            '
         DEPSPC( 99 ) = 'DMS             '
         DEPSPC( 100) = 'MSA             '
         DEPSPC( 101) = 'METHANE         '
         DEPSPC( 102) = 'ACRYACID        '
         DEPSPC( 103) = 'CARBSULFIDE     '
         DEPSPC( 104) = 'ACETONITRILE    '
         DEPSPC( 105) = 'METH_NIT_PHEN   ' ! 6-methyl-2-nitrophenol aka 6-nitro-o-cresol
         DEPSPC( 106) = 'PCVOC           '
         DEPSPC( 107) = 'INTR            '
         DEPSPC( 108) = 'ISPX            '
         DEPSPC( 109) = 'ROOH            '
         DEPSPC( 110) = 'LVPCSOG         '
         DEPSPC( 111) = 'VIVPO1          '
         DEPSPC( 112) = 'VLVOO1          '
         DEPSPC( 113) = 'VLVOO2          '
         DEPSPC( 114) = 'VLVPO1          '
         DEPSPC( 115) = 'VSVOO1          '
         DEPSPC( 116) = 'VSVOO2          '
         DEPSPC( 117) = 'VSVOO3          '
         DEPSPC( 118) = 'VSVPO1          '
         DEPSPC( 119) = 'VSVPO2          '
         DEPSPC( 120) = 'VSVPO3          '
         DEPSPC( 121) = 'FACD            '
         DEPSPC( 122) = 'KET             '
         DEPSPC( 123) = 'ETH             '
         DEPSPC( 124) = 'PNA             '
         DEPSPC( 125) = 'GLY             '
         DEPSPC( 126) = 'GLYD            '
         DEPSPC( 127) = 'MGLY            '
         DEPSPC( 128) = 'ETHA            '
         DEPSPC( 129) = 'ETOH            '
         DEPSPC( 130) = 'PAR             '
         DEPSPC( 131) = 'ACET            '
         DEPSPC( 132) = 'PRPA            '
         DEPSPC( 133) = 'ETHY            '
         DEPSPC( 134) = 'OLE             '
         DEPSPC( 135) = 'IOLE            '
         DEPSPC( 136) = 'IEPOX           '
         DEPSPC( 137) = 'BENZ            '
         DEPSPC( 138) = 'CRES            '
         DEPSPC( 139) = 'TOL             '
         DEPSPC( 140) = 'XYLMN           '
         DEPSPC( 141) = 'NAPH            '
         DEPSPC( 142) = 'CAT1            '
         DEPSPC( 143) = 'SESQ            '
         DEPSPC( 144) = 'TERP            '
         DEPSPC( 145) = 'ISOP            '
         DEPSPC( 146) = 'OPEN            '
         DEPSPC( 147) = 'XOPN            '
         DEPSPC( 148) = 'SOAALK          '
         DEPSPC( 149) = 'BUTADIENE13     '
         DEPSPC( 150) = 'ACROLEIN        '
         DEPSPC( 151) = 'SVMT1           '
         DEPSPC( 152) = 'SVMT2           '
         DEPSPC( 153) = 'SVMT3           '
         DEPSPC( 154) = 'SVMT4           '
         DEPSPC( 155) = 'SVMT5           '
         DEPSPC( 156) = 'SVMT6           '
         DEPSPC( 157) = 'SVMT7           '
         DEPSPC( 158) = 'SVAVB1         '
         DEPSPC( 159) = 'SVAVB2         '
         DEPSPC( 160) = 'SVAVB3         '
         DEPSPC( 161) = 'SVAVB4         '
         DEPSPC( 162) = 'CLNO3           '
         DEPSPC( 163) = 'FMBR            '
         DEPSPC( 164) = 'I2             '
         DEPSPC( 165) = 'CH3I           '
         DEPSPC( 166) = 'ICL            '
         DEPSPC( 167) = 'IBR            '
         DEPSPC( 168) = 'MI2            '
         DEPSPC( 169) = 'MIB            '
         DEPSPC( 170) = 'MIC            '
         DEPSPC( 171) = 'BR2            '
         DEPSPC( 172) = 'MB3            '
         DEPSPC( 173) = 'CH3BR          '
         DEPSPC( 174) = 'MB2            '
         DEPSPC( 175) = 'MB2C           '
         DEPSPC( 176) = 'MBC2           '
         DEPSPC( 177) = 'MBC            '
         DEPSPC( 178) = 'CLO            '

         N_USE_DEPSPC = 0
         USE_DEPSPC = .FALSE.   ! array

         RETURN

         END FUNCTION DEPVVARS_INIT

      END MODULE DEPVVARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module Bidi_Mod

C Contains the shared variables and subrountes needed for the bidirectional 
C NH3 flux model in CMAQ
C
C OPASX_MEDIA - Opens the output file for NH4+ and H+ in the soil water solution
C               
C Revision History: J. Bash Mar 15 11: Created
C                   J. Bash May 11 11: Updated for CMAQ 5.0
C                   D. Wong 1 Feb 19: removed MY_N clauses
      USE RUNTIME_VARS


      Implicit None
! Private variables
      Integer, Parameter, Private :: NHx_AQ_CONC  = 4
      Integer, Parameter, Private :: NHx_GAS_CONC = 0      
      Integer, Parameter, Private :: NHx_SOL_CONC = 0     
      Integer, Parameter, Private :: NHx_TOT = NHx_AQ_CONC + NHx_GAS_CONC + NHx_SOL_CONC       
      Integer, Parameter, Private :: HG_AQ_CONC   = 3
      Integer, Parameter, Private :: HG_GAS_CONC  = 1      
      Integer, Parameter, Private :: HG_SOL_CONC  = 2           
      
      Integer, Save,   Private :: N_Hg
      Character( 96 ), Private :: XMSG = ' '
! shared variables
      Character( 16 ), Save , Allocatable :: MEDIA_NAMES( : )
      Character( 16 ), Save , Allocatable :: MEDIA_UNITS( : )
      Character( 80 ), Save , Allocatable :: MEDIA_DESCR( : )

      Integer, Parameter      :: HG_TOT = HG_AQ_CONC + HG_GAS_CONC + HG_SOL_CONC       
      Integer, Save           :: N_TOT
      Real, Save, Allocatable :: gamma1 ( :,: ) ! soil NH4/H
      Real, Save, Allocatable :: gamma2 ( :,: ) ! soil NH4/H
      Real, Save, Allocatable :: MHp1   ( :,: ) ! molar H+
      Real, Save, Allocatable :: MHp2   ( :,: ) ! molar H+  
      Real, Save, Allocatable :: CMEDIA ( :,:,: ) ! surface layer concs 
      Logical, Save     :: INIT_LAI   
      Logical, Save     :: INIT_ATX 
      Logical, Save     :: INIT_ASX              


      Contains 
         Subroutine INIT_BIDI( )
         Use GRID_CONF
         Use CGRID_SPCS          ! CGRID mechanism species
         Use UTILIO_DEFN
         
         Implicit None
         
C... Local:
 
         Character( 16 ) :: PNAME = 'INIT_BIDI       '
         Character( 80 ) :: VARDESC
         Integer         :: STATUS
         
C--------------------------------------------------------------------------
         ! Set Mercury BiDi Processing Flag equal to false if there is
         ! no mercury gas-phase species.
         If ( INDEX1( 'HG', N_GC_DDEP, GC_DDEP ) .EQ. 0 ) HGBIDI = .FALSE.

         ! Define Media Concentration Output Variables and Descriptions
         If ( ABFLUX .And. .Not. HGBIDI ) Then
         
            N_TOT = NHx_TOT
            N_Hg  = 0            
            Allocate( MEDIA_NAMES( N_TOT ), MEDIA_UNITS( N_TOT ), MEDIA_DESCR( N_TOT )  )

            MEDIA_NAMES( 1 ) = 'Gamma1          '
            MEDIA_UNITS( 1 ) = ' '
            MEDIA_DESCR( 1 ) = 'NH4+/H+ in Soil layer 1'
            MEDIA_NAMES( 2 ) = 'Gamma2          '
            MEDIA_UNITS( 2 ) = ' '
            MEDIA_DESCR( 2 ) = 'NH4+/H+ in Soil layer 2'
            MEDIA_NAMES( 3 ) = 'MHpsl1          '
            MEDIA_UNITS( 3 ) = 'mol/l'
            MEDIA_DESCR( 3 ) = 'Molar H+ in Soil layer 1'
            MEDIA_NAMES( 4 ) = 'MHpsl2          '
            MEDIA_UNITS( 4 ) = 'mol/l'
            MEDIA_DESCR( 4 ) = 'Molar H+ in Soil layer 2'
               
         Else If ( .Not. ABFLUX .And. HGBIDI ) Then
            N_TOT = HG_TOT
            N_Hg  = HG_TOT
            Allocate( MEDIA_NAMES( HG_TOT ), MEDIA_UNITS( N_TOT ), MEDIA_DESCR( N_TOT )  )

            MEDIA_NAMES( 1 ) = 'DGM             ' ! Dissolved gaseous Hg
            MEDIA_UNITS( 1 ) = 'umol/mol' 
            MEDIA_DESCR( 1 ) = 'Surface water dissolved Hg(0)'
            MEDIA_NAMES( 2 ) = 'DRM             ' ! Dissolved reactive Hg
            MEDIA_UNITS( 2 ) = 'umol/mol' 
            MEDIA_DESCR( 2 ) = 'Surface water dissolved Hg(II)'
            MEDIA_NAMES( 3 ) = 'HGSOIL          '
            MEDIA_UNITS( 3 ) = 'umol/mol'      
            MEDIA_DESCR( 3 ) = 'Soil water dissolved Hg(0)'
            MEDIA_NAMES( 4 ) = 'HGZ0            '
            MEDIA_UNITS( 4 ) = 'ppmV'      
            MEDIA_DESCR( 4 ) = 'Hg(0) compensation point'
            MEDIA_NAMES( 5 ) = 'HGMES           ' ! mesophyll Hg
            MEDIA_UNITS( 5 ) = 'umol/g'      
            MEDIA_DESCR( 5 ) = 'Hg(0) bound to leaf mesophyll'
            MEDIA_NAMES( 6 ) = 'HGCUT           ' ! cuticular Hg  
            MEDIA_UNITS( 6 ) = 'umol/g'      
            MEDIA_DESCR( 6 ) = 'Hg(0) bound to vegetation surfaces'      
            
         Else If ( ABFLUX .And. HGBIDI ) Then
            N_TOT = HG_TOT + NHx_TOT
            N_Hg  = HG_TOT
            Allocate( MEDIA_NAMES( N_TOT ), MEDIA_UNITS( N_TOT ), MEDIA_DESCR( N_TOT )  )

            MEDIA_NAMES( 1 ) = 'DGM             ' ! Dissolved gaseous Hg
            MEDIA_UNITS( 1 ) = 'umol/mol' 
            MEDIA_DESCR( 1 ) = 'Surface water dissolved Hg(0)'
            MEDIA_NAMES( 2 ) = 'DRM             ' ! Dissolved reactive Hg
            MEDIA_UNITS( 2 ) = 'umol/mol' 
            MEDIA_DESCR( 2 ) = 'Surface water dissolved Hg(II)'
            MEDIA_NAMES( 3 ) = 'HGSOIL          '
            MEDIA_UNITS( 3 ) = 'umol/mol'      
            MEDIA_DESCR( 3 ) = 'Soil water dissolved Hg(0)'
            MEDIA_NAMES( 4 ) = 'HGZ0            '
            MEDIA_UNITS( 4 ) = 'ppmV'      
            MEDIA_DESCR( 4 ) = 'Hg(0) compensation point'
            MEDIA_NAMES( 5 ) = 'HGMES           ' ! mesophyll Hg
            MEDIA_UNITS( 5 ) = 'umol/g'      
            MEDIA_DESCR( 5 ) = 'Hg(0) bound to leaf mesophyll'
            MEDIA_NAMES( 6 ) = 'HGCUT           ' ! cuticular Hg  
            MEDIA_UNITS( 6 ) = 'umol/g'      
            MEDIA_DESCR( 6 ) = 'Hg(0) bound to vegetation surfaces'   
            MEDIA_NAMES( 7 ) = 'Gamma1          ' 
            MEDIA_UNITS( 7 ) = ' ' 
            MEDIA_DESCR( 7 ) = 'NH4+/H+ in Soil layer 1'
            MEDIA_NAMES( 8 ) = 'Gamma2          '
            MEDIA_UNITS( 8 ) = ' ' 
            MEDIA_DESCR( 8 ) = 'NH4+/H+ in Soil layer 2'
            MEDIA_NAMES( 9 ) = 'MHpsl1'
            MEDIA_UNITS( 9 ) = 'mol/l' 
            MEDIA_DESCR( 9 ) = 'Molar H+ in Soil layer 1'
            MEDIA_NAMES( 10 ) = 'MHpsl2         '
            MEDIA_UNITS( 10 ) = 'mol/l' 
            MEDIA_DESCR( 10 ) = 'Molar H+ in Soil layer 2'
            
         End If
         
         ! allocate the media array variable
         If ( .Not. Allocated ( CMEDIA ) ) Then
            Allocate ( CMEDIA( NCOLS,NROWS,N_TOT ) )
            CMEDIA = 0.0
         End If         
         
         Return
         
         End Subroutine INIT_BIDI
!*****************************************************************************
!************** Iput / output section of the module **************************
!*****************************************************************************

         Subroutine OPASX_MEDIA( JDATE, JTIME, TSTEP )

         Use GRID_CONF
         Use CGRID_SPCS          ! CGRID mechanism species
         Use UTILIO_DEFN

         Implicit None

         Include SUBST_FILES_ID  ! file name parameters

         Integer,     Intent( In ) :: JDATE
         Integer,     Intent( In ) :: JTIME
         Integer,     Intent( In ) :: TSTEP

         Character( 16 ) :: PNAME = 'OPASX_MEDIA     '
         Character( 80 ) :: VARDESC
         Character( 96 ) :: MSG = ' '

         Integer  N, V, L
         
C--------------------------------------------------------------------------
         
         If ( ABFLUX .And. .Not. HGBIDI) Then

            If ( .Not. OPEN3( MEDIA_CONC, FSRDWR3, PNAME ) ) Then

               XMSG = 'Could not open ' // MEDIA_CONC // ' file for update - '
     &             // 'try to open new'
               Call M3MESG( XMSG )

               FTYPE3D = GRDDED3
               SDATE3D = JDATE
               STIME3D = JTIME
               TSTEP3D = TSTEP
               Call NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

               NVARS3D = N_TOT
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NLAYS3D =     1
               NTHIK3D =     1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD
               Do L = 1, NLAYS3D + 1
                  VGLVS3D( L ) = VGLVS_GD( L )
               End Do
               GDNAM3D = GRID_NAME  ! from HGRD_DEFN

               FDESC3D = ' '   ! array

               FDESC3D( 1 ) = 'Multimedia concentration estimates from integrated ambient '
     &                     // 'NH3 concentrations and surface exchange algorithms'
                        
               N = 0

               Do V = 1, NHx_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'mol L-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = NHx_AQ_CONC

               Do V = 1, NHx_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV g-1'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = NHx_AQ_CONC + NHx_GAS_CONC

               Do V = 1, NHx_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do              
            End If
            
         Else If ( .Not. ABFLUX .And. HGBIDI ) Then              
            
            If ( .Not. OPEN3( MEDIA_CONC, FSRDWR3, PNAME ) ) Then!

               XMSG = 'Could not open ' // MEDIA_CONC // ' file for update - '
     &             // 'try to open new'
               Call M3MESG( XMSG )

               FTYPE3D = GRDDED3
               SDATE3D = JDATE
               STIME3D = JTIME
               TSTEP3D = TSTEP
               Call NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour            
               NVARS3D = N_TOT
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NLAYS3D =     1
               NTHIK3D =     1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD

               FDESC3D = ' '   ! array

               FDESC3D( 1 ) = 'Multimedia concentration estimates from integrated ambient '
     &                     // 'HG concentrations and surface exchange algorithms'

               NLAYS3D = 1

               N = 0

               Do V = 1, HG_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol mol-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = HG_AQ_CONC

               Do V = 1, HG_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV g'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = HG_AQ_CONC + HG_GAS_CONC

               Do V = 1, HG_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do
            End If
            
         Else If ( ABFLUX .And. HGBIDI ) Then         
            
            If ( .Not. OPEN3( MEDIA_CONC, FSRDWR3, PNAME ) ) Then

               XMSG = 'Could not open ' // MEDIA_CONC // ' file for update - '
     &             // 'try to open new'
               Call M3MESG( XMSG )

               FTYPE3D = GRDDED3
               SDATE3D = JDATE
               STIME3D = JTIME
               TSTEP3D = TSTEP
               Call NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour            
               NVARS3D = N_TOT
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NLAYS3D =     1
               NTHIK3D =     1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD

               FDESC3D = ' '   ! array

               FDESC3D( 1 ) = 'Multimedia concentration estimates from integrated ambient '
     &                     // 'NH3 and HG concentrations and surface exchange algorithms'

               NLAYS3D = 1

               N = 0

               Do V = 1, HG_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol mol-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = HG_AQ_CONC

               Do V = 1, HG_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV g'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = HG_AQ_CONC + HG_GAS_CONC

               Do V = 1, HG_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do
               
               N = HG_TOT

               Do V = 1, NHx_AQ_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'mol L-1'
                  VDESC3D( N ) = 'aqueous phase concentration'
               End Do

               N = HG_TOT + NHx_AQ_CONC

               Do V = 1, NHx_GAS_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'ppmV g'
                  VDESC3D( N ) = 'gas phase concentration'
               End Do

               N = HG_TOT + NHx_AQ_CONC + NHx_GAS_CONC

               Do V = 1, NHx_SOL_CONC
                  N = N + 1
                  VTYPE3D( N ) = M3REAL
                  VNAME3D( N ) = MEDIA_NAMES( N )
                  UNITS3D( N ) = 'umol g-1'
                  VDESC3D( N ) = 'Solid phase concentration'
               End Do        
            End If
                                                  
         End If         
! Open file, then close it for subsequent open by all processors
            
         If ( .Not. OPEN3( MEDIA_CONC, FSNEW3, PNAME ) ) Then
            XMSG = 'Could not create '// TRIM( MEDIA_CONC) // ' file'
            Call M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         End If                   

         Return

         End Subroutine OPASX_MEDIA

!****************************************************************************

         Subroutine WRASX_MEDIA( MDATE, MTIME )

! Revision History.
!     Aug 12, 15 D. Wong: added code to handle parallel I/O implementation
!     Jan 16, 16 J. Young: update log file once per output; consistent tokens

         Use GRID_CONF           ! horizontal grid specifications
         Use UTILIO_DEFN

         Implicit None

         Include SUBST_FILES_ID  ! file name parameters

         Integer, Intent( In )    :: MDATE
         Integer, Intent( In )    :: MTIME

         Logical, Save :: FIRSTIME = .TRUE.

         Real          WRMC( NCols,NRows )         ! media write buffer
         Integer V, R, C

         Character( 16 ) :: PNAME = 'WRASX_MEDIA     '
         
!*****************************************************************************         
         If ( HGBIDI ) Then
            INIT_LAI = .FALSE.   
            INIT_ATX = .FALSE.   
            INIT_ASX = .FALSE.
         End If
         
         If ( ABFLUX ) Then
            Do R = 1, NRows
               Do C = 1, NCols
                  CMedia( C,R,N_Hg+1 ) = Gamma1( C,R )
                  CMedia( C,R,N_Hg+2 ) = Gamma2( C,R )
                  CMedia( C,R,N_Hg+3 ) = MHp1( C,R )
                  CMedia( C,R,N_Hg+4 ) = MHp2( C,R )
               End Do
            End Do
         End If

#ifdef parallel_io
         If ( FIRSTIME ) Then
            FIRSTIME = .FALSE.
            If ( .Not. IO_PE_INCLUSIVE ) Then
               If ( .Not. OPEN3( MEDIA_CONC, FSREAD3, PNAME ) ) Then
                  XMSG = 'Could not open ' // TRIM( MEDIA_CONC )
                  Call M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
               End If
            End If
         End If
#endif
         
         Do V = 1, N_TOT ! species/media loop
            Do R = 1, NRows ! row loop
               Do C = 1,NCols  ! column loop
                  WRMC( C, R ) = CMEDIA( C,R,V  )
               End Do
            End Do

            If ( .Not. WRITE3( MEDIA_CONC, MEDIA_NAMES( V ), MDATE, MTIME,
     &                WRMC ) ) Then
               XMSG = 'Could not write ' // MEDIA_CONC // ' file'
               Call M3EXIT( PNAME, MDATE, MTIME, XMSG, XSTAT1 )
            End If

         End Do                 

         Write( LOGDEV, '( /5X, A, I8, ":", I6.6 )' )
     &         'Timestep written to "' // TRIM( MEDIA_CONC ) //
     &         '" for date and time', MDATE, MTIME

         Return

         End Subroutine WRASX_MEDIA

      End Module Bidi_Mod   

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CLDPROC ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C
C  FUNCTION:  RADM/ACM and Resolved cloud process driver
C
C  PRECONDITIONS REQUIRED:
C       Dates and times represented YYYYDDD:HHMMSS.
C
C  REVISION  HISTORY:
C      Date   Who             What
C    -------- ---             -----------------------------------------
C     11/21/00 J. Young       enable appending timesteps to wetdep1 and wetdep2
C     3/01/98 S.Roselle       modified to output 2 wet deposition files
C     8/12/97 S.Roselle       added conversion of cgrid units to mol/mol units
C     6/14/94 Dongming Hwang  configuration management prototype
C     Dec 00  J. Young        move CGRID_MAP into f90 module
C     Sep 01  J. Young        Dyn Alloc - Use HGRD_DEFN
C     Jan 05  J. Young        dyn alloc - establish both horizontal & vertical
C                             domain specifications in one module
C     May 05  J. Pleim        Replaced RADMcld with RADMacmcld
C     6/08/05 S.Roselle       added new cloud diagnostic variables
C     7/21/09 D. Wong         fixed parallel bug in opening WET_DEP_2
C     Oct 10  J.Young         convert for Namelist redesign
C     3/01/11 S.Roselle       replaced I/O API include files with UTILIO_DEFN
C     5/11/11 D.Wong:         incorporated twoway model implementation
C     02Aug12 S.Roselle:      instrumented to output transmissivity for 
C                             convective and resolved clouds
C     Aug 2015 D. Wong        Extracted section of code that deals with creating
C                             CTM_WET_DEP_1 and CTM_WET_DEP_2 and put it in opwdep.F
C                             Added a section of code to let non I/O processors
C                             open CTM_WET_DEP_1 and CTM_WET_DEP_2 for parallel I/O
C                             implementation
C     Feb 2018 D. Wong        Implemented centralized I/O approach, removed all MY_N
C                             clauses
C    Nov 2018 S.Napelenok     ISAM implementation
C    Apr 2019 F.Sidi & 
C             S.Roselle:      Fixed bug relating to incorrect unit conversions
C                             in GC, NR and TR. 
C    Dec 2019 S.Napelenok     DDM-3D implementation for v 5.3.1
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
      use CENTRALIZED_IO_MODULE, only : interpolate_var

#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, N_SPCTAG, TOT_SADEP, CONV_SADEP,
     &                   SPC_INDEX, VNAM_SPCTAG, NTAG_SA, S_SPCTAG, 
     &                   ITAG, T_SPCTAG
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY: NP, NPMAX, SENGRID, SENNUM, 
     &                      S_TOTDEP, S_CONDEP, S_DEPWRT, SEN_PAR
#endif

      IMPLICIT NONE

C...........INCLUDES

      INCLUDE SUBST_CONST            ! constants
      INCLUDE SUBST_FILES_ID         ! file name parameters

      CHARACTER( 120 ) :: XMSG = ' ' ! exit message string

C...........PARAMETERS

C # of wet deposition species
      INTEGER, SAVE :: N_SPC_WDEP

      REAL, PARAMETER :: CNV1 = MWAIR * 1.0E-9
      REAL, PARAMETER :: CNV1I = 1.0 / CNV1
      REAL, PARAMETER :: CNV2 = MWAIR * 1.0E-3
      REAL, PARAMETER :: CNV2I = 1.0 / CNV2
!     REAL, PARAMETER :: CNV3 = MWAIR * 1.0E+3 / AVO  ! -> ppmV
!     REAL, PARAMETER :: CNV3 = CNV2 / AVO            ! -> mol/mol
      REAL, PARAMETER :: CNV3 = CNV2                  ! -> #/mol
      REAL, PARAMETER :: CNV3I = 1.0 / CNV3

C...........ARGUMENTS

!     REAL          CGRID( NCOLS, NROWS, NLAYS, * )  ! concentrations
!     REAL       :: CGRID( :,:,:,: )                 ! concentrations
      REAL, POINTER :: CGRID( :,:,:,: )                 ! concentrations
      INTEGER       JDATE            ! current model date, coded YYYYDDD
      INTEGER       JTIME            ! current model time, coded HHMMSS
      INTEGER       TSTEP( 3 )       ! model time step, coded HHMMSS

C...........Local Variables

      LOGICAL, SAVE :: FIRSTIME = .TRUE. ! flag for first pass thru

      CHARACTER( 16 ), SAVE :: PNAME = 'CLDPROC' ! driver program name
      CHARACTER( 16 ) :: VNAME            ! input variable name list

      INTEGER       COL              ! column subscript indices
      INTEGER       FINI             ! ending position
      INTEGER       LAY              ! layer subscript indices
      INTEGER       MDATE            ! middle of this time step
      INTEGER       MTIME            ! middle of this time step
      INTEGER       NDATE            ! middle of this time step
      INTEGER       NTIME            ! middle of this time step
      INTEGER, SAVE :: WSTEP  = 0    ! local write counter
      INTEGER, SAVE :: NNAE          ! number of #/m3 species
      INTEGER, SAVE :: NQAE          ! number of ug/m3 species
      INTEGER, SAVE :: NSAE          ! number of m2/m3 species
      INTEGER       ROW              ! row subscript indices
      INTEGER       SPC              ! species subscript indices
      INTEGER       STRT             ! starting position
      INTEGER       VAR              ! variable subscript indices
      INTEGER       ALLOCSTAT
      INTEGER, ALLOCATABLE, SAVE :: WDEP_MAP( : ) ! wet deposition map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: QAE( : ) ! CGRID pointer to ug/m3 species
      INTEGER, ALLOCATABLE, SAVE :: NAE( : ) ! CGRID pointer to #/m3 species
      INTEGER, ALLOCATABLE, SAVE :: SAE( : ) ! CGRID pointer to m2/m3 species


!     REAL          DENS    ( NCOLS,NROWS,NLAYS ) ! air density (kg/m3)
!     REAL          CONV_DEP( NCOLS,NROWS,N_SPC_WDEP+8 ) ! convective wdep only
!     REAL          TOT_DEP ( NCOLS,NROWS,N_SPC_WDEP+1 ) ! total wdep
      REAL, ALLOCATABLE, SAVE :: DENS    ( :,:,: ) ! air density (kg/m3)
      REAL, ALLOCATABLE, SAVE :: CONV_DEP( :,:,: ) ! convective wdep only
      REAL, ALLOCATABLE, SAVE :: TOT_DEP ( :,:,: ) ! total wdep
      REAL, ALLOCATABLE, SAVE :: RESTRANS( :,: )   ! resolved cloud transmissivity
      REAL, ALLOCATABLE, SAVE :: SUBTRANS( :,:,: ) ! subgrid cloud transmissivity

      REAL FAC                       ! temp conversion factor
      REAL CCMIN

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: BUFF2 ( :,: )
#endif

C...........EXTERNAL FUNCTIONS

      INTERFACE
#ifdef isam
         SUBROUTINE RESCLD ( CGRID, JDATE, JTIME, TSTEP,
     &                       N_SPC_WDEP, WDEP_MAP, DEP, RESTRANS,
     &                       SA_DEP )
#else
         SUBROUTINE RESCLD ( CGRID, JDATE, JTIME, TSTEP,
     &                       N_SPC_WDEP, WDEP_MAP, DEP, RESTRANS )
#endif
            IMPLICIT NONE
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP( 3 )
            INTEGER, INTENT( IN )    :: N_SPC_WDEP
            INTEGER, INTENT( IN )    :: WDEP_MAP( : )
            REAL,    INTENT( INOUT ) :: DEP( :,:,: )
            REAL,    INTENT( OUT )   :: RESTRANS( :,: )
#ifdef isam
            REAL,    INTENT( INOUT ) :: SA_DEP( :,:,:,: )

#endif
         END SUBROUTINE RESCLD
#ifdef isam
         SUBROUTINE CONVCLD_ACM ( CGRID, JDATE, JTIME, TSTEP,
     &                            N_SPC_WDEP, WDEP_MAP, DEP, SUBTRANS,
     &                            CONV_SADEP )
#else
         SUBROUTINE CONVCLD_ACM ( CGRID, JDATE, JTIME, TSTEP,
     &                            N_SPC_WDEP, WDEP_MAP, DEP, SUBTRANS )
#endif
            IMPLICIT NONE
            REAL, POINTER            :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )    :: JDATE, JTIME, TSTEP( 3 )
            INTEGER, INTENT( IN )    :: N_SPC_WDEP
            INTEGER, INTENT( IN )    :: WDEP_MAP( : )
            REAL,    INTENT( INOUT ) :: DEP( :,:,: )
            REAL,    INTENT( OUT )   :: SUBTRANS( :,:,: )
#ifdef isam
            REAL,    INTENT( INOUT ) :: CONV_SADEP( :,:,:,: )
#endif
         END SUBROUTINE CONVCLD_ACM
      END INTERFACE

C-----------------------------------------------------------------------
C   begin body of subroutine  CLDPROC

C...Initialization

      IF ( FIRSTIME ) THEN
        FIRSTIME = .FALSE.

C...first check to make sure that some species in CGRID were specified
C...for output in the wet deposition array, otherwise notify the user
C...and return

        N_SPC_WDEP = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
        ALLOCATE ( WDEP_MAP( N_SPC_WDEP ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating WDEP_MAP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        IF ( N_SPC_WDEP .LE. 0 ) THEN

          XMSG = 'No species were specified for wet deposition ' //
     &           'tracking'
          CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )

          XMSG = 'ONLY CLOUD DIAGNOSTICS WILL BE WRITTEN TO THE ' //
     &           'WETDEP OUTPUT FILE!'
          CALL M3MESG ( XMSG )

        END IF

C...check to see if user wants to output extra diagnostic files

        
        SPC = 0
        STRT = 1
        FINI = N_GC_WDEP
        DO VAR = STRT, FINI
          SPC = SPC + 1
          WDEP_MAP( VAR ) = GC_STRT - 1 + GC_WDEP_MAP( SPC )
        END DO

        SPC = 0
        STRT = N_GC_WDEP + 1
        FINI = N_GC_WDEP + N_AE_WDEP
        DO VAR = STRT, FINI
          SPC = SPC + 1
          WDEP_MAP( VAR ) = AE_STRT - 1 + AE_WDEP_MAP( SPC )
        END DO

        SPC = 0
        STRT = N_GC_WDEP + N_AE_WDEP + 1
        FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP
        DO VAR = STRT, FINI
          SPC = SPC + 1
          WDEP_MAP( VAR ) = NR_STRT - 1 + NR_WDEP_MAP( SPC )
        END DO

        SPC = 0
        STRT = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + 1
        FINI = N_GC_WDEP + N_AE_WDEP + N_NR_WDEP + N_TR_WDEP
        DO VAR = STRT, FINI
          SPC = SPC + 1
          WDEP_MAP( VAR ) = TR_STRT - 1 + TR_WDEP_MAP( SPC )
        END DO

        IF ( N_AE_SPC .GT. 0 ) THEN
C...create aerosol species pointers to distinguish micro-grams / m**3
C...  # / m**3 (number density), and m**2 / m**3 (surface area) units

          ALLOCATE ( QAE( N_AE_SPC ),
     &               NAE( N_AE_SPC ),
     &               SAE( N_AE_SPC ), STAT = ALLOCSTAT )
          IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating QAE, NAE, or SAE'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
          END IF

          NQAE = 0       ! number of ug/m3 species
          NNAE = 0       ! number of #/m3 species
          NSAE = 0       ! number of m2/m3 species

          DO VAR = 1, N_AE_SPC
            IF ( AE_SPC( VAR )( 1:3 ) .EQ. 'NUM' ) THEN
              NNAE = NNAE + 1
              NAE( NNAE ) = AE_STRT - 1 + VAR
            ELSE IF ( AE_SPC( VAR )( 1:3 ) .EQ. 'SRF' ) THEN
              NSAE = NSAE + 1
              SAE( NSAE ) = AE_STRT - 1 + VAR
            ELSE
              NQAE = NQAE + 1
              QAE( NQAE ) = AE_STRT - 1 + VAR
            END IF
          END DO

        END IF

C...initialize the deposition array before processing clouds

        ALLOCATE ( TOT_DEP ( NCOLS,NROWS,N_SPC_WDEP+1 ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating TOT_DEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        TOT_DEP = 0.0   ! array assignment

        ALLOCATE ( CONV_DEP( NCOLS,NROWS,N_SPC_WDEP+8+4 ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating CONV_DEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        CONV_DEP = 0.0   ! array assignment

        ALLOCATE ( RESTRANS ( NCOLS,NROWS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating RESTRANS'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        RESTRANS = 1.0   ! array assignment

        ALLOCATE ( SUBTRANS ( NCOLS,NROWS,2 ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating SUBTRANS'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        SUBTRANS = 1.0   ! array assignment

        ALLOCATE ( DENS( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating DENS'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF

#ifdef isam
Ckrt deposition arrays for tagged species.....
        ALLOCATE ( TOT_SADEP ( NCOLS,NROWS,NSPC_SA,NTAG_SA ),
     &            CONV_SADEP ( NCOLS,NROWS,NSPC_SA,NTAG_SA ),
     &             STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating TOT_ or CONV_SADEP'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
        TOT_SADEP = 0.0
        CONV_SADEP = 0.0
        ALLOCATE( BUFF2( NCOLS, NROWS ), STAT = ALLOCSTAT )
        IF ( ALLOCSTAT .NE. 0 ) THEN
          XMSG = 'Failure allocating BUFF2'
          CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
        END IF
#endif

#ifdef sens
         ALLOCATE ( S_TOTDEP ( NCOLS,NROWS,NPMAX,N_SPC_WDEP+1 ),
     &             STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating S_TOTDEP'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         S_TOTDEP = 0.0

         ALLOCATE ( S_CONDEP( NCOLS,NROWS,NPMAX,N_SPC_WDEP+1 ),
     &             STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating S_CONDEP'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         S_CONDEP = 0.0

         ALLOCATE ( S_DEPWRT ( NCOLS,NROWS, ( N_SPC_WDEP + 1 ) * NPMAX ),
     &             STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
           XMSG = 'Failure allocating S_DEPWRT'
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         S_DEPWRT = 0.0
#endif

#ifdef parallel_io
         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( CTM_WET_DEP_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // TRIM( CTM_WET_DEP_1 )
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF
         IF ( CLD_DIAG ) THEN
            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( CTM_WET_DEP_2, FSREAD3, PNAME ) ) THEN
                  XMSG = 'Could not open ' // TRIM( CTM_WET_DEP_2 )
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF
         END IF
#endif

      END IF   ! FIRSTIME

      MDATE = JDATE
      MTIME = JTIME

      call interpolate_var ('DENS', mdate, mtime, DENS)

C...convert units on cgrid to molar mixing ratio (by volume)
C...  determine no. of moles of gas per moles of air by volume

      STRT = GC_STRT
      FINI = GC_STRT + N_GC_SPC - 1
      DO SPC = STRT, FINI
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              CGRID( COL, ROW, LAY, SPC ) = MAX( CGRID( COL, ROW, LAY, SPC )
     &                                    * 1.0E-6,  1.0E-36 )
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRID( COL, ROW, LAY, SPC ) .LE. 1.0E-30 ) THEN
                  SENGRID( COL, ROW, LAY, NP, SPC ) = 0.0
                ELSE
                  SENGRID( COL, ROW, LAY, NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC ) 
     &                                              * 1.0E-6
                END IF
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...for aerosol mass concentration
C...  convert to moles of aerosol per mole of air by volume

      STRT = 1
      FINI = NQAE
      DO VAR = STRT, FINI
        SPC = QAE( VAR )
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              FAC = CNV1 / DENS( COL, ROW, LAY ) / AE_MOLWT( SPC - AE_STRT + 1 )
              CCMIN = MAX( CGRID( COL, ROW, LAY, SPC ), 1.0E-30/FAC )
              CGRID( COL, ROW, LAY, SPC ) = FAC * CCMIN
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRID( COL, ROW, LAY, SPC ) .LE. 1.0E-30 ) THEN
                   SENGRID( COL, ROW, LAY, NP, SPC ) = 0.0
                ELSE
                   SENGRID( COL, ROW, LAY, NP, SPC ) = FAC * SENGRID( COL, ROW, LAY, NP, SPC )
                ENDIF
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...for aerosol number concentration
C...    convert to # per mole of air by volume

      STRT = 1
      FINI = NNAE
      DO VAR = STRT, FINI
        SPC = NAE( VAR )
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              FAC = CNV3 / DENS( COL, ROW, LAY )
              CCMIN = MAX( CGRID( COL, ROW, LAY, SPC ), 1.0E-30/FAC )
              CGRID( COL, ROW, LAY, SPC ) = FAC * CCMIN
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRID( COL, ROW, LAY, SPC ) .LE. 1.0E-30 ) THEN
                   SENGRID( COL, ROW, LAY, NP, SPC ) = 0.0
                ELSE
                   SENGRID( COL, ROW, LAY, NP, SPC ) = FAC * SENGRID( COL, ROW, LAY, NP, SPC )
                ENDIF
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...for aerosol surface area
C...    convert to m2 per mole of air by volume

      STRT = 1
      FINI = NSAE
      DO VAR = STRT, FINI
        SPC = SAE( VAR )
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              FAC = CNV2 / DENS( COL, ROW, LAY )
              CCMIN = MAX( CGRID( COL, ROW, LAY, SPC ), 1.0E-30/FAC )
              CGRID( COL, ROW, LAY, SPC ) = FAC * CCMIN
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRID( COL, ROW, LAY, SPC ) .LE. 1.0E-30 ) THEN
                   SENGRID( COL, ROW, LAY, NP, SPC ) = 0.0
                ELSE
                   SENGRID( COL, ROW, LAY, NP, SPC ) = FAC * SENGRID( COL, ROW, LAY, NP, SPC )
                ENDIF
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...determine no. of moles of non-reactive gas per moles of air by volume

      STRT = NR_STRT
      FINI = NR_STRT + N_NR_SPC - 1
      DO SPC = STRT, FINI
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              CGRID( COL, ROW, LAY, SPC ) = MAX( CGRID( COL, ROW, LAY, SPC )
     &                                    * 1.0E-6, 1.0E-36 )
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRID( COL, ROW, LAY, SPC ) .LE. 1.0E-30 ) THEN
                   SENGRID( COL, ROW, LAY, NP, SPC ) = 0.0
                ELSE
                   SENGRID( COL, ROW, LAY, NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC )
     &                                               * 1.0E-6
                ENDIF
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...determine no. of moles of tracer gas per moles of air by volume

      STRT = TR_STRT
      FINI = TR_STRT + N_TR_SPC - 1
      DO SPC = STRT, FINI
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              CGRID( COL, ROW, LAY, SPC ) = MAX( CGRID( COL, ROW, LAY, SPC )
     &                                    * 1.0E-6, 1.0E-36 )
#ifdef sens
              DO NP = 1, NPMAX
                IF ( CGRID( COL, ROW, LAY, SPC ) .LE. 1.0E-30 ) THEN
                  SENGRID( COL, ROW, LAY, NP, SPC ) = 0.0
                ELSE
                  SENGRID( COL, ROW, LAY, NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC ) 
     &                                           * 1.0E-6
                END IF
              END DO
#endif
            END DO
          END DO
        END DO
      END DO


#ifdef isam
c ISAM  unit conversion
      DO SPC = 1, NSPC_SA
        VAR = SPC_INDEX(SPC,2)
        IF ( VAR .LE. N_GC_SPC .OR. VAR .GE. NR_STRT ) THEN ! this is not an aerosol
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM(COL,ROW,LAY,SPC,ITAG ) * 1.0E-6
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = MAX ( ISAM( COL,ROW,LAY,SPC, ITAG ), 1.0E-30 )
c                 IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-10 ) THEN
c                   ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
c                 ENDIF
                END DO
              END DO
            END DO
          END DO
        ELSE ! this is an aerosol
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  FAC = CNV1 / DENS( COL, ROW, LAY ) / AE_MOLWT( VAR - AE_STRT + 1 )
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG ) * FAC
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = MAX ( ISAM(COL,ROW,LAY,SPC, ITAG ), 1.0E-30 )
c                 IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-10 ) THEN
c                   ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
c                 ENDIF
                END DO
              END DO
            END DO
          END DO
        ENDIF
      END DO
#endif

C...compute cloud effects for the resolved clouds and resolved rainwater

#ifdef isam
      CALL RESCLD ( CGRID, JDATE, JTIME, TSTEP,
     &              N_SPC_WDEP, WDEP_MAP, TOT_DEP, RESTRANS,
     &              TOT_SADEP  )
#else
      CALL RESCLD ( CGRID, JDATE, JTIME, TSTEP,
     &              N_SPC_WDEP, WDEP_MAP, TOT_DEP, RESTRANS )
#endif

C...compute cloud effects for convective (subgrid) clouds

#ifdef isam
      CALL CONVCLD_ACM ( CGRID, JDATE, JTIME, TSTEP,
     &                   N_SPC_WDEP, WDEP_MAP, CONV_DEP, SUBTRANS,
     &                   CONV_SADEP )
#else
      CALL CONVCLD_ACM ( CGRID, JDATE, JTIME, TSTEP,
     &                   N_SPC_WDEP, WDEP_MAP, CONV_DEP, SUBTRANS )
#endif

C...now check to see if it's time to write the deposition file
      WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
      IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
        NDATE = JDATE
        NTIME = JTIME
        CALL NEXTIME( NDATE, NTIME, TSTEP( 2 ) )
        WSTEP = 0

        DO VAR = 1, N_SPC_WDEP + 1
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              TOT_DEP( COL, ROW, VAR ) = TOT_DEP ( COL, ROW, VAR )
     &                                 + CONV_DEP( COL, ROW, VAR )
#ifdef sens
              DO NP = 1, NPMAX
                 S_TOTDEP( COL, ROW, NP, VAR ) =
     &                 S_TOTDEP( COL, ROW, NP, VAR )
     &               + S_CONDEP( COL, ROW, NP, VAR )
              END DO
#endif
            END DO
          END DO
        END DO

        DO ROW = 1, NROWS
          DO COL = 1, NCOLS
            VAR = N_SPC_WDEP + 8 + 1
            CONV_DEP( COL, ROW, VAR ) = SUBTRANS( COL, ROW, 1 )
            VAR = VAR + 1
            CONV_DEP( COL, ROW, VAR ) = SUBTRANS( COL, ROW, 2 )
            VAR = VAR + 1
            CONV_DEP( COL, ROW, VAR ) = RESTRANS( COL, ROW )
            VAR = VAR + 1
            CONV_DEP( COL, ROW, VAR ) = SUBTRANS( COL, ROW, 1 )
     &                                * SUBTRANS( COL, ROW, 2 )
     &                                * RESTRANS( COL, ROW )
          END DO
        END DO

        RESTRANS = 1.0
        SUBTRANS = 1.0

#ifdef isam
Ckrt Sum up the wetdep from both resolved and convective clouds
Ckrt  for the tagged species as well....
        DO SPC = 1, N_SPCTAG
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              TOT_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) =
     &        TOT_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) +
     &       CONV_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
            END DO ! col
          END DO ! row
        END DO ! n_spctag
#endif

C...write data to the normal wet deposition file

        IF ( .NOT. WRITE3( CTM_WET_DEP_1, ALLVAR3, NDATE,
     &                     NTIME, TOT_DEP ) ) THEN
          XMSG = 'Could not write ' // CTM_WET_DEP_1 // ' file'
          CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
        END IF

        WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_WET_DEP_1,
     &         'for date and time', NDATE, NTIME

#ifdef sens
C...write data to the sensitivity wet deposition file
c gas species
        DO NP = 1, NPMAX
          DO SPC = 1, ( N_SPC_WDEP + 1 ) 
            SENNUM = ( SPC - 1 ) * NPMAX + NP
            S_DEPWRT(:,:,SENNUM) = S_TOTDEP( :,:,NP,SPC )
          END DO
        END DO

        IF ( .NOT. WRITE3( CTM_SWETDEP_1, ALLVAR3, NDATE,
     &                     NTIME, S_DEPWRT ) ) THEN
          XMSG = 'Could not write ' // CTM_SWETDEP_1 // ' file'
          CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
        END IF

        WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6)' )
     &         'Timestep written to', CTM_SWETDEP_1,
     &         'for date and time', NDATE, NTIME

#endif


C...write data to the diagnostic file if requested by the user

        IF ( CLD_DIAG ) THEN

          IF ( .NOT. WRITE3( CTM_WET_DEP_2, ALLVAR3, NDATE,
     &                       NTIME, CONV_DEP ) ) THEN
          XMSG = 'Could not write ' // CTM_WET_DEP_2 // ' file'
            CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
          END IF

          WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &           'Timestep written to', CTM_WET_DEP_2,
     &           'for date and time', NDATE, NTIME

        END IF   ! CLD_DIAG

C...reinitialize deposition array

        TOT_DEP  = 0.0
        CONV_DEP = 0.0

#ifdef sens
        S_TOTDEP = 0.0
        S_CONDEP = 0.0
#endif

#ifdef isam
        BUFF2 = 0.0
        DO SPC = 1, N_SPCTAG
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              BUFF2( COL,ROW ) = TOT_SADEP( COL,ROW,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
            END DO ! col
          END DO ! row
          IF ( .NOT. WRITE3( SA_WD_1, VNAM_SPCTAG( SPC ),
     &                       NDATE, NTIME, BUFF2 ) ) THEN
            XMSG = 'Could not write ' // SA_WD_1 // ' file'
            CALL M3EXIT ( PNAME, NDATE, NTIME, XMSG, XSTAT1 )
          END IF
       END DO ! n_spctag

       TOT_SADEP  = 0.0
       CONV_SADEP = 0.0
#endif

      END IF   ! time to write

C...convert units on cgrid back to original units
C...  convert to ppmV gas

      STRT = GC_STRT
      FINI = GC_STRT + N_GC_SPC - 1
      DO SPC = STRT, FINI
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              CGRID( COL, ROW, LAY, SPC ) = CGRID( COL, ROW, LAY, SPC )
     &                                    * 1.0E+6
#ifdef sens
              DO NP = 1, NPMAX
                SENGRID( COL, ROW, LAY, NP, SPC ) =
     &               SENGRID( COL, ROW, LAY, NP, SPC ) * 1.0E+6
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...convert to ug/m3 of aerosol mass

      STRT = 1
      FINI = NQAE
      DO VAR = STRT, FINI
        SPC = QAE( VAR )
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              FAC = CNV1I * DENS( COL, ROW, LAY )
              CGRID( COL, ROW, LAY, SPC ) = FAC * CGRID( COL, ROW, LAY, SPC )
     &                                    * AE_MOLWT( SPC - AE_STRT + 1 )
#ifdef sens
              DO NP = 1, NPMAX
                SENGRID( COL, ROW, LAY, NP, SPC ) = FAC * SENGRID( COL, ROW, LAY, NP, SPC )
     &                                            * AE_MOLWT( SPC - AE_STRT + 1 )
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...convert to #/m3 of aerosol number

      STRT = 1
      FINI = NNAE
      DO VAR = STRT, FINI
        SPC = NAE( VAR )
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              FAC = CNV3I * DENS( COL, ROW, LAY )
              CGRID( COL, ROW, LAY, SPC ) = FAC * CGRID( COL, ROW, LAY, SPC )
#ifdef sens
              DO NP = 1, NPMAX
                SENGRID( COL, ROW, LAY, NP, SPC ) = FAC * SENGRID( COL, ROW, LAY, NP, SPC )
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...convert to m2/m3 of aerosol surface area

      STRT = 1
      FINI = NSAE
      DO VAR = STRT, FINI
        SPC = SAE( VAR )
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              FAC = CNV2I * DENS( COL, ROW, LAY )
              CGRID( COL, ROW, LAY, SPC ) = FAC * CGRID( COL, ROW, LAY, SPC )
#ifdef sens
              DO NP = 1, NPMAX
                SENGRID( COL, ROW, LAY, NP, SPC ) = FAC * SENGRID( COL, ROW, LAY, NP, SPC )
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...convert to ppmV non-reactive gas

      STRT = NR_STRT
      FINI = NR_STRT + N_NR_SPC - 1
      DO SPC = STRT, FINI
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              CGRID( COL, ROW, LAY, SPC ) = CGRID( COL, ROW, LAY, SPC )
     &                                    * 1.0E+6
#ifdef sens
              DO NP = 1, NPMAX
                SENGRID( COL, ROW, LAY, NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC )
     &                                            * 1.0E+6
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

C...convert to ppmV tracer gas

      STRT = TR_STRT
      FINI = TR_STRT + N_TR_SPC - 1
      DO SPC = STRT, FINI
        DO LAY = 1, NLAYS
          DO ROW = 1, NROWS
            DO COL = 1, NCOLS
              CGRID( COL, ROW, LAY, SPC ) = CGRID( COL, ROW, LAY, SPC )
     &                                    * 1.0E+6
#ifdef sens
              DO NP = 1, NPMAX
                SENGRID( COL, ROW, LAY, NP, SPC ) = SENGRID( COL, ROW, LAY, NP, SPC )
     &                                           * 1.0E+6
              END DO
#endif
            END DO
          END DO
        END DO
      END DO

#ifdef isam
c ISAM  unit conversion
      DO SPC = 1, NSPC_SA
        VAR = SPC_INDEX(SPC,2)
        IF ( VAR .LE. N_GC_SPC .OR. VAR .GE. NR_STRT ) THEN ! this is not an aerosol
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG ) * 1.0E+6
                  IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-18 ) THEN
                    ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
                  END IF
                END DO
              END DO
            END DO
          END DO
        ELSE ! this is an aerosol
          DO ITAG = 1, NTAG_SA
            DO LAY = 1, NLAYS
              DO ROW = 1, NROWS
                DO COL = 1, NCOLS
                  FAC = CNV1I * DENS( COL, ROW, LAY ) * AE_MOLWT( VAR - AE_STRT + 1 )
                  ISAM( COL,ROW,LAY,SPC, ITAG ) = ISAM( COL,ROW,LAY,SPC,ITAG ) * FAC
                  IF ( ISAM( COL,ROW,LAY,SPC, ITAG ) .LT. 1.0E-18 ) THEN
                    ISAM( COL,ROW,LAY,SPC, ITAG ) = 0.0
                  END IF
                END DO
              END DO
            END DO
          END DO
        ENDIF
      END DO
#endif

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module ASX_DATA_MOD

C-----------------------------------------------------------------------
C Function: User-defined types

C Revision History:
C     19 Aug 2014 J.Bash: initial implementation
C     17 July 2015 H.Foroutan: Updated the calculation of MOL, MOLI, HOL, and WSTAR
C     25 Aug 2015 H. Pye: Added IEPOX, HACET surrogates
C                         modified PROPNN and H2O2
C                         Increased ar for ozone from 8 to 12.
C                         Change meso from 0.1 to 0 for some org. nitrates
C                         Changes based on Nguyen et al. 2015 PNAS and SOAS
C     07 May 2018 D. Schwede: Added call to CZANGLE here and removed call 
C                         to CZANGLE in other modules
C
C---------Notes
C  * Updates based on literature review 7/96 JEP
C  # Diff and H based on Wesely (1988) same as RADM
C  + Estimated by JEP 2/97
C  @ Updated by JEP 9/01
C  ~ Added by YW 1/02.  Dif0 based on Massman (1998).  Henry's Law constant
C    is defined here as: h=cg/ca, where cg is the concentration of a species
C    in gas-phase, and ca is its aqueous-phase concentration.  The smaller h,
C    the larger solubility.  Henry's Law constant in another definition (KH):
C    KH = ca/pg [M/atm], KH = KH0 * exp(-DKH/R(1/T-1/T0)), where KH0 and -DKH
C    values are from Rolf Sander (1999).  h=1/(KH*R*T).
C ** Update by DBS based on estimates by JEP 1/03
C ^^ From Bill Massman, personal communication 4/03
C ## Diffusivity calculated by SPARC, reactivity = other aldehydes
C ++ Dif0 in Massman is diffusivity at temperature 0C and 1 atm (101.325kPa), so
C    chemicals that were not in Massman's paper need to be adjusted.  We assume
C    JEP's original values were for 25C and 1 atm.
C  % Added by G. Sarwar (10/04)
C  $ Added by R. Bullock (02/05) HG diffusivity is from Massman (1999).
C    HGIIGAS diffusivity calculated from the HG value and a mol. wt. scaling
C    factor of MW**(-2/3) from EPA/600/3-87/015. ORD, Athens, GA.  HGIIGAS
C    mol.wt. used is that of HgCl2.  Reactivity of HG is 1/20th of NO and NO2
C    values based on general atmospheric lifetimes of each species.  Reactivity
C    of HGIIGAS is based on HNO3 surrogate.
C @@ Mesophyll resistances for NO, NO2, and CO added by J. Pleim (07/07) based
C    on values in Pleim, Venkatram, and Yamartino, 1984:  ADOM/TADAP Model
C    Development Program, Volume 4, The Dry Deposition Module.  ERT, Inc.,
C    Concord, MA (peer reviewed).
C ~~ Reactivity for PAN changed from 4.0 to 16.0 by J. Pleim (07/07) based on
C    comparisons with Turnipseed et al., JGR, 2006.
C %% Species ICL1 and ICL2 are removed, not used in CB05.  G. Sarwar (07/07)
C <> Hazardous Air Pollutants that are believed to undergo significant dry
C    deposition. Hydrazine and triethylamine reactivities are based on analogies
C    to NH3. Maleic anhydride reactivity is assumed similar to aldehydes.
C    Toluene diisocyanate and hexamethylene diisocyanate reactivities are
C    assumed to be similar to SO2. Diffusivities are calculated with standard
C    formulas.  W. Hutzell (04/08)
C %% G. Sarwar: added data for iodine and bromine species (03/2016)
C %% B. Hutzell: added dry deposition data for methane, acrylic acid, methyl chloride,
C    and acetonitrile (09/2016)  
C    G. Sarwar: added ClNO3 and FMBR, and updated INO3 and BRNO3 name changes (07/2018)
C    G. Sarwar: removed NACL (07/2018)
C    G. Sarwar: made minor changes to halogen species and added several iodine species (12/2018)
C    D. Wong: Implemented centralized I/O approach, removed all MY_N clauses, removed
C             unnecessary SAVE attribute (02/2019)
C-------------------------------------------------------------------------------
      Use RUNTIME_VARS
      Use GRID_CONF           ! horizontal & vertical domain specifications
      Use LSM_MOD             ! Land surface data
      Use DEPVVARS, Only: ltotg
      Use CENTRALIZED_IO_MODULE

      Implicit None

      Include SUBST_CONST     ! constants

      Type :: MET_Type
!> 2-D meteorological fields:
         Real,    Allocatable :: RDEPVHT  ( :,: )  ! reciprocal layer 1 height [m-1]
         Real,    Allocatable :: DENS1    ( :,: )  ! layer 1 air density
         Real,    Allocatable :: PRSFC    ( :,: )  ! surface pressure [Pa]
         Real,    Allocatable :: Q2       ( :,: )  ! 2 meter water vapor mixing ratio [kg/kg]
         Real,    Allocatable :: QSS_GRND ( :,: )  ! ground saturation water vapor mixing ratio [kg/kg]
         Real,    Allocatable :: RH2      ( :,: )  ! relative humidity [percent]
         Real,    Allocatable :: RA       ( :,: )  ! aerodynamic resistance [s/m]
         Real,    Allocatable :: RS       ( :,: )  ! stomatal resistance [s/m]
         Real,    Allocatable :: RC       ( :,: )  ! convective precipitation [cm]
         Real,    Allocatable :: RN       ( :,: )  ! non-convective precipitation [cm]
         Real,    Allocatable :: RGRND    ( :,: )  ! Solar radiation at the ground [W/m**2]
         Real,    Allocatable :: HFX      ( :,: )  ! Sensible heat flux [W/m**2]
         Real,    Allocatable :: LH       ( :,: )  ! Latent heat flux [W/m**2]
         Real,    Allocatable :: SNOCOV   ( :,: )  ! Snow cover [1=yes, 0=no]
         Real,    Allocatable :: TEMP2    ( :,: )  ! two meter temperature [K]
         Real,    Allocatable :: TEMPG    ( :,: )  ! skin temperature [K]
         Real,    Allocatable :: TSEASFC  ( :,: )  ! SST [K]
         Real,    Allocatable :: USTAR    ( :,: )  ! surface friction velocity [m/s]
         Real,    Allocatable :: VEG      ( :,: )  ! fractional vegetation coverage [ratio]
         Real,    Allocatable :: LAI      ( :,: )  ! grid cell leaf area index [m**2/m**2]
         Real,    Allocatable :: WR       ( :,: )  ! precip intercepted by canopy [m]
         Real,    Allocatable :: WSPD10   ( :,: )  ! 10-m wind speed [m/s]
         Real,    Allocatable :: WSTAR    ( :,: )  ! convective velocity scale [m/s]
         Real,    Allocatable :: Z0       ( :,: )  ! roughness length [m]
         Real,    Allocatable :: SOIM1    ( :,: )  ! 1 cm soil moisture [m**3/m**3]
         Real,    Allocatable :: SOIM2    ( :,: )  ! 1 m soil moisture  [m**3/m**3]
         Real,    Allocatable :: SOIT1    ( :,: )  ! 1 cm soil temperature [K]
!        Real,    Allocatable :: SOIT2    ( :,: )  ! 1 m soil temperature [K]
         Real,    Allocatable :: SEAICE   ( :,: )  ! Sea ice coverage [%]
         Real,    Allocatable :: MOL      ( :,: )  ! Monin-Obukhov length [m]
         Real,    Allocatable :: MOLI     ( :,: )  ! inverse of Monin-Obukhov length [m]
         Real,    Allocatable :: HOL      ( :,: )  ! PBL over Obukhov length
         Real,    Allocatable :: XPBL     ( :,: )  ! PBL sigma height
         Integer, Allocatable :: LPBL     ( :,: )  ! PBL layer
         Logical, Allocatable :: CONVCT   ( :,: )  ! convection flag
         Real,    Allocatable :: PBL      ( :,: )  ! pbl height (m)
!         Real,    Allocatable :: NACL_EMIS( :,: )  ! NACL mass emission rate of particles with d <10 um (g/m2/s)
         Real,    Allocatable :: COSZEN   ( :,: )  ! Cosine of the zenith angle
!> U and V wind components on the cross grid points
         Real,    Allocatable :: UWIND    ( :,:,: )  ! [m/s]
         Real,    Allocatable :: VWIND    ( :,:,: )  ! [m/s]                    
!> 3-D meteorological fields:
         Real,    Allocatable :: KZMIN    ( :,:,: )  ! minimum Kz [m**2/s]
         Real,    Allocatable :: PRES     ( :,:,: )  ! pressure [Pa]
         Real,    Allocatable :: QV       ( :,:,: )  ! water vapor mixing ratio
         Real,    Allocatable :: QC       ( :,:,: )  ! cloud water mixing ratio
         Real,    Allocatable :: THETAV   ( :,:,: )  ! potential temp
         Real,    Allocatable :: TA       ( :,:,: )  ! temperature (K)
         Real,    Allocatable :: RH       ( :,:,: )  ! relative humidity [ratio]
         Real,    Allocatable :: ZH       ( :,:,: )  ! mid-layer height above ground [m]
         Real,    Allocatable :: ZF       ( :,:,: )  ! layer height [m]
         Real,    Allocatable :: DZF      ( :,:,: )  ! layer thickness
         Real,    Allocatable :: DENS     ( :,:,: )  ! air density
         Real,    Allocatable :: RJACM    ( :,:,: )  ! reciprocal mid-layer Jacobian
         Real,    Allocatable :: RJACF    ( :,:,: )  ! reciprocal full-layer Jacobian
         Real,    Allocatable :: RRHOJ    ( :,:,: )  ! reciprocal density X Jacobian
      End Type MET_Type
      
      Type :: GRID_Type
!> Grid infomation:
!> Vertical information
         Real,    Allocatable :: DX3F   ( : )     ! sigma layer surface thickness ! vdiffacmx.F
         Real,    Allocatable :: RDX3F  ( : )     ! reciprocal sigma layer thickness ! EMIS_DEFN.F, sedi.F, vdiffacmx.F, vdiffproc.F
         Real,    Allocatable :: RDX3M  ( : )     ! reciprocal sigma midlayer thickness ! vdiffproc.F
!> Horizontal Information:
         Real,    Allocatable :: RMSFX4 ( :,: )  ! inverse map scale factor ** 4
         Real,    Allocatable :: LON    ( :,: )  ! longitude
         Real,    Allocatable :: LAT    ( :,: )  ! latitude
         Real,    Allocatable :: LWMASK ( :,: )  ! land water mask
         Real,    Allocatable :: OCEAN  ( :,: )  ! Open ocean fraction
         Real,    Allocatable :: SZONE  ( :,: )  ! Surf zone fraction
         Real,    Allocatable :: PURB   ( :,: )  ! percent urban [%]
         Integer, Allocatable :: SLTYP  ( :,: )  ! soil type [category]
         Real,    Allocatable :: WSAT   ( :,: )  ! volumetric soil saturation concentration
         Real,    Allocatable :: WWLT   ( :,: )  ! soil wilting point
         Real,    Allocatable :: BSLP   ( :,: )  ! B Slope 
         Real,    Allocatable :: WRES   ( :,: )  ! Soil residual moisture point
         Real,    Allocatable :: WFC    ( :,: )  ! soil field capacity 
!        Real,    Allocatable :: RHOB   ( :,: )  ! soil bulk density
         Real, Allocatable :: LUFRAC  ( :,:,: ) ! land use fraction (col,row,lu_type)[ratio]
C Land use information:
         Character( 16 ), Allocatable   :: NAME    ( : )     ! LU name
         Character( 16 ), Allocatable   :: LU_Type ( : )     ! general land use type e.g. water, forest, etc.
      End Type GRID_Type


      Type( MET_Type )    :: Met_Data 
      Type( GRID_Type )   :: Grid_Data 

      Integer, Save   :: n_spc_m3dry = ltotg       ! from DEPVVARS module
!> M3 asx constants
      Real, Parameter :: a0         = 8.0        ! [dim'less]
      Real, Parameter :: d3         = 1.38564e-2 ! [dim'less]
      Real, Parameter :: dwat       = 0.2178     ! [cm^2/s] at 273.15K
      Real, Parameter :: hplus_ap   = 1.0e-6     ! pH=6.0 leaf apoplast solution Ph (Massad et al 2008)      
      Real, Parameter :: hplus_def  = 1.0e-5     ! pH=5.0
      Real, Parameter :: hplus_east = 1.0e-5     ! pH=5.0
      Real, Parameter :: hplus_h2o  = 7.94328e-9 ! 10.0**(-8.1)
      Real, Parameter :: hplus_west = 3.16228e-6 ! 10.0**(-5.5)
      Real, Parameter :: kvis       = 0.132      ! [cm^2 / s] at 273.15K
      Real, Parameter :: pr         = 0.709      ! [dim'less]
      Real, Parameter :: rcut0      = 3000.0     ! [s/m]
      Real, Parameter :: rcw0       = 125000.0   ! acc'd'g to Padro and
      Real, Parameter :: resist_max = 1.0e30     ! maximum resistance
      Real, Parameter :: rg0        = 1000.0     ! [s/m]
      Real, Parameter :: rgwet0     = 25000.0    ! [s/m]
      Real, Parameter :: rsndiff    = 10.0       ! snow diffusivity fac
      Real, Parameter :: rsnow0     = 10000.0    !  Changed from 1000 to 10000 - Helmig et al 2012
      Real, Parameter :: svp2       = 17.67      ! from MM5 and WRF
      Real, Parameter :: svp3       = 29.65      ! from MM5 and WRF
      Real, Parameter :: rt25inK    = 1.0/(stdtemp + 25.0) ! 298.15K = 25C
      Real, Parameter :: twothirds  = 2.0 / 3.0
      Real, Parameter :: betah      = 5.0       ! WRF 3.6 px uses Dyer
      Real, Parameter :: gamah      = 16.0
      Real, Parameter :: pr0        = 0.95
      Real, Parameter :: karman     = 0.40
      Real, Parameter :: f3min      = 0.25
      Real, Parameter :: ftmin      = 0.0000001  ! m/s
      Real, Parameter :: nscat      = 16.0
      Real, Parameter :: rsmax      = 5000.0     ! s/m

      Real            :: ar       ( ltotg )        ! reactivity relative to HNO3
      Real            :: dif0     ( ltotg )        ! molecular diffusivity [cm2/s]
      Real            :: lebas    ( ltotg )        ! Le Bas molar volume [cm3/mol ]
      Real            :: meso     ( ltotg )        ! Exception for species that 
                                                   ! react with cell walls. fo in 
                                                   ! Wesely 1989 eq 6.
      Character( 16 ) :: subname  ( ltotg )        ! for subroutine HLCONST

      Logical, Save :: MET_INITIALIZED = .false.
      Logical, Save :: CSTAGUV            ! Winds are available with C stagger?
!      Logical, Save :: ifwr     = .false.

      Public        :: INIT_MET, GET_MET

      Integer,         Private :: C, R, L, S               ! loop induction variables
      Integer,         Private :: SPC
      Character( 16 ), Private, Save :: vname_rc, vname_rn, vname_uc, vname_vc

      Real, allocatable, private :: BUFF1D( : )     ! 1D temp var number of layers
      Real, allocatable, private :: BUFF2D( :,: )   ! 2D temp var
      Real, allocatable, private :: BUFF3D( :,:,: ) ! 3D temp var


      DATA subname(  1), dif0(  1), ar(  1), meso(  1), lebas(  1) / 'SO2             ', 0.1089,   10.0, 0.0,  35.0 /
      DATA subname(  2), dif0(  2), ar(  2), meso(  2), lebas(  2) / 'H2SO4           ', 0.1091, 8000.0, 0.0,  49.0 /
      DATA subname(  3), dif0(  3), ar(  3), meso(  3), lebas(  3) / 'NO2             ', 0.1361,    2.0, 0.1,  21.0 /
      DATA subname(  4), dif0(  4), ar(  4), meso(  4), lebas(  4) / 'NO              ', 0.1802,    2.0, 0.0,  14.0 /
      DATA subname(  5), dif0(  5), ar(  5), meso(  5), lebas(  5) / 'O3              ', 0.1444,   12.0, 1.0,  21.0 /
      DATA subname(  6), dif0(  6), ar(  6), meso(  6), lebas(  6) / 'HNO3            ', 0.1067, 8000.0, 0.0,  35.0 /
      DATA subname(  7), dif0(  7), ar(  7), meso(  7), lebas(  7) / 'H2O2            ', 0.1300,34000.0, 1.0,  28.0 /   !ar=34,000 such that r_cut=0.7 s/m as in Nguyen et al. 2015
      DATA subname(  8), dif0(  8), ar(  8), meso(  8), lebas(  8) / 'ACETALDEHYDE    ', 0.1111,   10.0, 0.0,  56.0 /
      DATA subname(  9), dif0(  9), ar(  9), meso(  9), lebas(  9) / 'FORMALDEHYDE    ', 0.1554,   10.0, 0.0,  35.0 /
      DATA subname( 10), dif0( 10), ar( 10), meso( 10), lebas( 10) / 'METHYLHYDROPEROX', 0.1179,   10.0, 0.3,  49.0 /   !meso change from 0.1 to 0.3, Wolfe and Thornton 2011 ACP per J. Bash
      DATA subname( 11), dif0( 11), ar( 11), meso( 11), lebas( 11) / 'PEROXYACETIC_ACI', 0.0868,   20.0, 0.1,  70.0 /
      DATA subname( 12), dif0( 12), ar( 12), meso( 12), lebas( 12) / 'ACETIC_ACID     ', 0.0944,   20.0, 0.0,  63.0 /
      DATA subname( 13), dif0( 13), ar( 13), meso( 13), lebas( 13) / 'NH3             ', 0.1978,   20.0, 0.0,  28.0 /
      DATA subname( 14), dif0( 14), ar( 14), meso( 14), lebas( 14) / 'PAN             ', 0.0687,   16.0, 0.1,  91.0 /
      DATA subname( 15), dif0( 15), ar( 15), meso( 15), lebas( 15) / 'HNO2            ', 0.1349,   20.0, 0.1,  28.0 /
      DATA subname( 16), dif0( 16), ar( 16), meso( 16), lebas( 16) / 'CO              ', 0.1807,    5.0, 0.0,  14.0 /
      DATA subname( 17), dif0( 17), ar( 17), meso( 17), lebas( 17) / 'METHANOL        ', 0.1329,    2.0, 0.0,  42.0 /
      DATA subname( 18), dif0( 18), ar( 18), meso( 18), lebas( 18) / 'N2O5            ', 0.0808, 5000.0, 0.0,  49.0 /
      DATA subname( 19), dif0( 19), ar( 19), meso( 19), lebas( 19) / 'NO3             ', 0.1153, 5000.0, 0.0,  28.0 /
      DATA subname( 20), dif0( 20), ar( 20), meso( 20), lebas( 20) / 'GENERIC_ALDEHYDE', 0.0916,   10.0, 0.0,  56.0 /
      DATA subname( 21), dif0( 21), ar( 21), meso( 21), lebas( 21) / 'CL2             ', 0.1080,   10.0, 0.0,  49.0 /
      DATA subname( 22), dif0( 22), ar( 22), meso( 22), lebas( 22) / 'HOCL            ', 0.1300,   10.0, 0.0,  38.5 / ! used value of HCL
      DATA subname( 23), dif0( 23), ar( 23), meso( 23), lebas( 23) / 'HCL             ', 0.1510, 8000.0, 0.0,  31.5 /
      DATA subname( 24), dif0( 24), ar( 24), meso( 24), lebas( 24) / 'FMCL            ', 0.1094,   10.0, 0.0,  45.5 / ! default value
      DATA subname( 25), dif0( 25), ar( 25), meso( 25), lebas( 25) / 'HG              ', 0.1194,    0.1, 0.0,  14.8 / ! lebas not used
      DATA subname( 26), dif0( 26), ar( 26), meso( 26), lebas( 26) / 'HGIIGAS         ', 0.0976, 8000.0, 0.0,  95.0 / ! estimation from back calculating to get dw25 = 1.04e-5 (Garland et al, 1965)
      DATA subname( 27), dif0( 27), ar( 27), meso( 27), lebas( 27) / 'TECDD_2378      ', 0.0525,    2.0, 0.0, 217.0 /
      DATA subname( 28), dif0( 28), ar( 28), meso( 28), lebas( 28) / 'PECDD_12378     ', 0.0508,    2.0, 0.0, 234.5 /
      DATA subname( 29), dif0( 29), ar( 29), meso( 29), lebas( 29) / 'HXCDD_123478    ', 0.0494,    2.0, 0.0, 252.0 /
      DATA subname( 30), dif0( 30), ar( 30), meso( 30), lebas( 30) / 'HXCDD_123678    ', 0.0494,    2.0, 0.0, 252.0 /
      DATA subname( 31), dif0( 31), ar( 31), meso( 31), lebas( 31) / 'HXCDD_123478    ', 0.0494,    2.0, 0.0, 252.0 /
      DATA subname( 32), dif0( 32), ar( 32), meso( 32), lebas( 32) / 'HPCDD_1234678   ', 0.0480,    2.0, 0.0, 269.5 /
      DATA subname( 33), dif0( 33), ar( 33), meso( 33), lebas( 33) / 'OTCDD           ', 0.0474,    2.0, 0.0, 287.0 /
      DATA subname( 34), dif0( 34), ar( 34), meso( 34), lebas( 34) / 'TECDF_2378      ', 0.0534,    2.0, 0.0, 210.0 /
      DATA subname( 35), dif0( 35), ar( 35), meso( 35), lebas( 35) / 'PECDF_12378     ', 0.0517,    2.0, 0.0, 227.5 /
      DATA subname( 36), dif0( 36), ar( 36), meso( 36), lebas( 36) / 'PECDF_23478     ', 0.0517,    2.0, 0.0, 227.5 /
      DATA subname( 37), dif0( 37), ar( 37), meso( 37), lebas( 37) / 'HXCDF_123478    ', 0.0512,    2.0, 0.0, 245.0 /
      DATA subname( 38), dif0( 38), ar( 38), meso( 38), lebas( 38) / 'HXCDF_123678    ', 0.0512,    2.0, 0.0, 245.0 /
      DATA subname( 39), dif0( 39), ar( 39), meso( 39), lebas( 39) / 'HXCDF_234678    ', 0.0512,    2.0, 0.0, 245.0 /
      DATA subname( 40), dif0( 40), ar( 40), meso( 40), lebas( 40) / 'HXCDF_123789    ', 0.0512,    2.0, 0.0, 245.0 /
      DATA subname( 41), dif0( 41), ar( 41), meso( 41), lebas( 41) / 'HPCDF_1234678   ', 0.0487,    2.0, 0.0, 262.5 /
      DATA subname( 42), dif0( 42), ar( 42), meso( 42), lebas( 42) / 'HPCDF_1234789   ', 0.0487,    2.0, 0.0, 262.5 /
      DATA subname( 43), dif0( 43), ar( 43), meso( 43), lebas( 43) / 'OTCDF           ', 0.0474,    2.0, 0.0, 280.0 /
      DATA subname( 44), dif0( 44), ar( 44), meso( 44), lebas( 44) / 'NAPHTHALENE     ', 0.0778,    4.0, 0.0, 119.0 / !Julin et al. 2014 doi:10.1021/es501816h 
      DATA subname( 45), dif0( 45), ar( 45), meso( 45), lebas( 45) / '1NITRONAPHTHALEN', 0.0692,    4.0, 0.0, 133.0 /
      DATA subname( 46), dif0( 46), ar( 46), meso( 46), lebas( 46) / '2NITRONAPHTHALEN', 0.0692,    4.0, 0.0, 133.0 /
      DATA subname( 47), dif0( 47), ar( 47), meso( 47), lebas( 47) / '14NAPHTHOQUINONE', 0.0780,    4.0, 0.0, 119.0 /
      DATA subname( 48), dif0( 48), ar( 48), meso( 48), lebas( 48) / 'HEXAMETHYLE_DIIS', 0.0380,   10.0, 0.0, 196.0 /
      DATA subname( 49), dif0( 49), ar( 49), meso( 49), lebas( 49) / 'HYDRAZINE       ', 0.4164,   20.0, 0.0,  42.0 /
      DATA subname( 50), dif0( 50), ar( 50), meso( 50), lebas( 50) / 'MALEIC_ANHYDRIDE', 0.0950,   10.0, 0.0,  70.0 /
      DATA subname( 51), dif0( 51), ar( 51), meso( 51), lebas( 51) / '24-TOLUENE_DIIS ', 0.0610,   10.0, 0.0, 154.0 /
      DATA subname( 52), dif0( 52), ar( 52), meso( 52), lebas( 52) / 'TRIETHYLAMINE   ', 0.0881,   20.0, 0.0, 154.0 /
      DATA subname( 53), dif0( 53), ar( 53), meso( 53), lebas( 53) / 'ORG_NTR         ', 0.0607,   16.0, 0.0, 160.0 /  ! assumes 58.2% C5H11O4N and 41.8% C5H11O3N
      DATA subname( 54), dif0( 54), ar( 54), meso( 54), lebas( 54) / 'HYDROXY_NITRATES', 0.0609,   16.0, 0.0, 156.1 /
      DATA subname( 55), dif0( 55), ar( 55), meso( 55), lebas( 55) / 'MPAN            ', 0.0580,   16.0, 0.1, 133.0 /
      DATA subname( 56), dif0( 56), ar( 56), meso( 56), lebas( 56) / 'PPN             ', 0.0631,   16.0, 0.1, 118.2 /
      DATA subname( 57), dif0( 57), ar( 57), meso( 57), lebas( 57) / 'METHACROLEIN    ', 0.0810,    8.0, 1.0,  88.8 /
      DATA subname( 58), dif0( 58), ar( 58), meso( 58), lebas( 58) / 'DINTR           ', 0.0617,   16.0, 0.1, 169.8 /
      DATA subname( 59), dif0( 59), ar( 59), meso( 59), lebas( 59) / 'NTR_ALK         ', 0.0688,   16.0, 0.1, 133.0 /
      DATA subname( 60), dif0( 60), ar( 60), meso( 60), lebas( 60) / 'NTR_OH          ', 0.0665,   16.0, 0.1, 140.4 /
      DATA subname( 61), dif0( 61), ar( 61), meso( 61), lebas( 61) / 'HYDROXY_NITRATES', 0.0646,   16.0, 0.0, 147.8 /
      DATA subname( 62), dif0( 62), ar( 62), meso( 62), lebas( 62) / 'PROPNN          ', 0.0677,   16.0, 0.0, 133.0 /
      DATA subname( 63), dif0( 63), ar( 63), meso( 63), lebas( 63) / 'NITRYL_CHLORIDE ', 0.0888,    8.0, 0.0,  45.5 /  ! dif0 estimated following Erickson III et al., JGR, 104, D7, 8347-8372, 1999
      DATA subname( 64), dif0( 64), ar( 64), meso( 64), lebas( 64) / 'ISOPNN          ',0.0457,  275.9, 0.0,  206.8 /
      DATA subname( 65), dif0( 65), ar( 65), meso( 65), lebas( 65) / 'MTNO3           ',0.0453,   96.2, 0.0,  251.2 /
      DATA subname( 66), dif0( 66), ar( 66), meso( 66), lebas( 66) / 'IEPOX           ',0.0579,    8.0, 0.0,  110.8 /
      DATA subname( 67), dif0( 67), ar( 67), meso( 67), lebas( 67) / 'HACET           ',0.1060,    8.0, 0.0,   72.6 /  ! dif0 from Nguyen 2015 PNAS
      DATA subname( 68), dif0( 68), ar( 68), meso( 68), lebas( 68) / 'SVALK1          ',0.0514, 4572.8, 0.0,  280.5 /  ! Pye et al. doi:10.5194/acp-17-343-2017; rel. reactivity per J. Bash
      DATA subname( 69), dif0( 69), ar( 69), meso( 69), lebas( 69) / 'SVALK2          ',0.0546,   12.9, 0.0,  275.6 /
      DATA subname( 70), dif0( 70), ar( 70), meso( 70), lebas( 70) / 'SVBNZ1          ',0.0642,20671.2, 0.0,  134.1 /
      DATA subname( 71), dif0( 71), ar( 71), meso( 71), lebas( 71) / 'SVBNZ2          ',0.0726,   52.5, 0.0,  127.5 /
      DATA subname( 72), dif0( 72), ar( 72), meso( 72), lebas( 72) / 'SVISO1          ',0.0733,   50.6, 0.0,  126.3 /
      DATA subname( 73), dif0( 73), ar( 73), meso( 73), lebas( 73) / 'SVISO2          ',0.0729,10009.0, 0.0,  123.8 /
      DATA subname( 74), dif0( 74), ar( 74), meso( 74), lebas( 74) / 'SVPAH1          ',0.0564,  772.1, 0.0,  235.7 /
      DATA subname( 75), dif0( 75), ar( 75), meso( 75), lebas( 75) / 'SVPAH2          ',0.0599,    4.8, 0.0,  231.5 /
      DATA subname( 76), dif0( 76), ar( 76), meso( 76), lebas( 76) / 'SVSQT           ',0.0451,   10.3, 0.0,  346.5 /
      DATA subname( 77), dif0( 77), ar( 77), meso( 77), lebas( 77) / 'SVTOL1          ',0.0637, 1928.3, 0.0,  153.7 /
      DATA subname( 78), dif0( 78), ar( 78), meso( 78), lebas( 78) / 'SVTOL2          ',0.0607,  111.6, 0.0,  194.1 /
      DATA subname( 79), dif0( 79), ar( 79), meso( 79), lebas( 79) / 'SVTRP1          ',0.0603,  160.1, 0.0,  194.9 /
      DATA subname( 80), dif0( 80), ar( 80), meso( 80), lebas( 80) / 'SVTRP2          ',0.0559,   13.0, 0.0,  218.8 /
      DATA subname( 81), dif0( 81), ar( 81), meso( 81), lebas( 81) / 'SVXYL1          ',0.0610, 3586.7, 0.0,  154.6 /
      DATA subname( 82), dif0( 82), ar( 82), meso( 82), lebas( 82) / 'SVXYL2          ',0.0585,   72.2, 0.0,  194.6 /
      DATA subname( 83), dif0( 83), ar( 83), meso( 83), lebas( 83) / 'IO              ',0.1004,    8.0, 0.0,   45.5 /
      DATA subname( 84), dif0( 84), ar( 84), meso( 84), lebas( 84) / 'OIO             ',0.0940,    8.0, 0.0,   52.5 /
      DATA subname( 85), dif0( 85), ar( 85), meso( 85), lebas( 85) / 'I2O2            ',0.0734,    8.0, 0.0,   91.0 /
      DATA subname( 86), dif0( 86), ar( 86), meso( 86), lebas( 86) / 'I2O3            ',0.0709,    8.0, 0.0,   98.0 /
      DATA subname( 87), dif0( 87), ar( 87), meso( 87), lebas( 87) / 'I2O4            ',0.0686,    8.0, 0.0,  105.0 /
      DATA subname( 88), dif0( 88), ar( 88), meso( 88), lebas( 88) / 'HI              ',0.1047,    8.0, 0.0,   45.5 /
      DATA subname( 89), dif0( 89), ar( 89), meso( 89), lebas( 89) / 'HOI             ',0.0974,    8.0, 0.0,   52.5 /
      DATA subname( 90), dif0( 90), ar( 90), meso( 90), lebas( 90) / 'INO             ',0.0885,    8.0, 0.0,   52.5 /
      DATA subname( 91), dif0( 91), ar( 91), meso( 91), lebas( 91) / 'INO2            ',0.0835,   20.0, 0.0,   59.5 /
      DATA subname( 92), dif0( 92), ar( 92), meso( 92), lebas( 92) / 'INO3            ',0.0794,    8.0, 0.0,   66.5 /
      DATA subname( 93), dif0( 93), ar( 93), meso( 93), lebas( 93) / 'BRO             ',0.1146,    1.0, 0.0,   38.5 /
      DATA subname( 94), dif0( 94), ar( 94), meso( 94), lebas( 94) / 'HOBR            ',0.1104,    1.0, 0.0,   45.5 /
      DATA subname( 95), dif0( 95), ar( 95), meso( 95), lebas( 95) / 'HBR             ',0.1219,    2.0, 0.0,   38.5 /
      DATA subname( 96), dif0( 96), ar( 96), meso( 96), lebas( 96) / 'BRNO3           ',0.0871,    1.0, 0.0,   59.5 /
      DATA subname( 97), dif0( 97), ar( 97), meso( 97), lebas( 97) / 'BRNO2           ',0.0922,    1.0, 0.0,   52.5 /
      DATA subname( 98), dif0( 98), ar( 98), meso( 98), lebas( 98) / 'BRCL            ',0.0968,    1.0, 0.0,   56.0 /
      DATA subname( 99), dif0( 99), ar( 99), meso( 99), lebas( 99) / 'DMS             ',0.0896,    2.0, 0.0,   77.0 /
      DATA subname(100), dif0(100), ar(100), meso(100), lebas(100) / 'MSA             ',0.0844,    2.0, 0.0,   77.0 /
      DATA subname(101), dif0(101), ar(101), meso(101), lebas(101) / 'METHANE         ',0.2107,    2.0, 0.0,   29.6 / ! dif0, eqn 9-22 Schwarzenbach Gschwend & Imboden (1993) Env Org Chem
      DATA subname(102), dif0(102), ar(102), meso(102), lebas(102) / 'ACRYACID        ',0.0908,    2.0, 0.0,   63.2 / 
      DATA subname(103), dif0(103), ar(103), meso(103), lebas(103) / 'CARBSULFIDE     ',0.1240,    5.0, 0.0,   51.5 / 
      DATA subname(104), dif0(104), ar(104), meso(104), lebas(104) / 'ACETONITRILE    ',0.1280,    5.0, 0.0,   52.3 / 
      DATA subname(105), dif0(105), ar(105), meso(105), lebas(105) / '6_NITRO_O_CRESOL',0.0664,   16.0, 0.0,  155.0 / ! dif0, eqn 9-22 Schwarzenbach Gschwend & Imboden (1993) Env Org Chem
      DATA subname(106), dif0(106), ar(106), meso(106), lebas(106) / 'GENERIC_ALDEHYDE',0.0646,   10.0, 0.0,   56.0 / ! PCVOC
      DATA subname(107), dif0(107), ar(107), meso(107), lebas(107) / 'NTR_OH          ',0.0722,   16.0, 0.1,  140.4 / ! INTR
      DATA subname(108), dif0(108), ar(108), meso(108), lebas(108) / 'METHYLHYDROPEROX',0.0853,   10.0, 0.3,   49.0 / ! ISPX diffusion should be ~ 0.0710 according to Wolfe and thornton 2011 ACP
      DATA subname(109), dif0(109), ar(109), meso(109), lebas(109) / 'METHYLHYDROPEROX',0.1371,   10.0, 0.3,   49.0 / ! ROOH diffusion should be ~ 0.0710 according to Wolfe and thornton 2011 ACP
      DATA subname(110), dif0(110), ar(110), meso(110), lebas(110) / 'ADIPIC_ACID     ',0.0646,90000.0, 0.0,   63.0 / ! LVPCSOG
      DATA subname(111), dif0(111), ar(111), meso(111), lebas(111) / 'ADIPIC_ACID     ',0.0456,    4.2, 0.0,   63.0 / ! VIVPO1
      DATA subname(112), dif0(112), ar(112), meso(112), lebas(112) / 'ADIPIC_ACID     ',0.0766,71624.8, 0.0,   63.0 / ! VLVOO1
      DATA subname(113), dif0(113), ar(113), meso(113), lebas(113) / 'ADIPIC_ACID     ',0.0766, 9042.0, 0.0,   63.0 / ! VLVOO2
      DATA subname(114), dif0(114), ar(114), meso(114), lebas(114) / 'ADIPIC_ACID     ',0.0533,13818.0, 0.0,   63.0 / ! VLVPO1
      DATA subname(115), dif0(115), ar(115), meso(115), lebas(115) / 'ADIPIC_ACID     ',0.0771, 1133.9, 0.0,   63.0 / ! VSVOO1
      DATA subname(116), dif0(116), ar(116), meso(116), lebas(116) / 'ADIPIC_ACID     ',0.0771,   18.1, 0.0,   63.0 / ! VSVOO2
      DATA subname(117), dif0(117), ar(117), meso(117), lebas(117) / 'ADIPIC_ACID     ',0.0775,    2.3, 0.0,   63.0 / ! VSVOO3
      DATA subname(118), dif0(118), ar(118), meso(118), lebas(118) / 'ADIPIC_ACID     ',0.0511, 1830.5, 0.0,   63.0 / ! VSVPO1
      DATA subname(119), dif0(119), ar(119), meso(119), lebas(119) / 'ADIPIC_ACID     ',0.0493,  241.0, 0.0,   63.0 / ! VSVPO2
      DATA subname(120), dif0(120), ar(120), meso(120), lebas(120) / 'ADIPIC_ACID     ',0.0474,   31.8, 0.0,   63.0 / ! VSVPO3
      DATA subname(121), dif0(121), ar(121), meso(121), lebas(121) / 'FORMIC_ACID     ',0.1411,   20.0, 0.0,   63.0 / ! FACD
      DATA subname(122), dif0(122), ar(122), meso(122), lebas(122) / 'MEK             ',0.0859,    1.0, 0.0,  108.2 / ! KET different in different mechanisms
      DATA subname(123), dif0(123), ar(123), meso(123), lebas(123) / 'ETHENE          ',0.1366,    1.0, 0.0,   58.1 / ! ETH
      DATA subname(124), dif0(124), ar(124), meso(124), lebas(124) / 'HNO4            ',0.1233,    1.0, 0.0,   45.2 / ! PNA
      DATA subname(125), dif0(125), ar(125), meso(125), lebas(125) / 'GLYOXAL         ',0.1188,    1.0, 0.0,   56.2 / ! GLY
      DATA subname(126), dif0(126), ar(126), meso(126), lebas(126) / 'GLYOXAL         ',0.1181,    1.0, 0.0,   56.4 / ! GLYD
      DATA subname(127), dif0(127), ar(127), meso(127), lebas(127) / 'METHYL_GLYOXAL  ',0.1038,    1.0, 0.0,   72.5 / ! MGLY
      DATA subname(128), dif0(128), ar(128), meso(128), lebas(128) / 'ETHANE          ',0.1312,    1.0, 0.0,   61.5 / ! ETHA
      DATA subname(129), dif0(129), ar(129), meso(129), lebas(129) / 'ETHANOL         ',0.1213,    1.0, 0.0,   59.1 / ! ETOH
      DATA subname(130), dif0(130), ar(130), meso(130), lebas(130) / 'ETHANE          ',0.0870,    1.0, 0.0,  111.1 / ! PAR as Pentane
      DATA subname(131), dif0(131), ar(131), meso(131), lebas(131) / 'ACETONE         ',0.1057,    1.0, 0.0,   75.2 / ! ACET
      DATA subname(132), dif0(132), ar(132), meso(132), lebas(132) / 'PROPANE         ',0.1095,    1.0, 0.0,   78.1 / ! PRPA
      DATA subname(133), dif0(133), ar(133), meso(133), lebas(133) / 'ACETYLENE       ',0.1523,    1.0, 0.0,   45.8 / ! ETHY
      DATA subname(134), dif0(134), ar(134), meso(134), lebas(134) / 'ETHENE          ',0.1135,    1.0, 0.0,   73.1 / ! OLE as Propene
      DATA subname(135), dif0(135), ar(135), meso(135), lebas(135) / 'ETHENE          ',0.0990,    1.0, 0.0,   89.5 / ! IOLE as Isobutene
      DATA subname(136), dif0(136), ar(136), meso(136), lebas(136) / 'MEK             ',0.0852,    1.0, 0.0,  101.2 / ! IEPOX different scavenging H in CB05 and CB06
      DATA subname(137), dif0(137), ar(137), meso(137), lebas(137) / 'BENZENE         ',0.0942,    1.0, 0.0,   89.4 / ! BENZENE
      DATA subname(138), dif0(138), ar(138), meso(138), lebas(138) / '2-CRESOL        ',0.0850,    1.0, 0.0,  108.1 / ! CRES
      DATA subname(139), dif0(139), ar(139), meso(139), lebas(139) / 'TOLUENE         ',0.0860,    1.0, 0.0,  105.7 / ! TOL
      DATA subname(140), dif0(140), ar(140), meso(140), lebas(140) / 'O-XYLENE        ',0.0796,    1.0, 0.0,  122.0 / ! XYLMN
      DATA subname(141), dif0(141), ar(141), meso(141), lebas(141) / 'O-XYLENE        ',0.0777,    1.0, 0.0,  123.5 / ! NAPH
      DATA subname(142), dif0(142), ar(142), meso(142), lebas(142) / 'PHENOL          ',0.0844,    1.0, 0.0,  102.6 / ! CAT1
      DATA subname(143), dif0(143), ar(143), meso(143), lebas(143) / 'PINENE          ',0.0545,    1.0, 0.0,  251.5 / ! SESQ
      DATA subname(144), dif0(144), ar(144), meso(144), lebas(144) / 'PINENE          ',0.0700,    1.0, 0.0,  136.2 / ! TERP
      DATA subname(145), dif0(145), ar(145), meso(145), lebas(145) / 'ISOPRENE        ',0.0913,    1.0, 0.0,  136.2 / ! ISOP
      DATA subname(146), dif0(146), ar(146), meso(146), lebas(146) / 'METHACROLEIN    ',0.1033,    1.0, 0.0,   69.6 / ! OPEN C4H4O2
      DATA subname(147), dif0(147), ar(147), meso(147), lebas(147) / 'MEK             ',0.0950,    1.0, 0.0,   81.7 / ! XOPN C5H6O2
      DATA subname(148), dif0(148), ar(148), meso(148), lebas(148) / 'DECANE          ',0.0739,    1.0, 0.0,  142.8 / ! SOAALK as Propylcyclopentane
      DATA subname(149), dif0(149), ar(149), meso(149), lebas(149) / '13-BUTADIENE    ',0.1019,    1.0, 0.0,   84.8 / ! BUTADIENE13
      DATA subname(150), dif0(150), ar(150), meso(150), lebas(150) / 'ACROLEIN        ',0.1092,    1.0, 0.0,   70.5 /
      DATA subname(151), dif0(151), ar(151), meso(151), lebas(151) / 'SVMT1           ',0.0424,   20.0,      0.0, 355.2/ ! see Xu et al., 2018 ACPD: doi:10.5194/acp-2017-1109
      DATA subname(152), dif0(152), ar(152), meso(152), lebas(152) / 'SVMT2           ',0.0556,   20.0,      0.0, 236.8/
      DATA subname(153), dif0(153), ar(153), meso(153), lebas(153) / 'SVMT3           ',0.0583,   20.0,      0.0, 214.6/
      DATA subname(154), dif0(154), ar(154), meso(154), lebas(154) / 'SVMT4           ',0.0587,   20.0,      0.0, 229.4/
      DATA subname(155), dif0(155), ar(155), meso(155), lebas(155) / 'SVMT5           ',0.0619,   20.0,      0.0, 207.2/
      DATA subname(156), dif0(156), ar(156), meso(156), lebas(156) / 'SVMT6           ',0.0624,   20.0,      0.0, 222.0/
      DATA subname(157), dif0(157), ar(157), meso(157), lebas(157) / 'SVMT7           ',0.0661,   20.0,      0.0, 199.8/
      DATA subname(158), dif0(158), ar(158), meso(158), lebas(158) / 'SVAVB1          ',0.0560,100388.0,     0.0, 163.1/
      DATA subname(159), dif0(159), ar(159), meso(159), lebas(159) / 'SVAVB2          ',0.0600,  1461.2,     0.0, 163.2/
      DATA subname(160), dif0(160), ar(160), meso(160), lebas(160) / 'SVAVB3          ',0.0620,   175.2,     0.0, 163.0/
      DATA subname(161), dif0(161), ar(161), meso(161), lebas(161) / 'SVAVB4          ',0.0650,    20.8,     0.0, 162.7/
      DATA subname(162), dif0(162), ar(162), meso(162), lebas(162) / 'CLNO3           ',0.0902,    8.0,      0.0,  52.5/
      DATA subname(163), dif0(163), ar(163), meso(163), lebas(163) / 'FMBR            ',0.0965,   10.0,      0.0,  52.5/
      DATA subname(164), dif0(164), ar(164), meso(164), lebas(164) / 'I2              ',0.0795,    4.0,      0.0,  77.0/
      DATA subname(165), dif0(165), ar(165), meso(165), lebas(165) / 'CH3I            ',0.0881,    2.0,      0.0,  66.5/
      DATA subname(166), dif0(166), ar(166), meso(166), lebas(166) / 'ICL             ',0.0878,    4.0,      0.0,  63.0/
      DATA subname(167), dif0(167), ar(167), meso(167), lebas(167) / 'IBR             ',0.0851,    4.0,      0.0,  70.0/
      DATA subname(168), dif0(168), ar(168), meso(168), lebas(168) / 'MI2             ',0.0713,    2.0,      0.0,  98.0/
      DATA subname(169), dif0(169), ar(169), meso(169), lebas(169) / 'MIB             ',0.0753,    2.0,      0.0,  91.0/
      DATA subname(170), dif0(170), ar(170), meso(170), lebas(170) / 'MIC             ',0.0773,    2.0,      0.0,  84.0/
      DATA subname(171), dif0(171), ar(171), meso(171), lebas(171) / 'BR2             ',0.0925,    2.0,      0.0,  63.0/
      DATA subname(172), dif0(172), ar(172), meso(172), lebas(172) / 'MB3             ',0.0705,    2.0,      0.0, 108.5/
      DATA subname(173), dif0(173), ar(173), meso(173), lebas(173) / 'CH3BR           ',0.0980,    2.0,      0.0,  59.5/
      DATA subname(174), dif0(174), ar(174), meso(174), lebas(174) / 'MB2             ',0.0804,    2.0,      0.0,  84.0/
      DATA subname(175), dif0(175), ar(175), meso(175), lebas(175) / 'MB2C            ',0.0720,    2.0,      0.0, 101.5/
      DATA subname(176), dif0(176), ar(176), meso(176), lebas(176) / 'MBC2            ',0.0739,    2.0,      0.0,  94.5/
      DATA subname(177), dif0(177), ar(177), meso(177), lebas(177) / 'MBC             ',0.0834,    2.0,      0.0,  77.0/
      DATA subname(178), dif0(178), ar(178), meso(178), lebas(178) / 'CLO             ',0.1288,    8.0,      0.0,  31.5/

      CONTAINS

C=======================================================================
         Subroutine INIT_MET ( JDATE, JTIME )

C-----------------------------------------------------------------------
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX;
C                      allocatable RDEPVHT, RJACM, RRHOJ
C   14 Nov 03 J.Young: add reciprocal vertical Jacobian product for full and
C                      mid-layer
C   Tanya took JACOBF out of METCRO3D! Improvise
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   25 Jul 19 D.Wong: used N_SOIL_TYPE defined in LSM_Mod to handle
C                     various number of soil type from different WRF version
C-----------------------------------------------------------------------

         Use UTILIO_DEFN
         Use LSM_Mod, only : N_SOIL_TYPE

         Implicit None
 
         Include SUBST_FILES_ID  ! file name parameters

C Arguments:
         Integer, Intent( IN ) :: JDATE, JTIME      ! internal simulation date&time

C Local variables:
         Character( 16 ) :: PNAME = 'INIT_MET'
         Character( 16 ) :: VNAME
         CHARACTER( 16 ) :: UNITSCK
         CHARACTER( 30 ) :: MSG1 = ' Error interpolating variable '
         Character( 96 ) :: XMSG = ' '

         Integer V
         Integer ALLOCSTAT

C-----------------------------------------------------------------------

         If( MET_INITIALIZED )Return

!> Allocate buffers
         ALLOCATE ( BUFF1D( NLAYS ),
     &              BUFF2D( NCOLS,NROWS ),
     &              BUFF3D( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating Buffers'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

         BUFF1D = 0.0
         BUFF2D = 0.0
         BUFF3D = 0.0

!> Allocate shared arrays
!> Met_Data
         ALLOCATE( Met_Data%RDEPVHT  ( NCOLS,NROWS ),
     &             Met_Data%DENS1    ( NCOLS,NROWS ),
     &             Met_Data%PRSFC    ( NCOLS,NROWS ),
     &             Met_Data%Q2       ( NCOLS,NROWS ),
     &             Met_Data%QSS_GRND ( NCOLS,NROWS ),
     &             Met_Data%RH2      ( NCOLS,NROWS ),
     &             Met_Data%RA       ( NCOLS,NROWS ),
     &             Met_Data%RS       ( NCOLS,NROWS ),
     &             Met_Data%RC       ( NCOLS,NROWS ),
     &             Met_Data%RN       ( NCOLS,NROWS ),
     &             Met_Data%RGRND    ( NCOLS,NROWS ),
     &             Met_Data%HFX      ( NCOLS,NROWS ),
     &             Met_Data%LH       ( NCOLS,NROWS ),
     &             Met_Data%SNOCOV   ( NCOLS,NROWS ),
     &             Met_Data%TEMP2    ( NCOLS,NROWS ),
     &             Met_Data%TEMPG    ( NCOLS,NROWS ),
     &             Met_Data%TSEASFC  ( NCOLS,NROWS ),
     &             Met_Data%USTAR    ( NCOLS,NROWS ),
     &             Met_Data%VEG      ( NCOLS,NROWS ),
     &             Met_Data%LAI      ( NCOLS,NROWS ),
     &             Met_Data%WR       ( NCOLS,NROWS ),
     &             Met_Data%WSPD10   ( NCOLS,NROWS ),
     &             Met_Data%WSTAR    ( NCOLS,NROWS ),
     &             Met_Data%Z0       ( NCOLS,NROWS ),
     &             Met_Data%SOIM1    ( NCOLS,NROWS ),
     &             Met_Data%SOIT1    ( NCOLS,NROWS ),
     &             Met_Data%SEAICE   ( NCOLS,NROWS ),
     &             Met_Data%MOL      ( NCOLS,NROWS ),
     &             Met_Data%MOLI     ( NCOLS,NROWS ),
     &             Met_Data%HOL      ( NCOLS,NROWS ),
     &             Met_Data%XPBL     ( NCOLS,NROWS ),
     &             Met_Data%LPBL     ( NCOLS,NROWS ),
     &             Met_Data%CONVCT   ( NCOLS,NROWS ),
     &             Met_Data%PBL      ( NCOLS,NROWS ),
!     &             Met_Data%NACL_EMIS( NCOLS,NROWS ),
     &             Met_Data%COSZEN   ( NCOLS,NROWS ),
     &             Met_Data%UWIND    ( NCOLS+1,NROWS+1,NLAYS ),
     &             Met_Data%VWIND    ( NCOLS+1,NROWS+1,NLAYS ),
     &             Met_Data%KZMIN    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%PRES     ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%QV       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%QC       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%THETAV   ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%TA       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RH       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%ZH       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%ZF       ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%DZF      ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%DENS     ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RJACM    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RJACF    ( NCOLS,NROWS,NLAYS ),
     &             Met_Data%RRHOJ    ( NCOLS,NROWS,NLAYS ),
     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating met vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If

         ALLOCATE( Grid_Data%DX3F    ( NLAYS ),
     &             Grid_Data%RDX3F   ( NLAYS ),
     &             Grid_Data%RDX3M   ( NLAYS ),
     &             Grid_Data%RMSFX4  ( NCOLS,NROWS ),
     &             Grid_Data%LON     ( NCOLS,NROWS ),
     &             Grid_Data%LAT     ( NCOLS,NROWS ),
     &             Grid_Data%LWMASK  ( NCOLS,NROWS ),
     &             Grid_Data%OCEAN   ( NCOLS,NROWS ),
     &             Grid_Data%SZONE   ( NCOLS,NROWS ),
     &             Grid_Data%PURB    ( NCOLS,NROWS ),
     &             Grid_Data%SLTYP   ( NCOLS,NROWS ),
     &             Grid_Data%WSAT    ( NCOLS,NROWS ),
     &             Grid_Data%WFC     ( NCOLS,NROWS ),   !We now use WFC whether BIDI is on or off
     &             Grid_Data%NAME    ( n_lufrac ),
     &             Grid_Data%LU_Type ( n_lufrac ),
     &             STAT = ALLOCSTAT )
         If ( ALLOCSTAT .Ne. 0 ) Then
            XMSG = 'Failure allocating grid vars'
            Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         End If
         Grid_Data%NAME    = name_lu
         Grid_Data%LU_Type = cat_lu
         Grid_Data%WSAT    = 0.0
         Grid_Data%WFC     = 0.0

         If ( ABFLUX  ) Then
            ALLOCATE( Met_Data%SOIM2    ( NCOLS,NROWS ),
     &                STAT = ALLOCSTAT )
            If ( ALLOCSTAT .Ne. 0 ) Then
               XMSG = 'Failure allocating layer 2 soil moisture'
               Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            End If

            ALLOCATE( Grid_Data%WWLT   ( NCOLS,NROWS ),
     &                Grid_Data%BSLP   ( NCOLS,NROWS ),
     &                Grid_Data%WRES   ( NCOLS,NROWS ),
!    &                Grid_Data%WFC    ( NCOLS,NROWS ),
     &                Grid_Data%LUFRAC ( NCOLS,NROWS,n_lufrac ),
     &                STAT = ALLOCSTAT )
            If ( ALLOCSTAT .Ne. 0 ) Then
               XMSG = 'Failure allocating Soil grid vars'
               Call M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            End If
            Grid_Data%WWLT    = 0.0
!           Grid_Data%WFC     = 0.0
            Grid_Data%WRES    = 0.0
            Grid_Data%BSLP    = 0.0
         End If

!> ccccccccccccccccccccc enable backward compatiblity ccccccccccccccccccccc

         IF (RCA_AVAIL) THEN
            vname_rc = 'RCA'
         Else
            vname_rc = 'RC'
         End If

         IF (RNA_AVAIL) THEN
            vname_rn = 'RNA'
         Else
            vname_rn = 'RN'
         End If

         If (UWINDC_AVAIL) Then
            vname_uc = 'UWINDC'
            CSTAGUV  = .TRUE.
         Else
            vname_uc = 'UWIND'
            CSTAGUV  = .FALSE.
         End If

         If (VWINDC_AVAIL) Then
            vname_vc = 'VWINDC'
         Else
            vname_vc = 'VWIND'
         End If

         If ( .Not. MINKZ ) Then
            XMSG = 'This run uses Kz0UT, *NOT* KZMIN in subroutine edyintb.'
            Write( LOGDEV,'(/5X, A, /)' ) XMSG
         End If

!> Get sigma coordinate variables
         Do L = 1, NLAYS
            Grid_Data%DX3F( L )  = X3FACE_GD( L ) - X3FACE_GD( L-1 )
            Grid_Data%RDX3F( L ) = 1.0 / Grid_Data%DX3F( L )
            BUFF1D( L ) = 0.5 * ( X3FACE_GD( L ) + X3FACE_GD( L-1 ) )
         End Do
         Do L = 1, NLAYS - 1
            Grid_Data%RDX3M( L ) = 1.0 / ( BUFF1D( L+1 ) - BUFF1D( L ) )
         End Do
         Grid_Data%RDX3M( NLAYS ) = 0.0

!> reciprocal of msfx2**2
         Grid_Data%RMSFX4 = 1.0 / ( MSFX2**2 )

         Grid_Data%LON = LON

         Grid_Data%LAT = LAT

         Grid_Data%LWMASK = LWMASK

         Grid_Data%PURB = PURB

         Grid_Data%SLTYP = NINT( SOILCAT_A )

         If ( ABFLUX ) Then
            Grid_Data%LUFRAC = LUFRAC

            Forall( C = 1:NCOLS, R = 1:NROWS, Grid_Data%SLTYP(C,R) .Le. N_SOIL_TYPE )
               Grid_Data%WSAT( C,R ) = WSAT( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WWLT( C,R ) = WWLT( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WFC ( C,R ) = WFC ( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WRES( C,R ) = WRES( Grid_Data%SLTYP( C,R ) )
               Grid_Data%BSLP( C,R ) = BSLP( Grid_Data%SLTYP( C,R ) )
            End Forall
         Else
            Forall( C = 1:NCOLS, R = 1:NROWS, Grid_Data%SLTYP(C,R) .Le. N_SOIL_TYPE )
               Grid_Data%WSAT( C,R ) = WSAT( Grid_Data%SLTYP( C,R ) )
               Grid_Data%WFC ( C,R ) = WFC ( Grid_Data%SLTYP( C,R ) )
            End Forall
         End If

         Grid_Data%OCEAN = ocean

         Grid_Data%SZONE = szone
         
         MET_INITIALIZED = .true.

         Return
         End Subroutine INIT_MET

C=======================================================================
         Subroutine GET_MET ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX;
C                      allocatable RDEPVHT, RJACM, RRHOJ
C   14 Nov 03 J.Young: add reciprocal vertical Jacobian product for full and
C                      mid-layer
C   Tanya took JACOBF out of METCRO3D! Improvise
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C-----------------------------------------------------------------------

         USE GRID_CONF       ! horizontal & vertical domain specifications
         Use UTILIO_DEFN
#ifdef parallel
         USE SE_MODULES      ! stenex (using SE_COMM_MODULE)
#else
         USE NOOP_MODULES    ! stenex (using NOOP_COMM_MODULE)
#endif

         Implicit None
 
         Include SUBST_FILES_ID  ! file name parameters
         Include SUBST_PE_COMM   ! PE communication displacement and direction

C Arguments:

         Integer, Intent( IN ) :: JDATE, JTIME, TSTEP      ! internal simulation date&time

C Parameters:
         Real, Parameter :: cond_min = 1.0 / resist_max ! minimum conductance [m/s]
         Real, Parameter :: KZMAXL = 500.0    ! upper limit for min Kz [m]
         Real, Parameter :: KZ0UT  = 1.0      ! minimum eddy diffusivity [m**2/sec] KZ0
         Real, Parameter :: KZL    = 0.01     ! lowest KZ
         Real, Parameter :: KZU    = 1.0      ! 2.0  ! highest KZ
         Real, Parameter :: EPS    = 1.0E-08  ! small number for temperature difference

C Local variables:
         Real    FINT
         Real    CPAIR, LV, QST 
         Real    TMPFX, TMPVTCON, TST, TSTV
         Integer LP
         Integer C, R, L         ! loop induction variables

         Character( 16 ) :: PNAME = 'GET_MET'
         Character( 16 ) :: VNAME
         CharactER( 30 ) :: MSG1 = ' Error interpolating variable '
         Character( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------
C Interpolate file input variables and format for output
C-------------------------------- MET_CRO_3D --------------------------------
      
         call interpolate_var ('ZH', jdate, jtime, Met_Data%ZH)

         call interpolate_var ('PRES', jdate, jtime, Met_Data%PRES)

         call interpolate_var ('ZF', jdate, jtime, Met_Data%ZF)

         call interpolate_var ('DENS', jdate, jtime, Met_Data%DENS)

         Met_Data%DENS1 = Met_Data%DENS( :,:,1 )
     
         call interpolate_var ('JACOBM', jdate, jtime, Met_Data%RJACM)

         Met_Data%RJACM = 1.0 / Met_Data%RJACM

         call interpolate_var ('JACOBF', jdate, jtime, Met_Data%RJACF)

         Met_Data%RJACF = 1.0 / Met_Data%RJACF

         call interpolate_var ('DENSA_J', jdate, jtime, Met_Data%RRHOJ)

         Met_Data%RRHOJ = 1.0 / Met_Data%RRHOJ

         call interpolate_var ('TA', jdate, jtime, Met_Data%TA)

         call interpolate_var ('QV', jdate, jtime, Met_Data%QV)

         call interpolate_var ('QC', jdate, jtime, Met_Data%QC)

C-------------------------------- MET_CRO_2D --------------------------------
C Vegetation and surface vars
         call interpolate_var ('LAI', jdate, jtime, Met_Data%LAI)

         call interpolate_var ('VEG', jdate, jtime, Met_Data%VEG)

         call interpolate_var ('ZRUF', jdate, jtime, Met_Data%Z0)

C Soil vars
         call interpolate_var ('SOIM1', jdate, jtime, Met_Data%SOIM1)

         If ( ABFLUX ) Then
            call interpolate_var ('SOIM2', jdate, jtime, Met_Data%SOIM2)
         End If

         call interpolate_var ('SOIT1', jdate, jtime, Met_Data%SOIT1)

         call interpolate_var ('SEAICE', jdate, jtime, Met_Data%SEAICE)

C met vars

         call interpolate_var ('PRSFC', jdate, jtime, Met_Data%PRSFC)

         call interpolate_var ('RGRND', jdate, jtime, Met_Data%RGRND)

         call interpolate_var ('SNOCOV', jdate, jtime, Met_Data%SNOCOV)

         Where( Met_Data%SNOCOV .Lt. 0.0 )
            Met_Data%SNOCOV = 0.0
         End Where

         call interpolate_var ('TEMP2', jdate, jtime, Met_Data%TEMP2)

         call interpolate_var ('TEMPG', jdate, jtime, Met_Data%TEMPG)

         call interpolate_var ('USTAR', jdate, jtime, Met_Data%USTAR)

         call interpolate_var ('WSPD10', jdate, jtime, Met_Data%WSPD10)

         call interpolate_var ('HFX', jdate, jtime, Met_Data%HFX)

         If ( LH_AVAIL ) Then
            call interpolate_var ('LH', jdate, jtime, Met_Data%LH)
         Else   ! for backward compatibility
            call interpolate_var ('QFX', jdate, jtime, Met_Data%LH)
         End If

         call interpolate_var ('PBL', jdate, jtime, Met_Data%PBL)

C Met_cro_2D variables that have recently changed due to MCIP or WRF/CMAQ

         call interpolate_var (vname_rn, jdate, jtime, Met_Data%RN)

         call interpolate_var (vname_rc, jdate, jtime, Met_Data%RC)

         If ( WR_AVAIL ) Then
            call interpolate_var ('WR', jdate, jtime, Met_Data%WR)
         End If

         If ( TSEASFC_AVAIL ) Then
            call interpolate_var ('TSEASFC', jdate, jtime, Met_Data%TSEASFC)
         Else
            Met_Data%TSEASFC = Met_Data%TEMPG
         End If

         If ( .not. RA_RS_AVAIL ) Then
            call interpolate_var ('RADYNI', jdate, jtime, Met_Data%RA)

            Where( Met_Data%RA .Gt. cond_min ) 
               Met_Data%RA = 1.0/Met_Data%RA
            Elsewhere
               Met_Data%RA = resist_max
            End Where

            call interpolate_var ('RSTOMI', jdate, jtime, Met_Data%RS)

            Where( Met_Data%RS .Gt. cond_min ) 
               Met_Data%RS = 1.0 / Met_Data%RS
            Elsewhere 
               Met_Data%RS = resist_max
            End Where

         Else 

            call interpolate_var ('RA', jdate, jtime, Met_Data%RA)

            call interpolate_var ('RS', jdate, jtime, Met_Data%RS)

         End If

         If ( Q2_AVAIL ) Then  ! Q2 in METCRO2D
            call interpolate_var ('Q2', jdate, jtime, Met_Data%Q2)
         Else
            Met_Data%Q2 = Met_Data%QV( :,:,1 )
         End If
         
         Where( Met_Data%TEMPG .Lt. stdtemp )
            BUFF2D = vp0 *Exp( 22.514 - ( 6.15e3 / Met_Data%TEMPG ) )
         Elsewhere
            BUFF2D = vp0 *Exp( svp2 * ( Met_Data%TEMPG -stdtemp ) / ( Met_Data%TEMPG -svp3 ) ) 
         End Where
         Met_Data%QSS_GRND = BUFF2D * 0.622 / ( Met_Data%PRSFC - BUFF2D )

         Where( Met_Data%TEMP2 .Lt. stdtemp )
            BUFF2D = vp0 *Exp( 22.514 - ( 6.15e3 / Met_Data%TEMP2 ) )
         Elsewhere
            BUFF2D = vp0 *Exp( svp2 * ( Met_Data%TEMP2 -stdtemp ) / ( Met_Data%TEMP2 -svp3 ) )
         End Where

         ! Calculate Relative Humidity at 2m
         Met_Data%RH2 = Met_Data%Q2 / ( BUFF2D * 0.622 / ( Met_Data%PRSFC - BUFF2D ) ) * 100.0
         Where( Met_Data%RH2 .Gt. 100.0 )
            Met_Data%RH2 = 100.0
         Elsewhere( Met_Data%RH2 .lt. 0.0 )
            Met_Data%RH2 = 0.0
         End Where

         ! Calculate 3D Relative Humidity at Grid Scale
         MET_DATA%RH = MET_DATA%QV * MET_DATA%PRES / ( MET_DATA%QV + 0.622015 ) /
     &                 ( 610.94 * EXP( 17.625 * ( MET_DATA%TA - 273.15 ) / 
     &                                 ( MET_DATA%TA - 273.15 + 243.04 ) ) )
         MET_DATA%RH = MIN( 0.9999, MAX( 0.001, MET_DATA%RH ) )

C-------------------------------- MET_DOT_3D --------------------------------
         call interpolate_var (vname_uc, jdate, jtime, Met_Data%UWIND)

         call interpolate_var (vname_vc, jdate, jtime, Met_Data%VWIND)

C get ghost values for wind fields in case of free trop.
         CALL SUBST_COMM ( Met_Data%UWIND, DSPL_N0_E1_S0_W0, DRCN_E )
         CALL SUBST_COMM ( Met_Data%VWIND, DSPL_N1_E0_S0_W0, DRCN_N )

C-------------------------------- Calculated Variables --------------------------------
         Met_Data%DZF = Met_Data%ZF - EOSHIFT(Met_Data%ZF, Shift = -1, Boundary = 0.0, Dim = 3)

         Met_Data%RDEPVHT = 1.0 / Met_Data%ZF( :,:,1 )

         IF ( MINKZ ) THEN
            Met_Data%KZMIN = KZL
            DO L = 1, NLAYS
               Where( Met_Data%ZF( :,:,L ) .LE. KZMAXL )
                  Met_Data%KZMIN( :,:,L ) = KZL + ( KZU - KZL ) * 0.01 * Grid_data%PURB
               End Where
            End Do
         ELSE
            Met_Data%KZMIN = KZ0UT
         END IF

         BUFF3D = Met_Data%TA * ( 1.0 + 0.608 * Met_Data%QV )
         Met_Data%THETAV = BUFF3D * ( P0 / Met_Data%PRES ) ** 0.286

C------  Updating MOL, then WSTAR, MOLI, HOL 
         DO R = 1, NROWS
            DO C = 1, NCOLS
 !             CPAIR    = 1004.67 * ( 1.0 + 0.84 * Met_Data%QV( C,R,1 ) )   ! J/(K KG)
               CPAIR    = CPD * ( 1.0 + 0.84 * Met_Data%QV( C,R,1 ) )   ! J/(K KG)
               TMPFX    = Met_Data%HFX( C,R ) / ( CPAIR * Met_Data%DENS( C,R,1 ) )
               TMPVTCON = 1.0 + 0.608 * Met_Data%QV( C,R,1 )  ! Conversion factor for virtual temperature
               TST      = -TMPFX / Met_Data%USTAR( C,R )
               IF ( Met_Data%TA( C,R,1 ) .GT. STDTEMP ) THEN
                  LV = LV0 - ( 0.00237 * ( Met_Data%TA( C,R,1 ) - STDTEMP ) ) * 1.0E6
               ELSE
                  LV = 2.83E6     ! Latent heat of sublimation at 0C from Stull (1988) (J/KG)
               END IF
               QST  = -( Met_Data%LH( C,R ) / LV )
     &              / ( Met_Data%USTAR( C,R ) * Met_Data%DENS( C,R,1 ) )
               TSTV = TST * TMPVTCON + Met_Data%THETAV( C,R,1 ) * 0.608 * QST
               IF ( ABS( TSTV ) .LT. 1.0E-6 ) THEN
                  TSTV = SIGN( 1.0E-6, TSTV )
               END IF
               Met_Data%MOL( C,R ) = Met_Data%THETAV( C,R,1 )
     &                             * Met_Data%USTAR( C,R ) ** 2 / ( karman * GRAV * TSTV )
               IF ( Met_Data%MOL( C,R ) .LT. 0.0 ) THEN
                  Met_Data%WSTAR( C,R ) = Met_Data%USTAR( C,R ) * ( Met_Data%PBL( C,R )
     &                                  / ( karman * ABS( Met_Data%MOL( C,R ) ) ) ) ** 0.333333
               ELSE
                  Met_Data%WSTAR( C,R ) = 0.0
               END IF

            END DO
         END DO
   
         Met_Data%MOLI  = 1.0 / Met_Data%MOL 
         Met_Data%HOL   = Met_Data%PBL / Met_Data%MOL
C------

         Met_Data%CONVCT = .FALSE.
         DO R = 1, NROWS
            DO C = 1, NCOLS
               DO L = 1, NLAYS
                  IF ( Met_Data%PBL( C,R ) .LT. Met_Data%ZF( C,R,L ) ) THEN
                     LP = L; EXIT
                  END IF
               END DO

               Met_Data%LPBL( C,R ) = LP
               If ( LP .Eq. 1 ) Then
                  FINT = ( Met_Data%PBL( C,R ) )
     &                 / ( Met_Data%ZF( C,R,LP ) )
                  Met_Data%XPBL( C,R ) = FINT * ( X3FACE_GD( LP ) - X3FACE_GD( LP-1 ) )
     &                        + X3FACE_GD( LP-1 )
               Else
                  FINT = ( Met_Data%PBL( C,R )   - Met_Data%ZF( C,R,LP-1 ) )
     &                 / ( Met_Data%ZF( C,R,LP ) - Met_Data%ZF( C,R,LP-1 ) )
                  Met_Data%XPBL( C,R ) = FINT * ( X3FACE_GD( LP ) - X3FACE_GD( LP-1 ) )
     &                        + X3FACE_GD( LP-1 )
               End If
            END DO
         END DO
         Where( Met_Data%THETAV( :,:,1 ) - Met_Data%THETAV( :,:,2 ) .Gt. EPS .And.
     &          Met_Data%HOL .Lt. -0.02 .And. Met_Data%LPBL .Gt. 3 )
            Met_Data%CONVCT = .True.
         End Where

!        Calculate the cosine of the zenith angle 
         CALL CZANGLE(JDATE, JTIME, NCOLS, NROWS )

         Return
         End Subroutine GET_MET

      End Module ASX_DATA_MOD

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE EDDYX ( EDDYV )

C--------------------------------------------------------------------------
C---- Eddy diffusivity (Kz) computed according to 2 different models:
C----   1- Boundary Layer scaling based on Hostlag and Boville (1993)
C----      Kz = k ust z(1-z/h)2 / phih
C       2- Local scaling based on local Richardson # and vertical shear
C          similar to Liu and Carroll (1996)
C
C  Revision History:
C  JEP        4/00 - CCTM implimentation from MM5
C  JEP        4/06 - Updated for ACM2
C  TLO       10/09 - Allow read of C-staggered UWINDC and VWINDC from
C                    MET_DOT_3D, and corrected algorithm that computes
C                    component-wise shear so that B-staggered winds
C                    will be properly used.  Removed map-scale factor
C                    from wind shear calculation.
C  SJR       02/11 - replaced I/O API include files with UTILIO_DEFN
C  YOJ       05/13 - access met data from VDIFF_MET module
C  JOB       11/14 - Updated for the ASX_DATA_MOD shared data module which 
C                    included variables in the VDIFF_MET module.
C  HF        07/15 - Included pleim5 formulation. 
C  David Wong 02/19 - removed all MY_N clauses
C--------------------------------------------------------------------------

      USE GRID_CONF             ! horizontal domain specifications
      USE ASX_DATA_MOD          ! Includes CONST
      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:

C Arguments:
      REAL,   INTENT( OUT ) :: EDDYV ( :,:,: ) ! eddy diffusivity (m**2/s)

C Parameters:

      REAL, PARAMETER :: RLAM   = 80.0 ! asymptotic mixing length (m)
      REAL, PARAMETER :: RIC    = 0.25 ! critical Richardson #
      REAL, PARAMETER :: QUARTER = 0.25
      REAL, PARAMETER :: SIXTEENTH = QUARTER * QUARTER  ! 1/16

C External Functions: None

C File Variables:
      REAL    KZM                            ! local KZMIN

C Local variables:
      INTEGER MDATE, MTIME, STEP
      INTEGER C, R, L, V

      REAL    DZL                     ! Z(L+1)-Z(L)
      REAL    WW2                     ! (wind speed)**2
      REAL    WS2                     ! (wind shear)**2
      REAL    RIB                     ! Bulk Richardson Number
      REAL    ZOL
      REAL    ZFUNC, HPBL 
      REAL    EDDV                    ! local EDDYV
      REAL    FH

      INTEGER MCOL                   ! these don't need to be initialized
      INTEGER MROW
      INTEGER MLVL
      REAL    MTH1                   ! pot. temp. in layer L
      REAL    MTH2                   ! pot. temp. in layer L+1
      REAL    MRIB                   ! bulk Richardson Number
      REAL    MWS                    ! wind shear (/sec)
      REAL    MEDDYV                 ! eddy diffusivity (m**2/sec)

      REAL    QMEAN, TMEAN
      REAL    XLV, ALPH, CHI
      REAL    CPAIR, ZK, SQL, PHIH
      REAL    PHIM
      REAL    WT, ZSOL
      REAL    EDYZ
      REAL    ZFL                    ! local ZF

      CHARACTER( 16 ) :: PNAME = 'EDDYX'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: UNITSCK
      CHARACTER( 96 ) :: XMSG = ' '

C-----------------------------------------------------------------------

      MEDDYV = 0.0

      DO 233 L = 1, NLAYS-1
      DO 222 R = 1, NROWS
      DO 211 C = 1, NCOLS
         HPBL = MAX( Met_Data%PBL( C,R ), 20.0 )
         ZFL = Met_Data%ZF( C,R,L )
         KZM = Met_Data%KZMIN( C,R,L )

         ZOL = ZFL * Met_Data%MOLI( C,R )
         IF ( ZFL .LT. HPBL ) THEN
            IF ( ZOL .LT. 0.0 ) THEN
               IF ( ZFL .LT. 0.1 * HPBL ) THEN
                  PHIH = 1.0 / SQRT( 1.0 - GAMAH * ZOL )
               ELSE
                  ZSOL = 0.1 * HPBL * Met_Data%MOLI( C,R )
                  PHIH = 1.0 / SQRT( 1.0 - GAMAH * ZSOL )
               END IF
            ELSE IF ( ZOL .LT. 1.0 ) THEN
               PHIH = 1.0 + BETAH * ZOL
            ELSE
               PHIH = BETAH + ZOL
            END IF
            WT = Met_Data%USTAR( C,R ) / PHIH
            ZFUNC = 1.0 - ZFL / HPBL
            ZFUNC = ZFL * ZFUNC * ZFUNC
            EDYZ = KARMAN * WT * ZFUNC
            EDYZ = MAX( EDYZ, KZM )
         ELSE
            EDYZ = 0.0
         END IF

         IF ( CSTAGUV ) THEN  ! u- and v-component winds on C-stagger
           WW2 = QUARTER                  ! component-wise wind shear
     &         * ( ( Met_Data%UWIND( C+1,R,  L+1 ) - Met_Data%UWIND( C+1,R  ,L  )
     &             + Met_Data%UWIND( C,  R,  L+1 ) - Met_Data%UWIND( C,  R  ,L  ) ) ** 2
     &         +   ( Met_Data%VWIND( C,  R+1,L+1 ) - Met_Data%VWIND( C,  R+1,L )
     &             + Met_Data%VWIND( C,  R,  L+1 ) - Met_Data%VWIND( C,  R,  L  ) ) ** 2 )
         ELSE  ! u- and v-component winds on B-stagger
           WW2 = SIXTEENTH                ! component-wise wind shear
     &         * ( ( Met_Data%UWIND( C,  R,  L+1 ) - Met_Data%UWIND( C,  R  ,L  )
     &             + Met_Data%UWIND( C+1,R,  L+1 ) - Met_Data%UWIND( C+1,R  ,L  )
     &             + Met_Data%UWIND( C,  R+1,L+1 ) - Met_Data%UWIND( C,  R+1,L  )
     &             + Met_Data%UWIND( C+1,R+1,L+1 ) - Met_Data%UWIND( C+1,R+1,L  ) ) ** 2
     &          +  ( Met_Data%VWIND( C,  R,  L+1 ) - Met_Data%VWIND( C,  R  ,L  )
     &             + Met_Data%VWIND( C+1,R,  L+1 ) - Met_Data%VWIND( C+1,R  ,L  )
     &             + Met_Data%VWIND( C,  R+1,L+1 ) - Met_Data%VWIND( C,  R+1,L  )
     &             + Met_Data%VWIND( C+1,R+1,L+1 ) - Met_Data%VWIND( C+1,R+1,L  ) ) ** 2 )
         END IF

         DZL = Met_Data%ZH( C,R,L+1 ) - Met_Data%ZH( C,R,L )
         WS2 = WW2 / ( DZL * DZL ) + 1.0E-9

         RIB = 2.0 * GRAV * ( Met_Data%THETAV( C,R,L+1 ) - Met_Data%THETAV( C,R,L ) )
     &      / ( DZL * WS2 * ( Met_Data%THETAV( C,R,L+1 ) + Met_Data%THETAV( C,R,L ) ) )

C-- Adjustment to vert diff in Moist air from HIRPBL

         IF ( ( Met_Data%QC( C,R,L ) .GT. 0.01E-3 ) .OR.
     &        ( Met_Data%QC( C,R,L+1 ) .GT. 0.01E-3 ) ) THEN
            QMEAN = 0.5 * ( Met_Data%QV( C,R,L ) + Met_Data%QV( C,R,L+1 ) )
            TMEAN = 0.5 * ( Met_Data%TA( C,R,L ) + Met_Data%TA( C,R,L+1 ) )
            XLV = ( 2.501 - 0.00237 * ( TMEAN - 273.15 ) ) * 1.0E6
            ALPH = XLV * QMEAN / RDGAS / TMEAN
            CPAIR = 1004.67 * ( 1.0 + 0.84 * Met_Data%QV( C,R,L ) )   ! J/(K KG)
            CHI = XLV * XLV * QMEAN / ( CPAIR * RWVAP * TMEAN * TMEAN )
            RIB = ( 1.0 + ALPH )
     &          * ( RIB - GRAV * GRAV / ( WS2 * TMEAN * CPAIR )
     &          * ( ( CHI - ALPH ) / ( 1.0 + CHI ) ) )
         END IF

         ZK = 0.4 * ZFL
         SQL = ZK * RLAM / ( RLAM + ZK )
         SQL = SQL * SQL

         IF ( RIB .GE. 0.0 ) THEN
!           FH = 1.0   ! pleim5
!    &         / ( 1.0 + 10.0 * RIB + 50.0 * RIB ** 2 + 5000.0 * RIB ** 4 ) + 0.0012
            FH =  1.0 + RIB * ( 10.0 + RIB * ( 50.0 + 5000.0 * RIB * RIB ) )
            FH = 0.0012 + 1.0 / FH  ! pleim5

            EDDV = KZM + SQRT( WS2 ) * FH * SQL
         ELSE
            EDDV = KZM + SQRT( WS2 * ( 1.0 - 25.0 * RIB ) ) * SQL
         END IF

         IF ( ZFL .LT. HPBL .AND. EDYZ .GT. EDDV ) THEN
            EDDV = EDYZ
         END IF
         EDDV = MIN( 1000.0, EDDV )

         IF ( EDDV .GT. MEDDYV ) THEN
C Capture the col, row, lvl, and EDDYV for the global min DT
            MCOL = C
            MROW = R
            MLVL = L
            MEDDYV = EDDV
            MTH1 = Met_Data%THETAV( C,R,L )
            MTH2 = Met_Data%THETAV( C,R,L+1 )
            MRIB = RIB
            MWS  = SQRT ( WS2 )
         END IF

         EDDYV( C,R,L ) = EDDV

211   CONTINUE       !  end loop on columns
222   CONTINUE       !  end loop on rows
233   CONTINUE       !  end loop on levels

      !WRITE( LOGDEV,* ) ' '
      !WRITE( LOGDEV,1001 ) MEDDYV, MCOL, MROW, MLVL
1001  FORMAT(/ 5X, 'Maximum eddy diffusivity of:', 1PG13.5,
     &         1X, '(m**2/sec)'
     &       / 5X, 'at col, row, layer:', I4, 2(', ', I3) )
      !WRITE( LOGDEV,1003 ) MWS, MRIB, MTH1, MTH2
1003  FORMAT(  5X, 'corresponding to a free tropospheric wind shear of:',
     &         1PG13.5,  1X, '(/sec),'
     &        /28X, 'a bulk Richardson Number of:', 1PG13.5, ','
     &        / 5X, 'and pot. temps. in layer and layer+1:', 2(1PG13.5) )
      WRITE( LOGDEV,* ) '    '

      DO R = 1, NROWS
         DO C = 1, NCOLS
            EDDYV( C,R,NLAYS ) = 0.0
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/aero/aero5/aero_depv.F,v 1.12 2012/01/19 13:12:14 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C @(#)aero_depv.F       1.3 /project/mod3/CMAQ/src/ae_depv/aero_depv/SCCS/s.aero_depv.F 18 Jun 1997 12:55:48

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!      SUBROUTINE AERO_DEPV ( CGRID, JDATE, JTIME, TSTEP, MOSAIC, VDEP_AE )
      SUBROUTINE AERO_DEPV ( CGRID, JDATE, JTIME, TSTEP, VDEP_AE )

C-----------------------------------------------------------------------
C aerosol dry deposition routine
C   written 4/9/97 by Dr. Francis S. Binkowski
C   uses code from modpar and vdvg from the aerosol module.
C   This routine uses a single block to hold information
C   for the lowest layer.
C NOTES: This version assumes that RA is available on the met file.
c        Array structure for vector optimization
C 26 Apr 97 Jeff - many mods
C 13 Dec 97 Jeff - expect uncoupled CGRID, concs as micro-g/m**3, #/m**3
C
C 1/11/99 David Wong at LM - change NUMCELLS to CELLNUM in the loop index
C FSB 3/17/99 changed to accommodate surface area/second moment and
C    encapsulated the actual drydep calculation into a subroutine which
C    is attached to this code
C Jeff - Dec 00 - move CGRID_MAP into f90 module
C FSB 12/11/2000. Logic added to allow deposition of particles at their
C     "wet" diameters; that is, accounting for the water on the particles.
C     This is done by adjusting the third and second moments for the
C     presence of water assuming that the geometric standard deviations
C     are not changed by this process. This appears to be a very good
C     assumption.
C 30 Aug 01 J.Young: Dyn alloc; Use HGRD_DEFN
C    Jan 03 J.Young: Change CGRID dimensions, eliminate re-allocations
C  6 Mar 03 J.Young: eliminate a lot of allocate/deallocates
C  7 Aug 03 S.Roselle: updated code for loading the min aero conc array
C 17 Dec 03 S.Roselle: Adjust 2nd and 3rd moments to include SOA,
C     without affecting the geometric standard deviations.
C 31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C     domain specifications in one module
C 07 Jun 05 P.Bhave: Added code to handle new species in the AE4
C     mechanism: ANAI, ANAJ, ANAK, ACLI, ACLJ, ACLK, ASO4K, AH2OK,
C     and ANO3K; look for ASEAS only when using AE3 mechanism
C 30 Jan 08 S.Napelenok & P.Bhave: Added code to handle new SOA species
C     in AE5; defined DRY aerosol to include nonvolatile SOA spcs
C 14 Apr 08 J.Kelly: Added code to handle new species ANH4K and SRFCOR.
C     Also added code to handle variable coarse mode standard deviation
C     in AE5 (no longer fixed at 2.2).
C 08 Sep 08 P.Bhave: Backward compatibility with AE4 mechanisms
C     standardized names of all coarse-mode variables
C 19 Apr 10 S.Howard: aero re-engineering for modularity
C 23 Apr 10 J.Young: replace chem mechanism include files with namelists
C 10 Mar 11 S.Howard: Renamed met_data to aeromet_data
C 25 Mar 11 S.Roselle: Replaced I/O API include files with UTILIO_DEFN
C 20 May 11 D.Schwede: Modified for mosaic
C 31 Aug 11 J.Bash: Moved shared mosaic variables to MOSAIC_MOD
C 27 Sep 11 David Wong: replaced all run time dynamic arrays with allocatable
C                       arrays to avoid run time memory issue  
C 08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C 07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C 07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C    May 16 B. Murphy, H. Pye: Updated treatment of aerosol moments
C-----------------------------------------------------------------------

      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE RXNS_DATA           ! chemical mechanism data
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN      
      USE AERO_DATA           ! aero variable data
      USE AEROMET_DATA        ! Includes CONST.EXT
!      USE Mosaic_Mod, Only: ADEPVJ  ! Shared mosaic variables
!      Use LSM_Mod, Only: N_LUFRAC
      USE ASX_DATA_MOD, Only: Met_Data

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments
      REAL,    POINTER       :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN )  :: JDATE               ! current model date , coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME               ! current model time , coded HHMMSS
      INTEGER, INTENT( IN )  :: TSTEP               ! model time step, coded HHMMSS
!      LOGICAL, INTENT( IN )  :: MOSAIC              ! use mosaic option
      REAL,    INTENT( OUT ) :: VDEP_AE( :,:,: )    ! surrogate deposition velocities [ m s**-1 ]

C Parameters
      REAL,    PARAMETER :: T0 = 288.15      ! [ K ] ! starting standard surface temp.
      REAL,    PARAMETER :: TWO3 = 2.0 / 3.0
      INTEGER, PARAMETER :: N_AE_DEP_SPC = 9 ! no. of surrogates for aerosol dry dep velocities

C set up species dimension and indices for deposition velocity internal array VDEP
      INTEGER, PARAMETER :: VDNATK = 1,  ! Aitken mode number
     &                      VDNACC = 2,  ! accumulation mode number
     &                      VDNCOR = 3,  ! coarse mode number
     &                      VDMATK = 4,  ! Aitken mode mass
     &                      VDMACC = 5,  ! accumulation mode mass
     &                      VDMCOR = 6,  ! coarse mode mass
     &                      VDSATK = 7,  ! Aitken mode surface area
     &                      VDSACC = 8,  ! accumulation mode surface area
     &                      VDSCOR = 9   ! coarse mode surface area

C Local variables:

      CHARACTER( 16 ) :: VDAE_NAME( N_AE_DEP_SPC )! dep vel surrogate name table
      DATA         VDAE_NAME( 1 ) / 'VNUMATKN' /
      DATA         VDAE_NAME( 2 ) / 'VNUMACC ' /
      DATA         VDAE_NAME( 3 ) / 'VNUMCOR ' /
      DATA         VDAE_NAME( 4 ) / 'VMASSI  ' /
      DATA         VDAE_NAME( 5 ) / 'VMASSJ  ' /
      DATA         VDAE_NAME( 6 ) / 'VMASSC  ' /
      DATA         VDAE_NAME( 7 ) / 'VSRFATKN' /
      DATA         VDAE_NAME( 8 ) / 'VSRFACC ' /
      DATA         VDAE_NAME( 9 ) / 'VSRFCOR ' /

      INTEGER, ALLOCATABLE, SAVE :: DEPV_SUR( : )   ! pointer to surrogate

C Meteorological variables

      CHARACTER( 16 ), SAVE :: AE_VRSN ! Aerosol version name

      INTEGER, SAVE :: NCELLS              ! number of cells per layer

      REAL, ALLOCATABLE, SAVE  :: XXLSG( :,:,: )  ! log of standard deviation
      REAL, ALLOCATABLE, SAVE  :: DG( :,:,: )     ! geometric mean diameter
      REAL, ALLOCATABLE, SAVE  :: PDENS( :,:,: )  ! particle density         
      REAL, ALLOCATABLE, SAVE  :: XLM( :,: )      ! mean free path [ m ]
      REAL, ALLOCATABLE, SAVE  :: AMU( :,: )      ! dynamic viscosity [ kg m**-1 s**-1 ]

      REAL, ALLOCATABLE, SAVE :: VDEP( :,:,: )    ! deposition  velocity [ m/s ]
!      REAL, ALLOCATABLE, SAVE :: VDEPJ( :,:,:,: ) ! deposition  velocity [ m/s ]

      REAL M3_WET, M3SUBT, M3_DRY
      REAL M2_WET, M2_DRY

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 16 ), SAVE :: PNAME = 'AERO_DEPV'
      CHARACTER( 16 ) :: VNAME            ! varable name
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER  C, R, V, N, J, IM     ! loop counters
      INTEGER  SPC, S                ! species loop counter
      INTEGER  ALLOCSTAT
 
      INTERFACE
        SUBROUTINE GETDEP_V ( XLM, AMU, DG, XXLSG, PDENS,
     &                        VDEP, N_AE_DEP_SPC ) !VDEPJ, MOSAIC )
          REAL, INTENT( IN ) :: XLM( :,: )        ! atmospheric mean free path [ m ]
          REAL, INTENT( IN ) :: AMU( :,: )        ! atmospheric dynamic viscosity [ kg/(m s) ]
          REAL, INTENT( IN ) :: DG( :,:,: )       ! geometric mean diameter  [ m ]
          REAL, INTENT( IN ) :: XXLSG( :,:,: )    ! Standard Deviation
          REAL, INTENT( IN ) :: PDENS( :,:,: )    ! average particle density 
          REAL, INTENT( OUT ) :: VDEP( :,:,: )    ! deposition  velocity [ m/s ]
          !REAL, INTENT( OUT ) :: VDEPJ( :,:,:,: ) ! deposition  velocity [ m/s ] for each land use category
          !LOGICAL, INTENT( IN ) :: MOSAIC
          INTEGER, INTENT( IN ) :: N_AE_DEP_SPC
        END SUBROUTINE GETDEP_V
      END INTERFACE
 
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         NCELLS = NCOLS * NROWS

C  Allocate arrays
         ALLOCATE ( XLM( NCOLS,NROWS ), AMU( NCOLS,NROWS ), 
     &              DG( NCOLS,NROWS,N_MODE ), XXLSG( NCOLS,NROWS,N_MODE ),
     &              PDENS( NCOLS,NROWS,N_MODE ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating XLM, AMU, DG, XXLSG, or PDENS.'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ALLOCATE ( VDEP( NCOLS,NROWS,N_AE_DEP_SPC ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VDEP'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         ALLOCATE ( DEPV_SUR( N_AE_DEPV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DEPV_SUR'
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Set the dep vel surrogate pointers
         DO V = 1, N_AE_DEPV
            N = INDEX1( AE_DEPV( V ), N_AE_DEP_SPC, VDAE_NAME )
            IF ( N .NE. 0 ) THEN
               DEPV_SUR( V ) = N
            ELSE
               XMSG = 'Could not find ' // AE_DEPV( V ) // ' in aerosol' //
     &                ' surrogate table. >>> Dep vel set to zero <<< '
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               DEPV_SUR( V ) = 0
            END IF
         END DO

      END IF    ! FIRSTIME      

      IF ( N_AE_SPC .LE. 0 ) RETURN

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Put the grid cell physical data in the block arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

      DO R = 1, NROWS
      DO C = 1, NCOLS

C ***    Set meteorological data for the grid cell.
         AIRDENS = Met_Data%DENS1( C,R )
         AIRTEMP = Met_Data%TEMP2( C,R )
         AIRPRES = Met_Data%PRSFC( C,R )

C ***    extract grid cell concentrations of aero species from CGRID
C        into aerospc_conc in aero_data module
C        Also determines second moment from surface area and adds wet
C        species
#ifdef sens
         CALL EXTRACT_AERO( CGRID( C,R,1,: ), .TRUE., CGRID( C,R,:,: ), .FALSE. ) 
#else
         CALL EXTRACT_AERO( CGRID( C,R,1,: ), .TRUE. )
#endif

C ***    Calculate geometric mean diameters and standard deviations of the
C        "wet" size distribution
         CALL GETPAR( .FALSE. )     
 
C        Calculate mean free path [ m ]:
         XLM( C,R ) = 6.6328E-8 * STDATMPA * AIRTEMP / ( T0 * AIRPRES )

C ***    Calculate dynamic viscosity [ kg m-1 s-1 ]:
         AMU( C,R ) = 1.458E-6 * AIRTEMP * SQRT( AIRTEMP )
     &              / ( AIRTEMP + 110.4 )

         DO IM = 1,N_MODE
C           Save getpar values to arrays
            XXLSG( C,R,IM ) = AEROMODE_LNSG( IM )
            DG( C,R,IM )    = AEROMODE_DIAM( IM )
            PDENS( C,R,IM ) = AEROMODE_DENS( IM )

         END DO

      END DO ! Column LOOP
      END DO   ! Row LOOP

C *** Get dry deposition velocities:
      CALL GETDEP_V ( XLM, AMU, DG, XXLSG, PDENS,
     &                VDEP, N_AE_DEP_SPC ) !VDEPJ, MOSAIC )

C Return dry deposition velocities for aerosols (first layer only).

      DO R = 1, NROWS
         DO C = 1, NCOLS
            DO V = 1, N_AE_DEPV
               IF ( DEPV_SUR( V ) .GT. 0 ) THEN
                  VDEP_AE( V,C,R ) = VDEP( C,R,DEPV_SUR( V ) )
               ELSE
                  VDEP_AE( V,C,R ) = 0.0
               END IF
            END DO
         END DO
      END DO


      RETURN
      END SUBROUTINE AERO_DEPV

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETDEP_V ( XLM, AMU, DG, XXLSG, PDENS,
     &                      VDEP, N_AE_DEP_SPC ) !, VDEPJ, MOSAIC )

C *** Calculate deposition velocity for Aitken, accumulation, and
C     coarse modes.
C     Reference:
C     Binkowski F. S., and U. Shankar, The regional particulate
C     model 1. Model description and preliminary results.
C     J. Geophys. Res., 100, D12, 26191-26209, 1995.
 
C    May 05 D.Schwede: added impaction term to coarse mode dry deposition
C 25 May 05 J.Pleim:  Updated dry dep velocity calculation for aerosols
C                     to Venkatram and Pleim (1999)
C 20 Jul 05 J.Pleim:  Changed impaction term using modal integration of
C                     Stokes**2 / 400 (Giorgi, 1986, JGR)
C 14 Apr 08 J.Kelly:  Added code to calculate deposition velocity of
C                     coarse surface area and to account for variable
C                     standard deviation of the coarse mode.
C 08 Sep 08 P.Bhave:  Backward compatibility with AE4 mechanisms
C                     standardized names of all coarse-mode variables
C 29 Aug 18 J.Pleim:  Revised formulation of dry deposition impaction term 
C                     so that it integrates the affect of mode width in the 
C                     Stokes number via the settling velocity rather than 
C                     adjusting the impaction term magnitude directly at the
C                     end. This change is believed to resolve massive 
C                     overprediction of deposition velocity for coarse-mode 
C                     particles. Changed Stokes # to be more representative 
C                     of vegetated surfaces as suggested by Slinn (1982) and 
C                     Giorgi (1986), changed impaction term according to Slinn 
C                     (1982), and added scaling of diffusion layer resistance 
C                     (Rd) by LAI for vegetated fraction of grid cell. Developed 
C                     based on analysis by Qian Shu, University of Florida. 
C                     Peer-reviewed publication in preparation.
C-----------------------------------------------------------------------

      USE GRID_CONF, Only: ncols, nrows
      USE AEROMET_DATA   ! Includes CONST.EXT
      USE ASX_DATA_MOD, Only: Met_Data, Grid_Data !, Mosaic_Data
      USE AERO_DATA, Only: N_MODE

      IMPLICIT NONE

C *** input arguments
      INTEGER, INTENT( IN ) :: N_AE_DEP_SPC

C     atmospheric properties
      REAL, INTENT( IN ) :: XLM( :,: )  ! atmospheric mean free path [ m ]
      REAL, INTENT( IN ) :: AMU( :,: )  ! atmospheric dynamic viscosity [ kg/(m s) ]

C     aerosol properties:

C     modal diameters: [ m ]
      REAL, INTENT( IN ) :: DG( :,:,: ) 

C     log of modal geometric standard deviations
      REAL, INTENT( IN ) :: XXLSG( :,:,: )  

C     average modal particle densities  [ kg m-3 ]
      REAL, INTENT( IN ) :: PDENS( :,:,: )  

C *** output arguments

      ! deposition  velocity [ m/s ]
      REAL, INTENT( OUT ) :: VDEP( :,:,: ) 
      
C *** array indices hardcoded to match SUBROUTINE AERO_DEPV
      INTEGER, PARAMETER, DIMENSION( 3 ) :: 
     &                      VDN = (/ 1,2,3 /) , 
     &                      VDM = (/ 4,5,6 /) , 
     &                      VDS = (/ 7,8,9 /)  

C modal Knudsen number
      REAL KN 

C modal particle diffusivities for number, 2nd, and 3rd moment, or mass:
      REAL DCHAT0
      REAL DCHAT2
      REAL DCHAT3

C modal sedimentation velocities for number, 2nd, and 3rd moment, or mass:
      REAL VGHAT0
      REAL VGHAT2
      REAL VGHAT3

      INTEGER NCELL, J, C, R, IM

      REAL DCONST,  DCONST1
      REAL DCONST2, DCONST3
      REAL SC0     ! Schmidt numbers for number
      REAL SC2     ! Schmidt numbers for 2nd moment
      REAL SC3     ! Schmidt numbers for 3rd moment
      REAL STOKE2  ! Stokes numbers for each mode squared
      REAL RD0     ! canopy resistance for number
      REAL RD2     ! canopy resistance for 2nd moment
      REAL RD3     ! canopy resisteance for 3rd moment
      REAL UTSCALE              ! scratch function of USTAR and WSTAR
      REAL NU                   ! kinematic viscosity [ m2 s-1 ]
      REAL STOKEFAC             ! scratch function of USTAR, NU, and GRAV

      REAL, PARAMETER :: BHAT    = 1.246 ! Constant from Cunningham slip correction
      REAL, PARAMETER :: THREEPI = 3.0 * PI
      REAL, PARAMETER :: TWO3    = 2.0 / 3.0
      REAL, PARAMETER :: A2      = 0.002        ! size of surface element = 2 mm, could be func of LU

C Scalar variables for VARIABLE standard deviations.

      REAL    L2SG

      REAL    E1             ! mode exp( log^2( sigmag )/8 )
      REAL    ES04           !        " **4
      REAL    ES08           !        " **8
      REAL    ES12           !        " **12
      REAL    ES16           !        " **16
      REAL    ES20           !        " **20
      REAL    ES28           !        " **28
      REAL    ES32           !        " **32
      REAL    ES36           !        " **36
      REAL    ES48           !        " **48
      REAL    ES64           !        " **64
      REAL    ES128          !        " **128
      REAL    ES160          !        " **160
      REAL    ESM12          !        " **(-12)
      REAL    ESM16          !        " **(-16)
      REAL    ESM20          !        " **(-20)
      REAL    ESM32          !        " **(-32)
      REAL    EIM            ! Impaction efficiency

      REAL    TWOXLM

C-----------------------------------------------------------------------

      VDEP  = 0.0   ! array assignment

      DO IM = 1,N_MODE
      DO R = 1,NROWS
        DO C = 1,NCOLS
C *** Calculate Knudsen numbers
            TWOXLM = XLM( C,R ) + XLM( C,R )
            KN = TWOXLM / DG( C,R,IM )

C *** Calculate functions of variable standard deviation.

            L2SG = XXLSG( C,R,IM ) ** 2

            E1   = EXP( 0.125 * L2SG )
            ES04 = E1 ** 4
            ES08 = ES04 * ES04
            ES12 = ES04 * ES08
            ES16 = ES08 * ES08
            ES20 = ES16 * ES04
            ES28 = ES20 * ES08
            ES32 = ES16 * ES16
            ES36 = ES16 * ES20
            ES48 = ES36 * ES12
            ES64 = ES32 * ES32
            ES128= ES64 * ES64
            ES160= ES128* ES32

C *** calculate inverses:

            ESM12 = 1.0 / ES12
            ESM16 = 1.0 / ES16
            ESM20 = 1.0 / ES20
            ESM32 = 1.0 / ES32

            DCONST  = BOLTZMANN * Met_Data%TEMP2( C,R ) / ( THREEPI * AMU( C,R ) )
            DCONST1 = DCONST / DG( C,R,IM )

            DCONST2 = GRAV / ( 18.0 * AMU( C,R ) )
            DCONST3 = DCONST2 * PDENS( C,R,IM ) * DG( C,R,IM ) * DG( C,R,IM )
C Calculate characteristic parameters
            DCHAT0  = DCONST1 * ( ES04  + BHAT * KN * ES16 )
            DCHAT2  = DCONST1 * ( ESM12 + BHAT * KN * ESM16 )
            DCHAT3  = DCONST1 * ( ESM20 + BHAT * KN * ESM32 )
            VGHAT0  = DCONST3 * ( ES16  + BHAT * KN * ES04 )
            VGHAT2  = DCONST3 * ( ES48  + BHAT * KN * ES20 )
            VGHAT3  = DCONST3 * ( ES64  + BHAT * KN * ES28 )

C now calculate the deposition velocities

            NU = AMU( C,R ) / Met_Data%DENS1( C,R )
!            USTFAC = Met_Data%USTAR( C,R ) ** 2 / ( GRAV * NU )
!            STOKE  = DCONST3 * USTFAC
            STOKEFAC = Met_Data%USTAR( C,R ) / (GRAV * A2)
            UTSCALE = (1.+Met_Data%VEG(C,R) * MAX(Met_Data%LAI(C,R)-1.,0.0) )
     &              * (Met_Data%USTAR( C,R )
     &              + 0.24 * Met_Data%WSTAR( C,R )**2
     &              /        Met_Data%USTAR( C,R ) )

C first do 0th moment for the deposition of number
            SC0 = NU / DCHAT0
            STOKE2 = (STOKEFAC * VGHAT0)**2
            EIM = STOKE2 / (1.0 + STOKE2)
!            EIM = MIN( EIM, 1.0 )
            RD0 = 1.0 / ( UTSCALE * ( SC0 ** ( -TWO3 ) + EIM ) )

            VDEP( C,R,VDN( IM ) ) = VGHAT0
     &             / ( 1.0 - EXP( -VGHAT0 * ( Met_Data%RA( C,R ) + RD0 ) ) )

C now do 2nd moment for the deposition of surface area
            SC2 = NU / DCHAT2
            STOKE2 = (STOKEFAC * VGHAT2)**2
            EIM = STOKE2 / (1.0 + STOKE2)
!            EIM = MIN( EIM, 1.0 )
            RD2 = 1.0 / ( UTSCALE * ( SC2 ** ( -TWO3 ) + EIM ) )

            VDEP( C,R,VDS( IM ) ) = VGHAT2
     &             / ( 1.0 - EXP( -VGHAT2 * ( Met_Data%RA( C,R ) + RD2 ) ) )

C now do 3rd moment for the deposition of mass
            SC3 = NU / DCHAT3
            STOKE2 = (STOKEFAC * VGHAT3)**2
            EIM = STOKE2 / (1.0 + STOKE2)
!            EIM = MIN( EIM, 1.0 )
            RD3 = 1.0 / ( UTSCALE * ( SC3 ** ( -TWO3 ) + EIM ) )

            VDEP( C,R,VDM( IM ) ) = VGHAT3
     &             / ( 1.0 - EXP( -VGHAT3 * ( Met_Data%RA( C,R ) + RD3 ) ) )

        END DO ! end loop on C
      END DO ! end loop on R
      END DO ! aerosol mode

      RETURN
      END SUBROUTINE GETDEP_V

       MODULE RXNS_FUNCTION


       IMPLICIT NONE



! Name of Mechanism CB6R3_AE7_AQ

       PUBLIC             :: CALC_RCONST, SPECIAL_RATES, MAP_CHEMISTRY_SPECIES

       CONTAINS


       REAL( 8 ) FUNCTION POWER_T02( TEMPOT300,A0,B0 )
         IMPLICIT NONE
! rate constant for CMAQ Arrhenuis reaction type 2
! Arguements:
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: B0
         ! Local: None
         POWER_T02 =  A0 * TEMPOT300**B0
         RETURN
       END FUNCTION POWER_T02
       REAL( 8 ) FUNCTION ARRHENUIS_T04( INV_TEMP,TEMPOT300,A0,B0,C0 )
         IMPLICIT NONE
! rate constant for CMAQ Arrhenuis reaction type 4
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: B0
         REAL( 8 ), INTENT( IN ) :: C0
         ! Local:
         INTRINSIC DEXP
         ARRHENUIS_T04 =  A0 * DEXP( B0 * INV_TEMP ) * TEMPOT300**C0
         RETURN
       END FUNCTION ARRHENUIS_T04
       REAL( 8 ) FUNCTION ARRHENUIS_T03( INV_TEMP,A0,B0 )
! rate constant for CMAQ Arrhenuis reaction type 3
         IMPLICIT NONE
! Arguements:
         REAL( 8 ),   INTENT( IN ) ::  INV_TEMP
         REAL( 8 ),     INTENT(IN) ::  A0
         REAL( 8 ),     INTENT(IN) ::  B0
         ! Local:
         INTRINSIC DEXP
         ARRHENUIS_T03 =  A0 * DEXP( B0 * INV_TEMP )
         RETURN
       END FUNCTION ARRHENUIS_T03 
       REAL( 8 ) FUNCTION FALLOFF_T08(INV_TEMP,CAIR,A0,C0,A2,C2,A3,C3)
! rate constant for CMAQ fall off reaction type 8
         IMPLICIT NONE
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: C0
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: C2
         REAL( 8 ), INTENT( IN ) :: A3
         REAL( 8 ), INTENT( IN ) :: C3
         ! Local:
         REAL( 8 ) K0
         REAL( 8 ) K2
         REAL( 8 ) K3
         INTRINSIC DEXP
         K0 = A0 * DEXP( C0 * INV_TEMP )
         K2 = A2 * DEXP( C2 * INV_TEMP )
         K3 = A3 * DEXP( C3 * INV_TEMP )
         K3 = K3 * CAIR
         FALLOFF_T08 = K0 + K3/( 1.0D0 + K3/K2 )
         RETURN
       END FUNCTION FALLOFF_T08
       REAL( 8 ) FUNCTION FALLOFF_T09(INV_TEMP,CAIR,A1,C1,A2,C2)
! rate constant for CMAQ fall off reaction type 9
         IMPLICIT NONE
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: C1
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: C2
         !  Local:
         REAL( 8 ) K1
         REAL( 8 ) K2
         INTRINSIC DEXP
         K1 = A1 * DEXP( C1 * INV_TEMP )
         K2 = A2 * DEXP( C2 * INV_TEMP )
         FALLOFF_T09 = K1 + K2 * CAIR
         RETURN
       END FUNCTION FALLOFF_T09
       REAL( 8 ) FUNCTION FALLOFF_T10(INV_TEMP,TEMPOT300,CAIR,A0,B0,C0,A1,B1,C1,CE,CF)
         IMPLICIT NONE
! rate constant for CMAQ fall off reaction type 10
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A0
         REAL( 8 ), INTENT( IN ) :: B0
         REAL( 8 ), INTENT( IN ) :: C0
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: B1
         REAL( 8 ), INTENT( IN ) :: C1
         REAL( 8 ), INTENT( IN ) :: CE
         REAL( 8 ), INTENT( IN ) :: CF
         ! Local:
         REAL( 8 ) K0
         REAL( 8 ) K1
         REAL( 8 ) KEND
         K0 = A0 * CAIR * DEXP(B0*INV_TEMP)* TEMPOT300**C0
         K1 = A1 * DEXP(B1*INV_TEMP) * TEMPOT300**C1
         KEND = ( ( 1.0D0 + ( ( 1.0D0 / CE ) * DLOG10( K0 / K1 ) ) ** 2.0D0 ) )
         KEND = 1.0D0 / KEND
         FALLOFF_T10 = ( K0 / ( 1.0D0 + K0/K1 ) ) * CF ** KEND
         RETURN
       END FUNCTION FALLOFF_T10
       REAL( 8 ) FUNCTION FALLOFF_T11(INV_TEMP,TEMPOT300,CAIR,A1,B1,C1,A2, B2, C2, D1, D2)
! rate constant for CMAQ fall off reaction type 11
! actually expanded form of type 9
         IMPLICIT NONE
! Arguements:
         REAL( 8 ), INTENT( IN ) :: INV_TEMP
         REAL( 8 ), INTENT( IN ) :: TEMPOT300
         REAL( 8 ), INTENT( IN ) :: CAIR
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: B1
         REAL( 8 ), INTENT( IN ) :: C1
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: B2
         REAL( 8 ), INTENT( IN ) :: C2
         REAL( 8 ), INTENT( IN ) :: D1
         REAL( 8 ), INTENT( IN ) :: D2
         !  Local:
         REAL( 8 ) K1
         REAL( 8 ) K2
         REAL( 8 ) K3
         INTRINSIC DEXP
         K1 = A1 * DEXP( C1 * INV_TEMP ) * TEMPOT300**B1
         K2 = A2 * DEXP( C2 * INV_TEMP ) * TEMPOT300**B2
         K3 = D1 * DEXP( D2 * INV_TEMP )
         FALLOFF_T11 = K1 + K2 * CAIR + K3
         RETURN
       END FUNCTION FALLOFF_T11
       REAL( 8 ) FUNCTION HALOGEN_FALLOFF(PRESS,A1,B1,A2,B2)
         IMPLICIT NONE
         REAL( 8 ), PARAMETER    :: MAX_RATE = 2.6750D-06  ! Maximum loss rate (1/sec)
         REAL( 8 ), INTENT( IN ) :: PRESS
         REAL( 8 ), INTENT( IN ) :: A1
         REAL( 8 ), INTENT( IN ) :: B1
         REAL( 8 ), INTENT( IN ) :: A2
         REAL( 8 ), INTENT( IN ) :: B2
         INTRINSIC DEXP
         HALOGEN_FALLOFF = A1 * DEXP( B1 * PRESS ) + A2 * DEXP( B2 * PRESS )
         HALOGEN_FALLOFF = DMIN1 (MAX_RATE, HALOGEN_FALLOFF )
         RETURN
       END FUNCTION HALOGEN_FALLOFF

       SUBROUTINE SPECIAL_RATES( NUMCELLS, Y, TEMP, DENS, RKI )
! Purpose: calculate special rate operators and update
!         appropriate rate constants

       USE RXNS_DATA
       IMPLICIT NONE

! Arguments:
       INTEGER,      INTENT( IN  )   :: NUMCELLS        ! Number of cells in block 
       REAL( 8 ),    INTENT( IN )    :: Y( :, : )       ! species concs
       REAL( 8 ),    INTENT( IN )    :: TEMP( : )       ! air temperature, K 
       REAL( 8 ),    INTENT( IN )    :: DENS( : )       ! air density, Kg/m3
       REAL( 8 ),    INTENT( INOUT ) :: RKI( :, : )     ! reaction rate constant, ppm/min 
! Local:
       REAL( 8 ), PARAMETER :: DENSITY_TO_NUMBER = 2.07930D+19 ! Kg/m3 to molecules/cm3

       INTEGER   :: NCELL
       REAL( 8 ) :: INV_TEMP
       REAL( 8 ) :: CAIR
       REAL( 8 ) :: CFACT         ! scales operator if not multiplied by RKI, cm^3/(molecule) to 1/(ppm)
       REAL( 8 ) :: CFACT_SQU     ! scales operator if not multiplied by RKI, cm^6/(molec^2) to 1/(ppm^2)
! special rate operators listed below



       DO NCELL = 1, NUMCELLS
          INV_TEMP  = 1.0D0 / TEMP( NCELL )
          CAIR      = DENSITY_TO_NUMBER * DENS( NCELL )
          CFACT     = 1.0D-06 * CAIR
          CFACT_SQU = 1.0D-12 * CAIR * CAIR


! define special rate operators


! define rate constants in terms of special rate operators 

       END DO

       RETURN
       END SUBROUTINE SPECIAL_RATES
 
       SUBROUTINE CALC_RCONST( BLKTEMP, BLKPRES, BLKH2O, RJBLK, BLKHET, LSUNLIGHT, LAND, RKI, NUMCELLS )

!**********************************************************************

!  Function: To compute thermal and photolytic reaction rate
!            coefficients for each reaction.

!  Preconditions: Photolysis rates for individual species must have
!                 been calculated and stored in RJPHOT. Expects
!                 temperature in deg K, pressure in atm., water
!                 vapor in ppmV, and J-values in /min.
!  Key Subroutines/Functions Called: POWER_02, ARRHRENUIS_T0*, FALLOFF_T*, HALOGEN_FALLOFF 
!***********************************************************************




       USE RXNS_DATA

        IMPLICIT NONE  

!  Arguements: None 

        REAL( 8 ),           INTENT( IN  ) :: BLKTEMP( : )      ! temperature, deg K 
        REAL( 8 ),           INTENT( IN  ) :: BLKPRES( : )      ! pressure, Atm
        REAL( 8 ),           INTENT( IN  ) :: BLKH2O ( : )      ! water mixing ratio, ppm 
        REAL( 8 ),           INTENT( IN  ) :: RJBLK  ( :, : )   ! photolysis rates, 1/min 
        REAL( 8 ),           INTENT( IN  ) :: BLKHET ( :, : )   ! heterogeneous rate constants, ???/min
        INTEGER,             INTENT( IN  ) :: NUMCELLS          ! Number of cells in block 
        LOGICAL,             INTENT( IN  ) :: LSUNLIGHT         ! Is there sunlight? 
        LOGICAL,             INTENT( IN  ) :: LAND( : )         ! Is the surface totally land? 
        REAL( 8 ),           INTENT( OUT ) :: RKI ( :, : )      ! reaction rate constant, ppm/min 
!..Parameters: 

        REAL( 8 ), PARAMETER :: COEF1  = 7.33981D+15     ! Molec/cc to ppm conv factor 
        REAL( 8 ), PARAMETER :: CONSTC = 0.6D+0          ! Constant for reaction type 7
        REAL( 8 ), PARAMETER :: TI300  = 1.0D+0/300.0D+0 ! reciprocal of 300 deg K
        REAL( 8 ), PARAMETER :: SFACT  = 60.D+0          ! seconds per minute 
!..External Functions: None

!..Local Variables:

        INTEGER   :: NRT           ! Loop index for reaction types 
        INTEGER   :: IRXN          ! Reaction number
        INTEGER   :: JNUM          ! J-value species # from PHOT)
        INTEGER   :: KNUM          ! Reaction # for a relative rate coeff.
        INTEGER   :: N             ! Loop index for reactions
        INTEGER   :: NCELL         ! Loop index for # of cells in the block
        REAL( 8 ) :: CAIR          ! air number density (wet) [molec/cm^3]
        REAL( 8 ) :: CFACT         ! Convertor cm^3/(molec*sec) to 1/(ppm*min)
        REAL( 8 ) :: CFACT_SQU     ! Convertor cm^6/(molec^2*sec) to 1/(ppm^2*min)
        REAL( 8 ) :: INV_CFACT     ! ppm/min to molec/(cm^3*sec)
        REAL( 8 ) :: TEMPOT300     ! temperature divided by 300 K, dimensionaless 
        REAL( 8 ) :: INV_TEMP      ! reciprocal of air temperature, K-1
        REAL( 8 ) :: INV_CAIR      ! reciprocal of air number density (wet), [cm^3/molec]
        REAL( 8 ) :: TEMP          ! air temperature, K
        REAL( 8 ) :: PRESS         ! pressure [Atm] 
        REAL( 8 ) :: INV_RFACT     ! ppm/min to molec/(cm^3*min)
        REAL( 8 ) :: RFACT_SQU     ! cm^6/(molec^2*min) to 1/(ppm^2*min)
        REAL( 8 ) :: RFACT         ! cm^3/(molec*min) to 1/(ppm*min)
        REAL( 8 ) :: H2O           ! concentration, [molec/cm^3] 

        RKI = 0.0D0 

! All rate constants converted from  molec/cm3 to ppm
! and 1/sec to 1/min

        IF( LSUNLIGHT )THEN 
            DO NCELL = 1, NUMCELLS 

!  Reaction Label R1              
                RKI( NCELL,    1) =  RJBLK( NCELL, IJ_NO2_IUPAC10 )
!  Reaction Label R8              
                RKI( NCELL,    8) =  RJBLK( NCELL, IJ_O3_O3P_IUPAC10 )
!  Reaction Label R9              
                RKI( NCELL,    9) =  RJBLK( NCELL, IJ_O3_O1D_IUPAC10 )
!  Reaction Label R21             
                RKI( NCELL,   21) =  RJBLK( NCELL, IJ_H2O2_IUPAC10 )
!  Reaction Label R27             
                RKI( NCELL,   27) =  RJBLK( NCELL, IJ_NO3NO2_06 )
!  Reaction Label R28             
                RKI( NCELL,   28) =  RJBLK( NCELL, IJ_NO3NO_06 )
!  Reaction Label R38             
                RKI( NCELL,   38) =  RJBLK( NCELL, IJ_N2O5_IUPAC10 )
!  Reaction Label R43             
                RKI( NCELL,   43) =  RJBLK( NCELL, IJ_HONO_IUPAC10 )
!  Reaction Label R47             
                RKI( NCELL,   47) =  RJBLK( NCELL, IJ_HNO3_IUPAC10 )
!  Reaction Label R50             
                RKI( NCELL,   50) =  RJBLK( NCELL, IJ_PNA_IUPAC10 )
!  Reaction Label R56             
                RKI( NCELL,   56) =  RJBLK( NCELL, IJ_PAN_IUPAC10 )
!  Reaction Label R64             
                RKI( NCELL,   64) =  RJBLK( NCELL, IJ_PAN_IUPAC10 )
!  Reaction Label R88             
                RKI( NCELL,   88) =  RJBLK( NCELL, IJ_MEPX_IUPAC10 )
!  Reaction Label R90             
                RKI( NCELL,   90) =  RJBLK( NCELL, IJ_MEPX_IUPAC10 )
!  Reaction Label R92             
                RKI( NCELL,   92) =  RJBLK( NCELL, IJ_NTR_IUPAC10 )
!  Reaction Label R97             
                RKI( NCELL,   97) =  RJBLK( NCELL, IJ_FORM_R_IUPAC10 )
!  Reaction Label R98             
                RKI( NCELL,   98) =  RJBLK( NCELL, IJ_FORM_M_IUPAC10 )
!  Reaction Label R108            
                RKI( NCELL,  108) =  RJBLK( NCELL, IJ_ALD2_R_IUPAC10 )
!  Reaction Label R112            
                RKI( NCELL,  112) =  RJBLK( NCELL, IJ_ALDX_R_IUPAC10 )
!  Reaction Label R114            
                RKI( NCELL,  114) =  RJBLK( NCELL, IJ_GLYD_IUPAC10 )
!  Reaction Label R117            
                RKI( NCELL,  117) =  RJBLK( NCELL, IJ_GLY_R_IUPAC10 )
!  Reaction Label R119            
                RKI( NCELL,  119) =  RJBLK( NCELL, IJ_MGLY_IUPAC10 )
!  Reaction Label R128            
                RKI( NCELL,  128) =  RJBLK( NCELL, IJ_KET_IUPAC10 )
!  Reaction Label R129            
                RKI( NCELL,  129) =  RJBLK( NCELL, IJ_ACET_IUPAC10 )
!  Reaction Label R161            
                RKI( NCELL,  161) =  RJBLK( NCELL, IJ_ISPD )
!  Reaction Label R163            
                RKI( NCELL,  163) =  RJBLK( NCELL, IJ_HPALD )
!  Reaction Label R196            
                RKI( NCELL,  201) =  RJBLK( NCELL, IJ_NTR_IUPAC10 )
!  Reaction Label R197            
                RKI( NCELL,  202) =   5.0000D-02 * RJBLK( NCELL, IJ_NO2_IUPAC10 )
!  Reaction Label R201            
                RKI( NCELL,  206) =   2.8000D-02 * RJBLK( NCELL, IJ_NO2_IUPAC10 )
!  Reaction Label CL1             
                RKI( NCELL,  225) =  RJBLK( NCELL, IJ_CL2_IUPAC04 )
!  Reaction Label CL2             
                RKI( NCELL,  226) =  RJBLK( NCELL, IJ_HOCL_IUPAC04 )
!  Reaction Label CL9             
                RKI( NCELL,  233) =  RJBLK( NCELL, IJ_FMCL_IUPAC04 )
!  Reaction Label CL27            
                RKI( NCELL,  251) =  RJBLK( NCELL, IJ_CLNO2_IUPAC13 )
!  Reaction Label CL30            
                RKI( NCELL,  253) =  RJBLK( NCELL, IJ_CLONO2_1 )
!  Reaction Label CL31            
                RKI( NCELL,  254) =  RJBLK( NCELL, IJ_CLONO2_2 )
!  Reaction Label BP71mtp         
                RKI( NCELL,  289) =  RJBLK( NCELL, IJ_IC3ONO2 )
!  Reaction Label T04             
                RKI( NCELL,  315) =  RJBLK( NCELL, IJ_FORM_R_IUPAC10 )
!  Reaction Label T05             
                RKI( NCELL,  316) =  RJBLK( NCELL, IJ_FORM_M_IUPAC10 )
!  Reaction Label T09             
                RKI( NCELL,  321) =  RJBLK( NCELL, IJ_ALD2_R_IUPAC10 )
!  Reaction Label T16             
                RKI( NCELL,  330) =  RJBLK( NCELL, IJ_ACRO_09 )
!  Reaction Label T20             
                RKI( NCELL,  335) =  RJBLK( NCELL, IJ_ACRO_09 )

                IF( .NOT. LAND( NCELL ) )THEN
!  Reaction Label HAL_Ozone       
                   RKI( NCELL,  277) =  SFACT * HALOGEN_FALLOFF( BLKPRES( NCELL ),   2.8964D-11,   1.1998D+01,  & 
     &                                                           0.0000D+00,         0.0000D+00 )
                END IF

            END DO 
       END IF 

        DO NCELL = 1, NUMCELLS 
!  Set-up conversion factors 
             INV_TEMP  = 1.0D+00 / BLKTEMP( NCELL ) 
             CAIR      = 1.0D+06 * COEF1 * BLKPRES( NCELL ) * INV_TEMP 
             CFACT     = 6.0D-05 * CAIR
             CFACT_SQU = 6.0D-11 * CAIR * CAIR 
             INV_CAIR  = 1.0D0 / CAIR 
             INV_CFACT = 6.0D+07 * INV_CAIR 
             TEMP      = BLKTEMP( NCELL ) 
             TEMPOT300 = BLKTEMP( NCELL ) * TI300 
             RFACT     = 1.0D+06 * INV_CAIR 
             RFACT_SQU = 1.0D+12 * INV_CAIR * INV_CAIR 

!  Reaction Label R2              
             RKI( NCELL,    2) =  CFACT_SQU * POWER_T02( TEMPOT300,   5.6800D-34,  -2.6000D+00 )
!  Reaction Label R3              
             RKI( NCELL,    3) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.3100D+03 )
!  Reaction Label R4              
             RKI( NCELL,    4) =  CFACT_SQU * POWER_T02( TEMPOT300,   1.0000D-31,  -1.6000D+00 )
!  Reaction Label R5              
             RKI( NCELL,    5) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.5000D-12,   1.8800D+02 )
!  Reaction Label R6              
             RKI( NCELL,    6) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.3000D-31,   0.0000D+00,  -1.5000D+00,  & 
     &                                                 2.3000D-11,   0.0000D+00,   2.4000D-01,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label R7              
             RKI( NCELL,    7) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.0000D-12,  -2.0600D+03 )
!  Reaction Label R10             
             RKI( NCELL,   10) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.2300D-11,   1.1500D+02 )
!  Reaction Label R11             
             RKI( NCELL,   11) =   2.1400D-10 * CFACT 
!  Reaction Label R12             
             RKI( NCELL,   12) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.7000D-12,  -9.4000D+02 )
!  Reaction Label R13             
             RKI( NCELL,   13) =  CFACT * ARRHENUIS_T04( INV_TEMP,  TEMPOT300, & 
     &                                                   2.0300D-16,   6.9300D+02,   4.5700D+00 )
!  Reaction Label R14             
             RKI( NCELL,   14) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.4000D-11,   1.1000D+02 )
!  Reaction Label R15             
             RKI( NCELL,   15) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-11,   2.2400D+02 )
!  Reaction Label R16             
             RKI( NCELL,   16) =  CFACT * ARRHENUIS_T04( INV_TEMP,  TEMPOT300, & 
     &                                                   6.2000D-14,   9.4500D+02,   2.6000D+00 )
!  Reaction Label R17             
             RKI( NCELL,   17) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 6.9000D-31,   0.0000D+00,  -8.0000D-01,  & 
     &                                                 2.6000D-11,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.1300D+00,   5.0000D-01 )
!  Reaction Label R18             
             RKI( NCELL,   18) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.8000D-11,   2.5000D+02 )
!  Reaction Label R19             
             RKI( NCELL,   19) =  CFACT * FALLOFF_T09( INV_TEMP,  CAIR, & 
     &                                                 2.2000D-13,   6.0000D+02,   1.9000D-33,  & 
     &                                                 9.8000D+02 )
!  Reaction Label R20             
             RKI( NCELL,   20) =  CFACT_SQU * FALLOFF_T09( INV_TEMP,  CAIR, & 
     &                                                 3.0800D-34,   2.8000D+03,   2.6600D-54,  & 
     &                                                 3.1800D+03 )
!  Reaction Label R22             
             RKI( NCELL,   22) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.9000D-12,  -1.6000D+02 )
!  Reaction Label R23             
             RKI( NCELL,   23) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -2.0000D+03 )
!  Reaction Label R24             
             RKI( NCELL,   24) =  CFACT_SQU * ARRHENUIS_T03( INV_TEMP,  3.3000D-39,   5.3000D+02 )
!  Reaction Label R25             
             RKI( NCELL,   25) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4500D-12,   2.7000D+02 )
!  Reaction Label R26             
             RKI( NCELL,   26) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-13,  -2.4700D+03 )
!  Reaction Label R29             
             RKI( NCELL,   29) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-11,   1.1000D+02 )
!  Reaction Label R30             
             RKI( NCELL,   30) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.5000D-14,  -1.2600D+03 )
!  Reaction Label R31             
             RKI( NCELL,   31) =   1.7000D-11 * CFACT 
!  Reaction Label R32             
             RKI( NCELL,   32) =   2.0000D-11 * CFACT 
!  Reaction Label R33             
             RKI( NCELL,   33) =   4.0000D-12 * CFACT 
!  Reaction Label R34             
             RKI( NCELL,   34) =   1.0000D-17 * CFACT 
!  Reaction Label R35             
             RKI( NCELL,   35) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.5000D-13,  -2.4500D+03 )
!  Reaction Label R36             
             RKI( NCELL,   36) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 3.6000D-30,   0.0000D+00,  -4.1000D+00,  & 
     &                                                 1.9000D-12,   0.0000D+00,   2.0000D-01,  & 
     &                                                 1.3300D+00,   3.5000D-01 )
!  Reaction Label R37             
             RKI( NCELL,   37) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.3000D-03,  -1.1000D+04,  -3.5000D+00,  & 
     &                                                 9.7000D+14,  -1.1080D+04,   1.0000D-01,  & 
     &                                                 1.3300D+00,   3.5000D-01 )
!  Reaction Label R39             
             RKI( NCELL,   39) =   1.0000D-22 * CFACT 
!  Reaction Label R40             
             RKI( NCELL,   40) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 7.4000D-31,   0.0000D+00,  -2.4000D+00,  & 
     &                                                 3.3000D-11,   0.0000D+00,  -3.0000D-01,  & 
     &                                                 8.7000D-01,   8.1000D-01 )
!  Reaction Label R41             
             RKI( NCELL,   41) =   5.0000D-40 * CFACT_SQU 
!  Reaction Label R42             
             RKI( NCELL,   42) =   1.0000D-20 * CFACT 
!  Reaction Label R44             
             RKI( NCELL,   44) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.5000D-12,   2.6000D+02 )
!  Reaction Label R45             
             RKI( NCELL,   45) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.8000D-30,   0.0000D+00,  -3.0000D+00,  & 
     &                                                 2.8000D-11,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label R46             
             RKI( NCELL,   46) =  CFACT * FALLOFF_T08( INV_TEMP,  CAIR, & 
     &                                                 2.4000D-14,   4.6000D+02,   2.7000D-17,  & 
     &                                                 2.1990D+03,   6.5000D-34,   1.3350D+03 )
!  Reaction Label R48             
             RKI( NCELL,   48) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.8000D-31,   0.0000D+00,  -3.2000D+00,  & 
     &                                                 4.7000D-12,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label R49             
             RKI( NCELL,   49) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 4.1000D-05,  -1.0650D+04,   0.0000D+00,  & 
     &                                                 4.8000D+15,  -1.1170D+04,   0.0000D+00,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label R51             
             RKI( NCELL,   51) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.2000D-13,   6.9000D+02 )
!  Reaction Label R52             
             RKI( NCELL,   52) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 4.5000D-31,   0.0000D+00,  -3.9000D+00,  & 
     &                                                 1.3000D-12,   0.0000D+00,  -7.0000D-01,  & 
     &                                                 1.1000D+00,   5.3000D-01 )
!  Reaction Label R53             
             RKI( NCELL,   53) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.5000D-12,   2.9000D+02 )
!  Reaction Label R54             
             RKI( NCELL,   54) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 2.7000D-28,   0.0000D+00,  -7.1000D+00,  & 
     &                                                 1.2000D-11,   0.0000D+00,  -9.0000D-01,  & 
     &                                                 1.4100D+00,   3.0000D-01 )
!  Reaction Label R55             
             RKI( NCELL,   55) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 4.9000D-03,  -1.2100D+04,   0.0000D+00,  & 
     &                                                 5.4000D+16,  -1.3830D+04,   0.0000D+00,  & 
     &                                                 1.4100D+00,   3.0000D-01 )
!  Reaction Label R57             
             RKI( NCELL,   57) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.2000D-13,   9.8000D+02 )
!  Reaction Label R58             
             RKI( NCELL,   58) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.9000D-13,   8.0000D+02 )
!  Reaction Label R59             
             RKI( NCELL,   59) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.9000D-12,   5.0000D+02 )
!  Reaction Label R60             
             RKI( NCELL,   60) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.9000D-12,   5.0000D+02 )
!  Reaction Label R61             
             RKI( NCELL,   61) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.7000D-12,   3.4000D+02 )
!  Reaction Label R62             
             RKI( NCELL,   62) =   RKI( NCELL,   54 ) 
!  Reaction Label R63             
             RKI( NCELL,   63) =   RKI( NCELL,   55 ) 
!  Reaction Label R65             
             RKI( NCELL,   65) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.2000D-13,   9.8000D+02 )
!  Reaction Label R66             
             RKI( NCELL,   66) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.9000D-13,   8.0000D+02 )
!  Reaction Label R67             
             RKI( NCELL,   67) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.2000D-12,   5.0000D+02 )
!  Reaction Label R68             
             RKI( NCELL,   68) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.4000D-12,   3.6000D+02 )
!  Reaction Label R69             
             RKI( NCELL,   69) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.8000D-13,   8.0000D+02 )
!  Reaction Label R70             
             RKI( NCELL,   70) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.5000D-14,   5.0000D+02 )
!  Reaction Label R71             
             RKI( NCELL,   71) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3000D-12,   3.6000D+02 )
!  Reaction Label R72             
             RKI( NCELL,   72) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.8000D-13,   7.8000D+02 )
!  Reaction Label R73             
             RKI( NCELL,   73) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.0000D-12,   5.0000D+02 )
!  Reaction Label R74             
             RKI( NCELL,   74) =   RKI( NCELL,   70 ) 
!  Reaction Label R75             
             RKI( NCELL,   75) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R76             
             RKI( NCELL,   76) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.8000D-13,   8.0000D+02 )
!  Reaction Label R77             
             RKI( NCELL,   77) =   RKI( NCELL,   58 ) 
!  Reaction Label R78             
             RKI( NCELL,   78) =   RKI( NCELL,   70 ) 
!  Reaction Label R79             
             RKI( NCELL,   79) =   RKI( NCELL,   75 ) 
!  Reaction Label R80             
             RKI( NCELL,   80) =   RKI( NCELL,   76 ) 
!  Reaction Label R81             
             RKI( NCELL,   81) =   RKI( NCELL,   58 ) 
!  Reaction Label R82             
             RKI( NCELL,   82) =   RKI( NCELL,   70 ) 
!  Reaction Label R83             
             RKI( NCELL,   83) =   RKI( NCELL,   75 ) 
!  Reaction Label R84             
             RKI( NCELL,   84) =   RKI( NCELL,   76 ) 
!  Reaction Label R85             
             RKI( NCELL,   85) =   RKI( NCELL,   58 ) 
!  Reaction Label R86             
             RKI( NCELL,   86) =   RKI( NCELL,   70 ) 
!  Reaction Label R87             
             RKI( NCELL,   87) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.3000D-12,   1.9000D+02 )
!  Reaction Label R89             
             RKI( NCELL,   89) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.3000D-12,   1.9000D+02 )
!  Reaction Label R91             
             RKI( NCELL,   91) =   2.0000D-12 * CFACT 
!  Reaction Label R93             
             RKI( NCELL,   93) =   4.5000D-13 * CFACT 
!  Reaction Label R94             
             RKI( NCELL,   94) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.0000D-14,   8.5000D+02 )
!  Reaction Label R95             
             RKI( NCELL,   95) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.3000D-12,   1.9000D+02 )
!  Reaction Label R96             
             RKI( NCELL,   96) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.4000D-12,   1.3500D+02 )
!  Reaction Label R99             
             RKI( NCELL,   99) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4000D-11,  -1.6000D+03 )
!  Reaction Label R100            
             RKI( NCELL,  100) =   5.5000D-16 * CFACT 
!  Reaction Label R101            
             RKI( NCELL,  101) =  CFACT * ARRHENUIS_T03( INV_TEMP,  9.7000D-15,   6.2500D+02 )
!  Reaction Label R102            
             RKI( NCELL,  102) =  SFACT * ARRHENUIS_T03( INV_TEMP,  2.4000D+12,  -7.0000D+03 )
!  Reaction Label R103            
             RKI( NCELL,  103) =   5.6000D-12 * CFACT 
!  Reaction Label R104            
             RKI( NCELL,  104) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.6000D-15,   2.3000D+03 )
!  Reaction Label R105            
             RKI( NCELL,  105) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-11,  -1.1000D+03 )
!  Reaction Label R106            
             RKI( NCELL,  106) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.7000D-12,   3.4500D+02 )
!  Reaction Label R107            
             RKI( NCELL,  107) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label R109            
             RKI( NCELL,  109) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.3000D-11,  -8.7000D+02 )
!  Reaction Label R110            
             RKI( NCELL,  110) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.9000D-12,   4.0500D+02 )
!  Reaction Label R111            
             RKI( NCELL,  111) =   6.3000D-15 * CFACT 
!  Reaction Label R113            
             RKI( NCELL,  113) =   8.0000D-12 * CFACT 
!  Reaction Label R115            
             RKI( NCELL,  115) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label R116            
             RKI( NCELL,  116) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.1000D-12,   3.4000D+02 )
!  Reaction Label R118            
             RKI( NCELL,  118) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label R120            
             RKI( NCELL,  120) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label R121            
             RKI( NCELL,  121) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-12,   5.7500D+02 )
!  Reaction Label R122            
             RKI( NCELL,  122) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.7000D-12,  -2.1000D+03 )
!  Reaction Label R123            
             RKI( NCELL,  123) =  CFACT * FALLOFF_T09( INV_TEMP,  CAIR, & 
     &                                                 1.4400D-13,   0.0000D+00,   3.4300D-33,  & 
     &                                                 0.0000D+00 )
!  Reaction Label R124            
             RKI( NCELL,  124) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8500D-12,  -1.6900D+03 )
!  Reaction Label R125            
             RKI( NCELL,  125) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.9000D-12,  -1.0000D+03 )
!  Reaction Label R126            
             RKI( NCELL,  126) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.8500D-12,  -3.4500D+02 )
!  Reaction Label R127            
             RKI( NCELL,  127) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.0000D-12,   2.0000D+01 )
!  Reaction Label R130            
             RKI( NCELL,  130) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4100D-12,  -6.2060D+02 )
!  Reaction Label R131            
             RKI( NCELL,  131) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.6000D-12,  -5.8500D+02 )
!  Reaction Label R132            
             RKI( NCELL,  132) =   8.1000D-13 * CFACT 
!  Reaction Label R133            
             RKI( NCELL,  133) =  SFACT * ARRHENUIS_T03( INV_TEMP,  5.7000D+12,  -5.7800D+03 )
!  Reaction Label R134            
             RKI( NCELL,  134) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.5000D-14,  -2.0000D+02 )
!  Reaction Label R135            
             RKI( NCELL,  135) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.6000D-12,   4.0000D+02 )
!  Reaction Label R136            
             RKI( NCELL,  136) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 5.0000D-30,   0.0000D+00,  -1.5000D+00,  & 
     &                                                 1.0000D-12,   0.0000D+00,   0.0000D+00,  & 
     &                                                 1.3000D+00,   3.7000D-01 )
!  Reaction Label R137            
             RKI( NCELL,  137) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0400D-11,  -7.9200D+02 )
!  Reaction Label R138            
             RKI( NCELL,  138) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 8.6000D-29,   0.0000D+00,  -3.1000D+00,  & 
     &                                                 9.0000D-12,   0.0000D+00,  -8.5000D-01,  & 
     &                                                 1.1500D+00,   4.8000D-01 )
!  Reaction Label R139            
             RKI( NCELL,  139) =  CFACT * ARRHENUIS_T03( INV_TEMP,  9.1000D-15,  -2.5800D+03 )
!  Reaction Label R140            
             RKI( NCELL,  140) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.3000D-12,  -2.8800D+03 )
!  Reaction Label R141            
             RKI( NCELL,  141) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0000D-11,  -2.8000D+02 )
!  Reaction Label R142            
             RKI( NCELL,  142) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 8.0000D-27,   0.0000D+00,  -3.5000D+00,  & 
     &                                                 3.0000D-11,   0.0000D+00,  -1.0000D+00,  & 
     &                                                 1.1300D+00,   5.0000D-01 )
!  Reaction Label R143            
             RKI( NCELL,  143) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.5000D-15,  -1.8800D+03 )
!  Reaction Label R144            
             RKI( NCELL,  144) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.6000D-13,  -1.1550D+03 )
!  Reaction Label R145            
             RKI( NCELL,  145) =   2.3000D-11 * CFACT 
!  Reaction Label R146            
             RKI( NCELL,  146) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0500D-11,   5.1900D+02 )
!  Reaction Label R147            
             RKI( NCELL,  147) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.7000D-15,  -1.0130D+03 )
!  Reaction Label R148            
             RKI( NCELL,  148) =   3.7000D-13 * CFACT 
!  Reaction Label R149            
             RKI( NCELL,  149) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-11,   3.9000D+02 )
!  Reaction Label R150            
             RKI( NCELL,  150) =   3.0000D-11 * CFACT 
!  Reaction Label R151            
             RKI( NCELL,  151) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3900D-12,   3.6500D+02 )
!  Reaction Label R152            
             RKI( NCELL,  152) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.4300D-13,   7.0000D+02 )
!  Reaction Label R153            
             RKI( NCELL,  153) =   RKI( NCELL,   58 ) 
!  Reaction Label R154            
             RKI( NCELL,  154) =   RKI( NCELL,   70 ) 
!  Reaction Label R155            
             RKI( NCELL,  155) =  SFACT * ARRHENUIS_T03( INV_TEMP,  3.3000D+09,  -8.3000D+03 )
!  Reaction Label R156            
             RKI( NCELL,  156) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0300D-14,  -1.9950D+03 )
!  Reaction Label R157            
             RKI( NCELL,  157) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.0300D-12,  -4.4800D+02 )
!  Reaction Label R158            
             RKI( NCELL,  158) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.5800D-12,   5.1100D+02 )
!  Reaction Label R159            
             RKI( NCELL,  159) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.8800D-15,  -1.7700D+03 )
!  Reaction Label R160            
             RKI( NCELL,  160) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.1000D-12,  -1.8600D+03 )
!  Reaction Label R162            
             RKI( NCELL,  162) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.2300D-11,   3.7200D+02 )
!  Reaction Label R164            
             RKI( NCELL,  164) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.0000D-12,  -1.8600D+03 )
!  Reaction Label R165            
             RKI( NCELL,  165) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.7800D-11,  -4.0000D+02 )
!  Reaction Label R166            
             RKI( NCELL,  166) =  CFACT * ARRHENUIS_T03( INV_TEMP,  7.4300D-13,   7.0000D+02 )
!  Reaction Label R167            
             RKI( NCELL,  167) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3900D-12,   3.6500D+02 )
!  Reaction Label R168            
             RKI( NCELL,  168) =   RKI( NCELL,   58 ) 
!  Reaction Label R169            
             RKI( NCELL,  169) =   RKI( NCELL,   70 ) 
!  Reaction Label R170            
             RKI( NCELL,  170) =   3.1000D-11 * CFACT 
!  Reaction Label R171            
             RKI( NCELL,  171) =   3.6000D-11 * CFACT 
!  Reaction Label R172            
             RKI( NCELL,  172) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.5000D-11,   4.4900D+02 )
!  Reaction Label R173            
             RKI( NCELL,  173) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.2000D-15,  -8.2100D+02 )
!  Reaction Label R174            
             RKI( NCELL,  174) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.7000D-12,   1.7500D+02 )
!  Reaction Label R171a           
             RKI( NCELL,  175) =   3.6000D-11 * CFACT 
!  Reaction Label R172a           
             RKI( NCELL,  176) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.5000D-11,   4.4900D+02 )
!  Reaction Label R173a           
             RKI( NCELL,  177) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.2000D-15,  -8.2100D+02 )
!  Reaction Label R174a           
             RKI( NCELL,  178) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.7000D-12,   1.7500D+02 )
!  Reaction Label R175            
             RKI( NCELL,  179) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3000D-12,  -1.9000D+02 )
!  Reaction Label R176            
             RKI( NCELL,  180) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R177            
             RKI( NCELL,  181) =   RKI( NCELL,   58 ) 
!  Reaction Label R178            
             RKI( NCELL,  182) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label R179            
             RKI( NCELL,  183) =   RKI( NCELL,   70 ) 
!  Reaction Label R180            
             RKI( NCELL,  184) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-12,   3.4000D+02 )
!  Reaction Label R181            
             RKI( NCELL,  185) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R182            
             RKI( NCELL,  186) =   RKI( NCELL,   58 ) 
!  Reaction Label R183            
             RKI( NCELL,  187) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label R184            
             RKI( NCELL,  188) =   RKI( NCELL,   70 ) 
!  Reaction Label R185            
             RKI( NCELL,  189) =   1.8500D-11 * CFACT 
!  Reaction Label R185a           
             RKI( NCELL,  190) =   1.8500D-11 * CFACT 
!  Reaction Label R186            
             RKI( NCELL,  191) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label R187            
             RKI( NCELL,  192) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label R188            
             RKI( NCELL,  193) =   RKI( NCELL,   58 ) 
!  Reaction Label R189            
             RKI( NCELL,  194) =   RKI( NCELL,   70 ) 
!  Reaction Label R190            
             RKI( NCELL,  195) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.7000D-12,   9.5000D+02 )
!  Reaction Label R191            
             RKI( NCELL,  196) =   1.4000D-11 * CFACT 
!  Reaction Label R192            
             RKI( NCELL,  197) =   2.1000D-12 * CFACT 
!  Reaction Label R193            
             RKI( NCELL,  198) =   5.5000D-12 * CFACT 
!  Reaction Label R194            
             RKI( NCELL,  199) =   1.5300D-12 * CFACT 
!  Reaction Label R195            
             RKI( NCELL,  200) =   3.8000D-12 * CFACT 
!  Reaction Label R198            
             RKI( NCELL,  203) =   9.0000D-11 * CFACT 
!  Reaction Label R199            
             RKI( NCELL,  204) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.0800D-16,  -5.0000D+02 )
!  Reaction Label R200            
             RKI( NCELL,  205) =   3.0000D-12 * CFACT 
!  Reaction Label R202            
             RKI( NCELL,  207) =   4.4000D-11 * CFACT 
!  Reaction Label R203            
             RKI( NCELL,  208) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.4000D-17,  -5.0000D+02 )
!  Reaction Label R204            
             RKI( NCELL,  209) =   3.8000D-12 * CFACT 
!  Reaction Label R205            
             RKI( NCELL,  210) =   5.0000D-11 * CFACT 
!  Reaction Label R206            
             RKI( NCELL,  211) =   1.7000D-10 * CFACT 
!  Reaction Label R207            
             RKI( NCELL,  212) =   1.0000D-11 * CFACT 
!  Reaction Label R208            
             RKI( NCELL,  213) =   RKI( NCELL,   54 ) 
!  Reaction Label R209            
             RKI( NCELL,  214) =   RKI( NCELL,   55 ) 
!  Reaction Label R210            
             RKI( NCELL,  215) =   RKI( NCELL,   57 ) 
!  Reaction Label R211            
             RKI( NCELL,  216) =   RKI( NCELL,   59 ) 
!  Reaction Label R212            
             RKI( NCELL,  217) =   RKI( NCELL,   58 ) 
!  Reaction Label R213            
             RKI( NCELL,  218) =   3.6000D-11 * CFACT 
!  Reaction Label R214            
             RKI( NCELL,  219) =   3.0000D-12 * CFACT 
!  Reaction Label R216            
             RKI( NCELL,  220) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8500D-12,  -1.6900D+03 )
!  Reaction Label R217            
             RKI( NCELL,  221) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 2.3700D-21,   0.0000D+00,   0.0000D+00,  & 
     &                                                 4.3000D-01,   0.0000D+00,  -8.0000D+00,  & 
     &                                                 1.0000D+00,   4.1000D-01 )
!  Reaction Label R218            
             RKI( NCELL,  222) =   1.0000D+00 * SFACT 
!  Reaction Label R219            
             RKI( NCELL,  223) =  SFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 4.8100D-20,   0.0000D+00,   0.0000D+00,  & 
     &                                                 4.3000D-01,   0.0000D+00,  -8.0000D+00,  & 
     &                                                 1.0000D+00,   4.1000D-01 )
!  Reaction Label R220            
             RKI( NCELL,  224) =   1.0000D+00 * SFACT 
!  Reaction Label CL3             
             RKI( NCELL,  227) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.3000D-11,  -2.0000D+02 )
!  Reaction Label CL4             
             RKI( NCELL,  228) =   1.6300D-14 * CFACT 
!  Reaction Label CL5             
             RKI( NCELL,  229) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.4000D-12,   2.9000D+02 )
!  Reaction Label CL6             
             RKI( NCELL,  230) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.2000D-12,   3.4000D+02 )
!  Reaction Label CL7             
             RKI( NCELL,  231) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.2000D-12,  -1.1000D+02 )
!  Reaction Label CL8             
             RKI( NCELL,  232) =   5.0000D-13 * CFACT 
!  Reaction Label CL10            
             RKI( NCELL,  234) =  CFACT * ARRHENUIS_T03( INV_TEMP,  6.6000D-12,  -1.2400D+03 )
!  Reaction Label CL11            
             RKI( NCELL,  235) =   5.0000D-11 * CFACT 
!  Reaction Label CL12            
             RKI( NCELL,  236) =   1.4000D-10 * CFACT 
!  Reaction Label CL13            
             RKI( NCELL,  237) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.3000D-11,  -1.0000D+02 )
!  Reaction Label CL14            
             RKI( NCELL,  238) =   1.0700D-10 * CFACT 
!  Reaction Label CL15            
             RKI( NCELL,  239) =   2.5000D-10 * CFACT 
!  Reaction Label CL16            
             RKI( NCELL,  240) =   3.5000D-10 * CFACT 
!  Reaction Label CL17            
             RKI( NCELL,  241) =   4.3000D-10 * CFACT 
!  Reaction Label CL18            
             RKI( NCELL,  242) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.2000D-11,  -3.4000D+01 )
!  Reaction Label CL19            
             RKI( NCELL,  243) =   7.9000D-11 * CFACT 
!  Reaction Label CL20            
             RKI( NCELL,  244) =   1.3000D-10 * CFACT 
!  Reaction Label CL21            
             RKI( NCELL,  245) =   5.5000D-11 * CFACT 
!  Reaction Label CL22            
             RKI( NCELL,  246) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.2000D-11,   4.5000D+01 )
!  Reaction Label CL23            
             RKI( NCELL,  247) =  CFACT * ARRHENUIS_T04( INV_TEMP,  TEMPOT300, & 
     &                                                   6.5800D-13,   5.8000D+01,   1.1600D+00 )
!  Reaction Label CL24            
             RKI( NCELL,  248) =   6.1000D-11 * CFACT 
!  Reaction Label CL25            
             RKI( NCELL,  249) =   1.2000D-10 * CFACT 
!  Reaction Label CL26            
             RKI( NCELL,  250) =   1.2000D-10 * CFACT 
!  Reaction Label CL28            
             RKI( NCELL,  252) =  CFACT * FALLOFF_T10( INV_TEMP,  TEMPOT300,  CAIR, & 
     &                                                 1.8000D-31,   0.0000D+00,  -3.4000D+00,  & 
     &                                                 1.5000D-11,   0.0000D+00,  -1.9000D+00,  & 
     &                                                 1.0000D+00,   6.0000D-01 )
!  Reaction Label HET_CLNO3_WAJ   
             RKI( NCELL,  255) =  BLKHET(  NCELL, IK_HETERO_CLNO3_WAJ )
!  Reaction Label SA01            
             RKI( NCELL,  256) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA02            
             RKI( NCELL,  257) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA03            
             RKI( NCELL,  258) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA04            
             RKI( NCELL,  259) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA06            
             RKI( NCELL,  260) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA07            
             RKI( NCELL,  261) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA08            
             RKI( NCELL,  262) =   1.1600D-14 * CFACT 
!  Reaction Label SA09            
             RKI( NCELL,  263) =   1.9700D-10 * CFACT 
!  Reaction Label SA10            
             RKI( NCELL,  264) =   1.9000D-11 * CFACT 
!  Reaction Label SA11            
             RKI( NCELL,  265) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.6000D+02 )
!  Reaction Label SA12            
             RKI( NCELL,  266) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.9000D-13,   1.3000D+03 )
!  Reaction Label SA13            
             RKI( NCELL,  267) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.7000D-12,   3.7400D+02 )
!  Reaction Label HET_NTR2        
             RKI( NCELL,  268) =   1.4000D+00 * BLKHET( NCELL, IK_HETERO_NTR2 )
!  Reaction Label HET_N2O5IJ      
             RKI( NCELL,  269) =  BLKHET(  NCELL, IK_HETERO_N2O5IJ )
!  Reaction Label HET_N2O5K       
             RKI( NCELL,  270) =  BLKHET(  NCELL, IK_HETERO_N2O5K )
!  Reaction Label HET_H2NO3PIJA   
             RKI( NCELL,  271) =  BLKHET(  NCELL, IK_HETERO_H2NO3PAIJ )
!  Reaction Label HET_H2NO3PKA    
             RKI( NCELL,  272) =  BLKHET(  NCELL, IK_HETERO_H2NO3PAK )
!  Reaction Label HET_H2NO3PIB    
             RKI( NCELL,  273) =  BLKHET(  NCELL, IK_HETERO_H2NO3PBIJ )
!  Reaction Label HET_H2NO3PJB    
             RKI( NCELL,  274) =  BLKHET(  NCELL, IK_HETERO_H2NO3PBIJ )
!  Reaction Label HET_H2NO3PKB    
             RKI( NCELL,  275) =  BLKHET(  NCELL, IK_HETERO_H2NO3PBK )
!  Reaction Label HET_N02         
             RKI( NCELL,  276) =  BLKHET(  NCELL, IK_HETERO_NO2 )
!  Reaction Label HET_IEPOX       
             RKI( NCELL,  278) =  BLKHET(  NCELL, IK_HETERO_IEPOX )
!  Reaction Label HET_IEPOXOS     
             RKI( NCELL,  279) =  BLKHET(  NCELL, IK_HETERO_IEPOXOS )
!  Reaction Label HET_TETROL      
             RKI( NCELL,  280) =  BLKHET(  NCELL, IK_HETERO_TETROL )
!  Reaction Label HET_GLY         
             RKI( NCELL,  281) =  BLKHET(  NCELL, IK_HETERO_GLY )
!  Reaction Label HET_MGLY        
             RKI( NCELL,  282) =  BLKHET(  NCELL, IK_HETERO_MGLY )
!  Reaction Label BL18a           
             RKI( NCELL,  283) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.6000D-12,   3.8000D+02 )
!  Reaction Label BL18b           
             RKI( NCELL,  284) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.6500D-13,   1.3000D+03 )
!  Reaction Label BL18c           
             RKI( NCELL,  285) =   2.3000D-12 * CFACT 
!  Reaction Label BL18d           
             RKI( NCELL,  286) =   3.5000D-14 * CFACT 
!  Reaction Label CP07mtp         
             RKI( NCELL,  287) =   1.9200D-10 * CFACT 
!  Reaction Label BP70mtp         
             RKI( NCELL,  288) =   7.2000D-12 * CFACT 
!  Reaction Label HYD_MT          
             RKI( NCELL,  290) =   9.2590D-05 * SFACT 
!  Reaction Label OLIG_AROMATIC1  
             RKI( NCELL,  291) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_AROMATIC2  
             RKI( NCELL,  292) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_AROMATIC3  
             RKI( NCELL,  293) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_ISOPRENE1  
             RKI( NCELL,  294) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_ISOPRENE2  
             RKI( NCELL,  295) =   9.4882D-06 * SFACT 
!  Reaction Label OLIG_SESQT1     
             RKI( NCELL,  296) =   9.4882D-06 * SFACT 
!  Reaction Label RPOAGEPI        
             RKI( NCELL,  297) =   2.5000D-12 * CFACT 
!  Reaction Label RPOAGELI        
             RKI( NCELL,  298) =  BLKHET(  NCELL, IK_HETERO_PNCOMLI )
!  Reaction Label RPOAGEPJ        
             RKI( NCELL,  299) =   2.5000D-12 * CFACT 
!  Reaction Label RPOAGELJ        
             RKI( NCELL,  300) =  BLKHET(  NCELL, IK_HETERO_PNCOMLJ )
!  Reaction Label PCSOA           
             RKI( NCELL,  301) =   1.2500D-11 * CFACT 
!  Reaction Label POA_AGE1        
             RKI( NCELL,  302) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE2        
             RKI( NCELL,  303) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE3        
             RKI( NCELL,  304) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE4        
             RKI( NCELL,  305) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE5        
             RKI( NCELL,  306) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE6        
             RKI( NCELL,  307) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE7        
             RKI( NCELL,  308) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE8        
             RKI( NCELL,  309) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE9        
             RKI( NCELL,  310) =   4.0000D-11 * CFACT 
!  Reaction Label POA_AGE10       
             RKI( NCELL,  311) =   4.0000D-11 * CFACT 
!  Reaction Label T01             
             RKI( NCELL,  312) =  CFACT * ARRHENUIS_T03( INV_TEMP,  5.4000D-12,   1.3500D+02 )
!  Reaction Label T02             
             RKI( NCELL,  313) =   5.5000D-16 * CFACT 
!  Reaction Label T03             
             RKI( NCELL,  314) =  CFACT * ARRHENUIS_T03( INV_TEMP,  3.4000D-11,  -1.6000D+03 )
!  Reaction Label TCL1            
             RKI( NCELL,  317) =  CFACT * ARRHENUIS_T03( INV_TEMP,  8.2000D-11,  -3.4000D+01 )
!  Reaction Label T06             
             RKI( NCELL,  318) =  CFACT * ARRHENUIS_T03( INV_TEMP,  4.7000D-12,   3.4500D+02 )
!  Reaction Label T07             
             RKI( NCELL,  319) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4000D-12,  -1.8600D+03 )
!  Reaction Label T08             
             RKI( NCELL,  320) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-11,  -1.1000D+03 )
!  Reaction Label TCL2            
             RKI( NCELL,  322) =   7.9000D-11 * CFACT 
!  Reaction Label T10             
             RKI( NCELL,  323) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.4800D-11,   4.4800D+02 )
!  Reaction Label T11             
             RKI( NCELL,  324) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.3400D-14,  -2.2830D+03 )
!  Reaction Label T12             
             RKI( NCELL,  325) =   1.7900D-13 * CFACT 
!  Reaction Label TCL3            
             RKI( NCELL,  326) =   2.5100D-10 * CFACT 
!  Reaction Label T13             
             RKI( NCELL,  327) =   2.0000D-11 * CFACT 
!  Reaction Label T14             
             RKI( NCELL,  328) =   2.6100D-19 * CFACT 
!  Reaction Label T15             
             RKI( NCELL,  329) =   1.1500D-15 * CFACT 
!  Reaction Label TCL4            
             RKI( NCELL,  331) =   2.3700D-10 * CFACT 
!  Reaction Label T17             
             RKI( NCELL,  332) =   2.0000D-11 * CFACT 
!  Reaction Label T18             
             RKI( NCELL,  333) =   2.6100D-19 * CFACT 
!  Reaction Label T19             
             RKI( NCELL,  334) =   1.1500D-15 * CFACT 
!  Reaction Label TCL5            
             RKI( NCELL,  336) =   2.3700D-10 * CFACT 
!  Reaction Label T21             
             RKI( NCELL,  337) =  CFACT * ARRHENUIS_T03( INV_TEMP,  1.8000D-12,   3.4000D+02 )
!  Reaction Label TCL6            
             RKI( NCELL,  338) =   6.1000D-11 * CFACT 
!  Reaction Label HG1             
             RKI( NCELL,  339) =  CFACT * ARRHENUIS_T03( INV_TEMP,  2.1100D-18,  -1.2565D+03 )
!  Reaction Label HG2             
             RKI( NCELL,  340) =   2.6000D-18 * CFACT 
!  Reaction Label HG3             
             RKI( NCELL,  341) =   8.5000D-19 * CFACT 
!  Reaction Label HG4             
             RKI( NCELL,  342) =   7.7000D-14 * CFACT 
!  Reaction Label HG5             
             RKI( NCELL,  343) =  CFACT_SQU * ARRHENUIS_T03( INV_TEMP,  2.2500D-33,   6.8000D+02 )

        END DO  
!  Multiply rate constants by [M], [O2], [N2], [H2O], [H2], or [CH4]
!  where needed and return
       IF ( NWM .GT. 0 ) THEN
          DO NRT = 1, NWM
             IRXN = NRXWM( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_AIR
             END DO
          END DO
       END IF
       IF ( NWO2 .GT. 0 ) THEN
          DO NRT = 1, NWO2
             IRXN = NRXWO2( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_O2
             END DO
          END DO
       END IF
       IF ( NWN2 .GT. 0 ) THEN
          DO NRT = 1, NWN2
             IRXN = NRXWN2( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_N2
             END DO
          END DO
       END IF
       IF ( NWW .GT. 0 ) THEN
          DO NRT = 1, NWW
             IRXN = NRXWW( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * BLKH2O( NCELL )
             END DO
          END DO
       END IF
       IF ( NWH2 .GT. 0 ) THEN
          DO NRT = 1, NWH2
             IRXN = NRXWH2( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_H2
             END DO
          END DO
       END IF
       IF ( NWCH4 .GT. 0 ) THEN
          DO NRT = 1, NWCH4
             IRXN = NRXWCH4( NRT )
             DO NCELL = 1, NUMCELLS
                RKI( NCELL,IRXN ) = RKI( NCELL,IRXN ) * ATM_CH4
             END DO
          END DO
       END IF
       RETURN
       END SUBROUTINE CALC_RCONST
         FUNCTION MAP_CHEMISTRY_SPECIES() RESULT ( SUCCESS )

! Purpose find or test the CGRID Index, Species Type, and Conversion Factor
! for the Mechanism against the CMAQ namelists

            USE UTILIO_DEFN
            USE CGRID_SPCS
            USE RXNS_DATA

            IMPLICIT NONE

!Parameters:
            CHARACTER(  1 ), PARAMETER :: BL = ' '
            INTEGER,         PARAMETER :: SPC_DIM = 200
!Local:

            LOGICAL SUCCESS
            INTEGER I, IOS, J
            INTEGER I1, I2, I3, I4      ! SURROGATE TYPE 1 COUNTERS
            INTEGER J1, J2              ! SURROGATE TYPE 2 COUNTERS
            INTEGER K1, K2, K3, K4, K5  ! CONTROL TYPE COUNTERS
            INTEGER ICALL

            LOGICAL :: ORDER = .TRUE.
            LOGICAL :: FOUND = .TRUE.

            CHARACTER( 120 ) :: XMSG

            CHARACTER( 16 ), ALLOCATABLE     :: CGRID_SPC  ( : )
            CHARACTER( 16 ), ALLOCATABLE     :: NML_SPC    ( : )
            CHARACTER(  2 ), ALLOCATABLE     :: NML_TYPE   ( : )
            INTEGER,         ALLOCATABLE     :: NML_INDEX  ( : )
            LOGICAL,         ALLOCATABLE     :: NML_CONVERT( : )
            REAL,            ALLOCATABLE     :: NML_MOLWT  ( : )
            REAL                             :: DELTA            ! fractional difference

            LOGICAL, SAVE :: INITIALIZED = .FALSE.

            IF( INITIALIZED )RETURN

            INITIALIZED = .TRUE.
            SUCCESS     = .TRUE.


            ALLOCATE ( CGRID_SPC( NSPCSD - 1 ),    &
     &                 NML_SPC  ( NSPCSD - 1 ),    &
     &                 NML_INDEX( NSPCSD - 1 ),    &
     &                 NML_TYPE( NSPCSD - 1 ),     &
     &                 NML_CONVERT( NSPCSD - 1 ),  &
     &                 NML_MOLWT( NSPCSD - 1 ),    &
     &                 STAT = IOS )


            J = 0


            NML_INDEX     = -1
            TYPE_INDEX    = -1
            NML_TYPE      = '??'
            NML_CONVERT   = .FALSE.

            DO I = 1, N_GC_SPC ! load gc names and indices
               J = J + 1
               CGRID_SPC( I )     = GC_SPC( I )
               NML_INDEX( J )     = I + GC_STRT -1
               NML_TYPE( J )      = 'GC'
               NML_MOLWT( J )     = GC_MOLWT( I )
            END DO

            DO I = 1, N_AE_SPC ! load ae names and indices
               J = J + 1
               CGRID_SPC( J )     = AE_SPC( I )
               NML_INDEX( J )     = I + AE_STRT - 1
               NML_TYPE( J )      = 'AE'
               NML_CONVERT( J )   = .TRUE.
               NML_MOLWT( J )     = AE_MOLWT( I )
            END DO

            DO I = 1, N_NR_SPC ! load nr names and indices
               J = J + 1
               CGRID_SPC( J )     = NR_SPC( I )
               NML_INDEX( J )     = I + NR_STRT - 1
               NML_TYPE( J )      = 'NR'
               NML_MOLWT( J )     = NR_MOLWT( I )
            END DO

            DO I = 1, N_TR_SPC ! load tr names and indices
               J = J + 1
               CGRID_SPC( J )     = TR_SPC( I )
               NML_INDEX( J )     = I + TR_STRT - 1
               NML_TYPE( J )      = 'TR'
               NML_MOLWT( J )     = TR_MOLWT( I )
            END DO

            NML_SPC( 1:(NSPCSD-1) ) = CGRID_SPC( 1:(NSPCSD-1) )


! determine if mechanism species are in cgrid species

            DO I = 1, NUMB_MECH_SPC
! set species informations arrays using SPECIES_LIST array before mapping
               CHEMISTRY_SPC( I ) = SPECIES_LIST( I )%CHEMISTRY_SPC
               CGRID_INDEX  ( I ) = SPECIES_LIST( I )%CGRID_INDEX
               SPECIES_TYPE ( I ) = SPECIES_LIST( I )%SPECIES_TYPE
               CONVERT_CONC ( I ) = SPECIES_LIST( I )%CONVERT_CONC
               SPECIES_MOLWT( I ) = SPECIES_LIST( I )%SPECIES_MOLWT

               I1 = INDEX1R( CHEMISTRY_SPC( I ), (NSPCSD-1), CGRID_SPC )
               IF ( I1 .LT. 1 ) THEN
                  FOUND = .FALSE.
               ELSE
                  FOUND = .TRUE.
                  IF( .NOT. MAPPED_TO_CGRID )THEN
                      CGRID_INDEX( I )   = NML_INDEX( I1 )
                      SPECIES_TYPE( I )  = NML_TYPE ( I1 )
                      SPECIES_MOLWT( I ) = NML_MOLWT( I1 )
                      CONVERT_CONC( I )  = NML_CONVERT( I1 )
                  ELSE
                      IF(CGRID_INDEX( I ) .NE. NML_INDEX( I1 ))THEN
                         SUCCESS = .FALSE.
                         XMSG = '*** For Species ' // TRIM( CHEMISTRY_SPC( I ) ) &
    &                        // ' cgrid index does not match mechanism value.'
                         WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                         WRITE( XMSG,'(A,I3,1X,I3)')'CGRID Indices: Mechanism and NML Values are ',    &
    &                    CGRID_INDEX( I ),NML_INDEX( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                      END IF
                      IF(CONVERT_CONC( I ) .NEQV. NML_CONVERT( I1 ))THEN
                         SUCCESS = .FALSE.
                         XMSG = '*** For Species ' // TRIM( CHEMISTRY_SPC( I ) ) &
    &                        // ' species unit conversion flag does not match mechanism value.'
                         WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                         WRITE( XMSG,'(A,1X,L21X,L2)')'CONVERSION FLAGS: Mechanism and NML Values are ', &
    &                    CONVERT_CONC( I ),NML_CONVERT( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                         WRITE( XMSG,'(A,1X,A3,1X,A3)')'SPECIES TYPE: Mechanism and NML Values are ',    &
    &                    SPECIES_TYPE( I ),NML_TYPE( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                      END IF
                      DELTA = ( SPECIES_MOLWT( I ) - NML_MOLWT( I1 ) )/MAX(NML_MOLWT( I1 ),1.0E-20)
                      IF( ABS( DELTA ) .GE. 0.05 )THEN
                         IF( CONVERT_CONC( I ) )SUCCESS = .FALSE.
                         XMSG = '*** For Species ' // TRIM( CHEMISTRY_SPC( I ) ) &
    &                        // ' species molecular weight does not match mechanism value.'
                         WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                         WRITE( XMSG,'(A,2(ES12.4,1X))')'Molecular Weight: Mechanism and NML Values are ', &
    &                    SPECIES_MOLWT( I ), NML_MOLWT( I1 )
                         WRITE( LOGDEV,'( 5X, A )' )XMSG
                      END IF
                 END IF
              END IF
              IF( INDEX( CHEMISTRY_SPC( I ), 'SRF') .GT. 0 )THEN
                  SUCCESS = .FALSE.
                  XMSG = '*** reactions cannot use modal aerosol surface area as species'
                  WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                  XMSG = TRIM( CHEMISTRY_SPC( I ) )
                  WRITE( LOGDEV,'( 2X, A )' ) TRIM( XMSG )
              END IF
              IF( INDEX( CHEMISTRY_SPC( I ), 'NUM') .GT. 0 )THEN
                  SUCCESS = .FALSE.
                  XMSG = '*** reactions cannot use modal aerosol number density as species'
                  WRITE( LOGDEV,'( /5X, A )' ) TRIM( XMSG )
                  XMSG = TRIM( CHEMISTRY_SPC( I ) )
                  WRITE( LOGDEV,'( 2X, A )' ) TRIM( XMSG )
              END IF
              IF ( .NOT. FOUND ) THEN
                 XMSG = 'Fatal error: Mechanism Species found not in species namelist:'
                 WRITE( LOGDEV,'( /5X, A )', ADVANCE = 'NO' ) TRIM( XMSG )
                 XMSG = TRIM( CHEMISTRY_SPC( I ) )
                 WRITE( LOGDEV,'( 2X, A )' ) TRIM( XMSG )
                 SUCCESS = .FALSE.
              END IF
            END DO

            IF( SUCCESS )RETURN

            WRITE(LOGDEV,99901)TRIM( MECHNAME )
            XMSG = 'The FATAL errors found in namelist used. Check ' &
      &          //  'the log of exiting processor if more details are needed.'
            CALL M3WARN('MAP_CHEMISTRY_SPECIES',0,0,XMSG)


99901       FORMAT( / 'FATAL error(s) found in the namelists used. Check that ' &
     &     /  'these namelists contain the above data as the respective files ' &
     &     /  'in the respository version of the mechanism: ' , A )

         RETURN

         END FUNCTION MAP_CHEMISTRY_SPECIES
!----------------------------------------------------------------------------------------
         INTEGER FUNCTION INDEX1R ( NAME, N, NLIST )
            IMPLICIT NONE
            CHARACTER( * ) NAME        ! character string being searched for
            INTEGER N                  ! length of array to be searched
            CHARACTER( * ) NLIST( : )  ! array to be searched

            INTEGER I

            DO I = 1, N
               IF ( NAME .EQ. NLIST( I ) ) THEN
                  INDEX1R = I
                  RETURN
               END IF
           END DO
           INDEX1R = 0
           RETURN

          END FUNCTION INDEX1R
          SUBROUTINE RESET_SPECIES_POINTERS( IOLD2NEW )

             USE RXNS_DATA
             IMPLICIT NONE
             INTEGER, INTENT( IN ) :: IOLD2NEW( :,: ) 


             INDEX_NO2          = IOLD2NEW( INDEX_NO2         , 1 )
             INDEX_NO           = IOLD2NEW( INDEX_NO          , 1 )
             INDEX_O            = IOLD2NEW( INDEX_O           , 1 )
             INDEX_O3           = IOLD2NEW( INDEX_O3          , 1 )
             INDEX_NO3          = IOLD2NEW( INDEX_NO3         , 1 )
             INDEX_O1D          = IOLD2NEW( INDEX_O1D         , 1 )
             INDEX_OH           = IOLD2NEW( INDEX_OH          , 1 )
             INDEX_HO2          = IOLD2NEW( INDEX_HO2         , 1 )
             INDEX_H2O2         = IOLD2NEW( INDEX_H2O2        , 1 )
             INDEX_N2O5         = IOLD2NEW( INDEX_N2O5        , 1 )
             INDEX_HNO3         = IOLD2NEW( INDEX_HNO3        , 1 )
             INDEX_HONO         = IOLD2NEW( INDEX_HONO        , 1 )
             INDEX_PNA          = IOLD2NEW( INDEX_PNA         , 1 )
             INDEX_SO2          = IOLD2NEW( INDEX_SO2         , 1 )
             INDEX_SULF         = IOLD2NEW( INDEX_SULF        , 1 )
             INDEX_SULRXN       = IOLD2NEW( INDEX_SULRXN      , 1 )
             INDEX_C2O3         = IOLD2NEW( INDEX_C2O3        , 1 )
             INDEX_MEO2         = IOLD2NEW( INDEX_MEO2        , 1 )
             INDEX_RO2          = IOLD2NEW( INDEX_RO2         , 1 )
             INDEX_PAN          = IOLD2NEW( INDEX_PAN         , 1 )
             INDEX_PACD         = IOLD2NEW( INDEX_PACD        , 1 )
             INDEX_AACD         = IOLD2NEW( INDEX_AACD        , 1 )
             INDEX_CXO3         = IOLD2NEW( INDEX_CXO3        , 1 )
             INDEX_ALD2         = IOLD2NEW( INDEX_ALD2        , 1 )
             INDEX_XO2H         = IOLD2NEW( INDEX_XO2H        , 1 )
             INDEX_PANX         = IOLD2NEW( INDEX_PANX        , 1 )
             INDEX_FORM         = IOLD2NEW( INDEX_FORM        , 1 )
             INDEX_MEPX         = IOLD2NEW( INDEX_MEPX        , 1 )
             INDEX_MEOH         = IOLD2NEW( INDEX_MEOH        , 1 )
             INDEX_ROOH         = IOLD2NEW( INDEX_ROOH        , 1 )
             INDEX_XO2          = IOLD2NEW( INDEX_XO2         , 1 )
             INDEX_XO2N         = IOLD2NEW( INDEX_XO2N        , 1 )
             INDEX_NTR1         = IOLD2NEW( INDEX_NTR1        , 1 )
             INDEX_NTR2         = IOLD2NEW( INDEX_NTR2        , 1 )
             INDEX_FACD         = IOLD2NEW( INDEX_FACD        , 1 )
             INDEX_CO           = IOLD2NEW( INDEX_CO          , 1 )
             INDEX_HCO3         = IOLD2NEW( INDEX_HCO3        , 1 )
             INDEX_ALDX         = IOLD2NEW( INDEX_ALDX        , 1 )
             INDEX_GLYD         = IOLD2NEW( INDEX_GLYD        , 1 )
             INDEX_GLY          = IOLD2NEW( INDEX_GLY         , 1 )
             INDEX_MGLY         = IOLD2NEW( INDEX_MGLY        , 1 )
             INDEX_ETHA         = IOLD2NEW( INDEX_ETHA        , 1 )
             INDEX_ETOH         = IOLD2NEW( INDEX_ETOH        , 1 )
             INDEX_KET          = IOLD2NEW( INDEX_KET         , 1 )
             INDEX_PAR          = IOLD2NEW( INDEX_PAR         , 1 )
             INDEX_ACET         = IOLD2NEW( INDEX_ACET        , 1 )
             INDEX_PRPA         = IOLD2NEW( INDEX_PRPA        , 1 )
             INDEX_XPRP         = IOLD2NEW( INDEX_XPRP        , 1 )
             INDEX_XPAR         = IOLD2NEW( INDEX_XPAR        , 1 )
             INDEX_ROR          = IOLD2NEW( INDEX_ROR         , 1 )
             INDEX_ETHY         = IOLD2NEW( INDEX_ETHY        , 1 )
             INDEX_ETH          = IOLD2NEW( INDEX_ETH         , 1 )
             INDEX_OLE          = IOLD2NEW( INDEX_OLE         , 1 )
             INDEX_IOLE         = IOLD2NEW( INDEX_IOLE        , 1 )
             INDEX_ISOP         = IOLD2NEW( INDEX_ISOP        , 1 )
             INDEX_ISO2         = IOLD2NEW( INDEX_ISO2        , 1 )
             INDEX_ISOPRXN      = IOLD2NEW( INDEX_ISOPRXN     , 1 )
             INDEX_ISPD         = IOLD2NEW( INDEX_ISPD        , 1 )
             INDEX_INTR         = IOLD2NEW( INDEX_INTR        , 1 )
             INDEX_ISPX         = IOLD2NEW( INDEX_ISPX        , 1 )
             INDEX_HPLD         = IOLD2NEW( INDEX_HPLD        , 1 )
             INDEX_OPO3         = IOLD2NEW( INDEX_OPO3        , 1 )
             INDEX_EPOX         = IOLD2NEW( INDEX_EPOX        , 1 )
             INDEX_EPX2         = IOLD2NEW( INDEX_EPX2        , 1 )
             INDEX_TERP         = IOLD2NEW( INDEX_TERP        , 1 )
             INDEX_TRPRXN       = IOLD2NEW( INDEX_TRPRXN      , 1 )
             INDEX_TERPNRO2     = IOLD2NEW( INDEX_TERPNRO2    , 1 )
             INDEX_APIN         = IOLD2NEW( INDEX_APIN        , 1 )
             INDEX_BENZENE      = IOLD2NEW( INDEX_BENZENE     , 1 )
             INDEX_CRES         = IOLD2NEW( INDEX_CRES        , 1 )
             INDEX_BZO2         = IOLD2NEW( INDEX_BZO2        , 1 )
             INDEX_OPEN         = IOLD2NEW( INDEX_OPEN        , 1 )
             INDEX_BENZRO2      = IOLD2NEW( INDEX_BENZRO2     , 1 )
             INDEX_TOL          = IOLD2NEW( INDEX_TOL         , 1 )
             INDEX_TO2          = IOLD2NEW( INDEX_TO2         , 1 )
             INDEX_TOLRO2       = IOLD2NEW( INDEX_TOLRO2      , 1 )
             INDEX_XOPN         = IOLD2NEW( INDEX_XOPN        , 1 )
             INDEX_XYLMN        = IOLD2NEW( INDEX_XYLMN       , 1 )
             INDEX_XLO2         = IOLD2NEW( INDEX_XLO2        , 1 )
             INDEX_XYLRO2       = IOLD2NEW( INDEX_XYLRO2      , 1 )
             INDEX_NAPH         = IOLD2NEW( INDEX_NAPH        , 1 )
             INDEX_PAHRO2       = IOLD2NEW( INDEX_PAHRO2      , 1 )
             INDEX_CRO          = IOLD2NEW( INDEX_CRO         , 1 )
             INDEX_CAT1         = IOLD2NEW( INDEX_CAT1        , 1 )
             INDEX_CRON         = IOLD2NEW( INDEX_CRON        , 1 )
             INDEX_OPAN         = IOLD2NEW( INDEX_OPAN        , 1 )
             INDEX_ECH4         = IOLD2NEW( INDEX_ECH4        , 1 )
             INDEX_CL2          = IOLD2NEW( INDEX_CL2         , 1 )
             INDEX_CL           = IOLD2NEW( INDEX_CL          , 1 )
             INDEX_HOCL         = IOLD2NEW( INDEX_HOCL        , 1 )
             INDEX_CLO          = IOLD2NEW( INDEX_CLO         , 1 )
             INDEX_FMCL         = IOLD2NEW( INDEX_FMCL        , 1 )
             INDEX_HCL          = IOLD2NEW( INDEX_HCL         , 1 )
             INDEX_CLNO2        = IOLD2NEW( INDEX_CLNO2       , 1 )
             INDEX_CLNO3        = IOLD2NEW( INDEX_CLNO3       , 1 )
             INDEX_SVAVB2       = IOLD2NEW( INDEX_SVAVB2      , 1 )
             INDEX_SVAVB3       = IOLD2NEW( INDEX_SVAVB3      , 1 )
             INDEX_SVAVB4       = IOLD2NEW( INDEX_SVAVB4      , 1 )
             INDEX_SVAVB1       = IOLD2NEW( INDEX_SVAVB1      , 1 )
             INDEX_SESQ         = IOLD2NEW( INDEX_SESQ        , 1 )
             INDEX_SESQRXN      = IOLD2NEW( INDEX_SESQRXN     , 1 )
             INDEX_SOAALK       = IOLD2NEW( INDEX_SOAALK      , 1 )
             INDEX_H2NO3PIJ     = IOLD2NEW( INDEX_H2NO3PIJ    , 1 )
             INDEX_H2NO3PK      = IOLD2NEW( INDEX_H2NO3PK     , 1 )
             INDEX_ACLI         = IOLD2NEW( INDEX_ACLI        , 1 )
             INDEX_ACLJ         = IOLD2NEW( INDEX_ACLJ        , 1 )
             INDEX_ACLK         = IOLD2NEW( INDEX_ACLK        , 1 )
             INDEX_IEPOXP       = IOLD2NEW( INDEX_IEPOXP      , 1 )
             INDEX_ASO4J        = IOLD2NEW( INDEX_ASO4J       , 1 )
             INDEX_AISO3J       = IOLD2NEW( INDEX_AISO3J      , 1 )
             INDEX_AGLYJ        = IOLD2NEW( INDEX_AGLYJ       , 1 )
             INDEX_MTNO3        = IOLD2NEW( INDEX_MTNO3       , 1 )
             INDEX_AMTNO3J      = IOLD2NEW( INDEX_AMTNO3J     , 1 )
             INDEX_AMTHYDJ      = IOLD2NEW( INDEX_AMTHYDJ     , 1 )
             INDEX_AAVB2J       = IOLD2NEW( INDEX_AAVB2J      , 1 )
             INDEX_AOLGAJ       = IOLD2NEW( INDEX_AOLGAJ      , 1 )
             INDEX_AAVB3J       = IOLD2NEW( INDEX_AAVB3J      , 1 )
             INDEX_AAVB4J       = IOLD2NEW( INDEX_AAVB4J      , 1 )
             INDEX_AISO1J       = IOLD2NEW( INDEX_AISO1J      , 1 )
             INDEX_AOLGBJ       = IOLD2NEW( INDEX_AOLGBJ      , 1 )
             INDEX_AISO2J       = IOLD2NEW( INDEX_AISO2J      , 1 )
             INDEX_ASQTJ        = IOLD2NEW( INDEX_ASQTJ       , 1 )
             INDEX_APOCI        = IOLD2NEW( INDEX_APOCI       , 1 )
             INDEX_APNCOMI      = IOLD2NEW( INDEX_APNCOMI     , 1 )
             INDEX_APOCJ        = IOLD2NEW( INDEX_APOCJ       , 1 )
             INDEX_APNCOMJ      = IOLD2NEW( INDEX_APNCOMJ     , 1 )
             INDEX_PCVOC        = IOLD2NEW( INDEX_PCVOC       , 1 )
             INDEX_PCSOARXN     = IOLD2NEW( INDEX_PCSOARXN    , 1 )
             INDEX_VLVPO1       = IOLD2NEW( INDEX_VLVPO1      , 1 )
             INDEX_VSVPO1       = IOLD2NEW( INDEX_VSVPO1      , 1 )
             INDEX_VSVPO2       = IOLD2NEW( INDEX_VSVPO2      , 1 )
             INDEX_VSVPO3       = IOLD2NEW( INDEX_VSVPO3      , 1 )
             INDEX_VIVPO1       = IOLD2NEW( INDEX_VIVPO1      , 1 )
             INDEX_VLVOO1       = IOLD2NEW( INDEX_VLVOO1      , 1 )
             INDEX_VLVOO2       = IOLD2NEW( INDEX_VLVOO2      , 1 )
             INDEX_VSVOO2       = IOLD2NEW( INDEX_VSVOO2      , 1 )
             INDEX_VSVOO3       = IOLD2NEW( INDEX_VSVOO3      , 1 )
             INDEX_VSVOO1       = IOLD2NEW( INDEX_VSVOO1      , 1 )
             INDEX_FORM_PRIMARY = IOLD2NEW( INDEX_FORM_PRIMARY, 1 )
             INDEX_ALD2_PRIMARY = IOLD2NEW( INDEX_ALD2_PRIMARY, 1 )
             INDEX_BUTADIENE13  = IOLD2NEW( INDEX_BUTADIENE13 , 1 )
             INDEX_ACROLEIN     = IOLD2NEW( INDEX_ACROLEIN    , 1 )
             INDEX_ACRO_PRIMARY = IOLD2NEW( INDEX_ACRO_PRIMARY, 1 )
             INDEX_TOLU         = IOLD2NEW( INDEX_TOLU        , 1 )
             INDEX_HG           = IOLD2NEW( INDEX_HG          , 1 )
             INDEX_HGIIAER      = IOLD2NEW( INDEX_HGIIAER     , 1 )
             INDEX_HGIIGAS      = IOLD2NEW( INDEX_HGIIGAS     , 1 )
          END SUBROUTINE RESET_SPECIES_POINTERS
       END MODULE RXNS_FUNCTION

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C routines for aerosol formation and transformation processes

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AEROPROC( DT, COL, ROW, LAYER )

C-----------------------------------------------------------------------
C  SUBROUTINE AEROPROC advances the number, second moment, and mass
C   concentrations for each mode over the time interval DT.

C  KEY SUBROUTINES CALLED:
C     GETPAR, ORGAER5, GETCOAGS, INTERCOAG_GH, INTRACOAG_GH,
C     VOLINORG

C  KEY FUNCTIONS CALLED:  ERF, ERFC, GETAF

C  REVISION HISTORY:
C     Coded in December 1999 by Dr. Francis S. Binkowski
C      Modified from older versions used in CMAQ.

C FSB 05/17/00  new version of RPMARES included

C FSB 05/30/00  Fixed minor bug in awater.f

C FSB Correction to extinction coefficient in getbext.

C FSB 07/21/00 corrected units on ORGRATES and ORGBRATE_IN from
C      ppm/min to ppm/sec in AEROPROC and AEROSTEP.

C FSB 11/30/00 following changes from 07/28/00
C     Fixed problem for new emissions file version
C     Combined emissions for M3
C     Used a fixed value of Dpmin for plotting
C     Added variables OMEGA_AT & OMEGA_AC for partitioning
C     Eliminated the restriction on relative humidity for nucleation.
C     Added a branch in EQL for very low relative humidity (<1%).

C FSB Following changes to RPMARES:
C     Number of iterations reduced from 150 to 50.
C     Iterations are used only if 0.5 < = RATIO.
C     In calculating the molality of the bisulfate ion, a
C     MAX(1.0e-10, MSO4 ) is used.

C FSB 08/08/01 Changes to NEWPART to correct mass rate and to AEROSTEP
C     to correct sulfate, include emissions, and trap problem in
C     accumulation mode number calculation.

C FSB 09/19/01 Version AE3, major changes
C     Organics are done with Dr. Benedikt Schell's approach. (ORGAER3)
C     Particle production uses Kulmala approach (NEWPART3)
C     Condensational factors for sulfate and organics are calculated
C      separately.
C     Emissions are assumed to be input in vertical diffusion.
C     Include files replaced by Fortran 90 Modules.
C     The modules also contain subroutines.

C FSB 10/24/01 Added the treatment of gaseous N2O5 -> aerosol HNO3

C FSB 10/25/01 Changed the mass transfer calculation for Aitken to
C     accumulation mode by coagulation as recommended by Dr. Benedikt
C     Schell.

C SJR 04/24/02 Replaced thermodynamic code RPMARES with ISORROPIA
C     --Shawn J. Roselle

C GLG 04/04/03 Modifications to allow for evaporation of semi-volatile
C     organics from aerosol phase.  --Gerald L. Gipson

C FSB 11/18/03 Corrections to sulfate condensation.  Previously,
C     SCONDRATE was undefined when SO4RATE=0 and SCONDRATE was
C     negative when SO4RATE < DMDT_so4.

C PVB 01/08/04 Several changes in preparation for simulation of 2001
C      calendar year --Dr. Prakash V. Bhave
C    -Added interface to new subroutine, GETCOAGS, for calculating
C      coagulation rates.  GETCOAGS is used instead of Gauss-Hermite
C      quadrature for computational efficiency, by setting
C      FASTCOAG_FLAG = .TRUE.  --PVB
C    -Removed SOA from the definition of "DRY" aerosol.  Aerosol surface
C      area is now transported without SOA.  See notes in GETPAR, AERO,
C      and AERO_DEPV subroutines.  --SJR
C    -Moved EQL3 call from AEROPROC to AEROSTEP, immediately following
C      the ORGAER3 call.  This is a side effect of transporting aerosol
C      surface area without SOA.  --SJR
C    -New subroutine, HCOND3, to calculate condensation rates for
C      2nd and 3rd moments.  Results are unchanged.  --FSB
C    -Revised method of calculating SOA.  Partition SOA to the modes
C      in proportion to the amounts of total organic mass (SOA plus
C      primary) in each mode.  Modal geometric standard deviations are
C      now preserved during SOA condensation and evaporation. --FSB
C    -Combined the former subroutines AEROPROC and AEROSTEP into this
C      subroutine; retained the name AEROPROC.  --PVB

C PVB 09/21/04 added in-line documentation with input from FSB.
C     Changed MWH2SO4 from 98.07354 to 98.0 g/mol for consistency with
C     the mechanism files.

C PVB 09/27/04 removed the IF(XM3.GT.0.0) mode-merging precondition
C     because it caused significant erroneous mode crossover.  Fix
C     suggested by Dr. Chris Nolte.

C PVB 01/19/05 Added SO4RATE to the EQL3 call vector.  This is necessary
C     to ensure that the gas and inorganic fine PM (i+j) concentrations
C     are in thermodynamic equilibrium at the end of each time step.

C PVB 05/02/05 Modified ERF statement function for negative arguments such
C     that erf(-x) = -erf(x).  Previous version had erf(-x) = erf(x).

C PVB 04/06/06 Added GAMMA_N2O5 to the AEROPROC and EQL3 call vectors,
C     so it can be written to the aerosol diagnostic file.

C SLN 09/07/07 Several changes in preparation for new SOA module
C    -Removed Aitken-mode SOA species (CBLK(VORGAI),CBLK(VORGBI)) and
C     all of the related variables (OMASS_I, OMASS_J, FRACI, FRACJ,
C     OLD_M2_I, OLD_M3_I, NEW_M2_I, NEW_M3_I)
C    -Replaced the other SOA species (CBLK(VORGAJ),CBLK(VORGBJ)) with
C     precursor-specific SOA species (e.g., CBLK(VTOL1J)).
C    -Replaced SOA_A and SOA_B with an array, SOA_ALL.  Replaced
C     OLDSOA_A and OLDSOA_B with an array, OLDSOA.  Updated ORGAER3
C     call vector accordingly.
C    -Removed dependence of mode-merging criteria on SOA condensation
C     because that logic was flawed.  Deleted all variables needed
C     for that calculation (CHEMRATE_ORG, ORGRATE, ORGBRATE).

C PVB 11/02/07 Moved heterogenous N2O5 chemistry from EQL3 to a new
C     subroutine, HETCHEM.

C PVB 11/29/07 Implementation of new SOA formation mechanisms
C    -Replaced call to ORGAER3 with a call to ORGAER5
C    -Moved CBLK updates of SV species, SOA species, M2, and M3 into
C     ORGAER5 instead of updating those values in AEROPROC

C JOY 04/08/08 White space, alignment, readability

C JTK 04/17/08 Implemented coarse chemistry updates
C     -replaced condensation calculations with call to VOLINORG
C     -added code for coarse surface area and variable coarse std. dev.
C     -modified modal dynamics equations because new particle formation
C      and growth are now calculated in VOLINORG

C JOY 12/07/08 Removed unused EQL3 code, add column and row arguments to
C     VOLINORG for diagnostic logging

C SH  12/17/09 Major restructuring of all aerosol codes
C     -use new Fortran modules (e.g., AERO_DATA, SOA_DEFN); shortened call
C      vector; replaced CBLK with aerospc structure; eliminated AERO_INFO

C SH  03/10/11 Renamed met_data to aeromet_data

C HS  03/10/11 Added call to POAAGE between ORGAER and HETCHEM

C SR  03/25/11 Replaced I/O API include files with UTILIO_DEFN

C BH  09/30/13 Removed Call to HETCHEM and GAMMA_N2O5 argument
C              because of merging of gas and heterogeneous 
C              chemistry

C JB  02/07/14 Added Jai Xing's mass balance fix when there is excessive
C              condensation or evaporation under cold conditions

C BH  07/21/14 Removed call to POAAGE because reaction represented in
C              chemical mechanism

C GS/KF 09/23/14 Updated nucleation scheme with Vehkamaki et al. (2002)

C HP/BM  4/16 Removed m3_wet_flag since wet/dry status is now
C             tracked by AERO_DATA variable. Moments are always wet in AEROPROC
C             Updated treatment of aerosol moments

C SLN 12/30/19 Update for ddm-3d implementation in version 5.3.1

C  REFERENCES:
C   1. Binkowski, F.S. and U. Shankar, The regional particulate matter
C      model 1. Model description and preliminary results, J. Geophys.
C      Res., Vol 100, No D12, 26101-26209, 1995.

C   2. Binkowski, F.S. and S.J. Roselle, Models-3 Community
C      Multiscale Air Quality (CMAQ) model aerosol component 1:
C      Model Description.  J. Geophys. Res., Vol 108, No D6, 4183
C      doi:10.1029/2001JD001409, 2003.

C   3. Bhave, P.V., S.J. Roselle, F.S. Binkowski, C.G. Nolte, S. Yu,
C      G.L. Gipson, and K.L. Schere, CMAQ aerosol module development:
C      recent enhancements and future plans, Paper No. 6.8, CMAS Annual
C      Conference, Chapel Hill, NC, 2004.
C-----------------------------------------------------------------------
      
      USE AERO_DATA
      USE PRECURSOR_DATA      ! gas phase aero precursor data
      USE SOA_DEFN
      USE AEROMET_DATA
      USE UTILIO_DEFN
      USE AERO_BUDGET

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX
      USE AERO_DDM3D, ONLY : s_aerospc_conc, s_precursor_conc, s_so4rate, s_vapor_conc, s_orgprod_conc
#endif


      IMPLICIT NONE

C *** arguments:
      REAL,    INTENT( IN ) :: DT          ! synchronization time step, sec
      INTEGER, INTENT( IN ) :: COL         ! Column of cell
      INTEGER, INTENT( IN ) :: ROW         ! Row of cell
      INTEGER, INTENT( IN ) :: LAYER       ! Layer of cell

C *** Parameters
      REAL, PARAMETER :: DIFFSULF = 9.36E-06  ! molecular diffusiviity for sulfuric acid
      REAL, PARAMETER :: SQRT2 = 1.4142135623731
      REAL, PARAMETER :: T0 = 288.15   ! [ K ]
      REAL, PARAMETER :: TWOTHIRDS   =  2.0 / 3.0
      REAL, PARAMETER :: ONE_OVER_TICE =  1.0 / 273.16

C *** local variables
      REAL         DIFFCORR   ! Correction to DIFFSULF & DIFFORG for pressure
      REAL         DV_SO4     ! molecular diffusivity of H2SO4 vapor after correction for ambient conditions
      REAL         SQRT_TEMP  ! square root of ambient temperature
      REAL         XLM        ! atmospheric mean free path [m]
      REAL         AMU        ! atmospheric dynamic viscosity [kg/m s]

      REAL( 8 ) :: CGR( N_MODE-1 ) ! Aitken & Accum. modes

      REAL( 8 ) :: LAMDA      ! mean free path [ m ]
      REAL( 8 ) :: KNC        ! KNC = TWO3 * BOLTZMANN *  AIRTEMP / AMU

C *** Free Molecular regime (depends upon modal density)
      REAL( 8 ) :: KFMAT      ! = SQRT( 3.0*BOLTZMANN * AIRTEMP / PDENSAT )
      REAL( 8 ) :: KFMAC      ! = SQRT( 3.0*BOLTZMANN * AIRTEMP / PDENSAC )
      REAL( 8 ) :: KFMATAC    ! = SQRT( 6.0*BOLTZMANN * AIRTEMP / ( PDENSAT + PDENSAC ) )

C *** Intermodal coagulation rates [ m**3/s ] ( 0th & 2nd moments )
      REAL( 8 ) :: BATAC( 2 ) ! Aitken to accumulation
      REAL( 8 ) :: BACAT( 2 ) ! accumulation from Aitken

C *** Intramodal coagulation rates [ m**3/s ] ( 0th & 2nd moments )
      REAL( 8 ) :: BATAT( 2 ) ! Aitken mode
      REAL( 8 ) :: BACAC( 2 ) ! accumulation mode

C *** Intermodal coagulation rate [ m**3/s ] ( 3rd moment )
      REAL( 8 ) :: C3IJ       ! Aitken to accumulation
      REAL( 8 ) :: C30ATAC    ! Aitken to accumulation
      REAL( 8 ) :: DG_D ( N_MODE )
      REAL( 8 ) :: SG_D ( N_MODE )
      REAL( 8 ) :: XXL_D( N_MODE )

! *** Variables for computing the budget
      REAL( 8 ) :: CBUDGET0_NUM ( N_MODE )
      REAL( 8 ) :: CBUDGET0_SRF ( N_MODE )
      REAL( 8 ) :: CBUDGET0_MASS( N_AEROSPC,N_MODE )

C *** variables for advancing concentrations one time step
      REAL( 8 ) :: A, B
      REAL( 8 ) :: Y0, Y
      REAL( 8 ) :: EXPDT
      REAL( 8 ) :: LOSS, PROD, POL
      REAL         TMASS
      REAL         FACTRANS ! special factor to compute mass transfer
      REAL         M20      ! for initial condidtions in time stepping

C *** Variables for mode merging
      REAL         GETAF
      REAL         AAA, XNUM, XM2, XM3,XXM2, XXM3
      REAL         FNUM, FM2, FM3, PHNUM, PHM2, PHM3
      REAL         ERF, ERFC    ! Error and complementary error function

C *** local variables
      INTEGER      SPC        ! loop counter
      INTEGER      N          ! loop counter

      logical, save :: firstime = .true.
C-----------------------------------------------------------------------

      if ( firstime ) then
         firstime = .false.
#ifdef nomm
         write( logdev,* ) 'aero_subs: nomm'
#endif
      end if

C *** square root of the ambient temperature for later use
      SQRT_TEMP = SQRT( AIRTEMP )
 
C *** Calculate mean free path [ m ]:
C     6.6328E-8 is the sea level value given in Table I.2.8
C     on page 10 of U.S. Standard Atmosphere 1962

      XLM = 6.6328E-8 * STDATMPA * AIRTEMP  / ( T0 * AIRPRES )

C *** Calculate dynamic viscosity [ kg m**-1 s**-1 ]:
C     U.S. Standard Atmosphere 1962 page 14 expression
C     for dynamic viscosity is:
C     dynamic viscosity =  beta * T * sqrt(T) / ( T + S)
C     where beta = 1.458e-6 [ kg sec^-1 K**-0.5 ], s = 110.4 [ K ].
      AMU = 1.458E-6 * AIRTEMP * SQRT_TEMP / ( AIRTEMP + 110.4 )

C *** Set minimums for coarse mode
      MOMENT0_CONC( N_MODE ) = MAX( AEROMODE_MINNUM( N_MODE ),
     &                              MOMENT0_CONC( N_MODE ) )

C *** Secondary Organics
C     Update the secondary organic aerosol (SOA) mass concentrations
C     and the SVOC mass concentrations by equilibrium absorptive
C     partitioning between the particle and vapor phases.  Assume all
C     SOA resides in the accumulation mode.
C
C     Aerosol is wet when it enters orgaer
      CALL ORGAER( DT, LAYER )

C *** Secondary Inorganics
C     The VOLINORG subroutine includes the treatment of new particle
C     production and a fully dynamic treatment of inorganic gas-to-
C     particle mass transfer.

C *** Compute H2SO4 diffusivity, correct for temperature and pressure
      DIFFCORR = ( STDATMPA / AIRPRES ) * ( ONE_OVER_TICE * AIRTEMP ) ** 1.75
      DV_SO4 = DIFFSULF * DIFFCORR

C *** Update size parameters (distribution is wet from ORGAER)
      CALL GETPAR( FIXED_sg )

! *** Mass transfer of inorganic constituents      
! *** Process Budget is calculated inside this routine because NPF and
! *** condensation are calculated simultaneously
      CALL VOLINORG( DT, COL, ROW, LAYER, DV_SO4, CGR )

! *** Coagulation
!     Calculate coagulation coefficients using a method dictated by
!     the value of FASTCOAG_FLAG.  If TRUE, the computationally-
!     efficient GETCOAGS routine is used.  If FALSE, the more intensive
!     Gauss-Hermite numerical quadrature method is used.  See Section
!     2.1 of Bhave et al. (2004) for further discussion.
! *** Initialize Budget Variables
      CBUDGET0_NUM  = MOMENT0_CONC
      CBUDGET0_SRF  = MOMENT2_CONC
      CBUDGET0_MASS = AEROSPC_CONC
 
! *** set atmospheric mean free path in double precision
      LAMDA    = XLM

! *** calculate term used in Equation A6 of Binkowski & Shankar (1995)
      KNC      = TWOTHIRDS * BOLTZMANN *  AIRTEMP / AMU

! *** calculate terms used in Equation A5 of Binkowski & Shankar (1995)
      KFMAT    = SQRT( 3.0 * BOLTZMANN * AIRTEMP / AEROMODE_DENS( 1 ) )
      KFMAC    = SQRT( 3.0 * BOLTZMANN * AIRTEMP / AEROMODE_DENS( 2 ) )
      KFMATAC  = SQRT( 6.0 * BOLTZMANN * AIRTEMP
     &         / ( AEROMODE_DENS( 1 ) + AEROMODE_DENS( 2 ) ) )

! *** transfer of number to accumulation mode from Aitken mode is zero
      BACAT( 1 ) = 0.0

      IF ( FASTCOAG_FLAG ) THEN ! Solve coagulation analytically

C *** set geometric mean diameters, geometric standard deviations, and
C     ln(GSD) in double precision
         DO N = 1, N_MODE
            DG_D( N ) = AEROMODE_DIAM( N )
            SG_D( N ) = EXP( AEROMODE_LNSG( N ) )
            XXL_D( N ) = AEROMODE_LNSG( N )
         END DO

C *** calculate intermodal and intramodal coagulation coefficients
C     for zeroth and second moments, and intermodal coagulation
C     coefficient for third moment
         CALL GETCOAGS( LAMDA, KFMATAC, KFMAT, KFMAC, KNC,
     &                  DG_D(1), DG_D(2), SG_D(1), SG_D(2),
     &                  XXL_D(1),XXL_D(2),
     &                  BATAT( 2 ), BATAT( 1 ), BACAC( 2 ), BACAC( 1 ),
     &                  BATAC( 2 ), BACAT( 2 ), BATAC( 1 ), C3IJ )

      ELSE                 ! Use Gauss-Hermite numerical quadrature

C *** calculate Aitken-mode intramodal coagulation coefficients
C     for zeroth and second moments
         CALL INTRACOAG_GH( LAMDA, KFMAT, KNC, AEROMODE_DIAM( 1 ),
     &                      AEROMODE_LNSG( 1 ), BATAT( 2 ), BATAT( 1 ) )

C *** calculate accumulation-mode intramodal coagulation coefficients
C     for zeroth and second moments
         CALL INTRACOAG_GH( LAMDA, KFMAC, KNC, AEROMODE_DIAM( 2 ),
     &                      AEROMODE_LNSG( 2 ), BACAC( 2 ), BACAC( 1 ) )

C *** calculate intermodal coagulation coefficients for zeroth, second,
C     and third moments
         CALL INTERCOAG_GH( LAMDA, KFMATAC, KNC,
     &                      AEROMODE_DIAM( 1 ), AEROMODE_DIAM( 2 ),
     &                      AEROMODE_LNSG( 1 ), AEROMODE_LNSG( 2 ),
     &                      BATAC( 2 ), BACAT( 2 ), BATAC( 1 ), C3IJ )

      END IF   ! FASTCOAG_FLAG

C *** calculate 3rd moment intermodal transfer rate by coagulation
      C30ATAC = C3IJ * MOMENT0_CONC( 1 ) * MOMENT0_CONC( 2 )

C *** TAKE ONE FORWARD TIME STEP - Solve Modal Dynamics Equations
C     This code implements Section 1.4 of Binkowski and Roselle (2003)
C     with two notable exceptions.  1) emissions are treated in
C     CMAQ`s vertical diffusion routine, so they do not appear in the
C     following equations. 2) new particle formation and condensational
C     growth are now treated in the VOLINORG subroutine, so they do not
C     appear in the following equations.
 
C     M2 is updated before M0 because the intermodal transfer rate of
C     M2 is a function of the number concentrations.  In contrast,
C     production and loss rates of M0 are independent of M2.  Advancing
C     M2 before M0 avoids operator splitting within the modal-dynamic-
C     equation solution.  A similar rearrangement would be necessary
C     for the M3 update, but the dependence of M3 on number
C     concentrations already is accounted for in the C30ATAC term.

C *** UPDATE SECOND MOMENT
C     For each lognormal mode, solve equations of form:
C        dM2/dt = P2 - L2*M2   ! if L2 > 0
C     with solution
C        M2(t) = P2/L2 + ( M2(t0) - P2/L2 ) * exp( -L2*dt )
C     or
C        dM2/dt = P2           ! if L2 = 0
C     with solution
C        M2(t) = M2(t0) + P2*dt

C *** Aitken mode: initial value of M2
      M20 = MOMENT2_CONC( 1 )

C *** Loss of 2nd moment from Aitken mode is due to intermodal
C     coagulation with accumulation mode and intramodal coagulation.
C     Production term is removed, because new particle formation
C     and condensational growth are accounted for in VOLINORG.
      LOSS = (
     &        ( BATAT( 2 ) * MOMENT0_CONC( 1 )
     &        + BATAC( 2 ) * MOMENT0_CONC( 2 ) ) * MOMENT0_CONC( 1 )
     &       ) / M20

C *** Solve for M2_Aitken based on LOSS during this time step
C     Note: LOSS is assumed to be non-negative.
      IF ( LOSS .GT. 0.0 ) THEN
         Y = M20 * EXP( -LOSS * DT )
      ELSE
         Y = M20
      END IF ! test on loss

C *** Transfer new value of M2_Aitken to the array
      MOMENT2_CONC( 1 ) = MAX( REAL( AEROMODE_MINM2( 1 ) ), REAL( Y ) )

C *** Accumulation mode: initial value of M2
      M20 = MOMENT2_CONC( 2 )

C *** Production of 2nd moment in accumulation mode is due to
C     intermodal coagulation Aitken mode
      PROD = BACAT( 2 ) * MOMENT0_CONC( 1 ) * MOMENT0_CONC( 2 )

C *** Loss of 2nd moment from accumulation mode is due only to
C     intramodal coagulation
      LOSS = ( BACAC( 2 ) * MOMENT0_CONC( 2 ) * MOMENT0_CONC( 2 ) ) / M20

C *** Solve for M2_accum based on PROD and LOSS during this time step
C     Note: LOSS is assumed to be non-negative.
      IF ( LOSS .GT. 0.0 ) THEN
         POL = PROD / LOSS
         Y = POL + ( M20 - POL ) * EXP( -LOSS * DT )
      ELSE
         Y = M20 + PROD * DT
      END IF ! test on loss

C *** Transfer new value of M2_accum to moment array
      MOMENT2_CONC( 2 ) = MAX( REAL( AEROMODE_MINM2( 2 ) ), REAL( Y ) )

C *** Coarse mode: no change because coagulation of coarse particles
C     is neglected in current model version.

! ** Update Budget Variable for Second Moment
      COAG_BUDGET( AEROSRF_MAP( 1 ),1 ) = MOMENT2_CONC( 1 ) - CBUDGET0_SRF( 1 )
      COAG_BUDGET( AEROSRF_MAP( 2 ),2 ) = MOMENT2_CONC( 2 ) - CBUDGET0_SRF( 2 )

C *** end of update for second moment

C *** Update Zeroth Moment (i.e. number concentration)

C *** Aitken mode: initial value of M0

      Y0 = MOMENT0_CONC( 1 )

C *** The rate of change for M0_Aitken is described in Equation 8a of
C     Binkowski & Roselle (2003), with the c_i term equal to 0.

      A = BATAT( 1 )                      ! intramodal coagulation
      B = BATAC( 1 ) * moment0_conc( 2 )  ! intermodal coagulation

      EXPDT = EXP( - B * DT )
      IF ( EXPDT .LT. 1.0D0 ) THEN
         Y = B * Y0 * EXPDT / ( B + A * Y0 * ( 1.0D0 - EXPDT ) )
      ELSE
         Y = Y0                 ! solution in the limit that B approaches zero
      END IF

C *** Transfer new value of M0_Aitken to the moment array
      MOMENT0_CONC( 1 ) = MAX( AEROMODE_MINNUM( 1 ), REAL( Y ) )

C *** Accumulation mode: initial value of M0
      Y0 = MOMENT0_CONC( 2 )

C *** The rate of change for M0_accum is described in Equation 8b of
C     Binkowski & Roselle (2003), except the coefficient C is zero
C     because emissions are treated outside the CMAQ aerosol module.
C     The equation reduces to the form: dY/dt = -A * Y**2 , where
      A = BACAC( 1 )                 ! intramodal coagulation

C *** Solve for M0_accum using Smoluchowski`s solution
      Y = Y0 / ( 1.0D0 + A * Y0 * DT )

C *** Transfer new value of M0_accum to the moment array
      MOMENT0_CONC( 2 ) = MAX( AEROMODE_MINNUM( 2 ), REAL( Y ) )

! ** Update Budget Variable for Second Moment
      COAG_BUDGET( AERONUM_MAP( 1 ),1 ) = MOMENT0_CONC( 1 ) - CBUDGET0_NUM( 1 )
      COAG_BUDGET( AERONUM_MAP( 2 ),2 ) = MOMENT0_CONC( 2 ) - CBUDGET0_NUM( 2 )

C *** end of update for zeroth moment - note that the coarse mode number does
C     not change because coarse-mode coagulation is neglected in the model

C *** UPDATE MASS CONCENTRATIONS (for each species)
C     The following procedure is described in Paragraphs 21-23
C     of Binkowski & Roselle (2003), except the Ei,n and Ej,n terms
C     are excluded here because emissions are treated outside the
C     CMAQ aerosol module.

C     Aitken mode mass concentration rates of change are of the form:
C        dc/dt = P - L*c    ! Equation 9a of Binkowski & Roselle (2003)
C     with solution
C        c(t0 + dt) = P/L + ( c(t0) - P/L ) * exp(-L*dt)

C     For all species, loss of Aitken mode mass is due to intermodal
C     coagulation.
C        LOSSn = PI/6 * RHOn * C30ATAC / MASSn
C        RHOn  = MASSn / (M3 * PI/6)
C     When above equations are combined, the PI/6 terms cancel yielding
C        LOSSn = C30ATAC / M3
C     where LOSSn is the loss rate of species n, RHOn is the mass of
C     species n per unit of particle volume, C30ATAC is the 3rd moment
C     loss rate due to intermodal coagulation, MASSn is the mass
C     concentration of species n, and M3 is the 3rd moment
C     concentration.

      LOSS = C30ATAC / MOMENT3_CONC( 1 )

C *** Set up extra variables to solve for Aitken mode mass concentrations
      FACTRANS = REAL( LOSS,4 ) * DT
      EXPDT = EXP( -FACTRANS )

C *** Transfer mass from Aitken to accumulation mode, resulting from 
C     intermodal coagulation.

      DO SPC = 1, N_AEROSPC
         IF ( AERO_MISSING(SPC,1) ) CYCLE
 
         TMASS = AEROSPC_CONC( SPC,1 ) + AEROSPC_CONC( SPC,2 )
         IF( SPC .EQ. APHGJ_IDX  )THEN 
! assumes all production adsorb onto accumulation mode
             TMASS = TMASS + PHG_RATE * DT
         END IF

         AEROSPC_CONC( SPC,1 ) = MAX( AEROSPC( SPC )%MIN_CONC( 1 ),
     &                                REAL( AEROSPC_CONC( SPC,1 ) * EXPDT ) )
         AEROSPC_CONC( SPC,2 ) = MAX( AEROSPC( SPC )%MIN_CONC( 2 ),
     &                                TMASS - AEROSPC_CONC( SPC,1 ) )


         ! Update Budget Variable for Second Moment
         IF ( AEROSPC_MAP( SPC,1 ) .NE. 0 ) 
     &      COAG_BUDGET( AEROSPC_MAP( SPC,1 ),1 ) = 
     &           AEROSPC_CONC( SPC,1 ) - CBUDGET0_MASS( SPC,1 )
         IF ( AEROSPC_MAP( SPC,2 ) .NE. 0 ) 
     &      COAG_BUDGET( AEROSPC_MAP( SPC,2 ),1 ) = 
     &           AEROSPC_CONC( SPC,2 ) - CBUDGET0_MASS( SPC,2 )

      END DO

C *** end of update for species mass concentrations

C *** Mode Merging
C     This code implements Section 1.5 of Binkowski and Roselle (2003).
C     If the Aitken mode mass is growing faster than accumulation mode
C     mass and the Aitken mode number concentration exceeds the
C     accumulation mode number concentration, then modes are merged by
C     renaming.

! *** Initialize Budget Variables
      CBUDGET0_NUM  = MOMENT0_CONC
      CBUDGET0_SRF  = MOMENT2_CONC
      CBUDGET0_MASS = AEROSPC_CONC

#ifdef nomm
      if ( .false. ) then
#else
      IF ( CGR( 1 ) .GT. CGR( 2 ) .AND.
     &     MOMENT0_CONC( 1 ) .GT. MOMENT0_CONC( 2 ) ) THEN
#endif

C *** Before mode merging, update the third moments, geometric mean
C     diameters, geometric standard deviations, modal mass totals, and
C     particle densities, based on the new concentrations of M2, M0, and
C     speciated masses calculated above. This is still the wet
C     distribution.
         CALL GETPAR( FIXED_sg )

C *** Calculate AAA = ln( Dij / DGATK ) / ( SQRT2 * XXLSGAT ), where Dij
C     is the diameter at which the Aitken-mode and accumulation-mode
C     number distributions intersect (i.e., overlap).  AAA is equivalent
C     to the "Xnum" term described below Equation 10a by Binkowski and
C     Roselle (2003).
         AAA = GETAF( MOMENT0_CONC( 1 ), MOMENT0_CONC( 2 ),
     &                AEROMODE_DIAM( 1 ), AEROMODE_DIAM( 2 ), 
     &                AEROMODE_LNSG( 1 ), AEROMODE_LNSG( 2 ),
     &                SQRT2 ) 

C *** Ensure that Xnum is large enough so that no more than half of
C     the Aitken mode mass is merged into the accumulation mode during
C     any given time step.  This criterion is described in Paragraph 26
C     of Binkowski and Roselle (2003).
         XXM3 = 3.0 * AEROMODE_LNSG( 1 ) / SQRT2
         XNUM = MAX( AAA, XXM3 )

C *** Factors used in error function calls for M2 and M3 mode merging
         XXM2 = TWOTHIRDS * XXM3
         XM2  = XNUM - XXM2 ! set up for 2nd moment transfer
         XM3  = XNUM - XXM3 ! set up for 3rd moment and mass transfers

C *** Calculate the fractions of the number, 2nd, and 3rd moment
C     distributions with diameter greater than the intersection diameter
         FNUM  = 0.5 * ERFC( XNUM )            ! Eq 10a of B&R 2003
         FM2   = 0.5 * ERFC( XM2 )             ! Eq 10b of B&R 2003
         FM3   = 0.5 * ERFC( XM3 )             ! Eq 10b of B&R 2003

C *** Calculate the fractions of the number, 2nd, and 3rd moment
C     distributions with diameters less than the intersection diameter.
         PHNUM = 0.5 * ( 1.0 + ERF( XNUM ) )  ! Eq 10c of B&R 2003
         PHM2  = 0.5 * ( 1.0 + ERF( XM2 ) )   ! Eq 10d of B&R 2003
         PHM3  = 0.5 * ( 1.0 + ERF( XM3 ) )   ! Eq 10d of B&R 2003

C *** Update accumulation-mode moment concentrations using
C     Equations 11a - 11c of Binkowski and Roselle (2003).
         MOMENT0_CONC( 2 ) = MOMENT0_CONC( 2 ) + MOMENT0_CONC( 1 ) * FNUM
         MOMENT2_CONC( 2 ) = MOMENT2_CONC( 2 ) + MOMENT2_CONC( 1 ) * FM2
         MOMENT3_CONC( 2 ) = MOMENT3_CONC( 2 ) + MOMENT3_CONC( 1 ) * FM3

C *** Update Aitken-mode moment concentrations using
C     Equations 11d - 11f of Binkowski and Roselle (2003).
         MOMENT0_CONC( 1 ) = MOMENT0_CONC( 1 ) * PHNUM
         MOMENT2_CONC( 1 ) = MOMENT2_CONC( 1 ) * PHM2
         MOMENT3_CONC( 1 ) = MOMENT3_CONC( 1 ) * PHM3
 
C *** Rename masses of each species from Aitken mode to acumulation mode
C     using Equation 11b of Binkowski and Roselle (2003). Do this for
C     all species, even the aerosol water.
         DO SPC = 1, N_AEROSPC
            IF ( AERO_MISSING(SPC,1) ) CYCLE

            AEROSPC_CONC( SPC,2 ) = AEROSPC_CONC( SPC,2 ) + AEROSPC_CONC( SPC,1 ) * FM3
            AEROSPC_CONC( SPC,1 ) = AEROSPC_CONC( SPC,1 ) * PHM3
         END DO

      END IF ! end check on necessity for merging

C *** end of update for mode merging

C *** Update the third moments, geometric mean diameters, geometric
C     standard deviations, modal mass totals, and particle densities,
C     based on the final concentrations of M2, M0, and speciated masses
C     after mode merging is complete. This should be done for the wet
C     distribution.
      CALL GETPAR( FIXED_sg )

C *** Set minimum value for all concentrations in the CBLK array

      DO N = 1, N_MODE
         DO SPC = 1, N_AEROSPC
            AEROSPC_CONC( SPC,N ) = MAX( AEROSPC_CONC( SPC,N ),
     &                                   AEROSPC( SPC )%MIN_CONC( N ) )
         END DO
      END DO

! *** Propagate Mode Merging and Minimum value impacts to budget variables
      GROWTH_BUDGET( AERONUM_MAP(:) ) = MOMENT0_CONC(:) - CBUDGET0_NUM(:)
      GROWTH_BUDGET( AEROSRF_MAP(:) ) = MOMENT0_CONC(:) - CBUDGET0_NUM(:)
      DO SPC = 1,N_AEROSPC
         WHERE( AEROSPC_MAP( SPC,: ) .NE. 0 )
     &          GROWTH_BUDGET( AEROSPC_MAP(SPC,:) )=
     &              AEROSPC_CONC(SPC,:) - CBUDGET0_MASS(SPC,:)
      END DO

      RETURN
      END SUBROUTINE AEROPROC


C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE VOLINORG( DT, COL, ROW, LAYER, DV_SO4, CGR )

C *** Calculates the partitioning of inorganic components (CL,NO3,NH4,SO4)
C     between the aerosol and gas phase over the operator synchronization
C     timestep (DT). Partitioning is calculated using the Hybrid approach,
C     where dynamic mass transfer of species to/from the coarse mode is
C     calculated using multiple sub-operator time steps (TSTEP) and the
C     fine modes are equilibrated with the gas phase. The mass transfer
C     calculations are made using the H+ flux-limiting approach of Pilinis
C     et al. (2000). If 'OPTIONFLAG' is not set to 'Hybrid', the mass
C     transfer calculations for the coarse mode are skipped, and the fine
C     modes are equilibrated with the gas phase.

C     Returns updated volatile inorganic species concentrations in the gas
C     and particulate phase, and the aerosol modal parameters

C *** Revision history: 4/07 - Moved HCOND3 and NEWPART3 calls from 
C                              AEROPROC to this subroutine for 
C                              mass transfer calculation  
C     15 Jul 08 J.Young, P.Bhave: increased cutoff to hybrid from .01 to .05 ug/m**3
C               J.Young: change 'OPTIONFLAG' to just a logical variable, 'Hybrid'

C     10 Mar 11 S.Howard Renamed met_data to aeromet_data
C     25 Mar 11 S.Roselle Replaced I/O API include files with UTILIO_DEFN
C     26 Apr 11 G.Sarwar Replaced existing ISORROPIA with ISORROPIA 2.1
C               Updated coarse-mode aerosol speciation and H+ calculation  
C     12 Apr 16 H. Pye and B. Murphy: Update with consistent treatment for wet particles.
C     15 Apr 16 J.Young: Use aerosol factors from AERO_DATA module named constants

C *** References
C 1. Pilinis C, Capaldo KP, Nenes A, Pandis SN (2000) MADM - A new
C    multicomponent aerosol dynamics model. AEROSOL SCIENCE AND TECHNOLOGY.
C    32(5):482-502
C
C 2. Capaldo KP, Pilinis C, Pandis SN (2000) A computationally efficient hybrid
C    approach for dynamic gas/aerosol transfer in air quality models. ATMOSPHERIC
C    ENVIRONMENT. 34(21):3617-3627
C
C 3. Fountoukis C, Nenes, A (2007) ISORROPIA II: a comnputationally efficient 
C    thermodynamic equilibrium model for K+-Ca2+-Mg2+-NH4+-SO42--NO3--Cl-H2O 
C    aerosols. ATMOSPHERIC CHEMISTRY AND PHYSICS. 7, 4639-4659

      USE AERO_DATA
      USE PRECURSOR_DATA
      USE SOA_DEFN
      USE AEROMET_DATA
      USE UTILIO_DEFN

      IMPLICIT NONE

C *** Arguments:
      REAL    DT              ! time step [sec]
      INTEGER COL             ! grid column index
      INTEGER ROW             ! grid row index
      INTEGER LAYER           ! model layer index
      REAL    DV_SO4          ! molecular diffusivity of H2SO4 vapor 
                              ! after correction for ambient conditions
      REAL( 8 ) :: CGR( N_MODE-1 ) ! 3rd moment SO4 growth rate [m^3/m^3-s]

C *** Parameters: 
      INTEGER, PARAMETER :: NINORG = 9      ! number of inorganic species
      INTEGER, PARAMETER :: NVOLINORG = 3   ! number of volatile inorganic species

      ! indices for inorganic species
!     INTEGER, PARAMETER :: KNH4 = 1, KNO3 = 2, KCL = 3, KSO4 = 4, KNA = 5, KHP = 6, KMG = 7, KK = 8, KCA = 9
      INTEGER, PARAMETER :: KNH4 = 1, KNO3 = 2, KCL = 3, KSO4 = 4, KNA = 5, KMG = 6, KK = 7, KCA = 8, KHP = 9

      REAL( 8 ), PARAMETER :: D_TWOTHIRDS = 2.0D0 / 3.0D0

      REAL, PARAMETER :: CUTOFF = 0.05  ! [ug/m**3]
      REAL, PARAMETER :: ALPHSULF = 0.1 ! Accommodation coefficient for sulfuric acid
                                        ! see Capaldo et al. (2000)

C *** Local Variables:

C *** Inputs to subroutine HCOND3

      REAL, SAVE :: COFCBAR_SO4  ! Temperature-independent coefficients
                                 ! for caculating molecular vel [m/s]
                                 ! = sqrt((8*Rgas)/(pi*MW)) 
      REAL         CBAR_SO4      ! molecular velocity of H2SO4                      

      REAL( 8 ) :: AM0( N_MODE ) ! zeroth moments
      REAL( 8 ) :: AM1( N_MODE ) ! first moments
      REAL( 8 ) :: AM2( N_MODE ) ! second moments

      REAL( 8 ) :: M2DRY_INIT( N_MODE )  ! Dry Second Moment Initial Array
      REAL( 8 ) :: M3DRY_INIT( N_MODE )  ! Dry Third Moment Initial Array
      REAL( 8 ) :: M2WET_INIT( N_MODE )  ! Wet Second Moment Initial Array
      REAL( 8 ) :: M3WET_INIT( N_MODE )  ! Wet Third Moment Initial Array
      REAL( 8 ) :: M2WET_FINAL( N_MODE ) ! Wet Second Moment Final Array
      REAL( 8 ) :: M3WET_FINAL( N_MODE ) ! Wet Third Moment Final Array

C *** Outputs from HCOND3: size-dependent term in the condensational-growth 
C     expressions defined in Equations A13-A14 of [Binkowski & Shankar,1995]
      REAL( 8 ) :: FCONC_SO4( N_MODE,2 )  ! All sizes 2nd and 3rd moments
      REAL( 8 ) :: FCONC_OUT( 2 )         ! Output for HCOND3, 2nd and 3rd moments
      REAL( 8 ) :: FCONCM1_SO4       ! reciprocals of total SO4 cond rates

C *** Modal partition factors [ dimensionless ]
C     defined in Equations A17-A18 of [Binkowski & Shankar,1995]
      REAL( 8 ) :: OMEGA_AT_SO4  ! Aitken mode 2nd and 3rd moments
      REAL( 8 ) :: OMEGA_AC_SO4  ! Accumulation mode 2nd and 3rd moments
      REAL( 8 ) :: OMEGA( 2 )    ! partitioning coefficient for equilibrium PM mass
      REAL( 8 ) :: PHI( NINORG,2 ) ! Mass Fraction of each component in each aerosol mode
      REAL( 8 ) :: TOTAER( NINORG )! Total aerosol component across multiple modes 

C *** Variables for new particle formation:
      REAL XH2SO4            ! steady state H2SO4 concentration
      REAL( 8 ) :: DMDT_SO4  ! particle mass production rate [ ug/m**3 s ]
      REAL( 8 ) :: DNDT      ! particle number production rate [ # / m**3 s ]
      REAL( 8 ) :: DM2DT     ! second moment production rate [ m**2 / m**3 s]
      REAL( 8 ) :: SCONDRATE ! SO4 condensation rate [ ug/m**3 s ]

C *** Mode-specific sulfate production rate [ ug/m**3 s ]
      REAL( 8 ) :: CONDSO4( N_MODE )    ! sulfate condensation rate [ ug/m**3 s ]
      REAL( 8 ) :: RATE                 ! CONDSO4 or cond+nucl rate

C *** Size-dependent portion of mass-transfer rate equation
      REAL( 8 ) :: GRFAC1( N_MODE )     ! 2nd moment [ m**2/m**3-s ] 
      REAL( 8 ) :: GRFAC2( N_MODE )     ! 3rd moment [ m**3/m**3-s ] 
      
C *** ISORROPIA input variables
      REAL( 8 ) :: WI( NINORG - 1 )     ! species array [ mol/m**3 ]
      REAL( 8 ) :: RHI                  ! relative humidity [ fraction ]
      REAL( 8 ) :: TEMPI                ! temperature   [ deg K]
      REAL( 8 ) :: CNTRL( 2 )           ! ISOROPIA control parameters 

C *** ISORROPIA output variables
      REAL( 8 ) :: WT( NINORG - 1 )     ! species output array (unused)
      REAL( 8 ) :: GAS( 3 )             ! gas-phase   "     " 
      REAL( 8 ) :: AERLIQ( 15 )         ! liq aerosol "     " 
      REAL( 8 ) :: AERSLD( 19 )         ! solid "     "     "  (unused)
      REAL( 8 ) :: OTHER( 9 )           ! supplmentary output array (unused)
      CHARACTER( 15 ) :: SCASI          ! subcase number output (unused)

C *** Variables to account for mass conservation violations in ISRP3F
!     LOGICAL TRUSTNH4                  ! false if ISOROPIA's partitioning
                                        !  of NH4/NH3 is to be ignored
      LOGICAL TRUSTCL                   ! false if ISOROPIA's partitioning       
                                        !  of Cl/HCl is to be ignored

C *** Initial (double-precision) concentrations [ug/m3]
      REAL( 8 ) :: GNH3R8               ! gas-phase ammonia
      REAL( 8 ) :: GNO3R8               ! gas-phase nitric acid
      REAL( 8 ) :: GCLR8                ! gas-phase hydrochloric acid

C *** Variables for volatile species mass transfer between gas and aerosol and
C     mass partitioning between the modes 
      LOGICAL HYBRID ! mass transfer option flag (mass transfer if .TRUE.)
      REAL( 8 ) :: DELT                 ! time step DT [s]
      REAL( 8 ) :: HPLUS( N_MODE )      ! scratch var for H+ [umol/m**3]

      REAL( 8 ), SAVE :: H2SO4RATM1     ! Mol. wt. ratio of SO4/H2SO4

      REAL( 8 ) :: DVOLINORG( NVOLINORG ) ! vol inorg spcs mass to be xferred [mol/m3]
      REAL( 8 ) :: DVOLMAX                ! max value for DVOLINORG 
      REAL( 8 ) :: CINORG( NINORG,N_MODE ) ! scratch array for inorg spcs [ug/m**3]
      REAL( 8 ) :: SEACAT                 ! coarse sea-salt cations [ug/m**3]
      REAL( 8 ) :: SOILwVOLS              ! windblown dust before removal of
                                          ! SO4,NO3,CL,H2O [ug/m**3]
      REAL( 8 ) :: PMCwVOLS               ! anthrop coarse material before removal
                                          ! of SO4,NO3,CL,H2O [ug/m**3]
      REAL( 8 ) :: INT_TIME               ! internal mass transfer time (s)
      REAL( 8 ) :: TSTEP                  ! mass transfer time step [s]
      REAL( 8 ) :: DRYM20, Y              ! scratch vars for 2nd moment [m**2/m**3]
      REAL( 8 ) :: M3OTHR                 ! vars for 3rd moment calculation [m**3/m**3]
      REAL( 8 ), SAVE :: DF( NVOLINORG )  ! scratch array for mole -> ug conversion
      REAL( 8 ), SAVE :: DFH2OR8          ! mole -> ug conversion for H2O
      REAL( 8 ) :: J( NVOLINORG )         ! condensation/evaporation flux [mol/m**3-s]
      REAL( 8 ) :: CFINAL( NVOLINORG,N_MODE ) ! conc after mass xfer step [ug/m**3]
      REAL( 8 ) :: H2O                    ! Scratch LWC variable for output
      REAL( 8 ) :: H2O_NEW                ! Update of LWC after condensation 
      REAL( 8 ) :: SO4                    ! modal SO4 after condensation or cond + nucl
      REAL( 8 ) :: DDRYM3DT               ! rate of 3rd moment transfer - dry inorg spcs
      REAL( 8 ) :: DDRYM2DT               ! rate of 2nd moment transfer -  "     "    "
      REAL( 8 ) :: DRYM3, WETM3           ! scratch vars for 3rd moment calc [m**3/m**3]
      REAL( 8 ) :: DRYM2, WETM2           ! scratch vars for 2nd moment calc [m**2/m**3]
      REAL( 8 ) :: LOSS                   ! rate of loss of second moment [1/s] 
      REAL( 8 ) :: EQLBHIJ                ! H+ concentration from isoropia for I plus J-modes [ug/m**3]

      REAL( 8 ) :: DELNUM( N_MODE ) ! Change in Number due to some process
      REAL( 8 ) :: DELSRF( N_MODE ) ! Change in Surface Area due to some process
      REAL( 8 ) :: DELSO4( N_MODE ) ! Change in Sulfate due to some process
      REAL( 8 ) :: DELNO3( N_MODE ) ! Change in Nitrate due to some process
      REAL( 8 ) :: DELNH4( N_MODE ) ! Change in Ammonium due to some process
      REAL( 8 ) :: DELCL( N_MODE )  ! Change in Chloride due to some process
      REAL( 8 ) :: DELH2O( N_MODE ) ! Change in Water due to some process
      REAL( 8 ) :: DELH3OP( N_MODE )! Change in Proton due to some process
      REAL( 8 ) :: CBUDGET0_NUM( N_MODE ) ! Initial Number before some process
      REAL( 8 ) :: CBUDGET0_SRF( N_MODE ) ! Initial Surface Area before some process
      REAL( 8 ) :: CBUDGET0_SO4( N_MODE ) ! Initial Sulfate before some process
      REAL( 8 ) :: CBUDGET0_NO3( N_MODE ) ! Initial Nitrate before some process
      REAL( 8 ) :: CBUDGET0_NH4( N_MODE ) ! Initial Ammonium before some process
      REAL( 8 ) :: CBUDGET0_CL( N_MODE )  ! Initial Chloride before some process
      REAL( 8 ) :: CBUDGET0_H2O( N_MODE ) ! Initial Particle Water before some process
      REAL( 8 ) :: CBUDGET0_H3OP( N_MODE )! Initial Proton before some process

      REAL( 8 ) :: TMP
      INTEGER I, N                        ! loop and array indices
      INTEGER IMODE                       ! mode loop index  
      INTEGER ISTEP                       ! loop index, mass transfer time step loop
      INTEGER ISP                         ! loop index, species loop
      LOGICAL TrustIso                    ! For negative vap. press., TrustIso = F

C *** Local Saved Variables 
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      LOGICAL, SAVE :: FIRSTWRITE = .TRUE.
      REAL( 8 ), SAVE :: SO4FAC         !  F6DPIM9 / RHOSO4
      REAL( 8 ), SAVE :: SOILFAC        !  F6DPIM9 / RHOSOIL
      REAL( 8 ), SAVE :: ANTHFAC        !  F6DPIM9 / RHOANTH
      REAL( 8 ), SAVE :: H2SO4RAT       ! Mol. wt ratios H2SO4/SO4
      REAL( 8 ), SAVE :: NH3RAT         ! Mol. wt ratios NH3/NH4
      REAL( 8 ), SAVE :: HNO3RAT        ! Mol. wt ratios HNO3/NO3
      REAL( 8 ), SAVE :: HCLRAT         ! Mol. wt ratios HCL/CL 
      REAL( 8 ), SAVE :: MWH2SO4        ! molecular weight for H2SO4
      REAL( 8 ), SAVE :: FAERH2SO4      ! 1e-6 / mw(h2so4)

      REAL( 8 ), SAVE :: CFAC_ANA
      REAL( 8 ), SAVE :: CFAC_ASO4
      REAL( 8 ), SAVE :: CFAC_ANH4
      REAL( 8 ), SAVE :: CFAC_ANO3
      REAL( 8 ), SAVE :: CFAC_ACL
      REAL( 8 ), SAVE :: CFAC_ACA
      REAL( 8 ), SAVE :: CFAC_AK
      REAL( 8 ), SAVE :: CFAC_AMG
      REAL( 8 ), SAVE :: CFAC_ASEACAT
      REAL( 8 ), SAVE :: CFAC_GNH3
      REAL( 8 ), SAVE :: CFAC_GHNO3
      REAL( 8 ), SAVE :: CFAC_GHCL

      REAL( 8 ), SAVE :: M3FAC_ANA
      REAL( 8 ), SAVE :: M3FAC_ASO4
      REAL( 8 ), SAVE :: M3FAC_ANH4
      REAL( 8 ), SAVE :: M3FAC_ANO3
      REAL( 8 ), SAVE :: M3FAC_ACL
      REAL( 8 ), SAVE :: M3FAC_H2O


      logical, save :: write1 = .true.

C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
      
         FIRSTIME = .FALSE.
#ifdef noiso
         write( logdev,* ) 'aero_subs, volinorg: noiso'
#endif

         CFAC_ANA  = 1.0D-6 / REAL( AEROSPC_MW( ANA_IDX ), 8 )
         CFAC_ASO4 = 1.0D-6 / REAL( AEROSPC_MW( ASO4_IDX ), 8 )
         CFAC_ANH4 = 1.0D-6 / REAL( AEROSPC_MW( ANH4_IDX ), 8 )
         CFAC_ANO3 = 1.0D-6 / REAL( AEROSPC_MW( ANO3_IDX ), 8 )
         CFAC_ACL  = 1.0D-6 / REAL( AEROSPC_MW( ACL_IDX ), 8 )
         CFAC_ACA  = 1.0D-6 / REAL( AEROSPC_MW( ACA_IDX ), 8 )
         CFAC_AK   = 1.0D-6 / REAL( AEROSPC_MW( AK_IDX ), 8 )
         CFAC_AMG  = 1.0D-6 / REAL( AEROSPC_MW( AMG_IDX ), 8 )
         CFAC_ASEACAT = 1.0D-6 / REAL( AEROSPC_MW( ASEACAT_IDX ), 8 )
         CFAC_GNH3 = 1.0D-6 / PRECURSOR_MW( NH3_IDX )
         CFAC_GHNO3= 1.0D-6 / PRECURSOR_MW( HNO3_IDX )
         CFAC_GHCL = 1.0D-6 / PRECURSOR_MW( HCL_IDX )

         M3FAC_ANA  = 1.0D-9 * F6DPI / REAL( AEROSPC( ANA_IDX )%DENSITY, 8 )
         M3FAC_ASO4 = 1.0D-9 * F6DPI / REAL( AEROSPC( ASO4_IDX )%DENSITY, 8 )
         M3FAC_ANH4 = 1.0D-9 * F6DPI / REAL( AEROSPC( ANH4_IDX )%DENSITY, 8 )
         M3FAC_ANO3 = 1.0D-9 * F6DPI / REAL( AEROSPC( ANO3_IDX )%DENSITY, 8 )
         M3FAC_ACL  = 1.0D-9 * F6DPI / REAL( AEROSPC( ACL_IDX )%DENSITY, 8 )
         M3FAC_H2O  = 1.0D-9 * F6DPI / REAL( AEROSPC( AH2O_IDX )%DENSITY, 8 )

         MWH2SO4 = PRECURSOR_MW( SULF_IDX ) ! molecular weight for H2SO4
         FAERH2SO4 = 1.0E-6 / MWH2SO4

         COFCBAR_SO4 = SQRT( 8.0 * RGASUNIV / ( PI * REAL( MWH2SO4,4 ) * 1.0E-3 ) )
         H2SO4RATM1 = AEROSPC_MW( ASO4_IDX ) / MWH2SO4
         SO4FAC  = 1.0D-9 * F6DPI / REAL( AEROSPC( ASO4_IDX )%DENSITY, 8 )
         SOILFAC = 1.0D-9 * F6DPI / REAL( AEROSPC( ASOIL_IDX )%DENSITY, 8 )
         ANTHFAC = 1.0D-9 * F6DPI / REAL( AEROSPC( ACORS_IDX )%DENSITY, 8 )

         DF( KNH4 ) = 1.0D0 / CFAC_ANH4
         DF( KNO3 ) = 1.0D0 / CFAC_ANO3
         DF( KCL )  = 1.0D0 / CFAC_ACL
         DFH2OR8    = 1.0D6 * MWWAT      ! aerospc_mw(AH2O_IDX) (18.0 != 18.0153)

         ! Mol. wt ratios H2SO4/SO4, NH3/NH4, HNO3/NO3, HCL/CL
         H2SO4RAT= PRECURSOR_MW( SULF_IDX ) / REAL( AEROSPC_MW( ASO4_IDX ), 8 )
         NH3RAT  = PRECURSOR_MW( NH3_IDX )  / REAL( AEROSPC_MW( ANH4_IDX ), 8 )
         HNO3RAT = PRECURSOR_MW( HNO3_IDX ) / REAL( AEROSPC_MW( ANO3_IDX ), 8 )
         HCLRAT  = PRECURSOR_MW( HCL_IDX )  / REAL( AEROSPC_MW( ACL_IDX ), 8 )
      END IF

C *** Determine if Hybrid
      TMP = 0.0
#ifdef noiso
      hybrid = .false.
#else
      DO I = 1, N_AEROSPC
         IF(  AEROSPC( I )%tracer )CYCLE
         IF ( AEROSPC( I )%CHARGE .NE. 0 ) TMP = TMP + AEROSPC_CONC( I,N_MODE )
      END DO
      HYBRID = ( TMP .GE. CUTOFF ) .AND. ( AIRRH .GE. 0.18 )
#endif

      DELT  = REAL( DT, 8 )
      TEMPI = AIRTEMP             ! assume const within synch timestep
      RHI   = MIN( 0.95, AIRRH )  ! "        "     "      "     "

C *** Calculate molecular velocities (temperature dependent) and
C     H+ concentration

      CBAR_SO4 = COFCBAR_SO4 * SQRT( AIRTEMP )

      HPLUS = 0.0
      DO I = 1, N_MODE
         DO N = 1, N_AEROSPC
            IF(  AEROSPC( N )%tracer )CYCLE
            HPLUS( I ) = HPLUS( I )
     &                 - AEROSPC( N )%CHARGE * AEROSPC_CONC( N,I ) / AEROSPC_MW( N )
         END DO
      END DO

C *** Condensational Growth (Size-dependent terms)
C     Calculate intermediate variables needed to determine the 2nd and
C     3rd moment condensational-growth rates.  3rd moment terms are 
C     needed for the calculation of new particle production.  See 
C     Section 3.3 of Jiang & Roth (2003) for a detailed discussion.
C    
C *** Set moments using Equation 4 of Binkowski & Shankar
C     (1995) or Equation 3 of Binkowski and Roselle (2003).
C     N.B: these are for a "wet" size distribution

      DO I = 1, N_MODE
         AM0( I ) = MOMENT0_CONC( I ) 
         AM1( I ) = MOMENT0_CONC( I ) * AEROMODE_DIAM( I )
     &            * EXP( 0.5 * AEROMODE_LNSG( I ) * AEROMODE_LNSG( I ) )
         AM2( I ) = MOMENT2_CONC( I )
      END DO
      
C *** Calculate the size-dependent terms in the condensational-
C     growth factor expressions for sulfate using 
C     Equations A13-A14 of Binkowski & Shankar (1995). 
       
      DO I = 1, N_MODE
         CALL HCOND3( AM0( I ), AM1( I ), AM2( I ),
     &                DV_SO4, ALPHSULF, CBAR_SO4, FCONC_OUT )
         FCONC_SO4( I, : ) = FCONC_OUT( : )
      END DO 

      IF ( .NOT. HYBRID ) THEN
         FCONC_SO4( N_MODE,1 ) = 0.0D0
         FCONC_SO4( N_MODE,2 ) = 0.0D0
      END IF

      DO I = 1, N_MODE
         GRFAC1( I ) = FCONC_SO4( I,1 )
         GRFAC2( I ) = FCONC_SO4( I,2 )
      END DO

C *** New Particle Production
C     Calculate the new particle production rate due to binary
C     nucleation of H2O and H2SO4.  These calculations are performed 
C     only when the gas-phase production rate of H2SO4 (i.e., SO4RATE) 
C     is non-zero.  The condensation rate of H2SO4 is calculated as the
C     gas-phase production rate minus the new particle production rate.

C *** Initialize Variables
      DMDT_SO4  = 0.0D0
      DNDT      = 0.0D0
      DM2DT     = 0.0D0
      SCONDRATE = 0.0D0

C *** Produce new particles only during time steps when the gas-phase 
C     production rate of H2SO4 is non-zero

      IF ( SO4RATE .NE. 0.0D0 ) THEN

C *** Adjust sulfuric acid vapor concentration to a value in
C     equilibrium with the production of new particles and the
C     condensation of sulfuric acid vapor on existing particles, based 
C     on Equations A21 and A23 of Binkowski & Shankar (1995).
         TMP = 0.0
         DO I = 1, N_MODE
            TMP = TMP + FCONC_SO4( I,2 )
         END DO

         XH2SO4 = SO4RATE / REAL( TMP,4 )
         XH2SO4 = MAX( XH2SO4, CONMIN )
         PRECURSOR_CONC( SULF_IDX ) = REAL( XH2SO4, 8 )

C *** Calculate new particle production rate for 0th, 2nd, & 3rd moments
         CALL NEWPART3 ( AIRRH, AIRTEMP, XH2SO4, SO4RATE,
     &                   DNDT, DMDT_SO4, DM2DT )
         
C *** Calculate sulfate condensation rate as the gas-phase production 
C     rate minus the new particle production rate, following Equation
C     3.23 of Jiang & Roth (2003).
         SCONDRATE = MAX( SO4RATE - DMDT_SO4, 0.0D0 )

! *** Propagate NPF Change to budget variables
         NPF_BUDGET( PRECURSOR_MAP( SULF_IDX ) ) = -DMDT_SO4 
     &             * H2SO4RAT  * DELT ! ug m-3 of Sulfuric Acid
                                      ! (converted to ppmv in update_precursor)
         NPF_BUDGET( AEROSPC_MAP( ASO4_IDX,1 ) ) =  DMDT_SO4 * DELT ! ug m-3
         NPF_BUDGET( AERONUM_MAP( 1 ) ) =  DNDT * DELT  ! N m-3
         NPF_BUDGET( AEROSRF_MAP( 1 ) ) =  DM2DT * DELT ! m2 m-3

      END IF   ! SO4RATE .NE. 0

C *** Sulfate Condensation (Size-resolved)
C     Calculate rate at which condensing sulfate should be added to each
C     mode.  The "omega" factors are defined in Equations 7a and 7b of
C     Binkowski & Shankar (1995). The i-mode and j-mode factors are 
C     calculated using Equation A17 of Binkowski & Shankar (1995). The 
C     condensation rate for accumulation mode (fine-equilibrium scheme) or 
C     coarse mode (hybrid and dynamic schemes) is computed by difference, 
C     to avoid mass conservation violations arising from numerical error.
      TMP = 0.0
      DO I = 1, N_MODE
         TMP = TMP + FCONC_SO4( I,2 )
      END DO

      FCONCM1_SO4  = 1.0D0 / TMP
      OMEGA_AT_SO4 = FCONCM1_SO4 * FCONC_SO4( 1,2 )
      OMEGA_AC_SO4 = FCONCM1_SO4 * FCONC_SO4( 2,2 )

C *** Growth values for mode merge condition
      CGR( 1 ) = SO4FAC * SCONDRATE * OMEGA_AT_SO4
      CGR( 2 ) = SO4FAC * SCONDRATE * OMEGA_AC_SO4

! *** Initialize Budget Counter Variables         
      CBUDGET0_NUM( : ) = MOMENT0_CONC( : )
      CBUDGET0_NUM( 1 ) = CBUDGET0_NUM( 1 ) + DNDT * DELT
      CBUDGET0_SRF( : ) = MOMENT2_CONC( : )
      CBUDGET0_SRF( 1 ) = CBUDGET0_SRF( 1 ) + DM2DT * DELT
      CBUDGET0_SO4( : ) = AEROSPC_CONC( ASO4_IDX, : )
      CBUDGET0_SO4( 1 ) = CBUDGET0_SO4( 1 ) + DMDT_SO4 * DELT
      CBUDGET0_NO3( : ) = AEROSPC_CONC( ANO3_IDX, : )
      CBUDGET0_NH4( : ) = AEROSPC_CONC( ANH4_IDX, : )
      CBUDGET0_CL ( : ) = AEROSPC_CONC( ACL_IDX , : )
      CBUDGET0_H2O( : ) = AEROSPC_CONC( AH2O_IDX, : )
      CBUDGET0_H3OP( : )= AEROSPC_CONC( AH3OP_IDX, : )

! *** Diagnose Condensaiton Sink to Each Mode
      CONDSO4( 1 ) = OMEGA_AT_SO4 * SCONDRATE      
      
      IF ( HYBRID ) THEN 
         CONDSO4( 2 ) = OMEGA_AC_SO4 * SCONDRATE      
         CONDSO4( 3 ) = SCONDRATE - ( CONDSO4( 1 ) + CONDSO4( 2 ) ) 
      ELSE                                  ! fine equilibrium
         CONDSO4( 2 ) = SCONDRATE - CONDSO4( 1 )
         CONDSO4( 3 ) = 0.0D0               ! no coarse mode chemistry
      END IF

C *** For Hybrid approach, calculate dynamic mass trasfer for
C     semi-volatile components of coarse mode (NO3, CL, NH4)  

      IF ( HYBRID ) THEN 

         CNTRL( 1 ) = 1.0D0 ! reverse problem
         CNTRL( 2 ) = 1.0D0 ! aerosol in metastable state

         INT_TIME = 0.0D0
         TSTEP    = 90.0D0
         ISTEP    = 1
         IMODE    = 3
         TrustIso = .TRUE.
 
         DO WHILE ( INT_TIME .LT. DELT ) 

            IF ( INT_TIME + TSTEP .GT. DELT ) TSTEP = DELT - INT_TIME 
            INT_TIME = INT_TIME + TSTEP 
            ISTEP = ISTEP + 1   

C *** Calculate first moments using Equation 4 of Binkowski & Shankar
C     (1995) or Equation 3 of Binkowski and Roselle (2003).
C     N.B: these are for a "wet" size distribution
            AM0( IMODE ) = MOMENT0_CONC( IMODE )
            AM1( IMODE ) = MOMENT0_CONC( IMODE ) * AEROMODE_DIAM( IMODE )
     &                  * EXP( 0.5 * AEROMODE_LNSG( IMODE ) * AEROMODE_LNSG( IMODE ) )
            AM2( IMODE ) = MOMENT2_CONC( IMODE )

C *** Calculate the size-dependent terms in the condensational-
C     growth factor expressions for sulfate using 
C     Equations A13-A14 of Binkowski & Shankar (1995). 
            CALL HCOND3( AM0( IMODE ), AM1( IMODE ), AM2( IMODE ), DV_SO4, ALPHSULF, 
     &                      CBAR_SO4, FCONC_OUT )  ! adapted from Eq A14
            FCONC_SO4( IMODE, : ) = FCONC_OUT( : )

            GRFAC1( IMODE ) = FCONC_SO4( IMODE,1 ) 
            GRFAC2( IMODE ) = FCONC_SO4( IMODE,2 ) 

C *** Set conc array to aerosol concentrations prior to mass transfer
C     (The _RENORM and cation_FAC constants are set in the AERO_DATA module)

            SEACAT    = REAL( AEROSPC_CONC( ASEACAT_IDX,IMODE ), 8 )              
            SOILwVOLS = REAL( AEROSPC_CONC( ASOIL_IDX,IMODE ), 8 ) / ASOIL_RENORM 
            PMCwVOLS  = REAL( AEROSPC_CONC( ACORS_IDX,IMODE ), 8 ) / ACORSEM_RENORM 

            CINORG( KNH4,IMODE ) = REAL( AEROSPC_CONC( ANH4_IDX,IMODE ), 8 )  ! KNH4 = 1, ANH4_IDX = 4
            CINORG( KNO3,IMODE ) = REAL( AEROSPC_CONC( ANO3_IDX,IMODE ), 8 )  ! KNO3 = 2, ANO3_IDX = 2
            CINORG( KCL, IMODE ) = REAL( AEROSPC_CONC( ACL_IDX,IMODE ), 8 )   ! KCL = 3, ACL_IDX = 3
            CINORG( KSO4,IMODE ) = REAL( AEROSPC_CONC( ASO4_IDX,IMODE ), 8 )  ! KSO4 = 4, ASO4_IDX = 1
            CINORG( KNA, IMODE ) = ASCAT_NA_FAC * SEACAT                      ! KNA = 5
     &                           + ASOIL_NA_FAC * SOILwVOLS
     &                           + ACORS_NA_FAC * PMCwVOLS
            CINORG( KMG, IMODE ) = ASCAT_MG_FAC * SEACAT                      ! KMG = 6
     &                           + ASOIL_MG_FAC * SOILwVOLS
     &                           + ACORS_MG_FAC * PMCwVOLS
            CINORG( KK,  IMODE ) = ASCAT_K_FAC  * SEACAT                      ! KK = 7
     &                           + ASOIL_K_FAC  * SOILwVOLS
     &                           + ACORS_K_FAC  * PMCwVOLS
            CINORG( KCA, IMODE ) = ASCAT_CA_FAC * SEACAT                      ! KCA = 8
     &                           + ASOIL_CA_FAC * SOILwVOLS
     &                           + ACORS_CA_FAC * PMCwVOLS
            CINORG( KHP, IMODE ) = REAL( HPLUS( IMODE ), 8 )                  ! KHP = 9

            M3OTHR = SOILFAC * AEROSPC_CONC( ASOIL_IDX,IMODE )
     &             + ANTHFAC * AEROSPC_CONC( ACORS_IDX,IMODE )
            WETM3  = MOMENT3_CONC( IMODE )
            WETM2  = MOMENT2_CONC( IMODE )
            DRYM3  = WETM3 - REAL( H2OFAC * AEROSPC_CONC( AH2O_IDX, IMODE ), 8 )  ! Assume no SOA in coarse mode
            DRYM20 = WETM2 * ( DRYM3 / WETM3 ) ** D_TWOTHIRDS

C *** Initial vapor-phase concentrations [ug/m3]
            GNO3R8 = PRECURSOR_CONC( HNO3_IDX )
            GNH3R8 = PRECURSOR_CONC( NH3_IDX )
            GCLR8  = PRECURSOR_CONC( HCL_IDX )

C *** Compute sulfate production rate [ug/m3 s] for coarse mode

            RATE = CONDSO4( IMODE )
            SO4  = CINORG( KSO4,IMODE ) + RATE * TSTEP * H2SO4RATM1

            IF ( TrustIso ) THEN

C *** Double Precision vars for ISORROPIA [mole/m3]
C              Compute equilibrium vapor pressures [mol/m3] of NH3, HNO3, and HCL
C              at the gas/particle interface of coarse mode aerosol.
C                 GAS(1) = NH3, GAS(2) = HNO3, GAS(3) = HCl
               WI( 1 ) = CINORG( KNA, IMODE ) * CFAC_ANA
               WI( 2 ) =                  SO4 * CFAC_ASO4
               WI( 3 ) = CINORG( KNH4,IMODE ) * CFAC_ANH4
               WI( 4 ) = CINORG( KNO3,IMODE ) * CFAC_ANO3
               WI( 5 ) = CINORG( KCL, IMODE ) * CFAC_ACL
               WI( 6 ) = CINORG( KCA, IMODE ) * CFAC_ACA
               WI( 7 ) = CINORG( KK,  IMODE ) * CFAC_AK
               WI( 8 ) = CINORG( KMG, IMODE ) * CFAC_AMG
C              Also obtain the aqueous H+ concentration, AERLIQ(1) [mol/m3]

#ifdef verbose_aero
         if ( write1 ) then
         write( logdev,'(a, 8e13.3)' ) "VOLINORG,WI's C:",
     &                                  wi( 1 ), wi( 2 ), wi( 3 ), wi( 4 ),
     &                                  wi( 5 ), wi( 6 ), wi( 7 ), wi( 8 )
         write( logdev,* ) "VOLINORG,RH,T:", rhi, tempi
         end if
#endif

               CALL ISOROPIA( WI, RHI, TEMPI, CNTRL, WT, GAS, AERLIQ,  
     &                        AERSLD, SCASI, OTHER )

               IF ( GAS( 1 ) .LT. 0.0D0 .OR. GAS( 2 ) .LT. 0.0D0 .OR.
     &              GAS( 3 ) .LT. 0.0D0 ) THEN
                  IF ( FIRSTWRITE ) THEN
                     FIRSTWRITE = .FALSE.
                     WRITE( LOGDEV,2023 )
                  END IF
                  WRITE( LOGDEV,2029 ) COL, ROW, LAYER, GAS( 1 ), GAS( 2 ), GAS( 3 )
                  TrustIso = .FALSE.
               END IF

            END IF   ! TrustIso

C *** Change in volatile inorganic PM concentration to achieve
C     equilibrium, calculated as initial-gas-phase concentration minus 
C     equilibrium gas-phase concentration.  DVOLINORG is positive for
C     condensation and negative for evaporation.

#ifdef verbose_aero
         if ( write1 ) then
         write( logdev,'(a, 3e13.3)' ) "GASes:", gas( 1 ), gas( 2 ), gas( 3 )

         dvolinorg( knh4 ) = gnh3r8 * CFAC_GNH3  - gas( 1 )  ! [mol/m**3]
         dvolinorg( kno3 ) = gno3r8 * CFAC_GHNO3 - gas( 2 )  ! [mol/m**3]
         dvolinorg( kcl )  = gclr8  * CFAC_GHCL  - gas( 3 )  ! [mol/m**3]
           
         write( logdev,'(a, 3e13.3)' ) "DVOLINORG_coarse:",
     &      dvolinorg( knh4 ) / ( gnh3r8 * CFAC_GNH3 ),
     &      dvolinorg( kno3 ) / ( gno3r8 * CFAC_GHNO3),
     &      dvolinorg( kcl )  / ( gclr8  * CFAC_GHCL )
         end if
#endif

C *** Calculate condensation/evaporation flux for this time step and update 
C     volatile species concentrations.  Final aerosol conc set to be no less
C     than the minimum aerosol conc.
            IF ( TrustIso ) THEN
               CALL COMPUTE_FLUX( NVOLINORG, GNH3R8, GNO3R8, GCLR8, KNH4,
     &                            KNO3, KCL, GAS( 1:3 ), GRFAC2( IMODE ),
     &                            AERLIQ( 1 ), RATE, J )
            ELSE
               J( : ) = 0.0D0
            END IF 

            IF ( J( KNH4 ) * TSTEP * DF( KNH4 ) * NH3RAT .GT. GNH3R8 ) THEN
               WRITE( LOGDEV,* ) 'Condensed amt. exceeds NH3 conc: aero_subs.f'
               J( KNH4 ) = GNH3R8 / ( TSTEP * DF( KNH4 ) * NH3RAT )
            END IF
            IF ( J( KNO3 ) * TSTEP * DF( KNO3 ) * HNO3RAT .GT. GNO3R8 ) THEN
               WRITE( LOGDEV,* ) 'Condensed amt. exceeds HNO3 conc: aero_subs.f'
               J( KNO3 ) = GNO3R8 / ( TSTEP * DF( KNO3 ) * HNO3RAT )
            END IF
            IF ( J( KCL ) * TSTEP * DF(KCL) * HCLRAT .GT. GCLR8 ) THEN
               WRITE( LOGDEV,* ) 'Condensed amt. exceeds HCl conc: aero_subs.f'
               J( KCL ) = GCLR8 / ( TSTEP * DF( KCL ) * HCLRAT )
            END IF

C *** Integrate mass transfer equation, convert flux from molar to mass

            DO ISP = 1, NVOLINORG
               CFINAL( ISP,IMODE ) = MAX( 0.0D0,
     &                                    CINORG( ISP,IMODE )
     &                                    + J( ISP ) * TSTEP * DF( ISP ) )
            END DO               

C *** Calculate updated H+ concentration 

            HPLUS( IMODE ) = 0.0
     &                     - AEROSPC( ASO4_IDX )%CHARGE * SO4                  / AEROSPC_MW( ASO4_IDX )
     &                     - AEROSPC( ANO3_IDX )%CHARGE * CFINAL( KNO3,IMODE ) / AEROSPC_MW( ANO3_IDX )
     &                     - AEROSPC( ACL_IDX )%CHARGE  * CFINAL( KCL, IMODE ) / AEROSPC_MW( ACL_IDX )
     &                     - AEROSPC( ANH4_IDX )%CHARGE * CFINAL( KNH4,IMODE ) / AEROSPC_MW( ANH4_IDX )
!    &                     - AEROSPC( ANA_IDX )%CHARGE  * CINORG( KNA, IMODE ) / AEROSPC_MW( ANA_IDX )
     &                     - AEROSPC( ASEACAT_IDX )%CHARGE  * CINORG( KNA, IMODE ) / AEROSPC_MW( ASEACAT_IDX )
     &                     - AEROSPC( AMG_IDX )%CHARGE  * CINORG( KMG, IMODE ) / AEROSPC_MW( AMG_IDX )
     &                     - AEROSPC( AK_IDX )%CHARGE   * CINORG( KK,  IMODE ) / AEROSPC_MW( AK_IDX )
     &                     - AEROSPC( ACA_IDX )%CHARGE  * CINORG( KCA, IMODE ) / AEROSPC_MW( ACA_IDX )

C *** Equilibrate aerosol LWC with CFINAL by calling CALC_H2O
            WI( 1 ) = CINORG( KNA, IMODE ) * CFAC_ASEACAT
            WI( 2 ) =                  SO4 * CFAC_ASO4
            WI( 3 ) = CFINAL( KNH4,IMODE ) * CFAC_ANH4
            WI( 4 ) = CFINAL( KNO3,IMODE ) * CFAC_ANO3
            WI( 5 ) = CFINAL( KCL, IMODE ) * CFAC_ACL
            WI( 6 ) = CINORG( KCA, IMODE ) * CFAC_ACA
            WI( 7 ) = CINORG( KK,  IMODE ) * CFAC_AK
            WI( 8 ) = CINORG( KMG, IMODE ) * CFAC_AMG

            CALL CALC_H2O( WI, RHI, TEMPI, H2O_NEW ) 

            H2O = H2O_NEW * DFH2OR8 

C *** Update all Local Aerosol Mass and Vapor Concentrations 
            !Aerosol
            AEROSPC_CONC( ANH4_IDX,IMODE ) = REAL( CFINAL( KNH4,IMODE ),4 )
            AEROSPC_CONC( ANO3_IDX,IMODE ) = REAL( CFINAL( KNO3,IMODE ),4 )
            AEROSPC_CONC( ACL_IDX,IMODE )  = REAL( CFINAL( KCL, IMODE ),4 )
            AEROSPC_CONC( ASO4_IDX,IMODE ) = REAL( SO4,4 )
            AEROSPC_CONC( AH2O_IDX,IMODE ) = REAL( H2O,4 )

            !Gas
            PRECURSOR_CONC( NH3_IDX ) = GNH3R8 + ( CINORG( KNH4,IMODE )
     &                                 -CFINAL( KNH4,IMODE ) ) * NH3RAT 
            PRECURSOR_CONC( HNO3_IDX )= GNO3R8 + ( CINORG( KNO3,IMODE )
     &                                 -CFINAL( KNO3,IMODE) ) * HNO3RAT  
            PRECURSOR_CONC( HCL_IDX ) = GCLR8 + ( CINORG( KCL,IMODE )
     &                                 -CFINAL( KCL,IMODE) ) * HCLRAT 
 
C *** Compute net change in 3rd moment due to dry inorganic mass transfer

            DDRYM3DT = ( ( CFINAL( KNH4,IMODE ) - CINORG( KNH4,IMODE ) ) * M3FAC_ANH4
     &                 + ( CFINAL( KNO3,IMODE ) - CINORG( KNO3,IMODE ) ) * M3FAC_ANO3
     &                 + ( CFINAL( KCL, IMODE ) - CINORG( KCL,IMODE ) )  * M3FAC_ACL
     &                 + ( SO4                  - CINORG( KSO4,IMODE ) ) * M3FAC_ASO4 ) / TSTEP

C *** Compute net change in 2nd moment due to dry inorganic mass transfer
C     (including nucleation) using equation A7 of Binkowski & Shankar (1995)
            DDRYM2DT = D_TWOTHIRDS * GRFAC1( IMODE ) / GRFAC2( IMODE ) * DDRYM3DT   

C *** Update dry 2nd moment for condensation/evaporation based on whether
C     net change in dry 2nd moment is production or loss
            IF ( DDRYM2DT .LT. 0.0D0 ) THEN
               LOSS = DDRYM2DT / DRYM20
               Y = DRYM20 * EXP( LOSS * TSTEP )
            ELSE
               Y = DRYM20 + DDRYM2DT * TSTEP
            END IF

C *** Add water (no SOA) 2nd moment while preserving standard deviation

            !Calculate 3rd Moment
            DRYM3 = ( M3FAC_ASO4 ) * SO4
     &            + M3FAC_ANH4 * CFINAL( KNH4,IMODE )
     &            + M3FAC_ANO3 * CFINAL( KNO3,IMODE )
     &            + M3FAC_ACL  * CFINAL( KCL,IMODE )
     &            + M3FAC_ANA  * SEACAT
     &            + M3OTHR                   
            WETM3 = DRYM3 + H2O * M3FAC_H2O

            !Calculate 2nd moment
            DRYM2 = MAX( REAL( AEROMODE_MINM2( IMODE ), 8 ), Y )
            WETM2 = DRYM2 * ( WETM3 / DRYM3 ) ** D_TWOTHIRDS

            MOMENT2_CONC( IMODE ) = REAL( WETM2,4 )

C *** Update the third moments, geometric mean diameters, geometric 
C     standard deviations, modal mass totals, and modal particle 
C     densities. It is a waste of time updating the aitken and
C     accumulation modes but the coarse mode does need to be updated
C     each sub-time step. This should be for the wet distribution
               
            CALL GETPAR( .TRUE. )

         END DO   ! end mass transfer time step loop
         
      END IF   ! for 'Hybrid' method

      write1 = .false.
C *** End of Coarse Mode dynamic mass transfer calculations

C *** Fine Aerosol Modes: Call ISORROPIA in forward mode to calculate gas-particle equilibrium
      !Get Precursors Vapor concentrations [ug m-3]
      GNH3R8 = PRECURSOR_CONC( NH3_IDX )   
      GNO3R8 = PRECURSOR_CONC( HNO3_IDX )  
      GCLR8  = PRECURSOR_CONC( HCL_IDX )

C *** Diagnose all total gas+particle concentrations to passed to
C     ISORROPIA. Convert everything to [mol m-3].
      WI( 1 ) = SUM( AEROSPC_CONC( ANA_IDX,1:2 ))   * CFAC_ANA
      !Compute sulfate from total sulfate production rate [ug/m3-s] for fine 
      !modes; add in H2SO4 nucleated in model timestep
      WI( 2 ) = ( SUM( AEROSPC_CONC( ASO4_IDX,1:2 ) ) 
     &           +( DMDT_SO4 + SUM( CONDSO4( 1:2 ) ) ) * DELT * H2SO4RATM1 ) * CFAC_ASO4
      WI( 3 ) = PRECURSOR_CONC( NH3_IDX )  * CFAC_GNH3
     &         +SUM( AEROSPC_CONC( ANH4_IDX,1:2 ) ) * CFAC_ANH4 
      WI( 4 ) = PRECURSOR_CONC( HNO3_IDX ) * CFAC_GHNO3
     &         +SUM( AEROSPC_CONC( ANO3_IDX,1:2 ) ) * CFAC_ANO3 
      WI( 5 ) = PRECURSOR_CONC( HCL_IDX )  * CFAC_GHCL 
     &         +SUM( AEROSPC_CONC( ACL_IDX,1:2 ) )  * CFAC_ACL 
      WI( 6 ) = SUM( AEROSPC_CONC( ACA_IDX,1:2 ) )  * CFAC_ACA 
      WI( 7 ) = SUM( AEROSPC_CONC( AK_IDX,1:2 ) )   * CFAC_AK 
      WI( 8 ) = SUM( AEROSPC_CONC( AMG_IDX,1:2 ) )  * CFAC_AMG 

      CNTRL( 1 ) = 0.0D0   ! Forward Problem
      CNTRL( 2 ) = 1.0D0   ! Aerosol in Metastable State

C *** Set flags to account for mass conservation violations in ISRP3F
      TRUSTCL  = .TRUE.
      IF ( (WI( 1 ) + WI( 5 )) .LT. 1.0D-20 .or. WI( 5 ) .LT. 1.0D-10 ) THEN
         TRUSTCL = .FALSE.
      END IF
         
#ifndef noiso
      CALL ISOROPIA( WI, RHI, TEMPI, CNTRL, WT, GAS, AERLIQ,
     &               AERSLD, SCASI, OTHER )

C *** Save H+ concentration information in microgram/m3 for consistency
      EQLBHIJ = AERLIQ(1) * 1.0D6 * AEROSPC_MW( ah3op_idx)

#else
      gas( 1 ) = real( precursor_conc( nh3_idx ),  8 ) * CFAC_GNH3
      gas( 2 ) = real( precursor_conc( hno3_idx ), 8 ) * CFAC_GHNO3
      gas( 3 ) = real( precursor_conc( hcl_idx ),  8 ) * CFAC_GHCL

      EQLBHIJ =  HPLUS( 1 ) + HPLUS( 2 )  ! use charge balance if lacking isoropia info 

#endif

C *** Change in volatile inorganic PM concentration to achieve
C     equilibrium, calculated as initial-gas-phase concentration minus 
C     equilibrium gas-phase concentration.  DVOLINORG is positive for
C     condensation and negative for evaporation.
      DVOLINORG( KNH4 ) = GNH3R8 * CFAC_GNH3  - GAS( 1 )   ! mol m-3
      DVOLINORG( KNO3 ) = GNO3R8 * CFAC_GHNO3 - GAS( 2 )   ! mol m-3
      DVOLINORG( KCL )  = GCLR8  * CFAC_GHCL  - GAS( 3 )   ! mol m-3

      IF ( DVOLINORG( KNH4 ) .LT. 0.0D0 ) THEN
         DVOLMAX = -SUM(REAL( AEROSPC_CONC( ANH4_IDX,1:2 ), 8 ) ) * CFAC_ANH4 + EVAPMIND
         DVOLINORG( KNH4 ) = MAX( DVOLINORG( KNH4 ), DVOLMAX )
      END IF

      IF ( DVOLINORG( KNO3 ) .LT. 0.0D0 ) THEN
         DVOLMAX = -SUM(REAL( AEROSPC_CONC( ANO3_IDX,1:2 ), 8 ) ) * CFAC_ANO3 + EVAPMIND
         DVOLINORG( KNO3 ) = MAX( DVOLINORG( KNO3 ), DVOLMAX)
      END IF

      IF ( .not.TRUSTCL ) THEN  
         DVOLINORG( KCL ) = 0.0D0
      ELSEIF ( DVOLINORG( KCL ) .LT. 0.0D0 ) THEN
         DVOLMAX = -SUM(REAL( AEROSPC_CONC( ACL_IDX,1:2 ), 8 ) ) * CFAC_ACL + EVAPMIND
         DVOLINORG( KCL ) = MAX( DVOLINORG( KCL ), DVOLMAX )
      END IF

C *** Apply modal partitioning of equilibrium aerosol mass
      ! Calculate Distribution of Mass Transfer Among Modes
      OMEGA( 1 ) = GRFAC2( 1 ) / ( GRFAC2( 1 ) + GRFAC2( 2 ) )
      OMEGA( 2 ) = 1.0D0 - OMEGA( 1 )

      ! Save Initial Concentrations
      DO IMODE = 1, 2  
         CINORG( KSO4,IMODE ) = AEROSPC_CONC( ASO4_IDX, IMODE )
         CINORG( KNH4,IMODE ) = AEROSPC_CONC( ANH4_IDX, IMODE )
         CINORG( KNO3,IMODE ) = AEROSPC_CONC( ANO3_IDX, IMODE )
         CINORG( KNA, IMODE ) = AEROSPC_CONC( ANA_IDX,  IMODE )
         CINORG( KCL, IMODE ) = AEROSPC_CONC( ACL_IDX,  IMODE )
         CINORG( KCA, IMODE ) = AEROSPC_CONC( ACA_IDX,  IMODE )
         CINORG( KK,  IMODE ) = AEROSPC_CONC( AK_IDX,   IMODE )
         CINORG( KMG, IMODE ) = AEROSPC_CONC( AMG_IDX,  IMODE )
      END DO

      ! Calculate Initial Distribution of Mass Composition Among Modes
      DO ISP = 1, NVOLINORG
         TOTAER( ISP ) = MAX( SUM( CINORG( ISP,1:2 ) ), CONMIND )
         DO IMODE = 1, 2
            PHI( ISP, IMODE ) = CINORG( ISP,IMODE ) / TOTAER( ISP )
         ENDDO
      ENDDO

      ! Initialize Final Concentrations
      CFINAL = 0.0

      ! Calculate Final Concentrations
      DO ISP = 1, NVOLINORG
         IF ( DVOLINORG( ISP ) .LT. 0.0 ) THEN
            ! Evaporate Mass Using Condensed-Phase Fraction in each Mode
            CFINAL( ISP,1:2 ) = CFINAL( ISP,1:2 ) + CINORG( ISP,1:2 )
     &                        + PHI( ISP,1:2 ) * DVOLINORG( ISP ) * DF( ISP )
         ELSE
            ! Condense Mass Using Condensation Sink Factors
            CFINAL( ISP,1:2 ) = CFINAL( ISP,1:2 ) + CINORG( ISP,1:2 )
     &                        + OMEGA( 1:2 ) * DVOLINORG( ISP ) * DF( ISP )
         END IF
      END DO

C *** Apply Final Concentrations to Moment Variables in Aerosol Scheme
      ! Store Initial Wet Moments
      M3WET_INIT( : ) = MOMENT3_CONC( : )
      M2WET_INIT( : ) = MOMENT2_CONC( : )

      ! Calculate and Store Initial Dry Moments and set wet_moments_flag to false/dry
      ! There has not yet been an update to AEROSPC_CONC so this will
      ! calculate the old 3rd moment.
      call calcmoments( .false. )
      M3DRY_INIT( : ) = MOMENT3_CONC( : )
      M2DRY_INIT( : ) = MOMENT2_CONC( : )

      DO IMODE = 1, 2  ! modal partitioning of equilibrium aerosol mass

         IF ( IMODE .EQ. 1 ) THEN
            ! Update Number Concentration with NPF
            MOMENT0_CONC( IMODE ) = REAL( AM0(IMODE) + DNDT * DELT, 4 )
            ! Add NPF to total condensation rate
            RATE = DMDT_SO4 + CONDSO4( IMODE )
            SO4 = CINORG( KSO4,IMODE ) + RATE * DELT * H2SO4RATM1 
         ELSE
            ! Ignore NPF. The small particles are not in these modes
            SO4 = CINORG( KSO4,IMODE ) + CONDSO4( IMODE ) * DELT * H2SO4RATM1
         END IF

C *** Double precision vars for CALC_H2O
         WI( 1 ) = CINORG( KNA, IMODE ) * CFAC_ANA
         WI( 2 ) =                  SO4 * CFAC_ASO4
         WI( 3 ) = CFINAL( KNH4,IMODE ) * CFAC_ANH4
         WI( 4 ) = CFINAL( KNO3,IMODE ) * CFAC_ANO3
         WI( 5 ) = CFINAL( KCL, IMODE ) * CFAC_ACL
         WI( 6 ) = CINORG( KCA, IMODE ) * CFAC_ACA
         WI( 7 ) = CINORG( KK,  IMODE ) * CFAC_AK
         WI( 8 ) = CINORG( KMG, IMODE ) * CFAC_AMG

         CALL CALC_H2O( WI, RHI, TEMPI, H2O_NEW ) 
         
         ! Update All Aerosol Concentrations
         AEROSPC_CONC( AH2O_IDX, IMODE ) = REAL( H2O_NEW * DFH2OR8, 4 )
         AEROSPC_CONC( ANH4_IDX, IMODE ) = REAL( CFINAL( KNH4,IMODE ),4 )
         AEROSPC_CONC( ANO3_IDX, IMODE ) = REAL( CFINAL( KNO3,IMODE ),4 )
         AEROSPC_CONC( ACL_IDX, IMODE )  = REAL( CFINAL( KCL ,IMODE ),4 )
         AEROSPC_CONC( ASO4_IDX, IMODE ) = REAL( SO4,4 )

C *** Compute net change in 3rd moment due to dry inorganic mass transfer
C     (includes nucleated sulfate mass). This is for projecting the
C     change to the second moment due to dry inorganic condensation
         
         DDRYM3DT = ( ( CFINAL( KNH4,IMODE ) - CINORG( KNH4,IMODE ) ) * M3FAC_ANH4
     &              + ( CFINAL( KNO3,IMODE ) - CINORG( KNO3,IMODE ) ) * M3FAC_ANO3
     &              + ( CFINAL( KCL, IMODE ) - CINORG( KCL,IMODE ) )  * M3FAC_ACL
     &              + ( SO4                  - CINORG( KSO4,IMODE ) ) * M3FAC_ASO4 ) 
     &              / DELT 

C *** Compute net change in 2nd moment due to dry inorganic mass transfer
C     (including nucleation) using equation A7 of Binkowski & Shankar (1995)
         DDRYM2DT = D_TWOTHIRDS * GRFAC1( IMODE ) / GRFAC2( IMODE ) * DDRYM3DT

C *** Update dry 2nd moment for condensation/evaporation based on whether
C     net change in dry 2nd moment is production or loss
         IF ( DDRYM2DT .LT. 0.0D0 ) THEN
            LOSS = DDRYM2DT / M2DRY_INIT( IMODE )
            Y = M2DRY_INIT( IMODE ) * EXP( LOSS * DELT )
         ELSE
            Y = M2DRY_INIT( IMODE ) + DDRYM2DT * DELT
         END IF
         moment2_conc( IMODE ) = REAL( MAX( REAL( AEROMODE_MINM2( IMODE ), 8 ), Y ),4 )

      END DO

C *** Add water and SOA to 2nd moment while preserving standard deviation
      call calcmoments( .true. )
      M3WET_FINAL = moment3_conc
      M2WET_FINAL = moment2_conc

C *** Assign H+ Concentration to each Mode
      HPLUS( 1:2 ) = 0.0
      DO I = 1, N_AEROSPC
         IF(  AEROSPC( I )%tracer )CYCLE
         HPLUS( 1:2 ) = HPLUS( 1:2 )
     &                  - AEROSPC( I )%CHARGE * AEROSPC_CONC( I,1:2 ) / AEROSPC_MW( I )
      END DO

      H2O = AEROSPC_CONC( AH2O_IDX, 1 ) + AEROSPC_CONC( AH2O_IDX, 2 )
      IF(  H2O .GT. CONMIN )THEN
          H2O = 1.0 / H2O
          AEROSPC_CONC( AH3OP_IDX, 1:2 ) = REAL( EQLBHIJ * H2O, 4 ) * AEROSPC_CONC( AH2O_IDX, 1:2 ) 
      ELSE
          AEROSPC_CONC( AH3OP_IDX, 1:2 ) = CONMIN
      END IF
      AEROSPC_CONC( AH3OP_IDX, 3 ) = REAL( HPLUS( 3 ),4 ) * AEROSPC_MW( ah3op_idx ) ! Coarse mode H+ concentration in ug/m3

C *** Update the third moments, geometric mean diameters, geometric 
C     standard deviations, modal mass totals, and modal particle 
C     densities. Note that moment2_conc needs to be up to date when this
C     routine is called. Moment3_conc does not need to be up to date
C     because it will be recalculated inside GETPAR as the sum of 
C     aerospc_conc variables. This should be for the wet distribution.
      CALL GETPAR( .TRUE. )
       
! *** Propagate Concentration Changes from Coarse-Mode Mass
! *** Transfer to Budget Vectors
      DELNUM( : )  = MOMENT0_CONC( : ) - CBUDGET0_NUM( : )
      DELSRF( : )  = MOMENT2_CONC( : ) - CBUDGET0_SRF( : )
      DELSO4( : )  = AEROSPC_CONC( ASO4_IDX, : ) - CBUDGET0_SO4( : )
      DELNH4( : )  = AEROSPC_CONC( ANH4_IDX, : ) - CBUDGET0_NH4( : )
      DELNO3( : )  = AEROSPC_CONC( ANO3_IDX, : ) - CBUDGET0_NO3( : )
      DELCL( : )   = AEROSPC_CONC( ACL_IDX , : ) - CBUDGET0_CL( : )
      DELH2O( : )  = AEROSPC_CONC( AH2O_IDX, : ) - CBUDGET0_H2O( : )
      DELH3OP( : ) = AEROSPC_CONC( AH3OP_IDX,: ) - CBUDGET0_H3OP( : )

      COND_BUDGET( AERONUM_MAP( : ) ) = REAL( DELNUM( : ), 4 )
      COND_BUDGET( AEROSRF_MAP( : ) ) = REAL( DELSRF( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ASO4_IDX,: ) ) = REAL( DELSO4( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ANH4_IDX,: ) ) = REAL( DELNH4( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ANO3_IDX,: ) ) = REAL( DELNO3( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( ACL_IDX ,: ) ) = REAL( DELCL( : ) , 4 )
      COND_BUDGET( AEROSPC_MAP( AH2O_IDX,: ) ) = REAL( DELH2O( : ), 4 )
      COND_BUDGET( AEROSPC_MAP( AH3OP_IDX,:) ) = REAL( DELH3OP( : ),4 )

      COND_BUDGET( PRECURSOR_MAP( SULF_IDX ) ) = SUM( REAL( -DELSO4(:) * H2SO4RAT, 4 ))
      COND_BUDGET( PRECURSOR_MAP( NH3_IDX  ) ) = SUM( REAL( -DELNH4(:) * NH3RAT  , 4 ))
      COND_BUDGET( PRECURSOR_MAP( HNO3_IDX ) ) = SUM( REAL( -DELNO3(:) * HNO3RAT , 4 ))
      COND_BUDGET( PRECURSOR_MAP( HCL_IDX  ) ) = SUM( REAL( -DELCL(:)  * HCLRAT  , 4 ))

 
C *** Update gas-phase concentrations from Aitken and Accumulation Mode Partitioning
      PRECURSOR_CONC( NH3_IDX )  = GNH3R8 + sum( CINORG( KNH4,1:2 )
     &                            -CFINAL( KNH4,1:2 ) ) * NH3RAT 
      PRECURSOR_CONC( HNO3_IDX ) = GNO3R8 + sum( CINORG( KNO3,1:2 )
     &                            -CFINAL( KNO3,1:2) ) * HNO3RAT  
      PRECURSOR_CONC( HCL_IDX )  = GCLR8 + sum( CINORG( KCL,1:2 )
     &                            -CFINAL( KCL,1:2) ) * HCLRAT 
         
2023  FORMAT( 1X, 'VOLINORG returning negative gas concentrations from ISOROPIA:'
     &       /10X, 'GAS(1) = NH3, GAS(2) = HNO3, GAS(3) = HCl' )
2029  FORMAT( 1X, '[see VOLINORG msg]'
     &        1X, 'at (C,R,L): ', 3I4, 1X, 'GAS Conc:', 3( 1PE11.3 ) )

      RETURN
      END SUBROUTINE VOLINORG

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HCOND3( AM0, AM1, AM2, DV, ALPHA, CBAR, F )

C  calculates the size-dependent term in the condensational-growth rate
C  expression for the 2nd and 3rd moments of a lognormal aerosol mode
C  using the harmonic mean method.  This code follows Section A2 of
C  Binkowski & Shankar (1995).
 
C  Key Subroutines/Functions called:  none
 
C  Revision History:
C     coded November 7, 2003 by Dr. Francis S. Binkowski
C     Revised November 20, 2003 by F. Binkowski to have am1 and
C     am2 as inputs
 
C  Reference:
C   1. Binkowski, F.S. and U. Shankar, The regional particulate matter
C      model 1. Model description and preliminary results, J. Geophys.
C      Res., Vol 100, No D12, 26101-26209, 1995.

      IMPLICIT NONE

C *** Includes:

      INCLUDE SUBST_CONST     ! physical and mathematical constants

C *** Arguments:

      REAL( 8 ), INTENT( IN ) :: AM0   ! zeroth moment of mode  [ #/m**3 ]
      REAL( 8 ), INTENT( IN ) :: AM1   ! first moment of mode   [ m/m**3 ]
      REAL( 8 ), INTENT( IN ) :: AM2   ! second moment of mode  [ m**2/m**3 ]
      REAL,      INTENT( IN ) :: Dv    ! molecular diffusivity of the
                                       ! condensing vapor  [ m**2/s ]
      REAL,      INTENT( IN ) :: ALPHA ! accommodation coefficient
      REAL,      INTENT( IN ) :: CBAR  ! kinetic velocity of condensing vapor [ m/s ]

      REAL( 8 ), INTENT( OUT ) :: F( 2 ) ! size-dependent term in condensational-growth
                                         ! rate: F(1) = 2nd moment [ m**2/m**3 s ]
                                         !       F(2) = 3rd moment [ m**3/m**3 s ]

C *** Local Variables:

      REAL( 8 ) :: GNC2 ! integrals used to calculate F(1) [m^2 / m^3 s]
      REAL( 8 ) :: GFM2 !

      REAL( 8 ) :: GNC3 ! integrals used to calculate F(2) [m^3 / m^3 s]
      REAL( 8 ) :: GFM3 !

      REAL( 8 ), PARAMETER :: TWOPI = 2.0D0 * PI
      REAL( 8 ), PARAMETER :: PI4 = 0.25D0 * PI

C-----------------------------------------------------------------------

C *** Implement equation A15 of Binkowski & Shankar (1995) for the
C     2nd and 3rd moments of a lognormal mode of arbitrary size.

      GNC2 = TWOPI * DV * AM0          ! 2nd moment, near-continuum
      GNC3 = TWOPI * DV * AM1          ! 3rd moment, near-continuum
      GFM2 = PI4 * ALPHA * CBAR * AM1  ! 2nd moment, free-molecular
      GFM3 = PI4 * ALPHA * CBAR * AM2  ! 3rd moment, free-molecular

C *** Implement equation A13 of Binkowski & Shankar (1995) for a
C     lognormal mode of arbitrary size.  These are the size-dependent
C     terms in the condensational-growth rate expression, given in
C     equation 7a of B&S (1995).

      F( 1 ) = GNC2 * GFM2 / ( GNC2 + GFM2 )  ! 2nd moment
      F( 2 ) = GNC3 * GFM3 / ( GNC3 + GFM3 )  ! 3rd moment

      RETURN
      END SUBROUTINE HCOND3

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE NEWPART3 ( RH, T, XH2SO4, SO4RATE, DNDT, DMDT_so4, DM2DT )

      USE AERO_DATA
      USE AEROMET_DATA   ! Includes CONST.EXT
      USE PRECURSOR_DATA, ONLY: PRECURSOR_MW, SULF_IDX
      USE UTILIO_DEFN
      
      IMPLICIT NONE

C   REVISION HISTORY:
C     Replacement of Kulmala et al., 1998 nucleation scheme with scheme 
C     of Vehkamaki et al. (2002) by G. Sarwar and K. Fahey - 03/2014

C.. References:
C     Vehkamaki, H., Kulmala, M, Napari, I., Lehtinen, K.E.J., Timmreck, C.,
C     Noppel, M., and A. Laaksonen. (2002) An improved parameterization for 
C     sulfuric acid-water nucleation rates for tropospheric and stratospheric
C     conditions.  JGR, v107(D22).    
   
C..Inputs: 
      REAL, INTENT(IN ) :: RH              ! fractional relative humidity      
      REAL, INTENT(IN)  :: T               ! Ambient temperature [ K ]
      REAL, INTENT(IN)  :: XH2SO4          ! sulfuric acid concentration [ ug/m**3 ]
      REAL, INTENT(IN)  :: SO4RATE         ! gas-phase H2SO4 production rate [ ug/m**3 s ]

C.. Outputs:
      REAL( 8 ), INTENT( OUT ) :: DNDT     ! particle number production rate [ m^-3/s ]
      REAL( 8 ), INTENT( OUT ) :: DMDT_so4 ! SO4 mass production rate [ ug/m**3 s ]
      REAL( 8 ), INTENT( OUT ) :: DM2DT    ! second moment production rate [ m**2/m**3 s ]

C.. Parameters
      CHARACTER( 16 ), PARAMETER :: PNAME = 'NEWPART'                 

C.. Particle size parameters:
      REAL, PARAMETER :: d20 = 2.0E-07                ! diameter of a new particle [cm]
      REAL, PARAMETER :: d20sq = d20 * d20            ! new-particle diameter squared [cm**2]
      REAL, PARAMETER :: m2_20 = 1.0E-4 * d20sq       ! new-particle diameter squared [m**2]
      REAL, PARAMETER :: v20 = PI * d20 * d20sq /6.0  ! volume of a new particle [cm**3]
      
      REAL( 8 )       :: sulfmass                     ! mass of a new particle [ug]
      REAL( 8 )       :: sulfmass1                    ! inverse of sulfmass [ug**-1]

C.. Set constants and local variables for Vehkamaki et al. (2002) scheme
      REAL, PARAMETER :: C1 = 0.740997
      REAL, PARAMETER :: C2 = -0.00266379
      REAL, PARAMETER :: C3 = -0.00349998
      REAL, PARAMETER :: C4 = 0.0000504022
      REAL, PARAMETER :: C5 = 0.00201048
      REAL, PARAMETER :: C6 = -0.000183289
      REAL, PARAMETER :: C7 = 0.00157407
      REAL, PARAMETER :: C8 = -0.0000179059
      REAL, PARAMETER :: C9 = 0.000184403
      REAL, PARAMETER :: C10 = -1.50345E-6

      REAL :: XSTAR           ! mole fraction of sulfuric acid in the critical cluster
      REAL :: NA              ! total gas phase concentration of H2SO4  [ #/cm**3 ]
      REAL :: TEMP            ! ambient temperature
      REAL :: LNRH, LNNA      ! LN(RH), LN(Na)
      REAL :: LNRH2, LNNA2    ! LN(RH)**2, LN(Na)**2
      REAL :: LNRH3, LNNA3    ! LN(RH)**3, LN(Na)**3  
      REAL :: TEMP2, TEMP3    ! TEMP**2, TEMP**3
      REAL( 8 ) :: XFAC       ! exponential term for the nucleation rate  
      REAL( 8 ) :: Jnuc       ! nucleation rate [ #/cm**3 s ]
      
      REAL :: A, B, C, D, E, F, G, H, I, J

      REAL :: MW_H2SO4        ! MW of H2SO4 in [ g / mole ]        
      REAL :: DENSITY_H2SO4   ! DENSITY of H2SO4 in [ kg / m**3 ]

      REAL, PARAMETER :: SCALEFAC = 1.0E-06           ! for [ 1 / m**3 ] ->  [ 1 / cm**3 ]
      REAL, PARAMETER :: MUG2G = 1.0E-6               ! [ ug  ] -> [ g ]                 

C.. Initialize variables
      DNDT     = 0.0D0
      DMDT_so4 = 0.0D0
      DM2DT    = 0.0D0

C.. Calculate molecular weight of H2SO4 [ g / mole ] 
      MW_H2SO4 = REAL( PRECURSOR_MW( SULF_IDX ),4 )
         
C.. Calculate density of sulfuric acid [ kg / m**3 ] 
      DENSITY_H2SO4 = AEROSPC( ASO4_IDX )%DENSITY           

C.. Calculate mass of a new particle [ug]
      sulfmass = 1.0D+3 * DENSITY_H2SO4 * v20

C.. Calculate inverse of sulfmass [ug**-1]      
      sulfmass1 = 1.0D0 / sulfmass   
     
C.. Calculate sulfuric acid concentration in molecules/cm3 
      NA = XH2SO4 * MUG2G * AVO * SCALEFAC / MW_H2SO4     

C.. The parameterization is valid at sulfuric acid concentrations of 1.0E4 - 1.0E11 molecules cm-3
      NA  = MAX (NA, 1.0E4)
      NA  = MIN (1.0E11, NA)

C.. The parameterization is valid at temperatures of 190.00-305.15 K
      TEMP = MAX (T, 190.00)
      TEMP = MIN (305.15, TEMP)

C.. The parameterization is valid at RH of 0.0001-1.0
C   aero_driver.f limits RH to 0.005-0.99; thus no additional constraint is needed

C.. Define convenient constants
      TEMP2 = TEMP * TEMP
      TEMP3 = TEMP * TEMP2
      
      LNRH = LOG( RH )  
      LNNA = LOG( NA )
      LNRH2 = LNRH * LNRH
      LNRH3 = LNRH * LNRH2
      LNNA2 = LNNA * LNNA
      LNNA3 = LNNA * LNNA2

C.. Calculate mole fraction of sulfuric acid in the critical cluster
      XSTAR = C1 + C2 * TEMP + C3 * LNNA + C4 * TEMP * LNNA + 
     &      C5 * LNRH + C6 * TEMP * LNRH +
     &      C7 * LNRH2 + C8 * TEMP * LNRH2 + C9 * LNRH3 + 
     &      C10 * TEMP * LNRH3

C.. Calculate coefficients needed for the nucleation rate [Eq-12 - Vehkamaki et al., 2002]           
      A = 0.14309 + 2.21956 * TEMP - 0.0273911 * TEMP2 + 
     &      0.0000722811 * TEMP3 + 5.91822 / XSTAR
     
      B = 0.117489 + 0.462532 * TEMP - 0.0118059 * TEMP2 + 
     &      0.0000404196 * TEMP3 + 15.7963 / XSTAR
     
      C = -0.215554 - 0.0810269 * TEMP + 0.00143581 * TEMP2 - 
     &      4.7758E-6 * TEMP3 - 2.91297 / XSTAR
     
      D = -3.58856 + 0.049508 * TEMP - 0.00021382 * TEMP2 + 
     &      3.10801E-7 * TEMP3 - 0.0293333 / XSTAR
     
      E = 1.14598 - 0.600796 * TEMP + 0.00864245 * TEMP2 - 
     &      0.0000228947 * TEMP3 - 8.44985 / XSTAR
     
      F = 2.15855 + 0.0808121 * TEMP - 0.000407382 * TEMP2 - 
     &      4.01957E-7 * TEMP3 + 0.721326 / XSTAR

      G = 1.6241 - 0.0160106 * TEMP + 0.0000377124 * TEMP2 + 
     &      3.21794E-8 * TEMP3 - 0.0113255 / XSTAR
      
      H = 9.71682 - 0.115048 * TEMP + 0.000157098 * TEMP2 + 
     &      4.00914E-7 * TEMP3 + 0.71186 / XSTAR
     
      I = -1.05611 + 0.00903378 * TEMP - 0.0000198417 * TEMP2 +
     &      2.46048E-8 * TEMP3 - 0.0579087 / XSTAR

      J = -0.148712 + 0.00283508 * TEMP - 9.24619E-6 * TEMP2 + 
     &      5.00427E-9 * TEMP3 - 0.0127081 / XSTAR

C.. Calculate the exponential term for the nucleation rate [Eq-12 - Vehkamaki et al., 2002] 
      XFAC = A + B * LNRH + C * LNRH2 + D * LNRH3 + 
     &      E * LNNA + F * LNRH * LNNA + G * LNRH2 * LNNA +     
     &      H * LNNA2 + I * LNRH * LNNA2 + J * LNNA3

C.. Calculate particle nucleation rate: unit [ 1 / cm**3 s] [Eq-12 - Vehkamaki et al., 2002] 
      Jnuc = EXP(XFAC)  
      
C.. The parameterization is valid for nucleation rates of 1.0E-7-1.0E10 [ 1 / cm**3 s]
      Jnuc = MAX (Jnuc, 1.0D-7)
      Jnuc = MIN (1.0D10, Jnuc)

C.. Convert the unit of particle nucleation rate into [ 1 / m**3 s] by multiplying it by 1.0E6  
       DNDT = Jnuc * 1.0E06  ! (1/(m**3 s))

C.. Calculate mass production rate [ ug / (m**3 s) ] analogous to
C   Equation 6a of Binkowski & Roselle (2003). Set the upper limit
C   of the mass production rate as the gas-phase production rate of
C   H2SO4, and adjust the number production rate accordingly.
      DMDT_so4 = sulfmass * DNDT 

      IF ( DMDT_so4 .GT. SO4RATE ) THEN
         DMDT_so4 = SO4RATE
         DNDT = DMDT_SO4 * sulfmass1
      END IF

C.. Calculate the production rate of 2nd moment [ m**2 / (m**3 s) ]
C   This is similar to Equation 6c of Binkowski & Roselle (2003),
C   except the factor of PI is removed and the assumed particle
C   diameter is different.
      DM2DT = DNDT * m2_20

      RETURN    
      END SUBROUTINE NEWPART3 

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE Compute_Flux ( nvolinorg, GNH3R8, GNO3R8, GCLR8, KNH4,
     &                          KNO3, KCL, Ceq, CondRate, Hplus, rate, J )
 
C Description
C   Determines the evaporative/condensational flux of volatile
C   inorganic species to aerosol modes. In cases where the resulting H+
C   flux is greater than a specified limit, the Pilinis et al. (2000)
C   AS&T approach is used to modify species vapor pressures such that
C   cond./evap. produces an H+ flux equal to the limit (which is
C   proportional to the current mode concentration of H+).
C   Routine called by VOLINORG.
 
C Arguments
C   Inputs
C     nvolinorg: Number of Volatile inorganic species
C     GNH3R8   : NH3(g) concentration (ug/m3)
C     GNO3R8   : HNO3(g) concentration (ug/m3)
C     GCLR8    : HCl(g) concentration (ug/m3)
C     KNH4     : Index to NH4 species
C     KNO3     : Index to NO3 species
C     KCL      : Index to NO3 species 
C     Ceq      : vapor concentration (mol/m3)
C     CondRate : effective condensation rate (I) of 3rd moment to mode
C              : [treat units as (1/s)]
C     Hplus    : aerosol hydrogen ion concentration (mol/m3) for mode
C     rate     : H2SO4(g) condensation rate (ug/m3/s) for mode
 
C   Output
C     Ceq      : modified vapor concentration (mol/m3)
C     J        : molar cond./evap. flux of volatile inorganics (mol/m3-s)
 
C-----------------------------------------------------------------------

      USE AERO_DATA
      USE PRECURSOR_DATA
      USE AEROMET_DATA

      IMPLICIT NONE

C     Arguments:
      INTEGER      nvolinorg
      REAL( 8 ) :: GNH3R8, GNO3R8, GCLR8 ! gas concentrations [ug/m3]
      INTEGER      KNH4, KNO3, KCL       ! Indices to species
      REAL( 8 ) :: Ceq( nvolinorg )      ! vapor concentrations [mol/m3]
      REAL( 8 ) :: CondRate              ! effective condensation rate (I) for 3rd moment
      REAL( 8 ) :: Hplus                 ! hydrogen ion concentration for mode [mol/m3]
      REAL( 8 ) :: rate
      REAL( 8 ) :: J( nvolinorg )        ! molar cond./evap. flux [mol/m3-s]

C     Local Variables:
      REAL( 8 ),  PARAMETER :: Afact = 1.0D-01  ! factor for H+ limiter
      REAL( 8 ),  PARAMETER :: small = 1.0D-25
      REAL( 8 ) :: Cinf( nvolinorg ) ! gas concentration in mol/m3
      REAL( 8 ) :: Qk              ! factor for modifying vapor press. based on H+ limit
      REAL( 8 ) :: Hflux           ! flux of H+ to mode from cond/evap
      REAL( 8 ) :: Hlim            ! maximum allowable H+ flux to mode
      REAL( 8 ) :: aa, bb, cc      ! terms in quadratic equation
      REAL( 8 ) :: JH2SO4          ! molar flux of H2SO4(g) [mol/m3/s]
      REAL( 8 ) :: CH2SO4          ! effective H2SO4(g) concentration [mol/m3]
      INTEGER      isp             ! inorganic species index

C-----------------------------------------------------------------------

C     Convert gas concentration from ug/m3 to mol/m3
      Cinf( KNH4 ) = GNH3R8 * 1.0D-6 / PRECURSOR_MW( NH3_IDX )
      Cinf( KNO3 ) = GNO3R8 * 1.0D-6 / PRECURSOR_MW( HNO3_IDX )
      Cinf( KCL )  = GCLR8  * 1.0D-6 / PRECURSOR_MW( HCL_IDX )

C     Calculate cond/evap fluxes (no H+ limiting)
      DO isp = 1, nvolinorg
         J( isp ) = CondRate * ( Cinf( isp ) - Ceq( isp ) )
      END DO

C     Convert rate to mol/m3/s and get effective Cinf for H2SO4(g)
      JH2SO4  = rate * 1.0D-6 / PRECURSOR_MW( SULPRD_IDX )
      CH2SO4  = JH2SO4 / CondRate

C     Limit H+ flux (Pilinis et al., 2000, AS&T). Note: J is flux
C     to entire mode, not one particle
      Hlim  = Afact * Hplus
      Hflux = 2.0D0 * JH2SO4 + J( KNO3 ) + J( KCL ) - J( KNH4 )

C     If Hflux is too large, limit the flux by modifying species
C     vapor pressures with Qk factor (Pilinis et al., 2000, AS&T).
      IF ( ABS( Hflux ) .GT. Hlim ) THEN
         Hlim = SIGN( Hlim, Hflux )

C        Solve quadratic for Qk: aa*Qk^2 + bb*Qk + cc = 0
         aa = Ceq( KCL ) + Ceq( KNO3 )

         bb = Hlim / CondRate
     &      + Cinf( KNH4) - Cinf( KNO3 ) - Cinf( KCL ) - 2.0D0 * CH2SO4
         cc = -Ceq( KNH4 )

         Qk = 0.0D0 ! initialize Qk

         IF ( aa .LT. small .AND. 0.0D0 .LT. bb ) THEN ! bb*Qk + cc = 0
            Qk = -cc / bb
         ELSE IF (aa .LT. small .AND. bb .LE. 0.0D0 ) THEN
            Qk = 0.0D0
         ELSE IF (-cc .LT. small .AND. bb .LT. 0.0D0 ) THEN  ! aa*Qk^2 + bb*Qk = 0
            Qk = -bb / aa
         ELSE IF (-cc .LT. small .AND. 0.0D0 .LE. bb ) THEN
            Qk = 0.0D0
         ELSE
            Qk = ( -bb + SQRT ( bb**2 - 4.0D0 * aa * cc ) ) / ( 2.0D0 * aa )
            IF ( bb ** 2 - 4.0D0 * aa * cc .LT. 0.0D0 ) THEN
               PRINT *, 'Compute_Flux, sqrt<0'
               Qk = 0.0D0
            END IF
         END IF

C     Modify vapor pressures and get new fluxes
         IF ( Qk .GT. small ) THEN
            Ceq( KNH4 ) = Ceq( KNH4 ) / Qk
            Ceq( KNO3 ) = Ceq( KNO3 ) * Qk
            Ceq( KCl )  = Ceq( KCl )  * Qk
            DO isp = 1, nvolinorg
               J( isp ) = CondRate * ( Cinf( isp ) - Ceq( isp ) )
            END DO
         END IF

      END IF   ! |Hflux| > Hlim

      END SUBROUTINE Compute_Flux

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CALC_H2O ( WI, RH, T, H2O_NEW )

C Description
C   Calculate the water content of aerosol at the new time step.  Water
C   calculations use the ZSR mixing rule with salts determined by the
C   ISORROPIA approach.
C   Routine called by VOLINORG.
 
C Arguments
C   Input
C     WI      : Concentration of components [mol/m^3] at new step
C     RH      : Relative humidity [0-1]
C     T       : Temperature [K]
 
C   Output
C     H2O_NEW : Water [mol/m^3] content at new time step
 
C-----------------------------------------------------------------------

      IMPLICIT NONE

C Parameters:
      INTEGER, PARAMETER :: NCMP = 8, NPAIR = 23
      REAL( 8 ),  PARAMETER :: SMALL = 1.0D-20
      REAL( 8 ),  PARAMETER :: Mw = 0.018D0   ! molar mass H2O (kg/mol)

C Arguments:
      REAL( 8 ), INTENT( IN )  :: WI( NCMP )
      REAL( 8 ), INTENT( IN )  :: RH, T
      REAL( 8 ), INTENT( OUT ) :: H2O_NEW

C Local Variables:
      CHARACTER( 3 ) :: SC ! subcase for composition
      REAL( 8 ) :: FSO4, FNH4, FNA, FNO3, FCL ! "free" ion amounts
      REAL( 8 ) :: FCA, FK, FMG            
      REAL( 8 ) :: CASO4         ! amount of calcium sulfate, does not participate in ZSR calc
      REAL( 8 ) :: WATER         ! kg of water for new time step 
      REAL( 8 ) :: X, Y
      REAL( 8 ) :: CONC( NCMP )    ! concentration (mol/m^3)
      REAL( 8 ) :: CONCR( NPAIR )  ! concentration (mol/m^3) ion "pairs" 
      REAL( 8 ) :: M0I( NPAIR )    ! single-solute molalities
      INTEGER :: J

C-----------------------------------------------------------------------

C     Return if small concentration
      IF ( WI( 1 ) + WI( 2 ) + WI( 3 ) + WI( 4 )
     &   + WI( 5 ) + WI( 6 ) + WI( 7 ) + WI( 8 ) .LE. SMALL) THEN
         H2O_NEW = SMALL
         RETURN
      END IF

C     Set component array (mol/m^3) for determining salts
      CONC = WI   ! array assignment

C     Get the sub-case to use in determining salts
      CALL GETSC ( CONC, RH, T, SC )

#ifdef verbose_aero
!     write( logdev,* ) 'CALC_H2O -SC: ', sc
#endif

C     Initialize ion "pairs" (i.e., salts) used in ZSR
      CONCR( : ) = 0.0D0

C     Depending on case, determine moles of salts in solution (i.e., CONCR)
C     for ZSR calculation below

      IF ( SC .EQ. 'S2' ) THEN    ! sulfate poor (NH4-SO4 system), old K2
         CONCR( 4 )= MIN ( CONC( 2 ), 0.5D0 * CONC( 3 ) )  ! (NH4)2SO4

      ELSE IF ( SC .EQ. 'B4' ) THEN  ! sulfate rich (no acid), old L4, O4
         X = 2.0D0 * CONC( 2 ) - CONC( 3 )     ! 2SO4 - NH4
         Y = CONC( 3 ) - CONC( 2 )            ! NH4 - SO4
         IF ( X .LE. Y ) THEN
            CONCR( 13 ) = X      ! (NH4)3H(SO4)2 is MIN (X,Y)
            CONCR(  4 ) = Y - X  ! (NH4)2SO4
         ELSE
            CONCR( 13 ) = Y      ! (NH4)3H(SO4)2 is MIN (X,Y)
            CONCR(  9 ) = X - Y  ! NH4HSO4
         END IF

      ELSE IF ( SC .EQ. 'C2' ) THEN  ! sulfate rich (free acid), old M2, P2
         CONCR( 9 ) = CONC( 3 )                      ! NH4HSO4
         CONCR( 7 ) = MAX( CONC( 2 ) - CONC( 3 ), 0.0D0 )   ! H2SO4

      ELSE IF ( SC .EQ. 'N3' ) THEN    ! sulfate poor (NH4-SO4-NO3 system)
         CONCR( 4 ) = MIN ( CONC( 2 ), 0.5D0 * CONC( 3 ) )           ! (NH4)2SO4
         FNH4       = MAX ( CONC( 3 ) - 2.0D0 * CONCR( 4 ), 0.0D0 )  ! available NH4
         CONCR( 5 ) = MAX ( MIN ( FNH4, CONC( 4 ) ), 0.0D0 )         ! NH4NO3=MIN(NH4,NO3)

      ELSE IF ( SC .EQ. 'Q5' ) THEN    ! sulfate poor, sodium poor (NH4-SO4-NO3-Cl-Na)
         CONCR( 2 ) = 0.5D0 * CONC( 1 )                              ! Na2SO4
         FSO4       = MAX ( CONC( 2 ) - CONCR( 2 ), 0.0D0 )          ! available SO4
         CONCR( 4 ) = MAX ( MIN ( FSO4, 0.5D0 * CONC( 3 ) ), SMALL ) ! NH42S4=MIN(NH4,S4)
         FNH4       = MAX ( CONC( 3 ) - 2.0D0 * CONCR( 4 ), 0.0D0 )  ! available NH4
         CONCR( 5 ) = MIN ( FNH4, CONC( 4 ) )                        ! NH4NO3=MIN(NH4,NO3)
         FNH4       = MAX ( FNH4 - CONCR( 5 ), 0.0D0 )               ! avaialable NH4
         CONCR( 6 ) = MIN ( FNH4, CONC( 5 ) )                        ! NH4Cl=MIN(NH4,Cl)

      ELSE IF ( SC .EQ. 'R6' ) THEN   ! sulfate poor, sodium rich (NH4-SO4-NO3-Cl-Na)
         CONCR( 2 ) = CONC( 2 )                            ! Na2SO4
         FNA        = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )

         CONCR( 3 ) = MIN ( FNA, CONC( 4 ) )               ! NaNO3
         FNO3       = MAX ( CONC( 4 ) - CONCR( 3 ), 0.0D0 )
         FNA        = MAX ( FNA - CONCR( 3 ), 0.0D0 )

         CONCR( 1 ) = MIN ( FNA, CONC( 5 ) )               ! NaCl
         FCL        = MAX ( CONC( 5 ) - CONCR( 1 ), 0.0D0 )
         FNA        = MAX ( FNA - CONCR( 1 ), 0.0D0 )

         CONCR( 5 ) = MIN ( FNO3, CONC( 3 ) )              ! NH4NO3
         FNO3       = MAX ( FNO3 - CONCR( 5 ), 0.0D0 )
         FNH4       = MAX ( CONC( 3 ) - CONCR( 5 ), 0.0D0 )

         CONCR( 6 ) = MIN (FCL, FNH4 )                     ! NH4Cl

      ELSE IF ( SC .EQ. 'I6' ) THEN   ! sulfate rich (no acid) (NH4-SO4-NO3-Cl-Na)
         CONCR(  2 ) = 0.5D0 * CONC( 1 )                          ! Na2SO4
         FSO4        = MAX ( CONC( 2 ) - CONCR( 2 ), 0.0D0 )
         CONCR( 13 ) = MIN ( CONC( 3 ) / 3.0D0, FSO4 / 2.0D0 )    ! (NH4)3H(SO4)2
         FSO4        = MAX ( FSO4 - 2.0D0 * CONCR( 13 ), 0.0D0 )
         FNH4        = MAX ( CONC( 3 ) - 3.0D0 * CONCR( 13 ), 0.0D0 )

         IF ( FSO4 .LE. SMALL ) THEN    ! reduce (NH4)3H(SO4)2, add (NH4)2SO4
            CONCR( 13 ) = MAX ( CONCR( 13 ) - FNH4, 0.0D0 )   ! (NH4)3H(SO4)2
            CONCR(  4 ) = 2.0D0 * FNH4                  ! (NH4)2SO4
         ELSE IF ( FNH4 .LE. SMALL ) THEN ! reduce (NH4)3H(SO4)2, add NH4HSO4
            CONCR(  9 ) = 3.0D0 * MIN ( FSO4, CONCR( 13 ) ) ! NH4HSO4
            CONCR( 13 ) = MAX ( CONCR( 13 ) - FSO4, 0.0D0 )
            IF ( CONCR( 2 ) .GT. SMALL ) THEN ! reduce Na2SO4, add NaHSO4
               FSO4        = MAX ( FSO4 - CONCR( 9 ) / 3.0D0, 0.0D0 )
               CONCR( 12 ) = 2.0D0 * FSO4                ! NaHSO4
               CONCR(  2 ) = MAX ( CONCR( 2 ) - FSO4, 0.0D0 )  ! Na2SO4
             END IF
         END IF

      ELSE IF ( SC .EQ. 'J3' ) THEN   ! sulfate rich (free acid) (NH4-SO4-NO3-Cl-Na)
         CONCR(  9 ) = CONC( 3 )                             ! NH4HSO4
         CONCR( 12 ) = CONC( 1 )                             ! NAHSO4
         CONCR(  7 ) = MAX ( CONC( 2 ) - CONC( 3 ) - CONC( 1 ), 0.0D0 ) ! H2SO4

      ! Crustal cases
      ELSE IF ( SC .EQ. 'V7' ) THEN  ! sulfate poor, sodium+crustal poor
         CASO4     = MIN ( CONC( 6 ), CONC( 2 ) )            ! CCASO4
         FSO4      = MAX ( CONC( 2 ) - CASO4, 0.0D0 )
         FCA       = MAX ( CONC( 6 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( 0.5D0 * CONC( 7 ), FSO4 )       ! CK2SO4
         FK          = MAX ( CONC( 7 ) - 2.D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 2 )  = MIN ( 0.5D0 * CONC( 1 ), FSO4 )       ! CNA2SO4
         FNA         = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 2 ), 0.0D0 )

         CONCR( 21 ) = MIN ( CONC( 8 ), FSO4 )               ! CMGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 21 ), 0.0D0 )

         CONCR( 4 )  = MAX ( MIN ( FSO4 , 0.5D0 * CONC( 3 ) ) , SMALL ) ! CNH42S4
         FNH4        = MAX ( CONC( 3 ) - 2.0D0 * CONCR( 4 ), 0.0D0 )

         CONCR( 5 )  = MIN ( FNH4, CONC( 4 ) )               ! CNH4NO3
         FNH4        = MAX ( FNH4 - CONCR( 5 ), 0.0D0 )

         CONCR( 6 )  = MIN ( FNH4, CONC( 5 ) )               ! CNH4CL

      ELSE IF ( SC .EQ. 'U8' ) THEN  ! sulfate poor, crustal+sodium rich, crustal poor
         CASO4       = MIN ( CONC( 6 ), CONC( 2 ) )          ! CCASO4
         FSO4        = MAX ( CONC( 2 ) - CASO4, 0.0D0 )
         FCA         = MAX ( CONC( 6 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( 0.5D0 * CONC( 7 ), FSO4 )       ! CK2SO4
         FK          = MAX ( CONC( 7 ) - 2.0D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 21 ) = MIN ( CONC( 8 ), FSO4 )               ! CMGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 21 ), 0.0D0 )

         CONCR( 2 )  = MAX ( FSO4, 0.0D0 )                   ! CNA2SO4
         FNA         = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )

         CONCR( 3 )  = MIN ( FNA, CONC( 4 ) )                ! NaNO3
         FNO3        = MAX ( CONC( 4 ) - CONCR( 3 ), 0.0D0 )
         FNA         = MAX ( FNA - CONCR( 3 ), 0.0D0 )

         CONCR( 1 )  = MIN ( FNA, CONC( 5 ) )                ! NaCl
         FCL         = MAX ( CONC( 5 ) - CONCR( 1 ), 0.0D0 )
         FNA         = MAX ( FNA - CONCR( 1 ), 0.0D0 )

         CONCR( 5 )  = MIN ( FNO3, CONC( 3 ) )               ! NH4NO3
         FNO3        = MAX ( FNO3 - CONCR( 5 ), 0.0D0 )
         FNH4        = MAX ( CONC( 3 ) - CONCR( 5 ), 0.0D0 )

         CONCR( 6 )  = MIN ( FCL, FNH4 )                     ! NH4Cl
         FCL         = MAX ( FCL - CONCR( 6 ), 0.0D0 )
         FNH4        = MAX ( FNH4 - CONCR( 6 ), 0.0D0 )

      ELSE IF ( SC .EQ. 'W13' ) THEN  ! sulfate poor, crustal+sodium rich
         CASO4       = MIN ( CONC( 2 ), CONC( 6 ) )          ! CASO4
         FCA         = MAX ( CONC( 6 ) - CASO4, 0.0D0 )
         FSO4        = MAX ( CONC( 2 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( FSO4, 0.5D0 * CONC( 7 ) )       ! K2SO4
         FK          = MAX ( CONC( 7 ) - 2.0D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 21 ) = FSO4                                  ! MGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )

         CONCR( 1 )  = MIN ( CONC( 1 ), CONC( 5 ) )          ! NACL
         FNA         = MAX ( CONC( 1 ) - CONCR( 1 ), 0.0D0 )
         FCL         = MAX ( CONC( 5 ) - CONCR( 1 ), 0.0D0 )

         CONCR( 16 ) = MIN ( FCA, 0.5D0 * FCL )              ! CACL2
         FCA         = MAX ( FCA - CONCR( 16 ), 0.0D0 )
         FCL         = MAX ( CONC( 5 ) - 2.0D0 * CONCR( 16 ), 0.0D0 )

         CONCR( 15 ) = MIN ( FCA, 0.5D0 * CONC( 4 ) )        ! CA(NO3)2
         FCA         = MAX ( FCA - CONCR( 15 ), 0.0D0 )
         FNO3        = MAX ( CONC( 4 ) - 2.0D0 * CONCR( 15 ), 0.0D0 )

         CONCR( 23 ) = MIN ( FMG, 0.5D0 * FCL )              ! MGCL2
         FMG         = MAX ( FMG - CONCR( 23 ), 0.0D0 )
         FCL         = MAX ( FCL - 2.0D0 * CONCR( 23 ), 0.0D0 )

         CONCR( 22 ) = MIN ( FMG, 0.5D0 * FNO3 )             ! MG(NO3)2
         FMG         = MAX ( FMG - CONCR( 22 ), 0.0D0 )
         FNO3        = MAX ( FNO3 - 2.0D0 * CONCR( 22 ), 0.0D0 )

         CONCR( 3 )  = MIN ( FNA, FNO3 )                     ! NANO3
         FNA         = MAX ( FNA - CONCR( 3 ), 0.0D0 )
         FNO3        = MAX ( FNO3 - CONCR( 3 ), 0.0D0 )

         CONCR( 20 ) = MIN ( FK, FCL )                       ! KCL
         FK          = MAX ( FK - CONCR( 20 ), 0.0D0 )
         FCL         = MAX ( FCL - CONCR( 20 ), 0.0D0 )

         CONCR( 19 ) = MIN ( FK, FNO3 )                      ! KNO3
         FK          = MAX ( FK - CONCR( 19 ), 0.0D0 )
         FNO3        = MAX ( FNO3 - CONCR( 19 ), 0.0D0 )

      ELSE IF ( SC .EQ. 'L9' ) THEN  ! sulfate rich, no free acid
         CASO4       = MIN ( CONC( 6 ), CONC( 2 ) )          ! CCASO4
         FSO4        = MAX ( CONC( 2 ) - CASO4, 0.0D0 )
         FCA         = MAX ( CONC( 6 ) - CASO4, 0.0D0 )

         CONCR( 17 ) = MIN ( 0.5D0 * CONC( 7 ), FSO4 )       ! CK2SO4
         FK          = MAX ( CONC( 7 ) - 2.0D0 * CONCR( 17 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 17 ), 0.0D0 )

         CONCR( 2 )  = MIN ( 0.5D0 * CONC( 1 ), FSO4 )       ! CNA2SO4
         FNA         = MAX ( CONC( 1 ) - 2.0D0 * CONCR( 2 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 2 ), 0.0D0 )

         CONCR( 21 ) = MIN ( CONC( 8 ), FSO4 )               ! CMGSO4
         FMG         = MAX ( CONC( 8 ) - CONCR( 21 ), 0.0D0 )
         FSO4        = MAX ( FSO4 - CONCR( 21 ), 0.0D0 )

         CONCR( 13 ) = MIN ( CONC( 3 ) / 3.0D0, FSO4 / 2.0D0 ) ! CLC
         FSO4        = MAX ( FSO4 - 2.0D0 * CONCR( 13 ), 0.0D0 )
         FNH4        = MAX ( CONC( 3 )- 3.0D0 * CONCR( 13 ),  0.0D0 )

         IF ( FSO4 .LE. SMALL ) THEN                           ! convert (NH4)3H(SO4)2 to (NH4)2SO4
            CONCR( 13 ) = MAX( CONCR( 13 ) - FNH4, 0.0D0 )
            CONCR(  4 ) = 2.0D0 * FNH4                         ! CNH42S4 

         ELSE IF ( FNH4 .LE. SMALL ) THEN                      ! convert (NH4)3H(SO4)2 to NH4HSO4
            CONCR(  9 ) = 3.0D0 * MIN( FSO4, CONCR( 13 ) )     ! CNH4HS4
            CONCR( 13 ) = MAX( CONCR( 13 ) - FSO4, 0.0D0 )     ! CLC, (NH4)3H(SO4)2
            IF ( CONCR( 2 ) .GT. SMALL ) THEN                  ! convert Na2SO4 to NaHSO4
               FSO4        = MAX( FSO4 - CONCR( 9 ) / 3.0D0, 0.0D0 )
               CONCR( 12 ) = 2.0D0 * FSO4                      ! CNAHSO4
               CONCR(  2 ) = MAX( CONCR( 2 ) - FSO4, 0.0D0 )   ! CNA2SO4
            END IF
            IF ( CONCR( 17 ) .GT. SMALL ) THEN                 ! convert K2SO4 to KHSO4
               FSO4        = MAX( FSO4 - CONCR( 9 ) / 3.0D0, 0.0D0 )
               CONCR( 18 ) = 2.0D0 * FSO4                      ! CKHSO4
               CONCR( 17 ) = MAX( CONCR( 17 ) - FSO4, 0.0D0 )  ! CK2SO4
            END IF
         END IF
         
      ELSE IF ( SC .EQ. 'K4' ) THEN ! sulfate super rich, free acid
         CONCR(  9 ) = CONC( 3 )                               ! NH4HSO4 = NH3
         CONCR( 12 ) = CONC( 1 )                               ! NaHSO4  = Na
         CONCR( 18 ) = CONC( 7 )                               ! KHSO4   = K
         CONCR( 21 ) = CONC( 8 )                               ! MgSO4   = Mg
         CONCR(  7 ) = MAX( CONC( 2 ) - CONC( 3 ) - CONC( 1 )
     &                    - CONC( 6 ) - CONC( 7 ) - CONC( 8 ), 0.0D0 ) ! H2SO4 = SO4 - NH4 - Na - Ca - K - Mg

      ELSE
         PRINT*, 'aero_subs.f: case not supported ',
     &          '(metastable reverse only)'
      END IF

C     Get single-solute molalities for ZSR calculation
      CALL GETM0I ( RH, M0I )

C     Calculate H2O with ZSR and determine delta water
      WATER = 0.0D0
      DO J = 1, NPAIR
         WATER = WATER + CONCR( J ) / M0I( J )
      END DO

      WATER = MAX ( WATER, SMALL )
      H2O_NEW = WATER / Mw

      END SUBROUTINE CALC_H2O  

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETM0I ( RHIN, M0I )

!!!!!!!!!!!!!!! We want to get rid of this dependency !!!!!!!!!!!!!!!!

C Description
C   Determines single-solute molalities for the 13 possible salts at
C   the ambient RH.  These molalities are used in the ZSR calculation
C   in CALC_H2O. Note that the molalities were determined at the beginning
C   of the time step, and so they are available in the IONS common block
C   of isrpia.inc.
C   Routine called by CALC_H2O.

C Revision History
C   ??? ???? Prakash Bhave(?), Jim Kelly(?): initial revision
C   Apr 2011 Havala Pye: Removed use of IONS common block since it requires
C                        ISORROPIA to be called to setup the initial array values.
C                        Now uses single-solute molalities from ZSR common block
C                        in isrpia.inc that is defined in BLKISO in isocom.f
C                        BE VERY CAREFUL ABOUT IMPLICIT VARIABLES HERE!
 
C Arguments
C   Output
C     M0I : Single-solute molalities (mol/kg-H2O) for 13 salts
 
C-----------------------------------------------------------------------

!     implicit none

      INCLUDE 'isrpia.inc'

C Arguments
      REAL( 8 ), INTENT( IN )  :: RHIN
      REAL( 8 ), INTENT( OUT ) :: M0I( NPAIR )

      INTEGER IZ

C Location in pure molality array (function of RH)
      IZ = MIN( INT( RHIN * REAL( NZSR, 8 ) + 0.5D0 ), NZSR )
      IZ = MAX( IZ, 1 )

C Default value
      M0I = 1.0D+5   ! array assignment

C Actual values (10,11 not provided)
      M0I( 01 ) = AWSC( IZ )   ! NACl
      M0I( 02 ) = AWSS( IZ )   ! (NA)2SO4
      M0I( 03 ) = AWSN( IZ )   ! NANO3
      M0I( 04 ) = AWAS( IZ )   ! (NH4)2SO4
      M0I( 05 ) = AWAN( IZ )   ! NH4NO3
      M0I( 06 ) = AWAC( IZ )   ! NH4CL
      M0I( 07 ) = AWSA( IZ )   ! 2H-SO4
      M0I( 08 ) = AWSA( IZ )   ! H-HSO4
      M0I( 09 ) = AWAB( IZ )   ! NH4HSO4


      M0I( 12 ) = AWSB( IZ )   ! NAHSO4
      M0I( 13 ) = AWLC( IZ )   ! (NH4)3H(SO4)2

      M0I( 15 ) = AWCN( IZ )   ! CA(NO3)2
      M0I( 16 ) = AWCC( IZ )   ! CACl2
      M0I( 17 ) = AWPS( IZ )   ! K2SO4
      M0I( 18 ) = AWPB( IZ )   ! KHSO4
      M0I( 19 ) = AWPN( IZ )   ! KNO3
      M0I( 20 ) = AWPC( IZ )   ! KCl
      M0I( 21 ) = AWMS( IZ )   ! MGSO4
      M0I( 22 ) = AWMN( IZ )   ! MG(NO3)2
      M0I( 23 ) = AWMC( IZ )   ! MGCL2
    
      END SUBROUTINE GETM0I               

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE GETSC ( CONC, RH, T, SC )
 
C Description
C   Determines the sub-case to use for water uptake calculations.
C   Follows the procedure of ISORROPIA.
C   Routine called by CALC_H2O.
 
C ArgumentS
C   Inputs
C     CONC : Concentration [mol/m^3] of aerosol components. This routine
C            sets minimum CONC to 1.0D-20
C     RH   : Relative humidity
C     T    : Temperature (K)
     
C   Output
C     SC   : Sub-case for aerosol composition
 
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INTEGER, PARAMETER :: NCMP = 8    ! was NCMP  = 5    ! number of aerosol components
      REAL( 8 ), PARAMETER :: SMALL = 1.0D-20

C Arguments:
!     REAL( 8 ), INTENT( IN )    :: CONC(  NCMP )
      REAL( 8 ), INTENT( INOUT ) :: CONC(  NCMP )
      REAL( 8 ), INTENT( IN )    :: RH, T
      CHARACTER( 3 ), INTENT( OUT ) :: SC
            
C Local Variables:
      REAL( 8 ) :: T0, TCF                     ! DRH(T) factor
      REAL( 8 ) :: S4RAT, S4RATW, NaRAT, SRI   ! sulfate & sodium ratios
      REAL( 8 ) :: CRAT                        ! crustals ratio
      REAL( 8 ) :: FSO4                        ! "free" sulfate
      REAL( 8 ) :: DNACL, DNH4CL, DNANO3, DNH4NO3, DNH42S4 ! DRH values

      REAL( 8 ) :: GETASR    ! ISORROPIA function for sulfate ratio

      LOGICAL :: SCP1R, SCP2R, SCP3R, SCP4R ! concentration regime

C-----------------------------------------------------------------------

      SCP1R = .FALSE.
      SCP2R = .FALSE.
      SCP3R = .FALSE.
      SCP4R = .FALSE.

C     See if any components are negligible (see isocom.for)
      IF ( CONC( 1 ) + CONC( 4 ) + CONC( 5 ) + 
     &     CONC( 6 ) + CONC( 7 ) + CONC( 8 ) .LE. SMALL ) THEN       ! Ca,K,Mg,Na,Cl,NO3=0
         SCP1R = .TRUE.                                    
      ELSE IF ( CONC( 1 ) +        CONC( 5 ) +
     &          CONC( 6 ) + CONC( 7 ) + CONC( 8 ) .LE. SMALL ) THEN  ! Ca,K,Mg,Na,Cl=0
         SCP2R = .TRUE.                                     
      ELSE IF ( CONC( 6 ) + CONC( 7 ) + CONC( 8 ) .LE. SMALL ) THEN  ! Ca,K,Mg=0
         SCP3R = .TRUE.                                     
      ELSE                                                           ! all species
         SCP4R = .TRUE.
      END IF

      CONC( : ) = MAX ( CONC( : ), SMALL )

C     Deliquescence RH calculations
      DNH42S4 = 0.7997D0
      DNH4NO3 = 0.6183D0
      IF ( INT( T ) .NE. 298 ) THEN
         T0      = 298.15D0
         TCF     = 1.0D0 / T - 1.0D0 / T0
         DNH4NO3 = DNH4NO3 * EXP( 852.0D0 * TCF )
         DNH42S4 = DNH42S4 * EXP(  80.0D0 * TCF )
         DNH4NO3 = MIN ( DNH4NO3, DNH42S4 ) ! adjust for curves crossing T<271K
      END IF

C     Find sub-case "SC"
      IF ( SCP1R ) THEN ! NH4-S04 system

         IF ( RH .GE. DNH42S4 ) THEN
            S4RATW = GETASR( CONC( 2 ), RH ) ! aerosol sulfate ratio
         ELSE
            S4RATW = 2.0D0                ! dry aerosol sulfate ratio
         END IF
         S4RAT  = CONC( 3 ) / CONC( 2 )     ! sulfate ratio (NH4/SO4)

         IF ( S4RATW .LE. S4RAT ) THEN      ! sulfate poor
            SC = 'S2'
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN ! sulfate rich (no acid)
            SC = 'B4'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN   ! sulfate rich (free acid)
            SC = 'C2'
         END IF

      ELSE IF ( SCP2R ) THEN ! NH4-SO4-NO3 system

         IF ( RH .GE. DNH4NO3 ) THEN
            S4RATW = GETASR( CONC( 2 ), RH )
         ELSE
            S4RATW = 2.0D0               ! dry aerosol ratio
         END IF
         S4RAT = CONC( 3 ) / CONC( 2 )

         IF ( S4RATW .LE. S4RAT ) THEN     ! sulfate poor
            SC = 'N3'
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN  ! sulfate rich (no acid)
            SC = 'B4'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN    ! sulfate rich (free acid)
            SC = 'C2'
         END IF

      ELSE IF ( SCP3R )  THEN ! NH4-SO4-NO3-Na-Cl system

C        Adjust DRH of NH4NO3 for low temperature
         DNACL  = 0.7528D0
         DNANO3 = 0.7379D0
         DNH4CL = 0.7710D0
         IF ( INT( T ) .NE. 298 ) THEN
            DNACL   = DNACL  * EXP(  25.0D0 * TCF )
            DNANO3  = DNANO3 * EXP( 304.0D0 * TCF )
            DNH4CL  = DNH4Cl * EXP( 239.0D0 * TCF )
            DNH4NO3 = MIN ( DNH4NO3, DNH4CL, DNANO3, DNACL )
         END IF

         IF ( RH .GE. DNH4NO3 ) THEN
            FSO4   = CONC( 2 ) - CONC( 1 ) / 2.0D0   ! sulfate unbound by Na+
            FSO4   = MAX ( FSO4, SMALL )
            SRI    = GETASR ( FSO4, RH )
            S4RATW = ( CONC( 1 ) + FSO4 * SRI ) / CONC( 2 )
            S4RATW = MIN ( S4RATW, 2.0D0 )
         ELSE
            S4RATW = 2.0D0                       ! ratio for dry aerosol
         END IF
         S4RAT = ( CONC( 1 ) + CONC( 3 ) ) / CONC( 2 )
         NaRAT = CONC( 1 ) / CONC( 2 )

         IF ( S4RATW .LE. S4RAT .AND. NaRAT .LT. 2.0D0 ) THEN ! sulfate poor, sodium poor
            SC = 'Q5'
         ELSE IF ( S4RAT .GE. S4RATW .AND. NaRAT .GE. 2.0D0 ) THEN ! SO4 poor, Na rich
            SC = 'R6'
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN ! SO4 rich, no acid
            SC = 'I6'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN ! sulfate rich, free acid
            SC = 'J3'
         END IF

      ELSE IF ( SCP4R ) THEN ! NH4-SO4-Na-Cl-Ca-K-Mg system

         ! Do I need an RH if check here????
         FSO4   = CONC( 2 ) - CONC( 1 ) / 2.0D0
     &          - CONC( 6 ) - CONC( 7 ) / 2.0D0 - CONC( 8 )  ! sulfate unbound by sodium,calcium,pottasium,magnesium
         FSO4   = MAX ( FSO4, SMALL )
         SRI    = GETASR( FSO4, RH )                         ! sulfate ratio for NH4+
         S4RATW = ( CONC( 1 ) + FSO4 * SRI + CONC( 6 )
     &            + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 )      ! limiting sulfate ratio
         S4RATW = MIN ( S4RATW, 2.0D0 )
         S4RAT = ( CONC( 1 ) + CONC( 3 ) + CONC( 6 ) + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 ) ! sulfate ratio
         NaRAT = ( CONC( 1 ) + CONC( 6 ) + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 ) ! crustals+sodium ratio
         CRAT  = ( CONC( 6 ) + CONC( 7 ) + CONC( 8 ) ) / CONC( 2 )             ! crustals ratio

         IF ( S4RATW .LE. S4RAT .AND. NaRAT .LT. 2.0D0 ) THEN ! sulfate, sodium, crustal poor
            SC = 'V7'
         ELSE IF ( S4RAT .GE. S4RATW .AND. NaRAT .GE. 2.0D0 ) THEN
            IF ( CRAT .LE. 2.0D0 ) THEN       ! sulfate poor, dust+sodium rich, dust poor
               SC = 'U8'
            ELSE                              ! sulfate poor, dust+sodium rich, dust rich
               SC = 'W13'
            END IF
         ELSE IF ( 1.0D0 .LE. S4RAT .AND. S4RAT .LT. S4RATW ) THEN ! sulfate rich, no acid
            SC = 'L9'
         ELSE IF ( S4RAT .LT. 1.0D0 ) THEN     ! sulfate rich, free acid
            SC = 'K4'
         END IF
      END IF

      !print*,'SUBCASE identified in calc_h2o', SC

      END SUBROUTINE GETSC

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      REAL FUNCTION GETAF( NI, NJ, DGNI, DGNJ, XLSGI, XLSGJ, SQRT2 )

C  Returns the value of "Xnum" in Equations 10a and 10c
C  of Binkowski and Roselle (2003), given the number concentrations,
C  median diameters, and natural logs of the geometric standard
C  deviations, in two lognormal modes.  The value returned by GETAF
C  is used subsequently in the mode merging calculations:
C       GETAF = ln( Dij / Dgi ) / ( SQRT2 * ln(Sgi) )
C  where Dij is the diameter of intersection,
C        Dgi is the median diameter of the smaller size mode, and
C        Sgi is the geometric standard deviation of smaller mode.
C  A quadratic equation is solved to obtain GETAF, following the
C  method of Press et al.
C 
C  References:
C   1. Binkowski, F.S. and S.J. Roselle, Models-3 Community
C      Multiscale Air Quality (CMAQ) model aerosol component 1:
C      Model Description.  J. Geophys. Res., Vol 108, No D6, 4183
C      doi:10.1029/2001JD001409, 2003.
C   2. Press, W.H., S.A. Teukolsky, W.T. Vetterling, and B.P.
C      Flannery, Numerical Recipes in Fortran 77 - 2nd Edition.
C      Cambridge University Press, 1992.

      IMPLICIT NONE

      REAL NI, NJ, DGNI, DGNJ, XLSGI, XLSGJ, SQRT2
      REAL AA, BB, CC, DISC, QQ, ALFA, L, YJI

C-----------------------------------------------------------------------

C *** Store intermediate values used for the quadratic solution
C     to reduce computational burden
      ALFA = XLSGI / XLSGJ
      YJI = LOG( DGNJ / DGNI ) / ( SQRT2 * XLSGI )
      L = LOG( ALFA * NJ / NI)

C *** Calculate quadratic equation coefficients & discriminant
      AA = 1.0 - ALFA * ALFA
      BB = 2.0 * YJI * ALFA * ALFA
      CC = L - YJI * YJI * ALFA * ALFA
      DISC = BB * BB - 4.0 * AA * CC

C *** If roots are imaginary, return a negative GETAF value so that no
C     mode merging takes place.
      IF ( DISC .LT. 0.0 ) THEN
         GETAF = - 5.0       ! error in intersection
         RETURN
      END IF

C *** Equation 5.6.4 of Press et al.
      QQ = -0.5 * ( BB + SIGN( 1.0, BB ) * SQRT( DISC ) )

C *** Return solution of the quadratic equation that corresponds to a
C     diameter of intersection lying between the median diameters of
C     the 2 modes.
      GETAF = CC / QQ       ! See Equation 5.6.5 of Press et al.

      RETURN
      END FUNCTION GETAF

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO_INLET ( DGN, XXLSG, RHOP, fPM1, fPM25, fPM10 )

C  Calculates the volume fraction of a given aerosol mode that would enter
C  a sharp-cut inlet, using equations from Jiang et al (2006). The
C  subroutine calculates transmission factors for PM1, PM2.5 and PM10,
C  after first converting those cutoffs from Aerodynamic Diameter to
C  Stokes Diameter (used internally within CMAQ).
 
C  CMAQ aerosols are represented with Stokes Diameter. There are many
C  alternate forms of diameter including the following:
C       Volume Equivalent Diameter (D_ve) - the diameter of a sphere with the
C          same volume as the particle.
C       Stokes Diameter (D_st) - the diameter of a sphere with the same
C          terminal velocity as the real particle. If the shape factor
C          is 1, then the Stokes and Volume Equivalent Diameters are
C          equal.
C       Aerodynamic Diameter (D_ad) - the diameter of a sphere with unit
C          density and the same terminal velocity as the real particle.
C          If the density is 1, then the Aerodynamic Diameter and Stokes
C          Diameter are equal.
C       Vacuum Aerodynamic Diameter (D_va) - the diameter of a sphere with very
C          high Knudsen number and thus a simplified relationship with
C          Stokes diameter that is only dependent on density and shape
C          factor, not Slip Correction. The very high Knudsen number
C          could be because the particle is very small or because the
C          system pressure is very low.
C       Electrical Mobility Diameter (D_em) - the diameter of a sphere with the
C          same migration velocity as the real particle. Requires a
C          slip-correction and a shape factor correction when converting
C          from volume equivalent diameter.
 
C  Conversions:
C       Parameters
C         rho  - Density
C         rho0 - Unit Density (1 g cm-3)
C         Cc( ) - Cunningham Slip Correction of a particular diameter
C         X   - Shape factor = (NonSpherical Drag Force)/(Spherical Drag Force)
C       Aerodynamic -> Stokes
C         D_st = D_ad * sqrt(rho0/rho) * sqrt( Cc(D_ad) / Cc(D_st) )
C       Volume Equivalent -> Stokes
C         D_st = D_ve * sqrt(1/X) * sqrt( Cc(D_ve) / Cc(D_st) )
C       Electrical Mobility -> Volume Equivalent
C         D_ve = D_em * [Cc(D_ve) / Cc(D_em)] * 1/X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_em )
C       Vacuum Aerodynamic -> Volume Equivalent (DeCarlo et al., 2004)
C         D_ve = D_va * rho0/rho * X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_va * rho0/rho )
 
C  Key Subroutines called: none
 
C  Key Functions called:  ERF
 
C  Revision History:
C    Coded Jul 2005 by Prakash Bhave
C          Apr 2008 J.Kelly: corrected equation for Dst25 calculation
C          Feb 2016 B.Murphy: modified to output PM1 and PM10 mode
C                             fractions in addition to PM2.5
 
C  References:
C   1. Jiang, W., Smyth, S., Giroux, E., Roth, H., Yin, D., Differences
C   between CMAQ fine mode particle and PM2.5 concentrations and their
C   impact on model performance evaluation in the Lower Fraser Valley,
C   Atmos. Environ., 40:4973-4985, 2006.
C   2. Meng, Z., Seinfeld, J.H., On the source of the submicrometer
C   droplet mode of urban and regional aerosols, Aerosol Sci. and
C   Technology, 20:253-265, 1994.
 
C-----------------------------------------------------------------------

      IMPLICIT NONE

      INCLUDE SUBST_CONST    ! for PI

C    Input variables
      REAL   DGN     ! geometric mean Stokes diameter by number [ m ]
      REAL   XXLSG   ! natural log of geometric standard deviation
      REAL   RHOP    ! average particle density [ kg/m**3 ]

C    Output variable
      REAL, INTENT( OUT ) :: fPM1   ! fraction of particulate volume transmitted through 1
      REAL, INTENT( OUT ) :: fPM25  ! fraction of particulate volume transmitted through 2
      REAL, INTENT( OUT ) :: fPM10  ! fraction of particulate volume transmitted through 10

C    Internal variables
      REAL, PARAMETER :: SQRT2 = 1.4142136  !  SQRT( 2 )
      REAL, PARAMETER :: D_AD1  = 1.0  ! aerodynamic diameter cut point [ um ]
      REAL, PARAMETER :: D_AD25 = 2.5  ! aerodynamic diameter cut point [ um ]
      REAL, PARAMETER :: D_AD10 = 10.0 ! aerodynamic diameter cut point [ um ]
      REAL, PARAMETER :: B = 0.21470 ! Cunningham slip-correction approx. param [ um ]
                                     ! This factor works well applied to the entire particle size-range
                                     ! The approximation is: Cc(Dp) = 1 + B/Dp
      REAL D_ST1, D_ST25, D_ST10     ! Stokes diameter equivalent of DCA..
      REAL DG                        ! DGN converted to [ um ]
      REAL ERFARG                    ! argument of ERF, from Step#6 of Jiang et al. (2006)

C *** Error function approximation, from Meng & Seinfeld (1994)
      REAL ERF        ! Error function
      REAL XX         ! dummy argument for ERF
      ERF( XX )  = SIGN( 1.0, XX ) * SQRT( 1.0 - EXP( -4.0 * XX * XX / PI ) )

C ----------------------- Begin solution -------------------------------

C *** Calculate Transmission Fractions for Inlets with Aerodynamic
C     Cutoffs
      DG = DGN * 1.0E+06 ! [um] The units need to be equivalent with the B parameter

      ! Convert size cut to equivalent Stokes diameter using
      ! equation 2 of Jiang et al. (2006). Note: the equation in Step 5
      ! of this paper has a typo (i.e., eq. 2 is correct).
      D_ST1  = 0.5 * ( SQRT( B ** 2 + 4.0 * D_AD1 *
     &                     ( D_AD1 + B ) * 1.0E+03 / RHOP ) - B )
      D_ST25 = 0.5 * ( SQRT( B ** 2 + 4.0 * D_AD25 *
     &                     ( D_AD25 + B ) * 1.0E+03 / RHOP ) - B )
      D_ST10 = 0.5 * ( SQRT( B ** 2 + 4.0 * D_AD10 *
     &                     ( D_AD10 + B ) * 1.0E+03 / RHOP ) - B )

      ! Calculate mass fraction with Dca < SizeCut, using ERF approximation
      ! from Meng & Seinfeld (1994) and modified form of Fk(X) equation
      ! in Step#6 of Jiang et al. (2006).
      ERFARG = ( LOG( D_ST1 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) - 3.0 * XXLSG / SQRT2
      fPM1   = 0.5 * ( 1.0 + ERF( ERFARG ) )
      ERFARG = ( LOG( D_ST25 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) - 3.0 * XXLSG / SQRT2
      fPM25  = 0.5 * ( 1.0 + ERF( ERFARG ) )
      ERFARG = ( LOG( D_ST10 ) - LOG( DG ) ) / ( SQRT2 * XXLSG ) - 3.0 * XXLSG / SQRT2
      fPM10  = 0.5 * ( 1.0 + ERF( ERFARG ) )

      END SUBROUTINE AERO_INLET

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE AERO_AMS ( M3_WET, M2_WET, M0, M_H2O, RHOP, RHO_H2O, fAMS )

C  The subroutine calculates transmission factors applicable for
C  comparison with AMS measurements using the curve suggested by Jimenez
C  and coworkers  (http://cires1.colorado.edu/jimenez-group/wiki/index.php/
C  FAQ_for_AMS_Data_Users#What_is_the_size_cut_of_AMS_measurements.3F).
C  The AMS measures Vacuum Aerodynamic Diameter (D_va) because the pressure is
C  so low in the instrument. This curve (also described in Ensberg et
C  al., 2013)  includes the following (Note: before applying the curve,
C  the bounds must be converted to Stokes Diameter):
C     D_va < 0.04 um: 0% transmission (T)
C     0.04 < D_va < 0.1 um:  T% = 1666.6 * (D_va - 0.04)   (1)
C     0.1  < D_va < 0.55 um: T% = 100%                     (2)
C     0.55 < D_va < 2.0 um:  T% = 100-68.965*(D_va-0.55)   (3)
C     2.0 um < D_va: T = 0%
 
C  CMAQ aerosols are represented with Stokes Diameter. There are many
C  alternate froms of diameter including the following:
C       Volume Equivalent Diameter (D_ve) - the diameter of a sphere with the
C          same volume as the particle.
C       Stokes Diameter (D_st) - the diameter of a sphere with the same
C          terminal velocity as the real particle. If the shape factor
C          is 1, then the Stokes and Volume Equivalent Diameters are
C          equal.
C       Vacuum Aerodynamic Diameter (D_va) - the diameter of a sphere with very
C          high Knudsen number and thus a simplified relationship with
C          Stokes diameter that is only dependent on density and shape
C          factor, not Slip Correction. The very high Knudsen number
C          could be because the particle is very small or because the
C          system pressure is very low.
 
C  Conversions:
C       Parameters
C         ro  - Density
C         ro0 - Unit Density (1 g cm-3)
C         Cc( ) - Cunningham Slip Correction of a particular diameter
C         X   - Shape factor = (NonSpherical Drag Force)/(Spherical Drag Force)
C       Vacuum Aerodynamic -> Volume Equivalent (DeCarlo et al., 2004)
C         D_ve = D_va * ro0/ro * X
C             (If X = 1 (i.e. spherical), then D_st = D_ve = D_va * ro0/ro )
 
C  Key Functions called:  ERF
 
C  Revision History:
C    Coded Feb 2016 B.Murphy: Created

C  References:
C   1. DeCarlo et al., Particle Morphology and Density Characterization
C   by Combined Mobility and Aerodynamic Diameter Measurements. Part 1:
C   Theory, Aerosol Sci. and Technology, 38:1185-1205, 2004
C   2. Ensberg et al., Inorganic and black carbon aerosols in the Los
C   Angeles Basin during CalNex, Journ. Geophys. Res., 2013.

C-----------------------------------------------------------------------

      USE AERO_DATA, ONLY : MIN_SIGMA_G, MAX_SIGMA_G
      USE AEROMET_DATA, ONLY : F6PI, PI6

      IMPLICIT NONE

      INCLUDE SUBST_CONST    ! for PI

C    Input variables
      REAL, INTENT( IN ) :: M3_WET  ! Third Moment of Wet Distribution (m3/m3)
      REAL, INTENT( IN ) :: M2_WET  ! Second Moment of Wet Distribution (m2/m3)
      REAL, INTENT( IN ) :: M0      ! Number of Particles in Distribution (N/m3)
      REAL, INTENT( IN ) :: M_H2O   ! Mass Conc. of Water in Particles (ug/m3)
      REAL, INTENT( IN ) :: RHOP    ! average particle density [ kg/m**3 ]
      REAL, INTENT( IN ) :: RHO_H2O ! Water Density [ kg/m3 ]

C    Output variable
      REAL, INTENT(OUT) :: fAMS   ! fraction of particulate volume transmitted through AMS Inlet

C    Internal variables
      REAL, PARAMETER :: SQRT2 = 1.4142136    !  SQRT( 2 )
      REAL, PARAMETER :: DGMIN = 1.0E-9       !  min(Dp) in [m]
      REAL, PARAMETER :: ONETHIRD = 1.0 / 3.0
      REAL, PARAMETER :: TWOTHIRDS = 2.0 * ONETHIRD

      REAL DG                        ! DGN converted to [ um ]
      REAL DGv                       ! Volume Median Diameter
      REAL XXLSG                     ! ln(StndDev) for current mode
      REAL M3_DRY, M2_DRY, M3SUBT, M_WET, M_DRY, DRY_DENS, DENSFAC
      REAL XFSUM, LXFM2, L2SG, ES36
      REAL DBlo_st, DBhi_st, LOG_HILO, LOG_LOHI, LOG_HI, LOG_LO
      REAL SQRT2LSG, TERM1, TERM2, TERM3, TERM4, TERM5

C *** Error function approximation, from Meng & Seinfeld (1994)
      REAL ERF        ! Error function
      REAL XX         ! dummy argument for ERF
      ERF( XX )  = SIGN( 1.0, XX ) * SQRT( 1.0 - EXP( -4.0 * XX * XX / PI ) )

C ----------------------- Begin solution -------------------------------

C *** First Calculate Parameters of Dry Distribution since this is more
C     applicable in general to AMS measurements.
      M3SUBT = ( 1.0E-9 * F6PI / RHO_H2O ) * M_H2O        ! m3 m-3
      M3_DRY = Max(M3_WET - M3SUBT, 0.0) + TINY(0.0)   ! m3 m-3 
      M2_DRY = M2_WET * ( M3_DRY / M3_WET ) ** TWOTHIRDS  ! m2 m-3

      M_WET = M3_WET * 1.0E+9 * PI6 * RHOP ! ug m-3
      M_DRY = Max(M_WET - M_H2O, 0.0) + TINY(0.0) ! m3 m-3 

      DRY_DENS = M_DRY / M3_DRY * F6PI * 1.0E-9   ! kg m-3

      XFSUM = ONETHIRD * Log( M0 ) + TWOTHIRDS * Log( M3_DRY )
      LXFM2 = Log( M2_DRY )
      L2SG = XFSUM - LXFM2   ! ( ln(sigma) )^2

      L2SG = Min( Max( L2SG, LOG( MIN_SIGMA_G ) ** 2 ), LOG( MAX_SIGMA_G ) ** 2 )
      LXFM2 = XFSUM - L2SG
      ES36 = Exp( 4.5 * L2SG )

      DG = Max( DGMIN, ( M3_DRY / ( M0 * ES36 ) ) ** ONETHIRD ) * 1.0E+06 ![um] Units should correspond to D
      XXLSG = Sqrt( L2SG )  ! ln(sigma)

      DGv = EXP( LOG( DG ) + 3.0 * L2SG )

C *** Calculate Transmission Fractions for AMS with Vacuum Aerodynamic
C     Cutoffs. This approximation is split into a piecewise function (see
C     Appendix B in Ensberg et al., 2013).
      fAMS = 0.0
      DENSFAC = 1.0E+03 / DRY_DENS  ! Density Correction Factor
                                    !   = rho0 / rho
                                    !   = 1000.0 / rho
      SQRT2LSG = SQRT2 * XXLSG

      ! First Piece of Function [T(%) = 1666.6 * (Dva - 0.04) ]
      DBlo_st = 0.040 * DENSFAC  ! Stokes Lower Bound of Piece [um]
      DBhi_st = 0.100 * DENSFAC  ! Stokes Upper Bound of Piece [um]

      LOG_HILO = LOG( 100.0/40.0 )
      LOG_HI   = LOG( DBhi_st/DGv )
      LOG_LO   = LOG( DBlo_st/DGv )

      TERM1 = LOG( DGv/DBlo_st ) / LOG_HILO
      TERM2 =  ERF( LOG_HI / SQRT2LSG )
     &        -ERF( LOG_LO / SQRT2LSG )
      TERM3 = XXLSG / ( LOG_HILO * (pi/2.0) ** 0.5 )
      TERM4 = EXP( -1.0 * ( LOG_LO / SQRT2LSG ) ** 2 )
      TERM5 = EXP( -1.0 * ( LOG_HI / SQRT2LSG ) ** 2 )

      fAMS = ( TERM1*TERM2  +  TERM3*(TERM4-TERM5) )

      ! Second Piece of Function [T(%) = 100]
      DBlo_st = DBhi_st         ! Stokes Lower Bound [um]
      DBhi_st = 0.55 * DENSFAC  ! Stokes Upper Bound [um]

      TERM1 = ERF( LOG( DBhi_st/DGv ) / SQRT2LSG )
      TERM2 = ERF( LOG( DBlo_st/DGv ) / SQRT2LSG )
      fAMS = fAMS +  (TERM1 - TERM2)

      ! Third Piece of Function [T(%) = 1.0 - 0.6805 * (Dva - 0.55) ]
      DBlo_st = DBhi_st        ! Stokes Lower Bound [um]
      DBhi_st = 2.0 * DENSFAC  ! Stokes Upper Bound [um]

      LOG_LOHI = LOG( 550.0/2000.0 )
      LOG_HI   = LOG( DBhi_st/DGv )
      LOG_LO   = LOG( DBlo_st/DGv )

      TERM1 = LOG( DGv/DBhi_st ) / LOG_LOHI
      TERM2 =  ERF( LOG_HI / SQRT2LSG )
     &        -ERF( LOG_LO / SQRT2LSG )
      TERM3 = XXLSG / ( LOG_LOHI * (pi/2.0) ** 0.5 )
      TERM4 = EXP( -1.0 * ( LOG_LO / SQRT2LSG ) ** 2 )
      TERM5 = EXP( -1.0 * ( LOG_HI / SQRT2LSG ) ** 2 )

      fAMS = fAMS + TERM1 * TERM2  +  TERM3 * (TERM4-TERM5)

      ! Apply the Factor of 0.5 Consistent with Appendix B in Ensberg et
      ! al., 2013. Omit the total mass quantity since these are fractions
      ! we want.
      fAMS = 0.5 * fAMS

      END SUBROUTINE AERO_AMS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE HETCHEM_EXTRACT_AERO ( CONCVEC, C, R, L, WET_M2, WET_M3, 
     &                                  DE_WET )

c  Calculates the change in aerosol surface area due to heterogeneous
C  reactions and updates the CGRID array with this information.
  
C  History
C  May 2016: BM Created

C  Key Subroutines Called: none
C
C  Called by: Gas-Phase Chemistry Driver
      USE AERO_DATA, ONLY: EXTRACT_AERO, CALCMOMENTS, N_MODE, MOMENT2_CONC,
     &                     MOMENT3_CONC, AEROMODE_DIAM, AEROMODE_LNSG,
     &                     CHEM_M2DRY_INIT, CHEM_M3DRY_INIT, FIXED_SG
      USE AEROMET_DATA, ONLY: pi
      USE GRID_CONF, ONLY: NLAYS, NCOLS, NROWS
      USE PRECURSOR_DATA, ONLY: EXTRACT_PRECURSOR

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID

#endif
      IMPLICIT NONE
      
      REAL, INTENT( IN ) :: CONCVEC ( : )  ! pointer to model concentrations
      REAL, PARAMETER    :: TWOTHIRDS = 2.0 / 3.0
      REAL               :: M2DRY_FINAL( N_MODE ) ! Dry 2nd Aerosol Moment
      REAL               :: M3DRY_FINAL( N_MODE ) ! Dry 3rd Aerosol Moment
      INTEGER            :: C, R, L, N
      REAL( 8 ), INTENT(OUT) :: WET_M2( : ), WET_M3( : ), DE_WET( : )
      LOGICAL, SAVE      :: FIRSTIME = .TRUE.

      IF ( FIRSTIME ) THEN
          FIRSTIME = .FALSE.
          ALLOCATE( CHEM_M2DRY_INIT( NCOLS,NROWS,NLAYS,N_MODE ),
     &              CHEM_M3DRY_INIT( NCOLS,NROWS,NLAYS,N_MODE ) )

      END IF

C *** extract grid cell concentrations of aero species from CGRID
C     into aerospc_conc in aero_data module
C     also converts dry surface area to wet second moment
#ifdef sens
               CALL EXTRACT_AERO ( CONCVEC(:), .TRUE., SENGRID(NCOLS,NROWS,NLAYS,:,:), .FALSE. )
#else
               CALL EXTRACT_AERO ( CONCVEC(:), .TRUE. )
#endif

C *** extract in inorganic aerosol processors

               CALL EXTRACT_PRECURSOR( CONCVEC(:) ) 
 
C *** Update geometric mean diameters, geometric
C     standard deviations, modal mass totals, and modal particle
C     densities, based on the concentrations of M2, M0, and speciated
C     masses.
               CALL getpar( FIXED_sg )
     
C *** set up variables needed for calculating KN2O5 and YIELD_CLNO2

               DO N = 1, N_MODE
C *** estimate the "wet third moments" from moment3_conc
C     Note: this is the H2O concentration from previous time step
                  WET_M3( N ) = REAL( MOMENT3_CONC( N ), 8 )
C *** calculate "wet second moment" assuming that H2O does not
C     affect the geometric standard deviation
                  WET_M2( N ) = REAL( MOMENT2_CONC( N ), 8 ) 
C *** The "wet" geometric mean (same as median) diameter was updated in
C     getpar. It is stored in aeromode_diam
C *** calculate effective diameter (this is actually the mean) using Eq 3 of Pleim et al (1995)
                  DE_WET( N ) = REAL( AEROMODE_DIAM( N ) * EXP( 1.5 * AEROMODE_LNSG( N ) ** 2 ), 8)
               END DO

C *** Retrieve and Save the Dry 3rd and 2nd Moments
               CALL calcmoments( .False. )
               CHEM_M2DRY_INIT( C,R,L,: ) = REAL( MOMENT2_CONC( : ), 8 )
               CHEM_M3DRY_INIT( C,R,L,: ) = REAL( MOMENT3_CONC( : ), 8 )

      END SUBROUTINE HETCHEM_EXTRACT_AERO

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      SUBROUTINE HETCHEM_UPDATE_AERO ( CGRID )

c  Calculates the change in aerosol surface area due to heterogeneous
C  reactions and updates the CGRID array with this information.
C  
C  History
C  May 2016: BM Created

C  Key Subroutines Called: none
C
C  Called by: Gas-Phase Chemistry Driver
      USE AERO_DATA
      USE AEROMET_DATA, ONLY: pi
      USE GRID_CONF, ONLY: NLAYS, NROWS, NCOLS

      IMPLICIT NONE
      
      REAL, POINTER   :: CGRID ( :,:,:,: )  ! pointer to model concentrations
      REAL, PARAMETER :: TWOTHIRDS = 2.0 / 3.0
      REAL            :: M2DRY_FINAL( N_MODE ) ! Dry 2nd Aerosol Moment
      REAL            :: M3DRY_FINAL( N_MODE ) ! Dry 3rd Aerosol Moment
      INTEGER L, R, C, M 

      LOOP_LAY: DO L = 1, NLAYS
         LOOP_ROW: DO R = 1, NROWS
            LOOP_COL: DO C = 1, NCOLS   
      
               ! Extract grid cell concentrations of aero species from CGRID
               ! into aerospc_conc in aero_data module
               ! also converts dry surface area to wet second moment
#ifdef sens
               CALL EXTRACT_AERO ( CGRID( C,R,L,: ), .TRUE., CGRID(C,R,:,: ), .FALSE. )
#else
               CALL extract_aero ( CGRID( C,R,L,: ), .True. )
#endif

               ! Recalculate Dry 3rd Moment After Chemistry Processes
               ! 2nd moment hasnt been update yet.
               CALL calcmoments( .False. )
               M2DRY_FINAL( : ) = MOMENT2_CONC( : )
               M3DRY_FINAL( : ) = MOMENT3_CONC( : )

               ! Calculate new Second Moment Manually
               ! Assume standard deviation is fixed.
               M2DRY_FINAL( : ) = REAL( CHEM_M2DRY_INIT( C,R,L,: ) ) 
     &             * ( M3DRY_FINAL( : ) 
     &             / REAL( CHEM_M3DRY_INIT( C,R,L,: ) ) ) ** TWOTHIRDS

               ! Update the Aerosol Surface Area making sure to multiply
               ! the 2nd moment by Pi to convert properly
               DO M = 1, N_MODE
                 CGRID( C,R,L, aerosrf_map( M ) ) = 
     &                        PI * M2DRY_FINAL( M )
               END DO

            END DO LOOP_COL
         END DO LOOP_ROW
      END DO LOOP_LAY

      END SUBROUTINE HETCHEM_UPDATE_AERO
C
 

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/getfline.f,v 1.3 2011/10/21 16:10:18 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      INTEGER FUNCTION GETFLINE( IDEV, DESCRIPT )

C----------------------------------------------------------------------
C Description: 
C    Counts the number of lines in an ASCII file
 
C Preconditions:
C    File opened and unit number provided
 
C Subroutines and Functions Called:  M3EXIT
 
C Revision History:
C      prototype 10/98 by M Houyoux
C      02/11: S.Roselle-removed deprecated TRIMLEN

C----------------------------------------------------------------------
C Modified from:

C Project Title: EDSS Tools Library
C File: @(#)$Id: getfline.f,v 1.3 2011/10/21 16:10:18 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/getfline.f,v $
C Last updated: $Date: 2011/10/21 16:10:18 $ 
C----------------------------------------------------------------------

      IMPLICIT NONE

C Arguments:

      INTEGER       IDEV         ! Unit number for ASCII file
      CHARACTER(*)  DESCRIPT     ! Description of file

C External Functions:

C Local Variables:

      INTEGER       L1           ! length of DESCRIPT
      INTEGER       ICNT         ! line counter
      INTEGER       IOS          ! i/o status

      CHARACTER      BUFFER      ! ASCII LINE from X-ref file
      CHARACTER(256) MESG        ! Message buffer

      CHARACTER(16) :: PROGNAME = 'GETFLINE' ! program name

C----------------------------------------------------------------------

      L1 = LEN_TRIM( DESCRIPT )

      REWIND( IDEV )

      ICNT = 0

C Loop through lines of file, counting the lines
11    CONTINUE

          READ( IDEV, 93000, IOSTAT=IOS, END=22 ) BUFFER
 
          ICNT = ICNT + 1
 
          IF ( IOS .GT. 0 ) THEN
              WRITE( MESG,94010 )
     &              'I/O error', IOS,
     &              'scanning ' // DESCRIPT( 1:L1 ) // 
     &              ' file at line', ICNT
              CALL M3EXIT( PROGNAME, 0, 0, MESG, 2 )
          END IF

      GO TO 11

22    CONTINUE

      GETFLINE = ICNT  

      REWIND( IDEV )

      RETURN

93000 FORMAT( A )
94010 FORMAT( 10( A, :, I6, :, 2X ) )

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SCIPROC ( CGRID, JDATE, JTIME, TSTEP, ASTEP )

C-----------------------------------------------------------------------
C Function:
C    Controls all of the physical and chemical processes for a grid
C    Operator splitting symmetric around chemistry
 
C Preconditions:
C    Dates and times represented YYYYDDD:HHMMSS.
C    No "skipped" dates and times.  All boundary input variables (layered or
C    non-layered) have the same perimeter structure with a thickness of NTHIK
 
C Subroutines and functions called:
C    All physical and chemical subroutines, 
C    DECOUPLE, COUPLE
 
C Revision History:
C    Oct. 24, 1995 by M. Talat Odman and Clint L. Ingram at NCSC: created
C    13 Dec 97 - Jeff - uncouple diffusion processes
C    27 Jun 98 - Jeff - sync step = chem step
C     7 Jul 01 - Shawn - mv cloud processing before chem
C       Jan 02 - Jeff - dyn alloc; remove PCGRID argument to ping
C    23 Jun 03 J.Young: for layer dependent advection tstep
C    18 Aug 03 J. Pleim - move vdiff before advection
C    29 Aug 03 J.Young: eliminate symmetric processing option and unused
C                       SUBST_GRID_ID string
C    30 May 05 J.Young: mass-conserving advection (yamo)
C     7 Jul 07 J.Young: No cksummer call after HADV - delay possible truncation of
C                       HADV negative conc's until after ZADV
C    25 Jul 08 S.Roselle: removed PING from modeled processes
C    16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    25 Mar 16 R.Mathur: incorporated pot. vorticity strat. O3 scaling
C    16 Sep 16 J.Young: update for inline procan (IPR)
C    10 July 19 F. Sidi: Renamed Couple_WRF to be couple
C-----------------------------------------------------------------------

      USE UTILIO_DEFN, ONLY: DT2STR, WKDAY
      USE RUNTIME_VARS, ONLY: LOGDEV, OUTDEV, MYPE, CKSUM, 
     &                        PRINT_PROC_TIME, WEEKDAY, 
     &                        LOG_MESSAGE, TIMING_SPLIT, STM,
     &                        COLUMN_MODEL
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
      USE PA_DEFN, Only: LIPR   ! Process Analysis control and data variables

#ifdef isam
      USE SA_DEFN, Only: ISAM
      USE GRID_CONF
      USE CGRID_SPCS, ONLY: NSPCSD
#endif

      USE STM_MODULE, ONLY: STM_WRAP_GAS, STM_WRAP_AE

      IMPLICIT NONE   

#ifdef parallel
      INCLUDE 'mpif.h'
#endif
C Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )

      INTEGER, INTENT(INOUT) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT(INOUT) :: JTIME        ! current model time, coded HHMMSS
      INTEGER, INTENT(IN)    :: TSTEP( 3 )   ! time step vector (HHMMSS)
                                             ! TSTEP(1) = local output step
                                             ! TSTEP(2) = sciproc sync. step (chem)
                                             ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                             !            step and wrf/cmaq call frequency

      INTEGER, INTENT(IN)    :: ASTEP( : )   ! layer advection time step

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'SCIPROC'
      CHARACTER( 120 ) :: XMSG = ' '
      CHARACTER( 36 ) :: NMSG = 'After NEXTIME: returned JDATE, JTIME'

      INTEGER         ::     SDATE       ! current science process date, coded YYYYDDD
      INTEGER         ::     STIME       ! current science process time, coded HHMMSS
 
      REAL            :: REAL_TIME

      REAL( 8 )       :: CPU_TIME_START  ! Timing individual
      REAL( 8 )       :: CPU_TIME_START_MASTER
      CHARACTER( 24 ) :: CDATE_TIME

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: CGRID0( :,:,:,: )
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
#endif
      INTERFACE
         SUBROUTINE CKSUMMER ( PNAME, CGRID, JDATE, JTIME )
            CHARACTER( * ), INTENT( IN ) :: PNAME
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
         END SUBROUTINE CKSUMMER
         SUBROUTINE PA_UPDATE ( PNAME, CGRID, JDATE, JTIME, TSTEP )
            CHARACTER( * ), INTENT( IN ) :: PNAME
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE PA_UPDATE
         SUBROUTINE HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
            INTEGER, INTENT( IN )     :: ASTEP( : )
         END SUBROUTINE HADV
         SUBROUTINE ZADV ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE ZADV
         SUBROUTINE COUPLE ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE COUPLE
         SUBROUTINE DECOUPLE ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE DECOUPLE
         SUBROUTINE HDIFF ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE HDIFF
         SUBROUTINE VDIFF ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE VDIFF
         SUBROUTINE PHOT ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( : )
         END SUBROUTINE PHOT
         SUBROUTINE CLDPROC ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE CLDPROC
         SUBROUTINE CHEM ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE CHEM
#ifdef potvorto3
         SUBROUTINE PVO3 ( CGRID, JDATE, JTIME )
            IMPLICIT NONE
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
         END SUBROUTINE PVO3
#endif
         SUBROUTINE AERO ( CGRID, JDATE, JTIME, TSTEP )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE, JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE AERO
#ifdef isam
         SUBROUTINE SA_WRAP_AE( CGRID0, CGRID, JDATE, JTIME, TSTEP )
            IMPLICIT NONE
            REAL                      :: CGRID0( :,:,:,: )
            REAL, POINTER             :: CGRID( :,:,:,: )
            INTEGER, INTENT( IN )     :: JDATE
            INTEGER, INTENT( IN )     :: JTIME
            INTEGER, INTENT( IN )     :: TSTEP( 3 )
         END SUBROUTINE SA_WRAP_AE
#endif
      END INTERFACE
  
C-----------------------------------------------------------------------
#ifdef isam
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ALLOCATE( CGRID0( NCOLS,NROWS,NLAYS,NSPCSD ) )
      END IF
#endif

! Write Time Step Information to Summary Logfile
      IF ( MYPE .EQ. 0 ) WRITE( OUTDEV, * ) 
      WRITE( LOGDEV, * )

#ifdef parallel
            CPU_TIME_START =  MPI_WTIME()
#else
            CALL CPU_TIME( REAL_TIME )
            CPU_TIME_START = REAL( REAL_TIME,8 )
#endif
      CPU_TIME_START_MASTER = CPU_TIME_START
      WRITE( XMSG, '(A,I7.7,A,I6.6)' ), 'Processing Day/Time [YYYYDDD:HHMMSS]: ',JDATE, 
     &       ':',JTIME
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
      CALL LOG_MESSAGE( LOGDEV, XMSG )

      CDATE_TIME = DT2STR( JDATE, JTIME )
      WRITE( XMSG, '(2x,6A)' ), 'Which is Equivalent to (UTC): ',
     &       CDATE_TIME(1:8),' ',TRIM( WEEKDAY( WKDAY( JDATE ) ) ),
     &       ',', CDATE_TIME(9:)
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
      CALL LOG_MESSAGE( LOGDEV, XMSG )

      WRITE( XMSG, '(2x,A,I6.6)' ), 'Time-Step Length (HHMMSS): ',TSTEP(2) 
      IF ( MYPE .EQ. 0 ) CALL LOG_MESSAGE( OUTDEV, XMSG )
      CALL LOG_MESSAGE( LOGDEV, XMSG )

C Synchronization Step Physical Processes Sequence
      CALL VDIFF ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'VDIFF', CGRID, JDATE, JTIME )
      IF ( LIPR ) CALL PA_UPDATE ( 'VDIF', CGRID, JDATE, JTIME, TSTEP )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'VDIFF' )


      IF ( .NOT. COLUMN_MODEL ) THEN
C couple CGRID for advection and horizontal diffusion
C The COUPLE routine converts aerosol mass from ug/m3 to kg/m3. The 
C DECOUPLE routine converts it back to ug/m3.

         CALL COUPLE ( CGRID, JDATE, JTIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'COUPLE', CGRID, JDATE, JTIME )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'COUPLE' )
         
         CALL SUBST_BARRIER()
         CALL HADV ( CGRID, JDATE, JTIME, TSTEP, ASTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'HADV', CGRID, JDATE, JTIME )
         IF ( LIPR ) CALL PA_UPDATE ( 'HADV', CGRID, JDATE, JTIME, TSTEP )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'HADV' )
         
         CALL ZADV ( CGRID, JDATE, JTIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'ADV', CGRID, JDATE, JTIME )
         IF ( LIPR ) CALL PA_UPDATE ( 'ZADV', CGRID, JDATE, JTIME, TSTEP )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'ZADV' )
         
         CALL HDIFF ( CGRID, JDATE, JTIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'HDIFF', CGRID, JDATE, JTIME )
         IF ( LIPR ) CALL PA_UPDATE ( 'HDIF', CGRID, JDATE, JTIME, TSTEP )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'HDIFF' )

C decouple CGRID for cloud and chemistry

         SDATE = JDATE
         STIME = JTIME
         CALL NEXTIME ( SDATE, STIME, TSTEP( 2 ) )
         
         CALL DECOUPLE ( CGRID, SDATE, STIME, TSTEP )
         IF ( CKSUM ) CALL CKSUMMER ( 'DECOUPLE', CGRID, JDATE, JTIME )
         IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'DECOUPLE' )

      END IF
      
      CALL PHOT ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'PHOT', CGRID, JDATE, JTIME )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'PHOT' )

      CALL CLDPROC ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'CLDPROC', CGRID, JDATE, JTIME )
      IF ( LIPR ) CALL PA_UPDATE ( 'CLDS', CGRID, JDATE, JTIME, TSTEP )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'CLDPROC' )

      IF ( STM ) CALL STM_WRAP_GAS ( CGRID, JDATE, JTIME, .TRUE. )
      CALL CHEM ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'CHEM', CGRID, JDATE, JTIME )
      IF ( LIPR ) CALL PA_UPDATE ( 'CHEM', CGRID, JDATE, JTIME, TSTEP ) 
      IF ( STM ) CALL STM_WRAP_GAS ( CGRID, JDATE, JTIME, .FALSE. )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'CHEM' )

#ifdef potvorto3
      CALL PVO3 ( CGRID, JDATE, JTIME )
      IF ( CKSUM ) CALL CKSUMMER ( 'PVO3', CGRID, JDATE, JTIME )
      IF ( LIPR ) CALL PA_UPDATE ( 'PVO3', CGRID, JDATE, JTIME, TSTEP )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'PVO3' )
#endif

#ifdef isam
      CGRID0  = CGRID
#endif

      CALL AERO ( CGRID, JDATE, JTIME, TSTEP )
      IF ( CKSUM ) CALL CKSUMMER ( 'AERO', CGRID, JDATE, JTIME )
      IF ( LIPR ) CALL PA_UPDATE_AERO ( CGRID, JDATE, JTIME, TSTEP )
      IF ( PRINT_PROC_TIME ) CALL TIMING_SPLIT ( CPU_TIME_START, 1, 'AERO' )
      IF ( STM ) CALL STM_WRAP_AE ( CGRID, JDATE, JTIME )

#ifdef isam
      CALL SA_WRAP_AE( CGRID0, CGRID, JDATE, JTIME, TSTEP )
#endif

      CALL NEXTIME ( JDATE, JTIME, TSTEP( 2 ) )
      WRITE( LOGDEV,'(/ 5X, A, I8, I7.6)' ) NMSG, JDATE, JTIME

! Print Summary Timing for Master time step      
      CALL TIMING_SPLIT ( CPU_TIME_START_MASTER, 2 )

1002  FORMAT ( 2x, A15, ' completed... ', F6.1, ' seconds' )

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       SUBROUTINE PA_OUTPUT( CGRID, JDATE, JTIME )

C-----------------------------------------------------------------------
C Function: Output the Process Analysis and/or Integrated Reaction Rate data           
 
C Preconditions: None
 
C Key Subroutines/Functions Called: M3EXIT
 
C Revision History:
C  Prototype created by Jerry Gipson, August, 1996
C  allow env var for file names Jeff, Dec, 1996
C  Modified May, 1997 by Jerry Gipson to be consistent with beta CTM
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified 1/19/99 by David Wong at LM:
C        -- add four include files because of new PA_CMN.EXT
C        -- add DATA_COPY function call to redistribute PA grid
C  Modified 2/26/99 by David Wong at LM:
C        -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC,
C           three .EXT files
C        -- replaced DATA_COPY function with dimension specific
C           DATA_COPY function and modified its argument list
C        -- used ifdef statement to distinguish parallel
C           implementation of IRR calculation which does not
C           start at the origin
C  Modified 22 Nov 00 by J.Young: Dave Wong's f90 stenex DATA_COPY
C  30 Mar 01 J.Young: dyn alloc - Use PAGRD_DEFN, which Uses
C                                 HGRD_DEFN; requires DBUFF for WRITE3
C  10 Oct 01 David Wong
C        -- use DBUFF to hold the output data for IRR data since
C           parallel WRITE3 can't output subsection of data
C        -- removed the usage of DBUFF for PA output
C        -- used a new formula to compute number of indexes in
C           each IPR and IRR output file rather than file header
C           to remove the call of DESC3 and use IPRFNAM and 
C           IRRNAME to determine variable name
C  10 Sep 02 J.Young: fix bug in IPRNAME, IRRNAME index
C  31 Jan 05 J.Young: dyn alloc - establish both horizontal &
C                     vertical domain specifications in one module (GRID_CONF)
C  23 Aug 05 David Wong
C        -- inserted PIO_INIT subroutine calls before and after
C           outputing PA data which is smaller than the model
C           domain size, to compute data indices correctly in each
C           processor for the entire PARIO library functions
C  15 Feb 06 J.Young: new pario PIO_RE_INIT from PIO_INIT to add flag
C                     to control printing decomposition map
C  10 Jul 10 J.Young: restructure so as to not keep reallocating DBUFF for IRR
C  16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C  26 Jan 16 J.Young: consolidated pio_init, flag for couple/decouple
C  16 Sep 16 J.Young: update for inline procan
C   7 Oct 16 J.Young: write domain re-decomp to log only on first call
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE PAGRD_DEFN            ! PA horiz domain specs
      USE UTILIO_DEFN           ! inherits PARUTILIO
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE, SE_DATA_COPY_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE, NOOP_DATA_COPY_MODULE)
#endif
      USE PA_DEFN               ! Process Anaylsis control and data variables

      IMPLICIT NONE 

C Includes:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: JDATE    ! current model date, format YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME    ! current model time, format HHMMSS

C Parameters: None 

C External Functions: None 

C Local Variables: 
      CHARACTER( 16 ), SAVE :: PNAME = 'PA_OUTPUT'
      CHARACTER( 16 ), SAVE :: IPRFNAM( MXFILE3 )  ! IPR output file names
      CHARACTER( 16 ), SAVE :: IRRFNAM( MXFILE3 )  ! IRR output file names
      INTEGER, SAVE :: NIPRFLS          ! Number of IPR output files
      INTEGER, SAVE :: NIRRFLS          ! Number of IRR output files
      LOGICAL, SAVE :: LFIRST = .TRUE.  ! Flag for first call

      CHARACTER( 80 ) ::  XMSG = ' '    ! Error message buffer

      INTEGER C         ! Loop index for columns
      INTEGER ICG       ! Index for species in cgrid array
      INTEGER L         ! Loop index for layers
      INTEGER NIRR      ! Loop index for IRR output variables
      INTEGER NFL       ! Loop index for no. of files
      INTEGER NOUT      ! Loop index for PA output variables
      INTEGER NS        ! Loop index for number cgrid concs saved
      INTEGER R         ! Loop index for rows
#ifndef parallel
      INTEGER PC        ! index for window column
      INTEGER PR        ! index for window row
      INTEGER PL        ! index for window level
#endif
      INTEGER VARINDX   ! Index for output variable
      INTEGER NVARINDX  ! number of output variable
     
#ifdef parallel
      CHARACTER( 2 ) :: COLROW = 'CR'  ! col/row arg list order for pio_re_init
      LOGICAL :: WFLG                  ! pio_init - print decomposition
#endif

C-----------------------------------------------------------------------

#ifdef parallel
      IF ( .NOT. LFIRST ) THEN
C Reset decomposition map
         IF ( .NOT. PIO_INIT( COLROW, PACOLS, PAROWS, PALEVS, NTHIK,
     &                        MY_PACOLS, MY_PAROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
      END IF
#endif

C On first call, get and save the output file names 
      IF ( LFIRST ) THEN

#ifdef parallel
C Reset decomposition map
         IF ( .NOT. PIO_INIT( COLROW, PACOLS, PAROWS, PALEVS, NTHIK,
     &                        MY_PACOLS, MY_PAROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE, wflg = WFLG ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
#endif

         IF ( LIPR .AND. NIPRVAR. GT. 0 ) THEN

            IF ( MOD( NIPRVAR, MXVARS3 ) .EQ. 0 ) THEN
               NIPRFLS = NIPRVAR / MXVARS3
            ELSE
               NIPRFLS = ( NIPRVAR / MXVARS3 ) + 1
            END IF

            DO NFL = 1, NIPRFLS

               IF ( NFL .EQ. 1 ) THEN
                  IPRFNAM( NFL ) = CTM_IPR_1
               ELSE IF ( NFL .EQ. 2 ) THEN
                  IPRFNAM( NFL ) = CTM_IPR_2
               ELSE IF ( NFL .EQ. 3 ) THEN
                  IPRFNAM( NFL ) = CTM_IPR_3
               ELSE IF ( NFL .GT. 3 ) THEN
                  XMSG = 'Maximum number of IPR output files exceeded'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF

               IF ( MYPE .EQ. 0 ) THEN
                  IF ( .NOT. OPEN3( IPRFNAM( NFL ), FSRDWR3, PNAME ) ) THEN
                     XMSG = 'Could not open Integrated Process Rate Output File: '
     &                    // IPRFNAM( NFL )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF

            END DO

         END IF

         IF ( LIRR .AND. NIRRVAR. GT. 0 ) THEN

            IF ( MOD( NIRRVAR, MXVARS3 ) .EQ. 0 ) THEN
               NIRRFLS = NIRRVAR / MXVARS3
            ELSE
               NIRRFLS = ( NIRRVAR / MXVARS3 ) + 1
            END IF

            DO NFL = 1, NIRRFLS
  
               IF ( NFL .EQ. 1 ) THEN
                  IRRFNAM( NFL ) = CTM_IRR_1
               ELSE IF ( NFL .EQ. 2 ) THEN
                  IRRFNAM( NFL ) = CTM_IRR_2
               ELSE IF ( NFL .EQ. 3 ) THEN
                  IRRFNAM( NFL ) = CTM_IRR_3
               ELSE IF ( NFL .GT. 3 ) THEN
                  XMSG = 'Maximum number of IRR output files exceeded'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
               END IF

               IF ( MYPE .EQ. 0 ) THEN
                  IF ( .NOT. OPEN3( IRRFNAM( NFL ), FSRDWR3, PNAME ) ) THEN
                     XMSG = 'Could not open Integrated Reaction Rate Output File: '
     &                    // IRRFNAM( NFL )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               END IF

            END DO

         END IF

      END IF    ! LFIRST

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Output Process analysis data and re-initialize arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIPR ) THEN

         DO NFL = 1, NIPRFLS

            NVARINDX = MIN ( MXVARS3, NIPRVAR - (NFL - 1) * MXVARS3 )

            DO NOUT = 1, NVARINDX
               VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT

               IF ( .NOT. WRITE3( IPRFNAM( NFL ), IPRNAME( VARINDX ),
     &                 JDATE, JTIME, DELC( :,:,:,VARINDX ) ) ) THEN 
                  XMSG = 'Could not write ' // IPRFNAM( NFL )
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

            END DO

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &            'Timestep written to', IPRFNAM( NFL ),
     &            'for date and time', JDATE, JTIME
         END DO

         DO  NOUT = 1, NIPRVAR
            DO L = 1, PALEVS
               DO R = 1, MY_PAROWS
                  DO C = 1, MY_PACOLS
                     DELC( C,R,L,NOUT ) = 0.0
                  END DO
               END DO
            END DO
         END DO

         DO NS = 1, NCSAVE
            ICG = SAV2GRD( NS )
#ifdef parallel
            CALL SUBST_DATA_COPY ( CGRID, CSAV, ICG, NS )
#else
            DO L = PA_BEGLEV, PA_ENDLEV
               PL = L - PA_BEGLEV + 1
               DO R = MY_BEGROW, MY_ENDROW
                  PR = R - MY_BEGROW + 1
                  DO C = MY_BEGCOL, MY_ENDCOL
                     PC = C - MY_BEGCOL + 1
                     CSAV( PC,PR,PL,NS ) = CGRID( C,R,L,ICG ) 
                  END DO
               END DO
            END DO
#endif
         END DO

      END IF   ! IPR

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
C  Output the IRR data and re-initialize arrays
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      IF ( LIRR ) THEN

         DO NFL = 1, NIRRFLS

            NVARINDX = MIN (MXVARS3, NIRRVAR - (NFL - 1) * MXVARS3)

            DO NOUT = 1, NVARINDX
               VARINDX = ( NFL - 1 ) * MXVARS3 + NOUT

#ifdef parallel
!              write( logdev,* ) 'paout-nout,varindx,my_pacols,etc,sizes: ',
!    &         nout, varindx, my_pacols, my_parows, palevs,
!    &         size( irrout,1 ), size( irrout,2 ), size( irrout,3 ),
!    &         size( irrout,4 ), size( tirrout,1 ), size( tirrout,2 ),
!    &         size( tirrout,3 ), size( dbuff,1 ), size( dbuff,2 ),
!    &         size( dbuff,3 ) 
               CALL SUBST_DATA_COPY ( IRROUT, DBUFF, VARINDX )
#else
               DBUFF = IRROUT( 1:MY_PACOLS,1:MY_PAROWS,1:PALEVS,VARINDX )
#endif
               IF ( .NOT. WRITE3( IRRFNAM( NFL ), IRRNAME( VARINDX ),
     &              JDATE, JTIME, DBUFF ) ) THEN 
                  XMSG = 'Could not write ' // IRRFNAM( NFL )
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF

            END DO

            WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &            'Timestep written to', IRRFNAM( NFL ),
     &            'for date and time', JDATE, JTIME

         END DO

         DO NIRR = 1, NIRRVAR
#ifdef parallel
         DO L = MY_IRR_BEGLEV, MY_IRR_ENDLEV
            DO R = MY_IRR_BEGROW, MY_IRR_ENDROW
               DO C = MY_IRR_BEGCOL, MY_IRR_ENDCOL
#else
         DO L = 1, PALEVS
            DO R = 1, MY_PAROWS
               DO C = 1, MY_PACOLS
#endif
                      IRROUT( C,R,L,NIRR ) = 0.0
                  END DO
               END DO
            END DO
         END DO

      END IF   ! IRR

#ifdef parallel
      IF ( .NOT. LFIRST ) THEN
C Reset decomposition map
         IF ( .NOT. PIO_INIT( COLROW, GL_NCOLS, GL_NROWS, NLAYS, NTHIK,
     &                        NCOLS, NROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
      ELSE
         IF ( .NOT. PIO_INIT( COLROW, GL_NCOLS, GL_NROWS, NLAYS, NTHIK,
     &                        NCOLS, NROWS, NPCOL, NPROW, NPCOL*NPROW,
     &                        MYPE, wflg = WFLG ) ) THEN
            XMSG = 'Failed to re-initialize parallel I/O library.'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            RETURN
         END IF
      END IF
#endif

      IF ( LFIRST ) THEN
         LFIRST = .FALSE.
      END IF

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

! RCS file, release, date & time of last delta, author, state, [and locker]
! $Header: /amber/home/krt/cmq471/models/CCTM/src/vdiff/acm2_inline/tri.F,v 1.1.1.1 2010/06/14 16:03:07 sjr Exp $ 

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE SA_TRI ( L, D, U, B, X )
C-----------------------------------------------------------------------
C20140428   Called by vdiffacm2.F
C
C  FUNCTION:
C    Solves tridiagonal system by Thomas algorithm.  Algorithm fails
C    ( M3ERR ) if first pivot is zero.  In that case, rewrite the
C    equation as a set of order KMAX-1, with X(2) trivially eliminated.
C The associated tri-diagonal system is stored in 3 arrays
C   D : diagonal
C   L : sub-diagonal
C   U : super-diagonal
C   B : right hand side function
C   X : return solution from tridiagonal solver

C     [ D(1) U(1) 0    0    0 ...       0     ]
C     [ L(2) D(2) U(2) 0    0 ...       .     ]
C     [ 0    L(3) D(3) U(3) 0 ...       .     ]
C     [ .       .     .     .           .     ] X(i) = B(i)
C     [ .             .     .     .     0     ]
C     [ .                   .     .     .     ]
C     [ 0                           L(n) D(n) ]

C   where n = NLAYS

C  PRECONDITIONS REQUIRED:
C    Dimensionality set up in terms of NLAYS from SUBST_VGRD_ID

C  SUBROUTINES AND FUNCTIONS CALLED:

C  REVISION HISTORY:
C    NO.   DATE     WHO      WHAT
C    __    ____     ___      ____
C    5     Apr 06   JEP   adapted tridiag for use with ACM2
C    4     Aug 96    yoj  cleaner
C    3     8/16/94   XKX  configuration management include statements
C    2     3/15/92   CJC  For use in Models-3 LCM.
C    1     10/19/89  JKV  converted for use on IBM
C    0      3/89     BDX  Initial version
C-----------------------------------------------------------------------

      USE VGRD_DEFN           ! vertical layer specifications
      USE SA_DEFN             ! Mc06

      IMPLICIT NONE


C Arguments:

      REAL, INTENT( IN )  :: L( : )      ! subdiagonal
      REAL, INTENT( IN )  :: D( : )      ! diagonal
      REAL, INTENT( IN )  :: U( : )      ! superdiagonal
      REAL, INTENT( IN )  :: B( :,: )    ! R.H. side
      REAL, INTENT( OUT ) :: X( :,: )    ! solution

C Local Variables:

      REAL        GAM( NLAYS )
      REAL        BET
      INTEGER     V, K

C Decomposition and forward substitution:
      BET = 1.0 / D( 1 )
      DO V = 1, N_SPCTAG
         X( V,1 ) = BET * B(V,1 )
      END DO

      DO K = 2, NLAYS
         GAM( K ) = BET * U( K-1 )
         BET = 1.0 / ( D( K ) - L( K ) * GAM( K ) )
	 DO V = 1, N_SPCTAG
            X( V, K ) = BET * ( B( V,K ) - L( K ) * X( V,K-1 ) )
	 END DO
      END DO

C Back-substitution:

      DO K = NLAYS - 1, 1, -1
         DO V = 1, N_SPCTAG
            X( V,K ) = X( V,K ) - GAM( K+1 ) * X( V,K+1 )
         END DO
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module stm_module

C  Contains:
C     Subroutines stm_wrap_ae
C                 stm_wrap_gas

C  Revision History:
C SR 12/13/2018 Initial version

C----------------------------------------------------------------------

      Implicit None

      Logical, Private, Save :: stm_mapped = .False.

      Real, Allocatable :: aero_conc( :,: ) ! aero species concentration [ ug/m^3 ]

      Contains

C-----------------------------------------------------------------------
      Subroutine stm_wrap_ae ( cgrid, jdate, jtime )

C  capture changes from aero proc (changes in aso4 from new particle
C     formation and condensation)

C  Revision History:
C     Initial version - 6/5/19 - Shawn Roselle
C
C-----------------------------------------------------------------------
      Use grid_conf, Only: ncols, nrows, nlays
      Use runtime_vars, Only: adj_stmspc
      Use rxns_data, only: mechname       ! chemical mechanism data
      Use aero_budget, Only: aero_cond, aero_npf
      Use aero_data, Only : aso4_idx, aso4aqh2o2_idx, aso4aqo3_idx,
     &                      aso4aqfemn_idx, aso4aqmhp_idx, aso4aqpaa_idx,
     &                      aso4gas_idx, aso4emis_idx, aso4icbc_idx,
     &                      oso4aqh2o2_idx, oso4aqo3_idx, oso4aqfemn_idx,
     &                      oso4aqmhp_idx, oso4aqpaa_idx, oso4_idx,
     &                      oso4gas_idx, oso4emis_idx, oso4icbc_idx,
     &                      aerospc_map, aerospc_mw, aerospc,
     &                      n_mode, ae6isoa,
     &                      findAero
      Use stm_vars, Only: organosulf

      Implicit None

C Arguments

      Real, Pointer :: cgrid( :,:,:,: )

      Integer, Intent( In ) :: jdate
      Integer, Intent( In ) :: jtime

C Local variables

      Integer c, r, l, m

      Real aso4tot, oso4tot
      Real mscor

      Do c = 1, ncols
         Do r = 1, nrows
            Do l = 1, nlays

C extract aerosol species from CGRID

               Call stm_extract_aero ( cgrid( c,r,l,: ) )

               Do m = 1, n_mode
                  aero_conc( aso4gas_idx, m ) =
     &                     Max( ( aero_conc( aso4gas_idx, m )
     &                          + aero_cond( c,r,l,aerospc_map( aso4_idx,m ) )
     &                          + aero_npf ( c,r,l,aerospc_map( aso4_idx,m ) ) ),
     &                          aerospc( aso4gas_idx )%min_conc( m ) )
               End Do

C normalize tracked sulfate species to total modeled sulfate

               If ( adj_stmspc ) Then

                  Do m = 1, n_mode

                     aso4tot = aero_conc( aso4gas_idx, m )
     &                       + aero_conc( aso4emis_idx,m )
     &                       + aero_conc( aso4icbc_idx,m )

C...  for the accumulation mode, add aqueous tracked species

                     If ( m .Eq. 2 ) Then

                        aso4tot = aso4tot
     &                          + aero_conc( aso4aqh2o2_idx,m )
     &                          + aero_conc( aso4aqo3_idx,  m )
     &                          + aero_conc( aso4aqfemn_idx,m )
     &                          + aero_conc( aso4aqmhp_idx, m )
     &                          + aero_conc( aso4aqpaa_idx, m )

                     End If

C...  normalize sulfur tracking species

                     If ( aso4tot .Gt. 0.0 ) Then

                        aso4tot = Max( aso4tot,
     &                                 aerospc( aso4_idx )%min_conc( m ) )
                        mscor = Max( aero_conc( aso4_idx, m ),
     &                               aerospc( aso4_idx )%min_conc( m ) )
     &                        / aso4tot

                        aero_conc( aso4gas_idx, m ) =
     &                     Max( aero_conc( aso4gas_idx, m ) * mscor,
     &                          aerospc( aso4gas_idx )%min_conc( m ) )
                        aero_conc( aso4emis_idx, m ) =
     &                     Max( aero_conc( aso4emis_idx, m ) * mscor,
     &                          aerospc( aso4emis_idx )%min_conc( m ) )
                        aero_conc( aso4icbc_idx, m ) =
     &                     Max( aero_conc( aso4icbc_idx, m ) * mscor,
     &                          aerospc( aso4icbc_idx )%min_conc( m ) )

C...  for the accumulation mode, adjust aqueous tracked species

                        If ( m .Eq. 2 ) Then
                           aero_conc( aso4aqh2o2_idx, m ) =
     &                        Max( aero_conc( aso4aqh2o2_idx, m ) * mscor,
     &                             aerospc( aso4aqh2o2_idx )%min_conc( m ) )
                           aero_conc( aso4aqo3_idx, m ) =
     &                        Max( aero_conc( aso4aqo3_idx, m ) * mscor,
     &                             aerospc( aso4aqo3_idx )%min_conc( m ) )
                           aero_conc( aso4aqfemn_idx, m ) =
     &                        Max( aero_conc( aso4aqfemn_idx, m ) * mscor,
     &                             aerospc( aso4aqfemn_idx )%min_conc( m ) )
                           aero_conc( aso4aqmhp_idx, m ) =
     &                        Max( aero_conc( aso4aqmhp_idx, m ) * mscor,
     &                             aerospc( aso4aqmhp_idx )%min_conc( m ) )
                           aero_conc( aso4aqpaa_idx, m ) =
     &                        Max( aero_conc( aso4aqpaa_idx, m ) * mscor,
     &                             aerospc( aso4aqpaa_idx )%min_conc( m ) )
                        End If

                     End If

                     If ( organosulf ) Then

C...  in the current implementation of heterogeneous chemistry,
C...    only the accumulation mode sulfate can be converted to organosulfate

                        If ( m .Eq. 2 ) Then
                           oso4tot = aero_conc( oso4gas_idx, m )
     &                             + aero_conc( oso4emis_idx,m )
     &                             + aero_conc( oso4icbc_idx,m )
     &                             + aero_conc( oso4aqh2o2_idx,m )
     &                             + aero_conc( oso4aqo3_idx,  m )
     &                             + aero_conc( oso4aqfemn_idx,m )
     &                             + aero_conc( oso4aqmhp_idx, m )
     &                             + aero_conc( oso4aqpaa_idx, m )

                           If ( oso4tot .Gt. 0.0 ) Then

                              oso4tot = Max( oso4tot,
     &                                       aerospc( oso4_idx )%min_conc( m ) )
                              mscor = Max( aero_conc( oso4_idx, m ),
     &                                     aerospc( oso4_idx )%min_conc( m ) )
     &                              / oso4tot

                              aero_conc( oso4gas_idx, m ) =
     &                           Max( aero_conc( oso4gas_idx, m ) * mscor,
     &                                aerospc( oso4gas_idx )%min_conc( m ) )
                              aero_conc( oso4emis_idx, m ) =
     &                           Max( aero_conc( oso4emis_idx, m ) * mscor,
     &                                aerospc( oso4emis_idx )%min_conc( m ) )
                              aero_conc( oso4icbc_idx, m ) =
     &                           Max( aero_conc( oso4icbc_idx, m ) * mscor,
     &                                aerospc( oso4icbc_idx )%min_conc( m ) )
                              aero_conc( oso4aqh2o2_idx, m ) =
     &                           Max( aero_conc( oso4aqh2o2_idx, m ) * mscor,
     &                                aerospc( oso4aqh2o2_idx )%min_conc( m ) )
                              aero_conc( oso4aqo3_idx, m ) =
     &                           Max( aero_conc( oso4aqo3_idx, m ) * mscor,
     &                                aerospc( oso4aqo3_idx )%min_conc( m ) )
                              aero_conc( oso4aqfemn_idx, m ) =
     &                           Max( aero_conc( oso4aqfemn_idx, m ) * mscor,
     &                                aerospc( oso4aqfemn_idx )%min_conc( m ) )
                              aero_conc( oso4aqmhp_idx, m ) =
     &                           Max( aero_conc( oso4aqmhp_idx, m ) * mscor,
     &                                aerospc( oso4aqmhp_idx )%min_conc( m ) )
                              aero_conc( oso4aqpaa_idx, m ) =
     &                           Max( aero_conc( oso4aqpaa_idx, m ) * mscor,
     &                                aerospc( oso4aqpaa_idx )%min_conc( m ) )

                           End If
                        End If
                     End If

                  End Do

               End If

C update aerosol species in CGRID

               Call stm_update_aero ( cgrid( c,r,l,: ) )

            End Do
         End Do
      End Do

      Return

      End Subroutine stm_wrap_ae


C-----------------------------------------------------------------------
      Subroutine stm_wrap_gas ( cgrid, jdate, jtime, b4chem )

C  capture changes in aso4 from gas phase chemistry
C  in the current release, ASO4 can be lost in gas chem to form organo-sulfate
C
C     Initial version - 6/5/19 - Shawn Roselle
C-----------------------------------------------------------------------

      Use grid_conf, Only: ncols, nrows, nlays
      Use utilio_defn, Only: xstat1
      Use rxns_data, only: mechname       ! chemical mechanism data
      Use aero_data, Only : aso4_idx, aso4aqh2o2_idx, aso4aqo3_idx,
     &                      aso4aqfemn_idx, aso4aqmhp_idx, aso4aqpaa_idx,
     &                      aso4gas_idx, aso4emis_idx, aso4icbc_idx,
     &                      oso4aqh2o2_idx, oso4aqo3_idx, oso4aqfemn_idx,
     &                      oso4aqmhp_idx, oso4aqpaa_idx, oso4_idx,
     &                      oso4gas_idx, oso4emis_idx, oso4icbc_idx,
     &                      aerospc, n_mode, ae6isoa
      Use stm_vars, Only: organosulf

      Implicit None

C Arguments

      Real, Pointer :: cgrid( :,:,:,: )

      Integer, Intent( In ) :: jdate
      Integer, Intent( In ) :: jtime
      Logical, Intent( In ) :: b4chem

C local variables

      Character( 16 ) :: pname = 'STM_WRAP_GAS'
      Character( 96 ) :: xmsg = ' '

      Logical, Save :: firstime = .True.

      Integer c, r, l, m
      Integer allocstat

      Real fso4, omfso4
      Real, Save, Allocatable :: so4b4( :,:,:,: )

C-----------------------------------------------------------------------
C  begin body of subroutine stm_wrap_gas

      If ( firstime ) Then

         Allocate ( so4b4( ncols, nrows, nlays, n_mode ),
     &              Stat = allocstat )
         If ( allocstat .Ne. 0 ) Then
            xmsg = 'Failure allocating so4_b4 '
            Call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         End If

         firstime = .False.

      End If

      if ( .not. organosulf ) Return

C capture the loss of ASO4J to organosulfate
      m = 2  ! in the current implementation of heterogeneous chemistry,
             ! only accumulation mode sulfate can be converted to organosulfate

C save ASO4 concentrations before call to CHEM
      If ( b4chem ) Then

         Do c = 1, ncols
            Do r = 1, nrows
               Do l = 1, nlays

C extract aerosol species from CGRID
                  Call stm_extract_aero ( cgrid( c,r,l,: ) )

                  so4b4( c,r,l,m ) = Max( aero_conc( aso4_idx, m ),
     &                                    aerospc( aso4_idx )%min_conc( m ) )

               End Do
            End Do
         End Do

C scale sulfur tracking species by change in ASO4J following call to CHEM
      Else

         Do c = 1, ncols
            Do r = 1, nrows
               Do l = 1, nlays

C extract aerosol species from CGRID
                  Call stm_extract_aero ( cgrid( c,r,l,: ) )

                  If ( ( aero_conc( aso4_idx, m ) .Ne. so4b4( c,r,l,m ) ) .And.
     &                 ( so4b4( c,r,l,m ) .Gt. 0.0 ) ) Then

C fractional change in ASO4J
                     fso4 = Max( aero_conc( aso4_idx, m ),
     &                           aerospc( aso4_idx )%min_conc( m ) )
     &                    / so4b4( c,r,l,m )
                     omfso4 = 1.0 - fso4

                     aero_conc( oso4_idx, m ) =
     &                  Max( ( aero_conc( oso4_idx, m )
     &                       + ( so4b4( c,r,l,m ) - aero_conc( aso4_idx, m ) ) ),
     &                       aerospc( oso4_idx )%min_conc( m ) )

                     aero_conc( oso4gas_idx, m ) =
     &                  Max( ( aero_conc( oso4gas_idx, m )
     &                       + aero_conc( aso4gas_idx, m ) * omfso4 ),
     &                       aerospc( oso4gas_idx )%min_conc( m ) )
                     aero_conc( oso4emis_idx, m ) =
     &                  Max( ( aero_conc( oso4emis_idx, m )
     &                       + aero_conc( aso4emis_idx, m ) * omfso4 ),
     &                       aerospc( oso4emis_idx )%min_conc( m ) )
                     aero_conc( oso4icbc_idx, m ) =
     &                  Max( ( aero_conc( oso4icbc_idx, m )
     &                       + aero_conc( aso4icbc_idx, m ) * omfso4 ),
     &                       aerospc( oso4icbc_idx )%min_conc( m ) )
                     aero_conc( oso4aqh2o2_idx, m ) =
     &                  Max( ( aero_conc( oso4aqh2o2_idx, m )
     &                       + aero_conc( aso4aqh2o2_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqh2o2_idx )%min_conc( m ) )
                     aero_conc( oso4aqo3_idx, m ) =
     &                  Max( ( aero_conc( oso4aqo3_idx, m )
     &                       + aero_conc( aso4aqo3_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqo3_idx )%min_conc( m ) )
                     aero_conc( oso4aqfemn_idx, m ) =
     &                  Max( ( aero_conc( oso4aqfemn_idx, m )
     &                       + aero_conc( aso4aqfemn_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqfemn_idx )%min_conc( m ) )
                     aero_conc( oso4aqmhp_idx, m ) =
     &                  Max( ( aero_conc( oso4aqmhp_idx, m )
     &                       + aero_conc( aso4aqmhp_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqmhp_idx )%min_conc( m ) )
                     aero_conc( oso4aqpaa_idx, m ) =
     &                  Max( ( aero_conc( oso4aqpaa_idx, m )
     &                       + aero_conc( aso4aqpaa_idx, m ) * omfso4 ),
     &                       aerospc( oso4aqpaa_idx )%min_conc( m ) )

c  reduce tracked inorganic species by amount converted to organosulfate
                     aero_conc( aso4gas_idx, m ) =
     &                  Max( aero_conc( aso4gas_idx, m ) * fso4,
     &                       aerospc( aso4gas_idx )%min_conc( m ) )
                     aero_conc( aso4emis_idx, m ) =
     &                  Max( aero_conc( aso4emis_idx, m ) * fso4,
     &                       aerospc( aso4emis_idx )%min_conc( m ) )
                     aero_conc( aso4icbc_idx, m ) =
     &                  Max( aero_conc( aso4icbc_idx, m ) * fso4,
     &                       aerospc( aso4icbc_idx )%min_conc( m ) )
                     aero_conc( aso4aqh2o2_idx, m ) =
     &                  Max( aero_conc( aso4aqh2o2_idx, m ) * fso4,
     &                       aerospc( aso4aqh2o2_idx )%min_conc( m ) )
                     aero_conc( aso4aqo3_idx, m ) =
     &                  Max( aero_conc( aso4aqo3_idx, m ) * fso4,
     &                       aerospc( aso4aqo3_idx )%min_conc( m ) )
                     aero_conc( aso4aqfemn_idx, m ) =
     &                  Max( aero_conc( aso4aqfemn_idx, m ) * fso4,
     &                       aerospc( aso4aqfemn_idx )%min_conc( m ) )
                     aero_conc( aso4aqmhp_idx, m ) =
     &                  Max( aero_conc( aso4aqmhp_idx, m ) * fso4,
     &                       aerospc( aso4aqmhp_idx )%min_conc( m ) )
                     aero_conc( aso4aqpaa_idx, m ) =
     &                  Max( aero_conc( aso4aqpaa_idx, m ) * fso4,
     &                       aerospc( aso4aqpaa_idx )%min_conc( m ) )
                  End If

C update aerosol species in CGRID

                  Call stm_update_aero ( cgrid( c,r,l,: ) )

               End Do
            End Do
         End Do

      End If
      Return

      End Subroutine stm_wrap_gas

C-----------------------------------------------------------------------
      Subroutine stm_extract_aero( conc )

C  Extracts aerosol data into the aero_conc array
C  The original idea is that the data for conc comes from CGRID

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     6/25/19 streamlined version of extract_aero borrowed from AERO_DATA
C-----------------------------------------------------------------------

      Use aero_data, Only : n_aerospc, aerospc_map, n_mode

      Implicit None

C Arguments:
      Real,    Intent( In ) :: conc( : )

C Local Variables:
      Logical, Save :: firstime = .True.

      Integer m, n, spc

      If ( .Not. stm_mapped ) Then
         Call stm_map_aero()
      End If

C Copy grid cell concentrations of aero species to aero_conc
      aero_conc = 0.0
      Do m = 1, n_mode
         Do spc = 1, n_aerospc
            n = aerospc_map( spc,m )
            If ( n .Ne. 0 ) Then
               aero_conc( spc,m ) = conc( n )   ! [ug/m^3]
            End If
         End Do
      End Do

      Return
      End Subroutine stm_extract_aero

C-----------------------------------------------------------------------
      Subroutine stm_update_aero( conc )

C  Updates conc from the aero_conc array.
C  The original idea is that the data in conc updates CGRID
C  stm_update_aero now also saves the updated surface area back to CGRID as
C  well.

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     6/25/19 streamlined version of update_aero borrowed from AERO_DATA
C-----------------------------------------------------------------------

      Use aero_data, Only : n_aerospc, aerospc_map, n_mode

      Use utilio_defn

      Implicit None

C Arguments:
      Real, Intent( Out ) :: conc( : )

C Local variables:

      Character( 16 ) :: pname = 'STM_WRAP_GAS'
      Character( 80 ) :: xmsg

      Integer m, n, spc

      If ( .Not. stm_mapped ) Then
         xmsg = 'CGRID Species has not been mapped in stm_update_aero'
         Call m3exit( pname, 0, 0, xmsg, xstat3 )
      End If

C Copy aero_conc back to grid cell concentrations

      Do m = 1, n_mode
         Do spc = 1, n_aerospc
            n = aerospc_map( spc,m )
            If ( n .Ne. 0 ) Then
                 conc( n ) = aero_conc( spc,m )
            End If
         End Do
      End Do

      Return
      End Subroutine stm_update_aero

C-----------------------------------------------------------------------
      Subroutine stm_map_aero()

C  Defines aerosol mapping from CGRID for species

C  Revision History:
C     First version was coded in April 2010 by Steve Howard with
C     Prakash Bhave, Jeff Young, and Sergey Napelenok.
C     6/25/19 streamlined version of map_aero borrowed from AERO_DATA
C-----------------------------------------------------------------------

      Use aero_data, Only : n_aerospc, map_aero, n_mode

      Implicit None

      If ( stm_mapped ) Return

C...map the aerosol species using map_aero in the AERO_DATA module
      Call map_aero()

      Allocate ( aero_conc  ( n_aerospc, n_mode ) )

      stm_mapped = .True.

      Return
      End Subroutine stm_map_aero

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      End Module stm_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_CONC ( JDATE, JTIME, TSTEP )

C Revision History:
C   10/13/99 David Wong at LM
C      -- Called from driver, where CGRID is a pointer (subset) of PCGRID.
C         Necessary, to keep from referencing parts of PCGRID that don't
C         belong to CGRID.
C    1/31/2000 Jeff Young
C      -- f90 memory mgmt
C   Jeff - Dec 00 - move CGRID_MAP into f90 module
C   Jeff - Feb 01 - assumed shape arrays
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; DBUFF for WRITE3
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   30 May 05 J.Young: optional save derived vert. vel. to conc file
C   29 Aug 06 J.Young: in conjunction with state CGRID file
C   30 Jan 10 David Wong: modified the code to write one species at a time
C                         in case ALLVAR3 cannot deal with large CONC size
C   14 Sep 10 J.Young: fix ALLVAR3 bug in writing W_VEL
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 D.Wong: - let non I/O PEs open CTM_CONC_1 for read only
C   12 Aug 15 D.Wong: - Replaced MYPE with IO_PE_INCLUSIVE for parallel
C                       I/O implementation
C                     - Added code to allow non IO processor to open
C                       CTM_CONC_1
C   01 Feb 19 D.Wong: - Implemented centralized I/O approach
C   Sept 19 F. Sidi: Replaced L_CONC_WVEL(depreciated) with W_VEL 
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE STD_CONC              ! standard CONC
      USE WVEL_DEFN             ! derived vertical velocity component
      USE UTILIO_DEFN
      USE ASX_DATA_MOD, ONLY : MET_DATA
      USE CENTRALIZED_IO_MODULE

      IMPLICIT NONE

C Include Files:

      INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

      INTEGER      JDATE        ! current model date, coded YYYYDDD
      INTEGER      JTIME        ! current model time, coded HHMMSS
      INTEGER      TSTEP        ! output timestep (HHMMSS)

C Local variables:
      CHARACTER( 16 ) :: PNAME = 'WR_CONC'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      ALLOCSTAT

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER      C, R, K, L, V, VAR, SPC   ! loop induction variables

      CHARACTER( 16 ), ALLOCATABLE, SAVE :: VNAME( : )
      INTEGER, SAVE :: NVARS

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN

         FIRSTIME = .FALSE.

C open conc file for update

         IF ( .NOT. IO_PE_INCLUSIVE ) THEN
            IF ( .NOT. OPEN3( CTM_CONC_1, FSREAD3, PNAME ) ) THEN
               XMSG = 'Could not open ' // CTM_CONC_1 // ' file for update'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         IF ( .NOT. DESC3( CTM_CONC_1 ) ) THEN
            XMSG = 'Could not get file description from ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         
         ! Retrieve number and values of variable names
         NVARS = NVARS3D
         ALLOCATE ( VNAME( NVARS ), STAT=ALLOCSTAT )
         VNAME = VNAME3D( 1:NVARS )

      END IF   ! firstime

      VAR = 0

      ! Write Gas-Phase Species to CONC File
      DO SPC = 1, N_C_GC_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_GC_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_GC_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO
 
      ! Write Aerosol Species Concentrations to CONC File
      DO SPC = 1, N_C_AE_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_AE_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_AE_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      ! Write Nonreactive Species Concentrations to CONC File
      DO SPC = 1, N_C_NR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_NR_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_NR_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      ! Write Tracer Species Concentrations to CONC File
      DO SPC = 1, N_C_TR_SPC
         VAR = VAR + 1
         IF ( .NOT. WRITE3( CTM_CONC_1, C_TR_SPC( SPC ),
     &      JDATE, JTIME, SGRID( :,:,:,VAR ) ) ) THEN
            XMSG = 'Could not write '
     &           // TRIM( C_TR_SPC( SPC ) )
     &           // ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END DO

      ! Write Vertical Velocity to Output CONC file
      IF ( W_VEL ) THEN
         IF ( .NOT. WRITE3( CTM_CONC_1, 'W_VEL',
     &      JDATE, JTIME, WVEL( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
            XMSG = 'Could not write W_VEL to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF   ! W_VEL

      ! Write Relative Humidity to Output CONC file
      IF ( L_CONC_RH ) THEN
      IF ( .NOT. WRITE3( CTM_CONC_1, 'RH',
     &     JDATE, JTIME, MET_DATA%RH( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
         XMSG = 'Could not write RH to ' // CTM_CONC_1
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
      END IF

      ! Write Temperature to Output CONC file
      IF ( L_CONC_TA ) THEN
      IF ( .NOT. WRITE3( CTM_CONC_1, 'TA',
     &     JDATE, JTIME, MET_DATA%TA( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
         XMSG = 'Could not write Temperature to ' // CTM_CONC_1
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
      END IF

      ! Write Pressure to Output CONC file
      IF ( L_CONC_PRES ) THEN
      IF ( .NOT. WRITE3( CTM_CONC_1, 'PRES',
     &     JDATE, JTIME, MET_DATA%PRES( :,:,CONC_BLEV:CONC_ELEV ) ) ) THEN
         XMSG = 'Could not write Pressure to ' // CTM_CONC_1
         CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF
      END IF

! Write Summary Message for Output Procedure
      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &      'Timestep written to', CTM_CONC_1,
     &      'for date and time', JDATE, JTIME

      RETURN 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE HPPM ( NI, NJ, CON, VEL, DT, DS, ORI )
      
C----------------------------------------------------------------------
C Function      
C   This is the one-dimensional implementation of piecewise parabolic
C   method.  Variable grid spacing is allowed. The scheme is positive
C   definite and monotonic. It is conservative, and causes small
C   numerical diffusion.
      
C   A piecewise continuous parabola is used as the intepolation polynomial.
C   The slope of the parabola at cell edges are computed from a cumulative
C   function of the advected quantity.  These slopes are further modified
C   so that the interpolation function is monotone. For more detailed
C   information see:
      
C   Colella, P., and P. L. Woodward, (1984), "The Piecewise Parabolic
C   Method (PPM) for Gas-Dynamical Simulations," J. Comput. Phys. 54,
C   174-201.
      
C   The concentrations at boundary cells (i.e., at 1 and NI) are not
C   computed here.  They should be updated according to the boundary
C   conditions.
      
C   The following definitions are used:
     
C              |---------------> Positive direction
C     
C  -->|Boundary|<----------------Main Grid----------------->|Boundary|<--
C     
C     |<------>|<------>|       ~|<------>|~       |<------>|<------>|
C       CON(0)   CON(1)            CON(i)            CON(n)  CON(n+1)
C     
C     VEL(1)-->|        VEL(i)-->|        |-->VEL(i+1)      |-->VEL(n+1)
C    
C      FP(0)-->|       FP(i-1)-->|        |-->FP(i)         |-->FP(n)
C     
C      FM(1)<--|         FM(i)<--|        |<--FM(i+1)       |<--FM(n+1)
C    
C                             -->| DS(i)  |<--
      
C----------------------------------------------------------------------
      
C Revision History:
      
C   20 April, 1993 by M. Talat Odman at NCSC: 
C   Created based on Colella and Woodward (1984)
      
C   15 Sept., 1993 by Daewon Byun at EPA:
C   Original code obtained from Phillip Colella at Berkeley
      
C   29 Nov.,  1993 by M. Talat Odman at NCSC:
C   Found no difference from original code
      
C   05 Oct.,  1993 by M. Talat Odman at NCSC:
C   Modified for EDSS archive, made discontinuity capturing an option

C   Sep 97 Jeff
C   Aug 98 - Jeff - optimize for mesh coefficients      

C   David Wong - Sep. 1998
C     -- parallelized the code
C     -- Expanded the one-level nested loop which involves either with row or
C        column, into a three-level nested loop with layers and species.
C        Corresponding arrays' dimensions were adjusted accordingly
C   Jeff - optimize for mesh coefficients
C
C   David Wong - 1/8/99
C     -- BARRIER is removed
C
C   David Wong - 1/12/99
C     -- inside BNDY_HI_PE conditional code segment, NI is changed to MY_NI
C
C   David Wong - 1/12/99
C     -- change se_loop_index argument list
C     -- add new subroutine call to determine lo and hi boundary processor

C   22 Nov 00 J.Young: PE_COMM2E -> Dave Wong's f90 stenex COMM
C                      PE_COMM3E -> Dave Wong's f90 stenex COMM

C   23 Feb 01 J.Young: allocatable arrays ...
C                      Since F90 does not preserve dummy argument array
C                      indices, CONI( 1:NI+2,, ) is copied into local array
C                      CON( 0:NI+1,, ).
C                      The caller of HPPM dimensions the actual argument,
C                      as CON( -NTHIK+1:MY_NCOLS+NTHIK,, ).

C   3 Sep 01 David Wong
C     -- use "dynamic" data structure instead of F90 ALLOCATE statement to
C        avoid memory fragmentation which eventually leads to not enough
C        contigous memory (F90 bug?)
C   24 Mar 04 G.Hammond: moved all mpi communication to caller

C   06/16/04 by Peter Percell & Daewon Byun at UH-IMAQS: 
C     - Fixed bug in using fluxes in non-uniform grids to update concentrations

C   14 Feb 05 J.Young: fix DS dimension bug
C   11 Oct 05 J.Young: re-dimension lattice arrays to one
C    1 Nov 06 J.Young: Following Glenn Hammond, moved all communication
C   out of HPPM; using "swap_sandia" communication in caller; update only
C   local values in the CGRID array within a time step, discarding previous
C   ghost values.
C    1 May 07 J.Young: Following Peter Percell, eliminate CONI,DSI using interface
C   specification in caller
C   11 May 09 J.Young: Simplify - remove STEEPEN option (never used); assume constant
C                      cell widths, DS( i )
C   11 May 10 D.Wong: Change local dynamic arrays: make allocatable to enable proper
C                     PGI compiliation; fix a max first dimension
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN

C----------------------------------------------------------------------
      
      USE HGRD_DEFN
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES          ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES        ! stenex (using NOOP_UTIL_MODULE)
#endif

      IMPLICIT NONE

C Includes:
      
! #ifdef parallel
      INTEGER, PARAMETER :: SWP = 3
      INTEGER, PARAMETER :: X1 = 1
      INTEGER, PARAMETER :: X2 = 2
      INTEGER, PARAMETER :: X3 = 3
! #else
!     INTEGER, PARAMETER :: SWP = 1
!     INTEGER, PARAMETER :: X1 = 0
!     INTEGER, PARAMETER :: X2 = 0
!     INTEGER, PARAMETER :: X3 = 0
! #endif

C Arguments:
 
      INTEGER, INTENT( IN )    :: NI, NJ      ! number of zones (cells)
      REAL,    INTENT( INOUT ) :: CON( 1-SWP:,1: ) ! conc's in the zones (cells)
      REAL,    INTENT( IN )    :: VEL( : )    ! velocities at zone (cell) boundaries
      REAL,    INTENT( IN )    :: DT          ! time step
      REAL,    INTENT( IN )    :: DS          ! distance between zone (cell) boundaries
      CHARACTER, INTENT( IN )  :: ORI         ! orientation of advection ('C'-x or 'R'-y)

C Parameters:
      
      REAL, PARAMETER :: TWO3RDS = 2.0 / 3.0
      REAL, PARAMETER :: SIXTH   = 1.0 / 6.0

C Local variables:

      CHARACTER, SAVE :: FIRSTORI = ' '   ! for test if Col or Row orientation change
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      
      INTEGER, SAVE :: NSPCS

!     REAL :: FM    (    1:NI+1,   SIZE( CON,2 ) ) ! outflux from left or bottom of cell
!     REAL :: FP    (    0:NI,     SIZE( CON,2 ) ) ! outflux from right or top of cell

!     REAL :: CM    ( 1-X1:NI+X1+1,SIZE( CON,2 ) ) ! zone R.H. trial intercept
!     REAL :: CL    ( 1-X1:NI+X1 )                 ! zone L.H. intercept
!     REAL :: CR    ( 1-X1:NI+X1 )                 ! zone R.H. intercept
!     REAL :: DC    ( 0-X1:NI+X1+1,SIZE( CON,2 ) ) ! CR - CL
!     REAL :: C6    ( 1-X1:NI+X1 )                 ! coefficient of second-order term

      REAL, ALLOCATABLE, SAVE :: FM( :,: ) ! outflux from left or bottom of cell
      REAL, ALLOCATABLE, SAVE :: FP( :,: ) ! outflux from right or top of cell

      REAL, ALLOCATABLE, SAVE :: CM( :,: ) ! zone R.H. trial intercept
      REAL, ALLOCATABLE, SAVE :: CL( : )   ! zone L.H. intercept
      REAL, ALLOCATABLE, SAVE :: CR( : )   ! zone R.H. intercept
      REAL, ALLOCATABLE, SAVE :: DC( :,: ) ! CR - CL
      REAL, ALLOCATABLE, SAVE :: C6( : )   ! coefficient of second-order term
      REAL C0, C1

      LOGICAL, SAVE :: BNDY_LO_PE, BNDY_HI_PE

      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 16 ) :: PNAME = 'HPPM'

      REAL X, Y                 ! Courant number
      INTEGER NMX, ASTAT
      
      INTEGER I, S              ! loop indices

C----------------------------------------------------------------------

#ifdef isam
      FIRSTIME = .TRUE.
#else
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
#endif
         NMX = MAX( NI,NJ )
         NSPCS = SIZE ( CON,2 )
         ALLOCATE( FM(     1:NMX+1,    NSPCS ),
     &             FP(     0:NMX,      NSPCS ),
     &             CM(  1-X1:NMX+X1+1, NSPCS ),
     &             CL(  1-X1:NMX+X1 ),
     &             CR(  1-X1:NMX+X1 ),
     &             DC(  0-X1:NMX+X1+1, NSPCS ),
     &             C6(  1-X1:NMX+X1 ), STAT = ASTAT )
         IF ( ASTAT .NE. 0 ) THEN
            XMSG = '*** Error allocating FM, FP, CM, CL, CR, DC, or C6'
            CALL M3EXIT ( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
#ifdef isam
#else
      END IF   ! Firstime
#endif

      IF ( ORI .NE. FIRSTORI ) THEN
         FIRSTORI = ORI
         CALL SUBST_HI_LO_BND_PE ( ORI, BNDY_LO_PE, BNDY_HI_PE )
      END IF   ! FIRSTORI

C Set all fluxes to zero. Either positive or negative flux will remain zero
C depending on the sign of the velocity.

      FM( 1:NI+1,: ) = 0.0
      FP( 0:NI,: ) = 0.0

! #ifndef parallel
C If PE near bottom or left domain boundary...
C Zeroth order polynomial at the boundary cells
C First order polynomial at the next cells, no monotonicity constraint needed
!     IF ( BNDY_LO_PE ) THEN
!        DO S = 1, NSPCS
!           CM( 1,S ) = CON( 1,S )
!           CM( 2,S ) = 0.5 * ( CON( 1,S ) + CON( 2,S ) )
!        END DO
!     END IF

C If PE near top or right domain boundary...
C Zeroth order polynomial at the boundary cells
C First order polynomial at the next cells, no monotonicity constraint needed
!     IF ( BNDY_HI_PE ) THEN
!        DO S = 1, NSPCS
!           CM( NI+1,S ) = CON( NI,S )
!           CM( NI,S )   = 0.5 * ( CON( NI,S ) + CON( NI-1,S ) )
!        END DO
!     END IF
! #endif
      
C Second order polynomial inside the domain
      
      DO S = 1, NSPCS
         DO I = 2 - X3, NI + X3 - 1
      
C Compute average slope in the i'th zone
      
C Equation (1.7)
            C0 = CON( I,S )   - CON( I-1,S )
            C1 = CON( I+1,S ) - CON( I,S )
            DC( I,S ) = 0.5 * ( C0 + C1 )
      
C Guarantee that CM lies between CON(I) and CON(I+1) - monotonicity constraint

C Equation (1.8)
            IF ( C0 * C1 .GT. 0.0 ) THEN
               DC( I,S ) = SIGN( 1.0, DC( I,S ) )
     &                   * MIN(      ABS( DC( I,S ) ),
     &                         2.0 * ABS( C0 ),
     &                         2.0 * ABS( C1 ) )
            ELSE
               DC( I,S ) = 0.0
            END IF

         END DO   ! I

C Equation (1.6)
         DO I = 3 - X3, NI + X3 - 1
            CM( I,S ) = 0.5 * ( CON( I,S ) + CON( I-1,S ) )
     &                - SIXTH * ( DC( I,S ) - DC( I-1,S ) )
         END DO

      END DO   ! S

C Generate piecewise parabolic distributions

      DO S = 1, NSPCS

         DO I = 1 - X1, NI + X1

C Equation (1.15)
            CR( I ) = CM( I+1,S )
            CL( I ) = CM( I,S )
 
C Monotonicity
 
            IF ( ( CR( I ) - CON( I,S ) )
     &        * ( CON( I,S ) - CL( I ) ) .GT. 0.0 ) THEN

C Temporary computation of DC and C6
               DC( I,S ) = CR( I ) - CL( I )
               C6( I ) = 6.0 * ( CON( I,S ) - 0.5 * ( CL( I ) + CR( I ) ) )

C overshoot cases - Equation (1.10)
               IF ( DC( I,S ) * C6( I ) .GT.
     &              DC( I,S ) * DC( I,S ) ) THEN
                  CL( I ) = 3.0 * CON( I,S ) - 2.0 * CR( I )
               ELSE IF ( -DC( I,S ) * DC( I,S ) .GT.
     &                    DC( I,S ) * C6( I ) ) THEN
                  CR( I ) = 3.0 * CON( I,S ) - 2.0 * CL( I )
               END IF

            ELSE                   ! Local extremum: Interpolation  
                                   ! function is set to be a constant
               CL( I ) = CON( I,S )
               CR( I ) = CL( I )

            END IF

            DC( I,S ) = CR( I ) - CL( I )      ! Equation (1.5)
            C6( I ) = 6.0 * ( CON( I,S ) - 0.5 * ( CL( I ) + CR( I ) ) )

         END DO   ! I

C Compute fluxes from the parabolic distribution as in Equation (1.12)

! #ifdef parallel
!        I = 0
!        IF ( VEL( I+1 ) .GT. 0.0 ) THEN
!           Y = VEL( I+1 ) * DT
!           X = Y / DS
!           FP( I,S ) = Y * ( CR( I ) - 0.5 * X * ( DC( I,S )
!    &                - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
!        END IF
! #endif
      
!        IF ( BNDY_LO_PE ) THEN
            I = 0
            IF ( VEL( I+1 ) .GT. 0.0 ) THEN
               Y = VEL( I+1 ) * DT
               X = Y / DS
               FP( I,S ) = Y * ( CR( I ) - 0.5 * X * ( DC( I,S )
     &                   - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF
!        END IF

         DO I = 1, NI

C function for mass leaving interval I at lower face (I-1/2)
C = length of segment leaving * integral average concentration in that segment
            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               X = Y / DS
               FM( I,S ) = Y * ( CL( I ) + 0.5 * X * ( DC( I,S )
     &                   + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF

C function for mass leaving interval I at upper face (I+1/2)
            IF ( VEL( I+1 ) .GT. 0.0 ) THEN
               Y = VEL( I+1 ) * DT
               X = Y / DS
               FP( I,S ) = Y * ( CR( I ) - 0.5 * X * ( DC( I,S )
     &                   - C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF

         END DO   ! I

! #ifdef parallel
!        I = NI + 1
!        IF ( VEL( I ) .LT. 0.0 ) THEN
!           Y = -VEL( I ) * DT
!           X = Y / DS
!           FM( I,S ) = Y * ( CL( I ) + 0.5 * X * ( DC( I,S )
!    &                + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
!        END IF
! #endif
!        IF ( BNDY_HI_PE ) THEN
            I = NI + 1
            IF ( VEL( I ) .LT. 0.0 ) THEN
               Y = -VEL( I ) * DT
               X = Y / DS
               FM( I,S ) = Y * ( CL( I ) + 0.5 * X * ( DC( I,S )
     &                   + C6( I ) * ( 1.0 - TWO3RDS * X ) ) )
            END IF
!        END IF

      END DO   ! S

C Compute fluxes from boundary cells
      
C If PE near top or left boundary...
      IF ( BNDY_LO_PE ) THEN
         IF ( VEL( 1 ) .GT. 0.0 ) THEN
            Y = VEL( 1 ) * DT
            DO S = 1, NSPCS
               FP( 0,S ) = Y * CON( 0,S )
            END DO
         END IF
      END IF

C If PE near bottom or right boundary...
      IF ( BNDY_HI_PE ) THEN
         IF ( VEL( NI+1 ) .LT. 0.0 ) THEN
            Y = -VEL( NI+1 ) * DT
            DO S = 1, NSPCS
               FM( NI+1,S ) = Y * CON( NI+1,S )
            END DO
         END IF
      END IF

C Update concentrations as in Equation (1.13)
      DO S = 1, NSPCS
         DO I = 1, NI
            CON( I,S ) = CON( I,S )
     &                 + ( FP( I-1,S ) - FP( I,S ) + FM( I+1,S ) - FM( I,S ) ) / DS
         END DO
      END DO

#ifdef isam
Ckrt...deallocate local arrays....20140126
         IF ( ALLOCATED( FM ) ) DEALLOCATE( FM )

         IF ( ALLOCATED( FP ) ) DEALLOCATE( FP )

         IF ( ALLOCATED( CM ) ) DEALLOCATE( CM )

         IF ( ALLOCATED( CL ) ) DEALLOCATE( CL )

         IF ( ALLOCATED( CR ) ) DEALLOCATE( CR )

         IF ( ALLOCATED( DC ) ) DEALLOCATE( DC )

         IF ( ALLOCATED( C6 ) ) DEALLOCATE( C6 )
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine aero_sedv ( col, row, cgrd, vsed_ae )

C-----------------------------------------------------------------------
C Get accum. and coarse mode grav. settling vel
C used Binkowski`s aerosol dry deposition routine as a guide
C 08 Feb 13 J.Young: initial
C 20 Jun 14 J.Young: restructure
C 22 Oct 14 J.Bash:  replaced P0 with STDATMPA from CONST.EXT and shared 
C                    variables in the asx_data_mod
C May 2015 B. Murphy, H. Pye: Updated treatment of aerosol moments
C-----------------------------------------------------------------------

      use grid_conf           ! horizontal & vertical domain specifications
      use cgrid_spcs          ! CGRID mechanism species
      use utilio_defn      
      use asx_data_mod, Only: Met_Data
      use aero_data           ! aero variable data
      use aeromet_data        ! Includes CONST.EXT

      implicit none

C Includes:

C Arguments
      integer, intent( in )  :: col, row
      real,    intent( in )  :: cgrd( :,: )     ! cgrid subsection (layers,species)
      real,    intent( out ) :: vsed_ae( :,: )  ! settling velocities [ m/s ]

C Parameters
      real,    parameter :: t0 = 288.15      ! [ K ] ! starting standard surface temp.
      real,    parameter :: two3 = 2.0 / 3.0
      integer, parameter :: n_ae_sed_spc = 6 ! no. of surrogates for aero settling velocities

C set up species indices for settling velocity internal array vsed
      integer, parameter :: vgnacc = 1,  ! accumulation mode number
     &                      vgncor = 2,  ! coarse mode number
     &                      vgsacc = 3,  ! accumulation mode surface area
     &                      vgscor = 4,  ! coarse mode surface area
     &                      vgmacc = 5,  ! accumulation mode mass
     &                      vgmcor = 6   ! coarse mode mass

C Local variables:

C follow the Namelist dep vel surrogate name table
      character( 16 ) :: vgae_name( n_ae_sed_spc ) = ! grav. settling vel surrogate table
     &                (/ 'VNUMACC',
     &                   'VNUMCOR',
     &                   'VSRFACC',
     &                   'VSRFCOR',
     &                   'VMASSJ ',
     &                   'VMASSC ' /)

      integer, allocatable, save :: sedi_sur( : )   ! pointer to surrogate

      real, allocatable, save :: xxlsgac( : )   ! log of stnd dev
      real, allocatable, save :: xxlsgco( : )
      real, allocatable, save :: dgacc  ( : )   ! geometric mean diameter
      real, allocatable, save :: dgcor  ( : )
      real, allocatable, save :: pdensac( : )   ! particle density
      real, allocatable, save :: pdensco( : )

      real, allocatable, save :: xlm    ( : )   ! mean free path [ m ]
      real, allocatable, save :: amu    ( : )   ! dynamic viscosity [ kg/m/s ]

      real, allocatable, save :: vsed   ( :,: ) ! grav settling velocity [ m/s ]

      real m2_wet, m2_dry
      real m3_wet, m3subt, m3_dry

      logical, save :: firstime = .true.
      character( 16 ), save :: pname = 'AERO_SEDI'
      character( 16 ) :: vname                  ! variable name
      character( 96 ) :: xmsg = ' '

      integer  l, v, n, j      ! loop counters
      integer  spc, s          ! species loop counter
      integer  astat

      integer :: jdate = 0, jtime = 0

      interface
        subroutine get_sedv ( xlm, amu,
     &                        dgacc, dgcor,
     &                        xxlsgac, xxlsgco,
     &                        pdensac, pdensco,
     &                        vsed )
          real, intent( in ) :: xlm    ( : )  ! atmos mean free path [ m ]
          real, intent( in ) :: amu    ( : )  ! atmos dynamic viscosity [ kg/(m s) ]
          real, intent( in ) :: dgacc  ( : )  ! accum mode geom mean diameter [ m ]
          real, intent( in ) :: dgcor  ( : )  ! coarse mode geom mean diameter  [ m ]
          real, intent( in ) :: xxlsgac( : )  ! accum mode log of stnd dev
          real, intent( in ) :: xxlsgco( : )  ! coarse mode
          real, intent( in ) :: pdensac( : )  ! avg particle density in accum mode
          real, intent( in ) :: pdensco( : )  ! avg particle density in coarse mode
          real, intent( out ) :: vsed  ( :,: ) ! settling velocity [ m/s ]
        end subroutine get_sedv
      end interface

c-----------------------------------------------------------------------

      if ( firstime ) then
         firstime = .false.

C  Allocate arrays
         allocate( xxlsgac( nlays ),
     &             xxlsgco( nlays ),
     &             dgacc  ( nlays ),
     &             dgcor  ( nlays ),
     &             pdensac( nlays ),
     &             pdensco( nlays ),
     &             xlm    ( nlays ),
     &             amu    ( nlays ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating'
     &           //  ' xxlsgac, xxlsgco,'
     &           //  ' dgacc, dgcor,'
     &           //  ' pdensac, pdensco,'
     &           //  ' xlm, or amu'
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

         allocate( vsed( nlays,n_ae_spc), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating vsed'
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

         allocate( sedi_sur( n_ae_spc ), stat = astat )
         if ( astat .ne. 0 ) then
            xmsg = 'Failure allocating sedi_sur'
            call m3exit( pname, jdate, jtime, xmsg, xstat1 )
         end if

C Set the settling vel surrogate pointers according to the depv table
         j = 0
         do v = 1, n_ae_depv   ! assume n_ae_spc = n_ae_depv
            n = index1( ae_depv( v ), n_ae_sed_spc, vgae_name )
            if ( n .ne. 0 ) then
               j = j + 1
               sedi_sur( v ) = n
            else
               write( logdev,* ) ' surrogate ', trim( ae_depv( v ) ),
     &                           ' not used for', v, trim( ae_spc( v ) )
               sedi_sur( v ) = 0
            end if
         end do
         n = j

         write( logdev,* ) n, ' Aerosol species with a grav. settling vel'
         do j = 1, n_ae_spc
            n = sedi_sur( j )
            if ( n .ne. 0 ) write( logdev,'( i3, 2x, a9, i3, 2x, a )' )
     &                             j, ae_spc( j ), n, trim( ae_depv( j ) )
         end do

      end if    ! firstime      

      do l = 1, nlays

C Set meteorological data for the grid cell.
         airtemp = Met_Data%ta  ( col,row,l )
         airpres = Met_Data%pres( col,row,l )

C extract grid cell concentrations of aero species from CGRID
C into aerospc_conc in aero_data module
C Also converts dry surface area to wet 2nd moment
#ifdef sens
         call extract_aero( cgrd( l,: ), .true., cgrd( :,: ), .false. )
#else
         call extract_aero( cgrd( l,: ), .true. )  ! set minimum floor
#endif

C Get the geometric mean diameters and standard deviations of the
C "wet" size distribution
         call getpar( .false. )     
C                        | do not fix stnd dev`s to existing value

C Save getpar values to arrays
         xxlsgac( l ) = aeromode_lnsg( 2 )
         xxlsgco( l ) = aeromode_lnsg( 3 )

         dgacc( l )   = aeromode_diam( 2 )
         dgcor( l )   = aeromode_diam( 3 )

         pdensac( l ) = aeromode_dens( 2 )
         pdensco( l ) = aeromode_dens( 3 )
 
C Calculate mean free path [ m ]:
         xlm( l ) = 6.6328e-8 * STDATMPA * airtemp / ( t0 * airpres )

C Calculate dynamic viscosity [ kg/m/s ]:
         amu( l ) = 1.458e-6 * airtemp * sqrt( airtemp ) / ( airtemp + 110.4 )

      end do ! layer loop

C get settling velocities:
      call get_sedv ( xlm, amu,
     &                dgacc, dgcor,
     &                xxlsgac, xxlsgco,
     &                pdensac, pdensco,
     &                vsed )

C Return sedimentation velocities for aerosols and cfl-safe iteration count

C "Stores read an entire cache line, modify the target, then write back the
C  entire line. Thus, non-consecutive stores are worse than non-consecutive
C  loads."

      do l = 1, nlays
         do v = 1, n_ae_spc
            if ( sedi_sur( v ) .gt. 0 ) then
               vsed_ae( v,l ) = vsed( l,sedi_sur( v ) )
            else
               vsed_ae( v,l ) = 0.0
            end if
         end do
      end do

      return
      end subroutine aero_sedv

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      subroutine get_sedv ( xlm, amu,
     &                      dgacc, dgcor,
     &                      xxlsgac, xxlsgco,
     &                      pdensac, pdensco,
     &                      vsed )

C Calculate settling velocity for Aitken, accumulation, and coarse modes.
C-----------------------------------------------------------------------

      use asx_data_mod, Only: Met_Data
      use aeromet_data   ! Includes CONST.EXT

      implicit none

C *** arguments

      real, intent( in ) :: xlm    ( : )  ! atmospheric mean free path [m]
      real, intent( in ) :: amu    ( : )  ! atmospheric dynamic viscosity [kg/(m s)]
      real, intent( in ) :: dgacc  ( : )  ! accum mode geom mean diameter [m]
      real, intent( in ) :: dgcor  ( : )  ! coarse mode geom mean diameter [m]
      real, intent( in ) :: xxlsgac( : )  ! accum mode log of modal geom stnd dev`s
      real, intent( in ) :: xxlsgco( : )  ! coarse mode log of modal geom stnd dev`s
      real, intent( in ) :: pdensac( : )  ! avg particle dens in accum mode [kg/m**3]
      real, intent( in ) :: pdensco( : )  ! avg particle dens in coarse mode [kg/m**3]
      real, intent( out ) :: vsed  ( :,: )  ! grav settling velocity [ m/s ]

C *** array indices hardcoded to match SUBROUTINE aero_sedi
      integer, parameter :: vgnacc = 1,  ! accumulation mode number
     &                      vgncor = 2,  ! coarse mode number
     &                      vgsacc = 3,  ! accumulation mode surface area
     &                      vgscor = 4,  ! coarse mode surface area
     &                      vgmacc = 5,  ! accumulation mode mass
     &                      vgmcor = 6   ! coarse mode mass

C modal Knudsen numbers X bhat
      real bknacc   ! accumulation mode 
      real bkncor   ! coarse mode

C modal sedimentation velocities for 0th (number), 2nd (srf area), and 3rd (mass) moments
      real vghat0a, vghat0c
      real vghat2a, vghat2c
      real vghat3a, vghat3c

      integer l

      real    dconst2, dconst3a, dconst3c
      real    bxlm

 !    real, parameter :: bhat    = 1.246 ! Constant from Cunningham slip correction
      real, parameter :: bhat    = 2.492 ! 2 X Constant from Cunningham slip correction

C Scalar variables for VARIABLE standard deviations.

      real    l2sgac, l2sgco   ! log^2( sigmag )

      real    esac01           ! accumu mode " ** 4
      real    esco01           ! coarse      "

      real    esac02           ! accumu mode " ** 8
      real    esco02           ! coarse      "

      real    esac04           ! accumu mode " ** 16
      real    esco04           ! coarse      "

      real    esac05           ! accumu mode " ** 20
      real    esco05           ! coarse      "

      real    esac07           ! accumu mode " ** 28
      real    esco07           ! coarse      "

      real    esac12           ! accumu mode " ** 48    
      real    esco12           ! coarse      "     

      real    esac16           ! accumu mode " ** 64
      real    esco16           ! coarse      "

C-----------------------------------------------------------------------

      do l = 1, size( met_data%ta, 3 )

C Calculate Knudsen numbers * bhat
         bxlm = bhat * xlm( l )
         bknacc = bxlm / dgacc( l )
         bkncor = bxlm / dgcor( l )

C Calculate functions of variable standard deviation.
         l2sgac = xxlsgac( l ) * xxlsgac( l )
         l2sgco = xxlsgco( l ) * xxlsgco( l )

         esac01  = exp( 0.5 * l2sgac )
         esco01  = exp( 0.5 * l2sgco )

         esac02  = esac01 * esac01
         esco02  = esco01 * esco01

         esac04  = esac02 * esac02
         esco04  = esco02 * esco02

         esac05  = esac04 * esac01
         esco05  = esco04 * esco01

         esac07  = esac05 * esac02
         esco07  = esco05 * esco02

         esac12  = esac07 * esac05
         esco12  = esco07 * esco05

         esac16  = esac12 * esac04
         esco16  = esco12 * esco04

         dconst2  = grav / ( 18.0 * amu( l ) )
         dconst3a = dconst2 * pdensac( l ) * dgacc( l ) * dgacc( l )
         dconst3c = dconst2 * pdensco( l ) * dgcor( l ) * dgcor( l )

c acc mode
         vghat0a  = dconst3a * ( esac04  + bknacc * esac01 )
         vghat2a  = dconst3a * ( esac12  + bknacc * esac05 )
         vghat3a  = dconst3a * ( esac16  + bknacc * esac07 )

c coarse mode
         vghat0c  = dconst3c * ( esco04  + bkncor * esco01 )
         vghat2c  = dconst3c * ( esco12  + bkncor * esco05 )
         vghat3c  = dconst3c * ( esco16  + bkncor * esco07 )

C settling velocities

C vsed of 0th moment for the number 
         vsed( l,vgnacc ) = vghat0a   ! accum mode
         vsed( l,vgncor ) = vghat0c   ! coarse mode

c vsed of 2nd moment for the surface area 
         vsed( l,vgsacc ) = vghat2a   ! accum mode
         vsed( l,vgscor ) = vghat2c   ! coarse mode

c vsed of 3rd moment for the mass 
         vsed( l,vgmacc ) = vghat3a   ! accum mode
         vsed( l,vgmcor ) = vghat3c   ! coarse mode

      end do ! end loop on l

      return
      end subroutine get_sedv

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE FIRE_PLMRIS( EMLAYS, LSTK, HFX, HMIX,
     &                        BFLX,
     &                        TSTK, USTAR, DTHDZ, TA, WSPD, 
     &                        ZF,           WSTK, ZPLM )

C-----------------------------------------------------------------------
 
C Description:  
C     computes final effective plume centerline height.
 
C Preconditions:
C     meteorology and stack parameters
 
C Subroutines and Functions called:
 
C Revision History:
C     Prototype 12/95 by CJC, based on Briggs algorithm adapted from
C     RADM 2.6 subroutine PLUMER() (but with completely different 
C     data structuring).
C     Copied from plmris.F 4.4 by M Houyoux 3/99 
C     Aug 2015, D. Wong: Used assumed shape array declaration
 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling System
C File: @(#)$Id: fire_plmris.F,v 1.2 2011/10/21 16:11:30 yoj Exp $
C COPYRIGHT (C) 2002, MCNC Environmental Modeling Center
C All Rights Reserved
C See file COPYRIGHT for conditions of use.
C Environmental Modeling Center
C MCNC
C P.O. Box 12889
C Research Triangle Park, NC  27709-2889
C smoke@emc.mcnc.org
C Pathname: $Source: /project/yoj/arc/CCTM/src/plrise/smoke/fire_plmris.F,v $
C Last updated: $Date: 2011/10/21 16:11:30 $ 
C-----------------------------------------------------------------------
      USE RUNTIME_VARS, ONLY : LOGDEV

      IMPLICIT NONE

C Includes:
      INCLUDE SUBST_CONST     ! physical and mathematical constants

C Arguments:
      INTEGER, INTENT( IN )  :: EMLAYS          ! no. of emission layers
      INTEGER, INTENT( IN )  :: LSTK            ! lyr of top of fire, = RADM's KSTK
      REAL,    INTENT( IN )  :: HFX             ! sensible heat flux [m K/s]
      REAL,    INTENT( IN )  :: HMIX            ! mixing height [m]

      REAL,    INTENT( IN )  :: BFLX            ! Buoyancy Flux [m**4/s**3]

      REAL,    INTENT( IN )  :: TSTK            ! tmptr at top of fire [deg K]
      REAL,    INTENT( IN )  :: USTAR           ! friction velocity [m/s]
      REAL,    INTENT( IN )  :: DTHDZ( : )      ! gradient of THETV
      REAL,    INTENT( IN )  :: TA   ( : )      ! temperature [deg K]
      REAL,    INTENT( IN )  :: WSPD ( : )      ! wind speed [m/s]
      REAL,    INTENT( IN )  :: ZF  ( 0: )      ! layer surface height [m]
      REAL,    INTENT( INOUT ) :: WSTK          ! wind speed @ top of fire [m/s]
                                                ! OUT for reporting, only
      REAL,    INTENT( OUT ) :: ZPLM            ! initially, plume top height above fire,
                                                ! finally, plume centerline height [m]
                                                ! can be greater than the top of EMLAYS

C Parameters:
      REAL, PARAMETER :: HCRIT   =  1.0E-4 * 0.03  ! hfx min * tolerance
      REAL, PARAMETER :: SMALL   =  3.0E-5         ! Criterion for stability
      REAL, PARAMETER :: D3      =  1.0 /  3.0     ! 1/ 3
      REAL, PARAMETER :: D6      =  1.0 /  6.0     ! 1/6
      REAL, PARAMETER :: D45     =  1.0 / 45.0     ! 1/45
      REAL, PARAMETER :: D2664   =  1.0 /  2.664   ! 1/ 2.664
      REAL, PARAMETER :: D59319  =  1.0 / 59.319   ! 1/59.319
      REAL, PARAMETER :: TWOTHD  =  2.0 /  3.0     ! 2/3
      REAL, PARAMETER :: FIVETHD =  5.0 /  3.0     ! 5/3
      REAL, PARAMETER :: NODIV0  =  1.0            ! Prevent divide by zero
      
      REAL, PARAMETER :: ZERO = 0.0

C Local Variables:
      INTEGER IQ              ! stability class: 1-unstable, 2-neutral, 3-stable
      INTEGER LPLM            ! first L: ZH(L) > Plume height ! same as RADM's KPR
      INTEGER NN              ! Counter for interations through layers
      REAL    DH              ! plume rise increment to center of the plume
      REAL    DHM             ! plume rise from momentum
      REAL    DHSM            ! stable momentum plume rise
      REAL    DHN             ! plume rise for neutral case
      REAL    DHT             ! plume rise increment to the top of the plume
      REAL    HSTAR           ! convective scale at fire (m**2/s**3)
      REAL    PX, RX, SX      ! scratch coefficients
      REAL    RBFLX           ! residual buoyancy flux (m**4/s**3)
      REAL    TPLM            ! temperature at top of plume (m/s)
      REAL    WPLM            ! wind speed  at top of plume (m/s)
      REAL    ZMIX            ! hmix - hs

      LOGICAL :: FIRSTIME = .TRUE.

C Statement Functions:
      REAL    B,    S, U, US  ! arguments
       
      REAL    NEUTRL          ! neutral-stability plume rise function
      REAL    STABLE          ! stable            plume rise function
      REAL    UNSTBL          ! unstable          plume rise function

      NEUTRL( B, U, US ) = 1.3327804 * B / ( U * US * US )

      STABLE( B, U, S ) =  2.6 * ( B / ( U * S ) ) ** D3
      UNSTBL( B, U )    = 30.0 * ( B / U ) ** 0.6

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
      END IF

C Compute convective scale.

      HSTAR = GRAV * HFX / TA( 1 )   ! Using surface temperature is correct

C Initialize layer of plume
      LPLM  = LSTK

C Compute momentum rise ( set min wind speed to 1 m/s)
      WSTK = MAX( WSTK, 1.0 )
      DHM  = ZERO

C Compute initial plume rise from fire top to next level surface:

      IF ( HSTAR .GT. HCRIT ) THEN           ! unstable case:
         ZMIX = HMIX 

         IF ( ZMIX .LE. 0.0 ) THEN           ! Fire above mixing height:
            SX = MAX( GRAV * DTHDZ( LPLM ) / TSTK, SMALL )

C Reset the wind speed at fire to the wind speed at plume when the layer
C of the plume is not equal to the layer of the fire.
            IF ( LPLM .NE. LSTK ) THEN
               WSTK = WSPD( LPLM )
               IF ( WSTK .EQ. 0.0 ) WSTK = NODIV0
            END IF

C Compute the stable momentum rise, for layer of the fire.
            IF ( DTHDZ( LPLM ) .GT. 0.001 ) THEN
               DHSM = ZERO
            ELSE
               DHSM = DHM     ! Set it to DHM, if THGRAD too small
            END IF
            DHM = MIN( DHSM, DHM )

C Compute the neutral and stable plume rises.         
            DHN = NEUTRL( BFLX, WSTK, USTAR )
            DH  = STABLE( BFLX, WSTK, SX )

            IF ( DHN .LT. DH ) THEN  ! Take the minimum of neutral and stable
               DH = DHN
               IQ = 2
            ELSE 
               IQ = 3 
            END IF

            IF ( DHM .GT. DH .AND. WSTK .GT. 1.0 ) THEN
               DH = DHM
               IQ = 4
            END IF
            DHT = 1.5 * DH

         ELSE                        !  unstable case:
            DH  = UNSTBL( BFLX, WSTK )
            DHN = NEUTRL( BFLX, WSTK, USTAR )

            IF ( DHN .LT. DH ) THEN
               DH = DHN
               IQ = 2
            ELSE
               IQ = 1
            END IF

            IF ( DHM .GT. DH .AND. WSTK .GT. 1.0 ) THEN
               DH = DHM
               IQ = 4 
            END IF

            DHT = 1.5 * DH

         END IF

      ELSE IF ( HSTAR .LT. -HCRIT .OR. DTHDZ( LSTK ) .GT. 0.001 ) THEN   ! stable case:

         SX = MAX( GRAV * DTHDZ( LSTK ) / TSTK, SMALL )
         DHT = 1.5 * STABLE( BFLX, WSTK, SX )
         DHN = 1.5 * NEUTRL( BFLX, WSTK, USTAR )
         IF ( DHN .LT. DHT ) THEN
             DHT = DHN
             IQ = 2
         ELSE
             IQ = 3
         END IF

      ELSE                             !  neutral case:

         DHT = 1.5 * NEUTRL( BFLX, WSTK, USTAR )
         IQ  = 2

      END IF                 !  hstar ==> unstable, stable, or neutral
  
C Compute further plume rise from between level surfaces:
      NN = 0
      RBFLX = BFLX
      ZPLM  = DHT

C End calculations if the momentum rise was used in the calculation

      IF ( IQ .EQ. 4 ) GO TO 199  ! to point past iterative buoyancy loop

      DO       !  loop computing further plume rise

         RX = ZPLM - ZF( LPLM )
         IF ( RX .LE. 0.0 ) THEN
            EXIT  ! exit plume rise loop
         END IF

         IF ( LPLM .EQ. EMLAYS ) THEN   ! we're finished
            ZPLM = MIN( ZPLM, ZF( EMLAYS ) )
            WRITE( LOGDEV,'(5X, A, I3, F10.3)' )
     &                    'Plume rise reached EMLAYS with ZPLM:', EMLAYS, ZPLM
            EXIT  ! exit plume rise loop
         END IF

C Reset met data. NOTE- the original RADM code submitted the 
C WSPD and TA to an interpolator, but then requested the height of
C interpolation identical to ZH( LPLM ).
         NN = NN + 1
         IF ( NN .GT. 1 ) THEN
            WPLM = WSPD( LPLM )
            TPLM = TA  ( LPLM )
         ELSE                  ! 1st time, use stack values ...
            WPLM = WSTK
            TPLM = TSTK
         END IF
 
C Compute residual bflx by stability case IQ:

         IF ( IQ .EQ. 1 ) THEN
            RX = D45 * RX      ! Includes the 1.5 factor for plume top
            RBFLX = WPLM * ( RX ** FIVETHD )
         ELSE IF ( IQ .EQ. 2 ) THEN
            PX = TWOTHD * ZPLM         
            RBFLX = D2664 * ( RX ** FIVETHD ) * WPLM * ( USTAR * USTAR ) / PX ** TWOTHD
         ELSE      !  else iq = 3:
            RBFLX = D59319 * WPLM * SX * RX ** 3
         END IF      !  if stability flag iq is 1, 2, or 3

C Increment the layer number below.
         IF ( LPLM .LT. EMLAYS ) LPLM = LPLM + 1
         WPLM = WSPD( LPLM )
         TPLM = TA  ( LPLM )

C Prevent divide-by-zero by WPLM
         IF ( WPLM .EQ. 0.0 ) WPLM = NODIV0

C Process according to stability cases:
         SX = GRAV * DTHDZ( LPLM ) / TPLM
         IF ( SX .GT. SMALL ) THEN               ! stable case:
C Use the theta gradient to determine pr eqn.
            DHT = 1.5 * STABLE( RBFLX, WPLM, SX )
            DHN = 1.5 * NEUTRL( RBFLX, WPLM, USTAR )
            IF ( DHN .LT. DHT ) THEN
               DHT = DHN
               IQ  = 2
            ELSE
               IQ  = 3
            END IF
            DH = DHT / 1.5
         ELSE          ! if upper layer is not stable, use neutral formula
                         
            DHN = NEUTRL( RBFLX, WPLM, USTAR )
            DH  = UNSTBL( RBFLX, WPLM )
            IQ = 1
            IF ( DHN .LT. DH ) THEN
               DH = DHN
               IQ  = 2
            END IF
            DHT = 1.5 * DH

         END IF
  
         ZPLM = ZF( LPLM-1 ) + DHT
         DH   = ZF( LPLM-1 ) + DH 
        
      END DO  ! end loop computing further plume rise

199   CONTINUE

C Compute plume rise amount (DH) and actual final plume centerline height (ZPLM):
      DH  = TWOTHD * ZPLM
      ZPLM = DH            

      RETURN

      END SUBROUTINE FIRE_PLMRIS

         
!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

        SUBROUTINE SA_DIM 

C KWOK: Determine dimensions of tagging array based on user-supplied sa_io_list
C KWOK: Created Oct 20, 2010
C
C20140428  Called by driver.F
C

        USE UTILIO_DEFN
        USE SA_DEFN
        USE EMIS_VARS, ONLY: N_EM_SRM

        IMPLICIT NONE

        CHARACTER( 16 ) :: PNAME = 'SA_DIM'

        INTEGER IOST

        INTEGER NTAGS

C----------------------------------------------

C...Count the number of tags specified by user
          CALL CNT_SA_IO_LIST( NTAGS )

C...Reading in the tag information
          ALLOCATE ( TAGNAME( NTAGS + 4 ), STAT = IOST )
          CALL CHECKMEM( IOST, 'TAGNAME', PNAME )
          TAGNAME = "NOT"

          ALLOCATE ( TAGSTREAMS_TEMP( NTAGS ), STAT = IOST )
          CALL CHECKMEM( IOST, 'TAGSTREAMS_TEMP', PNAME )
          TAGSTREAMS_TEMP = ''

          ALLOCATE ( TAGSTREAMS_NUM( NTAGS ) )
          TAGSTREAMS_NUM = 0

          ALLOCATE ( ISAMRGN_TEMP( NTAGS ), STAT = IOST )
          CALL CHECKMEM( IOST, 'ISAMRGN_TEMP', PNAME )

          ALLOCATE ( ISAMRGN_NUM( NTAGS ), STAT = IOST )
          CALL CHECKMEM( IOST, 'ISAMRGN_NUM', PNAME )
          ISAMRGN_NUM = 0

C...Process tag infromation from control file
          CALL RD_SA_IO_LIST( NTAGS )

C...Assign Tag Indices To ICON, BCON, OTHER *in that order*
          BCONTAG = NTAGS + 1
          OTHRTAG = BCONTAG + 1
          ICONTAG = OTHRTAG + 1
          NTAG_SA = ICONTAG

          TAGNAME( BCONTAG ) = "BCO"
          TAGNAME( OTHRTAG ) = "OTH"
          TAGNAME( ICONTAG ) = "ICO"

           
          CALL GET_NSPC_SA 

        END SUBROUTINE SA_DIM

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE COUPLE ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Convert units and couple concentration values in CGRID for transport
 
C Preconditions:
 
C Subroutines and functions called:
C   INTERPX, M3EXIT
 
C Revision History:
C    Jeff Sep 97 - leave gas chem, non-reactive and tracer species in
C                  standard (ppmV) units for transport
C    2 October, 1998 by Al Bourgeois at LM: parallel implementation
C   Jeff - Dec 00 - move CGRID_MAP into f90 module
C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C        - Jun 01 - update units conversion calls and comments
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                      removed deprecated TRIMLEN
C   16 Sep 11 S.Roselle: for Pleim`s zadv-wrf blend
C   11 Oct 11 J.Young: eliminate ppmv_msmr
C   15 Nov 2018: L.Zhou, S.Napelenok: isam implementation
C   01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all
C                     MY_N clauses
C   10 July 19 F. Sidi: Renamed Subroutine
C   09 Dec 19 S.L.Napelenok: ddm-3d implementation for cmaq v5.3.1
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
      use CENTRALIZED_IO_MODULE, only : interpolate_var
#ifdef isam
      USE SA_DEFN, ONLY: ISAM, NSPC_SA, NTAG_SA, SPC_INDEX, TRANSPORT_SPC, ITAG
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP
#endif 


      IMPLICIT NONE   

C Include files:
      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:
!     REAL      :: CGRID( :,:,:,: )  ! concentrations
      REAL, POINTER :: CGRID( :,:,:,: )   ! concentrations
      INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP( 3 ) ! time step vector (HHMMSS)
                                          ! TSTEP(1) = local output step
                                          ! TSTEP(2) = sciproc sync. step (chem)
                                          ! TSTEP(3) = twoway model time step w.r.t.
                                          ! wrf time step and wrf/cmaq call frequency
C Parameters:
      REAL, PARAMETER :: GPKG = 1.0E+03   ! g/kg
      REAL, PARAMETER :: MGPG = 1.0E+06   ! micro-g/g
      REAL, PARAMETER :: CONV = GPKG * MGPG

C External Functions:

C File Variables:
      REAL     :: JACOBM( NCOLS,NROWS,NLAYS )  !"total" Jacobian
      REAL     :: RHOJ  ( NCOLS,NROWS,NLAYS )  !"total" Jacobian * air density

C Local Variables:
      CHARACTER( 16 ) :: PNAME = 'COUPLE'
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 96 ) :: XMSG = ' '

      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER, SAVE :: NQAE              ! number of micro-grams/m**3 species
      INTEGER, SAVE :: NNAE              ! number of #/m**3 species
      INTEGER, SAVE :: NSAE              ! number of m**2/m**3 species
      INTEGER, ALLOCATABLE, SAVE :: QAE( : ) ! CGRID pointer to micro-grams/m**3 species
      INTEGER, ALLOCATABLE, SAVE :: NAE( : ) ! CGRID pointer to #/m**3 species
      INTEGER, ALLOCATABLE, SAVE :: SAE( : ) ! CGRID pointer to m**2/m**3 species

      INTEGER     ALLOCSTAT

      INTEGER     OFF              ! loop offset to CGRID species
      INTEGER     C, R, L, SPC, V  ! loop counters
      INTEGER     RHOJ_LOC         ! pointer to transported RHOJ (in CGRID)

#ifdef isam
      INTEGER  :: SPC_CGRID
#endif

C-----------------------------------------------------------------------

C If ISPCA .ne. 0, then air is advected and concs. are adjusted

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         IF ( N_AE_SPC .GT. 0 ) THEN
C create aerosol species pointers to distinguish micro-grams/m**3,
C #/m**3 (number density), and m**2/m**3 (surface area) species
 
            ALLOCATE ( QAE( N_AE_SPC ),
     &                 NAE( N_AE_SPC ),
     &                 SAE( N_AE_SPC ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating QAE, NAE, or SAE'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            NQAE = 0       ! no. of micro-grams/m**3 species
            NNAE = 0       ! no. of #/m**3 species
            NSAE = 0       ! no. of m**2/m**3 species
!           OFF = AE_STRT - 1
            OFF = 0
            DO SPC = 1, N_AE_SPC
               IF ( AE_SPC( SPC )( 1:3 ) .EQ. 'NUM' ) THEN
                  NNAE = NNAE + 1
                  NAE( NNAE ) = OFF + SPC
               ELSE IF ( AE_SPC( SPC )( 1:3 ) .EQ. 'SRF' ) THEN
                  NSAE = NSAE + 1
                  SAE( NSAE ) = OFF + SPC
               ELSE
                  NQAE = NQAE + 1
                  QAE( NQAE ) = OFF + SPC
               END IF
            END DO

         END if

      END IF       ! if firstime

C Read Jacobian X Air Density (Jacobian =  sq. root det. metric tensor)

      call interpolate_var ('DENSA_J', jdate, jtime, RHOJ)
 
      call interpolate_var ('JACOBM', jdate, jtime, JACOBM)

C couple for advection - use density times the square root of the determinant
C of the metric tensor (the Jacobian) = RHOJ

C CGRID in mixing ratio [ppmV] -> (air density X "total" Jacobian) X mixing ratio [ppmV]
      IF ( N_GC_SPC .GT. 0 ) THEN
         OFF = GC_STRT - 1
         DO V = 1, N_GC_TRNS
            SPC = OFF + GC_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) * RHOJ( C,R,L )
#ifdef sens
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) * RHOJ( C,R,L )
                     END DO
#endif
                  END DO
               END DO
            END DO
         END DO
      END IF
 
C initialize RhoJ from MCIP - done once per sync step
      RHOJ_LOC = GC_STRT + N_GC_SPC
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS
               CGRID( C,R,L,RHOJ_LOC ) = RHOJ( C,R,L )
#ifdef sens
                  DO NP = 1, NPMAX
                     SENGRID( C,R,L,NP,RHOJ_LOC ) = 0.0
                  END DO
#endif
            END DO
         END DO
      END DO

      OFF = AE_STRT - 1
C CGRID in ug/m**3 -> ("total" Jacobian [m]) X [Kg/m**3]
      IF ( NQAE .GT. 0 ) THEN
         DO V = 1, NQAE
            SPC = OFF + AE_TRNS_MAP( QAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = JACOBM( C,R,L ) * CGRID( C,R,L,SPC ) / CONV
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = JACOBM( C,R,L ) * SENGRID(C,R,L,NP,SPC)  / CONV
                     END DO
#endif
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in #/m**3 -> ("total" Jacobian [m]) X [#/m**3]
      IF ( NNAE .GT. 0 ) THEN
         DO V = 1, NNAE
            SPC = OFF + AE_TRNS_MAP( NAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = JACOBM( C,R,L ) * CGRID( C,R,L,SPC )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = JACOBM( C,R,L ) * SENGRID(C,R,L,NP,SPC)
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in m**2/m**3 -> ("total" Jacobian [m]) X [m**2/m**3]
      IF ( NSAE .GT. 0 ) THEN
         DO V = 1, NSAE
            SPC = OFF + AE_TRNS_MAP( SAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = JACOBM( C,R,L ) * CGRID( C,R,L,SPC )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = JACOBM( C,R,L ) * SENGRID(C,R,L,NP,SPC)
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in mixing ratio [ppmV] -> (air density X "total" Jacobian) X mixing ratio [ppmV]
      IF ( N_NR_SPC .GT. 0 ) THEN
         OFF = NR_STRT - 1
         DO V = 1, N_NR_TRNS
            SPC = OFF + NR_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) * RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC)* RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF
 
C CGRID in mixing ratio [ppmV] -> (air density X "total" Jacobian) X mixing ratio [ppmV]
      IF ( N_TR_SPC .GT. 0 ) THEN
         OFF = TR_STRT - 1
         DO V = 1, N_TR_SPC
            SPC = OFF + V
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) * RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) * RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

#ifdef isam
      DO SPC = 1, NSPC_SA
        IF ( TRANSPORT_SPC( SPC ) ) THEN
          SPC_CGRID = SPC_INDEX(SPC,2)
          IF ( SPC_CGRID .LE. N_GC_SPC .OR. SPC_CGRID .GE. NR_STRT ) THEN ! this is not an aerosol
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = ISAM( C,R,L,SPC,ITAG ) * RHOJ( C,R,L )
                    END DO
                 END DO
              END DO
            END DO
          ELSE ! this is an aerosol (mass only)
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = JACOBM( C,R,L ) * ISAM( C,R,L,SPC,ITAG ) / CONV
                    END DO
                 END DO
              END DO
            END DO
          END IF
        ENDIF
      END DO
#endif

      RETURN
 
C............................................................................
C entry DECOUPLE
 
      ENTRY DECOUPLE ( CGRID, JDATE, JTIME, TSTEP )

      call interpolate_var ('JACOBM', jdate, jtime, JACOBM)
 
C retrieve transported RhoJ
      RHOJ_LOC = GC_STRT + N_GC_SPC
      DO L = 1, NLAYS
         DO R = 1, NROWS
            DO C = 1, NCOLS
               RHOJ( C,R,L ) = CGRID( C,R,L,RHOJ_LOC )
            END DO
         END DO
      END DO

C decouple for chemistry and diffusion
 
C CGRID in mixing ratio [ppmV] X (air density X "total" Jacobian) -> mixing ratio [ppmV]
      IF ( N_GC_SPC .GT. 0 ) THEN
         OFF = GC_STRT - 1
         DO V = 1, N_GC_TRNS
            SPC = OFF + GC_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF
 
      OFF = AE_STRT - 1
C CGRID in Jacobian [m]) X [Kg/m**3] -> [ug/m**3]
      IF ( NQAE .GT. 0 ) THEN
         DO V = 1, NQAE
            SPC = OFF + AE_TRNS_MAP( QAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CONV * CGRID( C,R,L,SPC ) / JACOBM( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = CONV * SENGRID(C,R,L,NP,SPC) / JACOBM( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in Jacobian [m] X [#/m**3] -> #/m**3
      IF ( NNAE .GT. 0 ) THEN
         DO V = 1, NNAE
            SPC = OFF + AE_TRNS_MAP( NAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / JACOBM( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / JACOBM( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in Jacobian [m] X [m**2/m**3] -> m**2/m**3
      IF ( NSAE .GT. 0 ) THEN
         DO V = 1, NSAE
            SPC = OFF + AE_TRNS_MAP( SAE( V ) )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / JACOBM( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / JACOBM( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

C CGRID in mixing ratio [ppmV] X (air density X "total" jacobian) -> mixing ratio [ppmV]
      IF ( N_NR_SPC .GT. 0 ) THEN
         OFF = NR_STRT - 1
         DO V = 1, N_NR_TRNS
            SPC = OFF + NR_TRNS_MAP( V )
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF
 
C CGRID in mixing ratio [ppmV] X (air density X "total" jacobian) -> mixing ratio [ppmV]
      IF ( N_TR_SPC .GT. 0 ) THEN
         OFF = TR_STRT - 1
         DO V = 1, N_TR_SPC
            SPC = OFF + V
            DO L = 1, NLAYS
               DO R = 1, NROWS
                  DO C = 1, NCOLS
                     CGRID( C,R,L,SPC ) = CGRID( C,R,L,SPC ) / RHOJ( C,R,L )
#ifdef sens       
                     DO NP = 1, NPMAX
                        SENGRID( C,R,L,NP,SPC ) = SENGRID(C,R,L,NP,SPC) / RHOJ( C,R,L )
                     END DO
#endif               
                  END DO
               END DO
            END DO
         END DO
      END IF

#ifdef isam
      DO SPC = 1, NSPC_SA
        IF ( TRANSPORT_SPC( SPC ) ) THEN
          SPC_CGRID = SPC_INDEX(SPC,2)
          IF ( SPC_CGRID .LE. N_GC_SPC .OR. SPC_CGRID .GE. NR_STRT ) THEN ! this is not an aerosol
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = ISAM( C,R,L,SPC,ITAG ) / RHOJ( C,R,L )
                    END DO
                 END DO
              END DO
            END DO
          ELSE ! this is an aerosol (mass only)
            DO ITAG = 1, NTAG_SA
              DO L = 1, NLAYS
                 DO R = 1, NROWS
                    DO C = 1, NCOLS
                      ISAM( C,R,L,SPC,ITAG ) = CONV * ISAM( C,R,L,SPC,ITAG ) / JACOBM( C,R,L )
                    END DO
                 END DO
              END DO
            END DO
          END IF
        END IF
      END DO
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/aero/aero5/getpar.f,v 1.7 2012/01/19 13:13:27 yoj Exp $

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Subroutine getpar( fixed_sg  )

C  Calculates the 3rd moments (M3), masses, aerosol densities, and
C  geometric mean diameters (Dg) of all 3 modes, and the natural logs of
C  geometric standard deviations (Sg) of the Aitken and accumulation modes.

C  The logical variable, WET_MOMENTS_FLAG, dictates whether the
C  calculations in GETPAR are to assume that the aerosol is "wet" or
C  "dry."  In the present context, a "wet" aerosol consists of all
C  chemical components of the aerosol.  A "dry" aerosol excludes
C  particle-bound water and also excludes semivol secondary organic aerosol.

C  NOTE! 2nd moment concentrations (M2) are passed into GETPAR in the
C  CBLK array and are modified within GETPAR only in the event that
C  the Sg value of a given mode has gone outside of the acceptable
C  range (1.05 to 2.50).  The GETPAR calculations implicitly assume
C  that the input value of M2 is consistent with the input value of
C  WET_MOMENTS_FLAG.  If, for example, the input M2 value was calculated
C  for a "dry" aerosol and the WET_MOMENTS_FLAG is .TRUE., GETPAR would
C  incorrectly adjust the M2 concentrations!
C  
C  Outputs: 
C    moment3_conc  third moment, porportional to volume [ m3/m3 ]
C    moment2_conc  second moment, prop. to surface area [ m2/m3 ] 
C                     (adjusted if standard dev. hits limit)
C    aeromode_dens [ kg/m3 ]
C    aeromode_lnsg log of geometric standard deviation
C    aeromode_diam geometric mean diameter [ m ]
C    aeromode_mass mass concentration: [ ug / m**3 ]
C
C SH  03/10/11 Renamed met_data to aeromet_data
C HP and BM 4/2016: Updated use of wet_moments_flag which is now
C    available through AERO_DATA consistent with the moments it refers to
C-----------------------------------------------------------------------

      Use aero_data, only : wet_moments_flag, moment3_conc, moment2_conc, moment0_conc,
     &                       aeromode_dens, aeromode_lnsg, aeromode_diam, aeromode_mass,
     &                       min_diam_g, min_sigma_g, max_sigma_g, n_mode, n_aerospc,
     &                       aerospc, aero_missing, aerospc_conc, aeromode
      Use aeromet_data, only : f6pi   ! Includes CONST.EXT

      Implicit None

C Arguments:
      Logical, Intent( In ) :: fixed_sg  ! If TRUE, then the second moment is modified 
                                         ! during each call in order to preserve the 
                                         ! standard deviaiton at the current value.
                                         !
                                         ! If FALSE, then the standard deviation is 
                                         ! recalculated to be consistent with the current 
                                         ! combination of the 0th, 2nd and 3rd moments.
                                         ! During this calculation, standard deviaiton is 
                                         ! limited by parameters in AERO_DATA (min_sigma_g 
                                         ! and max_sigma_g)

C Local Variables:
      Real( 8 ) :: xxm0        ! temporary storage of moment 0 conc's
      Real( 8 ) :: xxm2        ! temporary storage of moment 2 conc's
      Real( 8 ) :: xxm3        ! temporary storage of moment 3 conc's
      Real( 8 ) :: xfsum       ! (ln(M0)+2ln(M3))/3; used in Sg calcs
      Real( 8 ) :: lxfm2       ! ln(M2); used in Sg calcs
      Real( 8 ) :: l2sg        ! square of ln(Sg); used in diameter calcs
      Real      :: es36        ! exp(4.5*l2sg); used in diameter calcs

      Real( 8 ), Parameter :: one3d = 1.0D0 / 3.0D0
      Real( 8 ), Parameter :: two3d = 2.0D0 / 3.0D0

      Real,      Parameter :: one3  = 1.0 / 3.0
      Real,      Parameter :: densmin = 1.0E03  ! minimum particle density [ kg/m**3 ]

      Real( 8 ), Save :: minl2sg( n_mode )   ! min value of ln(sg)**2 for each mode
      Real( 8 ), Save :: maxl2sg( n_mode )   ! max value of ln(sg)**2 for each mode

      Real( 8 ) :: factor
      Real( 8 ) :: species_mass
      Real( 8 ) :: sumM3
      Real( 8 ) :: sumMass
      Integer   :: n, spc   ! loop counters

      Real( 8 ), Save :: min_ln_sig_g_squ
      Real( 8 ), Save :: max_ln_sig_g_squ
      Logical,   Save :: FirsTime = .True.

C-----------------------------------------------------------------------

      If ( FirsTime ) Then
          ! Set bounds for ln(Sg)**2
          minl2sg = Real( Log( min_sigma_g ) ** 2, 8 )
          maxl2sg = Real( Log( max_sigma_g ) ** 2, 8 )
          FirsTime = .False.
      End If



C *** Calculate aerosol 3rd moment concentrations [ m**3 / m**3 ]

      Do n = 1, n_mode
         sumM3   = 0.0d0
         sumMass = 0.0d0

         Do spc = 1, n_aerospc
            If ( aerospc( spc )%tracer .Or. aero_missing(spc,n) .Or. 
     &         ( aerospc( spc )%no_M2Wet .AND. .Not. wet_moments_flag ) ) Cycle

            factor       = Real( 1.0E-9 * f6pi / aerospc( spc )%density, 8 )
            species_mass = Real( aerospc_conc( spc,n ), 8 )
            sumM3        = sumM3   + factor * species_mass
            sumMass      = sumMass + species_mass
         End Do

         moment3_conc( n )  = Max ( Real( sumM3 ), aeromode( n )%min_m3conc )
         aeromode_mass( n ) = Real( sumMass )
      End Do

C *** Calculate modal average particle densities [ kg/m**3 ]
      aeromode_dens = 1.0E-9 * f6pi * aeromode_mass / moment3_conc
      Where( aeromode_dens .Lt. densmin )
         aeromode_dens = densmin
      End Where

C *** Calculate geometric standard deviations as follows:
c        ln^2(Sg) = 1/3*ln(M0) + 2/3*ln(M3) - ln(M2)
c     NOTES:
c      1. Equation 10-5a of [Binkowski:1999] and Equation 5a of
c         Binkowski&Roselle(2003) contain typographical errors.
c      2. If the square of the logarithm of the geometric standard
c         deviation is out of an acceptable range, reset this value and
c         adjust the second moments to be consistent with this value.
c         In this manner, M2 is artificially increased when Sg exceeds
c         the maximum limit.  M2 is artificially decreased when Sg falls
c         below the minimum limit.

      Do n = 1, n_mode
         xxm0 = Real( moment0_conc( n ), 8 )
         xxm3 = Real( moment3_conc( n ), 8 )
         xfsum = one3d * Log( xxm0 ) + two3d * Log( xxm3 )

         if ( fixed_sg ) then
            l2sg  = Real( aeromode_lnsg( n ) ** 2, 8)

         else
            xxm2  = Real( moment2_conc( n ), 8 )

            lxfm2 = Log( xxm2 )
            l2sg  = xfsum - lxfm2

            l2sg  = Max( l2sg, minl2sg( n ) )
            l2sg  = Min( l2sg, maxl2sg( n ) )

         end if

         lxfm2 = xfsum - l2sg
         moment2_conc( n )  = Real( Exp ( lxfm2 ) )
         aeromode_lnsg( n ) = Real( Sqrt( l2sg ) )

         ES36 = Real( Exp( 4.5d0 * l2sg ) )
         aeromode_diam( n ) = Max( min_diam_g( n ), ( moment3_conc( n )
     &                      / ( moment0_conc( n ) * es36 ) ) ** one3 )

      End Do

      Return
      End Subroutine getpar

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE WR_INIT ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Create the IO/API netCDF header and open the output CONC file

C Revision history:
C   Dec 15 D.Wong: Created for writing initial data to CONC file
C   Apr 16 D.Wong: Added INTEN attribute for arguments JDATE, JTIME, and TSTEP
C                  so they match with the interface block in INITSCEN.F
C   Feb 19 D.Wong: removed all MY_N clauses
C   June 19 F. Sidi: Replaced BADVAL3 for TA, RH, & PRES with MET DATA
C   Sept 19 F. Sidi: Replaced L_CONC_WVEL(depreciated) with W_VEL 
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE WVEL_DEFN             ! derived vertical velocity component
      USE STD_CONC              ! standard CONC
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif
      USE CENTRALIZED_IO_MODULE
      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID    ! file name parameters
      
C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )  ! for initial CONC
      INTEGER, INTENT( IN ) :: JDATE     ! starting date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME     ! starting time (HHMMSS)
      INTEGER, INTENT( IN ) :: TSTEP     ! output timestep (HHMMSS)

C Local Variables:

      REAL, ALLOCATABLE :: DBUFF( :,:,: ), DBUFFP( :, :, :),
     &                     DBUFFTA( :, :, :), DBUFFQV(:, :, :)

      INTEGER      ALLOCSTAT

      CHARACTER( 16 ) :: PNAME = 'OPCONC'
      CHARACTER( 96 ) :: XMSG = ' '
      CHARACTER( 28 ) :: SSTR = ' species saved to CONC file:'

C environment variable for no. of layers from bottom to save on CONC file
      CHARACTER( 16 ) :: NLAYS_CONC = 'NLAYS_CONC'

C  environment variable description
      CHARACTER( 80 ) :: VARDESC

      INTEGER      K, KD, L, SPC, V   ! loop counters
      INTEGER      STRT, FINI         ! loop counters
      INTEGER      INDX

      LOGICAL, EXTERNAL :: FLUSH3

C-----------------------------------------------------------------------

#ifdef parallel_io
      CALL SUBST_BARRIER
      IF ( .NOT. IO_PE_INCLUSIVE ) THEN
         IF ( .NOT. OPEN3( CTM_CONC_1, FSREAD3, PNAME ) ) THEN
            XMSG = 'Could not open ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
#endif

C write the initial concentrations as step 0 on the conc file
C (inital data assumed to be in correct output units)

      ALLOCATE ( DBUFF( NCOLS,NROWS,C_NLAYS ), DBUFFP( NCOLS, NROWS,
     &           C_NLAYS), DBUFFTA( NCOLS, NROWS, C_NLAYS), 
     &           DBUFFQV( NCOLS, NROWS, C_NLAYS), STAT = ALLOCSTAT )
      IF ( ALLOCSTAT .NE. 0 ) THEN
         XMSG = 'Failure allocating DBUFF(s)'
         CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
      END IF

      WRITE( LOGDEV,* ) ' '

      V = 0

      IF ( N_C_GC_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Gas Chem", A )' ) SSTR

      DO SPC = 1, N_C_GC_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_GC_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_GC_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_GC_SPC( SPC ) )

      END DO

      IF ( N_C_AE_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Aerosol", A )' ) SSTR

      DO SPC = 1, N_C_AE_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_AE_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_AE_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_AE_SPC( SPC ) )

      END DO

      IF ( N_C_NR_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Non-reactive", A )' ) SSTR

      DO SPC = 1, N_C_NR_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_NR_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_NR_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_NR_SPC( SPC ) )
      END DO

      IF ( N_C_TR_SPC .NE. 0 ) WRITE( LOGDEV,'( /5X, "Inert tracer", A )' ) SSTR

      DO SPC = 1, N_C_TR_SPC
         V = V + 1
         INDX = CONC_MAP( V )

         DBUFF = CGRID( 1:NCOLS,1:NROWS,CONC_BLEV:CONC_ELEV,INDX )

         IF ( .NOT. WRITE3( CTM_CONC_1, C_TR_SPC( SPC ),
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write ' //
     &             TRIM( C_TR_SPC( SPC ) ) //
     &             ' to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         WRITE( LOGDEV,'( 5X, I4, " (", I3, ") ", A )' )
     &                SPC, V, TRIM( C_TR_SPC( SPC ) )

      END DO
 
      IF ( W_VEL ) THEN   ! Vertical Velocity Calculated from Advection

         DBUFF = BADVAL3

         IF ( .NOT. WRITE3( CTM_CONC_1, 'W_VEL',
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write Vertical Velocity (W_VEL) to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF
 
       IF ( L_CONC_TA ) THEN   ! for Temperature
      
      CALL interpolate_var ('TA', JDATE, JTIME, DBUFFTA)
         
         IF ( .NOT. WRITE3( CTM_CONC_1, 'TA',
     &                      JDATE, JTIME, DBUFFTA ) ) THEN
            XMSG = 'Could not write Temperature to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF

      IF ( L_CONC_PRES ) THEN   ! for Pressure
      
      CALL interpolate_var ('PRES', JDATE, JTIME, DBUFFP)
      
         IF ( .NOT. WRITE3( CTM_CONC_1, 'PRES',
     &                      JDATE, JTIME, DBUFFP ) ) THEN
            XMSG = 'Could not write Pressure to ' // CTM_CONC_1
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF


      IF ( L_CONC_RH ) THEN   ! for Relative Humidity

      CALL interpolate_var ('QV', JDATE, JTIME, DBUFFQV)

         DBUFF = DBUFFQV * DBUFFP / ( DBUFFQV + 0.622015 ) /
     &                 ( 610.94 * EXP( 17.625 * ( DBUFFTA - 273.15 ) / 
     &                                 ( DBUFFTA - 273.15 + 243.04 ) ) )
         DBUFF = MIN( 0.9999, MAX( 0.001, DBUFF) )

         IF ( .NOT. WRITE3( CTM_CONC_1, 'RH',
     &                      JDATE, JTIME, DBUFF ) ) THEN
            XMSG = 'Could not write Relative Humidity to ' // CTM_CONC_1

            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
      END IF


      DEALLOCATE ( DBUFF, DBUFFP, DBUFFTA, DBUFFQV)

      WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &  'Timestep written to', CTM_CONC_1,
     &  'for date and time', JDATE, JTIME
      WRITE( LOGDEV, '(  5X,  A, 1X, I8, ":", I6.6 )' )
     &  'from timestep on initial data files for date and time',
     &   JDATE, JTIME

      RETURN
      END SUBROUTINE WR_INIT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/PARIO/src/ptrwrite3.f,v 1.2 2011/03/30 18:13:05 sjr Exp $ 

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

        LOGICAL FUNCTION PTRWRITE3( FNAME, VNAME, JDATE, JTIME, BUFFER )

C-----------------------------------------------------------------------
C Function: Writes grided data BUFFER to the Models-3 data file with logical 
C           name FNAME by collecting from each PE.

C Return Value: TRUE iff the operation succeeds

C Preconditions: FNAME is a Models-3 data file already opened for write
C                access by OPEN3() or by CREATE3()

C Postconditions: Subsequent call to SHUT3() to flush the file to disk

C Revision History:
C   prototype 08/01 by David Wong, Lockheed Martin
C             10/01 by David Wong
C             -- expanded functionality to handle PING file
C             -- adjusted SIZE according to VID
C             -- modified the routine to accommodate writing sub-grid data
C             12/02 by David Wong
C             -- exteneded to write dot file
C             01/03 by David Wong
C             -- inserted WRTFLAG function to output time step info
C             02/04 by David Wong
C             -- collect all subdomain data and call WRITE3 once
C   12 May 06 J.Young: rank 4 F90 pointer capablity for BUFFER
C   23 Feb 11 S.Roselle: replaced I/O API include files with M3UTILIO; removed
C                        deprecated TRIMLEN
C   10 Sep 14 D. Wong: Removed redundant INCLUDE NETCDF.EXT statement
C-----------------------------------------------------------------------

      USE M3UTILIO              ! i/o api
      USE RUNTIME_VARS, ONLY : PWRTFLAG
      USE PIOMAPS_MODULE

      IMPLICIT NONE

C Includes:

      INCLUDE 'STATE3.EXT'

      INCLUDE 'PIOVARS.EXT'      ! Parameters for parallel implementation.
      INCLUDE 'PIOGRID.EXT'      ! Parallel grid dimensions.
!     INCLUDE 'PIOMAPS.EXT'      ! Parallel processor-to-subdomain maps.

      INCLUDE 'mpif.h'

C Arguments:

      CHARACTER( * ) :: FNAME       ! logical file name
      CHARACTER( * ) :: VNAME       ! logical file name
      INTEGER           JDATE       ! date, formatted YYYYDDD
      INTEGER           JTIME       ! time, formatted HHMMSS
      REAL, POINTER ::  BUFFER( :,:,:,: ) ! output buffer array

C Local Variables:

      INTEGER       IDUM            ! holds return value for INIT3()
      INTEGER       FID             ! file-subscript for STATE3 arrays
      INTEGER       STEP            ! time step record number
      INTEGER       STEP2           ! 1 or 2, according to step mod 2
      INTEGER       TFLAG( 2 )      ! ( JDATE=yyyyddd, JTIME=hhmmss )
      INTEGER       IERR            ! netCDF error status return
      CHARACTER( 16 ) :: FIL16      ! scratch file-name     buffer
      CHARACTER( 16 ) :: VAR16      ! scratch variable-name buffer

C Static Variables:

      LOGICAL        FLCHANGE      ! File-changed indicator.

C File written to on previous call to pwrite3.
      CHARACTER( 16 ), SAVE :: PREVFILE = '????????????????'
      CHARACTER( 80 ) :: MSG       ! Buffer for building error messages.

      INTEGER        ERROR
      INTEGER        NVARS         ! Number of file variables to read.
      INTEGER        IV            ! Loop counter over file variables.

      INTEGER        PACKAGE( 4 )  ! MPI broadcast data

      CHARACTER( 16 ) :: VNAM16    ! Scratch area for variable name.

      LOGICAL, EXTERNAL :: PWRGRDD ! Parallel write for gridded data files.

C-----------------------------------------------------------------------

C Check that Models-3 I/O has been initialized:

      PTRWRITE3 = .TRUE.

      IF ( .NOT. FINIT3 ) THEN
         IDUM = INIT3()
         WRITE( LOGDEV,91010 ) 'WRITE3():  I/O API not yet initialized.'
         PTRWRITE3 = .FALSE.; RETURN
      END IF

C Find netCDF index for the file, and check time step availability:

      IF ( LEN( FNAME ) .GT. 16 ) THEN
         WRITE( LOGDEV,91001 )
     &       'File "', FNAME, '"',
     &       'Max file name length 16; actual:', LEN( FNAME )
         PTRWRITE3 = .FALSE.; RETURN
      END IF

      IF ( LEN( VNAME ) .GT. 16 ) THEN
         WRITE( LOGDEV,91002 )
     &       'File "', FNAME, '"',
     &       'Variable "', VNAME, '"',
     &       'Max variable name length 16; actual:', LEN( VNAME )
         PTRWRITE3 = .FALSE.; RETURN
      END IF

      VAR16 = VNAME   ! fixed-length-16 scratch copy of name
      FIL16 = FNAME   ! fixed-length-16 scratch copy of name
      FID   = INDEX1 ( FIL16, COUNT3, FLIST3 )

      IF ( FNAME .EQ. PREVFILE ) THEN
         FLCHANGE = .FALSE.
      ELSE
         FLCHANGE = .TRUE.
         PREVFILE = FNAME
      END IF

      IF ( MY_PE .EQ. IO_PE ) THEN
         STEP = JSTEP3 ( JDATE, JTIME, SDATE3( FID ), STIME3( FID ),
     &                   ABS( TSTEP3( FID ) ) )
      END IF

      CALL MPI_BCAST ( STEP, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ERROR )

      IF ( STEP .LT. 0 ) THEN      
         WRITE( LOGDEV,91020 )
     &       'Time step error writing file:  ' // FIL16 ,
     &       'Requested date & time:    ', JDATE, JTIME ,
     &       'File starting date & time:',
     &       SDATE3( FID ), STIME3( FID ),
     &       'File time step:           ', TSTEP3( FID )
         PTRWRITE3 = .FALSE.; RETURN
      END IF
            
      IF ( MY_PE .EQ. IO_PE ) THEN

         IF ( TSTEP3( FID ) .LT. 0 ) THEN
            STEP2 = 1 + MOD ( STEP-1, 2 )
            TFLAG( 1 ) = JDATE
            TFLAG( 2 ) = JTIME
         ELSE IF ( TSTEP3( FID ) .EQ. 0 ) THEN
            STEP2 = STEP
            TFLAG( 1 ) = 0
            TFLAG( 2 ) = 0
         ELSE
            STEP2 = STEP
            TFLAG( 1 ) = JDATE
            TFLAG( 2 ) = JTIME
         END IF

C Get file description.
         IF ( .NOT. DESC3( FNAME ) ) THEN
             MSG = 'Could not get '// TRIM( FNAME )
     &           // ' file description'
             CALL M3WARN( 'PTRWRITE3', JDATE, JTIME, MSG )
         END IF

      END IF

      CALL MPI_BCAST ( UPNAM3D, 16, MPI_CHARACTER, 0, MPI_COMM_WORLD, ERROR )
      CALL MPI_BCAST ( FTYPE3D, 1, MPI_INTEGER, 0, MPI_COMM_WORLD, ERROR )

C Operation valid only for gridded files.
      IF ( FTYPE3D .EQ. GRDDED3 ) THEN

         IF ( UPNAM3D .EQ. 'PDM' .OR.
     &        UPNAM3D .EQ. 'READ_PTX2'.OR.
     &        UPNAM3D .EQ. 'FAKE_GRIDDED' ) THEN

            IF ( MY_PE .EQ. IO_PE ) THEN
               IF ( .NOT. WRITE3 ( FNAME, VNAME, JDATE, JTIME, BUFFER ) ) THEN
                  MSG = 'WRITE3 failed writing variable '
     &                // TRIM( VNAME )
     &                // ' to file '// TRIM( FNAME )
                  CALL M3WARN( 'PTRWRITE3', JDATE, JTIME, MSG )
                  PTRWRITE3 = .FALSE.
               END IF
            END IF

         ELSE
      
            IF ( MY_PE .EQ. IO_PE ) THEN
               PACKAGE( 1 ) = NCOLS3D
               PACKAGE( 2 ) = NROWS3D
               PACKAGE( 3 ) = NLAYS3D
               PACKAGE( 4 ) = NVARS3D
            END IF

            CALL MPI_BCAST ( PACKAGE, 4, MPI_INTEGER, 0, MPI_COMM_WORLD, ERROR )

            IF ( MY_PE .NE. IO_PE ) THEN
               NCOLS3D = PACKAGE( 1 )
               NROWS3D = PACKAGE( 2 )
               NLAYS3D = PACKAGE( 3 )
               NVARS3D = PACKAGE( 4 )
            END IF

            IF ( VAR16 .EQ. ALLVAR3 ) THEN
               NVARS = NVARS3D
            ELSE
               NVARS = 1
            END IF

            IF ( FLCHANGE ) THEN
               CALL GET_WRITE_MAP ( NUMPROCS, NPCOLD, NPROWD,
     &                              NCOLS3D, NROWS3D, NLAYS3D )
            END IF 

C Loop over file variables.
            DO IV = 1, NVARS

               IF ( VAR16 .EQ. ALLVAR3 ) THEN
                  VNAM16 = VNAME3D( IV )
               ELSE
                  VNAM16 = VAR16
               END IF

               IF ( .NOT. PWRGRDD( FIL16, VNAM16, JDATE, JTIME,
     &                             BUFFER( :,:,:,IV ),
     &                             NCOLS3D, NROWS3D, NLAYS3D,
     &                             NUMCOLS, NUMROWS, NUMPROCS ) ) THEN
                  MSG = 'PWRGRDD failed writing variable '
     &                  // TRIM( VNAM16 ) //
     &                  ' to file '// TRIM( FIL16 )
                  CALL PM3WARN( 'PTRWRITE3', JDATE, JTIME, MSG )
                  PTRWRITE3 = .FALSE.; RETURN
               END IF

            END DO

         END IF   ! fake-gridded

      ELSE     ! This is not a gridded file.

         MSG = 'PTRWRITE3 can not handle this type of data.'
         CALL PM3WARN( 'PTRWRITE3', JDATE, JTIME, MSG )
         PTRWRITE3 = .FALSE.; RETURN

      END IF   ! gridded file

      CALL MPI_BCAST ( PTRWRITE3, 1, MPI_LOGICAL, 0, MPI_COMM_WORLD, ERROR )

      IF ( .NOT. PTRWRITE3 ) THEN            !  failure
         IF ( MY_PE .EQ. IO_PE ) THEN
            IF ( TSTEP3( FID ) .EQ. 0 ) THEN
               WRITE( LOGDEV, 92030 ) 'Error writing', VNAME, 'to', FNAME
            ELSE
               WRITE( LOGDEV, 92030 ) 
     &         'Error writing', VNAME, 'to', FNAME, 'for', JDATE, JTIME
            END IF
         END IF
         RETURN
      END IF                        !  if failure
        
      IF ( MY_PE .EQ. IO_PE ) THEN
         MXREC3( FID ) = MAX( MXREC3( FID ), ABS( STEP ) )

         IF ( PWRTFLAG ) THEN   ! log successful writes
            IF ( VAR16 .NE. ALLVAR3 ) THEN   ! single variable written
               IF ( TSTEP3( FID ) .EQ. 0 ) THEN
                  WRITE( LOGDEV,92020 ) VNAME, 'written to', FNAME
               ELSE
                  WRITE( LOGDEV, 92020 ) 
     &                   VNAME, 'written to', FNAME, 'for', JDATE, JTIME
               END IF
            ELSE            ! vid <= 0:  entire timestamp written
               IF ( TSTEP3( FID ) .EQ. 0 ) THEN
                  WRITE( LOGDEV,92010 ) 'Record written to', FNAME
               ELSE
                  WRITE( LOGDEV,92010 ) 'Timestep written to', FNAME,
     &                     'for date and time', JDATE, JTIME
               END IF
            END IF          ! if single variable write, or timestamp write
         END IF          ! if PWRTFLAG
      END IF

      RETURN

C-----------------------------------------------------------------------

C Error and warning message formats... 91xxx

91001 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , 3A, /5X , A , I5, // )
91002 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , 3A, /5X , 3A, /5X , A , I5, // )
91010 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          3 ( /5X , A , : ) , I5, // )
91020 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , A , 2 ( /5X , A , :, I9, :, ':' , I6.6 ),
     &          /5X , A , 10X, I6.6,  // )
91030 FORMAT ( //5X , '>>> WARNING in subroutine WRITE3 <<<',
     &          /5X , A , I5 , : , /5X , A )

C Log message formats... 91xxx

92010 FORMAT ( /5X, 3( A, :, 1X ), I8, ':', I6.6 )
92020 FORMAT ( /5X, 4( A, :, 1X ), I8, ':', I6.6 )
92030 FORMAT ( /5X, 5( A, :, 1X ), I8, ':', I6.6 )

        END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


      SUBROUTINE HRINIT
C***********************************************************************
C
C  FUNCTION: To initialize species tolerances, arrays, and indices
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  RETURN VALUES: None
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C   21 Jun 10 J.Young:   convert for Namelist redesign
C   18 Jul 14 B.Hutzell: revised to use the RXNS_DATA and RXNS_FUNCTION
C                        modules instead of include files
C***********************************************************************

      USE UTILIO_DEFN
      USE HRDATA
      USE RXNS_DATA
      USE RXNS_FUNCTION

      IMPLICIT NONE

C.....INCLUDES:
      Include SUBST_CONST          ! common constants

C.....ARGUMENTS: NONE

C.....PARAMETERS: NONE


C.....SAVED VARIABLES:
      CHARACTER( 16 ), SAVE  ::  PNAME = 'HRINIT'   ! Program name


C.....LOCAL VARIABLES:
      CHARACTER( 132 ) ::  MSG       ! Log message

      INTEGER N               ! Loop index
      INTEGER IOS             ! Allocate error status

C***********************************************************************

      N_SPEC = NUMB_MECH_SPC
      N_RXNS = NRXNS
      N_SPCL_RKS =   0
      ALLOCATE( RKI( NRXNS ),
     &          RKI_SAV( MAX_CELLS_EBI, NRXNS ),
     &          FORWARD_CONV( NUMB_MECH_SPC),
     &          REVERSE_CONV( NUMB_MECH_SPC),
     &          RXRAT( NRXNS ),
     &          RTOL( NUMB_MECH_SPC),
     &          YC(   NUMB_MECH_SPC),
     &          YC0(  NUMB_MECH_SPC),
     &          YCP(  NUMB_MECH_SPC),
     &          PROD( NUMB_MECH_SPC),
     &          LOSS( NUMB_MECH_SPC),
     &          PNEG( N_SPEC),
     &          STAT = IOS )

       IF ( IOS .NE. 0 ) THEN
          MSG = 'Error allocating RKI, RXRAT, RTOL, YC, YC0, YCP, FORWARD_CONV, '
     &       // 'REVERSE_CONV, PROD, LOSS, or PNEG'
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
       END IF

       ALLOCATE( ATMPRES( MAX_CELLS_EBI ),
     &           H2O    ( MAX_CELLS_EBI ),
     &           TEMP   ( MAX_CELLS_EBI ),
     &           DENSITY( MAX_CELLS_EBI ),
     &           HET    ( MAX_CELLS_EBI, NHETERO ),
     &           RJIN   ( MAX_CELLS_EBI, NPHOTAB ),
     &           LAND   ( MAX_CELLS_EBI ) ,
     &           STAT = IOS )

       IF ( IOS .NE. 0 ) THEN
          MSG = 'Error allocating ATMPRES, H2O, TEMP, HET, RJIN, LAND '
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
       END IF

       IF( NSPECIAL .GT. 0 )THEN
          ALLOCATE( SYC( MAX_CELLS_EBI, NUMB_MECH_SPC ), STAT = IOS )
          IF ( IOS .NE. 0 ) THEN
               MSG = 'Error allocating SYC'
               CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
          END IF
          ALLOCATE( IOLD2NEW( NUMB_MECH_SPC, 1 ), STAT = IOS )
          IF ( IOS .NE. 0 ) THEN
               MSG = 'Error allocating IOLD2NEW'
               CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
          END IF
          DO N = 1, NUMB_MECH_SPC
             IOLD2NEW( N, 1 ) = N
          END DO
       END IF

       IF( .NOT. MAP_CHEMISTRY_SPECIES() )THEN
          MSG = 'Detected above error(s) when mapping Chemistry species from CGRID species'
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT2 )
       END IF

       DO N = 1, NUMB_MECH_SPC
          FORWARD_CONV( N ) = 1.0E-3 * MWAIR / SPECIES_MOLWT( N )
          REVERSE_CONV( N ) = 1.0E+3 / MWAIR * SPECIES_MOLWT( N )
       END DO

! initialize all reaction rates to zero so unused array elements are defined

       RXRAT = 0.0D0

! initialize all production and loss rates to zero so unused array elements are defined

       PROD  = 0.0D0
       LOSS  = 0.0D0

       NING1 = 4
       NING2 = 4

       ALLOCATE( YCCELL( MODEL_SPECIES), STAT = IOS )  ! array for degradation routines
       IF ( IOS .NE. 0 ) THEN
          MSG = 'Error allocating YCCELL '
          CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
       END IF


c..Allocate and define ebi species

      N_EBISP  = 134
      ALLOCATE( EBISP( N_EBISP ), STAT = IOS ) 
      IF ( IOS .NE. 0 ) THEN
         MSG = 'Error allocating EBISP' 
         CALL M3EXIT( PNAME, 0, 0, MSG, XSTAT1 )
      END IF

      EBISP(   1 ) = H2O2
      EBISP(   2 ) = HNO3
      EBISP(   3 ) = SO2
      EBISP(   4 ) = SULF
      EBISP(   5 ) = SULRXN
      EBISP(   6 ) = MEO2
      EBISP(   7 ) = RO2
      EBISP(   8 ) = PACD
      EBISP(   9 ) = AACD
      EBISP(  10 ) = CXO3
      EBISP(  11 ) = ALD2
      EBISP(  12 ) = XO2H
      EBISP(  13 ) = PANX
      EBISP(  14 ) = FORM
      EBISP(  15 ) = MEPX
      EBISP(  16 ) = MEOH
      EBISP(  17 ) = ROOH
      EBISP(  18 ) = XO2
      EBISP(  19 ) = XO2N
      EBISP(  20 ) = NTR1
      EBISP(  21 ) = NTR2
      EBISP(  22 ) = FACD
      EBISP(  23 ) = CO
      EBISP(  24 ) = HCO3
      EBISP(  25 ) = ALDX
      EBISP(  26 ) = GLYD
      EBISP(  27 ) = GLY
      EBISP(  28 ) = MGLY
      EBISP(  29 ) = ETHA
      EBISP(  30 ) = ETOH
      EBISP(  31 ) = KET
      EBISP(  32 ) = PAR
      EBISP(  33 ) = ACET
      EBISP(  34 ) = PRPA
      EBISP(  35 ) = XPRP
      EBISP(  36 ) = XPAR
      EBISP(  37 ) = ROR
      EBISP(  38 ) = ETHY
      EBISP(  39 ) = ETH
      EBISP(  40 ) = OLE
      EBISP(  41 ) = IOLE
      EBISP(  42 ) = ISOP
      EBISP(  43 ) = ISO2
      EBISP(  44 ) = ISOPRXN
      EBISP(  45 ) = ISPD
      EBISP(  46 ) = INTR
      EBISP(  47 ) = ISPX
      EBISP(  48 ) = HPLD
      EBISP(  49 ) = OPO3
      EBISP(  50 ) = EPOX
      EBISP(  51 ) = EPX2
      EBISP(  52 ) = TERP
      EBISP(  53 ) = TRPRXN
      EBISP(  54 ) = TERPNRO2
      EBISP(  55 ) = APIN
      EBISP(  56 ) = BENZENE
      EBISP(  57 ) = CRES
      EBISP(  58 ) = BZO2
      EBISP(  59 ) = OPEN
      EBISP(  60 ) = BENZRO2
      EBISP(  61 ) = TOL
      EBISP(  62 ) = TO2
      EBISP(  63 ) = TOLRO2
      EBISP(  64 ) = XOPN
      EBISP(  65 ) = XYLMN
      EBISP(  66 ) = XLO2
      EBISP(  67 ) = XYLRO2
      EBISP(  68 ) = NAPH
      EBISP(  69 ) = PAHRO2
      EBISP(  70 ) = CRO
      EBISP(  71 ) = CAT1
      EBISP(  72 ) = CRON
      EBISP(  73 ) = OPAN
      EBISP(  74 ) = ECH4
      EBISP(  75 ) = CL2
      EBISP(  76 ) = CL
      EBISP(  77 ) = HOCL
      EBISP(  78 ) = CLO
      EBISP(  79 ) = FMCL
      EBISP(  80 ) = HCL
      EBISP(  81 ) = CLNO2
      EBISP(  82 ) = CLNO3
      EBISP(  83 ) = SVAVB2
      EBISP(  84 ) = SVAVB3
      EBISP(  85 ) = SVAVB4
      EBISP(  86 ) = SVAVB1
      EBISP(  87 ) = SESQ
      EBISP(  88 ) = SESQRXN
      EBISP(  89 ) = SOAALK
      EBISP(  90 ) = H2NO3PIJ
      EBISP(  91 ) = H2NO3PK
      EBISP(  92 ) = ACLI
      EBISP(  93 ) = ACLJ
      EBISP(  94 ) = ACLK
      EBISP(  95 ) = IEPOXP
      EBISP(  96 ) = ASO4J
      EBISP(  97 ) = AISO3J
      EBISP(  98 ) = AGLYJ
      EBISP(  99 ) = MTNO3
      EBISP( 100 ) = AMTNO3J
      EBISP( 101 ) = AMTHYDJ
      EBISP( 102 ) = AAVB2J
      EBISP( 103 ) = AOLGAJ
      EBISP( 104 ) = AAVB3J
      EBISP( 105 ) = AAVB4J
      EBISP( 106 ) = AISO1J
      EBISP( 107 ) = AOLGBJ
      EBISP( 108 ) = AISO2J
      EBISP( 109 ) = ASQTJ
      EBISP( 110 ) = APOCI
      EBISP( 111 ) = APNCOMI
      EBISP( 112 ) = APOCJ
      EBISP( 113 ) = APNCOMJ
      EBISP( 114 ) = PCVOC
      EBISP( 115 ) = PCSOARXN
      EBISP( 116 ) = VLVPO1
      EBISP( 117 ) = VSVPO1
      EBISP( 118 ) = VSVPO2
      EBISP( 119 ) = VSVPO3
      EBISP( 120 ) = VIVPO1
      EBISP( 121 ) = VLVOO1
      EBISP( 122 ) = VLVOO2
      EBISP( 123 ) = VSVOO2
      EBISP( 124 ) = VSVOO3
      EBISP( 125 ) = VSVOO1
      EBISP( 126 ) = FORM_PRIMARY
      EBISP( 127 ) = ALD2_PRIMARY
      EBISP( 128 ) = BUTADIENE13
      EBISP( 129 ) = ACROLEIN
      EBISP( 130 ) = ACRO_PRIMARY
      EBISP( 131 ) = TOLU
      EBISP( 132 ) = HG
      EBISP( 133 ) = HGIIAER
      EBISP( 134 ) = HGIIGAS


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Set species tolerances
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      RTOL( NO2          ) = 5.0D-04
      RTOL( NO           ) = 5.0D-04
      RTOL( O            ) = 1.0D+00
      RTOL( O3           ) = 5.0D-04
      RTOL( NO3          ) = 5.0D-04
      RTOL( O1D          ) = 1.0D+00
      RTOL( OH           ) = 5.0D-04
      RTOL( HO2          ) = 5.0D-04
      RTOL( H2O2         ) = 5.0D-04
      RTOL( N2O5         ) = 5.0D-04
      RTOL( HNO3         ) = 5.0D-04
      RTOL( HONO         ) = 5.0D-04
      RTOL( PNA          ) = 5.0D-04
      RTOL( SO2          ) = 5.0D-04
      RTOL( SULF         ) = 1.0D+00
      RTOL( SULRXN       ) = 1.0D+00
      RTOL( C2O3         ) = 5.0D-04
      RTOL( MEO2         ) = 5.0D-04
      RTOL( RO2          ) = 5.0D-04
      RTOL( PAN          ) = 5.0D-04
      RTOL( PACD         ) = 5.0D-04
      RTOL( AACD         ) = 5.0D-04
      RTOL( CXO3         ) = 5.0D-04
      RTOL( ALD2         ) = 5.0D-04
      RTOL( XO2H         ) = 5.0D-04
      RTOL( PANX         ) = 5.0D-04
      RTOL( FORM         ) = 5.0D-04
      RTOL( MEPX         ) = 5.0D-04
      RTOL( MEOH         ) = 5.0D-04
      RTOL( ROOH         ) = 5.0D-04
      RTOL( XO2          ) = 5.0D-04
      RTOL( XO2N         ) = 5.0D-04
      RTOL( NTR1         ) = 5.0D-04
      RTOL( NTR2         ) = 5.0D-04
      RTOL( FACD         ) = 5.0D-04
      RTOL( CO           ) = 5.0D-04
      RTOL( HCO3         ) = 1.0D+00
      RTOL( ALDX         ) = 5.0D-04
      RTOL( GLYD         ) = 5.0D-04
      RTOL( GLY          ) = 5.0D-04
      RTOL( MGLY         ) = 5.0D-04
      RTOL( ETHA         ) = 5.0D-04
      RTOL( ETOH         ) = 5.0D-04
      RTOL( KET          ) = 5.0D-04
      RTOL( PAR          ) = 5.0D-04
      RTOL( ACET         ) = 5.0D-04
      RTOL( PRPA         ) = 5.0D-04
      RTOL( XPRP         ) = 5.0D-04
      RTOL( XPAR         ) = 5.0D-04
      RTOL( ROR          ) = 5.0D-04
      RTOL( ETHY         ) = 5.0D-04
      RTOL( ETH          ) = 5.0D-04
      RTOL( OLE          ) = 5.0D-04
      RTOL( IOLE         ) = 5.0D-04
      RTOL( ISOP         ) = 5.0D-04
      RTOL( ISO2         ) = 5.0D-04
      RTOL( ISOPRXN      ) = 1.0D+00
      RTOL( ISPD         ) = 5.0D-04
      RTOL( INTR         ) = 5.0D-04
      RTOL( ISPX         ) = 5.0D-04
      RTOL( HPLD         ) = 5.0D-04
      RTOL( OPO3         ) = 5.0D-04
      RTOL( EPOX         ) = 5.0D-04
      RTOL( EPX2         ) = 5.0D-04
      RTOL( TERP         ) = 5.0D-04
      RTOL( TRPRXN       ) = 1.0D+00
      RTOL( TERPNRO2     ) = 5.0D-04
      RTOL( APIN         ) = 5.0D-04
      RTOL( BENZENE      ) = 5.0D-04
      RTOL( CRES         ) = 5.0D-04
      RTOL( BZO2         ) = 5.0D-04
      RTOL( OPEN         ) = 5.0D-04
      RTOL( BENZRO2      ) = 5.0D-04
      RTOL( TOL          ) = 5.0D-04
      RTOL( TO2          ) = 5.0D-04
      RTOL( TOLRO2       ) = 5.0D-04
      RTOL( XOPN         ) = 5.0D-04
      RTOL( XYLMN        ) = 5.0D-04
      RTOL( XLO2         ) = 5.0D-04
      RTOL( XYLRO2       ) = 5.0D-04
      RTOL( NAPH         ) = 5.0D-04
      RTOL( PAHRO2       ) = 1.0D+00
      RTOL( CRO          ) = 5.0D-04
      RTOL( CAT1         ) = 5.0D-04
      RTOL( CRON         ) = 5.0D-04
      RTOL( OPAN         ) = 5.0D-04
      RTOL( ECH4         ) = 5.0D-04
      RTOL( CL2          ) = 5.0D-04
      RTOL( CL           ) = 5.0D-04
      RTOL( HOCL         ) = 5.0D-04
      RTOL( CLO          ) = 5.0D-04
      RTOL( FMCL         ) = 5.0D-04
      RTOL( HCL          ) = 5.0D-04
      RTOL( CLNO2        ) = 5.0D-04
      RTOL( CLNO3        ) = 5.0D-04
      RTOL( SVAVB2       ) = 5.0D-04
      RTOL( SVAVB3       ) = 5.0D-04
      RTOL( SVAVB4       ) = 5.0D-04
      RTOL( SVAVB1       ) = 5.0D-04
      RTOL( SESQ         ) = 5.0D-04
      RTOL( SESQRXN      ) = 1.0D+00
      RTOL( SOAALK       ) = 5.0D-04
      RTOL( H2NO3PIJ     ) = 5.0D-04
      RTOL( H2NO3PK      ) = 5.0D-04
      RTOL( ACLI         ) = 5.0D-04
      RTOL( ACLJ         ) = 5.0D-04
      RTOL( ACLK         ) = 5.0D-04
      RTOL( IEPOXP       ) = 5.0D-04
      RTOL( ASO4J        ) = 5.0D-04
      RTOL( AISO3J       ) = 5.0D-04
      RTOL( AGLYJ        ) = 5.0D-04
      RTOL( MTNO3        ) = 5.0D-04
      RTOL( AMTNO3J      ) = 5.0D-04
      RTOL( AMTHYDJ      ) = 5.0D-04
      RTOL( AAVB2J       ) = 5.0D-04
      RTOL( AOLGAJ       ) = 5.0D-04
      RTOL( AAVB3J       ) = 5.0D-04
      RTOL( AAVB4J       ) = 5.0D-04
      RTOL( AISO1J       ) = 5.0D-04
      RTOL( AOLGBJ       ) = 5.0D-04
      RTOL( AISO2J       ) = 5.0D-04
      RTOL( ASQTJ        ) = 5.0D-04
      RTOL( APOCI        ) = 5.0D-04
      RTOL( APNCOMI      ) = 5.0D-04
      RTOL( APOCJ        ) = 5.0D-04
      RTOL( APNCOMJ      ) = 5.0D-04
      RTOL( PCVOC        ) = 5.0D-04
      RTOL( PCSOARXN     ) = 5.0D-04
      RTOL( VLVPO1       ) = 5.0D-04
      RTOL( VSVPO1       ) = 5.0D-04
      RTOL( VSVPO2       ) = 5.0D-04
      RTOL( VSVPO3       ) = 5.0D-04
      RTOL( VIVPO1       ) = 5.0D-04
      RTOL( VLVOO1       ) = 5.0D-04
      RTOL( VLVOO2       ) = 5.0D-04
      RTOL( VSVOO2       ) = 5.0D-04
      RTOL( VSVOO3       ) = 5.0D-04
      RTOL( VSVOO1       ) = 5.0D-04
      RTOL( FORM_PRIMARY ) = 5.0D-04
      RTOL( ALD2_PRIMARY ) = 5.0D-04
      RTOL( BUTADIENE13  ) = 5.0D-04
      RTOL( ACROLEIN     ) = 5.0D-04
      RTOL( ACRO_PRIMARY ) = 5.0D-04
      RTOL( TOLU         ) = 5.0D-04
      RTOL( HG           ) = 5.0D-04
      RTOL( HGIIAER      ) = 5.0D-04
      RTOL( HGIIGAS      ) = 5.0D-04


      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/arc/CCTM/src/depv/m3dry/LSM_MOD.F,v 1.5 2012/01/19 14:23:58 yoj Exp $

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module LSM_Mod
       
C------------------------------------------------------------------------------
C Revision History: 
C      June 16 11  Created by J. Bash
C      April 19 12  J. Bash    Updated the LU_FAC data arrays to be a function
C                              of the annual total N deposition following 
C                              Massad et al 2010 doi:10.5194/acp-10-10359-2010
C                              The annual 2002 deposition filed from a previous bi-
C                              directional model run using values ~ 100 was used. 
C                              The model is not very sensitive to this paramater
C                              and using different annual deposition fileds would
C                              result in small changes. 
C      Sept 12 12  D. Schwede  Added NLCD40 land use classification.
C                              Also some changes made to values in tables for NLCD50.
C                              Maintain compatability with previous versions of MCIP and detect NLCD-MODIS
C                              as the same as NLCD50
C      Nov  5  12  D. Schwede  Modified albedo for NLCD pasture and grass categories so that they are more
C                              consistent with the MODIS and USGS values
C      Apr  4  13 J. Bash      Added general water, forest, shrub, grass, snow/ice, 
C                              agricultural land use classification in a land use type 
C                              to simplify how bidirecitonal NH3 code handles different 
C                              land use data sets. 
C      Aug  22 14 J. Bash      Moved all the data to defined data types for easier updates and data access. 
C      June 2018  j. pleim     Removed all LSM specific data
C      Feb. 2019  D. Wong      Implemented centralized I/O approach
C      25 Jul 19 D.Wong        Based on logical variable WRF_V4P defined in RUNTIME_VARS to handle
C                              various number of soil type from different WRF version
C------------------------------------------------------------------------------
       
      Implicit None

      INTEGER, PARAMETER :: N_SOIL_TYPE_WRFV4P = 16
      INTEGER, PARAMETER :: N_SOIL_TYPE_WRFV3  = 11
      INTEGER :: N_SOIL_TYPE
      
      REAL, ALLOCATABLE  :: wwlt (:)
      REAL, ALLOCATABLE  :: wsat (:)
      REAL, ALLOCATABLE  :: bslp (:)
      REAL, ALLOCATABLE  :: wres (:)
      REAL, ALLOCATABLE  :: wfc  (:)
      REAL, ALLOCATABLE  :: rhob (:)

      REAL,   SAVE, ALLOCATABLE  :: LUF_FAC   ( : )
      REAL,   SAVE, ALLOCATABLE  :: HGLU_FAC  ( : )
      INTEGER, SAVE              :: n_lufrac
      CHARACTER( 80 ), SAVE      :: LAND_SCHEME
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: cat_lu( : )
      CHARACTER( 16 ), SAVE, ALLOCATABLE :: name_lu( : )


      INTEGER, PRIVATE, PARAMETER :: n_modis   = 20
      INTEGER, PRIVATE, PARAMETER :: n_nlcd50  = 50
      INTEGER, PRIVATE, PARAMETER :: n_nlcd40  = 40
      INTEGER, PRIVATE, PARAMETER :: n_usgs    = 24
      INTEGER, PRIVATE            :: ALLOCSTAT
      
      TYPE lu_type
         CHARACTER( 16 ) :: name
         CHARACTER( 16 ) :: lu_cat
         REAL            :: LUF_FAC ! NH3 bidi stomatal gamma
         REAL            :: HGLU_FAC ! Hg bidi soil conc
      END TYPE lu_type


C-------------------------------------------------------------------------------
C Soil Characteristics by Type for WRFV38
C
C   #  SOIL TYPE  WSAT  WFC  WWLT  BSLP  CGSAT   JP   AS   C2R  C1SAT  WRES
C   _  _________  ____  ___  ____  ____  _____   ___  ___  ___  _____  ____
C   1  SAND       .395 .135  .068  4.05  3.222    4  .387  3.9  .082   .020
C   2  LOAMY SAND .410 .150  .075  4.38  3.057    4  .404  3.7  .098   .035
C   3  SANDY LOAM .435 .195  .114  4.90  3.560    4  .219  1.8  .132   .041
C   4  SILT LOAM  .485 .255  .179  5.30  4.418    6  .105  0.8  .153   .015
C   5  LOAM       .451 .240  .155  5.39  4.111    6  .148  0.8  .191   .027
C   6  SND CLY LM .420 .255  .175  7.12  3.670    6  .135  0.8  .213   .068
C   7  SLT CLY LM .477 .322  .218  7.75  3.593    8  .127  0.4  .385   .040
C   8  CLAY LOAM  .476 .325  .250  8.52  3.995   10  .084  0.6  .227   .075
C   9  SANDY CLAY .426 .310  .219 10.40  3.058    8  .139  0.3  .421   .109
C  10  SILTY CLAY .482 .370  .283 10.40  3.729   10  .075  0.3  .375   .056
C  11  CLAY       .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C
C-------------------------------------------------------------------------------
!-- WSAT is saturated soil moisture (M^3/M^3) (JN90)
      REAL, PARAMETER :: WSAT_WRFV3(N_SOIL_TYPE_WRFV3) =  
     &      (/ 0.395, 0.410, 0.435, 0.485, 0.451, 0.420, 0.477,
     &         0.476, 0.426, 0.482, 0.482 /)
!-- WFC is soil field capacity (Rawls et al 1982)     
      REAL, PARAMETER :: WFC_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/ 0.135, 0.150, 0.195, 0.255, 0.240, 0.255, 0.322,
     &         0.325, 0.310, 0.370, 0.367 /)
!-- WWLT is wilting point (M^3/M^3) (JN90)
      REAL, PARAMETER :: WWLT_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/ 0.068, 0.075, 0.114, 0.179, 0.155, 0.175, 0.218,
     &         0.250, 0.219, 0.283, 0.286 /)
!-- B is slop of the retention curve (NP89)
      REAL, PARAMETER :: BSLP_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/  4.05,  4.38,  4.90,  5.30,  5.39,  7.12,  7.75,
     &          8.52, 10.40, 10.40, 11.40 /)
!-- WRES is residual soil moisture (Rawls et al 1982)
      REAL, PARAMETER :: WRES_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/  0.020, 0.035, 0.041, 0.015, 0.027, 0.068, 0.040,
     &          0.075, 0.109, 0.056, 0.090 /)
! -- RHOB is the soil bulk dnesity following Lyons et al 1997   
      REAL, PARAMETER :: RHOB_WRFV3(N_SOIL_TYPE_WRFV3) =
     &      (/ 1.59e6, 1.55e6, 1.53e6, 1.53e6, 1.55e6, 1.62e6, 1.67e6,
     &         1.66e6, 1.83e6, 1.78e6, 1.83e6 /)

C-------------------------------------------------------------------------------
C Soil Characteristics by Type for WRF4+
C
C   #  SOIL TYPE  WSAT  WFC  WWLT  BSLP  CGSAT   JP   AS   C2R  C1SAT  WRES
C   _  _________  ____  ___  ____  ____  _____   ___  ___  ___  _____  ____
C   1  SAND       .395 .135  .068  4.05  3.222    4  .387  3.9  .082   .020
C   2  LOAMY SAND .410 .150  .075  4.38  3.057    4  .404  3.7  .098   .035
C   3  SANDY LOAM .435 .195  .114  4.90  3.560    4  .219  1.8  .132   .041
C   4  SILT LOAM  .485 .255  .179  5.30  4.418    6  .105  0.8  .153   .015
C   5  SILT       .480 .260  .150  5.30  4.418    6  .105  0.8  .153   .020
C   6  LOAM       .451 .240  .155  5.39  4.111    6  .148  0.8  .191   .027
C   7  SND CLY LM .420 .255  .175  7.12  3.670    6  .135  0.8  .213   .068
C   8  SLT CLY LM .477 .322  .218  7.75  3.593    8  .127  0.4  .385   .040
C   9  CLAY LOAM  .476 .325  .250  8.52  3.995   10  .084  0.6  .227   .075
C  10  SANDY CLAY .426 .310  .219 10.40  3.058    8  .139  0.3  .421   .109
C  11  SILTY CLAY .482 .370  .283 10.40  3.729   10  .075  0.3  .375   .056
C  12  CLAY       .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C  13  ORGANICMAT .451 .240  .155  5.39  4.111    6  .148  0.8  .191   .027
C  14  WATER      .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C  15  BEDROCK    .482 .367  .286 11.40  3.600   12  .083  0.3  .342   .090
C  16  OTHER      .420 .255  .175  7.12  3.670    6  .135  0.8  .213   .068
C-------------------------------------------------------------------------------

!-- WSAT is saturated soil moisture (M^3/M^3) (JN90)
      REAL, PARAMETER :: WSAT_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  0.395, 0.410, 0.435, 0.485, 0.480, 0.451, 0.420, 0.477,
     &          0.476, 0.426, 0.482, 0.482, 0.451, 0.482, 0.482, 0.420 /)
!-- WFC is soil field capacity (Rawls et al 1982)     
      REAL, PARAMETER :: WFC_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  0.135, 0.150, 0.195, 0.255, 0.260, 0.240, 0.255, 0.322,
     &          0.325, 0.310, 0.370, 0.367, 0.240, 0.367, 0.367, 0.255 /)
!-- WWLT is wilting point (M^3/M^3) (JN90)
      REAL, PARAMETER :: WWLT_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  0.068, 0.075, 0.114, 0.179, 0.150, 0.155, 0.175, 0.218,
     &          0.250, 0.219, 0.283, 0.286, 0.155, 0.286, 0.286, 0.175 /)
!-- B is slop of the retention curve (NP89)
      REAL, PARAMETER :: BSLP_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  4.05,  4.38,  4.90,  5.30,  5.30,  5.39,  7.12,  7.75,
     &          8.52, 10.40, 10.40, 11.40,  5.39, 11.40, 11.40,  7.12 /)
!-- WRES is residual soil moisture (Rawls et al 1982)
      REAL, PARAMETER :: WRES_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  0.020, 0.035, 0.041, 0.015, 0.020, 0.027, 0.068, 0.040,
     &          0.075, 0.109, 0.056, 0.090, 0.027, 0.090, 0.090, 0.068 /)
! -- RHOB is the soil bulk dnesity following Lyons et al 1997   
      REAL, PARAMETER :: RHOB_WRFV4P(N_SOIL_TYPE_WRFV4P) =  
     &      (/  1.59e6, 1.55e6, 1.53e6, 1.53e6, 1.53e6, 1.55e6, 1.62e6, 1.67e6,
     &          1.66e6, 1.83e6, 1.78e6, 1.83e6, 1.62e6, 1.83e6, 1.83e6, 1.67e6 /)


!*****************************************************************************
!*****************************************************************************
! MODIS-ONLY (1XX)/MODIS (2XX) LU characterization ... reclassified by NCEP
!-------------------------------------------------------------------------------
      
      TYPE( lu_type ),PRIVATE, PARAMETER :: MODIS( n_modis ) =  (/
!               -Name---    -LU cat - LUF_FAC HGLU_FAC     Cat Desc.
     & lu_type('NCEP_1 ', 'EVEFOR ', 246.0,  40.0),  ! 1 Evergreen Needleleaf Forest
     & lu_type('NCEP_2 ', 'EVEFOR ', 247.0, 130.0),  ! 2 Evergreen Broadleaf Forest
     & lu_type('NCEP_3 ', 'DECFOR ', 267.0,  81.0),  ! 3 Deciduous Needleleaf Forest
     & lu_type('NCEP_4 ', 'DECFOR ', 268.0,  81.0),  ! 4 Deciduous Broadleaf Forest  
     & lu_type('NCEP_5 ', 'MIXFOR ', 252.0, 139.0),  ! 5 Mixed Forest
     & lu_type('NCEP_6 ', 'SHRUB  ', 246.0, 125.0),  ! 6 Closed Shrublands
     & lu_type('NCEP_7 ', 'SHRUB  ', 246.0, 125.0),  ! 7 Open Shrublands
     & lu_type('NCEP_8 ', 'MIXFOR ', 246.0, 125.0),  ! 8 Woody Savanna
     & lu_type('NCEP_9 ', 'MIXFOR ', 246.0, 125.0),  ! 9 Savanna
     & lu_type('NCEP_10', 'GRASS  ', 247.0,  20.0),  ! 10 Grasslands
     & lu_type('NCEP_11', 'WETLAND', 260.0, 125.0),  ! 11 Perminent Wetlands
     & lu_type('NCEP_12', 'AG     ', 340.0,  81.0),  ! 12 Croplands  
     & lu_type('NCEP_13', 'BUILT  ', 338.0, 190.0),  ! 13 Urban and Built-up    
     & lu_type('NCEP_14', 'AGMOS  ', 298.0,  50.0),  ! 14 Crop/Natural Mosaic
     & lu_type('NCEP_15', 'SNOWICE',   0.0,   0.0),  ! 15 Snow and Ice   
     & lu_type('NCEP_16', 'BARREN ', 246.0, 125.0),  ! 16 Sparsely Vegetated
     & lu_type('NCEP_17', 'WATER  ',   0.0,   0.0),  ! 17 IGBP water
     & lu_type('NCEP_18', 'EVEFOR ', 246.0,  62.0),  ! 18 Wooded Tundra   
     & lu_type('NCEP_19', 'SHRUB  ', 246.0,  62.0),  ! 19 Mixed Tundra
     & lu_type('NCEP_20', 'GRASS  ', 246.0,  18.0)/) ! 20 Barren Tundra

!****************************************************************************************
!****************************************************************************************
! 50 CLASS NLCD (US only, cats 1-30)/MODIS (Outside US, cats 31-50) LU characterization
!---------------------------------------------------------------------------------------

      TYPE( lu_type ),PRIVATE, PARAMETER :: NLCD50( n_nlcd50 ) =  (/
!               -Name---    -LU cat - LUF_FAC HGLU_FAC     Cat Desc.
     & lu_type('NLCD_11  ', 'WATER  ',   0.0,   0.0),  ! 1 Open water
     & lu_type('NLCD_12  ', 'SNOWICE',   0.0,   0.0),  ! 2 Perennial Ice/snow
     & lu_type('NLCD_21  ', 'BUILT  ', 312.0, 130.0),  ! 3 Developed, Open space
     & lu_type('NLCD_22  ', 'BUILT  ', 305.0, 150.0),  ! 4 Developed, Low Intensity
     & lu_type('NLCD_23  ', 'BUILT  ', 331.0, 170.0),  ! 5 Developed, Medium Intensity
     & lu_type('NLCD_24  ', 'BUILT  ', 402.0, 190.0),  ! 6 Developed, High Intensity
     & lu_type('NLCD_31  ', 'BARREN ', 246.0, 125.0),  ! 7 Barren land
     & lu_type('NLCD_32  ', 'BARREN ', 248.0,   0.0),  ! 8 Unconsolidated Shore
     & lu_type('NLCD_41  ', 'DECFOR ', 274.0,  81.0),  ! 9 Deciduous Forest
     & lu_type('NLCD_42  ', 'EVEFOR ', 246.0,  81.0),  ! 10 Evergreen Forest
     & lu_type('NLCD_43  ', 'MIXFOR ', 254.0, 139.0),  ! 11 Mixed Forest
     & lu_type('NLCD_51  ', 'SHRUB  ', 246.0,  73.0),  ! 12 Dwarf Scrub
     & lu_type('NLCD_52  ', 'SHRUB  ', 246.0, 125.0),  ! 13 Shrub/Scrub
     & lu_type('NLCD_71  ', 'GRASS  ', 247.0,  20.0),  ! 14 Grassland/Herbaceous
     & lu_type('NLCD_72  ', 'GRASS  ', 246.0, 125.0),  ! 15 Sedge/Herbaceous
     & lu_type('NLCD_73  ', 'BARREN ',   0.0,  18.0),  ! 16 Lichens
     & lu_type('NLCD_74  ', 'BARREN ',   0.0,  18.0),  ! 17 Moss
     & lu_type('NLCD_75  ', 'BARREN ', 246.0,  62.0),  ! 18 Tundra
     & lu_type('NLCD_81  ', 'AG     ', 344.0,  50.0),  ! 19 Pasture/Hay
     & lu_type('NLCD_82  ', 'AG     ', 340.0,  80.0),  ! 20 Cultivated Crops   
     & lu_type('NLCD_90  ', 'WETLAND', 271.0, 125.0),  ! 21 Woody Wetland
     & lu_type('NLCD_91  ', 'WETLAND', 267.0, 125.0),  ! 22 Palustrine Forested Wetland   
     & lu_type('NLCD_92  ', 'WETLAND', 254.0, 125.0),  ! 23 Palustrine Shrub Wetland   
     & lu_type('NLCD_93  ', 'WETLAND', 267.0, 125.0),  ! 24 Estuarine Forested Wetland   
     & lu_type('NLCD_94  ', 'WETLAND', 267.0, 125.0),  ! 25 Estuarine Shrub Wetland   
     & lu_type('NLCD_95  ', 'WETLAND', 248.0, 125.0),  ! 26 Emergent Herbaceous Wetland   
     & lu_type('NLCD_96  ', 'WETLAND', 269.0, 125.0),  ! 27 Palustrine Emergent Wetland   
     & lu_type('NLCD_97  ', 'WETLAND', 262.0, 125.0),  ! 28 Estuarine Emergent Wetland   
     & lu_type('NLCD_98  ', 'WETLAND', 277.0, 125.0),  ! 29 Palustrine Aquatic Bed
     & lu_type('NLCD_99  ', 'WETLAND', 247.0, 125.0),  ! 30 Estuarine Aquatic Bed   
     & lu_type('MODIS_0  ', 'WATER  ',   0.0,   0.0),  ! 31 Open water (mapped to 1)
     & lu_type('MODIS_1  ', 'EVEFOR ', 246.0,  40.0),  ! 32 Evergreen Needleleaf Forest
     & lu_type('MODIS_2  ', 'EVEFOR ', 247.0, 130.0),  ! 33 Evergreen Broadleaf Forest
     & lu_type('MODIS_3  ', 'DECFOR ', 267.0,  81.0),  ! 34 Deciduous Needleleaf Forest
     & lu_type('MODIS_4  ', 'DECFOR ', 268.0,  81.0),  ! 35 Deciduous Broadleaf Forest  
     & lu_type('MODIS_5  ', 'MIXFOR ', 252.0, 139.0),  ! 36 Mixed Forest
     & lu_type('MODIS_6  ', 'SHRUB  ', 246.0, 125.0),  ! 37 Closed Shrublands
     & lu_type('MODIS_7  ', 'SHRUB  ', 246.0, 125.0),  ! 38 Open Shrublands
     & lu_type('MODIS_8  ', 'MIXFOR ', 246.0, 125.0),  ! 39 Woody Savanna
     & lu_type('MODIS_9  ', 'MIXFOR ', 246.0, 125.0),  ! 40 Savanna
     & lu_type('MODIS_10 ', 'GRASS  ', 247.0,  20.0),  ! 41 Grasslands
     & lu_type('MODIS_11 ', 'WETLAND', 260.0, 125.0),  ! 42 Perminent Wetlands
     & lu_type('MODIS_12 ', 'AG     ', 340.0,  81.0),  ! 43 Croplands  
     & lu_type('MODIS_13 ', 'BUILT  ', 338.0, 190.0),  ! 44 Urban and Built-up    
     & lu_type('MODIS_14 ', 'AGMOS  ', 298.0,  50.0),  ! 45 Crop/Natural Mosaic
     & lu_type('MODIS_15 ', 'SNOWICE',   0.0,   0.0),  ! 46 Snow and Ice   
     & lu_type('MODIS_16 ', 'BARREN ', 246.0, 125.0),  ! 47 Sparsely Vegetated
     & lu_type('MODIS_0  ', 'WATER  ',   0.0,   0.0),  ! 48 IGBP water
     & lu_type('MODIS_255', 'SNOWICE',   0.0,   0.0),  ! 49 unclassified   
     & lu_type('MODIS_255', 'WATER  ',   0.0,   0.0)/) ! 50 fill (normally ocean water)                                               
                                               
!****************************************************************************************
!****************************************************************************************
! 40 CLASS MODIS (Outside US, cats 1-20)/NLCD (US only, cats 21-40) LU characterization
!-------------------------------------------------------------------------------

       TYPE( lu_type ),PRIVATE, PARAMETER :: NLCD40( n_nlcd40 ) =  (/
!               -Name---    -LU cat - LUF_FAC HGLU_FAC     Cat Desc.
     & lu_type('MODIS_1  ', 'EVEFOR ', 246.0,  40.0),  ! 1 Evergreen Needleleaf Forest
     & lu_type('MODIS_2  ', 'EVEFOR ', 247.0, 130.0),  ! 2 Evergreen Broadleaf Forest
     & lu_type('MODIS_3  ', 'DECFOR ', 267.0,  81.0),  ! 3 Deciduous Needleleaf Forest
     & lu_type('MODIS_4  ', 'DECFOR ', 268.0,  81.0),  ! 4 Deciduous Broadleaf Forest  
     & lu_type('MODIS_5  ', 'MIXFOR ', 252.0, 139.0),  ! 5 Mixed Forest
     & lu_type('MODIS_6  ', 'SHRUB  ', 246.0, 125.0),  ! 6 Closed Shrublands
     & lu_type('MODIS_7  ', 'SHRUB  ', 246.0, 125.0),  ! 7 Open Shrublands
     & lu_type('MODIS_8  ', 'MIXFOR ', 246.0, 125.0),  ! 8 Woody Savanna
     & lu_type('MODIS_9  ', 'MIXFOR ', 246.0, 125.0),  ! 9 Savanna
     & lu_type('MODIS_10 ', 'GRASS  ', 247.0,  20.0),  ! 10 Grasslands
     & lu_type('MODIS_11 ', 'WETLAND', 260.0, 125.0),  ! 11 Perminent Wetlands
     & lu_type('MODIS_12 ', 'AG     ', 340.0,  81.0),  ! 12 Croplands  
     & lu_type('MODIS_13 ', 'BUILT  ', 338.0, 190.0),  ! 13 Urban and Built-up    
     & lu_type('MODIS_14 ', 'AGMOS  ', 298.0,  50.0),  ! 14 Crop/Natural Mosaic
     & lu_type('MODIS_15 ', 'SNOWICE',   0.0,   0.0),  ! 15 Snow and Ice   
     & lu_type('MODIS_16 ', 'BARREN ', 246.0, 125.0),  ! 16 Sparsely Vegetated
     & lu_type('MODIS_0  ', 'WATER  ',   0.0,   0.0),  ! 17 IGBP water
     & lu_type('MODIS_255', 'WATER  ',   0.0,   0.0),  ! 18 unclassified   
     & lu_type('MODIS_255', 'WATER  ',   0.0,   0.0),  ! 19 fill (normally ocean water)
     & lu_type('MODIS_255', 'WATER  ',   0.0,   0.0),  ! 20 unclassified   
     & lu_type('NLCD_11  ', 'WATER  ',   0.0,   0.0),  ! 21 Open water
     & lu_type('NLCD_12  ', 'SNOWICE',   0.0,   0.0),  ! 22 Perennial Ice/snow
     & lu_type('NLCD_21  ', 'BUILT  ', 312.0, 130.0),  ! 23 Developed, Open space
     & lu_type('NLCD_22  ', 'BUILT  ', 305.0, 150.0),  ! 24 Developed, Low Intensity
     & lu_type('NLCD_23  ', 'BUILT  ', 331.0, 170.0),  ! 25 Developed, Medium Intensity
     & lu_type('NLCD_24  ', 'BUILT  ', 402.0, 190.0),  ! 26 Developed, High Intensity
     & lu_type('NLCD_31  ', 'BARREN ', 246.0, 125.0),  ! 27 Barren land
     & lu_type('NLCD_41  ', 'DECFOR ', 274.0,  81.0),  ! 28 Deciduous Forest
     & lu_type('NLCD_42  ', 'EVEFOR ', 246.0,  81.0),  ! 29 Evergreen Forest
     & lu_type('NLCD_43  ', 'MIXFOR ', 254.0, 139.0),  ! 30 Mixed Forest
     & lu_type('NLCD_51  ', 'SHRUB  ', 246.0,  73.0),  ! 31 Dwarf Scrub
     & lu_type('NLCD_52  ', 'SHRUB  ', 246.0, 125.0),  ! 32 Shrub/Scrub
     & lu_type('NLCD_71  ', 'GRASS  ', 247.0,  20.0),  ! 33 Grassland/Herbaceous
     & lu_type('NLCD_72  ', 'GRASS  ', 246.0, 125.0),  ! 34 Sedge/Herbaceous
     & lu_type('NLCD_73  ', 'BARREN ',   0.0,  18.0),  ! 35 Lichens
     & lu_type('NLCD_74  ', 'BARREN ',   0.0,  18.0),  ! 36 Moss
     & lu_type('NLCD_81  ', 'AG     ', 344.0,  50.0),  ! 37 Pasture/Hay
     & lu_type('NLCD_82  ', 'AG     ', 340.0,  80.0), ! 38 Cultivated Crops   
     & lu_type('NLCD_90  ', 'WETLAND', 271.0, 125.0),  ! 39 Woody Wetland 
     & lu_type('NLCD_95  ', 'WETLAND', 248.0, 125.0)/) ! 40 Emergent Herbaceous Wetland

!*****************************************************************************
!*****************************************************************************
!  USGS LU characterization  --  note below may not match those for the same category in a diff
!                                classification system.  This was done to maintain compatibility with MM5.               
!-----------------------------------------------------------------------------                   

      TYPE( lu_type ), PRIVATE, PARAMETER :: USGS24( n_usgs ) =  (/
!               ---Name---  -LU cat - LUF_FAC  HGLU_FAC    Cat Desc.
     & lu_type('USGS_Urban', 'BUILT   ', 338.0, 190.0),  ! 1 Urban or Built-up Land
     & lu_type('USGS_DrCrp', 'AG      ', 340.0,  80.0),  ! 2 Dryland Crop and Pasture
     & lu_type('USGS_IrCrp', 'AG      ', 340.0,  32.0),  ! 3 Irr. Cropland and Pasture
     & lu_type('USGS_MixCp', 'AG      ', 340.0,  56.0),  ! 4 Mixed Dry/Irr Crop and Past
     & lu_type('USGS_CrGrM', 'AGMOS   ', 298.0,  50.0),  ! 5 Grassland/Cropland Mosaic
     & lu_type('USGS_CrWdM', 'AGMOS   ', 298.0,  26.0),  ! 6 Woodland/Cropland Mosaic
     & lu_type('USGS_GrsLd', 'GRASS   ', 247.0,  20.0),  ! 7 Grassland
     & lu_type('USGS_ShrLd', 'SHRUB   ', 246.0, 125.0),  ! 8 Shrubland
     & lu_type('USGS_ShrGr', 'SHRUB   ', 246.0,  73.0),  ! 9 Mixed Shrubland/Grassland
     & lu_type('USGS_Savan', 'MIXFOR  ', 246.0,  51.0),  ! 10 Savanna
     & lu_type('USGS_DBFst', 'DECFOR  ', 268.0,  81.0),  ! 11 Broadleaf Deciduous Forest
     & lu_type('USGS_DNFst', 'DECFOR  ', 267.0,  81.0),  ! 12 Deciduous Coniferous Forest
     & lu_type('USGS_EBFst', 'EVEFOR  ', 247.0, 130.0),  ! 13 Evergreen Broadleaf Forest
     & lu_type('USGS_ENFst', 'EVEFOR  ', 246.0,  40.0),  ! 14 Evergreen Coniferous Forest
     & lu_type('USGS_MxFst', 'MIXFOR  ', 252.0, 139.0),  ! 15 Mixed forest
     & lu_type('USGS_Water', 'WATER   ',   0.0,   0.0),  ! 16 Water
     & lu_type('USGS_HWtld', 'WETLAND ', 248.0, 125.0),  ! 17 Herbaceous Wetland
     & lu_type('USGS_WWtld', 'WETLAND ', 260.0, 125.0),  ! 18 Forested Wetlands
     & lu_type('USGS_BarSp', 'BARREN  ', 246.0,  26.0),  ! 19 Barren or Sparsely Vegetated
     & lu_type('USGS_HrTun', 'GRASS   ', 246.0,  62.0),  ! 20 Herbaceous Tundra
     & lu_type('USGS_WdTun', 'SHRUB   ', 246.0,  62.0),  ! 21 Shrub and Brush Tundra
     & lu_type('USGS_MxTun', 'SHRUB   ', 246.0,  62.0),  ! 22 Mixed Tundra
     & lu_type('USGS_BGTun', 'BARREN  ', 246.0,  18.0),  ! 23 Bare Ground Tundra
     & lu_type('USGS_SnwIc', 'SNOWICE ',   0.0,   0.0)/) ! 24 Snowfields or Glaciers

      CONTAINS                                 
         SUBROUTINE INIT_LSM( JDate, JTime )   
                                               
         USE HGRD_DEFN                         
         USE UTILIO_DEFN                       
         USE RUNTIME_VARS, ONLY : WRF_V4P
#ifdef twoway                                  
         USE twoway_data_module, ONLY : num_land_cat
#endif                                         
                                               
         IMPLICIT NONE                         
                                               
         INCLUDE SUBST_FILES_ID  ! file name parameters         
                                               
         INTEGER, INTENT( In )  :: jdate       
         INTEGER, INTENT( In )  :: jtime  
         CHARACTER( 240 )       :: XMSG = ' '  
         CHARACTER(  16 ), SAVE :: PNAME = 'Init_LSM'
         INTEGER l
         INTEGER :: STAT

         LOGICAL, SAVE :: INITIALIZED = .FALSE.

         IF( INITIALIZED ) RETURN
         INITIALIZED = .TRUE.
                                             
         IF (WRF_V4P) THEN
            N_SOIL_TYPE = N_SOIL_TYPE_WRFV4P
         ELSE
            N_SOIL_TYPE = N_SOIL_TYPE_WRFV3
         END IF

         ALLOCATE (WSAT(N_SOIL_TYPE),
     &             WFC(N_SOIL_TYPE),
     &             WWLT(N_SOIL_TYPE),
     &             BSLP(N_SOIL_TYPE),
     &             WRES(N_SOIL_TYPE),
     &             RHOB(N_SOIL_TYPE),
     &             STAT=STAT)

         IF (WRF_V4P) THEN
            WSAT = WSAT_WRFV4P
            WFC  = WFC_WRFV4P
            WWLT = WWLT_WRFV4P
            BSLP = BSLP_WRFV4P
            WRES = WRES_WRFV4P
            RHOB = RHOB_WRFV4P
         ELSE
            WSAT = WSAT_WRFV3
            WFC  = WFC_WRFV3
            WWLT = WWLT_WRFV3
            BSLP = BSLP_WRFV3
            WRES = WRES_WRFV3
            RHOB = RHOB_WRFV3
         END IF

#ifdef twoway                                  
         IF ( NUM_LAND_CAT .EQ. 24 ) THEN      
            LAND_SCHEME = 'USGS24'             
         ELSE IF ( NUM_LAND_CAT .EQ. 20 ) THEN 
            LAND_SCHEME = 'MODIS'              
         ELSE IF ( NUM_LAND_CAT .EQ. 50 ) THEN 
            LAND_SCHEME = 'NLCD50'         
         ELSE IF ( NUM_LAND_CAT .EQ. 40 ) THEN 
            LAND_SCHEME = 'NLCD40'         
         END IF                                
#endif                                         
!       Write( *,* ) 'Land use scheme is ', TRIM(LAND_SCHEME) 
                                               
         SELECT CASE( LAND_SCHEME )            
            CASE( 'USGS24' )                   
               n_lufrac    = n_usgs
               If ( .Not. Allocated ( cat_lu ) ) Then
                  Allocate ( cat_lu   ( n_lufrac ),
     &                       name_lu  ( n_lufrac ),
     &                       LUF_FAC  ( n_lufrac ),
     &                       HGLU_FAC ( n_lufrac ), STAT = ALLOCSTAT )
                  IF ( ALLOCSTAT .NE. 0 ) THEN
                     XMSG = 'Failure allocating land use data'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               End If
               cat_lu   = USGS24%lu_cat
               name_lu  = USGS24%name
               LUF_FAC  = USGS24%LUF_FAC
               HGLU_FAC = USGS24%HGLU_FAC
            CASE( 'MODIS' )                    
               n_lufrac    = n_modis 
               If ( .Not. Allocated ( cat_lu ) ) Then
                  Allocate ( cat_lu   ( n_lufrac ),
     &                       name_lu  ( n_lufrac ),
     &                       LUF_FAC  ( n_lufrac ),
     &                       HGLU_FAC ( n_lufrac ), STAT = ALLOCSTAT )
                  IF ( ALLOCSTAT .NE. 0 ) THEN
                     XMSG = 'Failure allocating land use data'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               End If
               cat_lu   = MODIS%lu_cat
               name_lu  = MODIS%name
               LUF_FAC  = MODIS%LUF_FAC
               HGLU_FAC = MODIS%HGLU_FAC
            CASE( 'NLCD50' )               
               n_lufrac    = n_nlcd50  
               If ( .Not. Allocated ( cat_lu ) ) Then
                  Allocate ( cat_lu   ( n_lufrac ),
     &                       name_lu  ( n_lufrac ),
     &                       LUF_FAC  ( n_lufrac ),
     &                       HGLU_FAC ( n_lufrac ), STAT = ALLOCSTAT )
                  IF ( ALLOCSTAT .NE. 0 ) THEN
                     XMSG = 'Failure allocating land use data'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               End If
               cat_lu   = NLCD50%lu_cat
               name_lu  = NLCD50%name
               LUF_FAC  = NLCD50%LUF_FAC
               HGLU_FAC = NLCD50%HGLU_FAC
            CASE( 'NLCD40' )               
               n_lufrac    = n_nlcd40   
               If ( .Not. Allocated ( cat_lu ) ) Then
                  Allocate ( cat_lu   ( n_lufrac ),
     &                       name_lu  ( n_lufrac ),
     &                       LUF_FAC  ( n_lufrac ),
     &                       HGLU_FAC ( n_lufrac ), STAT = ALLOCSTAT )
                  IF ( ALLOCSTAT .NE. 0 ) THEN
                     XMSG = 'Failure allocating land use data'
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
               End If
               cat_lu   = NLCD40%lu_cat
               name_lu  = NLCD40%name
               LUF_FAC  = NLCD40%LUF_FAC
               HGLU_FAC = NLCD40%HGLU_FAC
            CASE DEFAULT                       
               xmsg = 'Land use scheme not supported'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END SELECT                            
                                               
         END SUBROUTINE Init_LSM               
                                               
      END MODULE LSM_Mod                       

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!------------------------------------------------------------------------!
! This module contains key component from cropcal.F to facilitate 
! centralized I/O implementation by avoiding cyclic data dependence

! Revision History:
!  01 Feb 2019 D.Wong initial implementation, 
!------------------------------------------------------------------------!

          module crop_data_module

            implicit none

            integer, parameter :: nlcrp = 17
            character( 16 ), parameter :: crop_vnmld( nlcrp ) =  ! beld01
     &         ( / 'Alfalfa  ', 'Barley   ', 'Corn     ',
     &             'Cotton   ', 'Grass    ', 'Hay      ',
     &             'Misc_crop', 'Oats     ', 'Pasture  ',
     &             'Peanuts  ', 'Potatoes ', 'Rice     ',
     &             'Rye      ', 'Sorghum  ', 'Soybeans ',
     &             'Tobacco  ', 'Wheat    ' / )

C Conventional tillage (0-15% residue) fraction for 17 crops as VNMLD list
            real, parameter :: ctilf( nlcrp ) =
     &         ( / 0.0,  0.37, 0.40, 0.70,  ! Alfalfa, Barley, Corn, Cotton,
     &             0.0,  0.0,  0.70, 0.47,  ! Grass, Hay, Misc_crop, Oats,
     &             0.36, 0.80, 0.74, 0.79,  ! Pasture, Peanuts, Potatoes, Rice,
     &             0.52, 0.46, 0.24, 0.96,  ! Rye, Sorghum, Soybeans, Tobacco, 
     &             0.40 / )                 ! Wheat

C No tillage fraction for 17 crops as VNMLD list
            real, parameter :: ntilf( nlcrp ) =
     &         ( / 0.80, 0.10, 0.20, 0.14,  ! Alfalfa, Barley, Corn, Cotton,
     &             0.80, 0.80, 0.05, 0.08,  ! Grass, Hay, Misc_crop, Oats,
     &             0.47, 0.09, 0.0,  0.05,  ! Pasture, Peanuts, Potatoes, Rice,
     &             0.11, 0.14, 0.33, 0.01,  ! Rye, Sorghum, Soybeans, Tobacco, 
     &             0.13 / )                 ! Wheat

            real, allocatable :: crop_ladut ( :,:,: )   ! cropland fraction from BELD1
            real, allocatable :: crplnd( :,:,: )        ! each erodible crop land fraction

            integer, parameter :: ncrop = 18
            character( 16 ), parameter :: vcrop( ncrop ) =  ! crop calendar )CROPCAL)
     &         ( / 'Alfalfa     ', 'BarleySpring', 'BarleyFall  ',
     &             'Corn        ', 'Cotton      ', 'Hay         ',
     &             'OatsSpring  ', 'OatsFall    ', 'Peanuts     ',
     &             'Potatoes    ', 'Rice        ', 'Rye         ',
     &             'Sorghum     ', 'Soybeans    ', 'Sugerbeets  ',
     &             'Tobacco     ', 'WheatSpring ', 'WheatWinter ' / )

            character( 16 ), parameter :: crname( 3 ) = ! crop calendar NetCDF file name
     &         ( / 'CROPMAP01',        ! begin planting
     &             'CROPMAP04',        ! end planting
     &             'CROPMAP08' / )     ! end harvesting

            real, allocatable :: cropdt( :,:,:,: ) ! cropland calendar for species and 3 activities

          end module crop_data_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/vdiff/acm2/opddep.F,v 1.6 2012/01/19 14:40:52 yoj Exp $
 
C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%
 
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPDDEP ( JDATE, JTIME, TSTEP, N_SPC_DDEP )

C   30 Mar 01 J.Young: dyn alloc - Use HGRD_DEFN
C   03 Sep 01 David Wong: for new pario
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C   11 May 11 J.Bash: Modified to output NH3 bidi component fluxes
C   04 Jan 12 J.Young: Initalize char strings with blank padding
C   08 Jun 12 J.Young: remove full character blank padding for GNU Fortran (GCC) 4.1.2
C   12 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1

      USE RUNTIME_VARS, ONLY : ABFLUX
      USE GRID_CONF           ! horizontal & vertical domain specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN

#ifdef sens
      USE DDM3D_DEFN, ONLY: NP, NPMAX, SENNUM, SPCNAME, SEN_PAR
#endif

      IMPLICIT NONE
 
      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      INTEGER, INTENT( IN ) :: JDATE  ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP  ! output time step
      INTEGER, INTENT( IN ) :: N_SPC_DDEP ! no. of dry dep species

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'OPDDEP'
      CHARACTER( 96 ) :: XMSG = ' '

      INTEGER      V, N, L     ! loop induction variables
      INTEGER      STRT, FINI  ! loop induction variables

C-----------------------------------------------------------------------

C Try to open existing file for update

      IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSRDWR3, PNAME ) ) THEN
      
         XMSG = 'Could not open ' // CTM_DRY_DEP_1 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open the dry dep file

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME
         TSTEP3D = TSTEP
         CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour
         IF ( ABFLUX ) THEN
            NVARS3D = N_SPC_DDEP + 2
         ELSE 
            NVARS3D = N_SPC_DDEP 
         END IF
         NCOLS3D = GL_NCOLS
         NROWS3D = GL_NROWS
         NLAYS3D =     1
         NTHIK3D =     1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
!        VGTPUN3D = VGTPUN_GD ! currently, not defined
         DO L = 1, NLAYS3D + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
!        GDNAM3D = GDNAME_GD
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         N = 0
         STRT = 1
         FINI = N_GC_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = GC_DDEP( N )
            UNITS3D( V ) = 'kg ha-1'
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         N = 0
         STRT = N_GC_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = AE_DDEP( N )
            IF ( AE_DDEP( N )( 1:3 ) .EQ. 'NUM' ) THEN
               UNITS3D( V ) = 'ha-1'
            ELSE IF ( AE_DDEP( N )( 1:3 ) .EQ. 'SRF' ) THEN
               UNITS3D( V ) = 'm2 ha-1'
            ELSE
               UNITS3D( V ) = 'kg ha-1'
            END IF
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         N = 0
         STRT = N_GC_DDEP + N_AE_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = NR_DDEP( N )
            UNITS3D( V ) = 'kg ha-1'
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         N = 0
         STRT = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP
         DO V = STRT, FINI
            N = N + 1
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = TR_DDEP( N )
            UNITS3D( V ) = 'ha-1'
            VDESC3D( V ) = 'hourly dry deposition values'
         END DO

         IF ( ABFLUX ) THEN
            VTYPE3D( V ) = M3REAL
            VNAME3D( V ) = 'NH3_Flux'
            UNITS3D( V ) = 'kg/hectare'
            VDESC3D( V ) = 'hourly bidi flux values'
  
            VTYPE3D( V+1 ) = M3REAL
            VNAME3D( V+1 ) = 'NH3_Emis'
            UNITS3D( V+1 ) = 'kg/hectare'
            VDESC3D( V+1 ) = 'hourly NH3_Emis values'
         END IF

         FDESC3D( 1 ) = 'hourly 1-layer cross-point M3Dry dry deposition data'
         DO L = 2, MXDESC3
            FDESC3D( L ) = ' '
         END DO

C    Open dry deposition file

         IF ( .NOT. OPEN3( CTM_DRY_DEP_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_DRY_DEP_1 // ' file'
            CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF

#ifdef sens
CC..Create sensitivity dry deposition file

C...check for existing file
      IF ( .NOT. OPEN3( CTM_SDRYDEP_1, FSRDWR3, PNAME ) ) THEN
         XMSG = 'Could not open ' // CTM_SDRYDEP_1 // ' file for update - '
     &        // 'try to open new'
         CALL M3MESG( XMSG )

C...set output file variables 
         NVARS3D = N_SPC_DDEP * NPMAX
         FDESC3D( 1 ) = 'sensitivity of hourly dry deposition'

C...define sens dry deposition output descriptors for gaseous species
         N = 0
         STRT = 1
         FINI = N_GC_DDEP
         DO V = STRT, FINI
            N = N + 1
            SPCNAME = GC_DDEP( N )( 1:12 )
            DO NP = 1, NPMAX
               SENNUM = ( V - 1 ) * NPMAX + NP
               VNAME3D ( SENNUM ) = TRIM( SPCNAME ) //'_' // SEN_PAR( NP )
               VTYPE3D( SENNUM ) = M3REAL
               UNITS3D( SENNUM ) = 'kg/hectare'
               VDESC3D( SENNUM ) = 'sensitivity of hourly dry deposition values'
            END DO
         ENDDO

C...define dry deposition output descriptors for aerosol species
         N = 0
         STRT = N_GC_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP
         DO V = STRT, FINI
            N = N + 1
            SPCNAME = AE_DDEP( N )( 1:12 )
            DO NP = 1, NPMAX
               SENNUM = ( V - 1 ) * NPMAX + NP
               VNAME3D ( SENNUM ) = TRIM( SPCNAME ) //'_' // SEN_PAR( NP )
               VTYPE3D( SENNUM ) = M3REAL
               IF ( AE_DDEP( N )( 1:3 ) .EQ. 'NUM' ) THEN
                  UNITS3D( SENNUM ) = 'number/hectare'
               ELSE IF ( AE_DDEP( N )( 1:3 ) .EQ. 'SRF' ) THEN
                  UNITS3D( SENNUM ) = 'm**2/hectare'
               ELSE
                  UNITS3D( SENNUM ) = 'kg/hectare'
               END IF
               VDESC3D( SENNUM ) = 'sensitivity of hourly dry deposition values'
            END DO
         ENDDO

C...define dry deposition output descriptors for non-reactive species
         N = 0
         STRT = N_GC_DDEP + N_AE_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP
         DO V = STRT, FINI
            N = N + 1
            SPCNAME = NR_DDEP( N )( 1:12 )
            DO NP = 1, NPMAX
               SENNUM = ( V - 1 ) * NPMAX + NP
               VNAME3D ( SENNUM ) = TRIM( SPCNAME ) //'_' // SEN_PAR( NP )
               VTYPE3D( SENNUM ) = M3REAL
               UNITS3D( SENNUM ) = 'kg/hectare'
               VDESC3D( SENNUM ) = 'sensitivity of hourly dry deposition values'
            END DO
         END DO

C...define dry deposition output descriptors for tracer species
         N = 0
         STRT = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + 1
         FINI = N_GC_DDEP + N_AE_DDEP + N_NR_DDEP + N_TR_DDEP
         DO V = STRT, FINI
            N = N + 1
            SPCNAME = TR_DDEP( N )( 1:12 )
            DO NP = 1, NPMAX
               SENNUM = ( V - 1 ) * NPMAX + NP
               VNAME3D ( SENNUM ) = TRIM( SPCNAME ) //'_' // SEN_PAR( NP )
               VTYPE3D( SENNUM ) = M3REAL
               UNITS3D( SENNUM ) = '----'
               VDESC3D( SENNUM ) = 'sensitivity of hourly dry deposition values'
            END DO
         END DO

C...create a new file
         IF ( .NOT. OPEN3( CTM_SDRYDEP_1, FSNEW3, PNAME ) ) THEN
            XMSG = 'Could not create '// CTM_DRY_DEP_1 // ' file'
            CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
         END IF

      END IF
#endif

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE CKSUMMER ( SCIPROC, CGRID, JDATE, JTIME )

C Function:
C     Sum concentrations over entire grid.

C Revision History:
C   Original version ???
C   2 October, 1998 by Al Bourgeois at LM: parallel implementation
C         and fix bug by SAVEing DEVNAME.

C   1/22/99 David Wong at LM: compute global sum for variables: GC_CKSUM,
C                             AE_CKSUM, NR_CKSUM, and TR_CKSUM

C   1/28/99 David Wong at LM: compute global sum for GCELLS

C   15 Dec 00 J.Young: move CGRID_MAP into f90 module
C                      GLOBAL_RSUM -> Dave Wong`s f90 stenex GLOBAL_SUM
C   Jeff - Feb 01 - assumed shape arrays
C   23 Mar 01 J.Young: Use HGRD_DEFN
C   31 May 02 J.Young: REAL*8 reduction accumulator (avoid 32 bit roundoff)
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module
C    4 Feb 08 J.Young: checksums based on local processor
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN
C   10 Aug 11 David Wong: reset output format 1PEw.d to meet the standard
C                         w-d > 6
C    9 Apr 15 J.Bash: Use F90 MINVAL to speed up execution
C   18 Mar 16 J.Young: Add "INTENT" attribute; remove commented out code;
C                      rearrange logic for efficiency
C-----------------------------------------------------------------------

      USE GRID_CONF, ONLY:  NCOLS, NROWS, NLAYS
      USE CGRID_SPCS, ONLY: N_GC_SPC, GC_STRT, GC_SPC, 
     &                      N_AE_SPC, AE_STRT, AE_SPC,
     &                      N_NR_SPC, NR_STRT, NR_SPC,
     &                      N_TR_SPC, TR_STRT, TR_SPC
      USE RUNTIME_VARS, ONLY: LOGDEV, OUTDEV, CMYPE, APPL_NAME

      USE UTILIO_DEFN, ONLY: GETEFILE
#ifdef parallel
      USE SE_MODULES          ! stenex (using SE_GLOBAL_SUM_MODULE)
#else
      USE NOOP_MODULES        ! stenex (using NOOP_GLOBAL_SUM_MODULE)
#endif

      IMPLICIT NONE

C Arguments:

      CHARACTER( * ), INTENT( IN ) :: SCIPROC  ! science process name
      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: JDATE        ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME        ! current model time, coded HHMMSS

C Parameters:

      REAL, PARAMETER :: CMIN = 0.0

C Local variables:
 
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      CHARACTER( 16 ), SAVE :: PNAME = 'CKSUMMER'
      CHARACTER(  6 ) :: PRESTR = 'FLOOR_'
      CHARACTER( 96 ), SAVE :: DEVNAME ! Name of output file.

      INTEGER, SAVE :: FLOORDEV    ! FORTRAN unit number for neg conc ascii file

      LOGICAL ::  RDONLY = .FALSE.
      LOGICAL ::  FMTTED = .TRUE.

      INTEGER     S, V, L, C, R
      REAL( 8 ) :: DBL_CKSUM
      REAL         GC_CKSUM, AE_CKSUM, NR_CKSUM, TR_CKSUM
      REAL, SAVE :: LCELLS

      LOGICAL, SAVE :: OPFLG = .TRUE.               ! open file flag
      LOGICAL     EXFLG                             ! write header flag

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         LCELLS = FLOAT( NCOLS * NROWS * NLAYS )
         DEVNAME = PRESTR // CMYPE // '.' // TRIM( APPL_NAME )

      END IF

      IF ( MINVAL( CGRID ) .LT. CMIN ) THEN

         EXFLG = .TRUE.

         DBL_CKSUM = 0.0
         IF ( N_GC_SPC .GT. 0 ) THEN

            V = 0
            DO S = GC_STRT, GC_STRT - 1 + N_GC_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          GC_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            GC_CKSUM = REAL( DBL_CKSUM, 4 )
 
         ELSE

            GC_CKSUM = 0.0
 
         END IF
     
         DBL_CKSUM = 0.0
         IF ( N_AE_SPC .GT. 0 ) THEN

            V = 0
            DO S = AE_STRT, AE_STRT - 1 + N_AE_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          AE_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            AE_CKSUM = REAL( DBL_CKSUM, 4 )
  
         ELSE

            AE_CKSUM = 0.0
 
         END IF

         DBL_CKSUM = 0.0
         IF ( N_NR_SPC .GT. 0 ) THEN
 
            V = 0
            DO S = NR_STRT, NR_STRT - 1 + N_NR_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          NR_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            NR_CKSUM = REAL( DBL_CKSUM, 4 )
  
         ELSE

            NR_CKSUM = 0.0
 
         END IF
     
         DBL_CKSUM = 0.0
         IF ( N_TR_SPC .GT. 0 ) THEN
 
            V = 0
            DO S = TR_STRT, TR_STRT - 1 + N_TR_SPC
               V = V + 1
               DO L = 1, NLAYS
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBL_CKSUM = DBL_CKSUM + CGRID( C,R,L,S )
                        IF ( CGRID( C,R,L,S ) .LT. CMIN ) THEN
                           IF ( EXFLG ) THEN
                              EXFLG = .FALSE.
                              IF ( OPFLG ) THEN   ! open output ASCII file
                                 OPFLG = .FALSE.
                                 FLOORDEV = GETEFILE ( DEVNAME, RDONLY, FMTTED, PNAME )
                              END IF
                              WRITE( FLOORDEV,1001 ) CMIN, SCIPROC
                           END IF
                           WRITE( FLOORDEV,1003 ) JDATE, JTIME, C, R, L, S,
     &                                          TR_SPC( V ), CGRID( C,R,L,S )
                           CGRID( C,R,L,S ) = CMIN
                        END IF
                     END DO
                  END DO
               END DO
            END DO

            TR_CKSUM = REAL( DBL_CKSUM, 4 )
  
         ELSE

            TR_CKSUM = 0.0
 
         END IF

      ELSE   ! MINVAL( CGRID ) .GE. CMIN

         GC_CKSUM = SUM( CGRID( :,:,:,GC_STRT : ( GC_STRT - 1 + N_GC_SPC ) ) ) 
         AE_CKSUM = SUM( CGRID( :,:,:,AE_STRT : ( AE_STRT - 1 + N_AE_SPC ) ) ) 
         NR_CKSUM = SUM( CGRID( :,:,:,NR_STRT : ( NR_STRT - 1 + N_NR_SPC ) ) ) 
         IF ( N_TR_SPC .GT. 0 ) THEN
            TR_CKSUM = SUM( CGRID( :,:,:,TR_STRT : ( TR_STRT - 1 + N_TR_SPC ) ) ) 
         END IF
     
      END IF

      IF ( N_TR_SPC .EQ. 0 ) THEN
         WRITE( LOGDEV,1005 ) SCIPROC,
     &                        GC_CKSUM / LCELLS,
     &                        AE_CKSUM / LCELLS,
     &                        NR_CKSUM / LCELLS
         IF ( ( GC_CKSUM .NE. GC_CKSUM ) .OR. ( GC_CKSUM*2. .EQ. GC_CKSUM ) .OR.
     &        ( AE_CKSUM .NE. AE_CKSUM ) .OR. ( AE_CKSUM*2. .EQ. AE_CKSUM ) .OR.
     &        ( NR_CKSUM .NE. NR_CKSUM ) .OR. ( NR_CKSUM*2. .EQ. NR_CKSUM ) ) THEN
              WRITE( OUTDEV, '(7x,A,A)' ),'NaN or Infinity detected on processor ',TRIM(CMYPE)
              WRITE( OUTDEV,1008 ) SCIPROC,GC_CKSUM/LCELLS,AE_CKSUM/LCELLS,NR_CKSUM/LCELLS
              CALL M3EXIT( PNAME, jdate, jtime,'NaN or Infinity detected in '//SCIPROC, 1 )
         END IF
 
      ELSE
         WRITE( LOGDEV,1007 ) SCIPROC,
     &                        GC_CKSUM / LCELLS,
     &                        AE_CKSUM / LCELLS,
     &                        NR_CKSUM / LCELLS,
     &                        TR_CKSUM / LCELLS
         IF ( ( GC_CKSUM .NE. GC_CKSUM ) .OR. ( GC_CKSUM*2. .EQ. GC_CKSUM ) .OR.
     &        ( AE_CKSUM .NE. AE_CKSUM ) .OR. ( AE_CKSUM*2. .EQ. AE_CKSUM ) .OR.
     &        ( NR_CKSUM .NE. NR_CKSUM ) .OR. ( NR_CKSUM*2. .EQ. NR_CKSUM ) .OR.
     &        ( TR_CKSUM .NE. TR_CKSUM ) .OR. ( TR_CKSUM*2. .EQ. TR_CKSUM ) ) THEN
              WRITE( OUTDEV, '(7x,A,A)' ),'NaN or Infinity detected on processor ',TRIM(CMYPE)
              WRITE( OUTDEV,1009 ) SCIPROC,GC_CKSUM/LCELLS,AE_CKSUM/LCELLS,NR_CKSUM/LCELLS,TR_CKSUM/LCELLS
              CALL M3EXIT( PNAME, jdate, jtime,'NaN or Infinity detected in '//SCIPROC, 1 )
         END IF
      END IF

      RETURN

1001  FORMAT(  5X, 'Concentrations less than, but reset to', 1PE11.3,
     &         1X, 'in', A16
     &       / 9X, 'Date:Time',
     &         5X, 'Col', 2X, 'Row', 1X, 'Layer', 1X, 'Species',
     &         13X, 'Value before reset' )

1003  FORMAT( 5X, I8, ':', I6.6, 4I5, 1X, '(', A16, ')', 1PE12.3)

1005  FORMAT( 5X, 'After',
     &        1X, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3 )

1007  FORMAT( 5X, 'After',
     &        1x, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3,
     &                 1X, ' | Trc ', 1PE10.3 )
 
1008  FORMAT( 7X, 'During',
     &        1X, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3 )

1009  FORMAT( 7X, 'During',
     &        1x, A12, 1X, ':  Gas ', 1PE10.3,
     &                 1X, ' | Aer ', 1PE10.3,
     &                 1X, ' | Non ', 1PE10.3,
     &                 1X, ' | Trc ', 1PE10.3 )
 
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE X_PPM ( CGRID, FDATE, FTIME, TSTEP, LVL, BCON )

C-----------------------------------------------------------------------
C Function:
C   Piecewise Parabolic Method advection in the X-direction

C Preconditions:

C Subroutines and functions called:

C Revision history:
C  28 Jun 2004: Jeff Young

C   1 Nov 06: Jeff Young - Following Glenn Hammond, moved all communication
C   out of HPPM to this level; using "swap_sandia" communication; update only
C   local values in the CGRID array within a time step, discarding previous
C   ghost values.
C   11 May 2009: Jeff Young: Simplify - assume constant cell widths, DS( i )
C   11 May 2010: Jeff Young: New hppm fix for PGI compiler by David Wong
C   21 Jun 2010: Jeff Young: convert for Namelist redesign
C   16 Feb 2011: Shawn Roselle: replaced I/O API include files with UTILIO_DEFN
C   19 Oct 2015: Jeff Young: Remove stmnt func to resolve PGI compiler error
C   29 Nov 17 David Wong: removed all SWAP routines and replaced with SE_COMM
C   16 NOv 2018 S.Napelenok: ISAM implementation
C    1 Feb 19 David Wong: removed all MY_N clauses
C   11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE HGRD_DEFN             ! horizontal domain specifications
      USE CGRID_SPCS            ! CGRID mechanism species
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_COMM_MODULE, SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_COMM_MODULE, NOOP_UTIL_MODULE)
#endif

#ifdef isam
      USE SA_DEFN, Only: ISAM, N_SPCTAG, S_SPCTAG, T_SPCTAG, 
     &                   TRANSPORT_SPC, BCON_SPC, MAP_ADVtoSA
#endif

#ifdef sens
      USE DDM3D_DEFN, ONLY:SENGRID, NPMAX, NP, BSEN, BCS, DATENUM, IPT, IDATE, IPARM, IREGION, CKTIME, STARTDATE
#endif 

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_CONST       ! constants
      INCLUDE SUBST_PE_COMM     ! PE communication displacement and direction

C Arguments:

      REAL,    POINTER      :: CGRID( :,:,:,: )
      INTEGER, INTENT( IN ) :: FDATE         ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN ) :: FTIME         ! current model time, coded HHMMSS
      INTEGER, INTENT( IN ) :: TSTEP         ! time step (HHMMSS)
      INTEGER, INTENT( IN ) :: LVL           ! layer
      REAL,    INTENT( IN ) :: BCON( :,: )      ! boundary concentrations

C External Functions not declared in IODECL3.EXT:

      REAL,    EXTERNAL :: ZFDBC

C Parameters:

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

! #ifdef parallel
      INTEGER, PARAMETER :: SWP = 3
! #else
!     INTEGER, PARAMETER :: SWP = 1
! #endif

C File Variables:

      REAL         UHAT( NCOLS+1,NROWS+1 )       ! x1-component CX-velocity

C Local Variables:

      CHARACTER( 16 ) :: PNAME = 'X_PPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      CHARACTER( 96 ) :: XMSG = ' '

      REAL,    SAVE :: DX1                      ! dx1 (meters)
      INTEGER, SAVE :: ASPC                     ! RHOJ index in CGRID

      REAL, ALLOCATABLE, SAVE :: VELX( : ),     ! Velocities along a row
     &                           CONX( :,: )    ! Conc's along a row

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_CONX( :,: )
#endif

      REAL          DT                          ! TSTEP in sec
      INTEGER       ALLOCSTAT

      INTEGER, ALLOCATABLE, SAVE :: ADV_MAP( : ) ! global adv map to CGRID

      CHARACTER( 16 ) :: X1VEL = 'X1VEL'

      INTEGER      COL, ROW, SPC, VAR           ! loop counters
      INTEGER      A2C

      LOGICAL, SAVE :: BNDY_PE_LOX, BNDY_PE_HIX

#ifdef parallel
      INTEGER EAST_COL
      REAL, ALLOCATABLE, SAVE :: HALO_EAST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: HALO_WEST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: BUF_EW( :,:,: )

#ifdef isam
      REAL, ALLOCATABLE, SAVE :: SA_HALO_EAST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_HALO_WEST( :,:,: )
      REAL, ALLOCATABLE, SAVE :: SA_BUF_EW( :,:,: )
#endif

#endif

      INTEGER, SAVE :: EFX    ! fixed parameter for eastern boundary
      INTEGER, SAVE :: WFX    ! fixed parameter for western boundary

#ifdef sens
      LOGICAL TIMEFLAG                  ! checks if within desired time
      REAL, ALLOCATABLE, SAVE :: SENX( :,: )      ! Sens along a row
      REAL,    EXTERNAL :: S_ZFDBC   ! similar to zfdbc, for sens
#ifdef parallel
      REAL, ALLOCATABLE, SAVE :: S_HALO_EAST( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: S_HALO_WEST( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: S_BUF_EW( :,:,:,: )
#endif
#endif

C Required interface for allocatable array dummy arguments

      INTERFACE
         SUBROUTINE HCONTVEL( FDATE, FTIME, TSTEP, LVL, UORV, UHAT )
            INTEGER, INTENT( IN )         :: FDATE, FTIME, TSTEP, LVL
            CHARACTER( 16 ), INTENT( IN ) :: UORV
            REAL,    INTENT( OUT )        :: UHAT( :,: )
         END SUBROUTINE HCONTVEL
         SUBROUTINE HPPM ( NI, NJ, CON, VEL, DT, DS, ORI )
! #ifdef parallel
            INTEGER, PARAMETER         :: SWP = 3
! #else
!           INTEGER, PARAMETER         :: SWP = 1
! #endif
            INTEGER,   INTENT( IN )    :: NI, NJ
            REAL,      INTENT( INOUT ) :: CON( 1-SWP:,1: )
            REAL,      INTENT( IN )    :: VEL( : )
            REAL,      INTENT( IN )    :: DT
            REAL,      INTENT( IN )    :: DS
            CHARACTER, INTENT( IN )    :: ORI
         END SUBROUTINE HPPM
      END INTERFACE
C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         EFX = NCOLS + 1
         WFX = 2 * NCOLS + NROWS + 4

C Get dx1 from HGRD_DEFN module

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 ))) ! in m.
         ELSE
            DX1 = XCELL_GD        ! in m.
         END IF

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ

         ALLOCATE ( CONX( 1-SWP:NCOLS+SWP,N_SPC_ADV ),
#ifdef isam
     &           SA_CONX( 1-SWP:NCOLS+SWP,N_SPCTAG ), ! 20120816
#endif
     &              VELX( NCOLS+1 ), STAT = ALLOCSTAT ) ! Vel along a row
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating VELX, or CONX'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#ifdef isam
         SA_CONX = 0.0
#endif
         ALLOCATE ( ADV_MAP( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating ADV_MAP'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF

#ifdef parallel
         ALLOCATE ( HALO_EAST( SWP,NROWS,N_SPC_ADV ),
     &              HALO_WEST( SWP,NROWS,N_SPC_ADV ),
     &              BUF_EW   ( SWP,NROWS,N_SPC_ADV ),
#ifdef isam
     &              SA_HALO_EAST( SWP,NROWS,N_SPCTAG ),
     &              SA_HALO_WEST( SWP,NROWS,N_SPCTAG ),
     &              SA_BUF_EW   ( SWP,NROWS,N_SPCTAG ),
#endif
     &              STAT = ALLOCSTAT )

         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating HALO_EAST, HALO_WEST, or BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
         HALO_EAST = 0.0   ! array
         HALO_WEST = 0.0   ! array
         BUF_EW    = 0.0   ! array

#ifdef isam
         SA_HALO_EAST = 0.0   ! KRT array
         SA_HALO_WEST = 0.0   ! KRT array
         SA_BUF_EW    = 0.0   ! KRT array
#endif

#endif

#ifdef sens
         ALLOCATE ( SENX( 1-SWP:NCOLS+SWP,N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SENX'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
#ifdef parallel
         ALLOCATE ( S_HALO_EAST( SWP,NROWS,N_SPC_ADV,NPMAX ),
     &              S_HALO_WEST( SWP,NROWS,N_SPC_ADV,NPMAX ),
     &              S_BUF_EW   ( SWP,NROWS,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG =
     &        'Failure allocating S_HALO_EAST, S_HALO_WEST, or S_BUF_EW'
            CALL M3EXIT ( PNAME, FDATE, FTIME, XMSG, XSTAT1 )
         END IF
         S_HALO_EAST = 0.0   ! array
         S_HALO_WEST = 0.0   ! array
         S_BUF_EW    = 0.0   ! array
#endif
#endif

         ASPC = GC_STRT - 1 + N_GC_SPCD

C Create global map to CGRID

         SPC = 0
         DO VAR = 1, N_GC_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = GC_STRT - 1 + GC_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_AE_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = AE_STRT - 1 + AE_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_NR_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = NR_STRT - 1 + NR_TRNS_MAP( VAR )
         END DO
         DO VAR = 1, N_TR_ADV
            SPC = SPC + 1
            ADV_MAP( SPC ) = TR_STRT - 1 + TR_ADV_MAP( VAR )
         END DO

         ADV_MAP( N_SPC_ADV ) = ASPC

         CALL SUBST_HI_LO_BND_PE ( 'C', BNDY_PE_LOX, BNDY_PE_HIX )

      END IF                    ! if firstime

      DT = FLOAT ( TIME2SEC ( TSTEP ) )

#ifdef sens
      ! index that will be used by IDATE
      DATENUM = 1 + FDATE - STARTDATE
#endif

C Do the computation for x advection

C Get the contravariant x1 velocity component

      CALL HCONTVEL ( FDATE, FTIME, TSTEP, LVL, X1VEL, UHAT )

      CALL SUBST_COMM (UHAT, DSPL_N0_E1_S0_W0, DRCN_E)

#ifdef parallel
      EAST_COL = NCOLS - SWP
      DO SPC = 1, N_SPC_ADV
         A2C = ADV_MAP( SPC )
         DO ROW = 1, NROWS
            DO COL = 1, SWP
               HALO_WEST( COL,ROW,SPC ) = CGRID( COL,ROW,LVL,A2C )
               HALO_EAST( COL,ROW,SPC ) = CGRID( EAST_COL+COL,ROW,LVL,A2C )
               BUF_EW( COL,ROW,SPC ) = HALO_EAST( COL,ROW,SPC )
#ifdef sens
               DO NP = 1, NPMAX
                  S_HALO_WEST( COL,ROW,SPC,NP ) = SENGRID( COL,ROW,LVL,NP,A2C )
                  S_HALO_EAST( COL,ROW,SPC,NP ) = SENGRID( EAST_COL+COL,ROW,LVL,NP,A2C )
                  S_BUF_EW( COL,ROW,SPC,NP ) = S_HALO_EAST( COL,ROW,SPC,NP )
               END DO
#endif
            END DO
         END DO
      END DO

      CALL SUBST_COMM (HALO_WEST, HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (BUF_EW,    HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)

#ifdef sens
      DO NP = 1, NPMAX
         CALL SUBST_COMM( S_HALO_WEST(:,:,:,NP), S_HALO_EAST(:,:,:,NP), 
     &                    DSPL_N0_E1_S0_W0, DRCN_E )
         CALL SUBST_COMM( S_BUF_EW(:,:,:,NP),        S_HALO_WEST(:,:,:,NP), 
     &                    DSPL_N0_E0_S0_W1, DRCN_W )
      END DO
#endif

#ifdef isam
      DO SPC = 1, N_SPCTAG
         IF( TRANSPORT_SPC( SPC ) )THEN
            DO ROW = 1, NROWS
               DO COL = 1, SWP
                  SA_HALO_WEST( COL,ROW,SPC ) =
     &                    ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG ( SPC ) )
                  SA_HALO_EAST( COL,ROW,SPC ) =
     &                    ISAM( EAST_COL+COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
                  SA_BUF_EW( COL,ROW,SPC ) = SA_HALO_EAST( COL,ROW,SPC )
               END DO
            END DO
         END IF
      END DO

      CALL SUBST_COMM (SA_HALO_WEST, SA_HALO_EAST, DSPL_N0_E1_S0_W0, DRCN_E)
      CALL SUBST_COMM (SA_BUF_EW,    SA_HALO_WEST, DSPL_N0_E0_S0_W1, DRCN_W)
#endif

#endif

      DO 233 ROW = 1, NROWS

         DO COL = 1, NCOLS+1
            VELX( COL ) = UHAT( COL,ROW )
         END DO

         DO SPC = 1, N_SPC_ADV

            A2C = ADV_MAP( SPC )
            DO COL = 1, NCOLS
               CONX( COL,SPC ) = CGRID( COL,ROW,LVL,A2C )
            END DO

#ifdef parallel
            DO COL = 1, SWP
               CONX( COL-SWP,SPC )      = HALO_WEST( COL,ROW,SPC )
               CONX( NCOLS+COL,SPC ) = HALO_EAST( COL,ROW,SPC )
            END DO
#endif

C West boundary

            IF ( BNDY_PE_LOX ) THEN
               IF ( VELX( 1 ) .LT. 0.0 ) THEN          ! outflow
                  CONX( 1-SWP:0,SPC ) =
     &               ZFDBC ( CONX( 1,SPC ), CONX( 2,SPC ),
     &                       VELX( 1 ),     VELX( 2 ) )
               ELSE    ! inflow
                  CONX( 1-SWP:0,SPC ) = BCON( WFX+ROW,SPC )
               END IF
            END IF

C East boundary

            IF ( BNDY_PE_HIX ) THEN
               IF ( VELX( NCOLS+1 ) .GT. 0.0 ) THEN     ! outflow
                  CONX( NCOLS+1:NCOLS+SWP,SPC ) =
     &               ZFDBC ( CONX( NCOLS,SPC ), CONX( NCOLS-1,SPC ),
     &                       VELX( NCOLS+1 ),   VELX( NCOLS ) )
               ELSE    ! inflow
                  CONX( NCOLS+1:NCOLS+SWP,SPC ) = BCON( EFX+ROW,SPC )
               END IF
            END IF

         END DO

#ifdef isam
         DO SPC = 1, N_SPCTAG
         
            IF( TRANSPORT_SPC( SPC ) )THEN

               DO COL = 1, NCOLS
                  SA_CONX( COL, SPC  ) = ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
               END DO
               
#ifdef parallel
               DO COL = 1, SWP
                  SA_CONX( COL-SWP,SPC ) = SA_HALO_WEST( COL,ROW,SPC )
                  SA_CONX( NCOLS+COL,SPC ) = SA_HALO_EAST( COL,ROW,SPC )
               END DO
#endif

C West boundary
               IF ( BNDY_PE_LOX ) THEN
                  IF ( VELX( 1 ) .LT. 0.0 ) THEN   ! outflow
                     SA_CONX( 1-SWP:0,SPC ) =
     &               ZFDBC( SA_CONX( 1,SPC ), SA_CONX( 2,SPC ), VELX( 1 ), VELX( 2 ) )
                  ELSE    ! inflow
                     IF ( BCON_SPC( SPC ) ) THEN
                        SA_CONX( 1-SWP:0,SPC ) = BCON( WFX+ROW,MAP_ADVtoSA( SPC ) )
                     ELSE   ! non-bcon tags ?
                        SA_CONX( 1-SWP:0,SPC ) = 0.0
                     END IF   
                  END IF   ! velx < 0 ?
               END IF   ! bndy_pe_lox ?

C East boundary
               IF ( BNDY_PE_HIX ) THEN
                  IF ( VELX( NCOLS+1 ) .GT. 0.0 ) THEN     ! outflow
                     SA_CONX( NCOLS+1:NCOLS+SWP,SPC ) =
     &               ZFDBC ( SA_CONX( NCOLS,SPC ), SA_CONX( NCOLS-1,SPC ),
     &                       VELX( NCOLS+1 ), VELX( NCOLS ) )
                  ELSE    ! inflow
                     IF ( BCON_SPC( SPC ) ) THEN
                        SA_CONX( NCOLS+1:NCOLS+SWP,SPC ) = BCON( EFX+ROW, MAP_ADVtoSA( SPC ) )
                     ELSE   ! non-bcon tags ?
                        SA_CONX( NCOLS+1:NCOLS+SWP,SPC ) = 0.0
                     END IF 
                  END IF   ! velx > 0 ?
               END IF   ! bndy_pe_hix ?
               
            END IF
         END DO  ! SPC loop
#endif

C PPM scheme
         CALL HPPM ( NCOLS, NROWS, CONX, VELX, DT, DX1, 'C' )
#ifdef isam
         CALL HPPM ( NCOLS, NROWS, SA_CONX, VELX, DT, DX1, 'C' )
#endif

         DO SPC = 1, N_SPC_ADV
            A2C = ADV_MAP( SPC )
            DO COL = 1, NCOLS
               CGRID( COL,ROW,LVL,A2C ) = CONX( COL,SPC )
            END DO
         END DO

#ifdef isam
         DO SPC = 1, N_SPCTAG
           IF( TRANSPORT_SPC( SPC ) )THEN           
             DO COL = 1, NCOLS  
                ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) = SA_CONX( COL,SPC )
             END DO
           END IF     
         END DO
#endif

#ifdef sens
         DO NP = 1, NPMAX

           CALL CKTIME( FDATE,FTIME,NP,TIMEFLAG) ! Check if the current time is within the time range

           DO SPC = 1, N_SPC_ADV
             A2C = ADV_MAP( SPC )
             DO COL = 1, NCOLS
               SENX( COL,SPC ) = SENGRID( COL,ROW,LVL,NP,A2C )
             END DO

#ifdef parallel
             DO COL = 1, SWP
               SENX( COL-SWP,SPC )   = S_HALO_WEST( COL,ROW,SPC,NP )
               SENX( NCOLS+COL,SPC ) = S_HALO_EAST( COL,ROW,SPC,NP )
             END DO
#endif

C West boundary
             IF ( BNDY_PE_LOX ) THEN
               IF ( VELX( 1 ) .LT. 0.0 ) THEN          ! outflow
                 IF ( CONX( 0, SPC ) .EQ. 0.0 ) THEN
                   SENX( 1-SWP:0, SPC ) = 0.0
                 ELSE ! Zero-flux divergence boundary condition for sens
                   SENX( 1-SWP:0,SPC ) =
     &               S_ZFDBC ( SENX( 1,SPC ), SENX( 2,SPC ),
     &                         VELX( 1 ),     VELX( 2 ) )
                 END IF
               ELSE    ! inflow
                 IF ( BCS ) THEN
                   SENX( 1-SWP:0,SPC ) = BSEN( WFX+ROW,SPC,NP )
                 ELSE IF ( ( IPT( NP ) .EQ. 2 ) .AND. ( TIMEFLAG ) ) THEN
                 ! Insert boundary condition to SEN iff time, date,
                 ! species, and region match and senstype is BOUN
                   SENX( 1-SWP:0,SPC ) = BCON( WFX+ROW,SPC )
     &                                 * IREGION( 1, ROW, LVL, NP )
     &                                 * REAL ( IDATE ( NP, DATENUM ) )
     &                                 * REAL ( IPARM ( NP, A2C     ) )
                 ELSE
                 ! Otherwise, set to 0
                   SENX( 1-SWP:0, SPC ) = 0.0
                 END IF
               END IF
             END IF

C East boundary
             IF ( BNDY_PE_HIX ) THEN
               IF ( VELX( NCOLS+1 ) .GT. 0.0 ) THEN     ! outflow
                 IF ( CONX( NCOLS+1, SPC ) .EQ. 0.0 ) THEN
                   SENX( NCOLS+1:NCOLS+SWP, SPC ) = 0.0
                 ELSE
                 ! Zero-flux divergence boundary condition for
                 ! sens
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) =
     &               S_ZFDBC ( SENX( NCOLS,SPC ), SENX( NCOLS-1,SPC ),
     &                         VELX( NCOLS+1 ),   VELX( NCOLS ) )
                 END IF
               ELSE    ! inflow
                 IF ( BCS ) THEN
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) = BSEN( EFX+ROW,SPC,NP )
                 ELSE IF ( ( IPT( NP ) .EQ. 2 ) .AND. ( TIMEFLAG ) ) THEN
                 ! Insert boundary condition to SEN iff time, date,
                 ! species, and region match and senstype is BOUN
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) = BCON( EFX+ROW,SPC )
     &                               * IREGION( NCOLS, ROW, LVL, NP )
     &                               * REAL ( IDATE ( NP, DATENUM ) )
     &                               * REAL ( IPARM ( NP, A2C     ) )
                 ELSE
                   SENX( NCOLS+1:NCOLS+SWP,SPC ) = 0.0
                 END IF
               END IF
             END IF

           END DO

C PPM scheme
           CALL HPPM ( NCOLS, NROWS, SENX, VELX, DT, DX1, 'C' )

           DO SPC = 1, N_SPC_ADV
             A2C = ADV_MAP( SPC )
             DO COL = 1, NCOLS
               SENGRID( COL,ROW,LVL,NP,A2C ) = SENX( COL,SPC )
             END DO
           END DO

         END DO   ! NP
#endif

233   CONTINUE

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE BIOG_EMIS

C-----------------------------------------------------------------------
C Function: biogenics emissions interface to the speciation profiles file

C Revision History:
C     ?? ??? ???? ?.?????: initial implementation
C     20 Sep 2007 J.Young: inline DSCSPROF, eliminate MODSPRO module
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     16 Aug 2018 G. Sarwar: updated for CB6R3M_AE7_KMTBR
C     01 Feb 2019 D. Wong: Implemented centralized I/O approach, and 
C                          created a new module biog_emis_param_module 
C                          (model_data_module.F) to hold some of information
C                          originally stored here to avoid cyclic dependence
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE EMIS_VARS
      USE biog_emis_param_module

      IMPLICIT NONE

      INTEGER, SAVE                      :: MSPCS      ! no. of emitted species
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: EMSPC( : ) ! emitted species names

C Mole and mass factors:
      REAL,            ALLOCATABLE, SAVE :: MLFAC( :,: ) ! mole factors
      REAL,            ALLOCATABLE, SAVE :: MSFAC( :,: ) ! mass factors

C-----------------------------------------------------------------------

      CONTAINS
         FUNCTION BIOG_INIT() RESULT ( SUCCESS )
      
         USE RXNS_DATA, ONLY : MECHNAME
         USE UTILIO_DEFN
         USE CGRID_SPCS, ONLY : N_CGRID_SPC, CGRID_NAME, CGRID_MW

         IMPLICIT NONE

C Subroutine arguments:
         LOGICAL SUCCESS

C External Functions:
         INTEGER,        EXTERNAL :: GETFLINE

C Parameters:
C (A line from the profile file is a record.)
         INTEGER,        PARAMETER :: NSEGS = 6  ! # of potential line segments (fields)
         INTEGER,        PARAMETER :: MXLINES = 100 ! max lines for requested sppro name
         INTEGER,        PARAMETER :: MXSPPOL = 10  ! max no. spc per pollutant
         INTEGER,        PARAMETER :: NMECHS = 14   ! dimension for number of mechanisms considered
         CHARACTER,      PARAMETER :: CINVHDR = '#' ! Indicator for inventory hdr fields
!        REAL,           PARAMETER :: GM2TON  = 1.0 / 907184.74  ! grams to tons

C unit number for speciation profiles file
         INTEGER :: RDEV

C Header definitions for NONHAP pollutants 
         CHARACTER( 7 ), PARAMETER :: HDRSTART = '/NONHAP' ! start of header
         CHARACTER( 5 ), PARAMETER :: HDREND   = '/END/'   ! end of header

         INTEGER :: MXSPEC    ! max no. of species per pol

C Table of species names per inventory pollutant
         CHARACTER( 16 ), ALLOCATABLE :: SPCNAMES( :,: )
C Table of mole-based units per inventory pollutant for all species
         CHARACTER( 16 ), ALLOCATABLE :: MOLUNITS( :,: )

C Arrays for getting pollutant-specific information from file
         INTEGER         :: NSPECA ( NSEF )     ! number of species per pollutant
         CHARACTER( 16 ) :: POLNAMA( NSEF )     ! unsorted pollutant names
         CHARACTER( 20 ) :: SEGMENT( NSEGS )    ! Segments of parsed lines
         INTEGER         :: INDX1A  ( MXLINES ) ! sorting index for SPECNMA
         CHARACTER( 16 ) :: SPECNMA ( MXLINES ) ! unsort spcs names
         CHARACTER( 16 ) :: TMPNAMES( MXSPPOL,NSEF ) ! unsort names per pollutant
         LOGICAL         :: LMOLAR  ( MXLINES ) ! true: moles conversion is not mass

         INTEGER         :: IPOS( MXSPPOL )   ! position in input pollutant list

C Local variables
         INTEGER        I, J, K, M, N ! counters and indices
         INTEGER        ICOUNT     ! tmp counter while populating SPCNAMES
         INTEGER        IOS        ! i/o status
         INTEGER        POL        ! pollutant counter
         INTEGER        IREC       ! record counter
         INTEGER        ISP        ! species names counter
         INTEGER        NIPOS      ! number of pollutant matches
         INTEGER        PNDX       ! position (from INDEX1) of pol in POLNAMA
         INTEGER        SNDX       ! position (from INDEX1) of pol in SPECNMA
         INTEGER        NDX, INDX  ! index position

         LOGICAL     :: INHEADER = .FALSE.   ! true: in file header

         CHARACTER( 256 ) :: LINE       ! buffer for profile record
         CHARACTER( 256 ) :: MESG       ! message buffer
         CHARACTER(  16 ) :: SPNPRF     ! record (line) speciation profile name
         CHARACTER(  16 ) :: POLNAM     ! record (line) pollutant name
         CHARACTER(  16 ) :: SPECNM     ! record (line) species name
         CHARACTER(  16 ) :: FILE_SPPRO ! label read from gspro

         REAL                SPLTFAC, SDIV, SMFAC ! line speciation profile factors
 
         TYPE BIOG_MECH_TYPE
              CHARACTER( 32 ) :: CHEMMECH
              CHARACTER( 16 ) :: BIOGMECH
         END TYPE BIOG_MECH_TYPE

         TYPE( BIOG_MECH_TYPE ) :: BIOG_MECH_MAP( NMECHS ) = (/
     &         BIOG_MECH_TYPE( 'CB05E51_AE6_AQ         ','B10C5   '),
     &         BIOG_MECH_TYPE( 'CB05EH51_AE6_AQ        ','B10C5   '),
     &         BIOG_MECH_TYPE( 'CB05MP51_AE6_AQ        ','B10C5   '),
     &         BIOG_MECH_TYPE( 'CB05TUCL51_AE6_AQ      ','B10C5   '),
     &         BIOG_MECH_TYPE( 'CB6R3_AE6_AQ           ','B10C6   '),
     &         BIOG_MECH_TYPE( 'CB6MP_AE6_AQ           ','B10C6   '),
     &         BIOG_MECH_TYPE( 'CB6R3_AE7_AQ           ','B10C6AE7'),     
     &         BIOG_MECH_TYPE( 'CB6R3M_AE7_KMTBR       ','B10C6AE7'),
     &         BIOG_MECH_TYPE( 'RACM2_AE6_AQ           ','B10RD   '),
     &         BIOG_MECH_TYPE( 'SAPRC07TB_AE6_AQ       ','B10SP   '),
     &         BIOG_MECH_TYPE( 'SAPRC07TC_AE6_AQ       ','B10SP   '),
     &         BIOG_MECH_TYPE( 'SAPRC07TIC_AE6I_AQ     ','B10SP   '),
     &         BIOG_MECH_TYPE( 'SAPRC07TIC_AE7I_AQ     ','B10SP   '),
     &         BIOG_MECH_TYPE( 'SAPRC07TIC_AE6I_AQKMTI ','B10SP   ') /)
 
         CHARACTER( 16 ) :: PNAME = 'BIOG_INIT'

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

C Open speciation profiles file
         RDEV = PROMPTFFILE(
     &            'Enter logical name for Speciation Profiles file',
     &            .TRUE., .TRUE., 'GSPRO', PNAME )

         IF ( SPPRO .EQ. 'DEFAULT' ) THEN 
            INDX = INDEX1( MECHNAME, NMECHS, BIOG_MECH_MAP%CHEMMECH )
            SPPRO = BIOG_MECH_MAP( INDX )%BIOGMECH
            WRITE( LOGDEV, '(5X,A,A,A)' ), 'Accessing compatible biogenic ',
     &             'emissions mechanism: ',TRIM( SPPRO )
         END IF

C Scan speciation profiles file to get all of the pollutant-species combinations
C that are valid for the pollutants in the inventory. The species names are sorted
C in alphebetical order for each pollutant, and the pollutants are in the same order
C as BIOTYPES. Also retrieve the maximum number of species per pollutant and the
C maximum number of profile entries per pollutant.

C Initialize species count per pollutant and flag for indicating true molar
C conversions (NOTE - for some pollutants like PM10, there are no mole-based
C factor and outputs should be in units of gm/mole in the mole-base speciation
C matrix)
         NSPECA   = 0        ! array
         POLNAMA  = ' '      ! array
         TMPNAMES = ' '      ! array
         LMOLAR   = .FALSE.  ! array

C Read through input file to determine the total number of pollutants in the input
C file, to determine the number of profiles per pollutant, to store the unique
C species names, and to store the units for mass-based and mole-based conversions
         ICOUNT = 1
         POL    = 0
         ISP    = 0
         IREC   = 0
         DO
            READ( RDEV, 93000, END=1999, IOSTAT=IOS ) LINE
            IREC = IREC + 1
            IF ( IOS .GT. 0 ) THEN
               WRITE( MESG, 94010 )
     &               'I/O error', IOS, 'reading speciation profile ' //
     &               'file at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Skip blank and comment lines
            IF ( LINE .EQ. ' ' .OR. LINE( 1:1 ) .EQ. CINVHDR ) CYCLE

C Skip all lines until the end of the header...
C Check for header start
            NDX = INDEX( LINE, HDRSTART )
            IF ( NDX .GT. 0 ) INHEADER = .TRUE.

            NDX = INDEX( LINE, HDREND )
            IF ( INHEADER ) THEN
               IF ( NDX .GT. 0 ) INHEADER = .FALSE.
               CYCLE
            ELSE IF ( NDX .GT. 0 ) THEN
               WRITE( MESG,94010 ) 'Header end found before header ' //
     &                             'started at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Skip lines that dont reference the requested speciation profile name
            IF ( LINE( 1:1 ) .EQ. '"' ) THEN
               FILE_SPPRO = LINE( 2: INDEX( LINE,'"' )-1 )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            ELSE
               FILE_SPPRO = LINE( 1: INDEX( LINE,';' )-1 )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            END IF

C Separate the line of data (record) into the segments (parse the record fields)
            CALL PARSLINE( LINE, NSEGS, SEGMENT )

C Left-justify character strings and convert factors to reals
            SPNPRF  = ADJUSTL ( SEGMENT( 1 ) )
            POLNAM  = ADJUSTL ( SEGMENT( 2 ) )
            SPECNM  = ADJUSTL ( SEGMENT( 3 ) )
            SPLTFAC = STR2REAL( SEGMENT( 4 ) )
            SDIV    = STR2REAL( SEGMENT( 5 ) )
            SMFAC   = STR2REAL( SEGMENT( 6 ) )

C Check width of character fields of fixed length
            N = LEN_TRIM( SPNPRF )
            IF ( N .GT. 16 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Speciation profile code ' //
     &                'exceeds max width of 16 characters at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

            N = LEN_TRIM( POLNAM )
            IF ( N .GT. 16 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Pollutant name ' //
     &                'exceeds max characters of 16 at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

            N = LEN_TRIM( SPECNM )
            IF ( N .GT. 16 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Species name ' //
     &                 'exceeds max characters of 16 at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Make sure divisor factor is not zero
            IF ( SDIV .EQ. 0.0 ) THEN
               WRITE( MESG,94010 ) 'ERROR: Zero divisor found at line ', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Search for pollutant in list of valid names, and go to the end of the loop if
C none found (skip entry).  Record number and position of all matches.
            M    = 0
            IPOS = 0   ! array
            DO N = 1, NSEF
               IF ( POLNAM .EQ. BIOTYPES( N ) ) THEN
                  M = M + 1
                  IF ( M .LE. MXSPPOL ) THEN
                     IPOS( M ) = N
                  ELSE      ! Max of 10 profile pollutant names per biotype
                     MESG = 'ERROR: Exceeded max pollutant names' //
     &                      'per biotype in ' // PNAME
                     CALL M3MSG2( MESG )
                     MESG = 'Quitting'
                     CALL M3MESG( MESG )
                     SUCCESS = .FALSE.; RETURN
                  END IF
               END IF
            END DO
            NIPOS = M

            IF ( MAXVAL( IPOS ) .EQ. 0 ) CYCLE

C Build unique pollutant name list (POLNAMA) from list of all profile file pollutants
            PNDX = INDEX1( POLNAM, POL, POLNAMA )

            IF ( PNDX .LE. 0 ) THEN     ! if current POLNAM is not in POLNAMA, then
               POL = POL + 1            ! increment counter, and
               POLNAMA( POL ) = POLNAM  ! add POLNAM to POLNAMA
            END IF

C Build unique species name list (SPECNMA) from list of profile file species names
            SNDX = INDEX1( SPECNM, ISP, SPECNMA )

            IF ( SNDX .LE. 0 ) THEN     ! if current SPECNM is not in SPECNMA, then
               ISP = ISP + 1
               INDX1A ( ISP ) = ISP     ! add to index
               SPECNMA( ISP ) = SPECNM  ! add SPECNM to SPECNMA

C If mole-based = mass based, then use molar transform
               IF ( SPLTFAC / SDIV .NE. SMFAC ) LMOLAR( ISP ) = .TRUE.

            END IF

C Check if species is already stored for current pollutant, and if not, increment
C species-per-pollutant counter and add species to list.
            DO M = 1, NIPOS
               K   = NSPECA( IPOS( M ) )
               NDX = INDEX1( SPECNM, K, TMPNAMES( 1,IPOS( M ) ) )
               IF ( NDX .LE. 0 ) THEN
                  K = K + 1
                  IF ( K .LE. MXSPPOL ) THEN
                     TMPNAMES( K,IPOS( M ) ) = SPECNM
                  ELSE
                     MESG = 'ERROR: Exceeded TMPNAMES dimension'
                     CALL M3MESG( MESG )
                     SUCCESS = .FALSE.; RETURN
                  END IF
                  NSPECA( IPOS( M ) ) = K
               END IF
            END DO

         END DO   ! infinite read loop

1999     CONTINUE ! end reading speciation profile input lines

         IF ( POL .EQ. 0 ) THEN
            MESG = 'ERROR: No pollutants found in speciation ' //
     &             'profiles that match the inventory!'
            CALL M3MESG( MESG )
            SUCCESS = .FALSE.; RETURN
         END IF

         IF ( ISP .EQ. 0 ) THEN
            MESG = 'ERROR: No species found in speciation profile!'
            CALL M3MESG( MESG )
            SUCCESS = .FALSE.; RETURN
         END IF

C max number of species per pollutant
         MXSPEC  = MAXVAL( NSPECA )

C Allocate memory for species names array and units to use for mole-based
C transformations.
         ALLOCATE( SPCNAMES( MXSPEC,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'SPCNAMES', PNAME )
         ALLOCATE( MOLUNITS( MXSPEC,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'MOLUNITS', PNAME )

         SPCNAMES = ' '   ! array
         MOLUNITS = ' '   ! array

C Sort master species names
         CALL SORTIC( ISP, INDX1A, SPECNMA )  ! sort on INDX1A

C Cycle through count of all valid pollutants (NSEF) and all species associated
C with these pollutants (ISP).  Check if species is valid for the current pollutant,
C and if so, store in the output species name list.
         DO I = 1, NSEF
            ICOUNT = 0
            DO J = 1, ISP
C Process species in sorted order
               K = INDX1A( J )
C Find species in list of valid species per pollutant
               NDX = INDEX1( SPECNMA( K ), NSPECA( I ), TMPNAMES( 1,I ) )
               IF ( NDX .GT. 0 ) THEN
                  ICOUNT = ICOUNT + 1
                  SPCNAMES( ICOUNT, I ) = SPECNMA( K )
C When the species does not have molar factors, store the molar units as mass units
                  IF ( LMOLAR( K ) ) THEN
                     MOLUNITS( ICOUNT, I ) = 'moles/ton'
                  ELSE
                     MOLUNITS( ICOUNT, I ) = 'g/ton'
                  END IF
               END IF
            END DO
         END DO

C Reposition sequential file for second pass

         REWIND( RDEV )

         ALLOCATE( EMSPC( MXLINES ), STAT=IOS )
         CALL CHECKMEM( IOS, 'EMSPC', PNAME )

         EMSPC = ' '   ! array initialization

#ifdef Verbose
         write( logdev,* ) '    Biogenic emissions species:'
         write( logdev,* ) '    Pol POLNAMES  Spc SPCNAMES         Mspcs EMSPC'
#endif
C Find emitted CMAQ species names
         MSPCS = 0
         DO POL = 1, NSEF
            DO ISP = 1, MXSPEC
               IF ( SPCNAMES( ISP,POL ) .EQ. ' ' ) CYCLE
               NDX = INDEX1 ( SPCNAMES( ISP,POL ), MSPCS, EMSPC ) 
               IF ( NDX .EQ. 0 ) THEN
                  MSPCS = MSPCS + 1
                  EMSPC( MSPCS ) = SPCNAMES( ISP,POL )
#ifdef Verbose
                  write( logdev,'( 5X, I3, 1X, A5, 5X, I3, 1X, A16, I4, 3X, A16 )' )
     &                   pol, biotypes( pol ), isp, spcnames( isp,pol ), mspcs,
     &                   emspc( mspcs )
               else
                  write( logdev,'( 5X, I3, 1X, A5, 5X, I3, 1X, A16 )' )
     &                   pol, biotypes( pol ), isp, spcnames( isp,pol )
#endif
               END IF
            END DO
         END DO

C Save Species names in global array for mapping emissions
         EM_FILE_SURR( IBIOSRM )%LEN = MSPCS
         ALLOCATE( EM_FILE_SURR( IBIOSRM )%ARRY ( MSPCS ) )
         ALLOCATE( EM_FILE_SURR( IBIOSRM )%UNITS( MSPCS ) )
         ALLOCATE( EM_FILE_SURR( IBIOSRM )%MW   ( MSPCS ) )
         ALLOCATE( EM_FILE_SURR( IBIOSRM )%USED ( MSPCS ) )
         ALLOCATE( EM_FILE_SURR( IBIOSRM )%CONV ( MSPCS ) )
         ALLOCATE( EM_FILE_SURR( IBIOSRM )%BASIS( MSPCS ) )

         EM_FILE_SURR( IBIOSRM )%ARRY  = EMSPC
         EM_FILE_SURR( IBIOSRM )%UNITS = 'MOLES/S'
         EM_FILE_SURR( IBIOSRM )%MW    = 1.0
         EM_FILE_SURR( IBIOSRM )%USED  = .FALSE.
         EM_FILE_SURR( IBIOSRM )%CONV  = 1.0
         EM_FILE_SURR( IBIOSRM )%BASIS = 'MOLE'

         ! Populate the Molecular Weight Field by Matching Gas Species
         ! to the CMAQ mechanism species
         DO ISP = 1,MSPCS
             INDX = INDEX1( EMSPC( ISP ), N_CGRID_SPC, CGRID_NAME )
             IF ( INDX .NE. 0 ) THEN
                 EM_FILE_SURR( IBIOSRM )%MW( ISP ) = CGRID_MW( INDX )
             ELSE
                 WRITE( MESG, '(A,A,A,A)' ) 'WARNING: BEIS emission species ',
     &               EMSPC( ISP ),' is not found in the Gas-Phase Mechanism. ',
     &               'The surrogate molecular weight will be set to 1.0'
                 CALL LOG_MESSAGE( LOGDEV, MESG )
                 EM_FILE_SURR( IBIOSRM )%MW( ISP ) = 1.0
             END IF

         END DO

C Allocate memory for storing mole- and mass-based factors
         ALLOCATE( MLFAC( MSPCS,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'MLFAC', PNAME )
         ALLOCATE( MSFAC( MSPCS,NSEF ), STAT=IOS )
         CALL CHECKMEM( IOS, 'MSFAC', PNAME )
         MLFAC = 0.0   ! array
         MSFAC = 0.0   ! array

C Read through input file to determine the total number of pollutants in the
C input file, to determine the number of profiles per pollutant, to store the
C unique species names, and to store the units for mass-based and mole-based
C conversions
         IREC = 0
         DO
            READ( RDEV, 93000, END=2999, IOSTAT=IOS ) LINE
            IREC = IREC + 1
            IF ( IOS .GT. 0 ) THEN
               WRITE( MESG, 94010 )
     &              'I/O error', IOS, 'reading speciation profile ' //
     &              'file at line', IREC
               CALL M3MESG( MESG )
               SUCCESS = .FALSE.; RETURN
            END IF

C Skip blank and comment lines
            IF ( LINE .EQ. ' ' .OR. LINE( 1:1 ) .EQ. CINVHDR ) CYCLE

C Skip lines that dont reference the requested speciation profile name
            IF ( LINE( 1:1 ) .EQ. '"' ) THEN
               FILE_SPPRO = LINE( 2: INDEX( LINE,'"' )-1 )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            ELSE
               FILE_SPPRO = LINE( 1: ( INDEX( LINE,';' )-1 ) )
               IF ( FILE_SPPRO .NE. SPPRO ) CYCLE 
            END IF

C Separate the line of data into each part
            CALL PARSLINE( LINE, NSEGS, SEGMENT )

C Left-justify character strings and convert factors to reals
            SPNPRF  = ADJUSTL ( SEGMENT( 1 ) )
            POLNAM  = ADJUSTL ( SEGMENT( 2 ) )
            SPECNM  = ADJUSTL ( SEGMENT( 3 ) )
            SPLTFAC = STR2REAL( SEGMENT( 4 ) )
            SDIV    = STR2REAL( SEGMENT( 5 ) )
            SMFAC   = STR2REAL( SEGMENT( 6 ) )

C Search for pollutant in list of valid names, and go to the end of the loop if
C not found (skip entry)
            PNDX = INDEX1( POLNAM, NSEF, BIOTYPES )
            IF ( PNDX .EQ. 0 ) CYCLE
            SNDX = INDEX1( SPECNM, MSPCS, EMSPC )
            IF ( SNDX .GT. 0 ) THEN
               MLFAC( SNDX,PNDX ) = SPLTFAC / SDIV
               MSFAC( SNDX,PNDX ) = SMFAC
            END IF

         END DO   ! infinite read loop

2999     CONTINUE ! end reading speciation profile input lines

         RETURN

C-----------------------------------------------------------------------

93000    FORMAT( A )
94010    FORMAT( 10( A, :, I8, :, 1X ) )

         END FUNCTION BIOG_INIT

      END MODULE BIOG_EMIS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/beis3.f,v 1.2 2011/10/21 16:10:17 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE BEIS3( JDATE, JTIME, NX, NY, MSPCS, SEMIS,
     &                  SLAI, BIPOL )

C-----------------------------------------------------------------------
C Description:
 
C   Uses PAR and sfc temperature data to calculate
C   biogenic ISOP and MBO emissions.  Other emissions are
C   calculated using the temperature data only.
 
C Preconditions:
C   PAR and Surface Temperature
 
C Subroutines and Functions Called:
 
C Revision History:
C   4/01 : Prototype by JMV
C   6/05 : updates for BEIS3.3 by D. Schwede (BEIS3.13)
C   8/05 : additional diagnostic messages for PAR out of bounds (G. Pouliot)
C  10/06 : yoj
C   1/10 : yoj remove ck & report if TAIR > 315
C   7/14 : JOB added leaf temperature and two layer canopy model
C  11/07 : JOB updated for ASX_DATA_MOD and corrected the Cl algorithm 
C          to be consitent with Gunther et al. 1999 doi:10.1029/1999JD900391
C  5/7/18: D. Schwede Removed call to CZANGLE. COSZEN now calculated in ASX_DATA_MOD
C-----------------------------------------------------------------------
C Modified from:

C Project Title: Sparse Matrix Operator Kernel Emissions (SMOKE) Modeling
C              System
C File: @(#)$Id: beis3.f,v 1.2 2011/10/21 16:10:17 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/beis3.f,v $
C Last updated: $Date: 2011/10/21 16:10:17 $
C-----------------------------------------------------------------------

      USE BIOG_EMIS, ONLY: NSEF, NLAI, LAITYPES
      Use ASX_DATA_MOD

      IMPLICIT NONE
C Includes:

C Arguments:
      INTEGER, INTENT( IN ) :: JDATE   ! current simulation date (YYYYDDD)
      INTEGER, INTENT( IN ) :: JTIME   ! current simulation time (HHMMSS)
      INTEGER, INTENT( IN ) :: NX      ! no. columns
      INTEGER, INTENT( IN ) :: NY      ! no. rows
      INTEGER, INTENT( IN ) :: MSPCS   ! no. of output species

!     REAL,    INTENT( IN ) :: COSZEN( NX,NY )        ! cosine of zenith angle
!     REAL,    INTENT( IN ) :: SEMIS ( NX,NY,NSEF-1 ) ! normalized emissions
!     REAL,    INTENT( IN ) :: SLAI  ( NX,NY,NLAI )   ! leaf area indices
!     REAL,    INTENT( OUT ) :: BIPOL( NX,NY,NSEF-1 ) ! output emissions

      REAL,    INTENT( IN ) :: SEMIS ( :,:,: ) ! normalized emissions
      REAL,    INTENT( IN ) :: SLAI  ( :,:,: )   ! leaf area indices
      REAL,    INTENT( OUT ) :: BIPOL( :,:,: ) ! output emissions

C Local Variables:
      INTEGER        R, C, L, I   ! counters

      REAL           CFOTHR       ! isop corr fac -- non-forest
      REAL           CFCLAI       ! isop corr fac -- LAI
      REAL           CFNO         ! NO correction factor
      REAL           CFOVOC       ! non-isop corr fac
      REAL           CFSESQT      ! sesquiterpene corr fac
      REAL           PAR          ! photo. actinic flux (UE/M**2-S) (UE=micro-einsteins)
      REAL           CT_SUN       ! temperature correction
      REAL           DT_SUN       ! temperature correction
      REAL           CT_SHADE     ! temperature correction       
      REAL           DT_SHADE     ! temperature correction      
      REAL           TAIR         ! local 2 meter temperature
      REAL           DTLEAF_SUN   ! Difference between mean canopy leaf and ambient temperature [K]
      REAL           DTLEAF_SHADE ! Difference between mean canopy leaf and ambient temperature [K]      
      REAL           TLEAF_SUN    ! Mean canopy leaf temperature [K]
      REAL           TLEAF_SHADE  ! Mean canopy leaf temperature [K]
      REAL           RBW          ! Quasi-laminar boundary layer resistance for water vapor [s/m]
      REAL           RBH          ! Quasi-laminar boundary layer resistance for heat [s/m]     
      REAL           RH           ! Relative humidity [ratio 0-1]
      REAL           ES           ! Saturation vapor pressure for 2 meter T  [Pa]          
      REAL           SHF          ! Soil heat flux [W/m**2]    
      REAL           DVAP         ! vapor pressure deficit [Pa/Pa]  
      REAL           SSVP         ! Slope of the saturation vapor pressure curve over P [1/K] 
      REAL           GVAP         ! canopy water vapor conuctance m/s
      REAL           GHT          ! canopy heat conductance m/s      
      REAL           CPAIR        ! specific heat of air
      REAL           LHV          ! Latent heat of vaporization       
      REAL           CPOT         ! potential temperature conversion 
      REAL           DENS         ! Dry air density kg/m**3
      REAL           LHSH_DIV     ! W/m**2 to K units conversion 
      REAL           LHSH_COMP    ! latent/sensible heat flux component of leaf energy bal
      REAL           RK           ! k from Geron and Guenther
      REAL           CSUBL_SUN    ! C sub l
      REAL           CSUBL_SHADE  ! C sub l
      REAL           FRACSUN      ! Fraction sun
      REAL           FRACSHADE    ! Fraction shade            
      REAL           TLAI         ! local LAI
      REAL           SOLRAD       ! local solar radiation [W/m**2]
      REAL           PSFC         ! local sfc pressure (mb)
      REAL           ZEN          ! zenith angle
      REAL           PARDB        ! PAR direct beam
      REAL           PARDIF       ! PAR diffuse
      REAL           COSZ         ! local cosine of zenith angle
      
      REAL, PARAMETER :: CV     = 8.0e-6  ! Resistance to soil heat conductance under vegetation [s/m]
      REAL, PARAMETER :: RRAD   = 230.0   ! Atmospheric radiative resistance Monteith 1973 [s/m]
      REAL, PARAMETER :: SCW    = KVIS / DWAT ! schmidt number for water vapor
      REAL, PARAMETER :: REFLDV = 0.057 ! visible light reflection coefficient from MEGAN 2.10 

      CHARACTER( 5 )   :: BTMP    ! temporary variable name
      CHARACTER( 256 ) :: MESG    ! message buffer

      CHARACTER( 16 )  :: PROCNAME = 'BEIS3'   ! procedure name

C-----------------------------------------------------------------------
      
C Loop through cells
      DO R = 1, NY
         DO C = 1, NX

            TAIR = MET_DATA%TEMP2( C,R )         ! unit in degree K
            COSZ = MET_DATA%COSZEN( C,R )            

C Check min bounds for temperature
C Note we no longer cap temperature for isoprene
            IF ( TAIR .LT. 200.0 ) THEN
               WRITE( MESG, 94010 ) 'TAIR=', TAIR,
     &              'out of range at (C,R)=', C, R
               CALL M3EXIT( PROCNAME, JDATE, JTIME, MESG, 2 )
            END IF

            SOLRAD = MET_DATA%RGRND( C,R )

C Cosine of zenith angle to zenith angle (radians)
            ZEN =  ACOS( COSZ )
            PSFC = MET_DATA%PRSFC( C,R )
    
C atmospheric water vapor variables used for leaf latent heat flux
            IF ( TAIR .LE. STDTEMP ) THEN
               ES = VP0 * EXP( 22.514 - (6.15e3 / TAIR) )
            ELSE
               ES = VP0 * EXP( SVP2 * (TAIR - STDTEMP) /
     &                                (TAIR - SVP3) )
            END IF
            RH   = MET_DATA%RH2( C,R ) / 100.0
            DVAP = ES*(1.0-RH)/PSFC
            SSVP = (SVP2*(STDTEMP-SVP3)*ES/(TAIR-SVP3)**2)/
     &              PSFC

C calculate the soil heaf flux under a canopy folowing WRF3.4.1 PX
            SHF = -2.0*PI/SIDAY*(MET_DATA%TEMPG( C,R ) - TAIR)/CV

C calculate the heat and water vapor quasilaminar boundary layer resistance
            RBH = 5.0/MET_DATA%USTAR( C,R )
            RBW = RBH*(SCW/PR)**TWOTHIRDS
   
C calculate the specific heat of air and latent heat of vaporization
            CPAIR = CPD * (1.0 + 0.84 * MET_DATA%Q2( C,R ))
            LHV   = LV0 - 2370.0 * (TAIR - STDTEMP)

C calculate the leaf  water vapor and heat conductance 
            GHT  = 1 / (MET_DATA%RA( C,R ) + RBH  ) + 1/RRAD
            GVAP = 1 / (MET_DATA%RA( C,R ) + RBW + MET_DATA%RS( C,R ) * MET_DATA%LAI( C,R ))

C Calculate the potential temperature conversion from the sensible heat flux in WRF 3.4.1
            CPOT = (STDATMPA/PSFC)**(RDGAS/CPAIR)

C Calculate the solar radiation and soil heat flux of the leaf energy budget
            DENS     =  PSFC /( RDGAS * TAIR )
            LHSH_DIV =  DENS * CPOT * CPAIR * (GHT + 1 / (MET_DATA%RA( C,R ) + RBH  )) + 
     &                  DENS * LHV * SSVP * GVAP

C calculate the latent heat flux portion of the leaf energy budget 
            LHSH_COMP = SHF - LHV * DENS * GVAP * ( ES - RH * ES) / PSFC

C Direct and diffuse photosynthetically active radiation
            CALL GETPARB( SOLRAD, PSFC, COSZ, PARDB, PARDIF )

            PAR = PARDB + PARDIF

C Check max/min bounds of PAR and calculate biogenic ISOP
            IF ( PAR .LT. 0.0 .OR. PAR .GT. 2600.0 ) THEN
               
               WRITE( MESG, 94030 ) 'PAR=', PAR,
     &              'out of range at (C,R)=', C, R,
     &              'PARDB  = ', PARDB,
     &              'PARDIF = ', PARDIF,
     &              'SOLRAD = ', SOLRAD,
     &              'PSFC   = ', PSFC,
     &              'ZEN    = ', ZEN
    
                CALL M3MSG2( MESG )
            END IF

C Compute ISOP and MBO and METH emissions first
C Note assumption that these are the first 3 species in LAITYPE and BIOTYPE
C arrays
            DO I = 1, NLAI

               BTMP = LAITYPES( I )
               TLAI = SLAI( C,R,I ) 

C Adjust methanol based on T. Pierce recommendation (1-16-03)
               IF ( BTMP == 'METH' ) THEN
                  TLAI = MAX( 3.0, TLAI )
               END IF

               IF ( TLAI .GT. 10.0 ) THEN
                  WRITE( MESG, 94010 ) 'LAI=', TLAI,
     &              'out of range at (C,R)=', C, R
                  CALL M3EXIT( PROCNAME, JDATE, JTIME, MESG, 2 )
               END IF

C Initialize csubl
               CSUBL_SUN   = 0.0
               CSUBL_SHADE = 0.0       

               IF ( PARDB + PARDIF .EQ. 0.0 ) THEN
                  BIPOL( C,R,I ) = 0.0
               ELSE
                  CALL CLNEW_SUB( ZEN, PARDB, PARDIF, TLAI, LHSH_DIV,
     &                            LHSH_COMP, DTLEAF_SUN, DTLEAF_SHADE, 
     &                            CSUBL_SUN, CSUBL_SHADE, FRACSUN, FRACSHADE,
     &                            SOLRAD, REFLDV )

                  TLEAF_SUN   = DTLEAF_SUN   + TAIR
                  TLEAF_SHADE = DTLEAF_SHADE + TAIR
C Calculate temperature correction term
                  DT_SUN   = 28668.514 / TLEAF_SUN
                  DT_SHADE = 28668.514 / TLEAF_SHADE 
                  CT_SUN   = EXP( 37.711 - 0.398570815 * DT_SUN ) /
     &                          ( 1.0 + EXP( 91.301 - DT_SUN ) )
                  CT_SHADE = EXP( 37.711 - 0.398570815 * DT_SHADE ) /
     &                          ( 1.0 + EXP( 91.301 - DT_SHADE ) )     
                  BIPOL( C,R,I ) = SEMIS( C,R,I )*( FRACSUN   * CT_SUN   * CSUBL_SUN + 
     &                                              FRACSHADE * CT_SHADE * CSUBL_SHADE )
               END IF

            END DO ! end ISOP and MBO calculations loop

            CALL CLNEW_SUB( ZEN, PARDB, PARDIF, MET_DATA%LAI( C,R ), LHSH_DIV,
     &                      LHSH_COMP, DTLEAF_SUN, DTLEAF_SHADE, 
     &                      CSUBL_SUN, CSUBL_SHADE, FRACSUN, FRACSHADE,
     &                      SOLRAD, REFLDV )
     
            TLEAF_SUN   = TAIR + DTLEAF_SUN
            TLEAF_SHADE = TAIR + DTLEAF_SHADE
C Calculate other biogenic emissions except NO
C Note not speciated here
C Limit temerature to 315 K for monoterpenes and other VOCs
            TLEAF_SUN   = MIN( TLEAF_SUN, 315.0 )
            TLEAF_SHADE = MIN( TLEAF_SHADE, 315.0 )    

            CFOVOC  = FRACSUN   * EXP( 0.09 * ( TLEAF_SUN   - 303.0 ) ) + 
     &                FRACSHADE * EXP( 0.09 * ( TLEAF_SHADE - 303.0 ) ) 
            CFSESQT = FRACSUN   * EXP( 0.17 * ( TLEAF_SUN   - 303.0 ) ) + 
     &                FRACSHADE * EXP( 0.17 * ( TLEAF_SHADE - 303.0 ) )

            DO I = NLAI + 1, NSEF - 2
               BIPOL( C,R,I ) = SEMIS( C,R,I ) * CFOVOC
            END DO

            I = NSEF - 1
            BIPOL( C,R,I ) = SEMIS( C,R,I ) * CFSESQT

         END DO ! end loop over columns
      END DO ! end loop over rows

      RETURN

C-----------------------------------------------------------------------

94010 FORMAT( 1X, A, F10.2, 1X, A, I3, ',', I3 )
94020 FORMAT( 1X, A, F10.2, 1X, A, I3, ',', I3, A )
94030 FORMAT( 1X, A, F10.2, 1X, A, I3, ',', I3, 1X, 5(A, F10.2) )

C-----------------------------------------------------------------------
      CONTAINS

C Function to calculate csubl based on zenith angle, par, and lai
         SUBROUTINE CLNEW_SUB( ZEN, PARDB, PARDIF, TLAI, LHSH_DIV,
     &                              LHSH_COMP, DTLSUN, DTLSHADE, 
     &                              CSUBL_SUN, CSUBL_SHADE, FRACSUN, FRACSHADE,
     &                              SOLRAD, REFLDV )

         IMPLICIT NONE

C Function arguments:
         REAL, INTENT( IN )  :: PARDB    ! direct beam PAR( umol/m2-s)
         REAL, INTENT( IN )  :: PARDIF   ! diffuse PAR ( umol/m2-s)
         REAL, INTENT( IN )  :: ZEN      ! solar zenith angle (radians)
         REAL, INTENT( IN )  :: TLAI     ! leaf area index for grid cell
         REAL, INTENT( IN )  :: LHSH_DIV  
         REAL, INTENT( IN )  :: LHSH_COMP
         REAL, INTENT( IN )  :: SOLRAD
         REAL, INTENT( IN )  :: REFLDV
         REAL, INTENT( OUT ) :: CSUBL_SUN
         REAL, INTENT( OUT ) :: CSUBL_SHADE
         REAL, INTENT( OUT ) :: DTLSUN           ! Sun leaf temperature [K]
         REAL, INTENT( OUT ) :: DTLSHADE         ! Sun leaf temperature [K]
         REAL, INTENT( OUT ) :: FRACSUN          ! fraction of leaves that are sunlit
         REAL, INTENT( OUT ) :: FRACSHADE        ! fraction of leaves that are shaded

C Parameters:
         REAL, PARAMETER :: ALPHA = 0.8 ! leaf absorptivity
         REAL, PARAMETER :: KD = 0.68   ! extinction coefficient for diffuse radiation
         
         
C Local variables:
         REAL, SAVE :: SQALPHA ! square root of alpha
         REAL KBE              ! extinction coefficient for direct beam
         REAL CANPARSCAT       ! exponentially wtd scattered PAR (umol/m2-s)
         REAL CANPARDIF_SUN    ! exponentially wtd diffuse PAR at the top of the canopy (umol/m2-s)
         REAL CANPARDIF_SHADE  ! exponentially wtd diffuse PAR in the shaded part of the canopy (umol/m2-s)
         REAL PARSHADE         ! PAR on shaded leaves (umol/m2-s)
         REAL PARSUN           ! PAR on sunlit leaves (umol/m2-s)
         REAL SOLSUN           ! RS transmitted to sunlit leaves W/m**2
         REAL SOLSHADE         ! RS transmitted to shaded leaves W/m**2
         REAL LAISUN           ! LAI that is sunlit
         REAL LAISHADE         ! LAI that is shaded


         LOGICAL, SAVE :: FIRSTIME = .TRUE.

C-----------------------------------------------------------------------
         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            SQALPHA = SQRT( ALPHA )
         END IF
C CN98 - eqn 15.4, assume x=1 (can use a table or atributes to change this)
C Set a ceiling for KBE to prevent a blow up at high zenith angles. This has
C little impact on the results because direct PAR is low under these conditions
         IF( ZEN .GE. 1.57 ) THEN
            KBE = 627.9
         ELSE
            KBE = 0.5 * SQRT( 1.0 + TAN( ZEN )**2 )
         END IF
         IF ( TLAI .GT. 0.1 ) THEN
            IF ( PARDB + PARDIF .GT. 0.0 ) THEN

C CN98 p-259 Sun and shaded areas of the canopy
               LAISUN     = ( 1.0 - EXP( -1.0 * KBE * TLAI ) ) / KBE
               LAISHADE   = MAX( TLAI - LAISUN, 0.0 )
               FRACSUN    = LAISUN / TLAI             
               FRACSHADE  = 1.0 - FRACSUN

C CN98 - p. 261 (this is usually small)
               CANPARSCAT = 0.5 * PARDB * ( EXP( -1.0 * SQALPHA * KBE * TLAI )
     &                    - EXP( -1.0 * KBE * TLAI ) )

C CN98 - p. 261 (assume exponentially wtd avg)
               CANPARDIF_SUN    = PARDIF * ( 1.0 - EXP( -1.0 * SQALPHA * KD * LAISUN ) )
     &                                   / ( SQALPHA * KD * LAISUN )

               CANPARDIF_SHADE  = CANPARDIF_SUN * ( EXP( -1.0 * SQALPHA * KD * LAISUN ) 
     &                                            - EXP( -1.0 * SQALPHA * KD * TLAI ) )
     &                                   / ( SQALPHA * KD * (TLAI - LAISUN) )

C CN98 - p. 261 (for next 3 eqns)
C note that we use the incoming (not absorbed) PAR
               PARSHADE   = CANPARDIF_SHADE + CANPARSCAT
               PARSUN     = KBE * PARDB + CANPARDIF_SUN + CANPARSCAT
     
C calculate the leaf temperature following Campbel and Norman 1998 eq 14.6 
C with the addition of incomming atmospheric long wave irradiation resulting 
C in the cacelation of the long wave radiation budget
         
               SOLSUN    = SOLRAD * PARSUN / ( PARDB + PARDIF )
               SOLSHADE  = SOLRAD * PARSHADE / ( PARDB + PARDIF )
               DTLSUN    = ((1.0 - REFLDV) * SOLSUN + LHSH_COMP ) / LHSH_DIV
               DTLSHADE  = ((1.0 - REFLDV) * SOLSHADE + LHSH_COMP ) / LHSH_DIV
               DTLSUN    = MIN(DTLSUN,  10.0) 
               DTLSUN    = MAX(DTLSUN, -10.0) 
               DTLSHADE  = MIN(DTLSHADE,  10.0) 
               DTLSHADE  = MAX(DTLSHADE, -10.0) 

C cguen is Guenther's eqn for computing light correction as a function of
C PAR...fracSun should probably be higher since sunlit leaves tend to be
C thicker than shaded leaves. But since we need to make crude assumptions
C regarding leaf orientation (x=1), we will not attempt to fix at the moment.

               CSUBL_SUN   = CGUEN( PARDB + PARDIF, 0.0, LAISUN, KBE )
               CSUBL_SHADE = CGUEN( PARDB + PARDIF, LAISUN, TLAI, KBE )
            
            ELSE ! to prevent divide by 0 when there is no solar rad
               CSUBL_SUN   = 0.0
               CSUBL_SHADE = 0.0
               FRACSUN     = 0.2
               FRACSHADE   = 0.8
               DTLSUN      = LHSH_COMP / LHSH_DIV
               DTLSHADE    = LHSH_COMP / LHSH_DIV
               DTLSUN      = MIN(DTLSUN,  10.0) 
               DTLSUN      = MAX(DTLSUN, -10.0) 
               DTLSHADE    = MIN(DTLSHADE,  10.0) 
               DTLSHADE    = MAX(DTLSHADE, -10.0) 
            END IF       
    
         ELSE 
            CSUBL_SUN   = CGUEN( PARDB + PARDIF, 0.0, TLAI, KBE )
            CSUBL_SHADE = 0.0
            FRACSUN     = 1.0
            FRACSHADE   = 0.0
            DTLSUN      = ((1.0 - REFLDV) * SOLRAD + LHSH_COMP ) / LHSH_DIV
            DTLSHADE    = 0.0
            DTLSUN      = MIN(DTLSUN,  10.0) 
            DTLSUN      = MAX(DTLSUN, -10.0)      
         END IF

         END SUBROUTINE CLNEW_SUB

C-----------------------------------------------------------------------

C Function to calculate Guenther's equation for computing light correction
         REAL FUNCTION CGUEN( PAR, LAI1, LAI2, KBE )

C 11/14 J. Bash - Updated to Niinemets et al. 2010 doi:10.1029/2010JG001436 
C                 Big leaf model which updates Guenther et al. 1993 doi:10.1029/93JD00527 for 
C                 in-canopy gradients

         IMPLICIT NONE

C Function arguments:
         REAL, INTENT( IN ) :: PAR
         REAL, INTENT( IN ) :: LAI1 ! top of the layer LAI
         REAL, INTENT( IN ) :: LAI2 ! bottom of the layer LAI
         REAL, INTENT( IN ) :: KBE  ! light extenction coefficient

C Parameters:
         REAL, PARAMETER :: ALPHA = 0.0027 ! Guenther et al. 1993
         REAL, PARAMETER :: CL    = 1.066  ! Guenther et al. 1993

C-----------------------------------------------------------------------
         IF ( PAR .LE. 0.01 ) THEN
            CGUEN = 0.0
         ELSE
C Niinemets et al. 2010 equation A9 integrated from LAI1 to LAI2
            CGUEN = CL * ( SQRT(1+ALPHA**2 * PAR**2 * EXP(-2*LAI1*KBE)) -
     &                     SQRT(1+ALPHA**2 * PAR**2 * EXP(-2*LAI2*KBE)) ) /
     &                   ( ALPHA * KBE * PAR )
         END IF

         RETURN

         END FUNCTION CGUEN

C-----------------------------------------------------------------------

      END SUBROUTINE BEIS3

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      MODULE DEGRADE_SETUP_TOX
C**********************************************************************
C
C  FUNCTION:  Define arrays that identify species within CGRID used
C             based on input arrays
C
C  REVISION HISTORY: 07/29/05 : B.Hutzell - Initial version
C                    06 May 11: B.Hutzell: convert for Namelist redesign
C                    09 May 11: B.Hutzell: enabled a degraded species to
C                               be missing from namelists
C
C**********************************************************************

      USE CGRID_SPCS   ! CGRID species number and offsets
      USE UTILIO_DEFN  ! IOAPI declarations and definitions


      IMPLICIT NONE

C.....INCLUDES:

      INCLUDE SUBST_CONST         ! constants

C..declare and define variables used by maps and data

      INTEGER, PARAMETER :: N_REACT      = 30    ! number of  species being degraded
      INTEGER, PARAMETER :: N_UNI_LOSS   = 1     ! Number of Unimolecular Loss Processes
      INTEGER, PARAMETER :: N_BI_LOSS    = 5     ! Number of Bimolcular Loss processes
      INTEGER, PARAMETER :: N_TRI_LOSS   = 2     ! Number of Bimolcular Loss processes
      INTEGER, PARAMETER :: N_PHOTO_LOSS = 2     ! Number of Photolysis Loss processes

! Total number of Loss processes      
      INTEGER, PARAMETER :: N_PROCESSES  = N_UNI_LOSS
     &                                   + N_BI_LOSS
     &                                   + N_PHOTO_LOSS
     &                                   + N_TRI_LOSS

      CHARACTER(16), PARAMETER :: BLANK = ' '  ! default value for characters

      INTEGER, SAVE :: N_PHOTO_TAB    ! Number of photolysis rates in mechanism
      INTEGER, SAVE :: N_REACT_FOUND  ! Number ofreact species found in namelists

C..looping data

      INTEGER :: UNI_START
      INTEGER :: BI_START
      INTEGER :: TRI_START
      INTEGER :: PHOTO_START

      INTEGER :: UNI_STOP
      INTEGER :: BI_STOP
      INTEGER :: TRI_STOP
      INTEGER :: PHOTO_STOP

      CHARACTER(16), ALLOCATABLE :: REACT( : )         ! names of species being degraded
      CHARACTER(16), ALLOCATABLE :: BICAUSE( :,: )     ! species name that cause degradation
      CHARACTER(16), ALLOCATABLE :: TRICAUSE( :,:,: )  ! species name that cause degradation
      CHARACTER(16), ALLOCATABLE :: PHOTO_NAME( :,: )  ! name of photolysis rate for react(i)

      CHARACTER(16), ALLOCATABLE :: BI_PROD   ( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: TRI_PROD  ( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: PHOTO_PROD( :,: )  ! name of daughter product for react(i)
      CHARACTER(16), ALLOCATABLE :: UNI_PROD  ( :,: )  ! name of daughter product for react(i)

      REAL(8), ALLOCATABLE :: UNIRATE  ( :,: ) ! rate for unimolecular decay for react(i) [molecules/sec^1]
      REAL(8), ALLOCATABLE :: UNI_ACT  ( :,: ) ! activation energy for UNIRATE(I) [K]. Positive if exothermic
      REAL(8), ALLOCATABLE :: UNI_TEXP ( :,: ) ! exponent of Temperature
      REAL,    ALLOCATABLE :: UNI_YIELD( :,: ) ! production yield

      REAL(8), ALLOCATABLE :: BIRATE  ( :,: )  ! degradation rates for bimolecular reactions,  [cm^3/(sec*molecules)]
      REAL(8), ALLOCATABLE :: BI_ACT  ( :,: )  ! activation energy for BIRATE(I) [K]. Positive if exothermic
      REAL(8), ALLOCATABLE :: BI_TEXP ( :,: )  ! exponent of Temperature
      REAL,    ALLOCATABLE :: BI_YIELD( :,: )  ! production yield

      REAL(8), ALLOCATABLE :: TRIRATE  ( :,: ) ! degradation rates for trimolecular reactions,  [cm^3/(sec*molecules)]
      REAL(8), ALLOCATABLE :: TRI_ACT  ( :,: ) ! activation energy for TRIRATE(I) [K]. Positive if exothermic
      REAL(8), ALLOCATABLE :: TRI_TEXP ( :,: ) ! exponent of Temperature
      REAL,    ALLOCATABLE :: TRI_YIELD( :,: ) ! production yield

      REAL(8), ALLOCATABLE :: A_PHOTO    ( :,: ) ! multiplier of photolysis rates
      REAL,    ALLOCATABLE :: PHOTO_YIELD( :,: ) ! production yield

      REAL(8), ALLOCATABLE :: RATE_CONST( :,: )
      REAL(8), ALLOCATABLE :: RATE_YIELD( :,: )

      REAL(8)              :: EFFECTIVE_ZERO

C..arrays to store indices to CGRID

      INTEGER, ALLOCATABLE :: RXTANT_MAP( : )
      INTEGER, ALLOCATABLE :: PROD_MAP( :,: )
      INTEGER, ALLOCATABLE :: RAD_MAP( :,: )
      INTEGER, ALLOCATABLE :: RAD2_MAP( :,:,: )
      INTEGER, ALLOCATABLE :: PHOTO_MAP( :,: )

C..saved cell concentrations

      REAL( 8 ), ALLOCATABLE :: PREV_CONC( : )
      REAL( 8 ), ALLOCATABLE :: CURR_CONC( : )
      REAL( 8 )              :: TEMP                ! cell temperature [ K ]
      REAL( 8 )               :: NUMB_DENS           ! cell air number density [ 1/CM^3 ]

      REAL(8), ALLOCATABLE :: DELT_CONC( : )   ! changes predicted by degrade routine

C**********************************************************************

      CONTAINS
      

         SUBROUTINE DEGRADE_MAP( JDATE, JTIME )
C**********************************************************************
C
C  Function:  Determine CGRID indices used in DEGRADE routine.
C             Check decay and degradation rates for negative values.
C
C  CALLED BY: INIT_DEGRADE
C
C**********************************************************************

         USE RXNS_DATA

         IMPLICIT NONE

C.....INCLUDES:


C.....ARGUMENTS:

         INTEGER, INTENT( IN ) :: JDATE        ! current model date , coded YYYYDDD
         INTEGER, INTENT( IN ) :: JTIME        ! current model time , coded HHMMSS

C.....PARAMETERS:

         REAL(8), PARAMETER :: TEMP_298K  = 298.15        ! K

C.....LOCAL VARIABLES:

         CHARACTER(  16 ) :: PNAME =  'DEGRADE_MAP    '     ! name of routine
         CHARACTER(  16 ) :: EMTPTY
         CHARACTER(  16 ) :: WNAME                          ! SCRATCH variable
         CHARACTER(  16 ) :: VNAME( N_PROCESSES+1 )         ! SCRATCH variable
         CHARACTER( 128 ) :: XMSG = 'FATAL ERROR in DEGRADE_SETUP'

         INTEGER :: MARKER, N, M       ! indexes
         INTEGER :: I, J, K            ! loop counters
         INTEGER :: LEN_NAME           ! number of nonblank characters in species name

         REAL(8) :: INV_T298K = 1.0D0 / TEMP_298K   ! K^-1

C.....EXTERNAL FUNCTIONS:

C**********************************************************************

C..save number of photolysis rates in mechanism

         N_PHOTO_TAB = NPHOTAB

C..Quality control on pairs of Reactant and Products

         WRITE( LOGDEV,* ) 'Comments on Species in degradation routines'

         N_REACT_FOUND = 0

         LOOP_REACT : DO I = 1, N_REACT

            VNAME( 1 ) = REACT( I )

            VNAME( UNI_START+1  :  UNI_STOP+1 ) = UNI_PROD  ( I, 1:N_UNI_LOSS )
            VNAME( BI_START+1   :   BI_STOP+1 ) = BI_PROD   ( I, 1:N_BI_LOSS  )
            VNAME( TRI_START+1  :  TRI_STOP+1 ) = TRI_PROD  ( I, 1:N_TRI_LOSS )
            VNAME( PHOTO_START+1:PHOTO_STOP+1 ) = PHOTO_PROD( I, 1:N_PHOTO_LOSS )

            RATE_YIELD( I,   UNI_START:UNI_STOP   ) = UNI_YIELD  ( I, 1:N_UNI_LOSS )
            RATE_YIELD( I,    BI_START:BI_STOP    ) = BI_YIELD   ( I, 1:N_BI_LOSS  )
            RATE_YIELD( I,   TRI_START:TRI_STOP   ) = TRI_YIELD  ( I, 1:N_TRI_LOSS )
            RATE_YIELD( I, PHOTO_START:PHOTO_STOP ) = PHOTO_YIELD( I, 1:N_PHOTO_LOSS )

            CALL UPCASE( VNAME( 1 ) )

            LEN_NAME = LEN_TRIM( VNAME( 1 ) )

            IF ( LEN_NAME < 1 ) THEN
               WRITE( LOGDEV,* ) 'A Reactant has no name.'
     &              // ' Check file degrade module'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
            ENDIF

            DO K = 1, N_BI_LOSS
               IF ( VNAME( 1 ) == BICAUSE( I, K ) ) THEN
                  WRITE( LOGDEV,* ) 'WARNING: ',
     &                 VNAME( 1 )( 1:LEN_NAME ), ' is',
     &                 ' same as a species causing bimolecular degradation, hence'
     &                 // ' brakes linear assumptions '
               ENDIF
            ENDDO

            DO K = 1, N_TRI_LOSS
               IF ( VNAME( 1 ) == TRICAUSE( I, K, 1 ) .OR.
     &              VNAME( 1 ) == TRICAUSE( I, K, 2 ) ) THEN
                  WRITE( LOGDEV,* ) 'WARNING: ',
     &                 VNAME( 1 )( 1:LEN_NAME ), ' is same as',
     &                 ' a species causing trimolecular degradation,'
     &                 // ' hence brakes linear assumptions '
               ENDIF
            ENDDO

            DO J = 1, N_PROCESSES

               WNAME = VNAME( J + 1 )
               CALL UPCASE( WNAME )
               LEN_NAME = LEN_TRIM( WNAME )

               IF ( VNAME( 1 ) == WNAME ) THEN
                 WRITE( LOGDEV,* ) 'Warning: ', WNAME( 1:LEN_NAME ),
     &                ' and its parent share the same name.'
               ENDIF

            ENDDO

C..Set up indices that point to concentrations in CGRID.

            DO 20 J = 1, N_PROCESSES+1

               WNAME = VNAME( J )      ! note that reactant occupies VNAME(1)
               LEN_NAME = LEN_TRIM( WNAME )
               CALL UPCASE( WNAME )

               IF ( LEN_NAME > 0 ) THEN ! search gas species for index
                  N = INDEX1( WNAME, N_GC_SPC, GC_SPC )
                  MARKER = GC_STRT

                  IF ( N == 0 ) THEN  ! search non-reactive species for index
                     N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                     MARKER = NR_STRT
                     IF ( N == 0 ) THEN
#ifdef verbose_gas                     
                        WRITE( LOGDEV,'(a)' ) TRIM( WNAME ), ' is not '
     &                       // 'in gas or nonreactive species table.'
     &                       // 'its loss processes not calculated '
#endif                        
                        RXTANT_MAP( I ) = -1
                        CYCLE
                     ENDIF
                  ENDIF
         
                  N_REACT_FOUND = N_REACT_FOUND + 1

               ELSE
                  VNAME( J ) = 'NONE'
                  CYCLE
               ENDIF

C..write degrade data table

               IF ( N_REACT_FOUND == 1 ) THEN
                  WRITE( LOGDEV,* ) 'TABLE on Degradation Simulated.'
                  WRITE( LOGDEV,* ) 'Note: Rates use units of cm, sec, and molecules.'
                  WRITE( LOGDEV,* )
                  WRITE( LOGDEV,1600 )
               ENDIF

C..set map values

               IF ( J < 2 ) THEN
                  RXTANT_MAP( I ) = N + MARKER - 1
               ELSE
                  PROD_MAP( I, J-1 ) = N + MARKER - 1
               ENDIF

20          CONTINUE

C..cycle N_REACT LOOP

           IF( RXTANT_MAP( I ) .LT. 1 )CYCLE LOOP_REACT

C..check UNIMOLECULAR decay rates

            K = 0

            DO J = 1, N_UNI_LOSS

               IF ( UNIRATE( I, J ) < 0.0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), ' has a'
     &                 // 'negative rate for unimolecular decay.'
     &                 // 'Check degrade module'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               WRITE( LOGDEV,1100 ) VNAME( 1 ), RXTANT_MAP( I ),
     &              ' Unimolecular ',
     &              UNIRATE( I, J ) * TEMP_298K**UNI_TEXP( I, J )
     &              * EXP( -UNI_ACT( I, J ) * INV_T298K ),
     &              VNAME( J+1 ), PROD_MAP( I, J )

            ENDDO

            K = K + N_UNI_LOSS

C..locating degradation causes in CGRID

            DO 40 J = 1, N_BI_LOSS

C..checking degradation rates

               IF ( BIRATE( I, J ) < 0.0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), 'has a negative'
     &                 // ' rate for degradation by ', WNAME( 1:LEN_NAME ), '.'
     &                 // ' Check degrade module.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               WNAME = BICAUSE( I, J )

               CALL UPCASE( WNAME )

               LEN_NAME = LEN_TRIM( WNAME )

               IF ( LEN_NAME < 1 ) CYCLE

               IF ( WNAME == 'DENSITY' ) THEN      ! special case rate proportion to air density
                  RAD_MAP( I, J ) = 9999
                  WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' Bimolecular ', WNAME, RAD_MAP( I, J ),
     &                 BIRATE( I, J ) * TEMP_298K**BI_TEXP( I, J )
     &                 * EXP( -BI_ACT( I, J ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( I, J+K )
                  CYCLE
               ENDIF

               N = INDEX1( WNAME, N_GC_SPC, GC_SPC )   ! search gas species for index
               MARKER = GC_STRT

               IF ( N == 0 ) THEN                  ! search non-reactive species
                  N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                  MARKER = NR_STRT

                  IF ( N == 0 ) THEN
                     WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                    'NOT INCLUDED', WNAME, RAD_MAP( I, J ),
     &                    BIRATE( I, J ) * TEMP_298K**BI_TEXP( I, J )
     &                    * EXP( -BI_ACT( I, J ) * INV_T298K ),
     &                    VNAME( J+K+1 ), PROD_MAP( I, J+K )
                     MARKER = 0
                  ENDIF

               ENDIF ! End IF block that searches non-reactive species

C..set value in map

               RAD_MAP( I, J ) = N + MARKER - 1

               IF ( RAD_MAP( I, J ) > 0 ) THEN
                  WRITE( LOGDEV,1200 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' Bimolecular ', WNAME, RAD_MAP( I, J ),
     &                 BIRATE( I, J ) * TEMP_298K**BI_TEXP( I, J )
     &                 * EXP( -BI_ACT( I, J ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( I, J+K )
               ENDIF

40          CONTINUE

            K = K + N_BI_LOSS

            DO 50 J = 1, N_TRI_LOSS

C..checking degradation rates

               IF ( TRIRATE( I, J ) < 0.0D0 ) THEN
                  WRITE( LOGDEV,* ) 'Species ', REACT( I ), 'has a negative'
     &                 // ' rate for trimolecular degradation.'
     &                 // ' Check degrade module.'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               ENDIF

               DO 60 K = 1, 2

                  WNAME = TRICAUSE( I, J, K )

                  CALL UPCASE( WNAME )

                  LEN_NAME = LEN_TRIM( WNAME )

                  IF ( LEN_NAME < 1 ) CYCLE

                  N = INDEX1( WNAME, N_GC_SPC, GC_SPC )   ! search gas species for index
                  MARKER = GC_STRT

                  IF ( N == 0 ) THEN                  ! search non-reactive species
                     N = INDEX1( WNAME, N_NR_SPC, NR_SPC )
                     MARKER = NR_STRT
                  ENDIF ! End IF block that searches non-reactive species

C..set value in map

                  RAD2_MAP( I, J, K ) = N + MARKER - 1

60             CONTINUE

               IF ( RAD2_MAP( I, J, 1 ) > 0 .AND. RAD2_MAP( I, J, 2 ) > 0 ) THEN

                  WRITE( LOGDEV,1300 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' Trimolecular ', TRICAUSE( I, J, 1 ), RAD2_MAP( I, J, 1 ),
     &                 TRICAUSE( I, J, 2 ), RAD2_MAP( I, J, 2 ),
     &                 TRIRATE( I, J ) * TEMP_298K**TRI_TEXP( I, J )
     &                 * EXP( -TRI_ACT( I, J ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( I, J+K )

               ELSE

                  WRITE( LOGDEV,1300 ) VNAME( 1 ), RXTANT_MAP( I ),
     &                 ' NOT INCLUDED ', TRICAUSE( I, J, 1 ), RAD2_MAP( I, J, 1 ),
     &                 TRICAUSE( I, J, 2 ), RAD2_MAP( I, J, 2 ),
     &                 TRIRATE( I, J ) * TEMP_298K**TRI_TEXP( I, J )
     &                 * EXP( -TRI_ACT( I, J ) * INV_T298K ),
     &                 VNAME( J+K+1 ), PROD_MAP( I, J+K )

               ENDIF

50          CONTINUE

            LEN_NAME = LEN_TRIM( REACT( I ) )

            K = K + N_TRI_LOSS

            DO 70 J = 1, N_PHOTO_LOSS

               WNAME = PHOTO_NAME( I, J )

               CALL UPCASE( WNAME )

               N = INDEX1( WNAME, NPHOTAB, PHOTAB )

               IF ( LEN_TRIM( WNAME ) < 2 ) CYCLE

               IF ( N < 1 ) THEN
                  WRITE( LOGDEV,* ) 'Photolysis rate, ', WNAME, ' for ',
     &                 REACT( I )( 1:LEN_NAME ),
     &                 'is not JTABLE and is not included. '
                  CYCLE
               ENDIF

               PHOTO_MAP( I, J ) = N

               WRITE( LOGDEV,1400 ) VNAME( 1 ), RXTANT_MAP( I ),
     &              ' Photolysis ', PHOTAB( N ), ' ', 'times', ' ',
     &              A_PHOTO( I, J ),
     &              VNAME( J+K+1 ), PROD_MAP( I, J+K )

70          CONTINUE

         END DO LOOP_REACT

         IF( N_REACT_FOUND .LT. 1 )RETURN

         WRITE( LOGDEV,* ) 'Note: If INDEX of CAUSE A OR B equals -1, the '
     &        // 'process is dropped from degradation '
     &        // 'calculation.'

         WRITE( LOGDEV,* ) BLANK

1000     FORMAT(A20,1X,A5,1X,A20,1X,2(A20,1X,A5,1X),A12,1X,A20,1X,A5)
1100     FORMAT(A20,1X,I5,1X,A20,1X,2(21X,6X),ES12.4,1X,A20,1X,I5)
1200     FORMAT(A20,1X,I5,1X,A20,1X,A20,1X,I5,1X,21X,6X,ES12.4,1X,A20,1X,I5)
1300     FORMAT(A20,1X,I5,1X,A20,1X,2(A20,1X,I5,1X),ES12.4,1X,A20,1X,I5)
1400     FORMAT(A20,1X,I5,1X,A20,1X,2(A20,1X,A5,1X),ES12.4,1X,A20,1X,I5)
1600     FORMAT('       DEGRADED      ',' Index',
     &              '       Process      ','        Cause A      ',
     &              ' Index', '       Cause B      ',' Index',
     &              '    Rate at 298K    ', '       Product      ',
     &              ' Index')

         RETURN

         END SUBROUTINE DEGRADE_MAP

      END MODULE DEGRADE_SETUP_TOX

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_data_copy_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for data
C   copy routine which performs interior sub-grid data communication (data 
C   re-distribution)
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C
C                    10/09/00 by David Wong
C                      -- unified fsg and csg data structures into one,
C                         subgrid
C
C                    07/23/01 by David Wong
C                      -- redesign the message sending and receiving algorithm
C
C                    03/06/02 David Wong
C                      -- use blocking communication scheme
C                      -- use array copy mechanism when communicates to itself
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Note:
C
C   se_[n]d[e]_data_copy where [n] denotes the dimensionality of the data
C   and [e] is optional, indicates the first two dimensions are both decomposed
C   or not
C
C Subroutine parameter description:
C
C   In:  data1     -- original data
C        spc       -- (use as needed) a specific species in the original data
C        des       -- (use as needed) species number in the recipient data
C        grid_type -- optional input, to indicate the data is from coarse
C                     grid 'c', 'C' or not
C
C   Out: data2   -- recipient of original data
C
C Local variable description:
C
C    sdir, rdir -- loop indexes which indicate send to or recvd from
C    tag        -- message tag
C    i          -- local loop index
C
C Include file:
C
C   se_pe_info_ext
C   se_data_send_module
C   se_data_recv_module
C
C --------------------------------------------------------------------------

        module se_data_copy_module

        implicit none

        interface se_data_copy
          module procedure se_2d_data_copy, se_2de_data_copy, 
     &                     se_3d_data_copy, se_3de_data_copy, 
     &                     se_4d_data_copy, se_4de_data_copy
        end interface

        contains

C --------------------------------------------------------------------------
        subroutine se_2d_data_copy (data1, data2)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :)
        real, intent(out) :: data2(:, :)

        integer :: sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     $              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir))
     $        =
     $        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     $              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_2d_data_copy

C --------------------------------------------------------------------------
        subroutine se_2de_data_copy (data1, data2, spc)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :)
        real, intent(out) :: data2(:, :)
        integer, intent(in) :: spc

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = spc
           se_subgrid_send_ind(2,3,i) = spc
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     $              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir))
     $        =
     $        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     $              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     $              se_subgrid_send_ind(1,3,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_2de_data_copy

C --------------------------------------------------------------------------
        subroutine se_3d_data_copy (data1, data2)

        use se_subgrid_info_ext
        use se_domain_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :)
        real, intent(out) :: data2(:, :, :)

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_send_ind(2,3,i) = se_my_subgrid_endlev
           se_subgrid_recv_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_recv_ind(2,3,i) = se_my_subgrid_endlev
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr,
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr,
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if

        end do

        return
        end subroutine se_3d_data_copy

C --------------------------------------------------------------------------
        subroutine se_3de_data_copy (data1, data2, spc)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :)
        integer, intent(in) :: spc

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_send_ind(2,3,i) = se_my_subgrid_endlev
           se_subgrid_send_ind(1,4,i) = spc
           se_subgrid_send_ind(2,4,i) = spc

           se_subgrid_recv_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_recv_ind(2,3,i) = se_my_subgrid_endlev
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir),
     &              se_subgrid_send_ind(1,4,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_3de_data_copy

C --------------------------------------------------------------------------
        subroutine se_4d_data_copy (data1, data2)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_domain_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :, :)

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = 1
           se_subgrid_send_ind(2,3,i) = se_my_nlays
           se_subgrid_send_ind(1,4,i) = 1
           se_subgrid_send_ind(2,4,i) = se_my_nspcs
           se_subgrid_recv_ind(1,3,i) = 1
           se_subgrid_recv_ind(2,3,i) = se_my_nlays
           se_subgrid_recv_ind(1,4,i) = 1
           se_subgrid_recv_ind(2,4,i) = se_my_nspcs
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir),
     &              se_subgrid_recv_ind(1,4,sdir):se_subgrid_recv_ind(2,4,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir),
     &              se_subgrid_send_ind(1,4,sdir):se_subgrid_send_ind(2,4,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr,
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr,
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_4d_data_copy

C --------------------------------------------------------------------------
        subroutine se_4de_data_copy (data1, data2, spc, des)

        use se_subgrid_info_ext
        use se_pe_info_ext
        use se_data_send_module
        use se_data_recv_module

        implicit none

        include "mpif.h"

        real, intent(in) :: data1(:, :, :, :)
        real, intent(out) :: data2(:, :, :, :)
        integer, intent(in) :: spc, des

        integer :: i, sdir, rdir, tag
        integer :: request, status(MPI_STATUS_SIZE), error

        do i = 0, se_numworkers-1
           se_subgrid_send_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_send_ind(2,3,i) = se_my_subgrid_endlev
           se_subgrid_send_ind(1,4,i) = spc
           se_subgrid_send_ind(2,4,i) = spc

           se_subgrid_recv_ind(1,3,i) = se_my_subgrid_beglev
           se_subgrid_recv_ind(2,3,i) = se_my_subgrid_endlev
           se_subgrid_recv_ind(1,4,i) = des
           se_subgrid_recv_ind(2,4,i) = des
        end do

        do sdir = 0, se_numworkers-1

           if (se_subgrid_send(sdir) .eq. se_myworker_pe) then

              data2(se_subgrid_recv_ind(1,1,sdir):se_subgrid_recv_ind(2,1,sdir),
     &              se_subgrid_recv_ind(1,2,sdir):se_subgrid_recv_ind(2,2,sdir),
     &              se_subgrid_recv_ind(1,3,sdir):se_subgrid_recv_ind(2,3,sdir),
     &              se_subgrid_recv_ind(1,4,sdir))
     &        =
     &        data1(se_subgrid_send_ind(1,1,sdir):se_subgrid_send_ind(2,1,sdir),
     &              se_subgrid_send_ind(1,2,sdir):se_subgrid_send_ind(2,2,sdir),
     &              se_subgrid_send_ind(1,3,sdir):se_subgrid_send_ind(2,3,sdir),
     &              se_subgrid_send_ind(1,4,sdir))

           else

              if (se_subgrid_send(sdir) .ge. 0) then
                 tag = sdir+se_myworker_pe
                 call se_data_send (data1, se_subgrid_send_ind_ptr, 
     &                              se_subgrid_send_ptr, sdir, tag, request)
              end if

              if ((se_subgrid_recv(sdir) .ge. 0) .and.
     &            (se_subgrid_recv(sdir) .ne. se_myworker_pe)) then
                 tag = sdir+se_myworker_pe
                 call se_data_recv (data2, se_subgrid_recv_ind_ptr, 
     &                              se_subgrid_recv_ptr, sdir, tag)
              end if

c             if (se_subgrid_send(sdir) .ge. 0) then
c                call mpi_wait (request, status, error)
c             end if

           end if
        end do

        return
        end subroutine se_4de_data_copy

        end module se_data_copy_module

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

         SUBROUTINE FIND_DEGRADED( JDATE, JTIME, CALL_DEGRADE )

C**********************************************************************
C
C  Function:  Set Logic Flag in whether to call degradation routines
C
C  CALLED BY: HRDRIVER
C
C**********************************************************************
 
           USE DEGRADE_SETUP_TOX

           IMPLICIT NONE
 
C.....INCLUDES: NONE

C.....ARGUMENTS:

           INTEGER, INTENT( IN )  :: JDATE        ! current model date , coded YYYYDDD
           INTEGER, INTENT( IN )  :: JTIME        ! current model time , coded HHMMSS
           LOGICAL, INTENT( OUT ) :: CALL_DEGRADE ! whether to call degradation routines

C.....LOCAL VARIABLES:

           CHARACTER( 144 )        :: XMSG                    ! Message text
           CHARACTER( 16  ), SAVE  :: PNAME = 'FIND_DEGRADED' ! Routine name

           CALL DEGRADE_DATA()

           CALL DEGRADE_MAP( JDATE, JTIME )
           
           IF( N_REACT_FOUND .GT. 0 )THEN
               CALL_DEGRADE = .TRUE.
           ELSE
               CALL_DEGRADE = .FALSE.
           ENDIF
        
           RETURN
         
         END SUBROUTINE FIND_DEGRADED

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/yoj/arc/CCTM/src/biog/beis3/chkgrid.F,v 1.5 2011/10/21 16:10:17 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      FUNCTION CHKGRID( FNAME ) RESULT( SUCCESS )

C-----------------------------------------------------------------------
 
C  Description:
C    Check the grid information and against the first file referenced, and
C    update for next check
 
C  Preconditions:
C    FDESC3 common already loaded from call to DESC3 before calling this routine
 
C  Subroutines and Functions Called:
 
C  Revision History:
C    Oct 2007 Jeff: Make a function and simplify for inline BEIS in CMAQ
C    Feb 2011 S.Roselle: Replaced I/O API include files with UTILIO_DEFN
C    10 May 2011 D.Wong: incorporated twoway model implementation
 
C-----------------------------------------------------------------------
C Modified from:

C Project Title: EDSS Tools Library
C File: @(#)$Id: chkgrid.F,v 1.5 2011/10/21 16:10:17 yoj Exp $
C COPYRIGHT (C) 2004, Environmental Modeling for Policy Development
C All Rights Reserved
C Carolina Environmental Program
C University of North Carolina at Chapel Hill
C 137 E. Franklin St., CB# 6116
C Chapel Hill, NC 27599-6116
C smoke@unc.edu
C Pathname: $Source: /project/yoj/arc/CCTM/src/biog/beis3/chkgrid.F,v $
C Last updated: $Date: 2011/10/21 16:10:17 $
C-----------------------------------------------------------------------

      USE UTILIO_DEFN

      IMPLICIT NONE

C Includes:

C Arguments:
      CHARACTER( * ), INTENT( IN )  :: FNAME   ! File name
      LOGICAL                       :: SUCCESS ! true: comparison succeeded

C External Functions:

C Parameters:
      CHARACTER( 10 ), PARAMETER :: BLANK10  = ' '

C Local variables:
      CHARACTER( 16 ), SAVE :: GRDNM = ' ' ! grid nam
      INTEGER,   SAVE :: GDTYP  = -1       ! i/o api grid type code
      INTEGER,   SAVE :: NCOLS  = 0        ! number of columns in grid
      INTEGER,   SAVE :: NROWS  = 0        ! number of rows in grid
      REAL( 8 ), SAVE :: XORIG  = 0.D0     ! x-origin of grid
      REAL( 8 ), SAVE :: YORIG  = 0.D0     ! y-origin of grid
      REAL( 8 ), SAVE :: XCENT  = 0.D0     ! x-center of projection
      REAL( 8 ), SAVE :: YCENT  = 0.D0     ! y-center of projection
      REAL( 8 ), SAVE :: XCELL  = 0.D0     ! x-dim of cells
      REAL( 8 ), SAVE :: YCELL  = 0.D0     ! y-dim of cells
      REAL( 8 ), SAVE :: P_ALP  = 0.D0     ! projection alpha
      REAL( 8 ), SAVE :: P_BET  = 0.D0     ! projection beta
      REAL( 8 ), SAVE :: P_GAM  = 0.D0     ! projection gamma
      LOGICAL,   SAVE :: OFFLAG = .FALSE.  ! true: subgrid offset has been set
      INTEGER,   SAVE :: XOFF   = 0        ! subgrid offset (x-sub = x - xoff)
      INTEGER,   SAVE :: YOFF   = 0        ! subgrid offset
      INTEGER,   SAVE :: XOFF_A = 0        ! tmp subgrid offset (x-sub = x - xoff)
      INTEGER,   SAVE :: YOFF_A = 0        ! tmp subgrid offset
!     INTEGER       L       ! length of file description
      INTEGER       NC                     ! test number of columns
      INTEGER       NR                     ! test number of rows
      INTEGER       XO                     ! test x-offset  
      INTEGER       YO                     ! test y-offset  

      REAL( 8 )     :: CHK_X   ! test val for checking subgrid even with grid
      REAL( 8 )     :: CHK_Y   ! test val for checking subgrid even with grid

      LOGICAL, SAVE :: GINIT  = .FALSE. ! true: grid settings have been initialized

      CHARACTER(  12 ) :: FILETYPE = 'gridded file'
      CHARACTER( 300 ) :: MESG     ! message buffer

      CHARACTER( 16 ) :: PNAME = 'CHKGRID' ! procedure name

C-----------------------------------------------------------------------

      SUCCESS = .TRUE.

      NC = NCOLS3D
      NR = NROWS3D

C If grid information has already been initialized, then compare existing to this file
      IF ( GINIT ) THEN

#ifndef twoway
C Check settings that must be consistent for exact grid match
         IF ( NC .NE. NCOLS            .OR.
     &        NR .NE. NROWS            .OR.
     &        DBLERR( XORIG3D, XORIG ) .OR.
     &        DBLERR( YORIG3D, YORIG ) ) THEN
            SUCCESS = .TRUE.
            MESG = 'WARNING: Columns, rows, x-origin, or ' //
     &             'y-origin for ' // FNAME // ' in ' //
     &             CRLF() // BLANK10 // FILETYPE // 
     &             ' are inconsistent with GRID NAME: ' // 
     &             TRIM( GRDNM )
            CALL M3MSG2( MESG ) 
         END IF
#endif

         XOFF = 0
         YOFF = 0

C Check settings that must be consistent for grids and subgrids
         IF ( GDTYP3D .NE. GDTYP        .OR.
     &        DBLERR( XCELL3D, XCELL  ) .OR.
     &        DBLERR( YCELL3D, YCELL  ) .OR.
     &        DBLERR( XCENT3D, XCENT  ) .OR.
     &        DBLERR( YCENT3D, YCENT  ) .OR.
     &        DBLERR( P_ALP3D, P_ALP  ) .OR.
     &        DBLERR( P_BET3D, P_BET  ) .OR.
     &        DBLERR( P_GAM3D, P_GAM  ) ) THEN
            SUCCESS = .FALSE.
            MESG = 'ERROR: Grid type, cell sizes, or ' //
     &             'grid projection for ' // FNAME // ' in '//
     &              CRLF() // BLANK10 // FILETYPE // 
     &             ' are inconsistent with with GRID NAME: ' 
     &             // TRIM( GRDNM )
            CALL M3MSG2( MESG ) 
         END IF

C Ensure that origins are compatible with each other by making sure they line up
C based on the cell sizes
         CHK_X  = ( XORIG3D - XORIG ) / XCELL
         CHK_X  = CHK_X - INT( CHK_X )
         CHK_Y  = ( YORIG3D - YORIG ) / YCELL
         CHK_Y  = CHK_Y - INT( CHK_Y )
         IF ( DBLERR( CHK_X, 0.D0 ) .OR.
     &        DBLERR( CHK_Y, 0.D0 ) ) THEN
            SUCCESS = .FALSE.
            MESG = 'ERROR: Grid origins not compatible ' //
     &             'between ' // FNAME // ' in ' // 
     &             CRLF() // BLANK10 // FILETYPE // 
     &             ' and set by GRID NAME: ' // TRIM( GRDNM )
            CALL M3MSG2( MESG ) 
         END IF

C If offset has been set, then check to ensure its the same
         IF ( OFFLAG ) THEN

C If file has different origin from the subgrid...
            IF ( XORIG3D .NE. XORIG .OR. 
     &           YORIG3D .NE. YORIG ) THEN

               XO = INT( ( XORIG3D - XORIG ) / XCELL )
               YO = INT( ( YORIG3D - YORIG ) / YCELL )
               IF ( XOFF .NE. XO .OR.
     &              YOFF .NE. YO ) THEN
                  SUCCESS = .FALSE.
                  MESG = 'WARNING: Subgrid offset for ' //
     &                   FNAME // ' in ' // CRLF() // BLANK10// 
     &                   FILETYPE // 'is ' //
     &                  'inconsistent with with GRID NAME: ' 
     &                   // TRIM( GRDNM )
                  CALL M3MSG2( MESG ) 
               END IF

C If file has same origin as subgrid
            ELSE



C Check that current subgrid is the same as the previous subgrid
               IF ( NC .NE. NCOLS            .OR.
     &              NR .NE. NROWS            .OR.
     &              DBLERR( XORIG3D, XORIG ) .OR.
     &              DBLERR( YORIG3D, YORIG ) ) THEN
                  SUCCESS = .FALSE.
                  MESG = 'WARNING: Columns, rows, x-origin, ' //
     &                   'or y-origin for ' // FNAME // ' in ' 
     &                   // CRLF() // BLANK10 // FILETYPE // 
     &                   'are inconsistent with values from ' // 
     &                   TRIM( GRDNM)
                  CALL M3MSG2( MESG ) 
               END IF

            END IF

C If offset for final subgrid hasn't been set yet...
         ELSE

C Compute possible offset from upper right hand corner, and if there is one, set flag
!?          XOFF_A = INT( ( XORIG   + NCOLS * XCELL   )
!?   &                  - ( XORIG3D +    NC * XCELL3D ) ) / XCELL
!?          YOFF_A = INT( ( YORIG   + NROWS * YCELL   )
!?   &                  - ( YORIG3D +    NR * YCELL3D ) ) / YCELL

C Compute possible offset from origin, and if so, set flag
            XOFF_A = INT( ( XORIG3D - XORIG ) / XCELL )
            YOFF_A = INT( ( YORIG3D - YORIG ) / YCELL )
               
C Reset origin and number of cells to latest grid
            GRDNM = GDNAM3D

C Store grid and offset parameters
            XOFF = XOFF_A
            YOFF = YOFF_A
            IF ( XOFF .NE. 0 .OR. YOFF .NE. 0 ) OFFLAG = .TRUE.
            XORIG = XORIG3D
            YORIG = YORIG3D
            NCOLS = NC
            NROWS = NR

         END IF

C Store initial grid information
      ELSE

         GINIT = .TRUE.
         GRDNM = GDNAM3D
         GDTYP = GDTYP3D
         P_ALP = P_ALP3D
         P_BET = P_BET3D
         P_GAM = P_GAM3D
         XCENT = XCENT3D
         YCENT = YCENT3D
         XORIG = XORIG3D
         YORIG = YORIG3D
         XCELL = XCELL3D
         YCELL = YCELL3D
         NCOLS = NC
         NROWS = NR

         MESG = 'NOTE: Grid settings initialized using ' // 
     &          TRIM( FNAME ) // ' in ' // CRLF() // BLANK10 // 
     &          FILETYPE // ' GRID NAME: ' // TRIM( GRDNM )

         CALL M3MSG2( MESG )

      END IF

      IF ( .NOT. SUCCESS ) THEN

         MESG = 'ERROR: Grid parameters for ' // FNAME // ' in ' //
     &          CRLF() // BLANK10 // FILETYPE //
     &          ' are inconsistent with GRID NAME: ' // TRIM( GRDNM )
         CALL M3MSG2( MESG )

      END IF

      RETURN

      CONTAINS

         LOGICAL FUNCTION DBLERR( PD, QD )

         IMPLICIT NONE

         REAL( 8 ), INTENT( IN ) :: PD
         REAL( 8 ), INTENT( IN ) :: QD

         DBLERR = ( ( PD - QD )*( PD - QD ) .GT. 1.0D-12 * ( PD*PD + QD*QD + 1.0D-5 ) )

         RETURN

         END FUNCTION DBLERR

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      MODULE PA_IRR_CLT
     
      IMPLICIT NONE
C-----------------------------------------------------------------------
C Function: Set up for and update the integrated reaction rates 
C           computed by the subroutine pa_irr
             
C Preconditions: None
 
C Key Subroutines/Functions Called: None
 
C Revision History
C  Prototype created by Jerry Gipson, November, 1996
C  Modified Sept, 1997 by Jerry Gipson to be consistent with targeted CTM
C  Modified 1/19/99 by David Wong at LM:
C                      -- add four include files because of new PA_CMN.EXT
C  Modified 2/26/99 by David Wong at LM:
C                      -- remove SUBST_AE_SPC, SUBST_NR_SPC, SUBST_TR_SPC, 
C                         three .EXT files
C                      -- use ifdef parallel to distinguish the need of
C                         shifting to origin to perform calculation in serial 
C                         but not in parallel
C                      -- change BEG* and END* to corresponding 
C                         MY_IRR_BEG*, and MY_IRR_END*, respectively
C   30 Mar 01 J.Young: Use PAGRD_DEFN, which uses HGRD_DEFN; eliminate
C                      BLKPRM.EXT; Use GRVARS
C   31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                      domain specifications in one module (GRID_CONF)
C   21 Jun 10 J.Young: convert for Namelist redesign
C   16 Sep 16 J.Young: update for inline procan (IRR)
C    1 Feb 19 David Wong: removed all MY_N clauses
C-----------------------------------------------------------------------

      CONTAINS
      
      SUBROUTINE PA_IRR_SETUP( NBLKS, LIRRBLK, LCELL, BLKLEN,
     &                         CCOL, CROW, CLEV )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Flags all blocks that will need IRR/MB calculations
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs

         IMPLICIT NONE 
C..Includes: None

C..Arguments: 
         INTEGER, INTENT( IN    ) :: NBLKS            ! Number of blocks in modeling domain
         LOGICAL, INTENT(   OUT ) :: LIRRBLK( : )     ! Flag for doing IRR
         INTEGER, INTENT( IN    ) :: BLKLEN ( : )     ! Number of cells in each
         INTEGER, INTENT( IN    ) :: LCELL  ( : )     ! Offset to 1st cell in each
         INTEGER, INTENT( IN    ) :: CCOL   ( : )     ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )     ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )     ! Level pointer for cell
C..Parameters: None

C..External Functions: None
 
!?..Saved Local Variables:
!?????LOGICAL, SAVE :: LIRRCELL( BLKSIZE )  ! Flag to do IRR for a cell

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------

         DO BLK = 1, NBLKS
            SCL = LCELL( BLK ) + 1
            ECL = LCELL( BLK ) + BLKLEN( BLK )
            DO ICL = SCL, ECL
               COL = CCOL( ICL )
               ROW = CROW( ICL )
               LEV = CLEV( ICL )
               IF ( COL .GE. MY_IRR_BEGCOL .AND. COL .LE. MY_IRR_ENDCOL .AND.
     &              ROW .GE. MY_IRR_BEGROW .AND. ROW .LE. MY_IRR_ENDROW .AND.
     &              LEV .GE. MY_IRR_BEGLEV .AND. LEV .LE. MY_IRR_ENDLEV ) 
     &              LIRRBLK( BLK ) = .TRUE.
            END DO
          END DO 
          RETURN
        END SUBROUTINE PA_IRR_SETUP
        SUBROUTINE PA_IRR_CKBLK ( NUMCELLS, LIRRFLAG, OFFSET, CCOL,
     &                            CROW, CLEV, NORDCELL, NIRRCLS, IRRCELL )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Checks a block of cells to see if it has a cell that needs IRR
c  calculations for the case in which when the cell composition of the
c  block can change
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: NUMCELLS       ! Number of cells in one block
         LOGICAL, INTENT(   OUT ) :: LIRRFLAG       ! Flag for doing IRR for one block
         INTEGER, INTENT( IN    ) :: OFFSET         ! Offset to 1st cell in a block
         INTEGER, INTENT( IN    ) :: CCOL   ( : )   ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )   ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )   ! Level pointer for cell
         INTEGER, INTENT( IN    ) :: NORDCELL( : )  ! Cell number of ordered cells in a block
         INTEGER, INTENT( INOUT ) :: NIRRCLS        ! No. of cells in block for IRR cells
         INTEGER, INTENT( INOUT ) :: IRRCELL( : )   ! Cell No. of an IRR cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------
          NIRRCLS = 0
          DO NCELL = 1, NUMCELLS
             ICL = NORDCELL( OFFSET + NCELL )
             COL = CCOL( ICL )
             ROW = CROW( ICL )
             LEV = CLEV( ICL )
!?????????????LIRRCELL( NCELL ) = .FALSE.
             IF ( COL .GE. MY_IRR_BEGCOL .AND. COL .LE. MY_IRR_ENDCOL .AND.
     &            ROW .GE. MY_IRR_BEGROW .AND. ROW .LE. MY_IRR_ENDROW .AND.
     &            LEV .GE. MY_IRR_BEGLEV .AND. LEV .LE. MY_IRR_ENDLEV ) THEN
                LIRRFLAG = .TRUE.
!????????????????LIRRCELL( NCELL ) = .TRUE.
                NIRRCLS = NIRRCLS + 1
                IRRCELL( NIRRCLS ) = NCELL
             END IF
          END DO
         RETURN            
        END SUBROUTINE PA_IRR_CKBLK
        SUBROUTINE PA_IRR_CKCELLS ( LIRRFLAG )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Checks cells to see which needs IRR calculations
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         LOGICAL, INTENT(   OUT ) :: LIRRFLAG( :,:,: ) ! Flag for doing IRR for one block

C..Includes: None

C..Scratch Local Variables:
         INTEGER C, R, L     ! Column, row, and level indices for PA outputs
C-----------------------------------------------------------------------
      
          DO L = 1, NLAYS
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  IF ( C .GE. MY_IRR_BEGCOL .AND. C .LE. MY_IRR_ENDCOL .AND.
     &                 R .GE. MY_IRR_BEGROW .AND. R .LE. MY_IRR_ENDROW .AND.
     &                 L .GE. MY_IRR_BEGLEV .AND. L .LE. MY_IRR_ENDLEV ) THEN
                       LIRRFLAG( C,R,L ) = .TRUE.
                  ELSE
                       LIRRFLAG( C,R,L ) = .FALSE.     
                  END IF
               END DO
            END DO
         END DO
         RETURN            
        END SUBROUTINE PA_IRR_CKCELLS
        SUBROUTINE PA_IRR_BLKSTRT ( NUMCELLS )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Initializes IRRBLK to zero
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: NUMCELLS       ! Number of cells in one block

C..Includes: None

C..Scratch Local Variables:
         INTEGER CELL           ! Counter of cells in a block
         INTEGER NIRR           ! Loop index for IRR variables
C-----------------------------------------------------------------------
           DO NIRR = 1, NIRRVAR
              DO CELL = 1, NUMCELLS
                IRRBLK( CELL,NIRR ) = 0.0
             END DO
           END DO
          RETURN
        END SUBROUTINE PA_IRR_BLKSTRT
        SUBROUTINE PA_IRR_BLKENDF( OFFSET, NUMCELLS, CCOL, CROW, CLEV )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Updates the IRROUT array after a block is finished for the case
c  in which the cell composition of the block is fixed
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: OFFSET         ! Offset to 1st cell in a block
         INTEGER, INTENT( IN    ) :: NUMCELLS       ! Number of cells in one block
         INTEGER, INTENT( IN    ) :: CCOL   ( : )   ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )   ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )   ! Level pointer for cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------
          SCL = OFFSET + 1
          ECL = OFFSET + NUMCELLS
          CELL = 0
          DO ICL = SCL, ECL
            COL = CCOL( ICL )
            ROW = CROW( ICL )
            LEV = CLEV( ICL )
            CELL = CELL + 1
            IF ( COL .GE. MY_IRR_BEGCOL .AND. COL .LE. MY_IRR_ENDCOL .AND.
     &           ROW .GE. MY_IRR_BEGROW .AND. ROW .LE. MY_IRR_ENDROW .AND.
     &           LEV .GE. MY_IRR_BEGLEV .AND. LEV .LE. MY_IRR_ENDLEV ) THEN

#ifdef parallel
               PC = COL
               PR = ROW
               PL = LEV
#else
C -- serial case, calculations are shifted to the origin but not in
C    parallel implementation
               PC = COL - MY_IRR_BEGCOL + 1
               PR = ROW - MY_IRR_BEGROW + 1
               PL = LEV - MY_IRR_BEGLEV + 1
#endif
               DO NIRR = 1, NIRRVAR
                  IRROUT( PC,PR,PL,NIRR ) = IRROUT( PC,PR,PL,NIRR )
     &                                    + IRRBLK( CELL,NIRR )      
               END DO
            END IF
          END DO

          RETURN
        END SUBROUTINE  PA_IRR_BLKENDF
        SUBROUTINE PA_IRR_CELLENDF( COL, ROW, LEV )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Updates the IRROUT for cell 
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
         
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN ) :: COL      ! Column pointer for cell
         INTEGER, INTENT( IN ) :: ROW      ! Row pointer for cell
         INTEGER, INTENT( IN ) :: LEV      ! Level pointer for cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
C-----------------------------------------------------------------------
#ifdef parallel
               PC = COL
               PR = ROW
               PL = LEV
#else
C -- serial case, calculations are shifted to the origin but not in
C    parallel implementation
               PC = COL - MY_IRR_BEGCOL + 1
               PR = ROW - MY_IRR_BEGROW + 1
               PL = LEV - MY_IRR_BEGLEV + 1
#endif
               DO NIRR = 1, NIRRVAR
                  IRROUT( PC,PR,PL,NIRR ) = IRROUT( PC,PR,PL,NIRR )
     &                                    + IRRSUM( NIRR )      
               END DO

          RETURN
        END SUBROUTINE  PA_IRR_CELLENDF
        SUBROUTINE PA_IRR_BLKENDC ( OFFSET, CCOL, CROW, CLEV,
     &                              NORDCELL, NIRRCLS, IRRCELL )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Updates the IRROUT array after a block is finished for the case
c  in which the cell composition of the block can change
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE CGRID_SPCS            ! CGRID mechanism species
         USE PA_DEFN               ! Process Anaylsis control and data variables
         USE PAGRD_DEFN            ! PA horiz domain specs
     
         IMPLICIT NONE
C..Arguments 
         INTEGER, INTENT( IN    ) :: OFFSET         ! Offset to 1st cell in a block
         INTEGER, INTENT( IN    ) :: CCOL   ( : )   ! Column pointer for cell
         INTEGER, INTENT( IN    ) :: CROW   ( : )   ! Row pointer for cell
         INTEGER, INTENT( IN    ) :: CLEV   ( : )   ! Level pointer for cell
         INTEGER, INTENT( IN    ) :: NORDCELL( : )  ! Cell number of ordered cells in a block
         INTEGER, INTENT( INOUT ) :: NIRRCLS        ! No. of cells in block for IRR cells
         INTEGER, INTENT( INOUT ) :: IRRCELL( : )   ! Cell No. of an IRR cell

C..Includes: None

C..Scratch Local Variables:
         INTEGER BLK            ! Loop index for blocks
         INTEGER CELL           ! Counter of cells in a block
         INTEGER COL, ROW, LEV  ! Column, row, and level indices
         INTEGER ECL            ! Ending cell no. of block
         INTEGER ICL            ! Loop index for cells in a block
         INTEGER NCELL          ! Loop index for cells in a block
         INTEGER PC, PR, PL     ! Column, row, and level indices for PA outputs
         INTEGER NIRR           ! Loop index for IRR variables
         INTEGER SCL            ! Starting cell no. of block
C-----------------------------------------------------------------------
         DO NCELL = 1, NIRRCLS
            CELL = IRRCELL( NCELL )
            ICL = NORDCELL( OFFSET + CELL )
            COL = CCOL( ICL )
            ROW = CROW( ICL )
            LEV = CLEV( ICL )

C -- in serial case, calculations are shifted to the origin but not in
C    parallel implementation

#ifdef parallel
            PC = COL
            PR = ROW
            PL = LEV
#else
            PC = COL - MY_IRR_BEGCOL + 1
            PR = ROW - MY_IRR_BEGROW + 1
            PL = LEV - MY_IRR_BEGLEV + 1
#endif

            DO NIRR = 1, NIRRVAR
               IRROUT( PC,PR,PL,NIRR ) = IRROUT( PC,PR,PL,NIRR )
     &                                 + IRRBLK( NCELL,NIRR )      
            END DO
         END DO

         RETURN

        END SUBROUTINE PA_IRR_BLKENDC

      END MODULE PA_IRR_CLT

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE PT3D_DEFN

C-----------------------------------------------------------------------
C Function: 3d point source emissions interface to the chemistry-transport model

C Revision History:
C     21 Nov 2007 J.Young: initial implementation
C     1  Jun 2010 David Wong: In subroutine GET_PT3D_EMIS, removed a IF-THEN
C                             block of code since the argument for TIME2SEC is in
C                             HHMMSS format rather than day format and also
C                             STKDATE is already set correctly
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     11 May 2011 David Wong: incorporated twoway model implementation
C     27 Jul 2011 David Wong: 1. in subroutine GET_PT3D_EMIS, use PRE_JDATE, and
C                                LOC_STKDATE to track change of date during a
C                                simulation when the start time is not 0, so
C                                correct data can be pulled by INTERPX routine
C                             2. used WINDOW logical variable (in subroutine
C                                PT3D_INIT) to determine x and y orig information
C                                and in subroutine READGC3, do not expand the
C                                STATCOL and STRTROw in the west and south direction
C     29 Oct 2011 J.Young: fix domain windowing
C     30 Apr 2012 C.Nolte: fix number of substeps, NTICS to be the number of
C                          synchronization time steps rather than the number of seconds. 
C     19 Dec 2013 D. Wong: used WRTIME, a robust way to determine when to write the 
C                          PT3D diagnostic file instead of relying on NTICS in particular
C                          for the twoway model where a time step can be sub-divided.
C     29 Jul 2014 D. Wong: check MET_CRO_3D and MET_DOT_3D separately for domain windowing
C     12 Aug 2015 D. Wong: - Used assumed shape array declaration and declared associated 
C                            subroutines in INTERFACE block
C                          - Replaced BMATVEC with BMATVECN which will call with a 1d or 
C                            2d argument subroutine by F90 poly-morphism feature
C                          - Based on the condition of MY_NSRC ( > 0 or not) to determine 
C                            execution of certain section of code or not
C     30 Apr 2016 J.Young: add multiple fire source capability, in affiliation with
C                          Yongtao Hu (Georgia Tech)
C     22 Jun 2016 B.Hutzell: Fixed issue where single emis species maps to multiple model
C                            species
C     08 Aug 2016 B.Murphy: Neglect fire emissions for pcVOC
C     16 Aug 2017 B.Murphy: Pull plume height calc. to separate subroutine.
C     01 Feb 2019 D.Wong: Implemented centralized I/O approach and removed everything 
C                         related to ZSTATIC
C     05 June 2019 F. Sidi: Bugfix related to Parallel I/O Implementation
C     05 Aug  2019 D. Wong: Removed USE BMATVEC_MODULE statement and PTBILIIN
C     19 Sep  2019 D. Wong: Fixed the way to advance to next day on an emission file, EM_FILE_DATE
C-----------------------------------------------------------------------

      USE UDTYPES, ONLY: RARRY1

      IMPLICIT NONE


      PUBLIC PT3D_INIT, GET_PT3D_EMIS
      PRIVATE

C Output layer fractions, dimensioned NSRC, emlays, and for diagnostic file
      REAL,    ALLOCATABLE, SAVE :: LFRAC( :,: ) ! per source local layer fractn
      REAL,    ALLOCATABLE, SAVE :: TFRAC( :,: ) ! Temporary LFRAC

C debugging zplume
      REAL,    ALLOCATABLE, SAVE :: ZPLUM( :,: ) ! has to be 2D for play file

C Wildfire emissions source parameters
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: ACRES( : )   ! acres burned
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: BFLUX( : )   ! Briggs buoyancy flux

C Vertical coord values
      REAL,    ALLOCATABLE, SAVE :: VGLVSXG( : )

C Play report log
      INTEGER, ALLOCATABLE, SAVE :: RDEV( : )
C Play files source id file
#ifdef srcid
      INTEGER, ALLOCATABLE, SAVE :: LDEV( : )
#endif
C Plume rise info report files
      CHARACTER( 13 ), ALLOCATABLE, SAVE :: REPTNAME( : )
      CHARACTER( 11 )                    :: REPSTR

C Layer fractions matrix output files
      CHARACTER(  16 ), ALLOCATABLE, SAVE :: PLAYNAME( : )
C Layer fractions source id output files
      CHARACTER(  16 ), ALLOCATABLE, SAVE :: PLAY_SRCID_NAME( : )

C Point source 3d emis diagnostic file names
!     CHARACTER( 16 ),               SAVE :: PT3DNAME
C Point source 3d emis diagnostic integral average write buffers
      REAL,    ALLOCATABLE, SAVE :: VDEMIS_BUF( :,:,:,: )
C Diagnostic file avg factor
      REAL                       :: DIVFAC


C Stack parameters
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_DM( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_HT( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_TK( : )
      TYPE( RARRY1 ), ALLOCATABLE, SAVE :: STK_VEL( : )

C Private Parameters:
      CHARACTER(  10 ), PARAMETER :: BLANK10 = '          '

C cross-point layered grid file name
      CHARACTER(  16 ),     SAVE :: GC3NAME

C hourly stack emissions file names
      CHARACTER(  16 ), ALLOCATABLE, SAVE :: STKENAME( : )

      CHARACTER( 240 )           :: XMSG = ' '
          
      CONTAINS

C=======================================================================

         FUNCTION PT3D_INIT ( JDATE, JTIME, TSTEP )
     &                       RESULT ( SUCCESS )

         USE GRID_CONF, ONLY: NLAYS, VGTYP_GD
         USE STK_PRMS, ONLY: SOURCE, STK_PRMS_INIT, MY_NSRC
         USE STK_EMIS, ONLY: EM_FILE_NAME, NSRC_EMIS, FIREFLAG,
     &                       MAP_PTtoISRM, STK_EMIS_INIT
         USE PTMET, ONLY: PTMET_DATA, MC2NAME, MC3NAME, MD3NAME, PTMET_INIT
         USE PTBILIN, ONLY: NPTGRPS, 
     &                      METCXORIG, METCYORIG, XCELLCG, YCELLCG, 
     &                      METDXORIG, METDYORIG, XCELLDG, YCELLDG

         USE UTILIO_DEFN
         USE RUNTIME_VARS, ONLY: LOGDEV, MYPE, PT3DFRAC, PT_DATE, STDATE, STTIME,
     &                           PT_TIME, PT_NSTEPS, REP_LAYR
         USE EMIS_VARS, ONLY: EMLAYS, EMLAYS_MX
         USE stack_group_data_module
         USE centralized_io_module, only : window

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters (for CTM_PT3D_DIAG)

C Arguments:
         INTEGER          JDATE      ! Julian date (YYYYDDD)
         INTEGER          JTIME      ! time (HHMMSS)
         INTEGER          TSTEP      ! output time step
         LOGICAL          SUCCESS

C Parameters:

C Local Variables:
         CHARACTER( 16 )       :: PNAME = 'PT3D_INIT       ' ! procedure name
         CHARACTER( 16 )       :: VNAME    ! variable name buffer
!        CHARACTER( 16 ), SAVE, ALLOCATABLE :: STKGNAME( : ) ! stack groups file name

         INTEGER          METCCOLS       ! cross point grid number of columns
         INTEGER          METCROWS       ! cross point grid number of rows
         INTEGER          METDCOLS       ! dot point grid number of columns
         INTEGER          METDROWS       ! dot point grid number of rows
         INTEGER          IOS            ! i/o and allocate memory status
         INTEGER          NDATE          ! next timestep file Julian date (YYYYDDD)
         INTEGER          NTIME          ! next timestep file time (HHMMSS)

         INTEGER I, J, K, L, M, N, P, S, SRC, V, ISRM  ! counters and indices

         INTEGER :: GXOFF, GYOFF
         INTEGER :: STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC

         INTERFACE
            SUBROUTINE DELTA_ZS( EMLAYS, MY_NSRC, SRC_MAP, STKHT, ZF, ZSTK, DDZF )
               INTEGER, INTENT( IN )  :: EMLAYS, MY_NSRC
               INTEGER, INTENT( IN )  :: SRC_MAP( : )
               REAL,    INTENT( IN )  :: STKHT( : )
               REAL,    INTENT( IN )  :: ZF  ( :,: )
               REAL,    INTENT( OUT ) :: ZSTK( :,: )
               REAL,    INTENT( OUT ) :: DDZF( :,: )
            END SUBROUTINE DELTA_ZS
         END INTERFACE

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

C In-line 3D point source emissions?
         IF ( NPTGRPS .GT. 0 ) THEN
            XMSG = 'Using in-line 3d point source emissions option'
            CALL M3MSG2( XMSG )
         ELSE
            RETURN
         END IF


C Cannot use default and cannot set to less than 4 because of limits of plume
C rise algorithm
         IF ( EMLAYS_MX .GT. 0 .AND. EMLAYS_MX .LT. 4 ) THEN
            XMSG = 'Environment variable CTM_EMLAYS must be set to ' //
     &             'a number from 4 to the ' // CRLF() // BLANK10 //
     &             'number of layers in the meteorology inputs.'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
C get diagnostic files options
         IF ( REP_LAYR .LT. 1 ) THEN
            XMSG = 'NOTE: Environment variable REP_LAYR_MIN is ' //
     &             'less than 1.  Turning off reporting...'
         ELSE IF ( REP_LAYR .GT. EMLAYS ) THEN
            WRITE( XMSG,94010 )
     &             'NOTE: Environment variable REP_LAYR_MIN is '//
     &             'greater than the number of emissions ' //
     &             CRLF() // BLANK10 // 'layers (', EMLAYS, '). '//
     &             'Resetting to number of emissions layers.'
            REP_LAYR = EMLAYS
         ELSE
            WRITE( XMSG,94010 )
     &             'logging stack data for plume rise .ge. layer', REP_LAYR

         END IF

         CALL M3MSG2( XMSG )
#ifdef srcid
         IF ( PT3DFRAC ) THEN   ! save local source id's
            ALLOCATE ( LDEV( NPTGRPS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'LDEV', PNAME )
            LDEV = 0   ! array
            WRITE( XMSG,94010 ) "Enter logical name for file containing " //
     &                          "source id's of play files"
            ALLOCATE ( PLAY_SRCID_NAME( NPTGRPS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'PLAY_SRCID_NAME', PNAME )
            DO N = 1, NPTGRPS
               WRITE( REPSTR,'( "SRCIDLAY", I2.2, "_" )' ) N
               WRITE( PLAY_SRCID_NAME( N ),'( A, I2.2 )' ) REPSTR, MYPE   ! limited to 99 PE's
               LDEV( N ) = PROMPTFFILE( XMSG, .FALSE., .TRUE.,
     &                                  PLAY_SRCID_NAME( N ), PNAME )
            END DO
         END IF
#endif

         ALLOCATE ( RDEV( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'RDEV', PNAME )
         RDEV = 0   ! array
         IF ( REP_LAYR .GT. 0 ) THEN
            WRITE( XMSG,94010 ) 'Enter logical name for report of ' //
     &                          'plumes exceeding layer', REP_LAYR
            ALLOCATE ( REPTNAME( NPTGRPS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'REPTNAME', PNAME )
            DO N = 1, NPTGRPS
               WRITE( REPSTR,'( "REPRTLAY", I2.2, "_" )' ) N
               WRITE( REPTNAME( N ),'( A, I2.2 )' ) REPSTR, MYPE   ! limited to 99 PE's
               RDEV( N ) = PROMPTFFILE( XMSG, .FALSE., .TRUE., REPTNAME( N ), PNAME )
            END DO
         END IF

C get scenario timing

         PT_DATE = JDATE 
         PT_TIME = JTIME

C open met files

         MC2NAME = PROMPTMFILE( 'Enter name for CROSS-POINT SURFACE MET file',
     &                          FSREAD3, 'MET_CRO_2D', PNAME )

         MC3NAME = PROMPTMFILE( 'Enter name for CROSS-POINT LAYERED MET file',
     &                          FSREAD3, 'MET_CRO_3D', PNAME )

         MD3NAME = PROMPTMFILE( 'Enter name for DOT-POINT LAYERED MET file',
     &                          FSREAD3, 'MET_DOT_3D', PNAME )

C Get grid parameters from 3-d cross-point met file and store header information.
C Use time parameters for time defaults.
         CALL RETRIEVE_IOAPI_HEADER( MC3NAME, JDATE, JTIME )

         CALL SUBHFILE ( MC3NAME, GXOFF, GYOFF,
     &                   STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC )

C Initialize reference grid with met file
         XCELLCG = XCELL3D
         YCELLCG = YCELL3D
         METCCOLS = NCOLS3D
         METCROWS = NROWS3D
         METCXORIG = XORIG3D
         METCYORIG = YORIG3D

         IF ( ( GXOFF .GT. 0 ) .AND. ( GYOFF .GT. 0 ) ) THEN
            METCXORIG = XORIG3D + REAL( GXOFF,8 ) * XCELL3D
            METCYORIG = YORIG3D + REAL( GYOFF,8 ) * YCELL3D
         ELSE
            METCXORIG = XORIG3D
            METCYORIG = YORIG3D
         END IF

!!!!!!^^^^^^^!!!! THESE NEED TO BE CHECKED AGAINST GRIDDESC

C Get grid parameters from 3-d dot-point met file and store header information.
C (declared and stored in PTBILIN module)
         CALL RETRIEVE_IOAPI_HEADER( MD3NAME, JDATE, JTIME )
         XCELLDG = XCELL3D
         YCELLDG = YCELL3D
         METDXORIG = XORIG3D
         METDYORIG = YORIG3D
         METDCOLS = NCOLS3D
         METDROWS = NROWS3D

         CALL SUBHFILE ( MD3NAME, GXOFF, GYOFF,
     &                   STRTCOLMC, ENDCOLMC, STRTROWMC, ENDROWMC )

         IF ( ( GXOFF .GT. 0 ) .AND. ( GYOFF .GT. 0 ) ) THEN
            METDXORIG = XORIG3D + REAL( GXOFF,8 ) * XCELL3D
            METDYORIG = YORIG3D + REAL( GYOFF,8 ) * YCELL3D
         ELSE
            METDXORIG = XORIG3D
            METDYORIG = YORIG3D
         END IF

C Compare number of meteorology layers to number of emissions layers
!         IF ( EMLAYS .LE. NLAYS ) THEN
!            WRITE( XMSG,94010 ) 'NOTE: The number of emission layers ' //
!     &                          'is', EMLAYS, ', and the maximum ' // CRLF()
!     &                          // BLANK10 // 'possible layers is', NLAYS
!            CALL M3MSG2( XMSG )
!         ELSE
!            WRITE( XMSG,94010 ) 'Resetting number of emission layers ' //
!     &                          'from', EMLAYS, 'to number of ' // CRLF() //
!     &                          BLANK10 // 'layers in the meteorology file,', NLAYS
!            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
!            EMLAYS = NLAYS
!         END IF

         ALLOCATE( VGLVSXG( 0:MXLAYS3 ), STAT = IOS )
         CALL CHECKMEM( IOS, 'VGLVSXG', PNAME )

C Store local layer information
         J = LBOUND( VGLVS3D, 1 )   ! F90 array intrinsic
         VGLVSXG( 0 ) = VGLVS3D( J )
         DO L = 1, NLAYS
            J = J + 1
            VGLVSXG( L ) = VGLVS3D( J )
         END DO

         IF ( PT_NSTEPS .GT. MXREC3D ) THEN
            WRITE( XMSG,94010 ) 'Requested output time steps > those on met file '
     &                          // CRLF() // BLANK10 // 'reset to ', MXREC3D
            PT_NSTEPS = MXREC3D
         END IF

C Get stack data
!        ALLOCATE ( STKGNAME( NPTGRPS ), STAT = IOS )   ! stk parms files array
!        CALL CHECKMEM( IOS, 'STKGNAME', PNAME )
!        STKGNAME = ' '   ! array

!        DO N = 1, NPTGRPS
!           WRITE( VNAME,'( "STK_GRPS_",I3.3 )' ) N
!           STKGNAME( N ) = PROMPTMFILE( 'Enter name for stack groups file',
!    &                                   FSREAD3, VNAME, PNAME )
!        END DO

!        IF ( .NOT. STK_PRMS_INIT( STKGNAME ) ) THEN
!           XMSG = 'Could not initialize stack parameters'
!           CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
!           SUCCESS = .FALSE.; RETURN
!        END IF

#ifdef srcid
         IF ( PT3DFRAC ) THEN
            DO N = 1, NPTGRPS
               WRITE( LDEV( N ),93053 ) N, MY_NSRC( N ), MY_STRT_SRC( N )
               DO S = 1, MY_NSRC( N )
                  WRITE( LDEV( N ),93057 ) S, SOURCE( N )%ARRY( S ) + MY_STRT_SRC( N ) - 1
               END DO
            END DO
         END IF
#endif

C Initialize stack emissions data
         ALLOCATE ( STKENAME( NPTGRPS ), STAT = IOS )   ! stk emis files array
         CALL CHECKMEM( IOS, 'STKENAME', PNAME )
         STKENAME = ' '   ! array

         ! Retrive Point Source Filenames from Emissions Filename Vector
         DO N = 1, NPTGRPS
            ISRM = MAP_PTtoISRM( N )
            STKENAME( N ) = EM_FILE_NAME( ISRM )
         END DO

         ! Initialize Point Source Emissions
         IF ( .NOT. STK_EMIS_INIT( STKENAME, JDATE, JTIME ) ) THEN
            XMSG = 'Could not initialize stack parameters'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         ! Check that the number of individual sources on each point
         ! emissions file is consistent.
         DO N = 1, NPTGRPS
            IF ( NSRC( N ) .NE. NSRC_EMIS( N ) ) THEN
               WRITE( LOGDEV,* ) 'NSRC vs. NSRC_EMIS:', N, NSRC( N ), NSRC_EMIS( N )
               XMSG = 'No. of sources for stack files don''t match'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
         END DO

C Open diagnostic layer fractions file?
         IF ( PT3DFRAC ) THEN
            ALLOCATE ( PLAYNAME( NPTGRPS ), STAT = IOS )   ! stk parms files array
            CALL CHECKMEM( IOS, 'PLAYNAME', PNAME )
            PLAYNAME = ' '   ! array
            NDATE = PT_DATE; NTIME = PT_TIME
            CALL NEXTIME( NDATE, NTIME, TSTEP ) ! advance one output tstep
            CALL OPENLAYOUT( NDATE, NTIME, TSTEP, EMLAYS, VGLVSXG, NPTGRPS,
     &                       MY_NSRC, PLAYNAME )
         END IF

         IF ( .NOT. PTMET_INIT ( ) ) THEN
            XMSG = 'Could not initialize stack met data'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

         ALLOCATE( STK_DM( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_DM', PNAME )

         ALLOCATE( STK_HT( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_HT', PNAME )

         ALLOCATE( STK_TK( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_TK', PNAME )

         ALLOCATE( STK_VEL( NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'STK_VEL', PNAME )

         ALLOCATE( ACRES (NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'ACRES', PNAME )

         ALLOCATE( BFLUX (NPTGRPS ), STAT = IOS )
         CALL CHECKMEM( IOS, 'BFLUX', PNAME )

         DO N = 1, NPTGRPS

C Allocate and set stack parameters

            IF ( MY_NSRC( N ) .GT. 0 ) THEN
               ALLOCATE( STK_DM( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_DM', PNAME )
               STK_DM( N )%ARRY = 0.0   ! 1D array
               STK_DM( N )%LEN = MY_NSRC( N )

               ALLOCATE( STK_HT( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_HT', PNAME )
               STK_HT( N )%ARRY = 0.0   ! 1D array
               STK_HT( N )%LEN = MY_NSRC( N )

               ALLOCATE( STK_TK( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_TK', PNAME )
               STK_TK( N )%ARRY = 0.0   ! 1D array
               STK_TK( N )%LEN = MY_NSRC( N )

               ALLOCATE( STK_VEL( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
               CALL CHECKMEM( IOS, 'STK_VEL', PNAME )
               STK_VEL( N )%ARRY = 0.0   ! 1D array
               STK_VEL( N )%LEN = MY_NSRC( N )
 
               DO S = 1, MY_NSRC( N )
                  SRC = SOURCE( N )%ARRY( S )
                  STK_DM( N )%ARRY( S )  = STKDIAM( N )%ARRY( SRC )
                  STK_HT( N )%ARRY( S )  = STKHT( N )%ARRY( SRC )
                  STK_TK( N )%ARRY( S )  = STKTK( N )%ARRY( SRC )
                  STK_VEL( N )%ARRY( S ) = STKVEL( N )%ARRY( SRC )
               END DO

C If wildfires, allocate fire parameters
               IF ( FIREFLAG( N ) ) THEN

                  ALLOCATE( ACRES( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
                  CALL CHECKMEM( IOS, 'ACRES', PNAME )
                  ACRES( N )%ARRY  = 0.0   ! 1D array
                  ACRES( N )%LEN = MY_NSRC( N )

                  DO S = 1, MY_NSRC( N )
                     SRC = SOURCE( N )%ARRY( S )
                     ACRES( N )%ARRY( S ) = ACRES_BURNED( N )%ARRY( SRC )
                  END DO

                  ALLOCATE( BFLUX( N )%ARRY( MY_NSRC( N ) ), STAT = IOS )
                  CALL CHECKMEM( IOS, 'BFLUX', PNAME )
                  BFLUX( N )%ARRY = 0.0   ! 1D array
                  BFLUX( N )%LEN = MY_NSRC( N )

               END IF
            END IF   ! MY_NSRC > 0

         END DO

         SUCCESS = .TRUE.; RETURN

93053    FORMAT("#  Src Id's for play file", I2, ', with', I10, ' total sources',
     &          ", and my_strt_src:", I10 )
93057    FORMAT( I6, I8 )
94010    FORMAT( 12( A, :, I8, :, 1X ) )

         END FUNCTION PT3D_INIT

C=======================================================================

         SUBROUTINE GET_PT3D_EMIS ( JDATE, JTIME, TSTEP, EM_SURR_PT, ISRM,
     &                            VDEMIS_PT, PT_LAYS )

! Revision History.
!     Aug 12, 15 D. Wong: added code to handle parallel I/O implementation
!     Jun 05, 19 F. Sidi: Bugfix related to Parallel I/O Implementation

!-----------------------------------------------------------------------

! Time step part of laypoint

         USE GRID_CONF, ONLY:  NCOLS, NROWS, IO_PE_INCLUSIVE
         USE STK_PRMS, ONLY :  MY_NSRC, MY_STRT_SRC, MY_END_SRC, 
     &                         MY_STKCOL, MY_STKROW, SOURCE
         USE STK_EMIS, ONLY :  IPSRM, N_EMIS_ISTR, EM_FILE_SURR, EM_FILE_DATE, 
     &                         STKEMIS
         USE PTMET, ONLY    :  EMLAYS, PTMET_CONVT
         USE PRECURSOR_DATA, ONLY : PRECURSOR_MW, SULF_IDX
         USE RUNTIME_VARS, ONLY : LOGDEV, PT3DDIAG, PT3DFRAC, STDATE, STTIME
         USE CENTRALIZED_IO_MODULE, only : interpolate_var
         USE UTILIO_DEFN

         IMPLICIT NONE

! Includes:
         INCLUDE SUBST_CONST     ! physical and mathematical constants
         INCLUDE SUBST_FILES_ID  ! file name parameters (for CTM_PT3D_DIAG)

! Arguments:
         CHARACTER(16), INTENT( IN ) :: EM_SURR_PT( : )
         INTEGER               :: JDATE, JTIME
         INTEGER, INTENT( IN ) :: TSTEP( 3 )
         INTEGER, INTENT( IN ) :: ISRM
         INTEGER, INTENT( OUT) :: PT_LAYS
         REAL, INTENT(INOUT)  :: VDEMIS_PT( :,:,:,: ) 

! Parameters:

         LOGICAL,         EXTERNAL :: WRITE3_DISTR   ! calls WRITE3 directly

! Local variables:
         INTEGER          CDATE      ! previous step start date
         INTEGER          CTIME      ! previous step start time
         INTEGER, SAVE :: LDATE = 0  ! previous date
         INTEGER          LTOP       ! layer containing plume top
         INTEGER          SRC        ! source pointer in this proc sub-domain
         INTEGER          MY_DELTA   ! total number of sources on this processor
         REAL             LFRC       ! intermediate LFRAC
         REAL             TSUM       ! tmp layer frac sum for renormalizing

         CHARACTER(  8 ) :: CINT     ! integer to character buffer for warning messages
         CHARACTER( 16 ) :: PNAME = 'GET_PT3D_EMIS   '   ! procedure name
         CHARACTER( 16 ) :: VNAME    ! variable name buffer

         INTEGER          IOS        ! i/o and allocate memory status
         INTEGER          L, S, V    ! counters
         INTEGER          C, R, I, J, K, N, ISPC

         INTEGER, SAVE :: WSTEP = 0
         INTEGER          WDATE, WTIME
         LOGICAL, SAVE :: WRTIME
         INTEGER, SAVE :: NTICS = 0      ! no. of substeps within an output tstep
         LOGICAL, SAVE :: FIRSTIME = .TRUE.

         INTEGER       :: NDATE, NTIME
         INTEGER, ALLOCATABLE, SAVE :: PRE_EM_FILE_DATE(:)
         
#ifdef Verbose1
         real mxzplm
#endif

C-----------------------------------------------------------------------

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
             
            ! Set up and open 3d point source emissions diagnostic file?
            IF ( PT3DDIAG ) THEN
              NDATE = STDATE; NTIME = STTIME
              CALL NEXTIME( NDATE, NTIME, TSTEP(1) ) ! advance one output tstep
              CALL OPPT3D_DIAG( CTM_PT3D_DIAG, TSTEP(1), 
     &                   EM_FILE_SURR( ISRM )%LEN, EM_FILE_SURR( ISRM )%ARRY( : ),
     &                   EM_FILE_SURR( ISRM )%UNITS( : ) )
 

              ALLOCATE ( VDEMIS_BUF( N_EMIS_ISTR,EMLAYS,NCOLS,NROWS ), STAT = IOS )
              CALL CHECKMEM( IOS, 'VDEMIS_BUF', PNAME )
              VDEMIS_BUF = 0.0   ! array
              WRITE( LOGDEV,'(/5X, A /5X, A )' )
     &                        'Recording 3d point source emissions diagnostics',
     &                        'as a linear average over the output timestep'
#ifdef parallel_io
               IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_PT3D_DIAG, FSREAD3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM(CTM_PT3D_DIAG)
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
                  END IF
               END IF
#endif
            END IF
            ALLOCATE (PRE_EM_FILE_DATE(SIZE(EM_FILE_DATE)), STAT=IOS)
            PRE_EM_FILE_DATE = STDATE
         END IF

C Based on the current time step, find whether or not a report should be written

!         WRITE( XMSG,'(A, I7.6)' )
!     &   'Calculating emissions point source layer fractions for', JTIME
!         WRITE( LOGDEV,* ) ' '
!         CALL M3MSG2( XMSG )
!
!         IF ( LDATE .NE. JDATE ) THEN  ! write day and date to stdout & XMSG
!            CALL WRDAYMSG( JDATE, XMSG )
!            LDATE = JDATE
!            WRITE( LOGDEV,'(9X, "at time ", A)' ) HHMMSS( JTIME )
!         END IF
!         WRTIME = .FALSE.
!         WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
!         IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
!            WDATE = JDATE; WTIME = JTIME
!            CALL NEXTIME( WDATE, WTIME, TSTEP( 2 ) )
!            IF ( .NOT. CURRSTEP( WDATE, WTIME, SDATE, STIME, TSTEP( 1 ),
!     &                           CDATE, CTIME ) ) THEN
!               XMSG = 'Cannot get step date and time'
!               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
!            END IF
!            WDATE = CDATE; WTIME = CTIME
!            WSTEP = 0
!            WRTIME = .TRUE.
!            DO N = 1, NPTGRPS
!               IF ( RDEV( N ) .GT. 0 ) THEN    ! write day, date and time to report file
!                  WRITE( CINT,'( I8 )' ) REP_LAYR
!                  CALL WRDAYMSG( WDATE, XMSG )
!                  XMSG = XMSG( 1:LEN_TRIM( XMSG ) )
!     &                    // ' at time ' // HHMMSS( WTIME )
!     &                    // 'for ltop .ge. ' // TRIM( ADJUSTL( CINT ) )
!                  WRITE( RDEV( N ),93000 ) XMSG( 1:LEN_TRIM( XMSG ) )
!               END IF
!            END DO
!         END IF

C Convert pt source met data to bi-linear interpolated data
         CALL PTMET_CONVT( JDATE, JTIME )

C Initialize Output Array
         !VDEMIS_PT = 0.0   ! array assignment

         N = IPSRM( ISRM )
         PT_LAYS = 1       ! Initialize Point Layers at lowest possible value

         IF ( MY_NSRC( N ) .LE. 0 ) RETURN

         IF ( PT3DFRAC ) THEN   ! Store layer fractions
            ALLOCATE( LFRAC( MY_NSRC( N ),EMLAYS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'LFRAC', PNAME )
            ALLOCATE( ZPLUM( MY_NSRC( N ),EMLAYS ), STAT = IOS )
            CALL CHECKMEM( IOS, 'ZPLUM', PNAME )
            LFRAC = 0.0   ! 2-D array - Initialize layer fraction
            ZPLUM = 0.0   ! 2-D array - Initialize plume centroid height
         END IF

C Ensure that the model and stack groups emissions timestamp dates stay synchronized
         IF ( PRE_EM_FILE_DATE(ISRM) .NE. JDATE ) THEN
            NDATE = JDATE; NTIME = JTIME
            CALL NEXTIME( NDATE, NTIME, -TSTEP( 1 ) )       ! go back one output tstep
            CALL NEXTIME( EM_FILE_DATE( ISRM ), NTIME, TSTEP( 1 ) ) ! advance the start date one time step
            PRE_EM_FILE_DATE(ISRM) = JDATE
         END IF

C Allocate Array to Store the Layer Heights of All Stacks (i.e. sources)
C from this Point Group (i.e. ptgrp)
         ALLOCATE( TFRAC( EMLAYS,MY_NSRC( N ) ), STAT = IOS )
         CALL CHECKMEM( IOS, 'TFRAC', PNAME )
         TFRAC = 0.0   ! array

C Calculate Plume Heights for All Point Sources on this File
         CALL CALC_PLUME_HEIGHT( EM_FILE_DATE( ISRM ), JDATE, JTIME, WRTIME, N   )

C Read Emissions for all sources on File N            
         DO ISPC = 1, N_EMIS_ISTR
            VNAME = EM_SURR_PT( ISPC )
            IF ( VNAME .EQ. '' ) CYCLE
            call interpolate_var (STKENAME(N), VNAME, EM_FILE_DATE( ISRM ), JTIME, STKEMIS(N)%ARRY)

C Apportion emissions to the layers
            DO S = 1, MY_NSRC( N )
               SRC = SOURCE( N )%ARRY( S )
               C = MY_STKCOL( N )%ARRY( S ); R = MY_STKROW( N )%ARRY( S )

               DO L = 1, EMLAYS
                  LFRC = TFRAC( L,S )
                  IF ( LFRC .LE. 0.0 ) CYCLE
                  PT_LAYS = MAX( PT_LAYS, L )

                  ! Save Emissions in Common Array
                  VDEMIS_PT( ISPC,L,C,R ) = VDEMIS_PT( ISPC,L,C,R )
     &                              + LFRC * STKEMIS( N )%ARRY( SRC )

               END DO  ! End Layers Loop
            END DO  ! End Sources Loop
         END DO ! End Loop on Species

         DEALLOCATE( TFRAC )

C Write Out Diagnostic Info            
         IF ( PT3DFRAC .AND. WRTIME ) THEN     ! Write out layer fractions
            IF ( .NOT. WRITE3_DISTR( PLAYNAME( N ), 'LFRAC', WDATE, WTIME,
     &                               MY_NSRC( N ), EMLAYS, LFRAC ) ) THEN
               XMSG = 'Error writing "LFRAC" to file "' //
     &                 PLAYNAME( N )( 1:LEN_TRIM( PLAYNAME( N ) ) ) // '."'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            IF ( .NOT. WRITE3_DISTR( PLAYNAME( N ), 'ZPLUME', WDATE, WTIME,
     &                               MY_NSRC( N ), EMLAYS, ZPLUM ) ) THEN
               XMSG = 'Error writing "ZPLUM" to file "' //
     &                 PLAYNAME( N )( 1:LEN_TRIM( PLAYNAME( N ) ) ) // '."'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            WRITE( LOGDEV,94030 )
     &         'Timestep written to', TRIM( PLAYNAME( N ) ),
     &         'for date and time', WDATE, WTIME
         END IF

         IF ( PT3DFRAC ) THEN
            DEALLOCATE( LFRAC )
            DEALLOCATE( ZPLUM )
         END IF


C Write Out Diagnostic Info         
         IF ( PT3DDIAG ) THEN  ! store 3d point source emissions
            NTICS = NTICS + 1
            VDEMIS_BUF = VDEMIS_BUF + VDEMIS_PT   ! array assignmnt
            IF ( WRTIME ) THEN
               DIVFAC = 1.0 / FLOAT( NTICS )
               WRITE( LOGDEV,94030 )
     &               'Timestep written to', CTM_PT3D_DIAG,
     &               'for date and time', WDATE, WTIME
            VDEMIS_BUF = 0.0   ! array
            NTICS = 0
            END IF
         END IF

         RETURN

C------------------  FORMAT  STATEMENTS   ------------------------------

93000    FORMAT( A / 1X, 'source', 3X, 'ht', 3X, 'lpbl', 1X, 'lbot', 1X, 'ltop',
     &               3X, 'vel', 4X, 'windspeed', 2X, 'StkTemp', 3X, 'AmbTemp' )

93040    FORMAT( 'Sources with top of plume greater than layer', I3, //,
     &           'Src ID, ', A, ', H[m], ', 'V[m/s], ', 'Ts[K], ',
     &           'Ta[K], ', 'U[m/s], ', 'LPBL, ', 'LTOP' )

93042    FORMAT( '( I6, ",", I6.6, ",", A', I2.2, ', ","', I2.2, '(A',
     &           I2.2, ',", ") , F6.1, ", ", F6.2, ", ", F6.1, ", ",',
     &           'F5.1, ", ", F6.2, ", ", I3, ", ", I3 )' )

93044    FORMAT( I6, ",", I6.6, F6.1, ", ", F6.2, ", ", F6.1, ", ",
     &           F5.1, ", ", F6.2, ", ", I3, ", ", I3 )


94030    FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )

         END SUBROUTINE GET_PT3D_EMIS

C-------------- Subprograms used by GET_PT3D_EMIS ----------------------

C=======================================================================

      SUBROUTINE CALC_PLUME_HEIGHT( LOC_STKDATE, JDATE, JTIME, WRTIME, N )

! Revision History.
!     Aug 18, 17 B.Murphy: Separated plume height calculation from the
!                          point source allocation algorithm

C-----------------------------------------------------------------------

      USE VGRD_DEFN, ONLY : VGTOP_GD
      USE STK_EMIS, ONLY : FIREVAR, FIREFLAG
      USE STK_PRMS, ONLY : MY_STRT_SRC, MY_END_SRC, MY_NSRC, SOURCE
      USE PTMET, ONLY : EMLAYS, P_D => PTMET_DATA
      USE RUNTIME_VARS, ONLY : LOGDEV, IPVERT, PT3DFRAC, REP_LAYR, LOG_MESSAGE
      USE UTILIO_DEFN, ONLY : CRLF, XSTAT2
      USE CENTRALIZED_IO_MODULE, only : interpolate_var

      IMPLICIT NONE

C Includes:
      INCLUDE SUBST_CONST     ! physical and mathematical constants

      INTEGER, INTENT( IN ) :: LOC_STKDATE
      INTEGER, INTENT( IN ) :: JDATE, JTIME
         
      LOGICAL, INTENT( IN ) :: WRTIME
      INTEGER, INTENT( IN ) :: N       ! Point Source File Number

      CHARACTER( 16 ) :: PNAME = 'CALC_PLUME_HEIGHT'   ! procedure name
      CHARACTER( 16 ) :: VNAME 
      CHARACTER(  8 ) :: CINT     ! integer to character buffer for warning messages

      REAL,            PARAMETER :: USTARMIN = 0.1   ! Min valid value for USTAR
      REAL,            PARAMETER :: CONVPA = 1.0E-2  ! convert Pa to mb
      REAL,            PARAMETER :: BTU2M4PS3 = 9.2752E-03 ! convert BTU/s to m**4/s**3
      REAL,            PARAMETER :: BFACPHR = BTU2M4PS3 / 3600.0 ! m**4/s**3 per hour
                                 ! assumes heat flux from fire pt src file is in BTU/hr
      REAL             PSFC      ! surface pressure [Pa]
      REAL             USTMP      ! temp storage for ustar [m/s]
      REAL             HFLX       ! converted heat flux
      REAL             ZBOT       ! plume bottom elevation [m]
      REAL             ZTOP       ! plume top    elevation [m]
      REAL             ZPLM       ! plume centerline height above stack [m]
      REAL             ZDIFF      ! ZTOP - ZBOT
      REAL             DDZ        ! 1 / ZDIFF
      REAL             TSTK       ! temperature at top of stack [K]
      REAL             WSTK       ! wind speed  at top of stack [m/s]
      REAL             MV         ! mininum LFRAC 
      REAL             BESIZE     ! effective size of the fire buoyant core
      REAL             SFRACT     ! smoldering fraction size (1-BESIZE)
 
      INTEGER          LBOT       ! layer containing plume bottom
      INTEGER          LPBL       ! first L: ZF(L) above mixing layer - ONLY for REPORT
      INTEGER          LSTK       ! first L: ZF(L) > STKHT

      INTEGER :: S, L, SRC
      INTEGER :: LTOP, LACRESBURNED

      INTERFACE
           SUBROUTINE PREPLM( FIREFLG, EMLAYS, HMIX, HTS, PSFC, TS, DDZF, QV,
     &                        TA, UW, VW, ZH, ZF, PRES, LSTK, LPBL, TSTK,
     &                        WSTK, DTHDZ, WSPD )
             LOGICAL, INTENT( IN )  :: FIREFLG
             INTEGER, INTENT( IN )  :: EMLAYS
             REAL,    INTENT( IN )  :: HMIX
             REAL,    INTENT( IN )  :: HTS
             REAL,    INTENT( IN )  :: PSFC
             REAL,    INTENT( IN )  :: TS
             REAL,    INTENT( IN )  :: DDZF( : )
             REAL,    INTENT( IN )  :: QV  ( : )
             REAL,    INTENT( IN )  :: TA  ( : )
             REAL,    INTENT( IN )  :: UW  ( : )
             REAL,    INTENT( IN )  :: VW  ( : )
             REAL,    INTENT( IN )  :: ZH  ( : )
             REAL,    INTENT( IN )  :: ZF  ( : )
             REAL,    INTENT( IN )  :: PRES( 0: )
             INTEGER, INTENT( OUT ) :: LSTK
             INTEGER, INTENT( OUT ) :: LPBL
             REAL,    INTENT( OUT ) :: TSTK
             REAL,    INTENT( OUT ) :: WSTK
             REAL,    INTENT( OUT ) :: DTHDZ( : )
             REAL,    INTENT( OUT ) :: WSPD ( : )
           END SUBROUTINE PREPLM

           SUBROUTINE PLMRIS( EMLAYS, LSTK, HFX, HMIX,
     &                        STKDM, STKHT, STKTK, STKVE,
     &                        TSTK, USTAR, DTHDZ, TA, WSPD,
     &                        ZF, ZH, ZSTK, WSTK, ZPLM )
             INTEGER, INTENT( IN )  :: EMLAYS
             INTEGER, INTENT( IN )  :: LSTK
             REAL,    INTENT( IN )  :: HFX
             REAL,    INTENT( IN )  :: HMIX
             REAL,    INTENT( IN )  :: STKDM
             REAL,    INTENT( IN )  :: STKHT
             REAL,    INTENT( IN )  :: STKTK
             REAL,    INTENT( IN )  :: STKVE
             REAL,    INTENT( IN )  :: TSTK
             REAL,    INTENT( IN )  :: USTAR
             REAL,    INTENT( IN )  :: DTHDZ( : )
             REAL,    INTENT( IN )  :: TA   ( : )
             REAL,    INTENT( IN )  :: WSPD ( : )
             REAL,    INTENT( IN )  :: ZF ( 0:  )
             REAL,    INTENT( IN )  :: ZH   ( : )
             REAL,    INTENT( IN )  :: ZSTK ( : )
             REAL,    INTENT( INOUT ) :: WSTK
             REAL,    INTENT( OUT ) :: ZPLM 
           END SUBROUTINE PLMRIS

           SUBROUTINE FIRE_PLMRIS( EMLAYS, LSTK, HFX, HMIX,
     &                             BFLX, TSTK, USTAR, DTHDZ,
     &                             TA, WSPD, ZF, WSTK, ZPLM )
             INTEGER, INTENT( IN )  :: EMLAYS
             INTEGER, INTENT( IN )  :: LSTK
             REAL,    INTENT( IN )  :: HFX
             REAL,    INTENT( IN )  :: HMIX
             REAL,    INTENT( IN )  :: BFLX
             REAL,    INTENT( IN )  :: TSTK
             REAL,    INTENT( IN )  :: USTAR
             REAL,    INTENT( IN )  :: DTHDZ( : )
             REAL,    INTENT( IN )  :: TA   ( : )
             REAL,    INTENT( IN )  :: WSPD ( : )
             REAL,    INTENT( IN )  :: ZF ( 0:  )
             REAL,    INTENT( INOUT):: WSTK
             REAL,    INTENT( OUT ) :: ZPLM
           END SUBROUTINE FIRE_PLMRIS

           SUBROUTINE PLSPRD( DTHDZ, ZF, KZ, CEFSTK, PLTOP, PLBOT )
             REAL,    INTENT ( IN ) :: DTHDZ( : )
             REAL,    INTENT ( IN ) :: ZF( 0:  )
             INTEGER, INTENT ( IN ) :: KZ
             REAL,    INTENT ( IN ) :: CEFSTK
             REAL,    INTENT( OUT ) :: PLTOP
             REAL,    INTENT( OUT ) :: PLBOT
           END SUBROUTINE PLSPRD
       END INTERFACE
      
      ! If The Point File is for Fires, read and save the H-Flux Data in a
      ! Dedicated Variable, BFLUX
      LACRESBURNED = 0
      IF ( FIREFLAG( N ) ) THEN
         call interpolate_var (STKENAME(N), 'HFLUX', LOC_STKDATE, JTIME, FIREVAR(N)%ARRY)

         DO S = 1, MY_NSRC( N )
            SRC = SOURCE( N )%ARRY( S )
            BFLUX( N )%ARRY( S ) = FIREVAR( N )%ARRY( SRC ) * BTU2M4PS3
         END DO

         !Initialize negative ACRES-BURNED counter
      END IF
 
C Loop through sources and compute plume rise
      DO S = 1, MY_NSRC( N )

         IF ( FIREFLAG( N ) ) THEN
            IF ( BFLUX( N )%ARRY( S ) .LE. 0.0 ) THEN
               TFRAC( 1,S ) = 1.0
               TFRAC( 2:EMLAYS,S ) = 0.0
               LTOP = 1
               GO TO 201
            END IF
         END IF

         P_D( N )%ZZF( 0 ) = 0.0
         P_D( N )%ZZF( 1:EMLAYS ) = P_D( N )%ZF( 1:EMLAYS,S )  ! array of layers

C Get pressures: Use SIGMA values and surface pres. p=sigma*(psfc-ptop)+ptop
         PSFC = P_D( N )%PRSFC( S )
         DO L = 0, EMLAYS
            P_D( N )%PRESF( L ) = ( VGLVSXG( L ) * ( PSFC - VGTOP_GD )
     &                          +   VGTOP_GD ) * CONVPA
         END DO

C Set surface pressure (convert to mb from Pa)
         PSFC = CONVPA * PSFC

C Compute derived met vars needed before layer assignments
         CALL PREPLM( FIREFLAG( N ), EMLAYS,
     &                P_D( N )%HMIX( S ), STK_HT( N )%ARRY( S ), PSFC,
     &                P_D( N )%TSFC( S ),    P_D( N )%DDZF( :,S ),
     &                P_D( N )%QV( :,S ),    P_D( N )%TA( :,S ),
     &                P_D( N )%UWIND( :,S ), P_D( N )%VWIND( :,S ),
     &                P_D( N )%ZH( :,S ),    P_D( N )%ZF( :,S ),
     &                P_D( N )%PRESF, LSTK,  LPBL, TSTK, WSTK,
     &                P_D( N )%DTHDZ,        P_D( N )%WSPD )

C Trap USTAR at a minimum realistic value
         USTMP = MAX( P_D( N )%USTAR( S ), USTARMIN )

C Convert heat flux (watts/m2 to m K /s )
         HFLX = P_D( N )%HFX( S ) / ( CPD * P_D( N )%DENS( 1,S ) )

         IF ( .NOT. FIREFLAG( N ) ) THEN
            CALL PLMRIS( EMLAYS, LSTK, HFLX, P_D( N )%HMIX( S ),
     &                   STK_DM( N )%ARRY( S ), STK_HT( N )%ARRY( S ),
     &                   STK_TK( N )%ARRY( S ), STK_VEL( N )%ARRY( S ),
     &                   TSTK, USTMP,
     &                   P_D( N )%DTHDZ,     P_D( N )%TA( :,S ),
     &                   P_D( N )%WSPD,      P_D( N )%ZZF,
     &                   P_D( N )%ZH( :,S ), P_D( N )%ZSTK( :,S ),
     &                   WSTK, ZPLM )
         ELSE
            CALL FIRE_PLMRIS( EMLAYS, LSTK, HFLX, P_D( N )%HMIX( S ),
     &                   BFLUX( N )%ARRY( S ),
     &                   TSTK, USTMP,
     &                   P_D( N )%DTHDZ,     P_D( N )%TA( :,S ),
     &                   P_D( N )%WSPD,      P_D( N )%ZZF,
     &                   WSTK, ZPLM )
         END IF

#ifdef Verbose1
         if ( zplm .gt. mxzplm ) mxzplm = zplm
#endif

C Determine the bottom and top heights of the plume.
         IF ( IPVERT .EQ. 0 ) THEN
C Default Turner approach.  Plume thickness = amount of plume rise
C Plume rise DH = ZPLM minus the stack height STKHT
            IF ( FIREFLAG( N ) ) THEN
               ZTOP = 1.5 * ZPLM 
               ZBOT = 0.5 * ZPLM
            ELSE
               ZTOP = STK_HT( N )%ARRY( S )
     &              + 1.5 * ( ZPLM - STK_HT( N )%ARRY( S ) )
               ZBOT = STK_HT( N )%ARRY( S )
     &              + 0.5 * ( ZPLM - STK_HT( N )%ARRY( S ) )
            END IF
         ELSE
C Alternative method to compute plume top/bot heights
            CALL PLSPRD( P_D( N )%DTHDZ, P_D( N )%ZZF, EMLAYS,
     &                   ZPLM, ZTOP, ZBOT )
         END IF

C Set up for computing plume fractions, assuming uniform distribution in pressure
C (~mass concentration -- minor hydrostatic assumption) from bottom to top.

         IF ( ZTOP .LT. STK_HT( N )%ARRY( S ) ) THEN
            WRITE( CINT,'( I8 )' ) S
            WRITE( XMSG,94010 ) 'ERROR: Top of plume is less than '
     &                          // 'top of stack for source:' // CINT
            CALL M3MESG( XMSG )
            WRITE( LOGDEV,* ) '    Zbot: ', ZBOT, ' Ztop: ', ZTOP
            WRITE( LOGDEV,* ) '    Stack Top: ', STK_HT( N )%ARRY( S ),
     &                        ' Plume Top: ', ZPLM
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
         END IF

C Allocate plume to layers (compute layer plume fractions)

!              CALL POSTPLM( EMLAYS, ZBOT, ZTOP, PRESF, ZZF, TA( 1,S ), ZH( 1,S ),
!    &                       LTOP, TFRAC )

C Compute LBOT, LTOP such that
C  ZZF( LBOT-1 ) <= ZBOT < ZZF( LBOT ) and
C  ZZF( LTOP-1 ) <= ZTOP < ZZF( LTOP )

         DO L = 1, EMLAYS - 1
            IF ( ZBOT .LE. P_D( N )%ZZF( L ) ) THEN
               LBOT = L
               GO TO  122
            ELSE
               TFRAC( L,S ) = 0.0             ! fractions below plume
            END IF
         END DO
         LBOT = EMLAYS                      !  fallback

122      CONTINUE                           !  loop exit:  bottom found at LBOT

         IF ( ZTOP .LE. P_D( N )%ZZF( LBOT ) ) THEN  ! plume in this layer

            TFRAC( LBOT,S ) = 1.0
            LTOP = LBOT

            DO L = LBOT + 1, EMLAYS         ! fractions above plume
               TFRAC( L,S ) = 0.0
            END DO

         ELSE IF ( LBOT .EQ. EMLAYS ) THEN  ! plume above top layer

            TFRAC( LBOT,S ) = 1.0

            DO L = 1, EMLAYS - 1            ! fractions below plume
               TFRAC( L,S ) = 0.0
            END DO

         ELSE                               ! plume crosses layers

            DO L = LBOT + 1, EMLAYS
               IF ( ZTOP .LE. P_D( N )%ZZF( L ) ) THEN
                  LTOP = L
                  GO TO 126
               END IF
            END DO
            LTOP = EMLAYS                   !  fallback

126         CONTINUE

            ZDIFF = ZTOP - ZBOT
            IF ( ZDIFF .GT. 0.0 ) THEN

               DDZ  = 1.0 / ZDIFF
               TFRAC( LBOT,S ) = DDZ * ( P_D( N )%ZZF( LBOT ) - ZBOT )
               TFRAC( LTOP,S ) = DDZ * ( ZTOP - P_D( N )%ZZF( LTOP-1 ) )

            ELSE   ! ZDIFF .le. 0

               WRITE( CINT,'( I8 )' ) S
               WRITE( XMSG,94020 )
     &            'Infinitely small plume created for source:,'
     &            // CINT // CRLF() // BLANK10
     &            // 'All emissions put in first layer.'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               LBOT = 1; LTOP = 1
               TFRAC( LBOT,S ) = 1.0

            END IF

            DO L = LBOT + 1, LTOP - 1       ! layers in plume
               TFRAC( L,S ) = DDZ * ( P_D( N )%ZZF( L ) - P_D( N )%ZZF( L-1 ) )
            END DO

            DO L = LTOP + 1, EMLAYS         ! fractions above plume
               TFRAC( L,S ) = 0.0
            END DO

         END IF

C If layer fractions are negative, put in the first layer
         MV = MINVAL( TFRAC( 1:EMLAYS,S ) )
         IF ( MV .LT. 0.0 ) THEN

            WRITE( CINT,'( I8 )' ) S
            WRITE( XMSG,94010 ) 'WARNING: One or more negative plume '
     &               // 'fractions found for source:' // CINT
     &               // CRLF() // BLANK10 // 'Plume reset to '
     &               // 'put all emissions in surface layer.'
            CALL M3MESG( XMSG )

            TFRAC( 1,S ) = 1.0
            TFRAC( 2:EMLAYS,S ) = 0.0

         END IF

         IF ( FIREFLAG( N ) ) THEN
C If source is a fire, adjust for fire smoldering effects (include fractions below LBOT)
C calculate smoldering fraction:

             IF ( ACRES( N )%ARRY ( S ) .GT. 0.0 ) THEN
                BESIZE = 0.0703 * LOG( ACRES( N )%ARRY( S ) ) + 0.3
                BESIZE = MIN( BESIZE, 1.0 )
                SFRACT = 1.0 - BESIZE
             ELSE
                SFRACT = 1.0
                LACRESBURNED = LACRESBURNED + 1
             END IF

             ZDIFF = ZBOT - P_D( N )%ZZF( 0 )   ! Note: ZDIFF redefined
             IF ( ZDIFF .GT. 0.0 ) THEN
                DDZ  = 1.0 / ZDIFF
                DO L = 1, LBOT - 1
                  TFRAC( L,S ) = DDZ * ( P_D( N )%ZZF( L ) - P_D( N )%ZZF( L-1 ) )
     &                       * SFRACT
                END DO
                TFRAC( LBOT,S ) = TFRAC( LBOT,S )
     &                        + ( DDZ * ( ZBOT - P_D( N )%ZZF( LBOT-1 ) )
     &                          - TFRAC( LBOT,S ) ) * SFRACT
             ELSE   ! LBOT = 1
!               TFRAC( 1:LBOT-1 ) = 0.0
                TFRAC( LBOT,S ) = TFRAC( LBOT,S ) * ( 1.0 - SFRACT )
             END IF

             DO L = LBOT + 1, LTOP
                TFRAC( L,S ) = TFRAC( L,S ) * ( 1.0 - SFRACT )
             END DO

         END IF

201      CONTINUE
 
         IF ( PT3DFRAC ) THEN   ! Store layer fractions
            LFRAC( S,1:EMLAYS ) = TFRAC( 1:EMLAYS,S )  ! array
            ZPLUM( S,1 ) = ZPLM
         END IF

C Possible report to REPRTLAY
         IF ( LTOP .GE. REP_LAYR .AND. RDEV( N ) .GT. 0 .AND. WRTIME ) THEN
              WRITE( RDEV( N ),93048 ) S, STK_HT( N )%ARRY( S ), LPBL,
     &                                     LBOT, LTOP, STK_VEL( N )%ARRY( S ), WSTK,
     &                                     STK_TK( N )%ARRY( S ), TSTK
         END IF


      END DO    ! end loop on sources S

      ! Print warning if any ACRES-BURNED values were negative
      IF ( LACRESBURNED .GT. 0 ) THEN
           write( XMSG,'(A,I8,A,I8,A)') "Warning: the value of ACRESBURNED for ",LACRESBURNED, " fire sources on stream ",
     &                     N, " is negative. CMAQ will set the smodlering fraction equal to 1.0 for these cases." 
           call log_message( logdev, xmsg )
      END IF
     

94010 FORMAT( 12( A, :, I8, :, 1X ) )
94020 FORMAT( 10( A, :, I7, :, 1X ) )
93048 FORMAT( I6, F8.2, 3I4, 4F10.2 )


      END SUBROUTINE CALC_PLUME_HEIGHT

C-----------------------------------------------------------------------

         SUBROUTINE RETRIEVE_IOAPI_HEADER( FNAME, JDATE, JTIME )

            USE UTILIO_DEFN, ONLY : DESC3, XSTAT2

            IMPLICIT NONE

            CHARACTER( * ) :: FNAME
            INTEGER        :: JDATE, JTIME

            CHARACTER( 16 )  :: PNAME = 'RETRVE_IOAPI_HDR'   ! procedure name
            CHARACTER( 120 ) :: XMSG = ' '

            IF ( .NOT. DESC3( FNAME ) ) THEN
               XMSG = 'Could not get description of file "' //
     &                FNAME( 1:LEN_TRIM( FNAME ) ) // '"'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF

            RETURN

         END SUBROUTINE RETRIEVE_IOAPI_HEADER

C-----------------------------------------------------------------------

      END MODULE PT3D_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPEMIS ( JDATE, JTIME, EM_TRAC )

C  7 Mar 02 - J.Young: add units string variations
C 29 Oct 05 - J.Young: dyn. layers
C 19 Feb 08 - David Wong: add EM_TRAC = .TRUE. when EMIS_TRAC_1 exists
C 21 Jun 10 - J.Young: convert for Namelist redesign
C 16 Feb 11 - S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                        removed deprecated TRIMLEN

      USE RUNTIME_VARS    
      USE VGRD_DEFN           ! vertical layer specifications
      USE CGRID_SPCS          ! CGRID mechanism species
      USE UTILIO_DEFN
!     USE RXNS_DATA, only : MECHNAME 
      USE EMIS_VARS
      USE EMIS_DEFN
      USE AERO_DATA, only : AEROMODE, N_MODE, MGPG, GPKG
      USE VDIFF_MAP, only : N_SPC_DIFF, DIFF_SPC, DIFF_MASK_AERO

      IMPLICIT NONE

      INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:

      INTEGER      JDATE      ! current model date, coded YYYYDDD
      INTEGER      JTIME      ! current model time, coded HHMMSS
      LOGICAL      EM_TRAC    ! are there tracer emissions?
      INTEGER      NLAY_FILE  ! keep a running maximum of the layers from the gridded files

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'OPEMIS'
      CHARACTER(200 ) :: XMSG
      CHARACTER( 16 ) :: UNITSCK

      LOGICAL ::   LAERO
      LOGICAL ::   WRFLG = .FALSE.
      INTEGER      STATUS, IOS
      INTEGER      V, N, S, ISRM, ITRAC, IGR, IVAR, X    

C-----------------------------------------------------------------------
 
      CALL LOG_SUBHEADING( LOGDEV,'Open Gridded Emissions' )

      EM_GRID_LAYS = 0

C Open All Tracer Emission Files
      DO ISRM = 1,N_EM_SRM
        IF ( EM_FILE_TYPE( ISRM ) .EQ. 'TRAC' ) THEN
           ITRAC = ITSRM( ISRM )

           IF ( .NOT. OPEN3( EM_FILE_NAME( ISRM ), FSREAD3, PNAME ) ) THEN
              XMSG = 'Could not open tracer file'
              CALL M3MESG( XMSG )
           ELSE
             ! Save Tracer Variables for Use in Emissions Species Check
             ! Routine
             EM_FILE_SURR( ISRM )%LEN = NVARS3D
             ALLOCATE ( EM_FILE_SURR( ISRM )%ARRY( NVARS3D ), STAT = STATUS )
             ALLOCATE ( EM_FILE_SURR( ISRM )%UNITS( NVARS3D ), STAT = STATUS )
             EM_FILE_SURR( ISRM )%ARRY = VNAME3D( 1:NVARS3D )

             ! Assign Tracer Emissions Species
             IF ( .NOT. DESC3( EM_FILE_NAME( ISRM ) ) ) THEN
                XMSG = 'Could not get '// EM_FILE_NAME( ISRM ) // ' file description'
                CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
             END IF

             ! Assign Layers to Common Vector
             EM_GRID_LAYS( ISRM ) = NLAYS3D
              
             ! Check Units For Consistency
             UNITSCK = 'BLANK'
             DO N = 1,NVARS3D
                V = INDEX1( VNAME3D( N ), N_SPC_DIFF, DIFF_SPC )
                IF ( V .NE. 0 ) THEN
                  IF ( UNITSCK .EQ. 'BLANK' ) UNITSCK = UNITS3D( N )
                  IF ( UNITS3D( N ) .NE. UNITSCK ) THEN
                     XMSG = 'Units not uniform on ' // EM_FILE_LAB( ISRM )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                  END IF
                END IF
                EM_FILE_SURR( ISRM )%UNITS( N ) = UNITS3D( N )
             END DO 
           END IF

        END IF   ! tracer emissions
      END DO


C Open Gridded Emission Files (for gas chem, aerosols and non-reactive species)
      DO ISRM = 1,N_EM_SRM
        IF ( EM_FILE_TYPE( ISRM ) .EQ. 'GRID' ) THEN
          IGR = IGSRM( ISRM )
 
          IF ( .NOT. OPEN3( EM_FILE_NAME( ISRM ), FSREAD3, PNAME ) ) THEN
              XMSG = 'Could not open file ' // EM_FILE_NAME( ISRM )
              CALL M3MESG( XMSG )
          ELSE
 
            IF ( .NOT. DESC3( EM_FILE_NAME( ISRM ) ) ) THEN
              XMSG = 'Could not get '// EM_FILE_NAME( ISRM ) // ' file description'
              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            
            ! Let the date for this emission stream come from the model
            ! by default or the file if the user wishes to override the
            ! default for representative day files
            EM_FILE_DATE( ISRM ) = JDATE
            IF ( EM_FILE_SYM_DATE( ISRM ) )  EM_FILE_DATE( ISRM ) = SDATE3D

            ! Save Area Source Species Names For Use in Emissions Species
            ! Check Routine
            EM_FILE_SURR( ISRM )%LEN = NVARS3D
            ALLOCATE ( EM_FILE_SURR( ISRM )%ARRY( NVARS3D ), STAT = STATUS )
            ALLOCATE ( EM_FILE_SURR( ISRM )%UNITS( NVARS3D ), STAT = STATUS )
            EM_FILE_SURR( ISRM )%ARRY = VNAME3D( 1:NVARS3D )
           
            ! Assign Area Source Emission Species
            EM_GRID_LAYS( ISRM ) = NLAYS3D

            ! Assign Units
            DO IVAR = 1,NVARS3D
                  ! A match has been found
                  UNITSCK = UNITS3D( IVAR )
                  CALL UPCASE( UNITSCK )
                  EM_FILE_SURR( ISRM )%UNITS( IVAR ) = UNITS3D( IVAR )
            END DO
          END IF
        END IF    ! (gridded emission file)
      END DO

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header$

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%


      SUBROUTINE INIT_DEGRADE( CBLK, TCELL, DCELL, PHOTO_CELL,
     &                         JDATE, JTIME )
C**********************************************************************
C
C  FUNCTION:  Initialize arrays used by degrade routines then load
C             CBLK concentration needed in degrade routines.
C
C  CALLED BY: HRDRIVER
C
C  REVISION HISTORY:  07/29/05 : B.Hutzell - Initial version
C                     09/30/11 : B.Hutzell - added CYCLE statements to allow 
C                                optional degraded species i.e., RXTANT_MAP( I )
C                                is less than zero
C
C**********************************************************************

      USE RUNTIME_VARS
      USE RXNS_DATA
      USE DEGRADE_SETUP_TOX

      IMPLICIT NONE


C.....ARGUMENTS:

      REAL( 8 ), INTENT( IN ) :: CBLK( : )                 !  species concentration in cell
      REAL,      INTENT( IN ) :: TCELL                     !  cell temperature  [ k ]
      REAL,      INTENT( IN ) :: DCELL                     !  cell air density  [ kg/m^3 ]
      REAL( 8 ), INTENT( IN ) :: PHOTO_CELL( : )           !  Photolysis table for cell [1/s]

      INTEGER, INTENT( IN ) :: JDATE  ! current model date , coded YYYYDDD
      INTEGER, INTENT( IN ) :: JTIME  ! current model time , coded HHMMSS

C.....LOCAL VARIABLES:

      CHARACTER( 144 )        :: XMSG                   ! Message text
      CHARACTER( 16  ), SAVE  :: PNAME = 'INIT_DEGRADE' ! Routine name

      REAL(8), SAVE ::  MASS_TO_NUMBER ! air mass density( Kg/m3) to number density( #/cm3 ) [ (# per moles)/Kg ]

      REAL(8), SAVE ::  CONV_M2N       ! factor to convert ppm times mass density in [kg/m^3]
                                       ! into number density in [molecules/cm^3]
                                       
      REAL(8)       ::  CONV_FACT      ! conversion factor from ppm to molecules/cm^3
      REAL(8)       ::  INV_TEMP       ! reciprocal of temperature, [K^-1]

      INTEGER       :: I, J, K        ! loop counters
      INTEGER, SAVE :: ISIZE          ! dimension of CBLK array
      
      LOGICAL, SAVE ::  FIRSTCALL = .TRUE. 

C**********************************************************************

      IF ( FIRSTCALL ) THEN  ! initialize constants and allocate arrays


         MASS_TO_NUMBER = REAL( 1.0E-3*AVO / MWAIR, 8 )
         
         CONV_M2N       = 1.0D-6 * MASS_TO_NUMBER

         ISIZE = SIZE( CBLK )
         
         ALLOCATE( PREV_CONC( ISIZE ) )
         ALLOCATE( CURR_CONC( ISIZE ) )
         ALLOCATE( DELT_CONC( ISIZE ) )

         FIRSTCALL = .FALSE.

         EFFECTIVE_ZERO  = 5.0D0 * TINY( CONV_M2N )

      ENDIF

C..initialize concentrations and their changes
      DELT_CONC  = 0.0D0
      RATE_CONST = 0.0D0

      DO I = 1, ISIZE
         PREV_CONC( I ) = MAX( CBLK( I ), 0.0D0 )
         CURR_CONC( I ) = PREV_CONC( I )
      END DO
         

      NUMB_DENS = MASS_TO_NUMBER * REAL( DCELL, 8 )
      TEMP = REAL( TCELL, 8 )

      CONV_FACT  = CONV_M2N * REAL( DCELL, 8 )
      INV_TEMP   = 1.0D0 / TEMP

      LOOP_REACT: DO I = 1, N_REACT ! calculated rate constants

         IF( RXTANT_MAP( I ) < 0 )CYCLE LOOP_REACT

         LOOP_UNIRATE: DO J = 1, N_UNI_LOSS
            IF( UNIRATE( I, J ) .LT. EFFECTIVE_ZERO )CYCLE
            RATE_CONST( I, J ) = UNIRATE( I, J )
     &                         * TEMP**UNI_TEXP( I, J )
     &                         * DEXP( -UNI_ACT( I, J )*INV_TEMP )

         END DO LOOP_UNIRATE

         LOOP_BIRATE: DO J = 1, N_BI_LOSS
            IF( BIRATE( I, J ) .LT. EFFECTIVE_ZERO )CYCLE
            RATE_CONST( I, J+UNI_STOP ) = CONV_FACT * BIRATE( I, J )
     &                                  * TEMP**BI_TEXP( I, J )
     &                                  * DEXP( -BI_ACT( I, J )*INV_TEMP )

         END DO LOOP_BIRATE

         LOOP_TRIRATE: DO J = 1, N_TRI_LOSS
            IF( TRIRATE( I, J ) .LT. EFFECTIVE_ZERO )CYCLE
            RATE_CONST( I, J+BI_STOP ) = CONV_FACT * CONV_FACT * TRIRATE( I, J )
     &                                 * TEMP**TRI_TEXP( I, J )
     &                                 * DEXP( -TRI_ACT( I, J )*INV_TEMP )

         END DO LOOP_TRIRATE

         LOOP_PHOTORATE: DO J = 1, N_PHOTO_LOSS

            K = PHOTO_MAP( I, J )
            IF ( K < 1 ) CYCLE
            IF( A_PHOTO( I, J ) .LT. EFFECTIVE_ZERO )CYCLE
            RATE_CONST( I, J+TRI_STOP ) = A_PHOTO( I, J )
     &                                  * PHOTO_CELL( K )

         END DO LOOP_PHOTORATE

      END DO LOOP_REACT


      DO I = 1, N_REACT
         J = RXTANT_MAP( I )
         IF( J < 0 )CYCLE 
      END DO

      RETURN

      END SUBROUTINE INIT_DEGRADE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE EMIS_DEFN

C-----------------------------------------------------------------------
C Function: emissions interface to the chemistry-transport model

C Revision History:
C     28 Jul 2006 J.Young: initial implementation
C     18 Aug 2007 J.Young: move beis part to separate module; add plume rise
C     23 Sep 2009 B.Hutzell: modified algorithm that loads gas emissions from point
C                 sources into VDEMIS array to enable multi-use of an emission species
C     26 Jan 2010 J.Young: fix bug overwriting point source layer 1 NH3; inline rdemis
C     07 Jan 2011 B.Hutzell: updated for namelist definition of model species
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN;
C                            removed deprecated TRIMLEN
C      6 Apr 2011 J.Young, R.Pinder: add lightning NO emissions capability
C     11 May 2011 D.Wong: incorporated twoway model implementation
C      5 Jun 2012 J.Bash: Added support for NH3 bidirectional exchange. Fertilizer
C                         sector emissions are subtracted from the total NH3 emissions
C                         if the CTM_ABFLUX flag is set
C     07 Nov 14 J.Bash: Updated for the ASX_DATA_MOD shared data module. 
C     24 Feb 16 B.Murphy: Generalize scaling of point source species based on
C                         mapping model species, not point source species
C     03 Mar 16 B.Gantt/G. Sarwar: incorporated halogen emissions
C     08 Aug 2016 B.Murphy: Neglect fire emissions for pcVOC
C     12 Jan 2017 B.Murphy: Remove warning when model species are not
C                           read in correctly. Invoke error and model stop when model 
C                           species are not found on any emission file
C     16 NOv 2018 S.Napelenok: ISAM implementation
C     01 Feb 2019 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                         clauses, replaced IOS with LOGDEV when calling GET_ENV
C     15 May 2019 D.Wong: Put the check for using marine gas emission or not in RUNTIME_VAR.F
C     4 Oct 2019 D.Wong: fixed the time advancement, NEXTIME, for a multi-day run in subroutine
C                        GRIDEMIS
C     22 Nov 2019 F. Sidi: Re-introduced date override variable for representative
C                          Day Emissions
C     16 Dec 2019 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE GRID_CONF           ! horizontal & vertical domain specifications      
      USE EMIS_VARS
      USE VDIFF_MAP, ONLY : N_SPC_DIFF
      USE UTILIO_DEFN

      IMPLICIT NONE

      PUBLIC EMIS_INIT, GET_EMIS, EM_GRID_LAYS
      
      PRIVATE
      
     
      INTEGER, ALLOCATABLE, SAVE :: EM_GRID_LAYS( : ) ! no. of area emission layers
      
      LOGICAL, ALLOCATABLE, SAVE :: EM_MASK_AERO( : )! Store the location of aerosol species in master 
                                                     ! emissions vector
      

      LOGICAL, SAVE :: EM_TRAC    ! do tracer emissions?
      REAL,    SAVE :: DT         ! TSTEP (output) in sec

      INTEGER, SAVE :: STRT_GC, FINI_GC, STRT_AE, FINI_AE,
     &                 STRT_NR, FINI_NR, STRT_TR, FINI_TR
      INTEGER, SAVE :: SDATE, STIME  ! scenario start date/time (beis)
      INTEGER       :: LDATE, LTIME  ! step start date/time (beis)
      INTEGER, SAVE :: NDATE, NTIME  ! step next date/time (beis)

      REAL(8), SAVE   :: DX1, DX2          ! CX x1- and x2-cell widths

      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION EMIS_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

         USE CGRID_SPCS          ! CGRID mechanism species
         USE BEIS_DEFN           ! biogenic emissions
         USE MGEMIS              ! marine gas emissions
         USE LTNG_DEFN           ! NO emissions from lightning strikes
         USE PT3D_DEFN           ! plume rise emissions
         USE UTILIO_DEFN         ! I/O API
         USE AERO_EMIS           ! inherits GRID_CONF
         USE AERO_DATA           ! access subroutine map_pmemis

#ifdef isam
         USE SA_DEFN, ONLY : SA_VDEMIS_DIFF, NTAG_SA, SA_VDEMIS_CONV, NSPC_SA,
     &                       SA_VDEMIS_CONV_OTHER
#endif

#ifdef sens
        USE DDM3D_DEFN, ONLY: NP, NPMAX, SVDEMIS_DIFF
#endif

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_CONST     ! constants

C Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP   ! TSTEP is output time step (HHMMSS)
         LOGICAL :: SUCCESS

C Parameters:
                                        
C Local Variables:

         CHARACTER( 16 ) :: PNAME = 'EMIS_INIT'
         CHARACTER( 80 ) :: VARDESC   ! env variable description
         CHARACTER( 120 ) :: XMSG = ' '
         INTEGER V, STATUS, ISRM

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD
     &          * COS( PI180*( YORIG_GD + YCELL_GD*FLOAT( GL_NROWS/2 )))! in m.
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF

C Retrieve Number of Emission Files of Various Types (sectors)
         CALL EM_FILE_INIT( JDATE, JTIME )
         IF ( N_EM_SRM .EQ. 0 ) THEN 
            XMSG = 'No Emissions Streams Have Been Selected.'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .TRUE.; RETURN
         END IF

C Open Area Emissions files
         CALL OPEMIS ( JDATE, JTIME, EM_TRAC )

C Get number of emissions layers
         IF ( EMLAYS_MX .LE. 0 ) THEN
            ! Find The Largest Gridded Emission Layer And Let That be
            ! the initial top.
            EMLAYS = MAXVAL( EM_GRID_LAYS(:) ) 
            
            ! If there are 3D (inline point or Lightning) sources, 
            ! revise the top to be the model top.
            IF ( NPTGRPS .GT. 0 .OR. LTNG_NO ) EMLAYS = NLAYS

            ! Make sure the top is not greater than the model top
            EMLAYS = MAX( MIN( EMLAYS, NLAYS ), 1 )
         ELSE
           ! Make sure the top is not greater than the model top
           EMLAYS = MIN( EMLAYS_MX, NLAYS )

         END IF

         WRITE( LOGDEV,1009 ) EMLAYS, NLAYS
1009     FORMAT(    5X, 'Number of Emissions Layers:         ', I3
     &           /  5X, 'out of total Number of Model Layers:', I3 )


C Initialize 3D Point Source Emissions 
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Point Emissions' )
         IF ( .NOT. PT3D_INIT( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing plume rise emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
 
C Initialize Online Biogenic Emissions
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Biogenic Emissions' )
         IF ( .NOT. BEIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing biogenics emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize Online Marine Gas Emissions
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Marine Gas Emissions' )
         IF ( .NOT. MGEMIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing marine gas emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize Online Lightning NOx Emissions
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Lightning NO Emissions' )
         IF ( .NOT. LTNG_INIT( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing lightning emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Initialize Aerosol Emissions         
         CALL LOG_SUBHEADING( LOGDEV,'Process Aerosol Emissions' )
         IF ( .NOT. AERO_EMIS_INIT( JDATE, JTIME, TSTEP ) ) THEN
            XMSG = 'Failure initializing aerosol emissions module'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

C Map the Emissions Species Available on the Input Files To the
C Surrogates Identified by the User via the Namelists and Stop the model
C or Print Warnings if Mistakes Are Made.

         CALL EMIS_SPC_MAP( JDATE, JTIME )
         IF ( IO_PE_INCLUSIVE ) CALL OPEN_EMISS_DIAG( JDATE, JTIME, TSTEP )

C Allocate Space for Master Emissions Computation
         ALLOCATE ( VDEMIS_DIFF( N_SPC_DIFF,EMLAYS,NCOLS,NROWS ),STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'VDEMIS_DIFF memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

#ifdef isam
         ALLOCATE ( SA_VDEMIS_DIFF( NSPC_SA,   EMLAYS,NCOLS,NROWS, NTAG_SA ),
     &              SA_VDEMIS_CONV( N_SPC_DIFF,EMLAYS,NCOLS,NROWS, NTAG_SA ), 
     &              SA_VDEMIS_CONV_OTHER( N_SPC_DIFF,EMLAYS,NCOLS,NROWS ), 
     &                                                  STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'SA_VDEMIS_DIFF memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
#endif

#ifdef sens
         ALLOCATE ( SVDEMIS_DIFF( N_SPC_DIFF,EMLAYS,NCOLS,NROWS,NPMAX ),STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'SVDEMIS_DIFF memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
#endif

C Return From Initialization
         SUCCESS = .TRUE.; RETURN

         END FUNCTION EMIS_INIT

C-----------------------------------------------------------------------
         SUBROUTINE GET_EMIS ( JDATE, JTIME, TSTEP, CGRID )

C NEW APPROACH:
C Apply NML factors to all *input* emissions and inline plume rise, aero emis
C biog, SeaSalt, Dust, and Lightning NO
C GET_AERO_EMIS has to apply factors - don`t do it at this level.

         USE CGRID_SPCS          ! CGRID mechanism species
         USE AERO_EMIS           ! inherits GRID_CONF
         USE BEIS_DEFN           ! biogenic emissions
         USE BIOG_EMIS, ONLY: MSPCS
         USE SSEMIS
         USE DUST_EMIS
         USE MGEMIS              ! marine gas emissions
         USE PT3D_DEFN           ! plume rise emissions
         USE LTNG_DEFN           ! lightning NO emissions
         USE UTILIO_DEFN
         USE HGRD_DEFN
         USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
         USE RXNS_DATA, ONLY: MECHNAME
         USE AERO_DATA, ONLY : AERONUM_MAP, AEROSRF_MAP, DUSTOUTM

#ifdef isam
         USE SA_DEFN, ONLY : SA_VDEMIS_DIFF, ITAG, NTAG_SA, TAGSTREAMS,
     &                       STREAM_TO_TAG, OTHRTAG, TAGSTREAMS_TEMP,
     &                       TAGSTREAMS_NUM, SA_VDEMIS_CONV,
     &                       SA_VDEMIS_CONV_OTHER,
     &                       MAP_DIFFtoSA, SPC_NAME, NSPC_SA,
     &                       ISAMRGN_TEMP, ISAMRGN, ISAMRGN_NUM,
     &                       ISAMRGN_MAP, TAGS_PER_STREAM,
     &                       ISAM_PVO3_MAP, L_OZONE
         USE VDIFF_MAP, ONLY : DIFF_MAP, DIFF_SPC
#endif

#ifdef sens
         USE DDM3D_DEFN, ONLY: NP, NPMAX, SVDEMIS_DIFF, IPT, SENNUM,
     &                         S_STREAMLBL, S_NSTREAMS, IPARM, IREGION,
     &                         STREAM_TO_SENS, SENS_PER_STREAM
         USE VDIFF_MAP, ONLY : DIFF_MAP
#endif

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME  ! date (YYYYDDD), time (HHMMSS)
         INTEGER, INTENT( IN ) :: TSTEP( 3 )    ! time step vector (HHMMSS)
         REAL, POINTER :: CGRID( :,:,:,: )

C Local Variables:
         REAL             DELT          ! interpolation factor
         INTEGER          C, R, L, N, S, V, ISTR, ISRM, NL ! loop induction variables
         INTEGER          S_STRT, S_END ! substitute loop induction variables
         REAL, ALLOCATABLE, SAVE :: VDEMIS_READ  ( :,:,:,: ) ! Emissions as they are provided by each stream
         REAL, ALLOCATABLE, SAVE :: VDEMIS_SCALED( :,:,:,: ) ! Emissions after user scaling, and spatial scaling
         REAL, ALLOCATABLE, SAVE :: VDEMIS_CONV  ( :,:,:,: ) ! Emissions after converting to units for VDIFF
         

         CHARACTER( 16 ) :: VNAME
         CHARACTER( 16 ) :: PNAME = 'GET_EMIS'
         CHARACTER( 120 ):: XMSG = ' '
         INTEGER         :: ERROR_NEG
         INTEGER, SAVE   :: WSTEP, MDATE, MTIME
         LOGICAL         :: WRTIME
         LOGICAL, SAVE   :: FIRST_TIME = .TRUE.

#ifdef isam
         INTEGER                    :: IDX, SPC, LAYER, RGN
         CHARACTER(96)              :: TXTSTRING
         REAL                       :: MINCHECK, TOTAL
#endif
C-----------------------------------------------------------------------

         IF ( FIRST_TIME ) THEN
            FIRST_TIME = .FALSE.

            ALLOCATE( VDEMIS_READ  ( N_EMIS_ISTR,EMLAYS,NCOLS,NROWS ),
     &                VDEMIS_SCALED( N_EMIS_ISTR,EMLAYS,NCOLS,NROWS ),
     &                VDEMIS_CONV  ( N_SPC_DIFF, EMLAYS,NCOLS,NROWS ) )

#ifdef isam
C Map Emissions streams to ISAM tags
            ALLOCATE( STREAM_TO_TAG( N_EM_SRM, NTAG_SA ),
     &                TAGS_PER_STREAM( N_EM_SRM ),
     &                MAP_DIFFtoSA ( NSPC_SA  ),
     &                TAGSTREAMS( NTAG_SA, N_EM_SRM ) )
            STREAM_TO_TAG   = 0
            TAGS_PER_STREAM = 0
            MAP_DIFFtoSA    = 0
            TAGSTREAMS      = 'empty'

#ifdef potvorto3
            ALLOCATE ( ISAM_PVO3_MAP( NTAG_SA ) )
            ISAM_PVO3_MAP = 0
#endif
            DO ITAG = 1, NTAG_SA-3

C Count the number of streams going to each ISAM tag
              TXTSTRING = TRIM(TAGSTREAMS_TEMP( ITAG ))
              TAGSTREAMS_NUM( ITAG ) = 1 + COUNT(TRANSFER(TXTSTRING, 'A', LEN(TXTSTRING)) == "," )

C Parse out the stream names the user wants tagged
              READ(TXTSTRING, *) TAGSTREAMS(ITAG,1:TAGSTREAMS_NUM( ITAG ))

C Find emissions stream in the list of available streams
              DO ISRM = 1, TAGSTREAMS_NUM( ITAG )
                 IF ( TAGSTREAMS(ITAG,ISRM) .EQ. 'PVO3' ) THEN
#ifdef potvorto3
                    IF ( L_OZONE ) THEN
                      ISAM_PVO3_MAP(ITAG) = 1
                      CYCLE
                    ELSE
                      XMSG = " Must specifiy OZONE ISAM TAG CLASS" //
     &                       " in isam_control to track PVO3 "
                      CALL M3EXIT( 'ISAM_PVO3', 1, 1, XMSG, XSTAT1 )
                    ENDIF
#else
                    XMSG = " To track PVO3, model must be compiled" //
     &                     " with -Dpotvorto3 option. Check Makefile" //
     &                     " and/or build script."
                    CALL M3EXIT( 'ISAM_PVO3', 1, 1, XMSG, XSTAT1 )
#endif
                 ENDIF

                 IF ( TAGSTREAMS(ITAG,ISRM) .EQ. 'BIDIRECTIONALNH3' )THEN
                   IF ( ABFLUX ) THEN
                     CYCLE ! don't need a stream for this
                   ELSE
                     XMSG = " BIDIRECTIONALNH3 specified," //
     &                      " but ABLUX set to FALSE "
                     CALL M3EXIT( 'ISAM_PVO3', 1, 1, XMSG, XSTAT1 )
                   ENDIF           
                 END IF

                 IDX = INDEX1(TAGSTREAMS(ITAG,ISRM),N_EM_SRM,EM_FILE_LAB )
                 IF ( IDX .EQ. 0 ) THEN
                   XMSG = " User specified ISAM tag - " //
     &                    TRIM( TAGSTREAMS(ITAG,ISRM) )// 
     &                    " - not found in available emissions streams "
                   CALL M3EXIT( 'ISAM_STREAMS', 1, 1, XMSG, XSTAT1 )
                 ELSE
                   TAGS_PER_STREAM( IDX ) = TAGS_PER_STREAM( IDX ) + 1
                   STREAM_TO_TAG(IDX,TAGS_PER_STREAM( IDX )) = ITAG
                 END IF
              END DO

            END DO

C Develop a map of emitted/diffused ISAM species
            MAP_DIFFtoSA = 0
            DO SPC = 1, NSPC_SA
              MAP_DIFFtoSA( SPC ) = INDEX1(TRIM(SPC_NAME(SPC,1)), N_SPC_DIFF, DIFF_SPC )
            END DO

C Initialize geographic regions for ISAM tagging
            ALLOCATE( ISAMRGN( NTAG_SA, N_EM_RGN ) )
            ISAMRGN = 'EVERYWHERE'
            ALLOCATE( ISAMRGN_MAP( NTAG_SA, N_EM_RGN ) )
            ISAMRGN_MAP = 0
            ISAMRGN_NUM = 0

            DO ITAG = 1, NTAG_SA-3

C Check if the 'EVERYWHERE' keyword is present
              IDX = INDEX(ISAMRGN_TEMP(ITAG),'EVERYWHERE')
              IF ( IDX .NE. 0 ) THEN
                ISAMRGN_NUM( ITAG ) = 0
                CYCLE
              ENDIF

C Count the number of regions for each tag
              TXTSTRING = TRIM(ISAMRGN_TEMP( ITAG ))
              ISAMRGN_NUM( ITAG ) = 1 + COUNT(TRANSFER(TXTSTRING,'A', LEN(TXTSTRING)) == "," )

C Parse out the region names the user wants tagged
              READ(TXTSTRING, *) ISAMRGN(ITAG,1:ISAMRGN_NUM( ITAG ))

C Map the user specified ISAM regions to available CMAQ regions
              DO ISRM = 1, ISAMRGN_NUM(ITAG)
                IDX = INDEX1(ISAMRGN(ITAG,ISRM),N_EM_RGN, EM_REGIONS%LABEL )
                IF ( IDX .EQ. 0 ) THEN
                  XMSG = " User specified ISAM region - " //
     &                    TRIM( ISAMRGN(ITAG,ISRM) ) //
     &                    " - not found in available emissions regions "
                   CALL M3EXIT( 'ISAM_STREAMS', 1, 1, XMSG, XSTAT1 )
                ELSE
                   ISAMRGN_MAP(ITAG,ISRM) = IDX
                END IF
              END DO

            END DO

#endif

#ifdef sens
            ALLOCATE( STREAM_TO_SENS( N_EM_SRM, NPMAX ),
     &                SENS_PER_STREAM( N_EM_SRM ))
            STREAM_TO_SENS = 0
            SENS_PER_STREAM = 0

            DO NP = 1, NPMAX
              IF ( IPT ( NP ) .EQ. 3 ) THEN ! This is an emissions sensitivity
                IF ( S_NSTREAMS(NP) .EQ. 99 ) THEN ! all emissions streams
                  S_NSTREAMS(NP) = N_EM_SRM
                  S_STREAMLBL(NP,1:N_EM_SRM)=EM_FILE_LAB(1:N_EM_SRM)
                END IF
                DO ISRM = 1, S_NSTREAMS(NP)
                  SENNUM = INDEX1(S_STREAMLBL(NP,ISRM),N_EM_SRM,EM_FILE_LAB)
                  IF ( SENNUM .EQ. 0 ) THEN
                    XMSG = " User specified DDM Emissions Stream - " //
     &                    TRIM( S_STREAMLBL(NP,ISRM) )//
     &                    " - not found in available emissions streams "
                    CALL M3EXIT( 'ISAM_STREAMS', 1, 1, XMSG, XSTAT1 )
                  ELSE
                    SENS_PER_STREAM( SENNUM ) = SENS_PER_STREAM( SENNUM ) + 1
                    STREAM_TO_SENS(SENNUM,SENS_PER_STREAM( SENNUM )) = NP
                  END IF
                END DO
              END IF
            END DO
#endif
            ! Initialize Diagnostic Write Counter
            WSTEP = 0 
            MDATE = STDATE
            MTIME = STTIME
         END IF  ! First Time

C Initialize Emissions Array
         VDEMIS_DIFF = 0.0

         WRTIME = .FALSE.
         WSTEP  = WSTEP + TIME2SEC( TSTEP( 2 ) )
         WRTIME = ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) )
         IF ( WRTIME ) THEN 
           WSTEP = 0
           CALL NEXTIME( MDATE, MTIME,  TSTEP( 1 ) )
         END IF

#ifdef isam
         SA_VDEMIS_DIFF = 0.0
#endif

#ifdef sens
        SVDEMIS_DIFF = 0.0
#endif

C Retrieve Emissions from All Stream Types
         IF ( N_EM_SRM .GT. 0 ) THEN
         DO ISRM = 1,N_EM_SRM
           VDEMIS_READ = 0.0

           SELECT CASE ( EM_FILE_ITYPE( ISRM ) )
             
             ! Retrieve Gridded and Tracer Emissions
             CASE ( 1, 3 )
               NL = EM_GRID_LAYS( ISRM )
               CALL GRIDEMIS( JDATE, JTIME, TSTEP, EM_FILE_NAME( ISRM ), 
     &                        NL, ISRM, VDEMIS_READ )
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
               CALL EMISS_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )

             ! Retrieve Point Source Emissions Streams
             CASE ( 2 )
               NL = 1
               CALL GET_PT3D_EMIS ( JDATE, JTIME, TSTEP, EM_SURR( :,ISRM ), ISRM, VDEMIS_READ, NL )
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
               CALL EMISS_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )
             
             CASE ( 4 )
               NL = 1
               CALL GET_BEIS ( JDATE, JTIME, TSTEP )
               FORALL( ISTR = 1:N_EMIS_ISTR, MAP_EMtoSURR( ISTR,ISRM ) .GT. 0 )
                  VDEMIS_READ( ISTR,1,:,: ) = VDEMIS_BI( MAP_EMtoSURR( ISTR,ISRM ),:,: ) 
               END FORALL
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )

             ! Retrieve Marine Gas Emissions
             CASE ( 5 )
               NL = 1
               CALL GET_MGEMIS ( JDATE, JTIME, TSTEP, CGRID )
               FORALL( ISTR = 1:N_EMIS_ISTR, MAP_EMtoSURR( ISTR,ISRM ) .GT. 0 )
                  VDEMIS_READ( ISTR,1,:,: ) = VDEMIS_MG( MAP_EMtoSURR( ISTR,ISRM ),:,: ) 
               END FORALL
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )

             ! Retrieve Lightning NO Emissions
             CASE ( 6 )
               NL = EMLAYS
               CALL GET_LTNG ( JDATE, JTIME, TSTEP )
               DO L = 1,NL
                  FORALL( ISTR = 1:N_EMIS_ISTR, MAP_EMtoSURR( ISTR,ISRM ) .GT. 0 )
                     VDEMIS_READ( ISTR,L,:,: ) = VDEMIS_LT( :,:,L ) 
                  END FORALL
               END DO
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )

             ! Retrieve Sea Spray Aerosol Emissions 
             CASE ( 7 )
               NL = 1
               CALL GET_SSEMIS ( JDATE, JTIME, TSTEP, CELLVOL( 1 ), CELLHGT( 1 ) )
               FORALL( ISTR = 1:N_EMIS_ISTR, MAP_EMtoSURR( ISTR,ISRM ) .GT. 0 )
                  VDEMIS_READ( ISTR,1,:,: ) = SSOUTM( MAP_EMtoSURR( ISTR,ISRM ),:,: ) 
               END FORALL
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
               CALL EMISS_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )

             ! Retrieve Wind-Blown Dust Emissions 
             CASE ( 8 )
               NL = 1
               CALL GET_DUST_EMIS ( JDATE, JTIME, TSTEP, Met_data%RJACM( :,:,1 ), CELLHGT( 1 ) )
               FORALL( ISTR = 1:N_EMIS_ISTR, MAP_EMtoSURR( ISTR,ISRM ) .GT. 0 )
                  VDEMIS_READ( ISTR,1,:,: ) = DUSTOUTM( MAP_EMtoSURR( ISTR,ISRM ),:,: ) 
               END FORALL
               CALL EMISS_SCALING( VDEMIS_READ, ISRM, NL, VDEMIS_SCALED )
               CALL EMISS_SIZE_DIST( ISRM, VDEMIS_SCALED, NL )

           END SELECT
           
           ! Convert All Emissions to VDIFF Units, Check for negative
           ! values, write out diagnostic file (if requested) and apply
           ! emissions to output array
           CALL EMISS_CONV_DIFF( VDEMIS_SCALED, NL, VDEMIS_CONV )
           IF ( EM_FILE_LDIAG( ISRM ) .NE. 'FALSE' .AND. WRTIME ) 
     &                     CALL WRITE_EMISS_DIAG( MDATE, MTIME, VDEMIS_CONV, ISRM, NL )

           IF ( EM_FILE_LAPPLY( ISRM ) ) 
     &          VDEMIS_DIFF( :,1:NL,:,: ) = VDEMIS_DIFF( :,1:NL,:,: ) + VDEMIS_CONV( :,1:NL,:,: )

#ifdef isam
           IF ( EM_FILE_LAPPLY( ISRM ) ) THEN
             ! Populate SA_VDEMIS_CONV, array for carrying tagged
             ! emissions contributions

             ! Initialize 
             DO ITAG = 1,NTAG_SA
               DO R = 1,NROWS
                 DO C = 1,NCOLS
                   DO LAYER = 1,NL
                     DO SPC = 1,N_SPC_DIFF
                       SA_VDEMIS_CONV( SPC,LAYER,C,R,ITAG ) = 0.0
                     END DO
                   END DO
                 END DO
               END DO
             END DO
 
             ! Determine whether this emission stream corresponds to 
             ! any ISAM tags
             IF ( TAGS_PER_STREAM( ISRM ) .EQ. 0 ) THEN 
               ! Dump all into 'OTHRTAG'
               SA_VDEMIS_CONV( :,1:NL,:,:,OTHRTAG ) = 
     &                             VDEMIS_CONV( :,1:NL,:,: )
             ELSE
               ! Initialize Array for Tracking Residual of Tagged
               ! Emissions  
               SA_VDEMIS_CONV_OTHER( :,1:NL,:,: ) = VDEMIS_CONV( :,1:NL,:,: )

               ! Loop through all of the ISAM tags associated with this
               ! emissions stream. Generally each stream is only
               ! associated with one tag. The exception is when
               ! there are multiple tags corresponding to separate regions.
               DO IDX = 1, TAGS_PER_STREAM( ISRM )

                 ! Retrieve A Tag Associated with this Stream
                 ITAG = STREAM_TO_TAG(ISRM,IDX)

                 IF ( ISAMRGN_NUM( ITAG ) .LT. 1 ) THEN  
                   ! This tag is capturing 100% of every grid cell in
                   ! the full domain for this stream. We need to assign
                   ! all of the emissions from this stream to this tag
                   ! and the residual is then set to 0.
                   SA_VDEMIS_CONV( :,1:NL,:,:,ITAG ) = 
     &                  SA_VDEMIS_CONV( :,1:NL,:,:,ITAG )
     &                        + VDEMIS_CONV(:,1:NL,:,: )
                   SA_VDEMIS_CONV_OTHER = 0.0

                 ELSE
                   ! This tag is capturing some fraction of the stream
                   ! in grid cells across the domain. These fractional
                   ! contributions are applied using the EM_REG_FAC
                   ! array with corresponding map indices.
                   ! Loop Over Altitude, Species and Regions to Add
                   ! emissions to corresponding tag, ITAG.
                   DO RGN = 1, ISAMRGN_NUM( ITAG )
                     DO LAYER = 1, NL
                       DO SPC = 1, N_SPC_DIFF
                          SA_VDEMIS_CONV( SPC,LAYER,:,:,ITAG ) = 
     &                              SA_VDEMIS_CONV( SPC,LAYER,:,:,ITAG )
     &                             + VDEMIS_CONV( SPC,LAYER,:,: )
     &                               * EM_REG_FAC(:,:,ISAMRGN_MAP(ITAG,RGN))

                          SA_VDEMIS_CONV_OTHER( SPC,LAYER,:,: ) = 
     &                              SA_VDEMIS_CONV_OTHER( SPC,LAYER,:,: )
     &                            - VDEMIS_CONV( SPC,LAYER,:,: )
     &                              * EM_REG_FAC(:,:,ISAMRGN_MAP(ITAG,RGN))

                       END DO
                     END DO
                   END DO
                 END IF
               END DO
               
               ! Now that emissions from this stream have been assigned
               ! to all available tags, assess the remainder and assign
               ! it to the "OTHR" tag if any exists.
               MINCHECK = MINVAL( SA_VDEMIS_CONV_OTHER( :,1:NL,:,: ) )
               IF ( MINCHECK .GE. 0.0 ) THEN
                  ! Remainder is Valid. Move it all to the "OTHR" Tag
                  SA_VDEMIS_CONV( :,1:NL,:,:,OTHRTAG ) = 
     &                                SA_VDEMIS_CONV_OTHER( :,1:NL,:,: )
               ELSE
                  ! Some Part of the Remainder ("OTHER") is Invalid
                  XMSG = " ISAM mass balance error for emissions - " //
     &                     TRIM( EM_REGIONS(ISRM)%LABEL ) //
     &                    " - check isam control file. "
                  CALL M3WARN( 'ISAM_EMISSIONS', 1, 1, XMSG )

                  ! Repair OTHER By Distributing Negative Among Populated Tags 
                  ! and assigning positive part to the "OTHR" Tag as
                  ! planned
                  DO R = 1,NROWS
                  DO C = 1,NCOLS
                  DO LAYER = 1,NL
                  DO SPC = 1,N_SPC_DIFF
                     IF ( SA_VDEMIS_CONV_OTHER( SPC,LAYER,C,R ) .LT. 0.0 ) THEN
                        ! Find the total alloted to this (SPC,LAYER,C,R)
                        ! and use it to distribute the error fractionally
                        TOTAL = SUM( SA_VDEMIS_CONV( SPC,LAYER,C,R,: ) )
                        DO ITAG = 1,NTAG_SA 
                          SA_VDEMIS_CONV( SPC,LAYER,C,R,ITAG ) =
     &                      SA_VDEMIS_CONV( SPC,LAYER,C,R,ITAG ) *
     &                      ( 1.0 + SA_VDEMIS_CONV_OTHER( SPC,LAYER,C,R ) / TOTAL )
                        END DO
                     ELSE
                        ! Assign the positive values to the "OTHR" Tag
                        SA_VDEMIS_CONV( SPC,LAYER,C,R,OTHRTAG ) = 
     &                                SA_VDEMIS_CONV_OTHER( SPC,LAYER,C,R )
                     END IF
                  END DO
                  END DO
                  END DO
                  END DO
               END IF

             END IF

             ! Subset the emissions array for ISAM traced species  
             DO SPC = 1, NSPC_SA
               IF ( MAP_DIFFtoSA( SPC ) .NE. 0 ) THEN
                 DO ITAG = 1,NTAG_SA
                   DO R = 1,NROWS
                     DO C = 1,NCOLS
                       DO LAYER = 1,NL
                         SA_VDEMIS_DIFF( SPC,LAYER,C,R,ITAG ) =  
     &                                SA_VDEMIS_DIFF( SPC,LAYER,C,R,ITAG )
     &                             +  SA_VDEMIS_CONV( MAP_DIFFtoSA( SPC ),LAYER,C,R,ITAG )
                       END DO
                     END DO
                   END DO
                 END DO
               END IF
             END DO

           END IF
#endif


#ifdef sens
           IF ( SENS_PER_STREAM( ISRM ) .GT. 0 ) THEN ! This stream is used by DDM3D

             DO SENNUM = 1, SENS_PER_STREAM( ISRM )
               NP = STREAM_TO_SENS( ISRM,SENNUM )
               SVDEMIS_DIFF( :,1:NL,:,:,NP ) = SVDEMIS_DIFF( :,1:NL,:,:,NP ) 
     &                                       + VDEMIS_CONV(:,1:NL,:,: )
             END DO
           END IF
#endif

         END DO  ! Master Loop for Emissions Streams

#ifdef sens
C Subset the emissions array for DDM-3D (by species and region)
         DO NP = 1, NPMAX
           DO S = 1, N_SPC_DIFF
             DO L = 1, EMLAYS
               SVDEMIS_DIFF( S,L,:,:,NP ) = 
     &                        SVDEMIS_DIFF( S,L,:,:,NP )
     &                      * IREGION( :,:,L,NP )
     &                      * IPARM( NP, DIFF_MAP( S ) )
             END DO
           END DO
         END DO
#endif

         ERROR_NEG     = EMISS_NEG_CHECK( VDEMIS_DIFF, 1, EMLAYS )
         
         ! Write Out the Sum of All Emissions to Gridded Diagnostic File
         IF ( EM_FILE_LDIAG( N_EM_SRM+1 ) .NE. 'FALSE' .AND. WRTIME ) 
     &         CALL WRITE_EMISS_DIAG( MDATE, MTIME, VDEMIS_DIFF, N_EM_SRM+1, EMLAYS )

         END IF

         RETURN

         END SUBROUTINE GET_EMIS

!-----------------------------------------------------------------------
         SUBROUTINE GRIDEMIS ( JDATE, JTIME, TSTEP, EMIS_FNAME, FILE_LAYS, FSTREAM, VDEMIS )

         USE CGRID_SPCS          ! CGRID mechanism species
         USE UTILIO_DEFN
         USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
         USE RXNS_DATA, ONLY: MECHNAME
         USE CENTRALIZED_IO_MODULE, ONLY: interpolate_var

         IMPLICIT NONE

! Includes:
         INCLUDE SUBST_FILES_ID  ! file name parameters

! Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME  ! date (YYYYDDD), time (HHMMSS)
         INTEGER, INTENT( IN ) :: FSTREAM
         CHARACTER( 100 ), INTENT( IN ) :: EMIS_FNAME
         INTEGER, INTENT( IN ) :: TSTEP( 3 )    ! time step vector (HHMMSS)

! Output:
         REAL, INTENT( OUT )  :: VDEMIS( :,:,:,: )

! Local Variables:
         INTEGER   C, R, L, N, S, V, ISTR ! loop induction variables
         INTEGER   S_STRT, S_END, FILE_LAYS, NDATE, NTIME

         REAL, ALLOCATABLE, SAVE :: BUFF( :,:,: )
         CHARACTER( 16 ) :: VNAME
         CHARACTER( 16 ) :: PNAME = 'GRIDEMIS'
         CHARACTER( 200 ) :: XMSG = ' '
         LOGICAL, SAVE :: FIRSTIME = .TRUE.
         INTEGER, ALLOCATABLE, SAVE :: LOC_STDATE(:)

C-----------------------------------------------------------------------

         IF ( FIRSTIME ) THEN
            FIRSTIME = .FALSE.
            ! Get Domain Information for Emissions Read Routine

            ! Allocate Persistent Variables
            ALLOCATE( BUFF( NCOLS,NROWS,MAXVAL( EM_GRID_LAYS ) ) )
            ALLOCATE( LOC_STDATE( SIZE(EM_FILE_DATE) ) )

            LOC_STDATE = STDATE
         END IF    !FirstTime
 
C Ensure that the model and emissions timestamp dates stay synchronized
         IF (LOC_STDATE(FSTREAM) .NE. JDATE ) THEN
            NDATE = JDATE; NTIME = JTIME
            CALL NEXTIME( NDATE, NTIME, -TSTEP( 1 ) )       ! go back one output tstep
            CALL NEXTIME( EM_FILE_DATE( FSTREAM ), NTIME, TSTEP( 1 ) ) ! advance the start date one time step
            LOC_STDATE(FSTREAM) = EM_FILE_DATE( FSTREAM )
         END IF

C Read & Interpolate Emissions 
         VDEMIS = 0.0

         DO ISTR = 1, N_EMIS_ISTR 
           VNAME = EM_SURR( ISTR, FSTREAM )
           IF ( VNAME .EQ. '' ) CYCLE

           CALL INTERPOLATE_VAR (VNAME, EM_FILE_DATE( FSTREAM ), JTIME, BUFF, EMIS_FNAME)

C Store all emissions in mol/sec or g/sec and convert to ppmv/s later
           IF ( EMLAYS .GE. FILE_LAYS ) THEN 
             DO L = 1, FILE_LAYS
                VDEMIS( ISTR,L,:,: ) = BUFF( :,:,L )
             END DO
           ELSE
             DO L = 1, EMLAYS
                VDEMIS( ISTR,L,:,: ) = BUFF( :,:,L )
             END DO
             DO L = EMLAYS+1,FILE_LAYS
                VDEMIS( ISTR,L,:,: ) = VDEMIS( ISTR,L,:,: ) + BUFF( :,:,L )
             END DO
           END IF

         END DO   ! ISTR

         RETURN

      END SUBROUTINE GRIDEMIS

C-----------------------------------------------------------------------
      SUBROUTINE EMISS_SCALING( VDEMIS0, ISRM, NL, VDEMIS )

C     Apply region-dependent scaling of emissions rules.
C-----------------------------------------------------------------------
          
      IMPLICIT NONE

      INTEGER, INTENT( IN )   :: ISRM, NL
      REAL, INTENT( IN )      :: VDEMIS0( :,:,:,: )
      REAL, INTENT( OUT )     :: VDEMIS ( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: FAC1( :,:,:,: )
      INTEGER, ALLOCATABLE, SAVE :: NFAC( : )

      TYPE FAC_ST
          LOGICAL :: EXISTS  ! Does this source have any instructions with 
                             ! at least IFAC number of factors
          REAL, ALLOCATABLE    :: FAC( :,:,:,: ) ! Spatial-Dependent Scaling Factors 
          INTEGER              :: NISTR          ! Number of nonzero instructions for each stream
          INTEGER, ALLOCATABLE :: MAP_FACtoISTR( : )! Map the factors from the global 
                                                    ! structure to just the species 
                                                    ! relevant for this emission stream
      END TYPE FAC_ST
      TYPE ( FAC_ST ), ALLOCATABLE, SAVE :: EM_FAC1_ST( : )

      INTEGER ISTR, IFAC, L, NFAC_MAX, IRGN, OP, JSRM, ISTR_TMP, NISTR
      INTEGER, ALLOCATABLE :: MAP_FACtoISTR( : )
      REAL    FAC
      LOGICAL, SAVE :: FIRSTIME = .TRUE.


      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ALLOCATE( NFAC( N_EMIS_ISTR ) )

         ! Build Array for primary factor. This algorithm is optimized
         ! by assuming that most instructions only have one factor (i.e.
         ! the 'add' factor). So time will be saved by pre-populating
         ! the 5D array necessry to perform this operation.
         ALLOCATE( EM_FAC1_ST( N_EM_SRM ) )
         EM_FAC1_ST( : )%EXISTS = .FALSE.
         ALLOCATE( FAC1( N_EMIS_ISTR,EMLAYS,NCOLS,NROWS ) )
         ALLOCATE( MAP_FACtoISTR( N_EMIS_ISTR ) )

         DO JSRM = 1,N_EM_SRM
           NFAC( : ) = EM_FAC_ST( :,JSRM )%LEN
           IF ( ANY( NFAC( : ) .GE. 1 ) ) THEN
             ! Start Counting Instructions for this Emission Stream    
             FAC1 = 0.0
             ISTR_TMP = 0
             MAP_FACtoISTR = 0

             ! Loop through existing instructions
             DO ISTR = 1,N_EMIS_ISTR
               ! Determine whether Emissions for this combination exist
               IF ( EM_FAC_ST( ISTR,JSRM )%LEN .GT. 0 ) THEN
                 IRGN = EM_FAC_ST( ISTR,JSRM )%REG( 1 )
                 ISTR_TMP = ISTR_TMP + 1
                 MAP_FACtoISTR( ISTR_TMP ) = ISTR

                 DO L = 1,EMLAYS
                   IF ( IRGN .EQ. 1 ) THEN
                     ! Emissions are domain wide
                     FAC1( ISTR_TMP,L,:,: ) = EM_FAC_ST( ISTR,JSRM )%FAC( 1 )
                   ELSE
                     ! Regional-based scaling
                     FAC1( ISTR_TMP,L,:,: ) = EM_FAC_ST( ISTR,JSRM )%FAC( 1 )
     &                            * EM_REG_FAC( :,:,IRGN )
                   END IF
                 END DO
               END IF
             END DO

             ! Allocate factor array for the first factor
             EM_FAC1_ST( JSRM )%EXISTS = .TRUE.
             EM_FAC1_ST( JSRM )%NISTR = ISTR_TMP
             ALLOCATE( EM_FAC1_ST( JSRM )%FAC( ISTR_TMP,EMLAYS,NCOLS,NROWS ) )
             EM_FAC1_ST( JSRM )%FAC( 1:ISTR_TMP,:,:,: ) = FAC1( 1:ISTR_TMP,:,:,: )
             ALLOCATE( EM_FAC1_ST( JSRM )%MAP_FACtoISTR( ISTR_TMP ) )
             EM_FAC1_ST( JSRM )%MAP_FACtoISTR( 1:ISTR_TMP ) = MAP_FACtoISTR( 1:ISTR_TMP )
           
           END IF 
         END DO
         DEALLOCATE( MAP_FACtoISTR )

      END IF   ! First Time

      !! Time-Dependent Portion
      VDEMIS( :,1:NL,:,: ) = 0.0
      
      ! Skip Streams With no Emissions Whatsoever
      IF ( .NOT. EM_FAC1_ST( ISRM )%EXISTS ) RETURN

      ! For the Primary Scaling (IFAC = 1), apply the array operation
      NISTR = EM_FAC1_ST( ISRM )%NISTR
      ALLOCATE( MAP_FACtoISTR( NISTR ) )
      MAP_FACtoISTR = EM_FAC1_ST( ISRM )%MAP_FACtoISTR

      VDEMIS( MAP_FACtoISTR,1:NL,:,: ) = VDEMIS0( MAP_FACtoISTR,1:NL,:,: ) * 
     &        EM_FAC1_ST( ISRM )%FAC( 1:NISTR,1:NL,:,: )

      
      ! For Additional Scaling Operations (IFAC > 1), Loop through Instructions 
      NFAC( : ) = EM_FAC_ST( :,ISRM )%LEN
      DO ISTR = 1,N_EMIS_ISTR
        ! Do Not bother with this row if there is no surrogate to map
        IF ( MAP_EMtoSURR( ISTR,ISRM ) .EQ. 0 .OR. NFAC( ISTR ) .EQ. 1 ) CYCLE

        DO IFAC = 2,NFAC( ISTR )      

          FAC  = EM_FAC_ST( ISTR,ISRM )%FAC( IFAC )
          OP   = EM_FAC_ST( ISTR,ISRM )%OP ( IFAC )
          IRGN = EM_FAC_ST( ISTR,ISRM )%REG( IFAC )

          IF ( IRGN .EQ. 1 ) THEN
            !Apply scaling using EM_FAC_ST 
            IF ( OP .EQ. 1 .AND. NFAC( ISTR ) .EQ. 1 ) THEN ! Add New Emission
                VDEMIS( ISTR,1:NL,:,: ) = VDEMIS0( ISTR,1:NL,:,: ) * FAC
            ELSE IF ( OP.EQ.1 ) THEN   ! Add Additional Emission 
                VDEMIS( ISTR,1:NL,:,: ) = VDEMIS( ISTR,1:NL,:,: ) +
     &                 VDEMIS0( ISTR,1:NL,:,: ) * FAC
            ELSE IF ( OP.EQ.2 ) THEN ! Multiply Emissions Rule
                VDEMIS( ISTR,1:NL,:,: ) = VDEMIS( ISTR,1:NL,:,: ) * FAC
            ELSE IF ( OP.EQ.3 ) THEN ! Overwrite Existing Rule
                VDEMIS( ISTR,1:NL,:,: ) = VDEMIS0( ISTR,1:NL,:,: ) * FAC
            END IF
          ELSE
              
            !Apply scaling using EM_FAC_ST and VDEMIS_RGN
            IF ( OP.EQ.1 ) THEN   ! Add Additional Emission 
              DO L = 1,NL
                VDEMIS( ISTR,L,:,: ) = VDEMIS( ISTR,L,:,: ) +
     &             VDEMIS0( ISTR,L,:,: ) * FAC * EM_REG_FAC( :,:,IRGN )
              END DO
            ELSE IF ( OP.EQ.2 ) THEN ! Multiply Emissions Rule
              DO L = 1,NL
                VDEMIS( ISTR,L,:,: ) = VDEMIS( ISTR,L,:,: ) * 
     &               (1.0 - EM_REG_FAC( :,:,IRGN ) ) +
     &             VDEMIS( ISTR,L,:,: ) * FAC * EM_REG_FAC( :,:,IRGN )
              END DO
            ELSE IF ( OP.EQ.3 ) THEN ! Overwrite Existing Rule
              DO L = 1,NL
                VDEMIS( ISTR,L,:,: ) = VDEMIS( ISTR,L,:,: ) *
     &               (1.0 - EM_REG_FAC( :,:,IRGN ) ) +
     &             VDEMIS0( ISTR,L,:,: ) * FAC * EM_REG_FAC( :,:,IRGN )
              END DO
            END IF

          END IF

        END DO
      END DO

      RETURN

      END SUBROUTINE EMISS_SCALING


C-----------------------------------------------------------------------
      SUBROUTINE EMISS_CONV_DIFF( VDEMIS0, NL, VDEMIS )

C     Convert rate and map to Diffusivity module species order
C-----------------------------------------------------------------------
          
      USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
      USE AERO_EMIS           ! inherits GRID_CONF

      IMPLICIT NONE

      ! Local Variables
      REAL,ALLOCATABLE, SAVE :: CNVTC( :,:,: ) ! combined conversion factor
      REAL,ALLOCATABLE, SAVE :: CNVTI( : )     ! intermediate combined conv. factor
      REAL,       SAVE :: CNVTP                ! intermediate combined conv. factor
      REAL,ALLOCATABLE, SAVE :: CONVM( :,:,: ) ! Aerosol Mass and Surface Area conversion factor         
      REAL,ALLOCATABLE, SAVE :: CONVN( :,:,: ) ! Aerosol Number conversion factor       
      REAL, PARAMETER  :: GPKG = 1.0E+03       ! g/kg
      REAL, PARAMETER  :: MWAIR = 28.9628      ! g/mol
      REAL, PARAMETER  :: AVO  = 6.0221367E23
      REAL, PARAMETER  :: RAVO = 1.0 / AVO
      
      INTEGER, INTENT( IN ) :: NL
      REAL, INTENT( INOUT ) :: VDEMIS0( :,:,:,: )
      REAL, INTENT( OUT ):: VDEMIS ( :,:,:,: )
 
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER       :: EMtoDIFF(N_EMIS_ISTR)
      INTEGER       :: C, R, L, ISTR, INDX

      ! Get domain decomp info from the emissions file
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         ! Populate Persistent Variables
         CNVTP = 1.0E+06 * MWAIR / REAL( DX1 * DX2 ) !Conv. Factor for Gases 

         ALLOCATE( CNVTI( EMLAYS ), CNVTC( EMLAYS,NCOLS,NROWS ), 
     &             CONVM( EMLAYS,NCOLS,NROWS ),
     &             CONVN( EMLAYS,NCOLS,NROWS )  )
      END IF    !FirstTime
      
      ! Convert All Emissions to Units Appropriate for the Dispersion Solver
      CNVTI( 1:NL ) = CNVTP * Grid_Data%RDX3F( 1:NL )
      DO L = 1,NL
        CNVTC( L,:,: ) = 1.0E-3 * CNVTI( L ) * Met_Data%RRHOJ( :,:,L )  ! Gas Moles:   mol/s -> ppmv/s
        CONVM( L,:,: ) = MWAIR / GPKG / Met_Data%DENS( :,:,L ) !m3/mol  ! Aer. Mass:   umol/m3/s -> ppmv/s
      END DO                                                            ! m2/m3/s -> m2/mol/s
      CONVN( 1:NL,:,: ) = CONVM( 1:NL,:,: )                             ! Aer. Num:    N/m3/s -> N/mol/s

      !MAKE SURE TO APPLY RELEVANT UNIT CONVERSION TO EACH
      !TYPE OF VARIABLE (GAS, AEROSOL MASS, AEROSOL NUMBER,
      !AND AEROSOL SURFACE AREA)
      FORALL ( ISTR = 1:N_EMIS_ISTR, MAP_EMtoGAS( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( ISTR,1:NL,:,: )
  
      FORALL ( ISTR = 1:N_EMIS_ISTR, MAP_EMtoAERO( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CONVM( 1:NL,:,: ) * VDEMIS0( ISTR,1:NL,:,: )
      
      FORALL ( ISTR = 1:N_EMIS_ISTR, MAP_EMtoSRF( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CONVM( 1:NL,:,: ) * VDEMIS0( ISTR,1:NL,:,: )
      
      FORALL ( ISTR = 1:N_EMIS_ISTR, MAP_EMtoNUM( ISTR ) .NE. 0 )
     &    VDEMIS0( ISTR,1:NL,:,: ) = CONVN( 1:NL,:,: ) * VDEMIS0( ISTR,1:NL,:,: )

 
      ! zero out emissions values for diffused species not included in emissions list.
      ! ...accounts for emissions species names as a subset of the vert. diffused species list
      VDEMIS( :,1:NL,:,: ) = 0.0
      FORALL( ISTR = 1:N_EMIS_ISTR, MAP_EMtoDIFF( ISTR ) .NE. 0 ) 
     &        VDEMIS( MAP_EMtoDIFF( ISTR ),1:NL,:,: ) = 
     &                VDEMIS( MAP_EMtoDIFF( ISTR ),1:NL,:,: ) + 
     &                VDEMIS0( ISTR,1:NL,:,: )

      RETURN
      END SUBROUTINE EMISS_CONV_DIFF


!-----------------------------------------------------------------------
      FUNCTION EMISS_NEG_CHECK( VDEMIS, ISRM, NL ) RESULT( STAT )

!     Check Emissions Array for negative values and exit if negative values
!     exceed tolerance of 1.0E-7. Emissions that are negative but within 
!     tolerance are set to 0.0.
!     VDEMIS is the scaled emissions and VDEMIS0 is the emissions
!     read in from each stream.
!-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE VDIFF_MAP, only : DIFF_SPC ! Name for every Diffusion Module Species 

      IMPLICIT NONE

      REAL, INTENT( INOUT ) :: VDEMIS ( :,:,:,: )
      INTEGER, INTENT( IN ) :: NL
      INTEGER, INTENT( IN ) :: ISRM

      INTEGER :: ISPC
      INTEGER :: STAT
      INTEGER :: ALOC( 4 )
      REAL    :: EMIS_MIN
      CHARACTER(250) :: XMSG

      STAT = 0

      ! If All Values Are Positive then Return Right Away
      EMIS_MIN = MINVAL( VDEMIS( :,1:NL,:,: ) )
      IF ( EMIS_MIN .GE. 0.0 ) RETURN

      IF ( EMIS_MIN .LT. -1.0e-7 ) THEN

          STAT = 1

          ! Find Where the Most Negative Value Is and Exit
          ALOC = MINLOC( VDEMIS( :,1:NL,:,: ) )
          ISPC = ALOC( 1 )

          WRITE( LOGDEV, '(/,5x,A,ES10.3,A,/,5x,3A,/,5x,A)' ),
     &      'ERROR: Invalid Negative emission rate ', EMIS_MIN, ' has been ',
     &      ' for CMAQ species ',TRIM(DIFF_SPC( ISPC )),'.',
     &      'Please inspect the Emission Control Namelist File.'
          XMSG = 'Negative Emissions Detected'
          CALL M3EXIT( 'EMISS_NEG_CHECK', 0, 0, XMSG, XSTAT1 )

      ELSE ! reset slightly negative values to 0.0
          WHERE ( VDEMIS .LT. 0.0 ) VDEMIS = 0.0
      END IF

      END FUNCTION EMISS_NEG_CHECK    

!-----------------------------------------------------------------------
      SUBROUTINE WRITE_EMISS_DIAG( MDATE, MTIME, VDEMIS0, ISRM, NL ) 

!     Write out emissions diagnostic file
!-----------------------------------------------------------------------
          
      USE ASX_DATA_MOD, ONLY: MET_DATA, GRID_DATA
      USE AERO_EMIS           ! inherits GRID_CONF
      USE GRID_CONF
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_MASK_GAS, DIFF_MASK_AERO,
     &                      DIFF_MASK_NUM, DIFF_MASK_SRF, DIFF_MW, DIFF_SPC,
     &                      DIFF_MASK_NR, DIFF_MASK_TRAC
      USE AERO_DATA, ONLY : GPKG

      IMPLICIT NONE
         
      INCLUDE SUBST_CONST     ! constants

      INTEGER, INTENT( IN ) :: MDATE, MTIME, ISRM
      REAL, INTENT( In )    :: VDEMIS0( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: VDEMIS ( :,:,:,: )
      REAL, ALLOCATABLE, SAVE :: VDEMIS_OUT ( :,:,: )

      ! Local Variables
      REAL, PARAMETER :: RAVO = 1.0 / AVO
      REAL,ALLOCATABLE, SAVE :: CNVTC( :,:,: ) ! combined conversion factor
      REAL,ALLOCATABLE, SAVE :: CNVTI( : )     ! intermediate combined conv. factor
      REAL,       SAVE :: CNVTP                ! intermediate combined conv. factor
      REAL,ALLOCATABLE, SAVE :: CONVM( :,:,: ) ! Aerosol Mass and Surface Area conversion factor         
      REAL,ALLOCATABLE, SAVE :: CONVN( :,:,: ) ! Aerosol Number conversion factor       
 
      INTEGER       :: LAYS, L, C, R, IVAR, NL, I
      CHARACTER( 6 ):: EM_LDIAG
      CHARACTER( 16):: EM_FDIAG

      LOGICAL :: FIRST_TIME = .TRUE.
      CHARACTER( 586 ) :: XMSG

      ! Get pressure info from ASX_DATA_MOD
      IF ( FIRST_TIME ) THEN
         FIRST_TIME = .FALSE.
         CNVTP = 1.0E+06 * MWAIR / REAL( DX1 * DX2 ) !Conv. Factor for Gases 

         ALLOCATE( CNVTI( EMLAYS ), CNVTC( EMLAYS,NCOLS,NROWS ), 
     &             CONVM( EMLAYS,NCOLS,NROWS ),
     &             CONVN( EMLAYS,NCOLS,NROWS ),
     &             VDEMIS( N_SPC_DIFF,EMLAYS,NCOLS,NROWS ),
     &             VDEMIS_OUT( NCOLS,NROWS,EMLAYS ) )
      END IF    !FirstTime
      
      VDEMIS     = 0.0
      VDEMIS_OUT = 0.0
      LAYS       = 1

      EM_LDIAG = EM_FILE_LDIAG( ISRM )
      EM_FDIAG = EM_DIAG_FILE( ISRM )

      IF ( EM_LDIAG .EQ. '3D' .OR. 
     &     EM_LDIAG .EQ. '2DSUM' ) LAYS = NL

      ! Convert All Emissions to Units Appropriate for the Dispersion Solver
      CNVTI( 1:NL ) = CNVTP * Grid_Data%RDX3F( 1:NL )
      DO L = 1,NL
        CNVTC( L,:,: ) = 1.0E3 / ( CNVTI( L ) * Met_Data%RRHOJ( :,:,L ) ) ! Gas Moles: ppmv/s -> mol/s
        CONVM( L,:,: ) = (1.0 / MWAIR) * GPKG * Met_Data%DENS( :,:,L )    ! Aer. Mass: ppmv/s -> umol/s
     &                   / Met_Data%RJACM( :,:,L ) * CELLVOL( L )         ! m2/mol/s -> m2/s
      END DO                                                                
      CONVN( 1:NL,:,: ) = CONVM( 1:NL,:,: )                               ! Aer. Num:  N/mol/s -> N/s

      !MAKE SURE TO APPLY RELEVANT UNIT CONVERSION TO EACH
      !TYPE OF VARIABLE (GAS, AEROSOL MASS, AEROSOL NUMBER,
      !AND AEROSOL SURFACE AREA)
      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_GAS( I ) .OR.
     &                           DIFF_MASK_NR( I )  .OR.
     &                           DIFF_MASK_TRAC( I ) )
     &    VDEMIS( I,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( I,1:NL,:,:)

      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_AERO( I ) .AND.
     &                           .NOT. DIFF_MASK_NUM( I ) .AND.
     &                           .NOT. DIFF_MASK_SRF( I )  )
     &    VDEMIS( I,1:NL,:,: ) = CNVTC( 1:NL,:,: ) * VDEMIS0( I,1:NL,:,:) * DIFF_MW( I )

      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_SRF( I ) )
     &    VDEMIS( I,1:NL,:,: ) = CONVM( 1:NL,:,: ) * VDEMIS0( I,1:NL,:,:)

      FORALL ( I = 1:N_SPC_DIFF, DIFF_MASK_NUM( I ) )
     &    VDEMIS( I,1:NL,:,: ) = CONVN( 1:NL,:,: ) * VDEMIS0( I,1:NL,:,:)

 
      ! Output to Emissions Diagnostic File
      DO IVAR = 1,N_SPC_DIFF
            ! Skip Writing this species if this source did not
            ! contribute to it
            IF ( ISRM .LT. (N_EM_SRM+1) ) THEN
              IF ( .NOT. EM_FILE_DIFF( IVAR,ISRM ) ) CYCLE
            ELSE
              IF ( .NOT. ANY(EM_FILE_DIFF( IVAR,: )) ) CYCLE
            END IF

            ! Sum the column if requested
            IF ( EM_LDIAG .EQ. '2DSUM' ) THEN
                 VDEMIS( IVAR,1,:,: ) = SUM( VDEMIS( IVAR,1:NL,:,: ),1 )
                 LAYS = 1
            END IF 
   
            DO L = 1,LAYS
                VDEMIS_OUT( :,:,L ) = VDEMIS( IVAR,L,:,: )
            END DO

            ! Write out the emissions data
            IF ( .NOT. WRITE3( EM_FDIAG, DIFF_SPC( IVAR ),
     &                 MDATE, MTIME, VDEMIS_OUT( :,:,1:LAYS ) ) ) THEN
                XMSG = 'Could not write ' // TRIM( EM_FDIAG ) // ' file'
                CALL M3EXIT( 'WRITE_EMISS_DIAG', MDATE, MTIME, XMSG, XSTAT1 )
            END IF
      END DO

      END SUBROUTINE WRITE_EMISS_DIAG
 
C-----------------------------------------------------------------------
      SUBROUTINE EMIS_SPC_MAP( JDATE, JTIME )

C Check the chemical species from the namelists and AERO_DATA against
C the species that are available on the actual emissions input files. If
C they do not agree, print warnings or crash the program depending on
C how severe the error is.
C
C    16 Mar 2017  B.Murphy     Created Subroutine
C    10 Sep 2017  B.Murphy     Revised Emissions Mapping Approach
C    08 Nov 2017  B.Murphy     Vectorized Emission Maps to allow for 
C                                unlimited emissions streams
C-----------------------------------------------------------------------

         USE VDIFF_MAP, only : DIFF_SPC, ! Name for every Diffusion Module Species                                  
     &                         DIFF_MASK_GAS, DIFF_MASK_AERO, DIFF_MASK_NR, 
     &                         DIFF_MASK_TRAC, DIFF_MW
         USE UTILIO_DEFN
         USE AERO_DATA, only : N_MODE, AEROSPC,  ! Aerosol Properties Table
     &                         N_AEROSPC, AEROMODE, MODESUFF, EM_AERO_REF
         USE AERO_EMIS, only : MAP_NUMtoEM, MAP_SRFtoEM, MAP_EMtoAERO, MAP_EMtoMODE, 
     &                         MAP_EMtoNUM, MAP_EMtoSRF, MAP_EMtoSD,
     &                         EM_STREAM_SIZE, SD_SPLIT, EM_SD_INIT
         USE UDTYPES,   only : CARRY1, LARRY1

         IMPLICIT NONE

         INTEGER, INTENT(IN)  :: JDATE, JTIME
         INTEGER    :: N_UNUSED, REGNUM, N_USED

         INTEGER    :: STRT, PTSTRT, ISPC, IDX, IX, ISUR, IRULE,
     &                 N, IM, IAERO, V, ISRM, NSPC, IA, IDIFF, JDX, JM,
     &                 ISTR, ISUR0, ISRM0, IEM, KDX, JSD, JEM, ISD,
     &                 IFAC, IRGN, ISTRN, NFAC, NCHEM, ICHEM, IFAM, F,
     &                 IRGN2, N_SURR_CATCH, ICATCH
         REAL       :: AERO_SPLIT, UNIT_FAC_1, UNIT_FAC_2, SURR_MW, 
     &                 SPEC_MW, BASIS_FAC

         LOGICAL    :: LERROR, LFOUND, L_WDIFF, L_WISD, LTEST
         LOGICAL    :: LGAS_DIFF, LGAS_SURR, L_CATCH
         
         CHARACTER( 16 )  :: SPECNAME, SN, SM, EM_SURR_CATCH( 200 )

         CHARACTER( 16 )  :: PNAME = 'EMIS_SPC_CHECK'
         CHARACTER( 100)  :: VARDESC
         INTEGER          :: STATUS

         CHARACTER( 500 ) :: XMSG
         CHARACTER( 16 )  :: B
         CHARACTER( 20 )  :: REFNAME
         
         INTEGER, PARAMETER :: NISTR0 = 3000
         LOGICAL, ALLOCATABLE, SAVE :: EM_STREAM_RULE( : ), EM_SPEC_RULE( : )
         TYPE( LARRY1 ), ALLOCATABLE, SAVE :: EM_SURR_RULE( : ), EM_PHASE_RULE( : )
         INTEGER, PARAMETER :: N_SCALEFAC = 100
         LOGICAL            :: LSPEC_KEY( NISTR0 ), LSURR_KEY( NISTR0 )
         CHARACTER( 16 )    :: CHEM_NAME( 150 )
         LOGICAL            :: LERROR2, LERROR3( 150 )
        
         INTEGER            :: IC, N_COMMANDS
         INTEGER, PARAMETER :: NCOMM0 = 4000000
         INTEGER            :: RULE_ISTR_IDIFF( NCOMM0 )
         INTEGER            :: RULE_ISTR_ISRM ( NCOMM0 )
         INTEGER            :: RULE_ISTR_ISUR ( NCOMM0 )
         CHARACTER( 16 )    :: RULE_ISTR_SPEC ( NCOMM0 )
         CHARACTER( 16 )    :: RULE_ISTR_SURR ( NCOMM0 )
         INTEGER            :: RULE_ISTR_PHASE( NCOMM0 )

         REAL, ALLOCATABLE :: EM_FAC( :,:,: )
         REAL, ALLOCATABLE :: EM_FAC_BULK( :,:,: )
         CHARACTER( 1 ), ALLOCATABLE :: EM_OP( :,:,: )
         CHARACTER( 4 ), ALLOCATABLE :: EM_BASIS( :,:,: )
         REAL,  ALLOCATABLE          :: EM_CONV( :,:,: )
         INTEGER, ALLOCATABLE :: EM_REG( :,:,: )
         INTEGER              :: N_EM_RULE
         LOGICAL              :: LREMOVE

C Retrieve Environment Variable Letting User Ignore this Check
C and allowing the model to proceed.
         CALL LOG_SUBHEADING( LOGDEV, "Check Emissions Mapping" )

         WRITE( LOGDEV, '(/,/,5x,A)' ), REPEAT( '=', 77 )
         WRITE( LOGDEV, '(5x,A,A)' ), '|> SCALING EMISSIONS CONSISTENT WITH ',
     &                  'EMISSIONS CONTROL FILE SUPPLIED BY USER' 
         WRITE( LOGDEV, '(5x,A)' ), REPEAT( '=', 77 )
 
! Write Out Region Diagnostic Information
         WRITE( LOGDEV, '(/,5x,A)' ),'|> Regions Available for Scaling:'
         WRITE( LOGDEV, '(5x,A)'   ),'================================='

         ! Print Information about All the Available Regions for Scaling
         WRITE( LOGDEV,'(8x,A,2x,A,8x,A,10x,A)' ),'Number','Region Label','File Label','Variable'
         WRITE( LOGDEV,'(8x,A,2x,A,8x,A,10x,A)' ),'------','------------','----------','--------'
         DO IRGN = 1,N_EM_RGN
            WRITE( LOGDEV,'(8x,I3,5x,A18,2x,A18,2x,A)' ),IRGN, EM_REGIONS(IRGN)%LABEL( 1:18 ),
     &             EM_REGIONS( IRGN )%File( 1:18 ), TRIM(EM_REGIONS( IRGN )%VAR ) 
            IF ( EM_REGIONS(IRGN)%FILE(1:6) .EQ. 'Family' ) THEN
                 F = INDEX1( EM_REGIONS(IRGN)%LABEL(1:18), NREGIONFAMILIES, REGIONFAMILYNAME )
                 DO IRGN2 = 1,REGIONFAMILYNUM( F )
                     WRITE( LOGDEV,'(56x,A)' ), REGIONFAMILYMEMBERS( F,IRGN2 )
                 END DO
            END IF
         END DO

! Retrieve the Surrogates Available From Emissions Streams
         ! Load Default Molecular Weights and Units based on 
         ! SMOKE/MOVES/SPECIATE specifications

         WRITE( LOGDEV, '(/,5x,A)' ),'|> Map Available Emissions Surrogates to Defaults:'
         WRITE( LOGDEV, '(5x,A)'   ),'=================================================='
         N_SURR_CATCH = 0
         DO ISRM = 1,N_EM_SRM

            IF ( ISRM .EQ. ISEASRM .OR. ISRM .EQ. IBIOSRM .OR. 
     &           ISRM .EQ. IDUSTSRM.OR. ISRM .EQ. ILTSRM  .OR.
     &           ISRM .EQ. IMGSRM ) CYCLE

            ALLOCATE( EM_FILE_SURR( ISRM )%MW   ( EM_FILE_SURR( ISRM )%LEN ) )
            ALLOCATE( EM_FILE_SURR( ISRM )%USED ( EM_FILE_SURR( ISRM )%LEN ) )
            ALLOCATE( EM_FILE_SURR( ISRM )%CONV ( EM_FILE_SURR( ISRM )%LEN ) )
            ALLOCATE( EM_FILE_SURR( ISRM )%BASIS( EM_FILE_SURR( ISRM )%LEN ) )
            EM_FILE_SURR( ISRM )%USED = .FALSE.

            DO ISUR = 1,EM_FILE_SURR( ISRM )%LEN
               ! Assign Default Molecular Weight to Each Surrogate Species
               B = EM_FILE_SURR( ISRM )%ARRY( ISUR )
               IA  = INDEX1( B, N_EMIS_SURR_TABLE, EMIS_SURR_TABLE( : )%NAME )
               IF ( IA .GT. 0 ) THEN
                  EM_FILE_SURR( ISRM )%MW   ( ISUR ) = EMIS_SURR_TABLE( IA )%MW
               ELSE
                  ! Surrogate is not calculated online nor does it
                  ! belong to the default list of commonly used
                  ! surrogates.
                  EM_FILE_SURR( ISRM )%MW   ( ISUR ) = 1.0

                  ! Only Write a Note to the User if this species hasn't
                  ! been caught from a different stream already
                  IF ( N_SURR_CATCH .EQ. 0 .OR.
     &                 INDEX1( B, 200, EM_SURR_CATCH ) .EQ. 0 ) THEN
                     N_SURR_CATCH = N_SURR_CATCH + 1
                     EM_SURR_CATCH( N_SURR_CATCH ) = B
                  END IF
               END IF
            END DO

         END DO

         WRITE( LOGDEV, '(/,5x,A)' ),'|> Checking Emissions Surrogate Units:'
         WRITE( LOGDEV, '(5x,A)'   ),'======================================'
         DO ISRM = 1,N_EM_SRM
            DO ISUR = 1,EM_FILE_SURR( ISRM )%LEN
               ! Check Units and Assign Conversion Factors for
               ! translating [kmol or umol] -> mol, [kg or mg] -> g, and
               ! [s, min, hr] -> s
               CALL CHECK_EMIS_UNITS( ISRM, ISUR, 
     &                                EM_FILE_SURR( ISRM )%ARRY ( ISUR ),
     &                                EM_FILE_SURR( ISRM )%UNITS( ISUR ), 
     &                                EM_FILE_SURR( ISRM )%CONV ( ISUR ),
     &                                EM_FILE_SURR( ISRM )%BASIS( ISUR ) )
            END DO
         END DO

! Write Out All Available Stream Families to the Log File
         WRITE( LOGDEV, '(/,5x,A)' ),'|> Emission Stream Family Definitions:'
         WRITE( LOGDEV, '(5x,A)'   ),'======================================'
         WRITE( LOGDEV,'(8x,A19,15x,A)' ),'Stream Family Label','Stream Family Members'
         WRITE( LOGDEV,'(8x,A19,15x,A)' ),'-------------------','---------------------'
         DO IFAM = 1,NSTREAMFAMILIES
            WRITE( LOGDEV,'(8x,A32,2x,A)' ), STREAMFAMILYNAME( IFAM ), 
     &             STREAMFAMILYMEMBERS( IFAM,1 )
            IF ( STREAMFAMILYNUM( IFAM ) .GT. 1 ) THEN
                DO ISRM = 2,STREAMFAMILYNUM( IFAM )
                   WRITE( LOGDEV,'(42x,A)' ), STREAMFAMILYMEMBERS( IFAM,ISRM )
                END DO
            END IF
         END DO

! Write Out All Available Species Families to the Log File
         WRITE( LOGDEV, '(/,5x,A)' ),'|> CMAQ Species Family Definitions:'
         WRITE( LOGDEV, '(5x,A)'   ),'======================================'
         WRITE( LOGDEV,'(8x,A20,14x,A)' ),'Species Family Label','Species Family Members'
         WRITE( LOGDEV,'(8x,A20,14x,A)' ),'--------------------','---------------------'
         DO IFAM = 1,NCHEMFAMILIES
            WRITE( LOGDEV,'(8x,A32,2x,A)' ), CHEMFAMILYNAME( IFAM ), 
     &             CHEMFAMILYMEMBERS( IFAM,1 )
            IF ( CHEMFAMILYNUM( IFAM ) .GT. 1 ) THEN
                DO ISRM = 2,CHEMFAMILYNUM( IFAM )
                   WRITE( LOGDEV,'(42x,A)' ), CHEMFAMILYMEMBERS( IFAM,ISRM )
                END DO
            END IF
         END DO

! Set up Stream <-> Size Distribution relationship. This routine
! populates the EM_STREAM_SIZE structure which tells the logic below which
! modes are present on which streams.
         WRITE( LOGDEV, '(/,5x,A)' ),'|> Mapping Particle Size Distributions to Each Emission Stream:'
         WRITE( LOGDEV, '(5x,A)'   ),'==============================================================='
         CALL EM_SD_INIT( JDATE, JTIME )

! Process Default Emissions Mapping (if requested in namelist; i.e. 
         ALLOCATE( EM_SPEC( NISTR0 ) )                ! CMAQ Species Names
         EM_SPEC = ""
         ALLOCATE( EM_SURR( NISTR0,N_EM_SRM ) )       ! Surrogate Name
         EM_SURR = ""
         ALLOCATE( EM_FAC ( NISTR0,N_EM_SRM,N_SCALEFAC ) ) ! Scale Factor
         EM_FAC = 0.0
         ALLOCATE( EM_FAC_BULK( NISTR0,N_EM_SRM,N_SCALEFAC ) ) ! Bulk Scale Factor For Printing to Diagnostic
         EM_FAC_BULK = 0.0                                        !   Output. Ignores aero_split and unit conversion
         ALLOCATE( EM_OP( NISTR0,N_EM_SRM,N_SCALEFAC ) )  ! Bulk Scale Factor For Printing to Diagnostic
         EM_OP = ""                                          !   Output. Ignores aero_split and unit conversion
         ALLOCATE( EM_REG( NISTR0,N_EM_SRM,N_SCALEFAC ) ) ! Bulk Scale Factor For Printing to Diagnostic
         EM_REG = 1                                          !   Output. Ignores aero_split and unit conversion
         ALLOCATE( EM_BASIS ( NISTR0,N_EM_SRM,N_SCALEFAC ) )   ! Mass or Mole Basis for Conversion
         EM_BASIS = ""
         ALLOCATE( EM_CONV ( NISTR0,N_EM_SRM,N_SCALEFAC ) )   ! Mass or Mole Basis for Conversion
         EM_CONV = 1.0
         ALLOCATE( MAP_EMtoDIFF( NISTR0 ) )           ! Map from Emissions Species 
         MAP_EMtoDIFF = 0                             !   to Diffusion Vector
         ALLOCATE( MAP_EMtoSURR( NISTR0,N_EM_SRM ) )  ! Map from Emissions Species 
         MAP_EMtoSURR = 0                             !   to Surrogate Locatino on File
         ALLOCATE( MAP_EMtoGAS( NISTR0 ) )           ! Map from Emissions Species 
         MAP_EMtoGAS = 0                             !   to aerosol table
         ALLOCATE( MAP_EMtoAERO( NISTR0 ) )           ! Map from Emissions Species 
         MAP_EMtoAERO = 0                             !   to aerosol table
         ALLOCATE( MAP_EMtoMODE( NISTR0 ) )           ! Map from Emissions Species 
         MAP_EMtoMODE = 0                             !   to CMAQ aerosol mode
         ALLOCATE( MAP_EMtoNUM ( NISTR0 ) )           ! Map from Emissions Species 
         MAP_EMtoNUM  = 0                             !   to aerosol number
         ALLOCATE( MAP_EMtoSRF ( NISTR0 ) )           ! Map from Emissions Species 
         MAP_EMtoSRF  = 0                             !   to aerosol surface area
         ALLOCATE( MAP_EMtoSD  ( NISTR0,N_EM_SRM ) )  ! Map from Emissions Species 
         MAP_EMtoSD  = 0                              !   to emissions aerosol mode
         ALLOCATE( EM_FILE_DIFF( N_SPC_DIFF,N_EM_SRM ) )
         EM_FILE_DIFF = .FALSE.

         ! Find all matches between the transported species list and the
         ! available surrogates from each stream. Apply a scale factor
         ! of 1 to these matches. For aerosols, the CMAQ species name
         ! may or may not include the mode suffix (eg. i, j, or k).
         ! Equivalence tests should be performed without a suffix on the
         ! surrogate name and with each suffix added in turn.

         N_EMIS_ISTR = 0
         SPECNAME = ''

! Insert Emissions Instructions for Aerosol Number and Surface Area,
! if at least one aerosol species is being transported
         IF ( COUNT( DIFF_MASK_AERO ) .GT. 0 ) THEN
            DO IM = 1,N_MODE
               ! Aerosol Number
               EM_SPEC( N_EMIS_ISTR+1 ) = AEROMODE( IM )%NUM_NAME
               EM_FAC ( N_EMIS_ISTR+1,:,1 ) = 1.0
               EM_FAC_BULK ( N_EMIS_ISTR+1,:,1 ) = 1.0         
               EM_BASIS( N_EMIS_ISTR+1,:,1 ) = 'UNIT'
               EM_CONV( N_EMIS_ISTR+1,:,1 ) = 1.0
               EM_OP ( N_EMIS_ISTR+1,:,1 ) = "a"
               EM_REG ( N_EMIS_ISTR+1,:,1 ) = 1
               MAP_NUMtoEM( IM ) = N_EMIS_ISTR+1
               MAP_EMtoNUM( N_EMIS_ISTR+1 ) = IM
               MAP_EMtoDIFF( N_EMIS_ISTR+1 ) = 
     &            INDEX1( EM_SPEC( N_EMIS_ISTR+1 ), N_SPC_DIFF, DIFF_SPC )
               EM_FILE_DIFF( MAP_EMtoDIFF( N_EMIS_ISTR+1 ),: ) = .TRUE.
               MAP_EMtoSD( N_EMIS_ISTR+1, : ) = 0

               ! Aerosol Surface Area
               EM_SPEC( N_EMIS_ISTR+2 ) = AEROMODE( IM )%SRF_NAME
               EM_FAC ( N_EMIS_ISTR+2,:,1 ) = 1.0
               EM_FAC_BULK ( N_EMIS_ISTR+2,:,1 ) = 1.0         
               EM_BASIS( N_EMIS_ISTR+2,:,1 ) = 'UNIT'
               EM_CONV( N_EMIS_ISTR+2,:,1 ) = 1.0
               EM_OP ( N_EMIS_ISTR+2,:,1 ) = "a"
               EM_REG ( N_EMIS_ISTR+2,:,1 ) = 1
               MAP_SRFtoEM( IM ) = N_EMIS_ISTR+2
               MAP_EMtoSRF( N_EMIS_ISTR+2 ) = IM
               MAP_EMtoDIFF( N_EMIS_ISTR+2 ) = 
     &            INDEX1( EM_SPEC( N_EMIS_ISTR+2 ), N_SPC_DIFF, DIFF_SPC )
               EM_FILE_DIFF( MAP_EMtoDIFF( N_EMIS_ISTR+2 ),: ) = .TRUE.
               MAP_EMtoSD( N_EMIS_ISTR+2, : ) = 0

               N_EMIS_ISTR = N_EMIS_ISTR + 2
            END DO
         END IF

! Process User-Defined Emissions Scaling Rules. 
        ! Find Total Number of Rules
         N_EM_RULE = 0
         DO IRULE = 1,N_EM_RULE_REG
            IF( EM_NML( IRULE )%SPEC .EQ. '' ) EXIT
            N_EM_RULE = IRULE
         END DO

         ! Implement Default Scaling Rules that will Always Be Applied
         CALL CUSTOM_EM_RULES( N_EM_RULE )


         ! Allocate Rule->Instruction Transform Masks
         ALLOCATE( EM_STREAM_RULE  ( N_EM_SRM   ) )
         ALLOCATE( EM_SPEC_RULE ( N_SPC_DIFF ) )
         ALLOCATE( EM_SURR_RULE ( N_EM_SRM ) )
         ALLOCATE( EM_PHASE_RULE( N_EM_SRM ) )
         DO ISRM = 1,N_EM_SRM
           N = EM_FILE_SURR( ISRM )%LEN
           EM_SURR_RULE( ISRM )%LEN = N
           ALLOCATE( EM_SURR_RULE( ISRM )%ARRY( N ) )

           N = EM_STREAM_SIZE( ISRM )%LEN
           EM_PHASE_RULE( ISRM )%LEN = N
           ALLOCATE( EM_PHASE_RULE( ISRM )%ARRY( N ) )
         END DO
 
         ! Loop Through Emission Rules, Test for Fidelity, expand if necessary
         ! and Apply them to the instruction set that currently exists.
         DO IRULE = 1,N_EM_RULE 
            ! Exit this loop if the rule is blank
            IF ( EM_NML( IRULE )%SPEC .EQ. '' ) EXIT 

            ! Expand Rule To Individual Instructions. If the CMAQ
            ! Species, Stream Label, and Surrogate are all single
            ! components, then there will just be one instruction. If
            ! any of them equal 'All' the number of instructions will
            ! grow correspondingly.

            !------   ------   ------   ------   ------   ------   -----
            ! First error check and expand the stream field
            ! This subroutine returns a logical vector, EM_STREAM_RULE,
            ! which identifies which streams are affected by this rule.
            LREMOVE = .FALSE.
            CALL INTERPRET_EM_RULE_STREAM( EM_NML( IRULE )%STREAM, IRULE, 
     &              EM_STREAM_RULE, LREMOVE )
            IF ( LREMOVE ) CYCLE

            !------   ------   ------   ------   ------   ----  
            ! Now error check and expand the surrogate field
            CALL UPCASE( EM_NML( IRULE )%SURR )
 
            !Initialize Surrogate Array for every Stream
            DO ISRM = 1,N_EM_SRM
              EM_SURR_RULE( ISRM )%ARRY = .FALSE.
            END DO
            LSURR_KEY = .FALSE.

            LERROR = .TRUE.
            IF ( EM_NML( IRULE )%SURR .EQ. 'ALL' ) THEN
               ! Expand the Rule to Apply to All Surrogates
               DO ISRM = 1,N_EM_SRM
                 IF ( .NOT. EM_STREAM_RULE( ISRM ) ) CYCLE
                 EM_SURR_RULE( ISRM )%ARRY = .TRUE.
                 LSURR_KEY( IRULE ) = .TRUE.
                 LERROR = .FALSE.
               END DO
            ELSE
               ! Determine if the Surrogate Label Refers to A Family and if So, 
               ! Apply the Rule to all members of that Family
               IFAM = INDEX1( EM_NML( IRULE )%SURR, NChemFamilies, ChemFamilyName )
               IF ( IFAM .EQ. 0 ) THEN
                  ! This Surrogate Label Does not match any families.
                  ! Just look for one surrogate
                  DO ISRM = 1,N_EM_SRM
                     IF ( .NOT.EM_STREAM_RULE( ISRM ) ) CYCLE
                     IDX = INDEX1( EM_NML( IRULE )%SURR, EM_FILE_SURR( ISRM )%LEN, 
     &                             EM_FILE_SURR( ISRM )%ARRY )
                     IF ( IDX .NE. 0 ) THEN
                        EM_SURR_RULE( ISRM )%ARRY( IDX ) = .TRUE.
                        LERROR = .FALSE.
                     END IF
                 END DO
               ELSE
                  ! Surrogate Label is for a family. Loop through all
                  ! the members to assign surrogates
                  NCHEM = ChemFamilyNum( IFAM )
                  CHEM_NAME(1:NCHEM) = ChemFamilyMembers( IFAM,1:NCHEM )
                  LSURR_KEY( IRULE ) = .TRUE.
 
                  LERROR = .FALSE.
                  DO ICHEM = 1,NCHEM
                     LERROR3( ICHEM ) = .FALSE.
                     LERROR2 = .TRUE.
                     DO ISRM = 1,N_EM_SRM
                        IF ( .NOT. EM_STREAM_RULE( ISRM ) ) CYCLE
                        ! Find the Specific Species this Rule Identifies
                        IDX = INDEX1( CHEM_NAME( ICHEM ), EM_FILE_SURR( ISRM )%LEN, 
     &                                EM_FILE_SURR( ISRM )%ARRY )
                        IF ( IDX .NE. 0 ) THEN
                           EM_SURR_RULE( ISRM )%ARRY( IDX ) = .TRUE.
                           LERROR2 = .FALSE.
                        END IF
                     END DO
                     IF ( LERROR2 ) THEN
                         LERROR3( ICHEM ) = .TRUE.
                         LERROR = .TRUE.
                     END IF
                  END DO          
               END IF
 
            END IF
            
            IF ( LERROR ) THEN
              IF ( .NOT. EMISCHK ) THEN
                 WRITE( LOGDEV, '(/,5x,A,/,5x,2A,4(/,5x,A))') 
     &                  '*** ATTENTION **********************************************:',
     &                  'The emission surrogate or member of family ',TRIM( EM_NML( IRULE )%SURR ),
     &                  'was not found in the requested emission streams but the ',
     &                  'CTM_EMISCHK environment variable set to False so simulation ',
     &                  'will proceed.',
     &                  '*************************************************************'
                 IF ( IFAM .NE. 0 ) THEN
                    WRITE( LOGDEV, '(7x,A,/,7x,A,/,7x,A,1x,A )') 
     &                  'The surrogate label applied was a chemical family. The specific',
     &                  'family member(s) that did not appear on any emission stream',
     &                  'inputs was:'
                    DO ICHEM = 1,NCHEM
                        IF ( LERROR3( ICHEM ) ) WRITE( LOGDEV, '(20x,A)' ) TRIM( CHEM_NAME( ICHEM ) )
                    END DO
                    WRITE( LOGDEV, '(7x,A)' )
     &                  '*************************************************************'
                 END IF
                 CYCLE
              ELSE     
                 WRITE( LOGDEV, '(5x,A,/,5x,2A,/,8(/,5x,A))') 
     &                  '*** ERROR **************************************************************:',
     &                  'The emission surrogate or member of family ',TRIM( EM_NML( IRULE )%SURR ),
     &                  ' is not found in any of the emission streams.',
     &                  'Use one of the below options to continue.', 
     &                  '1) Change or remove this emission rule so that it refers to an existing surrogate.', 
     &                  'or',
     &                  '2) Change CTM_EMISCHK environment variable to False (F) in the runscript',
     &                  'if model predictions are acceptable without using the above emissions.',
     &                  '*************************************************************************'
                 IF ( IFAM .NE. 0 ) THEN
                    WRITE( LOGDEV, '(7x,A,/,7x,A,/,7x,A,1x,A )') 
     &                  'The surrogate label applied was a chemical family. The specific',
     &                  'family member(s) that did not appear on any emission stream',
     &                  'inputs was:'
                    DO ICHEM = 1,NCHEM
                        IF ( LERROR3( ICHEM ) ) WRITE( LOGDEV, '(20x,A)' ) TRIM( CHEM_NAME( ICHEM ) )
                    END DO
                    WRITE( LOGDEV, '(7x,A)' )
     &                  '*************************************************************'
                 END IF
                 XMSG = 'Species with the missing surrogates ' 
     &                //'must have a surrogate found in at least one stream.'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
              END IF
            END IF
 
            !------   ------   ------   ------   ------   ------
            ! Now Error Check and Expand the CMAQ Species Field
            CALL UPCASE( EM_NML( IRULE )%SPEC )

            ! Initialize CMAQ Species Array
            EM_SPEC_RULE = .FALSE.
            LSPEC_KEY = .FALSE.

            IF ( EM_NML( IRULE )%SPEC .EQ. 'ALL' ) THEN
               ! Expand the Rule to Apply to All Species
               EM_SPEC_RULE = .TRUE.
               LSPEC_KEY( IRULE ) = .TRUE.
            ELSE     
               ! Determine if the Species Label Refers to A Family and if So, 
               ! Apply the Rule to all members of that Family
               IFAM = INDEX1( EM_NML( IRULE )%SPEC, NChemFamilies, ChemFamilyName )
               IF ( IFAM .EQ. 0 ) THEN
                  NCHEM = 1
                  CHEM_NAME(1) = EM_NML( IRULE )%SPEC
               ELSE
                  NCHEM = ChemFamilyNum( IFAM )
                  CHEM_NAME(1:NCHEM) = ChemFamilyMembers( IFAM,1:NCHEM )
                  LSPEC_KEY( IRULE ) = .TRUE.
               END IF

               DO ICHEM = 1,NCHEM
                 ! Find the Specific Species this Rule Identifies
                 IDX = INDEX1( CHEM_NAME( ICHEM ), N_SPC_DIFF, DIFF_SPC )
                 JDX = INDEX1( CHEM_NAME( ICHEM ), N_AEROSPC,  AEROSPC( : )%BULKNAME )
                 IF ( IDX .NE. 0 ) THEN
                   EM_SPEC_RULE( IDX ) = .TRUE.
                 ELSE IF ( JDX .NE. 0 ) THEN
                   ! This is an aerosol species, and it is being
                   ! identified with a bulk name (no mode suffix). 
                   ! We need to allow for all possible DIFF_SPC with
                   ! all used suffixes
                   SN = CHEM_NAME( ICHEM )
                   DO IM = 1,N_MODE
                     KDX = INDEX1( TRIM( SN )//MODESUFF( IM ), N_SPC_DIFF, DIFF_SPC )
                     IF ( KDX .NE. 0 ) EM_SPEC_RULE( KDX ) = .TRUE.
                   END DO
                 ELSE
                   WRITE( LOGDEV, '(/,3A,/,A,/,A,/,A,/,A)' ),
     &               'Species ',TRIM(EM_NML( IRULE )%SPEC),' was used in the Emissions',
     &               ' Control Instructions Namelist but it is not a valid CMAQ ',
     &               'transported species or family. Please add it to one of the ',
     &               'input chemical namelists (ie. GC, AE, etc). Note that aerosol',
     &               'Number and Surface Area Species are not valid for scaling.'
                   XMSG = 'Error in Emissions Map Processing.'
                   CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                 END IF
               END DO
           END IF 
 
            !------   ------   ------   ------   ------   ------
            ! Now Error Check and Expand the Phase Field
            CALL UPCASE( EM_NML( IRULE )%PHASE )

            !Initialize Surrogate Array for every Stream
            DO ISRM = 1,N_EM_SRM
              EM_PHASE_RULE( ISRM )%ARRY = .FALSE.
            END DO

            LERROR = .TRUE.
            DO ISRM = 1,N_EM_SRM 
              ! Skip this stream if it is not identified
              IF ( .NOT. EM_STREAM_RULE( ISRM ) ) CYCLE 

              IF ( EM_NML( IRULE )%PHASE .EQ. 'ALL' ) THEN
                 ! Expand the Rule to Apply to All Phases and Modes
                 EM_PHASE_RULE( ISRM )%ARRY = .TRUE.
                 LERROR = .FALSE.
              ELSE IF ( EM_NML( IRULE )%PHASE .EQ. 'AERO' ) THEN
                 ! Expand the Rule to Apply to All Aerosol Modes
                 EM_PHASE_RULE( ISRM )%ARRY(2:) = .TRUE.
                 LERROR = .FALSE.
              ELSE
                 ! Find the Specific Phase/Mode this Rule Identifies
                 IDX = INDEX1( EM_NML( IRULE )%PHASE, EM_STREAM_SIZE( ISRM )%LEN, 
     &                         EM_STREAM_SIZE( ISRM )%NAME )
                 IF ( IDX .NE. 0 ) THEN
                   EM_PHASE_RULE( ISRM )%ARRY( IDX ) = .TRUE.
                   LERROR = .FALSE.
                 END IF
              END IF
            END DO
            
            IF ( LERROR ) THEN
                 WRITE( LOGDEV, '(A,/,2A,/,A,/,A,I3,A1,/,A)') 
     &                  '*****************************ERROR***************************************:',
     &                  'The phase or mode ',TRIM( EM_NML( IRULE )%PHASE ),
     &                  ' is not found in any of the emission streams you''re requesting for ',
     &                  'emission rule ',IRULE,'.',
     &                  '*************************************************************************'
                 WRITE( LOGDEV, * )
                 XMSG = 'Species with the missing surrogates ' 
     &                //'must have a surrogate found in at least one stream.'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
 
            !------   ------   ------   ------   ------   ------
            ! Now Error Check the Region Field
            CALL UPCASE( EM_NML( IRULE )%REGION )

            ! Check that the Region has been defined
            LERROR = .TRUE.
            DO IRGN = 1,N_EM_RGN 
              IF ( EM_NML( IRULE )%REGION .EQ. 
     &             EM_REGIONS( IRGN )%LABEL ) THEN 
                 REGNUM = IRGN
                 LERROR = .FALSE.
              END IF
            END DO
            
            IF ( LERROR ) THEN
                 WRITE( LOGDEV, '(A,/,2A,/,A,/,A,/,A)') 
     &                  '*****************************ERROR***************************************:',
     &                  'The Region ',TRIM( EM_NML( IRULE )%REGION ),
     &                  ' is not found in any of the regions defined',
     &                  ' in the Emission Control File.',
     &                  '*************************************************************************'
                 WRITE( LOGDEV, * )
                 XMSG = 'Regions used in the Emissions Scaling must ' 
     &                //'be defined on the Emission Control File.'
                 CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
 
            !------   ------   ------   ------   ------
            ! Check the Operation Identifier for errors
            IF ( EM_NML( IRULE )%OP .NE. 'a' .AND.
     &           EM_NML( IRULE )%OP .NE. 'm' .AND.
     &           EM_NML( IRULE )%OP .NE. 'o'       ) THEN
               WRITE( LOGDEV, * )
               WRITE( XMSG, '(/,A,A,A,I3,A,A,A)' ),
     &             'The Emissions Operator (',EM_NML( IRULE )%OP,
     &             ') applied for Rule ',IRULE,' in the Emissions Control ',
     &             'Namelist does not match any of the allowed values (a, m, or o)',
     &             '. Please check the your emissions control inputs.'
               WRITE( LOGDEV, * )TRIM( XMSG )
               XMSG = 'Error in Emissions Map Processing.'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
            
            !------   ------   ------   ------   ------   ------ ------
            ! Order the indivdual commands in this rule into one
            ! vector of instructions. The operator, scale factor, and
            ! region for each of these commands will be uniform because 
            ! they apply to the entire rule
            N_COMMANDS = 0
            DO IDIFF = 1,N_SPC_DIFF
            IF ( EM_SPEC_RULE( IDIFF ) ) THEN
              DO ISRM = 1,N_EM_SRM
              IF ( EM_STREAM_RULE( ISRM ) ) THEN
                DO ISUR = 1,EM_FILE_SURR( ISRM )%LEN 
                IF ( EM_SURR_RULE( ISRM )%ARRY( ISUR ) ) THEN
                  DO ISD = 1,EM_STREAM_SIZE( ISRM )%LEN
                  IF ( EM_PHASE_RULE( ISRM )%ARRY( ISD ) ) THEN

                    LTEST = .TRUE.
                    
                    ! If this command applies to a Gas CMAQ species, make
                    ! sure the aerosol phases are not invoked so that 
                    ! double-counting is avoided
                    IF ( .NOT. DIFF_MASK_AERO( IDIFF ) .AND. 
     &                   EM_STREAM_SIZE( ISRM )%NAME( ISD ) .NE. 'GAS' )
     &                 LTEST = .FALSE.

                    ! If this command applies to an aerosol CMAQ species,
                    ! then make sure that the 'mode' selection will apply
                    ! mass to this CMAQ species, DIFF_SPC( IDIFF ).
                    ! Because CMAQ species are resolved in modes, it
                    ! could be that this 'mode' selection will not put
                    ! any mass in this species. For example, if this
                    ! species is for the Aitken mode, but the selection
                    ! was meant to populate the coarse mode.
                    IF ( DIFF_MASK_AERO( IDIFF ) ) THEN
                        DO IAERO = 1,N_AEROSPC
                           IM = INDEX1( DIFF_SPC( IDIFF ), N_MODE,
     &                                  AEROSPC( IAERO )%NAME( : ) )
                           IF ( IM .GT. 0 ) THEN
                             IF ( EM_STREAM_SIZE( ISRM )%FACNUM( ISD,IM ) 
     &                              .LE. 1.0e-10 ) LTEST = .FALSE.
                           END IF
                        END DO
                    END IF

                    ! If any family name was used for the Surrogate 
                    ! and Species fields and those family or keyword
                    ! names match, then only exact matches or existing 
                    ! relationships should be populated.
                    IF (   (LSURR_KEY( IRULE ) .AND. 
     &                      LSPEC_KEY( IRULE ) )
     &                  .AND.
     &                     (EM_FILE_SURR( ISRM )%ARRY( ISUR ) .NE. 
     &                      DIFF_SPC( IDIFF ) ) ) THEN
                      ! Look for this relationship in at least one
                      ! of the existing instructions
                      LTEST = .FALSE.
                      DO ISTRN = 1,N_EMIS_ISTR
                          IF ( EM_SPEC( ISTRN ) .EQ. DIFF_SPC( IDIFF ) .AND.
     &                         EM_SURR( ISTRN,ISRM ) .EQ. 
     &                           EM_FILE_SURR( ISRM )%ARRY( ISUR ) ) THEN
                            LTEST = .TRUE.
                          END IF
                      END DO
                    END IF

                    ! Add an Instruction for this combination of CMAQ
                    ! Species, Stream, Surrogate, and Phase if the test
                    ! for validity (LTEST) is still TRUE
                    IF ( LTEST ) THEN
                      N_COMMANDS = N_COMMANDS + 1
                      RULE_ISTR_IDIFF( N_COMMANDS ) = IDIFF
                      RULE_ISTR_ISRM ( N_COMMANDS ) = ISRM
                      RULE_ISTR_ISUR ( N_COMMANDS ) = ISUR
                      RULE_ISTR_SPEC ( N_COMMANDS ) = DIFF_SPC( IDIFF )
                      RULE_ISTR_SURR ( N_COMMANDS ) = 
     &                     EM_FILE_SURR( ISRM )%ARRY( ISUR )
                      RULE_ISTR_PHASE( N_COMMANDS ) = ISD
                    END IF
                  END IF
                  END DO
                END IF
                END DO
              END IF
              END DO
            END IF
            END DO
            
            !------   ------   ------   ------   ------   ------
            ! Modify the Emissions Instruction Set Based on this Rule
            IF ( EM_NML( IRULE )%OP .EQ. 'a' ) THEN
               ! Add this rule to existing instructions
               DO IC = 1,N_COMMANDS
                  ! This entry needs to be created, but first we need
                  ! to check whether to add it as a new row or add it
                  ! to a previous row. We can add to a previous row
                  ! if the CMAQ species matches exactly, there is no 
                  ! surrogate present for this stream, and the same
                  ! Emissions Surrogate is being used for another 
                  ! stream.
                  LFOUND = .FALSE.
                  ! Look For a suitable previous instruction to add to.
                  IF ( N_EMIS_ISTR .GT. 0 ) THEN
                  DO ISTRN = 1,N_EMIS_ISTR
                    IF ( EM_SPEC( ISTRN ) .EQ. RULE_ISTR_SPEC( IC ) .AND.
     &                   EM_SURR( ISTRN,RULE_ISTR_ISRM( IC ) ) .EQ. '' .AND.
     &                   ANY( EM_SURR( ISTRN,: ) .EQ. RULE_ISTR_SURR( IC )) ) THEN
                      ! Add This Command to Instruction number ISTR
                      ISTR = ISTRN
                      LFOUND = .TRUE.
                    END IF
                  END DO
                  END IF

                  ! If no suitable instruction was found to add to, add a new
                  ! instruction. This means either there was no previous
                  ! instruction with the same CMAQ species and surrogate or there 
                  ! was an instruction with this CMAQ species but it already
                  ! had a surrogate and scale factor associated with this stream.
                  IF ( .NOT. LFOUND ) THEN
                    N_EMIS_ISTR = N_EMIS_ISTR + 1
                    ISTR = N_EMIS_ISTR

                    EM_SPEC( ISTR ) = RULE_ISTR_SPEC( IC )
                    MAP_EMtoDIFF( ISTR ) = RULE_ISTR_IDIFF( IC )

                    ! Link this row to the Aerosol or Gas Species
                    IF ( DIFF_MASK_AERO( RULE_ISTR_IDIFF( IC ) ) ) THEN
                      DO IAERO = 1,N_AEROSPC
                        JM = INDEX1( EM_SPEC( ISTR ), N_MODE, AEROSPC( IAERO )%NAME( : ) )
                        IF ( JM .GT. 0 ) THEN
                          MAP_EMtoAERO( ISTR ) = IAERO
                          MAP_EMtoMODE( ISTR ) = JM
                        END IF
                      END DO
                    ELSE
                      MAP_EMtoGAS( ISTR ) = RULE_ISTR_IDIFF( IC )
                    END IF
                  END IF
                          
                  ! Now that the instruction location has either been
                  ! found or created, populate it.
                  ISRM = RULE_ISTR_ISRM( IC )
                  IEM  = EM_STREAM_SIZE( ISRM )%REF( RULE_ISTR_PHASE( IC ) )
                  ISUR = RULE_ISTR_ISUR( IC )
                    
                  EM_SURR( ISTR, ISRM ) = RULE_ISTR_SURR( IC )
                  MAP_EMtoSURR( ISTR, ISRM ) = ISUR
                  EM_FILE_SURR( ISRM )%USED( ISUR ) = .TRUE.
                  MAP_EMtoSD( ISTR, ISRM ) = RULE_ISTR_PHASE( IC )
                  EM_FILE_DIFF( RULE_ISTR_IDIFF( IC ),ISRM ) = .TRUE.

                  ! Only apply an aerosol size-split parameter if this
                  ! species is an aerosol and if it is not from a dust 
                  ! or sea spray sector
                  AERO_SPLIT = 1.0
                  IF ( DIFF_MASK_AERO( RULE_ISTR_IDIFF( IC ) ) .AND. 
     &                 ISRM .NE. IDUSTSRM .AND. ISRM .NE. ISEASRM    )
     &                 AERO_SPLIT = SD_SPLIT( RULE_ISTR_IDIFF( IC ), IEM )

                  ! Determine Next Free Location in Scale Factor Space
                  ! (IFAC) so that the scale factor can be added.
                  DO IFAC = 1,N_SCALEFAC
                      IF ( EM_OP( ISTR, ISRM, IFAC ) .EQ. '' ) THEN
                           EM_FAC ( ISTR, ISRM, IFAC ) = EM_NML( IRULE)%FAC * AERO_SPLIT
                        EM_FAC_BULK ( ISTR, ISRM, IFAC ) = EM_NML( IRULE)%FAC
                        EM_REG( ISTR, ISRM, IFAC )    = REGNUM
                        CALL CHECK_OP( EM_NML( IRULE )%OP, IRULE )
                        EM_OP( ISTR, ISRM, IFAC )     = EM_NML( IRULE)%OP
                        CALL CHECK_BASIS( EM_NML( IRULE )%BASIS, IRULE )
                        EM_BASIS( ISTR, ISRM, IFAC )  = EM_NML( IRULE)%BASIS
                        EM_CONV( ISTR, ISRM, IFAC )  = EM_FILE_SURR( ISRM )%CONV( ISUR )
                        EXIT
                     END IF
                  END DO
               END DO
            ELSE
               ! Modify All Existing Instructions that Match this
               ! rule's parameters.
               DO IC = 1,N_COMMANDS
                 ! Loop through existing instructions and find matches
                 IF ( N_EMIS_ISTR .GT. 0 ) THEN
                   ISRM = RULE_ISTR_ISRM( IC )
                   DO ISTR = 1,N_EMIS_ISTR
                   IF ( EM_SPEC( ISTR ) .EQ. RULE_ISTR_SPEC( IC ) ) THEN
                      IF ( EM_SURR( ISTR, ISRM ) .EQ. RULE_ISTR_SURR( IC ) .AND.
     &                     MAP_EMtoSD( ISTR,ISRM ) .EQ. RULE_ISTR_PHASE( IC ) ) THEN
                  
                        ISUR = RULE_ISTR_ISUR( IC )
                        IEM = EM_STREAM_SIZE( ISRM )%REF( RULE_ISTR_PHASE( IC ) )
                        AERO_SPLIT = 1.0
                        IF ( DIFF_MASK_AERO( RULE_ISTR_IDIFF( IC ) ) .AND.
     &                       EM_NML( IRULE )%OP .EQ. 'o' ) 
     &                       AERO_SPLIT = SD_SPLIT( RULE_ISTR_IDIFF( IC ), IEM )

                        ! Determine Next Free Location in Scale Factor Space (IFAC) so 
                        ! that the scale factor can be added.
                        DO IFAC = 1,N_SCALEFAC
                          IF ( EM_OP( ISTR, ISRM, IFAC ) .EQ. '' ) THEN
                             EM_FAC ( ISTR, ISRM, IFAC )     = EM_NML( IRULE )%FAC * AERO_SPLIT
                             EM_FAC_BULK ( ISTR, ISRM, IFAC ) = EM_NML( IRULE )%FAC
                             EM_REG( ISTR, ISRM, IFAC )       = REGNUM
                             CALL CHECK_OP( EM_NML( IRULE )%OP, IRULE )
                             EM_OP( ISTR, ISRM, IFAC )        = EM_NML( IRULE )%OP
                             CALL CHECK_BASIS( EM_NML( IRULE )%BASIS, IRULE )
                             EM_BASIS( ISTR, ISRM, IFAC )     = EM_NML( IRULE )%BASIS
                             EM_CONV( ISTR, ISRM, IFAC )      = EM_FILE_SURR( ISRM )%CONV( ISUR )
                             EXIT
                          END IF
                        END DO
 
                      END IF
                   END IF
                   END DO
                 ELSE
                   WRITE( LOGDEV, '(5(/,A))' ),
     &              'ATTENTION: The emissions control file is ',
     &              'attempting to modify an existing instruction, but ',
     &              'there are no compatible existing instructions. ',
     &              'Please check the configuration of the emission ',
     &              'control file.'
                 END IF
               END DO
            END IF  ! Operator
         END DO !IRULE

! Inspect all of the Emissions Instructions for conversion based on 
! mass or moles. If there is a conversion, apply the correct factor
! based on species molecular weights.
         ALLOCATE( EM_FAC_ST( N_EMIS_ISTR,N_EM_SRM ) )
         DO ISTR = 1,N_EMIS_ISTR
            DO ISRM = 1,N_EM_SRM
               EM_FAC_ST( ISTR,ISRM )%LEN = 0
               IF ( MAP_EMtoSURR( ISTR,ISRM ) .NE. 0 ) THEN

               ! First load emission factor structure
               NFAC = 1
               DO IFAC = 2,N_SCALEFAC
                   IF ( EM_OP( ISTR,ISRM,IFAC ) .EQ. '' ) EXIT
                 NFAC = NFAC + 1  
               END DO

               ! Allocate and Prepopulate Emission Factor Structure
               EM_FAC_ST( ISTR,ISRM )%LEN = NFAC
               ALLOCATE( EM_FAC_ST( ISTR,ISRM )%FAC( NFAC ) )
               ALLOCATE( EM_FAC_ST( ISTR,ISRM )%BULK( NFAC ) )
               ALLOCATE( EM_FAC_ST( ISTR,ISRM )%BASIS( NFAC ) )
               ALLOCATE( EM_FAC_ST( ISTR,ISRM )%REG( NFAC ) )
               ALLOCATE( EM_FAC_ST( ISTR,ISRM )%OP( NFAC ) )
                 
               EM_FAC_ST( ISTR,ISRM )%FAC  = 0.
               EM_FAC_ST( ISTR,ISRM )%BULK = 0.
               EM_FAC_ST( ISTR,ISRM )%BASIS= 1.
               EM_FAC_ST( ISTR,ISRM )%REG  = 1
               EM_FAC_ST( ISTR,ISRM )%OP   = 0
        
               ISUR  = MAP_EMtoSURR( ISTR,ISRM )
               SURR_MW = EM_FILE_SURR( ISRM )%MW( ISUR ) ! MW [g mol-1]
               SPEC_MW = DIFF_MW( MAP_EMtoDIFF( ISTR ) )


               ! Populate Emission Factor Structure
               DO IFAC = 1,NFAC
                 EM_FAC_ST( ISTR,ISRM )%FAC( IFAC )    = EM_FAC ( ISTR, ISRM, IFAC ) 
                 EM_FAC_ST( ISTR,ISRM )%BULK( IFAC )   = EM_FAC_BULK( ISTR, ISRM, IFAC )
                 EM_FAC_ST( ISTR,ISRM )%REG( IFAC )    = EM_REG( ISTR, ISRM, IFAC )
                      
                   SELECT CASE ( EM_OP( ISTR, ISRM, IFAC ) )
                   CASE ( 'a' )
                       EM_FAC_ST( ISTR,ISRM )%OP( IFAC )    = 1
                   CASE ( 'm' )
                       EM_FAC_ST( ISTR,ISRM )%OP( IFAC )    = 2
                   CASE ( 'o' )
                       EM_FAC_ST( ISTR,ISRM )%OP( IFAC )    = 3
                 END SELECT

                 BASIS_FAC = 1.0
                 IF ( EM_BASIS( ISTR, ISRM, IFAC ) .EQ. 'UNIT' ) THEN
                     BASIS_FAC = BASIS_FAC
                 ELSE IF ( EM_BASIS( ISTR, ISRM, IFAC ) .EQ. 'MOLE' ) THEN
                     IF ( EM_FILE_SURR( ISRM )%BASIS( MAP_EMtoSURR( ISTR,ISRM ) ) .EQ. 'MOLE' ) THEN
                        BASIS_FAC = BASIS_FAC
                     ELSE
                        ! Convert surrogate emission rate to moles
                        BASIS_FAC = BASIS_FAC / SURR_MW  
                     END IF
                     IF ( .NOT. DIFF_MASK_AERO( MAP_EMtoDIFF( ISTR ) ) ) THEN
                        BASIS_FAC = BASIS_FAC
                     ELSE
                        ! Convert species emission rate to mass
                        BASIS_FAC = BASIS_FAC * SPEC_MW
                     END IF
                 ELSE IF ( EM_BASIS( ISTR, ISRM, IFAC ) .EQ. 'MASS' ) THEN
                     IF ( EM_FILE_SURR( ISRM )%BASIS( MAP_EMtoSURR( ISTR,ISRM ) ) .EQ. 'MOLE' ) THEN
                        ! Convert surrogate emission rate to mass
                        BASIS_FAC = BASIS_FAC * SURR_MW
                     ELSE
                        BASIS_FAC = BASIS_FAC
                     END IF
                     IF ( .NOT. DIFF_MASK_AERO( MAP_EMtoDIFF( ISTR ) ) ) THEN
                        ! Convert species emission rate to moles
                        BASIS_FAC = BASIS_FAC / SPEC_MW
                     ELSE
                        BASIS_FAC = BASIS_FAC
                     END IF
                 END IF
                 EM_FAC_ST( ISTR,ISRM )%BASIS = BASIS_FAC

                 IF ( EM_FAC_ST( ISTR,ISRM )%OP( IFAC ) .NE. 2 ) 
     &                EM_FAC_ST( ISTR,ISRM )%FAC( IFAC ) = 
     &                     EM_FAC_ST( ISTR,ISRM )%FAC( IFAC ) * BASIS_FAC
     &                       * EM_CONV( ISTR, ISRM, IFAC )
              END DO

              END IF
            END DO

        END DO !End Rule Loop

         ! Warn the User if there are no emissions instructions provided        
         IF ( N_EMIS_ISTR .LE. 0 ) THEN
            XMSG = 'There are no emissions instructions: VDEMIS is set to zero' ! below
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
         END IF

         ! Print a message for each emissions stream surrogate that is not used.
         WRITE( LOGDEV, '(/,5x,A)' ) '|> Checking for unused Emissions Surrogates:'
         WRITE( LOGDEV, '(5x,A)'   ),'============================================'

         LERROR = .FALSE.
         DO ISRM = 1,N_EM_SRM
             N = EM_FILE_SURR( ISRM )%LEN
             N_UNUSED = COUNT( .NOT. EM_FILE_SURR( ISRM )%USED( : )
     &                         .AND. EM_FILE_SURR(ISRM)%ARRY( 1:N ) .NE. 'NOT_AVAILABLE'  )
             WRITE( LOGDEV, '(5x,4A,I2,A)' ), TRIM( EM_FILE_LAB( ISRM )),' | ',
     &              TRIM(EM_FILE_DESC( ISRM )),': ', N_UNUSED,' unused surrogates.'
             IF ( N_UNUSED .GT. 0 ) THEN
                 LERROR = .TRUE.

                 DO ISUR = 1,EM_FILE_SURR( ISRM )%LEN
                   IF ( .NOT.EM_FILE_SURR( ISRM )%USED( ISUR )
     &                  .AND.EM_FILE_SURR( ISRM )%ARRY( ISUR ) .NE. 'NOT_AVAILABLE' ) 
     &               WRITE( LOGDEV, '(10x,A)'), EM_FILE_SURR( ISRM )%ARRY( ISUR )
                 END DO
             END IF
             WRITE( LOGDEV, '()' )
         END DO
         IF ( LERROR ) WRITE( LOGDEV, '(5x,A,/,5x,A,/,5x,A)' ),
     &       'NOTE: Some Emissions Surrogates are unused by your current', 
     &       'emission control configuration. You may want to include these ',
     &       'emissions if they are relevant to your application.'

         ! Print a message for every used surrogate that is not recognized on 
         ! the EMIS_SURR_TABLE                 
         WRITE( LOGDEV, '(/,5x,A)' ) '|> Checking status of used Emissions Surrogates:'
         WRITE( LOGDEV, '(5x,A)'   ),'================================================'

         DO ICATCH = 1,N_SURR_CATCH
             B = EM_SURR_CATCH( ICATCH )
             N_USED = 0
             !L_CATCH = .FALSE.
             DO ISRM = 1,N_EM_SRM
                 N = EM_FILE_SURR( ISRM )%LEN
                 N_USED = N_USED + COUNT( EM_FILE_SURR(ISRM)%ARRY( 1:N ) .EQ. B 
     &                                    .AND. EM_FILE_SURR(ISRM)%USED( 1:N ) )

                 !N = INDEX1( B,EM_FILE_SURR(ISRM)%LEN, EM_FILE_SURR(ISRM)%ARRY )
                 !IF ( N .GT. 0 ) THEN
                 !  IF ( EM_FILE_SURR( ISRM )%USED( N ) ) L_CATCH = .TRUE.
                 !END IF
             END DO
             IF ( N_USED .GT. 0 )
     &           WRITE( LOGDEV, '(/,5x,3A,/,5x,A,/,5x,3A,/,5x,A,/,5x,A,/,5x,A)') 
     &                  'WARNING: Surrogate ',TRIM(B),' is being used but does not have a',
     &                  '         default entry in the EMIS_SURR_TABLE in EMIS_VARS.F. Currently,',
     &                  '         the molecular weight of ',TRIM(B),' is assumed to be 1.0',
     &                  '         g/mol for any emissions scaling operations requiring mass-mole',
     &                  '         conversions. If you are only prescribing UNIT scaling, then this',
     &                  '         assumption will not be problematic.'
         END DO 

! Resize Important Arrays
         MAP_EMtoDIFF = MAP_EMtoDIFF( 1:N_EMIS_ISTR )
         MAP_EMtoNUM  = MAP_EMtoNUM ( 1:N_EMIS_ISTR )
         MAP_EMtoSRF  = MAP_EMtoSRF ( 1:N_EMIS_ISTR )
         MAP_EMtoAERO = MAP_EMtoAERO( 1:N_EMIS_ISTR )


! An Emissions Scaling Map Now Exists as a 2D Array (NSPECIES x NSTREAMS).
! For every element, there is an associated surrogate and scale factor
! to be applied. For the aerosols, the scale factor will be modified
! later in order to split the mass into the appropriate modes.


! Print out the Tables of CMAQ Emissions Instructions organized by each 
! emission stream and then by CMAQ internal species.

         WRITE( LOGDEV, '(/,/,5x,A)' ),'|> EMISSIONS SCALING DIAGNOSTIC:'
         WRITE( LOGDEV, '(5x,A)'   ),'=================================='
         WRITE( LOGDEV,'(7x,A,/,13x,A)' ),'Note: these are populated using rules from the',
     &                              'Emission Control File Supplied by the User.'
         DO ISRM = 1,N_EM_SRM
           
           ! Print summary information about each Sector including
           ! the label and the available aerosol modes
           WRITE( LOGDEV, '(/,5x,A,A)'   ),'>',REPEAT('-',80 )
           WRITE( LOGDEV,'(5x,A,A,A,A,A2,I2.2,A1)' ),
     &            'Stream Type: "',TRIM(EM_FILE_DESC( ISRM )),
     &            '" | Sector Label: ',TRIM(EM_FILE_LAB( ISRM ) ),' (',ISRM,')'

           WRITE( LOGDEV, '(/8x,A)' ),'Table of Aerosol Size Distributions Available for Use Sector-Wide.'
           WRITE( LOGDEV, '(8x,A)' ),'Note that Mode 1 is reserved for gas-phase species and surrogates.'
           WRITE( LOGDEV, '(10x,A,2x,A,2x,A)' ), 'Number','Surrogate Mode','Reference Mode (see AERO_DATA.F)'
           WRITE( LOGDEV, '(10x,A,2x,A,2x,A)' ), '------','--------------','--------------------------------'
           DO ISD = 2,EM_STREAM_SIZE( ISRM )%LEN
              IEM = EM_STREAM_SIZE( ISRM )%REF( ISD )
              REFNAME = ''
              IF ( IEM .GT. 0 ) THEN
                  REFNAME = EM_AERO_REF( IEM )%NAME
              END IF

              WRITE( LOGDEV,'(8x,I3,5x,A18,2x,A18,2x,A)' ),ISD, 
     &               EM_STREAM_SIZE( ISRM )%NAME( ISD )( 1:16 ), TRIM( REFNAME )
           END DO


           ! Finally Print Every Instruction for this Stream
           WRITE( LOGDEV, '(/,8x,A,5x,A,2x,A,9x,A,13x,A,1x,A,1x,A,1x,A)' ),
     &            'CMAQ Species','Phase/Mode','Surrogate','Region','Op','ScaleFac','Basis','FinalFac'
           WRITE( LOGDEV, '(8x,A,5x,A,2x,A,9x,A,13x,A,1x,A,1x,A,1x,A)' ),
     &            '------------','----------','---------','------','--','--------','-----','--------'

           DO IDIFF = 1,N_SPC_DIFF
             L_WDIFF = .TRUE.
             DO ISD = 1,EM_STREAM_SIZE( ISRM )%LEN
               L_WISD = .TRUE.
               DO ISTR = 1,N_EMIS_ISTR
             !    DO ISUR = 1,EM_FILE_SURR( ISRM )%LEN
                   IF ( EM_SPEC( ISTR ) .EQ. DIFF_SPC( IDIFF ) .AND.
     &                  MAP_EMtoSD( ISTR,ISRM ) .EQ. ISD     ) THEN !  .AND.
   !  &                  MAP_EMtoSURR( ISTR,ISRM ) .EQ. ISUR ) THEN
                     IF ( L_WDIFF ) THEN
                        WRITE( LOGDEV, '(10x,A,1x,A,1x,A,1x,A,1x,A,2x,F6.3,4x,A,2x,F6.3)' ),
     &                         EM_SPEC( ISTR ),
     &                         EM_STREAM_SIZE( ISRM )%NAME( ISD )(1:10),
     &                         EM_SURR( ISTR, ISRM ),
     &                         EM_REGIONS( EM_FAC_ST( ISTR,ISRM )%REG( 1 ) )%LABEL(1:18),
     &                         EM_OP( ISTR,ISRM,1 ), 
     &                         EM_FAC_ST( ISTR, ISRM )%BULK( 1 ), EM_BASIS( ISTR,ISRM,1 ),
     &                         EM_FAC_ST( ISTR,ISRM )%FAC( 1 ) 
     &                         
                        L_WDIFF = .FALSE.
                        L_WISD  = .FALSE.
                      ELSE IF ( L_WISD ) THEN
                        WRITE( LOGDEV, '(27x,A,1x,A,1x,A,1x,A,2x,F6.3,4x,A,2x,F6.3)' ),
     &                         EM_STREAM_SIZE( ISRM )%NAME( ISD )(1:10),
     &                         EM_SURR( ISTR, ISRM ),
     &                         EM_REGIONS( EM_FAC_ST( ISTR,ISRM )%REG( 1 ) )%LABEL(1:18),
     &                         EM_OP( ISTR,ISRM,1 ),
     &                         EM_FAC_ST( ISTR, ISRM )%BULK( 1 ), EM_BASIS( ISTR,ISRM,1 ),
     &                         EM_FAC_ST( ISTR,ISRM )%FAC( 1 )
                        L_WISD = .FALSE.
                      ELSE
                        WRITE( LOGDEV, '(38x,A,1x,A,1x,A,2x,F6.3,4x,A,2x,F6.3)' ),
     &                         EM_SURR( ISTR, ISRM ),
     &                         EM_REGIONS( EM_FAC_ST( ISTR,ISRM )%REG( 1 ) )%LABEL(1:18),
     &                         EM_OP( ISTR,ISRM,1 ), 
     &                         EM_FAC_ST( ISTR, ISRM )%BULK( 1 ), EM_BASIS( ISTR,ISRM,1 ),
     &                         EM_FAC_ST( ISTR,ISRM )%FAC( 1 ) 
                      END IF    

                      IF ( EM_FAC_ST( ISTR,ISRM )%LEN .GT. 1 ) THEN
                      DO IFAC = 2,EM_FAC_ST( ISTR,ISRM )%LEN
                         WRITE( LOGDEV, '(55x,A,1x,A,2x,F6.3,4x,A,2x,F6.3)' ),
     &                          EM_REGIONS( EM_FAC_ST( ISTR,ISRM )%REG( IFAC ) )%LABEL(1:18),
     &                          EM_OP( ISTR,ISRM,IFAC ),
     &                          EM_FAC_ST( ISTR, ISRM )%BULK( IFAC ), EM_BASIS( ISTR,ISRM,IFAC ),
     &                          EM_FAC_ST( ISTR,ISRM )%FAC( IFAC )
                      END DO
                      END IF

                   END IF
                 !END DO
               END DO
             END DO
           END DO
         END DO

         ! End Emissions Scaling Preparation and Diagnostic Output
         WRITE( LOGDEV, '(/,5x,A)' ), REPEAT( '=',80 )
         WRITE( LOGDEV, '(5x,A,/,/)' ),
     &          '|> END EMISSIONS SCALING PREPARATION AND DIAGNOSTIC OUTPUT'

      END SUBROUTINE EMIS_SPC_MAP

!-----------------------------------------------------------------------
         SUBROUTINE CHECK_EMIS_UNITS( ISRM, ISUR, SPEC, UNITS, CONV, BASIS )

! This subroutine checks for invalid values of the operation parameter 
! in the rules from the emission control list

         IMPLICIT NONE

         REAL, INTENT( OUT )              :: CONV
         CHARACTER( 4 ) , INTENT( OUT )   :: BASIS
         CHARACTER( 16 ), INTENT( INOUT ) :: UNITS
         INTEGER, INTENT( IN )            :: ISRM
         INTEGER, INTENT( IN )            :: ISUR
         CHARACTER( 16 ), INTENT( IN )    :: SPEC
         CHARACTER( 200 )      :: XMSG
         INTEGER               :: X, SLASH_IND

         CONV = 1.0

         CALL UPCASE( UNITS )

         ! Find Break between numerator and denominator. If it's not a
         ! slash, then it should be the first space
         SLASH_IND = INDEX( UNITS, '/' )
         IF ( SLASH_IND .EQ. 0 ) SLASH_IND = INDEX( UNITS, ' ' )
         X = SLASH_IND - 1

         ! Check for Molar or Mass Units
         IF ( UNITS(1:X) .EQ. 'MOLE' .OR. UNITS(1:X) .EQ. 'MOLES' .OR.
     &        UNITS(1:X) .EQ. 'MOL' ) THEN
            ! No Conversion Needed for Moles to Moles
            CONV = 1.0 
            BASIS = 'MOLE'
         ELSE IF ( UNITS(1:X) .EQ. 'KMOLE' .OR. UNITS(1:X) .EQ. 'KMOLES' .OR.
     &             UNITS(1:X) .EQ. 'KMOL' ) THEN
            ! Convert kmol to mol
            CONV = 1000.0
            BASIS = 'MOLE'
         ELSE IF ( UNITS(1:X) .EQ. 'MMOLE' .OR. UNITS(1:X) .EQ. 'MMOLES' .OR.
     &             UNITS(1:X) .EQ. 'MMOL' ) THEN
            ! Convert mmol to mol
            CONV = 1.0e-3
            BASIS = 'MOLE'
         ELSE IF ( UNITS(1:X) .EQ. 'UMOLE' .OR. UNITS(1:X) .EQ. 'UMOLES' .OR.
     &             UNITS(1:X) .EQ. 'UMOL' ) THEN
            ! Convert umol to mol
            CONV = 1.0e-6
            BASIS = 'MOLE'
         ELSE IF ( UNITS(1:X) .EQ. 'GRAM' .OR. UNITS(1:X) .EQ. 'GRAMS' .OR.
     &             UNITS(1:X) .EQ. 'G'    .OR. UNITS(1:X) .EQ. 'GM'    .OR.
     &             UNITS(1:X) .EQ. 'GMS'  .OR. UNITS(1:X) .EQ. 'GS'  ) THEN
            ! No Conversion Needed for Grams to Grams
            CONV = 1.0
            BASIS = 'MASS'
         ELSE IF ( UNITS(1:X) .EQ. 'KGRAM' .OR. UNITS(1:X) .EQ. 'KGRAMS' .OR.
     &             UNITS(1:X) .EQ. 'KG'    .OR. UNITS(1:X) .EQ. 'KGM'    .OR.
     &             UNITS(1:X) .EQ. 'KGMS'  .OR. UNITS(1:X) .EQ. 'KGS' ) THEN
            ! Convert kg -> g
            CONV = 1000.0
            BASIS = 'MASS'
         ELSE IF ( UNITS(1:X) .EQ. 'MGRAM' .OR. UNITS(1:X) .EQ. 'MGRAMS' .OR.
     &             UNITS(1:X) .EQ. 'MG'    .OR. UNITS(1:X) .EQ. 'MGM'    .OR.
     &             UNITS(1:X) .EQ. 'MGMS'  .OR. UNITS(1:X) .EQ. 'MGS' ) THEN
            ! Convert mg -> g
            CONV = 1.0e-3
            BASIS = 'MASS'
         ELSE IF ( UNITS(1:X) .EQ. 'UGRAM' .OR. UNITS(1:X) .EQ. 'UGRAMS' .OR.
     &             UNITS(1:X) .EQ. 'UG'    .OR. UNITS(1:X) .EQ. 'UGM'    .OR.
     &             UNITS(1:X) .EQ. 'UGMS'  .OR. UNITS(1:X) .EQ. 'UGS' ) THEN
            ! Convert ug -> g
            CONV = 1.0e-6
            BASIS = 'MASS'
         ELSE IF ( UNITS(1:X) .EQ. 'NGRAM' .OR. UNITS(1:X) .EQ. 'NGRAMS' .OR.
     &             UNITS(1:X) .EQ. 'NG'    .OR. UNITS(1:X) .EQ. 'NGM'    .OR.
     &             UNITS(1:X) .EQ. 'NGMS'  .OR. UNITS(1:X) .EQ. 'NGS' ) THEN
            ! Convert ng -> g
            CONV = 1.0e-9
            BASIS = 'MASS'
         ELSE
            WRITE( XMSG,'(A,A16,A,/,I3,A11,A16,A,/,A)' ),
     &              'ERROR: Surrogate Species ',TRIM(SPEC),' on emission stream ',
     &              ISRM, ' has units ',TRIM(UNITS),' which are unkown to CMAQ. ',
     &              'Please correct them to proceed.'
            CALL M3EXIT( 'CHECK_EMIS_UNITS', 0, 0, XMSG, 2 )
         END IF
          
         ! Check for Time Units
         X = X + 2
         IF ( UNITS(X:) .EQ. 'S' .OR. UNITS(X:) .EQ. 'S-1' .OR.
     &        UNITS(X:) .EQ. 'SEC'.OR.UNITS(X:) .EQ. 'SEC-1' .OR.
     &        UNITS(X:) .EQ. 'SECOND'.OR.UNITS(X:) .EQ. 'SECOND-1' .OR.
     &        UNITS(X:) .EQ. 'SECONDS'.OR.UNITS(X:) .EQ. 'SECONDS-1' ) THEN
            ! No Conversion Necessary for seconds -> seconds
            CONV = CONV * 1.0
         ELSE IF ( UNITS(X:) .EQ. 'H' .OR. UNITS(X:) .EQ. 'H-1' .OR.
     &             UNITS(X:) .EQ. 'HR'.OR.UNITS(X:) .EQ. 'HR-1' .OR.
     &             UNITS(X:) .EQ. 'HOUR'.OR.UNITS(X:) .EQ. 'HOUR-1' .OR.
     &             UNITS(X:) .EQ. 'HOURS'.OR.UNITS(X:) .EQ. 'HOURS-1' ) THEN
            ! Convert hours -> seconds
            CONV = CONV * 3600.0
         ELSE IF ( UNITS(X:) .EQ. 'M' .OR. UNITS(X:) .EQ. 'M-1' .OR.
     &             UNITS(X:) .EQ. 'MIN'.OR.UNITS(X:) .EQ. 'MIN-1' .OR.
     &             UNITS(X:) .EQ. 'MINUTE'.OR.UNITS(X:) .EQ. 'MINUTE-1' .OR.
     &             UNITS(X:) .EQ. 'MINUTES'.OR.UNITS(X:) .EQ. 'MINUTES-1' ) THEN
            ! Convert hours -> seconds
            CONV = CONV * 60.0
         ELSE
            WRITE( XMSG,'(A,A,A,I3,A11,A,A,A)' ),
     &              'ERROR: Surrogate Species ',TRIM(SPEC),' on emission stream ',
     &              ISRM, ' has units ',TRIM(UNITS),' which are unkown to CMAQ. ',
     &              'Please correct them to proceed.'
            CALL M3EXIT( 'CHECK_EMIS_UNITS', 0, 0, XMSG, 2 )
         END IF

         END SUBROUTINE CHECK_EMIS_UNITS
 
!-----------------------------------------------------------------------
         SUBROUTINE CHECK_OP( OP, IRULE )

! This subroutine checks for invalid values of the operation parameter 
! in the rules from the emission control list

         IMPLICIT NONE

         CHARACTER( 1 )        :: OP
         INTEGER, INTENT( IN ) :: IRULE
         CHARACTER( 200 )      :: XMSG

         IF ( OP .EQ. 'A' .OR. OP .EQ. 'a' ) THEN
             OP = 'a'
         ELSE IF ( OP .EQ. 'M' .OR. OP .EQ. 'm' ) THEN
             OP = 'm'
         ELSE IF ( OP .EQ. 'O' .OR. OP .EQ. 'o' ) THEN
             OP = 'o'
         ELSE
             WRITE( XMSG,'(A,I3,A,A1)' ),
     &              'ERROR: OP parameter for rule ',IRULE,
     &              ' has invalid value: ',OP
             CALL M3EXIT( 'CHECK_OP (EMIS_DEFN)', 0, 0, XMSG, 2 )
         END IF

         END SUBROUTINE CHECK_OP

!-----------------------------------------------------------------------
         SUBROUTINE CHECK_BASIS( BASIS, IRULE )

! This subroutine checks for invalid values of the operation parameter 
! in the rules from the emission control list

         IMPLICIT NONE

         CHARACTER( 4 )        :: BASIS
         INTEGER, INTENT( IN ) :: IRULE
         CHARACTER( 200 )      :: XMSG

         IF ( BASIS .EQ. 'mole' .OR. BASIS .EQ. 'MOLE' .OR.
     &        BASIS .EQ. 'Mole' ) THEN
             BASIS = 'MOLE'
         ELSE IF ( BASIS .EQ. 'mass' .OR. BASIS .EQ. 'MASS' .OR.
     &             BASIS .EQ. 'Mass' ) THEN
             BASIS = 'MASS'
         ELSE IF ( BASIS .EQ. 'unit' .OR. BASIS .EQ. 'UNIT' .OR.
     &             BASIS .EQ. 'Unit' ) THEN
             BASIS = 'UNIT'
         ELSE
             WRITE( XMSG,'(A,I3,A,A4)' ),
     &              'ERROR: BASIS parameter for rule ',IRULE,
     &              ' has invalid value: ',BASIS
             CALL M3EXIT( 'CHECK_BASIS (EMIS_DEFN)', 0, 0, XMSG, 2 )
         END IF

         END SUBROUTINE CHECK_BASIS

!-----------------------------------------------------------------------
         SUBROUTINE EM_FILE_INIT( JDATE, JTIME )

! Initialize the counter for the total nbumber of emissions files. Also
! allocate memory for the vectors storing the labels of emission files
! and the maps from master ID number to the relative ID number for each
! gridded and point stream file, i.e. Emissions File 10 is also known as
! Point Source file 2.
!
         USE AERO_DATA, only : MGPG, GPKG
         USE UTILIO_DEFN         ! I/O API
         USE RXNS_DATA, ONLY: MECHNAME
         USE RUNTIME_VARS, only : LOGDEV

         IMPLICIT NONE

         INTEGER, INTENT(IN)  :: JDATE, JTIME

         INTEGER ISRM, N

         CHARACTER( 16 )  :: PNAME = 'EM_FILE_INIT'
         CHARACTER( 32 )  :: VLAB
         CHARACTER( 16 )  :: VNAME
         INTEGER          :: STATUS
         CHARACTER( 200 ) :: XMSG
         LOGICAL :: SUCCESS
         CHARACTER( 200 ) :: EM_DIAG_PREFIX = 'CCTM_EMDIAG_'
         CHARACTER( 200 ) :: EM_DIAG_SUFFIX = ''
         LOGICAL        :: VALUE

         SUCCESS = .TRUE.

         ! Initialize Regions for Mapping Scale Factors Geographically for Base
         ! Model (eventually apply this to DDM-3D and ISAM)
!        CALL READ_EMISS_NAMELIST( )
!        CALL INIT_EMIS_REGIONS( )
    
       ! Calculate the total number of Emission Streams based on the
       ! user options
         ! Add the number of total Emission Streams 
         N_EM_SRM = N_FILE_GR + NPTGRPS + N_FILE_TR

         ! Online Biogenic Emissions
         IF ( BIOGEMIS ) N_EM_SRM = N_EM_SRM + 1

         ! Marine gas emissions; use online marine gas option only if CB6R3m is used
         IF ( USE_MARINE_GAS_EMISSION ) N_EM_SRM = N_EM_SRM + 1

         ! Lightning NO Emissions
         IF ( LTNG_NO ) N_EM_SRM = N_EM_SRM + 1
 
         ! Sea Spray Aerosol 
         IF ( OCEAN_CHEM ) N_EM_SRM = N_EM_SRM + 1

         ! Determine if WindBlown Dust is Requested
         IF ( WB_DUST ) N_EM_SRM = N_EM_SRM + 1

         ! Turn Back Now if N_EM_SRM Equals Zero (i.e. there are no emissions
         IF ( N_EM_SRM .EQ. 0 ) RETURN

       ! Allocate Emission File Structure Variables
         Allocate( EM_FILE_NAME  ( N_EM_SRM ) )
         Allocate( EM_FILE_LAB   ( N_EM_SRM+1 ) )
         Allocate( EM_FILE_TYPE  ( N_EM_SRM ) )
         Allocate( EM_FILE_ITYPE ( N_EM_SRM ) )
         Allocate( EM_FILE_DESC  ( N_EM_SRM ) )
         Allocate( EM_FILE_LAPPLY( N_EM_SRM ) )
         Allocate( EM_FILE_LDIAG ( N_EM_SRM+1 ) )
         Allocate( EM_DIAG_FILE  ( N_EM_SRM+1 ) )
         Allocate( EM_FILE_DATE  ( N_EM_SRM ) )
         Allocate( EM_FILE_SYM_DATE ( N_EM_SRM ) ) 
         Allocate( EM_FILE_FIRE  ( N_EM_SRM ) )
         Allocate( IGSRM         ( N_EM_SRM ) )
         Allocate( IPSRM         ( N_EM_SRM ) )
         Allocate( ITSRM         ( N_EM_SRM ) )
         Allocate( MAP_PTtoISRM  ( NPTGRPS ) )
         Allocate( EM_FILE_SURR  ( N_EM_SRM ) )
         Allocate( EM_GRID_LAYS  ( N_EM_SRM ) )
 
C Assign Attributes to Emission File Records. Other records will be 
C populated in individual subroutines. For example, opemis and
C stkemis_init.
         ISRM = 0
         EM_FILE_LAPPLY = .TRUE.
         EM_FILE_DATE   = JDATE
         EM_FILE_SYM_DATE = EMIS_SYM_DATE ! representative day files (default: false)
         EM_FILE_FIRE   = .FALSE.
         EM_GRID_LAYS   = 0
         
         EMISDIAG = RESOLVE_YN_TF_2D3D( EMISDIAG )
         EM_FILE_LDIAG   = EMISDIAG 

         ! Set the standard suffix for all Emissions Diagnostic Files
         IF ( OUTDIR(1:8 ) .NE. 'OUTDIR' ) EM_DIAG_PREFIX = TRIM( OUTDIR ) // '/' // EM_DIAG_PREFIX
         
         EM_DIAG_SUFFIX = '.nc'
         IF ( APPL_NAME(1:8 ) .NE. 'CTM_APPL' ) EM_DIAG_SUFFIX = '_' // TRIM(APPL_NAME) // '.nc'
 
         ! Set Diagnostic Type and Name for Total Emissions Diagnostic File
         CALL GET_ENV( EM_FILE_LDIAG(N_EM_SRM+1), "EMISDIAG_SUM", EMISDIAG, LOGDEV )
         EM_FILE_LDIAG( N_EM_SRM + 1 ) = RESOLVE_YN_TF_2D3D(EM_FILE_LDIAG(N_EM_SRM+1) )  
         EM_DIAG_FILE( N_EM_SRM+1 ) = 'SUM_EMDGFILE'
         VALUE = SETENVVAR( EM_DIAG_FILE( N_EM_SRM+1 ), TRIM( EM_DIAG_PREFIX ) // 
     &           'SUM' // TRIM( EM_DIAG_SUFFIX ) )  
         EM_FILE_LAB( N_EM_SRM+1 ) = 'TOTAL'

         ! Gridded Emission Files
         IF ( N_FILE_GR .GT. 0 ) THEN
           EM_FILE_TYPE( ISRM+1:ISRM+N_FILE_GR ) = 'GRID'
           EM_FILE_ITYPE( ISRM+1:ISRM+N_FILE_GR ) = 1
           DO N = 1, N_FILE_GR
              ISRM = ISRM + 1
              IGSRM( ISRM ) = N

              ! Create Description of this Emission File for output to
              ! diagnostics
              WRITE( EM_FILE_DESC( ISRM ), '(A,I3)' ),
     &           'Gridded Area Emissions File ', N
             
              ! Retrieve Short-Name Label for Each Gridded File
              WRITE( VLAB,'( "GR_EMIS_LAB_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_LAB( ISRM ), VLAB,
     &                      EM_FILE_LAB( ISRM ), LOGDEV )
              CALL UPCASE( EM_FILE_LAB( ISRM ) )

              ! Each Gridded File Name is stored already in IO-API as
              ! an object of the form GR_EMIS_XXX
              WRITE( EM_FILE_NAME( ISRM ),'( "GR_EMIS_",I3.3 )' ) N

              ! Retrieve Toggle for whether or not to apply these
              ! emissions 
              WRITE( VLAB,'( "GR_EMIS_APPLY_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_LAPPLY( ISRM ), VLAB, 
     &                      EM_FILE_LAPPLY( ISRM ), LOGDEV )
 
              ! Retrieve Toggle for overriding emissions file date with
              ! internal model date
              WRITE( VLAB,'( "GR_EM_SYM_DATE_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_SYM_DATE( ISRM ), VLAB, 
     &                      EMIS_SYM_DATE, LOGDEV )
 
              ! Retrieve Toggle for Outputing Gridded Emissions
              ! Diagnostic File
              WRITE( VLAB,'( "GR_EMIS_DIAG_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_LDIAG( ISRM ), VLAB, EMISDIAG, LOGDEV )
              EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
              WRITE( EM_DIAG_FILE( ISRM ),'( "GR_EMDGFILE_",I3.3 )' ) N
              VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &            TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) ) 

           END DO
         END IF
         
         ! In-Line Point Source Files
         IF ( NPTGRPS .GT. 0 ) THEN 
           EM_FILE_TYPE( ISRM+1:ISRM+NPTGRPS ) = 'POINT'
           EM_FILE_ITYPE( ISRM+1:ISRM+NPTGRPS ) = 2
           DO N = 1, NPTGRPS
              ISRM = ISRM + 1
              IPSRM( ISRM ) = N
              MAP_PTtoISRM( N ) = ISRM
              
              ! Create Description of this Emission File for output to
              ! diagnostics
              WRITE( EM_FILE_DESC( ISRM ), '(A,I3)' ),
     &        'Point Emissions File ', IPSRM( ISRM )
             
              ! Retrieve Short-Name Label for Each Inline File
              WRITE( VLAB,'( "STK_EMIS_LAB_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_LAB( ISRM ), VLAB, 
     &                      EM_FILE_LAB( ISRM ), LOGDEV )
              CALL UPCASE( EM_FILE_LAB( ISRM ) )
 
              ! Each Inline File Name is stored already in IO-API as
              ! an object of the form STK_EMIS_XXX
              WRITE( EM_FILE_NAME( ISRM ),'( "STK_EMIS_",I3.3 )' ) N
              
              ! Retrieve Toggle for whether or not to apply these
              ! emissions 
              WRITE( VLAB,'( "STK_EMIS_APPLY_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_LAPPLY( ISRM ), VLAB, 
     &                      EM_FILE_LAPPLY( ISRM ), LOGDEV )
 
              ! Retrieve Toggle for overriding emissions file date with
              ! internal model date
              WRITE( VLAB,'( "STK_EM_SYM_DATE_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_SYM_DATE( ISRM ), VLAB, 
     &                      EMIS_SYM_DATE, LOGDEV )
 
              ! Retrieve Toggle for Outputing Inline Emissions
              ! Diagnostic File
              WRITE( VLAB,'( "STK_EMIS_DIAG_",I3.3 )' ) N
              CALL GET_ENV( EM_FILE_LDIAG( ISRM ), VLAB, EMISDIAG, LOGDEV )
              EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
              WRITE( EM_DIAG_FILE( ISRM ),'( "STK_EMDGFILE_",I3.3 )' ) N
              VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &            TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

           END DO
         END IF
         
         ! Tracer Emissions
         IF ( N_FILE_TR .GT. 0 ) THEN 
           EM_TRAC = .TRUE.
           EM_FILE_TYPE( ISRM+1:ISRM+N_FILE_TR ) = 'TRAC'
           EM_FILE_ITYPE( ISRM+1:ISRM+N_FILE_TR ) = 3
           DO N = 1, N_FILE_TR
              ISRM = ISRM + 1
              ITSRM( ISRM ) = N

              ! Create Description of this Emission File for output to
              ! diagnostics
              WRITE( EM_FILE_DESC( ISRM ), '(A,I2)' ),
     &          'Gridded Tracer Emissions File ', N

              ! Retrieve Short-Name Label for Each Tracer File
              WRITE( VLAB,'( "TR_EMIS_LAB_",I2.2 )' ) N
              CALL GET_ENV( EM_FILE_LAB( ISRM ), VLAB,
     &                      EM_FILE_LAB( ISRM ), LOGDEV )
              CALL UPCASE( EM_FILE_LAB( ISRM ) )

              ! Each Tracer File Name is stored already in IO-API as
              ! an object of the form TR_EMIS_XXX
              WRITE( EM_FILE_NAME( ISRM ),'( "TR_EMIS_",I2.2 )' ) N

              ! Retrieve Toggle for Outputing Tracer Emissions
              ! Diagnostic File
              WRITE( VLAB,'( "TR_EMIS_DIAG_",I2.2 )' ) N
              CALL GET_ENV( EM_FILE_LDIAG( ISRM ), VLAB, EMISDIAG, LOGDEV )
              EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
              WRITE( EM_DIAG_FILE( ISRM ),'( "TR_EMDGFILE_",I2.2 )' ) N
              VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &            TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

           END DO
         ELSE
           EM_TRAC = .FALSE.
         END IF
         
         ! Online Biogenic Emissions (BEIS)
         IF ( BIOGEMIS ) THEN
             ISRM = ISRM + 1
             EM_FILE_TYPE( ISRM ) = 'BIOG'
             EM_FILE_ITYPE( ISRM ) = 4
             EM_FILE_LAB ( ISRM ) = 'BIOG'
             EM_FILE_DESC( ISRM ) = 'Biogenic Emissions'

             ! Retrieve Toggle for Outputing Biogenic Emissions
             ! Diagnostic File
             CALL GET_ENV( EM_FILE_LDIAG( ISRM ), "BIOG_EMIS_DIAG", EMISDIAG, LOGDEV )
             EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
             EM_DIAG_FILE( ISRM ) = "BIOG_EMDGFILE"
             VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &           TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

             IBIOSRM = ISRM
         END IF

         ! Online Marine Gas Emissions
         IF ( USE_MARINE_GAS_EMISSION ) THEN
             ISRM = ISRM + 1
             EM_FILE_TYPE( ISRM ) = 'MGEM'
             EM_FILE_ITYPE( ISRM ) = 5
             EM_FILE_LAB ( ISRM ) = 'MGEM'
             EM_FILE_DESC( ISRM ) = 'Marine Gas Emissions'

             ! Retrieve Toggle for Outputing Marine Gas Emissions
             ! Diagnostic File
             CALL GET_ENV( EM_FILE_LDIAG( ISRM ), "MG_EMIS_DIAG", EMISDIAG, LOGDEV )
             EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
             EM_DIAG_FILE( ISRM ) = "MG_EMDGFILE"
             VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &           TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

             IMGSRM = ISRM
         END IF

         ! Online Lightning NO Emissions
         IF ( LTNG_NO ) THEN
             ISRM = ISRM + 1
             EM_FILE_TYPE( ISRM ) = 'LTNG'
             EM_FILE_ITYPE( ISRM ) = 6
             EM_FILE_LAB ( ISRM ) = 'LTNG'
             EM_FILE_DESC( ISRM ) = 'Lightning NO Emissions'

             ! Retrieve Toggle for Outputing Lightning NO Emissions
             ! Diagnostic File
             CALL GET_ENV( EM_FILE_LDIAG( ISRM ), "LTNG_EMIS_DIAG", EMISDIAG, LOGDEV )
             EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
             EM_DIAG_FILE( ISRM ) = "LTNG_EMDGFILE"
             VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &           TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

             ILTSRM = ISRM
         END IF

         ! Sea Spray Aerosol Emissions
         IF ( OCEAN_CHEM ) THEN
             ISRM = ISRM + 1
             EM_FILE_TYPE( ISRM ) = 'ASEA'
             EM_FILE_ITYPE( ISRM ) = 7
             EM_FILE_LAB ( ISRM ) = 'SEASPRAY'
             EM_FILE_DESC( ISRM ) = 'Sea Spray Aerosol Emissions'
             
             ! Retrieve Toggle for Outputing Sea Spray Aerosol Emissions
             ! Diagnostic File
             CALL GET_ ENV( EM_FILE_LDIAG( ISRM ), "SEASPRAY_EMIS_DIAG", EMISDIAG, LOGDEV )
             EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
             EM_DIAG_FILE( ISRM ) = "ASEA_EMDGFILE"
             VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &           TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

             ISEASRM = ISRM
         END IF

         ! Wind-Blown Dust Emissions
         IF ( WB_DUST ) THEN
             ISRM = ISRM + 1
             EM_FILE_TYPE( ISRM ) = 'DUST'
             EM_FILE_ITYPE( ISRM ) = 8
             EM_FILE_LAB ( ISRM ) = 'WBDUST'
             EM_FILE_DESC( ISRM ) = 'Wind-Blown Dust Emissions'
             
             ! Retrieve Toggle for Outputing Wind-Blown Dust Emissions
             ! Diagnostic File
             CALL GET_ENV( EM_FILE_LDIAG( ISRM ), "DUST_EMIS_DIAG", EMISDIAG, LOGDEV )
             EM_FILE_LDIAG( ISRM ) = RESOLVE_YN_TF_2D3D( EM_FILE_LDIAG( ISRM ) )
             EM_DIAG_FILE( ISRM ) = "DUST_EMDGFILE"
             VALUE = SETENVVAR( EM_DIAG_FILE( ISRM ), TRIM( EM_DIAG_PREFIX ) // 
     &           TRIM( EM_FILE_LAB( ISRM ) ) // TRIM( EM_DIAG_SUFFIX ) )

             IDUSTSRM = ISRM
         END IF
          
      END SUBROUTINE EM_FILE_INIT    


!-----------------------------------------------------------------------
      FUNCTION RESOLVE_YN_TF_2D3D( ARG ) RESULT( ARGOUT )

!-----------------------------------------------------------------------
        IMPLICIT NONE

        CHARACTER( 6 ) :: ARG, ARGOUT
 
         IF ( ARG .EQ. 'FALSE' .OR. ARG .EQ. 'F' .OR.
     &        ARG .EQ. 'NO'    .OR. ARG .EQ. 'N' ) THEN
            ARGOUT = 'FALSE'
         ELSEIF ( ARG .EQ. 'TRUE' .OR. ARG .EQ. 'T' .OR.
     &            ARG .EQ. 'YES'  .OR. ARG .EQ. 'Y' ) THEN
            ARGOUT = 'TRUE'
         ELSEIF ( ARG .EQ. '2D'  .OR. ARG .EQ. '2d' ) THEN
            ARGOUT = 'TRUE'
         ELSEIF   ( ARG .EQ. '3D'  .OR. ARG .EQ. '3d' ) THEN
            ARGOUT = '3D'
         ELSEIF   ( ARG .EQ. '2DSUM' .OR. ARG .EQ. '2dSUM' .OR.
     &              ARG .EQ. '2dsum' ) THEN
            ARGOUT = '2DSUM'
         END IF
 
         RETURN

      END FUNCTION RESOLVE_YN_TF_2D3D

!-----------------------------------------------------------------------
      SUBROUTINE OPEN_EMISS_DIAG( JDATE, JTIME, TSTEP )
!       This subroutine opens diagnostic files for printing the
!       emission rates input to CMAQ after scaling by user emission
!       rules. The rates are put on files dedicated to each individual
!       emissions stream. This adds user flexibility in being able to
!       toggle the diagnostic output for streams individually and
!       reduces the storage space needed for most use cases (presumably
!       users will rarely want to output the data from all of the
!       emissions streams).
!-----------------------------------------------------------------------
      USE UTILIO_DEFN
      USE GRID_CONF
      USE VDIFF_MAP, ONLY : N_SPC_DIFF, DIFF_SPC, DIFF_MASK_GAS, DIFF_MASK_NR,
     &                      DIFF_MASK_AERO, DIFF_MASK_NUM, DIFF_MASK_SRF

      IMPLICIT NONE

      INTEGER, INTENT( IN ) :: JDATE, JTIME, TSTEP

      CHARACTER( 16 ) :: PNAME = 'OPEN_EMISS_DIAG'
      CHARACTER( 200 ) :: XMSG

      INTEGER :: ISRM, IVAR, NLAYERS, V
      CHARACTER( 2 ) :: CSRM
      
      DO ISRM = 1,N_EM_SRM+1
      
        ! Test whether or not each file should be opened
        IF ( EM_FILE_LDIAG( ISRM ) .NE. 'FALSE' ) THEN
 
          ! Make File 2D by Default, but 3D if the user requests it
          NLAYERS = 1
          IF ( EM_FILE_LDIAG( ISRM ) .EQ. '3D' ) NLAYERS = EMLAYS

          ! Set output file characteristics based on COORD.EXT and 
          ! open diagnostic file
          FTYPE3D = GRDDED3
          SDATE3D = JDATE
          STIME3D = JTIME
          TSTEP3D = TSTEP
          CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D ) !  start the next hour

          NVARS3D = 0
          DO IVAR = 1,N_SPC_DIFF
              IF ( ISRM .EQ. N_EM_SRM+1 ) THEN
                IF ( ANY(EM_FILE_DIFF( IVAR,: )) ) NVARS3D = NVARS3D + 1
              ELSE
                IF ( EM_FILE_DIFF( IVAR,ISRM ) ) NVARS3D = NVARS3D + 1
              END IF
          END DO
          NCOLS3D = GL_NCOLS
          NROWS3D = GL_NROWS
          NLAYS3D = NLAYERS
          NTHIK3D = 1
          GDTYP3D = GDTYP_GD
          P_ALP3D = P_ALP_GD
          P_BET3D = P_BET_GD
          P_GAM3D = P_GAM_GD
          XORIG3D = XORIG_GD
          YORIG3D = YORIG_GD
          XCENT3D = XCENT_GD
          YCENT3D = YCENT_GD
          XCELL3D = XCELL_GD
          YCELL3D = YCELL_GD
          VGTYP3D = VGTYP_GD
          VGTOP3D = VGTOP_GD
          VGLVS3D( 1:NLAYS3D+1 ) = VGLVS_GD( 1:NLAYS3D+1 )
          GDNAM3D = GRID_NAME  ! from HGRD_DEFN

          V = 0
          DO IVAR = 1,N_SPC_DIFF
              IF ( ISRM .EQ. N_EM_SRM+1 ) THEN
                IF ( .NOT. ANY(EM_FILE_DIFF( IVAR,: )) ) CYCLE
              ELSE
                IF ( .NOT. EM_FILE_DIFF( IVAR,ISRM ) ) CYCLE
              END IF
             V = V + 1

             VTYPE3D( V ) = M3REAL
             VNAME3D( V ) = DIFF_SPC( IVAR )
             IF ( DIFF_MASK_GAS( IVAR ) ) THEN
                    ! GAS SPECIES
                    UNITS3D( V ) = 'mol s-1'
             ELSE IF ( DIFF_MASK_NR( IVAR ) ) THEN
                    ! NR SPECIES
                    UNITS3D( V ) = 'mol s-1'
             ELSE IF ( DIFF_MASK_NUM( IVAR ) ) THEN
                    ! AEROSOL NUMBER SPECIES
                    UNITS3D( V ) = 'particles s-1'
             ELSE IF ( DIFF_MASK_SRF( IVAR ) ) THEN
                    ! AEROSOL SURFACE AREA SPECIES
                    UNITS3D( V ) = 'm2 s-1'
             ELSE
                    ! AEROSOL MASS SPECIES
                    UNITS3D( V ) = 'g s-1'
             END IF
            
             VDESC3D( V ) = 'Emission Rate of ' // TRIM( VNAME3D( V ) )
     &                       // ' from ' // TRIM(EM_FILE_LAB( ISRM )) // ' emissions'
          END DO
          
          WRITE( CSRM, '(I2.2)' ), ISRM
          FDESC3D( 1 ) = 'Instantaneous pollutant emissions from stream ' //
     &               TRIM( CSRM ) // ': ' // TRIM(EM_FILE_LAB( ISRM ) ) 
          FDESC3D( 2:MXDESC3 ) = ''

          ! Open emissions stream diagnostic file
          IF ( .NOT. OPEN3( EM_DIAG_FILE( ISRM ), FSNEW3, PNAME ) ) THEN
             XMSG = 'Could not create the ' // TRIM( EM_DIAG_FILE( ISRM ) ) // ' file'
             CALL M3EXIT( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
          END IF

        END IF   ! EM_FILE_LDIAG?
      END DO     ! ISRM


      END SUBROUTINE OPEN_EMISS_DIAG


C-----------------------------------------------------------------------
      END MODULE EMIS_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE SA_ARRAY_INIT(CGRID )

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c20140428 If cold start, write ICON values to ISAM; otherwise,
c         write to ISAM those ISAM values from last hour of previous day
c           Called by initscen.F
c
C     01 Nov 2018: S.Napelenok Updates for cmaq5.3 release 
C     09 May 2019: D.Wong Removed all MY_ clauses
C     13 May 2019: D.Wong Moved environment variable ISAM_NEW_START to RUNTIME_VARS
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      USE GRID_CONF
      USE UTILIO_DEFN           ! replaces ioparms, iofdesc, iodecl
      USE CGRID_SPCS            ! covers all kinds of species mapping
      USE SA_DEFN               ! Mc06
      USE RUNTIME_VARS, only : ISAM_NEW_START
      
#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif


      implicit none
      
      INCLUDE SUBST_FILES_ID    ! file name parameters

c.....arguments

      REAL, POINTER :: CGRID( :,:,:,: ) ! for initial CONC

c.....local variables

      INTEGER          C, R, L, S, K              ! loop index
      INTEGER          N, NSPC, JVOC              ! 20140123

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c     program entry
c.........................................................
c.....update isam array according to isam ICON source tag


      IF( ISAM_NEW_START == 'Y') THEN
                                !.....map N_SPC_ADV to the user-query species
        DO S = 1, NSPC_SA

          N = SPC_INDEX( S, 1 )
          IF( N .EQ. 1) THEN  ! query is for an original species, includes O3A 20130627
            DO L = 1, NLAYS
              DO R = 1, NROWS
                DO C = 1, NCOLS
                  ISAM(C,R,L,S,ICONTAG) = CGRID(C,R,L,SPC_INDEX(S,2))
                END DO ! R
              END DO ! C
            END DO ! L
          ELSEIF( N .EQ. -50) THEN  ! 50/50 for each of VOC- and NOx limited ozone
            DO L = 1, NLAYS
              DO R = 1, NROWS
                DO C = 1, NCOLS
                  ISAM(C,R,L,S,ICONTAG) = 0.5 * CGRID(C,R,L,SPC_INDEX(S,2))
                END DO ! R
              END DO ! C
            END DO ! L
          ELSEIF(N .NE. -1) THEN ! query is for constructed species
            DO NSPC = 1, N
              DO L = 1, NLAYS
                DO R = 1, NROWS
                  DO C = 1, NCOLS
                    ISAM(C,R,L,S, ICONTAG) =
     &                  ISAM(C,R,L,S, ICONTAG)+ CGRID(C,R,L,SPC_INDEX(S, 1+NSPC))
                  END DO ! R
                END DO ! C
              END DO ! L
            END DO ! NSPC of constructed species
          END IF ! original species, or constructed species ?
        END DO ! loop of isam species NSPC_SA

      ELSE
        ! Initialize ISAM array by isam output from previous day
        CALL CREATE_ICON( )

      END IF

      return

      end

C=======================================================================

      SUBROUTINE CREATE_ICON( )
      
C**********************************************************************
C
C  FUNCTION: [1] read in a ISAM IOAPI output file
C            [2] Load the last step's ISAM data into ISAM buffer array 
C
C
C**********************************************************************

      USE GRID_CONF
      USE UTILIO_DEFN   ! replaces ioparms, iofdesc, iodecl
      USE SA_DEFN   ! Mc06
      USE RUNTIME_VARS
      
      IMPLICIT NONE 

      
C.....argument:

c.....local variables:
      
      CHARACTER( 16 ), PARAMETER :: PNAME   = 'create_icon'
      CHARACTER( 16 ), PARAMETER :: INNAME  = 'ISAM_PREVDAY'
      
      
      INTEGER       ::  JDATE   ! current model date, coded YYYYDDD
      INTEGER       ::   JTIME   ! midpoint model time, coded HHMMSS

      LOGICAL, SAVE :: FIRSTIME = .TRUE.
      INTEGER       :: GXOFF, GYOFF              ! global origin offset from file
      INTEGER, SAVE :: STARTCOL, ENDCOL, STARTROW, ENDROW

      INTEGER       ::   LOGENV
      INTEGER       ::   C,R,L,S,K,I

      INTEGER       :: IBGN, JSPCTAG, NSPCTAG
      
      CHARACTER( 16 )    :: SPCNAME1( NSPC_SA ) 
      CHARACTER( 16 )    :: NAME_TAG
      CHARACTER( 99 )    :: XMSG
      
      LOGICAL            :: EFLAG = .FALSE.
      
      REAL, ALLOCATABLE  :: TEMP( :,:,: )      

C**********************************************************************
      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.
         LOGENV = INIT3()
C Get domain decomp info from the emissions file
         CALL SUBHFILE ( INNAME, GXOFF, GYOFF,
     &                   STARTCOL, ENDCOL, STARTROW, ENDROW )
      END IF                    ! FIRSTIME
      
      EFLAG = .FALSE.
      
      IF ( .NOT. OPEN3( INNAME, FSREAD3, PNAME) )THEN 
         WRITE(LOGDEV, *) 'Error: open file failed', INNAME
         CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
      ENDIF 
      
      
      IF ( .NOT. DESC3( INNAME ) ) THEN
         WRITE(LOGDEV, *) 'Error: read', INNAME, 'failed'
         CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
      ENDIF 

cyqwang...begin  Get The last step data

      DO I = 1, MXREC3D-1
        CALL NEXTIME( SDATE3D, STIME3D, TSTEP3D )
      END DO

cyqwang...end
      
      JDATE = SDATE3D
      JTIME = STIME3D
      NSPCTAG = NVARS3D

Ckrt....assign spc_name( nspc_sa, ntag_sa ) to spcname1( nspc_sa )
      DO S = 1, NSPC_SA
        SPCNAME1( S ) = SPC_NAME( S, NTAG_SA )
      ENDDO ! s

Ckrt allocate data-loading array 
      ALLOCATE( TEMP( NCOLS, NROWS, NLAYS3D ) )
      TEMP = 0.0
      
      DO JSPCTAG = 1, NSPCTAG
        !KRT: extract sa_conc_1 from previous day
        IF ( .NOT. XTRACT3( INNAME, VNAME3D( JSPCTAG ), 
     &       1, NLAYS3D, STARTROW, ENDROW, STARTCOL, ENDCOL,
     &       JDATE, JTIME, TEMP ) ) THEN
               XMSG = 'Read failure:  file ' // INNAME // 
     &         ' variable ' // VNAME3D( JSPCTAG ) //
     &         ' end of file...'
                WRITE(LOGDEV,*) PNAME, JDATE, JTIME,
     &          TRIM( XMSG )
             CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )             
        END IF
        !KRT: identify isam indices from input species names
        IBGN = INDEX( VNAME3D( JSPCTAG ),'_', BACK = .TRUE. )
        S = INDEX1( VNAME3D( JSPCTAG )( 1:IBGN-1 ),NSPC_SA,SPCNAME1 )
        K = INDEX1( VNAME3D( JSPCTAG )( IBGN+1:LEN_TRIM(VNAME3D(JSPCTAG))),
     &        NTAG_SA, TAGNAME )
        NAME_TAG = VNAME3D(JSPCTAG)(IBGN+1:LEN_TRIM(VNAME3D(JSPCTAG)))
        IF ( S .GT. 0 ) THEN
          IF ( K .GT. 0 ) THEN
            DO C = 1, NCOLS
              DO R = 1, NROWS
                DO L = 1, NLAYS3D
                  ISAM( C,R,L,S,K ) = TEMP( C,R,L )
                END DO
              END DO
            END DO
          ELSE ! bcon, othr, or icon tags            
            CK_SUFFX: SELECT CASE ( NAME_TAG )
            CASE ( 'BCON', 'BCO' )
              K = NTAG_SA - 2
            CASE ( 'OTHR', 'OTH' )
              K = NTAG_SA - 1
            CASE ( 'ICON', 'ICO' )
              K = NTAG_SA
            END SELECT CK_SUFFX
            IF ( K .LE. 0 ) THEN
              WRITE(LOGDEV,*)'ISAM ICON Species ', TRIM( VNAME3D(JSPCTAG) ), ' has bad tagname set to ',
     &        TRIM( NAME_TAG )            
              EFLAG = .TRUE.      
            ELSE
               DO L = 1, NLAYS3D
                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        ISAM( C,R,L,S,K ) = TEMP( C,R,L )
                     END DO
                  END DO
               END DO
            END IF
          ENDIF ! emission tags
        ENDIF ! species exist in tags
      END DO ! jspctag

      IF ( EFLAG ) THEN
         CALL M3EXIT( 'READ_ISAM_ICON', 0, 0, 'Above Fatal Error Encountered', XSTAT2 )
      END IF
      
      DEALLOCATE(TEMP)

      If ( .NOT. CLOSE3( INNAME ) ) Then
         WRITE ( *,* )
     &     '>>--> ISAM PREVDAY output not closed properly <--<<'
      End if
      RETURN
           
      END
     

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency         !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or     !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software       !
!  that is used with the CMAQ system but distributed under the GNU      !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                             !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      Module Cloud_Optics

! Purpose:
! Calculate the optical properties of hydrometeors per wavelength and layer.
! Five types are treated liquid cloud droplet, ice particles, snowflakes, graupel
! and rain droplet. The last three are lumped into one catagory called cloud 
! aggregates
! History:
! 09/15/14: B.Hutzell: Initial version created
! 02/01/19: D.Wong:    Cleaned up USE module clauses

         Implicit None

         real, parameter   :: cldmin   = 1.e-20      ! minimum value for cloud quantities
         
         real, allocatable :: cloud_liquid_ext ( :,: )   ! resolved cloud liquid droplet extinction, 1/m
         real, allocatable :: cloud_liquid_scat( :,: )   ! resolved cloud liquid droplet scattering, 1/m
         real, allocatable :: cloud_liquid_ssa ( :,: )   ! resolved cloud liquid droplet co-albedo
         real, allocatable :: cloud_liquid_asy ( :,: )   ! resolved cloud liquid droplet asymmetery factor

         real, allocatable :: cloud_aggreg_ext ( :,: )   ! resolved cloud aggregates extinction, 1/m
         real, allocatable :: cloud_aggreg_scat( :,: )   ! resolved cloud aggregates scattering, 1/m
         real, allocatable :: cloud_aggreg_ssa ( :,: )   ! resolved cloud aggregates co-albedo
         real, allocatable :: cloud_aggreg_asy ( :,: )   ! resolved cloud aggregates asymmetery factor

         real, allocatable :: cloud_ice_ext  ( :,: )    ! resolved cloud ice particle extinction, 1/m
         real, allocatable :: cloud_ice_scat ( :,: )    ! resolved cloud ice particle scattering, 1/m
         real, allocatable :: cloud_ice_ssa  ( :,: )    ! resolved cloud ice particle single scattering albedo
         real, allocatable :: cloud_ice_asy  ( :,: )    ! resolved cloud ice particle asymmetery factor
         real, allocatable :: cloud_ice_del  ( :,: )    ! resolved cloud ice delta forward tranmission function

         real, allocatable :: total_tau_cld( : )         ! total optical depth of resolved cloud 
#ifdef phot_debug         
         real, allocatable :: ave_asymm_cld( : )         ! column average of resolved cloud asymmetry factor
         real, allocatable :: ave_ssa_cld  ( : )         ! column average of resolved cloud single scattering albedo
#endif
 
         real, allocatable :: cloud_ext_coeff( :,: )   ! total cloud extinction coefficient, 1/m
         real, allocatable :: cloud_scat_coef( :,: )   ! total cloud scattering coefficent, 1/m
         real, allocatable :: cloud_asym_fact( :,: )   ! average cloud asymmetery factor


         real, allocatable :: total_tau_urcld( : ) ! total optical depth of unresolved cloud 
         real, allocatable :: ave_asymm_urcld( : ) ! column average of unresolved cloud asymmetry factor
         real, allocatable :: ave_ssa_urcld  ( : ) ! column average of unresolved cloud single scattering albedo

         real, allocatable :: rel( : )             ! liquid droplet effective radius, um
         real, allocatable :: dge( : )             ! generalized ice particle size, um
         real              :: max_dge              ! maximum allowed value for dge, um
         real              :: max_dge_squ          ! maximum allowed value squared for dge , um2
         real              :: min_dge              ! minimum allowed value for dge, um
        
         logical, allocatable :: cloud_layering ( : ) ! flag to use optical depth correction for cloud layering

         
         integer            :: row_cloud 
         integer            :: col_cloud
         
         public             :: init_cloud_optics,  general_effective_size, get_ice_optics,
     &                         get_droplet_optics, relcalc, get_aggregate_optics

         real, parameter, private :: low      = 1.e-06      ! epsilon
         real, parameter, private :: high     = 1.0e0 - low ! 1.0 - epsilon
         real, parameter, private :: cldtiny  = high*cldmin ! minimum value for cloud scattering
         
! Abscissas of Gauss-Laguerre Integration
! for 32 point quadrature
         real( 8 ), parameter, private :: xk(32) = 
     &    (/ 0.0444893658333D+0, 0.23452610952D+0,  
     &       0.576884629302D+0,  1.07244875382D+0, 1.72240877644D+0, 2.52833670643D+0, 
     &       3.49221327285D+0,   4.61645677223D+0, 5.90395848335D+0, 7.3581268086D+0,   
     &       8.98294126732D+0,   10.783012089D+0,  12.763745476D+0,  14.9309117981D+0,    
     &       17.2932661372D+0,   19.8536236493D+0, 22.6357789624D+0, 25.6201482024D+0,  
     &       28.8739336869D+0,   32.3333294017D+0, 36.1132042245D+0, 40.1337377056D+0,  
     &       44.5224085362D+0,   49.2086605665D+0, 54.3501813324D+0, 59.8791192845D+0,  
     &       65.9833617041D+0,   72.6842683222D+0, 80.1883747906D+0, 88.735192639D+0,   
     &       98.8295523184D+0,   111.751398227D+0 /)

! total weights (weight*exp(xk)) of Modified Gauss-Laguerre Integration
         real( 8 ), parameter, private :: totalw(32) = 
     &    (/ 0.114187105768D+0, 0.266065216898D+0, 
     &       0.418793137325D+0, 0.572532846497D+0, 0.727648788453D+0, 0.884536718946D+0, 
     &       1.04361887597D+0,  1.20534920595D+0,  1.37022171969D+0,  1.53877595906D+0,     
     &       1.71164594592D+0,  1.8895649683D+0,   2.07318851235D+0,  2.26590144444D+0,      
     &       2.46997418988D+0,  2.64296709494D+0,  2.76464437462D+0,  3.22890542981D+0,     
     &       2.92019361963D+0,  4.3928479809D+0,   4.27908673189D+0,  5.20480398519D+0,      
     &       5.11436212961D+0,  4.15561492173D+0,  6.19851060567D+0,  5.34795780128D+0,     
     &       6.28339212457D+0,  6.89198340969D+0,  7.92091094244D+0,  9.20440555803D+0,     
     &       11.1637432904D+0,  15.3902417688D+0 /)
     
         real( 8 ), private          :: newtotalw(32)
! Abscissas for 16 point quadrature
         real( 8 ), parameter, private :: gauss_laguerre_node( 16 ) =   
     &     (/ 0.8764941047892792D-1, 0.4626963289150808D+0, 1.141057774831227D+0,    
     &        2.129283645098381D+0,  3.437086633893207D+0, 5.078018614549768D+0,    
     &        7.070338535048235D+0,  9.438314336391938D+0, 12.21422336886616D+0,
     &        15.44152736878162D+0,  19.18015685675314D+0, 23.51590569399191D+0, 
     &        28.57872974288214D+0,  34.58339870228663D+0, 41.94045264768833D+0,
     &        51.70116033954332D+0 /)      
     
! total weights for 16 points     
         real( 8 ), parameter, private :: gauss_laguerre_weight( 16 ) = 
     &     (/ 0.2250363148642442D+0, 0.5258360527623427D+0, 0.8319613916870883D+0,
     &        1.146099240963750D+0,  1.471751316966809D+0,  1.813134687381348D+0,
     &        2.175517519694609D+0,  2.565762750165028D+0,  2.993215086371375D+0,
     &        3.471234483102089D+0,  4.020044086444668D+0,  4.672516607732857D+0,
     &        5.487420657986129D+0,  6.585361233289269D+0,  8.276357984364143D+0,
     &        11.82427755165841D+0 /)
     
         real( 8 ), private            :: gauss_laguerre_total( 16 )
     
         real( 8 ), parameter :: cloud_largest      = 9.0d+307 
         real( 8 ), parameter :: cloud_smallest     = 9.0d-307
         real( 8 ), parameter :: cloud_log_largest  =  709.090848126508d0
         real( 8 ), parameter :: cloud_log_smallest = -709.090848126508d0
         
         contains         
      
!-----------------------------------------------------------------------
         subroutine init_cloud_optics()

         use VGRD_DEFN, ONLY : NLAYS
         USE UTILIO_DEFN
         USE CSQY_DATA

         Implicit None

         integer          :: allocstat           ! memory allocation status
         integer          :: i

         Character( 132 ) :: xmsg
         Character(  32 ) :: pname = 'init_cloud_optics'
         Logical, Save    :: initialized = .false.
                
         If ( initialized ) Return
         
         initialized = .true.
         
         allocate( cloud_layering( nlays ),
     &             rel           ( nlays ),
     &             dge           ( nlays ), stat = allocstat )
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_layering, rel, dge'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

         max_dge     = maxi_diameter_ice-low
         max_dge_squ = max_dge*max_dge
         min_dge     = mini_diameter_ice+low
         
         cloud_layering = .true.
         
         allocate( cloud_liquid_ext ( nlays,nwl_ref ), 
     &             cloud_liquid_scat( nlays,nwl_ref ),
     &             cloud_liquid_ssa ( nlays,nwl_ref ),
     &             cloud_liquid_asy ( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_liquid_ext, cloud_liquid_scat, cloud_liquid_ssa, cloud_liquid_asy'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

         cloud_liquid_ext  = 0.0
         cloud_liquid_scat = 0.0
         cloud_liquid_ssa  = 1.0
         cloud_liquid_asy  = 0.0          

         allocate( cloud_ice_ext ( nlays,nwl_ref ), 
     &             cloud_ice_scat( nlays,nwl_ref ),
     &             cloud_ice_ssa ( nlays,nwl_ref ),
     &             cloud_ice_del ( nlays,nwl_ref ),
     &             cloud_ice_asy ( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_ice_ext, cloud_ice_ext,cloud_ice_ssa, cloud_ice_del, ice_asy_rcld'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If
         
         cloud_ice_ext  = 0.0
         cloud_ice_scat = 0.0
         cloud_ice_ssa  = 1.0
         cloud_ice_asy  = 0.0

         allocate( cloud_aggreg_ext ( nlays,nwl_ref ), 
     &             cloud_aggreg_scat( nlays,nwl_ref ),
     &             cloud_aggreg_ssa ( nlays,nwl_ref ),
     &             cloud_aggreg_asy ( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_aggreg_ext, cloud_aggreg_ext,cloud_aggreg_ssa,'
     &         // 'cloud_aggreg_del, cloud_aggreg_asy'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

         cloud_aggreg_ext  = cldmin
         cloud_aggreg_scat = cldtiny
         cloud_aggreg_ssa  = 1.0
         cloud_aggreg_asy  = 0.0

         allocate( cloud_ext_coeff( nlays,nwl_ref ), 
     &             cloud_scat_coef( nlays,nwl_ref ),
     &             cloud_asym_fact( nlays,nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating cloud_ext_coeff, cloud_scat_coef, cloud_asy_fact'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If
         
         allocate( total_tau_cld( nwl_ref ), stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating total_tau'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If

#ifdef phot_debug
         allocate( ave_asymm_cld( nwl_ref ),
     &             ave_ssa_cld( nwl_ref ),   stat = allocstat )
     
         If( allocstat .ne. 0 )Then
           xmsg = 'Failure Allocating ave_asymm, ave_ssa'
           call m3exit( pname, 0, 0, xmsg, xstat1 )
         End If
#endif         
         
         do i = 1, 32
            newtotalw( i ) = xk( i ) * xk( i ) * totalw( i )
         end do

         do i = 1, 16
            gauss_laguerre_total( i ) = gauss_laguerre_node( i )
     &                                * gauss_laguerre_node( i )
     &                                * gauss_laguerre_weight( i )
         end do

         end subroutine init_cloud_optics

!-----------------------------------------------------------------------
         subroutine general_effective_size( levels, t )
! Purpose: calculate the generalized effective size
!         of ice particle based on temperature. The routine
!         was adapted from WRF version 3.5 implementation of 
!         RRTMG
! returns the effect raduis, re,  of cloud ice particles, at
! temperature, t

            Implicit None

! Arguments:
            integer, intent(in)    :: levels  ! layers of process
            real,    intent(in)    :: t(:)    ! air temperaure, K
    
! Local:
            real corr
            integer i
            integer k
            integer index

            real, save :: retab(95)  ! look up table effective size, um, of ice particle versus 
                                    ! temperature. Values of re(T) are tabulated over temperature 
                                    ! interval 180 K -- 274 K; hexagonal columns assumed:
!
! The table comes from CAM version 4.0 and does not matched
! citation reference, equation (4) in 
! Kristjässon, J. E., J. M. Edwards, and D. L. Mitchell (1999),
! A new parameterization scheme for the optical properties of 
! ice crystals for use in general circulation models of the 
! atmosphere, Phys. Chem. Earth, B24, 231–236. 
! or 1030.7*EXP(0.05522*(Temp-279.5))
! Array's first value corresponds to Temp equals 186.1 K
! last temp correspond to Temp equal 253.8 K.

            data retab /
     &          5.92779, 6.26422, 6.61973, 6.99539, 7.39234,           ! 5
     &          7.81177, 8.25496, 8.72323, 9.21800, 9.74075, 10.2930,  ! 11
     &          10.8765, 11.4929, 12.1440, 12.8317, 13.5581, 14.2319,  ! 17
     &          15.0351, 15.8799, 16.7674, 17.6986, 18.6744, 19.6955,  ! 23
     &          20.7623, 21.8757, 23.0364, 24.2452, 25.5034, 26.8125,  ! 29
     &          27.7895, 28.6450, 29.4167, 30.1088, 30.7306, 31.2943,  ! 35
     &          31.8151, 32.3077, 32.7870, 33.2657, 33.7540, 34.2601,  ! 41
     &          34.7892, 35.3442, 35.9255, 36.5316, 37.1602, 37.8078,  ! 47
     &          38.4720, 39.1508, 39.8442, 40.5552, 41.2912, 42.0635,  ! 53
     &          42.8876, 43.7863, 44.7853, 45.9170, 47.2165, 48.7221,  ! 59
     &          50.4710, 52.4980, 54.8315, 57.4898, 60.4785, 63.7898,  ! 65
     &          65.5604, 71.2885, 75.4113, 79.7368, 84.2351, 88.8833,  ! 71
     &          93.6658, 98.5739, 103.603, 108.752, 114.025, 119.424,  ! 77
     &          124.954, 130.630, 136.457, 142.446, 148.608, 154.956,  ! 83
     &          161.503, 168.262, 175.248, 182.473, 189.952, 197.699,  ! 89
     &          205.728, 214.055, 222.694, 231.661, 240.971, 250.639/  ! 95

            do k = 1, levels
               If( t(k) .le. 179.0 )Then
                  index = 1
               Else If( t(k) .ge. 273.0 )Then
                  index = 94
               Else
                  index = max( int(t(k)-179.0), 1 )
               End If
               corr = t(k) - aint( t(k) )      ! temperatures of retab values differ by one degree K
               dge(k) = retab(index) + (retab(index+1)-retab(index))*corr

! Convert from effective radius to generalized effective size (*1.0315; Fu et al. 1996)
! but limit to upper bound in Fu et al. (1996) ice parameterization
               dge(k) = max( min( max_dge, 1.0315*dge(k) ), min_dge)
            end do

         return

         end subroutine general_effective_size

!-----------------------------------------------------------------------
         subroutine get_ice_optics( levels, t, iwc )
! Purpose calculate optical properties for ice particles
! Uses Fu (1996) parameterization for ice particle generalized effective size, dge, from 5 to 140 microns, 
! *** NOTE: Fu parameterization requires particle size in generalized effective size.
! and uses Ebert and Curry (1992) parameteriztion size, dge, >= 140 microns.
! *** NOTE: Transition between two methods has not been smoothed. 
! Algorithm adapted Rapid Radiative Model Global (RRTMG) version 3.8 and Weather Research Forecasting model
! (WRF) version 3.5

            USE UTILIO_DEFN         ! IO functions and parameters
            USE CSQY_DATA           ! number and value of wavelengths

            IMPLICIT NONE
! arguments:
            integer, intent( inout ) :: levels     ! layers to process
            real,    intent( inout ) :: t(:)       ! air temperaure, K
            real,    intent( in    ) :: iwc( : )   ! cloud ice water content, g/m3

! ice water coefficients (Ebert and Curry,1992, JGR, 97, 3831-3836)     
            real, save :: abari(4) = (/ 3.448e-03, 3.448e-03,3.448e-03,3.4480e-03/)
            real, save :: bbari(4) = (/ 2.431e+00, 2.431e+00,2.431e+00,2.4310e+00/)
            real, save :: cbari(4) = (/ 1.000e-05, 1.10e-04 ,1.861e-02,4.6658e-01/)
            real, save :: dbari(4) = (/ 0.000e+00, 1.405e-05,8.328e-04,2.0500e-05/)
            real, save :: ebari(4) = (/ 7.661e-01, 0.773e+00,0.794e+00,0.9595e+00/)
            real, save :: fbari(4) = (/ 5.851e-04, 5.665e-04,7.267e-04,1.0760e-04/)

! Local:
            real    factor
            real    fint
            real    forwice ! forward sccatering parameter
            integer iwl     ! loop counter
            integer layer   ! loop counter
            integer index
           
            character( 132 )      :: XMSG
            character( 16 ), save :: pname = 'GET_ICE_OPTICS'
           
            logical               :: error_flag

                 
            cloud_ice_ext ( 1:levels, 1:nwl_ref ) = cldmin
            cloud_ice_scat( 1:levels, 1:nwl_ref ) = cldtiny
            cloud_ice_ssa ( 1:levels, 1:nwl_ref ) = high
            cloud_ice_asy ( 1:levels, 1:nwl_ref ) = 0.0
            dge           ( 1:levels )            = 0.0

!           forall( layer = 1:levels )
!              dge( layer ) = 0.0
!              forall( iwl = 1:nwl_ref ) 
!                 cloud_liquid_ext ( layer, iwl ) = cldmin
!                 cloud_liquid_scat( layer, iwl ) = cldtiny
!                 cloud_liquid_ssa ( layer, iwl ) = high
!                 cloud_liquid_asy ( layer, iwl ) = 0.0
!              end forall 
!           end forall
              
            if( maxval( iwc ) .le. cldmin )return

            call general_effective_size( levels, t )

! Calculation of optical propeties due to ice particle
! Note that this loop structure may not be the most efficientbecuase the 
! inner loop use the farther right array index. The code does this because cycle 
! condition per layer may be more efficient than iterating over wavelength than 
! layer             

            error_flag = .false.
            
            do layer = 1, levels
               if( iwc( layer ) .le. cldmin )cycle
               do iwl = 1, nwl_ref
#ifdef phot_debug                                     
                  if (dge(layer) .lt. mini_diameter_ice)then
                      write(xmsg,*)Trim(pname)
     &                // ': ICE PARTICLE GENERALIZED EFFECTIVE SIZE OUT OF BOUNDS'
     &                // ' dge(', layer, ') = ', dge(layer),' um '
                      call m3mesg(xmsg)
                      error_flag = .true.
                  end if
#endif                   
                  if (dge(layer) .ge. mini_diameter_ice .and. dge(layer) .le. maxi_diameter_ice) then
                     factor = freq_diameter_ice * (dge(layer) - mini_diameter_ice)
                     index = int(factor)
                     fint = factor - float(index)
                     index = min(  ndiameter_ice - 1, max( 1, index ) )
                     cloud_ice_ext(layer, iwl) =  ice_extinct(index,iwl) 
     &                                         +  fint * (ice_extinct(index+1,iwl) - ice_extinct(index,iwl))
                     cloud_ice_ssa(layer, iwl) =  1.0 - ice_coalbedo(index,iwl) 
     &                                         +  fint * (ice_coalbedo(index+1,iwl) - ice_coalbedo(index,iwl))
                     cloud_ice_asy(layer, iwl) =  ice_asymfact(index,iwl) 
     &                                         +  fint * (ice_asymfact(index+1,iwl) - ice_asymfact(index,iwl))
                     cloud_ice_del(layer, iwl) = ice_deltrans(index,iwl) 
     &                                         + fint * (ice_deltrans(index+1,iwl) - ice_deltrans(index,iwl))
#ifdef phot_debug                      
                     if (cloud_ice_del(layer, iwl) .gt. 1.0 .or. cloud_ice_del(layer, iwl) .lt. 0.0)then
                         write(xmsg, 99950)'ice particle delta function outside bounds and equals ', 
     &                   cloud_ice_del(layer, iwl),' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
#endif
                     if(cloud_ice_ssa(layer, iwl) .gt. low)then
                         forwice = cloud_ice_del(layer, iwl) + 0.5 / cloud_ice_ssa(layer, iwl)
                     else 
                         forwice = high
                     end if 

! See Fu (1996) p. 2067 
                     if (cloud_ice_asy(layer, iwl) .ge. 1.0) cloud_ice_asy(layer, iwl) = cloud_ice_asy(layer, iwl)-low
                     if (cloud_ice_asy(layer, iwl) .le. 0.0) cloud_ice_asy(layer, iwl) = cloud_ice_asy(layer, iwl)+low
                     if (forwice .gt. cloud_ice_asy(layer, iwl)) forwice = cloud_ice_asy(layer, iwl)

                  else if (dge(layer) .gt. maxi_diameter_ice) then
                     if (effwl_ref(iwl) .lt. 0.700) then
                        index = 1
                     else if (effwl_ref(iwl) .lt. 1.300) then
                        index = 2
                     else if (effwl_ref(iwl) .lt. 1.900) then
                        index = 3
                     else if (effwl_ref(iwl) .lt. 2.500) then
                        index = 4
                     else ! if (effwl_ref(iwl) .e. 3.500) then
                        index = 5
                     end if
                     cloud_ice_ext(layer, iwl) = abari(index) + bbari(index)/dge(layer) 
                     cloud_ice_ssa(layer, iwl) = 1.0 - cbari(index) - dbari(index)*dge(layer) 
                     cloud_ice_asy(layer, iwl) = ebari(index) + fbari(index)*dge(layer) 
                     if (cloud_ice_asy(layer, iwl) .ge. 1.0)cloud_ice_asy(layer, iwl) = 1.0-low
                     if (cloud_ice_asy(layer, iwl) .le. 0.0)cloud_ice_asy(layer, iwl) = cloud_ice_asy(layer, iwl)+low
                     forwice = cloud_ice_asy(layer, iwl)*cloud_ice_asy(layer, iwl)
                  end if

! adjust results for fraction of light in forward scattering peak from nonspheric particles
! see Appendix A in Fu (1996), equations A.2(a,b,c)
!!! temporary to check interpolation method
                  cloud_ice_ext(layer, iwl) = (1.0 - forwice*cloud_ice_ssa(layer, iwl)) 
     &                                      *  cloud_ice_ext(layer, iwl)
                  cloud_ice_ssa(layer, iwl) =  cloud_ice_ssa(layer, iwl)*(1.0 - forwice) 
     &                                      / (1.0 - forwice*cloud_ice_ssa(layer, iwl))
                  cloud_ice_asy(layer, iwl) = (cloud_ice_asy(layer, iwl) -  forwice)                 
     &                                      / (1.0 - forwice)
                  cloud_ice_del(layer, iwl) = forwice
! convert extinction coefficient to extinction per layer thickness
                  cloud_ice_ext(layer, iwl) = cloud_ice_ext(layer, iwl) * iwc(layer)
! calculate scattering per per layer thickness
                  cloud_ice_scat(layer, iwl) =  cloud_ice_ssa(layer, iwl) * cloud_ice_ext(layer, iwl)
#ifdef phot_debug                       
! Check to ensure all calculated quantities are within physical limits.
                  if (cloud_ice_ext(layer, iwl) .lt. 0.0)then
                     write(xmsg,99950)'ice particle extinction equals ', 
     &               cloud_ice_ext(layer, iwl), ' at layer = ',layer
                     error_flag = .true.
                  end if
                  if (cloud_ice_ssa(layer, iwl) .gt. high .or. cloud_ice_ssa(layer, iwl) .lt. low)then
                     write(xmsg, 99950)'ice particle SSA outside bounds and equals ', 
     &               cloud_ice_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
                  if (cloud_ice_asy(layer, iwl) .gt. 1.0 .or. cloud_ice_asy(layer, iwl) .lt. -1.0)then
                     write(xmsg, 99950)'ice particle asymmetery factor outside bounds and equals ', 
     &               cloud_ice_asy(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
                  if (cloud_ice_scat(layer, iwl) .gt. cloud_ice_ext(layer, iwl))then
                     write(xmsg, 99950)'ice particle scattering greater than extinction, SSA ', 
     &               cloud_ice_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if                   
#endif
               end do
            end do

#ifdef phot_debug                       
            if( error_flag )then
               write(xmsg,99951)'Encountered the above Errors at COLUMN = ', col_cloud,
     &         ' and ROW = ', row_cloud
               call m3exit(pname,0,0,'Encountered the above Errors', XSTAT1 )
            end if
#endif
             
99950    format(a,es12.4,a,i3)
99951    format(a,i5,a,i5)
99962    format(a,1x,10(es12.4,1x),a,10(es12.4,1x))

         end subroutine get_ice_optics

!-----------------------------------------------------------------------
         subroutine relcalc( levels, t, owater_frac, icefrac, snowfrac )
!----------------------------------------------------------------------- 
! Purpose: 
! Compute effective radius of cloud water droplets
! Subroutine adapted WRF version 3.5 by Phil Rasch
! Method: 
! analytic formula following the formulation originally developed by J. T. Kiehl
! for CAM version 3.0 and 4.0 
!-----------------------------------------------------------------------
            Implicit None

! Arguments:
            integer, intent( in ) :: levels            ! layers to process
            real,    intent( in ) :: t( : )            ! Air Temperature, K
            real,    intent( in ) :: owater_frac       ! Open water fractional coverage
            real,    intent( in ) :: icefrac           ! Sea Ice fractional coverage
            real,    intent( in ) :: snowfrac          ! Snow fractional coverage

! Parameters:
            real, parameter :: tmelt     = 273.16 ! freezing temperature of fresh water (K)
            real, parameter :: rliqland  =  8.0   ! liquid drop size if over land
            real, parameter :: rliqocean = 14.0   ! liquid drop size if over ocean
            real, parameter :: rliqice   = 14.0   ! liquid drop size if over sea ice
             
            real, parameter :: del_land_ocean   = rliqocean - rliqland
!           real, parameter :: del_land_seaice  = rliqice - rliqland
             
            real, parameter :: sheight_factor = 1.0e-2 ! conversion factor for snow height
                                                       ! equal 0.001 in rrtmg implementation in WRF 3.5
                                                       ! times 10.0 factor in original relcalc subroutine
! variables:
            integer         :: k                    ! loop counter
            real            :: snowh                ! snow height
                                 
!           snowh = sheight_factor * snowfrac 
              
            forall( k=1:levels ) ! effective radius algorithm
! Start with temperature-dependent value appropriate for continental air
               rel(k) = rliqland + del_land_ocean * min(1.0,max(0.0,0.05*(tmelt-t(k))))
 ! Ramp up for snow frac over land; uses fill increase if snow_frac is 100%
               rel(k) = rel(k) + (rliqocean-rel(k)) * min(1.0, snowfrac)  ! min(1.0,max( 0.0, snowh))
 ! Ramp up between polluted value over land to clean value over ocean.
               rel(k) = rel(k) + (rliqocean-rel(k)) * min(1.0,max( 0.0, owater_frac))
 ! Ramp up between the resultant value and a sea ice value in the presence of ice.
               rel(k) = rel(k) + (rliqice-rel(k))   * min(1.0,max( 0.0, icefrac ))
            end forall
              
         end subroutine relcalc            

!-----------------------------------------------------------------------
         subroutine get_droplet_optics( levels, t, owater_frac, icefrac, snowfrac, lwc )

            USE UTILIO_DEFN         ! IO functions and parameters
            USE CSQY_DATA           ! number and value of wavelengths
            
            Implicit None
! Agruments:
            integer, intent( inout ) :: levels            ! layers to process
            real,    intent( inout ) :: t( : )            ! Air Temperature, K
            real,    intent( inout ) :: owater_frac       ! Open water fractional coverage
            real,    intent( inout ) :: icefrac           ! Sea Ice fractional coverage
            real,    intent( inout ) :: snowfrac          ! Snow fractional coverage
            real,    intent( in )    :: lwc( : )          ! cloud liquid water content, g/m3

! local:
            real    :: radliq
            real    :: fint
            integer :: index
            integer :: iwl
            integer :: layer

            character( 132 )      :: XMSG
            character( 32 ), save :: pname = 'GET_DROPLET_OPTICS'

            logical               :: error_flag

            error_flag = .false.
 
!           forall( layer = 1:levels )
!              rel( layer ) = 0.0
!              forall( iwl = 1:nwl_ref ) 
!                 cloud_liquid_ext ( layer, iwl ) = cldmin
!                 cloud_liquid_scat( layer, iwl ) = cldtiny
!                 cloud_liquid_ssa ( layer, iwl ) = high
!                 cloud_liquid_asy ( layer, iwl ) = 0.0
!              end forall 
!           end forall

            cloud_liquid_ext ( 1:levels, 1:nwl_ref ) = cldmin
            cloud_liquid_scat( 1:levels, 1:nwl_ref ) = cldtiny
            cloud_liquid_ssa ( 1:levels, 1:nwl_ref ) = high
            cloud_liquid_asy ( 1:levels, 1:nwl_ref ) = 0.0
             
            if( maxval(lwc) .le. cldmin )return
             
            call relcalc( levels, t, owater_frac, icefrac, snowfrac )
             
! Calculation of optical coefficients due to water clouds droplets
! Note that this loop structure may not be the most efficientbecuase the 
! inner loop use the farther right array index. The code does this because cycle 
! condition per layer may be more efficient than iterating over wavelength than 
! layer
            error_flag = .false.
             
            do layer = 1, levels
               if( lwc( layer ) .le. cldmin )cycle
               do iwl = 1, nwl_ref
                  radliq = rel(layer)
#ifdef phot_debug                    
                  if (radliq .lt. mini_radius_liquid .or. radliq .gt. maxi_radius_liquid)then
                     write(xmsg, 99950)'liquid effective radius outside bounds and equals ', radliq,
     &               ' um at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if
#endif                    
                  index = int(radliq - init_radius_liquid)
                  if (index .eq. 0) index = 1
                  if (index .eq. nradius_liquid) index = nradius_liquid - 1
                    
                  fint = max( freq_radius_liquid*(radliq - init_radius_liquid - real(index)), 0.0)
     
                  cloud_liquid_ext(layer, iwl) = liquid_extinct(index,iwl) 
     &                                         + fint * (liquid_extinct(index+1,iwl) - liquid_extinct(index,iwl))
     
                  cloud_liquid_ssa(layer, iwl) = 1.0 - liquid_coalbedo(index,iwl) 
     &                                         + fint * (liquid_coalbedo(index+1,iwl) - liquid_coalbedo(index,iwl))
                  if (cloud_liquid_ssa(layer, iwl) .le. 0.0)then
                     cloud_liquid_ssa(layer, iwl) = cloud_liquid_ssa(layer, iwl) + low
                  else if(cloud_liquid_ssa(layer, iwl) .ge. 1.0)then
                     cloud_liquid_ssa(layer, iwl) = cloud_liquid_ssa(layer, iwl) - low
                  end if
                  cloud_liquid_asy(layer, iwl) = liquid_asymfact(index,iwl) 
     &                                         + fint * (liquid_asymfact(index+1,iwl) - liquid_asymfact(index,iwl))

!                 forwliq(iwl) = cloud_liquid_asy(ig)*cloud_liquid_asy(iwl)

! convert extinction coefficient into extinction per layer 
                  cloud_liquid_ext(layer, iwl)  = cloud_liquid_ext(layer, iwl) * lwc(layer)
                    
! calculate scattering per layer
                  cloud_liquid_scat(layer, iwl) = cloud_liquid_ssa(layer, iwl) * cloud_liquid_ext(layer, iwl)
#ifdef phot_debug                    
! Check to ensure all calculated quantities are within physical limits.
                  if (cloud_liquid_ext(layer, iwl) .lt. 0.0)then
                     write(xmsg,99950)'cloud droplet extinction equals ', 
     &               cloud_liquid_ext(layer, iwl), ' at layer = ',layer
                     error_flag = .true.
                  end if
                  if (cloud_liquid_ssa(layer, iwl) .gt. high .or. cloud_liquid_ssa(layer, iwl) .lt. low)then
                     write(xmsg, 99950)'liquid cloud droplet SSA outside bounds and equals ', 
     &               cloud_liquid_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
                  if (cloud_liquid_scat(layer, iwl) .gt. cloud_liquid_ext(layer, iwl))then
                     write(xmsg, 99950)'cloud droplet scattering greater than extinction, SSA = ', 
     &               cloud_liquid_ssa(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
                  if (cloud_liquid_asy(layer, iwl) .gt. 1.0 .or. cloud_liquid_asy(layer, iwl) .lt. -1.0)then
                     write(xmsg, 99950)'liquid cloud droplet asymmetery factor outside bounds and equals ', 
     &               cloud_liquid_asy(layer, iwl),' at layer ', layer
                     call m3mesg(xmsg)
                     error_flag = .true.
                  end if 
#endif                    
               end do
            end do
#ifdef phot_debug                                            
            if( error_flag )then
               write(xmsg,99951)'Encountered the above Errors at COLUMN = ', col_cloud,
     &         ' and ROW = ', row_cloud
               call m3exit(pname,0,0,'Encountered the above Errors', XSTAT1 )
            end if
#endif
           
99950       format(a,es12.4,a,i3)
99951       format(a,i5,a,i5)
         end subroutine get_droplet_optics

!-----------------------------------------------------------------------
         subroutine aggreg_size_effective(hydro_type, q, reff, nlayers)

!---------------------------------------------------------------------------
! Purpose: compute effective radius of cloud water and ice aggregegates:
!         rain droplets, snowflakes and graupel from water liquid and ice
!         
! METHOD: 
!   assume exponential particle size distribution and spherical particles
!                     use Gauss-Laguerre Quadrature for integration
! HISTORY: 08/15/2014: B.Hutzell adapted from NCAR CAM model version 3 
!---------------------------------------------------------------------------

            implicit none
!..Includes:
!           INCLUDE SUBST_CONST     ! CMAQ constants

!...Arguments:
            integer, intent(in)  :: hydro_type        ! aggregegate to calculate
            real,    intent(in)  :: q   ( : )         ! aggregegate mixing ratio, g/m3
            real,    intent(out) :: reff( : )         ! effective radius, um
            integer, intent(in)  :: nlayers             ! # of layers

! constants  
! values for n0 values taken from default column of Table 1. in Wainwright et. al (2014)
! J. of Appl. Meteo. Climat., vol 53. pp 2072.
            real( 8 ), parameter :: n0_rain  =    0.08D0    ! cm(-4)
            real( 8 ), parameter :: n0_snow  =    0.03D0    ! cm(-4)
            real( 8 ), parameter :: n0_grau  =    0.005D0   ! cm(-4)
            real( 8 ), parameter :: rho_rain = 1000.0D0     ! kg m(-3)
            real( 8 ), parameter :: rho_snow =  100.0D0     ! kg m(-3)
            real( 8 ), parameter :: rho_grau =  400.0D0     ! kg m(-3)

            real( 8 ), parameter :: chi_rain = -4.47806054D+01 ! -2.0*(1.0e+3*pi*rho_rain*n0_rain)**0.25, (cm-4*g/m3)**.25
            real( 8 ), parameter :: chi_snow = -1.97059682D+01 ! -2.0*(1.0e+3*pi*rho_snow*n0_snow)**0.25, (cm-4*g/m3)**.25
            real( 8 ), parameter :: chi_grau = -1.78063523D+01 ! -2.0*(1.0e+3*pi*rho_grau*n0_grau)**0.25, (cm-4*g/m3)**.25
   
!!!!!!!!!!! real, parameter :: limit = 1.0E-10 ! value of q where calculation converges to a lower limit
            real, parameter :: limit = 1.0E-04 ! value of q where calculation converges to a upper limit

            real, parameter :: dmin_snow = 887.873       ! lower convergence results for snow, um 
            real, parameter :: dmin_grau = dmin_snow     ! lower convergence results for graupel, um 
            real, parameter :: dmin_rain = 0.5*dmin_snow ! lower convergence results for rain, um 

!  local variables
            integer   :: lay, nk
            real( 8 ) :: rho_hydro
            real( 8 ) :: sum1, sum2 
            real( 8 ) :: lamda
            real( 8 ) :: n0
            real( 8 ) :: chi
            real( 8 ) :: comp
            real( 8 ) :: psd      ! partical size distribution
            real( 8 ) :: argument
            real      :: factor
            real      :: dmin  ! value if q .le. limit

! initialize
!
! cloud rain/snow/graupel effective radius
!
            if ( maxval( q ) .le. cldmin )then
               reff( 1:nlayers )  = min_dge
               return
            end if
               select case ( hydro_type )
               case( 1 )
                  rho_hydro =  rho_rain
                  n0        =  n0_rain
                  chi       =  chi_rain
                  factor    =  1.0e+4
                  dmin      =  dmin_rain
               case( 2 )
                  rho_hydro =  rho_snow
                  n0        =  n0_snow
                  chi       =  chi_snow
                  factor    =  2.0e+4
                  dmin      =  dmin_snow
               case( 3 )
                  rho_hydro =  rho_grau
                  n0        =  n0_grau
                  chi       =  chi_grau
                  factor    =  2.0e+4
                  dmin      =  dmin_snow
               case default
                  reff( 1:nlayers )  = min_dge
                  return
               end select
               
            do lay = 1, nlayers
!              lamda = (1.0e+3*pi*rho_hydro*n0/q(lay))**0.25
               if( q(lay) .le.  limit )then
                  reff(lay) = dmin
                  cycle
               end if
               lamda = chi*(1.0D0/real( q(lay), 8))**0.25D0
               sum1 = 0.0D0
               sum2 = 0.0D0
!original method used thirty-two nodes
               do nk = 1, 32
                  argument = lamda*xk(nk)
                  if( argument .lt. cloud_log_smallest ) cycle ! assume dexp( argument ) equals zero
                  psd = n0*dexp( argument ) 
                  comp = newtotalw(nk) * psd
                  sum2 = sum2 + comp 
                  sum1 = sum1 + xk(nk)*comp
! reff results sixteen point seem off from thirty two points up to a factor of two
!              do nk = 1, 16
!                 psd  = n0*exp(lamda*gauss_laguerre_node(nk))
!                 comp = gauss_laguerre_total(nk) * psd
!                 sum2 = sum2 + comp 
!                 sum1 = sum1 + gauss_laguerre_node(nk)*comp
               end do
               if( sum2 .lt. cloud_smallest )then
                 reff(lay) = dmin
               else
                 reff(lay) = factor * real( sum1/sum2, 4 )    ! microns
               end if
            end do

         end subroutine aggreg_size_effective

!-----------------------------------------------------------------------
         subroutine get_aggregate_optics( levels, rwc, swc, gwc )
! Purpose calculate optical properties for aggregates: combined rain droplet, snowflakes and graupel
! Uses Fu (1996) parameterization for ice particle generalized effective size, dge, from 5 to 140 microns, 
! Algorithm adapted Rapid Radiative Model Global (RRTMG) version 3.9 and Weather Research Forecasting model
! (WRF) version 3.6

            use VGRD_DEFN, ONLY : NLAYS
            USE UTILIO_DEFN         ! IO functions and parameters
            USE CSQY_DATA           ! number and value of wavelengths

            IMPLICIT NONE
! arguments:
            integer, intent( inout ) :: levels     ! layer to processes
            real,    intent( inout ) :: rwc( : )   ! rain water content, g/m3
            real,    intent( inout ) :: swc( : )   ! snowflake content, g/m3
            real,    intent( inout ) :: gwc( : )   ! graupel content, g/m3

! Local:
            real     :: factor
            real     :: fint
            real     :: forwice                ! forward sccatering parameter
            real     :: reff_rain( nlays )     ! effective radius of rain droplet, um
            real     :: deff_snow( nlays )     ! effective diameter of snowflakes, um
            real     :: deff_graupel( nlays )  ! effective diameter of graupel, um
            
            real     :: deff_hydro( nlays )    ! effective diameter for unmodified hydrometeor, um
            real     :: hydro_content( nlays ) ! unmodified hydrometeor content, g/m3

            real     :: rain_ext               ! rain droplet extinction coefficient, 1/m
            real     :: rain_ssa               ! rain droplet sing scattering albedo
            real     :: rain_scat              ! rain droplet scattering coefficient, 1/m
            real     :: rain_asy               ! rain droplet asymmetry factor

            real     :: snow_ext               ! snowflake extinction coefficient, 1/m
            real     :: snow_ssa               ! snowflake sing scattering albedo
            real     :: snow_scat              ! snowflake scattering coefficient, 1/m
            real     :: snow_asy               ! snowflake asymmetry factor

            real     :: graupel_ext            ! graupel extinction coefficient, 1/m
            real     :: graupel_ssa            ! graupel sing scattering albedo
            real     :: graupel_scat           ! graupel scattering coefficient, 1/m
            real     :: graupel_asy            ! graupel asymmetry factor

            real     :: snow_del                ! snowflake delta forward tranmission function
            real     :: graupel_del             ! graupel delta forward tranmission function

            integer  :: iwl                    ! loop counter
            integer  :: layer                  ! loop counter
            integer  :: index
            
            character( 132 )       :: XMSG
            character(  32 ), save :: pname = 'GET_AGGREGATE_OPTICS'
            
            logical  :: error_flag
            logical  :: normalize

! for rain droplets used simple parameterization in Goddard Radiation Model

            normalize = .false.
            error_flag = .false.
           
! initialize optical properties to minimums
            forall( layer = 1:levels, iwl = 1:nwl_ref )
               cloud_aggreg_ext ( layer,iwl )  = cldmin
               cloud_aggreg_scat( layer,iwl )  = cldtiny
               cloud_aggreg_asy ( layer,iwl )  = 0.0
               cloud_aggreg_ssa ( layer,iwl )  = high
            end forall
!           cloud_aggreg_ext ( 1:levels,1:nwl_ref ) = cldmin
!           cloud_aggreg_scat( 1:levels,1:nwl_ref ) = cldtiny
!           cloud_aggreg_ssa ( 1:levels,1:nwl_ref ) = high
!           cloud_aggreg_asy ( 1:levels,1:nwl_ref ) = 0.0

           
            if( maxval( rwc ) .gt. cldmin )then
!!!!!!!!!      call aggreg_size_effective( 1, rwc, reff_rain, levels)

!Parameterization for rain droplets is taken from Goddard Space Flight Radiation Model
!in WRF version 3.6. Their derivation is discussed in Chou and Suarez (1999),
! A Solar Radiation Parameterization for Atmospheric Studies, NASA/TM-1999-104606,
!Vol. 15, pages 17-20.

               rain_ext  =  3.0e-3
               rain_ssa  =  high
               rain_scat =  rain_ssa*rain_ext
               rain_asy  =  0.883
               do layer = 1, levels
                  if( rwc( layer ) .le. cldmin )cycle
                  forall ( iwl = 1:nwl_ref )
                     cloud_aggreg_ext (layer,iwl) = rain_ext  * rwc(layer)
                     cloud_aggreg_scat(layer,iwl) = rain_scat * rwc(layer)
                     cloud_aggreg_asy (layer,iwl) = rain_asy * cloud_aggreg_scat(layer, iwl)
                     cloud_aggreg_ssa (layer, iwl) = rain_ssa
                  end forall
               end do
               normalize = .true.
            end if
            
            if( maxval( swc ) .gt. cldmin )then

               call aggreg_size_effective( 2, swc, deff_snow, levels)

               do layer = 1, levels
                  if( swc( layer ) .le. cldmin )cycle
                  deff_hydro(layer)    = deff_snow(layer)
! correct the snowflake effective size to be within maxi and min parameters then
! updated concentrations. Latter step is taken from the RRTMG code version 3.9 so Fu (1996) can be
! used for optical properties.
                  if( deff_snow( layer ) .ge. maxi_diameter_ice )then
                      hydro_content( layer ) = swc( layer ) * max_dge_squ
     &                                       / (deff_snow( layer )*deff_snow( layer ))
                  else
                      hydro_content(layer)   = swc(layer)
                  end if
                  deff_snow( layer ) = max( min( deff_snow( layer ), max_dge ), min_dge )
                  do iwl = 1, nwl_ref                 
                     factor = freq_diameter_ice * (deff_snow(layer) - mini_diameter_ice)
                     index = int(factor)
                     fint = factor - float(index)
                     index = min(  ndiameter_ice - 1, max( 1, index ) )
                     snow_ext  =  ice_extinct(index,iwl) 
     &                         +  fint * (ice_extinct(index+1,iwl) - ice_extinct(index,iwl))
                     snow_ssa  =  1.0 - ice_coalbedo(index,iwl) 
     &                         +  fint * (ice_coalbedo(index+1,iwl) - ice_coalbedo(index,iwl))
                     snow_asy  =  ice_asymfact(index,iwl) 
     &                         +  fint * (ice_asymfact(index+1,iwl) - ice_asymfact(index,iwl))
                     snow_del  = ice_deltrans(index,iwl) 
     &                         + fint * (ice_deltrans(index+1,iwl) - ice_deltrans(index,iwl))
#ifdef phot_debug                     
                     if (snow_del .gt. 1.0 .or. snow_del .lt. 0.0)then
                         write(xmsg, 99960)'snowflake delta function outside bounds and equals ', 
     &                   snow_del,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                        write(log_cloud_optics,99962)'hdc,deff_snow,snow_ext,snow_asy,ssa,del = ',
!     &                  hydro_content( layer ),deff_snow(layer),snow_ext,snow_asy,
!     &                  snow_ssa, snow_del
!                    end if
#endif                     

                     if(snow_ssa .gt. low)then
                         forwice = snow_del + 0.5 / snow_ssa
                     else 
                        forwice = high
                     end if 
! See Fu (1996) p. 2067 
                     if (snow_asy .ge. 1.0) snow_asy = snow_asy-low
                     if (snow_asy .le. 0.0) snow_asy = snow_asy+low
                     if (forwice .gt. snow_asy) forwice = snow_asy
! adjust results for fraction of light in forward scattering peak from nonspheric particles
! see Appendix A in Fu (1996), equations A.2(a,b,c)
                     snow_ext = (1.0 - forwice*snow_ssa) *  snow_ext
                     snow_ssa =  snow_ssa*(1.0 - forwice) / (1.0 - forwice*snow_ssa)
                     snow_asy = (snow_asy -  forwice) / (1.0 - forwice)
                     snow_del = forwice
! calculate extinction and scattering coefficients per layer
                     snow_ext  =  snow_ext * hydro_content(layer)
                     snow_scat =  snow_ssa * snow_ext
#ifdef phot_debug                      
! Check to ensure all calculated quantities are within physical limits.
                     if (snow_ext .lt. 0.0 .or. snow_ext .ne. snow_ext )then
                        write(xmsg,99960)'snowflake extinction equals ', 
     &                  snow_ext, ' at layer = ',layer
                        error_flag = .true.
                     end if
                     if (snow_ssa .gt. high .or. snow_ssa .lt. low .or. snow_ssa .ne. snow_ssa )then
                        write(xmsg, 99960)'snowflake SSA outside bounds and equals ', 
     &                  snow_ssa,' at layer ', layer
                        call m3mesg(xmsg)
                        error_flag = .true.
                     end if 
                     if (snow_asy .ge. 1.0 .or. snow_asy .le. -1.0 .or. snow_asy .ne. snow_asy )then
                         write(xmsg, 99960)'snowflake asymmetery factor outside bounds and equals ', 
     &                   snow_asy,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
                     if (snow_scat .gt. snow_ext)then
                         write(xmsg, 99960)'snowflake scattering greater than extinction, SSA ', 
     &                   snow_ssa,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if                      
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                        write(log_cloud_optics,99962)'swc,deff_hydro,snow_ext,snow_scat,snow_asyssa,del = ',
!     &                  swc( layer ),deff_hydro(layer),snow_ext/hydro_content(layer),snow_scat/hydro_content(layer),snow_asy,
!     &                  snow_ssa, snow_del
!                    end if
#endif
                     cloud_aggreg_ext(layer, iwl)  = cloud_aggreg_ext(layer, iwl)  + snow_ext
                     cloud_aggreg_scat(layer, iwl) = cloud_aggreg_scat(layer, iwl) + snow_scat
                     cloud_aggreg_asy(layer, iwl)  = cloud_aggreg_asy(layer, iwl)  + (snow_asy*snow_scat)
#ifdef phot_debug                                          
!             if( abs( cloud_aggreg_asy(layer, iwl) ) .ge. cloud_aggreg_scat(layer, iwl) )then
!                 write(log_cloud_optics,99962)
!     &           'swc,deff_hydro,snow_ext,snow_scat,snow_asy * snow_scat, ssa,del,  cloud_aggreg_asy = ',
!     &           swc( layer ),deff_hydro(layer),snow_ext,snow_scat,(snow_asy*snow_scat),
!     &           snow_ssa, snow_del, cloud_aggreg_asy(layer, iwl), cloud_aggreg_scat(layer, iwl)
!             end if
#endif
                  end do
               end do
               normalize = .true.
            end if

            if( maxval( gwc ) .gt. cldmin )then

               call aggreg_size_effective( 3, gwc, deff_graupel, levels)

               do layer = 1, levels
                  if( gwc( layer ) .le. cldmin )cycle                     
                  deff_hydro(layer) = deff_graupel(layer)
! correct effective size to be within maxi and min parameters then
! updated concentrations. Latter step is taken from the RRTMG code 
! version 3.9 so Fu (1996) can be used for optical properties.
                  if( deff_graupel( layer ) .ge. maxi_diameter_ice )then
                     hydro_content( layer ) = gwc( layer ) * max_dge_squ
     &                                      / (deff_graupel( layer )*deff_graupel( layer )) 
                  else
                     hydro_content(layer)   = gwc(layer)                    
                  end if
                  deff_graupel( layer ) = max( min( deff_graupel( layer ), max_dge ), min_dge )
                  do iwl = 1, nwl_ref
                     factor = freq_diameter_ice * (deff_graupel(layer) - mini_diameter_ice)
                     index = int(factor)
                     fint = factor - float(index)
                     index = min(  ndiameter_ice - 1, max( 1, index ) )
                     graupel_ext  =  ice_extinct(index,iwl) 
     &                            +  fint * (ice_extinct(index+1,iwl) - ice_extinct(index,iwl))
                     graupel_ssa  =  1.0 - ice_coalbedo(index,iwl) 
     &                            +  fint * (ice_coalbedo(index+1,iwl) - ice_coalbedo(index,iwl))
                     graupel_asy  =  ice_asymfact(index,iwl) 
     &                            +  fint * (ice_asymfact(index+1,iwl) - ice_asymfact(index,iwl))
                     graupel_del  = ice_deltrans(index,iwl) 
     &                            + fint * (ice_deltrans(index+1,iwl) - ice_deltrans(index,iwl))
#ifdef phot_debug                     
                     if (graupel_del .gt. 1.0 .or. graupel_del .lt. 0.0)then
                         write(xmsg, 99960)'graupel delta function outside bounds and equals ', 
     &                   graupel_del,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                        write(log_cloud_optics,99962)'hdc,deff_graupel,graupel_ext,graupel_asy,ssa,del = ',
!     &                  hydro_content( layer ),deff_graupel(layer),graupel_ext,graupel_asy,
!     &                  graupel_ssa, graupel_del
!                    end if
#endif

                     if(graupel_ssa .gt. low)then
                         forwice = graupel_del + 0.5 / graupel_ssa
                     else 
                         forwice = high
                     end if 

! See Fu (1996) p. 2067 
                     if (graupel_asy .ge. 1.0) graupel_asy = graupel_asy-low
                     if (graupel_asy .le. 0.0) graupel_asy = graupel_asy+low
                     if (forwice .gt. graupel_asy) forwice = graupel_asy
! adjust results for fraction of light in forward scattering peak from nonspheric particles
! see Appendix A in Fu (1996), equations A.2(a,b,c)
!!! temporary to check interpolation method
                     graupel_ext = (1.0 - forwice*graupel_ssa) *  graupel_ext
                     graupel_ssa =  graupel_ssa*(1.0 - forwice) / (1.0 - forwice*graupel_ssa)
                     graupel_asy = (graupel_asy -  forwice) / (1.0 - forwice)
                     graupel_del = forwice
! calculate extinction and scattering coefficients per layer
                     graupel_ext  =  graupel_ext * hydro_content(layer)
                     graupel_scat =  graupel_ssa * graupel_ext
#ifdef phot_debug                     
! Check to ensure all calculated quantities are within physical limits.
                     if (graupel_ext .lt. 0.0 .or. graupel_ext .ne. graupel_ext )then
                        write(xmsg,99960)'graupel extinction equals ', 
     &                  graupel_ext, ' at layer = ',layer
                        error_flag = .true.
                     end if
                     if (graupel_ssa .gt. high .or. graupel_ssa .lt. low .or. graupel_ssa .ne. graupel_ssa )then
                        write(xmsg, 99960)'graupel SSA outside bounds and equals ', 
     &                  graupel_ssa,' at layer ', layer
                        call m3mesg(xmsg)
                        error_flag = .true.
                      end if 
                      if (graupel_asy .gt. 1.0 .or. graupel_asy .lt. -1.0 .or. graupel_asy .ne. graupel_asy )then
                         write(xmsg, 99960)'graupel asymmetery factor outside bounds and equals ', 
     &                   graupel_asy,' at layer ', layer
                         call m3mesg(xmsg)
                         error_flag = .true.
                     end if 
!                    if( iwl .eq. 1 .and. row_cloud .eq. 1 .and. col_cloud .eq. 1 )then
!                       write(log_cloud_optics,99962)'gwc,deff_hydro,graupel_ext,graupel_scat,graupel_asy,ssa,del = ',
!     &                 gwc( layer ),deff_hydro(layer),graupel_ext/hydro_content(layer),graupel_scat/hydro_content(layer),
!     &                 graupel_asy,graupel_ssa, graupel_del
!                    end if
#endif
                     cloud_aggreg_ext(layer, iwl)  = cloud_aggreg_ext(layer, iwl)  + graupel_ext
                     cloud_aggreg_scat(layer, iwl) = cloud_aggreg_scat(layer, iwl) + graupel_scat
                     cloud_aggreg_asy(layer, iwl)  = cloud_aggreg_asy(layer, iwl)  + (graupel_asy*graupel_scat)
#ifdef phot_debug                     
                     if( abs( cloud_aggreg_asy(layer, iwl) ) .gt. cloud_aggreg_scat(layer, iwl) )then
                        write(logdev,99962)
     &                  'gwc,deff_hydro,graupel_ext,graupel_scat,graupel_asy*graupel_scat,ssa,del, cloud_aggreg_asy = ',
     &                  gwc( layer ),deff_hydro(layer),graupel_ext,graupel_scat,(graupel_asy*graupel_scat),
     &                  graupel_ssa, graupel_del, cloud_aggreg_asy(layer, iwl), cloud_aggreg_scat(layer, iwl)
                     end if
#endif                     
                  end do
               end do
               normalize = .true.                
            end if   
     
! computed average properties: single scattering albedo and asymmetery factor
            if( .Not. normalize )RETURN
            
            forall( layer = 1:levels, iwl = 1:nwl_ref )
               cloud_aggreg_ssa(layer,iwl) = cloud_aggreg_scat(layer,iwl)/cloud_aggreg_ext(layer,iwl)
               cloud_aggreg_asy(layer,iwl) =  cloud_aggreg_asy(layer,iwl)/cloud_aggreg_scat(layer,iwl)
            end forall
#ifdef phot_debug                                  
!           do layer = 1, nlays
!              do iwl = 1,nwl_ref
!                 if( abs( cloud_aggreg_asy(layer, iwl) ) .ge. 1.0 )then 
!                     write(log_cloud_optics,99964)
!     &               'layer, iwln cloud_aggreg_scat, cloud_aggreg_scat, cloud_aggreg_ssa, cloud_aggreg_asy = ',
!     &               layer, iwl, cloud_aggreg_ext(layer, iwl), cloud_aggreg_scat(layer, iwl), cloud_aggreg_ssa(layer, iwl), 
!     &               cloud_aggreg_asy(layer, iwl)
!                     error_flag = .true.
!                 end if
!              end do
!           end do
            if( error_flag )then
               write(xmsg,99961)'Encountered the above Errors at COLUMN = ', col_cloud,
     &         ' and ROW = ', row_cloud
               call m3exit(pname,0,0,'Encountered the above Errors', XSTAT1 )
            end if
#endif           

99960       format(a,es12.4,a,i3)
99961       format(a,i5,a,i5)
99962       format(a,1x,10(es12.4,1x),a,10(es12.4,1x))
99964       format(a,2(1x,i3),1x,10(es12.4,1x),a,10(es12.4,1x))
         end subroutine get_aggregate_optics

!-----------------------------------------------------------------------
         subroutine clear_hydrometeor_optics()
            implicit none
!Purpose clear values for hydrometeor optical properties
!Arguments: None
            cloud_liquid_ext  = 0.0
            cloud_liquid_scat = 0.0
            cloud_liquid_ssa  = 1.0
            cloud_liquid_asy  = 0.0          
            cloud_ice_ext     = 0.0
            cloud_ice_scat    = 0.0
            cloud_ice_ssa     = 1.0
            cloud_ice_asy     = 0.0
            cloud_aggreg_ext  = cldmin
            cloud_aggreg_scat = cldtiny
            cloud_aggreg_ssa  = 1.0
            cloud_aggreg_asy  = 0.0              
         end subroutine clear_hydrometeor_optics

      end module cloud_optics   

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE WVEL_DEFN

C Function: capture the derived vertical velocity component to write to the
C           conc file
C
C Revision history:
C   1 Feb 19 David Wong: Implemented centralized I/O approach, removed
C                        all MY_N clauses
C   6 Sep 19 F. Sidi   : Removed USE STD_CONC and USE AVG_CONC statements
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      IMPLICIT NONE

      REAL, ALLOCATABLE, SAVE :: WVEL( :,:,: )
      REAL, ALLOCATABLE, SAVE :: WY( :,:,: ) ! Diagnosed vert vel ala yamo

      CONTAINS

         FUNCTION WVEL_INIT () RESULT ( SUCCESS )

         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE UTILIO_DEFN

         LOGICAL SUCCESS

         CHARACTER( 16 ) :: PNAME = 'WVEL_INIT'
         CHARACTER( 16 ) :: CTM_WVEL = 'CTM_WVEL'
         CHARACTER( 96 ) :: XMSG = ' '

         INTEGER ALLOCSTAT, IERR
         INTEGER :: JDATE = 0, JTIME = 0

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         IF ( W_VEL ) THEN

            ALLOCATE ( WVEL( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'WVEL memory allocation failed'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            WVEL = 0.0

         END IF

         END FUNCTION WVEL_INIT

C-----------------------------------------------------------------------

      SUBROUTINE GET_WVEL( JDATE, JTIME )

      USE GRID_CONF
      USE UTILIO_DEFN
      Use CENTRALIZED_IO_MODULE, only : MSFX2, JACOBF_AVAIL, interpolate_var

      include SUBST_FILES_ID

      INTEGER     JDATE         ! current model date, coded YYYYDDD
      INTEGER     JTIME         ! current model time, coded HHMMSS 
      
      INTEGER       MTIME, MDATE, LVL
      LOGICAL, SAVE :: FIRST_TIME  = .TRUE.

      INTEGER       ALLOCSTAT
      CHARACTER( 16 ) :: PNAME = 'GET_WVEL'
      CHARACTER( 200 ) :: XMSG
      REAL, ALLOCATABLE, SAVE :: DBUFF ( :,:,: )  ! input for W_VEL
      REAL, ALLOCATABLE, SAVE :: JACF  ( :,:,: )  ! full-layer Jacobian
                                         
      IF ( FIRST_TIME ) THEN
            FIRST_TIME = .FALSE.

            ALLOCATE ( JACF( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )

            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating JACF'
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            ALLOCATE( WY( NLAYS,NCOLS,NROWS ) )
            WY = 0.0
      END IF
 

      IF (JACOBF_AVAIL) THEN 
         ! Time-Dependent Part of Vertical Velocity Retrieval
         call interpolate_var ('JACOBF', jdate, jtime, JACF)
      ELSE
         IF ( .NOT. ALLOCATED( DBUFF ) ) THEN
            ALLOCATE ( DBUFF( NCOLS,NROWS,NLAYS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DBUFF'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF
         END IF

         call interpolate_var ('JACOBM', jdate, jtime, DBUFF)

         JACF( :,:,1:NLAYS-1 ) = 0.5 * ( DBUFF( :,:,1:NLAYS-1 ) 
     &                              + DBUFF( :,:,2:NLAYS ) )
         JACF( :,:,NLAYS ) = 0.4 * JACF( :,:,NLAYS-1 )
     &                              + DBUFF( :,:,NLAYS )
      END IF

      ! convert from contravariant vertical velocity component to true wind
      DO LVL = 1, NLAYS
         WVEL( :,:,LVL ) = JACF( :,:,LVL )
     &                     * MSFX2( :,: ) * WY( LVL,:,: )
      END DO 

      END SUBROUTINE GET_WVEL    

      END MODULE WVEL_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE EMIS_VARS

!-----------------------------------------------------------------------
! Function: Define global variables used for emissions processor

! Revision History:
!     09 Nov 2017 B.Murphy: Extracted these variables from EMIS_DEFN
!-----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE em_param_module

      IMPLICIT NONE

      SAVE

      REAL,    ALLOCATABLE :: VDEMIS_DIFF( :,:,:,: ) ! emissions array mapped to diffused species

      INTEGER              :: EMLAYS

      CHARACTER( 16 ), ALLOCATABLE :: EM_SPEC  ( : ) ! Vector of Internal CMAQ Species names for 
                                                     ! each emission operation
      CHARACTER( 16 ), ALLOCATABLE :: EM_SURR( :,: ) ! Emissions Surrogate to be read ( species, stream )
      
      CHARACTER( 16 ), ALLOCATABLE :: TRACSPC( : )   ! Variables from Tracer Emission File
      CHARACTER( 16 ), ALLOCATABLE :: AREASPC( : )   ! Variables straight from the Area Emission File

      TYPE EM_SURR_TYPE
          INTEGER         :: LEN    ! Length of Sub-Vector
          CHARACTER( 16 ), ALLOCATABLE :: ARRY( : )   ! Surrogate Name
          CHARACTER( 16 ), ALLOCATABLE :: UNITS( : )  ! Units determined from input files
          REAL,            ALLOCATABLE :: MW( : )     ! Default MW from SPECIATE/SMOKE/MOVE
          LOGICAL,         ALLOCATABLE :: USED( : )   ! Whether or not the surrogate is used in CMAQ
          Real,            ALLOCATABLE :: CONV( : )   ! Conversion factor to account for kg -> g or hr -> s
          CHARACTER( 4 ),  ALLOCATABLE :: BASIS( : )  ! 'MOLE' or 'MASS'
      END TYPE EM_SURR_TYPE
      TYPE( EM_SURR_TYPE ),ALLOCATABLE :: EM_FILE_SURR( : )! Species to be read from each stream file

      TYPE EM_FAC_STRUCTURE
          INTEGER              :: LEN     ! Number of scaling instructions that apply to this element of 
                                          !   the EM_FAC_ST structure. The other attributes will be of 
                                          !   length LEN.
          REAL, ALLOCATABLE    :: FAC(:)  ! Scale Factor applied with potential aerosol splitting
          REAL, ALLOCATABLE    :: BULK(:) ! Scale Factor for bulk emission without
                                          !   splitting for aerosols
          REAL, ALLOCATABLE    :: BASIS(:)! Conversion factor to account for mole or mass basis
          INTEGER, ALLOCATABLE :: REG(:)  ! Index Mapping this entry to a particlar region in EM_REGIONS
          INTEGER, ALLOCATABLE :: OP(:)   ! Operation to perform for this scaling
                                          !   (addition,'a' = 1, 
                                          !    multiplication,'m' = 2, 
                                          !    overwrite,'o' = 3)
      END TYPE EM_FAC_STRUCTURE
      TYPE( EM_FAC_STRUCTURE), ALLOCATABLE :: EM_FAC_ST ( :,: ) ! Emissions Scale Factors ( species, stream )
      CHARACTER( 1 ) :: EM_OP_NAME( 3 ) = (/'a','m','o'/)
       
      ! Define Structure for Holding Emissions Aerosol Mode Information Globally
      TYPE EM_STREAM_MODES
         INTEGER  :: LEN
         INTEGER,         ALLOCATABLE :: REF( : )
         CHARACTER( 16 ), ALLOCATABLE :: NAME( : )
         REAL,            ALLOCATABLE :: FACNUM( :,: )
         REAL,            ALLOCATABLE :: FACSRF( :,: )
      END TYPE EM_STREAM_MODES
      TYPE( EM_STREAM_MODES ), ALLOCATABLE :: EM_STREAM_SIZE( : )
 
      ! Define Emissions File Attribute Variables
      CHARACTER( 200 ),ALLOCATABLE :: EM_FILE_NAME( : )  ! Filename of each emissions stream
      CHARACTER( 30  ),ALLOCATABLE :: EM_FILE_LAB ( : )  ! Nickname of each emissions stream
      CHARACTER( 16  ),ALLOCATABLE :: EM_FILE_TYPE( : )  ! shortname for the type of each emission
      INTEGER,         ALLOCATABLE :: EM_FILE_ITYPE( : ) ! shortname for the type of each emission
      CHARACTER( 100 ),ALLOCATABLE :: EM_FILE_DESC( : )  ! Description of each emissions stream
      LOGICAL,         ALLOCATABLE :: EM_FILE_LAPPLY( : )! Flag to use each emissions stream
      CHARACTER( 6   ),ALLOCATABLE :: EM_FILE_LDIAG( : ) ! Toggle for Default Emissions Diagnostic Output
      CHARACTER( 16  ),ALLOCATABLE :: EM_DIAG_FILE( : )  ! Filename for Emissions Diagnostic Output
      LOGICAL         ,ALLOCATABLE :: EM_FILE_DIFF( :,: )! Test for whether or not a stream contributes to 
                                                         !   a particular transported variable
      LOGICAL         ,ALLOCATABLE :: EM_FILE_SYM_DATE( : ) ! Toggle for whether or not to let the 
                                                             ! emission stream date override the model
      INTEGER         ,ALLOCATABLE :: EM_FILE_DATE( : )! Date to be read in from each emissions stream
      LOGICAL         ,ALLOCATABLE :: EM_FILE_FIRE( : )! Is this Emission Stream Representing Fires (1=Yes)

      INTEGER              :: IBIOSRM, IMGSRM, ILTSRM, ISEASRM, IDUSTSRM
      INTEGER, ALLOCATABLE :: IGSRM( : ), IPSRM( : ), ITSRM( : ), MAP_PTtoISRM( : )

      INTEGER, ALLOCATABLE :: MAP_EMtoSURR( :,: ), MAP_EMtoDIFF( : ), MAP_EMtoGAS( : )

      ! Create Lookup table of Molecular Weight for likely emission
      ! surrogate species. These values are used to compute mole <-> mass
      ! conversions if requested. 
      Type emis_legend
          Character( 16 ) :: NAME  ! Emissions Surrogate Species
          REAL            :: MW    ! Emissions Surrogate Molecular Weight [g mol-1]
      End Type emis_legend
      
      Integer, Parameter :: N_EMIS_SURR_TABLE = 150
      Type ( emis_legend ), Parameter :: 
     &  EMIS_SURR_TABLE( N_EMIS_SURR_TABLE ) = (/
     &    emis_legend( 'NO2          ' ,046.0 ),
     &    emis_legend( 'NO           ' ,030.0 ),
     &    emis_legend( 'HONO         ' ,047.0 ),
     &    emis_legend( 'SO2          ' ,064.0 ),
     &    emis_legend( 'SULF         ' ,098.0 ),
     &    emis_legend( 'NH3          ' ,017.0 ),
     &    emis_legend( 'NH3_FERT     ' ,017.0 ),
     &    emis_legend( 'CO           ' ,028.0 ),
     &    emis_legend( 'PACD         ' ,076.0 ),
     &    emis_legend( 'AACD         ' ,060.1 ),
     &    emis_legend( 'ALD2         ' ,044.0 ),
     &    emis_legend( 'FORM         ' ,030.0 ),
     &    emis_legend( 'HCHO         ' ,030.0 ),
     &    emis_legend( 'MEOH         ' ,032.0 ),
     &    emis_legend( 'FACD         ' ,046.0 ),
     &    emis_legend( 'ALDX         ' ,058.1 ),
     &    emis_legend( 'GLYXL        ' ,058.0 ),
     &    emis_legend( 'GLY          ' ,058.0 ),
     &    emis_legend( 'MGLY         ' ,072.1 ),
     &    emis_legend( 'ETHA         ' ,030.1 ),
     &    emis_legend( 'ETH          ' ,028.0 ),
     &    emis_legend( 'ETE          ' ,028.0 ),
     &    emis_legend( 'HC3          ' ,044.0 ),
     &    emis_legend( 'HC5          ' ,072.0 ),
     &    emis_legend( 'HC8          ' ,114.0 ),
     &    emis_legend( 'OLT          ' ,042.0 ),
     &    emis_legend( 'OLI          ' ,068.0 ),
     &    emis_legend( 'DIEN         ' ,054.0 ),
     &    emis_legend( 'ACE          ' ,026.0 ),
     &    emis_legend( 'ORA1         ' ,046.0 ),
     &    emis_legend( 'ORA2         ' ,060.0 ),
     &    emis_legend( 'ETOH         ' ,046.1 ),
     &    emis_legend( 'KET          ' ,072.1 ),
     &    emis_legend( 'PAR          ' ,014.0 ),
     &    emis_legend( 'ACET         ' ,058.1 ),
     &    emis_legend( 'ACD          ' ,044.0 ),
     &    emis_legend( 'ALD          ' ,058.0 ),
     &    emis_legend( 'ACT          ' ,058.0 ),
     &    emis_legend( 'UALD         ' ,084.0 ),
     &    emis_legend( 'HKET         ' ,074.0 ),
     &    emis_legend( 'PRPA         ' ,044.1 ),
     &    emis_legend( 'ETHY         ' ,026.0 ),
     &    emis_legend( 'OLE          ' ,042.1 ),
     &    emis_legend( 'IOLE         ' ,056.1 ),
     &    emis_legend( 'OLE1         ' ,072.3 ),
     &    emis_legend( 'OLE2         ' ,075.8 ),
     &    emis_legend( 'RNO3         ' ,147.2 ),
     &    emis_legend( 'CCHO         ' ,044.1 ),
     &    emis_legend( 'RCHO         ' ,058.1 ),
     &    emis_legend( 'ALK1         ' ,030.1 ),
     &    emis_legend( 'ALK2         ' ,036.7 ),
     &    emis_legend( 'ALK3         ' ,058.6 ),
     &    emis_legend( 'ALK4         ' ,077.6 ),
     &    emis_legend( 'ALK5         ' ,118.9 ),
     &    emis_legend( 'MEK          ' ,072.1 ),
     &    emis_legend( 'BACL         ' ,086.1 ),
     &    emis_legend( 'BALD         ' ,106.1 ),
     &    emis_legend( 'MACR         ' ,070.1 ),
     &    emis_legend( 'MVK          ' ,070.1 ),
     &    emis_legend( 'IPRD         ' ,100.1 ),
     &    emis_legend( 'PRD2         ' ,116.2 ),
     &    emis_legend( 'ISOP         ' ,068.1 ),
     &    emis_legend( 'ISO          ' ,068.1 ),
     &    emis_legend( 'TERP         ' ,136.2 ),
     &    emis_legend( 'APIN         ' ,136.2 ),
     &    emis_legend( 'API          ' ,136.2 ),
     &    emis_legend( 'LIM          ' ,136.2 ),
     &    emis_legend( 'SESQ         ' ,204.0 ),
     &    emis_legend( 'BENZ         ' ,078.1 ),
     &    emis_legend( 'BEN          ' ,078.1 ),
     &    emis_legend( 'BENZENE      ' ,078.1 ),
     &    emis_legend( 'PHEN         ' ,094.0 ),
     &    emis_legend( 'CRES         ' ,108.1 ),
     &    emis_legend( 'CSL          ' ,108.0 ),
     &    emis_legend( 'TOL          ' ,092.1 ),
     &    emis_legend( 'XYM          ' ,106.0 ),
     &    emis_legend( 'XYP          ' ,106.0 ),
     &    emis_legend( 'XYO          ' ,106.0 ),
     &    emis_legend( 'XYLMN        ' ,106.2 ),
     &    emis_legend( 'MXYL         ' ,106.2 ),
     &    emis_legend( 'OXYL         ' ,106.2 ),
     &    emis_legend( 'PXYL         ' ,106.2 ),
     &    emis_legend( 'ARO1         ' ,095.2 ),
     &    emis_legend( 'ARO2MN       ' ,118.7 ),
     &    emis_legend( 'NAPH         ' ,128.2 ),
     &    emis_legend( 'B124         ' ,120.2 ),
     &    emis_legend( 'CH4          ' ,016.0 ),
     &    emis_legend( 'CL2          ' ,071.0 ),
     &    emis_legend( 'HCL          ' ,036.5 ),
     &    emis_legend( 'SOAALK       ' ,112.0 ),
     &    emis_legend( 'FORM_PRIMARY ' ,030.0 ),
     &    emis_legend( 'ALD2_PRIMARY ' ,044.0 ),
     &    emis_legend( 'BUTADIENE13  ' ,054.0 ),
     &    emis_legend( 'ACRO         ' ,056.1 ),
     &    emis_legend( 'ACROLEIN     ' ,056.1 ),
     &    emis_legend( 'TOLU         ' ,092.0 ),
     &    emis_legend( 'HGNRVA       ' ,200.6 ),
     &    emis_legend( 'HGIIGAS      ' ,200.6 ),
     &    emis_legend( 'ETHE         ' ,028.1 ),
     &    emis_legend( 'PRPE         ' ,042.1 ),
     &    emis_legend( '13BDE        ' ,054.1 ),
     &    emis_legend( 'ACYE         ' ,026.0 ),
     &    emis_legend( 'MOH          ' ,032.0 ),
     &    emis_legend( 'EOH          ' ,046.0 ),
     &    emis_legend( 'ROH          ' ,060.0 ),
     &    emis_legend( 'ETEG         ' ,062.0 ),
     &    emis_legend( 'PSO4         ' ,096.0 ),
     &    emis_legend( 'PNO3         ' ,062.0 ),
     &    emis_legend( 'PNH4         ' ,018.0 ),
     &    emis_legend( 'PEC          ' ,012.0 ),
     &    emis_legend( 'POC          ' ,220.0 ),
     &    emis_legend( 'PNCOM        ' ,220.0 ),
     &    emis_legend( 'PMOTHR       ' ,200.0 ),
     &    emis_legend( 'PFE          ' ,055.8 ),
     &    emis_legend( 'PAL          ' ,027.0 ),
     &    emis_legend( 'PSI          ' ,028.1 ),
     &    emis_legend( 'PTI          ' ,047.9 ),
     &    emis_legend( 'PCA          ' ,040.1 ),
     &    emis_legend( 'PMG          ' ,024.3 ),
     &    emis_legend( 'PK           ' ,039.1 ),
     &    emis_legend( 'PMN          ' ,054.9 ),
     &    emis_legend( 'PH2O         ' ,018.0 ),
     &    emis_legend( 'PNA          ' ,023.0 ),
     &    emis_legend( 'PCL          ' ,035.5 ),
     &    emis_legend( 'PMC          ' ,100.0 ),
     &    emis_legend( 'ASOIL        ' ,100.0 ),
     &    emis_legend( 'ASEACAT      ' ,023.75),
     &    emis_legend( 'NICKEL_F     ' ,058.7 ),
     &    emis_legend( 'NICKEL_C     ' ,058.7 ),
     &    emis_legend( 'CHROMEHEX_F  ' ,052.0 ),
     &    emis_legend( 'CHROMEHEX_C  ' ,052.0 ),
     &    emis_legend( 'CHROMTRI_F   ' ,052.0 ),
     &    emis_legend( 'CHROMTRI_C   ' ,052.0 ),
     &    emis_legend( 'BERYLLIUM_F  ' ,009.0 ),
     &    emis_legend( 'BERYLLIUM_C  ' ,009.0 ),
     &    emis_legend( 'LEAD_F       ' ,207.2 ),
     &    emis_legend( 'LEAD_C       ' ,207.2 ),
     &    emis_legend( 'DIESEL_PMFINE' ,200.0 ),
     &    emis_legend( 'DIESEL_PMEC  ' ,012.0 ),
     &    emis_legend( 'DIESEL_PMOC  ' ,220.0 ),
     &    emis_legend( 'DIESEL_PMNO3 ' ,062.0 ),
     &    emis_legend( 'DIESEL_PMSO4 ' ,096.0 ),
     &    emis_legend( 'DIESEL_PMC   ' ,100.0 ),
     &    emis_legend( 'CADMIUM_F    ' ,112.4 ),
     &    emis_legend( 'CADMIUM_C    ' ,112.4 ),
     &    emis_legend( 'MANGANESE_F  ' ,054.9 ),
     &    emis_legend( 'MANGANESE_C  ' ,054.9 ),
     &    emis_legend( 'ARSENIC_F    ' ,074.92),
     &    emis_legend( 'ARSENIC_C    ' ,074.92),
     &    emis_legend( 'PHGI         ' ,200.5 )  /)

      CONTAINS

!-----------------------------------------------------------------------
      SUBROUTINE INTERPRET_EM_RULE_STREAM( RULE_STREAM0, IRULE, 
     &              EM_STREAM_RULE, LREMOVE )
!
! This subroutine analyzes the part of a rule identifying which streams
! to affect and searches for the individual streams, or, if the rule uses
! the 'ALL' keyword, this routine identifies every stream as impacted.
!-----------------------------------------------------------------------

      USE UTILIO_DEFN
      USE em_param_module


      IMPLICIT NONE

      CHARACTER(32), INTENT( IN ) :: RULE_STREAM0
      CHARACTER(32)               :: RULE_STREAM
      CHARACTER(32)               :: STREAM_NAME( N_EM_SRM )
      INTEGER, INTENT( IN )       :: IRULE
      LOGICAL, INTENT( INOUT )    :: EM_STREAM_RULE( N_EM_SRM )
      LOGICAL, INTENT( INOUT )    :: LREMOVE

      INTEGER ISRM, IDX, NSRM, IFAM
      CHARACTER( 200 ) :: XMSG
      CHARACTER( 16 )  :: PNAME = "EMIS_SPC_MAP"
      INTEGER  :: JDATE = 0
      INTEGER  :: JTIME = 0

      ! Initialize the output vector
      EM_STREAM_RULE = .FALSE.
      
      ! First Capitalize the Rule so it is easier to error-check
      RULE_STREAM = RULE_STREAM0
      CALL UPCASE( RULE_STREAM )

      LREMOVE = .FALSE.

      IF ( RULE_STREAM .EQ. 'ALL' ) THEN
         ! Special Case Where the Stream Identifier in the rule equals
         ! equals all 'ALL'. Expand the Rule to Apply to All Streams
         ISRM = 0
         IF ( N_FILE_GR .GT. 0 ) THEN
           EM_STREAM_RULE( ISRM+1:N_FILE_GR ) = .TRUE.
           ISRM = ISRM + N_FILE_GR
         END IF

         IF ( NPTGRPS .GT. 0 ) THEN
           EM_STREAM_RULE( ISRM+1:ISRM+NPTGRPS ) = .TRUE.
           ISRM = ISRM + NPTGRPS
         END IF
         IF ( N_FILE_TR .GT. 0 ) EM_STREAM_RULE( ISRM+1:ISRM+N_FILE_TR ) = .TRUE.
         IF ( IBIOSRM .GT.0 .AND. .NOT. Guard_BiogenicVOC   ) EM_STREAM_RULE( IBIOSRM  ) = .TRUE.
         IF ( IMGSRM  .GT.0 .AND. .NOT. Guard_MarineGas     ) EM_STREAM_RULE( IMGSRM   ) = .TRUE.
         IF ( ILTSRM  .GT.0 .AND. .NOT. Guard_LightningNO   ) EM_STREAM_RULE( ILTSRM   ) = .TRUE.
         IF ( ISEASRM .GT.0 .AND. .NOT. Guard_SeaSpray      ) EM_STREAM_RULE( ISEASRM  ) = .TRUE.
         IF ( IDUSTSRM.GT.0 .AND. .NOT. Guard_WindBlownDust ) EM_STREAM_RULE( IDUSTSRM ) = .TRUE.

      ELSE
         ! Determine if the Stream Label Refers to A Family and if So, 
         ! Apply the Rule to all members of that Family
         IFAM = INDEX1( RULE_STREAM, NStreamFamilies, StreamFamilyName )
         IF ( IFAM .EQ. 0 ) THEN
             NSRM = 1
             STREAM_NAME(1) = RULE_STREAM
         ELSE
             NSRM = StreamFamilyNum( IFAM )
             STREAM_NAME(1:NSRM) = StreamFamilyMembers( IFAM,1:NSRM )
         END IF

         ! Find the Specific Stream this Rule Identifies
         DO ISRM = 1,NSRM
           IDX = INDEX1( STREAM_NAME( ISRM ), N_EM_SRM, EM_FILE_LAB ) 
           IF ( IDX .NE. 0 ) THEN
             EM_STREAM_RULE( IDX ) = .TRUE.
           ELSE 
             ! Print warning that this stream is being ignored
             WRITE( LOGDEV, '(/,5x,3A,I3,/,5x,2A,4(/,5x,A))' ),
     &         'ATTENTION: The Emissions Stream Label (',TRIM( RULE_STREAM ),
     &         ') applied for Rule ',IRULE,'in the Emissions Control ',
     &         'Namelist does not match any of the emissions streams ',
     &         'labels or families provided to CMAQ. Please check the ',
     &         'runscript against your emissions control inputs',
     &         'confirm that this stream should be ignored.'

             ! Remove this rule from the list of rules
             LREMOVE = .TRUE.
           END IF
         END DO
      END IF
 
      END SUBROUTINE INTERPRET_EM_RULE_STREAM

!-----------------------------------------------------------------------
      SUBROUTINE CUSTOM_EM_RULES( N_EM_RULE )
!
!     This subroutine defines several hardcoded rules for emissions
!     scaling that will apply by default. These include subtracting NH3
!     from fertilizer emissions if BiDi is turned on, moving all
!     sulfuric acid vapor to the particle phase upon emission and
!     splitting up the coarse mode anthropogenic emissions mass into
!     speciated compounds.
!-----------------------------------------------------------------------

      USE AERO_DATA, ONLY : ACORSEM_ASO4_FAC

      IMPLICIT NONE
      
      INTEGER,         INTENT( INOUT ) :: N_EM_RULE
      TYPE( EM_RULE_REG )              :: EM_NML_B( N_EM_RULE_REG  )

      INTEGER          :: N_EM_RULE_B, IRULE, ISRM

      N_EM_RULE_B = 0
 
      ! Add a rule For Removing Fertilizer Ammonia if BiDi is
      ! activated and the user has requested the correction
         IF ( ABFLUX ) THEN
            N_EM_RULE_B = N_EM_RULE_B + 1
            EM_NML_B(N_EM_RULE_B)%SPEC  = 'NH3'
            EM_NML_B(N_EM_RULE_B)%STREAM= 'ALL'
            EM_NML_B(N_EM_RULE_B)%PHASE = 'GAS'
            EM_NML_B(N_EM_RULE_B)%SURR  = 'NH3_FERT'
            EM_NML_B(N_EM_RULE_B)%FAC   = -1.0
            EM_NML_B(N_EM_RULE_B)%BASIS = 'UNIT'
            EM_NML_B(N_EM_RULE_B)%OP    = 'a'
            EM_NML_B(N_EM_RULE_B)%REGION= 'EVERYWHERE'
         END IF

      ! sulfur tracking instrument model option
         IF ( STM ) THEN
      ! SULF emissions
            N_EM_RULE_B = N_EM_RULE_B + 1
            EM_NML_B(N_EM_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML_B(N_EM_RULE_B)%STREAM= 'ALL'
            EM_NML_B(N_EM_RULE_B)%PHASE = 'FINE'
            EM_NML_B(N_EM_RULE_B)%SURR  = 'SULF'
            EM_NML_B(N_EM_RULE_B)%FAC   = 1.0
            EM_NML_B(N_EM_RULE_B)%BASIS = 'MASS'
            EM_NML_B(N_EM_RULE_B)%OP    = 'a' 
            EM_NML_B(N_EM_RULE_B)%REGION= 'EVERYWHERE'
      !  PSO4 emissions 
            N_EM_RULE_B = N_EM_RULE_B + 1
            EM_NML_B(N_EM_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML_B(N_EM_RULE_B)%STREAM= 'ALL'
            EM_NML_B(N_EM_RULE_B)%PHASE = 'FINE'
            EM_NML_B(N_EM_RULE_B)%SURR  = 'PSO4'
            EM_NML_B(N_EM_RULE_B)%FAC   = 1.0
            EM_NML_B(N_EM_RULE_B)%BASIS = 'UNIT'
            EM_NML_B(N_EM_RULE_B)%OP    = 'a' 
            EM_NML_B(N_EM_RULE_B)%REGION= 'EVERYWHERE'
      ! Coarse-Mode Sulfate
            N_EM_RULE_B = N_EM_RULE_B + 1
            EM_NML_B(N_EM_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML_B(N_EM_RULE_B)%STREAM= 'ALL'
            EM_NML_B(N_EM_RULE_B)%PHASE = 'COARSE'
            EM_NML_B(N_EM_RULE_B)%SURR  = 'PMC'
            EM_NML_B(N_EM_RULE_B)%FAC   = REAL( ACORSEM_ASO4_FAC, 4 ) 
            EM_NML_B(N_EM_RULE_B)%BASIS = 'UNIT'
            EM_NML_B(N_EM_RULE_B)%OP    = 'a' 
            EM_NML_B(N_EM_RULE_B)%REGION= 'EVERYWHERE'
      !  Wind blown dust and sea spray SO4 emissions 
      !  Fine
            N_EM_RULE_B = N_EM_RULE_B + 1
            EM_NML_B(N_EM_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML_B(N_EM_RULE_B)%STREAM= 'ALL'
            EM_NML_B(N_EM_RULE_B)%PHASE = 'FINE'
            EM_NML_B(N_EM_RULE_B)%SURR  = 'PMFINE_SO4'
            EM_NML_B(N_EM_RULE_B)%FAC   = 1.0
            EM_NML_B(N_EM_RULE_B)%BASIS = 'UNIT'
            EM_NML_B(N_EM_RULE_B)%OP    = 'a' 
            EM_NML_B(N_EM_RULE_B)%REGION= 'EVERYWHERE'
      !  Coarse 
            N_EM_RULE_B = N_EM_RULE_B + 1
            EM_NML_B(N_EM_RULE_B)%SPEC  = 'ASO4EMIS'
            EM_NML_B(N_EM_RULE_B)%STREAM= 'ALL'
            EM_NML_B(N_EM_RULE_B)%PHASE = 'COARSE'
            EM_NML_B(N_EM_RULE_B)%SURR  = 'PMCOARSE_SO4'
            EM_NML_B(N_EM_RULE_B)%FAC   = 1.0
            EM_NML_B(N_EM_RULE_B)%BASIS = 'UNIT'
            EM_NML_B(N_EM_RULE_B)%OP    = 'a' 
            EM_NML_B(N_EM_RULE_B)%REGION= 'EVERYWHERE'
         END IF ! stm

      ! Add Rules to Existing List at Beginning
         N_EM_RULE = N_EM_RULE + N_EM_RULE_B
         DO IRULE = N_EM_RULE, N_EM_RULE_B+1, -1
            EM_NML( IRULE ) = EM_NML( IRULE - N_EM_RULE_B )
         END DO
         DO IRULE = 1,N_EM_RULE_B
            EM_NML( IRULE ) = EM_NML_B( IRULE ) 
         END DO

      END SUBROUTINE CUSTOM_EM_RULES
 
      END MODULE EMIS_VARS

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE ZADV ( CGRID, JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Advection in the vertical, x3-direction:
C   The process time step is set equal to TSTEP

C Preconditions:
C   Dates and times represented YYYYDDD:HHMMSS.
C   No "skipped" dates and times. Process time step divides TSTEP exactly
C   CGRID in transport units: SQRT{DET[metric tensor]}*concentration (Mass/Vol)

C Subroutines and functions called:
C   TIME2SEC

C Revision history:
C   02/19/93 by M. Talat Odman  at NCSC
C   05/17/93 by Carlie J. Coats at NCSC:  now uses INTERP3()
C   06/14/94 by Dongming Hwang at NCSC:
C              include statement and subroutine name template
C   10/15/95 by M. Talat Odman at NCSC: generalized coordinates

C   Sep 97 Jeff
C   Aug 98 Jeff better Courant condition tstep limit

C    David Wong, Sep. 1998
C      -- parallelized the code

C    15 Dec 00 J.Young: move CGRID_MAP into f90 module
C                       GLOBAL_RSUM -> Dave Wong's f90 stenex GLOBAL_SUM
C                       GLOBAL_ISUM -> Dave Wong's f90 stenex GLOBAL_SUM

C    28 Jul 01 J.Young: allocatable arrays ...
C                       Since F90 does not preserve dummy argument array
C                       indices, the 3rd dimension of WHAT has been changed
C                       from 0:NLAYS to 1:NLAYS+1 for the sake of vcontvel

C    03 Sep 01 David Wong
C      -- inserted F90 DEALLOCATE statement for NX3
C
C   1/03 - JP modified for Yamo mass conservation
C          Vertical velocity is diagnosed from mass continuity
C          vertical advection is upstream (no call to adv scheme)

C    31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module
C    27 Apr 07 J.Young: Talat's First-order upstream (donor cell) algorithm
C    30 Apr 09 J.Pleim, J.Young: Replace donor cell with ppm, adjust velocity
C                                accordingly
C    21 Aug 09 J.Young: Don't bypass VPPMY if ITER = 0
C    18 Nov 09 J.Young: Combine VPPMY and VPPM functionality
C    21 Jun 10 J.Young: convert for Namelist redesign
C    16 Feb 11 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    31 Jul 12 J.Bash: Changed the zadv dt for cases where cc > 1 to be 
C                      more stable for conditions when cc > 10
C    01 Feb 19 D.Wong: Implemented centralized I/O approach, removed all MY_N
C                      clauses
C    09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C    11 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C-----------------------------------------------------------------------

      USE GRID_CONF             ! horizontal & vertical domain specifications
      USE CGRID_SPCS            ! CGRID species number and offsets
      USE WVEL_DEFN             ! derived vertical velocity component
      USE UTILIO_DEFN

#ifdef isam
      USE SA_DEFN               ! 20120821
#endif

#ifdef parallel
      USE SE_MODULES            ! stenex (using SE_GLOBAL_SUM_MODULE)
#else
      USE NOOP_MODULES          ! stenex (using NOOP_GLOBAL_SUM_MODULE)
#endif

#ifdef snl_timing
      USE TIMING
#endif
      USE CENTRALIZED_IO_MODULE, only : interpolate_var

#ifdef sens
      USE DDM3D_DEFN, ONLY: SENGRID, NPMAX, NP
#endif 

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

      REAL, POINTER :: CGRID( :,:,:,: )
      INTEGER     JDATE         ! current model date, coded YYYYDDD
      INTEGER     JTIME         ! current model time, coded HHMMSS
      INTEGER     TSTEP( 3 )    ! time step vector (HHMMSS)
                                ! TSTEP(1) = local output step
                                ! TSTEP(2) = sciproc sync. step (chem)
                                ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                !            step and wrf/cmaq call frequency

C Parameters:

      INTEGER, PARAMETER :: MAXITER = 30     ! error exit limit

C Advected species dimension

      INTEGER, SAVE :: N_SPC_ADV

C File Variables:

      REAL        RHOJM1( NCOLS,NROWS,NLAYS ) ! RhoJ from Met file at start of tstep
      REAL        RHOJM2( NCOLS,NROWS,NLAYS ) ! RhoJ from Met file at end of tstep

C Local variables:

      CHARACTER( 16 ) :: PNAME = 'ZADVYPPM'
      LOGICAL, SAVE :: FIRSTIME = .TRUE.
!     REAL         UHATJD( NCOLS+1,NROWS+1,NLAYS )  ! x1-component CX-velocity
!     REAL         VHATJD( NCOLS+1,NROWS+1,NLAYS )  ! x2-component CX-velocity

      INTEGER       MTIME, MDATE
!     REAL          CON1( NLAYS,N_SPC_ADV ) ! concentrations subset
      REAL, ALLOCATABLE, SAVE :: CON1( :,: ) ! concentrations subset
      REAL          VEL ( NLAYS+1 )        ! Velocities in a N-S column
      REAL          FLX ( NLAYS+1 )        ! upstream donor cell computed conc. flux
      REAL, ALLOCATABLE, SAVE :: DS ( : )  ! dx3 (dimensionless in sigma coord.)
      REAL          DTSEC                  ! sync time step in seconds
      REAL          DELT                   ! adjusted time step
      REAL          FLUX                   ! intermediate flux

!     INTEGER, SAVE :: ADV_MAP( N_SPC_ADV ) ! global adv map to CGRID
      INTEGER, ALLOCATABLE, SAVE :: ADV_MAP( : ) ! global adv map to CGRID

      INTEGER       COL, ROW, LVL, SPC, VAR ! loop counters
      INTEGER       A2C
      INTEGER       ITER

      CHARACTER( 96 ) :: XMSG = ' '
      INTEGER, SAVE :: ASPC                ! pointer in CGRID to transported RHOJ
      REAL          RJ1( NLAYS )           ! local adjusted RHOJ
      REAL          RJ2( NLAYS )           ! local RHOJM at tstep + 1
      REAL          RJT( NLAYS )           ! local adjusted RHOJ
      REAL          DRJ, DUDX, DVDY
      REAL          DIVV( NLAYS )
      REAL          CC                     ! local Courant No.
      REAL          DTNEW                  ! sub timestep
      REAL          DSDT                   ! DS/DT
      REAL, ALLOCATABLE, SAVE :: FBLN( : ) ! blending function for upper layers
      INTEGER       ALLOCSTAT

#ifdef isam
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: NAME_ADV( : )
      REAL    :: SA_CON( NLAYS,N_SPCTAG )
#endif

#ifdef sens
      REAL, ALLOCATABLE, SAVE :: SEN1( :,:,: ) ! ( NLAYS,N_SPC_ADV,NPMAX ) sens subset
#endif

      INTERFACE
#ifdef isam
         SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON, SA_CON )
         USE SA_DEFN
#elif sens
         SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON, SEN1 )
#else
         SUBROUTINE VPPM ( NI, DT, DS, FLX, VEL, CON )
#endif
            INTEGER, INTENT( IN )    :: NI
            REAL,    INTENT( IN )    :: DT, DS( NI )
            REAL,    INTENT( IN )    :: FLX( NI+1 )
!           REAL,    INTENT( IN )    :: VEL( NI+1 )
            REAL,    INTENT( INOUT ) :: VEL( NI+1 )
            REAL,    INTENT( INOUT ) :: CON( :,: )
#ifdef isam
            REAL,    INTENT( INOUT ) :: SA_CON( NI,N_SPCTAG )
#elif sens
            REAL,    INTENT( INOUT ) :: SEN1( :,:,: )
#endif
         END SUBROUTINE VPPM
      END INTERFACE

C-----------------------------------------------------------------------

      IF ( FIRSTIME ) THEN
         FIRSTIME = .FALSE.

         ALLOCATE ( DS( NLAYS ),FBLN( NLAYS ),STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DS or FBLN'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

         N_SPC_ADV = N_GC_TRNS + N_AE_TRNS + N_NR_TRNS + N_TR_ADV + 1
                                                  ! add 1 for advecting RHOJ
         ALLOCATE ( CON1( NLAYS,N_SPC_ADV ),
     &              ADV_MAP( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating CON1 or ADV_MAP'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF

#ifdef isam
         ALLOCATE ( NAME_ADV( N_SPC_ADV ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating NAME_ADV'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
#endif

#ifdef sens
         ALLOCATE ( SEN1( NLAYS,N_SPC_ADV,NPMAX ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating SEN1'
            CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
#endif

C Get default file header attibutes from MET_CRO_3D (assumes file already open)

C Get dx3 from the GRID_CONF(VGRD) F90 module
!         WRITE( LOGDEV,* ) ' '
!         WRITE( LOGDEV,* ) '    layer    S (X3FACE_GD) Delta S'
         DO LVL = 1, NLAYS
            DS ( LVL ) = ABS ( X3FACE_GD( LVL ) - X3FACE_GD( LVL-1 ) )
!           FBLN( LVL ) = 1.0 - 1.0 / ( 1.0 + EXP( 15.0 * ( X3FACE_GD( LVL ) - 0.5 ) ) )
            FBLN( LVL ) = 1.0
!            WRITE( LOGDEV,'(5X, I3, 3F14.7)' ) LVL, X3FACE_GD( LVL ),
!    &                                          DS( LVL ), FBLN(LVL)
         END DO
!         WRITE( LOGDEV,* ) ' '

C Pointer to transported RHOJ
         ASPC = GC_STRT - 1 + N_GC_SPCD

C Create global map to CGRID
         SPC = 0
         DO VAR = 1, N_GC_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = GC_STRT - 1 + GC_TRNS_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = GC_TRNS( VAR )  ! KRT
#endif
         END DO
         DO VAR = 1, N_AE_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = AE_STRT - 1 + AE_TRNS_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = AE_TRNS( VAR )  ! KRT
#endif
         END DO
         DO VAR = 1, N_NR_TRNS
            SPC = SPC + 1
            ADV_MAP( SPC ) = NR_STRT - 1 + NR_TRNS_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = NR_TRNS( VAR )  ! KRT
#endif
         END DO
         DO VAR = 1, N_TR_ADV
            SPC = SPC + 1
            ADV_MAP( SPC ) = TR_STRT - 1 + TR_ADV_MAP( VAR )
#ifdef isam
            NAME_ADV( SPC ) = TR_ADV( VAR )  ! KRT
#endif
         END DO
 
         ADV_MAP( N_SPC_ADV ) = ASPC

      END IF                    ! if firstime

C Time-stepped gridded computation for Z-direction advection.
      DTSEC  = FLOAT( TIME2SEC( TSTEP( 2 ) ) ) ! process time step (seconds)

C vertical velocities are at face centers, positive upward.
C No boundary conditions are needed because VEL(1) = VEL(NLAYS+1) = 0

C Get rho*J at start of sync step
      MDATE = JDATE
      MTIME = JTIME
#ifdef snl_timing
      call start_timing( zadv_int, read_int, 1 )
#endif
      call interpolate_var ('DENSA_J', mdate, mtime, RHOJM1)

#ifdef snl_timing
      call stop_timing( zadv_int, read_int )
#endif

C Get rho*J at end of sync step
      CALL NEXTIME( MDATE, MTIME, TSTEP( 2 ) )
#ifdef snl_timing
      call start_timing( zadv_int, read_int, 1 )
#endif
      call interpolate_var ('DENSA_J', mdate, mtime, RHOJM2)

#ifdef snl_timing
      call stop_timing( zadv_int, read_int )
#endif

      DO 333 ROW = 1, NROWS
         DO 222 COL = 1, NCOLS

            DO SPC = 1, N_SPC_ADV
               A2C = ADV_MAP( SPC )
               DO LVL = 1, NLAYS
                  CON1( LVL,SPC ) = CGRID( COL,ROW,LVL,A2C )
#ifdef sens
                  DO NP = 1, NPMAX
                     SEN1 ( LVL,SPC,NP ) = SENGRID( COL,ROW,LVL,NP,A2C )
                  END DO
#endif
               END DO
            END DO

            DO LVL = 1, NLAYS
               RJ1( LVL ) = RHOJM1( COL,ROW,LVL )
               RJ2( LVL ) = RHOJM2( COL,ROW,LVL )
            END DO

            ITER = 0
            DELT = DTSEC
            VEL( 1 ) = 0.0   ! impermeable boundary condition at the surface
            FLX( 1 ) = 0.0
            DRJ = 0.0
            DO LVL = 1, NLAYS
               DSDT = DS( LVL ) / DELT              ! initial for this col/row
               RJT( LVL ) = CON1( LVL,N_SPC_ADV )   ! initial for this col/row
!              DUDX = ( UHATJD( COL+1,ROW,LVL ) - UHATJD( COL,ROW,LVL ) ) / XCELL_GD
!              DVDY = ( VHATJD( COL,ROW+1,LVL ) - VHATJD( COL,ROW,LVL ) ) / YCELL_GD
!              DIVV( LVL ) = DUDX * DS( LVL ) + DVDY * DS( LVL )
               DIVV( LVL ) = ( RJ1( LVL ) - RJT( LVL ) ) * DSDT
               DRJ = DRJ - DIVV( LVL )
            END DO

#ifdef isam
Ckrt...import isam array into sa_con
            DO SPC = 1, N_SPCTAG
               DO LVL = 1, NLAYS
                  SA_CON( LVL,SPC ) = ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) )
               END DO
            END DO
#endif
                        
111         CONTINUE   ! iteration loop if CC > 1

            FLUX = 0.0
            DO LVL = 1, NLAYS
               RJT( LVL ) = CON1( LVL,N_SPC_ADV )
!----Yamo part
               DSDT = DS( LVL ) / DELT
               FLUX = FLUX - DSDT * ( RJ2( LVL ) - RJT( LVL ) )
               FLX( LVL+1 ) = FLX( LVL ) - DS( LVL ) * DRJ - DIVV( LVL )
               FLX( LVL+1 ) = FBLN( LVL ) * FLX( LVL+1 ) + ( 1.0 - FBLN( LVL ) ) * FLUX
               FLUX = FLX( LVL+1 )
            END DO

            DO LVL = 2, NLAYS
               IF ( FLX( LVL ) .GE. 0.0 ) THEN
                  VEL( LVL ) = FLX( LVL ) / RJT( LVL-1 )
               ELSE
                  VEL( LVL ) = FLX( LVL ) / RJT( LVL )
               END IF
            END DO

            VEL( NLAYS+1 ) = FLX( NLAYS+1 ) / RJT( NLAYS )

C Find Maximum Courant Number

            CC = 0.0
            DTNEW = DELT

            DO LVL = 2, NLAYS
               IF ( VEL( LVL ) .GT. 0.0 ) THEN
                  CC = MAX ( CC, ( VEL( LVL ) * DELT / DS( LVL-1 ) ) )
                  DTNEW = MIN( DTNEW, 0.9 * DELT / CC )
               ELSE
                  CC = MAX ( CC, ( -VEL( LVL ) * DELT / DS( LVL ) ) )
   !              DTNEW = MIN( DTNEW, DELT / MAX( CC, 0.9 ) )
                  DTNEW = MIN( DTNEW, 0.9 * DELT / MAX( CC, 1.0 ) ) ! MAX in case vel = 0
               END IF
            END DO

            LVL = NLAYS+1
            IF ( VEL( LVL ) .GT. 0.0 ) THEN
               CC = MAX ( CC, ( VEL( LVL ) * DELT / DS( LVL-1 ) ) )
               DTNEW = MIN( DTNEW, 0.9 * DELT / CC )
            ELSE
               CC = MAX ( CC, ( -VEL( LVL ) * DELT / DS( LVL-1 ) ) )
   !           DTNEW = MIN( DTNEW, DELT / MAX( CC, 0.9 ) )
               DTNEW = MIN( DTNEW, 0.9 * DELT / MAX( CC, 1.0 ) ) ! MAX in case vel = 0
            END IF

            IF ( CC .GT. 1.0 ) THEN ! courant number is larger than unity

C Calculate a sub-time step that satisfies the Courant stability limit.
C Perform vertical advection with the computed velocity and sub-time step.
C Then calculate the difference between the original and sub-time steps.
C The difference is the new sub-time step. Recompute vertical velocities
C that would bring the air density field back to being uniform. Note that
C if Courant number with the new velocity and sub-time step is larger than
C unity again, then the last sub-time step would be split into further
C sub-steps.

               DTNEW = MAX( DTNEW, 1.0 )       

#ifdef isam
               CALL VPPM ( NLAYS, DTNEW, DS, FLX, VEL, CON1, SA_CON )
#elif sens
               CALL VPPM ( NLAYS, DTNEW, DS, FLX, VEL, CON1, SEN1 )
#else
               CALL VPPM ( NLAYS, DTNEW, DS, FLX, VEL, CON1 )
#endif
               DELT = DELT - DTNEW

               ITER = ITER + 1
               IF ( ITER .GT. MAXITER ) THEN
                  WRITE( LOGDEV,2005 ) COL, ROW, CC, DELT, ITER, JTIME
2005              FORMAT( 'zadv col  row     CC', 8X, 'dt    iter   jtime'
     &                    / 'zzzz', 2I4, 1PE12.3, 0PF10.5, 1X, I4, I10.6
     &                    / 10X, 'MetRhoj', 3X, 'TrRhoj', 5X, 'Diff',
     &                       4X, 'adv_rhoj', 3X, 'vel(l)', 6X, 'vel(l+1)' )
                  DO LVL = 1, NLAYS
                     WRITE( LOGDEV,2009 ) LVL, RJ2( LVL ), RJT( LVL ),
     &                                    RJ2( LVL ) - RJT( LVL ),
     &                                    CON1( LVL,N_SPC_ADV ),
     &                                    VEL( LVL ), VEL( LVL+1 )
                  END DO
2009              FORMAT( 'zzz2', I3, 4F10.2, 2(1PE12.3) )
                  WRITE( XMSG,2013 ) JTIME, TSTEP( 2 ), MAXITER
2013              FORMAT( 'vert adv soln failed at', I7.6,  ' with adv step:',
     &                     I7.6, ' HHMMSS', 2X, 'Max Iterations =', I3 )
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               END IF

               GO TO 111

            END IF

#ifdef isam
            CALL VPPM ( NLAYS, DELT, DS, FLX, VEL, CON1, SA_CON )
#elif sens
            CALL VPPM ( NLAYS, DELT, DS, FLX, VEL, CON1, SEN1 )
#else
            CALL VPPM ( NLAYS, DELT, DS, FLX, VEL, CON1 )
#endif
            DO SPC = 1, N_SPC_ADV
               A2C = ADV_MAP( SPC )
               DO LVL = 1, NLAYS
                  CGRID( COL,ROW,LVL,A2C ) = CON1( LVL,SPC )
#ifdef sens
                  DO NP = 1, NPMAX
                     SENGRID( COL,ROW,LVL,NP,A2C ) = SEN1 ( LVL,SPC,NP )
                  END DO
#endif
               END DO
            END DO

#ifdef isam
Ckrt...update ISAM with SA_CON....20120821
            DO SPC = 1, N_SPCTAG
               IF( TRANSPORT_SPC( SPC ) )THEN
                  DO LVL = 1, NLAYS
                     ISAM( COL,ROW,LVL,S_SPCTAG( SPC ),T_SPCTAG( SPC ) ) = SA_CON( LVL,SPC )
                  END DO
               END IF   
            END DO
#endif
            IF ( W_VEL ) THEN ! If the user wants vertical velocity written to file, fill in global scope array (WY)
              DO LVL = 1, NLAYS
                 WY( LVL,COL,ROW ) = VEL( LVL+1 )
              END DO
            END IF 

222         CONTINUE   ! COL
333      CONTINUE   ! ROW

      IF ( W_VEL ) CALL GET_WVEL( JDATE,JTIME )

      RETURN
      END SUBROUTINE ZADV

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

      SUBROUTINE HRRATES

C***********************************************************************
C
C  FUNCTION: To calculate rates of reactions
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C
C***********************************************************************
      USE HRDATA

      IMPLICIT NONE

C.....INCLUDES: NONE


C.....ARGUMENTS: NONE


C.....PARAMETERS: NONE


C.....EXTERNAL FUNCTIONS: NONE


C.....SAVED VARIABLES: NONE
!     CHARACTER( 16 ), SAVE  ::  PNAME = 'HRRATES'   ! Program name


C.....LOCAL VARIABLES: None

C***********************************************************************
C..NOTE: RXRAT commented out are not referenced by any routine
!     RXRAT(      1 ) = RKI(     1 ) * YC(  NO2 )
!     RXRAT(      2 ) = RKI(     2 ) * YC(  O )
!     RXRAT(      3 ) = RKI(     3 ) * YC(  O3 ) * YC(  NO )
!     RXRAT(      4 ) = RKI(     4 ) * YC(  O ) * YC(  NO )
!     RXRAT(      5 ) = RKI(     5 ) * YC(  O ) * YC(  NO2 )
      RXRAT(      6 ) = RKI(     6 ) * YC(  O ) * YC(  NO2 )
!     RXRAT(      7 ) = RKI(     7 ) * YC(  O ) * YC(  O3 )
      RXRAT(      8 ) = RKI(     8 ) * YC(  O3 )
      RXRAT(      9 ) = RKI(     9 ) * YC(  O3 )
!     RXRAT(     10 ) = RKI(    10 ) * YC(  O1D )
!     RXRAT(     11 ) = RKI(    11 ) * YC(  O1D )
!     RXRAT(     12 ) = RKI(    12 ) * YC(  O3 ) * YC(  OH )
!     RXRAT(     13 ) = RKI(    13 ) * YC(  O3 ) * YC(  HO2 )
!     RXRAT(     14 ) = RKI(    14 ) * YC(  OH ) * YC(  O )
!     RXRAT(     15 ) = RKI(    15 ) * YC(  HO2 ) * YC(  O )
      RXRAT(     16 ) = RKI(    16 ) * YC(  OH ) * YC(  OH )
      RXRAT(     17 ) = RKI(    17 ) * YC(  OH ) * YC(  OH )
!     RXRAT(     18 ) = RKI(    18 ) * YC(  OH ) * YC(  HO2 )
      RXRAT(     19 ) = RKI(    19 ) * YC(  HO2 ) * YC(  HO2 )
      RXRAT(     20 ) = RKI(    20 ) * YC(  HO2 ) * YC(  HO2 )
      RXRAT(     21 ) = RKI(    21 ) * YC(  H2O2 )
      RXRAT(     22 ) = RKI(    22 ) * YC(  H2O2 ) * YC(  OH )
      RXRAT(     23 ) = RKI(    23 ) * YC(  H2O2 ) * YC(  O )
!     RXRAT(     24 ) = RKI(    24 ) * YC(  NO ) * YC(  NO )
!     RXRAT(     25 ) = RKI(    25 ) * YC(  HO2 ) * YC(  NO )
      RXRAT(     26 ) = RKI(    26 ) * YC(  NO2 ) * YC(  O3 )
      RXRAT(     27 ) = RKI(    27 ) * YC(  NO3 )
      RXRAT(     28 ) = RKI(    28 ) * YC(  NO3 )
      RXRAT(     29 ) = RKI(    29 ) * YC(  NO3 ) * YC(  NO )
      RXRAT(     30 ) = RKI(    30 ) * YC(  NO3 ) * YC(  NO2 )
      RXRAT(     31 ) = RKI(    31 ) * YC(  NO3 ) * YC(  O )
      RXRAT(     32 ) = RKI(    32 ) * YC(  NO3 ) * YC(  OH )
      RXRAT(     33 ) = RKI(    33 ) * YC(  NO3 ) * YC(  HO2 )
      RXRAT(     34 ) = RKI(    34 ) * YC(  NO3 ) * YC(  O3 )
      RXRAT(     35 ) = RKI(    35 ) * YC(  NO3 ) * YC(  NO3 )
!     RXRAT(     36 ) = RKI(    36 ) * YC(  NO3 ) * YC(  NO2 )
      RXRAT(     37 ) = RKI(    37 ) * YC(  N2O5 )
      RXRAT(     38 ) = RKI(    38 ) * YC(  N2O5 )
      RXRAT(     39 ) = RKI(    39 ) * YC(  N2O5 )
!     RXRAT(     40 ) = RKI(    40 ) * YC(  NO ) * YC(  OH )
      RXRAT(     41 ) = RKI(    41 ) * YC(  NO ) * YC(  NO2 )
      RXRAT(     42 ) = RKI(    42 ) * YC(  HONO ) * YC(  HONO )
      RXRAT(     43 ) = RKI(    43 ) * YC(  HONO )
      RXRAT(     44 ) = RKI(    44 ) * YC(  HONO ) * YC(  OH )
      RXRAT(     45 ) = RKI(    45 ) * YC(  NO2 ) * YC(  OH )
      RXRAT(     46 ) = RKI(    46 ) * YC(  HNO3 ) * YC(  OH )
      RXRAT(     47 ) = RKI(    47 ) * YC(  HNO3 )
!     RXRAT(     48 ) = RKI(    48 ) * YC(  HO2 ) * YC(  NO2 )
      RXRAT(     49 ) = RKI(    49 ) * YC(  PNA )
      RXRAT(     50 ) = RKI(    50 ) * YC(  PNA )
      RXRAT(     51 ) = RKI(    51 ) * YC(  PNA ) * YC(  OH )
      RXRAT(     52 ) = RKI(    52 ) * YC(  SO2 ) * YC(  OH )
      RXRAT(     53 ) = RKI(    53 ) * YC(  C2O3 ) * YC(  NO )
!     RXRAT(     54 ) = RKI(    54 ) * YC(  C2O3 ) * YC(  NO2 )
      RXRAT(     55 ) = RKI(    55 ) * YC(  PAN )
      RXRAT(     56 ) = RKI(    56 ) * YC(  PAN )
      RXRAT(     57 ) = RKI(    57 ) * YC(  C2O3 ) * YC(  HO2 )
      RXRAT(     58 ) = RKI(    58 ) * YC(  C2O3 ) * YC(  RO2 )
      RXRAT(     59 ) = RKI(    59 ) * YC(  C2O3 ) * YC(  C2O3 )
      RXRAT(     60 ) = RKI(    60 ) * YC(  C2O3 ) * YC(  CXO3 )
      RXRAT(     61 ) = RKI(    61 ) * YC(  CXO3 ) * YC(  NO )
      RXRAT(     62 ) = RKI(    62 ) * YC(  CXO3 ) * YC(  NO2 )
      RXRAT(     63 ) = RKI(    63 ) * YC(  PANX )
      RXRAT(     64 ) = RKI(    64 ) * YC(  PANX )
      RXRAT(     65 ) = RKI(    65 ) * YC(  CXO3 ) * YC(  HO2 )
      RXRAT(     66 ) = RKI(    66 ) * YC(  CXO3 ) * YC(  RO2 )
      RXRAT(     67 ) = RKI(    67 ) * YC(  CXO3 ) * YC(  CXO3 )
      RXRAT(     68 ) = RKI(    68 ) * YC(  RO2 ) * YC(  NO )
      RXRAT(     69 ) = RKI(    69 ) * YC(  RO2 ) * YC(  HO2 )
      RXRAT(     70 ) = RKI(    70 ) * YC(  RO2 ) * YC(  RO2 )
      RXRAT(     71 ) = RKI(    71 ) * YC(  MEO2 ) * YC(  NO )
      RXRAT(     72 ) = RKI(    72 ) * YC(  MEO2 ) * YC(  HO2 )
      RXRAT(     73 ) = RKI(    73 ) * YC(  MEO2 ) * YC(  C2O3 )
      RXRAT(     74 ) = RKI(    74 ) * YC(  MEO2 ) * YC(  RO2 )
      RXRAT(     75 ) = RKI(    75 ) * YC(  XO2H ) * YC(  NO )
      RXRAT(     76 ) = RKI(    76 ) * YC(  XO2H ) * YC(  HO2 )
      RXRAT(     77 ) = RKI(    77 ) * YC(  XO2H ) * YC(  C2O3 )
      RXRAT(     78 ) = RKI(    78 ) * YC(  XO2H ) * YC(  RO2 )
      RXRAT(     79 ) = RKI(    79 ) * YC(  XO2 ) * YC(  NO )
      RXRAT(     80 ) = RKI(    80 ) * YC(  XO2 ) * YC(  HO2 )
      RXRAT(     81 ) = RKI(    81 ) * YC(  XO2 ) * YC(  C2O3 )
      RXRAT(     82 ) = RKI(    82 ) * YC(  XO2 ) * YC(  RO2 )
      RXRAT(     83 ) = RKI(    83 ) * YC(  XO2N ) * YC(  NO )
      RXRAT(     84 ) = RKI(    84 ) * YC(  XO2N ) * YC(  HO2 )
      RXRAT(     85 ) = RKI(    85 ) * YC(  XO2N ) * YC(  C2O3 )
      RXRAT(     86 ) = RKI(    86 ) * YC(  XO2N ) * YC(  RO2 )
      RXRAT(     87 ) = RKI(    87 ) * YC(  MEPX ) * YC(  OH )
      RXRAT(     88 ) = RKI(    88 ) * YC(  MEPX )
      RXRAT(     89 ) = RKI(    89 ) * YC(  ROOH ) * YC(  OH )
      RXRAT(     90 ) = RKI(    90 ) * YC(  ROOH )
      RXRAT(     91 ) = RKI(    91 ) * YC(  NTR1 ) * YC(  OH )
      RXRAT(     92 ) = RKI(    92 ) * YC(  NTR1 )
      RXRAT(     93 ) = RKI(    93 ) * YC(  FACD ) * YC(  OH )
      RXRAT(     94 ) = RKI(    94 ) * YC(  AACD ) * YC(  OH )
      RXRAT(     95 ) = RKI(    95 ) * YC(  PACD ) * YC(  OH )
      RXRAT(     96 ) = RKI(    96 ) * YC(  FORM ) * YC(  OH )
      RXRAT(     97 ) = RKI(    97 ) * YC(  FORM )
      RXRAT(     98 ) = RKI(    98 ) * YC(  FORM )
      RXRAT(     99 ) = RKI(    99 ) * YC(  FORM ) * YC(  O )
      RXRAT(    100 ) = RKI(   100 ) * YC(  FORM ) * YC(  NO3 )
      RXRAT(    101 ) = RKI(   101 ) * YC(  FORM ) * YC(  HO2 )
      RXRAT(    102 ) = RKI(   102 ) * YC(  HCO3 )
      RXRAT(    103 ) = RKI(   103 ) * YC(  HCO3 ) * YC(  NO )
      RXRAT(    104 ) = RKI(   104 ) * YC(  HCO3 ) * YC(  HO2 )
      RXRAT(    105 ) = RKI(   105 ) * YC(  ALD2 ) * YC(  O )
      RXRAT(    106 ) = RKI(   106 ) * YC(  ALD2 ) * YC(  OH )
      RXRAT(    107 ) = RKI(   107 ) * YC(  ALD2 ) * YC(  NO3 )
      RXRAT(    108 ) = RKI(   108 ) * YC(  ALD2 )
      RXRAT(    109 ) = RKI(   109 ) * YC(  ALDX ) * YC(  O )
      RXRAT(    110 ) = RKI(   110 ) * YC(  ALDX ) * YC(  OH )
      RXRAT(    111 ) = RKI(   111 ) * YC(  ALDX ) * YC(  NO3 )
      RXRAT(    112 ) = RKI(   112 ) * YC(  ALDX )
      RXRAT(    113 ) = RKI(   113 ) * YC(  GLYD ) * YC(  OH )
      RXRAT(    114 ) = RKI(   114 ) * YC(  GLYD )
      RXRAT(    115 ) = RKI(   115 ) * YC(  GLYD ) * YC(  NO3 )
      RXRAT(    116 ) = RKI(   116 ) * YC(  GLY ) * YC(  OH )
      RXRAT(    117 ) = RKI(   117 ) * YC(  GLY )
      RXRAT(    118 ) = RKI(   118 ) * YC(  GLY ) * YC(  NO3 )
      RXRAT(    119 ) = RKI(   119 ) * YC(  MGLY )
      RXRAT(    120 ) = RKI(   120 ) * YC(  MGLY ) * YC(  NO3 )
      RXRAT(    121 ) = RKI(   121 ) * YC(  MGLY ) * YC(  OH )
!     RXRAT(    122 ) = RKI(   122 ) * YC(  OH )
      RXRAT(    123 ) = RKI(   123 ) * YC(  CO ) * YC(  OH )
      RXRAT(    124 ) = RKI(   124 ) * YC(  OH )
      RXRAT(    125 ) = RKI(   125 ) * YC(  ETHA ) * YC(  OH )
      RXRAT(    126 ) = RKI(   126 ) * YC(  MEOH ) * YC(  OH )
      RXRAT(    127 ) = RKI(   127 ) * YC(  ETOH ) * YC(  OH )
      RXRAT(    128 ) = RKI(   128 ) * YC(  KET )
      RXRAT(    129 ) = RKI(   129 ) * YC(  ACET )
      RXRAT(    130 ) = RKI(   130 ) * YC(  ACET ) * YC(  OH )
      RXRAT(    131 ) = RKI(   131 ) * YC(  PRPA ) * YC(  OH )
      RXRAT(    132 ) = RKI(   132 ) * YC(  PAR ) * YC(  OH )
      RXRAT(    133 ) = RKI(   133 ) * YC(  ROR )
      RXRAT(    134 ) = RKI(   134 ) * YC(  ROR )
      RXRAT(    135 ) = RKI(   135 ) * YC(  ROR ) * YC(  NO2 )
      RXRAT(    136 ) = RKI(   136 ) * YC(  ETHY ) * YC(  OH )
      RXRAT(    137 ) = RKI(   137 ) * YC(  ETH ) * YC(  O )
      RXRAT(    138 ) = RKI(   138 ) * YC(  ETH ) * YC(  OH )
      RXRAT(    139 ) = RKI(   139 ) * YC(  ETH ) * YC(  O3 )
      RXRAT(    140 ) = RKI(   140 ) * YC(  ETH ) * YC(  NO3 )
      RXRAT(    141 ) = RKI(   141 ) * YC(  OLE ) * YC(  O )
      RXRAT(    142 ) = RKI(   142 ) * YC(  OLE ) * YC(  OH )
      RXRAT(    143 ) = RKI(   143 ) * YC(  OLE ) * YC(  O3 )
      RXRAT(    144 ) = RKI(   144 ) * YC(  OLE ) * YC(  NO3 )
      RXRAT(    145 ) = RKI(   145 ) * YC(  IOLE ) * YC(  O )
      RXRAT(    146 ) = RKI(   146 ) * YC(  IOLE ) * YC(  OH )
      RXRAT(    147 ) = RKI(   147 ) * YC(  IOLE ) * YC(  O3 )
      RXRAT(    148 ) = RKI(   148 ) * YC(  IOLE ) * YC(  NO3 )
      RXRAT(    149 ) = RKI(   149 ) * YC(  ISOP ) * YC(  OH )
      RXRAT(    150 ) = RKI(   150 ) * YC(  ISOP ) * YC(  O )
      RXRAT(    151 ) = RKI(   151 ) * YC(  ISO2 ) * YC(  NO )
      RXRAT(    152 ) = RKI(   152 ) * YC(  ISO2 ) * YC(  HO2 )
      RXRAT(    153 ) = RKI(   153 ) * YC(  ISO2 ) * YC(  C2O3 )
      RXRAT(    154 ) = RKI(   154 ) * YC(  ISO2 ) * YC(  RO2 )
      RXRAT(    155 ) = RKI(   155 ) * YC(  ISO2 )
      RXRAT(    156 ) = RKI(   156 ) * YC(  ISOP ) * YC(  O3 )
      RXRAT(    157 ) = RKI(   157 ) * YC(  ISOP ) * YC(  NO3 )
      RXRAT(    158 ) = RKI(   158 ) * YC(  ISPD ) * YC(  OH )
      RXRAT(    159 ) = RKI(   159 ) * YC(  ISPD ) * YC(  O3 )
      RXRAT(    160 ) = RKI(   160 ) * YC(  ISPD ) * YC(  NO3 )
      RXRAT(    161 ) = RKI(   161 ) * YC(  ISPD )
      RXRAT(    162 ) = RKI(   162 ) * YC(  ISPX ) * YC(  OH )
      RXRAT(    163 ) = RKI(   163 ) * YC(  HPLD )
      RXRAT(    164 ) = RKI(   164 ) * YC(  HPLD ) * YC(  NO3 )
      RXRAT(    165 ) = RKI(   165 ) * YC(  EPOX ) * YC(  OH )
      RXRAT(    166 ) = RKI(   166 ) * YC(  EPX2 ) * YC(  HO2 )
      RXRAT(    167 ) = RKI(   167 ) * YC(  EPX2 ) * YC(  NO )
      RXRAT(    168 ) = RKI(   168 ) * YC(  EPX2 ) * YC(  C2O3 )
      RXRAT(    169 ) = RKI(   169 ) * YC(  EPX2 ) * YC(  RO2 )
      RXRAT(    170 ) = RKI(   170 ) * YC(  INTR ) * YC(  OH )
      RXRAT(    171 ) = RKI(   171 ) * YC(  TERP ) * YC(  O )
      RXRAT(    172 ) = RKI(   172 ) * YC(  TERP ) * YC(  OH )
      RXRAT(    173 ) = RKI(   173 ) * YC(  TERP ) * YC(  O3 )
      RXRAT(    174 ) = RKI(   174 ) * YC(  TERP ) * YC(  NO3 )
      RXRAT(    175 ) = RKI(   175 ) * YC(  APIN ) * YC(  O )
      RXRAT(    176 ) = RKI(   176 ) * YC(  APIN ) * YC(  OH )
      RXRAT(    177 ) = RKI(   177 ) * YC(  APIN ) * YC(  O3 )
      RXRAT(    178 ) = RKI(   178 ) * YC(  APIN ) * YC(  NO3 )
      RXRAT(    179 ) = RKI(   179 ) * YC(  BENZENE ) * YC(  OH )
      RXRAT(    180 ) = RKI(   180 ) * YC(  BZO2 ) * YC(  NO )
      RXRAT(    181 ) = RKI(   181 ) * YC(  BZO2 ) * YC(  C2O3 )
      RXRAT(    182 ) = RKI(   182 ) * YC(  BZO2 ) * YC(  HO2 )
      RXRAT(    183 ) = RKI(   183 ) * YC(  BZO2 ) * YC(  RO2 )
      RXRAT(    184 ) = RKI(   184 ) * YC(  TOL ) * YC(  OH )
      RXRAT(    185 ) = RKI(   185 ) * YC(  TO2 ) * YC(  NO )
      RXRAT(    186 ) = RKI(   186 ) * YC(  TO2 ) * YC(  C2O3 )
      RXRAT(    187 ) = RKI(   187 ) * YC(  TO2 ) * YC(  HO2 )
      RXRAT(    188 ) = RKI(   188 ) * YC(  TO2 ) * YC(  RO2 )
      RXRAT(    189 ) = RKI(   189 ) * YC(  XYLMN ) * YC(  OH )
      RXRAT(    190 ) = RKI(   190 ) * YC(  NAPH ) * YC(  OH )
      RXRAT(    191 ) = RKI(   191 ) * YC(  XLO2 ) * YC(  NO )
      RXRAT(    192 ) = RKI(   192 ) * YC(  XLO2 ) * YC(  HO2 )
      RXRAT(    193 ) = RKI(   193 ) * YC(  XLO2 ) * YC(  C2O3 )
      RXRAT(    194 ) = RKI(   194 ) * YC(  XLO2 ) * YC(  RO2 )
      RXRAT(    195 ) = RKI(   195 ) * YC(  CRES ) * YC(  OH )
      RXRAT(    196 ) = RKI(   196 ) * YC(  CRES ) * YC(  NO3 )
      RXRAT(    197 ) = RKI(   197 ) * YC(  CRO ) * YC(  NO2 )
      RXRAT(    198 ) = RKI(   198 ) * YC(  CRO ) * YC(  HO2 )
      RXRAT(    199 ) = RKI(   199 ) * YC(  CRON ) * YC(  OH )
      RXRAT(    200 ) = RKI(   200 ) * YC(  CRON ) * YC(  NO3 )
      RXRAT(    201 ) = RKI(   201 ) * YC(  CRON )
      RXRAT(    202 ) = RKI(   202 ) * YC(  XOPN )
      RXRAT(    203 ) = RKI(   203 ) * YC(  XOPN ) * YC(  OH )
      RXRAT(    204 ) = RKI(   204 ) * YC(  XOPN ) * YC(  O3 )
      RXRAT(    205 ) = RKI(   205 ) * YC(  XOPN ) * YC(  NO3 )
      RXRAT(    206 ) = RKI(   206 ) * YC(  OPEN )
      RXRAT(    207 ) = RKI(   207 ) * YC(  OPEN ) * YC(  OH )
      RXRAT(    208 ) = RKI(   208 ) * YC(  OPEN ) * YC(  O3 )
      RXRAT(    209 ) = RKI(   209 ) * YC(  OPEN ) * YC(  NO3 )
      RXRAT(    210 ) = RKI(   210 ) * YC(  CAT1 ) * YC(  OH )
      RXRAT(    211 ) = RKI(   211 ) * YC(  CAT1 ) * YC(  NO3 )
      RXRAT(    212 ) = RKI(   212 ) * YC(  OPO3 ) * YC(  NO )
      RXRAT(    213 ) = RKI(   213 ) * YC(  OPO3 ) * YC(  NO2 )
      RXRAT(    214 ) = RKI(   214 ) * YC(  OPAN )
      RXRAT(    215 ) = RKI(   215 ) * YC(  OPO3 ) * YC(  HO2 )
      RXRAT(    216 ) = RKI(   216 ) * YC(  OPO3 ) * YC(  C2O3 )
      RXRAT(    217 ) = RKI(   217 ) * YC(  OPO3 ) * YC(  RO2 )
      RXRAT(    218 ) = RKI(   218 ) * YC(  OPAN ) * YC(  OH )
      RXRAT(    219 ) = RKI(   219 ) * YC(  PANX ) * YC(  OH )
      RXRAT(    220 ) = RKI(   220 ) * YC(  ECH4 ) * YC(  OH )
      RXRAT(    221 ) = RKI(   221 ) * YC(  XPRP )
      RXRAT(    222 ) = RKI(   222 ) * YC(  XPRP )
      RXRAT(    223 ) = RKI(   223 ) * YC(  XPAR )
      RXRAT(    224 ) = RKI(   224 ) * YC(  XPAR )
      RXRAT(    225 ) = RKI(   225 ) * YC(  CL2 )
      RXRAT(    226 ) = RKI(   226 ) * YC(  HOCL )
      RXRAT(    227 ) = RKI(   227 ) * YC(  CL ) * YC(  O3 )
      RXRAT(    228 ) = RKI(   228 ) * YC(  CLO ) * YC(  CLO )
      RXRAT(    229 ) = RKI(   229 ) * YC(  CLO ) * YC(  NO )
      RXRAT(    230 ) = RKI(   230 ) * YC(  CLO ) * YC(  HO2 )
      RXRAT(    231 ) = RKI(   231 ) * YC(  CLO ) * YC(  MEO2 )
      RXRAT(    232 ) = RKI(   232 ) * YC(  OH ) * YC(  FMCL )
      RXRAT(    233 ) = RKI(   233 ) * YC(  FMCL )
      RXRAT(    234 ) = RKI(   234 ) * YC(  CL )
      RXRAT(    235 ) = RKI(   235 ) * YC(  CL ) * YC(  PAR )
      RXRAT(    236 ) = RKI(   236 ) * YC(  CL ) * YC(  PRPA )
      RXRAT(    237 ) = RKI(   237 ) * YC(  CL ) * YC(  ETHA )
      RXRAT(    238 ) = RKI(   238 ) * YC(  CL ) * YC(  ETH )
      RXRAT(    239 ) = RKI(   239 ) * YC(  CL ) * YC(  OLE )
      RXRAT(    240 ) = RKI(   240 ) * YC(  CL ) * YC(  IOLE )
      RXRAT(    241 ) = RKI(   241 ) * YC(  CL ) * YC(  ISOP )
      RXRAT(    242 ) = RKI(   242 ) * YC(  CL ) * YC(  FORM )
      RXRAT(    243 ) = RKI(   243 ) * YC(  CL ) * YC(  ALD2 )
      RXRAT(    244 ) = RKI(   244 ) * YC(  CL ) * YC(  ALDX )
      RXRAT(    245 ) = RKI(   245 ) * YC(  CL ) * YC(  MEOH )
      RXRAT(    246 ) = RKI(   246 ) * YC(  CL ) * YC(  ETOH )
      RXRAT(    247 ) = RKI(   247 ) * YC(  HCL ) * YC(  OH )
      RXRAT(    248 ) = RKI(   248 ) * YC(  CL ) * YC(  TOL )
      RXRAT(    249 ) = RKI(   249 ) * YC(  CL ) * YC(  XYLMN )
      RXRAT(    250 ) = RKI(   250 ) * YC(  CL ) * YC(  NAPH )
      RXRAT(    251 ) = RKI(   251 ) * YC(  CLNO2 )
      RXRAT(    252 ) = RKI(   252 ) * YC(  CLO ) * YC(  NO2 )
      RXRAT(    253 ) = RKI(   253 ) * YC(  CLNO3 )
      RXRAT(    254 ) = RKI(   254 ) * YC(  CLNO3 )
      RXRAT(    255 ) = RKI(   255 ) * YC(  CLNO3 )
      RXRAT(    256 ) = RKI(   256 ) * YC(  TOLRO2 ) * YC(  NO )
      RXRAT(    257 ) = RKI(   257 ) * YC(  TOLRO2 ) * YC(  HO2 )
      RXRAT(    258 ) = RKI(   258 ) * YC(  XYLRO2 ) * YC(  NO )
      RXRAT(    259 ) = RKI(   259 ) * YC(  XYLRO2 ) * YC(  HO2 )
      RXRAT(    260 ) = RKI(   260 ) * YC(  BENZRO2 ) * YC(  NO )
      RXRAT(    261 ) = RKI(   261 ) * YC(  BENZRO2 ) * YC(  HO2 )
      RXRAT(    262 ) = RKI(   262 ) * YC(  SESQ ) * YC(  O3 )
      RXRAT(    263 ) = RKI(   263 ) * YC(  SESQ ) * YC(  OH )
      RXRAT(    264 ) = RKI(   264 ) * YC(  SESQ ) * YC(  NO3 )
      RXRAT(    265 ) = RKI(   265 ) * YC(  PAHRO2 ) * YC(  NO )
      RXRAT(    266 ) = RKI(   266 ) * YC(  PAHRO2 ) * YC(  HO2 )
      RXRAT(    267 ) = RKI(   267 ) * YC(  SOAALK ) * YC(  OH )
      RXRAT(    268 ) = RKI(   268 ) * YC(  NTR2 )
      RXRAT(    269 ) = RKI(   269 ) * YC(  N2O5 )
      RXRAT(    270 ) = RKI(   270 ) * YC(  N2O5 )
      RXRAT(    271 ) = RKI(   271 ) * YC(  H2NO3PIJ )
      RXRAT(    272 ) = RKI(   272 ) * YC(  H2NO3PK )
      RXRAT(    273 ) = RKI(   273 ) * YC(  H2NO3PIJ ) * YC(  ACLI )
      RXRAT(    274 ) = RKI(   274 ) * YC(  H2NO3PIJ ) * YC(  ACLJ )
      RXRAT(    275 ) = RKI(   275 ) * YC(  H2NO3PK ) * YC(  ACLK )
      RXRAT(    276 ) = RKI(   276 ) * YC(  NO2 )
!     RXRAT(    277 ) = RKI(   277 ) * YC(  O3 )
      RXRAT(    278 ) = RKI(   278 ) * YC(  EPOX )
      RXRAT(    279 ) = RKI(   279 ) * YC(  IEPOXP ) * YC(  ASO4J )
      RXRAT(    280 ) = RKI(   280 ) * YC(  IEPOXP )
      RXRAT(    281 ) = RKI(   281 ) * YC(  GLY )
      RXRAT(    282 ) = RKI(   282 ) * YC(  MGLY )
      RXRAT(    283 ) = RKI(   283 ) * YC(  TERPNRO2 ) * YC(  NO )
      RXRAT(    284 ) = RKI(   284 ) * YC(  TERPNRO2 ) * YC(  HO2 )
      RXRAT(    285 ) = RKI(   285 ) * YC(  TERPNRO2 ) * YC(  NO3 )
      RXRAT(    286 ) = RKI(   286 ) * YC(  TERPNRO2 ) * YC(  RO2 )
      RXRAT(    287 ) = RKI(   287 ) * YC(  MTNO3 ) * YC(  CL )
      RXRAT(    288 ) = RKI(   288 ) * YC(  MTNO3 ) * YC(  OH )
      RXRAT(    289 ) = RKI(   289 ) * YC(  MTNO3 )
      RXRAT(    290 ) = RKI(   290 ) * YC(  AMTNO3J )
      RXRAT(    291 ) = RKI(   291 ) * YC(  AAVB2J )
      RXRAT(    292 ) = RKI(   292 ) * YC(  AAVB3J )
      RXRAT(    293 ) = RKI(   293 ) * YC(  AAVB4J )
      RXRAT(    294 ) = RKI(   294 ) * YC(  AISO1J )
      RXRAT(    295 ) = RKI(   295 ) * YC(  AISO2J )
      RXRAT(    296 ) = RKI(   296 ) * YC(  ASQTJ )
      RXRAT(    297 ) = RKI(   297 ) * YC(  APOCI ) * YC(  OH )
      RXRAT(    298 ) = RKI(   298 ) * YC(  APNCOMI ) * YC(  OH )
      RXRAT(    299 ) = RKI(   299 ) * YC(  APOCJ ) * YC(  OH )
      RXRAT(    300 ) = RKI(   300 ) * YC(  APNCOMJ ) * YC(  OH )
      RXRAT(    301 ) = RKI(   301 ) * YC(  PCVOC ) * YC(  OH )
      RXRAT(    302 ) = RKI(   302 ) * YC(  VLVPO1 ) * YC(  OH )
      RXRAT(    303 ) = RKI(   303 ) * YC(  VSVPO1 ) * YC(  OH )
      RXRAT(    304 ) = RKI(   304 ) * YC(  VSVPO2 ) * YC(  OH )
      RXRAT(    305 ) = RKI(   305 ) * YC(  VSVPO3 ) * YC(  OH )
      RXRAT(    306 ) = RKI(   306 ) * YC(  VIVPO1 ) * YC(  OH )
      RXRAT(    307 ) = RKI(   307 ) * YC(  VLVOO1 ) * YC(  OH )
      RXRAT(    308 ) = RKI(   308 ) * YC(  VLVOO2 ) * YC(  OH )
      RXRAT(    309 ) = RKI(   309 ) * YC(  VSVOO1 ) * YC(  OH )
      RXRAT(    310 ) = RKI(   310 ) * YC(  VSVOO2 ) * YC(  OH )
      RXRAT(    311 ) = RKI(   311 ) * YC(  VSVOO3 ) * YC(  OH )
      RXRAT(    312 ) = RKI(   312 ) * YC(  FORM_PRIMARY ) * YC(  OH )
      RXRAT(    313 ) = RKI(   313 ) * YC(  FORM_PRIMARY ) * YC(  NO3 )
      RXRAT(    314 ) = RKI(   314 ) * YC(  FORM_PRIMARY ) * YC(  O )
      RXRAT(    315 ) = RKI(   315 ) * YC(  FORM_PRIMARY )
      RXRAT(    316 ) = RKI(   316 ) * YC(  FORM_PRIMARY )
      RXRAT(    317 ) = RKI(   317 ) * YC(  FORM_PRIMARY ) * YC(  CL )
      RXRAT(    318 ) = RKI(   318 ) * YC(  ALD2_PRIMARY ) * YC(  OH )
      RXRAT(    319 ) = RKI(   319 ) * YC(  ALD2_PRIMARY ) * YC(  NO3 )
      RXRAT(    320 ) = RKI(   320 ) * YC(  ALD2_PRIMARY ) * YC(  O )
      RXRAT(    321 ) = RKI(   321 ) * YC(  ALD2_PRIMARY )
      RXRAT(    322 ) = RKI(   322 ) * YC(  ALD2_PRIMARY ) * YC(  CL )
      RXRAT(    323 ) = RKI(   323 ) * YC(  BUTADIENE13 ) * YC(  OH )
      RXRAT(    324 ) = RKI(   324 ) * YC(  BUTADIENE13 ) * YC(  O3 )
      RXRAT(    325 ) = RKI(   325 ) * YC(  BUTADIENE13 ) * YC(  NO3 )
      RXRAT(    326 ) = RKI(   326 ) * YC(  BUTADIENE13 ) * YC(  CL )
      RXRAT(    327 ) = RKI(   327 ) * YC(  ACRO_PRIMARY ) * YC(  OH )
      RXRAT(    328 ) = RKI(   328 ) * YC(  ACRO_PRIMARY ) * YC(  O3 )
      RXRAT(    329 ) = RKI(   329 ) * YC(  ACRO_PRIMARY ) * YC(  NO3 )
      RXRAT(    330 ) = RKI(   330 ) * YC(  ACRO_PRIMARY )
      RXRAT(    331 ) = RKI(   331 ) * YC(  ACRO_PRIMARY ) * YC(  CL )
      RXRAT(    332 ) = RKI(   332 ) * YC(  ACROLEIN ) * YC(  OH )
      RXRAT(    333 ) = RKI(   333 ) * YC(  ACROLEIN ) * YC(  O3 )
      RXRAT(    334 ) = RKI(   334 ) * YC(  ACROLEIN ) * YC(  NO3 )
      RXRAT(    335 ) = RKI(   335 ) * YC(  ACROLEIN )
      RXRAT(    336 ) = RKI(   336 ) * YC(  ACROLEIN ) * YC(  CL )
      RXRAT(    337 ) = RKI(   337 ) * YC(  TOLU ) * YC(  OH )
      RXRAT(    338 ) = RKI(   338 ) * YC(  TOLU ) * YC(  CL )
      RXRAT(    339 ) = RKI(   339 ) * YC(  HG ) * YC(  O3 )
      RXRAT(    340 ) = RKI(   340 ) * YC(  HG ) * YC(  CL2 )
      RXRAT(    341 ) = RKI(   341 ) * YC(  HG ) * YC(  H2O2 )
      RXRAT(    342 ) = RKI(   342 ) * YC(  HG ) * YC(  OH )
      RXRAT(    343 ) = RKI(   343 ) * YC(  HG ) * YC(  CL )


      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

!C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE LTNG_DEFN

!C----------------------------------------------------------------------
!C Function: production of NO from lightning

!C Revision History:
!C   1 Jul 2010 Jeff Young
!C   1 Jan 2011 Rob Pinder: added support for online calculation of 
!C               lightning NO from convective precip and NLDN data
!C  10 Mar 2011 Jeff Young: code revisions
!C  11 Apr 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
!C  11 May 2011 D.Wong: incorporated twoway model implementation
!C   6 May 2013 D.Wong: replaced species name RC with RCA in the twoway model
!C  10 Jun 2013 D.Wong: modified the code to work in the twoway model mode
!C  24 Sep 2013 D.Wong: modified the code to allow finer met data time step
!C                      rather than fixed with one hour data
!C  15 Aug 2016 D.Wong: Replaced MYPE with IO_PE_INCLUSIVE for parallel I/O
!C                      implementation
!C  16 Aug 2016 D.Kang: Updated the lightning NO calculation with NLDN hourly
!C                      data directly and using NLDN-RC log linear relationship,
!C                      completely changing the data input process   
!C   1 Feb 2017 D.Kang: Modify the parameter (linear-log linear regression) scheme 
!C                      to set log-linear when RC is greater than 
!C                      exp(log-intercept), and move the LTNOx
!C                      production rate to environment variable to be set in run script
!C  18 Apr 2017 D. Kang: Make routine compatible with the two-way coupled model
!C  17 Jul 2017 D. Wong: In subroutine GET_LTNG: 
!C                       * implemented a bug fix for determining LASTTIC base on 
!C                         accumulation of time step, TSTEP(2)
!C                       * called SUBHFILE only once to improve code efficiency
!C  13 Jun 2018 D. Kang: Changes to accommodate the twoway WRF-CMAQ coupled model 
!C                       with/without data passing (lightning assimilation and NO emissions)
!C   5 Feb 2019 D. Kang: Changed the Lightning flash variable name (NLDNstrk) and make it 
!C                       consistent with the name (LNT) used in lightning assimilation;
!C                       In the meantime, it still can read the files with old name by 
!C                       defining a LT_NAME variable. A bug fix related to read RC variable
!C                       from met input file is also implemented.
!C  01 Feb 2019 D. Wong: Implemented centralized I/O approach, removed all MY_N clauses
!C  12 Mar 2019 D. Wong: Implemented centralized I/O approach to the twoway portion of the code
!C                       and fixed a bug to handle the output time step is less than 1 hour
!C                       scenario properly
!C  3 Sep 2019 D. Kang: Added to scale factors for the vertical distribution and to make sure 
!C                      the profile is similar to those reported in literature and fixed a bug 
!C                      that was introduced two years ago for generating diagnotic 3D lightning emissions.
!C 4 Feb 2020 D. Kang: Remove the SATLAM function call that is redundant and clean up the code to comply with 
!C                      the implementation of CIO.Though there is no effect when run the model over the continental
!C                      US (Lambert projection), when run over the hemisphere and turning lightning NOx on,
!C                       the run would crash due to uncompatible projection (polar)
!C----------------------------------------------------------------------
      USE RUNTIME_VARS
      USE EMIS_VARS

      IMPLICIT NONE

      REAL,    ALLOCATABLE, SAVE :: VDEMIS_LT( :,:,: )   ! lightning emis

!C lightning emis species name
      CHARACTER( 16 ), PARAMETER :: LTSPC = 'NO'
      
      PUBLIC :: VDEMIS_LT, LTNG_INIT, GET_LTNG, LTSPC
      PRIVATE

!C lightning log linear regression parameters with RC 
      REAL,                 SAVE :: SQUAREKM
      REAL,                 SAVE :: SCL_FACTOR

      INTEGER,              SAVE :: LTLYRS     ! no. of emissions layers
      REAL,    ALLOCATABLE, SAVE :: VDEMIS_DIAG( :,:,: ) ! lightning NO diagnostic
      REAL,    ALLOCATABLE, SAVE :: COLUMN_DIAG( :,: ) ! column total NO

      CHARACTER( 16 ),      SAVE :: RC_NAME       ! RC name: old is RC and CCnew is RCA

!C allocate these if LTNG_FNAME = 'INLINE'
      REAL,    ALLOCATABLE, SAVE :: LTNG_PRSFC     ( :,: ) ! surface pressure
      REAL,    ALLOCATABLE, SAVE :: LTNG_RC        ( :,: ) ! convective rainfall
!C allocate these if LPARAM
      REAL,    ALLOCATABLE, SAVE :: NLDN_STRIKE    ( :,: ) ! Hourly NLDN strike data
      REAL,    ALLOCATABLE, SAVE :: ICCG           ( :,: ) ! intercloud strikes per cloud to ground strike
!C Vertical coord values
      REAL,    ALLOCATABLE, SAVE :: VGLVSLT        ( : )

!C    scenario time/date needed for diagnostic output
      INTEGER,              SAVE :: NTICS = 0 ! no. of substeps within an output tstep
      INTEGER,              SAVE :: MTICS = 0 ! temporary sub for NTICS before it set to 0 
      INTEGER,              SAVE :: LDATE     ! test date to update emissions diag avg
      INTEGER,              SAVE :: LTIME     ! test time to update emissions diag avg
      INTEGER                    :: FTIME     ! Start time to Write to Diagnostic files

      INTEGER,              SAVE :: LT_TSTEP
      INTEGER                    :: LT_TSTEP_F  ! same time step info as LT_TSTEP but in HHMMSS format

      CONTAINS

!C======================================================================
!C Initialize lightning routines

         FUNCTION LTNG_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

         USE GRID_CONF ! horizontal & vertical domain specifications
         USE CGRID_SPCS         ! CGRID mechanism species
         USE UTILIO_DEFN
         USE CENTRALIZED_IO_MODULE, only : RCA_AVAIL, ICCG_SUM, ICCG_WIN,
     &                                     FILE_TSTEP, F_MET, F_LTNG,
     &                                     LT_NAME, FILE_XCELL, FILE_YCELL

#ifdef twoway
         USE twoway_data_module
#endif

         IMPLICIT NONE

!C Includes:
         INCLUDE SUBST_CONST     ! constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

!C Arguments:
         INTEGER :: JDATE, JTIME, TSTEP

         LOGICAL SUCCESS

!C External Functions:
         LOGICAL,     EXTERNAL :: CHKGRID

!C value to start log linear regression  
         CHARACTER( 16 )       :: PNAME = 'LTNG_INIT'
         CHARACTER( 80 )       :: VARDESC   ! env variable description
         CHARACTER( 120 )      :: XMSG = ' '
         REAL                  :: X, Y, VAL
         INTEGER               :: C, R

         LOGICAL LTNGPARAM           ! env var to use lightning NO parameters file
         INTEGER LSPCS               ! no. of lightning species
         INTEGER               :: I, J, K, L, V, STATUS
         INTEGER               :: CJDATE
         CHARACTER( 7 )        :: SJDATE

         LOGICAL OK
         INTEGER               :: SPC

!-----------------------------------------------------------------------

         SUCCESS = .TRUE.

!C Lightning NO production
         IF ( .NOT. LTNG_NO ) RETURN

!C Populate Emissions Species Record
         EM_FILE_SURR( ILTSRM )%LEN = 1
         ALLOCATE( EM_FILE_SURR( ILTSRM )%ARRY ( 1 ) )
         ALLOCATE( EM_FILE_SURR( ILTSRM )%UNITS( 1 ) )
         ALLOCATE( EM_FILE_SURR( ILTSRM )%MW   ( 1 ) )
         ALLOCATE( EM_FILE_SURR( ILTSRM )%USED ( 1 ) )
         ALLOCATE( EM_FILE_SURR( ILTSRM )%CONV ( 1 ) )
         ALLOCATE( EM_FILE_SURR( ILTSRM )%BASIS( 1 ) )
         
         EM_FILE_SURR( ILTSRM )%ARRY  = "NO"
         EM_FILE_SURR( ILTSRM )%UNITS = 'MOLES/S'
         EM_FILE_SURR( ILTSRM )%MW    = 30.0
         EM_FILE_SURR( ILTSRM )%USED  = .FALSE.
         EM_FILE_SURR( ILTSRM )%CONV  = 1.0
         EM_FILE_SURR( ILTSRM )%BASIS = 'MOLE'
 
!C Read in scenario time/date

         WRITE( SJDATE, '(I7)' ) JDATE
         READ( SJDATE, '(4X, I3)' ) CJDATE

!C Is lightning NO production inline, or from a file?
         CALL UPCASE(LTNG_FNAME)
         IF ( LTNG_FNAME .EQ. "INLINE" ) THEN  ! inline lightning NO production
            XMSG = 'Using in-line lightning NO production'
            CALL M3MSG2( XMSG )

#ifdef twoway
           IF (wrf_lightning_assim) THEN
              NLDNSTRIKE = .FALSE.
           END IF
#endif
           IF ( RCA_AVAIL ) THEN
               RC_NAME = 'RCA'
           ELSE
               RC_NAME = 'RC'
           END IF
           IF ( NLDNSTRIKE ) THEN
                  XMSG = 'Using hourly NLDN Strike data'
                  CALL M3MSG2( XMSG )

               LT_TSTEP = TIME2SEC ( FILE_TSTEP(F_LTNG)  )
               LT_TSTEP_F = FILE_TSTEP(F_LTNG) 

            ELSE
                 LT_TSTEP = TIME2SEC ( TSTEP )
                 LT_TSTEP_F = TSTEP 
                 XMSG = 'Using derived parameters for KF scheme '
                 CALL M3MSG2( XMSG )
            END IF  !END if NLDNSTRIKE

!            LT_TSTEP_F = SEC2TIME (LT_TSTEP)

            SQUAREKM = REAL( ( XCELL_GD * YCELL_GD * 1.0D-6 ), 4 )
!C Set up vertical layers
            ALLOCATE( VGLVSLT( 0:EMLAYS ), STAT = STATUS )
            CALL CHECKMEM( STATUS, 'VGLVSLT', PNAME )

            ALLOCATE( ICCG        ( NCOLS,NROWS ),
     &                   LTNG_PRSFC  ( NCOLS,NROWS ),
     &                   NLDN_STRIKE ( NCOLS,NROWS ),
     &                   LTNG_RC     ( NCOLS,NROWS ),STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = 'ICCG, OCEAN_MASK, LTNG_Parameters'
     &                 // '  memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               IF ( CJDATE .GT. 90 .AND. CJDATE .LT. 274 ) THEN
                  ICCG = ICCG_SUM
               ELSE
                  ICCG = ICCG_WIN
               END IF
!            END IF  !LPARAM
!C Store local layer information
            DO L = EMLAYS, 0, -1
                  VGLVSLT( L ) = VGLVS_GD( L+1 )
!                  WRITE( LOGDEV,'(5X, A, I3, A, F11.7)' ) 'VGLVSLT(', L, ' ):', VGLVSLT( L )
            END DO


            LDATE = STDATE; LTIME = STTIME
            IF ( LTNGDIAG ) THEN
!C Build description for, and open lightning diagnostic file
!C (all but variables-table and horizontal domain in description is borrowed from MNAME)
               FTIME = STTIME
               CALL NEXTIME( LDATE, FTIME, TSTEP )
               SDATE3D = LDATE
               STIME3D = FTIME
               TSTEP3D = TSTEP

               FTYPE3D = GRDDED3
               NCOLS3D = GL_NCOLS
               NROWS3D = GL_NROWS
               NTHIK3D = 1
               GDTYP3D = GDTYP_GD
               P_ALP3D = P_ALP_GD
               P_BET3D = P_BET_GD
               P_GAM3D = P_GAM_GD
               XORIG3D = XORIG_GD
               YORIG3D = YORIG_GD
               XCENT3D = XCENT_GD
               YCENT3D = YCENT_GD
               XCELL3D = XCELL_GD
               YCELL3D = YCELL_GD
               VGTYP3D = VGTYP_GD
               VGTOP3D = VGTOP_GD
               GDNAM3D = GRID_NAME  ! from HGRD_DEFN

               NLAYS3D = EMLAYS
               DO L = 1, NLAYS3D + 1
                  VGLVS3D( L ) = VGLVS_GD( L )
               END DO

               NVARS3D = 1
               VNAME3D( 1 ) = LTSPC
               VDESC3D( 1 ) = 'hourly average NO produced from lightning'
               VTYPE3D( 1 ) = M3REAL
               UNITS3D( 1 ) = 'mol s-1'

               FDESC3D = ' '   ! array assignment
               FDESC3D( 1 ) = 'Gridded lightning NO production from CMAQ'
               FDESC3D( 2 ) = '/from/ ' // PNAME
               FDESC3D( 3 ) = '/Version/ CMAQ'

!C Open output file (mol s-1)
               IF ( IO_PE_INCLUSIVE ) THEN
                  IF ( .NOT. OPEN3( CTM_LTNGDIAG_1, FSUNKN3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM( CTM_LTNGDIAG_1 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF
                  NLAYS3D = 1
                  VDESC3D( 1 ) = 'Column NO produced from lightning'
                  IF ( .NOT. OPEN3( CTM_LTNGDIAG_2, FSUNKN3, PNAME ) ) THEN
                     XMSG = 'Could not open ' // TRIM( CTM_LTNGDIAG_2 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                  END IF

               END IF

               ALLOCATE( VDEMIS_DIAG( NCOLS,NROWS,EMLAYS ), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = 'VDEMIS_DIAG memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               VDEMIS_DIAG = 0.0   ! array assignment
               ALLOCATE( COLUMN_DIAG( NCOLS,NROWS), STAT = STATUS )
               IF ( STATUS .NE. 0 ) THEN
                  XMSG = 'COLUMN_DIAG memory allocation failed'
                  CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               COLUMN_DIAG = 0.0   ! array assignment
            END IF   ! LTNGDIAG
         ELSE   ! lightning emissions off line

!C Lightning NO production from an input file
            CALL M3MSG2( 'Using lightning NO production from a file' )

!C Check grid definition (intialize, if first call)
            OK = CHKGRID( LTNG_FNAME )


         END IF   ! IF ( LTNG_FNAME .EQ. "INLINE" ) inline or offline lightning NO production

         LTLYRS = EMLAYS

!C Build Emissions Buffer
         ALLOCATE( VDEMIS_LT( NCOLS,NROWS,LTLYRS ), STAT = STATUS )
         IF ( STATUS .NE. 0 ) THEN
            XMSG = 'VDEMIS_LT memory allocation failed'
            CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
 
!         RETURN

         END FUNCTION LTNG_INIT

!C======================================================================
!C Get NO produced from lightning in VDEMIS_LT

         SUBROUTINE GET_LTNG ( JDATE, JTIME, TSTEP )

         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE UTILIO_DEFN
         USE CENTRALIZED_IO_MODULE, only : interpolate_var,
     &                                     OCEAN_MASK,
     &                                     SLOPE,
     &                                     INTERCEPT,
     &                                     SLOPE_lg,
     &                                     INTERCEPT_lg,
     &                                     ICCG_SUM,
     &                                     ICCG_WIN,
     &                                     LT_NAME
#ifdef twoway
         USE twoway_data_module
#endif
         IMPLICIT NONE

         INCLUDE SUBST_CONST     ! constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

         INTEGER JDATE, JTIME, TSTEP( 3 )
         INTEGER STATUS

         REAL,   PARAMETER :: CONVPA = 1.0E-2  ! convert Pa to hPa
!        REAL,   PARAMETER :: WK = 8.0         ! shape parameter for weibull distribution
!        REAL,   PARAMETER :: WLAMBDA = 700.0  ! scale parameter for weibull distribution
         REAL,   PARAMETER :: WMU = 350.0      ! mean
         REAL,   PARAMETER :: WSIGMA = 200.0   ! standard deviation
         REAL,   PARAMETER :: W2MU = 600.0     ! mean
         REAL,   PARAMETER :: W2SIGMA = 50.0   ! standard deviation
         REAL,   PARAMETER :: SQRT2 = 1.414213562731
         REAL,   PARAMETER :: SFACTOR1 = 0.95  ! the scaling factor for the wider distribution (WMU350)
         REAL,   PARAMETER :: SFACTOR2 = 0.12  ! the scaling factor for the wider distribution (WMU350

         INTEGER COL, ROW, LAY ! iterator variables

         REAL    PCALC    ! pressure level for NO vertical distribution (hPa)
         REAL    BOTTOM   ! pressure at bottom of grid cell (hPa)
         REAL    TOP      ! pressure at top of grid cell (hPa)        
         REAL    BOTTOM_FRAC, TOP_FRAC ! their difference is the fraction of lightning NO in this grid cell
         REAL    BOTTOM_FRAC2, TOP_FRAC2
         REAL    SUM_FRAC ! stores the sum of vertical fractions to re-normalize the column
         REAL    WEIGHT ! used to normalize emissions to total amount
         REAL    inErfB, inErfT !  nputs to error funciton calculation
         REAL    outErfB, outErfT ! outputs from error funciton calculation
         REAL :: LTEMIS( LTLYRS )
         REAL    XCELLR, YCELLR   ! cell spacing ratio to 36Km
         REAL    FLASH_FAC        ! lightning flashes factor

         LOGICAL,     SAVE :: LASTTIC   ! true: last sync step this output tstep
         REAL              :: DIVFAC   ! averaging factor for diagnostic file

         CHARACTER( 16 )   :: MNAME
         CHARACTER( 16 )   :: PNAME = 'GET_LTNG'
         CHARACTER( 120 )  :: XMSG = ' '
         REAL, ALLOCATABLE :: COLUMN_LTNG_NO ( :,: ) ! column total NO
         
         INTEGER           :: cjdate
         INTEGER           :: DTSTEP
         CHARACTER( 7 )    :: SJDATE

         LOGICAL,     SAVE :: R_READY = .TRUE.
         LOGICAL,     SAVE :: wrf_assim = .FALSE.
         INTEGER,     SAVE :: TOT_TSTEP
         LOGICAL,     SAVE :: FIRSTIME = .TRUE.

C statement function for ERF approximation
         REAL              :: ERF                ! ERF approx. statement function
         REAL              :: X                  ! dummy argument for ERF
         ERF( X ) = SIGN( 1.0, X ) * SQRT( 1.0 - EXP( -4.0 * X * X / PI ) )
!-----------------------------------------------------------------------
         
         CALL UPCASE(LTNG_FNAME)
         IF ( LTNG_FNAME .EQ. "INLINE" ) THEN
!C case of inline lightning NO production
!C initialize output array
            VDEMIS_LT = 0.0

            DTSTEP = TIME2SEC( TSTEP( 1 ) ) / TIME2SEC( TSTEP( 2 ) ) 
            !C Open me filet
!C Get domain window info for met_cro_2d file
            IF (FIRSTIME) THEN
                TOT_TSTEP = 0
                FIRSTIME = .FALSE.
            END IF
            WRITE( SJDATE, '(I7)') JDATE
            READ( SJDATE, '(4X, I3)') CJDATE

!C read in the hourly lightning strike file
#ifdef twoway
            IF(wrf_lightning_assim) THEN
              call interpolate_var ('LNT', jdate, jtime, NLDN_STRIKE)
!C Interpret the timestep NLDN_STRIKE value into hourly value
              NLDN_STRIKE = NLDN_STRIKE*60/LT_ASM_DT
               wrf_assim = .TRUE.
!               WRITE(*,*) "Max NLDN_STRIKE = ", MAXVAL(NLDN_STRIKE)
            ELSE
              IF ( .NOT. NLDNSTRIKE ) THEN
                call interpolate_var (RC_NAME, jdate, jtime, LTNG_RC)
!C Interpret the timestep RC value into hourly value
                LTNG_RC = LTNG_RC*DTSTEP
              END IF
            END IF
            call interpolate_var ('PRSFC', jdate, jtime, LTNG_PRSFC)
#else
            IF ( R_READY ) THEN
               IF ( .NOT. NLDNSTRIKE ) THEN
                  call interpolate_var (RC_NAME, ldate, ltime, LTNG_RC)
               END IF
               call interpolate_var ('PRSFC', ldate, ltime, LTNG_PRSFC)

               IF ( .NOT. NLDNSTRIKE ) THEN
                  R_READY = .FALSE.
               END IF
            END IF
#endif

            IF( R_READY ) THEN
               IF ( NLDNSTRIKE ) THEN
                  call interpolate_var (LT_NAME, ldate, ltime, NLDN_STRIKE)
                  R_READY = .FALSE.
               END IF  ! NLDNSTRIKE
            END IF     !R_READY
            ALLOCATE( COLUMN_LTNG_NO( NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
               XMSG = 'COLUMN_LTNG_NO memory allocation failed'
               CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
            END IF
            COLUMN_LTNG_NO( :,: ) = 0.0
!C Iterate over each grid cell and distribute lightning NO vertically
               DO ROW = 1, NROWS
                  DO COL = 1, NCOLS
                     IF ( NLDNSTRIKE .or. wrf_assim ) THEN
                        COLUMN_LTNG_NO( COL,ROW ) =
     &                     ( NLDN_STRIKE( COL,ROW )
     &                       * SQUAREKM     ! NLDN_STRIKE in km-2
     &                       * OCEAN_MASK( COL,ROW ) ! reduce offshore strikes
     &                       * ( MOLSNCG + MOLSNIC * ICCG( COL,ROW ) ) )
     &                       / ( 60.0 * 60.0 ) ! get time units right: emissions are in the unit of moles/s
                     ELSE
                        IF ( LTNG_RC( COL,ROW ) .GT. 0 ) THEN
                           SCL_FACTOR = EXP(INTERCEPT_lg(COL, ROW))
                           IF ( LTNG_RC( COL,ROW ) .GT. SCL_FACTOR .AND. OCEAN_MASK( COL,ROW ) .GT. 0.2 )THEN
                              COLUMN_LTNG_NO( COL,ROW ) =
     &                         ( EXP( SLOPE_LG( COL,ROW ) * LOG( LTNG_RC( COL,ROW ) )
     &                           + INTERCEPT_LG( COL,ROW) )
     &                           * SQUAREKM   ! the relation is built on the unit of flash/km2*hr
     &                           * OCEAN_MASK( COL,ROW ) ! reduce offshore strikes
     &                           * ( MOLSNCG  ! moles N per flash intercloud strikes per cloud-to-ground strike
     &                             + ( MOLSNIC * ICCG( COL,ROW ) ) ) )
     &                         / ( 60.0 * 60.0 )         ! get time units right
                              IF ( COLUMN_LTNG_NO( COL,ROW ) .LT. 0 ) COLUMN_LTNG_NO( COL,ROW ) = 0.0
                           ELSE
                              COLUMN_LTNG_NO( COL,ROW ) =
     &                         ( ( SLOPE( COL,ROW ) * LTNG_RC( COL,ROW ) + INTERCEPT( COL,ROW ) )
     &                           * SQUAREKM   ! the relation is built on flash/km2*hr
     &                           * OCEAN_MASK( COL,ROW ) ! reduce offshore strikes
     &                           * ( MOLSNCG  ! moles N per flash intercloud strikes per cloud-to-ground strike
     &                             + ( MOLSNIC * ICCG( COL,ROW ) ) ) )
     &                         / ( 60.0 * 60.0 )         ! get time units right 
                              IF ( COLUMN_LTNG_NO( COL,ROW ) .LT. 0 ) COLUMN_LTNG_NO( COL,ROW ) = 0.0
                           END IF
                        ELSE
                           COLUMN_LTNG_NO( COL,ROW ) = 0.0
                        END IF
                     END IF   ! NLDNSTRIKE
                  END DO   ! COL
               END DO   ! ROW

            VDEMIS_LT = 0.0   ! array assignment

            DO ROW = 1, NROWS
               DO COL = 1, NCOLS

!C check to see if there are lightning strikes for this grid cell
!C only calculate lightning for cloud top greater than 6500 meters

                  IF ( COLUMN_LTNG_NO( COL,ROW ) .LE. 0.0 ) CYCLE
                  SUM_FRAC = 0.0
                  LTEMIS = 0.0   ! array assignment

                  DO LAY = 1, LTLYRS

!C Get pressures: Use SIGMA values and surface pres.
!p=sigma*(psfc-ptop)+ptop
                     BOTTOM = ( VGLVSLT( LAY-1 )
     &                      * ( LTNG_PRSFC( COL,ROW ) - VGTOP_GD )
     &                      + VGTOP_GD ) * CONVPA
!                           write( logdev,* ) "bottom: ", bottom
                     TOP    = ( VGLVSLT( LAY )
     &                      * ( LTNG_PRSFC( COL,ROW ) - VGTOP_GD )
     &                      + VGTOP_GD ) * CONVPA

!C Find the bottom and top of each layer, and calculate the fraction 
!C of the column emissions for that layer
!C Use normal distribution, mean = wmu, standard deviation = wsigma
                     inErfB      = ( BOTTOM - WMU ) / ( WSIGMA * SQRT2 )
                     inErfT      = ( TOP - WMU ) / ( WSIGMA * SQRT2 )
                     outErfB     = ERF( inErfB )
                     outErfT     = ERF( inErfT )
                     BOTTOM_FRAC = 0.5 * ( 1.0 + outErfB )
                     TOP_FRAC    = 0.5 * ( 1.0 + outErfT )

!C Find the bottom and top of each layer, and calculate the fraction
!C of the column emissions for that layer
!C use normal distribution, mean = wmu, standard deviation = wsigma
                     inErfB       = ( BOTTOM - W2MU ) / ( W2SIGMA * SQRT2 )
                     inErfT       = ( TOP - W2MU ) / ( W2SIGMA * SQRT2 )
                     outErfB      = ERF( inErfB )
                     outErfT      = ERF( inErfT )
                     BOTTOM_FRAC2 = 0.5 * ( 1.0 + outErfB )
                     TOP_FRAC2    = 0.5 * ( 1.0 + outErfT )

!C Add weighted contribution to this level
                     WEIGHT = ( BOTTOM_FRAC - TOP_FRAC ) * SFACTOR1
     &                      + ( BOTTOM_FRAC2 - TOP_FRAC2 ) * SFACTOR2 

                     LTEMIS( LAY ) = WEIGHT * COLUMN_LTNG_NO( COL,ROW )

!C Sum weights in order to normalize to 1
                     SUM_FRAC = SUM_FRAC + WEIGHT

!C If emissions are less than 0, generate an error message in the log
                     IF ( LTEMIS( LAY ) .LT. 0.0 ) THEN
                        WRITE( LOGDEV,* ) LTEMIS( LAY ),
     &                                    COLUMN_LTNG_NO( COL,ROW ),
     &                                    BOTTOM_FRAC, TOP_FRAC
                        XMSG = '*** Ltng NO emis is less than zero'
                        CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                     END IF

                  END DO   ! end layers loop 

                  DO LAY = 1, LTLYRS
!C Re-normalize, in some cases area under the error function is not 1
                     VDEMIS_LT( COL,ROW,LAY ) = LTEMIS( LAY ) / SUM_FRAC
                  END DO        ! layers renormalized

               END DO   ! columns
            END DO   ! rows

!C Determine the time to read and/or write the hourly files
            NTICS = NTICS + 1
            TOT_TSTEP = TOT_TSTEP + TIME2SEC( TSTEP( 2 ) )
            LASTTIC = TOT_TSTEP .GE. LT_TSTEP
            IF ( LASTTIC ) THEN
               MTICS = NTICS
               NTICS = 0
               TOT_TSTEP = 0
               CALL NEXTIME( LDATE, LTIME, LT_TSTEP_F)
               R_READY = .TRUE.
            END IF

!C Write lightning NO to the diagnostic file
            IF ( LTNGDIAG ) THEN 
               VDEMIS_DIAG = VDEMIS_DIAG + VDEMIS_LT   ! array assignment
               COLUMN_DIAG = COLUMN_DIAG + COLUMN_LTNG_NO
               IF ( LASTTIC ) THEN   ! time to write out
                  DIVFAC = 1.0 / REAL( MTICS, 4 )
                  VDEMIS_DIAG = VDEMIS_DIAG * DIVFAC   ! array assignment
                  COLUMN_DIAG = COLUMN_DIAG*DIVFAC
                  IF ( .NOT. WRITE3( CTM_LTNGDIAG_1, LTSPC, LDATE, LTIME, VDEMIS_DIAG ) )  THEN
                     XMSG = 'Could not write to ' // TRIM( CTM_LTNGDIAG_1 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                  ELSE
                     WRITE( LOGDEV,94040 )
     &                    'Timestep written to', TRIM( CTM_LTNGDIAG_1 ),
     &                    'for date and time', LDATE, LTIME
                  END IF
                  IF ( .NOT. WRITE3( CTM_LTNGDIAG_2, LTSPC, LDATE, LTIME, COLUMN_DIAG ) )  THEN
                     XMSG = 'Could not write to ' // TRIM( CTM_LTNGDIAG_2 )
                     CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT2 )
                  ELSE
                     WRITE( LOGDEV,94040 )
     &                    'Timestep written to', TRIM( CTM_LTNGDIAG_2 ),
     &                    'for date and time', LDATE, LTIME
                  END IF

                  VDEMIS_DIAG = 0.0   ! array assignment
                  COLUMN_DIAG = 0.0
               END IF ! LASTTIC

            END IF  ! diagnostics turned on

         ELSE  ! LTNGO is not "InLine", but instead specifies a file

!C Read in lightning NO production from an input file
            VDEMIS_LT = 0.0   ! array assignment

            call interpolate_var (LTSPC, jdate, jtime, VDEMIS_LT)

         END IF  ! end lightning NO production inline or from a file


         DEALLOCATE( COLUMN_LTNG_NO )


         RETURN

C------------------  Format  Statements   ------------------------------

94040 FORMAT( /5X, 3( A, :, 1X ), I8, ":", I6.6 )
94042 FORMAT( /5X, A, 1X, I8, ":", I6.6, 1X, 1PE13.5 )

         END SUBROUTINE GET_LTNG

      END MODULE LTNG_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!


       SUBROUTINE HRG1( DTC )

C**********************************************************************
C
C  FUNCTION: To solve for the concentration of NO2, NO, O3, and O3P
C            algebraically.
C
C  PRECONDITIONS: For the CB6R3_AE7_AQ mechanism
C
C  KEY SUBROUTINES/FUNCTIONS CALLED: None
C
C  REVISION HISTORY: Created by EBI solver program, May 24, 2019
C
C   18 Jul 14 B.Hutzell: revised to use real(8) variables
C   01 Jun 18 B.Hutzell: replaced steady solution for O1D with backward Euler
C                        approximation. To match conditions where the initial
C                        concentration cannot be neglected.
C**********************************************************************
      USE HRDATA

      IMPLICIT NONE


C..INCLUDES: None


C..ARGUMENTS:
      REAL( 8 ), INTENT( IN ) :: DTC                      ! Time step


C..PARAMETERS: None


C..EXTERNAL FUNCTIONS: NONE


C..SAVED LOCAL VARIABLES:
!     CHARACTER( 16 ), SAVE  :: PNAME = 'HRG1'   ! Prgram Name


C..SCRATCH LOCAL VARIABLES:
      REAL( 8 ) :: O1D_S               ! sum of O1D loss frequencies
      REAL( 8 ) :: O3P_S               ! stoich coeff for O3P from O1D



      REAL( 8 ) :: R1_2                ! production term for NO from NO2
      REAL( 8 ) :: R2_1                ! production term for NO2 from NO
      REAL( 8 ) :: P1, P2, P3, P12     ! production terms for NO, NO2, O3, & O3P
      REAL( 8 ) :: L1, L2, L3, L12     ! loss terms for NO, NO2, O3, O3P
      REAL( 8 ) :: L1_INV, L2_INV,
     &             L3_INV, L12_INV     ! inverse of loss terms

      REAL( 8 ) :: T1, T2, T3, T4, T5  ! intermerdiate terms
      REAL( 8 ) :: F1, F2, F3          ! intermerdiate terms
      REAL( 8 ) :: A, B, C             ! coefficients for quadratic equation
      REAL( 8 ) :: Q, XX, S1, S2       ! intermerdiate terms

      REAL( 8 ) :: RK1, RK2, RK3       ! rate constants

      REAL( 8 ) :: PO3                 ! temp variable for O3

C**********************************************************************


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  O1D Section
c    1) sum of the rate constants for all O1D loss reactions
c    2) get fractional yield of O3P from O1D loss
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      O1D_S =                 RKI(    10 )                         ! O1D=O
     &      +                 RKI(    11 )                         ! O1D=0.2000D+01*OH

      O3P_S =                 RKI(    10 )                         ! O1D=O

      O3P_S  = O3P_S / O1D_S


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  NO Section
c    R1_2 = production of NO from NO2 ( rates of form k[NO2][x] )
c           except NO2+NO3=NO+NO2 (it is treated as if it were NO3=NO )
c    P1 =   remaining NO production terms
c    L1 =   loss of NO (except rxns producing NO2 - they are in R2_1)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      R1_2 =                 RKI(     1 )                         ! NO2=NO+O
     &     +                 RKI(     5 ) * YC ( O            )   ! NO2+O=NO
      R1_2  = R1_2 * DTC


      P1 =                 RXRAT(    28 )      ! NO3=NO
     &   +                 RXRAT(    30 )      ! NO2+NO3=NO+NO2
     &   +                 RXRAT(    42 )      ! HONO+HONO=NO+NO2
     &   +                 RXRAT(    43 )      ! HONO=NO+OH
      P1    = YC0( NO ) + P1 * DTC


      L1 =                 RKI(    40 ) * YC ( OH           )   ! NO+OH=HONO
     &   +                 RKI(    41 ) * YC ( NO2          )   ! NO+NO2=0.2000D+...
     &   +                 RKI(    83 ) * YC ( XO2N         )   ! NO+XO2N=0.5000D+...
     &   +    1.0000D-01 * RKI(   151 ) * YC ( ISO2         )   ! NO+ISO2=0.1000D+...
     &   +    8.2000D-02 * RKI(   180 ) * YC ( BZO2         )   ! NO+BZO2=0.9180D+...
     &   +    1.4000D-01 * RKI(   185 ) * YC ( TO2          )   ! NO+TO2=0.8600D+...
     &   +    1.4000D-01 * RKI(   191 ) * YC ( XLO2         )   ! NO+XLO2=0.8600D+...
      L1    = 1.0D0 + L1 * DTC


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  NO2 Section
c    R2_1 = production of NO2 from NO ( rates of form k[NO][x] )
c            a)  NO+O3=NO2 not included
c            b)  NO+NO3=2NO2 ( 1/2 of NO2 formation rate included )
c            c)  NO3+NO2=NO+NO2 is not included for NO2
c    P2 =  remaining NO2 production terms 
c            a)  NO+O3=NO2 not included
c            b)  NO+NO3=2NO2 (1/2 of NO2 formation rate included )
c    L2 = loss of NO2 (except rxns producing NO2 - they are in R1_2)
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      R2_1 =                 RKI(     4 ) * YC ( O            )   ! NO+O=NO2
     &     +    2.0000D+00 * RKI(    24 ) * YC ( NO           )   ! NO+NO=0.2000D+01*NO2
     &     +                 RKI(    25 ) * YC ( HO2          )   ! NO+HO2=NO2+OH
     &     +                 RKI(    29 ) * YC ( NO3          )   ! NO+NO3=0.2000D+...
     &     +                 RKI(    53 ) * YC ( C2O3         )   ! NO+C2O3=NO2+MEO2+RO2
     &     +                 RKI(    61 ) * YC ( CXO3         )   ! NO+CXO3=NO2+ALD2+...
     &     +                 RKI(    71 ) * YC ( MEO2         )   ! NO+MEO2=NO2+HO2+FORM
     &     +                 RKI(    75 ) * YC ( XO2H         )   ! NO+XO2H=NO2+HO2
     &     +                 RKI(    79 ) * YC ( XO2          )   ! NO+XO2=NO2
     &     +                 RKI(   103 ) * YC ( HCO3         )   ! NO+HCO3=NO2+FACD+HO2
     &     +    9.0000D-01 * RKI(   151 ) * YC ( ISO2         )   ! NO+ISO2=0.9000D+...
     &     +                 RKI(   167 ) * YC ( EPX2         )   ! NO+EPX2=NO2+...
     &     +    9.1800D-01 * RKI(   180 ) * YC ( BZO2         )   ! NO+BZO2=0.9180D+...
     &     +    8.6000D-01 * RKI(   185 ) * YC ( TO2          )   ! NO+TO2=0.8600D+...
     &     +    8.6000D-01 * RKI(   191 ) * YC ( XLO2         )   ! NO+XLO2=0.8600D+...
     &     +                 RKI(   212 ) * YC ( OPO3         )   ! NO+OPO3=NO2+...
     &     +                 RKI(   229 ) * YC ( CLO          )   ! NO+CLO=NO2+CL
      R2_1  = R2_1 * DTC


      P2 =                 RXRAT(    27 )      ! NO3=NO2+O
     &   +                 RXRAT(    29 )      ! NO+NO3=0.2000D+01*NO2
     &   +                 RXRAT(    31 )      ! NO3+O=NO2
     &   +                 RXRAT(    32 )      ! NO3+OH=NO2+HO2
     &   +                 RXRAT(    33 )      ! NO3+HO2=NO2+OH
     &   +                 RXRAT(    34 )      ! NO3+O3=NO2
     &   +    2.0000D+00 * RXRAT(    35 )      ! NO3+NO3=0.2000D+01*NO2
     &   +                 RXRAT(    37 )      ! N2O5=NO2+NO3
     &   +                 RXRAT(    38 )      ! N2O5=NO2+NO3
     &   +                 RXRAT(    42 )      ! HONO+HONO=NO2+NO
     &   +                 RXRAT(    44 )      ! HONO+OH=NO2
     &   +                 RXRAT(    47 )      ! HNO3=NO2+OH
     &   +                 RXRAT(    49 )      ! PNA=NO2+HO2
     &   +    5.9000D-01 * RXRAT(    50 )      ! PNA=0.5900D+00*NO2+...
     &   +                 RXRAT(    51 )      ! PNA+OH=NO2
     &   +                 RXRAT(    55 )      ! PAN=NO2+C2O3
     &   +    6.0000D-01 * RXRAT(    56 )      ! PAN=0.6000D+00*NO2+...
     &   +                 RXRAT(    63 )      ! PANX=NO2+CXO3
     &   +    6.0000D-01 * RXRAT(    64 )      ! PANX=0.6000D+00*NO2+...
     &   +                 RXRAT(    92 )      ! NTR1=NO2
     &   +    5.0000D-01 * RXRAT(   140 )      ! ETH+NO3=0.5000D+...
     &   +    5.0000D-01 * RXRAT(   144 )      ! OLE+NO3=0.5000D+...
     &   +    5.0000D-01 * RXRAT(   148 )      ! IOLE+NO3=0.5000D+...
     &   +    3.5000D-01 * RXRAT(   157 )      ! ISOP+NO3=0.3500D+...
     &   +    1.4200D-01 * RXRAT(   160 )      ! ISPD+NO3=0.1420D+...
     &   +    4.4400D-01 * RXRAT(   170 )      ! INTR+OH=0.4440D+...
     &   +    4.7000D-01 * RXRAT(   174 )      ! TERP+NO3=0.4700D+...
     &   +    4.7000D-01 * RXRAT(   178 )      ! APIN+NO3=0.4700D+...
     &   +    5.0000D-01 * RXRAT(   205 )      ! XOPN+NO3=0.5000D+...
     &   +                 RXRAT(   214 )      ! OPAN=NO2+OPO3
     &   +    5.0000D-01 * RXRAT(   218 )      ! OPAN+OH=0.5000D+...
     &   +                 RXRAT(   219 )      ! PANX+OH=NO2+ALD2
     &   +                 RXRAT(   251 )      ! CLNO2=NO2+CL
     &   +                 RXRAT(   253 )      ! CLNO3=NO2+CLO
      P2 = YC0( NO2 ) + P2 * DTC


      L2 =                 RKI(     6 ) * YC ( O            )   ! NO2+O=NO3
     &   +                 RKI(    26 ) * YC ( O3           )   ! NO2+O3=NO3
     &   +                 RKI(    36 ) * YC ( NO3          )   ! NO2+NO3=N2O5
     &   +                 RKI(    41 ) * YC ( NO           )   ! NO2+NO=0.2000D+...
     &   +                 RKI(    45 ) * YC ( OH           )   ! NO2+OH=HNO3
     &   +                 RKI(    48 ) * YC ( HO2          )   ! NO2+HO2=PNA
     &   +                 RKI(    54 ) * YC ( C2O3         )   ! NO2+C2O3=PAN
     &   +                 RKI(    62 ) * YC ( CXO3         )   ! NO2+CXO3=PANX
     &   +                 RKI(   135 ) * YC ( ROR          )   ! NO2+ROR=NTR1
     &   +                 RKI(   197 ) * YC ( CRO          )   ! NO2+CRO=CRON
     &   +                 RKI(   213 ) * YC ( OPO3         )   ! NO2+OPO3=OPAN
     &   +                 RKI(   252 ) * YC ( CLO          )   ! NO2+CLO=CLNO3
     &   +                 RKI(   276 )                         ! NO2=0.5000D+...
      L2     = 1.0D0 + L2 * DTC


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  O3 Section
c    P3 = production of O3 except O+O2=O3
c    L3 =   loss terms for O3 except NO+O3=NO2
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      P3 =    1.5000D-01 * RXRAT(    57 )      ! C2O3+HO2=0.1500D+...
     &   +    1.5000D-01 * RXRAT(    65 )      ! CXO3+HO2=0.1500D+...
     &   +    1.5000D-01 * RXRAT(   215 )      ! OPO3+HO2=0.1500D+...
      P3 = YC0( O3 ) + P3 * DTC


      L3 =                 RKI(     7 ) * YC ( O            )   ! O3+O=
     &   +                 RKI(     8 )                         ! O3=O
     &   +                 RKI(     9 )                         ! O3=O1D
     &   +                 RKI(    12 ) * YC ( OH           )   ! O3+OH=HO2
     &   +                 RKI(    13 ) * YC ( HO2          )   ! O3+HO2=OH
     &   +                 RKI(    26 ) * YC ( NO2          )   ! O3+NO2=NO3
     &   +                 RKI(    34 ) * YC ( NO3          )   ! O3+NO3=NO2
     &   +                 RKI(   139 ) * YC ( ETH          )   ! O3+ETH=FORM+...
     &   +                 RKI(   143 ) * YC ( OLE          )   ! O3+OLE=0.2950D+...
     &   +                 RKI(   147 ) * YC ( IOLE         )   ! O3+IOLE=0.7320D+...
     &   +                 RKI(   156 ) * YC ( ISOP         )   ! O3+ISOP=0.6000D+...
     &   +                 RKI(   159 ) * YC ( ISPD         )   ! O3+ISPD=0.4000D-...
     &   +                 RKI(   173 ) * YC ( TERP         )   ! O3+TERP=0.5700D+...
     &   +                 RKI(   177 ) * YC ( APIN         )   ! O3+APIN=0.5700D+...
     &   +                 RKI(   204 ) * YC ( XOPN         )   ! O3+XOPN=0.1200D+...
     &   +                 RKI(   208 ) * YC ( OPEN         )   ! O3+OPEN=0.1400D+...
     &   +                 RKI(   227 ) * YC ( CL           )   ! O3+CL=CLO
     &   +                 RKI(   277 )                         ! O3=
      L3    = 1.0D0 + L3 * DTC


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  O3P Section 
c    P12 = production of O3P except NO2+hv=O3P (J1)
c    L12 = loss terms
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      P12 =                 RXRAT(     8 )      ! O3=O
     &    +   O3P_S *       RXRAT(     9 )      ! O3=O1D
     &    +                 RXRAT(    16 )      ! OH+OH=O
     &    +                 RXRAT(    27 )      ! NO3=O+NO2
      P12 = YC0( O ) + P12 * DTC


      L12 =                 RKI(     2 )                         ! O=O3
     &    +                 RKI(     4 ) * YC ( NO           )   ! O+NO=NO2
     &    +                 RKI(     5 ) * YC ( NO2          )   ! O+NO2=NO
     &    +                 RKI(     6 ) * YC ( NO2          )   ! O+NO2=NO3
     &    +                 RKI(     7 ) * YC ( O3           )   ! O+O3=
     &    +                 RKI(    14 ) * YC ( OH           )   ! O+OH=HO2
     &    +                 RKI(    15 ) * YC ( HO2          )   ! O+HO2=OH
     &    +                 RKI(    23 ) * YC ( H2O2         )   ! O+H2O2=OH+HO2
     &    +                 RKI(    31 ) * YC ( NO3          )   ! O+NO3=NO2
     &    +                 RKI(    99 ) * YC ( FORM         )   ! O+FORM=OH+HO2+CO
     &    +                 RKI(   105 ) * YC ( ALD2         )   ! O+ALD2=C2O3+OH
     &    +                 RKI(   109 ) * YC ( ALDX         )   ! O+ALDX=CXO3+OH
     &    +                 RKI(   137 ) * YC ( ETH          )   ! O+ETH=FORM+HO2+CO+...
     &    +                 RKI(   141 ) * YC ( OLE          )   ! O+OLE=0.2000D+00*ALD2+...
     &    +                 RKI(   145 ) * YC ( IOLE         )   ! O+IOLE=0.1240D+...
     &    +                 RKI(   150 ) * YC ( ISOP         )   ! O+ISOP=0.7500D+...
     &    +                 RKI(   171 ) * YC ( TERP         )   ! O+TERP=0.1500D+...
     &    +                 RKI(   175 ) * YC ( APIN         )   ! O+APIN=0.1500D+...
      L12   = 1.0D0 + L12 * DTC

ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Solution section
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

c..compute reciprocal of loss terms
      L1_INV  = 1.0D0 / L1
      L2_INV  = 1.0D0 / L2
      L3_INV  = 1.0D0 / L3
      L12_INV = 1.0D0 / L12

c..compute specific k*delta t terms
      RK1 = RKI(   1 ) * DTC            ! J1    (NO2+hv=NO+O3P)
      RK2 = RKI(   2 ) * DTC            ! J2    (O3P+O2=O3)
      RK3 = RKI(   3 ) * DTC            ! k1_3  (NO+O3=NO2)

c..compute terms that are used to calulate a,b & c
      T1 = RK1  * L2_INV                ! J1   / ( 1.0 + Lno2 * dt )
      T2 = R1_2 * L2_INV                ! r1,2 / ( 1.0 + Lno2 * dt)
      T3 = R2_1 * L1_INV                ! r2,1 / ( 1.0 + Lno  * dt)
      T4 = RK2  * L12_INV               ! J2   / ( 1.0 + Lo3p * dt )
      T5 = T3   * P1 - T2 * P2          ! T3 * Pno - T2 * Pno2

      F1 = 1.0D0 + T2 + T3                ! factor in calculating a & b
      F2 = T1 * T4                      ! factor in calculating a & b
      F3 = L3 * L1 + RK3 * P1           ! (1 + Lo3 * dt) (1 + lno * dt )
                                        ! + k1,3 * dt * Pno

      PO3 = P3 + P12 * T4

      A = RK3 * ( F1  - F2 )

      B = F1 * F3 +  RK3 * ( F2 * ( P2 - P1 ) + PO3 +  T5 )

      C = RK3 * P1 * ( PO3 + P2 * F2 ) + F3 * T5

      Q = -0.5D0 * ( B + SIGN( 1.0D0, B ) * SQRT( B * B - 4.0D0 * A * C ) )

      XX = MAX( Q / A , C / Q  )


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
c  Species solutions
c       [NO]   = ( P1 + x ) / ( 1 + L1 )
c       [NO2]  = ( P2 - x ) / ( 1 + L2 )
c       [O3 ]  = ( P3 + Ko3p->O3 ) / (1 + K1,3 * [NO] + L3 )
c       [O3P]  = ( P12 + J1 * [NO2] ) / ( 1 + L12 )
c       [O1D] = ( yc0(o1d) + Ko3->o1d * [O3] *dtc) / ( 1 + O1D_S*dtc )
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      YCP( NO ) = MAX( 0.0D0, ( P1 + XX ) * L1_INV )

      YCP( NO2 ) = MAX( 0.0D0, ( P2 - XX ) * L2_INV )

      S1 = P12 + RK1 * YCP( NO2 )

      S2 = T4 * S1

      YCP( O3 ) = ( P3 + S2 ) / ( L3 + RK3 * YCP( NO ) )

      YCP( O ) = S1 * L12_INV

      YCP( O1D ) = ( YC0( O1D ) + RKI( 9 ) * YCP( O3 ) * DTC ) 
     &           / ( 1.0D0 + O1D_S * DTC )

      RETURN

      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      module lus_defn
C Land Use/Cover Schema

C Revision History:
C   10 Nov 2011: J.Young - Created
C   10 Dec 2011: J.Young - fix for two-way application (Tanya Spero`s help)
C    2 Feb 2019:  D. Wong - Implemented centralized I/O approach, removed all 
C                           MY_N clauses, with new re-structure of LUS_DEFN, 
C                           most of the data declaration has been moved to 
C                           lus_data_module (model_data_module.f)

      implicit none

      public lus_init
      private

      contains

         function lus_init( jdate, jtime ) result ( success )

         use hgrd_defn           ! horizontal domain specifications
#ifdef twoway
         use twoway_data_module, only : mminlu, num_land_cat
#endif
         use utilio_defn
         use lus_data_module

         implicit none

C Includes:
         include SUBST_FILES_ID  ! file name parameters

         integer, intent( in ) :: jdate      ! current model date, coded YYYYDDD
         integer, intent( in ) :: jtime      ! current model time, coded HHMMSS
         logical :: success

         integer :: gxoff, gyoff             ! global origin offset from file
         integer, save :: strtcol_01, endcol_01, strtrow_01, endrow_01
         integer, save :: strtcol_02, endcol_02, strtrow_02, endrow_02

         character( 16 ) :: ctm_wbdust_beld = 'CTM_WBDUST_BELD'
         character( 16 ) :: pname = 'LUS_INIT'
         character( 128 ) :: vardesc = ' '
         character( 128 ) :: xmsg = ' '
         character( 24 ) :: strg = 'incorrect num_land_cat, '
         real( 8 ) :: tland
         integer i, c, r, err

         success = .true.

         if ( .not. isbeld ) then   ! transform ladut & lut to %
            ladut = 100.0 * ladut   ! array assignment
            lut   = 100.0 * lut     ! array assignment
         end if

C Merge fractional landuse categories into 4 groups for dust transport factors
         select case( dust_land_scheme )

            case( 'BELD3' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,7 )   ! USGS_shrubland
     &                        + lut( c,r,14 )  ! USGS_water
     &                        + lut( c,r,16 )  ! USGS_sprsbarren
     &                        + lut( c,r,18 )  ! USGS_mxtundra
     &                        + lut( c,r,19 )  ! USGS_snowice
C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,6 )   ! USGS_grassland
     &                        + lut( c,r,8 )   ! USGS_shrubgrass
     &                        + lut( c,r,9 )   ! USGS_savanna
     &                        + lut( c,r,17 )  ! USGS_woodtundr
     &                        + lut( c,r,2 )   ! USGS_drycrop
     &                        + lut( c,r,3 )   ! USGS_irrcrop
     &                        + lut( c,r,4 )   ! USGS_cropgrass
     &                        + lut( c,r,5 )   ! USGS_cropwdlnd
C           building surrounding
               uland( c,r,3 ) = lut( c,r,1 )   ! USGS_urban
C           forest surrounding
               uland( c,r,4 ) = lut( c,r,10 )  ! USGS_decidforest
     &                        + lut( c,r,11 )  ! USGS_evbrdleaf
     &                        + lut( c,r,12 )  ! USGS_coniferfor
     &                        + lut( c,r,13 )  ! USGS_mxforest
     &                        + lut( c,r,15 )  ! USGS_wetwoods
     &                        + lut( c,r,20 )  ! FOREST  (dust_lu_2)
            end do
            end do

            case( 'BELD4' )   ! NLCD is national, MODIS is outside U.S.
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,1 )   ! NLCD_11 Open Water
     &                        + lut( c,r,2 )   ! NLCD_12 Perennial Ice/Snow
     &                        + lut( c,r,7 )   ! NLCD_31 Barren Land (Rock/Sand/Clay)
     &                        + lut( c,r,12 )  ! NLCD_51 Dwarf Scrub
     &                        + lut( c,r,13 )  ! NLCD_52 Shrub/Scrub
     &                        + lut( c,r,18 )  ! NLCD_75 Tundra
     &                        + lut( c,r,31 )  ! MODIS_0 water
     &                        + lut( c,r,46 )  ! MODIS_15 permanent snow and ice
     &                        + lut( c,r,47 )  ! MODIS_16 barren or sparsely vegetated
     &                        + lut( c,r,48 )  ! MODIS_17 IGBP water

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,14 )  ! NLCD_71 Grassland/Herbaceous
     &                        + lut( c,r,15 )  ! NLCD_72 Sedge/Herbaceous
     &                        + lut( c,r,16 )  ! NLCD_73 Lichens
     &                        + lut( c,r,17 )  ! NLCD_74 Moss
     &                        + lut( c,r,19 )  ! NLCD_81 Pasture/Hay
     &                        + lut( c,r,20 )  ! NLCD_82 Cultivated Crops
     &                        + lut( c,r,37 )  ! MODIS_6 closed shrublands
     &                        + lut( c,r,38 )  ! MODIS_7 open shrublands
     &                        + lut( c,r,40 )  ! MODIS_9 savannas
     &                        + lut( c,r,41 )  ! MODIS_10 grasslands
     &                        + lut( c,r,43 )  ! MODIS_12 croplands
     &                        + lut( c,r,45 )  ! MODIS_14 cropland / natural vegetation mosaic

C           building surrounding
               uland( c,r,3 ) = lut( c,r,4 )   ! NLCD_22 Developed Low Intensity
     &                        + lut( c,r,5 )   ! NLCD_23 Developed Medium Intensity
     &                        + lut( c,r,6 )   ! NLCD_24 Developed High Intensity
     &                        + lut( c,r,44 )  ! MODIS_13 urban and built up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,9 )   ! NLCD_41 Deciduous Forest
     &                        + lut( c,r,10 )  ! NLCD_42 Evergreen Forest
     &                        + lut( c,r,11 )  ! NLCD_43 Mixed Forest
     &                        + lut( c,r,21 )  ! NLCD_90 Woody Wetlands
     &                        + lut( c,r,22 )  ! NLCD_91 Palustrine Forested Wetland
     &                        + lut( c,r,24 )  ! NLCD_93 Estuarine Forested Wetland
     &                        + lut( c,r,32 )  ! MODIS_1 evergreen needleleaf forest
     &                        + lut( c,r,33 )  ! MODIS_2 evergreen broadleaf forest
     &                        + lut( c,r,34 )  ! MODIS_3 deciduous needleleaf forest
     &                        + lut( c,r,35 )  ! MODIS_4 deciduous broadleaf forest
     &                        + lut( c,r,36 )  ! MODIS_5 mixed forests
     &                        + lut( c,r,39 )  ! MODIS_8 woody savannas
     &                        + lut( c,r,42 )  ! MODIS_11 permanent wetlands

C Not used:
C               3  NLCD_21 Developed Open Space
C               8  NLCD_32 Unconsolidated Shore
C              23  NLCD_92 Palustrine Scrub/Shrub Wetland
C              25  NLCD_94 Estuarine Scrub/Shrub Wetland
C              26  NLCD_95 Emergent Herbaceous Wetlands
C              27  NLCD_96 Palustrine Emergent Wetland
C              28  NLCD_97 Estuarine Emergent Wetland
C              29  NLCD_98 Palustrine Aquatic Bed
C              30  NLCD_99 Estuarine Aquatic Bed
C              49  MODIS_254 unclassified
C              50  MODIS_255 fill value (normally ocean water)

            end do
            end do

            case( 'USGS24' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,8 )   ! Shrubland
     &                        + lut( c,r,16 )  ! Water
     &                        + lut( c,r,19 )  ! Barren or Sparsely Vegetated
     &                        + lut( c,r,22 )  ! Mixed Tundra
     &                        + lut( c,r,23 )  ! Bare Ground Tundra
     &                        + lut( c,r,24 )  ! Snow and Ice

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,2 )   ! Dryland Cropland and Pasture
     &                        + lut( c,r,3 )   ! Irrigated Cropland and Pasture
     &                        + lut( c,r,4 )   ! Mixed Dryland and Irrigated Cropland and Pasture
     &                        + lut( c,r,5 )   ! Cropland-Grassland Mosaic
     &                        + lut( c,r,6 )   ! Cropland-Woodland Mosaic
     &                        + lut( c,r,7 )   ! Grassland
     &                        + lut( c,r,9 )   ! Mixed Shrubland-Grassland
     &                        + lut( c,r,10 )  ! Savannah
     &                        + lut( c,r,17 )  ! Herbaceous Wetland
     &                        + lut( c,r,20 )  ! Herbaceous Tundra

C           building surrounding
               uland( c,r,3 ) = lut( c,r,1 )   ! Urban Land

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,11 )  ! Deciduous Broadleaf Forest
     &                        + lut( c,r,12 )  ! Deciduous Needleleaf Forest
     &                        + lut( c,r,13 )  ! Evergreen Broadleaf Forest
     &                        + lut( c,r,14 )  ! Evergreen Needleleaf Forest
     &                        + lut( c,r,15 )  ! Mixed Forest
     &                        + lut( c,r,18 )  ! Wooded Wetland
     &                        + lut( c,r,21 )  ! Wooded Tundra
            end do
            end do

!           case( 'MODIS' )
!           do r = 1, nrows
!           do c = 1, ncols
!              uland( c,r,1 ) = lut( c,r,> )
!           end do
!           end do

            case( 'NLCD40' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,21 )   ! Open Water
     &                        + lut( c,r,22 )   ! Perennial Ice-Snow
     &                        + lut( c,r,27 )   ! Barren Land (Rock-Sand-Clay)
     &                        + lut( c,r,31 )   ! Dwarf Scrub
     &                        + lut( c,r,32 )   ! Shrub-Scrub
     &                        + lut( c,r,15 )   ! Permanent Snow and Ice
     &                        + lut( c,r,16 )   ! Barren or Sparsely Vegetated
     &                        + lut( c,r,17 )   ! IGBP Water

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,33 )  ! Grassland-Herbaceous
     &                        + lut( c,r,34 )  ! Sedge-Herbaceous
     &                        + lut( c,r,35 )  ! Lichens
     &                        + lut( c,r,36 )  ! Moss
     &                        + lut( c,r,37 )  ! Pasture-Hay
     &                        + lut( c,r,38 )  ! Cultivated Crops
     &                        + lut( c,r,6  )  ! Closed Shrublands
     &                        + lut( c,r,7  )  ! Open Shrublands
     &                        + lut( c,r,9  )  ! Savannas
     &                        + lut( c,r,10 )  ! Grasslands
     &                        + lut( c,r,12 )  ! Croplands
     &                        + lut( c,r,14 )  ! Cropland-Natural Vegetation Mosaic

C           building surrounding
               uland( c,r,3 ) = lut( c,r,24 )   ! Developed Low Intensity
     &                        + lut( c,r,25 )   ! Developed Medium Intensity
     &                        + lut( c,r,26 )   ! Developed High Intensity
     &                        + lut( c,r,13 )   ! Urban and Built Up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,28 )  ! Deciduous Forest
     &                        + lut( c,r,29 )  ! Evergreen Forest
     &                        + lut( c,r,30 )  ! Mixed Forest
     &                        + lut( c,r,39 )  ! Woody Wetlands
     &                        + lut( c,r,40 )  ! Emergent Herbaceous Wetlands
     &                        + lut( c,r,1  )  ! Evergreen Needleleaf Forest
     &                        + lut( c,r,2  )  ! Evergreen Broadleaf Forest
     &                        + lut( c,r,3  )  ! Deciduous Needleleaf Forest
     &                        + lut( c,r,4  )  ! Deciduous Broadleaf Forest
     &                        + lut( c,r,5  )  ! Mixed Forests
     &                        + lut( c,r,8  )  ! Woody Savannas
     &                        + lut( c,r,11 )  ! Permanent Wetlands
            end do
            end do

            case( 'NLCD-MODIS', 'NLCD50' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,1 )   ! Open Water
     &                        + lut( c,r,2 )   ! Perennial Ice-Snow
     &                        + lut( c,r,7 )   ! Barren Land (Rock-Sand-Clay)
     &                        + lut( c,r,12 )  ! Dwarf Scrub
     &                        + lut( c,r,13 )  ! Shrub-Scrub
     &                        + lut( c,r,18 )  ! Tundra
     &                        + lut( c,r,31 )  ! Water
     &                        + lut( c,r,46 )  ! Permanent Snow and Ice
     &                        + lut( c,r,47 )  ! Barren or Sparsely Vegetated
     &                        + lut( c,r,48 )  ! IGBP Water

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,14 )  ! Grassland-Herbaceous
     &                        + lut( c,r,15 )  ! Sedge-Herbaceous
     &                        + lut( c,r,16 )  ! Lichens
     &                        + lut( c,r,17 )  ! Moss
     &                        + lut( c,r,19 )  ! Pasture-Hay
     &                        + lut( c,r,20 )  ! Cultivated Crops
     &                        + lut( c,r,37 )  ! Closed Shrublands
     &                        + lut( c,r,38 )  ! Open Shrublands
     &                        + lut( c,r,40 )  ! Savannas
     &                        + lut( c,r,41 )  ! Grasslands
     &                        + lut( c,r,43 )  ! Croplands
     &                        + lut( c,r,45 )  ! Cropland-Natural Vegetation Mosaic

C           building surrounding
               uland( c,r,3 ) = lut( c,r,4 )   ! Developed Low Intensity
     &                        + lut( c,r,5 )   ! Developed Medium Intensity
     &                        + lut( c,r,6 )   ! Developed High Intensity
     &                        + lut( c,r,44 )  ! Urban and Built Up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,9 )   ! Deciduous Forest
     &                        + lut( c,r,10 )  ! Evergreen Forest
     &                        + lut( c,r,11 )  ! Mixed Forest
     &                        + lut( c,r,21 )  ! Woody Wetlands
     &                        + lut( c,r,22 )  ! Palustrine Forested Wetland
     &                        + lut( c,r,24 )  ! Estuarine Forested Wetland
     &                        + lut( c,r,32 )  ! Evergreen Needleleaf Forest
     &                        + lut( c,r,33 )  ! Evergreen Broadleaf Forest
     &                        + lut( c,r,34 )  ! Deciduous Needleleaf Forest
     &                        + lut( c,r,35 )  ! Deciduous Broadleaf Forest
     &                        + lut( c,r,36 )  ! Mixed Forests
     &                        + lut( c,r,39 )  ! Woody Savannas
     &                        + lut( c,r,42 )  ! Permanent Wetlands
            end do
            end do

            case( 'MODIS_NOAH' )
            do r = 1, nrows
            do c = 1, ncols
C           water & barren surrounding
               uland( c,r,1 ) = lut( c,r,6 )   ! Closed Shrublands
     &                        + lut( c,r,7 )   ! Open Shrublands
     &                        + lut( c,r,15 )  ! Snow and Ice
     &                        + lut( c,r,16 )  ! Barren or Sparsely Vegetated
     &                        + lut( c,r,17 )  ! Water
     &                        + lut( c,r,19 )  ! Mixed Tundra
     &                        + lut( c,r,20 )  ! Barren Tundra

C           grass & crop surrounding
               uland( c,r,2 ) = lut( c,r,8 )   ! Woody Savannas
     &                        + lut( c,r,9 )   ! Savannas
     &                        + lut( c,r,10 )  ! Grasslands
     &                        + lut( c,r,12 )  ! Croplands
     &                        + lut( c,r,14 )  ! Cropland-Natural Vegetation Mosaic
     &                        + lut( c,r,18 )  ! Wooded Tundra

C           building surrounding
               uland( c,r,3 ) = lut( c,r,13 )  ! Urban and Built-Up

C           forest surrounding
               uland( c,r,4 ) = lut( c,r,1 )   ! Evergreen Needleleaf Forest
     &                        + lut( c,r,2 )   ! Evergreen Broadleaf Forest
     &                        + lut( c,r,3 )   ! Deciduous Needleleaf Forest
     &                        + lut( c,r,4 )   ! Deciduous Broadleaf Forest
     &                        + lut( c,r,5 )   ! Mixed Forests
     &                        + lut( c,r,11 )  ! Permanent Wetlands
            end do
            end do

         end select

         do r = 1, nrows
         do c = 1, ncols

            tland = 0.0d0
            do i = 1, 4
               uland( c,r,i ) = max( 0.0, min( 100.0, uland( c,r,i ) ) )
               tland = tland + real( uland( c,r,i ), 8 )
            end do

            if ( tland .gt. 100.0d0 ) then
#ifdef dbg_wbdust
               write( logdev,* ) ' >>> tland:', c, r, tland
#endif
               do i = 1, 4
                  uland( c,r,i ) = uland( c,r,i ) * real( 100.0d0 / tland, 4 )
               end do
            end if

         end do
         end do

         deallocate( lut )

         return
         end function lus_init

      end module lus_defn

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE DEPV_DEFN

C-----------------------------------------------------------------------
C Function: deposition velocity interface to the chemistry-transport model

C Revision History:
C   24 Nov 2006 J.Young: initial implementation using Bill Hutzell's and
C                        Tanya Otte's work
C   29 Jan 2010 D. Wong: Eliminate potential race condition at the MYPE = 0
C                        to open the diagnostic file. Eliminate the BARRIER
C                        and the CLOSE3 and OPEN3.
C   21 Jun 2010 J.Young: convert for Namelist redesign
C   27 Jan 2011 J.Young: remove references to AERO3 and AERO4
C   20 Jan 2011 J. Bash: Passed the component fluxes and tstep between vdiff 
C                        & m3dry
C   16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C    5 May 2011 J.Young: remove writing diagnostic output for initial call
C   22 Sep 2011 D. Wong: - incorporated twoway model implemenation
C                        - used a robust way to compute WTIME
C   11 Oct 2011 J.Young: PUBLIC/PRIVATE sections, re-do WTIME computation
C                        and WTIME computation for MOSAIC
C   13 Dec 2011 J.Young: removed separate SOA variables - no longer used
C   18 Sep 2012 D. Wong: invoke INIT_LSM regardless of MOSAIC or ABFLUX option
C   07 Jul 14 B.Hutzell: replaced mechanism include file(s) with fortran module
C   7 Nov 2014  J. Bash: Modified for the restructuring of vidff. Moved constants and data to 
C                       ASX_DATA_MOD.
C   Aug 2015 D. Wong:    Replaced MYPE with IO_PE_INCLUSIVE to facilitate
C                          parallel I/O implementation
C                        Added a block of code to let non I/O processors to
C                          open CTM_DEPV_DIAG in parallel I/O implementation
C   1 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                        clauses
C   12 Dec 19 S.L.Napelenok: ddm-3d implementation for version 5.3.1
C   August 2020 J Pleim: Fixed timestep in call to m3dry. Corrects NH3 bidi emis, dep outputs
C-------------------------------------------------------------------------------
      USE RUNTIME_VARS

#ifdef sens
      USE DDM3D_DEFN, ONLY : NP, NPMAX, S_PVD, S_CGRIDL1, S_PLDV
#endif

      IMPLICIT NONE

C model depositon velocites array
      REAL,    ALLOCATABLE, SAVE :: DEPV( :,:,: )

C no. of deposition velocity model species
      INTEGER, SAVE :: N_SPC_DEPV
      INTEGER, SAVE :: N_GAS_DEPV

C ddep spc conversion factors
      REAL,    ALLOCATABLE, SAVE :: DD_CONV( : )

C model-oriented bi-directional production [ppm-m/s]
      REAL,    ALLOCATABLE, SAVE :: PLDV( :,:,: )

C  Dry dep flux of NH3 for bidi [kg/ha hr]
      REAL,    ALLOCATABLE, SAVE :: NH3_EMIS( :,: )

!C flag for mosaic - luc specific deposition - within in-lining depv
!      LOGICAL, SAVE :: MOSAIC = .FALSE.

!C flag for mosaic - luc specific deposition - stomatal flux only - within in-lining depv
!      LOGICAL, SAVE :: FST = .FALSE.      

!      PUBLIC DEPV, DEPVJ, DEPVJ_FST, N_SPC_DEPV, DD_CONV, PLDV, CMP,
!     &             ILDEPV, SFC_HONO, ABFLUX, MOSAIC, FST, N_GAS_DEPV,
!     &             DEPV_INIT, GET_DEPV

      PUBLIC DEPV, N_SPC_DEPV, DD_CONV, PLDV, N_GAS_DEPV,
     &             DEPV_INIT, GET_DEPV, NH3_EMIS
      
      PRIVATE

C gas species (gas-phase and gas non-reactive) deposition velocities
      REAL,    ALLOCATABLE, SAVE :: DEPVEL_GAS( :,:,: )

C m3dry-oriented bi-directional production [ppm-m/s]
      REAL,    ALLOCATABLE, SAVE :: PVD( :,:,: )

C CGRID for m3dry bi-directional flux calculation
      REAL,    ALLOCATABLE, SAVE :: CGRIDL1( :,:,: )

C flag for diagnostic DEPV file
      INTEGER, SAVE                      :: N_UNIQUE_GDEPV   ! gas depv
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: UNIQUE_GDEPV( : )
      INTEGER, ALLOCATABLE, SAVE         :: GAS_DEPV_SUR( : )
      LOGICAL, ALLOCATABLE, SAVE         :: GAS_DEPV_FOUND( : )

      INTEGER, SAVE                      :: N_UNIQUE_ADEPV   ! aero depv
      CHARACTER( 16 ), ALLOCATABLE, SAVE :: UNIQUE_ADEPV( : )
      INTEGER, ALLOCATABLE, SAVE         :: AER_DEPV_SUR( : )

      INTEGER, SAVE :: NR_OFFSET            ! Offset to NR start in CGRID

      REAL,    ALLOCATABLE, SAVE :: ADEPV( :,:,: )    ! Aerosol dep vel from
                                                               ! subroutine AERO_DEPV
      REAL,    ALLOCATABLE, SAVE :: DBUFF( :,: )      ! diagnostic output buffer
      REAL,    ALLOCATABLE, SAVE :: DBUFF3( :,:,: )   ! diagnostic output buffer with 3 dimensions

      REAL,    ALLOCATABLE, SAVE :: UCROSS( :,:,:)
      REAL,    ALLOCATABLE, SAVE :: VCROSS( :,:,:)
      REAL,    ALLOCATABLE, SAVE :: DLUSE( :,: )
      
      CONTAINS

C-----------------------------------------------------------------------
         FUNCTION DEPV_INIT( JDATE, JTIME, TSTEP, CGRID ) RESULT ( SUCCESS )

         USE HGRD_DEFN
         USE RXNS_DATA           ! chemical mechanism data
         USE CGRID_SPCS          ! CGRID mechanism species
         USE DEPVVARS
         USE UTILIO_DEFN
!         USE MOSAIC_MOD, Only: Init_Mosaic
         USE LSM_MOD, Only: Init_LSM !, n_lufrac
         USE BIDI_MOD, Only: Init_Bidi, HgBidi

         IMPLICIT NONE

C Includes:
         INCLUDE SUBST_CONST     ! constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Arguments:
         INTEGER JDATE, JTIME, TSTEP( 3 )
         REAL, POINTER :: CGRID( :,:,:,: )
         LOGICAL SUCCESS

C External Functions:
         INTEGER, EXTERNAL :: FINDEX               ! finds index of a number in a list

C Parameters:
         REAL, PARAMETER :: RGAS1 = 1.0 / RGASUNIV ! univ. gas constant reciprocal
         REAL, PARAMETER :: M2PHA = 1.0E+04        ! 1 hectare = 1.0e4 m**2
         REAL, PARAMETER :: CMLMR = 1.0E+06        ! ppmV/Molar Mixing Ratio
         REAL, PARAMETER :: CNVTD = M2PHA / CMLMR / MWAIR ! combined ddep conv factor
 
C Local variables:
         CHARACTER( 16 ), ALLOCATABLE :: ALL_GAS_DEPV( : )
         LOGICAL, ALLOCATABLE         :: AE_DEPV_FOUND( : )

C variables for deposition velocities diagnostic file
         INTEGER          :: STATUS      ! ENV... status
         CHARACTER( 80 )  :: VARDESC     ! environment variable description

C environment variable for diagnostic DEPV file
         CHARACTER( 16 )  :: CTM_DEPV_FILE = 'CTM_DEPV_FILE'
         
         CHARACTER( 16 )  :: PNAME = 'DEPV_INIT'
         CHARACTER( 120 ) :: XMSG = ' '

         INTEGER          NDX, NDX2, NDX3      ! Temp index
         INTEGER          ALLOCSTAT
         INTEGER          J, L, N, S, V, STRT
         INTEGER, SAVE    :: n_spc_m3dry = ltotg       ! from DEPVVARS module

         INTERFACE
            SUBROUTINE OPDEPV_DIAG ( JDATE, JTIME, TSTEP,
     &                               N_GDEPV_NAMES, GDEPV_NAMES,
     &                               N_ADEPV_NAMES, ADEPV_NAMES )
               INTEGER,         INTENT( IN ) :: JDATE, JTIME, TSTEP
               INTEGER,         INTENT( IN ) :: N_GDEPV_NAMES
               CHARACTER( 16 ), INTENT( IN ) :: GDEPV_NAMES( : )
               INTEGER,         INTENT( IN ) :: N_ADEPV_NAMES
               CHARACTER( 16 ), INTENT( IN ) :: ADEPV_NAMES( : )
            END SUBROUTINE OPDEPV_DIAG

            SUBROUTINE GAS_DEPV_MAP ( N_DEPV_NAMES, DEPV_NAMES, DEPV_SUR )
               INTEGER,         INTENT( IN )    :: N_DEPV_NAMES
               CHARACTER( 16 ), INTENT( INOUT ) :: DEPV_NAMES( : )
               INTEGER,         INTENT( OUT )   :: DEPV_SUR( : )
            END SUBROUTINE GAS_DEPV_MAP
         END INTERFACE

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

         N_GAS_DEPV = N_GC_DEPV + N_NR_DEPV + N_TR_DEPV
         N_SPC_DEPV = N_GAS_DEPV + N_AE_DEPV

         ALLOCATE ( DEPV( N_SPC_DEPV+1,NCOLS,NROWS ),
     &              PLDV( N_SPC_DEPV,NCOLS,NROWS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DEPV or PLDV arrays'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

#ifdef sens
         ALLOCATE ( S_PLDV( NPMAX,N_SPC_DEPV,NCOLS,NROWS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating S_PLDV array'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF
         S_PLDV = 0.0   ! array assignment
#endif


C DEPVEL_GAS is used also for non-ILDEPV in the sgtot calculation
         ALLOCATE ( DEPVEL_GAS( N_GAS_DEPV,NCOLS,NROWS ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DEPVEL_GAS array'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

C Initialize deposition velocities for nondeposited species to zero:
C setting DEPV( N_SPC_DEPV+1,C,R ) = 0.0 accounts for dry dep. species names
C as a subset of the vert. diffused species list
         DEPV = 0.0   ! array assignment
         PLDV = 0.0   ! array assignment

         ALLOCATE ( DD_CONV( N_SPC_DEPV+1 ), STAT = ALLOCSTAT )
         IF ( ALLOCSTAT .NE. 0 ) THEN
            XMSG = 'Failure allocating DD_CONV'
            CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
            SUCCESS = .FALSE.; RETURN
         END IF

C set dry dep conversion factor (done here so that vdiff doesn`t need the include files)
         S = 0
         DO V = 1, N_GC_DEPV
            S = S + 1
            DD_CONV( S ) = CNVTD * GC_MOLWT( GC_DEPV_MAP( V ) )
         END DO

         DO V = 1, N_AE_DEPV
            S = S + 1
            IF ( AE_SPC( AE_DEPV_MAP( V ) )( 1:3 ) .EQ. 'NUM' ) THEN
               DD_CONV( S ) = CNVTD * AVO * 1.0E+03    ! --> #/Ha
            ELSE IF ( AE_SPC( AE_DEPV_MAP( V ) )( 1:3 ) .EQ. 'SRF' ) THEN
               DD_CONV( S ) = M2PHA * 1.0E+03 / MWAIR  ! --> M**2/Ha
            ELSE
               DD_CONV( S ) = CNVTD * AE_MOLWT( AE_DEPV_MAP( V ) )
            END IF
         END DO

         DO V = 1, N_NR_DEPV
            S = S + 1
            DD_CONV( S ) = CNVTD * NR_MOLWT( NR_DEPV_MAP( V ) )
         END DO

         DO V = 1, N_TR_DEPV
            S = S + 1
            DD_CONV( S ) = CNVTD * TR_MOLWT( TR_DEPV_MAP( V ) )
         END DO

C Initialize
         IF ( N_AE_DEPV .GT. 0 ) THEN
            ALLOCATE ( ADEPV( N_AE_DEPV,NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ADEPV'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
         END IF

         !IF ( ILDEPV ) THEN
         !
         !   CALL INIT_LSM( JDATE, JTIME )
         !   CALL INIT_BIDI( )
         !END IF   ! in-line depv

         INIT_GAS_DV:
     &   IF ( N_GAS_DEPV .GT. 0 ) THEN

            ALLOCATE ( ALL_GAS_DEPV( N_GAS_DEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating ALL_GAS_DEPV'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            DO V = 1, N_GC_DEPV
               ALL_GAS_DEPV( V ) = GC_DEPV( V )
            END DO
            STRT = N_GC_DEPV
            DO V = 1, N_NR_DEPV
               ALL_GAS_DEPV( V + STRT ) = NR_DEPV( V )
            END DO
            STRT = N_GC_DEPV + N_NR_DEPV
            DO V = 1, N_TR_DEPV
               ALL_GAS_DEPV( V + STRT ) = TR_DEPV( V )
            END DO

C Identify and remove multiple occurrences of gas deposition velocities
            ALLOCATE( GAS_DEPV_FOUND( N_GAS_DEPV ),
     &                GAS_DEPV_SUR  ( N_GAS_DEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating GAS_DEPV_FOUND or GAS_DEPV_SUR'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            GAS_DEPV_FOUND = .FALSE.
            N_UNIQUE_GDEPV = 0

            LOOP_UNIQUE:
     &      DO N = 1, N_GAS_DEPV
               IF ( GAS_DEPV_FOUND( N ) ) CYCLE LOOP_UNIQUE
               DO V = 1, N_GAS_DEPV
                  IF ( ALL_GAS_DEPV( N ) .EQ. ALL_GAS_DEPV( V ) ) THEN
                     IF ( GAS_DEPV_FOUND( V ) ) CYCLE LOOP_UNIQUE
                     N_UNIQUE_GDEPV = N_UNIQUE_GDEPV + 1
                     GAS_DEPV_FOUND( V ) = .TRUE.
                     CYCLE LOOP_UNIQUE
                  END IF
               END DO
            END DO LOOP_UNIQUE

            ALLOCATE( UNIQUE_GDEPV( N_UNIQUE_GDEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating UNIQUE_GDEPV'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

#ifdef Verbose
            write( logdev,* ) ' '
            write( logdev,* ) ' All Gas DEPVs           Requested Gas DEPV'
#endif

            V = 1
            DO N = 1, N_GAS_DEPV
               IF ( GAS_DEPV_FOUND( N ) ) THEN
                  UNIQUE_GDEPV( V ) = ALL_GAS_DEPV( N )
#ifdef Verbose
                  write( logdev,1019 ) n, all_gas_depv( n ), v, unique_gdepv( v )
1019              format( 2x, i5, 1x, a16, 2x, i5, 1x, a16 )
#endif
                  V = V + 1
#ifdef Verbose
               else
                  write( logdev,1019 ) n, all_gas_depv( n ), -1, ' '
#endif
               END IF
            END DO

C Get pointers to model species (GAS_DEPV_SUR)
            CALL GAS_DEPV_MAP ( N_UNIQUE_GDEPV, UNIQUE_GDEPV, GAS_DEPV_SUR )

C Identify and remove multiple occurrences of aerosol deposition velocities

            ALLOCATE( AE_DEPV_FOUND( N_AE_DEPV ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating AE_DEPV_FOUND'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
            AE_DEPV_FOUND = .FALSE.
            N_UNIQUE_ADEPV = 0

            AERO_UNIQUE:
     &      DO N = 1, N_AE_DEPV
               IF ( AE_DEPV_FOUND( N ) ) CYCLE AERO_UNIQUE
               DO V = 1, N_AE_DEPV
                  IF ( AE_DEPV( N ) .EQ. AE_DEPV( V ) ) THEN
                     IF ( AE_DEPV_FOUND( V ) ) CYCLE AERO_UNIQUE
                     N_UNIQUE_ADEPV = N_UNIQUE_ADEPV + 1
                     AE_DEPV_FOUND( V ) = .TRUE.
                     CYCLE AERO_UNIQUE
                  END IF
               END DO
            END DO AERO_UNIQUE

            ALLOCATE( UNIQUE_ADEPV( N_UNIQUE_ADEPV ) )
            ALLOCATE( AER_DEPV_SUR( N_UNIQUE_ADEPV ) )

#ifdef Verbose
            write( logdev,* ) ' '
            write( logdev,* ) ' Requested Aerosol DEPV and pointer'
#endif

            V = 1
            DO N = 1, N_AE_DEPV
               IF ( AE_DEPV_FOUND( N ) ) THEN
                  UNIQUE_ADEPV( V ) = AE_DEPV( N )
                  AER_DEPV_SUR( V ) = N
#ifdef Verbose
                  write( logdev,1021 ) n, v, unique_adepv( v ), aer_depv_sur( v )
1021              format( 2i5, 1x, a16, i5 )
#endif
                  V = V + 1
               END IF
            END DO

#ifdef Verbose
            write( logdev,* ) ' '
#endif

            ALLOCATE ( CGRIDL1( N_GAS_DEPV,NCOLS,NROWS ),
     &                 PVD    ( N_GAS_DEPV,NCOLS,NROWS ), 
     &                 NH3_EMIS( NCOLS,NROWS),STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating CGRIDL1, CMP or PVD arrays'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF
            CGRIDL1 = 0.0   ! array assignment (PVD initalized in m3dry)
            NH3_EMIS = 0.0

#ifdef sens
               ALLOCATE ( S_CGRIDL1( NPMAX,N_GAS_DEPV,NCOLS,NROWS ),
     &                    S_PVD    ( NPMAX,N_GAS_DEPV,NCOLS,NROWS ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating S_CGRIDL1 or S_PVD arrays'
                  CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
                  SUCCESS = .FALSE.; RETURN
               END IF
               S_CGRIDL1 = 0.0
#endif

         END IF INIT_GAS_DV

         WRITE( LOGDEV,'( 5X, A / )' ) 'DEPV_INIT: completed INIT_GAS_DV block '

         IF ( DEPV_DIAG ) THEN

            ALLOCATE ( DBUFF( NCOLS,NROWS ), STAT = ALLOCSTAT )
            IF ( ALLOCSTAT .NE. 0 ) THEN
               XMSG = 'Failure allocating DBUFF'
               CALL M3WARN( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

            IF ( IO_PE_INCLUSIVE ) THEN
               CALL OPDEPV_DIAG ( JDATE, JTIME, TSTEP( 1 ),
     &                            N_UNIQUE_GDEPV, UNIQUE_GDEPV,
     &                            N_UNIQUE_ADEPV, UNIQUE_ADEPV )
            END IF

         END IF

         END FUNCTION DEPV_INIT
C-----------------------------------------------------------------------


         SUBROUTINE GET_DEPV( JDATE, JTIME, TSTEP, CGRID)
C-----------------------------------------------------------------------

         USE HGRD_DEFN
         USE CGRID_SPCS          ! CGRID mechanism species
         USE DEPVVARS
         USE UTILIO_DEFN
         USE ASX_DATA_MOD, Only: GRID_DATA !, MOSAIC_DATA

         IMPLICIT NONE

C Arguments:
         INTEGER, INTENT( IN ) :: JDATE, JTIME     ! simulation date&time, tstep
         INTEGER, INTENT( IN ) :: TSTEP( 3 )       ! time step vector (HHMMSS)
                                                   ! TSTEP(1) = local output step
                                                   ! TSTEP(2) = sciproc sync. step (chem)
                                                   ! TSTEP(3) = twoway model time step w.r.t. wrf time
                                                   !            step and wrf/cmaq call frequency

         REAL, POINTER         :: CGRID( :,:,:,: ) ! concentrations

         INCLUDE SUBST_CONST     ! constants
         INCLUDE SUBST_FILES_ID  ! file name parameters

C Parameters:
         REAL, PARAMETER :: RGAS1 = 1.0 / RGASUNIV ! univ. gas constant reciprocal
         REAL, PARAMETER :: H_VAP = 156.0E+03      ! enthalpy of vaporization (J/mol)
         REAL, PARAMETER :: TREF = 298.0           ! Reference temperature for Cstar
         REAL, PARAMETER :: TREF1 = 1.0 / TREF     ! Reciprocal ref temperature

C Local variables:
         INTEGER          STRT, FINI
         LOGICAL       :: WRITE_TIME     ! write to file flag
         LOGICAL       :: WRITE_TIME_MOS ! write to file flag
         INTEGER, SAVE :: WSTEP = 0      ! local write counter [HHMMSS]
         INTEGER, SAVE :: WSTEP_MOS = 0  ! local write counter [HHMMSS]
         INTEGER       :: CDATE, CTIME   ! step beginning date and time
         INTEGER       :: WDATE, WTIME   ! write date and time
         REAL   DTSEC
         CHARACTER( 16 )  :: PNAME = 'GET_DEPV        '
         CHARACTER( 120 ) :: XMSG = ' '

         INTEGER C, R, N, V, NDX, J

         LOGICAL, SAVE :: FIRSTIME = .TRUE.

#ifdef Verbose
         integer cw, rw
#endif

         INTERFACE
            SUBROUTINE RDDEPV ( JDATE, JTIME, DEPV )
               INTEGER, INTENT( IN )            :: JDATE, JTIME
               REAL, INTENT( OUT )              :: DEPV( :,:,: )
            END SUBROUTINE RDDEPV            
            SUBROUTINE CGRID_DEPV( GAS_DEPV_FOUND, GAS_DEPV_SUR, CGRID, CGRIDL1 )
               LOGICAL, INTENT( IN )  :: GAS_DEPV_FOUND( : )
               INTEGER, INTENT( IN )  :: GAS_DEPV_SUR( : )
               REAL,    POINTER       :: CGRID( :,:,:,: )
               REAL,    INTENT( OUT ) :: CGRIDL1( :,:,: )
            END SUBROUTINE CGRID_DEPV
            SUBROUTINE M3DRY ( JDATE, JTIME, DTSEC, 
     &                         CGRIDL1, DEPVEL_GAS, PVD, NH3_EMIS)
               INTEGER, INTENT( IN )  :: JDATE, JTIME
               REAL,    INTENT( IN )  :: dtsec
               REAL,    INTENT( IN )  :: CGRIDL1( :,:,: )
               REAL,    INTENT( OUT ) :: DEPVEL_GAS( :,:,: ), PVD( :,:,: ),NH3_EMIS(:,:)
            END SUBROUTINE M3DRY
            SUBROUTINE AERO_DEPV ( CGRID, JDATE, JTIME, TSTEP, ADEPV )
               REAL, POINTER          :: CGRID( :,:,:,: )
               INTEGER, INTENT( IN )  :: JDATE, JTIME, TSTEP
               REAL,    INTENT( OUT ) :: ADEPV( :,:,: )
            END SUBROUTINE AERO_DEPV
         END INTERFACE

C-----------------------------------------------------------------------
         DEPV = 0.0         

! Made default for Hg bidi JOB 9/12/11
         CALL CGRID_DEPV( GAS_DEPV_FOUND, GAS_DEPV_SUR, CGRID, CGRIDL1 )

         DTSEC = FLOAT( TIME2SEC( TSTEP( 2 ) ) )
         CALL M3DRY ( JDATE, JTIME, DTSEC, 
     &                CGRIDL1, DEPVEL_GAS, PVD, NH3_EMIS )

#ifdef Verbose
         cw = ncols/2; rw = nrows/2
!        cw = 17; rw = 43
         write( logdev,1033 ) cw, rw
1033     format( /5x, 'Depv diagnostics for my_col, my_row:', i4, ', ', i4
     &           /6x, 'v', 3x, 'n', 1x, 'variable', 10x, 'ndx',
     &            2x, 'depvel_gas', 4x, 'depv', 9x, 'pvd', 10x, 'pldv' )
#endif

         N = 0
         STRT = 1
         FINI = N_GC_DEPV
         DO V = STRT, FINI
            N = N + 1
            NDX = GAS_DEPV_SUR( N )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DEPV( V,C,R ) = GC_DEPV_FAC( N ) * DEPVEL_GAS( NDX,C,R )
                  PLDV( V,C,R ) = PVD( NDX,C,R )
#ifdef sens
                  DO NP = 1, NPMAX
                     S_PLDV( NP,V,C,R ) = S_PVD( NP,NDX,C,R )
                  END DO
#endif
#ifdef Verbose
                  if ( c .eq. cw .and. r .eq. rw ) then
                     write( logdev,1039 ) v, n, gc_depv( n ), ndx,
     &                                    depvel_gas( ndx,c,r ), depv( v,c,r ),
     &                                    pvd( ndx,c,r ), pldv( v,c,r )
1039                 format( 3x, 2i4, 1x, a16, 1x, i3, 4( 1x, 1pe12.4 ) )
                  end if
#endif
               END DO
            END DO

         END DO

         N = 0
         STRT = N_GC_DEPV + N_AE_DEPV + 1
         FINI = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV
         DO V = STRT, FINI
            N = N + 1
            NDX = GAS_DEPV_SUR( N+N_GC_DEPV )
            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DEPV( V,C,R ) = NR_DEPV_FAC( N ) * DEPVEL_GAS( NDX,C,R )
                  PLDV( V,C,R ) = PVD( NDX,C,R )
#ifdef sens
                  DO NP = 1, NPMAX
                     S_PLDV( NP,V,C,R ) = S_PVD( NP,NDX,C,R )
                  END DO
#endif

#ifdef Verbose
                  if ( c == cw .and. r == rw ) then
                     write( logdev,1039 ) v, n, nr_depv( n ), ndx,
     &                                    depvel_gas( ndx,c,r ), depv( v,c,r ),
     &                                    pvd( ndx,c,r ), pldv( v,c,r )
                  end if
#endif
               END DO
            END DO
         END DO

         N = 0
         STRT = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + 1
         FINI = N_GC_DEPV + N_AE_DEPV + N_NR_DEPV + N_TR_DEPV
         DO V = STRT, FINI
            N = N + 1
            NDX = GAS_DEPV_SUR( N + N_GC_DEPV + N_NR_DEPV )

            DO R = 1, NROWS
               DO C = 1, NCOLS
                  DEPV( V,C,R ) = TR_DEPV_FAC( N ) * DEPVEL_GAS( NDX,C,R )
                  PLDV( V,C,R ) = PVD( NDX,C,R )
#ifdef sens
                  DO NP = 1, NPMAX
                     S_PLDV( NP,V,C,R ) = S_PVD( NP,NDX,C,R )
                  END DO
#endif
#ifdef Verbose
                  if ( c == cw .and. r == rw ) then
                     write( logdev,1039 ) v, n, tr_depv( n ), ndx,
     &                                    depvel_gas( ndx,c,r ), depv( v,c,r ),
     &                                    pvd( ndx,c,r ), pldv( v,c,r )
                  end if
#endif
               END DO
            END DO

         END DO      
         
         IF ( N_AE_DEPV .GT. 0 ) THEN
            CALL AERO_DEPV( CGRID, JDATE, JTIME, TSTEP( 1 ), ADEPV )

            STRT = N_GC_DEPV + 1
            FINI = N_GC_DEPV + N_AE_DEPV

            DO R = 1, NROWS
               DO C = 1, NCOLS
                  N = 0
                  DO V = STRT, FINI
                     N = N + 1
                     DEPV( V,C,R ) = AE_DEPV_FAC( N ) * ADEPV( N,C,R )
                  END DO
               END DO
            END DO

         END IF

         IF ( DEPV_DIAG ) THEN

            WRITE_TIME = .FALSE.
            WSTEP = WSTEP + TIME2SEC( TSTEP( 2 ) )
            IF ( WSTEP .GE. TIME2SEC( TSTEP( 1 ) ) ) THEN
               WDATE = JDATE; WTIME = JTIME
               CALL NEXTIME( WDATE, WTIME, TSTEP( 2 ) )
               IF ( .NOT. CURRSTEP( WDATE, WTIME, STDATE, STTIME, TSTEP( 1 ),
     &                              CDATE, CTIME ) ) THEN
                  XMSG = 'Cannot get step date and time'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
               END IF
               WDATE = CDATE; WTIME = CTIME
               WSTEP = 0
               WRITE_TIME = .TRUE.
            END IF

            IF ( WRITE_TIME ) THEN

#ifdef parallel_io
               IF ( FIRSTIME ) THEN
                  FIRSTIME = .FALSE.
                  IF ( DEPV_DIAG ) THEN
                     IF ( .NOT. IO_PE_INCLUSIVE ) THEN
                        IF ( .NOT. OPEN3( CTM_DEPV_DIAG, FSREAD3, PNAME ) ) THEN
                           XMSG = 'Could not open ' // TRIM( CTM_DEPV_DIAG )
                           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
                        END IF
                     END IF
                  END IF

               END IF
#endif

               N = 0
               DO V = 1, N_GC_DEPV
                  N = N + 1

                  IF ( GAS_DEPV_FOUND( N ) ) THEN
                     NDX = GAS_DEPV_SUR( N )

                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           DBUFF( C,R ) = 100.0 * DEPV( N,C,R )   ! cm/sec
                        END DO
                     END DO
                     
                     IF ( .NOT. WRITE3( CTM_DEPV_DIAG, UNIQUE_GDEPV( NDX ),
     &                                  WDATE, WTIME, DBUFF ) ) THEN
                         XMSG = 'Could not write ' // CTM_DEPV_DIAG // ' file'
                         CALL M3EXIT ( PNAME, WDATE, WTIME, XMSG, XSTAT1 )
                     END IF

                  END IF

               END DO

               DO V = 1, N_NR_DEPV
                  N = N + 1

                  IF ( GAS_DEPV_FOUND( N ) ) THEN
                     NDX = GAS_DEPV_SUR( N )

                     DO R = 1, NROWS
                        DO C = 1, NCOLS
                           DBUFF( C,R ) = 100.0 * DEPV( N+N_AE_DEPV,C,R )   ! cm/sec
                        END DO
                     END DO
                     IF ( .NOT. WRITE3( CTM_DEPV_DIAG, UNIQUE_GDEPV( NDX ),
     &                                  WDATE, WTIME, DBUFF ) ) THEN
                         XMSG = 'Could not write ' // CTM_DEPV_DIAG // ' file'
                         CALL M3EXIT ( PNAME, WDATE, WTIME, XMSG, XSTAT1 )
                     END IF

                  END IF

               END DO

               DO N = 1, N_UNIQUE_ADEPV

                  NDX = AER_DEPV_SUR( N )

                  DO R = 1, NROWS
                     DO C = 1, NCOLS
                        DBUFF( C,R ) = 100.0 * ADEPV( NDX,C,R )   ! cm/sec
                     END DO
                  END DO
                  IF ( .NOT. WRITE3( CTM_DEPV_DIAG, UNIQUE_ADEPV( N ),
     &                               WDATE, WTIME, DBUFF ) ) THEN
                      XMSG = 'Could not write ' // CTM_DEPV_DIAG // ' file'
                      CALL M3EXIT ( PNAME, WDATE, WTIME, XMSG, XSTAT1 )
                  END IF

               END DO

            END IF   ! write_time

         END IF   ! DEPV_DIAG

         END SUBROUTINE GET_DEPV

      END MODULE DEPV_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE OPAPMDIAG ( JDATE, JTIME, TSTEP )

C Revision history
C   09 May 16 D. Wong: Initial Implementation
C   19 May 16 D. Wong: renamed ACONC_END_TIME to AVG_FILE_ENDTIME

        USE GRID_CONF           ! horizontal & vertical domain specifications
        USE UTILIO_DEFN
        USE PMDIAG_DATA_MODULE

        IMPLICIT NONE
 
        INCLUDE SUBST_FILES_ID  ! file name parameters

C...Arguments:

        INTEGER, INTENT( IN ) :: JDATE      ! current model date, coded YYYYDDD
        INTEGER, INTENT( IN ) :: JTIME      ! current model time, coded HHMMSS
        INTEGER, INTENT( IN ) :: TSTEP      ! output time step

C...Local variables:

        CHARACTER( 16 ) :: PNAME = 'OPAPMDIAG'
        CHARACTER( 96 ) :: XMSG = ' '

        INTEGER :: L          ! loop induction variables

        INTEGER :: N, V
        INTEGER :: MDATE, MTIME, STATUS
        LOGICAL :: FOUND

C-----------------------------------------------------------------------

! get begin and end level information from environment variable
        IF ( APMDIAG_ZHI .EQ. -1 ) APMDIAG_ZHI = NLAYS
        IF ( APMDIAG_ZLO .LE. 0 .OR. APMDIAG_ZHI .GT. NLAYS ) THEN
           WRITE( XMSG,'( "Layer range", 2I4, " invalid for this model")' )
     &          APMDIAG_ZLO, APMDIAG_ZHI
           CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT3 )
        END IF

! get subset PMDIAG species list
        IF ( N_APMDIAG_SPC .EQ. 0 .OR. APMDIAG_SPC( 1 ) .EQ. 'ALL' ) THEN
           DO L = 1, NUM_PMDIAG_SPC
              VTYPE3D( L ) = PMDIAG_SPC_RECORD( L )%VAR_TYPE
              VNAME3D( L ) = PMDIAG_SPC_RECORD( L )%SPC_NAME
              UNITS3D( L ) = PMDIAG_SPC_RECORD( L )%SPC_UNIT
              VDESC3D( L ) = PMDIAG_SPC_RECORD( L )%SPC_DESC
              A_PMDIAG_SPC_MAP( L ) = 1
           END DO
           NVARS3D = NUM_PMDIAG_SPC 
        ELSE
           A_PMDIAG_SPC_MAP = 0
           DO L = 1, N_APMDIAG_SPC
              FOUND = .FALSE.
              V = 0
              DO WHILE ( ( .NOT. FOUND ) .AND. ( V .LT. NUM_PMDIAG_SPC ) )
                 V = V + 1
                 IF ( APMDIAG_SPC( L ) .EQ. PMDIAG_SPC_RECORD( V )%SPC_NAME ) THEN
                    FOUND = .TRUE.
                 END IF
              END DO
              IF ( FOUND ) THEN
                 A_PMDIAG_SPC_MAP( V ) = 1
                 VTYPE3D( L ) = PMDIAG_SPC_RECORD( V )%VAR_TYPE
                 VNAME3D( L ) = PMDIAG_SPC_RECORD( V )%SPC_NAME
                 UNITS3D( L ) = PMDIAG_SPC_RECORD( V )%SPC_UNIT
                 VDESC3D( L ) = PMDIAG_SPC_RECORD( V )%SPC_DESC
              ELSE
                 WRITE (XMSG, *) ' Warning: Invalid species ', TRIM( APMDIAG_SPC( L ) )
                 CALL M3MESG( XMSG )
              END IF
           END DO
           NVARS3D = N_APMDIAG_SPC 
        END IF

! get end time information from environment variable AVG_FILE_ENDTIME
        IF ( END_TIME ) THEN   ! ending time timestamp
           MDATE = JDATE; MTIME = JTIME
           CALL NEXTIME ( MDATE, MTIME, TSTEP )
        ELSE                   ! beginning time timestamp
           MDATE = JDATE; MTIME = JTIME
        END IF

C Try to open existing file for update

        IF ( IO_PE_INCLUSIVE ) THEN

           IF ( .NOT. OPEN3( CTM_APMDIAG_1, FSRDWR3, PNAME ) ) THEN

              XMSG = 'Could not open ' // CTM_APMDIAG_1 // ' file for update - '
     &                // 'try to open new'
              CALL M3MESG( XMSG )

C Set output file characteristics based on COORD.EXT and open the aerosol
C diagnostic file

              FTYPE3D = GRDDED3
              SDATE3D = MDATE
              STIME3D = MTIME
              TSTEP3D = TSTEP

              NCOLS3D = GL_NCOLS
              NROWS3D = GL_NROWS
              NLAYS3D = APMDIAG_ZHI - APMDIAG_ZLO + 1
              NTHIK3D =     1
              GDTYP3D = GDTYP_GD
              P_ALP3D = P_ALP_GD
              P_BET3D = P_BET_GD 
              P_GAM3D = P_GAM_GD
              XORIG3D = XORIG_GD
              YORIG3D = YORIG_GD
              XCENT3D = XCENT_GD
              YCENT3D = YCENT_GD
              XCELL3D = XCELL_GD
              YCELL3D = YCELL_GD
              VGTYP3D = VGTYP_GD
              VGTOP3D = VGTOP_GD

              DO L = APMDIAG_ZLO, APMDIAG_ZHI + 1
                 VGLVS3D( L ) = VGLVS_GD( L )
              END DO

              GDNAM3D = GRID_NAME  ! from HGRD_DEFN

              FDESC3D( 1 ) = 'aerosol distribution and chemistry parameters'
              DO L = 2, MXDESC3
                 FDESC3D( L ) = ' '
              END DO

C Open the aerosol diagnostic file

              IF ( .NOT. OPEN3( CTM_APMDIAG_1, FSNEW3, PNAME ) ) THEN
                 XMSG = 'Could not create '// CTM_APMDIAG_1 // ' file'
                 CALL M3EXIT ( PNAME, SDATE3D, STIME3D, XMSG, XSTAT1 )
              END IF

           END IF
        END IF

      END SUBROUTINE OPAPMDIAG

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      SUBROUTINE DEFORM ( JDATE, JTIME, DEFORM3D )
      
C-----------------------------------------------------------------------
C Function:
C    Computes wind deformation based on the contravariant horizontal
C    velocity components.
 
C Preconditions:
C    This routine can be used only for conformal map coordinates 
C    in the horizontal.
C    Dates and times should be represented YYYYDDD:HHMMSS.
 
C Subroutines and functions called:
C    INTERP3, M3EXIT, TIME2SEC, SEC2TIME, NEXTIME
      
C Revision history:
C
C    Oct 10, 2000  Initial development (code adapted from hcontvel.F)
C      Daewon Byun and Avi Lacser

C    26 Dec 00 J.Young: GLOBAL_RMAX -> Dave Wong's f90 stenex GLOBAL_MAX
C                       PE_COMM3 -> Dave Wong's f90 stenex COMM
C
C    11 Jan 01 David Wong: -- Introduced two new local variable LOC_UWIND and
C                             LOC_VWIND: because of INTERP3, The file buffer
C                             UWIND, neccessarily does not have dimensions for
C                             a row ghost region. the same is true for VWIND
C                             with respect to a column ghost region.
C                          -- invoked SE_LOOP_INDEX to compute correct loop
C                             index for the local processor
C                          -- corrected communication pattern for DENSJ
C     7 Aug 01 J.Young: dyn alloc - Use HGRD_DEFN; replace INTERP3 with INTERPX
C                       and INTERPB; allocatable arrays
C                       Not developed for other than NTHIK = 1
C    25 MAr 04 G.Hammond: move wind velocity ghost cell updates outside layer
C                         loop. Use SNL "swap3d".
C    31 Jan 05 J.Young: dyn alloc - establish both horizontal & vertical
C                       domain specifications in one module
C    16 Feb 11 S. Roselle: replaced I/O-API include files w/UTILIO_DEFN
C    11 May 11 D.Wong: incorporated twoway model implementation
C    28 Jul 11 David Wong: set REVERT to .false. for twoway model case since
C                          buffered file has only two time steps data
C    29 Nov 17 David Wong: removed all SWAP routines and replaced with SE_COMM
C    01 Feb 19 David Wong: Implemented centralized I/O approach, removed all MY_N
C                          clauses
C-----------------------------------------------------------------------
      
      USE GRID_CONF            ! horizontal & vertical domain specifications
      USE UTILIO_DEFN
#ifdef parallel
      USE SE_MODULES           ! stenex (using SE_GLOBAL_MAX_MODULE, SE_COMM_MODULE)
#else
      USE NOOP_MODULES         ! stenex (using NOOP_GLOBAL_MAX_MODULE, NOOP_COMM_MODULE)
#endif
      use CENTRALIZED_IO_MODULE, only : interpolate_var, window

      IMPLICIT NONE

C Includes:

      INCLUDE SUBST_FILES_ID   ! file name parameters
      INCLUDE SUBST_CONST      ! constants
      INCLUDE SUBST_PE_COMM    ! PE communication displacement and direction
 
C Parameters:

C Arguments:
      
      INTEGER, INTENT( IN )  :: JDATE             ! current model date, coded YYYYDDD
      INTEGER, INTENT( IN )  :: JTIME             ! current model time, coded HHMMSS
      REAL,    INTENT( OUT ) :: DEFORM3D( :,:,: ) ! Wind deformation
      
C Parameters:

C file variables:
      
      REAL      DENSJ_BUF( NCOLS,NROWS,NLAYS ) ! Jacobian * air density
      REAL      DENSJ_BND( NBNDY,NLAYS )       ! boundary Jacobian * air density
 
C External Functions: None
      
C local variables:
      
      LOGICAL, SAVE :: FIRSTIME = .TRUE.

      INTEGER, SAVE :: MLAYS
       
      INTEGER   ROW               ! Row index
      INTEGER   COL               ! Column index
      INTEGER   LVL               ! Layer index
      INTEGER   MDATE             ! mid-advection date
      INTEGER   MTIME             ! mid-advection time
!     INTEGER   STEP              ! advection time step in seconds
      INTEGER, SAVE :: LDATE( 3 ) ! last date for data on file
      INTEGER, SAVE :: LTIME( 3 ) ! last time for data on file
      LOGICAL   REVERT            ! recover last time step if true
      REAL      DJ                ! temporary Jacobian * air density
 
      CHARACTER( 16 ) :: VNAME
      CHARACTER( 16 ) :: PNAME = 'DEFORM'
      CHARACTER( 16 ) :: AMSG
      CHARACTER( 96 ) :: XMSG = ' '
 
C Jacobian * air density
      REAL         DENSJ    ( 0:NCOLS+1,0:NROWS+1,NLAYS )

      REAL         UWIND    (   NCOLS+1,  NROWS+1,NLAYS ) ! ContrVar x1-velocity 
      REAL         LOC_UWIND(   NCOLS+1,0:NROWS+1,NLAYS ) ! local CV x1-velocity 
      REAL         VWIND    (   NCOLS+1,  NROWS+1,NLAYS ) ! ContrVar x2-velocity 
      REAL         LOC_VWIND( 0:NCOLS+1,  NROWS+1,NLAYS ) ! local CV x2-velocity 
      REAL         DUDX     (   NCOLS,    NROWS )
      REAL         DUDY     (   NCOLS,    NROWS )
      REAL         DVDX     (   NCOLS,    NROWS )
      REAL         DVDY     (   NCOLS,    NROWS )
      CHARACTER( 8 ), SAVE :: COMMSTR

      REAL, SAVE :: DX1, DX2       ! X1 & X2 grid size
      REAL, SAVE :: RDX1, RDX2     ! inverse of DX1 & DX2
!     REAL, SAVE :: RDX1O2, RDX2O2 ! half of inverse of DX1 & DX2
      REAL, SAVE :: RDX1O4, RDX2O4 ! quarter of inverse of DX1 & DX2
      REAL    UBAR1, UBAR2         ! U average at X point (Avi)
      REAL    VBAR1, VBAR2         ! V average at X point (Avi)
      REAL    DF1, DF2             ! deformation components
      INTEGER C, R, L              ! notations for COL, ROW, LVL
      INTEGER C1, R1               ! C1 = C+1, R1 = R+1  (Avi)
      INTEGER C2, R2               ! C2 = C-1, R2 = R-1  (Avi)
!     INTEGER C1, R1               ! C1 = MAX(1, C-1), R1 = MAX(1, R-1) (Daewon)
!     INTEGER C2, R2               ! C2 = MIN(C+1, NCOLS), R2 = MIN(R+1, NROWS) (DBX)
      INTEGER COUNT                ! Counter for constructing density array.
      REAL    DEFMAX               ! max deformation (dianostic)

      INTEGER MY_TEMP
      INTEGER, SAVE :: FRSTROW, LASTROW, FRSTCOL, LASTCOL

C-----------------------------------------------------------------------
 
      IF ( FIRSTIME ) THEN
 
         FIRSTIME = .FALSE.

         MLAYS = SIZE ( DEFORM3D,3 )
 
         CALL LSTEPF( MET_CRO_3D, LDATE( 1 ), LTIME( 1 ) )
!        CALL LSTEPF( MET_BDY_3D, LDATE( 2 ), LTIME( 2 ) )
         CALL LSTEPF( MET_DOT_3D, LDATE( 3 ), LTIME( 3 ) )
 
!        LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 2 ), LDATE( 3 ) )
!        LTIME( 1 ) = SEC2TIME( MIN(
!    &                         TIME2SEC( LTIME( 1 ) ),
!    &                         TIME2SEC( LTIME( 2 ) ),
!    &                         TIME2SEC( LTIME( 3 ) )
!    &                         ) )

         LDATE( 1 ) = MIN( LDATE( 1 ), LDATE( 3 ) )
         LTIME( 1 ) = SEC2TIME( MIN(
     &                         TIME2SEC( LTIME( 1 ) ),
     &                         TIME2SEC( LTIME( 3 ) )
     &                         ) )

         WRITE( COMMSTR,'(4I2)' )  1, 0, 2, 0

C Get/compute DX1 & DX2
 
         IF ( GDTYP_GD .EQ. LATGRD3 ) THEN
            DX1 = DG2M * XCELL_GD ! in m.
            DX2 = DG2M * YCELL_GD *
     &         COS( PI180*( YORIG_GD + YCELL_GD * FLOAT( GL_NROWS/2 ))) !in m
         ELSE
            DX1 = XCELL_GD        ! in m.
            DX2 = YCELL_GD        ! in m.
         END IF                                                              

         RDX1 = 1.0 / DX1
         RDX2 = 1.0 / DX2
!        RDX1O2 = 0.5 / DX1
!        RDX2O2 = 0.5 / DX2
         RDX1O4 = 0.25 / DX1
         RDX2O4 = 0.25 / DX2

         CALL SUBST_LOOP_INDEX ( 'R', 2, NROWS, -1, MY_TEMP,
     &                           FRSTROW, LASTROW )
         CALL SUBST_LOOP_INDEX ( 'C', 2, NCOLS, -1, MY_TEMP, 
     &                           FRSTCOL, LASTCOL )

      END IF  ! if firstime
 
      MDATE  = JDATE
      MTIME  = JTIME
!     STEP   = TIME2SEC( TSTEP )
!     CALL NEXTIME( MDATE, MTIME, SEC2TIME( STEP / 2 ) )

#ifdef twoway
      REVERT = .FALSE.
#else
      IF ( MDATE .LT. LDATE( 1 ) ) THEN
         REVERT = .FALSE.
      ELSE IF ( MDATE .EQ. LDATE( 1 ) ) THEN
         IF ( MTIME .LE. LTIME( 1 ) ) THEN
            REVERT = .FALSE.
         ELSE
            REVERT = .TRUE.
         END IF
      ELSE   ! MDATE .GT. LDATE
         REVERT = .TRUE.
      END IF
#endif
 
      IF ( REVERT ) THEN
         XMSG = 'Current scenario interpolation step not available in all of '
     &        // TRIM( MET_CRO_3D ) // ', '
     &        // TRIM( MET_BDY_3D ) // ' and '
     &        // TRIM( MET_DOT_3D )
         CALL M3MESG( XMSG )
!        CALL NEXTIME( MDATE, MTIME, -SEC2TIME( STEP / 2 ) )
         WRITE( AMSG,'( 2I8 )' ) LDATE( 1 ), LTIME( 1 )
         XMSG = 'Using data for last file step: ' // AMSG
         CALL M3MESG( XMSG )
         MDATE = LDATE( 1 )
         MTIME = LTIME( 1 )
      END IF
 
C Interpolate Jacobian X Air Density

      IF ( WINDOW ) THEN

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ)

      ELSE ! need to extend data from bndy file

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BUF)

         call interpolate_var ('DENSA_J', mdate, mtime, DENSJ_BND, 'b')

C Load DENSJ array

         DO LVL = 1, MLAYS
            DO ROW = 1, NROWS
               DO COL = 1, NCOLS
                  DENSJ( COL,ROW,LVL ) = DENSJ_BUF( COL,ROW,LVL )
               END DO
            END DO
         END DO

C Fill in DENSJ array for boundaries

         DO LVL = 1, MLAYS
            COUNT = 0
            DO ROW = 0, 0
               DO COL = 1, NCOLS + 1
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! South
               END DO
            END DO
            DO ROW = 1, NROWS + 1
               DO COL = NCOLS + 1, NCOLS + 1
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! East
               END DO
            END DO
            DO ROW = NROWS + 1, NROWS + 1
               DO COL = 0, NCOLS
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! North
               END DO
            END DO
            DO ROW = 0, NROWS
               DO COL = 0, 0
                  COUNT = COUNT + 1
                  DENSJ( COL,ROW,LVL ) = DENSJ_BND( COUNT,LVL )  ! West
               END DO
            END DO
         END DO

      END IF   ! WINDOW
 
C Interpolate Contravariant Velocity components (already at flux points)
C X Jacobian X Air Density

      call interpolate_var ('UHAT_JD', mdate, mtime, UWIND)

      call interpolate_var ('VHAT_JD', mdate, mtime, VWIND)

C Obtain flux point values of Jacobian * air density and retrieve
C contravariant velocities 

C create U/RhoJ - update ghost regions for RhoJ

      CALL SUBST_COMM ( DENSJ, DSPL_N0_E1_S0_W1, DRCN_E_W, COMMSTR )

      LOC_UWIND = 0.0   ! array assignment
      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS
            DO COL = 1, NCOLS + 1
               DJ = 0.5*( DENSJ( COL,ROW,LVL ) + DENSJ( COL-1,ROW,LVL ) )
               LOC_UWIND( COL,ROW,LVL ) = UWIND( COL,ROW,LVL ) / DJ
            END DO
         END DO
      END DO

C create V/RhoJ - update ghost regions for RhoJ

      CALL SUBST_COMM ( DENSJ, DSPL_N1_E0_S1_W0, DRCN_N_S, COMMSTR )

      LOC_VWIND = 0.0   ! array assignment
      DO LVL = 1, MLAYS
         DO ROW = 1, NROWS + 1
            DO COL = 1, NCOLS
               DJ = 0.5*( DENSJ( COL,ROW,LVL ) + DENSJ( COL,ROW-1,LVL ) )
               LOC_VWIND( COL,ROW,LVL ) = VWIND( COL,ROW,LVL ) / DJ
            END DO
         END DO
      END DO

C Compute wind deformation
 
C initialize deformation arrays
C deformation at all boundary cells are defined to be zero
      DO L = 1, MLAYS
         DO R = 1, NROWS + 1
            DO C = 1, NCOLS + 1
               DEFORM3D( C,R,L ) = 0.0
            END DO
         END DO
      END DO

      CALL SUBST_COMM ( LOC_UWIND, DSPL_N1_E1_S1_W0, DRCN_N_NE_SE_S, '2 0' )

      CALL SUBST_COMM ( LOC_VWIND, DSPL_N1_E1_S0_W1, DRCN_NE_E_W_NW, '1 0' )

      DO 101 L = 1, MLAYS

         DEFMAX = 0.0
C initialize wind shear components (inner domain only dimensioned)
         DO R = 1, NROWS
            DO C = 1, NCOLS
               DUDX( C,R ) = 0.0
               DUDY( C,R ) = 0.0
               DVDX( C,R ) = 0.0
               DVDY( C,R ) = 0.0
            END DO
         END DO

C ORIGINAL by Daewon October 2000
C Compute gradients only at inner domain
!        DO R = 1, NROWS
!           DO C = 1, NCOLS
!              C1 = MAX( 1,C-1 )
!              R1 = MAX( 1,R-1 )
!              C2 = MIN( C+1,NCOLS )
!              R2 = MIN( R+1,NROWS )

!              DUDX( C,R ) = ( UWIND( C,R,L )  - UWIND( C1,R,L ) ) * RDX1
!              DUDY( C,R ) = ( UWIND( C,R2,L ) - UWIND( C,R1,L ) ) * RDX2O2
!              DVDX( C,R ) = ( VWIND( C2,R,L ) - VWIND( C1,R,L ) ) * RDX1O2
!              DVDY( C,R ) = ( VWIND( C,R,L )  - VWIND( C,R1,L ) ) * RDX2
!           END DO
!        END DO

C SUGGESTED by Avi October 2000
C for whole domain (DUDX, DVDY)
         DO R = 1, NROWS
            R1 = R + 1
            DO C = 1, NCOLS
               C1 = C + 1
               DUDX(C,R) = ( LOC_UWIND( C1,R,L ) - LOC_UWIND( C,R,L ) ) * RDX1
               DVDY(C,R) = ( LOC_VWIND( C,R1,L ) - LOC_VWIND( C,R,L ) ) * RDX2
            END DO
         END DO

1003     FORMAT( / '@1@Layer', 4X, 'Max Deform',
     &             5X, 'DUDX(4,5)',
     &             5X, 'DUDY(4,5)',
     &             5X, 'DVDX(4,5)',
     &             5X, 'DVDY(4,5)' )

C for DUDY inside domain (compute the gradient of the averages)
         DO R = FRSTROW, LASTROW
            R1 = R + 1
            R2 = R - 1
            DO C = 1, NCOLS
               C1 = C + 1
               UBAR1 = LOC_UWIND( C,R1,L ) + LOC_UWIND( C1,R1,L )
               UBAR2 = LOC_UWIND( C,R2,L ) + LOC_UWIND( C1,R2,L )
               DUDY(C,R) = ( UBAR1 - UBAR2 ) * RDX2O4
               END DO
            END DO
 
C for DVDX inner domain (compute the gradient of the averages)
         DO R = 1, NROWS
            R1 = R + 1
            DO C = FRSTCOL, LASTCOL
               C1 = C + 1
               C2 = C - 1
               VBAR1 = LOC_VWIND( C1,R1,L ) + LOC_VWIND( C1,R,L )
               VBAR2 = LOC_VWIND( C2,R1,L ) + LOC_VWIND( C2,R,L )
               DVDX(C,R) = ( VBAR1 - VBAR2 ) * RDX1O4
               END DO
            END DO

C DUDY = 0 for R=1 and NROWS for all NCOLS
C DVDX = 0 for C=1 and NCOLS for all NROWS

C END of section done by Avi

C Deformation only at inner domain
         DO R = 1, NROWS
            DO C = 1, NCOLS
               DF1 = DUDX( C,R ) - DVDY( C,R )
               DF2 = DVDX( C,R ) + DUDY( C,R )
               DEFORM3D( C,R,L ) = SQRT( DF1 * DF1 + DF2 * DF2 ) 
               DEFMAX = MAX( DEFMAX, DEFORM3D( C,R,L ) )
               END DO
            END DO
1005     FORMAT( '@1@ ', I3, 2X, 5( 1PE14.6 ) )

101   CONTINUE   ! MLAYS

      RETURN
      END

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
      MODULE BEIS_DEFN

C-----------------------------------------------------------------------
C Function: biogenics emissions interface to the chemistry-transport model

C Revision History:
C     18 Aug 2007 J.Young: initial implementation
C     16 Feb 2011 S.Roselle: replaced I/O API include files with UTILIO_DEFN
C     10 May 2011 D.Wong: incorporated twoway model implementation
C     01 Feb 19 David Wong: removed MY_N clauses
C-----------------------------------------------------------------------
      USE RUNTIME_VARS

      IMPLICIT NONE

      INTEGER,              SAVE :: N_SPC_BIOG ! biogenics emissions species
      REAL,    ALLOCATABLE, SAVE :: VDEMIS_BI( :,:,: ) ! beis emis
      INTEGER, ALLOCATABLE, SAVE :: BEIS_MAP( : ) ! map to GC
      CHARACTER( 16 ),      SAVE :: CTM_BIOGEMIS = 'CTM_BIOGEMIS'! env var for

      CONTAINS

C=======================================================================

         FUNCTION BEIS_INIT ( JDATE, JTIME, TSTEP ) RESULT ( SUCCESS )

         USE HGRD_DEFN
         USE CGRID_SPCS          ! CGRID mechanism species
         USE BIOG_EMIS           ! from beis
         USE UTILIO_DEFN

         IMPLICIT NONE

         INCLUDE SUBST_CONST     ! constants

         INTEGER JDATE, JTIME, TSTEP
         LOGICAL SUCCESS

         REAL, PARAMETER :: CMLMR = 1.0E+06       ! ppmV/Molar Mixing Ratio

         CHARACTER( 16 )       :: PNAME = 'BEIS_INIT'
         CHARACTER( 80 )       :: VARDESC   ! env variable description
         CHARACTER( 120 )      :: XMSG = ' '

         INTEGER N_SPC
         INTEGER V, K, STATUS

C-----------------------------------------------------------------------

         SUCCESS = .TRUE.

C In-line biogenic emissions?
         CALL LOG_SUBHEADING( LOGDEV, 'Initialize Online Biogenic VOC Emissions Module (BEIS)' )

C biogenics to gas-phase species map
         IF ( BIOGEMIS ) THEN

            XMSG = 'Using in-line biogenic emissions option'
            CALL M3MSG2( XMSG )

            IF ( .NOT. BIOG_INIT() ) THEN
                XMSG = 'Could not initialize biogenic emissions variables'
                CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
                SUCCESS = .FALSE.; RETURN
            END IF

            ALLOCATE( VDEMIS_BI( MSPCS,NCOLS,NROWS ), STAT = STATUS )
            IF ( STATUS .NE. 0 ) THEN
              XMSG = 'VDEMIS_BI memory allocation failed'
               CALL M3WARN ( PNAME, JDATE, JTIME, XMSG )
               SUCCESS = .FALSE.; RETURN
            END IF

         END IF

         SUCCESS = .TRUE.; RETURN

         END FUNCTION BEIS_INIT

C=======================================================================

         SUBROUTINE GET_BEIS ( JDATE, JTIME, TSTEP )

         USE EMIS_VARS, ONLY : N_EMIS_ISTR, IBIOSRM,
     &                         MAP_EMtoSURR, MAP_EMtoDIFF
         USE BIOG_EMIS, ONLY : MSPCS
             
         IMPLICIT NONE

         INTEGER JDATE, JTIME, TSTEP( 3 ), ISTR
         LOGICAL, SAVE :: FIRST_TIME = .TRUE.

         INTERFACE
            SUBROUTINE TMPBEIS312 ( MDATE, MTIME, TSTEP, BEIS_MAP, VDEMIS_BI )
               INTEGER, INTENT(  IN ) :: MDATE, MTIME, TSTEP( 3 )
               INTEGER, INTENT(  IN ) :: BEIS_MAP( : )
               REAL,    INTENT( OUT ) :: VDEMIS_BI( :,:,: )
            END SUBROUTINE TMPBEIS312
         END INTERFACE

C-----------------------------------------------------------------------

         IF ( FIRST_TIME ) THEN
             ! Map out BEIS_MAP using MAP_EMtoSURR Array
             ALLOCATE( BEIS_MAP( MSPCS ) )
             BEIS_MAP = 0
             DO ISTR = 1,N_EMIS_ISTR
                 IF ( MAP_EMtoSURR( ISTR,IBIOSRM ) .GT. 0 ) 
     &              BEIS_MAP( MAP_EMtoSURR( ISTR,IBIOSRM ) ) = 
     &                     MAP_EMtoDIFF( ISTR )
             END DO

             FIRST_TIME = .FALSE.
         END IF    

         CALL TMPBEIS312( JDATE, JTIME, TSTEP, BEIS_MAP, VDEMIS_BI )

         RETURN

         END SUBROUTINE GET_BEIS

      END MODULE BEIS_DEFN

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

       MODULE VERTEXT_MODULE

         USE STD_CONC, ONLY: N_C_GC_SPC, C_GC_SPC, N_C_AE_SPC, C_AE_SPC,  
     &                       N_C_NR_SPC, C_NR_SPC, N_C_TR_SPC, C_TR_SPC,
     &                       N_CSPCS, L_CONC_RH, L_CONC_TA,
     &                       L_CONC_PRES

         INTEGER              :: NVERTEXT
         INTEGER, ALLOCATABLE :: VERTEXTJ(:), VERTEXTI(:), VERT_SEQ(:)
 
         INTEGER                      :: NVERTEXT_SPCS = 0
         CHARACTER( 16 ), ALLOCATABLE :: VERTEXT_SPCS( : )

! for parallel implementation
         INTEGER              :: MY_NVERTEXT
         INTEGER, ALLOCATABLE :: MY_VERTEXTJ(:), MY_VERTEXTI(:), PE_NVERTEXT(:,:)

         PRIVATE :: PWRVEC

         CONTAINS

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE OPVEXT ( JDATE, JTIME, TSTEP )

C-----------------------------------------------------------------------
C Function:
C   Create the IO/API netCDF header and open the output VEXT file

C Revision history:
C   24 Nov 17 B.Henderson: copied from OPCONC.
C   09 Jan 18 D.Wong: put in parallel implementation
C   01 Feb 19 D.Wong: removed USE ALLOC_DATA_MODULE clause
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C-----------------------------------------------------------------------

         USE GRID_CONF
         USE RUNTIME_VARS, ONLY: LOGDEV, LVEXT, N_CONC_VARS, W_VEL
         USE UTILIO_DEFN
#ifdef parallel
         USE SE_MODULES            ! stenex (using SE_UTIL_MODULE)
#else
         USE NOOP_MODULES          ! stenex (using NOOP_UTIL_MODULE)
#endif

         IMPLICIT NONE
C        INTERFACE
C            SUBROUTINE GET_LONLAT(NVERT, VERTLAT, VERTLON)
C             REAL, ALLOCATABLE, INTENT(INOUT) :: VERTLAT(:), VERTLON(:)
C             INTEGER, INTENT(INOUT) :: NVERT
C            END SUBROUTINE GET_LONLAT
C        END INTERFACE

         INCLUDE SUBST_FILES_ID    ! file name parameters

C Arguments:

         INTEGER, INTENT(IN) :: JDATE        ! starting date (YYYYDDD)
         INTEGER, INTENT(IN) :: JTIME        ! starting time (HHMMSS)
         INTEGER, INTENT(IN) :: TSTEP        ! output timestep (HHMMSS)

C Local Variables:

         CHARACTER( 16 ) :: PNAME = 'OPVEXT'
         CHARACTER( 96 ) :: XMSG = ' '
         CHARACTER( 28 ) :: SSTR = ' species saved to VEXTfile:'

C environment variable for no. of layers from bottom to save on VEXT file
         CHARACTER( 16 ) :: NLAYS_VEXT = 'NLAYS_VEXT'

C  environment variable description
         CHARACTER( 80 ) :: VARDESC

         INTEGER :: K, KD, L, SPC, V, VAR   ! loop counters
         INTEGER :: STRT, FINI         ! loop counters
         INTEGER :: STATUS
         INTEGER :: GDTYP2 = 1
         REAL, ALLOCATABLE  :: VERTEXTLAT(:), VERTEXTLON(:)
         REAL, ALLOCATABLE :: VERTEXTJR(:), VERTEXTIR(:)

         LOGICAL, EXTERNAL :: FLUSH3
         CHARACTER( 16 ) :: DOVERTNAME = 'DOVERTEXT'
         CHARACTER( 16 ) :: VERTEXTLATNAME = 'VERTEXTLAT'
         CHARACTER( 16 ) :: VERTEXTLONNAME = 'VERTEXTLON'

         INTEGER :: PE
         LOGICAL :: FOUND, PRJSET

         CHARACTER (30) :: MYFMT

C-----------------------------------------------------------------------

         IF (.not. LVEXT) RETURN
         CALL GET_LONLAT(NVERTEXT, VERTEXTLON, VERTEXTLAT)

         ALLOCATE ( 
     &              VERTEXTJR(NVERTEXT), 
     &              VERTEXTIR(NVERTEXT), 
     &              VERTEXTJ(NVERTEXT), 
     &              VERTEXTI(NVERTEXT), 
     &              MY_VERTEXTJ(NVERTEXT), 
     &              MY_VERTEXTI(NVERTEXT), 
     &              PE_NVERTEXT(0:NVERTEXT, 0:NPCOL*NPROW-1), 
     &              VERT_SEQ(NVERTEXT), 
     &              STAT = STATUS)

         WRITE(LOGDEV, *)'IN', NVERTEXT

C Set output file characteristics from GRID_CONF and open 

         FTYPE3D = GRDDED3
         SDATE3D = JDATE
         STIME3D = JTIME + TSTEP
         TSTEP3D = TSTEP
         NVARS3D = N_CONC_VARS
         NCOLS3D = 1
         NROWS3D = NVERTEXT
         NLAYS3D = NLAYS
         NTHIK3D = 1
         GDTYP3D = GDTYP_GD
         P_ALP3D = P_ALP_GD
         P_BET3D = P_BET_GD 
         P_GAM3D = P_GAM_GD
         XORIG3D = XORIG_GD
         YORIG3D = YORIG_GD
         XCENT3D = XCENT_GD
         YCENT3D = YCENT_GD
         XCELL3D = XCELL_GD
         YCELL3D = YCELL_GD
         VGTYP3D = VGTYP_GD
         VGTOP3D = VGTOP_GD
         DO L = 1, NLAYS + 1
            VGLVS3D( L ) = VGLVS_GD( L )
         END DO
         GDNAM3D = GRID_NAME  ! from HGRD_DEFN

         FDESC3D( 1 ) = 'Concentration file output'
         FDESC3D( 2 ) = 'From CMAQ model dyn alloc version CTM'
         FDESC3D( 3 ) = 'Set of variables (possibly) reduced from CGRID'
         FDESC3D( 4 ) = 'For next scenario continuation runs,'
         FDESC3D( 5 ) = 'use the "one-step" CGRID file'
         KD = 5
         L = 0
         DO K = KD + 1, MIN ( NLAYS + KD, MXDESC3 )
            L = L + 1
            WRITE( FDESC3D( K ),'( "Layer", I3, " to", I3, " " )' )
     &      L - 1, L
         END DO
!        IF ( ( KD + 1 + L ) .LT. MXDESC3 ) THEN
!           DO K = KD + 1 + L, MXDESC3
!              FDESC3D( K ) = ' '
!           END DO
!        END IF
         WRITE (MYFMT, '(a10, i3, a6)') '(A16, 1X, ', NVERTEXT, 'f12.6)'
         WRITE (FDESC3D(KD + 2 + L), MYFMT) 'Latitude  list: ', VERTEXTLAT(1:NVERTEXT)
         WRITE (FDESC3D(KD + 3 + L), MYFMT) 'Longitude list: ', VERTEXTLON(1:NVERTEXT)
         CALL LONLAT2XY(NVERTEXT, VERTEXTLON, VERTEXTLAT,
     &                  VERTEXTIR, VERTEXTJR)
         WRITE (MYFMT, '(a10, i3, a6)') '(A16, 1X, ', NVERTEXT, 'f12.6)'
         WRITE (FDESC3D(KD + 4 + L), myfmt) 'Y list: ', VERTEXTJR(1:NVERTEXT)
         WRITE (FDESC3D(KD + 5 + L), myfmt) 'X list: ', VERTEXTIR(1:NVERTEXT)
         
         
         STATUS = 0
         MY_NVERTEXT = 0
         PE_NVERTEXT = 0
         VERT_SEQ = -1
         DO V = 1, NVERTEXT
            VERTEXTI(V) = INT((VERTEXTIR(V) - XORIG3D) / XCELL3D) + 1
            VERTEXTJ(V) = INT((VERTEXTJR(V) - YORIG3D) / YCELL3D) + 1
            IF ((VERTEXTI(V) .gt. GL_NCOLS) .or. (VERTEXTI(V) .lt. 1) .or.
     &          (VERTEXTJ(V) .gt. GL_NROWS) .or. (VERTEXTJ(V) .lt. 1)) THEN
               STATUS = STATUS + 1
               WRITE( LOGDEV, '( /5X, A, F10.4, F10.4, A, I8, I8)' )
     &              'Outside domain', VERTEXTLON(V), VERTEXTLAT(V),
     &              'COL/ROW', VERTEXTI(V), VERTEXTJ(V)
            ELSE 
               FOUND = .FALSE.
               PE = 0
               DO WHILE (.NOT. FOUND)
                  PE = PE + 1
                  IF ((VERTEXTI(V) .GE. COLSX_PE(1, PE)) .and. 
     &                (VERTEXTI(V) .LE. COLSX_PE(2, PE)) .and.
     &                (VERTEXTJ(V) .GE. ROWSX_PE(1, PE)) .and.
     &                (VERTEXTJ(V) .LE. ROWSX_PE(2, PE))) THEN
                      VERT_SEQ(V) = PE - 1
                      PE_NVERTEXT(0, PE-1) = PE_NVERTEXT(0, PE-1) + 1
                      K = PE_NVERTEXT(0, PE-1)
                      PE_NVERTEXT(K, PE-1) = V
                      FOUND = .TRUE.
                  END IF
               END DO
               IF (MYPE .EQ. VERT_SEQ(V)) THEN 
                  MY_NVERTEXT = MY_NVERTEXT + 1
                  MY_VERTEXTI(MY_NVERTEXT) = VERTEXTI(V) - COLSX_PE(1, MYPE+1) + 1
                  MY_VERTEXTJ(MY_NVERTEXT) = VERTEXTJ(V) - ROWSX_PE(1, MYPE+1) + 1

                  WRITE(LOGDEV, *)'IN', VERTEXTLON(V), VERTEXTLAT(V)
                  WRITE(LOGDEV, *) 'OUT', VERTEXTI(V), VERTEXTJ(V)
               END IF
            ENDIF
         END DO

         WRITE (MYFMT, '(a10, i3, a6)') '(A16, 1X, ', NVERTEXT, 'I6)'
         WRITE (FDESC3D(KD + 6 + L), MYFMT) 'J list: ', VERTEXTJ(1:NVERTEXT)
         WRITE (FDESC3D(KD + 7 + L), MYFMT) 'I list: ', VERTEXTI(1:NVERTEXT)
         WRITE( LOGDEV,* ) ' '
         WRITE( LOGDEV,* ) '      VEXT  File Header Description:'
         DO K = 1, KD + L
            WRITE( LOGDEV,* ) '    => ', TRIM( FDESC3D( K ) )
         END DO

         V = 0
         STRT = 1
         FINI = N_C_GC_SPC
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_GC_SPC( V )
            UNITS3D( SPC ) = 'ppmV'
            VDESC3D( SPC ) = 'Variable ' // VNAME3D( SPC )
         END DO

         V = 0
         STRT = FINI + 1
         FINI = FINI + N_C_AE_SPC
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_AE_SPC( V )
            IF ( VNAME3D( SPC )(1:3) .EQ. 'NUM' ) THEN
               UNITS3D( SPC ) = 'm-3'
            ELSE IF ( VNAME3D( SPC )(1:3) .EQ. 'SRF' ) THEN
               UNITS3D( SPC ) = 'm2 m-3'
            ELSE
               UNITS3D( SPC ) = 'ug m-3'
            END IF
            VDESC3D( SPC ) = 'Variable ' // VNAME3D( SPC )
         END DO

         V = 0
         STRT = FINI + 1
         FINI = FINI + N_C_NR_SPC
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_NR_SPC( V )
            UNITS3D( SPC ) = 'ppmV'
            VDESC3D( SPC ) = 'Variable ' // VNAME3D( SPC )
         END DO

         V = 0
         STRT = FINI + 1
         FINI = FINI + N_C_TR_SPC ! write all TR species
         DO SPC = STRT, FINI
            V = V + 1
            VTYPE3D( SPC ) = M3REAL
            VNAME3D( SPC ) = C_TR_SPC( V )
            UNITS3D( SPC ) = 'ppmV'
            VDESC3D( SPC ) = 'Molar Mixing Ratio for species ' // VNAME3D( SPC )
         END DO
 
         VAR = FINI
         IF ( W_VEL ) THEN   ! for W_YAMO
            VAR = VAR + 1
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'W_VEL'
            UNITS3D( VAR ) = 'm s-1'
            VDESC3D( VAR ) = 'Derived vertical velocity component'
         END IF
      
         IF ( L_CONC_RH ) THEN   ! for Relative Humidity
            VAR = VAR + 1 
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'RH'
            UNITS3D( VAR ) = '1'
            VDESC3D( VAR ) = 'Fractional Relative Humidity'
         END IF
       
         IF ( L_CONC_TA ) THEN   ! for Temperature
            VAR = VAR + 1 
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'TA'
            UNITS3D( VAR ) = 'K'
            VDESC3D( VAR ) = 'Air Temperature'
         END IF
       
         IF ( L_CONC_PRES ) THEN   ! for Pressure
            VAR = VAR + 1 
            VTYPE3D( VAR ) = M3REAL
            VNAME3D( VAR ) = 'PRES'
            UNITS3D( VAR ) = 'Pa'
            VDESC3D( VAR ) = 'Air Pressure'
         END IF
 
         NVERTEXT_SPCS = NVARS3D
         ALLOCATE( VERTEXT_SPCS( NVERTEXT_SPCS ), STAT = STATUS )
         VERTEXT_SPCS( 1:NVERTEXT_SPCS ) = VNAME3D( 1:NVERTEXT_SPCS ) 

C create header

         IF ( IO_PE_INCLUSIVE ) THEN   ! open new

            IF ( .NOT. OPEN3( CTM_VEXT_1, FSNEW3, PNAME ) ) THEN
               XMSG = 'Could not open ' // CTM_VEXT_1
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

            IF ( .NOT. FLUSH3 ( CTM_VEXT_1 ) ) THEN
               XMSG = 'Could not sync to disk ' // CTM_VEXT_1
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            END IF

         END IF

         DEALLOCATE(VERTEXTLAT, VERTEXTLON, VERTEXTJR, VERTEXTIR)

         END SUBROUTINE OPVEXT
#ifdef parallel
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         LOGICAL FUNCTION PWRVEC( FILNAME, VARNAME, DATE, TIME,
     &                            BUFFER, NLAYS,
     &                            NCOLS, NROWS, NP, 
     &                            NVERTEXT, VERTEXTII, VERTEXTJI)
C.....................................................................
  
C  PURPOSE:   Perform Models-3 file-write operation in a parallel
C             environment for a vector. Values of variable VARNAME on each processor
C             subdomain region are collected, via MPI calls, by the
C             primary I/O processor and the full grid of values are
C             written to file.

C  RETURN VALUE:  The function fails if M3IO routine WRITE3 fails. If
C       an MPI error occurs, the program is aborted with a call to
C       PM3EXIT. 
  
C  REVISION  HISTORY:
C       Copied 11/29/2017 by Barron Henderson
C          -- Copied from PWRGRDD
C   09 Jan 18 D.Wong: put in parallel implementation
  
C  ARGUMENT LIST DESCRIPTION:
C  M1 in PIOMAPS_MODULE
C  M2 in ALLOC_DATA_MODULE
C  E3 in PIOVARS.EXT
C  IN:
C    CHARACTER*(*)  FILNAME        ! Name of file containing variable VARNAME
C    CHARACTER*(*)  VARNAME        ! Name of file variable to write
C    INTEGER        DATE           ! Date, formatted YYYYDDD
C    INTEGER        TIME           ! Time, formatted HHMMSS
C    REAL           BUFFER(NCOLS, NROWS, NLAYS)
C                                  ! Buffer holding (local) array to be written
C    INTEGER  NLAYS                ! Layer dimension of file variables
C    INTEGER  NCOLS                ! Column dimension of local-processor arrays
C    INTEGER  NROWS                ! Row dimension of local-processor arrays
C    INTEGER  NP                   ! Number of processors
C    INTEGER  NVERTEXT             ! Number of Lat/Lon pairs
C    INTEGER  VERTEXTII            ! Vertice location
C    INTEGER  VERTEXTJI            ! Vertice location
 
C  OUT: none
 
C  LOCAL VARIABLE DESCRIPTION:  see below
 
C  CALLS: WRITE3, PM3WARN, PM3EXIT, MPI_SEND, MPI_RECV, MPI_BCAST
 
C  NOTES: (1) Only the primary I/O processor does the file writing. Input
C             arguments FILNAME, VARNAME, DATE, and TIME are meaningful
C             only to the I/O processor.
 
C         (2) This routine handles only gridded variables. The BUFFER is
C             assumed to be declared as BUFFER( NCOLS, NROWS, NLAYS ),
C             where NCOLS and NROWS are the local PE grid subdomain
C             dimensions and NLAYS is the file variable layer dimension.
C             BUFFER is assumed to be filled as BUFFER(1:C,1:R,1:NLAYS),
C             where C = WR_COLSX_PE(2,MY_PE+1), R = WR_ROWSX_PE(2,MY_PE+1).
C-----------------------------------------------------------------------

         USE PIOMAPS_MODULE
         USE M3UTILIO, ONLY : WRITE3              ! i/o api

         IMPLICIT NONE

C Include Files

         INCLUDE 'mpif.h'            ! MPI definitions and parameters
         INCLUDE 'PIOVARS.EXT'

C Arguments

         CHARACTER( * ), INTENT(IN) :: FILNAME   ! Name of file containing variable VARNAME
         CHARACTER( * ), INTENT(IN) :: VARNAME   ! Name of file variable to write
         INTEGER, INTENT(IN)        :: DATE      ! Date, formatted YYYYDDD
         INTEGER, INTENT(IN)        :: TIME      ! Time, formatted HHMMSS 
         INTEGER, INTENT(IN)        :: NLAYS     ! Layer dimension of file variables
         INTEGER, INTENT(IN)        :: NCOLS     ! Column dimension of local-processor arrays
         INTEGER, INTENT(IN)        :: NROWS     ! Row dimension of local-processor arrays
         INTEGER, INTENT(IN)        :: NP        ! Number of processors
         INTEGER, INTENT(IN)        :: NVERTEXT  ! Number of vertices
         INTEGER, INTENT(IN)        :: VERTEXTII(:),VERTEXTJI(:) ! vertex locations
         REAL, INTENT(IN)           :: BUFFER( :,:,: )           ! Buffer holding (local) array 

         REAL, ALLOCATABLE, SAVE :: WRITVBUF( :,:,: )
         REAL, ALLOCATABLE       :: RECVVBUF( :,: )
         REAL, ALLOCATABLE       :: SENDVBUF(:,:)     ! to be written

C External Functions:

         EXTERNAL PM3WARN                    ! Parallel M3IO library

C Local Variables:

         INTEGER         :: MSGSIZE   ! Message size of subgrid to receive
         INTEGER         :: IPE       ! For loop over processors
         INTEGER         :: IERROR    ! MPI error code
         LOGICAL         :: LERROR    ! LOCAL ERROR
         LOGICAL         :: RERROR    ! LOCAL MPI ALLREDUCE ERROR
         INTEGER         :: TC,TR     ! This cell position
         INTEGER         :: IG        ! Loop counter over grid layers
         CHARACTER( 16 ) :: FIL16     ! Scratch area for file-name
         CHARACTER( 16 ) :: VAR16     ! Scratch area for vble-name
         CHARACTER( 80 ) :: MSG       ! Message issued from PM3WARN routine
         INTEGER         :: STATUS( MPI_STATUS_SIZE )   ! MPI status code
         INTEGER         :: N, POS

         INTEGER, PARAMETER :: TAG1 = 901 ! MPI message tag for processor ID

C........................................................................

C Initialize return value and error code
         PWRVEC = .TRUE.
         LERROR = .FALSE.
         IERROR = 0
         
         IF ( MY_PE .EQ. IO_PE ) THEN    ! I/O processor collects and writes data

            IF (.NOT. ALLOCATED(WRITVBUF)) THEN
               ALLOCATE ( WRITVBUF  ( 1, NVERTEXT, NLAYS ), STAT = IERROR )
               IF ( IERROR .NE. 0 ) THEN
                  MSG = 'Failure allocating WRITVBUF '
                  CALL M3EXIT( 'PWRVEC', DATE, TIME, MSG, 1 )
               END IF
            END IF

C Gather the array and write it to file.

C I/O PE copies its own local array into output buffer

            DO N = 1, MY_NVERTEXT
               POS = PE_NVERTEXT(N, MY_PE)
               TC  = MY_VERTEXTI(N)
               TR  = MY_VERTEXTJ(N)

               WRITVBUF( 1, POS, : ) = BUFFER(TC, TR, :)
            END DO
 
C I/O PE receives array from all other processors and copies it to the output
C buffer. Arrays are received in a first-come-first-serve order.  

            DO IPE = 1, NP - 1

               IF (PE_NVERTEXT(0, IPE) .GT. 0) THEN
                  ALLOCATE ( RECVVBUF  ( PE_NVERTEXT(0, IPE), NLAYS ), STAT = IERROR )
                  IF ( IERROR .NE. 0 ) THEN
                     MSG = 'Failure allocating RECVVBUF '
                     CALL M3EXIT( 'PWRVEC', DATE, TIME, MSG, 1 )
                  END IF

                  MSGSIZE = PE_NVERTEXT(0, IPE) * NLAYS  

                  CALL MPI_RECV( RECVVBUF, MSGSIZE, MPI_REAL, IPE,
     &                           TAG1, MPI_COMM_WORLD, STATUS, IERROR )
                  IF ( IERROR .NE. 0 ) THEN
                     MSG = 'MPI error receiving data array RECVVBUF.'
                     CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
                     LERROR = .TRUE.
                  END IF

                  DO N = 1, PE_NVERTEXT(0, IPE)
                     POS = PE_NVERTEXT(N, IPE)
                     TC  = MY_VERTEXTI(N)
                     TR  = MY_VERTEXTJ(N)

                     WRITVBUF( 1, POS, : ) = RECVVBUF(N,:)
                  END DO
                  DEALLOCATE (RECVVBUF)
               END IF
            END DO

C Write the accumulated array to file

            FIL16 = FILNAME
            VAR16 = VARNAME
            IF ( .NOT. WRITE3( FIL16, VAR16, DATE, TIME, WRITVBUF ) ) THEN
               MSG = 'Could not write '
     &               // TRIM( VARNAME ) //
     &               ' to file '// TRIM( FIL16 )

               CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
               LERROR = .TRUE.
            END IF

         ELSE      ! Non-I/O processors send data

C Each processor, except for the I/O processor, sends its local array to
C the I/O processor.

            IF (MY_NVERTEXT .GT. 0) THEN
               IF (.NOT. ALLOCATED(SENDVBUF)) THEN
                  ALLOCATE ( SENDVBUF  ( MY_NVERTEXT, NLAYS   ), STAT = IERROR )
                  IF ( IERROR .NE. 0 ) THEN
                     MSG = 'Failure allocating SENDVBUF '
                     CALL M3EXIT( 'PWRVEC', DATE, TIME, MSG, 1 )
                  END IF
               END IF

               DO IG = 1, MY_NVERTEXT
                  TC = MY_VERTEXTI(IG)
                  TR = MY_VERTEXTJ(IG)

                  SENDVBUF( IG, : ) = BUFFER(TC, TR, :)
               END DO

               MSGSIZE = MY_NVERTEXT * NLAYS  

               CALL MPI_SEND( SENDVBUF, MSGSIZE, MPI_REAL, IO_PE, TAG1,
     &                        MPI_COMM_WORLD, IERROR )

               IF ( IERROR .NE. 0 ) THEN
                  MSG = 'MPI error sending data array WRITVBUF.'
                  CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
                  LERROR = .TRUE.
               END IF
            END IF

         END IF     ! if( my_pe .eq. io_pe )

C Notify non-I/O processors of failure

         CALL MPI_ALLREDUCE( LERROR, RERROR, 1, MPI_LOGICAL, MPI_LAND, 
     &                       MPI_COMM_WORLD, IERROR )

         IF ( IERROR .NE. 0 ) THEN
            MSG = 'MPI Allreduce error.'
            CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
            LERROR = .TRUE.
         END IF

         IF ( RERROR ) THEN
            MSG = 'Failed to write '
     &           // TRIM( VARNAME ) //
     &           ' from file '// TRIM( FILNAME )
            CALL PM3WARN( 'PWRVEC', DATE, TIME, MSG )
            PWRVEC = .FALSE.
         END IF

         END FUNCTION PWRVEC

C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE WR_VEXT( CGRID, JDATE, JTIME, TSTEP )

C Revision History:
C   24 Nov 17 B.Henderson: copied from WR_CONC
C   24 Jul 18 C. Nolte: removed call to INIT_MET that was causing conflict.
C             Met should already be initialized by this point.
C   09 Sep 19 F. Sidi: Replaced L_CONC_WVEL & L_ACONC_WVEL (depreciated) with W_VEL
C-----------------------------------------------------------------------

         USE GRID_CONF             ! horizontal & vertical domain specifications
         USE RUNTIME_VARS
         USE STD_CONC              ! standard CONC
         USE PIOMAPS_MODULE
         USE UTILIO_DEFN
         USE ASX_DATA_MOD, Only: Met_Data
         USE WVEL_DEFN, Only : WVEL

         IMPLICIT NONE

C Include Files:

         INCLUDE SUBST_FILES_ID    ! I/O definitions and declarations

         REAL,    POINTER    :: CGRID( :,:,:,: )  ! Species concentrations
         INTEGER, INTENT(IN) :: JDATE             ! current model date, coded YYYYDDD
         INTEGER, INTENT(IN) :: JTIME             ! current model time, coded HHMMSS
         INTEGER, INTENT(IN) :: TSTEP             ! output timestep (HHMMSS)

C Local variables:

         CHARACTER( 16 ) :: PNAME = 'WR_VEXT'
         CHARACTER( 96 ) :: XMSG = ' '

         REAL, ALLOCATABLE :: DBUFF ( :,: )     ! input for W_VEL
         INTEGER           :: ALLOCSTAT

         LOGICAL, SAVE :: FIRSTIME = .TRUE.

C for INTERPX

         INTEGER      :: C, R, K, L, V,GI   ! loop induction variables
         INTEGER      :: C0, CN, R0, RN
         INTEGER      :: INDX, VAR
!        CHARACTER( 16 ), ALLOCATABLE, SAVE :: VNAME( : )
!        INTEGER, SAVE :: NVARS

C-----------------------------------------------------------------------
         IF ( FIRSTIME ) THEN

            FIRSTIME = .FALSE.

C open vext file for update

            IF ( .NOT. IO_PE_INCLUSIVE ) THEN
               IF ( .NOT. OPEN3( CTM_VEXT_1, FSREAD3, PNAME ) ) THEN
                  XMSG = 'Could not open ' // CTM_VEXT_1 //
     &                    ' file for update'
                  CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF

!           IF ( .NOT. DESC3( CTM_VEXT_1 ) ) THEN
!              XMSG = 'Could not get file description from ' // CTM_VEXT_1
!              CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
!           END IF
!           NVARS = NVARS3D
!           ALLOCATE ( VNAME( NVARS ), STAT=ALLOCSTAT )
!           VNAME = VNAME3D( 1:NVARS )
!           WRITE(LOGDEV, *) 'WR_VEXT:NVARS', NVARS


            IF ( .NOT. ALLOCATED( DBUFF ) ) THEN
               ALLOCATE ( DBUFF( NVERTEXT, NLAYS ), STAT = ALLOCSTAT )
               IF ( ALLOCSTAT .NE. 0 ) THEN
                  XMSG = 'Failure allocating DBUFF'
                  CALL M3EXIT ( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
               END IF
            END IF

         END IF   ! firstime

         DO V = 1, N_CSPCS
            INDX = CONC_MAP( V )
            IF ( .NOT. PWRVEC(CTM_VEXT_1, CONC_FILE_SPCS( V ), JDATE, JTIME,
     &                        CGRID(:, :, :, INDX), NLAYS,
     &                        NCOLS, NROWS, NUMPROCS, 
     &                        NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
               XMSG = 'PWRGRDD failed writing variable '
     &              // TRIM( CONC_FILE_SPCS(V) ) //
     &              ' to file '// TRIM( CTM_VEXT_1 )
               CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
            ELSE
               XMSG = 'PWRGRDD wrote variable '
     &              // TRIM( CONC_FILE_SPCS(V) ) //
     &              ' to file '// TRIM( CTM_VEXT_1 )
               WRITE( LOGDEV, '(A)') XMSG
            END IF
         END DO
 
         IF ( W_VEL ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'W_VEL', JDATE, JTIME,
     &                     WVEL(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable WVEL'
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF
         
         IF ( L_CONC_RH ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'RH', JDATE, JTIME,
     &                     MET_DATA%RH(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable RH'
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF
         
 
         IF ( L_CONC_PRES ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'PRES', JDATE, JTIME,
     &                     Met_Data%PRES(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable PRES'
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF
         
         IF ( L_CONC_TA ) THEN
         IF ( .NOT. PWRVEC(CTM_VEXT_1, 'TA', JDATE, JTIME,
     &                     Met_Data%TA(:, :, :), NLAYS,
     &                     NCOLS, NROWS, NUMPROCS, 
     &                     NVERTEXT, VERTEXTI, VERTEXTJ     ) ) THEN
            XMSG = 'PWRGRDD failed writing variable TA '
     &          // ' to file '// TRIM( CTM_VEXT_1 )
            CALL M3EXIT( PNAME, JDATE, JTIME, XMSG, XSTAT1 )
         END IF
         END IF

         WRITE( LOGDEV, '( /5X, 3( A, :, 1X ), I8, ":", I6.6 )' )
     &         'Timestep written to', CTM_VEXT_1,
     &         'for date and time', JDATE, JTIME

         END SUBROUTINE WR_VEXT
#endif
C:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
         SUBROUTINE GET_LONLAT(NVERT, VERTLON, VERTLAT)
C-----------------------------------------------------------------------
C Function:
C   Get LON/LAT pairs from file
C Revision history:
C   09 Mar 18 B.Henderson: 
C-----------------------------------------------------------------------
         USE UTILIO_DEFN
         USE RUNTIME_VARS
         IMPLICIT NONE
         INTEGER :: STATUS, FUNIT, I
         INTEGER, INTENT(INOUT) :: NVERT
         REAL, ALLOCATABLE, INTENT(INOUT) :: VERTLAT(:), VERTLON(:)
        !  environment variable description
         CHARACTER( 80 ) :: VARDESC
         CHARACTER( 16 ) :: DEFTXT = ''
         CHARACTER( 16 ) :: PNAME = 'OPVEXT'
         CHARACTER( 96 ) :: XMSG = ' '

         FUNIT = 100
! OPEN FORMATTED FILE
! EXPECTED FORMAT 
! REC1: N
! REC2-N+1: LON LAT
         OPEN(UNIT=FUNIT, FILE=VEXT_COORD_PATH, STATUS='OLD',
     &        FORM = 'FORMATTED', IOSTAT = STATUS)

         IF ( STATUS .NE. 0 ) THEN
            XMSG = TRIM(VEXT_COORD_PATH) //
     &             ' Could not be opened'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
! READ NUMBER OF VERTICES
         READ(FUNIT, *, IOSTAT=STATUS) NVERT
         IF ( STATUS .NE. 0 ) THEN
            XMSG = TRIM(VEXT_COORD_PATH) //
     &             ' did not contain one integer on the first line'
            CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
         END IF
! ALLOCATE OUTPUT VARIABLES
         ALLOCATE ( VERTLAT(NVERT), VERTLON(NVERT), STAT = STATUS )
! FOR EACH INPUT LINE READ LON,LAT
         DO I=1,NVERT
            READ(FUNIT, *, IOSTAT=STATUS) VERTLON(I), VERTLAT(I)
            IF ( STATUS .NE. 0 ) THEN
               WRITE(XMSG, '(I6)') I
               XMSG = TRIM(VEXT_COORD_PATH) //
     &                ' did not contain two reals on line: ' //
     &                TRIM(XMSG)
               CALL M3EXIT( PNAME, 0, 0, XMSG, XSTAT1 )
            END IF
         ENDDO
! CLOSE FILE
         CLOSE(FUNIT)
         END SUBROUTINE GET_LONLAT

         SUBROUTINE LONLAT2XY(NVERTEXT, VERTEXTLON, VERTEXTLAT,
     &                        VERTEXTIR, VERTEXTJR)
         USE UTILIO_DEFN
         USE GRID_CONF             ! horizontal & vertical domain specifications
         IMPLICIT NONE
         INTEGER, INTENT(in) :: NVERTEXT
         REAL, INTENT(in) :: VERTEXTLON(NVERTEXT), VERTEXTLAT(NVERTEXT)
         REAL, INTENT(inout) :: VERTEXTIR(NVERTEXT), VERTEXTJR(NVERTEXT)
         CHARACTER( 16 ) :: PNAME = 'LONLAT2XY'
         CHARACTER( 96 ) :: XMSG = ' '
         LOGICAL :: PRJSET, LSTAT
         REAL :: JR, IR
         INTEGER :: V
!         IOAPI 3.2 has an explicit function, but many users are likely
!         using 3.1, so I basically rewrote LL2XY
!         CALL XY2XY( GDTYP_GD, P_ALP_GD, P_BET_GD, P_GAM_GD, XCENT_GD, YCENT_GD,
!     &               1      ,    0.d0,    0.d0,    0.d0,    0.d0,    0.d0,
!     &               NVERTEXT, VERTEXTLON, VERTEXTLAT, VERTEXTIR, VERTEXTJR )
         IF ( GDTYP3D .EQ. LAMGRD3 ) THEN
             PRJSET = SETLAM( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2LAM( VERTEXTLON(V), VERTEXTLAT(V), IR, JR ) 
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. POLGRD3 ) THEN
             PRJSET = SETPOL( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2POL( VERTEXTLON(V), VERTEXTLAT(V), IR, JR ) 
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. EQMGRD3 ) THEN
             PRJSET = SETEQM( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2EQM( VERTEXTLON(V), VERTEXTLAT(V), IR, JR ) 
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. TRMGRD3 ) THEN
             PRJSET = SETTRM( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT =  LL2TRM( VERTEXTLON(V), VERTEXTLAT(V), IR, JR )
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSEIF ( GDTYP_GD .EQ. ALBGRD3 ) THEN
             PRJSET = SETALB( REAL(P_ALP_GD), REAL(P_BET_GD), REAL(P_GAM_GD),
     &                         REAL(XCENT_GD), REAL(YCENT_GD))
             DO V=1,NVERTEXT
                 LSTAT = LL2ALB( VERTEXTLON(V), VERTEXTLAT(V), IR, JR )
                 VERTEXTIR(V) = IR
                 VERTEXTJR(V) = JR
             ENDDO
         ELSE
             XMSG = 'Unsupported coordinate system type'
             CALL M3EXIT(PNAME, 0, 0, XMSG, XSTAT2)
         END IF

         END SUBROUTINE LONLAT2XY

       END MODULE VERTEXT_MODULE

!------------------------------------------------------------------------!
!  The Community Multiscale Air Quality (CMAQ) system software is in     !
!  continuous development by various groups and is based on information  !
!  from these groups: Federal Government employees, contractors working  !
!  within a United States Government contract, and non-Federal sources   !
!  including research institutions.  These groups give the Government    !
!  permission to use, prepare derivative works of, and distribute copies !
!  of their work in the CMAQ system to the public and to permit others   !
!  to do so.  The United States Environmental Protection Agency          !
!  therefore grants similar permission to use the CMAQ system software,  !
!  but users are requested to provide copies of derivative works or      !
!  products designed to operate in the CMAQ system to the United States  !
!  Government without restrictions as to use by others.  Software        !
!  that is used with the CMAQ system but distributed under the GNU       !
!  General Public License or the GNU Lesser General Public License is    !
!  subject to their copyright restrictions.                              !
!------------------------------------------------------------------------!

C RCS file, release, date & time of last delta, author, state, [and locker]
C $Header: /project/work/rep/STENEX/src/se_snl/se_global_max_module.f,v 1.2 2006/02/15 14:41:56 yoj Exp $

C what(1) key, module and SID; SCCS file; date and time of last delta:
C %W% %P% %G% %U%

C --------------------------------------------------------------------------
C Purpose:
C
C   use F90 interface feature to achieve "faked" polymorphism for global max
C   determining routine
C
C Revision history:
C
C   Orginal version: 11/05/99 by David Wong
C
C                    12/04/02 by David Wong
C                       -- modified the routine to accommodate worker and
C                          I/O processors partition scheme
C
C Parameter List:
C
C   In: var -- distributed variable which needs be determined the max value
C              among all processors
C
C Local Variable:
C
C   max   -- maximum value among all processors
C   error -- error code of mpi call
C
C Include Files:
C
C   mpif.h
C -----------------------------------------------------------------------------

        module se_global_max_module

        use se_pe_info_ext

        implicit none

        interface se_global_max
          module procedure se_global_imax, se_global_rmax
        end interface

        contains

C -----------------------------------------------------------------------------
        function se_global_imax (var) result (se_global_imax_result)

        implicit none

        integer :: se_global_imax_result
        integer, intent(in) :: var

        include "mpif.h"

        integer :: max, error

        call mpi_reduce (var, max, 1, mpi_integer, MPI_MAX, 0, 
     &                   se_worker_comm, error)

        call mpi_bcast (max, 1, mpi_integer, 0, se_worker_comm, error)

        se_global_imax_result = max

        return
        end function se_global_imax

C -----------------------------------------------------------------------------
        function se_global_rmax (var) result (se_global_rmax_result)

        implicit none

        real :: se_global_rmax_result
        real, intent(in) :: var

        include "mpif.h"

        real :: max
        integer :: error

        call mpi_reduce (var, max, 1, mpi_real, MPI_MAX, 0, 
     &                   se_worker_comm, error)

        call mpi_bcast (max, 1, mpi_real, 0, se_worker_comm, error)

        se_global_rmax_result = max

        return
        end function se_global_rmax

        end module se_global_max_module

#!/bin/csh -f

# ===================== CCTMv5.3 Run Script =========================
# Usage: run.cctm >&! cctm_2016_12US1.log &
#
# To report problems or request help with this script/program:
#             http://www.epa.gov/cmaq    (EPA CMAQ Website)
#             http://www.cmascenter.org  (CMAS Website)
# ===================================================================

#> Simple Linux Utility for Resource Management System
#> (SLURM) - The following specifications are recommended
#> for executing the runscript on the cluster at the
#> National Computing Center used primarily by EPA.
#SBATCH -n 128
#SBATCH --constraint=broadwell
##SBATCH --constraint=cascadelake
#SBATCH -J cmaq_2018_4.2
#SBATCH -p oar
#SBATCH -t 168:00:00
##SBATCH -p debug
##SBATCH -t 4:00:00
#SBATCH --gid=romo
#SBATCH -A romo
#SBATCH -o /work/ROMO/users/bkx/cmaq/o1422/task4.2/2018/cctm/run/cmaq_%j.txt
#SBATCH --no-requeue

cat $0
uname -a
date

# use --constraint=broadwell   to use the 32-core nodes
# use --constraint=cascadelake to use the 48-core nodes

# note email from Ed Anderson Nov 2020:

# If you do not request the Cascade Lake nodes, your job will be
# scheduled on the older 32-core nodes if available, but may run on the
# new 48-core nodes if there are not enough 32-core nodes free.

# In testing, we found that executables using the 2019 version of Intel
# MPI (and, to a lesser extent, the 2018 version of Intel MPI) need to
# link in a newer version. We have changed the default version of Intel
# MPI from intelmpi/19.0.5 to intelmpi/19.0.8.  If you currently load an
# intelmpi module in your job script or startup file that is
# intelmpi/19.0.5 or older, we recommend you change that to load
# intelmpi/19.0.8 instead.

set echo

set base0 = /work/ROMO/users/bkx/cmaq/o1422/task4.2/2018/cctm

#> The following commands output information from the SLURM
#> scheduler to the log files for traceability.
   if ( $?SLURM_JOB_ID ) then
      echo Job ID is $SLURM_JOB_ID
      echo "Running on nodes `printenv SLURM_JOB_NODELIST`"
      echo Host is $SLURM_SUBMIT_HOST
      #> Switch to the working directory. By default,
      #>   SLURM launches processes from your home directory.
      echo Working directory is $SLURM_SUBMIT_DIR
      cd $SLURM_SUBMIT_DIR
   endif

#> Configure the system environment and set up the module
#> capability
   limit stacksize unlimited
#

# ===================================================================
#> Runtime Environment Options
# ===================================================================

echo 'Start Model Run At ' `date`

#> Toggle Diagnostic Mode which will print verbose information to
#> standard output
 setenv CTM_DIAG_LVL 0

#> Choose compiler and set up CMAQ environment with correct
#> libraries using config.cmaq. Options: intel | gcc | pgi
 if ( ! $?compiler ) then
   setenv compiler intel
 endif
 if ( ! $?compilerVrsn ) then
   setenv compilerVrsn 18.0
 endif

# set up modules as needed
# /home/kappel/CMAQ_Code/PROJECTS/CMAQv5321_22Dec2020_EQUATES/CCTM/scripts/BLD_CCTM_v532_intel18.0_M3Dry/CCTM_v532.exe
source /etc/profile.d/modules.csh
module purge
source /etc/profile.d/modules.csh
module load modules
echo 'before config:'
module list
# from source /home/kappel/CMAQ_Code/PROJECTS/CMAQv5321_22Dec2020_EQUATES/config_cmaq.csh intel 18.0
# should be:
  # 1) modules                    3) netcdf-4.4.1/intel-18.0    5) pnetcdf-1.8.1/intel-18.0
  # 2) intel/18.0.1               4) intelmpi/2018.0.128        6) forge/20.0
module load intel/18.0.1
module load netcdf-4.4.1/intel-18.0
module load intelmpi/2018.0.128
module load pnetcdf-1.8.1/intel-18.0
module load forge/20.0
echo 'after config:'
module list

setenv CMAQ_HOME \
/home/kappel/CMAQ_Code/PROJECTS/CMAQv5321_22Dec2020_EQUATES/CCTM/scripts/BLD_CCTM_v532_intel18.0_M3Dry

set compilerString = intel18.0

# # warning: testing only alias
# alias time   echo
# alias mv     echo
# alias rm     echo
# alias qsub   echo
# alias sbatch echo
# alias chgrp  echo

#> Set General Parameters for Configuring the Simulation
 set VRSN      = v532              #> Code Version
 set PROC      = mpi               #> serial or mpi
 set MECH      = cb6r3_ae7_aq      #> Mechanism ID
 set EMIS      = na # set later    #> Emission Inventory Details

# e.g.           2018gc_MP_cb6ae7_18j.v532.12US1_35
# set APPL = 2032fj_16j_cb6r3_ae7_aq_nvpoa.v532_m3dry.12US2_35  # describe emis, model, grid
# set APPL = 2032fj_16j_cb6r3_ae7_aq_nvpoa_50ptegu.v532_m3dry.12US2_35
# set APPL  = 2032fj_16j_cb6r3_ae7_aq_nvpoa_50ptegunoxso2.v532_m3dry.12US2_35
# set APPL  = 2032fj_16j_cb6r3_ae7_aq_nvpoa_50pteguso2.v532_m3dry.12US2_35
 set APPL  = 2018gg_18j_cb6r3_ae7_aq_nvpoa.v532_m3dry.12US2_35

#> Define RUNID as any combination of parameters above or others. By default,
#> this information will be collected into this one string, $RUNID, for easy
#> referencing in output binaries and log files as well as in other scripts.
# setenv RUNID  ${VRSN}_${compilerString}_${APPL}
 setenv RUNID  $APPL

#> Set the build directory (this is where the CMAQ executable
#> is located by default).
 set BLD = \
/home/kappel/CMAQ_Code/PROJECTS/CMAQv5321_22Dec2020_EQUATES/CCTM/scripts/BLD_CCTM_v532_intel18.0_M3Dry
 set EXEC      = CCTM_${VRSN}.exe

#> Output Each line of Runscript to Log File
 if ( $CTM_DIAG_LVL != 0 ) set echo

#> Set Working, Input, and Output Directories
 setenv WORKDIR $base0/run                 #> Working Directory. Where the runscript is.
 setenv OUTDIR  $base0/output           #> Output Directory
 setenv INPDIR  $base0                     #Input Directory
 setenv LOGDIR  ${OUTDIR}/LOGS     #> Log Directory Location
 setenv NMLpath ${BLD}             #> Location of Namelists. Common places are:
                                   #>   ${WORKDIR} | ${CCTM_SRC}/MECHS/${MECH} | ${BLD}

 echo ""
 echo "Working Directory is $WORKDIR"
 echo "Build Directory is $BLD"
 echo "Output Directory is $OUTDIR"
 echo "Log Directory is $LOGDIR"
 echo "Executable Name is $EXEC"

# =====================================================================
#> CCTM Configuration Options
# =====================================================================

 set firstday  = "2017-12-22"

#> Set Start and End Days for looping
#set START_DATE = "2017-12-22"    #> beginning date
#set START_DATE = "2018-08-25"    #> beginning date
set END_DATE   = "2018-12-31"    #> end date

 if ( $START_DATE == $firstday ) then
    setenv NEW_START TRUE
 else
    setenv NEW_START FALSE             #> Set to FALSE for model restart
 endif

#> Set Timestepping Parameters
 set STTIME     = 000000           #> beginning GMT time (HHMMSS)
 set NSTEPS     = 240000           #> time duration (HHMMSS) for this run
 set TSTEP      = 010000           #> output time step interval (HHMMSS)

#> Horizontal domain decomposition
if ( $PROC == serial ) then
   setenv NPCOL_NPROW "1 1"; set NPROCS   = 1 # single processor setting
else
   @ NPCOL  =  16; @ NPROW =  8  # 128 proc
#   @ NPCOL  =  16; @ NPROW =  16 # 256 proc
#   @ NPCOL  =  32; @ NPROW =  16  # 512 proc
   @ NPROCS = $NPCOL * $NPROW
   setenv NPCOL_NPROW "$NPCOL $NPROW";
endif

#> Define Execution ID: e.g. [CMAQ-Version-Info]_[User]_[Date]_[Time]
setenv EXECUTION_ID "CMAQ_CCTM${VRSN}_`id -u -n`_`date -u +%Y%m%d_%H%M%S_%N`"    #> Inform IO/API of the Execution ID
echo ""
echo "---CMAQ EXECUTION ID: $EXECUTION_ID ---"

#> Keep or Delete Existing Output Files
set CLOBBER_DATA = FALSE

#> Logfile Options
#> Master Log File Name; uncomment to write standard output to a log, otherwise write to screen
#setenv LOGFILE $CMAQ_HOME/$RUNID.log
if (! -e $LOGDIR ) then
  mkdir -p $LOGDIR
endif
setenv PRINT_PROC_TIME Y           #> Print timing for all science subprocesses to Logfile
                                   #>   [ default: TRUE or Y ]
setenv STDOUT T                    #> Override I/O-API trying to write information to both the processor
                                   #>   logs and STDOUT [ options: T | F ]

setenv GRID_NAME 12US2     #> check GRIDDESC file for GRID_NAME options
setenv GRIDDESC $base0/ref/GRIDDESC   #> grid description file

#> Retrieve the number of columns, rows, and layers in this simulation
set NZ = 35
set NX = `grep -A 1 ${GRID_NAME} ${GRIDDESC} | tail -1 | sed 's/  */ /g' | cut -d' ' -f6`
set NY = `grep -A 1 ${GRID_NAME} ${GRIDDESC} | tail -1 | sed 's/  */ /g' | cut -d' ' -f7`
set NCELLS = `echo "${NX} * ${NY} * ${NZ}" | bc -l`

setenv CTM_MGEMDIAG  N       # marine emissions diagnostic file [ default: N ]

#> Output Species and Layer Options
   #> CONC file species; comment or set to "ALL" to write all species to CONC
#   setenv CONC_SPCS "O3 NO ANO3I ANO3J NO2 FORM ISOP NH3 ANH4I ANH4J ASO4I ASO4J"
   setenv CONC_SPCS "ALL"
#   setenv CONC_BLEV_ELEV " 1 1" #> CONC file layer range; comment out to write all layers to CONC

   #> ACONC file species; comment or set to "ALL" to write all species to ACONC
   #setenv AVG_CONC_SPCS "O3 NO CO NO2 ASO4I ASO4J NH3"
   setenv AVG_CONC_SPCS "ALL"
   setenv ACONC_BLEV_ELEV " 1 1" #> ACONC file layer range; comment to write all layers to ACONC
   setenv AVG_FILE_ENDTIME N     #> override default beginning ACONC timestamp [ default: N ]

#> Synchronization Time Step and Tolerance Options
#setenv CTM_MAXSYNC 720       #> max sync time step (sec) [ default: 720 ]
setenv CTM_MAXSYNC 300       #> max sync time step (sec) [ default: 720 ]
setenv CTM_MINSYNC  60       #> min sync time step (sec) [ default: 60 ]
setenv SIGMA_SYNC_TOP 0.7    #> top sigma level thru which sync step determined [ default: 0.7 ]
#setenv ADV_HDIV_LIM 0.95    #> maximum horiz. div. limit for adv step adjust [ default: 0.9 ]
setenv CTM_ADV_CFL 0.95      #> max CFL [ default: 0.75]
#setenv RB_ATOL 1.0E-09      #> global ROS3 solver absolute tolerance [ default: 1.0E-07 ]

#> Science Options
setenv CTM_OCEAN_CHEM Y      #> Flag for ocean halogen chemistry and sea spray aerosol emissions [ default: Y ]

# no dust files avail confirmed email 24 sep 2020
setenv CTM_WB_DUST N         #> use inline windblown dust emissions [ default: Y ]
setenv CTM_WBDUST_BELD BELD3 #> landuse database for identifying dust source regions
                             #>    [ default: UNKNOWN ]; ignore if CTM_WB_DUST = N
# lightning data is not available.  confirmed email 24 sep 2020
setenv CTM_LTNG_NO N         #> turn on lightning NOx [ default: N ]
setenv CTM_WVEL Y            #> save derived vertical velocity component to conc
                             #>    file [ default: N ]
setenv KZMIN Y               #> use Min Kz option in edyintb [ default: Y ],
                             #>    otherwise revert to Kz0UT

setenv CTM_MOSAIC N          #> landuse specific deposition velocities [ default: N ]

setenv CTM_FST N             #> mosaic method to get land-use specific stomatal flux
                             #>    [ default: N ]

setenv PX_VERSION Y          #> WRF PX LSM
setenv CLM_VERSION N         #> WRF CLM LSM
setenv NOAH_VERSION N        #> WRF NOAH LSM
setenv CTM_ABFLUX Y          #> ammonia bi-directional flux for in-line deposition
                             #>    velocities [ default: N ]
setenv CTM_BIDI_FERT_NH3 Y   #> subtract fertilizer NH3 from emissions because it will be handled
                             #>    by the BiDi calculation [ default: Y ]
setenv CTM_HGBIDI N          #> mercury bi-directional flux for in-line deposition
                             #>    velocities [ default: N ]
setenv CTM_SFC_HONO Y        #> surface HONO interaction [ default: Y ]
setenv CTM_GRAV_SETL Y       #> vdiff aerosol gravitational sedimentation [ default: Y ]
#setenv CTM_ILDEPV Y          #> calculate in-line deposition velocities [ default: Y ]  # not in v532
setenv CTM_BIOGEMIS Y        #> calculate in-line biogenic emissions [ default: N ]
setenv OPTICS_MIE_CALC N     #> Get flag to use fast optics for volume mixing model for aerosol optical properties
setenv CORE_SHELL_OPTICS N   #> Get flag to use core-shell mixing model for aerosol optical properties

#> Vertical Extraction Options
setenv VERTEXT N
setenv VERTEXT_COORD_PATH na

#> I/O Controls
setenv IOAPI_LOG_WRITE F     #> turn on excess WRITE3 logging [ options: T | F ]
setenv FL_ERR_STOP N         #> stop on inconsistent input files
setenv PROMPTFLAG F          #> turn on I/O-API PROMPT*FILE interactive mode [ options: T | F ]
setenv IOAPI_OFFSET_64 YES   #> support large timestep records (>2GB/timestep record) [ options: YES | NO ]
setenv IOAPI_CHECK_HEADERS N #> check file headers [ options: Y | N ]
setenv CTM_EMISCHK N         #> Abort CMAQ if missing surrogates from emissions Input files
setenv EMISDIAG_SUM F        #> Print Sum of Emission Rates to Gridded Diagnostic File
setenv EMISDIAG F            #> Print Emission Rates at the output time step after they have been
                             #>   scaled and modified by the user Rules [options: F | T or 2D | 3D | 2DSUM ]
                             #>   Individual streams can be modified using the variables:
                             #>       GR_EMIS_DIAG_## | STK_EMIS_DIAG_## | BIOG_EMIS_DIAG
                             #>       MG_EMIS_DIAG    | LTNG_EMIS_DIAG   | DUST_EMIS_DIAG
                             #>       SEASPRAY_EMIS_DIAG
                             #>   Note that these diagnostics are different than other emissions diagnostic
                             #>   output because they occur after scaling.

# not in v532
#setenv EMIS_DATE_OVRD N     #> Master switch for allowing CMAQ to use the date from each Emission file
                             #>   rather than checking the emissions date against the internal model date.
                             #>   [options: T | F or Y | N]. If false (F/N), then the date from CMAQ's internal
                             #>   time will be used and an error check will be performed (recommended). Users
                             #>   may switch the behavior for individual emission files below using the variables:
                             #>       GR_EM_DTOVRD_## | STK_EM_DTOVRD_##
setenv EMIS_SYM_DATE N       #> Master switch for allowing CMAQ to use the date from each Emission file
                             #>   rather than checking the emissions date against the internal model date.
                             #>   [options: T | F or Y | N]. If false (F/N), then the date from CMAQ's internal
                             #>   time will be used and an error check will be performed (recommended). Users
                             #>   may switch the behavior for individual emission files below using the variables:
                             #>       GR_EM_SYM_DATE_## | STK_EM_SYM_DATE_## [default : N ]

#setenv CTM_PT3DEMIS Y        #> calculate in-line plume rise for elevated point emissions  # not in v532

#> Diagnostic Output Flags
setenv CTM_CKSUM Y           #> checksum report [ default: Y ]
setenv CLD_DIAG N            #> cloud diagnostic file [ default: N ]

setenv CTM_PHOTDIAG Y        #> photolysis diagnostic file [ default: N ]
setenv NLAYS_PHOTDIAG "1"    #> Number of layers for PHOTDIAG2 and PHOTDIAG3 from
                             #>     Layer 1 to NLAYS_PHOTDIAG  [ default: all layers ]
#setenv NWAVE_PHOTDIAG "294 303 310 316 333 381 607"  #> Wavelengths written for variables
                                                      #>   in PHOTDIAG2 and PHOTDIAG3
                                                      #>   [ default: all wavelengths ]

setenv CTM_PMDIAG Y          #> Instantaneous Aerosol Diagnostic File [ default: Y ]
setenv CTM_APMDIAG Y         #> Hourly-Average Aerosol Diagnostic File [ default: Y ]
setenv APMDIAG_BLEV_ELEV "1 1"  #> layer range for average pmdiag = NLAYS

setenv CTM_SSEMDIAG N        #> sea-spray emissions diagnostic file [ default: N ]
setenv CTM_DUSTEM_DIAG N     #> windblown dust emissions diagnostic file [ default: N ];
                             #>     Ignore if CTM_WB_DUST = N
setenv CTM_DEPV_FILE Y       #> deposition velocities diagnostic file [ default: N ]
setenv VDIFF_DIAG_FILE N     #> vdiff & possibly aero grav. sedimentation diagnostic file [ default: N ]
setenv LTNGDIAG N            #> lightning diagnostic file [ default: N ]
setenv B3GTS_DIAG N          #> BEIS mass emissions diagnostic file [ default: N ]
setenv PT3DDIAG N            #> 3D point source emissions diagnostic file [ default: N];
setenv PT3DFRAC N            #> layer fractions diagnostic file(s) [ default: N];
setenv REP_LAYER_MIN -1      #> Minimum layer for reporting plume rise info [ default: -1 ]

#> MPI Optimization Flags
setenv MPI_SM_POOL 16000     #> increase shared memory pool in case many MPI_SEND headers
setenv MP_EAGER_LIMIT 65536  #> set MPI message passing buffer size to max
setenv MP_SINGLE_THREAD yes  #> optimize for single threaded applications [ default: no ]
setenv MP_STDOUTMODE ordered #> order output by the processor ID
setenv MP_LABELIO yes        #> label output by processor ID [ default: no ]
setenv MP_SHARED_MEMORY yes  #> force use of shared memory for tasks on same node [ default: no ]
setenv MP_ADAPTER_USE shared #> share the MP adapter with other jobs
setenv MP_CPU_USE multiple   #> share the node with multiple users/jobs
setenv MP_CSS_INTERRUPT yes  #> specify whether arriving packets generate interrupts [ default: no ]


# =====================================================================
#> Input Directories and Filenames
# =====================================================================

set ICpath    = /work/ROMO/users/bkx/cmaq/o1422/task4.1/2018/cctm/icbc/out
set BCpath    = /work/ROMO/users/bkx/cmaq/o1422/task4.1/2018/cctm/icbc/out
set EMISpath  = na   # set later          #> surface emissions input directory
set IN_PTpath = na   # set later          #> elevated emissions input directory (in-line point only)
set IN_LTpath = na                        #> lightning NOx input directory
set METpath   = na   # set later          #> meteorology input directory
#set JVALpath  = $INPDIR/jproc            #> offline photolysis rate table directory
set OMIpath   = na # set later            #> ozone column data for the photolysis model
set LUpath    = na # set later            #> BELD landuse data for windblown dust model
set SZpath    = na # set later            #> surf zone file for in-line seaspray emissions

setenv OPTICS_DATA $BLD/PHOT_OPTICS.dat

# =====================================================================
#> Begin Loop Through Simulation Days
# =====================================================================
set rtarray = ""

set TODAYG = ${START_DATE}
set TODAYJ = `date -ud "${START_DATE}" +%Y%j` #> Convert YYYY-MM-DD to YYYYJJJ
set START_DAY = ${TODAYJ}
set STOP_DAY = `date -ud "${END_DATE}" +%Y%j` #> Convert YYYY-MM-DD to YYYYJJJ
set NDAYS = 0

while ($TODAYJ <= $STOP_DAY )  #>Compare dates in terms of YYYYJJJ

  set NDAYS = `echo "${NDAYS} + 1" | bc -l`

  #> Retrieve Calendar day Information
  set YYYYMMDD = `date -ud "${TODAYG}" +%Y%m%d` #> Convert YYYY-MM-DD to YYYYMMDD
  set YYYYMM = `date -ud "${TODAYG}" +%Y%m`     #> Convert YYYY-MM-DD to YYYYMM
  set YYYY = `date -ud "${TODAYG}" +%Y`         #> Convert YYYY-MM-DD to YYYY
  set YYMMDD = `date -ud "${TODAYG}" +%y%m%d`   #> Convert YYYY-MM-DD to YYMMDD
  set YYYYJJJ = $TODAYJ

  set mmdd = `echo $YYYYMMDD |cut -b5-`
  set mon  = `echo $YYYYMMDD |cut -b5-6`

  #> Calculate Yesterday's Date
  set YESTERDAY = `date -ud "${TODAYG}-1days" +%Y%m%d` #> Convert YYYY-MM-DD to YYYYJJJ

# =====================================================================
#> Set Output String and Propagate Model Configuration Documentation
# =====================================================================
  echo ""
  echo "Set up input and output files for Day ${TODAYG}."

  #> set output file name extensions
  setenv CTM_APPL ${RUNID}_${YYYYMMDD}

  #> Copy Model Configuration To Output Folder
  if ( ! -d "$OUTDIR" ) mkdir -p $OUTDIR
  cp $BLD/CCTM_${VRSN}.cfg $OUTDIR/CCTM_${CTM_APPL}.cfg

# =====================================================================
#> Input Files (Some are Day-Dependent)
# =====================================================================

  #> Initial conditions
  if ($NEW_START == true || $NEW_START == TRUE ) then
     setenv ICFILE ICON_2018gc_MP_cb6ae7_18j.v532.12US1to12US2_35.$YYYYMMDD.nc
     setenv INIT_MEDC_1 notused # notused for first day
     setenv INITIAL_RUN Y #related to restart soil information file
  else
     set ICpath = $OUTDIR
     setenv ICFILE CCTM_CGRID_${RUNID}_${YESTERDAY}.nc
     setenv INIT_MEDC_1 $ICpath/CCTM_MEDIA_CONC_${RUNID}_${YESTERDAY}.nc
     setenv INITIAL_RUN N
  endif

  setenv OMI $BLD/OMI_1979_to_2019.dat

  #> Boundary conditions
  set BCFILE = BCON_2018gc_MP_cb6ae7_18j.v532.12US1to12US2_35.$YYYYMMDD.nc

  #> Off-line photolysis rates
  #set JVALfile  = JTABLE_${YYYYJJJ}

  #> MCIP meteorology files

# /asm1/ROMO/met/MCIP/WRF_RAMBOLL_12US2_2018_35aL/v5.1.3
  set METpath = $base0/mcip
  set sfx = .12US2.35L.$YYMMDD
  setenv LUFRAC_CRO  $METpath/LUFRAC_CRO$sfx
  setenv GRID_CRO_2D $METpath/GRIDCRO2D$sfx
  setenv GRID_BDY_2D $METpath/GRIDBDY2D$sfx
  setenv GRID_CRO_3D ' '                     # not avail
  setenv GRID_DOT_2D $METpath/GRIDDOT2D$sfx
  setenv MET_CRO_2D  $METpath/METCRO2D$sfx
  setenv MET_CRO_3D  $METpath/METCRO3D$sfx
  setenv MET_DOT_3D  $METpath/METDOT3D$sfx
  setenv MET_BDY_3D  $METpath/METBDY3D$sfx

    echo "current metcro3d for $YYYYMMDD"
    ls -lpF $MET_CRO_3D

  if ( ! -e $MET_CRO_2D ) then
    echo "mcip not avail for $YYYYMMDD - exit"
    exit
  endif

#  setenv EMISSCTRL_NML ${BLD}/EmissCtrl_${MECH}.nml
  setenv EMISSCTRL_NML /work/ROMO/users/kjd/pmnaaqs_2021/ria/cmaq/nml/EmissCtrl_cb6r3_ae7_aq_nvpoa.nml

# in run_cctm_Bench_2016_12SE1.csh CMAQ_MASKS and OCEAN_1 are the same file.

  #> Spatial Masks For Emissions Scaling
#  setenv CMAQ_MASKS $SZpath/12US1_surf_bench.nc #> horizontal grid-dependent surf zone file
  setenv CMAQ_MASKS /work/romo/users/hnf/ocean/12US2_surf.ncf

  #> In-line sea spray emissions configuration
  setenv OCEAN_1 /work/romo/users/hnf/ocean/12US2_surf.ncf

  #> Determine Representative Emission Days
     #> In-line emissions configuration
        set refdir = $base0/smk_dates
        set reffile = $refdir/smk_merge_dates_$YYYYMM.txt

        set intable = `grep "^$YYYYMMDD" $reffile`

        set Date     = `echo $intable[1] | cut -d, -f1`
        set aveday_N = `echo $intable[2] | cut -d, -f1`
        set aveday_Y = `echo $intable[3] | cut -d, -f1`
        set mwdss_N  = `echo $intable[4] | cut -d, -f1`
        set mwdss_Y  = `echo $intable[5] | cut -d, -f1`
        set week_N   = `echo $intable[6] | cut -d, -f1`
        set week_Y   = `echo $intable[7] | cut -d, -f1`
        set all      = `echo $intable[8] | cut -d, -f1`
        echo $Date $aveday_N $aveday_Y $mwdss_N $mwdss_Y
        echo $week_N $week_Y $all

# from Chris Allen:

# The CMAQ-ready emissions for the 2018gg case, 36US3 domain, are available:
# /work/ROMO/pm_naaqs_2023/smoke_out/2018gg_18j/36US3/cmaq_cb6ae7/

# 2-D merged emissions with biogenics/RWC excluded are in the merged_nobeis_norwc/ directory.
# 2-D RWC emissions as a separate input are in the rwc/ directory.
# Inline point emissions exist for 10 sectors: cmv_c1c2_36, cmv_c3_36, othpt, pt_oilgas, ptagfire, ptegu, ptfire-rx, ptfir
# e-wild, ptfire_othna, ptnonipm. As usual, all are daily sectors except for othpt (mwdss_N, pt_oilgas (mwdss_Y), and ptno
# nipm (mwdss_Y).
# The inputs needed to run inline biogenics are in the beis_inline/ directory.
# The emissions do not include complete fertilizer, as we understand CMAQ will be run with bidirectional NH3.


# CMAQ-ready emissions are now also ready for the 12US2 domain:
# /work/ROMO/pm_naaqs_2023/smoke_out/2018gg_18j/12US2/cmaq_cb6ae7/

# The sector configuration is the same as 36US3, except the CMV sectors are named cmv_c1c2_12 and cmv_c3_12. 

set epath  = /work/ROMO/pm_naaqs_2023/smoke_out/2018gg_18j/12US2/cmaq_cb6ae7
set epath2 = na  # $base0/emis
set ecase = _2018gg_18j.ncf

#setenv N_EMIS_GR 20  # below 19 sectors plus ocean cl2
setenv N_EMIS_GR 2  # below 2 sectors without ocean cl2 because it is already in file

# make sure if beis is in the sector list that CTM_BIOGEMIS = N

# the below '.' separated fields correspond to values for:
# sector number, sector name, repday, repday logical T/F, GRIDDED_sectorlabel

# check grid labels

foreach sem (                             \
1.merged_nobeis_norwc.$all.F.GRIDDED_EMIS \
2.rwc.$all.F.GR_RES_FIRES                 )

#setenv CTM_BIOGEMIS N # would go with $sem.beis.$all.F.BEIS
setenv CTM_BIOGEMIS Y

set nsem = `echo $sem |cut -d. -f1`  # sector number
set tsem = `echo $sem |cut -d. -f2`  # sector name
set dsem = `echo $sem |cut -d. -f3`  # repday
set rsem = `echo $sem |cut -d. -f4`  # repday logical T/F GR_EM_DTOVRD_# or GR_EM_SYM_DATE_#
set csem = `echo $sem |cut -d. -f5`  # GRIDDED_sectorlabel

set zsem = $nsem
if ( $nsem < 100 ) set zsem = 0$nsem
if ( $nsem < 10  ) set zsem = 00$nsem

if ( $tsem == merged_nobeis_norwc ) then
setenv GR_EMIS_$zsem $epath/$tsem/emis_mole_all_${dsem}_12US2_nobeis_norwc$ecase

else if ( $tsem == rwc ) then
setenv GR_EMIS_$zsem $epath/$tsem/emis_mole_${tsem}_${dsem}_12US2_cmaq_cb6ae7$ecase

# normal default
else
setenv GR_EMIS_$zsem $epath/emis_mole_${tsem}_$dsem$ecase

endif

setenv GR_EMIS_LAB_$zsem $csem
setenv GR_EM_DTOVRD_$zsem   $rsem   # earlier versions
setenv GR_EM_SYM_DATE_$zsem $rsem

# no repdays used for merged_nobeis_norwc or rwc
# # 2015mmdd spinups are linked to 2016mmdd files.  repday logical is T here
# if ( $YYYY == 2015 ) then
# if ( $tsem == afdust_adj     || \
#      $tsem == ag             || \
#      $tsem == canada_ag      || \
#      $tsem == onroad         || \
#      $tsem == othafdust_adj  || \
#      $tsem == othptdust_adj  || \
#      $tsem == rwc            )  then
#      setenv GR_EM_DTOVRD_$zsem   T
#      setenv GR_EM_SYM_DATE_$zsem T
# endif # type
# endif # 2015

end # gridded emissions list

# # ocean cl2: this appears to be in the emis file already for 2016, 2032, 2018 12US2
# set zsem = 20  # 19 sectors plus 1

# inline point emissions

# using another grid for inline pt does not matter as long as the grid
# is the same map projection and completely covers the model data
# needed for the model grid.  this is because inline pt is input by
# xloc and yloc and not by cmaq col and row.  cmaq calculates col and
# row from xloc and yloc.

# /work/ROMO/pm_naaqs_2023/smoke_out/2018gg_18j/12US2/cmaq_cb6ae7

set ptpath1 = $epath
set ptpath2 = na

set pcase = _12US1_cmaq_cb6ae7_2018gg_18j.ncf
set scase = _12US1_2018gg_18j.ncf

# sector list

# check point labels

setenv N_EMIS_PT 10

foreach sect (                    \
1.ptnonipm.$mwdss_Y.T.PT_NONEGU   \
2.pt_oilgas.$mwdss_Y.T.PT_OILGAS  \
3.ptegu.$all.T.PT_EGU       \
4.ptfire-rx.$all.T.PT_RXFIRES     \
5.ptfire-wild.$all.T.PT_FIRES     \
6.ptfire_othna.$all.T.PT_OTHFIRES \
7.ptagfire.$all.T.PT_AGFIRES      \
8.othpt.$mwdss_N.T.PT_OTHER       \
9.cmv_c1c2_12.$all.T.PT_CMV_C1C2  \
10.cmv_c3_12.$all.T.PT_CMV_C3     )

set nsect = `echo $sect |cut -d. -f1`  # sector number
set tsect = `echo $sect |cut -d. -f2`  # sector name
set dsect = `echo $sect |cut -d. -f3`  # repday
set rsect = `echo $sect |cut -d. -f4`  # repday logical T/F STK_EM_DTOVRD_# or STK_EM_SYM_DATE_#
set csect = `echo $sect |cut -d. -f5`  # GRIDDED_sectorlabel

set zsect = $nsect
if ( $nsect < 100 ) set zsect = 0$nsect
if ( $nsect < 10  ) set zsect = 00$nsect

# daily stack_groups 12us1
if ( $tsect == ptfire_othna || $tsect == ptagfire || $tsect == ptfire-rx || $tsect == ptfire-wild ) then
setenv STK_EMIS_$zsect $ptpath1/$tsect/inln_mole_${tsect}_$dsect$pcase
setenv STK_GRPS_$zsect $ptpath1/$tsect/stack_groups_${tsect}_$dsect$scase

# normal defaults
else
setenv STK_EMIS_$zsect $ptpath1/$tsect/inln_mole_${tsect}_$dsect$pcase
setenv STK_GRPS_$zsect $ptpath1/$tsect/stack_groups_$tsect$scase

endif

# Label Each Emissions Stream
setenv STK_EMIS_LAB_$zsect $csect

# Allow CMAQ to Use Point Source files with dates that do not
# match the internal model date
setenv STK_EM_DTOVRD_$zsect   $rsect
setenv STK_EM_SYM_DATE_$zsect $rsect

end # point sector list

  setenv LAYP_STTIME $STTIME
  setenv LAYP_NSTEPS $NSTEPS
  setenv LAYP_STDATE $YYYYJJJ

  #setenv STK_EMIS_DIAG_001 2DSUM
  #setenv STK_EMIS_DIAG_002 2DSUM
  #setenv STK_EMIS_DIAG_003 2DSUM
  #setenv STK_EMIS_DIAG_004 2DSUM
  #setenv STK_EMIS_DIAG_005 2DSUM

  #> Lightning NOx configuration
  if ( $CTM_LTNG_NO == 'Y' ) then
     setenv LTNGNO "InLine"    #> set LTNGNO to "Inline" to activate in-line calculation

  #> In-line lightning NOx options
     setenv USE_NLDN  na        #> use hourly NLDN strike file [ default: Y ]
     if ( $USE_NLDN == Y ) then
        setenv NLDN_STRIKES na
     endif
     setenv LTNGPARMS_FILE na #> lightning parameter file; ignore if LTNGPARAM = N
  endif

# beis
# /work/ROMO/pm_naaqs_2023/smoke_out/2018gg_18j/12US2/cmaq_cb6ae7/beis_inline
# -rw-rw-r--. 1 callen05 romo      30034768 2022-06-16 08:46 b3grd.2016v3.2022Apr21.12US2.ncf
# -rw-rw-r--. 1 callen05 romo     146527860 2022-06-16 08:47 bioseason.cmaq.18j_12US2.ncf_full
# -rw-rw-r--. 1 callen05 emis-hpc     23102 2021-04-21 14:30 gspro_biogenics_28apr2020_v10.txt


  # #> In-line biogenic emissions configuration
  # if ( $CTM_BIOGEMIS == 'Y' ) then
  #    set IN_BEISpath = $base0/emis
  #    setenv GSPRO      $IN_BEISpath/gspro_biogenics_19nov2019_nf_v10.txt
  #    setenv B3GRD      $IN_BEISpath/b3grd_4NW2_WR403_2016fh_16j.ncf
  #    setenv BIOG_SPRO  BC6E7
  #    setenv BIOSW_YN   Y     #> use frost date switch [ default: Y ]
  #    setenv BIOSEASON  $IN_BEISpath/bioseason.cmaq.16j_4NW2.ncf_full
  #    setenv SUMMER_YN  Y     #> Use summer normalized emissions? [ default: Y ]
  #    setenv PX_VERSION Y     #> MCIP is PX version? [ default: N ]
  #    setenv SOILINP    $OUTDIR/CCTM_SOILOUT_${RUNID}_${YESTERDAY}.nc
  #                            #> Biogenic NO soil input file; ignore if INITIAL_RUN = Y
  # endif  # inline biogenics

  #> In-line biogenic emissions configuration
  if ( $CTM_BIOGEMIS == 'Y' ) then
     set IN_BEISpath = $epath/beis_inline
     setenv GSPRO      $IN_BEISpath/gspro_biogenics_28apr2020_v10.txt
     setenv B3GRD      $IN_BEISpath/b3grd.2016v3.2022Apr21.12US2.ncf
     setenv BIOG_SPRO  BC6E7
     setenv BIOSW_YN   Y   #> use frost date switch [ default: Y ]
     setenv BIOSEASON  $IN_BEISpath/bioseason.cmaq.18j_12US2.ncf_full
     setenv SUMMER_YN  Y   #> Use summer normalized emissions? [ default: Y ]
     setenv PX_VERSION Y   #> MCIP is PX version? [ default: N ]
     setenv SOILINP    $OUTDIR/CCTM_SOILOUT_${RUNID}_${YESTERDAY}.nc
                             #> Biogenic NO soil input file; ignore if INITIAL_RUN = Y
  endif  # inline biogenics

# dust files:

  #> Windblown dust emissions configuration
  if ( $CTM_WB_DUST == 'Y' ) then
     # Input variables for BELD3 Landuse option
     setenv DUST_LU_1  na
     setenv DUST_LU_2  na
     setenv MODIS_FPAR na  # MODIS_FPAR not in v532

# # this part may not be used anymore for v5.3 because CTM_ERODE_AGLAND is false in code
#      if ( $CTM_ERODE_AGLAND == 'Y' ) then
#         setenv CROPMAP01 $base0/calmap/EndPlanting_4NW2
#         setenv CROPMAP04 $base0/calmap/EndPlanting_4NW2
#         setenv CROPMAP08 $base0/calmap/EndHarvesting_4NW2
#      endif
  endif  # if CTM_WB_DUST

# originally from /work/MOD3DATA/2018_12US1/epic
# epic was originally 12US1 and was windowed to 12US2 by utility m3wndw

  #> Bidirectional ammonia configuration
  if ( $CTM_ABFLUX == 'Y' ) then
     set epicdir  = $base0/epic/out
     setenv E2C_SOIL $epicdir/${YYYY}r1_EPIC0509_12US1to12US2_soil.nc
     setenv E2C_CHEM $epicdir/${YYYY}r1_EPIC0509_12US1to12US2_time$YYYYMMDD.nc
     # if ( $YESTERDAY == 20151221 ) then
     #    setenv E2C_CHEM_YEST $epicdir2/us2_2016_cmaq12km_time$YESTERDAY.nc  # copy of 20151222
     # else
     #    setenv E2C_CHEM_YEST  $epicdir/us2_2016_cmaq12km_time$YESTERDAY.nc
     # endif
     setenv E2C_LU $epicdir/beld4_12US1to12US2_2011.nc
  endif

#> Inline Process Analysis
  setenv CTM_PROCAN N        #> use process analysis [ default: N]
  if ( $?CTM_PROCAN ) then   # $CTM_PROCAN is defined
     if ( $CTM_PROCAN == 'Y' || $CTM_PROCAN == 'T' ) then
#> process analysis global column, row and layer ranges
#       setenv PA_BCOL_ECOL "10 90"  # default: all columns
#       setenv PA_BROW_EROW "10 80"  # default: all rows
#       setenv PA_BLEV_ELEV "1  4"   # default: all levels
        setenv PACM_INFILE ${NMLpath}/pa_${MECH}.ctl
        setenv PACM_REPORT $OUTDIR/"PA_REPORT".${YYYYMMDD}
     endif
  endif

#> Integrated Source Apportionment Method (ISAM) Options
 setenv CTM_ISAM N

#> Sulfur Tracking Model (STM)
 setenv STM_SO4TRACK N        #> sulfur tracking [ default: N ]
 if ( $?STM_SO4TRACK ) then
    if ( $STM_SO4TRACK == 'Y' || $STM_SO4TRACK == 'T' ) then

      #> option to normalize sulfate tracers [ default: Y ]
      setenv STM_ADJSO4 Y

    endif
 endif

# marine file if needed
setenv CTM_MGEM_1      "$OUTDIR/CCTM_MGEM_${CTM_APPL}.nc -v"       #> Marine Gas Emissions

#> CMAQ-DDM-3D
 setenv CTM_DDM3D N
 set NPMAX    = 1
 setenv SEN_INPUT ${WORKDIR}/sensinput.dat

 setenv DDM3D_HIGH N     # allow higher-order sensitivity parameters [ T | Y | F | N ] (default is N/F)

 if ($NEW_START == true || $NEW_START == TRUE ) then
    setenv DDM3D_RST N   # begins from sensitivities from a restart file [ T | Y | F | N ] (default is Y/T)
    set S_ICpath =
    set S_ICfile =
 else
    setenv DDM3D_RST Y
    set S_ICpath = $OUTDIR
    set S_ICfile = CCTM_SENGRID_${RUNID}_${YESTERDAY}.nc
 endif

 setenv DDM3D_BCS F      # use sensitivity bc file for nested runs [ T | Y | F | N ] (default is N/F)
 set S_BCpath =
 set S_BCfile =

 setenv CTM_NPMAX       $NPMAX
 setenv CTM_SENS_1      "$OUTDIR/CCTM_SENGRID_${CTM_APPL}.nc -v"
 setenv A_SENS_1        "$OUTDIR/CCTM_ASENS_${CTM_APPL}.nc -v"
 setenv CTM_SWETDEP_1   "$OUTDIR/CCTM_SENWDEP_${CTM_APPL}.nc -v"
 setenv CTM_SDRYDEP_1   "$OUTDIR/CCTM_SENDDEP_${CTM_APPL}.nc -v"
 setenv CTM_NPMAX       $NPMAX
 setenv INIT_SENS_1     $S_ICpath/$S_ICfile
 setenv BNDY_SENS_1     $S_BCpath/$S_BCfile

# =====================================================================
#> Output Files
# =====================================================================

  #> set output file names
  setenv S_CGRID         "$OUTDIR/CCTM_CGRID_${CTM_APPL}.nc"         #> 3D Inst. Concentrations
  setenv CTM_CONC_1      "$OUTDIR/CCTM_CONC_${CTM_APPL}.nc -v"       #> On-Hour Concentrations
  setenv A_CONC_1        "$OUTDIR/CCTM_ACONC_${CTM_APPL}.nc -v"      #> Hourly Avg. Concentrations
  setenv MEDIA_CONC      "$OUTDIR/CCTM_MEDIA_CONC_${CTM_APPL}.nc -v" #> NH3 Conc. in Media
  setenv CTM_DRY_DEP_1   "$OUTDIR/CCTM_DRYDEP_${CTM_APPL}.nc -v"     #> Hourly Dry Deposition
  setenv CTM_DEPV_DIAG   "$OUTDIR/CCTM_DEPV_${CTM_APPL}.nc -v"       #> Dry Deposition Velocities
  setenv CTM_PT3D_DIAG   "$OUTDIR/CCTM_PT3D_${CTM_APPL}.nc -v"       #> Point Source Emissions by Layer
  setenv B3GTS_S         "$OUTDIR/CCTM_B3GTS_S_${CTM_APPL}.nc -v"    #> Biogenic Emissions
  setenv SOILOUT         "$OUTDIR/CCTM_SOILOUT_${CTM_APPL}.nc"       #> Soil Emissions
  setenv CTM_WET_DEP_1   "$OUTDIR/CCTM_WETDEP1_${CTM_APPL}.nc -v"    #> Wet Dep From All Clouds
  setenv CTM_WET_DEP_2   "$OUTDIR/CCTM_WETDEP2_${CTM_APPL}.nc -v"    #> Wet Dep From SubGrid Clouds
  setenv CTM_PMDIAG_1    "$OUTDIR/CCTM_PMDIAG_${CTM_APPL}.nc -v"     #> On-Hour Particle Diagnostics
  setenv CTM_APMDIAG_1   "$OUTDIR/CCTM_APMDIAG_${CTM_APPL}.nc -v"    #> Hourly Avg. Particle Diagnostics
  setenv CTM_RJ_1        "$OUTDIR/CCTM_PHOTDIAG1_${CTM_APPL}.nc -v"  #> 2D Surface Summary from Inline Photolysis
  setenv CTM_RJ_2        "$OUTDIR/CCTM_PHOTDIAG2_${CTM_APPL}.nc -v"  #> 3D Photolysis Rates
  setenv CTM_RJ_3        "$OUTDIR/CCTM_PHOTDIAG3_${CTM_APPL}.nc -v"  #> 3D Optical and Radiative Results from Photolysis
  setenv CTM_SSEMIS_1    "$OUTDIR/CCTM_SSEMIS_${CTM_APPL}.nc -v"     #> Sea Spray Emissions
  setenv CTM_DUST_EMIS_1 "$OUTDIR/CCTM_DUSTEMIS_${CTM_APPL}.nc -v"   #> Dust Emissions
  setenv CTM_IPR_1       "$OUTDIR/CCTM_PA_1_${CTM_APPL}.nc -v"       #> Process Analysis
  setenv CTM_IPR_2       "$OUTDIR/CCTM_PA_2_${CTM_APPL}.nc -v"       #> Process Analysis
  setenv CTM_IPR_3       "$OUTDIR/CCTM_PA_3_${CTM_APPL}.nc -v"       #> Process Analysis
  setenv CTM_IRR_1       "$OUTDIR/CCTM_IRR_1_${CTM_APPL}.nc -v"      #> Chem Process Analysis
  setenv CTM_IRR_2       "$OUTDIR/CCTM_IRR_2_${CTM_APPL}.nc -v"      #> Chem Process Analysis
  setenv CTM_IRR_3       "$OUTDIR/CCTM_IRR_3_${CTM_APPL}.nc -v"      #> Chem Process Analysis
  setenv CTM_DRY_DEP_MOS "$OUTDIR/CCTM_DDMOS_${CTM_APPL}.nc -v"      #> Dry Dep
  setenv CTM_DRY_DEP_FST "$OUTDIR/CCTM_DDFST_${CTM_APPL}.nc -v"      #> Dry Dep
  setenv CTM_DEPV_MOS    "$OUTDIR/CCTM_DEPVMOS_${CTM_APPL}.nc -v"    #> Dry Dep Velocity
  setenv CTM_DEPV_FST    "$OUTDIR/CCTM_DEPVFST_${CTM_APPL}.nc -v"    #> Dry Dep Velocity
  setenv CTM_VDIFF_DIAG  "$OUTDIR/CCTM_VDIFF_DIAG_${CTM_APPL}.nc -v" #> Vertical Dispersion Diagnostic
  setenv CTM_VSED_DIAG   "$OUTDIR/CCTM_VSED_DIAG_${CTM_APPL}.nc -v"  #> Particle Grav. Settling Velocity
  setenv CTM_LTNGDIAG_1  "$OUTDIR/CCTM_LTNGHRLY_${CTM_APPL}.nc -v"   #> Hourly Avg Lightning NO
  setenv CTM_LTNGDIAG_2  "$OUTDIR/CCTM_LTNGCOL_${CTM_APPL}.nc -v"    #> Column Total Lightning NO
  setenv CTM_VEXT_1      "$OUTDIR/CCTM_VEXT_${CTM_APPL}.nc -v"       #> On-Hour 3D Concs at select sites


  #> set floor file (neg concs)
  setenv FLOOR_FILE ${OUTDIR}/FLOOR_${CTM_APPL}.txt

  #> look for existing log files and output files
  ( ls CTM_LOG_???.${CTM_APPL} > buff.txt ) >& /dev/null
  ( ls ${LOGDIR}/CTM_LOG_???.${CTM_APPL} >> buff.txt ) >& /dev/null
  set log_test = `cat buff.txt`; rm -f buff.txt

  set OUT_FILES = (${FLOOR_FILE} ${S_CGRID} ${CTM_CONC_1} ${A_CONC_1} ${MEDIA_CONC}         \
             ${CTM_DRY_DEP_1} $CTM_DEPV_DIAG $CTM_PT3D_DIAG $B3GTS_S $SOILOUT $CTM_WET_DEP_1\
             $CTM_WET_DEP_2 $CTM_PMDIAG_1 $CTM_APMDIAG_1             \
             $CTM_RJ_1 $CTM_RJ_2 $CTM_RJ_3 $CTM_SSEMIS_1 $CTM_DUST_EMIS_1 $CTM_IPR_1 $CTM_IPR_2       \
             $CTM_IPR_3 $CTM_IRR_1 $CTM_IRR_2 $CTM_IRR_3 $CTM_DRY_DEP_MOS                   \
             $CTM_DRY_DEP_FST $CTM_DEPV_MOS $CTM_DEPV_FST $CTM_VDIFF_DIAG $CTM_VSED_DIAG    \
             $CTM_LTNGDIAG_1 $CTM_LTNGDIAG_2 $CTM_VEXT_1 )
  set OUT_FILES = `echo $OUT_FILES | sed "s; -v;;g" `
  ( ls $OUT_FILES > buff.txt ) >& /dev/null
  set out_test = `cat buff.txt`; rm -f buff.txt

  #> delete previous output if requested
  if ( $CLOBBER_DATA == true || $CLOBBER_DATA == TRUE ) then
     echo
     echo "Existing Logs and Output Files for Day ${TODAYG} Will Be Deleted"

     #> remove previous log files
     foreach file ( ${log_test} )
        #echo "Deleting log file: $file"
#        /bin/rm -f $file
     end

     #> remove previous output files
     foreach file ( ${out_test} )
        #echo "Deleting output file: $file"
#        /bin/rm -f $file
     end
#     /bin/rm -f ${OUTDIR}/CCTM_EMDIAG*${RUNID}_${YYYYMMDD}.nc

  else
     #> error if previous log files exist
     if ( "$log_test" != "" ) then
       echo "*** Logs exist - run ABORTED ***"
       echo "*** To overide, set CLOBBER_DATA = TRUE in run_cctm.csh ***"
       echo "*** and these files will be automatically deleted. ***"
       exit 1
     endif

     #> error if previous output files exist
     if ( "$out_test" != "" ) then
       echo "*** Output Files Exist - run will be ABORTED ***"
       foreach file ( $out_test )
          echo " cannot delete $file"
       end
       echo "*** To overide, set CLOBBER_DATA = TRUE in run_cctm.csh ***"
       echo "*** and these files will be automatically deleted. ***"
       exit 1
     endif
  endif

  #> for the run control ...
  setenv CTM_STDATE      $YYYYJJJ
  setenv CTM_STTIME      $STTIME
  setenv CTM_RUNLEN      $NSTEPS
  setenv CTM_TSTEP       $TSTEP
  setenv INIT_CONC_1     $ICpath/$ICFILE
  setenv BNDY_CONC_1     $BCpath/$BCFILE

  # setenv OMI $OMIpath/$OMIfile          # set earlier
  # setenv OPTICS_DATA $OMIpath/$OPTfile  # set earlier
  #setenv XJ_DATA $JVALpath/$JVALfile  # na
  set TR_DVpath = $METpath
  set TR_DVfile = $MET_CRO_2D

  #> species defn & photolysis
  setenv gc_matrix_nml ${NMLpath}/GC_$MECH.nml
  setenv ae_matrix_nml ${NMLpath}/AE_$MECH.nml
  setenv nr_matrix_nml ${NMLpath}/NR_$MECH.nml
  setenv tr_matrix_nml ${NMLpath}/Species_Table_TR_0.nml

  #> check for photolysis input data
  setenv CSQY_DATA ${NMLpath}/CSQY_DATA_$MECH

  if (! (-e $CSQY_DATA ) ) then
     echo " $CSQY_DATA  not found "
     exit 1
  endif
  if (! (-e $OPTICS_DATA ) ) then
     echo " $OPTICS_DATA  not found "
     exit 1
  endif

  if ( ! -e $INIT_CONC_1 ) then
    echo 'no initial condition file, program aborting'
    exit
  endif

# ===================================================================
#> Execution Portion
# ===================================================================

  #> Print attributes of the executable
  if ( $CTM_DIAG_LVL != 0 ) then
     ls -l $BLD/$EXEC
     size $BLD/$EXEC
     unlimit
     limit
  endif

  #> Print Startup Dialogue Information to Standard Out
  echo
  echo "CMAQ Processing of Day $YYYYMMDD Began at `date`"
  echo

  #> Executable call for single PE, uncomment to invoke
  #( /usr/bin/time -p $BLD/$EXEC ) |& tee buff_${EXECUTION_ID}.txt

  #> Executable call for multi PE, configure for your system
  # set MPI = /usr/local/intel/impi/3.2.2.006/bin64
  # set MPIRUN = $MPI/mpirun
  ls -lpF --time-style=long-iso $BLD/$EXEC
  ( /usr/bin/time -p mpirun -np $NPROCS $BLD/$EXEC ) |& tee buff_${EXECUTION_ID}.txt # comment out for testing

  #> Harvest Timing Output so that it may be reported below
  set rtarray = "${rtarray} `tail -3 buff_${EXECUTION_ID}.txt | grep -Eo '[+-]?[0-9]+([.][0-9]+)?' | head -1` "
  rm -rf buff_${EXECUTION_ID}.txt

  #> Abort script if abnormal termination
  if ( ! -e $S_CGRID ) then
    echo ""
    echo "**************************************************************"
    echo "** Runscript Detected an Error: CGRID file was not written. **"
    echo "**   This indicates that CMAQ was interrupted or an issue   **"
    echo "**   exists with writing output. The runscript will now     **"
    echo "**   abort rather than proceeding to subsequent days.       **"
    echo "**************************************************************"
    break
  endif

  #> Print Concluding Text
  echo
  echo "CMAQ Processing of Day $YYYYMMDD Finished at `date`"
  echo
  echo "\\\\\=====\\\\\=====\\\\\=====\\\\\=====/////=====/////=====/////=====/////"
  echo

# ===================================================================
#> Finalize Run for This Day and Loop to Next Day
# ===================================================================

  #> Save Log Files and Move on to Next Simulation Day
  mv CTM_LOG_???.${CTM_APPL} $LOGDIR
  if ( $CTM_DIAG_LVL != 0 ) then
    mv CTM_DIAG_???.${CTM_APPL} $LOGDIR
  endif

  #> The next simulation day will, by definition, be a restart
  setenv NEW_START false

  #> Increment both Gregorian and Julian Days
  set TODAYG = `date -ud "${TODAYG}+1days" +%Y-%m-%d` #> Add a day for tomorrow
  set TODAYJ = `date -ud "${TODAYG}" +%Y%j` #> Convert YYYY-MM-DD to YYYYJJJ

end  #Loop to the next Simulation Day

# ===================================================================
#> Generate Timing Report
# ===================================================================
set RTMTOT = 0
foreach it ( `seq ${NDAYS}` )
    set rt = `echo ${rtarray} | cut -d' ' -f${it}`
    set RTMTOT = `echo "${RTMTOT} + ${rt}" | bc -l`
end

set RTMAVG = `echo "scale=2; ${RTMTOT} / ${NDAYS}" | bc -l`
set RTMTOT = `echo "scale=2; ${RTMTOT} / 1" | bc -l`

echo
echo "=================================="
echo "  ***** CMAQ TIMING REPORT *****"
echo "=================================="
echo "Start Day: ${START_DATE}"
echo "End Day:   ${END_DATE}"
echo "Number of Simulation Days: ${NDAYS}"
echo "Domain Name:               ${GRID_NAME}"
echo "Number of Grid Cells:      ${NCELLS}  (ROW x COL x LAY)"
echo "Number of Layers:          ${NZ}"
echo "Number of Processes:       ${NPROCS}"
echo "   All times are in seconds."
echo
echo "Num  Day        Wall Time"
set d = 0
set day = ${START_DATE}
foreach it ( `seq ${NDAYS}` )
    # Set the right day and format it
    set d = `echo "${d} + 1"  | bc -l`
    set n = `printf "%02d" ${d}`

    # Choose the correct time variables
    set rt = `echo ${rtarray} | cut -d' ' -f${it}`

    # Write out row of timing data
    echo "${n}   ${day}   ${rt}"

    # Increment day for next loop
    set day = `date -ud "${day}+1days" +%Y-%m-%d`
end
echo "     Total Time = ${RTMTOT}"
echo "      Avg. Time = ${RTMAVG}"

exit
